********************************************************************************
*                                                                              *
*                                                                              *
*                                                                              *
*                  This is version 90.04 of Cloudy                             *
*                                                                              *
*                                                                              *
*                                                                              *
*                                                                              *
*    Cloudy is copywrited 1978-1997 by Gary J. Ferland.                        *
*    This code is copywrited material and may not be copied without            *
*    acknowledging its origin.                                                 *
*    Portions of the code are derived from the work of others,                 *
*    as acknowledged in Hazy.                                                  *
*                                                                              *
*    The development of Cloudy has been supported by grants from               *
*    NASA and NSF.                                                             *
*                                                                              *
*    Use of this code is not restricted provided that acknowledgement          *
*    is made in each publication.  The bibliographic reference to this         *
*    version of Cloudy is Ferland, G.J., 1996, Hazy, a Brief Introduction      *
*    to Cloud 90, University of Kentucky, Physics Department Internal Report.  *
*                                                                              *
*    Make sure that you have the current version (with the latest atomic       *
*    data and fixed problems) by checking the Cloudy Web site                  *
*    http://www.pa.uky.edu/~gary/cloudy                                        *
*                                                                              *
*    To be atutomatically notified of these changes, ask to be placed on the   *
*    cloudy mailing list by sending an e-mail to cldmail@cloud9.pa.uky.edu     *
*                                                                              *
********************************************************************************
*
*    this file has three optional lines
*    call pop371 and the two includes in FeIIData
*    comment these out to get rid of FeII
*    activate them to include them
****************************************************************
      subroutine PrtFeII
      implicit none
*called by prstep to print Katya's atom
*
*     in Katya's code this figures out the overlapping lines
*
      end
****************************************************************
      subroutine Fe2OvrLap
      implicit none
*handle overlapping FeII lines
*
*     in Katya's code this figures out the overlapping lines
*
      end
****************************************************************
      subroutine KatyaFe2
      implicit none
*drive Katya Verner's large FeII level inversion routine
*
*     this is Katya's routine - call it
*     call pop371
*
      end
*****************************************************
      block data FeIIData
      implicit none
*block data containing atomic data for Katya Verner's FeII atom
*     include "/home16/users/gary/cloudy/nta.par"
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*>>>>>uncomment one or the other, first only when Katya's code to be used
*     include "/home16/users/gary/cloudy/nFe2LevN.par"
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
      real t
      common/Fe2LevN/ t(nta,nFe2LevN,nFe2LevN )
*     integer nn
*     real s
*     common/PradDat/ nn(142) , s(20,142,142)
*
      integer i
*
*     the 3rd number is the A, which conv fe2 changes into gf
*     include "/home16/users/katya/fe/fe2d.dat"
*     data t/4 679 794 *0./
*     include "/home16/users/katya/fe/coll.dat"
*
      end
*     NB NB NB
*     throughout this there are two parameter files - in the
*     cloudy main directory nFe2LevN.par is dimensioned 1, but in the
*     Fe2 subdirectory it is dimensioned 371
*
*     include "nFe2LevN.par"
*
*     one or the other must be uncommented - nFe2LevN contains
*     correct number of levels for Katya's FeII atom
*     nFe2LevN1 has one, and is active when her atom is not linked in
*
****************************************************************
      real function SumBandFe2( ip1 , ip2 )
      implicit none
*sum up Katya's FeII emission over certain bands
      integer ip1 , ip2
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
*
*     local variables
      integer low , ihi
      real alo , ahi
*
*     convert to line energy in ergs
      ahi = 1.99e-8 / float( ip1 )
      alo = 1.99e-8 / float( ip2 )
      SumBandFe2 = 0.
      do low=1,nFe2LevN-1
        do ihi=low+1,nFe2LevN
          if( Fe2LevN(ipLnEnrErg,ihi,low).ge.alo .and.
     1    Fe2LevN(ipLnEnrErg,ihi,low).le.ahi )
     2    SumBandFe2 = SumBandFe2 +
     1    Fe2LevN(ipLnInten,ihi,low)
        end do
      end do
      end
****************************************************************
      subroutine TauIncFe2
      implicit none
*called after every zone to increment Katya's FeII line optical depths
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
*
*     local variables
      integer low , ihi
*
      do low=1,nFe2LevN-1
        do ihi=low+1,nFe2LevN
          call tauchn( Fe2LevN(1,ihi,low))
        end do
      end do
*
      end
****************************************************************
      subroutine TavFe2
      implicit none
*reset optical depths for Katya's FeII atom after each iteration
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
*
*     local variables
      integer low , ihi
*
*     called at end of iteration
      do low=1,nFe2LevN-1
        do ihi=low+1,nFe2LevN
          call tav( Fe2LevN(1,ihi,low) , 0.5 )
        end do
      end do
*
*     call Katya's overlap routine
      call Fe2OvrLap
*
      end
****************************************************************
      subroutine PointFe2
      implicit none
*set pointers to FeII lines in Katya's FeII atom
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real pi4
      parameter (pi4=12.566371)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
*     degrees kelvin per unit wavenumber
      real t1cm
      parameter (t1cm=1.43883)
*     energy ergs per unit wavenumber
      real e1cm
      parameter (e1cm=1.98648e-16)
      real WavNRyd
*number of Ryd per wavenumber
*from Physics Today '96, BG 10
      parameter (WavNRyd=9.1126732e-6)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer ip , ipoint , low , ihi
      real abscf
*
*     routine called when cloudy sets itself up - one time for all runs
*     sets pointers for Fe2 lines
*
*begin sanity check
*     this does not work with array bounds checking turned on, when nFe2LevN
*     is 1 (not linked in) but would not happen anyway
*     check that first datum is non-zero, 0 sign that block data not
*     properly linked in
*     if( Fe2LevN(ipLnEnrWN,2,1).le.0. ) then
*       write(qq,'('' The vector Fe2LevN has zero data where positive'',
*    1  '' data was expected.'')')
*       write(qq,'('' Was block data FeIIData linked in?'')')
*       call insane
*       stop
*     endif
*end sanity check
*
      do low=1,nFe2LevN-1
        do ihi=low+1,nFe2LevN
          Fe2LevN(ipLnRyd,ihi,low) = Fe2LevN(ipLnEnrWN,ihi,low) *
     1    WavNRyd
          ip = ipoint( Fe2LevN(ipLnRyd,ihi,low) )
          Fe2LevN(ipLnIpCont,ihi,low) =  ip
*         do not over write other pointers with feii since feii is everywhere
          if(chLineLabel(ip).eq.'    ') chLineLabel(ip) = 'FeII'
          Fe2LevN(ipLnDampRel,ihi,low) = Fe2LevN(ipLnAul,ihi,low) *
     1    Fe2LevN(ipLnWlAng,ihi,low)*1e-8 / pi4
*         derive the abs coef, call to function is gf, wl (A), g_low
          Fe2LevN(ipLnOpac,ihi,low) = abscf( Fe2LevN(ipLnGF,ihi,low) ,
     1    Fe2LevN(ipLnEnrWN,ihi,low) , Fe2LevN(ipLnGl,ihi,low) )
*         excitation energy of transition in degrees kelvin
          Fe2LevN(ipLnBolt,ihi,low) = t1cm * Fe2LevN(ipLnEnrWN,ihi,low)
*         energy of photon in ergs
          Fe2LevN(ipLnEnrErg,ihi,low) = e1cm*Fe2LevN(ipLnEnrWN,ihi,low)
        end do
      end do
*
      end
****************************************************************
      subroutine AccelFe2( fe2drive )
      implicit none
*compute acceleration due to Katya's FeII atom
      real fe2drive
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
*
*     this routine computes the line driven radiative acceleration
*     due to katya's Fe2 atom
*
*     local variables
      integer low , ihi
*
      fe2drive = 0.
      do low=1,nFe2LevN-1
        do ihi=low+1,nFe2LevN
          fe2drive = fe2drive + Fe2LevN(ipLnPump,ihi,low)*
     1    Fe2LevN(ipLnEnrErg,ihi,low)*
     1    Fe2LevN(ipLnPopOpc,ihi,low)
        end do
      end do
*
      end
****************************************************************
      subroutine MakeRTFe2
      implicit none
*called by MakeRT, gets Katya's FeII atom escape probs
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
*
*     local variables
      integer low , ihi
*
*     this routine drives calls to make RT relations with Katya's FeII atom
      if( windv.eq.0. ) then
*       static soluiton
        do low=1,nFe2LevN-1
          do ihi=low+1,nFe2LevN
            call MakeStatRT( Fe2LevN(1,ihi,low) )
          end do
        end do
      else
*       windy model
        do low=1,nFe2LevN-1
          do ihi=low+1,nFe2LevN
            call MakeWindRT( Fe2LevN(1,ihi,low) )
          end do
        end do
      endif
*
      end
****************************************************************
      subroutine Fe2Lines( chFunction, renorm )
      implicit none
*save accumulated FeII intensities, punch out at end of run
      real renorm
      character chFunction*3
*
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer ioVerner , ipHiVernFe2
      logical lgShortFe2
*punch unit for 'punch verner' command
*ipHiVernFe2 is highest level, second number on command line
      common/ioVerner/ ioVerner , ipHiVernFe2 , lgShortFe2
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgDROn , lgDRPLst
*     these control punching choice of dr - this is not really a punch cmnd
*     ipDRout is io unit, lgDROn says punching dr logic has been set,
*     and lgDRPLst says to punch the last iteration
      integer ipDRout
      logical lgFe2PLst
      common/ipdr/ ipDRout , lgDROn , lgDRPLst , lgFe2PLst
      logical lgLastIt
*     this is false on any but the last iteration
*     set true in startr if iter > itermx
      common/lastit/ lgLastIt
*     energy range and threshold for FeII lines output with punch verner
      real fe2ener(2) , fe2thresh
      common/feiipar/ fe2ener , fe2thresh
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgPunch , lgOK
      real TauMase , hbeta, absint , thresh
      real Fe2SavN(nFe2LevN,nFe2LevN )
      save Fe2SavN
*
*     local variables
      integer iup, low , MaseLow , MaseHi , limit
*
*     this routine puts the emission from Katya's FeII atom
*     into a line array, and eventually will punch it out
*
*     this is test for whether option is enabled with "punch feii"
      if( ioVerner.eq.0 ) return
      if( ipHiVernFe2 .eq.0 ) then
        limit = nFe2LevN
      else
        limit = ipHiVernFe2
      endif
*
      if(  chFunction.eq.'add' ) then
        if( ipass.eq.0 ) then
*         we were called by lines, and we want to zero out Fe2SavN
          do low=1,limit-1
            do iup=low+1,limit
              Fe2SavN(iup,low) = 0.
            end do
          end do
        else if( ipass.eq.1 ) then
*         total emission from vol
          do low=1,limit-1
            do iup=low+1,limit
              Fe2SavN(iup,low) = Fe2SavN(iup,low) +
     1        dVeff * Fe2LevN(ipLnInten,iup,low)
            end do
          end do
        else
*         this cannot happen
          write(qq,'('' Fe2Lines called with insane ipass='',i3)')
     1    ipass
          stop
        endif
*
*     here is where punch really takes place
      else if( chFunction.eq.'pun' ) then
        if( lgLastIt ) then
          lgPunch = .true.
        else
          if( lgFe2PLst ) then
            lgPunch = .false.
          else
            lgPunch = .true.
          endif
        endif
        if( lgPunch ) then
          write(ioVerner,'('' up low log I, I/I(norm), Tau'')')
*         first check on masing lines
          TauMase = 0.
          do low=1,limit-1
            do iup=low+1,limit
              if( Fe2LevN(ipLnTauIn,iup,low).lt.TauMase ) then
                TauMase = Fe2LevN(ipLnTauIn,iup,low)
                MaseLow = low
                MaseHi = iup
              endif
            end do
          end do
          if( TauMase.lt.0. ) write(ioVerner,'('' Most negative '',
     1    ''optical depth was '',2i4,1p,e10.2)') MaseHi,MaseLow,TauMase
*         actual line intensities, Hbeta first
          call cdLine( 'TOTL',4861, hbeta, absint, lgOK )
          write(ioVerner,'(2i3,f7.3,1p,2e9.2)') 4,2,
     1    absint+pirsq , hbeta
          thresh = fe2thresh / renorm
          do low=1,limit-1
            do iup=low+1,limit
*             fe2ener(1) and (2) are lower and upper limits to range of
*             wavelengths of interest.  entered in ryd with
*             punch feii verner range command, where they are converted
*             to wavenumbers
              if( Fe2SavN(iup,low).gt.thresh .and.
     1          Fe2LevN(ipLnEnrWN,iup,low).gt.fe2ener(1).and.
     2          Fe2LevN(ipLnEnrWN,iup,low).lt.fe2ener(2) ) then
                if( lgShortFe2 ) then
*                 short printout does not include rel intensity or optical dep
                  write(ioVerner,'(2i3,f7.3,1p,2e9.2)') iup,low,
     1            log10(max(1e-37,Fe2SavN(iup,low)))+pirsq
                else
*                 long printout does
                  write(ioVerner,'(2i3,f7.3,f9.4,1p,e10.2)') iup,low,
     1            log10(max(1e-37,Fe2SavN(iup,low)))+pirsq ,
     1            Fe2SavN(iup,low) * renorm , Fe2LevN(ipLnTauIn,iup,low)
                endif
              endif
            end do
          end do
        endif
      else
        write(qq,'('' Fe2Lines called with insane job='',a3)')
     1  chFunction
        stop
      endif
*
      end
****************************************************************
      subroutine EmitFe2( VolFac , ref )
      implicit none
*add Katya's FeII emission into the outward beam - called one time per zone
      real VolFac , ref
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real tmn
      common/tmn/ tmn(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
*
*     local variables
      integer ip , ilo , ihi
*
*
      do ilo=1,nFe2LevN-1
        do ihi=ilo+1,nFe2LevN
*         pointer to line energy in continuum array
          ip = Fe2LevN(ipLnIpCont,ihi,ilo)
* 666 error! make sure verner's put this in
          outlin(ip) = outlin(ip) + Fe2LevN(ipLnNPhots,ihi,ilo)*
     1    VolFac* tmn(ip)*Fe2LevN(ipLnColovTOT,ihi,ilo)
          reflin(ip) = reflin(ip) + Fe2LevN(ipLnNPhots,ihi,ilo) * ref
        end do
      end do
      end
****************************************************************
      subroutine ConvFe2
      implicit none
*generate needed opacity data for Katya's FeII atom
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer ihi , low
      real glow, gup, a , energy , cs1
      logical lgFirst
      save lgFirst
*
      data lgFirst/.true./
*
*     this routine is called only one time when cloudy is init
*     for the very first time.  It converts the fe2 data stored
*     in Katya's arrays into the array storage needed by cloudy
*     for its line optical depth arrays
*
*     NB NB NB NB NB - this routine MUST be called first since
*     it checks whether Katya's data has been linked in
*
      if( nFe2LevN.le.1 ) then
*       this forces Katya's Fe2 atom off - data not linked in
        lgKatyaData = .false.
        return
      else
        lgKatyaData = .true.
      endif
*
*     only do this one time
      if( .not.lgFirst .and. chFeIIAtom.ne.'Verner' ) then
        return
      endif
      lgFirst = .false.
*
*     convert Katya's line arrays into standard heavy el ar
      do low=1,nFe2LevN-1
        do ihi=low+1,nFe2LevN
*         pull information out of existing data arrays
            glow = Fe2LevN( 1,ihi,low )
            gup = Fe2LevN( 2,ihi,low )
               a = Fe2LevN( 3,ihi,low )
          energy = Fe2LevN( 4,ihi,low )
          cs1 = Fe2LevN( 5,ihi,low )
*begin sanity check
          if( energy.le.0. ) then
            write(qq,'('' ConvFeWnd: insane energy for Fe2LevN.'')')
            stop
          endif
*end sanity check
*         now put into standard internal line format
          Fe2LevN(ipLnAul,ihi,low) = a
          Fe2LevN(ipLnWlAng,ihi,low) = 1.e8/energy
          Fe2LevN(ipLnGl,ihi,low) = glow
          Fe2LevN(ipLnGu,ihi,low) = gup
*         generate gf from A
          Fe2LevN(ipLnGF,ihi,low) = a*gup*1.4992e-8*(1e4/energy)**2
          Fe2LevN(ipLnEnrWN,ihi,low) = energy
          Fe2LevN(ipLnIonStg,ihi,low) = 2.
          Fe2LevN(ipLnNelem,ihi,low) = 26.
          Fe2LevN(ipLnRedis,ihi,low) = 1.
          Fe2LevN(ipLnCS1,ihi,low) = cs1
        end do
      end do
*
      end
****************************************************************
      subroutine ZeroFe2
      implicit none
*zero out storage for Katya's FeII atom
      integer nFe2LevN
*this is the disabled version of the dimension for Katya's FeII atom
      parameter (nFe2LevN=1)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real Fe2LevN
      common/Fe2LevN/ Fe2LevN(nta,nFe2LevN,nFe2LevN )
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
*     local variables
      integer lo , iup
*
*     this routine is called in routine zero and it
*     zero's out various elements of the fe2 arrays
*     it is called on every iteration
*
      do lo=1,nFe2LevN-1
        do iup=lo+1,nFe2LevN
*         inward optical depth
          Fe2LevN(ipLnTauIn,iup,lo) = taumin
          Fe2LevN(ipLnTauCon,iup,lo) = taumin
          Fe2LevN(ipLnColovTOT,iup,lo) = taumin
*         outward optical depth
          Fe2LevN(ipLnTauTot,iup,lo) = 1e20
*         escape probability
          Fe2LevN(ipLnEscP,iup,lo) = 1.
*         inward part of line
          Fe2LevN(ipLnInwd,iup,lo) = 1.
*         destruction probability
          Fe2LevN(ipLnDesP,iup,lo) = 0.
*         line pumping rate
          Fe2LevN(ipLnPump,iup,lo) = 0.
*         population of lower level with correction for stim emission
          Fe2LevN(ipLnPopOpc,iup,lo) = 0.
*         population of lower level
          Fe2LevN(ipLnPopl,iup,lo) = 0.
*         following two heat exchange excitation, deexcitation
          Fe2LevN(ipLnCool,iup,lo) = 0.
          Fe2LevN(ipLnHeat,iup,lo) = 0.
*         intensity of line
          Fe2LevN(ipLnInten,iup,lo) = 0.
*         number of photons emitted in line
          Fe2LevN(ipLnNPhots,iup,lo) = 0.
*         opacity in line
          Fe2LevN(ipLnDTau,iup,lo) = 0.
        end do
      end do
*
      end
******************************************************************************
      subroutine abnset
      implicit none
*sets initial abundances after parameters are entered by reading input
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      logical lgAbunTabl(limelm) , lgAbTaDepth(limelm),lgAbTaON
*lgAbunTabl says whether this element is to have its abundance
*determined from a table (true) or stored constant (false)
*set true with element table command
*lgAbTaDepth says whether depth or radius, true is depth
      common/AbunTablLG/ lgAbunTabl , lgAbTaDepth,lgAbTaON
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real solar
      common/solar/ solar(limelm)
      real scalem
      common/scalem/ scalem(limelm)
      real Depletion , depset
*     Depletion is set of stored scale factors for depletion of general ism
*     depset is unity unless depletion is used
*     lgDepln is true if depln used
      logical lgDepln
      common/deplon/ Depletion(limelm) , depset(limelm) , lgDepln
      real ScaleMetals
*scale factor for metals, set with metals command
      common/dmetal/ ScaleMetals
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real solarm
*     solar mass in grams
      parameter (solarm=1.9892e33)
      real flong , cfirst , csecnd, flcPhase
*     parameters for the fluctuations command
      logical lgDenFluc
      common/fluct/ flong , cfirst , csecnd , lgDenFluc, flcPhase
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , nelem
      real fac , tababun
*
*     rescale so that abundances are H=1
      do i=2,limelm
        solar(i) = solar(i) / solar(1)
      end do
      solar(1) = 1.
*
*     set current abundances to "solar" times metals scale factor
*     and grain depletion factor
      solar(2) = solar(2) * depset(2) * scalem(2)
      if( lgDenFluc ) then
*       usual case - either density flucuations or none at all
        fac = 1.
      else
        fac = cfirst * cos( flcPhase ) + csecnd
      endif
*     >>chng 96 july 12, added fac for possible abundance fluctuations
      do i=3,limelm
        solar(i) = solar(i) * ScaleMetals * depset(i) * scalem(i)*fac
      end do
*
*     now fix abundance of any element with element table set
      if( lgAbTaON ) then
        do nelem=2,limelm
          if( lgAbunTabl(nelem) ) then
            solar(nelem) = tababun( radius , depth , nelem )
*            write(6,*) radius,depth , nelem, solar(nelem)
          endif
        end do
      endif
*
      if( lgTalk ) then
        call PrintElem( 'init','  ',0. )
        do i=1,limelm
          if(lgElmtOn(i))  then
            call PrintElem('fill',chElementSym(i),solar(i))
          endif
        end do
        call PrintElem( 'flus','  ',0. )
        write(qq,'('' '')')
      endif
*
*     xIonFracs(nelem,0) contains total abundance of element
      do nelem=1,limelm
        xIonFracs(nelem,0) = solar(nelem) * hden
        if( xIonFracs(nelem,0).le.0. ) then
          write(qq,'('' Abundances must be greater than zero.  '',
     1    ''Check entered abundance for element'',i3,1x,'' = '',a2)')
     2    nelem, chElementSym(nelem)
          stop
        endif
      end do
*
      ahe = solar(2) * hden
      heiii = ahe
      heii = 0.
      hei = 0.
*
*     alith =    solar(3) * hden
*     aberyl =   solar(4) * hden
*     aboron =   solar(5) * hden
*     afluorine =solar(9) * hden
*     ane =      solar(10) * hden
*     ana =      solar(11) * hden
*     amg =      solar(12) * hden
*     aal =      solar(13) * hden
*     asil =     solar(14) * hden
*     aphos =    solar(15) * hden
*     asul =     solar(16) * hden
*     aclor =    solar(17) * hden
*     aargon =   solar(18) * hden
*     apotas =   solar(19) * hden
*     aca =      solar(20) * hden
*     ascand =   solar(21) * hden
*     atitan =   solar(22) * hden
*     avana =    solar(23) * hden
*     achrom =   solar(24) * hden
*     amanga =   solar(25) * hden
*     afe =      solar(26) * hden
*     acobl =    solar(27) * hden
*     ani =      solar(28) * hden
*     acopp =    solar(29) * hden
*     azinc =    solar(30) * hden
*
*     usually computed in PRESUR, but not called before first zone
      agrav = (6.67e-8 * comass) * (solarm / radius ) / radius
*
      if( lgTrace ) then
        write(qq,'('' ABNSET sets following densities; '')')
        write(qq,'(1p,14(1x,a2,e8.2))')
     1  (chElementSym(nelem), xIonFracs(nelem,0),nelem=1,limelm)
      endif
*
      end
******************************************************************************
      real function abscf( gf , enercm , gl )
      implicit none
*convert gf into absorption coefficient
      real gf , enercm , gl
*
*     derive line absorption coefficient, given the following:
*     gf, enercm, g_low
*     gf is product of g and oscillator strength
*     abscf = 1.497e-6 * (gf/gl) * abs(wl/1e4)
      abscf = 1.4974e-6 * (gf/gl) * (1e4 / enercm)
*
      end
******************************************************************************
      subroutine absmag( chCard , nqh )
      implicit none
*parse the absolute magnitude command
      character chCard*80
      integer nqh
*
      real emm , egamry
      common/bounds/ emm , egamry
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real range
      common/range/ range(limspc,2)
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgEOL , lgMatch
*
*     local variables
      integer i
      real fread
*
*     enter luminosity in absolute magnitudes
      i = 5
      nqh = nqh + 1
      if( nqh.gt.limspc ) then
         if(lgTalk) write(qq,'('' Too many continua entered; increase '',
     1   ''LIMSPC'')')
         stop
      endif
      chRSpec(nqh) = '4 PI'
      totpow(nqh) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
         if(lgTalk) write(qq,'('' There should have been a number on '',
     1   ''this line.   Sorry.'')')
         stop
      endif
      if( lgMatch('BOLO' , chCard ) ) then
        chSpNorm(nqh) = 'LUMI'
        range(nqh,1) = emm
        range(nqh,2) = egamry
*       page 197 allen 76
        totpow(nqh) = (4.75 - totpow(nqh)) / 2.5  + 33.5827
      else if( lgMatch('VISU', chCard ) ) THEN
        chSpNorm(nqh) = 'FLUX'
*       this is 5550A, the center of the V filter
        range(nqh,1) = 0.164
*       totpow(nqh) = (4.79 - totpow(nqh)) / 2.5  + 18.758
*       page 197, allen 76, 3rd line from bottom
        totpow(nqh) =  -totpow(nqh)/2.5  + 20.65296
      else
        if(lgTalk) write(qq,'('' Keyword BOLOmetric or VISUal must '',
     1  ''appear.'')')
        stop
      endif
*
      end
******************************************************************************
      subroutine AddOpac( lgOK )
      implicit none
*derive total opacity for this position
      logical lgOK
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      integer nhe3lvl
      parameter (nhe3lvl=5)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      integer ippr , ioppr
      common/ipair/ ippr , ioppr
      integer iopcom
      common/iopcom/ iopcom
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
      real opac
      common/opac/ opac(ncell)
      real OldOpacSave
      logical lgOTSOn
*save previous opacity
      common/OldOpac/ OldOpacSave(ncell)  , lgOTSOn(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      logical lgOpacOn
      common/opacon/ lgOpacOn
      logical lgHeMase
*flag set true in addopac if any helium continua mased
      common/hemase/ lgHeMase
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      integer ircoil , irche
      common/ircoil/ ircoil , irche
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      integer iphmin
      common/iphmin/ iphmin
      real hi , hii
      common/h/ hi , hii
      real EdenFFSum
*sum of heavy element free electrons, set in esum
      common/ffsum/ EdenFFSum
      real hmidep , h2dep , h2pdep,h3pdep,hehdep
      common/hmidep/ hmidep , h2dep , h2pdep,h3pdep,hehdep
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
*     include "hbn.com"
      real ophf
      common/ophf/ ophf(lmhlvl)
      real stimax
      common/stimax/ stimax(2)
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      double precision he3bn
      common/he3bn/ he3bn(nhe3lvl)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      real he3n
      common/he3n/ he3n(nhe3lvl)
      integer ipRayScat
*opacity pointer for rayleigh scattering
      common/iprayl/ ipRayScat
      integer ipBrems
*opacity offset pointer for brems (free-free)
      common/ipbrms/ ipBrems
      integer iphmra
      common/iphmra/ iphmra
      integer iphmop
      common/iphmop/ iphmop
      integer ioptri
      common/ioptri/ ioptri
      integer iphop
      common/iphop/ iphop(lmhlvl)
      integer iophe1
      common/iophe1/ iophe1(9)
      integer iophe2
      common/iophe2/ iophe2(9)
      integer ih2pnt , ih2pof
      common/h2ppnt/ ih2pnt(2) , ih2pof
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer ica2ex , ica2op
      common/ca2ex/ ica2ex(2) , ica2op
      real pca2ex
      common/pca2ex/ pca2ex
      double precision FreeFreeOpacity
*density and temp factors needed for free-free opacity
      common/ffopac/ FreeFreeOpacity(ncell)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      logical lgResetOTS
      common/ResetOTS/ lgResetOTS
      integer ipmgex ,ipOpMgEx
      real xmglst, popmg2 , rmg2l , xMg2Max
*     these all deal with photoionization from upper lev of Mg II 2798
      common/mgexc/ ipmgex , xmglst, popmg2 , rmg2l , xMg2Max,ipOpMgEx
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      integer in1(3)
      real p2nit
      common/nitexc/ p2nit , in1
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
      character chReason*21
      common/reason/ chReason
*flag saying that calculation stopped for bad reason
*mostly set in endfun
      logical lgBadStop
      common/badstp/ lgBadStop
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i, n , nd
      real sum,fac,fac1,heff,depcoe , oldhe3
      real hnold(lmhlvl) , fachmi , fachmi1 , depold(lmhlvl)
      double precision dfactor
      save hnold , depold , oldhe3
*
*     free statement numbers >= 44
*
      if( lgTrace .or. (lgTrConvg.and. nLevTrace.lt.2 ) ) then
        write(qq,'(''     AddOpac called'')')
      endif
*
*     this flag tells HEOPAC whether gas opacity has ever been evaluated
      lgOpacOn = .true.
*     opacz will zero out scattering and absorption opacities,
*     and set OldOpacSave to opac to save it
      call opacz
*
*     free electron scattering opacity, Compton recoil energy loss
      do i=1,ircoil-1
*       scattering part of total opacity
        scatop(i) = scatop(i) + OpacStack(i-1+iopcom) * eden
      end do
      do i=ircoil,nflux
*       scattering part of total opacity
*       at high energies Compton recoil is important, simply loose photons
*       since code not designed for Compton thick clouds
        fac = anu(i) / 7.512e4
        fac = fac/(1.+fac)
*       >>chng 97 apr 28, better treatment of loss due to compton recoil
        scatop(i) = scatop(i) + OpacStack(i-1+iopcom) * eden*(1.-fac)
        opac(i) = opac(i) + OpacStack(i-1+iopcom) * eden*fac
      end do
*
      do i=ircoil,nflux
*       add in bound hydrogen electron scattering, treated as absorption
        opac(i) = opac(i) + OpacStack(i-1+iopcom) * hi
      end do
*
*     bound helium electron scattering, treated as absorption
      do i=irche,nflux
        opac(i) = opac(i) + OpacStack(i-1+iopcom) * hei*2.
      end do
*
*     opacity due to pair production
      sum = hden + 4.*ahe
      call opacin(ioppr ,ippr ,nflux ,sum)
*
*     hydrogen, helium, heavy element brems (free-free) opacity,
*     assuming Hydrogen free-free gaunt factors
*     logic change June 4 95 to better treat h- absorption
*     FreeFreeOpacity is evaluated in ff heating routine, then added here
*     OPSV is missing factor of 1E-20 to avoid underflow
      fac = (eden/1e10) * ((hii+heii+4.*heiii+EdenFFSum)/1e10) / sqrte
      fac1 = fac * te1ryd / te
      fachmi = (eden/1e10) * (hii*hn(1)/1e10) / sqrte
      fachmi1 = fachmi * te1ryd / te
      do i=1,nflux
        if( ContBoltz(i).lt.0.995 ) then
*         use 1-exp(hn/kT)) only if exp is small
*         last term is scaled h minus brems free-free absorption
          dfactor = OpacStack(i-1+ipBrems) * (1.-ContBoltz(i))* gff(i)
          FreeFreeOpacity(i) = dfactor * fac
*         this is the H- part, opsv here is ratio of H- to ff
          FreeFreeOpacity(i) = FreeFreeOpacity(i) + dfactor * fachmi *
     1    OpacStack(i-1+iphmra)
        else
          dfactor = OpacStack(i-1+ipBrems) * anu(i)* gff(i)
          FreeFreeOpacity(i) = dfactor * fac1
*         h- free free absorption
          FreeFreeOpacity(i) = FreeFreeOpacity(i) + dfactor * fachmi1 *
     1    OpacStack(i-1+iphmra)
        endif
        opac(i) = opac(i) + FreeFreeOpacity(i)
      end do
*
*     H minus absorption, with correction for stimulated emission
      do i=iphmin,min(nflux,nhe1(1))
        opac(i) = opac(i) + OpacStack(i-iphmin+iphmop) * hminus *
     1  (1. - ContBoltz(i)/hmidep )
      end do
*
*     H2P h2plus bound free opacity
      do i=ih2pnt(1),ih2pnt(2)
        opac(i) = opac(i) + h2plus * OpacStack(i-ih2pnt(1)+ih2pof)
      end do
*
      if( hbn(2).gt.1e-30 .and. .not.lgSearch) then
        stimax(2) = max( stimax(2) , ContBoltz(ipHn(2))/real(hbn(2)) )
      endif
*
*     get total population of hydrogen ground
      if( hii.le.0. ) then
        fac = hi
      else
        fac = hii * hn(1)
      endif
*
*     Ly a damp wing opac (Rayleigh scattering)
      do i=1,ipHn(1)
        scatop(i) = scatop(i) + fac * OpacStack( i-1+ipRayScat )
      end do
*
*     approx correction for presence of molecules; 3 is ratio of cs
      if( hii.gt.0. ) then
        heff = hn(1)*hii + 3.*htwo
      else
*       when gas is totally neutral HN(1)*HII is zero
        heff = hi + 3.*htwo
      endif
*
*     hydrogen lyman continuum photoelectric opacity with corr for stim emission
      if( hn(1).gt.0. .and. .not.lgSearch) then
        if( hbn(1).gt.1e-30 ) then
          depcoe = hbn(1)
          stimax(1) = max( stimax(1) , ContBoltz(ipHn(1)) / depcoe )
        else
          depcoe = 0.
        endif
      else
         depcoe = 0.
      endif
*     this version of OPACIN has stimulated emission
*      >>chng 96 feb 15, had been explicit loop
      call opinb( iphop(1), ipHn(1) , nflux , heff , depcoe )
*
*     atomic hydrogen opacity
*     Balmer, Paschen, etc continuum
      if( nzone.le.1 ) then
        do n=2,nhlvl
          hnold(n) = hn(n)*hii
          depold(n) = hbn(n)
        end do
      endif
*
      hnold(1) = hn(1)*hii
      depold(1) = hbn(1)
      do n=2,nhlvl
        if( .not.lgSearch .and. hbn(n).gt.1e-30 ) then
*       >>chng 96 may 15, departure coef saved
          depold(n) = depold(n)*0.75 + 0.25*real(hbn(n))
        else
          depold(n) = 0.
        endif
        hnold(n) = hn(n)*hii*0.25 + 0.75*hnold(n)
        call opinb( iphop(n), ipHn(n) , ipHn(1),hnold(n),depold(n))
      end do
*
*     generate current grain opacities since may be function of depth
      if( lgDustOn ) then
        do i=1,nupper
*         these are total absorption and scattering cross sections
          dstab(i) = 0.
          dstsc(i) = 0.
        end do
*       >>chng 97 july 17, grain abundance function of depth
        do nd=1,ndust
          if( lgDustOn1(nd) ) then
            do i=1,nupper
*             these are total absorption and scattering cross sections
              dstab(i) = dstab(i) + dstab1(i,nd) * dstAbund(nd)
              dstsc(i) = dstsc(i) + dstsc1(i,nd) * dstAbund(nd)
            end do
          endif
        end do
*
*       add dust grain opacity if dust present
        do i=1,nflux
          scatop(i) = scatop(i) + dstsc(i) * hden
          opac(i) = opac(i) + dstab(i) * hden
        end do
      endif
*
*     Helium singlets helium ion
      if( .not.lgSearch ) then
        if( he2bn(1).gt.0. ) then
          if( ContBoltz(nhe2(1))/he2bn(1).gt.1. ) lgHeMase = .true.
        endif
        if( he1bn(1).gt.0. ) then
          if( ContBoltz(nhe1(1))/he1bn(1).gt.1. ) lgHeMase = .true.
        endif
      endif
*
*     helium triplets hei
      if( lgSearch ) then
*       neglect stimulated emission corr if search underway
*       >>chng 96 feb 15, was 1
        depcoe = 0.
      else
        depcoe = he3bn(1)
      endif
*
      if( nzone.le.1 ) then
        oldhe3 = heii*he3n(1)
      endif
      oldhe3 = 0.75 * oldhe3 + 0.25 * heii*he3n(1)
*     this version of OPACIN has stimulated emission
      call opinb( ioptri, nhei3 , nhe1(1) , oldhe3 , depcoe )
*
*     helium singlets hei
*     ground special since it extends to high energy limit of code
      if( lgSearch ) then
*       neglect stimulated emission corr if search underway
*       >>chng 96 feb 15, was 1
        depcoe = 0.
      else
        depcoe = he1bn(1)
      endif
      call opinb( iophe1(1) , nhe1(1) , nflux , heii*he1n(1) , depcoe)
*
*     helium singlets hei, these only extend up to above
      do n=2,nhe1lvl
        if( lgSearch ) then
*         neglect stimulated emission corr if search underway
*       >>chng 96 feb 15, was 1
          depcoe = 0.
        else
          depcoe = he1bn(n)
        endif
        call opinb( iophe1(n), nhe1(n) , nhe1(1),he1n(n)*heii,depcoe)
      end do
*
*     ionized helium heii helium ion
*     ground special since extends up to high energy limit of code
      if( lgSearch ) then
*       neglect stimulated emission corr if search underway
        depcoe = 1.
      else
        depcoe = he2bn(1)
      endif
      call opinb( iophe2(1), nhe2(1) , nflux   , he2n(1)*heiii, depcoe )
      do n=2,nhe2lvl
        if( lgSearch ) then
*         neglect stimulated emission corr if search underway
          depcoe = 1.
        else
          depcoe = he2bn(n)
        endif
        call opinb( iophe2(n),nhe2(n) ,nhe2(1) ,he2n(n)*heiii,depcoe)
      end do
*
*     lithium opacity
      call PutOpacity( 3)
*
*     beryllium opacity
      call PutOpacity( 4)
*
*     boron opacity
      call PutOpacity( 5)
*
*     carbon opacity
      call PutOpacity( 6)
*
*     nitrogen opacity
      call PutOpacity( 7)
*     excited level of N+
      call opacin(in1(3),in1(1),in1(2),xIonFracs(7,1)*p2nit)
*
*     oxygen opacity
      call PutOpacity( 8)
*     excited level of Oo
      call opacin( ipo1exc(3),ipo1exc(1),ipo1exc(2),
     1 xIonFracs(8,1)*poiexc)
*     O2+ excited states
      call opacin( ipo3exc(3),ipo3exc(1),ipo3exc(2),
     1 xIonFracs(8,3)*poiii2)
      call opacin( ipo3exc3(3),ipo3exc3(1),ipo3exc3(2),
     1 xIonFracs(8,3)*poiii3)
*
*     fluorine opacity
      call PutOpacity( 9)
*
*     neon opacity
      call PutOpacity( 10)
*
*     sodium opacity
      call PutOpacity( 11)
*
*     magnesium opacity
      call PutOpacity( 12)
*     excited level of Mg+
      call opacin(ipOpMgEx,ipmgex,ipHn(1),xIonFracs(12,2)*popmg2)
*
*     aluminium opacity
      call PutOpacity( 13)
*
*     silicon opacity
      call PutOpacity( 14)
*
*     phosphorus opacity
      call PutOpacity( 15)
*
*     sulphur opacity
      call PutOpacity( 16)
*
*     clorine opacity
      call PutOpacity( 17)
*
*     Argon opacity
      call PutOpacity( 18)
*
*     potassium opacity
      call PutOpacity( 19)
*
*     calcium opacity
      call PutOpacity( 20)
*     photoionization of excited levels of Ca+
      call opacin( ica2op , ica2ex(1) , ica2ex(2) , pca2ex )
*
*     scandium opacity
      call PutOpacity( 21)
*
*     titanium opacity
      call PutOpacity( 22)
*
*     vanadium
      call PutOpacity( 23)
*
*     chromium
      call PutOpacity( 24)
*
*     manganese
      call PutOpacity( 25)
*
*     iron
      call PutOpacity( 26)
*
*     cobalt
      call PutOpacity( 27)
*
*     nickel
      call PutOpacity( 28)
*
*     copper
      call PutOpacity( 29)
*
*     zinc
      call PutOpacity( 30)
*
*     total opacity now defined - now look at some ratios
*
      do n=1,nhe2lvl
*       if( opac(nhe2(n)).gt.0. ) then
*         ophe2f(n) = max(0.,
*    1    (opac(nhe2(n))-heiii*he2n(n)*OpacStack(iophe2(n)) )
*       else
*         ophe2f(n) = 0.
*       endif
*       now find ratio of .not.helium to total opacities
        if( opac(nhe2(n)).gt.0. ) then
          if( he2bn(n).gt.1e-30 .and.(.not.lgSearch) ) then
             fac= 1. / he2bn(n)
          else if(lgSearch) then
             fac = 0.
          else
             fac= 1.
          endif
          ophe2f(n) = ((opac(nhe2(n)) - heiii*he2n(n)*
     1    OpacStack(iophe2(n))*
     1    (1.-fac*ContBoltz(nhe2(n)) ) )/ opac(nhe2(n)) + ophe2f(n))/2.
          ophe2f(n) = max( 0., ophe2f(n) )
        else
          ophe2f(n) = 0.
        endif
      end do
*
      do n=1,nhe1lvl
        if( nhe1(n).lt.nflux .and. opac(nhe1(n)).gt.0. ) then
          if( he1bn(n).gt.1e-30.and. (.not.lgSearch) ) then
             fac= 1. / he1bn(n)
          else if(lgSearch) then
             fac = 0.
          else
             fac= 1.
          endif
          ophe1f(n) = ( (opac(nhe1(n)) - heii*he1n(n)*
     1    OpacStack(iophe1(n))*
     1    (1.-fac*ContBoltz(nhe1(n)) ) )/ opac(nhe1(n)) + ophe1f(n))/2.
          ophe1f(n) = max( 0., ophe1f(n) )
        else
          ophe1f(n) = 0.
        endif
      end do
*
      if( nzone.lt.1 ) then
        do n=1,nhlvl
          if( opac(ipHn(n)) .gt. 1e-30 ) then
            ophf(n) =
     1      (opac(ipHn(n))  - hn(n)*hii*OpacStack(iphop(n))
     1       ) / opac(ipHn(n) )
          else
            ophf(n) = 0.
          endif
        end do
      endif
      do n=1,nhlvl
*       ratios of other to total opacity for H continua
*       same for Lyman, Balmer continua of hydrogen
        if( opac(ipHn(n) ).gt.0. ) then
          if( hbn(n).gt.1e-30 .and.(.not.lgSearch) ) then
             fac= 1. / hbn(n)
          else if(lgSearch) then
             fac = 0.
          else
             fac= 1.
          endif
*       >>chng 96 may 15, departure coef saved
          if( opac(ipHn(n)).gt.1e-30 ) then
            ophf(n) = ophf(n)*0.75 + 0.25*
     1      (opac(ipHn(n))  - hnold(n)*OpacStack(iphop(n))*(1.-fac*
     1      ContBoltz(ipHn(n) )) ) / opac(ipHn(n) )
          else
            ophf(n) = 0.
          endif
          ophf(n) = max( 0. , ophf(n) )
        else
          ophf(n) = 0.
        endif
      end do
*
*       >>chng 97 mar 8, zero out very small opacities, below precision on
*       current cpu.  done to stop ots fluxes from exploding at low densities
*       >>chng 97 may 6, decreased from 1e-30 to 1e-34, ldl.in did not work
      if( lgBit32 ) then
        do i=1,nflux
          if(opac(i).lt.1e-34 ) opac(i) = 0.
        end do
      endif
*
*     option to reset ots fields due to change in opacity
      if( lgResetOTS ) then
        do i=1,nflux
*         if( opac(i)*OldOpacSave(i) .gt.0. ) then
*         >>chng 97 mar 20, rescale if opac is greater than zero
*         >>chng 97 jul 7, from 1e-30 to 1e-29
*         >>chng 97 jul 9, from 1e-29 to 1e-28
*         >>chng 97 jul 11, from 1e-29 to 1e-30
          if( opac(i) .gt.1e-30 ) then
            otscon(i) = otscon(i) * (OldOpacSave(i)/opac(i))
            otslin(i) = otslin(i) * (OldOpacSave(i)/opac(i))
          else
*           >>chng 97 mar 8, zero it out if opac is zero
*           >>chng 97 jul 9, keep track of turned off lines so that
*           they are not turned
*           back on
            lgOTSOn(i) = .false.
            otscon(i) = 0.
            otslin(i) = 0.
          endif
        end do
*       must reset sums of these continua
        call SumContinuum
      endif
*     call TestCode
*     write(11,'('' ots2'',1p,2e10.2)') opac(iphl(2,1)),
*    1 otslin(iphl(2,1))
*
*     compute gas albedo here
      do i=1,nflux
        albedo(i) = scatop(i) / (scatop(i)+opac(i))
      end do
*
*begin sanity check
      sum = 0.
      do i=1,nflux
        sum = max( opac(i) , sum )
      end do
      lgOK = .true.
      if( sum.le.0. ) then
        write(qq,'('' AddOpac finds zero opacity - the density is '',
     1  ''probably too low for this cpu.'')')
        write(qq,'('' hydrogen density is '',1p,e10.2,
     1  ''and neutral density is '',e10.2)') hden, hn(1)*hden
        lgOK = .false.
*       say this was a bad stopping reason
        lgBadStop = .true.
        chReason = 'opacity scale undrflo'
      endif
*end sanity check
*
      if( lgTrace ) then
        write(qq,'(5x,''AddOpac returns; grd rec eff (opac)'',
     1  '' for Hn=1,4'',1P,4E10.2,'' HeI,II;'',2E10.2)')
     2  ophf(1) ,ophf(2),ophf(3),ophf(4),ophe1f(1),ophe2f(1)
      end if
*
      end
******************************************************************************
      subroutine AddOTSCon( ots , ip )
      implicit none
*add local destruction of continuum to ots field
      real ots
      integer ip
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real opac
      common/opac/ opac(ncell)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ZeroNum
*this is the number zero, used to trick clever compilers when
*dividing by it to crash program
*there is a routine called zero - this name cannot overlap
      common/zero0/ ZeroNum
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real OldOpacSave
      logical lgOTSOn
*save previous opacity
      common/OldOpac/ OldOpacSave(ncell)  , lgOTSOn(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real a , b  , otsnew
*
*     routine called to add ots due to continuum destruction to
*     radiation field
*
*     check if outside bounds of this continuum source
      if( ip.gt.nflux .or. .not.lgOTSOn(ip) ) return
*begin sanity checks
      if(ots.lt.0. ) then
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSCon called with negative ots flux.'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        write(qq,'('' 1/zero='',1p,e10.2)') a
        stop
      else if( ip.le.0 ) then
        b = 0.
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSCon called with non-positive line pnt'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        stop
      else if( ip.gt.ncell ) then
        b = 0.
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSCon called with too-large line pointer.'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        stop
      endif
*end sanity checks
*
*     add locally destroyed flux of photons to continuum OTS array
      if( opac(ip).gt.0. ) then
        otsnew = ots / opac(ip)
      else
        otsnew = 0.
      endif
*
*     update summed radiation fields
      otscon(ip) = otsnew
      SummedDif(ip) = otscon(ip)+otslin(ip)+outcon(ip)+outlin(ip)
      SummedCon(ip) = flux(ip)+SummedDif(ip)
      SummedOcc(ip) = SummedCon(ip) * convoc(ip)
*
      end
******************************************************************************
      subroutine AddOTSLin( ots , ip ,damper )
      implicit none
*add local destruction of lines to ots field
      real ots , damper
      integer ip
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real opac
      common/opac/ opac(ncell)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ZeroNum
*this is the number zero, used to trick clever compilers when
*dividing by it to crash program
*there is a routine called zero - this name cannot overlap
      common/zero0/ ZeroNum
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real OldOpacSave
      logical lgOTSOn
*save previous opacity
      common/OldOpac/ OldOpacSave(ncell)  , lgOTSOn(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real a , b  , otsnew
*
*     add ots due to line destruction to radiation field
*     damper is fraction of new ots
*
*     check if outside bounds of this continuum source
      if( ip.gt.nflux .or. (.not.lgOTSOn(ip)) ) return
*begin sanity checks
      if(ots.lt.0. ) then
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSLin called with negative ots flux.'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        write(qq,'('' 1/zero='',1p,e10.2)') a
        stop
      else if( ip.le.0 ) then
        b = 0.
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSLin called with non-positive line pointer.''
     1)')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        stop
      else if( ip.gt.ncell ) then
        b = 0.
        a = 1.
        call ShowMe
        write(qq,'('' AddOTSLin called with too-large line pointer.'')')
        write(qq,'('' I will divide by 0 to get trace.'')')
        a = a / ZeroNum
        stop
      endif
*end sanity checks
*
*     add locally destroyed flux of photons to line OTS array
      if( opac(ip).gt.0. ) then
        otsnew = ots/opac(ip)
      else
        otsnew = 0.
      endif
*
*     update summed radiation fields
      if( nzone.gt.1 ) then
        otslin(ip) = otsnew*damper + otslin(ip)*(1.-damper)
      else
        otslin(ip) = otsnew
      endif
      SummedDif(ip) = otscon(ip)+otslin(ip)+outcon(ip)+outlin(ip)
      SummedCon(ip) = flux(ip)+SummedDif(ip)
      SummedOcc(ip) = SummedCon(ip) * convoc(ip)
*
      end
******************************************************************************
      subroutine CheckAge
      implicit none
*check various timescales after calculation complete to confirm time steady OK
      integer nzlim
      parameter (nzlim=2000)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      real CloudAgeSet
*age of cloud set with age command
      common/CloudAge/ CloudAgeSet
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real tcmptn , ttherm
      common/timesc/ tcmptn , ttherm
*     these save structure variables, like te vs depth
      real testr, volstr, radstr, histr, hiistr , ednstr,o3str,heatstr,
     1 pdenstr
      common/struc/ testr(nzlim), volstr(nzlim), radstr(nzlim),
     1 histr(nzlim), hiistr(nzlim) , ednstr(nzlim),o3str(nzlim),
     2 heatstr(nzlim),pdenstr(nzlim)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real sound,vsound
*     vsound is local sound speed, eval zone by zone
*     sound is sound travel time (sec) updated in tauing
      common/sound/ sound,vsound
      logical lgPrnAges
      common/PrnAges/ lgPrnAges
      real AgeMoleForm
*longest timescale for molecules to form
      common/AgeMole/ AgeMoleForm
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      character chLine*132
*
*     local variables
      integer i
      real threc , tlong , tsound
*
*     cloud age of zero means that age command turned off
*     negative cloud age means was not set
*
*     remember longest timescale
      tlong = 0.
*     thermal equilibrium timescale
      ttherm = 0.
*     >>chng 97 may 6, may not be data for last zone if unusual exit
      do i=1,max(1,nzone-1)
        ttherm = max( ttherm,
     1  pdenstr(i)*Boltzmann*1.5*testr(i)/heatstr(i) )
      end do
*
      tlong = max( tlong , ttherm )
      if( lgPrnAges ) then
        write(chLine,'(''   AGE: longest thermal '',
     1  ''timescale='',1p,e10.2,''s.'')') ttherm
        call notein( chLine )
      endif
      if( CloudAgeSet.gt.0. .and. ttherm.gt.CloudAgeSet ) then
        write(chLine,'('' C-AGE: Thermal equilibrium '',
     1  ''timescale longer than age, ='',1P,E10.2,''s'')') ttherm
        call caunin( chLine )
      endif
*
*     check soundt travel time if constant pressure
      if( chCPres.eq.'CPRE' ) then
        tsound = sound
        if( lgPrnAges ) then
          write(chLine,'(''   AGE: sound travel '',
     1    ''time='',1p,e10.2,''s.'')') tsound
          call notein( chLine )
        endif
        if( CloudAgeSet.gt.0. .and. tsound.gt.CloudAgeSet ) then
          write(chLine,'('' C-AGE: Sound travel time '',
     1    ''longer than age in constant pressure model ='',1P,E10.2,
     2    ''s'')') ttherm
          call caunin( chLine )
        endif
      else
*       do not check if not constant pressure
        tsound = 0.
      endif
      tlong = max( tlong , tsound )
*
*     molecule formation timescale
      tlong = max( tlong , AgeMoleForm )
*     >>chng 97 jan 3, don't print if zero
      if( lgPrnAges .and. AgeMoleForm.gt.0. ) then
        write(chLine,'(''   AGE: longest H2 formation '',
     1  ''timescale='',1p,e10.2,''s.'')') AgeMoleForm
        call notein( chLine )
      endif
      if( CloudAgeSet.gt.0. .and. AgeMoleForm.gt.CloudAgeSet ) then
        write(chLine,'('' C-AGE: H2 formation '',
     1  ''timescale longer than age, ='',1P,E10.2,''s'')') AgeMoleForm
        call caunin( chLine )
      endif
*
*     hydrogen recombination timescale
      threc = 0.
      do i=1,max(1,nzone-1)
        threc = max( threc,
     1  1./(ednstr(i)*2.90e-10*testr(i)**(-0.77)) )
      end do
*
      tlong = max( tlong , threc )
      if( lgPrnAges ) then
        write(chLine,'(''   AGE: longest H recombination '',
     1  ''timescale='',1p,e10.2,''s.'')') threc
        call notein( chLine )
      endif
      if( CloudAgeSet.gt.0. .and. threc.gt.CloudAgeSet ) then
        write(chLine,'('' C-AGE: Hydrogen recombination '',
     1  ''timescale longer than age, ='',1P,E10.2,''s'')') threc
        call caunin( chLine )
      endif
*
      if( CloudAgeSet.lt.0. ) then
*       CloudAgeSet initially set to -1, if still the case then age not set
        if( tlong.lt.3600. ) then
*         less than one day, give only seconds
          write(chLine,'(''  !AGE: Cloud age was not set.  Longest '',
     1    ''timescale was'',1p,e9.2,''s.'')') tlong
          call bangin( chLine )
        else if( tlong.lt.8.64e4 ) then
*         less than one day, give seconds and hours
          write(chLine,'(''  !AGE: Cloud age was not set.  Longest '',
     1    ''timescale was '',1p,e8.2,''s = '',e8.2,'' hours.'')') tlong,
     2    tlong/3600.
          call bangin( chLine )
        else if( tlong.lt.3e7/12. ) then
*         less than one month, give seconds and days
          write(chLine,'(''  !AGE: Cloud age was not set.  Longest '',
     1    ''timescale was '',1p,e8.2,''s = '',e8.2,'' days.'')') tlong,
     2    tlong/86400.
          call bangin( chLine )
        else if( tlong.lt.3e7 ) then
*         less than one year, give seconds and months
          write(chLine,'(''  !AGE: Cloud age was not set.  Longest '',
     1    ''timescale was '',1p,e8.2,''s = '',e8.2,'' months.'')')tlong,
     2    tlong/3.15569e7*12.
          call bangin( chLine )
        else
*         more than one year, give seconds and years
          write(chLine,'(''  !AGE: Cloud age was not set.  Longest '',
     1    ''timescale was '',1p,e8.2,''s = '',e8.2,'' years.'')') tlong,
     2    tlong/3.15569e7
          call bangin( chLine )
        endif
      else
*       age set, and passed tests, still say longest
        if( tlong.lt.3e7 ) then
*         less than one year, give only seconds
          write(chLine,'(''   AGE: Cloud age was'',1p,e9.2,
     1    ''s, Longest '',''timescale was '',1p,e8.2,''s.'')')
     1    CloudAgeSet,tlong
          call notein( chLine )
        else
*         more than one year, give seconds and years
          write(chLine,'(''  !AGE: Cloud age was '',1p,e9.2,
     1    ''s.  Longest timescale was'',e9.2,''s = '',e8.2,'' years.''
     2    )') CloudAgeSet,tlong, tlong/3.15569e7
          call bangin( chLine )
        endif
      endif
*
      end
******************************************************************************
      subroutine alumin
      implicit none
*ionization balance for aluminum
      integer limelm
      parameter (limelm=30)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer nelem , ndim
      parameter (nelem=13)
      parameter (ndim=14)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(13)  , yYIELD(11) , yYIELDL(3)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/13*0.2/ , yYIELD/11*0./ , yYIELDL/3*0./
*
*     aluminium nelem=13
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
*     use silicon since not in shull + van steenberg
      data (cion(i,1),i=1,ndim-1)
     1 /3.92E-10,4.87E-11,2.32E-11,6.20E-12,4.86E-12,2.60E-12,
     1 1.65E-12,1.03E-12,6.02E-13,3.23E-13,1.95E-13,7.44E-15,3.09E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /9.46E4,1.90E5,3.88E5,5.24E5,1.93E6,2.38E6,2.86E6,3.52E6,4.07E6,
     2 4.66E6,5.52E6,6.07E6,2.83E7/
*
*     rec coef from Aldrovandi and Pequignot Revista Bras de Fisica 4, 491.
      data rec , pl
     1/2.14E-10 , 1.05E-9 , 6.49E-9 , 1.09E-8 , 1.31E-8 , 2.54E-8 ,
     2  3.13E-8 , 8.85E-8 , 1.22E-7 , 7.15E-7 , 5.54E-7 , 4.12E-7 ,
     3 -0.659  , -0.713  , -0.840  , -0.784  , -0.742  , -0.752  ,
     4 -0.733  , -0.789  ,  -0.790  , -0.927  , -0.883 , -0.809  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.13e-10 , -0.567/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/5.5E-3 , 6.0E-3 , 7.5E-3 , 5.6E-3 , 1.2E-2 , 1.9E-2 , 1.6E-2
     1,1.7E-2 , 4.4E-2 , 1.7E-2 , 3.0E-1 , 3.4E-0 , 0./
      data (dite(i,1),i=1,ndim-1)
     2/9.0E4  , 7.5E4  , 8.5E5  , 5.0E5  , 4.4E5  , 3.8E5  , 3.4E5
     2,3.4E5  , 3.9E5  , 2.3E5  , 1.6E7  , 1.7E7  , 1E20/
      data ditcrt
     3/8.0E3  , 7.0E3  , 1.2E5  , 7.0E4  , 6.5E4  , 5.5E4  , 5.5E4
     3,5.5E4  , 5.8E4  , 4.0E4  , 2.9E6  , 5.5E6  , 1E20 /
      data (dicoef(i,2),i=1,ndim-1)/nelem*0./
      data (dite(i,2),i=1,ndim-1)/nelem*0./
*
*     from Nussbaumer and Storey, Mg, Al, Si: n.b., al1 uses table 2(b)
      data
     1 aa/  0.0219 ,  0.7086 , 11*0./,
     2 bb/ -0.4528 , -3.1083 , 11*0./,
     3 cc/  2.5427 ,  7.0422 , 11*0./,
     4 dd/ -0.1678 ,  0.5998 , 11*0./,
     5 ff/  0.2276 ,  0.4194 , 0.1,10*0./
*
*     aluminium, atomic number 13
      if( .not.lgElmtOn(13) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if(lgTrace.and.lgHeavyBug)then
        write(qq,'(5X,''ALUMIN returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
******************************************************************************
      subroutine argoni
      implicit none
*compute ionization balance of argon
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real hi , hii
      common/h/ hi , hii
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=19)
      parameter (nelem=18)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(18)  , yYIELD(16) , yYIELDL(8)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/18*0.2/ , yYIELD/16*0./ , yYIELDL/8*0./
*
*     argon nelem=18
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /2.20E-10,1.20E-10,3.50E-11,3.80E-11,6.47E-12,1.72E-12,
     1 2.20E-12,6.95E-13,7.57E-13,4.75E-13,3.45E-13,2.48E-13,1.57E-13,
     2 9.10E-14,6.05E-14,2.62E-14,2.60E-15,1.13E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /1.83E5,3.21E5,4.75E5,6.94E5,8.70E5,1.06E6,1.44E6,1.66E6,4.90E6,
     2 5.56E6,6.25E6,7.17E6,7.96E6,8.77E6,9.92E6,1.07E7,4.78E7,5.14E7/
*
*     rec from +15, 16, 17 from Arnauld et al 85
      data rec , pl
     1/3.67E-11 , 1.16E-9 , 4.1E-9  , 6.3E-9  , 8.5E-9 , 1.15E-8,
     1 1.42E-8  , 6.71E-8 , 4.99E-8 , 6.5E-8  , 5.7E-8 , 5.1E-8 ,
     1 7.6E-8   , 8.3E-8  , 5.80E-7 , 1.14E-6 , 9.45E-7,
     2 -0.497   , -0.694  , -0.778  , -0.756  , -0.724 , -0.706,
     2 -0.676   , -0.830  , -0.750  , -0.755  , -0.707, -0.647,
     2 -0.694   , -0.682  , -0.819  , -0.854  , -0.803/
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.00E-3, 1.10E-2, 3.40E-2, 6.85E-2, 9.00E-2, 6.35E-2,
     2 2.60E-2, 1.70E-2, 2.10E-2, 3.50E-2, 4.30E-2, 7.13E-2,
     3 9.60E-2, 8.50E-2, 1.70E-2, .476, .297, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/.005, .045, .057, .087, .0769, .140, .120, .1, 1.92, 1.66,
     2 1.67, 1.40, 1.31, 1.02, .245, .294, .277, 0./
      data (dite(i,1),i=1,ndim-1)
     1 / 3.20E+5, 2.90E+5, 2.39E+5, 2.56E+5, 2.50E+5, 2.10E+5, 1.80E+5,
     1 2.70E+6, 8.30E+5, 6.95E+5, 6.05E+5, 6.68E+5, 6.50E+5, 5.30E+5,
     1 3.55E+5, 3.01E+7, 3.13E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1 / 3.10E+5, 5.50E+5, 6.00E+5, 3.81E+5, 3.30E+5, 2.15E+5, 2.15E+5,
     2 3.30E+6, 3.50E+6, 3.60E+6, 3.80E+6, 2.90E+6, 3.60E+6, 2.80E+6,
     3 1.10E+6, 6.05E+6, 6.54E+6, 0./
      data ditcrt
     3/2.5E4  , 3.0E4  , 2.5E4  , 2.5E4  , 1.8E4  , 1.8E4  , 2.2E4
     3,5.0E5  , 1.6E5  , 1.5E5  , 1.5E5  , 1.3E5  , 1.3E5  , 1.1E5
     3,7.6E4  , 6.5E6  , 1.4E7  , 1E20  /
*
      data aa/18*0./,bb/18*0./,cc/18*0./,dd/18*0./,ff/18*0./
*
*     argon, atomic number 18
      if( .not.lgElmtOn(18) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*666  call PrtGamma(ipArgon(2,5,1) ,ipArgon(2,5,2) ,
*    1 ipArgon(2,5,3),
*    1 qq,  photorate(nelem,2,5,1) ,photorate(nelem,2,5,1)*0.05 )
*     write(qq,'('' Ar 1'',1p,8e10.2)') (photorate(nelem,1,i,1),i=1,7)
*     write(qq,'('' Ar 2'',1p,8e10.2)') (photorate(nelem,2,i,1),i=1,7)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     CHARGE EXCHANGE, ALL RATES FROM BUTLER AND DALGARNO 1980B
*     A+2 => A+
*     CTHeavy(2,2) = CTHeavy(2,2) + 1E-14 * HI + HEI * 1.3E-10
*     >>chng 96 Oct 1, move H ct into bidiag
      CTHeavy(2,2) = CTHeavy(2,2) + hei * 1.3E-10
*     A+ => A+2
      CTHeavy(2,1) = CTHeavy(2,1) + heii * 1.1E-10
*     T = MIN( SQRTE , 200. )
*     A+3 => A+2
*     >>chng 96 Oct 1, move H ct into bidiag
*     CTHeavy(3,2) = CTHeavy(3,2) + 4.4E-11*min(sqrte,200.)*hi
*     >>chng 96 Oct 1, move H ct into bidiag
*     CTHeavy(4,2) = CTHeavy(4,2) + 6.3E-9 * hi
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
      block data auger
      implicit none
*block data with Auger yield data from Kaastra, J.S., and Mewe, R.,
*Astron Astrophys Suppl Ser 97, 443 (1993)
      integer i
      real vyield
      integer nyield
*     block data of yields from Mewe paper
*     vyield( nelem, nstage, nshell, nelec )
*     nelem is element number, 6 for carbon
*     nstage is stage of ionization, 1 for atom
*     nshell is shell number in dima notation
*     nelec is fraction that yield that number of electrons
**    nyield is number of electrons at most
      common/yield/ vyield(30,30,7,10), nyield(30,30,7)
       data nyield( 3, 1, 1)/ 1/
       data (vyield( 3, 1, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 3, 1, 2)/ 1/
       data (vyield( 3, 1, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 3, 2, 1)/ 1/
       data (vyield( 3, 2, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 3, 3, 1)/ 1/
       data (vyield( 3, 3, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 4, 1, 1)/ 2/
       data (vyield( 4, 1, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 4, 1, 2)/ 1/
       data (vyield( 4, 1, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 4, 2, 1)/ 1/
       data (vyield( 4, 2, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 4, 2, 2)/ 1/
       data (vyield( 4, 2, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 4, 3, 1)/ 1/
       data (vyield( 4, 3, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 4, 4, 1)/ 1/
       data (vyield( 4, 4, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 1, 1)/ 2/
       data (vyield( 5, 1, 1,i),i=1,10)
     1/ 6.0000E-04, 9.9940E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 1, 2)/ 1/
       data (vyield( 5, 1, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 1, 3)/ 1/
       data (vyield( 5, 1, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 2, 1)/ 2/
       data (vyield( 5, 2, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 2, 2)/ 1/
       data (vyield( 5, 2, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 3, 1)/ 1/
       data (vyield( 5, 3, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 3, 2)/ 1/
       data (vyield( 5, 3, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 4, 1)/ 1/
       data (vyield( 5, 4, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 5, 5, 1)/ 1/
       data (vyield( 5, 5, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 1, 1)/ 2/
       data (vyield( 6, 1, 1,i),i=1,10)
     1/ 2.6000E-03, 9.9740E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 1, 2)/ 1/
       data (vyield( 6, 1, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 1, 3)/ 1/
       data (vyield( 6, 1, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 2, 1)/ 2/
       data (vyield( 6, 2, 1,i),i=1,10)
     1/ 1.9000E-03, 9.9810E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 2, 2)/ 1/
       data (vyield( 6, 2, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 2, 3)/ 1/
       data (vyield( 6, 2, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 3, 1)/ 2/
       data (vyield( 6, 3, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 3, 2)/ 1/
       data (vyield( 6, 3, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 4, 1)/ 1/
       data (vyield( 6, 4, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 4, 2)/ 1/
       data (vyield( 6, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 5, 1)/ 1/
       data (vyield( 6, 5, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 6, 6, 1)/ 1/
       data (vyield( 6, 6, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 1, 1)/ 2/
       data (vyield( 7, 1, 1,i),i=1,10)
     1/ 6.0000E-03, 9.9400E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 1, 2)/ 1/
       data (vyield( 7, 1, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 1, 3)/ 1/
       data (vyield( 7, 1, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 2, 1)/ 2/
       data (vyield( 7, 2, 1,i),i=1,10)
     1/ 7.1000E-03, 9.9290E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 2, 2)/ 1/
       data (vyield( 7, 2, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 2, 3)/ 1/
       data (vyield( 7, 2, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 3, 1)/ 2/
       data (vyield( 7, 3, 1,i),i=1,10)
     1/ 5.2000E-03, 9.9480E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 3, 2)/ 1/
       data (vyield( 7, 3, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 3, 3)/ 1/
       data (vyield( 7, 3, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 4, 1)/ 2/
       data (vyield( 7, 4, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 4, 2)/ 1/
       data (vyield( 7, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 5, 1)/ 1/
       data (vyield( 7, 5, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 5, 2)/ 1/
       data (vyield( 7, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 6, 1)/ 1/
       data (vyield( 7, 6, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 7, 7, 1)/ 1/
       data (vyield( 7, 7, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 1, 1)/ 2/
       data (vyield( 8, 1, 1,i),i=1,10)
     1/ 9.4000E-03, 9.9060E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 1, 2)/ 1/
       data (vyield( 8, 1, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 1, 3)/ 1/
       data (vyield( 8, 1, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 2, 1)/ 2/
       data (vyield( 8, 2, 1,i),i=1,10)
     1/ 1.0900E-02, 9.8910E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 2, 2)/ 1/
       data (vyield( 8, 2, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 2, 3)/ 1/
       data (vyield( 8, 2, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 3, 1)/ 2/
       data (vyield( 8, 3, 1,i),i=1,10)
     1/ 1.2900E-02, 9.8710E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 3, 2)/ 1/
       data (vyield( 8, 3, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 3, 3)/ 1/
       data (vyield( 8, 3, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 4, 1)/ 2/
       data (vyield( 8, 4, 1,i),i=1,10)
     1/ 9.6000E-03, 9.9040E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 4, 2)/ 1/
       data (vyield( 8, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 4, 3)/ 1/
       data (vyield( 8, 4, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 5, 1)/ 2/
       data (vyield( 8, 5, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 5, 2)/ 1/
       data (vyield( 8, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 6, 1)/ 1/
       data (vyield( 8, 6, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 6, 2)/ 1/
       data (vyield( 8, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 7, 1)/ 1/
       data (vyield( 8, 7, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 8, 8, 1)/ 1/
       data (vyield( 8, 8, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 1, 1)/ 2/
       data (vyield( 9, 1, 1,i),i=1,10)
     1/ 1.3300E-02, 9.8670E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 1, 2)/ 1/
       data (vyield( 9, 1, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 1, 3)/ 1/
       data (vyield( 9, 1, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 2, 1)/ 2/
       data (vyield( 9, 2, 1,i),i=1,10)
     1/ 1.5200E-02, 9.8480E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 2, 2)/ 1/
       data (vyield( 9, 2, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 2, 3)/ 1/
       data (vyield( 9, 2, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 3, 1)/ 2/
       data (vyield( 9, 3, 1,i),i=1,10)
     1/ 1.7600E-02, 9.8240E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 3, 2)/ 1/
       data (vyield( 9, 3, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 3, 3)/ 1/
       data (vyield( 9, 3, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 4, 1)/ 2/
       data (vyield( 9, 4, 1,i),i=1,10)
     1/ 2.0800E-02, 9.7920E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 4, 2)/ 1/
       data (vyield( 9, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 4, 3)/ 1/
       data (vyield( 9, 4, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 5, 1)/ 2/
       data (vyield( 9, 5, 1,i),i=1,10)
     1/ 1.5400E-02, 9.8460E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 5, 2)/ 1/
       data (vyield( 9, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 5, 3)/ 1/
       data (vyield( 9, 5, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 6, 1)/ 2/
       data (vyield( 9, 6, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 6, 2)/ 1/
       data (vyield( 9, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 7, 1)/ 1/
       data (vyield( 9, 7, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 7, 2)/ 1/
       data (vyield( 9, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 8, 1)/ 1/
       data (vyield( 9, 8, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield( 9, 9, 1)/ 1/
       data (vyield( 9, 9, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 1, 1)/ 2/
       data (vyield(10, 1, 1,i),i=1,10)
     1/ 1.8200E-02, 9.8180E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 1, 2)/ 1/
       data (vyield(10, 1, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 1, 3)/ 1/
       data (vyield(10, 1, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 2, 1)/ 2/
       data (vyield(10, 2, 1,i),i=1,10)
     1/ 2.0400E-02, 9.7960E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 2, 2)/ 1/
       data (vyield(10, 2, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 2, 3)/ 1/
       data (vyield(10, 2, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 3, 1)/ 2/
       data (vyield(10, 3, 1,i),i=1,10)
     1/ 2.3200E-02, 9.7680E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 3, 2)/ 1/
       data (vyield(10, 3, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 3, 3)/ 1/
       data (vyield(10, 3, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 4, 1)/ 2/
       data (vyield(10, 4, 1,i),i=1,10)
     1/ 2.6800E-02, 9.7320E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 4, 2)/ 1/
       data (vyield(10, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 4, 3)/ 1/
       data (vyield(10, 4, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 5, 1)/ 2/
       data (vyield(10, 5, 1,i),i=1,10)
     1/ 3.1200E-02, 9.6880E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 5, 2)/ 1/
       data (vyield(10, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 5, 3)/ 1/
       data (vyield(10, 5, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 6, 1)/ 2/
       data (vyield(10, 6, 1,i),i=1,10)
     1/ 2.2900E-02, 9.7710E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 6, 2)/ 1/
       data (vyield(10, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 6, 3)/ 1/
       data (vyield(10, 6, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 7, 1)/ 2/
       data (vyield(10, 7, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 7, 2)/ 1/
       data (vyield(10, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 8, 1)/ 1/
       data (vyield(10, 8, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 8, 2)/ 1/
       data (vyield(10, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10, 9, 1)/ 1/
       data (vyield(10, 9, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(10,10, 1)/ 1/
       data (vyield(10,10, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 1, 1)/ 3/
       data (vyield(11, 1, 1,i),i=1,10)
     1/ 2.6000E-02, 6.3420E-01, 3.3980E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 1, 2)/ 2/
       data (vyield(11, 1, 2,i),i=1,10)
     1/ 1.0000E-04, 9.9990E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 1, 3)/ 1/
       data (vyield(11, 1, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 1, 4)/ 1/
       data (vyield(11, 1, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 2, 1)/ 2/
       data (vyield(11, 2, 1,i),i=1,10)
     1/ 2.6300E-02, 9.7370E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 2, 2)/ 1/
       data (vyield(11, 2, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 2, 3)/ 1/
       data (vyield(11, 2, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 3, 1)/ 2/
       data (vyield(11, 3, 1,i),i=1,10)
     1/ 2.9600E-02, 9.7040E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 3, 2)/ 1/
       data (vyield(11, 3, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 3, 3)/ 1/
       data (vyield(11, 3, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 4, 1)/ 2/
       data (vyield(11, 4, 1,i),i=1,10)
     1/ 3.3800E-02, 9.6620E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 4, 2)/ 1/
       data (vyield(11, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 4, 3)/ 1/
       data (vyield(11, 4, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 5, 1)/ 2/
       data (vyield(11, 5, 1,i),i=1,10)
     1/ 3.9300E-02, 9.6070E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 5, 2)/ 1/
       data (vyield(11, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 5, 3)/ 1/
       data (vyield(11, 5, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 6, 1)/ 2/
       data (vyield(11, 6, 1,i),i=1,10)
     1/ 4.6600E-02, 9.5340E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 6, 2)/ 1/
       data (vyield(11, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 6, 3)/ 1/
       data (vyield(11, 6, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 7, 1)/ 2/
       data (vyield(11, 7, 1,i),i=1,10)
     1/ 3.5200E-02, 9.6480E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 7, 2)/ 1/
       data (vyield(11, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 7, 3)/ 1/
       data (vyield(11, 7, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 8, 1)/ 2/
       data (vyield(11, 8, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 8, 2)/ 1/
       data (vyield(11, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 9, 1)/ 1/
       data (vyield(11, 9, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11, 9, 2)/ 1/
       data (vyield(11, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11,10, 1)/ 1/
       data (vyield(11,10, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(11,11, 1)/ 1/
       data (vyield(11,11, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 1, 1)/ 4/
       data (vyield(12, 1, 1,i),i=1,10)
     1/ 1.0000E-04, 5.4400E-02, 8.6450E-01, 8.1000E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 1, 2)/ 2/
       data (vyield(12, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 1, 3)/ 2/
       data (vyield(12, 1, 3,i),i=1,10)
     1/ 3.3000E-03, 9.9669E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 1, 4)/ 1/
       data (vyield(12, 1, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 2, 1)/ 3/
       data (vyield(12, 2, 1,i),i=1,10)
     1/ 3.4100E-02, 6.1000E-01, 3.5590E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 2, 2)/ 2/
       data (vyield(12, 2, 2,i),i=1,10)
     1/ 1.0000E-04, 9.9990E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 2, 3)/ 1/
       data (vyield(12, 2, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 2, 4)/ 1/
       data (vyield(12, 2, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 3, 1)/ 2/
       data (vyield(12, 3, 1,i),i=1,10)
     1/ 3.4600E-02, 9.6540E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 3, 2)/ 1/
       data (vyield(12, 3, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 3, 3)/ 1/
       data (vyield(12, 3, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 4, 1)/ 2/
       data (vyield(12, 4, 1,i),i=1,10)
     1/ 3.8600E-02, 9.6140E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 4, 2)/ 1/
       data (vyield(12, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 4, 3)/ 1/
       data (vyield(12, 4, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 5, 1)/ 2/
       data (vyield(12, 5, 1,i),i=1,10)
     1/ 4.3600E-02, 9.5640E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 5, 2)/ 1/
       data (vyield(12, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 5, 3)/ 1/
       data (vyield(12, 5, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 6, 1)/ 2/
       data (vyield(12, 6, 1,i),i=1,10)
     1/ 4.9700E-02, 9.5030E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 6, 2)/ 1/
       data (vyield(12, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 6, 3)/ 1/
       data (vyield(12, 6, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 7, 1)/ 2/
       data (vyield(12, 7, 1,i),i=1,10)
     1/ 5.6900E-02, 9.4310E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 7, 2)/ 1/
       data (vyield(12, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 7, 3)/ 1/
       data (vyield(12, 7, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 8, 1)/ 2/
       data (vyield(12, 8, 1,i),i=1,10)
     1/ 4.2400E-02, 9.5760E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 8, 2)/ 1/
       data (vyield(12, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 8, 3)/ 1/
       data (vyield(12, 8, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 9, 1)/ 2/
       data (vyield(12, 9, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12, 9, 2)/ 1/
       data (vyield(12, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12,10, 1)/ 1/
       data (vyield(12,10, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12,10, 2)/ 1/
       data (vyield(12,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12,11, 1)/ 1/
       data (vyield(12,11, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(12,12, 1)/ 1/
       data (vyield(12,12, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 1, 1)/ 4/
       data (vyield(13, 1, 1,i),i=1,10)
     1/ 5.0000E-04, 3.9100E-02, 6.2720E-01, 3.3320E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 1, 2)/ 3/
       data (vyield(13, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 2.7200E-02, 9.7280E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 1, 3)/ 2/
       data (vyield(13, 1, 3,i),i=1,10)
     1/ 3.1000E-03, 9.9689E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 1, 4)/ 1/
       data (vyield(13, 1, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 1, 5)/ 1/
       data (vyield(13, 1, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 2, 1)/ 3/
       data (vyield(13, 2, 1,i),i=1,10)
     1/ 2.0000E-04, 6.4300E-02, 9.3550E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 2, 2)/ 2/
       data (vyield(13, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 2, 3)/ 2/
       data (vyield(13, 2, 3,i),i=1,10)
     1/ 6.4000E-03, 9.9359E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 2, 4)/ 1/
       data (vyield(13, 2, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 3, 1)/ 2/
       data (vyield(13, 3, 1,i),i=1,10)
     1/ 3.8900E-02, 9.6110E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 3, 2)/ 2/
       data (vyield(13, 3, 2,i),i=1,10)
     1/ 2.0000E-04, 9.9980E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 3, 3)/ 1/
       data (vyield(13, 3, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 3, 4)/ 1/
       data (vyield(13, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 4, 1)/ 2/
       data (vyield(13, 4, 1,i),i=1,10)
     1/ 3.9700E-02, 9.6030E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 4, 2)/ 1/
       data (vyield(13, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 4, 3)/ 1/
       data (vyield(13, 4, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 5, 1)/ 2/
       data (vyield(13, 5, 1,i),i=1,10)
     1/ 4.4200E-02, 9.5580E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 5, 2)/ 1/
       data (vyield(13, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 5, 3)/ 1/
       data (vyield(13, 5, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 6, 1)/ 2/
       data (vyield(13, 6, 1,i),i=1,10)
     1/ 4.9900E-02, 9.5010E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 6, 2)/ 1/
       data (vyield(13, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 6, 3)/ 1/
       data (vyield(13, 6, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 7, 1)/ 2/
       data (vyield(13, 7, 1,i),i=1,10)
     1/ 5.6800E-02, 9.4320E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 7, 2)/ 1/
       data (vyield(13, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 7, 3)/ 1/
       data (vyield(13, 7, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 8, 1)/ 2/
       data (vyield(13, 8, 1,i),i=1,10)
     1/ 6.5000E-02, 9.3500E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 8, 2)/ 1/
       data (vyield(13, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 8, 3)/ 1/
       data (vyield(13, 8, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 9, 1)/ 2/
       data (vyield(13, 9, 1,i),i=1,10)
     1/ 4.8400E-02, 9.5160E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 9, 2)/ 1/
       data (vyield(13, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13, 9, 3)/ 1/
       data (vyield(13, 9, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13,10, 1)/ 2/
       data (vyield(13,10, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13,10, 2)/ 1/
       data (vyield(13,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13,11, 1)/ 1/
       data (vyield(13,11, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13,11, 2)/ 1/
       data (vyield(13,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13,12, 1)/ 1/
       data (vyield(13,12, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(13,13, 1)/ 1/
       data (vyield(13,13, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 1, 1)/ 5/
       data (vyield(14, 1, 1,i),i=1,10)
     1/ 1.2000E-03, 4.3800E-02, 5.4800E-02, 8.6430E-01, 3.5900E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 1, 2)/ 3/
       data (vyield(14, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 3.0400E-02, 9.6960E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 1, 3)/ 2/
       data (vyield(14, 1, 3,i),i=1,10)
     1/ 2.6666E-03, 9.9733E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 1, 4)/ 1/
       data (vyield(14, 1, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 1, 5)/ 1/
       data (vyield(14, 1, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 2, 1)/ 4/
       data (vyield(14, 2, 1,i),i=1,10)
     1/ 7.0000E-04, 4.4200E-02, 6.4600E-01, 3.0910E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 2, 2)/ 3/
       data (vyield(14, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 3.3300E-02, 9.6670E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 2, 3)/ 2/
       data (vyield(14, 2, 3,i),i=1,10)
     1/ 4.1666E-03, 9.9583E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 2, 4)/ 1/
       data (vyield(14, 2, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 2, 5)/ 1/
       data (vyield(14, 2, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 3, 1)/ 3/
       data (vyield(14, 3, 1,i),i=1,10)
     1/ 3.0000E-04, 7.7500E-02, 9.2220E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 3, 2)/ 2/
       data (vyield(14, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 3, 3)/ 2/
       data (vyield(14, 3, 3,i),i=1,10)
     1/ 8.0999E-03, 9.9189E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 3, 4)/ 1/
       data (vyield(14, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 4, 1)/ 2/
       data (vyield(14, 4, 1,i),i=1,10)
     1/ 4.4200E-02, 9.5580E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 4, 2)/ 1/
       data (vyield(14, 4, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 4, 3)/ 1/
       data (vyield(14, 4, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 4, 4)/ 1/
       data (vyield(14, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 5, 1)/ 2/
       data (vyield(14, 5, 1,i),i=1,10)
     1/ 4.4900E-02, 9.5510E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 5, 2)/ 1/
       data (vyield(14, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 5, 3)/ 1/
       data (vyield(14, 5, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 6, 1)/ 2/
       data (vyield(14, 6, 1,i),i=1,10)
     1/ 5.0700E-02, 9.4930E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 6, 2)/ 1/
       data (vyield(14, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 6, 3)/ 1/
       data (vyield(14, 6, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 7, 1)/ 2/
       data (vyield(14, 7, 1,i),i=1,10)
     1/ 5.8600E-02, 9.4140E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 7, 2)/ 1/
       data (vyield(14, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 7, 3)/ 1/
       data (vyield(14, 7, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 8, 1)/ 2/
       data (vyield(14, 8, 1,i),i=1,10)
     1/ 6.9900E-02, 9.3010E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 8, 2)/ 1/
       data (vyield(14, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 8, 3)/ 1/
       data (vyield(14, 8, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 9, 1)/ 2/
       data (vyield(14, 9, 1,i),i=1,10)
     1/ 8.9000E-02, 9.1100E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 9, 2)/ 1/
       data (vyield(14, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14, 9, 3)/ 1/
       data (vyield(14, 9, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,10, 1)/ 2/
       data (vyield(14,10, 1,i),i=1,10)
     1/ 7.6800E-02, 9.2320E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,10, 2)/ 1/
       data (vyield(14,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,10, 3)/ 1/
       data (vyield(14,10, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,11, 1)/ 2/
       data (vyield(14,11, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,11, 2)/ 1/
       data (vyield(14,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,12, 1)/ 1/
       data (vyield(14,12, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,12, 2)/ 1/
       data (vyield(14,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,13, 1)/ 1/
       data (vyield(14,13, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(14,14, 1)/ 1/
       data (vyield(14,14, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 1, 1)/ 5/
       data (vyield(15, 1, 1,i),i=1,10)
     1/ 2.3000E-03, 6.0300E-02, 6.9200E-02, 6.0220E-01, 2.6600E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 1, 2)/ 3/
       data (vyield(15, 1, 2,i),i=1,10)
     1/ 1.0000E-04, 3.0700E-02, 9.6920E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 1, 3)/ 2/
       data (vyield(15, 1, 3,i),i=1,10)
     1/ 5.9999E-04, 9.9939E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 1, 4)/ 1/
       data (vyield(15, 1, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 1, 5)/ 1/
       data (vyield(15, 1, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 2, 1)/ 5/
       data (vyield(15, 2, 1,i),i=1,10)
     1/ 1.8000E-03, 6.0500E-02, 6.4300E-02, 8.3950E-01, 3.3900E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 2, 2)/ 3/
       data (vyield(15, 2, 2,i),i=1,10)
     1/ 1.0000E-04, 3.1100E-02, 9.6880E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 2, 3)/ 2/
       data (vyield(15, 2, 3,i),i=1,10)
     1/ 3.8333E-03, 9.9616E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 2, 4)/ 1/
       data (vyield(15, 2, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 2, 5)/ 1/
       data (vyield(15, 2, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 3, 1)/ 4/
       data (vyield(15, 3, 1,i),i=1,10)
     1/ 1.2000E-03, 6.1400E-02, 6.9600E-01, 2.4140E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 3, 2)/ 3/
       data (vyield(15, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 3.9600E-02, 9.6040E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 3, 3)/ 2/
       data (vyield(15, 3, 3,i),i=1,10)
     1/ 5.8333E-03, 9.9416E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 3, 4)/ 1/
       data (vyield(15, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 3, 5)/ 1/
       data (vyield(15, 3, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 4, 1)/ 3/
       data (vyield(15, 4, 1,i),i=1,10)
     1/ 7.0000E-04, 1.0190E-01, 8.9740E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 4, 2)/ 2/
       data (vyield(15, 4, 2,i),i=1,10)
     1/ 1.0000E-04, 9.9990E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 4, 3)/ 2/
       data (vyield(15, 4, 3,i),i=1,10)
     1/ 1.0800E-02, 9.8919E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 4, 4)/ 1/
       data (vyield(15, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 5, 1)/ 2/
       data (vyield(15, 5, 1,i),i=1,10)
     1/ 6.2300E-02, 9.3770E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 5, 2)/ 1/
       data (vyield(15, 5, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 5, 3)/ 1/
       data (vyield(15, 5, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 5, 4)/ 1/
       data (vyield(15, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 6, 1)/ 2/
       data (vyield(15, 6, 1,i),i=1,10)
     1/ 6.3400E-02, 9.3660E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 6, 2)/ 1/
       data (vyield(15, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 6, 3)/ 1/
       data (vyield(15, 6, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 7, 1)/ 2/
       data (vyield(15, 7, 1,i),i=1,10)
     1/ 7.1900E-02, 9.2810E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 7, 2)/ 1/
       data (vyield(15, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 7, 3)/ 1/
       data (vyield(15, 7, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 8, 1)/ 2/
       data (vyield(15, 8, 1,i),i=1,10)
     1/ 8.3300E-02, 9.1670E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 8, 2)/ 1/
       data (vyield(15, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 8, 3)/ 1/
       data (vyield(15, 8, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 9, 1)/ 2/
       data (vyield(15, 9, 1,i),i=1,10)
     1/ 9.9800E-02, 9.0020E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 9, 2)/ 1/
       data (vyield(15, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15, 9, 3)/ 1/
       data (vyield(15, 9, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,10, 1)/ 2/
       data (vyield(15,10, 1,i),i=1,10)
     1/ 1.2790E-01, 8.7210E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,10, 2)/ 1/
       data (vyield(15,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,10, 3)/ 1/
       data (vyield(15,10, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,11, 1)/ 2/
       data (vyield(15,11, 1,i),i=1,10)
     1/ 1.1020E-01, 8.8980E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,11, 2)/ 1/
       data (vyield(15,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,11, 3)/ 1/
       data (vyield(15,11, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,12, 1)/ 2/
       data (vyield(15,12, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,12, 2)/ 1/
       data (vyield(15,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,13, 1)/ 1/
       data (vyield(15,13, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,13, 2)/ 1/
       data (vyield(15,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,14, 1)/ 1/
       data (vyield(15,14, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(15,15, 1)/ 1/
       data (vyield(15,15, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 1, 1)/ 6/
       data (vyield(16, 1, 1,i),i=1,10)
     1/ 4.6000E-03, 8.1200E-02, 8.3100E-02, 5.6000E-01, 2.3850E-01,
     2  3.2600E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 1, 2)/ 3/
       data (vyield(16, 1, 2,i),i=1,10)
     1/ 1.0000E-04, 3.3600E-02, 9.6630E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 1, 3)/ 2/
       data (vyield(16, 1, 3,i),i=1,10)
     1/ 4.3333E-04, 9.9956E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 1, 4)/ 1/
       data (vyield(16, 1, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 1, 5)/ 1/
       data (vyield(16, 1, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 2, 1)/ 5/
       data (vyield(16, 2, 1,i),i=1,10)
     1/ 3.6000E-03, 8.1600E-02, 7.1900E-02, 5.6970E-01, 2.7320E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 2, 2)/ 3/
       data (vyield(16, 2, 2,i),i=1,10)
     1/ 1.0000E-04, 3.1600E-02, 9.6830E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 2, 3)/ 2/
       data (vyield(16, 2, 3,i),i=1,10)
     1/ 8.3333E-04, 9.9916E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 2, 4)/ 1/
       data (vyield(16, 2, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 2, 5)/ 1/
       data (vyield(16, 2, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 3, 1)/ 4/
       data (vyield(16, 3, 1,i),i=1,10)
     1/ 2.8000E-03, 8.2400E-02, 7.0800E-02, 8.4400E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 3, 2)/ 3/
       data (vyield(16, 3, 2,i),i=1,10)
     1/ 1.0000E-04, 3.3900E-02, 9.6600E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 3, 3)/ 2/
       data (vyield(16, 3, 3,i),i=1,10)
     1/ 5.1000E-03, 9.9489E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 3, 4)/ 1/
       data (vyield(16, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 3, 5)/ 1/
       data (vyield(16, 3, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 4, 1)/ 3/
       data (vyield(16, 4, 1,i),i=1,10)
     1/ 1.9000E-03, 8.4000E-02, 9.1410E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 4, 2)/ 3/
       data (vyield(16, 4, 2,i),i=1,10)
     1/ 3.0000E-04, 1.4650E-01, 8.5320E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 4, 3)/ 2/
       data (vyield(16, 4, 3,i),i=1,10)
     1/ 7.6333E-03, 9.9236E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 4, 4)/ 1/
       data (vyield(16, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 4, 5)/ 1/
       data (vyield(16, 4, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 5, 1)/ 3/
       data (vyield(16, 5, 1,i),i=1,10)
     1/ 1.2000E-03, 1.2710E-01, 8.7170E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 5, 2)/ 2/
       data (vyield(16, 5, 2,i),i=1,10)
     1/ 1.0000E-04, 9.9990E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 5, 3)/ 2/
       data (vyield(16, 5, 3,i),i=1,10)
     1/ 1.3800E-02, 9.8619E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 5, 4)/ 1/
       data (vyield(16, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 6, 1)/ 2/
       data (vyield(16, 6, 1,i),i=1,10)
     1/ 8.5900E-02, 9.1410E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 6, 2)/ 1/
       data (vyield(16, 6, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 6, 3)/ 1/
       data (vyield(16, 6, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 6, 4)/ 1/
       data (vyield(16, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 7, 1)/ 2/
       data (vyield(16, 7, 1,i),i=1,10)
     1/ 8.7500E-02, 9.1250E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 7, 2)/ 1/
       data (vyield(16, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 7, 3)/ 1/
       data (vyield(16, 7, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 8, 1)/ 2/
       data (vyield(16, 8, 1,i),i=1,10)
     1/ 9.8400E-02, 9.0160E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 8, 2)/ 1/
       data (vyield(16, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 8, 3)/ 1/
       data (vyield(16, 8, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 9, 1)/ 2/
       data (vyield(16, 9, 1,i),i=1,10)
     1/ 1.1270E-01, 8.8730E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 9, 2)/ 1/
       data (vyield(16, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16, 9, 3)/ 1/
       data (vyield(16, 9, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,10, 1)/ 2/
       data (vyield(16,10, 1,i),i=1,10)
     1/ 1.3300E-01, 8.6700E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,10, 2)/ 1/
       data (vyield(16,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,10, 3)/ 1/
       data (vyield(16,10, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,11, 1)/ 2/
       data (vyield(16,11, 1,i),i=1,10)
     1/ 1.6610E-01, 8.3390E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,11, 2)/ 1/
       data (vyield(16,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,11, 3)/ 1/
       data (vyield(16,11, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,12, 1)/ 2/
       data (vyield(16,12, 1,i),i=1,10)
     1/ 1.4460E-01, 8.5540E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,12, 2)/ 1/
       data (vyield(16,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,12, 3)/ 1/
       data (vyield(16,12, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,13, 1)/ 2/
       data (vyield(16,13, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,13, 2)/ 1/
       data (vyield(16,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,14, 1)/ 1/
       data (vyield(16,14, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,14, 2)/ 1/
       data (vyield(16,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,15, 1)/ 1/
       data (vyield(16,15, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(16,16, 1)/ 1/
       data (vyield(16,16, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 1, 1)/ 6/
       data (vyield(17, 1, 1,i),i=1,10)
     1/ 6.9000E-03, 9.3000E-02, 9.4400E-02, 5.5690E-01, 2.1400E-01,
     2  3.4800E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 1, 2)/ 3/
       data (vyield(17, 1, 2,i),i=1,10)
     1/ 3.0000E-04, 3.7500E-02, 9.6220E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 1, 3)/ 2/
       data (vyield(17, 1, 3,i),i=1,10)
     1/ 3.6666E-04, 9.9963E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 1, 4)/ 1/
       data (vyield(17, 1, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 1, 5)/ 1/
       data (vyield(17, 1, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 2, 1)/ 6/
       data (vyield(17, 2, 1,i),i=1,10)
     1/ 5.7000E-03, 9.3600E-02, 8.2100E-02, 5.6510E-01, 2.2000E-01,
     2  3.3500E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 2, 2)/ 3/
       data (vyield(17, 2, 2,i),i=1,10)
     1/ 2.0000E-04, 3.5400E-02, 9.6440E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 2, 3)/ 2/
       data (vyield(17, 2, 3,i),i=1,10)
     1/ 5.6666E-04, 9.9943E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 2, 4)/ 1/
       data (vyield(17, 2, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 2, 5)/ 1/
       data (vyield(17, 2, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 3, 1)/ 5/
       data (vyield(17, 3, 1,i),i=1,10)
     1/ 4.4000E-03, 9.4600E-02, 7.3200E-02, 5.9120E-01, 2.3660E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 3, 2)/ 3/
       data (vyield(17, 3, 2,i),i=1,10)
     1/ 2.0000E-04, 3.3700E-02, 9.6610E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 3, 3)/ 2/
       data (vyield(17, 3, 3,i),i=1,10)
     1/ 1.2333E-03, 9.9876E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 3, 4)/ 1/
       data (vyield(17, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 3, 5)/ 1/
       data (vyield(17, 3, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 4, 1)/ 4/
       data (vyield(17, 4, 1,i),i=1,10)
     1/ 3.6000E-03, 9.5900E-02, 1.0130E-01, 7.9920E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 4, 2)/ 3/
       data (vyield(17, 4, 2,i),i=1,10)
     1/ 6.0000E-04, 1.1480E-01, 8.8460E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 4, 3)/ 2/
       data (vyield(17, 4, 3,i),i=1,10)
     1/ 7.1999E-03, 9.9279E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 4, 4)/ 1/
       data (vyield(17, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 4, 5)/ 1/
       data (vyield(17, 4, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 5, 1)/ 3/
       data (vyield(17, 5, 1,i),i=1,10)
     1/ 2.5000E-03, 9.7900E-02, 8.9960E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 5, 2)/ 2/
       data (vyield(17, 5, 2,i),i=1,10)
     1/ 4.2000E-03, 9.9580E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 5, 3)/ 2/
       data (vyield(17, 5, 3,i),i=1,10)
     1/ 1.0833E-02, 9.8916E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 5, 4)/ 1/
       data (vyield(17, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 5, 5)/ 1/
       data (vyield(17, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 6, 1)/ 3/
       data (vyield(17, 6, 1,i),i=1,10)
     1/ 1.9000E-03, 1.4170E-01, 8.5640E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 6, 2)/ 2/
       data (vyield(17, 6, 2,i),i=1,10)
     1/ 2.0000E-04, 9.9980E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 6, 3)/ 2/
       data (vyield(17, 6, 3,i),i=1,10)
     1/ 1.9600E-02, 9.8039E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 6, 4)/ 1/
       data (vyield(17, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 7, 1)/ 2/
       data (vyield(17, 7, 1,i),i=1,10)
     1/ 1.0020E-01, 8.9980E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 7, 2)/ 1/
       data (vyield(17, 7, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 7, 3)/ 1/
       data (vyield(17, 7, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 7, 4)/ 1/
       data (vyield(17, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 8, 1)/ 2/
       data (vyield(17, 8, 1,i),i=1,10)
     1/ 1.0190E-01, 8.9810E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 8, 2)/ 1/
       data (vyield(17, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 8, 3)/ 1/
       data (vyield(17, 8, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 9, 1)/ 2/
       data (vyield(17, 9, 1,i),i=1,10)
     1/ 1.1470E-01, 8.8530E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 9, 2)/ 1/
       data (vyield(17, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17, 9, 3)/ 1/
       data (vyield(17, 9, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,10, 1)/ 2/
       data (vyield(17,10, 1,i),i=1,10)
     1/ 1.3150E-01, 8.6850E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,10, 2)/ 1/
       data (vyield(17,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,10, 3)/ 1/
       data (vyield(17,10, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,11, 1)/ 2/
       data (vyield(17,11, 1,i),i=1,10)
     1/ 1.5500E-01, 8.4500E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,11, 2)/ 1/
       data (vyield(17,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,11, 3)/ 1/
       data (vyield(17,11, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,12, 1)/ 2/
       data (vyield(17,12, 1,i),i=1,10)
     1/ 1.9260E-01, 8.0740E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,12, 2)/ 1/
       data (vyield(17,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,12, 3)/ 1/
       data (vyield(17,12, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,13, 1)/ 2/
       data (vyield(17,13, 1,i),i=1,10)
     1/ 1.6560E-01, 8.3440E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,13, 2)/ 1/
       data (vyield(17,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,13, 3)/ 1/
       data (vyield(17,13, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,14, 1)/ 2/
       data (vyield(17,14, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,14, 2)/ 1/
       data (vyield(17,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,15, 1)/ 1/
       data (vyield(17,15, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,15, 2)/ 1/
       data (vyield(17,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,16, 1)/ 1/
       data (vyield(17,16, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(17,17, 1)/ 1/
       data (vyield(17,17, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 1, 1)/ 6/
       data (vyield(18, 1, 1,i),i=1,10)
     1/ 1.0200E-02, 1.1720E-01, 1.0010E-01, 5.1720E-01, 2.0090E-01,
     2  5.4400E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 1, 2)/ 3/
       data (vyield(18, 1, 2,i),i=1,10)
     1/ 5.0000E-04, 3.6100E-02, 9.6340E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 1, 3)/ 2/
       data (vyield(18, 1, 3,i),i=1,10)
     1/ 3.0000E-04, 9.9969E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 1, 4)/ 1/
       data (vyield(18, 1, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 1, 5)/ 1/
       data (vyield(18, 1, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 2, 1)/ 6/
       data (vyield(18, 2, 1,i),i=1,10)
     1/ 8.7000E-03, 1.1810E-01, 8.8500E-02, 5.2430E-01, 2.0720E-01,
     2  5.3200E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 2, 2)/ 3/
       data (vyield(18, 2, 2,i),i=1,10)
     1/ 4.0000E-04, 3.4800E-02, 9.6480E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 2, 3)/ 2/
       data (vyield(18, 2, 3,i),i=1,10)
     1/ 4.6666E-04, 9.9953E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 2, 4)/ 1/
       data (vyield(18, 2, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 2, 5)/ 1/
       data (vyield(18, 2, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 3, 1)/ 5/
       data (vyield(18, 3, 1,i),i=1,10)
     1/ 7.2000E-03, 1.1930E-01, 7.7700E-02, 5.4230E-01, 2.5350E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 3, 2)/ 3/
       data (vyield(18, 3, 2,i),i=1,10)
     1/ 4.0000E-04, 3.3400E-02, 9.6620E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 3, 3)/ 2/
       data (vyield(18, 3, 3,i),i=1,10)
     1/ 6.6666E-04, 9.9933E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 3, 4)/ 1/
       data (vyield(18, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 3, 5)/ 1/
       data (vyield(18, 3, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 4, 1)/ 4/
       data (vyield(18, 4, 1,i),i=1,10)
     1/ 5.6000E-03, 1.2110E-01, 1.0050E-01, 7.7280E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 4, 2)/ 3/
       data (vyield(18, 4, 2,i),i=1,10)
     1/ 4.0000E-04, 4.1300E-02, 9.5830E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 4, 3)/ 2/
       data (vyield(18, 4, 3,i),i=1,10)
     1/ 1.5333E-03, 9.9846E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 4, 4)/ 1/
       data (vyield(18, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 4, 5)/ 1/
       data (vyield(18, 4, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 5, 1)/ 4/
       data (vyield(18, 5, 1,i),i=1,10)
     1/ 4.7000E-03, 1.2250E-01, 1.0920E-01, 7.6360E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 5, 2)/ 2/
       data (vyield(18, 5, 2,i),i=1,10)
     1/ 1.0200E-02, 9.8980E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 5, 3)/ 2/
       data (vyield(18, 5, 3,i),i=1,10)
     1/ 8.5999E-03, 9.9139E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 5, 4)/ 1/
       data (vyield(18, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 5, 5)/ 1/
       data (vyield(18, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 6, 1)/ 3/
       data (vyield(18, 6, 1,i),i=1,10)
     1/ 3.5000E-03, 1.2490E-01, 8.7160E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 6, 2)/ 2/
       data (vyield(18, 6, 2,i),i=1,10)
     1/ 7.7000E-03, 9.9230E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 6, 3)/ 2/
       data (vyield(18, 6, 3,i),i=1,10)
     1/ 1.2800E-02, 9.8719E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 6, 4)/ 1/
       data (vyield(18, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 6, 5)/ 1/
       data (vyield(18, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 7, 1)/ 3/
       data (vyield(18, 7, 1,i),i=1,10)
     1/ 2.9000E-03, 1.6890E-01, 8.2820E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 7, 2)/ 2/
       data (vyield(18, 7, 2,i),i=1,10)
     1/ 2.0000E-04, 9.9980E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 7, 3)/ 2/
       data (vyield(18, 7, 3,i),i=1,10)
     1/ 2.3000E-02, 9.7699E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 7, 4)/ 1/
       data (vyield(18, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 8, 1)/ 2/
       data (vyield(18, 8, 1,i),i=1,10)
     1/ 1.2840E-01, 8.7160E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 8, 2)/ 1/
       data (vyield(18, 8, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 8, 3)/ 1/
       data (vyield(18, 8, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 8, 4)/ 1/
       data (vyield(18, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 9, 1)/ 2/
       data (vyield(18, 9, 1,i),i=1,10)
     1/ 1.3050E-01, 8.6950E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 9, 2)/ 1/
       data (vyield(18, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18, 9, 3)/ 1/
       data (vyield(18, 9, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,10, 1)/ 2/
       data (vyield(18,10, 1,i),i=1,10)
     1/ 1.4470E-01, 8.5530E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,10, 2)/ 1/
       data (vyield(18,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,10, 3)/ 1/
       data (vyield(18,10, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,11, 1)/ 2/
       data (vyield(18,11, 1,i),i=1,10)
     1/ 1.6230E-01, 8.3770E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,11, 2)/ 1/
       data (vyield(18,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,11, 3)/ 1/
       data (vyield(18,11, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,12, 1)/ 2/
       data (vyield(18,12, 1,i),i=1,10)
     1/ 1.8430E-01, 8.1570E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,12, 2)/ 1/
       data (vyield(18,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,12, 3)/ 1/
       data (vyield(18,12, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,13, 1)/ 2/
       data (vyield(18,13, 1,i),i=1,10)
     1/ 2.1160E-01, 7.8840E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,13, 2)/ 1/
       data (vyield(18,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,13, 3)/ 1/
       data (vyield(18,13, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,14, 1)/ 2/
       data (vyield(18,14, 1,i),i=1,10)
     1/ 1.6710E-01, 8.3290E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,14, 2)/ 1/
       data (vyield(18,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,14, 3)/ 1/
       data (vyield(18,14, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,15, 1)/ 2/
       data (vyield(18,15, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,15, 2)/ 1/
       data (vyield(18,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,16, 1)/ 1/
       data (vyield(18,16, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,16, 2)/ 1/
       data (vyield(18,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,17, 1)/ 1/
       data (vyield(18,17, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(18,18, 1)/ 1/
       data (vyield(18,18, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 1, 1)/ 7/
       data (vyield(19, 1, 1,i),i=1,10)
     1/ 1.1000E-02, 8.6100E-02, 9.6900E-02, 3.0830E-01, 3.0050E-01,
     2  1.4960E-01, 4.7600E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 1, 2)/ 4/
       data (vyield(19, 1, 2,i),i=1,10)
     1/ 7.0000E-04, 2.6000E-03, 4.3640E-01, 5.6030E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 1, 3)/ 3/
       data (vyield(19, 1, 3,i),i=1,10)
     1/ 0.0000E+00, 7.8229E-01, 2.1770E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 1, 4)/ 2/
       data (vyield(19, 1, 4,i),i=1,10)
     1/ 1.0000E-04, 9.9990E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 1, 5)/ 1/
       data (vyield(19, 1, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 1, 6)/ 1/
       data (vyield(19, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 1, 7)/ 1/
       data (vyield(19, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 2, 1)/ 6/
       data (vyield(19, 2, 1,i),i=1,10)
     1/ 1.1100E-02, 1.1200E-01, 1.1700E-01, 5.1820E-01, 1.9300E-01,
     2  4.8700E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 2, 2)/ 3/
       data (vyield(19, 2, 2,i),i=1,10)
     1/ 7.0000E-04, 3.8300E-02, 9.6100E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 2, 3)/ 2/
       data (vyield(19, 2, 3,i),i=1,10)
     1/ 4.0000E-04, 9.9959E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 2, 4)/ 1/
       data (vyield(19, 2, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 2, 5)/ 1/
       data (vyield(19, 2, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 3, 1)/ 5/
       data (vyield(19, 3, 1,i),i=1,10)
     1/ 9.5000E-03, 1.1260E-01, 1.0550E-01, 5.4500E-01, 2.2740E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 3, 2)/ 3/
       data (vyield(19, 3, 2,i),i=1,10)
     1/ 6.0000E-04, 3.6800E-02, 9.6260E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 3, 3)/ 2/
       data (vyield(19, 3, 3,i),i=1,10)
     1/ 5.6666E-04, 9.9943E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 3, 4)/ 1/
       data (vyield(19, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 3, 5)/ 1/
       data (vyield(19, 3, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 4, 1)/ 4/
       data (vyield(19, 4, 1,i),i=1,10)
     1/ 7.8000E-03, 1.1430E-01, 1.3060E-01, 7.4730E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 4, 2)/ 3/
       data (vyield(19, 4, 2,i),i=1,10)
     1/ 1.2000E-03, 7.4500E-02, 9.2430E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 4, 3)/ 2/
       data (vyield(19, 4, 3,i),i=1,10)
     1/ 9.3333E-04, 9.9906E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 4, 4)/ 1/
       data (vyield(19, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 4, 5)/ 1/
       data (vyield(19, 4, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 5, 1)/ 4/
       data (vyield(19, 5, 1,i),i=1,10)
     1/ 6.1000E-03, 1.1570E-01, 1.2220E-01, 7.5600E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 5, 2)/ 2/
       data (vyield(19, 5, 2,i),i=1,10)
     1/ 1.5600E-02, 9.8440E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 5, 3)/ 2/
       data (vyield(19, 5, 3,i),i=1,10)
     1/ 2.0666E-03, 9.9793E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 5, 4)/ 1/
       data (vyield(19, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 5, 5)/ 1/
       data (vyield(19, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 6, 1)/ 4/
       data (vyield(19, 6, 1,i),i=1,10)
     1/ 5.4000E-03, 1.1710E-01, 1.3420E-01, 7.4330E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 6, 2)/ 2/
       data (vyield(19, 6, 2,i),i=1,10)
     1/ 1.3800E-02, 9.8620E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 6, 3)/ 2/
       data (vyield(19, 6, 3,i),i=1,10)
     1/ 1.1900E-02, 9.8809E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 6, 4)/ 1/
       data (vyield(19, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 6, 5)/ 1/
       data (vyield(19, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 7, 1)/ 3/
       data (vyield(19, 7, 1,i),i=1,10)
     1/ 4.2000E-03, 1.1990E-01, 8.7590E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 7, 2)/ 2/
       data (vyield(19, 7, 2,i),i=1,10)
     1/ 1.0600E-02, 9.8940E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 7, 3)/ 2/
       data (vyield(19, 7, 3,i),i=1,10)
     1/ 1.7900E-02, 9.8209E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 7, 4)/ 1/
       data (vyield(19, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 7, 5)/ 1/
       data (vyield(19, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 8, 1)/ 3/
       data (vyield(19, 8, 1,i),i=1,10)
     1/ 4.0000E-03, 1.7540E-01, 8.2060E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 8, 2)/ 2/
       data (vyield(19, 8, 2,i),i=1,10)
     1/ 4.0000E-04, 9.9960E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 8, 3)/ 2/
       data (vyield(19, 8, 3,i),i=1,10)
     1/ 3.2800E-02, 9.6719E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 8, 4)/ 1/
       data (vyield(19, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 9, 1)/ 2/
       data (vyield(19, 9, 1,i),i=1,10)
     1/ 1.2280E-01, 8.7720E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 9, 2)/ 1/
       data (vyield(19, 9, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 9, 3)/ 1/
       data (vyield(19, 9, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19, 9, 4)/ 1/
       data (vyield(19, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,10, 1)/ 2/
       data (vyield(19,10, 1,i),i=1,10)
     1/ 1.2530E-01, 8.7470E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,10, 2)/ 1/
       data (vyield(19,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,10, 3)/ 1/
       data (vyield(19,10, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,11, 1)/ 2/
       data (vyield(19,11, 1,i),i=1,10)
     1/ 1.3930E-01, 8.6070E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,11, 2)/ 1/
       data (vyield(19,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,11, 3)/ 1/
       data (vyield(19,11, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,12, 1)/ 2/
       data (vyield(19,12, 1,i),i=1,10)
     1/ 1.5680E-01, 8.4320E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,12, 2)/ 1/
       data (vyield(19,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,12, 3)/ 1/
       data (vyield(19,12, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,13, 1)/ 2/
       data (vyield(19,13, 1,i),i=1,10)
     1/ 1.7870E-01, 8.2130E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,13, 2)/ 1/
       data (vyield(19,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,13, 3)/ 1/
       data (vyield(19,13, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,14, 1)/ 2/
       data (vyield(19,14, 1,i),i=1,10)
     1/ 2.0640E-01, 7.9360E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,14, 2)/ 1/
       data (vyield(19,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,14, 3)/ 1/
       data (vyield(19,14, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,15, 1)/ 2/
       data (vyield(19,15, 1,i),i=1,10)
     1/ 1.6260E-01, 8.3740E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,15, 2)/ 1/
       data (vyield(19,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,15, 3)/ 1/
       data (vyield(19,15, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,16, 1)/ 2/
       data (vyield(19,16, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,16, 2)/ 1/
       data (vyield(19,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,17, 1)/ 1/
       data (vyield(19,17, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,17, 2)/ 1/
       data (vyield(19,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,18, 1)/ 1/
       data (vyield(19,18, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(19,19, 1)/ 1/
       data (vyield(19,19, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 1, 1)/ 8/
       data (vyield(20, 1, 1,i),i=1,10)
     1/ 1.0000E-04, 1.6700E-02, 1.3170E-01, 1.2940E-01, 4.4350E-01,
     2  1.7130E-01, 7.8500E-02, 2.8800E-02, 0.0000E+00, 0.0000E+00/
       data nyield(20, 1, 2)/ 5/
       data (vyield(20, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 4.0000E-03, 5.2300E-02, 8.3180E-01, 1.1190E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 1, 3)/ 4/
       data (vyield(20, 1, 3,i),i=1,10)
     1/ 0.0000E+00, 2.2833E-02, 9.6586E-01, 1.1300E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 1, 4)/ 2/
       data (vyield(20, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 1, 5)/ 2/
       data (vyield(20, 1, 5,i),i=1,10)
     1/ 5.0000E-03, 9.9499E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 1, 6)/ 1/
       data (vyield(20, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 1, 7)/ 1/
       data (vyield(20, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 2, 1)/ 7/
       data (vyield(20, 2, 1,i),i=1,10)
     1/ 1.4000E-02, 1.0110E-01, 1.0300E-01, 2.9660E-01, 3.0050E-01,
     2  1.4550E-01, 3.9300E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 2, 2)/ 4/
       data (vyield(20, 2, 2,i),i=1,10)
     1/ 1.0000E-03, 3.2000E-03, 4.1850E-01, 5.7730E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 2, 3)/ 3/
       data (vyield(20, 2, 3,i),i=1,10)
     1/ 0.0000E+00, 7.7303E-01, 2.2697E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 2, 4)/ 2/
       data (vyield(20, 2, 4,i),i=1,10)
     1/ 1.0000E-04, 9.9990E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 2, 5)/ 1/
       data (vyield(20, 2, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 2, 6)/ 1/
       data (vyield(20, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 2, 7)/ 1/
       data (vyield(20, 2, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 3, 1)/ 6/
       data (vyield(20, 3, 1,i),i=1,10)
     1/ 1.4100E-02, 1.3270E-01, 1.1960E-01, 5.1470E-01, 1.8100E-01,
     2  3.7900E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 3, 2)/ 3/
       data (vyield(20, 3, 2,i),i=1,10)
     1/ 9.0000E-04, 4.5000E-02, 9.5410E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 3, 3)/ 2/
       data (vyield(20, 3, 3,i),i=1,10)
     1/ 5.0000E-04, 9.9949E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 3, 4)/ 1/
       data (vyield(20, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 3, 5)/ 1/
       data (vyield(20, 3, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 4, 1)/ 5/
       data (vyield(20, 4, 1,i),i=1,10)
     1/ 1.2100E-02, 1.3390E-01, 1.0890E-01, 5.5310E-01, 1.9200E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 4, 2)/ 3/
       data (vyield(20, 4, 2,i),i=1,10)
     1/ 1.7000E-03, 8.3500E-02, 9.1480E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 4, 3)/ 2/
       data (vyield(20, 4, 3,i),i=1,10)
     1/ 7.3333E-04, 9.9926E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 4, 4)/ 1/
       data (vyield(20, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 4, 5)/ 1/
       data (vyield(20, 4, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 5, 1)/ 4/
       data (vyield(20, 5, 1,i),i=1,10)
     1/ 1.0000E-02, 1.3620E-01, 1.3270E-01, 7.2110E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 5, 2)/ 3/
       data (vyield(20, 5, 2,i),i=1,10)
     1/ 2.7000E-03, 1.3680E-01, 8.6050E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 5, 3)/ 2/
       data (vyield(20, 5, 3,i),i=1,10)
     1/ 1.2667E-03, 9.9873E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 5, 4)/ 1/
       data (vyield(20, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 5, 5)/ 1/
       data (vyield(20, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 6, 1)/ 4/
       data (vyield(20, 6, 1,i),i=1,10)
     1/ 7.9000E-03, 1.3810E-01, 1.2550E-01, 7.2850E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 6, 2)/ 2/
       data (vyield(20, 6, 2,i),i=1,10)
     1/ 1.8500E-02, 9.8150E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 6, 3)/ 2/
       data (vyield(20, 6, 3,i),i=1,10)
     1/ 2.6666E-03, 9.9733E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 6, 4)/ 1/
       data (vyield(20, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 6, 5)/ 1/
       data (vyield(20, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 7, 1)/ 4/
       data (vyield(20, 7, 1,i),i=1,10)
     1/ 7.3000E-03, 1.3980E-01, 1.4290E-01, 7.1000E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 7, 2)/ 2/
       data (vyield(20, 7, 2,i),i=1,10)
     1/ 1.6400E-02, 9.8360E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 7, 3)/ 2/
       data (vyield(20, 7, 3,i),i=1,10)
     1/ 1.5333E-02, 9.8466E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 7, 4)/ 1/
       data (vyield(20, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 7, 5)/ 1/
       data (vyield(20, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 8, 1)/ 3/
       data (vyield(20, 8, 1,i),i=1,10)
     1/ 5.9000E-03, 1.4330E-01, 8.5080E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 8, 2)/ 2/
       data (vyield(20, 8, 2,i),i=1,10)
     1/ 1.2400E-02, 9.8760E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 8, 3)/ 2/
       data (vyield(20, 8, 3,i),i=1,10)
     1/ 2.3300E-02, 9.7669E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 8, 4)/ 1/
       data (vyield(20, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 8, 5)/ 1/
       data (vyield(20, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 9, 1)/ 3/
       data (vyield(20, 9, 1,i),i=1,10)
     1/ 6.3000E-03, 2.0240E-01, 7.9130E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 9, 2)/ 2/
       data (vyield(20, 9, 2,i),i=1,10)
     1/ 5.0000E-04, 9.9950E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 9, 3)/ 2/
       data (vyield(20, 9, 3,i),i=1,10)
     1/ 4.3300E-02, 9.5669E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20, 9, 4)/ 1/
       data (vyield(20, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,10, 1)/ 2/
       data (vyield(20,10, 1,i),i=1,10)
     1/ 1.4750E-01, 8.5250E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,10, 2)/ 1/
       data (vyield(20,10, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,10, 3)/ 1/
       data (vyield(20,10, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,10, 4)/ 1/
       data (vyield(20,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,11, 1)/ 2/
       data (vyield(20,11, 1,i),i=1,10)
     1/ 1.5050E-01, 8.4950E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,11, 2)/ 1/
       data (vyield(20,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,11, 3)/ 1/
       data (vyield(20,11, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,12, 1)/ 2/
       data (vyield(20,12, 1,i),i=1,10)
     1/ 1.6720E-01, 8.3280E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,12, 2)/ 1/
       data (vyield(20,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,12, 3)/ 1/
       data (vyield(20,12, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,13, 1)/ 2/
       data (vyield(20,13, 1,i),i=1,10)
     1/ 1.8780E-01, 8.1220E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,13, 2)/ 1/
       data (vyield(20,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,13, 3)/ 1/
       data (vyield(20,13, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,14, 1)/ 2/
       data (vyield(20,14, 1,i),i=1,10)
     1/ 2.1400E-01, 7.8600E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,14, 2)/ 1/
       data (vyield(20,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,14, 3)/ 1/
       data (vyield(20,14, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,15, 1)/ 2/
       data (vyield(20,15, 1,i),i=1,10)
     1/ 2.4780E-01, 7.5220E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,15, 2)/ 1/
       data (vyield(20,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,15, 3)/ 1/
       data (vyield(20,15, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,16, 1)/ 2/
       data (vyield(20,16, 1,i),i=1,10)
     1/ 1.9840E-01, 8.0160E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,16, 2)/ 1/
       data (vyield(20,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,16, 3)/ 1/
       data (vyield(20,16, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,17, 1)/ 2/
       data (vyield(20,17, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,17, 2)/ 1/
       data (vyield(20,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,18, 1)/ 1/
       data (vyield(20,18, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,18, 2)/ 1/
       data (vyield(20,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,19, 1)/ 1/
       data (vyield(20,19, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(20,20, 1)/ 1/
       data (vyield(20,20, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 1, 1)/ 8/
       data (vyield(21, 1, 1,i),i=1,10)
     1/ 0.0000E+00, 2.0500E-02, 1.4260E-01, 1.2180E-01, 3.4570E-01,
     2  2.5090E-01, 9.5800E-02, 2.2700E-02, 0.0000E+00, 0.0000E+00/
       data nyield(21, 1, 2)/ 6/
       data (vyield(21, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 1.7000E-03, 1.5500E-02, 5.2630E-01, 4.5270E-01,
     2  3.8000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 1, 3)/ 4/
       data (vyield(21, 1, 3,i),i=1,10)
     1/ 1.6667E-04, 1.0667E-03, 8.0266E-01, 1.9610E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 1, 4)/ 3/
       data (vyield(21, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 3.5800E-02, 9.6420E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 1, 5)/ 2/
       data (vyield(21, 1, 5,i),i=1,10)
     1/ 2.6666E-04, 9.9973E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 1, 6)/ 1/
       data (vyield(21, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 1, 7)/ 1/
       data (vyield(21, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 2, 1)/ 7/
       data (vyield(21, 2, 1,i),i=1,10)
     1/ 0.0000E+00, 3.5000E-02, 1.7480E-01, 1.7540E-01, 4.4930E-01,
     2  1.3640E-01, 2.9100E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 2, 2)/ 4/
       data (vyield(21, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 4.7000E-03, 1.9820E-01, 7.9710E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 2, 3)/ 3/
       data (vyield(21, 2, 3,i),i=1,10)
     1/ 1.3333E-04, 8.4866E-02, 9.1499E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 2, 4)/ 2/
       data (vyield(21, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 2, 5)/ 2/
       data (vyield(21, 2, 5,i),i=1,10)
     1/ 4.6666E-04, 9.9953E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 2, 6)/ 1/
       data (vyield(21, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 2, 7)/ 1/
       data (vyield(21, 2, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 3, 1)/ 6/
       data (vyield(21, 3, 1,i),i=1,10)
     1/ 2.0500E-02, 1.7900E-01, 1.2250E-01, 4.9910E-01, 1.5870E-01,
     2  2.0200E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 3, 2)/ 3/
       data (vyield(21, 3, 2,i),i=1,10)
     1/ 1.3000E-03, 5.1000E-02, 9.4770E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 3, 3)/ 2/
       data (vyield(21, 3, 3,i),i=1,10)
     1/ 7.3333E-04, 9.9926E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 3, 4)/ 1/
       data (vyield(21, 3, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 3, 5)/ 1/
       data (vyield(21, 3, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 3, 6)/ 1/
       data (vyield(21, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 4, 1)/ 4/
       data (vyield(21, 4, 1,i),i=1,10)
     1/ 2.0500E-02, 1.8020E-01, 1.5960E-01, 6.3970E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 4, 2)/ 3/
       data (vyield(21, 4, 2,i),i=1,10)
     1/ 3.0000E-03, 1.0460E-01, 8.9240E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 4, 3)/ 2/
       data (vyield(21, 4, 3,i),i=1,10)
     1/ 7.0000E-04, 9.9929E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 4, 4)/ 1/
       data (vyield(21, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 4, 5)/ 1/
       data (vyield(21, 4, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 5, 1)/ 4/
       data (vyield(21, 5, 1,i),i=1,10)
     1/ 1.7600E-02, 1.8250E-01, 1.4580E-01, 6.5410E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 5, 2)/ 2/
       data (vyield(21, 5, 2,i),i=1,10)
     1/ 2.7400E-02, 9.7260E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 5, 3)/ 2/
       data (vyield(21, 5, 3,i),i=1,10)
     1/ 9.3333E-04, 9.9906E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 5, 4)/ 1/
       data (vyield(21, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 5, 5)/ 1/
       data (vyield(21, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 6, 1)/ 4/
       data (vyield(21, 6, 1,i),i=1,10)
     1/ 1.4600E-02, 1.8520E-01, 1.3210E-01, 6.6810E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 6, 2)/ 2/
       data (vyield(21, 6, 2,i),i=1,10)
     1/ 2.6300E-02, 9.7370E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 6, 3)/ 2/
       data (vyield(21, 6, 3,i),i=1,10)
     1/ 1.6000E-03, 9.9839E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 6, 4)/ 1/
       data (vyield(21, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 6, 5)/ 1/
       data (vyield(21, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 7, 1)/ 4/
       data (vyield(21, 7, 1,i),i=1,10)
     1/ 1.1600E-02, 1.8840E-01, 1.2480E-01, 6.7520E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 7, 2)/ 2/
       data (vyield(21, 7, 2,i),i=1,10)
     1/ 2.4700E-02, 9.7530E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 7, 3)/ 2/
       data (vyield(21, 7, 3,i),i=1,10)
     1/ 3.3666E-03, 9.9663E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 7, 4)/ 1/
       data (vyield(21, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 7, 5)/ 1/
       data (vyield(21, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 8, 1)/ 4/
       data (vyield(21, 8, 1,i),i=1,10)
     1/ 1.1200E-02, 1.9080E-01, 1.4780E-01, 6.5020E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 8, 2)/ 2/
       data (vyield(21, 8, 2,i),i=1,10)
     1/ 2.1900E-02, 9.7810E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 8, 3)/ 2/
       data (vyield(21, 8, 3,i),i=1,10)
     1/ 1.9200E-02, 9.8079E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 8, 4)/ 1/
       data (vyield(21, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 8, 5)/ 1/
       data (vyield(21, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 9, 1)/ 3/
       data (vyield(21, 9, 1,i),i=1,10)
     1/ 9.5000E-03, 1.9550E-01, 7.9500E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 9, 2)/ 2/
       data (vyield(21, 9, 2,i),i=1,10)
     1/ 1.6700E-02, 9.8330E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 9, 3)/ 2/
       data (vyield(21, 9, 3,i),i=1,10)
     1/ 2.8933E-02, 9.7106E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 9, 4)/ 1/
       data (vyield(21, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21, 9, 5)/ 1/
       data (vyield(21, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,10, 1)/ 3/
       data (vyield(21,10, 1,i),i=1,10)
     1/ 1.0700E-02, 2.5440E-01, 7.3490E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,10, 2)/ 2/
       data (vyield(21,10, 2,i),i=1,10)
     1/ 7.0000E-04, 9.9930E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,10, 3)/ 2/
       data (vyield(21,10, 3,i),i=1,10)
     1/ 5.3300E-02, 9.4669E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,10, 4)/ 1/
       data (vyield(21,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,11, 1)/ 2/
       data (vyield(21,11, 1,i),i=1,10)
     1/ 2.0360E-01, 7.9640E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,11, 2)/ 1/
       data (vyield(21,11, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,11, 3)/ 1/
       data (vyield(21,11, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,11, 4)/ 1/
       data (vyield(21,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,12, 1)/ 2/
       data (vyield(21,12, 1,i),i=1,10)
     1/ 2.0730E-01, 7.9270E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,12, 2)/ 1/
       data (vyield(21,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,12, 3)/ 1/
       data (vyield(21,12, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,13, 1)/ 2/
       data (vyield(21,13, 1,i),i=1,10)
     1/ 2.3040E-01, 7.6960E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,13, 2)/ 1/
       data (vyield(21,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,13, 3)/ 1/
       data (vyield(21,13, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,14, 1)/ 2/
       data (vyield(21,14, 1,i),i=1,10)
     1/ 2.5960E-01, 7.4040E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,14, 2)/ 1/
       data (vyield(21,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,14, 3)/ 1/
       data (vyield(21,14, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,15, 1)/ 2/
       data (vyield(21,15, 1,i),i=1,10)
     1/ 2.9790E-01, 7.0210E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,15, 2)/ 1/
       data (vyield(21,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,15, 3)/ 1/
       data (vyield(21,15, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,16, 1)/ 2/
       data (vyield(21,16, 1,i),i=1,10)
     1/ 3.5210E-01, 6.4790E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,16, 2)/ 1/
       data (vyield(21,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,16, 3)/ 1/
       data (vyield(21,16, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,17, 1)/ 2/
       data (vyield(21,17, 1,i),i=1,10)
     1/ 2.9630E-01, 7.0370E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,17, 2)/ 1/
       data (vyield(21,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,17, 3)/ 1/
       data (vyield(21,17, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,18, 1)/ 2/
       data (vyield(21,18, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,18, 2)/ 1/
       data (vyield(21,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,19, 1)/ 1/
       data (vyield(21,19, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,19, 2)/ 1/
       data (vyield(21,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,20, 1)/ 1/
       data (vyield(21,20, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(21,21, 1)/ 1/
       data (vyield(21,21, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 1, 1)/ 9/
       data (vyield(22, 1, 1,i),i=1,10)
     1/ 2.0000E-04, 2.6100E-02, 3.2200E-02, 1.8950E-01, 2.0940E-01,
     2  3.9590E-01, 1.1680E-01, 2.7800E-02, 2.1000E-03, 0.0000E+00/
       data nyield(22, 1, 2)/ 6/
       data (vyield(22, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 2.5000E-03, 6.0000E-03, 3.2880E-01, 6.0450E-01,
     2  5.8200E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 1, 3)/ 5/
       data (vyield(22, 1, 3,i),i=1,10)
     1/ 8.6666E-04, 1.0800E-02, 1.6077E-01, 8.2093E-01, 6.6333E-03,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 1, 4)/ 3/
       data (vyield(22, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 3.8500E-02, 9.6150E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 1, 5)/ 2/
       data (vyield(22, 1, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 1, 6)/ 1/
       data (vyield(22, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 1, 7)/ 1/
       data (vyield(22, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 2, 1)/ 8/
       data (vyield(22, 2, 1,i),i=1,10)
     1/ 2.0000E-04, 2.6000E-02, 2.0610E-01, 1.3030E-01, 4.0210E-01,
     2  1.8200E-01, 4.9800E-02, 3.5000E-03, 0.0000E+00, 0.0000E+00/
       data nyield(22, 2, 2)/ 5/
       data (vyield(22, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 2.2000E-03, 8.5900E-02, 8.4740E-01, 6.4500E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 2, 3)/ 4/
       data (vyield(22, 2, 3,i),i=1,10)
     1/ 8.3333E-04, 1.0500E-02, 9.8316E-01, 5.5000E-03, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 2, 4)/ 3/
       data (vyield(22, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 2.0500E-02, 9.7950E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 2, 5)/ 2/
       data (vyield(22, 2, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 2, 6)/ 1/
       data (vyield(22, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 2, 7)/ 1/
       data (vyield(22, 2, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 3, 1)/ 6/
       data (vyield(22, 3, 1,i),i=1,10)
     1/ 2.0000E-04, 2.2630E-01, 9.3800E-02, 2.0300E-01, 4.1270E-01,
     2  6.4000E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 3, 2)/ 4/
       data (vyield(22, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 5.5600E-02, 6.6730E-01, 2.7710E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 3, 3)/ 3/
       data (vyield(22, 3, 3,i),i=1,10)
     1/ 8.3333E-04, 9.8279E-01, 1.6367E-02, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 3, 4)/ 2/
       data (vyield(22, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 3, 5)/ 2/
       data (vyield(22, 3, 5,i),i=1,10)
     1/ 2.0000E-04, 9.9979E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 3, 6)/ 1/
       data (vyield(22, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 4, 1)/ 5/
       data (vyield(22, 4, 1,i),i=1,10)
     1/ 2.4300E-02, 2.0660E-01, 1.2640E-01, 5.0380E-01, 1.3890E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 4, 2)/ 3/
       data (vyield(22, 4, 2,i),i=1,10)
     1/ 3.6000E-03, 1.0380E-01, 8.9260E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 4, 3)/ 2/
       data (vyield(22, 4, 3,i),i=1,10)
     1/ 1.2333E-03, 9.9876E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 4, 4)/ 1/
       data (vyield(22, 4, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 4, 5)/ 1/
       data (vyield(22, 4, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 4, 6)/ 1/
       data (vyield(22, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 5, 1)/ 4/
       data (vyield(22, 5, 1,i),i=1,10)
     1/ 2.4200E-02, 2.0810E-01, 1.5930E-01, 6.0840E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 5, 2)/ 2/
       data (vyield(22, 5, 2,i),i=1,10)
     1/ 3.7100E-02, 9.6290E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 5, 3)/ 2/
       data (vyield(22, 5, 3,i),i=1,10)
     1/ 7.9999E-04, 9.9919E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 5, 4)/ 1/
       data (vyield(22, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 5, 5)/ 1/
       data (vyield(22, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 6, 1)/ 4/
       data (vyield(22, 6, 1,i),i=1,10)
     1/ 2.0800E-02, 2.1110E-01, 1.4510E-01, 6.2300E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 6, 2)/ 2/
       data (vyield(22, 6, 2,i),i=1,10)
     1/ 3.6300E-02, 9.6370E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 6, 3)/ 2/
       data (vyield(22, 6, 3,i),i=1,10)
     1/ 1.2000E-03, 9.9879E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 6, 4)/ 1/
       data (vyield(22, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 6, 5)/ 1/
       data (vyield(22, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 7, 1)/ 4/
       data (vyield(22, 7, 1,i),i=1,10)
     1/ 1.7300E-02, 2.1460E-01, 1.3210E-01, 6.3600E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 7, 2)/ 2/
       data (vyield(22, 7, 2,i),i=1,10)
     1/ 3.5000E-02, 9.6500E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 7, 3)/ 2/
       data (vyield(22, 7, 3,i),i=1,10)
     1/ 1.9333E-03, 9.9806E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 7, 4)/ 1/
       data (vyield(22, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 7, 5)/ 1/
       data (vyield(22, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 8, 1)/ 4/
       data (vyield(22, 8, 1,i),i=1,10)
     1/ 1.3900E-02, 2.1860E-01, 1.2660E-01, 6.4090E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 8, 2)/ 2/
       data (vyield(22, 8, 2,i),i=1,10)
     1/ 3.2900E-02, 9.6710E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 8, 3)/ 2/
       data (vyield(22, 8, 3,i),i=1,10)
     1/ 4.1333E-03, 9.9586E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 8, 4)/ 1/
       data (vyield(22, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 8, 5)/ 1/
       data (vyield(22, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 9, 1)/ 4/
       data (vyield(22, 9, 1,i),i=1,10)
     1/ 1.4100E-02, 2.2100E-01, 1.5590E-01, 6.0900E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 9, 2)/ 2/
       data (vyield(22, 9, 2,i),i=1,10)
     1/ 2.9300E-02, 9.7070E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 9, 3)/ 2/
       data (vyield(22, 9, 3,i),i=1,10)
     1/ 2.3400E-02, 9.7659E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 9, 4)/ 1/
       data (vyield(22, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22, 9, 5)/ 1/
       data (vyield(22, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,10, 1)/ 3/
       data (vyield(22,10, 1,i),i=1,10)
     1/ 1.2500E-02, 2.2640E-01, 7.6110E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,10, 2)/ 2/
       data (vyield(22,10, 2,i),i=1,10)
     1/ 2.2400E-02, 9.7760E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,10, 3)/ 2/
       data (vyield(22,10, 3,i),i=1,10)
     1/ 3.5000E-02, 9.6499E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,10, 4)/ 1/
       data (vyield(22,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,10, 5)/ 1/
       data (vyield(22,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,11, 1)/ 3/
       data (vyield(22,11, 1,i),i=1,10)
     1/ 1.4900E-02, 2.8640E-01, 6.9870E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,11, 2)/ 2/
       data (vyield(22,11, 2,i),i=1,10)
     1/ 9.0000E-04, 9.9910E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,11, 3)/ 2/
       data (vyield(22,11, 3,i),i=1,10)
     1/ 6.3900E-02, 9.3609E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,11, 4)/ 1/
       data (vyield(22,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,12, 1)/ 2/
       data (vyield(22,12, 1,i),i=1,10)
     1/ 2.3690E-01, 7.6310E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,12, 2)/ 1/
       data (vyield(22,12, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,12, 3)/ 1/
       data (vyield(22,12, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,12, 4)/ 1/
       data (vyield(22,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,13, 1)/ 2/
       data (vyield(22,13, 1,i),i=1,10)
     1/ 2.4110E-01, 7.5890E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,13, 2)/ 1/
       data (vyield(22,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,13, 3)/ 1/
       data (vyield(22,13, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,14, 1)/ 2/
       data (vyield(22,14, 1,i),i=1,10)
     1/ 2.6700E-01, 7.3300E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,14, 2)/ 1/
       data (vyield(22,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,14, 3)/ 1/
       data (vyield(22,14, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,15, 1)/ 2/
       data (vyield(22,15, 1,i),i=1,10)
     1/ 2.9940E-01, 7.0060E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,15, 2)/ 1/
       data (vyield(22,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,15, 3)/ 1/
       data (vyield(22,15, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,16, 1)/ 2/
       data (vyield(22,16, 1,i),i=1,10)
     1/ 3.4180E-01, 6.5820E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,16, 2)/ 1/
       data (vyield(22,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,16, 3)/ 1/
       data (vyield(22,16, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,17, 1)/ 2/
       data (vyield(22,17, 1,i),i=1,10)
     1/ 4.0160E-01, 5.9840E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,17, 2)/ 1/
       data (vyield(22,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,17, 3)/ 1/
       data (vyield(22,17, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,18, 1)/ 2/
       data (vyield(22,18, 1,i),i=1,10)
     1/ 3.4380E-01, 6.5620E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,18, 2)/ 1/
       data (vyield(22,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,18, 3)/ 1/
       data (vyield(22,18, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,19, 1)/ 2/
       data (vyield(22,19, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,19, 2)/ 1/
       data (vyield(22,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,20, 1)/ 1/
       data (vyield(22,20, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,20, 2)/ 1/
       data (vyield(22,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,21, 1)/ 1/
       data (vyield(22,21, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(22,22, 1)/ 1/
       data (vyield(22,22, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 1, 1)/ 9/
       data (vyield(23, 1, 1,i),i=1,10)
     1/ 6.0000E-04, 3.4000E-02, 4.8800E-02, 1.4790E-01, 1.6750E-01,
     2  4.0560E-01, 1.5950E-01, 3.3100E-02, 3.0000E-03, 0.0000E+00/
       data nyield(23, 1, 2)/ 7/
       data (vyield(23, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 3.2000E-03, 9.3000E-03, 8.3400E-02, 6.6430E-01,
     2  2.3940E-01, 4.0000E-04, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 1, 3)/ 5/
       data (vyield(23, 1, 3,i),i=1,10)
     1/ 2.4667E-03, 2.8333E-02, 2.1347E-01, 6.0956E-01, 1.4617E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 1, 4)/ 3/
       data (vyield(23, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 4.5400E-02, 9.5460E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 1, 5)/ 2/
       data (vyield(23, 1, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 1, 6)/ 1/
       data (vyield(23, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 1, 7)/ 1/
       data (vyield(23, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 2, 1)/ 8/
       data (vyield(23, 2, 1,i),i=1,10)
     1/ 6.0000E-04, 3.8900E-02, 2.5730E-01, 3.6640E-01, 2.4850E-01,
     2  7.6000E-02, 1.1700E-02, 6.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(23, 2, 2)/ 5/
       data (vyield(23, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 2.9000E-03, 4.7610E-01, 4.4990E-01, 7.1100E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 2, 3)/ 4/
       data (vyield(23, 2, 3,i),i=1,10)
     1/ 2.9000E-03, 4.9666E-02, 9.2679E-01, 2.0633E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 2, 4)/ 3/
       data (vyield(23, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 2.1000E-03, 9.9790E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 2, 5)/ 2/
       data (vyield(23, 2, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 2, 6)/ 1/
       data (vyield(23, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 3, 1)/ 7/
       data (vyield(23, 3, 1,i),i=1,10)
     1/ 5.0000E-04, 2.2120E-01, 1.2220E-01, 3.2610E-01, 2.5420E-01,
     2  6.8300E-02, 7.5000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 3, 2)/ 4/
       data (vyield(23, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 1.2800E-02, 8.1920E-01, 1.6800E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 3, 3)/ 3/
       data (vyield(23, 3, 3,i),i=1,10)
     1/ 2.4000E-03, 8.2983E-01, 1.6777E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 3, 4)/ 2/
       data (vyield(23, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 3, 5)/ 2/
       data (vyield(23, 3, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 3, 6)/ 1/
       data (vyield(23, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 4, 1)/ 6/
       data (vyield(23, 4, 1,i),i=1,10)
     1/ 2.8100E-02, 1.9220E-01, 1.2660E-01, 3.6500E-01, 2.6660E-01,
     2  2.1500E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 4, 2)/ 4/
       data (vyield(23, 4, 2,i),i=1,10)
     1/ 3.3000E-03, 1.9000E-02, 8.7580E-01, 1.0190E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 4, 3)/ 3/
       data (vyield(23, 4, 3,i),i=1,10)
     1/ 1.8667E-03, 8.2369E-01, 1.7443E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 4, 4)/ 2/
       data (vyield(23, 4, 4,i),i=1,10)
     1/ 5.2100E-02, 9.4790E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 4, 5)/ 1/
       data (vyield(23, 4, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 4, 6)/ 1/
       data (vyield(23, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 5, 1)/ 5/
       data (vyield(23, 5, 1,i),i=1,10)
     1/ 2.8200E-02, 2.3480E-01, 1.2260E-01, 4.8150E-01, 1.3290E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 5, 2)/ 3/
       data (vyield(23, 5, 2,i),i=1,10)
     1/ 1.1800E-02, 2.6110E-01, 7.2710E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 5, 3)/ 2/
       data (vyield(23, 5, 3,i),i=1,10)
     1/ 1.9333E-03, 9.9806E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 5, 4)/ 1/
       data (vyield(23, 5, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 5, 5)/ 1/
       data (vyield(23, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 5, 6)/ 1/
       data (vyield(23, 5, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 6, 1)/ 4/
       data (vyield(23, 6, 1,i),i=1,10)
     1/ 2.8000E-02, 2.3660E-01, 1.5550E-01, 5.7990E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 6, 2)/ 2/
       data (vyield(23, 6, 2,i),i=1,10)
     1/ 4.6900E-02, 9.5310E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 6, 3)/ 2/
       data (vyield(23, 6, 3,i),i=1,10)
     1/ 9.9999E-04, 9.9899E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 6, 4)/ 1/
       data (vyield(23, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 6, 5)/ 1/
       data (vyield(23, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 7, 1)/ 4/
       data (vyield(23, 7, 1,i),i=1,10)
     1/ 2.4100E-02, 2.4040E-01, 1.4210E-01, 5.9340E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 7, 2)/ 2/
       data (vyield(23, 7, 2,i),i=1,10)
     1/ 4.5900E-02, 9.5410E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 7, 3)/ 2/
       data (vyield(23, 7, 3,i),i=1,10)
     1/ 1.4667E-03, 9.9853E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 7, 4)/ 1/
       data (vyield(23, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 7, 5)/ 1/
       data (vyield(23, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 8, 1)/ 4/
       data (vyield(23, 8, 1,i),i=1,10)
     1/ 2.0100E-02, 2.4460E-01, 1.3010E-01, 6.0520E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 8, 2)/ 2/
       data (vyield(23, 8, 2,i),i=1,10)
     1/ 4.4300E-02, 9.5570E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 8, 3)/ 2/
       data (vyield(23, 8, 3,i),i=1,10)
     1/ 2.3666E-03, 9.9763E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 8, 4)/ 1/
       data (vyield(23, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 8, 5)/ 1/
       data (vyield(23, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 9, 1)/ 4/
       data (vyield(23, 9, 1,i),i=1,10)
     1/ 1.6300E-02, 2.4920E-01, 1.2710E-01, 6.0740E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 9, 2)/ 2/
       data (vyield(23, 9, 2,i),i=1,10)
     1/ 4.1700E-02, 9.5830E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 9, 3)/ 2/
       data (vyield(23, 9, 3,i),i=1,10)
     1/ 5.0333E-03, 9.9496E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 9, 4)/ 1/
       data (vyield(23, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23, 9, 5)/ 1/
       data (vyield(23, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,10, 1)/ 4/
       data (vyield(23,10, 1,i),i=1,10)
     1/ 1.7400E-02, 2.5130E-01, 1.6280E-01, 5.6850E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,10, 2)/ 2/
       data (vyield(23,10, 2,i),i=1,10)
     1/ 3.7100E-02, 9.6290E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,10, 3)/ 2/
       data (vyield(23,10, 3,i),i=1,10)
     1/ 2.8433E-02, 9.7156E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,10, 4)/ 1/
       data (vyield(23,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,10, 5)/ 1/
       data (vyield(23,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,11, 1)/ 3/
       data (vyield(23,11, 1,i),i=1,10)
     1/ 1.6300E-02, 2.5710E-01, 7.2660E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,11, 2)/ 2/
       data (vyield(23,11, 2,i),i=1,10)
     1/ 2.8500E-02, 9.7150E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,11, 3)/ 2/
       data (vyield(23,11, 3,i),i=1,10)
     1/ 4.2533E-02, 9.5746E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,11, 4)/ 1/
       data (vyield(23,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,11, 5)/ 1/
       data (vyield(23,11, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,12, 1)/ 3/
       data (vyield(23,12, 1,i),i=1,10)
     1/ 2.0600E-02, 3.1780E-01, 6.6160E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,12, 2)/ 2/
       data (vyield(23,12, 2,i),i=1,10)
     1/ 1.1000E-03, 9.9890E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,12, 3)/ 2/
       data (vyield(23,12, 3,i),i=1,10)
     1/ 7.7299E-02, 9.2269E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,12, 4)/ 1/
       data (vyield(23,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,13, 1)/ 2/
       data (vyield(23,13, 1,i),i=1,10)
     1/ 2.7050E-01, 7.2950E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,13, 2)/ 1/
       data (vyield(23,13, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,13, 3)/ 1/
       data (vyield(23,13, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,13, 4)/ 1/
       data (vyield(23,13, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,14, 1)/ 2/
       data (vyield(23,14, 1,i),i=1,10)
     1/ 2.7510E-01, 7.2490E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,14, 2)/ 1/
       data (vyield(23,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,14, 3)/ 1/
       data (vyield(23,14, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,15, 1)/ 2/
       data (vyield(23,15, 1,i),i=1,10)
     1/ 3.0310E-01, 6.9690E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,15, 2)/ 1/
       data (vyield(23,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,15, 3)/ 1/
       data (vyield(23,15, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,16, 1)/ 2/
       data (vyield(23,16, 1,i),i=1,10)
     1/ 3.3780E-01, 6.6220E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,16, 2)/ 1/
       data (vyield(23,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,16, 3)/ 1/
       data (vyield(23,16, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,17, 1)/ 2/
       data (vyield(23,17, 1,i),i=1,10)
     1/ 3.8260E-01, 6.1740E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,17, 2)/ 1/
       data (vyield(23,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,17, 3)/ 1/
       data (vyield(23,17, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,18, 1)/ 2/
       data (vyield(23,18, 1,i),i=1,10)
     1/ 4.4420E-01, 5.5580E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,18, 2)/ 1/
       data (vyield(23,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,18, 3)/ 1/
       data (vyield(23,18, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,19, 1)/ 2/
       data (vyield(23,19, 1,i),i=1,10)
     1/ 3.8380E-01, 6.1620E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,19, 2)/ 1/
       data (vyield(23,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,19, 3)/ 1/
       data (vyield(23,19, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,20, 1)/ 2/
       data (vyield(23,20, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,20, 2)/ 1/
       data (vyield(23,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,21, 1)/ 1/
       data (vyield(23,21, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,21, 2)/ 1/
       data (vyield(23,21, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,22, 1)/ 1/
       data (vyield(23,22, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(23,23, 1)/ 1/
       data (vyield(23,23, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 1, 1)/ 9/
       data (vyield(24, 1, 1,i),i=1,10)
     1/ 1.7000E-03, 6.0700E-02, 7.2300E-02, 1.3640E-01, 1.1180E-01,
     2  3.7770E-01, 2.0700E-01, 3.0400E-02, 2.3000E-03, 0.0000E+00/
       data nyield(24, 1, 2)/ 7/
       data (vyield(24, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 6.6000E-03, 4.0000E-02, 1.4390E-01, 4.4810E-01,
     2  3.5640E-01, 5.0000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 1, 3)/ 6/
       data (vyield(24, 1, 3,i),i=1,10)
     1/ 6.6000E-03, 1.1717E-01, 2.8030E-01, 4.7793E-01, 1.1713E-01,
     2  8.6666E-04, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 1, 4)/ 3/
       data (vyield(24, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 3.5200E-02, 9.6480E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 1, 5)/ 2/
       data (vyield(24, 1, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 1, 6)/ 1/
       data (vyield(24, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 1, 7)/ 1/
       data (vyield(24, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 2, 1)/ 8/
       data (vyield(24, 2, 1,i),i=1,10)
     1/ 1.7000E-03, 6.0800E-02, 7.4300E-02, 2.7380E-01, 3.7590E-01,
     2  1.8600E-01, 2.5300E-02, 2.4000E-03, 0.0000E+00, 0.0000E+00/
       data nyield(24, 2, 2)/ 5/
       data (vyield(24, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 6.4000E-03, 5.0200E-02, 6.5490E-01, 2.8850E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 2, 3)/ 4/
       data (vyield(24, 2, 3,i),i=1,10)
     1/ 6.6000E-03, 1.1723E-01, 2.8826E-01, 5.8790E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 2, 4)/ 3/
       data (vyield(24, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 1.3500E-02, 9.8650E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 2, 5)/ 2/
       data (vyield(24, 2, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 2, 6)/ 1/
       data (vyield(24, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 3, 1)/ 7/
       data (vyield(24, 3, 1,i),i=1,10)
     1/ 1.3000E-03, 4.4100E-02, 2.5400E-01, 5.3920E-01, 1.3350E-01,
     2  2.2500E-02, 5.3000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 3, 2)/ 4/
       data (vyield(24, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 5.3000E-03, 6.2700E-01, 3.6770E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 3, 3)/ 4/
       data (vyield(24, 3, 3,i),i=1,10)
     1/ 5.2000E-03, 5.1066E-02, 8.0949E-01, 1.3423E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 3, 4)/ 2/
       data (vyield(24, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 3, 5)/ 2/
       data (vyield(24, 3, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 3, 6)/ 1/
       data (vyield(24, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 4, 1)/ 6/
       data (vyield(24, 4, 1,i),i=1,10)
     1/ 1.1000E-03, 2.4740E-01, 1.6210E-01, 4.3980E-01, 1.1000E-01,
     2  3.9600E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 4, 2)/ 3/
       data (vyield(24, 4, 2,i),i=1,10)
     1/ 0.0000E+00, 1.5800E-02, 9.8420E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 4, 3)/ 3/
       data (vyield(24, 4, 3,i),i=1,10)
     1/ 4.3333E-03, 8.3229E-01, 1.6337E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 4, 4)/ 2/
       data (vyield(24, 4, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 4, 5)/ 2/
       data (vyield(24, 4, 5,i),i=1,10)
     1/ 2.0000E-04, 9.9979E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 4, 6)/ 1/
       data (vyield(24, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 5, 1)/ 5/
       data (vyield(24, 5, 1,i),i=1,10)
     1/ 3.2100E-02, 2.6090E-01, 1.2000E-01, 4.0250E-01, 1.8450E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 5, 2)/ 3/
       data (vyield(24, 5, 2,i),i=1,10)
     1/ 8.6000E-03, 1.6250E-01, 8.2890E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 5, 3)/ 2/
       data (vyield(24, 5, 3,i),i=1,10)
     1/ 3.3000E-03, 9.9669E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 5, 4)/ 2/
       data (vyield(24, 5, 4,i),i=1,10)
     1/ 5.6500E-02, 9.4350E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 5, 5)/ 1/
       data (vyield(24, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 5, 6)/ 1/
       data (vyield(24, 5, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 6, 1)/ 4/
       data (vyield(24, 6, 1,i),i=1,10)
     1/ 3.2000E-02, 2.6290E-01, 1.5260E-01, 5.5250E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 6, 2)/ 3/
       data (vyield(24, 6, 2,i),i=1,10)
     1/ 1.4900E-02, 2.5940E-01, 7.2570E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 6, 3)/ 2/
       data (vyield(24, 6, 3,i),i=1,10)
     1/ 2.9000E-03, 9.9709E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 6, 4)/ 1/
       data (vyield(24, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 6, 5)/ 1/
       data (vyield(24, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 6, 6)/ 1/
       data (vyield(24, 6, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 7, 1)/ 4/
       data (vyield(24, 7, 1,i),i=1,10)
     1/ 3.1600E-02, 2.6340E-01, 1.5280E-01, 5.5220E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 7, 2)/ 2/
       data (vyield(24, 7, 2,i),i=1,10)
     1/ 5.9200E-02, 9.4080E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 7, 3)/ 2/
       data (vyield(24, 7, 3,i),i=1,10)
     1/ 1.2000E-03, 9.9879E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 7, 4)/ 1/
       data (vyield(24, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 7, 5)/ 1/
       data (vyield(24, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 8, 1)/ 4/
       data (vyield(24, 8, 1,i),i=1,10)
     1/ 2.7200E-02, 2.6790E-01, 1.4000E-01, 5.6490E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 8, 2)/ 2/
       data (vyield(24, 8, 2,i),i=1,10)
     1/ 5.7800E-02, 9.4220E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 8, 3)/ 2/
       data (vyield(24, 8, 3,i),i=1,10)
     1/ 1.7333E-03, 9.9826E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 8, 4)/ 1/
       data (vyield(24, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 8, 5)/ 1/
       data (vyield(24, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 9, 1)/ 4/
       data (vyield(24, 9, 1,i),i=1,10)
     1/ 2.2700E-02, 2.7270E-01, 1.2910E-01, 5.7550E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 9, 2)/ 2/
       data (vyield(24, 9, 2,i),i=1,10)
     1/ 5.5800E-02, 9.4420E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 9, 3)/ 2/
       data (vyield(24, 9, 3,i),i=1,10)
     1/ 2.8666E-03, 9.9713E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 9, 4)/ 1/
       data (vyield(24, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24, 9, 5)/ 1/
       data (vyield(24, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,10, 1)/ 4/
       data (vyield(24,10, 1,i),i=1,10)
     1/ 1.8600E-02, 2.7790E-01, 1.2830E-01, 5.7520E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,10, 2)/ 2/
       data (vyield(24,10, 2,i),i=1,10)
     1/ 5.2500E-02, 9.4750E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,10, 3)/ 2/
       data (vyield(24,10, 3,i),i=1,10)
     1/ 6.0333E-03, 9.9396E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,10, 4)/ 1/
       data (vyield(24,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,10, 5)/ 1/
       data (vyield(24,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,11, 1)/ 4/
       data (vyield(24,11, 1,i),i=1,10)
     1/ 2.1100E-02, 2.7930E-01, 1.6960E-01, 5.3000E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,11, 2)/ 2/
       data (vyield(24,11, 2,i),i=1,10)
     1/ 4.6800E-02, 9.5320E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,11, 3)/ 2/
       data (vyield(24,11, 3,i),i=1,10)
     1/ 3.3900E-02, 9.6609E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,11, 4)/ 1/
       data (vyield(24,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,11, 5)/ 1/
       data (vyield(24,11, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,12, 1)/ 3/
       data (vyield(24,12, 1,i),i=1,10)
     1/ 2.0600E-02, 2.8530E-01, 6.9410E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,12, 2)/ 2/
       data (vyield(24,12, 2,i),i=1,10)
     1/ 3.5800E-02, 9.6420E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,12, 3)/ 2/
       data (vyield(24,12, 3,i),i=1,10)
     1/ 5.0600E-02, 9.4939E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,12, 4)/ 1/
       data (vyield(24,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,12, 5)/ 1/
       data (vyield(24,12, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,13, 1)/ 3/
       data (vyield(24,13, 1,i),i=1,10)
     1/ 2.7200E-02, 3.4630E-01, 6.2650E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,13, 2)/ 2/
       data (vyield(24,13, 2,i),i=1,10)
     1/ 1.4000E-03, 9.9860E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,13, 3)/ 2/
       data (vyield(24,13, 3,i),i=1,10)
     1/ 9.1699E-02, 9.0829E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,13, 4)/ 1/
       data (vyield(24,13, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,14, 1)/ 2/
       data (vyield(24,14, 1,i),i=1,10)
     1/ 3.0190E-01, 6.9810E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,14, 2)/ 1/
       data (vyield(24,14, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,14, 3)/ 1/
       data (vyield(24,14, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,14, 4)/ 1/
       data (vyield(24,14, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,15, 1)/ 2/
       data (vyield(24,15, 1,i),i=1,10)
     1/ 3.0680E-01, 6.9320E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,15, 2)/ 1/
       data (vyield(24,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,15, 3)/ 1/
       data (vyield(24,15, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,16, 1)/ 2/
       data (vyield(24,16, 1,i),i=1,10)
     1/ 3.3650E-01, 6.6350E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,16, 2)/ 1/
       data (vyield(24,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,16, 3)/ 1/
       data (vyield(24,16, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,17, 1)/ 2/
       data (vyield(24,17, 1,i),i=1,10)
     1/ 3.7310E-01, 6.2690E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,17, 2)/ 1/
       data (vyield(24,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,17, 3)/ 1/
       data (vyield(24,17, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,18, 1)/ 2/
       data (vyield(24,18, 1,i),i=1,10)
     1/ 4.1950E-01, 5.8050E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,18, 2)/ 1/
       data (vyield(24,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,18, 3)/ 1/
       data (vyield(24,18, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,19, 1)/ 2/
       data (vyield(24,19, 1,i),i=1,10)
     1/ 4.8260E-01, 5.1740E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,19, 2)/ 1/
       data (vyield(24,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,19, 3)/ 1/
       data (vyield(24,19, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,20, 1)/ 2/
       data (vyield(24,20, 1,i),i=1,10)
     1/ 4.2140E-01, 5.7860E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,20, 2)/ 1/
       data (vyield(24,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,20, 3)/ 1/
       data (vyield(24,20, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,21, 1)/ 2/
       data (vyield(24,21, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,21, 2)/ 1/
       data (vyield(24,21, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,22, 1)/ 1/
       data (vyield(24,22, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,22, 2)/ 1/
       data (vyield(24,22, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,23, 1)/ 1/
       data (vyield(24,23, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(24,24, 1)/ 1/
       data (vyield(24,24, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 1, 1)/10/
       data (vyield(25, 1, 1,i),i=1,10)
     1/ 2.7000E-03, 7.0600E-02, 8.3800E-02, 1.4370E-01, 8.0900E-02,
     2  1.5380E-01, 3.1210E-01, 1.2520E-01, 2.6200E-02, 1.0000E-03/
       data nyield(25, 1, 2)/ 8/
       data (vyield(25, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 9.4000E-03, 4.7300E-02, 1.5550E-01, 3.4000E-01,
     2  3.0190E-01, 1.4580E-01, 1.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(25, 1, 3)/ 6/
       data (vyield(25, 1, 3,i),i=1,10)
     1/ 9.6333E-03, 1.2857E-01, 2.9266E-01, 4.5370E-01, 1.0990E-01,
     2  5.5333E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 1, 4)/ 3/
       data (vyield(25, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 5.9000E-02, 9.4100E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 1, 5)/ 2/
       data (vyield(25, 1, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 1, 6)/ 1/
       data (vyield(25, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 1, 7)/ 1/
       data (vyield(25, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 2, 1)/ 9/
       data (vyield(25, 2, 1,i),i=1,10)
     1/ 2.7000E-03, 7.0700E-02, 8.2900E-02, 1.5450E-01, 1.7380E-01,
     2  3.5280E-01, 1.4190E-01, 2.0600E-02, 1.0000E-04, 0.0000E+00/
       data nyield(25, 2, 2)/ 7/
       data (vyield(25, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 9.0000E-03, 4.6200E-02, 1.9510E-01, 5.2570E-01,
     2  2.2050E-01, 3.5000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 2, 3)/ 6/
       data (vyield(25, 2, 3,i),i=1,10)
     1/ 9.7333E-03, 1.2870E-01, 2.8983E-01, 4.7773E-01, 9.3899E-02,
     2  9.9999E-05, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 2, 4)/ 3/
       data (vyield(25, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 3.7100E-02, 9.6290E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 2, 5)/ 2/
       data (vyield(25, 2, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 2, 6)/ 1/
       data (vyield(25, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 2, 7)/ 1/
       data (vyield(25, 2, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 3, 1)/ 7/
       data (vyield(25, 3, 1,i),i=1,10)
     1/ 2.7000E-03, 7.0800E-02, 1.9520E-01, 2.2040E-01, 3.9400E-01,
     2  1.0230E-01, 1.4600E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 3, 2)/ 5/
       data (vyield(25, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 1.1400E-02, 2.3550E-01, 6.7560E-01, 7.7500E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 3, 3)/ 4/
       data (vyield(25, 3, 3,i),i=1,10)
     1/ 9.7333E-03, 1.2880E-01, 6.5510E-01, 2.0637E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 3, 4)/ 3/
       data (vyield(25, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 1.2800E-02, 9.8720E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 3, 5)/ 2/
       data (vyield(25, 3, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 3, 6)/ 1/
       data (vyield(25, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 4, 1)/ 6/
       data (vyield(25, 4, 1,i),i=1,10)
     1/ 2.1000E-03, 2.7550E-01, 1.6120E-01, 4.1590E-01, 1.2370E-01,
     2  2.1600E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 4, 2)/ 3/
       data (vyield(25, 4, 2,i),i=1,10)
     1/ 0.0000E+00, 1.7200E-02, 9.8280E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 4, 3)/ 3/
       data (vyield(25, 4, 3,i),i=1,10)
     1/ 7.5333E-03, 8.4046E-01, 1.5200E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 4, 4)/ 2/
       data (vyield(25, 4, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 4, 5)/ 2/
       data (vyield(25, 4, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 4, 6)/ 1/
       data (vyield(25, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 5, 1)/ 5/
       data (vyield(25, 5, 1,i),i=1,10)
     1/ 3.6600E-02, 2.8670E-01, 1.1720E-01, 4.3900E-01, 1.2050E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 5, 2)/ 3/
       data (vyield(25, 5, 2,i),i=1,10)
     1/ 7.2000E-03, 1.2340E-01, 8.6940E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 5, 3)/ 2/
       data (vyield(25, 5, 3,i),i=1,10)
     1/ 6.4666E-03, 9.9353E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 5, 4)/ 2/
       data (vyield(25, 5, 4,i),i=1,10)
     1/ 2.4200E-02, 9.7580E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 5, 5)/ 1/
       data (vyield(25, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 5, 6)/ 1/
       data (vyield(25, 5, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 6, 1)/ 4/
       data (vyield(25, 6, 1,i),i=1,10)
     1/ 3.6500E-02, 2.8890E-01, 1.5090E-01, 5.2360E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 6, 2)/ 3/
       data (vyield(25, 6, 2,i),i=1,10)
     1/ 1.0300E-02, 1.5900E-01, 8.3070E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 6, 3)/ 2/
       data (vyield(25, 6, 3,i),i=1,10)
     1/ 6.0333E-03, 9.9396E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 6, 4)/ 1/
       data (vyield(25, 6, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 6, 5)/ 1/
       data (vyield(25, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 6, 6)/ 1/
       data (vyield(25, 6, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 7, 1)/ 4/
       data (vyield(25, 7, 1,i),i=1,10)
     1/ 3.6000E-02, 2.8960E-01, 1.5090E-01, 5.2350E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 7, 2)/ 2/
       data (vyield(25, 7, 2,i),i=1,10)
     1/ 6.7300E-02, 9.3270E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 7, 3)/ 2/
       data (vyield(25, 7, 3,i),i=1,10)
     1/ 4.1000E-03, 9.9589E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 7, 4)/ 1/
       data (vyield(25, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 7, 5)/ 1/
       data (vyield(25, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 7, 6)/ 1/
       data (vyield(25, 7, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 8, 1)/ 4/
       data (vyield(25, 8, 1,i),i=1,10)
     1/ 3.5300E-02, 2.9040E-01, 1.5000E-01, 5.2430E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 8, 2)/ 2/
       data (vyield(25, 8, 2,i),i=1,10)
     1/ 7.3700E-02, 9.2630E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 8, 3)/ 2/
       data (vyield(25, 8, 3,i),i=1,10)
     1/ 1.5000E-03, 9.9849E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 8, 4)/ 1/
       data (vyield(25, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 8, 5)/ 1/
       data (vyield(25, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 9, 1)/ 4/
       data (vyield(25, 9, 1,i),i=1,10)
     1/ 3.0500E-02, 2.9550E-01, 1.3800E-01, 5.3600E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 9, 2)/ 2/
       data (vyield(25, 9, 2,i),i=1,10)
     1/ 7.2000E-02, 9.2800E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 9, 3)/ 2/
       data (vyield(25, 9, 3,i),i=1,10)
     1/ 2.1333E-03, 9.9786E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 9, 4)/ 1/
       data (vyield(25, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25, 9, 5)/ 1/
       data (vyield(25, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,10, 1)/ 4/
       data (vyield(25,10, 1,i),i=1,10)
     1/ 2.5500E-02, 3.0100E-01, 1.2810E-01, 5.4540E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,10, 2)/ 2/
       data (vyield(25,10, 2,i),i=1,10)
     1/ 6.9500E-02, 9.3050E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,10, 3)/ 2/
       data (vyield(25,10, 3,i),i=1,10)
     1/ 3.5333E-03, 9.9646E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,10, 4)/ 1/
       data (vyield(25,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,10, 5)/ 1/
       data (vyield(25,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,11, 1)/ 4/
       data (vyield(25,11, 1,i),i=1,10)
     1/ 2.1100E-02, 3.0680E-01, 1.2980E-01, 5.4230E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,11, 2)/ 2/
       data (vyield(25,11, 2,i),i=1,10)
     1/ 6.5500E-02, 9.3450E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,11, 3)/ 2/
       data (vyield(25,11, 3,i),i=1,10)
     1/ 7.4666E-03, 9.9253E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,11, 4)/ 1/
       data (vyield(25,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,11, 5)/ 1/
       data (vyield(25,11, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,12, 1)/ 4/
       data (vyield(25,12, 1,i),i=1,10)
     1/ 2.5600E-02, 3.0700E-01, 1.7680E-01, 4.9060E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,12, 2)/ 2/
       data (vyield(25,12, 2,i),i=1,10)
     1/ 5.8500E-02, 9.4150E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,12, 3)/ 2/
       data (vyield(25,12, 3,i),i=1,10)
     1/ 4.0733E-02, 9.5926E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,12, 4)/ 1/
       data (vyield(25,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,12, 5)/ 1/
       data (vyield(25,12, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,13, 1)/ 3/
       data (vyield(25,13, 1,i),i=1,10)
     1/ 2.6100E-02, 3.1290E-01, 6.6100E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,13, 2)/ 2/
       data (vyield(25,13, 2,i),i=1,10)
     1/ 4.4800E-02, 9.5520E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,13, 3)/ 2/
       data (vyield(25,13, 3,i),i=1,10)
     1/ 6.1033E-02, 9.3896E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,13, 4)/ 1/
       data (vyield(25,13, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,13, 5)/ 1/
       data (vyield(25,13, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,14, 1)/ 3/
       data (vyield(25,14, 1,i),i=1,10)
     1/ 3.6500E-02, 3.7410E-01, 5.8940E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,14, 2)/ 2/
       data (vyield(25,14, 2,i),i=1,10)
     1/ 1.7000E-03, 9.9830E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,14, 3)/ 2/
       data (vyield(25,14, 3,i),i=1,10)
     1/ 1.1130E-01, 8.8869E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,14, 4)/ 1/
       data (vyield(25,14, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,15, 1)/ 2/
       data (vyield(25,15, 1,i),i=1,10)
     1/ 3.3350E-01, 6.6650E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,15, 2)/ 1/
       data (vyield(25,15, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,15, 3)/ 1/
       data (vyield(25,15, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,15, 4)/ 1/
       data (vyield(25,15, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,16, 1)/ 2/
       data (vyield(25,16, 1,i),i=1,10)
     1/ 3.3860E-01, 6.6140E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,16, 2)/ 1/
       data (vyield(25,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,16, 3)/ 1/
       data (vyield(25,16, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,17, 1)/ 2/
       data (vyield(25,17, 1,i),i=1,10)
     1/ 3.6980E-01, 6.3020E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,17, 2)/ 1/
       data (vyield(25,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,17, 3)/ 1/
       data (vyield(25,17, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,18, 1)/ 2/
       data (vyield(25,18, 1,i),i=1,10)
     1/ 4.0770E-01, 5.9230E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,18, 2)/ 1/
       data (vyield(25,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,18, 3)/ 1/
       data (vyield(25,18, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,19, 1)/ 2/
       data (vyield(25,19, 1,i),i=1,10)
     1/ 4.5520E-01, 5.4480E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,19, 2)/ 1/
       data (vyield(25,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,19, 3)/ 1/
       data (vyield(25,19, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,20, 1)/ 2/
       data (vyield(25,20, 1,i),i=1,10)
     1/ 5.1840E-01, 4.8160E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,20, 2)/ 1/
       data (vyield(25,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,20, 3)/ 1/
       data (vyield(25,20, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,21, 1)/ 2/
       data (vyield(25,21, 1,i),i=1,10)
     1/ 4.5620E-01, 5.4380E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,21, 2)/ 1/
       data (vyield(25,21, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,21, 3)/ 1/
       data (vyield(25,21, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,22, 1)/ 2/
       data (vyield(25,22, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,22, 2)/ 1/
       data (vyield(25,22, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,23, 1)/ 1/
       data (vyield(25,23, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,23, 2)/ 1/
       data (vyield(25,23, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,24, 1)/ 1/
       data (vyield(25,24, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(25,25, 1)/ 1/
       data (vyield(25,25, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 1, 1)/10/
       data (vyield(26, 1, 1,i),i=1,10)
     1/ 4.7000E-03, 1.0050E-01, 9.8400E-02, 1.4380E-01, 9.7000E-02,
     2  1.5980E-01, 2.0070E-01, 1.7290E-01, 2.0500E-02, 2.2000E-03/
       data nyield(26, 1, 2)/ 8/
       data (vyield(26, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 1.6200E-02, 8.9300E-02, 2.0000E-01, 3.3170E-01,
     2  2.4950E-01, 1.1220E-01, 1.1000E-03, 0.0000E+00, 0.0000E+00/
       data nyield(26, 1, 3)/ 6/
       data (vyield(26, 1, 3,i),i=1,10)
     1/ 1.5400E-02, 2.0457E-01, 3.0893E-01, 3.7553E-01, 9.1133E-02,
     2  4.4333E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 1, 4)/ 3/
       data (vyield(26, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 6.4100E-02, 9.3590E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 1, 5)/ 2/
       data (vyield(26, 1, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 1, 6)/ 1/
       data (vyield(26, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 1, 7)/ 1/
       data (vyield(26, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 2, 1)/ 9/
       data (vyield(26, 2, 1,i),i=1,10)
     1/ 4.7000E-03, 1.0070E-01, 9.7600E-02, 1.5640E-01, 1.8590E-01,
     2  3.2420E-01, 1.1540E-01, 1.4300E-02, 7.0000E-04, 0.0000E+00/
       data nyield(26, 2, 2)/ 7/
       data (vyield(26, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 1.7000E-02, 9.5300E-02, 2.5810E-01, 4.8290E-01,
     2  1.4090E-01, 5.8000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 2, 3)/ 6/
       data (vyield(26, 2, 3,i),i=1,10)
     1/ 1.5467E-02, 2.0487E-01, 3.0660E-01, 4.0180E-01, 7.1166E-02,
     2  9.9999E-05, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 2, 4)/ 3/
       data (vyield(26, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 4.3700E-02, 9.5630E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 2, 5)/ 2/
       data (vyield(26, 2, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 2, 6)/ 1/
       data (vyield(26, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 2, 7)/ 1/
       data (vyield(26, 2, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 3, 1)/ 8/
       data (vyield(26, 3, 1,i),i=1,10)
     1/ 4.7000E-03, 1.0090E-01, 2.2200E-01, 2.1390E-01, 3.6010E-01,
     2  8.5800E-02, 1.2300E-02, 3.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(26, 3, 2)/ 6/
       data (vyield(26, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 1.9400E-02, 3.6870E-01, 4.9760E-01, 1.1390E-01,
     2  4.0000E-04, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 3, 3)/ 4/
       data (vyield(26, 3, 3,i),i=1,10)
     1/ 1.5500E-02, 2.0527E-01, 6.6746E-01, 1.1177E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 3, 4)/ 3/
       data (vyield(26, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 2.1700E-02, 9.7830E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 3, 5)/ 2/
       data (vyield(26, 3, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 3, 6)/ 1/
       data (vyield(26, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 4, 1)/ 7/
       data (vyield(26, 4, 1,i),i=1,10)
     1/ 4.1000E-03, 3.0580E-01, 1.2430E-01, 3.3130E-01, 1.8500E-01,
     2  3.9800E-02, 9.7000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 4, 2)/ 5/
       data (vyield(26, 4, 2,i),i=1,10)
     1/ 0.0000E+00, 2.7500E-02, 8.2950E-01, 1.4260E-01, 4.0000E-04,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 4, 3)/ 4/
       data (vyield(26, 4, 3,i),i=1,10)
     1/ 1.3533E-02, 8.5649E-01, 1.2370E-01, 6.2666E-03, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 4, 4)/ 2/
       data (vyield(26, 4, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 4, 5)/ 2/
       data (vyield(26, 4, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 4, 6)/ 1/
       data (vyield(26, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 5, 1)/ 6/
       data (vyield(26, 5, 1,i),i=1,10)
     1/ 4.1500E-02, 2.6240E-01, 1.6250E-01, 3.9610E-01, 1.1800E-01,
     2  1.9500E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 5, 2)/ 3/
       data (vyield(26, 5, 2,i),i=1,10)
     1/ 6.5000E-03, 1.9400E-02, 9.7410E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 5, 3)/ 3/
       data (vyield(26, 5, 3,i),i=1,10)
     1/ 1.0533E-02, 8.3959E-01, 1.4987E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 5, 4)/ 2/
       data (vyield(26, 5, 4,i),i=1,10)
     1/ 1.7700E-02, 9.8230E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 5, 5)/ 1/
       data (vyield(26, 5, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 5, 6)/ 1/
       data (vyield(26, 5, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 6, 1)/ 5/
       data (vyield(26, 6, 1,i),i=1,10)
     1/ 4.1100E-02, 3.1170E-01, 1.1670E-01, 4.2200E-01, 1.0850E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 6, 2)/ 3/
       data (vyield(26, 6, 2,i),i=1,10)
     1/ 8.5000E-03, 1.2250E-01, 8.6900E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 6, 3)/ 2/
       data (vyield(26, 6, 3,i),i=1,10)
     1/ 9.0333E-03, 9.9096E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 6, 4)/ 2/
       data (vyield(26, 6, 4,i),i=1,10)
     1/ 3.4700E-02, 9.6530E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 6, 5)/ 1/
       data (vyield(26, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 6, 6)/ 1/
       data (vyield(26, 6, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 7, 1)/ 4/
       data (vyield(26, 7, 1,i),i=1,10)
     1/ 4.0900E-02, 3.1430E-01, 1.4920E-01, 4.9560E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 7, 2)/ 3/
       data (vyield(26, 7, 2,i),i=1,10)
     1/ 1.6200E-02, 2.0480E-01, 7.7900E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 7, 3)/ 2/
       data (vyield(26, 7, 3,i),i=1,10)
     1/ 8.2666E-03, 9.9173E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 7, 4)/ 1/
       data (vyield(26, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 7, 5)/ 1/
       data (vyield(26, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 7, 6)/ 1/
       data (vyield(26, 7, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 8, 1)/ 4/
       data (vyield(26, 8, 1,i),i=1,10)
     1/ 4.0100E-02, 3.1530E-01, 1.4870E-01, 4.9590E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 8, 2)/ 2/
       data (vyield(26, 8, 2,i),i=1,10)
     1/ 8.1300E-02, 9.1870E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 8, 3)/ 2/
       data (vyield(26, 8, 3,i),i=1,10)
     1/ 5.5000E-03, 9.9449E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 8, 4)/ 1/
       data (vyield(26, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 8, 5)/ 1/
       data (vyield(26, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 8, 6)/ 1/
       data (vyield(26, 8, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 9, 1)/ 4/
       data (vyield(26, 9, 1,i),i=1,10)
     1/ 3.8900E-02, 3.1650E-01, 1.4710E-01, 4.9750E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 9, 2)/ 2/
       data (vyield(26, 9, 2,i),i=1,10)
     1/ 8.9500E-02, 9.1050E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 9, 3)/ 2/
       data (vyield(26, 9, 3,i),i=1,10)
     1/ 1.7000E-03, 9.9829E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 9, 4)/ 1/
       data (vyield(26, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26, 9, 5)/ 1/
       data (vyield(26, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,10, 1)/ 4/
       data (vyield(26,10, 1,i),i=1,10)
     1/ 3.3600E-02, 3.2220E-01, 1.3570E-01, 5.0850E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,10, 2)/ 2/
       data (vyield(26,10, 2,i),i=1,10)
     1/ 8.7600E-02, 9.1240E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,10, 3)/ 2/
       data (vyield(26,10, 3,i),i=1,10)
     1/ 2.4666E-03, 9.9753E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,10, 4)/ 1/
       data (vyield(26,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,10, 5)/ 1/
       data (vyield(26,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,11, 1)/ 4/
       data (vyield(26,11, 1,i),i=1,10)
     1/ 2.8200E-02, 3.2830E-01, 1.2670E-01, 5.1680E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,11, 2)/ 2/
       data (vyield(26,11, 2,i),i=1,10)
     1/ 8.4600E-02, 9.1540E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,11, 3)/ 2/
       data (vyield(26,11, 3,i),i=1,10)
     1/ 4.0333E-03, 9.9596E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,11, 4)/ 1/
       data (vyield(26,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,11, 5)/ 1/
       data (vyield(26,11, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,12, 1)/ 4/
       data (vyield(26,12, 1,i),i=1,10)
     1/ 2.3600E-02, 3.3450E-01, 1.2990E-01, 5.1200E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,12, 2)/ 2/
       data (vyield(26,12, 2,i),i=1,10)
     1/ 7.9800E-02, 9.2020E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,12, 3)/ 2/
       data (vyield(26,12, 3,i),i=1,10)
     1/ 8.5666E-03, 9.9143E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,12, 4)/ 1/
       data (vyield(26,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,12, 5)/ 1/
       data (vyield(26,12, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,13, 1)/ 4/
       data (vyield(26,13, 1,i),i=1,10)
     1/ 2.9700E-02, 3.3360E-01, 1.7920E-01, 4.5750E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,13, 2)/ 2/
       data (vyield(26,13, 2,i),i=1,10)
     1/ 7.1400E-02, 9.2860E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,13, 3)/ 2/
       data (vyield(26,13, 3,i),i=1,10)
     1/ 4.5666E-02, 9.5433E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,13, 4)/ 1/
       data (vyield(26,13, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,13, 5)/ 1/
       data (vyield(26,13, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,14, 1)/ 3/
       data (vyield(26,14, 1,i),i=1,10)
     1/ 3.1300E-02, 3.3900E-01, 6.2970E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,14, 2)/ 2/
       data (vyield(26,14, 2,i),i=1,10)
     1/ 5.4800E-02, 9.4520E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,14, 3)/ 2/
       data (vyield(26,14, 3,i),i=1,10)
     1/ 6.8833E-02, 9.3116E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,14, 4)/ 1/
       data (vyield(26,14, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,14, 5)/ 1/
       data (vyield(26,14, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,15, 1)/ 3/
       data (vyield(26,15, 1,i),i=1,10)
     1/ 4.5300E-02, 3.9850E-01, 5.5620E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,15, 2)/ 2/
       data (vyield(26,15, 2,i),i=1,10)
     1/ 1.9000E-03, 9.9810E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,15, 3)/ 2/
       data (vyield(26,15, 3,i),i=1,10)
     1/ 1.2630E-01, 8.7369E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,15, 4)/ 1/
       data (vyield(26,15, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,16, 1)/ 2/
       data (vyield(26,16, 1,i),i=1,10)
     1/ 3.6380E-01, 6.3620E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,16, 2)/ 1/
       data (vyield(26,16, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,16, 3)/ 1/
       data (vyield(26,16, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,16, 4)/ 1/
       data (vyield(26,16, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,17, 1)/ 2/
       data (vyield(26,17, 1,i),i=1,10)
     1/ 3.6920E-01, 6.3080E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,17, 2)/ 1/
       data (vyield(26,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,17, 3)/ 1/
       data (vyield(26,17, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,18, 1)/ 2/
       data (vyield(26,18, 1,i),i=1,10)
     1/ 4.0150E-01, 5.9850E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,18, 2)/ 1/
       data (vyield(26,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,18, 3)/ 1/
       data (vyield(26,18, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,19, 1)/ 2/
       data (vyield(26,19, 1,i),i=1,10)
     1/ 4.4040E-01, 5.5960E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,19, 2)/ 1/
       data (vyield(26,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,19, 3)/ 1/
       data (vyield(26,19, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,20, 1)/ 2/
       data (vyield(26,20, 1,i),i=1,10)
     1/ 4.8870E-01, 5.1130E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,20, 2)/ 1/
       data (vyield(26,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,20, 3)/ 1/
       data (vyield(26,20, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,21, 1)/ 2/
       data (vyield(26,21, 1,i),i=1,10)
     1/ 5.5210E-01, 4.4790E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,21, 2)/ 1/
       data (vyield(26,21, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,21, 3)/ 1/
       data (vyield(26,21, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,22, 1)/ 2/
       data (vyield(26,22, 1,i),i=1,10)
     1/ 4.9030E-01, 5.0970E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,22, 2)/ 1/
       data (vyield(26,22, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,22, 3)/ 1/
       data (vyield(26,22, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,23, 1)/ 2/
       data (vyield(26,23, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,23, 2)/ 1/
       data (vyield(26,23, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,24, 1)/ 1/
       data (vyield(26,24, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,24, 2)/ 1/
       data (vyield(26,24, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,25, 1)/ 1/
       data (vyield(26,25, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(26,26, 1)/ 1/
       data (vyield(26,26, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 1, 1)/10/
       data (vyield(27, 1, 1,i),i=1,10)
     1/ 7.3000E-03, 1.2490E-01, 1.0820E-01, 1.4930E-01, 1.0830E-01,
     2  1.4620E-01, 1.5130E-01, 1.3790E-01, 6.3300E-02, 3.7000E-03/
       data nyield(27, 1, 2)/ 8/
       data (vyield(27, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 2.2400E-02, 1.2420E-01, 2.2480E-01, 3.1750E-01,
     2  2.0050E-01, 1.0210E-01, 8.5000E-03, 0.0000E+00, 0.0000E+00/
       data nyield(27, 1, 3)/ 6/
       data (vyield(27, 1, 3,i),i=1,10)
     1/ 2.2567E-02, 2.5746E-01, 3.1016E-01, 3.2873E-01, 7.7299E-02,
     2  3.7666E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 1, 4)/ 3/
       data (vyield(27, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 7.3900E-02, 9.2610E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 1, 5)/ 2/
       data (vyield(27, 1, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 1, 6)/ 1/
       data (vyield(27, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 1, 7)/ 1/
       data (vyield(27, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 2, 1)/ 9/
       data (vyield(27, 2, 1,i),i=1,10)
     1/ 7.7000E-03, 1.4180E-01, 1.0820E-01, 1.5950E-01, 3.2980E-01,
     2  1.1960E-01, 1.2100E-01, 1.2300E-02, 1.0000E-04, 0.0000E+00/
       data nyield(27, 2, 2)/ 7/
       data (vyield(27, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 2.6300E-02, 1.7030E-01, 2.7060E-01, 4.9870E-01,
     2  3.3200E-02, 9.0000E-04, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 2, 3)/ 5/
       data (vyield(27, 2, 3,i),i=1,10)
     1/ 2.3466E-02, 3.0896E-01, 3.0623E-01, 3.1266E-01, 4.8666E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 2, 4)/ 3/
       data (vyield(27, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 3.6600E-02, 9.6340E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 2, 5)/ 2/
       data (vyield(27, 2, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 2, 6)/ 1/
       data (vyield(27, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 3, 1)/ 8/
       data (vyield(27, 3, 1,i),i=1,10)
     1/ 7.4000E-03, 1.2540E-01, 1.1040E-01, 3.4350E-01, 1.8930E-01,
     2  1.9810E-01, 2.5700E-02, 2.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(27, 3, 2)/ 6/
       data (vyield(27, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 2.6700E-02, 1.6910E-01, 7.0950E-01, 9.3100E-02,
     2  1.6000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 3, 3)/ 4/
       data (vyield(27, 3, 3,i),i=1,10)
     1/ 2.2633E-02, 2.5836E-01, 3.1663E-01, 4.0236E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 3, 4)/ 3/
       data (vyield(27, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 3.0400E-02, 9.6960E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 3, 5)/ 2/
       data (vyield(27, 3, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 3, 6)/ 1/
       data (vyield(27, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 4, 1)/ 7/
       data (vyield(27, 4, 1,i),i=1,10)
     1/ 6.9000E-03, 1.0700E-01, 2.6010E-01, 3.0230E-01, 2.4440E-01,
     2  7.3700E-02, 5.6000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 4, 2)/ 5/
       data (vyield(27, 4, 2,i),i=1,10)
     1/ 0.0000E+00, 3.2200E-02, 8.1140E-01, 1.5250E-01, 3.9000E-03,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 4, 3)/ 4/
       data (vyield(27, 4, 3,i),i=1,10)
     1/ 2.1067E-02, 2.0167E-01, 6.8253E-01, 9.4733E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 4, 4)/ 2/
       data (vyield(27, 4, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 4, 5)/ 2/
       data (vyield(27, 4, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 4, 6)/ 1/
       data (vyield(27, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 5, 1)/ 7/
       data (vyield(27, 5, 1,i),i=1,10)
     1/ 6.0000E-03, 3.2600E-01, 1.3550E-01, 3.1090E-01, 1.9960E-01,
     2  2.0600E-02, 1.4000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 5, 2)/ 4/
       data (vyield(27, 5, 2,i),i=1,10)
     1/ 0.0000E+00, 3.5700E-02, 8.6120E-01, 1.0310E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 5, 3)/ 4/
       data (vyield(27, 5, 3,i),i=1,10)
     1/ 1.8433E-02, 8.5286E-01, 1.2787E-01, 8.3333E-04, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 5, 4)/ 2/
       data (vyield(27, 5, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 5, 5)/ 2/
       data (vyield(27, 5, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 5, 6)/ 1/
       data (vyield(27, 5, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 6, 1)/ 5/
       data (vyield(27, 6, 1,i),i=1,10)
     1/ 4.5700E-02, 3.3150E-01, 1.1600E-01, 3.9970E-01, 1.0710E-01,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 6, 2)/ 3/
       data (vyield(27, 6, 2,i),i=1,10)
     1/ 7.6000E-03, 1.0950E-01, 8.8290E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 6, 3)/ 2/
       data (vyield(27, 6, 3,i),i=1,10)
     1/ 1.4367E-02, 9.8563E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 6, 4)/ 2/
       data (vyield(27, 6, 4,i),i=1,10)
     1/ 1.5800E-02, 9.8420E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 6, 5)/ 1/
       data (vyield(27, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 6, 6)/ 1/
       data (vyield(27, 6, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 7, 1)/ 4/
       data (vyield(27, 7, 1,i),i=1,10)
     1/ 4.5600E-02, 3.3420E-01, 1.4850E-01, 4.7170E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 7, 2)/ 3/
       data (vyield(27, 7, 2,i),i=1,10)
     1/ 1.3500E-02, 1.6390E-01, 8.2260E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 7, 3)/ 2/
       data (vyield(27, 7, 3,i),i=1,10)
     1/ 1.3867E-02, 9.8613E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 7, 4)/ 1/
       data (vyield(27, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 7, 5)/ 1/
       data (vyield(27, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 7, 6)/ 1/
       data (vyield(27, 7, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 8, 1)/ 4/
       data (vyield(27, 8, 1,i),i=1,10)
     1/ 4.4700E-02, 3.3510E-01, 1.4790E-01, 4.7230E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 8, 2)/ 2/
       data (vyield(27, 8, 2,i),i=1,10)
     1/ 8.4800E-02, 9.1520E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 8, 3)/ 2/
       data (vyield(27, 8, 3,i),i=1,10)
     1/ 1.1133E-02, 9.8886E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 8, 4)/ 1/
       data (vyield(27, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 8, 5)/ 1/
       data (vyield(27, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 8, 6)/ 1/
       data (vyield(27, 8, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 9, 1)/ 4/
       data (vyield(27, 9, 1,i),i=1,10)
     1/ 4.3500E-02, 3.3640E-01, 1.4620E-01, 4.7390E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 9, 2)/ 2/
       data (vyield(27, 9, 2,i),i=1,10)
     1/ 9.2500E-02, 9.0750E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 9, 3)/ 2/
       data (vyield(27, 9, 3,i),i=1,10)
     1/ 7.3666E-03, 9.9263E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 9, 4)/ 1/
       data (vyield(27, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 9, 5)/ 1/
       data (vyield(27, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27, 9, 6)/ 1/
       data (vyield(27, 9, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,10, 1)/ 4/
       data (vyield(27,10, 1,i),i=1,10)
     1/ 4.1900E-02, 3.3800E-01, 1.4320E-01, 4.7690E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,10, 2)/ 2/
       data (vyield(27,10, 2,i),i=1,10)
     1/ 1.0140E-01, 8.9860E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,10, 3)/ 2/
       data (vyield(27,10, 3,i),i=1,10)
     1/ 2.2000E-03, 9.9779E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,10, 4)/ 1/
       data (vyield(27,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,10, 5)/ 1/
       data (vyield(27,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,11, 1)/ 4/
       data (vyield(27,11, 1,i),i=1,10)
     1/ 3.6200E-02, 3.4410E-01, 1.3260E-01, 4.8710E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,11, 2)/ 2/
       data (vyield(27,11, 2,i),i=1,10)
     1/ 9.9300E-02, 9.0070E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,11, 3)/ 2/
       data (vyield(27,11, 3,i),i=1,10)
     1/ 3.1333E-03, 9.9686E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,11, 4)/ 1/
       data (vyield(27,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,11, 5)/ 1/
       data (vyield(27,11, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,12, 1)/ 4/
       data (vyield(27,12, 1,i),i=1,10)
     1/ 3.0600E-02, 3.5060E-01, 1.2480E-01, 4.9400E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,12, 2)/ 2/
       data (vyield(27,12, 2,i),i=1,10)
     1/ 9.6000E-02, 9.0400E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,12, 3)/ 2/
       data (vyield(27,12, 3,i),i=1,10)
     1/ 5.1333E-03, 9.9486E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,12, 4)/ 1/
       data (vyield(27,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,12, 5)/ 1/
       data (vyield(27,12, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,13, 1)/ 4/
       data (vyield(27,13, 1,i),i=1,10)
     1/ 2.6000E-02, 3.5710E-01, 1.3200E-01, 4.8490E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,13, 2)/ 2/
       data (vyield(27,13, 2,i),i=1,10)
     1/ 9.0700E-02, 9.0930E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,13, 3)/ 2/
       data (vyield(27,13, 3,i),i=1,10)
     1/ 1.0833E-02, 9.8916E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,13, 4)/ 1/
       data (vyield(27,13, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,13, 5)/ 1/
       data (vyield(27,13, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,14, 1)/ 4/
       data (vyield(27,14, 1,i),i=1,10)
     1/ 3.6300E-02, 3.5340E-01, 1.9090E-01, 4.1940E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,14, 2)/ 2/
       data (vyield(27,14, 2,i),i=1,10)
     1/ 8.1400E-02, 9.1860E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,14, 3)/ 2/
       data (vyield(27,14, 3,i),i=1,10)
     1/ 5.7966E-02, 9.4203E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,14, 4)/ 1/
       data (vyield(27,14, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,14, 5)/ 1/
       data (vyield(27,14, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,15, 1)/ 3/
       data (vyield(27,15, 1,i),i=1,10)
     1/ 4.0000E-02, 3.5880E-01, 6.0120E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,15, 2)/ 2/
       data (vyield(27,15, 2,i),i=1,10)
     1/ 6.3000E-02, 9.3700E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,15, 3)/ 2/
       data (vyield(27,15, 3,i),i=1,10)
     1/ 8.6399E-02, 9.1359E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,15, 4)/ 1/
       data (vyield(27,15, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,15, 5)/ 1/
       data (vyield(27,15, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,16, 1)/ 3/
       data (vyield(27,16, 1,i),i=1,10)
     1/ 5.9800E-02, 4.1840E-01, 5.2180E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,16, 2)/ 2/
       data (vyield(27,16, 2,i),i=1,10)
     1/ 2.7000E-03, 9.9730E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,16, 3)/ 2/
       data (vyield(27,16, 3,i),i=1,10)
     1/ 1.5600E-01, 8.4399E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,16, 4)/ 1/
       data (vyield(27,16, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,17, 1)/ 2/
       data (vyield(27,17, 1,i),i=1,10)
     1/ 3.8870E-01, 6.1130E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,17, 2)/ 1/
       data (vyield(27,17, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,17, 3)/ 1/
       data (vyield(27,17, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,17, 4)/ 1/
       data (vyield(27,17, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,18, 1)/ 2/
       data (vyield(27,18, 1,i),i=1,10)
     1/ 3.9420E-01, 6.0580E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,18, 2)/ 1/
       data (vyield(27,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,18, 3)/ 1/
       data (vyield(27,18, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,19, 1)/ 2/
       data (vyield(27,19, 1,i),i=1,10)
     1/ 4.2760E-01, 5.7240E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,19, 2)/ 1/
       data (vyield(27,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,19, 3)/ 1/
       data (vyield(27,19, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,20, 1)/ 2/
       data (vyield(27,20, 1,i),i=1,10)
     1/ 4.6780E-01, 5.3220E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,20, 2)/ 1/
       data (vyield(27,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,20, 3)/ 1/
       data (vyield(27,20, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,21, 1)/ 2/
       data (vyield(27,21, 1,i),i=1,10)
     1/ 5.1770E-01, 4.8230E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,21, 2)/ 1/
       data (vyield(27,21, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,21, 3)/ 1/
       data (vyield(27,21, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,22, 1)/ 2/
       data (vyield(27,22, 1,i),i=1,10)
     1/ 5.8390E-01, 4.1610E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,22, 2)/ 1/
       data (vyield(27,22, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,22, 3)/ 1/
       data (vyield(27,22, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,23, 1)/ 2/
       data (vyield(27,23, 1,i),i=1,10)
     1/ 5.2670E-01, 4.7330E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,23, 2)/ 1/
       data (vyield(27,23, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,23, 3)/ 1/
       data (vyield(27,23, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,24, 1)/ 2/
       data (vyield(27,24, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,24, 2)/ 1/
       data (vyield(27,24, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,25, 1)/ 1/
       data (vyield(27,25, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,25, 2)/ 1/
       data (vyield(27,25, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,26, 1)/ 1/
       data (vyield(27,26, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(27,27, 1)/ 1/
       data (vyield(27,27, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 1, 1)/10/
       data (vyield(28, 1, 1,i),i=1,10)
     1/ 1.1400E-02, 1.5710E-01, 1.2340E-01, 1.6000E-01, 1.1660E-01,
     2  1.4110E-01, 1.3660E-01, 1.0840E-01, 4.1200E-02, 4.4000E-03/
       data nyield(28, 1, 2)/ 8/
       data (vyield(28, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 2.9200E-02, 1.5580E-01, 2.4200E-01, 3.0490E-01,
     2  1.7780E-01, 8.4300E-02, 6.0000E-03, 0.0000E+00, 0.0000E+00/
       data nyield(28, 1, 3)/ 6/
       data (vyield(28, 1, 3,i),i=1,10)
     1/ 3.0933E-02, 2.9983E-01, 3.0766E-01, 2.9160E-01, 6.6900E-02,
     2  3.0666E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 1, 4)/ 3/
       data (vyield(28, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 7.9500E-02, 9.2050E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 1, 5)/ 2/
       data (vyield(28, 1, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 1, 6)/ 1/
       data (vyield(28, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 1, 7)/ 1/
       data (vyield(28, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 2, 1)/ 9/
       data (vyield(28, 2, 1,i),i=1,10)
     1/ 1.1600E-02, 1.7370E-01, 1.2270E-01, 1.7110E-01, 3.0570E-01,
     2  1.8200E-01, 2.8700E-02, 4.3000E-03, 2.0000E-04, 0.0000E+00/
       data nyield(28, 2, 2)/ 6/
       data (vyield(28, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 3.7600E-02, 2.2670E-01, 3.1130E-01, 4.0650E-01,
     2  1.7900E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 2, 3)/ 5/
       data (vyield(28, 2, 3,i),i=1,10)
     1/ 3.1533E-02, 3.4446E-01, 3.0230E-01, 2.8243E-01, 3.9266E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 2, 4)/ 3/
       data (vyield(28, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 4.0700E-02, 9.5930E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 2, 5)/ 2/
       data (vyield(28, 2, 5,i),i=1,10)
     1/ 6.6666E-05, 9.9993E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 2, 6)/ 1/
       data (vyield(28, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 3, 1)/ 8/
       data (vyield(28, 3, 1,i),i=1,10)
     1/ 1.1400E-02, 1.5770E-01, 1.2620E-01, 3.4030E-01, 2.7710E-01,
     2  7.2600E-02, 1.4100E-02, 6.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(28, 3, 2)/ 6/
       data (vyield(28, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 3.6200E-02, 2.1340E-01, 6.6880E-01, 8.0800E-02,
     2  8.0000E-04, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 3, 3)/ 4/
       data (vyield(28, 3, 3,i),i=1,10)
     1/ 3.1033E-02, 3.0070E-01, 3.1473E-01, 3.5353E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 3, 4)/ 3/
       data (vyield(28, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 3.5900E-02, 9.6410E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 3, 5)/ 2/
       data (vyield(28, 3, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 3, 6)/ 1/
       data (vyield(28, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 4, 1)/ 7/
       data (vyield(28, 4, 1,i),i=1,10)
     1/ 1.1000E-02, 1.3980E-01, 2.7380E-01, 3.7250E-01, 1.3860E-01,
     2  5.4300E-02, 1.0000E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 4, 2)/ 5/
       data (vyield(28, 4, 2,i),i=1,10)
     1/ 0.0000E+00, 4.3100E-02, 8.2000E-01, 1.3430E-01, 2.6000E-03,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 4, 3)/ 4/
       data (vyield(28, 4, 3,i),i=1,10)
     1/ 2.9900E-02, 2.5200E-01, 6.3616E-01, 8.1933E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 4, 4)/ 2/
       data (vyield(28, 4, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 4, 5)/ 2/
       data (vyield(28, 4, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 4, 6)/ 1/
       data (vyield(28, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 5, 1)/ 7/
       data (vyield(28, 5, 1,i),i=1,10)
     1/ 1.0300E-02, 3.7120E-01, 1.3870E-01, 2.6260E-01, 1.6680E-01,
     2  4.7300E-02, 3.1000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 5, 2)/ 4/
       data (vyield(28, 5, 2,i),i=1,10)
     1/ 0.0000E+00, 4.6800E-02, 8.8190E-01, 7.1300E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 5, 3)/ 4/
       data (vyield(28, 5, 3,i),i=1,10)
     1/ 2.7833E-02, 8.6053E-01, 1.1127E-01, 3.6666E-04, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 5, 4)/ 2/
       data (vyield(28, 5, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 5, 5)/ 2/
       data (vyield(28, 5, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 5, 6)/ 1/
       data (vyield(28, 5, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 6, 1)/ 6/
       data (vyield(28, 6, 1,i),i=1,10)
     1/ 5.5500E-02, 3.7050E-01, 1.1320E-01, 3.5290E-01, 9.9100E-02,
     2  8.8000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 6, 2)/ 3/
       data (vyield(28, 6, 2,i),i=1,10)
     1/ 7.2000E-03, 1.1020E-01, 8.8260E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 6, 3)/ 2/
       data (vyield(28, 6, 3,i),i=1,10)
     1/ 2.4400E-02, 9.7559E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 6, 4)/ 2/
       data (vyield(28, 6, 4,i),i=1,10)
     1/ 2.6000E-03, 9.9740E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 6, 5)/ 1/
       data (vyield(28, 6, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 6, 6)/ 1/
       data (vyield(28, 6, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 7, 1)/ 4/
       data (vyield(28, 7, 1,i),i=1,10)
     1/ 5.4200E-02, 3.7390E-01, 1.4330E-01, 4.2860E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 7, 2)/ 3/
       data (vyield(28, 7, 2,i),i=1,10)
     1/ 1.2200E-02, 1.4150E-01, 8.4630E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 7, 3)/ 2/
       data (vyield(28, 7, 3,i),i=1,10)
     1/ 2.0600E-02, 9.7939E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 7, 4)/ 1/
       data (vyield(28, 7, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 7, 5)/ 1/
       data (vyield(28, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 7, 6)/ 1/
       data (vyield(28, 7, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 8, 1)/ 4/
       data (vyield(28, 8, 1,i),i=1,10)
     1/ 5.3300E-02, 3.7500E-01, 1.4270E-01, 4.2900E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 8, 2)/ 2/
       data (vyield(28, 8, 2,i),i=1,10)
     1/ 9.0600E-02, 9.0940E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 8, 3)/ 2/
       data (vyield(28, 8, 3,i),i=1,10)
     1/ 1.8033E-02, 9.8196E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 8, 4)/ 1/
       data (vyield(28, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 8, 5)/ 1/
       data (vyield(28, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 8, 6)/ 1/
       data (vyield(28, 8, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 9, 1)/ 4/
       data (vyield(28, 9, 1,i),i=1,10)
     1/ 5.1900E-02, 3.7640E-01, 1.4130E-01, 4.3040E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 9, 2)/ 2/
       data (vyield(28, 9, 2,i),i=1,10)
     1/ 9.7800E-02, 9.0220E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 9, 3)/ 2/
       data (vyield(28, 9, 3,i),i=1,10)
     1/ 1.4400E-02, 9.8559E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 9, 4)/ 1/
       data (vyield(28, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 9, 5)/ 1/
       data (vyield(28, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28, 9, 6)/ 1/
       data (vyield(28, 9, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,10, 1)/ 4/
       data (vyield(28,10, 1,i),i=1,10)
     1/ 5.0100E-02, 3.7820E-01, 1.3890E-01, 4.3280E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,10, 2)/ 2/
       data (vyield(28,10, 2,i),i=1,10)
     1/ 1.0630E-01, 8.9370E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,10, 3)/ 2/
       data (vyield(28,10, 3,i),i=1,10)
     1/ 9.3333E-03, 9.9066E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,10, 4)/ 1/
       data (vyield(28,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,10, 5)/ 1/
       data (vyield(28,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,10, 6)/ 1/
       data (vyield(28,10, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,11, 1)/ 4/
       data (vyield(28,11, 1,i),i=1,10)
     1/ 4.7600E-02, 3.8040E-01, 1.3480E-01, 4.3720E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,11, 2)/ 2/
       data (vyield(28,11, 2,i),i=1,10)
     1/ 1.1610E-01, 8.8390E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,11, 3)/ 2/
       data (vyield(28,11, 3,i),i=1,10)
     1/ 2.5000E-03, 9.9749E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,11, 4)/ 1/
       data (vyield(28,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,11, 5)/ 1/
       data (vyield(28,11, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,12, 1)/ 4/
       data (vyield(28,12, 1,i),i=1,10)
     1/ 4.1300E-02, 3.8750E-01, 1.2500E-01, 4.4620E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,12, 2)/ 2/
       data (vyield(28,12, 2,i),i=1,10)
     1/ 1.1370E-01, 8.8630E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,12, 3)/ 2/
       data (vyield(28,12, 3,i),i=1,10)
     1/ 3.6666E-03, 9.9633E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,12, 4)/ 1/
       data (vyield(28,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,12, 5)/ 1/
       data (vyield(28,12, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,13, 1)/ 4/
       data (vyield(28,13, 1,i),i=1,10)
     1/ 3.5100E-02, 3.9490E-01, 1.1850E-01, 4.5150E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,13, 2)/ 2/
       data (vyield(28,13, 2,i),i=1,10)
     1/ 1.1000E-01, 8.9000E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,13, 3)/ 2/
       data (vyield(28,13, 3,i),i=1,10)
     1/ 5.9666E-03, 9.9403E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,13, 4)/ 1/
       data (vyield(28,13, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,13, 5)/ 1/
       data (vyield(28,13, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,14, 1)/ 4/
       data (vyield(28,14, 1,i),i=1,10)
     1/ 3.0300E-02, 4.0190E-01, 1.2820E-01, 4.3960E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,14, 2)/ 2/
       data (vyield(28,14, 2,i),i=1,10)
     1/ 1.0390E-01, 8.9610E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,14, 3)/ 2/
       data (vyield(28,14, 3,i),i=1,10)
     1/ 1.2767E-02, 9.8723E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,14, 4)/ 1/
       data (vyield(28,14, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,14, 5)/ 1/
       data (vyield(28,14, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,15, 1)/ 4/
       data (vyield(28,15, 1,i),i=1,10)
     1/ 4.5400E-02, 3.9450E-01, 1.9020E-01, 3.6990E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,15, 2)/ 2/
       data (vyield(28,15, 2,i),i=1,10)
     1/ 9.3400E-02, 9.0660E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,15, 3)/ 2/
       data (vyield(28,15, 3,i),i=1,10)
     1/ 6.8566E-02, 9.3143E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,15, 4)/ 1/
       data (vyield(28,15, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,15, 5)/ 1/
       data (vyield(28,15, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,16, 1)/ 3/
       data (vyield(28,16, 1,i),i=1,10)
     1/ 5.1500E-02, 3.9880E-01, 5.4970E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,16, 2)/ 2/
       data (vyield(28,16, 2,i),i=1,10)
     1/ 7.2500E-02, 9.2750E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,16, 3)/ 2/
       data (vyield(28,16, 3,i),i=1,10)
     1/ 1.0120E-01, 8.9879E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,16, 4)/ 1/
       data (vyield(28,16, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,16, 5)/ 1/
       data (vyield(28,16, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,17, 1)/ 3/
       data (vyield(28,17, 1,i),i=1,10)
     1/ 7.7900E-02, 4.5170E-01, 4.7040E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,17, 2)/ 2/
       data (vyield(28,17, 2,i),i=1,10)
     1/ 3.7000E-03, 9.9630E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,17, 3)/ 2/
       data (vyield(28,17, 3,i),i=1,10)
     1/ 1.8020E-01, 8.1979E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,17, 4)/ 1/
       data (vyield(28,17, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,18, 1)/ 2/
       data (vyield(28,18, 1,i),i=1,10)
     1/ 4.3820E-01, 5.6180E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,18, 2)/ 1/
       data (vyield(28,18, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,18, 3)/ 1/
       data (vyield(28,18, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,18, 4)/ 1/
       data (vyield(28,18, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,19, 1)/ 2/
       data (vyield(28,19, 1,i),i=1,10)
     1/ 4.4380E-01, 5.5620E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,19, 2)/ 1/
       data (vyield(28,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,19, 3)/ 1/
       data (vyield(28,19, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,20, 1)/ 2/
       data (vyield(28,20, 1,i),i=1,10)
     1/ 4.7830E-01, 5.2170E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,20, 2)/ 1/
       data (vyield(28,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,20, 3)/ 1/
       data (vyield(28,20, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,21, 1)/ 2/
       data (vyield(28,21, 1,i),i=1,10)
     1/ 5.1930E-01, 4.8070E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,21, 2)/ 1/
       data (vyield(28,21, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,21, 3)/ 1/
       data (vyield(28,21, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,22, 1)/ 2/
       data (vyield(28,22, 1,i),i=1,10)
     1/ 5.6950E-01, 4.3050E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,22, 2)/ 1/
       data (vyield(28,22, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,22, 3)/ 1/
       data (vyield(28,22, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,23, 1)/ 2/
       data (vyield(28,23, 1,i),i=1,10)
     1/ 6.3550E-01, 3.6450E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,23, 2)/ 1/
       data (vyield(28,23, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,23, 3)/ 1/
       data (vyield(28,23, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,24, 1)/ 2/
       data (vyield(28,24, 1,i),i=1,10)
     1/ 5.8360E-01, 4.1640E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,24, 2)/ 1/
       data (vyield(28,24, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,24, 3)/ 1/
       data (vyield(28,24, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,25, 1)/ 2/
       data (vyield(28,25, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,25, 2)/ 1/
       data (vyield(28,25, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,26, 1)/ 1/
       data (vyield(28,26, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,26, 2)/ 1/
       data (vyield(28,26, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,27, 1)/ 1/
       data (vyield(28,27, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(28,28, 1)/ 1/
       data (vyield(28,28, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 1, 1)/ 9/
       data (vyield(29, 1, 1,i),i=1,10)
     1/ 1.7000E-02, 2.0120E-01, 1.3520E-01, 1.6510E-01, 1.3440E-01,
     2  1.4950E-01, 1.3570E-01, 5.8500E-02, 3.5000E-03, 0.0000E+00/
       data nyield(29, 1, 2)/ 8/
       data (vyield(29, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 4.2300E-02, 2.2020E-01, 2.6950E-01, 2.7610E-01,
     2  1.4240E-01, 4.9400E-02, 1.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(29, 1, 3)/ 6/
       data (vyield(29, 1, 3,i),i=1,10)
     1/ 4.3400E-02, 3.8276E-01, 3.0210E-01, 2.2020E-01, 4.9600E-02,
     2  1.9333E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 1, 4)/ 3/
       data (vyield(29, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 9.0500E-02, 9.0950E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 1, 5)/ 2/
       data (vyield(29, 1, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 1, 6)/ 1/
       data (vyield(29, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 1, 7)/ 1/
       data (vyield(29, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 2, 1)/ 8/
       data (vyield(29, 2, 1,i),i=1,10)
     1/ 1.7100E-02, 2.0150E-01, 1.3450E-01, 1.7710E-01, 2.2200E-01,
     2  2.0590E-01, 4.1800E-02, 2.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(29, 2, 2)/ 6/
       data (vyield(29, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 5.0000E-02, 2.6210E-01, 3.2380E-01, 3.2910E-01,
     2  3.5000E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 2, 3)/ 5/
       data (vyield(29, 2, 3,i),i=1,10)
     1/ 4.3466E-02, 3.8320E-01, 3.0090E-01, 2.4463E-01, 2.7800E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 2, 4)/ 3/
       data (vyield(29, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 6.4400E-02, 9.3560E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 2, 5)/ 2/
       data (vyield(29, 2, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 2, 6)/ 1/
       data (vyield(29, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 3, 1)/ 8/
       data (vyield(29, 3, 1,i),i=1,10)
     1/ 1.7100E-02, 1.8670E-01, 1.3930E-01, 2.6800E-01, 2.7200E-01,
     2  1.1550E-01, 1.3000E-03, 1.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(29, 3, 2)/ 6/
       data (vyield(29, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 5.2000E-02, 2.6730E-01, 5.2250E-01, 1.5690E-01,
     2  1.3000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 3, 3)/ 4/
       data (vyield(29, 3, 3,i),i=1,10)
     1/ 4.3400E-02, 3.4523E-01, 3.1526E-01, 2.9610E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 3, 4)/ 3/
       data (vyield(29, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 5.7700E-02, 9.4230E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 3, 5)/ 2/
       data (vyield(29, 3, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 3, 6)/ 1/
       data (vyield(29, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 4, 1)/ 8/
       data (vyield(29, 4, 1,i),i=1,10)
     1/ 1.6900E-02, 1.7020E-01, 2.3050E-01, 3.2900E-01, 2.3100E-01,
     2  1.9300E-02, 3.0000E-03, 1.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(29, 4, 2)/ 5/
       data (vyield(29, 4, 2,i),i=1,10)
     1/ 0.0000E+00, 5.9500E-02, 5.8000E-01, 3.3560E-01, 2.4900E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 4, 3)/ 4/
       data (vyield(29, 4, 3,i),i=1,10)
     1/ 4.2800E-02, 3.0310E-01, 5.0566E-01, 1.4843E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 4, 4)/ 2/
       data (vyield(29, 4, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 4, 5)/ 2/
       data (vyield(29, 4, 5,i),i=1,10)
     1/ 9.9999E-05, 9.9989E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 4, 6)/ 1/
       data (vyield(29, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 5, 1)/ 7/
       data (vyield(29, 5, 1,i),i=1,10)
     1/ 1.6300E-02, 2.9140E-01, 2.0810E-01, 3.6370E-01, 9.3000E-02,
     2  2.0800E-02, 6.7000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 5, 2)/ 4/
       data (vyield(29, 5, 2,i),i=1,10)
     1/ 0.0000E+00, 6.1200E-02, 8.2670E-01, 1.1210E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 5, 3)/ 4/
       data (vyield(29, 5, 3,i),i=1,10)
     1/ 4.1266E-02, 6.0096E-01, 3.3010E-01, 2.7667E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 5, 4)/ 2/
       data (vyield(29, 5, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 5, 5)/ 2/
       data (vyield(29, 5, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 5, 6)/ 1/
       data (vyield(29, 5, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 6, 1)/ 6/
       data (vyield(29, 6, 1,i),i=1,10)
     1/ 4.8600E-02, 3.6220E-01, 1.5990E-01, 3.0930E-01, 9.1100E-02,
     2  2.8900E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 6, 2)/ 3/
       data (vyield(29, 6, 2,i),i=1,10)
     1/ 4.8000E-03, 5.3200E-02, 9.4200E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 6, 3)/ 3/
       data (vyield(29, 6, 3,i),i=1,10)
     1/ 3.8500E-02, 8.5423E-01, 1.0727E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 6, 4)/ 2/
       data (vyield(29, 6, 4,i),i=1,10)
     1/ 1.0000E-03, 9.9900E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 6, 5)/ 2/
       data (vyield(29, 6, 5,i),i=1,10)
     1/ 1.0000E-04, 9.9990E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 6, 6)/ 1/
       data (vyield(29, 6, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 7, 1)/ 4/
       data (vyield(29, 7, 1,i),i=1,10)
     1/ 6.3400E-02, 3.9510E-01, 1.4560E-01, 3.9590E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 7, 2)/ 3/
       data (vyield(29, 7, 2,i),i=1,10)
     1/ 1.1900E-02, 1.4850E-01, 8.3960E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 7, 3)/ 2/
       data (vyield(29, 7, 3,i),i=1,10)
     1/ 3.3833E-02, 9.6616E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 7, 4)/ 2/
       data (vyield(29, 7, 4,i),i=1,10)
     1/ 2.9000E-03, 9.9710E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 7, 5)/ 1/
       data (vyield(29, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 7, 6)/ 1/
       data (vyield(29, 7, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 8, 1)/ 4/
       data (vyield(29, 8, 1,i),i=1,10)
     1/ 6.1300E-02, 3.9690E-01, 1.4300E-01, 3.9880E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 8, 2)/ 2/
       data (vyield(29, 8, 2,i),i=1,10)
     1/ 9.7500E-02, 9.0250E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 8, 3)/ 2/
       data (vyield(29, 8, 3,i),i=1,10)
     1/ 2.8267E-02, 9.7173E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 8, 4)/ 1/
       data (vyield(29, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 8, 5)/ 1/
       data (vyield(29, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 8, 6)/ 1/
       data (vyield(29, 8, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 9, 1)/ 4/
       data (vyield(29, 9, 1,i),i=1,10)
     1/ 6.0000E-02, 3.9840E-01, 1.4190E-01, 3.9970E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 9, 2)/ 2/
       data (vyield(29, 9, 2,i),i=1,10)
     1/ 1.0500E-01, 8.9500E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 9, 3)/ 2/
       data (vyield(29, 9, 3,i),i=1,10)
     1/ 2.4900E-02, 9.7509E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 9, 4)/ 1/
       data (vyield(29, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 9, 5)/ 1/
       data (vyield(29, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29, 9, 6)/ 1/
       data (vyield(29, 9, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,10, 1)/ 4/
       data (vyield(29,10, 1,i),i=1,10)
     1/ 5.8100E-02, 4.0030E-01, 1.3990E-01, 4.0170E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,10, 2)/ 2/
       data (vyield(29,10, 2,i),i=1,10)
     1/ 1.1370E-01, 8.8630E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,10, 3)/ 2/
       data (vyield(29,10, 3,i),i=1,10)
     1/ 1.9900E-02, 9.8009E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,10, 4)/ 1/
       data (vyield(29,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,10, 5)/ 1/
       data (vyield(29,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,10, 6)/ 1/
       data (vyield(29,10, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,11, 1)/ 4/
       data (vyield(29,11, 1,i),i=1,10)
     1/ 5.5300E-02, 4.0280E-01, 1.3650E-01, 4.0540E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,11, 2)/ 2/
       data (vyield(29,11, 2,i),i=1,10)
     1/ 1.2380E-01, 8.7620E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,11, 3)/ 2/
       data (vyield(29,11, 3,i),i=1,10)
     1/ 1.2933E-02, 9.8706E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,11, 4)/ 1/
       data (vyield(29,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,11, 5)/ 1/
       data (vyield(29,11, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,11, 6)/ 1/
       data (vyield(29,11, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,12, 1)/ 4/
       data (vyield(29,12, 1,i),i=1,10)
     1/ 5.1500E-02, 4.0610E-01, 1.3040E-01, 4.1200E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,12, 2)/ 2/
       data (vyield(29,12, 2,i),i=1,10)
     1/ 1.3570E-01, 8.6430E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,12, 3)/ 2/
       data (vyield(29,12, 3,i),i=1,10)
     1/ 3.2000E-03, 9.9679E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,12, 4)/ 1/
       data (vyield(29,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,12, 5)/ 1/
       data (vyield(29,12, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,13, 1)/ 4/
       data (vyield(29,13, 1,i),i=1,10)
     1/ 4.4800E-02, 4.1370E-01, 1.2140E-01, 4.2010E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,13, 2)/ 2/
       data (vyield(29,13, 2,i),i=1,10)
     1/ 1.3290E-01, 8.6710E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,13, 3)/ 2/
       data (vyield(29,13, 3,i),i=1,10)
     1/ 4.5333E-03, 9.9546E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,13, 4)/ 1/
       data (vyield(29,13, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,13, 5)/ 1/
       data (vyield(29,13, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,14, 1)/ 4/
       data (vyield(29,14, 1,i),i=1,10)
     1/ 3.8300E-02, 4.2140E-01, 1.1640E-01, 4.2390E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,14, 2)/ 2/
       data (vyield(29,14, 2,i),i=1,10)
     1/ 1.2870E-01, 8.7130E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,14, 3)/ 2/
       data (vyield(29,14, 3,i),i=1,10)
     1/ 7.4333E-03, 9.9256E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,14, 4)/ 1/
       data (vyield(29,14, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,14, 5)/ 1/
       data (vyield(29,14, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,15, 1)/ 4/
       data (vyield(29,15, 1,i),i=1,10)
     1/ 3.3800E-02, 4.2840E-01, 1.2920E-01, 4.0860E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,15, 2)/ 2/
       data (vyield(29,15, 2,i),i=1,10)
     1/ 1.2170E-01, 8.7830E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,15, 3)/ 2/
       data (vyield(29,15, 3,i),i=1,10)
     1/ 1.5733E-02, 9.8426E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,15, 4)/ 1/
       data (vyield(29,15, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,15, 5)/ 1/
       data (vyield(29,15, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,16, 1)/ 4/
       data (vyield(29,16, 1,i),i=1,10)
     1/ 5.4500E-02, 4.1680E-01, 1.9530E-01, 3.3340E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,16, 2)/ 2/
       data (vyield(29,16, 2,i),i=1,10)
     1/ 1.0970E-01, 8.9030E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,16, 3)/ 2/
       data (vyield(29,16, 3,i),i=1,10)
     1/ 8.2066E-02, 9.1793E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,16, 4)/ 1/
       data (vyield(29,16, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,16, 5)/ 1/
       data (vyield(29,16, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,17, 1)/ 3/
       data (vyield(29,17, 1,i),i=1,10)
     1/ 6.3700E-02, 4.1980E-01, 5.1650E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,17, 2)/ 2/
       data (vyield(29,17, 2,i),i=1,10)
     1/ 8.5700E-02, 9.1430E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,17, 3)/ 2/
       data (vyield(29,17, 3,i),i=1,10)
     1/ 1.2037E-01, 8.7963E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,17, 4)/ 1/
       data (vyield(29,17, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,17, 5)/ 1/
       data (vyield(29,17, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,18, 1)/ 3/
       data (vyield(29,18, 1,i),i=1,10)
     1/ 9.7900E-02, 4.6850E-01, 4.3360E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,18, 2)/ 2/
       data (vyield(29,18, 2,i),i=1,10)
     1/ 4.9000E-03, 9.9510E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,18, 3)/ 2/
       data (vyield(29,18, 3,i),i=1,10)
     1/ 2.1200E-01, 7.8799E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,18, 4)/ 1/
       data (vyield(29,18, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,19, 1)/ 2/
       data (vyield(29,19, 1,i),i=1,10)
     1/ 4.6770E-01, 5.3230E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,19, 2)/ 1/
       data (vyield(29,19, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,19, 3)/ 1/
       data (vyield(29,19, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,19, 4)/ 1/
       data (vyield(29,19, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,20, 1)/ 2/
       data (vyield(29,20, 1,i),i=1,10)
     1/ 4.7340E-01, 5.2660E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,20, 2)/ 1/
       data (vyield(29,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,20, 3)/ 1/
       data (vyield(29,20, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,21, 1)/ 2/
       data (vyield(29,21, 1,i),i=1,10)
     1/ 5.0850E-01, 4.9150E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,21, 2)/ 1/
       data (vyield(29,21, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,21, 3)/ 1/
       data (vyield(29,21, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,22, 1)/ 2/
       data (vyield(29,22, 1,i),i=1,10)
     1/ 5.4990E-01, 4.5010E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,22, 2)/ 1/
       data (vyield(29,22, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,22, 3)/ 1/
       data (vyield(29,22, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,23, 1)/ 2/
       data (vyield(29,23, 1,i),i=1,10)
     1/ 6.0070E-01, 3.9930E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,23, 2)/ 1/
       data (vyield(29,23, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,23, 3)/ 1/
       data (vyield(29,23, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,24, 1)/ 2/
       data (vyield(29,24, 1,i),i=1,10)
     1/ 6.6780E-01, 3.3220E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,24, 2)/ 1/
       data (vyield(29,24, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,24, 3)/ 1/
       data (vyield(29,24, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,25, 1)/ 2/
       data (vyield(29,25, 1,i),i=1,10)
     1/ 6.2150E-01, 3.7850E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,25, 2)/ 1/
       data (vyield(29,25, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,25, 3)/ 1/
       data (vyield(29,25, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,26, 1)/ 2/
       data (vyield(29,26, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,26, 2)/ 1/
       data (vyield(29,26, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,27, 1)/ 1/
       data (vyield(29,27, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,27, 2)/ 1/
       data (vyield(29,27, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,28, 1)/ 1/
       data (vyield(29,28, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(29,29, 1)/ 1/
       data (vyield(29,29, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 1, 1)/10/
       data (vyield(30, 1, 1,i),i=1,10)
     1/ 2.3200E-02, 2.0130E-01, 1.4170E-01, 1.6590E-01, 1.3380E-01,
     2  1.3410E-01, 9.9400E-02, 6.8400E-02, 2.5800E-02, 6.5000E-03/
       data nyield(30, 1, 2)/ 8/
       data (vyield(30, 1, 2,i),i=1,10)
     1/ 0.0000E+00, 5.2600E-02, 2.1850E-01, 2.7520E-01, 2.6830E-01,
     2  1.3030E-01, 5.0500E-02, 4.6000E-03, 0.0000E+00, 0.0000E+00/
       data nyield(30, 1, 3)/ 6/
       data (vyield(30, 1, 3,i),i=1,10)
     1/ 5.8666E-02, 3.7873E-01, 3.0473E-01, 2.1247E-01, 4.3600E-02,
     2  1.8000E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 1, 4)/ 3/
       data (vyield(30, 1, 4,i),i=1,10)
     1/ 0.0000E+00, 1.5240E-01, 8.4760E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 1, 5)/ 2/
       data (vyield(30, 1, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 1, 6)/ 1/
       data (vyield(30, 1, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 1, 7)/ 1/
       data (vyield(30, 1, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 2, 1)/ 9/
       data (vyield(30, 2, 1,i),i=1,10)
     1/ 2.3200E-02, 2.0160E-01, 1.4110E-01, 1.7190E-01, 1.3330E-01,
     2  1.6040E-01, 1.4160E-01, 2.5700E-02, 1.3000E-03, 0.0000E+00/
       data nyield(30, 2, 2)/ 7/
       data (vyield(30, 2, 2,i),i=1,10)
     1/ 0.0000E+00, 5.5600E-02, 2.3150E-01, 2.9550E-01, 2.7000E-01,
     2  1.2120E-01, 2.6200E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 2, 3)/ 6/
       data (vyield(30, 2, 3,i),i=1,10)
     1/ 5.8800E-02, 3.7906E-01, 3.0360E-01, 2.2300E-01, 3.4500E-02,
     2  1.0333E-03, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 2, 4)/ 3/
       data (vyield(30, 2, 4,i),i=1,10)
     1/ 0.0000E+00, 1.1840E-01, 8.8160E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 2, 5)/ 2/
       data (vyield(30, 2, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 2, 6)/ 1/
       data (vyield(30, 2, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 2, 7)/ 1/
       data (vyield(30, 2, 7,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 3, 1)/ 8/
       data (vyield(30, 3, 1,i),i=1,10)
     1/ 2.3300E-02, 2.0180E-01, 1.4530E-01, 1.8830E-01, 2.8050E-01,
     2  1.5830E-01, 2.2000E-03, 3.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(30, 3, 2)/ 6/
       data (vyield(30, 3, 2,i),i=1,10)
     1/ 0.0000E+00, 6.5000E-02, 2.8910E-01, 3.1680E-01, 3.1680E-01,
     2  1.2300E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 3, 3)/ 4/
       data (vyield(30, 3, 3,i),i=1,10)
     1/ 5.8833E-02, 3.7946E-01, 3.1220E-01, 2.4950E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 3, 4)/ 3/
       data (vyield(30, 3, 4,i),i=1,10)
     1/ 0.0000E+00, 7.6700E-02, 9.2330E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 3, 5)/ 2/
       data (vyield(30, 3, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 3, 6)/ 1/
       data (vyield(30, 3, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 4, 1)/ 8/
       data (vyield(30, 4, 1,i),i=1,10)
     1/ 2.3300E-02, 1.8770E-01, 1.4490E-01, 3.3250E-01, 2.8760E-01,
     2  2.0300E-02, 3.6000E-03, 1.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(30, 4, 2)/ 5/
       data (vyield(30, 4, 2,i),i=1,10)
     1/ 0.0000E+00, 7.9100E-02, 3.0860E-01, 5.5420E-01, 5.8100E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 4, 3)/ 4/
       data (vyield(30, 4, 3,i),i=1,10)
     1/ 5.8833E-02, 3.4340E-01, 3.1620E-01, 2.8156E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 4, 4)/ 2/
       data (vyield(30, 4, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 4, 5)/ 2/
       data (vyield(30, 4, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 4, 6)/ 1/
       data (vyield(30, 4, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 5, 1)/ 8/
       data (vyield(30, 5, 1,i),i=1,10)
     1/ 2.3000E-02, 1.7120E-01, 2.8560E-01, 4.0300E-01, 8.7100E-02,
     2  2.7500E-02, 2.4000E-03, 2.0000E-04, 0.0000E+00, 0.0000E+00/
       data nyield(30, 5, 2)/ 4/
       data (vyield(30, 5, 2,i),i=1,10)
     1/ 0.0000E+00, 7.5700E-02, 8.1180E-01, 1.1250E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 5, 3)/ 4/
       data (vyield(30, 5, 3,i),i=1,10)
     1/ 5.8033E-02, 3.0146E-01, 5.7653E-01, 6.3966E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 5, 4)/ 2/
       data (vyield(30, 5, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 5, 5)/ 2/
       data (vyield(30, 5, 5,i),i=1,10)
     1/ 1.6667E-04, 9.9983E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 5, 6)/ 1/
       data (vyield(30, 5, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 6, 1)/ 6/
       data (vyield(30, 6, 1,i),i=1,10)
     1/ 2.2200E-02, 3.9880E-01, 1.6210E-01, 2.7170E-01, 1.2310E-01,
     2  2.2100E-02, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 6, 2)/ 3/
       data (vyield(30, 6, 2,i),i=1,10)
     1/ 0.0000E+00, 7.8900E-02, 9.2110E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 6, 3)/ 3/
       data (vyield(30, 6, 3,i),i=1,10)
     1/ 5.6100E-02, 8.5386E-01, 9.0033E-02, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 6, 4)/ 2/
       data (vyield(30, 6, 4,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 6, 5)/ 2/
       data (vyield(30, 6, 5,i),i=1,10)
     1/ 2.0000E-04, 9.9979E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 6, 6)/ 1/
       data (vyield(30, 6, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 7, 1)/ 5/
       data (vyield(30, 7, 1,i),i=1,10)
     1/ 7.1300E-02, 3.9190E-01, 1.3120E-01, 3.1950E-01, 8.6100E-02,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 7, 2)/ 4/
       data (vyield(30, 7, 2,i),i=1,10)
     1/ 8.5000E-03, 1.3450E-01, 8.1400E-01, 4.3000E-02, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 7, 3)/ 2/
       data (vyield(30, 7, 3,i),i=1,10)
     1/ 5.2366E-02, 9.4763E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 7, 4)/ 2/
       data (vyield(30, 7, 4,i),i=1,10)
     1/ 1.7000E-03, 9.9830E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 7, 5)/ 1/
       data (vyield(30, 7, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 7, 6)/ 1/
       data (vyield(30, 7, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 8, 1)/ 4/
       data (vyield(30, 8, 1,i),i=1,10)
     1/ 6.9600E-02, 3.9340E-01, 1.5440E-01, 3.8260E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 8, 2)/ 2/
       data (vyield(30, 8, 2,i),i=1,10)
     1/ 9.9300E-02, 9.0070E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 8, 3)/ 2/
       data (vyield(30, 8, 3,i),i=1,10)
     1/ 4.8033E-02, 9.5196E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 8, 4)/ 1/
       data (vyield(30, 8, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 8, 5)/ 1/
       data (vyield(30, 8, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 8, 6)/ 1/
       data (vyield(30, 8, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 9, 1)/ 4/
       data (vyield(30, 9, 1,i),i=1,10)
     1/ 6.5800E-02, 3.9660E-01, 1.5050E-01, 3.8710E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 9, 2)/ 2/
       data (vyield(30, 9, 2,i),i=1,10)
     1/ 1.1220E-01, 8.8780E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 9, 3)/ 2/
       data (vyield(30, 9, 3,i),i=1,10)
     1/ 3.8066E-02, 9.6193E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 9, 4)/ 1/
       data (vyield(30, 9, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 9, 5)/ 1/
       data (vyield(30, 9, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30, 9, 6)/ 1/
       data (vyield(30, 9, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,10, 1)/ 4/
       data (vyield(30,10, 1,i),i=1,10)
     1/ 6.4000E-02, 3.9840E-01, 1.4910E-01, 3.8850E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,10, 2)/ 2/
       data (vyield(30,10, 2,i),i=1,10)
     1/ 1.2110E-01, 8.7890E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,10, 3)/ 2/
       data (vyield(30,10, 3,i),i=1,10)
     1/ 3.3633E-02, 9.6636E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,10, 4)/ 1/
       data (vyield(30,10, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,10, 5)/ 1/
       data (vyield(30,10, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,10, 6)/ 1/
       data (vyield(30,10, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,11, 1)/ 4/
       data (vyield(30,11, 1,i),i=1,10)
     1/ 6.1500E-02, 4.0070E-01, 1.4640E-01, 3.9140E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,11, 2)/ 2/
       data (vyield(30,11, 2,i),i=1,10)
     1/ 1.3140E-01, 8.6860E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,11, 3)/ 2/
       data (vyield(30,11, 3,i),i=1,10)
     1/ 2.7067E-02, 9.7293E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,11, 4)/ 1/
       data (vyield(30,11, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,11, 5)/ 1/
       data (vyield(30,11, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,11, 6)/ 1/
       data (vyield(30,11, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,12, 1)/ 4/
       data (vyield(30,12, 1,i),i=1,10)
     1/ 5.7700E-02, 4.0400E-01, 1.4150E-01, 3.9680E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,12, 2)/ 2/
       data (vyield(30,12, 2,i),i=1,10)
     1/ 1.4340E-01, 8.5660E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,12, 3)/ 2/
       data (vyield(30,12, 3,i),i=1,10)
     1/ 1.7567E-02, 9.8243E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,12, 4)/ 1/
       data (vyield(30,12, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,12, 5)/ 1/
       data (vyield(30,12, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,12, 6)/ 1/
       data (vyield(30,12, 6,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,13, 1)/ 4/
       data (vyield(30,13, 1,i),i=1,10)
     1/ 5.2300E-02, 4.0850E-01, 1.3270E-01, 4.0650E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,13, 2)/ 2/
       data (vyield(30,13, 2,i),i=1,10)
     1/ 1.5750E-01, 8.4250E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,13, 3)/ 2/
       data (vyield(30,13, 3,i),i=1,10)
     1/ 3.9000E-03, 9.9609E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,13, 4)/ 1/
       data (vyield(30,13, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,13, 5)/ 1/
       data (vyield(30,13, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,14, 1)/ 4/
       data (vyield(30,14, 1,i),i=1,10)
     1/ 4.5700E-02, 4.1600E-01, 1.2420E-01, 4.1410E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,14, 2)/ 2/
       data (vyield(30,14, 2,i),i=1,10)
     1/ 1.5450E-01, 8.4550E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,14, 3)/ 2/
       data (vyield(30,14, 3,i),i=1,10)
     1/ 5.6333E-03, 9.9436E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,14, 4)/ 1/
       data (vyield(30,14, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,14, 5)/ 1/
       data (vyield(30,14, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,15, 1)/ 4/
       data (vyield(30,15, 1,i),i=1,10)
     1/ 3.9400E-02, 4.2350E-01, 1.2040E-01, 4.1670E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,15, 2)/ 2/
       data (vyield(30,15, 2,i),i=1,10)
     1/ 1.4980E-01, 8.5020E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,15, 3)/ 2/
       data (vyield(30,15, 3,i),i=1,10)
     1/ 9.1999E-03, 9.9079E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,15, 4)/ 1/
       data (vyield(30,15, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,15, 5)/ 1/
       data (vyield(30,15, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,16, 1)/ 4/
       data (vyield(30,16, 1,i),i=1,10)
     1/ 3.5700E-02, 4.3010E-01, 1.3720E-01, 3.9700E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,16, 2)/ 2/
       data (vyield(30,16, 2,i),i=1,10)
     1/ 1.4210E-01, 8.5790E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,16, 3)/ 2/
       data (vyield(30,16, 3,i),i=1,10)
     1/ 1.9433E-02, 9.8056E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,16, 4)/ 1/
       data (vyield(30,16, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,16, 5)/ 1/
       data (vyield(30,16, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,17, 1)/ 4/
       data (vyield(30,17, 1,i),i=1,10)
     1/ 6.1700E-02, 4.1520E-01, 2.0960E-01, 3.1350E-01, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,17, 2)/ 2/
       data (vyield(30,17, 2,i),i=1,10)
     1/ 1.2870E-01, 8.7130E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,17, 3)/ 2/
       data (vyield(30,17, 3,i),i=1,10)
     1/ 9.7466E-02, 9.0253E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,17, 4)/ 1/
       data (vyield(30,17, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,17, 5)/ 1/
       data (vyield(30,17, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,18, 1)/ 3/
       data (vyield(30,18, 1,i),i=1,10)
     1/ 7.3800E-02, 4.1780E-01, 5.0840E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,18, 2)/ 2/
       data (vyield(30,18, 2,i),i=1,10)
     1/ 1.0130E-01, 8.9870E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,18, 3)/ 2/
       data (vyield(30,18, 3,i),i=1,10)
     1/ 1.4193E-01, 8.5806E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,18, 4)/ 1/
       data (vyield(30,18, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,18, 5)/ 1/
       data (vyield(30,18, 5,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,19, 1)/ 3/
       data (vyield(30,19, 1,i),i=1,10)
     1/ 1.1470E-01, 4.6730E-01, 4.1800E-01, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,19, 2)/ 2/
       data (vyield(30,19, 2,i),i=1,10)
     1/ 6.4000E-03, 9.9360E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,19, 3)/ 2/
       data (vyield(30,19, 3,i),i=1,10)
     1/ 2.4700E-01, 7.5299E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,19, 4)/ 1/
       data (vyield(30,19, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,20, 1)/ 2/
       data (vyield(30,20, 1,i),i=1,10)
     1/ 4.7020E-01, 5.2980E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,20, 2)/ 1/
       data (vyield(30,20, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,20, 3)/ 1/
       data (vyield(30,20, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,20, 4)/ 1/
       data (vyield(30,20, 4,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,21, 1)/ 2/
       data (vyield(30,21, 1,i),i=1,10)
     1/ 4.7580E-01, 5.2420E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,21, 2)/ 1/
       data (vyield(30,21, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,21, 3)/ 1/
       data (vyield(30,21, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,22, 1)/ 2/
       data (vyield(30,22, 1,i),i=1,10)
     1/ 5.1120E-01, 4.8880E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,22, 2)/ 1/
       data (vyield(30,22, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,22, 3)/ 1/
       data (vyield(30,22, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,23, 1)/ 2/
       data (vyield(30,23, 1,i),i=1,10)
     1/ 5.5320E-01, 4.4680E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,23, 2)/ 1/
       data (vyield(30,23, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,23, 3)/ 1/
       data (vyield(30,23, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,24, 1)/ 2/
       data (vyield(30,24, 1,i),i=1,10)
     1/ 6.0490E-01, 3.9510E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,24, 2)/ 1/
       data (vyield(30,24, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,24, 3)/ 1/
       data (vyield(30,24, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,25, 1)/ 2/
       data (vyield(30,25, 1,i),i=1,10)
     1/ 6.7420E-01, 3.2580E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,25, 2)/ 1/
       data (vyield(30,25, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,25, 3)/ 1/
       data (vyield(30,25, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,26, 1)/ 2/
       data (vyield(30,26, 1,i),i=1,10)
     1/ 6.3220E-01, 3.6780E-01, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,26, 2)/ 1/
       data (vyield(30,26, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,26, 3)/ 1/
       data (vyield(30,26, 3,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,27, 1)/ 2/
       data (vyield(30,27, 1,i),i=1,10)
     1/ 0.0000E+00, 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,27, 2)/ 1/
       data (vyield(30,27, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,28, 1)/ 1/
       data (vyield(30,28, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,28, 2)/ 1/
       data (vyield(30,28, 2,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,29, 1)/ 1/
       data (vyield(30,29, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
       data nyield(30,30, 1)/ 1/
       data (vyield(30,30, 1,i),i=1,10)
     1/ 1.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00,
     2  0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00, 0.0000E+00/
      end
******************************************************************************
      subroutine aver( chWhat , quan, weight , chLabl )
      implicit none
*compute average of various quantities over the computed geometry
      character chWhat*4 , chLabl*10
      real quan , weight
*
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , j , n , ioff
*     NAVER is the limit to the number than can be averaged
      integer naver
      parameter (naver=20)
      character chLabavr(naver)*10 , chTitAvr*132
      save chLabavr , chTitAvr
      double precision aversv(naver,4) , vaver(naver) , raver(naver)
      save aversv , n
*
      if( chWhat.eq.'zero' ) then
*       chWhat='zero' - zero out the save array
        do i=1,naver
          do j=1,4
            aversv(i,j) = 0.
          end do
        end do
        n = 0
      else if( chWhat.eq.'zone' ) then
        n = 0
      else if( chWhat.eq.'doit' ) then
*       chWhat='doit' - enter values to average
        n = n + 1
        if( n.gt.naver ) then
          write(qq,'('' Too many values entered into AVER, '',
     1    ''increase NAVER'')')
          stop
        endif
*       SUBROUTINE AVER( chWhat , QUAN, weight , chLabl )
        aversv(n,1) = aversv(n,1) + weight*dble(quan)*dble(dReff)
        aversv(n,2) = aversv(n,2) +      weight*dble(dReff)
        aversv(n,3) = aversv(n,3) + weight*dble(quan)*dble(dVeff)
        aversv(n,4) = aversv(n,4) +      weight*dble(dVeff)
        chLabavr(n) = chLabl
      else if( chWhat.eq.'prin' ) then
*       set things up to get answers
        do i=1,132
          chTitAvr(i:i) = ' '
        end do
        ioff = n*10/2+1
        chTitAvr(ioff:ioff+18) = 'Averaged Quantities'
        write(qq,'(/A130)') chTitAvr
        write(qq,'(8X,12(1X,A10))') (chLabavr(i),i=1,n)
        do i=1,n
          if( aversv(i,2).gt.0. ) then
            raver(i) = aversv(i,1) / aversv(i,2)
          else
            raver(i) = 0.
          endif
          if( aversv(i,4).gt.0. ) then
            vaver(i) = aversv(i,3) / aversv(i,4)
          else
            vaver(i) = 0.
          endif
        end do
        write(qq,'('' Radius:'',1P,10E11.3)') (raver(i),i=1,n)
*       only print vol aver is lgSphere is set
        if(lgSphere)write(qq,'('' Volume:'',1P,10E11.3)')
     1  (vaver(i),i=1,n)
      else
        write(qq,'('' AVER does not understand chWhat='',A4)') chWhat
        call ShowMe
        stop
      endif
*
      end
******************************************************************************
      subroutine backgr( nqh , chCard , ar1 )
      implicit none
*parse options for the BACKGROUND command
      integer nqh
      real ar1
      character chCard*80
*
      real pi4
      parameter (pi4=12.566371)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real HIonPot
      parameter (HIonPot=0.99946)
*ionization potential of real hydrogen atom, in inf mass ryd
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real range
      common/range/ range(limspc,2)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real emm , egamry
      common/bounds/ emm , egamry
      real rdfalt
      common/rdfalt/ rdfalt
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL , lgMatch
      integer i
      real z , fread , fac , a , rlogl
*
*     check that stack of shape and luminosity specifications
*     is parallel, stop if not - this happens is background comes
*     BETWEEN another set of shape and luminosity commands
      if( nspec.ne.nqh ) then
        write(qq,'('' This command has come between a previous ''
     1  ,''ordered pair of continuum shape and luminosity commands.''/
     2  ,'' Reorder the commands to complete each continuum '',
     3  ''specification before starting another.'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
*     diffuse x-ray background from Ostriker and Ikeuchi Ap.J.L 268, L63.
*     parameter on card is redshift, followed by optional J21 (ApJ 301, 522)
      nspec = nspec+1
      if( nspec.gt.limspc) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
      chSpType(nspec) = 'POWER'
      slope(nspec) =  -1.
      cutoff(nspec,1) = 1e10
      cutoff(nspec,2) = 0.
*     now generate equivalent of luminosity command
*     enter phi(h), the number of h-ionizing photons/cm2
      nqh = nqh + 1
      if( nqh.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
      chRSpec(nqh) = 'SQCM'
      chSpNorm(nqh) = 'FLUX'
      i = 5
*
*     this will be the redshift
      z = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        z = 0.
      endif
*     optional scale factor
      fac = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) fac = 1.0
*
*     this equation from Ostriker and Ikeuchi Ap.J.L 268, L63.
*     this should be J_nu into 4\pi sr
*     >>chng 96 july 23, from ostriker to vedel, et al mnras 271, 743.
      totpow(nqh) = log10( pi4 * fac * 1.e-21 /
     1 (1.+(5./(1.+z)) ** 4 )  )
*     this is at 1 ryd for H
*     range(nqh,1) = 1.
*chnage 96 dec 18, to H ioniz pot from 1 ryd
      range(nqh,1) = HIonPot
*
*     add fireball unless NO FIREBALL in
      if( .not.lgMatch( 'O FI', chCard ) ) then
        nspec = nspec+1
        nqh = nqh + 1
        if( nqh.gt.limspc ) then
          write(qq,'('' Too many continua entered; increase LIMSPC'')')
          stop
        endif
*       put in a black body
        chSpType(nspec) = 'BLACK'
        slope(nspec) = 2.756 * ( 1. + z )
        cutoff(nspec,1) = 0.
        cutoff(nspec,2) = 0.
        chSpNorm(nqh) = 'LUMI'
        a = log10(slope(nspec))
        rlogl = log10( 2.99792e10 * 7.56464e-15) + 4.*a
        chRSpec(nqh) = 'SQCM'
        range(nqh,1) = emm
        range(nqh,2) = egamry
        totpow(nqh) = rlogl
      endif
*
*     set radius to very large value if not already set
      if( radius.eq.0. ) then
        ar1 = rdfalt
        radius = 10.**ar1
      endif
*
      end
******************************************************************************
      subroutine badprt( total )
      implicit none
*print out coolants if energy not conserved
      real total
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*     following is smallest ratio to print
      real ratio
      parameter (ratio=0.02)
      character*1 chInfo
      integer i
      real reclin , totlin , collin
*
      write(qq,'('' BADPRT: all entries with greater than'',F6.2,
     1 ''% of incident continuum follow.'')') ratio*100.
      write(qq,'('' BADPRT: Intensities are relative to total '',
     1 ''energy radiated.'')')
*     now find sum of lines of various types
      chInfo = 'r'
      reclin = totlin( 'r' )
      write(qq,'('' Sum of recombination (abs)='',1P,E10.2,'' (rel)=''
     1 ,e10.2)') reclin, reclin/max( 1e-30, total )
*     total is total luminosity available in radiation
      do i=1,nsum
        if( chSumTyp(i).eq.chInfo .and. sumlin(i)/total.gt.ratio ) then
          write(qq,'(1X,A4,I5,F7.3,1X,A1)')
     1    chALab(i),lin(i), sumlin(i)/total , chInfo
        endif
      end do
*
      chInfo = 'c'
      collin = totlin( 'c' )
      write(qq,'('' Sum of coolants (abs) ='',1p,e10.2,'' (rel)='',
     1 e10.2)') collin , collin/max(1e-30, total)
      do i=1,nsum
        if( chSumTyp(i).eq.chInfo .and. sumlin(i)/total.gt.ratio ) then
          write(qq,'(1x,a4,i5,1p,e10.2,1x,a1)')
     1    chALab(i),lin(i), sumlin(i)/total , chInfo
        endif
      end do
*
      chInfo = 'h'
      write(qq,'('' Sum of heat (abs) ='',1p,e10.2,'' (rel)='',
     1 e10.2)') power , power/max(1e-30, total)
      do i=1,nsum
        if( chSumTyp(i).eq.chInfo .and. sumlin(i)/total.gt.ratio ) then
          write(qq,'(1X,A4,I5,F7.3,1X,A1)')
     1    chALab(i),lin(i), sumlin(i)/total , chInfo
        endif
      end do
*
      end
******************************************************************************
      subroutine bangin( chLine )
      implicit none
*called by routine comment to enter surprise into comment stack
      character*132 chLine
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      integer limwcn
      parameter (limwcn=100)
      character chWarnln*132 , chCaunln*132 , chNoteln*132 ,
     1 chBangln*132
      common/wcnln/ chWarnln(limwcn) , chCaunln(limwcn) ,
     1 chNoteln(limwcn) , chBangln(limwcn)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      nbang = nbang + 1
      if( nbang.gt.limwcn ) then
        write(qq,'('' Too many surprises have been entered; increase'',
     1  '' the value of LIMWCN everywhere in the code.'')')
        stop
      else
        chBangln(nbang) = chLine
      endif
*
      end
******************************************************************************
      subroutine bangot( io )
      implicit none
*print out all surprises on arbitrary unit number
      integer io
*
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      integer limwcn
      parameter (limwcn=100)
      character chWarnln*132 , chCaunln*132 , chNoteln*132 ,
     1 chBangln*132
      common/wcnln/ chWarnln(limwcn) , chCaunln(limwcn) ,
     1 chNoteln(limwcn) , chBangln(limwcn)
*
*     local variables
      integer i
*
      if(nbang.gt.0) then
        write(io,'(a132)') (chBangln(i),i=1,nbang)
      endif
*
      end
******************************************************************************
      subroutine beryli
      implicit none
*ionization balance for beryllium
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=5)
      parameter (nelem=4)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*
*     boron nelem=4
*     data are for carbon
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.44E-10,4.20E-11,1.92E-11,5.32E-12/
      data (cion(i,2),i=1,ndim-1)
     2 /1.31E5,2.83E5,5.56E5,7.48E5/
*     DATA GRDEFF/0.10,0.10,0.10,0.053/
*     GRDEFF is fraction of recombinations to ground state, used for
*     outward diffuse fields
*
*     rec from +3, +4 from Arnaud et al Ast Ap Sup 60 425. (1985)
*     rec from fully ionized uses Seaton '79 in ionrat
      data rec , pl/
     1 1.47E-10 , 8.74E-10 , 7.98E-9 ,
     2  -0.624  , -0.645   , -0.803  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/1.44e-10 , -0.621/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.54e-3 , 6.15e-3 , 1.62e-3 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/4.42E-2 , 5.88E-2 , 0.343 , 0./
      data (dite(i,1),i=1,ndim-1)
     2/1.57E+5 , 1.41E+5 , 8.19E+4 , 0./
      data (dite(i,2),i=1,ndim-1)
     2 /3.74E5 , 1.41E5 , 1.59E5 , 0./
      data ditcrt
     3/1.2E+4 , 1.2E+4 , 1.1E+4 , 1E20/
*
      data aa/  .0108  ,1.8267 ,2.3196  ,0./
     1  ,  bb/-0.1075  ,4.1012 ,10.7328 ,0./
     1,    cc/  .2810  ,4.8443 ,6.8830  ,0./
     2,    dd/-0.0193  ,.2261  ,-0.1824 ,0./
     3,    ff/ 0.001   ,0.5960 ,0.4101  ,0./
*
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
*     zero out ionization balance arrays
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if( lgTrace.and.lgHeavyBug ) then
        write(qq,'(5X,''Beryli returns; frac='',1P,7E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,nelem+1)
      endif
*
      end
******************************************************************************
      subroutine beseq(cs12,cs13,cs23,tarray,a30)
      implicit none
*compute level populations and emissivity for Be-sequence ions
      real cs12,cs13,cs23,a30
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
*
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
      integer limLevelN
      parameter (limLevelN=20)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real p2ovp1
      common/p2ovp1/ p2ovp1
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real te , eden , hden
      common/phycon/ te , eden , hden
*
*     local variables
      logical lgNegPop
      integer i , ner
      double precision zz(0:4,0:4)
      real boltz , excit , a20,c10,c20,c02,c01,aem,
     1 coolng , dest , c30 , c03,c21,c12,c31,c13,c32,c23,cs1u,
     1 AbunxIon , ri02 , ri20 , tot20
      real r10,r01,r02,r20,r30,r03, r12,r21,r13,r31,r23,r32,
     1 Enr01 , Enr10
      character chIonLbl*4 , chLab*4
*
*     function returns total emission in both components of line
*     destruction by background opacity computed and added to otslin field
*     here,
*     total cooling computed and added via coladd
*
*     finds population of four level Be-like atom
*     level 1 = ground, J=0
*     levels 2,3,4 are J=0,1,2, OF 3P.
*     levels 3-1 is the fast one, j=1 to ground j=0
*     cs1u is coll str to all J sub-levels of 3P; C.S. goes as 2J+1
*
*     beseq(cs12,cs13,cs23,tarray,a30,chLab)
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      AbunxIon = xIonFracs( int(tarray(ipLnNelem)) ,
     1  int(tarray(ipLnIonStg)) )
      chLab = chIonLbl( tarray )
      boltz = tarray(ipLnBolt) / te
*     low density cutoff to keep matrix happy
      if( AbunxIon.le.1e-20 .or. boltz.gt.30. ) then
*       put in pop since possible just too cool
        tarray(ipLnPopl) = AbunxIon
*     >>chng 96 sep 12, ipLnPopu had not been set before
        tarray(ipLnPopOpc) = AbunxIon
        tarray(ipLnPopu) = 0.
        tarray(ipLnInten) = 0.
        tarray(ipLnCool) = 0.
        tarray(ipLnNPhots) = 0.
        tarray(ipLnOTS) = 0.
        tarray(ipLnAovTOT) = 0.
        tarray(ipLnColovTOT) = 0.
        tarray(ipLnHeat) = 0.
*       level populations
        PopLevels(0) = AbunxIon
        PopLevels(1) = 0.
        PopLevels(2) = 0.
        PopLevels(3) = 0.
        DepLTELevels(0) = 1.
        DepLTELevels(1) = 0.
        DepLTELevels(2) = 0.
        DepLTELevels(3) = 0.
        p2ovp1 = 0.
        call coladd( chLab,int(tarray(ipLnWlAng)) ,0. )
*       now add zero to ots field
        call AddOTSLin( 0. , int(tarray(ipLnIpCont) ) ,1.0 )
        return
      endif
      excit = exp( -boltz )
      cs1u = tarray(ipLnCS)
*
*begin sanity checks
      if( tarray(ipLnGl) .ne. 1. .or. tarray(ipLnGu).ne.3. ) then
        write(qq,'('' BESEQ called with insane stat weights:'',
     1  2f5.0,1x,a4)') tarray(ipLnGl),tarray(ipLnGu),chLab
      endif
      if( cs1u.le.0. ) then
        write(qq,'('' BESEQ called with insane coll strength:'',
     1  1p,e10.2,1x,a4)') tarray(ipLnCS),chLab
      endif
*end sanity checks
*
*     incuded rates for fastest transition
      ri02 = tarray(ipLnPump)
*     back reaction has ratio of stat weights
      ri20 = tarray(ipLnPump) *1./3.
*
*     net rate out of level 3, with destruction
      a20 = tarray(ipLnAul) * ( tarray(ipLnEscP) + tarray(ipLnDesP) )
      tot20 = a20 + ri20
*
*     1/9 is ratio of level stat weight to term stat weight
      c10 = cs1u * cdsqte / 9.
      c01 = c10 * excit
      r01 = c01
      r10 = c10
*
*     stat weights canceled out here
      c20 = c10
      c02 = c01 * 3.
      r02 = c02 + ri02
      r20 = c20 + tot20
*
      c30 = c10
      c03 = c01 * 5.
      r30 = c30 + a30
      r03 = c03
*
      c21 = cs12 * cdsqte / 3.
      c12 = c21 * 3.
      r12 = c12
      r21 = c21
*
      c31 = cs13 * cdsqte / 5.
      c13 = c31 * 5.
      r31 = c31
      r13 = c13
*
      c32 = cs23 * cdsqte / 5.
      c23 = c32 * 1.667
      r32 = c32
      r23 = c23
*
*     set up matrix
      do i=0,3
*       first equation will be sum to abund
        zz(0,i) = 1.
        zz(i,4) = 0.
      end do
*
*     zz(0,4) = AbunxIon
      zz(0,4) = 1.
*
*     ground level 0 is implicit
*     level 1 balance equation
      zz(1,0) = -r01
      zz(1,1) = r10 + r12 + r13
      zz(1,2) = -r21
      zz(1,3) = -r31
*     level 2 balance equation
      zz(2,0) = -r02
      zz(2,1) = -r12
      zz(2,2) = r20 + r21 + r23
      zz(2,3) = -r32
*     level 3 balance equation
      zz(3,0) = -r03
      zz(3,1) = -r13
      zz(3,2) = -r23
      zz(3,3) = r30+r31+r32
      call matin1(zz,5,4,1,ner)
      if( ner.ne.0 ) then
        write(qq,'('' beseq matrix error'')')
        stop
      endif
*
      lgNegPop = .false.
      do i=0,3
        PopLevels(i) = zz(i,4) * AbunxIon
        if( PopLevels(i).lt.0. ) lgNegPop = .true.
      end do
*
      if(lgNegPop) then
        write(qq,*) ' beseq finds non-positive pop,=',
     1  (PopLevels(i),i=0,3),chLab
        write(qq,*)' te=',te,' total abund=',AbunxIon,' boltz=',boltz
        stop
      endif
*
      p2ovp1 = PopLevels(2) / PopLevels(0) / 3.
      DepLTELevels(0) = 1.
      DepLTELevels(1) = (PopLevels(1)/PopLevels(0))/excit
      DepLTELevels(2) = (PopLevels(2)/PopLevels(0))/(excit*3.)
      DepLTELevels(3) = (PopLevels(3)/PopLevels(0))/(excit*5.)
*
*     compute ratio Aul/(Aul+Cul)
      aem = tarray(ipLnAul) * tarray(ipLnEscP)
      tarray(ipLnAovTOT) = aem / (aem+c20)
*
      tarray(ipLnColovTOT) = c02 / r02
*
      tarray(ipLnPopl) = AbunxIon
*     >>chng 96 sep 12, ipLnPopu had not been set before
      tarray(ipLnPopu) = PopLevels(2)
      tarray(ipLnPopOpc) = AbunxIon - PopLevels(2)*1./3.
*     this will be escaping part of line
*     number of escaping line photons, used elsewhere for outward beam
      tarray(ipLnNPhots) = PopLevels(2)*tarray(ipLnAul)*tarray(ipLnEscP)
      tarray(ipLnInten) = tarray(ipLnNPhots) * tarray(ipLnEnrErg)
*
*     follow is total cooling due to this line, inclues destroyed part
*
*     following are correct heat exchange, if will mix to get correct deriv
      Enr01 = PopLevels(0)*(c01+c02+c03)*tarray(ipLnEnrErg)
      Enr10 = (PopLevels(1)*c10+ PopLevels(2)*c20+
     1 PopLevels(3)*c30 ) *tarray(ipLnEnrErg)
*
*     net cooling due to excit minus part of de-excit
      tarray(ipLnCool) = Enr01 - Enr10*tarray(ipLnColovTOT)
*     net heating is remainder
      tarray(ipLnHeat) = Enr10*(1.-tarray(ipLnColovTOT))
*
      coolng = tarray(ipLnCool)
      call coladd( chLab,int(tarray(ipLnWlAng)) , coolng )
*
*     derivative of cooling function
      dCooldT = dCooldT + coolng*( tarray(ipLnBolt)*tsq1 - halfte )
*
*     destroyed part of line
      dest = PopLevels(2) * tarray(ipLnAul) * tarray(ipLnDesP)
      tarray(ipLnOTS) = dest
*
*     now add to ots field
      call AddOTSLin( dest , int(tarray(ipLnIpCont) ) ,1.0 )
*
      end
******************************************************************************
      subroutine BiDiag( nelem, lgPrintIt)
      implicit none
*solve the bi-diagonal matrix for ionization balance
      integer nelem
      real vyield
      integer nyield
*     block data of yields from Mewe paper
*     vyield( nelem, nstage, nshell, nelec )
*     nelem is element number, 6 for carbon
*     nstage is stage of ionization, 1 for atom
*     nshell is shell number in dima notation
*     nelec is fraction that yield that number of electrons
**    nyield is number of electrons at most
      common/yield/ vyield(30,30,7,10), nyield(30,30,7)
      logical lgPrintIt
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      logical lgPrtArry
*flag set with print array command
      common/parray/ lgPrtArry
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
*recombination rates for the elements
*first dim is nelem, the atomic number of element
*secnd dim is stage of ionizaiton, 1 for atom
      real RecombinRate(limelm,limelm)
      common/RecomRate/ RecombinRate
      real secmet , smetla
      common/secmet/ secmet , smetla
      real hv2ion , hv2la
      common/hv2ion/ hv2ion(limelm,limelm) , hv2la(limelm,limelm)
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real hi , hii
      common/h/ hi , hii
      real workft , workfz
      common/workf/ workft , workfz
      real worksv
      common/worksv/ worksv(32)
      real HeavIonCool
*total cooling due to heavy element collisional ionization
      common/cmeion/ HeavIonCool
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real hetmet
      common/hetmet/ hetmet
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      real HCharExcIon(limelm,limelm) , HCharExcRec(limelm,limelm)
*     ion, nelem
*     these arrays save the charge transfer ionization and recom
*     rates for the heavy elements onto hydrogen.  ionization is
*     of the heavy element, and so is a recom for hydrogen
      common/CharExc/ HCharExcIon , HCharExcRec
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      character chElNames*4
      common/ElNames/ chElNames(limelm)
      real CollidRate(limelm, limelm, 2)
* collisional ionization rate for CollidRate(nelem,ion,1), s-1
* cooling, erg/s in (nelem,ion,2)
      common/CollIonRate/ CollidRate
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      character*10 chInCvgRsn
      common/InCvgRsn/ chInCvgRsn
      character chIonStage*4
      common/IonStage/ chIonStage(limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgNegPop , lgDone
      integer  i , ns , nej , nelec , max , LoopBig
      real heat , abundOld
*
      double precision sum , csav(32) , ratio
*
      LoopBig = 0
      lgDone = .false.
      do while (LoopBig.lt.5 .and. (.not.lgDone) )
        do i=1,nelem
          destroy(nelem,i) = 0.
          create(nelem,i) = 0.
        end do
*
*       get total destruction rates
        do i=IonLow(nelem),IonHigh(nelem)-1
*         collisional ionization
          destroy(nelem,i) = destroy(nelem,i) + CollidRate(nelem,i,1)
*         >>chng 96 oct 9, following was clobbered by above, must maintain
*         contents of destroy for Auger effect
*         destroy(nelem,i) = CollidRate(nelem,i,1)
*         photoionization loop
          do ns=1,nsShells(nelem,i)
*         >>chng 96 oct 17 add destruction here
            destroy(nelem,i) = destroy(nelem,i) +
     1        PhotoRate(nelem,i,ns,1)
*           following is most number of electrons freed
            nelec = nyield(nelem,i,ns)
*           following loop is over number of electrons that come out of shell
*           with multiple electron ejection
            do nej=2,nelec
*             this is highest possible stage of ionization -
*             do not want to ignore ionization that go beyond this
*             >>chng 96 oct 10 put highest dest into highest hole
              max = min( i+nej-1, IonHigh(nelem)-1 )
*             if( xIonFracs(nelem,i+nej-1).gt.1e-30 ) then
              if( xIonFracs(nelem,max).gt.1e-30 ) then
*               i points to current stage of ionization
                ratio = dble(xIonFracs(nelem,i)) /
     1          dble(xIonFracs(nelem,max))
              else
                ratio = 1.
              endif
*             yield here is fraction removing ion electrons
*             destroy(nelem,i+nej-1) = destroy(nelem,i+nej-1) +
*             >>chng 96 oct 10
              destroy(nelem,max) = destroy(nelem,max) +
     1        PhotoRate(nelem,i,ns,1) * vyield(nelem,i,ns,nej) * ratio
*             >>chng 96 Oct 9, had been below, change nelec to nej
*    1        PhotoRate(nelem,i,ns,1) * vyield(nelem,i,ns,nelec) * ratio
            end do
          end do
*         this is charge transfer destruction
*         >>chng 96 Oct 1, break out H ct totally
          destroy(nelem,i) = destroy(nelem,i) + CTHeavy(i,1) +
     1    HCharExcIon(i,nelem)*hii
        end do
*
*       recombination rates
        do i=IonLow(nelem),IonHigh(nelem)-1
*         recombination
          create(nelem,i) = RecombinRate(nelem,i)
*         charge transfer recombination
*         >>chng 96 Oct 1, break out H ct totally
          create(nelem,i) = create(nelem,i) + CTHeavy(i,2) +
     1    HCharExcRec(i,nelem)*hi
        end do
*
*       option to print ionization and recombination arrays
*       parray flag set with "print array" command
        if( lgPrtArry .or. lgPrintIt) then
          write(qq,'(/1x,a4,1x,''I'',1p,16e8.1/7x,16e8.1)')
     1    chElNames(nelem),(destroy(nelem,i),i=1,IonHigh(nelem)-1)
          write(qq,'(1x,a4,1x,''C'',1p,16e8.1/7x,16e8.1)')
     1    chElNames(nelem),(CollidRate(nelem,i,1),i=1,IonHigh(nelem)-1)
          write(qq,'(1x,a4,1x,''R'',1p,16e8.1/7x,16e8.1)')
     2    chElNames(nelem),(create(nelem,i),i=1,IonHigh(nelem)-1)
          write(qq,'(1x,''char I'',1p,16e8.1/7x,16e8.1)')
     1    (HCharExcIon(i,nelem)*hii,i=1,IonHigh(nelem)-1)
          write(qq,'(1x,''char R'',1p,16e8.1/7x,16e8.1)')
     2    (HCharExcRec(i,nelem)*hi,i=1,IonHigh(nelem)-1)
        endif
*
*       invert and solve bidiagonal matrix
        csav(IonLow(nelem)) = 1.d0
        sum = 1.d0
*
        do i=IonLow(nelem)+1,IonHigh(nelem)
          csav(i) = csav(i-1) * destroy(nelem,i-1) / create(nelem,i-1)
          sum = sum + csav(i)
        end do
*
        sum = dble( xIonFracs(nelem,0) ) / sum
*
        do i=1,IonLow(nelem)-1
          heating(nelem,i) = 0.
          xIonFracs(nelem,i) = 0.
        end do
        do i=IonHigh(nelem)+1,nelem+1
          xIonFracs(nelem,i) = 0.
        end do
        do i=IonHigh(nelem),nelem
          heating(nelem,i) = 0.
        end do
*
*       this is a sanity check
        lgNegPop = .false.
*
        xIonFracs(nelem,IonHigh(nelem)) = csav(IonHigh(nelem)) * sum
        if( xIonFracs(nelem,IonHigh(nelem)).lt.0. ) lgNegPop = .true.
*
        lgDone = .true.
        do i=IonLow(nelem),IonHigh(nelem)-1
          if( lgSearch .and.xIonFracs(nelem,i).gt.0. ) then
*           >>chng 96 oct 27, sulphur and above oscillated, corrected by
*           using log mean during search phase
            abundOld = xIonFracs(nelem,i)
            xIonFracs(nelem,i) =
     1      10.**( 0.5*(log10(xIonFracs(nelem,i))+log10(csav(i)*sum) ) )
*           >>chng 97 jul 29, set flag to redo if changes happen
            if( xIonFracs(nelem,i).gt.1e-15 ) then
              if( abs(abundOld/xIonFracs(nelem,i)-1.).gt.0.2 )
     1        lgDone = .false.
            endif
          else
            abundOld = xIonFracs(nelem,i)
            xIonFracs(nelem,i) = csav(i) * sum
*           >>chng 97 jul 30, set flag to redo if changes happen
            if( xIonFracs(nelem,i).gt.1e-10 ) then
              if( abs(abundOld/xIonFracs(nelem,i)-1.).gt.0.2 )
     1        lgDone = .false.
            endif
          endif
          if( xIonFracs(nelem,i).lt.0. ) lgNegPop = .true.
        end do
        if( lgPrtArry .or. lgPrintIt) then
          write(qq,'(1x,''AbundX'',1p,16e8.1/7x,16e8.1)')
     2    (xIonFracs(nelem,i),i=1,IonHigh(nelem))
        endif
        LoopBig = LoopBig + 1
      end do
*
      if(.not.lgDone) then
        lgIonDone = .false.
        chInCvgRsn(1:6) = 'BiDiag'
        chInCvgRsn(7:8) = '  '
*       this is list of numbers, 1 to limelm+1
        chInCvgRsn(9:10) = chIonStage(nelem)
      endif
*
*     we now have final solution for this element
*
      do i=IonLow(nelem),IonHigh(nelem)-1
        heat = 0.
        do ns=1,nsShells(nelem,i)
*         heating by various sub-shells
          heat = heat + PhotoRate(nelem,i,ns,2)
        end do
        heating(nelem,i) = xIonFracs(nelem,i) * heat
*       total metal photo heating for LINES
        hetmet = hetmet + heating(nelem,i)
*       HeavIonCool is cooling due to collisional ionization of heavy elements
*       CollidRate(nelem,i,2) is cooling, erg/s/atom, eval in CollidIonize
        HeavIonCool = HeavIonCool + xIonFracs(nelem,i) *
     1  CollidRate(nelem,i,2)
*
*       secondary ionization rate,
        secmet = secmet + hv2ion(nelem,i) * xIonFracs(nelem,i)
*       LA excit rate, =0 if ionized
        smetla = smetla + hv2la(nelem,i) * xIonFracs(nelem,i)
      end do
*
*     this can`t possibly happen
      if( lgNegPop ) then
        write(qq,'('' Negative population found for abundance of '',
     1  ''ionization stage of element '',A4,'', ZONE='',I4)')
     2  chElNames(nelem) ,nzone
        write(qq,'('' Populations were'',1p,12e9.1)')
     1  (xIonFracs(nelem,i),i=1,IonHigh(nelem))
        write(qq,'('' destroy vector ='',1p,12e9.1)')
     1  (destroy(nelem,i),i=1,IonHigh(nelem)-1)
        lgNegPop = .false.
        do i=1,IonHigh(nelem)-1
          if( destroy(nelem,i).lt.0. ) lgNegPop = .true.
        end do
*       print some extra stuff if destroy was negative
        if( lgNegPop ) then
          write(qq,'('' CTHeavy  vector ='',1p,12e9.1)')
     1    (CTHeavy(i,1),i=1,IonHigh(nelem)-1)
          write(qq,'('' HCharExcIon vtr='',1p,12e9.1)')
     1    (HCharExcIon(i,nelem),i=1,IonHigh(nelem)-1)
          write(qq,'('' CollidRate  vtr='',1p,12e9.1)')
     1    (CollidRate(nelem,i,1),i=1,IonHigh(nelem)-1)
*         photo rates per subshell
          write(qq,'('' photo rates per subshell, ion'')')
          do i=1,IonHigh(nelem)-1
            write(qq,'(i3,1p,8e9.1)') i,(PhotoRate(nelem,i,ns,1),
     1      ns=1,nsShells(nelem,i))
          end do
        endif
*       now check out creation vector
        write(qq,'('' create  vector ='',1p,12e9.1)')
     1  (create(nelem,i),i=1,IonHigh(nelem)-1)
        call negcon
        call ShowMe
        stop
      endif
*
*     estimate of work function of total gas
      do i=IonLow(nelem),IonHigh(nelem)-1
        workfz = workfz + worksv(i) * xIonFracs(nelem,i+1)
      end do
*
      end
******************************************************************************
      subroutine blacfx( chCard , nqh , ar1 )
      implicit none
*parse parameters off black body command
      character chCard*80
      integer nqh
      real ar1
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
      real emm , egamry
      common/bounds/ emm , egamry
      real range
      common/range/ range(limspc,2)
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real rdfalt
      common/rdfalt/ rdfalt
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL , lgMatch
      integer i
      real fread , a , rlogl , dil
*
      nspec = min( nspec+1 , limspc )
*     type is blackbody
      chSpType(nspec) = 'BLACK'
*
*     these two are not used for this continuum shape
      cutoff(nspec,1) = 0.
      cutoff(nspec,2) = 0.
*
*     get the temperature
      i = 5
      slope(nspec) = fread( chCard , i , 76 , lgEOL )
*
*     there must be at least one number, the temperature
      if( lgEOL ) then
        write(qq,'('' There must be at least 1 number on a'',
     1  '' BLACKBODY command line.  Sorry.'')')
        stop
      endif
*
*     this is the temperature - make sure its linear in the end
*     there are two keys, LINEAR and LOG, that could be here,
*     else choose which is here by which side of 10
      if( (slope(nspec).le.10. .and..not.lgMatch('LINE',chCard) ) .or.
     1 lgMatch(' LOG',chCard) ) then
*       log option
        slope(nspec) = 10.**slope(nspec)
      endif
*
*     check that temp is not too low - could happen if log misused
      if( slope(nspec).lt.1e4 ) write(qq,'('' Is T(star)='',1P,E10.2,
     1'' correct???'')') slope(nspec)
*
*     now check that temp not too low - would peak below low
*     energy limit of the code
*     factor is temperature of 1 Ryd, egamry is high energy limit of code
      if( slope(nspec)/te1ryd .lt. emm ) then
        write(qq,'('' This temperature is very low - the blackbody '',
     1  ''will have significant flux low the low energy limit of '',
     2  ''the code, presently '',1p,e10.2,'' Ryd.'')') emm
        write(qq,'('' Was this intended?'')')
      endif
*
*     now check that temp not too high - would extend beyond high
*     energy limit of the code
*     factor is temperature of 1 Ryd, egamry is high energy limit of code
      if( slope(nspec)/te1ryd*2. .gt. egamry ) then
        write(qq,'('' This temperature is very high - the blackbody '',
     1  ''will have significant flux above the high energy limit of '',
     2  ''the code,'',1p,e10.2,'' Ryd.'')') egamry
        write(qq,'('' Was this intended?'')')
      endif
*
*     also possible to input log(total luminosity)=real log(l)
      a = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
*       there was not a second number on the line; check if LTE
        if( lgMatch( ' LTE' , chCard ) ) then
*         set energy density to LTE value
          nqh = min( nqh+1 , limspc )
*         check that stack of shape and luminosity specifications
*         is parallel, stop if not - this happens is background comes
*         BETWEEN another set of shape and luminosity commands
          if( nspec.ne.nqh ) then
            write(qq,'('' This command has come between a previous ''
     1      ,''ordered pair of continuum shape and luminosity '',
     2      ''commands.''/'' Reorder the commands to complete each'',
     3      ''continuum specification before starting another.'')')
            write(qq,'('' Sorry.'')')
            stop
          endif
          chSpNorm(nqh) = 'LUMI'
          a = log10(slope(nspec))
          rlogl = log10( 2.99792e10 * 7.56464e-15) + 4.*a
          if( radius.eq.0. ) then
            ar1 = rdfalt
            radius = 10.**ar1
          endif
          chRSpec(nqh) = 'SQCM'
          range(nqh,1) = emm
          range(nqh,2) = egamry
          totpow(nqh) = rlogl
        endif
        return
      endif
*
*     the second number will be some sort of luminosity
      nqh = min( nqh+1 , limspc )
*     check that stack of shape and luminosity specifications
*     is parallel, stop if not - this happens is background comes
*     BETWEEN another set of shape and luminosity commands
      if( nspec.ne.nqh ) then
        write(qq,'('' This command has come between a previous '',
     1  ''ordered pair of continuum shape and luminosity '',
     2  ''commands.''/'' Reorder the commands to complete each'',
     3  ''continuum specification before starting another.'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
      chSpNorm(nqh) = 'LUMI'
*
*     a second number was entered, what was it?
      if( lgMatch( 'LUMI' , chCard ) ) then
        rlogl = a
        chRSpec(nqh) = '4 PI'
*
      else if( lgMatch( 'RADI' , chCard ) ) then
*       radius was entered, convert to total lumin
        rlogl = -3.147238 + 2.*a + 4.*log10(slope(nspec) )
        chRSpec(nqh) = '4 PI'
*
      else if( lgMatch( 'DENS' , chCard ) ) then
*       number was temperature to deduce energy density
*       number is linear if greater than 10, or if LINEAR appears on line
*       want number to be log of temperature at end of this
        if( lgMatch( 'LINE' , chCard ) .or. a.gt.10. ) then
            a = log10(a)
        endif
        rlogl = log10( 2.99792e10 * 7.56464e-15) + 4.*a
        if( radius.eq.0. ) then
           ar1 = rdfalt
           radius = 10.**ar1
        endif
        chRSpec(nqh) = 'SQCM'
*
      else if( lgMatch( 'DILU' , chCard ) ) then
*       number is dilution factor, if negative then its log
        if( a.lt.0. ) then
          dil = a
        else
          dil = log10( a )
        endif
        if( dil.gt.0. ) write(qq,'('' Is a dilution factor greater'',
     1  '' than one physical?'')')
*       this is LTE energy density
        a = log10(slope(nspec))
        rlogl = log10( 2.99792e10 * 7.56464e-15) + 4.*a
*       add on dilution factor
        rlogl = rlogl + dil
*
        if( radius.eq.0. ) then
           ar1 = rdfalt
           radius = 10.**ar1
        endif
        chRSpec(nqh) = 'SQCM'
*
      else
        write(qq,'('' I dont understand what the second number ''
     1  ,''was- keywords are LUMINOSITY, RADIUS, DILUTION, and '',
     2  ''DENSITY.'')')
        stop
      endif
*
      range(nqh,1) = emm
      range(nqh,2) = egamry
      totpow(nqh) = rlogl
*
      end
      block data LineData
      implicit none
*block data with atomic data for all level 1 lines
*
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
*
*     Kirk went over all the level 1 line 96 Feb 7, updated to
*     be parallel to Dima's data
*
*     ipLnWlAng REALLY is wl in angstroms, 1micron = 1e4 ang
*     either a gf or an Aul must be entered.  gf is the
*     preferred value, in which case nothing need be
*     entered for ipLnAul.  If the ipLnAul is given then the
*     cell t(ipLnGu) must be set to zero here.
*
*     a dummy line optical dpeth array
      data TauDummy(ipLnWlAng)/0./,TauDummy(ipLnGl)/0./,
     1  TauDummy(ipLnGu)/0./, TauDummy(ipLnGF)/0./,
     2  TauDummy(ipLnEnrWN)/0./ ,TauDummy(ipLnIonStg)/0./,
     2  TauDummy(ipLnNelem)/0./ TauDummy(ipLnRedis)/0./,
     1  TauDummy(ipLnAul)/0./
*
*     carbon line optical depth data
*     arrays all explained above, where commons first occur
      data t1656(ipLnWlAng)/1656./,t1656(ipLnGl)/9./,
     1  t1656(ipLnGu)/9./, t1656(ipLnGF)/1.332/,
     2  t1656(ipLnEnrWN)/60343./ ,t1656(ipLnIonStg)/1./ ,
     3  t1656(ipLnNelem)/6./ , t1656(ipLnRedis)/1./
*
      data t9830(ipLnWlAng)/9830./,t9830(ipLnGl)/9./,
     1  t9830(ipLnGu)/5./ , t9830(ipLnGF)/2.36e-11/,
     2  t9830(ipLnEnrWN)/10159./,t9830(ipLnIonStg)/1./,
     3  t9830(ipLnNelem)/6./ , t9830(ipLnRedis)/1./
*
      data t8727(ipLnWlAng)/8727./, t8727(ipLnGl)/5./,
     1  t8727(ipLnGu)/1./, t8727(ipLnGF)/6.05e-9/,
     2  t8727(ipLnEnrWN)/11454.7/, t8727(ipLnIonStg)/1./,
     3  t8727(ipLnNelem)/6./ , t8727(ipLnRedis)/1./
*
      data t2326(ipLnWlAng)/2326./, t2326(ipLnGl)/6./,
     1  t2326(ipLnGu)/12./, t2326(ipLnGF)/5.56e-7/,
     2  t2326(ipLnEnrWN)/42990./,t2326(ipLnIonStg)/2./,
     3  t2326(ipLnNelem)/6./ , t2326(ipLnRedis)/1./
*
      data t1335(ipLnWlAng)/1335./,t1335(ipLnGl)/6./,
     1  t1335(ipLnGu)/10./, t1335(ipLnGF)/0.75/,
     2  t1335(ipLnEnrWN)/74889./,t1335(ipLnIonStg)/2./,
     3  t1335(ipLnNelem)/6./, t1335(ipLnRedis)/1./
*
*     A's
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
      data t1909(ipLnWlAng)/1910./,t1909(ipLnGl)/1./,
     1  t1909(ipLnGu)/3./, t1909(ipLnGF)/0./,
     2  t1909(ipLnEnrWN)/52338./,t1909(ipLnIonStg)/3./,
     3  t1909(ipLnNelem)/6./, t1909(ipLnRedis)/1./,
     1  t1909(ipLnAul)/103.8/
*
      data t977(ipLnWlAng)/977./,t977(ipLnGl)/1./,
     1  t977(ipLnGu)/3./,t977(ipLnGF)/0.767/,
     1  t977(ipLnEnrWN)/102351./ ,t977(ipLnIonStg)/3./,
     2  t977(ipLnNelem)/6./, t977(ipLnRedis)/1./
*
      data t1550(ipLnWlAng)/1551./ ,t1550(ipLnGl)/2./,
     1  t1550(ipLnGu)/2./, t1550(ipLnGF)/0.1904/,
     2  t1550(ipLnEnrWN)/64484./ ,t1550(ipLnIonStg)/4./,
     3  t1550(ipLnNelem)/6./, t1550(ipLnRedis)/1./
*
      data t1548(ipLnWlAng)/1548./ ,t1548(ipLnGl)/2./,
     1  t1548(ipLnGu)/4./, t1548(ipLnGF)/0.380/,
     2  t1548(ipLnEnrWN)/64591./ ,t1548(ipLnIonStg)/4./,
     3  t1548(ipLnNelem)/6./, t1548(ipLnRedis)/1./
*
      data t386(ipLnWlAng)/386./,t386(ipLnGl)/1./,
     1  t386(ipLnGu)/3./, t386(ipLnGF)/0.232/,
     2  t386(ipLnEnrWN)/258931./,t386(ipLnIonStg)/3./,
     3  t386(ipLnNelem)/6./, t386(ipLnRedis)/1./
*
      data t310(ipLnWlAng)/310./,t310(ipLnGl)/1./,
     1  t310(ipLnGu)/3./, t310(ipLnGF)/0.0284/,
     1  t310(ipLnEnrWN)/322402.8/,t310(ipLnIonStg)/3./,
     3  t310(ipLnNelem)/6./, t310(ipLnRedis)/1./
*
*     CIII* 1175, lower level = upper level of 1909
      data c31175(ipLnWlAng)/1176./,c31175(ipLnGl)/9./,
     1  c31175(ipLnGu)/9./, c31175(ipLnGF)/0./,
     2  c31175(ipLnEnrWN)/85055.71/,c31175(ipLnIonStg)/3./,
     3  c31175(ipLnNelem)/6./, c31175(ipLnRedis)/1./,
     1  c31175(ipLnAul)/1.33e9/
*
      data t291(ipLnWlAng)/291./,t291(ipLnGl)/1./,
     1  t291(ipLnGu)/3./, t291(ipLnGF)/0.045/,
     1  t291(ipLnEnrWN)/343258./,t291(ipLnIonStg)/3./,
     3  t291(ipLnNelem)/6./, t291(ipLnRedis)/1./
*
      data t280(ipLnWlAng)/280./,t280(ipLnGl)/1./,
     1  t280(ipLnGu)/3./, t280(ipLnGF)/0.016/,
     2  t280(ipLnEnrWN)/357092./,t280(ipLnIonStg)/3./,
     3  t280(ipLnNelem)/6./, t280(ipLnRedis)/1./
*
      data t274(ipLnWlAng)/274./,t274(ipLnGl)/1./,
     1  t274(ipLnGu)/3./, t274(ipLnGF)/0.011/,
     2  t274(ipLnEnrWN)/364896.9/,t274(ipLnIonStg)/3./,
     3  t274(ipLnNelem)/6./, t274(ipLnRedis)/1./
*
      data t270(ipLnWlAng)/270./,t270(ipLnGl)/1./,
     1  t270(ipLnGu)/3./, t270(ipLnGF)/0.0077/,
     2  t270(ipLnEnrWN)/369931.9/,t270(ipLnIonStg)/3./,
     3  t270(ipLnNelem)/6./, t270(ipLnRedis)/1./
*
      data t312(ipLnWlAng)/312./,t312(ipLnGl)/2./,
     1  t312(ipLnGu)/6./, t312(ipLnGF)/0.4056/,
     2  t312(ipLnEnrWN)/320071./,t312(ipLnIonStg)/4./ ,
     3  t312(ipLnNelem)/6./, t312(ipLnRedis)/1./
*
*     carbon fine structure lines added by Jim Kingdon
      data t610(ipLnWlAng)/6.094e6/,t610(ipLnGl)/1./,
     1  t610(ipLnGu)/3./, t610(ipLnGF)/1.33e-9/,
     2  t610(ipLnEnrWN)/16.41/ ,t610(ipLnIonStg)/1./ ,
     3  t610(ipLnNelem)/6./, t610(ipLnRedis)/-1./
*
      data t370(ipLnWlAng)/3.697e6/,t370(ipLnGl)/3./,
     1  t370(ipLnGu)/5./, t370(ipLnGF)/2.75e-9/,
     2  t370(ipLnEnrWN)/27.05/ ,t370(ipLnIonStg)/1./ ,
     3  t370(ipLnNelem)/6./, t370(ipLnRedis)/-1./
*
      data t157(ipLnWlAng)/1.57e6/,t157(ipLnGl)/2./,
     1  t157(ipLnGu)/4./, t157(ipLnGF)/3.33e-9/,
     2  t157(ipLnEnrWN)/63.42/ ,t157(ipLnIonStg)/2./ ,
     3  t157(ipLnNelem)/6./, t157(ipLnRedis)/-1./
*
*     nitrogen line optical depth data
      data t1085(ipLnWlAng)/1085./ ,t1085(ipLnGl)/9./,
     1  t1085(ipLnGu)/15./, t1085(ipLnGF)/0.981/,
     2  t1085(ipLnEnrWN)/92155.7/ ,t1085(ipLnIonStg)/2./,
     3  t1085(ipLnNelem)/7./, t1085(ipLnRedis)/1./
*
*     ref A
*     >>refer Brage, T., Froese-Fischer, C., Judge, P.G. 1995,
*     >>refer ApJ 445, 457
      data t1750(ipLnWlAng)/1750./ ,t1750(ipLnGl)/6./,
     1  t1750(ipLnGu)/12./, t1750(ipLnGF)/0./,
     2  t1750(ipLnEnrWN)/57129./ ,t1750(ipLnIonStg)/3./,
     3  t1750(ipLnNelem)/7./, t1750(ipLnRedis)/1./ ,
     4  t1750(ipLnAul)/288./
*
      data t990(ipLnWlAng)/990./ ,t990(ipLnGl)/6./,
     1  t990(ipLnGu)/10./, t990(ipLnGF)/0.732/,
     2  t990(ipLnEnrWN)/100910.7/ ,t990(ipLnIonStg)/3./,
     3  t990(ipLnNelem)/7./, t990(ipLnRedis)/1./
*
*     A
*     >>refer Fleming, J., Brage, T., Bell, K.L., Vaeck, N.,
*     >>refer Hibbert, A., Godefroid, M.R., Froese-Fischer, C. 1995, ApJ,
*     >>refer 455, 758
*     >>refer Froese Fischer, C. 1995, ApJ 455, 758
      data t1486(ipLnWlAng)/1488./ ,t1486(ipLnGl)/1./,
     1  t1486(ipLnGu)/3./,t1486(ipLnGF)/0./,
     2  t1486(ipLnEnrWN)/67273./ ,t1486(ipLnIonStg)/4./,
     3  t1486(ipLnNelem)/7./, t1486(ipLnRedis)/1./,
     1  t1486(ipLnAul)/580./
*
      data t765(ipLnWlAng)/765./ ,t765(ipLnGl)/1./,
     1  t765(ipLnGu)/3./, t765(ipLnGF)/0.616/,
     2  t765(ipLnEnrWN)/130695./ ,t765(ipLnIonStg)/4./,
     3  t765(ipLnNelem)/7./, t765(ipLnRedis)/1./
*
      data t1243(ipLnWlAng)/1243./ ,t1243(ipLnGl)/2./,
     1  t1243(ipLnGu)/2./, t1243(ipLnGF)/0.156/,
     2  t1243(ipLnEnrWN)/80464./ ,t1243(ipLnIonStg)/5./,
     3  t1243(ipLnNelem)/7./, t1243(ipLnRedis)/1./
*
      data t1239(ipLnWlAng)/1239./ ,t1239(ipLnGl)/2./,
     1  t1239(ipLnGu)/4./, t1239(ipLnGF)/0.314/,
     2  t1239(ipLnEnrWN)/80722./ ,t1239(ipLnIonStg)/5./,
     3  t1239(ipLnNelem)/7./, t1239(ipLnRedis)/1./
*
      data t374g(ipLnWlAng)/373./ ,t374g(ipLnGl)/2./,
     1  t374g(ipLnGu)/4./, t374g(ipLnGF)/0.882/,
     2  t374g(ipLnEnrWN)/267238.4/ ,t374g(ipLnIonStg)/3./,
     3  t374g(ipLnNelem)/7./, t374g(ipLnRedis)/1./
*
*     this is the stronger of the two lines
      data t374x(ipLnWlAng)/374./ ,t374x(ipLnGl)/4./,
     1  t374x(ipLnGu)/6./, t374x(ipLnGF)/1.588/,
     2  t374x(ipLnEnrWN)/267244.0/ ,t374x(ipLnIonStg)/3./,
     3  t374x(ipLnNelem)/7./, t374x(ipLnRedis)/1./
*
      data t1200(ipLnWlAng)/1200./,t1200(ipLnGl)/4./,
     1  t1200(ipLnGu)/12./, t1200(ipLnGF)/1.3/,
     2  t1200(ipLnEnrWN)/83335.6/,t1200(ipLnIonStg)/1./,
     3  t1200(ipLnNelem)/7./, t1200(ipLnRedis)/1./
*
*     A=180.2 from
*     >>refer Calamai, A.G., & Johnson, C.E., 1991, Phys Rev A,
*     >>refer 44, 218
*     revised to 189.6 from
*     >>refer Brage, T., Hibbert, A., Leckrone, D.S. 1997, ApJ, 478, 423
      data t2140(ipLnWlAng)/2140./,t2140(ipLnGl)/9./,
     1  t2140(ipLnGu)/5./,t2140(ipLnGF)/0./ ,
     2  t2140(ipLnEnrWN)/46700./ ,t2140(ipLnIonStg)/2./,
     3  t2140(ipLnNelem)/7./, t2140(ipLnRedis)/1./ ,
     1  t2140(ipLnAul)/189.6/
*
      data t671(ipLnWlAng)/671./,t671(ipLnGl)/9./,
     1  t671(ipLnGu)/9./, t671(ipLnGF)/0.69/,
     2  t671(ipLnEnrWN)/148923.7/,t671(ipLnIonStg)/2./,
     3  t671(ipLnNelem)/7./ , t671(ipLnRedis)/1./
*
      data t315(ipLnWlAng)/315./ ,t315(ipLnGl)/6./,
     1  t315(ipLnGu)/10./,t315(ipLnGF)/1.1686/,
     2  t315(ipLnEnrWN)/317401/ ,t315(ipLnIonStg)/3./,
     3  t315(ipLnNelem)/7./, t315(ipLnRedis)/1./
*
      data t324(ipLnWlAng)/324./ ,t324(ipLnGl)/6./,
     1  t324(ipLnGu)/6./,t324(ipLnGF)/0.3129/,
     2  t324(ipLnEnrWN)/308805/ ,t324(ipLnIonStg)/3./,
     3  t324(ipLnNelem)/7./, t324(ipLnRedis)/1./
*
      data t333(ipLnWlAng)/333./ ,t333(ipLnGl)/6./,
     1  t333(ipLnGu)/2./,t333(ipLnGF)/0.0369/,
     2  t333(ipLnEnrWN)/300735/ ,t333(ipLnIonStg)/3./,
     3  t333(ipLnNelem)/7./, t333(ipLnRedis)/1./
*
      data t209(ipLnWlAng)/209./ ,t209(ipLnGl)/2./,
     1  t209(ipLnGu)/6./, t209(ipLnGF)/0.477/,
     2  t209(ipLnEnrWN)/477817./ ,t209(ipLnIonStg)/5./,
     3  t209(ipLnNelem)/7./, t209(ipLnRedis)/1./
*
*     fine structure lines
*     [N II] 121.8
      data t122(ipLnWlAng)/1.218e6/ ,t122(ipLnGl)/3./,
     1  t122(ipLnGu)/5./, t122(ipLnGF)/0./,
     2  t122(ipLnEnrWN)/82.13/ ,t122(ipLnIonStg)/2./,
     3  t122(ipLnNelem)/7./, t122(ipLnRedis)/-1./,
     4  t122(ipLnAul)/7.40e-6/
*
*     [N II] 205.5
      data t205(ipLnWlAng)/2.055e6/ ,t205(ipLnGl)/1./,
     1  t205(ipLnGu)/3./, t205(ipLnGF)/3.93e-9/,
     2  t205(ipLnEnrWN)/48.67/ ,t205(ipLnIonStg)/2./,
     3  t205(ipLnNelem)/7./, t205(ipLnRedis)/-1./,
     4  t205(ipLnAul)/2.07e-6/
*
*     big disagreement in A for this line, other val is 2x larger
*     see review in DEO Seaton 70th birthday
      data t57(ipLnWlAng)/5.7e5/ ,t57(ipLnGl)/2./,
     1  t57(ipLnGu)/4./, t57(ipLnGF)/9.35e-9/,
     2  t57(ipLnEnrWN)/174.76/ ,t57(ipLnIonStg)/3./,
     3  t57(ipLnNelem)/7./, t57(ipLnRedis)/-1./
*
*     oxygen line optical depth data
*     [OI] A's from
*     >>refer Baluja, K.L., & Zeippen, C.J. 1988, J Phys B 21, 1455
      data t6300(ipLnWlAng)/6300./,t6300(ipLnGl)/5./,
     1  t6300(ipLnGu)/5./, t6300(ipLnGF)/0./,
     2  t6300(ipLnEnrWN)/15867./,t6300(ipLnIonStg)/1./,
     3  t6300(ipLnNelem)/8./, t6300(ipLnRedis)/1./,
     4  t6300(ipLnAul)/5.65e-3/
*
      data t6363(ipLnWlAng)/6363./,t6363(ipLnGl)/3./,
     1  t6363(ipLnGu)/5./, t6363(ipLnGF)/0./,
     2  t6363(ipLnEnrWN)/15709./,t6363(ipLnIonStg)/1./,
     3  t6363(ipLnNelem)/8./, t6363(ipLnRedis)/1./,
     4  t6363(ipLnAul)/1.82e-3/
*
*     A from NISt 96
      data t5577(ipLnWlAng)/5577./ ,t5577(ipLnGl)/5./,
     1  t5577(ipLnGu)/1./, t5577(ipLnGF)/0./,
     2  t5577(ipLnEnrWN)/17924.7/ ,t5577(ipLnIonStg)/1./,
     3  t5577(ipLnNelem)/8./, t5577(ipLnRedis)/1./ ,
     4  t5577(ipLnAul)/1.26/
*
      data t834(ipLnWlAng)/834./ ,t834(ipLnGl)/4./,
     1  t834(ipLnGu)/12./, t834(ipLnGF)/1.064/,
     2  t834(ipLnEnrWN)/119932.56/ ,t834(ipLnIonStg)/2./,
     3  t834(ipLnNelem)/8./, t834(ipLnRedis)/1./
*
*     split into doublet by KtK 3/95; gf from
*     >>refer Nussbaumer, H., & Storey, P. J. 1981, AA, 99, 177
      data t1661(ipLnWlAng)/1661./ ,t1661(ipLnGl)/3./,
     1  t1661(ipLnGu)/5./,t1661(ipLnGF)/4.38e-7/ ,
     2  t1661(ipLnEnrWN)/60211.8/ ,t1661(ipLnIonStg)/3./,
     3  t1661(ipLnNelem)/8./,  t1661(ipLnRedis)/1./
*
      data t1666(ipLnWlAng)/1666./ ,t1666(ipLnGl)/5./,
     1  t1666(ipLnGu)/5./,t1666(ipLnGF)/1.09e-6/ ,
     2  t1666(ipLnEnrWN)/60018.4/ ,t1666(ipLnIonStg)/3./,
     3  t1666(ipLnNelem)/8./, t1666(ipLnRedis)/1./
*
      data t835(ipLnWlAng)/835./,t835(ipLnGl)/9./,
     1  t835(ipLnGu)/15./, t835(ipLnGF)/0.963/,
     2  t835(ipLnEnrWN)/119833./,t835(ipLnIonStg)/3./,
     3  t835(ipLnNelem)/8./, t835(ipLnRedis)/1./
*
*     A from NISt 96, A from
*     >>refer Brage, T., Judge, P.G., & Brekke, P., 1996, ApJ 464, 1030
      data t1402(ipLnWlAng)/1402./,t1402(ipLnGl)/6./,
     1  t1402(ipLnGu)/12./,t1402(ipLnGF)/0./ ,
     2  t1402(ipLnEnrWN)/71500./,t1402(ipLnIonStg)/4./,
     3  t1402(ipLnNelem)/8./, t1402(ipLnRedis)/1./ ,
     4  t1402(ipLnAul)/ 1179./
*
*     split into quintuplet by KtK 3/95
*     gf from
*     >>refer Merkelis, G., Vilkas, M.J., Gaigalas, G., & Kisielius, R. 1994,
*     >>refer priviate communication
*     via Pradhan & Preng (1994 Seaton and Osterbrock Emission Line meeting
*     at StScI 5/94)
*     data tO1400(ipLnWlAng)/1400./,tO1400(ipLnGl)/2./,
*    1  tO1400(ipLnGu)/2./,tO1400(ipLnGF)/1.06E-06/ ,
*    2  tO1400(ipLnEnrWN)/71439.8/,tO1400(ipLnIonStg)/4./,
*    3  tO1400(ipLnNelem)/8./, tO1400(ipLnRedis)/1./
* 666 error! replace first entry with these five
*     data tO1397(ipLnWlAng)/1397./,tO1397(ipLnGl)/2./,
*    1  tO1397(ipLnGu)/4./,tO1397(ipLnGF)/2.67e-8/
*    2  tO1397(ipLnEnrWN)/71570.1/,tO1397(ipLnIonStg)/4./,
*    3  tO1397(ipLnNelem)/8./, tO1397(ipLnRedis)/1./
*
*    data tO1407(ipLnWlAng)/1407./,tO1407(ipLnGl)/4./,
*    1  tO1407(ipLnGu)/2./,tO1407(ipLnGF)/1.05e-6/,
*    2  tO1407(ipLnEnrWN)/71053.9/,tO1407(ipLnIonStg)/4./,
*    3  tO1407(ipLnNelem)/8./, tO1407(ipLnRedis)/1./
*
*    data tO1405(ipLnWlAng)/1405./,tO1405(ipLnGl)/4./,
*    1  tO1405(ipLnGu)/4./,tO1405(ipLnGF)/3.88e-7/,
*    2  tO1405(ipLnEnrWN)/71184.2/,tO1405(ipLnIonStg)/4./,
*    3  tO1405(ipLnNelem)/8./, tO1405(ipLnRedis)/1./
*
*    data tO1401(ipLnWlAng)/1401./,tO1401(ipLnGl)/4./,
*    1  tO1401(ipLnGu)/6./,tO1401(ipLnGF)/1.84e-6/ ,
*    2  tO1401(ipLnEnrWN)/71369.6/,tO1401(ipLnIonStg)/4./,
*    3  tO1401(ipLnNelem)/8./, tO1401(ipLnRedis)/1./
*
      data t789(ipLnWlAng)/789./ ,t789(ipLnGl)/6./,
     1  t789(ipLnGu)/10./, t789(ipLnGF)/0.66/,
     2  t789(ipLnEnrWN)/126684.3/ ,t789(ipLnIonStg)/4./,
     3  t789(ipLnNelem)/8./, t789(ipLnRedis)/1./
*
      data t630(ipLnWlAng)/630./ ,t630(ipLnGl)/1./,
     1  t630(ipLnGu)/3./, t630(ipLnGF)/0.515/,
     2  t630(ipLnEnrWN)/158798./ ,t630(ipLnIonStg)/5./,
     3  t630(ipLnNelem)/8./, t630(ipLnRedis)/1./
*
*     6 level model OI atom, with Ly beta pump
*     gf's from tOPBASE, Dima Verner, 96 Feb 6
      data t1304(ipLnWlAng)/1304./,t1304(ipLnGl)/9./,
     1  t1304(ipLnGu)/3./, t1304(ipLnGF)/0.45/ ,
     2  t1304(ipLnEnrWN)/76716./,t1304(ipLnIonStg)/1./,
     3  t1304(ipLnNelem)/8./ , t1304(ipLnRedis)/1./
*
      data t1039(ipLnWlAng)/1039./,t1039(ipLnGl)/9./,
     1  t1039(ipLnGu)/3./, t1039(ipLnGF)/0.0813/,
     2  t1039(ipLnEnrWN)/96147.1/,t1039(ipLnIonStg)/1./,
     3  t1039(ipLnNelem)/8./, t1039(ipLnRedis)/1./
*
      data t8446(ipLnWlAng)/8446./,t8446(ipLnGl)/3./,
     1  t8446(ipLnGu)/9./, t8446(ipLnGF)/3.27/,
     2  t8446(ipLnEnrWN)/11836./,t8446(ipLnIonStg)/1./,
     3  t8446(ipLnNelem)/8./, t8446(ipLnRedis)/1./
*
      data t4368(ipLnWlAng)/4368./,t4368(ipLnGl)/3./,
     1  t4368(ipLnGu)/9./, t4368(ipLnGF)/0.0237/ ,
     2  t4368(ipLnEnrWN)/22885./,t4368(ipLnIonStg)/1./,
     3  t4368(ipLnNelem)/8./, t4368(ipLnRedis)/1./
*
      data tOI13(ipLnWlAng)/13200./,tOI13(ipLnGl)/9./,
     1  tOI13(ipLnGu)/3./,tOI13(ipLnGF)/1.69/ ,
     2  tOI13(ipLnEnrWN)/7596.5/,tOI13(ipLnIonStg)/1./,
     3  tOI13(ipLnNelem)/8./, tOI13(ipLnRedis)/1./
*
      data tOI11(ipLnWlAng)/11300./,tOI11(ipLnGl)/9./,
     1  tOI11(ipLnGu)/15./,tOI11(ipLnGF)/8.93/ ,
     2  tOI11(ipLnEnrWN)/8847./,tOI11(ipLnIonStg)/1./,
     3  tOI11(ipLnNelem)/8./, tOI11(ipLnRedis)/1./
*
      data tOI29(ipLnWlAng)/29000./,tOI29(ipLnGl)/3./,
     1  tOI29(ipLnGu)/9./,tOI29(ipLnGF)/4.51/ ,
     2  tOI29(ipLnEnrWN)/3454.9/,tOI29(ipLnIonStg)/1./,
     3  tOI29(ipLnNelem)/8./, tOI29(ipLnRedis)/1./
*
      data tOI46(ipLnWlAng)/46000./ ,tOI46(ipLnGl)/15./,
     1  tOI46(ipLnGu)/9./, tOI46(ipLnGF)/2.63/,
     2  tOI46(ipLnEnrWN)/2192.26/ ,tOI46(ipLnIonStg)/1./,
     3  tOI46(ipLnNelem)/8./ , tOI46(ipLnRedis)/1./
*
      data tO1025(ipLnWlAng)/1025./,tO1025(ipLnGl)/9./,
     1  tO1025(ipLnGu)/15./, tO1025(ipLnGF)/0.169/,
     2  tO1025(ipLnEnrWN)/97410.5/,tO1025(ipLnIonStg)/1./,
     3  tO1025(ipLnNelem)/8./, tO1025(ipLnRedis)/1./
*
*     end of OI 6 level atom
*
      data t304(ipLnWlAng)/304./,t304(ipLnGl)/9./,
     1  t304(ipLnGu)/9./, t304(ipLnGF)/4.23/,
     2  t304(ipLnEnrWN)/327095.2/,t304(ipLnIonStg)/3./,
     3  t304(ipLnNelem)/8./, t304(ipLnRedis)/1./
*
*     gf from
*     >>refer Allard, N., Artru, M.-C., Lanz, T., & Le Dournef, M. 1990,
*     >>refer A&AS, 84, 563
*     A's
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
      data t1214(ipLnWlAng)/1218./,t1214(ipLnGl)/1./,
     1  t1214(ipLnGu)/3./,t1214(ipLnGF)/0./ ,
     2  t1214(ipLnEnrWN)/82280./,t1214(ipLnIonStg)/5./,
     3  t1214(ipLnNelem)/8./, t1214(ipLnRedis)/1./,
     1  t1214(ipLnAul)/2280.2/
*
      data t150(ipLnWlAng)/150./,t150(ipLnGl)/2./,
     1  t150(ipLnGu)/6./, t150(ipLnGF)/0.5308/,
     2  t150(ipLnEnrWN)/666218./,t150(ipLnIonStg)/6./,
     3  t150(ipLnNelem)/8./, t150(ipLnRedis)/1./
*
*     fine structure lines
*     [O I] 146 microns
      data t146(ipLnWlAng)/1.4553e6/,t146(ipLnGl)/3./,
     1  t146(ipLnGu)/1./, t146(ipLnGF)/0.00/,
     2  t146(ipLnEnrWN)/68.712/,t146(ipLnIonStg)/1./,
     3  t146(ipLnNelem)/8./, t146(ipLnRedis)/-1./,
     4  t146(ipLnAul)/1.75e-5/
*
*     [O I] 63 microns
      data t63(ipLnWlAng)/6.3185e5/,t63(ipLnGl)/5./,
     1  t63(ipLnGu)/3./, t63(ipLnGF)/0.00/,
     2  t63(ipLnEnrWN)/158.265/,t63(ipLnIonStg)/1./,
     3  t63(ipLnNelem)/8./, t63(ipLnRedis)/-1./,
     4  t63(ipLnAul)/8.91e-5/
*
*     [O III] 88.3564 m
      data tO88(ipLnWlAng)/8.8356e5/,tO88(ipLnGl)/1./,
     1  tO88(ipLnGu)/3./, tO88(ipLnGF)/9.12e-9/,
     2  tO88(ipLnEnrWN)/113.178/,tO88(ipLnIonStg)/3./,
     3  tO88(ipLnNelem)/8./, tO88(ipLnRedis)/-1./
*
*     [O III] 51.8145
      data t52(ipLnWlAng)/5.1814e5/,t52(ipLnGl)/3./,
     1  t52(ipLnGu)/5./, t52(ipLnGF)/1.95e-8/,
     2  t52(ipLnEnrWN)/192.996/,t52(ipLnIonStg)/3./,
     3  t52(ipLnNelem)/8./, t52(ipLnRedis)/-1./
*
*     [O IV] 25.89mic, A from
*     >>refer Brage, T., Judge, P.G., & Brekke, P., 1996, ApJ 464, 1030
      data t26(ipLnWlAng)/2.589e5/,t26(ipLnGl)/2./,
     1  t26(ipLnGu)/4./, t26(ipLnGF)/0.00/,
     2  t26(ipLnEnrWN)/386.25/,t26(ipLnIonStg)/4./,
     3  t26(ipLnNelem)/8./, t26(ipLnRedis)/-1./ ,
     4  t26(ipLnAul)/5.19e-4/
*
      data t1032(ipLnWlAng)/1032./,t1032(ipLnGl)/2./,
     1  t1032(ipLnGu)/4./, t1032(ipLnGF)/0.266/,
     2  t1032(ipLnEnrWN)/96906.2/,t1032(ipLnIonStg)/6./,
     3  t1032(ipLnNelem)/8./, t1032(ipLnRedis)/1./
*
      data t1037(ipLnWlAng)/1037./,t1037(ipLnGl)/2./,
     1  t1037(ipLnGu)/2./, t1037(ipLnGF)/0.1322/,
     2  t1037(ipLnEnrWN)/96374.7/,t1037(ipLnIonStg)/6./,
     3  t1037(ipLnNelem)/8./, t1037(ipLnRedis)/1./
*
*     fluorine
*     f ii 29.33 mic
      data F0229(ipLnWlAng)/29.33e4/,F0229(ipLnGl)/5./,
     1  F0229(ipLnGu)/3./, F0229(ipLnGF)/0./,
     2  F0229(ipLnEnrWN)/340.9/,F0229(ipLnIonStg)/2./,
     3  F0229(ipLnNelem)/9./, F0229(ipLnRedis)/-1./,
     4  F0229(ipLnAul)/8.912e-4/
*
*     f ii 67.2 mic
      data F0267(ipLnWlAng)/67.2e4/,F0267(ipLnGl)/3./,
     1  F0267(ipLnGu)/1./, F0267(ipLnGF)/0./,
     2  F0267(ipLnEnrWN)/148.8/,F0267(ipLnIonStg)/2./,
     3  F0267(ipLnNelem)/9./, F0267(ipLnRedis)/-1./,
     4  F0267(ipLnAul)/1.784e-4/
*
*     f iv 44.07 mic
      data F444(ipLnWlAng)/44.07e4/,F444(ipLnGl)/1./,
     1  F444(ipLnGu)/3./, F444(ipLnGF)/0./,
     2  F444(ipLnEnrWN)/226.9/,F444(ipLnIonStg)/4./,
     3  F444(ipLnNelem)/9./, F444(ipLnRedis)/-1./,
     4  F444(ipLnAul)/2.10e-4/
*
*     f iv 25.83 mic
      data F425(ipLnWlAng)/25.83e4/,F425(ipLnGl)/3./,
     1  F425(ipLnGu)/5./, F425(ipLnGF)/0./,
     2  F425(ipLnEnrWN)/387.14/,F425(ipLnIonStg)/4./,
     3  F425(ipLnNelem)/9./, F425(ipLnRedis)/-1./,
     4  F425(ipLnAul)/7.82e-4/
*
*     neon
      data t770(ipLnWlAng)/770./ ,t770(ipLnGl)/2./,
     1  t770(ipLnGu)/4./, t770(ipLnGF)/.206/,
     2  t770(ipLnEnrWN)/129802./ ,t770(ipLnIonStg)/8./,
     3  t770(ipLnNelem)/10./, t770(ipLnRedis)/1./
*
      data t780(ipLnWlAng)/780./ ,t780(ipLnGl)/2./,
     1  t780(ipLnGu)/2./, t780(ipLnGF)/.101/,
     2  t780(ipLnEnrWN)/128151.9/ ,t780(ipLnIonStg)/8./,
     3  t780(ipLnNelem)/10./, t780(ipLnRedis)/1./
*
*     [Ne VI] 7.652 micron
      data xNe0676(ipLnWlAng)/7.652e4/,xNe0676(ipLnGl)/2./,
     1  xNe0676(ipLnGu)/4./, xNe0676(ipLnGF)/0./,
     2  xNe0676(ipLnEnrWN)/1306.78/,xNe0676(ipLnIonStg)/6./,
     3  xNe0676(ipLnNelem)/10./, xNe0676(ipLnRedis)/-1./,
     4  xNe0676(ipLnAul)/1.9e-2/
*
*     A's
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
      data t895(ipLnWlAng)/895./ ,t895(ipLnGl)/1./,
     1  t895(ipLnGu)/3./, t895(ipLnGF)/0./,
     2  t895(ipLnEnrWN)/111732./ ,t895(ipLnIonStg)/7./,
     3  t895(ipLnNelem)/10./, t895(ipLnRedis)/1./,
     1  t895(ipLnAul)/19204.4/
*
      data t88(ipLnWlAng)/88./ ,t88(ipLnGl)/2./,
     1  t88(ipLnGu)/6./, t88(ipLnGF)/.602/,
     2  t88(ipLnEnrWN)/1135177./ ,t88(ipLnIonStg)/8./,
     3  t88(ipLnNelem)/10./, t88(ipLnRedis)/1./
*
*     fine structure lines
*     [Ne II] 12.8
      data tNe13(ipLnWlAng)/1.28e5/,tNe13(ipLnGl)/4./,
     1  tNe13(ipLnGu)/2./, tNe13(ipLnGF)/0./,
     2  tNe13(ipLnEnrWN)/780.34/,tNe13(ipLnIonStg)/2./,
     3  tNe13(ipLnNelem)/10./, tNe13(ipLnRedis)/-1./,
     4  tNe13(ipLnAul)/8.55e-3/
*
*     [Ne III] 36.013 m
      data tNe36(ipLnWlAng)/3.6014e5/,tNe36(ipLnGl)/3./,
     1  tNe36(ipLnGu)/1./, tNe36(ipLnGF)/2.23e-8/,
     2  tNe36(ipLnEnrWN)/277.674/,tNe36(ipLnIonStg)/3./,
     3  tNe36(ipLnNelem)/10./, tNe36(ipLnRedis)/-1./
*
*     [Ne III] 15.56 m
      data tNe16(ipLnWlAng)/1.56e5/,tNe16(ipLnGl)/5./,
     1  tNe16(ipLnGu)/3./, tNe16(ipLnGF)/6.49e-8/,
     2  tNe16(ipLnEnrWN)/642.88/,tNe16(ipLnIonStg)/3./,
     3  tNe16(ipLnNelem)/10./, tNe16(ipLnRedis)/-1./
*
*     [Ne V] 14.32 m
      data tNe14(ipLnWlAng)/1.432e5/,tNe14(ipLnGl)/3./,
     1  tNe14(ipLnGu)/5./, tNe14(ipLnGF)/6.65e-8/,
     2  tNe14(ipLnEnrWN)/698.24/,tNe14(ipLnIonStg)/5./,
     3  tNe14(ipLnNelem)/10./, tNe14(ipLnRedis)/-1./
*
*     [Ne V] 24.318 m
      data tNe24(ipLnWlAng)/2.4318e5/,tNe24(ipLnGl)/1./,
     1  tNe24(ipLnGu)/3./, tNe24(ipLnGF)/3.12e-8/,
     2  tNe24(ipLnEnrWN)/411.226/,tNe24(ipLnIonStg)/5./,
     3  tNe24(ipLnNelem)/10./, tNe24(ipLnRedis)/-1./
*
*     sodium line optical depth data
      data t5895(ipLnWlAng)/5895./,t5895(ipLnGl)/2./,
     1  t5895(ipLnGu)/6./, t5895(ipLnGF)/1.94/,
     2  t5895(ipLnEnrWN)/16967.646/,t5895(ipLnIonStg)/1./,
     3  t5895(ipLnNelem)/11./, t5895(ipLnRedis)/1./
*
*     [Na III] 7.3177mic
      data fsNa373(ipLnWlAng)/7.32e4/,fsNa373(ipLnGl)/4./,
     1  fsNa373(ipLnGu)/2./, fsNa373(ipLnGF)/0./,
     2  fsNa373(ipLnEnrWN)/1366.54/,fsNa373(ipLnIonStg)/3./,
     3  fsNa373(ipLnNelem)/11./, fsNa373(ipLnRedis)/-1./,
     4  fsNa373(ipLnAul)/4.59e-2/
*
*     [Na IV] 9.039 mic
      data fsNa490(ipLnWlAng)/9.039e4/,fsNa490(ipLnGl)/5./,
     1  fsNa490(ipLnGu)/3./, fsNa490(ipLnGF)/0./,
     2  fsNa490(ipLnEnrWN)/1106.3/,fsNa490(ipLnIonStg)/4./,
     3  fsNa490(ipLnNelem)/11./, fsNa490(ipLnRedis)/-1./,
     4  fsNa490(ipLnAul)/2.91e-2/
*
*     [Na IV] 21.29 mic
      data fsNa421(ipLnWlAng)/2.129e5/,fsNa421(ipLnGl)/3./,
     1  fsNa421(ipLnGu)/1./, fsNa421(ipLnGF)/0./,
     2  fsNa421(ipLnEnrWN)/ 469.7/,fsNa421(ipLnIonStg)/4./,
     3  fsNa421(ipLnNelem)/11./, fsNa421(ipLnRedis)/-1./,
     4  fsNa421(ipLnAul)/5.31e-3/
*
*     [Na VI] 14.40 mic
      data xNa6143(ipLnWlAng)/1.44e5/,xNa6143(ipLnGl)/1./,
     1  xNa6143(ipLnGu)/3./, xNa6143(ipLnGF)/0./,
     2  xNa6143(ipLnEnrWN)/ 694.62/,xNa6143(ipLnIonStg)/6./,
     3  xNa6143(ipLnNelem)/11./, xNa6143(ipLnRedis)/-1./,
     4  xNa6143(ipLnAul)/6.14e-3/
*
*     [Na VI] 8.611 mic
      data xNa6862(ipLnWlAng)/8.611e4/,xNa6862(ipLnGl)/3./,
     1  xNa6862(ipLnGu)/5./, xNa6862(ipLnGF)/0./,
     2  xNa6862(ipLnEnrWN)/1161.36/,xNa6862(ipLnIonStg)/6./,
     3  xNa6862(ipLnNelem)/11./, xNa6862(ipLnRedis)/-1./,
     4  xNa6862(ipLnAul)/2.11e-2/
*
*     [Na VII] 4.68 micron
      data xNa0746(ipLnWlAng)/4.68e4/,xNa0746(ipLnGl)/2./,
     1  xNa0746(ipLnGu)/4./, xNa0746(ipLnGF)/0./,
     2  xNa0746(ipLnEnrWN)/2134.60/,xNa0746(ipLnIonStg)/7./,
     3  xNa0746(ipLnNelem)/11./, xNa0746(ipLnRedis)/-1./,
     4  xNa0746(ipLnAul)/.088/
*
*     magnesium line optical depth data
      data MgI2853(ipLnWlAng)/2853./,MgI2853(ipLnGl)/ 1./,
     1  MgI2853(ipLnGu)/ 3./,MgI2853(ipLnGF)/1.73E+00/,
     2  MgI2853(ipLnEnrWN)/35051.264/,MgI2853(ipLnIonStg)/1./,
     3  MgI2853(ipLnNelem)/12./,MgI2853(ipLnRedis)/1./
     4  MgI2853(ipLnAul)/0./
*
      data MgI2026(ipLnWlAng)/2026./,MgI2026(ipLnGl)/ 1./,
     1  MgI2026(ipLnGu)/ 3./,MgI2026(ipLnGF)/1.22E-01/,
     2  MgI2026(ipLnEnrWN)/49346.729/,MgI2026(ipLnIonStg)/1./,
     3  MgI2026(ipLnNelem)/12./,MgI2026(ipLnRedis)/1./
     4  MgI2026(ipLnAul)/0./
*
      data t2796(ipLnWlAng)/2796./ ,t2796(ipLnGl)/2./,
     1  t2796(ipLnGu)/4./, t2796(ipLnGF)/1.258/,
     2  t2796(ipLnEnrWN)/35760.88/ ,t2796(ipLnIonStg)/2./,
     3   t2796(ipLnNelem)/12./, t2796(ipLnRedis)/1./
*
      data t2804(ipLnWlAng)/2804./ ,t2804(ipLnGl)/2./,
     1  t2804(ipLnGu)/2./, t2804(ipLnGF)/0.628/,
     2  t2804(ipLnEnrWN)/35669.304/ ,t2804(ipLnIonStg)/2./,
     3   t2804(ipLnNelem)/12./, t2804(ipLnRedis)/1./
*
*     upper level split into 3, wide energy sep, really should separate out
*     A's
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
*     NB following A is not real A but mult average, with 0 for other line
*     real A is 97242
      data t705(ipLnWlAng)/705./,t705(ipLnGl)/1./,
     1  t705(ipLnGu)/3./, t705(ipLnGF)/1.93e-5/,
     2  t705(ipLnEnrWN)/143192.22/,t705(ipLnIonStg)/9./,
     3  t705(ipLnNelem)/12./, t705(ipLnRedis)/1./,
     4  t705(ipLnAul)/32414./
*
      data t4561(ipLnWlAng)/4561./,t4561(ipLnGl)/1./,
     1  t4561(ipLnGu)/9./,t4561(ipLnGF)/2.05e-6/ ,
     2  t4561(ipLnEnrWN)/21890.816/,t4561(ipLnIonStg)/1./,
     3  t4561(ipLnNelem)/12./, t4561(ipLnRedis)/1./
*
*     [Mg V] 1325, 3-1 in three level atom
      data xMg51325(ipLnWlAng)/1325./,xMg51325(ipLnGl)/9./,
     1  xMg51325(ipLnGu)/1./,xMg51325(ipLnGF)/0./ ,
     2  xMg51325(ipLnEnrWN)/75496./,xMg51325(ipLnIonStg)/5./,
     3  xMg51325(ipLnNelem)/12./, xMg51325(ipLnRedis)/-1./ ,
     4  xMg51325(ipLnAul)/27.9/
*
*     [Mg V] 2417, 3-2 in three level atom
      data xMg52417(ipLnWlAng)/2417./,xMg52417(ipLnGl)/5./,
     1  xMg52417(ipLnGu)/1./,xMg52417(ipLnGF)/0./ ,
     2  xMg52417(ipLnEnrWN)/41353./,xMg52417(ipLnIonStg)/5./,
     3  xMg52417(ipLnNelem)/12./, xMg52417(ipLnRedis)/-1./ ,
     4  xMg52417(ipLnAul)/6.59/
*
*     [Mg V] 2855, 2-1 in three level atom, really 2928, 2782
      data xMg52855(ipLnWlAng)/2855./,xMg52855(ipLnGl)/9./,
     1  xMg52855(ipLnGu)/5./,xMg52855(ipLnGF)/0./ ,
     2  xMg52855(ipLnEnrWN)/34143./,xMg52855(ipLnIonStg)/5./,
     3  xMg52855(ipLnNelem)/12./, xMg52855(ipLnRedis)/-1./ ,
     4  xMg52855(ipLnAul)/2.481/
*
*     [Mg VII] 1325, 3-1 in three level atom
      data xMg71190(ipLnWlAng)/1190./,xMg71190(ipLnGl)/9./,
     1  xMg71190(ipLnGu)/1./,xMg71190(ipLnGF)/0./ ,
     2  xMg71190(ipLnEnrWN)/84046./,xMg71190(ipLnIonStg)/7./,
     3  xMg71190(ipLnNelem)/12./, xMg71190(ipLnRedis)/-1./ ,
     4  xMg71190(ipLnAul)/45.8/
*
*     [Mg VII] 2261, 3-2 in three level atom
      data xMg72261(ipLnWlAng)/2261./,xMg72261(ipLnGl)/5./,
     1  xMg72261(ipLnGu)/1./,xMg72261(ipLnGF)/0./ ,
     2  xMg72261(ipLnEnrWN)/44218./,xMg72261(ipLnIonStg)/7./,
     3  xMg72261(ipLnNelem)/12./, xMg72261(ipLnRedis)/-1./ ,
     4  xMg72261(ipLnAul)/6.61/
*
*     [Mg VII] 2569, 2-1 in three level atom, really 2509, 2629
      data xMg72569(ipLnWlAng)/2569./,xMg72569(ipLnGl)/9./,
     1  xMg72569(ipLnGu)/5./,xMg72569(ipLnGF)/0./ ,
     2  xMg72569(ipLnEnrWN)/39828./,xMg72569(ipLnIonStg)/7./,
     3  xMg72569(ipLnNelem)/12./, xMg72569(ipLnRedis)/-1./ ,
     4  xMg72569(ipLnAul)/4.531/
*
*     [Mg VIII] 3.03 micron
      data xMg08303(ipLnWlAng)/3.03e4/,xMg08303(ipLnGl)/2./,
     1  xMg08303(ipLnGu)/4./, xMg08303(ipLnGF)/0./,
     2  xMg08303(ipLnEnrWN)/3302.56/,xMg08303(ipLnIonStg)/8./,
     3  xMg08303(ipLnNelem)/12./, xMg08303(ipLnRedis)/-1./,
     4  xMg08303(ipLnAul)/.324/
*
*     the Mg X 615 li seq doublet
      data tMg610(ipLnWlAng)/610./ ,tMg610(ipLnGl)/2./,
     1  tMg610(ipLnGu)/4./, tMg610(ipLnGF)/.1684/,
     2  tMg610(ipLnEnrWN)/163990./ ,tMg610(ipLnIonStg)/10./,
     3  tMg610(ipLnNelem)/12./, tMg610(ipLnRedis)/1./
*
      data tMg625(ipLnWlAng)/625./ ,tMg625(ipLnGl)/2./,
     1  tMg625(ipLnGu)/2./, tMg625(ipLnGF)/.0820/,
     2  tMg625(ipLnEnrWN)/160015./ ,tMg625(ipLnIonStg)/10./,
     3  tMg625(ipLnNelem)/12./, tMg625(ipLnRedis)/1./
*
      data t58(ipLnWlAng)/58./ ,t58(ipLnGl)/2./,
     1  t58(ipLnGu)/6./, t58(ipLnGF)/.652/,
     2  t58(ipLnEnrWN)/1727393./ ,t58(ipLnIonStg)/10./,
     3  t58(ipLnNelem)/12./, t58(ipLnRedis)/1./
*
*     Mg IV 4.487m
      data tMg4(ipLnWlAng)/4.487e4/,tMg4(ipLnGl)/4./,
     1  tMg4(ipLnGu)/2./, tMg4(ipLnGF)/0./,
     2  tMg4(ipLnEnrWN)/2228.82/,tMg4(ipLnIonStg)/4./,
     3  tMg4(ipLnNelem)/12./, tMg4(ipLnRedis)/-1./ ,
     4  tMg4(ipLnAul)/0.199/
*
*     [Mg V] 13.52
      data tMg14(ipLnWlAng)/1.352e5/,tMg14(ipLnGl)/3./,
     1  tMg14(ipLnGu)/1./, tMg14(ipLnGF)/5.95e-8/,
     2  tMg14(ipLnEnrWN)/739.58/,tMg14(ipLnIonStg)/5./,
     3  tMg14(ipLnNelem)/12./, tMg14(ipLnRedis)/-1./
*
*     [Mg V] 5.610
      data tMg6(ipLnWlAng)/5.610e4/,tMg6(ipLnGl)/5./,
     1  tMg6(ipLnGu)/3./, tMg6(ipLnGF)/1.80e-7/,
     2  tMg6(ipLnEnrWN)/1782.58/,tMg6(ipLnIonStg)/5./,
     3  tMg6(ipLnNelem)/12./, tMg6(ipLnRedis)/-1./
*
*     [Mg VII] 9.033 mic
      data fsMg790(ipLnWlAng)/9.033e4/,fsMg790(ipLnGl)/1./,
     1  fsMg790(ipLnGu)/3./, fsMg790(ipLnGF)/0./,
     2  fsMg790(ipLnEnrWN)/1107./,fsMg790(ipLnIonStg)/7./,
     3  fsMg790(ipLnNelem)/12./, fsMg790(ipLnRedis)/-1./,
     4  fsMg790(ipLnAul)/2.44e-2/
*
*     [Mg VII] 5.503 mic
      data fsMg755(ipLnWlAng)/5.503e4/,fsMg755(ipLnGl)/3./,
     1  fsMg755(ipLnGu)/5./, fsMg755(ipLnGF)/0./,
     2  fsMg755(ipLnEnrWN)/1817.10/,fsMg755(ipLnIonStg)/7./,
     3  fsMg755(ipLnNelem)/12./, fsMg755(ipLnRedis)/-1./,
     4  fsMg755(ipLnAul)/8.09e-2/
*
*     aluminum line optical depth data
      data AlI3957(ipLnWlAng)/3957./,AlI3957(ipLnGl)/ 6./,
     1  AlI3957(ipLnGu)/ 2./,AlI3957(ipLnGF)/7.32E-01/,
     2  AlI3957(ipLnEnrWN)/25273.049/,AlI3957(ipLnIonStg)/1./,
     3  AlI3957(ipLnNelem)/13./,AlI3957(ipLnRedis)/1./
     4  AlI3957(ipLnAul)/0./
*
*     this line back in level 2
*     data al1671(ipLnWlAng)/1671./,al1671(ipLnGl)/ 1./,
*    1  al1671(ipLnGu)/3./,al1671(ipLnGF)/1.81/,
*    2  al1671(ipLnEnrWN)/59852.03 /,al1671(ipLnIonStg)/2./,
*    3  al1671(ipLnNelem)/13./,al1671(ipLnRedis)/1./
*    4  al1671(ipLnAul)/0./
*
      data AlI3090(ipLnWlAng)/3090./,AlI3090(ipLnGl)/ 6./,
     1  AlI3090(ipLnGu)/10./,AlI3090(ipLnGF)/9.66E-01/,
     2  AlI3090(ipLnEnrWN)/32361.552/,AlI3090(ipLnIonStg)/1./,
     3  AlI3090(ipLnNelem)/13./,AlI3090(ipLnRedis)/1./
     4  AlI3090(ipLnAul)/0./
*
      data t1855(ipLnWlAng)/1855./ ,t1855(ipLnGl)/2./,
     1  t1855(ipLnGu)/4./, t1855(ipLnGF)/1.15/ ,
     2  t1855(ipLnEnrWN)/53916.60/ ,t1855(ipLnIonStg)/3./,
     3  t1855(ipLnNelem)/13./, t1855(ipLnRedis)/1./
*
      data t1863(ipLnWlAng)/1863./ ,t1863(ipLnGl)/2./,
     1  t1863(ipLnGu)/2./, t1863(ipLnGF)/0.572/ ,
     2  t1863(ipLnEnrWN)/53682.93/ ,t1863(ipLnIonStg)/3./,
     3  t1863(ipLnNelem)/13./, t1863(ipLnRedis)/1./
*
      data t2670(ipLnWlAng)/2670./ ,t2670(ipLnGl)/1./,
     1  t2670(ipLnGu)/3./,t2670(ipLnGF)/1.07e-5/ ,
     2  t2670(ipLnEnrWN)/37516.656/ ,t2670(ipLnIonStg)/2./,
     3  t2670(ipLnNelem)/13./, t2670(ipLnRedis)/1./
*
*     [Al V] 2.905 mic
      data Al529(ipLnWlAng)/29052./,Al529(ipLnGl)/4./,
     1  Al529(ipLnGu)/2./, Al529(ipLnGF)/0./ ,
     2  Al529(ipLnEnrWN)/3442.1/,Al529(ipLnIonStg)/5./,
     3  Al529(ipLnNelem)/13./, Al529(ipLnRedis)/-1./,
     4  Al529(ipLnAul)/0.734/
*
*     [Al VI] 3.66 mic
      data Al6366(ipLnWlAng)/36600./,Al6366(ipLnGl)/5./,
     1  Al6366(ipLnGu)/3./, Al6366(ipLnGF)/0./ ,
     2  Al6366(ipLnEnrWN)/2732./,Al6366(ipLnIonStg)/6./,
     3  Al6366(ipLnNelem)/13./, Al6366(ipLnRedis)/-1./,
     4  Al6366(ipLnAul)/0.458/
*
*     [Al VI] 9.116 mic
      data Al6912(ipLnWlAng)/91160./,Al6912(ipLnGl)/3./,
     1  Al6912(ipLnGu)/5./, Al6912(ipLnGF)/0./ ,
     2  Al6912(ipLnEnrWN)/1097./,Al6912(ipLnIonStg)/6./,
     3  Al6912(ipLnNelem)/13./, Al6912(ipLnRedis)/-1./,
     4  Al6912(ipLnAul)/0.0710/
*
*     [Al VIII] 5.848 mic
      data Al8575(ipLnWlAng)/58480./,Al8575(ipLnGl)/1./,
     1  Al8575(ipLnGu)/3./, Al8575(ipLnGF)/0./ ,
     2  Al8575(ipLnEnrWN)/1710./,Al8575(ipLnIonStg)/8./,
     3  Al8575(ipLnNelem)/13./, Al8575(ipLnRedis)/-1./,
     4  Al8575(ipLnAul)/8.96e-2/
*
*     [Al VIII] 3.69 mic
      data Al8370(ipLnWlAng)/36900./,Al8370(ipLnGl)/3./,
     1  Al8370(ipLnGu)/5./, Al8370(ipLnGF)/0./ ,
     2  Al8370(ipLnEnrWN)/2710./,Al8370(ipLnIonStg)/8./,
     3  Al8370(ipLnNelem)/13./, Al8370(ipLnRedis)/-1./,
     4  Al8370(ipLnAul)/2.68e-1/
*
*     [Al IX] 2.04 micron
      data Al09204(ipLnWlAng)/2.04e4/,Al09204(ipLnGl)/2./,
     1  Al09204(ipLnGu)/4./, Al09204(ipLnGF)/0./,
     2  Al09204(ipLnEnrWN)/4890./,Al09204(ipLnIonStg)/9./,
     3  Al09204(ipLnNelem)/13./, Al09204(ipLnRedis)/-1./,
     4  Al09204(ipLnAul)/1.05/
*
      data t639(ipLnWlAng)/639./,t639(ipLnGl)/1./,
     1  t639(ipLnGu)/3./, t639(ipLnGF)/3.17e-5/ ,
     2  t639(ipLnEnrWN)/158385.563/,t639(ipLnIonStg)/10./,
     3  t639(ipLnNelem)/13./, t639(ipLnRedis)/1./
*
*     Al XI 550, 568 Li seq doublet
      data tAl550(ipLnWlAng)/550./ ,tAl550(ipLnGl)/2./,
     1  tAl550(ipLnGu)/4./, tAl550(ipLnGF)/0.1546/,
     2  tAl550(ipLnEnrWN)/181807.9/ ,tAl550(ipLnIonStg)/11./,
     3  tAl550(ipLnNelem)/13./, tAl550(ipLnRedis)/1./
*
      data tAl568(ipLnWlAng)/568./ ,tAl568(ipLnGl)/2./,
     1  tAl568(ipLnGu)/2./, tAl568(ipLnGF)/0.0750/,
     2  tAl568(ipLnEnrWN)/176019.2/ ,tAl568(ipLnIonStg)/11./,
     3  tAl568(ipLnNelem)/13./, tAl568(ipLnRedis)/1./
*
      data tAl48(ipLnWlAng)/48./ ,tAl48(ipLnGl)/2./,
     1  tAl48(ipLnGu)/6./, tAl48(ipLnGF)/0.67/,
     2  tAl48(ipLnEnrWN)/2.069935E+06/ ,tAl48(ipLnIonStg)/11./,
     3  tAl48(ipLnNelem)/13./, tAl48(ipLnRedis)/1./
*
*     silicon line optical depth data
      data Sii2518(ipLnWlAng)/2518./,Sii2518(ipLnGl)/ 9./,
     1  Sii2518(ipLnGu)/ 9./,Sii2518(ipLnGF)/2.12E+00/,
     2  Sii2518(ipLnEnrWN)/39710.239/,Sii2518(ipLnIonStg)/1./,
     3  Sii2518(ipLnNelem)/14./,Sii2518(ipLnRedis)/1./
     4  Sii2518(ipLnAul)/0./
*
      data Sii2215(ipLnWlAng)/2215./,Sii2215(ipLnGl)/ 9./,
     1  Sii2215(ipLnGu)/15./,Sii2215(ipLnGF)/4.68E-01/,
     2  Sii2215(ipLnEnrWN)/45153.629/,Sii2215(ipLnIonStg)/1./,
     3  Sii2215(ipLnNelem)/14./,Sii2215(ipLnRedis)/1./
     4  Sii2215(ipLnAul)/0./
*
*     new A from
*     >>refer Calamai, A.G., Smith, P.L., Bergeson, S.D. 1993, ApJ, 415, L59
      data t2335(ipLnWlAng)/2335./,t2335(ipLnGl)/6./,
     1  t2335(ipLnGu)/12./,t2335(ipLnGF)/0./ ,
     2  t2335(ipLnEnrWN)/44067.881/,t2335(ipLnIonStg)/2./,
     3  t2335(ipLnNelem)/14./, t2335(ipLnRedis)/1./ ,
     4  t2335(ipLnAul)/3241.7/
*
      data t1808(ipLnWlAng)/1808./,t1808(ipLnGl)/6./,
     1  t1808(ipLnGu)/10./,t1808(ipLnGF)/0.0153/ ,
     2  t1808(ipLnEnrWN)/55127.143/,t1808(ipLnIonStg)/2./,
     3  t1808(ipLnNelem)/14./, t1808(ipLnRedis)/1./
*
      data t1207(ipLnWlAng)/1207./,t1207(ipLnGl)/1./,
     1  t1207(ipLnGu)/3./, t1207(ipLnGF)/1.68/ ,
     2  t1207(ipLnEnrWN)/82883.0/,t1207(ipLnIonStg)/3./,
     3  t1207(ipLnNelem)/14./, t1207(ipLnRedis)/1./
*
      data t1895(ipLnWlAng)/1892./,t1895(ipLnGl)/1./,
     1  t1895(ipLnGu)/3./,t1895(ipLnGF)/2.69e-5/ ,
     2  t1895(ipLnEnrWN)/52888.777/,t1895(ipLnIonStg)/3./,
     3  t1895(ipLnNelem)/14./, t1895(ipLnRedis)/1./
*
      data t1394(ipLnWlAng)/1394./,t1394(ipLnGl)/2./,
     1  t1394(ipLnGu)/4./, t1394(ipLnGF)/1.048/ ,
     2  t1394(ipLnEnrWN)/71748.621/,t1394(ipLnIonStg)/4./,
     3  t1394(ipLnNelem)/14./, t1394(ipLnRedis)/1./
*
      data t1403(ipLnWlAng)/1403./,t1403(ipLnGl)/2./,
     1  t1403(ipLnGu)/2./, t1403(ipLnGF)/0.520/ ,
     2  t1403(ipLnEnrWN)/71287.523/,t1403(ipLnIonStg)/4./,
     3  t1403(ipLnNelem)/14./, t1403(ipLnRedis)/1./
*
      data t1527(ipLnWlAng)/1527./,t1527(ipLnGl)/6./,
     1  t1527(ipLnGu)/2./, t1527(ipLnGF)/0.786/ ,
     2  t1527(ipLnEnrWN)/65309.747/,t1527(ipLnIonStg)/2./,
     3  t1527(ipLnNelem)/14./, t1527(ipLnRedis)/1./
*
      data t1305(ipLnWlAng)/1305./,t1305(ipLnGl)/6./,
     1  t1305(ipLnGu)/2./, t1305(ipLnGF)/0.5208/ ,
     2  t1305(ipLnEnrWN)/76472.567/,t1305(ipLnIonStg)/2./,
     3  t1305(ipLnNelem)/14./, t1305(ipLnRedis)/1./
*
      data t1260(ipLnWlAng)/1260./,t1260(ipLnGl)/6./,
     1  t1260(ipLnGu)/10./, t1260(ipLnGF)/7.084/ ,
     2  t1260(ipLnEnrWN)/79156.519/,t1260(ipLnIonStg)/2./,
     3  t1260(ipLnNelem)/14./, t1260(ipLnRedis)/1./
*
*     [Si VI] 1.9641mic
      data Si619(ipLnWlAng)/19631./,Si619(ipLnGl)/4./,
     1  Si619(ipLnGu)/2./, Si619(ipLnGF)/0./ ,
     2  Si619(ipLnEnrWN)/5093.19/,Si619(ipLnIonStg)/6./,
     3  Si619(ipLnNelem)/14./, Si619(ipLnRedis)/-1./,
     4  Si619(ipLnAul)/2.37/
*
*     [Si X] 1.43 micron
      data Si10143(ipLnWlAng)/1.43e4/,Si10143(ipLnGl)/2./,
     1  Si10143(ipLnGu)/4./, Si10143(ipLnGF)/0./,
     2  Si10143(ipLnEnrWN)/6990./,Si10143(ipLnIonStg)/10./,
     3  Si10143(ipLnNelem)/14./, Si10143(ipLnRedis)/-1./,
     4  Si10143(ipLnAul)/3.07/
*
      data tSi499(ipLnWlAng)/499./ ,tSi499(ipLnGl)/2./,
     1 tSi499(ipLnGu)/4./, tSi499(ipLnGF)/0.1438/,
     2 tSi499(ipLnEnrWN)/200237.9/ ,tSi499(ipLnIonStg)/12./,
     3 tSi499(ipLnNelem)/14./ , tSi499(ipLnRedis)/1./
*
      data tSi521(ipLnWlAng)/521./ ,tSi521(ipLnGl)/2./,
     1 tSi521(ipLnGu)/2./, tSi521(ipLnGF)/0.0690/,
     2 tSi521(ipLnEnrWN)/192062.1/ ,tSi521(ipLnIonStg)/12./,
     3 tSi521(ipLnNelem)/14./ , tSi521(ipLnRedis)/1./
*
      data tSi41(ipLnWlAng)/41./ ,tSi41(ipLnGl)/2./,
     1  tSi41(ipLnGu)/6./, tSi41(ipLnGF)/0.686/,
     2  tSi41(ipLnEnrWN)/2.443793E+06/ ,tSi41(ipLnIonStg)/12./,
     3  tSi41(ipLnNelem)/14./, tSi41(ipLnRedis)/1./
*
*     [Si II] 34.8 mic
      data tSi35(ipLnWlAng)/3.4815e5/,tSi35(ipLnGl)/2./,
     1  tSi35(ipLnGu)/4./, tSi35(ipLnGF)/1.58e-8/,
     2  tSi35(ipLnEnrWN)/287.231/,tSi35(ipLnIonStg)/2./,
     3  tSi35(ipLnNelem)/14./, tSi35(ipLnRedis)/-1./
*
*     [Si VII] 2.481
      data tSi25(ipLnWlAng)/2.481e4/,tSi25(ipLnGl)/5./,
     1  tSi25(ipLnGu)/3./, tSi25(ipLnGF)/4.01e-7/,
     2  tSi25(ipLnEnrWN)/4026.84/,tSi25(ipLnIonStg)/7./,
     3  tSi25(ipLnNelem)/14./, tSi25(ipLnRedis)/-1./
*
*     [Si VII] 6.4922
      data tSi65(ipLnWlAng)/6.492e4/,tSi65(ipLnGl)/3./,
     1  tSi65(ipLnGu)/1./, tSi65(ipLnGF)/1.22e-7/,
     2  tSi65(ipLnEnrWN)/1540.29/,tSi65(ipLnIonStg)/7./,
     3  tSi65(ipLnNelem)/14./, tSi65(ipLnRedis)/-1./
*
*     [Si IX] 2.585 mic
      data tSi3(ipLnWlAng)/2.584e4/,tSi3(ipLnGl)/3./,
     1  tSi3(ipLnGu)/5./, tSi3(ipLnGF)/3.79e-7/,
     2  tSi3(ipLnEnrWN)/3869.6/,tSi3(ipLnIonStg)/9./,
     3  tSi3(ipLnNelem)/14./, tSi3(ipLnRedis)/-1./
*
*     [Si IX] 3.929 mic
      data tSi4(ipLnWlAng)/3.929e4/,tSi4(ipLnGl)/1./,
     1  tSi4(ipLnGu)/3./, tSi4(ipLnGF)/1.89e-7/,
     2  tSi4(ipLnEnrWN)/2545./,tSi4(ipLnIonStg)/9./,
     3  tSi4(ipLnNelem)/14./, tSi4(ipLnRedis)/-1./
*
*     phosphorus line data
*     P II 60.64 mic
      data P0260(ipLnWlAng)/60.64e4/,P0260(ipLnGl)/1./,
     1  P0260(ipLnGu)/3./, P0260(ipLnGF)/0./ ,
     2  P0260(ipLnEnrWN)/164.9/,P0260(ipLnIonStg)/2./,
     3  P0260(ipLnNelem)/15./, P0260(ipLnRedis)/-1./,
     4  P0260(ipLnAul)/8.31e-5/
*
*     P II 32.87 mic
      data P0233(ipLnWlAng)/32.87e4/,P0233(ipLnGl)/3./,
     1  P0233(ipLnGu)/5./, P0233(ipLnGF)/0./ ,
     2  P0233(ipLnEnrWN)/304.2/,P0233(ipLnIonStg)/2./,
     3  P0233(ipLnNelem)/15./, P0233(ipLnRedis)/-1./,
     4  P0233(ipLnAul)/3.78e-4/
*
*     P III 17.885 mic
      data P0318(ipLnWlAng)/17.885e4/,P0318(ipLnGl)/2./,
     1  P0318(ipLnGu)/4./, P0318(ipLnGF)/0./ ,
     2  P0318(ipLnEnrWN)/559.1/,P0318(ipLnIonStg)/3./,
     3  P0318(ipLnNelem)/15./, P0318(ipLnRedis)/-1./,
     4  P0318(ipLnAul)/1.57e-3/
*
*     P VII 1.3745 mic
      data P713(ipLnWlAng)/13745./,P713(ipLnGl)/4./,
     1  P713(ipLnGu)/2./, P713(ipLnGF)/0./ ,
     2  P713(ipLnEnrWN)/7275./,P713(ipLnIonStg)/7./,
     3  P713(ipLnNelem)/15./, P713(ipLnRedis)/-1./,
     4  P713(ipLnAul)/6.92/
*
*     P VIII 4.85 mic
      data P848(ipLnWlAng)/4.85e4/,P848(ipLnGl)/3./,
     1  P848(ipLnGu)/1./, P848(ipLnGF)/0./,
     2  P848(ipLnEnrWN)/2061.8/,P848(ipLnIonStg)/8./,
     3  P848(ipLnNelem)/15./, P848(ipLnRedis)/-1./,
     4  P848(ipLnAul)/0.470/
*
*     P VIII 1.735 mic
      data P817(ipLnWlAng)/1.735e4/,P817(ipLnGl)/5./,
     1  P817(ipLnGu)/3./, P817(ipLnGF)/0./,
     2  P817(ipLnEnrWN)/5763.7/,P817(ipLnIonStg)/8./,
     3  P817(ipLnNelem)/15./, P817(ipLnRedis)/-1./,
     4  P817(ipLnAul)/4.28/
*
*     P X 2.708 mic
      data P1027(ipLnWlAng)/2.708e4/,P1027(ipLnGl)/1./,
     1  P1027(ipLnGu)/3./, P1027(ipLnGF)/0./,
     2  P1027(ipLnEnrWN)/3692.7/,P1027(ipLnIonStg)/10./,
     3  P1027(ipLnNelem)/15./, P1027(ipLnRedis)/-1./,
     4  P1027(ipLnAul)/0.899/
*
*     P X 1.868
      data P1018(ipLnWlAng)/1.868e4/,P1018(ipLnGl)/3./,
     1  P1018(ipLnGu)/5./, P1018(ipLnGF)/0./,
     2  P1018(ipLnEnrWN)/5353.3/,P1018(ipLnIonStg)/10./,
     3  P1018(ipLnNelem)/15./, P1018(ipLnRedis)/-1./,
     4  P1018(ipLnAul)/2.05/
*
*     sulphur line optical depth data
      data t1256(ipLnWlAng)/1256./ ,t1256(ipLnGl)/4./,
     1 t1256(ipLnGu)/12./,t1256(ipLnGF)/0.124/ ,
     2 t1256(ipLnEnrWN)/79610.367/ ,t1256(ipLnIonStg)/2./,
     3 t1256(ipLnNelem)/16./, t1256(ipLnRedis)/1./
*
      data t1194(ipLnWlAng)/1194./ ,t1194(ipLnGl)/9./,
     1  t1194(ipLnGu)/15./,t1194(ipLnGF)/0.226/ ,
     2  t1194(ipLnEnrWN)/83503.413/ ,t1194(ipLnIonStg)/3./,
     3  t1194(ipLnNelem)/16./, t1194(ipLnRedis)/1./
*
*     Heise et al. 1995 Ap.J. 451, 241. for A
      data tS1720(ipLnWlAng)/1720./ ,tS1720(ipLnGl)/9./,
     1  tS1720(ipLnGu)/5./,tS1720(ipLnGF)/0./ ,
     2  tS1720(ipLnEnrWN)/58139.5/ ,tS1720(ipLnIonStg)/3./,
     3  tS1720(ipLnNelem)/16./, tS1720(ipLnRedis)/1./,
     4  tS1720(ipLnAul)/20800./
*
*     A from
*     >>refer Dufton, P.L., Hibbert, A., Kingston, A.E., & Doschek, G.A.
*     >>refer 1982, ApJ, 257, 338
      data t1406(ipLnWlAng)/1406./,t1406(ipLnGl)/6./,
     1  t1406(ipLnGu)/12./,t1406(ipLnGF)/2.35e-4/ ,
     2  t1406(ipLnEnrWN)/71766.697/,t1406(ipLnIonStg)/4./,
     3  t1406(ipLnNelem)/16./, t1406(ipLnRedis)/1./
*
      data t1198(ipLnWlAng)/1198./,t1198(ipLnGl)/1./,
     1  t1198(ipLnGu)/3./,t1198(ipLnGF)/1.06e-4/ ,
     2  t1198(ipLnEnrWN)/83433./,t1198(ipLnIonStg)/5./,
     3  t1198(ipLnNelem)/16./, t1198(ipLnRedis)/-1./
*
      data t786(ipLnWlAng)/786./ ,t786(ipLnGl)/1./,
     1  t786(ipLnGu)/3./, t786(ipLnGF)/1.42/ ,
     2  t786(ipLnEnrWN)/127150./ ,t786(ipLnIonStg)/5./,
     3  t786(ipLnNelem)/16./, t786(ipLnRedis)/1./
*
      data t933(ipLnWlAng)/933./,t933(ipLnGl)/2./,
     1  t933(ipLnGu)/4./, t933(ipLnGF)/0.89/ ,
     2  t933(ipLnEnrWN)/107137.7/,t933(ipLnIonStg)/6./,
     3  t933(ipLnNelem)/16./, t933(ipLnRedis)/1./
*
      data t944(ipLnWlAng)/944./,t944(ipLnGl)/2./,
     1  t944(ipLnGu)/2./, t944(ipLnGF)/0.44/ ,
     2  t944(ipLnEnrWN)/105873.6/,t944(ipLnIonStg)/6./,
     3  t944(ipLnNelem)/16./, t944(ipLnRedis)/1./
*
*     [S VIII] 9913
      data fsS810(ipLnWlAng)/9913./,fsS810(ipLnGl)/4./,
     1  fsS810(ipLnGu)/2./, fsS810(ipLnGF)/0./ ,
     2  fsS810(ipLnEnrWN)/10085.3/,fsS810(ipLnIonStg)/8./,
     3  fsS810(ipLnNelem)/16./, fsS810(ipLnRedis)/-1./ ,
     4  fsS810(ipLnAul)/18.4/
*
*     [S IX] 1.252 mic
      data fsS912(ipLnWlAng)/1.252e4/,fsS912(ipLnGl)/5./,
     1  fsS912(ipLnGu)/3./, fsS912(ipLnGF)/0./ ,
     2  fsS912(ipLnEnrWN)/7985./,fsS912(ipLnIonStg)/9./,
     3  fsS912(ipLnNelem)/16./, fsS912(ipLnRedis)/-1./ ,
     4  fsS912(ipLnAul)/11.4/
*
*     [S IX] 3.755 mic
      data fsS938(ipLnWlAng)/3.755e4/,fsS938(ipLnGl)/3./,
     1  fsS938(ipLnGu)/1./, fsS938(ipLnGF)/0./ ,
     2  fsS938(ipLnEnrWN)/2663./,fsS938(ipLnIonStg)/9./,
     3  fsS938(ipLnNelem)/16./, fsS938(ipLnRedis)/-1./ ,
     4  fsS938(ipLnAul)/1.01/
*
*     [S XI] 1.9201 mic
      data fsS1119(ipLnWlAng)/1.9201e4/,fsS1119(ipLnGl)/1./,
     1  fsS1119(ipLnGu)/3./, fsS1119(ipLnGF)/0./ ,
     2  fsS1119(ipLnEnrWN)/5208./,fsS1119(ipLnIonStg)/11./,
     3  fsS1119(ipLnNelem)/16./, fsS1119(ipLnRedis)/-1./ ,
     4  fsS1119(ipLnAul)/2.51/
*
*     [S XI] 1.3927 mic
      data fsS1114(ipLnWlAng)/1.3927e4/,fsS1114(ipLnGl)/3./,
     1  fsS1114(ipLnGu)/5./, fsS1114(ipLnGF)/0./ ,
     2  fsS1114(ipLnEnrWN)/7180.1/,fsS1114(ipLnIonStg)/11./,
     3  fsS1114(ipLnNelem)/16./, fsS1114(ipLnRedis)/-1./ ,
     4  fsS1114(ipLnAul)/4.94/
*
*     S XII 7536
*     this is a vacuum wavelength
      data fsS1207(ipLnWlAng)/7611.2/,fsS1207(ipLnGl)/2./,
     1  fsS1207(ipLnGu)/4./, fsS1207(ipLnGF)/0./ ,
     2  fsS1207(ipLnEnrWN)/13135.3/,fsS1207(ipLnIonStg)/12./,
     3  fsS1207(ipLnNelem)/16./, fsS1207(ipLnRedis)/-1./ ,
     4  fsS1207(ipLnAul)/20.4/
*
      data tSu418(ipLnWlAng)/418./ ,tSu418(ipLnGl)/2./,
     1 tSu418(ipLnGu)/4./, tSu418(ipLnGF)/0.1278/,
     2 tSu418(ipLnEnrWN)/239429.2/ ,tSu418(ipLnIonStg)/14./,
     2 tSu418(ipLnNelem)/16./ , tSu418(ipLnRedis)/1./
*
      data tSu446(ipLnWlAng)/446./ ,tSu446(ipLnGl)/2./,
     1 tSu446(ipLnGu)/2./, tSu446(ipLnGF)/0.0598/,
     2 tSu446(ipLnEnrWN)/224330.9/ ,tSu446(ipLnIonStg)/14./,
     2 tSu446(ipLnNelem)/16./ , tSu446(ipLnRedis)/1./
*
      data tSu30(ipLnWlAng)/30./ ,tSu30(ipLnGl)/2./,
     1 tSu30(ipLnGu)/6./, tSu30(ipLnGF)/0.712/,
     2 tSu30(ipLnEnrWN)/3.285043E+06/ ,tSu30(ipLnIonStg)/14./,
     3 tSu30(ipLnNelem)/16./, tSu30(ipLnRedis)/1./
*
*     fine structure lines added in by Jim Kingdon
      data tS19(ipLnWlAng)/1.87e5/,tS19(ipLnGl)/3./,
     1  tS19(ipLnGu)/5./, tS19(ipLnGF)/5.41e-8/,
     2  tS19(ipLnEnrWN)/535.33/,tS19(ipLnIonStg)/3./,
     3  tS19(ipLnNelem)/16./, tS19(ipLnRedis)/-1./
*
*     [S III] 33.48
      data tS34(ipLnWlAng)/3.348e5/,tS34(ipLnGl)/1./,
     1  tS34(ipLnGu)/3./, tS34(ipLnGF)/2.40e-8/,
     2  tS34(ipLnEnrWN)/298.677/,tS34(ipLnIonStg)/3./,
     3  tS34(ipLnNelem)/16./, tS34(ipLnRedis)/-1./
*
      data tS11(ipLnWlAng)/1.053e5/,tS11(ipLnGl)/2./,
     1  tS11(ipLnGu)/4./, tS11(ipLnGF)/5.13e-8/,
     2  tS11(ipLnEnrWN)/951.43/,tS11(ipLnIonStg)/4./,
     3  tS11(ipLnNelem)/16./, tS11(ipLnRedis)/-1./
*
*     chlorine line optical depth data
*
*     Cl II 14.3678 mic
      data fsCl214(ipLnWlAng)/1.44e5/,fsCl214(ipLnGl)/5./,
     1  fsCl214(ipLnGu)/3./, fsCl214(ipLnGF)/0./,
     2  fsCl214(ipLnEnrWN)/697./,fsCl214(ipLnIonStg)/2./,
     3  fsCl214(ipLnNelem)/17./, fsCl214(ipLnRedis)/-1./,
     4  fsCl214(ipLnAul)/7.57e-3/
*
*     Cl II 33.281 mic
      data fsCl233(ipLnWlAng)/3.33e5/,fsCl233(ipLnGl)/3./,
     1  fsCl233(ipLnGu)/1./, fsCl233(ipLnGF)/0./,
     2  fsCl233(ipLnEnrWN)/299.0/,fsCl233(ipLnIonStg)/2./,
     3  fsCl233(ipLnNelem)/17./, fsCl233(ipLnRedis)/-1./,
     4  fsCl233(ipLnAul)/1.46e-3/
*
*     [Cl 4] 20.354 mic
      data Cl04203(ipLnWlAng)/2.04e5/,Cl04203(ipLnGl)/1./,
     1  Cl04203(ipLnGu)/3./, Cl04203(ipLnGF)/0./,
     2  Cl04203(ipLnEnrWN)/491.3/,Cl04203(ipLnIonStg)/4./,
     3  Cl04203(ipLnNelem)/17./, Cl04203(ipLnRedis)/-1./,
     4  Cl04203(ipLnAul)/2.13e-3/
*
*     [Cl 4] 11.741 mic
      data Cl04117(ipLnWlAng)/1.17e5/,Cl04117(ipLnGl)/3./,
     1  Cl04117(ipLnGu)/5./, Cl04117(ipLnGF)/0./,
     2  Cl04117(ipLnEnrWN)/851.72/,Cl04117(ipLnIonStg)/4./,
     3  Cl04117(ipLnNelem)/17./, Cl04117(ipLnRedis)/-1./,
     4  Cl04117(ipLnAul)/8.32e-3/
*
*     Cl IX 7334A
      data Cl973(ipLnWlAng)/7334./,Cl973(ipLnGl)/4./,
     1  Cl973(ipLnGu)/2./, Cl973(ipLnGF)/0./ ,
     2  Cl973(ipLnEnrWN)/1.3635e4/,Cl973(ipLnIonStg)/9./,
     3  Cl973(ipLnNelem)/17./, Cl973(ipLnRedis)/-1./,
     4  Cl973(ipLnAul)/45.5/
*
*     Cl X 3.05 mic
      data Cl1030(ipLnWlAng)/3.05e4/,Cl1030(ipLnGl)/3./,
     1  Cl1030(ipLnGu)/1./, Cl1030(ipLnGF)/0./,
     2  Cl1030(ipLnEnrWN)/3278.7/,Cl1030(ipLnIonStg)/10./,
     3  Cl1030(ipLnNelem)/17./, Cl1030(ipLnRedis)/-1./,
     4  Cl1030(ipLnAul)/1.87/
*
*     Cl X 9332
      data Cl1092(ipLnWlAng)/9332./,Cl1092(ipLnGl)/5./,
     1  Cl1092(ipLnGu)/3./, Cl1092(ipLnGF)/0./,
     2  Cl1092(ipLnEnrWN)/10715.8/,Cl1092(ipLnIonStg)/10./,
     3  Cl1092(ipLnNelem)/17./, Cl1092(ipLnRedis)/-1./,
     4  Cl1092(ipLnAul)/28.3/
*
*     argon line optical depth data
*     Ar XVI
      data t354(ipLnWlAng)/354./ ,t354(ipLnGl)/2./,
     1  t354(ipLnGu)/4./, t354(ipLnGF)/.1158/,
     2  t354(ipLnEnrWN)/282549./ ,t354(ipLnIonStg)/16./,
     3  t354(ipLnNelem)/18./ , t354(ipLnRedis)/1./
*
*     Ar XVI
      data t389(ipLnWlAng)/389./ ,t389(ipLnGl)/2./,
     1  t389(ipLnGu)/2./, t389(ipLnGF)/.0526/,
     2  t389(ipLnEnrWN)/256976./ ,t389(ipLnIonStg)/16./,
     3  t389(ipLnNelem)/18./ , t389(ipLnRedis)/1./
*
*     Ar XVI
      data t25(ipLnWlAng)/25.53/ ,t25(ipLnGl)/2./,
     1  t25(ipLnGu)/6./, t25(ipLnGF)/.736/,
     2  t25(ipLnEnrWN)/3.916960E6/ ,t25(ipLnIonStg)/16./,
     3  t25(ipLnNelem)/18./ , t25(ipLnRedis)/1./
*
*     argon fine structure lines
*     [Ar II]
      data tAr7(ipLnWlAng)/6.98e4/,tAr7(ipLnGl)/4./,
     1  tAr7(ipLnGu)/2./, tAr7(ipLnGF)/7.71e-8/,
     2  tAr7(ipLnEnrWN)/1430.46/,tAr7(ipLnIonStg)/2./,
     3  tAr7(ipLnNelem)/18./, tAr7(ipLnRedis)/-1./
*
*     [Ar III] 9.0 mic
      data tAr9(ipLnWlAng)/9.0e4/,tAr9(ipLnGl)/5./,
     1  tAr9(ipLnGu)/3./, tAr9(ipLnGF)/1.12e-7/,
     2  tAr9(ipLnEnrWN)/1112.66/,tAr9(ipLnIonStg)/3./,
     3  tAr9(ipLnNelem)/18./, tAr9(ipLnRedis)/-1./
*
*     [Ar III] 21.83 mic
      data tAr22(ipLnWlAng)/2.183e5/,tAr22(ipLnGl)/3./,
     1  tAr22(ipLnGu)/1./, tAr22(ipLnGF)/3.69e-8/,
     2  tAr22(ipLnEnrWN)/458.10/,tAr22(ipLnIonStg)/3./,
     3  tAr22(ipLnNelem)/18./, tAr22(ipLnRedis)/-1./
*
*     [Ar V] 13.1 mic
      data tAr13(ipLnWlAng)/1.31e5/,tAr13(ipLnGl)/1./,
     1  tAr13(ipLnGu)/3./, tAr13(ipLnGF)/6.14e-8/,
     2  tAr13(ipLnEnrWN)/763.23/,tAr13(ipLnIonStg)/5./,
     3  tAr13(ipLnNelem)/18./, tAr13(ipLnRedis)/-1./
*
*     [Ar V] 8.0 mic
      data tAr8(ipLnWlAng)/8.0e4/,tAr8(ipLnGl)/3./,
     1  tAr8(ipLnGu)/5./, tAr8(ipLnGF)/1.27e-7/,
     2  tAr8(ipLnEnrWN)/1265.30/,tAr8(ipLnIonStg)/5./,
     3  tAr8(ipLnNelem)/18./, tAr8(ipLnRedis)/-1./
*
*     [Ar VI] 4.53 micron
      data Ar06453(ipLnWlAng)/4.53e4/,Ar06453(ipLnGl)/2./,
     1  Ar06453(ipLnGu)/4./, Ar06453(ipLnGF)/0./,
     2  Ar06453(ipLnEnrWN)/2207.74/,Ar06453(ipLnIonStg)/6./,
     3  Ar06453(ipLnNelem)/18./, Ar06453(ipLnRedis)/-1./,
     4  Ar06453(ipLnAul)/0.097/
*
*     Ar X 5533
      data Ar1055(ipLnWlAng)/5533./,Ar1055(ipLnGl)/4./,
     1  Ar1055(ipLnGu)/2./, Ar1055(ipLnGF)/0./ ,
     2  Ar1055(ipLnEnrWN)/1.8063e4/,Ar1055(ipLnIonStg)/10./,
     3  Ar1055(ipLnNelem)/18./, Ar1055(ipLnRedis)/-1./,
     4  Ar1055(ipLnAul)/106./
*
*     [Ar XI] 2.619 mic
      data Ar1126(ipLnWlAng)/2.619e4/,Ar1126(ipLnGl)/1./,
     1  Ar1126(ipLnGu)/3./, Ar1126(ipLnGF)/0./,
     2  Ar1126(ipLnEnrWN)/3818.0/,Ar1126(ipLnIonStg)/11./,
     3  Ar1126(ipLnNelem)/18./, Ar1126(ipLnRedis)/-1./,
     4  Ar1126(ipLnAul)/3./
*
*     [Ar XI] 6917.5
      data Ar1178(ipLnWlAng)/6917.5/,Ar1178(ipLnGl)/3./,
     1  Ar1178(ipLnGu)/5./, Ar1178(ipLnGF)/0./,
     2  Ar1178(ipLnEnrWN)/1.44556e4/,Ar1178(ipLnIonStg)/11./,
     3  Ar1178(ipLnNelem)/18./, Ar1178(ipLnRedis)/-1./,
     4  Ar1178(ipLnAul)/66.3/
*
*     potasium - really should split into two
      data KI7745(ipLnWlAng)/7745./,KI7745(ipLnGl)/ 2./,
     1  KI7745(ipLnGu)/ 6./,KI7745(ipLnGF)/2.04E+00/,
     2  KI7745(ipLnEnrWN)/13023.641/,KI7745(ipLnIonStg)/1./,
     3  KI7745(ipLnNelem)/19./,KI7745(ipLnRedis)/1./
     4  KI7745(ipLnAul)/0./
*
*     [K III] 4.62 micron
      data xK03462(ipLnWlAng)/4.62e4/,xK03462(ipLnGl)/4./,
     1  xK03462(ipLnGu)/2./, xK03462(ipLnGF)/0./,
     2  xK03462(ipLnEnrWN)/2165.43/,xK03462(ipLnIonStg)/3./,
     3  xK03462(ipLnNelem)/19./, xK03462(ipLnRedis)/-1./,
     4  xK03462(ipLnAul)/0.183/
*
*     [K IV] 5.982 micron
      data xK04598(ipLnWlAng)/5.98e4/,xK04598(ipLnGl)/5./,
     1  xK04598(ipLnGu)/3./, xK04598(ipLnGF)/0./,
     2  xK04598(ipLnEnrWN)/1671.68/,xK04598(ipLnIonStg)/4./,
     3  xK04598(ipLnNelem)/19./, xK04598(ipLnRedis)/-1./,
     4  xK04598(ipLnAul)/0.104/
*
*     [K IV] 15.39 micron
      data xK04154(ipLnWlAng)/15.39e4/,xK04154(ipLnGl)/3./,
     1  xK04154(ipLnGu)/1./, xK04154(ipLnGF)/0./,
     2  xK04154(ipLnEnrWN)/649.8/,xK04154(ipLnIonStg)/4./,
     3  xK04154(ipLnNelem)/19./, xK04154(ipLnRedis)/-1./,
     4  xK04154(ipLnAul)/0.0151/
*
*     [K VI] 8.823 micron
      data xK06882(ipLnWlAng)/8.82e4/,xK06882(ipLnGl)/1./,
     1  xK06882(ipLnGu)/3./, xK06882(ipLnGF)/0./,
     2  xK06882(ipLnEnrWN)/1133.4/,xK06882(ipLnIonStg)/6./,
     3  xK06882(ipLnNelem)/19./, xK06882(ipLnRedis)/-1./,
     4  xK06882(ipLnAul)/0.0261/
*
*     [K VI] 5.575 micron
      data xK06557(ipLnWlAng)/5.57e4/,xK06557(ipLnGl)/3./,
     1  xK06557(ipLnGu)/5./, xK06557(ipLnGF)/0./,
     2  xK06557(ipLnEnrWN)/1793.8/,xK06557(ipLnIonStg)/6./,
     3  xK06557(ipLnNelem)/19./, xK06557(ipLnRedis)/-1./,
     4  xK06557(ipLnAul)/0.0774/
*
*     [K VII] 3.19 micron
      data xK07319(ipLnWlAng)/3.1905e4/,xK07319(ipLnGl)/2./,
     1  xK07319(ipLnGu)/4./, xK07319(ipLnGF)/0./,
     2  xK07319(ipLnEnrWN)/3134.28/,xK07319(ipLnIonStg)/7./,
     3  xK07319(ipLnNelem)/19./, xK07319(ipLnRedis)/-1./,
     4  xK07319(ipLnAul)/0.277/
*
*     [K XI] 4249.99 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data xK11425(ipLnWlAng)/4250./,xK11425(ipLnGl)/4./,
     1  xK11425(ipLnGu)/2./, xK11425(ipLnGF)/0./,
     2  xK11425(ipLnEnrWN)/23530./,xK11425(ipLnIonStg)/11./,
     3  xK11425(ipLnNelem)/19./, xK11425(ipLnRedis)/-1./,
     4  xK11425(ipLnAul)/234./
*
*     calcium line optical depth data
      data CaI4228(ipLnWlAng)/4228./,CaI4228(ipLnGl)/ 1./,
     1  CaI4228(ipLnGu)/ 3./,CaI4228(ipLnGF)/1.94E+00/,
     2  CaI4228(ipLnEnrWN)/23652.304/,CaI4228(ipLnIonStg)/1./,
     3  CaI4228(ipLnNelem)/20./,CaI4228(ipLnRedis)/1./
     4  CaI4228(ipLnAul)/0./
*
      data t3934(ipLnWlAng)/3934./,t3934(ipLnGl)/2./,
     1  t3934(ipLnGu)/4./, t3934(ipLnGF)/1.30/ ,
     2  t3934(ipLnEnrWN)/25414.427/,t3934(ipLnIonStg)/2./,
     3  t3934(ipLnNelem)/20./, t3934(ipLnRedis)/1./
*
      data t3969(ipLnWlAng)/3969./,t3969(ipLnGl)/2./,
     1  t3969(ipLnGu)/2./, t3969(ipLnGF)/.644/ ,
     2  t3969(ipLnEnrWN)/25191.541/,t3969(ipLnIonStg)/2./,
     3  t3969(ipLnNelem)/20./, t3969(ipLnRedis)/1./
*
      data t8498(ipLnWlAng)/8498./,t8498(ipLnGl)/4./,
     1  t8498(ipLnGu)/4./, t8498(ipLnGF)/3.56E-2/,
     2  t8498(ipLnEnrWN)/11764.215/,t8498(ipLnIonStg)/2./,
     3  t8498(ipLnNelem)/20./ , t8498(ipLnRedis)/1./
*
      data t8542(ipLnWlAng)/8542./,t8542(ipLnGl)/6./,
     1  t8542(ipLnGu)/4./, t8542(ipLnGF)/0.327/,
     2  t8542(ipLnEnrWN)/11703.526/,t8542(ipLnIonStg)/2./,
     3  t8542(ipLnNelem)/20./, t8542(ipLnRedis)/1./
*
      data t8662(ipLnWlAng)/8662./,t8662(ipLnGl)/4./,
     1  t8662(ipLnGu)/2./, t8662(ipLnGF)/.178/,
     2  t8662(ipLnEnrWN)/11541.329/,t8662(ipLnIonStg)/2./,
     3  t8662(ipLnNelem)/20./, t8662(ipLnRedis)/1./
*
      data t7291(ipLnWlAng)/7291./,t7291(ipLnGl)/2./,
     1  t7291(ipLnGu)/6./,t7291(ipLnGF)/4.76E-8/ ,
     2  t7291(ipLnEnrWN)/13710.901/,t7291(ipLnIonStg)/2./,
     3  t7291(ipLnNelem)/20./, t7291(ipLnRedis)/1./
*
      data t7324(ipLnWlAng)/7324./,t7324(ipLnGl)/2./,
     1  t7324(ipLnGu)/4./,t7324(ipLnGF)/3.23E-8/ ,
     2  t7324(ipLnEnrWN)/13650.212/,t7324(ipLnIonStg)/2./,
     3  t7324(ipLnNelem)/20./, t7324(ipLnRedis)/1./
*
      data tCa302(ipLnWlAng)/302./ ,tCa302(ipLnGl)/2./,
     1 tCa302(ipLnGu)/4./, tCa302(ipLnGF)/0.1076/,
     2 tCa302(ipLnEnrWN)/330917.6/ ,tCa302(ipLnIonStg)/18./,
     3 tCa302(ipLnNelem)/20./ , tCa302(ipLnRedis)/1./
*
      data tCa345(ipLnWlAng)/345./ ,tCa345(ipLnGl)/2./,
     1  tCa345(ipLnGu)/2./, tCa345(ipLnGF)/0.0472/,
     2  tCa345(ipLnEnrWN)/290056.9/ ,tCa345(ipLnIonStg)/18./,
     2  tCa345(ipLnNelem)/20./ , tCa345(ipLnRedis)/1./
*
      data tCa19(ipLnWlAng)/19./ ,tCa19(ipLnGl)/2./,
     1  tCa19(ipLnGu)/6./, tCa19(ipLnGF)/0.746/,
     2  tCa19(ipLnEnrWN)/5.346164E+06/ ,tCa19(ipLnIonStg)/18./,
     3  tCa19(ipLnNelem)/20./, tCa19(ipLnRedis)/1./
*
*     Jim Kingdon added these fs lines
*     [Ca IV] 3.21 min
      data tCa3(ipLnWlAng)/3.21e4/,tCa3(ipLnGl)/4./,
     1  tCa3(ipLnGu)/2./, tCa3(ipLnGF)/1.68e-7/,
     2  tCa3(ipLnEnrWN)/3118.46/,tCa3(ipLnIonStg)/4./,
     3  tCa3(ipLnNelem)/20./, tCa3(ipLnRedis)/-1./
*
      data tCa12(ipLnWlAng)/1.14e5/,tCa12(ipLnGl)/3./,
     1  tCa12(ipLnGu)/1./, tCa12(ipLnGF)/7.01e-8/,
     2  tCa12(ipLnEnrWN)/870.93/,tCa12(ipLnIonStg)/5./,
     3  tCa12(ipLnNelem)/20./, tCa12(ipLnRedis)/-1./
*
      data tCa4(ipLnWlAng)/4.15e4/,tCa4(ipLnGl)/5./,
     1  tCa4(ipLnGu)/3./, tCa4(ipLnGF)/2.41e-7/,
     2  tCa4(ipLnEnrWN)/2404.66/,tCa4(ipLnIonStg)/5./,
     3  tCa4(ipLnNelem)/20./, tCa4(ipLnRedis)/-1./
*
*     [Ca VII] 4.09 micron
      data Ca0741(ipLnWlAng)/4.09e4/,Ca0741(ipLnGl)/3./,
     1  Ca0741(ipLnGu)/5./, Ca0741(ipLnGF)/0./,
     2  Ca0741(ipLnEnrWN)/2446.5/,Ca0741(ipLnIonStg)/7./,
     3  Ca0741(ipLnNelem)/20./, Ca0741(ipLnRedis)/-1./,
     4  Ca0741(ipLnAul)/0.196/
*
*     [Ca VII] 6.15 micron
      data Ca0761(ipLnWlAng)/6.15e4/,Ca0761(ipLnGl)/1./,
     1  Ca0761(ipLnGu)/3./, Ca0761(ipLnGF)/0./,
     2  Ca0761(ipLnEnrWN)/1624.9/,Ca0761(ipLnIonStg)/7./,
     3  Ca0761(ipLnNelem)/20./, Ca0761(ipLnRedis)/-1./,
     4  Ca0761(ipLnAul)/0.0767/
*
*     [Ca VIII] 2.32 micron
      data Ca08232(ipLnWlAng)/2.32e4/,Ca08232(ipLnGl)/2./,
     1  Ca08232(ipLnGu)/4./, Ca08232(ipLnGF)/0./,
     2  Ca08232(ipLnEnrWN)/4306.55/,Ca08232(ipLnIonStg)/8./,
     3  Ca08232(ipLnNelem)/20./, Ca08232(ipLnRedis)/-1./,
     4  Ca08232(ipLnAul)/0.72/
*
*     [Ca 12] 3328.78 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Ca12333(ipLnWlAng)/3329./,Ca12333(ipLnGl)/4./,
     1  Ca12333(ipLnGu)/2./, Ca12333(ipLnGF)/0./,
     2  Ca12333(ipLnEnrWN)/30041./,Ca12333(ipLnIonStg)/12./,
     3  Ca12333(ipLnNelem)/20./, Ca12333(ipLnRedis)/-1./,
     4  Ca12333(ipLnAul)/487./
*
*     scandium data
*     [Sc V] 2.31 micron
      data Sc05231(ipLnWlAng)/2.31e4/,Sc05231(ipLnGl)/4./,
     1  Sc05231(ipLnGu)/2./, Sc05231(ipLnGF)/0./,
     2  Sc05231(ipLnEnrWN)/4326.8/,Sc05231(ipLnIonStg)/5./,
     3  Sc05231(ipLnNelem)/21./, Sc05231(ipLnRedis)/-1./,
     4  Sc05231(ipLnAul)/1.46/
*
*     [Sc 13] 2637.97 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Sc13264(ipLnWlAng)/2638./,Sc13264(ipLnGl)/4./,
     1  Sc13264(ipLnGu)/2./, Sc13264(ipLnGF)/0./,
     2  Sc13264(ipLnEnrWN)/37908./,Sc13264(ipLnIonStg)/13./,
     3  Sc13264(ipLnNelem)/21./, Sc13264(ipLnRedis)/-1./,
     4  Sc13264(ipLnAul)/978./
*
*     Titanium data
*     [Ti VI] 1.72 micron
      data Ti06172(ipLnWlAng)/1.72e4/,Ti06172(ipLnGl)/4./,
     1  Ti06172(ipLnGu)/2./, Ti06172(ipLnGF)/0./,
     2  Ti06172(ipLnEnrWN)/5830.9/,Ti06172(ipLnIonStg)/6./,
     3  Ti06172(ipLnNelem)/22./, Ti06172(ipLnRedis)/-1./,
     4  Ti06172(ipLnAul)/3.56/
*
*     [Ti 14] 2117.79 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Ti14212(ipLnWlAng)/2118./,Ti14212(ipLnGl)/4./,
     1  Ti14212(ipLnGu)/2./, Ti14212(ipLnGF)/0./,
     2  Ti14212(ipLnEnrWN)/47219./,Ti14212(ipLnIonStg)/14./,
     3  Ti14212(ipLnNelem)/22./, Ti14212(ipLnRedis)/-1./,
     4  Ti14212(ipLnAul)/1890./
*
*     Vanadium data
*     [V VII] 1.30 micron
      data Va07130(ipLnWlAng)/1.30e4/,Va07130(ipLnGl)/4./,
     1  Va07130(ipLnGu)/2./, Va07130(ipLnGF)/0./,
     2  Va07130(ipLnEnrWN)/7669.9/,Va07130(ipLnIonStg)/7./,
     3  Va07130(ipLnNelem)/23./, Va07130(ipLnRedis)/-1./,
     4  Va07130(ipLnAul)/8.11/
*
*     [V 15] 1721.38 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Va15172(ipLnWlAng)/1721./,Va15172(ipLnGl)/4./,
     1  Va15172(ipLnGu)/2./, Va15172(ipLnGF)/0./,
     2  Va15172(ipLnEnrWN)/58093./,Va15172(ipLnIonStg)/15./,
     3  Va15172(ipLnNelem)/23./, Va15172(ipLnRedis)/-1./,
     4  Va15172(ipLnAul)/3520./
*
*     Chromium data
*     [Cr VIII] 1.01 micron
      data Cr08101(ipLnWlAng)/1.01e4/,Cr08101(ipLnGl)/4./,
     1  Cr08101(ipLnGu)/2./, Cr08101(ipLnGF)/0./,
     2  Cr08101(ipLnEnrWN)/9895.1/,Cr08101(ipLnIonStg)/8./,
     3  Cr08101(ipLnNelem)/24./, Cr08101(ipLnRedis)/-1./,
     4  Cr08101(ipLnAul)/17.4/
*
*     [Cr 16] 1410.60 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Cr16141(ipLnWlAng)/1411./,Cr16141(ipLnGl)/4./,
     1  Cr16141(ipLnGu)/2./, Cr16141(ipLnGF)/0./,
     2  Cr16141(ipLnEnrWN)/70892./,Cr16141(ipLnIonStg)/16./,
     3  Cr16141(ipLnNelem)/24./, Cr16141(ipLnRedis)/-1./,
     4  Cr16141(ipLnAul)/6390./
*
*     Manganese data
*     [Mn IX] 7968.5A
      data xMn0979(ipLnWlAng)/7968.5/,xMn0979(ipLnGl)/4./,
     1  xMn0979(ipLnGu)/2./, xMn0979(ipLnGF)/0./,
     2  xMn0979(ipLnEnrWN)/12549.4/,xMn0979(ipLnIonStg)/9./,
     3  xMn0979(ipLnNelem)/25./, xMn0979(ipLnRedis)/-1./,
     4  xMn0979(ipLnAul)/35.5/
*
*     [Mn 17] 1169.59 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data xMn1712(ipLnWlAng)/1170./,xMn1712(ipLnGl)/4./,
     1  xMn1712(ipLnGu)/2./, xMn1712(ipLnGF)/0./,
     2  xMn1712(ipLnEnrWN)/85500./,xMn1712(ipLnIonStg)/17./,
     3  xMn1712(ipLnNelem)/25./, xMn1712(ipLnRedis)/-1./,
     4  xMn1712(ipLnAul)/11200./
*
*     iron Fe line optical depth data
      data FeI3884(ipLnWlAng)/3884./,FeI3884(ipLnGl)/25./,
     1  FeI3884(ipLnGu)/25./,FeI3884(ipLnGF)/5.65E-01/,
     2  FeI3884(ipLnEnrWN)/25748.000/,FeI3884(ipLnIonStg)/1./,
     3  FeI3884(ipLnNelem)/26./,FeI3884(ipLnRedis)/1./
     4  FeI3884(ipLnAul)/0./
*
      data FeI3729(ipLnWlAng)/3729./,FeI3729(ipLnGl)/25./,
     1  FeI3729(ipLnGu)/35./,FeI3729(ipLnGF)/1.18E+00/,
     2  FeI3729(ipLnEnrWN)/26817.000/,FeI3729(ipLnIonStg)/1./,
     3  FeI3729(ipLnNelem)/26./,FeI3729(ipLnRedis)/1./
     4  FeI3729(ipLnAul)/0./
*
      data FeI3457(ipLnWlAng)/3457./,FeI3457(ipLnGl)/25./,
     1  FeI3457(ipLnGu)/15./,FeI3457(ipLnGF)/6.00E-01/,
     2  FeI3457(ipLnEnrWN)/28926.000/,FeI3457(ipLnIonStg)/1./,
     3  FeI3457(ipLnNelem)/26./,FeI3457(ipLnRedis)/1./
     4  FeI3457(ipLnAul)/0./
*
      data FeI3021(ipLnWlAng)/3021./,FeI3021(ipLnGl)/25./,
     1  FeI3021(ipLnGu)/25./,FeI3021(ipLnGF)/3.50E+00/,
     2  FeI3021(ipLnEnrWN)/33101.000/,FeI3021(ipLnIonStg)/1./,
     3  FeI3021(ipLnNelem)/26./,FeI3021(ipLnRedis)/1./
     4  FeI3021(ipLnAul)/0./
*
      data FeI2966(ipLnWlAng)/2966./,FeI2966(ipLnGl)/25./,
     1  FeI2966(ipLnGu)/35./,FeI2966(ipLnGF)/1.20E+00/,
     2  FeI2966(ipLnEnrWN)/33715.000/,FeI2966(ipLnIonStg)/1./,
     3  FeI2966(ipLnNelem)/26./,FeI2966(ipLnRedis)/1./
     4  FeI2966(ipLnAul)/0./
*
      data tuv3(ipLnWlAng)/2360./,tuv3(ipLnGl)/1./,
     1  tuv3(ipLnGu)/1./, tuv3(ipLnGF)/0.500/ ,
     2  tuv3(ipLnEnrWN)/42372.881/,tuv3(ipLnIonStg)/2./,
     3  tuv3(ipLnNelem)/26./, tuv3(ipLnRedis)/-1./
*
      data tr48(ipLnWlAng)/6200./,tr48(ipLnGl)/1./,
     1  tr48(ipLnGu)/1./, tr48(ipLnGF)/3.98E-4/ ,
     2  tr48(ipLnEnrWN)/20000./,tr48(ipLnIonStg)/2./,
     3  tr48(ipLnNelem)/26./, tr48(ipLnRedis)/-1./
*
      data tFe16(ipLnWlAng)/1080./,tFe16(ipLnGl)/1./,
     1  tFe16(ipLnGu)/1./,tFe16(ipLnGF)/7.0E-3/ ,
     2  tFe16(ipLnEnrWN)/90900./,tFe16(ipLnIonStg)/2./,
     3  tFe16(ipLnNelem)/26./, tFe16(ipLnRedis)/-1./
*
      data tFe26(ipLnWlAng)/1500./,tFe26(ipLnGl)/1./,
     1  tFe26(ipLnGu)/1./,tFe26(ipLnGF)/0.00337/ ,
     2  tFe26(ipLnEnrWN)/66670./,tFe26(ipLnIonStg)/2./,
     3  tFe26(ipLnNelem)/26./, tFe26(ipLnRedis)/-1./
*
      data tFe34(ipLnWlAng)/11500./,tFe34(ipLnGl)/1./,
     1  tFe34(ipLnGu)/1./,tFe34(ipLnGF)/5.9E-4/ ,
     2  tFe34(ipLnEnrWN)/8850./,tFe34(ipLnIonStg)/2./,
     3  tFe34(ipLnNelem)/26./, tFe34(ipLnRedis)/-1./
*
      data tFe35(ipLnWlAng)/2500./,tFe35(ipLnGl)/1./,
     1  tFe35(ipLnGu)/1./,tFe35(ipLnGF)/0.2/ ,
     2  tFe35(ipLnEnrWN)/40000./,tFe35(ipLnIonStg)/2./,
     3  tFe35(ipLnNelem)/26./, tFe35(ipLnRedis)/-1./
*
      data tFe46(ipLnWlAng)/2300./,tFe46(ipLnGl)/1./,
     1  tFe46(ipLnGu)/1./,tFe46(ipLnGF)/0.0158/ ,
     2  tFe46(ipLnEnrWN)/43470./,tFe46(ipLnIonStg)/2./,
     3  tFe46(ipLnNelem)/26./, tFe46(ipLnRedis)/-1./
*
      data tFe56(ipLnWlAng)/8900./,tFe56(ipLnGl)/1./,
     1  tFe56(ipLnGu)/1./,tFe56(ipLnGF)/.47/ ,
     2  tFe56(ipLnEnrWN)/11236./,tFe56(ipLnIonStg)/2./,
     3  tFe56(ipLnNelem)/26./, tFe56(ipLnRedis)/-1./
*
      data t1122(ipLnWlAng)/1122./,t1122(ipLnGl)/25./,
     1  t1122(ipLnGu)/15./, t1122(ipLnGF)/1.9875/ ,
     2  t1122(ipLnEnrWN)/88826.495/,t1122(ipLnIonStg)/3./,
     3  t1122(ipLnNelem)/26./, t1122(ipLnRedis)/1./
*
*     [Fe VII] 9.53 mic, A
*     >>refer Nussbaumer, H., & Storey, P.J. 1982, A&A, 113, 21
      data Fe0795(ipLnWlAng)/9.51e4/,Fe0795(ipLnGl)/5./,
     1  Fe0795(ipLnGu)/7./, Fe0795(ipLnGF)/0./ ,
     2  Fe0795(ipLnEnrWN)/1049.68/,Fe0795(ipLnIonStg)/7./,
     3  Fe0795(ipLnNelem)/26./, Fe0795(ipLnRedis)/1./ ,
     4  Fe0795(ipLnAul)/0.0298/
*
*     [Fe VII] 7.81 mic, A
*     >>refer Nussbaumer, H., & Storey, P.J. 1982, A&A, 113, 21
      data Fe0778(ipLnWlAng)/7.81e4/,Fe0778(ipLnGl)/7./,
     1  Fe0778(ipLnGu)/9./, Fe0778(ipLnGF)/0./ ,
     2  Fe0778(ipLnEnrWN)/1279.67/,Fe0778(ipLnIonStg)/7./,
     3  Fe0778(ipLnNelem)/26./, Fe0778(ipLnRedis)/1./ ,
     4  Fe0778(ipLnAul)/0.0424/
*
      data t245(ipLnWlAng)/245./,t245(ipLnGl)/1./,
     1  t245(ipLnGu)/3./, t245(ipLnGF)/2.4e-4/ ,
     2  t245(ipLnEnrWN)/408163./,t245(ipLnIonStg)/9./,
     3  t245(ipLnNelem)/26./, t245(ipLnRedis)/-1./
*
*     this is pump line for upper level of [FeX] 6375
      data t352(ipLnWlAng)/352./,t352(ipLnGl)/6./,
     1  t352(ipLnGu)/2./, t352(ipLnGF)/0.169/ ,
     2  t352(ipLnEnrWN)/284021./,t352(ipLnIonStg)/10./,
     3  t352(ipLnNelem)/26./, t352(ipLnRedis)/1./
*
*     [FeX] 6375 coronal line
*     A
*     >>refer Bhatia, A.K., & Doscheck, G.A. 1995 ADNDT, 60, 9
      data Fe106375(ipLnWlAng)/6375./,Fe106375(ipLnGl)/4./,
     1  Fe106375(ipLnGu)/2./, Fe106375(ipLnGF)/0./ ,
     2  Fe106375(ipLnEnrWN)/15686./,Fe106375(ipLnIonStg)/10./,
     3  Fe106375(ipLnNelem)/26./, Fe106375(ipLnRedis)/1./ ,
     4  Fe106375(ipLnAul)/54.91/
*
*     actually three lines contributing here, important for coronal pump
*     following is whole multiplet average
      data t353(ipLnWlAng)/353./,t353(ipLnGl)/9./,
     1  t353(ipLnGu)/9./, t353(ipLnGF)/0.553/ ,
     2  t353(ipLnEnrWN)/283286./,t353(ipLnIonStg)/11./,
     3  t353(ipLnNelem)/26./, t353(ipLnRedis)/1./
*
*     [Fe XIII] 1.07 microns
      data Fe1310(ipLnWlAng)/1.07e4/,Fe1310(ipLnGl)/1./,
     1  Fe1310(ipLnGu)/3./, Fe1310(ipLnGF)/0./ ,
     2  Fe1310(ipLnEnrWN)/9302.5/,Fe1310(ipLnIonStg)/13./,
     3  Fe1310(ipLnNelem)/26./, Fe1310(ipLnRedis)/-1./ ,
     4  Fe1310(ipLnAul)/14.0/
*
*     [Fe XIII] 1.08 microns
      data Fe1311(ipLnWlAng)/1.08e4/,Fe1311(ipLnGl)/3./,
     1  Fe1311(ipLnGu)/5./, Fe1311(ipLnGF)/0./ ,
     2  Fe1311(ipLnEnrWN)/9258.5/,Fe1311(ipLnIonStg)/13./,
     3  Fe1311(ipLnNelem)/26./, Fe1311(ipLnRedis)/-1./,
     4  Fe1311(ipLnAul)/9.86/
*
      data t347(ipLnWlAng)/347./,t347(ipLnGl)/6./,
     1  t347(ipLnGu)/10./, t347(ipLnGF)/0.4092/ ,
     2  t347(ipLnEnrWN)/288184./,t347(ipLnIonStg)/14./,
     3  t347(ipLnNelem)/26./, t347(ipLnRedis)/1./
*
      data t192(ipLnWlAng)/192./ ,t192(ipLnGl)/2./,
     1  t192(ipLnGu)/4./, t192(ipLnGF)/.0964/,
     2  t192(ipLnEnrWN)/520725./ ,t192(ipLnIonStg)/24./,
     3  t192(ipLnNelem)/26./ , t192(ipLnRedis)/1./
*
      data t255(ipLnWlAng)/255./ ,t255(ipLnGl)/2./,
     1  t255(ipLnGu)/2./, t255(ipLnGF)/.0362/,
     2  t255(ipLnEnrWN)/392003./ ,t255(ipLnIonStg)/24./,
     3  t255(ipLnNelem)/26./ , t255(ipLnRedis)/1./
*
      data t11(ipLnWlAng)/11./ ,t11(ipLnGl)/2./,
     1  t11(ipLnGu)/6./, t11(ipLnGF)/.784/,
     2  t11(ipLnEnrWN)/9.403799E+06/ ,t11(ipLnIonStg)/24./,
     3  t11(ipLnNelem)/26./, t11(ipLnRedis)/1./
*
*     this transition from
*     >>refer Johansson, S., Brage, T., Leckrone, D.S., Nave, G. & Wahlgren,
*     >>refer G.M. 1995, ApJ 446, 361
      data t191(ipLnWlAng)/1787./ ,t191(ipLnGl)/6./,
     1  t191(ipLnGu)/22./, t191(ipLnGF)/9.3/,
     2  t191(ipLnEnrWN)/55978.9/ ,t191(ipLnIonStg)/2./,
     3  t191(ipLnNelem)/26./, t191(ipLnRedis)/1./
*
*     Jim Kingdon added these fs lines
      data tFe07(ipLnWlAng)/7.892e3/,tFe07(ipLnGl)/5./,
     1  tFe07(ipLnGu)/3./, tFe07(ipLnGF)/1.22e-6/,
     2  tFe07(ipLnEnrWN)/12691.24/,tFe07(ipLnIonStg)/11./,
     3  tFe07(ipLnNelem)/26./, tFe07(ipLnRedis)/-1./
*
      data tFe61(ipLnWlAng)/6.1e4/,tFe61(ipLnGl)/3./,
     1  tFe61(ipLnGu)/1./, tFe61(ipLnGF)/1.25e-7/,
     2  tFe61(ipLnEnrWN)/1775.38/,tFe61(ipLnIonStg)/11./,
     3  tFe61(ipLnNelem)/26./, tFe61(ipLnRedis)/-1./
*
*     [Fe 18] 974.86 A
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     energies
*     >>refer Sugar, J., & Corliss, C 1985 J Phys Chem Ref Dat, vol 14
      data Fe18975(ipLnWlAng)/974.9/,Fe18975(ipLnGl)/4./,
     1  Fe18975(ipLnGu)/2./, Fe18975(ipLnGF)/0./,
     2  Fe18975(ipLnEnrWN)/102579./,Fe18975(ipLnIonStg)/18./,
     3  Fe18975(ipLnNelem)/26./, Fe18975(ipLnRedis)/-1./,
     4  Fe18975(ipLnAul)/19300./
*
      data tFe23(ipLnWlAng)/2.299e3/,tFe23(ipLnGl)/3./,
     1  tFe23(ipLnGu)/5./, tFe23(ipLnGF)/3.43e-6/,
     2  tFe23(ipLnEnrWN)/43503.51/,tFe23(ipLnIonStg)/21./,
     3  tFe23(ipLnNelem)/26./, tFe23(ipLnRedis)/-1./
*
      data tFe13(ipLnWlAng)/1.354e3/,tFe13(ipLnGl)/1./,
     1  tFe13(ipLnGu)/3./, tFe13(ipLnGF)/5.10e-6/,
     2  tFe13(ipLnEnrWN)/73850./,tFe13(ipLnIonStg)/21./,
     3  tFe13(ipLnNelem)/26./, tFe13(ipLnRedis)/-1./
*
*     Cobalt data
*     [Co XI] 5168.A
      data Co11527(ipLnWlAng)/5168.0/,Co11527(ipLnGl)/4./,
     1  Co11527(ipLnGu)/2./, Co11527(ipLnGF)/0./,
     2  Co11527(ipLnEnrWN)/19350./,Co11527(ipLnIonStg)/11./,
     3  Co11527(ipLnNelem)/27./, Co11527(ipLnRedis)/-1./,
     4  Co11527(ipLnAul)/130.0/
*
*     Nickel data
*     [Ni XII] 4230.8A
      data xNi1242(ipLnWlAng)/4230.8/,xNi1242(ipLnGl)/4./,
     1  xNi1242(ipLnGu)/2./, xNi1242(ipLnGF)/0./,
     2  xNi1242(ipLnEnrWN)/23635.6/,xNi1242(ipLnIonStg)/12./,
     3  xNi1242(ipLnNelem)/28./, xNi1242(ipLnRedis)/-1./,
     4  xNi1242(ipLnAul)/237.0/
*
      end
      block data blckwind
      implicit none
*block data that includes all level 2, or wind, lines
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     these are expansions for collision strengths
*     210 is total number of coef from mewe plus gaetz and salpeter
      real g(4,210)
      common/MeweCoef/ g
      real u
*
*     a negative element number indicates that the line should be removed
*     elsewhere this appears as WindLine not u
      common/WindData/ u(nta,NWINDLINE)
      integer i
*
*     block data lines
*     common/g/g(4,210)
*     common/u/u(7,6744)
* July 7, 1996. OIV 609 line is corrected.
      DATA (g(i, 2),i=1,4)/ 0.15, 0.00, 0.00, 0.28/
      DATA (g(i, 3),i=1,4)/ 0.60, 0.00, 0.00, 0.28/
      DATA (g(i, 4),i=1,4)/ 0.04, 0.21,-0.04, 0.28/
      DATA (g(i, 5),i=1,4)/ 0.27, 0.08, 0.00, 0.28/
      DATA (g(i, 6),i=1,4)/ 0.33, 0.05, 0.00, 0.28/
      DATA (g(i, 7),i=1,4)/ 0.36, 0.04, 0.00, 0.28/
      DATA (g(i, 8),i=1,4)/ 0.37, 0.03, 0.00, 0.28/
      DATA (g(i, 9),i=1,4)/ 0.38, 0.03, 0.00, 0.28/
      DATA (g(i,10),i=1,4)/ 0.02, 0.02, 0.00, 0.28/
      DATA (g(i,11),i=1,4)/ 0.04, 0.20,-0.04, 0.28/
      DATA (g(i,12),i=1,4)/ 0.20, 0.05, 0.00, 0.28/
      DATA (g(i,13),i=1,4)/ 0.30, 0.05, 0.00, 0.28/
      DATA (g(i,14),i=1,4)/ 0.70, 1.00,-0.50, 0.28/
      DATA (g(i,15),i=1,4)/-0.30, 0.60,-0.20, 0.28/
      DATA (g(i,16),i=1,4)/-0.32, 0.88,-0.27, 0.28/
      DATA (g(i,17),i=1,4)/-0.26, 0.63,-0.30, 0.28/
      DATA (g(i,18),i=1,4)/-0.16, 0.80,-0.20, 0.28/
      DATA (g(i,19),i=1,4)/ 0.05, 0.20, 0.00, 0.28/
      DATA (g(i,20),i=1,4)/ 0.20, 0.15, 0.00, 0.28/
      DATA (g(i,21),i=1,4)/-0.17, 0.25, 0.00, 0.28/
      DATA (g(i,22),i=1,4)/-0.04, 0.20, 0.00, 0.28/
      DATA (g(i,23),i=1,4)/0.055, 0.00, 0.00, 0.00/
      DATA (g(i,24),i=1,4)/ 0.00, 0.00, 0.07, 0.00/
      DATA (g(i,25),i=1,4)/ 0.00, 0.00, 0.20, 0.00/
      DATA (g(i,  26),i=1,4)/5.28E-04, 0.145,7.60,1./
      DATA (g(i,  27),i=1,4)/1.16E-03, 0.191,7.60,1./
      DATA (g(i,  28),i=1,4)/3.63E-03, 0.268,7.90,1./
      DATA (g(i,  29),i=1,4)/4.35E-03, 0.323,7.60,1./
      DATA (g(i,  30),i=1,4)/1.49E-03,-0.506,7.60,1./
      DATA (g(i,  31),i=1,4)/1.01E-03,-0.009,7.60,1./
      DATA (g(i,  32),i=1,4)/3.62E-03, 0.198,7.25,1./
      DATA (g(i,  33),i=1,4)/6.44E-04,-0.579,7.60,1./
      DATA (g(i,  34),i=1,4)/3.03E-03, 0.122,6.80,1./
      DATA (g(i,  35),i=1,4)/8.29E-03, 0.199,7.20,1./
      DATA (g(i,  36),i=1,4)/8.63E-03, 0.263,6.80,1./
      DATA (g(i,  37),i=1,4)/2.35E-03, 0.052,6.80,1./
      DATA (g(i,  38),i=1,4)/3.03E-03,-0.145,6.80,1./
      DATA (g(i,  39),i=1,4)/2.33E-03,-0.312,6.80,1./
      DATA (g(i,  40),i=1,4)/1.87E-03, 0.078,6.60,1./
      DATA (g(i,  41),i=1,4)/3.92E-03, 0.109,6.60,1./
      DATA (g(i,  42),i=1,4)/1.04E-02, 0.177,7.00,1./
      DATA (g(i,  43),i=1,4)/1.99E-03, 0.028,7.00,1./
      DATA (g(i,  44),i=1,4)/1.02E-02, 0.235,6.60,1./
      DATA (g(i,  45),i=1,4)/3.20E-03,-0.026,6.60,1./
      DATA (g(i,  46),i=1,4)/3.28E-03,-0.224,6.60,1./
      DATA (g(i,  47),i=1,4)/3.05E-03,-0.424,6.60,1./
      DATA (g(i,  48),i=1,4)/2.55E-03, 0.071,6.40,1./
      DATA (g(i,  49),i=1,4)/5.31E-03, 0.099,6.40,1./
      DATA (g(i,  50),i=1,4)/4.72E-03, 0.026,7.25,1./
      DATA (g(i,  51),i=1,4)/1.38E-02, 0.160,6.80,1./
      DATA (g(i,  52),i=1,4)/2.68E-03, 0.025,6.80,1./
      DATA (g(i,  53),i=1,4)/1.35E-02, 0.306,6.40,1./
      DATA (g(i,  54),i=1,4)/4.04E-03, 0.026,6.40,1./
      DATA (g(i,  55),i=1,4)/3.46E-03,-0.201,6.40,1./
      DATA (g(i,  56),i=1,4)/3.65E-03,-0.376,6.40,1./
      DATA (g(i,  57),i=1,4)/1.09E-02, 0.402,7.25,1./
      DATA (g(i,  58),i=1,4)/1.25E-02, 0.442,7.15,1./
      DATA (g(i,  59),i=1,4)/3.80E-02, 0.203,7.05,1./
      DATA (g(i,  60),i=1,4)/1.94E-02, 0.153,6.60,1./
      DATA (g(i,  61),i=1,4)/3.81E-03, 0.023,6.60,1./
      DATA (g(i,  62),i=1,4)/1.78E-02, 0.212,7.00,1./
      DATA (g(i,  63),i=1,4)/3.39E-02, 0.231,7.00,1./
      DATA (g(i,  64),i=1,4)/1.12E-02, 0.097,7.00,1./
      DATA (g(i,  65),i=1,4)/1.66E-02, 0.256,6.20,1./
      DATA (g(i,  66),i=1,4)/1.48E-02,-0.147,6.20,1./
      DATA (g(i,  67),i=1,4)/1.72E-03, 0.336,6.80,1./
      DATA (g(i,  68),i=1,4)/4.98E-03, 0.493,6.70,1./
      DATA (g(i,  69),i=1,4)/2.17E-03, 0.434,6.80,1./
      DATA (g(i,  70),i=1,4)/2.59E-03, 0.402,6.80,1./
      DATA (g(i,  71),i=1,4)/1.27E-01, 0.246,6.70,1./
      DATA (g(i,  72),i=1,4)/4.71E-02, 0.202,6.70,1./
      DATA (g(i,  73),i=1,4)/1.22E-02,-0.239,6.70,1./
      DATA (g(i,  74),i=1,4)/2.68E-05, 0.125,6.30,1./
      DATA (g(i,  75),i=1,4)/3.08E-02, 0.219,6.70,1./
      DATA (g(i,  76),i=1,4)/3.15E-02, 0.244,6.70,1./
      DATA (g(i,  77),i=1,4)/1.13E-02, 0.080,5.90,1./
      DATA (g(i,  78),i=1,4)/4.81E-05, 0.125,6.30,1./
      DATA (g(i,  79),i=1,4)/5.87E-03, 0.015,6.30,1./
      DATA (g(i,  80),i=1,4)/2.31E-02, 0.254,5.90,1./
      DATA (g(i,  81),i=1,4)/8.26E-03, 0.042,5.90,1./
      DATA (g(i,  82),i=1,4)/7.06E-03,-0.129,5.90,1./
      DATA (g(i,  83),i=1,4)/7.39E-03,-0.206,5.90,1./
      DATA (g(i,  84),i=1,4)/3.81E-02, 0.112,6.15,1./
      DATA (g(i,  85),i=1,4)/5.12E-02, 0.118,6.00,1./
      DATA (g(i,  86),i=1,4)/1.03E-02, 0.005,6.00,1./
      DATA (g(i,  87),i=1,4)/2.06E-02, 0.064,5.50,1./
      DATA (g(i,  88),i=1,4)/2.25E-02, 0.345,6.55,1./
      DATA (g(i,  89),i=1,4)/2.96E-02, 0.282,5.50,1./
      DATA (g(i,  90),i=1,4)/1.09E-02, 0.094,5.50,1./
      DATA (g(i,  91),i=1,4)/2.80E-01, 0.285,6.15,1./
      DATA (g(i,  92),i=1,4)/1.41E-02, 0.510,6.65,1./
      DATA (g(i,  93),i=1,4)/1.36E-01, 0.145,6.20,1./
      DATA (g(i,  94),i=1,4)/3.67E-02, 0.591,6.55,1./
      DATA (g(i,  95),i=1,4)/1.79E-01, 0.299,6.10,1./
      DATA (g(i,  96),i=1,4)/6.68E-02, 0.298,6.10,1./
      DATA (g(i,  97),i=1,4)/8.75E-02, 0.352,6.45,1./
      DATA (g(i,  98),i=1,4)/3.04E-01, 0.149,5.95,1./
      DATA (g(i,  99),i=1,4)/8.96E-02, 0.146,7.00,1./
      DATA (g(i, 100),i=1,4)/1.95E-01, 0.153,7.05,1./
      DATA (g(i, 101),i=1,4)/1.08E-01, 0.146,7.00,1./
      DATA (g(i, 102),i=1,4)/2.69E-01, 0.141,6.90,1./
      DATA (g(i, 103),i=1,4)/4.42E-01, 0.163,7.15,1./
      DATA (g(i, 104),i=1,4)/1.26E-01, 0.141,7.00,1./
      DATA (g(i, 105),i=1,4)/1.27E-01, 0.149,7.05,1./
      DATA (g(i, 106),i=1,4)/3.90E-01, 0.296,5.65,1./
      DATA (g(i, 107),i=1,4)/1.60E+00, 0.083,5.40,1./
      DATA (g(i, 108),i=1,4)/1.29E+00, 0.112,5.65,1./
      DATA (g(i, 109),i=1,4)/1.37E+00, 0.141,5.90,1./
      DATA (g(i, 110),i=1,4)/1.08E+00, 0.142,5.90,1./
      DATA (g(i, 111),i=1,4)/7.59E+00, 0.278,6.00,2./
      DATA (g(i, 112),i=1,4)/3.87E+00, 0.162,6.10,1./
      DATA (g(i, 113),i=1,4)/2.13E+00, 0.115,5.65,1./
      DATA (g(i, 114),i=1,4)/2.12E+00, 0.163,6.10,1./
      DATA (g(i, 115),i=1,4)/2.98E+00, 0.168,6.15,1./
      DATA (g(i, 116),i=1,4)/1.20E+00, 0.146,5.90,1./
      DATA (g(i, 117),i=1,4)/8.09E-01, 0.165,6.10,1./
      DATA (g(i, 118),i=1,4)/9.23E-01, 0.101,6.15,2./
      DATA (g(i, 119),i=1,4)/4.07E+00, 0.174,6.20,1./
      DATA (g(i, 120),i=1,4)/1.54E+00, 0.180,6.30,1./
      DATA (g(i, 121),i=1,4)/3.48E-01, 0.181,6.30,1./
      DATA (g(i, 122),i=1,4)/3.42E-01, 0.167,7.25,1./
      DATA (g(i, 123),i=1,4)/1.14E+00, 0.027,6.45,2./
      DATA (g(i, 124),i=1,4)/4.27E-01, 0.091,6.00,1./
      DATA (g(i, 125),i=1,4)/4.39E-01, 0.110,6.10,1./
      DATA (g(i, 126),i=1,4)/2.72E-01, 0.230,5.20,1./
      DATA (g(i, 127),i=1,4)/2.74E-01, 0.126,5.60,1./
      DATA (g(i, 128),i=1,4)/9.82E-01, 0.034,6.30,2./
      DATA (g(i, 129),i=1,4)/1.15E+00, 0.149,6.40,1./
      DATA (g(i, 130),i=1,4)/7.14E-01, 0.179,6.15,1./
      DATA (g(i, 131),i=1,4)/2.21E+00, 0.019,6.45,2./
      DATA (g(i, 132),i=1,4)/5.28E-01, 0.129,5.80,1./
      DATA (g(i, 133),i=1,4)/1.67E+00, 0.298,5.40,1./
      DATA (g(i, 134),i=1,4)/6.89E-01, 0.153,5.80,2./
      DATA (g(i, 135),i=1,4)/2.53E-01, 0.019,6.45,2./
      DATA (g(i, 136),i=1,4)/3.64E+00, 0.150,6.55,1./
      DATA (g(i, 137),i=1,4)/3.50E-01, 0.068,6.10,1./
      DATA (g(i, 138),i=1,4)/1.12E+00, 0.028,6.25,1./
      DATA (g(i, 139),i=1,4)/4.16E-01, 0.204,4.95,1./
      DATA (g(i, 140),i=1,4)/1.49E+00, 0.089,5.90,2./
      DATA (g(i, 141),i=1,4)/7.73E-01, 0.017,6.30,2./
      DATA (g(i, 142),i=1,4)/1.26E+00, 0.083,5.95,2./
      DATA (g(i, 143),i=1,4)/2.36E+00, 0.152,6.65,1./
      DATA (g(i, 144),i=1,4)/1.32E+00, 0.011,6.45,2./
      DATA (g(i, 145),i=1,4)/6.06E-01, 0.073,6.10,1./
      DATA (g(i, 146),i=1,4)/8.50E-01, 0.045,6.10,2./
      DATA (g(i, 147),i=1,4)/7.61E-01, 0.127,5.45,1./
      DATA (g(i, 148),i=1,4)/1.70E+00, 0.027,6.15,2./
      DATA (g(i, 149),i=1,4)/2.46E+00, 0.030,6.20,2./
      DATA (g(i, 150),i=1,4)/3.78E-01, 0.233,5.45,1./
      DATA (g(i, 151),i=1,4)/1.36E+00, 0.013,6.30,2./
      DATA (g(i, 152),i=1,4)/4.32E-01, 0.217,5.80,1./
      DATA (g(i, 153),i=1,4)/1.61E+00, 0.111,6.00,1./
      DATA (g(i, 154),i=1,4)/2.30E+00, 0.178,5.60,2./
      DATA (g(i, 155),i=1,4)/1.76E+00, 0.185,5.60,2./
      DATA (g(i, 156),i=1,4)/6.46E-01, 0.196,5.80,1./
      DATA (g(i, 157),i=1,4)/9.25E-01, 0.096,5.90,2./
      DATA (g(i, 158),i=1,4)/2.11E+00, 0.068,5.70,1./
      DATA (g(i, 159),i=1,4)/7.17E-01, 0.184,5.45,1./
      DATA (g(i, 160),i=1,4)/1.03E+00, 0.136,6.30,1./
      DATA (g(i, 161),i=1,4)/5.65E-01, 0.163,4.95,1./
      DATA (g(i, 162),i=1,4)/1.38E+00, 0.148,5.20,1./
      DATA (g(i, 163),i=1,4)/4.64E-01, 0.113,5.60,1./
      DATA (g(i, 164),i=1,4)/8.93E-01, 0.164,5.45,1./
      DATA (g(i, 165),i=1,4)/3.95E-01, 0.123,5.20,1./
      DATA (g(i, 166),i=1,4)/1.33E+00, 0.126,6.05,1./
      DATA (g(i, 167),i=1,4)/3.08E+00, 0.067,5.40,1./
      DATA (g(i, 168),i=1,4)/1.34E+00, 0.195,4.90,1./
      DATA (g(i, 169),i=1,4)/9.23E-01, 0.128,4.95,1./
      DATA (g(i, 170),i=1,4)/3.50E+00, 0.171,5.10,1./
      DATA (g(i, 171),i=1,4)/4.03E+00, 0.157,5.20,1./
      DATA (g(i, 172),i=1,4)/1.93E+00, 0.117,5.80,1./
      DATA (g(i, 173),i=1,4)/8.63E+00, 0.135,5.20,1./
      DATA (g(i, 174),i=1,4)/1.05E+00, 0.098,5.20,1./
      DATA (g(i, 175),i=1,4)/5.83E-01, 0.289,4.45,1./
      DATA (g(i, 176),i=1,4)/1.16E+00, 0.108,4.95,1./
      DATA (g(i, 177),i=1,4)/4.23E-01,-0.124,4.35,1./
      DATA (g(i, 178),i=1,4)/9.19E-01, 0.269,4.35,1./
      DATA (g(i, 179),i=1,4)/1.27E+00, 0.072,4.45,1./
      DATA (g(i, 180),i=1,4)/7.70E+00, 0.156,5.30,1./
      DATA (g(i, 181),i=1,4)/4.61E+00, 0.094,4.85,1./
      DATA (g(i, 182),i=1,4)/9.30E-01, 0.061,4.90,1./
      DATA (g(i, 183),i=1,4)/5.84E-01, 0.159,4.25,1./
      DATA (g(i, 184),i=1,4)/5.35E-02,-0.106,5.60,1./
      DATA (g(i, 185),i=1,4)/2.98E+00, 0.103,5.45,1./
      DATA (g(i, 186),i=1,4)/3.50E-01, 0.230,4.35,1./
      DATA (g(i, 187),i=1,4)/9.37E-01, 0.028,5.10,1./
      DATA (g(i, 188),i=1,4)/1.39E+00, 0.062,4.45,1./
      DATA (g(i, 189),i=1,4)/4.69E-01, 0.888,4.25,1./
      DATA (g(i, 190),i=1,4)/2.97E-01, 0.113,4.80,1./
      DATA (g(i, 191),i=1,4)/1.13E+01, 0.193,4.90,1./
      DATA (g(i, 192),i=1,4)/3.48E-01,-0.325,5.40,1./
      DATA (g(i, 193),i=1,4)/3.98E+00, 0.103,5.30,1./
      DATA (g(i, 194),i=1,4)/1.73E+00, 0.439,4.25,1./
      DATA (g(i, 195),i=1,4)/2.64E-01, 0.205,4.25,1./
      DATA (g(i, 196),i=1,4)/1.18E+00, 0.148,4.35,1./
      DATA (g(i, 197),i=1,4)/5.78E-01,-0.466,5.10,1./
      DATA (g(i, 198),i=1,4)/1.01E+01, 0.135,5.05,1./
      DATA (g(i, 199),i=1,4)/1.63E-01,-0.169,5.20,1./
      DATA (g(i, 200),i=1,4)/5.24E-01,-0.290,5.20,1./
      DATA (g(i, 201),i=1,4)/4.52E-01, 0.248,4.25,1./
      DATA (g(i, 202),i=1,4)/5.13E+00, 0.108,5.00,1./
      DATA (g(i, 203),i=1,4)/1.10E-01,-0.205,4.95,1./
      DATA (g(i, 204),i=1,4)/2.71E-01,-0.130,4.90,1./
      DATA (g(i, 205),i=1,4)/1.00E-01, 0.133,4.25,1./
      DATA (g(i, 206),i=1,4)/2.47E+00,-0.494,4.90,1./
      DATA (g(i, 207),i=1,4)/8.81E-01,-0.162,4.85,1./
      DATA (g(i, 208),i=1,4)/4.26E-01,-0.365,4.45,1./
      DATA (g(i, 209),i=1,4)/5.14E-01,-0.055,4.35,1./
      DATA (g(i, 210),i=1,4)/2.10E+00,-0.302,4.25,1./
      DATA (u(i,   1),i=1,7)/ 3., 1., 2., 6., 1.49E+00,1.48285E+04, 0.1/
      DATA (u(i,   2),i=1,7)/ 3., 1., 2., 6., 9.58E-03,3.08131E+04,  1./
      DATA (u(i,   3),i=1,7)/ 3., 1., 2., 6., 8.60E-03,3.63465E+04,  1./
      DATA (u(i,   4),i=1,7)/ 3., 1., 2., 6., 5.14E-03,3.88881E+04,  1./
      DATA (u(i,   5),i=1,7)/ 3., 1., 2., 6., 3.16E-03,4.02617E+04,  1./
      DATA (u(i,   6),i=1,7)/ 3., 1., 2., 6., 2.04E-03,4.10868E+04,  1./
      DATA (u(i,   7),i=1,7)/ 3., 1., 2., 6., 1.39E-03,4.16211E+04,  1./
      DATA (u(i,   8),i=1,7)/ 3., 1., 2., 6., 9.87E-04,4.19865E+04,  1./
      DATA (u(i,   9),i=1,7)/ 3., 1., 2., 6., 7.24E-04,4.22474E+04,  1./
      DATA (u(i,  10),i=1,7)/ 3., 2., 1., 3.,-3.76E+04,4.76035E+05, 24./
      DATA (u(i,  11),i=1,7)/ 3., 2., 1., 3., 3.29E-07,4.94261E+05, 25./
      DATA (u(i,  12),i=1,7)/ 3., 2., 1., 3., 4.59E-01,4.98554E+05, 10./
      DATA (u(i,  13),i=1,7)/ 3., 2., 1., 3., 1.11E-01,5.58410E+05, 12./
      DATA (u(i,  14),i=1,7)/ 3., 2., 1., 3., 4.38E-02,5.79475E+05, 13./
      DATA (u(i,  15),i=1,7)/ 3., 2., 1., 3., 2.17E-02,5.89240E+05, 13./
      DATA (u(i,  16),i=1,7)/ 3., 2., 1., 3., 1.24E-02,5.94566E+05, 13./
      DATA (u(i,  17),i=1,7)/ 3., 2., 1., 3., 7.70E-03,5.97764E+05, 13./
      DATA (u(i,  18),i=1,7)/ 3., 2., 1., 3., 5.12E-03,5.99844E+05, 13./
      DATA (u(i,  19),i=1,7)/ 3., 2., 1., 3., 3.58E-03,6.01287E+05, 13./
      DATA (u(i,  20),i=1,7)/ 3., 2., 1., 3., 2.60E-03,6.02301E+05, 13./
      DATA (u(i,  21),i=1,7)/ 3., 3., 2., 2.,-6.66E+02,7.40734E+05, 23./
      DATA (u(i,  22),i=1,7)/ 3., 3., 2., 6., 8.32E-01,7.40302E+05,  4./
      DATA (u(i,  23),i=1,7)/ 3., 3., 2., 6., 1.58E-01,8.77424E+05,  5./
      DATA (u(i,  24),i=1,7)/ 3., 3., 2., 6., 5.80E-02,9.25412E+05,  6./
      DATA (u(i,  25),i=1,7)/ 3., 3., 2., 6., 2.79E-02,9.47598E+05,  7./
      DATA (u(i,  26),i=1,7)/ 3., 3., 2., 6., 1.56E-02,9.59693E+05,  8./
      DATA (u(i,  27),i=1,7)/ 3., 3., 2., 6., 9.63E-03,9.66931E+05,  9./
      DATA (u(i,  28),i=1,7)/ 3., 3., 2., 6., 6.37E-03,9.71628E+05,  9./
      DATA (u(i,  29),i=1,7)/ 3., 3., 2., 6., 4.43E-03,9.74944E+05,  9./
      DATA (u(i,  30),i=1,7)/ 3., 3., 2., 6., 3.21E-03,9.77230E+05,  9./
      DATA (u(i,  31),i=1,7)/ 4., 1., 1., 3., 1.40E+00,4.28842E+04, 0.1/
      DATA (u(i,  32),i=1,7)/ 4., 1., 1., 3., 1.56E-02,5.99779E+04,  1./
      DATA (u(i,  33),i=1,7)/ 4., 1., 1., 3., 4.39E-04,7.13089E+04,  1./
      DATA (u(i,  34),i=1,7)/ 4., 1., 1., 3., 3.76E-04,7.22559E+04,  1./
      DATA (u(i,  35),i=1,7)/ 4., 1., 1., 3., 3.55E-04,6.97024E+04,  1./
      DATA (u(i,  36),i=1,7)/ 4., 1., 1., 3., 2.96E-04,7.28592E+04,  1./
      DATA (u(i,  37),i=1,7)/ 4., 1., 1., 3., 2.29E-04,7.32671E+04,  1./
      DATA (u(i,  38),i=1,7)/ 4., 1., 1., 3., 1.77E-04,7.35548E+04,  1./
      DATA (u(i,  39),i=1,7)/ 4., 1., 1., 3., 8.40E-07,6.66671E+04,  1./
      DATA (u(i,  40),i=1,7)/ 4., 2., 2., 6., 9.99E-01,3.18767E+04, 14./
      DATA (u(i,  41),i=1,7)/ 4., 2., 2., 6., 1.65E-01,9.62899E+04, 15./
      DATA (u(i,  42),i=1,7)/ 4., 2., 2., 6., 6.23E-02,1.18507E+05, 17./
      DATA (u(i,  43),i=1,7)/ 4., 2., 2., 6., 2.97E-02,1.28700E+05, 17./
      DATA (u(i,  44),i=1,7)/ 4., 2., 2., 6., 1.64E-02,1.34205E+05, 17./
      DATA (u(i,  45),i=1,7)/ 4., 2., 2., 6., 1.01E-02,1.37510E+05, 17./
      DATA (u(i,  46),i=1,7)/ 4., 2., 2., 6., 6.64E-03,1.39649E+05, 17./
      DATA (u(i,  47),i=1,7)/ 4., 2., 2., 6., 4.60E-03,1.41113E+05, 17./
      DATA (u(i,  48),i=1,7)/ 4., 2., 2., 6., 3.32E-03,1.42159E+05, 17./
      DATA (u(i,  49),i=1,7)/ 4., 3., 1., 3.,-1.19E+05,9.56502E+05, 24./
      DATA (u(i,  50),i=1,7)/ 4., 3., 1., 3., 1.86E-06,9.83348E+05, 25./
      DATA (u(i,  51),i=1,7)/ 4., 3., 1., 3., 5.53E-01,9.93542E+05, 11./
      DATA (u(i,  52),i=1,7)/ 4., 3., 1., 3., 1.27E-01,1.12829E+06, 12./
      DATA (u(i,  53),i=1,7)/ 4., 3., 1., 3., 4.92E-02,1.17578E+06, 13./
      DATA (u(i,  54),i=1,7)/ 4., 3., 1., 3., 2.42E-02,1.19775E+06, 13./
      DATA (u(i,  55),i=1,7)/ 4., 3., 1., 3., 1.37E-02,1.20977E+06, 13./
      DATA (u(i,  56),i=1,7)/ 4., 3., 1., 3., 8.55E-03,1.21699E+06, 13./
      DATA (u(i,  57),i=1,7)/ 4., 3., 1., 3., 5.68E-03,1.22160E+06, 13./
      DATA (u(i,  58),i=1,7)/ 4., 3., 1., 3., 3.97E-03,1.22489E+06, 13./
      DATA (u(i,  59),i=1,7)/ 4., 3., 1., 3., 2.88E-03,1.22714E+06, 13./
      DATA (u(i,  60),i=1,7)/ 4., 4., 2., 2.,-2.11E+03,1.31697E+06, 23./
      DATA (u(i,  61),i=1,7)/ 4., 4., 2., 6., 8.32E-01,1.31614E+06,  4./
      DATA (u(i,  62),i=1,7)/ 4., 4., 2., 6., 1.58E-01,1.55982E+06,  5./
      DATA (u(i,  63),i=1,7)/ 4., 4., 2., 6., 5.80E-02,1.64528E+06,  6./
      DATA (u(i,  64),i=1,7)/ 4., 4., 2., 6., 2.79E-02,1.68464E+06,  7./
      DATA (u(i,  65),i=1,7)/ 4., 4., 2., 6., 1.56E-02,1.70619E+06,  8./
      DATA (u(i,  66),i=1,7)/ 4., 4., 2., 6., 9.63E-03,1.71910E+06,  9./
      DATA (u(i,  67),i=1,7)/ 4., 4., 2., 6., 6.37E-03,1.72741E+06,  9./
      DATA (u(i,  68),i=1,7)/ 4., 4., 2., 6., 4.43E-03,1.73310E+06,  9./
      DATA (u(i,  69),i=1,7)/ 4., 4., 2., 6., 3.21E-03,1.73732E+06,  9./
      DATA (u(i,  70),i=1,7)/ 5., 1., 6., 6., 3.54E+00,7.31106E+04, 0.1/
      DATA (u(i,  71),i=1,7)/ 5., 1., 6.,10., 1.04E+00,5.40389E+04,  1./
      DATA (u(i,  72),i=1,7)/ 5., 1., 6., 2., 4.75E-01,3.92429E+04,  1./
      DATA (u(i,  73),i=1,7)/ 5., 1., 6.,10., 4.33E-01,5.91621E+04,  1./
      DATA (u(i,  74),i=1,7)/ 5., 1., 6., 6., 3.48E-01,8.65516E+04,  1./
      DATA (u(i,  75),i=1,7)/ 5., 1., 6.,10., 2.15E-01,6.16299E+04,  1./
      DATA (u(i,  76),i=1,7)/ 5., 1., 6.,10., 2.11E-01,4.79074E+04, 0.1/
      DATA (u(i,  77),i=1,7)/ 5., 1., 6.,10., 1.22E-01,6.29802E+04,  1./
      DATA (u(i,  78),i=1,7)/ 5., 1., 6., 2., 1.00E-01,6.45745E+04, 0.1/
      DATA (u(i,  79),i=1,7)/ 5., 1., 6., 2., 9.25E-02,5.41812E+04,  1./
      DATA (u(i,  80),i=1,7)/ 5., 1., 6., 2., 8.94E-02,6.42550E+04,  1./
      DATA (u(i,  81),i=1,7)/ 5., 1., 6.,10., 7.55E-02,6.37959E+04,  1./
      DATA (u(i,  82),i=1,7)/ 5., 1., 6., 2., 6.06E-02,6.48176E+04,  1./
      DATA (u(i,  83),i=1,7)/ 5., 1., 6., 2., 5.92E-02,6.37682E+04,  1./
      DATA (u(i,  84),i=1,7)/ 5., 1., 6.,10., 5.01E-02,6.43252E+04,  1./
      DATA (u(i,  85),i=1,7)/ 5., 1., 6., 2., 4.91E-02,5.93166E+04,  1./
      DATA (u(i,  86),i=1,7)/ 5., 1., 6., 2., 4.34E-02,6.29941E+04,  1./
      DATA (u(i,  87),i=1,7)/ 5., 1., 6., 2., 4.00E-02,6.16991E+04,  1./
      DATA (u(i,  88),i=1,7)/ 5., 1., 6.,10., 3.49E-02,6.46881E+04,  1./
      DATA (u(i,  89),i=1,7)/ 5., 1., 6.,10., 2.53E-02,6.49477E+04,  1./
      DATA (u(i,  90),i=1,7)/ 5., 1., 6., 6., 2.06E-02,9.43512E+04,  1./
      DATA (u(i,  91),i=1,7)/ 5., 1., 6., 6., 2.96E-03,9.78914E+04,  1./
      DATA (u(i,  92),i=1,7)/ 5., 1., 6., 6., 7.28E-04,9.97079E+04,  1./
      DATA (u(i,  93),i=1,7)/ 5., 1., 6., 6., 2.48E-04,1.00754E+05,  1./
      DATA (u(i,  94),i=1,7)/ 5., 1., 6., 6., 1.05E-04,1.01410E+05,  1./
      DATA (u(i,  95),i=1,7)/ 5., 1., 6., 6., 5.15E-05,1.01848E+05,  1./
      DATA (u(i,  96),i=1,7)/ 5., 1., 6., 6., 2.83E-05,1.02154E+05,  1./
      DATA (u(i,  97),i=1,7)/ 5., 2., 1., 3., 1.03E+00,7.46135E+04,  3./
      DATA (u(i,  98),i=1,7)/ 5., 2., 1., 3., 9.91E-02,1.43707E+05,  2./
      DATA (u(i,  99),i=1,7)/ 5., 2., 1., 3., 5.12E-02,1.69958E+05,  2./
      DATA (u(i, 100),i=1,7)/ 5., 2., 1., 3., 2.40E-02,1.81182E+05,  2./
      DATA (u(i, 101),i=1,7)/ 5., 2., 1., 3., 4.22E-03,1.92838E+05,  2./
      DATA (u(i, 102),i=1,7)/ 5., 2., 1., 3., 3.58E-03,1.94985E+05,  2./
      DATA (u(i, 103),i=1,7)/ 5., 2., 1., 3., 2.77E-03,1.96487E+05,  2./
      DATA (u(i, 104),i=1,7)/ 5., 2., 1., 3., 2.50E-03,1.89804E+05,  2./
      DATA (u(i, 105),i=1,7)/ 5., 2., 1., 3., 2.13E-03,1.97566E+05,  2./
      DATA (u(i, 106),i=1,7)/ 5., 2., 1., 3., 2.02E-03,1.86230E+05,  2./
      DATA (u(i, 107),i=1,7)/ 5., 3., 2., 6., 7.29E-01,4.83426E+04, 14./
      DATA (u(i, 108),i=1,7)/ 5., 3., 2., 6., 3.06E-01,1.92630E+05, 15./
      DATA (u(i, 109),i=1,7)/ 5., 3., 2., 6., 9.94E-02,2.42412E+05, 17./
      DATA (u(i, 110),i=1,7)/ 5., 3., 2., 6., 4.50E-02,2.65266E+05, 17./
      DATA (u(i, 111),i=1,7)/ 5., 3., 2., 6., 2.44E-02,2.77616E+05, 17./
      DATA (u(i, 112),i=1,7)/ 5., 3., 2., 6., 1.48E-02,2.85038E+05, 17./
      DATA (u(i, 113),i=1,7)/ 5., 3., 2., 6., 9.64E-03,2.89847E+05, 17./
      DATA (u(i, 114),i=1,7)/ 5., 3., 2., 6., 6.65E-03,2.93126E+05, 17./
      DATA (u(i, 115),i=1,7)/ 5., 3., 2., 6., 4.79E-03,2.95473E+05, 17./
      DATA (u(i, 116),i=1,7)/ 5., 4., 1., 3.,-2.90E+05,1.60154E+06, 24./
      DATA (u(i, 117),i=1,7)/ 5., 4., 1., 3., 7.08E-06,1.63694E+06, 25./
      DATA (u(i, 118),i=1,7)/ 5., 4., 1., 3., 6.10E-01,1.65317E+06, 11./
      DATA (u(i, 119),i=1,7)/ 5., 4., 1., 3., 1.35E-01,1.89322E+06, 12./
      DATA (u(i, 120),i=1,7)/ 5., 4., 1., 3., 5.20E-02,1.97785E+06, 13./
      DATA (u(i, 121),i=1,7)/ 5., 4., 1., 3., 2.55E-02,2.01694E+06, 13./
      DATA (u(i, 122),i=1,7)/ 5., 4., 1., 3., 1.44E-02,2.03832E+06, 13./
      DATA (u(i, 123),i=1,7)/ 5., 4., 1., 3., 8.94E-03,2.05128E+06, 13./
      DATA (u(i, 124),i=1,7)/ 5., 4., 1., 3., 5.94E-03,2.05931E+06, 13./
      DATA (u(i, 125),i=1,7)/ 5., 4., 1., 3., 4.15E-03,2.06526E+06, 13./
      DATA (u(i, 126),i=1,7)/ 5., 4., 1., 3., 3.01E-03,2.06911E+06, 13./
      DATA (u(i, 127),i=1,7)/ 5., 5., 2., 2.,-5.14E+03,2.05797E+06, 23./
      DATA (u(i, 128),i=1,7)/ 5., 5., 2., 6., 8.32E-01,2.05634E+06,  4./
      DATA (u(i, 129),i=1,7)/ 5., 5., 2., 6., 1.58E-01,2.43724E+06,  5./
      DATA (u(i, 130),i=1,7)/ 5., 5., 2., 6., 5.80E-02,2.57069E+06,  6./
      DATA (u(i, 131),i=1,7)/ 5., 5., 2., 6., 2.79E-02,2.63227E+06,  7./
      DATA (u(i, 132),i=1,7)/ 5., 5., 2., 6., 1.56E-02,2.66596E+06,  8./
      DATA (u(i, 133),i=1,7)/ 5., 5., 2., 6., 9.63E-03,2.68601E+06,  9./
      DATA (u(i, 134),i=1,7)/ 5., 5., 2., 6., 6.37E-03,2.69906E+06,  9./
      DATA (u(i, 135),i=1,7)/ 5., 5., 2., 6., 4.43E-03,2.70783E+06,  9./
      DATA (u(i, 136),i=1,7)/ 5., 5., 2., 6., 3.21E-03,2.71444E+06,  9./
      DATA (u(i, 137),i=1,7)/ 6., 1., 9., 3., 1.37E+00,1.05939E+05, 0.1/
      DATA (u(i, 138),i=1,7)/ 6., 1., 9.,15., 9.88E-01,8.01603E+04,  1./
      DATA (u(i, 139),i=1,7)/ 6., 1., 9., 3., 8.43E-01,1.18903E+05,  1./
      DATA (u(i, 140),i=1,7)/ 6., 1., 9.,15., 6.43E-01,6.40480E+04, 0.1/
      DATA (u(i, 141),i=1,7)/ 6., 1., 9., 9., 5.54E-01,7.60589E+04, 0.1/
      DATA (u(i, 142),i=1,7)/ 6., 1., 9.,15., 4.38E-01,8.57648E+04,  1./
      DATA (u(i, 143),i=1,7)/ 6., 1., 9., 9., 3.56E-01,8.10839E+04,  1./
      DATA (u(i, 144),i=1,7)/ 6., 1., 9.,15., 2.25E-01,8.83345E+04,  1./
      DATA (u(i, 145),i=1,7)/ 6., 1., 9., 9., 1.95E-01,7.99565E+04,  1./
      DATA (u(i, 146),i=1,7)/ 6., 1., 9., 3., 1.56E-01,1.25233E+05,  1./
      DATA (u(i, 147),i=1,7)/ 6., 1., 9.,15., 1.45E-01,8.99256E+04,  1./
      DATA (u(i, 148),i=1,7)/ 6., 1., 9.,15., 1.30E-01,8.97223E+04,  1./
      DATA (u(i, 149),i=1,7)/ 6., 1., 9., 9., 1.19E-01,8.60319E+04,  1./
      DATA (u(i, 150),i=1,7)/ 6., 1., 9., 9., 9.72E-02,8.57038E+04,  1./
      DATA (u(i, 151),i=1,7)/ 6., 1., 9.,15., 8.12E-02,9.05559E+04,  1./
      DATA (u(i, 152),i=1,7)/ 6., 1., 9.,15., 8.02E-02,9.01713E+04,  1./
      DATA (u(i, 153),i=1,7)/ 6., 1., 9., 9., 5.57E-02,8.84596E+04,  1./
      DATA (u(i, 154),i=1,7)/ 6., 1., 9.,15., 5.42E-02,9.10946E+04,  1./
      DATA (u(i, 155),i=1,7)/ 6., 1., 9., 9., 5.13E-02,8.83143E+04,  1./
      DATA (u(i, 156),i=1,7)/ 6., 1., 9.,15., 4.61E-02,9.03906E+04,  1./
      DATA (u(i, 157),i=1,7)/ 6., 1., 9.,15., 3.80E-02,9.14629E+04,  1./
      DATA (u(i, 158),i=1,7)/ 6., 1., 9., 3., 3.49E-02,1.28756E+05,  1./
      DATA (u(i, 159),i=1,7)/ 6., 1., 9.,15., 3.19E-02,9.00544E+04,  1./
      DATA (u(i, 160),i=1,7)/ 6., 1., 9., 9., 3.08E-02,8.97924E+04,  1./
      DATA (u(i, 161),i=1,7)/ 6., 1., 9., 9., 3.02E-02,8.97143E+04,  1./
      DATA (u(i, 162),i=1,7)/ 6., 1., 9.,15., 2.76E-02,9.17255E+04,  1./
      DATA (u(i, 163),i=1,7)/ 6., 1., 9., 9., 1.92E-02,9.05518E+04,  1./
      DATA (u(i, 164),i=1,7)/ 6., 1., 9., 9., 1.88E-02,9.05986E+04,  1./
      DATA (u(i, 165),i=1,7)/ 6., 1., 9., 9., 1.29E-02,9.10921E+04,  1./
      DATA (u(i, 166),i=1,7)/ 6., 1., 9., 3., 1.25E-02,1.30630E+05,  1./
      DATA (u(i, 167),i=1,7)/ 6., 1., 9., 9., 1.24E-02,9.11228E+04,  1./
      DATA (u(i, 168),i=1,7)/ 6., 1., 9., 9., 9.12E-03,9.14620E+04,  1./
      DATA (u(i, 169),i=1,7)/ 6., 1., 9., 9., 8.56E-03,9.14829E+04,  1./
      DATA (u(i, 170),i=1,7)/ 6., 1., 9., 9., 6.67E-03,9.17255E+04,  1./
      DATA (u(i, 171),i=1,7)/ 6., 1., 9., 9., 6.18E-03,9.17398E+04,  1./
      DATA (u(i, 172),i=1,7)/ 6., 1., 9., 3., 5.88E-03,1.31714E+05,  1./
      DATA (u(i, 173),i=1,7)/ 6., 1., 9., 3., 3.26E-03,1.32392E+05,  1./
      DATA (u(i, 174),i=1,7)/ 6., 1., 9., 3., 2.01E-03,1.32843E+05,  1./
      DATA (u(i, 175),i=1,7)/ 6., 1., 9., 3., 1.34E-03,1.33159E+05,  1./
      DATA (u(i, 176),i=1,7)/ 6., 2., 6., 6., 3.06E+00,1.12003E+05,178./
      DATA (u(i, 177),i=1,7)/ 6., 2., 6.,10., 2.01E+00,1.45182E+05,  2./
      DATA (u(i, 178),i=1,7)/ 6., 2., 6., 2., 7.47E-01,9.80219E+04,186./
      DATA (u(i, 179),i=1,7)/ 6., 2., 6.,10., 7.04E-01,1.67628E+05,  2./
      DATA (u(i, 180),i=1,7)/ 6., 2., 6.,10., 3.42E-01,1.77949E+05,  2./
      DATA (u(i, 181),i=1,7)/ 6., 2., 6.,10., 2.17E-01,1.88423E+05,  2./
      DATA (u(i, 182),i=1,7)/ 6., 2., 6.,10., 2.09E-01,1.83517E+05,  2./
      DATA (u(i, 183),i=1,7)/ 6., 2., 6.,10., 1.79E-01,1.86811E+05,  2./
      DATA (u(i, 184),i=1,7)/ 6., 2., 6., 6., 1.09E-01,1.81699E+05,  2./
      DATA (u(i, 185),i=1,7)/ 6., 2., 6., 2., 7.81E-02,1.16526E+05,177./
      DATA (u(i, 186),i=1,7)/ 6., 2., 6., 6., 5.32E-02,2.13922E+05,  2./
      DATA (u(i, 187),i=1,7)/ 6., 2., 6., 2., 3.67E-02,1.56745E+05,  2./
      DATA (u(i, 188),i=1,7)/ 6., 2., 6., 6., 3.24E-02,2.35410E+05,  2./
      DATA (u(i, 189),i=1,7)/ 6., 2., 6., 6., 2.31E-02,2.27350E+05,  2./
      DATA (u(i, 190),i=1,7)/ 6., 2., 6.,10., 2.04E-02,1.90600E+05,  2./
      DATA (u(i, 191),i=1,7)/ 6., 2., 6.,10., 2.00E-02,1.91633E+05,  2./
      DATA (u(i, 192),i=1,7)/ 6., 2., 6., 2., 1.40E-02,1.72804E+05,  2./
      DATA (u(i, 193),i=1,7)/ 6., 2., 6., 6., 1.35E-02,2.38334E+05,  2./
      DATA (u(i, 194),i=1,7)/ 6., 2., 6., 6., 7.74E-03,2.40813E+05,  2./
      DATA (u(i, 195),i=1,7)/ 6., 2., 6., 2., 6.72E-03,1.80698E+05,  2./
      DATA (u(i, 196),i=1,7)/ 6., 2., 6., 6., 5.13E-03,2.42489E+05,  2./
      DATA (u(i, 197),i=1,7)/ 6., 2., 6., 6., 3.63E-03,2.43677E+05,  2./
      DATA (u(i, 198),i=1,7)/ 6., 2., 6., 2., 3.62E-03,1.85158E+05,  2./
      DATA (u(i, 199),i=1,7)/ 6., 2., 6., 6., 2.39E-03,2.34060E+05,  2./
      DATA (u(i, 200),i=1,7)/ 6., 2., 6., 2., 2.07E-03,1.87924E+05,  2./
      DATA (u(i, 201),i=1,7)/ 6., 2., 6., 2., 1.19E-03,1.89753E+05,  2./
      DATA (u(i, 202),i=1,7)/ 6., 2., 6., 2., 6.40E-04,1.91026E+05,  2./
      DATA (u(i, 203),i=1,7)/ 6., 2., 6.,10., 3.46E-04,1.89247E+05,  2./
      DATA (u(i, 204),i=1,7)/ 6., 3., 1., 3., 7.70E-03,3.68881E+05,  2./
      DATA (u(i, 205),i=1,7)/ 6., 3., 1., 3., 5.40E-03,3.72301E+05,  2./
      DATA (u(i, 206),i=1,7)/ 6., 3., 1., 3., 3.76E-03,3.74700E+05,  2./
      DATA (u(i, 207),i=1,7)/ 6., 3., 1., 3., 3.25E-03,3.46620E+05,  2./
      DATA (u(i, 208),i=1,7)/ 6., 4., 2., 6., 1.22E-01,4.07664E+05, 18./
      DATA (u(i, 209),i=1,7)/ 6., 4., 2., 6., 5.41E-02,4.48149E+05, 18./
      DATA (u(i, 210),i=1,7)/ 6., 4., 2., 6., 2.90E-02,4.70035E+05, 18./
      DATA (u(i, 211),i=1,7)/ 6., 4., 2., 6., 1.74E-02,4.83208E+05, 18./
      DATA (u(i, 212),i=1,7)/ 6., 4., 2., 6., 1.13E-02,4.91715E+05, 18./
      DATA (u(i, 213),i=1,7)/ 6., 4., 2., 6., 7.80E-03,4.97562E+05, 18./
      DATA (u(i, 214),i=1,7)/ 6., 4., 2., 6., 5.60E-03,5.01706E+05, 18./
      DATA (u(i, 215),i=1,7)/ 6., 5., 1., 3.,-6.01E+05,2.44112E+06, 24./
      DATA (u(i, 216),i=1,7)/ 6., 5., 1., 3., 2.11E-05,2.45515E+06, 25./
      DATA (u(i, 217),i=1,7)/ 6., 5., 1., 3., 6.47E-01,2.47770E+06, 89./
      DATA (u(i, 218),i=1,7)/ 6., 5., 1., 3., 1.41E-01,2.85307E+06, 87./
      DATA (u(i, 219),i=1,7)/ 6., 5., 1., 3., 5.35E-02,2.98507E+06, 13./
      DATA (u(i, 220),i=1,7)/ 6., 5., 1., 3., 2.61E-02,3.04692E+06, 13./
      DATA (u(i, 221),i=1,7)/ 6., 5., 1., 3., 1.48E-02,3.07977E+06, 13./
      DATA (u(i, 222),i=1,7)/ 6., 5., 1., 3., 9.16E-03,3.09981E+06, 13./
      DATA (u(i, 223),i=1,7)/ 6., 5., 1., 3., 6.08E-03,3.11333E+06, 13./
      DATA (u(i, 224),i=1,7)/ 6., 5., 1., 3., 4.24E-03,3.12207E+06, 13./
      DATA (u(i, 225),i=1,7)/ 6., 5., 1., 3., 3.08E-03,3.12891E+06, 13./
      DATA (u(i, 226),i=1,7)/ 6., 6., 2., 2.,-1.07E+04,2.96381E+06, 86./
      DATA (u(i, 227),i=1,7)/ 6., 6., 2., 6., 8.32E-01,2.96121E+06, 85./
      DATA (u(i, 228),i=1,7)/ 6., 6., 2., 6., 1.58E-01,3.51000E+06,  5./
      DATA (u(i, 229),i=1,7)/ 6., 6., 2., 6., 5.80E-02,3.70096E+06,  6./
      DATA (u(i, 230),i=1,7)/ 6., 6., 2., 6., 2.79E-02,3.79075E+06,  7./
      DATA (u(i, 231),i=1,7)/ 6., 6., 2., 6., 1.56E-02,3.83877E+06,  8./
      DATA (u(i, 232),i=1,7)/ 6., 6., 2., 6., 9.63E-03,3.86847E+06,  9./
      DATA (u(i, 233),i=1,7)/ 6., 6., 2., 6., 6.37E-03,3.88651E+06,  9./
      DATA (u(i, 234),i=1,7)/ 6., 6., 2., 6., 4.43E-03,3.90016E+06,  9./
      DATA (u(i, 235),i=1,7)/ 6., 6., 2., 6., 3.21E-03,3.90930E+06,  9./
      DATA (u(i, 236),i=1,7)/ 7., 1., 4.,12., 2.81E-01,1.06128E+05,  1./
      DATA (u(i, 237),i=1,7)/ 7., 1., 4.,12., 1.35E-01,1.11567E+05,  1./
      DATA (u(i, 238),i=1,7)/ 7., 1., 4.,12., 1.27E-01,1.05029E+05,  1./
      DATA (u(i, 239),i=1,7)/ 7., 1., 4.,12., 9.26E-02,8.84080E+04, 0.1/
      DATA (u(i, 240),i=1,7)/ 7., 1., 4.,12., 7.27E-02,1.14068E+05,  1./
      DATA (u(i, 241),i=1,7)/ 7., 1., 4.,12., 5.40E-02,1.11126E+05,  1./
      DATA (u(i, 242),i=1,7)/ 7., 1., 4.,12., 4.31E-02,1.15424E+05,  1./
      DATA (u(i, 243),i=1,7)/ 7., 1., 4.,12., 2.75E-02,1.16241E+05,  1./
      DATA (u(i, 244),i=1,7)/ 7., 1., 4.,12., 2.66E-02,1.13851E+05,  1./
      DATA (u(i, 245),i=1,7)/ 7., 1., 4.,12., 1.86E-02,1.16771E+05,  1./
      DATA (u(i, 246),i=1,7)/ 7., 1., 4.,12., 1.51E-02,1.15302E+05,  1./
      DATA (u(i, 247),i=1,7)/ 7., 1., 4.,12., 1.31E-02,1.17133E+05,  1./
      DATA (u(i, 248),i=1,7)/ 7., 1., 4.,12., 9.58E-03,1.17393E+05,  1./
      DATA (u(i, 249),i=1,7)/ 7., 1., 4.,12., 9.36E-03,1.16166E+05,  1./
      DATA (u(i, 250),i=1,7)/ 7., 1., 4.,12., 6.21E-03,1.16720E+05,  1./
      DATA (u(i, 251),i=1,7)/ 7., 1., 4.,12., 4.33E-03,1.17099E+05,  1./
      DATA (u(i, 252),i=1,7)/ 7., 1., 4.,12., 3.14E-03,1.17367E+05,  1./
      DATA (u(i, 253),i=1,7)/ 7., 2., 9.,15., 2.70E+00,1.87913E+05,  2./
      DATA (u(i, 254),i=1,7)/ 7., 2., 9., 3., 2.05E+00,1.57619E+05,  3./
      DATA (u(i, 255),i=1,7)/ 7., 2., 9., 9., 1.46E+00,1.10244E+05,179./
      DATA (u(i, 256),i=1,7)/ 7., 2., 9.,15., 1.07E+00,2.10464E+05,  2./
      DATA (u(i, 257),i=1,7)/ 7., 2., 9., 9., 9.29E-01,1.89344E+05,  2./
      DATA (u(i, 258),i=1,7)/ 7., 2., 9.,15., 5.63E-01,2.20765E+05,  2./
      DATA (u(i, 259),i=1,7)/ 7., 2., 9.,15., 4.15E-01,2.26270E+05,  2./
      DATA (u(i, 260),i=1,7)/ 7., 2., 9., 9., 3.92E-01,2.10841E+05,  2./
      DATA (u(i, 261),i=1,7)/ 7., 2., 9.,15., 3.43E-01,2.28451E+05,  2./
      DATA (u(i, 262),i=1,7)/ 7., 2., 9., 9., 2.00E-01,2.20941E+05,  2./
      DATA (u(i, 263),i=1,7)/ 7., 2., 9., 9., 1.22E-01,2.26419E+05,  2./
      DATA (u(i, 264),i=1,7)/ 7., 2., 9., 9., 1.12E-01,2.31396E+05,  2./
      DATA (u(i, 265),i=1,7)/ 7., 2., 9., 9., 9.61E-02,2.29690E+05,  2./
      DATA (u(i, 266),i=1,7)/ 7., 2., 9., 9., 9.42E-02,1.96812E+05,  2./
      DATA (u(i, 267),i=1,7)/ 7., 2., 9.,15., 7.69E-02,2.31906E+05,  2./
      DATA (u(i, 268),i=1,7)/ 7., 2., 9.,15., 6.06E-02,2.33361E+05,  2./
      DATA (u(i, 269),i=1,7)/ 7., 2., 9.,15., 5.06E-02,2.29827E+05,  2./
      DATA (u(i, 270),i=1,7)/ 7., 2., 9.,15., 4.61E-02,2.34412E+05,  2./
      DATA (u(i, 271),i=1,7)/ 7., 2., 9., 9., 3.28E-02,2.14376E+05,  2./
      DATA (u(i, 272),i=1,7)/ 7., 2., 9., 3., 2.30E-02,2.21720E+05,  2./
      DATA (u(i, 273),i=1,7)/ 7., 2., 9., 3., 1.79E-02,2.57685E+05,  2./
      DATA (u(i, 274),i=1,7)/ 7., 2., 9., 9., 1.77E-02,2.33399E+05,  2./
      DATA (u(i, 275),i=1,7)/ 7., 2., 9., 9., 1.65E-02,2.32455E+05,  2./
      DATA (u(i, 276),i=1,7)/ 7., 2., 9., 9., 1.55E-02,2.34428E+05,  2./
      DATA (u(i, 277),i=1,7)/ 7., 2., 9., 9., 1.42E-02,2.22836E+05,  2./
      DATA (u(i, 278),i=1,7)/ 7., 2., 9., 3., 9.19E-03,2.72087E+05,  2./
      DATA (u(i, 279),i=1,7)/ 7., 2., 9., 9., 6.04E-03,2.27547E+05,  2./
      DATA (u(i, 280),i=1,7)/ 7., 2., 9., 9., 5.87E-03,2.33732E+05,  2./
      DATA (u(i, 281),i=1,7)/ 7., 2., 9., 3., 5.15E-03,2.79330E+05,  2./
      DATA (u(i, 282),i=1,7)/ 7., 2., 9., 9., 4.59E-03,2.32029E+05,  2./
      DATA (u(i, 283),i=1,7)/ 7., 2., 9., 3., 3.15E-03,2.83487E+05,  2./
      DATA (u(i, 284),i=1,7)/ 7., 2., 9., 3., 2.06E-03,2.86090E+05,  2./
      DATA (u(i, 285),i=1,7)/ 7., 2., 9., 3., 1.42E-03,2.87828E+05,  2./
      DATA (u(i, 286),i=1,7)/ 7., 2., 9., 3., 1.02E-03,2.89042E+05,  2./
      DATA (u(i, 287),i=1,7)/ 7., 2., 9., 9., 5.60E-04,2.30409E+05,  2./
      DATA (u(i, 288),i=1,7)/ 7., 3., 6., 6., 2.44E+00,1.47447E+05,168./
      DATA (u(i, 289),i=1,7)/ 7., 3., 6., 2., 5.00E-01,1.32959E+05,  3./
      DATA (u(i, 290),i=1,7)/ 7., 3., 6.,10., 2.89E-01,3.40704E+05,  2./
      DATA (u(i, 291),i=1,7)/ 7., 3., 6., 2., 1.89E-01,2.20604E+05,  2./
      DATA (u(i, 292),i=1,7)/ 7., 3., 6.,10., 1.62E-01,3.53245E+05,  2./
      DATA (u(i, 293),i=1,7)/ 7., 3., 6., 6., 1.18E-01,3.78000E+05,  2./
      DATA (u(i, 294),i=1,7)/ 7., 3., 6.,10., 9.93E-02,3.60776E+05,  2./
      DATA (u(i, 295),i=1,7)/ 7., 3., 6.,10., 9.57E-02,3.20400E+05,  2./
      DATA (u(i, 296),i=1,7)/ 7., 3., 6.,10., 6.59E-02,3.65644E+05,  2./
      DATA (u(i, 297),i=1,7)/ 7., 3., 6., 6., 5.10E-02,3.73902E+05,  2./
      DATA (u(i, 298),i=1,7)/ 7., 3., 6., 6., 4.92E-02,4.01752E+05,  2./
      DATA (u(i, 299),i=1,7)/ 7., 3., 6.,10., 4.68E-02,3.68976E+05,  2./
      DATA (u(i, 300),i=1,7)/ 7., 3., 6., 2., 4.08E-02,3.27172E+05,  2./
      DATA (u(i, 301),i=1,7)/ 7., 3., 6.,10., 3.57E-02,3.71347E+05,  2./
      DATA (u(i, 302),i=1,7)/ 7., 3., 6., 2., 3.26E-02,3.32546E+05,  2./
      DATA (u(i, 303),i=1,7)/ 7., 3., 6., 6., 1.55E-02,4.19076E+05,  2./
      DATA (u(i, 304),i=1,7)/ 7., 3., 6., 6., 1.24E-02,4.26803E+05,  2./
      DATA (u(i, 305),i=1,7)/ 7., 3., 6., 2., 1.14E-02,3.48554E+05,  2./
      DATA (u(i, 306),i=1,7)/ 7., 3., 6., 6., 8.14E-03,4.32021E+05,  2./
      DATA (u(i, 307),i=1,7)/ 7., 3., 6., 2., 6.91E-03,3.57859E+05,  2./
      DATA (u(i, 308),i=1,7)/ 7., 3., 6., 6., 5.29E-03,4.35578E+05,  2./
      DATA (u(i, 309),i=1,7)/ 7., 3., 6., 2., 4.85E-03,3.63702E+05,  2./
      DATA (u(i, 310),i=1,7)/ 7., 3., 6., 2., 3.79E-03,3.67607E+05,  2./
      DATA (u(i, 311),i=1,7)/ 7., 3., 6., 6., 3.30E-03,4.38097E+05,  2./
      DATA (u(i, 312),i=1,7)/ 7., 3., 6., 2., 3.25E-03,3.70343E+05,  2./
      DATA (u(i, 313),i=1,7)/ 7., 3., 6., 6., 7.34E-04,4.11540E+05,  2./
      DATA (u(i, 314),i=1,7)/ 7., 4., 1., 3., 3.26E-01,4.03600E+05,  2./
      DATA (u(i, 315),i=1,7)/ 7., 4., 1., 3., 1.05E-01,5.06047E+05,  2./
      DATA (u(i, 316),i=1,7)/ 7., 4., 1., 3., 4.16E-02,5.48878E+05,  2./
      DATA (u(i, 317),i=1,7)/ 7., 4., 1., 3., 2.32E-02,5.71363E+05,  2./
      DATA (u(i, 318),i=1,7)/ 7., 4., 1., 3., 1.31E-02,5.86648E+05,  2./
      DATA (u(i, 319),i=1,7)/ 7., 4., 1., 3., 1.29E-02,5.94919E+05,  2./
      DATA (u(i, 320),i=1,7)/ 7., 4., 1., 3., 5.98E-03,5.18457E+05,  2./
      DATA (u(i, 321),i=1,7)/ 7., 4., 1., 3., 5.32E-03,5.97872E+05,  2./
      DATA (u(i, 322),i=1,7)/ 7., 4., 1., 3., 4.52E-03,4.72590E+05,  2./
      DATA (u(i, 323),i=1,7)/ 7., 4., 1., 3., 4.08E-03,6.01178E+05,  2./
      DATA (u(i, 324),i=1,7)/ 7., 4., 1., 3., 3.95E-03,6.05364E+05,  2./
      DATA (u(i, 325),i=1,7)/ 7., 4., 1., 3., 7.81E-05,5.79946E+05,  2./
      DATA (u(i, 326),i=1,7)/ 7., 5., 2., 6., 1.37E-01,6.14137E+05, 18./
      DATA (u(i, 327),i=1,7)/ 7., 5., 2., 6., 5.99E-02,6.77186E+05, 18./
      DATA (u(i, 328),i=1,7)/ 7., 5., 2., 6., 3.18E-02,7.11339E+05, 18./
      DATA (u(i, 329),i=1,7)/ 7., 5., 2., 6., 1.91E-02,7.31850E+05, 18./
      DATA (u(i, 330),i=1,7)/ 7., 5., 2., 6., 1.24E-02,7.45156E+05, 18./
      DATA (u(i, 331),i=1,7)/ 7., 5., 2., 6., 8.50E-03,7.54262E+05, 18./
      DATA (u(i, 332),i=1,7)/ 7., 5., 2., 6., 6.10E-03,7.60746E+05, 18./
      DATA (u(i, 333),i=1,7)/ 7., 6., 1., 3.,-1.11E+06,3.38589E+06, 24./
      DATA (u(i, 334),i=1,7)/ 7., 6., 1., 3., 5.30E-05,3.43832E+06, 25./
      DATA (u(i, 335),i=1,7)/ 7., 6., 1., 3., 6.74E-01,3.46620E+06, 11./
      DATA (u(i, 336),i=1,7)/ 7., 6., 1., 3., 1.44E-01,4.00802E+06, 12./
      DATA (u(i, 337),i=1,7)/ 7., 6., 1., 3., 5.45E-02,4.19815E+06, 13./
      DATA (u(i, 338),i=1,7)/ 7., 6., 1., 3., 2.65E-02,4.28633E+06, 13./
      DATA (u(i, 339),i=1,7)/ 7., 6., 1., 3., 1.50E-02,4.33463E+06, 13./
      DATA (u(i, 340),i=1,7)/ 7., 6., 1., 3., 9.28E-03,4.36491E+06, 13./
      DATA (u(i, 341),i=1,7)/ 7., 6., 1., 3., 6.16E-03,4.38404E+06, 13./
      DATA (u(i, 342),i=1,7)/ 7., 6., 1., 3., 4.30E-03,4.39560E+06, 13./
      DATA (u(i, 343),i=1,7)/ 7., 6., 1., 3., 3.12E-03,4.40529E+06, 13./
      DATA (u(i, 344),i=1,7)/ 7., 7., 2., 2.,-1.98E+04,4.03461E+06, 23./
      DATA (u(i, 345),i=1,7)/ 7., 7., 2., 6., 8.32E-01,4.03063E+06, 84./
      DATA (u(i, 346),i=1,7)/ 7., 7., 2., 6., 1.58E-01,4.77783E+06,  5./
      DATA (u(i, 347),i=1,7)/ 7., 7., 2., 6., 5.80E-02,5.03778E+06,  6./
      DATA (u(i, 348),i=1,7)/ 7., 7., 2., 6., 2.79E-02,5.15996E+06,  7./
      DATA (u(i, 349),i=1,7)/ 7., 7., 2., 6., 1.56E-02,5.22466E+06,  8./
      DATA (u(i, 350),i=1,7)/ 7., 7., 2., 6., 9.63E-03,5.26316E+06,  9./
      DATA (u(i, 351),i=1,7)/ 7., 7., 2., 6., 6.37E-03,5.29101E+06,  9./
      DATA (u(i, 352),i=1,7)/ 7., 7., 2., 6., 4.43E-03,5.30786E+06,  9./
      DATA (u(i, 353),i=1,7)/ 7., 7., 2., 6., 3.21E-03,5.31915E+06,  9./
      DATA (u(i, 354),i=1,7)/ 8., 1., 9., 9., 7.15E-01,1.15300E+05,  1./
      DATA (u(i, 355),i=1,7)/ 8., 1., 9., 9., 5.61E-01,1.26989E+05, 0.1/
      DATA (u(i, 356),i=1,7)/ 8., 1., 9.,15., 4.88E-01,1.02376E+05,  1./
      DATA (u(i, 357),i=1,7)/ 8., 1., 9., 9., 1.72E-01,1.30256E+05,  1./
      DATA (u(i, 358),i=1,7)/ 8., 1., 9.,15., 1.39E-01,1.03194E+05,  1./
      DATA (u(i, 359),i=1,7)/ 8., 1., 9., 9., 7.18E-02,1.32552E+05,  1./
      DATA (u(i, 360),i=1,7)/ 8., 1., 9.,15., 5.64E-02,1.05665E+05,  1./
      DATA (u(i, 361),i=1,7)/ 8., 1., 9., 9., 4.01E-02,1.33851E+05,  1./
      DATA (u(i, 362),i=1,7)/ 8., 1., 9.,15., 3.25E-02,1.07009E+05,  1./
      DATA (u(i, 363),i=1,7)/ 8., 1., 9., 3., 2.95E-02,1.02714E+05,  1./
      DATA (u(i, 364),i=1,7)/ 8., 1., 9., 9., 2.67E-02,1.23877E+05,  1./
      DATA (u(i, 365),i=1,7)/ 8., 1., 9., 9., 2.56E-02,1.34642E+05,  1./
      DATA (u(i, 366),i=1,7)/ 8., 1., 9.,15., 2.05E-02,1.07820E+05,  1./
      DATA (u(i, 367),i=1,7)/ 8., 1., 9., 9., 1.78E-02,1.35159E+05,  1./
      DATA (u(i, 368),i=1,7)/ 8., 1., 9., 3., 1.41E-02,1.05429E+05,  1./
      DATA (u(i, 369),i=1,7)/ 8., 1., 9.,15., 1.38E-02,1.08346E+05,  1./
      DATA (u(i, 370),i=1,7)/ 8., 1., 9., 9., 1.31E-02,1.35514E+05,  1./
      DATA (u(i, 371),i=1,7)/ 8., 1., 9., 9., 1.02E-02,1.35770E+05,  1./
      DATA (u(i, 372),i=1,7)/ 8., 1., 9.,15., 9.70E-03,1.08706E+05,  1./
      DATA (u(i, 373),i=1,7)/ 8., 1., 9., 3., 7.82E-03,1.06875E+05,  1./
      DATA (u(i, 374),i=1,7)/ 8., 1., 9.,15., 7.08E-03,1.08965E+05,  1./
      DATA (u(i, 375),i=1,7)/ 8., 1., 9.,15., 5.52E-03,1.08849E+05,  1./
      DATA (u(i, 376),i=1,7)/ 8., 1., 9., 3., 4.80E-03,1.07737E+05,  1./
      DATA (u(i, 377),i=1,7)/ 8., 1., 9.,15., 4.26E-03,1.08995E+05,  1./
      DATA (u(i, 378),i=1,7)/ 8., 1., 9., 3., 3.16E-03,1.08291E+05,  1./
      DATA (u(i, 379),i=1,7)/ 8., 1., 9., 3., 2.19E-03,1.08667E+05,  1./
      DATA (u(i, 380),i=1,7)/ 8., 1., 9., 3., 1.58E-03,1.08936E+05,  1./
      DATA (u(i, 381),i=1,7)/ 8., 2., 4.,12., 1.50E+00,2.35189E+05,  2./
      DATA (u(i, 382),i=1,7)/ 8., 2., 4.,12., 6.63E-01,2.57460E+05,  2./
      DATA (u(i, 383),i=1,7)/ 8., 2., 4.,12., 5.30E-01,1.88388E+05,  2./
      DATA (u(i, 384),i=1,7)/ 8., 2., 4.,12., 3.52E-01,2.67666E+05,  2./
      DATA (u(i, 385),i=1,7)/ 8., 2., 4.,12., 2.55E-01,2.76380E+05,  2./
      DATA (u(i, 386),i=1,7)/ 8., 2., 4.,12., 2.27E-01,2.73179E+05,  2./
      DATA (u(i, 387),i=1,7)/ 8., 2., 4.,12., 1.02E-01,2.77339E+05,  2./
      DATA (u(i, 388),i=1,7)/ 8., 2., 4.,12., 5.93E-02,2.41185E+05,  2./
      DATA (u(i, 389),i=1,7)/ 8., 2., 4.,12., 4.03E-02,2.78722E+05,  2./
      DATA (u(i, 390),i=1,7)/ 8., 2., 4.,12., 3.87E-02,2.80167E+05,  2./
      DATA (u(i, 391),i=1,7)/ 8., 2., 4.,12., 3.06E-02,2.81207E+05,  2./
      DATA (u(i, 392),i=1,7)/ 8., 2., 4.,12., 1.53E-02,2.60132E+05,  2./
      DATA (u(i, 393),i=1,7)/ 8., 2., 4.,12., 5.68E-03,2.69092E+05,  2./
      DATA (u(i, 394),i=1,7)/ 8., 2., 4.,12., 5.62E-03,2.79057E+05,  2./
      DATA (u(i, 395),i=1,7)/ 8., 2., 4.,12., 5.05E-03,2.76932E+05,  2./
      DATA (u(i, 396),i=1,7)/ 8., 2., 4.,12., 2.61E-03,2.80411E+05,  2./
      DATA (u(i, 397),i=1,7)/ 8., 2., 4.,12., 1.55E-03,2.74025E+05,  2./
      DATA (u(i, 398),i=1,7)/ 8., 3., 9.,15., 4.24E+00,3.27439E+05,139./
      DATA (u(i, 399),i=1,7)/ 8., 3., 9., 3., 1.69E+00,1.99736E+05,161./
      DATA (u(i, 400),i=1,7)/ 8., 3., 9., 9., 1.24E+00,1.43219E+05,169./
      DATA (u(i, 401),i=1,7)/ 8., 3., 9.,15., 1.06E+00,3.73037E+05,  2./
      DATA (u(i, 402),i=1,7)/ 8., 3., 9.,15., 9.34E-01,3.79003E+05,  2./
      DATA (u(i, 403),i=1,7)/ 8., 3., 9., 9., 7.49E-01,2.67637E+05,  2./
      DATA (u(i, 404),i=1,7)/ 8., 3., 9., 9., 6.61E-01,3.77330E+05,  2./
      DATA (u(i, 405),i=1,7)/ 8., 3., 9.,15., 5.98E-01,4.02042E+05,  2./
      DATA (u(i, 406),i=1,7)/ 8., 3., 9.,15., 3.35E-01,4.14594E+05,  2./
      DATA (u(i, 407),i=1,7)/ 8., 3., 9., 9., 2.11E-01,4.02220E+05,  2./
      DATA (u(i, 408),i=1,7)/ 8., 3., 9.,15., 2.06E-01,4.22137E+05,  2./
      DATA (u(i, 409),i=1,7)/ 8., 3., 9.,15., 1.40E-01,4.27004E+05,  2./
      DATA (u(i, 410),i=1,7)/ 8., 3., 9., 3., 1.24E-01,3.61141E+05,  2./
      DATA (u(i, 411),i=1,7)/ 8., 3., 9., 9., 1.18E-01,4.14697E+05,  2./
      DATA (u(i, 412),i=1,7)/ 8., 3., 9., 9., 9.96E-02,3.56570E+05,  2./
      DATA (u(i, 413),i=1,7)/ 8., 3., 9., 9., 9.77E-02,3.79896E+05,  2./
      DATA (u(i, 414),i=1,7)/ 8., 3., 9.,15., 9.76E-02,4.30330E+05,  2./
      DATA (u(i, 415),i=1,7)/ 8., 3., 9., 9., 7.22E-02,4.22190E+05,  2./
      DATA (u(i, 416),i=1,7)/ 8., 3., 9.,15., 7.17E-02,4.32694E+05,  2./
      DATA (u(i, 417),i=1,7)/ 8., 3., 9., 9., 6.19E-02,3.91558E+05,  2./
      DATA (u(i, 418),i=1,7)/ 8., 3., 9., 9., 5.16E-02,4.30385E+05,  2./
      DATA (u(i, 419),i=1,7)/ 8., 3., 9., 9., 4.62E-02,4.27022E+05,  2./
      DATA (u(i, 420),i=1,7)/ 8., 3., 9., 3., 4.29E-02,4.34499E+05,  2./
      DATA (u(i, 421),i=1,7)/ 8., 3., 9., 9., 2.67E-02,4.32713E+05,  2./
      DATA (u(i, 422),i=1,7)/ 8., 3., 9., 3., 2.63E-02,4.84543E+05,  2./
      DATA (u(i, 423),i=1,7)/ 8., 3., 9., 9., 2.61E-02,4.08747E+05,  2./
      DATA (u(i, 424),i=1,7)/ 8., 3., 9., 3., 1.88E-02,4.64554E+05,  2./
      DATA (u(i, 425),i=1,7)/ 8., 3., 9., 9., 1.51E-02,4.18533E+05,  2./
      DATA (u(i, 426),i=1,7)/ 8., 3., 9., 9., 1.34E-02,4.28559E+05,  2./
      DATA (u(i, 427),i=1,7)/ 8., 3., 9., 9., 1.08E-02,4.24592E+05,  2./
      DATA (u(i, 428),i=1,7)/ 8., 3., 9., 3., 8.59E-03,4.79916E+05,  2./
      DATA (u(i, 429),i=1,7)/ 8., 3., 9., 3., 7.73E-03,4.88854E+05,  2./
      DATA (u(i, 430),i=1,7)/ 8., 3., 9., 9., 4.53E-03,4.30126E+05,  2./
      DATA (u(i, 431),i=1,7)/ 8., 3., 9., 3., 4.51E-03,4.94462E+05,  2./
      DATA (u(i, 432),i=1,7)/ 8., 3., 9.,15., 3.35E-03,4.25532E+05,  2./
      DATA (u(i, 433),i=1,7)/ 8., 3., 9., 3., 3.03E-03,4.98256E+05,  2./
      DATA (u(i, 434),i=1,7)/ 8., 3., 9., 3., 2.15E-03,5.00902E+05,  2./
      DATA (u(i, 435),i=1,7)/ 8., 3., 9., 9., 7.65E-05,4.31648E+05,  2./
      DATA (u(i, 436),i=1,7)/ 8., 4., 6.,10., 3.02E+00,4.18183E+05,126./
      DATA (u(i, 437),i=1,7)/ 8., 4., 6., 6., 2.03E+00,1.82060E+05,162./
      DATA (u(i, 438),i=1,7)/ 8., 4., 6.,10., 7.56E-01,4.81672E+05,  2./
      DATA (u(i, 439),i=1,7)/ 8., 4., 6.,10., 6.87E-01,5.08750E+05,  2./
      DATA (u(i, 440),i=1,7)/ 8., 4., 6., 6., 4.50E-01,4.65636E+05,  2./
      DATA (u(i, 441),i=1,7)/ 8., 4., 6., 2., 4.07E-01,1.64109E+05,165./
      DATA (u(i, 442),i=1,7)/ 8., 4., 6.,10., 2.94E-01,5.50116E+05,  2./
      DATA (u(i, 443),i=1,7)/ 8., 4., 6.,10., 2.16E-01,5.82920E+05,  2./
      DATA (u(i, 444),i=1,7)/ 8., 4., 6., 2., 1.88E-01,3.56443E+05,  2./
      DATA (u(i, 445),i=1,7)/ 8., 4., 6.,10., 1.72E-01,5.72377E+05,  2./
      DATA (u(i, 446),i=1,7)/ 8., 4., 6., 2., 1.31E-01,4.92587E+05,  2./
      DATA (u(i, 447),i=1,7)/ 8., 4., 6., 6., 1.24E-01,5.73691E+05,  2./
      DATA (u(i, 448),i=1,7)/ 8., 4., 6.,10., 1.05E-01,5.47345E+05,  2./
      DATA (u(i, 449),i=1,7)/ 8., 4., 6., 6., 9.37E-02,5.50146E+05,  2./
      DATA (u(i, 450),i=1,7)/ 8., 4., 6.,10., 7.02E-02,5.85789E+05,  2./
      DATA (u(i, 451),i=1,7)/ 8., 4., 6., 6., 6.36E-02,6.26253E+05,  2./
      DATA (u(i, 452),i=1,7)/ 8., 4., 6.,10., 5.46E-02,5.94389E+05,  2./
      DATA (u(i, 453),i=1,7)/ 8., 4., 6., 6., 5.24E-02,6.56340E+05,  2./
      DATA (u(i, 454),i=1,7)/ 8., 4., 6., 2., 4.14E-02,5.54570E+05,  2./
      DATA (u(i, 455),i=1,7)/ 8., 4., 6., 2., 3.27E-02,5.37577E+05,  2./
      DATA (u(i, 456),i=1,7)/ 8., 4., 6.,10., 3.03E-02,6.00348E+05,  2./
      DATA (u(i, 457),i=1,7)/ 8., 4., 6.,10., 2.91E-02,6.04522E+05,  2./
      DATA (u(i, 458),i=1,7)/ 8., 4., 6., 6., 2.35E-02,6.66045E+05,  2./
      DATA (u(i, 459),i=1,7)/ 8., 4., 6., 6., 1.97E-02,6.51169E+05,  2./
      DATA (u(i, 460),i=1,7)/ 8., 4., 6., 2., 1.75E-02,5.88720E+05,  2./
      DATA (u(i, 461),i=1,7)/ 8., 4., 6., 6., 1.51E-02,5.94354E+05,  2./
      DATA (u(i, 462),i=1,7)/ 8., 4., 6., 6., 1.39E-02,6.75083E+05,  2./
      DATA (u(i, 463),i=1,7)/ 8., 4., 6., 2., 1.35E-02,4.84121E+05,  2./
      DATA (u(i, 464),i=1,7)/ 8., 4., 6.,10., 1.26E-02,6.00096E+05,  2./
      DATA (u(i, 465),i=1,7)/ 8., 4., 6., 6., 9.27E-03,6.81385E+05,  2./
      DATA (u(i, 466),i=1,7)/ 8., 4., 6., 6., 6.57E-03,6.85824E+05,  2./
      DATA (u(i, 467),i=1,7)/ 8., 4., 6., 2., 6.21E-03,5.92172E+05,  2./
      DATA (u(i, 468),i=1,7)/ 8., 4., 6.,10., 3.38E-03,5.94742E+05,  2./
      DATA (u(i, 469),i=1,7)/ 8., 4., 6., 2., 2.26E-03,5.98623E+05,  2./
      DATA (u(i, 470),i=1,7)/ 8., 4., 6., 2., 1.43E-03,6.03282E+05,  2./
      DATA (u(i, 471),i=1,7)/ 8., 4., 6., 2., 6.27E-04,5.81903E+05,  2./
      DATA (u(i, 472),i=1,7)/ 8., 4., 6., 2., 4.75E-04,5.66829E+05,  2./
      DATA (u(i, 473),i=1,7)/ 8., 4., 6., 6., 7.65E-05,6.63790E+05,  2./
      DATA (u(i, 474),i=1,7)/ 8., 4., 6., 6., 2.55E-06,6.31473E+05,  2./
      DATA (u(i, 475),i=1,7)/ 8., 5., 1., 3., 3.94E-01,5.79475E+05,  2./
      DATA (u(i, 476),i=1,7)/ 8., 5., 1., 3., 7.76E-02,7.36323E+05,  2./
      DATA (u(i, 477),i=1,7)/ 8., 5., 1., 3., 5.79E-02,7.18701E+05,  2./
      DATA (u(i, 478),i=1,7)/ 8., 5., 1., 3., 4.99E-02,8.00576E+05,  2./
      DATA (u(i, 479),i=1,7)/ 8., 5., 1., 3., 2.95E-02,8.37802E+05,  2./
      DATA (u(i, 480),i=1,7)/ 8., 5., 1., 3., 1.39E-02,8.58885E+05,  2./
      DATA (u(i, 481),i=1,7)/ 8., 5., 1., 3., 1.02E-02,8.72448E+05,  2./
      DATA (u(i, 482),i=1,7)/ 8., 5., 1., 3., 7.31E-03,8.81756E+05,  2./
      DATA (u(i, 483),i=1,7)/ 8., 5., 1., 3., 5.68E-03,8.46238E+05,  2./
      DATA (u(i, 484),i=1,7)/ 8., 5., 1., 3., 5.33E-03,8.88257E+05,  2./
      DATA (u(i, 485),i=1,7)/ 8., 5., 1., 3., 1.96E-04,8.22842E+05,  2./
      DATA (u(i, 486),i=1,7)/ 8., 5., 1., 3., 1.51E-05,6.63614E+05,  2./
      DATA (u(i, 487),i=1,7)/ 8., 6., 2., 6., 1.48E-01,8.61772E+05, 18./
      DATA (u(i, 488),i=1,7)/ 8., 6., 2., 6., 6.39E-02,9.52381E+05, 18./
      DATA (u(i, 489),i=1,7)/ 8., 6., 2., 6., 3.38E-02,1.00140E+06, 18./
      DATA (u(i, 490),i=1,7)/ 8., 6., 2., 6., 2.02E-02,1.03093E+06, 18./
      DATA (u(i, 491),i=1,7)/ 8., 6., 2., 6., 1.31E-02,1.05009E+06, 18./
      DATA (u(i, 492),i=1,7)/ 8., 6., 2., 6., 8.97E-03,1.06315E+06, 18./
      DATA (u(i, 493),i=1,7)/ 8., 6., 2., 6., 6.43E-03,1.07250E+06, 18./
      DATA (u(i, 494),i=1,7)/ 8., 7., 1., 3.,-1.90E+06,4.52534E+06, 83./
      DATA (u(i, 495),i=1,7)/ 8., 7., 1., 3., 1.18E-04,4.58600E+06, 82./
      DATA (u(i, 496),i=1,7)/ 8., 7., 1., 3., 6.95E-01,4.62107E+06, 80./
      DATA (u(i, 497),i=1,7)/ 8., 7., 1., 3., 1.46E-01,5.35906E+06, 77./
      DATA (u(i, 498),i=1,7)/ 8., 7., 1., 3., 5.51E-02,5.61798E+06, 13./
      DATA (u(i, 499),i=1,7)/ 8., 7., 1., 3., 2.68E-02,5.73723E+06, 13./
      DATA (u(i, 500),i=1,7)/ 8., 7., 1., 3., 1.51E-02,5.80383E+06, 13./
      DATA (u(i, 501),i=1,7)/ 8., 7., 1., 3., 9.36E-03,5.84454E+06, 13./
      DATA (u(i, 502),i=1,7)/ 8., 7., 1., 3., 6.21E-03,5.86854E+06, 13./
      DATA (u(i, 503),i=1,7)/ 8., 7., 1., 3., 4.33E-03,5.88582E+06, 13./
      DATA (u(i, 504),i=1,7)/ 8., 7., 1., 3., 3.14E-03,5.89970E+06, 13./
      DATA (u(i, 505),i=1,7)/ 8., 8., 2., 2.,-3.37E+04,5.27048E+06, 79./
      DATA (u(i, 506),i=1,7)/ 8., 8., 2., 6., 8.32E-01,5.26316E+06, 78./
      DATA (u(i, 507),i=1,7)/ 8., 8., 2., 6., 1.58E-01,6.23830E+06, 74./
      DATA (u(i, 508),i=1,7)/ 8., 8., 2., 6., 5.80E-02,6.57895E+06,  6./
      DATA (u(i, 509),i=1,7)/ 8., 8., 2., 6., 2.79E-02,6.73854E+06,  7./
      DATA (u(i, 510),i=1,7)/ 8., 8., 2., 6., 1.56E-02,6.82594E+06,  8./
      DATA (u(i, 511),i=1,7)/ 8., 8., 2., 6., 9.63E-03,6.87758E+06,  9./
      DATA (u(i, 512),i=1,7)/ 8., 8., 2., 6., 6.37E-03,6.91085E+06,  9./
      DATA (u(i, 513),i=1,7)/ 8., 8., 2., 6., 4.43E-03,6.93481E+06,  9./
      DATA (u(i, 514),i=1,7)/ 8., 8., 2., 6., 3.21E-03,6.94927E+06,  9./
      DATA (u(i, 515),i=1,7)/ 9., 1., 6., 6., 5.73E-01,1.05651E+05,  1./
      DATA (u(i, 516),i=1,7)/ 9., 1., 6.,10., 2.92E-01,1.24911E+05,  1./
      DATA (u(i, 517),i=1,7)/ 9., 1., 6., 2., 1.18E-01,1.47955E+05,  1./
      DATA (u(i, 518),i=1,7)/ 9., 1., 6.,10., 1.17E-01,1.28138E+05,  1./
      DATA (u(i, 519),i=1,7)/ 9., 1., 6., 6., 1.14E-01,1.26307E+05,  1./
      DATA (u(i, 520),i=1,7)/ 9., 1., 6.,10., 5.79E-02,1.33508E+05,  1./
      DATA (u(i, 521),i=1,7)/ 9., 1., 6., 6., 4.14E-02,1.32783E+05,  1./
      DATA (u(i, 522),i=1,7)/ 9., 1., 6.,10., 3.16E-02,1.35995E+05,  1./
      DATA (u(i, 523),i=1,7)/ 9., 1., 6., 6., 2.54E-02,1.28261E+05,  1./
      DATA (u(i, 524),i=1,7)/ 9., 1., 6., 6., 1.97E-02,1.35636E+05,  1./
      DATA (u(i, 525),i=1,7)/ 9., 1., 6., 2., 1.89E-02,1.48878E+05,  1./
      DATA (u(i, 526),i=1,7)/ 9., 1., 6.,10., 1.89E-02,1.37344E+05,  1./
      DATA (u(i, 527),i=1,7)/ 9., 1., 6., 6., 1.37E-02,1.33570E+05,  1./
      DATA (u(i, 528),i=1,7)/ 9., 1., 6.,10., 1.21E-02,1.38158E+05,  1./
      DATA (u(i, 529),i=1,7)/ 9., 1., 6., 6., 1.09E-02,1.37140E+05,  1./
      DATA (u(i, 530),i=1,7)/ 9., 1., 6.,10., 8.17E-03,1.38685E+05,  1./
      DATA (u(i, 531),i=1,7)/ 9., 1., 6., 6., 7.67E-03,1.36029E+05,  1./
      DATA (u(i, 532),i=1,7)/ 9., 1., 6., 6., 6.71E-03,1.38030E+05,  1./
      DATA (u(i, 533),i=1,7)/ 9., 1., 6.,10., 5.78E-03,1.39047E+05,  1./
      DATA (u(i, 534),i=1,7)/ 9., 1., 6., 6., 4.63E-03,1.37365E+05,  1./
      DATA (u(i, 535),i=1,7)/ 9., 1., 6., 6., 4.41E-03,1.38600E+05,  1./
      DATA (u(i, 536),i=1,7)/ 9., 1., 6.,10., 4.23E-03,1.39305E+05,  1./
      DATA (u(i, 537),i=1,7)/ 9., 1., 6., 6., 3.06E-03,1.38987E+05,  1./
      DATA (u(i, 538),i=1,7)/ 9., 1., 6., 6., 2.99E-03,1.38169E+05,  1./
      DATA (u(i, 539),i=1,7)/ 9., 1., 6., 6., 2.21E-03,1.39262E+05,  1./
      DATA (u(i, 540),i=1,7)/ 9., 1., 6., 6., 2.03E-03,1.38694E+05,  1./
      DATA (u(i, 541),i=1,7)/ 9., 1., 6., 6., 1.44E-03,1.39053E+05,  1./
      DATA (u(i, 542),i=1,7)/ 9., 1., 6., 2., 1.11E-03,1.54048E+05,  1./
      DATA (u(i, 543),i=1,7)/ 9., 1., 6., 2., 5.20E-04,1.56588E+05,  1./
      DATA (u(i, 544),i=1,7)/ 9., 1., 6., 2., 2.27E-04,1.57973E+05,  1./
      DATA (u(i, 545),i=1,7)/ 9., 1., 6., 2., 1.06E-04,1.58806E+05,  1./
      DATA (u(i, 546),i=1,7)/ 9., 1., 6., 2., 5.43E-05,1.59347E+05,  1./
      DATA (u(i, 547),i=1,7)/ 9., 1., 6., 2., 3.00E-05,1.59719E+05,  1./
      DATA (u(i, 548),i=1,7)/ 9., 1., 6., 2., 1.77E-05,1.59982E+05,  1./
      DATA (u(i, 549),i=1,7)/ 9., 2., 9., 9., 1.60E+00,1.65981E+05,  3./
      DATA (u(i, 550),i=1,7)/ 9., 2., 9.,15., 8.78E-01,2.32428E+05,  2./
      DATA (u(i, 551),i=1,7)/ 9., 2., 9.,15., 6.32E-01,2.13211E+05,  2./
      DATA (u(i, 552),i=1,7)/ 9., 2., 9., 9., 6.20E-01,2.66702E+05,  2./
      DATA (u(i, 553),i=1,7)/ 9., 2., 9., 3., 5.03E-01,1.84037E+05,  2./
      DATA (u(i, 554),i=1,7)/ 9., 2., 9.,15., 4.62E-01,2.65738E+05,  2./
      DATA (u(i, 555),i=1,7)/ 9., 2., 9.,15., 3.45E-01,2.53994E+05,  2./
      DATA (u(i, 556),i=1,7)/ 9., 2., 9., 9., 3.19E-01,2.31022E+05,  2./
      DATA (u(i, 557),i=1,7)/ 9., 2., 9., 9., 2.58E-01,2.83262E+05,  2./
      DATA (u(i, 558),i=1,7)/ 9., 2., 9.,15., 2.35E-01,2.69767E+05,  2./
      DATA (u(i, 559),i=1,7)/ 9., 2., 9., 3., 2.08E-01,2.66603E+05,  2./
      DATA (u(i, 560),i=1,7)/ 9., 2., 9., 9., 2.01E-01,2.86903E+05,  2./
      DATA (u(i, 561),i=1,7)/ 9., 2., 9., 9., 1.46E-01,2.98151E+05,  2./
      DATA (u(i, 562),i=1,7)/ 9., 2., 9., 9., 1.05E-01,3.03545E+05,  2./
      DATA (u(i, 563),i=1,7)/ 9., 2., 9., 9., 9.66E-02,2.88575E+05,  2./
      DATA (u(i, 564),i=1,7)/ 9., 2., 9., 3., 9.53E-02,2.37090E+05,  2./
      DATA (u(i, 565),i=1,7)/ 9., 2., 9., 9., 9.41E-02,3.05194E+05,  2./
      DATA (u(i, 566),i=1,7)/ 9., 2., 9.,15., 7.85E-02,2.72755E+05,  2./
      DATA (u(i, 567),i=1,7)/ 9., 2., 9.,15., 7.81E-02,2.63943E+05,  2./
      DATA (u(i, 568),i=1,7)/ 9., 2., 9., 9., 6.59E-02,3.06748E+05,  2./
      DATA (u(i, 569),i=1,7)/ 9., 2., 9.,15., 5.82E-02,2.69469E+05,  2./
      DATA (u(i, 570),i=1,7)/ 9., 2., 9.,15., 4.79E-02,2.74876E+05,  2./
      DATA (u(i, 571),i=1,7)/ 9., 2., 9., 3., 3.41E-02,2.56174E+05,  2./
      DATA (u(i, 572),i=1,7)/ 9., 2., 9.,15., 3.17E-02,2.76327E+05,  2./
      DATA (u(i, 573),i=1,7)/ 9., 2., 9., 9., 2.99E-02,3.08976E+05,  2./
      DATA (u(i, 574),i=1,7)/ 9., 2., 9., 9., 2.36E-02,3.10424E+05,  2./
      DATA (u(i, 575),i=1,7)/ 9., 2., 9.,15., 2.21E-02,2.77369E+05,  2./
      DATA (u(i, 576),i=1,7)/ 9., 2., 9., 9., 1.80E-02,3.11459E+05,  2./
      DATA (u(i, 577),i=1,7)/ 9., 2., 9., 3., 1.18E-02,2.70161E+05,  2./
      DATA (u(i, 578),i=1,7)/ 9., 2., 9., 3., 1.06E-02,2.65182E+05,  2./
      DATA (u(i, 579),i=1,7)/ 9., 2., 9., 3., 6.76E-03,2.73187E+05,  2./
      DATA (u(i, 580),i=1,7)/ 9., 2., 9., 3., 4.39E-03,2.75171E+05,  2./
      DATA (u(i, 581),i=1,7)/ 9., 2., 9., 3., 3.03E-03,2.76541E+05,  2./
      DATA (u(i, 582),i=1,7)/ 9., 2., 9., 9., 1.98E-03,3.07229E+05,  2./
      DATA (u(i, 583),i=1,7)/ 9., 3., 4.,12., 2.73E+00,3.94120E+05,  2./
      DATA (u(i, 584),i=1,7)/ 9., 3., 4.,12., 9.97E-01,1.51412E+05,  3./
      DATA (u(i, 585),i=1,7)/ 9., 3., 4.,12., 7.72E-01,4.44939E+05,  2./
      DATA (u(i, 586),i=1,7)/ 9., 3., 4.,12., 6.33E-01,4.37637E+05,  2./
      DATA (u(i, 587),i=1,7)/ 9., 3., 4.,12., 5.46E-01,3.20359E+05,  2./
      DATA (u(i, 588),i=1,7)/ 9., 3., 4.,12., 4.54E-01,4.67924E+05,  2./
      DATA (u(i, 589),i=1,7)/ 9., 3., 4.,12., 2.58E-01,4.80423E+05,  2./
      DATA (u(i, 590),i=1,7)/ 9., 3., 4.,12., 1.60E-01,4.87924E+05,  2./
      DATA (u(i, 591),i=1,7)/ 9., 3., 4.,12., 1.06E-01,4.92756E+05,  2./
      DATA (u(i, 592),i=1,7)/ 9., 3., 4.,12., 7.45E-02,4.96081E+05,  2./
      DATA (u(i, 593),i=1,7)/ 9., 3., 4.,12., 5.76E-02,4.18148E+05,  2./
      DATA (u(i, 594),i=1,7)/ 9., 3., 4.,12., 5.45E-02,4.98455E+05,  2./
      DATA (u(i, 595),i=1,7)/ 9., 3., 4.,12., 3.51E-02,4.55394E+05,  2./
      DATA (u(i, 596),i=1,7)/ 9., 3., 4.,12., 1.45E-02,4.73485E+05,  2./
      DATA (u(i, 597),i=1,7)/ 9., 3., 4.,12., 7.94E-03,4.83699E+05,  2./
      DATA (u(i, 598),i=1,7)/ 9., 3., 4.,12., 4.93E-03,4.90004E+05,  2./
      DATA (u(i, 599),i=1,7)/ 9., 3., 4.,12., 3.35E-03,4.94169E+05,  2./
      DATA (u(i, 600),i=1,7)/ 9., 3., 4.,12., 2.46E-03,4.97067E+05,  2./
      DATA (u(i, 601),i=1,7)/ 9., 4., 9.,15., 5.30E+00,4.97389E+05,  2./
      DATA (u(i, 602),i=1,7)/ 9., 4., 9., 9., 1.79E+00,5.00350E+05,  2./
      DATA (u(i, 603),i=1,7)/ 9., 4., 9.,15., 1.48E+00,5.88582E+05,  2./
      DATA (u(i, 604),i=1,7)/ 9., 4., 9., 3., 1.44E+00,2.40720E+05,  3./
      DATA (u(i, 605),i=1,7)/ 9., 4., 9., 9., 1.10E+00,1.75679E+05,  3./
      DATA (u(i, 606),i=1,7)/ 9., 4., 9.,15., 8.96E-01,1.47165E+05,  3./
      DATA (u(i, 607),i=1,7)/ 9., 4., 9.,15., 8.38E-01,5.48757E+05,  2./
      DATA (u(i, 608),i=1,7)/ 9., 4., 9., 9., 7.21E-01,4.16615E+05,  2./
      DATA (u(i, 609),i=1,7)/ 9., 4., 9.,15., 6.84E-01,6.30001E+05,  2./
      DATA (u(i, 610),i=1,7)/ 9., 4., 9., 9., 5.03E-01,5.89067E+05,  2./
      DATA (u(i, 611),i=1,7)/ 9., 4., 9.,15., 4.09E-01,6.52316E+05,  2./
      DATA (u(i, 612),i=1,7)/ 9., 4., 9., 9., 3.76E-01,5.58972E+05,  2./
      DATA (u(i, 613),i=1,7)/ 9., 4., 9.,15., 3.56E-01,6.59805E+05,  2./
      DATA (u(i, 614),i=1,7)/ 9., 4., 9., 9., 2.37E-01,6.30239E+05,  2./
      DATA (u(i, 615),i=1,7)/ 9., 4., 9., 9., 2.20E-01,6.63262E+05,  2./
      DATA (u(i, 616),i=1,7)/ 9., 4., 9., 3., 1.92E-01,5.31689E+05,  2./
      DATA (u(i, 617),i=1,7)/ 9., 4., 9.,15., 1.87E-01,6.65779E+05,  2./
      DATA (u(i, 618),i=1,7)/ 9., 4., 9., 9., 1.57E-01,5.54262E+05,  2./
      DATA (u(i, 619),i=1,7)/ 9., 4., 9., 9., 1.38E-01,6.52443E+05,  2./
      DATA (u(i, 620),i=1,7)/ 9., 4., 9.,15., 1.10E-01,6.74400E+05,  2./
      DATA (u(i, 621),i=1,7)/ 9., 4., 9.,15., 8.82E-02,6.80365E+05,  2./
      DATA (u(i, 622),i=1,7)/ 9., 4., 9.,15., 6.45E-02,6.84556E+05,  2./
      DATA (u(i, 623),i=1,7)/ 9., 4., 9., 3., 5.63E-02,6.52614E+05,  2./
      DATA (u(i, 624),i=1,7)/ 9., 4., 9., 9., 5.14E-02,6.13949E+05,  2./
      DATA (u(i, 625),i=1,7)/ 9., 4., 9., 9., 4.62E-02,6.65868E+05,  2./
      DATA (u(i, 626),i=1,7)/ 9., 4., 9., 3., 4.54E-02,6.78610E+05,  2./
      DATA (u(i, 627),i=1,7)/ 9., 4., 9., 9., 4.45E-02,6.74491E+05,  2./
      DATA (u(i, 628),i=1,7)/ 9., 4., 9.,15., 4.37E-02,6.70286E+05,  2./
      DATA (u(i, 629),i=1,7)/ 9., 4., 9., 9., 3.80E-02,6.74900E+05,  2./
      DATA (u(i, 630),i=1,7)/ 9., 4., 9., 9., 3.73E-02,6.61070E+05,  2./
      DATA (u(i, 631),i=1,7)/ 9., 4., 9., 9., 3.11E-02,6.80365E+05,  2./
      DATA (u(i, 632),i=1,7)/ 9., 4., 9., 9., 2.67E-02,6.44164E+05,  2./
      DATA (u(i, 633),i=1,7)/ 9., 4., 9., 9., 2.26E-02,6.84603E+05,  2./
      DATA (u(i, 634),i=1,7)/ 9., 4., 9., 3., 2.16E-02,7.02149E+05,  2./
      DATA (u(i, 635),i=1,7)/ 9., 4., 9., 9., 1.98E-02,6.70916E+05,  2./
      DATA (u(i, 636),i=1,7)/ 9., 4., 9., 3., 1.16E-02,7.31904E+05,  2./
      DATA (u(i, 637),i=1,7)/ 9., 4., 9.,15., 1.00E-02,6.74673E+05,  2./
      DATA (u(i, 638),i=1,7)/ 9., 4., 9.,15., 8.29E-03,6.12445E+05,  2./
      DATA (u(i, 639),i=1,7)/ 9., 4., 9., 3., 7.64E-03,7.46157E+05,  2./
      DATA (u(i, 640),i=1,7)/ 9., 4., 9., 9., 7.22E-03,6.20463E+05,  2./
      DATA (u(i, 641),i=1,7)/ 9., 4., 9., 3., 4.90E-03,7.55572E+05,  2./
      DATA (u(i, 642),i=1,7)/ 9., 4., 9., 3., 3.31E-03,7.62021E+05,  2./
      DATA (u(i, 643),i=1,7)/ 9., 4., 9., 3., 2.33E-03,7.66577E+05,  2./
      DATA (u(i, 644),i=1,7)/ 9., 4., 9., 9., 1.30E-03,6.83060E+05,  2./
      DATA (u(i, 645),i=1,7)/ 9., 4., 9., 3., 2.04E-04,7.18959E+05,  2./
      DATA (u(i, 646),i=1,7)/ 9., 4., 9., 9., 5.81E-05,6.78380E+05,  2./
      DATA (u(i, 647),i=1,7)/ 9., 4., 9., 9., 1.41E-05,6.57030E+05,  2./
      DATA (u(i, 648),i=1,7)/ 9., 5., 6.,10., 3.26E+00,6.00565E+05,  2./
      DATA (u(i, 649),i=1,7)/ 9., 5., 6., 6., 1.74E+00,2.16146E+05,  3./
      DATA (u(i, 650),i=1,7)/ 9., 5., 6.,10., 8.75E-01,6.74218E+05,  2./
      DATA (u(i, 651),i=1,7)/ 9., 5., 6.,10., 7.69E-01,7.41565E+05,  2./
      DATA (u(i, 652),i=1,7)/ 9., 5., 6.,10., 5.99E-01,1.52681E+05,  3./
      DATA (u(i, 653),i=1,7)/ 9., 5., 6., 6., 5.48E-01,6.53808E+05,  2./
      DATA (u(i, 654),i=1,7)/ 9., 5., 6., 2., 3.47E-01,1.98950E+05,  3./
      DATA (u(i, 655),i=1,7)/ 9., 5., 6.,10., 3.14E-01,8.06062E+05,  2./
      DATA (u(i, 656),i=1,7)/ 9., 5., 6.,10., 2.53E-01,8.31186E+05,  2./
      DATA (u(i, 657),i=1,7)/ 9., 5., 6., 2., 1.79E-01,5.23122E+05,  2./
      DATA (u(i, 658),i=1,7)/ 9., 5., 6., 6., 1.48E-01,8.27130E+05,  2./
      DATA (u(i, 659),i=1,7)/ 9., 5., 6.,10., 1.43E-01,8.40760E+05,  2./
      DATA (u(i, 660),i=1,7)/ 9., 5., 6., 6., 1.36E-01,7.53069E+05,  2./
      DATA (u(i, 661),i=1,7)/ 9., 5., 6., 2., 1.26E-01,6.86813E+05,  2./
      DATA (u(i, 662),i=1,7)/ 9., 5., 6.,10., 9.03E-02,8.61623E+05,  2./
      DATA (u(i, 663),i=1,7)/ 9., 5., 6., 2., 7.19E-02,7.10581E+05,  2./
      DATA (u(i, 664),i=1,7)/ 9., 5., 6.,10., 6.83E-02,8.75120E+05,  2./
      DATA (u(i, 665),i=1,7)/ 9., 5., 6.,10., 6.17E-02,7.50694E+05,  2./
      DATA (u(i, 666),i=1,7)/ 9., 5., 6., 6., 5.96E-02,8.95576E+05,  2./
      DATA (u(i, 667),i=1,7)/ 9., 5., 6., 2., 4.38E-02,7.60052E+05,  2./
      DATA (u(i, 668),i=1,7)/ 9., 5., 6., 6., 4.38E-02,9.33271E+05,  2./
      DATA (u(i, 669),i=1,7)/ 9., 5., 6., 2., 3.99E-02,8.35841E+05,  2./
      DATA (u(i, 670),i=1,7)/ 9., 5., 6.,10., 3.83E-02,8.84330E+05,  2./
      DATA (u(i, 671),i=1,7)/ 9., 5., 6., 6., 3.38E-02,9.18442E+05,  2./
      DATA (u(i, 672),i=1,7)/ 9., 5., 6.,10., 3.05E-02,8.81446E+05,  2./
      DATA (u(i, 673),i=1,7)/ 9., 5., 6.,10., 3.02E-02,8.90869E+05,  2./
      DATA (u(i, 674),i=1,7)/ 9., 5., 6., 6., 2.71E-02,8.88968E+05,  2./
      DATA (u(i, 675),i=1,7)/ 9., 5., 6.,10., 2.58E-02,8.72372E+05,  2./
      DATA (u(i, 676),i=1,7)/ 9., 5., 6., 6., 2.38E-02,9.55292E+05,  2./
      DATA (u(i, 677),i=1,7)/ 9., 5., 6.,10., 2.16E-02,8.09979E+05,  2./
      DATA (u(i, 678),i=1,7)/ 9., 5., 6., 6., 1.54E-02,7.96305E+05,  2./
      DATA (u(i, 679),i=1,7)/ 9., 5., 6., 6., 1.12E-02,9.68429E+05,  2./
      DATA (u(i, 680),i=1,7)/ 9., 5., 6., 6., 6.84E-03,9.80008E+05,  2./
      DATA (u(i, 681),i=1,7)/ 9., 5., 6., 2., 5.36E-03,7.92833E+05,  2./
      DATA (u(i, 682),i=1,7)/ 9., 5., 6., 2., 5.22E-03,8.56751E+05,  2./
      DATA (u(i, 683),i=1,7)/ 9., 5., 6., 6., 4.02E-03,8.51064E+05,  2./
      DATA (u(i, 684),i=1,7)/ 9., 5., 6., 2., 3.13E-03,8.71840E+05,  2./
      DATA (u(i, 685),i=1,7)/ 9., 5., 6., 2., 2.45E-03,8.81990E+05,  2./
      DATA (u(i, 686),i=1,7)/ 9., 5., 6., 2., 2.25E-03,8.89126E+05,  2./
      DATA (u(i, 687),i=1,7)/ 9., 5., 6., 6., 1.42E-03,9.86485E+05,  2./
      DATA (u(i, 688),i=1,7)/ 9., 5., 6., 6., 1.34E-03,9.72479E+05,  2./
      DATA (u(i, 689),i=1,7)/ 9., 5., 6.,10., 8.43E-04,8.42744E+05,  2./
      DATA (u(i, 690),i=1,7)/ 9., 5., 6., 2., 5.05E-04,8.74967E+05,  2./
      DATA (u(i, 691),i=1,7)/ 9., 5., 6., 2., 3.42E-04,8.32154E+05,  2./
      DATA (u(i, 692),i=1,7)/ 9., 6., 1., 3., 4.48E-01,1.88690E+05,  3./
      DATA (u(i, 693),i=1,7)/ 9., 6., 1., 3., 4.45E-01,7.85855E+05,  2./
      DATA (u(i, 694),i=1,7)/ 9., 6., 1., 3., 1.11E-01,1.00553E+06,  2./
      DATA (u(i, 695),i=1,7)/ 9., 6., 1., 3., 4.57E-02,1.09673E+06,  2./
      DATA (u(i, 696),i=1,7)/ 9., 6., 1., 3., 4.00E-02,9.51928E+05,  2./
      DATA (u(i, 697),i=1,7)/ 9., 6., 1., 3., 2.43E-02,1.15181E+06,  2./
      DATA (u(i, 698),i=1,7)/ 9., 6., 1., 3., 1.72E-02,1.18175E+06,  2./
      DATA (u(i, 699),i=1,7)/ 9., 6., 1., 3., 1.19E-02,1.13520E+06,  2./
      DATA (u(i, 700),i=1,7)/ 9., 6., 1., 3., 1.12E-02,1.20091E+06,  2./
      DATA (u(i, 701),i=1,7)/ 9., 6., 1., 3., 9.68E-03,1.11000E+06,  2./
      DATA (u(i, 702),i=1,7)/ 9., 6., 1., 3., 8.59E-03,1.21521E+06,  2./
      DATA (u(i, 703),i=1,7)/ 9., 6., 1., 3., 5.61E-03,1.22145E+06,  2./
      DATA (u(i, 704),i=1,7)/ 9., 6., 1., 3., 2.98E-03,1.22474E+06,  2./
      DATA (u(i, 705),i=1,7)/ 9., 6., 1., 3., 2.19E-03,8.84643E+05,  2./
      DATA (u(i, 706),i=1,7)/ 9., 6., 1., 3., 2.58E-05,1.20773E+06,  2./
      DATA (u(i, 707),i=1,7)/ 9., 7., 2., 6., 5.70E-01,8.83314E+05, 16./
      DATA (u(i, 708),i=1,7)/ 9., 7., 2., 6., 3.43E-01,1.11992E+05, 14./
      DATA (u(i, 709),i=1,7)/ 9., 7., 2., 6., 1.56E-01,1.15062E+06, 18./
      DATA (u(i, 710),i=1,7)/ 9., 7., 2., 6., 6.67E-02,1.27372E+06, 18./
      DATA (u(i, 711),i=1,7)/ 9., 7., 2., 6., 3.52E-02,1.34030E+06, 18./
      DATA (u(i, 712),i=1,7)/ 9., 7., 2., 6., 2.10E-02,1.38045E+06, 18./
      DATA (u(i, 713),i=1,7)/ 9., 7., 2., 6., 1.36E-02,1.40647E+06, 18./
      DATA (u(i, 714),i=1,7)/ 9., 7., 2., 6., 9.31E-03,1.42410E+06, 18./
      DATA (u(i, 715),i=1,7)/ 9., 7., 2., 6., 6.67E-03,1.43699E+06, 18./
      DATA (u(i, 716),i=1,7)/ 9., 8., 1., 3.,-3.04E+06,5.83004E+06, 24./
      DATA (u(i, 717),i=1,7)/ 9., 8., 1., 3., 2.37E-04,5.90075E+06, 25./
      DATA (u(i, 718),i=1,7)/ 9., 8., 1., 3., 7.10E-01,5.93824E+06, 11./
      DATA (u(i, 719),i=1,7)/ 9., 8., 1., 3., 1.48E-01,6.90131E+06, 12./
      DATA (u(i, 720),i=1,7)/ 9., 8., 1., 3., 5.56E-02,7.24113E+06, 13./
      DATA (u(i, 721),i=1,7)/ 9., 8., 1., 3., 2.70E-02,7.40192E+06, 13./
      DATA (u(i, 722),i=1,7)/ 9., 8., 1., 3., 1.52E-02,7.48503E+06, 13./
      DATA (u(i, 723),i=1,7)/ 9., 8., 1., 3., 9.42E-03,7.53580E+06, 13./
      DATA (u(i, 724),i=1,7)/ 9., 8., 1., 3., 6.25E-03,7.57002E+06, 13./
      DATA (u(i, 725),i=1,7)/ 9., 8., 1., 3., 4.36E-03,7.59301E+06, 13./
      DATA (u(i, 726),i=1,7)/ 9., 8., 1., 3., 3.16E-03,7.61035E+06, 13./
      DATA (u(i, 727),i=1,7)/ 9., 9., 2., 2.,-5.40E+04,6.66222E+06, 23./
      DATA (u(i, 728),i=1,7)/ 9., 9., 2., 6., 8.32E-01,6.66222E+06,  4./
      DATA (u(i, 729),i=1,7)/ 9., 9., 2., 6., 1.58E-01,7.89889E+06,  5./
      DATA (u(i, 730),i=1,7)/ 9., 9., 2., 6., 5.80E-02,8.32639E+06,  6./
      DATA (u(i, 731),i=1,7)/ 9., 9., 2., 6., 2.79E-02,8.52515E+06,  7./
      DATA (u(i, 732),i=1,7)/ 9., 9., 2., 6., 1.56E-02,8.63558E+06,  8./
      DATA (u(i, 733),i=1,7)/ 9., 9., 2., 6., 9.63E-03,8.70322E+06,  9./
      DATA (u(i, 734),i=1,7)/ 9., 9., 2., 6., 6.37E-03,8.74126E+06,  9./
      DATA (u(i, 735),i=1,7)/ 9., 9., 2., 6., 4.43E-03,8.77193E+06,  9./
      DATA (u(i, 736),i=1,7)/ 9., 9., 2., 6., 3.21E-03,8.79508E+06,  9./
      DATA (u(i, 737),i=1,7)/10., 1., 1., 3., 1.70E-01,1.45224E+05,  1./
      DATA (u(i, 738),i=1,7)/10., 1., 1., 3., 3.48E-02,1.67532E+05,  1./
      DATA (u(i, 739),i=1,7)/10., 1., 1., 3., 2.31E-02,1.69978E+05,  1./
      DATA (u(i, 740),i=1,7)/10., 1., 1., 3., 1.27E-02,1.74350E+05,  1./
      DATA (u(i, 741),i=1,7)/10., 1., 1., 3., 1.25E-02,1.75325E+05,  1./
      DATA (u(i, 742),i=1,7)/10., 1., 1., 3., 7.02E-03,1.77800E+05,  1./
      DATA (u(i, 743),i=1,7)/10., 1., 1., 3., 6.07E-03,1.77314E+05,  1./
      DATA (u(i, 744),i=1,7)/10., 1., 1., 3., 4.24E-03,1.79144E+05,  1./
      DATA (u(i, 745),i=1,7)/10., 1., 1., 3., 3.37E-03,1.78868E+05,  1./
      DATA (u(i, 746),i=1,7)/10., 1., 1., 3., 2.74E-03,1.79953E+05,  1./
      DATA (u(i, 747),i=1,7)/10., 1., 1., 3., 2.06E-03,1.79782E+05,  1./
      DATA (u(i, 748),i=1,7)/10., 1., 1., 3., 1.86E-03,1.80479E+05,  1./
      DATA (u(i, 749),i=1,7)/10., 1., 1., 3., 1.35E-03,1.80365E+05,  1./
      DATA (u(i, 750),i=1,7)/10., 1., 1., 3., 1.32E-03,1.80842E+05,  1./
      DATA (u(i, 751),i=1,7)/10., 1., 1., 3., 9.71E-04,1.81097E+05,  1./
      DATA (u(i, 752),i=1,7)/10., 1., 1., 3., 9.37E-04,1.80760E+05,  1./
      DATA (u(i, 753),i=1,7)/10., 1., 1., 3., 6.75E-04,1.81041E+05,  1./
      DATA (u(i, 754),i=1,7)/10., 2., 6., 6., 7.05E-01,2.25149E+05,  2./
      DATA (u(i, 755),i=1,7)/10., 2., 6.,10., 6.63E-01,2.80214E+05,  2./
      DATA (u(i, 756),i=1,7)/10., 2., 6., 2., 5.14E-01,2.16896E+05,  3./
      DATA (u(i, 757),i=1,7)/10., 2., 6.,10., 3.93E-01,2.47445E+05,  2./
      DATA (u(i, 758),i=1,7)/10., 2., 6., 6., 2.53E-01,3.05157E+05,  2./
      DATA (u(i, 759),i=1,7)/10., 2., 6.,10., 2.53E-01,3.01932E+05,  2./
      DATA (u(i, 760),i=1,7)/10., 2., 6.,10., 2.36E-01,3.05680E+05,  2./
      DATA (u(i, 761),i=1,7)/10., 2., 6., 6., 2.35E-01,2.80923E+05,  2./
      DATA (u(i, 762),i=1,7)/10., 2., 6.,10., 1.72E-01,3.12012E+05,  2./
      DATA (u(i, 763),i=1,7)/10., 2., 6., 2., 1.43E-01,3.05661E+05,  2./
      DATA (u(i, 764),i=1,7)/10., 2., 6.,10., 9.35E-02,3.17450E+05,  2./
      DATA (u(i, 765),i=1,7)/10., 2., 6., 6., 9.03E-02,2.83046E+05,  2./
      DATA (u(i, 766),i=1,7)/10., 2., 6., 2., 7.56E-02,3.27279E+05,  2./
      DATA (u(i, 767),i=1,7)/10., 2., 6., 6., 6.67E-02,3.02142E+05,  2./
      DATA (u(i, 768),i=1,7)/10., 2., 6., 6., 6.58E-02,3.12129E+05,  2./
      DATA (u(i, 769),i=1,7)/10., 2., 6., 2., 5.91E-02,2.77847E+05,  2./
      DATA (u(i, 770),i=1,7)/10., 2., 6.,10., 5.67E-02,3.20718E+05,  2./
      DATA (u(i, 771),i=1,7)/10., 2., 6., 2., 4.60E-02,3.36893E+05,  2./
      DATA (u(i, 772),i=1,7)/10., 2., 6.,10., 3.65E-02,3.22841E+05,  2./
      DATA (u(i, 773),i=1,7)/10., 2., 6., 6., 3.43E-02,3.17511E+05,  2./
      DATA (u(i, 774),i=1,7)/10., 2., 6.,10., 3.00E-02,3.07759E+05,  2./
      DATA (u(i, 775),i=1,7)/10., 2., 6., 6., 2.85E-02,3.03260E+05,  2./
      DATA (u(i, 776),i=1,7)/10., 2., 6.,10., 2.43E-02,3.24296E+05,  2./
      DATA (u(i, 777),i=1,7)/10., 2., 6., 6., 2.02E-02,3.20760E+05,  2./
      DATA (u(i, 778),i=1,7)/10., 2., 6., 2., 1.96E-02,3.42947E+05,  2./
      DATA (u(i, 779),i=1,7)/10., 2., 6., 6., 1.80E-02,3.12695E+05,  2./
      DATA (u(i, 780),i=1,7)/10., 2., 6.,10., 1.64E-02,3.25330E+05,  2./
      DATA (u(i, 781),i=1,7)/10., 2., 6., 2., 1.32E-02,3.46212E+05,  2./
      DATA (u(i, 782),i=1,7)/10., 2., 6., 6., 1.26E-02,3.22862E+05,  2./
      DATA (u(i, 783),i=1,7)/10., 2., 6., 6., 9.90E-03,3.17854E+05,  2./
      DATA (u(i, 784),i=1,7)/10., 2., 6., 2., 9.10E-03,3.48335E+05,  2./
      DATA (u(i, 785),i=1,7)/10., 2., 6., 6., 7.95E-03,3.24307E+05,  2./
      DATA (u(i, 786),i=1,7)/10., 2., 6., 2., 6.49E-03,3.49797E+05,  2./
      DATA (u(i, 787),i=1,7)/10., 2., 6., 6., 6.05E-03,3.20986E+05,  2./
      DATA (u(i, 788),i=1,7)/10., 2., 6., 6., 4.87E-03,3.25341E+05,  2./
      DATA (u(i, 789),i=1,7)/10., 2., 6., 2., 4.78E-03,3.50828E+05,  2./
      DATA (u(i, 790),i=1,7)/10., 2., 6., 6., 3.95E-03,3.23018E+05,  2./
      DATA (u(i, 791),i=1,7)/10., 2., 6., 6., 2.69E-03,3.24423E+05,  2./
      DATA (u(i, 792),i=1,7)/10., 2., 6., 2., 1.90E-03,3.38135E+05,  2./
      DATA (u(i, 793),i=1,7)/10., 3., 9., 9., 1.58E+00,2.05364E+05,  3./
      DATA (u(i, 794),i=1,7)/10., 3., 9.,15., 1.58E+00,3.98533E+05,  2./
      DATA (u(i, 795),i=1,7)/10., 3., 9., 9., 1.34E+00,4.39715E+05,  2./
      DATA (u(i, 796),i=1,7)/10., 3., 9.,15., 7.90E-01,4.57959E+05,  2./
      DATA (u(i, 797),i=1,7)/10., 3., 9.,15., 7.38E-01,4.47808E+05,  2./
      DATA (u(i, 798),i=1,7)/10., 3., 9.,15., 7.22E-01,4.36929E+05,  2./
      DATA (u(i, 799),i=1,7)/10., 3., 9.,15., 6.66E-01,3.55139E+05,  2./
      DATA (u(i, 800),i=1,7)/10., 3., 9., 3., 4.95E-01,3.21419E+05,  2./
      DATA (u(i, 801),i=1,7)/10., 3., 9., 9., 4.66E-01,4.88926E+05,  2./
      DATA (u(i, 802),i=1,7)/10., 3., 9., 3., 4.44E-01,4.40160E+05,  2./
      DATA (u(i, 803),i=1,7)/10., 3., 9.,15., 4.09E-01,4.70478E+05,  2./
      DATA (u(i, 804),i=1,7)/10., 3., 9., 9., 3.70E-01,3.76634E+05,  2./
      DATA (u(i, 805),i=1,7)/10., 3., 9., 9., 3.61E-01,4.58652E+05,  2./
      DATA (u(i, 806),i=1,7)/10., 3., 9.,15., 2.85E-01,4.87567E+05,  2./
      DATA (u(i, 807),i=1,7)/10., 3., 9.,15., 2.67E-01,4.60575E+05,  2./
      DATA (u(i, 808),i=1,7)/10., 3., 9., 9., 2.29E-01,5.08776E+05,  2./
      DATA (u(i, 809),i=1,7)/10., 3., 9., 9., 2.25E-01,5.11561E+05,  2./
      DATA (u(i, 810),i=1,7)/10., 3., 9.,15., 1.97E-01,4.90292E+05,  2./
      DATA (u(i, 811),i=1,7)/10., 3., 9., 3., 1.87E-01,4.89045E+05,  2./
      DATA (u(i, 812),i=1,7)/10., 3., 9., 9., 1.47E-01,5.23944E+05,  2./
      DATA (u(i, 813),i=1,7)/10., 3., 9.,15., 1.47E-01,4.82719E+05,  2./
      DATA (u(i, 814),i=1,7)/10., 3., 9., 9., 1.30E-01,5.31350E+05,  2./
      DATA (u(i, 815),i=1,7)/10., 3., 9., 9., 1.06E-01,4.80054E+05,  2./
      DATA (u(i, 816),i=1,7)/10., 3., 9., 3., 1.02E-01,4.20044E+05,  2./
      DATA (u(i, 817),i=1,7)/10., 3., 9.,15., 9.03E-02,4.95025E+05,  2./
      DATA (u(i, 818),i=1,7)/10., 3., 9., 9., 6.97E-02,5.36164E+05,  2./
      DATA (u(i, 819),i=1,7)/10., 3., 9., 9., 6.80E-02,5.32170E+05,  2./
      DATA (u(i, 820),i=1,7)/10., 3., 9.,15., 6.27E-02,4.98281E+05,  2./
      DATA (u(i, 821),i=1,7)/10., 3., 9.,15., 5.71E-02,4.97463E+05,  2./
      DATA (u(i, 822),i=1,7)/10., 3., 9., 9., 4.84E-02,5.39491E+05,  2./
      DATA (u(i, 823),i=1,7)/10., 3., 9., 3., 4.24E-02,4.57289E+05,  2./
      DATA (u(i, 824),i=1,7)/10., 3., 9., 9., 4.10E-02,5.41829E+05,  2./
      DATA (u(i, 825),i=1,7)/10., 3., 9.,15., 3.89E-02,5.00626E+05,  2./
      DATA (u(i, 826),i=1,7)/10., 3., 9., 3., 2.07E-02,4.75489E+05,  2./
      DATA (u(i, 827),i=1,7)/10., 3., 9., 9., 1.75E-02,5.18699E+05,  2./
      DATA (u(i, 828),i=1,7)/10., 3., 9., 3., 1.15E-02,4.85743E+05,  2./
      DATA (u(i, 829),i=1,7)/10., 3., 9., 3., 7.84E-03,4.92102E+05,  2./
      DATA (u(i, 830),i=1,7)/10., 3., 9., 3., 5.14E-03,4.96278E+05,  2./
      DATA (u(i, 831),i=1,7)/10., 3., 9., 3., 3.61E-03,4.99201E+05,  2./
      DATA (u(i, 832),i=1,7)/10., 3., 9., 9., 2.47E-03,5.37374E+05,  2./
      DATA (u(i, 833),i=1,7)/10., 4., 4.,12., 3.73E+00,5.82920E+05,  2./
      DATA (u(i, 834),i=1,7)/10., 4., 4.,12., 1.16E+00,6.73174E+05,  2./
      DATA (u(i, 835),i=1,7)/10., 4., 4.,12., 9.29E-01,1.83083E+05,  3./
      DATA (u(i, 836),i=1,7)/10., 4., 4.,12., 5.34E-01,4.82672E+05,  2./
      DATA (u(i, 837),i=1,7)/10., 4., 4.,12., 4.66E-01,7.14388E+05,  2./
      DATA (u(i, 838),i=1,7)/10., 4., 4.,12., 4.42E-01,6.28536E+05,  2./
      DATA (u(i, 839),i=1,7)/10., 4., 4.,12., 3.21E-01,7.36811E+05,  2./
      DATA (u(i, 840),i=1,7)/10., 4., 4.,12., 2.67E-01,7.49681E+05,  2./
      DATA (u(i, 841),i=1,7)/10., 4., 4.,12., 1.83E-01,6.36578E+05,  2./
      DATA (u(i, 842),i=1,7)/10., 4., 4.,12., 1.13E-01,7.58898E+05,  2./
      DATA (u(i, 843),i=1,7)/10., 4., 4.,12., 9.52E-02,7.15922E+05,  2./
      DATA (u(i, 844),i=1,7)/10., 4., 4.,12., 7.99E-02,7.64818E+05,  2./
      DATA (u(i, 845),i=1,7)/10., 4., 4.,12., 6.69E-02,7.50356E+05,  2./
      DATA (u(i, 846),i=1,7)/10., 4., 4.,12., 5.82E-02,7.68994E+05,  2./
      DATA (u(i, 847),i=1,7)/10., 4., 4.,12., 3.65E-02,7.45268E+05,  2./
      DATA (u(i, 848),i=1,7)/10., 4., 4.,12., 3.47E-02,6.96670E+05,  2./
      DATA (u(i, 849),i=1,7)/10., 4., 4.,12., 9.79E-03,7.27220E+05,  2./
      DATA (u(i, 850),i=1,7)/10., 4., 4.,12., 5.00E-03,7.55173E+05,  2./
      DATA (u(i, 851),i=1,7)/10., 4., 4.,12., 4.80E-03,7.41950E+05,  2./
      DATA (u(i, 852),i=1,7)/10., 4., 4.,12., 3.87E-03,7.62195E+05,  2./
      DATA (u(i, 853),i=1,7)/10., 4., 4.,12., 2.76E-03,7.67106E+05,  2./
      DATA (u(i, 854),i=1,7)/10., 5., 9.,15., 6.06E+00,6.97593E+05,  2./
      DATA (u(i, 855),i=1,7)/10., 5., 9., 9., 2.04E+00,7.01066E+05,  2./
      DATA (u(i, 856),i=1,7)/10., 5., 9.,15., 1.60E+00,8.39631E+05,  2./
      DATA (u(i, 857),i=1,7)/10., 5., 9., 3., 1.26E+00,2.81183E+05,150./
      DATA (u(i, 858),i=1,7)/10., 5., 9., 9., 9.88E-01,2.07835E+05,159./
      DATA (u(i, 859),i=1,7)/10., 5., 9.,15., 9.48E-01,7.54375E+05,  2./
      DATA (u(i, 860),i=1,7)/10., 5., 9.,15., 8.28E-01,1.74407E+05,164./
      DATA (u(i, 861),i=1,7)/10., 5., 9., 9., 6.87E-01,5.95876E+05,  2./
      DATA (u(i, 862),i=1,7)/10., 5., 9.,15., 6.38E-01,9.04404E+05,  2./
      DATA (u(i, 863),i=1,7)/10., 5., 9., 9., 4.65E-01,7.62486E+05,  2./
      DATA (u(i, 864),i=1,7)/10., 5., 9., 9., 4.29E-01,8.40901E+05,  2./
      DATA (u(i, 865),i=1,7)/10., 5., 9.,15., 3.36E-01,9.39232E+05,  2./
      DATA (u(i, 866),i=1,7)/10., 5., 9.,15., 2.93E-01,9.21914E+05,  2./
      DATA (u(i, 867),i=1,7)/10., 5., 9.,15., 2.74E-01,8.91981E+05,  2./
      DATA (u(i, 868),i=1,7)/10., 5., 9., 3., 2.40E-01,7.32654E+05,  2./
      DATA (u(i, 869),i=1,7)/10., 5., 9., 9., 2.18E-01,9.04568E+05,  2./
      DATA (u(i, 870),i=1,7)/10., 5., 9.,15., 2.08E-01,9.60154E+05,  2./
      DATA (u(i, 871),i=1,7)/10., 5., 9., 9., 1.67E-01,8.97908E+05,  2./
      DATA (u(i, 872),i=1,7)/10., 5., 9., 9., 1.66E-01,8.00192E+05,  2./
      DATA (u(i, 873),i=1,7)/10., 5., 9.,15., 1.36E-01,9.73615E+05,  2./
      DATA (u(i, 874),i=1,7)/10., 5., 9., 9., 1.23E-01,8.37521E+05,  2./
      DATA (u(i, 875),i=1,7)/10., 5., 9., 9., 1.14E-01,9.39320E+05,  2./
      DATA (u(i, 876),i=1,7)/10., 5., 9., 9., 9.67E-02,9.25583E+05,  2./
      DATA (u(i, 877),i=1,7)/10., 5., 9.,15., 9.44E-02,9.82898E+05,  2./
      DATA (u(i, 878),i=1,7)/10., 5., 9.,15., 7.11E-02,9.89511E+05,  2./
      DATA (u(i, 879),i=1,7)/10., 5., 9., 9., 7.09E-02,9.60154E+05,  2./
      DATA (u(i, 880),i=1,7)/10., 5., 9., 9., 6.77E-02,8.79817E+05,  2./
      DATA (u(i, 881),i=1,7)/10., 5., 9., 3., 6.28E-02,9.02527E+05,  2./
      DATA (u(i, 882),i=1,7)/10., 5., 9., 3., 5.92E-02,9.10001E+05,  2./
      DATA (u(i, 883),i=1,7)/10., 5., 9., 9., 5.38E-02,8.86446E+05,  2./
      DATA (u(i, 884),i=1,7)/10., 5., 9.,15., 5.22E-02,8.29119E+05,  2./
      DATA (u(i, 885),i=1,7)/10., 5., 9., 9., 5.12E-02,9.29714E+05,  2./
      DATA (u(i, 886),i=1,7)/10., 5., 9., 9., 4.64E-02,9.73710E+05,  2./
      DATA (u(i, 887),i=1,7)/10., 5., 9., 9., 3.22E-02,9.82898E+05,  2./
      DATA (u(i, 888),i=1,7)/10., 5., 9., 3., 3.00E-02,9.91473E+05,  2./
      DATA (u(i, 889),i=1,7)/10., 5., 9., 3., 2.85E-02,1.06929E+06,  2./
      DATA (u(i, 890),i=1,7)/10., 5., 9., 9., 2.39E-02,9.89511E+05,  2./
      DATA (u(i, 891),i=1,7)/10., 5., 9., 3., 1.52E-02,1.03008E+06,  2./
      DATA (u(i, 892),i=1,7)/10., 5., 9., 9., 1.19E-02,9.53925E+05,  2./
      DATA (u(i, 893),i=1,7)/10., 5., 9., 3., 8.17E-03,1.05308E+06,  2./
      DATA (u(i, 894),i=1,7)/10., 5., 9., 9., 7.29E-03,9.69556E+05,  2./
      DATA (u(i, 895),i=1,7)/10., 5., 9., 3., 6.77E-03,1.07991E+06,  2./
      DATA (u(i, 896),i=1,7)/10., 5., 9., 9., 4.90E-03,9.80008E+05,  2./
      DATA (u(i, 897),i=1,7)/10., 5., 9., 3., 4.60E-03,9.50390E+05,  2./
      DATA (u(i, 898),i=1,7)/10., 5., 9., 3., 4.02E-03,1.08495E+06,  2./
      DATA (u(i, 899),i=1,7)/10., 5., 9., 9., 3.58E-03,9.87362E+05,  2./
      DATA (u(i, 900),i=1,7)/10., 5., 9.,15., 3.29E-03,9.40645E+05,  2./
      DATA (u(i, 901),i=1,7)/10., 5., 9., 3., 2.50E-03,1.07770E+06,  2./
      DATA (u(i, 902),i=1,7)/10., 5., 9., 3., 8.00E-04,1.06769E+06,  2./
      DATA (u(i, 903),i=1,7)/10., 5., 9.,15., 6.99E-04,9.69180E+05,  2./
      DATA (u(i, 904),i=1,7)/10., 6., 6.,10., 3.42E+00,8.13537E+05,  2./
      DATA (u(i, 905),i=1,7)/10., 6., 6., 6., 1.52E+00,2.49981E+05,154./
      DATA (u(i, 906),i=1,7)/10., 6., 6., 6., 1.00E-06,1.00080E+05,184./
      DATA (u(i, 907),i=1,7)/10., 6., 6.,10., 1.01E+00,8.97344E+05,  2./
      DATA (u(i, 908),i=1,7)/10., 6., 6.,10., 7.32E-01,1.01585E+06,  2./
      DATA (u(i, 909),i=1,7)/10., 6., 6., 6., 6.21E-01,8.72600E+05,  2./
      DATA (u(i, 910),i=1,7)/10., 6., 6.,10., 5.41E-01,1.77996E+05,163./
      DATA (u(i, 911),i=1,7)/10., 6., 6.,10., 3.35E-01,1.10828E+06,  2./
      DATA (u(i, 912),i=1,7)/10., 6., 6., 2., 3.04E-01,2.31492E+05,  3./
      DATA (u(i, 913),i=1,7)/10., 6., 6.,10., 2.74E-01,1.11421E+06,  2./
      DATA (u(i, 914),i=1,7)/10., 6., 6., 2., 1.75E-01,9.12659E+05,  2./
      DATA (u(i, 915),i=1,7)/10., 6., 6., 2., 1.70E-01,7.20513E+05,  2./
      DATA (u(i, 916),i=1,7)/10., 6., 6., 6., 1.67E-01,9.86388E+05,  2./
      DATA (u(i, 917),i=1,7)/10., 6., 6.,10., 1.56E-01,1.15821E+06,  2./
      DATA (u(i, 918),i=1,7)/10., 6., 6.,10., 1.54E-01,1.21330E+06,  2./
      DATA (u(i, 919),i=1,7)/10., 6., 6., 6., 1.30E-01,1.11284E+06,  2./
      DATA (u(i, 920),i=1,7)/10., 6., 6.,10., 1.18E-01,9.84349E+05,  2./
      DATA (u(i, 921),i=1,7)/10., 6., 6.,10., 9.50E-02,1.18821E+06,  2./
      DATA (u(i, 922),i=1,7)/10., 6., 6., 2., 8.26E-02,9.73331E+05,  2./
      DATA (u(i, 923),i=1,7)/10., 6., 6., 6., 7.84E-02,1.21803E+06,  2./
      DATA (u(i, 924),i=1,7)/10., 6., 6., 6., 6.29E-02,1.09963E+06,  2./
      DATA (u(i, 925),i=1,7)/10., 6., 6.,10., 5.16E-02,1.20758E+06,  2./
      DATA (u(i, 926),i=1,7)/10., 6., 6., 6., 4.35E-02,1.21007E+06,  2./
      DATA (u(i, 927),i=1,7)/10., 6., 6., 6., 4.19E-02,1.26326E+06,  2./
      DATA (u(i, 928),i=1,7)/10., 6., 6., 6., 3.91E-02,1.31770E+06,  2./
      DATA (u(i, 929),i=1,7)/10., 6., 6., 2., 3.82E-02,1.21536E+06,  2./
      DATA (u(i, 930),i=1,7)/10., 6., 6.,10., 3.68E-02,1.20380E+06,  2./
      DATA (u(i, 931),i=1,7)/10., 6., 6.,10., 3.58E-02,1.22070E+06,  2./
      DATA (u(i, 932),i=1,7)/10., 6., 6.,10., 3.33E-02,1.12334E+06,  2./
      DATA (u(i, 933),i=1,7)/10., 6., 6., 2., 2.77E-02,1.12020E+06,  2./
      DATA (u(i, 934),i=1,7)/10., 6., 6.,10., 2.71E-02,1.23016E+06,  2./
      DATA (u(i, 935),i=1,7)/10., 6., 6., 6., 2.34E-02,1.29668E+06,  2./
      DATA (u(i, 936),i=1,7)/10., 6., 6., 6., 2.21E-02,1.14876E+06,  2./
      DATA (u(i, 937),i=1,7)/10., 6., 6., 2., 1.99E-02,1.13084E+06,  2./
      DATA (u(i, 938),i=1,7)/10., 6., 6.,10., 1.36E-02,1.14364E+06,  2./
      DATA (u(i, 939),i=1,7)/10., 6., 6., 6., 1.24E-02,1.33067E+06,  2./
      DATA (u(i, 940),i=1,7)/10., 6., 6., 2., 1.13E-02,1.14850E+06,  2./
      DATA (u(i, 941),i=1,7)/10., 6., 6., 2., 1.05E-02,1.00210E+06,  2./
      DATA (u(i, 942),i=1,7)/10., 6., 6., 2., 8.22E-03,1.09135E+06,  2./
      DATA (u(i, 943),i=1,7)/10., 6., 6., 6., 7.08E-03,1.34030E+06,  2./
      DATA (u(i, 944),i=1,7)/10., 6., 6.,10., 6.40E-03,1.13830E+06,  2./
      DATA (u(i, 945),i=1,7)/10., 6., 6., 2., 5.75E-03,1.15727E+06,  2./
      DATA (u(i, 946),i=1,7)/10., 6., 6., 6., 5.49E-03,1.33887E+06,  2./
      DATA (u(i, 947),i=1,7)/10., 6., 6., 2., 4.75E-03,1.18203E+06,  2./
      DATA (u(i, 948),i=1,7)/10., 6., 6., 2., 4.18E-03,1.20322E+06,  2./
      DATA (u(i, 949),i=1,7)/10., 6., 6., 6., 2.65E-03,1.30480E+06,  2./
      DATA (u(i, 950),i=1,7)/10., 6., 6., 6., 1.77E-03,1.31596E+06,  2./
      DATA (u(i, 951),i=1,7)/10., 6., 6.,10., 1.65E-03,1.21788E+06,  2./
      DATA (u(i, 952),i=1,7)/10., 6., 6.,10., 6.17E-04,1.05396E+06,  2./
      DATA (u(i, 953),i=1,7)/10., 6., 6., 2., 4.09E-04,1.22294E+06,  2./
      DATA (u(i, 954),i=1,7)/10., 6., 6., 2., 4.03E-04,1.21743E+06,  2./
      DATA (u(i, 955),i=1,7)/10., 6., 6., 2., 2.75E-04,1.22865E+06,  2./
      DATA (u(i, 956),i=1,7)/10., 6., 6.,10., 2.37E-04,1.22459E+06,  2./
      DATA (u(i, 957),i=1,7)/10., 6., 6., 6., 1.39E-04,1.27894E+06,  2./
      DATA (u(i, 958),i=1,7)/10., 6., 6., 6., 1.14E-04,1.03983E+06,  2./
      DATA (u(i, 959),i=1,7)/10., 7., 1., 3., 4.85E-01,1.02281E+06,  2./
      DATA (u(i, 960),i=1,7)/10., 7., 1., 3., 3.92E-01,2.16361E+05,158./
      DATA (u(i, 961),i=1,7)/10., 7., 1., 3., 1.26E-01,1.31648E+06,  2./
      DATA (u(i, 962),i=1,7)/10., 7., 1., 3., 5.14E-02,1.44739E+06,  2./
      DATA (u(i, 963),i=1,7)/10., 7., 1., 3., 3.63E-02,1.21521E+06,  2./
      DATA (u(i, 964),i=1,7)/10., 7., 1., 3., 2.92E-02,1.51423E+06,  2./
      DATA (u(i, 965),i=1,7)/10., 7., 1., 3., 1.85E-02,1.55473E+06,  2./
      DATA (u(i, 966),i=1,7)/10., 7., 1., 3., 1.62E-02,1.58153E+06,  2./
      DATA (u(i, 967),i=1,7)/10., 7., 1., 3., 1.16E-02,1.42918E+06,  2./
      DATA (u(i, 968),i=1,7)/10., 7., 1., 3., 7.22E-03,1.60026E+06,  2./
      DATA (u(i, 969),i=1,7)/10., 7., 1., 3., 5.87E-03,1.13585E+06,  2./
      DATA (u(i, 970),i=1,7)/10., 7., 1., 3., 5.59E-03,1.61316E+06,  2./
      DATA (u(i, 971),i=1,7)/10., 7., 1., 3., 5.03E-03,1.46628E+06,  2./
      DATA (u(i, 972),i=1,7)/10., 7., 1., 3., 3.91E-05,1.56715E+06,  2./
      DATA (u(i, 973),i=1,7)/10., 7., 1., 3., 1.99E-05,1.58453E+06,  2./
      DATA (u(i, 974),i=1,7)/10., 8., 2., 6., 1.62E-01,1.48060E+06, 18./
      DATA (u(i, 975),i=1,7)/10., 8., 2., 6., 6.89E-02,1.64096E+06, 18./
      DATA (u(i, 976),i=1,7)/10., 8., 2., 6., 3.62E-02,1.72801E+06, 18./
      DATA (u(i, 977),i=1,7)/10., 8., 2., 6., 2.16E-02,1.78031E+06, 18./
      DATA (u(i, 978),i=1,7)/10., 8., 2., 6., 1.40E-02,1.81422E+06, 18./
      DATA (u(i, 979),i=1,7)/10., 8., 2., 6., 9.56E-03,1.83756E+06, 18./
      DATA (u(i, 980),i=1,7)/10., 8., 2., 6., 6.85E-03,1.85391E+06, 18./
      DATA (u(i, 981),i=1,7)/10., 9., 1., 3.,-4.64E+06,7.29994E+06, 24./
      DATA (u(i, 982),i=1,7)/10., 9., 1., 3., 4.42E-04,7.37850E+06, 66./
      DATA (u(i, 983),i=1,7)/10., 9., 1., 3., 7.23E-01,7.41840E+06, 65./
      DATA (u(i, 984),i=1,7)/10., 9., 1., 3., 1.49E-01,8.64304E+06, 12./
      DATA (u(i, 985),i=1,7)/10., 9., 1., 3., 5.60E-02,9.07441E+06, 13./
      DATA (u(i, 986),i=1,7)/10., 9., 1., 3., 2.71E-02,9.27644E+06, 13./
      DATA (u(i, 987),i=1,7)/10., 9., 1., 3., 1.53E-02,9.38086E+06, 13./
      DATA (u(i, 988),i=1,7)/10., 9., 1., 3., 9.46E-03,9.44287E+06, 13./
      DATA (u(i, 989),i=1,7)/10., 9., 1., 3., 6.27E-03,9.48767E+06, 13./
      DATA (u(i, 990),i=1,7)/10., 9., 1., 3., 4.37E-03,9.51475E+06, 13./
      DATA (u(i, 991),i=1,7)/10., 9., 1., 3., 3.17E-03,9.54198E+06, 13./
      DATA (u(i, 992),i=1,7)/10.,10., 2., 2.,-8.23E+04,8.23723E+06, 61./
      DATA (u(i, 993),i=1,7)/10.,10., 2., 6., 8.32E-01,8.22368E+06, 60./
      DATA (u(i, 994),i=1,7)/10.,10., 2., 6., 1.58E-01,9.74659E+06,  5./
      DATA (u(i, 995),i=1,7)/10.,10., 2., 6., 5.80E-02,1.02775E+07,  6./
      DATA (u(i, 996),i=1,7)/10.,10., 2., 6., 2.79E-02,1.05263E+07,  7./
      DATA (u(i, 997),i=1,7)/10.,10., 2., 6., 1.56E-02,1.06610E+07,  8./
      DATA (u(i, 998),i=1,7)/10.,10., 2., 6., 9.63E-03,1.07411E+07,  9./
      DATA (u(i, 999),i=1,7)/10.,10., 2., 6., 6.37E-03,1.07991E+07,  9./
      DATA (u(i,1000),i=1,7)/10.,10., 2., 6., 4.43E-03,1.08342E+07,  9./
      DATA (u(i,1001),i=1,7)/10.,10., 2., 6., 3.21E-03,1.08578E+07,  9./
      DATA (u(i,1002),i=1,7)/11., 1., 2., 6., 2.64E-02,2.95527E+04,  1./
      DATA (u(i,1003),i=1,7)/11., 1., 2., 6., 3.90E-03,3.42648E+04,  1./
      DATA (u(i,1004),i=1,7)/11., 1., 2., 6., 1.18E-03,3.64983E+04,  1./
      DATA (u(i,1005),i=1,7)/11., 1., 2., 6., 5.01E-04,3.77320E+04,  1./
      DATA (u(i,1006),i=1,7)/11., 1., 2., 6., 2.60E-04,3.84849E+04,  1./
      DATA (u(i,1007),i=1,7)/11., 1., 2., 6., 1.53E-04,3.89781E+04,  1./
      DATA (u(i,1008),i=1,7)/11., 1., 2., 6., 9.79E-05,3.93185E+04,  1./
      DATA (u(i,1009),i=1,7)/11., 2., 1., 3., 2.38E-01,3.40983E+05, 19./
      DATA (u(i,1010),i=1,7)/11., 2., 1., 3., 2.27E-01,2.79376E+05, 21./
      DATA (u(i,1011),i=1,7)/11., 2., 1., 3., 1.09E-01,3.62582E+05, 20./
      DATA (u(i,1012),i=1,7)/11., 2., 1., 3., 5.71E-02,3.72550E+05,  2./
      DATA (u(i,1013),i=1,7)/11., 2., 1., 3., 3.34E-02,3.77943E+05,  2./
      DATA (u(i,1014),i=1,7)/11., 2., 1., 3., 2.11E-02,3.81199E+05,  2./
      DATA (u(i,1015),i=1,7)/11., 2., 1., 3., 1.42E-02,3.83303E+05,  2./
      DATA (u(i,1016),i=1,7)/11., 2., 1., 3., 9.98E-03,3.84749E+05,  2./
      DATA (u(i,1017),i=1,7)/11., 2., 1., 3., 7.29E-03,3.85773E+05,  2./
      DATA (u(i,1018),i=1,7)/11., 2., 1., 3., 1.35E-04,3.72745E+05,  2./
      DATA (u(i,1019),i=1,7)/11., 2., 1., 3., 1.22E-04,3.62950E+05,  2./
      DATA (u(i,1020),i=1,7)/11., 2., 1., 3., 1.04E-04,3.78058E+05,  2./
      DATA (u(i,1021),i=1,7)/11., 2., 1., 3., 7.60E-05,3.81272E+05,  2./
      DATA (u(i,1022),i=1,7)/11., 2., 1., 3., 5.55E-05,3.83347E+05,  2./
      DATA (u(i,1023),i=1,7)/11., 2., 1., 3., 4.12E-05,3.84778E+05,  2./
      DATA (u(i,1024),i=1,7)/11., 2., 1., 3., 3.13E-05,3.85802E+05,  2./
      DATA (u(i,1025),i=1,7)/11., 2., 1., 3., 8.36E-06,3.41764E+05, 22./
      DATA (u(i,1026),i=1,7)/11., 3., 6.,10., 1.38E+00,4.64382E+05,  2./
      DATA (u(i,1027),i=1,7)/11., 3., 6., 6., 7.30E-01,3.74714E+05,  2./
      DATA (u(i,1028),i=1,7)/11., 3., 6.,10., 6.38E-01,5.13795E+05,  2./
      DATA (u(i,1029),i=1,7)/11., 3., 6., 2., 5.32E-01,2.63685E+05,  3./
      DATA (u(i,1030),i=1,7)/11., 3., 6., 6., 5.29E-01,4.92562E+05,  2./
      DATA (u(i,1031),i=1,7)/11., 3., 6.,10., 4.22E-01,4.00064E+05,  2./
      DATA (u(i,1032),i=1,7)/11., 3., 6.,10., 4.06E-01,4.93949E+05,  2./
      DATA (u(i,1033),i=1,7)/11., 3., 6., 6., 3.98E-01,4.65701E+05,  2./
      DATA (u(i,1034),i=1,7)/11., 3., 6.,10., 3.13E-01,5.36481E+05,  2./
      DATA (u(i,1035),i=1,7)/11., 3., 6., 2., 3.12E-01,4.93194E+05,  2./
      DATA (u(i,1036),i=1,7)/11., 3., 6., 6., 2.36E-01,5.14112E+05,  2./
      DATA (u(i,1037),i=1,7)/11., 3., 6., 6., 2.24E-01,5.42977E+05,  2./
      DATA (u(i,1038),i=1,7)/11., 3., 6.,10., 2.07E-01,5.48847E+05,  2./
      DATA (u(i,1039),i=1,7)/11., 3., 6.,10., 1.86E-01,5.28989E+05,  2./
      DATA (u(i,1040),i=1,7)/11., 3., 6., 2., 1.47E-01,5.42623E+05,  2./
      DATA (u(i,1041),i=1,7)/11., 3., 6.,10., 1.42E-01,5.43478E+05,  2./
      DATA (u(i,1042),i=1,7)/11., 3., 6., 6., 1.25E-01,4.81742E+05,  2./
      DATA (u(i,1043),i=1,7)/11., 3., 6.,10., 1.14E-01,5.56204E+05,  2./
      DATA (u(i,1044),i=1,7)/11., 3., 6., 6., 8.36E-02,5.48878E+05,  2./
      DATA (u(i,1045),i=1,7)/11., 3., 6., 2., 7.52E-02,4.36148E+05,  2./
      DATA (u(i,1046),i=1,7)/11., 3., 6., 6., 7.33E-02,5.36481E+05,  2./
      DATA (u(i,1047),i=1,7)/11., 3., 6., 6., 7.13E-02,5.66091E+05,  2./
      DATA (u(i,1048),i=1,7)/11., 3., 6.,10., 6.92E-02,5.60978E+05,  2./
      DATA (u(i,1049),i=1,7)/11., 3., 6., 2., 6.78E-02,5.66348E+05,  2./
      DATA (u(i,1050),i=1,7)/11., 3., 6.,10., 6.10E-02,5.10569E+05,  2./
      DATA (u(i,1051),i=1,7)/11., 3., 6., 6., 5.00E-02,5.21458E+05,  2./
      DATA (u(i,1052),i=1,7)/11., 3., 6., 2., 4.06E-02,5.78771E+05,  2./
      DATA (u(i,1053),i=1,7)/11., 3., 6., 6., 3.96E-02,5.56204E+05,  2./
      DATA (u(i,1054),i=1,7)/11., 3., 6.,10., 3.92E-02,5.64239E+05,  2./
      DATA (u(i,1055),i=1,7)/11., 3., 6.,10., 3.22E-02,5.66284E+05,  2./
      DATA (u(i,1056),i=1,7)/11., 3., 6., 2., 2.72E-02,5.86063E+05,  2./
      DATA (u(i,1057),i=1,7)/11., 3., 6.,10., 2.63E-02,5.51086E+05,  2./
      DATA (u(i,1058),i=1,7)/11., 3., 6., 6., 2.32E-02,5.40541E+05,  2./
      DATA (u(i,1059),i=1,7)/11., 3., 6., 6., 2.15E-02,5.60978E+05,  2./
      DATA (u(i,1060),i=1,7)/11., 3., 6., 2., 1.54E-02,5.91156E+05,  2./
      DATA (u(i,1061),i=1,7)/11., 3., 6., 6., 1.41E-02,5.51177E+05,  2./
      DATA (u(i,1062),i=1,7)/11., 3., 6., 2., 1.12E-02,5.94460E+05,  2./
      DATA (u(i,1063),i=1,7)/11., 3., 6., 6., 8.71E-03,5.57693E+05,  2./
      DATA (u(i,1064),i=1,7)/11., 3., 6., 6., 8.27E-03,5.64239E+05,  2./
      DATA (u(i,1065),i=1,7)/11., 3., 6., 2., 8.26E-03,5.96801E+05,  2./
      DATA (u(i,1066),i=1,7)/11., 3., 6., 6., 5.77E-03,5.62019E+05,  2./
      DATA (u(i,1067),i=1,7)/11., 3., 6., 6., 3.96E-03,5.64972E+05,  2./
      DATA (u(i,1068),i=1,7)/11., 3., 6., 2., 1.35E-03,5.46926E+05,  2./
      DATA (u(i,1069),i=1,7)/11., 3., 6., 2., 5.13E-04,5.86992E+05,  2./
      DATA (u(i,1070),i=1,7)/11., 4., 9.,15., 2.07E+00,5.95309E+05,  2./
      DATA (u(i,1071),i=1,7)/11., 4., 9., 9., 2.02E+00,6.43211E+05,  2./
      DATA (u(i,1072),i=1,7)/11., 4., 9., 9., 1.51E+00,2.44349E+05,  3./
      DATA (u(i,1073),i=1,7)/11., 4., 9.,15., 1.51E+00,6.38855E+05,  2./
      DATA (u(i,1074),i=1,7)/11., 4., 9.,15., 1.28E+00,6.83854E+05,  2./
      DATA (u(i,1075),i=1,7)/11., 4., 9.,15., 1.12E+00,6.65602E+05,  2./
      DATA (u(i,1076),i=1,7)/11., 4., 9.,15., 1.06E+00,7.54148E+05,  2./
      DATA (u(i,1077),i=1,7)/11., 4., 9., 3., 7.20E-01,6.44454E+05,  2./
      DATA (u(i,1078),i=1,7)/11., 4., 9., 9., 6.96E-01,7.31422E+05,  2./
      DATA (u(i,1079),i=1,7)/11., 4., 9.,15., 6.67E-01,5.27677E+05,  2./
      DATA (u(i,1080),i=1,7)/11., 4., 9.,15., 6.55E-01,7.29714E+05,  2./
      DATA (u(i,1081),i=1,7)/11., 4., 9., 3., 4.77E-01,4.89309E+05,  2./
      DATA (u(i,1082),i=1,7)/11., 4., 9., 9., 4.28E-01,6.63967E+05,  2./
      DATA (u(i,1083),i=1,7)/11., 4., 9., 9., 3.77E-01,5.52914E+05,  2./
      DATA (u(i,1084),i=1,7)/11., 4., 9.,15., 3.05E-01,7.46102E+05,  2./
      DATA (u(i,1085),i=1,7)/11., 4., 9., 9., 2.89E-01,7.54091E+05,  2./
      DATA (u(i,1086),i=1,7)/11., 4., 9., 9., 2.84E-01,7.63126E+05,  2./
      DATA (u(i,1087),i=1,7)/11., 4., 9., 3., 2.62E-01,7.32064E+05,  2./
      DATA (u(i,1088),i=1,7)/11., 4., 9.,15., 2.57E-01,7.23798E+05,  2./
      DATA (u(i,1089),i=1,7)/11., 4., 9., 9., 2.43E-01,7.72320E+05,  2./
      DATA (u(i,1090),i=1,7)/11., 4., 9.,15., 1.78E-01,7.71307E+05,  2./
      DATA (u(i,1091),i=1,7)/11., 4., 9., 9., 1.77E-01,7.94407E+05,  2./
      DATA (u(i,1092),i=1,7)/11., 4., 9.,15., 1.23E-01,7.59705E+05,  2./
      DATA (u(i,1093),i=1,7)/11., 4., 9., 3., 1.16E-01,7.72618E+05,  2./
      DATA (u(i,1094),i=1,7)/11., 4., 9., 3., 1.07E-01,7.57920E+05,  2./
      DATA (u(i,1095),i=1,7)/11., 4., 9., 9., 1.07E-01,8.07494E+05,  2./
      DATA (u(i,1096),i=1,7)/11., 4., 9.,15., 1.03E-01,7.73994E+05,  2./
      DATA (u(i,1097),i=1,7)/11., 4., 9., 9., 8.30E-02,7.14643E+05,  2./
      DATA (u(i,1098),i=1,7)/11., 4., 9., 9., 7.72E-02,7.96115E+05,  2./
      DATA (u(i,1099),i=1,7)/11., 4., 9.,15., 7.45E-02,6.89893E+05,  2./
      DATA (u(i,1100),i=1,7)/11., 4., 9., 9., 6.97E-02,8.16260E+05,  2./
      DATA (u(i,1101),i=1,7)/11., 4., 9., 3., 5.76E-02,6.44870E+05,  2./
      DATA (u(i,1102),i=1,7)/11., 4., 9.,15., 5.58E-02,7.78089E+05,  2./
      DATA (u(i,1103),i=1,7)/11., 4., 9.,15., 5.52E-02,7.67990E+05,  2./
      DATA (u(i,1104),i=1,7)/11., 4., 9., 9., 5.33E-02,8.18666E+05,  2./
      DATA (u(i,1105),i=1,7)/11., 4., 9., 9., 4.66E-02,8.22166E+05,  2./
      DATA (u(i,1106),i=1,7)/11., 4., 9., 3., 4.50E-02,7.05467E+05,  2./
      DATA (u(i,1107),i=1,7)/11., 4., 9., 3., 2.62E-02,7.52899E+05,  2./
      DATA (u(i,1108),i=1,7)/11., 4., 9., 9., 2.61E-02,8.26378E+05,  2./
      DATA (u(i,1109),i=1,7)/11., 4., 9.,15., 2.28E-02,7.51823E+05,  2./
      DATA (u(i,1110),i=1,7)/11., 4., 9., 3., 2.00E-02,7.35727E+05,  2./
      DATA (u(i,1111),i=1,7)/11., 4., 9., 9., 1.21E-02,8.25696E+05,  2./
      DATA (u(i,1112),i=1,7)/11., 4., 9.,15., 9.08E-03,7.55801E+05,  2./
      DATA (u(i,1113),i=1,7)/11., 4., 9., 9., 8.29E-03,7.77544E+05,  2./
      DATA (u(i,1114),i=1,7)/11., 4., 9., 3., 4.16E-03,7.71010E+05,  2./
      DATA (u(i,1115),i=1,7)/11., 4., 9., 9., 3.08E-03,8.08407E+05,  2./
      DATA (u(i,1116),i=1,7)/11., 4., 9., 3., 2.35E-03,7.63884E+05,  2./
      DATA (u(i,1117),i=1,7)/11., 4., 9., 3., 2.16E-03,7.75976E+05,  2./
      DATA (u(i,1118),i=1,7)/11., 5., 4.,12., 4.48E+00,8.01860E+05,  2./
      DATA (u(i,1119),i=1,7)/11., 5., 4.,12., 1.31E+00,9.42863E+05,  2./
      DATA (u(i,1120),i=1,7)/11., 5., 4.,12., 8.64E-01,2.14643E+05,  3./
      DATA (u(i,1121),i=1,7)/11., 5., 4.,12., 6.23E-01,1.00766E+06,  2./
      DATA (u(i,1122),i=1,7)/11., 5., 4.,12., 5.90E-01,8.50485E+05,  2./
      DATA (u(i,1123),i=1,7)/11., 5., 4.,12., 5.18E-01,6.75584E+05,  2./
      DATA (u(i,1124),i=1,7)/11., 5., 4.,12., 3.24E-01,1.04243E+06,  2./
      DATA (u(i,1125),i=1,7)/11., 5., 4.,12., 2.32E-01,1.02680E+06,  2./
      DATA (u(i,1126),i=1,7)/11., 5., 4.,12., 1.69E-01,1.06349E+06,  2./
      DATA (u(i,1127),i=1,7)/11., 5., 4.,12., 1.17E-01,1.07689E+06,  2./
      DATA (u(i,1128),i=1,7)/11., 5., 4.,12., 1.09E-01,8.95576E+05,  2./
      DATA (u(i,1129),i=1,7)/11., 5., 4.,12., 1.08E-01,1.05175E+06,  2./
      DATA (u(i,1130),i=1,7)/11., 5., 4.,12., 8.19E-02,1.08613E+06,  2./
      DATA (u(i,1131),i=1,7)/11., 5., 4.,12., 6.01E-02,1.09278E+06,  2./
      DATA (u(i,1132),i=1,7)/11., 5., 4.,12., 4.90E-02,1.03018E+06,  2./
      DATA (u(i,1133),i=1,7)/11., 5., 4.,12., 3.48E-02,9.81643E+05,  2./
      DATA (u(i,1134),i=1,7)/11., 5., 4.,12., 9.43E-03,9.53107E+05,  2./
      DATA (u(i,1135),i=1,7)/11., 5., 4.,12., 7.76E-03,9.88435E+05,  2./
      DATA (u(i,1136),i=1,7)/11., 5., 4.,12., 3.09E-03,1.07193E+06,  2./
      DATA (u(i,1137),i=1,7)/11., 5., 4.,12., 2.38E-03,1.08272E+06,  2./
      DATA (u(i,1138),i=1,7)/11., 5., 4.,12., 1.65E-03,1.09027E+06,  2./
      DATA (u(i,1139),i=1,7)/11., 5., 4.,12., 1.12E-04,1.05619E+06,  2./
      DATA (u(i,1140),i=1,7)/11., 6., 9.,15., 6.62E+00,9.28764E+05,  2./
      DATA (u(i,1141),i=1,7)/11., 6., 9., 9., 2.22E+00,9.32662E+05,  2./
      DATA (u(i,1142),i=1,7)/11., 6., 9.,15., 1.78E+00,1.13199E+06,  2./
      DATA (u(i,1143),i=1,7)/11., 6., 9., 3., 1.12E+00,3.21244E+05,  3./
      DATA (u(i,1144),i=1,7)/11., 6., 9.,15., 1.07E+00,9.90786E+05,  2./
      DATA (u(i,1145),i=1,7)/11., 6., 9., 9., 8.95E-01,2.39756E+05,  3./
      DATA (u(i,1146),i=1,7)/11., 6., 9.,15., 7.64E-01,2.01499E+05,  3./
      DATA (u(i,1147),i=1,7)/11., 6., 9., 9., 6.58E-01,8.06257E+05,  2./
      DATA (u(i,1148),i=1,7)/11., 6., 9.,15., 5.85E-01,1.22790E+06,  2./
      DATA (u(i,1149),i=1,7)/11., 6., 9., 9., 5.74E-01,1.00070E+06,  2./
      DATA (u(i,1150),i=1,7)/11., 6., 9., 9., 4.07E-01,1.13276E+06,  2./
      DATA (u(i,1151),i=1,7)/11., 6., 9.,15., 3.55E-01,1.27714E+06,  2./
      DATA (u(i,1152),i=1,7)/11., 6., 9.,15., 3.34E-01,1.22205E+06,  2./
      DATA (u(i,1153),i=1,7)/11., 6., 9., 9., 3.25E-01,1.22790E+06,  2./
      DATA (u(i,1154),i=1,7)/11., 6., 9., 3., 2.75E-01,9.64599E+05,  2./
      DATA (u(i,1155),i=1,7)/11., 6., 9.,15., 2.42E-01,1.30651E+06,  2./
      DATA (u(i,1156),i=1,7)/11., 6., 9., 9., 1.89E-01,1.13546E+06,  2./
      DATA (u(i,1157),i=1,7)/11., 6., 9.,15., 1.75E-01,1.32538E+06,  2./
      DATA (u(i,1158),i=1,7)/11., 6., 9.,15., 1.56E-01,1.32820E+06,  2./
      DATA (u(i,1159),i=1,7)/11., 6., 9., 9., 1.55E-01,1.15207E+06,  2./
      DATA (u(i,1160),i=1,7)/11., 6., 9., 9., 1.27E-01,1.09278E+06,  2./
      DATA (u(i,1161),i=1,7)/11., 6., 9., 9., 1.21E-01,1.27730E+06,  2./
      DATA (u(i,1162),i=1,7)/11., 6., 9.,15., 1.01E-01,1.33851E+06,  2./
      DATA (u(i,1163),i=1,7)/11., 6., 9.,15., 8.60E-02,1.14574E+06,  2./
      DATA (u(i,1164),i=1,7)/11., 6., 9.,15., 8.24E-02,1.34771E+06,  2./
      DATA (u(i,1165),i=1,7)/11., 6., 9., 9., 7.88E-02,1.30651E+06,  2./
      DATA (u(i,1166),i=1,7)/11., 6., 9., 3., 7.84E-02,1.15714E+06,  2./
      DATA (u(i,1167),i=1,7)/11., 6., 9., 9., 7.52E-02,1.22956E+06,  2./
      DATA (u(i,1168),i=1,7)/11., 6., 9.,15., 7.31E-02,1.23716E+06,  2./
      DATA (u(i,1169),i=1,7)/11., 6., 9., 9., 6.76E-02,1.07805E+06,  2./
      DATA (u(i,1170),i=1,7)/11., 6., 9., 9., 6.70E-02,1.33032E+06,  2./
      DATA (u(i,1171),i=1,7)/11., 6., 9., 9., 6.11E-02,1.32556E+06,  2./
      DATA (u(i,1172),i=1,7)/11., 6., 9., 3., 5.85E-02,1.22775E+06,  2./
      DATA (u(i,1173),i=1,7)/11., 6., 9.,15., 5.73E-02,1.07631E+06,  2./
      DATA (u(i,1174),i=1,7)/11., 6., 9., 9., 3.51E-02,1.33851E+06,  2./
      DATA (u(i,1175),i=1,7)/11., 6., 9., 3., 3.31E-02,1.32328E+06,  2./
      DATA (u(i,1176),i=1,7)/11., 6., 9., 9., 2.78E-02,1.34771E+06,  2./
      DATA (u(i,1177),i=1,7)/11., 6., 9., 9., 2.30E-02,1.26279E+06,  2./
      DATA (u(i,1178),i=1,7)/11., 6., 9.,15., 2.30E-02,1.30242E+06,  2./
      DATA (u(i,1179),i=1,7)/11., 6., 9., 3., 2.24E-02,1.39938E+06,  2./
      DATA (u(i,1180),i=1,7)/11., 6., 9., 9., 1.82E-02,1.20337E+06,  2./
      DATA (u(i,1181),i=1,7)/11., 6., 9., 3., 1.64E-02,1.19746E+06,  2./
      DATA (u(i,1182),i=1,7)/11., 6., 9., 9., 1.60E-02,1.31596E+06,  2./
      DATA (u(i,1183),i=1,7)/11., 6., 9., 9., 1.57E-02,1.33476E+06,  2./
      DATA (u(i,1184),i=1,7)/11., 6., 9., 3., 1.50E-02,1.37836E+06,  2./
      DATA (u(i,1185),i=1,7)/11., 6., 9., 3., 1.35E-02,1.41123E+06,  2./
      DATA (u(i,1186),i=1,7)/11., 6., 9., 9., 1.30E-02,1.29735E+06,  2./
      DATA (u(i,1187),i=1,7)/11., 6., 9., 3., 1.19E-02,1.35888E+06,  2./
      DATA (u(i,1188),i=1,7)/11., 6., 9.,15., 9.43E-03,1.33761E+06,  2./
      DATA (u(i,1189),i=1,7)/11., 6., 9., 3., 7.31E-03,1.43205E+06,  2./
      DATA (u(i,1190),i=1,7)/11., 6., 9., 9., 5.76E-03,1.34499E+06,  2./
      DATA (u(i,1191),i=1,7)/11., 6., 9., 3., 4.77E-03,1.44613E+06,  2./
      DATA (u(i,1192),i=1,7)/11., 6., 9.,15., 3.70E-03,1.34156E+06,  2./
      DATA (u(i,1193),i=1,7)/11., 6., 9., 9., 3.45E-03,1.34372E+06,  2./
      DATA (u(i,1194),i=1,7)/11., 6., 9., 3., 2.98E-03,1.45560E+06,  2./
      DATA (u(i,1195),i=1,7)/11., 6., 9., 9., 2.46E-04,1.32031E+06,  2./
      DATA (u(i,1196),i=1,7)/11., 6., 9., 9., 1.03E-05,1.28816E+06,  2./
      DATA (u(i,1197),i=1,7)/11., 6., 9.,15., 7.65E-06,1.24750E+06,  2./
      DATA (u(i,1198),i=1,7)/11., 6., 9.,15., 5.68E-06,1.31320E+06,  2./
      DATA (u(i,1199),i=1,7)/11., 7., 6.,10., 3.54E+00,1.05675E+06,  2./
      DATA (u(i,1200),i=1,7)/11., 7., 6., 6., 1.35E+00,2.83559E+05,  3./
      DATA (u(i,1201),i=1,7)/11., 7., 6.,10., 1.13E+00,1.15075E+06,  2./
      DATA (u(i,1202),i=1,7)/11., 7., 6.,10., 7.32E-01,1.33120E+06,  2./
      DATA (u(i,1203),i=1,7)/11., 7., 6., 6., 6.76E-01,1.12170E+06,  2./
      DATA (u(i,1204),i=1,7)/11., 7., 6.,10., 4.92E-01,2.03079E+05,  3./
      DATA (u(i,1205),i=1,7)/11., 7., 6.,10., 2.79E-01,1.45666E+06,  2./
      DATA (u(i,1206),i=1,7)/11., 7., 6.,10., 2.75E-01,1.44697E+06,  2./
      DATA (u(i,1207),i=1,7)/11., 7., 6., 2., 2.71E-01,2.63797E+05,  3./
      DATA (u(i,1208),i=1,7)/11., 7., 6., 2., 2.10E-01,1.16863E+06,  2./
      DATA (u(i,1209),i=1,7)/11., 7., 6., 6., 1.92E-01,1.43699E+06,  2./
      DATA (u(i,1210),i=1,7)/11., 7., 6., 6., 1.91E-01,1.25016E+06,  2./
      DATA (u(i,1211),i=1,7)/11., 7., 6., 2., 1.62E-01,9.48317E+05,  2./
      DATA (u(i,1212),i=1,7)/11., 7., 6.,10., 1.51E-01,1.52439E+06,  2./
      DATA (u(i,1213),i=1,7)/11., 7., 6.,10., 1.18E-01,1.57679E+06,  2./
      DATA (u(i,1214),i=1,7)/11., 7., 6.,10., 1.12E-01,1.24844E+06,  2./
      DATA (u(i,1215),i=1,7)/11., 7., 6., 6., 1.04E-01,1.57183E+06,  2./
      DATA (u(i,1216),i=1,7)/11., 7., 6.,10., 8.96E-02,1.40964E+06,  2./
      DATA (u(i,1217),i=1,7)/11., 7., 6.,10., 8.47E-02,1.56495E+06,  2./
      DATA (u(i,1218),i=1,7)/11., 7., 6.,10., 7.72E-02,1.55594E+06,  2./
      DATA (u(i,1219),i=1,7)/11., 7., 6., 2., 7.63E-02,1.25502E+06,  2./
      DATA (u(i,1220),i=1,7)/11., 7., 6.,10., 5.30E-02,1.59134E+06,  2./
      DATA (u(i,1221),i=1,7)/11., 7., 6., 6., 5.05E-02,1.69005E+06,  2./
      DATA (u(i,1222),i=1,7)/11., 7., 6.,10., 4.63E-02,1.42633E+06,  2./
      DATA (u(i,1223),i=1,7)/11., 7., 6., 6., 4.31E-02,1.64555E+06,  2./
      DATA (u(i,1224),i=1,7)/11., 7., 6., 2., 4.09E-02,1.45455E+06,  2./
      DATA (u(i,1225),i=1,7)/11., 7., 6.,10., 3.77E-02,1.60927E+06,  2./
      DATA (u(i,1226),i=1,7)/11., 7., 6., 6., 3.38E-02,1.55739E+06,  2./
      DATA (u(i,1227),i=1,7)/11., 7., 6.,10., 2.71E-02,1.62206E+06,  2./
      DATA (u(i,1228),i=1,7)/11., 7., 6., 2., 2.56E-02,1.44697E+06,  2./
      DATA (u(i,1229),i=1,7)/11., 7., 6., 6., 2.29E-02,1.38122E+06,  2./
      DATA (u(i,1230),i=1,7)/11., 7., 6., 2., 1.88E-02,1.55521E+06,  2./
      DATA (u(i,1231),i=1,7)/11., 7., 6., 6., 1.81E-02,1.71468E+06,  2./
      DATA (u(i,1232),i=1,7)/11., 7., 6.,10., 1.79E-02,1.50376E+06,  2./
      DATA (u(i,1233),i=1,7)/11., 7., 6., 6., 1.66E-02,1.43947E+06,  2./
      DATA (u(i,1234),i=1,7)/11., 7., 6.,10., 1.52E-02,1.32732E+06,  2./
      DATA (u(i,1235),i=1,7)/11., 7., 6., 2., 1.43E-02,1.58078E+06,  2./
      DATA (u(i,1236),i=1,7)/11., 7., 6., 6., 1.19E-02,1.73340E+06,  2./
      DATA (u(i,1237),i=1,7)/11., 7., 6., 2., 1.07E-02,1.56274E+06,  2./
      DATA (u(i,1238),i=1,7)/11., 7., 6., 2., 9.00E-03,1.51263E+06,  2./
      DATA (u(i,1239),i=1,7)/11., 7., 6., 6., 8.29E-03,1.74642E+06,  2./
      DATA (u(i,1240),i=1,7)/11., 7., 6., 6., 7.38E-03,1.68691E+06,  2./
      DATA (u(i,1241),i=1,7)/11., 7., 6., 6., 7.10E-03,1.31216E+06,  2./
      DATA (u(i,1242),i=1,7)/11., 7., 6., 2., 7.02E-03,1.29634E+06,  2./
      DATA (u(i,1243),i=1,7)/11., 7., 6., 2., 6.51E-03,1.43616E+06,  2./
      DATA (u(i,1244),i=1,7)/11., 7., 6.,10., 5.45E-03,1.47080E+06,  2./
      DATA (u(i,1245),i=1,7)/11., 7., 6.,10., 3.58E-03,1.58755E+06,  2./
      DATA (u(i,1246),i=1,7)/11., 7., 6., 2., 3.32E-03,1.58730E+06,  2./
      DATA (u(i,1247),i=1,7)/11., 7., 6., 6., 2.11E-03,1.65755E+06,  2./
      DATA (u(i,1248),i=1,7)/11., 7., 6., 6., 1.70E-03,1.62522E+06,  2./
      DATA (u(i,1249),i=1,7)/11., 7., 6., 2., 1.40E-03,1.60617E+06,  2./
      DATA (u(i,1250),i=1,7)/11., 7., 6., 2., 9.86E-04,1.61970E+06,  2./
      DATA (u(i,1251),i=1,7)/11., 7., 6.,10., 4.48E-04,1.58831E+06,  2./
      DATA (u(i,1252),i=1,7)/11., 7., 6., 2., 4.99E-05,1.40964E+06,  2./
      DATA (u(i,1253),i=1,7)/11., 7., 6., 6., 3.54E-05,1.69952E+06,  2./
      DATA (u(i,1254),i=1,7)/11., 8., 1., 3., 5.16E-01,1.29032E+06,  2./
      DATA (u(i,1255),i=1,7)/11., 8., 1., 3., 3.49E-01,2.43920E+05,  3./
      DATA (u(i,1256),i=1,7)/11., 8., 1., 3., 1.36E-01,1.66889E+06,  2./
      DATA (u(i,1257),i=1,7)/11., 8., 1., 3., 5.89E-02,1.83318E+06,  2./
      DATA (u(i,1258),i=1,7)/11., 8., 1., 3., 3.49E-02,1.50875E+06,  2./
      DATA (u(i,1259),i=1,7)/11., 8., 1., 3., 3.15E-02,1.92530E+06,  2./
      DATA (u(i,1260),i=1,7)/11., 8., 1., 3., 1.73E-02,1.98059E+06,  2./
      DATA (u(i,1261),i=1,7)/11., 8., 1., 3., 1.10E-02,2.01410E+06,  2./
      DATA (u(i,1262),i=1,7)/11., 8., 1., 3., 9.77E-03,1.41764E+06,  2./
      DATA (u(i,1263),i=1,7)/11., 8., 1., 3., 8.62E-03,1.84162E+06,  2./
      DATA (u(i,1264),i=1,7)/11., 8., 1., 3., 8.24E-03,2.03749E+06,  2./
      DATA (u(i,1265),i=1,7)/11., 8., 1., 3., 6.17E-03,2.05423E+06,  2./
      DATA (u(i,1266),i=1,7)/11., 8., 1., 3., 3.51E-03,1.97122E+06,  2./
      DATA (u(i,1267),i=1,7)/11., 8., 1., 3., 3.26E-03,1.99203E+06,  2./
      DATA (u(i,1268),i=1,7)/11., 8., 1., 3., 2.59E-03,1.79727E+06,  2./
      DATA (u(i,1269),i=1,7)/11., 9., 2., 6., 6.28E-01,1.41163E+06, 16./
      DATA (u(i,1270),i=1,7)/11., 9., 2., 6., 2.71E-01,1.43349E+05, 14./
      DATA (u(i,1271),i=1,7)/11., 9., 2., 6., 1.67E-01,1.85185E+06, 18./
      DATA (u(i,1272),i=1,7)/11., 9., 2., 6., 7.06E-02,2.05465E+06, 18./
      DATA (u(i,1273),i=1,7)/11., 9., 2., 6., 3.71E-02,2.16450E+06, 18./
      DATA (u(i,1274),i=1,7)/11., 9., 2., 6., 2.20E-02,2.23065E+06, 18./
      DATA (u(i,1275),i=1,7)/11., 9., 2., 6., 1.42E-02,2.27324E+06, 18./
      DATA (u(i,1276),i=1,7)/11., 9., 2., 6., 9.75E-03,2.30256E+06, 18./
      DATA (u(i,1277),i=1,7)/11., 9., 2., 6., 6.98E-03,2.32396E+06, 18./
      DATA (u(i,1278),i=1,7)/11.,10., 1., 3.,-6.79E+06,8.93534E+06, 24./
      DATA (u(i,1279),i=1,7)/11.,10., 1., 3., 7.76E-04,9.02287E+06, 25./
      DATA (u(i,1280),i=1,7)/11.,10., 1., 3., 7.33E-01,9.06618E+06, 11./
      DATA (u(i,1281),i=1,7)/11.,10., 1., 3., 1.50E-01,1.05820E+07, 12./
      DATA (u(i,1282),i=1,7)/11.,10., 1., 3., 5.62E-02,1.11111E+07, 13./
      DATA (u(i,1283),i=1,7)/11.,10., 1., 3., 2.72E-02,1.13507E+07, 13./
      DATA (u(i,1284),i=1,7)/11.,10., 1., 3., 1.53E-02,1.14943E+07, 13./
      DATA (u(i,1285),i=1,7)/11.,10., 1., 3., 9.49E-03,1.15741E+07, 13./
      DATA (u(i,1286),i=1,7)/11.,10., 1., 3., 6.29E-03,1.16279E+07, 13./
      DATA (u(i,1287),i=1,7)/11.,10., 1., 3., 4.39E-03,1.16550E+07, 13./
      DATA (u(i,1288),i=1,7)/11.,10., 1., 3., 3.18E-03,1.16822E+07, 13./
      DATA (u(i,1289),i=1,7)/11.,11., 2., 2.,-1.20E+05,9.97171E+06, 23./
      DATA (u(i,1290),i=1,7)/11.,11., 2., 6., 8.32E-01,9.95025E+06,  4./
      DATA (u(i,1291),i=1,7)/11.,11., 2., 6., 1.58E-01,1.17925E+07,  5./
      DATA (u(i,1292),i=1,7)/11.,11., 2., 6., 5.80E-02,1.24378E+07,  6./
      DATA (u(i,1293),i=1,7)/11.,11., 2., 6., 2.79E-02,1.27389E+07,  7./
      DATA (u(i,1294),i=1,7)/11.,11., 2., 6., 1.56E-02,1.29032E+07,  8./
      DATA (u(i,1295),i=1,7)/11.,11., 2., 6., 9.63E-03,1.30039E+07,  9./
      DATA (u(i,1296),i=1,7)/11.,11., 2., 6., 6.37E-03,1.30719E+07,  9./
      DATA (u(i,1297),i=1,7)/11.,11., 2., 6., 4.43E-03,1.31062E+07,  9./
      DATA (u(i,1298),i=1,7)/11.,11., 2., 6., 3.21E-03,1.31406E+07,  9./
      DATA (u(i,1299),i=1,7)/12., 1., 1., 3., 2.85E-02,5.50264E+04,  1./
      DATA (u(i,1300),i=1,7)/12., 1., 1., 3., 1.03E-02,5.75013E+04,  1./
      DATA (u(i,1301),i=1,7)/12., 1., 1., 3., 4.88E-03,5.88564E+04,  1./
      DATA (u(i,1302),i=1,7)/12., 1., 1., 3., 2.72E-03,5.96751E+04,  1./
      DATA (u(i,1303),i=1,7)/12., 1., 1., 3., 1.68E-03,6.02069E+04,  1./
      DATA (u(i,1304),i=1,7)/12., 1., 1., 3., 1.12E-03,6.05712E+04,  1./
      DATA (u(i,1305),i=1,7)/12., 1., 1., 3., 7.81E-04,6.08317E+04,  1./
      DATA (u(i,1306),i=1,7)/12., 2., 2., 6., 2.77E-03,9.61465E+04,  2./
      DATA (u(i,1307),i=1,7)/12., 2., 2., 6., 1.97E-03,1.04242E+05,  2./
      DATA (u(i,1308),i=1,7)/12., 2., 2., 6., 1.31E-03,1.08790E+05,  2./
      DATA (u(i,1309),i=1,7)/12., 2., 2., 6., 1.10E-03,7.95140E+04,  2./
      DATA (u(i,1310),i=1,7)/12., 2., 2., 6., 8.88E-04,1.11600E+05,  2./
      DATA (u(i,1311),i=1,7)/12., 2., 2., 6., 6.23E-04,1.13456E+05,  2./
      DATA (u(i,1312),i=1,7)/12., 2., 2., 6., 4.52E-04,1.14747E+05,  2./
      DATA (u(i,1313),i=1,7)/12., 3., 1., 3., 4.82E-01,5.44840E+05, 19./
      DATA (u(i,1314),i=1,7)/12., 3., 1., 3., 2.45E-01,4.42713E+05, 21./
      DATA (u(i,1315),i=1,7)/12., 3., 1., 3., 2.12E-01,5.93331E+05, 20./
      DATA (u(i,1316),i=1,7)/12., 3., 1., 3., 1.09E-01,6.15726E+05,  2./
      DATA (u(i,1317),i=1,7)/12., 3., 1., 3., 6.32E-02,6.27825E+05,  2./
      DATA (u(i,1318),i=1,7)/12., 3., 1., 3., 3.98E-02,6.35163E+05,  2./
      DATA (u(i,1319),i=1,7)/12., 3., 1., 3., 3.56E-02,5.57165E+05, 22./
      DATA (u(i,1320),i=1,7)/12., 3., 1., 3., 2.66E-02,6.39877E+05,  2./
      DATA (u(i,1321),i=1,7)/12., 3., 1., 3., 1.87E-02,6.43128E+05,  2./
      DATA (u(i,1322),i=1,7)/12., 3., 1., 3., 1.36E-02,6.45453E+05,  2./
      DATA (u(i,1323),i=1,7)/12., 3., 1., 3., 1.32E-02,5.98767E+05,  2./
      DATA (u(i,1324),i=1,7)/12., 3., 1., 3., 6.44E-03,6.18544E+05,  2./
      DATA (u(i,1325),i=1,7)/12., 3., 1., 3., 3.64E-03,6.29525E+05,  2./
      DATA (u(i,1326),i=1,7)/12., 3., 1., 3., 2.26E-03,6.36213E+05,  2./
      DATA (u(i,1327),i=1,7)/12., 3., 1., 3., 1.51E-03,6.40615E+05,  2./
      DATA (u(i,1328),i=1,7)/12., 3., 1., 3., 1.05E-03,6.43666E+05,  2./
      DATA (u(i,1329),i=1,7)/12., 4., 6.,10., 1.97E+00,6.79394E+05,  2./
      DATA (u(i,1330),i=1,7)/12., 4., 6.,10., 9.89E-01,7.67931E+05,  2./
      DATA (u(i,1331),i=1,7)/12., 4., 6., 6., 9.88E-01,7.10682E+05,  2./
      DATA (u(i,1332),i=1,7)/12., 4., 6.,10., 8.54E-01,7.12555E+05,  2./
      DATA (u(i,1333),i=1,7)/12., 4., 6., 6., 7.26E-01,5.55155E+05,  2./
      DATA (u(i,1334),i=1,7)/12., 4., 6.,10., 5.43E-01,8.08538E+05,  2./
      DATA (u(i,1335),i=1,7)/12., 4., 6., 2., 5.20E-01,3.09876E+05,  3./
      DATA (u(i,1336),i=1,7)/12., 4., 6., 6., 5.08E-01,6.80828E+05,  2./
      DATA (u(i,1337),i=1,7)/12., 4., 6., 2., 4.74E-01,7.10985E+05,  2./
      DATA (u(i,1338),i=1,7)/12., 4., 6.,10., 4.29E-01,5.83669E+05,  2./
      DATA (u(i,1339),i=1,7)/12., 4., 6., 6., 3.05E-01,7.67872E+05,  2./
      DATA (u(i,1340),i=1,7)/12., 4., 6.,10., 2.80E-01,8.43668E+05,  2./
      DATA (u(i,1341),i=1,7)/12., 4., 6.,10., 2.70E-01,7.52162E+05,  2./
      DATA (u(i,1342),i=1,7)/12., 4., 6., 6., 2.43E-01,8.00384E+05,  2./
      DATA (u(i,1343),i=1,7)/12., 4., 6., 6., 2.39E-01,8.08604E+05,  2./
      DATA (u(i,1344),i=1,7)/12., 4., 6.,10., 2.29E-01,8.30220E+05,  2./
      DATA (u(i,1345),i=1,7)/12., 4., 6.,10., 1.44E-01,8.01025E+05,  2./
      DATA (u(i,1346),i=1,7)/12., 4., 6., 6., 1.43E-01,8.43740E+05,  2./
      DATA (u(i,1347),i=1,7)/12., 4., 6., 6., 1.37E-01,7.22439E+05,  2./
      DATA (u(i,1348),i=1,7)/12., 4., 6.,10., 1.34E-01,8.41255E+05,  2./
      DATA (u(i,1349),i=1,7)/12., 4., 6., 2., 1.32E-01,8.01860E+05,  2./
      DATA (u(i,1350),i=1,7)/12., 4., 6.,10., 1.21E-01,8.52006E+05,  2./
      DATA (u(i,1351),i=1,7)/12., 4., 6., 2., 9.42E-02,8.42318E+05,  2./
      DATA (u(i,1352),i=1,7)/12., 4., 6., 6., 7.95E-02,8.30151E+05,  2./
      DATA (u(i,1353),i=1,7)/12., 4., 6., 2., 7.92E-02,6.25469E+05,  2./
      DATA (u(i,1354),i=1,7)/12., 4., 6.,10., 7.59E-02,8.57780E+05,  2./
      DATA (u(i,1355),i=1,7)/12., 4., 6., 6., 7.07E-02,8.41893E+05,  2./
      DATA (u(i,1356),i=1,7)/12., 4., 6., 2., 6.74E-02,7.96052E+05,  2./
      DATA (u(i,1357),i=1,7)/12., 4., 6., 6., 5.56E-02,7.86720E+05,  2./
      DATA (u(i,1358),i=1,7)/12., 4., 6.,10., 4.66E-02,8.61995E+05,  2./
      DATA (u(i,1359),i=1,7)/12., 4., 6., 2., 4.45E-02,8.64828E+05,  2./
      DATA (u(i,1360),i=1,7)/12., 4., 6., 6., 4.20E-02,8.51934E+05,  2./
      DATA (u(i,1361),i=1,7)/12., 4., 6., 2., 3.39E-02,8.78040E+05,  2./
      DATA (u(i,1362),i=1,7)/12., 4., 6.,10., 2.93E-02,8.20816E+05,  2./
      DATA (u(i,1363),i=1,7)/12., 4., 6., 6., 2.66E-02,8.18264E+05,  2./
      DATA (u(i,1364),i=1,7)/12., 4., 6., 2., 2.36E-02,8.86682E+05,  2./
      DATA (u(i,1365),i=1,7)/12., 4., 6., 6., 2.36E-02,8.57780E+05,  2./
      DATA (u(i,1366),i=1,7)/12., 4., 6., 2., 1.75E-02,8.92618E+05,  2./
      DATA (u(i,1367),i=1,7)/12., 4., 6., 6., 1.63E-02,8.36120E+05,  2./
      DATA (u(i,1368),i=1,7)/12., 4., 6.,10., 1.54E-02,7.55801E+05,  2./
      DATA (u(i,1369),i=1,7)/12., 4., 6., 2., 1.25E-02,8.96861E+05,  2./
      DATA (u(i,1370),i=1,7)/12., 4., 6., 2., 1.09E-02,8.62069E+05,  2./
      DATA (u(i,1371),i=1,7)/12., 4., 6., 6., 1.08E-02,8.61920E+05,  2./
      DATA (u(i,1372),i=1,7)/12., 4., 6.,10., 9.97E-03,8.52806E+05,  2./
      DATA (u(i,1373),i=1,7)/12., 4., 6., 6., 9.33E-03,8.47170E+05,  2./
      DATA (u(i,1374),i=1,7)/12., 4., 6., 6., 6.65E-03,8.54482E+05,  2./
      DATA (u(i,1375),i=1,7)/12., 4., 6.,10., 5.32E-03,8.42957E+05,  2./
      DATA (u(i,1376),i=1,7)/12., 4., 6., 6., 4.89E-03,8.59624E+05,  2./
      DATA (u(i,1377),i=1,7)/12., 4., 6.,10., 4.76E-04,8.44523E+05,  2./
      DATA (u(i,1378),i=1,7)/12., 4., 6., 2., 1.22E-04,8.94214E+05,  2./
      DATA (u(i,1379),i=1,7)/12., 5., 9., 9., 2.58E+00,8.76808E+05,  2./
      DATA (u(i,1380),i=1,7)/12., 5., 9.,15., 2.33E+00,8.22233E+05,  2./
      DATA (u(i,1381),i=1,7)/12., 5., 9.,15., 2.19E+00,8.71004E+05,  2./
      DATA (u(i,1382),i=1,7)/12., 5., 9.,15., 1.72E+00,9.02201E+05,  2./
      DATA (u(i,1383),i=1,7)/12., 5., 9., 9., 1.42E+00,2.83110E+05,147./
      DATA (u(i,1384),i=1,7)/12., 5., 9.,15., 1.40E+00,9.60984E+05,  2./
      DATA (u(i,1385),i=1,7)/12., 5., 9.,15., 1.40E+00,9.60984E+05,  2./
      DATA (u(i,1386),i=1,7)/12., 5., 9., 3., 8.73E-01,8.79353E+05,  2./
      DATA (u(i,1387),i=1,7)/12., 5., 9., 9., 8.31E-01,1.00746E+06,  2./
      DATA (u(i,1388),i=1,7)/12., 5., 9.,15., 7.02E-01,9.97805E+05,  2./
      DATA (u(i,1389),i=1,7)/12., 5., 9.,15., 6.77E-01,1.04243E+06,  2./
      DATA (u(i,1390),i=1,7)/12., 5., 9.,15., 6.57E-01,7.30674E+05,  2./
      DATA (u(i,1391),i=1,7)/12., 5., 9.,15., 4.97E-01,1.02522E+06,  2./
      DATA (u(i,1392),i=1,7)/12., 5., 9., 3., 4.58E-01,6.87569E+05,  2./
      DATA (u(i,1393),i=1,7)/12., 5., 9., 9., 4.56E-01,8.99119E+05,  2./
      DATA (u(i,1394),i=1,7)/12., 5., 9., 9., 3.72E-01,7.59705E+05,  2./
      DATA (u(i,1395),i=1,7)/12., 5., 9., 9., 3.59E-01,1.01657E+06,  2./
      DATA (u(i,1396),i=1,7)/12., 5., 9.,15., 3.51E-01,1.01235E+06,  2./
      DATA (u(i,1397),i=1,7)/12., 5., 9., 9., 3.47E-01,1.07910E+06,  2./
      DATA (u(i,1398),i=1,7)/12., 5., 9.,15., 3.19E-01,1.08026E+06,  2./
      DATA (u(i,1399),i=1,7)/12., 5., 9.,15., 3.03E-01,1.05932E+06,  2./
      DATA (u(i,1400),i=1,7)/12., 5., 9., 3., 2.93E-01,1.01657E+06,  2./
      DATA (u(i,1401),i=1,7)/12., 5., 9.,15., 2.31E-01,1.10730E+06,  2./
      DATA (u(i,1402),i=1,7)/12., 5., 9., 9., 2.19E-01,1.04112E+06,  2./
      DATA (u(i,1403),i=1,7)/12., 5., 9., 9., 1.84E-01,1.11421E+06,  2./
      DATA (u(i,1404),i=1,7)/12., 5., 9., 3., 1.59E-01,9.98502E+05,  2./
      DATA (u(i,1405),i=1,7)/12., 5., 9., 3., 1.39E-01,1.08015E+06,  2./
      DATA (u(i,1406),i=1,7)/12., 5., 9., 9., 1.26E-01,1.16117E+06,  2./
      DATA (u(i,1407),i=1,7)/12., 5., 9.,15., 1.19E-01,1.09325E+06,  2./
      DATA (u(i,1408),i=1,7)/12., 5., 9., 9., 1.15E-01,1.13507E+06,  2./
      DATA (u(i,1409),i=1,7)/12., 5., 9., 9., 1.13E-01,1.10668E+06,  2./
      DATA (u(i,1410),i=1,7)/12., 5., 9.,15., 1.10E-01,1.10902E+06,  2./
      DATA (u(i,1411),i=1,7)/12., 5., 9., 3., 9.71E-02,9.10830E+05,  2./
      DATA (u(i,1412),i=1,7)/12., 5., 9.,15., 8.04E-02,1.07770E+06,  2./
      DATA (u(i,1413),i=1,7)/12., 5., 9., 9., 7.74E-02,1.14850E+06,  2./
      DATA (u(i,1414),i=1,7)/12., 5., 9., 9., 6.64E-02,1.15768E+06,  2./
      DATA (u(i,1415),i=1,7)/12., 5., 9., 9., 5.59E-02,1.14181E+06,  2./
      DATA (u(i,1416),i=1,7)/12., 5., 9.,15., 4.96E-02,1.10241E+06,  2./
      DATA (u(i,1417),i=1,7)/12., 5., 9., 9., 4.87E-02,9.90589E+05,  2./
      DATA (u(i,1418),i=1,7)/12., 5., 9., 3., 4.16E-02,1.00392E+06,  2./
      DATA (u(i,1419),i=1,7)/12., 5., 9.,15., 3.53E-02,1.10047E+06,  2./
      DATA (u(i,1420),i=1,7)/12., 5., 9.,15., 3.49E-02,1.05363E+06,  2./
      DATA (u(i,1421),i=1,7)/12., 5., 9., 9., 2.00E-02,1.16428E+06,  2./
      DATA (u(i,1422),i=1,7)/12., 5., 9., 9., 1.95E-02,1.14548E+06,  2./
      DATA (u(i,1423),i=1,7)/12., 5., 9., 9., 1.62E-02,1.12841E+06,  2./
      DATA (u(i,1424),i=1,7)/12., 5., 9., 9., 1.56E-02,1.09242E+06,  2./
      DATA (u(i,1425),i=1,7)/12., 5., 9., 9., 1.51E-02,1.16320E+06,  2./
      DATA (u(i,1426),i=1,7)/12., 5., 9., 3., 1.44E-02,1.04559E+06,  2./
      DATA (u(i,1427),i=1,7)/12., 5., 9.,15., 1.43E-02,1.08944E+06,  2./
      DATA (u(i,1428),i=1,7)/12., 5., 9., 9., 1.27E-02,1.15500E+06,  2./
      DATA (u(i,1429),i=1,7)/12., 5., 9., 3., 1.11E-02,1.07147E+06,  2./
      DATA (u(i,1430),i=1,7)/12., 5., 9., 9., 9.43E-03,1.08225E+06,  2./
      DATA (u(i,1431),i=1,7)/12., 5., 9., 3., 5.29E-03,1.08778E+06,  2./
      DATA (u(i,1432),i=1,7)/12., 5., 9., 3., 4.24E-03,1.09866E+06,  2./
      DATA (u(i,1433),i=1,7)/12., 5., 9., 3., 3.29E-03,1.10619E+06,  2./
      DATA (u(i,1434),i=1,7)/12., 5., 9.,15., 1.13E-04,1.08237E+06,  2./
      DATA (u(i,1435),i=1,7)/12., 6., 4.,12., 5.06E+00,1.05108E+06,  2./
      DATA (u(i,1436),i=1,7)/12., 6., 4.,12., 8.87E-01,1.25345E+06,  2./
      DATA (u(i,1437),i=1,7)/12., 6., 4.,12., 8.03E-01,2.46081E+05,155./
      DATA (u(i,1438),i=1,7)/12., 6., 4.,12., 7.11E-01,1.34698E+06,  2./
      DATA (u(i,1439),i=1,7)/12., 6., 4.,12., 6.75E-01,1.10241E+06,  2./
      DATA (u(i,1440),i=1,7)/12., 6., 4.,12., 5.38E-01,1.25549E+06,  2./
      DATA (u(i,1441),i=1,7)/12., 6., 4.,12., 5.02E-01,8.99038E+05,  2./
      DATA (u(i,1442),i=1,7)/12., 6., 4.,12., 3.09E-01,1.39723E+06,  2./
      DATA (u(i,1443),i=1,7)/12., 6., 4.,12., 2.15E-01,1.32767E+06,  2./
      DATA (u(i,1444),i=1,7)/12., 6., 4.,12., 1.88E-01,1.42735E+06,  2./
      DATA (u(i,1445),i=1,7)/12., 6., 4.,12., 1.30E-01,1.44676E+06,  2./
      DATA (u(i,1446),i=1,7)/12., 6., 4.,12., 1.05E-01,1.31909E+06,  2./
      DATA (u(i,1447),i=1,7)/12., 6., 4.,12., 9.78E-02,1.46007E+06,  2./
      DATA (u(i,1448),i=1,7)/12., 6., 4.,12., 8.98E-02,1.19460E+06,  2./
      DATA (u(i,1449),i=1,7)/12., 6., 4.,12., 7.56E-02,1.44802E+06,  2./
      DATA (u(i,1450),i=1,7)/12., 6., 4.,12., 5.80E-02,1.46951E+06,  2./
      DATA (u(i,1451),i=1,7)/12., 6., 4.,12., 3.72E-02,1.34807E+06,  2./
      DATA (u(i,1452),i=1,7)/12., 6., 4.,12., 3.43E-02,1.22205E+06,  2./
      DATA (u(i,1453),i=1,7)/12., 6., 4.,12., 1.38E-02,1.38217E+06,  2./
      DATA (u(i,1454),i=1,7)/12., 6., 4.,12., 7.69E-03,1.41784E+06,  2./
      DATA (u(i,1455),i=1,7)/12., 6., 4.,12., 5.87E-03,1.46671E+06,  2./
      DATA (u(i,1456),i=1,7)/12., 6., 4.,12., 5.28E-03,1.44051E+06,  2./
      DATA (u(i,1457),i=1,7)/12., 6., 4.,12., 4.79E-03,1.46028E+06,  2./
      DATA (u(i,1458),i=1,7)/12., 6., 4.,12., 4.07E-03,1.46284E+06,  2./
      DATA (u(i,1459),i=1,7)/12., 6., 4.,12., 6.92E-04,1.45560E+06,  2./
      DATA (u(i,1460),i=1,7)/12., 7., 9.,15., 6.99E+00,1.18963E+06,  2./
      DATA (u(i,1461),i=1,7)/12., 7., 9., 9., 2.33E+00,1.19403E+06,  2./
      DATA (u(i,1462),i=1,7)/12., 7., 9.,15., 1.57E+00,1.46628E+06,  2./
      DATA (u(i,1463),i=1,7)/12., 7., 9.,15., 1.19E+00,1.25786E+06,  2./
      DATA (u(i,1464),i=1,7)/12., 7., 9., 3., 1.01E+00,3.61102E+05,134./
      DATA (u(i,1465),i=1,7)/12., 7., 9., 9., 8.18E-01,2.71562E+05,152./
      DATA (u(i,1466),i=1,7)/12., 7., 9.,15., 7.07E-01,2.28514E+05,156./
      DATA (u(i,1467),i=1,7)/12., 7., 9., 9., 6.68E-01,1.26936E+06,  2./
      DATA (u(i,1468),i=1,7)/12., 7., 9.,15., 6.65E-01,1.59210E+06,  2./
      DATA (u(i,1469),i=1,7)/12., 7., 9., 9., 6.34E-01,1.04723E+06,  2./
      DATA (u(i,1470),i=1,7)/12., 7., 9., 9., 5.32E-01,1.46714E+06,  2./
      DATA (u(i,1471),i=1,7)/12., 7., 9.,15., 4.38E-01,1.57085E+06,  2./
      DATA (u(i,1472),i=1,7)/12., 7., 9.,15., 3.83E-01,1.42898E+06,  2./
      DATA (u(i,1473),i=1,7)/12., 7., 9.,15., 3.56E-01,1.66030E+06,  2./
      DATA (u(i,1474),i=1,7)/12., 7., 9., 3., 3.02E-01,1.22714E+06,  2./
      DATA (u(i,1475),i=1,7)/12., 7., 9., 9., 2.85E-01,1.40687E+06,  2./
      DATA (u(i,1476),i=1,7)/12., 7., 9.,15., 2.22E-01,1.70097E+06,  2./
      DATA (u(i,1477),i=1,7)/12., 7., 9., 9., 2.19E-01,1.57307E+06,  2./
      DATA (u(i,1478),i=1,7)/12., 7., 9., 9., 1.77E-01,1.59261E+06,  2./
      DATA (u(i,1479),i=1,7)/12., 7., 9.,15., 1.71E-01,1.70765E+06,  2./
      DATA (u(i,1480),i=1,7)/12., 7., 9., 9., 1.38E-01,1.43968E+06,  2./
      DATA (u(i,1481),i=1,7)/12., 7., 9., 9., 1.22E-01,1.66030E+06,  2./
      DATA (u(i,1482),i=1,7)/12., 7., 9.,15., 1.11E-01,1.72771E+06,  2./
      DATA (u(i,1483),i=1,7)/12., 7., 9.,15., 1.10E-01,1.75685E+06,  2./
      DATA (u(i,1484),i=1,7)/12., 7., 9.,15., 9.41E-02,1.74551E+06,  2./
      DATA (u(i,1485),i=1,7)/12., 7., 9., 9., 9.12E-02,1.70969E+06,  2./
      DATA (u(i,1486),i=1,7)/12., 7., 9., 3., 9.05E-02,1.44217E+06,  2./
      DATA (u(i,1487),i=1,7)/12., 7., 9., 3., 8.71E-02,1.56397E+06,  2./
      DATA (u(i,1488),i=1,7)/12., 7., 9.,15., 7.92E-02,1.35410E+06,  2./
      DATA (u(i,1489),i=1,7)/12., 7., 9., 9., 7.76E-02,1.70126E+06,  2./
      DATA (u(i,1490),i=1,7)/12., 7., 9., 9., 7.63E-02,1.59160E+06,  2./
      DATA (u(i,1491),i=1,7)/12., 7., 9., 9., 4.11E-02,1.72741E+06,  2./
      DATA (u(i,1492),i=1,7)/12., 7., 9.,15., 3.85E-02,1.65645E+06,  2./
      DATA (u(i,1493),i=1,7)/12., 7., 9., 9., 3.70E-02,1.72087E+06,  2./
      DATA (u(i,1494),i=1,7)/12., 7., 9.,15., 3.63E-02,1.72384E+06,  2./
      DATA (u(i,1495),i=1,7)/12., 7., 9., 3., 3.40E-02,1.70213E+06,  2./
      DATA (u(i,1496),i=1,7)/12., 7., 9., 9., 3.09E-02,1.74551E+06,  2./
      DATA (u(i,1497),i=1,7)/12., 7., 9., 9., 3.06E-02,1.75840E+06,  2./
      DATA (u(i,1498),i=1,7)/12., 7., 9.,15., 2.98E-02,1.72117E+06,  2./
      DATA (u(i,1499),i=1,7)/12., 7., 9.,15., 2.89E-02,1.75840E+06,  2./
      DATA (u(i,1500),i=1,7)/12., 7., 9., 9., 2.51E-02,1.64501E+06,  2./
      DATA (u(i,1501),i=1,7)/12., 7., 9., 3., 2.49E-02,1.76274E+06,  2./
      DATA (u(i,1502),i=1,7)/12., 7., 9., 3., 2.48E-02,1.77620E+06,  2./
      DATA (u(i,1503),i=1,7)/12., 7., 9., 9., 1.91E-02,1.75500E+06,  2./
      DATA (u(i,1504),i=1,7)/12., 7., 9., 9., 1.83E-02,1.66639E+06,  2./
      DATA (u(i,1505),i=1,7)/12., 7., 9., 3., 1.07E-02,1.81884E+06,  2./
      DATA (u(i,1506),i=1,7)/12., 7., 9., 9., 1.07E-02,1.42207E+06,  2./
      DATA (u(i,1507),i=1,7)/12., 7., 9., 3., 1.06E-02,1.67560E+06,  2./
      DATA (u(i,1508),i=1,7)/12., 7., 9., 9., 9.97E-03,1.69233E+06,  2./
      DATA (u(i,1509),i=1,7)/12., 7., 9.,15., 9.85E-03,1.61865E+06,  2./
      DATA (u(i,1510),i=1,7)/12., 7., 9., 9., 8.10E-03,1.74155E+06,  2./
      DATA (u(i,1511),i=1,7)/12., 7., 9., 3., 6.66E-03,1.84945E+06,  2./
      DATA (u(i,1512),i=1,7)/12., 7., 9., 9., 5.75E-03,1.56568E+06,  2./
      DATA (u(i,1513),i=1,7)/12., 7., 9.,15., 5.74E-03,1.52765E+06,  2./
      DATA (u(i,1514),i=1,7)/12., 7., 9., 3., 4.63E-03,1.86776E+06,  2./
      DATA (u(i,1515),i=1,7)/12., 7., 9., 9., 3.31E-03,1.72236E+06,  2./
      DATA (u(i,1516),i=1,7)/12., 7., 9., 3., 3.07E-03,1.88111E+06,  2./
      DATA (u(i,1517),i=1,7)/12., 7., 9., 9., 2.09E-03,1.73792E+06,  2./
      DATA (u(i,1518),i=1,7)/12., 7., 9.,15., 2.07E-03,1.67056E+06,  2./
      DATA (u(i,1519),i=1,7)/12., 7., 9., 9., 9.29E-04,1.36388E+06,  2./
      DATA (u(i,1520),i=1,7)/12., 7., 9., 9., 4.47E-04,1.67504E+06,  2./
      DATA (u(i,1521),i=1,7)/12., 7., 9., 9., 3.01E-04,1.69981E+06,  2./
      DATA (u(i,1522),i=1,7)/12., 7., 9., 3., 1.59E-04,1.83284E+06,  2./
      DATA (u(i,1523),i=1,7)/12., 7., 9., 3., 1.49E-04,1.49723E+06,  2./
      DATA (u(i,1524),i=1,7)/12., 7., 9.,15., 4.16E-06,1.59008E+06,  2./
      DATA (u(i,1525),i=1,7)/12., 7., 9.,15., 1.43E-08,1.70242E+06,  2./
      DATA (u(i,1526),i=1,7)/12., 8., 6.,10., 3.63E+00,1.33067E+06,  2./
      DATA (u(i,1527),i=1,7)/12., 8., 6.,10., 1.23E+00,1.43472E+06,  2./
      DATA (u(i,1528),i=1,7)/12., 8., 6., 6., 1.22E+00,3.17007E+05,140./
      DATA (u(i,1529),i=1,7)/12., 8., 6.,10., 7.46E-01,1.68776E+06,  2./
      DATA (u(i,1530),i=1,7)/12., 8., 6., 6., 7.21E-01,1.40154E+06,  2./
      DATA (u(i,1531),i=1,7)/12., 8., 6.,10., 4.50E-01,2.28128E+05,157./
      DATA (u(i,1532),i=1,7)/12., 8., 6.,10., 3.09E-01,1.81587E+06,  2./
      DATA (u(i,1533),i=1,7)/12., 8., 6.,10., 2.80E-01,1.85151E+06,  2./
      DATA (u(i,1534),i=1,7)/12., 8., 6., 2., 2.44E-01,2.95928E+05,  3./
      DATA (u(i,1535),i=1,7)/12., 8., 6., 2., 2.39E-01,1.45518E+06,  2./
      DATA (u(i,1536),i=1,7)/12., 8., 6., 6., 2.11E-01,1.54440E+06,  2./
      DATA (u(i,1537),i=1,7)/12., 8., 6., 6., 1.95E-01,1.80571E+06,  2./
      DATA (u(i,1538),i=1,7)/12., 8., 6., 2., 1.56E-01,1.20685E+06,  2./
      DATA (u(i,1539),i=1,7)/12., 8., 6.,10., 1.43E-01,1.98491E+06,  2./
      DATA (u(i,1540),i=1,7)/12., 8., 6.,10., 1.23E-01,1.93723E+06,  2./
      DATA (u(i,1541),i=1,7)/12., 8., 6.,10., 1.12E-01,1.54321E+06,  2./
      DATA (u(i,1542),i=1,7)/12., 8., 6.,10., 9.63E-02,1.93986E+06,  2./
      DATA (u(i,1543),i=1,7)/12., 8., 6., 6., 9.44E-02,1.97824E+06,  2./
      DATA (u(i,1544),i=1,7)/12., 8., 6.,10., 8.26E-02,1.99243E+06,  2./
      DATA (u(i,1545),i=1,7)/12., 8., 6.,10., 7.49E-02,1.72801E+06,  2./
      DATA (u(i,1546),i=1,7)/12., 8., 6., 2., 5.93E-02,1.55497E+06,  2./
      DATA (u(i,1547),i=1,7)/12., 8., 6.,10., 5.51E-02,2.02675E+06,  2./
      DATA (u(i,1548),i=1,7)/12., 8., 6., 6., 5.28E-02,1.93949E+06,  2./
      DATA (u(i,1549),i=1,7)/12., 8., 6., 2., 4.32E-02,1.82949E+06,  2./
      DATA (u(i,1550),i=1,7)/12., 8., 6., 6., 4.11E-02,2.07383E+06,  2./
      DATA (u(i,1551),i=1,7)/12., 8., 6.,10., 3.73E-02,2.05044E+06,  2./
      DATA (u(i,1552),i=1,7)/12., 8., 6.,10., 3.38E-02,1.74490E+06,  2./
      DATA (u(i,1553),i=1,7)/12., 8., 6.,10., 3.26E-02,1.83083E+06,  2./
      DATA (u(i,1554),i=1,7)/12., 8., 6., 6., 3.15E-02,2.12902E+06,  2./
      DATA (u(i,1555),i=1,7)/12., 8., 6.,10., 3.07E-02,2.06697E+06,  2./
      DATA (u(i,1556),i=1,7)/12., 8., 6.,10., 3.02E-02,2.06441E+06,  2./
      DATA (u(i,1557),i=1,7)/12., 8., 6., 6., 2.94E-02,1.75902E+06,  2./
      DATA (u(i,1558),i=1,7)/12., 8., 6., 2., 2.74E-02,1.82216E+06,  2./
      DATA (u(i,1559),i=1,7)/12., 8., 6., 2., 2.42E-02,1.98965E+06,  2./
      DATA (u(i,1560),i=1,7)/12., 8., 6., 6., 2.04E-02,2.20702E+06,  2./
      DATA (u(i,1561),i=1,7)/12., 8., 6., 6., 1.83E-02,2.16403E+06,  2./
      DATA (u(i,1562),i=1,7)/12., 8., 6., 6., 1.82E-02,1.69262E+06,  2./
      DATA (u(i,1563),i=1,7)/12., 8., 6., 2., 1.81E-02,1.64420E+06,  2./
      DATA (u(i,1564),i=1,7)/12., 8., 6., 6., 1.75E-02,1.61447E+06,  2./
      DATA (u(i,1565),i=1,7)/12., 8., 6., 6., 1.72E-02,2.09556E+06,  2./
      DATA (u(i,1566),i=1,7)/12., 8., 6., 2., 1.61E-02,1.94401E+06,  2./
      DATA (u(i,1567),i=1,7)/12., 8., 6., 6., 1.55E-02,2.11416E+06,  2./
      DATA (u(i,1568),i=1,7)/12., 8., 6., 2., 1.48E-02,1.92456E+06,  2./
      DATA (u(i,1569),i=1,7)/12., 8., 6., 6., 1.20E-02,2.18818E+06,  2./
      DATA (u(i,1570),i=1,7)/12., 8., 6., 2., 9.06E-03,1.76897E+06,  2./
      DATA (u(i,1571),i=1,7)/12., 8., 6., 6., 7.37E-03,2.05128E+06,  2./
      DATA (u(i,1572),i=1,7)/12., 8., 6.,10., 6.49E-03,1.84400E+06,  2./
      DATA (u(i,1573),i=1,7)/12., 8., 6.,10., 4.66E-03,1.63106E+06,  2./
      DATA (u(i,1574),i=1,7)/12., 8., 6., 2., 2.29E-03,2.02143E+06,  2./
      DATA (u(i,1575),i=1,7)/12., 8., 6.,10., 1.76E-03,2.04708E+06,  2./
      DATA (u(i,1576),i=1,7)/12., 8., 6., 6., 1.55E-03,2.01654E+06,  2./
      DATA (u(i,1577),i=1,7)/12., 8., 6., 2., 1.53E-03,2.04666E+06,  2./
      DATA (u(i,1578),i=1,7)/12., 8., 6., 6., 1.33E-03,2.20507E+06,  2./
      DATA (u(i,1579),i=1,7)/12., 8., 6.,10., 1.06E-03,1.99840E+06,  2./
      DATA (u(i,1580),i=1,7)/12., 8., 6., 2., 1.05E-03,2.06441E+06,  2./
      DATA (u(i,1581),i=1,7)/12., 8., 6., 2., 8.55E-04,1.72325E+06,  2./
      DATA (u(i,1582),i=1,7)/12., 8., 6., 6., 3.51E-04,2.19635E+06,  2./
      DATA (u(i,1583),i=1,7)/12., 8., 6.,10., 3.46E-04,1.97316E+06,  2./
      DATA (u(i,1584),i=1,7)/12., 8., 6., 2., 7.22E-06,1.98452E+06,  2./
      DATA (u(i,1585),i=1,7)/12., 9., 1., 3., 5.41E-01,1.58806E+06,  2./
      DATA (u(i,1586),i=1,7)/12., 9., 1., 3., 3.14E-01,2.71385E+05,153./
      DATA (u(i,1587),i=1,7)/12., 9., 1., 3., 1.43E-01,2.06228E+06,  2./
      DATA (u(i,1588),i=1,7)/12., 9., 1., 3., 4.86E-02,2.27480E+06,  2./
      DATA (u(i,1589),i=1,7)/12., 9., 1., 3., 3.41E-02,1.83284E+06,  2./
      DATA (u(i,1590),i=1,7)/12., 9., 1., 3., 3.31E-02,2.38550E+06,  2./
      DATA (u(i,1591),i=1,7)/12., 9., 1., 3., 2.28E-02,2.24921E+06,  2./
      DATA (u(i,1592),i=1,7)/12., 9., 1., 3., 1.35E-02,1.72980E+06,  2./
      DATA (u(i,1593),i=1,7)/12., 9., 1., 3., 1.29E-02,2.45459E+06,  2./
      DATA (u(i,1594),i=1,7)/12., 9., 1., 3., 1.22E-02,2.49750E+06,  2./
      DATA (u(i,1595),i=1,7)/12., 9., 1., 3., 1.07E-02,2.44559E+06,  2./
      DATA (u(i,1596),i=1,7)/12., 9., 1., 3., 8.81E-03,2.52717E+06,  2./
      DATA (u(i,1597),i=1,7)/12., 9., 1., 3., 7.13E-03,2.54907E+06,  2./
      DATA (u(i,1598),i=1,7)/12., 9., 1., 3., 7.61E-04,2.20507E+06,  2./
      DATA (u(i,1599),i=1,7)/12., 9., 1., 3., 1.41E-04,2.54065E+06,  2./
      DATA (u(i,1600),i=1,7)/12., 9., 1., 3., 7.79E-05,2.42424E+06,  2./
      DATA (u(i,1601),i=1,7)/12.,10., 2., 6., 1.70E-01,2.26398E+06, 18./
      DATA (u(i,1602),i=1,7)/12.,10., 2., 6., 7.19E-02,2.51383E+06, 18./
      DATA (u(i,1603),i=1,7)/12.,10., 2., 6., 3.77E-02,2.64971E+06, 18./
      DATA (u(i,1604),i=1,7)/12.,10., 2., 6., 2.24E-02,2.73149E+06, 18./
      DATA (u(i,1605),i=1,7)/12.,10., 2., 6., 1.45E-02,2.78396E+06, 18./
      DATA (u(i,1606),i=1,7)/12.,10., 2., 6., 9.90E-03,2.82008E+06, 18./
      DATA (u(i,1607),i=1,7)/12.,10., 2., 6., 7.09E-03,2.84657E+06, 18./
      DATA (u(i,1608),i=1,7)/12.,11., 1., 3.,-9.62E+06,1.07364E+07, 56./
      DATA (u(i,1609),i=1,7)/12.,11., 1., 3., 1.29E-03,1.08350E+07, 55./
      DATA (u(i,1610),i=1,7)/12.,11., 1., 3., 7.41E-01,1.08814E+07, 53./
      DATA (u(i,1611),i=1,7)/12.,11., 1., 3., 1.51E-01,1.27065E+07, 49./
      DATA (u(i,1612),i=1,7)/12.,11., 1., 3., 5.64E-02,1.33511E+07, 48./
      DATA (u(i,1613),i=1,7)/12.,11., 1., 3., 2.73E-02,1.36426E+07, 13./
      DATA (u(i,1614),i=1,7)/12.,11., 1., 3., 1.53E-02,1.38122E+07, 13./
      DATA (u(i,1615),i=1,7)/12.,11., 1., 3., 9.50E-03,1.39082E+07, 13./
      DATA (u(i,1616),i=1,7)/12.,11., 1., 3., 6.30E-03,1.39665E+07, 13./
      DATA (u(i,1617),i=1,7)/12.,11., 1., 3., 4.39E-03,1.40056E+07, 13./
      DATA (u(i,1618),i=1,7)/12.,11., 1., 3., 3.18E-03,1.40449E+07, 13./
      DATA (u(i,1619),i=1,7)/12.,12., 2., 2.,-1.71E+05,1.18703E+07, 52./
      DATA (u(i,1620),i=1,7)/12.,12., 2., 6., 8.32E-01,1.18483E+07, 51./
      DATA (u(i,1621),i=1,7)/12.,12., 2., 6., 1.58E-01,1.40449E+07,  5./
      DATA (u(i,1622),i=1,7)/12.,12., 2., 6., 5.80E-02,1.48148E+07,  6./
      DATA (u(i,1623),i=1,7)/12.,12., 2., 6., 2.79E-02,1.51515E+07,  7./
      DATA (u(i,1624),i=1,7)/12.,12., 2., 6., 1.56E-02,1.53610E+07,  8./
      DATA (u(i,1625),i=1,7)/12.,12., 2., 6., 9.63E-03,1.54799E+07,  9./
      DATA (u(i,1626),i=1,7)/12.,12., 2., 6., 6.37E-03,1.55521E+07,  9./
      DATA (u(i,1627),i=1,7)/12.,12., 2., 6., 4.43E-03,1.56006E+07,  9./
      DATA (u(i,1628),i=1,7)/12.,12., 2., 6., 3.21E-03,1.56250E+07,  9./
      DATA (u(i,1629),i=1,7)/13., 1., 6., 6., 4.75E+00,5.63174E+04, 0.1/
      DATA (u(i,1630),i=1,7)/13., 1., 6.,10., 7.59E-01,4.17012E+04,  1./
      DATA (u(i,1631),i=1,7)/13., 1., 6., 6., 7.10E-01,6.99413E+04,  1./
      DATA (u(i,1632),i=1,7)/13., 1., 6.,10., 5.80E-01,4.36544E+04,  1./
      DATA (u(i,1633),i=1,7)/13., 1., 6.,10., 3.78E-01,4.48320E+04,  1./
      DATA (u(i,1634),i=1,7)/13., 1., 6.,10., 3.53E-01,3.82869E+04,  1./
      DATA (u(i,1635),i=1,7)/13., 1., 6.,10., 2.48E-01,4.55778E+04,  1./
      DATA (u(i,1636),i=1,7)/13., 1., 6.,10., 1.69E-01,4.60745E+04,  1./
      DATA (u(i,1637),i=1,7)/13., 1., 6.,10., 1.19E-01,4.64199E+04,  1./
      DATA (u(i,1638),i=1,7)/13., 1., 6., 2., 8.68E-02,3.72311E+04,  1./
      DATA (u(i,1639),i=1,7)/13., 1., 6., 6., 8.62E-02,7.71551E+04,  1./
      DATA (u(i,1640),i=1,7)/13., 1., 6., 2., 2.88E-02,4.16530E+04,  1./
      DATA (u(i,1641),i=1,7)/13., 1., 6., 6., 2.67E-02,8.02568E+04,  1./
      DATA (u(i,1642),i=1,7)/13., 1., 6., 2., 1.38E-02,4.37652E+04,  1./
      DATA (u(i,1643),i=1,7)/13., 1., 6., 6., 1.18E-02,8.18585E+04,  1./
      DATA (u(i,1644),i=1,7)/13., 1., 6., 2., 7.73E-03,4.49414E+04,  1./
      DATA (u(i,1645),i=1,7)/13., 1., 6., 6., 6.32E-03,8.27958E+04,  1./
      DATA (u(i,1646),i=1,7)/13., 1., 6., 2., 4.76E-03,4.56638E+04,  1./
      DATA (u(i,1647),i=1,7)/13., 1., 6., 6., 3.79E-03,8.33917E+04,  1./
      DATA (u(i,1648),i=1,7)/13., 1., 6., 2., 3.15E-03,4.61395E+04,  1./
      DATA (u(i,1649),i=1,7)/13., 1., 6., 6., 2.47E-03,8.37935E+04,  1./
      DATA (u(i,1650),i=1,7)/13., 1., 6., 2., 2.19E-03,4.64691E+04,  1./
      DATA (u(i,1651),i=1,7)/13., 1., 6., 6., 1.70E-03,8.40781E+04,  1./
      DATA (u(i,1652),i=1,7)/13., 2., 1., 3., 1.81E+00,5.98520E+04,999./
      DATA (u(i,1653),i=1,7)/13., 2., 1., 3., 3.02E-03,1.07641E+05,  2./
      DATA (u(i,1654),i=1,7)/13., 2., 1., 3., 1.10E-03,1.40241E+05,  2./
      DATA (u(i,1655),i=1,7)/13., 2., 1., 3., 1.09E-03,1.35252E+05,  2./
      DATA (u(i,1656),i=1,7)/13., 2., 1., 3., 1.05E-03,1.43277E+05,  2./
      DATA (u(i,1657),i=1,7)/13., 2., 1., 3., 9.98E-04,1.45258E+05,  2./
      DATA (u(i,1658),i=1,7)/13., 2., 1., 3., 9.48E-04,1.46621E+05,  2./
      DATA (u(i,1659),i=1,7)/13., 2., 1., 3., 8.58E-04,1.47601E+05,  2./
      DATA (u(i,1660),i=1,7)/13., 2., 1., 3., 5.67E-04,1.26208E+05,  2./
      DATA (u(i,1661),i=1,7)/13., 3., 2., 6., 2.75E-02,1.42233E+05,  2./
      DATA (u(i,1662),i=1,7)/13., 3., 2., 6., 1.59E-02,1.76672E+05,  2./
      DATA (u(i,1663),i=1,7)/13., 3., 2., 6., 8.80E-03,1.93735E+05,  2./
      DATA (u(i,1664),i=1,7)/13., 3., 2., 6., 5.29E-03,2.03430E+05,  2./
      DATA (u(i,1665),i=1,7)/13., 3., 2., 6., 3.41E-03,2.09468E+05,  2./
      DATA (u(i,1666),i=1,7)/13., 3., 2., 6., 2.33E-03,2.13479E+05,  2./
      DATA (u(i,1667),i=1,7)/13., 3., 2., 6., 1.66E-03,2.16282E+05,  2./
      DATA (u(i,1668),i=1,7)/13., 4., 1., 3., 7.88E-01,7.80153E+05, 19./
      DATA (u(i,1669),i=1,7)/13., 4., 1., 3., 3.26E-01,8.66476E+05, 20./
      DATA (u(i,1670),i=1,7)/13., 4., 1., 3., 2.50E-01,6.36132E+05, 21./
      DATA (u(i,1671),i=1,7)/13., 4., 1., 3., 1.64E-01,9.06290E+05,  2./
      DATA (u(i,1672),i=1,7)/13., 4., 1., 3., 9.39E-02,9.27902E+05,  2./
      DATA (u(i,1673),i=1,7)/13., 4., 1., 3., 5.87E-02,9.40911E+05,  2./
      DATA (u(i,1674),i=1,7)/13., 4., 1., 3., 4.05E-02,8.14200E+05, 22./
      DATA (u(i,1675),i=1,7)/13., 4., 1., 3., 3.92E-02,9.49307E+05,  2./
      DATA (u(i,1676),i=1,7)/13., 4., 1., 3., 2.74E-02,9.55110E+05,  2./
      DATA (u(i,1677),i=1,7)/13., 4., 1., 3., 1.99E-02,9.59233E+05,  2./
      DATA (u(i,1678),i=1,7)/13., 4., 1., 3., 1.51E-02,8.81523E+05,  2./
      DATA (u(i,1679),i=1,7)/13., 4., 1., 3., 7.40E-03,9.14160E+05,  2./
      DATA (u(i,1680),i=1,7)/13., 4., 1., 3., 4.20E-03,9.32575E+05,  2./
      DATA (u(i,1681),i=1,7)/13., 4., 1., 3., 2.62E-03,9.43841E+05,  2./
      DATA (u(i,1682),i=1,7)/13., 4., 1., 3., 1.75E-03,9.51384E+05,  2./
      DATA (u(i,1683),i=1,7)/13., 4., 1., 3., 1.23E-03,9.56572E+05,  2./
      DATA (u(i,1684),i=1,7)/13., 5., 6.,10., 2.35E+00,9.24642E+05,  2./
      DATA (u(i,1685),i=1,7)/13., 5., 6., 6., 1.49E+00,9.59509E+05,  2./
      DATA (u(i,1686),i=1,7)/13., 5., 6.,10., 1.42E+00,9.61446E+05,  2./
      DATA (u(i,1687),i=1,7)/13., 5., 6.,10., 1.14E+00,1.06349E+06,  2./
      DATA (u(i,1688),i=1,7)/13., 5., 6., 6., 7.15E-01,7.65873E+05,  2./
      DATA (u(i,1689),i=1,7)/13., 5., 6., 2., 6.10E-01,9.58773E+05,  2./
      DATA (u(i,1690),i=1,7)/13., 5., 6.,10., 6.02E-01,1.12689E+06,  2./
      DATA (u(i,1691),i=1,7)/13., 5., 6.,10., 5.92E-01,1.15794E+06,  2./
      DATA (u(i,1692),i=1,7)/13., 5., 6., 6., 5.28E-01,9.25754E+05,  2./
      DATA (u(i,1693),i=1,7)/13., 5., 6., 2., 4.99E-01,3.55720E+05,  3./
      DATA (u(i,1694),i=1,7)/13., 5., 6.,10., 4.29E-01,7.97575E+05,  2./
      DATA (u(i,1695),i=1,7)/13., 5., 6.,10., 3.74E-01,1.00614E+06,  2./
      DATA (u(i,1696),i=1,7)/13., 5., 6., 6., 3.52E-01,1.06315E+06,  2./
      DATA (u(i,1697),i=1,7)/13., 5., 6., 6., 3.39E-01,1.09999E+06,  2./
      DATA (u(i,1698),i=1,7)/13., 5., 6.,10., 3.10E-01,1.10047E+06,  2./
      DATA (u(i,1699),i=1,7)/13., 5., 6., 6., 2.42E-01,1.15982E+06,  2./
      DATA (u(i,1700),i=1,7)/13., 5., 6., 6., 2.35E-01,1.12689E+06,  2./
      DATA (u(i,1701),i=1,7)/13., 5., 6., 2., 2.03E-01,1.10072E+06,  2./
      DATA (u(i,1702),i=1,7)/13., 5., 6.,10., 1.92E-01,1.14666E+06,  2./
      DATA (u(i,1703),i=1,7)/13., 5., 6.,10., 1.64E-01,1.18203E+06,  2./
      DATA (u(i,1704),i=1,7)/13., 5., 6., 6., 1.57E-01,1.16564E+06,  2./
      DATA (u(i,1705),i=1,7)/13., 5., 6.,10., 1.56E-01,1.16564E+06,  2./
      DATA (u(i,1706),i=1,7)/13., 5., 6., 6., 1.38E-01,1.00452E+06,  2./
      DATA (u(i,1707),i=1,7)/13., 5., 6., 2., 1.34E-01,1.16455E+06,  2./
      DATA (u(i,1708),i=1,7)/13., 5., 6., 6., 1.28E-01,1.09854E+06,  2./
      DATA (u(i,1709),i=1,7)/13., 5., 6., 6., 1.07E-01,1.16184E+06,  2./
      DATA (u(i,1710),i=1,7)/13., 5., 6.,10., 8.51E-02,1.20453E+06,  2./
      DATA (u(i,1711),i=1,7)/13., 5., 6.,10., 8.49E-02,1.19531E+06,  2./
      DATA (u(i,1712),i=1,7)/13., 5., 6., 2., 8.00E-02,8.45094E+05,  2./
      DATA (u(i,1713),i=1,7)/13., 5., 6.,10., 7.98E-02,1.20019E+06,  2./
      DATA (u(i,1714),i=1,7)/13., 5., 6., 6., 7.12E-02,1.20005E+06,  2./
      DATA (u(i,1715),i=1,7)/13., 5., 6.,10., 6.73E-02,1.04178E+06,  2./
      DATA (u(i,1716),i=1,7)/13., 5., 6., 6., 5.71E-02,1.18189E+06,  2./
      DATA (u(i,1717),i=1,7)/13., 5., 6., 2., 4.21E-02,1.18078E+06,  2./
      DATA (u(i,1718),i=1,7)/13., 5., 6., 6., 3.95E-02,1.20453E+06,  2./
      DATA (u(i,1719),i=1,7)/13., 5., 6., 6., 3.78E-02,1.14548E+06,  2./
      DATA (u(i,1720),i=1,7)/13., 5., 6., 2., 3.75E-02,1.20048E+06,  2./
      DATA (u(i,1721),i=1,7)/13., 5., 6., 2., 3.57E-02,1.08838E+06,  2./
      DATA (u(i,1722),i=1,7)/13., 5., 6., 6., 3.33E-02,1.20019E+06,  2./
      DATA (u(i,1723),i=1,7)/13., 5., 6., 2., 2.97E-02,1.22115E+06,  2./
      DATA (u(i,1724),i=1,7)/13., 5., 6.,10., 2.90E-02,1.13714E+06,  2./
      DATA (u(i,1725),i=1,7)/13., 5., 6., 2., 2.64E-02,1.18526E+06,  2./
      DATA (u(i,1726),i=1,7)/13., 5., 6., 6., 2.27E-02,1.19517E+06,  2./
      DATA (u(i,1727),i=1,7)/13., 5., 6., 6., 2.05E-02,1.21095E+06,  2./
      DATA (u(i,1728),i=1,7)/13., 5., 6., 2., 1.75E-02,1.23487E+06,  2./
      DATA (u(i,1729),i=1,7)/13., 5., 6.,10., 1.75E-02,1.18469E+06,  2./
      DATA (u(i,1730),i=1,7)/13., 5., 6.,10., 1.73E-02,1.21095E+06,  2./
      DATA (u(i,1731),i=1,7)/13., 5., 6., 2., 1.39E-02,1.24394E+06,  2./
      DATA (u(i,1732),i=1,7)/13., 5., 6., 2., 1.04E-02,1.25063E+06,  2./
      DATA (u(i,1733),i=1,7)/13., 5., 6., 6., 7.35E-03,1.18892E+06,  2./
      DATA (u(i,1734),i=1,7)/13., 5., 6., 6., 6.87E-03,1.17233E+06,  2./
      DATA (u(i,1735),i=1,7)/13., 5., 6.,10., 6.06E-03,1.16198E+06,  2./
      DATA (u(i,1736),i=1,7)/13., 5., 6., 2., 3.80E-03,1.23168E+06,  2./
      DATA (u(i,1737),i=1,7)/13., 5., 6., 6., 3.60E-03,1.20788E+06,  2./
      DATA (u(i,1738),i=1,7)/13., 5., 6.,10., 2.17E-05,1.16863E+06,  2./
      DATA (u(i,1739),i=1,7)/13., 5., 6.,10., 8.28E-07,1.20221E+06,  2./
      DATA (u(i,1740),i=1,7)/13., 6., 9., 9., 3.04E+00,1.14038E+06,  2./
      DATA (u(i,1741),i=1,7)/13., 6., 9.,15., 2.80E+00,1.13327E+06,  2./
      DATA (u(i,1742),i=1,7)/13., 6., 9.,15., 2.45E+00,1.07910E+06,  2./
      DATA (u(i,1743),i=1,7)/13., 6., 9.,15., 2.24E+00,1.16877E+06,  2./
      DATA (u(i,1744),i=1,7)/13., 6., 9., 9., 1.34E+00,3.21750E+05,  3./
      DATA (u(i,1745),i=1,7)/13., 6., 9.,15., 1.31E+00,1.37363E+06,  2./
      DATA (u(i,1746),i=1,7)/13., 6., 9.,15., 1.31E+00,1.37363E+06,  2./
      DATA (u(i,1747),i=1,7)/13., 6., 9., 3., 1.03E+00,1.14430E+06,  2./
      DATA (u(i,1748),i=1,7)/13., 6., 9.,15., 1.02E+00,1.27000E+06,  2./
      DATA (u(i,1749),i=1,7)/13., 6., 9.,15., 8.16E-01,1.27600E+06,  2./
      DATA (u(i,1750),i=1,7)/13., 6., 9., 9., 7.48E-01,1.34102E+06,  2./
      DATA (u(i,1751),i=1,7)/13., 6., 9.,15., 6.48E-01,9.64413E+05,  2./
      DATA (u(i,1752),i=1,7)/13., 6., 9.,15., 5.51E-01,1.33708E+06,  2./
      DATA (u(i,1753),i=1,7)/13., 6., 9., 9., 4.88E-01,1.28403E+06,  2./
      DATA (u(i,1754),i=1,7)/13., 6., 9., 9., 4.60E-01,1.16414E+06,  2./
      DATA (u(i,1755),i=1,7)/13., 6., 9., 3., 4.44E-01,9.16590E+05,  2./
      DATA (u(i,1756),i=1,7)/13., 6., 9., 9., 3.67E-01,9.97307E+05,  2./
      DATA (u(i,1757),i=1,7)/13., 6., 9.,15., 3.66E-01,1.45943E+06,  2./
      DATA (u(i,1758),i=1,7)/13., 6., 9.,15., 3.31E-01,1.28156E+06,  2./
      DATA (u(i,1759),i=1,7)/13., 6., 9.,15., 3.26E-01,1.43143E+06,  2./
      DATA (u(i,1760),i=1,7)/13., 6., 9., 9., 2.69E-01,1.43062E+06,  2./
      DATA (u(i,1761),i=1,7)/13., 6., 9., 9., 2.56E-01,1.36911E+06,  2./
      DATA (u(i,1762),i=1,7)/13., 6., 9.,15., 2.39E-01,1.42106E+06,  2./
      DATA (u(i,1763),i=1,7)/13., 6., 9.,15., 2.03E-01,1.45096E+06,  2./
      DATA (u(i,1764),i=1,7)/13., 6., 9., 3., 1.94E-01,1.34102E+06,  2./
      DATA (u(i,1765),i=1,7)/13., 6., 9., 9., 1.81E-01,1.48302E+06,  2./
      DATA (u(i,1766),i=1,7)/13., 6., 9., 3., 1.74E-01,1.27779E+06,  2./
      DATA (u(i,1767),i=1,7)/13., 6., 9., 3., 1.68E-01,1.34282E+06,  2./
      DATA (u(i,1768),i=1,7)/13., 6., 9.,15., 1.68E-01,1.48368E+06,  2./
      DATA (u(i,1769),i=1,7)/13., 6., 9., 3., 1.56E-01,1.43390E+06,  2./
      DATA (u(i,1770),i=1,7)/13., 6., 9., 9., 1.52E-01,1.43410E+06,  2./
      DATA (u(i,1771),i=1,7)/13., 6., 9.,15., 1.45E-01,1.47037E+06,  2./
      DATA (u(i,1772),i=1,7)/13., 6., 9.,15., 1.38E-01,1.46477E+06,  2./
      DATA (u(i,1773),i=1,7)/13., 6., 9., 9., 1.35E-01,1.51286E+06,  2./
      DATA (u(i,1774),i=1,7)/13., 6., 9., 9., 1.25E-01,1.53681E+06,  2./
      DATA (u(i,1775),i=1,7)/13., 6., 9., 9., 1.19E-01,1.30804E+06,  2./
      DATA (u(i,1776),i=1,7)/13., 6., 9., 3., 1.08E-01,1.21803E+06,  2./
      DATA (u(i,1777),i=1,7)/13., 6., 9., 9., 1.04E-01,1.45476E+06,  2./
      DATA (u(i,1778),i=1,7)/13., 6., 9., 9., 9.95E-02,1.46370E+06,  2./
      DATA (u(i,1779),i=1,7)/13., 6., 9., 9., 9.61E-02,1.53233E+06,  2./
      DATA (u(i,1780),i=1,7)/13., 6., 9.,15., 6.95E-02,1.49298E+06,  2./
      DATA (u(i,1781),i=1,7)/13., 6., 9., 3., 6.55E-02,1.48368E+06,  2./
      DATA (u(i,1782),i=1,7)/13., 6., 9.,15., 5.41E-02,1.48170E+06,  2./
      DATA (u(i,1783),i=1,7)/13., 6., 9., 9., 4.51E-02,1.51423E+06,  2./
      DATA (u(i,1784),i=1,7)/13., 6., 9.,15., 4.12E-02,1.40233E+06,  2./
      DATA (u(i,1785),i=1,7)/13., 6., 9., 9., 3.80E-02,1.54560E+06,  2./
      DATA (u(i,1786),i=1,7)/13., 6., 9., 9., 3.51E-02,1.54464E+06,  2./
      DATA (u(i,1787),i=1,7)/13., 6., 9., 9., 3.51E-02,1.55521E+06,  2./
      DATA (u(i,1788),i=1,7)/13., 6., 9.,15., 2.46E-02,1.36911E+06,  2./
      DATA (u(i,1789),i=1,7)/13., 6., 9., 3., 2.36E-02,1.47340E+06,  2./
      DATA (u(i,1790),i=1,7)/13., 6., 9., 3., 1.63E-02,1.40410E+06,  2./
      DATA (u(i,1791),i=1,7)/13., 6., 9., 9., 1.59E-02,1.53445E+06,  2./
      DATA (u(i,1792),i=1,7)/13., 6., 9., 3., 1.36E-02,1.47885E+06,  2./
      DATA (u(i,1793),i=1,7)/13., 6., 9., 9., 1.10E-02,1.37988E+06,  2./
      DATA (u(i,1794),i=1,7)/13., 6., 9.,15., 1.04E-02,1.46649E+06,  2./
      DATA (u(i,1795),i=1,7)/13., 6., 9., 3., 6.35E-03,1.44051E+06,  2./
      DATA (u(i,1796),i=1,7)/13., 6., 9., 3., 4.35E-03,1.46327E+06,  2./
      DATA (u(i,1797),i=1,7)/13., 6., 9., 3., 3.17E-03,1.48943E+06,  2./
      DATA (u(i,1798),i=1,7)/13., 6., 9., 9., 3.06E-03,1.49813E+06,  2./
      DATA (u(i,1799),i=1,7)/13., 6., 9., 9., 1.29E-03,1.43988E+06,  2./
      DATA (u(i,1800),i=1,7)/13., 7., 4.,12., 5.78E+00,1.33333E+06,  2./
      DATA (u(i,1801),i=1,7)/13., 7., 4.,12., 1.60E+00,1.60927E+06,  2./
      DATA (u(i,1802),i=1,7)/13., 7., 4.,12., 7.56E-01,2.81912E+05,  3./
      DATA (u(i,1803),i=1,7)/13., 7., 4.,12., 6.26E-01,1.37570E+06,  2./
      DATA (u(i,1804),i=1,7)/13., 7., 4.,12., 6.07E-01,1.73551E+06,  2./
      DATA (u(i,1805),i=1,7)/13., 7., 4.,12., 4.94E-01,1.15594E+06,  2./
      DATA (u(i,1806),i=1,7)/13., 7., 4.,12., 3.31E-01,1.80343E+06,  2./
      DATA (u(i,1807),i=1,7)/13., 7., 4.,12., 2.27E-01,1.84400E+06,  2./
      DATA (u(i,1808),i=1,7)/13., 7., 4.,12., 2.14E-01,1.69808E+06,  2./
      DATA (u(i,1809),i=1,7)/13., 7., 4.,12., 1.64E-01,1.64420E+06,  2./
      DATA (u(i,1810),i=1,7)/13., 7., 4.,12., 1.31E-01,1.54273E+06,  2./
      DATA (u(i,1811),i=1,7)/13., 7., 4.,12., 1.25E-01,1.87056E+06,  2./
      DATA (u(i,1812),i=1,7)/13., 7., 4.,12., 8.92E-02,1.88893E+06,  2./
      DATA (u(i,1813),i=1,7)/13., 7., 4.,12., 6.95E-02,1.70416E+06,  2./
      DATA (u(i,1814),i=1,7)/13., 7., 4.,12., 6.45E-02,1.90150E+06,  2./
      DATA (u(i,1815),i=1,7)/13., 7., 4.,12., 4.92E-02,1.83453E+06,  2./
      DATA (u(i,1816),i=1,7)/13., 7., 4.,12., 3.58E-02,1.83184E+06,  2./
      DATA (u(i,1817),i=1,7)/13., 7., 4.,12., 1.34E-02,1.78540E+06,  2./
      DATA (u(i,1818),i=1,7)/13., 7., 4.,12., 1.19E-02,1.84468E+06,  2./
      DATA (u(i,1819),i=1,7)/13., 7., 4.,12., 8.10E-03,1.86359E+06,  2./
      DATA (u(i,1820),i=1,7)/13., 7., 4.,12., 6.41E-03,1.88218E+06,  2./
      DATA (u(i,1821),i=1,7)/13., 7., 4.,12., 3.39E-03,1.51630E+06,  2./
      DATA (u(i,1822),i=1,7)/13., 7., 4.,12., 2.52E-03,1.56128E+06,  2./
      DATA (u(i,1823),i=1,7)/13., 7., 4.,12., 2.26E-03,1.89825E+06,  2./
      DATA (u(i,1824),i=1,7)/13., 7., 4.,12., 5.36E-04,1.88501E+06,  2./
      DATA (u(i,1825),i=1,7)/13., 7., 4.,12., 1.96E-04,1.78987E+06,  2./
      DATA (u(i,1826),i=1,7)/13., 7., 4.,12., 1.51E-04,1.87547E+06,  2./
      DATA (u(i,1827),i=1,7)/13., 8., 9.,15., 7.30E+00,1.48148E+06,  2./
      DATA (u(i,1828),i=1,7)/13., 8., 9., 9., 2.43E+00,1.48610E+06,  2./
      DATA (u(i,1829),i=1,7)/13., 8., 9.,15., 1.65E+00,1.84128E+06,  2./
      DATA (u(i,1830),i=1,7)/13., 8., 9.,15., 1.30E+00,1.55521E+06,  2./
      DATA (u(i,1831),i=1,7)/13., 8., 9., 3., 9.17E-01,4.00769E+05,  3./
      DATA (u(i,1832),i=1,7)/13., 8., 9., 9., 7.52E-01,3.03232E+05,  3./
      DATA (u(i,1833),i=1,7)/13., 8., 9., 9., 7.47E-01,1.56838E+06,  2./
      DATA (u(i,1834),i=1,7)/13., 8., 9.,15., 6.57E-01,2.55441E+05,  3./
      DATA (u(i,1835),i=1,7)/13., 8., 9., 9., 6.13E-01,1.31874E+06,  2./
      DATA (u(i,1836),i=1,7)/13., 8., 9.,15., 6.05E-01,2.00521E+06,  2./
      DATA (u(i,1837),i=1,7)/13., 8., 9., 9., 5.53E-01,1.84230E+06,  2./
      DATA (u(i,1838),i=1,7)/13., 8., 9.,15., 3.51E-01,2.09380E+06,  2./
      DATA (u(i,1839),i=1,7)/13., 8., 9.,15., 3.40E-01,1.74338E+06,  2./
      DATA (u(i,1840),i=1,7)/13., 8., 9.,15., 3.39E-01,1.95886E+06,  2./
      DATA (u(i,1841),i=1,7)/13., 8., 9., 3., 3.23E-01,1.52022E+06,  2./
      DATA (u(i,1842),i=1,7)/13., 8., 9., 9., 2.72E-01,1.74886E+06,  2./
      DATA (u(i,1843),i=1,7)/13., 8., 9., 9., 2.32E-01,2.00562E+06,  2./
      DATA (u(i,1844),i=1,7)/13., 8., 9.,15., 2.14E-01,2.14731E+06,  2./
      DATA (u(i,1845),i=1,7)/13., 8., 9.,15., 2.12E-01,2.13265E+06,  2./
      DATA (u(i,1846),i=1,7)/13., 8., 9., 9., 2.04E-01,1.96232E+06,  2./
      DATA (u(i,1847),i=1,7)/13., 8., 9.,15., 1.44E-01,1.93949E+06,  2./
      DATA (u(i,1848),i=1,7)/13., 8., 9., 9., 1.27E-01,1.73130E+06,  2./
      DATA (u(i,1849),i=1,7)/13., 8., 9., 9., 1.18E-01,2.09424E+06,  2./
      DATA (u(i,1850),i=1,7)/13., 8., 9.,15., 1.18E-01,2.18198E+06,  2./
      DATA (u(i,1851),i=1,7)/13., 8., 9.,15., 1.08E-01,2.00602E+06,  2./
      DATA (u(i,1852),i=1,7)/13., 8., 9., 3., 1.01E-01,1.75747E+06,  2./
      DATA (u(i,1853),i=1,7)/13., 8., 9.,15., 1.01E-01,1.66196E+06,  2./
      DATA (u(i,1854),i=1,7)/13., 8., 9., 3., 9.43E-02,1.94666E+06,  2./
      DATA (u(i,1855),i=1,7)/13., 8., 9., 9., 8.53E-02,2.13675E+06,  2./
      DATA (u(i,1856),i=1,7)/13., 8., 9.,15., 8.03E-02,2.16076E+06,  2./
      DATA (u(i,1857),i=1,7)/13., 8., 9., 9., 7.78E-02,1.97550E+06,  2./
      DATA (u(i,1858),i=1,7)/13., 8., 9., 9., 7.27E-02,2.14731E+06,  2./
      DATA (u(i,1859),i=1,7)/13., 8., 9.,15., 6.71E-02,2.20556E+06,  2./
      DATA (u(i,1860),i=1,7)/13., 8., 9., 9., 6.70E-02,2.16357E+06,  2./
      DATA (u(i,1861),i=1,7)/13., 8., 9.,15., 6.17E-02,2.22222E+06,  2./
      DATA (u(i,1862),i=1,7)/13., 8., 9., 9., 5.03E-02,2.13311E+06,  2./
      DATA (u(i,1863),i=1,7)/13., 8., 9., 9., 3.95E-02,2.18198E+06,  2./
      DATA (u(i,1864),i=1,7)/13., 8., 9., 3., 3.69E-02,2.16779E+06,  2./
      DATA (u(i,1865),i=1,7)/13., 8., 9., 3., 3.43E-02,2.12585E+06,  2./
      DATA (u(i,1866),i=1,7)/13., 8., 9., 9., 2.82E-02,2.20556E+06,  2./
      DATA (u(i,1867),i=1,7)/13., 8., 9., 3., 2.37E-02,2.34357E+06,  2./
      DATA (u(i,1868),i=1,7)/13., 8., 9., 9., 2.23E-02,1.78476E+06,  2./
      DATA (u(i,1869),i=1,7)/13., 8., 9., 9., 2.06E-02,2.22222E+06,  2./
      DATA (u(i,1870),i=1,7)/13., 8., 9.,15., 2.06E-02,2.06911E+06,  2./
      DATA (u(i,1871),i=1,7)/13., 8., 9., 3., 1.97E-02,2.22074E+06,  2./
      DATA (u(i,1872),i=1,7)/13., 8., 9.,15., 1.74E-02,2.20459E+06,  2./
      DATA (u(i,1873),i=1,7)/13., 8., 9., 9., 1.67E-02,2.07900E+06,  2./
      DATA (u(i,1874),i=1,7)/13., 8., 9., 9., 1.65E-02,2.06016E+06,  2./
      DATA (u(i,1875),i=1,7)/13., 8., 9., 3., 1.13E-02,2.28050E+06,  2./
      DATA (u(i,1876),i=1,7)/13., 8., 9., 9., 1.07E-02,1.67420E+06,  2./
      DATA (u(i,1877),i=1,7)/13., 8., 9., 9., 1.04E-02,2.01369E+06,  2./
      DATA (u(i,1878),i=1,7)/13., 8., 9., 3., 1.00E-02,2.02265E+06,  2./
      DATA (u(i,1879),i=1,7)/13., 8., 9.,15., 9.56E-03,2.06441E+06,  2./
      DATA (u(i,1880),i=1,7)/13., 8., 9.,15., 7.88E-03,1.99203E+06,  2./
      DATA (u(i,1881),i=1,7)/13., 8., 9., 3., 6.79E-03,2.31642E+06,  2./
      DATA (u(i,1882),i=1,7)/13., 8., 9., 9., 5.63E-03,2.06868E+06,  2./
      DATA (u(i,1883),i=1,7)/13., 8., 9., 9., 5.41E-03,2.14179E+06,  2./
      DATA (u(i,1884),i=1,7)/13., 8., 9., 3., 5.31E-03,1.82183E+06,  2./
      DATA (u(i,1885),i=1,7)/13., 8., 9., 3., 4.78E-03,2.35849E+06,  2./
      DATA (u(i,1886),i=1,7)/13., 8., 9.,15., 4.35E-03,2.11149E+06,  2./
      DATA (u(i,1887),i=1,7)/13., 8., 9.,15., 4.15E-03,2.15008E+06,  2./
      DATA (u(i,1888),i=1,7)/13., 8., 9., 9., 2.98E-03,2.11416E+06,  2./
      DATA (u(i,1889),i=1,7)/13., 8., 9., 9., 2.64E-03,2.20070E+06,  2./
      DATA (u(i,1890),i=1,7)/13., 8., 9., 9., 2.56E-03,1.91975E+06,  2./
      DATA (u(i,1891),i=1,7)/13., 8., 9., 9., 1.84E-03,2.21877E+06,  2./
      DATA (u(i,1892),i=1,7)/13., 8., 9.,15., 8.40E-04,1.85357E+06,  2./
      DATA (u(i,1893),i=1,7)/13., 8., 9., 3., 5.79E-04,2.24568E+06,  2./
      DATA (u(i,1894),i=1,7)/13., 8., 9., 3., 5.58E-04,2.34028E+06,  2./
      DATA (u(i,1895),i=1,7)/13., 8., 9., 9., 3.91E-04,2.17580E+06,  2./
      DATA (u(i,1896),i=1,7)/13., 9., 6.,10., 3.70E+00,1.63506E+06,  2./
      DATA (u(i,1897),i=1,7)/13., 9., 6.,10., 1.33E+00,1.74917E+06,  2./
      DATA (u(i,1898),i=1,7)/13., 9., 6., 6., 1.11E+00,3.50385E+05,  3./
      DATA (u(i,1899),i=1,7)/13., 9., 6.,10., 8.26E-01,2.08594E+06,  2./
      DATA (u(i,1900),i=1,7)/13., 9., 6., 6., 7.57E-01,1.71204E+06,  2./
      DATA (u(i,1901),i=1,7)/13., 9., 6.,10., 4.14E-01,2.53126E+05,  3./
      DATA (u(i,1902),i=1,7)/13., 9., 6.,10., 3.48E-01,2.22668E+06,  2./
      DATA (u(i,1903),i=1,7)/13., 9., 6.,10., 2.97E-01,2.29253E+06,  2./
      DATA (u(i,1904),i=1,7)/13., 9., 6., 2., 2.63E-01,1.77211E+06,  2./
      DATA (u(i,1905),i=1,7)/13., 9., 6., 6., 2.28E-01,1.86916E+06,  2./
      DATA (u(i,1906),i=1,7)/13., 9., 6., 2., 2.23E-01,3.27998E+05,  3./
      DATA (u(i,1907),i=1,7)/13., 9., 6., 6., 2.07E-01,2.21484E+06,  2./
      DATA (u(i,1908),i=1,7)/13., 9., 6.,10., 1.53E-01,2.43902E+06,  2./
      DATA (u(i,1909),i=1,7)/13., 9., 6., 2., 1.50E-01,1.49589E+06,  2./
      DATA (u(i,1910),i=1,7)/13., 9., 6.,10., 1.39E-01,2.40385E+06,  2./
      DATA (u(i,1911),i=1,7)/13., 9., 6.,10., 1.12E-01,1.86811E+06,  2./
      DATA (u(i,1912),i=1,7)/13., 9., 6.,10., 8.52E-02,2.47036E+06,  2./
      DATA (u(i,1913),i=1,7)/13., 9., 6.,10., 8.05E-02,2.55428E+06,  2./
      DATA (u(i,1914),i=1,7)/13., 9., 6., 6., 7.62E-02,2.42836E+06,  2./
      DATA (u(i,1915),i=1,7)/13., 9., 6.,10., 7.29E-02,2.36016E+06,  2./
      DATA (u(i,1916),i=1,7)/13., 9., 6., 6., 6.19E-02,2.36239E+06,  2./
      DATA (u(i,1917),i=1,7)/13., 9., 6., 2., 5.81E-02,2.23464E+06,  2./
      DATA (u(i,1918),i=1,7)/13., 9., 6.,10., 5.76E-02,2.51383E+06,  2./
      DATA (u(i,1919),i=1,7)/13., 9., 6., 2., 5.13E-02,1.88324E+06,  2./
      DATA (u(i,1920),i=1,7)/13., 9., 6., 6., 4.33E-02,2.55102E+06,  2./
      DATA (u(i,1921),i=1,7)/13., 9., 6.,10., 3.75E-02,2.54324E+06,  2./
      DATA (u(i,1922),i=1,7)/13., 9., 6., 6., 3.03E-02,2.62054E+06,  2./
      DATA (u(i,1923),i=1,7)/13., 9., 6., 6., 2.85E-02,1.94742E+06,  2./
      DATA (u(i,1924),i=1,7)/13., 9., 6., 6., 2.76E-02,2.10970E+06,  2./
      DATA (u(i,1925),i=1,7)/13., 9., 6.,10., 2.75E-02,2.56476E+06,  2./
      DATA (u(i,1926),i=1,7)/13., 9., 6., 6., 2.68E-02,2.58065E+06,  2./
      DATA (u(i,1927),i=1,7)/13., 9., 6., 2., 2.64E-02,2.36407E+06,  2./
      DATA (u(i,1928),i=1,7)/13., 9., 6., 6., 2.45E-02,2.69687E+06,  2./
      DATA (u(i,1929),i=1,7)/13., 9., 6., 2., 2.43E-02,2.44379E+06,  2./
      DATA (u(i,1930),i=1,7)/13., 9., 6., 2., 2.19E-02,2.03500E+06,  2./
      DATA (u(i,1931),i=1,7)/13., 9., 6., 6., 2.11E-02,2.45098E+06,  2./
      DATA (u(i,1932),i=1,7)/13., 9., 6., 2., 1.97E-02,2.26552E+06,  2./
      DATA (u(i,1933),i=1,7)/13., 9., 6.,10., 1.73E-02,2.50313E+06,  2./
      DATA (u(i,1934),i=1,7)/13., 9., 6., 2., 1.71E-02,2.55558E+06,  2./
      DATA (u(i,1935),i=1,7)/13., 9., 6., 6., 1.70E-02,2.66454E+06,  2./
      DATA (u(i,1936),i=1,7)/13., 9., 6., 6., 1.65E-02,2.03459E+06,  2./
      DATA (u(i,1937),i=1,7)/13., 9., 6.,10., 1.26E-02,2.07598E+06,  2./
      DATA (u(i,1938),i=1,7)/13., 9., 6., 6., 1.21E-02,2.53743E+06,  2./
      DATA (u(i,1939),i=1,7)/13., 9., 6.,10., 1.21E-02,2.09380E+06,  2./
      DATA (u(i,1940),i=1,7)/13., 9., 6., 6., 9.46E-03,2.71813E+06,  2./
      DATA (u(i,1941),i=1,7)/13., 9., 6.,10., 9.31E-03,2.53229E+06,  2./
      DATA (u(i,1942),i=1,7)/13., 9., 6.,10., 8.46E-03,2.18962E+06,  2./
      DATA (u(i,1943),i=1,7)/13., 9., 6.,10., 7.59E-03,1.96541E+06,  2./
      DATA (u(i,1944),i=1,7)/13., 9., 6., 2., 7.46E-03,2.12044E+06,  2./
      DATA (u(i,1945),i=1,7)/13., 9., 6.,10., 6.25E-03,2.40038E+06,  2./
      DATA (u(i,1946),i=1,7)/13., 9., 6., 2., 6.13E-03,2.53872E+06,  2./
      DATA (u(i,1947),i=1,7)/13., 9., 6., 2., 4.41E-03,2.46184E+06,  2./
      DATA (u(i,1948),i=1,7)/13., 9., 6., 6., 4.19E-03,2.48633E+06,  2./
      DATA (u(i,1949),i=1,7)/13., 9., 6., 6., 3.78E-03,2.69251E+06,  2./
      DATA (u(i,1950),i=1,7)/13., 9., 6., 2., 2.42E-03,2.50752E+06,  2./
      DATA (u(i,1951),i=1,7)/13., 9., 6., 6., 2.06E-03,2.69542E+06,  2./
      DATA (u(i,1952),i=1,7)/13., 9., 6., 2., 2.03E-03,2.56148E+06,  2./
      DATA (u(i,1953),i=1,7)/13., 9., 6., 2., 1.55E-03,2.06697E+06,  2./
      DATA (u(i,1954),i=1,7)/13., 9., 6., 2., 8.38E-04,2.39063E+06,  2./
      DATA (u(i,1955),i=1,7)/13., 9., 6., 6., 8.12E-04,2.67237E+06,  2./
      DATA (u(i,1956),i=1,7)/13., 9., 6., 2., 1.23E-04,2.53936E+06,  2./
      DATA (u(i,1957),i=1,7)/13., 9., 6.,10., 1.01E-04,2.45459E+06,  2./
      DATA (u(i,1958),i=1,7)/13., 9., 6.,10., 6.47E-05,2.25785E+06,  2./
      DATA (u(i,1959),i=1,7)/13., 9., 6.,10., 3.43E-05,2.48201E+06,  2./
      DATA (u(i,1960),i=1,7)/13., 9., 6.,10., 3.07E-06,2.56345E+06,  2./
      DATA (u(i,1961),i=1,7)/13.,10., 1., 3., 5.63E-01,1.91644E+06,  2./
      DATA (u(i,1962),i=1,7)/13.,10., 1., 3., 2.86E-01,2.98784E+05,  3./
      DATA (u(i,1963),i=1,7)/13.,10., 1., 3., 1.48E-01,2.49688E+06,  2./
      DATA (u(i,1964),i=1,7)/13.,10., 1., 3., 5.68E-02,2.75710E+06,  2./
      DATA (u(i,1965),i=1,7)/13.,10., 1., 3., 3.40E-02,2.89352E+06,  2./
      DATA (u(i,1966),i=1,7)/13.,10., 1., 3., 3.37E-02,2.18723E+06,  2./
      DATA (u(i,1967),i=1,7)/13.,10., 1., 3., 1.80E-02,2.97885E+06,  2./
      DATA (u(i,1968),i=1,7)/13.,10., 1., 3., 1.70E-02,2.07211E+06,  2./
      DATA (u(i,1969),i=1,7)/13.,10., 1., 3., 1.68E-02,2.70343E+06,  2./
      DATA (u(i,1970),i=1,7)/13.,10., 1., 3., 1.28E-02,3.03214E+06,  2./
      DATA (u(i,1971),i=1,7)/13.,10., 1., 3., 7.90E-03,3.07031E+06,  2./
      DATA (u(i,1972),i=1,7)/13.,10., 1., 3., 5.73E-03,2.94638E+06,  2./
      DATA (u(i,1973),i=1,7)/13.,10., 1., 3., 5.70E-03,3.09502E+06,  2./
      DATA (u(i,1974),i=1,7)/13.,10., 1., 3., 2.12E-03,3.07882E+06,  2./
      DATA (u(i,1975),i=1,7)/13.,10., 1., 3., 1.68E-03,3.06373E+06,  2./
      DATA (u(i,1976),i=1,7)/13.,10., 1., 3., 2.89E-04,2.92227E+06,  2./
      DATA (u(i,1977),i=1,7)/13.,10., 1., 3., 2.19E-04,2.65393E+06,  2./
      DATA (u(i,1978),i=1,7)/13.,11., 2., 6., 1.74E-01,2.71739E+06, 18./
      DATA (u(i,1979),i=1,7)/13.,11., 2., 6., 7.30E-02,3.01932E+06, 18./
      DATA (u(i,1980),i=1,7)/13.,11., 2., 6., 3.82E-02,3.18370E+06, 18./
      DATA (u(i,1981),i=1,7)/13.,11., 2., 6., 2.27E-02,3.28192E+06, 18./
      DATA (u(i,1982),i=1,7)/13.,11., 2., 6., 1.46E-02,3.34672E+06, 18./
      DATA (u(i,1983),i=1,7)/13.,11., 2., 6., 1.00E-02,3.38983E+06, 18./
      DATA (u(i,1984),i=1,7)/13.,11., 2., 6., 7.18E-03,3.42114E+06, 18./
      DATA (u(i,1985),i=1,7)/13.,12., 1., 3.,-1.33E+07,1.27035E+07, 24./
      DATA (u(i,1986),i=1,7)/13.,12., 1., 3., 2.06E-03,1.28095E+07, 25./
      DATA (u(i,1987),i=1,7)/13.,12., 1., 3., 7.48E-01,1.28535E+07, 11./
      DATA (u(i,1988),i=1,7)/13.,12., 1., 3., 1.52E-01,1.50376E+07, 12./
      DATA (u(i,1989),i=1,7)/13.,12., 1., 3., 5.66E-02,1.57978E+07, 13./
      DATA (u(i,1990),i=1,7)/13.,12., 1., 3., 2.74E-02,1.61551E+07, 13./
      DATA (u(i,1991),i=1,7)/13.,12., 1., 3., 1.54E-02,1.63399E+07, 13./
      DATA (u(i,1992),i=1,7)/13.,12., 1., 3., 9.51E-03,1.64745E+07, 13./
      DATA (u(i,1993),i=1,7)/13.,12., 1., 3., 6.30E-03,1.65289E+07, 13./
      DATA (u(i,1994),i=1,7)/13.,12., 1., 3., 4.39E-03,1.65837E+07, 13./
      DATA (u(i,1995),i=1,7)/13.,12., 1., 3., 3.19E-03,1.66389E+07, 13./
      DATA (u(i,1996),i=1,7)/13.,13., 2., 2.,-2.35E+05,1.39351E+07, 23./
      DATA (u(i,1997),i=1,7)/13.,13., 2., 6., 8.32E-01,1.39082E+07,  4./
      DATA (u(i,1998),i=1,7)/13.,13., 2., 6., 1.58E-01,1.64745E+07,  5./
      DATA (u(i,1999),i=1,7)/13.,13., 2., 6., 5.80E-02,1.73913E+07,  6./
      DATA (u(i,2000),i=1,7)/13.,13., 2., 6., 2.79E-02,1.77936E+07,  7./
      DATA (u(i,2001),i=1,7)/13.,13., 2., 6., 1.56E-02,1.80180E+07,  8./
      DATA (u(i,2002),i=1,7)/13.,13., 2., 6., 9.63E-03,1.81488E+07,  9./
      DATA (u(i,2003),i=1,7)/13.,13., 2., 6., 6.37E-03,1.82482E+07,  9./
      DATA (u(i,2004),i=1,7)/13.,13., 2., 6., 4.43E-03,1.83150E+07,  9./
      DATA (u(i,2005),i=1,7)/13.,13., 2., 6., 3.21E-03,1.83486E+07,  9./
      DATA (u(i,2006),i=1,7)/14., 1., 9., 3., 2.59E+00,7.92852E+04, 0.1/
      DATA (u(i,2007),i=1,7)/14., 1., 9.,15., 2.43E+00,5.39651E+04, 0.1/
      DATA (u(i,2008),i=1,7)/14., 1., 9.,15., 1.40E+00,5.90423E+04,  1./
      DATA (u(i,2009),i=1,7)/14., 1., 9.,15., 7.66E-01,6.15067E+04,  1./
      DATA (u(i,2010),i=1,7)/14., 1., 9., 3., 7.28E-01,9.16582E+04,  1./
      DATA (u(i,2011),i=1,7)/14., 1., 9., 9., 4.80E-01,5.00015E+04, 0.1/
      DATA (u(i,2012),i=1,7)/14., 1., 9.,15., 4.53E-01,6.28579E+04,  1./
      DATA (u(i,2013),i=1,7)/14., 1., 9., 9., 3.11E-01,5.99582E+04,  1./
      DATA (u(i,2014),i=1,7)/14., 1., 9.,15., 2.86E-01,6.36776E+04,  1./
      DATA (u(i,2015),i=1,7)/14., 1., 9., 9., 2.64E-01,6.18957E+04,  1./
      DATA (u(i,2016),i=1,7)/14., 1., 9., 9., 2.63E-01,5.45212E+04,  1./
      DATA (u(i,2017),i=1,7)/14., 1., 9.,15., 1.91E-01,6.42108E+04,  1./
      DATA (u(i,2018),i=1,7)/14., 1., 9., 9., 1.65E-01,6.30565E+04,  1./
      DATA (u(i,2019),i=1,7)/14., 1., 9., 3., 1.40E-01,9.80960E+04,  1./
      DATA (u(i,2020),i=1,7)/14., 1., 9.,15., 1.34E-01,6.45765E+04,  1./
      DATA (u(i,2021),i=1,7)/14., 1., 9., 9., 1.09E-01,5.65633E+04,  1./
      DATA (u(i,2022),i=1,7)/14., 1., 9., 9., 1.07E-01,6.42793E+04,  1./
      DATA (u(i,2023),i=1,7)/14., 1., 9., 9., 1.03E-01,5.94594E+04,  1./
      DATA (u(i,2024),i=1,7)/14., 1., 9., 9., 1.01E-01,6.37824E+04,  1./
      DATA (u(i,2025),i=1,7)/14., 1., 9.,15., 9.72E-02,6.48382E+04,  1./
      DATA (u(i,2026),i=1,7)/14., 1., 9., 9., 7.96E-02,6.46229E+04,  1./
      DATA (u(i,2027),i=1,7)/14., 1., 9., 9., 6.62E-02,6.17593E+04,  1./
      DATA (u(i,2028),i=1,7)/14., 1., 9., 9., 6.48E-02,6.30187E+04,  1./
      DATA (u(i,2029),i=1,7)/14., 1., 9., 9., 5.67E-02,6.37942E+04,  1./
      DATA (u(i,2030),i=1,7)/14., 1., 9., 3., 4.30E-02,1.01273E+05,  1./
      DATA (u(i,2031),i=1,7)/14., 1., 9., 3., 1.90E-02,1.02940E+05,  1./
      DATA (u(i,2032),i=1,7)/14., 1., 9., 3., 1.01E-02,1.03918E+05,  1./
      DATA (u(i,2033),i=1,7)/14., 1., 9., 3., 6.09E-03,1.04537E+05,  1./
      DATA (u(i,2034),i=1,7)/14., 1., 9., 3., 3.97E-03,1.04954E+05,  1./
      DATA (u(i,2035),i=1,7)/14., 1., 9., 9., 3.78E-03,6.42884E+04,  1./
      DATA (u(i,2036),i=1,7)/14., 1., 9., 3., 2.74E-03,1.05248E+05,  1./
      DATA (u(i,2037),i=1,7)/14., 1., 9., 9., 2.85E-05,6.46316E+04,  1./
      DATA (u(i,2038),i=1,7)/14., 2., 6., 6., 5.32E+00,8.47752E+04,189./
      DATA (u(i,2039),i=1,7)/14., 2., 6.,10., 1.02E+00,1.00669E+05,183./
      DATA (u(i,2040),i=1,7)/14., 2., 6.,10., 2.59E-01,1.11913E+05,  2./
      DATA (u(i,2041),i=1,7)/14., 2., 6.,10., 9.99E-02,1.17977E+05,  2./
      DATA (u(i,2042),i=1,7)/14., 2., 6., 2., 9.04E-02,9.76534E+04,  2./
      DATA (u(i,2043),i=1,7)/14., 2., 6.,10., 4.89E-02,1.21589E+05,  2./
      DATA (u(i,2044),i=1,7)/14., 2., 6., 2., 3.41E-02,1.10732E+05,  2./
      DATA (u(i,2045),i=1,7)/14., 2., 6.,10., 2.76E-02,1.23907E+05,  2./
      DATA (u(i,2046),i=1,7)/14., 2., 6.,10., 1.71E-02,1.25480E+05,  2./
      DATA (u(i,2047),i=1,7)/14., 2., 6., 2., 1.67E-02,1.17387E+05,  2./
      DATA (u(i,2048),i=1,7)/14., 2., 6., 6., 1.62E-02,1.30627E+05,  2./
      DATA (u(i,2049),i=1,7)/14., 2., 6.,10., 1.14E-02,1.26595E+05,  2./
      DATA (u(i,2050),i=1,7)/14., 2., 6., 2., 9.53E-03,1.21253E+05,  2./
      DATA (u(i,2051),i=1,7)/14., 2., 6., 2., 6.01E-03,1.23698E+05,  2./
      DATA (u(i,2052),i=1,7)/14., 2., 6., 2., 4.05E-03,1.25340E+05,  2./
      DATA (u(i,2053),i=1,7)/14., 2., 6., 2., 2.87E-03,1.26499E+05,  2./
      DATA (u(i,2054),i=1,7)/14., 2., 6., 6., 1.17E-03,1.66387E+05,  2./
      DATA (u(i,2055),i=1,7)/14., 2., 6., 6., 1.17E-03,1.71762E+05,  2./
      DATA (u(i,2056),i=1,7)/14., 2., 6., 6., 9.23E-04,1.55579E+05,  2./
      DATA (u(i,2057),i=1,7)/14., 2., 6., 6., 8.86E-04,1.75070E+05,  2./
      DATA (u(i,2058),i=1,7)/14., 2., 6., 6., 6.63E-04,1.77217E+05,  2./
      DATA (u(i,2059),i=1,7)/14., 2., 6., 6., 5.01E-04,1.78683E+05,  2./
      DATA (u(i,2060),i=1,7)/14., 2., 6., 6., 3.85E-04,1.79733E+05,  2./
      DATA (u(i,2061),i=1,7)/14., 2., 6., 6., 3.46E-04,1.63988E+05,  2./
      DATA (u(i,2062),i=1,7)/14., 3., 1., 3., 1.56E-02,1.77113E+05,  2./
      DATA (u(i,2063),i=1,7)/14., 3., 1., 3., 1.41E-02,2.15082E+05,  2./
      DATA (u(i,2064),i=1,7)/14., 3., 1., 3., 4.85E-03,2.29442E+05,  2./
      DATA (u(i,2065),i=1,7)/14., 3., 1., 3., 2.87E-03,2.45773E+05,  2./
      DATA (u(i,2066),i=1,7)/14., 3., 1., 3., 2.17E-03,2.51984E+05,  2./
      DATA (u(i,2067),i=1,7)/14., 3., 1., 3., 1.81E-03,2.36474E+05,  3./
      DATA (u(i,2068),i=1,7)/14., 3., 1., 3., 1.58E-03,2.56141E+05,  2./
      DATA (u(i,2069),i=1,7)/14., 3., 1., 3., 1.17E-03,2.59041E+05,  2./
      DATA (u(i,2070),i=1,7)/14., 3., 1., 3., 4.18E-04,2.35877E+05,  2./
      DATA (u(i,2071),i=1,7)/14., 4., 2., 6., 7.02E-02,2.16535E+05,  2./
      DATA (u(i,2072),i=1,7)/14., 4., 2., 6., 3.20E-02,2.74251E+05,  2./
      DATA (u(i,2073),i=1,7)/14., 4., 2., 6., 1.66E-02,3.03214E+05,  2./
      DATA (u(i,2074),i=1,7)/14., 4., 2., 6., 9.70E-03,3.19795E+05,  2./
      DATA (u(i,2075),i=1,7)/14., 4., 2., 6., 6.17E-03,3.30175E+05,  2./
      DATA (u(i,2076),i=1,7)/14., 4., 2., 6., 4.17E-03,3.37109E+05,  2./
      DATA (u(i,2077),i=1,7)/14., 4., 2., 6., 2.96E-03,3.41962E+05,  2./
      DATA (u(i,2078),i=1,7)/14., 5., 1., 3., 1.09E+00,1.04657E+06, 19./
      DATA (u(i,2079),i=1,7)/14., 5., 1., 3., 4.28E-01,1.18147E+06, 20./
      DATA (u(i,2080),i=1,7)/14., 5., 1., 3., 2.50E-01,8.59919E+05, 21./
      DATA (u(i,2081),i=1,7)/14., 5., 1., 3., 2.13E-01,1.24378E+06,  2./
      DATA (u(i,2082),i=1,7)/14., 5., 1., 3., 1.23E-01,1.27747E+06,  2./
      DATA (u(i,2083),i=1,7)/14., 5., 1., 3., 7.79E-02,1.29786E+06,  2./
      DATA (u(i,2084),i=1,7)/14., 5., 1., 3., 5.33E-02,1.31113E+06,  2./
      DATA (u(i,2085),i=1,7)/14., 5., 1., 3., 4.21E-02,1.11272E+06, 22./
      DATA (u(i,2086),i=1,7)/14., 5., 1., 3., 3.86E-02,1.32013E+06,  2./
      DATA (u(i,2087),i=1,7)/14., 5., 1., 3., 2.94E-02,1.32661E+06,  2./
      DATA (u(i,2088),i=1,7)/14., 5., 1., 3., 1.59E-02,1.21095E+06,  2./
      DATA (u(i,2089),i=1,7)/14., 5., 1., 3., 7.87E-03,1.25929E+06,  2./
      DATA (u(i,2090),i=1,7)/14., 5., 1., 3., 4.52E-03,1.28684E+06,  2./
      DATA (u(i,2091),i=1,7)/14., 5., 1., 3., 2.85E-03,1.30378E+06,  2./
      DATA (u(i,2092),i=1,7)/14., 5., 1., 3., 1.93E-03,1.31510E+06,  2./
      DATA (u(i,2093),i=1,7)/14., 5., 1., 3., 1.37E-03,1.32310E+06,  2./
      DATA (u(i,2094),i=1,7)/14., 6., 6.,10., 2.53E+00,1.20005E+06,  2./
      DATA (u(i,2095),i=1,7)/14., 6., 6.,10., 2.05E+00,1.24085E+06,  2./
      DATA (u(i,2096),i=1,7)/14., 6., 6., 6., 1.98E+00,1.23916E+06,  2./
      DATA (u(i,2097),i=1,7)/14., 6., 6.,10., 1.32E+00,1.40056E+06,  2./
      DATA (u(i,2098),i=1,7)/14., 6., 6., 2., 7.19E-01,1.23671E+06,  2./
      DATA (u(i,2099),i=1,7)/14., 6., 6., 6., 7.01E-01,1.00705E+06,  2./
      DATA (u(i,2100),i=1,7)/14., 6., 6.,10., 6.90E-01,1.49432E+06,  2./
      DATA (u(i,2101),i=1,7)/14., 6., 6., 6., 5.65E-01,1.44092E+06,  2./
      DATA (u(i,2102),i=1,7)/14., 6., 6., 6., 4.96E-01,1.20034E+06,  2./
      DATA (u(i,2103),i=1,7)/14., 6., 6.,10., 4.86E-01,1.28966E+06,  2./
      DATA (u(i,2104),i=1,7)/14., 6., 6.,10., 4.85E-01,1.44134E+06,  2./
      DATA (u(i,2105),i=1,7)/14., 6., 6., 2., 4.75E-01,4.01381E+05,127./
      DATA (u(i,2106),i=1,7)/14., 6., 6.,10., 4.25E-01,1.04199E+06,  2./
      DATA (u(i,2107),i=1,7)/14., 6., 6., 6., 3.94E-01,1.39978E+06,  2./
      DATA (u(i,2108),i=1,7)/14., 6., 6.,10., 3.93E-01,1.54226E+06,  2./
      DATA (u(i,2109),i=1,7)/14., 6., 6.,10., 3.77E-01,1.45455E+06,  2./
      DATA (u(i,2110),i=1,7)/14., 6., 6., 2., 2.60E-01,1.44092E+06,  2./
      DATA (u(i,2111),i=1,7)/14., 6., 6., 6., 2.41E-01,1.45497E+06,  2./
      DATA (u(i,2112),i=1,7)/14., 6., 6., 6., 1.86E-01,1.49209E+06,  2./
      DATA (u(i,2113),i=1,7)/14., 6., 6.,10., 1.86E-01,1.58453E+06,  2./
      DATA (u(i,2114),i=1,7)/14., 6., 6., 6., 1.79E-01,1.54202E+06,  2./
      DATA (u(i,2115),i=1,7)/14., 6., 6.,10., 1.73E-01,1.57159E+06,  2./
      DATA (u(i,2116),i=1,7)/14., 6., 6., 6., 1.42E-01,1.32802E+06,  2./
      DATA (u(i,2117),i=1,7)/14., 6., 6., 6., 1.38E-01,1.53398E+06,  2./
      DATA (u(i,2118),i=1,7)/14., 6., 6.,10., 1.23E-01,1.59109E+06,  2./
      DATA (u(i,2119),i=1,7)/14., 6., 6., 6., 1.13E-01,1.58453E+06,  2./
      DATA (u(i,2120),i=1,7)/14., 6., 6., 2., 9.63E-02,1.53468E+06,  2./
      DATA (u(i,2121),i=1,7)/14., 6., 6., 2., 8.69E-02,1.48170E+06,  2./
      DATA (u(i,2122),i=1,7)/14., 6., 6., 2., 7.96E-02,1.09541E+06,  2./
      DATA (u(i,2123),i=1,7)/14., 6., 6.,10., 7.91E-02,1.53445E+06,  2./
      DATA (u(i,2124),i=1,7)/14., 6., 6., 6., 7.40E-02,1.59058E+06,  2./
      DATA (u(i,2125),i=1,7)/14., 6., 6.,10., 6.98E-02,1.36930E+06,  2./
      DATA (u(i,2126),i=1,7)/14., 6., 6., 6., 6.02E-02,1.57134E+06,  2./
      DATA (u(i,2127),i=1,7)/14., 6., 6., 2., 5.66E-02,1.58504E+06,  2./
      DATA (u(i,2128),i=1,7)/14., 6., 6.,10., 5.51E-02,1.60385E+06,  2./
      DATA (u(i,2129),i=1,7)/14., 6., 6., 6., 5.17E-02,1.45943E+06,  2./
      DATA (u(i,2130),i=1,7)/14., 6., 6.,10., 4.51E-02,1.49098E+06,  2./
      DATA (u(i,2131),i=1,7)/14., 6., 6.,10., 4.34E-02,1.58680E+06,  2./
      DATA (u(i,2132),i=1,7)/14., 6., 6.,10., 4.05E-02,1.61316E+06,  2./
      DATA (u(i,2133),i=1,7)/14., 6., 6.,10., 3.45E-02,1.56544E+06,  2./
      DATA (u(i,2134),i=1,7)/14., 6., 6., 2., 3.30E-02,1.61525E+06,  2./
      DATA (u(i,2135),i=1,7)/14., 6., 6.,10., 3.27E-02,1.60385E+06,  2./
      DATA (u(i,2136),i=1,7)/14., 6., 6., 6., 2.57E-02,1.60385E+06,  2./
      DATA (u(i,2137),i=1,7)/14., 6., 6., 2., 2.48E-02,1.42187E+06,  2./
      DATA (u(i,2138),i=1,7)/14., 6., 6., 6., 2.30E-02,1.52207E+06,  2./
      DATA (u(i,2139),i=1,7)/14., 6., 6., 2., 2.15E-02,1.63479E+06,  2./
      DATA (u(i,2140),i=1,7)/14., 6., 6., 2., 1.52E-02,1.64799E+06,  2./
      DATA (u(i,2141),i=1,7)/14., 6., 6., 6., 1.27E-02,1.59847E+06,  2./
      DATA (u(i,2142),i=1,7)/14., 6., 6., 6., 1.23E-02,1.59515E+06,  2./
      DATA (u(i,2143),i=1,7)/14., 6., 6., 6., 1.18E-02,1.55933E+06,  2./
      DATA (u(i,2144),i=1,7)/14., 6., 6., 2., 9.37E-03,1.65755E+06,  2./
      DATA (u(i,2145),i=1,7)/14., 6., 6.,10., 8.41E-03,1.50038E+06,  2./
      DATA (u(i,2146),i=1,7)/14., 6., 6., 6., 7.12E-03,1.58278E+06,  2./
      DATA (u(i,2147),i=1,7)/14., 6., 6., 6., 6.06E-03,1.60927E+06,  2./
      DATA (u(i,2148),i=1,7)/14., 6., 6., 6., 5.98E-03,1.61316E+06,  2./
      DATA (u(i,2149),i=1,7)/14., 6., 6., 2., 3.57E-03,1.59388E+06,  2./
      DATA (u(i,2150),i=1,7)/14., 6., 6., 2., 1.98E-03,1.55304E+06,  2./
      DATA (u(i,2151),i=1,7)/14., 6., 6., 2., 1.89E-03,1.65645E+06,  2./
      DATA (u(i,2152),i=1,7)/14., 6., 6., 2., 6.15E-06,1.61917E+06,  2./
      DATA (u(i,2153),i=1,7)/14., 7., 9., 9., 3.41E+00,1.43431E+06,  2./
      DATA (u(i,2154),i=1,7)/14., 7., 9.,15., 3.29E+00,1.42613E+06,  2./
      DATA (u(i,2155),i=1,7)/14., 7., 9.,15., 2.73E+00,1.46585E+06,  2./
      DATA (u(i,2156),i=1,7)/14., 7., 9.,15., 2.47E+00,1.36612E+06,  2./
      DATA (u(i,2157),i=1,7)/14., 7., 9., 9., 1.26E+00,3.60269E+05,132./
      DATA (u(i,2158),i=1,7)/14., 7., 9., 3., 1.15E+00,1.43968E+06,  2./
      DATA (u(i,2159),i=1,7)/14., 7., 9.,15., 1.05E+00,1.64042E+06,  2./
      DATA (u(i,2160),i=1,7)/14., 7., 9.,15., 9.66E-01,1.57654E+06,  2./
      DATA (u(i,2161),i=1,7)/14., 7., 9.,15., 8.26E-01,1.76522E+06,  2./
      DATA (u(i,2162),i=1,7)/14., 7., 9., 9., 7.40E-01,1.70765E+06,  2./
      DATA (u(i,2163),i=1,7)/14., 7., 9.,15., 6.59E-01,1.74095E+06,  2./
      DATA (u(i,2164),i=1,7)/14., 7., 9.,15., 6.45E-01,1.70387E+06,  2./
      DATA (u(i,2165),i=1,7)/14., 7., 9.,15., 6.36E-01,1.22820E+06,  2./
      DATA (u(i,2166),i=1,7)/14., 7., 9.,15., 5.49E-01,1.83385E+06,  2./
      DATA (u(i,2167),i=1,7)/14., 7., 9., 9., 5.37E-01,1.59058E+06,  2./
      DATA (u(i,2168),i=1,7)/14., 7., 9., 9., 4.56E-01,1.45943E+06,  2./
      DATA (u(i,2169),i=1,7)/14., 7., 9., 3., 4.30E-01,1.17578E+06,  2./
      DATA (u(i,2170),i=1,7)/14., 7., 9.,15., 3.76E-01,1.91498E+06,  2./
      DATA (u(i,2171),i=1,7)/14., 7., 9., 3., 3.71E-01,1.70911E+06,  2./
      DATA (u(i,2172),i=1,7)/14., 7., 9., 9., 3.60E-01,1.26518E+06,  2./
      DATA (u(i,2173),i=1,7)/14., 7., 9.,15., 3.22E-01,1.87301E+06,  2./
      DATA (u(i,2174),i=1,7)/14., 7., 9.,15., 2.85E-01,1.90042E+06,  2./
      DATA (u(i,2175),i=1,7)/14., 7., 9., 9., 2.34E-01,1.73853E+06,  2./
      DATA (u(i,2176),i=1,7)/14., 7., 9.,15., 2.31E-01,1.62973E+06,  2./
      DATA (u(i,2177),i=1,7)/14., 7., 9., 9., 2.29E-01,1.83150E+06,  2./
      DATA (u(i,2178),i=1,7)/14., 7., 9.,15., 2.28E-01,1.78285E+06,  2./
      DATA (u(i,2179),i=1,7)/14., 7., 9.,15., 2.15E-01,1.86811E+06,  2./
      DATA (u(i,2180),i=1,7)/14., 7., 9., 9., 2.04E-01,1.90078E+06,  2./
      DATA (u(i,2181),i=1,7)/14., 7., 9., 9., 1.95E-01,1.92345E+06,  2./
      DATA (u(i,2182),i=1,7)/14., 7., 9., 3., 1.89E-01,1.56470E+06,  2./
      DATA (u(i,2183),i=1,7)/14., 7., 9., 9., 1.77E-01,1.69837E+06,  2./
      DATA (u(i,2184),i=1,7)/14., 7., 9., 3., 1.42E-01,1.83453E+06,  2./
      DATA (u(i,2185),i=1,7)/14., 7., 9., 9., 1.33E-01,1.83453E+06,  2./
      DATA (u(i,2186),i=1,7)/14., 7., 9., 9., 1.16E-01,1.86706E+06,  2./
      DATA (u(i,2187),i=1,7)/14., 7., 9., 3., 1.12E-01,1.58579E+06,  2./
      DATA (u(i,2188),i=1,7)/14., 7., 9., 9., 1.01E-01,1.94175E+06,  2./
      DATA (u(i,2189),i=1,7)/14., 7., 9., 9., 9.34E-02,1.77809E+06,  2./
      DATA (u(i,2190),i=1,7)/14., 7., 9., 3., 7.96E-02,1.90150E+06,  2./
      DATA (u(i,2191),i=1,7)/14., 7., 9., 9., 7.47E-02,1.66583E+06,  2./
      DATA (u(i,2192),i=1,7)/14., 7., 9., 9., 6.61E-02,1.96812E+06,  2./
      DATA (u(i,2193),i=1,7)/14., 7., 9., 3., 6.13E-02,1.91718E+06,  2./
      DATA (u(i,2194),i=1,7)/14., 7., 9., 9., 5.79E-02,1.93611E+06,  2./
      DATA (u(i,2195),i=1,7)/14., 7., 9., 9., 4.99E-02,1.98610E+06,  2./
      DATA (u(i,2196),i=1,7)/14., 7., 9., 9., 3.73E-02,1.75994E+06,  2./
      DATA (u(i,2197),i=1,7)/14., 7., 9., 9., 3.53E-02,1.97746E+06,  2./
      DATA (u(i,2198),i=1,7)/14., 7., 9., 9., 3.52E-02,1.99920E+06,  2./
      DATA (u(i,2199),i=1,7)/14., 7., 9.,15., 3.17E-02,1.69148E+06,  2./
      DATA (u(i,2200),i=1,7)/14., 7., 9.,15., 3.08E-02,1.93013E+06,  2./
      DATA (u(i,2201),i=1,7)/14., 7., 9., 3., 2.99E-02,1.81258E+06,  2./
      DATA (u(i,2202),i=1,7)/14., 7., 9.,15., 2.65E-02,1.92901E+06,  2./
      DATA (u(i,2203),i=1,7)/14., 7., 9., 3., 2.44E-02,1.79888E+06,  2./
      DATA (u(i,2204),i=1,7)/14., 7., 9., 3., 1.88E-02,1.72891E+06,  2./
      DATA (u(i,2205),i=1,7)/14., 7., 9., 3., 1.52E-02,1.91095E+06,  2./
      DATA (u(i,2206),i=1,7)/14., 7., 9.,15., 1.37E-02,1.91755E+06,  2./
      DATA (u(i,2207),i=1,7)/14., 7., 9., 9., 1.15E-02,1.96541E+06,  2./
      DATA (u(i,2208),i=1,7)/14., 7., 9., 3., 1.10E-02,1.89072E+06,  2./
      DATA (u(i,2209),i=1,7)/14., 7., 9., 3., 1.09E-02,1.86047E+06,  2./
      DATA (u(i,2210),i=1,7)/14., 7., 9.,15., 8.46E-03,1.89861E+06,  2./
      DATA (u(i,2211),i=1,7)/14., 7., 9.,15., 7.38E-03,1.82949E+06,  2./
      DATA (u(i,2212),i=1,7)/14., 7., 9.,15., 4.78E-03,1.88041E+06,  2./
      DATA (u(i,2213),i=1,7)/14., 7., 9., 9., 4.27E-03,1.99601E+06,  2./
      DATA (u(i,2214),i=1,7)/14., 7., 9., 9., 4.27E-03,1.99601E+06,  2./
      DATA (u(i,2215),i=1,7)/14., 7., 9.,15., 4.19E-04,1.79759E+06,  2./
      DATA (u(i,2216),i=1,7)/14., 7., 9., 3., 2.54E-04,1.92604E+06,  2./
      DATA (u(i,2217),i=1,7)/14., 7., 9., 9., 5.19E-05,1.91644E+06,  2./
      DATA (u(i,2218),i=1,7)/14., 8., 4.,12., 6.14E+00,1.64312E+06, 98./
      DATA (u(i,2219),i=1,7)/14., 8., 4.,12., 1.26E+00,2.00361E+06,  2./
      DATA (u(i,2220),i=1,7)/14., 8., 4.,12., 7.07E-01,3.13352E+05,142./
      DATA (u(i,2221),i=1,7)/14., 8., 4.,12., 6.97E-01,1.68805E+06,  2./
      DATA (u(i,2222),i=1,7)/14., 8., 4.,12., 6.22E-01,2.16732E+06,  2./
      DATA (u(i,2223),i=1,7)/14., 8., 4.,12., 4.97E-01,1.97941E+06,  2./
      DATA (u(i,2224),i=1,7)/14., 8., 4.,12., 4.80E-01,1.44030E+06,  2./
      DATA (u(i,2225),i=1,7)/14., 8., 4.,12., 3.16E-01,2.25632E+06,  2./
      DATA (u(i,2226),i=1,7)/14., 8., 4.,12., 2.74E-01,2.09996E+06,  2./
      DATA (u(i,2227),i=1,7)/14., 8., 4.,12., 2.05E-01,2.30947E+06,  2./
      DATA (u(i,2228),i=1,7)/14., 8., 4.,12., 1.21E-01,2.34357E+06,  2./
      DATA (u(i,2229),i=1,7)/14., 8., 4.,12., 1.15E-01,1.92976E+06,  2./
      DATA (u(i,2230),i=1,7)/14., 8., 4.,12., 1.07E-01,2.28154E+06,  2./
      DATA (u(i,2231),i=1,7)/14., 8., 4.,12., 8.78E-02,2.36742E+06,  2./
      DATA (u(i,2232),i=1,7)/14., 8., 4.,12., 7.49E-02,2.37586E+06,  2./
      DATA (u(i,2233),i=1,7)/14., 8., 4.,12., 6.45E-02,1.88466E+06,  2./
      DATA (u(i,2234),i=1,7)/14., 8., 4.,12., 6.17E-02,2.38436E+06,  2./
      DATA (u(i,2235),i=1,7)/14., 8., 4.,12., 4.40E-02,2.32992E+06,  2./
      DATA (u(i,2236),i=1,7)/14., 8., 4.,12., 3.16E-02,2.13038E+06,  2./
      DATA (u(i,2237),i=1,7)/14., 8., 4.,12., 2.73E-02,2.25530E+06,  2./
      DATA (u(i,2238),i=1,7)/14., 8., 4.,12., 1.83E-02,2.29621E+06,  2./
      DATA (u(i,2239),i=1,7)/14., 8., 4.,12., 1.65E-02,2.14179E+06,  2./
      DATA (u(i,2240),i=1,7)/14., 8., 4.,12., 1.52E-02,2.23414E+06,  2./
      DATA (u(i,2241),i=1,7)/14., 8., 4.,12., 1.35E-02,2.29200E+06,  2./
      DATA (u(i,2242),i=1,7)/14., 8., 4.,12., 5.20E-03,2.37982E+06,  2./
      DATA (u(i,2243),i=1,7)/14., 8., 4.,12., 5.15E-03,2.33536E+06,  2./
      DATA (u(i,2244),i=1,7)/14., 8., 4.,12., 3.83E-03,2.36128E+06,  2./
      DATA (u(i,2245),i=1,7)/14., 8., 4.,12., 2.71E-03,1.84638E+06,  2./
      DATA (u(i,2246),i=1,7)/14., 8., 4.,12., 1.73E-04,2.30521E+06,  2./
      DATA (u(i,2247),i=1,7)/14., 9., 9.,15., 7.54E+00,1.80375E+06, 95./
      DATA (u(i,2248),i=1,7)/14., 9., 9., 9., 2.50E+00,1.80865E+06, 96./
      DATA (u(i,2249),i=1,7)/14., 9., 9.,15., 1.67E+00,2.25734E+06,  2./
      DATA (u(i,2250),i=1,7)/14., 9., 9.,15., 1.40E+00,1.88324E+06,  2./
      DATA (u(i,2251),i=1,7)/14., 9., 9., 3., 8.40E-01,4.40315E+05,125./
      DATA (u(i,2252),i=1,7)/14., 9., 9., 9., 8.17E-01,1.89789E+06,  2./
      DATA (u(i,2253),i=1,7)/14., 9., 9., 9., 6.97E-01,3.34840E+05,137./
      DATA (u(i,2254),i=1,7)/14., 9., 9.,15., 6.48E-01,2.46488E+06,  2./
      DATA (u(i,2255),i=1,7)/14., 9., 9.,15., 6.13E-01,2.82318E+05,145./
      DATA (u(i,2256),i=1,7)/14., 9., 9., 9., 5.95E-01,1.62101E+06,  2./
      DATA (u(i,2257),i=1,7)/14., 9., 9., 9., 5.58E-01,2.25887E+06,  2./
      DATA (u(i,2258),i=1,7)/14., 9., 9.,15., 3.68E-01,2.57666E+06,  2./
      DATA (u(i,2259),i=1,7)/14., 9., 9.,15., 3.47E-01,2.38493E+06,  2./
      DATA (u(i,2260),i=1,7)/14., 9., 9., 3., 3.40E-01,1.84366E+06,  2./
      DATA (u(i,2261),i=1,7)/14., 9., 9.,15., 3.40E-01,2.08812E+06,  2./
      DATA (u(i,2262),i=1,7)/14., 9., 9.,15., 3.08E-01,2.60281E+06,  2./
      DATA (u(i,2263),i=1,7)/14., 9., 9., 9., 2.51E-01,2.09644E+06,  2./
      DATA (u(i,2264),i=1,7)/14., 9., 9., 9., 2.24E-01,2.46548E+06,  2./
      DATA (u(i,2265),i=1,7)/14., 9., 9., 9., 2.12E-01,2.38834E+06,  2./
      DATA (u(i,2266),i=1,7)/14., 9., 9., 9., 2.02E-01,2.60552E+06,  2./
      DATA (u(i,2267),i=1,7)/14., 9., 9.,15., 1.90E-01,2.64410E+06,  2./
      DATA (u(i,2268),i=1,7)/14., 9., 9.,15., 1.31E-01,2.37586E+06,  2./
      DATA (u(i,2269),i=1,7)/14., 9., 9.,15., 1.25E-01,2.68745E+06,  2./
      DATA (u(i,2270),i=1,7)/14., 9., 9.,15., 1.24E-01,2.00040E+06,  2./
      DATA (u(i,2271),i=1,7)/14., 9., 9., 9., 1.18E-01,2.57666E+06,  2./
      DATA (u(i,2272),i=1,7)/14., 9., 9., 3., 1.09E-01,2.10349E+06,  2./
      DATA (u(i,2273),i=1,7)/14., 9., 9., 9., 1.07E-01,2.07684E+06,  2./
      DATA (u(i,2274),i=1,7)/14., 9., 9., 3., 9.86E-02,2.37135E+06,  2./
      DATA (u(i,2275),i=1,7)/14., 9., 9.,15., 8.84E-02,2.71739E+06,  2./
      DATA (u(i,2276),i=1,7)/14., 9., 9.,15., 8.74E-02,2.71961E+06,  2./
      DATA (u(i,2277),i=1,7)/14., 9., 9., 9., 6.66E-02,2.19058E+06,  2./
      DATA (u(i,2278),i=1,7)/14., 9., 9.,15., 6.45E-02,2.31160E+06,  2./
      DATA (u(i,2279),i=1,7)/14., 9., 9., 9., 6.31E-02,2.64410E+06,  2./
      DATA (u(i,2280),i=1,7)/14., 9., 9.,15., 6.17E-02,2.73898E+06,  2./
      DATA (u(i,2281),i=1,7)/14., 9., 9.,15., 6.10E-02,2.44978E+06,  2./
      DATA (u(i,2282),i=1,7)/14., 9., 9., 9., 5.49E-02,2.72183E+06,  2./
      DATA (u(i,2283),i=1,7)/14., 9., 9., 9., 5.45E-02,2.39120E+06,  2./
      DATA (u(i,2284),i=1,7)/14., 9., 9., 9., 5.34E-02,2.43072E+06,  2./
      DATA (u(i,2285),i=1,7)/14., 9., 9., 3., 4.89E-02,2.61438E+06,  2./
      DATA (u(i,2286),i=1,7)/14., 9., 9., 9., 4.16E-02,2.68817E+06,  2./
      DATA (u(i,2287),i=1,7)/14., 9., 9., 9., 2.84E-02,2.71739E+06,  2./
      DATA (u(i,2288),i=1,7)/14., 9., 9., 3., 2.83E-02,2.59605E+06,  2./
      DATA (u(i,2289),i=1,7)/14., 9., 9., 9., 2.16E-02,2.01491E+06,  2./
      DATA (u(i,2290),i=1,7)/14., 9., 9.,15., 2.02E-02,2.72777E+06,  2./
      DATA (u(i,2291),i=1,7)/14., 9., 9., 9., 2.00E-02,2.73898E+06,  2./
      DATA (u(i,2292),i=1,7)/14., 9., 9., 3., 1.88E-02,2.72109E+06,  2./
      DATA (u(i,2293),i=1,7)/14., 9., 9., 9., 1.59E-02,2.44141E+06,  2./
      DATA (u(i,2294),i=1,7)/14., 9., 9., 3., 1.54E-02,2.82725E+06,  2./
      DATA (u(i,2295),i=1,7)/14., 9., 9., 9., 1.48E-02,2.55689E+06,  2./
      DATA (u(i,2296),i=1,7)/14., 9., 9., 9., 1.46E-02,2.55754E+06,  2./
      DATA (u(i,2297),i=1,7)/14., 9., 9., 3., 1.23E-02,2.17628E+06,  2./
      DATA (u(i,2298),i=1,7)/14., 9., 9., 3., 1.15E-02,2.78940E+06,  2./
      DATA (u(i,2299),i=1,7)/14., 9., 9., 3., 9.32E-03,2.40038E+06,  2./
      DATA (u(i,2300),i=1,7)/14., 9., 9., 3., 7.74E-03,2.83527E+06,  2./
      DATA (u(i,2301),i=1,7)/14., 9., 9., 3., 6.20E-03,2.84091E+06,  2./
      DATA (u(i,2302),i=1,7)/14., 9., 9., 3., 6.03E-03,2.86615E+06,  2./
      DATA (u(i,2303),i=1,7)/14., 9., 9., 9., 5.72E-03,2.73523E+06,  2./
      DATA (u(i,2304),i=1,7)/14., 9., 9.,15., 5.48E-03,2.42601E+06,  2./
      DATA (u(i,2305),i=1,7)/14., 9., 9.,15., 5.44E-03,2.60688E+06,  2./
      DATA (u(i,2306),i=1,7)/14., 9., 9., 9., 5.30E-03,2.68025E+06,  2./
      DATA (u(i,2307),i=1,7)/14., 9., 9.,15., 4.88E-03,2.55363E+06,  2./
      DATA (u(i,2308),i=1,7)/14., 9., 9., 9., 4.30E-03,2.63366E+06,  2./
      DATA (u(i,2309),i=1,7)/14., 9., 9., 3., 4.09E-03,2.88850E+06,  2./
      DATA (u(i,2310),i=1,7)/14., 9., 9.,15., 3.92E-03,2.20994E+06,  2./
      DATA (u(i,2311),i=1,7)/14., 9., 9., 9., 3.79E-03,2.61028E+06,  2./
      DATA (u(i,2312),i=1,7)/14., 9., 9., 9., 3.74E-03,2.71223E+06,  2./
      DATA (u(i,2313),i=1,7)/14., 9., 9., 9., 3.11E-03,2.73000E+06,  2./
      DATA (u(i,2314),i=1,7)/14., 9., 9.,15., 2.70E-03,2.50376E+06,  2./
      DATA (u(i,2315),i=1,7)/14., 9., 9., 9., 2.08E-03,2.58532E+06,  2./
      DATA (u(i,2316),i=1,7)/14., 9., 9., 3., 1.52E-03,2.69542E+06,  2./
      DATA (u(i,2317),i=1,7)/14., 9., 9.,15., 1.39E-04,2.73224E+06,  2./
      DATA (u(i,2318),i=1,7)/14., 9., 9., 9., 8.26E-05,2.50878E+06,  2./
      DATA (u(i,2319),i=1,7)/14., 9., 9.,15., 8.10E-05,2.62467E+06,  2./
      DATA (u(i,2320),i=1,7)/14., 9., 9., 9., 5.72E-05,2.28206E+06,  2./
      DATA (u(i,2321),i=1,7)/14., 9., 9.,15., 5.21E-05,2.65604E+06,  2./
      DATA (u(i,2322),i=1,7)/14.,10., 6.,10., 3.75E+00,1.97006E+06, 93./
      DATA (u(i,2323),i=1,7)/14.,10., 6.,10., 1.41E+00,2.09424E+06,  2./
      DATA (u(i,2324),i=1,7)/14.,10., 6., 6., 1.02E+00,3.83686E+05,  3./
      DATA (u(i,2325),i=1,7)/14.,10., 6., 6., 7.87E-01,2.05255E+06,  2./
      DATA (u(i,2326),i=1,7)/14.,10., 6.,10., 7.65E-01,2.52525E+06,  2./
      DATA (u(i,2327),i=1,7)/14.,10., 6.,10., 3.84E-01,2.78079E+05,  3./
      DATA (u(i,2328),i=1,7)/14.,10., 6.,10., 3.66E-01,2.67809E+06,  2./
      DATA (u(i,2329),i=1,7)/14.,10., 6.,10., 3.02E-01,2.77932E+06,  2./
      DATA (u(i,2330),i=1,7)/14.,10., 6., 2., 2.83E-01,2.11954E+06,  2./
      DATA (u(i,2331),i=1,7)/14.,10., 6., 6., 2.42E-01,2.22420E+06,  2./
      DATA (u(i,2332),i=1,7)/14.,10., 6., 6., 2.16E-01,2.66525E+06,  2./
      DATA (u(i,2333),i=1,7)/14.,10., 6., 2., 2.05E-01,3.59997E+05,  3./
      DATA (u(i,2334),i=1,7)/14.,10., 6.,10., 1.58E-01,2.93772E+06,  2./
      DATA (u(i,2335),i=1,7)/14.,10., 6., 2., 1.46E-01,1.81554E+06,  2./
      DATA (u(i,2336),i=1,7)/14.,10., 6.,10., 1.44E-01,2.91630E+06,  2./
      DATA (u(i,2337),i=1,7)/14.,10., 6.,10., 1.13E-01,2.22370E+06,  2./
      DATA (u(i,2338),i=1,7)/14.,10., 6.,10., 9.61E-02,3.08071E+06,  2./
      DATA (u(i,2339),i=1,7)/14.,10., 6.,10., 8.87E-02,2.99940E+06,  2./
      DATA (u(i,2340),i=1,7)/14.,10., 6., 6., 8.25E-02,2.93858E+06,  2./
      DATA (u(i,2341),i=1,7)/14.,10., 6.,10., 6.85E-02,2.82406E+06,  2./
      DATA (u(i,2342),i=1,7)/14.,10., 6., 6., 6.80E-02,2.82646E+06,  2./
      DATA (u(i,2343),i=1,7)/14.,10., 6., 2., 6.55E-02,2.68745E+06,  2./
      DATA (u(i,2344),i=1,7)/14.,10., 6.,10., 5.53E-02,3.05250E+06,  2./
      DATA (u(i,2345),i=1,7)/14.,10., 6., 2., 4.66E-02,2.24165E+06,  2./
      DATA (u(i,2346),i=1,7)/14.,10., 6.,10., 4.48E-02,2.47280E+06,  2./
      DATA (u(i,2347),i=1,7)/14.,10., 6.,10., 4.27E-02,2.45399E+06,  2./
      DATA (u(i,2348),i=1,7)/14.,10., 6.,10., 4.04E-02,3.08928E+06,  2./
      DATA (u(i,2349),i=1,7)/14.,10., 6., 6., 4.01E-02,3.07692E+06,  2./
      DATA (u(i,2350),i=1,7)/14.,10., 6., 6., 3.90E-02,2.31054E+06,  2./
      DATA (u(i,2351),i=1,7)/14.,10., 6., 6., 3.59E-02,3.09406E+06,  2./
      DATA (u(i,2352),i=1,7)/14.,10., 6., 6., 3.02E-02,3.16256E+06,  2./
      DATA (u(i,2353),i=1,7)/14.,10., 6., 2., 2.78E-02,2.94464E+06,  2./
      DATA (u(i,2354),i=1,7)/14.,10., 6., 6., 2.72E-02,2.49066E+06,  2./
      DATA (u(i,2355),i=1,7)/14.,10., 6.,10., 2.58E-02,3.11526E+06,  2./
      DATA (u(i,2356),i=1,7)/14.,10., 6., 2., 2.33E-02,2.46731E+06,  2./
      DATA (u(i,2357),i=1,7)/14.,10., 6., 2., 2.15E-02,2.83046E+06,  2./
      DATA (u(i,2358),i=1,7)/14.,10., 6., 6., 1.87E-02,2.91206E+06,  2./
      DATA (u(i,2359),i=1,7)/14.,10., 6., 2., 1.82E-02,2.74876E+06,  2./
      DATA (u(i,2360),i=1,7)/14.,10., 6., 6., 1.79E-02,3.23520E+06,  2./
      DATA (u(i,2361),i=1,7)/14.,10., 6., 6., 1.55E-02,2.40674E+06,  2./
      DATA (u(i,2362),i=1,7)/14.,10., 6., 2., 1.51E-02,3.08452E+06,  2./
      DATA (u(i,2363),i=1,7)/14.,10., 6., 6., 1.41E-02,3.25521E+06,  2./
      DATA (u(i,2364),i=1,7)/14.,10., 6.,10., 1.14E-02,3.09215E+06,  2./
      DATA (u(i,2365),i=1,7)/14.,10., 6., 6., 1.09E-02,3.21647E+06,  2./
      DATA (u(i,2366),i=1,7)/14.,10., 6.,10., 1.07E-02,2.32992E+06,  2./
      DATA (u(i,2367),i=1,7)/14.,10., 6., 6., 1.04E-02,3.02024E+06,  2./
      DATA (u(i,2368),i=1,7)/14.,10., 6.,10., 1.04E-02,2.98240E+06,  2./
      DATA (u(i,2369),i=1,7)/14.,10., 6., 6., 9.41E-03,3.28192E+06,  2./
      DATA (u(i,2370),i=1,7)/14.,10., 6., 6., 7.86E-03,3.21958E+06,  2./
      DATA (u(i,2371),i=1,7)/14.,10., 6.,10., 7.26E-03,2.95858E+06,  2./
      DATA (u(i,2372),i=1,7)/14.,10., 6.,10., 6.82E-03,3.09119E+06,  2./
      DATA (u(i,2373),i=1,7)/14.,10., 6., 2., 6.68E-03,2.50188E+06,  2./
      DATA (u(i,2374),i=1,7)/14.,10., 6.,10., 6.15E-03,3.01386E+06,  2./
      DATA (u(i,2375),i=1,7)/14.,10., 6., 2., 5.67E-03,3.07125E+06,  2./
      DATA (u(i,2376),i=1,7)/14.,10., 6.,10., 5.16E-03,2.57798E+06,  2./
      DATA (u(i,2377),i=1,7)/14.,10., 6., 2., 4.87E-03,3.09885E+06,  2./
      DATA (u(i,2378),i=1,7)/14.,10., 6., 2., 3.89E-03,2.98864E+06,  2./
      DATA (u(i,2379),i=1,7)/14.,10., 6., 2., 3.87E-03,3.02115E+06,  2./
      DATA (u(i,2380),i=1,7)/14.,10., 6., 2., 2.84E-03,2.90107E+06,  2./
      DATA (u(i,2381),i=1,7)/14.,10., 6., 2., 2.46E-03,3.04507E+06,  2./
      DATA (u(i,2382),i=1,7)/14.,10., 6., 6., 2.46E-03,3.26797E+06,  2./
      DATA (u(i,2383),i=1,7)/14.,10., 6., 2., 2.39E-03,2.44081E+06,  2./
      DATA (u(i,2384),i=1,7)/14.,10., 6., 6., 1.37E-03,2.96296E+06,  2./
      DATA (u(i,2385),i=1,7)/14.,10., 6., 2., 9.98E-04,3.08356E+06,  2./
      DATA (u(i,2386),i=1,7)/14.,10., 6.,10., 5.65E-04,2.86862E+06,  2./
      DATA (u(i,2387),i=1,7)/14.,10., 6.,10., 5.35E-04,2.95596E+06,  2./
      DATA (u(i,2388),i=1,7)/14.,10., 6.,10., 3.55E-04,2.71370E+06,  2./
      DATA (u(i,2389),i=1,7)/14.,10., 6., 2., 3.35E-04,3.11236E+06,  2./
      DATA (u(i,2390),i=1,7)/14.,10., 6., 6., 7.12E-05,3.19285E+06,  2./
      DATA (u(i,2391),i=1,7)/14.,10., 6.,10., 2.40E-05,3.11139E+06,  2./
      DATA (u(i,2392),i=1,7)/14.,11., 1., 3., 5.81E-01,2.27531E+06,  2./
      DATA (u(i,2393),i=1,7)/14.,11., 1., 3., 2.62E-01,3.26137E+05,138./
      DATA (u(i,2394),i=1,7)/14.,11., 1., 3., 1.53E-01,2.97265E+06,  2./
      DATA (u(i,2395),i=1,7)/14.,11., 1., 3., 6.07E-02,3.28623E+06,  2./
      DATA (u(i,2396),i=1,7)/14.,11., 1., 3., 3.34E-02,2.57202E+06,  2./
      DATA (u(i,2397),i=1,7)/14.,11., 1., 3., 3.21E-02,3.45066E+06,  2./
      DATA (u(i,2398),i=1,7)/14.,11., 1., 3., 2.02E-02,2.44499E+06,  2./
      DATA (u(i,2399),i=1,7)/14.,11., 1., 3., 1.93E-02,3.55366E+06,  2./
      DATA (u(i,2400),i=1,7)/14.,11., 1., 3., 1.46E-02,3.19898E+06,  2./
      DATA (u(i,2401),i=1,7)/14.,11., 1., 3., 1.33E-02,3.61794E+06,  2./
      DATA (u(i,2402),i=1,7)/14.,11., 1., 3., 7.37E-03,3.66300E+06,  2./
      DATA (u(i,2403),i=1,7)/14.,11., 1., 3., 6.23E-03,3.69413E+06,  2./
      DATA (u(i,2404),i=1,7)/14.,11., 1., 3., 3.99E-03,3.49284E+06,  2./
      DATA (u(i,2405),i=1,7)/14.,11., 1., 3., 3.87E-03,3.65364E+06,  2./
      DATA (u(i,2406),i=1,7)/14.,11., 1., 3., 3.61E-03,3.46741E+06,  2./
      DATA (u(i,2407),i=1,7)/14.,11., 1., 3., 4.13E-05,3.14465E+06,  2./
      DATA (u(i,2408),i=1,7)/14.,11., 1., 3., 1.15E-07,3.63769E+06,  2./
      DATA (u(i,2409),i=1,7)/14.,12., 2., 6., 1.76E-01,3.21234E+06, 18./
      DATA (u(i,2410),i=1,7)/14.,12., 2., 6., 7.39E-02,3.57143E+06, 18./
      DATA (u(i,2411),i=1,7)/14.,12., 2., 6., 3.86E-02,3.76648E+06, 18./
      DATA (u(i,2412),i=1,7)/14.,12., 2., 6., 2.29E-02,3.88350E+06, 18./
      DATA (u(i,2413),i=1,7)/14.,12., 2., 6., 1.48E-02,3.96040E+06, 18./
      DATA (u(i,2414),i=1,7)/14.,12., 2., 6., 1.01E-02,4.01123E+06, 18./
      DATA (u(i,2415),i=1,7)/14.,12., 2., 6., 7.25E-03,4.04858E+06, 18./
      DATA (u(i,2416),i=1,7)/14.,13., 1., 3.,-1.78E+07,1.48359E+07, 47./
      DATA (u(i,2417),i=1,7)/14.,13., 1., 3., 3.16E-03,1.49540E+07, 46./
      DATA (u(i,2418),i=1,7)/14.,13., 1., 3., 7.55E-01,1.49925E+07, 44./
      DATA (u(i,2419),i=1,7)/14.,13., 1., 3., 1.52E-01,1.75439E+07, 41./
      DATA (u(i,2420),i=1,7)/14.,13., 1., 3., 5.67E-02,1.84502E+07, 40./
      DATA (u(i,2421),i=1,7)/14.,13., 1., 3., 2.74E-02,1.88679E+07, 13./
      DATA (u(i,2422),i=1,7)/14.,13., 1., 3., 1.54E-02,1.90840E+07, 13./
      DATA (u(i,2423),i=1,7)/14.,13., 1., 3., 9.52E-03,1.92308E+07, 13./
      DATA (u(i,2424),i=1,7)/14.,13., 1., 3., 6.31E-03,1.93050E+07, 13./
      DATA (u(i,2425),i=1,7)/14.,13., 1., 3., 4.40E-03,1.93798E+07, 13./
      DATA (u(i,2426),i=1,7)/14.,13., 1., 3., 3.19E-03,1.94175E+07, 13./
      DATA (u(i,2427),i=1,7)/14.,14., 2., 2.,-3.16E+05,1.61665E+07, 43./
      DATA (u(i,2428),i=1,7)/14.,14., 2., 6., 8.32E-01,1.61290E+07, 42./
      DATA (u(i,2429),i=1,7)/14.,14., 2., 6., 1.58E-01,1.91205E+07,  5./
      DATA (u(i,2430),i=1,7)/14.,14., 2., 6., 5.80E-02,2.01613E+07,  6./
      DATA (u(i,2431),i=1,7)/14.,14., 2., 6., 2.79E-02,2.06186E+07,  7./
      DATA (u(i,2432),i=1,7)/14.,14., 2., 6., 1.56E-02,2.09205E+07,  8./
      DATA (u(i,2433),i=1,7)/14.,14., 2., 6., 9.63E-03,2.10526E+07,  9./
      DATA (u(i,2434),i=1,7)/14.,14., 2., 6., 6.37E-03,2.11416E+07,  9./
      DATA (u(i,2435),i=1,7)/14.,14., 2., 6., 4.43E-03,2.12314E+07,  9./
      DATA (u(i,2436),i=1,7)/14.,14., 2., 6., 3.21E-03,2.12766E+07,  9./
      DATA (u(i,2437),i=1,7)/16., 1., 9.,15., 1.36E+00,7.37436E+04, 0.1/
      DATA (u(i,2438),i=1,7)/16., 1., 9., 9., 1.06E+00,8.15003E+04,  1./
      DATA (u(i,2439),i=1,7)/16., 1., 9., 3., 8.27E-01,6.01623E+04,  1./
      DATA (u(i,2440),i=1,7)/16., 1., 9.,15., 3.90E-01,7.18262E+04,  1./
      DATA (u(i,2441),i=1,7)/16., 1., 9., 9., 2.68E-01,9.85076E+04,  1./
      DATA (u(i,2442),i=1,7)/16., 1., 9.,15., 2.52E-01,7.90520E+04,  1./
      DATA (u(i,2443),i=1,7)/16., 1., 9., 9., 1.82E-01,8.98828E+04, 0.1/
      DATA (u(i,2444),i=1,7)/16., 1., 9., 9., 1.74E-01,9.75952E+04, 0.1/
      DATA (u(i,2445),i=1,7)/16., 1., 9., 9., 1.55E-01,9.87586E+04,  1./
      DATA (u(i,2446),i=1,7)/16., 1., 9., 9., 1.37E-01,9.47472E+04,  1./
      DATA (u(i,2447),i=1,7)/16., 1., 9., 3., 1.34E-01,7.48548E+04,  1./
      DATA (u(i,2448),i=1,7)/16., 1., 9., 3., 4.32E-02,7.99731E+04,  1./
      DATA (u(i,2449),i=1,7)/16., 1., 9.,15., 3.87E-02,8.17281E+04,  1./
      DATA (u(i,2450),i=1,7)/16., 1., 9., 9., 2.68E-02,9.93206E+04,  1./
      DATA (u(i,2451),i=1,7)/16., 1., 9., 9., 2.54E-02,9.98223E+04,  1./
      DATA (u(i,2452),i=1,7)/16., 1., 9., 9., 1.94E-02,1.00173E+05,  1./
      DATA (u(i,2453),i=1,7)/16., 1., 9., 3., 1.87E-02,8.23567E+04,  1./
      DATA (u(i,2454),i=1,7)/16., 1., 9.,15., 1.86E-02,8.54299E+04,  1./
      DATA (u(i,2455),i=1,7)/16., 1., 9.,15., 1.69E-02,8.51361E+04,  1./
      DATA (u(i,2456),i=1,7)/16., 1., 9.,15., 1.19E-02,8.47264E+04,  1./
      DATA (u(i,2457),i=1,7)/16., 1., 9., 3., 9.50E-03,8.36582E+04,  1./
      DATA (u(i,2458),i=1,7)/16., 1., 9., 9., 7.63E-03,9.69359E+04,  1./
      DATA (u(i,2459),i=1,7)/16., 1., 9., 3., 5.39E-03,8.44466E+04,  1./
      DATA (u(i,2460),i=1,7)/16., 1., 9., 9., 4.47E-03,7.05169E+04, 0.1/
      DATA (u(i,2461),i=1,7)/16., 1., 9.,15., 3.90E-03,8.41305E+04,  1./
      DATA (u(i,2462),i=1,7)/16., 1., 9., 3., 3.32E-03,8.49596E+04,  1./
      DATA (u(i,2463),i=1,7)/16., 1., 9., 3., 2.17E-03,8.53126E+04,  1./
      DATA (u(i,2464),i=1,7)/16., 1., 9.,15., 8.28E-04,8.32189E+04,  1./
      DATA (u(i,2465),i=1,7)/16., 2., 4.,12., 9.72E+00,1.33276E+05,  3./
      DATA (u(i,2466),i=1,7)/16., 2., 4.,12., 2.11E+00,1.58050E+05,  2./
      DATA (u(i,2467),i=1,7)/16., 2., 4.,12., 1.53E+00,1.12557E+05,  2./
      DATA (u(i,2468),i=1,7)/16., 2., 4.,12., 6.70E-01,1.70184E+05,  2./
      DATA (u(i,2469),i=1,7)/16., 2., 4.,12., 2.91E-01,1.76638E+05,  2./
      DATA (u(i,2470),i=1,7)/16., 2., 4.,12., 2.24E-01,1.52739E+05,  2./
      DATA (u(i,2471),i=1,7)/16., 2., 4.,12., 1.51E-01,1.80457E+05,  2./
      DATA (u(i,2472),i=1,7)/16., 2., 4.,12., 8.80E-02,1.82892E+05,  2./
      DATA (u(i,2473),i=1,7)/16., 2., 4.,12., 6.21E-02,1.68047E+05,  2./
      DATA (u(i,2474),i=1,7)/16., 2., 4.,12., 5.57E-02,1.84539E+05,  2./
      DATA (u(i,2475),i=1,7)/16., 2., 4.,12., 3.75E-02,1.85704E+05,  2./
      DATA (u(i,2476),i=1,7)/16., 2., 4.,12., 2.97E-02,1.75586E+05,  2./
      DATA (u(i,2477),i=1,7)/16., 2., 4.,12., 1.67E-02,1.79866E+05,  2./
      DATA (u(i,2478),i=1,7)/16., 2., 4.,12., 1.03E-02,1.82528E+05,  2./
      DATA (u(i,2479),i=1,7)/16., 2., 4.,12., 6.81E-03,1.84301E+05,  2./
      DATA (u(i,2480),i=1,7)/16., 2., 4.,12., 4.74E-03,1.85539E+05,  2./
      DATA (u(i,2481),i=1,7)/16., 3., 9.,15., 1.50E+01,1.49914E+05,  3./
      DATA (u(i,2482),i=1,7)/16., 3., 9., 9., 7.13E+00,1.44672E+05,  2./
      DATA (u(i,2483),i=1,7)/16., 3., 9., 3., 3.26E+00,1.42001E+05,  3./
      DATA (u(i,2484),i=1,7)/16., 3., 9., 9., 6.24E-01,1.48918E+05,  3./
      DATA (u(i,2485),i=1,7)/16., 3., 9.,15., 5.23E-01,2.07409E+05,  2./
      DATA (u(i,2486),i=1,7)/16., 3., 9., 9., 3.84E-01,9.92713E+04,  3./
      DATA (u(i,2487),i=1,7)/16., 3., 9., 9., 2.44E-01,2.10855E+05,  2./
      DATA (u(i,2488),i=1,7)/16., 3., 9., 9., 1.61E-01,2.08281E+05,  2./
      DATA (u(i,2489),i=1,7)/16., 3., 9., 9., 1.00E-01,2.37682E+05,  2./
      DATA (u(i,2490),i=1,7)/16., 3., 9.,15., 6.63E-02,2.35599E+05,  2./
      DATA (u(i,2491),i=1,7)/16., 3., 9., 9., 3.06E-02,2.51851E+05,  2./
      DATA (u(i,2492),i=1,7)/16., 3., 9., 9., 2.73E-02,2.59882E+05,  2./
      DATA (u(i,2493),i=1,7)/16., 3., 9., 9., 2.28E-02,2.51370E+05,  2./
      DATA (u(i,2494),i=1,7)/16., 3., 9., 9., 1.85E-02,2.36278E+05,  2./
      DATA (u(i,2495),i=1,7)/16., 3., 9., 9., 1.71E-02,2.65097E+05,  2./
      DATA (u(i,2496),i=1,7)/16., 3., 9.,15., 1.50E-02,2.51042E+05,  2./
      DATA (u(i,2497),i=1,7)/16., 3., 9., 9., 1.10E-02,2.68622E+05,  2./
      DATA (u(i,2498),i=1,7)/16., 3., 9., 9., 8.00E-03,2.71223E+05,  2./
      DATA (u(i,2499),i=1,7)/16., 3., 9.,15., 4.84E-03,2.59276E+05,  2./
      DATA (u(i,2500),i=1,7)/16., 3., 9., 3., 3.80E-03,2.88101E+05,  2./
      DATA (u(i,2501),i=1,7)/16., 3., 9., 3., 1.94E-03,3.09511E+05,  2./
      DATA (u(i,2502),i=1,7)/16., 3., 9.,15., 1.94E-03,2.66042E+05,  2./
      DATA (u(i,2503),i=1,7)/16., 3., 9., 9., 1.92E-03,2.59430E+05,  2./
      DATA (u(i,2504),i=1,7)/16., 3., 9.,15., 1.64E-03,2.64669E+05,  2./
      DATA (u(i,2505),i=1,7)/16., 3., 9., 3., 1.55E-03,3.22331E+05,  2./
      DATA (u(i,2506),i=1,7)/16., 3., 9., 9., 1.53E-03,2.49116E+05,  2./
      DATA (u(i,2507),i=1,7)/16., 3., 9., 3., 1.21E-03,3.34426E+05,  2./
      DATA (u(i,2508),i=1,7)/16., 3., 9., 3., 8.80E-04,3.29359E+05,  2./
      DATA (u(i,2509),i=1,7)/16., 3., 9.,15., 8.39E-04,2.68327E+05,  2./
      DATA (u(i,2510),i=1,7)/16., 3., 9., 9., 7.45E-04,2.71039E+05,  2./
      DATA (u(i,2511),i=1,7)/16., 3., 9., 9., 7.08E-04,2.64767E+05,  2./
      DATA (u(i,2512),i=1,7)/16., 3., 9., 3., 6.53E-04,3.37291E+05,  2./
      DATA (u(i,2513),i=1,7)/16., 3., 9., 9., 4.40E-04,2.68384E+05,  2./
      DATA (u(i,2514),i=1,7)/16., 3., 9., 3., 4.25E-04,3.13765E+05,  2./
      DATA (u(i,2515),i=1,7)/16., 3., 9.,15., 3.87E-04,2.70907E+05,  2./
      DATA (u(i,2516),i=1,7)/16., 3., 9., 3., 1.64E-04,2.38783E+05,  2./
      DATA (u(i,2517),i=1,7)/16., 3., 9., 3., 8.73E-06,3.33433E+05,  2./
      DATA (u(i,2518),i=1,7)/16., 3., 9., 9., 3.50E-06,2.70555E+05,  2./
      DATA (u(i,2519),i=1,7)/16., 3., 9.,15., 1.51E-06,2.45857E+05,  2./
      DATA (u(i,2520),i=1,7)/16., 4., 6.,10., 7.10E+00,1.52655E+05,  3./
      DATA (u(i,2521),i=1,7)/16., 4., 6., 6., 4.57E+00,1.35630E+05,170./
      DATA (u(i,2522),i=1,7)/16., 4., 6., 2., 6.31E-01,1.25183E+05,  3./
      DATA (u(i,2523),i=1,7)/16., 4., 6., 2., 5.24E-01,1.82103E+05,  2./
      DATA (u(i,2524),i=1,7)/16., 4., 6.,10., 2.86E-01,9.20581E+04,187./
      DATA (u(i,2525),i=1,7)/16., 4., 6.,10., 1.17E-01,3.02929E+05,  2./
      DATA (u(i,2526),i=1,7)/16., 4., 6., 2., 9.57E-02,2.70270E+05,  2./
      DATA (u(i,2527),i=1,7)/16., 4., 6., 6., 8.36E-02,2.93032E+05,  2./
      DATA (u(i,2528),i=1,7)/16., 4., 6.,10., 5.34E-02,3.38639E+05,  2./
      DATA (u(i,2529),i=1,7)/16., 4., 6., 2., 5.32E-02,3.10646E+05,  2./
      DATA (u(i,2530),i=1,7)/16., 4., 6., 6., 4.92E-02,3.64964E+05,  2./
      DATA (u(i,2531),i=1,7)/16., 4., 6.,10., 3.26E-02,3.26392E+05,  2./
      DATA (u(i,2532),i=1,7)/16., 4., 6., 2., 2.04E-02,3.31598E+05,  2./
      DATA (u(i,2533),i=1,7)/16., 4., 6., 6., 1.75E-02,3.40646E+05,  2./
      DATA (u(i,2534),i=1,7)/16., 4., 6., 6., 1.35E-02,4.19586E+05,  2./
      DATA (u(i,2535),i=1,7)/16., 4., 6., 2., 1.24E-02,3.43548E+05,  2./
      DATA (u(i,2536),i=1,7)/16., 4., 6., 6., 1.13E-02,3.91573E+05,  2./
      DATA (u(i,2537),i=1,7)/16., 4., 6.,10., 9.00E-03,3.01060E+05,  2./
      DATA (u(i,2538),i=1,7)/16., 4., 6., 6., 7.90E-03,4.30812E+05,  2./
      DATA (u(i,2539),i=1,7)/16., 4., 6., 6., 7.72E-03,4.44385E+05,  2./
      DATA (u(i,2540),i=1,7)/16., 4., 6., 6., 7.56E-03,4.01962E+05,  2./
      DATA (u(i,2541),i=1,7)/16., 4., 6., 6., 7.33E-03,4.11556E+05,  2./
      DATA (u(i,2542),i=1,7)/16., 4., 6., 2., 5.90E-03,3.53070E+05,  2./
      DATA (u(i,2543),i=1,7)/16., 4., 6., 6., 5.16E-03,4.38327E+05,  2./
      DATA (u(i,2544),i=1,7)/16., 4., 6.,10., 3.89E-03,3.57475E+05,  2./
      DATA (u(i,2545),i=1,7)/16., 4., 6.,10., 2.99E-03,3.61886E+05,  2./
      DATA (u(i,2546),i=1,7)/16., 4., 6.,10., 2.94E-03,3.51284E+05,  2./
      DATA (u(i,2547),i=1,7)/16., 4., 6., 2., 2.76E-03,3.58641E+05,  3./
      DATA (u(i,2548),i=1,7)/16., 4., 6., 6., 2.09E-03,3.57003E+05,  3./
      DATA (u(i,2549),i=1,7)/16., 4., 6.,10., 1.80E-03,3.43206E+05,  2./
      DATA (u(i,2550),i=1,7)/16., 4., 6., 6., 1.54E-03,4.43498E+05,  2./
      DATA (u(i,2551),i=1,7)/16., 4., 6., 2., 1.50E-03,3.58899E+05,  2./
      DATA (u(i,2552),i=1,7)/16., 4., 6., 2., 1.29E-03,3.45507E+05,  2./
      DATA (u(i,2553),i=1,7)/16., 4., 6.,10., 1.03E-03,3.54547E+05,  2./
      DATA (u(i,2554),i=1,7)/16., 4., 6., 6., 4.10E-04,4.34160E+05,  3./
      DATA (u(i,2555),i=1,7)/16., 4., 6.,10., 3.08E-04,2.54537E+05,  2./
      DATA (u(i,2556),i=1,7)/16., 4., 6., 2., 1.92E-04,3.09195E+05,  2./
      DATA (u(i,2557),i=1,7)/16., 4., 6.,10., 8.98E-05,3.36225E+05,  3./
      DATA (u(i,2558),i=1,7)/16., 4., 6., 6., 9.48E-08,3.20585E+05,  3./
      DATA (u(i,2559),i=1,7)/16., 5., 1., 3., 9.84E-02,3.49858E+05,  2./
      DATA (u(i,2560),i=1,7)/16., 5., 1., 3., 3.09E-02,4.48893E+05,  2./
      DATA (u(i,2561),i=1,7)/16., 5., 1., 3., 2.01E-02,4.93340E+05,  2./
      DATA (u(i,2562),i=1,7)/16., 5., 1., 3., 1.12E-02,5.20021E+05,  2./
      DATA (u(i,2563),i=1,7)/16., 5., 1., 3., 7.89E-03,4.25206E+05,  2./
      DATA (u(i,2564),i=1,7)/16., 5., 1., 3., 6.83E-03,5.35475E+05,  2./
      DATA (u(i,2565),i=1,7)/16., 5., 1., 3., 4.47E-03,5.47705E+05,  2./
      DATA (u(i,2566),i=1,7)/16., 5., 1., 3., 3.44E-03,5.55216E+05,  2./
      DATA (u(i,2567),i=1,7)/16., 5., 1., 3., 2.19E-03,3.81723E+05,  3./
      DATA (u(i,2568),i=1,7)/16., 5., 1., 3., 3.99E-04,5.11274E+05,  2./
      DATA (u(i,2569),i=1,7)/16., 5., 1., 3., 3.25E-04,5.39636E+05,  2./
      DATA (u(i,2570),i=1,7)/16., 6., 2., 6., 1.63E-01,3.98565E+05,  2./
      DATA (u(i,2571),i=1,7)/16., 6., 2., 6., 6.24E-02,5.18565E+05,  2./
      DATA (u(i,2572),i=1,7)/16., 6., 2., 6., 3.07E-02,5.79777E+05,  2./
      DATA (u(i,2573),i=1,7)/16., 6., 2., 6., 1.75E-02,6.15195E+05,  2./
      DATA (u(i,2574),i=1,7)/16., 6., 2., 6., 1.10E-02,6.37552E+05,  2./
      DATA (u(i,2575),i=1,7)/16., 6., 2., 6., 7.38E-03,6.52571E+05,  2./
      DATA (u(i,2576),i=1,7)/16., 6., 2., 6., 5.21E-03,6.63130E+05,  2./
      DATA (u(i,2577),i=1,7)/16., 7., 1., 3., 1.61E+00,1.67140E+06, 19./
      DATA (u(i,2578),i=1,7)/16., 7., 1., 3., 6.10E-01,1.93573E+06, 20./
      DATA (u(i,2579),i=1,7)/16., 7., 1., 3., 2.45E-01,1.39880E+06, 21./
      DATA (u(i,2580),i=1,7)/16., 7., 1., 3., 2.20E-01,2.05888E+06,  2./
      DATA (u(i,2581),i=1,7)/16., 7., 1., 3., 1.34E-01,2.12495E+06,  2./
      DATA (u(i,2582),i=1,7)/16., 7., 1., 3., 1.31E-01,2.00844E+06,  2./
      DATA (u(i,2583),i=1,7)/16., 7., 1., 3., 8.36E-02,2.16497E+06,  2./
      DATA (u(i,2584),i=1,7)/16., 7., 1., 3., 6.44E-02,2.01005E+06,  2./
      DATA (u(i,2585),i=1,7)/16., 7., 1., 3., 5.54E-02,2.19106E+06,  2./
      DATA (u(i,2586),i=1,7)/16., 7., 1., 3., 4.44E-02,1.83385E+06, 22./
      DATA (u(i,2587),i=1,7)/16., 7., 1., 3., 3.86E-02,2.20848E+06,  2./
      DATA (u(i,2588),i=1,7)/16., 7., 1., 3., 2.79E-02,2.22124E+06,  2./
      DATA (u(i,2589),i=1,7)/16., 7., 1., 3., 7.50E-03,2.09732E+06,  2./
      DATA (u(i,2590),i=1,7)/16., 7., 1., 3., 4.43E-03,2.14777E+06,  2./
      DATA (u(i,2591),i=1,7)/16., 7., 1., 3., 2.82E-03,2.17960E+06,  2./
      DATA (u(i,2592),i=1,7)/16., 7., 1., 3., 1.91E-03,2.20070E+06,  2./
      DATA (u(i,2593),i=1,7)/16., 7., 1., 3., 1.36E-03,2.21582E+06,  2./
      DATA (u(i,2594),i=1,7)/16., 8., 6.,10., 3.30E+00,1.89143E+06,  2./
      DATA (u(i,2595),i=1,7)/16., 8., 6., 6., 2.80E+00,1.89000E+06,  2./
      DATA (u(i,2596),i=1,7)/16., 8., 6.,10., 2.56E+00,1.84060E+06,  2./
      DATA (u(i,2597),i=1,7)/16., 8., 6.,10., 1.08E+00,2.20022E+06,  2./
      DATA (u(i,2598),i=1,7)/16., 8., 6., 2., 8.75E-01,1.88288E+06,  2./
      DATA (u(i,2599),i=1,7)/16., 8., 6.,10., 6.96E-01,1.94742E+06,  2./
      DATA (u(i,2600),i=1,7)/16., 8., 6., 6., 6.75E-01,1.58178E+06,  2./
      DATA (u(i,2601),i=1,7)/16., 8., 6.,10., 6.71E-01,2.36239E+06,  2./
      DATA (u(i,2602),i=1,7)/16., 8., 6., 6., 6.59E-01,2.24719E+06,  2./
      DATA (u(i,2603),i=1,7)/16., 8., 6.,10., 5.93E-01,2.24770E+06,  2./
      DATA (u(i,2604),i=1,7)/16., 8., 6.,10., 5.63E-01,2.13721E+06,  2./
      DATA (u(i,2605),i=1,7)/16., 8., 6., 2., 4.29E-01,4.92320E+05,  3./
      DATA (u(i,2606),i=1,7)/16., 8., 6.,10., 4.16E-01,1.62364E+06,  2./
      DATA (u(i,2607),i=1,7)/16., 8., 6., 6., 3.95E-01,1.83891E+06,  2./
      DATA (u(i,2608),i=1,7)/16., 8., 6., 6., 3.92E-01,2.14316E+06,  2./
      DATA (u(i,2609),i=1,7)/16., 8., 6.,10., 3.60E-01,2.44978E+06,  2./
      DATA (u(i,2610),i=1,7)/16., 8., 6.,10., 3.26E-01,2.15008E+06,  2./
      DATA (u(i,2611),i=1,7)/16., 8., 6., 6., 3.11E-01,2.19780E+06,  2./
      DATA (u(i,2612),i=1,7)/16., 8., 6.,10., 3.09E-01,2.50376E+06,  2./
      DATA (u(i,2613),i=1,7)/16., 8., 6., 6., 2.30E-01,2.41255E+06,  2./
      DATA (u(i,2614),i=1,7)/16., 8., 6., 2., 2.05E-01,2.24770E+06,  2./
      DATA (u(i,2615),i=1,7)/16., 8., 6., 6., 2.03E-01,2.36128E+06,  2./
      DATA (u(i,2616),i=1,7)/16., 8., 6.,10., 2.00E-01,2.29621E+06,  2./
      DATA (u(i,2617),i=1,7)/16., 8., 6., 6., 1.89E-01,2.09820E+06,  2./
      DATA (u(i,2618),i=1,7)/16., 8., 6., 6., 1.87E-01,2.50376E+06,  2./
      DATA (u(i,2619),i=1,7)/16., 8., 6., 2., 1.82E-01,2.17250E+06,  2./
      DATA (u(i,2620),i=1,7)/16., 8., 6.,10., 1.67E-01,2.41313E+06,  2./
      DATA (u(i,2621),i=1,7)/16., 8., 6.,10., 1.46E-01,2.53678E+06,  2./
      DATA (u(i,2622),i=1,7)/16., 8., 6., 6., 1.36E-01,2.44978E+06,  2./
      DATA (u(i,2623),i=1,7)/16., 8., 6.,10., 1.33E-01,2.31000E+06,  2./
      DATA (u(i,2624),i=1,7)/16., 8., 6.,10., 1.17E-01,2.56016E+06,  2./
      DATA (u(i,2625),i=1,7)/16., 8., 6., 2., 1.10E-01,2.41255E+06,  2./
      DATA (u(i,2626),i=1,7)/16., 8., 6.,10., 9.79E-02,2.57732E+06,  2./
      DATA (u(i,2627),i=1,7)/16., 8., 6., 2., 7.80E-02,1.68862E+06,  2./
      DATA (u(i,2628),i=1,7)/16., 8., 6.,10., 7.80E-02,2.47525E+06,  2./
      DATA (u(i,2629),i=1,7)/16., 8., 6., 6., 7.29E-02,2.31374E+06,  2./
      DATA (u(i,2630),i=1,7)/16., 8., 6., 2., 5.88E-02,2.50188E+06,  2./
      DATA (u(i,2631),i=1,7)/16., 8., 6.,10., 5.79E-02,2.56608E+06,  2./
      DATA (u(i,2632),i=1,7)/16., 8., 6., 6., 5.61E-02,2.56016E+06,  2./
      DATA (u(i,2633),i=1,7)/16., 8., 6., 6., 5.23E-02,2.55558E+06,  2./
      DATA (u(i,2634),i=1,7)/16., 8., 6., 6., 4.74E-02,2.53678E+06,  2./
      DATA (u(i,2635),i=1,7)/16., 8., 6.,10., 4.01E-02,2.55558E+06,  2./
      DATA (u(i,2636),i=1,7)/16., 8., 6., 2., 3.59E-02,2.55558E+06,  2./
      DATA (u(i,2637),i=1,7)/16., 8., 6.,10., 3.50E-02,2.47647E+06,  2./
      DATA (u(i,2638),i=1,7)/16., 8., 6., 2., 3.36E-02,2.21288E+06,  2./
      DATA (u(i,2639),i=1,7)/16., 8., 6., 2., 3.20E-02,2.59000E+06,  2./
      DATA (u(i,2640),i=1,7)/16., 8., 6., 2., 2.97E-02,2.59605E+06,  2./
      DATA (u(i,2641),i=1,7)/16., 8., 6., 6., 2.92E-02,2.57666E+06,  2./
      DATA (u(i,2642),i=1,7)/16., 8., 6., 6., 1.81E-02,2.30574E+06,  2./
      DATA (u(i,2643),i=1,7)/16., 8., 6., 6., 1.69E-02,2.42248E+06,  2./
      DATA (u(i,2644),i=1,7)/16., 8., 6., 6., 1.65E-02,2.48571E+06,  2./
      DATA (u(i,2645),i=1,7)/16., 8., 6., 2., 1.33E-02,2.61438E+06,  2./
      DATA (u(i,2646),i=1,7)/16., 8., 6., 2., 1.22E-02,2.63089E+06,  2./
      DATA (u(i,2647),i=1,7)/16., 8., 6., 6., 1.11E-02,2.55232E+06,  2./
      DATA (u(i,2648),i=1,7)/16., 8., 6., 6., 9.83E-03,2.52589E+06,  2./
      DATA (u(i,2649),i=1,7)/16., 8., 6., 6., 7.85E-03,2.57136E+06,  2./
      DATA (u(i,2650),i=1,7)/16., 8., 6., 6., 5.80E-03,2.50062E+06,  2./
      DATA (u(i,2651),i=1,7)/16., 8., 6.,10., 5.68E-03,2.50125E+06,  2./
      DATA (u(i,2652),i=1,7)/16., 8., 6.,10., 3.27E-03,2.53936E+06,  2./
      DATA (u(i,2653),i=1,7)/16., 8., 6., 2., 2.03E-03,2.60417E+06,  2./
      DATA (u(i,2654),i=1,7)/16., 8., 6., 2., 1.95E-03,2.31054E+06,  2./
      DATA (u(i,2655),i=1,7)/16., 8., 6., 2., 1.19E-03,2.54001E+06,  2./
      DATA (u(i,2656),i=1,7)/16., 8., 6., 2., 1.85E-04,2.43072E+06,  2./
      DATA (u(i,2657),i=1,7)/16., 8., 6.,10., 8.70E-05,2.36630E+06,  2./
      DATA (u(i,2658),i=1,7)/16., 9., 9.,15., 4.03E+00,2.10305E+06,  2./
      DATA (u(i,2659),i=1,7)/16., 9., 9., 9., 3.94E+00,2.11282E+06,  2./
      DATA (u(i,2660),i=1,7)/16., 9., 9.,15., 3.63E+00,2.15100E+06,  2./
      DATA (u(i,2661),i=1,7)/16., 9., 9.,15., 2.40E+00,2.03087E+06,  2./
      DATA (u(i,2662),i=1,7)/16., 9., 9., 3., 1.33E+00,2.12134E+06,  2./
      DATA (u(i,2663),i=1,7)/16., 9., 9.,15., 1.14E+00,2.48386E+06,  2./
      DATA (u(i,2664),i=1,7)/16., 9., 9., 9., 1.12E+00,4.37082E+05,124./
      DATA (u(i,2665),i=1,7)/16., 9., 9.,15., 1.03E+00,2.27998E+06,  2./
      DATA (u(i,2666),i=1,7)/16., 9., 9., 9., 7.97E-01,2.56476E+06,  2./
      DATA (u(i,2667),i=1,7)/16., 9., 9.,15., 7.60E-01,2.60620E+06,  2./
      DATA (u(i,2668),i=1,7)/16., 9., 9.,15., 6.80E-01,2.55885E+06,  2./
      DATA (u(i,2669),i=1,7)/16., 9., 9.,15., 6.80E-01,2.69034E+06,  2./
      DATA (u(i,2670),i=1,7)/16., 9., 9.,15., 6.49E-01,2.81452E+06,  2./
      DATA (u(i,2671),i=1,7)/16., 9., 9., 9., 6.31E-01,2.29674E+06,  2./
      DATA (u(i,2672),i=1,7)/16., 9., 9.,15., 6.18E-01,1.84809E+06,  2./
      DATA (u(i,2673),i=1,7)/16., 9., 9., 9., 4.40E-01,2.14133E+06,  2./
      DATA (u(i,2674),i=1,7)/16., 9., 9.,15., 4.30E-01,2.52525E+06,  2./
      DATA (u(i,2675),i=1,7)/16., 9., 9., 3., 4.10E-01,1.78635E+06,  2./
      DATA (u(i,2676),i=1,7)/16., 9., 9.,15., 3.57E-01,2.80112E+06,  2./
      DATA (u(i,2677),i=1,7)/16., 9., 9., 9., 3.49E-01,1.89394E+06,  2./
      DATA (u(i,2678),i=1,7)/16., 9., 9., 3., 3.01E-01,2.56871E+06,  2./
      DATA (u(i,2679),i=1,7)/16., 9., 9., 3., 2.90E-01,2.28728E+06,  2./
      DATA (u(i,2680),i=1,7)/16., 9., 9., 9., 2.72E-01,2.77239E+06,  2./
      DATA (u(i,2681),i=1,7)/16., 9., 9.,15., 2.71E-01,2.46609E+06,  2./
      DATA (u(i,2682),i=1,7)/16., 9., 9., 9., 2.47E-01,2.60213E+06,  2./
      DATA (u(i,2683),i=1,7)/16., 9., 9.,15., 2.47E-01,2.76855E+06,  2./
      DATA (u(i,2684),i=1,7)/16., 9., 9., 9., 1.98E-01,2.83046E+06,  2./
      DATA (u(i,2685),i=1,7)/16., 9., 9., 9., 1.91E-01,2.88351E+06,  2./
      DATA (u(i,2686),i=1,7)/16., 9., 9.,15., 1.91E-01,2.92740E+06,  2./
      DATA (u(i,2687),i=1,7)/16., 9., 9., 3., 1.74E-01,2.77239E+06,  2./
      DATA (u(i,2688),i=1,7)/16., 9., 9.,15., 1.71E-01,2.88184E+06,  2./
      DATA (u(i,2689),i=1,7)/16., 9., 9.,15., 1.50E-01,2.86779E+06,  2./
      DATA (u(i,2690),i=1,7)/16., 9., 9., 9., 1.49E-01,2.49066E+06,  2./
      DATA (u(i,2691),i=1,7)/16., 9., 9., 9., 1.29E-01,2.51130E+06,  2./
      DATA (u(i,2692),i=1,7)/16., 9., 9., 3., 1.25E-01,2.54259E+06,  2./
      DATA (u(i,2693),i=1,7)/16., 9., 9., 9., 1.23E-01,2.76702E+06,  2./
      DATA (u(i,2694),i=1,7)/16., 9., 9., 9., 1.22E-01,2.81294E+06,  2./
      DATA (u(i,2695),i=1,7)/16., 9., 9.,15., 1.11E-01,2.91206E+06,  2./
      DATA (u(i,2696),i=1,7)/16., 9., 9., 9., 1.08E-01,2.95072E+06,  2./
      DATA (u(i,2697),i=1,7)/16., 9., 9., 9., 1.03E-01,2.99401E+06,  2./
      DATA (u(i,2698),i=1,7)/16., 9., 9., 9., 8.76E-02,2.42660E+06,  2./
      DATA (u(i,2699),i=1,7)/16., 9., 9., 3., 8.44E-02,2.88434E+06,  2./
      DATA (u(i,2700),i=1,7)/16., 9., 9., 3., 8.28E-02,2.81690E+06,  2./
      DATA (u(i,2701),i=1,7)/16., 9., 9.,15., 7.89E-02,2.94118E+06,  2./
      DATA (u(i,2702),i=1,7)/16., 9., 9.,15., 7.86E-02,2.81532E+06,  2./
      DATA (u(i,2703),i=1,7)/16., 9., 9.,15., 7.77E-02,2.94898E+06,  2./
      DATA (u(i,2704),i=1,7)/16., 9., 9.,15., 6.90E-02,2.96296E+06,  2./
      DATA (u(i,2705),i=1,7)/16., 9., 9., 9., 6.05E-02,2.92654E+06,  2./
      DATA (u(i,2706),i=1,7)/16., 9., 9., 3., 5.03E-02,2.95159E+06,  2./
      DATA (u(i,2707),i=1,7)/16., 9., 9., 3., 4.91E-02,2.38949E+06,  2./
      DATA (u(i,2708),i=1,7)/16., 9., 9., 9., 4.45E-02,3.04507E+06,  2./
      DATA (u(i,2709),i=1,7)/16., 9., 9., 9., 3.67E-02,2.52398E+06,  2./
      DATA (u(i,2710),i=1,7)/16., 9., 9., 9., 3.52E-02,3.02389E+06,  2./
      DATA (u(i,2711),i=1,7)/16., 9., 9., 3., 2.86E-02,2.64271E+06,  2./
      DATA (u(i,2712),i=1,7)/16., 9., 9., 9., 2.85E-02,3.02297E+06,  2./
      DATA (u(i,2713),i=1,7)/16., 9., 9.,15., 2.39E-02,2.72257E+06,  2./
      DATA (u(i,2714),i=1,7)/16., 9., 9.,15., 2.17E-02,2.85551E+06,  2./
      DATA (u(i,2715),i=1,7)/16., 9., 9., 9., 2.06E-02,3.03767E+06,  2./
      DATA (u(i,2716),i=1,7)/16., 9., 9.,15., 1.89E-02,2.95247E+06,  2./
      DATA (u(i,2717),i=1,7)/16., 9., 9., 9., 1.48E-02,2.78087E+06,  2./
      DATA (u(i,2718),i=1,7)/16., 9., 9.,15., 1.34E-02,2.41371E+06,  2./
      DATA (u(i,2719),i=1,7)/16., 9., 9., 9., 1.30E-02,2.98597E+06,  2./
      DATA (u(i,2720),i=1,7)/16., 9., 9., 9., 8.27E-03,3.03951E+06,  2./
      DATA (u(i,2721),i=1,7)/16., 9., 9., 9., 7.09E-03,2.97885E+06,  2./
      DATA (u(i,2722),i=1,7)/16., 9., 9., 9., 5.78E-03,2.99491E+06,  2./
      DATA (u(i,2723),i=1,7)/16., 9., 9., 9., 5.40E-03,2.95334E+06,  2./
      DATA (u(i,2724),i=1,7)/16., 9., 9., 9., 4.73E-03,2.90107E+06,  2./
      DATA (u(i,2725),i=1,7)/16., 9., 9., 3., 4.39E-03,2.85225E+06,  2./
      DATA (u(i,2726),i=1,7)/16., 9., 9.,15., 4.35E-03,2.93341E+06,  2./
      DATA (u(i,2727),i=1,7)/16., 9., 9., 3., 4.10E-03,2.77469E+06,  2./
      DATA (u(i,2728),i=1,7)/16., 9., 9., 3., 3.36E-03,2.93427E+06,  2./
      DATA (u(i,2729),i=1,7)/16., 9., 9., 3., 3.02E-03,2.90107E+06,  2./
      DATA (u(i,2730),i=1,7)/16., 9., 9., 3., 1.31E-03,2.95683E+06,  2./
      DATA (u(i,2731),i=1,7)/16., 9., 9.,15., 5.35E-04,2.88018E+06,  2./
      DATA (u(i,2732),i=1,7)/16., 9., 9., 9., 2.83E-04,3.02847E+06,  2./
      DATA (u(i,2733),i=1,7)/16.,10., 4.,12., 6.63E+00,2.35405E+06, 91./
      DATA (u(i,2734),i=1,7)/16.,10., 4.,12., 1.51E+00,2.91375E+06,  2./
      DATA (u(i,2735),i=1,7)/16.,10., 4.,12., 8.38E-01,2.40442E+06,  2./
      DATA (u(i,2736),i=1,7)/16.,10., 4.,12., 6.25E-01,3.76053E+05,130./
      DATA (u(i,2737),i=1,7)/16.,10., 4.,12., 6.05E-01,3.16957E+06,  2./
      DATA (u(i,2738),i=1,7)/16.,10., 4.,12., 4.58E-01,2.10084E+06,  2./
      DATA (u(i,2739),i=1,7)/16.,10., 4.,12., 4.04E-01,2.74048E+06,  2./
      DATA (u(i,2740),i=1,7)/16.,10., 4.,12., 3.35E-01,3.03122E+06,  2./
      DATA (u(i,2741),i=1,7)/16.,10., 4.,12., 2.47E-01,3.30797E+06,  2./
      DATA (u(i,2742),i=1,7)/16.,10., 4.,12., 2.40E-01,3.30688E+06,  2./
      DATA (u(i,2743),i=1,7)/16.,10., 4.,12., 2.26E-01,3.39098E+06,  2./
      DATA (u(i,2744),i=1,7)/16.,10., 4.,12., 1.14E-01,3.44471E+06,  2./
      DATA (u(i,2745),i=1,7)/16.,10., 4.,12., 8.65E-02,3.40368E+06,  2./
      DATA (u(i,2746),i=1,7)/16.,10., 4.,12., 7.99E-02,3.48068E+06,  2./
      DATA (u(i,2747),i=1,7)/16.,10., 4.,12., 7.62E-02,3.45185E+06,  2./
      DATA (u(i,2748),i=1,7)/16.,10., 4.,12., 6.25E-02,2.63713E+06,  2./
      DATA (u(i,2749),i=1,7)/16.,10., 4.,12., 5.91E-02,3.15657E+06,  2./
      DATA (u(i,2750),i=1,7)/16.,10., 4.,12., 5.76E-02,3.50754E+06,  2./
      DATA (u(i,2751),i=1,7)/16.,10., 4.,12., 3.88E-02,2.82087E+06,  2./
      DATA (u(i,2752),i=1,7)/16.,10., 4.,12., 3.25E-02,3.12207E+06,  2./
      DATA (u(i,2753),i=1,7)/16.,10., 4.,12., 1.79E-02,3.37496E+06,  2./
      DATA (u(i,2754),i=1,7)/16.,10., 4.,12., 1.58E-02,3.28299E+06,  2./
      DATA (u(i,2755),i=1,7)/16.,10., 4.,12., 1.57E-02,2.59403E+06,  2./
      DATA (u(i,2756),i=1,7)/16.,10., 4.,12., 2.70E-03,3.28407E+06,  2./
      DATA (u(i,2757),i=1,7)/16.,10., 4.,12., 2.62E-03,3.47343E+06,  2./
      DATA (u(i,2758),i=1,7)/16.,10., 4.,12., 1.93E-03,3.50140E+06,  2./
      DATA (u(i,2759),i=1,7)/16.,10., 4.,12., 1.09E-03,3.43407E+06,  2./
      DATA (u(i,2760),i=1,7)/16.,10., 4.,12., 9.28E-04,2.93169E+06,  2./
      DATA (u(i,2761),i=1,7)/16.,10., 4.,12., 7.47E-04,3.22997E+06,  2./
      DATA (u(i,2762),i=1,7)/16.,10., 4.,12., 4.93E-04,3.24886E+06,  2./
      DATA (u(i,2763),i=1,7)/16.,11., 9.,15., 7.89E+00,2.53872E+06,  2./
      DATA (u(i,2764),i=1,7)/16.,11., 9., 9., 2.61E+00,2.54453E+06,  2./
      DATA (u(i,2765),i=1,7)/16.,11., 9.,15., 1.76E+00,3.20821E+06,  2./
      DATA (u(i,2766),i=1,7)/16.,11., 9.,15., 1.60E+00,2.63227E+06,  2./
      DATA (u(i,2767),i=1,7)/16.,11., 9., 9., 9.42E-01,2.65041E+06,  2./
      DATA (u(i,2768),i=1,7)/16.,11., 9., 3., 7.20E-01,5.19103E+05,  3./
      DATA (u(i,2769),i=1,7)/16.,11., 9.,15., 6.09E-01,3.50385E+06,  2./
      DATA (u(i,2770),i=1,7)/16.,11., 9., 9., 6.06E-01,3.97725E+05,  3./
      DATA (u(i,2771),i=1,7)/16.,11., 9., 9., 5.79E-01,3.20924E+06,  2./
      DATA (u(i,2772),i=1,7)/16.,11., 9., 9., 5.71E-01,2.31750E+06,  2./
      DATA (u(i,2773),i=1,7)/16.,11., 9.,15., 5.39E-01,3.35886E+05,  3./
      DATA (u(i,2774),i=1,7)/16.,11., 9.,15., 4.83E-01,3.36022E+06,  2./
      DATA (u(i,2775),i=1,7)/16.,11., 9., 3., 3.70E-01,2.58465E+06,  2./
      DATA (u(i,2776),i=1,7)/16.,11., 9.,15., 3.59E-01,2.87026E+06,  2./
      DATA (u(i,2777),i=1,7)/16.,11., 9., 9., 2.76E-01,3.36700E+06,  2./
      DATA (u(i,2778),i=1,7)/16.,11., 9., 9., 2.24E-01,2.88268E+06,  2./
      DATA (u(i,2779),i=1,7)/16.,11., 9., 9., 2.10E-01,3.50385E+06,  2./
      DATA (u(i,2780),i=1,7)/16.,11., 9.,15., 2.02E-01,3.69140E+06,  2./
      DATA (u(i,2781),i=1,7)/16.,11., 9.,15., 1.99E-01,3.68189E+06,  2./
      DATA (u(i,2782),i=1,7)/16.,11., 9.,15., 1.71E-01,2.77085E+06,  2./
      DATA (u(i,2783),i=1,7)/16.,11., 9.,15., 1.60E-01,3.61925E+06,  2./
      DATA (u(i,2784),i=1,7)/16.,11., 9.,15., 1.43E-01,3.78644E+06,  2./
      DATA (u(i,2785),i=1,7)/16.,11., 9., 9., 1.25E-01,2.86205E+06,  2./
      DATA (u(i,2786),i=1,7)/16.,11., 9., 3., 1.23E-01,2.88767E+06,  2./
      DATA (u(i,2787),i=1,7)/16.,11., 9., 9., 1.20E-01,3.62188E+06,  2./
      DATA (u(i,2788),i=1,7)/16.,11., 9., 9., 1.11E-01,3.69549E+06,  2./
      DATA (u(i,2789),i=1,7)/16.,11., 9., 3., 1.01E-01,3.34448E+06,  2./
      DATA (u(i,2790),i=1,7)/16.,11., 9.,15., 9.77E-02,3.85356E+06,  2./
      DATA (u(i,2791),i=1,7)/16.,11., 9.,15., 9.77E-02,3.86399E+06,  2./
      DATA (u(i,2792),i=1,7)/16.,11., 9., 9., 8.43E-02,3.12793E+06,  2./
      DATA (u(i,2793),i=1,7)/16.,11., 9., 9., 7.90E-02,3.68189E+06,  2./
      DATA (u(i,2794),i=1,7)/16.,11., 9.,15., 7.13E-02,3.89864E+06,  2./
      DATA (u(i,2795),i=1,7)/16.,11., 9., 9., 6.10E-02,3.86548E+06,  2./
      DATA (u(i,2796),i=1,7)/16.,11., 9.,15., 5.49E-02,3.92927E+06,  2./
      DATA (u(i,2797),i=1,7)/16.,11., 9.,15., 4.74E-02,3.21854E+06,  2./
      DATA (u(i,2798),i=1,7)/16.,11., 9., 9., 4.73E-02,3.78644E+06,  2./
      DATA (u(i,2799),i=1,7)/16.,11., 9., 9., 4.45E-02,2.78862E+06,  2./
      DATA (u(i,2800),i=1,7)/16.,11., 9., 9., 4.40E-02,3.48189E+06,  2./
      DATA (u(i,2801),i=1,7)/16.,11., 9., 3., 4.05E-02,3.68053E+06,  2./
      DATA (u(i,2802),i=1,7)/16.,11., 9., 3., 3.86E-02,3.62845E+06,  2./
      DATA (u(i,2803),i=1,7)/16.,11., 9.,15., 3.73E-02,3.68460E+06,  2./
      DATA (u(i,2804),i=1,7)/16.,11., 9.,15., 3.39E-02,3.50140E+06,  2./
      DATA (u(i,2805),i=1,7)/16.,11., 9., 9., 3.26E-02,3.85356E+06,  2./
      DATA (u(i,2806),i=1,7)/16.,11., 9.,15., 2.97E-02,3.14070E+06,  2./
      DATA (u(i,2807),i=1,7)/16.,11., 9., 3., 2.94E-02,3.96511E+06,  2./
      DATA (u(i,2808),i=1,7)/16.,11., 9., 3., 2.72E-02,2.97708E+06,  2./
      DATA (u(i,2809),i=1,7)/16.,11., 9., 9., 2.23E-02,3.89864E+06,  2./
      DATA (u(i,2810),i=1,7)/16.,11., 9., 3., 2.18E-02,3.85951E+06,  2./
      DATA (u(i,2811),i=1,7)/16.,11., 9., 9., 1.68E-02,3.92927E+06,  2./
      DATA (u(i,2812),i=1,7)/16.,11., 9.,15., 1.60E-02,3.30360E+06,  2./
      DATA (u(i,2813),i=1,7)/16.,11., 9., 9., 1.53E-02,3.29164E+06,  2./
      DATA (u(i,2814),i=1,7)/16.,11., 9.,15., 1.53E-02,3.86548E+06,  2./
      DATA (u(i,2815),i=1,7)/16.,11., 9., 9., 1.23E-02,3.23206E+06,  2./
      DATA (u(i,2816),i=1,7)/16.,11., 9., 9., 1.21E-02,3.87898E+06,  2./
      DATA (u(i,2817),i=1,7)/16.,11., 9.,15., 1.21E-02,3.80228E+06,  2./
      DATA (u(i,2818),i=1,7)/16.,11., 9., 9., 1.05E-02,3.77644E+06,  2./
      DATA (u(i,2819),i=1,7)/16.,11., 9., 3., 1.04E-02,3.24570E+06,  2./
      DATA (u(i,2820),i=1,7)/16.,11., 9.,15., 1.04E-02,3.01386E+06,  2./
      DATA (u(i,2821),i=1,7)/16.,11., 9., 3., 9.50E-03,4.02901E+06,  2./
      DATA (u(i,2822),i=1,7)/16.,11., 9., 3., 6.14E-03,3.88651E+06,  2./
      DATA (u(i,2823),i=1,7)/16.,11., 9.,15., 5.92E-03,3.79651E+06,  2./
      DATA (u(i,2824),i=1,7)/16.,11., 9.,15., 5.66E-03,3.87747E+06,  2./
      DATA (u(i,2825),i=1,7)/16.,11., 9., 9., 5.34E-03,3.88802E+06,  2./
      DATA (u(i,2826),i=1,7)/16.,11., 9., 9., 5.19E-03,3.92465E+06,  2./
      DATA (u(i,2827),i=1,7)/16.,11., 9., 9., 4.91E-03,3.89256E+06,  2./
      DATA (u(i,2828),i=1,7)/16.,11., 9., 9., 4.48E-03,3.66972E+06,  2./
      DATA (u(i,2829),i=1,7)/16.,11., 9., 9., 4.44E-03,3.83730E+06,  2./
      DATA (u(i,2830),i=1,7)/16.,11., 9., 3., 3.92E-03,4.10846E+06,  2./
      DATA (u(i,2831),i=1,7)/16.,11., 9., 9., 3.68E-03,3.09885E+06,  2./
      DATA (u(i,2832),i=1,7)/16.,11., 9., 9., 3.62E-03,3.59971E+06,  2./
      DATA (u(i,2833),i=1,7)/16.,11., 9., 9., 3.16E-03,3.84615E+06,  2./
      DATA (u(i,2834),i=1,7)/16.,11., 9., 3., 3.00E-03,3.72856E+06,  2./
      DATA (u(i,2835),i=1,7)/16.,11., 9., 3., 2.98E-03,4.07166E+06,  2./
      DATA (u(i,2836),i=1,7)/16.,11., 9., 3., 2.90E-03,4.07830E+06,  2./
      DATA (u(i,2837),i=1,7)/16.,11., 9.,15., 2.24E-03,3.87447E+06,  2./
      DATA (u(i,2838),i=1,7)/16.,11., 9.,15., 1.49E-03,3.56506E+06,  2./
      DATA (u(i,2839),i=1,7)/16.,11., 9., 9., 7.07E-04,3.57015E+06,  2./
      DATA (u(i,2840),i=1,7)/16.,11., 9., 9., 5.85E-04,3.51000E+06,  2./
      DATA (u(i,2841),i=1,7)/16.,11., 9., 9., 5.24E-04,3.86698E+06,  2./
      DATA (u(i,2842),i=1,7)/16.,11., 9.,15., 4.62E-04,3.71609E+06,  2./
      DATA (u(i,2843),i=1,7)/16.,11., 9.,15., 3.98E-04,3.41530E+06,  2./
      DATA (u(i,2844),i=1,7)/16.,11., 9., 3., 1.41E-04,3.96040E+06,  2./
      DATA (u(i,2845),i=1,7)/16.,11., 9.,15., 2.89E-05,3.83583E+06,  2./
      DATA (u(i,2846),i=1,7)/16.,12., 6.,10., 3.84E+00,2.73149E+06,  2./
      DATA (u(i,2847),i=1,7)/16.,12., 6.,10., 1.55E+00,2.87604E+06,  2./
      DATA (u(i,2848),i=1,7)/16.,12., 6., 6., 8.70E-01,4.50025E+05,  3./
      DATA (u(i,2849),i=1,7)/16.,12., 6., 6., 8.35E-01,2.82566E+06,  2./
      DATA (u(i,2850),i=1,7)/16.,12., 6.,10., 7.49E-01,3.52734E+06,  2./
      DATA (u(i,2851),i=1,7)/16.,12., 6.,10., 3.94E-01,3.70508E+06,  2./
      DATA (u(i,2852),i=1,7)/16.,12., 6.,10., 3.34E-01,3.27815E+05,  3./
      DATA (u(i,2853),i=1,7)/16.,12., 6., 2., 3.16E-01,2.90613E+06,  2./
      DATA (u(i,2854),i=1,7)/16.,12., 6., 6., 2.63E-01,3.02572E+06,  2./
      DATA (u(i,2855),i=1,7)/16.,12., 6.,10., 2.51E-01,3.89256E+06,  2./
      DATA (u(i,2856),i=1,7)/16.,12., 6., 6., 2.28E-01,3.69004E+06,  2./
      DATA (u(i,2857),i=1,7)/16.,12., 6., 2., 1.76E-01,4.23783E+05,  3./
      DATA (u(i,2858),i=1,7)/16.,12., 6.,10., 1.45E-01,4.08831E+06,  2./
      DATA (u(i,2859),i=1,7)/16.,12., 6., 2., 1.38E-01,2.54582E+06,  2./
      DATA (u(i,2860),i=1,7)/16.,12., 6.,10., 1.30E-01,4.08163E+06,  2./
      DATA (u(i,2861),i=1,7)/16.,12., 6.,10., 1.24E-01,3.87447E+06,  2./
      DATA (u(i,2862),i=1,7)/16.,12., 6.,10., 1.14E-01,3.02663E+06,  2./
      DATA (u(i,2863),i=1,7)/16.,12., 6., 6., 9.24E-02,4.07498E+06,  2./
      DATA (u(i,2864),i=1,7)/16.,12., 6.,10., 8.70E-02,4.20698E+06,  2./
      DATA (u(i,2865),i=1,7)/16.,12., 6., 6., 7.65E-02,3.87747E+06,  2./
      DATA (u(i,2866),i=1,7)/16.,12., 6., 2., 7.38E-02,3.71747E+06,  2./
      DATA (u(i,2867),i=1,7)/16.,12., 6.,10., 6.42E-02,4.28082E+06,  2./
      DATA (u(i,2868),i=1,7)/16.,12., 6., 6., 6.15E-02,4.27716E+06,  2./
      DATA (u(i,2869),i=1,7)/16.,12., 6., 6., 5.80E-02,3.12793E+06,  2./
      DATA (u(i,2870),i=1,7)/16.,12., 6.,10., 5.27E-02,4.05844E+06,  2./
      DATA (u(i,2871),i=1,7)/16.,12., 6.,10., 4.41E-02,3.32336E+06,  2./
      DATA (u(i,2872),i=1,7)/16.,12., 6.,10., 4.39E-02,3.30142E+06,  2./
      DATA (u(i,2873),i=1,7)/16.,12., 6.,10., 4.24E-02,4.25713E+06,  2./
      DATA (u(i,2874),i=1,7)/16.,12., 6., 2., 4.11E-02,3.04878E+06,  2./
      DATA (u(i,2875),i=1,7)/16.,12., 6.,10., 4.06E-02,4.28266E+06,  2./
      DATA (u(i,2876),i=1,7)/16.,12., 6.,10., 3.91E-02,4.28449E+06,  2./
      DATA (u(i,2877),i=1,7)/16.,12., 6.,10., 3.55E-02,4.33651E+06,  2./
      DATA (u(i,2878),i=1,7)/16.,12., 6., 2., 3.28E-02,4.08497E+06,  2./
      DATA (u(i,2879),i=1,7)/16.,12., 6., 6., 3.08E-02,4.39947E+06,  2./
      DATA (u(i,2880),i=1,7)/16.,12., 6., 6., 2.71E-02,3.34448E+06,  2./
      DATA (u(i,2881),i=1,7)/16.,12., 6., 2., 2.56E-02,3.85060E+06,  2./
      DATA (u(i,2882),i=1,7)/16.,12., 6.,10., 2.53E-02,4.37445E+06,  2./
      DATA (u(i,2883),i=1,7)/16.,12., 6., 2., 2.38E-02,3.45662E+06,  2./
      DATA (u(i,2884),i=1,7)/16.,12., 6., 6., 2.20E-02,4.47828E+06,  2./
      DATA (u(i,2885),i=1,7)/16.,12., 6., 6., 2.14E-02,4.25713E+06,  2./
      DATA (u(i,2886),i=1,7)/16.,12., 6., 6., 1.87E-02,4.45831E+06,  2./
      DATA (u(i,2887),i=1,7)/16.,12., 6.,10., 1.84E-02,3.44590E+06,  2./
      DATA (u(i,2888),i=1,7)/16.,12., 6.,10., 1.65E-02,3.15060E+06,  2./
      DATA (u(i,2889),i=1,7)/16.,12., 6., 6., 1.45E-02,3.24254E+06,  2./
      DATA (u(i,2890),i=1,7)/16.,12., 6., 2., 1.40E-02,4.25894E+06,  2./
      DATA (u(i,2891),i=1,7)/16.,12., 6., 6., 1.38E-02,4.53104E+06,  2./
      DATA (u(i,2892),i=1,7)/16.,12., 6., 2., 1.35E-02,4.28449E+06,  2./
      DATA (u(i,2893),i=1,7)/16.,12., 6., 6., 1.31E-02,4.03877E+06,  2./
      DATA (u(i,2894),i=1,7)/16.,12., 6., 2., 9.87E-03,3.88802E+06,  2./
      DATA (u(i,2895),i=1,7)/16.,12., 6., 6., 9.42E-03,4.57038E+06,  2./
      DATA (u(i,2896),i=1,7)/16.,12., 6.,10., 9.01E-03,4.23012E+06,  2./
      DATA (u(i,2897),i=1,7)/16.,12., 6., 6., 8.45E-03,4.10846E+06,  2./
      DATA (u(i,2898),i=1,7)/16.,12., 6., 2., 6.48E-03,3.35796E+06,  2./
      DATA (u(i,2899),i=1,7)/16.,12., 6.,10., 4.57E-03,4.03063E+06,  2./
      DATA (u(i,2900),i=1,7)/16.,12., 6., 2., 3.85E-03,4.19463E+06,  2./
      DATA (u(i,2901),i=1,7)/16.,12., 6., 2., 3.47E-03,4.11015E+06,  2./
      DATA (u(i,2902),i=1,7)/16.,12., 6., 2., 3.29E-03,3.27976E+06,  2./
      DATA (u(i,2903),i=1,7)/16.,12., 6.,10., 2.93E-03,4.10172E+06,  2./
      DATA (u(i,2904),i=1,7)/16.,12., 6.,10., 2.50E-03,4.10172E+06,  2./
      DATA (u(i,2905),i=1,7)/16.,12., 6., 2., 2.07E-03,4.06835E+06,  2./
      DATA (u(i,2906),i=1,7)/16.,12., 6., 6., 1.60E-03,4.37445E+06,  2./
      DATA (u(i,2907),i=1,7)/16.,12., 6., 6., 1.27E-03,4.40335E+06,  2./
      DATA (u(i,2908),i=1,7)/16.,12., 6., 2., 1.17E-03,4.33088E+06,  2./
      DATA (u(i,2909),i=1,7)/16.,12., 6., 2., 8.62E-04,4.37063E+06,  2./
      DATA (u(i,2910),i=1,7)/16.,12., 6., 6., 8.01E-04,3.98248E+06,  2./
      DATA (u(i,2911),i=1,7)/16.,12., 6.,10., 7.16E-04,3.74813E+06,  2./
      DATA (u(i,2912),i=1,7)/16.,12., 6.,10., 6.80E-04,4.29369E+06,  2./
      DATA (u(i,2913),i=1,7)/16.,12., 6., 6., 2.73E-04,4.46828E+06,  2./
      DATA (u(i,2914),i=1,7)/16.,12., 6., 2., 2.29E-04,4.16840E+06,  2./
      DATA (u(i,2915),i=1,7)/16.,12., 6., 2., 1.38E-04,4.27716E+06,  2./
      DATA (u(i,2916),i=1,7)/16.,12., 6.,10., 4.95E-05,3.92927E+06,  2./
      DATA (u(i,2917),i=1,7)/16.,13., 1., 3., 6.10E-01,3.08452E+06,  2./
      DATA (u(i,2918),i=1,7)/16.,13., 1., 3., 2.25E-01,3.80720E+05,129./
      DATA (u(i,2919),i=1,7)/16.,13., 1., 3., 1.60E-01,4.04694E+06,  2./
      DATA (u(i,2920),i=1,7)/16.,13., 1., 3., 6.49E-02,4.48230E+06,  2./
      DATA (u(i,2921),i=1,7)/16.,13., 1., 3., 3.59E-02,4.71476E+06,  2./
      DATA (u(i,2922),i=1,7)/16.,13., 1., 3., 3.30E-02,3.43289E+06,  2./
      DATA (u(i,2923),i=1,7)/16.,13., 1., 3., 2.58E-02,3.28192E+06,  2./
      DATA (u(i,2924),i=1,7)/16.,13., 1., 3., 2.06E-02,4.85437E+06,  2./
      DATA (u(i,2925),i=1,7)/16.,13., 1., 3., 1.51E-02,4.94560E+06,  2./
      DATA (u(i,2926),i=1,7)/16.,13., 1., 3., 1.26E-02,4.31220E+06,  2./
      DATA (u(i,2927),i=1,7)/16.,13., 1., 3., 8.98E-03,5.00751E+06,  2./
      DATA (u(i,2928),i=1,7)/16.,13., 1., 3., 6.72E-03,5.05050E+06,  2./
      DATA (u(i,2929),i=1,7)/16.,13., 1., 3., 3.99E-03,4.68823E+06,  2./
      DATA (u(i,2930),i=1,7)/16.,13., 1., 3., 8.25E-04,4.92854E+06,  2./
      DATA (u(i,2931),i=1,7)/16.,13., 1., 3., 2.23E-04,4.72590E+06,  2./
      DATA (u(i,2932),i=1,7)/16.,13., 1., 3., 1.43E-04,4.94805E+06,  2./
      DATA (u(i,2933),i=1,7)/16.,13., 1., 3., 1.49E-05,4.24809E+06,  2./
      DATA (u(i,2934),i=1,7)/16.,14., 2., 6., 1.80E-01,4.32339E+06,  2./
      DATA (u(i,2935),i=1,7)/16.,14., 2., 6., 7.54E-02,4.81232E+06, 18./
      DATA (u(i,2936),i=1,7)/16.,14., 2., 6., 3.93E-02,5.07872E+06, 18./
      DATA (u(i,2937),i=1,7)/16.,14., 2., 6., 2.33E-02,5.23834E+06, 18./
      DATA (u(i,2938),i=1,7)/16.,14., 2., 6., 1.50E-02,5.34188E+06, 18./
      DATA (u(i,2939),i=1,7)/16.,14., 2., 6., 1.03E-02,5.41126E+06, 18./
      DATA (u(i,2940),i=1,7)/16.,14., 2., 6., 7.36E-03,5.46150E+06, 18./
      DATA (u(i,2941),i=1,7)/16.,15., 1., 3.,-3.04E+07,1.96021E+07, 39./
      DATA (u(i,2942),i=1,7)/16.,15., 1., 3., 6.72E-03,1.97400E+07, 38./
      DATA (u(i,2943),i=1,7)/16.,15., 1., 3., 7.65E-01,1.97628E+07, 36./
      DATA (u(i,2944),i=1,7)/16.,15., 1., 3., 1.53E-01,2.32019E+07, 34./
      DATA (u(i,2945),i=1,7)/16.,15., 1., 3., 5.69E-02,2.43902E+07, 13./
      DATA (u(i,2946),i=1,7)/16.,15., 1., 3., 2.75E-02,2.49377E+07, 13./
      DATA (u(i,2947),i=1,7)/16.,15., 1., 3., 1.54E-02,2.52525E+07, 13./
      DATA (u(i,2948),i=1,7)/16.,15., 1., 3., 9.54E-03,2.53807E+07, 13./
      DATA (u(i,2949),i=1,7)/16.,15., 1., 3., 6.32E-03,2.55102E+07, 13./
      DATA (u(i,2950),i=1,7)/16.,15., 1., 3., 4.40E-03,2.56410E+07, 13./
      DATA (u(i,2951),i=1,7)/16.,15., 1., 3., 3.19E-03,2.56410E+07, 13./
      DATA (u(i,2952),i=1,7)/16.,16., 2., 2.,-5.39E+05,2.13015E+07, 23./
      DATA (u(i,2953),i=1,7)/16.,16., 2., 6., 8.32E-01,2.10526E+07, 35./
      DATA (u(i,2954),i=1,7)/16.,16., 2., 6., 1.58E-01,2.49377E+07,  5./
      DATA (u(i,2955),i=1,7)/16.,16., 2., 6., 5.80E-02,2.63158E+07,  6./
      DATA (u(i,2956),i=1,7)/16.,16., 2., 6., 2.79E-02,2.69542E+07,  7./
      DATA (u(i,2957),i=1,7)/16.,16., 2., 6., 1.56E-02,2.73224E+07,  8./
      DATA (u(i,2958),i=1,7)/16.,16., 2., 6., 9.63E-03,2.74725E+07,  9./
      DATA (u(i,2959),i=1,7)/16.,16., 2., 6., 6.37E-03,2.76243E+07,  9./
      DATA (u(i,2960),i=1,7)/16.,16., 2., 6., 4.43E-03,2.77008E+07,  9./
      DATA (u(i,2961),i=1,7)/16.,16., 2., 6., 3.21E-03,2.77778E+07,  9./
      DATA (u(i,2962),i=1,7)/18., 1., 1., 3., 3.39E-01,9.12667E+04,  1./
      DATA (u(i,2963),i=1,7)/18., 1., 1., 3., 1.23E-01,1.08400E+05,  1./
      DATA (u(i,2964),i=1,7)/18., 1., 1., 3., 1.10E-01,1.08874E+05, 0.1/
      DATA (u(i,2965),i=1,7)/18., 1., 1., 3., 5.93E-02,1.14261E+05,  1./
      DATA (u(i,2966),i=1,7)/18., 1., 1., 3., 4.84E-02,1.14090E+05,  1./
      DATA (u(i,2967),i=1,7)/18., 1., 1., 3., 3.31E-02,1.16750E+05,  1./
      DATA (u(i,2968),i=1,7)/18., 1., 1., 3., 2.38E-02,1.16668E+05,  1./
      DATA (u(i,2969),i=1,7)/18., 1., 1., 3., 1.99E-02,1.18100E+05,  1./
      DATA (u(i,2970),i=1,7)/18., 1., 1., 3., 1.35E-02,1.18054E+05,  1./
      DATA (u(i,2971),i=1,7)/18., 1., 1., 3., 1.28E-02,1.18913E+05,  1./
      DATA (u(i,2972),i=1,7)/18., 1., 1., 3., 8.72E-03,1.19440E+05,  1./
      DATA (u(i,2973),i=1,7)/18., 1., 1., 3., 8.38E-03,1.18885E+05,  1./
      DATA (u(i,2974),i=1,7)/18., 1., 1., 3., 6.18E-03,1.19802E+05,  1./
      DATA (u(i,2975),i=1,7)/18., 1., 1., 3., 5.56E-03,1.19422E+05,  1./
      DATA (u(i,2976),i=1,7)/18., 1., 1., 3., 4.54E-03,1.20060E+05,  1./
      DATA (u(i,2977),i=1,7)/18., 1., 1., 3., 3.88E-03,1.19789E+05,  1./
      DATA (u(i,2978),i=1,7)/18., 1., 1., 3., 2.82E-03,1.20051E+05,  1./
      DATA (u(i,2979),i=1,7)/18., 2., 6.,10., 3.48E+00,1.82279E+05,  3./
      DATA (u(i,2980),i=1,7)/18., 2., 6.,10., 2.40E+00,2.00965E+05,  2./
      DATA (u(i,2981),i=1,7)/18., 2., 6., 6., 1.96E+00,1.84560E+05,  3./
      DATA (u(i,2982),i=1,7)/18., 2., 6., 6., 1.39E+00,1.47623E+05,  2./
      DATA (u(i,2983),i=1,7)/18., 2., 6.,10., 1.24E+00,2.11046E+05,  2./
      DATA (u(i,2984),i=1,7)/18., 2., 6., 6., 9.77E-01,1.97589E+05,  2./
      DATA (u(i,2985),i=1,7)/18., 2., 6., 2., 8.16E-01,1.92552E+05,  3./
      DATA (u(i,2986),i=1,7)/18., 2., 6.,10., 7.27E-01,2.15806E+05,  2./
      DATA (u(i,2987),i=1,7)/18., 2., 6., 6., 7.07E-01,2.11408E+05,  2./
      DATA (u(i,2988),i=1,7)/18., 2., 6., 2., 5.80E-01,2.12757E+05,  2./
      DATA (u(i,2989),i=1,7)/18., 2., 6.,10., 5.67E-01,1.57764E+05,  2./
      DATA (u(i,2990),i=1,7)/18., 2., 6.,10., 5.67E-01,1.62101E+05,  3./
      DATA (u(i,2991),i=1,7)/18., 2., 6., 2., 4.34E-01,1.76242E+05,  2./
      DATA (u(i,2992),i=1,7)/18., 2., 6., 6., 3.93E-01,2.15480E+05,  2./
      DATA (u(i,2993),i=1,7)/18., 2., 6., 6., 3.01E-01,1.89437E+05,  2./
      DATA (u(i,2994),i=1,7)/18., 2., 6.,10., 2.73E-01,2.21710E+05,  2./
      DATA (u(i,2995),i=1,7)/18., 2., 6., 2., 2.30E-01,2.23354E+05,  2./
      DATA (u(i,2996),i=1,7)/18., 2., 6., 6., 2.15E-01,2.05373E+05,  2./
      DATA (u(i,2997),i=1,7)/18., 2., 6.,10., 2.02E-01,2.22970E+05,  2./
      DATA (u(i,2998),i=1,7)/18., 2., 6., 6., 1.61E-01,2.21872E+05,  2./
      DATA (u(i,2999),i=1,7)/18., 2., 6., 6., 1.61E-01,2.23060E+05,  2./
      DATA (u(i,3000),i=1,7)/18., 2., 6., 2., 1.60E-01,2.28912E+05,  2./
      DATA (u(i,3001),i=1,7)/18., 2., 6.,10., 1.32E-01,2.18465E+05,  2./
      DATA (u(i,3002),i=1,7)/18., 2., 6., 6., 1.12E-01,2.23999E+05,  2./
      DATA (u(i,3003),i=1,7)/18., 2., 6., 2., 1.11E-01,1.11221E+05,  3./
      DATA (u(i,3004),i=1,7)/18., 2., 6.,10., 1.08E-01,2.23944E+05,  2./
      DATA (u(i,3005),i=1,7)/18., 2., 6., 2., 9.69E-02,2.32401E+05,  2./
      DATA (u(i,3006),i=1,7)/18., 2., 6.,10., 9.07E-02,2.18747E+05,  2./
      DATA (u(i,3007),i=1,7)/18., 2., 6.,10., 6.91E-02,2.20327E+05,  2./
      DATA (u(i,3008),i=1,7)/18., 2., 6., 6., 6.71E-02,2.20352E+05,  2./
      DATA (u(i,3009),i=1,7)/18., 2., 6., 2., 6.25E-02,2.34670E+05,  2./
      DATA (u(i,3010),i=1,7)/18., 2., 6., 2., 6.01E-02,2.21205E+05,  2./
      DATA (u(i,3011),i=1,7)/18., 2., 6.,10., 5.92E-02,2.02045E+05,  2./
      DATA (u(i,3012),i=1,7)/18., 2., 6., 6., 5.41E-02,2.13251E+05,  2./
      DATA (u(i,3013),i=1,7)/18., 2., 6., 2., 4.27E-02,2.36222E+05,  2./
      DATA (u(i,3014),i=1,7)/18., 2., 6., 6., 3.66E-02,2.18355E+05,  2./
      DATA (u(i,3015),i=1,7)/18., 2., 6., 6., 3.54E-02,2.17670E+05,  2./
      DATA (u(i,3016),i=1,7)/18., 2., 6., 2., 3.04E-02,2.37315E+05,  2./
      DATA (u(i,3017),i=1,7)/18., 2., 6.,10., 2.01E-02,2.05948E+05,  2./
      DATA (u(i,3018),i=1,7)/18., 2., 6., 6., 1.84E-02,2.05643E+05,  2./
      DATA (u(i,3019),i=1,7)/18., 2., 6., 6., 1.12E-02,2.22237E+05,  2./
      DATA (u(i,3020),i=1,7)/18., 2., 6., 6., 8.69E-03,2.23504E+05,  2./
      DATA (u(i,3021),i=1,7)/18., 2., 6., 6., 2.88E-03,1.55872E+05,  3./
      DATA (u(i,3022),i=1,7)/18., 2., 6., 6., 2.21E-03,2.20434E+05,  2./
      DATA (u(i,3023),i=1,7)/18., 2., 6.,10., 1.13E-04,1.94288E+05,  3./
      DATA (u(i,3024),i=1,7)/18., 3., 9.,15., 1.67E+01,2.18274E+05,  3./
      DATA (u(i,3025),i=1,7)/18., 3., 9., 9., 8.41E+00,2.15206E+05,  2./
      DATA (u(i,3026),i=1,7)/18., 3., 9., 9., 3.32E+00,2.21685E+05,  3./
      DATA (u(i,3027),i=1,7)/18., 3., 9., 3., 2.40E+00,2.11569E+05,  3./
      DATA (u(i,3028),i=1,7)/18., 3., 9.,15., 1.76E+00,2.04537E+05,  2./
      DATA (u(i,3029),i=1,7)/18., 3., 9.,15., 1.52E+00,2.57407E+05,  2./
      DATA (u(i,3030),i=1,7)/18., 3., 9., 3., 1.15E+00,1.89591E+05,  2./
      DATA (u(i,3031),i=1,7)/18., 3., 9., 9., 6.80E-01,2.77054E+05,  2./
      DATA (u(i,3032),i=1,7)/18., 3., 9.,15., 6.62E-01,2.89026E+05,  2./
      DATA (u(i,3033),i=1,7)/18., 3., 9.,15., 5.47E-01,2.73898E+05,  2./
      DATA (u(i,3034),i=1,7)/18., 3., 9., 9., 3.40E-01,1.11747E+05,  3./
      DATA (u(i,3035),i=1,7)/18., 3., 9.,15., 2.92E-01,1.93229E+05,  3./
      DATA (u(i,3036),i=1,7)/18., 3., 9., 3., 2.19E-01,2.58224E+05,  2./
      DATA (u(i,3037),i=1,7)/18., 3., 9.,15., 1.96E-01,2.77600E+05,  2./
      DATA (u(i,3038),i=1,7)/18., 3., 9., 3., 1.17E-01,2.77131E+05,  2./
      DATA (u(i,3039),i=1,7)/18., 3., 9., 9., 1.10E-01,3.06786E+05,  2./
      DATA (u(i,3040),i=1,7)/18., 3., 9., 9., 1.07E-01,2.87084E+05,  2./
      DATA (u(i,3041),i=1,7)/18., 3., 9.,15., 9.87E-02,3.01132E+05,  2./
      DATA (u(i,3042),i=1,7)/18., 3., 9.,15., 8.67E-02,3.05605E+05,  2./
      DATA (u(i,3043),i=1,7)/18., 3., 9.,15., 7.70E-02,3.19652E+05,  2./
      DATA (u(i,3044),i=1,7)/18., 3., 9.,15., 7.66E-02,3.07267E+05,  2./
      DATA (u(i,3045),i=1,7)/18., 3., 9., 3., 6.50E-02,2.86985E+05,  2./
      DATA (u(i,3046),i=1,7)/18., 3., 9., 9., 6.08E-02,2.91460E+05,  2./
      DATA (u(i,3047),i=1,7)/18., 3., 9.,15., 5.38E-02,3.10068E+05,  2./
      DATA (u(i,3048),i=1,7)/18., 3., 9.,15., 5.18E-02,2.85918E+05,  2./
      DATA (u(i,3049),i=1,7)/18., 3., 9., 9., 4.44E-02,3.22113E+05,  2./
      DATA (u(i,3050),i=1,7)/18., 3., 9., 3., 4.06E-02,3.01623E+05,  2./
      DATA (u(i,3051),i=1,7)/18., 3., 9.,15., 3.60E-02,3.22383E+05,  2./
      DATA (u(i,3052),i=1,7)/18., 3., 9.,15., 3.55E-02,3.21906E+05,  2./
      DATA (u(i,3053),i=1,7)/18., 3., 9., 9., 3.33E-02,1.93267E+05,  3./
      DATA (u(i,3054),i=1,7)/18., 3., 9.,15., 2.45E-02,1.59951E+05,  3./
      DATA (u(i,3055),i=1,7)/18., 3., 9., 9., 2.15E-02,3.19152E+05,  2./
      DATA (u(i,3056),i=1,7)/18., 3., 9.,15., 2.05E-02,3.15447E+05,  2./
      DATA (u(i,3057),i=1,7)/18., 3., 9., 9., 2.02E-02,3.21007E+05,  2./
      DATA (u(i,3058),i=1,7)/18., 3., 9., 3., 1.79E-02,3.10260E+05,  2./
      DATA (u(i,3059),i=1,7)/18., 3., 9., 9., 1.72E-02,3.35852E+05,  2./
      DATA (u(i,3060),i=1,7)/18., 3., 9., 3., 1.66E-02,3.06701E+05,  2./
      DATA (u(i,3061),i=1,7)/18., 3., 9., 9., 1.57E-02,3.36530E+05,  2./
      DATA (u(i,3062),i=1,7)/18., 3., 9., 9., 1.37E-02,3.30841E+05,  2./
      DATA (u(i,3063),i=1,7)/18., 3., 9., 3., 1.32E-02,3.15667E+05,  2./
      DATA (u(i,3064),i=1,7)/18., 3., 9., 3., 9.66E-03,3.19315E+05,  2./
      DATA (u(i,3065),i=1,7)/18., 3., 9., 3., 9.65E-03,3.21709E+05,  2./
      DATA (u(i,3066),i=1,7)/18., 3., 9., 9., 5.44E-03,3.40287E+05,  2./
      DATA (u(i,3067),i=1,7)/18., 3., 9., 9., 3.19E-03,3.42900E+05,  2./
      DATA (u(i,3068),i=1,7)/18., 3., 9.,15., 2.37E-03,3.21306E+05,  2./
      DATA (u(i,3069),i=1,7)/18., 3., 9., 9., 1.74E-03,3.37223E+05,  2./
      DATA (u(i,3070),i=1,7)/18., 3., 9.,15., 7.93E-04,3.18979E+05,  2./
      DATA (u(i,3071),i=1,7)/18., 3., 9., 9., 6.30E-04,3.34806E+05,  2./
      DATA (u(i,3072),i=1,7)/18., 3., 9., 3., 5.36E-04,3.22020E+05,  2./
      DATA (u(i,3073),i=1,7)/18., 3., 9.,15., 3.19E-05,3.14139E+05,  2./
      DATA (u(i,3074),i=1,7)/18., 4., 4.,12., 1.27E+01,2.24881E+05,  3./
      DATA (u(i,3075),i=1,7)/18., 4., 4.,12., 4.97E-01,2.55102E+05,  2./
      DATA (u(i,3076),i=1,7)/18., 4., 4.,12., 3.05E-01,1.16372E+05,  3./
      DATA (u(i,3077),i=1,7)/18., 4., 4.,12., 1.57E-01,3.59337E+05,  2./
      DATA (u(i,3078),i=1,7)/18., 4., 4.,12., 6.73E-02,4.04302E+05,  2./
      DATA (u(i,3079),i=1,7)/18., 4., 4.,12., 3.23E-02,4.27991E+05,  2./
      DATA (u(i,3080),i=1,7)/18., 4., 4.,12., 2.83E-02,3.84172E+05,  2./
      DATA (u(i,3081),i=1,7)/18., 4., 4.,12., 2.27E-02,3.43006E+05,  2./
      DATA (u(i,3082),i=1,7)/18., 4., 4.,12., 2.08E-02,3.96589E+05,  2./
      DATA (u(i,3083),i=1,7)/18., 4., 4.,12., 2.06E-02,4.23298E+05,  2./
      DATA (u(i,3084),i=1,7)/18., 4., 4.,12., 1.99E-02,4.42048E+05,  2./
      DATA (u(i,3085),i=1,7)/18., 4., 4.,12., 1.38E-02,4.39097E+05,  2./
      DATA (u(i,3086),i=1,7)/18., 4., 4.,12., 1.20E-02,4.50938E+05,  2./
      DATA (u(i,3087),i=1,7)/18., 4., 4.,12., 1.17E-02,4.48893E+05,  2./
      DATA (u(i,3088),i=1,7)/18., 4., 4.,12., 7.36E-03,4.57018E+05,  2./
      DATA (u(i,3089),i=1,7)/18., 4., 4.,12., 6.76E-03,4.55643E+05,  2./
      DATA (u(i,3090),i=1,7)/18., 4., 4.,12., 4.77E-03,4.37025E+05,  2./
      DATA (u(i,3091),i=1,7)/18., 4., 4.,12., 1.86E-03,4.60257E+05,  2./
      DATA (u(i,3092),i=1,7)/18., 4., 4.,12., 1.11E-03,4.61318E+05,  2./
      DATA (u(i,3093),i=1,7)/18., 4., 4.,12., 8.36E-04,4.53618E+05,  2./
      DATA (u(i,3094),i=1,7)/18., 4., 4.,12., 3.59E-04,4.19956E+05,  2./
      DATA (u(i,3095),i=1,7)/18., 5., 9.,15., 1.27E+01,2.26321E+05,  3./
      DATA (u(i,3096),i=1,7)/18., 5., 9., 9., 5.24E+00,2.19346E+05,  3./
      DATA (u(i,3097),i=1,7)/18., 5., 9., 3., 2.79E+00,1.94882E+05,  3./
      DATA (u(i,3098),i=1,7)/18., 5., 9., 9., 1.28E+00,2.96402E+05,  2./
      DATA (u(i,3099),i=1,7)/18., 5., 9., 9., 5.45E-01,1.40111E+05,  3./
      DATA (u(i,3100),i=1,7)/18., 5., 9.,15., 3.78E-01,1.17933E+05,  3./
      DATA (u(i,3101),i=1,7)/18., 5., 9., 9., 2.64E-01,4.31760E+05,  2./
      DATA (u(i,3102),i=1,7)/18., 5., 9.,15., 1.99E-01,4.75443E+05,  2./
      DATA (u(i,3103),i=1,7)/18., 5., 9.,15., 1.84E-01,5.15039E+05,  2./
      DATA (u(i,3104),i=1,7)/18., 5., 9.,15., 1.69E-01,4.42988E+05,  2./
      DATA (u(i,3105),i=1,7)/18., 5., 9., 9., 1.30E-01,4.48571E+05,  2./
      DATA (u(i,3106),i=1,7)/18., 5., 9.,15., 1.27E-01,3.96778E+05,  2./
      DATA (u(i,3107),i=1,7)/18., 5., 9., 9., 1.23E-01,4.93340E+05,  2./
      DATA (u(i,3108),i=1,7)/18., 5., 9.,15., 1.04E-01,5.49994E+05,  2./
      DATA (u(i,3109),i=1,7)/18., 5., 9., 9., 6.88E-02,5.26039E+05,  2./
      DATA (u(i,3110),i=1,7)/18., 5., 9., 9., 5.58E-02,5.51998E+05,  2./
      DATA (u(i,3111),i=1,7)/18., 5., 9.,15., 5.45E-02,5.25845E+05,  2./
      DATA (u(i,3112),i=1,7)/18., 5., 9., 3., 4.84E-02,4.31276E+05,  2./
      DATA (u(i,3113),i=1,7)/18., 5., 9., 9., 4.84E-02,4.76145E+05,  2./
      DATA (u(i,3114),i=1,7)/18., 5., 9., 9., 4.07E-02,5.17866E+05,  2./
      DATA (u(i,3115),i=1,7)/18., 5., 9.,15., 3.79E-02,5.54785E+05,  2./
      DATA (u(i,3116),i=1,7)/18., 5., 9., 9., 3.29E-02,4.01139E+05,  2./
      DATA (u(i,3117),i=1,7)/18., 5., 9.,15., 3.15E-02,5.40774E+05,  2./
      DATA (u(i,3118),i=1,7)/18., 5., 9., 3., 2.92E-02,5.47046E+05,  2./
      DATA (u(i,3119),i=1,7)/18., 5., 9.,15., 2.40E-02,5.66572E+05,  2./
      DATA (u(i,3120),i=1,7)/18., 5., 9., 9., 2.24E-02,5.46299E+05,  2./
      DATA (u(i,3121),i=1,7)/18., 5., 9.,15., 2.12E-02,5.72836E+05,  2./
      DATA (u(i,3122),i=1,7)/18., 5., 9., 9., 2.01E-02,5.59253E+05,  2./
      DATA (u(i,3123),i=1,7)/18., 5., 9., 9., 1.60E-02,5.56204E+05,  2./
      DATA (u(i,3124),i=1,7)/18., 5., 9., 3., 1.31E-02,5.98265E+05,  2./
      DATA (u(i,3125),i=1,7)/18., 5., 9., 9., 1.20E-02,4.78675E+05,  2./
      DATA (u(i,3126),i=1,7)/18., 5., 9., 9., 1.15E-02,5.10960E+05,  2./
      DATA (u(i,3127),i=1,7)/18., 5., 9.,15., 1.02E-02,4.86358E+05,  3./
      DATA (u(i,3128),i=1,7)/18., 5., 9., 9., 9.29E-03,5.68053E+05,  2./
      DATA (u(i,3129),i=1,7)/18., 5., 9., 9., 8.56E-03,5.65675E+05,  2./
      DATA (u(i,3130),i=1,7)/18., 5., 9., 9., 8.49E-03,5.41272E+05,  2./
      DATA (u(i,3131),i=1,7)/18., 5., 9., 3., 7.06E-03,6.35890E+05,  2./
      DATA (u(i,3132),i=1,7)/18., 5., 9., 9., 6.80E-03,5.29184E+05,  2./
      DATA (u(i,3133),i=1,7)/18., 5., 9.,15., 6.75E-03,5.37982E+05,  2./
      DATA (u(i,3134),i=1,7)/18., 5., 9., 9., 5.72E-03,5.72705E+05,  2./
      DATA (u(i,3135),i=1,7)/18., 5., 9., 3., 5.71E-03,6.27392E+05,  2./
      DATA (u(i,3136),i=1,7)/18., 5., 9., 3., 5.21E-03,5.28877E+05,  2./
      DATA (u(i,3137),i=1,7)/18., 5., 9., 3., 5.11E-03,6.45536E+05,  2./
      DATA (u(i,3138),i=1,7)/18., 5., 9.,15., 4.95E-03,4.38770E+05,  3./
      DATA (u(i,3139),i=1,7)/18., 5., 9., 9., 4.61E-03,5.69963E+05,  2./
      DATA (u(i,3140),i=1,7)/18., 5., 9., 3., 3.64E-03,6.57549E+05,  2./
      DATA (u(i,3141),i=1,7)/18., 5., 9.,15., 3.24E-03,5.72148E+05,  2./
      DATA (u(i,3142),i=1,7)/18., 5., 9., 3., 2.67E-03,5.37721E+05,  3./
      DATA (u(i,3143),i=1,7)/18., 5., 9., 9., 2.45E-03,4.85531E+05,  3./
      DATA (u(i,3144),i=1,7)/18., 5., 9., 9., 2.31E-03,5.73230E+05,  3./
      DATA (u(i,3145),i=1,7)/18., 5., 9., 3., 2.29E-03,6.65646E+05,  2./
      DATA (u(i,3146),i=1,7)/18., 5., 9.,15., 1.85E-03,5.12111E+05,  3./
      DATA (u(i,3147),i=1,7)/18., 5., 9.,15., 1.46E-03,5.62651E+05,  2./
      DATA (u(i,3148),i=1,7)/18., 5., 9.,15., 5.62E-04,5.17706E+05,  3./
      DATA (u(i,3149),i=1,7)/18., 5., 9.,15., 4.30E-04,4.70898E+05,  2./
      DATA (u(i,3150),i=1,7)/18., 5., 9., 3., 4.12E-04,6.52997E+05,  2./
      DATA (u(i,3151),i=1,7)/18., 5., 9., 3., 3.38E-04,4.83887E+05,  3./
      DATA (u(i,3152),i=1,7)/18., 5., 9., 9., 3.31E-04,5.66123E+05,  2./
      DATA (u(i,3153),i=1,7)/18., 5., 9.,15., 1.35E-04,5.60475E+05,  2./
      DATA (u(i,3154),i=1,7)/18., 5., 9., 9., 1.30E-04,5.53495E+05,  3./
      DATA (u(i,3155),i=1,7)/18., 5., 9., 9., 1.14E-04,4.91473E+05,  3./
      DATA (u(i,3156),i=1,7)/18., 6., 6.,10., 5.65E+00,2.18484E+05,  3./
      DATA (u(i,3157),i=1,7)/18., 6., 6., 6., 3.93E+00,1.83614E+05,  3./
      DATA (u(i,3158),i=1,7)/18., 6., 6., 2., 5.25E-01,1.70129E+05,  3./
      DATA (u(i,3159),i=1,7)/18., 6., 6., 2., 4.96E-01,3.42009E+05,  2./
      DATA (u(i,3160),i=1,7)/18., 6., 6.,10., 3.90E-01,1.28742E+05,  3./
      DATA (u(i,3161),i=1,7)/18., 6., 6.,10., 2.68E-01,4.52325E+05,  2./
      DATA (u(i,3162),i=1,7)/18., 6., 6.,10., 2.41E-01,5.52761E+05,  2./
      DATA (u(i,3163),i=1,7)/18., 6., 6.,10., 2.27E-01,5.16636E+05,  2./
      DATA (u(i,3164),i=1,7)/18., 6., 6., 6., 1.59E-01,4.95000E+05,  2./
      DATA (u(i,3165),i=1,7)/18., 6., 6.,10., 1.25E-01,6.47291E+05,  2./
      DATA (u(i,3166),i=1,7)/18., 6., 6.,10., 1.13E-01,5.02892E+05,  3./
      DATA (u(i,3167),i=1,7)/18., 6., 6., 2., 8.82E-02,5.07769E+05,  2./
      DATA (u(i,3168),i=1,7)/18., 6., 6.,10., 7.12E-02,6.46120E+05,  2./
      DATA (u(i,3169),i=1,7)/18., 6., 6.,10., 6.28E-02,6.14137E+05,  2./
      DATA (u(i,3170),i=1,7)/18., 6., 6., 6., 6.18E-02,5.04388E+05,  3./
      DATA (u(i,3171),i=1,7)/18., 6., 6., 2., 6.01E-02,5.27148E+05,  2./
      DATA (u(i,3172),i=1,7)/18., 6., 6., 6., 5.82E-02,5.60884E+05,  2./
      DATA (u(i,3173),i=1,7)/18., 6., 6., 6., 5.45E-02,6.48004E+05,  2./
      DATA (u(i,3174),i=1,7)/18., 6., 6., 6., 5.02E-02,7.11946E+05,  2./
      DATA (u(i,3175),i=1,7)/18., 6., 6.,10., 3.74E-02,6.67067E+05,  2./
      DATA (u(i,3176),i=1,7)/18., 6., 6.,10., 3.18E-02,6.91085E+05,  2./
      DATA (u(i,3177),i=1,7)/18., 6., 6.,10., 3.04E-02,6.13949E+05,  2./
      DATA (u(i,3178),i=1,7)/18., 6., 6., 6., 3.03E-02,6.25117E+05,  2./
      DATA (u(i,3179),i=1,7)/18., 6., 6., 2., 2.97E-02,5.87302E+05,  2./
      DATA (u(i,3180),i=1,7)/18., 6., 6., 6., 2.41E-02,7.50976E+05,  2./
      DATA (u(i,3181),i=1,7)/18., 6., 6., 2., 2.05E-02,6.51593E+05,  2./
      DATA (u(i,3182),i=1,7)/18., 6., 6.,10., 1.90E-02,5.58223E+05,  3./
      DATA (u(i,3183),i=1,7)/18., 6., 6.,10., 1.77E-02,6.82640E+05,  2./
      DATA (u(i,3184),i=1,7)/18., 6., 6., 2., 1.68E-02,6.30239E+05,  2./
      DATA (u(i,3185),i=1,7)/18., 6., 6., 6., 1.65E-02,7.00329E+05,  2./
      DATA (u(i,3186),i=1,7)/18., 6., 6., 6., 1.58E-02,7.74653E+05,  2./
      DATA (u(i,3187),i=1,7)/18., 6., 6., 2., 1.39E-02,6.56771E+05,  2./
      DATA (u(i,3188),i=1,7)/18., 6., 6., 2., 1.33E-02,5.65675E+05,  2./
      DATA (u(i,3189),i=1,7)/18., 6., 6.,10., 1.22E-02,6.80087E+05,  2./
      DATA (u(i,3190),i=1,7)/18., 6., 6., 6., 1.14E-02,7.68699E+05,  2./
      DATA (u(i,3191),i=1,7)/18., 6., 6., 2., 7.76E-03,6.74127E+05,  2./
      DATA (u(i,3192),i=1,7)/18., 6., 6., 6., 7.69E-03,7.92519E+05,  2./
      DATA (u(i,3193),i=1,7)/18., 6., 6., 6., 6.66E-03,8.07559E+05,  2./
      DATA (u(i,3194),i=1,7)/18., 6., 6., 6., 5.87E-03,8.03084E+05,  2./
      DATA (u(i,3195),i=1,7)/18., 6., 6., 2., 5.42E-03,6.86153E+05,  2./
      DATA (u(i,3196),i=1,7)/18., 6., 6., 2., 4.53E-03,4.99476E+05,  3./
      DATA (u(i,3197),i=1,7)/18., 6., 6.,10., 1.88E-03,5.37692E+05,  3./
      DATA (u(i,3198),i=1,7)/18., 6., 6.,10., 1.57E-03,6.56168E+05,  2./
      DATA (u(i,3199),i=1,7)/18., 6., 6., 6., 1.33E-03,6.10762E+05,  3./
      DATA (u(i,3200),i=1,7)/18., 6., 6.,10., 1.09E-03,4.74608E+05,  3./
      DATA (u(i,3201),i=1,7)/18., 6., 6.,10., 7.48E-04,6.91324E+05,  2./
      DATA (u(i,3202),i=1,7)/18., 6., 6., 6., 6.89E-04,4.49095E+05,  3./
      DATA (u(i,3203),i=1,7)/18., 6., 6.,10., 4.78E-04,6.07755E+05,  2./
      DATA (u(i,3204),i=1,7)/18., 6., 6., 6., 3.69E-04,7.85669E+05,  2./
      DATA (u(i,3205),i=1,7)/18., 6., 6., 2., 3.03E-04,6.02446E+05,  3./
      DATA (u(i,3206),i=1,7)/18., 6., 6., 6., 2.51E-04,7.23014E+05,  2./
      DATA (u(i,3207),i=1,7)/18., 6., 6., 6., 1.46E-04,7.29341E+05,  2./
      DATA (u(i,3208),i=1,7)/18., 6., 6.,10., 1.33E-04,5.67795E+05,  2./
      DATA (u(i,3209),i=1,7)/18., 6., 6., 2., 1.29E-04,6.66533E+05,  2./
      DATA (u(i,3210),i=1,7)/18., 6., 6., 6., 1.21E-04,7.78938E+05,  2./
      DATA (u(i,3211),i=1,7)/18., 7., 1., 3., 1.24E+00,1.70343E+05,  3./
      DATA (u(i,3212),i=1,7)/18., 7., 1., 3., 1.79E-01,5.64844E+05,  2./
      DATA (u(i,3213),i=1,7)/18., 7., 1., 3., 6.52E-02,7.36106E+05,  2./
      DATA (u(i,3214),i=1,7)/18., 7., 1., 3., 3.16E-02,8.21288E+05,  2./
      DATA (u(i,3215),i=1,7)/18., 7., 1., 3., 1.70E-02,8.71232E+05,  2./
      DATA (u(i,3216),i=1,7)/18., 7., 1., 3., 1.21E-02,9.01469E+05,  2./
      DATA (u(i,3217),i=1,7)/18., 7., 1., 3., 6.25E-03,5.13637E+05,  3./
      DATA (u(i,3218),i=1,7)/18., 7., 1., 3., 5.38E-03,9.36944E+05,  2./
      DATA (u(i,3219),i=1,7)/18., 7., 1., 3., 4.34E-03,9.23617E+05,  2./
      DATA (u(i,3220),i=1,7)/18., 7., 1., 3., 2.98E-03,9.19371E+05,  2./
      DATA (u(i,3221),i=1,7)/18., 7., 1., 3., 7.26E-04,8.55212E+05,  2./
      DATA (u(i,3222),i=1,7)/18., 7., 1., 3., 5.20E-04,6.61113E+05,  2./
      DATA (u(i,3223),i=1,7)/18., 7., 1., 3., 4.22E-04,7.79970E+05,  2./
      DATA (u(i,3224),i=1,7)/18., 7., 1., 3., 3.32E-06,9.00009E+05,  2./
      DATA (u(i,3225),i=1,7)/18., 8., 2., 6., 1.13E+00,1.39901E+05,  3./
      DATA (u(i,3226),i=1,7)/18., 8., 2., 6., 2.47E-01,6.24142E+05,  2./
      DATA (u(i,3227),i=1,7)/18., 8., 2., 6., 8.69E-02,8.26856E+05,  2./
      DATA (u(i,3228),i=1,7)/18., 8., 2., 6., 4.16E-02,9.31359E+05,  2./
      DATA (u(i,3229),i=1,7)/18., 8., 2., 6., 2.35E-02,9.92260E+05,  2./
      DATA (u(i,3230),i=1,7)/18., 8., 2., 6., 1.46E-02,1.03093E+06,  2./
      DATA (u(i,3231),i=1,7)/18., 8., 2., 6., 9.80E-03,1.05697E+06,  2./
      DATA (u(i,3232),i=1,7)/18., 8., 2., 6., 6.90E-03,1.07527E+06,  2./
      DATA (u(i,3233),i=1,7)/18., 9., 1., 3., 2.02E+00,2.41896E+06, 19./
      DATA (u(i,3234),i=1,7)/18., 9., 1., 3., 5.25E-01,2.85796E+06, 20./
      DATA (u(i,3235),i=1,7)/18., 9., 1., 3., 3.33E-01,2.79174E+06,  2./
      DATA (u(i,3236),i=1,7)/18., 9., 1., 3., 2.78E-01,3.05904E+06,  2./
      DATA (u(i,3237),i=1,7)/18., 9., 1., 3., 2.39E-01,2.05973E+06, 21./
      DATA (u(i,3238),i=1,7)/18., 9., 1., 3., 1.53E-01,3.16857E+06,  2./
      DATA (u(i,3239),i=1,7)/18., 9., 1., 3., 9.40E-02,3.23520E+06,  2./
      DATA (u(i,3240),i=1,7)/18., 9., 1., 3., 6.23E-02,3.27761E+06,  2./
      DATA (u(i,3241),i=1,7)/18., 9., 1., 3., 5.14E-02,2.71961E+06, 22./
      DATA (u(i,3242),i=1,7)/18., 9., 1., 3., 4.39E-02,3.30688E+06,  2./
      DATA (u(i,3243),i=1,7)/18., 9., 1., 3., 3.28E-02,3.32779E+06,  2./
      DATA (u(i,3244),i=1,7)/18., 9., 1., 3., 1.50E-02,2.99312E+06,  2./
      DATA (u(i,3245),i=1,7)/18., 9., 1., 3., 7.82E-03,3.13185E+06,  2./
      DATA (u(i,3246),i=1,7)/18., 9., 1., 3., 4.65E-03,3.21234E+06,  2./
      DATA (u(i,3247),i=1,7)/18., 9., 1., 3., 3.06E-03,3.26264E+06,  2./
      DATA (u(i,3248),i=1,7)/18., 9., 1., 3., 2.17E-03,3.29707E+06,  2./
      DATA (u(i,3249),i=1,7)/18., 9., 1., 3., 1.67E-03,3.32116E+06,  2./
      DATA (u(i,3250),i=1,7)/18.,10., 6.,10., 4.34E+00,2.66454E+06,  2./
      DATA (u(i,3251),i=1,7)/18.,10., 6., 6., 3.40E+00,2.66454E+06,  2./
      DATA (u(i,3252),i=1,7)/18.,10., 6.,10., 2.43E+00,2.60213E+06,  2./
      DATA (u(i,3253),i=1,7)/18.,10., 6.,10., 1.23E+00,3.16256E+06,  2./
      DATA (u(i,3254),i=1,7)/18.,10., 6., 2., 9.81E-01,2.65111E+06,  2./
      DATA (u(i,3255),i=1,7)/18.,10., 6.,10., 9.00E-01,2.72702E+06,  2./
      DATA (u(i,3256),i=1,7)/18.,10., 6.,10., 7.05E-01,2.94724E+06,  2./
      DATA (u(i,3257),i=1,7)/18.,10., 6., 6., 6.63E-01,3.21958E+06,  2./
      DATA (u(i,3258),i=1,7)/18.,10., 6., 6., 6.53E-01,2.27687E+06,  2./
      DATA (u(i,3259),i=1,7)/18.,10., 6.,10., 6.36E-01,3.41647E+06,  2./
      DATA (u(i,3260),i=1,7)/18.,10., 6.,10., 6.27E-01,3.21958E+06,  2./
      DATA (u(i,3261),i=1,7)/18.,10., 6., 6., 5.15E-01,2.95072E+06,  2./
      DATA (u(i,3262),i=1,7)/18.,10., 6.,10., 4.89E-01,3.55492E+06,  2./
      DATA (u(i,3263),i=1,7)/18.,10., 6.,10., 4.06E-01,2.32666E+06,  2./
      DATA (u(i,3264),i=1,7)/18.,10., 6., 2., 3.88E-01,5.82988E+05,  3./
      DATA (u(i,3265),i=1,7)/18.,10., 6., 6., 3.18E-01,2.59875E+06,  2./
      DATA (u(i,3266),i=1,7)/18.,10., 6., 6., 3.14E-01,3.15956E+06,  2./
      DATA (u(i,3267),i=1,7)/18.,10., 6.,10., 2.86E-01,3.61925E+06,  2./
      DATA (u(i,3268),i=1,7)/18.,10., 6., 6., 2.55E-01,3.47705E+06,  2./
      DATA (u(i,3269),i=1,7)/18.,10., 6., 2., 2.36E-01,3.21854E+06,  2./
      DATA (u(i,3270),i=1,7)/18.,10., 6.,10., 2.19E-01,3.29272E+06,  2./
      DATA (u(i,3271),i=1,7)/18.,10., 6.,10., 2.12E-01,3.09119E+06,  2./
      DATA (u(i,3272),i=1,7)/18.,10., 6., 6., 2.06E-01,3.41530E+06,  2./
      DATA (u(i,3273),i=1,7)/18.,10., 6.,10., 2.05E-01,3.47705E+06,  2./
      DATA (u(i,3274),i=1,7)/18.,10., 6., 2., 1.98E-01,2.98864E+06,  2./
      DATA (u(i,3275),i=1,7)/18.,10., 6.,10., 1.85E-01,3.63636E+06,  2./
      DATA (u(i,3276),i=1,7)/18.,10., 6., 6., 1.73E-01,3.14070E+06,  2./
      DATA (u(i,3277),i=1,7)/18.,10., 6.,10., 1.54E-01,3.13283E+06,  2./
      DATA (u(i,3278),i=1,7)/18.,10., 6., 6., 1.33E-01,3.55366E+06,  2./
      DATA (u(i,3279),i=1,7)/18.,10., 6.,10., 1.22E-01,3.69276E+06,  2./
      DATA (u(i,3280),i=1,7)/18.,10., 6., 6., 1.21E-01,3.62188E+06,  2./
      DATA (u(i,3281),i=1,7)/18.,10., 6., 6., 1.19E-01,3.61402E+06,  2./
      DATA (u(i,3282),i=1,7)/18.,10., 6., 2., 1.13E-01,3.47584E+06,  2./
      DATA (u(i,3283),i=1,7)/18.,10., 6.,10., 9.67E-02,3.72717E+06,  2./
      DATA (u(i,3284),i=1,7)/18.,10., 6., 6., 8.72E-02,3.69959E+06,  2./
      DATA (u(i,3285),i=1,7)/18.,10., 6.,10., 7.92E-02,3.61664E+06,  2./
      DATA (u(i,3286),i=1,7)/18.,10., 6., 2., 7.61E-02,2.40385E+06,  2./
      DATA (u(i,3287),i=1,7)/18.,10., 6., 6., 7.26E-02,3.63636E+06,  2./
      DATA (u(i,3288),i=1,7)/18.,10., 6., 6., 6.97E-02,3.03582E+06,  2./
      DATA (u(i,3289),i=1,7)/18.,10., 6.,10., 6.61E-02,3.69959E+06,  2./
      DATA (u(i,3290),i=1,7)/18.,10., 6., 2., 6.34E-02,3.61533E+06,  2./
      DATA (u(i,3291),i=1,7)/18.,10., 6., 6., 5.58E-02,3.61533E+06,  2./
      DATA (u(i,3292),i=1,7)/18.,10., 6.,10., 5.53E-02,3.41880E+06,  2./
      DATA (u(i,3293),i=1,7)/18.,10., 6., 2., 4.74E-02,3.64431E+06,  2./
      DATA (u(i,3294),i=1,7)/18.,10., 6.,10., 4.69E-02,3.69004E+06,  2./
      DATA (u(i,3295),i=1,7)/18.,10., 6., 6., 4.48E-02,3.35570E+06,  2./
      DATA (u(i,3296),i=1,7)/18.,10., 6., 6., 3.30E-02,3.72578E+06,  2./
      DATA (u(i,3297),i=1,7)/18.,10., 6., 2., 3.22E-02,3.69959E+06,  2./
      DATA (u(i,3298),i=1,7)/18.,10., 6., 6., 3.01E-02,3.69004E+06,  2./
      DATA (u(i,3299),i=1,7)/18.,10., 6., 6., 2.38E-02,3.51989E+06,  2./
      DATA (u(i,3300),i=1,7)/18.,10., 6., 2., 2.30E-02,3.75375E+06,  2./
      DATA (u(i,3301),i=1,7)/18.,10., 6.,10., 2.04E-02,3.75235E+06,  2./
      DATA (u(i,3302),i=1,7)/18.,10., 6., 2., 1.62E-02,3.79075E+06,  2./
      DATA (u(i,3303),i=1,7)/18.,10., 6., 2., 1.49E-02,3.14465E+06,  2./
      DATA (u(i,3304),i=1,7)/18.,10., 6., 2., 1.45E-02,3.81098E+06,  2./
      DATA (u(i,3305),i=1,7)/18.,10., 6.,10., 1.24E-02,3.67918E+06,  2./
      DATA (u(i,3306),i=1,7)/18.,10., 6., 2., 9.61E-03,3.17763E+06,  2./
      DATA (u(i,3307),i=1,7)/18.,10., 6., 2., 6.54E-03,3.81679E+06,  2./
      DATA (u(i,3308),i=1,7)/18.,10., 6.,10., 6.51E-03,3.74112E+06,  2./
      DATA (u(i,3309),i=1,7)/18.,10., 6.,10., 6.16E-03,3.58295E+06,  2./
      DATA (u(i,3310),i=1,7)/18.,10., 6., 6., 5.44E-03,3.67647E+06,  2./
      DATA (u(i,3311),i=1,7)/18.,10., 6., 2., 3.94E-03,3.66032E+06,  2./
      DATA (u(i,3312),i=1,7)/18.,10., 6., 6., 3.81E-03,3.71747E+06,  2./
      DATA (u(i,3313),i=1,7)/18.,10., 6., 6., 3.65E-03,3.74532E+06,  2./
      DATA (u(i,3314),i=1,7)/18.,10., 6.,10., 2.21E-03,3.55114E+06,  2./
      DATA (u(i,3315),i=1,7)/18.,10., 6., 2., 1.17E-03,3.50508E+06,  2./
      DATA (u(i,3316),i=1,7)/18.,10., 6., 6., 1.02E-03,3.75235E+06,  2./
      DATA (u(i,3317),i=1,7)/18.,10., 6.,10., 6.84E-04,3.70508E+06,  2./
      DATA (u(i,3318),i=1,7)/18.,10., 6., 2., 1.70E-04,3.81825E+06,  2./
      DATA (u(i,3319),i=1,7)/18.,10., 6., 2., 4.46E-05,3.49528E+06,  2./
      DATA (u(i,3320),i=1,7)/18.,10., 6., 2., 1.31E-05,3.75657E+06,  2./
      DATA (u(i,3321),i=1,7)/18.,11., 9.,15., 4.49E+00,2.90192E+06,  2./
      DATA (u(i,3322),i=1,7)/18.,11., 9.,15., 4.40E+00,2.95946E+06,  2./
      DATA (u(i,3323),i=1,7)/18.,11., 9., 9., 4.29E+00,2.91290E+06,  2./
      DATA (u(i,3324),i=1,7)/18.,11., 9.,15., 2.29E+00,2.81690E+06,  2./
      DATA (u(i,3325),i=1,7)/18.,11., 9., 3., 1.45E+00,2.92398E+06,  2./
      DATA (u(i,3326),i=1,7)/18.,11., 9.,15., 1.16E+00,3.49284E+06,  2./
      DATA (u(i,3327),i=1,7)/18.,11., 9.,15., 1.13E+00,3.10752E+06,  2./
      DATA (u(i,3328),i=1,7)/18.,11., 9., 9., 1.01E+00,5.13611E+05,  3./
      DATA (u(i,3329),i=1,7)/18.,11., 9., 9., 8.69E-01,3.58551E+06,  2./
      DATA (u(i,3330),i=1,7)/18.,11., 9.,15., 8.62E-01,3.63636E+06,  2./
      DATA (u(i,3331),i=1,7)/18.,11., 9.,15., 8.14E-01,3.57910E+06,  2./
      DATA (u(i,3332),i=1,7)/18.,11., 9., 9., 7.19E-01,3.12695E+06,  2./
      DATA (u(i,3333),i=1,7)/18.,11., 9.,15., 6.72E-01,3.79939E+06,  2./
      DATA (u(i,3334),i=1,7)/18.,11., 9.,15., 6.00E-01,2.58933E+06,  2./
      DATA (u(i,3335),i=1,7)/18.,11., 9.,15., 5.76E-01,3.38639E+06,  2./
      DATA (u(i,3336),i=1,7)/18.,11., 9., 9., 5.67E-01,3.89408E+06,  2./
      DATA (u(i,3337),i=1,7)/18.,11., 9., 9., 4.40E-01,2.94551E+06,  2./
      DATA (u(i,3338),i=1,7)/18.,11., 9.,15., 4.12E-01,3.88199E+06,  2./
      DATA (u(i,3339),i=1,7)/18.,11., 9., 3., 3.94E-01,2.51889E+06,  2./
      DATA (u(i,3340),i=1,7)/18.,11., 9., 3., 3.73E-01,3.58938E+06,  2./
      DATA (u(i,3341),i=1,7)/18.,11., 9., 9., 3.40E-01,2.64620E+06,  2./
      DATA (u(i,3342),i=1,7)/18.,11., 9., 3., 3.17E-01,3.11721E+06,  2./
      DATA (u(i,3343),i=1,7)/18.,11., 9.,15., 3.11E-01,3.96668E+06,  2./
      DATA (u(i,3344),i=1,7)/18.,11., 9.,15., 2.86E-01,3.89105E+06,  2./
      DATA (u(i,3345),i=1,7)/18.,11., 9.,15., 2.67E-01,3.94633E+06,  2./
      DATA (u(i,3346),i=1,7)/18.,11., 9.,15., 2.66E-01,4.06669E+06,  2./
      DATA (u(i,3347),i=1,7)/18.,11., 9., 9., 2.50E-01,3.63240E+06,  2./
      DATA (u(i,3348),i=1,7)/18.,11., 9., 9., 1.96E-01,4.06174E+06,  2./
      DATA (u(i,3349),i=1,7)/18.,11., 9., 3., 1.73E-01,3.89560E+06,  2./
      DATA (u(i,3350),i=1,7)/18.,11., 9.,15., 1.69E-01,4.11523E+06,  2./
      DATA (u(i,3351),i=1,7)/18.,11., 9.,15., 1.67E-01,4.17362E+06,  2./
      DATA (u(i,3352),i=1,7)/18.,11., 9., 9., 1.52E-01,4.16146E+06,  2./
      DATA (u(i,3353),i=1,7)/18.,11., 9.,15., 1.46E-01,4.13052E+06,  2./
      DATA (u(i,3354),i=1,7)/18.,11., 9., 9., 1.43E-01,3.28084E+06,  2./
      DATA (u(i,3355),i=1,7)/18.,11., 9., 9., 1.30E-01,3.38295E+06,  2./
      DATA (u(i,3356),i=1,7)/18.,11., 9., 9., 1.07E-01,3.94477E+06,  2./
      DATA (u(i,3357),i=1,7)/18.,11., 9., 3., 9.47E-02,3.41413E+06,  2./
      DATA (u(i,3358),i=1,7)/18.,11., 9.,15., 9.34E-02,3.96354E+06,  2./
      DATA (u(i,3359),i=1,7)/18.,11., 9.,15., 9.33E-02,4.15973E+06,  2./
      DATA (u(i,3360),i=1,7)/18.,11., 9., 3., 8.70E-02,3.88350E+06,  2./
      DATA (u(i,3361),i=1,7)/18.,11., 9., 9., 8.55E-02,4.22654E+06,  2./
      DATA (u(i,3362),i=1,7)/18.,11., 9., 3., 8.18E-02,4.06174E+06,  2./
      DATA (u(i,3363),i=1,7)/18.,11., 9., 9., 7.87E-02,4.22654E+06,  2./
      DATA (u(i,3364),i=1,7)/18.,11., 9.,15., 7.60E-02,3.46620E+06,  2./
      DATA (u(i,3365),i=1,7)/18.,11., 9., 9., 6.97E-02,3.35683E+06,  2./
      DATA (u(i,3366),i=1,7)/18.,11., 9., 9., 6.01E-02,4.11353E+06,  2./
      DATA (u(i,3367),i=1,7)/18.,11., 9.,15., 5.87E-02,4.05844E+06,  2./
      DATA (u(i,3368),i=1,7)/18.,11., 9., 3., 5.79E-02,4.16146E+06,  2./
      DATA (u(i,3369),i=1,7)/18.,11., 9., 9., 5.70E-02,4.17014E+06,  2./
      DATA (u(i,3370),i=1,7)/18.,11., 9.,15., 5.69E-02,4.17537E+06,  2./
      DATA (u(i,3371),i=1,7)/18.,11., 9.,15., 5.65E-02,4.20698E+06,  2./
      DATA (u(i,3372),i=1,7)/18.,11., 9., 9., 5.61E-02,3.52113E+06,  2./
      DATA (u(i,3373),i=1,7)/18.,11., 9.,15., 4.79E-02,3.97614E+06,  2./
      DATA (u(i,3374),i=1,7)/18.,11., 9., 9., 4.51E-02,3.89712E+06,  2./
      DATA (u(i,3375),i=1,7)/18.,11., 9., 9., 4.18E-02,4.27168E+06,  2./
      DATA (u(i,3376),i=1,7)/18.,11., 9., 9., 4.10E-02,3.88802E+06,  2./
      DATA (u(i,3377),i=1,7)/18.,11., 9., 3., 3.90E-02,3.37382E+06,  2./
      DATA (u(i,3378),i=1,7)/18.,11., 9., 9., 3.31E-02,4.21585E+06,  2./
      DATA (u(i,3379),i=1,7)/18.,11., 9., 9., 3.24E-02,4.30293E+06,  2./
      DATA (u(i,3380),i=1,7)/18.,11., 9., 3., 2.99E-02,3.74112E+06,  2./
      DATA (u(i,3381),i=1,7)/18.,11., 9., 9., 2.04E-02,4.28082E+06,  2./
      DATA (u(i,3382),i=1,7)/18.,11., 9.,15., 2.01E-02,3.83289E+06,  2./
      DATA (u(i,3383),i=1,7)/18.,11., 9., 3., 1.60E-02,4.18060E+06,  2./
      DATA (u(i,3384),i=1,7)/18.,11., 9., 9., 1.58E-02,3.94477E+06,  2./
      DATA (u(i,3385),i=1,7)/18.,11., 9.,15., 1.43E-02,4.02576E+06,  2./
      DATA (u(i,3386),i=1,7)/18.,11., 9.,15., 1.32E-02,4.14079E+06,  2./
      DATA (u(i,3387),i=1,7)/18.,11., 9., 3., 9.02E-03,4.04531E+06,  2./
      DATA (u(i,3388),i=1,7)/18.,11., 9.,15., 7.35E-03,4.04367E+06,  2./
      DATA (u(i,3389),i=1,7)/18.,11., 9., 9., 6.37E-03,4.08330E+06,  2./
      DATA (u(i,3390),i=1,7)/18.,11., 9., 9., 5.89E-03,4.26986E+06,  2./
      DATA (u(i,3391),i=1,7)/18.,11., 9., 3., 4.75E-03,4.19992E+06,  2./
      DATA (u(i,3392),i=1,7)/18.,11., 9., 3., 4.19E-03,4.11692E+06,  2./
      DATA (u(i,3393),i=1,7)/18.,11., 9., 3., 3.60E-03,3.93391E+06,  2./
      DATA (u(i,3394),i=1,7)/18.,11., 9.,15., 3.34E-03,3.26584E+06,  2./
      DATA (u(i,3395),i=1,7)/18.,11., 9., 9., 2.55E-03,4.14079E+06,  2./
      DATA (u(i,3396),i=1,7)/18.,11., 9.,15., 1.14E-03,4.12371E+06,  2./
      DATA (u(i,3397),i=1,7)/18.,11., 9., 3., 6.54E-04,4.16493E+06,  2./
      DATA (u(i,3398),i=1,7)/18.,11., 9., 9., 4.02E-04,4.12201E+06,  2./
      DATA (u(i,3399),i=1,7)/18.,11., 9., 9., 3.68E-04,3.69549E+06,  2./
      DATA (u(i,3400),i=1,7)/18.,11., 9., 9., 3.10E-04,4.04367E+06,  2./
      DATA (u(i,3401),i=1,7)/18.,11., 9., 9., 9.76E-05,4.19815E+06,  2./
      DATA (u(i,3402),i=1,7)/18.,12., 4.,12., 6.95E+00,3.18674E+06,  2./
      DATA (u(i,3403),i=1,7)/18.,12., 4.,12., 1.53E+00,3.98883E+06,  2./
      DATA (u(i,3404),i=1,7)/18.,12., 4.,12., 9.73E-01,3.24254E+06,  2./
      DATA (u(i,3405),i=1,7)/18.,12., 4.,12., 5.68E-01,4.35540E+06,  2./
      DATA (u(i,3406),i=1,7)/18.,12., 4.,12., 5.58E-01,4.38558E+05,  3./
      DATA (u(i,3407),i=1,7)/18.,12., 4.,12., 4.40E-01,2.88351E+06,  2./
      DATA (u(i,3408),i=1,7)/18.,12., 4.,12., 4.02E-01,3.62450E+06,  2./
      DATA (u(i,3409),i=1,7)/18.,12., 4.,12., 3.59E-01,4.12541E+06,  2./
      DATA (u(i,3410),i=1,7)/18.,12., 4.,12., 3.10E-01,4.54959E+06,  2./
      DATA (u(i,3411),i=1,7)/18.,12., 4.,12., 1.80E-01,4.67508E+06,  2./
      DATA (u(i,3412),i=1,7)/18.,12., 4.,12., 1.56E-01,4.51671E+06,  2./
      DATA (u(i,3413),i=1,7)/18.,12., 4.,12., 1.20E-01,4.55581E+06,  2./
      DATA (u(i,3414),i=1,7)/18.,12., 4.,12., 1.17E-01,4.75059E+06,  2./
      DATA (u(i,3415),i=1,7)/18.,12., 4.,12., 8.17E-02,4.72144E+06,  2./
      DATA (u(i,3416),i=1,7)/18.,12., 4.,12., 8.06E-02,4.80307E+06,  2./
      DATA (u(i,3417),i=1,7)/18.,12., 4.,12., 7.31E-02,3.51000E+06,  2./
      DATA (u(i,3418),i=1,7)/18.,12., 4.,12., 6.04E-02,4.52284E+06,  2./
      DATA (u(i,3419),i=1,7)/18.,12., 4.,12., 5.72E-02,4.84262E+06,  2./
      DATA (u(i,3420),i=1,7)/18.,12., 4.,12., 5.54E-02,3.87597E+06,  2./
      DATA (u(i,3421),i=1,7)/18.,12., 4.,12., 4.87E-02,4.35730E+06,  2./
      DATA (u(i,3422),i=1,7)/18.,12., 4.,12., 4.42E-02,4.11692E+06,  2./
      DATA (u(i,3423),i=1,7)/18.,12., 4.,12., 2.88E-02,4.29738E+06,  2./
      DATA (u(i,3424),i=1,7)/18.,12., 4.,12., 2.77E-02,3.46260E+06,  2./
      DATA (u(i,3425),i=1,7)/18.,12., 4.,12., 1.31E-02,4.37445E+06,  2./
      DATA (u(i,3426),i=1,7)/18.,12., 4.,12., 5.29E-03,4.65549E+06,  2./
      DATA (u(i,3427),i=1,7)/18.,12., 4.,12., 4.83E-03,3.84615E+06,  2./
      DATA (u(i,3428),i=1,7)/18.,12., 4.,12., 3.94E-03,4.73709E+06,  2./
      DATA (u(i,3429),i=1,7)/18.,12., 4.,12., 3.19E-03,4.42087E+06,  2./
      DATA (u(i,3430),i=1,7)/18.,12., 4.,12., 3.07E-03,4.79616E+06,  2./
      DATA (u(i,3431),i=1,7)/18.,12., 4.,12., 3.03E-03,4.82859E+06,  2./
      DATA (u(i,3432),i=1,7)/18.,12., 4.,12., 2.70E-03,4.76417E+06,  2./
      DATA (u(i,3433),i=1,7)/18.,12., 4.,12., 1.72E-03,4.83559E+06,  2./
      DATA (u(i,3434),i=1,7)/18.,12., 4.,12., 9.11E-04,4.75511E+06,  2./
      DATA (u(i,3435),i=1,7)/18.,12., 4.,12., 4.70E-04,4.78927E+06,  2./
      DATA (u(i,3436),i=1,7)/18.,13., 9.,15., 8.15E+00,3.39674E+06,  2./
      DATA (u(i,3437),i=1,7)/18.,13., 9., 9., 2.68E+00,3.40368E+06,  2./
      DATA (u(i,3438),i=1,7)/18.,13., 9.,15., 1.73E+00,3.50018E+06,  2./
      DATA (u(i,3439),i=1,7)/18.,13., 9.,15., 1.67E+00,4.33463E+06,  2./
      DATA (u(i,3440),i=1,7)/18.,13., 9., 9., 1.03E+00,3.52113E+06,  2./
      DATA (u(i,3441),i=1,7)/18.,13., 9.,15., 7.36E-01,4.76417E+06,  2./
      DATA (u(i,3442),i=1,7)/18.,13., 9., 3., 6.30E-01,5.97657E+05,  3./
      DATA (u(i,3443),i=1,7)/18.,13., 9., 9., 5.54E-01,4.33651E+06,  2./
      DATA (u(i,3444),i=1,7)/18.,13., 9., 9., 5.46E-01,3.13381E+06,  2./
      DATA (u(i,3445),i=1,7)/18.,13., 9., 9., 5.36E-01,4.60617E+05,  3./
      DATA (u(i,3446),i=1,7)/18.,13., 9.,15., 5.22E-01,4.50450E+06,  2./
      DATA (u(i,3447),i=1,7)/18.,13., 9.,15., 4.80E-01,3.89393E+05,  3./
      DATA (u(i,3448),i=1,7)/18.,13., 9., 3., 3.87E-01,3.44353E+06,  2./
      DATA (u(i,3449),i=1,7)/18.,13., 9.,15., 3.71E-01,3.77216E+06,  2./
      DATA (u(i,3450),i=1,7)/18.,13., 9.,15., 3.28E-01,4.99750E+06,  2./
      DATA (u(i,3451),i=1,7)/18.,13., 9., 9., 3.01E-01,4.51264E+06,  2./
      DATA (u(i,3452),i=1,7)/18.,13., 9.,15., 2.24E-01,4.95295E+06,  2./
      DATA (u(i,3453),i=1,7)/18.,13., 9., 9., 2.18E-01,4.76417E+06,  2./
      DATA (u(i,3454),i=1,7)/18.,13., 9., 9., 2.17E-01,3.78788E+06,  2./
      DATA (u(i,3455),i=1,7)/18.,13., 9.,15., 2.05E-01,3.66032E+06,  2./
      DATA (u(i,3456),i=1,7)/18.,13., 9.,15., 1.94E-01,5.13611E+06,  2./
      DATA (u(i,3457),i=1,7)/18.,13., 9., 9., 1.35E-01,3.76364E+06,  2./
      DATA (u(i,3458),i=1,7)/18.,13., 9., 3., 1.32E-01,3.79075E+06,  2./
      DATA (u(i,3459),i=1,7)/18.,13., 9.,15., 1.26E-01,5.22739E+06,  2./
      DATA (u(i,3460),i=1,7)/18.,13., 9.,15., 1.14E-01,5.19480E+06,  2./
      DATA (u(i,3461),i=1,7)/18.,13., 9., 9., 1.09E-01,4.95786E+06,  2./
      DATA (u(i,3462),i=1,7)/18.,13., 9., 9., 1.09E-01,4.99750E+06,  2./
      DATA (u(i,3463),i=1,7)/18.,13., 9., 3., 1.06E-01,4.48632E+06,  2./
      DATA (u(i,3464),i=1,7)/18.,13., 9.,15., 1.04E-01,4.80077E+06,  2./
      DATA (u(i,3465),i=1,7)/18.,13., 9., 9., 8.94E-02,4.80538E+06,  2./
      DATA (u(i,3466),i=1,7)/18.,13., 9., 9., 8.83E-02,4.23370E+06,  2./
      DATA (u(i,3467),i=1,7)/18.,13., 9.,15., 7.92E-02,5.28821E+06,  2./
      DATA (u(i,3468),i=1,7)/18.,13., 9.,15., 6.55E-02,5.25762E+06,  2./
      DATA (u(i,3469),i=1,7)/18.,13., 9., 9., 6.21E-02,5.13611E+06,  2./
      DATA (u(i,3470),i=1,7)/18.,13., 9., 9., 6.17E-02,3.68053E+06,  2./
      DATA (u(i,3471),i=1,7)/18.,13., 9., 9., 5.89E-02,4.71476E+06,  2./
      DATA (u(i,3472),i=1,7)/18.,13., 9.,15., 5.66E-02,5.33333E+06,  2./
      DATA (u(i,3473),i=1,7)/18.,13., 9., 9., 5.60E-02,5.19751E+06,  2./
      DATA (u(i,3474),i=1,7)/18.,13., 9.,15., 5.33E-02,4.18235E+06,  2./
      DATA (u(i,3475),i=1,7)/18.,13., 9.,15., 4.98E-02,4.27899E+06,  2./
      DATA (u(i,3476),i=1,7)/18.,13., 9., 9., 4.75E-02,5.26039E+06,  2./
      DATA (u(i,3477),i=1,7)/18.,13., 9., 3., 4.55E-02,4.81232E+06,  2./
      DATA (u(i,3478),i=1,7)/18.,13., 9., 9., 4.08E-02,5.22739E+06,  2./
      DATA (u(i,3479),i=1,7)/18.,13., 9., 3., 3.86E-02,3.89560E+06,  2./
      DATA (u(i,3480),i=1,7)/18.,13., 9., 3., 3.67E-02,4.95540E+06,  2./
      DATA (u(i,3481),i=1,7)/18.,13., 9.,15., 3.30E-02,4.08998E+06,  2./
      DATA (u(i,3482),i=1,7)/18.,13., 9., 9., 2.99E-02,4.97018E+06,  2./
      DATA (u(i,3483),i=1,7)/18.,13., 9.,15., 2.71E-02,5.20291E+06,  2./
      DATA (u(i,3484),i=1,7)/18.,13., 9., 9., 2.61E-02,5.28821E+06,  2./
      DATA (u(i,3485),i=1,7)/18.,13., 9., 3., 2.21E-02,5.18941E+06,  2./
      DATA (u(i,3486),i=1,7)/18.,13., 9., 9., 2.13E-02,4.19815E+06,  2./
      DATA (u(i,3487),i=1,7)/18.,13., 9., 9., 2.01E-02,5.19751E+06,  2./
      DATA (u(i,3488),i=1,7)/18.,13., 9., 3., 1.95E-02,5.26316E+06,  2./
      DATA (u(i,3489),i=1,7)/18.,13., 9., 9., 1.88E-02,5.33333E+06,  2./
      DATA (u(i,3490),i=1,7)/18.,13., 9., 9., 1.76E-02,4.78011E+06,  2./
      DATA (u(i,3491),i=1,7)/18.,13., 9., 9., 1.73E-02,4.26439E+06,  2./
      DATA (u(i,3492),i=1,7)/18.,13., 9.,15., 1.60E-02,3.93856E+06,  2./
      DATA (u(i,3493),i=1,7)/18.,13., 9., 3., 1.46E-02,5.33333E+06,  2./
      DATA (u(i,3494),i=1,7)/18.,13., 9., 9., 1.38E-02,5.10986E+06,  2./
      DATA (u(i,3495),i=1,7)/18.,13., 9., 3., 1.29E-02,5.50358E+06,  2./
      DATA (u(i,3496),i=1,7)/18.,13., 9.,15., 1.09E-02,5.02008E+06,  2./
      DATA (u(i,3497),i=1,7)/18.,13., 9., 9., 1.08E-02,5.21376E+06,  2./
      DATA (u(i,3498),i=1,7)/18.,13., 9.,15., 1.08E-02,5.09944E+06,  2./
      DATA (u(i,3499),i=1,7)/18.,13., 9., 3., 1.03E-02,4.21408E+06,  2./
      DATA (u(i,3500),i=1,7)/18.,13., 9., 3., 9.23E-03,4.91400E+06,  2./
      DATA (u(i,3501),i=1,7)/18.,13., 9., 3., 8.46E-03,5.42888E+06,  2./
      DATA (u(i,3502),i=1,7)/18.,13., 9., 9., 6.22E-03,4.03388E+06,  2./
      DATA (u(i,3503),i=1,7)/18.,13., 9.,15., 5.92E-03,4.74158E+06,  2./
      DATA (u(i,3504),i=1,7)/18.,13., 9., 3., 5.71E-03,5.53710E+06,  2./
      DATA (u(i,3505),i=1,7)/18.,13., 9., 3., 4.92E-03,5.11509E+06,  2./
      DATA (u(i,3506),i=1,7)/18.,13., 9., 9., 4.85E-03,5.12820E+06,  2./
      DATA (u(i,3507),i=1,7)/18.,13., 9., 3., 4.47E-03,5.49149E+06,  2./
      DATA (u(i,3508),i=1,7)/18.,13., 9.,15., 3.40E-03,4.66636E+06,  2./
      DATA (u(i,3509),i=1,7)/18.,13., 9., 9., 3.22E-03,4.74608E+06,  2./
      DATA (u(i,3510),i=1,7)/18.,13., 9., 9., 2.79E-03,5.11771E+06,  2./
      DATA (u(i,3511),i=1,7)/18.,13., 9.,15., 1.95E-03,5.12295E+06,  2./
      DATA (u(i,3512),i=1,7)/18.,13., 9., 9., 1.80E-03,5.32765E+06,  2./
      DATA (u(i,3513),i=1,7)/18.,13., 9., 9., 1.64E-03,5.10464E+06,  2./
      DATA (u(i,3514),i=1,7)/18.,13., 9., 9., 1.09E-03,5.27983E+06,  2./
      DATA (u(i,3515),i=1,7)/18.,13., 9., 9., 9.92E-04,5.23560E+06,  2./
      DATA (u(i,3516),i=1,7)/18.,13., 9., 9., 7.20E-04,4.67290E+06,  2./
      DATA (u(i,3517),i=1,7)/18.,13., 9.,15., 7.19E-04,4.56621E+06,  2./
      DATA (u(i,3518),i=1,7)/18.,13., 9.,15., 4.35E-04,5.15730E+06,  2./
      DATA (u(i,3519),i=1,7)/18.,13., 9.,15., 3.52E-04,5.00751E+06,  2./
      DATA (u(i,3520),i=1,7)/18.,13., 9.,15., 3.42E-04,5.21105E+06,  2./
      DATA (u(i,3521),i=1,7)/18.,13., 9.,15., 2.28E-04,4.87567E+06,  2./
      DATA (u(i,3522),i=1,7)/18.,13., 9., 3., 1.65E-04,5.53710E+06,  2./
      DATA (u(i,3523),i=1,7)/18.,13., 9., 9., 1.54E-04,5.15730E+06,  2./
      DATA (u(i,3524),i=1,7)/18.,13., 9., 3., 7.14E-05,5.39084E+06,  2./
      DATA (u(i,3525),i=1,7)/18.,13., 9.,15., 6.25E-05,4.98256E+06,  2./
      DATA (u(i,3526),i=1,7)/18.,13., 9.,15., 2.38E-05,5.29381E+06,  2./
      DATA (u(i,3527),i=1,7)/18.,14., 6.,10., 3.90E+00,3.61533E+06,  2./
      DATA (u(i,3528),i=1,7)/18.,14., 6.,10., 1.66E+00,3.77929E+06,  2./
      DATA (u(i,3529),i=1,7)/18.,14., 6., 6., 8.70E-01,3.72162E+06,  2./
      DATA (u(i,3530),i=1,7)/18.,14., 6., 6., 7.62E-01,5.16262E+05,  3./
      DATA (u(i,3531),i=1,7)/18.,14., 6.,10., 7.52E-01,4.69263E+06,  2./
      DATA (u(i,3532),i=1,7)/18.,14., 6.,10., 4.14E-01,4.89716E+06,  2./
      DATA (u(i,3533),i=1,7)/18.,14., 6., 2., 3.41E-01,3.81388E+06,  2./
      DATA (u(i,3534),i=1,7)/18.,14., 6.,10., 2.96E-01,3.77487E+05,  3./
      DATA (u(i,3535),i=1,7)/18.,14., 6., 6., 2.80E-01,3.94945E+06,  2./
      DATA (u(i,3536),i=1,7)/18.,14., 6.,10., 2.77E-01,5.18941E+06,  2./
      DATA (u(i,3537),i=1,7)/18.,14., 6., 6., 2.36E-01,4.87805E+06,  2./
      DATA (u(i,3538),i=1,7)/18.,14., 6.,10., 1.60E-01,5.40541E+06,  2./
      DATA (u(i,3539),i=1,7)/18.,14., 6., 2., 1.55E-01,4.87448E+05,  3./
      DATA (u(i,3540),i=1,7)/18.,14., 6.,10., 1.46E-01,5.45554E+06,  2./
      DATA (u(i,3541),i=1,7)/18.,14., 6., 2., 1.33E-01,3.39789E+06,  2./
      DATA (u(i,3542),i=1,7)/18.,14., 6.,10., 1.15E-01,3.95101E+06,  2./
      DATA (u(i,3543),i=1,7)/18.,14., 6., 6., 9.93E-02,5.39665E+06,  2./
      DATA (u(i,3544),i=1,7)/18.,14., 6.,10., 9.49E-02,5.09165E+06,  2./
      DATA (u(i,3545),i=1,7)/18.,14., 6.,10., 8.79E-02,5.67537E+06,  2./
      DATA (u(i,3546),i=1,7)/18.,14., 6., 6., 8.23E-02,5.09424E+06,  2./
      DATA (u(i,3547),i=1,7)/18.,14., 6., 2., 7.92E-02,4.91159E+06,  2./
      DATA (u(i,3548),i=1,7)/18.,14., 6., 6., 7.43E-02,4.06669E+06,  2./
      DATA (u(i,3549),i=1,7)/18.,14., 6.,10., 7.13E-02,5.61798E+06,  2./
      DATA (u(i,3550),i=1,7)/18.,14., 6.,10., 5.76E-02,5.60538E+06,  2./
      DATA (u(i,3551),i=1,7)/18.,14., 6., 6., 5.70E-02,5.67215E+06,  2./
      DATA (u(i,3552),i=1,7)/18.,14., 6.,10., 5.55E-02,5.84112E+06,  2./
      DATA (u(i,3553),i=1,7)/18.,14., 6.,10., 5.21E-02,5.72082E+06,  2./
      DATA (u(i,3554),i=1,7)/18.,14., 6.,10., 4.65E-02,4.29553E+06,  2./
      DATA (u(i,3555),i=1,7)/18.,14., 6.,10., 4.26E-02,4.27168E+06,  2./
      DATA (u(i,3556),i=1,7)/18.,14., 6., 2., 3.78E-02,3.97772E+06,  2./
      DATA (u(i,3557),i=1,7)/18.,14., 6.,10., 3.73E-02,5.79374E+06,  2./
      DATA (u(i,3558),i=1,7)/18.,14., 6., 2., 3.15E-02,5.09424E+06,  2./
      DATA (u(i,3559),i=1,7)/18.,14., 6., 6., 2.98E-02,5.60538E+06,  2./
      DATA (u(i,3560),i=1,7)/18.,14., 6.,10., 2.96E-02,5.30504E+06,  2./
      DATA (u(i,3561),i=1,7)/18.,14., 6., 6., 2.94E-02,5.83771E+06,  2./
      DATA (u(i,3562),i=1,7)/18.,14., 6., 2., 2.90E-02,5.40833E+06,  2./
      DATA (u(i,3563),i=1,7)/18.,14., 6., 6., 2.71E-02,4.31965E+06,  2./
      DATA (u(i,3564),i=1,7)/18.,14., 6., 2., 2.39E-02,4.61042E+06,  2./
      DATA (u(i,3565),i=1,7)/18.,14., 6.,10., 2.38E-02,5.84454E+06,  2./
      DATA (u(i,3566),i=1,7)/18.,14., 6.,10., 2.16E-02,4.09333E+06,  2./
      DATA (u(i,3567),i=1,7)/18.,14., 6., 6., 2.13E-02,5.94177E+06,  2./
      DATA (u(i,3568),i=1,7)/18.,14., 6., 6., 1.57E-02,5.88235E+06,  2./
      DATA (u(i,3569),i=1,7)/18.,14., 6., 2., 1.56E-02,5.67859E+06,  2./
      DATA (u(i,3570),i=1,7)/18.,14., 6., 6., 1.40E-02,4.19992E+06,  2./
      DATA (u(i,3571),i=1,7)/18.,14., 6., 2., 1.27E-02,5.84112E+06,  2./
      DATA (u(i,3572),i=1,7)/18.,14., 6., 6., 1.26E-02,6.01323E+06,  2./
      DATA (u(i,3573),i=1,7)/18.,14., 6.,10., 1.26E-02,4.43656E+06,  2./
      DATA (u(i,3574),i=1,7)/18.,14., 6., 6., 1.05E-02,6.04595E+06,  2./
      DATA (u(i,3575),i=1,7)/18.,14., 6., 6., 1.05E-02,6.06796E+06,  2./
      DATA (u(i,3576),i=1,7)/18.,14., 6., 2., 9.98E-03,5.59910E+06,  2./
      DATA (u(i,3577),i=1,7)/18.,14., 6.,10., 9.52E-03,5.78704E+06,  2./
      DATA (u(i,3578),i=1,7)/18.,14., 6., 6., 9.41E-03,5.36193E+06,  2./
      DATA (u(i,3579),i=1,7)/18.,14., 6., 2., 8.72E-03,5.43478E+06,  2./
      DATA (u(i,3580),i=1,7)/18.,14., 6., 6., 7.93E-03,5.27983E+06,  2./
      DATA (u(i,3581),i=1,7)/18.,14., 6.,10., 7.28E-03,5.35332E+06,  2./
      DATA (u(i,3582),i=1,7)/18.,14., 6., 6., 7.02E-03,5.84454E+06,  2./
      DATA (u(i,3583),i=1,7)/18.,14., 6., 2., 6.18E-03,4.33463E+06,  2./
      DATA (u(i,3584),i=1,7)/18.,14., 6.,10., 5.15E-03,5.50055E+06,  2./
      DATA (u(i,3585),i=1,7)/18.,14., 6., 2., 4.06E-03,4.24088E+06,  2./
      DATA (u(i,3586),i=1,7)/18.,14., 6., 2., 3.93E-03,5.61482E+06,  2./
      DATA (u(i,3587),i=1,7)/18.,14., 6., 6., 2.95E-03,5.77367E+06,  2./
      DATA (u(i,3588),i=1,7)/18.,14., 6., 2., 2.81E-03,5.36193E+06,  2./
      DATA (u(i,3589),i=1,7)/18.,14., 6., 2., 2.79E-03,5.15198E+06,  2./
      DATA (u(i,3590),i=1,7)/18.,14., 6.,10., 2.17E-03,5.84112E+06,  2./
      DATA (u(i,3591),i=1,7)/18.,14., 6., 2., 1.97E-03,5.71102E+06,  2./
      DATA (u(i,3592),i=1,7)/18.,14., 6.,10., 1.46E-03,5.15464E+06,  2./
      DATA (u(i,3593),i=1,7)/18.,14., 6., 2., 1.33E-03,5.78704E+06,  2./
      DATA (u(i,3594),i=1,7)/18.,14., 6., 6., 1.32E-03,6.04230E+06,  2./
      DATA (u(i,3595),i=1,7)/18.,14., 6., 6., 1.01E-03,6.02410E+06,  2./
      DATA (u(i,3596),i=1,7)/18.,14., 6.,10., 9.51E-04,4.94805E+06,  2./
      DATA (u(i,3597),i=1,7)/18.,14., 6.,10., 7.91E-04,5.27148E+06,  2./
      DATA (u(i,3598),i=1,7)/18.,14., 6., 2., 4.46E-04,5.83771E+06,  2./
      DATA (u(i,3599),i=1,7)/18.,14., 6.,10., 2.52E-04,5.69152E+06,  2./
      DATA (u(i,3600),i=1,7)/18.,14., 6.,10., 1.09E-04,5.42888E+06,  2./
      DATA (u(i,3601),i=1,7)/18.,14., 6., 6., 1.01E-04,5.74053E+06,  2./
      DATA (u(i,3602),i=1,7)/18.,14., 6., 2., 3.94E-05,5.42888E+06,  2./
      DATA (u(i,3603),i=1,7)/18.,14., 6.,10., 3.43E-05,5.63698E+06,  2./
      DATA (u(i,3604),i=1,7)/18.,14., 6.,10., 6.31E-06,5.80383E+06,  2./
      DATA (u(i,3605),i=1,7)/18.,14., 6., 6., 5.47E-07,5.21376E+06,  2./
      DATA (u(i,3606),i=1,7)/18.,15., 1., 3., 6.32E-01,4.01606E+06,  2./
      DATA (u(i,3607),i=1,7)/18.,15., 1., 3., 1.97E-01,4.35218E+05,  3./
      DATA (u(i,3608),i=1,7)/18.,15., 1., 3., 1.65E-01,5.28821E+06,  2./
      DATA (u(i,3609),i=1,7)/18.,15., 1., 3., 6.75E-02,5.86166E+06,  2./
      DATA (u(i,3610),i=1,7)/18.,15., 1., 3., 3.27E-02,4.41696E+06,  2./
      DATA (u(i,3611),i=1,7)/18.,15., 1., 3., 3.04E-02,4.24088E+06,  2./
      DATA (u(i,3612),i=1,7)/18.,15., 1., 3., 3.02E-02,6.17284E+06,  2./
      DATA (u(i,3613),i=1,7)/18.,15., 1., 3., 2.14E-02,6.35728E+06,  2./
      DATA (u(i,3614),i=1,7)/18.,15., 1., 3., 1.29E-02,6.47668E+06,  2./
      DATA (u(i,3615),i=1,7)/18.,15., 1., 3., 1.16E-02,5.58972E+06,  2./
      DATA (u(i,3616),i=1,7)/18.,15., 1., 3., 9.63E-03,6.13874E+06,  2./
      DATA (u(i,3617),i=1,7)/18.,15., 1., 3., 9.42E-03,6.56168E+06,  2./
      DATA (u(i,3618),i=1,7)/18.,15., 1., 3., 6.85E-03,6.61813E+06,  2./
      DATA (u(i,3619),i=1,7)/18.,15., 1., 3., 3.12E-03,6.43915E+06,  2./
      DATA (u(i,3620),i=1,7)/18.,15., 1., 3., 1.14E-03,6.61813E+06,  2./
      DATA (u(i,3621),i=1,7)/18.,15., 1., 3., 8.74E-04,6.10128E+06,  2./
      DATA (u(i,3622),i=1,7)/18.,15., 1., 3., 2.79E-04,6.60502E+06,  2./
      DATA (u(i,3623),i=1,7)/18.,15., 1., 3., 1.00E-04,5.51572E+06,  2./
      DATA (u(i,3624),i=1,7)/18.,15., 1., 3., 2.43E-05,6.41437E+06,  2./
      DATA (u(i,3625),i=1,7)/18.,16., 2., 6., 1.83E-01,5.60224E+06, 18./
      DATA (u(i,3626),i=1,7)/18.,16., 2., 6., 7.64E-02,6.23830E+06, 18./
      DATA (u(i,3627),i=1,7)/18.,16., 2., 6., 3.98E-02,6.58328E+06, 18./
      DATA (u(i,3628),i=1,7)/18.,16., 2., 6., 2.36E-02,6.79348E+06, 18./
      DATA (u(i,3629),i=1,7)/18.,16., 2., 6., 1.52E-02,6.93001E+06, 18./
      DATA (u(i,3630),i=1,7)/18.,16., 2., 6., 1.04E-02,7.02247E+06, 18./
      DATA (u(i,3631),i=1,7)/18.,16., 2., 6., 7.44E-03,7.08717E+06, 18./
      DATA (u(i,3632),i=1,7)/18.,17., 1., 3.,-4.87E+07,2.50382E+07, 24./
      DATA (u(i,3633),i=1,7)/18.,17., 1., 3., 1.28E-02,2.51947E+07, 25./
      DATA (u(i,3634),i=1,7)/18.,17., 1., 3., 7.72E-01,2.53240E+07, 11./
      DATA (u(i,3635),i=1,7)/18.,17., 1., 3., 1.54E-01,2.95858E+07, 12./
      DATA (u(i,3636),i=1,7)/18.,17., 1., 3., 5.71E-02,3.11526E+07, 13./
      DATA (u(i,3637),i=1,7)/18.,17., 1., 3., 2.75E-02,3.18471E+07, 13./
      DATA (u(i,3638),i=1,7)/18.,17., 1., 3., 1.55E-02,3.22581E+07, 13./
      DATA (u(i,3639),i=1,7)/18.,17., 1., 3., 9.56E-03,3.24675E+07, 13./
      DATA (u(i,3640),i=1,7)/18.,17., 1., 3., 6.33E-03,3.25733E+07, 13./
      DATA (u(i,3641),i=1,7)/18.,17., 1., 3., 4.41E-03,3.26797E+07, 13./
      DATA (u(i,3642),i=1,7)/18.,17., 1., 3., 3.20E-03,3.27869E+07, 13./
      DATA (u(i,3643),i=1,7)/18.,18., 2., 2.,-8.64E+05,2.66667E+07, 23./
      DATA (u(i,3644),i=1,7)/18.,18., 2., 6., 8.32E-01,2.66667E+07,  4./
      DATA (u(i,3645),i=1,7)/18.,18., 2., 6., 1.58E-01,3.15457E+07,  5./
      DATA (u(i,3646),i=1,7)/18.,18., 2., 6., 5.80E-02,3.33333E+07,  6./
      DATA (u(i,3647),i=1,7)/18.,18., 2., 6., 2.79E-02,3.41297E+07,  7./
      DATA (u(i,3648),i=1,7)/18.,18., 2., 6., 1.56E-02,3.46021E+07,  8./
      DATA (u(i,3649),i=1,7)/18.,18., 2., 6., 9.63E-03,3.48432E+07,  9./
      DATA (u(i,3650),i=1,7)/18.,18., 2., 6., 6.37E-03,3.49650E+07,  9./
      DATA (u(i,3651),i=1,7)/18.,18., 2., 6., 4.43E-03,3.50877E+07,  9./
      DATA (u(i,3652),i=1,7)/18.,18., 2., 6., 3.21E-03,3.52113E+07,  9./
      DATA (u(i,3653),i=1,7)/20., 1., 1., 3., 1.96E-02,4.49671E+04,  1./
      DATA (u(i,3654),i=1,7)/20., 1., 1., 3., 1.94E-02,3.55046E+04,  1./
      DATA (u(i,3655),i=1,7)/20., 1., 1., 3., 1.83E-02,4.41597E+04,  1./
      DATA (u(i,3656),i=1,7)/20., 1., 1., 3., 1.49E-02,4.55206E+04,  1./
      DATA (u(i,3657),i=1,7)/20., 1., 1., 3., 1.05E-02,4.28541E+04,  1./
      DATA (u(i,3658),i=1,7)/20., 1., 1., 3., 9.61E-03,4.59219E+04,  1./
      DATA (u(i,3659),i=1,7)/20., 1., 1., 3., 6.01E-03,4.62190E+04,  1./
      DATA (u(i,3660),i=1,7)/20., 1., 1., 3., 1.50E-03,4.04776E+04,  1./
      DATA (u(i,3661),i=1,7)/20., 2., 2., 6., 4.34E-03,7.35262E+04,  2./
      DATA (u(i,3662),i=1,7)/20., 2., 2., 6., 3.25E-03,8.04027E+04,  2./
      DATA (u(i,3663),i=1,7)/20., 2., 2., 6., 2.22E-03,8.43697E+04,  2./
      DATA (u(i,3664),i=1,7)/20., 2., 2., 6., 1.72E-03,5.99179E+04,  2./
      DATA (u(i,3665),i=1,7)/20., 2., 2., 6., 1.54E-03,8.68666E+04,  2./
      DATA (u(i,3666),i=1,7)/20., 2., 2., 6., 1.10E-03,8.85410E+04,  2./
      DATA (u(i,3667),i=1,7)/20., 2., 2., 6., 8.08E-04,8.97183E+04,  2./
      DATA (u(i,3668),i=1,7)/20., 3., 1., 3., 3.91E+00,2.84689E+05,  3./
      DATA (u(i,3669),i=1,7)/20., 3., 1., 3., 1.16E+00,3.35087E+05,  2./
      DATA (u(i,3670),i=1,7)/20., 3., 1., 3., 6.94E-01,2.45447E+05,  2./
      DATA (u(i,3671),i=1,7)/20., 3., 1., 3., 4.13E-01,3.60023E+05,  2./
      DATA (u(i,3672),i=1,7)/20., 3., 1., 3., 1.85E-01,3.73776E+05,  2./
      DATA (u(i,3673),i=1,7)/20., 3., 1., 3., 1.34E-01,3.24296E+05,  2./
      DATA (u(i,3674),i=1,7)/20., 3., 1., 3., 9.78E-02,3.82015E+05,  2./
      DATA (u(i,3675),i=1,7)/20., 3., 1., 3., 5.80E-02,3.87327E+05,  2./
      DATA (u(i,3676),i=1,7)/20., 3., 1., 3., 4.94E-02,3.55859E+05,  2./
      DATA (u(i,3677),i=1,7)/20., 3., 1., 3., 3.73E-02,3.90930E+05,  2./
      DATA (u(i,3678),i=1,7)/20., 3., 1., 3., 2.54E-02,3.93484E+05,  2./
      DATA (u(i,3679),i=1,7)/20., 3., 1., 3., 2.41E-02,3.71761E+05,  2./
      DATA (u(i,3680),i=1,7)/20., 3., 1., 3., 1.37E-02,3.80894E+05,  2./
      DATA (u(i,3681),i=1,7)/20., 3., 1., 3., 8.61E-03,3.86638E+05,  2./
      DATA (u(i,3682),i=1,7)/20., 3., 1., 3., 5.78E-03,3.90472E+05,  2./
      DATA (u(i,3683),i=1,7)/20., 3., 1., 3., 4.08E-03,3.93159E+05,  2./
      DATA (u(i,3684),i=1,7)/20., 4., 6.,10., 9.95E+00,3.29088E+05,  2./
      DATA (u(i,3685),i=1,7)/20., 4., 6.,10., 5.22E+00,3.22196E+05,  3./
      DATA (u(i,3686),i=1,7)/20., 4., 6., 6., 4.74E+00,3.24834E+05,  3./
      DATA (u(i,3687),i=1,7)/20., 4., 6., 6., 3.96E+00,3.09215E+05,  3./
      DATA (u(i,3688),i=1,7)/20., 4., 6., 2., 2.89E+00,3.13411E+05,  3./
      DATA (u(i,3689),i=1,7)/20., 4., 6.,10., 4.13E-01,4.10880E+05,  2./
      DATA (u(i,3690),i=1,7)/20., 4., 6., 6., 3.55E-01,4.20946E+05,  2./
      DATA (u(i,3691),i=1,7)/20., 4., 6.,10., 2.78E-01,4.25604E+05,  2./
      DATA (u(i,3692),i=1,7)/20., 4., 6., 2., 1.78E-01,1.53424E+05,  3./
      DATA (u(i,3693),i=1,7)/20., 4., 6.,10., 1.39E-01,2.91741E+05,  3./
      DATA (u(i,3694),i=1,7)/20., 4., 6.,10., 9.22E-02,4.38385E+05,  2./
      DATA (u(i,3695),i=1,7)/20., 4., 6., 6., 8.78E-02,4.09333E+05,  2./
      DATA (u(i,3696),i=1,7)/20., 4., 6., 6., 7.45E-02,4.69726E+05,  2./
      DATA (u(i,3697),i=1,7)/20., 4., 6.,10., 4.30E-02,2.43784E+05,  3./
      DATA (u(i,3698),i=1,7)/20., 4., 6., 2., 4.29E-02,4.23496E+05,  2./
      DATA (u(i,3699),i=1,7)/20., 4., 6.,10., 4.27E-02,4.86594E+05,  2./
      DATA (u(i,3700),i=1,7)/20., 4., 6., 6., 3.65E-02,4.94535E+05,  2./
      DATA (u(i,3701),i=1,7)/20., 4., 6.,10., 3.54E-02,4.64253E+05,  2./
      DATA (u(i,3702),i=1,7)/20., 4., 6.,10., 3.22E-02,4.48109E+05,  2./
      DATA (u(i,3703),i=1,7)/20., 4., 6.,10., 2.33E-02,5.11849E+05,  2./
      DATA (u(i,3704),i=1,7)/20., 4., 6., 2., 2.05E-02,4.63263E+05,  2./
      DATA (u(i,3705),i=1,7)/20., 4., 6., 2., 1.58E-02,5.13136E+05,  2./
      DATA (u(i,3706),i=1,7)/20., 4., 6., 6., 1.43E-02,5.18350E+05,  2./
      DATA (u(i,3707),i=1,7)/20., 4., 6., 6., 1.37E-02,4.26476E+05,  2./
      DATA (u(i,3708),i=1,7)/20., 4., 6., 6., 1.34E-02,4.63908E+05,  2./
      DATA (u(i,3709),i=1,7)/20., 4., 6., 6., 1.33E-02,5.09996E+05,  2./
      DATA (u(i,3710),i=1,7)/20., 4., 6.,10., 1.27E-02,5.26482E+05,  2./
      DATA (u(i,3711),i=1,7)/20., 4., 6., 6., 1.09E-02,5.08750E+05,  2./
      DATA (u(i,3712),i=1,7)/20., 4., 6., 6., 1.06E-02,5.24797E+05,  2./
      DATA (u(i,3713),i=1,7)/20., 4., 6., 2., 9.92E-03,3.49223E+05,  2./
      DATA (u(i,3714),i=1,7)/20., 4., 6., 6., 7.03E-03,5.29073E+05,  2./
      DATA (u(i,3715),i=1,7)/20., 4., 6., 6., 5.56E-03,2.33984E+05,  2./
      DATA (u(i,3716),i=1,7)/20., 4., 6.,10., 5.53E-03,5.02285E+05,  2./
      DATA (u(i,3717),i=1,7)/20., 4., 6., 2., 5.34E-03,5.36798E+05,  2./
      DATA (u(i,3718),i=1,7)/20., 4., 6.,10., 3.83E-03,4.79916E+05,  2./
      DATA (u(i,3719),i=1,7)/20., 4., 6., 6., 1.89E-03,4.91304E+05,  2./
      DATA (u(i,3720),i=1,7)/20., 4., 6., 6., 1.59E-03,5.04643E+05,  2./
      DATA (u(i,3721),i=1,7)/20., 4., 6.,10., 1.51E-03,5.05945E+05,  2./
      DATA (u(i,3722),i=1,7)/20., 4., 6., 2., 1.11E-03,5.34045E+05,  2./
      DATA (u(i,3723),i=1,7)/20., 4., 6., 2., 1.03E-03,5.43242E+05,  2./
      DATA (u(i,3724),i=1,7)/20., 4., 6.,10., 9.87E-04,4.91352E+05,  2./
      DATA (u(i,3725),i=1,7)/20., 4., 6., 2., 7.97E-04,5.07511E+05,  2./
      DATA (u(i,3726),i=1,7)/20., 4., 6.,10., 7.63E-04,5.28374E+05,  2./
      DATA (u(i,3727),i=1,7)/20., 4., 6., 2., 6.71E-04,4.79432E+05,  2./
      DATA (u(i,3728),i=1,7)/20., 4., 6., 6., 5.86E-04,4.79272E+05,  2./
      DATA (u(i,3729),i=1,7)/20., 4., 6., 2., 5.24E-04,5.40862E+05,  2./
      DATA (u(i,3730),i=1,7)/20., 4., 6.,10., 5.03E-04,5.24356E+05,  2./
      DATA (u(i,3731),i=1,7)/20., 4., 6., 6., 4.16E-04,5.24219E+05,  2./
      DATA (u(i,3732),i=1,7)/20., 4., 6., 2., 3.81E-04,5.23917E+05,  2./
      DATA (u(i,3733),i=1,7)/20., 4., 6., 6., 3.79E-04,5.06817E+05,  2./
      DATA (u(i,3734),i=1,7)/20., 4., 6.,10., 3.76E-04,5.16983E+05,  2./
      DATA (u(i,3735),i=1,7)/20., 4., 6., 2., 2.01E-04,5.10673E+05,  2./
      DATA (u(i,3736),i=1,7)/20., 4., 6.,10., 1.42E-04,5.08776E+05,  2./
      DATA (u(i,3737),i=1,7)/20., 4., 6., 2., 8.33E-05,5.45941E+05,  2./
      DATA (u(i,3738),i=1,7)/20., 4., 6., 6., 2.92E-05,5.28402E+05,  2./
      DATA (u(i,3739),i=1,7)/20., 4., 6., 6., 2.73E-05,5.23451E+05,  2./
      DATA (u(i,3740),i=1,7)/20., 4., 6.,10., 5.73E-06,4.94584E+05,  2./
      DATA (u(i,3741),i=1,7)/20., 4., 6.,10., 2.54E-06,5.06945E+05,  2./
      DATA (u(i,3742),i=1,7)/20., 4., 6.,10., 1.15E-06,5.23478E+05,  2./
      DATA (u(i,3743),i=1,7)/20., 4., 6.,10., 5.90E-07,5.29157E+05,  2./
      DATA (u(i,3744),i=1,7)/20., 4., 6.,10., 2.42E-07,5.16156E+05,  2./
      DATA (u(i,3745),i=1,7)/20., 4., 6., 6., 2.00E-07,5.16983E+05,  2./
      DATA (u(i,3746),i=1,7)/20., 5., 9.,15., 1.76E+01,3.17935E+05,  3./
      DATA (u(i,3747),i=1,7)/20., 5., 9., 9., 1.01E+01,3.07305E+05,  3./
      DATA (u(i,3748),i=1,7)/20., 5., 9., 3., 2.61E+00,3.01132E+05,  3./
      DATA (u(i,3749),i=1,7)/20., 5., 9.,15., 8.13E-01,3.79406E+05,  2./
      DATA (u(i,3750),i=1,7)/20., 5., 9., 3., 6.11E-01,3.62004E+05,  2./
      DATA (u(i,3751),i=1,7)/20., 5., 9., 9., 4.81E-01,1.51307E+05,  3./
      DATA (u(i,3752),i=1,7)/20., 5., 9., 9., 4.75E-01,3.97377E+05,  2./
      DATA (u(i,3753),i=1,7)/20., 5., 9.,15., 1.72E-01,5.31096E+05,  2./
      DATA (u(i,3754),i=1,7)/20., 5., 9., 3., 1.56E-01,5.08569E+05,  2./
      DATA (u(i,3755),i=1,7)/20., 5., 9., 9., 1.32E-01,2.71304E+05,  3./
      DATA (u(i,3756),i=1,7)/20., 5., 9., 9., 1.14E-01,5.48697E+05,  2./
      DATA (u(i,3757),i=1,7)/20., 5., 9.,15., 9.24E-02,2.72970E+05,  3./
      DATA (u(i,3758),i=1,7)/20., 5., 9.,15., 8.53E-02,5.63031E+05,  2./
      DATA (u(i,3759),i=1,7)/20., 5., 9., 9., 7.62E-02,6.15385E+05,  2./
      DATA (u(i,3760),i=1,7)/20., 5., 9.,15., 7.47E-02,6.23480E+05,  2./
      DATA (u(i,3761),i=1,7)/20., 5., 9.,15., 6.46E-02,5.97514E+05,  2./
      DATA (u(i,3762),i=1,7)/20., 5., 9., 9., 6.43E-02,5.64653E+05,  2./
      DATA (u(i,3763),i=1,7)/20., 5., 9.,15., 5.31E-02,5.80585E+05,  2./
      DATA (u(i,3764),i=1,7)/20., 5., 9., 9., 5.24E-02,5.82004E+05,  2./
      DATA (u(i,3765),i=1,7)/20., 5., 9.,15., 4.68E-02,5.55833E+05,  2./
      DATA (u(i,3766),i=1,7)/20., 5., 9., 3., 4.66E-02,5.71657E+05,  2./
      DATA (u(i,3767),i=1,7)/20., 5., 9., 3., 4.43E-02,5.83908E+05,  2./
      DATA (u(i,3768),i=1,7)/20., 5., 9.,15., 3.86E-02,6.33032E+05,  2./
      DATA (u(i,3769),i=1,7)/20., 5., 9.,15., 3.51E-02,6.37267E+05,  2./
      DATA (u(i,3770),i=1,7)/20., 5., 9.,15., 3.39E-02,5.95593E+05,  2./
      DATA (u(i,3771),i=1,7)/20., 5., 9., 9., 3.27E-02,6.20925E+05,  2./
      DATA (u(i,3772),i=1,7)/20., 5., 9.,15., 3.14E-02,5.99269E+05,  2./
      DATA (u(i,3773),i=1,7)/20., 5., 9., 3., 3.00E-02,6.06612E+05,  2./
      DATA (u(i,3774),i=1,7)/20., 5., 9.,15., 2.72E-02,6.41766E+05,  2./
      DATA (u(i,3775),i=1,7)/20., 5., 9., 9., 2.60E-02,6.48508E+05,  2./
      DATA (u(i,3776),i=1,7)/20., 5., 9., 9., 2.55E-02,5.97514E+05,  2./
      DATA (u(i,3777),i=1,7)/20., 5., 9.,15., 2.41E-02,6.54707E+05,  2./
      DATA (u(i,3778),i=1,7)/20., 5., 9., 3., 2.25E-02,6.29010E+05,  2./
      DATA (u(i,3779),i=1,7)/20., 5., 9.,15., 1.94E-02,6.03318E+05,  3./
      DATA (u(i,3780),i=1,7)/20., 5., 9.,15., 1.90E-02,6.48424E+05,  2./
      DATA (u(i,3781),i=1,7)/20., 5., 9., 9., 1.81E-02,6.63922E+05,  2./
      DATA (u(i,3782),i=1,7)/20., 5., 9.,15., 1.78E-02,6.27038E+05,  2./
      DATA (u(i,3783),i=1,7)/20., 5., 9., 9., 1.76E-02,6.50999E+05,  2./
      DATA (u(i,3784),i=1,7)/20., 5., 9., 9., 1.67E-02,6.71862E+05,  2./
      DATA (u(i,3785),i=1,7)/20., 5., 9.,15., 1.56E-02,6.54022E+05,  2./
      DATA (u(i,3786),i=1,7)/20., 5., 9.,15., 1.54E-02,6.47417E+05,  2./
      DATA (u(i,3787),i=1,7)/20., 5., 9., 3., 1.50E-02,6.23869E+05,  2./
      DATA (u(i,3788),i=1,7)/20., 5., 9., 9., 1.38E-02,6.42261E+05,  2./
      DATA (u(i,3789),i=1,7)/20., 5., 9., 3., 1.36E-02,6.50110E+05,  2./
      DATA (u(i,3790),i=1,7)/20., 5., 9., 3., 1.32E-02,6.27274E+05,  2./
      DATA (u(i,3791),i=1,7)/20., 5., 9., 3., 1.32E-02,6.40861E+05,  2./
      DATA (u(i,3792),i=1,7)/20., 5., 9., 9., 1.29E-02,4.99126E+05,  2./
      DATA (u(i,3793),i=1,7)/20., 5., 9., 9., 1.15E-02,6.81385E+05,  2./
      DATA (u(i,3794),i=1,7)/20., 5., 9.,15., 1.09E-02,5.16102E+05,  2./
      DATA (u(i,3795),i=1,7)/20., 5., 9.,15., 9.63E-03,4.96968E+05,  2./
      DATA (u(i,3796),i=1,7)/20., 5., 9., 9., 9.29E-03,5.73000E+05,  3./
      DATA (u(i,3797),i=1,7)/20., 5., 9., 3., 8.69E-03,5.66476E+05,  2./
      DATA (u(i,3798),i=1,7)/20., 5., 9., 9., 7.59E-03,6.74354E+05,  2./
      DATA (u(i,3799),i=1,7)/20., 5., 9., 3., 6.48E-03,6.56556E+05,  2./
      DATA (u(i,3800),i=1,7)/20., 5., 9., 3., 6.10E-03,6.48550E+05,  2./
      DATA (u(i,3801),i=1,7)/20., 5., 9., 9., 5.17E-03,5.14880E+05,  2./
      DATA (u(i,3802),i=1,7)/20., 5., 9., 9., 4.77E-03,6.34115E+05,  2./
      DATA (u(i,3803),i=1,7)/20., 5., 9., 9., 4.73E-03,6.66222E+05,  2./
      DATA (u(i,3804),i=1,7)/20., 5., 9., 3., 4.12E-03,4.98604E+05,  2./
      DATA (u(i,3805),i=1,7)/20., 5., 9., 9., 3.31E-03,6.25352E+05,  2./
      DATA (u(i,3806),i=1,7)/20., 5., 9.,15., 1.77E-03,2.27020E+05,  3./
      DATA (u(i,3807),i=1,7)/20., 5., 9., 9., 1.06E-03,5.98946E+05,  2./
      DATA (u(i,3808),i=1,7)/20., 5., 9.,15., 3.86E-04,6.20501E+05,  2./
      DATA (u(i,3809),i=1,7)/20., 5., 9., 9., 3.55E-04,6.81849E+05,  2./
      DATA (u(i,3810),i=1,7)/20., 5., 9.,15., 2.82E-04,4.74383E+05,  2./
      DATA (u(i,3811),i=1,7)/20., 5., 9.,15., 1.43E-04,6.35042E+05,  2./
      DATA (u(i,3812),i=1,7)/20., 5., 9., 9., 5.17E-05,6.56125E+05,  3./
      DATA (u(i,3813),i=1,7)/20., 5., 9.,15., 4.77E-05,6.01468E+05,  2./
      DATA (u(i,3814),i=1,7)/20., 5., 9.,15., 4.77E-05,6.01468E+05,  2./
      DATA (u(i,3815),i=1,7)/20., 5., 9.,15., 3.26E-05,6.55265E+05,  2./
      DATA (u(i,3816),i=1,7)/20., 5., 9.,15., 2.80E-05,6.34236E+05,  3./
      DATA (u(i,3817),i=1,7)/20., 6., 4.,12., 1.01E+01,3.02673E+05,  3./
      DATA (u(i,3818),i=1,7)/20., 6., 4.,12., 8.06E-01,4.39928E+05,  2./
      DATA (u(i,3819),i=1,7)/20., 6., 4.,12., 3.71E-01,1.53315E+05,  3./
      DATA (u(i,3820),i=1,7)/20., 6., 4.,12., 3.29E-01,5.70548E+05,  2./
      DATA (u(i,3821),i=1,7)/20., 6., 4.,12., 2.53E-01,6.86908E+05,  2./
      DATA (u(i,3822),i=1,7)/20., 6., 4.,12., 2.29E-01,6.30199E+05,  2./
      DATA (u(i,3823),i=1,7)/20., 6., 4.,12., 1.98E-01,7.40247E+05,  2./
      DATA (u(i,3824),i=1,7)/20., 6., 4.,12., 1.71E-01,6.18850E+05,  2./
      DATA (u(i,3825),i=1,7)/20., 6., 4.,12., 1.04E-01,7.68167E+05,  2./
      DATA (u(i,3826),i=1,7)/20., 6., 4.,12., 5.97E-02,8.04376E+05,  2./
      DATA (u(i,3827),i=1,7)/20., 6., 4.,12., 5.16E-02,7.16025E+05,  2./
      DATA (u(i,3828),i=1,7)/20., 6., 4.,12., 4.83E-02,7.79910E+05,  2./
      DATA (u(i,3829),i=1,7)/20., 6., 4.,12., 4.21E-02,8.18733E+05,  2./
      DATA (u(i,3830),i=1,7)/20., 6., 4.,12., 3.76E-02,6.83200E+05,  2./
      DATA (u(i,3831),i=1,7)/20., 6., 4.,12., 3.05E-02,7.81311E+05,  2./
      DATA (u(i,3832),i=1,7)/20., 6., 4.,12., 3.05E-02,8.28912E+05,  2./
      DATA (u(i,3833),i=1,7)/20., 6., 4.,12., 2.58E-02,7.18288E+05,  3./
      DATA (u(i,3834),i=1,7)/20., 6., 4.,12., 2.17E-02,7.49513E+05,  2./
      DATA (u(i,3835),i=1,7)/20., 6., 4.,12., 1.95E-02,6.03610E+05,  3./
      DATA (u(i,3836),i=1,7)/20., 6., 4.,12., 1.87E-02,6.93241E+05,  3./
      DATA (u(i,3837),i=1,7)/20., 6., 4.,12., 1.66E-02,7.63709E+05,  2./
      DATA (u(i,3838),i=1,7)/20., 6., 4.,12., 1.46E-02,7.44824E+05,  3./
      DATA (u(i,3839),i=1,7)/20., 6., 4.,12., 1.44E-02,7.92016E+05,  2./
      DATA (u(i,3840),i=1,7)/20., 6., 4.,12., 1.39E-02,6.64849E+05,  2./
      DATA (u(i,3841),i=1,7)/20., 6., 4.,12., 1.38E-02,7.88581E+05,  2./
      DATA (u(i,3842),i=1,7)/20., 6., 4.,12., 1.36E-02,8.10636E+05,  2./
      DATA (u(i,3843),i=1,7)/20., 6., 4.,12., 9.14E-03,7.73455E+05,  3./
      DATA (u(i,3844),i=1,7)/20., 6., 4.,12., 8.37E-03,8.23316E+05,  2./
      DATA (u(i,3845),i=1,7)/20., 6., 4.,12., 1.01E-03,6.63570E+05,  3./
      DATA (u(i,3846),i=1,7)/20., 6., 4.,12., 5.70E-04,7.86411E+05,  3./
      DATA (u(i,3847),i=1,7)/20., 6., 4.,12., 3.23E-04,8.16727E+05,  2./
      DATA (u(i,3848),i=1,7)/20., 6., 4.,12., 3.06E-05,7.99105E+05,  2./
      DATA (u(i,3849),i=1,7)/20., 6., 4.,12., 6.45E-06,8.09258E+05,  3./
      DATA (u(i,3850),i=1,7)/20., 7., 9.,15., 1.03E+01,2.95858E+05,  3./
      DATA (u(i,3851),i=1,7)/20., 7., 9., 9., 4.17E+00,2.87249E+05,  3./
      DATA (u(i,3852),i=1,7)/20., 7., 9., 3., 2.44E+00,2.46427E+05,  3./
      DATA (u(i,3853),i=1,7)/20., 7., 9., 9., 1.30E+00,4.90388E+05,  2./
      DATA (u(i,3854),i=1,7)/20., 7., 9.,15., 6.53E-01,7.74294E+05,  2./
      DATA (u(i,3855),i=1,7)/20., 7., 9., 9., 5.83E-01,1.80584E+05,  3./
      DATA (u(i,3856),i=1,7)/20., 7., 9.,15., 5.51E-01,6.31433E+05,  2./
      DATA (u(i,3857),i=1,7)/20., 7., 9.,15., 4.34E-01,1.53395E+05,  3./
      DATA (u(i,3858),i=1,7)/20., 7., 9.,15., 4.05E-01,6.87474E+05,  2./
      DATA (u(i,3859),i=1,7)/20., 7., 9.,15., 3.37E-01,6.27313E+05,  3./
      DATA (u(i,3860),i=1,7)/20., 7., 9., 9., 2.74E-01,7.16794E+05,  2./
      DATA (u(i,3861),i=1,7)/20., 7., 9.,15., 2.43E-01,8.74585E+05,  2./
      DATA (u(i,3862),i=1,7)/20., 7., 9., 9., 2.14E-01,6.93481E+05,  2./
      DATA (u(i,3863),i=1,7)/20., 7., 9., 9., 1.86E-01,7.82718E+05,  2./
      DATA (u(i,3864),i=1,7)/20., 7., 9.,15., 1.79E-01,9.05059E+05,  2./
      DATA (u(i,3865),i=1,7)/20., 7., 9.,15., 1.78E-01,8.61401E+05,  2./
      DATA (u(i,3866),i=1,7)/20., 7., 9., 9., 1.68E-01,6.39182E+05,  2./
      DATA (u(i,3867),i=1,7)/20., 7., 9.,15., 1.32E-01,9.66931E+05,  2./
      DATA (u(i,3868),i=1,7)/20., 7., 9.,15., 1.19E-01,9.34143E+05,  2./
      DATA (u(i,3869),i=1,7)/20., 7., 9., 3., 1.04E-01,6.67780E+05,  2./
      DATA (u(i,3870),i=1,7)/20., 7., 9., 9., 1.02E-01,8.77732E+05,  2./
      DATA (u(i,3871),i=1,7)/20., 7., 9., 9., 9.38E-02,9.67960E+05,  2./
      DATA (u(i,3872),i=1,7)/20., 7., 9., 9., 9.27E-02,8.25491E+05,  2./
      DATA (u(i,3873),i=1,7)/20., 7., 9.,15., 8.63E-02,9.53380E+05,  2./
      DATA (u(i,3874),i=1,7)/20., 7., 9., 9., 7.92E-02,8.84877E+05,  2./
      DATA (u(i,3875),i=1,7)/20., 7., 9.,15., 6.86E-02,9.65997E+05,  2./
      DATA (u(i,3876),i=1,7)/20., 7., 9., 9., 6.50E-02,6.33955E+05,  3./
      DATA (u(i,3877),i=1,7)/20., 7., 9., 9., 6.45E-02,7.27273E+05,  2./
      DATA (u(i,3878),i=1,7)/20., 7., 9., 9., 5.85E-02,8.62069E+05,  2./
      DATA (u(i,3879),i=1,7)/20., 7., 9., 9., 5.79E-02,9.06125E+05,  2./
      DATA (u(i,3880),i=1,7)/20., 7., 9.,15., 5.06E-02,7.88208E+05,  3./
      DATA (u(i,3881),i=1,7)/20., 7., 9., 3., 4.94E-02,8.68131E+05,  2./
      DATA (u(i,3882),i=1,7)/20., 7., 9.,15., 4.94E-02,6.72314E+05,  3./
      DATA (u(i,3883),i=1,7)/20., 7., 9., 9., 4.53E-02,7.69527E+05,  2./
      DATA (u(i,3884),i=1,7)/20., 7., 9., 9., 3.78E-02,9.34579E+05,  2./
      DATA (u(i,3885),i=1,7)/20., 7., 9., 9., 3.37E-02,9.21065E+05,  2./
      DATA (u(i,3886),i=1,7)/20., 7., 9.,15., 3.31E-02,6.83293E+05,  3./
      DATA (u(i,3887),i=1,7)/20., 7., 9., 3., 2.97E-02,7.88644E+05,  2./
      DATA (u(i,3888),i=1,7)/20., 7., 9., 9., 2.78E-02,9.53652E+05,  2./
      DATA (u(i,3889),i=1,7)/20., 7., 9., 9., 2.70E-02,7.21605E+05,  3./
      DATA (u(i,3890),i=1,7)/20., 7., 9., 9., 2.32E-02,6.26920E+05,  3./
      DATA (u(i,3891),i=1,7)/20., 7., 9.,15., 2.29E-02,7.18133E+05,  2./
      DATA (u(i,3892),i=1,7)/20., 7., 9., 9., 2.17E-02,9.44376E+05,  2./
      DATA (u(i,3893),i=1,7)/20., 7., 9., 3., 1.90E-02,9.79336E+05,  2./
      DATA (u(i,3894),i=1,7)/20., 7., 9., 9., 1.87E-02,7.46157E+05,  3./
      DATA (u(i,3895),i=1,7)/20., 7., 9., 3., 1.76E-02,9.62279E+05,  2./
      DATA (u(i,3896),i=1,7)/20., 7., 9., 9., 1.52E-02,9.61261E+05,  2./
      DATA (u(i,3897),i=1,7)/20., 7., 9.,15., 1.48E-02,8.41397E+05,  2./
      DATA (u(i,3898),i=1,7)/20., 7., 9., 3., 1.34E-02,1.01626E+06,  2./
      DATA (u(i,3899),i=1,7)/20., 7., 9., 3., 1.28E-02,1.07216E+06,  2./
      DATA (u(i,3900),i=1,7)/20., 7., 9.,15., 1.22E-02,8.50196E+05,  2./
      DATA (u(i,3901),i=1,7)/20., 7., 9., 9., 8.05E-03,8.56091E+05,  2./
      DATA (u(i,3902),i=1,7)/20., 7., 9.,15., 7.89E-03,7.52672E+05,  3./
      DATA (u(i,3903),i=1,7)/20., 7., 9., 3., 7.32E-03,1.04943E+06,  2./
      DATA (u(i,3904),i=1,7)/20., 7., 9., 3., 3.96E-03,1.08684E+06,  2./
      DATA (u(i,3905),i=1,7)/20., 7., 9., 9., 3.75E-03,8.07168E+05,  3./
      DATA (u(i,3906),i=1,7)/20., 7., 9.,15., 2.84E-03,9.29627E+05,  2./
      DATA (u(i,3907),i=1,7)/20., 7., 9.,15., 2.62E-03,8.12414E+05,  3./
      DATA (u(i,3908),i=1,7)/20., 7., 9., 9., 2.51E-03,9.59693E+05,  2./
      DATA (u(i,3909),i=1,7)/20., 7., 9.,15., 2.40E-03,9.12159E+05,  2./
      DATA (u(i,3910),i=1,7)/20., 7., 9., 3., 1.82E-03,6.98519E+05,  3./
      DATA (u(i,3911),i=1,7)/20., 7., 9.,15., 1.76E-03,7.42666E+05,  3./
      DATA (u(i,3912),i=1,7)/20., 7., 9.,15., 1.60E-03,5.71821E+05,  3./
      DATA (u(i,3913),i=1,7)/20., 7., 9., 9., 9.37E-04,7.93525E+05,  2./
      DATA (u(i,3914),i=1,7)/20., 7., 9., 9., 9.16E-04,9.15499E+05,  2./
      DATA (u(i,3915),i=1,7)/20., 7., 9., 9., 8.28E-04,9.67305E+05,  2./
      DATA (u(i,3916),i=1,7)/20., 7., 9.,15., 7.49E-04,7.92644E+05,  2./
      DATA (u(i,3917),i=1,7)/20., 7., 9., 3., 4.35E-04,1.07066E+06,  2./
      DATA (u(i,3918),i=1,7)/20., 7., 9., 9., 2.78E-04,8.49473E+05,  2./
      DATA (u(i,3919),i=1,7)/20., 7., 9.,15., 2.33E-04,9.12242E+05,  2./
      DATA (u(i,3920),i=1,7)/20., 7., 9.,15., 1.40E-04,7.98977E+05,  2./
      DATA (u(i,3921),i=1,7)/20., 7., 9., 3., 2.84E-05,6.28852E+05,  3./
      DATA (u(i,3922),i=1,7)/20., 7., 9., 9., 3.16E-06,7.62486E+05,  3./
      DATA (u(i,3923),i=1,7)/20., 7., 9., 3., 3.03E-06,8.37802E+05,  3./
      DATA (u(i,3924),i=1,7)/20., 8., 6.,10., 4.58E+00,2.80348E+05,  3./
      DATA (u(i,3925),i=1,7)/20., 8., 6., 6., 3.43E+00,2.30367E+05,  3./
      DATA (u(i,3926),i=1,7)/20., 8., 6.,10., 6.82E-01,6.93674E+05,  2./
      DATA (u(i,3927),i=1,7)/20., 8., 6.,10., 5.79E-01,7.66107E+05,  2./
      DATA (u(i,3928),i=1,7)/20., 8., 6., 2., 4.62E-01,5.45524E+05,  2./
      DATA (u(i,3929),i=1,7)/20., 8., 6., 2., 4.55E-01,2.14133E+05,  3./
      DATA (u(i,3930),i=1,7)/20., 8., 6.,10., 4.18E-01,1.64837E+05,  3./
      DATA (u(i,3931),i=1,7)/20., 8., 6., 6., 3.35E-01,7.46213E+05,  2./
      DATA (u(i,3932),i=1,7)/20., 8., 6.,10., 2.59E-01,8.80359E+05,  2./
      DATA (u(i,3933),i=1,7)/20., 8., 6.,10., 1.92E-01,9.92359E+05,  2./
      DATA (u(i,3934),i=1,7)/20., 8., 6.,10., 1.25E-01,8.24402E+05,  2./
      DATA (u(i,3935),i=1,7)/20., 8., 6., 6., 1.19E-01,9.83961E+05,  2./
      DATA (u(i,3936),i=1,7)/20., 8., 6., 2., 1.14E-01,8.07754E+05,  2./
      DATA (u(i,3937),i=1,7)/20., 8., 6.,10., 1.14E-01,9.71251E+05,  2./
      DATA (u(i,3938),i=1,7)/20., 8., 6., 6., 9.97E-02,8.25764E+05,  2./
      DATA (u(i,3939),i=1,7)/20., 8., 6.,10., 8.97E-02,1.10132E+06,  2./
      DATA (u(i,3940),i=1,7)/20., 8., 6., 2., 8.21E-02,7.84375E+05,  2./
      DATA (u(i,3941),i=1,7)/20., 8., 6., 6., 6.21E-02,1.09782E+06,  2./
      DATA (u(i,3942),i=1,7)/20., 8., 6.,10., 5.55E-02,1.03445E+06,  2./
      DATA (u(i,3943),i=1,7)/20., 8., 6.,10., 5.43E-02,1.03167E+06,  2./
      DATA (u(i,3944),i=1,7)/20., 8., 6.,10., 3.92E-02,1.07089E+06,  2./
      DATA (u(i,3945),i=1,7)/20., 8., 6.,10., 3.33E-02,1.09505E+06,  2./
      DATA (u(i,3946),i=1,7)/20., 8., 6., 2., 3.30E-02,9.38879E+05,  2./
      DATA (u(i,3947),i=1,7)/20., 8., 6., 2., 3.20E-02,9.95520E+05,  2./
      DATA (u(i,3948),i=1,7)/20., 8., 6., 6., 2.97E-02,1.16918E+06,  2./
      DATA (u(i,3949),i=1,7)/20., 8., 6.,10., 2.93E-02,9.78474E+05,  2./
      DATA (u(i,3950),i=1,7)/20., 8., 6.,10., 2.69E-02,1.05341E+06,  2./
      DATA (u(i,3951),i=1,7)/20., 8., 6.,10., 2.67E-02,1.11210E+06,  2./
      DATA (u(i,3952),i=1,7)/20., 8., 6.,10., 2.61E-02,9.57029E+05,  2./
      DATA (u(i,3953),i=1,7)/20., 8., 6., 6., 2.29E-02,1.05664E+06,  2./
      DATA (u(i,3954),i=1,7)/20., 8., 6., 2., 2.25E-02,1.01061E+06,  2./
      DATA (u(i,3955),i=1,7)/20., 8., 6., 6., 2.12E-02,1.20613E+06,  2./
      DATA (u(i,3956),i=1,7)/20., 8., 6.,10., 1.80E-02,1.05787E+06,  2./
      DATA (u(i,3957),i=1,7)/20., 8., 6., 6., 1.44E-02,1.23579E+06,  2./
      DATA (u(i,3958),i=1,7)/20., 8., 6., 6., 1.40E-02,1.15647E+06,  2./
      DATA (u(i,3959),i=1,7)/20., 8., 6., 2., 1.36E-02,1.05441E+06,  2./
      DATA (u(i,3960),i=1,7)/20., 8., 6., 2., 1.30E-02,1.10339E+06,  2./
      DATA (u(i,3961),i=1,7)/20., 8., 6., 6., 1.16E-02,1.04319E+06,  2./
      DATA (u(i,3962),i=1,7)/20., 8., 6., 6., 1.00E-02,1.25298E+06,  2./
      DATA (u(i,3963),i=1,7)/20., 8., 6.,10., 8.35E-03,6.45328E+05,  3./
      DATA (u(i,3964),i=1,7)/20., 8., 6., 2., 7.84E-03,1.10558E+06,  2./
      DATA (u(i,3965),i=1,7)/20., 8., 6., 2., 7.55E-03,7.64117E+05,  3./
      DATA (u(i,3966),i=1,7)/20., 8., 6.,10., 6.61E-03,8.98069E+05,  2./
      DATA (u(i,3967),i=1,7)/20., 8., 6.,10., 6.49E-03,6.87285E+05,  3./
      DATA (u(i,3968),i=1,7)/20., 8., 6., 6., 6.46E-03,1.23365E+06,  2./
      DATA (u(i,3969),i=1,7)/20., 8., 6., 2., 5.10E-03,1.08519E+06,  2./
      DATA (u(i,3970),i=1,7)/20., 8., 6.,10., 4.53E-03,1.09902E+06,  2./
      DATA (u(i,3971),i=1,7)/20., 8., 6.,10., 4.35E-03,1.02260E+06,  2./
      DATA (u(i,3972),i=1,7)/20., 8., 6.,10., 4.19E-03,1.11495E+06,  2./
      DATA (u(i,3973),i=1,7)/20., 8., 6., 2., 3.56E-03,1.04657E+06,  2./
      DATA (u(i,3974),i=1,7)/20., 8., 6., 6., 3.54E-03,6.39264E+05,  3./
      DATA (u(i,3975),i=1,7)/20., 8., 6.,10., 3.08E-03,6.07128E+05,  3./
      DATA (u(i,3976),i=1,7)/20., 8., 6., 6., 2.90E-03,1.18022E+06,  2./
      DATA (u(i,3977),i=1,7)/20., 8., 6., 6., 1.79E-03,9.08265E+05,  2./
      DATA (u(i,3978),i=1,7)/20., 8., 6., 6., 1.70E-03,1.22279E+06,  2./
      DATA (u(i,3979),i=1,7)/20., 8., 6., 2., 9.67E-04,1.06123E+06,  2./
      DATA (u(i,3980),i=1,7)/20., 8., 6.,10., 8.86E-04,1.05020E+06,  2./
      DATA (u(i,3981),i=1,7)/20., 8., 6., 2., 8.07E-04,9.54290E+05,  2./
      DATA (u(i,3982),i=1,7)/20., 8., 6., 6., 6.54E-04,1.21981E+06,  2./
      DATA (u(i,3983),i=1,7)/20., 8., 6., 6., 4.36E-04,1.03702E+06,  2./
      DATA (u(i,3984),i=1,7)/20., 8., 6.,10., 3.63E-04,7.16538E+05,  3./
      DATA (u(i,3985),i=1,7)/20., 8., 6., 6., 3.53E-04,5.74581E+05,  3./
      DATA (u(i,3986),i=1,7)/20., 8., 6., 2., 3.02E-04,6.40738E+05,  3./
      DATA (u(i,3987),i=1,7)/20., 8., 6., 6., 2.68E-04,1.16645E+06,  2./
      DATA (u(i,3988),i=1,7)/20., 8., 6., 2., 2.62E-04,8.38504E+05,  2./
      DATA (u(i,3989),i=1,7)/20., 8., 6., 6., 1.11E-04,7.78028E+05,  3./
      DATA (u(i,3990),i=1,7)/20., 8., 6., 6., 7.37E-05,1.10705E+06,  2./
      DATA (u(i,3991),i=1,7)/20., 8., 6.,10., 6.04E-05,8.92061E+05,  2./
      DATA (u(i,3992),i=1,7)/20., 8., 6., 6., 1.39E-05,1.13559E+06,  3./
      DATA (u(i,3993),i=1,7)/20., 9., 1., 3., 1.08E+00,2.12436E+05,  3./
      DATA (u(i,3994),i=1,7)/20., 9., 1., 3., 2.56E-01,8.23927E+05,  2./
      DATA (u(i,3995),i=1,7)/20., 9., 1., 3., 6.38E-02,1.08648E+06,  2./
      DATA (u(i,3996),i=1,7)/20., 9., 1., 3., 3.81E-02,1.22669E+06,  2./
      DATA (u(i,3997),i=1,7)/20., 9., 1., 3., 2.45E-02,1.10278E+06,  2./
      DATA (u(i,3998),i=1,7)/20., 9., 1., 3., 2.39E-02,1.30651E+06,  2./
      DATA (u(i,3999),i=1,7)/20., 9., 1., 3., 1.43E-02,1.35740E+06,  2./
      DATA (u(i,4000),i=1,7)/20., 9., 1., 3., 7.09E-03,1.41423E+06,  2./
      DATA (u(i,4001),i=1,7)/20., 9., 1., 3., 5.48E-03,1.38850E+06,  2./
      DATA (u(i,4002),i=1,7)/20., 9., 1., 3., 3.97E-03,1.39315E+06,  2./
      DATA (u(i,4003),i=1,7)/20., 9., 1., 3., 2.13E-03,1.23870E+06,  2./
      DATA (u(i,4004),i=1,7)/20., 9., 1., 3., 2.02E-03,6.47626E+05,  3./
      DATA (u(i,4005),i=1,7)/20., 9., 1., 3., 8.51E-04,1.25897E+06,  2./
      DATA (u(i,4006),i=1,7)/20., 9., 1., 3., 2.53E-04,1.31944E+06,  2./
      DATA (u(i,4007),i=1,7)/20., 9., 1., 3., 2.03E-04,9.43485E+05,  2./
      DATA (u(i,4008),i=1,7)/20., 9., 1., 3., 6.44E-05,1.38083E+06,  2./
      DATA (u(i,4009),i=1,7)/20.,10., 2., 6., 9.96E-01,1.73608E+05,  3./
      DATA (u(i,4010),i=1,7)/20.,10., 2., 6., 3.18E-01,8.92937E+05,  2./
      DATA (u(i,4011),i=1,7)/20.,10., 2., 6., 1.06E-01,1.19847E+06,  2./
      DATA (u(i,4012),i=1,7)/20.,10., 2., 6., 5.00E-02,1.35722E+06,  2./
      DATA (u(i,4013),i=1,7)/20.,10., 2., 6., 2.80E-02,1.45012E+06,  2./
      DATA (u(i,4014),i=1,7)/20.,10., 2., 6., 1.74E-02,1.50943E+06,  2./
      DATA (u(i,4015),i=1,7)/20.,10., 2., 6., 1.16E-02,1.54919E+06,  2./
      DATA (u(i,4016),i=1,7)/20.,10., 2., 6., 8.15E-03,1.57754E+06,  2./
      DATA (u(i,4017),i=1,7)/20.,11., 1., 3., 2.34E+00,3.28731E+06, 19./
      DATA (u(i,4018),i=1,7)/20.,11., 1., 3., 6.51E-01,3.94166E+06, 20./
      DATA (u(i,4019),i=1,7)/20.,11., 1., 3., 3.03E-01,3.69822E+06,  2./
      DATA (u(i,4020),i=1,7)/20.,11., 1., 3., 2.99E-01,4.24448E+06,  2./
      DATA (u(i,4021),i=1,7)/20.,11., 1., 3., 2.32E-01,2.84252E+06, 21./
      DATA (u(i,4022),i=1,7)/20.,11., 1., 3., 1.64E-01,4.40917E+06,  2./
      DATA (u(i,4023),i=1,7)/20.,11., 1., 3., 1.29E-01,4.50653E+06,  2./
      DATA (u(i,4024),i=1,7)/20.,11., 1., 3., 6.61E-02,4.51875E+06,  2./
      DATA (u(i,4025),i=1,7)/20.,11., 1., 3., 5.66E-02,4.57247E+06,  2./
      DATA (u(i,4026),i=1,7)/20.,11., 1., 3., 4.06E-02,4.61467E+06,  2./
      DATA (u(i,4027),i=1,7)/20.,11., 1., 3., 2.95E-02,4.64684E+06,  2./
      DATA (u(i,4028),i=1,7)/20.,11., 1., 3., 2.85E-02,3.77216E+06, 22./
      DATA (u(i,4029),i=1,7)/20.,11., 1., 3., 1.53E-02,4.16146E+06,  2./
      DATA (u(i,4030),i=1,7)/20.,11., 1., 3., 8.24E-03,4.36110E+06,  2./
      DATA (u(i,4031),i=1,7)/20.,11., 1., 3., 6.34E-03,4.47828E+06,  2./
      DATA (u(i,4032),i=1,7)/20.,11., 1., 3., 1.53E-03,4.55166E+06,  2./
      DATA (u(i,4033),i=1,7)/20.,11., 1., 3., 1.50E-03,4.60193E+06,  2./
      DATA (u(i,4034),i=1,7)/20.,11., 1., 3., 1.14E-03,4.63822E+06,  2./
      DATA (u(i,4035),i=1,7)/20.,12., 6.,10., 5.11E+00,3.56125E+06,  2./
      DATA (u(i,4036),i=1,7)/20.,12., 6., 6., 3.83E+00,3.56125E+06,  2./
      DATA (u(i,4037),i=1,7)/20.,12., 6.,10., 2.30E+00,3.48554E+06,  2./
      DATA (u(i,4038),i=1,7)/20.,12., 6.,10., 1.27E+00,4.29000E+06,  2./
      DATA (u(i,4039),i=1,7)/20.,12., 6.,10., 1.09E+00,3.62976E+06,  2./
      DATA (u(i,4040),i=1,7)/20.,12., 6., 2., 1.05E+00,3.54108E+06,  2./
      DATA (u(i,4041),i=1,7)/20.,12., 6.,10., 7.57E-01,3.88199E+06,  2./
      DATA (u(i,4042),i=1,7)/20.,12., 6., 6., 7.38E-01,4.35730E+06,  2./
      DATA (u(i,4043),i=1,7)/20.,12., 6.,10., 7.17E-01,4.35730E+06,  2./
      DATA (u(i,4044),i=1,7)/20.,12., 6., 6., 6.35E-01,3.09502E+06,  2./
      DATA (u(i,4045),i=1,7)/20.,12., 6., 6., 5.38E-01,3.88651E+06,  2./
      DATA (u(i,4046),i=1,7)/20.,12., 6.,10., 4.09E-01,4.65549E+06,  2./
      DATA (u(i,4047),i=1,7)/20.,12., 6.,10., 3.98E-01,3.15358E+06,  2./
      DATA (u(i,4048),i=1,7)/20.,12., 6., 2., 3.54E-01,6.73310E+05,  3./
      DATA (u(i,4049),i=1,7)/20.,12., 6., 6., 3.40E-01,4.28633E+06,  2./
      DATA (u(i,4050),i=1,7)/20.,12., 6.,10., 3.39E-01,4.81928E+06,  2./
      DATA (u(i,4051),i=1,7)/20.,12., 6.,10., 3.26E-01,4.85437E+06,  2./
      DATA (u(i,4052),i=1,7)/20.,12., 6.,10., 3.00E-01,4.08664E+06,  2./
      DATA (u(i,4053),i=1,7)/20.,12., 6.,10., 2.92E-01,4.65766E+06,  2./
      DATA (u(i,4054),i=1,7)/20.,12., 6., 6., 2.73E-01,3.47947E+06,  2./
      DATA (u(i,4055),i=1,7)/20.,12., 6., 6., 2.68E-01,4.72590E+06,  2./
      DATA (u(i,4056),i=1,7)/20.,12., 6., 2., 2.47E-01,4.35540E+06,  2./
      DATA (u(i,4057),i=1,7)/20.,12., 6.,10., 2.43E-01,4.44247E+06,  2./
      DATA (u(i,4058),i=1,7)/20.,12., 6.,10., 2.25E-01,4.72813E+06,  2./
      DATA (u(i,4059),i=1,7)/20.,12., 6., 2., 2.23E-01,3.93082E+06,  2./
      DATA (u(i,4060),i=1,7)/20.,12., 6.,10., 2.17E-01,4.97265E+06,  2./
      DATA (u(i,4061),i=1,7)/20.,12., 6., 6., 2.07E-01,4.65549E+06,  2./
      DATA (u(i,4062),i=1,7)/20.,12., 6.,10., 1.76E-01,5.05050E+06,  2./
      DATA (u(i,4063),i=1,7)/20.,12., 6., 6., 1.33E-01,4.13736E+06,  2./
      DATA (u(i,4064),i=1,7)/20.,12., 6., 6., 1.27E-01,4.92611E+06,  2./
      DATA (u(i,4065),i=1,7)/20.,12., 6., 6., 1.25E-01,4.82393E+06,  2./
      DATA (u(i,4066),i=1,7)/20.,12., 6., 2., 1.14E-01,4.72590E+06,  2./
      DATA (u(i,4067),i=1,7)/20.,12., 6., 6., 1.02E-01,4.85201E+06,  2./
      DATA (u(i,4068),i=1,7)/20.,12., 6., 6., 9.44E-02,4.10172E+06,  2./
      DATA (u(i,4069),i=1,7)/20.,12., 6.,10., 9.20E-02,5.10204E+06,  2./
      DATA (u(i,4070),i=1,7)/20.,12., 6., 6., 8.97E-02,4.81000E+06,  2./
      DATA (u(i,4071),i=1,7)/20.,12., 6.,10., 8.91E-02,5.13875E+06,  2./
      DATA (u(i,4072),i=1,7)/20.,12., 6.,10., 8.67E-02,4.92611E+06,  2./
      DATA (u(i,4073),i=1,7)/20.,12., 6., 6., 8.08E-02,5.04032E+06,  2./
      DATA (u(i,4074),i=1,7)/20.,12., 6., 6., 8.08E-02,5.05050E+06,  2./
      DATA (u(i,4075),i=1,7)/20.,12., 6., 6., 7.92E-02,4.97265E+06,  2./
      DATA (u(i,4076),i=1,7)/20.,12., 6., 2., 7.46E-02,3.24465E+06,  2./
      DATA (u(i,4077),i=1,7)/20.,12., 6.,10., 7.26E-02,4.81464E+06,  2./
      DATA (u(i,4078),i=1,7)/20.,12., 6.,10., 7.23E-02,5.04032E+06,  2./
      DATA (u(i,4079),i=1,7)/20.,12., 6.,10., 6.94E-02,5.01504E+06,  2./
      DATA (u(i,4080),i=1,7)/20.,12., 6., 2., 6.53E-02,4.84731E+06,  2./
      DATA (u(i,4081),i=1,7)/20.,12., 6., 2., 5.55E-02,4.92611E+06,  2./
      DATA (u(i,4082),i=1,7)/20.,12., 6.,10., 5.06E-02,4.21053E+06,  2./
      DATA (u(i,4083),i=1,7)/20.,12., 6., 6., 4.53E-02,4.58085E+06,  2./
      DATA (u(i,4084),i=1,7)/20.,12., 6., 6., 4.39E-02,5.12558E+06,  2./
      DATA (u(i,4085),i=1,7)/20.,12., 6.,10., 3.46E-02,5.12558E+06,  2./
      DATA (u(i,4086),i=1,7)/20.,12., 6., 6., 2.94E-02,5.10204E+06,  2./
      DATA (u(i,4087),i=1,7)/20.,12., 6., 2., 2.74E-02,5.04032E+06,  2./
      DATA (u(i,4088),i=1,7)/20.,12., 6., 6., 2.67E-02,5.13875E+06,  2./
      DATA (u(i,4089),i=1,7)/20.,12., 6.,10., 2.50E-02,4.87805E+06,  2./
      DATA (u(i,4090),i=1,7)/20.,12., 6., 2., 1.98E-02,5.12558E+06,  2./
      DATA (u(i,4091),i=1,7)/20.,12., 6., 2., 1.75E-02,4.29923E+06,  2./
      DATA (u(i,4092),i=1,7)/20.,12., 6., 2., 1.57E-02,5.04796E+06,  2./
      DATA (u(i,4093),i=1,7)/20.,12., 6.,10., 1.57E-02,5.02260E+06,  2./
      DATA (u(i,4094),i=1,7)/20.,12., 6., 2., 1.41E-02,5.17866E+06,  2./
      DATA (u(i,4095),i=1,7)/20.,12., 6.,10., 1.20E-02,5.13611E+06,  2./
      DATA (u(i,4096),i=1,7)/20.,12., 6., 2., 1.02E-02,5.21648E+06,  2./
      DATA (u(i,4097),i=1,7)/20.,12., 6.,10., 9.35E-03,4.88759E+06,  2./
      DATA (u(i,4098),i=1,7)/20.,12., 6., 6., 6.99E-03,4.94805E+06,  2./
      DATA (u(i,4099),i=1,7)/20.,12., 6., 6., 5.45E-03,5.08906E+06,  2./
      DATA (u(i,4100),i=1,7)/20.,12., 6.,10., 5.43E-03,4.92611E+06,  2./
      DATA (u(i,4101),i=1,7)/20.,12., 6., 6., 4.06E-03,5.03271E+06,  2./
      DATA (u(i,4102),i=1,7)/20.,12., 6., 6., 2.89E-03,5.13084E+06,  2./
      DATA (u(i,4103),i=1,7)/20.,12., 6., 2., 2.62E-03,4.11692E+06,  2./
      DATA (u(i,4104),i=1,7)/20.,12., 6., 2., 1.79E-03,4.97760E+06,  2./
      DATA (u(i,4105),i=1,7)/20.,12., 6.,10., 1.28E-03,5.10986E+06,  2./
      DATA (u(i,4106),i=1,7)/20.,12., 6.,10., 9.05E-04,5.04796E+06,  2./
      DATA (u(i,4107),i=1,7)/20.,12., 6., 2., 6.22E-04,5.11247E+06,  2./
      DATA (u(i,4108),i=1,7)/20.,12., 6., 2., 2.18E-04,5.20021E+06,  2./
      DATA (u(i,4109),i=1,7)/20.,12., 6., 6., 1.43E-04,5.04796E+06,  2./
      DATA (u(i,4110),i=1,7)/20.,12., 6., 2., 1.38E-04,4.53720E+06,  2./
      DATA (u(i,4111),i=1,7)/20.,12., 6., 2., 7.23E-07,4.74608E+06,  2./
      DATA (u(i,4112),i=1,7)/20.,13., 9.,15., 5.00E+00,3.88802E+06,  2./
      DATA (u(i,4113),i=1,7)/20.,13., 9.,15., 4.79E+00,3.81971E+06,  2./
      DATA (u(i,4114),i=1,7)/20.,13., 9., 9., 4.49E+00,3.83289E+06,  2./
      DATA (u(i,4115),i=1,7)/20.,13., 9.,15., 2.17E+00,3.72301E+06,  2./
      DATA (u(i,4116),i=1,7)/20.,13., 9., 3., 1.53E+00,3.84615E+06,  2./
      DATA (u(i,4117),i=1,7)/20.,13., 9.,15., 1.23E+00,4.06009E+06,  2./
      DATA (u(i,4118),i=1,7)/20.,13., 9.,15., 1.14E+00,4.66636E+06,  2./
      DATA (u(i,4119),i=1,7)/20.,13., 9., 9., 9.14E-01,5.90284E+05,  3./
      DATA (u(i,4120),i=1,7)/20.,13., 9.,15., 9.00E-01,4.83559E+06,  2./
      DATA (u(i,4121),i=1,7)/20.,13., 9., 9., 8.75E-01,4.77099E+06,  2./
      DATA (u(i,4122),i=1,7)/20.,13., 9.,15., 8.52E-01,4.76417E+06,  2./
      DATA (u(i,4123),i=1,7)/20.,13., 9., 9., 7.95E-01,4.08330E+06,  2./
      DATA (u(i,4124),i=1,7)/20.,13., 9.,15., 7.70E-01,5.09684E+06,  2./
      DATA (u(i,4125),i=1,7)/20.,13., 9.,15., 5.83E-01,3.45066E+06,  2./
      DATA (u(i,4126),i=1,7)/20.,13., 9.,15., 5.66E-01,4.37828E+06,  2./
      DATA (u(i,4127),i=1,7)/20.,13., 9., 9., 4.70E-01,3.86997E+06,  2./
      DATA (u(i,4128),i=1,7)/20.,13., 9., 9., 3.82E-01,5.20291E+06,  2./
      DATA (u(i,4129),i=1,7)/20.,13., 9., 3., 3.79E-01,3.37154E+06,  2./
      DATA (u(i,4130),i=1,7)/20.,13., 9., 3., 3.78E-01,4.77555E+06,  2./
      DATA (u(i,4131),i=1,7)/20.,13., 9.,15., 3.70E-01,5.32765E+06,  2./
      DATA (u(i,4132),i=1,7)/20.,13., 9., 3., 3.44E-01,4.07166E+06,  2./
      DATA (u(i,4133),i=1,7)/20.,13., 9., 9., 3.33E-01,3.52237E+06,  2./
      DATA (u(i,4134),i=1,7)/20.,13., 9.,15., 3.29E-01,5.27148E+06,  2./
      DATA (u(i,4135),i=1,7)/20.,13., 9.,15., 3.07E-01,5.20021E+06,  2./
      DATA (u(i,4136),i=1,7)/20.,13., 9., 9., 2.78E-01,5.13611E+06,  2./
      DATA (u(i,4137),i=1,7)/20.,13., 9.,15., 2.75E-01,5.12033E+06,  2./
      DATA (u(i,4138),i=1,7)/20.,13., 9., 9., 2.59E-01,5.43478E+06,  2./
      DATA (u(i,4139),i=1,7)/20.,13., 9., 9., 2.52E-01,4.82859E+06,  2./
      DATA (u(i,4140),i=1,7)/20.,13., 9.,15., 2.07E-01,5.46747E+06,  2./
      DATA (u(i,4141),i=1,7)/20.,13., 9.,15., 2.01E-01,5.59284E+06,  2./
      DATA (u(i,4142),i=1,7)/20.,13., 9., 9., 1.87E-01,4.25894E+06,  2./
      DATA (u(i,4143),i=1,7)/20.,13., 9.,15., 1.77E-01,5.50358E+06,  2./
      DATA (u(i,4144),i=1,7)/20.,13., 9., 3., 1.69E-01,5.20562E+06,  2./
      DATA (u(i,4145),i=1,7)/20.,13., 9.,15., 1.53E-01,5.43478E+06,  2./
      DATA (u(i,4146),i=1,7)/20.,13., 9.,15., 1.49E-01,5.45256E+06,  2./
      DATA (u(i,4147),i=1,7)/20.,13., 9., 9., 1.17E-01,4.37445E+06,  2./
      DATA (u(i,4148),i=1,7)/20.,13., 9., 9., 1.16E-01,5.60224E+06,  2./
      DATA (u(i,4149),i=1,7)/20.,13., 9., 9., 1.14E-01,5.26870E+06,  2./
      DATA (u(i,4150),i=1,7)/20.,13., 9.,15., 1.13E-01,4.62963E+06,  2./
      DATA (u(i,4151),i=1,7)/20.,13., 9., 9., 1.09E-01,5.57414E+06,  2./
      DATA (u(i,4152),i=1,7)/20.,13., 9.,15., 1.08E-01,5.64334E+06,  2./
      DATA (u(i,4153),i=1,7)/20.,13., 9.,15., 1.07E-01,5.55556E+06,  2./
      DATA (u(i,4154),i=1,7)/20.,13., 9., 3., 1.03E-01,5.43774E+06,  2./
      DATA (u(i,4155),i=1,7)/20.,13., 9.,15., 9.85E-02,5.57414E+06,  2./
      DATA (u(i,4156),i=1,7)/20.,13., 9., 3., 8.70E-02,5.12295E+06,  2./
      DATA (u(i,4157),i=1,7)/20.,13., 9.,15., 7.87E-02,5.61798E+06,  2./
      DATA (u(i,4158),i=1,7)/20.,13., 9., 3., 7.08E-02,4.52899E+06,  2./
      DATA (u(i,4159),i=1,7)/20.,13., 9., 9., 7.07E-02,5.66572E+06,  2./
      DATA (u(i,4160),i=1,7)/20.,13., 9., 3., 6.95E-02,4.40723E+06,  2./
      DATA (u(i,4161),i=1,7)/20.,13., 9., 9., 6.72E-02,4.34216E+06,  2./
      DATA (u(i,4162),i=1,7)/20.,13., 9., 9., 6.25E-02,4.69925E+06,  2./
      DATA (u(i,4163),i=1,7)/20.,13., 9., 9., 5.60E-02,5.50358E+06,  2./
      DATA (u(i,4164),i=1,7)/20.,13., 9.,15., 5.39E-02,5.13875E+06,  2./
      DATA (u(i,4165),i=1,7)/20.,13., 9., 9., 4.91E-02,5.72738E+06,  2./
      DATA (u(i,4166),i=1,7)/20.,13., 9., 3., 4.85E-02,5.59597E+06,  2./
      DATA (u(i,4167),i=1,7)/20.,13., 9., 9., 4.69E-02,5.44959E+06,  2./
      DATA (u(i,4168),i=1,7)/20.,13., 9., 3., 4.58E-02,5.57724E+06,  2./
      DATA (u(i,4169),i=1,7)/20.,13., 9.,15., 4.10E-02,5.05817E+06,  2./
      DATA (u(i,4170),i=1,7)/20.,13., 9., 9., 3.62E-02,5.77034E+06,  2./
      DATA (u(i,4171),i=1,7)/20.,13., 9., 3., 3.60E-02,5.03271E+06,  2./
      DATA (u(i,4172),i=1,7)/20.,13., 9., 9., 3.59E-02,5.64334E+06,  2./
      DATA (u(i,4173),i=1,7)/20.,13., 9.,15., 3.16E-02,5.40248E+06,  2./
      DATA (u(i,4174),i=1,7)/20.,13., 9.,15., 3.10E-02,5.66251E+06,  2./
      DATA (u(i,4175),i=1,7)/20.,13., 9., 9., 2.12E-02,5.73394E+06,  2./
      DATA (u(i,4176),i=1,7)/20.,13., 9.,15., 1.97E-02,5.55556E+06,  2./
      DATA (u(i,4177),i=1,7)/20.,13., 9., 3., 1.78E-02,5.46150E+06,  2./
      DATA (u(i,4178),i=1,7)/20.,13., 9., 9., 1.62E-02,5.02008E+06,  2./
      DATA (u(i,4179),i=1,7)/20.,13., 9., 3., 9.43E-03,5.29381E+06,  2./
      DATA (u(i,4180),i=1,7)/20.,13., 9., 9., 9.34E-03,5.21105E+06,  2./
      DATA (u(i,4181),i=1,7)/20.,13., 9., 3., 7.95E-03,5.54324E+06,  2./
      DATA (u(i,4182),i=1,7)/20.,13., 9., 9., 6.78E-03,5.62430E+06,  2./
      DATA (u(i,4183),i=1,7)/20.,13., 9., 9., 5.10E-03,5.72082E+06,  2./
      DATA (u(i,4184),i=1,7)/20.,13., 9.,15., 4.72E-03,5.65291E+06,  2./
      DATA (u(i,4185),i=1,7)/20.,13., 9.,15., 4.05E-03,5.39665E+06,  2./
      DATA (u(i,4186),i=1,7)/20.,13., 9., 9., 4.02E-03,5.41419E+06,  2./
      DATA (u(i,4187),i=1,7)/20.,13., 9., 9., 3.53E-03,5.30786E+06,  2./
      DATA (u(i,4188),i=1,7)/20.,13., 9., 3., 2.80E-03,5.65611E+06,  2./
      DATA (u(i,4189),i=1,7)/20.,13., 9.,15., 2.01E-03,4.24088E+06,  2./
      DATA (u(i,4190),i=1,7)/20.,13., 9., 3., 1.44E-03,5.44662E+06,  2./
      DATA (u(i,4191),i=1,7)/20.,13., 9., 9., 9.14E-04,5.39374E+06,  2./
      DATA (u(i,4192),i=1,7)/20.,13., 9.,15., 8.69E-04,5.55247E+06,  2./
      DATA (u(i,4193),i=1,7)/20.,13., 9., 9., 8.15E-04,4.73485E+06,  2./
      DATA (u(i,4194),i=1,7)/20.,13., 9., 3., 4.88E-04,5.60852E+06,  2./
      DATA (u(i,4195),i=1,7)/20.,13., 9.,15., 1.44E-04,5.21648E+06,  2./
      DATA (u(i,4196),i=1,7)/20.,13., 9., 9., 1.33E-04,5.47345E+06,  2./
      DATA (u(i,4197),i=1,7)/20.,13., 9.,15., 6.94E-05,5.21648E+06,  2./
      DATA (u(i,4198),i=1,7)/20.,13., 9.,15., 1.16E-05,5.30223E+06,  2./
      DATA (u(i,4199),i=1,7)/20.,13., 9.,15., 3.28E-06,5.63063E+06,  2./
      DATA (u(i,4200),i=1,7)/20.,14., 4.,12., 7.16E+00,4.14079E+06,  2./
      DATA (u(i,4201),i=1,7)/20.,14., 4.,12., 1.51E+00,5.23013E+06,  2./
      DATA (u(i,4202),i=1,7)/20.,14., 4.,12., 1.10E+00,4.20168E+06,  2./
      DATA (u(i,4203),i=1,7)/20.,14., 4.,12., 6.23E-01,5.72738E+06,  2./
      DATA (u(i,4204),i=1,7)/20.,14., 4.,12., 5.05E-01,5.00952E+05,  3./
      DATA (u(i,4205),i=1,7)/20.,14., 4.,12., 4.27E-01,3.78788E+06,  2./
      DATA (u(i,4206),i=1,7)/20.,14., 4.,12., 4.09E-01,4.62963E+06,  2./
      DATA (u(i,4207),i=1,7)/20.,14., 4.,12., 3.89E-01,5.38503E+06,  2./
      DATA (u(i,4208),i=1,7)/20.,14., 4.,12., 3.02E-01,5.99880E+06,  2./
      DATA (u(i,4209),i=1,7)/20.,14., 4.,12., 1.80E-01,6.15764E+06,  2./
      DATA (u(i,4210),i=1,7)/20.,14., 4.,12., 1.69E-01,5.85480E+06,  2./
      DATA (u(i,4211),i=1,7)/20.,14., 4.,12., 1.55E-01,5.91017E+06,  2./
      DATA (u(i,4212),i=1,7)/20.,14., 4.,12., 1.18E-01,6.26566E+06,  2./
      DATA (u(i,4213),i=1,7)/20.,14., 4.,12., 8.40E-02,4.50450E+06,  2./
      DATA (u(i,4214),i=1,7)/20.,14., 4.,12., 7.89E-02,6.33714E+06,  2./
      DATA (u(i,4215),i=1,7)/20.,14., 4.,12., 6.81E-02,5.19751E+06,  2./
      DATA (u(i,4216),i=1,7)/20.,14., 4.,12., 6.49E-02,6.19579E+06,  2./
      DATA (u(i,4217),i=1,7)/20.,14., 4.,12., 6.33E-02,5.09424E+06,  2./
      DATA (u(i,4218),i=1,7)/20.,14., 4.,12., 6.11E-02,6.38570E+06,  2./
      DATA (u(i,4219),i=1,7)/20.,14., 4.,12., 5.44E-02,6.35728E+06,  2./
      DATA (u(i,4220),i=1,7)/20.,14., 4.,12., 4.08E-02,4.45038E+06,  2./
      DATA (u(i,4221),i=1,7)/20.,14., 4.,12., 2.23E-02,6.29327E+06,  2./
      DATA (u(i,4222),i=1,7)/20.,14., 4.,12., 1.99E-02,5.65931E+06,  2./
      DATA (u(i,4223),i=1,7)/20.,14., 4.,12., 1.54E-02,6.18812E+06,  2./
      DATA (u(i,4224),i=1,7)/20.,14., 4.,12., 1.43E-02,5.67859E+06,  2./
      DATA (u(i,4225),i=1,7)/20.,14., 4.,12., 1.10E-02,5.71429E+06,  2./
      DATA (u(i,4226),i=1,7)/20.,14., 4.,12., 9.81E-03,5.95948E+06,  2./
      DATA (u(i,4227),i=1,7)/20.,14., 4.,12., 7.46E-03,4.88043E+06,  2./
      DATA (u(i,4228),i=1,7)/20.,14., 4.,12., 6.64E-03,6.13497E+06,  2./
      DATA (u(i,4229),i=1,7)/20.,14., 4.,12., 5.79E-03,6.16523E+06,  2./
      DATA (u(i,4230),i=1,7)/20.,14., 4.,12., 5.27E-03,6.25000E+06,  2./
      DATA (u(i,4231),i=1,7)/20.,14., 4.,12., 4.75E-03,6.37755E+06,  2./
      DATA (u(i,4232),i=1,7)/20.,14., 4.,12., 3.30E-03,6.32511E+06,  2./
      DATA (u(i,4233),i=1,7)/20.,14., 4.,12., 2.67E-03,6.18047E+06,  2./
      DATA (u(i,4234),i=1,7)/20.,14., 4.,12., 2.65E-03,5.63063E+06,  2./
      DATA (u(i,4235),i=1,7)/20.,14., 4.,12., 5.76E-04,6.21891E+06,  2./
      DATA (u(i,4236),i=1,7)/20.,15., 9.,15., 8.31E+00,4.37637E+06,  2./
      DATA (u(i,4237),i=1,7)/20.,15., 9., 9., 2.73E+00,4.38404E+06,  2./
      DATA (u(i,4238),i=1,7)/20.,15., 9.,15., 1.86E+00,4.49035E+06,  2./
      DATA (u(i,4239),i=1,7)/20.,15., 9.,15., 1.69E+00,5.62114E+06,  2./
      DATA (u(i,4240),i=1,7)/20.,15., 9., 9., 1.10E+00,4.51467E+06,  2./
      DATA (u(i,4241),i=1,7)/20.,15., 9.,15., 5.72E-01,6.19195E+06,  2./
      DATA (u(i,4242),i=1,7)/20.,15., 9., 3., 5.61E-01,6.76087E+05,  3./
      DATA (u(i,4243),i=1,7)/20.,15., 9., 9., 5.54E-01,5.62114E+06,  2./
      DATA (u(i,4244),i=1,7)/20.,15., 9.,15., 5.49E-01,5.81058E+06,  2./
      DATA (u(i,4245),i=1,7)/20.,15., 9., 9., 5.30E-01,4.07332E+06,  2./
      DATA (u(i,4246),i=1,7)/20.,15., 9., 9., 4.81E-01,5.23533E+05,  3./
      DATA (u(i,4247),i=1,7)/20.,15., 9.,15., 4.33E-01,4.42929E+05,  3./
      DATA (u(i,4248),i=1,7)/20.,15., 9., 3., 4.01E-01,4.42674E+06,  2./
      DATA (u(i,4249),i=1,7)/20.,15., 9.,15., 3.83E-01,4.79616E+06,  2./
      DATA (u(i,4250),i=1,7)/20.,15., 9.,15., 3.31E-01,6.49773E+06,  2./
      DATA (u(i,4251),i=1,7)/20.,15., 9., 9., 3.19E-01,5.82072E+06,  2./
      DATA (u(i,4252),i=1,7)/20.,15., 9.,15., 2.73E-01,6.14251E+06,  2./
      DATA (u(i,4253),i=1,7)/20.,15., 9.,15., 2.38E-01,4.67290E+06,  2./
      DATA (u(i,4254),i=1,7)/20.,15., 9., 9., 2.20E-01,4.81464E+06,  2./
      DATA (u(i,4255),i=1,7)/20.,15., 9.,15., 1.94E-01,6.68449E+06,  2./
      DATA (u(i,4256),i=1,7)/20.,15., 9., 9., 1.90E-01,6.19195E+06,  2./
      DATA (u(i,4257),i=1,7)/20.,15., 9.,15., 1.53E-01,6.41026E+06,  2./
      DATA (u(i,4258),i=1,7)/20.,15., 9., 3., 1.41E-01,4.81696E+06,  2./
      DATA (u(i,4259),i=1,7)/20.,15., 9., 9., 1.39E-01,4.78698E+06,  2./
      DATA (u(i,4260),i=1,7)/20.,15., 9.,15., 1.30E-01,6.72043E+06,  2./
      DATA (u(i,4261),i=1,7)/20.,15., 9., 9., 1.29E-01,6.40615E+06,  2./
      DATA (u(i,4262),i=1,7)/20.,15., 9.,15., 1.17E-01,6.80272E+06,  2./
      DATA (u(i,4263),i=1,7)/20.,15., 9., 9., 1.12E-01,6.49773E+06,  2./
      DATA (u(i,4264),i=1,7)/20.,15., 9., 3., 1.10E-01,5.79039E+06,  2./
      DATA (u(i,4265),i=1,7)/20.,15., 9., 9., 1.06E-01,6.12745E+06,  2./
      DATA (u(i,4266),i=1,7)/20.,15., 9., 9., 8.89E-02,5.50358E+06,  2./
      DATA (u(i,4267),i=1,7)/20.,15., 9.,15., 8.06E-02,6.88705E+06,  2./
      DATA (u(i,4268),i=1,7)/20.,15., 9., 9., 7.90E-02,4.69704E+06,  2./
      DATA (u(i,4269),i=1,7)/20.,15., 9., 9., 7.66E-02,6.72495E+06,  2./
      DATA (u(i,4270),i=1,7)/20.,15., 9.,15., 6.95E-02,6.74764E+06,  2./
      DATA (u(i,4271),i=1,7)/20.,15., 9., 9., 6.38E-02,6.68449E+06,  2./
      DATA (u(i,4272),i=1,7)/20.,15., 9.,15., 5.81E-02,6.94444E+06,  2./
      DATA (u(i,4273),i=1,7)/20.,15., 9.,15., 5.56E-02,5.26870E+06,  2./
      DATA (u(i,4274),i=1,7)/20.,15., 9., 9., 5.48E-02,6.15764E+06,  2./
      DATA (u(i,4275),i=1,7)/20.,15., 9.,15., 5.30E-02,6.38978E+06,  2./
      DATA (u(i,4276),i=1,7)/20.,15., 9., 3., 5.00E-02,6.15385E+06,  2./
      DATA (u(i,4277),i=1,7)/20.,15., 9., 3., 4.82E-02,4.93583E+06,  2./
      DATA (u(i,4278),i=1,7)/20.,15., 9., 9., 4.65E-02,6.74764E+06,  2./
      DATA (u(i,4279),i=1,7)/20.,15., 9., 3., 4.61E-02,6.39795E+06,  2./
      DATA (u(i,4280),i=1,7)/20.,15., 9.,15., 4.12E-02,6.91085E+06,  2./
      DATA (u(i,4281),i=1,7)/20.,15., 9., 9., 3.87E-02,6.80272E+06,  2./
      DATA (u(i,4282),i=1,7)/20.,15., 9.,15., 3.56E-02,6.37755E+06,  2./
      DATA (u(i,4283),i=1,7)/20.,15., 9., 9., 3.47E-02,6.11247E+06,  2./
      DATA (u(i,4284),i=1,7)/20.,15., 9.,15., 3.29E-02,5.16262E+06,  2./
      DATA (u(i,4285),i=1,7)/20.,15., 9.,15., 3.26E-02,6.91563E+06,  2./
      DATA (u(i,4286),i=1,7)/20.,15., 9.,15., 2.82E-02,5.37634E+06,  2./
      DATA (u(i,4287),i=1,7)/20.,15., 9., 9., 2.74E-02,6.91085E+06,  2./
      DATA (u(i,4288),i=1,7)/20.,15., 9., 9., 2.66E-02,6.88705E+06,  2./
      DATA (u(i,4289),i=1,7)/20.,15., 9., 3., 2.39E-02,6.75219E+06,  2./
      DATA (u(i,4290),i=1,7)/20.,15., 9.,15., 2.11E-02,4.98504E+06,  2./
      DATA (u(i,4291),i=1,7)/20.,15., 9., 3., 2.02E-02,6.71592E+06,  2./
      DATA (u(i,4292),i=1,7)/20.,15., 9., 9., 1.93E-02,6.94444E+06,  2./
      DATA (u(i,4293),i=1,7)/20.,15., 9., 9., 1.92E-02,6.46831E+06,  2./
      DATA (u(i,4294),i=1,7)/20.,15., 9., 9., 1.87E-02,5.28541E+06,  2./
      DATA (u(i,4295),i=1,7)/20.,15., 9., 9., 1.76E-02,5.35619E+06,  2./
      DATA (u(i,4296),i=1,7)/20.,15., 9., 9., 1.39E-02,6.91563E+06,  2./
      DATA (u(i,4297),i=1,7)/20.,15., 9.,15., 1.34E-02,6.60502E+06,  2./
      DATA (u(i,4298),i=1,7)/20.,15., 9., 9., 1.11E-02,6.66667E+06,  2./
      DATA (u(i,4299),i=1,7)/20.,15., 9., 3., 1.08E-02,6.91085E+06,  2./
      DATA (u(i,4300),i=1,7)/20.,15., 9.,15., 1.05E-02,6.48929E+06,  2./
      DATA (u(i,4301),i=1,7)/20.,15., 9., 3., 1.03E-02,5.30504E+06,  2./
      DATA (u(i,4302),i=1,7)/20.,15., 9., 3., 9.35E-03,7.06215E+06,  2./
      DATA (u(i,4303),i=1,7)/20.,15., 9., 9., 8.71E-03,5.09424E+06,  2./
      DATA (u(i,4304),i=1,7)/20.,15., 9., 3., 8.28E-03,7.03235E+06,  2./
      DATA (u(i,4305),i=1,7)/20.,15., 9., 3., 6.69E-03,7.11744E+06,  2./
      DATA (u(i,4306),i=1,7)/20.,15., 9.,15., 5.19E-03,5.99520E+06,  2./
      DATA (u(i,4307),i=1,7)/20.,15., 9., 9., 4.84E-03,6.60066E+06,  2./
      DATA (u(i,4308),i=1,7)/20.,15., 9., 3., 4.55E-03,7.17360E+06,  2./
      DATA (u(i,4309),i=1,7)/20.,15., 9., 3., 4.43E-03,6.50618E+06,  2./
      DATA (u(i,4310),i=1,7)/20.,15., 9., 9., 4.39E-03,6.48929E+06,  2./
      DATA (u(i,4311),i=1,7)/20.,15., 9., 3., 4.10E-03,7.07214E+06,  2./
      DATA (u(i,4312),i=1,7)/20.,15., 9., 9., 3.51E-03,6.79348E+06,  2./
      DATA (u(i,4313),i=1,7)/20.,15., 9., 9., 3.49E-03,6.93963E+06,  2./
      DATA (u(i,4314),i=1,7)/20.,15., 9., 9., 3.47E-03,6.87758E+06,  2./
      DATA (u(i,4315),i=1,7)/20.,15., 9., 3., 3.45E-03,6.89655E+06,  2./
      DATA (u(i,4316),i=1,7)/20.,15., 9., 9., 2.93E-03,6.71592E+06,  2./
      DATA (u(i,4317),i=1,7)/20.,15., 9.,15., 2.25E-03,6.07903E+06,  2./
      DATA (u(i,4318),i=1,7)/20.,15., 9.,15., 1.38E-03,6.63570E+06,  2./
      DATA (u(i,4319),i=1,7)/20.,15., 9.,15., 1.09E-03,6.74309E+06,  2./
      DATA (u(i,4320),i=1,7)/20.,15., 9., 9., 1.05E-03,6.08643E+06,  2./
      DATA (u(i,4321),i=1,7)/20.,15., 9., 9., 9.99E-04,6.59631E+06,  2./
      DATA (u(i,4322),i=1,7)/20.,15., 9.,15., 8.69E-04,5.88235E+06,  2./
      DATA (u(i,4323),i=1,7)/20.,15., 9., 9., 6.25E-04,6.63570E+06,  2./
      DATA (u(i,4324),i=1,7)/20.,15., 9.,15., 5.74E-04,6.78887E+06,  2./
      DATA (u(i,4325),i=1,7)/20.,15., 9., 3., 4.83E-04,6.27746E+06,  2./
      DATA (u(i,4326),i=1,7)/20.,15., 9., 9., 4.42E-04,6.50195E+06,  2./
      DATA (u(i,4327),i=1,7)/20.,15., 9.,15., 4.09E-04,6.59196E+06,  2./
      DATA (u(i,4328),i=1,7)/20.,15., 9.,15., 3.48E-04,6.93481E+06,  2./
      DATA (u(i,4329),i=1,7)/20.,15., 9.,15., 2.90E-04,6.23053E+06,  2./
      DATA (u(i,4330),i=1,7)/20.,15., 9., 9., 2.43E-04,6.93963E+06,  2./
      DATA (u(i,4331),i=1,7)/20.,15., 9.,15., 2.36E-04,6.43915E+06,  2./
      DATA (u(i,4332),i=1,7)/20.,15., 9., 9., 2.25E-04,6.00240E+06,  2./
      DATA (u(i,4333),i=1,7)/20.,15., 9.,15., 1.16E-04,6.92521E+06,  2./
      DATA (u(i,4334),i=1,7)/20.,16., 6.,10., 3.94E+00,4.62107E+06,  2./
      DATA (u(i,4335),i=1,7)/20.,16., 6.,10., 1.75E+00,4.80538E+06,  2./
      DATA (u(i,4336),i=1,7)/20.,16., 6., 6., 8.97E-01,4.73709E+06,  2./
      DATA (u(i,4337),i=1,7)/20.,16., 6.,10., 7.51E-01,6.02410E+06,  2./
      DATA (u(i,4338),i=1,7)/20.,16., 6., 6., 6.77E-01,5.82411E+05,  3./
      DATA (u(i,4339),i=1,7)/20.,16., 6.,10., 4.30E-01,6.25391E+06,  2./
      DATA (u(i,4340),i=1,7)/20.,16., 6., 2., 3.61E-01,4.84496E+06,  2./
      DATA (u(i,4341),i=1,7)/20.,16., 6., 6., 2.93E-01,4.99500E+06,  2./
      DATA (u(i,4342),i=1,7)/20.,16., 6.,10., 2.74E-01,6.67111E+06,  2./
      DATA (u(i,4343),i=1,7)/20.,16., 6.,10., 2.65E-01,4.27077E+05,  3./
      DATA (u(i,4344),i=1,7)/20.,16., 6., 6., 2.43E-01,6.23053E+06,  2./
      DATA (u(i,4345),i=1,7)/20.,16., 6.,10., 1.69E-01,6.91085E+06,  2./
      DATA (u(i,4346),i=1,7)/20.,16., 6.,10., 1.43E-01,7.01754E+06,  2./
      DATA (u(i,4347),i=1,7)/20.,16., 6., 2., 1.38E-01,5.50994E+05,  3./
      DATA (u(i,4348),i=1,7)/20.,16., 6., 2., 1.28E-01,4.37254E+06,  2./
      DATA (u(i,4349),i=1,7)/20.,16., 6.,10., 1.15E-01,4.99750E+06,  2./
      DATA (u(i,4350),i=1,7)/20.,16., 6., 6., 1.03E-01,6.90131E+06,  2./
      DATA (u(i,4351),i=1,7)/20.,16., 6.,10., 9.45E-02,6.47249E+06,  2./
      DATA (u(i,4352),i=1,7)/20.,16., 6.,10., 9.38E-02,7.26744E+06,  2./
      DATA (u(i,4353),i=1,7)/20.,16., 6., 6., 8.80E-02,5.12820E+06,  2./
      DATA (u(i,4354),i=1,7)/20.,16., 6., 6., 8.65E-02,6.47249E+06,  2./
      DATA (u(i,4355),i=1,7)/20.,16., 6., 2., 8.31E-02,6.26959E+06,  2./
      DATA (u(i,4356),i=1,7)/20.,16., 6.,10., 7.87E-02,7.23066E+06,  2./
      DATA (u(i,4357),i=1,7)/20.,16., 6.,10., 5.90E-02,7.47943E+06,  2./
      DATA (u(i,4358),i=1,7)/20.,16., 6., 6., 5.41E-02,7.25689E+06,  2./
      DATA (u(i,4359),i=1,7)/20.,16., 6.,10., 5.31E-02,7.36377E+06,  2./
      DATA (u(i,4360),i=1,7)/20.,16., 6.,10., 4.88E-02,5.38793E+06,  2./
      DATA (u(i,4361),i=1,7)/20.,16., 6.,10., 4.33E-02,7.13776E+06,  2./
      DATA (u(i,4362),i=1,7)/20.,16., 6.,10., 4.13E-02,5.36193E+06,  2./
      DATA (u(i,4363),i=1,7)/20.,16., 6.,10., 3.60E-02,7.45712E+06,  2./
      DATA (u(i,4364),i=1,7)/20.,16., 6., 2., 3.56E-02,5.02765E+06,  2./
      DATA (u(i,4365),i=1,7)/20.,16., 6., 6., 3.28E-02,7.13776E+06,  2./
      DATA (u(i,4366),i=1,7)/20.,16., 6., 2., 3.22E-02,6.92042E+06,  2./
      DATA (u(i,4367),i=1,7)/20.,16., 6.,10., 2.95E-02,6.71592E+06,  2./
      DATA (u(i,4368),i=1,7)/20.,16., 6., 6., 2.83E-02,7.47384E+06,  2./
      DATA (u(i,4369),i=1,7)/20.,16., 6., 6., 2.71E-02,5.41712E+06,  2./
      DATA (u(i,4370),i=1,7)/20.,16., 6., 2., 2.70E-02,6.47668E+06,  2./
      DATA (u(i,4371),i=1,7)/20.,16., 6.,10., 2.59E-02,5.15730E+06,  2./
      DATA (u(i,4372),i=1,7)/20.,16., 6., 2., 2.37E-02,5.93120E+06,  2./
      DATA (u(i,4373),i=1,7)/20.,16., 6.,10., 2.35E-02,7.52445E+06,  2./
      DATA (u(i,4374),i=1,7)/20.,16., 6., 6., 2.14E-02,7.61615E+06,  2./
      DATA (u(i,4375),i=1,7)/20.,16., 6., 6., 2.12E-02,7.71010E+06,  2./
      DATA (u(i,4376),i=1,7)/20.,16., 6., 6., 2.07E-02,7.49625E+06,  2./
      DATA (u(i,4377),i=1,7)/20.,16., 6.,10., 1.84E-02,7.49625E+06,  2./
      DATA (u(i,4378),i=1,7)/20.,16., 6., 2., 1.72E-02,7.27273E+06,  2./
      DATA (u(i,4379),i=1,7)/20.,16., 6., 6., 1.36E-02,5.27983E+06,  2./
      DATA (u(i,4380),i=1,7)/20.,16., 6., 2., 1.29E-02,7.47943E+06,  2./
      DATA (u(i,4381),i=1,7)/20.,16., 6., 2., 1.20E-02,7.14286E+06,  2./
      DATA (u(i,4382),i=1,7)/20.,16., 6.,10., 1.10E-02,5.54631E+06,  2./
      DATA (u(i,4383),i=1,7)/20.,16., 6., 6., 1.04E-02,7.77605E+06,  2./
      DATA (u(i,4384),i=1,7)/20.,16., 6., 6., 8.36E-03,6.77966E+06,  2./
      DATA (u(i,4385),i=1,7)/20.,16., 6.,10., 7.75E-03,6.93481E+06,  2./
      DATA (u(i,4386),i=1,7)/20.,16., 6., 6., 6.77E-03,6.68449E+06,  2./
      DATA (u(i,4387),i=1,7)/20.,16., 6., 2., 6.51E-03,6.99301E+06,  2./
      DATA (u(i,4388),i=1,7)/20.,16., 6., 2., 6.39E-03,6.62690E+06,  2./
      DATA (u(i,4389),i=1,7)/20.,16., 6., 2., 6.03E-03,5.43183E+06,  2./
      DATA (u(i,4390),i=1,7)/20.,16., 6.,10., 5.92E-03,7.34214E+06,  2./
      DATA (u(i,4391),i=1,7)/20.,16., 6.,10., 5.71E-03,6.76590E+06,  2./
      DATA (u(i,4392),i=1,7)/20.,16., 6., 2., 4.68E-03,5.32481E+06,  2./
      DATA (u(i,4393),i=1,7)/20.,16., 6., 6., 4.60E-03,7.41290E+06,  2./
      DATA (u(i,4394),i=1,7)/20.,16., 6., 6., 4.12E-03,7.29395E+06,  2./
      DATA (u(i,4395),i=1,7)/20.,16., 6., 6., 3.66E-03,7.71010E+06,  2./
      DATA (u(i,4396),i=1,7)/20.,16., 6., 2., 3.42E-03,7.49625E+06,  2./
      DATA (u(i,4397),i=1,7)/20.,16., 6.,10., 3.19E-03,7.40741E+06,  2./
      DATA (u(i,4398),i=1,7)/20.,16., 6., 2., 2.73E-03,6.77966E+06,  2./
      DATA (u(i,4399),i=1,7)/20.,16., 6., 2., 1.97E-03,7.35294E+06,  2./
      DATA (u(i,4400),i=1,7)/20.,16., 6.,10., 1.93E-03,6.67557E+06,  2./
      DATA (u(i,4401),i=1,7)/20.,16., 6., 2., 1.89E-03,7.41290E+06,  2./
      DATA (u(i,4402),i=1,7)/20.,16., 6., 6., 1.82E-03,7.33138E+06,  2./
      DATA (u(i,4403),i=1,7)/20.,16., 6., 6., 1.73E-03,7.67460E+06,  2./
      DATA (u(i,4404),i=1,7)/20.,16., 6., 2., 1.50E-03,7.45156E+06,  2./
      DATA (u(i,4405),i=1,7)/20.,16., 6., 2., 1.44E-03,7.21501E+06,  2./
      DATA (u(i,4406),i=1,7)/20.,16., 6., 6., 1.42E-03,7.75795E+06,  2./
      DATA (u(i,4407),i=1,7)/20.,16., 6.,10., 1.13E-03,6.31313E+06,  2./
      DATA (u(i,4408),i=1,7)/20.,16., 6., 2., 6.63E-04,6.84932E+06,  2./
      DATA (u(i,4409),i=1,7)/20.,16., 6.,10., 4.93E-04,7.49064E+06,  2./
      DATA (u(i,4410),i=1,7)/20.,16., 6.,10., 4.92E-04,6.54450E+06,  2./
      DATA (u(i,4411),i=1,7)/20.,16., 6.,10., 4.58E-04,7.28332E+06,  2./
      DATA (u(i,4412),i=1,7)/20.,16., 6., 2., 3.61E-04,7.51880E+06,  2./
      DATA (u(i,4413),i=1,7)/20.,16., 6.,10., 1.75E-04,7.51880E+06,  2./
      DATA (u(i,4414),i=1,7)/20.,16., 6.,10., 1.73E-04,6.94444E+06,  2./
      DATA (u(i,4415),i=1,7)/20.,16., 6., 6., 1.64E-04,6.60939E+06,  2./
      DATA (u(i,4416),i=1,7)/20.,16., 6.,10., 1.03E-04,7.17360E+06,  2./
      DATA (u(i,4417),i=1,7)/20.,16., 6.,10., 2.99E-05,7.36377E+06,  2./
      DATA (u(i,4418),i=1,7)/20.,16., 6., 6., 6.84E-06,7.65697E+06,  2./
      DATA (u(i,4419),i=1,7)/20.,16., 6.,10., 1.16E-06,7.41840E+06,  2./
      DATA (u(i,4420),i=1,7)/20.,17., 1., 3., 6.49E-01,5.06842E+06,  2./
      DATA (u(i,4421),i=1,7)/20.,17., 1., 3., 1.75E-01,4.89644E+05,  3./
      DATA (u(i,4422),i=1,7)/20.,17., 1., 3., 1.69E-01,6.69344E+06,  2./
      DATA (u(i,4423),i=1,7)/20.,17., 1., 3., 6.92E-02,7.42942E+06,  2./
      DATA (u(i,4424),i=1,7)/20.,17., 1., 3., 3.42E-02,5.32198E+06,  2./
      DATA (u(i,4425),i=1,7)/20.,17., 1., 3., 3.39E-02,7.82473E+06,  2./
      DATA (u(i,4426),i=1,7)/20.,17., 1., 3., 3.25E-02,5.52181E+06,  2./
      DATA (u(i,4427),i=1,7)/20.,17., 1., 3., 2.19E-02,8.05802E+06,  2./
      DATA (u(i,4428),i=1,7)/20.,17., 1., 3., 1.36E-02,8.21693E+06,  2./
      DATA (u(i,4429),i=1,7)/20.,17., 1., 3., 1.10E-02,7.03235E+06,  2./
      DATA (u(i,4430),i=1,7)/20.,17., 1., 3., 9.73E-03,8.31947E+06,  2./
      DATA (u(i,4431),i=1,7)/20.,17., 1., 3., 6.93E-03,7.73994E+06,  2./
      DATA (u(i,4432),i=1,7)/20.,17., 1., 3., 6.55E-03,8.39631E+06,  2./
      DATA (u(i,4433),i=1,7)/20.,17., 1., 3., 2.37E-03,8.12348E+06,  2./
      DATA (u(i,4434),i=1,7)/20.,17., 1., 3., 1.51E-03,8.35422E+06,  2./
      DATA (u(i,4435),i=1,7)/20.,17., 1., 3., 3.77E-04,7.69231E+06,  2./
      DATA (u(i,4436),i=1,7)/20.,17., 1., 3., 1.98E-04,6.94927E+06,  2./
      DATA (u(i,4437),i=1,7)/20.,17., 1., 3., 1.01E-04,8.09717E+06,  2./
      DATA (u(i,4438),i=1,7)/20.,17., 1., 3., 3.18E-05,8.34028E+06,  2./
      DATA (u(i,4439),i=1,7)/20.,18., 2., 6., 1.86E-01,7.04225E+06, 18./
      DATA (u(i,4440),i=1,7)/20.,18., 2., 6., 7.73E-02,7.84929E+06, 18./
      DATA (u(i,4441),i=1,7)/20.,18., 2., 6., 4.02E-02,8.28500E+06, 18./
      DATA (u(i,4442),i=1,7)/20.,18., 2., 6., 2.38E-02,8.54701E+06, 18./
      DATA (u(i,4443),i=1,7)/20.,18., 2., 6., 1.53E-02,8.71840E+06, 18./
      DATA (u(i,4444),i=1,7)/20.,18., 2., 6., 1.05E-02,8.83392E+06, 18./
      DATA (u(i,4445),i=1,7)/20.,18., 2., 6., 7.50E-03,8.92061E+06, 18./
      DATA (u(i,4446),i=1,7)/20.,19., 1., 3.,-7.42E+07,3.11452E+07, 24./
      DATA (u(i,4447),i=1,7)/20.,19., 1., 3., 2.19E-02,3.13237E+07, 25./
      DATA (u(i,4448),i=1,7)/20.,19., 1., 3., 7.78E-01,3.14770E+07, 11./
      DATA (u(i,4449),i=1,7)/20.,19., 1., 3., 1.54E-01,3.67647E+07, 12./
      DATA (u(i,4450),i=1,7)/20.,19., 1., 3., 5.72E-02,3.87597E+07, 13./
      DATA (u(i,4451),i=1,7)/20.,19., 1., 3., 2.76E-02,3.95257E+07, 13./
      DATA (u(i,4452),i=1,7)/20.,19., 1., 3., 1.55E-02,4.00000E+07, 13./
      DATA (u(i,4453),i=1,7)/20.,19., 1., 3., 9.56E-03,4.03226E+07, 13./
      DATA (u(i,4454),i=1,7)/20.,19., 1., 3., 6.33E-03,4.04858E+07, 13./
      DATA (u(i,4455),i=1,7)/20.,19., 1., 3., 4.41E-03,4.06504E+07, 13./
      DATA (u(i,4456),i=1,7)/20.,19., 1., 3., 3.20E-03,4.08163E+07, 13./
      DATA (u(i,4457),i=1,7)/20.,20., 2., 2.,-1.32E+06,3.30717E+07, 23./
      DATA (u(i,4458),i=1,7)/20.,20., 2., 6., 8.32E-01,3.28947E+07,  4./
      DATA (u(i,4459),i=1,7)/20.,20., 2., 6., 1.58E-01,3.90625E+07,  5./
      DATA (u(i,4460),i=1,7)/20.,20., 2., 6., 5.80E-02,4.11523E+07,  6./
      DATA (u(i,4461),i=1,7)/20.,20., 2., 6., 2.79E-02,4.21941E+07,  7./
      DATA (u(i,4462),i=1,7)/20.,20., 2., 6., 1.56E-02,4.27350E+07,  8./
      DATA (u(i,4463),i=1,7)/20.,20., 2., 6., 9.63E-03,4.29185E+07,  9./
      DATA (u(i,4464),i=1,7)/20.,20., 2., 6., 6.37E-03,4.31034E+07,  9./
      DATA (u(i,4465),i=1,7)/20.,20., 2., 6., 4.43E-03,4.32900E+07,  9./
      DATA (u(i,4466),i=1,7)/20.,20., 2., 6., 3.21E-03,4.34783E+07,  9./
      DATA (u(i,4467),i=1,7)/26., 1.,25.,35., 1.80E+01,4.02414E+04,  1./
      DATA (u(i,4468),i=1,7)/26., 1.,25.,25., 8.00E+00,3.95684E+04,  1./
      DATA (u(i,4469),i=1,7)/26., 1.,25.,15., 3.70E+00,4.58505E+04,  1./
      DATA (u(i,4470),i=1,7)/26., 1.,25.,15., 3.00E+00,3.66227E+04,  1./
      DATA (u(i,4471),i=1,7)/26., 1.,25.,15., 1.03E+00,5.40249E+04,  1./
      DATA (u(i,4472),i=1,7)/26., 1.,25.,15., 1.00E+00,4.23549E+04,  1./
      DATA (u(i,4473),i=1,7)/26., 1.,25.,15., 8.75E-01,4.79846E+04,  1./
      DATA (u(i,4474),i=1,7)/26., 1.,25.,25., 8.00E-01,4.34972E+04,  1./
      DATA (u(i,4475),i=1,7)/26., 3.,25.,35., 3.11E+00,1.09757E+05,  2./
      DATA (u(i,4476),i=1,7)/26., 3.,25.,25., 1.97E+00,1.16330E+05,  2./
      DATA (u(i,4477),i=1,7)/26., 3.,25.,15., 1.61E+00,1.11498E+05,  2./
      DATA (u(i,4478),i=1,7)/26., 3.,25.,35., 1.52E+00,1.72586E+05,  2./
      DATA (u(i,4479),i=1,7)/26., 3.,25.,25., 1.11E+00,1.31123E+05,  2./
      DATA (u(i,4480),i=1,7)/26., 3.,25.,35., 8.70E-01,1.94833E+05,  2./
      DATA (u(i,4481),i=1,7)/26., 3.,25.,15., 7.78E-01,2.04901E+05,  2./
      DATA (u(i,4482),i=1,7)/26., 3.,25.,25., 7.30E-01,2.04754E+05,  2./
      DATA (u(i,4483),i=1,7)/26., 3.,25.,35., 6.34E-01,2.07740E+05,  2./
      DATA (u(i,4484),i=1,7)/26., 3.,25.,35., 5.97E-01,2.11291E+05,  2./
      DATA (u(i,4485),i=1,7)/26., 3.,25.,25., 5.60E-01,2.24326E+05,  2./
      DATA (u(i,4486),i=1,7)/26., 3.,25.,35., 4.34E-01,1.14755E+05,  2./
      DATA (u(i,4487),i=1,7)/26., 3.,25.,35., 4.14E-01,2.24255E+05,  2./
      DATA (u(i,4488),i=1,7)/26., 3.,25.,25., 4.13E-01,2.46311E+05,  2./
      DATA (u(i,4489),i=1,7)/26., 3.,25.,25., 3.64E-01,2.27035E+05,  2./
      DATA (u(i,4490),i=1,7)/26., 3.,25.,35., 3.61E-01,1.30139E+05,  2./
      DATA (u(i,4491),i=1,7)/26., 3.,25.,35., 3.48E-01,2.06894E+05,  2./
      DATA (u(i,4492),i=1,7)/26., 3.,25.,35., 3.42E-01,2.14202E+05,  2./
      DATA (u(i,4493),i=1,7)/26., 3.,25.,35., 3.19E-01,1.88331E+05,  2./
      DATA (u(i,4494),i=1,7)/26., 3.,25.,25., 2.95E-01,2.11256E+05,  2./
      DATA (u(i,4495),i=1,7)/26., 3.,25.,25., 2.70E-01,2.07702E+05,  2./
      DATA (u(i,4496),i=1,7)/26., 3.,25.,35., 2.67E-01,2.04625E+05,  2./
      DATA (u(i,4497),i=1,7)/26., 3.,25.,15., 2.54E-01,1.57406E+05,  2./
      DATA (u(i,4498),i=1,7)/26., 3.,25.,25., 2.42E-01,2.39131E+05,  2./
      DATA (u(i,4499),i=1,7)/26., 3.,25.,15., 2.04E-01,2.24266E+05,  2./
      DATA (u(i,4500),i=1,7)/26., 3.,25.,35., 1.87E-01,2.24507E+05,  2./
      DATA (u(i,4501),i=1,7)/26., 3.,25.,35., 1.83E-01,2.19293E+05,  2./
      DATA (u(i,4502),i=1,7)/26., 3.,25.,25., 1.62E-01,1.94617E+05,  2./
      DATA (u(i,4503),i=1,7)/26., 3.,25.,25., 1.62E-01,2.45640E+05,  2./
      DATA (u(i,4504),i=1,7)/26., 3.,25.,25., 1.58E-01,2.33530E+05,  2./
      DATA (u(i,4505),i=1,7)/26., 3.,25.,35., 1.46E-01,2.18919E+05,  2./
      DATA (u(i,4506),i=1,7)/26., 3.,25.,15., 1.44E-01,1.91091E+05,  2./
      DATA (u(i,4507),i=1,7)/26., 3.,25.,35., 1.40E-01,2.22183E+05,  2./
      DATA (u(i,4508),i=1,7)/26., 3.,25.,25., 1.17E-01,2.38453E+05,  2./
      DATA (u(i,4509),i=1,7)/26., 3.,25.,25., 1.11E-01,2.51181E+05,  2./
      DATA (u(i,4510),i=1,7)/26., 3.,25.,35., 1.11E-01,2.07284E+05,  2./
      DATA (u(i,4511),i=1,7)/26., 3.,25.,25., 7.72E-02,2.54434E+05,  2./
      DATA (u(i,4512),i=1,7)/26., 3.,25.,25., 6.55E-02,2.52992E+05,  2./
      DATA (u(i,4513),i=1,7)/26., 3.,25.,25., 6.14E-02,2.56759E+05,  2./
      DATA (u(i,4514),i=1,7)/26., 3.,25.,15., 5.39E-02,1.17363E+05,  2./
      DATA (u(i,4515),i=1,7)/26., 3.,25.,25., 5.29E-02,2.29933E+05,  2./
      DATA (u(i,4516),i=1,7)/26., 3.,25.,15., 4.86E-02,1.87484E+05,  2./
      DATA (u(i,4517),i=1,7)/26., 3.,25.,25., 4.63E-02,2.54013E+05,  2./
      DATA (u(i,4518),i=1,7)/26., 3.,25.,15., 3.80E-02,1.94632E+05,  2./
      DATA (u(i,4519),i=1,7)/26., 3.,25.,15., 3.36E-02,2.11743E+05,  2./
      DATA (u(i,4520),i=1,7)/26., 3.,25.,15., 3.23E-02,2.22178E+05,  2./
      DATA (u(i,4521),i=1,7)/26., 3.,25.,25., 3.03E-02,2.42096E+05,  2./
      DATA (u(i,4522),i=1,7)/26., 3.,25.,25., 2.83E-02,2.25698E+05,  2./
      DATA (u(i,4523),i=1,7)/26., 3.,25.,15., 2.73E-02,2.11211E+05,  2./
      DATA (u(i,4524),i=1,7)/26., 3.,25.,25., 2.23E-02,1.90709E+05,  2./
      DATA (u(i,4525),i=1,7)/26., 3.,25.,25., 1.89E-02,2.41371E+05,  2./
      DATA (u(i,4526),i=1,7)/26., 3.,25.,15., 1.73E-02,2.02885E+05,  2./
      DATA (u(i,4527),i=1,7)/26., 3.,25.,25., 1.72E-02,1.10445E+05,  2./
      DATA (u(i,4528),i=1,7)/26., 3.,25.,25., 1.64E-02,2.49426E+05,  2./
      DATA (u(i,4529),i=1,7)/26., 3.,25.,25., 1.38E-02,2.50350E+05,  2./
      DATA (u(i,4530),i=1,7)/26., 3.,25.,25., 1.33E-02,2.54188E+05,  2./
      DATA (u(i,4531),i=1,7)/26., 3.,25.,25., 1.32E-02,2.22020E+05,  2./
      DATA (u(i,4532),i=1,7)/26., 3.,25.,15., 1.28E-02,2.17306E+05,  2./
      DATA (u(i,4533),i=1,7)/26., 3.,25.,25., 5.48E-03,2.56023E+05,  2./
      DATA (u(i,4534),i=1,7)/26., 3.,25.,25., 5.29E-03,2.46773E+05,  2./
      DATA (u(i,4535),i=1,7)/26., 3.,25.,15., 4.90E-03,2.21043E+05,  2./
      DATA (u(i,4536),i=1,7)/26., 3.,25.,25., 3.92E-03,2.56253E+05,  2./
      DATA (u(i,4537),i=1,7)/26., 3.,25.,25., 3.69E-03,2.52442E+05,  2./
      DATA (u(i,4538),i=1,7)/26., 3.,25.,25., 3.30E-03,2.46506E+05,  2./
      DATA (u(i,4539),i=1,7)/26., 3.,25.,15., 2.47E-03,2.23684E+05,  2./
      DATA (u(i,4540),i=1,7)/26., 3.,25.,25., 1.36E-03,2.37716E+05,  2./
      DATA (u(i,4541),i=1,7)/26., 3.,25.,25., 1.25E-03,2.07568E+05,  2./
      DATA (u(i,4542),i=1,7)/26., 3.,25.,35., 7.89E-04,1.94243E+05,  2./
      DATA (u(i,4543),i=1,7)/26., 3.,25.,25., 1.86E-06,2.46524E+05,  2./
      DATA (u(i,4544),i=1,7)/26., 3.,25.,25., 5.49E-07,2.56792E+05,  2./
      DATA (u(i,4545),i=1,7)/26., 3.,25.,25., 1.80E-07,2.54472E+05,  2./
      DATA (u(i,4546),i=1,7)/26., 3.,25.,25., 5.96E-09,2.39240E+05,  2./
      DATA (u(i,4547),i=1,7)/26., 3.,25.,25., 2.01E-10,2.51237E+05,  2./
      DATA (u(i,4548),i=1,7)/26., 4., 6.,18., 2.53E+00,3.23426E+05,  2./
      DATA (u(i,4549),i=1,7)/26., 4., 6.,18., 2.44E+00,1.87635E+05,  2./
      DATA (u(i,4550),i=1,7)/26., 4., 6.,18., 1.44E+00,3.63465E+05,  2./
      DATA (u(i,4551),i=1,7)/26., 4., 6.,18., 8.52E-01,3.85208E+05,  2./
      DATA (u(i,4552),i=1,7)/26., 4., 6.,18., 5.40E-01,3.98295E+05,  2./
      DATA (u(i,4553),i=1,7)/26., 4., 6.,18., 3.63E-01,4.06769E+05,  2./
      DATA (u(i,4554),i=1,7)/26., 4., 6.,18., 2.97E-01,3.06636E+05,  2./
      DATA (u(i,4555),i=1,7)/26., 4., 6.,18., 2.55E-01,4.12592E+05,  2./
      DATA (u(i,4556),i=1,7)/26., 4., 6.,18., 1.86E-01,4.16736E+05,  2./
      DATA (u(i,4557),i=1,7)/26., 4., 6.,18., 1.09E-01,3.55619E+05,  2./
      DATA (u(i,4558),i=1,7)/26., 4., 6.,18., 5.42E-02,3.80880E+05,  2./
      DATA (u(i,4559),i=1,7)/26., 4., 6.,18., 3.13E-02,3.95664E+05,  2./
      DATA (u(i,4560),i=1,7)/26., 4., 6.,18., 1.99E-02,4.05055E+05,  2./
      DATA (u(i,4561),i=1,7)/26., 4., 6.,18., 1.34E-02,4.11404E+05,  2./
      DATA (u(i,4562),i=1,7)/26., 4., 6.,18., 9.54E-03,4.15887E+05,  2./
      DATA (u(i,4563),i=1,7)/26., 5.,25.,25., 4.67E+00,4.23352E+05,  2./
      DATA (u(i,4564),i=1,7)/26., 5.,25.,35., 4.50E+00,4.23191E+05,  2./
      DATA (u(i,4565),i=1,7)/26., 5.,25.,25., 4.27E+00,2.55487E+05,  2./
      DATA (u(i,4566),i=1,7)/26., 5.,25.,35., 4.03E+00,4.39020E+05,  2./
      DATA (u(i,4567),i=1,7)/26., 5.,25.,35., 2.25E+00,4.85555E+05,  2./
      DATA (u(i,4568),i=1,7)/26., 5.,25.,35., 2.16E+00,5.02311E+05,  2./
      DATA (u(i,4569),i=1,7)/26., 5.,25.,35., 2.01E+00,2.56720E+05,  2./
      DATA (u(i,4570),i=1,7)/26., 5.,25.,15., 1.90E+00,2.70446E+05,  2./
      DATA (u(i,4571),i=1,7)/26., 5.,25.,25., 1.90E+00,4.85932E+05,  2./
      DATA (u(i,4572),i=1,7)/26., 5.,25.,15., 1.63E+00,4.22155E+05,  2./
      DATA (u(i,4573),i=1,7)/26., 5.,25.,25., 1.44E+00,5.19588E+05,  2./
      DATA (u(i,4574),i=1,7)/26., 5.,25.,35., 1.38E+00,5.19400E+05,  2./
      DATA (u(i,4575),i=1,7)/26., 5.,25.,35., 1.08E+00,5.36798E+05,  2./
      DATA (u(i,4576),i=1,7)/26., 5.,25.,35., 9.84E-01,5.39957E+05,  2./
      DATA (u(i,4577),i=1,7)/26., 5.,25.,25., 9.12E-01,5.40073E+05,  2./
      DATA (u(i,4578),i=1,7)/26., 5.,25.,15., 8.60E-01,4.84801E+05,  2./
      DATA (u(i,4579),i=1,7)/26., 5.,25.,35., 7.70E-01,5.57600E+05,  2./
      DATA (u(i,4580),i=1,7)/26., 5.,25.,25., 5.88E-01,4.84660E+05,  2./
      DATA (u(i,4581),i=1,7)/26., 5.,25.,25., 5.80E-01,5.53373E+05,  2./
      DATA (u(i,4582),i=1,7)/26., 5.,25.,35., 5.16E-01,5.53250E+05,  2./
      DATA (u(i,4583),i=1,7)/26., 5.,25.,15., 4.85E-01,5.19103E+05,  2./
      DATA (u(i,4584),i=1,7)/26., 5.,25.,25., 4.52E-01,4.41151E+05,  2./
      DATA (u(i,4585),i=1,7)/26., 5.,25.,25., 4.24E-01,4.13702E+05,  2./
      DATA (u(i,4586),i=1,7)/26., 5.,25.,25., 4.13E-01,5.62461E+05,  2./
      DATA (u(i,4587),i=1,7)/26., 5.,25.,35., 4.08E-01,5.62398E+05,  2./
      DATA (u(i,4588),i=1,7)/26., 5.,25.,15., 2.92E-01,5.39753E+05,  2./
      DATA (u(i,4589),i=1,7)/26., 5.,25.,25., 2.89E-01,5.68990E+05,  2./
      DATA (u(i,4590),i=1,7)/26., 5.,25.,15., 2.85E-01,4.30608E+05,  2./
      DATA (u(i,4591),i=1,7)/26., 5.,25.,35., 2.79E-01,4.14130E+05,  2./
      DATA (u(i,4592),i=1,7)/26., 5.,25.,35., 2.47E-01,5.68925E+05,  2./
      DATA (u(i,4593),i=1,7)/26., 5.,25.,25., 2.06E-01,5.03550E+05,  2./
      DATA (u(i,4594),i=1,7)/26., 5.,25.,15., 2.01E-01,5.53128E+05,  2./
      DATA (u(i,4595),i=1,7)/26., 5.,25.,35., 1.95E-01,4.81649E+05,  2./
      DATA (u(i,4596),i=1,7)/26., 5.,25.,25., 1.40E-01,4.81765E+05,  2./
      DATA (u(i,4597),i=1,7)/26., 5.,25.,15., 1.36E-01,5.62303E+05,  2./
      DATA (u(i,4598),i=1,7)/26., 5.,25.,25., 1.15E-01,4.31574E+05,  2./
      DATA (u(i,4599),i=1,7)/26., 5.,25.,25., 1.15E-01,5.37230E+05,  2./
      DATA (u(i,4600),i=1,7)/26., 5.,25.,15., 1.11E-01,4.99276E+05,  2./
      DATA (u(i,4601),i=1,7)/26., 5.,25.,25., 1.09E-01,2.73336E+05,  2./
      DATA (u(i,4602),i=1,7)/26., 5.,25.,15., 1.02E-01,5.68861E+05,  2./
      DATA (u(i,4603),i=1,7)/26., 5.,25.,25., 8.45E-02,5.57849E+05,  2./
      DATA (u(i,4604),i=1,7)/26., 5.,25.,15., 6.56E-02,5.35389E+05,  2./
      DATA (u(i,4605),i=1,7)/26., 5.,25.,35., 6.54E-02,5.17706E+05,  2./
      DATA (u(i,4606),i=1,7)/26., 5.,25.,25., 6.23E-02,5.17625E+05,  2./
      DATA (u(i,4607),i=1,7)/26., 5.,25.,25., 5.36E-02,4.99625E+05,  2./
      DATA (u(i,4608),i=1,7)/26., 5.,25.,35., 4.12E-02,5.38996E+05,  2./
      DATA (u(i,4609),i=1,7)/26., 5.,25.,25., 3.60E-02,5.38967E+05,  2./
      DATA (u(i,4610),i=1,7)/26., 5.,25.,25., 3.31E-02,5.01555E+05,  2./
      DATA (u(i,4611),i=1,7)/26., 5.,25.,15., 3.14E-02,5.56824E+05,  2./
      DATA (u(i,4612),i=1,7)/26., 5.,25.,35., 2.62E-02,5.52669E+05,  2./
      DATA (u(i,4613),i=1,7)/26., 5.,25.,25., 2.47E-02,5.35533E+05,  2./
      DATA (u(i,4614),i=1,7)/26., 5.,25.,25., 2.15E-02,5.56917E+05,  2./
      DATA (u(i,4615),i=1,7)/26., 5.,25.,25., 2.09E-02,5.52639E+05,  2./
      DATA (u(i,4616),i=1,7)/26., 5.,25.,35., 1.84E-02,5.62019E+05,  2./
      DATA (u(i,4617),i=1,7)/26., 5.,25.,25., 1.38E-02,5.61987E+05,  2./
      DATA (u(i,4618),i=1,7)/26., 5.,25.,35., 1.32E-02,5.68666E+05,  2./
      DATA (u(i,4619),i=1,7)/26., 5.,25.,25., 9.45E-03,5.68634E+05,  2./
      DATA (u(i,4620),i=1,7)/26., 5.,25.,35., 8.01E-03,4.82044E+05,  2./
      DATA (u(i,4621),i=1,7)/26., 5.,25.,15., 6.83E-04,5.06073E+05,  2./
      DATA (u(i,4622),i=1,7)/26., 6.,28.,28., 1.59E+01,5.73033E+05,  3./
      DATA (u(i,4623),i=1,7)/26., 6.,28.,20., 1.47E+01,6.37674E+05,107./
      DATA (u(i,4624),i=1,7)/26., 6.,28.,36., 1.02E+01,5.54816E+05,  2./
      DATA (u(i,4625),i=1,7)/26., 6.,28.,36., 9.35E+00,5.40103E+05,  2./
      DATA (u(i,4626),i=1,7)/26., 6.,28.,28., 6.37E+00,6.27825E+05,  2./
      DATA (u(i,4627),i=1,7)/26., 6.,28.,36., 5.44E+00,6.26174E+05,  2./
      DATA (u(i,4628),i=1,7)/26., 6.,28.,28., 3.92E+00,3.38375E+05,  2./
      DATA (u(i,4629),i=1,7)/26., 6.,28.,20., 3.37E+00,6.50618E+05,  2./
      DATA (u(i,4630),i=1,7)/26., 6.,28.,36., 3.08E+00,6.75128E+05,  2./
      DATA (u(i,4631),i=1,7)/26., 6.,28.,28., 2.94E+00,6.75539E+05,  2./
      DATA (u(i,4632),i=1,7)/26., 6.,28.,36., 2.81E+00,6.43542E+05,  2./
      DATA (u(i,4633),i=1,7)/26., 6.,28.,20., 2.57E+00,3.41518E+05,  2./
      DATA (u(i,4634),i=1,7)/26., 6.,28.,20., 2.48E+00,6.47375E+05,  2./
      DATA (u(i,4635),i=1,7)/26., 6.,28.,28., 2.06E+00,5.39811E+05,  2./
      DATA (u(i,4636),i=1,7)/26., 6.,28.,36., 1.97E+00,7.04722E+05,  2./
      DATA (u(i,4637),i=1,7)/26., 6.,28.,36., 1.90E+00,7.24113E+05,  2./
      DATA (u(i,4638),i=1,7)/26., 6.,28.,20., 1.87E+00,6.75219E+05,  2./
      DATA (u(i,4639),i=1,7)/26., 6.,28.,28., 1.65E+00,7.04871E+05,  2./
      DATA (u(i,4640),i=1,7)/26., 6.,28.,20., 1.61E+00,6.22007E+05,  2./
      DATA (u(i,4641),i=1,7)/26., 6.,28.,36., 1.24E+00,6.93241E+05,  2./
      DATA (u(i,4642),i=1,7)/26., 6.,28.,20., 1.08E+00,6.30001E+05,  2./
      DATA (u(i,4643),i=1,7)/26., 6.,28.,20., 1.06E+00,5.66348E+05,  2./
      DATA (u(i,4644),i=1,7)/26., 6.,28.,36., 1.06E+00,5.05178E+05,  3./
      DATA (u(i,4645),i=1,7)/26., 6.,28.,28., 1.03E+00,7.24008E+05,  2./
      DATA (u(i,4646),i=1,7)/26., 6.,28.,20., 9.77E-01,5.40365E+05,  2./
      DATA (u(i,4647),i=1,7)/26., 6.,28.,20., 8.48E-01,3.58141E+05,133./
      DATA (u(i,4648),i=1,7)/26., 6.,28.,36., 7.95E-01,7.37083E+05,  2./
      DATA (u(i,4649),i=1,7)/26., 6.,28.,28., 6.96E-01,7.37137E+05,  2./
      DATA (u(i,4650),i=1,7)/26., 6.,28.,20., 6.70E-01,7.04622E+05,  2./
      DATA (u(i,4651),i=1,7)/26., 6.,28.,36., 6.50E-01,7.46491E+05,  2./
      DATA (u(i,4652),i=1,7)/26., 6.,28.,36., 5.59E-01,3.37621E+05,  2./
      DATA (u(i,4653),i=1,7)/26., 6.,28.,28., 5.34E-01,5.28849E+05,  2./
      DATA (u(i,4654),i=1,7)/26., 6.,28.,28., 4.93E-01,7.46547E+05,  2./
      DATA (u(i,4655),i=1,7)/26., 6.,28.,20., 4.72E-01,5.59284E+05,  2./
      DATA (u(i,4656),i=1,7)/26., 6.,28.,36., 4.72E-01,7.42832E+05,  2./
      DATA (u(i,4657),i=1,7)/26., 6.,28.,20., 4.12E-01,7.23380E+05,  2./
      DATA (u(i,4658),i=1,7)/26., 6.,28.,20., 3.07E-01,6.42137E+05,  2./
      DATA (u(i,4659),i=1,7)/26., 6.,28.,36., 2.97E-01,4.53042E+05,  3./
      DATA (u(i,4660),i=1,7)/26., 6.,28.,28., 2.73E-01,6.29882E+05,  2./
      DATA (u(i,4661),i=1,7)/26., 6.,28.,28., 2.60E-01,6.43170E+05,  2./
      DATA (u(i,4662),i=1,7)/26., 6.,28.,20., 2.51E-01,7.36974E+05,  2./
      DATA (u(i,4663),i=1,7)/26., 6.,28.,20., 2.45E-01,5.32566E+05,  2./
      DATA (u(i,4664),i=1,7)/26., 6.,28.,20., 2.05E-01,6.94541E+05,  2./
      DATA (u(i,4665),i=1,7)/26., 6.,28.,28., 1.56E-01,5.36653E+05,  3./
      DATA (u(i,4666),i=1,7)/26., 6.,28.,36., 1.56E-01,4.64209E+05,  3./
      DATA (u(i,4667),i=1,7)/26., 6.,28.,20., 1.55E-01,7.46436E+05,  2./
      DATA (u(i,4668),i=1,7)/26., 6.,28.,28., 1.52E-01,6.93481E+05,  2./
      DATA (u(i,4669),i=1,7)/26., 6.,28.,28., 1.31E-01,4.96229E+05,  3./
      DATA (u(i,4670),i=1,7)/26., 6.,28.,28., 1.07E-01,6.44704E+05,  2./
      DATA (u(i,4671),i=1,7)/26., 6.,28.,28., 9.42E-02,4.59242E+05,  3./
      DATA (u(i,4672),i=1,7)/26., 6.,28.,36., 9.23E-02,6.29446E+05,  2./
      DATA (u(i,4673),i=1,7)/26., 6.,28.,28., 8.48E-02,7.23484E+05,  2./
      DATA (u(i,4674),i=1,7)/26., 6.,28.,36., 8.10E-02,7.23118E+05,  2./
      DATA (u(i,4675),i=1,7)/26., 6.,28.,36., 6.26E-02,5.39869E+05,  2./
      DATA (u(i,4676),i=1,7)/26., 6.,28.,28., 5.46E-02,7.42942E+05,  2./
      DATA (u(i,4677),i=1,7)/26., 6.,28.,20., 5.22E-02,5.20888E+05,  3./
      DATA (u(i,4678),i=1,7)/26., 6.,28.,20., 3.61E-02,7.24480E+05,  2./
      DATA (u(i,4679),i=1,7)/26., 6.,28.,20., 3.36E-02,7.43273E+05,  2./
      DATA (u(i,4680),i=1,7)/26., 6.,28.,20., 3.24E-02,5.45792E+05,  3./
      DATA (u(i,4681),i=1,7)/26., 6.,28.,36., 3.23E-02,6.77690E+05,  2./
      DATA (u(i,4682),i=1,7)/26., 6.,28.,20., 1.78E-02,4.64770E+05,  3./
      DATA (u(i,4683),i=1,7)/26., 6.,28.,36., 1.57E-02,5.22930E+05,  3./
      DATA (u(i,4684),i=1,7)/26., 6.,28.,20., 1.48E-02,4.85979E+05,  3./
      DATA (u(i,4685),i=1,7)/26., 6.,28.,36., 1.29E-02,7.06564E+05,  2./
      DATA (u(i,4686),i=1,7)/26., 6.,28.,36., 8.25E-03,7.38062E+05,  2./
      DATA (u(i,4687),i=1,7)/26., 6.,28.,28., 6.67E-03,7.25321E+05,  2./
      DATA (u(i,4688),i=1,7)/26., 6.,28.,20., 6.23E-03,6.78196E+05,  2./
      DATA (u(i,4689),i=1,7)/26., 6.,28.,28., 5.77E-03,7.06614E+05,  2./
      DATA (u(i,4690),i=1,7)/26., 6.,28.,20., 5.75E-03,4.33107E+05,  3./
      DATA (u(i,4691),i=1,7)/26., 6.,28.,28., 4.81E-03,7.38116E+05,  2./
      DATA (u(i,4692),i=1,7)/26., 6.,28.,28., 4.61E-03,4.43066E+05,  3./
      DATA (u(i,4693),i=1,7)/26., 6.,28.,20., 2.53E-03,7.44768E+05,  2./
      DATA (u(i,4694),i=1,7)/26., 6.,28.,20., 2.21E-03,7.38171E+05,  2./
      DATA (u(i,4695),i=1,7)/26., 6.,28.,20., 1.91E-03,7.25426E+05,  2./
      DATA (u(i,4696),i=1,7)/26., 6.,28.,28., 1.46E-03,6.77782E+05,  2./
      DATA (u(i,4697),i=1,7)/26., 6.,28.,20., 1.12E-03,7.06864E+05,  2./
      DATA (u(i,4698),i=1,7)/26., 6.,28.,28., 1.04E-03,6.76911E+05,  2./
      DATA (u(i,4699),i=1,7)/26., 6.,28.,20., 8.00E-04,6.76682E+05,  2./
      DATA (u(i,4700),i=1,7)/26., 6.,28.,20., 7.06E-04,6.97301E+05,  2./
      DATA (u(i,4701),i=1,7)/26., 6.,28.,36., 4.50E-04,7.25321E+05,  2./
      DATA (u(i,4702),i=1,7)/26., 6.,28.,36., 2.28E-04,6.96136E+05,  2./
      DATA (u(i,4703),i=1,7)/26., 6.,28.,36., 1.52E-04,7.25268E+05,  2./
      DATA (u(i,4704),i=1,7)/26., 6.,28.,36., 9.28E-05,6.76865E+05,  2./
      DATA (u(i,4705),i=1,7)/26., 6.,28.,36., 7.84E-05,7.37681E+05,  2./
      DATA (u(i,4706),i=1,7)/26., 6.,28.,36., 7.79E-05,7.05916E+05,  2./
      DATA (u(i,4707),i=1,7)/26., 6.,28.,28., 4.20E-05,5.53863E+05,  2./
      DATA (u(i,4708),i=1,7)/26., 6.,28.,36., 3.56E-05,7.44214E+05,  2./
      DATA (u(i,4709),i=1,7)/26., 6.,28.,20., 2.42E-05,7.26164E+05,  2./
      DATA (u(i,4710),i=1,7)/26., 6.,28.,28., 1.14E-05,7.24795E+05,  2./
      DATA (u(i,4711),i=1,7)/26., 6.,28.,20., 7.46E-06,7.37681E+05,  2./
      DATA (u(i,4712),i=1,7)/26., 6.,28.,20., 5.40E-06,7.05866E+05,  2./
      DATA (u(i,4713),i=1,7)/26., 6.,28.,20., 2.05E-06,7.24743E+05,  2./
      DATA (u(i,4714),i=1,7)/26., 6.,28.,28., 6.47E-07,7.05916E+05,  2./
      DATA (u(i,4715),i=1,7)/26., 6.,28.,28., 4.25E-07,7.37735E+05,  2./
      DATA (u(i,4716),i=1,7)/26., 6.,28.,36., 1.21E-09,7.24743E+05,  2./
      DATA (u(i,4717),i=1,7)/26., 7.,21.,15., 1.86E+01,6.56211E+05,108./
      DATA (u(i,4718),i=1,7)/26., 7.,21.,21., 1.50E+01,6.11733E+05,113./
      DATA (u(i,4719),i=1,7)/26., 7.,21.,27., 1.41E+01,6.74627E+05,106./
      DATA (u(i,4720),i=1,7)/26., 7.,21.,21., 9.90E+00,6.72676E+05,  2./
      DATA (u(i,4721),i=1,7)/26., 7.,21.,27., 6.13E+00,5.50661E+05,  3./
      DATA (u(i,4722),i=1,7)/26., 7.,21.,27., 5.76E+00,7.97639E+05,  2./
      DATA (u(i,4723),i=1,7)/26., 7.,21.,27., 2.95E+00,8.65351E+05,  2./
      DATA (u(i,4724),i=1,7)/26., 7.,21.,21., 2.60E+00,7.95102E+05,  2./
      DATA (u(i,4725),i=1,7)/26., 7.,21.,15., 2.55E+00,4.38847E+05,  2./
      DATA (u(i,4726),i=1,7)/26., 7.,21.,27., 2.54E+00,8.04182E+05,  2./
      DATA (u(i,4727),i=1,7)/26., 7.,21.,27., 2.29E+00,5.09398E+05,  3./
      DATA (u(i,4728),i=1,7)/26., 7.,21.,15., 2.12E+00,5.91786E+05,  3./
      DATA (u(i,4729),i=1,7)/26., 7.,21.,27., 1.72E+00,9.06208E+05,  2./
      DATA (u(i,4730),i=1,7)/26., 7.,21.,21., 1.59E+00,8.19269E+05,  2./
      DATA (u(i,4731),i=1,7)/26., 7.,21.,21., 1.38E+00,4.41813E+05,  2./
      DATA (u(i,4732),i=1,7)/26., 7.,21.,21., 1.13E+00,8.63782E+05,  2./
      DATA (u(i,4733),i=1,7)/26., 7.,21.,27., 1.12E+00,9.32662E+05,  2./
      DATA (u(i,4734),i=1,7)/26., 7.,21.,27., 9.29E-01,8.33959E+05,  2./
      DATA (u(i,4735),i=1,7)/26., 7.,21.,27., 7.74E-01,9.50751E+05,  2./
      DATA (u(i,4736),i=1,7)/26., 7.,21.,21., 6.51E-01,9.05141E+05,  2./
      DATA (u(i,4737),i=1,7)/26., 7.,21.,21., 5.85E-01,9.31793E+05,  2./
      DATA (u(i,4738),i=1,7)/26., 7.,21.,27., 5.65E-01,9.63670E+05,  2./
      DATA (u(i,4739),i=1,7)/26., 7.,21.,15., 5.53E-01,7.82105E+05,  2./
      DATA (u(i,4740),i=1,7)/26., 7.,21.,21., 2.59E-01,9.50299E+05,  2./
      DATA (u(i,4741),i=1,7)/26., 7.,21.,27., 2.24E-01,4.58421E+05,  3./
      DATA (u(i,4742),i=1,7)/26., 7.,21.,21., 1.89E-01,9.63298E+05,  2./
      DATA (u(i,4743),i=1,7)/26., 7.,21.,15., 1.60E-01,8.53388E+05,  2./
      DATA (u(i,4744),i=1,7)/26., 7.,21.,15., 1.52E-01,8.13206E+05,  2./
      DATA (u(i,4745),i=1,7)/26., 7.,21.,15., 1.39E-01,7.98467E+05,  2./
      DATA (u(i,4746),i=1,7)/26., 7.,21.,21., 1.27E-01,5.07743E+05,  3./
      DATA (u(i,4747),i=1,7)/26., 7.,21.,15., 1.13E-01,8.67303E+05,  2./
      DATA (u(i,4748),i=1,7)/26., 7.,21.,21., 6.95E-02,9.33010E+05,  2./
      DATA (u(i,4749),i=1,7)/26., 7.,21.,15., 6.09E-02,4.58526E+05,  3./
      DATA (u(i,4750),i=1,7)/26., 7.,21.,21., 6.00E-02,5.49149E+05,  3./
      DATA (u(i,4751),i=1,7)/26., 7.,21.,15., 4.76E-02,8.74585E+05,  2./
      DATA (u(i,4752),i=1,7)/26., 7.,21.,15., 4.65E-02,9.06372E+05,  2./
      DATA (u(i,4753),i=1,7)/26., 7.,21.,21., 3.38E-02,8.11886E+05,  2./
      DATA (u(i,4754),i=1,7)/26., 7.,21.,15., 3.12E-02,4.81116E+05,  3./
      DATA (u(i,4755),i=1,7)/26., 7.,21.,21., 3.04E-02,8.34585E+05,  2./
      DATA (u(i,4756),i=1,7)/26., 7.,21.,15., 2.99E-02,9.32749E+05,  2./
      DATA (u(i,4757),i=1,7)/26., 7.,21.,15., 2.97E-02,6.78564E+05,  2./
      DATA (u(i,4758),i=1,7)/26., 7.,21.,15., 2.94E-02,5.78737E+05,  3./
      DATA (u(i,4759),i=1,7)/26., 7.,21.,15., 2.72E-02,9.12326E+05,  2./
      DATA (u(i,4760),i=1,7)/26., 7.,21.,21., 2.60E-02,8.74814E+05,  2./
      DATA (u(i,4761),i=1,7)/26., 7.,21.,21., 2.37E-02,9.38086E+05,  2./
      DATA (u(i,4762),i=1,7)/26., 7.,21.,21., 2.32E-02,9.12326E+05,  2./
      DATA (u(i,4763),i=1,7)/26., 7.,21.,15., 2.08E-02,9.50842E+05,  2./
      DATA (u(i,4764),i=1,7)/26., 7.,21.,15., 1.81E-02,9.36856E+05,  2./
      DATA (u(i,4765),i=1,7)/26., 7.,21.,21., 1.64E-02,6.99007E+05,  2./
      DATA (u(i,4766),i=1,7)/26., 7.,21.,27., 1.53E-02,4.92126E+05,  3./
      DATA (u(i,4767),i=1,7)/26., 7.,21.,15., 1.52E-02,9.63762E+05,  2./
      DATA (u(i,4768),i=1,7)/26., 7.,21.,15., 1.30E-02,9.53743E+05,  2./
      DATA (u(i,4769),i=1,7)/26., 7.,21.,21., 1.17E-02,4.54194E+05,  3./
      DATA (u(i,4770),i=1,7)/26., 7.,21.,15., 1.11E-02,8.12150E+05,  2./
      DATA (u(i,4771),i=1,7)/26., 7.,21.,27., 9.66E-03,8.72676E+05,  2./
      DATA (u(i,4772),i=1,7)/26., 7.,21.,21., 8.66E-03,8.14531E+05,  2./
      DATA (u(i,4773),i=1,7)/26., 7.,21.,15., 7.88E-03,6.97934E+05,  2./
      DATA (u(i,4774),i=1,7)/26., 7.,21.,15., 7.77E-03,8.64902E+05,  2./
      DATA (u(i,4775),i=1,7)/26., 7.,21.,21., 3.86E-03,4.80607E+05,  3./
      DATA (u(i,4776),i=1,7)/26., 7.,21.,15., 3.69E-03,5.01580E+05,  3./
      DATA (u(i,4777),i=1,7)/26., 7.,21.,21., 2.11E-04,9.54107E+05,  2./
      DATA (u(i,4778),i=1,7)/26., 8.,10.,10., 1.31E+01,6.22007E+05,109./
      DATA (u(i,4779),i=1,7)/26., 8.,10.,14., 7.44E+00,5.65387E+05,116./
      DATA (u(i,4780),i=1,7)/26., 8.,10.,14., 6.01E+00,8.06972E+05,  2./
      DATA (u(i,4781),i=1,7)/26., 8.,10., 6., 6.00E+00,6.23597E+05,110./
      DATA (u(i,4782),i=1,7)/26., 8.,10.,14., 2.07E+00,9.69932E+05,  2./
      DATA (u(i,4783),i=1,7)/26., 8.,10., 6., 1.58E+00,5.59190E+05,  2./
      DATA (u(i,4784),i=1,7)/26., 8.,10.,14., 1.19E+00,9.13576E+05,  2./
      DATA (u(i,4785),i=1,7)/26., 8.,10.,14., 1.10E+00,1.05910E+06,  2./
      DATA (u(i,4786),i=1,7)/26., 8.,10.,10., 9.87E-01,9.42596E+05,  2./
      DATA (u(i,4787),i=1,7)/26., 8.,10.,14., 7.60E-01,1.11284E+06,  2./
      DATA (u(i,4788),i=1,7)/26., 8.,10.,14., 5.83E-01,9.43129E+05,  2./
      DATA (u(i,4789),i=1,7)/26., 8.,10.,10., 5.79E-01,1.16009E+06,  2./
      DATA (u(i,4790),i=1,7)/26., 8.,10.,14., 5.38E-01,1.13469E+06,  2./
      DATA (u(i,4791),i=1,7)/26., 8.,10., 6., 4.54E-01,8.97102E+05,  2./
      DATA (u(i,4792),i=1,7)/26., 8.,10.,14., 3.76E-01,1.17151E+06,  2./
      DATA (u(i,4793),i=1,7)/26., 8.,10.,14., 3.55E-01,1.14797E+06,  2./
      DATA (u(i,4794),i=1,7)/26., 8.,10., 6., 3.53E-01,1.14286E+06,  2./
      DATA (u(i,4795),i=1,7)/26., 8.,10.,14., 3.34E-01,4.70146E+05,  3./
      DATA (u(i,4796),i=1,7)/26., 8.,10.,10., 2.81E-01,1.13675E+06,  2./
      DATA (u(i,4797),i=1,7)/26., 8.,10.,14., 2.46E-01,1.15996E+06,  2./
      DATA (u(i,4798),i=1,7)/26., 8.,10.,14., 2.33E-01,1.15594E+06,  2./
      DATA (u(i,4799),i=1,7)/26., 8.,10.,14., 1.56E-01,1.12145E+06,  2./
      DATA (u(i,4800),i=1,7)/26., 8.,10.,14., 1.45E-01,4.56788E+05,  3./
      DATA (u(i,4801),i=1,7)/26., 8.,10.,10., 1.38E-01,1.11000E+06,  2./
      DATA (u(i,4802),i=1,7)/26., 8.,10.,14., 1.32E-01,1.18878E+06,  2./
      DATA (u(i,4803),i=1,7)/26., 8.,10.,14., 1.25E-01,1.17330E+06,  2./
      DATA (u(i,4804),i=1,7)/26., 8.,10., 6., 1.18E-01,1.16768E+06,  2./
      DATA (u(i,4805),i=1,7)/26., 8.,10., 6., 1.17E-01,1.16023E+06,  2./
      DATA (u(i,4806),i=1,7)/26., 8.,10., 6., 1.06E-01,1.06259E+06,  2./
      DATA (u(i,4807),i=1,7)/26., 8.,10., 6., 4.71E-02,5.36308E+05,  3./
      DATA (u(i,4808),i=1,7)/26., 8.,10., 6., 4.14E-02,4.65008E+05,  3./
      DATA (u(i,4809),i=1,7)/26., 8.,10., 6., 4.08E-02,1.00070E+06,  2./
      DATA (u(i,4810),i=1,7)/26., 8.,10., 6., 3.49E-02,8.60659E+05,  2./
      DATA (u(i,4811),i=1,7)/26., 8.,10.,10., 2.57E-02,1.15473E+06,  2./
      DATA (u(i,4812),i=1,7)/26., 8.,10., 6., 2.07E-02,1.18850E+06,  2./
      DATA (u(i,4813),i=1,7)/26., 8.,10.,10., 1.35E-02,9.34318E+05,  2./
      DATA (u(i,4814),i=1,7)/26., 8.,10., 6., 1.31E-02,1.15660E+06,  2./
      DATA (u(i,4815),i=1,7)/26., 8.,10., 6., 8.49E-03,1.11632E+06,  2./
      DATA (u(i,4816),i=1,7)/26., 8.,10.,10., 7.48E-03,5.08311E+05,  3./
      DATA (u(i,4817),i=1,7)/26., 8.,10., 6., 4.49E-03,1.17786E+06,  2./
      DATA (u(i,4818),i=1,7)/26., 8.,10.,10., 4.04E-03,4.51365E+05,  3./
      DATA (u(i,4819),i=1,7)/26., 8.,10.,10., 3.16E-03,1.18050E+06,  2./
      DATA (u(i,4820),i=1,7)/26., 8.,10., 6., 9.07E-05,1.12562E+06,  2./
      DATA (u(i,4821),i=1,7)/26., 8.,10., 6., 5.16E-05,1.07980E+06,  2./
      DATA (u(i,4822),i=1,7)/26., 9., 1., 3., 3.08E+00,5.89310E+05,111./
      DATA (u(i,4823),i=1,7)/26., 9., 1., 3., 5.45E-01,1.20569E+06,  2./
      DATA (u(i,4824),i=1,7)/26., 9., 1., 3., 3.17E-01,9.70685E+05,  2./
      DATA (u(i,4825),i=1,7)/26., 9., 1., 3., 2.40E-01,1.47080E+06,  2./
      DATA (u(i,4826),i=1,7)/26., 9., 1., 3., 8.33E-02,1.37495E+06,  3./
      DATA (u(i,4827),i=1,7)/26., 9., 1., 3., 7.16E-02,1.60077E+06,  2./
      DATA (u(i,4828),i=1,7)/26., 9., 1., 3., 7.10E-02,1.60901E+06,  2./
      DATA (u(i,4829),i=1,7)/26., 9., 1., 3., 6.43E-02,1.69233E+06,  2./
      DATA (u(i,4830),i=1,7)/26., 9., 1., 3., 6.22E-02,1.34246E+06,  2./
      DATA (u(i,4831),i=1,7)/26., 9., 1., 3., 5.58E-02,1.69837E+06,  2./
      DATA (u(i,4832),i=1,7)/26., 9., 1., 3., 5.38E-02,1.73974E+06,  2./
      DATA (u(i,4833),i=1,7)/26., 9., 1., 3., 4.16E-02,1.48280E+06,  2./
      DATA (u(i,4834),i=1,7)/26., 9., 1., 3., 3.77E-02,1.36874E+06,  2./
      DATA (u(i,4835),i=1,7)/26., 9., 1., 3., 3.66E-02,1.77274E+06,  2./
      DATA (u(i,4836),i=1,7)/26., 9., 1., 3., 3.37E-02,1.55424E+06,  2./
      DATA (u(i,4837),i=1,7)/26., 9., 1., 3., 2.65E-02,1.79662E+06,  2./
      DATA (u(i,4838),i=1,7)/26., 9., 1., 3., 2.37E-02,1.34662E+06,  3./
      DATA (u(i,4839),i=1,7)/26., 9., 1., 3., 1.27E-02,1.65728E+06,  2./
      DATA (u(i,4840),i=1,7)/26., 9., 1., 3., 1.01E-02,1.71821E+06,  2./
      DATA (u(i,4841),i=1,7)/26., 9., 1., 3., 6.85E-03,1.61812E+06,  3./
      DATA (u(i,4842),i=1,7)/26., 9., 1., 3., 6.56E-03,1.75840E+06,  2./
      DATA (u(i,4843),i=1,7)/26., 9., 1., 3., 5.04E-03,1.64853E+06,  2./
      DATA (u(i,4844),i=1,7)/26., 9., 1., 3., 4.63E-03,1.78603E+06,  2./
      DATA (u(i,4845),i=1,7)/26., 9., 1., 3., 3.45E-03,1.58831E+06,  2./
      DATA (u(i,4846),i=1,7)/26., 9., 1., 3., 1.69E-03,1.66945E+06,  2./
      DATA (u(i,4847),i=1,7)/26., 9., 1., 3., 1.45E-03,1.26088E+06,  3./
      DATA (u(i,4848),i=1,7)/26., 9., 1., 3., 1.05E-03,1.62655E+06,  3./
      DATA (u(i,4849),i=1,7)/26., 9., 1., 3., 5.99E-04,1.74856E+06,  2./
      DATA (u(i,4850),i=1,7)/26., 9., 1., 3., 5.58E-04,1.76835E+06,  2./
      DATA (u(i,4851),i=1,7)/26., 9., 1., 3., 4.76E-04,1.53822E+06,  3./
      DATA (u(i,4852),i=1,7)/26., 9., 1., 3., 4.09E-04,1.44446E+06,  3./
      DATA (u(i,4853),i=1,7)/26., 9., 1., 3., 2.53E-04,1.53398E+06,  3./
      DATA (u(i,4854),i=1,7)/26., 9., 1., 3., 1.89E-04,1.44739E+06,  3./
      DATA (u(i,4855),i=1,7)/26., 9., 1., 3., 1.38E-04,1.78063E+06,  3./
      DATA (u(i,4856),i=1,7)/26., 9., 1., 3., 5.20E-05,1.57208E+06,  3./
      DATA (u(i,4857),i=1,7)/26., 9., 1., 3., 5.80E-07,1.50421E+06,  2./
      DATA (u(i,4858),i=1,7)/26., 9., 1., 3., 5.87E-10,1.78635E+06,  2./
      DATA (u(i,4859),i=1,7)/26.,10., 6.,10., 8.67E+00,5.82174E+05,112./
      DATA (u(i,4860),i=1,7)/26.,10., 6., 6., 4.56E+00,5.73888E+05,114./
      DATA (u(i,4861),i=1,7)/26.,10., 6., 2., 1.74E+00,5.41272E+05,117./
      DATA (u(i,4862),i=1,7)/26.,10., 6.,10., 1.12E+00,1.29116E+06,  2./
      DATA (u(i,4863),i=1,7)/26.,10., 6., 6., 9.12E-01,1.05020E+06,  2./
      DATA (u(i,4864),i=1,7)/26.,10., 6., 6., 7.94E-01,1.31718E+06,  2./
      DATA (u(i,4865),i=1,7)/26.,10., 6.,10., 7.90E-01,1.32328E+06,  2./
      DATA (u(i,4866),i=1,7)/26.,10., 6.,10., 7.17E-01,1.60823E+06,  2./
      DATA (u(i,4867),i=1,7)/26.,10., 6.,10., 5.30E-01,1.07032E+06,  2./
      DATA (u(i,4868),i=1,7)/26.,10., 6.,10., 3.93E-01,1.77022E+06,  2./
      DATA (u(i,4869),i=1,7)/26.,10., 6.,10., 3.90E-01,1.43184E+06,  2./
      DATA (u(i,4870),i=1,7)/26.,10., 6., 6., 2.70E-01,1.63747E+06,  2./
      DATA (u(i,4871),i=1,7)/26.,10., 6., 2., 2.58E-01,1.31062E+06,  2./
      DATA (u(i,4872),i=1,7)/26.,10., 6., 6., 2.58E-01,1.43472E+06,  2./
      DATA (u(i,4873),i=1,7)/26.,10., 6.,10., 2.37E-01,1.64042E+06,  2./
      DATA (u(i,4874),i=1,7)/26.,10., 6.,10., 2.28E-01,1.86498E+06,  2./
      DATA (u(i,4875),i=1,7)/26.,10., 6., 6., 2.00E-01,1.61160E+06,  2./
      DATA (u(i,4876),i=1,7)/26.,10., 6.,10., 1.66E-01,1.82448E+06,  2./
      DATA (u(i,4877),i=1,7)/26.,10., 6., 6., 1.45E-01,1.82648E+06,  2./
      DATA (u(i,4878),i=1,7)/26.,10., 6., 6., 1.41E-01,1.29786E+06,  2./
      DATA (u(i,4879),i=1,7)/26.,10., 6., 6., 1.41E-01,1.50807E+06,  2./
      DATA (u(i,4880),i=1,7)/26.,10., 6.,10., 1.41E-01,1.92456E+06,  2./
      DATA (u(i,4881),i=1,7)/26.,10., 6., 2., 1.38E-01,1.11297E+06,  2./
      DATA (u(i,4882),i=1,7)/26.,10., 6., 6., 1.35E-01,1.49678E+06,  2./
      DATA (u(i,4883),i=1,7)/26.,10., 6.,10., 1.35E-01,1.28766E+06,  3./
      DATA (u(i,4884),i=1,7)/26.,10., 6., 6., 1.18E-01,1.77179E+06,  2./
      DATA (u(i,4885),i=1,7)/26.,10., 6., 6., 1.11E-01,1.80018E+06,  2./
      DATA (u(i,4886),i=1,7)/26.,10., 6., 2., 1.02E-01,1.63506E+06,  2./
      DATA (u(i,4887),i=1,7)/26.,10., 6.,10., 1.02E-01,1.52695E+06,  2./
      DATA (u(i,4888),i=1,7)/26.,10., 6.,10., 1.02E-01,1.96502E+06,  2./
      DATA (u(i,4889),i=1,7)/26.,10., 6., 6., 1.01E-01,1.71116E+06,  2./
      DATA (u(i,4890),i=1,7)/26.,10., 6.,10., 1.01E-01,1.49656E+06,  2./
      DATA (u(i,4891),i=1,7)/26.,10., 6.,10., 9.66E-02,1.80213E+06,  2./
      DATA (u(i,4892),i=1,7)/26.,10., 6.,10., 8.88E-02,1.89322E+06,  2./
      DATA (u(i,4893),i=1,7)/26.,10., 6., 6., 8.44E-02,1.89358E+06,  2./
      DATA (u(i,4894),i=1,7)/26.,10., 6.,10., 8.34E-02,1.68237E+06,  2./
      DATA (u(i,4895),i=1,7)/26.,10., 6.,10., 8.28E-02,1.36687E+06,  2./
      DATA (u(i,4896),i=1,7)/26.,10., 6., 2., 6.83E-02,1.44781E+06,  2./
      DATA (u(i,4897),i=1,7)/26.,10., 6.,10., 6.76E-02,1.84468E+06,  2./
      DATA (u(i,4898),i=1,7)/26.,10., 6.,10., 6.62E-02,1.99362E+06,  2./
      DATA (u(i,4899),i=1,7)/26.,10., 6., 6., 6.42E-02,1.86567E+06,  2./
      DATA (u(i,4900),i=1,7)/26.,10., 6.,10., 5.61E-02,1.42735E+06,  3./
      DATA (u(i,4901),i=1,7)/26.,10., 6., 2., 5.20E-02,1.79986E+06,  2./
      DATA (u(i,4902),i=1,7)/26.,10., 6., 6., 4.89E-02,1.92530E+06,  2./
      DATA (u(i,4903),i=1,7)/26.,10., 6., 6., 4.56E-02,1.95618E+06,  2./
      DATA (u(i,4904),i=1,7)/26.,10., 6.,10., 3.85E-02,1.74095E+06,  2./
      DATA (u(i,4905),i=1,7)/26.,10., 6.,10., 3.82E-02,1.99680E+06,  2./
      DATA (u(i,4906),i=1,7)/26.,10., 6., 2., 3.70E-02,1.83318E+06,  2./
      DATA (u(i,4907),i=1,7)/26.,10., 6., 2., 3.69E-02,1.56937E+06,  2./
      DATA (u(i,4908),i=1,7)/26.,10., 6., 6., 3.52E-02,1.90186E+06,  2./
      DATA (u(i,4909),i=1,7)/26.,10., 6., 6., 3.47E-02,1.96541E+06,  2./
      DATA (u(i,4910),i=1,7)/26.,10., 6., 2., 3.39E-02,1.89107E+06,  2./
      DATA (u(i,4911),i=1,7)/26.,10., 6., 6., 3.30E-02,1.99680E+06,  2./
      DATA (u(i,4912),i=1,7)/26.,10., 6.,10., 2.87E-02,1.95695E+06,  2./
      DATA (u(i,4913),i=1,7)/26.,10., 6.,10., 2.78E-02,1.93949E+06,  2./
      DATA (u(i,4914),i=1,7)/26.,10., 6., 2., 2.76E-02,1.42816E+06,  3./
      DATA (u(i,4915),i=1,7)/26.,10., 6.,10., 2.41E-02,1.93311E+06,  2./
      DATA (u(i,4916),i=1,7)/26.,10., 6., 6., 2.32E-02,1.82916E+06,  2./
      DATA (u(i,4917),i=1,7)/26.,10., 6., 2., 2.14E-02,1.95542E+06,  2./
      DATA (u(i,4918),i=1,7)/26.,10., 6., 6., 1.97E-02,1.30685E+06,  3./
      DATA (u(i,4919),i=1,7)/26.,10., 6., 2., 1.94E-02,1.78348E+06,  2./
      DATA (u(i,4920),i=1,7)/26.,10., 6., 6., 1.92E-02,4.22922E+05,  3./
      DATA (u(i,4921),i=1,7)/26.,10., 6., 6., 1.86E-02,1.99402E+06,  2./
      DATA (u(i,4922),i=1,7)/26.,10., 6., 6., 1.56E-02,1.94932E+06,  2./
      DATA (u(i,4923),i=1,7)/26.,10., 6., 2., 1.50E-02,2.02388E+06,  2./
      DATA (u(i,4924),i=1,7)/26.,10., 6., 2., 1.45E-02,1.99641E+06,  2./
      DATA (u(i,4925),i=1,7)/26.,10., 6., 6., 1.31E-02,1.98216E+06,  2./
      DATA (u(i,4926),i=1,7)/26.,10., 6., 2., 1.24E-02,2.02143E+06,  2./
      DATA (u(i,4927),i=1,7)/26.,10., 6.,10., 1.22E-02,4.36338E+05,  3./
      DATA (u(i,4928),i=1,7)/26.,10., 6.,10., 1.02E-02,1.98098E+06,  2./
      DATA (u(i,4929),i=1,7)/26.,10., 6.,10., 9.71E-03,1.31492E+06,  3./
      DATA (u(i,4930),i=1,7)/26.,10., 6., 6., 9.62E-03,1.90078E+06,  2./
      DATA (u(i,4931),i=1,7)/26.,10., 6.,10., 9.08E-03,1.85977E+06,  2./
      DATA (u(i,4932),i=1,7)/26.,10., 6.,10., 9.02E-03,1.75562E+06,  2./
      DATA (u(i,4933),i=1,7)/26.,10., 6.,10., 8.72E-03,1.99960E+06,  2./
      DATA (u(i,4934),i=1,7)/26.,10., 6., 2., 7.37E-03,1.89825E+06,  2./
      DATA (u(i,4935),i=1,7)/26.,10., 6., 6., 7.22E-03,1.50195E+06,  3./
      DATA (u(i,4936),i=1,7)/26.,10., 6.,10., 5.36E-03,1.89897E+06,  2./
      DATA (u(i,4937),i=1,7)/26.,10., 6., 6., 4.94E-03,1.44030E+06,  3./
      DATA (u(i,4938),i=1,7)/26.,10., 6.,10., 4.72E-03,1.61316E+06,  3./
      DATA (u(i,4939),i=1,7)/26.,10., 6.,10., 4.62E-03,1.24301E+06,  3./
      DATA (u(i,4940),i=1,7)/26.,10., 6.,10., 4.12E-03,1.46542E+06,  3./
      DATA (u(i,4941),i=1,7)/26.,10., 6., 6., 4.08E-03,1.51837E+06,  3./
      DATA (u(i,4942),i=1,7)/26.,10., 6.,10., 3.86E-03,1.30822E+06,  3./
      DATA (u(i,4943),i=1,7)/26.,10., 6.,10., 3.59E-03,1.28090E+06,  3./
      DATA (u(i,4944),i=1,7)/26.,10., 6., 6., 3.18E-03,1.33601E+06,  3./
      DATA (u(i,4945),i=1,7)/26.,10., 6.,10., 3.10E-03,5.11954E+05,  3./
      DATA (u(i,4946),i=1,7)/26.,10., 6., 2., 2.80E-03,1.47885E+06,  3./
      DATA (u(i,4947),i=1,7)/26.,10., 6.,10., 2.64E-03,1.53022E+06,  3./
      DATA (u(i,4948),i=1,7)/26.,10., 6., 2., 2.46E-03,1.97589E+06,  2./
      DATA (u(i,4949),i=1,7)/26.,10., 6., 2., 2.45E-03,2.02552E+06,  2./
      DATA (u(i,4950),i=1,7)/26.,10., 6.,10., 2.36E-03,1.40312E+06,  3./
      DATA (u(i,4951),i=1,7)/26.,10., 6., 6., 2.20E-03,1.34680E+06,  3./
      DATA (u(i,4952),i=1,7)/26.,10., 6., 6., 2.18E-03,1.42207E+06,  3./
      DATA (u(i,4953),i=1,7)/26.,10., 6., 2., 1.92E-03,1.35851E+06,  3./
      DATA (u(i,4954),i=1,7)/26.,10., 6., 6., 1.87E-03,1.70358E+06,  3./
      DATA (u(i,4955),i=1,7)/26.,10., 6., 2., 1.52E-03,1.70184E+06,  3./
      DATA (u(i,4956),i=1,7)/26.,10., 6., 6., 1.36E-03,1.24938E+06,  3./
      DATA (u(i,4957),i=1,7)/26.,10., 6., 2., 1.24E-03,1.90367E+06,  2./
      DATA (u(i,4958),i=1,7)/26.,10., 6.,10., 1.23E-03,1.71733E+06,  3./
      DATA (u(i,4959),i=1,7)/26.,10., 6.,10., 1.16E-03,1.69607E+06,  2./
      DATA (u(i,4960),i=1,7)/26.,10., 6.,10., 9.52E-04,1.47995E+06,  3./
      DATA (u(i,4961),i=1,7)/26.,10., 6., 6., 8.61E-04,1.59388E+06,  3./
      DATA (u(i,4962),i=1,7)/26.,10., 6.,10., 6.18E-04,1.63399E+06,  3./
      DATA (u(i,4963),i=1,7)/26.,10., 6.,10., 5.79E-04,1.58579E+06,  3./
      DATA (u(i,4964),i=1,7)/26.,10., 6.,10., 5.69E-04,1.56177E+06,  3./
      DATA (u(i,4965),i=1,7)/26.,10., 6.,10., 5.09E-04,1.53492E+06,  3./
      DATA (u(i,4966),i=1,7)/26.,10., 6.,10., 5.07E-04,1.94553E+06,  2./
      DATA (u(i,4967),i=1,7)/26.,10., 6., 2., 4.87E-04,1.57456E+06,  3./
      DATA (u(i,4968),i=1,7)/26.,10., 6.,10., 4.61E-04,1.03125E+06,  3./
      DATA (u(i,4969),i=1,7)/26.,10., 6., 6., 4.42E-04,1.20178E+06,  3./
      DATA (u(i,4970),i=1,7)/26.,10., 6., 2., 3.86E-04,1.32205E+06,  3./
      DATA (u(i,4971),i=1,7)/26.,10., 6., 6., 2.91E-04,1.31458E+06,  3./
      DATA (u(i,4972),i=1,7)/26.,10., 6., 2., 2.89E-04,1.51263E+06,  2./
      DATA (u(i,4973),i=1,7)/26.,10., 6., 6., 2.79E-04,1.17261E+06,  3./
      DATA (u(i,4974),i=1,7)/26.,10., 6.,10., 2.52E-04,1.40786E+06,  3./
      DATA (u(i,4975),i=1,7)/26.,10., 6.,10., 2.41E-04,1.37495E+06,  3./
      DATA (u(i,4976),i=1,7)/26.,10., 6., 2., 2.03E-04,1.97355E+06,  3./
      DATA (u(i,4977),i=1,7)/26.,10., 6.,10., 1.69E-04,1.83621E+06,  2./
      DATA (u(i,4978),i=1,7)/26.,10., 6.,10., 1.12E-04,1.14299E+06,  3./
      DATA (u(i,4979),i=1,7)/26.,10., 6.,10., 8.93E-05,1.69808E+06,  2./
      DATA (u(i,4980),i=1,7)/26.,10., 6.,10., 8.72E-05,1.91718E+06,  2./
      DATA (u(i,4981),i=1,7)/26.,10., 6.,10., 5.64E-05,1.51791E+06,  3./
      DATA (u(i,4982),i=1,7)/26.,10., 6.,10., 4.95E-05,1.97006E+06,  2./
      DATA (u(i,4983),i=1,7)/26.,10., 6., 6., 3.16E-05,1.45773E+06,  3./
      DATA (u(i,4984),i=1,7)/26.,10., 6.,10., 2.79E-05,1.95656E+06,  3./
      DATA (u(i,4985),i=1,7)/26.,10., 6., 6., 2.51E-05,1.55280E+06,  3./
      DATA (u(i,4986),i=1,7)/26.,10., 6., 2., 2.23E-05,1.53374E+06,  3./
      DATA (u(i,4987),i=1,7)/26.,10., 6.,10., 1.86E-05,1.25786E+06,  3./
      DATA (u(i,4988),i=1,7)/26.,10., 6., 6., 1.76E-05,1.38485E+06,  3./
      DATA (u(i,4989),i=1,7)/26.,10., 6., 6., 1.67E-05,1.96271E+06,  3./
      DATA (u(i,4990),i=1,7)/26.,10., 6.,10., 1.67E-05,1.49992E+06,  3./
      DATA (u(i,4991),i=1,7)/26.,10., 6., 6., 1.44E-05,1.58128E+06,  3./
      DATA (u(i,4992),i=1,7)/26.,10., 6., 2., 1.42E-05,1.14943E+06,  3./
      DATA (u(i,4993),i=1,7)/26.,10., 6.,10., 1.38E-05,1.99084E+06,  3./
      DATA (u(i,4994),i=1,7)/26.,10., 6.,10., 4.03E-06,1.34916E+06,  3./
      DATA (u(i,4995),i=1,7)/26.,10., 6.,10., 2.71E-07,1.19760E+06,  3./
      DATA (u(i,4996),i=1,7)/26.,11., 9.,15., 1.01E+01,5.60287E+05,115./
      DATA (u(i,4997),i=1,7)/26.,11., 9., 9., 5.88E+00,5.31406E+05,118./
      DATA (u(i,4998),i=1,7)/26.,11., 9.,15., 1.57E+00,1.41064E+06,  2./
      DATA (u(i,4999),i=1,7)/26.,11., 9., 3., 1.55E+00,5.36222E+05,  3./
      DATA (u(i,5000),i=1,7)/26.,11., 9., 9., 1.32E+00,1.41223E+06,  2./
      DATA (u(i,5001),i=1,7)/26.,11., 9.,15., 1.20E+00,1.37495E+06,  2./
      DATA (u(i,5002),i=1,7)/26.,11., 9.,15., 9.57E-01,1.50875E+06,  2./
      DATA (u(i,5003),i=1,7)/26.,11., 9.,15., 8.30E-01,1.15300E+06,  2./
      DATA (u(i,5004),i=1,7)/26.,11., 9.,15., 7.40E-01,1.74277E+06,  2./
      DATA (u(i,5005),i=1,7)/26.,11., 9., 3., 6.14E-01,1.12676E+06,  2./
      DATA (u(i,5006),i=1,7)/26.,11., 9., 9., 5.90E-01,1.18694E+06,  2./
      DATA (u(i,5007),i=1,7)/26.,11., 9.,15., 5.04E-01,1.45054E+06,  2./
      DATA (u(i,5008),i=1,7)/26.,11., 9., 9., 4.75E-01,1.78476E+06,  2./
      DATA (u(i,5009),i=1,7)/26.,11., 9.,15., 4.44E-01,1.93237E+06,  2./
      DATA (u(i,5010),i=1,7)/26.,11., 9.,15., 4.34E-01,1.78380E+06,  2./
      DATA (u(i,5011),i=1,7)/26.,11., 9., 3., 3.87E-01,1.41683E+06,  2./
      DATA (u(i,5012),i=1,7)/26.,11., 9., 9., 3.72E-01,1.50921E+06,  2./
      DATA (u(i,5013),i=1,7)/26.,11., 9.,15., 2.64E-01,1.81752E+06,  2./
      DATA (u(i,5014),i=1,7)/26.,11., 9.,15., 2.33E-01,1.97472E+06,  2./
      DATA (u(i,5015),i=1,7)/26.,11., 9., 9., 2.30E-01,4.83512E+05,  3./
      DATA (u(i,5016),i=1,7)/26.,11., 9., 9., 2.14E-01,1.97589E+06,  2./
      DATA (u(i,5017),i=1,7)/26.,11., 9., 9., 2.04E-01,1.95771E+06,  2./
      DATA (u(i,5018),i=1,7)/26.,11., 9.,15., 2.02E-01,1.95351E+06,  2./
      DATA (u(i,5019),i=1,7)/26.,11., 9.,15., 1.95E-01,2.00884E+06,  2./
      DATA (u(i,5020),i=1,7)/26.,11., 9., 3., 1.85E-01,1.62999E+06,  2./
      DATA (u(i,5021),i=1,7)/26.,11., 9., 3., 1.81E-01,1.51676E+06,  2./
      DATA (u(i,5022),i=1,7)/26.,11., 9., 3., 1.81E-01,1.78603E+06,  2./
      DATA (u(i,5023),i=1,7)/26.,11., 9.,15., 1.72E-01,1.66639E+06,  2./
      DATA (u(i,5024),i=1,7)/26.,11., 9.,15., 1.62E-01,2.04374E+06,  2./
      DATA (u(i,5025),i=1,7)/26.,11., 9.,15., 1.55E-01,1.60927E+06,  2./
      DATA (u(i,5026),i=1,7)/26.,11., 9., 9., 1.48E-01,1.70010E+06,  2./
      DATA (u(i,5027),i=1,7)/26.,11., 9.,15., 1.41E-01,2.11506E+06,  2./
      DATA (u(i,5028),i=1,7)/26.,11., 9.,15., 1.30E-01,2.12134E+06,  2./
      DATA (u(i,5029),i=1,7)/26.,11., 9., 9., 1.25E-01,1.56863E+06,  2./
      DATA (u(i,5030),i=1,7)/26.,11., 9.,15., 1.25E-01,2.17486E+06,  2./
      DATA (u(i,5031),i=1,7)/26.,11., 9.,15., 1.21E-01,2.16310E+06,  2./
      DATA (u(i,5032),i=1,7)/26.,11., 9., 3., 1.12E-01,1.97668E+06,  2./
      DATA (u(i,5033),i=1,7)/26.,11., 9.,15., 9.24E-02,2.04876E+06,  2./
      DATA (u(i,5034),i=1,7)/26.,11., 9., 9., 8.70E-02,2.17723E+06,  2./
      DATA (u(i,5035),i=1,7)/26.,11., 9.,15., 8.59E-02,2.08768E+06,  2./
      DATA (u(i,5036),i=1,7)/26.,11., 9.,15., 8.45E-02,1.82249E+06,  2./
      DATA (u(i,5037),i=1,7)/26.,11., 9., 9., 8.35E-02,2.15889E+06,  2./
      DATA (u(i,5038),i=1,7)/26.,11., 9., 9., 8.05E-02,2.08855E+06,  2./
      DATA (u(i,5039),i=1,7)/26.,11., 9.,15., 7.30E-02,2.06101E+06,  2./
      DATA (u(i,5040),i=1,7)/26.,11., 9., 9., 7.08E-02,1.81884E+06,  2./
      DATA (u(i,5041),i=1,7)/26.,11., 9., 3., 6.95E-02,1.86986E+06,  2./
      DATA (u(i,5042),i=1,7)/26.,11., 9.,15., 6.75E-02,2.19684E+06,  2./
      DATA (u(i,5043),i=1,7)/26.,11., 9., 9., 6.61E-02,2.00844E+06,  2./
      DATA (u(i,5044),i=1,7)/26.,11., 9.,15., 6.50E-02,2.19298E+06,  2./
      DATA (u(i,5045),i=1,7)/26.,11., 9., 9., 5.28E-02,2.08290E+06,  2./
      DATA (u(i,5046),i=1,7)/26.,11., 9., 9., 5.28E-02,2.20702E+06,  2./
      DATA (u(i,5047),i=1,7)/26.,11., 9., 9., 5.28E-02,2.24014E+06,  2./
      DATA (u(i,5048),i=1,7)/26.,11., 9., 9., 5.08E-02,1.60565E+06,  2./
      DATA (u(i,5049),i=1,7)/26.,11., 9., 9., 4.92E-02,2.05761E+06,  2./
      DATA (u(i,5050),i=1,7)/26.,11., 9.,15., 4.90E-02,1.91095E+06,  2./
      DATA (u(i,5051),i=1,7)/26.,11., 9., 3., 4.65E-02,2.09074E+06,  2./
      DATA (u(i,5052),i=1,7)/26.,11., 9.,15., 4.09E-02,2.15843E+06,  2./
      DATA (u(i,5053),i=1,7)/26.,11., 9., 9., 3.93E-02,1.94477E+06,  2./
      DATA (u(i,5054),i=1,7)/26.,11., 9., 9., 3.93E-02,2.12134E+06,  2./
      DATA (u(i,5055),i=1,7)/26.,11., 9., 9., 3.71E-02,1.44865E+06,  2./
      DATA (u(i,5056),i=1,7)/26.,11., 9., 3., 3.55E-02,2.00602E+06,  2./
      DATA (u(i,5057),i=1,7)/26.,11., 9., 3., 3.48E-02,1.95695E+06,  2./
      DATA (u(i,5058),i=1,7)/26.,11., 9.,15., 3.40E-02,2.18914E+06,  2./
      DATA (u(i,5059),i=1,7)/26.,11., 9., 3., 3.19E-02,2.15889E+06,  2./
      DATA (u(i,5060),i=1,7)/26.,11., 9., 3., 3.13E-02,2.17628E+06,  2./
      DATA (u(i,5061),i=1,7)/26.,11., 9.,15., 3.12E-02,4.87710E+05,  3./
      DATA (u(i,5062),i=1,7)/26.,11., 9., 9., 2.98E-02,2.19250E+06,  2./
      DATA (u(i,5063),i=1,7)/26.,11., 9.,15., 2.69E-02,1.77651E+06,  2./
      DATA (u(i,5064),i=1,7)/26.,11., 9., 3., 2.41E-02,2.08768E+06,  2./
      DATA (u(i,5065),i=1,7)/26.,11., 9., 3., 1.53E-02,2.06313E+06,  2./
      DATA (u(i,5066),i=1,7)/26.,11., 9.,15., 1.52E-02,2.13356E+06,  2./
      DATA (u(i,5067),i=1,7)/26.,11., 9., 9., 1.51E-02,1.38889E+06,  3./
      DATA (u(i,5068),i=1,7)/26.,11., 9.,15., 1.42E-02,2.01207E+06,  2./
      DATA (u(i,5069),i=1,7)/26.,11., 9., 3., 1.16E-02,2.14592E+06,  2./
      DATA (u(i,5070),i=1,7)/26.,11., 9.,15., 1.09E-02,2.01532E+06,  2./
      DATA (u(i,5071),i=1,7)/26.,11., 9., 9., 9.45E-03,1.39295E+06,  3./
      DATA (u(i,5072),i=1,7)/26.,11., 9., 9., 8.88E-03,1.42005E+06,  3./
      DATA (u(i,5073),i=1,7)/26.,11., 9., 9., 8.70E-03,1.81127E+06,  2./
      DATA (u(i,5074),i=1,7)/26.,11., 9., 9., 8.40E-03,2.22370E+06,  2./
      DATA (u(i,5075),i=1,7)/26.,11., 9.,15., 8.39E-03,1.87512E+06,  2./
      DATA (u(i,5076),i=1,7)/26.,11., 9.,15., 8.27E-03,1.41403E+06,  3./
      DATA (u(i,5077),i=1,7)/26.,11., 9.,15., 7.71E-03,1.23900E+06,  3./
      DATA (u(i,5078),i=1,7)/26.,11., 9., 3., 6.84E-03,2.18484E+06,  2./
      DATA (u(i,5079),i=1,7)/26.,11., 9., 9., 6.06E-03,1.51469E+06,  3./
      DATA (u(i,5080),i=1,7)/26.,11., 9., 9., 5.43E-03,1.19133E+06,  3./
      DATA (u(i,5081),i=1,7)/26.,11., 9.,15., 5.16E-03,1.49611E+06,  3./
      DATA (u(i,5082),i=1,7)/26.,11., 9., 3., 5.00E-03,1.50466E+06,  3./
      DATA (u(i,5083),i=1,7)/26.,11., 9.,15., 4.97E-03,1.33779E+06,  3./
      DATA (u(i,5084),i=1,7)/26.,11., 9.,15., 4.44E-03,2.18007E+06,  2./
      DATA (u(i,5085),i=1,7)/26.,11., 9., 9., 4.35E-03,2.24115E+06,  2./
      DATA (u(i,5086),i=1,7)/26.,11., 9.,15., 4.07E-03,1.22699E+06,  3./
      DATA (u(i,5087),i=1,7)/26.,11., 9.,15., 3.66E-03,1.30310E+06,  3./
      DATA (u(i,5088),i=1,7)/26.,11., 9., 9., 3.18E-03,1.25486E+06,  3./
      DATA (u(i,5089),i=1,7)/26.,11., 9., 9., 3.17E-03,1.13973E+06,  3./
      DATA (u(i,5090),i=1,7)/26.,11., 9., 9., 3.15E-03,2.16779E+06,  2./
      DATA (u(i,5091),i=1,7)/26.,11., 9.,15., 2.12E-03,1.25676E+06,  3./
      DATA (u(i,5092),i=1,7)/26.,11., 9.,15., 1.91E-03,1.61420E+06,  3./
      DATA (u(i,5093),i=1,7)/26.,11., 9.,15., 1.76E-03,1.27210E+06,  3./
      DATA (u(i,5094),i=1,7)/26.,11., 9., 9., 1.72E-03,1.32626E+06,  3./
      DATA (u(i,5095),i=1,7)/26.,11., 9.,15., 1.70E-03,1.28916E+06,  3./
      DATA (u(i,5096),i=1,7)/26.,11., 9.,15., 1.63E-03,1.39140E+06,  3./
      DATA (u(i,5097),i=1,7)/26.,11., 9., 9., 1.57E-03,1.60231E+06,  3./
      DATA (u(i,5098),i=1,7)/26.,11., 9.,15., 1.36E-03,2.10970E+06,  2./
      DATA (u(i,5099),i=1,7)/26.,11., 9.,15., 1.32E-03,1.18022E+06,  3./
      DATA (u(i,5100),i=1,7)/26.,11., 9., 9., 1.26E-03,1.31735E+06,  3./
      DATA (u(i,5101),i=1,7)/26.,11., 9., 3., 1.25E-03,2.01167E+06,  3./
      DATA (u(i,5102),i=1,7)/26.,11., 9., 3., 1.15E-03,1.32979E+06,  3./
      DATA (u(i,5103),i=1,7)/26.,11., 9., 9., 1.11E-03,1.61447E+06,  2./
      DATA (u(i,5104),i=1,7)/26.,11., 9., 3., 1.01E-03,1.25329E+06,  3./
      DATA (u(i,5105),i=1,7)/26.,11., 9., 9., 9.50E-04,2.01167E+06,  2./
      DATA (u(i,5106),i=1,7)/26.,11., 9.,15., 7.77E-04,2.07727E+06,  2./
      DATA (u(i,5107),i=1,7)/26.,11., 9.,15., 7.44E-04,1.21595E+06,  3./
      DATA (u(i,5108),i=1,7)/26.,11., 9.,15., 7.29E-04,1.05130E+06,  3./
      DATA (u(i,5109),i=1,7)/26.,11., 9.,15., 7.00E-04,2.17297E+06,  2./
      DATA (u(i,5110),i=1,7)/26.,11., 9.,15., 5.60E-04,2.12495E+06,  3./
      DATA (u(i,5111),i=1,7)/26.,11., 9., 9., 5.03E-04,1.44217E+06,  3./
      DATA (u(i,5112),i=1,7)/26.,11., 9., 9., 4.35E-04,2.03459E+06,  3./
      DATA (u(i,5113),i=1,7)/26.,11., 9., 9., 4.08E-04,1.95656E+06,  3./
      DATA (u(i,5114),i=1,7)/26.,11., 9.,15., 4.04E-04,2.17960E+06,  3./
      DATA (u(i,5115),i=1,7)/26.,11., 9., 3., 3.80E-04,1.17911E+06,  3./
      DATA (u(i,5116),i=1,7)/26.,11., 9.,15., 3.74E-04,2.10571E+06,  3./
      DATA (u(i,5117),i=1,7)/26.,11., 9.,15., 3.21E-04,2.02184E+06,  3./
      DATA (u(i,5118),i=1,7)/26.,11., 9., 9., 2.97E-04,9.93641E+05,  3./
      DATA (u(i,5119),i=1,7)/26.,11., 9., 9., 2.96E-04,2.06398E+06,  3./
      DATA (u(i,5120),i=1,7)/26.,11., 9.,15., 2.88E-04,2.06654E+06,  3./
      DATA (u(i,5121),i=1,7)/26.,11., 9., 9., 2.72E-04,2.23414E+06,  2./
      DATA (u(i,5122),i=1,7)/26.,11., 9., 9., 2.49E-04,1.89394E+06,  3./
      DATA (u(i,5123),i=1,7)/26.,11., 9.,15., 2.29E-04,2.01329E+06,  3./
      DATA (u(i,5124),i=1,7)/26.,11., 9., 9., 2.23E-04,2.06441E+06,  2./
      DATA (u(i,5125),i=1,7)/26.,11., 9.,15., 2.00E-04,1.93536E+06,  3./
      DATA (u(i,5126),i=1,7)/26.,11., 9., 3., 1.86E-04,1.58907E+06,  3./
      DATA (u(i,5127),i=1,7)/26.,11., 9.,15., 1.83E-04,1.11062E+06,  3./
      DATA (u(i,5128),i=1,7)/26.,11., 9.,15., 1.66E-04,1.46135E+06,  3./
      DATA (u(i,5129),i=1,7)/26.,11., 9., 3., 1.43E-04,1.61420E+06,  2./
      DATA (u(i,5130),i=1,7)/26.,11., 9., 9., 1.40E-04,1.47798E+06,  3./
      DATA (u(i,5131),i=1,7)/26.,11., 9., 9., 1.34E-04,1.21124E+06,  3./
      DATA (u(i,5132),i=1,7)/26.,11., 9., 9., 1.09E-04,1.90730E+06,  3./
      DATA (u(i,5133),i=1,7)/26.,11., 9.,15., 1.08E-04,1.54583E+06,  3./
      DATA (u(i,5134),i=1,7)/26.,11., 9., 9., 9.93E-05,2.13402E+06,  3./
      DATA (u(i,5135),i=1,7)/26.,11., 9.,15., 9.67E-05,1.98452E+06,  3./
      DATA (u(i,5136),i=1,7)/26.,11., 9., 9., 8.94E-05,2.20361E+06,  3./
      DATA (u(i,5137),i=1,7)/26.,11., 9., 9., 8.36E-05,2.12630E+06,  2./
      DATA (u(i,5138),i=1,7)/26.,11., 9., 3., 8.32E-05,2.07857E+06,  3./
      DATA (u(i,5139),i=1,7)/26.,11., 9.,15., 6.67E-05,4.08347E+05,  3./
      DATA (u(i,5140),i=1,7)/26.,11., 9., 9., 6.23E-05,2.10393E+06,  3./
      DATA (u(i,5141),i=1,7)/26.,11., 9., 9., 5.94E-05,2.00040E+06,  3./
      DATA (u(i,5142),i=1,7)/26.,11., 9.,15., 4.87E-05,2.04248E+06,  3./
      DATA (u(i,5143),i=1,7)/26.,11., 9.,15., 4.68E-05,1.98255E+06,  3./
      DATA (u(i,5144),i=1,7)/26.,11., 9.,15., 2.78E-05,1.40017E+06,  3./
      DATA (u(i,5145),i=1,7)/26.,11., 9., 9., 2.68E-05,1.30022E+06,  3./
      DATA (u(i,5146),i=1,7)/26.,11., 9.,15., 2.65E-05,2.12993E+06,  2./
      DATA (u(i,5147),i=1,7)/26.,11., 9.,15., 2.41E-05,1.34409E+06,  3./
      DATA (u(i,5148),i=1,7)/26.,11., 9.,15., 1.80E-05,2.09161E+06,  3./
      DATA (u(i,5149),i=1,7)/26.,11., 9., 9., 1.35E-05,1.26342E+06,  3./
      DATA (u(i,5150),i=1,7)/26.,11., 9., 3., 1.97E-06,1.42288E+06,  3./
      DATA (u(i,5151),i=1,7)/26.,11., 9., 3., 1.74E-06,2.11327E+06,  3./
      DATA (u(i,5152),i=1,7)/26.,11., 9.,15., 1.69E-06,1.48324E+06,  3./
      DATA (u(i,5153),i=1,7)/26.,11., 9., 9., 1.52E-06,2.01572E+06,  3./
      DATA (u(i,5154),i=1,7)/26.,11., 9.,15., 1.13E-06,1.56789E+06,  2./
      DATA (u(i,5155),i=1,7)/26.,11., 9., 9., 8.66E-07,2.17865E+06,  3./
      DATA (u(i,5156),i=1,7)/26.,11., 9.,15., 2.51E-07,2.13038E+06,  3./
      DATA (u(i,5157),i=1,7)/26.,11., 9.,15., 9.97E-08,1.84672E+06,  2./
      DATA (u(i,5158),i=1,7)/26.,11., 9.,15., 7.86E-08,1.90476E+06,  3./
      DATA (u(i,5159),i=1,7)/26.,12., 4.,12., 6.12E+00,5.16956E+05,119./
      DATA (u(i,5160),i=1,7)/26.,12., 4.,12., 2.10E+00,1.51492E+06,  2./
      DATA (u(i,5161),i=1,7)/26.,12., 4.,12., 8.95E-01,1.58554E+06,  2./
      DATA (u(i,5162),i=1,7)/26.,12., 4.,12., 7.84E-01,1.94742E+06,  2./
      DATA (u(i,5163),i=1,7)/26.,12., 4.,12., 7.53E-01,1.25770E+06,  2./
      DATA (u(i,5164),i=1,7)/26.,12., 4.,12., 4.56E-01,2.16873E+06,  2./
      DATA (u(i,5165),i=1,7)/26.,12., 4.,12., 3.90E-01,2.63477E+05,149./
      DATA (u(i,5166),i=1,7)/26.,12., 4.,12., 3.08E-01,1.77242E+06,  2./
      DATA (u(i,5167),i=1,7)/26.,12., 4.,12., 2.43E-01,2.08464E+06,  2./
      DATA (u(i,5168),i=1,7)/26.,12., 4.,12., 1.50E-01,2.38436E+06,  2./
      DATA (u(i,5169),i=1,7)/26.,12., 4.,12., 1.49E-01,2.30256E+06,  2./
      DATA (u(i,5170),i=1,7)/26.,12., 4.,12., 1.30E-01,2.27998E+06,  2./
      DATA (u(i,5171),i=1,7)/26.,12., 4.,12., 1.28E-01,1.82782E+06,  2./
      DATA (u(i,5172),i=1,7)/26.,12., 4.,12., 1.28E-01,2.33481E+06,  2./
      DATA (u(i,5173),i=1,7)/26.,12., 4.,12., 1.03E-01,2.44081E+06,  2./
      DATA (u(i,5174),i=1,7)/26.,12., 4.,12., 9.85E-02,2.48077E+06,  2./
      DATA (u(i,5175),i=1,7)/26.,12., 4.,12., 8.90E-02,2.10349E+06,  2./
      DATA (u(i,5176),i=1,7)/26.,12., 4.,12., 6.02E-02,2.26040E+06,  2./
      DATA (u(i,5177),i=1,7)/26.,12., 4.,12., 5.76E-02,1.66362E+06,  2./
      DATA (u(i,5178),i=1,7)/26.,12., 4.,12., 4.70E-02,2.47893E+06,  2./
      DATA (u(i,5179),i=1,7)/26.,12., 4.,12., 4.53E-02,1.91058E+06,  2./
      DATA (u(i,5180),i=1,7)/26.,12., 4.,12., 4.26E-02,1.21803E+06,  3./
      DATA (u(i,5181),i=1,7)/26.,12., 4.,12., 2.05E-02,2.35849E+06,  2./
      DATA (u(i,5182),i=1,7)/26.,12., 4.,12., 2.03E-02,2.27428E+06,  2./
      DATA (u(i,5183),i=1,7)/26.,12., 4.,12., 1.90E-02,1.26119E+06,  3./
      DATA (u(i,5184),i=1,7)/26.,12., 4.,12., 1.55E-02,1.69463E+06,  2./
      DATA (u(i,5185),i=1,7)/26.,12., 4.,12., 1.27E-02,2.42307E+06,  2./
      DATA (u(i,5186),i=1,7)/26.,12., 4.,12., 8.30E-03,2.46792E+06,  2./
      DATA (u(i,5187),i=1,7)/26.,12., 4.,12., 7.21E-03,1.17758E+06,  3./
      DATA (u(i,5188),i=1,7)/26.,12., 4.,12., 6.48E-03,2.47341E+06,  2./
      DATA (u(i,5189),i=1,7)/26.,12., 4.,12., 4.83E-03,2.19732E+06,  2./
      DATA (u(i,5190),i=1,7)/26.,12., 4.,12., 4.54E-03,1.32293E+06,  3./
      DATA (u(i,5191),i=1,7)/26.,12., 4.,12., 2.85E-03,1.49835E+06,  3./
      DATA (u(i,5192),i=1,7)/26.,12., 4.,12., 2.71E-03,2.15843E+06,  2./
      DATA (u(i,5193),i=1,7)/26.,12., 4.,12., 1.72E-03,1.03284E+06,  3./
      DATA (u(i,5194),i=1,7)/26.,12., 4.,12., 6.28E-04,2.44978E+06,  2./
      DATA (u(i,5195),i=1,7)/26.,12., 4.,12., 2.71E-04,1.13084E+06,  3./
      DATA (u(i,5196),i=1,7)/26.,12., 4.,12., 2.45E-04,1.31130E+06,  3./
      DATA (u(i,5197),i=1,7)/26.,12., 4.,12., 1.49E-04,2.09688E+06,  3./
      DATA (u(i,5198),i=1,7)/26.,12., 4.,12., 9.03E-05,2.02470E+06,  3./
      DATA (u(i,5199),i=1,7)/26.,12., 4.,12., 4.69E-05,2.40964E+06,  2./
      DATA (u(i,5200),i=1,7)/26.,12., 4.,12., 1.88E-05,1.89789E+06,  3./
      DATA (u(i,5201),i=1,7)/26.,12., 4.,12., 1.10E-05,2.04625E+06,  3./
      DATA (u(i,5202),i=1,7)/26.,12., 4.,12., 9.42E-06,1.93087E+06,  3./
      DATA (u(i,5203),i=1,7)/26.,12., 4.,12., 8.87E-06,1.99720E+06,  3./
      DATA (u(i,5204),i=1,7)/26.,12., 4.,12., 9.48E-07,1.35999E+06,  3./
      DATA (u(i,5205),i=1,7)/26.,12., 4.,12., 8.04E-08,2.13038E+06,  3./
      DATA (u(i,5206),i=1,7)/26.,13., 9.,15., 6.34E+00,4.89548E+05,120./
      DATA (u(i,5207),i=1,7)/26.,13., 9.,15., 3.11E+00,1.58957E+06,  2./
      DATA (u(i,5208),i=1,7)/26.,13., 9., 9., 2.57E+00,4.79157E+05,121./
      DATA (u(i,5209),i=1,7)/26.,13., 9., 3., 1.75E+00,3.95867E+05,128./
      DATA (u(i,5210),i=1,7)/26.,13., 9.,15., 1.24E+00,1.67983E+06,  2./
      DATA (u(i,5211),i=1,7)/26.,13., 9., 9., 9.50E-01,1.60668E+06,  2./
      DATA (u(i,5212),i=1,7)/26.,13., 9., 9., 9.08E-01,1.33511E+06,  2./
      DATA (u(i,5213),i=1,7)/26.,13., 9., 9., 6.34E-01,1.69607E+06,  2./
      DATA (u(i,5214),i=1,7)/26.,13., 9.,15., 6.04E-01,2.33590E+06,  2./
      DATA (u(i,5215),i=1,7)/26.,13., 9.,15., 5.59E-01,2.07469E+06,  2./
      DATA (u(i,5216),i=1,7)/26.,13., 9., 9., 5.32E-01,3.00156E+05,141./
      DATA (u(i,5217),i=1,7)/26.,13., 9.,15., 4.91E-01,2.08899E+06,  2./
      DATA (u(i,5218),i=1,7)/26.,13., 9.,15., 4.33E-01,2.58839E+05,151./
      DATA (u(i,5219),i=1,7)/26.,13., 9., 9., 3.40E-01,2.08812E+06,  2./
      DATA (u(i,5220),i=1,7)/26.,13., 9.,15., 3.25E-01,2.23964E+06,  2./
      DATA (u(i,5221),i=1,7)/26.,13., 9., 9., 2.77E-01,1.32890E+06,  3./
      DATA (u(i,5222),i=1,7)/26.,13., 9.,15., 2.59E-01,1.83016E+06,  2./
      DATA (u(i,5223),i=1,7)/26.,13., 9., 3., 2.52E-01,1.64339E+06,  2./
      DATA (u(i,5224),i=1,7)/26.,13., 9.,15., 2.34E-01,2.48942E+06,  2./
      DATA (u(i,5225),i=1,7)/26.,13., 9., 9., 1.96E-01,1.83891E+06,  2./
      DATA (u(i,5226),i=1,7)/26.,13., 9., 9., 1.91E-01,1.96541E+06,  2./
      DATA (u(i,5227),i=1,7)/26.,13., 9., 9., 1.83E-01,2.33918E+06,  2./
      DATA (u(i,5228),i=1,7)/26.,13., 9.,15., 1.82E-01,2.58398E+06,  2./
      DATA (u(i,5229),i=1,7)/26.,13., 9.,15., 1.76E-01,2.52016E+06,  2./
      DATA (u(i,5230),i=1,7)/26.,13., 9., 9., 1.46E-01,2.24467E+06,  2./
      DATA (u(i,5231),i=1,7)/26.,13., 9.,15., 1.44E-01,1.74125E+06,  2./
      DATA (u(i,5232),i=1,7)/26.,13., 9.,15., 1.36E-01,2.64901E+06,  2./
      DATA (u(i,5233),i=1,7)/26.,13., 9., 9., 1.24E-01,2.26912E+06,  2./
      DATA (u(i,5234),i=1,7)/26.,13., 9., 9., 1.03E-01,2.52525E+06,  2./
      DATA (u(i,5235),i=1,7)/26.,13., 9., 3., 9.68E-02,1.83722E+06,  2./
      DATA (u(i,5236),i=1,7)/26.,13., 9., 9., 8.47E-02,2.49066E+06,  2./
      DATA (u(i,5237),i=1,7)/26.,13., 9.,15., 8.39E-02,2.39636E+06,  2./
      DATA (u(i,5238),i=1,7)/26.,13., 9.,15., 8.20E-02,2.68673E+06,  2./
      DATA (u(i,5239),i=1,7)/26.,13., 9., 3., 8.07E-02,2.22568E+06,  2./
      DATA (u(i,5240),i=1,7)/26.,13., 9., 9., 7.17E-02,2.39923E+06,  2./
      DATA (u(i,5241),i=1,7)/26.,13., 9.,15., 6.85E-02,2.68097E+06,  2./
      DATA (u(i,5242),i=1,7)/26.,13., 9.,15., 6.79E-02,2.69687E+06,  2./
      DATA (u(i,5243),i=1,7)/26.,13., 9., 9., 6.34E-02,2.58465E+06,  2./
      DATA (u(i,5244),i=1,7)/26.,13., 9., 9., 5.88E-02,1.76025E+06,  2./
      DATA (u(i,5245),i=1,7)/26.,13., 9.,15., 4.44E-02,2.18962E+06,  2./
      DATA (u(i,5246),i=1,7)/26.,13., 9., 9., 4.37E-02,2.68097E+06,  2./
      DATA (u(i,5247),i=1,7)/26.,13., 9., 9., 4.29E-02,2.24770E+06,  2./
      DATA (u(i,5248),i=1,7)/26.,13., 9., 9., 3.92E-02,2.68817E+06,  2./
      DATA (u(i,5249),i=1,7)/26.,13., 9., 9., 3.64E-02,1.80766E+06,  2./
      DATA (u(i,5250),i=1,7)/26.,13., 9., 9., 3.64E-02,2.64971E+06,  2./
      DATA (u(i,5251),i=1,7)/26.,13., 9., 3., 3.54E-02,2.50941E+06,  2./
      DATA (u(i,5252),i=1,7)/26.,13., 9., 3., 3.34E-02,2.39808E+06,  2./
      DATA (u(i,5253),i=1,7)/26.,13., 9.,15., 3.29E-02,2.24568E+06,  2./
      DATA (u(i,5254),i=1,7)/26.,13., 9., 9., 3.18E-02,2.44738E+06,  2./
      DATA (u(i,5255),i=1,7)/26.,13., 9., 9., 3.14E-02,2.55820E+06,  2./
      DATA (u(i,5256),i=1,7)/26.,13., 9., 3., 2.99E-02,2.68528E+06,  2./
      DATA (u(i,5257),i=1,7)/26.,13., 9., 9., 2.59E-02,1.92641E+06,  2./
      DATA (u(i,5258),i=1,7)/26.,13., 9., 9., 2.56E-02,1.23548E+06,  3./
      DATA (u(i,5259),i=1,7)/26.,13., 9.,15., 2.50E-02,2.47586E+06,  2./
      DATA (u(i,5260),i=1,7)/26.,13., 9.,15., 2.48E-02,1.99680E+06,  2./
      DATA (u(i,5261),i=1,7)/26.,13., 9., 9., 2.30E-02,2.63158E+06,  2./
      DATA (u(i,5262),i=1,7)/26.,13., 9., 9., 2.25E-02,2.69760E+06,  2./
      DATA (u(i,5263),i=1,7)/26.,13., 9., 9., 2.23E-02,2.68528E+06,  2./
      DATA (u(i,5264),i=1,7)/26.,13., 9.,15., 2.02E-02,2.66383E+06,  2./
      DATA (u(i,5265),i=1,7)/26.,13., 9.,15., 1.86E-02,2.07771E+06,  3./
      DATA (u(i,5266),i=1,7)/26.,13., 9.,15., 1.48E-02,2.53357E+06,  2./
      DATA (u(i,5267),i=1,7)/26.,13., 9.,15., 1.32E-02,1.92012E+06,  2./
      DATA (u(i,5268),i=1,7)/26.,13., 9., 3., 1.30E-02,2.78629E+06,  2./
      DATA (u(i,5269),i=1,7)/26.,13., 9., 9., 1.29E-02,2.65252E+06,  2./
      DATA (u(i,5270),i=1,7)/26.,13., 9., 9., 1.04E-02,2.36855E+06,  2./
      DATA (u(i,5271),i=1,7)/26.,13., 9., 9., 9.46E-03,2.00924E+06,  2./
      DATA (u(i,5272),i=1,7)/26.,13., 9., 3., 9.16E-03,2.84495E+06,  2./
      DATA (u(i,5273),i=1,7)/26.,13., 9., 9., 8.58E-03,2.31054E+06,  2./
      DATA (u(i,5274),i=1,7)/26.,13., 9., 3., 8.12E-03,2.85959E+06,  2./
      DATA (u(i,5275),i=1,7)/26.,13., 9.,15., 7.75E-03,1.22309E+06,  3./
      DATA (u(i,5276),i=1,7)/26.,13., 9., 9., 6.91E-03,2.17486E+06,  2./
      DATA (u(i,5277),i=1,7)/26.,13., 9., 3., 6.43E-03,2.90698E+06,  2./
      DATA (u(i,5278),i=1,7)/26.,13., 9.,15., 5.72E-03,2.58331E+06,  2./
      DATA (u(i,5279),i=1,7)/26.,13., 9.,15., 5.71E-03,2.58732E+06,  2./
      DATA (u(i,5280),i=1,7)/26.,13., 9.,15., 5.35E-03,1.82715E+06,  3./
      DATA (u(i,5281),i=1,7)/26.,13., 9., 9., 4.97E-03,1.25723E+06,  3./
      DATA (u(i,5282),i=1,7)/26.,13., 9.,15., 4.43E-03,2.65322E+06,  2./
      DATA (u(i,5283),i=1,7)/26.,13., 9.,15., 4.19E-03,2.17770E+06,  2./
      DATA (u(i,5284),i=1,7)/26.,13., 9., 3., 3.99E-03,2.68097E+06,  2./
      DATA (u(i,5285),i=1,7)/26.,13., 9., 3., 3.83E-03,2.65463E+06,  2./
      DATA (u(i,5286),i=1,7)/26.,13., 9.,15., 3.56E-03,1.91351E+06,  2./
      DATA (u(i,5287),i=1,7)/26.,13., 9., 3., 3.19E-03,2.17960E+06,  2./
      DATA (u(i,5288),i=1,7)/26.,13., 9.,15., 2.98E-03,2.42189E+06,  2./
      DATA (u(i,5289),i=1,7)/26.,13., 9., 9., 2.56E-03,1.04297E+06,  3./
      DATA (u(i,5290),i=1,7)/26.,13., 9., 3., 2.54E-03,2.55232E+06,  2./
      DATA (u(i,5291),i=1,7)/26.,13., 9.,15., 2.42E-03,1.04351E+06,  3./
      DATA (u(i,5292),i=1,7)/26.,13., 9., 9., 1.94E-03,2.42718E+06,  2./
      DATA (u(i,5293),i=1,7)/26.,13., 9.,15., 1.56E-03,1.11346E+06,  3./
      DATA (u(i,5294),i=1,7)/26.,13., 9.,15., 1.53E-03,2.35018E+06,  2./
      DATA (u(i,5295),i=1,7)/26.,13., 9., 3., 1.44E-03,1.35980E+06,  3./
      DATA (u(i,5296),i=1,7)/26.,13., 9., 9., 1.37E-03,1.84332E+06,  3./
      DATA (u(i,5297),i=1,7)/26.,13., 9.,15., 1.36E-03,1.13714E+06,  3./
      DATA (u(i,5298),i=1,7)/26.,13., 9.,15., 1.09E-03,2.30150E+06,  2./
      DATA (u(i,5299),i=1,7)/26.,13., 9., 9., 1.01E-03,2.18103E+06,  2./
      DATA (u(i,5300),i=1,7)/26.,13., 9., 3., 9.65E-04,1.95008E+06,  2./
      DATA (u(i,5301),i=1,7)/26.,13., 9., 9., 9.37E-04,1.04811E+06,  3./
      DATA (u(i,5302),i=1,7)/26.,13., 9., 9., 8.09E-04,1.19517E+06,  3./
      DATA (u(i,5303),i=1,7)/26.,13., 9.,15., 7.98E-04,2.51193E+06,  2./
      DATA (u(i,5304),i=1,7)/26.,13., 9., 9., 7.93E-04,2.65463E+06,  2./
      DATA (u(i,5305),i=1,7)/26.,13., 9., 9., 7.63E-04,2.65745E+06,  2./
      DATA (u(i,5306),i=1,7)/26.,13., 9.,15., 7.57E-04,1.31596E+06,  3./
      DATA (u(i,5307),i=1,7)/26.,13., 9., 3., 7.04E-04,1.95427E+06,  3./
      DATA (u(i,5308),i=1,7)/26.,13., 9., 3., 4.94E-04,1.15594E+06,  3./
      DATA (u(i,5309),i=1,7)/26.,13., 9.,15., 4.81E-04,1.24363E+06,  3./
      DATA (u(i,5310),i=1,7)/26.,13., 9.,15., 3.96E-04,2.65463E+06,  2./
      DATA (u(i,5311),i=1,7)/26.,13., 9., 9., 3.41E-04,2.48386E+06,  2./
      DATA (u(i,5312),i=1,7)/26.,13., 9.,15., 2.96E-04,9.55475E+05,  3./
      DATA (u(i,5313),i=1,7)/26.,13., 9.,15., 2.62E-04,2.59943E+06,  2./
      DATA (u(i,5314),i=1,7)/26.,13., 9., 3., 2.15E-04,2.90782E+06,  2./
      DATA (u(i,5315),i=1,7)/26.,13., 9.,15., 2.14E-04,1.93949E+06,  3./
      DATA (u(i,5316),i=1,7)/26.,13., 9., 9., 2.06E-04,2.60078E+06,  2./
      DATA (u(i,5317),i=1,7)/26.,13., 9., 3., 1.35E-04,2.84900E+06,  2./
      DATA (u(i,5318),i=1,7)/26.,13., 9., 9., 1.09E-04,2.58933E+06,  2./
      DATA (u(i,5319),i=1,7)/26.,13., 9.,15., 1.06E-04,2.17297E+06,  2./
      DATA (u(i,5320),i=1,7)/26.,13., 9., 9., 7.55E-05,1.98807E+06,  2./
      DATA (u(i,5321),i=1,7)/26.,13., 9., 3., 5.51E-05,1.04395E+06,  3./
      DATA (u(i,5322),i=1,7)/26.,13., 9.,15., 4.93E-05,1.30890E+06,  3./
      DATA (u(i,5323),i=1,7)/26.,13., 9.,15., 3.57E-05,1.99164E+06,  3./
      DATA (u(i,5324),i=1,7)/26.,13., 9.,15., 2.06E-05,1.89645E+06,  3./
      DATA (u(i,5325),i=1,7)/26.,13., 9., 9., 9.52E-06,2.60281E+06,  2./
      DATA (u(i,5326),i=1,7)/26.,13., 9., 9., 9.18E-06,2.02102E+06,  3./
      DATA (u(i,5327),i=1,7)/26.,13., 9., 9., 8.86E-06,1.98334E+06,  3./
      DATA (u(i,5328),i=1,7)/26.,13., 9.,15., 8.08E-06,1.92160E+06,  2./
      DATA (u(i,5329),i=1,7)/26.,13., 9., 3., 1.64E-06,2.08812E+06,  3./
      DATA (u(i,5330),i=1,7)/26.,13., 9.,15., 5.15E-07,1.95886E+06,  3./
      DATA (u(i,5331),i=1,7)/26.,13., 9., 9., 1.32E-07,1.89970E+06,  3./
      DATA (u(i,5332),i=1,7)/26.,14., 6.,10., 2.86E+00,4.55000E+05,123./
      DATA (u(i,5333),i=1,7)/26.,14., 6., 6., 2.48E+00,3.65831E+05,131./
      DATA (u(i,5334),i=1,7)/26.,14., 6.,10., 1.69E+00,1.67701E+06, 97./
      DATA (u(i,5335),i=1,7)/26.,14., 6.,10., 1.07E+00,1.79469E+06,  2./
      DATA (u(i,5336),i=1,7)/26.,14., 6., 6., 5.76E-01,1.76367E+06,  2./
      DATA (u(i,5337),i=1,7)/26.,14., 6.,10., 4.73E-01,2.22519E+06,  2./
      DATA (u(i,5338),i=1,7)/26.,14., 6., 2., 3.88E-01,1.41703E+06,  2./
      DATA (u(i,5339),i=1,7)/26.,14., 6.,10., 3.86E-01,2.71297E+05,144./
      DATA (u(i,5340),i=1,7)/26.,14., 6., 2., 3.26E-01,3.42478E+05,135./
      DATA (u(i,5341),i=1,7)/26.,14., 6.,10., 2.54E-01,2.41080E+06,  2./
      DATA (u(i,5342),i=1,7)/26.,14., 6.,10., 2.11E-01,2.49688E+06,  2./
      DATA (u(i,5343),i=1,7)/26.,14., 6., 2., 2.07E-01,1.82050E+06,  2./
      DATA (u(i,5344),i=1,7)/26.,14., 6., 6., 2.05E-01,1.88395E+06,  2./
      DATA (u(i,5345),i=1,7)/26.,14., 6., 6., 1.74E-01,2.39693E+06,  2./
      DATA (u(i,5346),i=1,7)/26.,14., 6.,10., 1.47E-01,2.72035E+06,  2./
      DATA (u(i,5347),i=1,7)/26.,14., 6.,10., 1.26E-01,2.68168E+06,  2./
      DATA (u(i,5348),i=1,7)/26.,14., 6.,10., 8.24E-02,2.50815E+06,  2./
      DATA (u(i,5349),i=1,7)/26.,14., 6.,10., 8.00E-02,1.88537E+06,  2./
      DATA (u(i,5350),i=1,7)/26.,14., 6., 2., 7.13E-02,2.09996E+06,  2./
      DATA (u(i,5351),i=1,7)/26.,14., 6.,10., 6.59E-02,2.90360E+06,  2./
      DATA (u(i,5352),i=1,7)/26.,14., 6., 6., 5.43E-02,2.50815E+06,  2./
      DATA (u(i,5353),i=1,7)/26.,14., 6.,10., 5.05E-02,2.79330E+06,  2./
      DATA (u(i,5354),i=1,7)/26.,14., 6.,10., 4.94E-02,2.86533E+06,  2./
      DATA (u(i,5355),i=1,7)/26.,14., 6.,10., 4.77E-02,2.37079E+06,  2./
      DATA (u(i,5356),i=1,7)/26.,14., 6., 2., 4.58E-02,2.43902E+06,  2./
      DATA (u(i,5357),i=1,7)/26.,14., 6.,10., 4.39E-02,2.91886E+06,  2./
      DATA (u(i,5358),i=1,7)/26.,14., 6., 6., 4.27E-02,2.72109E+06,  2./
      DATA (u(i,5359),i=1,7)/26.,14., 6., 6., 4.27E-02,2.90107E+06,  2./
      DATA (u(i,5360),i=1,7)/26.,14., 6., 6., 3.32E-02,2.71961E+06,  2./
      DATA (u(i,5361),i=1,7)/26.,14., 6., 2., 3.12E-02,2.38663E+06,  2./
      DATA (u(i,5362),i=1,7)/26.,14., 6., 2., 2.73E-02,1.89934E+06,  2./
      DATA (u(i,5363),i=1,7)/26.,14., 6., 2., 2.72E-02,2.72628E+06,  2./
      DATA (u(i,5364),i=1,7)/26.,14., 6.,10., 2.70E-02,2.51953E+06,  2./
      DATA (u(i,5365),i=1,7)/26.,14., 6.,10., 2.58E-02,2.82167E+06,  2./
      DATA (u(i,5366),i=1,7)/26.,14., 6.,10., 2.30E-02,2.12089E+06,  2./
      DATA (u(i,5367),i=1,7)/26.,14., 6.,10., 2.21E-02,2.13174E+06,  2./
      DATA (u(i,5368),i=1,7)/26.,14., 6., 6., 2.19E-02,2.82486E+06,  2./
      DATA (u(i,5369),i=1,7)/26.,14., 6., 6., 2.17E-02,3.02480E+06,  2./
      DATA (u(i,5370),i=1,7)/26.,14., 6.,10., 1.89E-02,2.26912E+06,  2./
      DATA (u(i,5371),i=1,7)/26.,14., 6.,10., 1.86E-02,2.23814E+06,  2./
      DATA (u(i,5372),i=1,7)/26.,14., 6., 6., 1.79E-02,3.10078E+06,  2./
      DATA (u(i,5373),i=1,7)/26.,14., 6.,10., 1.56E-02,2.78784E+06,  2./
      DATA (u(i,5374),i=1,7)/26.,14., 6., 6., 1.49E-02,3.01114E+06,  2./
      DATA (u(i,5375),i=1,7)/26.,14., 6., 2., 1.38E-02,2.45821E+06,  2./
      DATA (u(i,5376),i=1,7)/26.,14., 6.,10., 1.36E-02,2.78707E+06,  2./
      DATA (u(i,5377),i=1,7)/26.,14., 6., 6., 1.35E-02,3.15657E+06,  2./
      DATA (u(i,5378),i=1,7)/26.,14., 6.,10., 1.33E-02,2.43784E+06,  2./
      DATA (u(i,5379),i=1,7)/26.,14., 6., 6., 1.31E-02,2.35960E+06,  2./
      DATA (u(i,5380),i=1,7)/26.,14., 6., 2., 1.29E-02,2.63992E+06,  2./
      DATA (u(i,5381),i=1,7)/26.,14., 6., 6., 1.22E-02,2.67881E+06,  2./
      DATA (u(i,5382),i=1,7)/26.,14., 6.,10., 1.14E-02,2.79174E+06,  2./
      DATA (u(i,5383),i=1,7)/26.,14., 6., 2., 1.05E-02,2.42895E+06,  2./
      DATA (u(i,5384),i=1,7)/26.,14., 6., 2., 1.05E-02,2.76243E+06,  2./
      DATA (u(i,5385),i=1,7)/26.,14., 6.,10., 1.01E-02,2.78242E+06,  2./
      DATA (u(i,5386),i=1,7)/26.,14., 6., 2., 9.82E-03,2.90444E+06,  2./
      DATA (u(i,5387),i=1,7)/26.,14., 6.,10., 9.64E-03,2.04499E+06,  2./
      DATA (u(i,5388),i=1,7)/26.,14., 6., 2., 9.02E-03,2.82805E+06,  2./
      DATA (u(i,5389),i=1,7)/26.,14., 6., 6., 8.89E-03,3.12695E+06,  2./
      DATA (u(i,5390),i=1,7)/26.,14., 6.,10., 8.13E-03,2.62123E+06,  2./
      DATA (u(i,5391),i=1,7)/26.,14., 6., 2., 7.33E-03,2.90360E+06,  2./
      DATA (u(i,5392),i=1,7)/26.,14., 6., 6., 6.92E-03,2.25632E+06,  2./
      DATA (u(i,5393),i=1,7)/26.,14., 6., 2., 6.89E-03,2.51953E+06,  2./
      DATA (u(i,5394),i=1,7)/26.,14., 6., 6., 6.49E-03,2.91036E+06,  2./
      DATA (u(i,5395),i=1,7)/26.,14., 6.,10., 5.62E-03,1.99164E+06,  2./
      DATA (u(i,5396),i=1,7)/26.,14., 6., 6., 5.58E-03,2.02102E+06,  2./
      DATA (u(i,5397),i=1,7)/26.,14., 6., 6., 5.23E-03,2.24871E+06,  2./
      DATA (u(i,5398),i=1,7)/26.,14., 6., 6., 5.06E-03,2.78862E+06,  2./
      DATA (u(i,5399),i=1,7)/26.,14., 6., 6., 4.57E-03,2.45158E+06,  2./
      DATA (u(i,5400),i=1,7)/26.,14., 6.,10., 4.54E-03,2.91630E+06,  2./
      DATA (u(i,5401),i=1,7)/26.,14., 6., 6., 4.34E-03,3.01386E+06,  2./
      DATA (u(i,5402),i=1,7)/26.,14., 6.,10., 4.03E-03,2.81452E+06,  2./
      DATA (u(i,5403),i=1,7)/26.,14., 6.,10., 3.56E-03,2.86615E+06,  2./
      DATA (u(i,5404),i=1,7)/26.,14., 6., 6., 3.36E-03,2.99133E+06,  2./
      DATA (u(i,5405),i=1,7)/26.,14., 6., 2., 2.72E-03,1.24039E+06,  3./
      DATA (u(i,5406),i=1,7)/26.,14., 6., 2., 2.67E-03,2.84738E+06,  2./
      DATA (u(i,5407),i=1,7)/26.,14., 6.,10., 2.42E-03,2.52334E+06,  2./
      DATA (u(i,5408),i=1,7)/26.,14., 6., 2., 2.06E-03,2.08943E+06,  2./
      DATA (u(i,5409),i=1,7)/26.,14., 6., 6., 2.02E-03,2.79955E+06,  2./
      DATA (u(i,5410),i=1,7)/26.,14., 6., 6., 1.85E-03,3.08166E+06,  2./
      DATA (u(i,5411),i=1,7)/26.,14., 6.,10., 1.85E-03,2.34302E+06,  2./
      DATA (u(i,5412),i=1,7)/26.,14., 6.,10., 1.75E-03,1.15741E+06,  3./
      DATA (u(i,5413),i=1,7)/26.,14., 6.,10., 1.64E-03,2.66454E+06,  2./
      DATA (u(i,5414),i=1,7)/26.,14., 6., 6., 1.62E-03,1.23609E+06,  3./
      DATA (u(i,5415),i=1,7)/26.,14., 6.,10., 1.47E-03,2.48571E+06,  2./
      DATA (u(i,5416),i=1,7)/26.,14., 6.,10., 1.42E-03,2.88517E+06,  2./
      DATA (u(i,5417),i=1,7)/26.,14., 6.,10., 1.35E-03,1.04069E+06,  3./
      DATA (u(i,5418),i=1,7)/26.,14., 6., 2., 1.33E-03,2.79330E+06,  2./
      DATA (u(i,5419),i=1,7)/26.,14., 6., 2., 1.19E-03,2.26603E+06,  2./
      DATA (u(i,5420),i=1,7)/26.,14., 6., 2., 1.14E-03,2.76091E+06,  2./
      DATA (u(i,5421),i=1,7)/26.,14., 6., 6., 9.69E-04,3.16256E+06,  2./
      DATA (u(i,5422),i=1,7)/26.,14., 6., 6., 9.35E-04,2.51699E+06,  2./
      DATA (u(i,5423),i=1,7)/26.,14., 6., 6., 9.05E-04,3.07314E+06,  2./
      DATA (u(i,5424),i=1,7)/26.,14., 6., 6., 8.88E-04,2.55689E+06,  2./
      DATA (u(i,5425),i=1,7)/26.,14., 6.,10., 7.90E-04,1.10473E+06,  3./
      DATA (u(i,5426),i=1,7)/26.,14., 6.,10., 7.67E-04,9.87849E+05,  2./
      DATA (u(i,5427),i=1,7)/26.,14., 6.,10., 7.54E-04,2.71444E+06,  2./
      DATA (u(i,5428),i=1,7)/26.,14., 6., 2., 7.27E-04,1.03853E+06,  3./
      DATA (u(i,5429),i=1,7)/26.,14., 6., 6., 5.97E-04,1.03199E+06,  3./
      DATA (u(i,5430),i=1,7)/26.,14., 6., 2., 4.47E-04,2.56805E+06,  2./
      DATA (u(i,5431),i=1,7)/26.,14., 6.,10., 3.97E-04,2.89017E+06,  2./
      DATA (u(i,5432),i=1,7)/26.,14., 6.,10., 3.75E-04,1.83554E+06,  3./
      DATA (u(i,5433),i=1,7)/26.,14., 6.,10., 3.02E-04,2.55037E+06,  2./
      DATA (u(i,5434),i=1,7)/26.,14., 6.,10., 2.87E-04,2.61301E+06,  2./
      DATA (u(i,5435),i=1,7)/26.,14., 6.,10., 2.52E-04,2.72851E+06,  2./
      DATA (u(i,5436),i=1,7)/26.,14., 6., 2., 2.43E-04,2.62812E+06,  2./
      DATA (u(i,5437),i=1,7)/26.,14., 6.,10., 1.99E-04,2.19010E+06,  2./
      DATA (u(i,5438),i=1,7)/26.,14., 6.,10., 1.94E-04,2.56148E+06,  2./
      DATA (u(i,5439),i=1,7)/26.,14., 6., 6., 1.72E-04,9.37998E+05,  3./
      DATA (u(i,5440),i=1,7)/26.,14., 6.,10., 1.34E-04,1.90694E+06,  3./
      DATA (u(i,5441),i=1,7)/26.,14., 6., 6., 1.33E-04,2.87026E+06,  2./
      DATA (u(i,5442),i=1,7)/26.,14., 6.,10., 1.09E-04,2.77162E+06,  2./
      DATA (u(i,5443),i=1,7)/26.,14., 6., 6., 8.02E-05,2.49252E+06,  2./
      DATA (u(i,5444),i=1,7)/26.,14., 6., 6., 7.35E-05,3.10752E+06,  2./
      DATA (u(i,5445),i=1,7)/26.,14., 6., 2., 6.59E-05,2.76549E+06,  2./
      DATA (u(i,5446),i=1,7)/26.,14., 6.,10., 5.21E-05,2.62812E+06,  2./
      DATA (u(i,5447),i=1,7)/26.,14., 6., 6., 5.18E-05,2.85714E+06,  2./
      DATA (u(i,5448),i=1,7)/26.,14., 6.,10., 4.75E-05,2.84172E+06,  2./
      DATA (u(i,5449),i=1,7)/26.,14., 6., 6., 4.62E-05,2.61575E+06,  2./
      DATA (u(i,5450),i=1,7)/26.,14., 6.,10., 2.36E-05,2.85225E+06,  2./
      DATA (u(i,5451),i=1,7)/26.,14., 6.,10., 2.13E-05,2.86287E+06,  2./
      DATA (u(i,5452),i=1,7)/26.,14., 6., 6., 9.19E-06,2.75255E+06,  2./
      DATA (u(i,5453),i=1,7)/26.,14., 6., 6., 9.08E-06,3.14070E+06,  2./
      DATA (u(i,5454),i=1,7)/26.,14., 6., 6., 7.83E-06,3.06091E+06,  2./
      DATA (u(i,5455),i=1,7)/26.,14., 6., 6., 6.01E-06,3.13185E+06,  2./
      DATA (u(i,5456),i=1,7)/26.,14., 6., 2., 3.38E-06,2.86451E+06,  2./
      DATA (u(i,5457),i=1,7)/26.,14., 6., 6., 3.07E-06,1.83655E+06,  3./
      DATA (u(i,5458),i=1,7)/26.,14., 6., 6., 2.33E-06,2.76243E+06,  2./
      DATA (u(i,5459),i=1,7)/26.,14., 6., 6., 1.54E-06,3.08928E+06,  2./
      DATA (u(i,5460),i=1,7)/26.,14., 6.,10., 1.83E-07,2.84900E+06,  2./
      DATA (u(i,5461),i=1,7)/26.,15., 1., 3., 8.29E-01,3.53782E+05,136./
      DATA (u(i,5462),i=1,7)/26.,15., 1., 3., 4.08E-01,1.88857E+06, 94./
      DATA (u(i,5463),i=1,7)/26.,15., 1., 3., 1.09E-01,2.57268E+06, 88./
      DATA (u(i,5464),i=1,7)/26.,15., 1., 3., 5.69E-02,2.92398E+06,  2./
      DATA (u(i,5465),i=1,7)/26.,15., 1., 3., 3.24E-02,3.13283E+06,  2./
      DATA (u(i,5466),i=1,7)/26.,15., 1., 3., 1.55E-02,3.26264E+06,  2./
      DATA (u(i,5467),i=1,7)/26.,15., 1., 3., 1.41E-02,2.60484E+06,  2./
      DATA (u(i,5468),i=1,7)/26.,15., 1., 3., 1.34E-02,3.35345E+06,  2./
      DATA (u(i,5469),i=1,7)/26.,15., 1., 3., 8.87E-03,3.41764E+06,  2./
      DATA (u(i,5470),i=1,7)/26.,15., 1., 3., 6.05E-03,2.34522E+06,  2./
      DATA (u(i,5471),i=1,7)/26.,15., 1., 3., 4.24E-03,2.08681E+06,  2./
      DATA (u(i,5472),i=1,7)/26.,15., 1., 3., 3.14E-03,2.95072E+06,  2./
      DATA (u(i,5473),i=1,7)/26.,15., 1., 3., 2.71E-03,3.27547E+06,  2./
      DATA (u(i,5474),i=1,7)/26.,15., 1., 3., 2.54E-03,3.25309E+06,  2./
      DATA (u(i,5475),i=1,7)/26.,15., 1., 3., 1.28E-03,1.07793E+06,  3./
      DATA (u(i,5476),i=1,7)/26.,15., 1., 3., 7.48E-04,3.40716E+06,  2./
      DATA (u(i,5477),i=1,7)/26.,15., 1., 3., 3.23E-04,2.81770E+06,  2./
      DATA (u(i,5478),i=1,7)/26.,15., 1., 3., 6.70E-05,2.83366E+06,  2./
      DATA (u(i,5479),i=1,7)/26.,15., 1., 3., 3.83E-05,3.37496E+06,  2./
      DATA (u(i,5480),i=1,7)/26.,15., 1., 3., 2.80E-05,3.18979E+06,  2./
      DATA (u(i,5481),i=1,7)/26.,16., 2., 6., 7.28E-01,2.73763E+05,143./
      DATA (u(i,5482),i=1,7)/26.,16., 2., 6., 4.71E-01,1.95656E+06, 92./
      DATA (u(i,5483),i=1,7)/26.,16., 2., 6., 1.44E-01,2.69034E+06,  2./
      DATA (u(i,5484),i=1,7)/26.,16., 2., 6., 6.58E-02,3.07692E+06,  2./
      DATA (u(i,5485),i=1,7)/26.,16., 2., 6., 3.63E-02,3.30469E+06,  2./
      DATA (u(i,5486),i=1,7)/26.,16., 2., 6., 2.24E-02,3.45066E+06,  2./
      DATA (u(i,5487),i=1,7)/26.,16., 2., 6., 1.49E-02,3.54988E+06,  2./
      DATA (u(i,5488),i=1,7)/26.,16., 2., 6., 1.04E-02,3.62056E+06,  2./
      DATA (u(i,5489),i=1,7)/26.,17., 1., 3., 2.94E+00,6.62252E+06, 71./
      DATA (u(i,5490),i=1,7)/26.,17., 1., 3., 6.30E-01,6.55220E+06, 72./
      DATA (u(i,5491),i=1,7)/26.,17., 1., 3., 9.70E-03,6.47250E+06, 73./
      DATA (u(i,5492),i=1,7)/26.,17., 1., 3., 7.37E-01,8.18331E+06, 20./
      DATA (u(i,5493),i=1,7)/26.,17., 1., 3., 3.43E-01,8.90472E+06,  2./
      DATA (u(i,5494),i=1,7)/26.,17., 1., 3., 3.27E-01,7.14286E+06, 68./
      DATA (u(i,5495),i=1,7)/26.,17., 1., 3., 2.20E-01,5.92417E+06, 75./
      DATA (u(i,5496),i=1,7)/26.,17., 1., 3., 1.22E-01,5.86370E+06, 76./
      DATA (u(i,5497),i=1,7)/26.,17., 1., 3., 1.57E-01,9.30233E+06,  2./
      DATA (u(i,5498),i=1,7)/26.,17., 1., 3., 9.45E-02,9.53289E+06,  2./
      DATA (u(i,5499),i=1,7)/26.,17., 1., 3., 9.25E-02,8.96861E+06,  2./
      DATA (u(i,5500),i=1,7)/26.,17., 1., 3., 6.22E-02,9.68992E+06,  2./
      DATA (u(i,5501),i=1,7)/26.,17., 1., 3., 5.00E-02,9.77517E+06,  2./
      DATA (u(i,5502),i=1,7)/26.,17., 1., 3., 3.69E-02,7.91139E+06, 22./
      DATA (u(i,5503),i=1,7)/26.,17., 1., 3., 3.42E-02,9.79432E+06,  2./
      DATA (u(i,5504),i=1,7)/26.,17., 1., 3., 2.86E-02,9.87167E+06,  2./
      DATA (u(i,5505),i=1,7)/26.,17., 1., 3., 1.71E-02,8.77193E+06,  2./
      DATA (u(i,5506),i=1,7)/26.,17., 1., 3., 1.22E-02,9.77517E+06,  2./
      DATA (u(i,5507),i=1,7)/26.,17., 1., 3., 6.15E-03,9.22509E+06,  2./
      DATA (u(i,5508),i=1,7)/26.,17., 1., 3., 4.01E-03,9.48767E+06,  2./
      DATA (u(i,5509),i=1,7)/26.,17., 1., 3., 2.84E-03,9.66184E+06,  2./
      DATA (u(i,5510),i=1,7)/26.,17., 1., 3., 9.34E-04,9.85222E+06,  2./
      DATA (u(i,5511),i=1,7)/26.,18., 6.,10., 6.22E+00,6.98812E+06,  2./
      DATA (u(i,5512),i=1,7)/26.,18., 6., 6., 4.53E+00,6.99301E+06,  2./
      DATA (u(i,5513),i=1,7)/26.,18., 6.,10., 2.31E+00,6.86342E+06,  2./
      DATA (u(i,5514),i=1,7)/26.,18., 6.,10., 1.52E+00,7.09220E+06,  2./
      DATA (u(i,5515),i=1,7)/26.,18., 6.,10., 1.35E+00,8.66551E+06,  2./
      DATA (u(i,5516),i=1,7)/26.,18., 6., 2., 1.18E+00,6.95410E+06,  2./
      DATA (u(i,5517),i=1,7)/26.,18., 6.,10., 9.43E-01,7.45156E+06, 70./
      DATA (u(i,5518),i=1,7)/26.,18., 6., 6., 7.75E-01,8.77963E+06,  2./
      DATA (u(i,5519),i=1,7)/26.,18., 6.,10., 7.69E-01,8.77963E+06,  2./
      DATA (u(i,5520),i=1,7)/26.,18., 6., 6., 6.59E-01,7.46269E+06, 69./
      DATA (u(i,5521),i=1,7)/26.,18., 6., 6., 5.94E-01,6.28141E+06,  2./
      DATA (u(i,5522),i=1,7)/26.,18., 6.,10., 5.22E-01,9.47867E+06,  2./
      DATA (u(i,5523),i=1,7)/26.,18., 6.,10., 5.04E-01,9.44287E+06,  2./
      DATA (u(i,5524),i=1,7)/26.,18., 6.,10., 3.83E-01,6.38570E+06,  2./
      DATA (u(i,5525),i=1,7)/26.,18., 6., 6., 3.64E-01,8.65801E+06,  2./
      DATA (u(i,5526),i=1,7)/26.,18., 6.,10., 3.27E-01,9.92064E+06,  2./
      DATA (u(i,5527),i=1,7)/26.,18., 6.,10., 3.25E-01,7.73994E+06, 67./
      DATA (u(i,5528),i=1,7)/26.,18., 6., 2., 2.89E-01,7.52445E+06,  2./
      DATA (u(i,5529),i=1,7)/26.,18., 6., 6., 2.79E-01,9.60615E+06,  2./
      DATA (u(i,5530),i=1,7)/26.,18., 6., 2., 2.77E-01,9.43485E+05,  3./
      DATA (u(i,5531),i=1,7)/26.,18., 6., 6., 2.71E-01,6.85401E+06,  2./
      DATA (u(i,5532),i=1,7)/26.,18., 6.,10., 2.58E-01,8.92061E+06,  2./
      DATA (u(i,5533),i=1,7)/26.,18., 6., 2., 2.48E-01,8.77193E+06,  2./
      DATA (u(i,5534),i=1,7)/26.,18., 6., 6., 2.47E-01,9.45180E+06,  2./
      DATA (u(i,5535),i=1,7)/26.,18., 6.,10., 2.36E-01,9.60615E+06,  2./
      DATA (u(i,5536),i=1,7)/26.,18., 6.,10., 1.94E-01,9.74659E+06,  2./
      DATA (u(i,5537),i=1,7)/26.,18., 6.,10., 1.76E-01,1.01937E+07,  2./
      DATA (u(i,5538),i=1,7)/26.,18., 6.,10., 1.65E-01,1.03306E+07,  2./
      DATA (u(i,5539),i=1,7)/26.,18., 6., 6., 1.60E-01,7.76398E+06,  2./
      DATA (u(i,5540),i=1,7)/26.,18., 6., 6., 1.40E-01,9.47867E+06,  2./
      DATA (u(i,5541),i=1,7)/26.,18., 6.,10., 1.26E-01,1.03627E+07,  2./
      DATA (u(i,5542),i=1,7)/26.,18., 6., 6., 1.20E-01,1.00503E+07,  2./
      DATA (u(i,5543),i=1,7)/26.,18., 6., 6., 1.12E-01,9.92064E+06,  2./
      DATA (u(i,5544),i=1,7)/26.,18., 6., 2., 1.08E-01,9.59693E+06,  2./
      DATA (u(i,5545),i=1,7)/26.,18., 6., 6., 1.04E-01,8.43170E+06,  2./
      DATA (u(i,5546),i=1,7)/26.,18., 6.,10., 9.48E-02,1.00503E+07,  2./
      DATA (u(i,5547),i=1,7)/26.,18., 6.,10., 8.71E-02,1.02041E+07,  2./
      DATA (u(i,5548),i=1,7)/26.,18., 6., 2., 8.47E-02,9.48767E+06,  2./
      DATA (u(i,5549),i=1,7)/26.,18., 6.,10., 8.42E-02,1.04822E+07,  2./
      DATA (u(i,5550),i=1,7)/26.,18., 6., 6., 7.75E-02,1.03306E+07,  2./
      DATA (u(i,5551),i=1,7)/26.,18., 6.,10., 7.63E-02,8.55432E+06,  2./
      DATA (u(i,5552),i=1,7)/26.,18., 6., 2., 7.47E-02,6.54450E+06,  2./
      DATA (u(i,5553),i=1,7)/26.,18., 6., 6., 7.14E-02,1.01937E+07,  2./
      DATA (u(i,5554),i=1,7)/26.,18., 6., 6., 6.62E-02,9.36330E+06,  2./
      DATA (u(i,5555),i=1,7)/26.,18., 6.,10., 6.40E-02,1.05708E+07,  2./
      DATA (u(i,5556),i=1,7)/26.,18., 6., 6., 6.31E-02,1.03199E+07,  2./
      DATA (u(i,5557),i=1,7)/26.,18., 6., 6., 5.52E-02,1.04932E+07,  2./
      DATA (u(i,5558),i=1,7)/26.,18., 6., 2., 5.15E-02,1.00503E+07,  2./
      DATA (u(i,5559),i=1,7)/26.,18., 6., 6., 4.90E-02,9.75610E+06,  2./
      DATA (u(i,5560),i=1,7)/26.,18., 6.,10., 4.84E-02,1.04932E+07,  2./
      DATA (u(i,5561),i=1,7)/26.,18., 6., 6., 4.55E-02,1.03627E+07,  2./
      DATA (u(i,5562),i=1,7)/26.,18., 6.,10., 4.46E-02,1.03199E+07,  2./
      DATA (u(i,5563),i=1,7)/26.,18., 6., 2., 3.30E-02,1.03520E+07,  2./
      DATA (u(i,5564),i=1,7)/26.,18., 6., 2., 3.07E-02,1.03199E+07,  2./
      DATA (u(i,5565),i=1,7)/26.,18., 6.,10., 2.85E-02,9.92064E+06,  2./
      DATA (u(i,5566),i=1,7)/26.,18., 6., 6., 2.80E-02,1.03413E+07,  2./
      DATA (u(i,5567),i=1,7)/26.,18., 6.,10., 2.23E-02,8.86525E+06,  2./
      DATA (u(i,5568),i=1,7)/26.,18., 6., 2., 2.20E-02,8.71080E+06,  2./
      DATA (u(i,5569),i=1,7)/26.,18., 6., 6., 2.08E-02,1.05708E+07,  2./
      DATA (u(i,5570),i=1,7)/26.,18., 6., 2., 1.94E-02,1.04932E+07,  2./
      DATA (u(i,5571),i=1,7)/26.,18., 6., 6., 1.83E-02,1.04822E+07,  2./
      DATA (u(i,5572),i=1,7)/26.,18., 6., 6., 1.79E-02,9.86193E+06,  2./
      DATA (u(i,5573),i=1,7)/26.,18., 6.,10., 1.72E-02,1.04712E+07,  2./
      DATA (u(i,5574),i=1,7)/26.,18., 6., 2., 1.42E-02,1.06157E+07,  2./
      DATA (u(i,5575),i=1,7)/26.,18., 6., 6., 1.09E-02,1.01523E+07,  2./
      DATA (u(i,5576),i=1,7)/26.,18., 6., 2., 9.33E-03,9.76562E+06,  2./
      DATA (u(i,5577),i=1,7)/26.,18., 6., 2., 8.77E-03,1.06952E+07,  2./
      DATA (u(i,5578),i=1,7)/26.,18., 6., 2., 7.34E-03,1.06496E+07,  2./
      DATA (u(i,5579),i=1,7)/26.,18., 6.,10., 6.74E-03,1.04712E+07,  2./
      DATA (u(i,5580),i=1,7)/26.,18., 6.,10., 5.03E-03,9.99001E+06,  2./
      DATA (u(i,5581),i=1,7)/26.,18., 6., 6., 4.01E-03,1.04603E+07,  2./
      DATA (u(i,5582),i=1,7)/26.,18., 6.,10., 3.80E-03,1.02775E+07,  2./
      DATA (u(i,5583),i=1,7)/26.,18., 6., 6., 2.76E-03,1.05485E+07,  2./
      DATA (u(i,5584),i=1,7)/26.,18., 6., 2., 1.63E-03,9.65251E+06,  2./
      DATA (u(i,5585),i=1,7)/26.,18., 6., 2., 1.06E-03,1.04384E+07,  2./
      DATA (u(i,5586),i=1,7)/26.,18., 6., 2., 8.40E-04,1.01420E+07,  2./
      DATA (u(i,5587),i=1,7)/26.,18., 6.,10., 7.56E-04,9.49668E+06,  2./
      DATA (u(i,5588),i=1,7)/26.,18., 6., 2., 6.88E-04,1.06270E+07,  2./
      DATA (u(i,5589),i=1,7)/26.,18., 6., 2., 3.40E-04,8.40336E+06,  2./
      DATA (u(i,5590),i=1,7)/26.,18., 6.,10., 2.93E-04,9.61538E+06,  2./
      DATA (u(i,5591),i=1,7)/26.,18., 6., 2., 2.07E-04,7.79423E+06,  2./
      DATA (u(i,5592),i=1,7)/26.,18., 6.,10., 7.05E-05,1.04167E+07,  2./
      DATA (u(i,5593),i=1,7)/26.,18., 6., 2., 6.84E-05,1.05263E+07,  2./
      DATA (u(i,5594),i=1,7)/26.,18., 6.,10., 1.06E-06,9.75610E+06,  2./
      DATA (u(i,5595),i=1,7)/26.,19., 9.,15., 6.06E+00,7.42942E+06,  2./
      DATA (u(i,5596),i=1,7)/26.,19., 9.,15., 5.49E+00,7.30994E+06,  2./
      DATA (u(i,5597),i=1,7)/26.,19., 9., 9., 4.66E+00,7.32601E+06,  2./
      DATA (u(i,5598),i=1,7)/26.,19., 9.,15., 1.93E+00,7.17360E+06,  2./
      DATA (u(i,5599),i=1,7)/26.,19., 9., 3., 1.68E+00,7.34754E+06,  2./
      DATA (u(i,5600),i=1,7)/26.,19., 9.,15., 1.53E+00,7.68640E+06,  2./
      DATA (u(i,5601),i=1,7)/26.,19., 9.,15., 1.15E+00,9.17431E+06,  2./
      DATA (u(i,5602),i=1,7)/26.,19., 9., 9., 9.79E-01,7.71605E+06,  2./
      DATA (u(i,5603),i=1,7)/26.,19., 9.,15., 9.39E-01,9.30233E+06,  2./
      DATA (u(i,5604),i=1,7)/26.,19., 9.,15., 9.32E-01,9.44287E+06,  2./
      DATA (u(i,5605),i=1,7)/26.,19., 9., 9., 8.61E-01,9.31966E+06,  2./
      DATA (u(i,5606),i=1,7)/26.,19., 9., 9., 7.10E-01,8.18733E+05,  3./
      DATA (u(i,5607),i=1,7)/26.,19., 9., 9., 6.96E-01,7.39645E+06,  2./
      DATA (u(i,5608),i=1,7)/26.,19., 9.,15., 6.77E-01,8.12348E+06,  2./
      DATA (u(i,5609),i=1,7)/26.,19., 9.,15., 5.72E-01,1.00908E+07,  2./
      DATA (u(i,5610),i=1,7)/26.,19., 9.,15., 5.48E-01,6.76590E+06,  2./
      DATA (u(i,5611),i=1,7)/26.,19., 9.,15., 5.33E-01,9.85222E+06,  2./
      DATA (u(i,5612),i=1,7)/26.,19., 9., 9., 4.19E-01,1.02354E+07,  2./
      DATA (u(i,5613),i=1,7)/26.,19., 9., 3., 4.08E-01,7.70416E+06,  2./
      DATA (u(i,5614),i=1,7)/26.,19., 9., 3., 3.85E-01,9.32836E+06,  2./
      DATA (u(i,5615),i=1,7)/26.,19., 9., 3., 3.53E-01,6.66222E+06,  2./
      DATA (u(i,5616),i=1,7)/26.,19., 9.,15., 3.47E-01,1.02249E+07,  2./
      DATA (u(i,5617),i=1,7)/26.,19., 9.,15., 3.34E-01,1.05820E+07,  2./
      DATA (u(i,5618),i=1,7)/26.,19., 9., 9., 3.30E-01,6.91563E+06,  2./
      DATA (u(i,5619),i=1,7)/26.,19., 9., 9., 3.28E-01,9.88142E+06,  2./
      DATA (u(i,5620),i=1,7)/26.,19., 9.,15., 3.03E-01,1.03734E+07,  2./
      DATA (u(i,5621),i=1,7)/26.,19., 9., 9., 2.95E-01,7.96178E+06,  2./
      DATA (u(i,5622),i=1,7)/26.,19., 9.,15., 2.80E-01,1.08814E+07,  2./
      DATA (u(i,5623),i=1,7)/26.,19., 9., 9., 2.58E-01,9.43396E+06,  2./
      DATA (u(i,5624),i=1,7)/26.,19., 9.,15., 2.37E-01,1.03093E+07,  2./
      DATA (u(i,5625),i=1,7)/26.,19., 9.,15., 2.36E-01,1.08342E+07,  2./
      DATA (u(i,5626),i=1,7)/26.,19., 9., 9., 1.82E-01,1.07296E+07,  2./
      DATA (u(i,5627),i=1,7)/26.,19., 9., 3., 1.74E-01,1.02354E+07,  2./
      DATA (u(i,5628),i=1,7)/26.,19., 9., 9., 1.47E-01,1.08460E+07,  2./
      DATA (u(i,5629),i=1,7)/26.,19., 9.,15., 1.44E-01,1.07181E+07,  2./
      DATA (u(i,5630),i=1,7)/26.,19., 9.,15., 1.29E-01,1.10742E+07,  2./
      DATA (u(i,5631),i=1,7)/26.,19., 9., 9., 1.27E-01,8.11688E+06,  2./
      DATA (u(i,5632),i=1,7)/26.,19., 9., 3., 1.21E-01,9.86193E+06,  2./
      DATA (u(i,5633),i=1,7)/26.,19., 9.,15., 1.15E-01,9.10747E+06,  2./
      DATA (u(i,5634),i=1,7)/26.,19., 9., 9., 1.09E-01,1.10254E+07,  2./
      DATA (u(i,5635),i=1,7)/26.,19., 9., 3., 1.05E-01,8.16327E+06,  2./
      DATA (u(i,5636),i=1,7)/26.,19., 9., 9., 9.82E-02,1.03627E+07,  2./
      DATA (u(i,5637),i=1,7)/26.,19., 9.,15., 9.72E-02,1.11607E+07,  2./
      DATA (u(i,5638),i=1,7)/26.,19., 9.,15., 8.65E-02,1.08696E+07,  2./
      DATA (u(i,5639),i=1,7)/26.,19., 9., 9., 8.44E-02,9.25069E+06,  2./
      DATA (u(i,5640),i=1,7)/26.,19., 9., 3., 8.02E-02,1.07296E+07,  2./
      DATA (u(i,5641),i=1,7)/26.,19., 9.,15., 7.64E-02,1.10254E+07,  2./
      DATA (u(i,5642),i=1,7)/26.,19., 9.,15., 7.10E-02,1.11982E+07,  2./
      DATA (u(i,5643),i=1,7)/26.,19., 9.,15., 7.09E-02,1.12108E+07,  2./
      DATA (u(i,5644),i=1,7)/26.,19., 9., 9., 7.02E-02,1.12108E+07,  2./
      DATA (u(i,5645),i=1,7)/26.,19., 9., 9., 6.95E-02,1.12994E+07,  2./
      DATA (u(i,5646),i=1,7)/26.,19., 9., 9., 6.56E-02,1.13507E+07,  2./
      DATA (u(i,5647),i=1,7)/26.,19., 9., 9., 6.53E-02,1.03093E+07,  2./
      DATA (u(i,5648),i=1,7)/26.,19., 9., 3., 6.33E-02,8.96861E+06,  2./
      DATA (u(i,5649),i=1,7)/26.,19., 9., 9., 6.26E-02,8.05802E+06,  2./
      DATA (u(i,5650),i=1,7)/26.,19., 9., 9., 5.84E-02,1.08696E+07,  2./
      DATA (u(i,5651),i=1,7)/26.,19., 9., 3., 5.72E-02,1.08342E+07,  2./
      DATA (u(i,5652),i=1,7)/26.,19., 9.,15., 5.60E-02,1.12994E+07,  2./
      DATA (u(i,5653),i=1,7)/26.,19., 9., 3., 5.04E-02,1.10254E+07,  2./
      DATA (u(i,5654),i=1,7)/26.,19., 9., 9., 4.16E-02,1.13507E+07,  2./
      DATA (u(i,5655),i=1,7)/26.,19., 9.,15., 3.77E-02,9.06618E+06,  2./
      DATA (u(i,5656),i=1,7)/26.,19., 9.,15., 3.63E-02,1.01420E+07,  2./
      DATA (u(i,5657),i=1,7)/26.,19., 9., 9., 3.52E-02,1.02881E+07,  2./
      DATA (u(i,5658),i=1,7)/26.,19., 9., 9., 3.42E-02,1.11607E+07,  2./
      DATA (u(i,5659),i=1,7)/26.,19., 9., 9., 3.35E-02,1.14416E+07,  2./
      DATA (u(i,5660),i=1,7)/26.,19., 9., 3., 3.12E-02,1.12108E+07,  2./
      DATA (u(i,5661),i=1,7)/26.,19., 9., 9., 2.97E-02,1.13636E+07,  2./
      DATA (u(i,5662),i=1,7)/26.,19., 9., 3., 2.75E-02,1.03306E+07,  2./
      DATA (u(i,5663),i=1,7)/26.,19., 9.,15., 2.15E-02,1.11111E+07,  2./
      DATA (u(i,5664),i=1,7)/26.,19., 9., 9., 1.65E-02,9.00901E+06,  2./
      DATA (u(i,5665),i=1,7)/26.,19., 9., 3., 1.37E-02,1.00000E+07,  2./
      DATA (u(i,5666),i=1,7)/26.,19., 9., 3., 1.26E-02,1.05374E+07,  2./
      DATA (u(i,5667),i=1,7)/26.,19., 9.,15., 1.24E-02,1.11982E+07,  2./
      DATA (u(i,5668),i=1,7)/26.,19., 9.,15., 1.14E-02,1.06724E+07,  2./
      DATA (u(i,5669),i=1,7)/26.,19., 9.,15., 1.00E-02,1.09890E+07,  2./
      DATA (u(i,5670),i=1,7)/26.,19., 9., 9., 5.72E-03,1.10988E+07,  2./
      DATA (u(i,5671),i=1,7)/26.,19., 9., 9., 5.21E-03,1.11359E+07,  2./
      DATA (u(i,5672),i=1,7)/26.,19., 9., 9., 4.18E-03,1.01112E+07,  2./
      DATA (u(i,5673),i=1,7)/26.,19., 9., 9., 3.98E-03,8.64304E+06,  2./
      DATA (u(i,5674),i=1,7)/26.,19., 9., 3., 3.71E-03,1.11857E+07,  2./
      DATA (u(i,5675),i=1,7)/26.,19., 9., 3., 2.51E-03,1.10497E+07,  2./
      DATA (u(i,5676),i=1,7)/26.,19., 9.,15., 2.30E-03,1.00000E+07,  2./
      DATA (u(i,5677),i=1,7)/26.,19., 9.,15., 2.04E-03,1.10865E+07,  2./
      DATA (u(i,5678),i=1,7)/26.,19., 9., 3., 2.01E-03,1.12867E+07,  2./
      DATA (u(i,5679),i=1,7)/26.,19., 9., 9., 1.95E-03,1.08225E+07,  2./
      DATA (u(i,5680),i=1,7)/26.,19., 9., 9., 1.59E-03,1.02459E+07,  2./
      DATA (u(i,5681),i=1,7)/26.,19., 9., 9., 1.40E-03,1.10865E+07,  2./
      DATA (u(i,5682),i=1,7)/26.,19., 9.,15., 8.07E-04,1.11359E+07,  2./
      DATA (u(i,5683),i=1,7)/26.,19., 9., 9., 6.92E-04,1.13379E+07,  2./
      DATA (u(i,5684),i=1,7)/26.,19., 9., 9., 6.68E-04,1.09409E+07,  2./
      DATA (u(i,5685),i=1,7)/26.,19., 9.,15., 5.56E-04,7.93651E+06,  2./
      DATA (u(i,5686),i=1,7)/26.,19., 9.,15., 3.12E-04,1.08932E+07,  2./
      DATA (u(i,5687),i=1,7)/26.,19., 9., 3., 2.96E-04,1.08460E+07,  2./
      DATA (u(i,5688),i=1,7)/26.,19., 9., 9., 2.26E-04,1.11359E+07,  2./
      DATA (u(i,5689),i=1,7)/26.,19., 9., 9., 1.10E-04,1.02354E+07,  2./
      DATA (u(i,5690),i=1,7)/26.,19., 9., 9., 3.92E-05,1.12233E+07,  2./
      DATA (u(i,5691),i=1,7)/26.,19., 9.,15., 3.81E-05,1.02459E+07,  2./
      DATA (u(i,5692),i=1,7)/26.,19., 9.,15., 7.13E-06,1.04603E+07,  2./
      DATA (u(i,5693),i=1,7)/26.,19., 9.,15., 4.30E-09,1.01010E+07,  2./
      DATA (u(i,5694),i=1,7)/26.,20., 4.,12., 7.49E+00,7.73395E+06,  2./
      DATA (u(i,5695),i=1,7)/26.,20., 4.,12., 1.53E+00,9.94036E+06,  2./
      DATA (u(i,5696),i=1,7)/26.,20., 4.,12., 1.41E+00,7.81250E+06,  2./
      DATA (u(i,5697),i=1,7)/26.,20., 4.,12., 5.64E-01,1.09529E+07,  2./
      DATA (u(i,5698),i=1,7)/26.,20., 4.,12., 4.50E-01,8.37521E+06,  2./
      DATA (u(i,5699),i=1,7)/26.,20., 4.,12., 4.34E-01,1.01523E+07,  2./
      DATA (u(i,5700),i=1,7)/26.,20., 4.,12., 3.99E-01,7.23589E+06,  2./
      DATA (u(i,5701),i=1,7)/26.,20., 4.,12., 3.90E-01,6.87663E+05,102./
      DATA (u(i,5702),i=1,7)/26.,20., 4.,12., 2.97E-01,1.14943E+07,  2./
      DATA (u(i,5703),i=1,7)/26.,20., 4.,12., 2.47E-01,1.07643E+07,  2./
      DATA (u(i,5704),i=1,7)/26.,20., 4.,12., 1.91E-01,1.18203E+07,  2./
      DATA (u(i,5705),i=1,7)/26.,20., 4.,12., 1.73E-01,1.11982E+07,  2./
      DATA (u(i,5706),i=1,7)/26.,20., 4.,12., 1.11E-01,8.22368E+06,  2./
      DATA (u(i,5707),i=1,7)/26.,20., 4.,12., 1.08E-01,1.20337E+07,  2./
      DATA (u(i,5708),i=1,7)/26.,20., 4.,12., 9.44E-02,1.17647E+07,  2./
      DATA (u(i,5709),i=1,7)/26.,20., 4.,12., 7.48E-02,1.21803E+07,  2./
      DATA (u(i,5710),i=1,7)/26.,20., 4.,12., 7.21E-02,8.14996E+06,  2./
      DATA (u(i,5711),i=1,7)/26.,20., 4.,12., 6.45E-02,9.74659E+06,  2./
      DATA (u(i,5712),i=1,7)/26.,20., 4.,12., 6.06E-02,1.18483E+07,  2./
      DATA (u(i,5713),i=1,7)/26.,20., 4.,12., 5.51E-02,1.20919E+07,  2./
      DATA (u(i,5714),i=1,7)/26.,20., 4.,12., 5.29E-02,1.22850E+07,  2./
      DATA (u(i,5715),i=1,7)/26.,20., 4.,12., 4.15E-02,9.16590E+06,  2./
      DATA (u(i,5716),i=1,7)/26.,20., 4.,12., 1.93E-02,1.14025E+07,  2./
      DATA (u(i,5717),i=1,7)/26.,20., 4.,12., 1.52E-02,8.71840E+06,  2./
      DATA (u(i,5718),i=1,7)/26.,20., 4.,12., 1.35E-02,1.17925E+07,  2./
      DATA (u(i,5719),i=1,7)/26.,20., 4.,12., 1.12E-02,1.14416E+07,  2./
      DATA (u(i,5720),i=1,7)/26.,20., 4.,12., 7.89E-03,1.12360E+07,  2./
      DATA (u(i,5721),i=1,7)/26.,20., 4.,12., 6.53E-03,1.08578E+07,  2./
      DATA (u(i,5722),i=1,7)/26.,20., 4.,12., 3.40E-03,1.20192E+07,  2./
      DATA (u(i,5723),i=1,7)/26.,20., 4.,12., 2.95E-03,1.21654E+07,  2./
      DATA (u(i,5724),i=1,7)/26.,20., 4.,12., 2.57E-03,1.05374E+07,  2./
      DATA (u(i,5725),i=1,7)/26.,20., 4.,12., 2.06E-03,1.22699E+07,  2./
      DATA (u(i,5726),i=1,7)/26.,20., 4.,12., 1.70E-03,1.05932E+07,  2./
      DATA (u(i,5727),i=1,7)/26.,20., 4.,12., 1.29E-03,1.04822E+07,  2./
      DATA (u(i,5728),i=1,7)/26.,20., 4.,12., 8.83E-04,1.21212E+07,  2./
      DATA (u(i,5729),i=1,7)/26.,20., 4.,12., 7.73E-04,1.21359E+07,  2./
      DATA (u(i,5730),i=1,7)/26.,20., 4.,12., 7.04E-04,1.16144E+07,  2./
      DATA (u(i,5731),i=1,7)/26.,20., 4.,12., 3.20E-04,1.15741E+07,  2./
      DATA (u(i,5732),i=1,7)/26.,20., 4.,12., 1.51E-04,1.21654E+07,  2./
      DATA (u(i,5733),i=1,7)/26.,20., 4.,12., 3.62E-05,1.15607E+07,  2./
      DATA (u(i,5734),i=1,7)/26.,21., 9.,15., 8.63E+00,8.04505E+06, 63./
      DATA (u(i,5735),i=1,7)/26.,21., 9., 9., 2.82E+00,8.05153E+06, 62./
      DATA (u(i,5736),i=1,7)/26.,21., 5., 7., 9.50E-01,8.02000E+06, 64./
      DATA (u(i,5737),i=1,7)/26.,21., 9.,15., 2.14E+00,8.19672E+06,  2./
      DATA (u(i,5738),i=1,7)/26.,21., 9.,15., 1.69E+00,1.04603E+07,  2./
      DATA (u(i,5739),i=1,7)/26.,21., 9., 9., 1.27E+00,8.23045E+06,  2./
      DATA (u(i,5740),i=1,7)/26.,21., 9.,15., 6.38E-01,1.15741E+07,  2./
      DATA (u(i,5741),i=1,7)/26.,21., 9.,15., 5.96E-01,1.07181E+07,  2./
      DATA (u(i,5742),i=1,7)/26.,21., 9., 9., 5.50E-01,1.04712E+07,  2./
      DATA (u(i,5743),i=1,7)/26.,21., 9., 9., 4.97E-01,7.62195E+06,  2./
      DATA (u(i,5744),i=1,7)/26.,21., 9., 3., 4.31E-01,8.10373E+06,  2./
      DATA (u(i,5745),i=1,7)/26.,21., 9., 3., 4.21E-01,9.10747E+05, 99./
      DATA (u(i,5746),i=1,7)/26.,21., 9.,15., 4.09E-01,8.59845E+06,  2./
      DATA (u(i,5747),i=1,7)/26.,21., 9., 9., 3.68E-01,7.11693E+05,101./
      DATA (u(i,5748),i=1,7)/26.,21., 9., 9., 3.50E-01,1.07296E+07,  2./
      DATA (u(i,5749),i=1,7)/26.,21., 9.,15., 3.34E-01,6.02991E+05,104./
      DATA (u(i,5750),i=1,7)/26.,21., 9.,15., 3.15E-01,8.43882E+06,  2./
      DATA (u(i,5751),i=1,7)/26.,21., 9.,15., 3.02E-01,1.21803E+07,  2./
      DATA (u(i,5752),i=1,7)/26.,21., 9.,15., 2.39E-01,1.18624E+07,  2./
      DATA (u(i,5753),i=1,7)/26.,21., 9.,15., 2.20E-01,1.11607E+07,  2./
      DATA (u(i,5754),i=1,7)/26.,21., 9., 9., 2.10E-01,8.62813E+06,  2./
      DATA (u(i,5755),i=1,7)/26.,21., 9., 9., 2.08E-01,1.15741E+07,  2./
      DATA (u(i,5756),i=1,7)/26.,21., 9.,15., 1.85E-01,1.25313E+07,  2./
      DATA (u(i,5757),i=1,7)/26.,21., 9., 9., 1.64E-01,8.59106E+06,  2./
      DATA (u(i,5758),i=1,7)/26.,21., 9., 3., 1.56E-01,8.62813E+06,  2./
      DATA (u(i,5759),i=1,7)/26.,21., 9., 9., 1.46E-01,1.11607E+07,  2./
      DATA (u(i,5760),i=1,7)/26.,21., 9., 9., 1.42E-01,1.18624E+07,  2./
      DATA (u(i,5761),i=1,7)/26.,21., 9.,15., 1.24E-01,1.24844E+07,  2./
      DATA (u(i,5762),i=1,7)/26.,21., 9., 9., 1.20E-01,8.47458E+06,  2./
      DATA (u(i,5763),i=1,7)/26.,21., 9.,15., 1.18E-01,1.27714E+07,  2./
      DATA (u(i,5764),i=1,7)/26.,21., 9., 3., 1.15E-01,1.06838E+07,  2./
      DATA (u(i,5765),i=1,7)/26.,21., 9.,15., 1.05E-01,1.29366E+07,  2./
      DATA (u(i,5766),i=1,7)/26.,21., 9., 9., 1.01E-01,1.21803E+07,  2./
      DATA (u(i,5767),i=1,7)/26.,21., 9.,15., 9.20E-02,1.23153E+07,  2./
      DATA (u(i,5768),i=1,7)/26.,21., 9., 9., 8.76E-02,1.02987E+07,  2./
      DATA (u(i,5769),i=1,7)/26.,21., 9.,15., 7.54E-02,1.28535E+07,  2./
      DATA (u(i,5770),i=1,7)/26.,21., 9., 3., 7.18E-02,8.79508E+06,  2./
      DATA (u(i,5771),i=1,7)/26.,21., 9., 9., 6.98E-02,1.24844E+07,  2./
      DATA (u(i,5772),i=1,7)/26.,21., 9., 9., 6.13E-02,1.23153E+07,  2./
      DATA (u(i,5773),i=1,7)/26.,21., 9., 9., 6.06E-02,1.25313E+07,  2./
      DATA (u(i,5774),i=1,7)/26.,21., 9.,15., 6.03E-02,9.25069E+06,  2./
      DATA (u(i,5775),i=1,7)/26.,21., 9., 3., 5.69E-02,1.11732E+07,  2./
      DATA (u(i,5776),i=1,7)/26.,21., 9.,15., 5.48E-02,1.30548E+07,  2./
      DATA (u(i,5777),i=1,7)/26.,21., 9., 3., 4.85E-02,1.18483E+07,  2./
      DATA (u(i,5778),i=1,7)/26.,21., 9., 9., 4.33E-02,1.28535E+07,  2./
      DATA (u(i,5779),i=1,7)/26.,21., 9., 9., 3.81E-02,1.27714E+07,  2./
      DATA (u(i,5780),i=1,7)/26.,21., 9.,15., 3.36E-02,8.85740E+06,  2./
      DATA (u(i,5781),i=1,7)/26.,21., 9.,15., 3.25E-02,9.10747E+06,  2./
      DATA (u(i,5782),i=1,7)/26.,21., 9., 9., 3.14E-02,1.29366E+07,  2./
      DATA (u(i,5783),i=1,7)/26.,21., 9.,15., 2.90E-02,1.21803E+07,  2./
      DATA (u(i,5784),i=1,7)/26.,21., 9., 9., 2.55E-02,1.14943E+07,  2./
      DATA (u(i,5785),i=1,7)/26.,21., 9., 3., 2.53E-02,1.24688E+07,  2./
      DATA (u(i,5786),i=1,7)/26.,21., 9., 3., 2.17E-02,1.23305E+07,  2./
      DATA (u(i,5787),i=1,7)/26.,21., 9.,15., 2.06E-02,9.39850E+06,  2./
      DATA (u(i,5788),i=1,7)/26.,21., 9., 9., 1.89E-02,1.29366E+07,  2./
      DATA (u(i,5789),i=1,7)/26.,21., 9., 9., 1.80E-02,1.30548E+07,  2./
      DATA (u(i,5790),i=1,7)/26.,21., 9.,15., 1.78E-02,1.29366E+07,  2./
      DATA (u(i,5791),i=1,7)/26.,21., 9., 9., 1.76E-02,9.36330E+06,  2./
      DATA (u(i,5792),i=1,7)/26.,21., 9., 9., 1.70E-02,9.27644E+06,  2./
      DATA (u(i,5793),i=1,7)/26.,21., 9., 9., 1.67E-02,1.21359E+07,  2./
      DATA (u(i,5794),i=1,7)/26.,21., 9., 9., 1.47E-02,9.00090E+06,  2./
      DATA (u(i,5795),i=1,7)/26.,21., 9., 3., 1.44E-02,1.28370E+07,  2./
      DATA (u(i,5796),i=1,7)/26.,21., 9.,15., 1.24E-02,1.15075E+07,  2./
      DATA (u(i,5797),i=1,7)/26.,21., 9.,15., 1.23E-02,1.29032E+07,  2./
      DATA (u(i,5798),i=1,7)/26.,21., 9., 3., 1.20E-02,1.29366E+07,  2./
      DATA (u(i,5799),i=1,7)/26.,21., 9., 9., 1.03E-02,1.25156E+07,  2./
      DATA (u(i,5800),i=1,7)/26.,21., 9., 3., 1.02E-02,9.30233E+06,  2./
      DATA (u(i,5801),i=1,7)/26.,21., 9.,15., 1.02E-02,1.16414E+07,  2./
      DATA (u(i,5802),i=1,7)/26.,21., 9., 3., 9.96E-03,1.30719E+07,  2./
      DATA (u(i,5803),i=1,7)/26.,21., 9., 9., 9.61E-03,1.29199E+07,  2./
      DATA (u(i,5804),i=1,7)/26.,21., 9.,15., 9.22E-03,1.17925E+07,  2./
      DATA (u(i,5805),i=1,7)/26.,21., 9.,15., 8.22E-03,1.09649E+07,  2./
      DATA (u(i,5806),i=1,7)/26.,21., 9., 3., 7.61E-03,1.33156E+07,  2./
      DATA (u(i,5807),i=1,7)/26.,21., 9., 9., 6.69E-03,1.16550E+07,  2./
      DATA (u(i,5808),i=1,7)/26.,21., 9., 9., 6.36E-03,1.11235E+07,  2./
      DATA (u(i,5809),i=1,7)/26.,21., 9., 3., 6.33E-03,1.32450E+07,  2./
      DATA (u(i,5810),i=1,7)/26.,21., 9.,15., 6.05E-03,1.25945E+07,  2./
      DATA (u(i,5811),i=1,7)/26.,21., 9., 9., 5.95E-03,1.27551E+07,  2./
      DATA (u(i,5812),i=1,7)/26.,21., 9., 9., 5.77E-03,1.21803E+07,  2./
      DATA (u(i,5813),i=1,7)/26.,21., 9., 3., 4.98E-03,1.33511E+07,  2./
      DATA (u(i,5814),i=1,7)/26.,21., 9., 9., 4.45E-03,1.28866E+07,  2./
      DATA (u(i,5815),i=1,7)/26.,21., 9., 9., 4.35E-03,1.17786E+07,  2./
      DATA (u(i,5816),i=1,7)/26.,21., 9.,15., 4.25E-03,1.27389E+07,  2./
      DATA (u(i,5817),i=1,7)/26.,21., 9., 9., 3.89E-03,1.27551E+07,  2./
      DATA (u(i,5818),i=1,7)/26.,21., 9., 3., 3.56E-03,1.16550E+07,  2./
      DATA (u(i,5819),i=1,7)/26.,21., 9., 9., 3.49E-03,1.21212E+07,  2./
      DATA (u(i,5820),i=1,7)/26.,21., 9., 3., 2.15E-03,1.27551E+07,  2./
      DATA (u(i,5821),i=1,7)/26.,21., 9., 9., 2.13E-03,1.30378E+07,  2./
      DATA (u(i,5822),i=1,7)/26.,21., 9., 9., 1.99E-03,1.28205E+07,  2./
      DATA (u(i,5823),i=1,7)/26.,21., 9., 9., 1.88E-03,1.09769E+07,  2./
      DATA (u(i,5824),i=1,7)/26.,21., 9., 9., 1.20E-03,1.27389E+07,  2./
      DATA (u(i,5825),i=1,7)/26.,21., 9.,15., 1.20E-03,1.10865E+07,  2./
      DATA (u(i,5826),i=1,7)/26.,21., 9.,15., 1.11E-03,1.08225E+07,  2./
      DATA (u(i,5827),i=1,7)/26.,21., 9., 3., 1.07E-03,1.25313E+07,  2./
      DATA (u(i,5828),i=1,7)/26.,21., 9., 3., 5.84E-04,1.33511E+07,  2./
      DATA (u(i,5829),i=1,7)/26.,21., 9., 9., 5.78E-04,1.22850E+07,  2./
      DATA (u(i,5830),i=1,7)/26.,21., 9.,15., 4.86E-04,1.27389E+07,  2./
      DATA (u(i,5831),i=1,7)/26.,21., 9.,15., 4.65E-04,1.19190E+07,  2./
      DATA (u(i,5832),i=1,7)/26.,21., 9., 9., 4.64E-04,1.16279E+07,  2./
      DATA (u(i,5833),i=1,7)/26.,21., 9.,15., 3.88E-04,1.12867E+07,  2./
      DATA (u(i,5834),i=1,7)/26.,21., 9.,15., 3.85E-04,1.28700E+07,  2./
      DATA (u(i,5835),i=1,7)/26.,21., 9., 9., 3.70E-04,1.10988E+07,  2./
      DATA (u(i,5836),i=1,7)/26.,21., 9.,15., 3.29E-04,1.14811E+07,  2./
      DATA (u(i,5837),i=1,7)/26.,21., 9., 3., 2.87E-04,1.13507E+07,  2./
      DATA (u(i,5838),i=1,7)/26.,21., 9.,15., 1.24E-04,1.27714E+07,  2./
      DATA (u(i,5839),i=1,7)/26.,21., 9.,15., 9.90E-05,1.23762E+07,  2./
      DATA (u(i,5840),i=1,7)/26.,21., 9., 9., 9.39E-05,1.29032E+07,  2./
      DATA (u(i,5841),i=1,7)/26.,21., 9., 9., 8.48E-05,1.27714E+07,  2./
      DATA (u(i,5842),i=1,7)/26.,21., 9.,15., 7.09E-05,1.21212E+07,  2./
      DATA (u(i,5843),i=1,7)/26.,21., 9.,15., 4.04E-05,1.25000E+07,  2./
      DATA (u(i,5844),i=1,7)/26.,21., 9.,15., 2.50E-05,1.26743E+07,  2./
      DATA (u(i,5845),i=1,7)/26.,21., 9.,15., 2.29E-05,1.29702E+07,  2./
      DATA (u(i,5846),i=1,7)/26.,21., 9., 3., 4.27E-06,1.31579E+07,  2./
      DATA (u(i,5847),i=1,7)/26.,21., 9.,15., 5.09E-07,1.27714E+07,  2./
      DATA (u(i,5848),i=1,7)/26.,22., 6.,10., 4.02E+00,8.36820E+06, 59./
      DATA (u(i,5849),i=1,7)/26.,22., 6.,10., 1.94E+00,8.61326E+06,  2./
      DATA (u(i,5850),i=1,7)/26.,22., 6., 6., 9.51E-01,8.51789E+06,  2./
      DATA (u(i,5851),i=1,7)/26.,22., 6.,10., 7.47E-01,1.10011E+07,  2./
      DATA (u(i,5852),i=1,7)/26.,22., 6., 6., 5.08E-01,7.80457E+05,100./
      DATA (u(i,5853),i=1,7)/26.,22., 6.,10., 4.61E-01,1.13122E+07,  2./
      DATA (u(i,5854),i=1,7)/26.,22., 6., 2., 4.01E-01,8.66551E+06,  2./
      DATA (u(i,5855),i=1,7)/26.,22., 6., 6., 3.20E-01,8.85740E+06,  2./
      DATA (u(i,5856),i=1,7)/26.,22., 6.,10., 2.77E-01,1.22249E+07,  2./
      DATA (u(i,5857),i=1,7)/26.,22., 6., 6., 2.55E-01,1.12740E+07,  2./
      DATA (u(i,5858),i=1,7)/26.,22., 6.,10., 2.02E-01,5.75573E+05,105./
      DATA (u(i,5859),i=1,7)/26.,22., 6.,10., 1.84E-01,1.25471E+07,  2./
      DATA (u(i,5860),i=1,7)/26.,22., 6.,10., 1.24E-01,1.28700E+07,  2./
      DATA (u(i,5861),i=1,7)/26.,22., 6., 2., 1.20E-01,8.02568E+06,  2./
      DATA (u(i,5862),i=1,7)/26.,22., 6., 6., 1.18E-01,9.04159E+06,  2./
      DATA (u(i,5863),i=1,7)/26.,22., 6.,10., 1.16E-01,8.86525E+06,  2./
      DATA (u(i,5864),i=1,7)/26.,22., 6., 6., 1.08E-01,1.25313E+07,  2./
      DATA (u(i,5865),i=1,7)/26.,22., 6., 2., 1.04E-01,7.41290E+05,  3./
      DATA (u(i,5866),i=1,7)/26.,22., 6.,10., 9.88E-02,1.16009E+07,  2./
      DATA (u(i,5867),i=1,7)/26.,22., 6., 6., 9.46E-02,1.16009E+07,  2./
      DATA (u(i,5868),i=1,7)/26.,22., 6., 2., 9.03E-02,1.13250E+07,  2./
      DATA (u(i,5869),i=1,7)/26.,22., 6.,10., 8.10E-02,1.32802E+07,  2./
      DATA (u(i,5870),i=1,7)/26.,22., 6.,10., 6.78E-02,1.28370E+07,  2./
      DATA (u(i,5871),i=1,7)/26.,22., 6.,10., 6.67E-02,1.32100E+07,  2./
      DATA (u(i,5872),i=1,7)/26.,22., 6., 6., 5.64E-02,1.31926E+07,  2./
      DATA (u(i,5873),i=1,7)/26.,22., 6.,10., 5.59E-02,1.36054E+07,  2./
      DATA (u(i,5874),i=1,7)/26.,22., 6.,10., 5.42E-02,9.39850E+06,  2./
      DATA (u(i,5875),i=1,7)/26.,22., 6.,10., 4.04E-02,1.35318E+07,  2./
      DATA (u(i,5876),i=1,7)/26.,22., 6.,10., 3.84E-02,9.36330E+06,  2./
      DATA (u(i,5877),i=1,7)/26.,22., 6., 6., 3.69E-02,1.28370E+07,  2./
      DATA (u(i,5878),i=1,7)/26.,22., 6., 2., 3.60E-02,1.25471E+07,  2./
      DATA (u(i,5879),i=1,7)/26.,22., 6., 6., 3.55E-02,1.36054E+07,  2./
      DATA (u(i,5880),i=1,7)/26.,22., 6.,10., 3.55E-02,9.08265E+06,  2./
      DATA (u(i,5881),i=1,7)/26.,22., 6.,10., 3.41E-02,1.35135E+07,  2./
      DATA (u(i,5882),i=1,7)/26.,22., 6.,10., 3.37E-02,1.36986E+07,  2./
      DATA (u(i,5883),i=1,7)/26.,22., 6., 2., 3.17E-02,8.91266E+06,  2./
      DATA (u(i,5884),i=1,7)/26.,22., 6.,10., 2.80E-02,1.32100E+07,  2./
      DATA (u(i,5885),i=1,7)/26.,22., 6., 6., 2.71E-02,9.44287E+06,  2./
      DATA (u(i,5886),i=1,7)/26.,22., 6., 2., 2.43E-02,1.16144E+07,  2./
      DATA (u(i,5887),i=1,7)/26.,22., 6.,10., 2.43E-02,1.38313E+07,  2./
      DATA (u(i,5888),i=1,7)/26.,22., 6., 2., 2.31E-02,1.08696E+07,  2./
      DATA (u(i,5889),i=1,7)/26.,22., 6.,10., 2.03E-02,1.19332E+07,  2./
      DATA (u(i,5890),i=1,7)/26.,22., 6., 6., 1.93E-02,1.38696E+07,  2./
      DATA (u(i,5891),i=1,7)/26.,22., 6., 2., 1.76E-02,1.32100E+07,  2./
      DATA (u(i,5892),i=1,7)/26.,22., 6., 6., 1.73E-02,1.35135E+07,  2./
      DATA (u(i,5893),i=1,7)/26.,22., 6., 6., 1.51E-02,1.40449E+07,  2./
      DATA (u(i,5894),i=1,7)/26.,22., 6.,10., 1.48E-02,1.31234E+07,  2./
      DATA (u(i,5895),i=1,7)/26.,22., 6., 2., 1.39E-02,1.28205E+07,  2./
      DATA (u(i,5896),i=1,7)/26.,22., 6., 6., 1.30E-02,9.25069E+06,  2./
      DATA (u(i,5897),i=1,7)/26.,22., 6., 6., 1.07E-02,1.39082E+07,  2./
      DATA (u(i,5898),i=1,7)/26.,22., 6., 2., 1.05E-02,1.36054E+07,  2./
      DATA (u(i,5899),i=1,7)/26.,22., 6.,10., 9.04E-03,9.61538E+06,  2./
      DATA (u(i,5900),i=1,7)/26.,22., 6., 2., 7.98E-03,1.21507E+07,  2./
      DATA (u(i,5901),i=1,7)/26.,22., 6., 6., 7.41E-03,1.41643E+07,  2./
      DATA (u(i,5902),i=1,7)/26.,22., 6., 6., 7.36E-03,1.20192E+07,  2./
      DATA (u(i,5903),i=1,7)/26.,22., 6., 2., 6.65E-03,1.35135E+07,  2./
      DATA (u(i,5904),i=1,7)/26.,22., 6., 2., 5.97E-03,9.30233E+06,  2./
      DATA (u(i,5905),i=1,7)/26.,22., 6., 2., 5.84E-03,9.46074E+06,  2./
      DATA (u(i,5906),i=1,7)/26.,22., 6.,10., 5.80E-03,1.20048E+07,  2./
      DATA (u(i,5907),i=1,7)/26.,22., 6., 6., 5.63E-03,1.18906E+07,  2./
      DATA (u(i,5908),i=1,7)/26.,22., 6.,10., 5.44E-03,1.22249E+07,  2./
      DATA (u(i,5909),i=1,7)/26.,22., 6.,10., 5.39E-03,1.37741E+07,  2./
      DATA (u(i,5910),i=1,7)/26.,22., 6., 6., 4.01E-03,1.31062E+07,  2./
      DATA (u(i,5911),i=1,7)/26.,22., 6., 6., 3.62E-03,1.38696E+07,  2./
      DATA (u(i,5912),i=1,7)/26.,22., 6.,10., 3.48E-03,1.34409E+07,  2./
      DATA (u(i,5913),i=1,7)/26.,22., 6., 2., 3.43E-03,1.32450E+07,  2./
      DATA (u(i,5914),i=1,7)/26.,22., 6., 6., 3.01E-03,1.32100E+07,  2./
      DATA (u(i,5915),i=1,7)/26.,22., 6., 2., 2.55E-03,1.20192E+07,  2./
      DATA (u(i,5916),i=1,7)/26.,22., 6., 2., 1.91E-03,1.28535E+07,  2./
      DATA (u(i,5917),i=1,7)/26.,22., 6., 2., 1.79E-03,1.35318E+07,  2./
      DATA (u(i,5918),i=1,7)/26.,22., 6., 6., 1.58E-03,1.37552E+07,  2./
      DATA (u(i,5919),i=1,7)/26.,22., 6.,10., 1.47E-03,1.13895E+07,  2./
      DATA (u(i,5920),i=1,7)/26.,22., 6.,10., 1.45E-03,1.28866E+07,  2./
      DATA (u(i,5921),i=1,7)/26.,22., 6., 2., 1.43E-03,1.32100E+07,  2./
      DATA (u(i,5922),i=1,7)/26.,22., 6., 6., 1.41E-03,1.41443E+07,  2./
      DATA (u(i,5923),i=1,7)/26.,22., 6., 2., 1.11E-03,1.36986E+07,  2./
      DATA (u(i,5924),i=1,7)/26.,22., 6., 6., 9.63E-04,1.17786E+07,  2./
      DATA (u(i,5925),i=1,7)/26.,22., 6., 2., 8.76E-04,1.38122E+07,  2./
      DATA (u(i,5926),i=1,7)/26.,22., 6.,10., 5.40E-04,1.25786E+07,  2./
      DATA (u(i,5927),i=1,7)/26.,22., 6., 6., 5.08E-04,1.30378E+07,  2./
      DATA (u(i,5928),i=1,7)/26.,22., 6.,10., 3.38E-04,1.38313E+07,  2./
      DATA (u(i,5929),i=1,7)/26.,22., 6., 6., 2.87E-04,1.41243E+07,  2./
      DATA (u(i,5930),i=1,7)/26.,22., 6.,10., 2.03E-04,1.36240E+07,  2./
      DATA (u(i,5931),i=1,7)/26.,22., 6.,10., 1.52E-04,1.16959E+07,  2./
      DATA (u(i,5932),i=1,7)/26.,22., 6.,10., 1.29E-04,1.32275E+07,  2./
      DATA (u(i,5933),i=1,7)/26.,22., 6., 2., 9.42E-05,1.21065E+07,  2./
      DATA (u(i,5934),i=1,7)/26.,22., 6.,10., 8.34E-05,1.35318E+07,  2./
      DATA (u(i,5935),i=1,7)/26.,22., 6., 2., 6.46E-05,1.33690E+07,  2./
      DATA (u(i,5936),i=1,7)/26.,22., 6., 6., 1.98E-05,1.37174E+07,  2./
      DATA (u(i,5937),i=1,7)/26.,22., 6.,10., 1.78E-05,1.18765E+07,  2./
      DATA (u(i,5938),i=1,7)/26.,22., 6.,10., 4.98E-07,1.31406E+07,  2./
      DATA (u(i,5939),i=1,7)/26.,22., 6.,10., 6.43E-09,1.32275E+07,  2./
      DATA (u(i,5940),i=1,7)/26.,23., 1., 3., 6.84E-01,8.96057E+06, 58./
      DATA (u(i,5941),i=1,7)/26.,23., 1., 3., 1.77E-01,1.18906E+07,  2./
      DATA (u(i,5942),i=1,7)/26.,23., 1., 3., 1.32E-01,6.53253E+05,103./
      DATA (u(i,5943),i=1,7)/26.,23., 1., 3., 7.25E-02,1.32275E+07,  2./
      DATA (u(i,5944),i=1,7)/26.,23., 1., 3., 4.24E-02,9.29368E+06,  2./
      DATA (u(i,5945),i=1,7)/26.,23., 1., 3., 3.68E-02,1.39470E+07,  2./
      DATA (u(i,5946),i=1,7)/26.,23., 1., 3., 3.21E-02,9.56938E+06,  2./
      DATA (u(i,5947),i=1,7)/26.,23., 1., 3., 1.97E-02,1.43885E+07,  2./
      DATA (u(i,5948),i=1,7)/26.,23., 1., 3., 1.44E-02,1.46628E+07,  2./
      DATA (u(i,5949),i=1,7)/26.,23., 1., 3., 9.94E-03,1.23457E+07,  2./
      DATA (u(i,5950),i=1,7)/26.,23., 1., 3., 9.55E-03,1.48588E+07,  2./
      DATA (u(i,5951),i=1,7)/26.,23., 1., 3., 7.12E-03,1.49925E+07,  2./
      DATA (u(i,5952),i=1,7)/26.,23., 1., 3., 5.13E-03,1.36426E+07,  2./
      DATA (u(i,5953),i=1,7)/26.,23., 1., 3., 4.47E-03,1.43472E+07,  2./
      DATA (u(i,5954),i=1,7)/26.,23., 1., 3., 1.58E-03,1.47710E+07,  2./
      DATA (u(i,5955),i=1,7)/26.,23., 1., 3., 6.05E-04,1.43062E+07,  2./
      DATA (u(i,5956),i=1,7)/26.,23., 1., 3., 4.33E-04,1.22249E+07,  2./
      DATA (u(i,5957),i=1,7)/26.,23., 1., 3., 6.15E-05,1.35870E+07,  2./
      DATA (u(i,5958),i=1,7)/26.,23., 1., 3., 2.52E-05,1.47493E+07,  2./
      DATA (u(i,5959),i=1,7)/26.,24., 2., 6., 1.91E-01,1.23609E+07, 50./
      DATA (u(i,5960),i=1,7)/26.,24., 2., 6., 7.89E-02,1.37931E+07, 18./
      DATA (u(i,5961),i=1,7)/26.,24., 2., 6., 4.10E-02,1.45560E+07, 18./
      DATA (u(i,5962),i=1,7)/26.,24., 2., 6., 2.42E-02,1.50376E+07, 18./
      DATA (u(i,5963),i=1,7)/26.,24., 2., 6., 1.56E-02,1.53374E+07, 18./
      DATA (u(i,5964),i=1,7)/26.,24., 2., 6., 1.07E-02,1.55280E+07, 18./
      DATA (u(i,5965),i=1,7)/26.,24., 2., 6., 7.63E-03,1.56986E+07, 18./
      DATA (u(i,5966),i=1,7)/26.,24., 2., 6., 1.31E+00,5.38830E+07, 32./
      DATA (u(i,5967),i=1,7)/26.,25., 1., 3.,-2.12E+08,5.35271E+07, 33./
      DATA (u(i,5968),i=1,7)/26.,25., 1., 3., 6.87E-02,5.37850E+07, 30./
      DATA (u(i,5969),i=1,7)/26.,25., 1., 3., 7.91E-01,5.40474E+07, 29./
      DATA (u(i,5970),i=1,7)/26.,25., 1., 3., 1.55E-01,6.28931E+07, 27./
      DATA (u(i,5971),i=1,7)/26.,25., 1., 3., 5.74E-02,6.62252E+07, 26./
      DATA (u(i,5972),i=1,7)/26.,25., 1., 3., 2.76E-02,6.80272E+07, 13./
      DATA (u(i,5973),i=1,7)/26.,25., 1., 3., 1.55E-02,6.84932E+07, 13./
      DATA (u(i,5974),i=1,7)/26.,25., 1., 3., 9.58E-03,6.94444E+07, 13./
      DATA (u(i,5975),i=1,7)/26.,25., 1., 3., 6.34E-03,6.94444E+07, 13./
      DATA (u(i,5976),i=1,7)/26.,25., 1., 3., 4.42E-03,6.99301E+07, 13./
      DATA (u(i,5977),i=1,7)/26.,25., 1., 3., 3.20E-03,6.99301E+07, 13./
      DATA (u(i,5978),i=1,7)/26.,26., 2., 2.,-3.76E+06,5.60759E+07, 23./
      DATA (u(i,5979),i=1,7)/26.,26., 2., 6., 8.32E-01,5.55556E+07, 28./
      DATA (u(i,5980),i=1,7)/26.,26., 2., 6., 1.58E-01,6.57895E+07,  5./
      DATA (u(i,5981),i=1,7)/26.,26., 2., 6., 5.80E-02,6.94444E+07,  6./
      DATA (u(i,5982),i=1,7)/26.,26., 2., 6., 2.79E-02,7.14286E+07,  7./
      DATA (u(i,5983),i=1,7)/26.,26., 2., 6., 1.56E-02,7.19424E+07,  8./
      DATA (u(i,5984),i=1,7)/26.,26., 2., 6., 9.63E-03,7.24638E+07,  9./
      DATA (u(i,5985),i=1,7)/26.,26., 2., 6., 6.37E-03,7.29927E+07,  9./
      DATA (u(i,5986),i=1,7)/26.,26., 2., 6., 4.43E-03,7.29927E+07,  9./
      DATA (u(i,5987),i=1,7)/26.,26., 2., 6., 3.21E-03,7.35294E+07,  9./
      DATA (u(i,5988),i=1,7)/15., 1., 4.,12., 1.23E+00,5.61899E+04,  1./
      DATA (u(i,5989),i=1,7)/15., 1., 4.,12., 1.97E-01,5.96426E+04,  1./
      DATA (u(i,5990),i=1,7)/15., 1., 4.,12., 1.15E-01,7.26574E+04,  1./
      DATA (u(i,5991),i=1,7)/15., 1., 4.,12., 5.55E-01,7.24607E+04,  1./
      DATA (u(i,5992),i=1,7)/15., 1., 4., 6., 2.82E-02,7.58332E+04,  1./
      DATA (u(i,5993),i=1,7)/15., 2., 9.,15., 6.82E-02,6.49688E+04,  3./
      DATA (u(i,5994),i=1,7)/15., 2., 9., 9., 1.55E-01,7.64711E+04,  3./
      DATA (u(i,5995),i=1,7)/15., 2., 9., 9., 2.12E+00,8.66236E+04,  2./
      DATA (u(i,5996),i=1,7)/15., 2., 9., 9., 5.05E+00,1.03391E+05,  3./
      DATA (u(i,5997),i=1,7)/15., 2., 9.,15., 1.12E+01,1.03753E+05,  3./
      DATA (u(i,5998),i=1,7)/15., 3., 6.,10., 1.51E-01,7.45615E+04,  3./
      DATA (u(i,5999),i=1,7)/15., 3., 6., 2., 6.68E-01,9.98277E+04,  3./
      DATA (u(i,6000),i=1,7)/15., 3., 6., 6., 3.64E+00,1.08915E+05,  3./
      DATA (u(i,6001),i=1,7)/15., 4., 1., 3., 6.05E-05,6.81465E+04,  3./
      DATA (u(i,6002),i=1,7)/15., 4., 1., 3., 1.16E+00,1.05190E+05,  3./
      DATA (u(i,6003),i=1,7)/15., 4., 1., 3., 1.00E-01,2.57520E+05,  2./
      DATA (u(i,6004),i=1,7)/15., 5., 2., 6., 1.42E+00,8.91821E+04,  3./
      DATA (u(i,6005),i=1,7)/15., 5., 2., 6., 1.10E-01,3.04349E+05,  2./
      DATA (u(i,6006),i=1,7)/15., 5., 2., 6., 4.40E-01,3.91190E+05,  2./
      DATA (u(i,6007),i=1,7)/15., 6., 1., 3., 2.80E-02,1.09324E+06, 21./
      DATA (u(i,6008),i=1,7)/15., 6., 1., 3., 1.80E-01,1.10318E+06, 21./
      DATA (u(i,6009),i=1,7)/15., 6., 1., 3., 4.20E-03,1.30661E+06, 19./
      DATA (u(i,6010),i=1,7)/15., 6., 1., 3., 1.20E+00,1.32191E+06, 19./
      DATA (u(i,6011),i=1,7)/15., 6., 1., 3., 1.70E-01,1.33420E+06, 19./
      DATA (u(i,6012),i=1,7)/15., 7., 6., 2., 6.00E-01,4.52304E+05,  3./
      DATA (u(i,6013),i=1,7)/15., 8., 9., 9., 1.62E+00,4.03600E+05,  3./
      DATA (u(i,6014),i=1,7)/15., 9., 4.,12., 8.40E-01,3.48347E+05,  3./
      DATA (u(i,6015),i=1,7)/15.,10., 9.,15., 6.93E-01,3.17038E+05,  3./
      DATA (u(i,6016),i=1,7)/15.,10., 9., 3., 8.37E-01,4.84215E+05,  3./
      DATA (u(i,6017),i=1,7)/15.,11., 6.,10., 4.08E-01,3.10723E+05,  3./
      DATA (u(i,6018),i=1,7)/15.,11., 6., 2., 2.04E-01,3.96857E+05,  3./
      DATA (u(i,6019),i=1,7)/15.,11., 6., 6., 9.60E-01,4.23245E+05,  3./
      DATA (u(i,6020),i=1,7)/15.,11., 6., 2., 1.32E-01,2.16760E+06,  2./
      DATA (u(i,6021),i=1,7)/15.,11., 6.,10., 3.84E+00,2.34137E+06,  2./
      DATA (u(i,6022),i=1,7)/15.,12., 1., 3., 1.10E-04,1.86390E+05,  3./
      DATA (u(i,6023),i=1,7)/15.,12., 1., 3., 2.45E-01,3.58834E+05,  3./
      DATA (u(i,6024),i=1,7)/15.,12., 1., 3., 6.60E-01,2.67773E+06,  2./
      DATA (u(i,6025),i=1,7)/15.,13., 2., 6., 2.00E-01,2.15406E+05,  3./
      DATA (u(i,6026),i=1,7)/15.,13., 2., 6., 6.86E-01,2.84819E+06,  2./
      DATA (u(i,6027),i=1,7)/15.,15., 2., 6., 8.32E-01,1.85102E+07,  4./
      DATA (u(i,6028),i=1,7)/15.,15., 2., 6., 1.58E-01,2.19380E+07,  5./
      DATA (u(i,6029),i=1,7)/15.,15., 2., 6., 5.80E-02,2.31377E+07,  6./
      DATA (u(i,6030),i=1,7)/15.,15., 2., 6., 2.79E-02,2.36930E+07,  7./
      DATA (u(i,6031),i=1,7)/15.,15., 2., 6., 1.56E-02,2.39947E+07,  8./
      DATA (u(i,6032),i=1,7)/15.,15., 2., 6., 9.63E-03,2.41766E+07,  9./
      DATA (u(i,6033),i=1,7)/15.,15., 2., 6., 6.37E-03,2.42946E+07,  9./
      DATA (u(i,6034),i=1,7)/15.,15., 2., 6., 4.43E-03,2.43756E+07,  9./
      DATA (u(i,6035),i=1,7)/15.,15., 2., 6., 3.21E-03,2.44334E+07,  9./
      DATA (u(i,6036),i=1,7)/17., 1., 6., 6., 8.50E-01,7.41450E+04,  1./
      DATA (u(i,6037),i=1,7)/17., 1., 6.,10., 4.91E-01,8.38268E+04,  1./
      DATA (u(i,6038),i=1,7)/17., 1., 6., 2., 5.79E-02,8.53848E+04,  1./
      DATA (u(i,6039),i=1,7)/17., 1., 6.,10., 2.96E-01,9.08515E+04,  1./
      DATA (u(i,6040),i=1,7)/17., 1., 6., 6., 1.85E-01,9.16901E+04,  1./
      DATA (u(i,6041),i=1,7)/17., 1., 6., 2., 9.33E-01,9.92403E+04,  1./
      DATA (u(i,6042),i=1,7)/17., 1., 6., 2., 1.55E-01,1.01302E+05,  1./
      DATA (u(i,6043),i=1,7)/17., 2., 9., 9., 1.80E-01,9.33430E+04,  3./
      DATA (u(i,6044),i=1,7)/17., 3., 4.,12., 1.71E-01,9.88834E+04,  3./
      DATA (u(i,6045),i=1,7)/17., 4., 9.,15., 3.96E-01,1.01910E+05,  3./
      DATA (u(i,6046),i=1,7)/17., 5., 6.,10., 3.12E+00,1.12283E+05,  3./
      DATA (u(i,6047),i=1,7)/17., 5., 6., 2., 5.46E-01,2.55317E+05,  2./
      DATA (u(i,6048),i=1,7)/17., 6., 1., 3., 1.76E-04,9.86320E+04,  3./
      DATA (u(i,6049),i=1,7)/17., 6., 1., 3., 1.28E+00,1.48949E+05,  3./
      DATA (u(i,6050),i=1,7)/17., 7., 2., 6., 1.26E+00,1.24261E+05,  3./
      DATA (u(i,6051),i=1,7)/17., 7., 2., 6., 2.04E-01,5.09658E+05,  2./
      DATA (u(i,6052),i=1,7)/17., 8., 1., 3., 4.40E-02,1.68945E+06, 21./
      DATA (u(i,6053),i=1,7)/17., 8., 1., 3., 1.50E-01,1.70436E+06, 21./
      DATA (u(i,6054),i=1,7)/17., 8., 1., 3., 5.20E-03,1.97239E+06, 19./
      DATA (u(i,6055),i=1,7)/17., 8., 1., 3., 1.60E+00,1.99704E+06, 19./
      DATA (u(i,6056),i=1,7)/17., 8., 1., 3., 1.70E-01,2.02073E+06, 19./
      DATA (u(i,6057),i=1,7)/17., 9., 6., 2., 5.34E-01,5.48878E+05,  3./
      DATA (u(i,6058),i=1,7)/17.,17., 2., 6., 8.32E-01,2.37753E+07,  4./
      DATA (u(i,6059),i=1,7)/17.,17., 2., 6., 1.58E-01,2.81781E+07,  5./
      DATA (u(i,6060),i=1,7)/17.,17., 2., 6., 5.80E-02,2.97191E+07,  6./
      DATA (u(i,6061),i=1,7)/17.,17., 2., 6., 2.79E-02,3.04324E+07,  7./
      DATA (u(i,6062),i=1,7)/17.,17., 2., 6., 1.56E-02,3.08198E+07,  8./
      DATA (u(i,6063),i=1,7)/17.,17., 2., 6., 9.63E-03,3.10535E+07,  9./
      DATA (u(i,6064),i=1,7)/17.,17., 2., 6., 6.37E-03,3.12051E+07,  9./
      DATA (u(i,6065),i=1,7)/17.,17., 2., 6., 4.43E-03,3.13090E+07,  9./
      DATA (u(i,6066),i=1,7)/17.,17., 2., 6., 3.21E-03,3.13834E+07,  9./
      DATA (u(i,6067),i=1,7)/19., 1., 2., 6., 1.83E-02,2.47139E+04,  1./
      DATA (u(i,6068),i=1,7)/19., 1., 2., 6., 1.80E-03,2.90049E+04,  1./
      DATA (u(i,6069),i=1,7)/19., 1., 2., 6., 4.29E-04,3.10729E+04,  1./
      DATA (u(i,6070),i=1,7)/19., 1., 2., 6., 1.59E-04,3.22361E+04,  1./
      DATA (u(i,6071),i=1,7)/19., 1., 2., 6., 7.80E-05,3.29511E+04,  1./
      DATA (u(i,6072),i=1,7)/19., 1., 2., 6., 4.38E-05,3.34202E+04,  1./
      DATA (u(i,6073),i=1,7)/19., 1., 2., 6., 2.60E-05,3.37473E+04,  1./
      DATA (u(i,6074),i=1,7)/19., 1., 2., 6., 1.84E-05,3.39824E+04,  1./
      DATA (u(i,6075),i=1,7)/19., 1., 2., 6., 1.34E-05,3.41588E+04,  1./
      DATA (u(i,6076),i=1,7)/19., 3., 6., 2., 1.32E+00,1.29889E+05,  3./
      DATA (u(i,6077),i=1,7)/19., 4., 9., 9., 6.48E+00,1.34109E+05,  3./
      DATA (u(i,6078),i=1,7)/19., 5., 4.,12., 3.84E+00,1.37468E+05,  3./
      DATA (u(i,6079),i=1,7)/19., 6., 9.,15., 4.14E+00,1.38864E+05,  3./
      DATA (u(i,6080),i=1,7)/19., 7., 6.,10., 2.64E+00,1.49896E+05,  3./
      DATA (u(i,6081),i=1,7)/19., 7., 6., 2., 5.10E-01,4.37216E+05,  2./
      DATA (u(i,6082),i=1,7)/19., 8., 1., 3., 1.14E+00,1.92541E+05,  3./
      DATA (u(i,6083),i=1,7)/19., 9., 2., 6., 1.08E+00,1.58909E+05,  3./
      DATA (u(i,6084),i=1,7)/19., 9., 2., 6., 2.80E-01,7.59128E+05,  2./
      DATA (u(i,6085),i=1,7)/19.,10., 1., 3., 6.00E-02,2.40732E+06, 21./
      DATA (u(i,6086),i=1,7)/19.,10., 1., 3., 1.20E-01,2.43031E+06, 21./
      DATA (u(i,6087),i=1,7)/19.,10., 1., 3., 6.50E-03,2.76022E+06, 19./
      DATA (u(i,6088),i=1,7)/19.,10., 1., 3., 1.90E+00,2.79494E+06, 19./
      DATA (u(i,6089),i=1,7)/19.,10., 1., 3., 2.20E-01,2.83230E+06, 19./
      DATA (u(i,6090),i=1,7)/19.,19., 2., 6., 8.32E-01,2.96986E+07,  4./
      DATA (u(i,6091),i=1,7)/19.,19., 2., 6., 1.58E-01,3.51983E+07,  5./
      DATA (u(i,6092),i=1,7)/19.,19., 2., 6., 5.80E-02,3.71232E+07,  6./
      DATA (u(i,6093),i=1,7)/19.,19., 2., 6., 2.79E-02,3.80142E+07,  7./
      DATA (u(i,6094),i=1,7)/19.,19., 2., 6., 1.56E-02,3.84981E+07,  8./
      DATA (u(i,6095),i=1,7)/19.,19., 2., 6., 9.63E-03,3.87900E+07,  9./
      DATA (u(i,6096),i=1,7)/19.,19., 2., 6., 6.37E-03,3.89794E+07,  9./
      DATA (u(i,6097),i=1,7)/19.,19., 2., 6., 4.43E-03,3.91092E+07,  9./
      DATA (u(i,6098),i=1,7)/19.,19., 2., 6., 3.21E-03,3.92021E+07,  9./
      DATA (u(i,6099),i=1,7)/21., 1.,10., 6., 1.40E-02,1.87070E+04,  1./
      DATA (u(i,6100),i=1,7)/21., 1.,10.,14., 1.50E+00,3.31240E+04,  1./
      DATA (u(i,6101),i=1,7)/21., 1.,10.,10., 6.80E-01,3.35690E+04,  1./
      DATA (u(i,6102),i=1,7)/21., 1.,10.,10., 2.40E-01,4.10580E+04,  1./
      DATA (u(i,6103),i=1,7)/21., 1.,10., 6., 2.40E-01,4.40600E+04,  1./
      DATA (u(i,6104),i=1,7)/21., 1.,10.,14., 2.00E-02,3.66020E+04,  1./
      DATA (u(i,6105),i=1,7)/21., 1.,10.,10., 3.40E-01,3.68970E+04,  1./
      DATA (u(i,6106),i=1,7)/21., 1.,10., 6., 1.10E-01,3.69980E+04,  1./
      DATA (u(i,6107),i=1,7)/21., 1.,10.,10., 4.03E+00,2.48540E+04,  1./
      DATA (u(i,6108),i=1,7)/21., 1.,10.,14., 4.46E+00,2.55640E+04,  1./
      DATA (u(i,6109),i=1,7)/21., 1.,10., 6., 3.00E+00,3.05610E+04,  1./
      DATA (u(i,6110),i=1,7)/21., 1.,10.,10., 9.20E-02,1.59520E+04,  1./
      DATA (u(i,6111),i=1,7)/21., 1.,10.,14., 4.80E-02,2.09620E+04,  1./
      DATA (u(i,6112),i=1,7)/21., 1.,10., 6., 2.70E-02,4.04620E+04,  1./
      DATA (u(i,6113),i=1,7)/21., 1.,10., 6., 8.30E-02,4.26920E+04,  1./
      DATA (u(i,6114),i=1,7)/21., 1.,10.,10., 2.20E-01,4.31190E+04,  1./
      DATA (u(i,6115),i=1,7)/21., 2.,15., 9., 2.35E+00,3.91250E+04,  2./
      DATA (u(i,6116),i=1,7)/21., 2.,15.,21., 7.50E+00,2.75615E+04,  3./
      DATA (u(i,6117),i=1,7)/21., 2.,15.,15., 6.00E+00,2.79605E+04,  3./
      DATA (u(i,6118),i=1,7)/21., 2.,15., 9., 2.10E+00,2.96815E+04,  3./
      DATA (u(i,6119),i=1,7)/21., 3.,10., 6., 1.00E+00,6.23014E+04,  2./
      DATA (u(i,6120),i=1,7)/21., 3.,10.,14., 1.50E+00,1.36755E+05,  2./
      DATA (u(i,6121),i=1,7)/21., 3.,10., 6., 7.80E-02,1.28105E+05,  2./
      DATA (u(i,6122),i=1,7)/21., 3.,10.,14., 7.30E-01,1.59353E+05,  2./
      DATA (u(i,6123),i=1,7)/21., 4., 1., 3., 1.60E-03,2.69427E+05,  3./
      DATA (u(i,6124),i=1,7)/21., 4., 1., 3., 3.92E+00,3.45005E+05,  3./
      DATA (u(i,6125),i=1,7)/21., 4., 1., 3., 8.00E-02,3.34405E+05,  2./
      DATA (u(i,6126),i=1,7)/21., 4., 1., 3., 3.40E-01,3.37484E+05,  2./
      DATA (u(i,6127),i=1,7)/21., 5., 6., 2., 2.05E-01,1.72970E+05,  3./
      DATA (u(i,6128),i=1,7)/21., 5., 6.,10., 1.23E+01,3.52238E+05,  3./
      DATA (u(i,6129),i=1,7)/21., 5., 6., 2., 2.35E+00,3.36198E+05,  3./
      DATA (u(i,6130),i=1,7)/21., 7., 4.,12., 3.88E-01,1.76653E+05,  3./
      DATA (u(i,6131),i=1,7)/21., 8., 9.,15., 4.14E-01,1.76420E+05,  3./
      DATA (u(i,6132),i=1,7)/21., 8., 9., 9., 5.40E-01,2.03966E+05,  3./
      DATA (u(i,6133),i=1,7)/21., 9., 6.,10., 3.96E-01,1.87996E+05,  3./
      DATA (u(i,6134),i=1,7)/21., 9., 6., 2., 4.14E-01,2.36520E+05,  3./
      DATA (u(i,6135),i=1,7)/21., 9., 6., 6., 3.24E+00,2.54205E+05,  3./
      DATA (u(i,6136),i=1,7)/21., 9., 6.,10., 4.08E+00,3.10231E+05,  3./
      DATA (u(i,6137),i=1,7)/21.,10., 1., 3., 1.05E+00,2.36490E+05,  3./
      DATA (u(i,6138),i=1,7)/21.,10., 1., 3., 2.70E-01,9.80604E+05,  2./
      DATA (u(i,6139),i=1,7)/21.,10., 1., 3., 9.20E-02,1.30990E+06,  2./
      DATA (u(i,6140),i=1,7)/21.,11., 2., 6., 9.92E-01,1.95741E+05,  3./
      DATA (u(i,6141),i=1,7)/21.,11., 2., 6., 3.32E-01,1.05301E+06,  2./
      DATA (u(i,6142),i=1,7)/21.,11., 2., 6., 1.08E-01,1.41910E+06,  2./
      DATA (u(i,6143),i=1,7)/21.,11., 2., 6., 2.78E-02,1.72170E+06,  2./
      DATA (u(i,6144),i=1,7)/21.,12., 1., 3., 9.20E-02,3.24510E+06, 21./
      DATA (u(i,6145),i=1,7)/21.,12., 1., 3., 1.37E-01,3.28080E+06, 21./
      DATA (u(i,6146),i=1,7)/21.,12., 1., 3., 8.00E-03,3.66840E+06, 19./
      DATA (u(i,6147),i=1,7)/21.,12., 1., 3., 2.50E-01,3.71470E+06, 19./
      DATA (u(i,6148),i=1,7)/21.,12., 1., 3., 2.50E+00,3.76730E+06, 19./
      DATA (u(i,6149),i=1,7)/21.,13., 6., 2., 4.29E-01,7.51002E+05,  3./
      DATA (u(i,6150),i=1,7)/21.,13., 6., 2., 1.02E-01,3.70576E+06,  2./
      DATA (u(i,6151),i=1,7)/21.,13., 6., 2., 1.14E+00,4.04156E+06,  2./
      DATA (u(i,6152),i=1,7)/21.,13., 6.,10., 1.50E+00,4.13976E+06,  2./
      DATA (u(i,6153),i=1,7)/21.,14., 9., 9., 1.08E+00,6.62940E+05,  3./
      DATA (u(i,6154),i=1,7)/21.,14., 9., 3., 4.41E-01,3.83408E+06,  2./
      DATA (u(i,6155),i=1,7)/21.,14., 9., 9., 3.06E-01,3.96818E+06,  2./
      DATA (u(i,6156),i=1,7)/21.,14., 9., 1., 2.70E+00,4.20328E+06,  2./
      DATA (u(i,6157),i=1,7)/21.,15., 4.,12., 5.60E-01,5.66460E+05,  3./
      DATA (u(i,6158),i=1,7)/21.,15., 4., 2., 1.08E-03,8.81890E+05,  3./
      DATA (u(i,6159),i=1,7)/21.,16., 9.,15., 4.95E-01,5.06693E+05,  3./
      DATA (u(i,6160),i=1,7)/21.,16., 9., 9., 5.31E-01,5.99720E+05,  3./
      DATA (u(i,6161),i=1,7)/21.,16., 9., 3., 5.94E-01,7.49687E+05,  3./
      DATA (u(i,6162),i=1,7)/21.,17., 6.,10., 2.95E-01,4.88570E+05,  3./
      DATA (u(i,6163),i=1,7)/21.,17., 6., 2., 1.68E-01,6.01900E+05,  3./
      DATA (u(i,6164),i=1,7)/21.,17., 6., 6., 6.84E-01,6.60270E+05,  3./
      DATA (u(i,6165),i=1,7)/21.,17., 6.,10., 3.96E+00,5.19153E+06,  2./
      DATA (u(i,6166),i=1,7)/21.,18., 1., 3., 5.10E-04,2.86860E+05,  3./
      DATA (u(i,6167),i=1,7)/21.,18., 1., 3., 1.82E-01,5.53440E+05,  3./
      DATA (u(i,6168),i=1,7)/21.,18., 1., 3., 3.20E-01,5.70300E+06,  2./
      DATA (u(i,6169),i=1,7)/21.,18., 1., 3., 3.60E-01,5.69200E+06,  2./
      DATA (u(i,6170),i=1,7)/21.,19., 2., 6., 1.49E-01,3.40600E+05, 14./
      DATA (u(i,6171),i=1,7)/21.,19., 2., 6., 7.32E-01,5.94070E+06, 16./
      DATA (u(i,6172),i=1,7)/21.,19., 2., 6., 1.96E-01,7.89020E+06, 18./
      DATA (u(i,6173),i=1,7)/21.,19., 2., 6., 8.00E-02,8.78970E+06, 18./
      DATA (u(i,6174),i=1,7)/21.,19., 2., 6., 4.22E-02,9.27210E+06, 18./
      DATA (u(i,6175),i=1,7)/21.,19., 2., 6., 2.48E-02,9.57580E+06, 18./
      DATA (u(i,6176),i=1,7)/21.,19., 2., 6., 1.54E-02,9.76560E+06, 18./
      DATA (u(i,6177),i=1,7)/21.,20., 1., 3., 2.78E-02,3.46416E+07, 25./
      DATA (u(i,6178),i=1,7)/21.,20., 1., 3., 7.41E-01,3.48088E+07, 11./
      DATA (u(i,6179),i=1,7)/21.,20., 1., 3., 6.40E-03,4.08462E+07, 25./
      DATA (u(i,6180),i=1,7)/21.,20., 1., 3., 1.43E-01,4.08928E+07, 12./
      DATA (u(i,6181),i=1,7)/21.,20., 1., 3., 2.50E-03,4.30083E+07, 25./
      DATA (u(i,6182),i=1,7)/21.,20., 1., 3., 5.27E-02,4.30275E+07, 13./
      DATA (u(i,6183),i=1,7)/21.,20., 1., 3., 1.20E-03,4.40064E+07, 25./
      DATA (u(i,6184),i=1,7)/21.,20., 1., 3., 2.54E-02,4.40161E+07, 13./
      DATA (u(i,6185),i=1,7)/21.,21., 2., 6., 8.32E-01,3.62800E+07,  4./
      DATA (u(i,6186),i=1,7)/21.,21., 2., 6., 1.58E-01,4.29985E+07,  5./
      DATA (u(i,6187),i=1,7)/21.,21., 2., 6., 5.80E-02,4.53500E+07,  6./
      DATA (u(i,6188),i=1,7)/21.,21., 2., 6., 2.79E-02,4.64384E+07,  7./
      DATA (u(i,6189),i=1,7)/21.,21., 2., 6., 1.56E-02,4.70296E+07,  8./
      DATA (u(i,6190),i=1,7)/21.,21., 2., 6., 9.63E-03,4.73861E+07,  9./
      DATA (u(i,6191),i=1,7)/21.,21., 2., 6., 6.37E-03,4.76175E+07,  9./
      DATA (u(i,6192),i=1,7)/21.,21., 2., 6., 4.43E-03,4.77761E+07,  9./
      DATA (u(i,6193),i=1,7)/21.,21., 2., 6., 3.21E-03,4.78896E+07,  9./
      DATA (u(i,6194),i=1,7)/22., 1.,21.,21., 3.34E-01,1.92415E+04,  1./
      DATA (u(i,6195),i=1,7)/22., 1.,21.,21., 2.29E+00,2.50445E+04,  1./
      DATA (u(i,6196),i=1,7)/22., 1.,21.,21., 2.33E+00,2.67065E+04,  1./
      DATA (u(i,6197),i=1,7)/22., 1.,21.,15., 2.37E-01,2.72115E+04,  1./
      DATA (u(i,6198),i=1,7)/22., 1.,21.,27., 4.33E+00,2.74175E+04,  1./
      DATA (u(i,6199),i=1,7)/22., 1.,21.,21., 3.15E+00,3.38875E+04,  1./
      DATA (u(i,6200),i=1,7)/22., 1.,21.,21., 1.87E+00,3.83535E+04,  1./
      DATA (u(i,6201),i=1,7)/22., 2.,28.,36., 1.01E+01,2.97114E+04,  3./
      DATA (u(i,6202),i=1,7)/22., 2.,28.,28., 6.90E+00,3.08825E+04,  3./
      DATA (u(i,6203),i=1,7)/22., 2.,28.,28., 2.06E+00,5.25164E+04,  3./
      DATA (u(i,6204),i=1,7)/22., 2.,28.,20., 3.77E+00,5.24286E+04,  3./
      DATA (u(i,6205),i=1,7)/22., 3.,21.,15., 1.56E+00,7.70121E+04,  3./
      DATA (u(i,6206),i=1,7)/22., 3.,21.,21., 2.05E+00,7.76040E+04,  2./
      DATA (u(i,6207),i=1,7)/22., 4.,10., 6., 7.80E-01,1.28238E+05,  2./
      DATA (u(i,6208),i=1,7)/22., 4.,10.,14., 2.00E+00,2.35910E+05,  2./
      DATA (u(i,6209),i=1,7)/22., 4.,10., 6., 9.10E-02,2.30590E+05,  2./
      DATA (u(i,6210),i=1,7)/22., 5., 1., 3., 1.90E-03,3.09252E+05,  3./
      DATA (u(i,6211),i=1,7)/22., 5., 1., 3., 3.63E+00,3.95321E+05,  3./
      DATA (u(i,6212),i=1,7)/22., 5., 1., 3., 9.70E-02,4.36850E+05,  2./
      DATA (u(i,6213),i=1,7)/22., 5., 1., 3., 3.30E-01,4.43753E+05,  2./
      DATA (u(i,6214),i=1,7)/22., 6., 6., 2., 2.11E-01,1.94685E+05,  3./
      DATA (u(i,6215),i=1,7)/22., 6., 6.,10., 1.14E+01,3.99244E+05,  3./
      DATA (u(i,6216),i=1,7)/22., 6., 6., 2., 2.17E+00,3.77930E+05,  3./
      DATA (u(i,6217),i=1,7)/22., 8., 4.,12., 3.96E-01,1.96596E+05,  3./
      DATA (u(i,6218),i=1,7)/22., 9., 9.,15., 4.23E-01,1.95521E+05,  3./
      DATA (u(i,6219),i=1,7)/22., 9., 9., 9., 5.40E-01,2.25606E+05,  3./
      DATA (u(i,6220),i=1,7)/22.,10., 6.,10., 3.90E-01,2.07357E+05,  3./
      DATA (u(i,6221),i=1,7)/22.,10., 6., 2., 4.20E-01,2.59426E+05,  3./
      DATA (u(i,6222),i=1,7)/22.,10., 6., 6., 3.06E+00,2.78796E+05,  3./
      DATA (u(i,6223),i=1,7)/22.,10., 6.,10., 3.84E+00,3.40616E+05,  3./
      DATA (u(i,6224),i=1,7)/22.,11., 1., 3., 1.30E-03,1.75700E+05,  3./
      DATA (u(i,6225),i=1,7)/22.,11., 1., 3., 9.95E-01,2.58973E+05,  3./
      DATA (u(i,6226),i=1,7)/22.,11., 1., 3., 2.94E-01,1.13990E+06,  2./
      DATA (u(i,6227),i=1,7)/22.,11., 1., 3., 9.90E-02,1.52900E+06,  2./
      DATA (u(i,6228),i=1,7)/22.,12., 2., 6., 9.44E-01,2.14156E+05,  3./
      DATA (u(i,6229),i=1,7)/22.,12., 2., 6., 3.60E-01,1.21658E+06,  2./
      DATA (u(i,6230),i=1,7)/22.,12., 2., 6., 1.16E-01,1.64690E+06,  2./
      DATA (u(i,6231),i=1,7)/22.,12., 2., 6., 5.32E-02,1.87120E+06,  2./
      DATA (u(i,6232),i=1,7)/22.,12., 2., 6., 2.96E-02,2.00350E+06,  2./
      DATA (u(i,6233),i=1,7)/22.,12., 2., 6., 1.82E-02,2.08740E+06,  2./
      DATA (u(i,6234),i=1,7)/22.,13., 1., 3., 1.00E-01,3.70920E+06, 21./
      DATA (u(i,6235),i=1,7)/22.,13., 1., 3., 1.30E-01,3.75360E+06, 21./
      DATA (u(i,6236),i=1,7)/22.,13., 1., 3., 8.80E-03,4.16820E+06, 19./
      DATA (u(i,6237),i=1,7)/22.,13., 1., 3., 3.00E-01,4.21980E+06, 19./
      DATA (u(i,6238),i=1,7)/22.,13., 1., 3., 2.50E+00,4.28160E+06, 19./
      DATA (u(i,6239),i=1,7)/22.,14., 6., 2., 4.10E-01,8.04026E+05,  3./
      DATA (u(i,6240),i=1,7)/22.,14., 6., 2., 1.14E+00,4.56726E+06,  2./
      DATA (u(i,6241),i=1,7)/22.,14., 6.,10., 1.68E+00,4.67336E+06,  2./
      DATA (u(i,6242),i=1,7)/22.,15., 9., 9., 9.90E-01,7.10213E+05,  3./
      DATA (u(i,6243),i=1,7)/22.,15., 9., 3., 4.23E-01,4.33650E+06,  2./
      DATA (u(i,6244),i=1,7)/22.,15., 9., 1., 2.61E+00,4.76540E+06,  2./
      DATA (u(i,6245),i=1,7)/22.,16., 4.,12., 5.60E-01,6.07000E+05,  3./
      DATA (u(i,6246),i=1,7)/22.,16., 4., 2., 1.40E-03,9.39920E+05,  3./
      DATA (u(i,6247),i=1,7)/22.,17., 9.,15., 4.59E-01,5.41954E+05,  3./
      DATA (u(i,6248),i=1,7)/22.,17., 9., 9., 4.86E-01,6.43050E+05,  3./
      DATA (u(i,6249),i=1,7)/22.,17., 9., 3., 5.31E-01,7.97484E+05,  3./
      DATA (u(i,6250),i=1,7)/22.,18., 6.,10., 2.84E-01,5.21870E+05,  3./
      DATA (u(i,6251),i=1,7)/22.,18., 6.,10., 3.84E+00,5.77447E+06,  2./
      DATA (u(i,6252),i=1,7)/22.,19., 1., 3., 6.60E-04,3.04600E+05,  3./
      DATA (u(i,6253),i=1,7)/22.,19., 1., 3., 1.75E-01,5.89692E+05,  3./
      DATA (u(i,6254),i=1,7)/22.,19., 1., 3., 3.30E-01,6.30320E+06,  2./
      DATA (u(i,6255),i=1,7)/22.,19., 1., 3., 3.60E-01,6.31900E+06,  2./
      DATA (u(i,6256),i=1,7)/22.,20., 2., 6., 1.44E-01,3.64920E+05, 14./
      DATA (u(i,6257),i=1,7)/22.,20., 2., 6., 7.36E-01,6.56820E+06, 16./
      DATA (u(i,6258),i=1,7)/22.,20., 2., 6., 1.98E-01,8.73210E+06, 18./
      DATA (u(i,6259),i=1,7)/22.,20., 2., 6., 8.00E-02,9.72950E+06, 18./
      DATA (u(i,6260),i=1,7)/22.,20., 2., 6., 4.22E-02,1.02700E+07, 18./
      DATA (u(i,6261),i=1,7)/22.,20., 2., 6., 2.48E-02,1.06000E+07, 18./
      DATA (u(i,6262),i=1,7)/22.,20., 2., 6., 1.54E-02,1.08200E+07, 18./
      DATA (u(i,6263),i=1,7)/22.,21., 1., 3., 3.46E-02,3.81292E+07, 25./
      DATA (u(i,6264),i=1,7)/22.,21., 1., 3., 7.35E-01,3.83116E+07, 11./
      DATA (u(i,6265),i=1,7)/22.,21., 1., 3., 8.40E-03,4.49708E+07, 25./
      DATA (u(i,6266),i=1,7)/22.,21., 1., 3., 1.41E-01,4.50219E+07, 12./
      DATA (u(i,6267),i=1,7)/22.,21., 1., 3., 3.10E-03,4.73552E+07, 25./
      DATA (u(i,6268),i=1,7)/22.,21., 1., 3., 5.22E-02,4.73762E+07, 13./
      DATA (u(i,6269),i=1,7)/22.,21., 1., 3., 1.60E-03,4.84558E+07, 25./
      DATA (u(i,6270),i=1,7)/22.,21., 1., 3., 2.52E-02,4.84665E+07, 13./
      DATA (u(i,6271),i=1,7)/22.,22., 2., 6., 8.32E-01,3.98175E+07,  4./
      DATA (u(i,6272),i=1,7)/22.,22., 2., 6., 1.58E-01,4.71911E+07,  5./
      DATA (u(i,6273),i=1,7)/22.,22., 2., 6., 5.80E-02,4.97718E+07,  6./
      DATA (u(i,6274),i=1,7)/22.,22., 2., 6., 2.79E-02,5.09664E+07,  7./
      DATA (u(i,6275),i=1,7)/22.,22., 2., 6., 1.56E-02,5.16152E+07,  8./
      DATA (u(i,6276),i=1,7)/22.,22., 2., 6., 9.63E-03,5.20065E+07,  9./
      DATA (u(i,6277),i=1,7)/22.,22., 2., 6., 6.37E-03,5.22604E+07,  9./
      DATA (u(i,6278),i=1,7)/22.,22., 2., 6., 4.43E-03,5.24345E+07,  9./
      DATA (u(i,6279),i=1,7)/22.,22., 2., 6., 3.21E-03,5.25591E+07,  9./
      DATA (u(i,6280),i=1,7)/23., 1.,28.,20., 6.69E-01,2.05406E+04,  1./
      DATA (u(i,6281),i=1,7)/23., 1.,28.,36., 6.16E-01,2.17846E+04,  1./
      DATA (u(i,6282),i=1,7)/23., 1.,28.,28., 2.18E+00,2.57676E+04,  1./
      DATA (u(i,6283),i=1,7)/23., 1.,28.,20., 2.97E+00,2.60466E+04,  1./
      DATA (u(i,6284),i=1,7)/23., 1.,28.,36., 1.51E+01,3.13796E+04,  1./
      DATA (u(i,6285),i=1,7)/23., 2.,25.,35., 1.25E+00,3.68767E+04,  3./
      DATA (u(i,6286),i=1,7)/23., 2.,25.,25., 2.28E+00,3.72437E+04,  3./
      DATA (u(i,6287),i=1,7)/23., 2.,25.,15., 1.93E+00,4.67289E+04,  3./
      DATA (u(i,6288),i=1,7)/23., 3.,28.,36., 5.00E-01,8.59107E+04,  3./
      DATA (u(i,6289),i=1,7)/23., 3.,28.,28., 3.52E+00,8.68660E+04,  3./
      DATA (u(i,6290),i=1,7)/23., 3.,28.,20., 1.77E+00,8.88523E+04,  3./
      DATA (u(i,6291),i=1,7)/23., 5.,10.,14., 4.60E+00,3.96822E+05,  3./
      DATA (u(i,6292),i=1,7)/23., 5.,10.,10., 1.80E+01,4.43966E+05,  3./
      DATA (u(i,6293),i=1,7)/23., 5.,10., 6., 7.80E+00,4.38593E+05,  3./
      DATA (u(i,6294),i=1,7)/23., 6., 1., 3., 2.10E-03,3.47900E+05,  3./
      DATA (u(i,6295),i=1,7)/23., 6., 1., 3., 3.30E+00,4.45436E+05,  3./
      DATA (u(i,6296),i=1,7)/23., 6., 1., 3., 1.10E-01,5.49299E+05,  2./
      DATA (u(i,6297),i=1,7)/23., 6., 1., 3., 3.10E-01,5.57636E+05,  2./
      DATA (u(i,6298),i=1,7)/23., 7., 6., 2., 2.12E-01,2.16606E+05,  3./
      DATA (u(i,6299),i=1,7)/23., 7., 6.,10., 1.02E+01,4.44144E+05,  3./
      DATA (u(i,6300),i=1,7)/23., 7., 6., 2., 2.01E+00,4.18494E+05,  3./
      DATA (u(i,6301),i=1,7)/23., 7., 6.,10., 1.92E-02,4.16644E+05,  3./
      DATA (u(i,6302),i=1,7)/23., 9., 4.,12., 3.96E-01,2.16834E+05,  3./
      DATA (u(i,6303),i=1,7)/23., 9., 4.,12., 7.20E+00,4.08950E+05,  3./
      DATA (u(i,6304),i=1,7)/23.,10., 9.,15., 4.23E-01,2.14908E+05,  3./
      DATA (u(i,6305),i=1,7)/23.,10., 9., 9., 5.31E-01,2.47603E+05,  3./
      DATA (u(i,6306),i=1,7)/23.,11., 6.,10., 3.84E-01,2.26992E+05,  3./
      DATA (u(i,6307),i=1,7)/23.,11., 6., 2., 4.02E-01,2.82448E+05,  3./
      DATA (u(i,6308),i=1,7)/23.,11., 6., 6., 2.88E+00,3.03726E+05,  3./
      DATA (u(i,6309),i=1,7)/23.,11., 6.,10., 3.48E+00,3.70913E+05,  3./
      DATA (u(i,6310),i=1,7)/23.,12., 1., 3., 1.40E-03,1.91400E+05,  3./
      DATA (u(i,6311),i=1,7)/23.,12., 1., 3., 9.47E-01,2.81600E+05,  3./
      DATA (u(i,6312),i=1,7)/23.,12., 1., 3., 3.17E-01,1.31060E+06,  2./
      DATA (u(i,6313),i=1,7)/23.,12., 1., 3., 1.04E-01,1.76510E+06,  2./
      DATA (u(i,6314),i=1,7)/23.,13., 2., 6., 8.98E-01,2.32890E+05,  3./
      DATA (u(i,6315),i=1,7)/23.,13., 2., 6., 3.74E-01,1.39141E+06,  2./
      DATA (u(i,6316),i=1,7)/23.,13., 2., 6., 1.22E-01,1.89040E+06,  2./
      DATA (u(i,6317),i=1,7)/23.,13., 2., 6., 5.60E-02,2.15210E+06,  2./
      DATA (u(i,6318),i=1,7)/23.,13., 2., 6., 3.10E-02,2.30570E+06,  2./
      DATA (u(i,6319),i=1,7)/23.,13., 2., 6., 1.92E-02,2.40410E+06,  2./
      DATA (u(i,6320),i=1,7)/23.,14., 1., 3., 1.07E-01,4.20270E+06, 21./
      DATA (u(i,6321),i=1,7)/23.,14., 1., 3., 1.23E-01,4.25710E+06, 21./
      DATA (u(i,6322),i=1,7)/23.,14., 1., 3., 9.60E-03,4.69620E+06, 19./
      DATA (u(i,6323),i=1,7)/23.,14., 1., 3., 3.80E-01,4.75780E+06, 19./
      DATA (u(i,6324),i=1,7)/23.,14., 1., 3., 2.51E+00,4.82720E+06, 19./
      DATA (u(i,6325),i=1,7)/23.,15., 6., 2., 3.94E-01,8.58345E+05,  3./
      DATA (u(i,6326),i=1,7)/23.,15., 6., 2., 1.02E-01,4.73691E+06,  2./
      DATA (u(i,6327),i=1,7)/23.,15., 6., 2., 1.14E+00,5.12381E+06,  2./
      DATA (u(i,6328),i=1,7)/23.,15., 6.,10., 1.74E+00,5.24011E+06,  2./
      DATA (u(i,6329),i=1,7)/23.,16., 9., 9., 9.90E-01,7.59110E+05,  3./
      DATA (u(i,6330),i=1,7)/23.,16., 9., 3., 4.14E-01,4.86954E+06,  2./
      DATA (u(i,6331),i=1,7)/23.,16., 9., 1., 2.61E+00,5.32482E+06,  2./
      DATA (u(i,6332),i=1,7)/23.,17., 4.,12., 5.20E-01,6.49450E+05,  3./
      DATA (u(i,6333),i=1,7)/23.,17., 4., 2., 1.88E-03,9.99840E+05,  3./
      DATA (u(i,6334),i=1,7)/23.,18., 9.,15., 4.41E-01,5.78736E+05,  3./
      DATA (u(i,6335),i=1,7)/23.,18., 9., 9., 4.77E-01,6.88896E+05,  3./
      DATA (u(i,6336),i=1,7)/23.,18., 9., 3., 5.13E-01,8.46793E+05,  3./
      DATA (u(i,6337),i=1,7)/23.,19., 6.,10., 2.70E-01,5.56500E+05,  3./
      DATA (u(i,6338),i=1,7)/23.,19., 6.,10., 3.90E+00,6.38716E+06,  2./
      DATA (u(i,6339),i=1,7)/23.,20., 1., 3., 8.30E-04,3.22600E+05,  3./
      DATA (u(i,6340),i=1,7)/23.,20., 1., 3., 1.69E-01,6.27500E+05,  3./
      DATA (u(i,6341),i=1,7)/23.,20., 1., 3., 3.10E-01,6.94380E+06,  2./
      DATA (u(i,6342),i=1,7)/23.,20., 1., 3., 3.80E-01,6.96400E+06,  2./
      DATA (u(i,6343),i=1,7)/23.,20., 1., 3., 1.60E-01,9.14000E+06,  2./
      DATA (u(i,6344),i=1,7)/23.,21., 2., 6., 1.40E-01,3.90800E+05, 14./
      DATA (u(i,6345),i=1,7)/23.,21., 2., 6., 7.40E-01,7.22440E+06, 16./
      DATA (u(i,6346),i=1,7)/23.,21., 2., 6., 1.98E-01,9.60340E+06, 18./
      DATA (u(i,6347),i=1,7)/23.,21., 2., 6., 8.00E-02,1.06900E+07, 18./
      DATA (u(i,6348),i=1,7)/23.,21., 2., 6., 4.24E-02,1.13100E+07, 18./
      DATA (u(i,6349),i=1,7)/23.,21., 2., 6., 2.48E-02,1.16600E+07, 18./
      DATA (u(i,6350),i=1,7)/23.,22., 1., 3., 4.22E-02,4.17868E+07, 25./
      DATA (u(i,6351),i=1,7)/23.,22., 1., 3., 7.28E-01,4.19860E+07, 11./
      DATA (u(i,6352),i=1,7)/23.,22., 1., 3., 1.10E-02,4.92974E+07, 25./
      DATA (u(i,6353),i=1,7)/23.,22., 1., 3., 1.40E-01,4.93534E+07, 12./
      DATA (u(i,6354),i=1,7)/23.,22., 1., 3., 3.80E-03,5.19151E+07, 25./
      DATA (u(i,6355),i=1,7)/23.,22., 1., 3., 5.18E-02,5.19383E+07, 13./
      DATA (u(i,6356),i=1,7)/23.,22., 1., 3., 1.90E-03,5.31235E+07, 25./
      DATA (u(i,6357),i=1,7)/23.,22., 1., 3., 2.50E-02,5.31353E+07, 13./
      DATA (u(i,6358),i=1,7)/23.,23., 2., 6., 8.32E-01,4.35195E+07,  4./
      DATA (u(i,6359),i=1,7)/23.,23., 2., 6., 1.58E-01,5.15787E+07,  5./
      DATA (u(i,6360),i=1,7)/23.,23., 2., 6., 5.80E-02,5.43994E+07,  6./
      DATA (u(i,6361),i=1,7)/23.,23., 2., 6., 2.79E-02,5.57050E+07,  7./
      DATA (u(i,6362),i=1,7)/23.,23., 2., 6., 1.56E-02,5.64142E+07,  8./
      DATA (u(i,6363),i=1,7)/23.,23., 2., 6., 9.63E-03,5.68418E+07,  9./
      DATA (u(i,6364),i=1,7)/23.,23., 2., 6., 6.37E-03,5.71194E+07,  9./
      DATA (u(i,6365),i=1,7)/23.,23., 2., 6., 4.43E-03,5.73096E+07,  9./
      DATA (u(i,6366),i=1,7)/23.,23., 2., 6., 3.21E-03,5.74457E+07,  9./
      DATA (u(i,6367),i=1,7)/24., 1., 7.,21., 1.79E+00,2.34150E+04,  1./
      DATA (u(i,6368),i=1,7)/24., 1., 7.,21., 6.17E+00,2.78480E+04,  1./
      DATA (u(i,6369),i=1,7)/24., 1., 7.,21., 9.80E-02,4.22590E+04,  1./
      DATA (u(i,6370),i=1,7)/24., 1., 7.,21., 1.58E-02,4.77100E+04,  1./
      DATA (u(i,6371),i=1,7)/24., 1., 7.,21., 2.04E-01,5.15322E+04,  1./
      DATA (u(i,6372),i=1,7)/24., 2., 6.,18., 1.89E+00,4.85333E+04,  3./
      DATA (u(i,6373),i=1,7)/24., 2., 6.,18., 1.41E-03,5.46682E+04,  3./
      DATA (u(i,6374),i=1,7)/24., 2., 6.,18., 4.82E-02,9.24819E+04,  3./
      DATA (u(i,6375),i=1,7)/24., 2., 6., 4., 4.32E-05,9.26123E+04,  3./
      DATA (u(i,6376),i=1,7)/24., 2., 6.,18., 5.40E-02,9.40338E+04,  2./
      DATA (u(i,6377),i=1,7)/24., 3.,25.,35., 2.59E+00,9.67996E+04,  2./
      DATA (u(i,6378),i=1,7)/24., 3.,25.,25., 3.29E+00,9.65491E+04,  2./
      DATA (u(i,6379),i=1,7)/24., 3.,25.,15., 2.00E+00,1.08224E+05,  2./
      DATA (u(i,6380),i=1,7)/24., 6.,10.,14., 1.00E-01,3.57657E+05,  3./
      DATA (u(i,6381),i=1,7)/24., 6.,10.,14., 4.10E-01,3.74079E+05,  3./
      DATA (u(i,6382),i=1,7)/24., 6.,10.,14., 7.70E+00,4.41177E+05,  3./
      DATA (u(i,6383),i=1,7)/24., 6.,10.,10., 1.60E+01,4.96609E+05,  3./
      DATA (u(i,6384),i=1,7)/24., 6.,10., 6., 4.40E+00,4.93792E+05,  3./
      DATA (u(i,6385),i=1,7)/24., 6.,10., 6., 3.20E-01,5.79423E+05,  2./
      DATA (u(i,6386),i=1,7)/24., 6.,10.,14., 1.10E+00,5.92197E+05,  2./
      DATA (u(i,6387),i=1,7)/24., 6.,10.,10., 7.30E-01,6.18298E+05,  2./
      DATA (u(i,6388),i=1,7)/24., 6.,10.,14., 4.40E-01,6.14789E+05,  2./
      DATA (u(i,6389),i=1,7)/24., 7., 1., 3., 2.80E-03,3.85828E+05,  3./
      DATA (u(i,6390),i=1,7)/24., 7., 1., 3., 3.09E+00,4.93035E+05,  3./
      DATA (u(i,6391),i=1,7)/24., 7., 1., 3., 1.30E-01,6.72428E+05,  2./
      DATA (u(i,6392),i=1,7)/24., 7., 1., 3., 2.90E-01,6.82610E+05,  2./
      DATA (u(i,6393),i=1,7)/24., 8., 6., 2., 2.12E-01,2.38768E+05,  3./
      DATA (u(i,6394),i=1,7)/24., 8., 6.,10., 9.60E+00,4.87843E+05,  3./
      DATA (u(i,6395),i=1,7)/24., 8., 6., 2., 1.87E+00,4.58233E+05,  3./
      DATA (u(i,6396),i=1,7)/24., 8., 6.,10., 1.80E-02,4.58703E+05,  3./
      DATA (u(i,6397),i=1,7)/24.,10., 4.,12., 3.88E-01,2.37428E+05,  3./
      DATA (u(i,6398),i=1,7)/24.,10., 4.,12., 6.80E+00,4.43780E+05,  3./
      DATA (u(i,6399),i=1,7)/24.,11., 9.,15., 4.32E-01,2.34615E+05,  3./
      DATA (u(i,6400),i=1,7)/24.,11., 9., 9., 5.22E-01,2.70026E+05,  3./
      DATA (u(i,6401),i=1,7)/24.,12., 6.,10., 3.84E-01,2.47000E+05,  3./
      DATA (u(i,6402),i=1,7)/24.,12., 6., 2., 4.08E-01,3.05660E+05,  3./
      DATA (u(i,6403),i=1,7)/24.,12., 6., 6., 2.70E+00,3.29160E+05,  3./
      DATA (u(i,6404),i=1,7)/24.,12., 6.,10., 3.30E+00,4.01210E+05,  3./
      DATA (u(i,6405),i=1,7)/24.,13., 1., 3., 1.90E-03,2.07400E+05,  3./
      DATA (u(i,6406),i=1,7)/24.,13., 1., 3., 9.02E-01,3.04610E+05,  3./
      DATA (u(i,6407),i=1,7)/24.,13., 1., 3., 3.38E-01,1.49200E+06,  2./
      DATA (u(i,6408),i=1,7)/24.,13., 1., 3., 1.09E-01,2.01700E+06,  2./
      DATA (u(i,6409),i=1,7)/24.,14., 2., 6., 8.58E-01,2.51930E+05,  3./
      DATA (u(i,6410),i=1,7)/24.,14., 2., 6., 3.94E-01,1.57741E+06,  2./
      DATA (u(i,6411),i=1,7)/24.,14., 2., 6., 1.28E-01,2.15110E+06,  2./
      DATA (u(i,6412),i=1,7)/24.,14., 2., 6., 5.84E-02,2.45170E+06,  2./
      DATA (u(i,6413),i=1,7)/24.,14., 2., 6., 3.22E-02,2.62910E+06,  2./
      DATA (u(i,6414),i=1,7)/24.,14., 2., 6., 2.00E-02,2.74230E+06,  2./
      DATA (u(i,6415),i=1,7)/24.,15., 1., 3., 1.10E-01,4.72750E+06, 21./
      DATA (u(i,6416),i=1,7)/24.,15., 1., 3., 1.20E-01,4.79320E+06, 21./
      DATA (u(i,6417),i=1,7)/24.,15., 1., 3., 1.00E-02,5.25900E+06, 19./
      DATA (u(i,6418),i=1,7)/24.,15., 1., 3., 4.40E-01,5.32420E+06, 19./
      DATA (u(i,6419),i=1,7)/24.,15., 1., 3., 2.49E+00,5.40630E+06, 19./
      DATA (u(i,6420),i=1,7)/24.,16., 6., 2., 3.75E-01,9.14279E+05,  3./
      DATA (u(i,6421),i=1,7)/24.,16., 6., 2., 9.60E-02,5.29997E+06,  2./
      DATA (u(i,6422),i=1,7)/24.,16., 6., 2., 1.14E+00,5.71097E+06,  2./
      DATA (u(i,6423),i=1,7)/24.,16., 6.,10., 1.80E+00,5.83897E+06,  2./
      DATA (u(i,6424),i=1,7)/24.,17., 9., 9., 9.00E-01,8.10120E+05,  3./
      DATA (u(i,6425),i=1,7)/24.,17., 9., 3., 4.14E-01,5.42721E+06,  2./
      DATA (u(i,6426),i=1,7)/24.,18., 4.,12., 5.20E-01,6.94180E+05,  3./
      DATA (u(i,6427),i=1,7)/24.,18., 4., 2., 2.44E-03,1.06206E+06,  3./
      DATA (u(i,6428),i=1,7)/24.,19., 9.,15., 4.26E-01,6.17210E+05,  3./
      DATA (u(i,6429),i=1,7)/24.,19., 9., 9., 4.68E-01,7.37720E+05,  3./
      DATA (u(i,6430),i=1,7)/24.,19., 9., 3., 4.95E-01,8.98150E+05,  3./
      DATA (u(i,6431),i=1,7)/24.,20., 6.,10., 2.70E-01,5.92920E+05,  3./
      DATA (u(i,6432),i=1,7)/24.,21., 1., 3., 1.00E-03,3.41170E+05,  3./
      DATA (u(i,6433),i=1,7)/24.,21., 1., 3., 1.64E-01,6.67110E+05,  3./
      DATA (u(i,6434),i=1,7)/24.,21., 1., 3., 2.90E-01,7.62000E+06,  2./
      DATA (u(i,6435),i=1,7)/24.,21., 1., 3., 4.00E-01,7.64800E+06,  2./
      DATA (u(i,6436),i=1,7)/24.,22., 2., 6., 1.36E-01,4.18140E+05, 14./
      DATA (u(i,6437),i=1,7)/24.,22., 2., 6., 7.46E-01,7.91350E+06, 16./
      DATA (u(i,6438),i=1,7)/24.,22., 2., 6., 2.00E-01,1.05300E+07, 18./
      DATA (u(i,6439),i=1,7)/24.,22., 2., 6., 8.00E-02,1.17370E+07, 18./
      DATA (u(i,6440),i=1,7)/24.,22., 2., 6., 4.24E-02,1.23920E+07, 18./
      DATA (u(i,6441),i=1,7)/24.,22., 2., 6., 2.48E-02,1.27880E+07, 18./
      DATA (u(i,6442),i=1,7)/24.,23., 1., 3., 5.05E-02,4.56149E+07, 25./
      DATA (u(i,6443),i=1,7)/24.,23., 1., 3., 7.21E-01,4.58329E+07, 11./
      DATA (u(i,6444),i=1,7)/24.,23., 1., 3., 1.30E-02,5.38266E+07, 25./
      DATA (u(i,6445),i=1,7)/24.,23., 1., 3., 1.39E-01,5.38882E+07, 12./
      DATA (u(i,6446),i=1,7)/24.,23., 1., 3., 4.50E-03,5.66889E+07, 25./
      DATA (u(i,6447),i=1,7)/24.,23., 1., 3., 5.14E-02,5.67144E+07, 13./
      DATA (u(i,6448),i=1,7)/24.,23., 1., 3., 2.20E-03,5.80101E+07, 25./
      DATA (u(i,6449),i=1,7)/24.,23., 1., 3., 2.48E-02,5.80231E+07, 13./
      DATA (u(i,6450),i=1,7)/24.,24., 2., 6., 8.32E-01,4.73861E+07,  4./
      DATA (u(i,6451),i=1,7)/24.,24., 2., 6., 1.58E-01,5.61613E+07,  5./
      DATA (u(i,6452),i=1,7)/24.,24., 2., 6., 5.80E-02,5.92326E+07,  6./
      DATA (u(i,6453),i=1,7)/24.,24., 2., 6., 2.79E-02,6.06542E+07,  7./
      DATA (u(i,6454),i=1,7)/24.,24., 2., 6., 1.56E-02,6.14264E+07,  8./
      DATA (u(i,6455),i=1,7)/24.,24., 2., 6., 9.63E-03,6.18920E+07,  9./
      DATA (u(i,6456),i=1,7)/24.,24., 2., 6., 6.37E-03,6.21942E+07,  9./
      DATA (u(i,6457),i=1,7)/24.,24., 2., 6., 4.43E-03,6.24014E+07,  9./
      DATA (u(i,6458),i=1,7)/24.,24., 2., 6., 3.21E-03,6.25496E+07,  9./
      DATA (u(i,6459),i=1,7)/25., 1., 6.,18., 7.20E-01,2.47920E+04,  1./
      DATA (u(i,6460),i=1,7)/25., 1., 6.,18., 7.80E+00,3.57380E+04,  1./
      DATA (u(i,6461),i=1,7)/25., 1., 6.,18., 1.00E+00,4.51069E+04,  1./
      DATA (u(i,6462),i=1,7)/25., 1., 6.,18., 8.23E-01,4.99764E+04,  1./
      DATA (u(i,6463),i=1,7)/25., 2., 7.,21., 5.70E+00,3.86139E+04,  3./
      DATA (u(i,6464),i=1,7)/25., 2., 7.,21., 2.45E+00,8.34130E+04,  3./
      DATA (u(i,6465),i=1,7)/25., 2., 7.,21., 1.57E-01,8.59865E+04,  3./
      DATA (u(i,6466),i=1,7)/25., 6.,21.,21., 1.58E+00,3.24287E+05,  2./
      DATA (u(i,6467),i=1,7)/25., 7.,10., 6., 2.10E-01,4.06074E+05,  3./
      DATA (u(i,6468),i=1,7)/25., 7.,10.,14., 4.00E-01,4.13027E+05,  3./
      DATA (u(i,6469),i=1,7)/25., 7.,10.,14., 7.90E+00,4.91639E+05,  3./
      DATA (u(i,6470),i=1,7)/25., 7.,10.,10., 1.50E+01,5.46797E+05,  3./
      DATA (u(i,6471),i=1,7)/25., 7.,10., 6., 6.50E+00,5.42723E+05,  3./
      DATA (u(i,6472),i=1,7)/25., 7.,10., 6., 3.70E-01,7.03210E+05,  2./
      DATA (u(i,6473),i=1,7)/25., 7.,10.,14., 1.20E+00,7.18879E+05,  2./
      DATA (u(i,6474),i=1,7)/25., 7.,10.,10., 8.30E-01,7.48237E+05,  2./
      DATA (u(i,6475),i=1,7)/25., 7.,10.,14., 4.10E-01,7.42910E+05,  2./
      DATA (u(i,6476),i=1,7)/25., 8., 1., 3., 2.87E+00,5.39214E+05,  3./
      DATA (u(i,6477),i=1,7)/25., 8., 1., 3., 1.40E-01,8.06094E+05,  2./
      DATA (u(i,6478),i=1,7)/25., 8., 1., 3., 2.70E-01,8.18545E+05,  2./
      DATA (u(i,6479),i=1,7)/25., 9., 6., 2., 2.10E-01,2.61226E+05,  3./
      DATA (u(i,6480),i=1,7)/25., 9., 6.,10., 9.00E+00,5.30608E+05,  3./
      DATA (u(i,6481),i=1,7)/25., 9., 6., 2., 1.75E+00,4.97528E+05,  3./
      DATA (u(i,6482),i=1,7)/25., 9., 6.,10., 1.98E-02,5.00018E+05,  3./
      DATA (u(i,6483),i=1,7)/25.,11., 4.,12., 3.84E-01,2.58405E+05,  3./
      DATA (u(i,6484),i=1,7)/25.,12., 9.,15., 4.14E-01,2.55100E+05,  3./
      DATA (u(i,6485),i=1,7)/25.,12., 9., 9., 5.13E-01,2.93260E+05,  3./
      DATA (u(i,6486),i=1,7)/25.,13., 6.,10., 3.72E-01,2.67333E+05,  3./
      DATA (u(i,6487),i=1,7)/25.,13., 6., 2., 4.08E-01,3.28843E+05,  3./
      DATA (u(i,6488),i=1,7)/25.,13., 6., 6., 2.58E+00,3.54973E+05,  3./
      DATA (u(i,6489),i=1,7)/25.,13., 6.,10., 3.12E+00,4.31413E+05,  3./
      DATA (u(i,6490),i=1,7)/25.,14., 1., 3., 2.40E-03,2.23200E+05,  3./
      DATA (u(i,6491),i=1,7)/25.,14., 1., 3., 8.63E-01,3.28030E+05,  3./
      DATA (u(i,6492),i=1,7)/25.,14., 1., 3., 3.55E-01,1.68560E+06,  2./
      DATA (u(i,6493),i=1,7)/25.,14., 1., 3., 1.12E-01,2.28600E+06,  2./
      DATA (u(i,6494),i=1,7)/25.,15., 2., 6., 8.22E-01,2.71330E+05,  3./
      DATA (u(i,6495),i=1,7)/25.,15., 2., 6., 4.14E-01,1.77490E+06,  2./
      DATA (u(i,6496),i=1,7)/25.,15., 2., 6., 1.34E-01,2.42700E+06,  2./
      DATA (u(i,6497),i=1,7)/25.,15., 2., 6., 6.08E-02,2.76970E+06,  2./
      DATA (u(i,6498),i=1,7)/25.,15., 2., 6., 3.34E-02,2.97310E+06,  2./
      DATA (u(i,6499),i=1,7)/25.,15., 2., 6., 2.06E-02,3.10270E+06,  2./
      DATA (u(i,6500),i=1,7)/25.,16., 1., 3., 1.20E-01,5.28120E+06, 21./
      DATA (u(i,6501),i=1,7)/25.,16., 1., 3., 1.10E-01,5.36080E+06, 21./
      DATA (u(i,6502),i=1,7)/25.,16., 1., 3., 1.10E-02,5.84970E+06, 19./
      DATA (u(i,6503),i=1,7)/25.,16., 1., 3., 5.30E-01,5.92350E+06, 19./
      DATA (u(i,6504),i=1,7)/25.,16., 1., 3., 2.48E+00,6.01830E+06, 19./
      DATA (u(i,6505),i=1,7)/25.,17., 6., 2., 3.63E-01,9.71500E+05,  3./
      DATA (u(i,6506),i=1,7)/25.,17., 6., 2., 9.60E-02,5.89440E+06,  2./
      DATA (u(i,6507),i=1,7)/25.,17., 6., 2., 1.14E+00,6.32820E+06,  2./
      DATA (u(i,6508),i=1,7)/25.,17., 6.,10., 1.92E+00,6.46980E+06,  2./
      DATA (u(i,6509),i=1,7)/25.,18., 9., 9., 8.64E-01,8.62300E+05,  3./
      DATA (u(i,6510),i=1,7)/25.,18., 9., 3., 3.87E-01,6.02097E+06,  2./
      DATA (u(i,6511),i=1,7)/25.,19., 4.,12., 4.80E-01,7.40730E+05,  3./
      DATA (u(i,6512),i=1,7)/25.,19., 4., 2., 3.24E-03,1.12682E+06,  3./
      DATA (u(i,6513),i=1,7)/25.,20., 9., 9., 4.59E-01,7.89110E+05,  3./
      DATA (u(i,6514),i=1,7)/25.,20., 9., 3., 4.59E-01,9.50850E+05,  3./
      DATA (u(i,6515),i=1,7)/25.,21., 6.,10., 2.70E-01,6.31290E+05,  3./
      DATA (u(i,6516),i=1,7)/25.,22., 1., 3., 1.30E-03,3.59970E+05,  3./
      DATA (u(i,6517),i=1,7)/25.,22., 1., 3., 1.59E-01,7.08770E+05,  3./
      DATA (u(i,6518),i=1,7)/25.,22., 1., 3., 2.80E-01,8.33500E+06,  2./
      DATA (u(i,6519),i=1,7)/25.,22., 1., 3., 4.20E-01,8.35400E+06,  2./
      DATA (u(i,6520),i=1,7)/25.,23., 2., 6., 1.34E-01,4.47130E+05, 14./
      DATA (u(i,6521),i=1,7)/25.,23., 2., 6., 7.48E-01,8.63810E+06, 16./
      DATA (u(i,6522),i=1,7)/25.,23., 2., 6., 2.00E-01,1.15100E+07, 18./
      DATA (u(i,6523),i=1,7)/25.,23., 2., 6., 8.00E-02,1.28300E+07, 18./
      DATA (u(i,6524),i=1,7)/25.,23., 2., 6., 4.24E-02,1.35320E+07, 18./
      DATA (u(i,6525),i=1,7)/25.,23., 2., 6., 2.50E-02,1.39660E+07, 18./
      DATA (u(i,6526),i=1,7)/25.,24., 1., 3., 5.94E-02,4.96141E+07, 25./
      DATA (u(i,6527),i=1,7)/25.,24., 1., 3., 7.12E-01,4.98531E+07, 11./
      DATA (u(i,6528),i=1,7)/25.,24., 1., 3., 1.50E-02,5.85593E+07, 25./
      DATA (u(i,6529),i=1,7)/25.,24., 1., 3., 1.39E-01,5.86271E+07, 12./
      DATA (u(i,6530),i=1,7)/25.,24., 1., 3., 5.10E-03,6.16773E+07, 25./
      DATA (u(i,6531),i=1,7)/25.,24., 1., 3., 5.10E-02,6.17054E+07, 13./
      DATA (u(i,6532),i=1,7)/25.,24., 1., 3., 2.50E-03,6.31165E+07, 25./
      DATA (u(i,6533),i=1,7)/25.,24., 1., 3., 2.46E-02,6.31308E+07, 13./
      DATA (u(i,6534),i=1,7)/25.,25., 2., 6., 8.32E-01,5.14172E+07,  4./
      DATA (u(i,6535),i=1,7)/25.,25., 2., 6., 1.58E-01,6.09389E+07,  5./
      DATA (u(i,6536),i=1,7)/25.,25., 2., 6., 5.80E-02,6.42715E+07,  6./
      DATA (u(i,6537),i=1,7)/25.,25., 2., 6., 2.79E-02,6.58140E+07,  7./
      DATA (u(i,6538),i=1,7)/25.,25., 2., 6., 1.56E-02,6.66519E+07,  8./
      DATA (u(i,6539),i=1,7)/25.,25., 2., 6., 9.63E-03,6.71571E+07,  9./
      DATA (u(i,6540),i=1,7)/25.,25., 2., 6., 6.37E-03,6.74851E+07,  9./
      DATA (u(i,6541),i=1,7)/25.,25., 2., 6., 4.43E-03,6.77099E+07,  9./
      DATA (u(i,6542),i=1,7)/25.,25., 2., 6., 3.21E-03,6.78707E+07,  9./
      DATA (u(i,6543),i=1,7)/27., 1.,28.,28., 7.28E-01,2.80359E+04,  1./
      DATA (u(i,6544),i=1,7)/27., 1.,28.,20., 5.88E-01,2.90729E+04,  1./
      DATA (u(i,6545),i=1,7)/27., 2.,21.,27., 1.25E+00,4.85069E+04,  3./
      DATA (u(i,6546),i=1,7)/27., 2.,21.,21., 1.33E+00,4.95184E+04,  3./
      DATA (u(i,6547),i=1,7)/27., 2.,21.,15., 1.42E+00,5.12889E+04,  3./
      DATA (u(i,6548),i=1,7)/27., 2.,21.,21., 2.01E+00,6.34553E+04,  3./
      DATA (u(i,6549),i=1,7)/27., 2.,21.,27., 3.11E+00,6.80187E+04,  3./
      DATA (u(i,6550),i=1,7)/27., 3.,28.,20., 2.68E+00,1.06074E+05,  3./
      DATA (u(i,6551),i=1,7)/27., 3.,28.,28., 1.48E+00,1.06676E+05,  3./
      DATA (u(i,6552),i=1,7)/27., 8.,21.,21., 2.06E+01,6.16993E+05,  3./
      DATA (u(i,6553),i=1,7)/27., 9.,10.,14., 3.60E-01,4.89921E+05,  3./
      DATA (u(i,6554),i=1,7)/27., 9.,10.,14., 7.20E+00,5.83592E+05,  3./
      DATA (u(i,6555),i=1,7)/27., 9.,10.,10., 1.30E+01,6.43598E+05,  3./
      DATA (u(i,6556),i=1,7)/27., 9.,10., 6., 5.60E+00,6.51746E+05,  3./
      DATA (u(i,6557),i=1,7)/27., 9.,10., 6., 4.80E-01,9.88236E+05,  2./
      DATA (u(i,6558),i=1,7)/27., 9.,10.,14., 1.10E+00,1.00452E+06,  2./
      DATA (u(i,6559),i=1,7)/27.,10., 1., 3., 2.50E+00,6.29450E+05,  3./
      DATA (u(i,6560),i=1,7)/27.,10., 1., 3., 1.60E-01,1.10500E+06,  2./
      DATA (u(i,6561),i=1,7)/27.,10., 1., 3., 2.30E-01,1.12400E+06,  2./
      DATA (u(i,6562),i=1,7)/27.,10., 1., 3., 3.90E-01,1.38000E+06,  2./
      DATA (u(i,6563),i=1,7)/27.,10., 1., 3., 2.00E-01,1.39900E+06,  2./
      DATA (u(i,6564),i=1,7)/27.,11., 6., 2., 2.03E-01,3.07180E+05,  3./
      DATA (u(i,6565),i=1,7)/27.,11., 6.,10., 7.68E+00,6.15340E+05,  3./
      DATA (u(i,6566),i=1,7)/27.,11., 6., 2., 1.56E+00,5.76060E+05,  3./
      DATA (u(i,6567),i=1,7)/27.,13., 4.,12., 3.84E-01,3.01940E+05,  3./
      DATA (u(i,6568),i=1,7)/27.,13., 4.,12., 5.20E+00,5.51040E+05,  3./
      DATA (u(i,6569),i=1,7)/27.,14., 9.,15., 4.05E-01,2.96740E+05,  3./
      DATA (u(i,6570),i=1,7)/27.,14., 9., 9., 4.95E-01,3.42470E+05,  3./
      DATA (u(i,6571),i=1,7)/27.,15., 6.,10., 3.54E-01,3.09250E+05,  3./
      DATA (u(i,6572),i=1,7)/27.,15., 6., 2., 4.32E-01,3.75510E+05,  3./
      DATA (u(i,6573),i=1,7)/27.,15., 6., 6., 2.34E+00,4.08330E+05,  3./
      DATA (u(i,6574),i=1,7)/27.,15., 6.,10., 2.82E+00,4.92440E+05,  3./
      DATA (u(i,6575),i=1,7)/27.,16., 1., 3., 3.70E-03,2.57070E+05,  3./
      DATA (u(i,6576),i=1,7)/27.,16., 1., 3., 7.96E-01,3.76310E+05,  3./
      DATA (u(i,6577),i=1,7)/27.,16., 1., 3., 3.81E-01,2.10580E+06,  2./
      DATA (u(i,6578),i=1,7)/27.,17., 2., 6., 7.60E-01,3.11490E+05,  3./
      DATA (u(i,6579),i=1,7)/27.,17., 2., 6., 4.40E-01,2.20320E+06,  2./
      DATA (u(i,6580),i=1,7)/27.,17., 2., 6., 1.44E-01,3.02920E+06,  2./
      DATA (u(i,6581),i=1,7)/27.,17., 2., 6., 6.52E-02,3.46380E+06,  2./
      DATA (u(i,6582),i=1,7)/27.,18., 1., 3., 2.90E-01,7.93270E+06, 21./
      DATA (u(i,6583),i=1,7)/27.,18., 1., 3., 1.20E-01,9.97010E+06, 21./
      DATA (u(i,6584),i=1,7)/27.,18., 1., 3., 1.19E-01,6.47790E+06, 21./
      DATA (u(i,6585),i=1,7)/27.,18., 1., 3., 1.05E-01,6.59240E+06, 21./
      DATA (u(i,6586),i=1,7)/27.,18., 1., 3., 1.20E-02,7.12200E+06, 19./
      DATA (u(i,6587),i=1,7)/27.,18., 1., 3., 7.00E-01,7.21080E+06, 19./
      DATA (u(i,6588),i=1,7)/27.,18., 1., 3., 2.40E+00,7.33460E+06, 19./
      DATA (u(i,6589),i=1,7)/27.,18., 1., 3., 2.50E-02,8.70630E+06, 22./
      DATA (u(i,6590),i=1,7)/27.,18., 1., 3., 2.20E-02,8.83310E+06, 22./
      DATA (u(i,6591),i=1,7)/27.,18., 1., 3., 3.40E-03,8.96860E+06, 20./
      DATA (u(i,6592),i=1,7)/27.,18., 1., 3., 4.20E-01,9.00250E+06, 20./
      DATA (u(i,6593),i=1,7)/27.,18., 1., 3., 5.10E-01,9.11160E+06, 20./
      DATA (u(i,6594),i=1,7)/27.,19., 6., 2., 3.38E-01,1.09100E+06,  3./
      DATA (u(i,6595),i=1,7)/27.,19., 6., 2., 1.14E+00,7.66260E+06,  2./
      DATA (u(i,6596),i=1,7)/27.,20., 9., 9., 8.28E-01,9.74440E+05,  3./
      DATA (u(i,6597),i=1,7)/27.,21., 4.,12., 4.44E-01,8.43230E+05,  3./
      DATA (u(i,6598),i=1,7)/27.,21., 4., 2., 5.20E-03,1.26747E+06,  3./
      DATA (u(i,6599),i=1,7)/27.,22., 9.,15., 3.87E-01,7.44270E+05,  3./
      DATA (u(i,6600),i=1,7)/27.,22., 9., 9., 4.41E-01,9.02430E+05,  3./
      DATA (u(i,6601),i=1,7)/27.,22., 9., 3., 4.39E-01,1.06344E+06,  3./
      DATA (u(i,6602),i=1,7)/27.,23., 6.,10., 2.50E-01,7.14020E+05,  3./
      DATA (u(i,6603),i=1,7)/27.,23., 6., 6., 5.28E-01,9.18170E+05,  3./
      DATA (u(i,6604),i=1,7)/27.,23., 6., 2., 1.50E-01,9.58020E+05,  3./
      DATA (u(i,6605),i=1,7)/27.,24., 1., 3., 1.80E-03,3.98720E+05,  3./
      DATA (u(i,6606),i=1,7)/27.,24., 1., 3., 1.52E-01,7.99040E+05,  3./
      DATA (u(i,6607),i=1,7)/27.,24., 1., 3., 2.70E-01,9.88600E+06,  2./
      DATA (u(i,6608),i=1,7)/27.,25., 2., 6., 1.29E-01,5.12820E+05, 14./
      DATA (u(i,6609),i=1,7)/27.,25., 2., 6., 7.52E-01,1.01937E+07, 16./
      DATA (u(i,6610),i=1,7)/27.,26., 1., 3., 7.84E-02,5.81282E+07, 25./
      DATA (u(i,6611),i=1,7)/27.,26., 1., 3., 6.93E-01,5.84165E+07, 11./
      DATA (u(i,6612),i=1,7)/27.,26., 1., 3., 1.80E-02,6.86377E+07, 25./
      DATA (u(i,6613),i=1,7)/27.,26., 1., 3., 1.35E-01,6.87202E+07, 12./
      DATA (u(i,6614),i=1,7)/27.,26., 1., 3., 6.60E-03,7.23011E+07, 25./
      DATA (u(i,6615),i=1,7)/27.,26., 1., 3., 4.88E-02,7.23354E+07, 13./
      DATA (u(i,6616),i=1,7)/27.,26., 1., 3., 3.30E-03,7.39919E+07, 25./
      DATA (u(i,6617),i=1,7)/27.,26., 1., 3., 2.40E-02,7.40094E+07, 13./
      DATA (u(i,6618),i=1,7)/27.,27., 2., 6., 8.32E-01,5.99730E+07,  4./
      DATA (u(i,6619),i=1,7)/27.,27., 2., 6., 1.58E-01,7.10791E+07,  5./
      DATA (u(i,6620),i=1,7)/27.,27., 2., 6., 5.80E-02,7.49663E+07,  6./
      DATA (u(i,6621),i=1,7)/27.,27., 2., 6., 2.79E-02,7.67654E+07,  7./
      DATA (u(i,6622),i=1,7)/27.,27., 2., 6., 1.56E-02,7.77428E+07,  8./
      DATA (u(i,6623),i=1,7)/27.,27., 2., 6., 9.63E-03,7.83321E+07,  9./
      DATA (u(i,6624),i=1,7)/27.,27., 2., 6., 6.37E-03,7.87146E+07,  9./
      DATA (u(i,6625),i=1,7)/27.,27., 2., 6., 4.43E-03,7.89768E+07,  9./
      DATA (u(i,6626),i=1,7)/27.,27., 2., 6., 3.21E-03,7.91644E+07,  9./
      DATA (u(i,6627),i=1,7)/28., 1.,21.,21., 2.52E-01,2.87272E+04,  1./
      DATA (u(i,6628),i=1,7)/28., 1.,21.,27., 2.10E-01,3.01942E+04,  1./
      DATA (u(i,6629),i=1,7)/28., 1.,21.,21., 1.18E-01,3.21992E+04,  1./
      DATA (u(i,6630),i=1,7)/28., 1.,21.,15., 1.25E-01,3.29312E+04,  1./
      DATA (u(i,6631),i=1,7)/28., 2.,10.,14., 9.06E-01,5.70832E+04,  2./
      DATA (u(i,6632),i=1,7)/28., 2.,10.,10., 1.47E+00,5.73317E+04,  2./
      DATA (u(i,6633),i=1,7)/28., 2.,10.,14., 2.41E-01,6.73413E+04,  2./
      DATA (u(i,6634),i=1,7)/28., 2.,10.,10., 6.20E-01,6.79006E+04,  2./
      DATA (u(i,6635),i=1,7)/28., 2.,10.,10., 4.49E-01,7.14099E+04,  2./
      DATA (u(i,6636),i=1,7)/28., 2.,10., 6., 1.30E+00,7.26887E+04,  2./
      DATA (u(i,6637),i=1,7)/28., 2.,10.,14., 1.56E+00,7.55225E+04,  2./
      DATA (u(i,6638),i=1,7)/28.,11., 1., 3., 2.90E-04,4.72974E+05,  3./
      DATA (u(i,6639),i=1,7)/28.,11., 1., 3., 6.80E-03,5.34828E+05,  3./
      DATA (u(i,6640),i=1,7)/28.,11., 1., 3., 2.31E+00,6.73973E+05,  3./
      DATA (u(i,6641),i=1,7)/28.,11., 1., 3., 1.70E-01,1.26990E+06,  2./
      DATA (u(i,6642),i=1,7)/28.,11., 1., 3., 2.30E-01,1.29210E+06,  2./
      DATA (u(i,6643),i=1,7)/28.,11., 1., 3., 4.50E-01,1.57130E+06,  2./
      DATA (u(i,6644),i=1,7)/28.,11., 1., 3., 2.20E-01,1.59410E+06,  2./
      DATA (u(i,6645),i=1,7)/28.,12., 6., 2., 1.99E-01,3.30738E+05,  3./
      DATA (u(i,6646),i=1,7)/28.,12., 6.,10., 7.20E+00,6.57013E+05,  3./
      DATA (u(i,6647),i=1,7)/28.,12., 6., 2., 1.50E+00,6.14966E+05,  3./
      DATA (u(i,6648),i=1,7)/28.,14., 4.,12., 3.64E-01,3.24680E+05,  3./
      DATA (u(i,6649),i=1,7)/28.,14., 4.,12., 4.80E+00,5.87340E+05,  3./
      DATA (u(i,6650),i=1,7)/28.,15., 9.,15., 3.96E-01,3.17829E+05,  3./
      DATA (u(i,6651),i=1,7)/28.,15., 9., 9., 5.04E-01,3.67649E+05,  3./
      DATA (u(i,6652),i=1,7)/28.,16., 6.,10., 3.54E-01,3.31021E+05,  3./
      DATA (u(i,6653),i=1,7)/28.,16., 6., 2., 4.38E-01,3.98942E+05,  3./
      DATA (u(i,6654),i=1,7)/28.,16., 6., 6., 2.28E+00,4.36153E+05,  3./
      DATA (u(i,6655),i=1,7)/28.,16., 6.,10., 2.70E+00,5.23313E+05,  3./
      DATA (u(i,6656),i=1,7)/28.,17., 1., 3., 3.50E-03,2.72700E+05,  3./
      DATA (u(i,6657),i=1,7)/28.,17., 1., 3., 7.67E-01,4.01316E+05,  3./
      DATA (u(i,6658),i=1,7)/28.,17., 1., 3., 3.92E-01,2.33350E+06,  2./
      DATA (u(i,6659),i=1,7)/28.,17., 1., 3., 1.19E-01,3.23430E+06,  2./
      DATA (u(i,6660),i=1,7)/28.,18., 2., 6., 7.34E-01,3.32310E+05,  3./
      DATA (u(i,6661),i=1,7)/28.,18., 2., 6., 4.60E-01,2.43440E+06,  2./
      DATA (u(i,6662),i=1,7)/28.,18., 2., 6., 1.48E-01,3.35620E+06,  2./
      DATA (u(i,6663),i=1,7)/28.,18., 2., 6., 6.68E-02,3.84190E+06,  2./
      DATA (u(i,6664),i=1,7)/28.,19., 1., 3., 3.80E-02,8.62140E+06, 21./
      DATA (u(i,6665),i=1,7)/28.,19., 1., 3., 2.90E-01,8.66630E+06, 21./
      DATA (u(i,6666),i=1,7)/28.,19., 1., 3., 2.00E-02,1.09300E+07, 21./
      DATA (u(i,6667),i=1,7)/28.,19., 1., 3., 1.20E-01,1.09400E+07, 21./
      DATA (u(i,6668),i=1,7)/28.,19., 1., 3., 1.16E-01,7.12100E+06, 21./
      DATA (u(i,6669),i=1,7)/28.,19., 1., 3., 1.05E-01,7.25740E+06, 21./
      DATA (u(i,6670),i=1,7)/28.,19., 1., 3., 8.10E-03,7.80520E+06, 19./
      DATA (u(i,6671),i=1,7)/28.,19., 1., 3., 7.20E-01,7.90140E+06, 19./
      DATA (u(i,6672),i=1,7)/28.,19., 1., 3., 2.55E+00,8.04180E+06, 19./
      DATA (u(i,6673),i=1,7)/28.,19., 1., 3., 2.50E-02,9.58500E+06, 22./
      DATA (u(i,6674),i=1,7)/28.,19., 1., 3., 2.20E-02,9.72480E+06, 22./
      DATA (u(i,6675),i=1,7)/28.,19., 1., 3., 3.20E-03,9.84540E+06, 20./
      DATA (u(i,6676),i=1,7)/28.,19., 1., 3., 4.30E-01,9.89120E+06, 20./
      DATA (u(i,6677),i=1,7)/28.,19., 1., 3., 4.90E-01,1.00200E+07, 20./
      DATA (u(i,6678),i=1,7)/28.,20., 6., 2., 3.26E-01,1.15401E+06,  3./
      DATA (u(i,6679),i=1,7)/28.,20., 6.,10., 4.44E-01,7.69031E+06,  2./
      DATA (u(i,6680),i=1,7)/28.,20., 6., 2., 9.60E-02,7.90121E+06,  2./
      DATA (u(i,6681),i=1,7)/28.,20., 6., 2., 1.14E+00,8.37381E+06,  2./
      DATA (u(i,6682),i=1,7)/28.,21., 9., 9., 8.01E-01,1.03444E+06,  3./
      DATA (u(i,6683),i=1,7)/28.,21., 9., 3., 3.42E-01,7.97662E+06,  2./
      DATA (u(i,6684),i=1,7)/28.,22., 4.,12., 4.28E-01,8.99720E+05,  3./
      DATA (u(i,6685),i=1,7)/28.,22., 4., 2., 6.40E-03,1.34463E+06,  3./
      DATA (u(i,6686),i=1,7)/28.,23., 9.,15., 3.60E-01,7.91620E+05,  3./
      DATA (u(i,6687),i=1,7)/28.,23., 9., 9., 4.43E-01,9.65180E+05,  3./
      DATA (u(i,6688),i=1,7)/28.,23., 9., 3., 4.17E-01,1.12415E+06,  3./
      DATA (u(i,6689),i=1,7)/28.,24., 6., 6., 5.04E-01,9.71440E+05,  3./
      DATA (u(i,6690),i=1,7)/28.,24., 6., 2., 1.46E-01,1.02044E+06,  3./
      DATA (u(i,6691),i=1,7)/28.,25., 1., 3., 2.10E-03,4.18720E+05,  3./
      DATA (u(i,6692),i=1,7)/28.,25., 1., 3., 1.49E-01,8.48100E+05,  3./
      DATA (u(i,6693),i=1,7)/28.,25., 1., 3., 2.60E-01,1.06500E+07,  2./
      DATA (u(i,6694),i=1,7)/28.,25., 1., 3., 4.50E-01,1.07070E+07,  2./
      DATA (u(i,6695),i=1,7)/28.,26., 2., 6., 1.27E-01,5.45340E+05, 14./
      DATA (u(i,6696),i=1,7)/28.,26., 2., 6., 7.50E-01,1.10200E+07, 16./
      DATA (u(i,6697),i=1,7)/28.,27., 1., 3., 8.83E-02,6.26442E+07, 25./
      DATA (u(i,6698),i=1,7)/28.,27., 1., 3., 6.83E-01,6.29615E+07, 11./
      DATA (u(i,6699),i=1,7)/28.,27., 1., 3., 2.00E-02,7.39850E+07, 25./
      DATA (u(i,6700),i=1,7)/28.,27., 1., 3., 1.34E-01,7.40763E+07, 12./
      DATA (u(i,6701),i=1,7)/28.,27., 1., 3., 7.40E-03,7.79382E+07, 25./
      DATA (u(i,6702),i=1,7)/28.,27., 1., 3., 4.72E-02,7.79762E+07, 13./
      DATA (u(i,6703),i=1,7)/28.,27., 1., 3., 3.70E-03,7.97626E+07, 25./
      DATA (u(i,6704),i=1,7)/28.,27., 1., 3., 2.37E-02,7.97820E+07, 13./
      DATA (u(i,6705),i=1,7)/28.,28., 2., 6., 8.32E-01,6.44977E+07,  4./
      DATA (u(i,6706),i=1,7)/28.,28., 2., 6., 1.58E-01,7.64417E+07,  5./
      DATA (u(i,6707),i=1,7)/28.,28., 2., 6., 5.80E-02,8.06222E+07,  6./
      DATA (u(i,6708),i=1,7)/28.,28., 2., 6., 2.79E-02,8.25571E+07,  7./
      DATA (u(i,6709),i=1,7)/28.,28., 2., 6., 1.56E-02,8.36082E+07,  8./
      DATA (u(i,6710),i=1,7)/28.,28., 2., 6., 9.63E-03,8.42419E+07,  9./
      DATA (u(i,6711),i=1,7)/28.,28., 2., 6., 6.37E-03,8.46533E+07,  9./
      DATA (u(i,6712),i=1,7)/28.,28., 2., 6., 4.43E-03,8.49353E+07,  9./
      DATA (u(i,6713),i=1,7)/28.,28., 2., 6., 3.21E-03,8.51370E+07,  9./
      DATA (u(i,6714),i=1,7)/29., 1., 2., 6., 1.29E+00,3.07009E+04,  1./
      DATA (u(i,6715),i=1,7)/29., 1., 2., 6., 3.89E-01,4.58599E+04,  1./
      DATA (u(i,6716),i=1,7)/29., 1., 2., 4., 1.43E-01,4.61728E+04,  1./
      DATA (u(i,6717),i=1,7)/29., 1., 2., 6., 3.61E-02,4.93831E+04,  1./
      DATA (u(i,6718),i=1,7)/29., 2., 1., 3., 8.38E-03,6.79166E+04,  2./
      DATA (u(i,6719),i=1,7)/29., 2., 1., 3., 3.32E-02,7.31020E+04,  2./
      DATA (u(i,6720),i=1,7)/29., 2., 1., 3., 3.80E-01,7.35958E+04,  2./
      DATA (u(i,6721),i=1,7)/29.,29., 2., 6., 8.32E-01,6.91870E+07,  4./
      DATA (u(i,6722),i=1,7)/29.,29., 2., 6., 1.58E-01,8.19994E+07,  5./
      DATA (u(i,6723),i=1,7)/29.,29., 2., 6., 5.80E-02,8.64837E+07,  6./
      DATA (u(i,6724),i=1,7)/29.,29., 2., 6., 2.79E-02,8.85593E+07,  7./
      DATA (u(i,6725),i=1,7)/29.,29., 2., 6., 1.56E-02,8.96868E+07,  8./
      DATA (u(i,6726),i=1,7)/29.,29., 2., 6., 9.63E-03,9.03666E+07,  9./
      DATA (u(i,6727),i=1,7)/29.,29., 2., 6., 6.37E-03,9.08079E+07,  9./
      DATA (u(i,6728),i=1,7)/29.,29., 2., 6., 4.43E-03,9.11104E+07,  9./
      DATA (u(i,6729),i=1,7)/29.,29., 2., 6., 3.21E-03,9.13268E+07,  9./
      DATA (u(i,6730),i=1,7)/30., 1., 1., 3., 1.46E+00,4.67454E+04,  1./
      DATA (u(i,6731),i=1,7)/30., 1., 1., 3., 1.22E-01,6.29105E+04,  1./
      DATA (u(i,6732),i=1,7)/30., 1., 1., 3., 2.90E-02,6.86073E+04,  1./
      DATA (u(i,6733),i=1,7)/30., 1., 1., 3., 1.13E-02,7.12190E+04,  1./
      DATA (u(i,6734),i=1,7)/30., 2., 2., 6., 1.54E+00,4.90637E+04,  3./
      DATA (u(i,6735),i=1,7)/30., 2., 2., 6., 5.93E-03,1.01530E+05,  2./
      DATA (u(i,6736),i=1,7)/30.,30., 2., 6., 8.32E-01,7.40408E+07,  4./
      DATA (u(i,6737),i=1,7)/30.,30., 2., 6., 1.58E-01,8.77520E+07,  5./
      DATA (u(i,6738),i=1,7)/30.,30., 2., 6., 5.80E-02,9.25509E+07,  6./
      DATA (u(i,6739),i=1,7)/30.,30., 2., 6., 2.79E-02,9.47722E+07,  7./
      DATA (u(i,6740),i=1,7)/30.,30., 2., 6., 1.56E-02,9.59788E+07,  8./
      DATA (u(i,6741),i=1,7)/30.,30., 2., 6., 9.63E-03,9.67063E+07,  9./
      DATA (u(i,6742),i=1,7)/30.,30., 2., 6., 6.37E-03,9.71785E+07,  9./
      DATA (u(i,6743),i=1,7)/30.,30., 2., 6., 4.43E-03,9.75022E+07,  9./
      DATA (u(i,6744),i=1,7)/30.,30., 2., 6., 3.21E-03,9.77338E+07,  9./
*     end
      end
******************************************************************************
      subroutine boltgn
      implicit none
*evaluate Boltzmann factors for the continuum, and related variables
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgTrGant
*flag set with trace gaunt command
      common/trgant/ lgTrGant
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer maxcor
      common/maxcor/ maxcor
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real tgffused , tgffsued2
      common/tgff/ tgffused , tgffsued2
*
*     local variables
      logical lgGauntF(2)
*     real toler
*     parameter (toler=0.015)
      real fac , fanu
      integer i , if1
*
*     correction factors for induced recombination,
*     also used as Boltzmann factors
*     check for zero is because ContBoltz is zeroed out in initizationation
*     of code, its possible this is a constant density grid of models
*     in which the code is called as a subroutine
      if( tgffused.ne.te .or. ContBoltz(1).le.0. ) then
        tgffused = te
        fac = te1ryd / te
        i = 1
        fanu = fac * anu(i)
        do while(i.le.nupper.and.fanu.lt.84. )
          ContBoltz(i) = exp(-fanu)
          i = i + 1
          fanu = fac * anu(i)
        end do
        maxcor = i - 1
*       zero out remainder
        do i=maxcor+1,nupper
          ContBoltz(i) = 0.
        end do
      endif
*
*     find frequency where thin to brems or plasma frequency
      call tauff
*
      if( abs(1.-tgffsued2/te) .gt. 0.10) then
        call gffsub(0.,anulog,gff,1,nflux,ncell,if1)
*       follwoing for ionized helium
        call gffsub(0.30103,anulog,gffhe2,1,nflux,ncell,if1)
        tgffsued2 = te
        lgGauntF(1) = .true.
      else
        lgGauntF(1) = .false.
      endif
*
      if( lgTrace.and.lgTrGant ) then
        write(qq,'(5X,''BOLTGN; gaunt facs?'',
     1  2L2,'' g 1 2='',1P,2E9.2,'' flag'',I2,'' guv(1,n)'',2E9.2)')
     2  lgGauntF,gff(1),gff(ipHn(2)),if1,gff(ipHn(2)+1),
     3  gff(nflux)
      endif
*
      end
******************************************************************************
      subroutine boroni
      implicit none
*ionization balance for boron
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=6)
      parameter (nelem=5)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*
*     boron nelem=5
*     data are for carbon
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.44E-10,4.20E-11,1.92E-11,5.32E-12,2.87E-13/
      data (cion(i,2),i=1,ndim-1)
     2 /1.31E5,2.83E5,5.56E5,7.48E5,4.55E6/
*     DATA GRDEFF/0.10,0.10,0.10,0.053,0.10/
*     GRDEFF is fraction of recombinations to ground state, used for
*     outward diffuse fields
*
*     rec from +3, +4 from Arnaud et al Ast Ap Sup 60 425. (1985)
*     rec from fully ionized uses Seaton '79 in ionrat
      data rec , pl/
     1 1.47E-10 , 8.74E-10 , 7.98E-9 , 1.34E-8 ,
     2  -0.624  , -0.645   , -0.803  , -0.791 /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/1.44e-10 , -0.621/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.54E-3 , 6.15E-3 , 1.62E-3 , 4.78E-2 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/4.42E-2 , 5.88E-2 , 0.343 , 0.362 , 0./
      data (dite(i,1),i=1,ndim-1)
     2/1.57E+5 , 1.41E+5 , 8.19E+4 , 3.44E+6 , 0./
      data (dite(i,2),i=1,ndim-1)
     2 /3.74E5 , 1.41E5 , 1.59E5 , 5.87E5 , 0./
      data ditcrt
     3/1.2E+4 , 1.2E+4 , 1.1E+4 , 4.4E+5 ,  1E20/
*
      data aa/  .0108  ,1.8267 ,2.3196  ,0. ,0./
     1  ,  bb/-0.1075  ,4.1012 ,10.7328 ,0. ,0./
     1,    cc/  .2810  ,4.8443 ,6.8830  ,0. ,0./
     2,    dd/-0.0193  ,.2261  ,-0.1824 ,0. ,0./
     3,    ff/ 0.001   ,0.5960 ,0.4101  ,0.1,0./
*
      IF( .NOT.lgElmtOn(nelem) ) THEN
        return
      endif
*
*     zero out ionization balance arrays
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if( lgTrace.and.lgHeavyBug ) then
        write(qq,'(5X,''Boroni returns; frac='',1P,7E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,nelem+1)
      endif
*
      end
******************************************************************************
      real function branch(ihigh,ilow)
      implicit none
*generate density - temperature dependent branching ratios for H atom
      integer ihigh,ilow
*
      real te , eden , hden
      common/phycon/ te , eden , hden
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real lowden,intden,highden
      real a(15,14),b(15,14),c(15,14)
      real d(7,14),e(7,14),DenCut(7)
      integer i,k
      real teuse , t , den, answer
*
*     function to evaluate branching ratios for hydrogen lines
*     as a function of density
*     Jason Ferguson, 1994-95,
*     only defined for ihigh up to 15
*
*     Arrays A and B satisfy the equation y=A+B*ln(x), x=temp.
*     Each line or pair of lines are for an upper level shown
*     by the continue number on the left.  Reading from left to
*     right the fit for the ratio to 2, then 3, etc..
      data ((a(i,k),k=2,14),i=4,15) /
     4  -0.1211,1.1216,0.0,0.0,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     5  -0.231,0.1541,1.0777,0.0,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     6  -0.2393,-0.018,0.2895,0.9860,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     7  -0.2313,-0.0752,0.1399,0.3215,0.8889,
     a   0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     8  -0.28112508,-0.084956103,0.052335384,0.1860462,0.36730798,
     a   0.76040317,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     9   -0.26984897,-0.09420251,0.01491954,0.1091487,0.2099884,
     a   0.35743391,0.672561,0.0,0.0,0.0,0.0,0.0,0.0,
     1   -0.25481577,-0.10231569,-0.0076578428,0.066757904,
     a   0.13321928,0.21432451,0.34000516,0.61679296,
     b   0.0,0.0,0.0,0.0,0.0,
     1   -0.24810157,-0.10400516,-0.016991176,0.041470196,0.084,
     a   0.14448418,0.2123012,0.31571745,0.55750333,0.0,0.0,0.0,0.0,
     2   -0.23702982,-0.098810607,-0.023991176,0.027159673,
     a   0.074,0.10390876,0.1507719,0.2043017,0.29242974,0.51702791,
     b   0.0,0.0,0.0,
     3   -0.24848052,-0.10171745,-0.031084333,0.014182484,0.066,0.068,
     a   0.11119647,0.15174908,0.1983017,0.27323518,0.47868582,0.0,0.0,
     4   -0.22367861,-0.099506928,-0.039968366,0.001871961,0.060,0.061,
     a   0.064,0.11284033,0.14641575,0.18110714,0.2579315,0.44211039,
     b   0.0,
     5   -0.23721562,-0.095522895,-0.036991176,-0.001128039,0.056,0.056,
     a   0.057,0.0978631332,0.11515085,0.13543856,0.18099118,0.24585431,
     b   0.41351216/
      data ((b(i,k),k=2,14),i=4,15) /
     4  0.0603,-0.0604,0.0,0.0,0.0,0.0,0.0,
     a  0.0,0.0,0.0,0.0,0.0,0.0,
     5  0.0555,0.0136,-0.0692,0.0,0.0,0.0,
     a  0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     6  0.0490,0.0226,-0.0061,-0.0668,0.0,0.0,
     a  0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     7  0.0441,0.0244,0.0024,-0.0135,-0.0615,
     a  0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     8  0.046526194,0.022736152,0.0079918092,-0.0049268036,-0.020577159,
     a -0.051751635,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     9  0.04357732,0.02200398,0.00984134,0.0002229,-0.00906445,
     a -0.02135838,-0.045223,0.0,0.0,0.0,0.0,0.0,0.0,
     1  0.040611865,0.021640426,0.0108200213,0.0028853901,-.0036067376,
     a  -.010820213,-.020919078,-.041333213,0.0,0.0,0.0,0.0,0.0,
     1  0.038952766,0.020919078,0.010820213,0.0043280851,0.0,
     a  -.0057707802,-.01154156,-.019476383,-.036788724,0.0,0.0,0.0,0.0,
     2  0.037005128,0.019692787,0.010820213,0.0050494326,0.0,
     a  -.0028853901,-.0072134752,-0.01154156,-.018033688,-.033703333,
     b  0.0,0.0,0.0 ,
     3  0.037510071,0.019476383,0.011036617,0.0057707802,0.0,0.0,
     a  -.0043280851,-.0079348227,-.01154156,-.016807397,-.031017943,
     b  0.0,0.0 ,
     4  0.034408277,0.018755036,0.01154156,0.0064921277,0.0,0.0,0.0,
     a  -.0050494326,-.0079348227,-.01031527,-.015869645,-.028132553,
     b  0.0,
     5  0.035346029,0.018250092,0.010820213,0.0064921277,0.0,0.0,0.0,
     a  -.0043280851,-.0057707802,-.0072134752,-.010820213,-.015148298,
     b  -.025968511/
* The array c is the high density branching ratio
      data ((c(i,k),k=2,14),i=4,15) /
     4  0.4835,0.5165,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     a  0.0,0.0,
     5  0.3407,0.2961,0.3632,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     a  0.0,0.0,
     6  0.274,0.219,0.218,0.290,0.0,0.0,0.0,0.0,0.0,0.0,0.0,
     a  0.0,0.0,
     7  0.2360,0.1800,0.1636,0.175,0.245,0.0,0.0,0.0,0.0,0.0,0.0,
     a  0.0,0.0,
     8  0.2096,0.1565,0.1352,0.1322,0.149,0.2175, 0.0,0.0,
     a  0.0,0.0,0.0,0.0,0.0,
     9  0.1923,0.1409,0.1181,0.1095,0.1120,0.1310,0.1961,0.0,
     a  0.0,0.0,0.0,0.0,0.0,
     1  0.1783,0.1293,0.1063,0.09549,0.09285,0.09843,0.1185,0.1807,
     a  0.0,0.0,0.0,0.0,0.0,
     1  0.1683,0.1206,0.0979,0.08606,0.08074,0.08119,0.0885,0.1082,
     a  0.1684,0.0,0.0,0.0,0.0,
     2  0.1598,0.1138,0.09151,0.07907,0.07268,0.06847,0.07498,0.08021,
     a  0.1004,0.1586,0.0,0.0,0.0,
     3  0.1528,0.1082,0.08631,0.07380,0.06685,0.06317,0.06308,0.06617,
     a  0.07461,0.09408,0.1505,0.0,0.0,
     4  0.1468,0.1037,0.082,0.0697,0.0623,0.0581,0.0564,0.0572,
     a  0.0611,0.0698,0.0890,0.1437,0.0,
     5  0.142,0.1,0.079,0.066,0.0585,0.054,0.052,0.051,
     a  0.053,0.0566,0.0655,0.085,0.138/
*
*     Arrays d and e are the linear fits D + E*ln(T)
*     to the branching ratios at the density of
*     DenCut below.
      data ((d(i,k),k=2,14),i=4,7) /
     4   0.3618,0.6382,0.0,0.0,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     5   0.1284,0.2895,0.5808,0.0,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     6   0.124,0.1822,0.2562,0.4378,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     7   -0.0102,0.0889,0.1619,0.2684,0.4915,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0/
*
      data ((e(i,k),k=2,14),i=4,7) /
     4   0.0146,-0.0146,0.0,0.0,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     5   0.0220,0.00,-0.0218,0.0,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     6   0.0152,0.0033,-0.0041,-0.0145,0.0,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0,
     7   0.0238,0.0083,0.00,-0.0090,-0.0232,0.0,0.0,
     a   0.0,0.0,0.0,0.0,0.0,0.0/
*
*     the intermediate density for cutting the
*     interpolation.  Only used for ihigh=4,5,6,7.
      data (DenCut(k),k=4,7) /9.0,8.0,8.0,7.0/
*
      if(ilow.ge.ihigh) then
        write(qq,*) (' routine branch: the indices are not right!')
        stop
      endif
      if( ihigh.gt.15 ) then
        write(qq,'('' routine branch only extends up to 15.'')')
        stop
      endif
*
      teuse = max(1000.,te)
      teuse = min(3e4,teuse)
      t = alog(teuse)
      den = alog10(eden)
*
*     Compute the low,intermediate and high density limits.
      lowden = a(ihigh,ilow) + b(ihigh,ilow) * t
      highden = c(ihigh,ilow)
*
      if(ihigh.gt.7) then
*       greater than 7 is a linear fit, less than is double linear.
        if(den.ge.9.0) then
*         if the den>9.0 then use just the high limit...
          answer = highden
        else if(den.le.4.0) then
*         if the den<4.0 then use the low limit...
          answer = lowden
        else
*         else linerly interpolate between two limits...
          answer = lowden + (highden - lowden) * (den - 4.0) / 5.0
        endif
      else
*       the branching ratio at intermediate density:
        intden = d(ihigh,ilow) + e(ihigh,ilow) * t
        if(den.ge.(DenCut(ihigh)+2.)) then
*         if the den>11.0 (for ihigh=4) then use just the high limit...
          answer = highden
        else if(den.ge.DenCut(ihigh)) then
*         between limits interpolate
          answer = intden +
     1       (highden - intden) * (den - DenCut(ihigh)) / 2.0
        else if(den.le.4.0) then
*         if the den<4.0 then use the low limit...
*         between limits interpolate
          answer = lowden
        else
*         else linerly interpolate between two limits...
          answer = lowden + (intden - lowden) * (den - 4.0) / 5.0
        endif
      endif
*
*     the answer...
      branch = answer
*
      end
******************************************************************************
      subroutine broken
      implicit none
*set flag saying that the code is broken
      logical lgBroke
*logical flag saying that the code is broken
      common/broke/ lgBroke
*
      lgBroke = .true.
*
      end
******************************************************************************
      subroutine calcm
      implicit none
*perform ionization balance for calcium
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      real dstCala , dCakh , dCaf12 , Ca3d , Ca4p
*parameters dealing with dest of CaII by Lya
      common/dcala/ dstCala , dCakh , dCaf12 , Ca3d , Ca4p
      logical lgCalBug
*trace caldium atom flag
      common/calbug/ lgCalBug
*recombination rates for the elements
*first dim is nelem, the atomic number of element
*secnd dim is stage of ionizaiton, 1 for atom
      real RecombinRate(limelm,limelm)
      common/RecomRate/ RecombinRate
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=21)
      parameter (nelem=20)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real grdeff(20)  , yyield(18) , yyieldl(10)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/20*0.2/ , yYIELD/18*0./ , yYIELDL/10*0./
*
*     calcium nelem=20
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /2.09E-10,9.00E-11,5.35E-11,2.58E-11,1.31E-11,5.91E-12,
     1 2.86E-12,6.96E-13,9.56E-13,3.20E-13,3.86E-13,2.54E-13,1.90E-13,
     2 1.42E-13,9.25E-14,5.48E-14,3.74E-14,1.65E-14,1.68E-15,7.39E-16/
      data (cion(i,2),i=1,ndim-1)
     1 /7.09E4,1.38E5,5.94E5,7.81E5,9.79E5,1.27E6,1.49E6,1.66E6,
     2 2.18E6,2.45E6,6.87E6,7.61E6,8.43E6,9.48E6,1.04E7,1.13E7,
     3 1.26E7,1.34E7,5.95E7,6.35E7/
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data rec,pl
     1/ 4.5E-10 , 1.07E-9 , 2.50E-9 , 9.33E-9 , 2.45E-8 , 3.43E-8
     2, 4.57E-8 , 6.53E-8 , 6.64E-8 , 2.57E-7 , 1.62E-7 , 2.05E-7
     3, 2.50E-7 , 1.70E-7 , 4.12E-7 , 4.27E-7 , 9.57E-7 , 1.29E-6
     4, 1.35E-6
     1, -0.900  , -0.800  , -0.700  , -0.780  , -0.840  , -0.820
     2, -0.820  , -0.810  , -0.780  , -0.900  , -0.820  , -0.810
     3, -0.800  , -0.730  , -0.800  , -0.780  , -0.850  , -0.850
     4, -0.830  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.06e-10 , -0.683 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/3.28E-4, .0584, .122, .132, .133, .126, .139, .0955, .0402,
     2 .0419, .0257, .0445, .0548, .0713, .0903, .110, .0205, .549,
     3 .355, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/.0907, .110, .0174, .132, .114, .162, .0878, .263, .0627, .0616,
     2 2.77, 2.23, 2.00, 1.82, .424, .243, .185, .292, .275, 0./
      data (dite(i,1),i=1,ndim-1)
     1/3.46E+4, 3.84E+5, 4.08E+5, 3.82E+5, 3.53E+5, 3.19E+5, 3.22E+5,
     2 2.47E+5, 2.29E+5, 3.73E+6, 9.26E+5, 7.96E+5, 6.90E+5, 6.70E+5,
     3 4.72E+5, 5.67E+5, 4.21E+5, 3.65E+7, 3.78E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/1.64E+4, 2.45E+5, 4.27E+5, 6.92E+5, 8.78E+5, 7.43E+5, 6.99E+5,
     2 4.43E+5, 2.81E+5, 5.84E+6, 4.89E+6, 4.62E+6, 4.52E+6, 3.32E+6,
     3 1.37E+6, 4.41E+6, 2.27E+6, 7.25E+6, 7.68E+6, 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 1E20 /
*
      data aa/20*0./,bb/20*0./,cc/20*0./,dd/20*0./,
     1 ff/0.,0.1,18*0./
*
*     calcium, atomic number 20
      if( .not.lgElmtOn(20) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     correct low temp rad rec coef
      if( te.lt.1e3 ) then
        RecombinRate(nelem,2) = RecombinRate(nelem,2) +
     1  ( 5.49e-10*(te**(-0.647)) - rec(2)*(te**pl(2)) ) * eden
      endif
*
*     charge transfer - Kingdon et al.
*     Ca+3 + H => Ca+2 + H+
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(3,2) = CTHeavy(3,2) + 2.E-10 * hi
*     CTHeavy(4,2) = CTHeavy(4,2) + 4.E-9 * hi
*     Ly-alpha photoionization of Ca+
      CTHeavy(2,1) = CTHeavy(2,1) + dstCala
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine cap4( chLab , chCAP )
      implicit none
*convert input line chLab into chCAP all in caps, for command parser
      character chLab*4 , chCAP*4
      integer chr
      integer i , la,lz,ldiff
*
      la = ichar('a')
      lz = ichar('z')
      ldiff = ( ichar('A')-ichar('a') )
*
*     convert 4 character string in chLab to ALL CAPS, chCAP
*
      do i=1,4
        chr = ichar( chLab(i:i) )
        if( (chr.ge.la).and.(chr.le.lz) ) then
          chCAP(i:i) = char(chr+ldiff)
        else
          chCAP(i:) = chLab(i:)
        endif
      end do
*
      end
******************************************************************************
      subroutine caps( chCard )
      implicit none
*convert input command line to all caps
      character chCard*80
*
*     local variables
      integer chr,i,la,lz,ldiff
*
      la = ichar('a')
      lz = ichar('z')
      ldiff = ( ichar('A')-ichar('a') )
*
*     convert 80 character string in chCard to ALL CAPS
*
      do i=1,80
        chr = ichar( chCard(i:i) )
        if( (chr.ge.la).and.(chr.le.lz) ) chCard(i:i) = char(chr+ldiff)
      end do
*
      end
******************************************************************************
      subroutine carbon
      implicit none
*compute ionization balance for carbon
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real p1909 , p2326 , p1895 , p1666 , p1401
      common/pmp2s/ p1909 , p2326 , p1895 , p1666 , p1401
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      logical lgCarBug
*trace carbon flag
      common/carbug/ lgCarBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real catmic , oatmic
      common/coatom/ catmic , oatmic
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*recombination rates for the elements
*first dim is nelem, the atomic number of element
*secnd dim is stage of ionizaiton, 1 for atom
      real RecombinRate(limelm,limelm)
      common/RecomRate/ RecombinRate
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real OldPRate , OldRRate
      save OldPRate , OldRRate
      integer i
      integer ndim
      parameter (ndim=7)
      integer nelem
      parameter (nelem=6)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),save,
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
      integer nzUsed
      save nzUsed
*
*     carbon nelem=6
*
*     real CollidRate(nelem,2)
*
      data nzUsed/0/ , OldPRate/0./
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.44E-10,4.20E-11,1.92E-11,5.32E-12,2.87E-13,9.16E-14/
      data (cion(i,2),i=1,ndim-1)
     2 /1.31E5,2.83E5,5.56E5,7.48E5,4.55E6,5.68E6/
*
*     rec from +3, +4 from Arnaud et al Ast Ap Sup 60 425. (1985)
*     rec from fully ionized uses Seaton '79 in ionrat
      data rec , pl/
     1 1.47E-10 , 8.74E-10 , 7.98E-9 , 1.34E-8 , 1.30E-8 ,
     2  -0.624  , -0.645   , -0.803  , -0.791  , -0.721  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/1.44e-10 , -0.621/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.54E-3 , 6.15E-3 , 1.62E-3 , 4.78E-2 , 3.22E-2 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/4.42E-2 , 5.88E-2 , 0.343 , 0.362 , 0.315,0./
      data (dite(i,1),i=1,ndim-1)
     2/1.57E+5 , 1.41E+5 , 8.19E+4 , 3.44E+6 , 4.06E+6 , 0./
      data (dite(i,2),i=1,ndim-1)
     2 /3.74E5 , 1.41E5 , 1.59E5 , 5.87E5 , 8.31E5,0./
      data ditcrt
     3/1.2E+4 , 1.2E+4 , 1.1E+4 , 4.4E+5 , 7.0E+5 , 1E20/
*
      data aa/  .0108  ,1.8267 ,2.3196  ,0. ,0. ,0./
     1  ,  bb/-0.1075  ,4.1012 ,10.7328 ,0. ,0. ,0./
     1,    cc/  .2810  ,4.8443 ,6.8830  ,0. ,0. ,0./
     2,    dd/-0.0193  ,.2261  ,-0.1824 ,0. ,0. ,0./
     3,    ff/ 0.000  ,0.5960 ,0.4101  ,0.1,0.1,0./
*     in above, ff(1) has been reset to 0 since NS fit diverges at very low t
*     better to use mean background diel
*
      if( lgTrace .and. lgCarBug ) write(qq,'(5x,''carbon called.'')')
*
      if( .not.lgElmtOn(6) ) then
        p1909 = 0.
        p2326 = 0.
        catmic = 0.
        heating(6,10) = 0.
        return
      endif
*
*     zero out ionization balance arrays
      call ionzer(nelem)
*
      call PhotoIonize(nelem )
*     call PrtGamma(ipCarbon(1,3,1) ,ipCarbon(1,3,2) ,
*    1 ipCarbon(1,3,3),
*    1 qq,  photorate(nelem,1,3,1) ,photorate(nelem,1,3,1)*0.05 )
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( nzone.gt.1 .and. OldPRate.gt.0. ) then
        if( nzone.ne.nzUsed .and. lgDoPhoto) then
*         damp out pdr oscillations
          PhotoRate(6,1,3,1) = (PhotoRate(6,1,3,1) + OldPRate)/2.
          OldPRate = PhotoRate(6,1,3,1)
          OldRRate = (RecombinRate(nelem,1) + OldRRate) / 2.
*     >>chng 96 may 15 only 1 eval per zone to stop Lyman ots oscil
          nzUsed = nzone
        else
          PhotoRate(6,1,3,1) = OldPRate
          RecombinRate(nelem,1) = OldRRate
        endif
      else
        OldPRate = PhotoRate(nelem,1,3,1)
        OldRRate = RecombinRate(nelem,1)
      endif
*
*     Photoproduction of 3P
      p1909 = PhotoRate(6,2,2,1)
*
*     photoproduction of C II] 2326
      p2326 =  PhotoRate(6,1,2,1)
*
*     charge transfer
*     C+ + H0 => H+ + C0, rate from Butler and Dalgarno (1980A)
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(1,2) = CTHeavy(1,2) + HI*1.4E-17
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(1,1) = CTHeavy(1,1) + HII*2.8E-20*TE
*     write(6,*) 2.8e-20*te*hii , HCTIon(1,6)*hii
*     C+2 => C+ Butler Heil Dalgarno 1980
*     CTHeavy(2,2) = CTHeavy(2,2) + 1.2E-12 * HI
*     C+3 => C+ Butler Heil Dalgarno 1980
*     CTHeavy(3,2) = CTHeavy(3,2) + 4.3E-10*TE10*TE10*TE03 * HI
*     C+4 => C+3 Butler and Dalgarno 1980B
*     CTHeavy(4,2) = CTHeavy(4,2) + 7.6E-16 * MIN(TE32,1E7) * HI
*     >>chng 96 aug 9, added following ct reaction
*     He+ + C => He + C+, Kimura et al, ApJ 417, 812, 1993.
      CTHeavy(1,1) = CTHeavy(1,1) + heii*4.17e-17*(te/te03)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     this is atomic carbon abundance, removing CO
      catmic = xIonFracs(6,0) * max(1e-7,(1.-co/xIonFracs(6,0)))
*
*     solve for ionization balance
*     last var is option to print stuff
      save = xIonFracs(6,0)
*     must trick BiDiag into conserving C
      xIonFracs(6,0) = catmic
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
      xIonFracs(6,0) = save
*
*     rate will be cm-3 s-1, into triplets only
*     >>chng 96 nov 22, rid of carb()
      p1909 = p1909 * xIonFracs(6,2) * 0.62
      p2326 = p2326 * xIonFracs(6,1) * 0.15
*
*     charge exchange rates (s-1) for hydrogen
*     >>chng 96 nov 22, rid of carb()
      CTHionAgnt(1) = xIonFracs(6,2) * 1.4E-17
      CTHion(1) = CTHion(1) + CTHionAgnt(1)
      CTHrec(1) = CTHrec(1) + xIonFracs(6,1) * 2.18E-20 * te
*
      if( lgTrace ) then
        write(qq,'(5X,''CARBON returns; CO=,''1p,e10.3,'' fracs='',
     1  7e10.3)') co/xIonFracs(6,0),
     2  (xIonFracs(6,i)/xIonFracs(6,0),i=1,7)
      endif
*
      end
******************************************************************************
      subroutine caunin( chLine )
      implicit none
*called by comment to enter caution into comment stack
      character*132 chLine
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      integer limwcn
      parameter (limwcn=100)
      character chWarnln*132 , chCaunln*132 , chNoteln*132 ,
     1 chBangln*132
      common/wcnln/ chWarnln(limwcn) , chCaunln(limwcn) ,
     1 chNoteln(limwcn) , chBangln(limwcn)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      ncaun = ncaun + 1
      if( ncaun.gt.limwcn ) then
        write(qq,'('' Too many cautions have been entered; increase'',
     1  '' the value of LIMWCN everywhere in the code.'')')
        stop
      else
        chCaunln(ncaun) = chLine
      endif
*
      end
******************************************************************************
      subroutine caunot( io )
      implicit none
*print out all cautions after calculation, on arbitrary io unit
      integer io
*
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      integer limwcn
      parameter (limwcn=100)
      character chWarnln*132 , chCaunln*132 , chNoteln*132 ,
     1 chBangln*132
      common/wcnln/ chWarnln(limwcn) , chCaunln(limwcn) ,
     1 chNoteln(limwcn) , chBangln(limwcn)
*
*     local variables
      integer i
*
      if(ncaun.gt.0)then
        write(io,'(a132)') (chCaunln(i),i=1,ncaun)
      endif
*
      end
********************************************************
*>>>>>CDEXTRA.F
********************************************************
      subroutine cdGett( io , lgEOF )
      implicit none
*get input parameters from Cloudy header, used when analyzing stored output
*     parameters are not converted from logs, results of this
*     routine are as they appear on the header
      integer io
      logical lgEOF
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsumtt
      common/nsumtt/ nsumtt
      real gethdn , getflx , getu , gthcol, getbbt,
     1 getaox , getpl , gettrb , gettab , getagn,getradius
      common/getpar/ gethdn , getflx , getu , gthcol, getbbt,
     1 getaox , getpl(3) , gettrb , gettab , getagn(2),getradius
      real gttaue
      common/getres/ gttaue
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      integer limelm
      parameter (limelm=30)
*     xIonMeans(nelem, stage,type)
*     stage=0 is integrated sum of all
*     type = 1 is radius integration, 2=vol
      real xIonMeans
      common/IonMeans/ xIonMeans(limelm,0:limelm+1,2)
*
*     local variables
      logical lgEOL , lgMatch , lgDone
      character*4 chKey , chCard*80
      real fread
      integer i , n0 , ierr
*
*     this routine reads the output generated with the
*     punch results command
*     if parameter was not entered then zero set
*
*     these are the parameters which may be read off the input stream
*     all must be initialized here
*
*     radius
      getradius = 0.
*     table command, possible parameter
      gettab = 0.
*     turbulence command
      gettrb = 0.
*     stop column density command
      gthcol = 0.
*     black body temperature command
      getbbt = 0.
*     ratio command parameter, probably alpha ox
      getaox = 0.
*     the input hydrogen density, from hden command
      gethdn = 0.
*     the input photon flux, from phi(h) command
      getflx = 0.
*     the input ionization parameter, from ionization par command
      getu = 0.
*     the deduced electron scattering optical depth
      gttaue = 0.
*     these are the parameters on the power law command
      getpl(1) = 0.
      getpl(2) = 0.
      getpl(3) = 0.
*     parameters for agn command
      getagn(1) = 0.
      getagn(2) = 0.
*     this will be flag saying if we hit normal end of model
      lgDone = .false.
*
*2    read(io,'(a80)',end=999) chCard
      read(io,'(a80)',iostat=ierr) chCard
      do while( ierr.eq.0 .and. .not.lgDone)
*       change chCard to all caps
        call caps( chCard )
*       this will be the key to search on
        chKey = chCard(1:4)
*>>>>>>>>make sure all zeroed above
        if( chKey.eq.'BLAC' ) then
*         temperature on blackbody line, leave as is
          i = 4
          getbbt = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'AGN ' ) then
*         agn command
          i = 3
          getagn(1) = fread( chCard , i , 76 , lgEOL )
          getagn(2) = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'POWE' ) then
*         power law command
          i = 4
          getpl(1) = fread( chCard , i , 76 , lgEOL )
          getpl(2) = fread( chCard , i , 76 , lgEOL )
          getpl(3) = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'RADI' ) then
*         radius command
          i = 4
          getradius = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'RATI' ) then
*         ratio command
          i = 4
          getaox = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'HDEN' ) then
*         this is an hden command, scan off density
          i = 4
          gethdn = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'STOP' .and.lgMatch('COLU',chCard) ) then
*         this is hydrogen column density
          i = 4
          gthcol = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'TABL' ) then
*         table command
          i = 4
          gettab = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'PHI(' ) then
*         this is a flux command, scan off flux
          i = 4
          getflx = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'IONI' ) then
*         this is a ionization parameter command, scan off U
          i = 4
          getu = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'C*OP' ) then
*         this is a line of deduced optical depths
          i = 4
          gttaue = fread( chCard , i , 76 , lgEOL )
        else if( chKey.eq.'TURB' ) then
*         this is a turbulence
          i = 4
          gettrb = fread( chCard , i , 76 , lgEOL )
*
        else if( chCard(1:20).eq.'BEGIN EMISSION LINES' ) then
          read(io,'(6(1x,a4,i6,1p,e10.3))',iostat=ierr) (chALab(i) ,
     1    lin(i) , sumlin(i),i=1,6)
          n0 = 6
          do while(chALab(n0-5).ne.'   '.and. ierr.eq.0 )
             read(io,'(6(1x,a4,i6,1p,e10.3))',iostat=ierr) (chALab(i) ,
     1       lin(i) , sumlin(i),i=1+n0,6+n0)
             n0 = n0 + 6
          end do
          nsumtt = n0 - 6
       else if( chCard(1:20).eq.'BEGIN COLUMN DENSITI' ) then
*         real in all column densities
*         make sure this is kept parallel with CDCOLM, which uses it
*         do nelem=1,limelm
*     >>chng 97 mar 20, get whole thing
            read(io,'(4x,1p,12e10.3)') xIonMeans
*    1      (xIonMeans(nelem,i,1),i=1,nelem+1)
*         end do
*
*       following is normal way to exit
        else if( chCard(1:14) .eq. 'END OF RESULTS' ) then
          lgDone = .true.
        endif
*
        read(io,'(a80)',iostat=ierr) chCard
      end do
*
*999  continue
      if( lgDone ) then
        lgEOF = .false.
      else
        lgEOF = .true.
      endif
*
      end
********************************************************
      subroutine cfit(iz,in,t,c)
      implicit none
*D Verner's routine to compute collisional ionization rate coefficients
* Version 3, April 21, 1997
* Cu (Z=29) and Zn (Z=30) are added (fits from Ni, correct thresholds).
******************************************************************************
*** This subroutine calculates rates of direct collisional ionization
*** for all ionization stages of all elements from H to Ni (Z=28)
*** by use of the fits from G. S. Voronov, 1997, ADNDT, 65, 1
*** Input parameters:  iz - atomic number
***                    in - number of electrons from 1 to iz
***                    t  - temperature, K
*** Output parameter:  c  - rate coefficient, cm^3 s^(-1)
******************************************************************************
      integer iz,in
      real t,c
      real CF,te,u
      common/CF/CF(5,30,30)
      c=0.0
      if(iz.lt.1.or.iz.gt.30)return
      if(in.lt.1.or.in.gt.iz)return
      te=t*8.617385e-05
      u=CF(1,iz,in)/te
      if(u.gt.80.0)return
      c=CF(3,iz,in)*(1.0+CF(2,iz,in)*sqrt(u))/(CF(4,iz,in)+u)*
     *u**CF(5,iz,in)*exp(-u)
      return
      end
*********************************************
      block data cifit
      implicit none
*block data for all of D Verner's collision ionization data
      integer I
      real CF
      common/CF/CF(5,30,30)
      DATA(CF(I, 1, 1),I=1,5)/   13.6,0.,2.91E-08,0.2320,0.39/
      DATA(CF(I, 2, 2),I=1,5)/   24.6,0.,1.75E-08,0.1800,0.35/
      DATA(CF(I, 2, 1),I=1,5)/   54.4,1.,2.05E-09,0.2650,0.25/
      DATA(CF(I, 3, 3),I=1,5)/    5.4,0.,1.39E-07,0.4380,0.41/
      DATA(CF(I, 3, 2),I=1,5)/   75.6,1.,2.01E-09,0.2090,0.23/
      DATA(CF(I, 3, 1),I=1,5)/  122.4,1.,9.60E-10,0.5820,0.17/
      DATA(CF(I, 4, 4),I=1,5)/    9.3,0.,1.02E-07,0.3750,0.27/
      DATA(CF(I, 4, 3),I=1,5)/   18.2,1.,2.08E-08,0.4390,0.21/
      DATA(CF(I, 4, 2),I=1,5)/  153.9,0.,2.67E-09,0.6120,0.27/
      DATA(CF(I, 4, 1),I=1,5)/  217.7,1.,4.27E-10,0.6580,0.15/
      DATA(CF(I, 5, 5),I=1,5)/    8.3,0.,6.49E-08,0.2000,0.26/
      DATA(CF(I, 5, 4),I=1,5)/   25.2,1.,1.24E-08,0.2670,0.22/
      DATA(CF(I, 5, 3),I=1,5)/   37.9,1.,3.27E-09,0.2950,0.23/
      DATA(CF(I, 5, 2),I=1,5)/  259.4,1.,4.95E-10,0.4890,0.09/
      DATA(CF(I, 5, 1),I=1,5)/  340.2,1.,2.19E-10,0.6570,0.15/
      DATA(CF(I, 6, 6),I=1,5)/   11.3,0.,6.85E-08,0.1930,0.25/
      DATA(CF(I, 6, 5),I=1,5)/   24.4,1.,1.86E-08,0.2860,0.24/
      DATA(CF(I, 6, 4),I=1,5)/   47.9,1.,6.35E-09,0.4270,0.21/
      DATA(CF(I, 6, 3),I=1,5)/   64.5,1.,1.50E-09,0.4160,0.13/
      DATA(CF(I, 6, 2),I=1,5)/  392.1,1.,2.99E-10,0.6660,0.02/
      DATA(CF(I, 6, 1),I=1,5)/  490.0,1.,1.23E-10,0.6200,0.16/
      DATA(CF(I, 7, 7),I=1,5)/   14.5,0.,4.82E-08,0.0652,0.42/
      DATA(CF(I, 7, 6),I=1,5)/   29.6,0.,2.98E-08,0.3100,0.30/
      DATA(CF(I, 7, 5),I=1,5)/   47.5,1.,8.10E-09,0.3500,0.24/
      DATA(CF(I, 7, 4),I=1,5)/   77.5,1.,3.71E-09,0.5490,0.18/
      DATA(CF(I, 7, 3),I=1,5)/   97.9,0.,1.51E-09,0.0167,0.74/
      DATA(CF(I, 7, 2),I=1,5)/  552.1,0.,3.71E-10,0.5460,0.29/
      DATA(CF(I, 7, 1),I=1,5)/  667.0,1.,7.77E-11,0.6240,0.16/
      DATA(CF(I, 8, 8),I=1,5)/   13.6,0.,3.59E-08,0.0730,0.34/
      DATA(CF(I, 8, 7),I=1,5)/   35.1,1.,1.39E-08,0.2120,0.22/
      DATA(CF(I, 8, 6),I=1,5)/   54.9,1.,9.31E-09,0.2700,0.27/
      DATA(CF(I, 8, 5),I=1,5)/   77.4,0.,1.02E-08,0.6140,0.27/
      DATA(CF(I, 8, 4),I=1,5)/  113.9,1.,2.19E-09,0.6300,0.17/
      DATA(CF(I, 8, 3),I=1,5)/  138.1,0.,1.95E-09,0.3600,0.54/
      DATA(CF(I, 8, 2),I=1,5)/  739.3,0.,2.12E-10,0.3960,0.35/
      DATA(CF(I, 8, 1),I=1,5)/  871.4,1.,5.21E-11,0.6290,0.16/
      DATA(CF(I, 9, 9),I=1,5)/   17.4,1.,7.00E-08,0.1780,0.29/
      DATA(CF(I, 9, 8),I=1,5)/   35.0,0.,5.41E-08,0.5710,0.27/
      DATA(CF(I, 9, 7),I=1,5)/   62.7,1.,9.37E-09,0.3190,0.20/
      DATA(CF(I, 9, 6),I=1,5)/   87.1,1.,4.92E-09,0.3230,0.24/
      DATA(CF(I, 9, 5),I=1,5)/  114.2,0.,7.06E-09,0.6840,0.27/
      DATA(CF(I, 9, 4),I=1,5)/  157.2,1.,1.28E-09,0.6480,0.16/
      DATA(CF(I, 9, 3),I=1,5)/  185.2,1.,5.61E-10,0.7380,0.16/
      DATA(CF(I, 9, 2),I=1,5)/  953.9,0.,1.66E-10,0.5420,0.29/
      DATA(CF(I, 9, 1),I=1,5)/ 1103.1,1.,3.74E-11,0.6590,0.15/
      DATA(CF(I,10,10),I=1,5)/   21.6,1.,1.50E-08,0.0329,0.43/
      DATA(CF(I,10, 9),I=1,5)/   41.0,0.,1.98E-08,0.2950,0.20/
      DATA(CF(I,10, 8),I=1,5)/   63.5,1.,7.03E-09,0.0677,0.39/
      DATA(CF(I,10, 7),I=1,5)/   97.1,1.,4.24E-09,0.0482,0.58/
      DATA(CF(I,10, 6),I=1,5)/  126.2,1.,2.79E-09,0.3050,0.25/
      DATA(CF(I,10, 5),I=1,5)/  157.9,0.,3.45E-09,0.5810,0.28/
      DATA(CF(I,10, 4),I=1,5)/  207.3,1.,9.56E-10,0.7490,0.14/
      DATA(CF(I,10, 3),I=1,5)/  239.1,1.,4.73E-10,0.9920,0.04/
      DATA(CF(I,10, 2),I=1,5)/ 1196.0,1.,3.92E-11,0.2620,0.20/
      DATA(CF(I,10, 1),I=1,5)/ 1360.6,1.,2.77E-11,0.6610,0.13/
      DATA(CF(I,11,11),I=1,5)/    5.1,1.,1.01E-07,0.2750,0.23/
      DATA(CF(I,11,10),I=1,5)/   47.3,1.,7.35E-09,0.0560,0.35/
      DATA(CF(I,11, 9),I=1,5)/   71.6,1.,8.10E-09,0.1480,0.32/
      DATA(CF(I,11, 8),I=1,5)/   98.9,0.,1.14E-08,0.5530,0.28/
      DATA(CF(I,11, 7),I=1,5)/  138.4,1.,2.63E-09,0.2300,0.29/
      DATA(CF(I,11, 6),I=1,5)/  172.2,1.,1.85E-09,0.3630,0.22/
      DATA(CF(I,11, 5),I=1,5)/  208.5,0.,2.82E-09,0.6740,0.27/
      DATA(CF(I,11, 4),I=1,5)/  264.2,1.,6.72E-10,0.7520,0.14/
      DATA(CF(I,11, 3),I=1,5)/  299.9,1.,2.80E-10,0.7810,0.15/
      DATA(CF(I,11, 2),I=1,5)/ 1465.1,1.,4.63E-11,0.5580,0.16/
      DATA(CF(I,11, 1),I=1,5)/ 1648.7,1.,2.16E-11,0.7430,0.13/
      DATA(CF(I,12,12),I=1,5)/    7.6,0.,6.21E-07,0.5920,0.39/
      DATA(CF(I,12,11),I=1,5)/   15.2,0.,1.92E-08,0.0027,0.85/
      DATA(CF(I,12,10),I=1,5)/   80.1,1.,5.56E-09,0.1070,0.30/
      DATA(CF(I,12, 9),I=1,5)/  109.3,1.,4.35E-09,0.1590,0.31/
      DATA(CF(I,12, 8),I=1,5)/  141.3,0.,7.10E-09,0.6580,0.25/
      DATA(CF(I,12, 7),I=1,5)/  186.5,1.,1.70E-09,0.2420,0.28/
      DATA(CF(I,12, 6),I=1,5)/  224.9,1.,1.22E-09,0.3430,0.23/
      DATA(CF(I,12, 5),I=1,5)/  266.0,0.,2.20E-09,0.8970,0.22/
      DATA(CF(I,12, 4),I=1,5)/  328.2,1.,4.86E-10,0.7510,0.14/
      DATA(CF(I,12, 3),I=1,5)/  367.5,1.,2.35E-10,1.0300,0.10/
      DATA(CF(I,12, 2),I=1,5)/ 1761.8,1.,2.06E-11,0.1960,0.25/
      DATA(CF(I,12, 1),I=1,5)/ 1962.7,1.,1.75E-11,0.8350,0.11/
      DATA(CF(I,13,13),I=1,5)/    6.0,1.,2.28E-07,0.3870,0.25/
      DATA(CF(I,13,12),I=1,5)/   18.8,0.,1.18E-07,2.2100,0.25/
      DATA(CF(I,13,11),I=1,5)/   28.5,1.,4.40E-09,0.1060,0.24/
      DATA(CF(I,13,10),I=1,5)/  120.0,0.,1.75E-08,0.8720,0.22/
      DATA(CF(I,13, 9),I=1,5)/  153.8,1.,2.61E-09,0.1590,0.31/
      DATA(CF(I,13, 8),I=1,5)/  198.5,1.,1.85E-09,0.1520,0.36/
      DATA(CF(I,13, 7),I=1,5)/  241.4,1.,1.14E-09,0.2280,0.29/
      DATA(CF(I,13, 6),I=1,5)/  284.6,1.,8.00E-10,0.4170,0.16/
      DATA(CF(I,13, 5),I=1,5)/  390.2,1.,5.83E-10,0.4970,0.23/
      DATA(CF(I,13, 4),I=1,5)/  399.4,0.,4.93E-10,0.7060,0.16/
      DATA(CF(I,13, 3),I=1,5)/  442.0,1.,9.77E-11,0.2780,0.17/
      DATA(CF(I,13, 2),I=1,5)/ 2086.6,0.,3.94E-11,0.2860,0.36/
      DATA(CF(I,13, 1),I=1,5)/ 2304.1,1.,1.38E-11,0.8350,0.11/
      DATA(CF(I,14,14),I=1,5)/    8.2,1.,1.88E-07,0.3760,0.25/
      DATA(CF(I,14,13),I=1,5)/   16.4,1.,6.43E-08,0.6320,0.20/
      DATA(CF(I,14,12),I=1,5)/   33.5,1.,2.01E-08,0.4730,0.22/
      DATA(CF(I,14,11),I=1,5)/   54.0,1.,4.94E-09,0.1720,0.23/
      DATA(CF(I,14,10),I=1,5)/  166.8,1.,1.76E-09,0.1020,0.31/
      DATA(CF(I,14, 9),I=1,5)/  205.3,1.,1.74E-09,0.1800,0.29/
      DATA(CF(I,14, 8),I=1,5)/  246.5,1.,1.23E-09,0.5180,0.07/
      DATA(CF(I,14, 7),I=1,5)/  303.5,1.,8.27E-10,0.2390,0.28/
      DATA(CF(I,14, 6),I=1,5)/  351.1,1.,6.01E-10,0.3050,0.25/
      DATA(CF(I,14, 5),I=1,5)/  401.4,1.,4.65E-10,0.6660,0.04/
      DATA(CF(I,14, 4),I=1,5)/  476.4,1.,2.63E-10,0.6660,0.16/
      DATA(CF(I,14, 3),I=1,5)/  523.5,1.,1.18E-10,0.7340,0.16/
      DATA(CF(I,14, 2),I=1,5)/ 2437.7,0.,3.36E-11,0.3360,0.37/
      DATA(CF(I,14, 1),I=1,5)/ 2673.2,1.,1.19E-11,0.9890,0.08/
      DATA(CF(I,15,15),I=1,5)/   10.5,1.,1.99E-07,0.5350,0.24/
      DATA(CF(I,15,14),I=1,5)/   19.8,1.,5.88E-08,0.5370,0.21/
      DATA(CF(I,15,13),I=1,5)/   30.2,1.,2.96E-08,0.8650,0.16/
      DATA(CF(I,15,12),I=1,5)/   51.4,1.,1.01E-08,0.5460,0.20/
      DATA(CF(I,15,11),I=1,5)/   65.0,1.,2.36E-09,0.1920,0.17/
      DATA(CF(I,15,10),I=1,5)/  220.4,0.,6.66E-09,1.0000,0.18/
      DATA(CF(I,15, 9),I=1,5)/  263.2,1.,1.24E-09,0.2150,0.26/
      DATA(CF(I,15, 8),I=1,5)/  309.4,0.,2.27E-09,0.7340,0.23/
      DATA(CF(I,15, 7),I=1,5)/  371.7,1.,6.14E-10,0.2560,0.27/
      DATA(CF(I,15, 6),I=1,5)/  424.5,1.,4.69E-10,0.3420,0.23/
      DATA(CF(I,15, 5),I=1,5)/  479.6,0.,6.14E-10,0.3340,0.39/
      DATA(CF(I,15, 4),I=1,5)/  560.4,0.,3.22E-10,0.8500,0.12/
      DATA(CF(I,15, 3),I=1,5)/  611.9,1.,9.32E-11,0.7340,0.16/
      DATA(CF(I,15, 2),I=1,5)/ 2816.9,0.,3.79E-11,0.8050,0.22/
      DATA(CF(I,15, 1),I=1,5)/ 3069.9,1.,9.73E-12,0.9910,0.08/
      DATA(CF(I,16,16),I=1,5)/   10.4,1.,5.49E-08,0.1000,0.25/
      DATA(CF(I,16,15),I=1,5)/   23.3,1.,6.81E-08,0.6930,0.21/
      DATA(CF(I,16,14),I=1,5)/   34.8,1.,2.14E-08,0.3530,0.24/
      DATA(CF(I,16,13),I=1,5)/   47.3,1.,1.66E-08,1.0300,0.14/
      DATA(CF(I,16,12),I=1,5)/   72.6,1.,6.12E-09,0.5800,0.19/
      DATA(CF(I,16,11),I=1,5)/   88.1,1.,1.33E-09,0.0688,0.35/
      DATA(CF(I,16,10),I=1,5)/  280.9,0.,4.93E-09,1.1300,0.16/
      DATA(CF(I,16, 9),I=1,5)/  328.2,1.,8.73E-10,0.1930,0.28/
      DATA(CF(I,16, 8),I=1,5)/  379.1,0.,1.35E-09,0.4310,0.32/
      DATA(CF(I,16, 7),I=1,5)/  447.1,1.,4.59E-10,0.2420,0.28/
      DATA(CF(I,16, 6),I=1,5)/  504.8,1.,3.49E-10,0.3050,0.25/
      DATA(CF(I,16, 5),I=1,5)/  564.7,0.,5.23E-10,0.4280,0.35/
      DATA(CF(I,16, 4),I=1,5)/  651.6,0.,2.59E-10,0.8540,0.12/
      DATA(CF(I,16, 3),I=1,5)/  707.2,1.,7.50E-11,0.7340,0.16/
      DATA(CF(I,16, 2),I=1,5)/ 3223.9,0.,2.67E-11,0.5720,0.28/
      DATA(CF(I,16, 1),I=1,5)/ 3494.2,1.,6.32E-12,0.5850,0.17/
      DATA(CF(I,17,17),I=1,5)/   13.0,1.,1.69E-07,0.4300,0.24/
      DATA(CF(I,17,16),I=1,5)/   23.8,1.,6.96E-08,0.6700,0.20/
      DATA(CF(I,17,15),I=1,5)/   39.6,1.,3.40E-08,0.8650,0.18/
      DATA(CF(I,17,14),I=1,5)/   53.5,1.,1.10E-08,0.3280,0.25/
      DATA(CF(I,17,13),I=1,5)/   67.8,1.,1.11E-08,1.3700,0.10/
      DATA(CF(I,17,12),I=1,5)/   97.0,1.,3.17E-09,0.3300,0.24/
      DATA(CF(I,17,11),I=1,5)/  114.2,1.,1.01E-09,0.1960,0.16/
      DATA(CF(I,17,10),I=1,5)/  348.3,0.,2.11E-09,0.3130,0.37/
      DATA(CF(I,17, 9),I=1,5)/  400.1,1.,6.32E-10,0.1730,0.30/
      DATA(CF(I,17, 8),I=1,5)/  455.6,0.,9.48E-10,0.3440,0.36/
      DATA(CF(I,17, 7),I=1,5)/  529.3,1.,3.69E-10,0.2730,0.26/
      DATA(CF(I,17, 6),I=1,5)/  592.0,1.,2.85E-10,0.3430,0.23/
      DATA(CF(I,17, 5),I=1,5)/  656.7,0.,4.81E-10,0.6580,0.27/
      DATA(CF(I,17, 4),I=1,5)/  749.8,1.,1.31E-10,0.6230,0.16/
      DATA(CF(I,17, 3),I=1,5)/  809.4,1.,6.13E-11,0.7360,0.16/
      DATA(CF(I,17, 2),I=1,5)/ 3658.4,0.,1.90E-11,0.3790,0.36/
      DATA(CF(I,17, 1),I=1,5)/ 3946.3,1.,5.14E-12,0.5530,0.18/
      DATA(CF(I,18,18),I=1,5)/   15.8,1.,5.99E-08,0.1360,0.26/
      DATA(CF(I,18,17),I=1,5)/   27.6,1.,6.07E-08,0.5440,0.21/
      DATA(CF(I,18,16),I=1,5)/   40.9,1.,3.43E-08,0.8340,0.17/
      DATA(CF(I,18,15),I=1,5)/   52.3,0.,3.00E-08,1.0300,0.25/
      DATA(CF(I,18,14),I=1,5)/   75.0,1.,8.73E-09,0.3660,0.31/
      DATA(CF(I,18,13),I=1,5)/   91.0,1.,5.78E-09,0.3140,0.34/
      DATA(CF(I,18,12),I=1,5)/  124.3,1.,2.98E-09,0.7030,0.16/
      DATA(CF(I,18,11),I=1,5)/  143.5,1.,7.25E-10,0.2070,0.15/
      DATA(CF(I,18,10),I=1,5)/  422.4,1.,1.40E-09,0.6960,0.13/
      DATA(CF(I,18, 9),I=1,5)/  478.7,1.,4.78E-10,0.1640,0.31/
      DATA(CF(I,18, 8),I=1,5)/  539.0,0.,8.02E-10,0.4390,0.32/
      DATA(CF(I,18, 7),I=1,5)/  618.3,1.,2.88E-10,0.2590,0.27/
      DATA(CF(I,18, 6),I=1,5)/  686.1,1.,2.32E-10,0.3620,0.22/
      DATA(CF(I,18, 5),I=1,5)/  755.7,0.,3.33E-10,0.4120,0.36/
      DATA(CF(I,18, 4),I=1,5)/  854.8,1.,1.27E-10,0.9100,0.13/
      DATA(CF(I,18, 3),I=1,5)/  918.0,1.,5.21E-11,0.7810,0.15/
      DATA(CF(I,18, 2),I=1,5)/ 4120.7,0.,1.66E-11,0.4350,0.33/
      DATA(CF(I,18, 1),I=1,5)/ 4426.2,1.,4.32E-12,0.5540,0.18/
      DATA(CF(I,19,19),I=1,5)/    4.3,1.,2.02E-07,0.2720,0.31/
      DATA(CF(I,19,18),I=1,5)/   31.6,1.,4.01E-08,0.3710,0.22/
      DATA(CF(I,19,17),I=1,5)/   45.8,1.,1.50E-08,0.4330,0.21/
      DATA(CF(I,19,16),I=1,5)/   60.9,1.,1.94E-08,0.8890,0.16/
      DATA(CF(I,19,15),I=1,5)/   82.7,1.,6.95E-09,0.4940,0.18/
      DATA(CF(I,19,14),I=1,5)/   99.4,1.,4.11E-09,0.5400,0.17/
      DATA(CF(I,19,13),I=1,5)/  117.6,1.,2.23E-09,0.5190,0.16/
      DATA(CF(I,19,12),I=1,5)/  154.7,1.,2.15E-09,0.8280,0.14/
      DATA(CF(I,19,11),I=1,5)/  175.8,0.,1.61E-09,0.6420,0.13/
      DATA(CF(I,19,10),I=1,5)/  504.0,1.,1.07E-09,0.6950,0.13/
      DATA(CF(I,19, 9),I=1,5)/  564.7,1.,3.78E-10,0.1730,0.30/
      DATA(CF(I,19, 8),I=1,5)/  629.4,0.,6.24E-10,0.4180,0.33/
      DATA(CF(I,19, 7),I=1,5)/  714.6,1.,2.29E-10,0.2450,0.28/
      DATA(CF(I,19, 6),I=1,5)/  786.6,1.,1.86E-10,0.3440,0.23/
      DATA(CF(I,19, 5),I=1,5)/  861.1,0.,2.69E-10,0.3960,0.37/
      DATA(CF(I,19, 4),I=1,5)/  968.0,1.,1.06E-10,0.9120,0.13/
      DATA(CF(I,19, 3),I=1,5)/ 1053.4,1.,4.24E-11,0.7370,0.16/
      DATA(CF(I,19, 2),I=1,5)/ 4610.9,0.,1.38E-11,0.4160,0.34/
      DATA(CF(I,19, 1),I=1,5)/ 4934.1,1.,3.67E-12,0.5550,0.18/
      DATA(CF(I,20,20),I=1,5)/    6.1,0.,4.40E-07,0.8480,0.33/
      DATA(CF(I,20,19),I=1,5)/   11.9,0.,5.22E-08,0.1510,0.34/
      DATA(CF(I,20,18),I=1,5)/   50.9,1.,2.06E-08,0.4180,0.20/
      DATA(CF(I,20,17),I=1,5)/   67.3,1.,1.72E-08,0.6380,0.19/
      DATA(CF(I,20,16),I=1,5)/   84.5,1.,1.26E-08,1.0100,0.14/
      DATA(CF(I,20,15),I=1,5)/  108.8,1.,4.72E-09,0.5260,0.17/
      DATA(CF(I,20,14),I=1,5)/  127.2,1.,2.89E-09,0.5480,0.17/
      DATA(CF(I,20,13),I=1,5)/  147.2,1.,1.64E-09,0.5520,0.15/
      DATA(CF(I,20,12),I=1,5)/  188.3,1.,1.57E-09,0.7990,0.14/
      DATA(CF(I,20,11),I=1,5)/  211.3,1.,4.32E-10,0.2320,0.14/
      DATA(CF(I,20,10),I=1,5)/  591.9,0.,9.47E-10,0.3110,0.38/
      DATA(CF(I,20, 9),I=1,5)/  657.2,1.,2.98E-10,0.1630,0.31/
      DATA(CF(I,20, 8),I=1,5)/  726.6,0.,4.78E-10,0.3590,0.36/
      DATA(CF(I,20, 7),I=1,5)/  817.6,1.,1.86E-10,0.2440,0.28/
      DATA(CF(I,20, 6),I=1,5)/  894.5,1.,1.56E-10,0.3640,0.22/
      DATA(CF(I,20, 5),I=1,5)/  974.0,0.,2.16E-10,0.3570,0.39/
      DATA(CF(I,20, 4),I=1,5)/ 1087.0,1.,7.70E-11,0.6550,0.15/
      DATA(CF(I,20, 3),I=1,5)/ 1157.0,1.,3.58E-11,0.7360,0.16/
      DATA(CF(I,20, 2),I=1,5)/ 5128.9,0.,1.28E-11,0.5200,0.30/
      DATA(CF(I,20, 1),I=1,5)/ 5469.9,1.,3.08E-12,0.5280,0.19/
      DATA(CF(I,21,21),I=1,5)/    6.6,1.,3.16E-07,0.2040,0.28/
      DATA(CF(I,21,20),I=1,5)/   12.8,1.,8.61E-08,0.1810,0.25/
      DATA(CF(I,21,19),I=1,5)/   24.8,1.,5.08E-08,0.3570,0.24/
      DATA(CF(I,21,18),I=1,5)/   73.5,1.,1.00E-08,0.4530,0.15/
      DATA(CF(I,21,17),I=1,5)/   91.9,1.,6.76E-09,0.4600,0.15/
      DATA(CF(I,21,16),I=1,5)/  110.7,1.,5.27E-09,0.5610,0.17/
      DATA(CF(I,21,15),I=1,5)/  138.0,1.,3.40E-09,0.5600,0.16/
      DATA(CF(I,21,14),I=1,5)/  158.1,1.,2.18E-09,0.6120,0.15/
      DATA(CF(I,21,13),I=1,5)/  180.0,1.,1.26E-09,0.6100,0.14/
      DATA(CF(I,21,12),I=1,5)/  225.1,1.,1.24E-09,0.8520,0.13/
      DATA(CF(I,21,11),I=1,5)/  249.8,1.,3.62E-10,0.3490,0.05/
      DATA(CF(I,21,10),I=1,5)/  687.4,1.,5.52E-10,0.3750,0.28/
      DATA(CF(I,21, 9),I=1,5)/  756.7,1.,5.64E-10,0.8730,0.15/
      DATA(CF(I,21, 8),I=1,5)/  830.8,1.,4.50E-10,1.0500,0.13/
      DATA(CF(I,21, 7),I=1,5)/  927.5,1.,2.73E-10,0.8660,0.15/
      DATA(CF(I,21, 6),I=1,5)/ 1009.0,1.,1.56E-10,0.7150,0.17/
      DATA(CF(I,21, 5),I=1,5)/ 1094.0,0.,1.81E-10,1.1400,0.36/
      DATA(CF(I,21, 4),I=1,5)/ 1213.0,1.,4.29E-11,0.7840,0.15/
      DATA(CF(I,21, 3),I=1,5)/ 1288.0,0.,2.21E-11,0.0270,0.82/
      DATA(CF(I,21, 2),I=1,5)/ 5674.9,1.,4.51E-12,0.9180,0.04/
      DATA(CF(I,21, 1),I=1,5)/ 6033.8,0.,2.03E-12,0.0170,0.70/
      DATA(CF(I,22,22),I=1,5)/    6.8,1.,1.60E-07,0.3600,0.28/
      DATA(CF(I,22,21),I=1,5)/   13.6,0.,2.14E-07,0.8800,0.28/
      DATA(CF(I,22,20),I=1,5)/   27.5,1.,2.85E-08,0.2270,0.21/
      DATA(CF(I,22,19),I=1,5)/   43.3,1.,3.48E-08,0.3900,0.23/
      DATA(CF(I,22,18),I=1,5)/   99.3,1.,1.00E-08,0.5790,0.18/
      DATA(CF(I,22,17),I=1,5)/  119.5,1.,7.01E-09,0.6380,0.17/
      DATA(CF(I,22,16),I=1,5)/  140.8,1.,4.95E-09,0.7170,0.16/
      DATA(CF(I,22,15),I=1,5)/  170.4,1.,2.99E-09,0.6930,0.17/
      DATA(CF(I,22,14),I=1,5)/  192.1,1.,2.10E-09,0.7220,0.16/
      DATA(CF(I,22,13),I=1,5)/  215.9,1.,1.62E-09,0.7650,0.14/
      DATA(CF(I,22,12),I=1,5)/  265.0,1.,1.11E-09,0.8850,0.12/
      DATA(CF(I,22,11),I=1,5)/  291.5,0.,9.09E-10,0.9720,0.06/
      DATA(CF(I,22,10),I=1,5)/  787.8,1.,4.41E-10,0.3590,0.29/
      DATA(CF(I,22, 9),I=1,5)/  863.1,1.,4.39E-10,0.7810,0.17/
      DATA(CF(I,22, 8),I=1,5)/  941.9,1.,3.73E-10,1.0500,0.13/
      DATA(CF(I,22, 7),I=1,5)/ 1044.0,1.,2.28E-10,0.8580,0.15/
      DATA(CF(I,22, 6),I=1,5)/ 1131.0,1.,1.34E-10,0.7570,0.16/
      DATA(CF(I,22, 5),I=1,5)/ 1221.0,0.,1.55E-10,1.1500,0.36/
      DATA(CF(I,22, 4),I=1,5)/ 1346.0,1.,3.80E-11,0.8350,0.14/
      DATA(CF(I,22, 3),I=1,5)/ 1426.0,0.,1.89E-11,0.0280,0.82/
      DATA(CF(I,22, 2),I=1,5)/ 6249.1,1.,4.01E-12,0.9680,0.03/
      DATA(CF(I,22, 1),I=1,5)/ 6625.0,1.,1.62E-12,0.6570,0.14/
      DATA(CF(I,23,23),I=1,5)/    6.7,0.,8.82E-07,0.3590,0.32/
      DATA(CF(I,23,22),I=1,5)/   14.7,0.,3.11E-07,0.4320,0.29/
      DATA(CF(I,23,21),I=1,5)/   29.3,1.,3.50E-08,0.2470,0.25/
      DATA(CF(I,23,20),I=1,5)/   46.7,0.,5.32E-08,1.1100,0.16/
      DATA(CF(I,23,19),I=1,5)/   65.3,1.,8.98E-09,0.1400,0.37/
      DATA(CF(I,23,18),I=1,5)/  128.1,1.,5.87E-09,0.5170,0.17/
      DATA(CF(I,23,17),I=1,5)/  150.6,1.,5.11E-09,0.6790,0.16/
      DATA(CF(I,23,16),I=1,5)/  173.4,1.,3.71E-09,0.7610,0.15/
      DATA(CF(I,23,15),I=1,5)/  205.8,1.,2.24E-09,0.7110,0.17/
      DATA(CF(I,23,14),I=1,5)/  230.5,1.,1.65E-09,0.7640,0.15/
      DATA(CF(I,23,13),I=1,5)/  256.0,1.,1.26E-09,0.7620,0.14/
      DATA(CF(I,23,12),I=1,5)/  308.0,1.,8.86E-10,0.8860,0.12/
      DATA(CF(I,23,11),I=1,5)/  336.3,0.,3.89E-10,0.1420,0.39/
      DATA(CF(I,23,10),I=1,5)/  896.0,1.,3.80E-10,0.4090,0.27/
      DATA(CF(I,23, 9),I=1,5)/  976.0,0.,4.84E-10,0.1730,0.57/
      DATA(CF(I,23, 8),I=1,5)/ 1060.0,1.,2.49E-10,0.6500,0.14/
      DATA(CF(I,23, 7),I=1,5)/ 1168.0,0.,5.91E-10,1.6100,0.18/
      DATA(CF(I,23, 6),I=1,5)/ 1260.0,0.,5.02E-10,2.1200,0.15/
      DATA(CF(I,23, 5),I=1,5)/ 1355.0,1.,5.38E-11,0.1370,0.40/
      DATA(CF(I,23, 4),I=1,5)/ 1486.0,1.,5.56E-11,0.7080,0.10/
      DATA(CF(I,23, 3),I=1,5)/ 1571.0,0.,2.84E-11,0.0240,0.79/
      DATA(CF(I,23, 2),I=1,5)/ 6851.3,0.,2.54E-11,2.9200,0.09/
      DATA(CF(I,23, 1),I=1,5)/ 7246.1,0.,1.32E-11,3.5100,0.07/
      DATA(CF(I,24,24),I=1,5)/    6.8,1.,1.03E-07,0.2170,0.27/
      DATA(CF(I,24,23),I=1,5)/   16.5,0.,2.45E-07,0.3810,0.32/
      DATA(CF(I,24,22),I=1,5)/   31.0,0.,1.09E-07,0.5180,0.27/
      DATA(CF(I,24,21),I=1,5)/   49.1,1.,1.52E-08,0.1820,0.30/
      DATA(CF(I,24,20),I=1,5)/   69.5,0.,3.25E-08,1.3600,0.13/
      DATA(CF(I,24,19),I=1,5)/   90.6,1.,5.50E-09,0.1430,0.37/
      DATA(CF(I,24,18),I=1,5)/  160.2,1.,5.13E-09,0.6570,0.16/
      DATA(CF(I,24,17),I=1,5)/  184.7,1.,3.85E-09,0.7220,0.15/
      DATA(CF(I,24,16),I=1,5)/  209.3,1.,2.81E-09,0.7590,0.15/
      DATA(CF(I,24,15),I=1,5)/  244.4,1.,1.76E-09,0.7320,0.16/
      DATA(CF(I,24,14),I=1,5)/  271.0,1.,1.30E-09,0.7640,0.15/
      DATA(CF(I,24,13),I=1,5)/  298.0,1.,1.02E-09,0.8100,0.13/
      DATA(CF(I,24,12),I=1,5)/  354.8,1.,7.19E-10,0.8870,0.12/
      DATA(CF(I,24,11),I=1,5)/  384.2,1.,1.61E-10,0.1500,0.22/
      DATA(CF(I,24,10),I=1,5)/ 1011.0,1.,4.64E-10,0.9710,0.12/
      DATA(CF(I,24, 9),I=1,5)/ 1097.0,1.,3.31E-10,0.9240,0.14/
      DATA(CF(I,24, 8),I=1,5)/ 1185.0,1.,2.49E-10,0.9310,0.15/
      DATA(CF(I,24, 7),I=1,5)/ 1299.0,1.,1.68E-10,0.9100,0.14/
      DATA(CF(I,24, 6),I=1,5)/ 1396.0,1.,1.01E-10,0.8050,0.15/
      DATA(CF(I,24, 5),I=1,5)/ 1496.0,0.,1.17E-10,1.2100,0.35/
      DATA(CF(I,24, 4),I=1,5)/ 1634.0,1.,2.91E-11,0.8840,0.13/
      DATA(CF(I,24, 3),I=1,5)/ 1721.0,0.,1.45E-11,0.0350,0.80/
      DATA(CF(I,24, 2),I=1,5)/ 7482.0,1.,3.07E-12,0.9670,0.03/
      DATA(CF(I,24, 1),I=1,5)/ 7894.8,1.,1.46E-12,0.1830,0.39/
      DATA(CF(I,25,25),I=1,5)/    7.4,1.,8.56E-08,0.1320,0.26/
      DATA(CF(I,25,24),I=1,5)/   15.6,0.,1.18E-07,0.3590,0.19/
      DATA(CF(I,25,23),I=1,5)/   33.7,0.,8.54E-08,0.3970,0.32/
      DATA(CF(I,25,22),I=1,5)/   51.2,1.,1.80E-08,0.2720,0.18/
      DATA(CF(I,25,21),I=1,5)/   72.4,1.,8.22E-09,0.1610,0.32/
      DATA(CF(I,25,20),I=1,5)/   95.0,0.,2.15E-08,1.5400,0.11/
      DATA(CF(I,25,19),I=1,5)/  119.3,1.,3.65E-09,0.1470,0.37/
      DATA(CF(I,25,18),I=1,5)/  194.5,1.,3.91E-09,0.6990,0.15/
      DATA(CF(I,25,17),I=1,5)/  221.8,1.,2.92E-09,0.7190,0.15/
      DATA(CF(I,25,16),I=1,5)/  248.3,1.,2.23E-09,0.8060,0.14/
      DATA(CF(I,25,15),I=1,5)/  286.0,1.,1.39E-09,0.7350,0.16/
      DATA(CF(I,25,14),I=1,5)/  314.4,1.,1.04E-09,0.7610,0.15/
      DATA(CF(I,25,13),I=1,5)/  343.6,1.,8.28E-10,0.8090,0.13/
      DATA(CF(I,25,12),I=1,5)/  403.0,1.,5.60E-10,0.7870,0.14/
      DATA(CF(I,25,11),I=1,5)/  435.2,1.,1.52E-10,0.2990,0.08/
      DATA(CF(I,25,10),I=1,5)/ 1133.0,1.,4.03E-10,1.0400,0.11/
      DATA(CF(I,25, 9),I=1,5)/ 1244.0,1.,2.74E-10,0.9230,0.14/
      DATA(CF(I,25, 8),I=1,5)/ 1317.0,1.,2.18E-10,0.9900,0.14/
      DATA(CF(I,25, 7),I=1,5)/ 1437.0,1.,1.49E-10,0.9680,0.13/
      DATA(CF(I,25, 6),I=1,5)/ 1539.0,1.,8.70E-11,0.8020,0.15/
      DATA(CF(I,25, 5),I=1,5)/ 1644.0,0.,1.02E-10,1.2200,0.35/
      DATA(CF(I,25, 4),I=1,5)/ 1788.0,1.,2.54E-11,0.8830,0.13/
      DATA(CF(I,25, 3),I=1,5)/ 1880.0,0.,1.28E-11,0.0330,0.81/
      DATA(CF(I,25, 2),I=1,5)/ 8141.0,1.,2.77E-12,1.0100,0.02/
      DATA(CF(I,25, 1),I=1,5)/ 8571.9,1.,1.32E-12,0.2190,0.37/
      DATA(CF(I,26,26),I=1,5)/    7.9,0.,2.52E-07,0.7010,0.25/
      DATA(CF(I,26,25),I=1,5)/   16.2,1.,2.21E-08,0.0330,0.45/
      DATA(CF(I,26,24),I=1,5)/   30.6,0.,4.10E-08,0.3660,0.17/
      DATA(CF(I,26,23),I=1,5)/   54.8,0.,3.53E-08,0.2430,0.39/
      DATA(CF(I,26,22),I=1,5)/   75.0,1.,1.04E-08,0.2850,0.17/
      DATA(CF(I,26,21),I=1,5)/   99.0,1.,1.23E-08,0.4110,0.21/
      DATA(CF(I,26,20),I=1,5)/  125.0,1.,9.47E-09,0.4580,0.21/
      DATA(CF(I,26,19),I=1,5)/  151.1,1.,4.71E-09,0.2800,0.28/
      DATA(CF(I,26,18),I=1,5)/  233.6,1.,3.02E-09,0.6970,0.15/
      DATA(CF(I,26,17),I=1,5)/  262.1,1.,2.34E-09,0.7640,0.14/
      DATA(CF(I,26,16),I=1,5)/  290.0,1.,1.76E-09,0.8050,0.14/
      DATA(CF(I,26,15),I=1,5)/  331.0,1.,1.14E-09,0.7730,0.15/
      DATA(CF(I,26,14),I=1,5)/  361.0,1.,8.66E-10,0.8050,0.14/
      DATA(CF(I,26,13),I=1,5)/  392.0,1.,6.61E-10,0.7620,0.14/
      DATA(CF(I,26,12),I=1,5)/  457.0,1.,4.41E-10,0.6980,0.16/
      DATA(CF(I,26,11),I=1,5)/  489.3,1.,1.18E-10,0.2110,0.15/
      DATA(CF(I,26,10),I=1,5)/ 1262.0,1.,3.61E-10,1.1600,0.09/
      DATA(CF(I,26, 9),I=1,5)/ 1360.0,1.,2.45E-10,0.9780,0.13/
      DATA(CF(I,26, 8),I=1,5)/ 1470.0,1.,1.87E-10,0.9880,0.14/
      DATA(CF(I,26, 7),I=1,5)/ 1582.0,1.,1.33E-10,1.0300,0.12/
      DATA(CF(I,26, 6),I=1,5)/ 1690.0,1.,7.84E-11,0.8480,0.14/
      DATA(CF(I,26, 5),I=1,5)/ 1800.0,0.,8.90E-11,1.2000,0.35/
      DATA(CF(I,26, 4),I=1,5)/ 1960.0,1.,2.29E-11,0.9360,0.12/
      DATA(CF(I,26, 3),I=1,5)/ 2046.0,0.,1.12E-11,0.0340,0.81/
      DATA(CF(I,26, 2),I=1,5)/ 8828.0,1.,2.46E-12,1.0200,0.02/
      DATA(CF(I,26, 1),I=1,5)/ 9277.7,1.,9.79E-13,0.6640,0.14/
      DATA(CF(I,27,27),I=1,5)/    7.9,1.,8.89E-08,0.1270,0.24/
      DATA(CF(I,27,26),I=1,5)/   17.1,1.,5.65E-08,0.1940,0.23/
      DATA(CF(I,27,25),I=1,5)/   33.5,1.,3.06E-08,0.2010,0.22/
      DATA(CF(I,27,24),I=1,5)/   51.3,0.,2.27E-08,0.5740,0.10/
      DATA(CF(I,27,23),I=1,5)/   79.5,0.,1.93E-08,0.1950,0.42/
      DATA(CF(I,27,22),I=1,5)/  102.0,0.,1.27E-08,0.1260,0.47/
      DATA(CF(I,27,21),I=1,5)/  129.0,1.,3.58E-09,0.1940,0.29/
      DATA(CF(I,27,20),I=1,5)/  158.0,0.,1.17E-08,1.9800,0.07/
      DATA(CF(I,27,19),I=1,5)/  186.1,1.,1.78E-09,0.1120,0.42/
      DATA(CF(I,27,18),I=1,5)/  275.0,1.,2.41E-09,0.7390,0.14/
      DATA(CF(I,27,17),I=1,5)/  305.0,1.,1.86E-09,0.7620,0.14/
      DATA(CF(I,27,16),I=1,5)/  336.0,1.,1.41E-09,0.8040,0.14/
      DATA(CF(I,27,15),I=1,5)/  379.0,1.,9.54E-10,0.8130,0.14/
      DATA(CF(I,27,14),I=1,5)/  411.0,1.,7.12E-10,0.8030,0.14/
      DATA(CF(I,27,13),I=1,5)/  444.0,1.,5.34E-10,0.7180,0.15/
      DATA(CF(I,27,12),I=1,5)/  512.0,1.,3.62E-10,0.6580,0.17/
      DATA(CF(I,27,11),I=1,5)/  546.6,1.,1.05E-10,0.2520,0.12/
      DATA(CF(I,27,10),I=1,5)/ 1397.0,1.,3.10E-10,1.1700,0.09/
      DATA(CF(I,27, 9),I=1,5)/ 1486.0,1.,1.56E-10,0.5720,0.15/
      DATA(CF(I,27, 8),I=1,5)/ 1603.0,1.,1.32E-10,0.6820,0.13/
      DATA(CF(I,27, 7),I=1,5)/ 1735.0,1.,9.08E-11,0.5110,0.17/
      DATA(CF(I,27, 6),I=1,5)/ 1846.0,0.,3.45E-10,2.8400,0.11/
      DATA(CF(I,27, 5),I=1,5)/ 1962.0,1.,5.01E-11,0.7140,0.11/
      DATA(CF(I,27, 4),I=1,5)/ 2119.0,1.,1.92E-11,0.1170,0.42/
      DATA(CF(I,27, 3),I=1,5)/ 2219.0,1.,1.95E-11,1.2000,0.00/
      DATA(CF(I,27, 2),I=1,5)/ 9544.0,0.,1.68E-11,3.5200,0.05/
      DATA(CF(I,27, 1),I=1,5)/10012.1,1.,1.45E-12,0.6350,0.15/
      DATA(CF(I,28,28),I=1,5)/    7.6,0.,1.65E-07,0.4520,0.28/
      DATA(CF(I,28,27),I=1,5)/   18.2,0.,8.42E-08,0.6190,0.16/
      DATA(CF(I,28,26),I=1,5)/   35.3,1.,1.89E-08,0.2200,0.21/
      DATA(CF(I,28,25),I=1,5)/   54.9,1.,1.48E-08,0.2160,0.21/
      DATA(CF(I,28,24),I=1,5)/   76.0,0.,1.13E-08,0.5180,0.09/
      DATA(CF(I,28,23),I=1,5)/  108.0,0.,1.16E-08,0.1850,0.44/
      DATA(CF(I,28,22),I=1,5)/  133.0,0.,8.68E-09,0.1380,0.46/
      DATA(CF(I,28,21),I=1,5)/  162.0,1.,2.45E-09,0.1630,0.32/
      DATA(CF(I,28,20),I=1,5)/  193.0,0.,9.24E-09,2.2500,0.05/
      DATA(CF(I,28,19),I=1,5)/  225.0,0.,2.41E-09,0.0270,0.79/
      DATA(CF(I,28,18),I=1,5)/  321.0,1.,1.92E-09,0.7380,0.14/
      DATA(CF(I,28,17),I=1,5)/  352.0,1.,1.50E-09,0.7610,0.14/
      DATA(CF(I,28,16),I=1,5)/  384.0,1.,1.16E-09,0.8030,0.14/
      DATA(CF(I,28,15),I=1,5)/  430.0,1.,8.08E-10,0.8560,0.13/
      DATA(CF(I,28,14),I=1,5)/  464.0,1.,6.09E-10,0.8500,0.13/
      DATA(CF(I,28,13),I=1,5)/  499.0,1.,4.48E-10,0.7180,0.15/
      DATA(CF(I,28,12),I=1,5)/  571.3,1.,3.00E-10,0.6220,0.18/
      DATA(CF(I,28,11),I=1,5)/  607.0,1.,7.90E-11,0.1600,0.19/
      DATA(CF(I,28,10),I=1,5)/ 1541.0,1.,2.78E-10,1.2500,0.08/
      DATA(CF(I,28, 9),I=1,5)/ 1648.0,1.,1.92E-10,1.0400,0.12/
      DATA(CF(I,28, 8),I=1,5)/ 1756.0,1.,1.51E-10,1.1100,0.12/
      DATA(CF(I,28, 7),I=1,5)/ 1894.0,1.,1.05E-10,1.0900,0.11/
      DATA(CF(I,28, 6),I=1,5)/ 2011.0,1.,6.04E-11,0.8490,0.14/
      DATA(CF(I,28, 5),I=1,5)/ 2131.0,0.,6.91E-11,1.2100,0.35/
      DATA(CF(I,28, 4),I=1,5)/ 2295.0,1.,1.84E-11,0.9910,0.11/
      DATA(CF(I,28, 3),I=1,5)/ 2399.0,0.,9.03E-12,0.0420,0.79/
      DATA(CF(I,28, 2),I=1,5)/10290.0,1.,2.61E-12,0.5680,0.16/
      DATA(CF(I,28, 1),I=1,5)/10775.3,1.,1.39E-12,0.7290,0.13/
      DATA(CF(I,29,29),I=1,5)/    7.7,0.,1.65E-07,0.4520,0.28/
      DATA(CF(I,29,28),I=1,5)/   20.3,0.,8.42E-08,0.6190,0.16/
      DATA(CF(I,29,27),I=1,5)/   36.8,0.,8.42E-08,0.6190,0.16/
      DATA(CF(I,29,26),I=1,5)/   57.4,1.,1.89E-08,0.2200,0.21/
      DATA(CF(I,29,25),I=1,5)/   79.9,1.,1.48E-08,0.2160,0.21/
      DATA(CF(I,29,24),I=1,5)/  103.0,0.,1.13E-08,0.5180,0.09/
      DATA(CF(I,29,23),I=1,5)/  139.0,0.,1.16E-08,0.1850,0.44/
      DATA(CF(I,29,22),I=1,5)/  167.0,0.,8.68E-09,0.1380,0.46/
      DATA(CF(I,29,21),I=1,5)/  199.0,1.,2.45E-09,0.1630,0.32/
      DATA(CF(I,29,20),I=1,5)/  232.0,0.,9.24E-09,2.2500,0.05/
      DATA(CF(I,29,19),I=1,5)/  266.1,0.,2.41E-09,0.0270,0.79/
      DATA(CF(I,29,18),I=1,5)/  368.8,1.,1.92E-09,0.7380,0.14/
      DATA(CF(I,29,17),I=1,5)/  401.0,1.,1.50E-09,0.7610,0.14/
      DATA(CF(I,29,16),I=1,5)/  435.0,1.,1.16E-09,0.8030,0.14/
      DATA(CF(I,29,15),I=1,5)/  484.0,1.,8.08E-10,0.8560,0.13/
      DATA(CF(I,29,14),I=1,5)/  520.0,1.,6.09E-10,0.8500,0.13/
      DATA(CF(I,29,13),I=1,5)/  557.0,1.,4.48E-10,0.7180,0.15/
      DATA(CF(I,29,12),I=1,5)/  633.0,1.,3.00E-10,0.6220,0.18/
      DATA(CF(I,29,11),I=1,5)/  670.6,1.,7.90E-11,0.1600,0.19/
      DATA(CF(I,29,10),I=1,5)/ 1690.0,1.,2.78E-10,1.2500,0.08/
      DATA(CF(I,29, 9),I=1,5)/ 1793.0,1.,1.92E-10,1.0400,0.12/
      DATA(CF(I,29, 8),I=1,5)/ 1905.0,1.,1.51E-10,1.1100,0.12/
      DATA(CF(I,29, 7),I=1,5)/ 2045.0,1.,1.05E-10,1.0900,0.11/
      DATA(CF(I,29, 6),I=1,5)/ 2173.0,1.,6.04E-11,0.8490,0.14/
      DATA(CF(I,29, 5),I=1,5)/ 2298.0,0.,6.91E-11,1.2100,0.35/
      DATA(CF(I,29, 4),I=1,5)/ 2459.0,1.,1.84E-11,0.9910,0.11/
      DATA(CF(I,29, 3),I=1,5)/ 2585.0,0.,9.03E-12,0.0420,0.79/
      DATA(CF(I,29, 2),I=1,5)/11060.0,1.,2.61E-12,0.5680,0.16/
      DATA(CF(I,29, 1),I=1,5)/11570.0,1.,1.39E-12,0.7290,0.13/
      DATA(CF(I,30,30),I=1,5)/    9.4,0.,1.65E-07,0.4520,0.28/
      DATA(CF(I,30,29),I=1,5)/   18.0,0.,8.42E-08,0.6190,0.16/
      DATA(CF(I,30,28),I=1,5)/   39.7,0.,8.42E-08,0.6190,0.16/
      DATA(CF(I,30,27),I=1,5)/   59.4,0.,8.42E-08,0.6190,0.16/
      DATA(CF(I,30,26),I=1,5)/   82.6,1.,1.89E-08,0.2200,0.21/
      DATA(CF(I,30,25),I=1,5)/  108.0,1.,1.48E-08,0.2160,0.21/
      DATA(CF(I,30,24),I=1,5)/  136.0,0.,1.13E-08,0.5180,0.09/
      DATA(CF(I,30,23),I=1,5)/  175.0,0.,1.16E-08,0.1850,0.44/
      DATA(CF(I,30,22),I=1,5)/  203.0,0.,8.68E-09,0.1380,0.46/
      DATA(CF(I,30,21),I=1,5)/  238.0,1.,2.45E-09,0.1630,0.32/
      DATA(CF(I,30,20),I=1,5)/  274.0,0.,9.24E-09,2.2500,0.05/
      DATA(CF(I,30,19),I=1,5)/  310.8,0.,2.41E-09,0.0270,0.79/
      DATA(CF(I,30,18),I=1,5)/  419.7,1.,1.92E-09,0.7380,0.14/
      DATA(CF(I,30,17),I=1,5)/  454.0,1.,1.50E-09,0.7610,0.14/
      DATA(CF(I,30,16),I=1,5)/  490.0,1.,1.16E-09,0.8030,0.14/
      DATA(CF(I,30,15),I=1,5)/  542.0,1.,8.08E-10,0.8560,0.13/
      DATA(CF(I,30,14),I=1,5)/  579.0,1.,6.09E-10,0.8500,0.13/
      DATA(CF(I,30,13),I=1,5)/  619.0,1.,4.48E-10,0.7180,0.15/
      DATA(CF(I,30,12),I=1,5)/  698.0,1.,3.00E-10,0.6220,0.18/
      DATA(CF(I,30,11),I=1,5)/  737.4,1.,7.90E-11,0.1600,0.19/
      DATA(CF(I,30,10),I=1,5)/ 1846.0,1.,2.78E-10,1.2500,0.08/
      DATA(CF(I,30, 9),I=1,5)/ 1953.0,1.,1.92E-10,1.0400,0.12/
      DATA(CF(I,30, 8),I=1,5)/ 2070.0,1.,1.51E-10,1.1100,0.12/
      DATA(CF(I,30, 7),I=1,5)/ 2216.0,1.,1.05E-10,1.0900,0.11/
      DATA(CF(I,30, 6),I=1,5)/ 2363.0,1.,6.04E-11,0.8490,0.14/
      DATA(CF(I,30, 5),I=1,5)/ 2479.0,0.,6.91E-11,1.2100,0.35/
      DATA(CF(I,30, 4),I=1,5)/ 2647.0,1.,1.84E-11,0.9910,0.11/
      DATA(CF(I,30, 3),I=1,5)/ 2780.0,0.,9.03E-12,0.0420,0.79/
      DATA(CF(I,30, 2),I=1,5)/11870.0,1.,2.61E-12,0.5680,0.16/
      DATA(CF(I,30, 1),I=1,5)/12390.0,1.,1.39E-12,0.7290,0.13/
      end
******************************************************************************
      subroutine ChckFill
      implicit none
*perform sanity check confirming that the energy array has been properly filled
      integer nfill
      parameter (nfill=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real filbnd,fildel,filres
      integer ifill0 , nrange
      common/fillnu/ filbnd(nfill+1),fildel(nfill),filres(nfill),
     1 ifill0(nfill) , nrange
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , ipoint , ipnt
      real energy
      logical lgFail
*
      lgFail = .false.
      do i=1,nrange
*       test middle of energy bound
        energy = (filbnd(i)+filbnd(i+1))/2.
        ipnt = ipoint( energy )
        if( energy.lt. anu(ipnt)-widflx(ipnt)*0.5 ) then
          write(qq,'('' ChckFill middle test low fail'')')
          lgFail = .true.
        else if (energy.gt. anu(ipnt)+widflx(ipnt)*0.5) then
          write(qq,'('' ChckFill middle test high fail'')')
          lgFail = .true.
        endif
*       test near low bound
        energy = filbnd(i)*0.99 +filbnd(i+1)*0.01
        ipnt = ipoint( energy )
        if( energy.lt. anu(ipnt)-widflx(ipnt)*0.5 ) then
          write(qq,'('' ChckFill low test low fail'')')
          lgFail = .true.
        else if (energy.gt. anu(ipnt)+widflx(ipnt)*0.5) then
          write(qq,'('' ChckFill low test high fail'')')
          lgFail = .true.
        endif
*       test near high bound
        energy = filbnd(i)*0.01 +filbnd(i+1)*0.99
        ipnt = ipoint( energy )
        if( energy.lt. anu(ipnt)-widflx(ipnt)*0.5 ) then
          write(qq,'('' ChckFill high test low fail'')')
          lgFail = .true.
        else if (energy.gt. anu(ipnt)+widflx(ipnt)*0.5) then
          write(qq,'('' ChckFill high test high fail'')')
          lgFail = .true.
        endif
      end do
      if( lgFail ) stop
*
      end
******************************************************************************
      function chGetLbl(i)
      implicit none
*use line arrays to get a label knowing only pointer within stack of lines
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      character chGetLbl*10 , chLineLbl*10
      integer i
*
*     this is to allow addressing of line array when main
*     sub already has explicit set
*
      chGetLbl = chLineLbl( TauLines(1,i) )
*
      end
******************************************************************************
      function chIonLbl(tarray)
      implicit none
*use information in line array to generate an ion label
      character*4 chIonLbl
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
*
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      character chIonStage*4
      common/IonStage/ chIonStage(limelm+1)
*
*     function to use information within the line array
*     to generate an ion label, giving element and
*     ionization stage
*
      if( tarray(ipLnNelem).lt.0. ) then
*       this line is to be ignored
        chIonLbl = 'Dumy'
      else
        chIonLbl(1:2) = chElementSym(int(tarray(ipLnNelem)))
        chIonLbl(3:4) =  chIonStage(int(tarray(ipLnIonStg)))
      endif
*
      end
      subroutine chkCaHeps( totwid )
      implicit none
*check whether CaII K and H epsilon overlap
      real totwid
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*
*     local variables
      real conca , conhe
*     pumping of CaH
      if( t3969(1).gt.0. .and. htau(6,2).gt.0. ) then
        conca = max( sqrt(max(1.,log(t3969(1)))),
     1  (6.1e-5*t3969(1))**0.5 )
        conhe = max( sqrt(max(1.,log(htau(6,2)))) ,
     1  (1.7e-6*htau(6,2)) ** 0.5 )
        totwid = 10.*conhe + 1.6*conca
      else
       totwid = 0.
      endif
      end
******************************************************************************
      subroutine ChkRate( nelem , dDestRate , istage )
      implicit none
*called by nextdr to check how rates of destruction of various species changes
      integer nelem, istage
      real dDestRate
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*
*     local variables
      integer i
      real OldDest(limelm,limelm) , average , dDest
      save OldDest
*
      if( .not.lgElmtOn(nelem) ) then
        dDestRate = 1e-3
        return
      endif
*
*     write(90,'(i3,1x,1p,2e10.2)')
*    1 (i,destroy(i,i),create(i,i),i=1,limelm)
      dDestRate = 0.
      if( nzone.le.1 ) then
        do i=1,nelem
          OldDest(nelem,i) = destroy(nelem,i)
        end do
      else if( xIonFracs(nelem,1)/xIonFracs(nelem,0).lt.0.9 ) then
*       do not use this method if everything is atomic
        do i=1,nelem-1
*         last check below, .5 chosen so that do not key off
*         predominantly neutral species where self-opacity
*         could cause oscillations
          if( xIonFracs(nelem,i)/xIonFracs(nelem,0).gt.0.01.and.
     1      xIonFracs(nelem,i)/xIonFracs(nelem,0).lt.0.9 .and.
     2      xIonFracs(nelem,i+1)/xIonFracs(nelem,0).gt..05 .and.
     3      OldDest(nelem,i).gt.0. ) then
*           last check on old dest in case just lowered ionization
*           stage, so no history
*begin sanity check
            if( destroy(nelem,i).le.0. ) then
              write(qq,'('' ChkRate gets insane destruction rate for ''
     1        ''ion'',2i4,1p,e10.2)') nelem,i,destroy(nelem,i)
              stop
            endif
*end sanity check
*           do not consider unless of middling ionization, and
*           rate is going down (to prevent dr osciallating)
*           no absolute value in following since do not want to
*           consider cases where ionization rate increases
            average = (OldDest(nelem,i) + destroy(nelem,i))*0.5
            dDest = (OldDest(nelem,i) - real(destroy(nelem,i)))/ average
*           ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ term + if rate going down
            if( dDestRate.lt.dDest ) then
              dDestRate = dDest
              istage = i
            endif
*           dDestRate = max(dDestRate,
*    1      (OldDest(nelem,i) - real(destroy(nelem,i)))/ average)
*           ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ term + if rate going down
          endif
          OldDest(nelem,i) = destroy(nelem,i)
        end do
      endif
*     write(nelem,'(1p,10e10.2)') (destroy(nelem,i),i=1,5)
*
      end
******************************************************************************
      subroutine ChkSumCon( ipPnt )
      implicit none
*sanity check confirms summed continua reflect contents of individuals
      integer ipPnt
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      integer ipSecIon
      common/ipSecIon/ ipSecIon
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real phisig
*
*     this entire sub is a sanity check
*begin sanity check
      do i=1,nflux
        phisig = otscon(i)+otslin(i)+outcon(i)+outlin(i)
        if( phisig.gt.0. ) then
          if( abs(SummedDif(i)/phisig-1.) .gt.1e-3 )then
            call insane
            write(qq,'('' ChkSumCon insane SummedDif at energy''
     1      ,1p,e12.5,'' error='',e10.2,'' i='',i4)')
     2      anu(i),SummedDif(i)/phisig-1., i
            write(qq,'('' SummedDif, sum are'',1p,5e11.4)')SummedDif(i),
     1      phisig
            write(qq,'('' otscon otslin outcon outlin are'',1p,5e11.4)')
     1      otscon(i),otslin(i),outcon(i), outlin(i)
            write(qq,'('' line continuum here are'',2(1x,a4))')
     1      chLineLabel(i), chContLabel(i)
          endif
        endif
        phisig = flux(i) + phisig
        if( phisig.gt.0. ) then
          if( abs(SummedCon(i)/phisig-1.) .gt.1e-3 )then
            call insane
            write(qq,'('' ChkSumCon'',i3'', insane SummedCon at energy''
     1      ,1p,e12.5,'' error='',e10.2,'' i='',i4)')ipPnt,
     2      anu(i),SummedCon(i)/phisig-1., i
            write(qq,'('' SummedCon, sum are'',1p,5e11.4)')SummedCon(i),
     1      phisig
            write(qq,'('' otscon otslin outcon outlin flux are'',1p,
     1      5e11.4)')
     1      otscon(i),otslin(i),outcon(i), outlin(i),flux(i)
            write(qq,'('' line continuum here are'',2(1x,a4))')
     1      chLineLabel(i), chContLabel(i)
          endif
        endif
      end do
*end sanity check
*
      end
******************************************************************************
      function chLineLbl(tarray)
      implicit none
*use information in line transfer arrays to generate a line label
      character*10 chLineLbl
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
*
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      character chIonStage*4
      common/IonStage/ chIonStage(limelm+1)
*
*     local variables
      integer iWl
*
*     function to use information within the line array
*     to generate a line label, giving element and
*     ionization stage
*     rhs are set in large block data
*
*     NB this funciton is profoundly slow due to write statement
*     also - it cannot be evaluated within a write statement itself
*
      iWl = tarray(ipLnWlAng)
      if( iWl.gt.99 999 ) then
        write(chLineLbl,'(a2,a2,i5,a1)')
     1  chElementSym(int(tarray(ipLnNelem))) ,
     2  chIonStage(int(tarray(ipLnIonStg))) ,
     3  iWl /10 000 , 'm'
      else if( iWl.gt. 9 999 ) then
        write(chLineLbl,'(a2,a2,f5.2,a1)')
     1  chElementSym(int(tarray(ipLnNelem))) ,
     2  chIonStage(int(tarray(ipLnIonStg))) ,
     3  tarray(ipLnWlAng)/1e4 , 'm'
      else if( iWl.ge.100 ) then
        write(chLineLbl,'(a2,a2,i5,a1)')
     1  chElementSym(int(tarray(ipLnNelem))) ,
     2  chIonStage(int(tarray(ipLnIonStg))) ,
     3  iWl , 'A'
      else if( iWl.ge.10 ) then
        write(chLineLbl,'(a2,a2,f5.1,a1)')
     1  chElementSym(int(tarray(ipLnNelem))) ,
     2  chIonStage(int(tarray(ipLnIonStg))) ,
     3  tarray(ipLnWlAng) , 'A'
      else
        write(chLineLbl,'(a2,a2,f5.2,a1)')
     1  chElementSym(int(tarray(ipLnNelem))) ,
     2  chIonStage(int(tarray(ipLnIonStg))) ,
     3  tarray(ipLnWlAng) , 'A'
      endif
*666  write(6,'(a10)') chLineLbl
*
      end
******************************************************************************
      subroutine cholup( dc , loop )
      implicit none
*called by tfirst, calls ConvIoniz and coolr to get converged ion, cooling
      real dc
      integer loop
*
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real hold , cold  , tol
      integer llim
      logical lgGivewn
      save lgGivewn
*
*     this routine only called by tfirst, when poking around
*     for initial solution
*
      lgGivewn = .true.
      hold = 0.
      cold = 0.
      loop = 1
*     must do very first solution several times to get stable answer
*     since there is some hysteresis in the problem
*     this routine keeps at it until the heating and cooling do not change
      tol = 0.1
      llim = 20
      do while( loop.lt.llim .and.
     1   (abs(cold/ctot-1.).gt.tol .or.
     2   abs(hold/max(1e-37,htot)-1.).gt.tol ))
         hold = htot
         cold = ctot
         lgNewIon = .true.
         lgDoPhoto = .true.
         call ConvIoniz
         if( htot.eq.0. .and.lgGivewn ) then
            write(qq,'(''  '')')
            write(qq,'('' HELP!!! I found a heating rate of zero and ''
     1      ,''will probably soon crash.'')')
            write(qq,'('' Whats wrong??  There MUST be a heating '',
     1      ''source.'')')
            lgGivewn = .false.
            write(qq,'(''  '')')
            write(qq,'(''  '')')
         endif
         call coolr(ctot,dc )
         if( lgTrace ) then
           write(qq,'('' RETURN TO CHOLUP 1, HTOT:'',1P,E10.3,
     1     ''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e10.2,25(''<''))
     2     ')
     2     htot , ctot , te,eden
         end if
*        force reevaluation of H trans rates
         htnext(3,2) = htnext(3,2) * 0.9999
         if(lgTrConvg.and.nLevTrace.lt.2 ) then
           write(qq,'(''   cholup'',i3,'' htot,old'',1p,2e9.2
     1     ,'' ctot,old='',2e9.2)') loop,htot,hold,ctot,cold
         endif
         loop = loop + 1
      end do
*     repair optical depths
      htnext(3,2) = htnext(3,2) * 0.9999
      if( loop.gt.1 ) then
        htnext(3,2) = htnext(3,2) / ( 0.9999**loop )
      endif
*
      if( loop.ge.llim+1 ) then
        write(qq,'('' CHOLUP did not converge heating'',
     1  '' and cooling, loop='',I3,'' te='',1P,E10.2)') loop,te
      endif
*
*     write(QQ,'('' cholup, te, lup, h c'',1p,e10.2,i3,2e10.2)')
*    1 te , loop , htot , ctot
*
      end
******************************************************************************
      subroutine chromi
      implicit none
*do ionization balance for chromium
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real hi , hii
      common/h/ hi , hii
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (nelem=24)
      parameter (ndim=25)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL fyield(NELEM) , grdeff(NELEM)
*
*     chromium nelem=24
*     based on iron
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.26E-10,4.97E-11,1.49E-10,3.90E-11,1.66E-11,7.16E-12,
     1 3.00E-12,1.02E-12,2.54E-12,1.70E-12,1.11E-12,6.42E-13,3.59E-13,
     2 9.30E-14,1.62E-14,5.97E-14,8.44E-14,5.92E-14,4.72E-14,3.79E-14,
     3 2.60E-14,1.61E-14,1.16E-14,5.39E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /9.13E4,1.88E5,3.56E5,6.36E5,8.70E5,1.15E6,1.45E6,1.75E6,
     2 2.73E6,3.04E6,3.37E6,3.84E6,4.19E6,4.55E6,5.30E6,5.68E6,
     3 1.47E7,1.58E7,1.69E7,1.84E7,1.96E7,2.09E7,2.26E7,2.35E7/
*
*     DATA FYIELD/2*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47,2*.48,.49, 3*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/nelem*0.2/
*
*     Fe rates from Woods et al. Ap.J. 249, 399.
*     rec from +23, 24 25 from Arnauld et al 85
      data rec,pl
     1/ 5.2E-10 , 2.40E-9 , 3.20E-9 , 4.17E-9 , 9.44E-9 , 2.14E-8
     2, 4.48E-8 , 8.75E-8 , 1.41E-7 , 2.26E-7 , 2.73E-7 , 3.56E-7
     3, 4.42E-7 , 5.52E-7 , 7.00E-7 , 8.59E-7 , 8.55E-7 , 8.93E-7
     4, 9.64E-7 , 1.06E-6 , 1.19E-6 , 1.22E-6 , 2.94E-6 ,
     1  -0.891  , -0.843  , -0.746  , -0.682  , -0.699  , -0.728
     2, -0.759  , -0.790  , -0.810  , -0.829  , -0.828  , -0.834
     3, -0.836  , -0.840  , -0.846  , -0.850  , -0.836  , -0.824
     4, -0.816  , -0.811  , -0.808  , -0.800  , -0.852  /
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.28e-10 , -0.686 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.58E-3  , 8.38E-3  , 1.54E-2, 3.75E-2, 0.117   , 0.254
     2, 0.291   , 0.150   , 0.140   , 0.100   , 0.200   , 0.240
     3, 0.260   , 0.190   , 0.120   , 0.350   , 0.066   , 0.10
     4, 0.13    , 0.23    , 0.14    , 0.11    , 0.041
     5, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/ .456    , .323    , .310    , .411    , .359    , .0975
     1, .229    , 4.20    , 3.30    , 5.30    , 1.50    , 0.700
     1, .600    , .5      , 1.      , 0.      , 7.8     , 6.3
     1, 5.5     , 3.6     , 4.9     , 1.6     , 4.2
     1, 0./
      data (dite(i,1),i=1,ndim-1)
     1/ 6.00E4  , 1.94E5  , 3.31E5  , 4.32E5  , 6.28E5  , 7.50E5
     2, 7.73E5  , 2.62E5  , 2.50E5  , 2.57E5  , 2.84E5  , 8.69E5
     3, 4.21E5  , 4.57E5  , 2.85E5  , 8.18E5  , 1.51E6  , 1.30E6
     4, 1.19E6  , 1.09E6  , 9.62E5  , 7.23E5  , 4.23E5
     5, 0./
      data (dite(i,2),i=1,ndim-1)
     1/8.97E4   , 1.71E5  , 2.73E5  , 3.49E5  , 5.29E5  , 4.69E5
     2,6.54E5   , 1.32E6  , 1.33E6  , 1.41E6  , 1.52E6  , 1.51E6
     3,1.82E6   , 1.84E6  , 2.31E6  , 0.      , 9.98E6  , 9.98E6
     4,1.00E7   , 1.10E7  , 8.34E6  , 1.01E7  , 1.07E7
     5 , 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4
     5, 1E20    /
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
*
      IF( .NOT.lgElmtOn(nelem) ) THEN
        RETURN
      ENDIF
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine cloudy
      implicit none
*the main routine, this IS Cloudy
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgNoExec
*flag saying no to compute model, just generate continuum and stop
*set with cdNoex call
      common/noexec/ lgNoExec
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
*
*     local variables
      logical lgEndFun , lgOK
*
*     this is the main routine to drive the modules that compute a model
*     when cloudy is used as a stand-alone program
*     the main program (PROGRAM MAIN) calls CDINIT then CDDRIV
*     this sub is called by CDDRIV which returns upon exiting
*
*     this routine uses the following variables:
*
*     NZONE
*     this is the zone number, and is incremented here
*     logical function lgEndFun returns a true condition if NZONE reaches
*     NEND(ITER), the limit to the number of zones in this iteration
*     NZONE is totally controlled in this subroutine
*
*     ITER
*     this is the iteration number, it is 1 for the first iteration
*     and is incremented in this subroutine at the end of each iteration
*
*     itermx
*     this is the limiit to the number of iterations, and is entered
*     by the user
*     This routine returns when ITER > ITERMX
*
*     zero out some variables that can't be in big block
      call zero
*     NZONE is zero while initial search for conditions takes place
      nzone = 0
*     interpret input data
      call readr
*     ITER is iteration number
      iter = 1
*     fix pointers to ionization edges and frequency array
*     this routine has internal check for whether ever called before,
*     if only retuns if this is a later call of code
      call SetPoint
*     fix abundances of elements
      call abnset
*     find normalization factors for the continua
      call conorm
*     set continuum
      call SetCon( lgOK )
*     print header
      call prhead
*     this is an option to stop after printing header only
      if( lgNoExec ) return
      if( .not.lgOK ) then
        call BadStart
        return
      endif
*     set upper and lower stages of ionization of heavies
      call nsset
*     guess some outward optical depths
      call tauout
      call opac0
      call tfirst( lgOK )
*     punt if initial conditions outside range of code
      if( .not.lgOK ) then
        call BadStart
        return
      endif
      call FirstDR
      call NextDR
      call zonsrt('init')
      call plot('FIRST')
*     will not trip on following test - will return in mid-loop
      do while( iter.le. itermx+10 )
        call startr
        nzone = 0
*       main loop to drive model
*     >>chng 97 june 9, get rid of go to, move lgEndFun to start
        do while( .not.lgEndFun() )
*7      continue
*     >>chng 97 june 9, zone increment at start not bottom
          nzone = nzone + 1
*         set variable dealing with new radius
          call zonsrt('incr')
*         do pressure-temperature-ionization balance
          call PIonte
*         evaluate total opacity, it was also done in ionize, called by PIonte
*     >>chng 97 may 6, ok checks that opacity scale is ok, not underflow to 0
          call AddOpac( lgOK )
          if( .not. lgOK ) then
            call prstep
            goto1
          endif
*         use changes in opacity, temperature, ionization, to fix new dr
          call NextDR
*         find diffuse emission from this zone
          call diffem
*         do work associated with incrementing this radius
          call radinc
*         diffuse fields of heavy elements, outward beams
          call metdif
*         fill in emission line array
          call lines
*         increment optical depths
          call TauInc
*         possibly punch out some results from this zone
          call DoPunch( 'MIDL' )
*         call print-step, update dr, and check on end conditions
*     >>chng 97 june 9, got rid of go to
*         if( lgEndFun() ) go to1
*         nzone = nzone + 1
*         do some things to finish out this zone
          call zondun
*       go to7
        end do
*
*       model complete
 1      continue
*       print out some comments, generate w, c that DoPunch may need
        call comment
*       punch stuff only needed on last shot
        call DoPunch( 'LAST' )
        call plot('SECND')
*       print out the results
        call final
        if( iter .gt. itermx ) return
*       update limiting optical depth variables
        call update
        iter = iter + 1
*       reinitialize some variables which may have changed
        nzone = 0
        call reset
        call zonsrt('init')
        call tfirst( lgOK )
*       punt if gas totally cold and molecular
        if( .not.lgOK ) return
      end do
      end
******************************************************************************
      subroutine BadStart
      implicit none
*announce that things are so bad the calculation cannot even start
      character chRgcln*132
*     a comment about the geometry after model stops
      common/rgcom/ chRgcln(2)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
*
*     local variables
      character chLine*80
*     initialize the line saver
      call wcnint
      write(chRgcln(1),'(''   Calculation stopped because initial'',
     1 '' conditions out of bounds.'')')
      write(chLine,'('' W-Calculation could not begin.'')')
      call warnin( chLine )
      lgBusted = .true.
      end
******************************************************************************
      subroutine clrine
      implicit none
*ionization balance for chlorine
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      real hi , hii
      common/h/ hi , hii
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=18)
      parameter (nelem=17)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(17)  , yYIELD(15) , yYIELDL(7)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/17*0.2/ , yYIELD/15*0./ , yYIELDL/7*0./
*
*     chlorine nelem=17
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
*     these are for argon, but no better can be done today
      data (cion(i,1),i=1,ndim-1)
     1 /1.20E-10,3.50E-11,3.80E-11,6.47E-12,1.72E-12,
     1 2.20E-12,6.95E-13,7.57E-13,4.75E-13,3.45E-13,2.48E-13,1.57E-13,
     2 9.10E-14,6.05E-14,2.62E-14,2.60E-15,1.13E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /1.83E5,3.21E5,4.75E5,6.94E5,8.70E5,1.06E6,1.44E6,1.66E6,4.90E6,
     2 5.56E6,6.25E6,7.17E6,7.96E6,8.77E6,9.92E6,1.07E7,4.78E7/
*
*     fits to Aldrovandi and Pequignot Rev Bras Fisica 4, 491
      data rec / 4.81e-10, 1.08e-09, 2.39e-09, 4.33e-09, 6.59e-09,
     1 1.04E-08, 1.63E-08, 1.82E-08, 2.27E-08, 2.67E-08, 3.17E-08,
     2 3.73E-08, 4.42E-08, 5.24E-08, 5.95E-08, 6.43E-08/
      data pl / -0.702, -0.697, -0.678, -0.669, -0.659,
     1 -0.681, -0.711, -0.670, -0.668, -0.646, -0.640,
     2 -0.629, -0.631, -0.647, -0.641, -0.616/
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1 / 5.5E-5, 1.0E-2,1.1E-2, 1.0E-2, 5.0E-2, 3.2E-2,
     1 3.4E-2, 1.6E-2, 2.4E-2, 4.0E-2, 4.0E-2, 3.8E-2, 6.8E-2, 2.6E-2,
     2 4.6E-1, 11.,0./
      data (dite(i,1),i=1,ndim-1)
     1 /1.3E5, 1.4E5, 1.4E5, 1.4E5, 2.0E5, 1.8E5, 2.3E5,
     1 7.2E5, 6.4E5, 6.0E5, 4.9E5, 4.6E5, 5.3E5, 3.2E5, 2.6E7, 2.8E7,0./
      data ditcrt
     3/3.0E4  , 2.5E4  , 2.5E4  , 1.8E4  , 1.8E4  , 2.2E4
     3,5.0E5  , 1.6E5  , 1.5E5  , 1.5E5  , 1.3E5  , 1.3E5  , 1.1E5
     3,7.6E4  , 6.5E6  , 1.4E7  , 1E20  /
      data (dicoef(i,2),i=1,ndim-1)/nelem*0./
      data (dite(i,2),i=1,ndim-1)/nelem*0./
*
      data aa/17*0./,bb/17*0./,cc/17*0./,dd/17*0./,ff/17*0./
*
*     clorine, atomic number 17
      IF( .NOT.lgElmtOn(17) ) THEN
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     charge transfer, rate from Pradhan and Dalarno Phys Rev A 49, 960 1994
*     Cl+ + H0 => H+ + Clo,
*     R = 6.85E-13 *TE70*TE10/TE01*SEXP(6920./TE)
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(1,2) = CTHeavy(1,2) + HI*R
*     R = 1.45E-12 *TE70*TE03*SEXP(232./TE)
*     CTHeavy(1,1) = CTHeavy(1,1) + HII*R
*     Cl+2 + Ho => Cl+1 + H+
*     CTHeavy(2,2) = CTHeavy(2,2) + HI*1.E-14
*     Cl+3 + Ho => Cl+2 + H+
*     CTHeavy(3,2) = CTHeavy(3,2) + HI*1.5E-9
*
      if( itime .eq. -1 ) then
        call theavy( nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine cmshft
      implicit none
*compute effects of comptonization
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      double precision comup, comdn
      common/comexc/ comup(ncell) , comdn(ncell)
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
*
*     local variables
      integer i
*
*     first check whether compton scattering is in as heat/cool
      if( comoff.eq.0. ) return
      if( comoff.ne.0. ) return
*
*     do reshuffle
      do i=1,nflux
*       watch this space for some really great code!!!!
*       COMUP needs factor of TE to be compton cooling
      end do
*
      end
******************************************************************************
      subroutine cobalt
      implicit none
*do ionization balance for cobalt
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=28)
      parameter (nelem=27)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real GRDEFF(27)
*
*     cobalt nelem=27
*
*     real CollidRate(nelem,2)
*
*     REAL yYIELD(25) , yYIELDL(17)
*     DATA yYIELD/25*0./ , yYIELDL/17*0./
*     rates for ni from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1  /6.38E-10,1.51E-10,5.43E-11,2.46E-11,1.00E-11,
     1 5.29E-11,2.67E-12,1.26E-12,4.66E-13,1.36E-12,9.44E-13,6.35E-13,
     2 3.80E-13,2.17E-13,5.74E-14,1.03E-13,3.88E-14,5.65E-14,4.02E-14,
     3 3.25E-14,2.65E-14,1.83E-14,1.15E-15,8.39E-15,3.84E-15,4.21E-16,
     4 1.91E-16/
      data (cion(i,2),i=1,ndim-1)
     1 /2.11E5,4.08E5,6.37E5,8.76E5,1.25E6,1.54E6,1.88E6,2.24E6,
     2 2.60E6,3.73E6,4.09E6,4.46E6,4.99E6,5.39E6,5.79E6,6.63E6,
     3 7.04E6,1.80E7,1.91E7,2.04E7,2.20E7,2.33E7,2.47E7,2.66E7,2.78E7,
     4 1.19E8,1.25E8/
*
*     DATA FYIELD/1*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47,2*.48,2*.49, .11,.75,5*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*     they are correct for iron, not ni
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/27*0.2/
*
*     all rates from Shull and Van Steenberg apj sup 48, 95. for Ni
*     assumed to have same cs per stage of ionization
      data rec/2.27e-10, 6.31e-10, 8.83e-10, 1.01e-09, 3.71e-09,
     1         4.84E-09, 1.09E-08, 2.48E-08, 9.68E-08, 1.72E-07,
     2         2.61E-07, 3.95E-07, 4.70E-07, 5.70E-07, 6.98E-07,
     3         8.32E-07, 9.76E-07, 1.19E-06, 1.16E-06, 1.14E-06,
     4         1.17E-06, 1.24E-06, 1.35E-06, 1.38E-06, 6.64E-07,
     5         4.67E-07/
      data pl/ -0.7, -0.7, -0.7, -0.7, -0.746, -0.682, -0.699, -0.728,
     1 -0.759, -0.79, -0.81, -0.829, -0.828, -0.834, -0.836, -0.84,
     2 -0.846, -0.85, -0.836, -0.824, -0.816, -0.811, -0.808, -0.8,
     3 -0.718, -0.677/
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.81e-10 , -0.681 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 5.2E-3  , 1.38E-3 , 2.3E-2  , 4.19E-2 , 6.83E-2
     2, 0.122   , 0.30    , 0.15    , 0.697   , 0.709   , 0.644
     3, 0.525   , 0.446   , 0.363   , 0.302   , 0.102   , 0.270
     4, 0.0467  , 0.0835  , 0.0996  , 0.199   , 0.240   , 0.115
     5, 0.0316   , 0.803  , 0.575   ,  0.  /
      data (dite(i,1),i=1,ndim-1)
     1/ 2.01E5  , 3.05E5  , 4.20E5  , 5.56E5  , 6.72E5
     2, 7.93E5  , 9.00E5  , 1.00E6  , 7.81E5  , 7.64E5  , 7.44E5
     3, 6.65E5  , 5.97E5  , 5.24E5  , 4.96E5  , 4.46E5  , 8.49E6
     4, 1.36E6  , 1.23E6  , 1.06E6  , 1.25E6  , 1.23E6  , 3.32E5
     5, 6.45E5  , 6.65E7 , 6.81E7 , 0./
      data ditcrt
     1/ 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4     , 6E6
     5, 6E6     , 1E20    , 1E20 , 1E20 /
      data (dicoef(i,2),i=1,ndim-1)/nelem*0./
      data (dite(i,2),i=1,ndim-1)/nelem*0./
      data aa/27*0./,bb/27*0./,cc/27*0./,dd/27*0./,ff/27*0./
*
*     free statement numbers >= 7
*
*     cobalt, atomic number 27
      if( .not.lgElmtOn(27) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine coladd( chLabel , lambda , cool )
      implicit none
*add coolants to the cooling stack, called in evaluation of cooling function
      real cool
      character chLabel*4
      integer lambda
*
      integer ncolnt
      parameter (ncolnt=10 000)
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      ncltot = ncltot + 1
      if( ncltot.gt.ncolnt ) then
        write(qq,'('' Too many coolants added with COLADD,'',
     1  '' the limit is'',I5,''.'')') ncolnt
        write(qq,'('' Increase ncolnt in the parameter statements.'')')
        stop
      endif
*
      chClntLab(ncltot) = chLabel
      collam(ncltot) = lambda
*     normal line cooling
      cooling(ncltot) = max( 0., cool )
*     possible line heating - not supposed to be done this way!
*     this is intrinsic positive number, to be added to heating
      heatnt(ncltot) = max( 0., -cool )
*
      end
******************************************************************************
      subroutine CollidIonize( nelem , cion )
      implicit none
*fill in collisional ionization rates, and resulting cooling
      integer nelem
      real cion(nelem,2)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      real CollidRate(limelm, limelm, 2)
* collisional ionization rate for CollidRate(nelem,ion,1), s-1
* cooling, erg/s in (nelem,ion,2)
      common/CollIonRate/ CollidRate
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      logical lgInsane
      real crate , DimaRate
*
*     compute collisional ionization rate
*
*     CollidRate(nelem,ion , 1) is collisional ionization rate, s-1
*     CollidRate(nelem,ion , 2) is collisional ionization cooling, erg/s
*
      do i=1,IonLow(nelem)-1
        CollidRate(nelem,i,1) = 0.
        CollidRate(nelem,i,2) = 0.
      end do
*
      do i=IonLow(nelem),IonHigh(nelem)-1
*       real sexp
*       collisional ionization by thermal electrons
*       crate = cion(i,1)/(1.+0.1*te/cion(i,2)) * sqrte * eden*
*    1  sexp(cion(i,2)/te)
*       call Dima's master set of fits
*       call colfit( nelem , nelem-i+1,0,te,DimaRate )
*     >>chng 97 mar 19, to Dima's new routine using Voronov '97, ADNDT 65, 1
*error 666 this returns 0 for nelem=29, 30
        call cfit( nelem , nelem-i+1,te,DimaRate )
        crate = DimaRate * eden
*       write(6,'(2i3,1p,2e10.2)') nelem,i,DimaRate,csupra
        CollidRate(nelem,i,1) = crate + csupra
*       cooling due to collisional ionization
        CollidRate(nelem,i,2) = crate * cion(i,2)*Boltzmann
      end do
*
      do i=IonHigh(nelem),nelem
        CollidRate(nelem,i,1) = 0.
        CollidRate(nelem,i,2) = 0.
      end do
*
*begin sanity check
      lgInsane = .false.
      do i=1,nelem
*       there can be no negative rates
        if( CollidRate(nelem,i,1).lt.0. ) then
          write(qq,'('' CollidIonize finds insane coll ionize rate'',
     1    1p,e10.2,'' nelem, ion='',2i3,'' csupra='',e10.2,'' te='',
     2    e12.4)') CollidRate(nelem,i,1),nelem,i,csupra,te
          lgInsane = .true.
        endif
      end do
      if( lgInsane ) then
        write(qq,'('' Insanity has occurred.'')')
        call ShowMe
        stop
      endif
*end sanity check
*
      end
******************************************************************************
      subroutine colred( chCard )
      implicit none
*read observed column densities & errors for optimizer
      character*80 chCard
*
      integer ncollm
      parameter (ncollm=100)
      real amcol,amcerr
      integer ionam,ncobs
      common/obscol/ amcol(ncollm),amcerr(ncollm),ionam(ncollm),ncobs
      character chColmnLab*4
*     labels for column densities on vary command
      common/colab/ chColmnLab(ncollm)
      logical lgTrOpt
*lgTrOpt flag set with optimization trace command
*nTrOpt is which call to cloudy to turn on trace
      integer nTrOpt
      common/tropt/ nTrOpt , lgTrOpt
*     include "troptm.com"
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer  i , j
      real fread
      real deferr
      parameter (deferr=0.05)
      character*80  chCap , chVlt*1
      logical lgEOF , lgEOL
*
*     read observed column densities & errors
*
      ncobs = 0
*
*     get first line
      call readar( chCard , lgEOF )
      chCap = chCard
      call caps( chCap )
      if( lgEOF ) then
        write(qq,'('' Hit EOF while reading column density list; use ''
     1  ,''END to end list.'')')
        stop
      endif
*
      do while( .not.lgEOF )
        ncobs = ncobs + 1
        if( ncobs.gt.ncollm ) then
          write(qq,'('' Too many column densities have been entered; '',
     1    ''the limit is'',i4,''.  Increase variable NCOLLM.'')') ncollm
          stop
        endif
*
*       order on line is label (col 1-4), ionization stage, column density, err
        call cap4( chCard(1:4) , chColmnLab(ncobs) )
        i = 5
        ionam(ncobs) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'(1X,A80)') chCard
          write(qq,'('' The ionization stage MUST appear on this line.''
     1    ,''  Sorry.'')')
          stop
        else if( ionam(ncobs) .le.0 ) then
          write(qq,'(1X,A80)') chCard
          write(qq,'('' An ionization stage of'',I4,'' does not make '',
     1    ''sense.  Sorry.'')') ionam(ncobs)
          stop
        endif
*
        amcol(ncobs) = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'(1X,A80)') chCard
          write(qq,'('' An observed column density MUST be entered.  '',
     1    ''Sorry.'')')
          stop
        endif
*
        amcerr(ncobs) = fread( chCard , i , 76 , lgEOL )
        if(amcerr(ncobs).le.0.0 ) then
*         this is the relative error allowed
          amcerr(ncobs) = deferr
        endif
*
*       check if number is a limit
        chVlt=' '
        do j=1,80
          if(chCard(j:j).EQ.'<') then
*           limit value assumed
            chVlt='<'
          endif
        end do
*
        if(chVlt.EQ.'<') then
*         value is an upper limit only, use negative error to flag
          amcerr(ncobs) = -amcerr(ncobs)
        endif
*
        call readar( chCard , lgEOF )
        chCap = chCard
        call caps( chCap )
        if( lgEOF ) then
          write(qq,'('' Hit EOF while reading column density list; use''
     1    ,'' END to end list.'')')
          stop
        endif
        if( chCap(1:3).eq.'END' ) lgEOF = .true.
      end do
*
      if(lgTrace.and.lgTrOpt ) then
        write(qq,'(i4,'' colunms were entered, they were;'')') ncobs
        do i=1,ncobs
          write(qq,'(1X,A4,'' ion='',i5,1P,2E10.2)') chColmnLab(i),
     1    ionam(i),amcol(i),amcerr(i)
        end do
      endif
*
      end
******************************************************************************
      subroutine colzro
      implicit none
*set cooling and heating stack to zero
      integer ncolnt
      parameter (ncolnt=10 000)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*
      integer i
*
      ncltot = 0
      dCooldT = 0.
*
      do i=1,ncolnt
        cooling(i) = 0.
        heatnt(i) = 0.
      end do
*
      end
******************************************************************************
      subroutine comment
      implicit none
*analyze model, generating comments on its features
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer nfst
      parameter (nfst=39)
      integer ndfst
      parameter (ndfst=5)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real pi
      parameter ( pi=3.141592654 )
      real solarm
*     solar mass in grams
      parameter (solarm=1.9892e33)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nfudgc
      parameter (nfudgc=10)
      integer nzlim
      parameter (nzlim=2000)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      integer nFe2Neg
*clount how many times FeII came back with negative level pops
      common/Fe2Neg/ nFe2Neg
      real xLaMase
*smallest Lya optical depth that occured in the calculation
      common/LaMase/ xLaMase
*     TexcLya is the excitation temperature of Lya
*     nLyaHot is counts how ofter Lya hotter than gas
*     TLyaMax is hottest
*     TeLyaMax is electron temp at point where Lya max
*     nZTLaMax is the zone where this happened
      real TexcLya , TLyaMax , TeLyaMax
      integer nLyaHot , nZTLaMax
      common/LyaExT/ TexcLya , nLyaHot , TLyaMax , TeLyaMax , nZTLaMax
      logical lgZonLimOK
*flag saying that too many zones to store in nzlim
      common/nzlmok/ lgZonLimOK
      logical lgInsane
*     flag to say whether insanity detected
      common/insanity/ lgInsane
*     this says whether temp or C-H deriv is changing sign
      logical lgCmHOsc , lgTOscl
*     this is deriv of cooling minus heating wft temp
      double precision dCoolmHeatdT
      common/dCmHdT/ dCoolmHeatdT , lgCmHOsc , lgTOscl
      real Depletion , depset
*     Depletion is set of stored scale factors for depletion of general ism
*     depset is unity unless depletion is used
*     lgDepln is true if depln used
      logical lgDepln
      common/deplon/ Depletion(limelm) , depset(limelm) , lgDepln
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      real BigEdenError
      integer ipEdenError
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      common/EdError/ BigEdenError , ipEdenError
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
*     indicate whether plasma freq ever entered energy array
      logical lgPlasNu
*     this is the plasma frequency
      real plsfrq
*     this is the continuum pointer to the plasma frequency, and largest it ever
      integer ipPlasma, ipPlasmax
      common/plasnu/ lgPlasNu , plsfrq , ipPlasma, ipPlasmax
      logical lgHionRad
      common/HionRad/ lgHionRad
      logical lgTestIt , lgTestOn
*flag lgTestIt turned on if routine TestCode ever called, only generates
*comment that test code is in place
*flag lgTestOn set true for some test code to be run somewhere
      common/Testit/ lgTestIt , lgTestOn
      logical lgOpacNeg
*flag set if negative opacities occured
      common/opcneg/ lgOpacNeg
      logical lgEdenBad
      integer nzEdenBad
*some flags and counters set in radinc when bad electron density is detected
      common/ednbad/ lgEdenBad , nzEdenBad
      real Ca2RmLya
*amount of Lya removed by photoionization of excited CaII levels
      common/ca2mly/ Ca2RmLya
      logical lgBroke
*logical flag saying that the code is broken
      common/broke/ lgBroke
      logical lgdR2Small
*set true if zone thickness became too small
      common/dr2sml/ lgdR2Small
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
*flag saying that calculation stopped for bad reason
*mostly set in endfun
      logical lgBadStop
      common/badstp/ lgBadStop
      real totlum , totlsv
      common/totlum/ totlum , totlsv
      real turhet,turrad
      common/turhet/ turhet,turrad
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
      real CarMolFrac
*largest fraction of carbon that went molecular
      common/cmfrac/ CarMolFrac
      real rjnmin , ajmmin
      common/jmin/ rjnmin , ajmmin
      logical lgZoneSet , lgZoneTrp
*lgZonSet set if stopping zone specified
*lgZoneTrp set if stopped due to zone number
      common/zonset/ lgZoneSet , lgZoneTrp
      real CaseBCheck
*largest difference between actual rec sum and real case B
      common/difher/ CaseBCheck
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      real plow , phi
*     keep trace of lowest and highest pressures in model
      common/prslim/ plow , phi
      real TotalDustHeat , dphmax , h2pmax , dclmax
*TotalDustHeat is total heating due to grain heating over model
      common/dphoht/ TotalDustHeat , dphmax , h2pmax , dclmax
      real CODissHeat , codfrc , codtot
*CODissHeat is CO Photodissociation heating
      common/codish/ CODissHeat , codfrc , codtot
      real HeatH2Dish , h2dfrc , h2dtot
*HeatH2Dish is heating due to H2 dissociation
      common/h2dish/ HeatH2Dish , h2dfrc , h2dtot
      logical lgCon0
*flag saying that parts of continuum are zero
      common/con0/ lgCon0
      integer negoi
      common/negoi/ negoi
      logical lgAbnSolar
      common/abnslr/ lgAbnSolar
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      logical lgComNeg
*flag saying some molecular abundances were negative
      common/comneg/ lgComNeg
      logical lgStatic
*flag saying that spherical geometry is static, set with sphere static
      common/static/ lgStatic
      logical lgNegGrnDrg
*flag set if negative grin drag force encountered
      common/negdrg/ lgNegGrnDrg
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real occmax , occmnu , tbrmax , tbrmnu , tbr4nu , occ1nu
      common/occmax/ occmax , occmnu , tbrmax , tbrmnu , tbr4nu ,
     1 occ1nu
      real BiggestH2
*max H2/H ratio that occured in the calculation, set in hmole
      common/h2max/ BiggestH2
      integer kapots , kap911
      common/kapots/ kapots , kap911
      real OTSCap
*largest allowed ratio of line ots to total photo rate,
*set to 1.5 in scalar
      common/capots/ OTSCap
      integer nUnstable
      logical lgUnstable
*keep track of possibly thermall unstagle models
*nUnstable is number of zones that were possibly thermall unstable
*lgUnstable is set in ionte and says that current consitions possibly unstable
      common/nustbl/ nUnstable , lgUnstable
      real resmax
      common/resmax/ resmax
      real tgrmax
      common/tgrmax/ tgrmax(ndust)
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hlmax
*     remember max photo rate for var h levels, by h lines
      common/hlmax/ hlmax(lmhlvl)
      real tcmptn , ttherm
      common/timesc/ tcmptn , ttherm
      real TEnerDen
*energy density temperature
      common/tenden/ TEnerDen
      real reftot,avhden,chii, avdust , avdpot , thtot
      common/toiii/ reftot,avhden,chii,
     1 avdust(ndust) , avdpot(ndust) , thtot
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real stimax
      common/stimax/ stimax(2)
      real cryden , crpowr , crtemp , hxtot
      common/hextra/ cryden , crpowr , crtemp , hxtot
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      real TimeErode
*timescale for photoerosion of iron due to gamma rays
      common/terode/ TimeErode
      real bignum , smlnum
      common/number/ bignum , smlnum
      real thist , tlowst
      common/tehigh/ thist , tlowst
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      integer ilt,iltln, ilthn, ihthn, ifail
      common/dalerr/ilt, iltln, ilthn, ihthn, ifail
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      real the1lo
      integer nhe1lo
      common/the1lo/ the1lo , nhe1lo
      real the2lo
      integer nhe2lo
      common/the2lo/ the2lo , nhe2lo
      integer ifailz
      common/failz/ ifailz(12)
      real failmx
*     info related to the number of temperature or pressure failures
*     failmx is largest relative error in heating cooling match
*     nPreFail is number of pressure failuers
      integer nfail , nPreFail
      common/nfail/ nfail , failmx , nPreFail
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real telec , thmin
      common/taucon/ telec , thmin
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      logical lgDrMinUsed
*set true is calculations stops because zone thickness gets too small
      common/drminu/ lgDrMinUsed
      integer iprdmx
      common/iprdmx/ iprdmx
      logical lgPradCap , lgPradDen
*lgPradCap true if radiation pressure capped on first iteration
*lgPradDen capped by thermalization length
      common/prdcap/ lgPradCap , lgPradDen
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      real fudgea
      integer nfudge
      common/fudgec/ fudgea(nfudgc) , nfudge
      logical lgHLyaMased
*flag saying that Lya mased
      common/lyamas/ lgHLyaMased
      logical lgPresHeLya
*flag set to turn on HeII Lya, set with helium radiation pressure command
      common/phela/ lgPresHeLya
      logical lgHeMase
*flag set true in addopac if any helium continua mased
      common/hemase/ lgHeMase
      logical lgLastIt
*     this is false on any but the last iteration
*     set true in startr if iter > itermx
      common/lastit/ lgLastIt
      logical lgEdnGTcm
*flag set if energy density of rad field greater tha
*compton temp - this is unphysical but could be set
*by users
      common/edgtcm/ lgEdnGTcm
      logical lgPhysOK
*flag set if a physical condition has been disabled
      common/physok/ lgPhysOK
      logical lgOcc1Hi
*flag saying that occupation number at 1 ryd > 1
      common/occ1hi/ lgOcc1Hi
      logical lgComUndr
*set true if compton cooling underflows
      common/comund/ lgComUndr
      logical lgHiPop2
      real pop2mx
*lgHiPop2 flag set if H n=2 population gets large relative to ground
*pop2mx is maximum population of n=2 relative to ground
      common/hipop2/ lgHiPop2 , pop2mx
      logical lgMMok , lgHPhtOK , lgXRayOK , lgGamrOK
      common/bndsok/ lgMMok , lgHPhtOK , lgXRayOK , lgGamrOK
      real FracInd , fbul
*remember induced fractions for hydrogen
      integer ndclev , nbul
      common/frcind/ FracInd , ndclev , fbul , nbul
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgHabing
*flag set if incident radiation field less than
*10x the Habing ISM field
      common/habing/ lgHabing
      character chDstLab*10
*     labels for types of dust grains
      common/dstlab/ chDstLab(ndust)
      character chReason*21
      common/reason/ chReason
      logical lgWarngs , lgCautns
*flags set if warnings or cautions present
      common/warngs/ lgWarngs , lgCautns
      logical lgIterAgain
*flag saying that another iteration is needed
      common/itagan/ lgIterAgain
      real CycloCoolCoef
*coefficient scaled from magnetic field used for
*Cyclotron cooling
      common/cyclot/ CycloCoolCoef
      real he3pht , he3lya , he3local , he3relax
*     he3relax is fraction of 23s populations that go to singlets
      common/he3pht/ he3pht , he3lya , he3local , he3relax
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      logical lgWindOK
*flag set if wind not ok, (below sonic point)
      common/windok/ lgWindOK
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      logical lgGeoPP
*true if geometry is plane parallel, set in comment
      common/GeoPP/ lgGeoPP
      character chRgcln*132
*     a comment about the geometry after model stops
      common/rgcom/ chRgcln(2)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgH2Ozer
*flag set true if H2O destruction rate went to zero
      common/h2ozer/ lgH2Ozer
      real ColDenSav
*save column densities from iteration to iteration, to check whether
*it changed by too much (a bad sign)
      common/ColDnSav/ ColDenSav(itrdim)
      real sublimat
      common/sublimat/ sublimat(ndust)
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      logical lgCSetOn
*lgCSetOn set with set csupra command
*SetCsupra is secondary ionization rate set with set csupra
      real SetCsupra
      common/cspset/ SetCsupra , lgCSetOn
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
*     these save structure variables, like te vs depth
      real testr, volstr, radstr, histr, hiistr , ednstr,o3str,heatstr,
     1 pdenstr
      common/struc/ testr(nzlim), volstr(nzlim), radstr(nzlim),
     1 histr(nzlim), hiistr(nzlim) , ednstr(nzlim),o3str(nzlim),
     2 heatstr(nzlim),pdenstr(nzlim)
      real xMax2Pht
      common/Max2Pht/ xMax2Pht
      real heatlmax
      integer levlmax , ipHeatlmax
      common/heatlmax/ heatlmax , levlmax , ipHeatlmax
      real GBarMax
      integer ipMaxExtra
*value of, and pointer to, strongest g-bar cooling line
      common/ExtraMax/ GBarMax , ipMaxExtra
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      real TAddHLya,TAddHeI,TAddHeII
      common/TAddLya/ TAddHLya,TAddHeI,TAddHeII
      logical lgPrnErr
      integer ioPrnErr
      common/PrnErr/ lgPrnErr , ioPrnErr
      real EdenError
*     this is relative error in the electron density we want
*     set in block data to 0.01
*     reset with set EdenError command
      common/erredn/ EdenError
      real DoubleTau
*1 or two, set to double optical depth scale, set to 2 with double command
*default is 1
      common/double/ DoubleTau
      real TurbVel
*this is the turbulent velocity in cm/s, normally zero, set with
*turbulence command
      common/turb/ TurbVel
      real CoolHeatMax
      character*4 chCoolHeatMax
*     max of negative coolants, and a pointer to it
      integer ipCoolHeatMax
      common/CHMax/ CoolHeatMax , ipCoolHeatMax , chCoolHeatMax
      integer ipmgex ,ipOpMgEx
      real xmglst, popmg2 , rmg2l , xMg2Max
*     these all deal with photoionization from upper lev of Mg II 2798
      common/mgexc/ ipmgex , xmglst, popmg2 , rmg2l , xMg2Max,ipOpMgEx
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      integer nBetaVer
*     normally zero, non-zero if this is a beta test version
      common/BetaVer/ nBetaVer
      character chNotConverged*10
*     this gives the reason the model was declaired not converged
*     when 'iter to convergence' command is given
      common/NoConverge/ chNotConverged
      logical lgAutoIt
      real autocv
      common/autoit/ lgAutoIt , autocv
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     local variables
      logical lgHe1thk,lgHe2thk
      logical lgOK
      character chLine*132  , chLbl*10 , chLineLbl*10, chGetLbl*10
      logical lgMaser , lgThick , lgFFimp
      real rel , outtot , outin,outout, reclin,totlin,t4363 , SumNeg
      real small,tauneg,aj,comfrc,ts,rate,relhm,flur,HBeta,relfl,alpha
      real big,bigm,differ,fedest,collin,absint,c4363,ratio
      real totwid , error , freqn , BigJump , GetHeat
      integer nd , imas , nneg , nline,nw,nc,nn,ns,i,j,isav
*
*     enter all comments cautions warnings and surprises into a large
*     stack of statements
*     at end of this routine is master call to printing routines
*
      lgIterAgain = .false.
*
*     free statement numbers >=9
*
*     initialize the line saver
      call wcnint
*
      if( nBetaVer.gt.0 ) then
        write(chLine,'(''  !This is beta test version'',i4,
     1  '' and should not be used for publications.'')')nBetaVer
        call bangin( chLine )
      endif
*
*     say why calculation stopped
      if( lgBadStop ) then
*       this case stop probably was not intended
        write(chRgcln(1),'('' W-Calculation stopped because '',A21,
     1  '' Iteration'',i3,'' of'',i3)') chReason,iter,itermx+1
        write(chLine,'('' W-Calculation stopped because '',A21)')
     1  chReason
        call warnin( chLine )
        write(chLine,'('' W-This was not intended.'')')
        call warnin( chLine )
      else
        if( lgAutoIt .and. iter.ne.itermx+1 .and.iter.gt.2 ) then
          write(chRgcln(1),'(''   Calculation stopped because '',A21,
     1    '' Iteration'',i3,'' of'',i3,'', not converged due to '',a10)'
     2    )chReason,iter,itermx+1, chNotConverged
        else
          write(chRgcln(1),'(''   Calculation stopped because '',A21,
     1    '' Iteration'',i3,'' of'',i3)')
     2    chReason,iter,itermx+1
        endif
      endif
*
*     check whether stopped because default number of zones hit,
*     not intended??
      if( (.not.lgZoneSet) .and. lgZoneTrp ) then
        lgBadStop = .true.
        write(chLine,'('' W-Calculation stopped because default '',
     1  ''number of zones reached.  Was this intended???'')')
        call warnin( chLine )
        write(chLine,'('' W-Default limit can be increased while'',
     1  '' retaining this check with the SET NEND command.'')')
        call warnin( chLine )
      endif
*
*     check whether stopped because zones too thin - only happens when glob set
*     and depth + dr = depth
*     not intended
      if( lgDrMinUsed .or. lgdR2Small ) then
        lgBadStop = .true.
        write(chLine,'('' W-Calculation stopped zone thickness '',
     1  ''became too thin.   This was not intended.'')')
        call warnin( chLine )
        write(chLine,'('' W-The most likely reason was an '',
     1  ''uncontrolled oscillation.'')')
        call warnin( chLine )
        call ShowMe
      endif
      if( lgdR2Small ) then
        write(chLine,'('' W-This happened because the globule '',
     1  ''scale became very small relative to the depth.'')')
        call warnin( chLine )
        write(chLine,'('' W-This problem is described in Hazy.'')')
        call warnin( chLine )
      endif
*
*     did insanity occur?
      if( lgInsane ) then
        lgBadStop = .true.
        write(chLine,'('' W-Insanity occurred.'')')
        call warnin( chLine )
        call ShowMe
        call warnin( chLine )
      endif
*
*     possible that last zone does not have stored temp - if so
*     then make it up - this happens for some bad stops
      if( testr(nzone).eq.0. ) testr(nzone) = testr(nzone-1)
      if( ednstr(nzone).eq.0. ) ednstr(nzone) = ednstr(nzone-1)
*
*     give indication of geometry
      rel = depth/rinner
      if( rel.lt.0.1 ) then
        write(chRgcln(2),'(''   The geometry is plane-parallel.'')')
        lgGeoPP = .true.
      else if(rel.ge.0.1 .and. rel.lt.3. ) then
        lgGeoPP = .false.
        write(chRgcln(2),'(''   The geometry is a thick shell.'')')
      else
        lgGeoPP = .false.
        write(chRgcln(2),'(''   The geometry is spherical.'')')
      endif
*
*     levels of warnings: Warning   (possibly major problems)
*                         Caution   (not likely to invalidate the results)
*                         [nothing] interesting note
*                         [      !] surprise, but not disaster
*
      if( nfudge.gt.0 ) then
        write(chLine,'('' W-Fudge factors in place.  Why?'')')
        call warnin( chLine )
      endif
*
      if( lgBroke ) then
        write(chLine,'('' W-The code is broken.'')')
        call warnin( chLine )
      endif
*
*     incorrect electron density detected in radinc during the calculation
      if( lgEdenBad ) then
        if( nzEdenBad.eq.nzone ) then
          write(chLine,'('' C-The assumed electron density was'',
     1    '' incorrect for the last zone.'')')
          call caunin( chLine )
          write(chLine,'('' C-Did a temperature discontinuity occur??''
     1    )')
          call caunin( chLine )
        else
          write(chLine,'('' W-The assumed electron density was'',
     1    '' incorrect during the calculation.  This is bad.'')')
          call warnin( chLine )
          call ShowMe
          call warnin( chLine )
        endif
      endif
*
      if( lgBusted ) then
        write(chLine,'('' W-The code returned with BUSTED set.'',
     1  ''  Something REALLY went wrong!'')')
        call warnin( chLine )
      endif
*
      if( hden .gt. 1.1e13 ) then
        if( hden.gt.1e15 ) then
          write(chLine,'('' W-Density greater than 10**15'')')
          call warnin( chLine )
        else
          write(chLine,'('' C-Density greater than 10**13'')')
          call caunin( chLine )
        endif
      endif
*
*     HBeta is used later in the code to check on line intensites
      call cdLine( 'Pump' , 4861 , relfl , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Did not find flur H-beta'')')
      call cdLine( 'totl' , 4861 , HBeta , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Did not find totl H-beta'')')
      if( HBeta.gt.0. ) then
        flur = relfl / HBeta
        if( flur.gt.0.01 ) then
          write(chLine,'(''   Continuum fluorescent production of '',
     1    ''H-beta was significant.'')')
          call notein( chLine )
        endif
      endif
*
*     check if there were problems with initial wind velocity
      if( windv0 .gt. 0. .and.
     1 ( (.not.lgWindOK).or.windv.lt.1e6 )   ) then
        write(chLine,'('' C-Wind velocity below sonic point;'',
     1  '' solution is not valid.'')')
        call caunin( chLine )
      endif
*
*     check that we didn't overrun zone scale
      if( nzone.ge.nzlim ) then
        lgZonLimOK = .false.
        write(chLine,'('' C-Number of zones exceeded NZLIM - '',
     1  '' several structure quantities are not valid.'')')
        call caunin( chLine )
        write(chLine,'('' C-Number of zones exceeded NZLIM - '',
     1  '' The emission line spectrum is ok though.'')')
        call caunin( chLine )
      else
        lgZonLimOK = .true.
      endif
*
*     check whether energy is conserved
*     following is outward continuum
      call outsum( outtot, outin, outout )
*     reclin is the sum of all recombination line energy
      reclin = totlin( 'r' )
      if( reclin.eq.0. ) then
        write(chLine,'(''   totlin(r) returned zero'')')
        call notein( chLine )
      endif
*     collin is the sum of all coolants
      collin = totlin( 'c' )
      if( collin.eq.0. ) then
        write(chLine,'(''   totlin(c) returned zero'')')
        call notein( chLine )
      endif
*
*     TOTLUM is total incident photon luminosity, evaluated in setup
*     POWER is incremented in LINES and is the total heating integrated
*     over the computed volume
*     COLLIN is evaluated here, is sum of all coolants
      if( (collin+reclin).gt.totlum .and. (.not.lgTSetOn) ) then
        if( cryden.eq.0.  .and.turhet.eq.0. .and. .not.lgCSetOn ) then
*
          write(chLine,'('' W-Radiated luminosity (cool+rec='',1P,E8.2
     1    ,''+'',E9.2,'') is greater than that in incident ''
     2    ,''radiation (TOTLUM='',E8.2,'').  Power='',e8.2)')
     3    collin , reclin,totlum , power
          call warnin( chLine )
*         write same thing directly to output (above will be sorted later)
          write(qq,'('' This calculation DID NOT CONSERVE ENERGY!'')')
*         print out the offenders
          call badprt(totlum)
*
          write(chLine,'('' W-Something is really wrong: the ratio of ''
     1    ,''radiated to incident luminosity  is '',1P,E9.2,''.'')')
     2    (collin+reclin) / totlum
          call warnin( chLine )
*
*         this can be caused by the force te command
          if( ForceTemp.gt.0. ) then
            write(qq,'('' This may have been caused by the FORCE '',
     1      ''TE command.'')')
            write(qq,'('' Remove it and run again.'')')
          else
            call ShowMe
          endif
          call warnin( chLine )
        endif
      endif
*
*     warn if cosmic rays and bmag field both present
      if( cryden*CycloCoolCoef.gt.0. ) then
        write(chLine,'('' W-Magnetic field and cosmic rays are both'',
     1  '' present.  This is not correctly treated.'')')
        call warnin( chLine )
      endif
*
*     comment if test code is in place
      if( lgTestIt ) then
        write(chLine,'(''  !Test code is in place.'')')
        call bangin( chLine )
      endif
*
*     lgComUndr set to .true. if compton cooling rate underflows to 0
      if( lgComUndr ) then
        write(chLine,'(''  !Compton cooling rate underflows'',
     1  '' to zero.  Is this important?'')')
        call bangin( chLine )
      endif
*
*     lgHionRad set to .true. if no hydrogen ionizing radiation
      if( lgHionRad ) then
        write(chLine,'(''  !There is no Hydrogen-ionizing'',
     1  '' radiation.  Was this intended?'')')
        call bangin( chLine )
      endif
*
*     check whether certain zones were thermally unstable
      if( nUnstable.gt.0 ) then
        write(chLine,'(''   Derivative of net cooling negative ''
     1  ,''and so possibly thermally unstable in'',I4,'' zones.'')')
     2  nUnstable
        call notein( chLine )
      endif
*
*     did derivative of heating minus cooling every change sign during search
      if( lgCmHOsc ) then
        write(chLine,'(''   Derivative of net cooling oscillated ''
     1  ,''during thermal solution.  Standard fixup taken.'')')
        call notein( chLine )
      endif
*
*     generate a bang if a large fraction of the zones were unstable
      if( nzone.gt.1 .and. float(nUnstable)/float(nzone) .gt.0.25 ) then
        write(chLine,'(''  !A large fraction of the zones were '',
     1  ''possibly thermally unstable,'',i4,'' out of'',i4)')
     2  nUnstable , nzone
        call bangin( chLine )
      endif
*
*     comment if negative coolants were ever significant
      if( CoolHeatMax.gt. 0.2 ) then
        write(chLine,'(''  !Negative cooling reached '',f6.1''% of'',
     1  '' the local heating, due to '',a4,i6)') CoolHeatMax*100.,
     2  chCoolHeatMax,ipCoolHeatMax
        call bangin( chLine )
      else if (CoolHeatMax.gt.0.05 ) then
        write(chLine,'(''   Negative cooling reached '',f6.1''% of'',
     1  '' the local heating, due to '',a4,i6)')CoolHeatMax*100.,
     2   chCoolHeatMax,ipCoolHeatMax
        call notein( chLine )
      endif
*
*     did Lya mase?
      if( xLaMase.lt.0. ) then
        if( xLaMase.lt.-0.01 ) then
          write(chLine,'(''  !H Lya mased!!  Smallest optical depth'',
     1    '' was'',1p,e10.2)') xLaMase
          call bangin( chLine )
        else
          write(chLine,'(''   H Lya mased.  Smallest optical depth'',
     1    '' was'',1p,e10.2)') xLaMase
          call notein( chLine )
        endif
      endif
*
      if( kapots.gt.0 ) then
        write(chLine,'(''   KAPOTS='',I4,'' OTSCap='',1P,
     1  e10.3)') kapots,OTSCap
        call notein( chLine )
      endif
*
      if( kap911.gt.0 ) then
        write(chLine,'(''   KAP911='',I4,'' OTSCap='',1P,
     1  e10.3)') kap911,OTSCap
        call notein( chLine )
      endif
*
*     check whether photo from up level of Mg2 2798 ever important
      if( xMg2Max.gt.0.1 ) then
        write(chLine,'(''  !Photoionization of upper level of Mg II '',
     1  ''2798 reached '' ,F5.1,''% of the total Mg+ photo rate.'')')
     2  xMg2Max*100.
        call bangin( chLine )
      else if( xMg2Max.gt.0.01 ) then
        write(chLine,'(''   Photoionization of upper level of Mg II '',
     1  ''2798 reached '' ,F5.1,''% of the total Mg+ photo rate.'')')
     2  xMg2Max*100.
        call notein( chLine )
      endif
*
*     check whether photo from up level of [OI] 6300 ever important
      if( poimax.gt.0.1 ) then
        write(chLine,'(''  !Photoionization of upper levels of [OI]'',
     1  '' reached '' ,F5.1,''% of the total O destruction rate.'')')
     2  poimax*100.
        call bangin( chLine )
      else if( poimax.gt.0.01 ) then
        write(chLine,'(''   Photoionization of upper levels of [OI]'',
     1  '' reached '' ,F5.1,''% of the total O destruction rate.'')')
     2  poimax*100.
        call notein( chLine )
      endif
*
*     check whether photo from up level of [OIII] 5007 ever important
      if( (poiii2Max+poiii3Max).gt.0.1 ) then
        write(chLine,'(''  !Photoionization of upper levels of [OIII]'',
     1  '' reached '' ,F5.1,''% of the total O++ photo rate.'')')
     2  (poiii2Max+poiii3Max)*100.
        call bangin( chLine )
      else if( (poiii2Max+poiii3Max).gt.0.01 ) then
        write(chLine,'(''   Photoionization of upper levels of [OIII]'',
     1  '' reached '' ,F5.1,''% of the total O++ photo rate.'')')
     2  (poiii2Max+poiii3Max)*100.
        call notein( chLine )
      endif
*
*     check whether resonance line ionization of H n=2 was important
      if( resmax.gt.0.01 ) then
        write(chLine,'(''   FeII-MgII photoionization of H N=2 '',
     1  ''reached'' ,F5.1,'' percent of the total rate out.'')')
     2  resmax*100.
        call notein( chLine )
      endif
*
*     check whether photoionization of He 2trip S was important
      if( he3pht.gt.0.01 ) then
        write(chLine,'(''   Photoionization of He 2TriS reached '',
     1  F5.1,''% of the total rate out,'',F5.1,
     2  ''% of that was Lya.'')') he3pht*100. , he3lya*100.
        call notein( chLine )
      endif
*
*     frequency array may not have been defined for all energies
      if(.not.lgMMok) then
         write(chLine,'('' C-Continuum not defined in extreme'',
     1'' infrared - Compton scat, grain heating, not treated.?'')')
         call caunin( chLine )
      endif
      if(.not.lgHPhtOK) then
        write(chLine,'('' C-Continuum not defined at photon'',
     1  '' energies which ionize excited states of H, important for '',
     2  ''H- and ff heating.'')')
        call caunin( chLine )
      endif
      if(.not.lgXRayOK) then
        write(chLine,'('' C-Continuum not defined at x-ray energies'',
     1  '' - Compton scattering and Auger ionization wrong?'')')
        call caunin( chLine )
      endif
      if(.not.lgGamrOK) then
        write(chLine,'('' C-Continuum not defined at gamma-ray ''
     1  ,''energies - pair production and Compton scattering OK?'')')
        call caunin( chLine )
      endif
      if( lgCon0 ) then
        write(chLine,'('' C-Continuum zero at some energies.'')')
        call caunin( chLine )
      endif
*
      if( lgOcc1Hi ) then
        write(chLine,'(''  !The continuum occupation number'',
     1  '' at 1 Ryd is greater than unity.'')')
        call bangin( chLine )
      endif
*
*     check whether non-col excit of 4363 was important
      call cdLine( 'TOTL',4363, t4363, absint, lgOK)
      if(.not.lgOK ) then
        write(qq,'('' COMMNT could not find total OIII 4363 with cdLine.
     1'')')
        stop
      endif
      call cdLine( 'Coll',4363, c4363, absint, lgOK)
      if(.not.lgOK ) then
        write(qq,'('' COMMNT could not find collis OIII 4363 with cdLine
     1.'')')
        stop
      endif
*     only print this comment is 4363 is significant and density low
      if( HBeta.gt.1e-35 ) then
        if(t4363/HBeta.gt.1e-4  .and.  hden.lt.1e7 ) then
          ratio = (t4363-c4363)/t4363
          if( ratio.gt.0.01 ) then
            write(chLine,'(''  !Non-collisional excitation of'',
     1      '' [OIII] 4363 reached '',F6.2,''% of the total.'')')
     2      ratio * 100.
            call bangin( chLine )
          else if( ratio.gt.0.001 ) then
            write(chLine,'(''   Non-collisional excitation of'',
     1      '' [OIII] 4363 reached '',F6.2,''% of the total.'')')
     2      ratio * 100.
            call notein( chLine )
          endif
        endif
      endif
*
*     check for plasma shielding
      if( lgPlasNu ) then
        write(chLine,'(''  !The plasma frequency is'',1P,E9.2,
     1  '' Ryd.  The incident continuum is set to 0 below this.'')')
     2  plsfrq
        call bangin( chLine )
      endif
*
      if( occmax.gt.0.1) then
        if( occmnu.gt.1e-4 ) then
          write(chLine,'(''  !The largest continuum '',
     1    ''occupation number was'',1P,E10.3,'' at'',E10.3,'' Ryd.'')')
     2    occmax , occmnu
          call bangin( chLine )
        else
*         not surprising if occ num bigger than 1 around 1e-5 Ryd,
*         since this is the case for 3K background
          write(chLine,'(''   The largest continuum '',
     1    ''occupation number was'',1P,E10.3,'' at'',E10.3,'' Ryd.'')')
     2    occmax , occmnu
          call notein( chLine )
        endif
      endif
*
      if( occmax.gt.1e4 .and. occ1nu.gt.0. ) then
*       occ1nu is energy (ryd) where continuum occ num falls below 1
        if( occ1nu.lt.0.0912 ) then
          write(chLine,'(''   The continuum occupation number fell ''
     1    ,''below 1 at '',1P,E10.3,'' microns.'')') 0.0912/occ1nu
          call notein( chLine )
        else if( occ1nu.lt.1. ) then
          write(chLine,'(''   The continuum occupation number fell ''
     1    ,'' below 1 at '',1P,E10.3,'' Angstroms.'')') 912./occ1nu
          call notein( chLine )
        else
          write(chLine,'(''   The continuum occupation number fell ''
     1    ,'' below 1 at '',1P,E10.3,'' Ryd.'')') occ1nu
          call notein( chLine )
        endif
      endif
*
      if( tbrmax.gt.1e3) then
         write(chLine,'(''  !The largest continuum brightness'',
     1   '' temperature was'',1P,E10.3,''K at'',E10.3,'' Ryd.'')')
     2   tbrmax , tbrmnu
         call bangin( chLine )
      endif
*
      if( tbrmax.gt.1e4 ) then
*       tbr4nu is energy (ryd) where continuum bright temp falls < 1e4
        if( tbr4nu.lt.0.0912 ) then
          write(chLine,'(''   The continuum brightness temperature '',
     1    ''fell below 10,000K at '',1P,E10.3,'' microns.'')')
     2    0.0912/tbr4nu
          call notein( chLine )
        else if( tbr4nu.lt.1. ) then
          write(chLine,'(''   The continuum brightness temperature '',
     1    ''fell below 10,000K at '',1P,E10.3,'' Angstroms.'')')
     2    912./tbr4nu
          call notein( chLine )
        else
          write(chLine,'(''   The continuum brightness temperature '',
     1    ''fell below 10,000K at '',1P,E10.3,'' Ryd.'')') tbr4nu
          call notein( chLine )
        endif
      endif
*
*     turbulence AND constant pressure do not make sense
      if( TurbVel.gt.0. .and. chCPres.eq.'CPRE' ) then
        write(chLine,'(''  !Both constant pressure and turbulence'',
     1  '' makes no physical sense???'')')
        call bangin( chLine )
      endif
*
*     filling factor AND constant pressure do not make sense
      if( FillFac.lt.1. .and. chCPres.eq.'CPRE' ) then
        write(chLine,'(''  !Both constant pressure and a filling '',
     1  ''factor makes no physical sense???'')')
        call bangin( chLine )
      endif
*
*     grains and solar abundances do not make sense
      if( lgDustOn.and.lgAbnSolar ) then
        write(chLine,'(''  !Grains are present, but the gas phase '',
     1  ''abundances were left at the solar default.  '',
     2  ''This is not physical.'')')
        call bangin( chLine )
      endif
*
*     check if depletion command set but no grains, another silly thing to do
      if( lgDepln .and. .not.lgDustOn ) then
        write(chLine,'(''  !Grains are not present, but the gas phase'',
     1  '' abundances were depleted.  This is not physical.'')')
        call bangin( chLine )
      endif
*
*     PAH physics is not correct
      if( lgDustOn1(9) .or. lgDustOn1(10) ) then
        write(chLine,'('' W-PAHs are turned on.  The photoionization'',
     1  '' problem is not correctly treated in this version.'')')
        call warnin( chLine )
      endif
*
*     remark that grains not present but energy density was low
      if(.not.lgDustOn.and.TEnerDen.lt.800. ) then
        write(chLine,'(''   Grains were not present but might '',
     1  ''survive in this environment (energy density temperature was''
     1  ,1p,e9.2,''K)'')') TEnerDen
        call notein( chLine )
      endif
*
*     call routine that will check age of cloud
      call CheckAge
*
*     He II Ly-a radiation pressure turned on with non-trivial O abund
      if( lgPresHeLya .and. xIonFracs(8,0)/hden.gt.1e-7 ) then
        write(chLine,'('' W-HeII Ly-a radiation pressure'',
     1  '' is on, and oxygen abundance is significant.''
     2  ,'' Bowen, Prad, not treated OK.'')')
        call warnin( chLine )
      endif
*
*     check on CaH and H-epsilon overlapping
*     need to do this since need to refer to lines arrays
      call chkCaHeps( totwid )
      if( totwid.gt.121. ) then
        write(chLine,'(''   H-eps and CaH overlap.'')')
        call notein( chLine )
      endif
*
*     warning that something was turned off
      if(.not.lgPhysOK) then
        write(chLine,'('' W-A physical process has been disabled.'')')
        call warnin( chLine )
      endif
*
*     check on lifetimes of [OIII] against photoionization, only for low den
      if( hden.lt.1e8 ) then
        if( r5007Max.gt. 0.0263 ) then
          write(chLine,'(''  !Photoionization of upper level of [OIII]''
     1    ,'' 5007 reached'',1p,e10.2,''% of the radiative lifetime.'')'
     2    )r5007Max*100.
          call bangin( chLine )
        else if( r5007Max.gt. 0.0263/10. ) then
          write(chLine,'(''   Photoionization of upper level of [OIII]''
     1    ,'' 5007 reached'',1p,e10.2,''% of the radiative lifetime.'')'
     2    )r5007Max*100.
          call notein( chLine )
        endif
        if( r4363Max.gt. 1.78 ) then
          write(chLine,'(''  !Photoionization of upper level of [OIII]''
     1    ,'' 4363 reached'',1p,e10.2,''% of the radiative lifetime.'')'
     2    )r4363Max*100.
          call bangin( chLine )
        else if( r4363Max.gt. 1.78/10. ) then
          write(chLine,'(''   Photoionization of upper level of [OIII]''
     1    ,'' 4363 reached'',1p,e10.2,''% of the radiative lifetime.'')'
     2    )r4363Max*100.
          call notein( chLine )
        endif
      endif
*
*     check whether total heating and cooling matched
*     >>chng 97 mar 28, added GrossHeat, heat in terms normally heat-cool
      error = abs(power-totcol) / ( ( power + totcol+GrossHeat)/2.)
      if( lgTSetOn ) then
        if( error.gt.0.05 ) then
          write(chLine,'(''  !Heating - cooling mismatch ='',F5.1,''%.''
     1    ,'' Caused by constant temperature assumption. '')')error*100.
          call bangin( chLine )
        endif
      else
        if( error.gt.0.05 .and. error.lt.0.2 ) then
          write(chLine,'('' C-Heating - cooling mismatch ='',F5.1,''%.''
     1    ,'' Whats wrong?'')')  error*100.
          call caunin( chLine )
        else if(  error.ge.0.2 ) then
          write(chLine,'('' W-Heating - cooling mismatch ='',1P,E10.2,
     1    '' Whats wrong????'')') error
          call warnin( chLine )
        endif
      endif
*
*     say if Ly-alpha photo of Ca+ excited levels was important
      if( Ca2RmLya.gt.0.01 ) then
        write(chLine,'(''   Photoionization of Ca+ 2D level by '',
     1  ''Ly-alpha reached '',F6.1,''% of the total rate out.'')')
     2  Ca2RmLya*100.
        call notein( chLine )
      endif
*
*     check if Lya alpha ever hotter than gas
      if( nLyaHot .gt.0 ) then
        if( TLyaMax/TeLyaMax.gt. 1.05 ) then
          write(chLine,'(''  !The excitation temp of Lya '',
     1    ''exceeded the electron temp, largest value was'',1p,e10.2,
     2    ''K (gas temp there was'',e9.2,''K, zone'',i4,'')'')')
     3    TLyaMax,TeLyaMax,nZTLaMax
          call bangin( chLine )
        endif
      endif
*
*     was line photoionization of hydrogen important
      hlmax(1) = 0.
      isav = 0
      do i=2,nhlvl
        if( hlmax(i) .gt. 0.001 ) then
          if( hlmax(i).gt.hlmax(1) ) then
            hlmax(1) = hlmax(i)
            isav = i
          endif
        endif
      end do
      if(isav.gt.0) then
         write(chLine,'(''   Hydrogen self ionization by alpha '',
     1   ''transitions reached '',F6.1,''% of the destruction rate for''
     2   ,'' level'',i3,''.'')') hlmax(1) * 100. , isav
         call notein( chLine )
      endif
*
*     check if line absorption heating was important
*
*     get all negative lines, check if line absorption significant heat source
*     this is used in "final" for energy budget print out
      call cdLine( 'Line' , 0 , SumNeg , absint , lgOK )
      if( .not.lgOK ) write(qq,'('' did not get sumneg cdLine'')')
*     this is total heating
      call cdLine( 'TotH' , 0 , GetHeat , absint , lgOK )
      if( .not.lgOK ) write(qq,'('' did not get GetHeat cdLine'')')
      if( GetHeat.gt.0. ) then
        SumNeg = SumNeg / GetHeat
        if( SumNeg.gt.0.1 ) then
          write(chLine,'(''  !Line absorption heating reached'',1p,
     1    e10.2,''% of the global heating.'')') SumNeg * 100.
          call bangin( chLine )
        else if( SumNeg.gt.0.01 ) then
          write(chLine,'(''   Line absorption heating reached'',1p,
     1    e10.2,''% of the global heating.'')') SumNeg * 100.
          call notein( chLine )
        endif
      endif
*
*     this is check of extra lines added with g-bar
      if( GBarMax .gt.0.1 ) then
        chLbl = chLineLbl( WindLine(1,ipMaxExtra) )
        write(chLine,'(''  !G-bar cooling lines reached'',1p,e10.2,
     1  ''% of the local cooling.  Line='',a10)') GBarMax * 100.,chLbl
        call bangin( chLine )
      else if( GBarMax.gt.0.01 ) then
        chLbl = chLineLbl( WindLine(1,ipMaxExtra) )
        write(chLine,'(''   G-bar cooling lines reached'',1p,e10.2,
     1  ''% of the local cooling.  Line='',a10)') GBarMax * 100.,chLbl
        call notein( chLine )
      endif
*
*     line absorption heating reached more than 10% of local heating?
*     heatlmax is largest heating(1,23)/htot
      if( heatlmax .gt.0.1 ) then
        if( levlmax.eq.1 ) then
*         main block of lines
          chLbl = chGetLbl( ipHeatlmax )
        else if( levlmax.eq.2 ) then
*         level 2 lines
          chLbl = chLineLbl( WindLine(1,ipHeatlmax) )
        else
          write(qq,'('' comment has insane levlmax,='',i5)')levlmax
        endif
        write(chLine,'(''  !Line absorption heating reached'',1p,e10.2,
     1  ''% of the local heating - largest by level'',i2,'' line '',
     2  a10)') heatlmax * 100. , levlmax , chLbl
        call bangin( chLine )
      else if( heatlmax.gt.0.01 ) then
        write(chLine,'(''   Line absorption heating reached'',1p,e10.2,
     1  ''% of the local heating.'')') heatlmax * 100.
        call notein( chLine )
      endif
*
*     did Ly-alpha mase
      if( lgHLyaMased ) then
        write(chLine,'(''   Ly-alpha mased.'')')
        call notein( chLine )
      endif
*
*     did HeII mase?
      if( lgHeMase ) then
        write(chLine,'(''   Helium continuum mased.'')')
        call notein( chLine )
      endif
*
*     check whether excited states of helium were optically thick
      lgHe1thk = .false.
      lgHe2thk = .false.
      do i=2,5
        do j=i+1,6
          if( he1tau(j,i).gt.1. ) lgHe1thk = .true.
          if( he2tau(j,i).gt.1. ) lgHe2thk = .true.
        end do
      end do
      if( lgHe1thk ) then
        write(chLine,'(''   Some excited state HeI lines are thick.'')
     1  ')
        call notein( chLine )
      endif
      if( lgHe2thk ) then
        write(chLine,'(''   Some excited state HeII lines are thick.''
     1   )')
        call notein( chLine )
      endif
*
      if( hden.lt.1e7 ) then
*       check on IR fine structure lines
        lgThick = .false.
        tauneg = 0.
        alpha = 0.
        do i=1,nTauLines
*         define IR as anything longward of 1 micron
          if( TauLines(ipLnEnrWN,i).lt. 10 000. ) then
            if( TauLines(ipLnTauIn,i).gt.1. ) then
              lgThick = .true.
              alpha = max( alpha,TauLines(ipLnTauIn,i) )
            else if( TauLines(ipLnTauIn,i).lt.tauneg ) then
              tauneg = tauneg
              chLbl = chLineLbl( TauLines(1,i) )
            endif
          endif
        end do
*       now print results, were any fine structure lines optically thick?
        if( lgThick ) then
          write(chLine,'(''  !Some infrared fine structure lines '',
     1    ''are optically thick:  largest tau was'',1p,e10.2)') alpha
          call bangin( chLine )
        endif
*       did any fine structure lines mase?
        if( tauneg.lt.-0.01 ) then
          write(chLine,'(''  !Some fine structure lines mased:'',
     1    ''ion with smallest tau was'',a10,1p,e10.2)') chLbl,tauneg
          call bangin( chLine )
        endif
      endif
*
*     were any other lines masing?
      tauneg = 0.
      alpha = 0.
      do i=1,nTauLines
*       define UV as anything shortward of 1 micron
        if( TauLines(ipLnEnrWN,i).ge. 10 000. ) then
          if( TauLines(ipLnTauIn,i).lt.tauneg ) then
            tauneg = TauLines(ipLnTauIn,i)
            chLbl = chLineLbl( TauLines(1,i) )
          endif
        endif
      end do
*     did any lines mase?
      if( tauneg.lt.-0.01 ) then
        write(chLine,'(''  !Some lines mased: '',
     1  ''most negative ion and tau were:'',a10,1p,e10.2)') chLbl,tauneg
        call bangin( chLine )
      endif
*
      if( lgStatic.and.lgLastIt.and.(iter.eq.1 ) ) then
        write(chLine,'('' C-I must iterate when SPHERE STATIC is set.''
     1  )')
        call caunin( chLine )
        lgIterAgain = .true.
      endif
*
*     how important was induced two photon??
      if(xMax2Pht.gt.1.) then
        write(chLine,'(''  !Rate of induced H 2-photon emission '',
     1  ''reached '',1p,e9.2,'' s^-1'')') xMax2Pht
        call bangin( chLine )
      else if( xMax2Pht.gt.0.05 ) then
        write(chLine,'(''   Rate of induced H 2-photon emission '',
     1  ''reached '',1p,e9.2,'' s^-1'')') xMax2Pht
        call notein( chLine )
      endiF
*
*     how important was induced recombination?
      if(FracInd.gt.0.01) then
        write(chLine,'(''   Induced recombination was '',
     1  F5.1,''% of the total for H level'',i3)') FracInd*100. , ndclev
        call notein( chLine )
      endiF
*
      if(fbul.gt.0.01) then
         write(chLine,'(''   Stimulated emission was'',F6.1,
     1   ''% of the total for H transition'',i3,'' -'',i3)')
     2   fbul*100. , nbul+1 , nbul
         call notein( chLine )
      endif
*
*     check whether FeII destruction of La was important
      call cdLine( 'Fe 2' , 1216 , fedest , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Did not find Fe ii Lya'')')
      call cdLine( 'TOTL' , 1216 , alpha , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Did not find Lya'')')
      if( alpha.gt.0. ) then
        ratio = fedest/(fedest+alpha)*100.
        if( ratio.gt.10. ) then
          write(chLine,'(''  !FeII destruction of Ly-a removed '',
     1    F5.1,''% of the line.'')') ratio
          call bangin( chLine )
        else if( ratio.gt.0.1 ) then
          write(chLine,'(''   FeII destruction of Ly-a removed '',
     1    F5.1,''% of the line.'')') ratio
          call notein( chLine )
        endif
      endif
*
      call cdLine( 'H-CT' , 6563 , relhm , absint , lgOK )
      if(.not.lgOK)write(qq,'('' Comment did not find H-CT H-alpha'')')
      if( HBeta.gt.0. ) then
        if( relhm/HBeta.gt.0.01 ) then
          write(chLine,'(''  !Mutual neutralization production of H-'',
     1    ''alpha was significant.'')')
          call bangin( chLine )
        endif
      endif
*
*     note about very high population in H n=2 rel to ground
      if( lgHiPop2 ) then
         write(chLine,'(''   The population of H n=2 reached'',1P,
     1   E9.2,'' relative to the ground state.'')') pop2mx
         call notein( chLine )
      endif
*
*     check where diffuse emission error
      if( CaseBCheck.gt.1.5 ) then
         write(chLine,'(''   Ratio of computed diffuse emission to ''
     1   ,'' case B reached'',1P,E9.2)') CaseBCheck
         call notein( chLine )
      endif
*
      if( thist.gt.1e9 ) then
        if( thist.gt.5e9 ) then
          write(chLine,'('' W-Electrons were relativistic;'',
     1    '' High TE='',1P,E9.2)') thist
          call warnin( chLine )
        else
          write(chLine,'('' C-Electrons were mildly relativistic;'',
     1    '' High TE='',1P,E9.2)') thist
          call caunin( chLine )
        endif
      endif
*
      rate = TimeErode * 2e-26
      if( rate.gt.1e-35 ) then
*        2E-26 is roughly cross section for photoerosion
*        see Boyd and Ferland ApJ Let 318, L21.
         ts = (1. / rate ) / 3e7
         if( ts.lt. 1e3 ) then
            write(chLine,'(''  !Timescale-photoerosion of Fe='',1P,E8.2,
     1      ''yr'')') ts
            call bangin( chLine )
         else if( ts.lt.1e9 ) then
            write(chLine,'(''   Timescale-photoerosion of Fe='',1P,E8.2,
     1      ''yr'')') ts
            call notein( chLine )
         endif
      endif
*
*     check whether Compton heating was significant
      comfrc = comtot / power
      if( comfrc .gt.0.01 ) then
         write(chLine,'(''   Compton heating was '',F5.1,''% of the '',
     1   ''total.'')') comfrc*100.
         call notein( chLine )
      endif
*
*     check on relative importance of induced compton heating
      if( comfrc.gt.0.01.and.cinrat.gt.0.05 ) then
         write(chLine,'(''  !Induced Compton heating was '',1P,E9.2,
     1   '' of the total Compton heating.'')') cinrat
         call bangin( chLine )
      endif
*
*     check whether equilibrium timescales are short rel to Hubble time
      if( tcmptn.gt.5e17 ) then
         if( comfrc.gt.0.05 ) then
            write(chLine,'('' C-Compton cooling is significant and '',
     1      ''the equilibrium timescale ('',1p,e9.2,''s) is longer '',
     1      ''than the Hubble time.'')') tcmptn
            call caunin( chLine )
         else
            write(chLine,'(''   Compton cooling '',
     1      ''equilibrium timescale ('',1p,e9.2,''s) is longer '',
     1      ''than Hubble time.'')') tcmptn
            call notein( chLine )
         endif
      endif
*
      if( ttherm.gt.5e17 ) then
         write(chLine,'('' C-Thermal equilibrium timescale longer '',
     1   ''than Hubble time, ='',1P,E10.2,''s'')') ttherm
         call caunin( chLine )
      endif
*
*     check whether model large relative to Jeans length
*     DMEAN is mean density (gm per cc)
*     mean temp is weighted by mass density
      if( log10(depth).gt.rjnmin ) then
*       AJMIN is minimum Jeans mass, log in grams
        aj = 10.**( ajmmin - log10(solarm) )
        if( chCPres.eq.'CPRE' ) then
          write(chLine,'('' C-Cloud thicker than smallest Jeans '',
     1    ''length='',1P,E8.2,''cm; stability problems? '',
     2    ''(smallest Jeans mass='', E8.2,''Mo)'')') 10.**rjnmin,aj
          call caunin( chLine )
        else
          write(chLine,'(''   Cloud thicker than smallest Jeans '',
     1    ''length='',
     1    1P,E8.2,''cm; stability problems? (smallest Jeans mass='',
     2    E8.2,''Mo)'')') 10.**rjnmin,aj
          call notein( chLine )
        endif
      endif
*
*     check if constant pressure, but it wasn't
      if( chCPres.eq.'CPRE' ) then
        if( phi/plow.gt.1.50 ) then
          write(chLine,'('' C-Sum of gas+line rad pressure ranged from''
     1    ,1P,E10.2,'' to '',E10.2,'' in a constant pressure model.'')')
     2    plow , phi
          call caunin( chLine )
        else if( phi/plow.gt.1.20 ) then
          write(chLine,'(''  !Sum of gas+line rad pressure ranged from''
     1    ,1P,E10.2,'' to '',E10.2,'' in a constant pressure model.'')')
     2    plow , phi
          call bangin( chLine )
        else if( phi/plow.gt.1.05 ) then
          write(chLine,'(''   Sum of gas+line rad pressure ranged from''
     1    ,1P,E10.2,'' to '',E10.2,'' in a constant pressure model.'')')
     2    plow , phi
          call notein( chLine )
        endif
      endif
*
*     check whether grains too hot to survive
      do nd=1,ndust
        if( lgDustOn1(nd) ) then
          if( tgrmax(nd).gt.sublimat(nd) ) then
            write(chLine,'('' W-Maximum temperature of grain '',A10,
     1      '' was'',1P,E10.2,''K, above its sublimation temperature,'',
     2      e10.2,''K.'')')
     2      chDstLab(nd) , tgrmax(nd),sublimat(nd)
            call warnin( chLine )
          else if( tgrmax(nd).gt.sublimat(nd)*0.9 ) then
            write(chLine,'('' C-Maximum temperature of grain '',A10,
     1      '' was'', 1P,E10.2,''K, near its sublimation temperature,'',
     2      e10.2,''K.'')')
     2      chDstLab(nd) , tgrmax(nd),sublimat(nd)
            call caunin( chLine )
          endif
        endif
      end do
*
      if( lgNegGrnDrg ) then
        write(chLine,'(''  !Grain drag force <0.'')')
        call bangin( chLine )
      endif
*
*     is photoelectric heating of gas by photioniz of grains important
      if( dphmax.gt.0.05 ) then
        write(chLine,'(''   Local grain-gas photoelectric '',
     1  ''heating rate reached '',F5.1,''% of the total.'')'
     2   ) dphmax*100.
        call notein( chLine )
      endif
*
      if( TotalDustHeat/power .gt. 0.01 ) then
        write(chLine,'(''   Global grain photoelectric heating of '',
     1  ''gas was'',F5.1,''% of the total.'')') TotalDustHeat/power*100.
        call notein( chLine )
        if( TotalDustHeat/power .gt. 0.25 ) then
          write(chLine,'(''  !Grain photoelectric heating is VERY '',
     1    ''important.'')')
          call bangin( chLine )
        endif
      endif
*
*     grain-gas collis cooling of gas
      if( dclmax.gt.0.05 ) then
         write(chLine,'(''   Local grain-gas '',
     1   ''cooling of gas rate reached '',F5.1,''% of the total.'')'
     2    ) dclmax*100.
         call notein( chLine )
      endif
*
*     check whether photodissociation of H_2^+ molecular ion was important
      if( h2pmax.gt.0.10 ) then
         write(chLine,'(''  !The local H2+ photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total heating.'')')
     2   h2pmax*100.
         call bangin( chLine )
      else if( h2pmax.gt.0.01 ) then
         write(chLine,'(''   The local H2+ photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total heating.'')')
     2   h2pmax*100.
         call notein( chLine )
      endif
*
*     check whether photodissociation of molecular hydrogen (H2)was important
      if( h2dfrc.gt.0.05 ) then
         write(chLine,'(''   The local H2 photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total.'')')
     2   h2dfrc*100.
         call notein( chLine )
      endif
*
      if( h2dtot/power .gt. 0.01 ) then
         write(chLine,'(''   Global H2 photodissociation heating of '',
     1   ''gas was'',F5.1,''% of the total.'')') h2dtot/power*100.
         call notein( chLine )
         if( h2dtot/power .gt. 0.25 ) then
            write(chLine,'(''   H2 photodissociation heating is VERY '',
     1      ''important.'')')
            call notein( chLine )
         endif
      endif
*
*     check whether photodissociation of carbon monoxide (co) was important
      if( codfrc.gt.0.25 ) then
         write(chLine,'(''  !Local CO photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total.'')')
     2   codfrc*100.
         call bangin( chLine )
      else if( codfrc.gt.0.05 ) then
         write(chLine,'(''   Local CO photodissociation'',
     1   '' heating rate reached '',F5.1,''% of the total.'')')
     2   codfrc*100.
         call notein( chLine )
      endif
*
      if( codtot/power .gt. 0.01 ) then
         write(chLine,'(''   Global CO photodissociation heating of '',
     1   ''gas was'',F5.1,''% of the total.'')') codtot/power*100.
         call notein( chLine )
         if( codtot/power .gt. 0.25 ) then
            write(chLine,'(''   CO photodissociation heating is VERY '',
     1      ''important.'')')
            call notein( chLine )
         endif
      endif
*
      if( lgEdnGTcm ) then
        write(chLine,'(''   Energy density of radiation field was '',
     1  ''greater than the Compton temperature. Is this physical?'')')
        call notein( chLine )
      endif
*
*     was cooling due to induced recombination important?
      if( cintot/power.gt.0.01) then
        write(chLine,'(''   Induced recombination'',
     1  '' cooling was'',F5.1,''% of the total.'')') cintot/power*100.
        call notein( chLine )
      endif
*
*     check whether free-free heating was significant
      if( ffhtot/power.gt.0.1 ) then
        write(chLine,'(''  !Free-free heating was'',F5.1,''% of the '',
     1  ''total.'')') ffhtot/power*100.
        lgFFimp = .true.
        call bangin( chLine )
      else if( ffhtot/power.gt.0.01 ) then
        write(chLine,'(''   Free-free heating was'',F5.1,''% of the '',
     1  ''total.'')') ffhtot/power*100.
        lgFFimp = .true.
        call notein( chLine )
      else
        lgFFimp = .false.
      endif
*
*     was heating due to H- absorption important?
      if( hmitot/power.gt.0.01 ) then
        write(chLine,'(''   H- absorption heating'',
     1  '' was'',F5.1,''% of the total.'')') hmitot/power*100.
        call notein( chLine )
      endif
*
*     water desruction rate was zero
      if( lgH2Ozer ) then
        write(chLine,'(''   Water destruction rate zero.'')')
        call notein( chLine )
      endif
*
*     numerical instability in matrix inverson routine
      if( negoi.gt.0 ) then
        write(chLine,'('' C-OI negative level populations'',
     1  I4,'' times.'')') negoi
        call caunin( chLine )
      endif
*
*     numerical instability in matrix inverson routine
      if( nFe2Neg.gt.0 ) then
        write(chLine,'('' C-FeII negative level populations'',
     1  I4,'' times.'')') nFe2Neg
        call caunin( chLine )
      endif
*
*     check for negative optical depths,
*     optical depth in excited state helium lines
      lgMaser = .false.
      small = 0.
      do i=1,nhlvl-1
        do j=i+1,nhlvl
          if( htau(j,i).lt.-0.05 ) then
            small = min( small , htau(j,i) )
            lgMaser = .true.
            imas = 100 * j + i
          endif
        end do
      end do
      if( lgMaser ) then
        write(chLine,'(''  !Some H lines mased.'',
     1  ''  Smallest tau='',1P,E10.2,i6)') small, imas
        call bangin( chLine )
      endif
*
*     check for negative optical depths in He atom
*     optical depth in excited state helium lines
      lgMaser = .false.
      small = 0.
      do i=1,nhe1lvl-1
        do j=i+1,nhe1lvl
          if( he1tau(j,i).lt.-0.05 ) then
            small = min( small , he1tau(j,i) )
            lgMaser = .true.
            imas = 100 * j + i
          endif
        end do
      end do
      if( lgMaser ) then
        write(chLine,'(''  !Some HeI lines mased.'',
     1  ''  Smallest tau='',1P,E10.2,i6)') small, imas
        call bangin( chLine )
      endif
*
*     check for negative optical depths in He ion
*     optical depth in excited state helium lines
      lgMaser = .false.
      small = 0.
      do i=1,nhe2lvl-1
        do j=i+1,nhe2lvl
          if( he2tau(j,i).lt.-0.05 ) then
            small = min( small , he2tau(j,i) )
            lgMaser = .true.
            imas = 100 * j + i
          endif
        end do
      end do
      if( lgMaser ) then
        write(chLine,'(''  !Some HeII lines mased.'',
     1  ''  Smallest tau='',1P,E10.2,i6)') small, imas
        call bangin( chLine )
      endif
*
*     check for negative opacities
      if( lgOpacNeg ) then
        write(chLine,'(''  !Some opacities were negative - the'',
     1  '' SET NEGOPC command will punch which ones.'')')
        call bangin( chLine )
      endif
*
*     now check continua
      lgMaser = .false.
      small = 0.
      do i=1,9
        if( tauabs(ipHn(i),1).lt.-0.001 ) then
          small = min( small , tauabs(ipHn(i),1) )
          lgMaser = .true.
          imas = i
        endif
      end do
      if( lgMaser ) then
        write(chLine,'(''  !Some H continua optical depths were'',
     1  ''negative; smallest='',1P,E10.2,'' level='',i3)') small , imas
        call bangin( chLine )
      endif
*
*     check whether any continuum optical depths are negative
      nneg = 0
      tauneg = 0.
      do i=1,nflux
        if( tauabs(i,1).lt.-0.001 ) then
          nneg = nneg + 1
*         only remember the smallest freq, and most neg optical depth
          if(nneg.eq.1) freqn = anu(i)
          tauneg = min( tauneg,tauabs(i,1) )
        endif
      end do
      if( nneg.gt.0 ) then
         write(chLine,'(''  !Some continuous optical'',
     1     '' depths <0.  The lowest freq was'',
     2     1P,E10.3,'' Ryd, and a total of'',I4)') freqn , nneg
         call bangin( chLine )
         write(chLine,'(''  !The smallest optical depth was'',
     1   1p,e10.2)') tauneg
         call bangin( chLine )
      endif
*
*     say if Balmer continuum optically thick
      if( tauabs(ipHn(2),1).gt.0.05 ) then
         write(chLine,'(''   The Balmer continuum ''
     1   ,''optical depth was'',1P,E9.2,''.'')') tauabs(ipHn(2),1)
         call notein( chLine )
      endif
*
*     was correction for stimulated emission significant?
      if( stimax(1).gt.0.02 .and.tauabs(ipHn(1),1).gt.0.2 ) then
         write(chLine,'(''   The Lyman continuum stimulated emission ''
     1   ,''correction to optical depths reached'',1P,E9.2,''.'')')
     2   stimax(1)
         call notein( chLine )
      else if( stimax(2).gt.0.02 .and.tauabs(ipHn(2),1).gt.0.1 ) then
         write(chLine,'(''   The Balmer continuum stimulated emission ''
     1   ,''correction to optical depths reached'',1P,E9.2,''.'')')
     2   stimax(2)
         call notein( chLine )
      endif
*
*     say if Paschen continuum optically thick
      if( tauabs(ipHn(3),1) .gt.0.2 ) then
         write(chLine,'(''   The Paschen continuum optical depth was'',
     1   1P,E10.2,''.'')') tauabs(ipHn(3),1)
         call notein( chLine )
      endif
*
*     some comments about near IR total optical depth
      if( tauabs(1,1).gt.1. ) then
         write(chLine,'(''   The continuum optical depth at the lowest''
     1   ,'' energy considered (E='',1P,
     1   E10.3,'' Ryd) was '',E10.3,''.'')') anu(1) , tauabs(1,1)
         call notein( chLine )
      endif
*
*     comment if optical depth to Rayleigh scattering is big
*     cs from VAL 76
      if( chi*7e-24 .gt. 0.01 ) then
         write(chLine,'(''   The optical depth to'',
     1   '' Rayleigh scattering at 1300A is'',1P,E9.2)') chi*6.71E-24
         call notein( chLine )
      endif
*
      if( ch2pls*7e-18 .gt. 0.01 ) then
         write(chLine,'(''   The optical depth to''
     1   ,'' the H2+ molecular ion is'',1P,E9.2)') ch2pls*7e-18
         call notein( chLine )
      endif
*
*     warn if optically thick to H- absorption
      if( thmin.gt.0.01 ) then
         write(chLine,'(''   Optical depth to negative hydrogen ion is''
     1   ,1P,e10.2)') thmin
         call notein( chLine )
      endif
*
*     say if 3-dody rec coef function outside range of validity
*     tripped if te/z**2 < 100 or approx 10**13: => effect >50% of radiative
*     other intergers defined in source for da
      if( ifail.gt.0 .and. ifail.le.10 ) then
         write(chLine,'(''   3 body rec coef outside range'',I4)') ifail
         call notein( chLine )
      else if( ifail.gt.10 ) then
         write(chLine,'('' C-3 body rec coef outside range'',I4)') ifail
         call caunin( chLine )
      endif
*
*     check whether energy density less than background
      if( TEnerDen.lt.2.6 ) then
         write(chLine,'(''  !Incident radiation field '',
     1   ''energy density is less than 2.7K.  Add background with ''
     2   ,''FIREBALL command.'')')
         call bangin( chLine )
      endif
*
*     incident radiation field is less than Habing ISM field
      if( lgHabing ) then
         write(chLine,'(1X,'' !The intensity of the incident '',
     1   ''radiation field is less than 10 times the Habing'',
     1   '' diffuse ISM field.  Is this OK?'')')
         call bangin( chLine )
      endif
*
*     check whether cosmic rays on, but model thick to them
      if( cryden.gt.0. .and. (chi/10. + chii).gt.1e23 ) then
         write(chLine,'('' C-Model is thick to cosmic rays, which are'',
     1   '' on.'')')
         call caunin( chLine )
      endif
*
*     was ionization rate less than cosmic ray ionization rate in ISM?
      if( cryden.eq.0. .and. hgamnc(1).lt.1e-17 ) then
         write(chLine,'(''   Ionization rate fell below background ''
     1   ,''cosmic ray ionization rate.  Should this be added too?'')')
         call notein( chLine )
      endif
*
*     more than 10% of H is in the H2 molecule
      if( BiggestH2.gt.0.1 ) then
         write(chLine,'(''  !A large amount of the hydrogen is '',
     1   ''molecular, the fraction reached '',F5.1,''%.'')')
     2   min(1.,BiggestH2)*100.
         call bangin( chLine )
      else if( BiggestH2.gt.1e-3 ) then
         write(chLine,'(''   The H2/H molecular fraction reached'',1P,
     1   e9.2,''%.'')') BiggestH2*100.
         call notein( chLine )
      endif
*
*     how much carbon is molecular?
      if( CarMolFrac.gt.0.1 ) then
         write(chLine,'(''  !A large amount of the carbon is molecular''
     1   ,'', fraction reached '',F5.1,''%'')') min(1.,CarMolFrac)*100.
         call bangin( chLine )
      else if( CarMolFrac.gt.1e-3 ) then
         write(chLine,'(''   The carbon molecular fraction reached'',1P,
     1   e9.2,''%'')') CarMolFrac*100.
         call notein( chLine )
      endif
*
*     brems optical depth
      if( tff.gt.0.09 ) then
        write(chLine,'(''  !The cloud is optically thick at '',
     1  ''optical wavelengths, extending to'',1P,E10.3,'' Ryd ='',
     2  e10.3,''A'')') tff , rydlam / tff
        call bangin( chLine )
      else if ( tff.gt.0.009 ) then
        write(chLine,'(''   The continuum of the computed structure '',
     1  ''may be optically thick in the near infrared.'')')
        call notein( chLine )
      endif
*
*     did model run away to very large radius?
      if( radius.gt.1e23 .and. radius/rinner.gt.10. ) then
        write(chLine,
     1  '(''   Is an outer radius of'',1P,E9.2,'' reasonable?'')')
     2  radius
        call notein( chLine )
      endif
*
*     lgPradCap is true if radiation pressure was capped on first iteration
*     also check that this is a constant total pressure model
      if( lgPradCap.and. (chCPres.eq.'CPRE').and.lgRadPresON ) then
         write(chLine,'(''   Radiation '',
     1   ''pressure kept below gas pressure on this iteration.'')')
         call notein( chLine )
      endif
*
      if( RadBetaMax.gt.0.5 ) then
        if( iprdmx.eq.1 ) then
          write(chLine,'(''   The ratio of radiation to gas pressure''
     1    ,'' reached '',1P,E9.2,''.  Caused by Lyman alpha.'',I3)')
     2    RadBetaMax
          call notein( chLine )
        else
          write(chLine,'(''   The ratio of radiation to gas pressure''
     1    ,'' reached '',1P,E9.2,''.  Caused by line number'',I3)')
     2    RadBetaMax, iprdmx
          call notein( chLine )
        endif
      endif
*
      if( telec.gt.0.05 .and. telec.le.1.0 )  then
        write(chLine,'(''   The optical depth to electron scattering ''
     1  ,''was'',1P,E10.2)')telec
        call notein( chLine )
      else if( telec.gt.1.0 .and. telec.lt.5. ) then
        write(chLine,'('' C-The model is optically thick to electron'',
     1  '' scattering; tau='',1P,E9.2)') telec
        call caunin( chLine )
      else if( telec.ge.5. ) then
        write(chLine,'('' W-The model is optically thick to electron'',
     1  '' scattering; tau='',1P,E9.2)') telec
        call warnin( chLine )
      endif
*
*     heavy element molecules had negative poppulations
      if( lgComNeg .and. CarMolFrac.gt.0.5 ) then
        write(chLine,'(''  !Populations of heavy element molecules '',
     1  ''were negative because of large CO population.'')')
        call bangin( chLine )
      else if( lgComNeg ) then
        write(chLine,'('' C-Populations of heavy element molecules '',
     1  ''were negative; CO, H2O, etc populations may not be correct.''
     2  )')
        call caunin( chLine )
      endif
*
*     check on convergence of hydrogen lines
      if( htau(3,2).gt.0.2) then
        differ = abs(1.- htau(3,2)*DoubleTau/htlim(3,2)  ) * 100.
*       check whether H-alpha optical depth changed by much on last iteration
*       no tolerance can be finer than autocv, the tolerance on the
*       iterate to convergence comamnd.  It is 15%
        if(  lgLastIt .and.  htau(3,2).gt.0.8  .and. differ.gt.20. .and.
     1    windv.eq.0. ) then
          write(chLine,'('' C-This is the last iteration and H(a) '',
     1    ''optical depth changed by'',F6.1,''% (was '',1P,E9.2,
     2    ''). Try another iteration.'')') differ , htlim(3,2)
          call caunin( chLine )
          lgIterAgain = .true.
        endif
*       only check on Lya convergence if Balmer lines are thick
        if( htau(2,1).gt.0. ) then
          differ = abs(1.- htau(2,1)*DoubleTau/htlim(2,1)  ) * 100.
*         check whether h-alpha optical depth changed by much on last iteration
*         no tolerance can be finer than autocv, the tolerance on the
*         iterate to convergence comamnd.  It is 15%
          if( lgLastIt .and.  htau(2,1).gt.0.8  .and. differ.gt.25..and.
     1      windv.eq.0. ) then
            write(chLine,'('' C-This is the last iteration and Ly(a) '',
     1      ''optical depth changed by'',F7.0,''% (was '',1P,E9.2,
     2      ''). Try another iteration.'')') differ , htlim(2,1)
            call caunin( chLine )
            lgIterAgain = .true.
          endif
        endif
      endif
*
      if( he1tau(2,1).lt.1e3 .and. lgHe1ON .and.
     1  (he1tau(2,1)-TAddHeI) .gt.0.5 ) then
        differ = abs(1.- he1tau(2,1)*DoubleTau/he1lim(2,1) ) * 100.
*       check whether he 1 h-alpha optical depth converged
        if(  lgLastIt .and.  he1tau(2,1).gt.0.8  .and. differ.gt.10.
     1    .and.  windv.eq.0. ) then
          write(chLine,'('' C-This is the last iteration and HeI(Lya) ''
     1    ,''optical depth changed by'',F6.1,''% (was '',1P,E9.2,
     2    ''). Try another iteration'')') differ , he1lim(2,1)
          call caunin( chLine )
          lgIterAgain = .true.
        endif
      endif
*
      if( he2tau(2,1).lt.1e3 .and. lgHe2ON ) then
        differ = abs(1.- he2tau(2,1)*DoubleTau/he2lim(2,1) ) * 100.
*       check whether he 2 h-alpha optical depth converged
        if(  lgLastIt .and.  he2tau(2,1).gt.0.8  .and. differ.GT.10.
     1  .and.  windv.eq.0. ) then
          write(chLine,'('' C-This is the last iteration and HeII(''
     1    ,''Lya) optical depth changed by'',F6.1,''% (was '',1P,E9.2,
     2    ''). Try another iteration'')') differ , he2lim(2,1)
          call caunin( chLine )
          lgIterAgain = .true.
        endif
      endif
*
*     check whether sphere was set if dr/r large
      if( radius/rinner.gt.2. .and. .not.lgSphere ) then
        write(chLine,'('' C-R(out)/R(in)='',1P,E10.2,
     1  '' and SPHERE was not set.'')')radius/rinner
        call caunin( chLine )
      endif
*
*     check if thin in Lyman continuum, and assumed thick
      if( tauabs(ipHn(1),1).lt.2. .and. tauabs(ipHn(1),2) .gt.3.
     1  .and. lgLastIt .and. (.not.lgCaseb) ) then
        write(chLine,'('' C-The Lyman continuum is thin, and I '',
     2  ''assumed that it was thick.  Try another iteration.'')')
        call caunin( chLine )
        lgIterAgain = .true.
      endif
*
*     check if thin in helium continua, but assumed to be thick
      if( lgLastIt ) then
        if( tauabs(nhe2(1),1).lt.2. .and. tauabs(nhe2(1),1).gt.2. .and.
     1  nflux.gt.nheii ) then
          write(chLine,'('' C-The HeII continuum is thin and I '',
     1    ''assumed that it was thick.  Try another iteration.'')')
          call caunin( chLine )
          lgIterAgain = .true.
        endif
        if( tauabs(nhe1(1),1).lt.2. .and. tauabs(nhe1(1),1).gt.2. .and.
     1  nflux.gt.nhei1 ) then
          write(chLine,'('' C-The HeI continuum is thin and I '',
     1    ''assumed that it was thick.  Try another iteration.'')')
          call caunin( chLine )
          lgIterAgain = .true.
        endif
      endif
*
*     check whether column density changed by much on this iteration
      if( iter.gt.1 ) then
        if( ColDenSav(iter-1).le.0. ) then
          write(qq,'('' ColDenSav is insane in comment.'')')
          call ShowMe
          stop
        endif
        differ = abs( 1.-colden/ColDenSav(iter-1) )
        if( differ.gt.0.1 .and. differ.le.0.3 ) then
          write(chLine,'(''   The column density changed by '',
     1    1p,e10.2,''% between this and previous iteration.'')')
     3    differ*100.
          call notein( chLine )
        else if( differ.gt.0.3 ) then
          if( lgLastIt ) then
            write(chLine,'(''  !The column density changed by '',
     1      1p,e10.2,''% and this is the last iteration.  '',
     2      ''What happened?'')')
     3      differ*100.
            call bangin( chLine )
          else
            write(chLine,'(''  !The column density changed by '',
     1      1p,e10.2,''%  What happened?'')')
     3      differ*100.
            call bangin( chLine )
          endif
        endif
      endif
*
*     say if rad pressure caused by la and la optical depth changed too much
      differ = abs(1.-  htau(2,1)/htlim(2,1)  ) * 100.
      if( lgLastIt .and. RadBetaMax.gt.0.1 .and. differ.gt.50. .and.
     1 iprdmx.eq.1 .and. lgRadPresON .and.windv.eq.0. ) then
         write(chLine,'(1X,''C-This is the last iteration, radiation '',
     1   ''pressure was significant, and the L-a optical depth '',
     2   ''changed by '',F7.2,''% (was'',1P,E10.2,'')'')') differ,
     3   htlim(2,1)
         call caunin( chLine )
      endif
*
*     say if la rad pressure capped by thermalization length
      if( lgPradDen ) then
         write(chLine,'(3X,
     1   ''Line radiation pressure capped by thermalization length.'')')
         call notein( chLine )
      endif
*
*     print te failures
      nline = min( nfail , 10 )
      if( nfail .ne. 0 ) then
        if( failmx.lt.0.1 ) then
          write(chLine,'(3X,''There were'',I4,
     1    '' minor temperature failures, the zones were''
     2    ,12I4)') nfail,(ifailz(i),i=1,nline)
          call notein( chLine )
        else
          write(chLine,'(''  !There were'',I4,
     1    '' temperature failures, and some were large.'',
     2    '' The largest was'',F6.1,''%.  What happened?'')')
     2     nfail,failmx*100.
          call bangin( chLine )
          write(chLine,'(''  !The zones were'',12I4)')
     1    (ifailz(i),i=1,nline)
          call bangin( chLine )
          if( testr(1).gt.8e4.and. te .lt.6E5 ) then
            write(chLine,'(''  !I think they may have been caused by'',
     1      '' the change from hot to nebular gas'',
     2      '' phase.  The physics of this is unclear.'')')
            call bangin( chLine )
          endif
        endif
      endif
*
*     check for temperature jumps
      BigJump = 0.
      do i=2,nzone
        big = abs(1.-testr(i-1)/testr(i))
        if( big .gt.BigJump ) then
          j = i
          BigJump = big
        endif
      end do
      if( BigJump .gt.0.4 ) then
        write(chLine,'('' C-A temperature discontinuity occurred at '',
     1  ''zone'',i4,'' from'',1p,e9.2,''K to'',e9.2,''K.'')')
     2  j , testr(j-1) , testr(j)
        call caunin( chLine )
      else if( BigJump.gt.0.2 ) then
        write(chLine,'(''  !A temperature discontinuity occurred at '',
     1  ''zone'',i4,'' from'',1p,e9.2,''K to'',e9.2,''K.'')')
     2  j , testr(j-1) , testr(j)
        call bangin( chLine )
      endif
*
*     check for largest error in local electron density
      if( abs(BigEdenError).gt.EdenError ) then
*       this only produces a warning if not the very last zone
        if( abs(BigEdenError).gt.EdenError*10..and. nzEdenBad.ne.nzone)
     1    then
          write(chLine,'('' W-The local error in the electron density'',
     1    '' reached'',f5.1,''% at zone'',i5)') BigEdenError*100,
     2    ipEdenError
          call warnin( chLine )
        else if( abs(BigEdenError).gt.EdenError*5. ) then
          write(chLine,'('' C-The local error in the electron density'',
     1    '' reached'',f5.1,''% at zone'',i5)') BigEdenError*100,
     2    ipEdenError
          call caunin( chLine )
        else
          write(chLine,'(''   The local error in the electron density'',
     1    '' reached'',f5.1,''% at zone'',i5)') BigEdenError*100,
     2    ipEdenError
          call notein( chLine )
        endif
      endif
*
*     check for temperature oscillations
      BigJump = 0.
      do i=2,nzone-1
        big = (testr(i-1)-testr(i)) /testr(i)
        bigm = (testr(i)-testr(i+1)) /testr(i)
        if( big*bigm.lt.0. .and.
     1    min(abs(bigm),abs(big)).gt.BigJump) then
          j = i
          BigJump = min(abs(bigm),abs(big))
        endif
      end do
      if( BigJump .gt.0.1 ) then
        write(chLine,'('' C-A temperature oscillation occurred ''
     1  ,''at zone'',i4,'' by'',f5.0,''% from'',1p,e9.2,'' to '',e9.2,
     2  '' to'',e9.2)')
     2  j , BigJump*100.,testr(j-1) , testr(j) , testr(j+1)
        call caunin( chLine )
      else if( BigJump.gt.0.3 ) then
        write(chLine,'(''  !A temperature oscillation occurred ''
     1  ,''at zone'',i4,'' by'',f5.0,''% from'',1p,e9.2,'' to '',e9.2,
     2  '' to'',e9.2)')
     2  j , BigJump*100.,testr(j-1) , testr(j) , testr(j+1)
        call bangin( chLine )
      endif
*
*     check for eden oscillations
      if( chCPres.eq.'CDEN' ) then
        BigJump = 0.
        do i=2,nzone-1
          big = (ednstr(i-1)-ednstr(i)) /ednstr(i)
          if( abs(big).lt.EdenError ) big = 0.
          bigm = (ednstr(i)-ednstr(i+1)) /ednstr(i)
          if( abs(bigm).lt.EdenError ) bigm = 0.
          if( big*bigm.lt.0. .and.
     1      abs(ednstr(i-1)-ednstr(i) )/ednstr(i).gt.BigJump) then
            j = i
            BigJump = abs(ednstr(i-1)-ednstr(i)) /ednstr(i)
          endif
        end do
        if( BigJump .gt.EdenError*10. ) then
          write(chLine,'('' C-An electron density oscillation ''
     1    ,''occurred at zone'',i4,'' by'',f5.0,''% from'',1p,e9.2,
     2    '' to '',e9.2,'' to'',e9.2)')
     2    j , BigJump*100.,ednstr(j-1) , ednstr(j) , ednstr(j+1)
          call caunin( chLine )
        else if( BigJump.gt.EdenError*3. ) then
          write(chLine,'(''  !An electron density oscillation occurred''
     1    ,'' at zone'',i4,'' by'',f5.0,''% from'',1p,e9.2,'' to '',e9.2
     2    ,'' to'',e9.2)')
     2    j , BigJump*100.,ednstr(j-1) , ednstr(j) , ednstr(j+1)
          call bangin( chLine )
        endif
      endif
*
*     say if te fell too low for matrix formalism
      if( nhlo.ne.0 ) then
         if( htau(3,2).gt.1. ) then
            write(chLine,'('' C-Temp or ion too low and matrix ''
     1      ,''not used for H.  Low den Case B assumed, BUT lines are''
     2      ,'' thick.'',I5,'' THLO='',1P,E10.3)') nhlo , thlo
            call caunin( chLine )
         else if( hden.gt.1e7 ) then
            write(chLine,'('' C-Temp or ion too low and matrix not ''
     1      ,''used for H in some zones. Low density Case B assumed.'',
     1      I5,'' THLO='' ,1P,E10.3)') nhlo , thlo
            call caunin( chLine )
         else
            write(chLine,'(''   Temp or ion too low and matrix not '',
     1      ''used for H in some zones. Low density Case B assumed.'',
     2      I5,'' THLO='',1P,E10.3)') nhlo , thlo
            call notein( chLine )
         endif
      endif
*
      if( nhe1lo.ne.0 ) then
         if( hden.gt.1e7 ) then
            write(chLine,'('' C-Temp too low and matrix not used for ''
     1      ,''He singlets in some zones. Low density Case B assumed.''
     2      ,I5,'' THE1LO='',1P,E10.3)') nhe1lo , the1lo
            call caunin( chLine )
         else
            write(chLine,'(''   Temp too low and matrix not used for ''
     1      ,''He singlets in some zones. Low density Case B assumed.''
     2      ,I5,'' THE1LO='',1P,E10.3)') nhe1lo , the1lo
            call notein( chLine )
         endif
      endif
*
      if( nhe2lo.ne.0 ) then
        if( hden.gt.1e7 ) then
          write(chLine,'('' C-Temp too low and matrix not used for ''
     1    ,''He ion in some zones. Low density Case B assumed.'',I5,
     2    '' THE2LO='',1P,E10.3)') nhe2lo , the2lo
          call caunin( chLine )
        else
          write(chLine,'(''   Temp too low and matrix not used for ''
     1    ,''He ion in some zones. Low density Case B assumed.'',I5,
     2    '' THE2LO='',1P,E10.3)') nhe2lo , the2lo
        call notein( chLine )
        endif
      endif
*
*     final prinout of warnings, cautions, notes,
      call cdNwcns( nw , nc , nn , ns , i, j )
      if( nw .gt. 0 ) then
        lgWarngs = .true.
      else
        lgWarngs = .false.
      endif
*
      if( nc .gt. 0 ) then
        lgCautns = .true.
      else
        lgCautns = .false.
      endif
*
      if( lgTalk ) then
        write(qq,'(3x,a74)') chTitle(2:75)
        call reageo( qq )
        call warnot( qq )
        call caunot( qq )
        call bangot( qq )
        call noteot( qq )
      endif
*
*     option to print warnings on special io
      if( lgPrnErr ) call warnot( ioPrnErr )
*
      end
******************************************************************************
      subroutine codriv
      implicit none
*main driver for heavy molecular equilibrium routines
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgLotsCO
*flag saying that there is lots of CO, triggers lgEndFun stopping model
      common/lotsco/ lgLotsCO
      logical lgComNeg
*flag saying some molecular abundances were negative
      common/comneg/ lgComNeg
      real COLimit
*limit to ratio CO/Total carbon, used to stop fully molecular
*models
      common/colimt/ COLimit
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgNegPop , lgZerPop
      integer loop , lupmax
      real ohold , coToler
*
      save loop , ohold
      parameter (coToler=0.10 , lupmax=10)
*
      ohold = oh
      call comole( lgNegPop , lgZerPop )
      call molav( 1 )
*     >>chng 97 july 29, turn on flag for too much CO here too, there were
*     models in which this test never took place since oh went zero
      if( oh.eq.0. ) then
        if( co/xIonFracs(6,0).gt.COLimit ) lgLotsCO = .true.
        return
      endif
      loop = 1
      do while((abs(ohold/oh-1.).gt.coToler .or. lgNegPop) .and.
     1 (loop.lt.lupmax) .and. (co/xIonFracs(6,0).lt.COLimit)  )
         call molav(2)
         ohold = oh
         call comole( lgNegPop , lgZerPop )
         if( oh.eq.0. ) return
         loop = loop + 1
      end do
*
      if( co/xIonFracs(6,0).gt.COLimit ) then
        lgLotsCO = .true.
      else if( lgNegPop ) then
        lgLotsCO = .true.
        write(qq,'('' CODRIV failed to converge, zone='',I4,
     1  '', CO/C='',1P,E10.2,'' negpop?'',L1)')nzone,
     2  co/xIonFracs(6,0),lgNegPop
        lgNegPop = .false.
      else if( loop.eq.lupmax ) then
        write(qq,'('' CODRIV failed to converge, zone='',I4,
     1  '', CO/C='',1P,E10.2,'' negpop?'',L1)')nzone,
     2  co/xIonFracs(6,0),lgNegPop
      endif
*
      if( lgNegPop ) lgComNeg = .true.
*
      end
******************************************************************************
      subroutine comole( lgNegPop , lgZerPop )
      implicit none
*fills in matrix for heavy elements molecular routines
      logical lgNegPop , lgZerPop
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real saha
*     saha is ( h^2/2/pi/m/k )^1.5
      parameter (saha=4.14157e-16)
*     SAHA is ( h^2/2/pi/m/k )^1.5, is correct constant for free electron
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real CarMolFrac
*largest fraction of carbon that went molecular
      common/cmfrac/ CarMolFrac
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real hi , hii
      common/h/ hi , hii
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgTrMole
*flag set with trace molecules command
      common/trmole/ lgTrMole
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgNoMole
*flag to turn off molecules
      common/nomole/ lgNoMole
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real te , eden , hden
      common/phycon/ te , eden , hden
      real catmic , oatmic
      common/coatom/ catmic , oatmic
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real chk,chpk,ohk,ohpk,otwok,ctwok,cok,copk,h2ok,h2opk,
     1 o2pk,c2pk,h3pk,h3opk,ch2pk,ch2k,ch3k,cpk
      common/hevcol/ chk,chpk,ohk,ohpk,otwok,ctwok,cok,copk,h2ok,h2opk,
     1 o2pk,c2pk,h3pk,h3opk,ch2pk,ch2k,ch3k,cpk
      logical lgDriveMole
*flag set when drive molecule command entered
      common/moldrv/ lgDriveMole
      real GammaHabing
*UV flux relative to Habing value, used for some photodissociation rates
      common/ghabng/ GammaHabing
      logical lgH2Ozer
*flag set true if H2O destruction rate went to zero
      common/h2ozer/ lgH2Ozer
      real CODissHeat , codfrc , codtot
*CODissHeat is CO Photodissociation heating
      common/codish/ CODissHeat , codfrc , codtot
      real COVibCool, dCOVdT
*cooling due to rotational excit fo CO, and its deriv
      common/covib/ COVibCool, dCOVdT
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nmole
      parameter (nmole=15)
      double precision c(nmole+1,nmole+1)
      real csav(nmole,nmole)
      logical lgEOL
      character*4 chLab(nmole)
      character*80 chCard
*
      integer ioatm,ich,ichp,ioh,iohp,ich2p,icp,icatm,j,i ,loop
      integer ico,icop,ih2o,ih2op,ih3op,io2,io2p , merror
*
      real po2lte,expo2,pc2lte,expc2,chplte,expchp,pcolte,
     1 expco,coplte,sexp,h2lim,fread,fac,expcop,cartot,oxytot,
     2 chchp,choco ,h2pchp,h3pchp,cpchp,
     3 chph,chpe,chohwa,chch2,ch2ph3,ch2pch,wachoh,coch,cch,
     4 chhchp,chhc,chooh,hmrate,chphch,ohohp,ohcop,ohco,oho2,
     5 oho,oh2wat,ohohwa,o2oh,ohpoh,cooh,waoh,wa2oh,wapoh,
     6 waph3p,e3opoh , h3pwap,ohprm,ohpwap,waohp,wapohp,ratio,
     7 opohp,oohp,h3pohp,ohph3p,o2o2p,o2rm,o2cop,o2co,co2co,coo2,ho2p
      real eo2o,cocp,cocn,phodco,copco,h3pcop,coprm,wacop,ch2pco,
     1 wawap,wapwa,h3oh3p,wah3op,h3opwa,e3opwa,h3pwai,waprm,
     2 cocop,waiwai,h3owai,ch2pc,crden , cf , cpch2p
*
*     free statement labels >=13
*
      call molav( 1 )
*999  continue
      loop = 0
      do while( lgDriveMole.or.(loop.lt.1 ) )
      loop = loop + 1
      if( lgDriveMole ) then
*       option to allow user to enter oh abundances
        write(qq,'('' enter log of OH abundance'')')
        read(5,'(a80)') chCard
        i = 1
*       option to set OH here
        fac = fread( chCard , i , 76 , lgEOL )
        if( fac.eq.1. ) then
           return
        else if( fac.eq.0. ) then
           call molav(2)
        else
           oh = 10.** fac
        endif
        write(qq,'('' enter log of H2O abundance'')')
        read(5,'(a80)') chCard
        i = 1
*       option to set H2O here
        fac = fread( chCard , i , 76 , lgEOL )
        if( fac.ne.0. ) h2o = 10.** fac
      endif
*
      ctwo = 0.
      c2p = 0.
      otwo = 0.
      o2p = 0.
      h3p = 0.
*
*     H2LIM is smallest ratio of H2/HDEN for which we will
*     even try to invert heavy element network
      h2lim=1e-4
      if( lgNoMole .or. te.gt.3800. .or. htwo/hden.lt.h2lim
     1  .or. xIonFracs(6,1)*xIonFracs(8,1).eq.0. ) then
        catmic = xIonFracs(6,1)
        oatmic = xIonFracs(8,1)
        ch = 0.
        chp = 0.
        oh = 0.
        ohp = 0.
        otwo = 0.
        co = 0.
        cop = 0.
        h2o = 0.
        h2op = 0.
        o2p = 0.
        c2p = 0.
        h3op = 0.
        ch2p = 0.
        ch2 = 0.
        ch3 = 0.
        cp = 0.
*       heating due to CO photodissociation
        heating(1,10) = 0.
        COVibCool = 0.
        dCOVdT = 0.
        CODissHeat = 0.
        return
      endif
*     call PrtMolDif('init',0)
*
*     dissociation energies;
*     CO 11.09, CO+ 8.3eV, CH+ 3.8eV
*     LTE population of CO+
      expcop = sexp(9.632e4 /te )
      if( expcop.gt.0. ) then
         coplte = saha / (te32*expcop) * (1. / ( 6.*9. ) )
      else
         coplte = 0.
      endif
*
      expco = sexp( 1.287e5 / te )
      if( expco.gt.0. ) then
         pcolte = saha / (te32*expco ) * (1./(9.*9.))
      else
         pcolte = 0.
      endif
*
      expchp = sexp( 4.4098e4 / te )
      if( expchp.gt.0. ) then
         chplte = saha / (te32*expchp ) * (1./(1.*6.))
      else
         chplte = 0.
      endif
*
      expc2 = sexp( 4.4098e4 / te )
      if( expc2.gt.0. ) then
         pc2lte = saha / (te32*expc2 ) * (1./(9.*9.))
      else
         pc2lte = 0.
      endif
*
      expo2 = sexp( 4.4098e4 / te )
      if( expo2.gt.0. ) then
         po2lte = saha / (te32*expo2 ) * (3./(9.*9.))
      else
         po2lte = 0.
      endif
*
*     molecule formation
*
      do i=1,nmole
        c(i,nmole+1) = 0.
        do j=1,nmole
          c(i,j) = 0.
        end do
      end do
*
*     set up pointers
      icatm = 1
      chLab(icatm) = 'C   '
      ioatm = 2
      chLab(ioatm) = 'O   '
      ich = 3
      chLab(ich) = 'CH  '
      ichp = 4
      chLab(ichp) = 'CH+ '
      ioh = 5
      chLab(ioh) = 'OH  '
      iohp = 6
      chLab(iohp) = 'OH+ '
      ich2p = 7
      chLab(ich2p) = 'CH2+'
      icp = 8
      chLab(icp) = 'C+  '
      ico = 9
      chLab(ico) = 'CO  '
      icop = 10
      chLab(icop) = 'CO+ '
      ih2o = 11
      chLab(ih2o) = 'H2O '
      ih2op = 12
      chLab(ih2op) = 'H2O+'
      ih3op = 13
      chLab(ih3op) = 'H3O+'
      io2 = 14
      chLab(io2) = 'O2  '
      io2p = 15
      chLab(io2p) = 'O2+ '
*
*     carbon conservation
      cartot = 0.
      do i=3,7
        cartot = cartot + xIonFracs(6,i)
      end do
      cartot = xIonFracs(6,0) - cartot
      c(icatm,nmole+1) = cartot
*
*     oxygen conservation
      if( oatmic.eq.0. ) oatmic = xIonFracs(8,1)
      oxytot = 0.
      do i=2,9
        oxytot = oxytot + xIonFracs(8,i)
      end do
      oxytot = xIonFracs(8,0) - oxytot
      c(ioatm,nmole+1) = oxytot
*
*--------------------------------------------------------------------
*
*     first equation is carbon conservation
      c(icatm,icatm) = 1.
      c(icatm,ioatm) = 0.
      c(icatm,ich) = 1.
      c(icatm,ichp) = 1.
      c(icatm,ioh) = 0.
      c(icatm,iohp) = 0.
      c(icatm,io2) = 0.
      c(icatm,io2p) = 0.
      c(icatm,ico) = 1.
      c(icatm,icop) = 1.
      c(icatm,ih2o) = 0.
      c(icatm,ih2op) = 0.
      c(icatm,ih3op) = 0.
      c(icatm,ich2p) = 1.
      c(icatm,icp) = 1.
*
*--------------------------------------------------------------------
*
*     second equation is oxygen conservation
      c(ioatm,icatm) = 0.
      c(ioatm,ioatm) = 1.
      c(ioatm,ich) = 0.
      c(ioatm,ichp) = 0.
      c(ioatm,ioh) = 1.
      c(ioatm,iohp) = 1.
      c(ioatm,io2) = 2.
      c(ioatm,io2p) = 2.
      c(ioatm,ico) = 1.
      c(ioatm,icop) = 1.
      c(ioatm,ih2o) = 1.
      c(ioatm,ih2op) = 1.
      c(ioatm,ih3op) = 1.
      c(ioatm,ich2p) = 0.
      c(ioatm,icp) = 0.
*
*--------------------------------------------------------------------
*
*     balance equations;
*     (1,n) is C, called ICATM
*     (2,n) is O, called IOATM
*     (3,n) is CH, called ICH
*     (4,n) is CHP, called ICHP
*     (5,n) is OH, called IOH
*     (6,n) is OHP, called IOHP
*     (7,n) is CH2P, called ICH2P
*     (8,n) is CP, called ICP
*     (9,n) is CO, called ICO
*     (10,n) is COP, called ICOP
*     (11,n) is H2O, called IH2O
*     (12,n) is H2OP, called IH2OP
*     (13,n) is H3OP, called IH3OP
*     (14,n) is OTWO, IO2
*     (15,n) is O2P, called IO2P
*
*--------------------------------------------------------------------
*
*     CH balance equations
*
*     sum of CH + HII => ch+ and both H+ and Ho
*     also electrons to 2e
      chchp = hmrate( 8.83e-14,0.5, 1.29e5 )*(hii+hi+htwo) +
     1 1.90e-9*hii +
     1 hmrate( 5.2e-10 , 0.5 , 1.50e5 )*eden
      c(ich,ich) = c(ich,ich) - chchp
*     o + ch => co + h
      choco = hmrate( 9.53e-11 , 0.5 , 0. ) * oatmic
      c(ich,ich) = c(ich,ich) - choco
*     O + CH => C + OH
      chooh = hmrate( 1.73e-11 , 0.50 , 4000. ) * oatmic
      c(ich,ich) = c(ich,ich) - chooh
*     CH + H => C + H2
      chhc = hmrate( 1.80e-11 , 0.50 , 4000. ) * hi
*     there is no carbon balance equation
      c(ich,ich) = c(ich,ich) - chhc
*     CH + H => CH+ + H + e
      chhchp = hmrate( 8.83e-14 , 0.5 , 1.29e5 ) * hi
      c(ich,ich) = c(ich,ich) - chhchp
*     C + H2 => CH + H
      cch = hmrate( 4.50e-11 , 0.5 , 1.56e4 ) * htwo
      c(ich,icatm) = c(ich,icatm) + cch
*     CO + H => CH + O
      coch = hmrate( 9.53e-11,0.5,8.83e4) * hi
      c(ich,ico) = c(ich,ico) + coch
*     H2O + C => CH + OH
      wachoh = hmrate( 1.43e-10, 0.50 , 2.40e4 ) * catmic
      c(ich,ih2o) = c(ich,ih2o) + wachoh
*     e- + CH2+ => CH + H
      ch2pch = hmrate( 2.50e-7 , -0.5 , 0. ) * eden
      c(ich,ich2p) = c(ich,ich2p) + ch2pch
*     H2 + CH2+ => CH + H3+
      ch2ph3 = hmrate( 1.20e-9 , 0. , 4.22e4 ) * htwo
      c(ich,ich2p) = c(ich,ich2p) + ch2ph3
*     CH + H2 => CH2 + H
      chch2 = hmrate( 3.60e-10 , 0. , 3.90e3 ) * htwo
      c(ich,ich) = c(ich,ich) - chch2
*     OH + CH => H2O + C
      chohwa = 1e-10 * oh
      c(ich,ich) = c(ich,ich) - chohwa
*
*--------------------------------------------------------------------
*
*     CH+ balance equation
*
*     CH+ + e => C + H
      chpe = hmrate( 3.00e-7 , -0.40 , 0. ) * eden
      c(ichp,ichp) = c(ichp,ichp) - chpe
*     CH+ + H => H2 + C+
      chph = hmrate( 6.00e-10 , -0.25 , 0. ) * hi
      c(ichp,ichp) = c(ichp,ichp) - chph
*     make CH+ from CH via collisions with protons and electrons, H
      c(ichp,ich) = c(ichp,ich) + chchp + chhchp
*     H2 + C+ => H + CH+
      cpchp = hmrate(2.00e-10,0.,4640. ) * htwo
      c(ichp,icp) = c(ichp,icp) + cpchp
*     C + H3+ => H2 + CH+
      h3pchp = 2.00e-9 * h3plus
      c(ichp,icatm) = c(ichp,icatm) + h3pchp
*     H + CH2+ => H2 + CH+
      h2pchp = hmrate( 1.00e-9 , 0. , 1.20e4 ) * hi
      c(ichp,ich2p) = c(ichp,ich2p) + h2pchp
*     H2 + CH+ => H + CH2+
      chphch = 1.00e-9 * htwo
      c(ichp,ichp) = c(ichp,ichp) - chphch
*
*--------------------------------------------------------------------
*
*     OH balance equations
*
*     various processes which change OH to OH+
      ohohp = 2.10e-10*hii + hmrate(8.83e-14,0.5,1.53e5 )*(hii+hi+htwo)+
     1 7.60e-10*h2plus + hmrate(5.20e-10,0.5,1.5e5 )*eden
      c(ioh,ioh) = c(ioh,ioh) - ohohp
*     this is first major step to making CO
*     OH + C+ => H + CO+
      ohcop = 7.70e-10 * cp
      c(ioh,ioh) = c(ioh,ioh) - ohcop
*     OH + CH => H2O + C
      chohwa = 1e-10 * ch
      c(ioh,ioh) = c(ioh,ioh) - chohwa
*     C + OH => CO + H
      ohco = hmrate( 1.11e-10 , 0.5 , 0. ) * catmic
      c(ioh,ioh) = c(ioh,ioh) - ohco
*     O + OH => O2 + H
      oho2 = hmrate( 4.33e-11 , -0.5, 30.0 )* oatmic
      c(ioh,ioh) = c(ioh,ioh) - oho2
*     OH + H => O + H2
      oho = hmrate( 6.60e-13 , 1.53 , 2970. ) * hi
*     this is really OH + cr => O + H, enhance from Gredel et al. ApJ 347, 289
      oho = oho + csupra * 500.
      c(ioh,ioh) = c(ioh,ioh) - oho
*     two ways to make water, H2 and OH
*     first is OH + H2 => H2O + H
      oh2wat = hmrate( 8.80e-13,1.95,1420. ) * htwo
*     second is OH + OH => H2O + O
      ohohwa =  hmrate( 4.20e-12 , 0. , 242. ) * oh
      c(ioh,ioh) = c(ioh,ioh) - oh2wat - ohohwa*2.
*     O2 + H => OH + O
      o2oh = hmrate( 1.63e-9 , -0.9 , 8750. ) * hi
      c(ioh,io2) = c(ioh,io2) + o2oh
*     OH+ + stuff goes to OH
      ohpoh = hmrate( 2.10e-9 , 0. , 2800. )*hi +
     1 hmrate( 7.60e-10 , 0. , 2.36e4 ) * htwo
      c(ioh,iohp) = c(ioh,iohp) + ohpoh
*     O + CH => C + OH
      c(ioh,ich) = c(ioh,ich) + chooh
*     CO + H => C + OH
      cooh = hmrate( 1.11e-10,0.5, 7.77e4)*hi
      c(ioh,ico) = c(ioh,ico) + cooh
*     water into OH
      waoh = 2.03e-10*heii + hmrate(9.20e-9,-0.5,6.96e4)*eden +
     1 hmrate( 7.44e-12,1.57,9140. ) * hi
      c(ioh,ih2o) = c(ioh,ih2o) + waoh
*     H2O + O => OH + OH
      wa2oh = hmrate( 1.35e-12 , 1.75 , 7860. ) * oatmic
      c(ioh,ih2o) = c(ioh,ih2o) + wa2oh*2.
*     H2O + C => CH + OH
      c(ioh,ih2o) = c(ioh,ih2o) + wachoh
*     ionized water into OH
      wapoh = hmrate(7.60e-10,0.,4e4)*hi +
     1 hmrate(1.30e-9,0.,2.03e4)*htwo +hmrate(2e-7,-0.5,0.)*eden
      c(ioh,ih2op) = c(ioh,ih2op) + wapoh
*     H2 + H2O+ => OH + H3+
      waph3p = hmrate(1.30e-9 , 0. , 2.03e4 ) * htwo
      c(ioh,ih2op) = c(ioh,ih2op) + waph3p
*     e- + H3O+ => OH + H3
      e3opoh = hmrate( 3.00e-7 , -0.5 , 0. ) * eden
      c(ioh,ih3op) = c(ioh,ih3op) + e3opoh
*     OH + H3P => H2 + H2O+
      h3pwap = 1.0e-9 * h3plus
      c(ioh,ioh) = c(ioh,ioh) - h3pwap
*
*--------------------------------------------------------------------
*
*     OH+ balance equations
*
*     following remove OH+ from network
*     both collide with H, go to H2 or H2+
      ohprm = hmrate(1.60e-9,0.,2.26e4)*hi +
     1 hmrate( 4.90e-10,-0.03, 1970. ) * hi +
     2 hmrate( 2.00e-7 , -0.5 , 0. ) * eden
      c(iohp,iohp) = c(iohp,iohp) - ohprm
*     OH+ + H => OH + H+ and OH+ + H2 => OH + H2+
      c(iohp,iohp) = c(iohp,iohp) - ohpoh
*     h2 + oh+ => h + h2o+
      ohpwap = 1.10e-9 * htwo
      c(iohp,iohp) = c(iohp,iohp) - ohpwap
*     several processes converting OH into OH+
      c(iohp,ioh) = c(iohp,ioh) + ohohp
*     water into OH+
      waohp = 2.86e-10*heii
      c(iohp,ih2o) = c(iohp,ih2o) + waohp
*     H + H2O+ => H2 + OH+
      wapohp = hmrate( 1.70e-9 , 0.29 , 1.40e4 ) * hi
      c(iohp,ih2op) = c(iohp,ih2op) + wapohp
*     O+ + H2 => H + OH+
      if( xIonFracs(8,2).gt.0. ) then
         ratio = xIonFracs(8,2) / xIonFracs(8,1)
         opohp = 1.60e-9*ratio*htwo
         c(iohp,ioatm) = c(iohp,ioatm) + opohp
      endif
*     O + H2+ => H + OH+
      oohp = 1.50e-9 * h2plus
      c(iohp,ioatm) = c(iohp,ioatm) + oohp
*     O + H3P => H2 + OHP
      h3pohp = 8.00e-10*h3plus
      c(iohp,ioatm) = c(iohp,ioatm) + h3pohp
*     H2 + OH+ => O + H3P
      ohph3p = hmrate( 8.00e-10 , 0. , 2900. ) * htwo
      c(iohp,iohp) = c(iohp,iohp) - ohph3p
*
*--------------------------------------------------------------------
*
*     O2 balance equation
*
*     reactions that remove O2 from network
      o2o2p = 1.20e-9*hii + hmrate( 2.37e-15, 1.04 , 1.40e5 )*hii +
     1 2.70e-9*h2plus + hmrate( 1.40e-11,1.04,1.40e5 )*eden +
     2 hmrate( 2.37e-15,1.04,1.40e5 ) * ( hi  + htwo )
      c(io2,io2) = c(io2,io2) - o2o2p
      o2rm = 1.10e-9*heii +  hmrate( 2.30e-9,-0.5, 6.96e4 ) * eden
*     cr destruction with enhancement from Gredel et al.
      o2rm = o2rm + csupra * 730.
      c(io2,io2) = c(io2,io2) - o2rm
*     O2 + C+ => O + CO+
      o2cop = 3.76e-10 * cp
      c(io2,io2) = c(io2,io2) - o2cop
*     O2 + C+ => CO + O+
      o2co = 6.14e-10 * cp
      c(io2,io2) = c(io2,io2) - o2co
*     C + O2 => CO + O
      co2co =  hmrate( 1.80e-11,0.5,0.)*catmic
      c(io2,io2) = c(io2,io2) - co2co
*     O2 + H => OH + O
      c(io2,io2) = c(io2,io2) - o2oh
*     o + oh => o2 + h
      c(io2,ioh) = c(io2,ioh) + oho2
*     o + co => c + o2
      coo2 = hmrate( 2.90e-11,0.5,6.93e4 ) * oatmic
      c(io2,ico) = c(io2,ico) + coo2
*     h + o2+ => o2 + h+
      ho2p = hmrate( 2.80e-10 , -0.04 , 1.78e4 ) * hi
      c(io2,io2p) = c(io2,io2p) + ho2p
*
*--------------------------------------------------------------------
*
*     O2+ balance
*
*     e + O2+ => O + O
      eo2o = hmrate( 2.00e-7 , -0.5 , 0. ) * eden
      c(io2p,io2p) = c(io2p,io2p) - eo2o
*     H + O2+ => O2 + H+
      c(io2p,io2p) = c(io2p,io2p) - ho2p
*     various processes creating O2+ from O2
      c(io2p,io2) = c(io2p,io2) + o2o2p
*
*------------------------------------------------------------------
*
*     CO balance equation carbon monoxide
*
*     CO + H+ => H + CO+, also CO + H+ => CO+ +
      cocop = hmrate( 1.90e-10,0.,4660.) * hii +
     1 hmrate( 1.13e-13,0.6,1.63e5 ) * (hii+hi+htwo) +
     2 2.80e-9*h2plus + hmrate(6.70e-10,0.6,1.63e5)*eden
      c(ico,ico) = c(ico,ico) - cocop
*     co + hE+ => o + c+ + hE
      cocp = 1.70e-9 * heii * 1.1
      c(ico,ico) = c(ico,ico) - cocp
*     CO + e => C + O  + e
      cocn = hmrate(8.1e-10,-0.50, 1.14e5)*eden
*     estra factor is enhancement due to light
      cocn = cocn + csupra*20.
      c(ico,ico) = c(ico,ico) - cocn
*     CO + hnu => C + O, from Teilens and Hollenback, Table 5
      phodco = GammaHabing * 1.4e-11
      c(ico,ico) = c(ico,ico) - phodco
*     O + CO => C + O2
      c(ico,ico) = c(ico,ico) - coo2
*     CO + H => C + OH
      c(ico,ico) = c(ico,ico) - cooh
*     CO + H => CH + O
      c(ico,ico) = c(ico,ico) - coch
*     O + CH => CO + H
      c(ico,ich) = c(ico,ich) + choco
*     C + OH => CO + H
      c(ico,ioh) = c(ico,ioh) + ohco
*     O2 + C+ => CO + O+
      o2co = 6.14e-10 * otwo
      c(ico,icp) = c(ico,icp) + o2co
*     C + O2 => CO + O
      c(ico,io2) = c(ico,io2) + co2co
*     CO+ + H => CO + H+
      copco = 1.90e-10 * hi
      c(ico,icop) = c(ico,icop) + copco
*     CO + H3+ => H2 + CO+
      h3pcop = 1.70e-9 * h3plus
      c(ico,ico) = c(ico,ico) - h3pcop
*666  write(QQ,'('' dest co: '',1p,10e10.2)') c(ico,ico),
*    1 -phodco/c(ico,ico), -cocp/c(ico,ico) , -h3pcop/c(ico,ico),
*    2 -cocop/c(ico,ico) , -cocn/c(ico,ico) , -coo2/c(ico,ico) ,
*    3 -cooh/c(ico,ico) , -coch/c(ico,ico)
*
*--------------------------------------------------------------------
*
*     CO+ balance equation
*
*     e + CO+ => C + O
      coprm = hmrate(1.80e-7 , -0.5 , 0. ) * eden
      c(icop,icop) = c(icop,icop) - coprm
*     CO+ + H => CO + H+
      c(icop,icop) = c(icop,icop) - copco
*     co + h+ => h + co+, ALSO co + h+ => co+ +
      c(icop,ico) = c(icop,ico) + cocop
*     OH + C+ => H + CO+
      ohcop = 7.70e-10 * oh
      c(icop,icp) = c(icop,icp) + ohcop
*     H2O + C+ => H2 + CO+
      wacop = 2.70e-9 * cp
      c(icop,ih2o) = c(icop,ih2o) + wacop
*     CO + H3+ => H2 + CO+
      c(icop,ico) = c(icop,ico) + h3pcop
*     o + ch2+ => h + co+
      ch2pco = 7.50e-10 * oatmic
      c(icop,ich2p) = c(icop,ich2p) + ch2pco
*     O2 + C+ => O + CO+
      o2cop = 3.76e-10 * cp
      c(icop,io2) = c(icop,io2) + o2cop
*
*--------------------------------------------------------------------
*
*     water H2O balance
*
*     processes converting wat to wap
      wawap = 8.20e-9*hii +hmrate(7.55e-14,0.45,1.47e5)*(hi+htwo+hii) +
     1 3.90e-9*h2plus  + hmrate(4.40e-10,0.45,1.47e5)*eden +
     2 6.05e-11 * heii
      c(ih2o,ih2o) = c(ih2o,ih2o) - wawap
*     h2o => oh+
      c(ih2o,ih2o) = c(ih2o,ih2o) - waohp
*     water into OH
      c(ih2o,ih2o) = c(ih2o,ih2o) - waoh
*     H2O + C => CH + OH
      c(ih2o,ih2o) = c(ih2o,ih2o) - wachoh
*     H2O + O => OH + OH
      c(ih2o,ih2o) = c(ih2o,ih2o) - wa2oh
*     h2o + c+ => h2 + co+
      c(ih2o,ih2o) = c(ih2o,ih2o) - wacop
      if(c(ih2o,ih2o).eq.0.) then
*       possible for zero water destruction, this is an error
        c(ih2o,ih2o) = -1e-35
        lgH2Ozer = .true.
      endif
*     end of water destruction mechanisms
*     CH + OH => H2O + C
      chohwa = 1e-10 * oh
      c(ih2o,ich) = c(ih2o,ich) + chohwa
*     OH + stuff => water
      c(ih2o,ioh) = c(ih2o,ioh) + oh2wat + ohohwa
*     ionized water into water
      wapwa = hmrate(8.20e-9,0.,1.15e4)*hi +
     1 hmrate(3.90e-9,0.,3.27e4)*htwo
      c(ih2o,ih2op) = c(ih2o,ih2op) + wapwa
*     H2 + H3O => H2O + H3+
      h3oh3p = hmrate( 5.90e-9 , 0. , 3.28e4 ) * htwo
      c(ih2o,ih3op) = c(ih2o,ih3op) + h3oh3p
*     H2O + H2+ => H + H3O+
      wah3op = 3.40e-9 * h2plus
      c(ih2o,ih2o) = c(ih2o,ih2o) - wah3op
*     H + H3O+ => H2O + H2+
      h3opwa = hmrate( 5.90e-9 , 0. , 3.28e4 ) * htwo
      c(ih2o,ih3op) = c(ih2o,ih3op) + h3opwa
*     e- + H3O+ => H2O + H
      e3opwa = hmrate( 1.00e-6 , -0.5 , 0. ) * eden
      c(ih2o,ih3op) = c(ih2o,ih3op) + e3opwa
*     H2O + H3P => H2 + H3OP
      h3pwai = 5.90e-9 * h3plus
      c(ih2o,ih2o) = c(ih2o,ih2o) - h3pwai
*
*--------------------------------------------------------------------
*     H2O+ balance
*
*     removes ionized water from network
      waprm = hmrate( 2e-7,-0.5,0.) * eden
      c(ih2op,ih2op) = c(ih2op,ih2op) - waprm
*     H + H2O+ => H2 + OH+
      c(ih2op,ih2op) = c(ih2op,ih2op) - wapohp
*     ionized water into water
      c(ih2op,ih2op) = c(ih2op,ih2op) - wapwa
*     ionized water into OH
      c(ih2op,ih2op) = c(ih2op,ih2op) - wapoh
*     H2 + OH+ => H + H2O
      c(ih2op,iohp) = c(ih2op,iohp) + ohpwap
*     processes converting wat to wap
      c(ih2op,ih2o) = c(ih2op,ih2o) + wawap
*     OH + H3P => H2 + H2O+
      h3pwap = 1.0e-9 * h3plus
      c(ih2op,ioh) = c(ih2op,ioh) + h3pwap
*     H2 + H2O+ => OH + H3+
      c(ih2op,ih2op) = c(ih2op,ih2op) - waph3p
*     H2 + H2O+ => H + H3O+
      waiwai = 6.10e-10 * htwo
      c(ih2op,ih2op) = c(ih2op,ih2op) - waiwai
*     H + H3O+ => H2 + H2O+
      h3owai = hmrate( 6.00e-9 , 0.390 , 1.98e4 ) * hi
      c(ih2op,ih3op) = c(ih2op,ih3op) + h3owai
*
*--------------------------------------------------------------------
*     H3O+ balance
*     H2O + H3P => H2 + H3OP
      c(ih3op,ih2o) = c(ih3op,ih2o) + h3pwai
*     H2 + H3O+ => H2O + H3+
      c(ih3op,ih3op) = c(ih3op,ih3op) - h3oh3p
*     H2O + H2+ => H + H3O+
      c(ih3op,ih2o) = c(ih3op,ih2o) + wah3op
*     H2 + H2O+ => H + H3O+
      c(ih3op,ih2op) = c(ih3op,ih2op) + waiwai
*     H + H3O+ => H2 + H2O+
      c(ih3op,ih3op) = c(ih3op,ih3op) - h3owai
*     H + H3O+ => H2O + H2+
      c(ih3op,ih3op) = c(ih3op,ih3op) - h3opwa
*     e- + H3O+ => H2O + H
      c(ih3op,ih3op) = c(ih3op,ih3op) - e3opwa
*     e- + H3O+ => OH + H3
      c(ih3op,ih3op) = c(ih3op,ih3op) - e3opoh
*
*--------------------------------------------------------------------
*     CH2+ balance
*     e- + CH2+ => C + H2, there is no carbon balance eqn
      ch2pc = hmrate( 2.50e-7 , -0.5 , 0. ) * eden
      c(ich2p,ich2p) = c(ich2p,ich2p) - ch2pc
*     e- + CH2+ => CH + H
      c(ich2p,ich2p) = c(ich2p,ich2p) - ch2pch
*     H + CH2+ => H2 + CH+
      c(ich2p,ich2p) = c(ich2p,ich2p) - h2pchp
*     H2 + CH2+ => CH + H3+
      c(ich2p,ich2p) = c(ich2p,ich2p) - ch2ph3
*     O + CH2+ => H + CO+
      c(ich2p,ich2p) = c(ich2p,ich2p) - ch2pco
*     H2 + C+ => CH2+
      cpch2p = hmrate( 4.00e-16 , -0.20 , 0. ) * htwo
      c(ich2p,icp) = c(ich2p,icp) + cpch2p
*     H2 + CH+ => H + CH2+
      c(ich2p,ichp) = c(ich2p,ichp) + chphch
*
*--------------------------------------------------------------------
*     C+ balance
*     atomic processes changing C+ into Co, calculated in car bal
      c(icp,icp) = c(icp,icp) - create(6,1)
*     atomic processes changing Co into C+, calculated in car bal
      c(icp,icatm) = c(icp,icatm) + destroy(6,1)
*     CO + He+ => C + C+ + He
      c(icp,ico) = c(icp,ico) + cocp
*     H2 + C+ => H + CH+
      c(icp,icp) = c(icp,icp) - cpchp
*     H2 + C+ => CH2+
      c(icp,icp) = c(icp,icp) - cpch2p
*     OH + C+ => H + CO+
      ohcop = 7.70e-10 * oh
      c(icp,icp) = c(icp,icp) - ohcop
*     CH+ + H => H2 + C+
      c(icp,ichp) = c(icp,ichp) + chph
*     O2 + C+ => O + CO+
      o2cop = 3.76e-10 * otwo
      c(icp,icp) = c(icp,icp) - o2cop
*     O2 + C+ => CO + O+
      o2co = 6.14e-10 * otwo
      c(icp,icp) = c(icp,icp) - o2co
*
*--------------------------------------------------------------------
*
      if( lgTrace.and.lgTrMole ) then
         write(qq,'('' COMOLE matrix''/9X,14(2X,A4,3X))') (chLab(i),i=1,
     1   min(nmole,8))
         do j=1,nmole
           write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),(c(j,i),i=1,
     1     min(nmole,8))
         end do
*
         if( nmole.ge.9 ) then
           write(qq,'('' COMOLE matrix''/9X,14(2X,A4,3X))')(chLab(i),
     1     i=9, nmole)
           do j=1,nmole
             write(qq,'(1X,A4,1X,1P,14E9.1)')chLab(j),(c(j,i),i=9,nmole)
           end do
         endif
         write(qq,'('' COMOLE H2 den:'',1P,E10.3,'', H2,3+='',2E9.2,
     1   '' Carb sum='',E10.3,
     1   '' Oxy sum='',E10.3)') htwo , h2plus, h3plus, c(icatm,nmole+1),
     2   c(ioatm,nmole+1)
      endif
*
*     invert matrix
      do i=1,nmole
        do j=1,nmole
          csav(i,j) = c(i,j)
        end do
      end do
*
      call matin1(c,nmole+1,nmole,1,merror)
      if( merror.ne.0 ) then
        write(qq,'('' COMOLE matrix inversion error, MERROR='',
     1  i5,'' zone='',i5)') merror, nzone
        call ShowMe
        write(qq,'('' Product matrix''/9X,14(2X,A4,3X))')(chLab(i),i=1,
     1  min(nmole,8))
        do j=1,nmole
          write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),
     1    (csav(j,i)*c(i,nmole+1),i=1,min(nmole,8) )
        end do
        if( nmole.ge.9 ) then
          write(qq,'('' COMOLE matrix''/9X,14(2X,A4,3X))')(chLab(i),i=9
     1    ,nmole)
          do j=1,nmole
            write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),
     1      (csav(j,i)*c(i,nmole+1),i=9,nmole)
          end do
        endif
        write(qq,'('' Molecular densities relative to H2''/
     1  1P,8(1X,A4,'':'',E10.2)/8(1X,A4,'':'',E10.2))')
     2  (chLab(j),c(j,nmole+1),j=1,nmole)
        stop
      endif
*
      if( lgTrace.and.lgTrMole ) then
        write(qq,'('' Product matrix''/9X,14(2X,A4,3X))')(chLab(i),i=1,
     1  min(nmole,8))
        do j=1,nmole
          write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),
     1    (csav(j,i)*c(i,nmole+1),i=1,min(nmole,8) )
        end do
*
        if( nmole.ge.9 ) then
          write(qq,'('' COMOLE matrix''/9X,14(2X,A4,3X))')(chLab(i),i=9
     1    ,nmole)
          do j=1,nmole
            write(qq,'(1X,A4,1X,1P,14E9.1)') chLab(j),
     1      (csav(j,i)*c(i,nmole+1),i=9,nmole)
          end do
        endif
        write(qq,'('' Molecular densities relative to H2''/
     1  1P,8(1X,A4,'':'',E10.2)/8(1X,A4,'':'',E10.2))')
     2  (chLab(j),c(j,nmole+1),j=1,nmole)
      endif
*
*     (1,n) is C atomic
      catmic = c(icatm,nmole+1)
*     (2,n) is O atomic
      oatmic = c(ioatm,nmole+1)
*     (3,n) is CH
      ch = c(ich,nmole+1)
*     (4,n) is CHP
      chp = c(ichp,nmole+1)
*     (5,n) is OH
      oh = c(ioh,nmole+1)
*     (6,n) is OHP
      ohp = c(iohp,nmole+1)
*     (9,n) is CO
      co = c(ico,nmole+1)
*     (10,n) is COP
      cop = c(icop,nmole+1)
*     (11,n) is H2O
      h2o = c(ih2o,nmole+1)
*     (12,n) is H2OP
      h2op = c(ih2op,nmole+1)
*     (14,n) is H3OP
      h3op = c(ih3op,nmole+1)
*     (15,n) is CH2P
      ch2p = c(ich2p,nmole+1)
*     (16,n) is CP
      cp = c(icp,nmole+1)
*     (7,n) is OTWO
      otwo = c(io2,nmole+1)
*     (8,n) is O2P
      o2p = c(io2p,nmole+1)
*
*     rememeber largest fraction of carbon in molecules
      cf = (ch + chp + co + cop + ch2p ) / xIonFracs(6,0)
      CarMolFrac = max( CarMolFrac , cf )
*     call PrtMolDif('prnt',66)
*
*     heating due to CO photodissociation
      CODissHeat = phodco * co * 1e-12
*666  write(6,'('' codish phodco, GammaHabing'',1p,3e10.2)') CODissHeat,
*    1 phodco , GammaHabing
      heating(1,10) = CODissHeat
*
*     cooling due to coll excit of vib-rot levels
*     from Hollenbach and McKee 1979
      crden = 1.9e3 * sqrte
*     this is their cooling coefficent, per H2, and CO
      COVibCool = 1.94e-23 * te * te /(htwo+crden+1.5*(htwo*crden)**0.5)
*     this is total cooling per unit vol
      COVibCool = COVibCool * htwo * co * 0.3
*     its derivative
      dCOVdT = COVibCool *2./te
*
      lgNegPop = .false.
      lgZerPop = .false.
      if( catmic.le.0. ) then
         if(catmic.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
         catmic = abs( catmic/2. )
         if( co.gt.ch ) then
            co = max( co/2. , co-catmic )
         else
            ch = max( ch/2. , ch-catmic )
         endif
      endif
      if( oatmic.le.0. ) then
*        WRITE(QQ,'('' WARNING; O population is negative or 0.'',1P,
*    1   E10.2)') OATMIC
         oatmic = 0.
         if(oatmic.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( ch.le.0. ) then
*        WRITE(QQ,'('' WARNING; CH population is negative or 0.'',1P,
*    1   E10.2)') CH
         ch = -ch/2.
         if(ch.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( chp.le.0. ) then
*        WRITE(QQ,'('' WARNING; CH+ population is negative or 0.'',1P,
*    1   E10.2)') CHP
         chp = -chp / 2.
         if(chp.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( oh.le.0. ) then
*        WRITE(QQ,'('' WARNING; OH population is negative or 0.'',1P,
*    1   E10.2)') OH
         oh = 0.
         if(oh.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( ohp.le.0. ) then
*        WRITE(QQ,'('' WARNING; OH+ population is negative or 0.'',1P,
*    1   E10.2)') OHP
         ohp = 0.
         if(ohp.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
*     IF( OTWO.LE.0. ) THEN
*        WRITE(QQ,'('' WARNING; O2 population is negative or 0.'',1P,
*    1   E10.2)') OTWO
*        OTWO = 0.
*        lgNegPop = .TRUE.
*     ENDIF
*     IF( O2P.LE.0. ) THEN
*        WRITE(QQ,'('' WARNING; O2+ population is negative or 0.'',1P,
*    1   E10.2)') O2P
*        O2P = 0.
*        lgNegPop = .TRUE.
*     ENDIF
      if( co.le.0. ) then
*        WRITE(QQ,'('' WARNING; CO population is negative or 0.'',1P,
*    1   E10.2)') CO
         co = 0.
         if(co.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( cop.le.0. ) then
*        WRITE(QQ,'('' WARNING; CO+ population is negative or 0.'',1P,
*    1   E10.2)') COP
         cop = 0.
         if(cop.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( h2o.le.0. ) then
*        WRITE(QQ,'('' WARNING; H2O population is negative or 0.'',1P,
*    1   E10.2)') H2O
         h2o = 0.
         if(h2o.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( h2op.le.0. ) then
*        WRITE(QQ,'('' WARNING; H2O+ population is negative or 0.'',1P,
*    1   E10.2)') H2OP
         h2op = 0.
         if(h2op.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( h3op.le.0. ) then
*        WRITE(QQ,'('' WARNING; H3O+ population is negative or 0.'',1P,
*    1   E10.2)') H3OP
         h3op = 0.
         if(h3op.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( ch2p.le.0. ) then
*        WRITE(QQ,'('' WARNING; CH2+ population is negative or 0.'',1P,
*    1   E10.2)') CH2P
         ch2p = -ch2p/2.
         if(ch2p.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
      if( cp.le.0. ) then
*        WRITE(QQ,'('' WARNING; C+ population is negative or 0.'',1P,
*    1   E10.2)') CP
         cp = -cp/2.
         if(cp.lt.0.  ) then
            lgNegPop = .true.
         else
            lgZerPop = .true.
         endif
      endif
*
*     if( lgDriveMole ) go to999
*     only continues if modrv set, used to query routines by user
      end do
*
      end
******************************************************************************
      real function hmrate( a , b , c )
      implicit none
*compile molecular rates using Hollenback and Mckee fits
      real a , b , c
      real te , eden , hden
      common/phycon/ te , eden , hden
*
*     local variables
      real cfac , bfac
*
*     function to evaluate Hollenbach and McKee ApJ 342, 306.
*     A is leading coef, B is power temp depen, and C is exponential
*     rate = a * (te/300K)^b * exp(-c/te)
*
      if( c/te.gt.50. ) then
         hmrate = 0.
         return
      endif
*
      if( c.eq.0. ) then
         cfac = 1.
      else
         cfac = exp( -c/te )
      endif
*
      if( b.eq.0. ) then
         bfac = 1.
      else
         bfac = (te/300.) ** b
      endif
*
      hmrate = a * bfac * cfac
*
      end
******************************************************************************
      subroutine molav( ix )
      implicit none
*average old and new molecular equilibrium balance from comole
      integer ix
*
      integer nhevml
      parameter (nhevml=18)
      real hevmol
      common/hevmol/ hevmol(nhevml)
      logical lgTrMole
*flag set with trace molecules command
      common/trmole/ lgTrMole
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real hevsav(nhevml) , damper
      save hevsav
      integer i
*
*     when called with IX=1, set saver
      if( ix.eq.1 ) then
*       this is first call - remember first abundances
        do i=1,nhevml
          hevsav(i) = hevmol(i)
        end do
        if( lgTrace.and.lgTrMole ) then
          write(qq,'(5x,'' MOLAV pop1='',1p,12e9.1)') hevmol
        endif
*
      else if( ix.lt.0 ) then
        do i=1,nhevml
          hevmol(i) = 0.
          hevsav(i) = 0.
        end do
*
      else
*       get new numbers - take average of old and new
        do i=1,nhevml
*         parameter to mix old and new
          damper = 0.2
          hevmol(i) = hevmol(i)*(1.-damper) + hevsav(i)*damper
          hevsav(i) = hevmol(i)
        end do
        if( lgTrace.and.lgTrMole ) then
          write(qq,'(5x,'' MOLAV pop2='',1p,12e9.1)') hevmol
        endif
      endif
*
      end
******************************************************************************
      subroutine PrtMolDif( chJob , io )
      implicit none
*print changes that occurred in the mole abundance in comole
      character chJob*4
      integer io
      integer nhevml
      parameter (nhevml=18)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real hevmol
      common/hevmol/ hevmol(nhevml)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real xMolSav(nhevml)
      save xMolSav
*
      if( chJob.eq.'init' ) then
        do i=1,nhevml
          xMolSav(i) = hevmol(i)
        end do
      else if( chJob.eq.'prnt' ) then
        do i=1,nhevml
          xMolSav(i) = xMolSav(i) / max(1e-25,hevmol(i))
        end do
        write(io,'(i4,18f6.3)') nzone,xMolSav
      else
        write(qq,'('' PrtMolDif gets insane job='',a4)')
        stop
      endif
*
      end
******************************************************************************
      subroutine compos( chCard , lgDSet )
      implicit none
*parse and read in composition as set by abundances command
      character chCard*80
      logical lgDSet
*
      integer limelm
      parameter (limelm=30)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer ipSolar, npSolar
      common/ipSolar/ ipSolar(limelm) , npSolar
      real solar
      common/solar/ solar(limelm)
      real SolarSave , anova , apn , ahii, camern, aprim, aism
      common/solars/ SolarSave(limelm) , anova(limelm) , apn(limelm) ,
     1 ahii(limelm) , camern(limelm) , aprim(limelm) , aism(limelm)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
*
*     local variables
      logical lgEOL , lgMatch , lgLog , lgEOF
      real absav(limelm)
      integer i , j , nd
      real fread  , chk
*
*     free statement labels, >=25
      j = 5
      absav(1) = fread( chCard , j , 76 , lgEOL )
*     check whether it scanned off end of line on first try
*     >>chng 97 june 8, get rid of go to
*     if( lgEOL ) go to10
      if( .not.lgEOL ) then
        absav(2) = fread( chCard , j , 76 , lgEOL )
        if( lgEOL .and.lgMatch(' ALL',chCard)) then
*         special option, all abundances will be this number
          if( absav(1).le.0. ) then
            absav(1) = 10. ** absav(1)
          endif
          do i=2,limelm
            solar(i) = absav(1)
          end do
          return
*     >>chng 97 june 8, get rid of go to
*        else if( lgEOL ) then
*         only one number, but not key ' all', so go to special sets
*          go to10
        endif
*
*     >>chng 95 july 14, get rid of go to's
        if( .not. lgEOL ) then
*         do this is there was a second number
          do i=3,npSolar
            absav(i) = fread( chCard , j , 76 , lgEOL )
            if( lgEOL ) then
*             read CONTINUE line if J scanned off end before reading all abund
              call readar( chCard , lgEOF )
              if( lgEOF ) then
                write(qq,'('' There MUST be'',I3,'' abundances entered''
     1          ,'', there were only'',I3,''.  Sorry.'')') npSolar, i-1
                stop
              endif
*             option to ignore all lines starting with #, *, or %.
              do while ( chCard(1:1).eq.'#' .or. chCard(1:1).eq.'*' .or.
     1        chCard(1:1).eq.'%')
                if( lgEOF ) then
                  write(qq,'('' There MUST be'',I3,'' abundances ''
     1            ,''entered, there were only'',I3,''.  Sorry.'')')
     1            npSolar, i-1
                  stop
                endif
                call readar( chCard , lgEOF )
              end do
*
              if(lgTalk) write(qq,'(23X,''*'',1X,A80,''*'')') chCard
              call caps( chCard )
              if( chCard(1:4).ne.'CONT' ) then
                write(qq,'('' There MUST be'',I3,'' abundances entered''
     1          ,'', there were only'',I3,''.  Sorry.'')') npSolar, i-1
                stop
              else
                j = 1
                absav(i) = fread( chCard , j , 76 , lgEOL )
                if( lgEOF ) then
                  write(qq,'('' There MUST be'',I3,'' abundances ''
     1            ,''entered, there were only'',I3,''.  Sorry.'')')
     2            npSolar, i-1
                  stop
                endif
              endif
            endif
          end do
*
*         fell through to here after reading in abundances
*         check that there are no more - could mean typo further upstream
          chk = fread( chCard , j , 76 , lgEOL )
          if(.not.lgEOL ) then
*           got another number, not lgEOL, so too many numbers
            write(qq,'('' There were more than '',I3,'' abundances '',
     1      ''entered'')') npSolar
            write(qq,'('' Could there have been a typo somewhere?'')')
          endif
*
*         are numbers scale factors, or log of abund rel to H??
          lgLog = .false.
          do i=1,npSolar
            if( absav(i).lt.0. ) lgLog = .true.
          end do
          if( lgLog ) then
*           entered as log of number rel to hydrogen
            do i=1,npSolar
              solar(ipSolar(i)) = 10.**absav(i)
            end do
          else
*           scale factors relative to solar
            do i=1,npSolar
              solar(ipSolar(i)) = solar(ipSolar(i)) * absav(i)
            end do
          endif
*
*         check whether the abundances are reasonable
          if( solar(2).gt.0.2 ) write(qq,'('' Is an abundance of'',1P,
     1    E10.3,'' for '',A2,'' reasonable?'')') solar(2),
     2    chElementSym(2)
          do i=3,limelm
            if( solar(i).gt.0.1 ) write(qq,'('' Is an abundance of'',1P,
     1      E10.3,'' for '',A2,'' reasonable?'')') solar(i),
     1      chElementSym(i)
          end do
          return
        endif
      endif
*
*     no numbers on line if it got this far
* 10   continue
*
*     enter std abundances for various objects
      if( lgMatch('PLAN',chCard) ) then
*       planetary nebular abundances
        if( .not.lgMatch('O GR',chCard) ) then
*         turn on grains if not already done
          if( .not.lgDSet ) then
            lgDustOn = .true.
            do nd=1,ndust
              dstfactor(nd) = 1.
*     >>chng 96 nov 29, loop setting false, followed by two set true
              lgDustOn1(nd) = .false.
            end do
            lgDustOn1(1) = .true.
            lgDustOn1(7) = .true.
          endif
        endif
        do i=1,limelm
          solar(i) = apn(i)
        end do
*
      else if( lgMatch('HII ',chCard).or.lgMatch('H II',chCard)
     1 .or.lgMatch('ORIO',chCard) ) then
*       H II region abundances
        if( .not.lgMatch('O GR',chCard) ) then
*         option to turn on grains
          if( .not.lgDSet ) then
            lgDustOn = .true.
            do nd=1,ndust
              dstfactor(nd) = 1.
*     >>chng 96 nov 29, loop setting false, followed by two set true
              lgDustOn1(nd) = .false.
            end do
*           orion grains
            lgDustOn1(3) = .true.
            lgDustOn1(4) = .true.
          endif
        endif
        do i=1,limelm
          solar(i) = ahii(i)
        end do
*
      else if( lgMatch('ISM ',chCard).or.lgMatch(' ISM',chCard) ) then
*       ISM abundances from Cowie and Songaila Ann Rev '86
        if( .not.lgMatch('O GR',chCard) ) then
          if( .not.lgDSet ) then
            lgDustOn = .true.
            do nd=1,ndust
              dstfactor(nd) = 1.
              lgDustOn1(nd) = .false.
*     >>chng 96 nov 29, loop setting false, followed by two set true
            end do
*           ism grains
            lgDustOn1(1) = .true.
            lgDustOn1(2) = .true.
          endif
        endif
        do i=1,limelm
          solar(i) = aism(i)
        end do
*
      else if( lgMatch('NOVA',chCard) ) then
*       Nova Cyg abundances
        do i=1,limelm
          solar(i) = anova(i)
        end do
*
      else if( lgMatch('STAR',chCard) ) then
*       Fred Hamonn's starburst galaxy mixture
        call strbst( chCard )
*
      else if( lgMatch('PRIM',chCard) ) then
*       roughly primordial abundances: He/H=.072
        do i=1,limelm
          solar(i) = aprim(i)
        end do
*       now turn off the heavy elements
        do i=5,limelm
          lgElmtOn(i) = .false.
        end do
*
      else if( lgMatch('CAME',chCard) ) then
*       mix from Cameron 1982, "Essays on Nuclear Astrophysics"
        do i=1,limelm
          solar(i) = camern(i)
        end do
*
      else
        write(qq,'('' ABUND must have PLAN, H II, CAMERON, NOVA, NLR,''
     1  ,'' ALL, STARBURST or PRIMORDIAL.  Sorry.'')')
        stop
      endif
*
      end
*****************************************************************
      subroutine ConcatRauch
      implicit none
*K Volk's routine to compact the 57 Rauch atmospheres into a large ascii file.
* As the wavelengths are always the same only the fluxes
* will be written to the output file.
*
* Before running this program issue the following command where the Rauch
* model atmosphere files are kept (050000_50.wf and so on)
*
*   ls *.wf > files.list
*
* and check to see that there are 57 lines in the file.
*
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real wl
      character*12 chFName
      integer ierr , i , j
      integer nfile
      parameter (nfile=57)
      character*12 chFile(nfile)
      data chFile/
     1 '050000_50.wf', '050000_60.wf', '050000_70.wf', '050000_80.wf',
     2 '060000_50.wf', '060000_60.wf', '060000_70.wf', '060000_80.wf',
     3 '070000_50.wf', '070000_60.wf', '070000_70.wf', '070000_80.wf',
     4 '080000_50.wf', '080000_60.wf', '080000_70.wf', '080000_80.wf',
     5 '090000_50.wf', '090000_60.wf', '090000_70.wf', '090000_80.wf',
     6 '100000_50.wf', '100000_60.wf', '100000_70.wf', '100000_80.wf',
     7 '110000_60.wf', '110000_70.wf', '110000_80.wf', '120000_60.wf',
     8 '120000_70.wf', '120000_80.wf', '130000_60.wf', '130000_70.wf',
     9 '130000_80.wf', '140000_60.wf', '140000_70.wf', '140000_80.wf',
     1 '150000_60.wf', '150000_70.wf', '150000_80.wf', '160000_60.wf',
     2 '160000_70.wf', '160000_80.wf', '170000_60.wf', '170000_70.wf',
     3 '170000_80.wf', '180000_60.wf', '180000_70.wf', '180000_80.wf',
     4 '190000_60.wf', '190000_70.wf', '190000_80.wf', '200000_70.wf',
     5 '200000_80.wf', '300000_70.wf', '300000_80.wf', '400000_80.wf',
     6 '500000_80.wf'/
*
      write(qq,'(''ConcatRauch on the job.  This will take a while.'')')
*
*     converted to above list of files
*     open(unit=01,file='files.list',status='old',iostat=ierr)
*     if( ierr.ne.0 ) then
*       write(qq,'('' ConcatRauch could not open list '',
*    1  ''file files.list'')')
*       stop
*     endif
      open(unit=02,file='rauch.ascii', status='new',iostat=ierr)
      if( ierr.ne.0 ) then
        write(qq,'('' ConcatRauch could not open stars '',
     1  ''file rauch.ascii'')')
        write(qq,'('' Make sure there is not already a file with '',
     1  ''this name.'')')
        stop
      endif
*
      do i=1,nfile
        write(qq,'('' star'',i3,1x,a12)') i, chFile(i)
*       get file name from list of star files
*       read(01,'(a12)',iostat=ierr) chFName
*       if( ierr.ne.0 ) then
*         write(qq,'('' ConcatRauch could not read stellar '',
*    1    ''atmosphile names '',i4)') i
*         stop
*       endif
*       open(unit=07,file=chFName,status='old',iostat=ierr)
        open(unit=07,file=chFile(i),status='old',iostat=ierr)
        if( ierr.ne.0 ) then
          write(qq,'('' ConcatRauch could not open stellar '',
     1    ''atmosphile file '',i4,'' name='',a12)') i,chFile(i)
          stop
        endif
*
        do j=1,33
*         throw away the header information
          read(07,'(a1)',iostat=ierr) chFName(1:1)
          if( ierr.ne.0 ) then
            write(qq,'('' ConcatRauch error in header '',
     1      ''atmosphile file '',2i4)') i,j
            stop
          endif
        end do
*
        do j=1,19951
          read(07,'(f6.1,e10.3)',iostat=ierr) wl,OpacStack(j)
          if( ierr.ne.0 ) then
            write(qq,'('' ConcatRauch error in getting '',
     1      ''fluxes, file, nflux '',2i4,'' name='',a12)') i,j,chFile(i)
            stop
          endif
        end do
*
        close(07)
*
        write(02,'(1p9e9.3)') (OpacStack(j),j=1,19951)
      end do
*
      close(02)
*
      stop
      end
******************************************************************************
      real function cone2( t )
      implicit none
*generate e2 function needed for continuum transport
      real tln, t
*
*     local variables
      real remain
      if( t.lt.80. ) then
        tln = exp(-t)
      else
        cone2 = 0.
        return
      endif
*
*     fit of second exponential integral;
*     T is optical depth, and TLN is exp(-t)
*
      if( t.lt.0.3 ) then
        remain = (1.998069357+t*(66.4037741+t*107.2041376)) /
     1  (1.+t*(37.4009646+t*105.0388805))
*
      else if( t.lt.20. ) then
        remain = (1.823707708+t*2.395042899)/
     1  (1.+t*(2.488885899-t*0.00430538))
*
      else
        remain = 1.
      endif
*
      cone2 = remain * tln / (2.+t)
*
      end
******************************************************************************
      real function conesc(x)
      implicit none
*one of the forms of the continuum escape probability
      real x , cone2
*
      real ContTkt , ctau
*variables used to pass continuum optical depth and temp to
*routine that integrates over continuum
      common/chnukt/ ContTkt , ctau
*
      conesc = exp(-ContTkt*(x-1.)) / x * cone2(ctau/x/x/x)
*
      end
*****************************************
      real function conpmp( tarray )
      implicit none
*local continuum pumping rate radiative transfer for all lines
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
*
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real pmpdmp
      common/pmpdmp/ pmpdmp
      real pmptau
      common/pmptau/ pmptau
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      external opfun
*
*     local variables
      real break , y1,y2 , tau
      parameter (break=3.)
      real fitted,t , a0
*
*     fit to results for tau less than 10
      fitted(t) = (0.98925439 + 0.084594094 *t) /
     1  (1.+t*(0.64794212+t*0.44743976))
*
      if( .not. lgFluor ) then
*       option to turn of continuum pumping with no fluorescense
        conpmp = 0.
      else
*       tau used will be optical depth in center of next zone
*     >>chng 96 july 6, had been ipLnTauIn, did not work when sphere static set
        tau = tarray(ipLnTauCon) + tarray(ipLnDTau)*dRNeff
*       compute pumping probability
        if( tau.le.10. ) then
*         for tau<10 a does not matter, and one fit for all
          conpmp = fitted(tau)
        else if( tau.gt. 1e6 ) then
*         this far in winds line opacity well below electron scattering
*         so ignore for this problem
          conpmp = 0.
        else
*         following two are passed on to later subs
          if( tarray(ipLnRedis).gt.0. ) then
            pmpdmp = tarray(ipLnDamp)
          else
            pmpdmp = 0.
          endif
          pmptau = tau
          a0 = 0.886227 * (1. + pmpdmp)
          call qg32 (0., break, opfun, y1)
          call qg32 (break, 100., opfun, y2)
          conpmp = (y1+y2)/a0
        endif
      endif
*
*     EscProb is escape probability, will not allow conpmp to be greater than it
*     on second iteration with thick lines, pump prob=1 and esc=0.5
*     conpmp = min( conpmp , tarray(ipLnEscP) )
*
      end
******************************************************************************
      real function conrec(x)
      implicit none
*one of the forms of the continuum escape probability
      real x
      real ContTkt , ctau
*variables used to pass continuum optical depth and temp to
*routine that integrates over continuum
      common/chnukt/ ContTkt , ctau
*
      conrec = exp(-ContTkt*(x-1.)) / x
*
      end
******************************************************************************
      subroutine constn( chCard )
      implicit none
*parse parameters from the 'constant ...' command
      character chCard*80
*
      integer limpar
      parameter (limpar=20)
      integer limext
      parameter (limext=5)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      real prspow
      common/prspow/ prspow
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      logical lgConPres
*flag saying whether or not incident continuum should be included
*in total pressure, turned off with constant gas pressure
      common/conprs/ lgConPres
      integer nvary , nparm
      common/nvary/ nvary , nparm
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      logical lgEOL , lgMatch
      real fread
      integer i
*
      if( lgMatch( 'TEMP', chCard ) ) then
*       force a constant temperature model
        lgTSetOn = .true.
        i = 5
        ForceTemp = fread( chCard , i , 76 , lgEOL )
        if(.not.lgMatch( 'LINE' , chCard ) ) then
          if( ForceTemp.le.10. ) ForceTemp = 10. ** ForceTemp
        endif
        if( lgEOL ) then
          write(qq,'('' There should be a number here, sorry.'')')
          stop
        endif
        if( ForceTemp.lt.3. ) then
          write(qq,'('' TE<3K, reset to 3K.'')')
          ForceTemp = 3.
        endif
        te = ForceTemp
*       vary option
        if( lgVarOn ) then
           nparm = nparm + 1
*          no luminosity options on vary
           nvarxt(nparm) = 1
           chVarFmt(nparm) = '(''CONStant TEMP'',F15.5)'
*          pointer to where to write
           nvfpnt(nparm) = nRead
*          log of temp will be pointer
           vparm(nparm,1) = log10( te )
           vincr(nparm) = 0.1
        endif
*
*     constant density
      else if( lgMatch( 'DENS',chCard) ) then
        chCPres = 'CDEN'
*       turn off radiation pressure
        lgRadPresON = .false.
*
      else if( lgMatch('PRES',chCard) ) then
*       constant pressure
        chCPres = 'CPRE'
        if( lgMatch(' GAS',chCard) ) then
*          constant gas pressure (no radiation)
*          turn off radiation pressure
           lgRadPresON = .false.
*          turn off incident continuum
           lgConPres = .false.
*          optional second number is power law index
           i = 4
           prspow = fread( chCard , i , 76 , lgEOL )
        else
*          constant total pressure, gas+rad+incident continuum
*          turn on radiation pressure
           lgRadPresON = .true.
*          option to turn off continuum pressure
           if( lgMatch('O CO', chCard ) ) then
             lgConPres = .false.
           else
              lgConPres = .true.
           endif
*          no power law option for constant total pressure
           prspow = 0.
        endif
*
      else
*       no keys were recognized
        write(qq,'('' The keyword should be TEMPerature, DENSity, GAS''
     1  ,'' or PRESsure, sorry.'')')
        stop
      endif
*
      end
******************************************************************************
      subroutine conorm
      implicit none
*normalize continuum to proper intensity
      real fr1ryd
*     frequency of 1 rydberg
*     FR1RYD is frequency for 912
      parameter (fr1ryd=3.28805E15)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real SpeedLight
*from Physics Today Aug '96, BG 10
      parameter (SpeedLight=2.99792458E10 )
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real emm , egamry
      common/bounds/ emm , egamry
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      real range
      common/range/ range(limspc,2)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , ip , ipoint
      real ar1 , diff , flx1,ffun1,f, qentrd , qintr,pentrd,pintr,
     1 flx2
*
      ar1 = log10( radius )
*
*     this is a sanity check, it can't happen
      do i=1,nspec
        if( chRSpec(i).eq.'UNKN' ) then
          write(qq,'('' UNKN spectral normalization cannot happen.'')')
          write(qq,'('' CONORM punts.'')')
          stop
        else if( chRSpec(i).ne.'SQCM'.and. chRSpec(i).ne.'4 PI' ) then
          write(qq,'('' chRSpec must be SQCM or 4 PI, and it was '',A4,
     1    ''.  This cannot happen.'')') chRSpec(i)
          write(qq,'('' CONORM punts.'')')
          stop
        endif
*
*       this sanity check makes sure that atlas.mod or werner.mod grids
*       are for the current version of the code
        if( chSpType(i).eq.'VOLK' ) then
          ip = ipoint( 9.5 )
          diff = abs(tnu(i,ip)-anu(ip)) / anu(ip)
          if( diff.gt.0.001 ) then
            write(qq,'(1p,2e10.2)') anu(ip) , tnu(i,ip)
            write(qq,'('' CONORM: The energy grid of the stellar '',
     1      ''atmosphere file does not agree with the grid in this '',
     2      ''version of the code.'')')
            write(qq,'('' A stellar atmosphere grid from an old '',
     2      ''version of the code is probably in place.'')')
            write(qq,'('' A grid for the current version of Cloudy '',
     1      ''must be generated and used.'')')
            write(qq,'('' This is done with the COMPILE STARS '',
     1      ''command.'')')
            write(qq,'('' Sorry.'')')
            stop
          endif
        endif
      end do
*
*     default is intensities, but luminosity of any would override
*     following two values are correct for intensities
      pirsq = 0.
      lgFourPi = .false.
*     check whether ANY luminosities are present
      do i=1,nspec
        if( chRSpec(i).eq.'4 PI' ) then
          pirsq = 1.0992099 + 2.*ar1
          lgFourPi = .true.
*         convert down to intensity
          totpow(i) = totpow(i) - pirsq
          if(lgTrace)write(qq,'('' CONORM converts continuum'',I3,
     1    '' from luminosity to intensity.'')') i
        endif
      end do
*
*     convert any ionization parameters to q(h)
      do i=1,nspec
        if( chSpNorm(i).eq.'IONI' ) then
          totpow(i) = totpow(i) + log10(hden) + log10(SpeedLight)
          chSpNorm(i) = 'Q(H)'
          if(lgTrace)write(qq,'('' CONORM converts continuum'',i3,
     1    '' from ionizat par to q(h).'')') i
        endif
      end do
*
      if( lgTrace ) then
        if( lgFourPi ) then
          write(qq,'('' Cloudy will predict lumin into 4pi'')')
        else
          write(qq,'('' Cloudy will do surface flux for lumin'')')
        endif
      endif
*
*     if intensity per unit area is predicted then geometric
*     covering factor must be unity
*     variable can also be set elsewhere
      if( .not.lgFourPi ) then
        covgeo = 1.
      endif
*
*     main loop to find continuum normalization starts here
      do i=1,nspec
        ipspec = i
        if( lgTrace ) write(qq,'('' CONORM continuum number'',I3,
     1  '' is shape '',A5,'' range is '',1P,2E11.2)') i,chSpType(i),
     2  range(i,1),range(i,2)
*
        if( chSpNorm(i).eq.'RATI' ) then
*         option to scale relative to previous continua
*         this must come first since otherwise may be too late
*         BUT ratio cannot be the first continuum source
          if( lgTrace ) then
            write(qq,'('' CONORM this is ratio to 1st con'')')
          endif
*         check that this is not the first continuum source, we must ratio
          if(i.le.1) then
            write(qq,'('' I cant form a ratio if continuum is first '',
     1      ''source.'')')
            stop
          endif
*
*         first find photon flux and Q of prevous continuum
          ipspec = ipspec - 1
          flx1 = ffun1( range(i,1) ) * spfac( ipspec ) * range(i,1)
*         check that previous continua were not zero where ratio is formed
          if(flx1.le.0. ) then
            write(qq,'('' Previous continua were zero where ratio is '',
     1      ''desired.'')')
            stop
          endif
*
*         return pointer to previous (correct) value, find F, Q
          ipspec = ipspec + 1
*         we want a continuum totpow as powerful, flx is now desired flx
          flx1 = flx1 * totpow(i)
*.        find flux of this new continuum at that point
          flx2 = ffun1( range(i,2) ) * range(i,2)
*         this is ratio of desired to actual
          spfac(i) = flx1 / flx2
          if( lgTrace ) then
            write(qq,'('' CONORM ratio will set scale fac to''
     1      ,1P,E10.3,'' at'',E10.2,'' Ryd.'')') totpow(i) , range(i,1)
          endif
*
        else if( chSpNorm(i).eq.'FLUX' ) then
*         specify flux density
*         option to use arbitrary frequency or range
          f = log10( max(1e-37,ffun1( range(i,1)) ) ) +
     1    log10( range(i,1)*en1ryd/fr1ryd )
          f = ( totpow(i) - f )
*     >>chng 96 dec 31, added following test
          if( lgBit32 ) then
            if( f.gt.35. ) then
              write(qq,'('' Continuum source'',i3,'' is too intense'',
     1        '' for this cpu - is it normalized correctly?'')')i
              stop
            endif
          endif
          spfac(i) = 10.** f
          if( lgTrace ) then
            write(qq,'('' CONORM will set log fnu to'',1P,E10.3,
     1      '' at'',E10.2,'' Ryd.  Factor='',E11.4)')
     2      totpow(i) , range(i,1) , spfac(i)
          end if
*
        else if( chSpNorm(i).eq.'Q(H)' .or. chSpNorm(i).eq.'PHI ' ) then
*         some type of photon density entered
          qentrd = qintr( range(i,1) , range(i,2) )
          diff = (totpow(i) - qentrd )
          if( lgBit32.and.(diff.lt.-25. .or. diff.gt.35.) ) then
            write(qq,'('' Continuum source specified is too extreme'',
     1      '' for a 32 bit cps.'')')
            stop
          else
            spfac(i) = 10.**diff
          endif
          if(lgTrace) write(qq,'('' CONORM finds Q over '',
     1    ''range from'',1p,e11.4,''-'',E11.4,'' Ryd, Factor='',
     2    e11.4)')
     4    range(i,1) , range(i,2) , spfac(i)
*
        else if( chSpNorm(i).eq.'LUMI' ) then
*         luminosity entered, special since default is TOTAL lumin
          pentrd = pintr( range(i,1) , range(i,2) ) + log10(en1ryd)
          f = totpow(i) - pentrd
*     >>chng 96 dec 31, added following test
          if( lgBit32 ) then
            if( f.gt.35. ) then
              write(qq,'('' Continuum source'',i3,'' is too intense'',
     1        '' for this cpu - is it normalized correctly?'')')i
              stop
            endif
          endif
          spfac(i) = 10.** f
          if(lgTrace) write(qq,'('' CONORM finds luminosity '',
     1    ''range is'',1P,E10.3,'' to '',E9.3,'' Ryd, factor is'',
     2    E11.4)')
     4    range(i,1) , range(i,2) , spfac(i)
        else
          write(qq,'('' What chSpNorm label is this?'',A4)')chSpNorm
          stop
        endif
*
*       sec part after .or. added June 93 because sometimes spfac=0
*       got past first test
        if( 1./spfac(i) .eq.0. .or.  spfac(i).eq.0. ) then
          write(qq,'('' CONORM finds infinite continuum scale '',
     1    ''factor.'')')
          write(qq,'('' The continuum is too intense to compute with''
     1    ,'' this cpu.'')')
          write(qq,'('' Were the intensity and luminosity commands'',
     1    ''switched??'')')
          write(qq,'('' Cloudy punts.  Sorry.'')')
          stop
        endif
      end do
*
      end
******************************************************************************
      real function qintr( enlo , enhi )
      implicit none
*integrates Q for any continuum between two limits, used for normalization
      real enlo , enhi
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real widflx
      common/widflx/ widflx(ncell)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real skip
      parameter (skip=2.)
      logical lgMore
      external ffun1
      real sum , fsum , wanu , wfun, ffun1,en1,en2,piece
      integer i , j , ipoint , ip , ipLo , ipHi
*
      real aweigh(4) , fweigh(4)
      data  aweigh(1)/-0.4305682/ , aweigh(2)/-0.1699905/ ,
     1      aweigh(3)/+0.1699905/ , aweigh(4)/+0.4305682/ ,
     2      fweigh(1)/+0.1739274/ , fweigh(2)/+0.3260726/ ,
     3      fweigh(3)/+0.3260726/ , fweigh(4)/+0.1739274/
*
*     returns LOG of number of photons over energy interval
      sum = 0.
      if( chSpType(ipspec).eq.'LASER' ) then
*        laser is special since delta function
         ip = ipoint( slope(ipspec) )
         do i= ip-20, ip+20
            fsum = 0.
            do j=1,4
               wanu = anu(i) + widflx(i)*aweigh(j)
               wfun = fweigh(j) * ffun1( wanu )
               fsum = fsum + wfun
            end do
            sum = sum + fsum * widflx(i)
         end do
      else if( chSpType(ipspec).eq.'INTER' ) then
*       interpolate is special since might be very chaotic
        ipLo = ipoint( enlo )
        ipHi = ipoint( enhi )
        sum = 0.
        do i=ipLo,ipHi
          sum = sum + ffun1( anu(i) ) * widflx(i)
        end do
      else
*       rest of cases should be smooth enough to just add up
        lgMore = .true.
        en1 = enlo / skip
        do while( lgMore )
          en1 = en1 * skip
          en2 = en1 * skip
          if( en2.ge.enhi ) then
            en2 = enhi
            lgMore = .false.
          endif
          call qg32( en1 , en2 , ffun1 , piece )
          sum = sum + piece
        end do
      endif
*
      if( sum.le.0. ) then
        write(qq,'('' Photon number sum in QINTR is'',1P,E10.3)') sum
        write(qq,'('' This source has no ionizing radiation, and the'',
     1  '' number of ionizing photons was specified.'')')
        write(qq,'('' This was continuum source number'',i3)') ipspec
        write(qq,'('' Sorry, but I cannot go on.  ANU and FLUX '',
     1  ''arrays follow.  Enjoy.'')')
        write(qq,'(1P,2E10.2)') (anu(i),flux(i),i=1,ncell)
        stop
      else
        qintr = log10( sum )
      endif
*
      end
******************************************************************************
      real function pintr( enlo , enhi )
      implicit none
*integrates L for any continuum between two limits, used for normalization
      real enlo , enhi
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      real widflx
      common/widflx/ widflx(ncell)
      character chSpType*5
      common/sptype/ chSpType(limspc)
*
*     local variables
      real skip
      parameter (skip=2.)
      logical lgMore
      external pow1
      real sum , fsum , wanu , pow1,en1,en2,piece, wfun , ffun1
      integer i , j , ip , ipoint
*
      real aweigh(4) , fweigh(4)
      data  aweigh(1)/-0.4305682/ , aweigh(2)/-0.1699905/ ,
     1      aweigh(3)/+0.1699905/ , aweigh(4)/+0.4305682/ ,
     2      fweigh(1)/+0.1739274/ , fweigh(2)/+0.3260726/ ,
     3      fweigh(3)/+0.3260726/ , fweigh(4)/+0.1739274/
*
*     computes log of luminosity in radiation over some intergal
*     answer is in Ryd per sec
*
      sum = 0.
      if( chSpType(ipspec).eq.'LASER' ) then
*       laser is special since delta function
        ip = ipoint( slope(ipspec) )
        do i= ip-20, ip+20
          fsum = 0.
          do j=1,4
            wanu = anu(i) + widflx(i)*aweigh(j)
            wfun = fweigh(j) * ffun1( wanu ) * wanu
            fsum = fsum + wfun
          end do
          sum = sum + fsum * widflx(i)
        end do
*
      else
        lgMore = .true.
        en1 = enlo / skip
        do while(lgMore)
          en1 = en1 * skip
          en2 = en1 * skip
          if( en2.ge.enhi ) then
            en2 = enhi
            lgMore = .false.
          endif
          call qg32( en1 , en2 , pow1 , piece )
          sum = sum + piece
        end do
      endif
*
      if( sum.gt.0. ) then
        pintr = log10( sum )
      else
        pintr = -38.
      endif
*
      end
******************************************************************************
      real function pow1( freq )
      implicit none
*evaluate luminosity of continuum
      real freq , ffun1
*
      pow1 = ffun1( freq ) * freq
*
      end
******************************************************************************
      subroutine sumcon( il , ih , q , p , panu )
      implicit none
*sums L and Q for net incident continuum
      integer il , ih
      real q , p , panu
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
*
      integer i , iupper
*
      q = 0.
      p = 0.
      panu = 0.
      iupper = min( nflux , ih )
*
*     n.b. - in F77 loop IS NOT executed when IUPPER < IL
      do i=il,iupper
        q = q + flux(i)
*       EN1RYD is needed to stop overflow
        p = p + flux(i) * (anu(i)*en1ryd)
        panu = panu + flux(i) * (anu2(i)*en1ryd)
      end do
*
      end
******************************************************************************
      real function ffun( anu )
      implicit none
*evaluate total flux for sum of all continuum sources
      real anu
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
*
*     local variables
      real ffun1
      logical lgWarn
      save lgWarn
      data lgWarn/.false./
*
*     FFUN returns the sum of photons per unit time, area, energy,
*     for all continuua in the calculation
*     we loop over all nspec continuum sources - ipspec points to each
*
      ffun = 0.
      do ipspec=1,nspec
        ffun = ffun + ffun1( anu ) * spfac(ipspec)
      end do
*
      if( ffun.gt.1e35 .and. (.not.lgWarn) .and. lgBit32 ) then
        lgWarn = .true.
        write(qq,'('' FFUN:  The net continuum is very intense for'',
     1  '' a 32 bit cpu.'')')
        write(qq,'('' I will try to press on, but may have '',
     1  ''problems.'')')
      endif
*
      end
******************************************************************************
      real function ffun1( xnu )
      implicit none
*derive flux at a specific energy, for one continuum
      real xnu
*
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ConTabRead
*save array for table read command, to save continuum previously punched
      common/cnread/ ConTabRead(ncell)
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      real emm , egamry
      common/bounds/ emm , egamry
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      character chSpType*5
      common/sptype/ chSpType(limspc)
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
*
      real small , big
      parameter (small=1e-25, big=1e10 )
      logical lgWarn
      save lgWarn
*
*     local variables
      character*5 chKey
      real sexp , fac , y
      integer i , j , ipoint
*
      data lgWarn/.false./
*
*     FFUN1 returns photons per unit time, area, energy, for one continuum
*     ipspec is the pointer to the continuum source, in the order
*     entered on the command lines
*
      chKey = chSpType(ipspec)
*
      if( chKey.eq.'AGN  ' ) then
*       power law with cutoff at both ends
*       nomenclature all screwed up - slope is cutoff energy in Ryd,
*       cutoff(i,1) is ratio of two continua from alpha ox
*       cutoff(i,2) is slope of bb temp
        ffun1 = xnu **(-1.+cutoff(ipspec,2) ) * sexp(xnu/slope(ipspec))
     1  * sexp(0.01/xnu)
*       only add on x-ray for energies above 0.1 Ryd
        if( xnu.gt.0.1 ) then
          if( xnu.lt.7350. ) then
*           cutoff is actually normalization constant
*           below 100keV continuum is nu-1
            ffun1 = ffun1 + xnu**(cutoff(ipspec,3)-1.)*cutoff(ipspec,1)*
     1      sexp(1./xnu)
          else
            ffun1 = ffun1 +
     1      7350.**(cutoff(ipspec,3)-1.)*cutoff(ipspec,1)*
     2      (xnu/7350.)**(-3)
          endif
        endif
*
      else if( chKey.eq.'POWER' ) then
*       power law with cutoff at both ends
        ffun1 = xnu **(-1.+slope(ipspec)) *
     1  sexp(  xnu/cutoff(ipspec,1)  +  cutoff(ipspec,2)/xnu  )
*
      else if( chKey.eq.'BLACK' ) then
*       black body
        fac = te1ryd * xnu/slope(ipspec)
        if( fac.ge.80. ) then
          ffun1 = 0.
        else if( fac.lt.80. .and. fac.gt.0.01 )  then
          ffun1 = xnu*xnu/(exp(fac) -1.)
        else
          ffun1 = xnu*xnu / ( fac*(1.+fac/2.) )
        endif
*
      else if( chKey.eq.'INTER' ) then
*       interpolate on input spectrum
        if( xnu.ge.tnu(ipspec,1) ) then
          do i=2,ncell
            j = i - 1
            if( xnu .lt. tnu(ipspec,i) ) then
              y = tfac(ipspec,j) + tslop(ipspec,j) *
     1        log10( xnu/tnu(ipspec,j) )
              ffun1 = (10. ** y) / xnu
              return
            endif
          end do
*         energy above highest in table
          ffun1 = 0.
        else
*         energy below lowest on table
          ffun1 = 0.
        endif
*
      else if( chKey.eq.'BREMS' ) then
*       brems continuum, rough gaunt factor
        fac = te1ryd * xnu / slope(ipspec)
        ffun1 = sexp( fac ) / xnu**1.2
*
      else if( chKey.eq.'LASER' ) then
*       a laser, mostly one frequency
        if(xnu.gt.0.95*slope(ipspec) .and. xnu.lt.1.05*slope(ipspec))
     1  then
          ffun1 = big
        else
          ffun1 = small
        endif
*
      else if( chKey.eq.'READ ' ) then
*       if this is first time called then we need to read in file
        if( tslop(ipspec,1).eq.0. ) then
          call ReadTable( int(tslop(ipspec,2) ) )
          tslop(ipspec,1) = 1.
        endif
*       use array of values read in on TABLE READ command
        if( xnu.ge.egamry ) then
          ffun1 = 0.
        else
          i = ipoint( xnu )
          if( i.gt.nupper.or.i.lt.1 ) then
            ffun1 = 0.
          else
            ffun1 = ConTabRead(i) / anu(i) / anu(i)
          endif
        endif
*
      else if( chKey.eq.'VOLK ' ) then
*       use array of values read in from Kevin Volk's rebinning of
*       large atlas grids
        if( xnu.ge.egamry ) then
           ffun1 = 0.
        else
           i = ipoint( xnu )
           if( i.gt.ncell ) then
             write(qq,'('' Too many points - increase ncell'')')
             write(qq,'('' cell needed='',i4,'' ncell='',i4)')
     1       i , ncell
             stop
           endif
*          change nupper to upper limit of stellar continuum
           if( i.gt.nupper.or.i.lt.1 ) then
              ffun1 = 0.
           else
* bug fixed Jul 9 93: FFUN1 = TSLOP(IPSPEC,I) / ANU(I) / ANU(I)
*             i has value 939
              ffun1 = tslop(ipspec,i) / anu(i)
           endif
        endif
      else
        write(qq,'('' I do not understand continuum label '',A5)')
     1  chKey
        stop
      endif
*
      if( ffun1.gt.1e35 .and. (.not.lgWarn) .and. lgBit32 ) then
        lgWarn = .true.
        write(qq,'('' FFUN1:  Continuum'',i4,'' is very intense for'',
     1  '' a 32 bit cpu.'')') ipspec
        write(qq,'('' I will try to press on, but may have '',
     1  ''problems.'')')
      endif
*
      end
******************************************************************************
      subroutine ContRate( freqm, opacm )
      implicit none
*called by nextdr to find energy of maximum continuum-gas interaction
      real freqm , opacm
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer limelm
      parameter (limelm=30)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real opac
      common/opac/ opac(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real xMaxH , FreqH , OpacH , xMaxSub , FreqSub , OpacSub
*    1 xMaxC , FreqC , OpacC
      integer i , iplow
*
*     in all following changed from anu2 to anu  july 25 95
*
*     find maximum continuum interaction rate
      xMaxSub = 0.
*     do up to carbon photo edge
      do i=2,ipHeavy(6,1)-1
*       this does not have grain opacity since grains totally passive
*       at energies below CI edge
        if( anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden).gt.xMaxSub
     1    ) then
          xMaxSub = anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden)
          FreqSub = anu(i)
          OpacSub = opac(i)-dstab(i)*hden
        endif
      end do
*
*     not every continuum extends beyond C edge-this whole loop can add to zero
*     use total opacity here
*     test is to put in fir continuum if free free heating is important
      if( FreeFreeHeat/htot.gt.0.05 ) then
*       this is pointer to energy where cloud free free optical depth is unity
        iplow = ntff
      else
        iplow = ipHeavy(6,1)
      endif
      do i=iplow,min(nflux,ipHn(1)-1)
        if( anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden).gt.xMaxSub)
     1    then
          xMaxSub = anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden)
          FreqSub = anu(i)
          OpacSub = opac(i)-dstab(i)*hden
        endif
      end do
*
*     not every continuum extends beyond 1 Ryd-this whole loop can add to zero
      xMaxH = 0.
      OpacH = 0.
      FreqH = 0.
      do i=ipHn(1),nflux
        if( anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden).gt.xMaxH)
     1    then
*         xMaxH = anu(i)*flux(i)/widflx(i)*opac(i)
          xMaxH = anu(i)*flux(i)/widflx(i)*(opac(i)-dstab(i)*hden)
          FreqH = anu(i)
          OpacH = opac(i)-dstab(i)*hden
        endif
      end do
*
*     use lyman continuum if its opacity is larger than non-h ion
*666  write(11,'(1p,3e10.2)') freqh,opach,xmaxh,
*    1 freqsub,opacsub,xmaxsub
      if( xMaxSub.lt.1e-30 ) then
*       this happens for laser source - use Lyman continuum
        opacm = OpacH
        freqm = FreqH
      else if( OpacH.gt.OpacSub .and. xMaxH/xMaxSub.gt.1e-10 ) then
*       use Lyman continuum
        opacm = OpacH
        freqm = FreqH
      else
        opacm = OpacSub
        freqm = FreqSub
      endif
*
      if( xMaxH.gt.xMaxSub ) then
        opacm = OpacH
        freqm = FreqH
      else
        opacm = OpacSub
        freqm = FreqSub
      endif
*
*begin sanity check
      if( opacm.le.0. .or. freqm.le.0. ) then
        write(qq,'('' ContRate found non positive interaction, or '',
     1  ''energy.'')')
        write(qq,'('' This is impossible.'')')
        call ShowMe
        stop
      endif
*end sanity check
*
      end
****************************************************************
      subroutine ConvIoniz
      implicit none
*called by ionte and cholup, it calls ionize until converged
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      integer ntry
      common/ntry/ ntry
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      character*10 chInCvgRsn
      common/InCvgRsn/ chInCvgRsn
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer loopi , LoopMax
      real dc
      parameter (LoopMax=10)
*
*     this routine is called by ionte, it calls ionize
*     until it converges
*
      loopi = 0
      lgNewIon = .true.
      lgIonDone = .false.
      chInCvgRsn = ' NONE!!!!!'
*     this is ionization convergence loop
*     keep calling ionize until lgIonDone is true
      do while( .not.lgIonDone .and. loopi.lt.LoopMax )
        if( lgTrConvg .and. nLevTrace.lt.2 ) then
*         cooling has not been evaluated yet
          write(qq,'(''   ConvIoniz ionization loop'',I4,'' Htot:'',
     1    1p,e9.2,'' lgDoPhoto='',l2,'' eden='',e9.2)')
     2    loopi, htot , lgDoPhoto , eden
        endif
        lgIonDone = .true.
        ntry = ntry + 1
        call ionize
*     >>chng 97 mar 27, add following call to coolr
*       reevaluate cooling when far from solution, since some coolants
*       can be powerful heating agents
        if( lgSearch ) call coolr( ctot, dc)
        if( lgTrConvg .and. nLevTrace.lt.2 ) then
          if( lgIonDone ) then
            write(qq,'(''     ConvIoniz ionization converged, heat='',
     1      1p,e9.2,'' Cool='',e9.2)')htot,ctot
          else
            write(qq,'(''     ConvIoniz ionization not converged:''
     1      ,a10)') chInCvgRsn
          endif
        endif
        loopi = loopi + 1
      end do
*
      end
****************************************************************
      subroutine ConvWind
      implicit none
*convert level 2 line parameters and pointers into internal form used by code
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      integer ipWindIon(NWINDLINE), ipWindNelem(NWINDLINE),ipWEtc
*pointers to element and ion, and spectroscopic label, for level 2 lines
      character*4 chWinLab(NWINDLINE)
      common/WindEtc/ ipWindIon , ipWindNelem,ipWEtc , chWinLab
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real glow, gup, energy , gf,zed,xion, xMewe
      character chIonLbl*4
      logical lgFirst
      save lgFirst
*
*     this routine takes the line parameters in the wind block data and sorts
*     them into what is needed for the actual line optical depth arrays
*
      data lgFirst/.true./
*
*     only do this one time
      if( .not.lgFirst ) return
      lgFirst = .false.
*
*     these are the massive set of op lines, with g-bar approx cs
*
*begin sanity check
*     confirm that block data linked in
      if( WindLine(1,1).eq.0. ) then
        write(qq,'('' The block data blckwind does not appear to '',
     1  ''have been linked in.  Was it compiled and linked ok?'')')
        call insane
        stop
      endif
*end sanity check
*
      do i=1,NWINDLINE
*       pull information out of existing data arrays
           zed = WindLine( 1,i)
          xion = WindLine( 2,i)
          glow = WindLine( 3,i)
           gup = WindLine( 4,i)
*          this is gf if positive, A if negative
            gf = WindLine( 5,i)
        energy = WindLine( 6,i)
*       following two in WindEtc common, used in level2
        ipWindIon(i) = xion + 0.0001
        ipWindNelem(i) = zed + 0.0001
        if(gf.lt.0. ) then
*         convert A (=-gf) into real gf
          gf = -gf * gup * 1.499e-8 *(1e4/energy)**2
        endif
        xMewe = WindLine( 7,i)
*begin sanity check
*       negative zed indicated line is to be ignored
        if( zed.eq.0.or. zed.gt.limelm ) then
          write(qq,'('' ConvWind: insane nelem for WindLine.  zed='',
     1    f5.1)') zed
          write(qq,'('' ConvWind: line number is'',i4)') i
          stop
        endif
        if( energy.le.0. ) then
          write(qq,'('' ConvWind: insane energy for WindLine. energy=''
     1    ,1p,e10.2)') energy
          stop
        endif
*       WindLine now has 0.1 for neutral, so foat non-zero but int zero
        if( xMewe.le.0  ) then
          write(qq,'('' ConvWind: insane xMewe type for WindLine.'')')
          stop
        endif
*end sanity check
*       now put into standard format
        WindLine(ipLnWlAng,i) = 1.e8/energy
        WindLine(ipLnGl,i) = glow
        WindLine(ipLnGu,i) = gup
        WindLine(ipLnGF,i) = gf
        WindLine(ipLnPopl,i) = 0.
        WindLine(ipLnPopu,i) = 0.
        WindLine(ipLnEnrWN,i) = energy
        WindLine(ipLnIonStg,i) = xion
        WindLine(ipLnNelem,i) = zed
        WindLine(ipLnRedis,i) = 1.
        WindLine(ipLnCS1,i) = xMewe
*       this will be used by level2
        chWinLab(i) = chIonLbl( WindLine(1,i) )
      end do
      do i=1,NWINDLINE
        if( WindLine(ipLnNelem,i).le.0. .or.
     1    WindLine(ipLnIonStg,i).le.0. ) then
*         >>chng 97 aug 30, this is not used any more
          write(qq,'('' level 2 lines have non-positive ipLnNelem'')')
          stop
*         totally kill of any lines with negative nelem
*         WindLine(ipLnPopl,i) = 0.
*         WindLine(ipLnPopu,i) = 0.
*         WindLine(ipLnPopOpc,i) = 0.
*         WindLine(ipLnInten,i) = 0.
*         WindLine(ipLnCool,i) = 0.
*         WindLine(ipLnNPhots,i) = 0.
*         WindLine(ipLnOTS,i) = 0.
*         WindLine(ipLnAovTOT,i) = 0.
*         WindLine(ipLnColovTOT,i) = 0.
*         WindLine(ipLnHeat,i) = 0.
        endif
      end do
*
      end
******************************************************************************
      subroutine carcol
      implicit none
*evaluate total cooling due to carbon
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer ndfst
      parameter (ndfst=5)
      integer limelm
      parameter (limelm=30)
      integer limLevelN
      parameter (limLevelN=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real c9850,c8727,c3134
      common/coolc/ c9850,c8727,c3134
      real pciexc
      common/pciexc/ pciexc
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real hi , hii
      common/h/ hi , hii
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real r9850
      common/r1335/ r9850
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     subroutine level3( t10,t21,t20)
*
*     local variables
*     real conpmp, damp
      real hdtot,cs01,cs12,cs02,cs13,cs23,a21,a31,cs,
     1 pop3, cs2s2p,cs2s3p,a32 , popup , SaveAbun
*---------------------------------------------------------------------
*     Carbon cooling
*
*     C I 1656, collision strength from transition prob
      call PutCS( 7.3 , t1656 )
      call level2( t1656 )
*
*     C I fine structure lines all data
*     >>refer Tielens, A.G.G., & Hollenbach, D. 1985, ApJ, 291, 722
*     factor in () is their rate coef
*     assume H2 and H are same
      hdtot = hi + htwo
*     electron collisions from
*     >>refer Johnson, C.T., Burke, P.G., Kingston, A.E. 1987, JPhB, 20, 2553
      cs = min( 0.371 , 0.00135*sqrte*te01 )
      cs01 = cs + (1.3e-10* te03*te01 ) / cdsqte * 3. * hdtot
      call PutCS( cs01 , t610 )
      cs = min( 1.02 , 0.0088 * sqrte*te01*te005 )
      cs12 = cs + (7.8e-11* te03  )/cdsqte*hdtot
      call PutCS( cs12 , t370 )
      cs = 0.00448 * sqrte/te10*te03*te005
      cs02 = cs + (2.0e-10* te10/te02 )/cdsqte*hdtot
      call PutCS( cs02 , TauDummy )
      call level3(  t610,t370,TauDummy)
*
*     C I 9850, 8727, A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
      if( xIonFracs(6,1) .gt.0.  .and. te.lt.40000. ) then
        cs12 = 1.156e-4*te*(1.09-7.5e-6*te-2.1e-10*te*te)
        cs13 = 2.8e-3*sqrte
        cs23 = 2.764e-3*sqrte
        a21 = 3.26e-4 * t9830(ipLnEscP)
        a31 = 2.73e-3
        a32 = 0.528 * t8727(ipLnEscP)
* 666 error! change to level3
        c8727 = pop3( 9.,5.,1., cs12,cs13,cs23 , a21,a31,a32 ,
     1  1.417e4,1.255e4,pciexc,xIonFracs(6,1),0.) * a32 * 2.28E-12
*       >>chng get rid of carb()
*    1  1.417e4,1.255e4,pciexc,carb(1),0.) * a32 * 2.28E-12
        t9830(ipLnPopOpc) = xIonFracs(6,1)
        t9830(ipLnPopl) = xIonFracs(6,1)
        t9830(ipLnPopu) = 0.
        t9830(ipLnCS) = cs12
        t8727(ipLnPopOpc) = c8727 / (a32*2.28E-12)
        t8727(ipLnPopl) = c8727 / (a32*2.28E-12)
        t8727(ipLnPopu) = 0.
        t8727(ipLnCS) = cs23
        c9850 = pciexc * a21 * 2.02e-12
        dCooldT = dCooldT + c9850 * ( 1.468e4*tsq1 + halfte )
        dCooldT = dCooldT + c8727 * ( 1.255e4*tsq1 + halfte )
*
*       C I 9850 correction for deexcitation, needed for rec line
        r9850 = a21 / (a21 + cs12/5.*8.629e-6/sqrte*eden)
*
      else
        c9850 = 0.
        c8727 = 0.
        r9850 = 0.
        pciexc = 0.
        t9830(ipLnPopOpc) = 0.
        t9830(ipLnPopl) = 0.
        t9830(ipLnPopu) = 0.
        t8727(ipLnPopOpc) = 0.
        t8727(ipLnPopl) = 0.
        t8727(ipLnPopu) = 0.
      endif
      call coladd( 'C  1' ,  8727 , c8727 )
      call coladd( 'C  1' ,  9850 , c9850 )
*
*     C II 158 micron emission, A=
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     CS From
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
*     neutral collision data from
*     >>refer Tielens, A.G.G., & Hollenbach, D. 1985, ApJ, 291, 722
*     >>chng 96aug 01, better fit to cs
      cs = min( 2.20 , 0.403*te20/te02*te001*te001) +
     1 5.8e-10*te02/cdsqte*4.* (hi+htwo)
      call PutCS( cs , t157 )
      call level2( t157 )
*
*     following used for pumping
* 666 error! put all these in cooling
      t386(ipLnPopOpc) = xIonFracs(6,3)
      t386(ipLnPopl) = xIonFracs(6,3)
      t386(ipLnPopu) = 0.
      t310(ipLnPopOpc) = xIonFracs(6,3)
      t310(ipLnPopl) = xIonFracs(6,3)
      t310(ipLnPopu) = 0.
      t291(ipLnPopOpc) = xIonFracs(6,3)
      t291(ipLnPopl) = xIonFracs(6,3)
      t291(ipLnPopu) = 0.
      t280(ipLnPopOpc) = xIonFracs(6,3)
      t280(ipLnPopl) = xIonFracs(6,3)
      t280(ipLnPopu) = 0.
      t274(ipLnPopOpc) = xIonFracs(6,3)
      t274(ipLnPopl) = xIonFracs(6,3)
      t274(ipLnPopu) = 0.
      t270(ipLnPopOpc) = xIonFracs(6,3)
      t270(ipLnPopl) = xIonFracs(6,3)
      t270(ipLnPopu) = 0.
*
*     all collision strengths and A'S from
*     >>refer Lennon, D.J., Dufton, P.L., Hibbert, A., Kingston, A.E. 1985,
*     >>refer ApJ, 294, 200
*     3134=guess
*     CS and trans prob from
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
      call PutCS( 2.51 , t2326 )
      cs = min(6.73 , 2.316*te10 )
      call PutCS( cs , t1335 )
      call PutCS(  5.39 , TauDummy )
*     subroutine level3( t10,t21,t20)
      call level3( t2326,TauDummy, t1335)
*
*     assumed to be optically thin
* 666 error! transfer this line
      c3134 = 0.
*
*     C III  1909
*     A for 1909 itself from
*     >>refer Kwong, V., Fang, Z., Gibbons, T.T., Parkinson, W.H., Smith, P.L.
*     >>refer 1993, ApJ, 411, 431
*     experimental value of 121 is larger than old NS 96, cs from
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
*     BESEQ(CS23,CS24,CS34,tarray,A41)
      cs = min( 1.1 , 2.67 / te10 )
      call PutCS( cs , t1909 )
*     C1909 = BESEQ(.96,.73,2.8 , T1909 ,5.19E-3 )
*     A's
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279 , 1289
      call beseq(.96,.73,2.8 , t1909 ,5.149E-3 )
*     call dumpline( t1909 )
      em1908 = PopLevels(3)*5.19e-3 * 1.04E-11
*
*     CIII 1175 excited state line
*     following were computed by previous call to beseq
      popup = PopLevels(1) + PopLevels(2)+PopLevels(3)
      SaveAbun = xIonFracs(6,3)
      xIonFracs(6,3) = popup
*     cs
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
      cs = min( 30., 4.806*te10*te05/te01/te003 )
      call PutCS( 18.45 , c31175 )
      call level2( c31175 )
      xIonFracs(6,3) = SaveAbun
*
*     C III 977, cs from
*     >>refer Berrington, K.A. 1985, JPhB, 18, L395
      cs = min( 7.0 , 1.556 * te10 )
      call PutCS( cs , t977 )
      call level2( t977 )
*     call DumpLine( t977 )
*
*     CIV 1548, 1550 doublet
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 6 , t1548, t312, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , t1548 )
      call PutCS( cs2s2p*0.5 , t1550 )
      call PutCS(  1.0 , TauDummy )
      call level3( t1550,TauDummy, t1548)
      call PutCS( cs2s3p , t312 )
      call level2( t312 )
*
      end
******************************************************************************
      subroutine nitcol
      implicit none
*evaluate total cooling due to nitrogen
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
      integer limLevelN
      parameter (limLevelN=20)
      integer ndfst
      parameter (ndfst=5)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real c5200, c5755, c6584, c10400,c3466
      common/cooln/ c5200, c5755, c6584, c10400,c3466
      real pfs1 , pfs2
      common/fslev/ pfs1 , pfs2
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
*
*     local variables
      real pop3 , pop2, cs,
     1 cs2s2p,cs2s3p, cs21 , cs31 , cs32 , a21,a31,a32,p3,p2
*
*     following not currently used for cooling
* 666 error! put all these in cooling
      t671(ipLnPopOpc) = xIonFracs(7,2)
      t671(ipLnPopl) = xIonFracs(7,2)
      t671(ipLnPopu) = 0.
      t315(ipLnPopOpc) = xIonFracs(7,3)
      t315(ipLnPopl) = xIonFracs(7,3)
      t315(ipLnPopu) = 0.
      t333(ipLnPopOpc) = xIonFracs(7,3)
      t333(ipLnPopl) = xIonFracs(7,3)
      t333(ipLnPopu) = 0.
      t324(ipLnPopOpc) = xIonFracs(7,3)
      t324(ipLnPopl) = xIonFracs(7,3)
      t324(ipLnPopu) = 0.
*
*     Nitrogen I 5200, CS and A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     trans prob from
*     >>refer Butler, K., & Zeippen, C.J. 1984, A&A, 141, 274
*     collision strengths from
*     >>refer Dopita, M.A., Mason, D.J., Robb, W.D. 1976, ApJ, 207, 102
*
*     N.B. following CS also appears in nitrogen ionization balance
      cs21 = 1.32e-4 * te/(te10*te01)
      cs31 = 3.60e-5 * te/te10*te02
      cs32 = 5.23e-4 * te70*te10/te02
*     following does not have photoionization from excited state
*     since already counted in photo balance equation
* 666 error! use level3
      a21 = 1.28e-5
      a31 = 5.31e-3
      a32 = 6.81e-2
      p3 = pop3(4.,10.,6.,cs21,cs31,cs32,a21,a31,a32,2.769E4,
     1 1.38e4,p2,xIonFracs(7,1),0.)
      c5200 = p2 * a21 * 3.83e-12
      dCooldT = dCooldT + c5200* ( 2.769e4*tsq1 + halfte )
      call coladd( 'N  1' , 5200 , c5200 )
*
      c10400 = p3 * a32 * 1.91e-12
      call coladd( 'N  1' , 10400 , c10400 )
      c3466 = p3 * a31 * 5.74e-12
      dCooldT = dCooldT + (c10400+c3466)* ( 4.15e4 *tsq1 + halfte )
      call coladd( 'N  1' , 3466 , c3466 )
*
*     N I 1200, CS from trans procb
      call PutCS( 4.1 , t1200 )
      call level2( t1200 )
*
*     N II 1084, CS from trans prob
      call PutCS( 5.5 , t1085 )
      call level2( t1085 )
*
*     coll data from
*     >>refer Stafford, R.P., Bell, K.L, Hibbert, A. & Wijesundera, W.P.,
*     >>refer MN 1994 268, 816,
*     at 10,000K (v weak T dep)
*     transit prob from
*     >>refer Nussbaumer, H., & Rusca, C. 1979, A&A, 72, 129
*     As from 96 nist
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      c5755 = pop3( 9.,5.,1., 3.02 ,0.372,0.505 , 3.65E-3,0.0316,1.17 ,
     1 21955. , 24982. , pop2 , xIonFracs(7,2) ,0. ) * 1.17 * 3.46E-12
      c6584 = pop2 * 3.65e-3 * 3.03e-12
      dCooldT = dCooldT + c6584 * ( 2.2e4*tsq1 - halfte )
      call coladd( 'N  2' , 5755 , c5755 )
      call coladd( 'N  2' , 6584 , c6584 )
*
*     N II fine structure lines,
      call PutCS( 0.429 , t205 )
      call PutCS( 1.13 , t122 )
      call PutCS( 0.265 , TauDummy )
      call level3( t205,t122,TauDummy)
*
*     N II 2140, data
*     >>refer Stafford, R.P., Bell, K.L, Hibbert, A. & Wijesundera, W.P. 1994,
*     >>refer MNRAS, 268, 816
*     A from
*     >>refer Brage, T., Hibbert, A., Leckrone, D.S. 1997, ApJ, 478, 423
      call PutCS( 1.15 , t2140 )
      call level2( t2140 )
*
*     N III 1750, cs from
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
*     trans prob from
*     >>refer Stafford, R.P., Hibbert, A., Bell, K.L. 1993, MNRAS, 260, L11
      call PutCS( 2.09 , t1750 )
      call level2( t1750 )
*
*     N III 989.8, CS from
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
      call PutCS( 7.12 , t990 )
      call level2( t990 )
*
*     57 micron N III, A=
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     collision strength from
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
      cs = min(1.90 , 0.2291 * te10 * te10 )
      call PutCS( cs , t57 )
      call level2( t57 )
*     save total populations for 374 optical depth
      t374g(ipLnPopl) = PopLevels(0)
      t374x(ipLnPopl) = PopLevels(1)
      t374g(ipLnPopOpc) = PopLevels(0)
      t374x(ipLnPopOpc) = PopLevels(1)
*
*     N IV 1486, collisions within 3P just guess
*     cs to ground from
*     >>refer Ramsbottom, C.A., Berrington, K.A., Hibbert, A., Bell, K.L. 1994,
*     >>refer PhyS, 50, 246
      if( te.gt.1.584e4 ) then
        cs = 21.346/(te10*te10*te10*te02)
      else
        cs = 75.221 / (sqrte/te03/te02)
      endif
      cs = max( 0.01, cs )
      call PutCS( cs , t1486 )
*     BESEQ(CS23,CS24,CS34,tarray,A41)
      call beseq(.9,.9,3.0,t1486,.0115)
      em1486 = PopLevels(3) * 0.0115 * 1.34e-11
*
*     N IV 765, CS from
*     >>refer Ramsbottom, C.A., Berrington, K.A., Hibbert, A., Bell, K.L. 1994,
*     >>refer PhyS, 50, 246
      cs = min( 4.0, 1.864*te03*te03 )
      call PutCS( cs , t765 )
      call level2( t765 )
*
*     N V 1240
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 7 , t1239, t209, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , t1239 )
      call PutCS( cs2s2p*0.5 , t1243 )
      call PutCS(  1.0 , TauDummy )
      call level3( t1243,TauDummy, t1239)
      call PutCS( cs2s3p , t209 )
      call level2( t209 )
*
      end
******************************************************************************
      subroutine oxycol
      implicit none
*evaluate total cooling due to oxygen
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limLevelN
      parameter (limLevelN=20)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer ndfst
      parameter (ndfst=5)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real c5577, c6300, c3727, c7325, c4363, c5007, fs88, fs52,
     1 coolOi , c6363
      common/coolox/ c5577, c6300, c3727, c7325, c4363, c5007, fs88,
     1 fs52, coolOi , c6363
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real O3730,O3727,O2471,O7323,O7332
      common/oii/ O3730,O3727,O2471,O7323,O7332
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real pciexc
      common/pciexc/ pciexc
      real hi , hii
      common/h/ hi , hii
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real o3cs12 , o3cs13 , o3ex23 , o3br32 , o3enro
      common/o3data/ o3cs12 , o3cs13 , o3ex23 , o3br32 , o3enro
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer nLev3Fail
*number indicating what went wrong in the routine level3
*not used elsewhere, info only
      common/Lev3Fail/ nLev3Fail
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real hold , o3cs23 , cs21, cs31, cs41,cs51,cs32,cs42,cs52,
     1 cs43,cs53,cs54
      real go2(5) , p(5) , exo2(4)
      real cs23 , cs13 , a6300 , a6363 , a32 , hdcor , cs01 , cs12 ,
     1 cs02, pop3 , a31,a41,a21,a51 , a42 , a52 , a43,a53,a54,
     3 cs , aeff , csoi, cs2s2p , cs2s3p
      data go2/4.,6.,4.,4.,2./ , exo2/26808.4,21.0,13637.5,1.5/
*
*     following does the OI Bowen Ly-bet pumping problem
      call p8446( coolOi )
      call coladd( 'o  1' , 8446 , coolOi )
*
*     O I 6300, 6363, A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     only electrons assumed; ok if ionized fraction GT 1E-4
*     >>refer Federman, S.R., & Shipsey, E.J. 1983, ApJ, 269, 791
      csoi = 2.68e-5*te*(1.+1.67e-6*te-2.95e-10*te*te)
      csoi = max( 0.1 , csoi)
      cs23 = 1.05e-3 * sqrte
      cs13 = 3.24e-6 * te
      a6300 = t6300(ipLnAul) *t6300(ipLnEscP)
      t6300(ipLnPopOpc) = xIonFracs(8,1)*5./5.
      t6300(ipLnPopl) = xIonFracs(8,1)*5./5.
      t6300(ipLnPopu) = 0.
      t6300(ipLnCS) = csoi * 5./9.
      t6363(ipLnPopOpc) = xIonFracs(8,1)*5./3.
      t6363(ipLnPopl) = xIonFracs(8,1)*5./3.
      t6363(ipLnPopu) = 0.
      t6363(ipLnCS) = csoi*3./9.
      a6363 = t6363(ipLnAul)*t6363(ipLnEscP)
*     d6300 is the photoionization rate from the excited level
*     was computed when ionization balance done
      a21 = a6300 + a6363 + d6300
      a32 = t5577(ipLnAul) * t5577(ipLnEscP)
      call PutCS( cs23 , t5577 )
      c5577 = pop3( 9.,5.,1., csoi,cs13,cs23,
     1 a21 , 7.56e-2 , a32 ,
     2 22590. , 25775.7 , poiexc , xIonFracs(8,1) ,0. )
     3 * a32 * 3.57e-12
      t5577(ipLnPopOpc) = poiexc
      t5577(ipLnPopl) = poiexc
      t5577(ipLnPopu) = 0.
*     convert poiexc to relative abundances
      c6300 = poiexc * a6300 * t6300(ipLnEnrErg)
      c6363 = poiexc * a6363 * t6363(ipLnEnrErg)
      dCooldT = dCooldT + c6300* ( 2.28e4*tsq1 + halfte )
      poiexc = poiexc/ max(1e-20, xIonFracs(8,1) )
      call coladd( 'o  1' , 5577 , c5577 )
      call coladd( 'o  1' , 6300 , c6300 )
      call coladd( 'o  1' , 6363 , c6363 )
*
*     O I fine structure lines rad data from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     >>refer Berrington, K.A. 1988, JPhB, 21, 1083
*     hydrogen collisions from
*     >>refer Tielens, A.G.G., & Hollenbach, D. 1985, ApJ, 291, 722
*     factor in () is their rate coef
*     assume H2 and H are same
*     CDSQTE = 8.629E-6*EDEN/SQRTE
*     cs01 = 9.8e-6*te + (4.2e-12*te70/te03) / cdsqte * 3. * hdcor
*     cs12 = 2.6e-6*te  + (1.5e-10*sqrte/te03/te03)/cdsqte*hdcor
*     cs02 = 2.9e-6*te  + (1.1e-12*te70*te10)/cdsqte*hdcor
*     evaluate fits to OI electron rates, indices on var do not agree
*     with Kirk's in sub, but are OK
      call oi3Pcs(cs01,cs02,cs12)
*     assume H atoms and molecule have same rate
      hdcor = (hi + htwo )
*     add on hydrogen atom collision
      cs01 = cs01 + (4.2e-12*te70/te03) / cdsqte * 3. * hdcor
      cs12 = cs12  + (1.5e-10*sqrte/te03/te03)/cdsqte*hdcor
      cs02 = cs02  + (1.1e-12*te70*te10)/cdsqte*hdcor
      call PutCS( cs01 , t63 )
      call PutCS( cs12 , t146 )
      call PutCS( cs02 , TauDummy )
      call level3( t63,t146,TauDummy)
*
*     O II lines, CS data from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     A;s from NIST
*     full five level atom, ex in wavenumbers
*     more recent cs
*     >>refer McLaughlin, B.M., & Bell, K.L. 1993, ApJ, 408, 753
*     >>chng 97 feb 19, change in last sig fig as per Bob Rubin e-mail feb 11 97
*     A from NIST compilation
*     >>refer Wiese, W.L., Fuhr, J.R., Deters, T.M. 1996, J Phys Chem Ref Data,
*     >>refer Monograph 7
      a21 = 3.058e-5
      a31 = 1.776e-4
      a41 = 5.22e-2
      a51 = 2.12e-2
      a32 = 1.30e-7
      a42 = 0.09907
      a52 = 0.0519
      a43 = 0.0534
      a53 = 0.08672
      a54 = 1.41e-10
*     >>chng 97 feb 19, mostly in last sig figs, as per Bob Rubin e-mail and
*     >>refer McLaughlin, B.M., & Bell, K.L. 1993, ApJ, 408, 753
      cs21 = 0.825
      cs31 = 0.55
      cs41 = 0.2765
      cs51 = 0.1382
      cs32 = 1.17
*     scale factor from
*     >>refer McLaughlin, B.M., & Bell, K.L. 1993, ApJ, 408, 753
      cs42 = 0.730 * 1.207
      cs52 = 0.295 * 1.207
      cs43 = 0.408 * 1.207
      cs53 = 0.275 * 1.207
      cs54 = 0.287
*     subroutine fivel(g,ex,cs12,cs13,cs14,cs15,
*    1 cs23,cs24,cs25,cs34,cs35,cs45, a21,a31,a41,a51, a32,a42,a52,
*    2 a43,a53,a54, p,abund)
      call fivel(go2, exo2 , cs21,cs31,cs41,cs51,
     1 cs32,cs42,cs52,cs43,cs53,cs54,
     2 a21 ,a31 ,a41 ,a51 ,a32 ,a42 ,a52 ,a43 ,
     3 a53 ,a54 , p, xIonFracs(8,2) )
      O3730 = p(2) * a21 * 5.34e-12
      O3727 = p(3) * a31 * 5.34e-12
      O2471 = ( p(4)*a41 + p(5)*a51 ) * 8.05e-12
      O7323 = ( p(4)*a42 + p(5)*a52 ) * 2.72e-12
      O7332 = ( p(4)*a43 + p(5)*a53 ) * 2.71e-12
      c3727 = O3730+O3727
      c7325 = O7323+O7332
      dCooldT = dCooldT + c3727*(3.86e4*tsq1 - halfte)
      call coladd( 'O  2' , 3727 , c3727 )
      call coladd( 'O  2' , 7325 , c7325 )
      call coladd( 'O  2' , 2470 , c7325*0.78 )
*
*     O II 833.9A, CS
*     >>refer McLaughlin, B.M., & Bell, K.L. 1993, ApJ, 408, 753
      cs = 0.355 * te10 * te10 * te003 * te001 *te001
      call PutCS( cs , t834 )
      call level2( t834 )
*
*     O III 1666, crit den=2.6+10, A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     c.s.
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      call PutCS( 0.756 , t1666 )
      call PutCS( 0.454 , t1661 )
      call PutCS( 1.3 , TauDummy )
      call level3( TauDummy, t1666,t1661 )
*     if( nLev3Fail.gt.0 )write(qq,'('' nlev3fail='',i3)') nLev3Fail
*
*     oiii 304 not in cooling function
* 666 error! put all these in cooling
      t304(ipLnPopOpc) = xIonFracs(8,3)
      t304(ipLnPopl) = xIonFracs(8,3)
      t304(ipLnPopu) = 0.
*
*     o iii 5007+4959, As 96 nist
      aeff = 0.0263 + d5007r
*     following data used in routine that deduces oiii temp from spectrum
*
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     IP paper Y(ki) differ significantly from those
*     calculated by
*     >>refer Burke, V.M., Lennon, D.J., & Seaton, M.J. 1989, MNRAS, 236, 353
*     especially for 1D2-1S0.
*     BLS89 is adopted for 1D2-1S0 and LB94 for 3P2,1-1D2.
*     NB!!  these cs's must be kept parallel with those in Peimbert analysis
      if( te.gt.3981 .and. te.le.1e5 ) then
        o3cs12 = 3.0211144 - 101.57536 /sqrte + 355.06905 *alogete/te
        o3cs23 = 0.32412181 + 79.051672/sqrte -4374.7816/te
      else if( te.lt.3981. ) then
        o3cs12 = 2.15
        o3cs23 = 0.4781
      else
        o3cs12 = 2.6594
        o3cs23 = 0.5304
      endif
      o3cs13 = min(0.36 , 0.0784*te10*te03*te01*te003 )
      a21 = 0.02431
      a31 = .215634
      a32 = 1.71
      o3ex23 = 32947.
      o3br32 =  a32 / ( a31 + a32 )
      o3enro = 4.56e-12 / 3.98e-12
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      poiii3 = pop3( 9.,5.,1.,o3cs12,o3cs13,o3cs23,a21 ,a31 ,a32 ,
     1 28990.,o3ex23 , poiii2,xIonFracs(8,3),d5007r)
      c4363 = poiii3 * a32 * 4.56e-12
      c5007 = poiii2 * a21 * 3.98e-12
      d5007t = c5007 * d5007r/aeff
      dCooldT = dCooldT + c5007* ( 2.88e4*tsq1 - halfte )
      dCooldT = dCooldT + c4363*6.20e4*tsq1
      call coladd( 'O  3' , 5007 , c5007 )
      call coladd( 'O  3' , 4363 , c4363 )
      call coladd( 'O  3' , 2331 , c4363*0.236 )
      if( xIonFracs(8,3).gt.0. ) then
        poiii3 = poiii3 / xIonFracs(8,3)
        poiii2 = poiii2 / xIonFracs(8,3)
      endif
*
*     oiii ir lines, col str from iron project,
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      call PutCS( 0.5590 , tO88 )
      call PutCS( 1.335 , t52 )
      call PutCS( 0.2832 , TauDummy )
      call level3( tO88,t52,TauDummy)
*
*     O III 834A, CS
*     >>refer Aggarwal, K.M., 1985 Ast Ap 146, 149.
      call PutCS( 5. , t835 )
      call level2( t835 )
*     call DumpLine( t835 )
*
*     O IV 26 mic, CS
*     >>refer Blum, R.D., & Pradhan, A.K. 1992, ApJS 80, 425
*     A=
*     >>refer Brage, T., Judge, P.G., & Brekke, P. 1996, ApJ. 464, 1030
      hold = max( te,4500.)
      hold = min( hold, 450000. )
      aeff = log( hold )
      cs = 9.2141614  - 5.1727759e-3*sqrt(hold) - 58.116447/aeff
      call PutCS( cs , t26 )
      call level2( t26 )
*
*     O IV 1402, wl from
*     >>refer Wills, D., & Netzer, H. 1979, ApJ, 233, 1
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     CS
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
      cs = -13.860726 - 0.14091452*aeff**2 + 2.9626895*aeff
      call PutCS( cs , t1402 )
      call level2( t1402 )
*
*     O IV 789A, CS from
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
      cs = -3.0102462 + 109.22973/aeff - 18666.357/hold
      call PutCS( cs , t789 )
      call level2( t789 )
*     call DumpLine( t789 )
*
*     O V 630, CS from
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
      cs = min( 4.0 , 1.317 * te10/te03 )
      call PutCS( cs , t630 )
      call level2( t630 )
*
*     O V 1218; coll data from
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
      if( te.le. 3.16e4 ) then
        cs = 3.224 /(te10*te03*te03*te003)
      else
        cs = 10.549 / (te10*te10*te10/te03)
      endif
      call PutCS( cs , t1214 )
*     c1214 = beseq( .87,1.05,3.32, t1214, .0216) * 1.64E-11
*     BESEQ(CS23,CS24,CS34,tarray,A41)
*     A's
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer  1996, MNRAS, 279, 1289
      call beseq( .87,0.602,2.86, t1214, .02198)
      em1218 = PopLevels(3)*0.0216 * 1.64e-11
*
*     O VI 1035 li seq
*     generate collision strengths, then stuff them in
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 8 , t1032, t150, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , t1032 )
      call PutCS( cs2s2p*0.5 , t1037 )
*     no data for the 2-3 transition
      call PutCS(  1.0 , TauDummy )
*     solve the 3 level atom
      call level3( t1037,TauDummy, t1032)
*
      call PutCS( cs2s3p , t150 )
      call level2( t150 )
*
      end
******************************************************************************
      subroutine flucol
      implicit none
*evaluate total cooling due to fluorine
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
*
*     local variables
      real cs
*
*     [F II] 29.33 micron, 67.2 micron
*     collision strength transition prob
*     >>refer Galavis, M.E., et al. 1997, A&AS 123, 159
*     >>refer Buttler, K., & Zeippen, C.J., 1994, A&AS 108, 1
      call PutCS( 0.60  , F0229 )
      call PutCS( 0.206 , F0267 )
      call PutCS( 0.160 , TauDummy )
*     subroutine level3( t10,t21,t20)
      call level3( F0229 , F0267 , TauDummy )
*
*     collision strength
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     [F IV] 44.07 microns
      cs = min(0.711 , 0.1245*te10*te05*te01*te001*te001 )
      call PutCS( cs , F444 )
*     [F IV] 25.83 microns
      cs = min( 1.89 , 0.2023*te20*te003*te003 )
      call PutCS( cs , F425 )
      cs = min( 0.451 , 0.02922*te20*te05 )
      call PutCS( cs , TauDummy )
*     subroutine level3( t10,t21,t20)
      call level3( F444 , F425 , TauDummy )
*
      end
******************************************************************************
      subroutine necol
      implicit none
*evaluate total cooling due to neon
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limLevelN
      parameter (limLevelN=20)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      integer ndfst
      parameter (ndfst=5)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real c3343, c3869, c4720, c2424, c2975, c1565, c3426, c1134
      common/coolne/ c3343, c3869, c4720, c2424, c2975, c1565, c3426,
     1 c1134
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real pfs1 , pfs2
      common/fslev/ pfs1 , pfs2
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     local variables
      real pop2 , pop3 , popexc, cs2s2p , cs2s3p,cs,
     1 a21,a31,a32
*
*     Neon II 12.8 micron
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max(0.272, min( 0.4 , 0.1294*te10/te02*te005 ) )
      call PutCS( cs , tNe13 )
      call level2( tNe13 )
*
*     Ne III fine structure lines
*     CS
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      call PutCS( 0.774 , tNe16 )
      call PutCS( 0.244 , tNe36 )
      call PutCS( 0.208 , TauDummy )
      call level3(tNe16,tNe36,TauDummy)
*
*     Ne III 3869+3968, 3343, A's
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     CS
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      if( te.lt.1e4 ) then
        cs = 0.269
      else
        cs = min( 0.333, 0.1142*(te10/te003/te003/te001) )
      endif
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      c3343 = pop3( 9.,5.,1.,  1.348,0.151,cs, 0.209,2.052,2.677,
     1 3.583e4,4.301e4, pop2,xIonFracs(10,3),0.) * 2.677*5.954e-12
      c3869 = pop2 * 0.209 * 5.14e-12
      dCooldT = dCooldT + c3869 * ( 3.72e4*tsq1 - halfte )
      call coladd( 'Ne 3' , 3342 , c3343 )
      call coladd( 'Ne 3' , 3869 , c3869 )
      call coladd( 'Ne 3' , 1793 , c3343*1.38 )
*
*     Ne IV 2425.4+2422.8  A'S from
*     >>refer Zeippen, C.J. 1982, MN 198 111
*     Ne IV CS from
*     >>refer Giles, K. 1981, MNRAS, 195, 63
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      a21 = 2.46e-3
      a31 = 1.02
      a32 = 0.693
      c4720 = pop3( 4.,10.,6.,1.37,0.464,2.14, a21 ,a31 ,a32,
     1 5.94e4,3.05e4 ,pop2,xIonFracs(10,4),0.) *a32 * 4.22e-12
      c2424 = pop2 * 8.21e-12 * a21
      call coladd( 'Ne 4' , 2424 , c2424 )
      call coladd( 'Ne 4' , 4720 , c4720 )
      call coladd( 'Ne 4' , 1602 , c4720*4.1 )
*
*     Ne V 3426, CS data from
*     >>refer Lennon, D.J. & Burke, V.M. 1991, MNRAS 251, 628
*     revised from
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     A's from
*     >>refer Baluja, K.L. 1985, JPhB, 18, L413
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      c2975 = pop3( 9.,5.,1., 2.18 ,0.254,0.688, 0.521,4.35,2.76,
     1 4.297e4,4.835e4, pop2 , xIonFracs(10,5),0.) * 2.76*6.69e-12
*     following are old values
*     C2975 = POP3( 9.,5.,1., 1.8,0.25,0.52, 0.521,4.34,2.76,
*    1 4.297E4,4.835E4, POP2 , ANEON(5),0.) * 2.76*6.69E-12
      c1565 = c2975 * 1.901 * 1.572
      c3426 = pop2 * 0.521 * 5.81e-12
      dCooldT = dCooldT + c3426 * ( 4.20e4*tsq1 - halfte ) +
     1 ( c2975 + c1565 ) * 9.132e4 * tsq1
      call coladd( 'Ne 5' , 2975 , c2975 )
      call coladd( 'Ne 5' , 1565 , c1565 )
      call coladd( 'Ne 5' , 3426 , c3426 )
*
*     Ne V 24.2, 14.3 micron
*     CS from
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     A's from
*     >>refer Baluja, K.L. 1985, JPhB, 18, L413
      cs = min( 1.84 , 21.12 /(te10*te10*te10/te003/te003 ) )
      call PutCS( cs , tNe24 )
      cs = min( 9.5 , 261.71 /(te10*te10*te10*te10*te01*te003) )
      call PutCS( cs , tNe14 )
      cs = min( 3.2 , 139.86 /(sqrte/te03*te003/te001) )
      call PutCS( cs , TauDummy )
      call level3(tNe24,tNe14,TauDummy)
*
*     Ne V 5S - 3P, CS
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
*     A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
* 666 error! transfer these lines
      c1134 = popexc( 11.9/(te10*te10*te03),9.,5.,4.67e3,1.273e5,
     1 xIonFracs(10,5)) * 1.767e-11
      call coladd( 'Ne 5' , 1134 , c1134 )
*
*     Ne VI 7.6 micron, A from
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     cs from
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
*     >>chng 96 july 16 had been just constant 2.0
      cs = min( 3.71 , 23.623 / (te20*te02/te003) )
      call PutCS( cs , xNe0676 )
      call level2( xNe0676 )
*     fs76 = popexc(0.37,2.,4.,1.9E-2,1.89E3,xIonFracs(10,6))*2.62E-13
*     dCooldT = dCooldT + fs76*(1890.*tsq1-halfte)
*     call coladd( 'Ne 6' , 76 , FS76 )
*
*     Ne VII col data from
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E. 1985,
*     >>refer ADNDT, 33, 195
*     low te from
*     >>refer Dufton, P.L., Doyle, J.G., Kingston, A.E. 1979, A&A, 78, 318
*     newer fit to
*     >>refer Ramsbottom, C.A., Berrington, K.A., Bell, K.L. 1995,
*     >>refer ADNDT, 61, 105
      if( te.lt.4e4 ) then
        cs = 0.0352 *(te20/te03)
      else
        cs = 0.736 /( te10*te02/te003)
      endif
      call PutCS( cs , t895 )
*     BESEQ(CS23,CS24,CS34,tarray,A41)
*     c895 = beseq(.52,.61, 2.0,t895,.0578) * 2.223E-11
*     A's
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
      call beseq(.52,.61, 2.0,t895,.07066)
      em895 = PopLevels(3) * 0.0578 * 2.223e-11
*
*     Ne VIII 774, iso with 1549, extrapolation for omega
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 10 , t770, t88, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , t770 )
      call PutCS( cs2s2p*0.5 , t780 )
      call PutCS(  1.0 , TauDummy )
      call level3( t780,TauDummy, t770)
*
      call PutCS( cs2s3p , t88 )
      call level2( t88 )
*
      end
***********************************************************************
       subroutine oi3Pcs(cs21,cs20,cs10)
       implicit none
*make collision strengths for 3P O I ground term.
*     >>refer Berrington, K.A. 1988, J.Phys.B, 21, 1083.
* numbers in cs variables refer to j value: j=0,1,2 (n=3,2,1 in 5 level atom)
* written by Kirk Korista, 29 may 96
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
       real cs21, cs20, cs10
       real a,b,c,d,temp
*
       temp = te
*
* 3P2 - 3P1
 
       if(temp .le. 1.0e4) then
         a = -5.5634127e-04
         b = 8.3458102e-08
         c = 2.3068232e-04
         cs21 = max(1.08e-03, min(0.106, a + b*te32 + c*sqrte))
       else
         cs21 = min(0.222, 5.563e-06*temp**1.07)
       endif
*
* 3P2 - 3P0
 
       if(temp .le. 1.0e4) then
         a = -3.7178028e-04
         b = 2.0569267e-08
         c = 1.1898539e-04
         cs20 = max(5.42e-04, min(0.0321, a + b*te32 + c*sqrte))
       else
         cs20 = min(0.0589, 1.015e-05*temp**0.875)
       endif
*
* 3P1 - 3P0
       if(temp .le. 1.0e4) then
         a = -5.9364373e-04
         b = 0.02946867
         c = 10768.675
         d = 3871.9826
         cs10 = max(4.05e-05, min(0.0283,
     1              a + b*exp(-0.5*((temp-c)/d)**2)))
       else
         cs10 = min(0.074, 7.794e-08*temp**1.39)
       endif
*
       end
***********************************************************************
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21, excit in Kelvin
*     level2(  t10 )
*     level3(  t10,t21,t20)
*     tsq1 = 1. / (te**2)
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     beseq(cs23,cs24,cs34,tarray,a41)
*     FIVEL( G(1-5) , ex(wn,1-5), cs12,cs13,14,15,23,24,25,34,35,45,
*            A21,31,41,51,32,42,52,43,53,54, pop(1-5), abund)
*
******************************************************************************
      subroutine nacol
      implicit none
*compute sodium cooling
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real c2569 , c1357 , c2972,c1365,c2067,c4017
      common/coolna/ c2569 , c1357 , c2972,c1365,c2067,c4017
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     local variables
      real cs , pop3 , p2 , cs13,cs23,a12,a13,a23, p3
*
*     NaD Na D Na1 Na 1 lines
*     transition is 3s-3p, ^2P^o - ^2P^o
*     change 26 Feb 96 cs to Verner's value
      cs = 2.12e-2 * (te70/te02)
      call PutCS( cs , t5895 )
      call level2( t5895 )
*
*     [NaIII] 7.319 microns
*     cs
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.35 , min(0.40,0.198*te05*te01) )
      call PutCS( cs , fsNa373 )
      call level2( fsNa373 )
*
*     collision data from
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
*     [NaIV] 9.048 microns
      call PutCS( 0.802 , fsNa490 )
*     [NaIV] 21.29 mic
      call PutCS( 0.273 , fsNa421 )
*     following from pradhan review
      call PutCS( .111 , TauDummy )
      call level3( fsNa490,fsNa421,TauDummy)
*
*     >>chng 97 mar 19, added NaV lines
*     NaV lines, collision data from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     A's from
*     >>refer Kaufman, V., & Sugar, J. 1986, J Phys Chem Ref Dat, 15, 321
*     >>chng 97 july 25, cs had been 1, changed to Me
      cs = 0.919
      cs13 = 0.359
      cs23 = 1.915
      a12 = 8.16e-3
      a13 = 3.81
      a23 = 2.68
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      p3 = pop3(4.,10.,6., cs , cs13, cs23, a12 ,a13 ,a23 ,
     1 6.96e4 , 3.58e4 , p2,xIonFracs(11,5),0.)
      c1365 = p3 *a13 *1.46e-11
      c4017 = p3 * a23 * 4.95e-12
      c2067 = p2 * a12 * 9.63e-12
      call coladd( 'Na 5' , 1365 , c1365  )
      call coladd( 'Na 5' , 4017 , c4017  )
      call coladd( 'Na 5' , 2067 , c2067  )
*
*     [Na VI] 14.32 mic, 8.62 mic
      cs = min( 0.77 , 2.346/(te10*te02*te001) )
      call PutCS( cs , xNa6143 )
      cs = min( 2.15 , 6.934/(te10*te03/te001/te001) )
      call PutCS( cs , xNa6862 )
      cs = min( 0.53 , 1.518/(te10*te01*te003*te003) )
      call PutCS( cs , TauDummy )
      call level3( xNa6143,xNa6862,TauDummy)
*
*     [Na VI] UV lines, 2971.9, 2872.7 doublet, 2578.9, 1356.6
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      cs = max( 0.1, min(0.2876,2.603e-3/(sqrte/te10) ) )
      c2569 = pop3(9.,5.,1., 1.38 , 0.173, cs, 1.68,16.9,5.27,
     1 5.01e4 , 5.60e4 , p2,xIonFracs(11,6),0.)*5.27*6.70e-12
      c1357 = c2569 * (16.9/5.27)*(2972/1357)
      c2972 = p2 * 1.68 * 6.70e-12
      call coladd( 'Na 6' , 2569 , c2569  )
      call coladd( 'Na 6' , 1357 , c1357  )
      call coladd( 'Na 6' , 2972 , c2972  )
*
*     [Na VII] 4.675 microns, no CS (interpolated), A NIST
*     collision strength interpolated from
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      call PutCS( 1.5 , xNa0746 )
      call level2( xNa0746 )
*
      end
******************************************************************************
      subroutine mgcol
      implicit none
*compute magnesium cooling
      integer ndfst
      parameter (ndfst=5)
      integer limLevelN
      parameter (limLevelN=20)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real  c1806
      common/coolmg/ c1806
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real opac
      common/opac/ opac(ncell)
      real otsfe2 , emuv3
      common/resion/ otsfe2 , emuv3
      integer ipmgex ,ipOpMgEx
      real xmglst, popmg2 , rmg2l , xMg2Max
*     these all deal with photoionization from upper lev of Mg II 2798
      common/mgexc/ ipmgex , xmglst, popmg2 , rmg2l , xMg2Max,ipOpMgEx
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     local variables
      real csoi,popexc,cs, cs2s2p,cs2s3p,csdum
*
*     Mg I 2853
*     fit to Dima's  integration of
*     >>refer Leep, D., & Gallagher, A. 1976, Phys Rev A, 13, 148
      cs = 5.21e-4 * te/te10
      call PutCS( cs , MgI2853 )
      call level2( MgI2853 )
*
*     Mg I 2026,
      call MakeCS( MgI2026 )
      call level2( MgI2026 )
*
*     Mg 1 4571, data from Mendoza
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs set to O I
      csoi = 2.68e-5*te*(1.+1.67e-6*te-2.95e-10*te*te)
      csoi = max( 0.1 , csoi)
      call PutCS( csoi/9. , t4561 )
      call level2( t4561 )
*
*     Mg II 2798
*     cs from
*     >>refer Sigut, A., & Pradhan, A.K., 1994, J Phys B sub
*     refer not publ as of '97, cs agrees fairly well with Harrington et al.
*     previous reference (~'82)
      cs2s2p = 4.50 * te10
      call PutCS( cs2s2p , t2796 )
      call PutCS( cs2s2p*0.5 , t2804 )
      call PutCS(  1.0 , TauDummy )
      call level3( t2804,TauDummy, t2796)
*     call PutCS( cs , t2800 )
*     call level2( t2800 )
*
*     following used in MAGNES for photo destruction rate
      if( PopLevels(0) .gt.0. ) then
        popmg2 = (PopLevels(2)+PopLevels(1))/PopLevels(0)
      else
        popmg2 = 0.
      endif
*
*     MG IV 4.487 MIC
*     cs
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.356 , min(0.425, 0.180*te05*te02 ) )
      call PutCS( cs ,  tMg4 )
      call level2( tMg4 )
*
*     MG V 5.61, 13.54 micron,
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
*     >>chng 96 july 16 had been constant 0.3
      cs = min( 0.311, 0.11*te10 )
      call PutCS( cs , tMg14 )
      cs = min( 1.06 , 0.339 * te10 )
      call PutCS( cs , tMg6 )
*     >>chng 96 july 16 had been constant 0.3
      cs = min( 0.297, 0.0745*te10*te02 )
      call PutCS( cs , TauDummy )
      call level3(tMg6,tMg14,TauDummy)
*
*     [Mg V] 2751+2893- Ne III-like, cs
*     >>refer Mendoza, C., & Zeippen, C.J. 1987, MNRAS, 224, 7p
*     >>chng 96 aug 5 to three level atom
*     c2751 = popexc(1.33,9.,5.,2.4,5.14e4,xmg(5))*7.11e-12
*     dCooldT = dCooldT + c2751*5.14e4*tsq1
*     call coladd( 'Mg 5' , 2751 , C2751 )
*
*     following is 2-1 transition, both 2928 and 2783,
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      call PutCS( 1.187 , xMg52855 )
      cs = max( 0.182 , min( 0.278,0.0171*te20*te05/te005/te003) )
*     3-2 transition, 2417.5
      call PutCS( cs , xMg52417 )
*     3-1 transition, 1324.58
      call PutCS( 0.153 , xMg51325 )
      call level3(  xMg52855,xMg52417,xMg51325)
*
*     Mg VI, 1806- OII like, data
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1806 = popexc( 0.6,4.,10.,0.1,7.974e4,xIonFracs(12,6))*1.11E-11
      call coladd( 'Mg 6' , 1806 , c1806 )
*
*     [Mg VII] IR lines at 5.517 and 9.03 microns,
*     carbon-like,
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      if( alogte.lt.4.4 ) then
        cs =  0.027 * te30/te03*te003*te001
      else
        cs =  0.44
      endif
      call PutCS( cs ,fsMg790 )
      if( alogte.lt.4.6 ) then
        cs =  min( 1.456, 0.0577*te30*te02/te001/te001 )
        csdum = 8.275e-3 * sqrte/te10/te001
      else
        cs =  3.257/(te05*te02*te003*te003 )
        csdum =  1.456/(te10*te01*te005 )
      endif
      call PutCS( cs ,fsMg755 )
      call PutCS( csdum , TauDummy )
*     level3(  t10,t21,t20)
      call level3(fsMg790,fsMg755,TauDummy)
*
*     [mg vii] 2510, 2629
*     c2596 = popexc( 1.7,9.,5.,10.,5.76e4,xIonFracs(12,7))*7.96e-12
*     dCooldT = dCooldT + c2596 * 5.76e4*tsq1
*     call coladd( 'Mg 7' , 2596 , C2596 )
*
*     >>chng 96 aug 5, converted to 3 level atom
      cs = min( 0.22, 0.3622/(te05*te02*te003) )
      call PutCS( cs , xMg71190 )
*     2-1 transitions, 2509.2A+2629.1A together
      cs = min( 1.067 , 0.247*te10*te03*te005 )
      call PutCS( cs , xMg72569 )
*     3-2 transition, 2261.5A
      cs = max( 0.3735 , min( 0.542 , 3.863/(te20*te03*te01/te003) ) )
      call PutCS( cs , xMg72261 )
      call level3( xMg72569 , xMg72261 , xMg71190 )
*     level3(  t10,t21,t20)
*
*     Mg VIII 3.03 micron, data from
*     >>refer Chandra, S. 1982, SoPh, 75, 133
*     cs from
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
      call PutCS( 1.0 , xMg08303 )
      call level2( xMg08303 )
*     fs303 = popexc(0.26,2.,4.,0.324,4752.,xmg(8))*6.58E-13
*     call coladd( 'Mg 8' , 303 , FS303 )
*
*     Mg IX 704.5, 1909-like, A from
*     >>refer Muhlethaler, H.P., & Nussbaumer, H. 1976, A&A 48, 109
*     beseq line, cs data from
*     >>refer Keenan, F.P. Berrington, K.A., Burke, P.G., Dufton, P.L.,
*     >>refer Kingston, A.E. 1986, PhyS 34, 216
*     A's
*     >>refer Fleming, J., Bell, K.L, Hibbert, A., Vaeck, N., Godefroid, M.R.
*     >>refer 1996, MNRAS, 279, 1289
* 666 error! use beseq here
      cs = 0.98288 - 0.23766*alogte + 0.014334*alogte**2
      cs = max( 0.01, cs )
      call PutCS( cs , t705 )
      call level2( t705 )
*
*     Mg X 610
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 12 , tMg610, t58, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , tMg610 )
      call PutCS( cs2s2p*0.5 , tMg625 )
      call PutCS(  1.0 , TauDummy )
      call level3( tMg625,TauDummy, tMg610)
*
*     Mg X 58A
      call PutCS( cs2s3p , t58 )
      call level2( t58 )
*
      end
******************************************************************************
      subroutine alcol
      implicit none
*compute aluminum cooling
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limLevelN
      parameter (limLevelN=20)
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real c1170, c2428, c2125
      common/coolal/ c1170, c2428, c2125
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     local variables
      real cs , cs2s2p,cs2s3p,pop3,p2
*
*     Al I 3957
      call MakeCS( AlI3957 )
      call level2( AlI3957 )
*
*     Al I 3090
      call MakeCS( AlI3090 )
      call level2( AlI3090 )
*
*     AlII  1670.787
*     >>chng 96 may 09 put back into level 2 for array processor speed up
*     cs from
*     >>refer Tayal, S.S., Burke, P.G., Kingston, A.E. 1985, JPhB, 18, 4321
*     cs = min( 5.0 , 0.0125 * sqrte*te10*te003 )
*     call PutCS( cs , al1671 )
*     call level2( al1671 )
*
*     Al 2, all data summarized in
*     >>refer Keenan, F.P., Harra, L.K., Aggarwal, K.M., Feibelman, W.A. 1992,
*     >>refer ApJ, 385, 375
*     doublet at 2660, 2669
      call PutCS( 3.56 , t2670 )
*     C2670 = beseq( 1.67,2.00,6.54, T2670 , 3.67E-3 )  * 7.45E-12
      call beseq( 1.67,2.00,6.54, t2670 , 3.67e-3 )
      em2669 = PopLevels(3) * 3.67e-3 * 7.45E-12
*
*     Aluminum al 3, 1854, 1862 doublet, 3s ^2 S gnd, ^2P^o 1/2 3/5 exc
*     f=0.854 from
*     >>refer Dufton, P.L., Brown, P.J.F., Lennon, D.J., Lynas-Gray, A.E. 1986,
*     >>refer MNRAS, 222, 713
*     cs from
*     >>refer Dufton, P.L., & Kingston, A.E. 1987, JPhB, 20, 3899
      cs = 4.407* te10 * te03*te01
      cs = min( 25.0 , cs )
      call PutCS( cs*0.667 , t1855 )
      call PutCS( cs*0.333 , t1863 )
      call PutCS(  1.0 , TauDummy )
      call level3( t1863,TauDummy, t1855)
*
*     Al V 2.905, cs
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = min( 0.524 , 1.113/(te10/te02/te003) )
      call PutCS( cs , Al529 )
      call level2( Al529 )
*
*     Al VI 3.66, 9.12 microns
      cs = min( 5.5 , 639.1 / (sqrte*te03**te003*te001) )
      call PutCS( cs , Al6366 )
      cs = min( 1.10 , 49.37/(sqrte/te10*te02/te001 ) )
      call PutCS( cs , Al6912 )
      cs = min( 2.0 , 319.11/(sqrte*te10/te02/te001 ) )
      call PutCS( cs , TauDummy )
      call level3( Al6366 , Al6912 , TauDummy )
*
*     [Al VI] 2428.4, 2601, 1169.8, 2124.9
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     cs from
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
*     >>refer As from NIST
      c1170 = pop3(9.,5.,1., 1.044 ,0.145 ,0.463 , 6.63,72.9,7.79 ,
     1 5.92E4 , 6.767E4 , p2 , xIonFracs(13,6) , 0. ) * 72.9 * 1.70E-11
      c2428 = p2 * 6.63 * 8.19e-12
      c2125 = c1170 * (7.79/72.9)*(1169.5/2124.9)
      call coladd( 'Al 6' , 1170 , c1170  )
      call coladd( 'Al 6' , 2428 , c2428  )
      call coladd( 'Al 6' , 2125 , c2125  )
*
*     Al VIII 5.85, 3.72 microns
*     collision strength
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      cs = min(0.39, 0.0459*te20/te003/te003 )
      call PutCS( cs , Al8575 )
      cs = min( 1.062 , 0.0407 * te30/te003/te003 )
      call PutCS( cs , Al8370 )
      cs = min( 0.27, 2.694e-3*te20*te20*te01*te003 )
      call PutCS( cs , TauDummy )
      call level3( Al8575 , Al8370 , TauDummy )
*
*     [Al IX] 2.04 micron, no collision strength, A NIST
      call PutCS( 1. , Al09204 )
      call level2( Al09204 )
*
*     Al 10 639, CS
*     >>refer Keenan, F.P. Berrington, K.A., Burke, P.G., Dufton, P.L.,
*     >>refer Kingston, A.E. 1986, PhyS 34, 216
*     A is extrapolation along iso seq
      cs = 0.73492 - 0.16964*alogte + 0.0096631*alogte**2
      cs = max( 0.01, cs )
      call PutCS( cs , t639 )
      call level2( t639 )
*
*     Al 11 Li seq 2s2p 556
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 13 , tAl550, tAl48, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , tAl550 )
      call PutCS( cs2s2p*0.5 , tAl568 )
      call PutCS(  1.0 , TauDummy )
      call level3( tAl568,TauDummy, tAl550)
*
      call PutCS( cs2s3p , tAl48 )
      call level2( tAl48 )
*
      end
******************************************************************************
      subroutine silcol
      implicit none
*compute silicon cooling
      integer ndfst
      parameter (ndfst=5)
      integer limLevelN
      parameter (limLevelN=20)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real c2148, c1446, c949, c1815, c1985, c691, c606, c583
      common/coolsi/ c2148, c1446, c949, c1815, c1985,c691, c606, c583
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real hi , hii
      common/h/ hi , hii
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
*
*     local variables
      real cs,p2,expion,popexc,
     1 cs2s2p,cs2s3p,pop3 , cs01,cs02,cs12
*
*     Si I 2518
      call MakeCS( Sii2518 )
      call level2( Sii2518 )
*
*     Si I 2215
      call MakeCS( Sii2215 )
      call level2( Sii2215 )
*
*     Silicon II 35 micron; elec cs from
*     >>refer Dufton, P.L., & Kingston, A.E. 1994, ADNDT, 57, xx
      cs = 5.77
*     hydrogen collision strength from
*     >>refer Tielens, A.G.G., & Hollenbach, D. 1985, ApJ, 291, 722
*     they give rate de-ex 6.5E-10 cm^3 s^-1, indep of temp
      cs = cs + 6.5e-10 / cdsqte * 4. * hi
      call PutCS( cs , tSi35 )
      call level2( tSi35 )
*
*     Si II  2337, atomic data from
*     >>refer Dumont, A.M., & Mathez, G. 1981, A&A, 102, 1
*     coll str
*     >>refer Dufton, P.L., & Kingston, A.E. 1991, MNRAS, 248, 827
*     also
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
      cs = min( 6.0 , 15.836/(te10*te02/te003) )
      call PutCS( 5.5 , t2335 )
      call level2( t2335 )
*
*     Si II 1808, permitted resonance line,
*     osc str from morton et al 88 (apj sup);
*     all si ii collision data (following 4 lines) are from
*     >>refer Dufton, P.L., & Kingston, A.E. 1991, MNRAS, 248, 827
*     following assumes there is typo in table 1 of dufton and kingston
*     and that they meant 2s 2p^2 ^2D instead of 3d
      call PutCS( 13.01 , t1808 )
      call level2( t1808 )
*
      call PutCS( 3.61 , t1527 )
      call level2( t1527 )
*
      call PutCS( 2.89 , t1305 )
      call level2( t1305 )
*
      call PutCS( 12.25, t1260 )
      call level2( t1260 )
*
*     permitted Si III 1206.5, collision strength from
*     >>refer Callaway, J. 1994, ADNDT, 57, 9
      cs = min( 7.0 , 1.442 * te10*te03*te03/te01 )
      call PutCS( cs , t1207 )
      call level2( t1207 )
*
*     Si III] 1895, CS=
*     >>refer Dufton, P.L., & Kingston, A.E. 1989, MNRAS, 241, 209
*     >>refer Callaway, J. 1994, ADNDT, 57, 9
*     a=
*     >>refer Nussbaumer, H. 1986, A&A , 155, 205
*     grnd 3s^2 ^1S, upper lev 3p ^3P^o j=0,1,2
      cs = 106. / (te10*te10*te10*te02)
      call PutCS( cs , t1895 )
      call beseq(1.8 , 3.6 , 10.4 , t1895 ,.013)
      em1895 = PopLevels(3) * 0.013 * 1.05e-11
*
*     Si IV 1394, 1403, data from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs from
*     >>refer Dufton, P.L., & Kingston, A.E. 1987, JPhB, 20, 3899
      cs = 6.37 * te10
      call PutCS( cs*0.667, t1394 )
      call PutCS( cs*0.333, t1403 )
      call PutCS(  1.0 , TauDummy )
      call level3( t1403,TauDummy, t1394)
*
*     Si VI 1.96 micron
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
*     >>chng 96 july 16 had been constant
      cs = max(0.3, min(0.43,0.0448*te20/te003/te003 ))
      call PutCS( cs , Si619 )
      call level2( Si619 )
*
*     Si VII 2148- OIII like,
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c2148 = popexc(0.4,9.,5.,15.,6.7e4,xIonFracs(14,7))*9.26e-12
      call coladd( 'Si 7' , 2148 , c2148  )
*
*     Si VII ground term, 2.48, 6.51 microns
*     cs
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      cs = min( 0.217 , 0.0904*te05*te03/te003/te001 )
      call PutCS( cs , tSi65 )
      cs = min(0.70 , 8.79e-2 *te10*te10/te02 )
      call PutCS( cs , tSi25 )
      cs = min( 0.20 , 9.751e-3 * te20*te03*te03/te003 )
      call PutCS( cs , TauDummy )
      call level3(tSi25,tSi65,TauDummy)
*
*     Si 8 1446, 3727-like,
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1446 = popexc(0.4,4.,10.,1.,9.97e4,xIonFracs(14,8))*1.39E-11
      call coladd( 'Si 8' , 1446 , c1446  )
*
*     Si 9 1985, 2150
*     cs, As from
*     >>refer Aggarwal, K.M. 1983, JPhB, 16, L59
*     >>refer Baluja, K.L. 1985, JPhB, 18, L413
      c949 = pop3(9.,5.,1., 0.5913,0.0757,0.225 , 26.3,214.,5.16 ,
     1 7.62e4 , 7.902e4 , p2 , xIonFracs(14,9) , 0. ) * 214. * 2.096E-11
      c1815 = c949 * 1.912 * 0.0516
      c1985 = p2 * 26.3 * 1.0e-11
      call coladd( 'Si 9' , 949 , c949  )
      call coladd( 'Si 9' , 1815 , c1815  )
      call coladd( 'Si 9' , 1985 , c1985  )
*
*     Si 9 3P fine structure lines, A=
*     >>refer Baluja, K.L. 1985, JPhB, 18, L413
*     2.583, 3.9microns
*     CS=
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      cs01 = min( 0.98 ,
     1 28.51/(te10*te10*te10*te10/te03*te003*te001*te001))
      cs12 = min( 2.7,
     1 81.21/(te10*te10*te10*te10/te01/te01/te001/te001 ) )
      cs02 = min( 0.70, 19.67/ (te10*te10*te10*te10/te03*te001) )
      call PutCS( cs01 , tSi4 )
      call PutCS( cs12 , tSi3 )
      call PutCS( cs02 , TauDummy )
      call level3(tSi4,tSi3,TauDummy)
*
*     5S0 - 3P, cs from, A=guess
*     >>refer Aggarwal, K.M. 1984, ApJS, 54, 1
      c691 = popexc(40.6/sqrte*te10,9.,5.,1e4,2.081e5,xIonFracs(14,9))*
     1 2.88e-11
      call coladd( 'Si 9' , 691 , c691 )
*
*     Si 10 606, actually four lines clumped together.
*     atomic data
*     >>refer Saha, H.P., & Trefftz, E. 1982, A&A, 116, 224
      c606 = 0.10 * 1.42e-16 * expion( 2.4e5 , xIonFracs(14,10) )
      call coladd( 'Si10' , 606 , c606  )
*
*     Si X 1.43m, A from
*     >>refer Chandra, S. 1982, SoPh, 75, 133
*     cs from
*     >>refer Zhang, H.L., Graziani, M., Pradhan, A.K. 1994, A&A, 283, 319
      if( te.le.40500. ) then
        cs = 0.190 * te20/te001
      else
        cs = 24.93 / ( te20*te03*te01*te003*te003 )
      endif
      call PutCS( cs , Si10143 )
      call level2( Si10143 )
*
*     SI 11 582.9, 1909-LIKE, CS=
*     >>refer Berrington, K.A., Burke, P.G., Dufton, P.L., Kingston, A.E.
*     >>refer 1985, ADNDT, 33, 195
*     A=
*     >>refer Muhlethaler, H.P., & Nussbaumer, H. 1976, A&A 48, 109
      c583 = popexc(0.10,1.,9.,1e5,2.47e5,xIonFracs(14,11))*3.4e-11
      call coladd( 'Si11' , 583 , c583  )
*
*     li seq 2s2p and 2s3p, Si XII 499, 521
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 14 , tSi499, tSi41, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , tSi499 )
      call PutCS( cs2s2p*0.5 , tSi521 )
      call PutCS(  1.0 , TauDummy )
      call level3( tSi521,TauDummy, tSi499)
*
      call PutCS( cs2s3p , tSi41 )
      call level2( tSi41 )
*
      end
******************************************************************************
      subroutine sulcol
      implicit none
*compute sulphur cooling
      integer ndfst
      parameter (ndfst=5)
      integer limLevelN
      parameter (limLevelN=20)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real c6731, c10330, c6312, c9532,
     2 c1715, c1213, c1826, c488, c520
*cooling lines of sulphur
      common/cools/ c6731, c10330,c6312, c9532,
     2 c1715, c1213, c1826, c488, c520
      real S6733,S6718,S4070,S4078,S10323,S10289,S10373,S10339
      common/sii/ S6733,S6718,S4070,S4078,S10323,S10289,S10373,S10339
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real gS2(5) , p(5) , exS2(4)
      real popexc,expion,cs2s2p,cs2s3p,pop2,pop3, cs02 , cs01,
     1 cs , cs12 , cs13, cs15,cs14,cs23,cs24,cs25,
     2 cs34,cs35,cs45
      data gS2/4.,4.,6.,2.,4./ , exS2/14851.9,31.5,9640.8,48.6/
*
*     Sulphur II [S II] 6731 + 6716, A
*     >>refer Mendoza, C., & Zeippen, C.J., 1982, MNRAS, 198, 127
*     collision strength from
*     >>refer Ramsbottom, C.A., Bell, K.L., Stafford, R.P. 1996, ADNDT, 63, 57
      call S2cs(alogte,cs12,cs13,cs14,cs15,cs23,cs24,cs25,
     1                 cs34,cs35,cs45)
*     cs13 = min(4.95 , 3.2640828 + 1.9369099*sexp(te/30337.498) )
*     cs12 = cs13 / 1.5
*     cs15 = min( 1.59 , 0.10*te10*te10*te10/te01/te003/te001/te001)
*     cs14 = cs15 * 0.5
*     FIVEL( G(1-5) , ex(wn,1-5), cs12,cs13,14,15,23,24,25,34,35,45,
*            A21,31,41,51,32,42,52,43,53,54, pop(1-5), abund)
      call fivel(gS2, exS2 ,
     1 cs12 , cs13 , cs14 , cs15 , cs23 , cs24 , cs25 ,
     2 cs34 ,cs35 ,cs45 ,
     2 8.82e-4,2.60e-4,9.06e-2,0.225,3.35e-7,0.163,0.133,0.078,0.179,
     3 1.03e-6, p , xIonFracs(16,2) )
      S6733 = p(2)*8.82e-4*2.96e-12
      S6718 = p(3)*2.60e-4*2.962e-12
      S4070 = p(5)*0.225*4.89e-12
      S4078 = p(4)*0.0906*4.88e-12
      S10323 = p(5)*0.179*1.93e-12
      S10289 = p(5)*0.133*1.93e-12
      S10373 = p(4)*0.078*1.92e-12
      S10339 = p(4)*0.163*1.92e-12
      c6731 = S6733 + S6718
      c10330 = S10323+S10289+S10373+S10339
      dCooldT = dCooldT + c6731 * (2.14e4*tsq1 - halfte)
      dCooldT = dCooldT + c10330*2.58*(3.53e4*tsq1 - halfte)
      call coladd( 'S  2' , 6731 , c6731  )
      call coladd( 'S  2' , 10330 , c10330  )
      call coladd( 'S  2' , 4070 , c10330*1.58  )
*
*     SII 1256
*
      cs = max(4.466, min(8.46, -4.9416304 + 47.01064/alogte ))
      call PutCS( cs , t1256 )
      call level2( t1256 )
*
*     S III 18.7M, 33.6M, A
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      cs = min(2.331, 7.935 * te/(te10*te03*te003))
      call PutCS( cs , tS34 )
      if(te.le. 39811. ) then
        cs = min( 5.78 , 3.114*te03*te03 )
      else
        cs = 24.93/(te10*te03*te01/te001/te001)
      endif
      call PutCS( cs , tS19 )
      cs = min(1.413, 0.221 * te*te20/te03*te005 )
      call PutCS( cs , TauDummy )
      call level3(tS34,tS19,TauDummy)
*
*     S III O III-like lines, A from
*     >>refer Mendoza, C., & Zeippen, C.J. 1982, MNRAS, 199, 1025
*     CS from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      cs = min( 2.05 , 0.0821*te30)
      c6312 = pop3( 9.,5.,1.,  7.98,1.14,cs , 7.97E-2,0.807,2.22,
     1 1.55e4,2.28e4 ,pop2,xIonFracs(16,3),0.) * 2.22 * 3.15e-12
*     folowing is 9532 + 9069 together (OIII-like)
      c9532 = pop2 * 7.93e-2 * 2.11e-12
      call coladd( 'S  3' , 6312 , c6312  )
      call coladd( 'S  3' , 9532 , c9532  )
      call coladd( 'S  3' , 3722 , c6312*0.59  )
*
*     S III 1194, data from
*     >>refer Ho, Y.K., & Henry,R.J.W. 1984, ApJ, 282, 816
*     >>chng 97 may 17, to, about 2x larger than above
*     >>refer Tayal, S.S. 1997, ApJ 481, 550
      if( te.le.3e4) then
        cs = 12.04/(te02*te02)
      else if( te.gt.3e4 .and.te.le.4e4 ) then
        cs = 7.97
      else
        cs = 55.42 / (te20/te02*te003)
      endif
      call PutCS( cs , t1194 )
      call level2( t1194 )
*
*     S III] 1713.12, 1728.94, cs from
*     >>refer Hayes, M.A., 1986, J Phys B 19, 1853.
*     cs = min( 4.0 , 7.794 / (te10/te02/te001/te001)  )
*     >>chng 97 may 17, about 20% smaller than before
*     >>refer Tayal, S.S. 1997, ApJ 481, 550
      if( te.le.3e4 ) then
        cs = 1.786 * te05*te01*te001
      else
        cs = 9.392 / te10
      endif
      call PutCS( cs , tS1720 )
      call level2( tS1720 )
*
*     S IV 10.5MI, CS and A FROM
*     >>refer Johnson, C.T., Kingston, A.E., Dufton, P.L. 1986, MNRAS, 220, 155
*     >>chng 97 feb 14, error in cs below t = 10,000K
*     >>chng 96 dec 19, to CS from
*     >>refer Saraph, H.E., Storey, P.J., & Tully, J.A. 1995, 5th International
*     >>refer Colloquium on Atomic Spectra and Oscillator Strengths, ed. by
*     >>refer W.-U L.  Tchang-Brillet, J.-F. Wyart, C.J. Zeippen,
*     >>refer (Meudon: Publications de l'Observaroire de Paris), p.110
*     above said to be A&A in press
      if( te.lt.1e4 ) then
        cs = 3.71*te10/te01
      else
        cs = min( 8.5 , 19.472/(te10/te01) )
      endif
      call PutCS( cs , tS11 )
      call level2( tS11 )
*
*     S IV 1406, cs from
*     >>refer Dufton, P.L., Hibbert, A., Kingston, A.E., & Doschek, G.A. 1982,
*     >>refer ApJ, 257, 338
      cs = 16.67 / (te10*te02)
      call PutCS( cs , t1406 )
      call level2( t1406 )
*
*     S V Be-seq line, A=
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     all cs
*     >>refer Dufton, P.L., Hibbert, A., Keenan, F.P, Kingston, A.E., &
*     >>refer Doschek, G.A. 1986, ApJ, 300, 448
*     and
*     >>refer Dufton, P.L., & Kingston, A.E. 1984, JPhB, 17, 3321
      cs = min(1.58 , 35.372/(te10*te10*te10) )
      call PutCS( cs , t1198 )
*     cs01 = min(1.98, 29.625/(T**0.25))
      cs01 = min(1.98, 29.625/(te20*te05 ) )
*     cs02 = min(2.26, 13.477/(T**0.165))
      cs02 = min(2.26, 13.477/(te10*te03*te03*te005) )
*     cs12 = min(7.59, 63.994/(T**0.197))
      cs12 = min(7.59, 63.994/(te20/te003) )
*     beseq(cs23,cs24,cs34,tarray,a41)
*     call beseq( 1.98 , 2.26 , 7.59, t1198 ,.066)
      call beseq( cs01 , cs02 , cs12 , t1198 ,.066)
      em1198 = PopLevels(3) * 0.066 * 1.66e-11
*
*     S V 786
*     cs from
*     >>refer Dufton, P.L., & Kingston, A.E. 1984, JPhB, 17, 3321
      call PutCS( 8.3 , t786 )
      call level2( t786 )
*
*     S VI, Li sequence, A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     CS from
*     >>refer Dufton, P.L., & Kingston, A.E. 1987, JPhB, 20, 3899
      cs = 11.9
      call PutCS( cs*0.667, t933 )
      call PutCS( cs*0.333, t944 )
      call PutCS(  1.0 , TauDummy )
      call level3( t944,TauDummy, t933)
*
*     S VIII 9913
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.192 , min( 0.291, 0.0289*te20/te01*te001 ) )
      call PutCS( cs , fsS810 )
      call level2( fsS810 )
*
*     S IX 1715, 1987,
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1715 = popexc(0.4,9.,5.,80.,8.39e4,xIonFracs(16,9))*1.16E-11
      call coladd( 'S  9' , 1715 , c1715  )
*
*     S IX 1.25, 3.78 microns
*     cs
*     >>refer Butler, K., & Zeippen, C.J. 1994, A&AS, 108, 1
      cs = min( 3.10 , 277.2/(sqrte/te003) )
      call PutCS( cs , fsS912 )
      cs = min( .50 , 7.940/(te10*te10*te10) )
      call PutCS( cs , fsS938 )
      cs = min( 1.1, 195.72/(sqrte*te03*te03*te01*te003*te001) )
      call PutCS(cs  , TauDummy )
      call level3( fsS912 , fsS938 ,TauDummy )
*
*     S X 1213, 1197,
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1213 = popexc(0.28,4.,6.,6.,1.19e5,xIonFracs(16,10))*1.64E-11
      call coladd( 'S 10' , 1213 , c1213  )
*
*     S XI 1.91, 1.40 microns, cs
*     >>refer Lennon, D.J. Burke, V.M. 1994, A&AS, 103, 273
      cs = min( 0.22 , 0.0151*te20*te03*te001*te001 )
      call PutCS( cs , fsS1119 )
      cs = min( 0.6 , 0.0168*te10*te10*te10*te01 )
      call PutCS( cs , fsS1114 )
      cs = min( 0.15 , 1.5e-3*te30*te10*te005 )
      call PutCS( cs , TauDummy )
      call level3( fsS1119 , fsS1114 ,TauDummy )
*
*     S XI 1615, 1826,
*     >>refer Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1826 = popexc(0.3,9.,5.,100.,8.92e4,xIonFracs(16,11))*1.23e-11
      call coladd( 'S 11' , 1615 , c1826  )
*
*     S XII 7611.2, cs from
*     >>refer Oliva, E., Pasquali, A., & Reconditi, M. 1996, A&A, 305, 210
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     >>refer Saha, H.P., & Trefftz, E. 1983, SoPh, 87, 233
      call PutCS( 0.135 , fsS1207 )
      call level2( fsS1207 )
*
*     S XII 520, actually group of four intercombination lines
*     all atomic data from
*     >>refer Saha, H.P., & Trefftz, E. 1983, SoPh, 87, 233
      c520 = 0.03 * 1.65e-16 * expion( 2.8e5 , xIonFracs(16,12) )
      call coladd( 'S 12' , 520 , c520  )
*
*     S XIII 488.4, 1909-like
      c488 = popexc(0.11,1.,9.,3.3e5,2.948e5,xIonFracs(16,13))*4.07E-11
      call coladd( 'S 13' , 488 , c488  )
*
*     li seq 2s2p and 2s3p, S XIV 418, 446
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 16 , tSu418, tSu30, cs2s2p , cs2s3p )
      call PutCS( cs2s2p , tSu418 )
      call PutCS( cs2s2p*0.5 , tSu446 )
      call PutCS(  1.0 , TauDummy )
      call level3( tSu446,TauDummy, tSu418)
*
      call PutCS( cs2s3p , tSu30 )
      call level2( tSu30 )
*
      end
******************************************************************************
      subroutine clcol
      implicit none
*compute chlorine cooling
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real c8579, c6164, c3679 , c5525, c3350,
     1 c8494, Cl5539, Cl5519, Cl3354, Cl3344, Cl8504, Cl8436,
     2 Cl8552, Cl8483, c8047, c3119, c5324
      common/coolcl/ c8579, c6164, c3679 , c5525, c3350,
     1 c8494, Cl5539, Cl5519, Cl3354, Cl3344, Cl8504, Cl8436,
     2 Cl8552, Cl8483, c8047, c3119, c5324
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     local variables
      real gcl3(5) , p(5) , excl3(4)
      real a21,a31,a32,p3,p2,pop3,cs12,cs13,cs14,a41,cs15,a51,
     1 cs23,cs24,a42,cs25,a52,cs34,a43,cs35,a53,cs45
      real a54,cs32,cs31,pop2 , cs
      data gcl3/4.,4.,6.,2.,4./ , excl3/18053.,66.,11693.,95./
*
*     cooling due to clorine lines
*
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      a21 = 0.133
      a31 = 1.33
      a32 = 2.06
      p3 = pop3( 9.,5.,1. , 3.86,0.456,1.15,a21,a31,a32,
     1 1.576e4,23344.,p2,xIonFracs(17,2),0.)
*     [Cl II] 8581, 9127 doublet
      c8579 = p2 * a21 * 2.32e-12
      call coladd( 'Cl 2' , 8579 , c8579  )
*     [Cl II] 6164 auroral line
      c6164 = p3 * a32 * 3.23e-12
      call coladd( 'Cl 2' , 6164 , c6164  )
*     [Cl II] 3679
      c3679 = p3 * a31 * 5.41e-12
      call coladd( 'Cl 2' , 3679 , c3679  )
*
*     [SII] - like doublet, vac lam=5519, 5539
*     all data from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
      cs12 = 1.26
      a21 = 4.83e-3
*
      cs13 = 1.88
      a31 = 7.04e-4
*
      cs14 = 0.627
      a41 =  0.305
*
      cs15 = 1.26
      a51 = 0.754
*
      cs23 = 3.19
      a32 = 3.22e-6
*
      cs24 = 1.24
      a42 = 0.303
*
      cs25 = 1.91
      a52 = 0.323
*
      cs34 = 1.38
      a43 = 0.100
*
      cs35 = 3.33
      a53 = 0.316
*
      cs45 = 1.34
      a54 = 7.65e-6
*
      call fivel(gcl3, excl3 , cs12 , cs13 , cs14 , cs15 , cs23 ,
     1 cs24 , cs25 , cs34 , cs35 , cs45 , a21,a31,a41,a51,a32,a42,a52,
     2 a43, a53, a54, p , xIonFracs(17,3) )
*
      Cl5539 = p(2)*a21 *3.59e-12
      Cl5519 = p(3)*a31 *3.61e-12
      Cl3354 = p(4)*a41 *5.93e-12
      Cl3344 = p(5)*a51 *5.95e-12
      Cl8504 = p(4)*a42 *2.34e-12
      Cl8436 = p(5)*a42 *2.36e-12
      Cl8552 = p(4)*a43 *2.33e-12
      Cl8483 = p(5)*a53 *2.35e-12
*
*     following are whole multiplets
      c5525 = Cl5539 + Cl5519
      c3350 = Cl3354 + Cl3344
      c8494 = Cl8504+Cl8436+Cl8552+Cl8483
      dCooldT = dCooldT + c5525 * (2.14e4*tsq1 - halfte)
      call coladd( 'Cl 3' , 5525 , c5525  )
      call coladd( 'Cl 3' , 3354 , c3350  )
      call coladd( 'Cl 3' , 8494 , c8494  )
*
*     [Cl III] IR lines
*     As from
*     >>refer Mendoza, C., & Zeippen, C.J. 1983, MNRAS, 202, 981
*     cs
*     >>refer Krueger, T.K., & Czyzak, S.J. 1970, Pro Roy Soc Lond, 318, 531
      call PutCS( 2.17 , fsCl214 )
      call PutCS( 0.93 , fsCl233 )
      call PutCS( 1.00 , TauDummy )
*     level3(  t10,t21,t20)
      call level3(fsCl214,fsCl233,TauDummy)
*
*     [CL IV], like [OIII]
*     cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      a21 = 0.251
      cs12 = 6.437
      a32 = 2.80
      cs32 = min(2.1, 0.0450 * te30*te03*te03)
      a31 = 2.50
      cs31 = 1.922
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      p3 = pop3( 9.,5.,1., cs12,cs13,cs23, a21,a31,a32,
     1 2.24e4 , 3.11e4 , pop2 ,xIonFracs(17,3),0.)
*     whole 2-1 transition
      c8047 = pop2 * a21 * 2.48e-12
      call coladd( 'Cl 4' , 8047 , c8047  )
      dCooldT = dCooldT + c8047 * (2.24e4*tsq1 - halfte)
*     3-1 transition
      c3119 = p3 * a31 * 6.38e-12
      call coladd( 'Cl 4' , 3119 , c3119  )
*     3-2 transition
      c5324 = p3 * a32 * 3.74e-12
      call coladd( 'Cl 4' , 5324 , c5324  )
*
*     [Cl IV] fine structure lines, 20.354, 11.741 microns
      cs = max(1.6,min(2.7,6.637/(te10*te03*te01) ) )
      call PutCS( cs, Cl04203 )
      cs = min( 8.0, 15.65/te10 )
      call PutCS( cs, Cl04117 )
      cs = min( 2.0, 5.805/(te10*te03) )
      call PutCS( cs, TauDummy )
*     level3(  t10,t21,t20)
      call level3(Cl04203,Cl04117,TauDummy)
*
*     [Cl IX] 7335 A,
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.28 , Cl973 )
      call level2( Cl973 )
*
*     [Cl X] 3.05m, 9223A
      cs = max(0.096 , min(0.187,6.686e-3*te30/te001 ) )
      call PutCS( cs , Cl1030 )
      cs = max(0.229 , min(0.568,9.432e-3*te30*te03*te03/te003/te001 ) )
      call PutCS( cs , Cl1092 )
      cs = max(0.048 , min(0.148,7.088e-4*sqrte/te03/te003/te003) )
      call PutCS( cs , TauDummy )
      call level3( Cl1092 , Cl1030 , TauDummy )
*
      end
******************************************************************************
      subroutine arcol
      implicit none
*compute argon cooling
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer ndfst
      parameter (ndfst=5)
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*all argon coolants not carried in line transfer arrays
      real c7136, c7007, fs4413, c409, c5192 , c3109,
     1 Ar4740, Ar4711, Ar2868, Ar2854, Ar7263, Ar7171, Ar7331,Ar7237
      common/coolar/ c7136, c7007,fs4413,c409, c5192 , c3109,
     1 Ar4740, Ar4711, Ar2868, Ar2854, Ar7263, Ar7171, Ar7331,Ar7237
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     local variables
      real popexc,cs2s2p,cs2s3p , cs12 , cs , pop3,pop2,popn3
      real a12,cs13,a13,cs14,a14,cs15,a15,cs23,a23,cs24,a24,cs25,a25,
     1 cs34,a34,cs35,a35,cs45,a45
      real gAr4(5) , p(5) , exAr4(4)
      data gAr4/4.,4.,6.,2.,4./ , exAr4/21090.4, 128.9, 13636.2, 177.1/
*
*     Argon II 6.98 micron
*     trans prob from
*     >>refer Nussbaumer, H., & Storey, P.J. 1988, A&A, 200, L25
*     Y(ik) from
*     >>refer  Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 3.1 , tAr7 )
      call level2( tAr7 )
*
*     A III 7136, 7751, 3109, 5192 CS
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     c7136 = popexc(4.825,9.,5.,0.403,1.955e4,xIonFracs(18,3))*2.7e-12
*     call coladd( 'Ar 3' , 7136 , C7136  )
*     >>chng 97 mar 19, break up into three level atom
      cs12 = 4.825
      cs13 = 0.841
      cs23 = min(  1.30  ,  3.296/(te10*te01/te001/te001)  )
      a12 = 0.3963
      a23 = 2.59
      a13 = 3.952
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      popn3 = pop3( 9.,5.,1.,cs12,cs13,cs23,a12 ,a13 ,a23 ,
     1 1.955e4,2.770e4 , pop2,xIonFracs(18,3) ,0.)
      c7136 = pop2*a12*2.7e-12
      c5192 = popn3*a23*3.83e-12
      c3109 = popn3*a13*6.40e-12
      call coladd( 'Ar 3' , 7136 , c7136  )
      dCooldT = dCooldT + c7136*1.955e4*tsq1
      call coladd( 'Ar 3' , 5192 , c5192  )
      call coladd( 'Ar 3' , 3109 , c3109  )
*
*     Ar III 21.8(J=0,1), 9.0 (J=1,2) mircon lines,
*     CS
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      call PutCS( 3.1, tAr9 )
      cs = min( 1.384, 3.110/(te10/te001*te001) )
      call PutCS( cs   , tAr22 )
      if( te.lt.1e4 ) then
        cs = 0.671
      else
        cs = min( 0.906 , 0.150*te20/te02/te02*te003 )
      endif
      call PutCS( cs , TauDummy )
      call level3(tAr9,tAr22,TauDummy)
*
*     Argon IV 4711+4740, 7335 lines (O II like)
*     CS from
*     >>refer Zeippen, C.J., Le Bourlot, J., Butler, K. 1987, A&A, 188, 251
*     expression is 1-3 by itself, convert to whole mult by *2.5
*     cs12 = min(3., 93.094/(sqrte/te10*te02) ) * 2.5
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     C7335 = POP3( 4.,10.,6., cs12 ,0.476,10.2 , 0.0103,1.7,1.16,
*    1 3.13e4 , 1.98e4 , pop2 ,xIonFracs(18,4),0.) * 1.16*2.75E-12
*     c4740 = pop2 * 0.0103 * 4.2e-12
*
*     >>chng 97 jan 31, increase to full 5 level atom
*     Ar IV, cs data from
*     >>refer Ramsbottom, C.A., Bell., K.L., & Keenan, F.P., 1997,
*     >>refer MNRAS 284, 754
*     differs by 2-3x from older values
*     temp dependence form
*     >>refer Ramsbottom, C.A., & Bell, K.L. 1997, ADNDT, 66, 65
      cs12 = min( 0.853 , max(0.761, 0.481*te05 ) )
      a12 = 2.23e-2
      cs13 = 1.16
      cs13 = min(1.3 , max(1.14,0.719*te05 ))
      a13 = 1.77e-3
      cs14 = min( 0.5 , max(0.39 , 0.108*te10*te02*te02 ) )
      a14 = 0.862
      cs15 = min( 1.0 , max(0.78 , 0.216 *te10*te02*te02 ) )
      a15 = 2.11
      cs23 = 7.06
      a23 = 2.30e-5
      cs24 = min(1.96, max(1.53,0.346*te10*te05 ) )
      a24 = 0.603
      cs25 = min( 2.65 , max(2.18, 0.664*te10*te02 ) )
      a25 = 0.789
      cs34 = min(1.89 , max(1.56 , 0.475*te10*te02 ) )
      a34 = 0.119
      cs35 = min( 5.03 , max(4.01, 1.00*te10*te02*te02 ) )
      a35 = 0.598
      cs45 = 0.0359 * te20*te20*te02*te02
      a45 = 4.94e-5
*     FIVEL( G(1-5) , ex(wn,1-5), cs12,cs13,14,15,23,24,25,34,35,45,
*            A21,31,41,51,32,42,52,43,53,54, pop(1-5), abund)
      call fivel(gAr4, exAr4 ,
     1 cs12 , cs13 , cs14 , cs15 , cs23 , cs24 , cs25 ,
     2 cs34 ,cs35 ,cs45 ,
     3 a12,a13,a14,a15,a23,a24,a25,a34,a35,a45,
     3 p , xIonFracs(18,4) )
      Ar4740 = p(2)*a12*4.20e-12
      Ar4711 = p(3)*a13*4.20e-12
      Ar2868 = p(4)*a14*6.94e-12
      Ar2854 = p(5)*a15*6.94e-12
      Ar7263 = p(4)*a24*2.74e-12
      Ar7171 = p(5)*a25*2.74e-12
      Ar7331 = p(4)*a34*2.74e-12
      Ar7237 = p(5)*a35*2.74e-12
      dCooldT = dCooldT + (Ar4740+Ar4711) * (3.04e4*tsq1 - halfte)
      dCooldT = dCooldT + (Ar2868+Ar2854+Ar7263+Ar7171+Ar7331+Ar7237)*
     1 (5.02e4*tsq1 - halfte)
      call coladd( 'Ar 4' , 7335 , Ar7263+Ar7171+Ar7331+Ar7237  )
      call coladd( 'Ar 4' , 4740 , Ar4740+Ar4711  )
      call coladd( 'Ar 4' , 2868 , Ar2868+Ar2854  )
*
*     Argon V 6435+7007, A from
*     >>refer Mendoza, C., & Zeippen, C.J. 1982, MNRAS, 199, 1025
*     CS from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21, excit in Kelvin
      if( te.lt.1e4 ) then
        cs = 3.09
      else
        cs = min(4.454, 0.634 * te20/te03*te001*te001)
      endif
      c7007 = popexc( cs,9.,5.,0.68,2.055e4,xIonFracs(18,5))*2.84E-12
      call coladd( 'Ar 5' , 7007 , c7007  )
*
*     Ar V 3P fine structure lines , A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs=
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     >>chng 96 july 16, bug upward change in collision strengths from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
      cs = min(3.26, 26.27 /(te20*te03*te01*te003))
      call PutCS( cs , tAr13 )
      cs = min(8.47, 44.31 / (te20/te003/te003))
      call PutCS( cs , tAr8 )
      cs = min(1.95, 7.280 / (te10*te05*te005))
      call PutCS( cs , TauDummy )
      call level3(tAr13,tAr8,TauDummy)
*
*     [Ar VI] 4.53 micron, cs from
*     >>refer Saraph, H.E., & Storey, P.J. A&AS, 115, 151
*     call PutCS( .8 , Ar06453 )
*     >>chng 96 Dec 11, cs should have been 6.33, caught by Simon Casassus
      call PutCS( 6.33 , Ar06453 )
      call level2( Ar06453 )
*     fs4p5 = popexc( 0.8, 2.,4., 9.7e-2, 3174.3,xIonFracs(18,6))
*    1 * 4.39E-13
*     call coladd( 'Ar 6' , 4 , FS4P5  )
*
*     [ArX] 5533.4A, cs
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = min( 0.573 , 20.05/(te30*te03*te005 ) )
      call PutCS( cs , Ar1055 )
      call level2( Ar1055 )
*
*     [Ar XI] 2.60, microns, 6917A
      cs = max(0.09 , min(0.207,2.685e-3*te20*te20*te001*te001 ) )
      call PutCS( cs , Ar1126 )
      cs = max(0.25 , min(0.64,0.0127 *te30*te05*te001*te001 ) )
      call PutCS( cs , Ar1178 )
      cs = max(0.06 , min(0.17,2.789e-3 *te30*te05*te02/te003 ) )
      call PutCS( cs , TauDummy )
      call level3( Ar1126 , Ar1178 , TauDummy )
*
*     Ar X IV 4413, wavelength+a from
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
*     cs is guess
      fs4413 = popexc(0.2,2.,4.,105.,3.259e4,xIonFracs(18,14))*4.51e-12
      call coladd( 'Ar14' , 4413 , fs4413  )
*
*     Ar 15 409A, Be seq interpolated lambda, cs, A.
      c409 = popexc(0.1,1.,9.,1.1e6,3.52e5,xIonFracs(18,15))*4.86e-11
      call coladd( 'Ar15' , 409 , c409  )
*
*     Ar 16 365, 25, Li Seq
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 18 , t354, t25, cs2s2p , cs2s3p )
*
      call PutCS( cs2s2p , t354 )
      call level2( t354 )
*
*     funny factor (should have been 0.5) due to energy change
      call PutCS( cs2s2p*0.454 , t389 )
      call level2( t389 )
*
      call PutCS( cs2s3p , t25 )
      call level2( t25 )
*
      end
******************************************************************************
      subroutine PhosCol
      implicit none
*compute phosphorus cooling
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
*
*     local variables
      real cs
*
*     [P II] 60.64, 32.87 microns
*     cs, As from
*     >>refer Mendoza, C., & Zeippen, C.J., 1982, MNRAS 199, 1025
*     >>refer Krueger, T.K., and Czyzak, S.J., 1970,
*     >>refer Proc Roy Soc London A 318, 531
      call PutCS( 1.587 , P0260 )
      call PutCS( 3.566 , P0233 )
      call PutCS( 1.0 , TauDummy )
*     level3(  t10,t21,t20)
      call level3( P0260 , P0233 , TauDummy )
*
*     [P III] 17.885 microns
*     CS, A from
*     >>refer Kaufman, V., & Sugar, J., 1986, J Phys Chem Ref Data 15, 321
*     >>refer Krueger, T.K., and Czyzak, S.J., 1970,
*     >>refer Proc Roy Soc London A 318, 531
      call PutCS( 1.859 , P0318 )
      call level2( P0318 )
*
*     [P VII] 1.374 microns
*     cs from Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.27, P713 )
      call level2( P713 )
*
*     [P VIII] 4.85, 1.735 microns
      call PutCS( 0.30 , P848 )
      call PutCS( 0.97 , P817 )
      call PutCS( 0.26 , TauDummy )
*     j levels inverted
      call level3( P817 , P848 , TauDummy )
*
*     [P X] 2.708, 1.868 microns
      cs = min( 0.33 , 0.892/(te10/te001) )
      call PutCS( cs , P1027 )
      cs = min( 1.082 , 5.949/(te20/te03*te003) )
      call PutCS( cs , P1018 )
      cs = min( 0.33 , 3.054/(te20*te02*te005 ) )
      call PutCS( cs , TauDummy )
      call level3( P1027 , P1018 , TauDummy )
*
      end
******************************************************************************
      subroutine PotCol
      implicit none
*compute potassium cooling
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
*
*     local variables
      real cs
*
*     potasium lines
*     KI 7745
      cs = 7.231e-4 * te*te03*te02
      call PutCS( cs, KI7745 )
      call level2( KI7745 )
*
*     [K III] 4.62 microns
*     Y(ik) from
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 2.2, xK03462 )
      call level2( xK03462 )
*
*     [KIV] 5.983, 15.39 mic, cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      call PutCS( 4.3  , xK04598 )
      call PutCS( 1.13 , xK04154 )
      call PutCS( 1.3  , TauDummy )
*     level3(  t10,t21,t20)
      call level3(  xK04598 ,xK04154,TauDummy )
*
*     [KVI] 8.823, 5.575 mic, cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
      cs = min( 1.505,0.274*te10*te05/te001/te001 )
      call PutCS( cs  , xK06882 )
      cs = max( 4.0 , min(4.632 , 1.909*te10/te003) )
      call PutCS( cs , xK06557 )
      call PutCS( 1.2  , TauDummy )
      call level3(  xK06882 ,xK06557,TauDummy )
*
*     [K VII] 3.189 microns cs from
*     >>refer Saraph, H.E., & Storey, P.J. A&AS, 115, 151
      call PutCS( 4.5 , xK07319 )
      call level2( xK07319 )
*
*     K 11 4249.99A, cs from
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.111, min( 0.172 , 0.0109*te20*te02/te001/te001 ) )
      call PutCS( 0.115, xK11425 )
      call level2( xK11425 )
*
      end
******************************************************************************
      subroutine calcol
      implicit none
*compute calcium cooling
      integer ndfst
      parameter (ndfst=5)
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real Cair, c7306, Cakh, Ca3688 , Ca2112 , Ca5620 , Ca4941 ,
     1 c3997, c2414, Ca6087, c5311,cCa302,cCa345,cCa19
      common/coolca/ Cair, c7306, Cakh, Ca3688 , Ca2112 , Ca5620 ,
     1 Ca4941 , c3997, c2414, Ca6087, c5311,cCa302,cCa345,cCa19
      real hi , hii
      common/h/ hi , hii
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real Ca2RmLya
*amount of Lya removed by photoionization of excited CaII levels
      common/ca2mly/ Ca2RmLya
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real dstCala , dCakh , dCaf12 , Ca3d , Ca4p
*parameters dealing with dest of CaII by Lya
      common/dcala/ dstCala , dCakh , dCaf12 , Ca3d , Ca4p
*     include "fcakh.com"
      real Cak,Cah,Cax,Cay,Caz,Caf1,Caf2
      common/caline/ Cak,Cah,Cax,Cay,Caz,Caf1,Caf2
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real opac
      common/opac/ opac(ncell)
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real pca2ex
      common/pca2ex/ pca2ex
      real escah , pmcah , ecah , tpcah , conca , conhe
      common/pmpcah/ escah , pmcah , ecah , tpcah(2) , conca , conhe
      real oldcla
      common/oldcla/ oldcla
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
*
*     local variables
      real Ca2pop(5)
      real gCa2(5) , exCa2(4)
      save opCax , opCay , opCaz
      real opCax,opCay,opCaz,a21,a31,a41,a51,a42,a52,a53,opcxyz,
     1 d52,d53,d42,opckh,op51,op41,d51,d41,r21,r31,r41,r51,r42,r52,
     2 p51,p41,p31,p21,pop3,p2,p3,cs2s2p,cs2s3p,r53,cs14,cs15,
     3 hlgam,c21 , cs , cs01 , cs02 , cs12
      data gCa2/2.,4.,6.,2.,4./ , exCa2/13650.2,60.7,11480.6,222.9/ ,
     2 opCax , opCay , opCaz /3*0./
*
*     Ca I 4228
      call MakeCS( CaI4228 )
      call level2( CaI4228 )
*
*     photoionization of evcited levels by Ly-alpha
      hlgam = otslin( iphl(2,1) )
      p51 = 1.7e-18 * hlgam
      p41 = 8.4e-19 * hlgam
      p31 = 7.0e-18 * hlgam
      p21 = 4.8e-18 * hlgam
*     spontaneous decays
*     frist two trans prob from
*     >>refer Zeippen, C.J. 1990, A&A, 229, 248
      a21 = 1.02 * t7324(ipLnEscP)
      a31 = 1.05 * t7291(ipLnEscP)
      a41 = 1.4e8 * t3969(ipLnEscP)
      a51 = 1.4e8 * t3934(ipLnEscP)
      a42 = 7.9e6 * t8662(ipLnEscP)
      a52 = 8.2e5 * t8498(ipLnEscP)
      a53 = 7.48e6 * t8542(ipLnEscP)
*     destruction of IR triplet by continuous opacities
      opcxyz = opac(int(t7324(ipLnIpCont)))
*     opcxyz = opac(icaxyz)
      if( opcxyz .gt. 0. ) then
        d52 = 5.6 * opcxyz / (opcxyz + opCax) * (1.-t8498(ipLnEscP))
        d53 = 5.6 * opcxyz / (opcxyz + opCay) * (1.-t8542(ipLnEscP))
        d42 = 5.6 * opcxyz / (opcxyz + opCaz) * (1.-t8662(ipLnEscP))
      else
        d52 = 0.
        d53 = 0.
        d42 = 0.
      endif
*     near UV dest of KH by background continuum
      opckh = opac(int(t3969(ipLnIpCont)))
*     opckh = opac(icakh)
      if( opckh .gt. 0. ) then
        op51 = xIonFracs(20,2) * 3.89e-7 / doppler(20)
        d51 = 5.6 * opckh / (opckh + op51 )
        op41 = xIonFracs(20,2) * 1.96e-7 / doppler(20)
        d41 = 5.6 * opckh / (opckh + op41 )
      else
        op51 = 0.
        d51 = 0.
        op41 = 0.
        d41 = 0.
      endif
*     net rates
      r21 = p21 + a21
      r31 = p31 + a31
      r41 = a41 + p41 + d41
      r51 = a51 + p51 + d51
      r42 = a42 + d42
      r52 = a52 + d52
      r53 = a53 + d53
      cs14 = 0.923*te10*te10
      cs15 = cs14 * 2.
      t3969(ipLnCS) = cs14
      t3934(ipLnCS) = cs15
*     following used to correct rec contribution
*     fcakh = a51 / ( a51 + eden*1.5e-5 / sqrte )
*     cs 1-2 from
*     >>refer Saraph, H.E. 1970, JPhB, 3, 952
*     other
*     >>refer Chidichimo, M.C. 1981, JPhB, 14, 4149
      call fivel( gCa2 , exCa2 ,
     1 5.8 , 8.6 , cs14 , cs15 , 20.6 , 22.9 , 9.8 , 3.4 , 44.4 , 1.0 ,
     2 r21 , r31 , r41 , r51 , 0. , r42 , r52 , 0. ,
     3 r53 , 0., Ca2pop , xIonFracs(20,2) )
*     CDSQTE = 8.629E-6*EDEN/SQRTE
      c21 = 5.8 / 4. * cdsqte
*     remember largest ratio of Ly-al removal to total
      if(xIonFracs(20,2).gt.0.) then
        Ca2RmLya = max( Ca2RmLya , p21 / ( p21 + a21 + c21 ) )
      endif
      Cak = Ca2pop(5) * a51 * 5.06e-12
      Cah = Ca2pop(4) * a41 * 5.01e-12
      Cax = Ca2pop(5) * a52 * 2.34e-12
      Cay = Ca2pop(5) * a53 * 2.33e-12
      Caz = Ca2pop(4) * a42 * 2.30e-12
      Caf1 = Ca2pop(3)* a31 * 2.73e-12
      Caf2 = Ca2pop(2)* a21 * 2.72e-12
      pca2ex = Ca2pop(2) + Ca2pop(3) + Ca2pop(4) + Ca2pop(5)
      Cair = Cax + Cay + Caz
      c7306 = Caf1 + Caf2
      Cakh = Cak + Cah
      call coladd( 'Ca 2' , 7306 , c7306  )
      call coladd( 'Ca 2' , 8400 , Cair  )
      call coladd( 'Ca 2' , 3800 , Cakh  )
      dstCala = Ca2pop(5)*p51 + Ca2pop(4)*p41
      dCakh = dstCala * 5.03e-12
      dCaf12 = ( Ca2pop(3)*p31 + Ca2pop(2)*p21 ) * 2.31e-12
      opCax = Ca2pop(2) * 1.13e-8 / doppler(20)
      opCay = Ca2pop(3) * 6.87e-8 / doppler(20)
      opCaz = Ca2pop(2) * 5.74e-8 / doppler(20)
*     total rate Lalpha destroys CaII
      if( xIonFracs(20,2).gt.0. ) then
        dstCala = ( dstCala + dCaf12 / 2.31e-12 ) / xIonFracs(20,2)
        dstCala = (dstCala + oldcla) / 2.
        oldcla = dstCala
      else
        dstCala = 0.
      endif
      Ca3d = Ca2pop(2) + Ca2pop(3)
      Ca4p = Ca2pop(4) + Ca2pop(5)
*     incl stimulated emission for Calcium II 5-level atom
      t3934(ipLnPopOpc) = Ca2pop(1)-Ca2pop(5)/2.
      t3934(ipLnPopu) = Ca2pop(5)
      t3934(ipLnPopl) = Ca2pop(1)
      t3969(ipLnPopOpc) = Ca2pop(1)-Ca2pop(4)
      t3969(ipLnPopu) = Ca2pop(4)
      t3969(ipLnPopl) = Ca2pop(1)
      tpcah(1) = t3969(1)
      t8498(ipLnPopOpc) = Ca2pop(2)-Ca2pop(5)
      t8498(ipLnPopu) = Ca2pop(5)
      t8498(ipLnPopl) = Ca2pop(2)
      t8542(ipLnPopOpc) = Ca2pop(3)-Ca2pop(5)*1.5
      t8542(ipLnPopu) = Ca2pop(5)
      t8542(ipLnPopl) = Ca2pop(3)
      t8662(ipLnPopOpc) = Ca2pop(2)-Ca2pop(4)*2.
      t8662(ipLnPopu) = Ca2pop(4)
      t8662(ipLnPopl) = Ca2pop(2)
      t7291(ipLnPopOpc) = xIonFracs(20,2)
      t7291(ipLnPopu) = 0.
      t7291(ipLnPopl) = xIonFracs(20,2)
      t7324(ipLnPopOpc) = xIonFracs(20,2)
      t7324(ipLnPopu) = 0.
      t7324(ipLnPopl) = xIonFracs(20,2)
*
*     Ca IV 3.2 micron; data from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     Y(ik) from
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      if( te.le.1e5 ) then
        cs = max( 1.0 , 8.854e-3 *sqrte )
      else if( te.lt.2.512e5 ) then
        cs = 2.8
      else
        cs = 641.1 / (te30*te10*te02*te02/te003)
      endif
      call PutCS( cs , tCa3 )
      call level2( tCa3 )
*
*     [Ca V] IR 4.16, 11.47 micron; A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     >>chng 96 july 16, big changes in cs
      cs = max(2.2, min(3.3, 0.392 * te20/te005/te003))
      call PutCS( cs , tCa4 )
*     >>chng 96 aug 02, following had error in te dep in ver 90.01
      cs = max(0.67, min(0.93, 0.162 * te10*te05*te003*te001))
      call PutCS( cs , tCa12 )
      cs = max(0.60, min(0.97, 0.0894 * te20*te01*te005))
      call PutCS( cs , TauDummy )
      call level3(tCa4,tCa12,TauDummy)
*
*     Ca V lines from 1d, 1s; A from
*     >>refer Mendoza, C. 1982, in Planetary Nebulae, IAU Symp No. 103,
*     >>refer ed by D.R. Flower, (D. Reidel: Holland), 143
*     cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      cs01 = max(2.8, min(4.1, 0.533 * te20/te01))
      cs02 = min(0.87, 5.22e-03 * sqrte)
      p3 = pop3(9.,5.,1.,cs01 ,cs02 ,1.35,2.326,23.2,3.73,2.57e4,
     1 3.60e4,p2,xIonFracs(20,5) , 0. )
      c3997 = p3 * 3.73 * 4.98e-12
      c2414 = p3 * 23.1 * 8.245e-12
      Ca6087 = p2 * 0.426 * 3.268e-12
      c5311 = p2 * 1.90 * 3.747e-12
      call coladd( 'Ca 5' , 3997 , c3997  )
      call coladd( 'Ca 5' , 2414 , c2414  )
      call coladd( 'Ca 5' , 6087 , Ca6087  )
      call coladd( 'Ca 5' , 5311 , c5311  )
*
*     Ca VII lines from 1d, 1s
*     all cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
      cs01 = max(3.5, min(4.4, 22.25 /(te20/te02/te02) ) )
      cs12 = max( 0.62,min( 1.20,0.303*te30*te03 ) )
      cs02 = max( 0.50,min( 0.959,7.889/(te20*te05/te01 ) ) )
      p3 = pop3(9.,5.,1.,cs01 ,cs02 ,cs12 ,3.124 ,30.4 ,6.81 ,2.91e4 ,
     1 3.90e4 ,p2 ,xIonFracs(20,7) , 0. )
      Ca3688 = p3 * 6.81 * 5.40e-12
      Ca2112 = p3 * 30.4 * 9.42e-12
      Ca5620 = p2 * 2.15 * 3.548e-12
      Ca4941 = p2 * 0.974* 4.037e-12
      call coladd( 'Ca 7' , 3688 , Ca3688  )
      call coladd( 'Ca 7' , 2112 , Ca2112  )
      call coladd( 'Ca 7' , 5620 , Ca5620  )
      call coladd( 'Ca 7' , 4941 , Ca4941  )
*
*     all cs from
*     >>refer Galavis, M.E., Mendoza, C., & Zeippen, C.J. 1995, A&AS, 111, 347
*     [Ca VII] 4.09, 6.15 mic 3P lines
      cs = max(3.702,min(5.354,0.406*te20*te03*te01 ) )
      call PutCS( cs , Ca0741 )
      cs = max(1.153,min(1.59,0.183*te20 ) )
      call PutCS( cs , Ca0761 )
      cs = max(1.005,min(1.497,0.0917*te20*te05*te01 ) )
      call PutCS( cs , TauDummy )
*     level3(  t10,t21,t20)
      call level3( Ca0761 , Ca0741 , TauDummy )
*
*     [Ca VIII]  2.32 microns, cs
*     >>refer Saraph, H.E., & Storey, P.J. A&AS, 115, 151
      cs = min( 6.75 , 22.04/(te10*te02*te005) )
      call PutCS( cs , Ca08232 )
      call level2( Ca08232 )
*
*     [Ca 12] 3328.78A, cs from
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = max( 0.10, min(0.172,0.0118*te20*te01))
      call PutCS( cs , Ca12333 )
      call level2( Ca12333 )
*
*     Li seq 2s2p 2s3p, 2s2p as two separate lines
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 20 , tCa302, tCa19, cs2s2p , cs2s3p )
*
      call PutCS( cs2s2p , tCa302 )
      call level2( tCa302 )
*
*     funny factor (should have been 0.5) due to energy change
      call PutCS( cs2s2p*0.439 , tCa345 )
      call level2( tCa345 )
*
      call PutCS( cs2s3p , tCa19 )
      call level2( tCa19 )
*
      end
******************************************************************************
      subroutine ScCol
      implicit none
*compute scandium cooling
      integer limelm
      parameter (limelm=30)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      common/coolsc/ Sc22p08m , Sc24p1m , Sc24p2m ,Sc33936, Sc42100 ,
     1 Sc45058 , Sc43595
      real Sc22p08m , Sc24p1m , Sc24p2m ,Sc33936, Sc42100 ,
     1 Sc45058 , Sc43595
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*
*     local variables
      real a21, a31 , a32 , pop3, p3, p2 , popexc,g1,g2,g3
*
*     Sc scandium cooling
*
*     Sc II
*     these are 3 lines estimated by Jim Kingdon
*     a's are bad, collision strengths just one
      a21 = 0.004
      a31 = 6.95e-3
      a32 = 5.0e-4
      g1 = 15.
      g2 = 5.
      g3 = 21.
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( g1,g2,g3, g1 ,g2,g3, a21 ,a31,a32,
     1  3504., 3407., p2, xIonFracs(21,2),0.)
*     2.08 microns
      Sc22p08m = p3 * a31 * 9.56e-13
*     4.1 micron
      Sc24p1m = p2 * a21 * 4.85e-13
*     4.22 micron
      Sc24p2m = p3 * a32 * 4.71e-13
      call coladd( 'Sc 2' , 41 , Sc24p1m  )
      call coladd( 'Sc 2' , 42 , Sc24p2m  )
      call coladd( 'Sc 2' , 21 , Sc22p08m  )
*
*     Sc III 3933
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21
*     [Sc III] 3933, multiplet average
      g1 = 10.
      g2 = 2.
      Sc33936 = popexc(g1,g1,g2,0.03,3.66e4,xIonFracs(21,3))*
     1 5.06e-12
      call coladd( 'Sc 3' , 3933 , Sc33936  )
*
*     [Sc V] 2.31 mic
*     Y(ik) from
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 6.00 , Sc05231 )
      call level2( Sc05231 )
*
*     Sc VI
      a21 = 4.94
      a31 = 49.24
      a32 = 4.3
      g1 = 9.
      g2 = 5.
      g3 = 1.
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( g1,g2,g3, g1 ,g2,g3, a21 ,a31,a32,
     1  28464., 40045., p2, xIonFracs(21,6),0.)
*     2100 ang - 3=>1
      Sc42100 = p3 * a31 * 9.47e-12
*     5054 - 2=>1
      Sc45058 = p2 * a21 * 3.93e-12
*     3592 3=>2
      Sc43595 = p3 * a32 * 5.53e-12
      call coladd( 'Sc 6' , 2100 , Sc42100  )
      call coladd( 'Sc 6' , 5054 , Sc45058  )
      call coladd( 'Sc 6' , 3592 , Sc43595  )
*
*     [Sc 13] 2637.97A, cs from
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.182 , Sc13264 )
      call level2( Sc13264 )
*
      end
******************************************************************************
      subroutine TiCol
      implicit none
*compute titanium cooling
      integer limelm
      parameter (limelm=30)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real Ti3l31 , Ti3l32 , Ti3l21
      common/coolti/ Ti3l31 , Ti3l32 , Ti3l21
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*
*     local variables
      real a21, a31 , a32 , pop3, p3, p2
*
*     Ti Titanium cooling
*
*     these are 3 lines estimated by Jim Kingdon
*     a's are bad, collision strengths just one
      a21 = 0.015
      a31 = 0.032
      a32 = 0.002
*
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( 21.,5.,9., 21. , 5.0, 9.0, a21 ,a31,a32,
     1  11844., 3148.4, p2, xIonFracs(22,3),0.)
*     multiplet at roughly 9594
      Ti3l31 = p3 * a31 * 2.07E-12
*     multiplet at roughly 4.57 microns
      Ti3l32 = p3 * a32 * 4.35e-13
*     multiplet at roughly 1.21 microns
      Ti3l21 = p2 * a21 * 1.64E-12
      call coladd( 'Ti 3' , 9594 , Ti3l31  )
      call coladd( 'Ti 3' ,    4 , Ti3l32  )
      call coladd( 'Ti 3' ,    1 , Ti3l21  )
*
*     [Ti VI] 1.7150 mic
*     Y(ik) from
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 3.48 , Ti06172 )
      call level2( Ti06172 )
*
*     [Ti XIV] 2117.79, cs from
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.23 , Ti14212 )
      call level2( Ti14212 )
*
      end
******************************************************************************
      subroutine VanCol
      implicit none
*compute vanadium cooling
      integer limelm
      parameter (limelm=30)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real V38830 , V47741 , V49496 , V44p2m,V38507
      common/coolvan/ V38830 , V47741 , V49496 , V44p2m,V38507
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*
*     local variables
      real a21, a31 , a32 , pop3, p3, p2 ,g1,g2,g3
*
*     V Vanadium cooling - element 23
*
*     V III 8823
      a21 = 0.05
      a31 = 0.10
      a32 = 0.00
      g1 = 28.
      g2 = 12.
      g3 = 18.
*     [V III] 8823, multiplet average
      p3 = pop3( g1,g2,g3, g1 ,g2,g3, a21 ,a31,a32,
     1  16303., 606., p2, xIonFracs(23,3),0.)
      V38830 = p2 * a21 * 2.25e-12
      V38507 = p3 * a31 * 2.34e-12
      call coladd( 'V  3' , 8823 , V38830  )
      call coladd( 'V  3' , 8507 , V38507  )
*
*     V IV
      a21 = 0.054
      a31 = 0.039
      a32 = 0.007
      g1 = 21.
      g2 = 5.
      g3 = 9.
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( g1,g2,g3, g1 ,g2,g3, a21 ,a31,a32,
     1  15159., 3437., p2, xIonFracs(23,4),0.)
*     7735 ang - 3=>1
      V47741 = p3 * a31 * 2.57e-12
*     9489 - 2=>1
      V49496 = p2 * a21 * 2.09e-12
*     4.19 microns 3=>2
      V44p2m = p3 * a32 * 4.74e-13
      call coladd( 'V  4' , 7735 , V47741  )
      call coladd( 'V  4' , 9489 , V49496  )
      call coladd( 'V  4' , 42 , V44p2m  )
*
*     [V VII] 1.3038 mic
*     Y(ik) from
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 2.39 , Va07130 )
      call level2( Va07130 )
*
*     [V 15] 1721.38, cs from
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.10 , Va15172 )
      call level2( Va15172 )
*
      end
******************************************************************************
      subroutine CrCol
      implicit none
*compute chromium cooling
      integer limelm
      parameter (limelm=30)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real Cr4l31 , Cr4l21 , Cr5l31 , Cr5l21 , Cr5l32,Cr3l21
      common/coolcr/ Cr4l31 , Cr4l21 , Cr5l31 , Cr5l21 , Cr5l32,Cr3l21
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*
*     local variables
      real a21, a31 , a32 , pop3, p3, p2 , popexc
*
*     Cr Chromium cooling
*
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21
*     [Cr III] 5828, multiplet average
      Cr3l21 = popexc(25.,25.,9.,0.05,2.47e4,xIonFracs(24,3))*
     1 3.41e-12
      call coladd( 'Cr 3' , 5828 , Cr3l21  )
*
*     Cr IV
*     these are 2 lines estimated by Jim Kingdon
*     a's are bad, collision strengths just one
      a21 = 0.053
      a31 = 0.102
      a32 = 0.00
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( 28.,12.,18., 28. ,12.,18., a21 ,a31,a32,
     1  19795., 1356., p2, xIonFracs(24,4),0.)
*     multiplet at roughly 6801 A
      Cr4l31 = p3 * a31 * 2.92E-12
*     multiplet at roughly 7267 A
      Cr4l21 = p2 * a21 * 2.74E-12
      call coladd( 'Cr 4' , 6801 , Cr4l31  )
      call coladd( 'Cr 4' , 7267 , Cr4l21  )
*
*     Cr V
*     these are 3 lines estimated by Jim Kingdon
*     a's are bad, collision strengths just one
      a21 = 0.157
      a31 = 0.048
      a32 = 0.016
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     energies are in kelvin
      p3 = pop3( 21.,5.,9., 21. ,5.,9., a21 ,a31,a32,
     1  18028., 3842., p2, xIonFracs(24,5),0.)
*     multiplet at roughly 6577 A
      Cr5l31 = p3 * a31 * 3.02E-12
*     multiplet at roughly 7979 A
      Cr5l21 = p2 * a21 * 2.49E-12
*     multiplet at roughly 3.74 microns
      Cr5l32 = p2 * a32 * 5.31E-13
      call coladd( 'Cr 5' , 6577 , Cr5l31  )
      call coladd( 'Cr 5' , 37 , Cr5l32  )
      call coladd( 'Cr 5' , 7979 , Cr5l21  )
*
*     [Cr VIII] 1.0106 mic
*     Y(ik) from
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 1.76 , Cr08101 )
      call level2( Cr08101 )
*
*     [Cr 16] 1410.60, cs from
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.11 , Cr16141 )
      call level2( Cr16141 )
*
      end
******************************************************************************
      subroutine fecol
      implicit none
*compute iron cooling
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limLevelN
      parameter (limLevelN=20)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     number of FeII lines in Fred's atom
      integer nfeii
      parameter (nfeii=373)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer ndfst
      parameter (ndfst=5)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*     coolants for iron
      real rmt48, for7, Fecool, Feir, c5270, c3892, c5177, c6087,
     1 c1467, c2649, c2568, c1242, c2170, c5303, c133, Fe5722,
     2 c7082, c1118, c1328, c592, fs846, c263, c242 ,
     3 Fe231 , Fe232 , Fe221, cFe16, cFe26, cFe34, cFe35, cFe46, cFe56
      common/coolfe/ rmt48, for7, Fecool, Feir, c5270, c3892, c5177,
     1 c6087, c1467, c2649, c2568, c1242, c2170, c5303, c133, Fe5722,
     2 c7082, c1118, c1328, c592, fs846, c263, c242 ,
     3 Fe231 , Fe232 , Fe221, cFe16, cFe26, cFe34, cFe35, cFe46, cFe56
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real otsfe2 , emuv3
      common/resion/ otsfe2 , emuv3
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     include "fe2pop.com"
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
      real opac
      common/opac/ opac(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real dstfe2lya , escfe2
*dstfe2lya is destruction probability for Lya onto FeII
      common/dstfe2/ dstfe2lya , escfe2
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      integer nFe2Neg
*clount how many times FeII came back with negative level pops
      common/Fe2Neg/ nFe2Neg
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      real PumpLyaFeII
*Lya pumping of FeII
      common/PLyaFeII/ PumpLyaFeII
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real fcool , dfcool , feheat
*     cooling computed by Katya's FeII model atom
*     fcool is total cooling (or heating if negative)
*     and dfcool is its derivative
*     holod is Russian for cold
      common/holod/ fcool , dfcool , feheat
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      logical lgCoolTr
*flag set with trace cooling
      common/cooltr/ lgCoolTr
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nlFe2
      logical lgNegPop
      parameter (nlFe2=6)
      real popFe2(nlFe2) , data(nlFe2,nlFe2) , gFe2(nlFe2) , ex(nlFe2),
     1 dest(nlFe2,nlFe2) , pump(nlFe2,nlFe2)
      integer ipdest(nlFe2,nlFe2)
      integer i , j , nzsave
      save nzsave , tesave
      real dFe2dt , tused
      real sexp ,  p2,pop3,popexc,cs, cs2s2p,cs2s3p , tesave
*
      data nzsave/-1/ , tesave/-1./
*
*     stat weights for Fred's 6 level model FeII atom
      data gFe2/6*1./
*     excitation energies (Kelvin) for Fred's 6 level model FeII atom
      data  ex/0. , 3.32e4 , 5.68e4 , 6.95e4 , 1.15e5 , 1.31e5 /
*
*     series of FeI lines from Dima Verner's list, each 2-lev atom
*
*     Fe I 3884
      call MakeCS( FeI3884 )
      call level2( FeI3884 )
*
*     Fe I 3729
      call MakeCS( FeI3729 )
      call level2( FeI3729 )
*
*     Fe I 3457
      call MakeCS( FeI3457 )
      call level2( FeI3457 )
*
*     Fe I 3021
      call MakeCS( FeI3021 )
      call level2( FeI3021 )
*666  write(6,'('' fei3021'',i4,1p,10e10.2)')
*    1 nzone,te,fe(1),fei3021(ipLnHeat),
*    1 fei3021(ipLnCool),fei3021(ipLnPump),fei3021(ipLnAovTOT),
*    2 fei3021(ipLnColovTOT)
*
*     Fe I 2966
      call MakeCS( FeI2966 )
      call level2( FeI2966 )
*
*
      if( chFeIIAtom.eq.'Verner' ) then
*       this is the Verner's 371 level FeII atom
*666    error! evaluate this destruction probability!!
        dstfe2lya = 0.
        escfe2 = 0.
*       >>chng 97 jan 17, evaluate Katya cooling every time temp changes
*       if( nzone.ne.nzsave .or. lgSearch ) then
*       >>chng 97 jan 31, added check on zone since must reeval even const temp
        if( lgSimKatya ) then
          nzsave = nzone
          tesave = te
          Fecool = 0.
          feheat = 0.
        else if( tesave.ne.te .or. nzone.ne.nzsave .or. lgSearch ) then
*         only call pop371 one time per temperature or zone
          call KatyaFe2
          nzsave = nzone
          tesave = te
          Fecool = fcool
*         counts as heating derivative if negative cooling
          if( Fecool.gt.0. ) dCooldT = dCooldT + dfcool
          call coladd( 'Fe 2' , 0 , max(0.,fcool) )
          heating(26,28) = max(0.,-fcool)
*         >>chng 97 mar 27 add sumheat call
*         likely that total heating was affected by feii atom
          call SumHeat
          if( lgTrace.and.lgCoolTr ) then
            write(qq,'('' Katya FeII returns te, cooling, dc='',
     1      1p,4e11.3)') te,Fecool,dfcool
          endif
        else
*         this is case where temp is unchanged, so heating and cooling same too
          Fecool = fcool
          dCooldT = dCooldT + dfcool
          call coladd( 'Fe 2' , 0 , max(0.,fcool) )
          heating(26,28) = max(0.,-fcool)
        endif
      else
        feheat = 0.
*
*       following treatment of Fe II follows
*       >>refer Wills, B.J., Wills, D., Netzer, H. 1985, ApJ, 288, 143
*       all elements are used, and must be set to zero if zero
        do i=1,nlFe2
          do j=1,nlFe2
            data(i,j) = 0.
            dest(i,j) = 0.
            pump(i,j) = 0.
            ipdest(i,j) = 0
          end do
        end do
        data(2,1) = 1.
         data(3,1) = tuv3(ipLnEscP)*tuv3(ipLnAul)
         dest(3,1) = tuv3(ipLnDesP)*tuv3(ipLnAul)
         pump(3,1) = tuv3(ipLnPump)
        ipdest(3,1) =tuv3(ipLnIpCont)
*
        data(6,1) = tFe16(ipLnEscP)*tFe16(ipLnAul)
        dest(6,1) = tFe16(ipLnDesP)*tFe16(ipLnAul)
*       continuum pumping of n=6
        pump(6,1) = tFe16(ipLnPump)
*       Ly-alpha pumping
        if( xIonFracs(26,2).gt.0. ) then
          PumpLyaFeII = hn2p*hii*hyas(2,1)*dstfe2lya/xIonFracs(26,2)
          pump(6,1) = pump(6,1) + PumpLyaFeII
        else
          PumpLyaFeII = 0.
        endif
        ipdest(6,1) = tFe16(ipLnIpCont)
*
        data(3,2) = tr48(ipLnEscP)*tr48(ipLnAul)
        dest(3,2) = tr48(ipLnDesP)*tr48(ipLnAul)
        pump(3,2) = tr48(ipLnPump)
        ipdest(3,2) = tr48(ipLnIpCont)
*
        data(6,2) = tFe26(ipLnEscP)*tFe26(ipLnAul)
        dest(6,2) = tFe26(ipLnDesP)*tFe26(ipLnAul)
        pump(6,2) = tFe26(ipLnPump)
        ipdest(6,2) = tFe26(ipLnIpCont)
*
        data(4,3) = tFe34(ipLnEscP)*tFe34(ipLnAul)
        dest(4,3) = tFe34(ipLnDesP)*tFe34(ipLnAul)
        pump(4,3) = tFe34(ipLnPump)
        ipdest(4,3) = tFe34(ipLnIpCont)
*
        data(5,3) = tFe35(ipLnEscP)*tFe35(ipLnAul)
        dest(5,3) = tFe35(ipLnDesP)*tFe35(ipLnAul)
        pump(5,3) = tFe35(ipLnPump)
        ipdest(5,3) = tFe35(ipLnIpCont)
*
        data(6,4) = tFe46(ipLnEscP)*tFe46(ipLnAul)
        dest(6,4) = tFe46(ipLnDesP)*tFe46(ipLnAul)
        pump(6,4) = tFe46(ipLnPump)
        ipdest(6,4) = tFe46(ipLnIpCont)
*
        data(6,5) = tFe56(ipLnEscP)*tFe56(ipLnAul)
        dest(6,5) = tFe56(ipLnDesP)*tFe56(ipLnAul)
        pump(6,5) = tFe56(ipLnPump)
        ipdest(6,5) = tFe56(ipLnIpCont)
*
*       these are collision strengths
        data(1,2) = 1.
        data(1,3) = 12.
        data(1,4) = 1.
        data(1,5) = 1.
        data(1,6) = 12.
        data(2,3) = 6.
        data(2,4) = 1.
        data(2,5) = 1.
        data(2,6) = 12.
        data(3,4) = 6.
        data(3,5) = 12.
        data(3,6) = 1.
        data(4,5) = 1.
        data(4,6) = 12.
        data(5,6) = 6.
*
        call LevelN(nlFe2,nlFe2,xIonFracs(26,2),gFe2,ex , popFe2,data,
     1   dest,pump, ipdest, Fecool,dFe2dt,'FeII', lgNegPop)
        if( lgNegPop ) nFe2Neg = nFe2Neg + 1
        call coladd( 'Fe 2' , 0 , max(0.,Fecool) )
        heating(26,28) = max(0.,-Fecool)
        dCooldT = dCooldT + dFe2dt
        tuv3(ipLnPopl) = popFe2(1)
        tuv3(ipLnPopOpc) = popFe2(1) - popFe2(3)
        emuv3 = popFe2(3) * data(3,1)*tuv3(ipLnEnrErg)
        tuv3(ipLnNPhots) = popFe2(3) * data(3,1)
        otsfe2 = popFe2(3) * tuv3(ipLnDesP)*tuv3(ipLnAul)
*
        tr48(ipLnPopl) = popFe2(2)
        tr48(ipLnPopOpc) = popFe2(2) - popFe2(3)
        rmt48 = popFe2(3) * data(3,2)* tr48(ipLnEnrErg)
        tr48(ipLnNPhots) = popFe2(3) * data(3,2)
*
        for7 = popFe2(2)*data(2,1)*4.65e-12
*
        tFe16(ipLnPopl) = popFe2(1)
        tFe16(ipLnPopOpc) = popFe2(1) - popFe2(6)
        tFe16(ipLnNPhots) = popFe2(6)*data(6,1)
        cFe16 = tFe16(ipLnNPhots)*tFe16(ipLnEnrErg)
*
        tFe26(ipLnPopl) = popFe2(2)
        tFe26(ipLnPopOpc) = popFe2(2) - popFe2(6)
        tFe26(ipLnNPhots) = popFe2(6)*data(6,2)
        cFe26 = tFe26(ipLnNPhots) *tFe26(ipLnEnrErg)
*
        tFe34(ipLnPopl) = popFe2(3)
        tFe34(ipLnPopOpc) = popFe2(3) - popFe2(4)
        tFe34(ipLnNPhots) = popFe2(4)*data(4,3)
        cFe34 = tFe34(ipLnNPhots) *tFe34(ipLnEnrErg)
*
        tFe35(ipLnPopl) = popFe2(3)
        tFe35(ipLnPopOpc) = popFe2(3) - popFe2(5)
        tFe35(ipLnNPhots) = popFe2(5)*data(5,3)
        cFe35 = tFe35(ipLnNPhots) *tFe35(ipLnEnrErg)
*
        tFe46(ipLnPopl) = popFe2(4)
        tFe46(ipLnPopOpc) = popFe2(4) - popFe2(6)
        tFe46(ipLnNPhots) = popFe2(6)*data(6,4)
        cFe46 = tFe46(ipLnNPhots) *tFe46(ipLnEnrErg)
*
        tFe56(ipLnPopl) = popFe2(5)
*       tFe56(ipLnPopOpc) = popFe2(5) - popFe2(6)
*       >>chng 96 apr 23 this levels mases due to Lya pump
        tFe56(ipLnPopOpc) = popFe2(5) - popFe2(6)*0.
        tFe56(ipLnNPhots) = popFe2(6)*data(6,5)
        cFe56 = tFe56(ipLnNPhots) *tFe56(ipLnEnrErg)
*
*       Jack's funny FeII lines, data from
*       >>refer Johansson, S., Brage, T., Leckrone, D.S., Nave, G. &
*       >>refer Wahlgren, G.M. 1995, ApJ 446, 361
        call PutCS( 10., t191 )
        call level2( t191 )
*
*       do 16 level ground + first two terms
        call Fe2Lev16
      endif
*
*     lump 3p and 3f together; cs=
*     >>refer Garstang, R.H., Robb, W.D., Rountree, S.P. 1978, ApJ, 222, 384
*     A from
*     >>refer Garstang, R.H., 1957, Vistas in Astronomy, 1, 268
*     FE III 5270, is 20.9% of total
      c5270 = popexc(5.53,25.,30.,0.435,2.948e4,xIonFracs(26,3))*
     1 3.78e-12
      call coladd( 'Fe 3' , 5270 , c5270 )
*
*     FeIII 1122 entire multiplet - atomic data=A's Dima, CS = guess
      call PutCS( 25., t1122 )
      call level2( t1122 )
*
*     call 12 level atom
      call Fe4Lev12
*
*     FE V 3892 + 3839, data from Shields
      c3892 = popexc(7.4,25.,5.,0.6,3.7e4,xIonFracs(26,5))*5.11e-12
      call coladd( 'Fe 5' , 3892 , c3892 )
*
*     FE VI 5177+5146+4972+4967
*     data from
*     >>refer Garstang, R.H., Robb, W.D., Rountree, S.P. 1978, ApJ, 222, 384
      c5177 = popexc(1.9,28.,18.,0.52,2.78e4,xIonFracs(26,6))*3.84E-12
      call coladd( 'Fe 6' , 5177 , c5177 )
*
*     >>chng 97 jan 6 added fir lines, cs from
*     >>refer Keenan, F.P., & Norrington, P.H. 1987 A&A, 181, 370
*     [FeVII] 9.51, 7.81 micron lines
      if( te.lt.1.5e4 ) then
        cs = min(1.49, 374.8/(sqrte*te10) )
        call PutCS( cs , Fe0795 )
        cs = min(1.57, 188.5/(sqrte*te02) )
        call PutCS( cs , Fe0778 )
        cs = min(0.389, 51.32/(sqrte*te03) )
        call PutCS( cs , TauDummy )
      else
        cs = min(1.17, 7.929/(te20/te001) )
        call PutCS( cs , Fe0795 )
        cs = min(1.27, 5.638/(te10*te05*te005) )
        call PutCS( cs , Fe0778 )
        cs = min(0.314, 1.491/(te10*te05*te01*te001*te001) )
        call PutCS( cs , TauDummy )
      endif
      call level3(  Fe0795,Fe0778,TauDummy )
*
*     FE VII 6087, A from
*     >>refer Nussbaumer, H., & Storey, P.J. 1982, A&A, 113, 21
*     cs from
*     >>refer Keenan, F.P., & Norrington, P.H. 1987 A&A, 181, 370
      tused = max(4.0,alogte)
      tused = min( 5.1, tused )
      cs = 2.2684 - tused* (0.60893 - 0.052004*tused)
*     >>chng 97 jan 27, should have been total collision strength of multiplet
*     thanks for Tino Oliva for finding this problem
      cs = cs * 2.96
      c6087 = popexc(cs ,21.,5.,0.94,2.32e4,xIonFracs(26,7))*3.27E-12
     1 * 0.577/0.94
      Fe5722 = c6087 * 0.629 * 6087./5722.
      dCooldT = dCooldT + c6087 * 2.37e4*tsq1
      call coladd( 'Fe 7' , 6087 , c6087 )
      call coladd( 'Fe 7' , 5722 , Fe5722 )
*
*     Fe IX 245,242
*     all atomic data from
*     >>refer Flower, D.R. 1976, A&A, 56, 451
      call PutCS( 0.123 , t245 )
*     beseq(cs23,cs24,cs34,tarray,a41)
*     C245 = BESEQ( .087 ,.038 ,.188 , t245 ,71. )  * 8.14E-11
      call beseq( .087 ,.038 ,.188 , t245 ,71. )
      c242 = PopLevels(3) * 8.22E-11 * 71.
*
*     Fe X 6374, A from
*     >>refer Mason, H. 1975, MNRAS 170, 651
*     cs
*     >>refer Mohan, M., Hibbert, A., & Kingston, A.E. 1994, ApJ, 434, 389
*     not used newer cs from
*     >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
*     does not agree with Mohan et al. by factor of 4
*     20x larger than Mason numbers used pre 1994
      cs = max(0.1, 13.3 - 2.*min(7.0,alogte ) )
* 666 error! following to stop insane FeX strengths
*     >>chng 96 july 11, removed 1/10 factor, so using real data, 90.01
*     cs = cs * 0.1
*     >>chng 96 june 3, transferred following
*     >>chng 97 jan 31, give up on this mess, use cs of unity
      cs = 1.
      call PutCS( cs , Fe106375 )
      call level2( Fe106375 )
*     c6374 = popexc(cs ,4.,2.,69.5,2.26e4,xIonFracs(26,10))*3.12e-12
*     dCooldT = dCooldT + c6374 * 2.26e4 * tsq1
*     call coladd( 'Fe10' , 6374 , c6374 )
*
*     this is the E1 line that can pump [FeX]
      cs = max(0.05 , 0.85 * sexp( 0.045*1.259e6/te ) )
      call PutCS( cs , t352 )
      call level2( t352 )
*
*     Fe XI 7892, 6.08 mic, CS from
*     >>refer Mason, H. 1975, MNRAS 170, 651
*     A from
*     >>refer Mendoza, C., & Zeippen, C.J. 1983, MNRAS, 202, 981
      cs = 0.27
*     >>chng 97 jan 31, set cs to unity, above ignored resonances
      cs = 1.
      call PutCS( cs , tFe07 )
      call PutCS( 0.036 , tFe61 )
      call PutCS( 0.11 , TauDummy )
      call level3(tFe07,tFe61,TauDummy)
*
*     Kafatos, M., & Lynch, J.P. 1980, ApJS, 42, 611
      c1467 = pop3(9.,5.,1., .24,.028,.342, 100.,1012.,9.3,
     1 5.43E4,6.19e4,p2,xIonFracs(26,11),0.) * 1012. * 1.36E-11
      call coladd( 'Fe11' , 1467 , c1467 )
      c2649 = p2 * 91.0 * 7.512E-12
      call coladd( 'Fe11' , 2469 , c2649 )
*
*     A's for 2-1 and 3-1 from
*     >>refer Tayal, S.S., & Henry, R.J.W. 1986, ApJ, 302, 200
*     CS fro
*     >>refer Tayal, S.S., Henry, R.J.W., Pradhan, A.K. 1987, ApJ, 319, 951
*     a(3-2) scaled from both ref
      c2568 = pop3( 4.,10.,6., 0.72,0.69,2.18 , 8.1E4,1.84E6,1.33E6,
     1 6.37e4,4.91e4 , p2 , xIonFracs(26,12) ,0. ) * 1.33E6 * 6.79E-12
      call coladd( 'Fe12' , 2568 , c2568 )
      c1242 = c2568 * 2.30 * 1.38
      call coladd( 'Fe12' , 1242 , c1242 )
      c2170 = p2 * 8.09e4 * 8.82E-12
      call coladd( 'Fe12' , 2170 , c2170 )
*
*     [Fe XIII] 1.07, 1.08 microns, no collision data available
      call PutCS( 1. , Fe1310 )
      call PutCS( 1. , Fe1311 )
      call PutCS( 1. , TauDummy )
      call level3(Fe1310,Fe1311,TauDummy)
*
*     Fe XIV 5303, cs from
*     >>refer Storey, P.J., Mason, H.E., Saraph, H.E., 1996, A&A, 309, 677
      call fe14cs(alogte,cs)
*     >>chng 97 jan 31, set cs to unity, above is VERY large, >10
      cs = 1.
      c5303 = popexc(cs ,2.,4.,60.3,2.71e4,xIonFracs(26,14))*3.75E-12
      dCooldT = dCooldT + c5303 * 2.71e4*tsq1
      call coladd( 'Fe14' , 5303 , c5303 )
*
*     Fe 18 974.8A;, cs from
*     >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      cs = min( 0.143, 0.804/(te10*te05))
      call PutCS( cs , Fe18975 )
      call level2( Fe18975 )
*
      c7082 = pop3( 5.,1.,3., 0.0132,0.0404,0.0137 ,
     1 0.505,1.46E4,41.2, 1.083E5,2.03E4,p2,xIonFracs(26,19),0.) *
     2 41.2 * 2.81E-12
      c1118 = c7082 * 354.4 * 6.335
      c1328 = p2 * 0.505 * 1.50e-11
      call coladd( 'Fe19' , 7082 , c7082 )
      call coladd( 'Fe19' , 1118 , c1118 )
      call coladd( 'Fe19' , 1328 , c1328 )
*
      c592 = popexc(0.0913,9.,5.,1.64E4,2.428e5,xIonFracs(26,19))*
     1 3.36E-11
      call coladd( 'Fe19' , 592 , c592 )
*
*     following all from same ref
      call PutCS( 0.0151 , tFe13 )
      call PutCS( 0.0424 , tFe23 )
      call PutCS( 0.0147 , TauDummy )
      call level3(tFe13,tFe23, TauDummy)
*
*     FE 22 845.6, C.S.=guess, A from
*     >>refer Froese Fischer, C. 1983, JPhB, 16, 157
      fs846 = popexc(0.2,2.,4.,1.5e4,1.701e5,xIonFracs(26,22))*2.35E-11
      call coladd( 'Fe22' , 846 , fs846 )
*
*     FE 23 262.6, 287A, 1909-LIKE,
*     cs from
*     >>refer Bhatia, A.K., & Mason, H.E. 1986, A&A, 155, 413
      c263 = popexc(0.04,1.,9.,1.6e7,5.484e5,xIonFracs(26,23))*7.58E-11
      call coladd( 'Fe23' , 262 , c263 )
*
*     FE 24, 255, 192 Li seq doublet
*     >>refer Cochrane, D.M., & McWhirter, R.W.P. 1983, PhyS, 28, 25
      call ligbar( 26 , t192, t11, cs2s2p , cs2s3p )
*
      call PutCS( cs2s2p , t192 )
      call level2( t192 )
*
*     funny factor (should have been 0.5) due to energy change
      call PutCS( cs2s2p*0.376 , t255 )
      call level2( t255 )
*
      call PutCS( cs2s3p , t11 )
      call level2( t11 )
*
* 666 error!
*     following not in cooling function
      t353(ipLnPopOpc) = xIonFracs(26,11)
      t353(ipLnPopl) = xIonFracs(26,11)
      t353(ipLnPopu) = 0.
      t347(ipLnPopOpc) = xIonFracs(26,14)
      t347(ipLnPopl) = xIonFracs(26,14)
      t347(ipLnPopu) = 0.
*
      end
***********************************************************************
       subroutine S2cs(telog,cs12,cs13,cs14,cs15,cs23,cs24,cs25,
     1                 cs34,cs35,cs45)
       implicit none
*compute [sii] collision strengths
* compute collision strengths for [SII] transitions
* w/in S II ground term. From
*     >>refer Ramsbottom, C.A., Bell, K.L., Stafford, R.P. 1996, ADNDT, 63, 57
* written by Kirk Korista
*
       real telog
       real cs12, cs13, cs14, cs15, cs23
       real cs24, cs25, cs34, cs35, cs45
       real a,b,c,telogn1
*
*     limit to stop exceeding bounds
      telogn1 = max( 3.5 , telog )
      telogn1 = min( telogn1 , 5.0 )
*
* 2D5/2 - 2P3/2    S II  10320.4   A=0.179 (3-->5)
       a = 18.335524
       b = -5.1180248
       c =  0.44482438
       cs35 = max(3.87, min(5.82, a + b * telogn1 +
     1        c * telogn1 * telogn1))
*
* 2D3/2 - 2P3/2          10286.7   A=0.1335 (2-->5)
       a =  6.690242
       b = -1.061514
       c = 0.034535506
       cs25 = max(2.24, min(3.38, a + b * telogn1 +
     1        c * telogn1 * telogn1))
*
* 2D5/2 - 2P1/2          10373.3   A=0.0779 (3-->4)
       a =  4.2250081
       b = -0.46549935
       c = -0.010172139
       cs34 = max(1.64, min(2.46, a + b * telogn1 +
     1        c * telogn1 * telogn1))
*
* 2D3/2 - 2P1/2          10336.3   A=0.1626 (2-->4)
       a =  8.274085
       b = -2.6223732
       c =  0.2502924
       cs24 = max(1.42, min(2.14, a + b * telogn1 +
     1        c * telogn1 * telogn1))
*
* 2P1/2 - 2P3/2
       a = -5.1994665
       b = 49.334586
       c = -70.93344
       cs45 = max(1.85, min(3.07, a + b/telogn1 +
     1        c/(telogn1 * telogn1)))
*
* 2D3/2 - 2D5/2
       a = -27.497273
       b = 247.27405
       c = -429.9142
       cs23 = max(4.79, min(8.01, a + b/telogn1 +
     1        c/(telogn1 * telogn1)))
*
* 4S3/2 - 2P3/2           4068.6   A=0.220
       a =  2.6106784
       b = -3.2766908e-05
       c =  6.5105436
       cs15 = max(1.45, min(2.46, a + b * (telogn1)**c))
*
* 4S3/2 - 2P1/2           4076.4   A=0.091
       cs14 = 0.5 * cs15
*
* 4S3/2 - 2D5/2            6716.5   A=2.601e-04
       a =  8.1458628
       b = -0.5389108
       c =  1.4486586
       cs13 = max(2.54, min(4.77, a + b * (telogn1)**c))
*
* 4S3/2 - 2D3/2           6730.8   A=8.82e-04
       cs12 = cs13/1.5
*
*     option to print values, usually commented out
*     write(6,*) 10.**telog
*     write(6,*) cs12
*     write(6,*) cs13
*     write(6,*) cs14
*     write(6,*) cs15
*     write(6,*) cs23
*     write(6,*) cs24
*     write(6,*) cs25
*     write(6,*) cs34
*     write(6,*) cs35
*     write(6,*) cs45
*     stop
*
       end
***********************************************************************
       subroutine fe14cs(te1,csfe14)
       implicit none
* compute collision strengths for forbidden transitions
* w/in Fe XIV ground term. From
*      >>refer Storey, P.J., Mason, H.E., Saraph, H.E., 1996, A&A, 309, 677
*
       real csfe14
       real a,b,c,d
       real telog1,telog2,telog3,te1
 
* limit range in log T:
 
       telog1 = te1
       telog1 = min(9.0, telog1)
       telog1 = max(4.0, telog1)
*
* compute square and cube
*
       telog2 = telog1 * telog1
       telog3 = telog1 * telog1 * telog1
*
* compute cs:
*
       if (telog1 .le. 5.0) then
         a = 557.05536
         b = -324.56109
         c = 63.437974
         d = -4.1365147
         csfe14 = a + b*telog1 + c*telog2 + d*telog3
       else
         a = 0.19515493
         b = 2.9404407
         c = 4.9578944
         d = 0.79887506
         csfe14 = a + b*exp(-0.5*((telog1-c)*(telog1-c)/d))
       endif
       end
***********************************************************************
      subroutine MnCol
      implicit none
*compute manganese cooling
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*
*     [Mn IX] 7968.5A
*     Y(ik) from
*      >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 2.48 , xMn0979 )
      call level2( xMn0979 )
*
*     [Mn 17] 1169.59, cs from
*      >>refer Saraph, H.E. & Tully, J.A. 1994, A&AS, 107, 29
      call PutCS( 0.12 , xMn1712 )
      call level2( xMn1712 )
*
      end
***********************************************************************
      subroutine CoCol
      implicit none
*compute cobalt cooling
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*
*     [Co XI] 5168.A
*     Y(ik) from
*      >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 1.36 , Co11527 )
      call level2( Co11527 )
*
      end
***********************************************************************
      subroutine NiCol
      implicit none
*compute nickel cooling
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*
*     [Ni XII] 4230.8A
*     Y(ik) from
*      >>refer Pelan, J., & Berrington, K.A. 1995, A&A Suppl, 110, 209
      call PutCS( 1.68 , xNi1242 )
      call level2( xNi1242 )
*
      end
******************************************************************************
      subroutine coolpr( chLabel , lambda , ratio , eps )
      implicit none
*stores coolants before block printed, when printing cooling agents
      character chLabel*4
      integer lambda
      real ratio , eps
*
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nColSav
      parameter (nColSav=100)
      character*1 chSig(nColSav)
      real csav(nColSav) , scratch(nColSav) , SavMax
      integer isav(nColSav) , i , j
      save isav , csav , ip , cset , chSig , chLabsv
      character chLabsv(nColSav)*4
*
      integer ip , ipAr(nColSav)
      real cset
*
      if( chLabel.EQ.'ZERO' ) then
         cset = htot * eps
         ip = 1
*
      else if( chLabel.ne.'DONE' .and. abs(ratio).gt.eps ) then
        chLabsv(ip) = chLabel
        if( lambda.lt.10 000 ) then
          isav(ip) = lambda
        else
          isav(ip) = lambda/10000
        endif
        csav(ip) = ratio
        if( ratio.lt.0. ) then
          chSig(ip) = 'n'
        else
          chSig(ip) = ' '
        endif
        ip = ip + 1
        if( ip.gt.nColSav ) then
           write(qq,'(''  coolpr ran out of room.'')')
           call ShowMe
           stop
        endif
*
      else if( chLabel.EQ.'DONE' ) then
*       want to print sorted list of coolants
        ip = ip - 1
        do i=1,ip
          scratch(i) = abs(csav(i) )
        end do
        do i=1,ip
          SavMax = 0.
*         find largest of remaining
          do j=1,ip
            if( scratch(j).gt.SavMax ) then
              SavMax = scratch(j)
              ipAr(i) = j
            endif
          end do
          scratch(ipAr(i)) = 0.
        end do
        do j=1,ip,7
          write(qq,'(4X,7(1X,A4,I6,A1,F6.3))') (chLabsv(ipAr(i)),
     1    isav(ipAr(i)), chSig(ipAr(i)), csav(ipAr(i)) ,i=j,min(ip,j+6))
        end do
      endif
*
      end
******************************************************************************
      subroutine coolr(tot,dc)
      implicit none
*main routine to call others, to evaluate total cooling
      real tot , dc
*
*     returns tot, the total cooling,
*     and dc, the derivative of the cooling
*
      integer ndfst
      parameter (ndfst=5)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer limelm
      parameter (limelm=30)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real cyntrn,hmfb,c584,heavfb,bhe,herec,eebrm,h2line,h2dis,
     1 heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      common/coolng/cyntrn,hmfb,c584,heavfb, bhe,herec,eebrm,h2line,
     1 h2dis,heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      real HeavIonCool
*total cooling due to heavy element collisional ionization
      common/cmeion/ HeavIonCool
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real DustCoolGas
*dust cooling the gas by collisions
      common/dclgas/ DustCoolGas
      real EdenFFSum
*sum of heavy element free electrons, set in esum
      common/ffsum/ EdenFFSum
      double precision hlte
      real hc2p2se , hc2p2sp , hc2s1s
*hc2p2se and hc2p2sp are rates for 2s - 2s collisions with electrons and protons
*hlte is lte population of each level
      common/hcolrt/ hlte(lmhlvl+1) , hc2p2se , hc2p2sp , hc2s1s
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real rh2dis
      common/rh2dis/ rh2dis
      logical lgCNegChk
*flag set true during cooling map, saying to keep cool even
*if cooling is negative
      common/cnegtk/ lgCNegChk
      logical lgColNeg
*set false during during search for equilibrium temp
*check whether to complain about negative cooling
      common/colneg/ lgColNeg
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgNumDeriv
      common/NumDeriv/ lgNumDeriv
      logical lgNoMole
*flag to turn off molecules
      common/nomole/ lgNoMole
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real He3IonCool
*cooling due to collisional ionization of helium triplets
      common/cionhe/ He3IonCool
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      double precision hlbolt , hcbolt
*     hlbolt(low,up) line boltzmann factors for hydrogen atom
*     hcbolt(n) excit to continuum
      common/hlvcol/ hlbolt(lmhlvl-1,lmhlvl+1) , hcbolt(lmhlvl+1)
      real teinv
      common/teinv/ teinv
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real CycloCoolCoef
*coefficient scaled from magnetic field used for
*Cyclotron cooling
      common/cyclot/ CycloCoolCoef
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hex , dhexdt
      common/hex/ hex , dhexdt
      real he1ex
      common/he1exCOM/ he1ex
      real he2ex
      common/he2ex/ he2ex
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      real he2cin
      common/he2cin/ he2cin(10)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real dDensityDT, dndtSave
*deriv of density needed for expansion cooling
      common/dndt/ dDensityDT, dndtSave
      real COVibCool, dCOVdT
*cooling due to rotational excit fo CO, and its deriv
      common/covib/ COVibCool, dCOVdT
      logical lgCExtraOn
*info about 'extra' cooling, lgCextOn says it is on
      real CoolExtra , cextpw
      common/cextra/ lgCExtraOn , CoolExtra , cextpw
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real H2PlsCool
*cooling due to H + H+ => H2+
      common/h2pcng/ H2PlsCool
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real telogn
      common/telogn/ telogn(7)
*     energy differences for model he singlet atom:
*     this is array of temperatures, first between levels, sec lev to cont
*     He1deltaT( upper , lower )
      real He1deltaTe, He1CionTe
      common/He1deltaT/ He1deltaTe(nhe1lvl,nhe1lvl), He1CionTe(nhe1lvl)
*energy differences for model he ion:
*this is array of temperatures, first between levels, sec lev to cont
*He2deltaT( upper , lower )
      real He2deltaTe, He2CionTe
      common/He2deltaT/ He2deltaTe(nhe2lvl,nhe2lvl), He2CionTe(nhe2lvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
      double precision he1bol , he1cbt
      common/he1blt/ he1bol(nhe1lvl-1,nhe1lvl+1) , he1cbt(nhe1lvl+1)
      double precision he2bol , he2cbt
      common/he2blt/ he2bol(nhe2lvl-1,nhe2lvl+1) , he2cbt(nhe2lvl+1)
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
      double precision he1lte
      real he1c2p2s , he1c2s1s
*collision strengths and lte densities for helium singlets
      common/he1crt/ he1c2p2s , he1c2s1s , he1lte(nhe1lvl+1)
      double precision he2lte
      real he2c2p2se , he2c2p2sp , he2c2s1s
*he2c2p2sp is collision rate coefficient for proton collisions from 2p to 2s
*he2c2p2se is collision rate coefficient for electron collisions from 2p to 2s
*he2c2s1 is collision rate coefficient for electron collisions from 2s to 1s
*he2lte is lte relative population density for helium ion
      common/he2crt/ he2lte(nhe2lvl+1), he2c2p2se,he2c2p2sp , he2c2s1s
      integer ipWindIon(NWINDLINE), ipWindNelem(NWINDLINE),ipWEtc
*pointers to element and ion, and spectroscopic label, for level 2 lines
      character*4 chWinLab(NWINDLINE)
      common/WindEtc/ ipWindIon , ipWindNelem,ipWEtc , chWinLab
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real x,rothi,sexp,qn, rotlow,he1ion,he2ion,factor,
     1 brems,hold,edhe3,tripcl,pgrd,
     2 widlin,recem , he2line , he2lmax , he2lone , he1line,
     3 he1lmax , he1lone , dhe1l , dhe2l
      real oldcool , oldtemp,deriv
      integer nzSave , nhit
      integer i , l , iu , n , j
      save nzSave , oldcool , oldtemp , nhit
*
*     routine level2( t10 )
*     routine level3( abund , t10,t21,t20)
*     tsq1 = 1. / (te**2)
*     POPEXC( O12,g1,g2,A21,excit,abund) ; result already*a21
*     POP3(G1,G2,G3,O12,O13,O23,A21,A31,A32,E12,E23,P2,ABUND,GAM2)
*     beseq(cs23,cs24,cs34,tarray,a41)
*     FIVEL( G(1-5) , ex(wn,1-5), cs12,cs13,14,15,23,24,25,34,35,45,
*            A21,31,41,51,32,42,52,43,53,54, pop(1-5), abund)
*
*     free statement lables, >=6
*
      if( lgTrace ) write(qq,'(''   COOLR called, TE='',1P,E12.4)') te
*     possibly update temperature variables
*     edensqte = eden/sqrte
*     cdsqte = 8.629e-6*eden/sqrte
*
      call tfidle
*
*     now zero out the cooling stack
      call colzro
*
*     grain recombination cooling, evaluated elsewhere
*     can either heat or cool the gas, do cooling here
      call coladd( 'dust' , 0 , max(0.,DustCoolGas) )
*
*     grain cooling proportional to temperature ^3/2
      dCooldT = dCooldT + max(0.,DustCoolGas)* 3./(2.*te)
*
*     molecular cooling
      if( lgNoMole ) then
         hmfb = 0.
         h2line = 0.
         h2dis = 0.
*        H + H+ => H2+ cooling
         H2PlsCool = 0.
      else
*        H- FB
         hmfb = hmicol
*        H- FF is in with H ff
*        rate for rotation lines from
*        >>refer Lepp, S., & Shull, J.M. 1983, ApJ, 270, 578
         x = alogte - 4.
         if( te.gt.1087. ) then
            rothi = 3.90e-19 * sexp( 6118./te )
         else
            rothi = 10.**( -19.24 + 0.474*x - 1.247*x*x )
         endif
*        low density rotation cooling
         qn = max(htwo,1e-37)**0.77 + 1.2*max(hi,1e-37)**0.77
         if( te.gt.4031. ) then
            rotlow = 1.38e-22 * sexp( 9243./te ) * qn
         else
            rotlow = 10.**( -22.90 - 0.553*x - 1.148*x*x ) * qn
         endif
         if( rotlow.gt.0. ) then
            h2line = htwo * rothi / (1. + rothi / rotlow )
         else
            h2line = 0.
         endif
         h2dis = rh2dis * hi * htwo * 7.19e-12 * 0.
*        H + H+ => H2+ cooling
         H2PlsCool = max((2.325*te-1875.)*1e-20,0.)*hi*hii*1.66e-11
      endif
      call coladd( 'H-fb' , 0 , hmfb )
*     >>chng 96 nov 15, fac of 2 in deriv to help convergence in very dense
*     models where H- is important, this takes change in eden into
*     partial account
      dCooldT = dCooldT + 2.*hmfb * teinv
      call coladd( 'H2ln' , 0 , h2line )
      dCooldT = dCooldT + h2line * teinv
      call coladd( 'H2ds' , 0 , h2dis )
      dCooldT = dCooldT + h2dis * teinv
      call coladd( 'H2+ ' , 0 , H2PlsCool )
      dCooldT = dCooldT + H2PlsCool * teinv
*
*     carbon monoxide (CO) vib-rot cooling
      call coladd( 'CO C' , 0 , COVibCool )
      dCooldT = dCooldT + dCOVdT
*
*     atomic hydrogen cooling
      call HydroCool
*
*     charge exchange cooling
*     ChargExc = c
*     chrexCool = chrener
*     write(6,'('' chra'',1p,e10.2)') chrexCool/htot
*     call coladd( 'Hchr' ,  0 , chrexCool )
*
*     net cooling for helium, HeI
*     HE1X evaluated in HE1LEV
      he1ion = he1ex * heii
      call coladd( 'He1i' ,  0 , he1ion )
      dCooldT = dCooldT + he1ion * 3.9e4 * tsq1
*
*     all cooling due to hei lines
      if( heii.gt.0. ) then
        he1line = 0.
        he1lmax = 0.
        dhe1l = 0.
*       first do 1s-2s and 1s-2p collisions
        he1line = eden*heiii * Boltzmann*He1deltaTe(2,1) *
     1  (he1n(1)*he1bol(1,2)* ( he1c2s1s+3.*he1cll(2,1) )
     1 - he12s*he1c2s1s - he12p*he1cll(2,1) )
        he1lmax = he1line
        he1lone = he1line
        if( he1lone .gt.0. ) then
*         line is coolant, note derivative counted from ground
          dhe1l = he1lone *(He1deltaTe(2,1)*tsq1-halfte)
        else
*         line is a heating agent
          dhe1l = -he1lone*halfte
        endif
        i = 1
        n = 2
*       upper limits changed to 5 and 6 due to strong cooling from
*       highest psuedo state
        do l=1,5
          do iu=max(3,l+1),6
            he1lone = he1cll(iu,l)*
     2      (he1n(l)*he1bol(l,iu)*he1stat(iu)/he1stat(l)-he1n(iu))*
     3      eden*heii* (Boltzmann * He1deltaTe(iu,l) )
*    3      eden*heii* (1.384e-16 * HdeltaT(iu,l)*4. )
*           >>chng 97 mar 4, above heii was heiii
            if( abs(he1lone).gt.abs(he1lmax) ) then
              he1lmax = he1lone
              i = l
              n = iu
            endif
            he1line = he1line + he1lone
*           >>chng 97 july 1, add in cooling derivative
            if( he1lone .gt.0. ) then
*             line is coolant, note derivative counted from ground
              dhe1l = dhe1l + he1lone *(He1deltaTe(iu,1)*tsq1-halfte)
            else
*             line is a heating agent
              dhe1l = dhe1l - he1lone*halfte
            endif
          end do
        end do
      else
        dhe1l = 0.
        he1line = 0.
      endif
*     all HeI line collisional excitation
      call coladd( 'He1l' ,  0 , he1line )
      dCooldT = dCooldT + dhe1l
*
*     net cooling for helium ionization, HeII
*     HE2X evaluated in HE2LEV
* 666 error! really should break this up into separate heating and cooling
      he2ion = he2ex * heiii
      call coladd( 'He2i' ,  0 , he2ion )
      dCooldT = dCooldT + he2ion * 3.9e4 * tsq1
*
*     all cooling due to heii lines
      if( heiii.gt.0. ) then
*       >>chng 97 july 2, 1s-2s collision had not been in
*       first do 1s-2s and 1s-2p collisions
        he2line = eden*heiii * Boltzmann*He2deltaTe(2,1) *
     1  (he2n(1)*he2bol(1,2)* ( he2c2s1s+3.*he2cll(2,1) )
     1 - he22s*he2c2s1s - he22p*he2cll(2,1) )
        he2lmax = he2line
        he2lone = he2line
        if( he2lone .gt.0. ) then
*         line is coolant, note derivative counted from ground
          dhe2l = he2lone *(He2deltaTe(2,1)*tsq1-halfte)
        else
*         line is a heating agent
          dhe2l = -he2lone*halfte
        endif
        i = 1
        n = 2
*
*       upper limits changed to 5 and 6 due to strong cooling from
*       highest psuedo state
        do l=1,5
          do iu=max(3,l+1),6
            he2lone = he2cll(iu,l)*
     2      (he2n(l)*he2bol(l,iu)*he2stat(iu)/he2stat(l)-he2n(iu))*
     3      eden*heiii* (Boltzmann * He2deltaTe(iu,l) )
*           >>chng 97 mar 5, const to par boltzmann, hdeltat*4 to He2deltaTe
*    3      eden*heiii* (1.384e-16 * HdeltaT(iu,l)*4. )
            if( abs(he2lone).gt.abs(he2lmax) ) then
              he2lmax = he2lone
              i = l
              n = iu
            endif
            he2line = he2line + he2lone
*           >>chng 97 july 1, add in cooling derivative
            if( he2lone .gt.0. ) then
*             line is coolant, note derivative counted from ground
              dhe2l = dhe2l + he2lone *(He2deltaTe(iu,1)*tsq1-halfte)
            else
*             line is a heating agent
              dhe2l = dhe2l - he2lone*halfte
            endif
          end do
        end do
      else
        he2line = 0.
        dhe2l = 0.
      endif
*     all HeII line collisional excitation
      call coladd( 'He2l' ,  0 , he2line )
*666  write(67,'(1p,3e12.4)')  te,he2line,dhe2l
      dCooldT = dCooldT + dhe2l
*
*     total Compton cooling
      tccool = cmcool * te
      call coladd( 'Comp' ,  0 , tccool )
      dCooldT = dCooldT + cmcool
*
*     option for "extra" cooling, expressed as power-law
      if( lgCExtraOn ) then
        cextxx = CoolExtra * ( te/1e4)** cextpw
      else
        cextxx = 0.
      endif
      call coladd( 'Extr' ,  0 , cextxx )
*
*     cooling due to wind expansion, only for winds expansion cooling
      if( windv.gt.0. ) then
        dDensityDT = AccelTot/windv + 2.*windv/radius
        expans = pden*te*Boltzmann * dDensityDT
      else
        dDensityDT = 0.
        expans = 0.
      endif
      call coladd( 'Expn' ,  0 , expans )
      dCooldT = dCooldT + expans/te
*
*     cyclotron cooling
      cyntrn = CycloCoolCoef * eden * te
      call coladd( 'Cycl' ,  0 , cyntrn )
      dCooldT = dCooldT + CycloCoolCoef * eden
*
*     electron-electron brems, approx form from
*     >>refer Stepney and Guilbert, MNRAS 204, 1269 (1983)
*     ok for T<10**9
      eebrm = dble(eden * te * 1.84e-21 ) ** 2
*     >>chng 97 mar 12, added deriv
      dCooldT = dCooldT + eebrm*halfte
      call coladd( 'eeff' ,  0 , eebrm )
*
*     ionized helium induced recombination cooling
      edhe3 = eden * heiii
      c3ind = he2cin(1)*edhe3
      dCooldT = dCooldT + c3ind*(1.58e5*4.*teinv-1.5)*teinv
      do i=1,nhe2lvl-1
        hold = he2cin(i) * edhe3
        c3ind = c3ind + hold
        dCooldT = dCooldT + hold*(1.58e5*4./(i*i*te) - 1.5 ) * teinv
      end do
      call coladd( 'Hein' ,  0 , c3ind )
*
*     collisional ionization of triplet helium
      call coladd( 'HeI3' , 0 , max(0.,He3IonCool))
      dCooldT = dCooldT + max(0.,He3IonCool) * 5.53e4*tsq1
*     net three body heating
*     >>chng 96 july 15, had always been cooling
      heating(2,5) = max( 0., -He3IonCool )
*
*     collisional excitation of all triplet lines, done in he3lev
*     can heat or cool
      if( hei3.gt. 0. ) then
        tripcl = he3clx
      else
        tripcl = 0.
      endif
      call coladd( 'Hetr' , 0 , max(0.,tripcl) )
      heating(2,4) = max( 0., -tripcl )
*
*     >>chng 96 nov 19, to following expression for HeI Lya cooling
*     c584 = hei * eden * 3.1e-19 * sexp(2.3e5/te)
*666 error! break out 2s and 2p, really should write entire he cooling rout
      c584 = eden*heii * 3.41e-11*he1cll(2,1) *
     1 ( he1bol(1,2)*he1n(1)*4.  - he1n(2) )
      dCooldT = dCooldT + c584 * 2.46e5 * tsq1
      call coladd( 'He I' ,  584 , c584 )
*
*     radiation pressure due to HE I 10830
      pgrd = p2s - p2p / 3.
      if( pgrd.ne.0. )  then
        plines(4) = 2.69e-10 *p2p/( p2s-p2p/3.) *
     1  widlin( t10830(ipLnTauIn) , t10830(ipLnTauTot) , 1.37e-4 ,
     2  doppler(2) )
      else
        plines(4) = 0.
      endif
*
*     He I, He II brems (free-free) and recombination
      factor = 0.9 + 1.2/(2.2+abs(alogte-5.398))
*     if( chDffTrns.eq.'OTS' ) then
*     >>chng 95 dec 23 always do ots for brems for stability
*       ots continuum transport - do not count optically thick part
        brems = 1.42e-27 * eden * sqrte * factor * sexp( tff*te1ryd/te)
*     else if( chDffTrns(1:2).eq.'OU' ) then
*       brems = 1.42e-27 * eden * sqrte * factor
*     else
*       write(qq,'('' COOLR: insane chDffTrns='',a3)') chDffTrns
*       stop
*     endif
      bhe = brems  * (4.*heiii + heii)
      call coladd( 'Heff' ,  0 , bhe )
*
      recem = 9.52e-26 * te10 * eden
      herec = recem  * (heiii*6. + heii)
      dCooldT = dCooldT + bhe*halfte + herec*0.27*teinv
      call coladd( 'Hefb' ,  0 , herec )
*
*     heavy element brems and recombination,
*     EdenFFSum set in ESUM, given by Harrington et al. 82
* 666 error! put in charge dependent rec term
      heavfb = 0.
      do i=3,limelm
        do j=2,i+1
          heavfb = heavfb + xIonFracs(i,j)
        end do
      end do
      heavfb = recem*heavfb
      call coladd( 'hvFB' ,  0 , heavfb )
*
      heavff = EdenFFSum * 1.44e-27 * sqrte * eden * factor
      dCooldT = dCooldT + heavfb * .113*teinv
      call coladd( 'Hvff' ,  0 , heavff )
*
*     heavy element collisional ionization
*     derivative should be zero since increased coll ion rate
*     decreases neutral fraction by proportional amount
      colmet = HeavIonCool
      call coladd( 'Hvin' ,  0 , colmet )
*
*     following flag will tell level2 these are level 1 lines
      ipWEtc = 0
*
*     Carbon cooling
      call carcol
*
*     Nitrogen cooling
      call nitcol
*
*     Oxygen cooling
      call oxycol
*
*     Fluorine cooling
      call flucol
*
*     Neon cooling
      call necol
*
*     Magnesium cooling
      call mgcol
*
*     Sodium cooling
      call nacol
*
*     Aluminum cooling
      call alcol
*
*     Silicon cooling
      call silcol
*
*     Phosphorus
      call PhosCol
*
*     Sulphur cooling
      call sulcol
*
*     Chlorine cooling
      call clcol
*
*     Argon cooling
      call arcol
*
*     Potasium cooling
      call PotCol
*
*     Calcium cooling
      call calcol
*
*     Scandium cooling
      call ScCol
*
*     Titanium cooling
      Call TiCol
*
*     Vanadium cooling
      Call VanCol
*
*     Chromium cooling
      Call CrCol
*
*     Iron cooling
      call fecol
*
*     Manganese cooling
      call MnCol
*
*     Cobalt cooling
      call CoCol
*
*     Nickel cooling
      call NiCol
*
*     do all the thousands of lines Dima added with g-bar approximation
      call DimaCool
*
*     now add up all the coolants
      call SumCool( tot )
*
      dc = dCooldT
*     negative cooling
      if( tot.le.0. ) then
        write(qq,'('' COOLR; cooling is <=0, this is impossible.'')')
        call ShowMe
        stop
      endif
*
*     bad derivative
      if( dc.eq.0. ) then
        write(qq,'('' COOLR; cooling slope <=0, this is impossible.'')')
        if( tot.gt.0. .and. lgBit32 .and. hden.lt.1e-4 )
     1  write(qq,'('' Probably due to very low density.'')')
        call ShowMe
        stop
      endif
*
      if( lgTrace ) call fndstr( tot , dc )
*
*     lgTSetOn true for constant temperature model
      if( (.not.lgTSetOn).and.tot.lt.0..and.lgTalk.and.lgColNeg.and.
     1   lgCNegChk .and. nzone.gt.0 ) then
         write(qq,'('' Negative cooling, zone'',I4,'', ='',
     2   1P,E9.2,'' coola='',E9.2,'' CHION='',E9.2,
     3   '' Te='',E9.2)') nzone , tot , coola ,chion , te
         call fndneg
      endif
*
*     possibility of getting emperical cooling derivative
*     normally false, set true with 'set numerical derivatives' command
      if( lgNumDeriv ) then
        if( nzone.gt.2 .and. nzone.eq.nzSave .and. oldtemp.ne.te
     1    .and. nhit.gt.4) then
*         hnit is number of trys on this zone - use to stop numerical problems
*         do not evaluate numerical deriv until well into solution
          deriv = (oldcool - tot)/(oldtemp-te)
          dc = deriv
        else
          deriv = dc
        endif
        if(nzone.ne.nzSave) nhit = 0
        nzSave = nzone
        nhit = nhit + 1
        oldcool = tot
        oldtemp = te
      endif
*
      end
******************************************************************************
      subroutine coppi
      implicit none
*do ionization balance for copper
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (nelem=29)
      parameter (ndim=30)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real GRDEFF(28)
*
*     copper nelem=29
*     rec data not for real
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.34E-10,6.38E-10,1.51E-10,5.43E-11,2.46E-11,1.00E-11,
     1 5.29E-11,2.67E-12,1.26E-12,4.66E-13,1.36E-12,9.44E-13,6.35E-13,
     2 3.80E-13,2.17E-13,5.74E-14,1.04E-13,3.88E-14,5.65E-14,4.02E-14,
     3 3.25E-14,2.65E-14,1.83E-14,1.15E-15,8.39E-15,3.84E-15,4.21E-16,
     4 1.91E-16,1.91E-16/
      data (cion(i,2),i=1,ndim-1)
     1 /8.86E4,2.11E5,4.08E5,6.37E5,8.76E5,1.25E6,1.54E6,1.88E6,2.24E6,
     2 2.60E6,3.73E6,4.09E6,4.46E6,4.99E6,5.39E6,5.79E6,6.63E6,
     3 7.04E6,1.80E7,1.91E7,2.04E7,2.20E7,2.33E7,2.47E7,2.66E7,2.78E7,
     4 1.19E8,1.25E8,1.25E8/
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/28*0.2/
*
*     all rates from Shull and Van Steenberg apj sup 48, 95.
      data rec/2.27e-10, 6.31e-10, 8.83e-10, 1.01e-09, 3.71e-09,
     1         4.84E-09, 1.09E-08, 2.48E-08, 9.68E-08, 1.72E-07,
     2         2.61E-07, 3.95E-07, 4.70E-07, 5.70E-07, 6.98E-07,
     3         8.32E-07, 9.76E-07, 1.19E-06, 1.16E-06, 1.14E-06,
     4         1.17E-06, 1.24E-06, 1.35E-06, 1.38E-06, 6.64E-07,
     5         4.67E-07, 8.98E-07, 8.98E-07/
      data pl/ -0.7, -0.7, -0.7, -0.7, -0.746, -0.682, -0.699, -0.728,
     1 -0.759, -0.79, -0.81, -0.829, -0.828, -0.834, -0.836, -0.84,
     2 -0.846, -0.85, -0.836, -0.824, -0.816, -0.811, -0.808, -0.8,
     3 -0.718, -0.677, -0.732,-0.732/
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.81e-10 , -0.681 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.41E-3, 5.2E-3, .0138, .023, .0419, .0683, .122, .300, .15,
     2 .697, .709, .644, .525, .446, .363, .302, .102, .27, .0467,
     3 .0835, .0996, .199, .24, .115, .0316, .803, .575,.575,  0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.469, .357, .281, .128, .0417, .0558, .0346, 0., 1.9, .277,
     2 .135, .134, .192, .332, .337, .121, .0514, .183, 7.56, 4.55,
     3 4.87, 2.19, 1.15, 1.23, .132, .289, .286,.286,  0./
      data (dite(i,1),i=1,ndim-1)
     1/9.82E+4, 2.01E+5, 3.05E+5, 4.20E+5, 5.56E+5, 6.72E+5, 7.93E+5,
     2 9.00E+5, 1.00E+6, 7.81E+5, 7.64E+5, 7.44E+5, 6.65E+5, 5.97E+5,
     3 5.24E+5, 4.96E+5, 4.46E+5, 8.46E+6, 1.36E+6, 1.23E+6, 1.06E+6,
     4 1.25E+6, 1.23E+6, 3.32E+5, 6.45E+5, 6.65E+7, 2*6.81E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/ 1.01E+5, 1.91E+5, 2.32E+5, 3.18E+5, 4.55E+5, 5.51E+5, 5.28E+5,
     2 0., 5.50E+5, 8.87E+5, 1.80E+6, 1.25E+6, 1.89E+6, 8.84E+5,
     3 1.29E+6, 6.24E+5, 1.59E+6, 8.01E+6, 9.32E+6, 9.45E+6, 9.45E+6,
     4 8.01E+6, 7.57E+6, 2.64E+6, 1.93E+6, 1.19E+7, 2*9.08E+6, 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4     , 6E6
     5, 6E6     , 1E20    , 1E20 , 2*1E20 /
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
*     copper
      IF( .NOT.lgElmtOn(nelem) ) THEN
        RETURN
      ENDIF
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) THEN
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine coronl( chCard , nqh , ar1 )
      implicit none
*parse parameters off coronal equilibrium command
      integer nqh
      real ar1
      character chCard*80
*
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
      logical lgSMinON
*lgSMinON is flag saying that set drmin has been enteed
*     these are 1e-30 and 1e30 by default, and are set with "set dr" cmnds
*     used as one of a pair of limits to how big or small zones get
*     set dr command forces constant dr by setting both to same number
      real sdrmin , sdrmax
      common/sdrmin/ sdrmin , sdrmax , lgSMinON
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      real rdfalt
      common/rdfalt/ rdfalt
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*     include "zonset.com"
*
*     local variables
      logical lgEOL , lgMatch
      integer i
      real a , fread
*
*     coronal equilibrium; set constant temperature to number on line
      lgTSetOn = .true.
      i = 5
      a = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' There should be a temperature on this line.'')')
        stop
      endif
*
*     numbers less than or equal to 10 are the log of the temperature
      if( a.le.10. .and. .not.lgMatch('LINE',chCard) ) then
        ForceTemp = 10.**a
      else
        ForceTemp = a
      endif
      if( ForceTemp.lt.3. ) then
        write(qq,'('' TE<3K, reset to 3K.'')')
        ForceTemp = 3.
      endif
*
*     now simulate a BREMS line
      nspec = nspec + 1
      if( nspec.gt.limspc )then
*       too many continua were entered
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
      chSpType(nspec) = 'BREMS'
      slope(nspec) = 1e8
      cutoff(nspec,1) = 0.
      cutoff(nspec,2) = 0.
*     simulate an ionization parameter line
      nqh = nqh + 1
      if( nqh.gt.limspc )then
*       too many continua were entered
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
      chRSpec(nqh) = 'SQCM'
      chSpNorm(nqh) = 'IONI'
*     >>chng 96 June 17, to stop mole network from crashing
      totpow(nqh) = -10.
*     set R to large value if U specified but R is not
      if( radius.eq.0. ) then
         ar1 = rdfalt
         radius = 10.** ar1
      endif
*
      end
******************************************************************************
      subroutine cratio( chCard , nqh )
      implicit none
*derive continuum luminosity of this continuum relative to previous
      character chCard*80
      integer nqh
*
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real range
      common/range/ range(limspc,2)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      integer nvary , nparm
      common/nvary/ nvary , nparm
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      real emm , egamry
      common/bounds/ emm , egamry
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgMatch , lgEOL , lgAoxOn
      integer i
      real aox , fread
*
*     enter a continuum luminosity as a ratio of
*     nuFnu for this continuum relative to a previous continuum
*     format; first number is ratio of second to first continuum
*     second number is energy for this ratio
*     if third numbewr on line, then 2nd number is energy of
*     first continuum, while 3rd number is energy of second continuum
      nqh = nqh + 1
      if( nqh.eq.1 ) then
        write(qq,'('' Cant form ratio since this is first '',
     1  ''continuum.'')')
        stop
      else if( nqh.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
*     per sq cm or luminosity is really irrelevant
      chRSpec(nqh) = 'SQCM'
      chSpNorm(nqh) = 'RATI'
      if( lgMatch( 'ALPH' , chCard ) ) then
        lgAoxOn = .true.
*       only one parameter to be recognized, alpha ox
        i = 5
        aox = fread( chCard , i , 76 , lgEOL )
*       403.3 is ratio of energies where alpha ox defined,
*       assumed to be 2500A and 2keV
        totpow(nqh) = 403.3**aox
        range(nqh,1) = 0.3645
        range(nqh,2) = 147.
      else
        lgAoxOn = .false.
*       specify ratio, two energies
        i = 5
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
*       assumed to be a log if negative or zero
        if( totpow(nqh).le. 0. .or. lgMatch(' LOG',chCard) ) then
          totpow(nqh) = 10.**totpow(nqh)
        endif
        if( lgEOL ) then
          write(qq,'('' There must be a number on this line.'')')
          stop
        endif
        range(nqh,1) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' There must be at least 2 numbers on '',
     1    ''this line.'')')
          write(qq,'('' The ratio, and two energies'')')
          stop
        endif
        range(nqh,2) = fread( chCard , i , 76 , lgEOL )
*       if only one number then assume same for each
        if( lgEOL ) range(nqh,2) = range(nqh,1)
        if( range(nqh,1).lt.emm .or.  range(nqh,2).lt.emm ) then
          write(qq,'('' One of the energies is too low, outside''
     1    ,'' the range of the code.'')')
          stop
        else if( range(nqh,1).gt.egamry .or.  range(nqh,2).gt.egamry
     1   ) then
          write(qq,'('' One of the energies is too high, outside''
     1    ,'' the range of the code.'')')
          stop
        endif
      endif
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
*       pointer to where to write
        nvfpnt(nparm) = nRead
        if( lgAoxOn ) then
*         this is the number of parameters to feed onto the input line
          nvarxt(nparm) = 1
*         vary alpha ox
          write(chVarFmt(nparm),'(''(''''RATIO alphox'''',F9.5)'')')
*         param is linear scale factor
          vparm(nparm,1) = aox
          vincr(nparm) = 0.2
        else
*         this is the number of parameters to feed onto the input line
          nvarxt(nparm) = 3
          write(chVarFmt(nparm),'(''(''''RATIO LOG '''',3F11.5)'')')
*         param is log of abundance by number relative to hydrogen
          vparm(nparm,1) = log10( totpow(nqh) )
          vparm(nparm,2) = range(nqh,1)
          vparm(nparm,3) = range(nqh,2)
          vincr(nparm) = 0.2
        endif
      endif
*
      end
**************************************************************************
      real function crsdst( freq , nd , chAbedo )
      implicit none
*interpolate on grains cross section, called once per calculation
      real freq
      character*4 chAbedo
      integer nd
*
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real dustp,eev, sab,sse,darea, dsize
      integer ndpts
      common/dust/ dustp(4,ndust),eev(limcrs,ndust),
     z sab(limcrs,ndust),sse(limcrs,ndust),ndpts(ndust),darea(ndust),
     z dsize(ndust)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
*
*     local variables
      real xlog(limcrs) , crs1(limcrs)
      character*4 chScat
      logical lgFirst , lgNew
      save lgFirst , lgNew , ncrs , ndold , chScat , xlog , crs1
      integer ndold , ncrs , i
      real x , y
*
      data lgFirst/.true./ , ndold/-1/ , chScat/'NONE'/
*
      if( lgFirst ) then
        lgNew = .true.
        ndold = nd
        chScat = chAbedo
        lgFirst = .false.
      else
        if(nd.ne.ndold .or. chScat.ne.chAbedo ) then
          lgNew = .true.
          ndold = nd
          chScat = chAbedo
        else
          lgNew = .false.
        endif
      endif
*
      if( lgNew ) then
        ncrs = ndpts(nd)
        if( chAbedo.eq.'ABSO' ) then
*         do absorption cross sections
          do i=1,ncrs
            xlog(i) = eev(i,nd)
*           dust scross section with log of depletion scale factor
*           >>chng 97 july 17, now remove depletion, so physical quantity
*           crs1(i) = sab(i,nd) * dstfactor(nd)
            crs1(i) = sab(i,nd)
          end do
        else if( chAbedo.eq.'SCAT' ) then
*         do scattering cross sections
          do i=1,ncrs
            xlog(i) = eev(i,nd)
*           dust scross section with scale factor
*           >>chng 97 july 17, now remove depletion, so physical quantity
*           crs1(i) = sse(i,nd) * dstfactor(nd)
            crs1(i) = sse(i,nd)
          end do
        else
          stop
        endif
      endif
*
      x = log10( freq )
      if( x.lt.eev(1,nd) .or. x.gt.eev(ncrs,nd) ) then
         crsdst = 0.
      else
        call lint( xlog , crs1 , ncrs , x , y )
        crsdst = 10.**y
      endif
*
      end
******************************************************************************
      real function csphot( inu , ithr , iofset )
      implicit none
*returns photoionization cross section from opacity stage using std pointers
      integer inu , ithr , iofset
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
*
*     function to facilitate addressing opacity array
*     INU is pointer to frequency where opacity is to be evaluated
*     ITHR is pointer to threshold
*     IOFSET is offset as defined in opac0
*
      csphot = OpacStack( inu-ithr + iofset )
*
      end
********************************************************************************
      block data ctdata
      implicit none
*block data with Jim Kingdon's charge transfer data
*
      real CTIon
*     second dimension is ionization stage,
*     1=+0 for parent, etc
*     third dimension is atomic number of atom
      common/CTIon/ CTIon(7,4,30)
      real CTRecomb
*     second dimension is ionization stage,
*     1=+1 for parent, etc
*     third dimension is atomic number of atom
      common/CTRecomb/ CTRecomb(6,4,30)
*
*     local variables
      integer i
*
*     digital form of the fits to the charge transfer
*     ionization rate coefficients
*
*     Note: First parameter is in units of 1e-9!
*     Note: Seventh parameter is in units of 1e4 K
      data (CTIon(i,1,3),i=1,7)/2.81e-3,2.00,221.36,-47.64,1e2,1e4,0.0/
      data (CTIon(i,2,3),i=1,7)/7*0./
      data (CTIon(i,3,3),i=1,7)/7*0./
      data (CTIon(i,1,4),i=1,7)/7*0./
      data (CTIon(i,2,4),i=1,7)/7*0./
      data (CTIon(i,3,4),i=1,7)/7*0./
      data (CTIon(i,1,5),i=1,7)/7*0./
      data (CTIon(i,2,5),i=1,7)/7*0./
      data (CTIon(i,3,5),i=1,7)/7*0./
      data (CTIon(i,1,6),i=1,7)/1.00e-5,0.00,0.00,0.00,1e3,1e4,0.0/
      data (CTIon(i,2,6),i=1,7)/7*0./
      data (CTIon(i,3,6),i=1,7)/7*0./
      data (CTIon(i,1,7),i=1,7)/4.55e-3,-0.29,-0.92,-8.38,1e2,5e4,1.086/
      data (CTIon(i,2,7),i=1,7)/7*0./
      data (CTIon(i,3,7),i=1,7)/7*0./
      data (CTIon(i,1,8),i=1,7)/7.40e-2,0.47,24.37,-0.74,1e1,1e4,0.023/
      data (CTIon(i,2,8),i=1,7)/7*0./
      data (CTIon(i,3,8),i=1,7)/7*0./
      data (CTIon(i,1,9),i=1,7)/7*0./
      data (CTIon(i,2,9),i=1,7)/7*0./
      data (CTIon(i,3,9),i=1,7)/7*0./
      data (CTIon(i,1,10),i=1,7)/7*0./
      data (CTIon(i,2,10),i=1,7)/7*0./
      data (CTIon(i,3,10),i=1,7)/7*0./
      data (CTIon(i,1,11),i=1,7)/3.34e-6,9.31,2632.31,-3.04,1e3,2e4,0.0/
      data (CTIon(i,2,11),i=1,7)/7*0./
      data (CTIon(i,3,11),i=1,7)/7*0./
      data (CTIon(i,1,12),i=1,7)/9.76e-3,3.14,55.54,-1.12,5e3,3e4,0.0/
      data (CTIon(i,2,12),i=1,7)/7.60e-5,0.00,-1.97,-4.32,1e4,3e5,1.670/
      data (CTIon(i,3,12),i=1,7)/7*0./
      data (CTIon(i,1,13),i=1,7)/7*0./
      data (CTIon(i,2,13),i=1,7)/7*0./
      data (CTIon(i,3,13),i=1,7)/7*0./
      data (CTIon(i,1,14),i=1,7)/0.92,1.15,0.80,-0.24,1e3,2e5,0.0/
      data (CTIon(i,2,14),i=1,7)/4.10e-1,0.24,3.17,4.18e-3,5e3,1e6,
     1 3.178/
      data (CTIon(i,3,14),i=1,7)/7*0./
      data (CTIon(i,1,15),i=1,7)/7*0./
      data (CTIon(i,2,15),i=1,7)/7*0./
      data (CTIon(i,3,15),i=1,7)/7*0./
      data (CTIon(i,1,16),i=1,7)/1.00e-5,0.00,0.00,0.00,1e3,1e4,0.0/
      data (CTIon(i,2,16),i=1,7)/7*0./
      data (CTIon(i,3,16),i=1,7)/7*0./
      data (CTIon(i,1,17),i=1,7)/7*0./
      data (CTIon(i,2,17),i=1,7)/7*0./
      data (CTIon(i,3,17),i=1,7)/7*0./
      data (CTIon(i,1,18),i=1,7)/7*0./
      data (CTIon(i,2,18),i=1,7)/7*0./
      data (CTIon(i,3,18),i=1,7)/7*0./
      data (CTIon(i,1,19),i=1,7)/7*0./
      data (CTIon(i,2,19),i=1,7)/7*0./
      data (CTIon(i,3,19),i=1,7)/7*0./
      data (CTIon(i,1,20),i=1,7)/7*0./
      data (CTIon(i,2,20),i=1,7)/7*0./
      data (CTIon(i,3,20),i=1,7)/7*0./
      data (CTIon(i,1,21),i=1,7)/7*0./
      data (CTIon(i,2,21),i=1,7)/7*0./
      data (CTIon(i,3,21),i=1,7)/7*0./
      data (CTIon(i,1,22),i=1,7)/7*0./
      data (CTIon(i,2,22),i=1,7)/7*0./
      data (CTIon(i,3,22),i=1,7)/7*0./
      data (CTIon(i,1,23),i=1,7)/7*0./
      data (CTIon(i,2,23),i=1,7)/7*0./
      data (CTIon(i,3,23),i=1,7)/7*0./
      data (CTIon(i,1,24),i=1,7)/7*0./
      data (CTIon(i,2,24),i=1,7)/4.39,0.61,-0.89,-3.56,1e3,3e4,3.349/
      data (CTIon(i,3,24),i=1,7)/7*0./
      data (CTIon(i,1,25),i=1,7)/7*0./
      data (CTIon(i,2,25),i=1,7)/2.83e-1,6.80e-3,6.44e-2,-9.70,1e3,3e4,
     1 2.368/
      data (CTIon(i,3,25),i=1,7)/7*0./
      data (CTIon(i,1,26),i=1,7)/7*0./
      data (CTIon(i,2,26),i=1,7)/2.10,7.72e-2,-0.41,-7.31,1e4,1e5,3.005/
      data (CTIon(i,3,26),i=1,7)/7*0./
      data (CTIon(i,1,27),i=1,7)/7*0./
      data (CTIon(i,2,27),i=1,7)/1.20e-2,3.49,24.41,-1.26,1e3,3e4,4.044/
      data (CTIon(i,3,27),i=1,7)/7*0./
      data (CTIon(i,1,28),i=1,7)/7*0./
      data (CTIon(i,2,28),i=1,7)/7*0./
      data (CTIon(i,3,28),i=1,7)/7*0./
      data (CTIon(i,1,29),i=1,7)/7*0./
      data (CTIon(i,2,29),i=1,7)/7*0./
      data (CTIon(i,3,29),i=1,7)/7*0./
      data (CTIon(i,1,30),i=1,7)/7*0./
      data (CTIon(i,2,30),i=1,7)/7*0./
      data (CTIon(i,3,30),i=1,7)/7*0./
*
*     digital form of the fits to the charge transfer
*     recombination rate coefficients (total)
*
*     Note: First parameter is in units of 1e-9!
*     recombination
      data (CTRecomb(i,1,2),i=1,6)/7.47e-6,2.06,9.93,-3.89,6e3,1e5/
      data (CTRecomb(i,2,2),i=1,6)/1.00e-5,0.,0.,0.,1e3,1e7/
      data (CTRecomb(i,1,3),i=1,6)/6*0./
      data (CTRecomb(i,2,3),i=1,6)/1.26,0.96,3.02,-0.65,1e3,3e4/
      data (CTRecomb(i,3,3),i=1,6)/1.00e-5,0.,0.,0.,2e3,5e4/
      data (CTRecomb(i,1,4),i=1,6)/6*0./
      data (CTRecomb(i,2,4),i=1,6)/1.00e-5,0.,0.,0.,2e3,5e4/
      data (CTRecomb(i,3,4),i=1,6)/1.00e-5,0.,0.,0.,2e3,5e4/
      data (CTRecomb(i,4,4),i=1,6)/5.17,0.82,-0.69,-1.12,2e3,5e4/
      data (CTRecomb(i,1,5),i=1,6)/6*0./
      data (CTRecomb(i,2,5),i=1,6)/2.00e-2,0.,0.,0.,1e3,1e9/
      data (CTRecomb(i,3,5),i=1,6)/1.00e-5,0.,0.,0.,2e3,5e4/
      data (CTRecomb(i,4,5),i=1,6)/5.27e-1,0.76,-0.63,-1.17,2e3,5e4/
      data (CTRecomb(i,1,6),i=1,6)/1.76e-9,8.33,4278.78,-6.41,1e3,
     1 1e4/
      data (CTRecomb(i,2,6),i=1,6)/1.67e-4,2.79,304.72,-4.07,5e3,5e4/
      data (CTRecomb(i,3,6),i=1,6)/3.25,0.21,0.19,-3.29,1e3,1e5/
      data (CTRecomb(i,4,6),i=1,6)/332.46,-0.11,-9.95e-1,-1.58e-3,1e1,
     1 1e5/
      data (CTRecomb(i,1,7),i=1,6)/1.01e-3,-0.29,-0.92,-8.38,1e2,5e4/
      data (CTRecomb(i,2,7),i=1,6)/3.05e-1,0.60,2.65,-0.93,1e3,1e5/
      data (CTRecomb(i,3,7),i=1,6)/4.54,0.57,-0.65,-0.89,1e1,1e5/
      data (CTRecomb(i,4,7),i=1,6)/3.28,0.52,-0.52,-0.19,1e3,3e5/
      data (CTRecomb(i,1,8),i=1,6)/1.04,3.15e-2,-0.61,-9.73,1e1,1e4/
      data (CTRecomb(i,2,8),i=1,6)/1.04,0.27,2.02,-5.92,1e2,1e5/
      data (CTRecomb(i,3,8),i=1,6)/3.98,0.26,0.56,-2.62,1e3,5e4/
      data (CTRecomb(i,4,8),i=1,6)/2.52e-1,0.63,2.08,-4.16,1e3,3e4/
      data (CTRecomb(i,1,9),i=1,6)/6*0./
      data (CTRecomb(i,2,9),i=1,6)/1.00e-5,0.,0.,0.,2e3,5e4/
      data (CTRecomb(i,3,9),i=1,6)/9.86,0.29,-0.21,-1.15,2e3,5e4/
      data (CTRecomb(i,4,9),i=1,6)/7.15e-1,1.21,-0.70,-0.85,2e3,5e4/
      data (CTRecomb(i,1,10),i=1,6)/6*0./
      data (CTRecomb(i,2,10),i=1,6)/1.00e-5,0.,0.,0.,5e3,5e4/
      data (CTRecomb(i,3,10),i=1,6)/14.73,4.52e-2,-0.84,-0.31,5e3,5e4/
      data (CTRecomb(i,4,10),i=1,6)/6.47,0.54,3.59,-5.22,1e3,3e4/
      data (CTRecomb(i,1,11),i=1,6)/6*0./
      data (CTRecomb(i,2,11),i=1,6)/1.00e-5,0.,0.,0.,2e3,5e4/
      data (CTRecomb(i,3,11),i=1,6)/1.33,1.15,1.20,-0.32,2e3,5e4/
      data (CTRecomb(i,4,11),i=1,6)/1.01e-1,1.34,10.05,-6.41,2e3,5e4/
      data (CTRecomb(i,1,12),i=1,6)/6*0./
      data (CTRecomb(i,2,12),i=1,6)/8.58e-5,2.49e-3,2.93e-2,-4.33,1e3,
     1 3e4/
      data (CTRecomb(i,3,12),i=1,6)/6.49,0.53,2.82,-7.63,1e3,3e4/
      data (CTRecomb(i,4,12),i=1,6)/6.36,0.55,3.86,-5.19,1e3,3e4/
      data (CTRecomb(i,1,13),i=1,6)/6*0./
      data (CTRecomb(i,2,13),i=1,6)/1.00e-5,0.,0.,0.,1e3,3e4/
      data (CTRecomb(i,3,13),i=1,6)/7.11e-5,4.12,1.72e4,-22.24,1e3,3e4/
      data (CTRecomb(i,4,13),i=1,6)/7.52e-1,0.77,6.24,-5.67,1e3,3e4/
      data (CTRecomb(i,1,14),i=1,6)/6*0./
      data (CTRecomb(i,2,14),i=1,6)/1.23,0.24,3.17,4.18e-3,1e1,1e6/
      data (CTRecomb(i,3,14),i=1,6)/4.90e-1,-8.74e-2,-0.36,-0.79,1e3,
     1 3e4/
      data (CTRecomb(i,4,14),i=1,6)/7.58,0.37,1.06,-4.09,1e3,5e4/
      data (CTRecomb(i,1,15),i=1,6)/6*0./
      data (CTRecomb(i,2,15),i=1,6)/1.74e-4,3.84,36.06,-0.97,1e3,3e4/
      data (CTRecomb(i,3,15),i=1,6)/9.46e-2,-5.58e-2,0.77,-6.43,1e3,3e4/
      data (CTRecomb(i,4,15),i=1,6)/5.37,0.47,2.21,-8.52,1e3,3e4/
      data (CTRecomb(i,1,16),i=1,6)/3.82e-7,11.10,2.57e4,-8.22,1e3,1e4/
      data (CTRecomb(i,2,16),i=1,6)/1.00e-5,0.,0.,0.,1e3,3e4/
      data (CTRecomb(i,3,16),i=1,6)/2.29,4.02e-2,1.59,-6.06,1e3,3e4/
      data (CTRecomb(i,4,16),i=1,6)/6.44,0.13,2.69,-5.69,1e3,3e4/
      data (CTRecomb(i,1,17),i=1,6)/6*0./
      data (CTRecomb(i,2,17),i=1,6)/1.00e-5,0.,0.,0.,1e3,3e4/
      data (CTRecomb(i,3,17),i=1,6)/1.88,0.32,1.77,-5.70,1e3,3e4/
      data (CTRecomb(i,4,17),i=1,6)/7.27,0.29,1.04,-10.14,1e3,3e4/
      data (CTRecomb(i,1,18),i=1,6)/6*0./
      data (CTRecomb(i,2,18),i=1,6)/1.00e-5,0.,0.,0.,1e3,3e4/
      data (CTRecomb(i,3,18),i=1,6)/4.57,0.27,-0.18,-1.57,1e3,3e4/
      data (CTRecomb(i,4,18),i=1,6)/6.37,0.85,10.21,-6.22,1e3,3e4/
      data (CTRecomb(i,1,19),i=1,6)/6*0./
      data (CTRecomb(i,2,19),i=1,6)/1.00e-5,0.,0.,0.,1e3,3e4/
      data (CTRecomb(i,3,19),i=1,6)/4.76,0.44,-0.56,-0.88,1e3,3e4/
      data (CTRecomb(i,4,19),i=1,6)/1.00e-5,0.,0.,0.,1e3,3e4/
      data (CTRecomb(i,1,20),i=1,6)/6*0./
      data (CTRecomb(i,2,20),i=1,6)/0.,0.,0.,0.,1e1,1e9/
      data (CTRecomb(i,3,20),i=1,6)/3.17e-2,2.12,12.06,-0.40,1e3,3e4/
      data (CTRecomb(i,4,20),i=1,6)/2.68,0.69,-0.68,-4.47,1e3,3e4/
      data (CTRecomb(i,1,21),i=1,6)/6*0./
      data (CTRecomb(i,2,21),i=1,6)/0.,0.,0.,0.,1e1,1e9/
      data (CTRecomb(i,3,21),i=1,6)/7.22e-3,2.34,411.50,-13.24,1e3,3e4/
      data (CTRecomb(i,4,21),i=1,6)/1.20e-1,1.48,4.00,-9.33,1e3,3e4/
      data (CTRecomb(i,1,22),i=1,6)/6*0./
      data (CTRecomb(i,2,22),i=1,6)/0.,0.,0.,0.,1e1,1e9/
      data (CTRecomb(i,3,22),i=1,6)/6.34e-1,6.87e-3,0.18,-8.04,1e3,3e4/
      data (CTRecomb(i,4,22),i=1,6)/4.37e-3,1.25,40.02,-8.05,1e3,3e4/
      data (CTRecomb(i,1,23),i=1,6)/6*0./
      data (CTRecomb(i,2,23),i=1,6)/1.00e-5,0.,0.,0.,1e3,3e4/
      data (CTRecomb(i,3,23),i=1,6)/5.12,-2.18e-2,-0.24,-0.83,1e3,3e4/
      data (CTRecomb(i,4,23),i=1,6)/1.96e-1,-8.53e-3,0.28,-6.46,1e3,3e4/
      data (CTRecomb(i,1,24),i=1,6)/6*0./
      data (CTRecomb(i,2,24),i=1,6)/5.27e-1,0.61,-0.89,-3.56,1e3,3e4/
      data (CTRecomb(i,3,24),i=1,6)/10.90,0.24,0.26,-11.94,1e3,3e4/
      data (CTRecomb(i,4,24),i=1,6)/1.18,0.20,0.77,-7.09,1e3,3e4/
      data (CTRecomb(i,1,25),i=1,6)/6*0./
      data (CTRecomb(i,2,25),i=1,6)/1.65e-1,6.80e-3,6.44e-2,-9.70,1e3,
     1 3e4/
      data (CTRecomb(i,3,25),i=1,6)/14.20,0.34,-0.41,-1.19,1e3,3e4/
      data (CTRecomb(i,4,25),i=1,6)/4.43e-1,0.91,10.76,-7.49,1e3,3e4/
      data (CTRecomb(i,1,26),i=1,6)/6*0./
      data (CTRecomb(i,2,26),i=1,6)/1.26,7.72e-2,-0.41,-7.31,1e3,1e5/
      data (CTRecomb(i,3,26),i=1,6)/3.42,0.51,-2.06,-8.99,1e3,1e5/
      data (CTRecomb(i,4,26),i=1,6)/14.60,3.57e-2,-0.92,-0.37,1e3,3e4/
      data (CTRecomb(i,1,27),i=1,6)/6*0./
      data (CTRecomb(i,2,27),i=1,6)/5.30,0.24,-0.91,-0.47,1e3,3e4/
      data (CTRecomb(i,3,27),i=1,6)/3.26,0.87,2.85,-9.23,1e3,3e4/
      data (CTRecomb(i,4,27),i=1,6)/1.03,0.58,-0.89,-0.66,1e3,3e4/
      data (CTRecomb(i,1,28),i=1,6)/6*0./
      data (CTRecomb(i,2,28),i=1,6)/1.05,1.28,6.54,-1.81,1e3,1e5/
      data (CTRecomb(i,3,28),i=1,6)/9.73,0.35,0.90,-5.33,1e3,3e4/
      data (CTRecomb(i,4,28),i=1,6)/6.14,0.25,-0.91,-0.42,1e3,3e4/
      data (CTRecomb(i,1,29),i=1,6)/6*0./
      data (CTRecomb(i,2,29),i=1,6)/1.47e-3,3.51,23.91,-0.93,1e3,3e4/
      data (CTRecomb(i,3,29),i=1,6)/9.26,0.37,0.40,-10.73,1e3,3e4/
      data (CTRecomb(i,4,29),i=1,6)/11.59,0.20,0.80,-6.62,1e3,3e4/
      data (CTRecomb(i,1,30),i=1,6)/6*0./
      data (CTRecomb(i,2,30),i=1,6)/1.00e-5,0.,0.,0.,1e3,3e4/
      data (CTRecomb(i,3,30),i=1,6)/6.96e-4,4.24,26.06,-1.24,1e3,3e4/
      data (CTRecomb(i,4,30),i=1,6)/1.33e-2,1.56,-0.92,-1.20,1e3,3e4/
*
      end
 
******************************************************************************
      real function da( z )
      implicit none
*interpolate on three body recombination by Steve Cota
      real z
*
* WRITTEN BY S. A. COTA, 2/87
*
      integer maxz
      parameter ( maxz = 28 )
*
* MAXZ IS THE MAXIMUM EFFECTIVE NUCLEAR CHARGE ( = IONIC CHARGE + 1 )
* WHICH THE DIMENSION STATEMENTS ACCOMODATE.
*
* IT IS USED ONLY FOR THE ARRAY ZLOG7 ( = 7 * LOG ( Z ) )
* AND THE ARRAY ZLOG2 ( = 2 * LOG ( Z ) ) .   THESE ARRAYS
* CONTAIN EASILY CALCULATED VALUES, WHICH HAVE BEEN STORED
* TO SAVE TIME IN EXECUTION.
*
* IF MAXZ IS EXCEEDED, THIS PROGRAM SIMPLY CALCULATES THE
* LOGS INSTEAD OF LOOKING THEM UP.
*
*
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      integer ilt,iltln, ilthn, ihthn, ifail
      common/dalerr/ilt, iltln, ilthn, ihthn, ifail
*
      real tz, zlog7, zlog2
      common/parms/ tz( 83), zlog7(28), zlog2(28)
      real a0,b0,x0
      common/dax/ a0( 83),b0( 83),x0( 83)
      real a1,b1,x1
      common/xcx/ a1( 83),b1( 83),x1( 83)
      real a2,b2,x2
      common/xnx/ a2( 21: 83),b2( 21: 83),x2( 21: 83)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real xmap , xinvrs,alognc,alogn,alogt,zlog,expp
      integer nt0,nt1,jfail,nt,nz
      real c, d, u, v, a, b, x, y, xnc
*
      real xx(3), yya(3), yyb(3), yyx(3), yyy(3)
*     logical lgInterp
*
*     lgInterp = .true.
*
*begin sanity check
      if( zlog7(2).le.0. ) then
        write(qq,'('' Insane value in zlog7 array.'')')
        write(qq,'('' Was block data dalpha linked in?'')')
        stop
      endif
*end sanity check
*
      nz = z + .1
      if ( nz .gt. maxz ) then
        zlog = alog10 ( z )
        alogt = alogte - 2. * zlog
        alogn = alogne - 7. * zlog
      else
        alogt = alogte - zlog2 (nz)
        alogn = alogne - zlog7 (nz)
      endif
*
* CHECK IF PARAMETERS ARE WITHIN BOUNDS.  IF NOT, INCREMENT
*       APPROPRIATE ERROR COUNTER AND SET TO BOUNDARY IF
*       NECESSARY:
*
* DEFINITION OF ERROR COUNTERS:
*
*     ILT    : LOW T
*     ILTLN  : LOW T , LOW  N
*     ILTHN  : LOW T , HIGH N
*     IHTHN  : HIGH T , HIGH N
*
      if  ( alogt .lt. 0. ) then
        ilt = ilt + 1
        alogt = 0.
      endif
*
      if  ( alogt .le. 2.1760913 ) then
        if  ( alogn .lt. ( 3.5 * alogt - 8. ) ) then
          iltln = iltln + 1
        else if ( alogn .gt. ( 3.5 * alogt - 2. ) ) then
          ilthn = ilthn + 1
          alogn = 3.5 * alogt - 2.
        endif
*
      else if ( alogt .le. 2.4771213 ) then
        if ( alogn .gt. 9. ) then
          ilthn = ilthn + 1
          alogn = 9.
        endif
*
      else if ( alogt .le. 5.1139434 ) then
        if ( alogn .gt. 13. ) then
          ihthn = ihthn + 1
          alogn = 13.
        endif
*
      else
        da  = 0.
        return
      endif
*
* LOCATE POSITION IN ARRAYS
*
      if ( alogt .le. 2. ) then
        nt  = 9.9657843 * alogt + 1.
      else
        nt = 19.931568 * alogt - 19.
      endif
      nt = max( 1 , min( 83 , nt ) )
*
* CENTER UP SINCE ARRAY VALUES ARE ROUNDED
*
      if ( abs ( alogt - tz ( nt ) ) .ge.
     *     abs ( alogt - tz ( min(83,nt+1) ) ) ) then
        nt = min( 83 , nt + 1 )
      else if ( abs ( alogt - tz ( nt  ) ) .gt.
     *          abs ( alogt - tz ( max(1,nt - 1) ) ) ) then
        nt  = max( 1 , nt - 1 )
      endif
*
* CHECK IF INTERPOLATION IS NEEDED AND PROCEED IF NOT.
*
      if ( abs ( alogt - tz ( nt ) ) .lt. 0.00001 ) then
        if ( z .ne. 1.0 ) then
          c = a1 ( nt )
          d = b1 ( nt )
          u = x1 ( nt )
          v = 8.90
        else
          nt = min( 83 , max( 21 , nt ) )
          c = a2 ( nt )
          d = b2 ( nt )
          u = x2 ( nt )
          v = 9.40
        endif
*
        xnc    = xinvrs ( alogn , c , d , u , v , jfail )
        if( xnc.le.0. .or. jfail.ne.0 ) then
           ifail = 1
           jfail = 1
           da = 0.
           return
        endif
        alognc = alog10 ( xnc )
*
        a      = a0 ( nt )
        b      = b0 ( nt )
        x      = -2.45
        y      = x0 ( nt )
        nt0    = nt - 1
*
*   IF INTERPOLATION WAS REQUIRED,
*   CHECK THAT NT IS NOT ON THE EDGE OF A DISCONTINUITY,
*   EITHER AT END OF ARRAYS OR WITHIN THEM,
*   WHERE VALUES CHANGE ABRUPTLY.
*
      else
        if ( ( nt .le. 21 ) .and. ( z .eq. 1.0 ) ) then
          nt = 22
        else if ( nt .le. 1 ) then
          nt = 2
        else if ( nt .ge. 83 ) then
          nt = 82
        else if ( nt .eq. 24 ) then
          if ( alogt .le. 2.1760913 ) then
            nt = 23
          else
            nt = 25
          endif
        else if ( nt .eq. 30 ) then
          if ( alogt .le. 2.4771213 ) then
            nt = 29
          else
            nt = 31
          endif
        endif
*
        nt0 = nt - 1
        nt1 = nt + 1
        xx ( 1 ) = tz ( nt0 )
        xx ( 2 ) = tz  ( nt )
        xx ( 3 ) = tz ( nt1 )
*
        if ( z .ne. 1.0 ) then
          if ( nt0 .eq. 24 ) then
            yya ( 1 ) = 17.2880135
            yyb ( 1 ) = 6.93410742e+03
            yyx ( 1 ) = -3.75
          else if ( nt0 .eq. 30 ) then
            yya ( 1 ) = 17.4317989
            yyb ( 1 ) = 1.36653821e+03
            yyx ( 1 ) = -3.40
          else
            yya ( 1 ) = a1( nt0 )
            yyb ( 1 ) = b1( nt0 )
            yyx ( 1 ) = x1( nt0 )
          endif
*
          yya ( 2 ) = a1( nt  )
          yya ( 3 ) = a1( nt1 )
          c       =  xmap ( xx , yya , alogt )
          yyb ( 2 ) = b1( nt  )
          yyb ( 3 ) = b1( nt1 )
          d       = xmap ( xx , yyb , alogt )
          yyx ( 2 ) = x1( nt  )
          yyx ( 3 ) = x1( nt1 )
          u        = xmap ( xx , yyx , alogt )
          v        = 8.90
*
        else
          if ( nt0 .eq. 24 ) then
            yya ( 1 ) = 20.1895161
            yyb ( 1 ) = 2.25774918e+01
            yyx ( 1 ) = -1.66
          else if ( nt0 .eq. 30 ) then
            yya ( 1 ) = 19.8647804
            yyb ( 1 ) = 6.70408707e+02
            yyx ( 1 ) = -2.12
          else
            yya ( 1 ) = a2( nt0 )
            yyb ( 1 ) = b2( nt0 )
            yyx ( 1 ) = x2( nt0 )
          endif
*
          yya ( 2 ) = a2( nt  )
          yya ( 3 ) = a2( nt1 )
          c       =  xmap ( xx , yya , alogt )
          yyb ( 2 ) = b2( nt  )
          yyb ( 3 ) = b2( nt1 )
          d       = xmap ( xx , yyb , alogt )
          yyx ( 2 ) = x2( nt  )
          yyx ( 3 ) = x2( nt1 )
          u        = xmap ( xx , yyx , alogt )
          v        = 9.40
        endif
*
        xnc    = xinvrs ( alogn , c , d , u , v , jfail )
        if( xnc.le.0. .or. jfail.ne.0 ) then
           ifail = 1
           jfail = 1
           da = 0.
           return
        endif
        alognc = alog10 ( xnc )
*
        if ( nt0 .eq. 24 ) then
          yya ( 1 ) = -8.04963875
          yyb ( 1 ) = 1.07205127e+03
          yyy ( 1 ) = 2.05
        else if ( nt0 .eq. 30 ) then
          yya ( 1 ) = -8.54721069
          yyb ( 1 ) = 4.70450195e+02
          yyy ( 1 ) = 2.05
        else
          yya ( 1 ) = a0 ( nt0 )
          yyb ( 1 ) = b0 ( nt0 )
          yyy ( 1 ) = x0 ( nt0 )
        endif
*
        yya ( 2 ) = a0 ( nt  )
        yya ( 3 ) = a0 ( nt1 )
        a       = xmap ( xx , yya , alogt )
        yyb ( 2 ) = b0 ( nt  )
        yyb ( 3 ) = b0 ( nt1 )
        b       = xmap ( xx , yyb , alogt )
        x         = -2.45
        yyy ( 2 ) = x0 ( nt  )
        yyy ( 3 ) = x0 ( nt1 )
        y         = xmap ( xx , yyy, alogt )
      endif
*
      expp = ( a - y * alognc + b * xnc ** x )
      IF( expp.lt.37 ) then
         da = z * 10. ** expp
      else
         da = 0.
      endif
      ifail = ifail + jfail
*
      end
******************************************************************************
      block data dalpha
      implicit none
*block data with Steve Cota's 3-body recombination coefficients
*
      integer maxz
      parameter ( maxz = 28 )
*
*      block data for function  da.
*
*     S. A. COTA, 2/1987
*
      real tz, zlog7, zlog2
      common/parms/ tz( 83), zlog7(28), zlog2(28)
      real a0,b0,x0
      common/dax/ a0( 83),b0( 83),x0( 83)
      real a1,b1,x1
      common/xcx/ a1( 83),b1( 83),x1( 83)
      real a2,b2,x2
      common/xnx/ a2( 21: 83),b2( 21: 83),x2( 21: 83)
      real ba0 ( 79 ) , bb0 ( 4 ) , ba1 ( 79 ), bb1 ( 4 )
      equivalence ( ba0 ( 1 ) , b0 ( 1 ) ) , ( bb0 ( 1 ) , b0 ( 80 ) )
      equivalence ( ba1 ( 1 ) , b1 ( 1 ) ) , ( bb1 ( 1 ) , b1 ( 80 ) )
      data zlog7/
     * 0.00000E+00, 2.10721E+00, 3.33985E+00, 4.21442E+00, 4.89279E+00,
     * 5.44706E+00, 5.91569E+00, 6.32163E+00, 6.67970E+00, 7.00000E+00,
     * 7.28975E+00, 7.55427E+00, 7.79760E+00, 8.02290E+00, 8.23264E+00,
     * 8.42884E+00, 8.61314E+00, 8.78691E+00, 8.95128E+00, 9.10721E+00,
     * 9.25554E+00, 9.39696E+00, 9.53209E+00, 9.66148E+00, 9.78558E+00,
     * 9.90481E+00,10.01954E+00,10.13010E+00/
      data zlog2/
     * 0.00000E+00, 6.02060E-01, 9.54243E-01, 1.20412E+00, 1.39794E+00,
     * 1.55630E+00, 1.69020E+00, 1.80618E+00, 1.90849E+00, 2.00000E+00,
     * 2.08279E+00, 2.15836E+00, 2.22789E+00, 2.29226E+00, 2.35218E+00,
     * 2.40824E+00, 2.46090E+00, 2.51055E+00, 2.55751E+00, 2.60206E+00,
     * 2.64444E+00, 2.68485E+00, 2.72346E+00, 2.76042E+00, 2.79588E+00,
     * 2.82995E+00, 2.86272E+00, 2.89431E+00/
      data tz /
     *0.     ,0.09691,0.17609,0.30103,0.39794,
     *0.47712,0.60206,0.69897,0.77815,0.90309,
     *1.00000,1.07918,1.20412,1.30103,1.39794,
     *1.47712,1.60206,1.69897,1.77815,1.90309,
     *2.00000,2.06070,2.09691,2.17609,2.20412,
     *2.24304,2.30103,2.35218,2.39794,2.47712,
     *2.51188,2.54407,2.60206,2.65321,2.69897,
     *2.75967,2.81291,2.86034,2.91645,2.95424,
     *3.00000,3.07918,3.11394,3.17609,3.20412,
     *3.25527,3.30103,3.36173,3.39794,3.46240,
     *3.51188,3.56820,3.60206,3.66276,3.72016,
     *3.76343,3.81291,3.86034,3.90309,3.95424,
     *4.02119,4.06070,4.11394,4.16137,4.20412,
     *4.25527,4.31175,4.36173,4.41497,4.46240,
     *4.51521,4.56526,4.61542,4.66605,4.71600,
     *4.76343,4.81624,4.86629,4.91645,4.96614,
     *5.02119,5.06726,5.11394/
      data a0 /
     * -4.31396484, -4.56640625, -4.74560547, -4.98535156, -5.15373850,
     * -5.28123093, -5.48215008, -5.63811255, -5.76573515, -5.96755028,
     * -6.12449837, -6.25304174, -6.45615673, -6.61384058, -6.77161551,
     * -6.90069818, -7.10470295, -7.26322412, -7.39289951, -7.59792519,
     * -7.75725508, -7.85722494, -7.91697407, -8.04758644, -8.09447479,
     * -8.15859795, -8.25424385, -8.33880615, -8.41452408, -8.54581165,
     * -8.60400581, -8.65751839, -8.75414848, -8.83946800, -8.91589737,
     * -9.01741695, -9.10663033, -9.18621922, -9.28059292, -9.34430218,
     * -9.42154408, -9.55562973, -9.61459446, -9.72023010, -9.76802444,
     * -9.85540199, -9.93374062,-10.03800774,-10.10044670,-10.21178055,
     *-10.29757786,-10.39561272,-10.45469666,-10.56102180,-10.66205502,
     *-10.73780537,-10.82557774,-10.91007328,-10.98659325,-11.07857418,
     *-11.19975281,-11.27170753,-11.36930943,-11.45675945,-11.53620148,
     *-11.63198853,-11.73875237,-11.83400822,-11.93677044,-12.02933311,
     *-12.13374519,-12.23410702,-12.33664989,-12.44163322,-12.54730415,
     *-12.64975739,-12.76682186,-12.88185978,-13.00052643,-13.12289810,
     *-13.26689529,-13.39390945,-30.00000000/
*  -13.53340816/
      data ba0 /        4.53776000e+05, 3.48304000e+05, 2.80224000E+05,
     * 1.98128000E+05, 1.51219797E+05, 1.21113266E+05, 8.52812109E+04,
     * 6.49598125E+04, 5.20075781E+04, 3.66190977E+04, 2.79060723E+04,
     * 2.23634102E+04, 1.57683135E+04, 1.20284307E+04, 9.17755273E+03,
     * 7.36044873E+03, 5.19871680E+03, 3.97240796E+03, 3.18934326E+03,
     * 2.25737622E+03, 1.72767114E+03, 1.46202722E+03, 1.32456628E+03,
     * 1.06499792E+03, 9.92735291E+02, 8.91604858E+02, 7.59411560E+02,
     * 6.59120056E+02, 5.80688965E+02, 4.66602264E+02, 4.27612854E+02,
     * 3.91531494E+02, 3.34516968E+02, 2.91021820E+02, 2.56853912E+02,
     * 2.17598007E+02, 1.88145462E+02, 1.65329865E+02, 1.41960342E+02,
     * 1.28181686E+02, 1.13336761E+02, 9.17785034E+01, 8.36242981E+01,
     * 7.08843536E+01, 6.58346100E+01, 5.75790634E+01, 5.11293755E+01,
     * 4.37563019E+01, 3.99226875E+01, 3.39562836E+01, 3.00413170E+01,
     * 2.61871891E+01, 2.41310368E+01, 2.08853607E+01, 1.82632275E+01,
     * 1.60007000E+01, 1.42617064E+01, 1.27951088E+01, 1.16221066E+01,
     * 1.03779335E+01, 8.97864914E+00, 8.25593281E+00, 7.39339924E+00,
     * 6.70784378E+00, 6.16084862E+00, 5.57818031E+00, 5.01341105E+00,
     * 4.55679178E+00, 4.13692093E+00, 3.80004382E+00, 3.46328306E+00,
     * 3.17340493E+00, 2.93525696E+00, 2.69083858E+00, 2.46588683E+00,
     * 2.26083040E+00, 2.04337358E+00, 1.89027369E+00, 1.69208312E+00/
      data bb0 /
     * 1.48992336E+00, 1.32466662E+00, 1.10697949E+00,  9.29813862E-01/
      data x0 /
     *2.12597656,2.08984375,2.06958008,2.05444336,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      ,2.05      ,2.05      ,
     *2.05      ,2.05      ,2.05      /
      data a1 /
     * 16.23337936, 16.27946854, 16.31696320, 16.37597656, 16.42210960,
     * 16.45996284, 16.51994896, 16.56644440, 16.60460854, 16.66510773,
     * 16.71198654, 16.75038719, 16.81106949, 16.85778809, 16.90416527,
     * 16.94209099, 17.00195694, 17.04838943, 17.08633804, 17.14627838,
     * 17.19270515, 17.22186279, 17.23933601, 17.27728271, 17.30161858,
     * 17.32085800, 17.34928894, 17.37349129, 17.39528084, 17.43282318,
     * 17.44827652, 17.46357536, 17.49082375, 17.51517677, 17.53697205,
     * 17.56587219, 17.59125519, 17.61410332, 17.64081383, 17.65900803,
     * 17.68086433, 17.71843529, 17.73512840, 17.76512146, 17.77873421,
     * 17.80340767, 17.82530022, 17.85470963, 17.87210464, 17.90334511,
     * 17.92751503, 17.95458603, 17.97117233, 18.00062943, 18.02842712,
     * 18.04934502, 18.07340050, 18.09639168, 18.11732864, 18.14218903,
     * 18.17465591, 18.19370079, 18.21962166, 18.24237251, 18.26305962,
     * 18.28767967, 18.31531525, 18.33900452, 18.36478043, 18.38741112,
     * 18.41271973, 18.43644333, 18.46075630, 18.48509216, 18.50897980,
     * 18.53143501, 18.55570030, 18.58008003, 18.60348320, 18.62536430,
     * 18.65199852, 18.67623520, 18.70072174/
      data ba1 /       1.09462866e+10, 9.32986675e+09, 6.15947008e+09,
     * 1.54486170E+09, 1.00812454E+09, 7.00559552E+08, 6.25999232E+08,
     * 3.50779968E+08, 3.11956288E+08, 3.74866016E+08, 2.47019424E+08,
     * 1.73169776E+08, 1.01753168E+08, 6.81861920E+07, 4.61764000E+07,
     * 3.31671360E+07, 2.03160540E+07, 1.40249480E+07, 1.02577860E+07,
     * 3.53822650E+06, 1.32563388E+06, 9.14284688E+05, 1.25230388E+06,
     * 3.17865156E+05, 4.76750244E+03, 4.81107031E+03, 4.88406152E+03,
     * 4.80611279E+03, 4.78843652E+03, 4.65988477E+03, 1.26723059E+03,
     * 1.20825342E+03, 8.66052612E+02, 7.76661316E+02, 7.05279358E+02,
     * 6.21722656E+02, 5.46207581E+02, 4.96247742E+02, 4.26340118E+02,
     * 3.96090424E+02, 3.48429657E+02, 2.37949142E+02, 2.14678406E+02,
     * 1.81019180E+02, 1.68923676E+02, 1.45979385E+02, 1.25311127E+02,
     * 1.05205528E+02, 9.39378357E+01, 7.75339966E+01, 6.68987427E+01,
     * 5.53580055E+01, 5.00100212E+01, 4.14198608E+01, 3.46289063E+01,
     * 3.00775223E+01, 2.60294399E+01, 2.26602840E+01, 2.02123032E+01,
     * 1.76353855E+01, 1.47198439E+01, 1.33078461E+01, 1.17181997E+01,
     * 1.04125805E+01, 9.45785904E+00, 8.42799950E+00, 7.62769842E+00,
     * 6.85484743E+00, 6.25903368E+00, 5.75135279E+00, 5.28468180E+00,
     * 4.87669659E+00, 4.57353973E+00, 4.30108690E+00, 4.05412245E+00,
     * 3.83283114E+00, 3.57902861E+00, 3.43705726E+00, 3.26563096E+00/
      data bb1/        3.07498097e+00, 2.96334076e+00, 2.92890000e+00,
     *                 2.89550042E+00/
      data x1/
     *-5.46,-5.51,-5.49,-5.30,-5.29,-5.28,-5.37,-5.33,-5.38,-5.55,
     *-5.55,-5.55,-5.55,-5.55,-5.55,-5.55,-5.55,-5.55,-5.55,-5.38,
     *-5.19,-5.14,-5.27,-4.93,-3.64,-3.68,-3.74,-3.78,-3.82,-3.88,
     *-3.40,-3.41,-3.32,-3.32,-3.32,-3.32,-3.31,-3.31,-3.29,-3.29,
     *-3.27,-3.16,-3.14,-3.11,-3.10,-3.07,-3.03,-2.99,-2.96,-2.91,
     *-2.87,-2.81,-2.78,-2.72,-2.66,-2.61,-2.56,-2.51,-2.47,-2.42,
     *-2.35,-2.31,-2.26,-2.21,-2.17,-2.12,-2.08,-2.03,-1.99,-1.95,
     *-1.91,-1.87,-1.84,-1.81,-1.78,-1.75,-1.71,-1.69,-1.66,-1.62,
     *-1.60,-1.60,-1.60/
      data a2 /
     * 20.30049515, 20.28500366, 20.25300407, 20.16626740, 20.15743256,
     * 20.11256981, 20.04818344, 19.99261856, 19.94472885, 19.86478043,
     * 19.83321571, 19.80185127, 19.74884224, 19.70136070, 19.65981102,
     * 19.60598755, 19.56017494, 19.52042389, 19.47429657, 19.44413757,
     * 19.40796280, 19.34819984, 19.32203293, 19.27634430, 19.25627136,
     * 19.22009087, 19.18853378, 19.14809799, 19.12456703, 19.08409119,
     * 19.05431557, 19.02083015, 19.00176430, 18.96817970, 18.93762589,
     * 18.91706085, 18.89299583, 18.87085915, 18.85210609, 18.83035851,
     * 18.80403900, 18.78901100, 18.77099228, 18.75540161, 18.74287033,
     * 18.72928810, 18.71601868, 18.70474434, 18.69515800, 18.68782425,
     * 18.68120766, 18.67630005, 18.67357445, 18.67129898, 18.67042351,
     * 18.67090988, 18.67313004, 18.67636490, 18.68120003, 18.68803024,
     * 18.69487381, 18.70458412, 18.71205139/
      data b2 /
     * 1.01078403E+00, 1.97956896E+00, 3.14605665E+00, 6.46874905E+00,
     * 3.16406364E+01, 3.74927673E+01, 4.75353088E+01, 5.27809143E+01,
     * 5.86515846E+01, 6.70408707E+01, 1.14904137E+02, 1.03133133E+02,
     * 1.26508728E+02, 1.03827606E+02, 8.79508896E+01, 7.18328934E+01,
     * 6.19807892E+01, 5.51255455E+01, 4.87156143E+01, 4.58579826E+01,
     * 4.19952011E+01, 4.08252220E+01, 3.78243637E+01, 3.34573860E+01,
     * 3.19036102E+01, 2.92026005E+01, 2.74482193E+01, 2.54643936E+01,
     * 2.46636391E+01, 2.33054180E+01, 2.23069897E+01, 2.12891216E+01,
     * 2.06667900E+01, 1.96430798E+01, 1.87381802E+01, 1.76523514E+01,
     * 1.69235287E+01, 1.62647285E+01, 1.56806908E+01, 1.50346069E+01,
     * 1.42240467E+01, 1.37954988E+01, 1.31949224E+01, 1.27211905E+01,
     * 1.22885675E+01, 1.17868662E+01, 1.12577572E+01, 1.08565578E+01,
     * 1.04121590E+01, 1.00410652E+01, 9.64534473E+00, 9.29232121E+00,
     * 8.92519569E+00, 8.60898972E+00, 8.31234550E+00, 8.04089737E+00,
     * 7.74343491E+00, 7.48133039E+00, 7.21957016E+00, 6.94726801E+00,
     * 6.71931219E+00, 6.45107985E+00, 6.28593779E+00/
      data x2/
     *-0.43,-0.75,-0.93,-1.20,-1.78,-1.85,-1.95,-2.00,-2.05,-2.12,
     *-2.34,-2.31,-2.42,-2.36,-2.31,-2.25,-2.21,-2.18,-2.15,-2.14,
     *-2.12,-2.14,-2.12,-2.09,-2.08,-2.06,-2.05,-2.04,-2.04,-2.04,
     *-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,
     *-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,
     *-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,-2.04,
     *-2.04,-2.04,-2.04/
      END
********************************************************************
      subroutine dcharg
      implicit none
*compute grains charge
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real dqabs, dqscat
      common/dqs/ dqabs(ncell,ndust) , dqscat(ncell,ndust)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real yn
      common/yn/ yn(ncell,ndust)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      real dustp,eev, sab,sse,darea, dsize
      integer ndpts
      common/dust/ dustp(4,ndust),eev(limcrs,ndust),
     z sab(limcrs,ndust),sse(limcrs,ndust),ndpts(ndust),darea(ndust),
     z dsize(ndust)
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      integer ipdpot
      common/ipdpot/ ipdpot(ndust)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgDustBug
*flag set with trace grains command
      common/dstbug/ lgDustBug
      real DustPhotoE
*difference between photon energy and work function for grains
      common/dnu/ DustPhotoE(ncell,ndust)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      character chDstLab*10
*     labels for types of dust grains
      common/dstlab/ chDstLab(ndust)
      real DustWorkFcn
*work function (Ioniz pot) of various grain species
      common/dwork/ DustWorkFcn(ndust)
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      integer idwork
      common/idwork/ idwork(ndust)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real slope(ndust) , oldpot(ndust) , oldpht(ndust),oldrec(ndust)
      save slope , oldpot , oldpht , oldrec
      real toler , dmaxx
      parameter (toler=0.005 , dmaxx=0.05)
      integer nd , luplim , ipoint , lopbig
      logical lgBigError
      real thres,grngam,drecom,phtion,recom,rerror,dnew,error,
     1 change , xxx
*
      if( lgTrace.and.lgDustBug) then
        write(qq,'(''    dcharg called lgSearch'',l2)') lgSearch
      endif
*
      do nd=1,ndust
      if( lgDustOn1(nd) ) then
        if( lgSearch ) then
          if( lgTrace.and.lgDustBug)
     1    write(qq,'(''    dchar search '',a10)') chDstLab(nd)
          luplim = 100
          dstpot(nd) = 0.
*         DustWorkFcn is neutral surface work function in ryd
*         DSTPOT is floating grain pot in Ryd
          thres = max( DustWorkFcn(nd),DustWorkFcn(nd)+dstpot(nd) )
*         idwork is the actualy pointer to threshold generated
*         by calling ipContSafe in setup - it could be a few cells
*         to either side to the correct cell if several grains
*         share the same ip, making max necessary below
          ipdpot(nd) = max( idwork(nd) , ipoint( thres ) )
          oldpot(nd) = dstpot(nd)
          oldpht(nd) = grngam(nd)
*         if(nd.eq.1.and.dstpot(1).eq.0.)write(QQ,'('' GRNGAM='',
*    1    1p,e10.2)') oldpht(1)
          oldrec(nd) = drecom(nd)
          dstpot(nd) = dstpot(nd) + 0.05
        else
          luplim = 10
        endif
*
*       find dust charge; do sum over photon number
        lopbig = 0
        lgBigError = .true.
*     >>chng 97 feb 28, from label to do while loop
        do while ( lopbig.le.luplim .and. lgBigError )
          lopbig = lopbig + 1
          thres = max( DustWorkFcn(nd),DustWorkFcn(nd)+dstpot(nd) )
          ipdpot(nd) = ipoint( thres )
          phtion = grngam( nd )
          recom = drecom( nd )
          error = phtion - recom
*     >>chng 97 feb 28, crashed when both phtion and recom zero - which
*happens when no ionizing radiation
          rerror = abs( error / ( 0.5*max(1e-35,phtion+recom) ) )
          if( rerror.gt.toler ) then
            if( dstpot(nd).ne.oldpot(nd) ) then
*             only re-estimate slope if new continuum
*     >>chng 96 apr 26, as per Peter van Hoof comment that div by zero can occur
              xxx =  (phtion-oldpht(nd)) - (recom-oldrec(nd))
              if(xxx.ne.0.) slope(nd) = xxx/(dstpot(nd)-oldpot(nd))
            endif
            oldpot(nd) = dstpot(nd)
            oldpht(nd) = phtion
            oldrec(nd) = recom
*           here is reason for above xxx, do not want zero slope:
*           really the change should be here not above??
            dnew = -error / slope(nd)
            change = abs( dnew )
            change = min( change , dmaxx*thres )
            change = sign( change , dnew )
*           write(QQ,'(i4,'' chan pot from'',1p,e10.2,'' to'',e10.2)')
*    1      nd, dstpot(nd) , dstpot(nd) + change
            dstpot(nd) = dstpot(nd) + change
            lgBigError = .true.
          else
            oldpot(nd) = dstpot(nd)
            oldpht(nd) = phtion
            oldrec(nd) = recom
            lgBigError = .false.
          endif
          if( lgTrace.and.lgDustBug) then
            write(qq,'(''    dcharg loop '',i3,a10,
     1      '' pot'',1p,e10.2,'' error'',e10.2,'' Pho rec Rate'',2e9.1)'
     1      )lopbig, chDstLab(nd),dstpot(nd),rerror,phtion,recom
          end if
        end do
*
        dstq(nd) = (dstpot(nd)*evryd) / 0.0048
        if(lgTrace.and.lgDustBug) then
          write(qq,'(5X,''Grain potential:'',a10,1P,
     1    E9.2,''Ryd, gamma:'',E9.2,'' recom:'',E9.2,
     2    '' Threshold:'',E9.2,''Ryd'')')
     3    chDstLab(nd),dstpot(nd),phtion ,recom ,
     1    DustWorkFcn(nd)+dstpot(nd)
        endif
        endif
      end do
*
      if( lgTrace .and. (.not.lgDustBug) ) then
        write(qq,'(5X,''Grain potentials:'',1P,10E10.2)')
     1  (dstpot(nd),nd=1,ndust)
      endif
*
      end
**************************************************************************
      subroutine dcolid( dcheat , dccool , nd )
      implicit none
*compute grains collisional heating cooling
      real dcheat , dccool
      integer nd
*
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
*     include "dareff.com"
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real tedust
      common/tedust/ tedust(ndust)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      integer limelm
      parameter (limelm=30)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real dustp,eev, sab,sse,darea, dsize
      integer ndpts
      common/dust/ dustp(4,ndust),eev(limcrs,ndust),
     z sab(limcrs,ndust),sse(limcrs,ndust),ndpts(ndust),darea(ndust),
     z dsize(ndust)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
*     local variables
      integer ion
      real vnz(4)
      integer nelem , i
      real heat , cool , psi , z , xi , eta , sexp
*
*     this subroutine evaluates the gas heating-cooling rate
*     (erg cm^-3 s^-1) due to grain gas collisions.
*     the net effect can be positive or negative,
*     depending on whether the grains or gas are hotter
*
*     this array is set of charges striking the grain surface
*     vnz(1) are neutrals, vnz(2) are single ions, etc
*     each population is weighted by the PROJECTED velocity
*
      do ion=1,4
        vnz(ion) = 0.
        do nelem=1,limelm
          vnz(ion) = vnz(ion) + xIonFracs(nelem,ion)*doppler(nelem)
        end do
      end do
*
*     following loop sums up collisions between these nuclei
*     electrons are done later
*     HEAT will be rate collisions heat the grain
*     COOL will be rate collisions cool the gas
      heat = 0.
      cool = 0.
      do i=1,4
         z = i - 1.
         psi = z * dstpot(nd)*evryd / (8.617e-5*te)
         if( psi.le.0. ) then
            eta = 1. - psi
            xi = 1. - psi/2.
         else
            eta = sexp(psi)
            xi = (1.+psi/2.) * eta
         endif
*        factor of two makes VNZ(I) arrival rate, not projected velocity
         heat = heat + vnz(i)*2.* Boltzmann*
     1   ( 2.*te*xi - eta*(
     3   z *dstpot(nd)*evryd*1.6022e-12 -
     4   z*z *en1ryd + 2.*tedust(nd) ) )
*
*        rate kinetic energy lost from gas - gas cooling
         cool = cool + vnz(i)*2.* Boltzmann*
     1    ( 2.*te*xi - eta*2.*tedust(nd) )
      end do
*
*     heating due to electrons
      z = - 1.
      psi = z * dstpot(nd)*evryd / (8.617e-5*te)
      if( psi.le.0. ) then
         eta = 1. - psi
         xi = 1. - psi/2.
      else
         eta = sexp(psi)
         xi = (1.+psi/2.) * eta
      endif
*     electron arrival rate
      vnz(1) = sqrte * 6.2124e5 * eden
      heat = heat + vnz(1)* 2.*1.38062e-16*te*xi
*     heat = heat + vnz(1)* ( 2.*1.38062e-16*te*xi -
*    1eta*z *dstpot(nd)*evryd*1.6022e-12 )
*
      cool = cool + vnz(1)* 2.*1.38062e-16*te*xi
*
      dcheat = heat * ( hden*darea(nd)*dstAbund(nd)/4. )
*     cooling is per projected area
      dccool = cool * ( hden*darea(nd)*dstAbund(nd)/4. )
*
      end
********************************************************************
      subroutine ddrift
      implicit none
*compute grains drift velocity
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      real SqrtEden
*square root of electron density, set in tfidle
      common/sqrne/ SqrtEden
      real dustp,eev, sab,sse,darea, dsize
      integer ndpts
      common/dust/ dustp(4,ndust),eev(limcrs,ndust),
     z sab(limcrs,ndust),sse(limcrs,ndust),ndpts(ndust),darea(ndust),
     z dsize(ndust)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real dqabs, dqscat
      common/dqs/ dqabs(ncell,ndust) , dqscat(ncell,ndust)
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      logical lgNegGrnDrg
*flag set if negative grin drag force encountered
      common/negdrg/ lgNegGrnDrg
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgDustBug
*flag set with trace grains command
      common/dstbug/ lgDustBug
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nd , i , loop
      real dmomen , fac, psi,rdust,alam,phi2lm,vdold,si,g0,g2,volmom,
     1 corr , fdrag
*
      do nd=1,ndust
        if( lgDustOn1(nd) ) then
*         find momentum absorbed by grain
          dmomen = 0.
          do i=1,nflux
            dmomen = dmomen + (flux(i)+outcon(i)+outlin(i))* anu(i) *
     1      (dqabs(i,nd)+dqscat(i,nd))
          end do
          dmomen = dmomen * en1ryd
*         now find force on grain, and drift velocity
*         factor is 2*k
          fac = 2.7612e-16 * te
*         now PSI defined by Draine and Salpeter 79 Ap.J. 231, 77 (1979)
          psi = (dstpot(nd)*evryd) * 1.1606e4 / te
          if( psi.gt.0. ) then
            rdust = 1e-6
            alam = log( 20.702 / rdust / psi * sqrte / SqrtEden )
          else
            alam = 0.
          endif
          phi2lm = psi**2 * alam
          corr = 2.
          loop = 0.
          do while( loop.lt.10 .and. abs(corr-1.).gt.0.03 )
*  7      if( loop.lt.10 ) then
*     >>chng 19 oct 95 to do while
            loop = loop + 1
            vdold = DustDftVel(nd)
*           interactions with protons
            si = DustDftVel(nd) / sqrte * 7.755e-5
            g0 = 1.5045 * si * sqrt(1.+0.4418*si*si)
            g2 = si / (1.329 + si**3 )
*           drag force due to protons, both linear and square in velocity
*           equation 4 from D+S Ap.J. 231, p77.
            fdrag = fac * hii * (g0 + phi2lm*g2)
*           drag force due to interactions with electrons
            si = DustDftVel(nd) / sqrte * 1.816e-6
            g0 = 1.5045 * si * sqrt(1.+0.4418*si*si)
            g2 = si / (1.329 + si**3 )
            fdrag = fdrag + fac * eden * (g0 + phi2lm*g2)
*           drag force due to collisions with hydrogen and helium atoms
            si = DustDftVel(nd) / sqrte * 7.755e-5
            g0 = 1.5045 * si * sqrt(1.+0.4418*si*si)
            fdrag = fdrag + fac * (hi + 1.1*hei) * g0
*           drag force due to interactions with helium ions
            si = DustDftVel(nd) / sqrte * 1.551e-4
            g0 = 1.5045 * si * sqrt(1.+0.4418*si*si)
            g2 = si / (1.329 + si**3 )
            fdrag = fdrag + fac * heii*(g0+phi2lm*g2)
*           this term does not work
*    2      HEIII*(G0+4.*PSI**2*(ALAM-0.693)*G2) )
*           this is total momentum absorbed by dust per unit vol
            volmom = dmomen / 2.998e10
            if( fdrag.gt.0. ) then
              corr = sqrt( volmom / fdrag )
              DustDftVel(nd) = vdold * corr
            else
              corr = 1.
              lgNegGrnDrg = .true.
            endif
            if(lgTrace.and.lgDustBug ) write(qq,'(5X,I2,'' new drift '',
     1      ''velocity:'',1P,E10.2,'' momentum absorbed:'',E10.2)')
     2      loop,DustDftVel(nd),volmom
          end do
        endif
      end do
*
      end
******************************************************************************
      subroutine descap( chCard )
      implicit none
*user queries escape probability routines, which return values
      character chCard*80
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL
      integer i , ierror
      real tau,fread,escinc,esccom,esa0k2
*
*     this routine is enterd with the command escape probability, and
*     drives the escape probability routine to compare answers
      write(qq,'('' Enter the log of the one-sided optical depth;'',
     1'' null line to stop.'')')
*
*     >>chng 96 july 7, got rid of statements, replaced with do while
*999  continue
      ierror = 0
      do while( ierror.eq.0 )
        read(5,'(A80)',iostat=ierror) chCard
        i = 1
        tau = fread( chCard , i , 76 , lgEOL )
        if( ierror.ne.0 .or. lgEOL ) then
           write(qq,'('' Esc prob driver exits, enter next line.'')')
           return
        endif
        tau = 10. ** tau
*
        write(qq,'('' ESCINC='',1P,E11.3)') escinc( tau , 1e-4 )
        write(qq,'('' ESCCOM='',1P,E11.3)') esccom( tau , 1e-4 )
        write(qq,'('' ESA0K2='',1P,E11.3)') esa0k2( tau )
*
      end do
*
      end
******************************************************************************
      subroutine dgaunt( chCard )
      implicit none
*drive gaunt factor routines by letting user query values
      character chCard*80
*
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      logical lgEOL
      integer i , if1 , ierror
      real ener(1) , gfac(1) , fread
*
*     this routine is entered with the command DRIVE GAUNT, and
*     drives the gaunt factor routine to check range
*
      write(qq,'('' Enter the temperature (log if <=10) and energy '',
     1''(Ryd). Null line to stop.'')')
*     >>chng 96 july 7, got rid of statement labels replacing with do while
*
      ierror = 0
      do while( ierror.eq.0 )
        read(5,'(A80)',iostat=ierror) chCard
        i = 1
        te = fread( chCard , i , 76 , lgEOL )
*       the line may be trash but ierror will pick it up
        if( lgEOL .or. ierror.ne.0 ) then
          write(qq,'('' Gaunt driver exits, enter next line.'')')
          return
        endif
*       numbers less than or equal to 10 are the log of the temperature
        if( te.le.10. ) then
          alogte  = te
        else
          alogte = log10( te )
        endif
*
        ener(1) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL.or.ener(1).eq.0. ) then
          write(qq,'('' Sorry, but there should be a second nonzero '',
     1    ''number, the energy.'')')
        endif
*
        if( ener(1).gt.0. ) then
          ener(1) = log10( ener(1) )
        endif
*
        call gffsub(0.,ener,gfac,1,1,1,if1)
        write(qq,'('' Gaunt factor is'',1P,E11.3)') gfac
*
*       if1=1 if GAMS is out of range; 2 if U is out of range.
        if( if1.ne.0 ) write(qq,'('' Failure mode is'',I2)')if1
*
      end do
*
      end
******************************************************************************
      subroutine DielSupres
      implicit none
*derive scale factors for suppression of Burgess dielectronic recombination
      integer limelm
      parameter (limelm=30)
      logical lgSupDie
*     logical flag for suppression of dielectronic recombination
*     1 is burgess, 2 is nussbaumer and storey
      common/supdie/ lgSupDie(2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real supprs
*     suppresssion factors for dielectronic recombination
*     1 is burgess and 2 is storey
      common/supprs/ supprs(limelm,2)
      integer ioreco
      common/ioreco/ ioreco
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
*
*     local variables
      real effden
      integer i
*
*     dielectronic burgess recombination suppresion
*     default is this to be true
      if( lgSupDie(1) ) then
        do i=1,limelm
*         following is effective density for scaling from Davidson's plot
*         first do temperature scaling, term in () is sqrt(te/15,000)
          effden =  eden / (sqrte / 122.47)
*         this is rough charge dependence, z^7 from Davidson
          effden = effden / ((float(i)/3.)**7)
          supprs(i,1) = min(1.,  (1.-0.092*log10(effden) )  )
          supprs(i,1) = max( 0.08, supprs(i,1) )
        end do
      else
        do i=1,limelm
          supprs(i,1) = 1.
        end do
      endif
*
*     nussbaumer and storey recombination
*     default is this to be false
      if( lgSupDie(2) ) then
        do i=1,limelm
*         assume same factors as above
          supprs(i,2) = supprs(i,1)
        end do
      else
        do i=1,limelm
          supprs(i,2) = 1.
        end do
      endif
*
      if( ioreco.gt.0 ) then
        write(ioreco,'('' DielSupres finds following dielectronic '',
     1 ''recom suppression factors.'')')
        write(ioreco,'('' Z   fac '')')
        do i=1,limelm
          write(ioreco,'(i3,1p,2e10.3)') i ,supprs(i,1),supprs(i,2)
        end do
      endif
*
      end
******************************************************************************
      subroutine diffem
      implicit none
*fill in DiffCont and ThrowOut arrays, with diffuse emission for this zone
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
      real pi4
      parameter (pi4=12.566371)
      real SpeedLight
*from Physics Today Aug '96, BG 10
      parameter (SpeedLight=2.99792458E10 )
      real pi
      parameter ( pi=3.141592654 )
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real fr1ryd
*     frequency of 1 rydberg
*     FR1RYD is frequency for 912
      parameter (fr1ryd=3.28805E15)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      real ExpZone
*exp(-tau) for the current zone only
      common/facexp/ ExpZone(ncell)
      real EdenFFSum
*sum of heavy element free electrons, set in esum
      common/ffsum/ EdenFFSum
      integer maxcor
      common/maxcor/ maxcor
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgTrDiff
*flag set with trace difuse fields command
      common/trdiff/ lgTrDiff
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real tedust
      common/tedust/ tedust(ndust)
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
      integer iphmin
      common/iphmin/ iphmin
      real Hy2nu, he12nu, he22nu
*Hy2nu is hydrogen two photon, others He1 and He2
      common/em2nu/ Hy2nu(ncell) , he12nu(ncell), he22nu(ncell)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      double precision hlbolt , hcbolt
*     hlbolt(low,up) line boltzmann factors for hydrogen atom
*     hcbolt(n) excit to continuum
      common/hlvcol/ hlbolt(lmhlvl-1,lmhlvl+1) , hcbolt(lmhlvl+1)
      double precision he1bol , he1cbt
      common/he1blt/ he1bol(nhe1lvl-1,nhe1lvl+1) , he1cbt(nhe1lvl+1)
      double precision he2bol , he2cbt
      common/he2blt/ he2bol(nhe2lvl-1,nhe2lvl+1) , he2cbt(nhe2lvl+1)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real widflx
      common/widflx/ widflx(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real DiffCont
*diffus is local diffuse continuum, for current zone
      common/diffus/ DiffCont(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real Diff2Pht
*total local two photon emission
      common/dif2nu/ Diff2Pht(ncell)
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
*     HRecRad is sum of radiative rec to all excited states
*     hrectot is hcaseb plus effective rec to ground
*     HRecEffec is total effec eval in hlevel, should be
*     roughly equal to hrectot
*     HRecNet is net rec coef, with 3-body rec less coll ioniz
*     HRecCol is thre-body recombination alone
*     HRecInd is induced recombination
      common/hcaseb/ HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      integer iphmra
      common/iphmra/ iphmra
      integer ioptri
      common/ioptri/ ioptri
      integer iphmop
      common/iphmop/ iphmop
      integer iphop
      common/iphop/ iphop(lmhlvl)
      integer iophe1
      common/iophe1/ iophe1(9)
      integer iophe2
      common/iophe2/ iophe2(9)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
      real HLevNIonRyd
*ionizatoin potention of hydrogenic level n
*set in makehydro
      common/HNIonRyd/ HLevNIonRyd(lmhlvl+1)
*ionization potential of level n, in Rydbergs
      real He1IonRyd
      common/He1NIonRyd/ He1IonRyd(nhe1lvl+1)
      real He2IonRyd
*ionization potential of level n in Ryd for HeII ion
      common/He2NIonRyd/ He2IonRyd(nhe2lvl+1)
      real CaseBCheck
*largest difference between actual rec sum and real case B
      common/difher/ CaseBCheck
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real DiffLumin
      common/DiffLumn/ DiffLumin
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      real ThrowOut(ncell)
*this is the spectrum of continuum thrown into the outward beam
      common/ThroOut/ ThrowOut
      real H12phtOTS , He12phtOTS , He22phtOTS
      integer ipH12pht , ipHe12pht , ipHe22pht
      common/hhe2phtots/ H12phtOTS , He12phtOTS , He22phtOTS,
     1 ipH12pht , ipHe12pht , ipHe22pht
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
*save total grain emission from this zone, per unit vol,
*for add outward in metfic
      real GrainEmission
      common/GrainEmis/ GrainEmission(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nd , n , i
      real bfac , f , bolt,factor,facff,fache2,fach,sum2ex,sum2gr,
     1 sum1ex,sum1gr,sumtri,sumhex,arg,photon,bolt2,fac,gion,gn,
     1 gamma,sumh1,dwid,cor , sexp
*
*     this routine evaluates the local diffuse fields
*     it fills in the vector DiffCont
*
      do i=1,ncell
        ThrowOut(i) = 0.
        DiffCont(i) = 0.
        Diff2Pht(i) = 0.
      end do
*
*     hydrogen Lyman continuum (free-bound) emission
      fac = eden * hii
      gion = 1.
      gn = 2.
      gamma = 2.0618684e11 * gn/gion / te / sqrte
      sumh1 = 0.
*     DWID is used to adjust where within WIDFLX exp is evaluated
      dwid = 0.2
      cor = hcbolt(1)
*     following is boltz fac for second cell, check not zero
      bolt2 = 1.57890e5*widflx(ipHn(1)+1) /te
      if( cor.gt.0. ) then
*       MAXCOR is highest energy with non-zero ContBoltz
        do i=ipHn(1),maxcor
*         flux is in photons per sec per ryd
*         ContBoltz is ratio of Boltz fac for each freq
          photon = gamma * ContBoltz(i)/cor *
     1    widflx(i)* OpacStack(i-ipHn(1)+iphop(1)) *anu2(i)
          sumh1 = sumh1 + photon
          DiffCont(i) = DiffCont(i) + photon * fac
          ThrowOut(i) = ThrowOut(i) + photon * fac*hrec(1,3)
        end do
*     following if gas not too cold
      else if( bolt2.lt.3. ) then
        do i=ipHn(1),maxcor
          arg = max(0.,1.57890e5*( anu(i)-1.+widflx(i)*dwid ) /te )
*         flux is in photons per sec per ryd
          photon = gamma * sexp( arg ) * widflx(i)*
     1    OpacStack(i-ipHn(1)+iphop(1))*anu2(i)
          sumh1 = sumh1 + photon
          DiffCont(i) = DiffCont(i) + photon * fac
          ThrowOut(i) = ThrowOut(i) + photon * fac*hrec(1,3)
        end do
      endif
*
*     ionized hydrogen free-bound recombination continua
      fac = eden * hii
      sumhex = 0.
      gion = 1.
      do n=2,nhlvl
*       MAX is to get 2s+p right
        gn = max(8., hstat(n) )
        gamma = 2.0618684e11 * gn/gion / te / sqrte
        cor = hcbolt(n)
        bolt2 = 1.57890e5*widflx(ipHn(n)+1)/te
        if( ContBoltz(ipHn(n)).gt.0. ) then
          do i=ipHn(n),ipHn(1)
*           flux is in photons per sec per ryd
*           ContBoltz is ratio of Boltz fac for each freq
            photon = gamma * ContBoltz(i)/cor *
     1      widflx(i)* OpacStack(i-ipHn(n)+iphop(n)) *anu2(i)
            sumhex = sumhex + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*hrec(n,3)
          end do
        else if( bolt2.lt.3. ) then
          do i=ipHn(n),ipHn(1)
            arg = max(0.,1.57890e5*( anu(i)-HLevNIonRyd(n)+
     1      widflx(i)*dwid ) /te )
*           flux is in photons per sec per ryd
            photon = gamma * sexp( arg ) *
     1      widflx(i)* OpacStack(i-ipHn(n)+iphop(n))*anu2(i)
            sumhex = sumhex + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*hrec(n,3)
          end do
        endif
      end do
*
*     following is check on self-consistency
      CaseBCheck = max( CaseBCheck , sumhex/HRecRad )
*
*     neutral helium triplets hei
      fac = eden * heii
      sumtri = 0.
      if( fac.gt.0. ) then
        gion = 2.
        gn = 3.
        gamma = 2.0618684e11 * gn/gion / te / sqrte
        bolt2 = 1.57890e5*widflx(nhei3) /te
        if( ContBoltz(nhei3).gt.0. ) then
          do i=nhei3,nhe1(1)
            photon = gamma * ContBoltz(i)/ContBoltz(nhei3) *
     1      widflx(i)* OpacStack(i-nhei3+ioptri)* anu2(i)
            sumtri = sumtri + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac
          end do
        else if( bolt2.lt.4. ) then
          do i=nhei3,nhe1(1)
            arg = max(0.,1.57890e5*( anu(i)-anu(nhei3) ) /te )
            photon = gamma * sexp( arg ) *
     1      widflx(i)*OpacStack(i-nhei3+ioptri)* anu2(i)
            sumtri = sumtri + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac
          end do
        endif
      endif
*
*     singlet neutral helium free-bound recombination continua
*
*     ground state from Milne relation
      fac = eden * heii
      sum1gr = 0.
      if( fac.gt.0. ) then
        gion = 2.
        gn = 1.
        gamma = 2.0618684e11 * gn/gion / te / sqrte
        cor = he1cbt(1)
        if( cor.gt.0. ) then
          do i=nhe1(1),maxcor
*           flux is in photons per sec per ryd
*           ContBoltz is ratio of Boltz fac for each freq
            photon = gamma * ContBoltz(i)/cor *
     1      widflx(i)* OpacStack(i-nhe1(1)+iophe1(1))*anu2(i)
            sum1gr = sum1gr + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*he1rec(1,3)
          end do
        else
          do i=nhe1(1),maxcor
            arg = max(0.,1.57890e5*( anu(i)-He1IonRyd(1) ) /te )
*           flux is in photons per sec per ryd
            photon = gamma * sexp( arg ) * widflx(i)*
     1      OpacStack(i-nhe1(1)+iophe1(1))*anu2(i)
            sum1gr = sum1gr + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*he1rec(1,3)
          end do
        endif
      endif
*
      sum1ex = 0.
      fac = eden * heii
      if( fac.gt.0. ) then
        gion = 2.
        do n=2,nhe1lvl
          bolt2 = 1.57890e5*widflx(nhe1(n)) /te
*         this is trick to do 2p, 2s correctly
          gn = max(4., he1stat(n) )
          gamma = 2.0618684e11 * gn/gion / te / sqrte
*         Milne relation for excited states
          if( ContBoltz(nhe1(n)).gt.0. ) then
            do i=nhe1(n),min(nhe1(1),nflux)
              photon = gamma * ContBoltz(i)/ ContBoltz(nhe1(n))*
     1        widflx(i)*OpacStack(i-nhe1(n)+iophe1(n))* anu2(i)
              sum1ex = sum1ex + photon
              DiffCont(i) = DiffCont(i) + photon * fac
              ThrowOut(i) = ThrowOut(i) + photon * fac*he1rec(n,3)
            end do
          else if( bolt2.lt.3. ) then
            do i=nhe1(n),min(nhe1(1),nflux)
              arg = max(0.,1.57890e5*(anu(i)-He1IonRyd(n)) /te )
              photon = gamma * sexp( arg ) *
     1        widflx(i)*OpacStack(i-nhe1(n)+iophe1(n))*anu2(i)
              sum1ex = sum1ex + photon
              DiffCont(i) = DiffCont(i) + photon * fac
              ThrowOut(i) = ThrowOut(i) + photon * fac*he1rec(n,3)
            end do
          endif
        end do
      endif
*
*     ionized He++=>He+ Helium free-bound recombination continua
*     continuum emission from Milne relation
      fac = eden * heiii
      sum2gr = 0.
      sum2ex = 0.
      if( fac.gt.0. ) then
        gion = 1.
        gn = 2.
        gamma = 2.0618684e11 * gn/gion / te / sqrte
        cor = he2cbt(1)
        if( cor .gt.0. ) then
          do i=nhe2(1),maxcor
*           flux is in photons per sec per ryd
*           ContBoltz is ratio of Boltz fac for each freq
            photon = gamma * ContBoltz(i)/cor *
     1      widflx(i)* OpacStack(i-nhe2(1)+iophe2(1))*anu2(i)
            sum2gr = sum2gr + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*he2rec(1,3)
          end do
        else
          do i=nhe2(1),maxcor
            arg = max(0.,1.57890e5*( anu(i)-4. ) /te )
*           flux is in photons per sec per ryd
            photon = gamma * sexp( arg ) * widflx(i)*
     1      OpacStack(i-nhe2(1)+iophe2(1))*anu2(i)
            sum2gr = sum2gr + photon
            DiffCont(i) = DiffCont(i) + photon * fac
            ThrowOut(i) = ThrowOut(i) + photon * fac*he2rec(1,3)
          end do
        endif
*
        do n=2,nhe2lvl-1
*         this is trick to do 2p, 2s correctly
          gn = max( 8., he2stat(n) )
          gamma = 2.0618684e11 * gn/gion / te / sqrte
          if( ContBoltz(nhe2(n)).gt.0. ) then
            do i=nhe2(n),min(nhe2(1),maxcor)
              photon = gamma *ContBoltz(i)/ContBoltz(nhe2(n))*
     1        widflx(i)* OpacStack(i-nhe2(n)+iophe2(n))*anu2(i)
              sum2ex = sum2ex + photon
              DiffCont(i) = DiffCont(i) + photon * fac
              ThrowOut(i) = ThrowOut(i) + photon * fac*he2rec(n,3)
            end do
          else
            do i=nhe2(n),min(nhe2(1),maxcor)
              arg = max(0.,1.57890e5*( anu(i)-He2IonRyd(n) ) /te )
              photon = gamma * sexp( arg ) * widflx(i)*
     1        OpacStack(i-nhe2(n)+iophe2(n))*anu2(i)
              sum2ex = sum2ex + photon
              DiffCont(i) = DiffCont(i) + photon * fac
              ThrowOut(i) = ThrowOut(i) + photon * fac*he2rec(n,3)
            end do
          endif
        end do
      endif
*
*     trace diffuse triggers this print
      if( lgTrace.and.lgTrDiff ) then
        write(qq,'('' DIFFEM: Hgrd;'',1P,E10.2,'' Ex;'',E9.2,'' He3;'',
     1  E9.2,'' He1g;'',E9.2,'' Ex;'',E9.2,'' He2g;'',E9.2,'' Ex;'',
     2  E9.2)')
     3  sumh1 , sumhex , sumtri , sum1gr , sum1ex, sum2gr , sum2ex
      endif
*
*     hydrogen two photon emission
*     in all following the factor of two is because a single
*     decay produces two photons
      fac =  2. * hn2s * hii
      H12phtOTS = 0.
*     f = 0.
      do i=1,iphl(2,1)
*       >>chng 97 july 17, bring factors together into fach
        fach = Hy2nu(i)*fac
        DiffCont(i) = DiffCont(i) + fach
        Diff2Pht(i) = fach
*       >>chng 96 jan 26 from above to below
*       ThrowOut(i) = ThrowOut(i) + Hy2nu(i)*fac*ExpZone(i)
        ThrowOut(i) = ThrowOut(i) + fach *ExpmTau(i)
*       f = f + fach*ExpmTau(i)
*       >>chng 96 jan 26 from above to below
*       H12phtOTS = H12phtOTS + Hy2nu(i)*fac*(1.-ExpZone(i))
        H12phtOTS = H12phtOTS + fach *(1.-ExpmTau(i))
      end do
*666  write(66,'(1p,3e10.2)') H12phtOTS, f,ExpmTau(iphl(2,1))
*
*     HeI two photon emission
      fac =  2. * he12s * heii
      do i=1,ipHn(1)
        DiffCont(i) = DiffCont(i) + he12nu(i)*fac
        Diff2Pht(i) = Diff2Pht(i) + he12nu(i)*fac
*       >>chng 96 jan 26 from ExpZone to below
        ThrowOut(i) = ThrowOut(i) + he12nu(i)*fac*ExpmTau(i)
      end do
      He12phtOTS = 0.
      do i=ipHn(1)+1,iphe1l(2,1)
        DiffCont(i) = DiffCont(i) + he12nu(i)*fac
        Diff2Pht(i) = Diff2Pht(i) + he12nu(i)*fac
*       ThrowOut(i) = ThrowOut(i) + he12nu(i)*fac*ExpZone(i)
*       >>chng 96 jan 26 from above to below
        ThrowOut(i) = ThrowOut(i) + he12nu(i)*fac*ExpmTau(i)
*       He12phtOTS = He12phtOTS + he12nu(i)*fac*(1.-ExpZone(i))
*       >>chng 96 jan 26 from above to below
        He12phtOTS = He12phtOTS + he12nu(i)*fac*(1.-ExpmTau(i))
      end do
*
*     HeII two photon emission
      fac =  2. * he22s * heiii
      do i=1,ipHn(1)
        DiffCont(i) = DiffCont(i) + he22nu(i)*fac
        Diff2Pht(i) = Diff2Pht(i) + he22nu(i)*fac
*       >>chng 96 jan 26 from ExpmTau to below
        ThrowOut(i) = ThrowOut(i) + he22nu(i)*fac*ExpmTau(i)
      end do
      He22phtOTS = 0.
      do i=ipHn(1)+1,iphe2l(2,1)
        DiffCont(i) = DiffCont(i) + he22nu(i)*fac
        Diff2Pht(i) = Diff2Pht(i) + he22nu(i)*fac
*       >>chng 96 jan 26 from above to below
*       ThrowOut(i) = ThrowOut(i) + he22nu(i)*fac*ExpZone(i)
        ThrowOut(i) = ThrowOut(i) + he22nu(i)*fac*ExpmTau(i)
*       >>chng 96 jan 26 from above to below
*       He22phtOTS = He22phtOTS + he22nu(i)*fac*(1.-ExpZone(i))
        He22phtOTS = He22phtOTS + he22nu(i)*fac*(1.-ExpmTau(i))
      end do
*
*     H, He, heavy element, brems free-free
      fach = eden * 1.032e-11 * (hii+heii) / sqrte
      fache2 = eden * 1.032e-11 * 4.*heiii / sqrte
      facff = eden * 1.032e-11 * EdenFFSum*5./ sqrte
*     ntff is pointer to energy where gas goes
*     optically thin to brems
      do i=1,ntff-1
        fac =
     1  ( fach*gff(i)*(1.+OpacStack(i-1+iphmra)*hn(1)) +
     2  fache2*gffhe2(i) + facff*gff(i) ) *
     2  widflx(i)* ContBoltz(i)/ anu(i)
        DiffCont(i) = DiffCont(i) + fac
*       do not add to outward beam since self absorbed
*       >>chng 96 feb 27, put back into outward beam since do not integrate
*       over it anyway.
        ThrowOut(i) = ThrowOut(i) + fac
      end do
      do i=ntff,maxcor
        fac =
     1  ( fach*gff(i)*(1.+OpacStack(i-1+iphmra)*hn(1)) +
     2  fache2*gffhe2(i) + facff*gff(i) ) *
     2  widflx(i)* ContBoltz(i)/ anu(i)
        DiffCont(i) = DiffCont(i) + fac
        ThrowOut(i) = ThrowOut(i) + fac
      end do
*
*     grain dust emission
*
      if( lgDustOn ) then
*       add grain dust emission in IR
        do i=1,nflux
          GrainEmission(i) = 0.
        end do
        do nd=1,ndust
          if( lgDustOn1(nd) ) then
            factor = 2.*pi4 * ((fr1ryd/SpeedLight)**2) * fr1ryd
            bolt = te1ryd / tedust(nd)
            f = 1.
            i = 1
*           >>chng 96 apr 26 upper limt chng from 15 to 75 Peter van Hoof
            do while ( i.lt.nflux .and. f.lt.75. )
              f = bolt * anu(i)
              if( f.gt.75. ) then
                bfac = 1e33
              else if( f.gt..01 ) then
                bfac = exp(f) - 1.
              else
                bfac = f
              endif
*             >>chng 96 july 13, save grain emission array
*             >>chng 97 feb 28, GrainEmission was set to last evaluated grain,
*             zeroed out above, and now increment grain instead of setting it
              cor = factor*(dstab1(i,nd)*hden*dstAbund(nd))*
     1        anu2(i)*widflx(i)/bfac
*666       call broken
*          kill emission from highly ionized regions
*          if( (nd.eq.9 .or. nd.eq.10) .and. hii/hden.gt.0.5)cor=0.
              GrainEmission(i) = GrainEmission(i) + cor
              DiffCont(i) = DiffCont(i) + cor
              ThrowOut(i) = ThrowOut(i) + cor
              i = i + 1
            end do
          endif
        end do
      endif
*
*     hminus emission
      fac = eden * hi
      gn = 1.
      gion = 2.
      gamma = 2.0618684e11 * gn/gion / te / sqrte
      cor = ContBoltz(iphmin)
      if( cor.gt.0. ) then
        do i=iphmin,min( nhe1(1) , nflux )
*         flux is in photons per sec per ryd
*         ContBoltz is ratio of Boltz fac for each freq
          factor = gamma * ContBoltz(i)/cor *
     1    widflx(i)* OpacStack(i-iphmin+iphmop)*anu2(i) * fac
          DiffCont(i) = DiffCont(i) + factor
          ThrowOut(i) = ThrowOut(i) + factor
        end do
      else
        do i=iphmin,min( nhe1(1) , nflux )
          arg = max(0.,1.57890e5*( anu(i)-0.05544 ) /te )
*         flux is in photons per sec per ryd
          factor = gamma * sexp( arg ) * widflx(i)*
     1    OpacStack(i-iphmin+iphmop)*anu2(i) * fac
          DiffCont(i) = DiffCont(i) + factor
          ThrowOut(i) = ThrowOut(i) + factor
        end do
      endif
*
*     get total luminosity of diffuse fields
      DiffLumin = 0.
      do i=1,nflux
        DiffLumin = DiffLumin + DiffCont(i) * anu(i)
      end do
      DiffLumin = DiffLumin * en1ryd
*
      end
**************************************************************************
      real function dintg( tdust , nd , ip )
      implicit none
*compute total radiative cooling due to large grains
      real tdust
      integer nd , ip
*
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      logical lgDustBug
*flag set with trace grains command
      common/dstbug/ lgDustBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real fac , arg , sum , planck
      integer i
      real ttused
      save ttused
      data ttused/0./
*
*     Boltzmann factors for Planck integration
      fac = te1ryd / tdust
      if( tdust.ne.ttused ) then
         dintg = 0.
         do i=1,nupper
            arg = fac * anu(i)
*           this is not the defn of ContBoltz used elsewhere in program,
*           but is used here to save core
            ContBoltz(i) = exp( min( 80. , arg ))
            if( ContBoltz(i).lt.1.01 ) then
               ContBoltz(i) = arg
            else
               ContBoltz(i) = ContBoltz(i) - 1.
            endif
         end do
         ttused = tdust
      endif
*
      dintg = 0.
      sum = 0.
      do i=1,nupper
        planck = 2.1675e16 * anu3(i) / ContBoltz(i) * widflx(i)
        sum = sum + planck
        dintg = dintg + planck * dstab1(i,nd)
      end do
*
      if( lgDustBug.and.lgTrace .and. ((ip-1)/5)*5.eq.(ip-1)) then
        write(qq,'(i4,1p,3e11.4)')
     1  nd,tdust,dintg,sum/4./5.6696e-5/tdust**4
      endif
*
      end
******************************************************************************
      subroutine dmpary
      implicit none
*print all coolants for some zone, as from print cooling command
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer ncolnt
      parameter (ncolnt=10 000)
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real eps , ratio
      parameter (eps=0.005)
      integer i
*
      write(qq,'('' This is a print out of the cooling array for zone ''
     1 ,''number '',I3)')nzone
      write(qq,'('' The total heating was HTOT='',1P,E9.2,'' erg/s/cm3''
     1,'', the total cooling was CTOT='',E9.2,'', and the '',
     1 ''temperature was'',E10.3,''K.'')') htot,ctot , te
      write(qq,'('' All coolants greater than'',F6.2,''% of the total ''
     1,''will be printed.'')') eps*100.
*
*     flag all significant coolants
      call coolpr( 'ZERO' ,1,  0.  , eps )
      do i=1,ncltot
         ratio = cooling(i)  / ctot
         call coolpr( chClntLab(i) , collam(i), ratio  , eps )
         ratio = heatnt(i)  / ctot
         call coolpr( chClntLab(i) , collam(i), ratio  , eps )
      end do
      call coolpr( 'DONE', 1 , 0.  , eps )
*
      end
******************************************************************************
      subroutine dmpast
      implicit none
*dump cooling, calls coolpr with most important coolants
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer ncolnt
      parameter (ncolnt=10 000)
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real te , eden , hden
      common/phycon/ te , eden , hden
*
      real eps , ratio
      integer i
      parameter (eps=0.005)
*
      write(qq,'(''     All coolants greater than'',F6.2,''% of the '',
     1''total will be printed.'')') eps*100.
*
*     flag all significant coolants
      call coolpr( 'ZERO' ,1,  0.  , eps )
      do i=1,ncltot
        ratio = cooling(i)  / ctot
        call coolpr( chClntLab(i) , collam(i), ratio  , eps )
      end do
      call coolpr( 'DONE', 1 , 0.  , eps )
*
      if( heating(1,23)/ctot.gt.0.05 ) then
        write(qq,'(''     All coolant heat greater than'',F6.2,
     1  ''% of the total will be printed.'')') eps*100.
        call coolpr( 'ZERO' ,1,  0.  , eps )
        do i=1,ncltot
          ratio = heatnt(i)  / ctot
          call coolpr( chClntLab(i) , collam(i), ratio  , eps )
        end do
      call coolpr( 'DONE', 1 , 0.  , eps )
      endif
*
      end
******************************************************************************
      subroutine dont( chCard )
      implicit none
*parse the dont command - do not do something
      character chCard*80
*
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer limelm
      parameter (limelm=30)
      real GrnIonRec , grecon
*rate coefficient for ionic recombination on grain surfaces, eval in hmole
*grecon usually 1, set to 0 with no grain neutralization command
      common/gionrc/ GrnIonRec , grecon
      logical lgPhysOK
*flag set if a physical condition has been disabled
      common/physok/ lgPhysOK
      real otsmin
      common/otsmin/ otsmin
      logical lgSecOFF
*flag saying that secondary electron have been turned off
      common/secoff/ lgSecOFF
      logical lgFstOn
      common/fston/ lgFstOn
      logical lgScatON
*flag saying whether (true) or not (false) scattering opacity
*is enabled
      common/scaton/ lgScatON
      logical lgRadPrsON
*flag true if radiation pressure is turned on, part of total pressure
      common/radpon/ lgRadPrsON
      logical lgFreeOn
*flag set false if no free-free heating command entered
      common/freeon/ lgFreeOn
      logical lgC2psOn
*are collisions between 2s and 2p enabled?
      common/c2pson/ lgC2psOn
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      logical lgNoCota
*lgNoCota flag set with no three body recombination
      real CotaRate
      common/rcota/ lgNoCota , CotaRate(limelm)
      logical lgNoMole
*flag to turn off molecules
      common/nomole/ lgNoMole
      logical lgStarkON
*flag saying that stark broadening is enabled, set false with no stark
      common/strkon/ lgStarkON
      logical lgCompRecoil
*flag saying that compton recoil ionization of bound
*electrons is enabled
      common/recoil/ lgCompRecoil
      logical lgFe2On
*logical variable that controls whether (true) or not (false)
*pumping of the FeiI model atom by HI Lya is included
      common/fe2on/ lgFe2On
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      real vyield
      integer nyield
*     block data of yields from Mewe paper
*     vyield( nelem, nstage, nshell, nelec )
*     nelem is element number, 6 for carbon
*     nstage is stage of ionization, 1 for atom
*     nshell is shell number in dima notation
*     nelec is fraction that yield that number of electrons
**    nyield is number of electrons at most
      common/yield/ vyield(30,30,7,10), nyield(30,30,7)
      real PhotScaleOn
*     set to 1 in zero, so have no effect
*     set to 0 with 'no photoionization' command, kills
*     photoionization of everything
      common/PhotScale/ PhotScaleOn
      real HCTOn
*     variable to turn on or off ct ionization-recombiantion of
*     hydrogen - set 0 with no charge trasnfer command
      common/HCTOnOff/ HCTOn
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgMatch , lgNoVary
      integer nelem , nstage , nshell
*
      if( lgMatch('AUGE',chCard) ) then
*        turn off auger effect
         lgPhysOK = .false.
         do nelem=1,limelm
           do nstage=1,nelem
             do nshell=1,7
*              only one electron comes out
               nyield(nelem,nstage,nshell) = 1
               vyield(nelem,nstage,nshell,1) = 1.
             end do
           end do
         end do
*
      else if( lgMatch('CHAR',chCard) ) then
*        turn off both recoil ionization and compton heating of free electron
         HCTOn = 0.
         lgPhysOK = .false.
*
      else if( lgMatch('COMP',chCard) ) then
*        turn off both recoil ionization and compton heating of free electron
         comoff = 0.
         lgPhysOK = .false.
*
      else if( lgMatch('FEII',chCard) ) then
*        turn off feii ly-alpha pumping
         lgFe2On = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('FINE',chCard) ) then
*        turn off fine structure optical depths
         lgFstOn = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('FREE',chCard) ) then
*        turn off free free heating
         lgFreeOn = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('GRAI',chCard) ) then
         if( lgMatch( 'NEUT' , chCard ) ) then
*        turn off ion grain recombination "NO GRAIN NEUTRALIZATION"
           grecon = 0.
           lgPhysOK = .false.
         else
           write(qq,'('' No key recognized on this line.'')')
           stop
         endif
*
      else if( lgMatch('INDU',chCard ) ) then
*        turn off induced recombination and stimulated emission
         lgPhysOK = .false.
*        turn off continuum fluorescent excitation of lines
         lgFluor = .false.
*
      else if( lgMatch('MOLE',chCard) ) then
*        disable molecule formation
         lgNoMole = .true.
         lgPhysOK = .false.
*
      else if( lgMatch('PHOT',chCard) ) then
*        disable photoionization
         PhotScaleOn = 0.
         lgPhysOK = .false.
*
      else if( lgMatch('RADI',chCard) ) then
*        don't include line radiation pressure
         lgRadPrsON = .false.
*
      else if( lgMatch('RECO',chCard) ) then
*        disable compton recoil of bound electrons - "no recoil ioniz"
         lgCompRecoil = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('SCAT',chCard) ) then
*        no scattering opacity, for Compton thick spherical geometry
         lgScatON = .false.
*
      else if( lgMatch('SECO',chCard) ) then
*        turn off secondary electron ionizations
         lgSecOFF = .true.
         lgPhysOK = .false.
*
      else if( lgMatch('SPOT',chCard) ) then
*        no on-the-spot; turn on all ground state rec
         otsmin = 1.
*
      else if( lgMatch('STAR',chCard) ) then
*        no stark broadening
         lgStarkON = .false.
         lgPhysOK = .false.
*
      else if( lgMatch('THRE',chCard) ) then
*        turn off Cota's three body rec subroutine
         lgNoCota = .true.
         lgPhysOK = .false.
*
      else if( chCard(1:7).eq.'NO VARY') then
*        this is a no-nothing, picked up in optimizer
         lgNoVary = .true.
*
      else if( lgMatch('2S2P',chCard).or.lgMatch('2P2S',chCard) ) then
*        turn off collisions between 2s and 2p
         lgC2psOn = .false.
         lgPhysOK = .false.
*
      else
*        end of else if trap
         write(qq,'('' I dont understand what not to do.  STOP'')')
         stop
      endif
*
      end
******************************************************************************
      subroutine DoPunch( chTime )
      implicit none
*produce punch output during calculation
      character*4 chTime
*     chTime is 'MIDL' during calculation, 'LAST' at the end
      integer limpun
      parameter (limpun=20 )
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer mapdim
      parameter (mapdim=102)
      integer nGrid
      parameter (nGrid=100)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      integer iphop
      common/iphop/ iphop(lmhlvl)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real FluxSave
*save incident continuum for later iterations
      common/flxsav/ FluxSave(ncell)
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      real tedust
      common/tedust/ tedust(ndust)
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgPresOK
*     set true in presur if presure ok, false otherwise
      common/presok/ lgPresOK
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      integer ioptri
      common/ioptri/ ioptri
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real dqabs, dqscat
      common/dqs/ dqabs(ncell,ndust) , dqscat(ncell,ndust)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgPunLstIter(limpun)
*lg flag lgPunLstIter for this punch option,
*do we only want to punch on last iteration?
      common/punlst/ lgPunLstIter
      logical lgLastIt
*     this is false on any but the last iteration
*     set true in startr if iter > itermx
      common/lastit/ lgLastIt
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real opac
      common/opac/ opac(ncell)
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real pinit , pinteg , pinzon
      common/pinteg/ pinit , pinteg , pinzon
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real DiffCont
*diffus is local diffuse continuum, for current zone
      common/diffus/ DiffCont(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      character chPunch*4, chConPunEnr*4
      integer ipConPunEnr
*chPUnch - what is it we want to punch? set in GetPunch, used in DoPunch
*chConPunEnr - units of continuum in punch output
      common/cpunch/ chPunch(limpun) , chConPunEnr(limpun) , ipConPunEnr
      integer ipPnunit , npunch
      real punarg
*     ipPnunit is io unit number, number of punch commands eneterd
*     punarg is set of optional arguments for the punch command
      common/pnunit/ ipPnunit(limpun) , npunch , punarg(limpun,3)
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer nmap
      real temap , hmap , cmap
      common/mapr/ nmap , temap(mapdim) , hmap(mapdim) , cmap(mapdim)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
*     include "hdamp.com"
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
      integer ndston , ipdon
      common/ndston/ ndston , ipdon(ndust)
      real DustCoolGas
*dust cooling the gas by collisions
      common/dclgas/ DustCoolGas
      integer maxcor
      common/maxcor/ maxcor
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      double precision comup, comdn
      common/comexc/ comup(ncell) , comdn(ncell)
*     these are the integrated absorption and scattering optical depths
*     to the illuminated face of the cloud
      real depabs , depsct
      common/deptau/ depabs(ncell) , depsct(ncell)
      real r1r0sq
      common/r1r0sq/ r1r0sq
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      integer LinEvery
      logical lgLinEvery
*option to punch line intensities every LinEvery zones
*logical variable says whether LinEvery was set
      common/levery/ LinEvery , lgLinEvery
      real raten3
      common/raten3/ raten3
      integer ipVFilter
* pointer to V filter for getting Av
      common/ipvfil/ ipVFilter
      real tlast
      common/tlast/ tlast
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer ncPunchSkip
*set skip sets this variable, which says how many cells to skip in punch
      common/PunchSkip/ ncPunchSkip
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
      real TeGrid(nGrid) , HtGrid(nGrid) , ClGrid(nGrid)
      integer ipGrid , nZonGrid(nGrid)
      common/HeatCool/ TeGrid , HtGrid , ClGrid , ipGrid, nZonGrid
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
*     include "facexp.com"
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      real HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
*     HRecRad is sum of radiative rec to all excited states
*     hrectot is hcaseb plus effective rec to ground
*     HRecEffec is total effec eval in hlevel, should be
*     roughly equal to hrectot
*     HRecNet is net rec coef, with 3-body rec less coll ioniz
*     HRecCol is thre-body recombination alone
*     HRecInd is induced recombination
      common/hcaseb/ HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
      real pnow , pcorec
      common/pnow/ pnow , pcorec
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real PressureInit
*     this is the total pressure at the illuminated face
      common/PresInit/ PressureInit
      real hesc , esesc
      common/hesc/ hesc(lmhlvl,lmhlvl) , esesc(lmhlvl,lmhlvl)
      real hfrcin
      common/hfrcin/ hfrcin(lmhlvl,lmhlvl-1)
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      real hnet
      common/hnet/ hnet(lmhlvl,lmhlvl-1)
      real TeInit , TeProp
      common/tpred/ TeInit , TeProp
      real collhe3 , she2ov3
      common/he3rate/ collhe3 , she2ov3
      real he3pht , he3lya , he3local , he3relax
*     he3relax is fraction of 23s populations that go to singlets
      common/he3pht/ he3pht , he3lya , he3local , he3relax
      real smhe2ov1 , clhe2ov1
      common/he1rate/ smhe2ov1 , clhe2ov1
      real reci , rectri , recii
      common/herec/ reci , rectri , recii
      real he3gam , He3FrLya
*     total photoionization rates for helium triplest
*     He3FrLya is fraction of this that is Lya
      common/he3gams/ he3gam(nhe3lvl) , He3FrLya
      real tmn
      common/tmn/ tmn(ncell)
      real sheiov2 , collhe2
      common/he2rate/ sheiov2 , collhe2
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer iophe1
      common/iophe1/ iophe1(9)
      real AnuOrg
*original set of energy units, always the same no matter what the
*shape of the continuum - actual energy units change with shape
      common/anusave/ AnuOrg(ncell)
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      real PH1
*     ph1(a,b,c,d)
*     a=1 => thresh, others fitting parameters
*     b atomic number
*     c number of electrons
*     d shell number 7-1
      common/PH1/ PH1(6,30,30,7)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      character chShell(7)*2
*character representation of shells 1 to 7 of atoms and ions, '1s', '2s', etc
      common/Shell/ chShell
      real SavOutCon(ncell)
*     variables related to deriving the ratio of outward to incident continuum
*     SumOutMax - energy where max occurs, ipSumOutMax pointer to this
*     sumOutCon is summed out outlin and outcon less SavOutCon for all energy
*     SumHOutCon is H-ionizing only
      real SumOutCon , SumIncCon , SumHOutCon , SumHIncCon , SumOutMax
      integer ipSumOutMax
      common/SumOutInc/ SumOutCon , SumIncCon , SavOutCon , SumHOutCon ,
     1 SumHIncCon , SumOutMax , ipSumOutMax
      real PunchLWidth
*contrast factor for lines to continuum in punch output
*default is 1 (gives correct line intensities) and changed with
*set width command (enters width in km/sec)
      common/PLWidth/ PunchLWidth
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character*6 chEner(limelm)
      integer j,ipoint,jj,nd , i1,isav,i, nelem,ion
      real fref,fout,fsum,sum,flxcor,damp,eps,stage,
     1 pop,texc,av,refac,flxin,flxatt,conem, opConSum ,
     2 flxtrn,flxref , plankf , HCTIon , HCTRecom, opLinSum ,
     3 ConMax , xLinMax , RateInter , AnuUnit
      integer ipConMax , ipLinMax , ips ,n
 
      logical lgOK , lgTlkSav
*
*     free statement labels, >= 13
*
*     the LAST option on punch command is parsed at the top of the loop
*     in only one place.  No action is needed at all for PUNCH LAST to work
*     ok throughout this routine
*
*     each branch can have a test whether chTime is or is not 'LAST'
*     if 'LAST' then this is last call to routine after calc complete
*     punch only if 'LAST' when results at end of cal are needed
*     test for .not.'LAST' is for every zone result, where you do not
*     want to punch last zone twice
*
*     punch results on unit ipPnunit
      if( npunch.lt.1 ) return
*
      do i=1,npunch
*       lgPunLstIter set true if 'last' key occured on punch command
*       normally is false.  This will skip punching if last set and
*       this is not last iteration
*       >>chng 97 june 8, get rid of go to
        if( lgLastIt .or. (.not.lgPunLstIter(i)) ) then
*
        if( chPunch(i).eq.'ABUN' ) then
*         punch abundances vs depth
          if(chTime.ne.'LAST') write(ipPnunit(i),'(0p,30f6.2)')
     1    (log10(xIonFracs(j,0)),j=1,limelm)
*
        else if( chPunch(i).eq.'CHAR' ) then
*         charge exchange rate coefficients
          do j=2,limelm
            write(ipPnunit(i),'(i3,1p,6e10.2)')
     1      j,(HCTRecom(jj,j),jj=1,min(6,j))
          end do
          do j=2,limelm
            write(ipPnunit(i),'(i3,1p,6e10.2)')
     1      j,(HCTIon(jj,j),jj=1,min(6,j))
          end do
*
        else if( chPunch(i).eq.'COOL' )then
          if(chTime.ne.'LAST')call PunCool(ipPnunit(i) )
*
        else if( chPunch(i).eq.'COMP' ) then
*         compton energy exchange coefficients
          if(chTime.ne.'LAST')write(ipPnunit(i),'(1x,1p,3e10.2)')
     1    (anu(jj),comup(jj)/widflx(jj),comdn(jj)/widflx(jj),
     2    jj=1,nflux,ncPunchSkip)
*
         else if( chPunch(i).eq.'CON ') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
           if( lgSphere ) then
             refac = 0.
           else
             refac = 1.
           endif
           do j=1,nflux,ncPunchSkip
*            four continua predicted here;
*            incident, attenuated incident, emitted,
*            then attenuated incident + emitted, last reflected
*            reflected continuum is stored relative to inner radius
*            others are stored for this radius
*
*            NB this code also used in punch emitted,
*            transmitted continuum commands
             flxref = (anu2(j)*refcon(j)/widflx(j)+
     1       anu(j)*PunchLWidth*reflin(j))*
     1       refac* en1ryd
             flxin = FluxSave(j)*anu2(j)*en1ryd/widflx(j)
             flxatt = flux(j) * anu2(j) * en1ryd / widflx(j) * r1r0sq
             conem = (  (ContDiff(j)+outcon(j))/widflx(j)*anu2(j) +
     1       PunchLWidth*outlin(j)*anu(j) ) * r1r0sq*en1ryd*covgeo
             flxtrn = conem + flxatt
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1p,e11.5,6e10.3,1x,2(a4,1x))')
     1       AnuUnit(j),
     1       flxin, flxatt, conem,flxtrn,flxref, flxref+flxtrn,
     2       chLineLabel(j), chContLabel(j)
           end do
           endif
*
         else if( chPunch(i).eq.'CONC') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*          incident continuum
           do j=1,nflux,ncPunchSkip
             flxin = FluxSave(j)*anu2(j)*en1ryd/widflx(j)
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1p,e11.5,6e10.3,1x,2(a4,1x))')
     1       AnuUnit(j), flxin
           end do
           endif
*
         else if( chPunch(i).EQ.'CONR') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
           if( lgSphere ) then
             write(ipPnunit(i),'('' Reflected continuum not predicted ''
     1       ,''when SPHERE is set.'')')
             stop
           endif
           do j=1,nflux,ncPunchSkip
*            reflected continuum
             flxref = anu2(j)*refcon(j)/widflx(j)* en1ryd
*            reflected lines
             fref = anu(j)*PunchLWidth*reflin(j)* en1ryd
*            ratio of reflected to incident continuum, the albedo
             if( FluxSave(j).gt.1e-25 ) then
               av = reflux(j)/FluxSave(j)
             else
               av = 0.
             endif
*            >>chng 96 oct 22, format of anu to 12.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1p,5e12.5,1x,a4)') AnuUnit(j), flxref,
     1       fref, flxref+fref , av , chContLabel(j)
           end do
           endif
*
         else if( chPunch(i).EQ.'CONB') then
*          this option to punch continuum binning
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if(chTime.ne.'LAST')
     1     write(ipPnunit(i),'(1p,2e14.5)') (AnuUnit(j),widflx(j),
     1     j=1,nupper,ncPunchSkip)
*
         else if( chPunch(i).eq.'COND') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*          this option to punch diffuse continuum
           do j=1,nflux,ncPunchSkip
*            >>chng 96 oct 22, format of anu to 12.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1p,2e12.5)') AnuUnit(j),
     1       DiffCont(j)*anu2(j)*en1ryd/widflx(j)
           end do
           endif
*
         else if( chPunch(i).eq.'CONE') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*          punch emitted continuum
           if( lgSphere ) then
             refac = 0.
           else
             refac = 1.
           endif
           do j=1,nflux,ncPunchSkip
*            this is the reflected component
             flxref = (anu2(j)*refcon(j)/widflx(j)+
     1       anu(j)*PunchLWidth*reflin(j))*
     1       refac* en1ryd
*            fref = (anu2(j)*refcon(j)/widflx(j)+anu(j)*PunchLWidth*reflin(j))*
*    1       en1ryd
*            this is the total emission in the outward direction
             conem = (ContDiff(j)+outcon(j))/widflx(j)*anu2(j) +
     1       PunchLWidth*outlin(j)*anu(j)
             conem = conem*r1r0sq*en1ryd*covgeo
*            output: photon energy, reflected, outward, total emission
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
             write(ipPnunit(i),'(1P,e11.5,3E11.3,1x,2(a4,1x))')
     1       AnuUnit(j),
     1       flxref, conem, flxref+conem,
     2       chLineLabel(j), chContLabel(j)
           end do
           endif
*
         else if( chPunch(i).eq.'CONi') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
*          continuum interactions
           if( chTime.ne.'LAST' ) then
             fref = 0.
             fout = 0.
             fsum = 0.
             sum = 0.
             flxin = 0.
*            this is option to set lowest energy
             if( punarg(i,1).le.0. ) then
               i1 = 1
             else if( punarg(i,1).lt.100. ) then
               i1 = ipoint( punarg(i,1) )
             else
               i1 = punarg(i,1)
             endif
             do j=i1,nflux
               fref = fref + flux(j)*opac(j)
               fout = fout + otslin(j) * opac(j)
               fsum = fsum + otscon(j) * opac(j)
               sum = sum + outcon(j)*opac(j)
               flxin = flxin + outlin(j)*opac(j)
             end do
             write(ipPnunit(i),'(1p,5e10.2)') fref,fout,fsum,sum,flxin
           endif
*
         else if( chPunch(i).eq.'CONI') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*          punch ionizing continuum command
*          this is option to set lowest energy
           if( punarg(i,1).le.0. ) then
             i1 = 1
           else if( punarg(i,1).lt.100. ) then
             i1 = ipoint( punarg(i,1) )
           else
             i1 = punarg(i,1)
           endif
           sum = 0.
           do j=i1,nflux
             flxcor = flux(j) + otslin(j)+otscon(j)+outcon(j)+outlin(j)
             sum = sum + flxcor * opac(j)
           end do
           if( sum.gt.0. ) then
             sum = 1. / sum
           else
             sum = 1.
           endif
           fsum = 0.
           do j=i1,nflux,ncPunchSkip
             flxcor = flux(j) + otslin(j)+otscon(j)+outcon(j)+outlin(j)
             fsum = fsum + flxcor * opac(j)
*            punched quantities are freq, flux, flux*cross sec,
*            fraction of total, integral fraction of total
             RateInter = flxcor*opac(j)*sum
*            punage(i,2) is lowest interaction rate to consider, def=0
             if( RateInter.gt. punarg(i,2)) then
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
               write(ipPnunit(i),'(1p,e11.5,2e9.2,0p,4f5.2,1p,2e10.2,1x,
     1         2(a4,1x))')
     1         AnuUnit(j),flxcor, flxcor * opac(j) ,
     2         flux(j)/flxcor,otslin(j)/flxcor,otscon(j)/flxcor,
     3         (outcon(j)+outlin(j))/flxcor , RateInter , fsum*sum ,
     1         chLineLabel(j), chContLabel(j)
             endif
           end do
           endif
*
         else if( chPunch(i).eq.'CORA') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*            this option to punch all raw ionizing continuum
             do j=1,nflux,ncPunchSkip
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
               write(ipPnunit(i),'(1P,e11.5,8E11.3)') AnuUnit(j),
     1         flux(j),
     1         otslin(j),otscon(j),refcon(j),outcon(j),outlin(j),
     2         ContDiff(j)
             end do
           endif
*
         else if( chPunch(i).eq.'COLO' ) then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*            option to punch out outward continuum here
             do j=1,nflux,ncPunchSkip
*              >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1ryd
               write(ipPnunit(i),'(1p,e11.5,8e10.2)')
     1         AnuUnit(j),SavOutCon(j) ,outcon(j)+PunchLWidth*outlin(j),
     2         SavOutCon(j)*opac(j)*anu(j) ,
     1         (flux(j)+otscon(j)+otslin(j)+outcon(j)+outcon(j) ) *
     1         opac(j)* anu(j)
             end do
           endif
*
         else if( chPunch(i).eq.'CONO' ) then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*            option to punch out outward continuum
             do j=1,nflux,ncPunchSkip
*            >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1 ryd
               write(ipPnunit(i),'(1p,e11.5,8e10.2)')
     1         AnuUnit(j),
     2         flux(j)*anu2(j)*en1ryd/widflx(j)*r1r0sq,
     3         outcon(j)/widflx(j)*anu2(j)*r1r0sq*en1ryd,
     4         PunchLWidth*outlin(j)*anu(j)*r1r0sq*en1ryd,
     5         (outcon(j)/widflx(j)*anu2(j)+
     6         PunchLWidth*outlin(j)*anu(j))*r1r0sq*en1ryd
             end do
           endif
*
         else if( chPunch(i).eq.'CONT') then
*          set pointer for possible change in units of energy in continuum
*          AnuUnit will give anu in whatever units were set with punch units
           ipConPunEnr = i
           if( chTime.eq.'LAST' ) then
*            this option to punch transmitted continuum
             do j=1,nflux,ncPunchSkip
*              contin = flux(j)+
*    1         ((ContDiff(j)+outcon(j))*anu2(j)/widflx(j)+
*    2         PunchLWidth*outlin(j)*anu(j))
*              attenuated incident continuum
*              >>chng 97 jul 10, remove PunchLWidth from this one only since
*              we must conserve energy even in lines
               flxatt = flux(j) * anu2(j) * en1ryd / widflx(j) * r1r0sq
               conem = (ContDiff(j)+outcon(j))/widflx(j)*anu2(j) +
     1         outlin(j)*anu(j)
               conem = conem*r1r0sq*en1ryd*covgeo
               flxtrn = conem + flxatt
*              >>chng 96 july 11, had been below, had big bug
*              flxcor = contin *en1ryd* r1r0sq*covgeo
*              use AnuOrg here instead of anu since probably
*              going to be used by table read
*              and we want good anu array for sanity check
*              >>chng 96 oct 22, format of anu to 11.5 to resolve grid near 1ryd
               write(ipPnunit(i),'(1p,3e12.5)') AnuUnit(j),flxtrn
             end do
           endif
*
         else if( chPunch(i).eq.'DUSO' ) then
*          >>chng 97 july 2, from ne last to eq last
*          punch grain opacity
           if(chTime.eq.'LAST')write(ipPnunit(i),'(1p,e12.4,3e9.2)')
     1     (anu(j),(dstab(j)+dstsc(j)),dstab(j),dstsc(j),j=1,nflux)
*
         else if( chPunch(i).eq.'DUSP' ) then
           write(ipPnunit(i),'(1x,i4,1p,8e10.2)') nzone,
     1     (tedust(ipdon(j)),j=1,ndston),(dstpot(ipdon(j))*evryd,j=1,
     1     ndston),
     2     (DustDftVel(ipdon(j)),j=1,ndston) , heating(1,14)/htot,
     3     DustCoolGas/htot
*
         else if( chPunch(i).eq.'ELEM' ) then
           if( chTime.ne.'LAST' ) then
*          this is the pointer to atomic number
           jj = punarg(i,1)
           write(ipPnunit(i),'(1x,1p,e11.4,31i5)') depth ,
     1     (int(-1000.*log10(max(5e-10,xIonFracs(jj,j)/
     2     xIonFracs(jj,0)))),j=1,jj+1)
           endif
*
         else if( chPunch(i).eq.'RECE' ) then
*           recombination efficiencies
            write(ipPnunit(i),'(1p,8e12.4)')  hrec(1,2),
     1      he1rec(1,2),he1rec(1,3),ophe1f(1),he2rec(1,2)
*
         else if( chPunch(i).eq.'FEII' ) then
            if(chTime.ne.'LAST')call pfeii(ipPnunit(i) )
*
         else if( chPunch(i).eq.'GAMM' ) then
            if(chTime.ne.'LAST')call PunGamma(ipPnunit(i) )
*
         else if( chPunch(i).eq.'GAUN' ) then
           if(chTime.ne.'LAST')call pgaunt(ipPnunit(i) )
*
         else if( chPunch(i).eq.'HEAT' )then
           if(chTime.ne.'LAST')call PunHeat(ipPnunit(i) )
*
*        punch helium
         else if( chPunch(i).eq.'HEL1' ) then
           if( chTime.ne.'LAST' ) then
             if( smhe2ov1.gt.1e-30 ) then
               fref = ( heii / smhe2ov1 ) / ahe
             else
               fref = 0.
             endif
*            second number is ratio of predicted HeII/AheII to simple
*            clhe2ov1 is computed He1/He1
             write(ipPnunit(i),'(''he1'',1p,9e10.2)') hei/ahe,
     1       fref ,clhe2ov1,smhe2ov1,reci*eden, he1gam(1),hei3/ahe
             call PrtGamma(nhe1(1) ,nflux ,iophe1(1),ipPnunit(i),
     1       he1gam(1),he1gam(1)*0.05)
           endif
*
         else if( chPunch(i).eq.'HEL2' ) then
           if( chTime.ne.'LAST' ) then
*          sheiov2 is He++ over He+
           if( heii.gt.0. ) then
             fref = heiii / heii
           else
             fref = 0.
           endif
           write(ipPnunit(i),'(1x,i4,1p,9e10.2)') nzone, fref ,
     1     sheiov2 ,recii, he2gam(1),  collhe2,csupra
           endif
*
         else if( chPunch(i).eq.'HEL3' ) then
           if( chTime.ne.'LAST' ) then
           if( she2ov3.gt.0. ) then
             fref = ( heii / she2ov3 ) / ahe
           else
             fref = 0.
           endif
           write(ipPnunit(i),'(1x,i4,1p,9e10.2)') nzone, hei3/ahe,
     1     fref ,rectri*eden, he3gam(1),  collhe3
           call PrtGamma(nhei3 ,nhe1(1) ,ioptri,ipPnunit(i),
     1     he3gam(1) , he3gam(1)*0.05 )
           endif
*
         else if( chPunch(i).eq.'HUMM' ) then
           damp = hdamp(2) / doppler(1) / 0.75
           eps = hyas(2,1) / (hcol(2,1)*eden)
           write(ipPnunit(i),'(1x,1p,13e10.3)')depth,htau(2,1),
     1     hn(1)*hii,hn2p*hii, te ,  damp , eps
*
         else if( chPunch(i).eq.'HYDc' ) then
*          punch hydrogen physical conditions
           write(ipPnunit(i),'(1x,1p,13e9.2)') depth,te,hden,
     1     eden,hi/hden,hii/hden,htwo/hden,h2plus/hden,h3plus/hden,
     2     hminus/hden
*
         else if( chPunch(i).eq.'HYDi' ) then
           if( chTime.ne.'LAST' ) then
*          punch hydrogen ionization
*          this will be total decays to ground
           RateInter = 0.
           stage = hcolnc(1)*eden * hn(1)
           fref = hgamnc(1) * hn(1)
           fout = hn(1)
           do ion=2,nhlvl
*            this is total decays to ground
             RateInter = RateInter + hnet(ion,1)
*            total photo from all levels
             fref = fref + hgamnc(ion) * hn(ion)
*            total col ion from all levels
             stage = stage + hcolnc(ion)*eden * hn(ion)
             fout = fout + hn(ion)
           end do
           write(ipPnunit(i),'(i4,1p,14e9.2)')nzone,
     1     hgamnc(1) , HRecEffec,HRecRad,hii/hi,
     1     hgamnc(1)/(eden*HRecEffec),hrec(1,3),RateInter,
     1     fref/max(1e-37,fout) , stage/max(1e-37,fout),
     1     hgamnc(1)*hi/(eden*hii)
           call PrtGamma(ipHn(1),nflux,iphop(1),ipPnunit(i),hgamnc(1),
     1     hgamnc(1)*0.05)
           endif
*
         else if( chPunch(i).eq.'HYDp' ) then
*          punch hydrogen populations
           write(ipPnunit(i),'(1x,1p,13e9.2)') depth,hi, hii,
     1     (hn(j),j=1,6),hn2s,hn2p
*
         else if( chPunch(i) .eq. ' IP ') then
           if( chTime.eq.'LAST' ) then
*          punch valence shell ip's
           do nelem=1,limelm
             do n=0,15,15
               if(n+1.le.nelem ) then
                 write(ipPnunit(i),'(1x)')
                 write(ipPnunit(i),'(a2,i4,29i6)')
     1           chElementSym(nelem),(ion,ion=n+1,min(n+15,nelem))
               endif
               if( n+1.le.nelem ) then
                 do ips=1,nsShells(min(n+15,nelem),1+n)
                   do j=n+1,min(n+15,nelem)
                     sum = PH1(1,nelem,nelem+1-j,ips)
                     if( sum.lt.2. ) then
                       chEner(j) = '      '
                     else if( sum.lt.10. ) then
                       write(chEner(j),'(f6.3)') sum
                     else if( sum.lt.100. ) then
                       write(chEner(j),'(f6.2)') sum
                     else if( sum.lt.1000. ) then
                       write(chEner(j),'(f6.1)') sum
                     else
                       write(chEner(j),'(i6)') int(sum)
                     endif
                   end do
                   write(ipPnunit(i),'(a2,30a6)')
     1             chShell(ips), (chEner(j),j=n+1,min(n+15,nelem))
                 end do
               endif
             end do
           end do
           endif
*
         else if( chPunch(i).eq.'LINC') then
*          punch line cumulative
           if(chTime.ne.'LAST')call punlin( ipPnunit(i) , 'PUNC' ,lgOK)
*
         else if( chPunch(i).eq.'LINL' ) then
*          punch line labels, then stop
           call pllabels( ipPnunit(i) )
           stop
*
         else if( chPunch(i).eq.'LIND' ) then
*          punch line data, then stop
           call pldata( ipPnunit(i) )
           stop
*
         else if( chPunch(i).eq.'LINS' ) then
*          punch line structure
           if(chTime.ne.'LAST')call punlin( ipPnunit(i) , 'PUNS' , lgOK)
*
         else if( chPunch(i).eq.'LINA' ) then
           if( chTime.eq.'LAST' ) then
*          punch out all lines with energies
           do j=1,nsum
             if( xLineEnergy(j).gt.0. .and.sumlin(j).gt.0. ) then
               write(ipPnunit(i),'(1p,e12.5,0p,f8.3,2x,a4)')
     1         xLineEnergy(j)  , log10(sumlin(j))+pirsq , chALab(j)
*              write(ipPnunit(i),'(a4,1p,2e12.4)')
*    1         chALab(j), xLineEnergy(j) , log10(sumlin(j))+pirsq
             endif
           end do
           endif
*
         else if( chPunch(i).eq.'LINI' ) then
           if( chTime.eq.'LAST'.and.
     1       (nzone/LinEvery)*LinEvery.ne.nzone) then
*            this is the last zone
*            punch line intensities - but do not do last zone twice
*            >>chng 97 july 24, following had (npunch) rather than (i)
             call plinin( ipPnunit(i) )
           else if( chTime.ne.'LAST' ) then
*            following so we only punch first zone if LinEvery reset
             if( (lgLinEvery .and. nzone.eq.1) .or.
     1         (nzone/LinEvery)*LinEvery.eq.nzone ) then
*              this is middle of calculation
*              punch line intensities
*              >>chng 97 july 24, following had (npunch) rather than (i)
               call plinin( ipPnunit(i) )
             endif
           endif
*
         else if( chPunch(i).eq.'LYMA' ) then
           pop = (hn2p/6.) / (hn(1)/2.)
           if( pop.gt.0. ) then
             texc = -1.183e5 / log(pop )
           else
             texc = 0.
           endif
           write(ipPnunit(i),'(1p,5e12.4)') htau(2,1),pop,texc,te,
     1     texc/te
*
         else if( chPunch(i).eq.'MAP ' ) then
           if( chTime.eq.'LAST' ) then
             lgTlkSav = lgTalk
             lgTalk = .true.
             isav = qq
             qq = ipPnunit(i)
             call punt(' map')
             qq = isav
             lgTalk = lgTlkSav
           endif
*
         else if( chPunch(i).eq.'MOLE' ) then
           write(ipPnunit(i),'(1x,1p,7e10.2)') depth,
     1     htwo/hden , co/hden , h2o/hden, oh/hden, ch/hden , otwo/hden
*
         else if( chPunch(i).eq.'OPAC' ) then
*          punch opacity - routine will parse which type of opacity punch to do
           if(chTime.eq.'LAST')call PunOpac( ipPnunit(i) , i)
*
         else if( chPunch(i).eq.'OPTI' ) then
           if(chTime.ne.'LAST')write(ipPnunit(i),'(1p,4e12.4)') (anu(j),
     1     tautot(j,1) , tauabs(j,1) , tausct(j,1), j=1,nflux)
*
         else if( chPunch(i).eq.' OTS' ) then
           ConMax = 0.
           xLinMax = 0.
           opConSum = 0.
           opLinSum = 0.
           ipLinMax = 1
           ipConMax = 1
           do j=1,nflux
             opConSum = opConSum + otscon(j)*opac(j)
             opLinSum = opLinSum + otslin(j)*opac(j)
             if(otslin(j)*opac(j).gt.xLinMax ) then
               xLinMax = otslin(j) * opac(j)
               ipLinMax = j
             endif
             if(otscon(j)*opac(j).gt.ConMax ) then
               ConMax = otscon(j) * opac(j)
               ipConMax = j
             endif
           end do
           write(ipPnunit(i),'(1p,''tot con lin='',2e9.2,'' lin='',a4,
     1     e11.4,e9.2,'' con='',a4,e11.4,e9.2)')opConSum,opLinSum,
     2     chLineLabel(ipLinMax), anu(ipLinMax),xLinMax,
     1     chContLabel(ipConMax), anu(ipConMax),ConMax
*
         else if( chPunch(i).eq.'OVER' ) then
*          overview of model results,
*          depth, te, hden, eden, ion fracs H, He, c, O
           if(chTime.ne.'LAST')
     1     write(ipPnunit(i),'(1p,e10.4,0p,f6.3,f8.3,2f7.3,16f6.3)')
     1     depth,log10(te), log10(htot),log10(hden), log10(eden),
     1     -log10(max(5e-10,hi/hden)) ,-log10(max(5e-10,hii/hden)),
     2     (-log10(max(5e-10,xIonFracs(2,j)/xIonFracs(2,0))),j=1,3),
     2     (-log10(max(5e-10,xIonFracs(6,j)/xIonFracs(6,0))),j=1,4),
     2     (-log10(max(5e-10,xIonFracs(8,j)/xIonFracs(8,0))),j=1,6)
*
        else if( chPunch(i).eq.' PDR' ) then
         if( chTime.ne.'LAST' ) then
           av = tautot(ipVFilter,1) * 1.08574
           write(ipPnunit(i),'(1p,e8.2,8e9.2)') depth,colden,av,te,
     1     hi/hden, htwo/hden, xIonFracs(6,1)/xIonFracs(6,0),
     2     co/xIonFracs(6,0) ,
     2     h2o/xIonFracs(8,0)
         endif
*
        else if( chPunch(i).eq.' QS ' ) then
          if(chTime.eq.'LAST')
     1    write(ipPnunit(i),'(1p,5e12.4)') (anu(j),(dqabs(j,nd),
     1    dqscat (j,nd), nd=1,ndust),j=1,nflux)
*
        else if( chPunch(i).eq.'PHYS' ) THEN
          if(chTime.ne.'LAST')
     1    write(ipPnunit(i),'(1x,i4,1p,6e11.3)') nzone,depth,te,hden,
     1    eden, htot,AccelTot
*
        else if( chPunch(i).eq.'PRES' ) then
*         subtract continuum rad pres which has already been added on
          write(ipPnunit(i),'(1x,1p,6e10.2,l3)') depth, pnow,
     2    PressureInit+pinteg, PressureInit, GasPres, RadPres,
     2    pinteg-pinzon, lgPresOK
*
         else if( chPunch(i).eq.'RADI' ) then
           if(chTime.ne.'LAST')
     1     write(ipPnunit(i),'(1x,i4,1p,4e12.4)') nzone,radius,depth,
     1     drad
*
         else if( chPunch(i) .eq. 'RESU' ) then
*           punch results of the calculation
            if(chTime.eq.'LAST')call result( ipPnunit(i) )
*
         else if( chPunch(i).eq.'SOUS') then
*          full spectrum of continuum source function at 1 depth
*          command was "punch source spectrum"
           if(chTime.ne.'LAST')
     1     write(ipPnunit(i),'(1p,5e12.4)') (anu(j),
     1     DiffCont(j)/widflx(j),
     1     opac(j), DiffCont(j)/widflx(j)/max(1e-35,opac(j)) ,
     2     DiffCont(j)/widflx(j)/max(1e-35,opac(j))/plankf(j),
     3     j=1,min(maxcor,nflux))
*
        else if( chPunch(i).eq.'SOUD' ) then
*         parts of continuum source function vs depth
*         command was source depth
          j = ipHn(1) + 2
          write(ipPnunit(i),'(1p,5e12.4)') depabs(j),
     1    DiffCont(j)/widflx(j)/max(1e-35,opac(j)) , otscon(ipHn(1)),
     1    otscon(ipHn(1))/opac(ipHn(1))
*
*       this is punch special option
        else if( chPunch(i).eq.'SPEC' ) then
*        ne does not punch last zone, change to eq to only punch last zone
         call PunSpec(ipPnunit(i),chTime)
*
        else if( chPunch(i).eq.'TEGR' ) then
*         punch history of heating and cooling
          if(chTime.ne.'LAST')write(ipPnunit(i),'(1x,i4,1p,3e11.3)')
     1    (nZonGrid(j),TeGrid(j) , HtGrid(j),ClGrid(j),
     2    j=1,nGrid)
*
        else if( chPunch(i).eq.'TEMP' ) then
*         temperature and its derivative
          write(ipPnunit(i),'(1x,i4,1p,2e12.4)') nzone,te,
     1    (te-tlast)/drad
*
        else if( chPunch(i).eq.'TPRE' ) then
*         temperature and its predictors
          write(ipPnunit(i),'(i5,1p,3e11.4)') nzone, TeInit,TeProp,te
*
        else if( chPunch(i) .eq. 'VERN' ) then
*         work actually done in routine Fe2Lines in KatyaFe2
          continue
*
        else if( chPunch(i).eq.'WIND' ) then
*         wind velocity, radiative accel, and ratio total to e- accel
          write(ipPnunit(i),'(1p,5e12.4)') radius,depth,windv,AccelTot,
     1    fmul
*
        else
*         this is insanity, internal flag set in getpunch not seen here
          write(qq,'('' DOPUNCH does not recognize flag '',a4,
     1    '' set by GETPUNCH.  This is impossible.'')') chPunch(i)
          call ShowMe
          stop
        endif
*       at start of loop, broke to here if not last iteration,
*       and punch last was set
*       throw special line if punching every iteration
        if( chTime.eq.'LAST' .and. .not.lgLastIt ) then
          write(ipPnunit(i),'('' ###########################'')')
        endif
*999  continue
      endif
      end do
*
      end
**************************************************************
      real function AnuUnit( ip )
      implicit none
*produce continuum energy in arbitrary units
      integer ip
      integer limpun
      parameter (limpun=20 )
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      character chPunch*4, chConPunEnr*4
      integer ipConPunEnr
*chPUnch - what is it we want to punch? set in GetPunch, used in DoPunch
*chConPunEnr - units of continuum in punch output
      common/cpunch/ chPunch(limpun) , chConPunEnr(limpun) , ipConPunEnr
      real AnuOrg
*original set of energy units, always the same no matter what the
*shape of the continuum - actual energy units change with shape
      common/anusave/ AnuOrg(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      if( chConPunEnr(ipConPunEnr) .eq. 'ryd ' ) then
*       energy in Ryd
        AnuUnit = AnuOrg(ip)
      else if( chConPunEnr(ipConPunEnr) .eq. 'micr' ) then
*       wavelength in microns
        AnuUnit = rydlam / AnuOrg(ip) * 1e-4
      else if( chConPunEnr(ipConPunEnr) .eq. ' kev' ) then
*       energy in keV
        AnuUnit = AnuOrg(ip) * evryd * 1.e-3
      else if( chConPunEnr(ipConPunEnr) .eq. ' ev ' ) then
*       energy in eV
        AnuUnit = AnuOrg(ip) * evryd
      else if( chConPunEnr(ipConPunEnr) .eq. 'angs' ) then
*       wavelength in Angstroms
        AnuUnit = rydlam / AnuOrg(ip)
      else
        write(qq,'('' insane units in AnuUnit ='',a4)')
     1  chConPunEnr(ipConPunEnr)
        stop
      endif
*
      end
********************************************************************
      real function drecom( nd )
      implicit none
*compute electron recombination onto grains surface
      integer nd
*
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
*
*     local variables
*     electron sticking prob
      real stick
      parameter (stick=1.)
      real psi , eta , sexp , ve , recoef
*
*     coef is qe(esu) / 300 / k to convert potential in volts to PSI
*     in eV here
*     this is defined for impact by electrons
      psi = -1.*(dstpot(nd)*evryd) * 1.1606e4 / te
      if( psi .le.0. ) then
        eta = 1. - psi
      else
        eta = sexp( psi )
      endif
*
*     this is rec coef for neutral grain; corr fac next
*     VE is mean electron velocity
      ve = sqrte * 6.2124e5
*     this is neutral surface recomb rate for electrons
      recoef = ve * eden * stick
*
*     now do charge
      drecom = recoef * eta
*
      end
******************************************************************************
      subroutine cdErrors( io )
      implicit none
*produce summary of all warnings, cautions, etc, on arbitrary io unit
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer io
*
*     local variables
      integer nw,nc,nn,ns, nte, npe
*
*     first check for number of warnings, cautions, etc
      call cdNwcns( nw,nc,nn,ns, nte, npe )
*
      if( nw.ne.0 .or. nc.ne.0 .or. nte.ne.0 .or. npe.ne.0 ) then
        write(io,'(a75)') chTitle
*       print warnings on the io unit
        if( nw.ne.0 ) call warnot( io )
*       print cautions on the io unit
        if( nc.ne.0 ) call caunot( io )
        if( nte.ne.0 ) write(io,'(''Te failures='',i4)') nte
        if( npe.ne.0 ) write(io,'(''Pressure failures='',i4)') npe
      endif
*
      end
******************************************************************************
      subroutine cdDriv( lgOK )
      implicit none
*main routine to call cloudy under all circumstances)
      logical lgOK
***************************************
*     main routine to call cloudy     *
***************************************
      logical lgVaryOn
*flag set true if vary option used
      common/vary/ lgVaryOn
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgReadIn , lgScanar
*flag lgReadIn set if we are to read in line images (cdRead never called)
*flag lsScanar set true in cdInit:w
*lgScanar is not used at all - confirm then remove
      common/readin/ lgReadIn , lgScanar
*
*     fill in input array
      if( lgReadIn ) call fillar
*
      if( lgVaryOn ) then
*       option to drive optimizer
        call drvary
      else
        call cloudy
      endif
*
      if( lgBusted ) then
        lgOK = .false.
      else
        lgOK = .true.
      endif
*
      end
******************************************************************************
      subroutine cdInit
      implicit none
*routine to initialize variables, called at start of calculation
      logical lgReadIn , lgScanar
*flag lgReadIn set if we are to read in line images (cdRead never called)
*flag lsScanar set true in cdInit:w
*lgScanar is not used at all - confirm then remove
      common/readin/ lgReadIn , lgScanar
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      logical lgVaryOn
*flag set true if vary option used
      common/vary/ lgVaryOn
      logical lgOptimr
*flag set true if optimize command entered
      common/optimr/ lgOptimr
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      double precision vtest
*
*     on a VAX compile with /G_FLOATING option on FORTRAN;
*     following makes sure this happened.
      vtest = 1d-35
      vtest = vtest / 1d35
      if( vtest.eq.0. ) write(qq,'('' Somethings wrong with the double'',
     1'' precision.  Use /g_floating on a VAX'')')
*
*     disable underflow by various system calls
*----------------------------------------------------------------------
*     IBM;
*     CALL ERRSET( 208 , 600 , -1 )
*----------------------------------------------------------------------
*     in Sun Unix do
*     CALL MTHTRP
*     in Unix do - - -
*     INTEGER SIGNAL
*     I = SIGNAL( 119 , P , 1 )
*----------------------------------------------------------------------
*     CDC machines
*     INTEGER ISYS(6)
*     DATA ISYS/0,0,0,600,0,20/
*     CALL SYSTEMC( 115 , ISYS )
*     CALL SYSTEMC( 144 , ISYS )
*     CALL SYSTEMC(  35 , ISYS )
*----------------------------------------------------------------------
*
*     if TALK is TRUE then do standard printout
*     if FALSE then never say anything
      lgTalk = .true.
      lgBusted = .false.
      lgVaryOn = .false.
      lgOptimr = .false.
*
*     if lgCalled is TRUE then cloudy is a called subroutine,
*     and it will RETURN in case of catastrophe, and will not read input
*     all input must be specified here in MAIN
*     by accessing the correct com blocks
*
*     if FALSE then unit 5 is read for input, output on 6,
*     and cloudy will stop in case of catastrophe
      lgCalled = .false.
*
      lgReadIn = .true.
      lgScanar = .true.
      nSave = 0
      nRead = 0
*
      end
******************************************************************************
      subroutine cdRead( chLin , nleft )
      implicit none
*routine to read in command lines when cloudy used as subroutine
      character chLin*80
      integer nleft
*
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      logical lgReadIn , lgScanar
*flag lgReadIn set if we are to read in line images (cdRead never called)
*flag lsScanar set true in cdInit:w
*lgScanar is not used at all - confirm then remove
      common/readin/ lgReadIn , lgScanar
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      logical lgOptimr
*flag set true if optimize command entered
      common/optimr/ lgOptimr
      logical lgVaryOn
*flag set true if vary option used
      common/vary/ lgVaryOn
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chCard*80, chLine*80
      integer ilim , i
      logical lgMatch , lgHit
*
*     this is called by user when driving as subroutine
      lgReadIn = .false.
      lgCalled = .true.
*
      nSave = nSave + 1
      if( nSave.lt.nkrd ) then
        nleft = nkrd - nSave
      else
        write(qq,'('' Too many line images entered to cdRead.'',
     1  ''  The limit is'',I5)') nkrd
        stop
      endif
*
*     now kill any part of line image after end of line character,
*     this stops undefined junk from entering after here
      ilim = 81
      lgHit = .false.
      i = 1
      do while( .not.lgHit .and. i.le.80 )
*     >>chng 97 jan 4, get rid of statement number
        chLine(i:i) = chLin(i:i)
        if( chLine(i:i).eq.'%' .or. chLine(i:i).eq.':' .or.
     1    chLine(i:i).eq.';' ) then
          ilim = i + 1
          lgHit = .true.
        endif
        i = i + 1
      end do
*     this loop skipped if no eol character found
      do i=ilim,80
        chLine(i:i) = ' '
      end do
*
      chCard = chLine
      call caps( chCard )
*
*     now check whether VARY is specified
      chCardSav(nSave) = chLine
      chCard = chLine
      call caps( chCard )
      if( lgMatch( 'VARY' , chCard ) ) then
*       a vary flag was on the line image
        lgVaryOn = .true.
      endif
      if( chCard(1:4).eq.'OPTI' ) then
*       optimize command read in
        lgOptimr = .true.
      endif
*
*     possible to have VARY on line without OPTIMIZE being set
      if( lgOptimr.and.lgVaryOn ) then
        lgVaryOn = .true.
      else
        lgVaryOn = .false.
      endif
*
      end
******************************************************************************
      subroutine cdNoex
      implicit none
*call this routine to tell code not to actually execute
      logical lgNoExec
*flag saying no to compute model, just generate continuum and stop
*set with cdNoex call
      common/noexec/ lgNoExec
*
*     this is an option to have the code read in all input quanties
*     not to NOT execute the actual model - to check on input parameters
*
      lgNoExec = .true.
*
      end
******************************************************************************
      subroutine cdGetPres( Pres , rpgas , rprad )
      implicit none
*routine to query results and return pressure of last zone
      real Pres, rpgas , rprad
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
*
      rpgas = GasPres
      rprad = RadPres
      Pres = GasPres + RadPres
*
      end
******************************************************************************
      subroutine cdGetTe( teget )
      implicit none
*routine to query results and return temperature of last zone
      real teget
      real te , eden , hden
      common/phycon/ te , eden , hden
*
      teget = te
*
      end
******************************************************************************
      subroutine cdOutp( iout )
      implicit none
*redirect output to arbitrary Fortran unit number
      integer iout
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      qq = iout
*
      end
******************************************************************************
      subroutine cdTalk( lgTOn )
      implicit none
*tells the code whether to print results or be silent
      logical lgTOn
*
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
*
      lgTalk = lgTOn
*
      end
******************************************************************************
      subroutine wginit
      implicit none
*initialize weighted results option in Cloudy as a subroutine mode
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      real wgsum
      common/wgsum/ wgsum(NLINES)
*
*     local variables
      integer i
*
*     zero out line weighted sum arrays
      do i=1,NLINES
        wgsum(i) = 0.
      end do
*
      end
******************************************************************************
      subroutine wgline( chLabel , length , relint , absint , lgOK )
      implicit none
*read line predictions when code used as subroutine with co-added weights
      logical lgOK
      character*4 chLabel
      integer length
      real relint , absint
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      real wgsum
      common/wgsum/ wgsum(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      integer nsumtt
      common/nsumtt/ nsumtt
*
*     local variables
      integer ipobs , j
      character*4 chCaps , chFind
*
*     change chLabel to all caps
      call cap4( chLabel , chFind )
      do j=1,nsumtt
*       change chLabel to all caps to be like input chAmLab
        call cap4( chALab(j) , chCaps )
*       check wavelength and chLabel for a match
        if(lin(j).eq.length .and.chCaps.eq.chFind) then
*         match, so set pointer
          ipobs = j
          relint = wgsum(ipobs)/wgsum(NormWL)*sclnrm
          if( wgsum(ipobs).gt.0. ) then
            absint = log10(wgsum(ipobs)) + pirsq
          else
            absint = 0.
          endif
          lgOK = .true.
          return
        endif
      end do
*
      lgOK = .false.
      absint = 0.
      relint = 0.
*
      end
******************************************************************************
      subroutine wgadd( weight )
      implicit none
*add the current model with arbitrary weight to stack of models
*used in subroutine mode
      real weight
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      real wgsum
      common/wgsum/ wgsum(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsumtt
      common/nsumtt/ nsumtt
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer j
*
*     check that entered weight is ok
      if( weight.le.0. ) then
         write(qq,'('' The weight entered into WDAGG,'',1P,E10.2,
     1   '' is not proper.  Sorry.'')')
         stop
      endif
*
*     add in weighted lines
      do j=1,nsumtt
        wgsum(j) = wgsum(j) + sumlin(j)*weight
      end do
*
      end
******************************************************************************
      subroutine cdLine( chLabel , length , relint , absint , lgOK )
      implicit none
*get the predicted line intensity
      integer length
      real relint , absint
      logical lgOK
      character*4 chLabel
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      integer nsumtt
      common/nsumtt/ nsumtt
*
*     local variables
      character*4 chCaps , chFind
      integer j , ipobs
*
*     change chLabel to all caps
      call cap4( chLabel , chFind )
      do j=1,nsumtt
*       change chLabel to all caps to be like input chAmLab
        call cap4( chALab(j) , chCaps )
*       check wavelength and chLabel for a match
        if(lin(j).eq.length .and.chCaps.EQ.chFind) then
*         match, so set pointer
          ipobs = j
          if( sumlin(NormWL).gt.0.) then
            relint = sumlin(ipobs)/sumlin(NormWL)*sclnrm
          else
            relint = 0.
          endif
          if( sumlin(ipobs).gt.0. ) then
            absint = log10(sumlin(ipobs)) + pirsq
          else
*           line intensity is actually zero, return small number
            absint = -37.
          endif
          lgOK = .true.
          return
        endif
      end do
*
      lgOK = .false.
      absint = 0.
      relint = 0.
*
      end
******************************************************************************
      subroutine cdEms( chLabel , length , emiss , lgOK )
      implicit none
*obtain the local emissivity for a line, for the last computed zone
      logical lgOK
      character*4 chLabel
      integer length
      real emiss
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      integer nsumtt
      common/nsumtt/ nsumtt
*
*     local variables
      character*4 chCaps , chFind
      integer j
*
*     routine returns the emissivity in the desired line
*     only used internally by the code, to do punch lines structure
*
*     change chLabel to all caps
      call cap4( chLabel , chFind )
      do j=1,nsumtt
*       change chLabel to all caps to be like input chAmLab
        call cap4( chALab(j) , chCaps )
*       check wavelength and chLabel for a match
        if(lin(j).eq.length .and.chCaps.EQ.chFind) then
*         match, so set emiss to emissivity in line
          emiss = emslin(j)
          lgOK = .true.
          return
        endif
      end do
*
      lgOK = .false.
*
      end
*********************************************************************
      subroutine cdColm( chLabell , ion , theocl , lgOK )
      implicit none
*get the column density for a constituent
      logical lgOK
      integer ion
      character*4 chLabell
      real theocl
*
      integer limelm
      parameter (limelm=30)
      character chElNames*4
      common/ElNames/ chElNames(limelm)
*     xIonMeans(nelem, stage,type)
*     stage=0 is integrated sum of all
*     type = 1 is radius integration, 2=vol
      real xIonMeans
      common/IonMeans/ xIonMeans(limelm,0:limelm+1,2)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nelem
      character*4 chLabel
      character*80 chCard
*
*     first ensure that chLabel is all caps
      chCard(1:4) = chLabell
      call caps( chCard )
      chLabel = chCard(1:4)
*
*     find which element this is
      nelem = 1
      do while (nelem.le.limelm .and. chLabel.ne.chElNames(nelem) )
        nelem = nelem + 1
      end do
      if( nelem.gt.limelm ) then
        write(qq,'('' cdColm called with unknown element chLabel, ='',
     1  a4)')chLabel
        lgOK = .false.
        return
      endif
*
*     sanity check - does this ionization stage exist?
      if( ion.gt.nelem+1 ) then
        write(qq,'('' cdColm asked to return ionization stage'',i4,
     1  '' for element '',a4,'' but this is not physical.'')') ion,
     2  chLabel
        lgOK = .false.
      endif
*
      theocl = xIonMeans(nelem,ion,1)
*
      lgOK = .true.
*
      end
*********************************************************************
      subroutine cdIonf( chLabelIn , ionIn , fracin , chWghtIn ,lgOK )
      implicit none
*get ionization fractions for a constituent
      logical lgOK
      character chLabelIn*4 , chWghtIn*6
      character chLabel*4 , chWght*6
      integer ion , ionIn
      real fracin
*
*     include "colden.exp"
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      integer limelm
      parameter (limelm=30)
      character chElNames*4
      common/ElNames/ chElNames(limelm)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nelem, ip
      real aaa(limelm+1)
      logical lgVol
      character*80 chCard
      character chLab6*6
*
      chLabel = chLabelIn
       chWght = chWghtIn
          ion = ionIn
*
      lgOK = .true.
*     make sure chWght is all caps
      chCard(1:6) = chWght
      call caps(chCard)
      chLab6 = chCard(1:6)
      if( chLab6.eq.'RADIUS' ) then
        lgVol = .false.
      else if( chLab6.EQ.'VOLUME' ) then
        lgVol = .true.
      else
        lgOK = .false.
        write(qq,'('' CDIONF: chWght='',A6,'' makes no sense to me'')')
     1  chWght
        fracin = 0.
        return
      endif
*
*     first ensure that chLabel is all caps
      chCard(1:4) = chLabel
      call caps( chCard )
      chLabel = chCard(1:4)
*
*     find which element this is
      nelem = 1
      do while (nelem.le.limelm .and. chLabel.ne.chElNames(nelem) )
        nelem = nelem + 1
      end do
      if( nelem.gt.limelm ) then
        write(qq,'('' cdIonf called with unknown element chLabel, ='',
     1  a4)')chLabel
        lgOK = .false.
        return
      endif
*
*     sanity check - does this ionization stage exist?
      if( ion.gt.nelem+1 ) then
        write(qq,'('' CDIONF asked to return ionization stage'',i4,
     1  '' for element '',a4,'' but this is not physical.'')') ion,
     2  chLabel
        lgOK = .false.
      endif
*
      if( lgVol ) then
        call VolMean( nelem , ip , aaa )
        fracin = 10.**aaa(ion)
      else
        call RadMean( nelem , ip , aaa )
        fracin = 10.**aaa(ion)
      endif
*
      lgOK = .true.
*
      end
******************************************************************************
      subroutine cdNwcns( nw,nc,nn,ns,nte,npe)
      implicit none
*get the number of cautions and warnings, to tell if calculation is ok
      integer nw,nc,nn,ns , nte , npe
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      real failmx
*     info related to the number of temperature or pressure failures
*     failmx is largest relative error in heating cooling match
*     nPreFail is number of pressure failuers
      integer nfail , nPreFail
      common/nfail/ nfail , failmx , nPreFail
*
*     this sub is called after comment, to find the number of various comments
      nw = nwarn
      nc = ncaun
      nn = nnote
      ns = nbang
      nte = nfail
      npe = nPreFail
*
      end
******************************************************************************
      subroutine driver( chCard )
      implicit none
*parse the drive command - drive calls to various subs
      character chCard*80
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      logical lgPtrace
*flag set with drive pointers command
      common/PltTrace/ lgPtrace
      logical lgDriveMole
*flag set when drive molecule command entered
      common/moldrv/ lgDriveMole
      integer limelm
      parameter (limelm=30)
      real solar
      common/solar/ solar(limelm)
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      real fread
      logical lgEOL , lgMatch
*
*     local variables
      integer i , ierror
      real zed , fac , conpmp
*
*     option to drive cloudy, which one?
      if( lgMatch( 'FREA' , chCard ) ) then
        ierror = 0
        write(qq,'('' FREAD driver entered.  Enter number.'')')
        do while( ierror.eq.0 )
          read(5,'(a80)',iostat=ierror ) chCard
*         drive function FREAD
          if( ierror.eq.0 ) then
            i = 1
            fac = fread( chCard , i , 76 , lgEOL )
            if( lgEOL ) then
              write(qq,'('' FREAD hit the EOL with no value, return='',
     1        1P,e10.2)')fac
              ierror = 1
            else
              write(qq,'('' FREAD returned with value'',1P,E11.4)') fac
            endif
            write(qq,'('' Enter 0 to stop, or another value.'')')
          endif
        end do
        write(qq,'('' FREAD driver exits.'')')
*
      else if( lgMatch( 'ESCA' , chCard ) ) then
*        option to drive escape probability routines
         call descap( chCard )
*
      else if( lgMatch( 'HYAS' , chCard ) ) then
*        option to drive Jason's hydrogen transition probabilities
         call DrvHyas( chCard )
*
      else if( lgMatch( 'GAUN' , chCard ) ) then
*        drive gaunt factor routine
         call dgaunt( chCard )
*
      else if( lgMatch( 'POIN' , chCard ) ) then
*        later on, check cell pointers, centers, widths
         write(qq,'('' Define entire model first, later I will ask '',
     1   ''for energies.'')')
         lgPtrace = .true.
*
      else if( lgMatch( 'MOLE' , chCard ) ) then
*        option to test molecule subroutine
         write(qq,'('' Define entire model first, later I will ask '',
     1   ''for molecule abundances.'')')
         lgDriveMole = .true.
*
      else if( lgMatch( 'PUMP' , chCard ) ) then
        ierror = 0
        write(qq,'('' Continuum pump driver entered - Enter log tau'')')
        do while( ierror.eq.0 )
          read(5,'(a80)',iostat=ierror ) chCard
*         get tau
          if( ierror.eq.0 ) then
            i = 1
            fac = fread( chCard , i , 76 , lgEOL )
            if(lgEOL) ierror = 1
            fac = 10.** fac
            write(qq,'('' Tau ='',1P,E11.4)') fac
            TauDummy(1) = fac
            fac = conpmp( TauDummy )
            write(qq,'('' conpmp ='',1P,E11.4)') fac
            write(qq,'('' Enter null to stop, or another value.'')')
          endif
        end do
        write(qq,'('' ConPmp driver exits.'')')
*
      else if( lgMatch( 'STAR' , chCard ) ) then
*        get starburst abundances
         do i=1,40
           zed = float(i) / 4. + 0.01
           write(chCard,'(''starburst, zed='',f10.4)') zed
           call strbst(chCard)
           write(qq,'(1p,31e8.1)') zed,solar
         end do
      else
        write(qq,'('' Unrecognized key; keys are FREAD, GAUNT, '',
     1  ''HYAS, POINT, MOLE, STAR, and ESCApe.  Sorry.'')')
        stop
      endif
*
      end
******************************************************************************
      subroutine DrvHyas( chCard )
      implicit none
*allow user to query hydrogen A's, asks for up, low level, gives A
      character chCard*80
*
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      logical lgEOL
      integer i , ihi , low , ierror
      real fread , EinstA
*
*     this routine is entered with the command DRIVE HYAS, and
*     drives Jason's hydrogen einstein A routines
*
      ierror = 0
      do while( ierror.eq.0 )
*     >>chng 96 july 7, got rid of statement labels, new do while
*999  continue
        write(qq,'('' Enter two quantum numbers, null line to stop.'')')
        read(5,'(A80)',iostat=ierror) chCard
        i = 1
        low = fread( chCard , i , 76 , lgEOL )
        if( ierror.ne.0 .or. lgEOL ) then
          write(qq,'('' Driver exits, enter next line.'')')
          return
        endif
        ihi = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' must be two numbers!'')')
        endif
        write(qq,'('' A('',i3,'',''i3,'')='',1p,e11.3)')
     1  min(low,ihi) , max(low,ihi),EinstA(low,ihi)
*
      end do
      write(qq,'('' Driver exits, enter next line.'')')
*
      end
********************************************************************
      subroutine dtempr
      implicit none
*compute grains temperature, heating
      integer ndems
      parameter (ndems=50)
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real DustPhotoE
*difference between photon energy and work function for grains
      common/dnu/ DustPhotoE(ncell,ndust)
      real yn
      common/yn/ yn(ncell,ndust)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgDustBug
*flag set with trace grains command
      common/dstbug/ lgDustBug
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real tgrmax
      common/tgrmax/ tgrmax(ndust)
      real tedust
      common/tedust/ tedust(ndust)
      real dustp,eev, sab,sse,darea, dsize
      integer ndpts
      common/dust/ dustp(4,ndust),eev(limcrs,ndust),
     z sab(limcrs,ndust),sse(limcrs,ndust),ndpts(ndust),darea(ndust),
     z dsize(ndust)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer ipdpot
      common/ipdpot/ ipdpot(ndust)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real yhat
      common/yhat/ yhat(ncell,ndust)
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real dsttmp , dstems , dstslp
      common/dustems/ dsttmp(ndems) , dstems(ndems,ndust) ,
     1 dstslp(ndems,ndust)
      real DustHeatLya , dstpow , dstsum , dincon,dstotl,dhcol,HDustDif
*     HDustDif is heating of grains in current zone due to diffuse fields
*DustHeatLya is heating of dust due to Lya
      common/dhla/ DustHeatLya , dstpow , dstsum , dincon ,dstotl,dhcol,
     1 HDustDif
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgDHetOn , lgDColOn
*lgDHetOn turned off with grain no heating
*lgDColOn turned off with grain no cooling
      common/dheton/ lgDHetOn , lgDColOn
      real dheat
*grain heating rate for this zone
      common/dustheat/ dheat(ndust)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real DustCoolGas
*dust cooling the gas by collisions
      common/dclgas/ DustCoolGas
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
*     >>chng 96 nov 30, add quantum heating from Kevin Volk
      logical lgQHeat
*Kevin Volk add for quantum heating of grains
      common/qheat/ lgQHeat(ndust)
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nd , i
      real hcon , hots,dtherm,phi,hla,dcheat,dccool,x,y,sum1
      real eyhat(ncell,ndust) , ted1, qtmax0, tqhout
*
      DustCoolGas = 0.
      do nd=1,ndust
         if( lgDustOn1(nd) ) then
*        find heating
*        add on fractional bit
         hcon = 0.
         hots = 0.
*        integrate over incident continuum for non-ionizing energies
         do i=1,ipdpot(nd)-1
*          direct heating by incident continuum
           hcon = hcon + flux(i) * anu(i) * dstab1(i,nd)
           hots = hots + SummedDif(i) * anu(i) * dstab1(i,nd)
         end do
*        hcon is radiative heating by NON-ionizing radiation
         hcon = hcon * en1ryd * hden * dstAbund(nd)
         hots = hots * dstAbund(nd)
*
*        integrate over ionizing continuum; energy goes to dust and gas
*        dheat is what heats the gas
         dheat(nd) = 0.
*        dtherm is part of h.nu-IP which heats dust before ejection
         dtherm = 0.
         do i=ipdpot(nd) ,nflux
           eyhat(i,nd) = 0.5 * yn(i,nd) * min( DustPhotoE(i,nd)  ,
     1     max(0., DustPhotoE(i,nd)**2 - (dstpot(nd))**2) /
     2     DustPhotoE(i,nd))
*          this is inciident continuum heating
           phi = flux(i) * dstab1(i,nd) * dstAbund(nd)
*          dtherm is part of h.nu-IP which heats dust before ejection
           dtherm = dtherm + phi * ( anu(i) - eyhat(i,nd) )
*          this is heating by all diffuse fields:
*          SummedDif has all continua and lines
           sum1 = SummedDif(i) * dstab1(i,nd) * dstAbund(nd)
           hots = hots + sum1 * (anu(i) -eyhat(i,nd))
*          dheat is rate grain photoionization heats the gas
           yhat(i,nd) = yn(i,nd) * min(1.,
     1     max(0.,1. - dstpot(nd)/DustPhotoE(i,nd) ) )
           dheat(nd) = dheat(nd) +
     1     SummedCon(i)*dstab1(i,nd) * dstAbund(nd) *
     1     (eyhat(i,nd) - dstpot(nd)*yhat(i,nd) )
         end do
*        write(68,'('' nzone='',i5)') nzone
*        do i=1,nflux
*          if( SummedDif(i)*dstab1(i,nd)*anu(i).gt.0.004*hots )
*    1     write(68,'(1p,10e10.2)') anu(i),
*    1     SummedDif(i)*dstab1(i,nd)*anu(i)/hots
*        end do
*        hots is total heating of the grain by diffuse fields
         hots = hots * en1ryd * hden
*        write(67,'(i4,1p,10e10.2)') nzone,hots, hla
*        dtherm is part of h.nu-IP which heats dust before ejection
         dtherm = dtherm * hden * en1ryd
*        dheat is what heats the gas
         if(lgDHetOn) then
           dheat(nd) = dheat(nd) * hden * en1ryd
           heating(1,14) = heating(1,14) + dheat(nd)
         else
           heating(1,14) = 0.
           dheat(nd) = 0.
         endif
*
*        find power absorbed by dust and resulting temperature
*        DustHeatLya - total heating by LA in this zone, erg cm-3 s-1, only here
*             for eventual printout, hots is total ots line heating
*        DTOTLA - integrated destroyed LA, erg s-1
*
*        heating by Ly A on dust in this zone, and total LA heating
*        only used for printout; Ly-a is already in OTS fields
         hla = otslin(iphl(2,1)) * dstab1(iphl(2,1),nd)*0.75*en1ryd*
     1   hden * dstAbund(nd)
         DustHeatLya = DustHeatLya + hla
*        if( hla.gt.0. ) write(67,'(i4,1p,10e10.2)') nzone,
*    1   otscon(iphl(2,1))*dstab1(iphl(2,1),nd)*0.75*en1ryd*hden/hla,
*    1   otslin(iphl(2,1))*dstab1(iphl(2,1),nd)*0.75*en1ryd*hden/hla,
*    2   outcon(iphl(2,1))*dstab1(iphl(2,1),nd)*0.75*en1ryd*hden/hla,
*    1   outlin(iphl(2,1))*dstab1(iphl(2,1),nd)*0.75*en1ryd*hden/hla
*        hoth was heating due to all other cooling lines in LINDST
*        >>chng 96 apr 26, this with line heating twice,
*        since already in SummedCon
*        hoth = dstoth * dstab1(iphl(3,2),nd)/dstab(iphl(3,2))
*
*        heating by thermal collisions with gas does work
*        factor of 1e8 is sqrt(8k/pi m_H)2k/4*1e20
*        DCHEAT is grain collisional heating by gas
*        DCCOOL is gas cooling due to collisions with grains
*        they should wqual each other
         call dcolid( dcheat , dccool , nd )
*
*        this will be total collisional heating, for printing in lines
         dhcol = dhcol + dcheat
*
*        dust often hotter than gas during initial TE search
         if( nzone.le.2 ) dcheat = max( 0. , dcheat )
*
*        hcon is heating from incident continuum by non-ionizing radiation
*        hots is heating from ots continua and lines
*        dcheat is grain collisional heating by gas
*        dtherm is part of h.nu-IP which heats dust before ejection,
*           this is only direct heating by ionizing radiation
*
*        dstsum is total heating of this grain type, to be balanced by cooling
*        dstsum is the grain heat input - this is the actual number entering
*        the energy balance
         dstsum = hcon + hots + dcheat + dtherm
*        if( dstsum.gt.0. )write(66,'(i4,1p,10e10.2)') nzone,
*    1   hcon/dstsum , hots/dstsum , dcheat/dstsum , dtherm/dstsum
*
*        following used to keep track of heating agents in printout
*        no physics done with dincon
*        dust heating by incident continuum, and elec friction before ejection
         dincon = dincon + hcon + dtherm
         HDustDif = HDustDif + hots
*
*        dstotl is total heating of all grain types in this zone,
*        will be carried by total cooling, only used in lines to print tot heat
*        printed as entry "GraT    0 "
         dstotl = dstotl + dstsum
*        remember total heating by diffuse fields, for printout
         HDustDif = HDustDif + dcheat
*
*        >>chng 96 nov 30, add Kevin Volk's quantum heating
*        (K Volk) added calculation of QTCOL here
         if(lgQHeat(nd)) then
           if (dcheat.gt.0.) then
             qcu1=dcheat*4.5911e+10*4.
*            QCU1 is the total grain collisional heating rate
*            in rydberg/s/H atom
*            DCHEAT is in erg/s/H atom; factor 4 for the entire surface, factor
*            4.5911e+10 to convert to rydberg energy units
*            change, 97 july 17, div by dstAbund due to variable abundances
             x = log10(dcheat/hden/dstAbund(nd))
             if( x.lt.dstems(1,nd) ) then
               qtcol = 10.**dsttmp(1)
               qcu1 = hden*(10.**dstems(1,nd))*4.5911e+10*4. *
     1         dstAbund(nd)
*              correct qtcol and qcu1 to the minimum values
*              if the collisional heating rate is very low;
*              otherwise the quantum heating routines fail since some of the
*              temperature bins are out of range of the dstems array.
*              This will produce erroneous results if both the
*              collisional and quantum heating rates are very low.
             else if( x.gt.dsttmp(ndems) ) then
               qtcol = 10.**dsttmp(ndems)
             else
               call splint( dstems(1,nd),dsttmp,dstslp(1,nd),ndems,x,y)
               qtcol = 10.**y
             endif
           else
             qtcol=1.0
           end if
         end if
*        End of changes here (K Volk)
*
*        now find temperature, dstsum is sum of total heating of grain
*        >>chng 97 july 17, divide by abundance here
         x = log10( max(1e-37, dstsum/hden/dstAbund(nd) ) )
         if( x.lt.dstems(1,nd) ) then
           tedust(nd) = 10.**dsttmp(1)
*          >>chng 96 apr 27, as per Peter van Hoof comment
         else if( x.gt.dstems(ndems,nd) ) then
           tedust(nd) = 10.**dsttmp(ndems)
         else
           call splint( dstems(1,nd) , dsttmp , dstslp(1,nd),ndems,x,y)
           tedust(nd) = 10.**y
         endif
*       >>chng 96 nov 30, add Kevin Volk quantum heating
*       Save the equilibrium temperature for possible print-out when the
*       quantum heating is asked for. (K Volk)
         tequil1(nd)=tedust(nd)
*
*        if qheat is set do the quantum heating calculation.
*        test qtmax first, and adjust if needed.
         if (lgQHeat(nd)) then
            ted1=tedust(nd)
*           use this value if something strange happens in qheat1
            if (qtmax.lt.5.*tedust(nd)) then
                qtmax0=qtmax
                qtmax=min(20.*tedust(nd),5000.)
                call qheat1(nd,tqhout,ted1)
                qtmax=qtmax0
            else
                call qheat1(nd,tqhout,ted1)
            end if
            tedust(nd)=tqhout
         end if
*        end of changes here (K Volk)
*        save for latter possible printout
         tgrmax(nd) = max( tgrmax(nd) , tedust(nd) )
*        rate dust cools gas by collisions
         if( lgDColOn ) then
*          dccool is gas cooling due to collisions with grains
           DustCoolGas = DustCoolGas + dccool
         endif
*
         if( lgTrace.and.lgDustBug ) then
           write(qq,'(1x,''DTEMPR finds'',I2,'' Tdst'',1p,e9.2,
     1     '' totHeat'',e9.2,'' Cont;'',e9.2,'' OTS;'',e9.2,
     2     '' HIIcol:'',e9.2,'' pho ej;'',e9.2,'' dheat'',e9.2)')
     3     nd , tedust(nd) , dstsum , hcon/dstsum ,
     4     hots/dstsum , dcheat/dstsum,dtherm/dstsum , dheat(nd)
           if( lgQHeat(nd) ) write(qq,'('' DTEMPR: QHEAT1 found'',
     1     '' tqhout, ted1='',1p,2e10.2)') tqhout , ted1
         endif
         endif
      end do
*
*     if grains hotter than gas then collisions with gas act
*     to heat the gas, add this in here
*     a symmetric statement appears in COOLR, where cooling is added on
      if(lgDHetOn) then
        heating(1,15) = max(0.,-DustCoolGas )
      else
        heating(1,15) = 0.
      endif
*
      end
******************************************************************************
      subroutine DumpLine( t )
      implicit none
*print various information about an emission line vector, used in debugging
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real t(nta)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real TexcLine
      character chLineLbl*10 , chLbl*10
*     routine to print contents of line arrays
      chLbl =  chLineLbl(t)
      write(qq,'('' Dump of '',a10,'' te, eden='',1p,
     1 2e10.3,'' CS='',e8.2,'' Aul='',e8.2,'' Texc='',e10.4,
     2 '' cool,heat='',2e10.2)')
     2 chLbl,te,eden,t(ipLnCS),t(ipLnAul), TexcLine(t),
     3 t(ipLnCool) , t(ipLnHeat)
*
      write(qq,'(''  Tin'',1p,e9.2,'' Tout'',e9.2,'' EscP'',e9.2,
     1 '' DesP'',e9.2,'' Pump'',e9.2,'' OTS '',e9.2,'' PopL,U'',2e9.2)')
     1 t(ipLnTauIn),t(ipLnTauTot),t(ipLnEscP),t(ipLnDesP),t(ipLnPump),
     2 t(ipLnOTS), t(ipLnPopl) , t(ipLnPopu)
*
      end
**************************************************************************
      subroutine dustop
      implicit none
*initialize grains opacity at start of calculation
      integer ndems
      parameter (ndems=50)
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real dsttmp , dstems , dstslp
      common/dustems/ dsttmp(ndems) , dstems(ndems,ndust) ,
     1 dstslp(ndems,ndust)
      real DustPhotoE
*difference between photon energy and work function for grains
      common/dnu/ DustPhotoE(ncell,ndust)
      real dustp,eev, sab,sse,darea, dsize
      integer ndpts
      common/dust/ dustp(4,ndust),eev(limcrs,ndust),
     z sab(limcrs,ndust),sse(limcrs,ndust),ndpts(ndust),darea(ndust),
     z dsize(ndust)
      character chDstLab*10
*     labels for types of dust grains
      common/dstlab/ chDstLab(ndust)
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      logical lgDustBug
*flag set with trace grains command
      common/dstbug/ lgDustBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      real dqabs, dqscat
      common/dqs/ dqabs(ncell,ndust) , dqscat(ncell,ndust)
      real yn
      common/yn/ yn(ncell,ndust)
      integer idwork
      common/idwork/ idwork(ndust)
      real DustWorkFcn
*work function (Ioniz pot) of various grain species
      common/dwork/ DustWorkFcn(ndust)
      real GrainMetal
*factor depleting grain abundances from grain on metals command, usually 1
      common/grmetl/ GrainMetal
      integer ndston , ipdon
      common/ndston/ ndston , ipdon(ndust)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real ydheat , y0 , y1
      parameter (ydheat=0.5 , y0=0.5 , y1=0.2)
      integer nd , i , j , k
      character chLab(ndust)*10
      real fac,crsdst,tdust,dintg , dst1(ndust), dst2(ndust) ,
     1 GrnVryDpth
*
*     free statement numbers >=19
*
      if( lgDustBug.and.lgTrace ) then
        write(qq,'(5X,''DUSTOP called with log grain depletion '',
     1  ''factors, dstfactor='')')
        write(qq,'(1p,10e10.2)') dstfactor
        write(qq,'(5X,''lgDustVary flag for depth dependence.'')')
        write(qq,'(1p,10l2)') lgDustVary
      endif
*
      ndston = 0.
      if( lgDustOn ) then
        do nd=1,ndust
          if( lgDustOn1(nd) ) then
*           counter for those dusts which are actually on
            ndston = ndston + 1
            ipdon(ndston) = nd
*           this is total grain depletion factor, GrainMetal is depletion
*           set with metals command, normally one
            dstfactor(nd) = dstfactor(nd) * GrainMetal
*           this will be actual abundance of grains used in calculation
            dstAbund(nd) = dstfactor(nd) * GrnVryDpth(nd)
*           this is effective area per proton, scaled by depletion
*           dareff(nd) = darea(nd) * dstAbund(nd)
            do i=idwork(nd),nupper
              DustPhotoE(i,nd) = anu(i) - DustWorkFcn(nd)
*             dust photo yield, from Draine 78
              yn(i,nd) = min( y1 , y0 *
     1        max( 0. , ( 1.-DustWorkFcn(nd)/anu(i) )))
            end do
            do i=1,nupper
*             absorption part of total dust opacity, then efficiency
              dstab1(i,nd) = crsdst( anu(i) , nd , 'ABSO' )
              dqabs(i,nd) = dstab1(i,nd) * 4. / darea(nd)
            end do
*
            do i=1,nupper
*             scttering  part of total dust opacity, then efficiency
              dstsc1(i,nd) = crsdst( anu(i) , nd , 'SCAT' )
              dqscat(i,nd) = dstsc1(i,nd) * 4. / darea(nd)
            end do
          else
*           >>chng 96 apr 26, zero out non-present species for safety
            do i=1,nupper
              dstab1(i,nd) = 0.
              dstsc1(i,nd) = 0.
            end do
          endif
        end do
      else
*        this branch dust not on - zero opacities
         do nd=1,ndust
            do i=1,nupper
               dstab1(i,nd) = 0.
               dstsc1(i,nd) = 0.
            end do
         end do
         do i=1,nupper
            dstab(i) = 0.
            dstsc(i) = 0.
         end do
         return
      endif
*
*
      do i=1,nupper
        dstab(i) = 0.
        dstsc(i) = 0.
      end do
*
      do nd=1,ndust
        if( lgDustOn1(nd) ) then
          do i=1,nupper
*           these are total absorption and scattering cross sections
            dstab(i) = dstab(i) + dstab1(i,nd) * dstAbund(nd)
            dstsc(i) = dstsc(i) + dstsc1(i,nd) * dstAbund(nd)
          end do
        endif
      end do
*
      if( lgDustBug.and.lgTrace ) then
*        >>chng 96 nov 30, two line format since soo many grains
         nd = 0
         do i=1,ndust
           if( lgDustOn1(i) )then
             nd = nd + 1
             chLab(nd) = chDstLab(i)
           endif
         end do
         write(qq,'('' There are'',i3,'' possible forms of grains in'',
     1   '' the calculation, and'',i3'' are turned on.  Their names '',
     2   '' are:'')') ndust, nd
         write(qq,'(10(1x,a10,'':'',l1))')
     1   (chDstLab(i),lgDustOn1(i),i=1,ndust)
         write(qq,'(5X,''NU(Ryd), Cross sec per proton, yield'')')
         write(qq,'(''    Ryd  '',6(A10,8X))') (chLab(i),i=1,nd)
         do i=1,nupper,40
           nd = 0
           do j=1,ndust
             if( lgDustOn1(j) )then
               nd = nd + 1
               dst1(nd) = dstab1(i,j)
               dst2(nd) = yn(i,j)
             endif
           end do
*          write(qq,'(1P,14E9.2)') anu(i),(dstab1(i,k),yn(i,k),k=1,
*    1     ndust) , dstab(i)
           write(qq,'(1P,14E9.2)') anu(i),(dst1(k),dst2(k),k=1,nd),
     1     dstab(i)
         end do
         write(qq,'(5X,''NU(Ryd), Cross sec per proton, total sct'')')
         write(qq,'(''    Ryd  '',9A10)') (chLab(i),i=1,nd)
         do i=1,nupper,40
           nd = 0
           do j=1,ndust
             if( lgDustOn1(j) )then
               nd = nd + 1
               dst1(nd) = dstsc1(i,j)
             endif
           end do
           write(qq,'(1P,10E9.2)') anu(i),(dst1(k),k=1,nd),dstsc(i)
         end do
         write(qq,'(5X,''NU(Ryd), Q abs, scat'')')
         write(qq,'(''    Ryd    '',6(A10,10X))') (chLab(i),i=1,nd)
         do i=1,nupper,40
           nd = 0
           do j=1,ndust
             if( lgDustOn1(j) )then
               nd = nd + 1
               dst1(nd) = dqabs(i,j)
               dst2(nd) = dqscat(i,j)
             endif
           end do
           write(qq,'(1P,13E10.3)') anu(i),(dst1(k) , dst2(k),k=1,nd)
         end do
      endif
*
*     now find dust emissivity from Kirchoff's law
      fac = 10.**( log10(1.2e9 / 2.) / float(ndems-1) )
      tdust = 2. / fac
      if(lgTrace.and.lgDustBug) write(qq,'(4X,''ND'',3X,''Tdust'',5X,
     1 ''Emis'',5X,''Emis/BB/sigma'')')
      do i=1,ndems
        tdust = tdust * fac
        dsttmp(i) = log10( tdust )
        do nd=1,ndust
          if( lgDustOn1(nd) ) then
*           >>chng 97 apr 25, protect against underflow when very small opacity
            dstems(i,nd) = log10( max(1e-30,dintg( tdust , nd , i ) ) )
          endif
        end do
      end do
*
*     now find slopes form spline fit
      do nd=1,ndust
        if( lgDustOn1(nd) ) then
*       set up coefficients for spline
          call spline( dstems(1,nd) , dsttmp , ndems , 2e31,2E31,
     1    dstslp(1,nd) )
        endif
      end do
*
      if(lgTrace.and.lgDustBug) write(qq,'(4X,''DustOp returns'')')
*
      end
******************************************************************************
      real function e2( t , tln )
      implicit none
*second exponential integral
*
*     local variables
      real t , tln , remain
*
*     fit of second exponential integral;
*     T is optical depth, and TLN is exp(-t)
*
      if( t.lt.0.3 ) then
        remain = (1.998069357+t*(66.4037741+t*107.2041376)) /
     1  (1.+t*(37.4009646+t*105.0388805))
*
      else if( t.lt.20. ) then
        remain = (1.823707708+t*2.395042899)/
     1  (1.+t*(2.488885899-t*0.00430538))
*
      else
        remain = 1.
      endif
*
      e2 = remain * tln / (2.+t)
*
      end
******************************************************************************
      real function ee1(x)
      implicit none
*first exponential integral
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     computes the exponential integral E1(x),
*     from abramowitz and stegun
*
      real x,a(6),b(4),c(4),ans,top,bot,alog
      data a/-.57721566,.99999193,-.24991055,.05519968,
     1 -.00976004,.00107857/
      data b/8.57332874,18.059016973,8.634760893,.267773734/
      data c/9.573322345,25.632956149,21.099653083,3.95849692/
*
      if(x.le.0) then
        write(qq,'('' Problem in function ee1, x<0'')')
        stop
      endif
*
      if(x.lt.1.) then
        ans = a(1) + a(2)*x + a(3)*x*x + a(4)*x**3 + a(5)*x**4
     1      + a(6)*x**5 - alog(x)
      endif
*
      if(x.ge.1.) then
        top = x**4 + b(1)*x**3 + b(2)*x*x + b(3)*x + b(4)
        bot = x**4 + c(1)*x**3 + c(2)*x*x + c(3)*x + c(4)
        ans = top/bot/x
      endif
*
      ee1 = ans
      end
******************************************************************************
      real function ehe12p( freq )
      implicit none
*two photon emission from helium singlets
      real freq
      integer ncrs
      parameter (ncrs=21)
      real ener(ncrs) , crs(ncrs)
      real  y2(ncrs) , y
      logical lgFirst
      save lgFirst , ener , crs , y2
*
      data ener/ 0. , 0.03738 , 0.07506 , 0.1124 , 0.1498 , 0.1875 ,
     1 0.225 , 0.263, 0.300   , 0.3373  , 0.375  , 0.4127 , 0.4500 ,
     2 0.487 , 0.525, 0.5625  , 0.6002  , 0.6376 , 0.6749 , 0.7126 ,
     3 0.75  /
*
      data crs/ 0.  , 5.03    , 8.09    , 10.16  , 11.52  ,  12.52 ,
     1 13.25 , 13.70,   14.02 , 14.25   , 14.27  , 14.25  ,  14.02 ,
     2 13.70 , 13.25,   12.52 , 11.52   , 10.16  , 8.09   ,   5.03 ,
     3 0. /
*
      data lgFirst/.true./
*
      if( lgFirst ) then
*       set up coefficients for spline
        call spline( ener , crs , ncrs , 2e31,2e31, y2 )
        lgFirst = .false.
      endif
*
      if( freq.lt.0. .or. freq.ge.1.56 ) then
        ehe12p = 0.
      else
        call splint( ener , crs , y2 , ncrs , freq/2.08 , y )
        ehe12p = y/2.16
      endif
*
      end
******************************************************************************
      real function ehe22p( freq )
      implicit none
*two photon emission from helium ion
      real freq
      integer ncrs
      parameter (ncrs=21)
      real ener(ncrs) , crs(ncrs)
      real  y2(ncrs) , y
      logical lgFirst
      save lgFirst , ener , crs , y2
*
      data ener/ 0. , 0.03738 , 0.07506 , 0.1124 , 0.1498 , 0.1875 ,
     1 0.225 , 0.263, 0.300   , 0.3373  , 0.375  , 0.4127 , 0.4500 ,
     2 0.487 , 0.525, 0.5625  , 0.6002  , 0.6376 , 0.6749 , 0.7126 ,
     3 0.75  /
*
      data crs/ 0.  , 5.03    , 8.09    , 10.16  , 11.52  ,  12.52 ,
     1 13.25 , 13.70,   14.02 , 14.25   , 14.27  , 14.25  ,  14.02 ,
     2 13.70 , 13.25,   12.52 , 11.52   , 10.16  , 8.09   ,   5.03 ,
     3 0. /
*
      data lgFirst/.true./
*
      if( lgFirst ) then
*        set up coefficients for spline
         call spline( ener , crs , ncrs , 2e31,2e31, y2 )
         lgFirst = .false.
      endif
*
      if( freq.lt.0. .or. freq.ge.3. ) then
        ehe22p = 0.
      else
        call splint( ener , crs , y2 , ncrs , freq/4. , y )
        ehe22p = y * 8. * 16. / 33.
      endif
*
      end
******************************************************************************
      real function eina( gf , enercm , gup )
      implicit none
*convert a gf into an Einstein A
      real gf , enercm , gup
*
*     derive the transition prob, given the following
*     call to function is gf, ener in cm^-1, g_up
*     gf is product of g and oscilator strength
*     eina = ( gf / 1.499e-8 ) / (wl/1e4)**2 / gup
      eina = ( gf/gup) / 1.4992e-8 / ( 1e4/enercm )**2
*
      end
******************************************************************************
      real function EinstA(lower,iupper)
      implicit none
*calculates Einstein A's from the oscillator strengths
*     (lower,upper) of Johnson 1972.
*
*     local variables
      integer lower,iupper
      real ryd,xmicron,xl,xu
      real fosc
*
      xl = float(min(iupper,lower))
      xu = float(max(iupper,lower))
      ryd = (1./xl**2 - 1./xu**2)
      xmicron = 1./(ryd*10.9737312)
      EinstA = fosc(xl,xu)/(1.499e-8) / (xmicron**2) * xl*xl/xu/xu
*
      end
******************************************************************************
      logical function lgEndFun()
      implicit none
*after each zone, determine whether model is complete
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      logical lgLotsCO
*flag saying that there is lots of CO, triggers lgEndFun stopping model
      common/lotsco/ lgLotsCO
      logical lgComNeg
*flag saying some molecular abundances were negative
      common/comneg/ lgComNeg
      logical lgDrNeg
*flag set in nextdr saying whether dr is negative
      common/drneg/ lgDrNeg
*flag saying that calculation stopped for bad reason
*mostly set in endfun
      logical lgBadStop
      common/badstp/ lgBadStop
      logical lgdR2Small
*set true if zone thickness became too small
      common/dr2sml/ lgdR2Small
      logical lgZoneSet , lgZoneTrp
*lgZonSet set if stopping zone specified
*lgZoneTrp set if stopped due to zone number
      common/zonset/ lgZoneSet , lgZoneTrp
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      integer nzdump
      common/dump/ nzdump
      real StopElecFrac
*stop efraction sets this limiting electron fraction rel to H
      common/efrend/ StopElecFrac
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer MXSTPL
*maximum numeer of stop line commands
      parameter (MXSTPL=10)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real reftot,avhden,chii, avdust , avdpot , thtot
      common/toiii/ reftot,avhden,chii,
     1 avdust(ndust) , avdpot(ndust) , thtot
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      integer MapZone , nMapStep
      real RangeMap
*parameters doing with map command, MapZone is zone number,
* -1 for very start
* RangeMap is range, parsed from same command
* nMapStep is number of steps, set with set nmap command
      common/MapPar/ MapZone , RangeMap(2), nMapStep
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real T2High
*highest allowed temperature, set with stop temperature exceeds command
      common/stphit/ T2High
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      real HColStop , colpls , colnut
*limit column densities set with stop column command
*colend is total hydrogen column, others are ionized and neutral
      common/colend/ HColStop , colpls , colnut
      real StopElecDensity
*stopping electron density, set with stop eden command
      common/endedn/ StopElecDensity
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real drNext
*next dr, as set in nextdr
      common/drnxt/ drNext
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgOnlyZone , lgOnlyHead
*lgOnlyZone set with print only zones
*lgOnlyHead set with print only header
      common/only/ lgOnlyZone , lgOnlyHead
      logical lgPrtStart
*lgPrtStart is option to start printout at certain zone
*nstart is zone number, set with print start command
      integer nstart
      common/pstart/ lgPrtStart , nstart
      logical lgVelPos
*flag set if wind solution had negative velocity
      common/velpos/ lgVelPos
      logical lgDrMinUsed
*set true is calculations stops because zone thickness gets too small
      common/drminu/ lgDrMinUsed
      logical lgLastIt
*     this is false on any but the last iteration
*     set true in startr if iter > itermx
      common/lastit/ lgLastIt
      logical lgTrOvrd
*flag affecting which iteration to turn on trace
      common/trovrd/ lgTrOvrd
      character chReason*21
      common/reason/ chReason
*parameters for stop line command
      real stpint
      integer ipStopLin1,ipStopLin2,nstpl , LineStopWl
*LineStopWl - line wavelength for stop line command
*ipStopLin1 is pointer to first line of pair in stack of lines
*ipStopLin2 is pointer to second line of pair in stack of lines, usually Hbeta
*  initially holds wavelength, converted to pointer in startr
      common/StopLine/ stpint(MXSTPL),ipStopLin1(MXSTPL),
     1 ipStopLin2(MXSTPL), nstpl , LineStopWl(MXSTPL)
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgDone , lgPrinted
      integer i
*     following used to ensure outer radius not exceeded
      real eps
      parameter (eps=1.00001)
*
*     free statement labels >=2
*
      if( lgTrace ) write(qq,'('' lgEndFun called.'')')
*
*     >>chng 97 june 9, now called before first zone with nozne 0
      if( nzone.eq.0 ) then
        lgEndFun = .false.
        return
      endif
*
*     check whether trace is needed for this zone and iteration
      if( nzone.ge.nznbug .and. iter.ge.npsbug .and. lgTrOvrd) then
        nprint = 1
        lgTrace = .true.
      endif
*
*     option to turn printout on after certain zone
      if( lgPrtStart .and. nstart.eq.nzone ) then
        lgTalk = .true.
      endif
*
*     check whether model is done, various criteria used.
      lgDone = .false.
*     this is flag to chekc whether stopping reason was bad
      lgBadStop = .false.
*
*     >>chng 97 july 23, from last iteration only, to any greater than 1
*     >>chng 97 july 23, back again to original
      if( lgRadPresON .and. pbeta.gt.1.0 .and. chCPres.eq.'CPRE' .and.
     1  lgLastIt ) then
*    1  iter.gt.1 ) then
*       const total pres model; if RadPres>PGAS, then unstable, stop
        if( lgTalk ) then
          write(qq,'(/,'' STOP since P(rad)/P(gas)='',F7.3,'' >1.0'')'
     1    ) pbeta
          if( plines(1)/RadPres.gt.0.9 ) then
            write(qq,'('' Caused by Ly-alpha.'')')
          else
            write(qq,'('' Line contributors to radiation pressure '',
     1      ''follows:'')')
            call PrtLinePres
          endif
        endif
        lgDone = .true.
        lgBadStop = .true.
        chReason = 'of radiation pressure'
*
      else if( .not.lgVelPos ) then
*       wind solution with negative velocity
        lgDone = .true.
        chReason = 'wind veloc too small '
*
      else if( lgBusted ) then
*       calculation failed
        lgBadStop = .true.
        lgDone = .true.
        chReason = 'code returned BUSTED '
*
      else if( lgLotsCO ) then
*       all carbon in CO
        lgDone = .true.
        chReason = 'carbon fully moleculr'
*
      else if( lgComNeg ) then
*       heavy element molecule solution with negative population
        lgDone = .true.
        lgBadStop = .true.
        chReason = 'negative mole abundan'
*
      else if( lgdR2Small                      )  then
        lgDone = .true.
        lgBadStop = .true.
        chReason = 'DR small rel to thick'
*
      else if( eden   .lt. StopElecDensity    )  then
        lgDone = .true.
        chReason = 'lowest EDEN reached. '
*
      else if( eden/hden.lt. StopElecFrac  )  then
        lgDone = .true.
        chReason = 'low electron fraction'
*
      else if( lgDrMinUsed                  )  then
*       dr became too small
        lgBadStop = .true.
        lgDone = .true.
        chReason = 'DRAD small- set DRMIN'
*
      else if( depth.ge.router(iter)/eps.or.lgDrNeg  )  then
        lgDone = .true.
        chReason = 'outer radius reached.'
*
      else if(iptnu.ne.ncell.and.
     1  tauabs(iptnu,1) .ge.tauend/eps )  then
        lgDone = .true.
        chReason = 'optical depth reached'
*
      else if( colden .ge. HColStop/eps    )  then
        lgDone = .true.
        chReason = 'column dens reached. '
*
      else if( chii .ge. colpls/eps        )  then
        lgDone = .true.
        chReason = 'column dens reached. '
*
      else if( chi .ge. colnut/eps         )  then
        lgDone = .true.
        chReason = 'column dens reached. '
*
      else if( te     .gt. T2High          )  then
        lgDone = .true.
        chReason = 'highest Te reached.  '
*
      else if( te     .lt. tend            )  then
        lgDone = .true.
        chReason = 'lowest Te reached.   '
*
      else if( nzone  .ge. nend(iter)     )  then
        lgDone = .true.
        lgZoneTrp = .true.
        chReason = 'NZONE reached.       '
*
      else if( nstpl      .gt.0            )  then
*       line ratio exceeded maximum permitted value
*       do not consider case where norm line has zero intensity
        do i=1,nstpl
          if( sumlin(ipStopLin2(i)) .gt.0. ) then
            if(sumlin(ipStopLin1(i))/sumlin(ipStopLin2(i)).gt.stpint(i))
     1        then
              lgDone = .true.
              write(chReason,'(''line'',i5,'' reached.   '')')
     1        LineStopWl(i)
            endif
          endif
        end do
*
      else if( drNext.le.0. ) then
*       this cant happen
        if(lgTalk) write(qq,'('' drNext='',1P,E10.2,'' STOP'')') drNext
        lgDone = .true.
        lgBadStop = .true.
        chReason = 'internal error - DRAD'
        call ShowMe
      endif
*
      lgPrinted = .false.
      if( lgDone ) then
*       flag to call it quits
        lgEndFun = .true.
        call prstep
        lgPrinted = .true.
      else
*       passed all the tests, keep going
*       time dependent model of this zone?
        if( itime .eq. nzone ) then
          call timer
          stop
        endif
*       check whether this zone should be printed
        if( (nzone/nprint)*nprint.eq.nzone  .or.  nzone.eq.1
     1  .or. lgTrConvg ) then
          call prstep
          lgPrinted = .true.
        endif
*       flag to keep going
        lgEndFun = .false.
      endif
*
*     dump cooling arrays for this zone?
      if( nzdump.eq.nzone .or. nzdump.eq.0 ) call dmpary
*
*     do map of cooling function if desired
      if( MapZone .lt. 0 .or. nzone.eq.MapZone ) then
*       print last zone if not already done
        if( .not.lgPrinted ) call prstep
        call punt(' map')
*       stop after doing map
        lgEndFun = .true.
        chReason = 'MAP command used-stop'
        return
      endif
*
      if( lgEndFun .and. lgOnlyZone ) then
        stop
      endif
*
      end
******************************************************************************
      real function eovrlp( abund ,tauin , tauout , a , crsec , ipanu ,
     1 widl, escp , chCore )
      implicit none
*derive line continuum overlap radiative transfer by destruction probability
      real abund ,tauin , tauout , a , crsec , widl, escp
      integer ipanu
      character chCore*4
*
      real sqrtpi
      parameter (sqrtpi=1.7724539)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real opac
      common/opac/ opac(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgOpacOn
      common/opacon/ lgOpacOn
      real conopc,beta
      common/eovrlpVar/ conopc,beta
*
*     local variables
*     dest0 is the smallest destruction probability to return
*     changed from 1e-4 to 1e-8 june 15 95 due to excessive ots heating
*     in high metallicity models
      real dest0 , scale
      parameter (dest0=1e-8 , scale=2.)
      real fhummr , aa
*
*     computes "escape probability" due to continuum destruction of
*     scattering lines
*     EOVRLP destruction probability
*     ABUND density of lower level    TAUIN, TAUOUT inner, outer optical depth
*     A damping constant  CRSEC vel cross ssec IPANU pointer to  freq of line
*     deppler WIDL width of lines    ESCP escape prob for line
*
*     if esc prob gt 1 then line is masing - return small number for dest prob
      if( escp.ge.1.0 ) then
        eovrlp = dest0
        return
      endif
*     following used to trick microsoft powerstation compiler
*     into not generating a warning about these variables,
*     which are not now used
      aa = tauin / max(1.,tauout) * a
*
*     find continuum opacity
      conopc = opac( ipanu )
      if( .not.lgOpacOn ) then
*       opacity not yet defined on very first try
        eovrlp = dest0
        return
      endif
*
*     may be no population
      if( abund.le.0. .or. conopc.le.0. ) then
*       do not set this to DEST0 since energy not then conserved
        eovrlp = 0.
        return
      endif
*
*     fac of 1.7 convert to Hummer convention for line opacity
      beta = conopc / ( abund*sqrtpi *crsec/widl + conopc)
      beta = min( beta , 1. - escp)
*
      if( chCore.eq.'INCO' ) then
*        fits to Hummer and Kunasz 1980 Ap.J. 236,609.
*        the max value of 1e-3 is so that we do not go too far
*        beyond what Hummer and Kunasz did
         eovrlp = min(1e-3 , 8.5 * beta )
      else if( chCore.eq.'  K2' ) then
*        Doppler core only; a=0., Hummer 68
         eovrlp = fhummr( beta )
      else if( chCore.eq.'SIMP' ) then
*        this for debugging only
         eovrlp = 8.5 * beta
      else
         write(qq,'('' chCore of '',A4,'' not understood by EOVRLP.'')')
     1   chCore
         stop
      endif
*
      eovrlp = eovrlp / (1. + eovrlp)
      eovrlp = eovrlp * (1.-escp)
*begin sanity check
      if( eovrlp.lt.0. .or. eovrlp.gt.1.0 ) then
        write(qq,'('' EovrLp returns insane destruction probability, =''
     1  ,1p,e10.2)') eovrlp
        call ShowMe
        stop
      endif
*end sanity check
*
      end
******************************************************************************
      Real function esa0k2( taume )
      implicit none
*derive Hummer's K2 escape probability for Doppler core only
      real taume
      real sqrtpi
      parameter (sqrtpi=1.7724539)
      real a(5) , b(6) , c(5) , d(6)
      real tau,suma,sumb,arg,sumc,sumd
*
*     local variables
      real escmase
*
      data a/1.00, -0.1117897 , -0.1249099917 , -9.136358767e-3 ,
     1 -3.370280896E-4/
      data b/1.00, 0.1566124168, 9.013261660e-3 , 1.908481163E-4,
     1 -1.547417750E-7 , -6.657439727E-9 /
      data c/1.000, 19.15049608, 100.7986843 , 129.5307533 ,
     1 -31.43372468 /
      data d/ 1.00 , 19.68910391 , 110.2576321 , 169.4911399 ,
     1 -16.69969409 , -36.664480000/
*
*     compute Hummer's K2 escape probability function for a=0
*     using approx from JQRST 26, 187.
*
*     convert to David's opacity
      tau = taume * sqrtpi
*
      if( tau.lt.0. ) then
*       the line mased
        esa0k2 = escmase(taume)
*
      else if( tau.lt.0.01 ) then
        esa0k2 = 1. - 2. * tau
*
      else if( tau.le.11. ) then
        suma = a(1) + tau*(a(2) + tau*(a(3) + tau*(a(4)+a(5)*tau)))
        sumb = b(1) + tau*(b(2) + tau*(b(3) + tau*(b(4)+tau*(b(5)+
     1  b(6)*tau))))
        esa0k2 = tau / 2.5066283 * log( tau/sqrtpi ) +
     1  suma/sumb
*
      else
*       large optical depth limit
        arg = 1. / log(tau/sqrtpi )
        sumc = c(1) + arg*(c(2) + arg*(c(3) + arg*(c(4)+c(5)*arg)))
        sumd = d(1) + arg*(d(2) + arg*(d(3) + arg*(d(4)+arg*(d(5)+
     1  d(6)*arg))))
        esa0k2 = ( sumc / sumd ) /
     1  ( 2.*tau*sqrt( log(tau/sqrtpi ) ) )
      endif
*
      end
******************************************************************************
      real function esccom( tau , a )
      implicit none
*fundamental escape probability radiative transfer routine, for complete redistr
      real tau , a
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real atau , b , esa0k2 , escmase
*
*     this is one of the three fundamental escape probability routines
*     the three are esccom, escinc, and escla
*     it computes esc prob for complete redistribution
*     computes escape prob for complete redistribution in one direction
*
      if( tau.lt.0. ) then
*       line mased
        esccom = escmase( tau )
        return
      endif
*
      if( chEscFun.EQ.'SIMP' ) then
*       this set with "escape simple" command, used for debugging
        esccom = 1. / (1. + tau )
        return
      endif
*
*     chEscFun is the escape prob function, usually k2
*
      if( chEscFun.EQ.'INCO' ) then
        if( tau.lt.10. ) then
          esccom = 1. / (1. + 1.6*tau )
          return
        endif
*
*       first find coeficient b(tau)
        atau = a * tau
        if( atau.gt.1. ) then
          b = 1.6 + ( 3.*(2.*a)**(-0.12) ) / (1. + atau )
        else
          b = 1.6 + ( 3.*(2.*a)**(-0.12) ) / (1. + 1./sqrt(atau) )
        endif
        b = min( 6. , b )
*
        esccom = 1. / ( 1. + b*tau ) + 0.25*sqrt(a/tau)
*
      else if( chEscFun.EQ.'  K2' ) then
*       this is the usual case, Hummer's k2 function
* error! what happens if negative tau?
        esccom = esa0k2( tau )
      else
        write(qq,'('' Unknown escape probability function='',A4)')
     1  chEscFun
        stop
      endif
*
      end
******************************************************************************
      real function escgrd( tau , tout , damp ,ipCont )
      implicit none
*escape probability radiative transfer for incomplete redistribution
      real tau , tout , damp
      integer ipCont
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real scale , tt , escinc
      parameter (scale=2.)
*
*     find escape prob for incomp redis, average of two 1-sided probs
*
*     >>chng 97 june 26, added ipCont
*begin sanity check
      if( ipCont.lt.1 ) then
        write(qq,'('' escgrd called with insane continuum pointer='',
     1  i6)') ipCont
        stop
      endif
*end sanity check
*
      if( lgTauOutOn ) then
*        outward optical depth if defined
         tt = (tout - tau)
*        help convergence by not letting tau go to zero at back edge of
*        when there was a bad guess for the total optical depth
*note that this test is seldom hit since makestatrt does check for overrun
         if( tt.lt.0. ) tt = tau / scale
         wayin = escinc(tau,damp)
         wayout = escinc(tt,damp)
         fracin = wayin / (wayin + wayout )
         escgrd = 0.5 * ( wayin + wayout )
      else
*        outward optical depth not defined, dont estimate fraction out
         fracin = 0.
         wayout = 1.
         escgrd = escinc( tau ,damp)
         wayin = escgrd
      endif
*
*begin sanity check
      if( escgrd.le.0. ) then
        write(qq,'('' escgrd finds insane escape probability,'',1p,
     1  e10.2)') escgrd
        write(qq,'('' tau, tout, damp='',1p,3e10.2)') tau , tout , damp
        call ShowMe
        stop
      endif
*end sanity check
*
      end
******************************************************************************
      real function escinc(tau,a)
      implicit none
*fundamental escape probability radiative transfer routine for incomplete redist
      real tau , a
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
*
*     local variables
      real atau , b , escmase
*
*     this is one of the three fundamental escape probability routines
*     the three are esccom, escinc, and escla
*     it computes esc prob for incomplete redistribution
*
      if( chEscFun.eq.'SIMP' ) then
*       this set with "escape simple" command, used for debugging
        escinc = 1. / (1. + tau )
        return
      endif
*
      if( tau.lt.0. ) then
*       line mased
        escinc = escmase( tau )
      else if( tau.lt.10. ) then
*       linear part of doppler core
        escinc = 1. / (1. + 1.6*tau )
      else
*       first find coeficient b(tau)
        atau = a * tau
        if( atau.gt.1. ) then
          b = 1.6 + ( 3.*(2.*a)**(-0.12) ) / (1. + atau )
        else
          b = 1.6 + ( 3.*(2.*a)**(-0.12) ) / (1. + 1./sqrt(atau) )
        endif
        b = min( 6. , b )
*
        escinc = 1. / ( 1.+b*tau )
      endif
*
      end
******************************************************************************
      real function escla( esin , dest , abund )
      implicit none
*escape prob for hydrogen atom Lya, using Hummer and Kunasz results
      real esin , dest , abund
*
      real sqrtpi
      parameter (sqrtpi=1.7724539)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real hesc , esesc
      common/hesc/ hesc(lmhlvl,lmhlvl) , esesc(lmhlvl,lmhlvl)
      real hfrcin
      common/hfrcin/ hfrcin(lmhlvl,lmhlvl-1)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real opac
      common/opac/ opac(ncell)
      character*4 chRedis
      common/redis/ chRedis
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      real hi , hii
      common/h/ hi , hii
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
*
*     local variables
      real beta , conopc , dstin, dstout,damp,escsub
*
*     this is one of the three fundamental escape probability functions
*     the three are esccom, escinc, and escla
*     evaluate esc prob for LA
*     optical depth in outer direction always defined
*
      if( htlim(2,1)-htnext(2,1) .lt.0. ) then
*       this is the case if we overrun the optical depth scale
*       just leave things as they are
        escla = hesc(2,1)
        fracin = hfrcin(2,1)
        esin = fracin
        dest = hdest(1,2)
        return
      endif
*
      if( chRedis.eq.'INCO' ) then
*       incomplete redistribution
        conopc = opac( iphl(2,1) )
*       abund = hn(1)*hii
        if( abund.gt.0. ) then
          beta = conopc / ( abund/sqrtpi *hopac(2,1)/doppler(1)+conopc)
        else
          beta = 1.
        endif
*
*       WAYIN will be escape prob in inward direction
        call humla( htnext(2,1) , beta , wayin, dstin)
        if( wayin.gt.1..or.wayin.lt.0. .or. dstin.gt.1. .oR.
     1    dstin.lt.0. ) then
          write(qq,'('' HUMLA returns inwd prob out of bounds; '',
     1    '' esc='',1P,E10.2,'' dst='',E10.2,'' beta='',E10.2,
     2    '' tau='',E10.2)')
     3    wayin , dstin , beta , htnext(2,1)
          stop
        endif
*
        call humla( max(htlim(2,1)/100.,htlim(2,1)-htnext(2,1))
     1  , beta , wayout, dstout )
        if( wayout.gt.1..or.wayout.lt.0. .or. dstout.gt.1. .or.
     1    dstout.lt.0. ) then
          write(qq,'('' HUMLA returns outwd prob out of bounds; '',
     1    '' esc='',1P,E10.2,'' dst='',E10.2,'' beta='',E10.2,
     2    '' tau='',E10.2)')
     3    wayout , dstout , beta ,
     4    max(htlim(2,1)/100.,htlim(2,1)-htnext(2,1))
          stop
        endif
        escla = (wayin + wayout) / 2.
*666    write(8,'('' ein ot din ot='',1p,4e10.2,'' beta'',e10.2)')
*    1  wayin,wayout, dstin,dstout,beta
        esin = wayin
        dest = (dstin + dstout ) / 2.
        fracin = wayin / (wayin + wayout )
      else
*       wind or complete redis
        escla = escsub( htnext(2,1) , htlim(2,1) , damp )
        esin = wayin
        fracin = 0.5
        dest = 0.
      endif
*666  write(6,'('' Lya prob'',1p,9e11.4)') escla,dest,beta,conopc
*
      if( escla.lt.0. ) then
        write(qq,'('' ESCLA returns a negative value, of'',1P,E10.2)')
     1  escla
        write(qq,'('' ESCLA: the redistribution type was '',A4)')chRedis
        write(qq,'('' The optical depths are '',1P,2E10.2)')
     1     htnext(2,1) , htlim(2,1)
        call ShowMe
        stop
      endif
*
      end
******************************************************************************
      real function escmase(tau)
      implicit none
*escape probability for negative (masing) optical depths
      real tau
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real zero , a
      data zero/0./
*
*     this is the only routine that computes maser escape proba
*begin sanity check
      if( tau.gt.0. ) then
        write(qq,'('' escmase called with positive tau!!'')')
        write(qq,'('' Tau ='',1p,e10.2)') tau
        stop
      endif
*end sanity check
      if( tau.gt.-0.1 ) then
        escmase = 1. - tau*(0.5 + tau/6.)
      else if( tau.gt.-30. ) then
        escmase = (1.- exp(-tau) ) / tau
      else
        write(qq,'('' escmase called with 2big tau''1p,e10.2)')tau
        call FindNeg
        write(qq,'('' will now div by 0 to get trace'')')
        a = 1. / zero
        write(qq,'(1p,e10.2)') a
        stop
      endif
*
*begin sanity check
      if( escmase.lt.1.0 ) then
        write(qq,'('' escmase finds P<1!!'')')
        write(qq,'('' escmase, Tau ='',1p,2e10.2)') escmase,tau
        stop
      endif
*end sanity check
*
      end
******************************************************************************
      real function escpcn( tau , hnukt )
      implicit none
*continuum escape probability
      real tau  , hnukt
      real ContTkt , ctau
*variables used to pass continuum optical depth and temp to
*routine that integrates over continuum
      common/chnukt/ ContTkt , ctau
      external conrec , conesc
*
*     local variables
      real dinc , sumrec , sumesc
*
*     computes continuum escape probabilities
      if( tau.lt.0.01 ) then
        escpcn = 1.
        return
      else if( hnukt.gt.1. .and. tau.gt.100. ) then
        escpcn = 1e-20
        return
      endif
*
      ContTkt = hnukt
      ctau = tau
*
      dinc = 10./hnukt
      call qg32( 1. , 1.+dinc , conrec , sumrec )
      call qg32( 1. , 1.+dinc , conesc , sumesc )
*
      if( sumrec.gt.0. ) then
        escpcn = sumesc/sumrec
      else
        escpcn = 0.
      endif
*
      end
******************************************************************************
      real function escsub( tau , tout , damp )
      implicit none
*escape probability radiative transfer for subordinate lines
      real tau , tout , damp
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
*
*     local variables
      real scale , t , esccom
      parameter (scale=2.)
*
      if( lgTauOutOn ) then
*       outward optical depths are defined, but don't let them go negat
        t = (tout - tau)
*        help convergence by not letting tau go to zero at back edge of
*        when there was a bad guess for the total optical depth
*note that this test is seldom hit since makestatrt does check for overrun
        if( t.lt.0. ) t = tau / scale
        wayin = esccom(tau, damp )
        wayout = esccom(t, damp )
        fracin = wayin / (wayin + wayout )
        escsub = 0.5 * ( wayin + wayout )
      else
*       first iteration, outward optical depths not defined
*       dont estimate fraction in
        fracin = 0.
        wayout = 1.
        escsub = esccom( tau , damp )
        wayin = escsub
      endif
*
      end
******************************************************************************
      real function eshe1l( esin )
      implicit none
*do radiative transfer for helium singlets lines
      real esin
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      character*4 chRedis
      common/redis/ chRedis
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real damp , escgrd , escsub
*
*     evaluate esc prob for HeI LA
      damp = 606.7 / doppler(2)
      if( chRedis.EQ.'INCO' ) THEN
*        incomplete redistribution
         eshe1l = escgrd( he1nxt(2,1) , he1lim(2,1) , damp ,
     1   iphe1l(2,1) )
         esin = wayin
      else
*        wind or complete redis
         eshe1l = escsub( he1nxt(2,1) , he1lim(2,1) , damp )
         esin = wayin
      endif
      if( eshe1l.lt.0. ) then
        write(qq,'('' ESHE1L returns a negative value, of'',1P,E10.2)')
     1  eshe1l
        write(qq,'('' ESHE1L: the redistribution type was '',A4)')
     1  chRedis
        write(qq,'('' The optical depths are '',1P,2E10.2)')
     1     he1nxt(2,1) , he1lim(2,1)
        call ShowMe
        stop
      endif
*
      end
******************************************************************************
      real function eshe2l( esin )
      implicit none
*do radiative transfer for all helium ion lines
      real esin
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer limelm
      parameter (limelm=30)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      character*4 chRedis
      common/redis/ chRedis
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real damp , escgrd , escsub
*
*     evaluate esc prob for HeII LA
*     optical depth in outer direction always defined
*
      damp = 606.7 / doppler(2)
      if( chRedis.eq.'INCO' ) then
*       incomplete redistribution
        eshe2l = escgrd( he2nxt(2,1) , he2lim(2,1) , damp ,
     1  iphe2l(2,1) )
        esin = wayin
      else
*       wind or complete redis
        eshe2l = escsub( he2nxt(2,1) , he2lim(2,1) , damp )
        esin = wayin
      endif
*
      if( eshe2l.lt.0. ) then
        write(qq,'('' ESHE2L returns a negative value, of'',1P,E10.2)')
     1  eshe2l
        write(qq,'('' ESHE2L: the redistribution type was '',A4)')
     1  chRedis
        write(qq,'('' The optical depths are '',1P,2E10.2)')
     1     he2nxt(2,1) , he2lim(2,1)
        call ShowMe
        stop
      endif
*
      end
******************************************************************************
      subroutine esread( chCard )
      implicit none
*parse escape probability command
      character chCard*80
*
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chKey*4
      logical lgMatch
*
*     escape probability function for subordinate lines
      if( lgMatch(' K2 ',chCard) ) then
        chKey = '  K2'
      else if( lgMatch('INCO',chCard) ) then
        chKey = 'INCO'
      else if( lgMatch('SIMP',chCard) ) then
        chKey = 'SIMP'
      else
        write(qq,'('' Subordinate escape probability'',
     1  '' must be either SIMP K2 or COMP.  Sorry.'')')
        stop
      endif
*
      if( lgMatch( 'EMIT' , chCard ) ) theN
        chEscFun = chKey
      else if( lgMatch( 'DEST' , chCard ) ) then
        chDstFun = chKey
      else
        chEscFun = chKey
        chDstFun = chKey
      endif
*
      end
******************************************************************************
      subroutine esum
      implicit none
*sum free electron density over all species, sets variable EdenTrue
*called by ionize which actually controlls the electron density updates
      real EdenExtra
*extra electrons added with eden command
      common/edxtra/ EdenExtra
      real EdenTrue
*     this is the true eden as set in esum
*     we will try to converge eden to this
      common/TrueEden/ EdenTrue
      real EdenFFSum
*sum of heavy element free electrons, set in esum
      common/ffsum/ EdenFFSum
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer limelm
      parameter (limelm=30)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real EdenMet , EdenNotH
*     EdenMet is sum of electrons from Lit through n=30, all ions
*     EdenNotH is total electron density less the proton density
*     used in hydrogen loop for charge conservation
      common/EdenOther/ EdenMet , EdenNotH
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nelem,i
      real csum , osum , edsave(limelm) , edmole
*
*     free statement number >=14
*
*     EdenExtra is normally zero, set with EDEN command, to add extra e-
      EdenTrue = hii + heii + 2.*heiii + EdenExtra
*     add on molecules
      edmole = EdenTrue
      EdenTrue = EdenTrue + h2plus + chp + ohp + cop + h2op + o2p +
     1 c2p + h3op + ch2p + h3plus
*     remember electron density from molecules
      edmole = EdenTrue - edmole
*     >>chng 97 mar 18, some extreme models have H- density very large during
* 666 Error! cap below should be elsewhere, this sub should return TrueEden
*search phase when far from solution.  do not let eden go neg
      if( lgSearch ) then
        EdenTrue = EdenTrue - min(EdenTrue*0.05,hminus)
      else
        EdenTrue = EdenTrue - min(EdenTrue/100.,hminus)
      endif
*
*     sum over all metals
      EdenMet = 0.
      EdenFFSum = 0.
      do nelem=3,limelm
        edsave(nelem) = 0.
        do i=1,nelem
*         >>chng 96 oct 27, save all contributors to electron density
          edsave(nelem) = edsave(nelem) + float(i)*xIonFracs(nelem,i+1)
          EdenFFSum = EdenFFSum + float(i*i)*xIonFracs(nelem,i+1)
        end do
        EdenMet = EdenMet + edsave(nelem)
      end do
*
      EdenTrue = EdenTrue + EdenMet
*     FFSUM is sum of effective contribution to heavy element free-free
*     >>chng 97 sep 4, get rid of extra variable, should make no change
*     ffsum = EdenFfsum
*
*     get all electrons not due to hydrogen
      EdenNotH = EdenTrue - hii
*
      if( lgTrace ) then
        csum = 0.
        do i=1,6
          csum = csum + float(i)*xIonFracs(6,i+1)
        end do
        osum = 0.
        do i=1,8
          osum = osum + float(i)*xIonFracs(8,i+1)
        end do
        write(qq,'(5X,''ESUM: TrueEden'',1P,E11.4,'' old'',
     1  E11.4,'' ff sum'',E10.3,'' H'',E8.2,'' He'',
     2  E8.2,'' C'',E8.2,'' O'',E8.2,'' met'',e8.2,'' mol'',e8.2)')
     3  EdenTrue , eden , EdenFFSum , hii , heii+2.*heiii,
     4  csum,osum,EdenMet,edmole
        if(lgNeBug) write(qq,'(4x,1p,15e8.1)') edsave
      endif
*
      if( EdenTrue.le. 0. ) then
        write(qq,'(''ESUM finds non-positive electron density.'')')
        write(qq,'(5X,''ESUM: EdenTrue to'',1P,E12.4,'' fm'',
     1  E12.4,'' ff sum;'',E10.3,'' Ne(H):'',E9.2,'' Ne(He):'',
     2  E9.2,'' Ne(C):'',E9.2,'' Ne(O):'',E9.2)')
     3  EdenTrue , eden , EdenFFSum , hii , heii+2.*heiii
        call ShowMe
        stop
      endif
*
      end
******************************************************************************
      real function eva2nu( freq )
      implicit none
*two photon emission function for hydrogen
      real freq
      integer ncrs
      parameter (ncrs=21)
      real ener(ncrs) , crs(ncrs)
      real  y2(ncrs) , y
      logical lgFirst
      save lgFirst , ener , crs , y2
*
      data ener/ 0. , 0.03738 , 0.07506 , 0.1124 , 0.1498 , 0.1875 ,
     1 0.225 , 0.263, 0.300   , 0.3373  , 0.375  , 0.4127 , 0.4500 ,
     2 0.487 , 0.525, 0.5625  , 0.6002  , 0.6376 , 0.6749 , 0.7126 ,
     3 0.75  /
*
      data crs/ 0.  , 5.03    , 8.09    , 10.16  , 11.52  ,  12.52 ,
     1 13.25 , 13.70,   14.02 , 14.25   , 14.27  , 14.25  ,  14.02 ,
     2 13.70 , 13.25,   12.52 , 11.52   , 10.16  , 8.09   ,   5.03 ,
     3 0. /
*
      data lgFirst/.true./
*
      if( lgFirst ) then
*        set up coefficients for spline
         call spline( ener , crs , ncrs , 2e31,2e31, y2 )
         lgFirst = .false.
      endif
*
      if( freq.lt.0. .or. freq.ge.0.75 ) then
         eva2nu = 0.
      else
         call splint( ener , crs , y2 , ncrs , freq , y )
         eva2nu = y
      endif
*
      end
******************************************************************
      real function exp1(x)
      implicit none
*routine from ucl group to compute 1-exp(-x)
* mod implicit none, and f77 control, gfj '96 jul 11
      real x
*     local variables
      real dx
*
      dx = abs(x)
      if(dx.lt.1.0E-9) then
        exp1 = -x
      else if(dx.lt.1.0E-5) then
        exp1 = ((-x*0.5  )-1.0  )*x
      else if(dx.lt.1.0E-3) then
        exp1 = (((-x*0.1666666667  )-0.5  )*x-1.0  )*x
      else
        exp1 = 1.0  -exp(x)
      endif
*
      end
******************************************************************************
      real function expion( bltz , abund )
      implicit none
*VERY simple two level cooling, do de-excitation or transfer
      real bltz , abund
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real te , eden , hden
      common/phycon/ te , eden , hden
      real teinv
      common/teinv/ teinv
      real exp , boltz
*
*     factor in front of call is C.S. * 8.6E-6/GLOW * HNU
*     edensqte is eden / sqrte
*
      if( abund.gt.0. ) then
        boltz = bltz * teinv
        if( boltz.lt.20. ) then
          expion = abund * edensqte * exp( -boltz )
        else
          expion = 0.
        endif
      else
        expion = 0.
      endif
*
      end
******************************************************************************
      subroutine extin( ex1ryd )
      implicit none
*do extinction of incident continuum as set by extinguish command
      real ex1ryd
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real excolm , exleak , exlow
      common/extinc/ excolm , exleak , exlow
      real absorb , sexp , factor
      integer low , i , ipoint
*
*     modify input continuum by leaky absorber
*     power law fit to Cruddace et al. 1974 ApJ 187, 497.
*
      if( excolm.eq.0. ) then
         ex1ryd = 1.
      else
*
        absorb  = 1. - exleak
        factor = excolm * 6.22e-18
*       extinction at 1 and 4 Ryd
        ex1ryd = exleak + absorb * sexp( factor )
*
        low = ipoint( exlow )
        do i=low,nflux
          flux(i) = flux(i) *
     1    (exleak + absorb * sexp( factor * (anu(i)**(-2.43) ) ) )
        end do
*
      endif
*
      end
******************************************************************************
      real function fabden ( radius , depth )
      implicit none
*called by dlaw command, returns density for any density law
      double precision radius , depth
*     include "dlaw.com"
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      double precision a
*
*
*     this routine is called when the DLAW command is given,
*     and must return the hydrogen density at the radius R0.
*     RADIUS is the radius, the distance from the center of symmetry.
*     DEPTH is the depth into the cloud, from the illuminated face
*     both are in cm
*     the values of R0 and DEPTH in the call are not always equal
*     to their current values in the cmmn block
*
*     R0 and the array DensityLaw are double precision.
*     the variables used are double precision, although
*     FABDEN itself is not
*
      write(qq,'('' the old version of FABDEN must be deleted,'',
     1'' and a new one put in place.  Sorry.'')')
*     following must be removed if this sub is to be used
*     it is only here to trick microsoft powerstation compiler into
*     not flagging this sub
      a = radius * depth
*
      fabden = 0.
      if( fabden.eq.0. ) then
        stop
      else
        return
      endif
*
      end
******************************************************************************
      subroutine fe2ir( totir , fe2 )
      implicit none
*cooling due to FIR lines of ground term of FeII
      real totir , fe2
      double precision zz(6,6)
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      real teinv
      common/teinv/ teinv
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real a21 , a32 , a43 , a54 , fexp , x
      real e12,e23,e34,e45,c21,c12,c31,c13,c41,c14,c15,c51
      real c32,c23,c42,c24,c52,c25,c43,c34,c53,c35,c54,c45
      integer i , ner
      real p2,p3,p4,p5 , dirdt
      data a21/2.13e-3/ , a32/1.57e-3/ , a43/7.18e-4/ ,
     1 a54/1.88e-4/
*
      fexp(x) = 1. + x * ( -0.9664 + 0.3536*x )
*
*     compute emission from 6D ground term of FeII
*     collision data from Pradhan and Zhang Ap.J. Let 409, L77
*     trans prob from Nussbaumer and Storey 1988 AstAp 193, 327.
*
      if( (fe2.le.0.) .or. (eden.gt.1e10) ) then
        totir = 0.
        return
      endif
*
*     five levels within ground term
*     level  J  excit energy
*     1      9/2   0
*     2      7/2 385
*     3      5/2 668
*     4      3/2 863
*     5      1/2 977
*
      if( te.gt.800. ) then
        e12 = fexp(553.6*teinv)
        e23 = fexp(407.*teinv)
        e34 = fexp(280.*teinv)
        e45 = fexp(164.*teinv)
      else
        e12 = exp(-553.6*teinv)
        e23 = exp(-407.*teinv)
        e34 = exp(-280.*teinv)
        e45 = exp(-164.*teinv)
      endif
*
*     extra neutral collisions from Tielens and Hollenbach 1985
      c21 = cdsqte * 5.8 / 8. + 9.5e-10*hi
      c12 = c21 * 0.8 * e12
      c31 = cdsqte * 1.6 / 6.
      c13 = c31 * 0.6 * e12*e23
      c41 = cdsqte * 0.75 / 4.
      c14 = c41 * 0.4 * e12*e23*e34
      c51 = cdsqte * 0.32 / 2.
      c15 = c51 * 0.2 * e12*e23*e34*e45
*
      c32 = cdsqte * 5.6 / 6. + 4.7e-10*hi
      c23 = c32 * 0.75 * e23
      c42 = cdsqte * 1.25 / 4.
      c24 = c42 * 0.5 * e23*e34
      c52 = cdsqte * 0.45 / 2.
      c25 = c52 * 0.25 * e23*e34*e45
*
      c43 = cdsqte * 4.46 / 4. + 5.7e-10*hi
      c34 = c43 * 0.6667 * e34
      c53 = cdsqte * 0.74 / 2.
      c35 = c53 * 0.3333 * e34*e45
*
      c54 = cdsqte * 2.72 / 2.
      c45 = c54 * 0.5 * e45
*
*---------------------------------------------------------
*
      do i=1,5
        zz(5,i) = 1.0
        zz(i,6) = 0.
      end do
      zz(5,6) = fe2
*
*     level one balance equation
      zz(1,1) = c12+c13+c14+c15
      zz(1,2) = -a21 - c21
      zz(1,3) = -c31
      zz(1,4) = -c41
      zz(1,5) = -c51
*
*     level two
      zz(2,1) = -c12
      zz(2,2) = a21+c21+c23+c24+c25
      zz(2,3) = -c32 - a32
      zz(2,4) = -c42
      zz(2,5) = -c52
*
*     level three
      zz(3,1) = -c13
      zz(3,2) = -c23
      zz(3,3) = a32+c31+c32+c34+c35
      zz(3,4) = -a43 - c43
      zz(3,5) = -c53
*
*     level four
      zz(4,1) = -c14
      zz(4,2) = -c24
      zz(4,3) = -c34
      zz(4,4) = a43+c43+c42+c41+c45
      zz(4,5) = -c54 - a54
*
      call matin1(zz,6,5,1,ner)
      if( ner.ne.0 ) then
        if( lgTalk ) write(qq,'('' fe2 ir matrix error'')')
        if( lgCalled ) then
          lgBusted = .true.
          return
        else
          stop
        endif
      endif
*
      p2 = zz(2,6)
      p3 = zz(3,6)
      p4 = zz(4,6)
      p5 = zz(5,6)
*
*     transition wavelengths =25.98mic, 35.34, 51.29, 87.36
*                              2-1      3-2    4-3    5-4
*     this is the total cooling
      totir = p2*a21*7.66e-14 + p3*a32*5.63e-14
     1      + p4*a43*3.88e-14 + p5*a54*2.26e-14
*     now put into cooling array
      call coladd( 'Fe 2' , 1 , totir  )
*
*     this is its derivative
      dirdt = p2*a21*7.66e-14*(553.6*tsq1 - halfte) +
     1 p3*a32*5.63e-14*(960.6*tsq1-halfte)  +
     2 p4*a43*3.88e-14*(1240.6*tsq1-halfte) +
     3 p5*a54*2.26e-14*(1404.6*tsq1-halfte)
      dCooldT = dCooldT + dirdt
*
      end
      subroutine Fe2Lev16
      implicit none
*compute populations and cooling due to 16 level Fe II ion
      integer limelm
      parameter (limelm=30)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limLevelN
      parameter (limLevelN=20)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real Fe2L16Tot,fe21308,fe21207,fe21106,fe21006,
     1 fe21204,fe21103,fe21104,fe21001,fe21002 ,
     1 fe20201 , fe20302 , fe20706 , fe20807 , fe20908 ,
     1 fe21007 , fe21107 , fe21108 , fe21110 , fe21507 ,
     1 fe21208 , fe21209 , fe21211 , fe21406 ,fe21508 , fe21609
*total cooling due to 16 level model FeII atom
*fe2cool is total cooling due to 16 level atom,
      common/fe2cool/ Fe2L16Tot,fe21308,fe21207,fe21106,fe21006,
     1 fe21204,fe21103,fe21104,fe21001,fe21002 ,
     1 fe20201 , fe20302 , fe20706 , fe20807 , fe20908 ,
     1 fe21007 , fe21107 , fe21108 , fe21110 , fe21507,
     1 fe21208 , fe21209 , fe21211 , fe21406,fe21508,fe21609
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*     number of levels in model ion
      integer nlfe2
      parameter (nlfe2=16)
*
      real gfe2(nlfe2) , ex(nlfe2) , popfe2(nlfe2) , data(nlfe2,nlfe2),
     1 dest(nlfe2,nlfe2) , pump(nlfe2,nlfe2) , Fe2A(nlfe2,nlfe2) ,
     2 Fe2CS(nlfe2,nlfe2)
      real dfe2dt
      logical lgNegPop
      integer ipdest(nlfe2,nlfe2) , i , j , nFe2Neg , nUsed
*     statistical weights
      data gfe2/10.,8.,6.,4.,2.,10.,8.,6.,4.,8.,6.,4.,2.,6.,4.,2./
*     excitation energies in Kelvin
* excitation energies in Kelvin
      data ex/ 0., 553.646, 960.680, 1241.151, 1405.810,
     1 2694.300, 3496.489, 4083.318, 4485.486, 11446.297,
     2 12074.546, 12489.670, 12728.966, 19387.344,
     3 19673.344, 20006.633/
*
*     each set is for a lower level indicated by second element in array,
*     index runs over upper level
*     A's are saved into arrays as data(up,lo)
* A's are saved into arrays as data(up,lo)
      data (Fe2A(j, 1), j=1,nlfe2)/
     1 0.00E+00, 2.13E-03, 1.00E-16, 1.00E-16, 1.00E-16, 2.80E-04,
     2 1.00E-04, 1.00E-16, 1.00E-16, 4.74E-03, 1.00E-16, 1.00E-16,
     3 1.00E-16, 1.00E-16, 1.00E-16, 1.00E-16/
      data (Fe2A(j, 2), j=1,nlfe2)/
     1 2*0.00E+00, 1.57E-03, 1.00E-16, 1.00E-16, 1.00E-16,
     2 1.80E-04, 6.90E-04, 1.00E-16, 1.31E-03, 4.80E-04, 1.00E-16,
     3 1.00E-16, 6.64E-03, 1.00E-16, 1.00E-16/
      data (Fe2A(j, 3), j=1,nlfe2)/
     1 3*0.00E+00, 7.18E-04, 1.00E-16, 1.00E-16,
     2 3.40E-05, 1.00E-04, 2.80E-05, 9.70E-04, 1.98E-03, 1.00E-16,
     3 1.00E-16, 1.00E-16, 6.81E-03, 1.00E-16/
      data (Fe2A(j, 4), j=1,nlfe2)/
     1 4*0.00E+00, 1.88E-04, 1.00E-16,
     2 1.00E-16, 2.50E-05, 4.00E-05, 1.00E-16, 1.17E-03, 2.45E-03,
     3 7.80E-04, 1.00E-16, 1.00E-16, 6.23E-03/
      data (Fe2A(j, 5), j=1,nlfe2)/
     1 5*0.00E+00, 1.00E-16,
     2 1.00E-16, 1.00E-16, 9.90E-06, 1.00E-16, 1.00E-16, 1.08E-03,
     3 3.32E-03, 1.00E-16, 2.20E-04, 1.93E-03/
      data (Fe2A(j, 6), j=1,nlfe2)/
     1 6*0.00E+00,
     2 5.84E-03, 1.00E-16, 1.00E-16, 5.98E-03, 3.12E-03, 1.00E-16,
     3 1.00E-16, 3.56E-02, 1.00E-16, 1.00E-16/
      data (Fe2A(j, 7), j=1,nlfe2)/
     1 7*0.00E+00, 3.92E-03, 1.00E-16, 1.32E-03, 2.49E-03, 4.18E-03,
     2 1.00E-16, 8.83E-03, 2.21E-02, 1.00E-16/
      data (Fe2A(j, 8), j=1,nlfe2)/
     1 8*0.00E+00, 1.41E-03, 1.00E-16, 1.82E-03, 1.18E-03,
     2 4.75E-03, 1.68E-03, 1.29E-02, 1.61E-02/
      data (Fe2A(j, 9), j=1,nlfe2)/
     1 9*0.00E+00, 1.00E-16, 1.00E-16, 2.12E-03,
     2 2.47E-03, 1.00E-16, 3.65E-03, 2.13E-02/
      data (Fe2A(j,10), j=1,nlfe2)/
     1 10*0.00E+00, 2.56E-03, 1.00E-16,
     2 1.00E-16, 2.23E-03, 2.25E-03, 1.00E-16/
      data (Fe2A(j,11), j=1,nlfe2)/
     1 11*0.00E+00, 1.36E-03, 1.00E-16, 2.70E-04, 1.00E-16, 2.76E-03/
      data (Fe2A(j,12), j=1,nlfe2)/
     1 12*0.00E+00, 3.71E-04, 7.70E-05, 1.60E-04, 2.50E-04/
      data (Fe2A(j,13), j=1,nlfe2)/
     1 13*0.00E+00, 1.00E-16, 1.50E-04, 1.00E-16/
      data (Fe2A(j,14), j=1,nlfe2)/14*0.00E+00, 1.90E-04, 1.00E-16/
      data (Fe2A(j,15), j=1,nlfe2)/15*0.00E+00, 5.50E-04/
      data (Fe2A(j,16), j=1,nlfe2)/16*0.00E+00/
*
*     collision strengths from Zhang & Pradhan 1995, A&A, 293, 953
*     order is cs(low,up), for 10,000 K
      data (Fe2CS(i, 1), i=1,nlfe2)/16*0.000E+00/
      data (Fe2CS(i, 2), i=1,nlfe2)/5.521E+00,15*0.000E+00/
      data (Fe2CS(i, 3), i=1,nlfe2)/
     1 1.491E+00,5.442E+00,14*0.000E+00/
      data (Fe2CS(i, 4), i=1,nlfe2)/
     1 6.747E-01,1.197E+00,4.319E+00,13*0.000E+00/
      data (Fe2CS(i, 5), i=1,nlfe2)/
     1 2.839E-01,4.191E-01,7.255E-01,2.640E+00,12*0.000E+00/
      data (Fe2CS(i, 6), i=1,nlfe2)/
     1 3.595E+00,1.633E+00,6.373E-01,2.108E-01,5.804E-02,11*0.000E+00/
      data (Fe2CS(i, 7), i=1,nlfe2)/
     1 1.507E+00,1.484E+00,1.113E+00,6.083E-01,2.231E-01,8.365E+00,
     2 10*0.000E+00/
      data (Fe2CS(i, 8), i=1,nlfe2)/
     1 4.969E-01,1.026E+00,9.581E-01,7.646E-01,4.466E-01,2.227E+00,
     2 7.386E+00,9*0.000E+00/
      data (Fe2CS(i, 9), i=1,nlfe2)/
     1 1.371E-01,4.457E-01,7.373E-01,7.140E-01,4.239E-01,7.005E-01,
     2 2.069E+00,5.627E+00,8*0.000E+00/
      data (Fe2CS(i,10), i=1,nlfe2)/
     1 1.098E+01,2.479E+00,5.033E-01,1.468E-01,5.434E-02,2.106E+00,
     2 8.906E-01,2.935E-01,6.481E-02,7*0.000E+00/
      data (Fe2CS(i,11), i=1,nlfe2)/
     1 5.599E-01,6.540E+00,2.847E+00,6.264E-01,1.177E-01,7.248E-01,
     2 8.511E-01,6.858E-01,3.146E-01,2.230E+00,6*0.000E+00/
      data (Fe2CS(i,12), i=1,nlfe2)/
     1 1.909E-01,3.552E-01,3.583E+00,2.445E+00,5.540E-01,1.477E-01,
     2 5.556E-01,4.996E-01,5.181E-01,8.177E-01,1.752E+00,5*0.000E+00/
      data (Fe2CS(i,13), i=1,nlfe2)/
     1 6.104E-02,1.227E-01,1.956E-01,1.534E+00,1.649E+00,2.123E-02,
     2 1.471E-01,3.672E-01,3.274E-01,3.689E-01,3.784E-01,1.015E+00,
     3 4*0.000E+00/
      data (Fe2CS(i,14), i=1,nlfe2)/
     1 9.480E-01,6.813E-01,3.850E-01,1.707E-01,5.327E-02,1.232E+00,
     2 6.882E-01,3.779E-01,1.971E-01,1.008E+00,5.870E-01,2.563E-01,
     3 7.694E-02,3*0.000E+00/
      data (Fe2CS(i,15), i=1,nlfe2)/
     1 5.024E-01,2.276E-01,2.681E-01,2.971E-01,1.967E-01,4.114E-01,
     2 5.541E-01,4.492E-01,2.809E-01,4.690E-01,2.905E-01,3.180E-01,
     3 2.262E-01,1.280E+00,2*0.000E+00/
      data (Fe2CS(i,16), i=1,nlfe2)/
     1 3.278E-02,2.871E-01,2.451E-01,1.319E-01,4.768E-02,1.404E-01,
     2 1.990E-01,2.603E-01,2.482E-01,7.626E-02,2.877E-01,2.033E-01,
     3 8.596E-02,4.837E-01,6.294E-01,0.000E+00/
*
*     all elements are used, and must be set to zero if zero
      do i=1,nlfe2
        do j=1,nlfe2
          data(i,j) = 1e33
          dest(i,j) = 0.
          pump(i,j) = 0.
          ipdest(i,j) = 0
        end do
        data(i,i) = 0.
        popfe2(i) = 0.
      end do
*
*     fill in einstein As and collision strengths
      do i=1,nlfe2
        do j=i+1,nlfe2
          data(j,i) = Fe2A(j,i)
          data(i,j) = Fe2CS(i,j)
        end do
      end do
*     write(6,*)' collision strengths'
*     do i=nlfe2,2,-1
*666    write(6,'(i3,1p,16e8.1)')i,(data(j,i),j=1,i-1)
*     end do
*     write(6,*)' A s'
*     do i=nlfe2,2,-1
*665    write(6,'(i3,1p,16e8.1)')i,(data(i,j),j=1,i-1)
*     end do
*     stop
*
*     leveln itself is well-protected against zero abundances,
*     low temperatures
*     >>chng 96 oct 16, reduce number of levels for low temp since
*can still be important coolant when highest level not populated
      if( te.lt.500. ) then
        nUsed = 5
      else if( te.lt.1e3 ) then
        nUsed = 9
      else
        nUsed = nlfe2
      endif
      call LevelN(nUsed,nlfe2,xIonFracs(26,2),gfe2,ex ,
     1 popfe2,data,dest,pump,ipdest,
     1 Fe2L16Tot,dfe2dt,'FeII', lgNegPop)
*     write(66,'(1p,8e11.3)') (popfe2(i),i=1,8)
*     write(6,'(1p,8e11.3)') (DepLTELevels(i),i=1,nlfe2-1)
*
*     write(67,'(i3,1p,3e10.2)') nzone,te,Fe2L16Tot
      if( lgNegPop ) nFe2Neg = nFe2Neg + 1
      call coladd( 'Fe 2' , 2 , Fe2L16Tot )
      dCooldT = dCooldT + dfe2dt
*
*     all 10 transitions within ground term
      fe21308 = popfe2(13)*Fe2A(13,8)*(ex(13)-ex(8))*Boltzmann
      fe21207 = popfe2(12)*Fe2A(12,7)*(ex(12)-ex(7))*Boltzmann
      fe21106 = popfe2(11)*Fe2A(11,6)*(ex(11)-ex(6))*Boltzmann
      fe21006 = popfe2(10)*Fe2A(10,6)*(ex(10)-ex(6))*Boltzmann
      fe21204 = popfe2(12)*Fe2A(12,4)*(ex(12)-ex(4))*Boltzmann
      fe21103 = popfe2(11)*Fe2A(11,3)*(ex(11)-ex(3))*Boltzmann
      fe21104 = popfe2(11)*Fe2A(11,4)*(ex(11)-ex(4))*Boltzmann
      fe21001 = popfe2(10)*Fe2A(10,1)*(ex(10)-ex(1))*Boltzmann
      fe21002 = popfe2(10)*Fe2A(10,2)*(ex(10)-ex(2))*Boltzmann
      fe20201 = popfe2(02)*Fe2A(02,01)*(ex(02)-ex(01))*Boltzmann
      fe20302 = popfe2(03)*Fe2A(03,02)*(ex(03)-ex(02))*Boltzmann
      fe20706 = popfe2(07)*Fe2A(07,06)*(ex(07)-ex(06))*Boltzmann
      fe20807 = popfe2(08)*Fe2A(08,07)*(ex(08)-ex(07))*Boltzmann
      fe20908 = popfe2(09)*Fe2A(09,08)*(ex(09)-ex(08))*Boltzmann
      fe21007 = popfe2(10)*Fe2A(10,07)*(ex(10)-ex(07))*Boltzmann
      fe21107 = popfe2(11)*Fe2A(11,07)*(ex(11)-ex(07))*Boltzmann
      fe21108 = popfe2(11)*Fe2A(11,08)*(ex(11)-ex(08))*Boltzmann
      fe21110 = popfe2(11)*Fe2A(11,10)*(ex(11)-ex(10))*Boltzmann
      fe21208 = popfe2(12)*Fe2A(12,08)*(ex(12)-ex(08))*Boltzmann
      fe21209 = popfe2(12)*Fe2A(12,09)*(ex(12)-ex(09))*Boltzmann
      fe21211 = popfe2(12)*Fe2A(12,11)*(ex(12)-ex(11))*Boltzmann
*
*     test lines
      fe21406 = popfe2(14)*Fe2A(14,06)*(ex(14)-ex(06))*Boltzmann
      fe21507 = popfe2(15)*Fe2A(15,07)*(ex(15)-ex(07))*Boltzmann
      fe21508 = popfe2(15)*Fe2A(15,08)*(ex(15)-ex(08))*Boltzmann
      fe21609 = popfe2(16)*Fe2A(16,09)*(ex(16)-ex(09))*Boltzmann
*
      end
      subroutine Fe4Lev12
      implicit none
*compute populations and cooling due to 12 level Fe IV ion
      integer limelm
      parameter (limelm=30)
      integer limLevelN
      parameter (limLevelN=20)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*     include "PopLevls.com"
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real Fe4CoolTot, fe42836,fe42829,fe42567 , fe40401 ,
     1 fe41207, fe41206, fe41106, fe41007, fe41008, fe40906
*total cooling due to 12 level model FeIV atom, and three uv lines
*4P5/2 - 6S5/2, 4P3/2 - 6S5/2, and 4D+ - 6S
*Fe4CoolTot is total cooling due to entire atom, also three selectec lines
      common/fe4cool/ Fe4CoolTot, fe42836,fe42829,fe42567 , fe40401,
     1 fe41207, fe41206, fe41106, fe41007, fe41008, fe40906
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*     number of levels in model ion
      integer nlfe4
      parameter (nlfe4=12)
*
      real gfe4(nlfe4) , ex(nlfe4) , popfe4(nlfe4) , data(nlfe4,nlfe4),
     1 dest(nlfe4,nlfe4) , pump(nlfe4,nlfe4) , Fe4A(nlfe4,nlfe4) ,
     2 Fe4CS(nlfe4,nlfe4)
      real dfe4dt
      logical lgNegPop
      integer ipdest(nlfe4,nlfe4) , i , j , nFe4Neg
      data gfe4/6.,12.,10.,6.,8.,6.,4.,2.,8.,2.,6.,4./
*     these are in wavenumbers
*     data ex/ 0., 32245.5, 32293., 32301.2,
*    1  32306., 35254., 35333., 35407., 38779., 38897., 38935.,
*    2  38938./
*     excitation energies in Kelvin
      data ex/ 0., 46395.8, 46464., 46475.6,
     1  46483., 50725., 50838., 50945., 55796., 55966., 56021.,
     2  56025./
*
*     A's are from Garstang, R.H., MNRAS 118, 572 (1958).
*     each set is for a lower level indicated by second element in array,
*     index runs over upper level
*     A's are saved into arrays as data(up,lo)
      data (Fe4A(j,1), j = 1,nlfe4)/
     1 0.,0., 0., 1.E-5, 0., 1.368, .89, 0., 1.3E-3, 1.8E-4, .056, .028/
      data (Fe4A(j,2), j = 1,nlfe4)/
     2 0.,0., 2.6E-8, 5*0., 1.7E-7, 3*0./
      data (Fe4A(j,3), j = 1,nlfe4)/
     3 3*0., 0., 3.5E-7, 6.4E-10, 0., 0., 6.315E-4, 0., 6.7E-7, 0./
      data (Fe4A(j,4), j = 1,nlfe4)/
     4 4*0.,1.1E-6,6.8E-5,8.6E-6,3.4E-10,7.6E-5,1.E-7,5.8E-4,2.8E-4/
      data (Fe4A(j,5), j = 1,nlfe4)/
     5 5*0., 1.5E-5, 1.3E-9, 0., 7.6E-4, 0., 1.1E-6, 6.0E-7/
      data (Fe4A(j,6), j = 1,nlfe4)/
     6 6*0., 1.1E-5, 1.2E-13, .038, 9.9E-7, .022, .018/
      data (Fe4A(j,7), j = 1,nlfe4)/
     7 7*0., 3.7E-5, 2.9E-6, .034, 3.5E-3, .039/
      data (Fe4A(j,8), j = 1,nlfe4)/
     8  8*0., 0., .058, 3.1E-6, 1.4E-3 /
      data (Fe4A(j,9), j = 1,nlfe4)/
     9 9*0., 0., 1.3E-4, 3.1E-14/
      data (Fe4A(j,10), j = 1,nlfe4)/
     1 10*0., 1.9E-19, 1.0E-5/
      data (Fe4A(j,11), j = 1,nlfe4)/
     1 11*0., 1.3E-7/
      data (Fe4A(j,12), j = 1,nlfe4)/nlfe4*0./
*
*     collision strengths from Berrington and Pelan  Ast Ap S 114, 367.
*     order is cs(low,up)
      data (Fe4CS(i,1), i = 1,nlfe4)/nlfe4*0./
      data (Fe4CS(i,2), i = 1,nlfe4) /0.98, 11*0./
      data (Fe4CS(i,3), i = 1,nlfe4)/
     3 0.8167, 3.72, 10*0./
      data (Fe4CS(i,4), i = 1,nlfe4)/
     4 0.49, 0.0475, 0.330, 9*0./
      data (Fe4CS(i,5), i = 1,nlfe4)/
     5 0.6533, 0.473, 2.26, 1.64, 8*0./
      data (Fe4CS(i,6), i = 1,nlfe4)/
     6 0.45, 0.686, 0.446, 0.106, 0.254, 7*0./
      data (Fe4CS(i,7), i = 1,nlfe4)/
     7 0.30, 0.392, 0.152, 0.269, 0.199, 0.605, 6*0./
      data (Fe4CS(i,8), i = 1,nlfe4)/
     8 0.15, 0.0207, 0.190, 0.0857, 0.166, 0.195, 0.327, 5*0./
      data (Fe4CS(i,9), i = 1,nlfe4)/
     9 0.512, 1.23, 0.733, 0.174, 0.398, 0.623, 0.335, 0.102, 4*0./
      data (Fe4CS(i,10), i = 1,nlfe4)/
     1 0.128, 0.0583, 0.185, 0.200, 0.188, 0.0835, 0.127, 0.0498,
     1 0.0787, 3*0./
      data (Fe4CS(i,11), i = 1,nlfe4)/
     1 0.384, 0.578, 0.534, 0.363, 0.417, 0.396, 0.210, 0.171,
     1 0.810, 0.101, 2*0./
      data (Fe4CS(i,12), i = 1,nlfe4)/
     2 0.256, 0.234, 0.306, 0.318, 0.403, 0.209, 0.195, 0.112,
     1 0.195, 0.458, 0.727,0./
*
*     all elements are used, and must be set to zero if zero
      do i=1,nlfe4
        do j=1,nlfe4
          data(i,j) = 1e33
          dest(i,j) = 0.
          pump(i,j) = 0.
          ipdest(i,j) = 0
        end do
        data(i,i) = 0.
        popfe4(i) = 0.
      end do
*
*     fill in einstein As and collision strengths
      do i=1,nlfe4
        do j=i+1,nlfe4
          data(j,i) = Fe4A(j,i)
          data(i,j) = Fe4CS(i,j)
        end do
      end do
*     write(6,*)' collision strengths'
*     do i=nlfe4,2,-1
*666    write(6,'(i3,1p,12e8.1)')i,(data(j,i),j=1,i-1)
*     end do
*     write(6,*)' A s'
*     do i=nlfe4,2,-1
*665    write(6,'(i3,1p,12e8.1)')i,(data(i,j),j=1,i-1)
*     end do
*     stop
*
*     leveln itself is well-protected against zero abundances,
*     low temperatures
      call LevelN(nlfe4,nlfe4,xIonFracs(26,4),gfe4,ex ,
     1 popfe4,data,dest,pump,ipdest,
     1 Fe4CoolTot,dfe4dt,'FeIV', lgNegPop)
*     write(6,'(1p,6e11.3)') popfe4
*
      if( lgNegPop ) nFe4Neg = nFe4Neg + 1
      call coladd( 'Fe 4' , 0 , Fe4CoolTot )
      dCooldT = dCooldT + dfe4dt
*
*     three transitions hst can observe
*     4 -1 3095.9A and 5 -1 3095.9A
      fe40401 = (popfe4(4)*Fe4A(4,1) + popfe4(5)*Fe4A(5,1) )* 6.42e-12
      fe42836 = popfe4(6)* Fe4A(6,1) * 7.02e-12
      fe42829 = popfe4(7)* Fe4A(7,1) * 7.03e-12
      fe42567 = (popfe4(11)* Fe4A(11,1)+popfe4(12)* Fe4A(12,1)) *
     1 7.752e-12
      fe41207 = popfe4(12)*Fe4A(12,07)*(ex(12)-ex(07))*Boltzmann
      fe41206 = popfe4(12)*Fe4A(12,06)*(ex(12)-ex(06))*Boltzmann
      fe41106 = popfe4(11)*Fe4A(11,06)*(ex(11)-ex(06))*Boltzmann
      fe41007 = popfe4(10)*Fe4A(10,07)*(ex(10)-ex(07))*Boltzmann
      fe41008 = popfe4(10)*Fe4A(10,08)*(ex(10)-ex(08))*Boltzmann
      fe40906 = popfe4(09)*Fe4A(09,06)*(ex(09)-ex(06))*Boltzmann
*
      end
******************************************************************************
      subroutine fe2ovr
      implicit none
*compute FeII overlap with Lya
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of FeII lines in Fred's atom
      integer nfeii
      parameter (nfeii=373)
      integer limelm
      parameter (limelm=30)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real wlal
      parameter (wlal=1215.6845)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      integer ipfe2
      common/ipfe2/ ipfe2(nfeii)
      real fe2lam , fe2osc , fe2enr,fe2gs
      common/fe2pmp/ fe2lam(nfeii) , fe2osc(nfeii) ,
     1 fe2enr(nfeii),fe2gs(nfeii)
*     include "fe2pop.com"
      real feopc , Fe2TauLte , Fe2PopLte
* opacity and optical depths for ground of Fred's FeII atom
      common/fe2tau/ feopc(nfeii) , Fe2TauLte(nfeii) , Fe2PopLte(nfeii)
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real HLineWidth
*width of each alpha transition from i+1 to i (Lya is 1)
      common/hwidth/ HLineWidth(lmhlvl)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hi , hii
      common/h/ hi , hii
      real dstfe2lya , escfe2
*dstfe2lya is destruction probability for Lya onto FeII
      common/dstfe2/ dstfe2lya , escfe2
      logical lgFe2On
*logical variable that controls whether (true) or not (false)
*pumping of the FeiI model atom by HI Lya is included
      common/fe2on/ lgFe2On
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real oldrat , rate , fe2par , displa , hopc , weight ,
     1 BigHWidth , BigFeWidth , Fe2Partn
      integer i , nhits , nZoneEval
      save oldrat , BigHWidth , BigFeWidth , nZoneEval
*
*     compute efficiency of FeII emission overlapping with Ly-alpha
*     implemented with Fred Hamann
*
*     make Ly-a width monotonically increasing to avoid oscillation
*     in deep regions of x-ray ionized clouds.
*
*     do nothing if Verner FeII atom is used
      if( chFeIIAtom.eq.'Verner' ) return
*
      if( nzone.le.1 ) then
        BigHWidth = HLineWidth(1)
        BigFeWidth = doppler(26)
        nZoneEval = nzone
      endif
      if( xIonFracs(26,2).le.0. .or. .not.lgFe2On .or.HLineWidth(1).le.
     1  0. ) then
        Fe2Partn = 0.
        oldrat = 0.
        dstfe2lya = 0.
        escfe2 = 0.
        do i=1,nfeii
          Fe2PopLte(i) = 0.
        end do
        return
      else if( .not.lgNewIon ) then
        return
      endif
*     only evaluate this one time per zone to avoid oscillations
*     deep in x-ray ionized clouds
      if( nZoneEval.eq.nzone .and.nzone.gt.1 ) return
      BigHWidth = max( BigHWidth , HLineWidth(1) )
      BigFeWidth = max( BigFeWidth , doppler(26) )
      nZoneEval = nzone
*
*begin sanity check
      if( fe2lam(1).le.0. ) then
        write(qq,'('' Insane value for fe2lam array.'')')
        write(qq,'('' Was block data fe2dat linked in?'')')
        stop
      endif
*end sanity check
*
      nhits = 0
      rate = 0.
      Fe2Partn = fe2par(te)
      do i=1,nfeii
*       this is displacement from line center in units of Lya width
        displa = abs(fe2lam(i)-wlal)/wlal*3e10 / BigHWidth
        if( displa.lt.1.333 ) then
*         have variable weighting factor depending on distance away
*         this comes form the Verner's fits to Adam's results
          if( displa .le. 0.66666 ) then
            weight = 1.
          else
            weight = max(0., 1. - (displa-0.666666)/0.66666 )
          endif
          nhits = nhits + 1
          Fe2PopLte(i) = fe2gs(i) / Fe2Partn * ContBoltz(ipfe2(i)) *
     1    xIonFracs(26,2)
          feopc(i) = Fe2PopLte(i) * fe2osc(i) * 0.0150*(fe2lam(i)*1e-8)/
     1    BigFeWidth
*         Ly-alpha line-center opacity
          if( hn(1)*hii.gt.0. ) then
            hopc = 7.60e-8 * hn(1)*hii/doppler(1)
          else
            hopc = 7.60e-8 * hi/doppler(1)
          endif
          rate = rate + (feopc(i)/(feopc(i)+hopc) ) *
     1    (BigFeWidth /doppler(1))*
     1    (1. - 1./(1.+1.6* Fe2TauLte(i) ) ) * weight
        endif
      end do
*
*     dstfe2lya is total Lya deexcitation probability due to line overlap
*     damper is to stop feedback between here and hydrogen ionization sln
      dstfe2lya = ( rate + oldrat ) / 2.
      oldrat = dstfe2lya
*     ESCFE2 is that part of dstfe2lya that escapes from the cloud as FeII
*     exctau is exp(-tau) inward
      escfe2 = dstfe2lya * ExpmTau(int(tuv3(7)))
*
      end
******************************************************************************
      subroutine pfeii( io )
      implicit none
*create punch output describing pumping of FeII by Lya
      integer io
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of FeII lines in Fred's atom
      integer nfeii
      parameter (nfeii=373)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      integer ipfe2
      common/ipfe2/ ipfe2(nfeii)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real fe2lam , fe2osc , fe2enr,fe2gs
      common/fe2pmp/ fe2lam(nfeii) , fe2osc(nfeii) ,
     1 fe2enr(nfeii),fe2gs(nfeii)
      real feopc , Fe2TauLte , Fe2PopLte
* opacity and optical depths for ground of Fred's FeII atom
      common/fe2tau/ feopc(nfeii) , Fe2TauLte(nfeii) , Fe2PopLte(nfeii)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hi , hii
      common/h/ hi , hii
      real dstfe2lya , escfe2
*dstfe2lya is destruction probability for Lya onto FeII
      common/dstfe2/ dstfe2lya , escfe2
      logical lgFe2On
*logical variable that controls whether (true) or not (false)
*pumping of the FeiI model atom by HI Lya is included
      common/fe2on/ lgFe2On
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real hopc , rate
*
*     compute efficiency of FeII emission overlapping with Ly-alpha
*     implemented with Fred Hamann
*
      if( xIonFracs(26,2).le.0. .or. .not.lgFe2On .or. dstfe2lya.le.0.
     1  ) then
        write(io,'('' No Fe II in this zone'')')
        return
      endif
*
      do i=1,nfeii
*       Ly-alpha line-center opacity
        if( hii.gt.0. ) then
          hopc = 7.60e-8 * hn(1)*hii/doppler(1)
        else
          hopc = 7.60e-8 * hi/doppler(1)
        endif
        rate = (feopc(i)/(feopc(i)+hopc) ) * (doppler(26)/doppler(1))*
     1  (1. - 1./(1.+1.6* Fe2TauLte(i) ) )
*       dstfe2lya is total Lya deexcitation probability due to line overlap
        write(io,'(1p,e15.5,5e10.2)')fe2lam(i),rate/dstfe2lya
      end do
*
      end
***********************************************************************
      block data fe2dat
      implicit none
*block data storing energy levels for Fred's FeII ground
*
*     There are 373 transitions:
*     number of FeII lines in Fred's atom
      integer nfeii
      parameter (nfeii=373)
      real fe2lam , fe2osc , fe2enr,fe2gs
      common/fe2pmp/ fe2lam(nfeii) , fe2osc(nfeii) ,
     1 fe2enr(nfeii),fe2gs(nfeii)
      integer i
*
*     Wavelength (A)
      data (fe2lam(i),i=1,95)/
     :    1204.735,1204.742,1204.755,1204.762,1204.867,
     :    1204.946,1205.021,1205.028,1205.117,1205.572,
     :    1205.576,1205.606,1205.909,1205.975,1205.997,
     :    1206.188,1206.259,1206.332,1206.350,1206.428,
     :    1206.457,1206.475,1206.487,1206.527,1206.549,
     :    1206.638,1206.646,1206.695,1206.727,1206.740,
     :    1206.983,1207.020,1207.031,1207.056,1207.122,
     :    1207.174,1207.286,1207.353,1207.354,1207.360,
     :    1207.384,1207.480,1207.482,1207.516,1207.655,
     :    1207.893,1207.928,1208.013,1208.162,1208.230,
     :    1208.430,1208.430,1208.432,1208.459,1208.561,
     :    1208.630,1208.847,1208.995,1209.160,1209.207,
     :    1209.292,1209.319,1209.378,1209.431,1209.484,
     :    1209.492,1209.503,1209.504,1209.676,1209.763,
     :    1209.783,1209.829,1209.929,1209.956,1210.068,
     :    1210.073,1210.103,1210.443,1210.490,1210.561,
     :    1210.572,1210.694,1210.695,1210.744,1210.809,
     :    1210.840,1210.881,1210.948,1211.010,1211.011,
     :    1211.037,1211.226,1211.230,1211.255,1211.272/
      data (fe2lam(i),i=96,190) /
     :    1211.311,1211.330,1211.342,1211.366,1211.391,
     :    1211.432,1211.436,1211.503,1211.566,1211.578,
     :    1211.606,1211.609,1211.618,1211.644,1211.690,
     :    1211.704,1211.809,1211.818,1211.825,1211.838,
     :    1211.860,1211.883,1211.892,1211.959,1211.973,
     :    1211.986,1212.014,1212.019,1212.070,1212.084,
     :    1212.122,1212.253,1212.264,1212.356,1212.662,
     :    1212.753,1212.950,1212.966,1212.985,1213.012,
     :    1213.075,1213.090,1213.091,1213.132,1213.221,
     :    1213.412,1213.529,1213.580,1213.644,1213.719,
     :    1213.734,1213.738,1213.759,1213.767,1213.833,
     :    1213.917,1214.032,1214.061,1214.067,1214.150,
     :    1214.172,1214.251,1214.283,1214.285,1214.286,
     :    1214.398,1214.432,1214.518,1214.559,1214.735,
     :    1214.821,1214.865,1214.905,1215.051,1215.058,
     :    1215.081,1215.180,1215.183,1215.359,1215.387,
     :    1215.421,1215.490,1215.647,1215.690,1215.691,
     :    1215.707,1215.801,1215.852,1215.873,1215.983,
     :    1216.013,1216.026,1216.038,1216.141,1216.239/
      data (fe2lam(i),i=191,285) /
     :    1216.272,1216.275,1216.275,1216.483,1216.522,
     :    1216.523,1216.638,1216.769,1216.783,1216.847,
     :    1216.902,1216.908,1216.922,1216.978,1216.996,
     :    1217.011,1217.041,1217.050,1217.107,1217.118,
     :    1217.143,1217.152,1217.205,1217.291,1217.301,
     :    1217.347,1217.349,1217.486,1217.487,1217.497,
     :    1217.566,1217.583,1217.593,1217.620,1217.633,
     :    1217.707,1217.729,1217.848,1217.854,1217.878,
     :    1217.880,1217.887,1218.042,1218.053,1218.088,
     :    1218.097,1218.099,1218.108,1218.186,1218.211,
     :    1218.213,1218.275,1218.301,1218.304,1218.374,
     :    1218.395,1218.408,1218.464,1218.666,1218.668,
     :    1218.672,1218.738,1218.808,1218.833,1218.835,
     :    1218.922,1218.928,1219.125,1219.132,1219.186,
     :    1219.413,1219.424,1219.512,1219.517,1219.533,
     :    1219.621,1219.649,1219.664,1219.708,1219.713,
     :    1219.731,1219.735,1219.802,1219.978,1219.992,
     :    1220.035,1220.064,1220.132,1220.173,1220.208,
     :    1220.239,1220.264,1220.270,1220.277,1220.386/
      data (fe2lam(i),i=286,nfeii) /
     :    1220.471,1220.479,1220.522,1220.560,1220.669,
     :    1220.769,1220.807,1220.872,1220.924,1221.060,
     :    1221.067,1221.123,1221.201,1221.204,1221.459,
     :    1221.465,1221.478,1221.526,1221.536,1221.555,
     :    1221.596,1221.648,1221.763,1221.805,1221.918,
     :    1221.998,1222.025,1222.231,1222.232,1222.384,
     :    1222.433,1222.453,1222.472,1222.547,1222.658,
     :    1222.663,1222.723,1222.746,1222.825,1222.912,
     :    1222.920,1222.927,1222.971,1223.107,1223.282,
     :    1223.291,1223.320,1223.327,1223.428,1223.561,
     :    1223.590,1223.623,1223.747,1223.827,1224.075,
     :    1224.101,1224.132,1224.225,1224.278,1224.380,
     :    1224.383,1224.388,1224.391,1224.455,1224.486,
     :    1224.673,1224.696,1224.829,1224.863,1224.878,
     :    1225.059,1225.111,1225.157,1225.212,1225.273,
     :    1225.282,1225.400,1225.402,1225.412,1225.459,
     :    1225.487,1225.496,1225.577,1225.615,1225.631,
     :    1225.651,1225.661,1225.730/
*
*     absorption oscillator strength
      data (fe2osc(i),i=1,95)/
     :    2.366E-08,1.037E-04,2.506E-03,4.529E-06,5.662E-06,
     :    2.529E-04,2.157E-11,1.083E-07,1.465E-02,1.188E-05,
     :    2.792E-03,2.697E-04,7.210E-05,1.101E-09,1.660E-02,
     :    5.715E-09,9.416E-08,1.330E-08,5.081E-06,3.183E-06,
     :    2.349E-03,2.306E-05,3.846E-07,4.601E-06,4.455E-04,
     :    3.733E-08,3.898E-06,2.371E-09,5.080E-06,8.392E-05,
     :    2.142E-03,1.428E-04,8.930E-06,1.778E-05,3.427E-06,
     :    4.976E-08,5.186E-05,6.697E-04,1.079E-03,2.269E-04,
     :    5.713E-06,4.404E-06,4.580E-05,2.243E-05,7.192E-06,
     :    1.674E-02,6.484E-08,1.373E-06,1.592E-03,2.897E-03,
     :    1.717E-04,2.495E-06,1.439E-03,6.150E-04,2.697E-04,
     :    8.471E-05,2.804E-03,8.318E-03,9.245E-06,2.629E-05,
     :    1.285E-10,1.538E-05,3.926E-06,2.018E-03,3.639E-06,
     :    3.621E-06,9.591E-05,1.183E-03,1.412E-05,3.295E-04,
     :    5.034E-05,5.621E-05,2.588E-03,9.681E-05,9.264E-07,
     :    7.012E-05,1.492E-09,1.028E-06,2.132E-08,1.180E-05,
     :    2.239E-06,1.857E-06,3.732E-04,4.225E-06,1.479E-03,
     :    8.014E-06,7.673E-06,2.600E-09,1.161E-04,1.270E-03,
     :    1.614E-03,3.793E-06,5.080E-05,2.666E-04,5.928E-03/
      data (fe2osc(i),i=96,190) /
     :    2.910E-04,9.141E-05,8.587E-07,1.242E-05,1.297E-05,
     :    2.466E-07,1.968E-06,1.216E-09,3.146E-04,1.262E-03,
     :    2.322E-07,1.663E-08,1.279E-04,1.667E-06,7.887E-04,
     :    8.259E-05,8.182E-06,4.864E-09,5.164E-08,2.930E-04,
     :    6.484E-06,4.808E-05,4.365E-06,9.791E-10,1.374E-04,
     :    4.017E-03,1.094E-05,2.172E-03,8.951E-06,4.539E-07,
     :    6.947E-08,1.227E-11,1.932E-08,9.747E-04,2.991E-08,
     :    4.416E-05,1.651E-08,4.275E-03,1.030E-08,4.374E-08,
     :    1.510E-05,8.570E-05,7.852E-03,2.612E-02,9.837E-06,
     :    4.018E-03,2.133E-06,4.548E-06,3.040E-04,7.328E-05,
     :    1.442E-08,1.216E-01,1.116E-01,9.683E-07,1.573E-06,
     :    1.581E-05,1.297E-05,1.585E-09,4.709E-03,1.603E-02,
     :    2.449E-06,1.438E-05,8.372E-07,3.443E-03,1.782E-08,
     :    7.310E-04,3.228E-03,1.706E-07,2.697E-07,2.143E-04,
     :    6.278E-06,2.647E-05,1.857E-06,2.698E-07,1.648E-03,
     :    6.053E-07,5.458E-06,2.647E-03,4.294E-05,7.798E-07,
     :    1.183E-06,1.309E-06,1.503E-06,1.106E-05,2.113E-03,
     :    2.197E-04,4.611E-07,1.541E-03,3.792E-03,1.482E-04,
     :    1.794E-04,1.294E-04,5.727E-04,8.259E-08,1.191E-03/
      data (fe2osc(i),i=191,285) /
     :    1.112E-03,1.339E-03,2.042E-06,6.107E-05,5.270E-05,
     :    2.466E-03,9.814E-05,4.036E-05,7.548E-05,3.404E-03,
     :    5.000E-05,1.023E-09,4.285E-06,5.571E-06,1.737E-07,
     :    3.097E-07,6.901E-06,2.138E-06,4.149E-07,1.807E-05,
     :    1.644E-05,1.493E-03,2.089E-03,6.380E-08,3.681E-03,
     :    6.010E-07,2.761E-06,1.671E-04,6.095E-09,2.766E-06,
     :    9.078E-05,7.816E-07,1.879E-06,3.523E-03,1.361E-10,
     :    1.309E-04,2.377E-06,4.017E-03,1.049E-04,9.418E-06,
     :    3.133E-06,1.035E-07,3.707E-06,7.128E-07,1.333E-04,
     :    1.659E-04,1.746E-06,2.890E-08,2.494E-03,3.289E-09,
     :    3.953E-03,6.081E-06,4.932E-05,4.943E-09,1.239E-08,
     :    9.547E-04,2.079E-06,1.230E-02,5.345E-05,2.426E-06,
     :    1.386E-04,9.549E-06,9.590E-04,8.034E-05,6.252E-09,
     :    4.120E-05,2.366E-06,3.971E-06,1.503E-10,7.815E-08,
     :    2.818E-04,5.873E-06,2.471E-07,5.584E-08,5.943E-06,
     :    5.358E-05,2.332E-08,3.774E-06,1.014E-05,5.283E-06,
     :    3.890E-07,2.223E-07,4.665E-02,5.740E-08,2.773E-06,
     :    2.393E-08,2.824E-07,1.084E-06,4.753E-05,2.296E-04,
     :    5.927E-06,2.157E-05,5.874E-07,4.786E-06,2.978E-03/
      data (fe2osc(i),i=286,nfeii) /
     :    3.630E-08,1.007E-07,9.033E-05,3.061E-04,6.037E-06,
     :    7.798E-05,3.281E-05,1.625E-03,1.534E-04,7.292E-08,
     :    2.122E-07,6.484E-04,5.559E-05,3.013E-05,1.725E-04,
     :    4.345E-04,1.096E-04,7.396E-06,1.074E-09,1.409E-04,
     :    3.589E-04,4.236E-05,8.510E-06,1.986E-03,2.410E-06,
     :    2.786E-08,8.707E-06,3.303E-05,2.280E-06,7.533E-04,
     :    5.534E-06,1.932E-05,4.083E-06,2.207E-05,4.091E-05,
     :    6.774E-08,8.165E-05,5.874E-06,9.247E-07,4.374E-11,
     :    2.443E-03,9.290E-07,2.248E-07,1.023E-07,2.850E-03,
     :    3.420E-04,7.551E-08,7.278E-07,6.426E-07,1.156E-05,
     :    3.083E-05,1.247E-04,1.161E-05,2.317E-05,4.149E-06,
     :    2.773E-06,4.907E-02,1.514E-04,1.725E-03,4.294E-04,
     :    1.233E-06,6.727E-04,6.107E-06,7.534E-06,1.074E-07,
     :    1.578E-03,8.993E-07,1.531E-05,8.051E-06,3.341E-10,
     :    1.202E-07,8.994E-06,7.226E-05,7.028E-04,1.678E-08,
     :    5.224E-07,3.775E-05,2.654E-06,9.244E-05,8.570E-05,
     :    1.345E-04,1.207E-02,8.432E-06,7.210E-09,1.840E-04,
     :    6.995E-06,3.871E-07,3.655E-05/
*
*     Energy of lower level (Ryd)
      data (fe2enr(i),i=1,95)/
     :    0.0079,0.2350,0.2351,0.0806,0.0806,
     :    0.2350,0.1853,0.1853,0.2385,0.2517,
     :    0.2374,0.0725,0.2367,0.0035,0.2401,
     :    0.1896,0.1870,0.1896,0.0791,0.1870,
     :    0.2367,0.2517,0.1896,0.1228,0.1898,
     :    0.1896,0.1870,0.1896,0.1870,0.1898,
     :    0.2374,0.2517,0.1870,0.1898,0.2350,
     :    0.1898,0.1898,0.2367,0.2351,0.0725,
     :    0.1870,0.1870,0.0765,0.1898,0.1228,
     :    0.2317,0.2517,0.1853,0.2063,0.2351,
     :    0.2374,0.1444,0.2350,0.2489,0.1228,
     :    0.1942,0.2374,0.2351,0.2489,0.2385,
     :    0.1988,0.1444,0.1721,0.0725,0.1942,
     :    0.1853,0.0765,0.2351,0.1870,0.2489,
     :    0.1942,0.0765,0.2367,0.2367,0.1853,
     :    0.2385,0.0061,0.1896,0.1853,0.1246,
     :    0.2769,0.2489,0.2078,0.1870,0.2367,
     :    0.1898,0.2350,0.1896,0.1898,0.2374,
     :    0.2374,0.1942,0.1898,0.2385,0.2367/
      data (fe2enr(i),i=96,190) /
     :    0.1898,0.2401,0.1853,0.2769,0.1942,
     :    0.1896,0.1444,0.1853,0.2317,0.2367,
     :    0.2489,0.1896,0.1898,0.0725,0.1492,
     :    0.0791,0.1228,0.1896,0.1896,0.0791,
     :    0.1870,0.2401,0.1721,0.1853,0.1898,
     :    0.0765,0.1870,0.0765,0.1898,0.2769,
     :    0.1853,0.1853,0.2769,0.2374,0.2374,
     :    0.2401,0.1953,0.0725,0.1967,0.1936,
     :    0.1870,0.1444,0.2351,0.0725,0.1870,
     :    0.2351,0.2350,0.2385,0.2517,0.2063,
     :    0.1942,0.0791,0.0765,0.1967,0.1228,
     :    0.1896,0.1870,0.1942,0.0791,0.0806,
     :    0.1942,0.2517,0.1898,0.0806,0.1942,
     :    0.0725,0.2350,0.1942,0.1978,0.1246,
     :    0.2374,0.2385,0.1978,0.1967,0.2063,
     :    0.2350,0.1967,0.2317,0.1898,0.2401,
     :    0.1978,0.1953,0.1953,0.1978,0.2367,
     :    0.2489,0.1953,0.0765,0.2317,0.0765,
     :    0.2367,0.2489,0.1988,0.1492,0.0791/
      data (fe2enr(i),i=191,285) /
     :    0.0791,0.2078,0.2401,0.1898,0.0765,
     :    0.0806,0.1898,0.1246,0.2374,0.2063,
     :    0.1988,0.2803,0.1896,0.1978,0.1936,
     :    0.1936,0.1492,0.2401,0.1978,0.2351,
     :    0.2350,0.0791,0.1988,0.1853,0.2367,
     :    0.1978,0.1896,0.2374,0.1896,0.1492,
     :    0.2401,0.1967,0.1942,0.2078,0.2803,
     :    0.1898,0.1967,0.0725,0.1898,0.1942,
     :    0.1942,0.1967,0.1967,0.1942,0.0765,
     :    0.2042,0.1967,0.1246,0.2090,0.1896,
     :    0.0725,0.1942,0.2351,0.1896,0.1896,
     :    0.2374,0.1936,0.2454,0.1988,0.1942,
     :    0.1898,0.0806,0.2385,0.1988,0.1896,
     :    0.1673,0.2350,0.1942,0.1896,0.1492,
     :    0.1444,0.0765,0.1853,0.1978,0.0171,
     :    0.0806,0.1953,0.1953,0.1870,0.1978,
     :    0.1492,0.2367,0.1936,0.1978,0.0791,
     :    0.1978,0.2350,0.0791,0.2769,0.1267,
     :    0.2517,0.0791,0.1978,0.2350,0.2350/
      data (fe2enr(i),i=286,nfeii) /
     :    0.2350,0.0725,0.1870,0.2517,0.1953,
     :    0.2351,0.0791,0.0765,0.2367,0.1953,
     :    0.1953,0.2374,0.2401,0.1988,0.1936,
     :    0.2351,0.2350,0.2401,0.1988,0.1267,
     :    0.2454,0.1988,0.1988,0.2454,0.1967,
     :    0.1988,0.2374,0.1942,0.2350,0.0791,
     :    0.1967,0.1942,0.0806,0.2385,0.2317,
     :    0.1936,0.2350,0.0806,0.2769,0.0725,
     :    0.2374,0.1967,0.1936,0.1967,0.2367,
     :    0.0806,0.1967,0.1967,0.2350,0.1936,
     :    0.1942,0.2351,0.1942,0.2350,0.1978,
     :    0.2367,0.1953,0.2769,0.2374,0.2367,
     :    0.1978,0.2374,0.1898,0.2769,0.2350,
     :    0.2351,0.1978,0.1942,0.1936,0.1978,
     :    0.1978,0.1988,0.1978,0.1898,0.1978,
     :    0.2401,0.1988,0.1988,0.1228,0.1967,
     :    0.2374,0.1936,0.1988,0.2489,0.2367,
     :    0.1953,0.1936,0.2350/
*
*     Statistical weight of lower level (g)
      data (fe2gs(i),i=1,95)/
     :     4, 4,10, 2, 2,
     :     4,12,12,12, 6,
     :     6, 8, 8, 8,10,
     :    10, 6,10, 4, 6,
     :     8, 6,10, 6, 6,
     :    10, 6,10, 6, 6,
     :     6, 6, 6, 6, 4,
     :     6, 6, 8,10, 8,
     :     6, 6, 6, 6, 6,
     :    12, 6,12,10,10,
     :     6,10, 4, 8, 6,
     :     4, 6,10, 8,12,
     :     4,10, 2, 8, 4,
     :    12, 6,10, 6, 8,
     :     4, 6, 8, 8,12,
     :    12, 6,10,12, 4,
     :    10, 8, 8, 6, 8,
     :     6, 4,10, 6, 6,
     :     6, 4, 6,12, 8/
      data (fe2gs(i),i=96,190) /
     :     6,10,12,10, 4,
     :    10,10,12,12, 8,
     :     8,10, 6, 8, 8,
     :     4, 6,10,10, 4,
     :     6,10, 2,12, 6,
     :     6, 6, 6, 6,10,
     :    12,12,10, 6, 6,
     :    10,12, 8,10,14,
     :     6,10,10, 8, 6,
     :    10, 4,12, 6,10,
     :     4, 4, 6,10, 6,
     :    10, 6, 4, 4, 2,
     :     4, 6, 6, 2, 4,
     :     8, 4, 4, 8, 4,
     :     6,12, 8,10,10,
     :     4,10,12, 6,10,
     :     8,12,12, 8, 8,
     :     8,12, 6,12, 6,
     :     8, 8, 4, 8, 4/
      data (fe2gs(i),i=191,285) /
     :     4, 8,10, 6, 6,
     :     2, 6, 4, 6,10,
     :     4, 8,10, 8,14,
     :    14, 8,10, 8,10,
     :     4, 4, 4,12, 8,
     :     8,10, 6,10, 8,
     :    10,10, 4, 8, 8,
     :     6,10, 8, 6, 4,
     :     4,10,10, 4, 6,
     :     2,10, 4, 6,10,
     :     8, 4,10,10,10,
     :     6,14, 2, 4, 4,
     :     6, 2,12, 4,10,
     :     4, 4, 4,10, 8,
     :    10, 6,12, 8,10,
     :     2,12,12, 6, 8,
     :     8, 8,14, 8, 4,
     :     8, 4, 4,10, 2,
     :     6, 4, 8, 4, 4/
      data (fe2gs(i),i=286,nfeii) /
     :     4, 8, 6, 6,12,
     :    10, 4, 6, 8,12,
     :    12, 6,10, 4,14,
     :    10, 4,10, 4, 2,
     :     2, 4, 4, 2,10,
     :     4, 6, 4, 4, 4,
     :    10, 4, 2,12,12,
     :    14, 4, 2,10, 8,
     :     6,10,14,10, 8,
     :     2,10,10, 4,14,
     :     4,10, 4, 4, 8,
     :     8,12,10, 6, 8,
     :     8, 6, 6,10, 4,
     :    10, 8, 4,14, 8,
     :     8, 4, 8, 6, 8,
     :    10, 4, 4, 6,10,
     :     6,14, 4, 8, 8,
     :    12,14, 4/
      END
******************************************************************************
      real function fe2par( te )
      implicit none
*evaluate FeII partition function
      real te
      integer nfe2pr , i
      parameter (nfe2pr=61)
      real fe2pt(nfe2pr) , fe2pf(nfe2pr) , slope,du
*
*     function to evaluate partition function for FeII
*
*     Temperature (K)
      data fe2pt/
     :    1.000E+00,5.000E+00,2.000E+01,5.000E+01,1.000E+02,
     :    2.000E+02,3.000E+02,5.000E+02,7.000E+02,1.000E+03,
     :    1.200E+03,1.500E+03,2.000E+03,2.500E+03,3.000E+03,
     :    3.500E+03,4.000E+03,4.500E+03,5.000E+03,5.500E+03,
     :    6.000E+03,6.500E+03,7.000E+03,7.500E+03,8.000E+03,
     :    8.500E+03,9.000E+03,9.500E+03,1.000E+04,1.100E+04,
     :    1.200E+04,1.300E+04,1.400E+04,1.500E+04,1.600E+04,
     :    1.700E+04,1.800E+04,1.900E+04,2.000E+04,2.200E+04,
     :    2.400E+04,2.600E+04,2.800E+04,3.000E+04,3.500E+04,
     :    4.000E+04,4.500E+04,5.000E+04,5.500E+04,6.000E+04,
     :    6.500E+04,7.000E+04,7.500E+04,8.000E+04,8.500E+04,
     :    9.000E+04,9.500E+04,1.000E+05,1.050E+05,1.100E+05,
     :    1.150E+05/
*
*     Partition Fct.
      data fe2pf/
     :    1.000E+01,1.000E+01,1.000E+01,1.000E+01,1.003E+01,
     :    1.056E+01,1.159E+01,1.403E+01,1.639E+01,1.960E+01,
     :    2.157E+01,2.426E+01,2.816E+01,3.146E+01,3.431E+01,
     :    3.684E+01,3.915E+01,4.132E+01,4.341E+01,4.547E+01,
     :    4.755E+01,4.967E+01,5.185E+01,5.411E+01,5.646E+01,
     :    5.891E+01,6.146E+01,6.412E+01,6.688E+01,7.273E+01,
     :    7.903E+01,8.576E+01,9.295E+01,1.006E+02,1.087E+02,
     :    1.174E+02,1.265E+02,1.362E+02,1.465E+02,1.689E+02,
     :    1.938E+02,2.214E+02,2.517E+02,2.846E+02,3.781E+02,
     :    4.855E+02,6.038E+02,7.301E+02,8.616E+02,9.959E+02,
     :    1.131E+03,1.266E+03,1.399E+03,1.530E+03,1.658E+03,
     :    1.782E+03,1.903E+03,2.020E+03,2.134E+03,2.243E+03,
     :    2.349E+03/
*
      if( te.lt.1. ) then
        fe2par = 10.
      else if( te.gt.fe2pt(nfe2pr) ) then
        fe2par = fe2pf(nfe2pr)
      else
        call locate( fe2pt , nfe2pr , te , i )
        slope = (fe2pf(i+1) - fe2pf(i) ) / ( fe2pt(i+1)-fe2pt(i) )
        du = slope * (te - fe2pt(i) )
        fe2par = fe2pf(i) + du
      endif
*
      end
******************************************************************************
      subroutine locate(xx,n,x,j)
      implicit none
*locate value within array
      integer n , j
      real xx(n) , x
*
*     local variables
      integer jl , ju , jm
*
*     This gives the index J of the array XX(J) such that XX(J) < X < XX(J+1),
*     where X (in our case the temperature) is provided.
*     when x exactly equals xx(j), returns xx(j+1)
      jl=0
      ju=n+1
*10   if(ju-jl.gt.1)then
      do while( ju-jl.gt.1 )
        jm=(ju+jl)/2
        if((xx(n).gt.xx(1)).eqv.(x.gt.xx(jm)))then
          jl=jm
        else
          ju=jm
        endif
*     go to 10
      end do
      j=jl
*
      end
******************************************************************************
      real function fhummr( beta )
      implicit none
*evaluate Hummer's F(beta) function
      real beta
*
*     local variables
      real x
*
*     evaluates Hummer's F(beta) function for case where damping
*     constant is zero, are returns beta*F(beta)
*     fit to Table 1, page 80, of Hummer MNRAS 138, 73-108.
*     beta is ratio of continuum to line opacity; FUMMER is
*     product of his F() times beta; the total destruction prob
*     this beta is Hummer's normalization of the Voigt function
      if( beta.le.0. ) then
         fhummr = 0.
      else
         x = log10( beta )
         if( x.lt. -5.5 ) then
            fhummr = 3.8363 - 0.56329*x
         else if( x.lt.-3.5 ) then
            fhummr = 2.79153 - 0.75325 * x
         else if( x.lt. -2. ) then
            fhummr = 1.8446 - 1.0238*x
         else
            fhummr = 0.72500 - 1.5836 * x
         endif
         fhummr = fhummr * beta
      endif
*
      end
******************************************************************************
      subroutine fiddle( ipnt , exact )
      implicit none
*adjust energy bounds of certain cells so that match ionization edges exactly
      integer ipnt
      real exact
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real bhi , blo, extra , anuold
*
*     make low edge of cell exact for photo integrals
*begin sanity checks
      if(ipnt.lt.1 .or. ipnt.gt.ncell ) then
        write(qq,'('' fiddle called with insane ipnt'',i5)')ipnt
        stop
      endif
      bhi = anu(ipnt+1) - widflx(ipnt+1)*0.5
      blo = exact
      extra = widflx(ipnt) - (bhi-blo)
      anu(ipnt-1) = anu(ipnt-1) + extra*0.5
      widflx(ipnt-1) = widflx(ipnt-1) + extra
      widflx(ipnt) = bhi - blo
      anuold = anu(ipnt)
      anu(ipnt) = (bhi + blo) / 2.
      if( widflx(ipnt).le.0. ) then
         write(qq,'('' logic error in FIDDLE; EXACT, IPNT='',1P,E10.2,
     1   0p,i5)') exact,ipnt
         write(qq,'('' anu(ipnt)='',1p,e11.3)') anuold
         stop
      endif
*
      end
******************************************************************************
      subroutine fill( enlo , enhi , resolv , n0 , ipnt )
      implicit none
*define the continuum energy grid over a specified range
      real enlo , enhi , resolv
      integer n0 , ipnt
*
      integer nfill
      parameter (nfill=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgPtrace
*flag set with drive pointers command
      common/PltTrace/ lgPtrace
      logical lgConBug
*flag set with trace continuum command
      common/conbug/ lgConBug
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real filbnd,fildel,filres
      integer ifill0 , nrange
      common/fillnu/ filbnd(nfill+1),fildel(nfill),filres(nfill),
     1 ifill0(nfill) , nrange
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , nbin
      real widtot
*
*     nrange is number of ranges
      ipnt = ipnt + 1
      if( ipnt.gt.1 .and.enlo.ne. filbnd(ipnt) ) then
        write(qq,'('' FILL improper bounds.'')')
        stop
      endif
      nrange = max( nrange , ipnt )
*
      if( ipnt.gt.nfill ) then
        write(qq,'('' The limit to the number of FILL ranges is'',
     1  i4)') nfill
        stop
      endif
      ifill0(ipnt) = n0 - 1
      filbnd(ipnt) = enlo
      filbnd(ipnt+1) = enhi
      nbin = log( 10. ) * log10( enhi / enlo ) / resolv + 1
      fildel(ipnt) = log10( enhi/enlo ) / nbin
      if( fildel(ipnt).lt.0.01 ) then
        filres(ipnt) = log(10.) * fildel(ipnt)
      else
        filres(ipnt) = (10.**(2.*fildel(ipnt)) - 1.)/
     1  2. / 10.**fildel(ipnt)
      endif
      if( n0+nbin.gt.ncell ) then
        write(qq,'('' Fill would need'',I4,'' cells to get to an'',
     1  '' energy of'',1P,E10.3)') n0+nbin , enhi
        write(qq,'('' Increase NCELL in all parameter statements.'',
     1  ''  The current value is'',i6)') ncell
        stop
      endif
*
      widtot = 0.
      do i=1,nbin
        anu(i+ifill0(ipnt)) = enlo * 10.**(fildel(ipnt)*(float(i)-0.5))
        widflx(i+ifill0(ipnt)) = anu(i+ifill0(ipnt)) * filres(ipnt)
        widtot = widtot + widflx(i+ifill0(ipnt))
      end do
*
      n0 = n0 + nbin
      if( lgTrace.and.(lgConBug.or.lgPtrace) ) then
        write(qq,'('' FILL range'',I2,'' from'',1P,E10.3,'' to'',
     1  E10.3,''R in'',I4,'' cell; ener res='',E10.3,'' WIDTOT='',E10.3
     2  )') ipnt , anu(ifill0(ipnt)+1)-widflx(ifill0(ipnt)+1)/2. ,
     3  anu(ifill0(ipnt)+nbin)+widflx(ifill0(ipnt)+nbin)/2.,nbin,
     4  filres(ipnt),widtot
        write(qq,'('' The requested range was'',1P,2E10.3,'' The '',
     1  ''requested resolution was'',E10.3)') enlo , enhi , resolv
      endif
*
      end
******************************************************************************
      subroutine fillar
      implicit none
*read in line images, fill into cloudy arrays
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      logical lgVaryOn
*flag set true if vary option used
      common/vary/ lgVaryOn
      logical lgOptimr
*flag set true if optimize command entered
      common/optimr/ lgOptimr
      logical lgReadIn , lgScanar
*flag lgReadIn set if we are to read in line images (cdRead never called)
*flag lsScanar set true in cdInit:w
*lgScanar is not used at all - confirm then remove
      common/readin/ lgReadIn , lgScanar
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgNoVary , lgMatch
      character chK1*1 , chCard*80 , chLine*132
      integer ierr
*
*     read until eof or blank line
      if( .not.lgReadIn ) return
      lgNoVary = .false.
      nSave = 1
*98   READ(5,'(A80)',END=999) chCardSav(nSave)
*98   READ(5,'(A132)',END=999) chLine
      read(5,'(a132)',iostat=ierr ) chLine
*     this is trick so that cloudy input can read cloudy output
      if( chLine(1:25).EQ. '                       * ')THEN
        chCardSav(nSave)(1:80) = chLine(26:105)
      else
        chCardSav(nSave)(1:80) = chLine(1:80)
      endif
*     read until eof or blank line
      do while( ierr.eq.0 .and.chCardSav(nSave)(1:1).ne.' ' )
*       totally ignore any card starting with a #, *, or %
        chK1 = chCardSav(nSave)(1:1)
*       if( chK1.EQ.'#' .OR. chK1.EQ.'*' .OR. chK1.EQ.'%' ) go to98
        if( chK1.ne.'#' .and. chK1.ne.'*' .and. chK1.ne.'%' ) then
*         save line image
          if( nSave.ge.(nkrd-nSaveIni) ) then
            write(qq,'('' The limit to the number of allowed input '',
     1      ''lines is'',I4,''.  This limit was exceeded.  Sorry.'')')
     2      nkrd
            write(qq,'('' This limit is set by the variable NKRD '',
     1      ''which appears in parameter statements throughout the'',
     2      '' code.'')')
            write(qq,'('' Increase it everywhere it appears.'')')
            write(qq,'('' nSave, nkrd, nSaveIni='',3i6)')  nSave,nkrd,
     1      nSaveIni
            stop
          endif
*         now check whether VARY is specified
          chCard = chCardSav( nSave )
          call caps( chCard )
          if( lgMatch( 'VARY' , chCard ) ) then
            lgVaryOn = .true.
          endif
          if( chCard(1:4).eq.'OPTI' ) then
            lgOptimr = .true.
          endif
*         now check whether line is "no vary" command
          if( chCard(1:7).eq.'NO VARY' ) lgNoVary = .true.
          nSave = nSave + 1
        endif
        read(5,'(a132)',iostat=ierr ) chLine
*       this is trick so that cloudy input can read cloudy output
        if( chLine(1:25).EQ. '                       * ')THEN
          chCardSav(nSave)(1:80) = chLine(26:105)
        else
          chCardSav(nSave)(1:80) = chLine(1:80)
        endif
      end do
*
*999  continue
      nSave = nSave - 1
*
*     possible to have VARY on line without OPTIMIZE being set
      if( lgOptimr.and.lgVaryOn ) then
        lgVaryOn = .true.
      else
        lgVaryOn = .false.
      endif
*
*     this is option to have command line saying "no vary"
*     to turn off optimizer
      if( lgNoVary ) lgVaryOn = .false.
*
      end
******************************************************************************
      subroutine final
      implicit none
*create final pages of printout, emission line intensities, etc
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real solarm
*     solar mass in grams
      parameter (solarm=1.9892e33)
      real pi
      parameter ( pi=3.141592654 )
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      real TotMassColl , tmas , wmas
*variables to do with mean mass per particle over model,
*called <Mol> in final print out, used to get Jeans mass
      common/colmas/ TotMassColl , tmas , wmas
      real rjnmin , ajmmin
      common/jmin/ rjnmin , ajmmin
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      integer lhytot
      common/lhytot/ lhytot
      real AccelAver , acldr
*variables for tracking average radiative acceleration
      common/aclbar/ AccelAver , acldr
      real tcmptn , ttherm
      common/timesc/ tcmptn , ttherm
      real TimeErode
*timescale for photoerosion of iron due to gamma rays
      common/terode/ TimeErode
      real thist , tlowst
      common/tehigh/ thist , tlowst
      integer iontot
      common/iontot/ iontot
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real r1r0sq
      common/r1r0sq/ r1r0sq
*flag saying that calculation stopped for bad reason
*mostly set in endfun
      logical lgBadStop
      common/badstp/ lgBadStop
      logical lgIterAgain
*flag saying that another iteration is needed
      common/itagan/ lgIterAgain
      logical lgWarngs , lgCautns
*flags set if warnings or cautions present
      common/warngs/ lgWarngs , lgCautns
      logical lgUSphON
*lgUSphON flag set when we hit stromgren radius in spherical geometry
      real rstrom
      common/uspher/ lgUSphON , rstrom
      real qhtot , qhe , qheii , qbal , qrad , qtot
      common/qs/ qhtot , qhe , qheii , qbal , qrad , qtot
      logical lgLastIt
*     this is false on any but the last iteration
*     set true in startr if iter > itermx
      common/lastit/ lgLastIt
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgPrtShort
*flag set with print short comand
      common/pshort/ lgPrtShort
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      logical lgFaintOn
*logical lgFaintOn normally true, says to not print very faint lines
*set false with print faint off command
*lines fainter than TooFaint will not be printed.  This is set in zerologic
*and reset with print line faint command
      real TooFaint
      common/faint/ TooFaint , lgFaintOn
      real prall , psort
      common/prall/ prall , psort
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      double precision dlnenp
      common/abrems/ dlnenp
      real workft , workfz
      common/workf/ workft , workfz
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      character chDate*7 , chVersion*7
      common/date/ chDate , chVersion
      real reftot,avhden,chii, avdust , avdpot , thtot
      common/toiii/ reftot,avhden,chii,
     1 avdust(ndust) , avdpot(ndust) , thtot
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real uh,uheii
      common/u/ uh,uheii
      real te , eden , hden
      common/phycon/ te , eden , hden
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      real sound,vsound
*     vsound is local sound speed, eval zone by zone
*     sound is sound travel time (sec) updated in tauing
      common/sound/ sound,vsound
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real hi , hii
      common/h/ hi , hii
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      character*4  chSMDLab
      common/smdlab/ chSMDLab(NLINES)
      integer ndsum , lind
      real smdlin
      common/dsum/ ndsum , smdlin(NLINES) , lind(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      character chDstLab*10
*     labels for types of dust grains
      common/dstlab/ chDstLab(ndust)
*     include "dhla.com"
      integer ipxry
      real tauxry
      common/xry/ ipxry , tauxry
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      logical lgCylnOn
*lgCylnOn set true when cylinder command given
*cylind is half height in centimeters
      real CylindHigh
      common/cylind/ CylindHigh , lgCylnOn
      real toiiir, tbac, t2hstr,tohyox,t2hyox,tbcthn,t2o3str,tsqden
*     tsqden is the highest hydrogen density to do print peimbert analysis
      common/peimbt/ toiiir, tbac, t2hstr,tohyox,t2hyox,tbcthn,t2o3str,
     1 tsqden
      real o3cs12 , o3cs13 , o3ex23 , o3br32 , o3enro
      common/o3data/ o3cs12 , o3cs13 , o3ex23 , o3br32 , o3enro
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      logical lgPrnPump , lgPrnHeat , lgPrnColl , lgPrnInwd,lgPrnDiff
      common/PrnLine/ lgPrnPump , lgPrnHeat , lgPrnColl , lgPrnInwd,
     1 lgPrnDiff
      integer nBetaVer
*     normally zero, non-zero if this is a beta test version
      common/BetaVer/ nBetaVer
      integer nHTopOff
      character chHTopType*4
      common/HTopOff/ nHTopOff , chHTopType
      logical lgQHeat
*Kevin Volk add for quantum heating of grains
      common/qheat/ lgQHeat(ndust)
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real d(32)
      integer index(32)
      logical lgOK
      integer i , j , nd , ipoint , ip2kev , ip2500,nline,nlow,iprnt,
     1 nneg
      character chLab(ndust)*10
      real alfox , ajmin,ajmass,rjeans,tmean,wmean,ferode,rate,
     1 hescal,znit,bremtk,coleff , dmean,totlin,powerl,uhel,uhl,usp,
     2 pion,qlow,plow,reclin,qion,bottom,tb,hbcab,bacthn, ratio,
     1 bot,absint,o4363,o5007,he5876,he4686,hbeta,a,bacobs,heabun,
     3 top
*
      character*20 chPlaw , chGeo*6 , chKey*4 , chCKey*4
      character chSLab(NLINES)*4 , chSTyp(NLINES)*1
      real sclsav(NLINES)
      logical lgPrt(NLINES)
      double precision bac , x,tel
      integer linsav(NLINES)
*
*     free statement labels >=20
*     return if not talking
      if( .not.lgTalk ) return
*
*     print out header, or parts that were saved
*
*     this would be a major logical error
      if( nsum .le. 1 ) then
        if( lgCalled ) then
          lgBusted = .true.
          return
        else
          stop
        endif
      endif
*
      write(qq,'(''1''/23X,33(''*''),''> Cloudy '',a7,'' <'',
     1 32(''*''))') chVersion
      do i=1,nSave
        chKey = chCardSav(i)(1:4)
        call cap4( chKey, chCKey )
        if(chCKey.ne.'CONT' )
     1  write(qq,'(23X,''*'',1X,A80,''*'')') chCardSav(i)
      end do
      if( uh.gt.0. ) then
        a = log10( uh )
      else
        a = -37.
      endif
      write(qq,'(23X,33(''*''),''> Log(U):'',F6.2,'' <'',33(''*''))')a
*
      if( nBetaVer.gt.0 ) write(qq,'(/24x,''This is a beta test '',
     1''version of the code, and should not be used for publications.''/
     2)')
*
      if( lgWarngs ) then
        write(qq,'(''  '')')
        write(qq,'(23X,10(''>''),'' Warning!'')')
        write(qq,'(23X,10(''>''),'' Warning!'')')
        write(qq,'(23X,10(''>''),'' Warning!  Warnings exist, this '',
     1  ''calculation has serious problems.'')')
        write(qq,'(23X,10(''>''),'' Warning!'')')
        write(qq,'(23X,10(''>''),'' Warning!'')')
        write(qq,'(''  '')')
      else if( lgCautns ) then
        write(qq,'(23X,10(''>''),'' Cautions are present.'')')
      endif
*
      if( lgBadStop ) then
        write(qq,'(23X,10(''>''),'' The calculation stopped for '',
     1  ''unintended reasons.'')')
      endif
*
      if( lgIterAgain ) then
        write(qq,'(23X,10(''>''),'' Another iteration is needed.'')')
      endif
*
      arealg = pirsq
*
*     open or closed geometry??
      if( lgSphere ) then
         chGeo = 'Closed'
      else
         chGeo = '  Open'
      endif
*
      if( chCPres.eq. 'CPRE' ) then
         chPlaw = ' Constant  Pressure '
      else if( chCPres.eq. 'CDEN' ) then
         chPlaw = '  Constant  Density '
      else if( chCPres.eq. 'POWD' .or.  chCPres.eq. 'POWR' .or.
     1   chCPres.eq.'POWC' ) then
         chPlaw = '  Power Law Density '
      else if( chCPres.eq. 'SINE' ) then
         chPlaw = ' Rapid Fluctuations '
      else if( chCPres(1:3).eq. 'DLW' ) then
         chPlaw = ' Special Density Lw '
      else if( chCPres.eq. 'TIME' ) then
         chPlaw = '   Time  Dependent  '
      else if( chCPres.eq. 'HYDR' ) then
         chPlaw = ' Hydrostatic Equlib '
      else if( chCPres.eq. 'WIND' ) then
         chPlaw = '  Radia Driven Wind '
      else if( chCPres.eq. 'GLOB' ) then
         chPlaw = ' Globule            '
      else
         chPlaw = ' UNRECOGNIZED CPRES '
      endif
      write(qq,'(/,21X,''Emission Line Spectrum. '',A20,''Model.  '',A6,
     1'' geometry.  Iteration''
     1,I2,'' of'',I2,''.'')') chPlaw , chGeo,iter , itermx+1
*
*     emission lines as logs of total luminosity
*     either per unit inner area (lgFourPi=.F.), or FOUR PI R SQRD (=.T.)
      if( lgFourPi ) then
*       four pi r^2, prog works in sqr cm, multiply by this
        if( lgCylnOn ) then
          write(qq,'(40X,'' Luminosity (erg/s) emitted by partial ''
     1    ,'' cylinder.'')')
        else if( covgeo.eq.1. ) then
          write(qq,'(36X,'' Luminosity (erg/s) emitted by shell with''
     1    ,'' full coverage.'')')
        else
          write(qq,'(30X,'' Luminosity (erg/s) emitted by shell with''
     1    ,'' a covering factor of'',F6.1,''%.'')') covgeo*100.
        endif
      else
        write(qq,'(51X,'' Intensity (erg/s/cm^2)'')')
      endif
*
*     throw a blank line
      write(qq,'(1x,a1)') ' '
*
      snorm = sumlin(NormWL)
      if( (snorm.eq.0.)  .or. (NormWL.le.0) .or. (NormWL.gt.nsum) )then
         write(qq,'('' >>Normalization line has zero intensity, its '',
     1   ''intensity was set to 1.  ''/
     2   '' >>Please consider using another normalization line '',
     3   ''(this is set with the NORMALIZE command).'' )')
         write(qq,'('' >>The relative intensities will be meaningless,''
     1   ,'' and many lines may appear too faint.'')')
         snorm = 1.
*        write(qq,'('' NormWL,nsum,itermx,iter='',5i5)')
*    2   NormWL, nsum , itermx,iter
      endif
*
*     analyse line arrays for abundances, temp, etc
*
*     find apparent helium abundance
      hbeta = sumlin(1)
      he5876 = 0.
      he4686 = 0.
      i = 30
      do while( i.le.nsum.and. lin(i).ne.5876)
        i = i + 1
      end do
      he5876 = sumlin(i)
*
      i = min( nsum , i )
      do while( i.le.nsum.and. lin(i).ne.4686)
        i = i + 1
      end do
      he4686 = sumlin(i)
*
      if( hbeta.gt.0. ) then
         heabun = (he4686*0.078 + he5876*0.739) / hbeta
      else
         heabun = 0.
      endif
      hescal = heabun / ( ahe / hden )
*
*     get temperature from [OIII] spectrum
      call cdLine( 'O  3',5007, o5007, absint, lgOK)
      if(.not.lgOK ) then
        write(qq,'('' FINAL could not find OIII 5007 with cdLine.'')')
        stop
      endif
      call cdLine( 'TOTL',4363, o4363, absint, lgOK)
      if(.not.lgOK ) then
        write(qq,'('' FINAL could not find OIII 4363 with cdLine.'')')
        stop
      endif
*
*     first find low density limit OIII zone temp
      if( (o4363.ne.0.) .and. (o5007.ne.0.) ) then
*       following will assume coll excit only, so correct
*       for 4363's that cascade as 5007
        bot = o5007 - o4363/o3enro
        if( bot.gt.0. ) then
          ratio = o4363 / bot
        else
          ratio = 0.178
        endif
        if( ratio.gt. 0.177 ) then
*         ratio was above infinite temperature limit
          toiiir = 1e10
        else
*         data for following set in oiii cooling routine
*         ratio of collision strengths, fac of 4/3 makes 5007+4959
*         >>chng 96 sep 7, reset cs to values at 10^4K,
*         had been last temp in model
          o3cs12 = 2.33239
          o3cs13 = 0.292628
          ratio = ratio/1.3333 /(o3cs13/o3cs12)
*         ratio of energies and branching ratio for 4363
          ratio = ratio / o3enro / o3br32
          toiiir = -o3ex23 / log( ratio )
        endif
      else
        toiiir = 0.
      endif
*
*     find temperature from Balmer continuum
      call cdLine( 'Bac ',3646, bacobs, absint, lgOK)
      call cdLine( 'TOTL',4861, hbeta, absint, lgOK)
      if (hbeta.gt.0. ) then
        bac = bacobs / hbeta
      else
        bac = 0.
      endif
      if( bac.gt.0. ) then
*----------------------------------------------------------*
***** TableCurve c:\tcwin2\balcon.for Sep 6, 1994 11:13:38 AM
***** log bal/Hbet
***** X= log temp
***** Y=
***** Eqn# 6503  y=a+b/x+c/x^2+d/x^3+e/x^4+f/x^5
***** r2=0.9999987190883581
***** r2adj=0.9999910336185065
***** StdErr=0.001705886369042427
***** Fval=312277.1895753243
***** a= -4.82796940090671
***** b= 33.08493347410885
***** c= -56.08886262205931
***** d= 52.44759454803217
***** e= -25.07958990094209
***** f= 4.815046760060006
*----------------------------------------------------------*
*       bac is double precision!!!!
        x = 1.d0/log10(bac)
        tel =-4.827969400906710+x*(33.08493347410885+
     1  x*(-56.08886262205931+x*(52.44759454803217+
     1  x*(-25.07958990094209+x*(4.815046760060006)))))
*
        if(tel.gt.1. .and. tel.lt.5. ) then
          tbac = 10.**tel
        else
          tbac = 0.
        endif
      else
        tbac = 0.
      endif
*
*     find temperature from optically thin Balmer continuum and case B H-beta
      call cdLine( 'thin',3646, bacthn, absint, lgOK)
      call cdLine( 'Ca B',4861, hbcab, absint, lgOK)
      if (hbcab.gt.0. ) then
        bacthn = bacthn / hbcab
      else
        bacthn = 0.
      endif
      if( bacthn.gt.0. ) then
*----------------------------------------------------------*
***** TableCurve c:\tcwin2\balcon.for Sep 6, 1994 11:13:38 AM
***** log bal/Hbet
***** X= log temp
***** Y=
***** Eqn# 6503  y=a+b/x+c/x^2+d/x^3+e/x^4+f/x^5
***** r2=0.9999987190883581
***** r2adj=0.9999910336185065
***** StdErr=0.001705886369042427
***** Fval=312277.1895753243
***** a= -4.82796940090671
***** b= 33.08493347410885
***** c= -56.08886262205931
***** d= 52.44759454803217
***** e= -25.07958990094209
***** f= 4.815046760060006
*----------------------------------------------------------*
*       bac is double precision!!!!
        x = 1.d0/log10(bacthn)
        tel =-4.827969400906710+x*(33.08493347410885+
     1  x*(-56.08886262205931+x*(52.44759454803217+
     1  x*(-25.07958990094209+x*(4.815046760060006)))))
*
        if(tel.gt.1. .and. tel.lt.5. ) then
          tbcthn = 10.**tel
        else
          tbcthn = 0.
        endif
      else
        tbcthn = 0.
      endif
*
*     we now have temps from OIII ratio and BAC ratio, now
*     do Peimbert analysis, getting To and t^2
      tb = tbac
      tohyox = (8.5*toiiir - 7.5*tbcthn - 228200. +
     1 sqrt( (8.5*toiiir - 7.5*tbcthn -228200.)**2+9.128e5*tbcthn))/2.
      if( tohyox.gt.0. ) then
        t2hyox = (tohyox-tbcthn)/( 1.7*tohyox )
      else
        t2hyox = 0.
      endif
*
*----------------------------------------------------------
*
*     first set scaled lines
      do i=1,nsum
        scaled(i) = sumlin(i) / snorm * sclnrm
        if( sumlin(i).gt.0. ) then
           asumli(i) = log10(sumlin(i)) + pirsq
        else
           asumli(i) = -38.
        endif
      end do
*
*     punch Verner FeII lines if this is desired
      if( chFeIIAtom.eq.'Verner' .and..not.lgSimKatya ) then
        call Fe2Lines( 'pun' , sclnrm/snorm )
      endif
*
*     this is option to not print certain contributions
      do i=1,nsum
        if( chALab(i).eq.'Coll'.and..not.lgPrnColl ) then
          lgPrt(i) = .false.
        else if( chALab(i).eq.'Pump'.and..not.lgPrnPump ) then
          lgPrt(i) = .false.
        else if( chALab(i)(1:3).eq.'Inw'.and..not.lgPrnInwd ) then
          lgPrt(i) = .false.
        else if( chALab(i).eq.'Heat'.and..not.lgPrnHeat ) then
          lgPrt(i) = .false.
        else if( chALab(i).eq.'nFnu'.and..not.lgPrnDiff ) then
          lgPrt(i) = .false.
        else
          lgPrt(i) = .true.
        endif
      end do
*
*     do not print relatively faint lines unless requested
      nneg = 1
      if( lgFaintOn ) then
        iprnt = 0
        do i=1,nsum
          if(scaled(i).ge.TooFaint.and.lgPrt(i) ) then
            iprnt = iprnt + 1
            asumli(iprnt) = log10(sumlin(i)) + pirsq
            sclsav(iprnt) = scaled(i)
            chSTyp(iprnt) = chSumTyp(i)
            chSLab(iprnt) = chALab(i)
            linsav(iprnt) = lin(i)
          else if( -scaled(i).gt.TooFaint .and. lgPrt(i) ) then
*           negative intensities occur if line absorbs continuum
            index(nneg) = i
            index(nneg+1) = lin(i)
            nneg = min( 32 , nneg + 2 )
          endif
        end do
      else
*       print everything
        iprnt = nsum
        do i=1,nsum
          sclsav(i) = scaled(i)
          chSTyp(i) = chSumTyp(i)
          chSLab(i) = chALab(i)
          linsav(i) = lin(i)
          if( scaled(i).lt.0. ) then
            index(nneg) = i
            index(nneg+1) = lin(i)
            nneg = min( 32 , nneg + 2 )
          endif
        end do
      endif
*
      if( lgDustOn.and. (.not.lgSphere) .and.(covrt.eq.0.) ) then
*       print special lines with continuum transfer in
        write(qq,'(51X,''Emergent line intensities'')')
        nlow = 1
        bottom = max( 1e-30 , smdlin(1) )
        do nlow=1,ndsum,4
          write(qq,'(5X,3(1X,A4,I5,F7.3,F9.4,5X),1X,A4,I5,F7.3,F9.4)')
     1    (chSMDLab(i),lind(i), log10(max(smdlin(i),1e-35))+pirsq,
     2    smdlin(i)/bottom , i=nlow,min(nlow+3,ndsum))
        end do
        write(qq,'(A1)')
        write(qq,'(51X,''Intrinsic line intensities'')')
      endif
*
*----------------------------------------------------------
*
*     print out all lines which made it through the faint filter
      nline = (iprnt+3) / 4
      do i=1,nline
        write(qq,'(5X,3(1X,A4,I5,F7.3,F9.4,5X),1X,A4,I5,F7.3,F9.4)')
     1  (chSLab(j),linsav(j),asumli(j),sclsav(j),j=i,iprnt,nline)
      end do
*
      if( nneg.gt.1 ) then
         write(qq,'('' Lines with negative intensities - '',
     1   '' Linear itensities relative to normalize line.'')')
         write(qq,'(10x,5(i5,a5,i5,1p,e9.1))')
     1   (index(i),chALab(index(i)),index(i+1),
     2   scaled(index(i)),i=1,nneg-1,2)
      endif
*
* add lines to truncated list, using known line ratios, with printou
      npxdd = iprnt
*     with area since sumlin does
      snorm = sumlin(NormWL)
      if(prall.eq.1) call addln1
*
* reorder lines according to wavelength for comparison with spectrum
* including writing out the results
      if(psort.eq.1) call spect
*
*     now find which were the very strongest, more that 5% of cooling
      j = 0
      do i=1,nsum
        a = sumlin(i) / totcol
        if( (a.ge.0.05) .and. chSumTyp(i).eq.'c' ) then
          j = min( j+1 , 7 )
          index(j) = i
          d(j) = a
        endif
      end do
*
      write(qq,'(///1x,a74)') chTitle(2:75)
      if( j.ne.0 ) write(qq,'('' Cooling:'',7(2X,A4,I5,
     1'':'',F5.3))') (chALab(index(i)),lin(index(i)),d(i),i=1,j)
*
*     now find strongest heating, more that 5% of total
      j = 0
      do i=1,nsum
        a = sumlin(i) / power
        if( (a.ge.0.05) .and. chSumTyp(i).eq.'h' ) then
          j = min( j+1 , 7 )
          index(j) = i
          d(j) = a
        endif
      end do
*
      if( j.ne.0 ) write(qq,'(1X,''Heating:'',7(2X,A4,I5,
     1'':'',F5.3))') (chALab(index(i)),lin(index(i)),d(i),i=1,j)
*
*     print out ionization parameters and radiation making it through
      qlow = 0.
      plow = 0.
      do i=1,ipHn(1)-1
*       N.B. in following en1ryd prevents overflow
        plow = plow + (flux(i)+outcon(i)+outlin(i))*en1ryd * anu(i)
        qlow = qlow + (flux(i)+outcon(i)+outlin(i))
      end do
      qlow = qlow * r1r0sq
      plow = plow * r1r0sq
      if( plow.gt.0. ) then
         qlow = log10( qlow ) + pirsq
         plow = log10( plow ) + pirsq
      else
         qlow = 0.
         plow = 0.
      endif
*
      qion = 0.
      pion = 0.
      do i=ipHn(1),nflux
*       N.B. in following en1ryd prevents overflow
        pion = pion + (flux(i)+outcon(i)+outlin(i))*en1ryd * anu(i)
        qion = qion + (flux(i)+outcon(i)+outlin(i))
      end do
      qion = qion * r1r0sq
      pion = pion * r1r0sq
*
      if( pion.gt.0. ) then
         qion = log10( qion ) + pirsq
         pion = log10( pion ) + pirsq
      else
         qion = 0.
         pion = 0.
      endif
*
*     derive ionization parameter for spherical geometry
      if( qhtot.gt.0. ) then
         if( lgUSphON ) then
*           RSTROM is stromgren radius
            usp = qhtot / (rstrom/rinner)**2 / 2.998e10 / hden
            usp = log10( usp )
         else
*           no stromgren radius found, use outer radius
            usp = qhtot / r1r0sq / 2.998e10 / hden
            usp = log10( usp )
         endif
      else
         usp = -37.
      endif
*
      if( uh.gt.0. ) then
         uhl = log10( uh )
      else
         uhl = -37.
      endif
      if( uheii.gt.0. ) then
         uhel = log10( uheii )
      else
         uhel = -37.
      endif
      write(qq,'(/,'' IONIZE PARMET:'',2X,''U(1-)'',F8.4,''  U(4-):'',
     1F8.4,''  U(sp):'',F6.2,''  Q(ion):   '',F6.3,''  L(ion):'',F8.3,
     2'' Q(low):'',F6.2,''    P(low)'',F9.3)')
     3 uhl , uhel , usp , qion , pion , qlow , plow
*
      a = abs( (power-totcol)*100. ) / power
*     output power and total cooling; can be neg for shocks, collisional ioniz
      if( power.gt.0. ) then
         powerl = log10(power) + pirsq
      else
         powerl = 0.
      endif
      if( totcol.gt.0. ) then
         totcol = log10(totcol) + pirsq
      else
         totcol = 0.
      endif
      if( ffhtot.gt.0. ) then
         ffhtot = log10(ffhtot) + pirsq
      else
         ffhtot = 0.
      endif
*     following is recombination line intensity
      reclin = totlin( 'r' )
      if( reclin.gt.0. ) then
         reclin = log10(reclin) + pirsq
      else
         reclin = 0.
      endif
      if( workft.gt.0. ) then
         workft = log10(max(1e-20,workft)) + pirsq
      else
         workft = 0.
      endif
*
      write(qq,'('' ENERGY BUDGET:  Heat:'',F8.3,2X,''Coolg:'',F8.3,2X,
     1''Error:'',0P,F5.1,''%'',2X,''Rec Lin:'',F8.3,''  WorkF: '',F8.3,
     2'' F-F  H'',F7.3,''    RadBetaMax:'',1P,E8.2)')
     2 powerl , totcol , a , reclin , workft , ffhtot , RadBetaMax
*
*     effective x-ray column density, from 0.5keV attenuation, no scat
*     IPXRY is pointer to 73.5 Ryd
      coleff = tauabs(ipxry,1) - tauxry
      coleff = coleff / 2.14e-22
*
      write(qq,'('' Column density  H12:'',1P,E9.3,2X,''H II:'',E9.3,
     1''  HI:'',E9.3,''  H-:    '',E9.3,2X,''H2:   '',E9.3,'' H2+:'',
     2E9.3,4X,''He H+:'',E9.3)')
     3colden,chii,chi,chmin,colh2,ch2pls,chehp
*
*     print molecular element column densities
      call molcol( 'PRIN' )
*
*     find t^2 from H II structure
      call gett2( t2hstr)
*     find t^2 from OIII structure
      call gett2o3( t2o3str)
*
      write(qq,'(5X,''Col(Heff):'',6X,1P,E9.3,''  snd travl time  '',
     1 e8.2,'' sec  NeN+dl: '',E8.2,''  Te-low:'',1P,E8.2,
     2 '' Te-hi'',E8.2)')
     3 coleff, sound,dlnenp, tlowst , thist
*
*     following is wl where gas goes thick to brems, in cm
      if( tff.gt. 0. ) then
        bremtk = 911.3e-8 / tff
      else
        bremtk = 1e30
      endif
*
      if( nzone.gt.0 ) then
        znit = float(iontot) / float(nzone)
      else
        znit = 0.
      endif
*
      write(qq,'('' He/Ha:'',1P,E8.2,''  ='',0P,F7.2,''*true'',
     1''  Lthin:'',1p,
     2 E8.2,''  iter/zn:'',0P,F5.3,''  Hlu/zn:'',1P,E8.2)')
     3 heabun,hescal,bremtk ,
     3 znit , float( lhytot ) / float(nzone)
*
*     timescale (sec here) for photoerosion of fe-ni
      rate = TimeErode * 2e-26
      if( rate.gt.1e-30 ) then
        ferode = (1. / rate )
      else
        ferode = 0.
      endif
*
*     mean acceleration
      if( acldr.gt.0. ) then
        AccelAver = AccelAver / acldr
      else
        AccelAver = 0.
      endif
*
*     DMEAN is mean density (gm per cc); mean temp is weighted by mass density
      wmean = wmas / TotMassColl
      dmean = TotMassColl / avhden
      tmean = tmas / TotMassColl
      wmean = wmas / TotMassColl
*
      write(qq,'(''   <a>:'',1P,E8.2,''  erdeFe'',E7.1,''  Tcompt'',
     1E8.2,''  Tthr'',E8.2,''  <Tden>: '',E8.2,''  <dens>:'',E8.2,
     2 '' <Mol>:'',E8.2)')
     1 AccelAver , ferode , tcmptn , ttherm , tmean, dmean,wmean
*
*     Jeans length and mass - this is mean over model
      rjeans = 7.79637+(log10(tmean)-log10(wmole)-
     1 log10(xMassDensity*FillFac))/ 2.
      if( rjeans.lt.36.) then
        rjeans = 10.** rjeans
*       AJMASS is Jeans mass in solar units
        ajmass = 3.*log10(rjeans/2.) + log10(4.*pi/3.*
     1  xMassDensity*FillFac) - log10( solarm )
        if( ajmass.lt.37 ) then
          ajmass = 10.** ajmass
        else
          ajmass = 0.
        endif
      else
        rjeans = 0.
        ajmass = 0.
      endif
*
*     Jeans length and mass - this is smallest over model
      ajmin = ajmmin - log10(solarm)
      if( ajmin.lt.37 ) then
        ajmin = 10.** ajmin
      else
        ajmin = 0.
      endif
*
*     estimate alpha (o-x)
      if( anu(nflux).gt.150. ) then
        ip2kev = ipoint( 147. )
        ip2500 = ipoint( 0.3648 )
        bottom = ((flux(ip2500)+ContDiff(ip2500))*
     2  anu(ip2500)/widflx( ip2500) )
        top = (flux(ip2kev)+ContDiff(ip2kev))*anu(ip2kev)/widflx(ip2kev)
        if( bottom.gt.1e-30 .and.top.gt.1e-30 ) then
          ratio = log10( top ) - log10( bottom )
          if( ratio.lt.36. .and. ratio.gt.-36. ) then
            ratio = 10.**ratio
          else
            ratio = 0.
          endif
        else
          ratio = 0.
        endif
        if( ratio .gt. 0. ) then
          alfox = log( ratio ) / log( anu(ip2kev)/anu(ip2500) )
        else
          alfox = 0.
        endif
      else
        alfox = 0.
      endif
*
      if( rjnmin.lt.37 ) then
        rjnmin = 10.**rjnmin
      else
        rjnmin = 1e37
      endif
*
      write(qq,'(''     Mean Jeans  l(cm)'',1P,E8.2,''  M(sun)'',E8.2,
     1''  smallest:     len(cm):'',1P,E8.2,''  M(sun):'',E8.2,
     2 '' Alf(ox-tran): '',0P,F10.4)')
     3 rjeans , ajmass , rjnmin , ajmin , alfox
*
*     some details about the hydrogen and helium ions
      write(qq,'('' Hatom level'',i3,''  NHtopoff:''
     2,i4,''  HatomType:'',a4,''  HInducImp'',l2,7x,''He1 level'',i3,
     3''  He2 level'',i3)')
     3nhlvl,nHTopOff,
     3chHTopType,lgHInducImp,nhe1lvl,nhe2lvl
*
*     print out some average quantities
      call aver('prin' , 0. , 0. , '          ' )
*
*     print out Peimbert analysis, tsqden default 1e7, changed
*     with set tsqden command
      if( hden.lt.tsqden ) then
        write(qq,'('' '')')
        write(qq,'('' Peimbert T(OIIIr)'',1p,e8.2,'' T(Bac)'',
     1  E8.2,'' T(Hth)'',E8.2,'' t2(Hstrc)'',E9.2,'' T(O3-BAC)''
     2  ,E8.2,'' t2(O3-BC)'',E9.2,'' t2(O3str)'',e9.2)')
     3 toiiir, tbac,tbcthn,t2hstr,tohyox,t2hyox , t2o3str
        if( lgDustOn ) write(qq,'('' Be careful: grains exist.'',
     1  ''  This spectrum was not corrected for reddening before '',
     1  ''analysis.'')')
      endif
*
*     print dust parameters if DEPLN not zero
      if( lgDustOn ) then
        nd = 0
        do i=1,ndust
          if( lgDustOn1(i) ) then
            nd = nd + 1
            if( lgQHeat(i) ) then
              chSTyp(nd) = '*'
            else
              chSTyp(nd) = ' '
            endif
*           >>chng 97 feb 28, only print out needed ones
            avdust(nd) = avdust(i) / reftot
            avdft(nd) = avdft(i) / reftot
            avdpot(nd) = avdpot(i) / reftot
            chLab(nd) = chDstLab(i)
          endif
        end do
        write(qq,'(/''   Average grain Properties: '')')
        write(qq,'(''           '',9(1x,A10,a1))')
     1  (chLab(i),chSTyp(i),i=1,nd)
        write(qq,'(''   <Tdust>:'',1P,9E12.3)')(avdust(i),i=1,nd)
        write(qq,'(''   <Vel D>:'',1P,9E12.3)')(avdft(i), i=1,nd)
        write(qq,'(''   <Pot D>:'',1P,9E12.3)')(avdpot(i),i=1,nd)
      endif
*
*     option to make short printout
      if( .not. lgPrtShort ) then
*       print log of optical depths
        call PrtAllTau
*       only print mean ionization and emergent continuum on last iteration
        if( lgLastIt ) then
*         print mean ionization fractions and column densities for all elements,
          call pmeani
*         print emergent continuum
          call pcontn
        endif
      endif
      write(qq,'(1x,a74)') chTitle(2:75)
*
      end
******************************************************************************
      subroutine FindNeg
      implicit none
*search through line arrays to find the most negative inward optical depths
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
*
*     local variables
      integer i
*
*     do the level 1 lines
      do i=1,nTauLines
*       check if a line was the major heat agent
        if( TauLines(ipLnTauIn,i).lt.-1. )
     1  call DumpLine(TauLines(1,i))
      end do
*     now do the level 2 lines
      do i=1,NWINDLINE
*       check if a line was the major heat agent
        if( WindLine(ipLnTauIn,i).lt.-1. )
     1  call DumpLine(WindLine(1,i))
      end do
*
      end
******************************************************************************
      subroutine firebl( z , nqh , ar1 )
      implicit none
*parse parameters from fireball command
      integer nqh
      real z, ar1
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real range
      common/range/ range(limspc,2)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real emm , egamry
      common/bounds/ emm , egamry
      real rdfalt
      common/rdfalt/ rdfalt
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real a , rlogl
*
*     check that stack of shape and luminosity specifications
*     is parallel, stop if not - this happens is background comes
*     BETWEEN another set of shape and luminosity commands
      if( nspec.ne.nqh ) then
        write(qq,'('' This command has come between a previous ''
     1  ,''ordered pair of continuum shape and luminosity commands.''/
     2  ,'' Reorder the commands to complete each continuum '',
     3  ''specification before starting another.'')')
        write(qq,'('' sORRY.'')')
        stop
      endif
*
      nspec = nspec+1
      nqh = nqh + 1
      if( nqh.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
*     put in a black body
      chSpType(nspec) = 'BLACK'
      slope(nspec) = 2.756 * ( 1. + z )
      cutoff(nspec,1) = 0.
      cutoff(nspec,2) = 0.
      chSpNorm(nqh) = 'LUMI'
      a = log10(slope(nspec))
      rlogl = log10( 2.99792e10 * 7.56464e-15) + 4.*a
      chRSpec(nqh) = 'SQCM'
      range(nqh,1) = emm
      range(nqh,2) = egamry
      totpow(nqh) = rlogl
*
*     set radius to very large value if not already set
      if( radius.eq.0. ) then
        ar1 = rdfalt
        radius = 10. ** ar1
      endif
*
      end
******************************************************************************
      subroutine FirstDR
      implicit none
*derive thickness of first zone
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      logical lgSMinON
*lgSMinON is flag saying that set drmin has been enteed
*     these are 1e-30 and 1e30 by default, and are set with "set dr" cmnds
*     used as one of a pair of limits to how big or small zones get
*     set dr command forces constant dr by setting both to same number
      real sdrmin , sdrmax
      common/sdrmin/ sdrmin , sdrmax , lgSMinON
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      real HColStop , colpls , colnut
*limit column densities set with stop column command
*colend is total hydrogen column, others are ionized and neutral
      common/colend/ HColStop , colpls , colnut
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgDrMnOn
*flag to turn off dr checking in dextdr when globule command entered
      common/drmnon/ lgDrMnOn
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real drMinimum
*fraction of initial thickness, set in firstdr
*do not let dr get smaller than this
      common/drmin/ drMinimum
      real flong , cfirst , csecnd, flcPhase
*     parameters for the fluctuations command
      logical lgDenFluc
      common/fluct/ flong , cfirst , csecnd , lgDenFluc, flcPhase
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real opac
      common/opac/ opac(ncell)
      real hi , hii
      common/h/ hi , hii
      real drChange
*fractional change used in nextdr
      common/didz/ drChange
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real z , a , accel,TotalPressure,winddr,dr912,drcol,dradf,
     1 big,drthrm , freqm , opacm , tabden , drTabDen,factor
      logical lgOK
      integer i
      parameter (z=1.0001)
*
*     wind, check acceleration length
      if( windv.gt.0. ) then
        a = TotalPressure()
        accel = 1.3e-10 * pden*wmole
        winddr = windv**2 /25. / accel
      else
        winddr = 1e30
      endif
*
*     key off of Lyman continuum optical depth
      if( taunu.gt.0.99.and.taunu.lt.3. ) then
        dr912 = tauend / 6.3e-18 / (hi * FillFac ) * z / 50.
      else
        dr912 = 1e30
      endif
*
*     key off of column density; total, neutral, or ionized
      if( HColStop.lt.5e29 ) then
*       this is useful for very thin columns, normally larger than 1st DR
        drcol = log10(HColStop ) - log10( hden * FillFac * 20. )
      else if( colpls.lt.5e29 ) then
        drcol = log10(colpls ) - log10( hii * FillFac * 20. )
      else if( colnut.lt.5e29 ) then
        drcol = log10(colnut ) - log10( hi * FillFac * 50. )
      else
        drcol = 30.
      endif
      drcol = 10.**min( 35., drcol )
*
*     find first DRAD using optical depths
*     drMinimum is smallest acceptable DRAD, and is 1/100 OF DRAD(1)
*
      if( flong .ne. 0. ) then
*       flong set => density fluctuations
        dradf = 6.283 / flong / 10.
        dradf = min( dradf , real(router(iter))*z , drcol , dr912 )
      else
        dradf = 1e37
      endif
*
*     following is usually the case
*     find largest opacity, keep first zone optical depth 1
      call AddOpac( lgOK )
      if( .not. lgOK ) then
        write(qq,'('' first opacity evaluation fails'')')
        stop
      endif
      big = 0.
      do i=1,nflux
        big = max( big , opac(i) )
      end do
*begin sanity check
      if( big.le.0. ) then
        write(qq,'('' largest opacity not >0 in FirstDR'')')
        stop
      endif
*end sanity check
*     >>chng 96 jan 8 following had dtau1, which was 0.001,
*     rather than rat drChange
      drad = (drChange/100.) / big / FillFac
      call ContRate( freqm, opacm )
*
*     rough guess of thermalization length
      drthrm = 1.5e31 / max( 1. , hden * hden )
*
*     >>chng 97 apr 2, added following logic to make sure we resolve initial
*     structure in tabden command
*     if interpolated table we need to make sure that we resolve the
*     initial changes in the structure
      if( chCPres.eq.'DLW2' ) then
        drTabDen = 1.
        i = 1
        factor = 0.
        do while ( i.lt.100 .and. factor.lt.0.05 )
*         >>chng 97 july 24, convert to double had not been done
*         both arguments to tabden are double precision
          factor = hden/tabden( radius+drTabDen, dble(drTabDen) )
          factor = abs(factor - 1.)
          drTabDen = drTabDen * 2.
          i = i + 1
        end do
        drTabDen = drTabDen / 2.
      else
        drTabDen = 1e30
      endif
*
*     above is fraction of total thickness; now set fraction of R
*     >>chng 96 nov 22, radius now 20, had been 8, resulted in big change in
*     iron ionization for high ionization gas
      drad = min( real(drad) , real(radius)/20. ,real(router(iter))/10.,
     1 drcol , dr912 ,sdrmax, drthrm , winddr , dradf , drTabDen)
      drad = max( real(drad) , sdrmin )
*
*     this can be turned off by GLOB command
      if( lgDrMnOn ) then
        drMinimum = drad / 1e7
      else
        drMinimum = 0.
      endif
      if( lgSMinON ) then
        drMinimum = sdrmin
      endif
*
      if( lgTrace ) write(qq,'(1X,''FirstDR called, finds dr='',1P,E13.5
     1,'' drMinimum='',E12.3,'' sdrmin='',E10.2,'' sdrmax='',E10.2)')
     2 drad, drMinimum , sdrmin , sdrmax
*
      end
******************************************************************************
      subroutine fivel(g,ex,cs12,cs13,cs14,cs15,
     1 cs23,cs24,cs25,cs34,cs35,cs45, a21,a31,a41,a51, a32,a42,a52,
     2 a43,a53,a54, p,abund)
      implicit none
*do five level atom population and cooling
      real g(5) , p(5) , ex(4)
      real cs12,cs13,cs14,cs15,
     1 cs23,cs24,cs25,cs34,cs35,cs45, a21,a31,a41,a51, a32,a42,a52,
     2 a43,a53,a54, abund
*
      double precision zz(6,6) , dmax
      real WavNKelv
*     conversion factor from wavenumbers to degrees kelvin
      parameter (WavNKelv=1.43883)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      real tf,e12,e23,e34,e45,e13,e15,e14,e24,e25,e35 ,
     1 c21,c12,c31,c13,c41,c14,c51,c15,c23,c32,c42,c24,
     2 c52,c25,c43,c34,c53,c35,c54,c45,sexp
      integer i , j , ner
*
*     tf = 1.438 / te
      tf = WavNKelv / te
      if( abund.le.0. ) then
         p(1) = 0.
         p(2) = 0.
         p(3) = 0.
         p(4) = 0.
         p(5) = 0.
         return
      endif
*
      e12 = sexp( ex(1)*tf )
      e23 = sexp( ex(2)*tf )
      e34 = sexp( ex(3)*tf )
      e45 = sexp( ex(4)*tf )
      e13 = e12 * e23
      e14 = e13 * e34
      e15 = e14 * e45
      e24 = e23 * e34
      e25 = e24 * e45
      e35 = e34 * e45
*
      if( e15.eq.0. ) then
         p(1) = 0.
         p(2) = 0.
         p(3) = 0.
         p(4) = 0.
         p(5) = 0.
         return
      endif
*
*     cdsqte IS 8.629e-6 / sqrte * eden
      c21 = cdsqte * cs12/g(2)
      c12 = c21 * g(2)/g(1) * e12
*
      c31 = cdsqte * cs13 / g(3)
      c13 = c31 * g(3)/g(1) * e13
*
      c41 = cdsqte * cs14 / g(4)
      c14 = c41 * g(4)/g(1) * e14
*
      c51 = cdsqte * cs15 / g(5)
      c15 = c51 * g(5) / g(1) * e15
*
      c32 = cdsqte * cs23 / g(3)
      c23 = c32 * g(3)/g(2) * e23
*
      c42 = cdsqte*cs24/g(4)
      c24 = c42*g(4)/g(2)*e24
*
      c52 = cdsqte * cs25/g(5)
      c25 = c52 * g(5) / g(2) * e25
*
      c43 = cdsqte * cs34/g(4)
      c34 = c43 * g(4)/g(3)*e34
*
      c53 = cdsqte*cs35/g(5)
      c35 = c53*g(5)/g(3)*e35
*
      c54 = cdsqte * cs45/g(5)
      c45 = c54 *g(5)/g(4) * e45
*
*     rate equations equal zero
      do i=1,5
        zz(5,i) = 1.0
        zz(i,6) = 0.
      end do
      zz(5,6) = abund
*
*     level one balance equation
      zz(1,1) = c12+c13+c14+c15
      zz(1,2) = -a21 - c21
      zz(1,3) = -a31 - c31
      zz(1,4) = -a41 - c41
      zz(1,5) = -a51 - c51
*
*     level two balance equation
      zz(2,1) = -c12
      zz(2,2) = c21+a21+c23+c24+c25
      zz(2,3) = -c32 - a32
      zz(2,4) = -c42 - a42
      zz(2,5) = -c52 - a52
*
*     level three balance equation
      zz(3,1) = -c13
      zz(3,2) = -c23
      zz(3,3) = a31+a32+c31+c32+c34+c35
      zz(3,4) = -c43-a43
      zz(3,5) = -c53 - a53
*
*     level four balance equation
      zz(4,1) = -c14
      zz(4,2) = -c24
      zz(4,3) = -c34
      zz(4,4) = a41+c41+a42+c42+a43+c43+c45
      zz(4,5) = -c54 - a54
*
*     divide both sides of equation by largest number to stop overflow
      dmax = -1d0
      do i=1,6
        do j=1,5
          dmax = max( zz(j,i) , dmax )
        end do
      end do
*
      do i=1,6
        do j=1,5
          zz(j,i) = zz(j,i) / dmax
        end do
      end do
*
      call matin1( zz,6,5,1,ner)
      if( ner.ne.0 ) then
        if( lgTalk ) write(qq,'('' 5-level matrix error.'')')
        if( lgCalled ) then
          lgBusted = .true.
           return
        else
          stop
        endif
      endif
*
* 666 error! p(5) was very slightly negative (1e-40) for SII in dqher.in
      p(2) = max(0.d0,zz(2,6) )
      p(3) = max(0.d0,zz(3,6) )
      p(4) = max(0.d0,zz(4,6) )
      p(5) = max(0.d0,zz(5,6) )
      p(1) = abund - p(2)-p(3)-p(4)-p(5)
*
      end
******************************************************************************
      subroutine fluorinei
      implicit none
*compute ionization balance for fluorine
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real hi , hii
      common/h/ hi , hii
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=10)
      parameter (nelem=9)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real grdeff(10)
*
*     fluorine, nelem=9
*     rec data from neon
*
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/10*0.2/
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /3.03E-11,1.79E-11,1.61E-11,9.76E-12,4.48E-12,2.03E-12,
     1 1.02E-12,3.84E-13,3.05E-14/
      data (cion(i,2),i=1,ndim-1)
     1/2.50E5,4.76E5,7.37E5,1.13E6,1.47E6,1.83E6,2.40E6,2.77E6,1.39E7/
*
*     rec from +7, +8 fro Arnaud et al 85
      data rec , pl
     1/3.07E-10, 8.87E-10, 2.21E-9, 4.28E-9, 8.17E-9, 1.51E-8, 3.21E-8
     1, 9.29E-8,
     2 -0.759  , -0.693  , -0.675 , -0.668 , -0.684 , -0.704 ,-0.742 ,
     2 -0.803 /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data
     1 aa/0., 0.0129, 3.6781,-0.0254,-0.0141, 19.9280,3*0./
     1,bb/0.,-0.1779,14.1481, 5.5365,33.8479,235.0536,3*0./
     1,cc/0., 0.9353,17.1175,17.0727,43.1608,152.5096,3*0./
     1,dd/0.,-0.0682,-0.5017,-0.7225,-1.6072,  9.1413,3*0./
     1,ff/0.,0.4516, 0.2313, 0.1702, 0.1942,  0.1282,3*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/9.77E-4 , 2.65E-3 , 3.69E-3 , 1.12E-2 , 2.44E-2 , 3.02E-2
     2,6.10E-3 , 2.52E-1 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.073, .242, 1.01, .391, 2.52, .445, .254, .304,0./
      data (dite(i,1),i=1,ndim-1)
     3/3.11E5  , 2.84E5  , 2.24E5  , 2.7E5  , 3.09E5  , 2.83E5
     4,1.68E5  , 1.4E7  , 0./
      data (dite(i,2),i=1,ndim-1)
     1 /2.06e5, 3.07e5, 2.94e5, 5.50e5, 9.91e5, 1.73e6, 6.13e5, 1.80e6,
     2 0./
      data ditcrt
     5/3.0E4  , 3.3E4  , 3.3E4  , 3.5E4  , 3.6E4  , 3.6E4
     6,2.9E4  , 1.5E6  , 1E20  /
*
*     fluorine, atomic number 9
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine FndLineHt( level , ipStrong , Strong )
      implicit none
*search through line heat arrays to find the strongest heat source
      real Strong
      integer level , ipStrong
*
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
*
*     local variables
      integer i
*
      Strong = 0.
      level = 0
*     do the level 1 lines
      do i=1,nTauLines
*       check if a line was the major heat agent
        if( TauLines(ipLnHeat,i).gt.Strong ) then
          ipStrong = i
          level = 1
          Strong = TauLines(ipLnHeat,i)
        endif
      end do
*     now do the level 2 lines
      do i=1,NWINDLINE
*       check if a line was the major heat agent
        if( WindLine(ipLnHeat,i).gt.Strong ) then
          ipStrong = i
          level = 2
          Strong = WindLine(ipLnHeat,i)
        endif
      end do
*
      end
******************************************************************************
      subroutine fndneg
      implicit none
*search cooling array to find negative values
      real te , eden , hden
      common/phycon/ te , eden , hden
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer ncolnt
      parameter (ncolnt=10 000)
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real eps , trig
      parameter (eps = 0.01)
*
      trig = abs( htot * eps )
      do i=1,ncltot
        if( cooling(i).lt.0. .and. abs(cooling(i)).gt.trig ) then
          write(qq,'('' negative line='',A4,I5,'' fraction of heat'',
     1    ''ing='',F9.3)')
     1    chClntLab(i) , collam(i), cooling(i)/htot
        endif
        if( heatnt(i).gt.trig ) then
          write(qq,'('' heating line='',A4,I5,'' fraction of heat'',
     1    ''ing='',F9.3)')
     1    chClntLab(i) , collam(i), heatnt(i)/htot
        endif
      end do
*
      end
******************************************************************************
      subroutine fndstr( tot , dc )
      implicit none
*search cooling stack to find strongest values
      real tot , dc
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer ncolnt
      parameter (ncolnt=10 000)
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      logical lgCoolTr
*flag set with trace cooling
      common/cooltr/ lgCoolTr
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real strong , str
      integer i , ip
      character*4 chStrngLab
*
      strong = 0.
      do i=1,ncltot
        if( abs(cooling(i)).gt.strong ) then
          ip = collam(i)
          chStrngLab = chClntLab(i)
          strong = abs(cooling(i))
        endif
      end do
      str = strong
*
      write(qq,'(3X,''FndStr: TE='',1P,E10.4,'' Ne='',
     1E10.4,'' C='',E10.3,'' H='',E10.3,'' dC/dT='',E9.2,
     2'' dH/dT='',e9.2,'' abs('',A4,I5,'')='',E9.2,'' nz='',i5)')
     3te , eden , tot , htot , dc , dHTotDT,chStrngLab , ip , str,nzone
*
*     option for extensive printout of lines
      if( lgCoolTr ) call dmpast
*
      end
******************************************************************************
      real function forlin()
      implicit none
*derive radiative acceleration due to line absorption of incident continuum
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
*     energy differences for levels in the model hydrogen atom:
      real HEnerRyd
      common/HEnrRyd/ HEnerRyd(lmhlvl,lmhlvl)
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     this function finds the total rate the gas absorbs energy
*     this result is divided by the calling routine to find the
*     momentum absorbed by the gas, and eventually the radiative acceleration
*
*     the energy absorbed by the line is
*     Abundance * energy * A *(g_up/g_lo) * occnum * escape prob
*     where occnum is the photon occupation number, and the g's are
*     the ratios of statistical weights
*
*     local variable
*     character chLineLbl*10
      integer i , ihi , low , ihmax , ipRestMax
      real hydro , fe2drive , AllHeavy , he2l, he1l,AllRest,HeavMax,
     1 OneLine , hydromax  , RestMax
*     integer ipHeavMax
*     real HTauMax
*
* 666 error!
*     put helium triplets in
*
*     total energy absorbed in this zone, per cubic cm
*     do hydrogen first
      hydro = 0
      ihmax = 0
      hydromax = 0.
*     do not put in highest level since its not real
      do low=1,nhlvl-2
        do ihi=low+1,nhlvl-1
          OneLine = hn(low)*hcont(ihi,low)*HEnerRyd(ihi,low)
          hydro = hydro + OneLine
*         if( OneLine.gt.hydromax ) then
*           ihmax = ihi*100 + low
*           hydromax = Oneline
*           HTauMax = htau(ihi,low)
*         endif
        end do
      end do
      hydromax = hydromax * en1ryd * hii
      hydro = hydro * en1ryd * hii
*
*     total energy absorbed in this zone, per cubic cm
*     helium
      he1l = 0
      he2l = 0
      do low=1,7
        do ihi=low+1,8
          he2l = he2l +
     1    he2n(low)*he2con(ihi,low)*anu(iphe2l(ihi,low))
          he1l = he1l +
     1    he1n(low)*he1con(ihi,low)*anu(iphe1l(ihi,low))
        end do
      end do
      he2l = he2l * en1ryd * heiii
      he1l = he1l * en1ryd * heii
*
*     all heavy element lines in calculation of cooling
      AllHeavy = 0.
      HeavMax = 0.
      do i=1,nTauLines
        OneLine = TauLines(ipLnPump,i)*
     1  TauLines(ipLnEnrErg,i)* TauLines(ipLnPopOpc,i)
*       if( OneLine.gt.HeavMax ) then
*         HeavMax = OneLine
*         ipHeavMax = i
*       endif
        AllHeavy = AllHeavy + OneLine
      end do
*
*     all heavy element lines treated with g-bar
      AllRest = 0.
      RestMax = 0.
      ipRestMax = 0
      do i=1,NWINDLINE
        OneLine = WindLine(ipLnPump,i)*
     1  WindLine(ipLnEnrErg,i)* WindLine(ipLnPopOpc,i)
*       if( OneLine.gt.RestMax ) then
*         RestMax = OneLine
*         ipRestMax = i
*       endif
        AllRest = AllRest + OneLine
      end do
*
*     The Verner's model FeII atom
      fe2drive = 0.
      if( chFeIIAtom.eq.'Verner' .and..not.lgSimKatya ) then
        call AccelFe2( fe2drive )
      endif
*
      forlin = AllHeavy + hydro + fe2drive + he2l + he1l+AllRest
*
*     activate character chLineLbl above
*666  write(qq,'(1p,5e10.2)') hydro/forlin,he1l/forlin, he2l/forlin ,
*    1 AllHeavy/forlin, AllRest/forlin
*     write(qq,'(''Hyd '',i5,1p,2e10.2)') ihmax,HTauMax,hydromax/forlin
*
*     write(qq,'(''Heav'',1x,a10,1p,2e10.2)')
*    1 chLineLbl(TauLines(1,ipHeavMax)) ,
*    1 TauLines(ipLnTauIn,ipHeavMax), HeavMax/forlin
*
*     write(qq,'(''Rest'',1x,a4,1p,2e10.2)')
*    1 chLineLbl(WindLine(1,ipRestMax)) ,
*    1 WindLine(ipLnTauIn,ipRestMax) , RestMax/forlin
*      ipHeavMax = 105
*      write(6,*) ipHeavMax
*      write(6,'(1p,4e10.2)') TauLines(ipLnPump,ipHeavMax),
*    1  TauLines(ipLnEnrErg,ipHeavMax), TauLines(ipLnPopl,ipHeavMax),
*    2 TauLines(ipLnTauIn,ipHeavMax)
*
      end
******************************************************************************
      real function fosc(xLower,Upper)
      implicit none
*computes hydrogenic oscillator strengths, Johnson L.C., 1972 ApJ 174 227
*     Used in the function hdexct.
      real xLower,Upper
*
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real x , gnt0 , gnt1 , gnt2 , gaunt
      real pi
*
*begin sanity check
      if( xLower.gt.Upper .or. xLower*Upper.lt.0. ) then
        write(qq,'('' fosc called with insane indices,='',1p,2e10.2)')
     1  xLower,Upper
        stop
      endif
*end sanity check
      pi=3.141592654
      x = 1.0 - (xLower/Upper)**2
      if(xLower.ge.3) then
        gnt0 = 0.9935 + 0.2328/xLower - 0.1296/xLower/xLower
        gnt1 = -(0.6282 - 0.5598/xLower + 0.5299/xLower/xLower)/xLower
        gnt2 = (0.3887 - 1.181/xLower +
     1  1.470/xLower/xLower)/xLower/xLower
      elseif(xLower.eq.2) then
        gnt0 = 1.0785
        gnt1 = -.2319
        gnt2 = 0.02947
      else
        gnt0 = 1.1330
        gnt1 = -.4059
        gnt2 = 0.07014
      endif
      gaunt = gnt0 + gnt1/x + gnt2/x/x
      fosc = 32./3./pi /sqrt(3.) * xLower/Upper**3 * gaunt /x/x/x
      end
******************************************************************************
      real function fread( chCard , ipnt , last , lgEOL )
      implicit none
*scan input line for free format number
      integer last,ipnt
      character chCard*80
      logical lgEOL
*
*     FREAD= first number encountered after column IPNT in card image
*
*     local variables
      real value , sign,expn
      integer l1,l2,ichr
      character chr*1
      logical lgNumber , lgNFound
*
      l1 = ichar('0')
      l2 = ichar('9')
*
 999  continue
      lgNumber = .false.
      lgNFound = .false.
      sign = 1.
      value = 0.
      fread = 0.
*     have we hit the end of line?
      call nxtchr( chr , ichr , ipnt , chCard , last , lgEOL )
      if( lgEOL ) return
*
*     find start of number
*----------------------------------------------
 4    if( chr .eq. '.') goto5
        if( (ichr.ge.l1)  .and.  (ichr.le.l2) ) goto1
        ipnt = ipnt + 1
        call nxtchr( chr , ichr , ipnt , chCard , last , lgEOL )
        if( lgEOL ) return
      goto4
*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
*
*     found start of number, check if neg
 1    if( chCard(ipnt-1:ipnt-1) .eq. '-') sign = -1.
      lgNFound = .true.
*
*     find numerical value
*----------------------------------------------
 6    value = 10.*value + float( iabs(  ichr-l1 ) )
      lgNumber = .true.
 7    ipnt = ipnt + 1
      call nxtchr( chr , ichr , ipnt , chCard , last , lgEOL )
      if( lgEOL ) then
        fread = value * sign
*       will be encountered on next call
        lgEOL = .false.
        return
      endif
      if( chr.eq.',') goto7
      if( (ichr.ge.l1) .and. (ichr.le.l2) ) goto6
*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
*
      if( chCard(ipnt:ipnt) .ne. '.') then
        fread = value * sign
        return
      endif
*
*     decimal point encountered
 5    expn = 1.
      if( chCard(ipnt-1:ipnt-1) .eq. '-') sign = -1.
*
*-------------------------------------------------------
 3    ipnt = ipnt + 1
      call nxtchr( chr , ichr , ipnt , chCard , last , lgEOL )
      if( chr.eq.',' ) goto3
      if( lgEOL .or. ichr.lt.l1 .or. ichr.gt.l2  ) then
*       following fails if no number found (only . on line)
        if( .not.lgNFound ) goto999
        fread = value * sign
        if( lgNumber ) lgEOL = .false.
        return
      endif
      expn = expn * 0.1
      lgNFound = .true.
      lgNumber = .true.
      value = value + expn * float( ichr-l1 )
      goto3
*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
      end
******************************************************************************
      subroutine freeht
      implicit none
*evaluate free-free heating due to incident continuum
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      logical lgFreeOn
*flag set false if no free-free heating command entered
      common/freeon/ lgFreeOn
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
      integer ipBrems
*opacity offset pointer for brems (free-free)
      common/ipbrms/ ipBrems
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real hi , hii
      common/h/ hi , hii
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      integer iphmra
      common/iphmra/ iphmra
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real EdenFFSum
*sum of heavy element free electrons, set in esum
      common/ffsum/ EdenFFSum
      double precision FreeFreeOpacity
*density and temp factors needed for free-free opacity
      common/ffopac/ FreeFreeOpacity(ncell)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real fac , fac1 , fachmi , fachmi1 , damper , oldfac
      double precision dfactor
      save oldfac
      data oldfac/0./
*
      if( .not. lgFreeOn ) then
        FreeFreeHeat = 0.
        return
      endif
*
*     must reevaluate if free free heating is important
      if( lgDoPhoto .or. FreeFreeHeat/htot.gt.0.05 ) then
        if( nzone.lt.1 ) then
          damper = 1.
        else
          damper = 0.5
        endif
*       OPSV is missing factor of 1E-20 to avoid underflow
        fac = (eden/1e10) * ((hii+heii+4.*heiii+EdenFFSum)/1e10) / sqrte
        fac1 = fac * te1ryd / te
*     >>chng 96 oct 30, put following after fac1 defn
        fac = damper*fac + oldfac*(1.-damper)
        fachmi = (eden/1e10) * (hii*hn(1)/1e10) / sqrte
        fachmi1 = fachmi * te1ryd / te
        do i=1,nflux
          if( ContBoltz(i).lt.0.995 ) then
*           use 1-exp(hn/kT)) only if exp is small
*           last term is scaled h minus brems free-free absorption
            dfactor = OpacStack(i-1+ipBrems) * (1.-ContBoltz(i))* gff(i)
            FreeFreeOpacity(i) = dfactor * fac
*           this is the H- part, opsv here is ratio of H- to ff
            FreeFreeOpacity(i) = FreeFreeOpacity(i) + dfactor * fachmi *
     1      OpacStack(i-1+iphmra)
          else
            dfactor = OpacStack(i-1+ipBrems) * anu(i)* gff(i)
            FreeFreeOpacity(i) = dfactor * fac1
*           h- free free absorption
            FreeFreeOpacity(i) = FreeFreeOpacity(i) + dfactor * fachmi1*
     1      OpacStack(i-1+iphmra)
          endif
        end do
        oldfac = fac
*       now integrate over this
        FreeFreeHeat = 0.
        do i=1,nflux
*         FreeFreeHeat = FreeFreeHeat + FreeFreeOpacity(i) *
*    1    SummedCon(i)*anu(i)
          FreeFreeHeat = FreeFreeHeat + FreeFreeOpacity(i) *
     1    flux(i)*anu(i)
        end do
        FreeFreeHeat = FreeFreeHeat * en1ryd
      endif
*
      end
******************************************************************************
      real function fudge( ipnt )
      implicit none
*enter fudge factors, or some arbitrary number, with fudge command
*     other sections of the code access these numbers via the common block
      integer ipnt
      integer nfudgc
      parameter (nfudgc=10)
      real fudgea
      integer nfudge
      common/fudgec/ fudgea(nfudgc) , nfudge
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      if( ipnt.gt.nfudge ) then
        write(qq,'('' FUDGE factor not entered for array number '',I3)'
     1  ) ipnt
        stop
      else
        fudge = fudgea( ipnt )
      endif
*
      end
****************************************************************
      real function gamk(n1,n2,ipOpac,yield1)
      implicit none
*evaluate photoionization rate for single shell
      integer n1 , n2 , ipOpac
*     yield1 is fraction of ionizations that emit 1 electron only,
*     only used for energy balance
      real yield1
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer ipSecIon
      common/ipSecIon/ ipSecIon
*
*     local variables
      integer iup , i , ilo , ipOffset
      real phisig , ht , eauger , HeatHi , GamHi
*
*     code spends roughly 20% of its time in this sub
*
*
*     evaluate photoioinzation rate and photoelectric heating
*     returns photoionization rate as GAMK, heating is H
*     N1 and N2 are pointers within frequency array to upper and
*     lower bounds of evaluation
*     ipOpac is offset to map onto OPSV
*
*     this routine is a major pace setter for the code
*     carefully check anything put into the following do loop
*
*     if(n1 .ge. nflux .or.  OpacStack(ipOpac).eq.0. ) then
*     >>chng 96 sept 26, remove check on zero opacity, for partial shells
      if(n1 .ge. nflux ) then
        secion = 0.
        secla = 0.
        gamk = 0.
        h = 0.
        return
      endif
*
      h = 0.
      iup = min( n2 , nflux )
*
      secion = 0.
      secla = 0.
*
*     anu(i) is threshold, assume each auger electron has this energy
*     less threshold energy, IP lost in initial photoionizaiton
*     yield1 is the fraction of photos that emit 1 electron
      eauger = anu(n1) * yield1
*
*     low energies where secondary ionization cannot occur
*     will do threshold point, n1, later
      gamk = 0.
      h = 0.
      ipOffset = ipOpac - n1
*     this loop only executed for energies than cannot sec ioniz
      do i=n1+1,min(iup,ipSecIon-1)
        phisig = SummedCon(i) * OpacStack(i+ipOffset)
        gamk = gamk + phisig
        h = h + phisig * anu(i)
      end do
*     correct heating for work function
      h = h - gamk * eauger
*
*     now do the threshold point
*     do not include otscon, which may contain diffuse continuum
      phisig = (flux(n1)+otslin(n1)) * OpacStack(ipOpac)
      gamk = gamk + phisig
      ht = phisig * ( anu(n1) - eauger )
      h = h + ht
*
*     now do part where secondary ionization possible
      HeatHi = 0.
      GamHi = 0.
*     make sure we don't count twice when ipSecIon = n1
      ilo = max( n1+1 , ipSecIon )
      do i=ilo,iup
*       produce of flux and cross section
        phisig = SummedCon(i) * OpacStack(i+ipOffset)
        GamHi = GamHi + phisig
        HeatHi = HeatHi + phisig * anu(i)
      end do
*
*     add on the high energy part
      gamk = gamk + GamHi
      HeatHi = HeatHi - GamHi*eauger
      h = h + HeatHi * heatef
      secion = HeatHi * efionz
      secla = HeatHi * exctef * 1.3333
*
*     final product is heating in erg
      h = h * en1ryd
*
      end
****************************************************************
      real function bnfun( n1 , n2 , ip , thresh , ainduc , rcool )
      implicit none
*evaluate photoionization rate for single shell with induced recomb
      integer n1 , n2 , ip
      real thresh , ainduc , rcool
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      integer ipSecIon
      common/ipSecIon/ ipSecIon
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
*     include "phtpiece.com"
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer k , i , iup , ilo
      real g , pinduc , phisig , prod , HeatHi , GamHi,emin
*
*     special version of GAMFUN for arbitrary threshold, and induc rec
*     compute ainduc, rate of inducted recombinations, rcool, induc rec cool
      if(n1.ge.nflux . or. n1.ge.n2 ) then
        bnfun = 0.
        secion = 0.
        h = 0.
        secla = 0.
        ainduc = 0.
        rcool = 0.
        return
      endif
*
*     >>chng 96 oct 25, first photo elec energy may have been negative
*     possible for first any point to be below threshold due to
*     finite resolution of continuum mesh
      emin = max( thresh,anu(n1) )
*
      h = 0.
      g = 0.
      pinduc = 0.
      rcool =  0.
      ilo = n1
      iup = min( n2 , nflux )
*
      secion = 0.
      secla = 0.
*     do first point without otscon, which may have diffuse cont
      i = ilo
      k = n1
      phisig = (flux(i)+otslin(i))* OpacStack(i-k+ip)
*     integral part of induced rec rate
      prod = phisig * ContBoltz(i)
      pinduc = pinduc + prod
      g = g + phisig
      h = h + phisig * anu(i)
*     incuded rec cooling
      rcool = rcool + prod*(anu(i)-emin)
*
      do i=k+1,min(iup,ipSecIon-1)
        phisig = SummedCon(i) * OpacStack(i-k+ip)
*       integral part of induced rec rate
        prod = phisig * ContBoltz(i)
        pinduc = pinduc + prod
        g = g + phisig
        h = h + phisig * anu(i)
*       incuded rec cooling
        rcool = rcool + prod*(anu(i)-emin)
      end do
*
*     heating in Rydbergs, no secondary ionization
      h = ( h - g*thresh )
*
*     now do part where secondary ionization is possible
      HeatHi = 0.
      GamHi = 0.
*     make sure we don't count twice when ipSecIon = n1
      ilo = max( n1+1 , ipSecIon )
      do i=ilo,iup
        phisig = SummedCon(i) * OpacStack(i-k+ip)
*       integral part of induced rec rate
        prod = phisig * ContBoltz(i)
        pinduc = pinduc + prod
        GamHi = GamHi + phisig
        HeatHi = HeatHi + phisig * anu(i)
*       incuded rec cooling
        rcool = rcool + prod*(anu(i)-emin)
      end do
*
*     this is total photo rate, low and high energy parts
      bnfun = g + GamHi
*     heating in Rydbergs, uncorrected for secondary ionization
      HeatHi = ( HeatHi - GamHi*thresh )
*
*     this is all the secondary ionization stuff
      h = h + HeatHi * heatef
      secion = HeatHi * efionz
      secla = HeatHi * exctef * 1.3333
*
*     final product is heating in erg
      h = h * en1ryd
*
*     this is an option to turn off induced processes
      if( lgFluor) then
        rcool = rcool * en1ryd
        ainduc = pinduc
      else
*       the "no induced" command was given
        rcool = 0.
        ainduc = 0.
      endif
*
      end
******************************************************************************
      real function gamfun(n1,n2,ip)
      implicit none
*evaluate photoionization rate for single species
      integer n1 , n2 , ip
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*
      integer k , iup  , i
      real g , thres , phisig
*
*     evaluate photoioinzation rate and photoelectric heating
*     returns photoionization rate as GAMFUN, heating is H
*     N1 and N2 are pointers within frequency array to upper and
*     lower bounds of evaluation
*     IP is offset to map onto OPSV
*
      h = 0.
      if(n1 .ge. nflux) then
        gamfun = 0.
        return
      endif
*
      g = 0.
      k = n1
      iup = min( n2 , nflux )
      thres = anu( n1 )
*
*     first do theshold point
*     do not include otscon, which may contain diffuse continuum
      i = n1
      phisig = (flux(i)+otslin(i)) * OpacStack(i-n1+ip)
      g = phisig
      h = phisig * anu(i)
*
      do i=n1+1,iup
        phisig = SummedCon(i) *OpacStack(i-n1+ip)
        g = g + phisig
        h = h + phisig * anu(i)
      end do
      gamfun = g
*
*     heating in Rydbergs, uncorrected for secondary ionization
      h = ( h - g*thres )
*
      if( anu(iup).gt.8. ) then
*       number of secondary ionizations, defined IN NOCKON
        secion = h * efionz
*
*       number of LA excitations
        secla = h * exctef * 1.3333
*
*       HEATEF is defined in NOCKON and =1 for fully ionized gas, less for
*       also convert RYD to ERG
        h = h * heatef * en1ryd
      else
        h = h * en1ryd
        secion = 0.
        secla = 0.
      endif
*
      end
******************************************************************
      subroutine gbar0(ex,g)
      implicit none
*compute g-bar gaunt factor for neutrals
      real te , eden , hden
      common/phycon/ te , eden , hden
      real ex , g
*
*     written by Dima Verner
*
* Calculation of the effective Gaunt-factor by use of
* Van Regemorter (1962, ApJ 136, 906) fits for neutrals
*    Input parameters:
* ex - energy ryd - now K
* t  - temperature in K
*    Output parameter:
* g  - effective Gaunt factor
*
*     local variables
      real y , a , b , c,d
*
*     y = ex*157813.7/te
      y = ex/te
      if(y.lt.0.01) then
         g = 0.29*(log(1.0+1.0/y)-0.4/(y+1.0)**2)/exp(y)
      else
         if(y.gt.10.0) then
            g=0.066/sqrt(y)
         else
            a=1.5819068e-02
            b=1.3018207e+00
            c=2.6896230e-03
            d=2.5486007e+00
            g=a+b*exp(-0.5*(log(y/c)/d)**2)
         endif
      endif
*
      end
******************************************************************
      subroutine gbar1(ex,g)
      implicit none
*compute g-bar collision strength using Mewe approximations
      real te , eden , hden
      common/phycon/ te , eden , hden
      real ex , g
*
*     written by Dima Verner
*
* Calculation of the effective Gaunt-factor by use of Mewe (1972, A&A 20, 215)
* fits for permitted transitions in ions MgII, CaII, FeII (delta n = 0)
*    Input parameters:
* ex - excitation energy in Ryd - now K
* te  - temperature in K
*    Output parameter:
* g  - effective Gaunt factor
*
*     local variables
      real y
*
*     y = ex*157813.7/te
      y = ex/te
      g = 0.6+0.28*(log(1.0+1.0/y)-0.4/(y+1.0)**2)
*
      end
******************************************************************************
      subroutine GetAge( chCard )
      implicit none
*parse parameters off the age command
      character chCard*80
      real CloudAgeSet
*age of cloud set with age command
      common/CloudAge/ CloudAgeSet
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     set age for the cloud
*     various timescales will be checked later
*
      logical lgEOL , lgMatch
      integer i
      real fread
*
      i = 4
      CloudAgeSet = fread( chCard , i , 76 , lgEOL )
*
*     key " off" turns age off
      if( lgEOL.and. (.not.lgMatch(' OFF',chCard ) ) ) then
        write(qq,'('' The age must be on this line.'')')
        stop
      endif
*
*     check if log of age
      if( lgMatch(' LOG',chCard ) ) then
        CloudAgeSet = 10.** CloudAgeSet
      endif
*
*     check for units, we want seconds in the end
      if( lgMatch('MILL',chCard ) ) then
*       millennium
        CloudAgeSet = CloudAgeSet * 3.15569e7 * 1000.
      else if( lgMatch('CENT',chCard ) ) then
*       centuries
        CloudAgeSet = CloudAgeSet * 3.15569e7 * 100.
      else if( lgMatch('YEAR',chCard ) ) then
*       years
        CloudAgeSet = CloudAgeSet * 3.15569e7
      else if( lgMatch('MONT',chCard ) ) then
*       months
        CloudAgeSet = CloudAgeSet * 3.15569e7/12.
      else if( lgMatch('FORT',chCard ) ) then
*       fortnights
        CloudAgeSet = CloudAgeSet * 24. * 3600. * 14.
      else if( lgMatch('WEEK',chCard ) ) then
*       weeks
        CloudAgeSet = CloudAgeSet * 24. * 3600. * 7.
      else if( lgMatch('DAY ',chCard ) ) then
*       days
        CloudAgeSet = CloudAgeSet * 24.*3600.
      else if( lgMatch('HOUR',chCard ) ) then
*       hours
        CloudAgeSet = CloudAgeSet * 3600.
      else if( lgMatch('MINU',chCard ) ) then
*       minuts
        CloudAgeSet = CloudAgeSet * 60.
      else if( lgMatch('SECO',chCard ) ) then
*       seconds - this is the default
        CloudAgeSet = CloudAgeSet * 1.
      endif
*
      end
******************************************************************************
      subroutine GetAgn( chCard )
      implicit none
*parse parameters for the AGN continuum shape command
      character chCard*80
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
*
*     first parameter is temperature of big bump
*     second parameter is alpha ox
*
*     local variables
      real Ratio, xnu , BigBump , XRays
      logical lgEOL
      integer i
      real fread , sexp
*
*     power law with cutoff
      nspec = nspec + 1
      if( nspec.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
*
      chSpType(nspec) = 'AGN  '
      i = 5
*     slope is first parameter is really temperature of bump
      slope(nspec) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' The big bump temperature should have been on '',
     1  ''this line.   Sorry.'')')
        stop
      endif
*
      if( slope(nspec).lE.0. ) then
        write(qq,'('' Non positive temperature not allowed'',
     1  ''.   Sorry.'')')
        stop
      endif
*
*     temps are log if first le 10
      if( slope(nspec).le.10.)slope(nspec)=10.** slope(nspec)
*
*     want cutoff in ryd not kelvin
      slope(nspec) = slope(nspec) / 1.5789e5
*
*     cutoff is second parameter is really alpha ox
      cutoff(nspec,1) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' alpha ox should have been on this '',
     1  ''line.   Sorry.'')')
        stop
      endif
      if( cutoff(nspec,1).gt.3. .or. cutoff(nspec,1).lt.-3.)then
        write(qq,'('' An alpha ox of'',1p,e10.2,'' looks funny to me.'',
     1  ''  Check Hazy to make sure its ok.'')') cutoff(nspec,1)
      endif
*
      if(cutoff(nspec,1) .ge.0. ) then
        write(qq,'('' The sign of alpha ox is almost '',
     1  ''certainly incorrect.   Check Hazy.'')')
      endif
*
*     bb slope is third parameter
      cutoff(nspec,2) = fread( chCard , i , 76 , lgEOL )
      if(lgEOL) cutoff(nspec,2) = -0.5
*
*     slope of X-Ray component is last parameter
      cutoff(nspec,3) = fread( chCard , i , 76 , lgEOL )
      if(lgEOL) cutoff(nspec,3) = -1.0
*
*     403.3 is ratio of energies where alpha ox defined,
*     assumed to be 2500A and 2keV
      Ratio = 403.3**(cutoff(nspec,1)-1.)
*     following code must be kept parallel with ffun1
      xnu = 0.3645
      BigBump = xnu **(-1.+cutoff(nspec,2)) * sexp( xnu/slope(nspec) )
      xnu = 147.
*     XRays = xnu**(-2.)
      XRays = xnu**(cutoff(nspec,3)-1. )
      if(BigBump.le.0. ) then
        write(qq,'('' Big Bump had zero flux at .3645 Ryd.'')')
        stop
      endif
      cutoff(nspec,1) = Ratio/(XRays/BigBump)
*
      end
*********************************************************************
      subroutine GetAtlas
      implicit none
*rebin Kurucz stellar models to match energy grid of code
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      common/StarBad/ lgStarBad
      logical lgStarBad
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , j , nvals,nmods,n1,n2,imod,ierr
*
* This is a program to re-bin the Kurucz stellar models spectrum to match the
* CLOUDY grid.  For short wavelengths I will use a power law extrapolation
* of the model values (which should be falling rapidly) if needed.  At long
* wavelengths I will assume Rayleigh-Jeans from the last stellar model point
* to extrapolate to 1 cm wavelength.
*
* This version uses power-law interpolation between the points of the stellar
* model.
*
      parameter (nvals=1221,nmods=412)
* nvals is the number of values per Kurucz model.  nmods is the total
* number of models in the set.  The last two are the Vega and Solar models.
*
*     real freq(ncell)
*     all freq changed to anu2
*     real flux2(ncell)
*     all flux2 changed to ContBoltz
*
      real teff(nmods),xlogg(nmods)
      integer iteff(ncell),logg(ncell)
      real wlin(nvals),flin(nvals)
*
      write(qq,'('' GetAtlas on the job.'')')
*
      n1 = 1
      do while( anu(n1).lt.10.)
        n1 = n1 + 1
      end do
      n1 = n1 - 1
*
       write(qq,'('' A total of '',i4,'' Cloudy cells needed.'')') n1
       if( n1.eq.nAtlas ) then
         write(qq,'('' The current value of nAtlas is ok.'')')
       else
         if( .not.lgStarBad ) then
*          no errors yet, so open errors file
           open(unit=66,file='problems.out',status='unknown')
         endif
         lgStarBad = .true.
         write(qq,'('' WARNING!!!!!'')')
         write(qq,'('' WARNING!!!!!'')')
         write(66,'('' nAtlas must be changed to'',i6,
     1   '' in block data scalar.  Its current value is'',i6)')
     2   n1,nAtlas
         write(qq,'('' nAtlas must be changed to'',i6,
     1   '' in block data scalar.  Its current value is'',i6)')
     2   n1,nAtlas
         write(qq,'('' I will take care of this for now.'')')
         nAtlas = n1
       endif
*
*     open(unit=01,file='kurucz.ascii',status='old',iostat=ierr,
*    c     access='direct',form='formatted',recl=12210)
      open(unit=01,file='kurucz.ascii',status='old',iostat=ierr)
      if( ierr.eq.0. ) then
        write(qq,'('' GetAtlas got kurucz.ascii.'')')
      else
        write(qq,'('' GetAtlas could not find kurucz.ascii.'')')
        stop
      endif
      open(unit=02,file='kurucz.list',status='old',iostat=ierr)
      if( ierr.eq.0. ) then
        write(qq,'('' GetAtlas got kurucz.list.'')')
      else
        write(qq,'('' GetAtlas could not find kurucz.list.'')')
        stop
      endif
*     read(01,40,rec=1,iostat=ierr) (wlin(i),i=1,nvals)
*     >>chng 97 jan 5, to get rid of format
      read(01,'(5e15.7)',iostat=ierr) (wlin(i),i=1,nvals)
*40   format(5e15.7)
*40   format(1221e10.3)
      if( ierr.eq.0. ) then
        write(qq,'('' GetAtlas got kurucz wavelengths, low high='',1p,
     1  2e11.3)') wlin(1), wlin(nvals)
      else
        write(qq,'('' GetAtlas could not read kurucz wavelengths.'')')
        stop
      endif
*
* the wavelength values wlin are in nm units, convert to freq (Hz)
* the energy range is 5.7e-4 to 10 Ryd
*
      do i=1,nvals
        anu2(i)=299792458.e+09/wlin(i)
      end do
*
*     first line is header
      read(02,'(11x)',iostat=ierr)
      do j=1,nmods
        read(02,'(11x,f8.1,8x,f7.5)',iostat=ierr) teff(j),xlogg(j)
*       write(qq,'(1p,2e10.2)') teff(j) , xlogg(j)
        if( ierr.ne.0 ) then
          write(qq,'('' GetAtlas failed readin teff, logg, for model'',
     1    i4)') j
          stop
        endif
        iteff(j)=teff(j)
        logg(j)=xlogg(j)*100000.
      end do
      write(qq,'('' Got grid of temperatures and gravities.'')')
*
      close(unit=02)
      open(unit=03,file='atlas.mod',access='direct',status='unknown',
     c     form='formatted',iostat=ierr, recl=7*ncell)
      if( ierr.ne.0 ) then
        write(qq,'('' GetAtlas failed creating kurucz.mod.'')')
        stop
      endif
*
*     >>chng 97 jan 5, get rid of format
      write(03,'(4000i7)',rec=1,iostat=ierr) (iteff(j),j=1,nmods)
*     this 4000 below is the value of ncell, and must be changed
*     if ncell changes
*65   format(4000i7)
      if( ierr.ne.0 ) then
        write(qq,'('' GetAtlas failed writing Teff.'')')
        stop
      endif
      write(03,'(4000i7)',rec=2,iostat=ierr) (logg(j),j=1,nmods)
      if( ierr.ne.0 ) then
        write(qq,'('' GetAtlas failed writng grav.'')')
        stop
      endif
*
      do j=1,n1
        iteff(j) = int(abs(log10(anu(j))-5.)*1000000.)
      end do
*
* *** NOTE ****  WARNING!!!!! ******
* As things are written here, the CLOUDY grid range covered by the models
* must be > 1.0e-05 Rydbergs and < 100000.0 Rydbergs so that the integer
* values are not larger than 9,999,999 and are all negative before the abs
* function is applied to the value to make the iteff element.  6 digits are
* needed in the logarithm value to give 5 digit accuracy when the values are
* converted back to energy values in Rydbergs by programs reading the model
* file.  For the present Werner and Kurucz models these limits are not a
* problem, nor are these limits likely to be violated in the future by purely
* stellar models....but if the limits are exceeded, things will not work.
*
* Since the Kurucz models cover up to a temperature of 50000 K and there is
* no significant emission at very high energies, the range of energy covered
* by the rebinning does not have to extend beyond a few Rydberg.  Here 10 Rydb
* is used to be consistent with the output from the hotter Werner models.
*
*     write out the cloudy energy grid for later sanity checks
      write(03,'(4000i7)',rec=3,iostat=ierr) (iteff(j),j=1,n1)
      if( ierr.ne.0 ) then
        write(qq,'('' GetAtlas failed writng anu array.'')')
        stop
      endif
*
      do j=1,n1
        iteff(j)=0
      end do
*
* This array will now be used for writing out the flux values in log form,
* multiplied by 1.e+05 and converted to integer (this allows sign plus 7
* integer places, storing 5 places in the log10 value which gives 4 significant
* figure accuracy in the values).
*
      write(6,'(///)')
      write(6,'('' Now would be a good time to get on the Cloudy '',
     1''mailing list, to'')')
      write(6,'('' find out about corrections and improvements to '',
     1''the code.'')')
      write(6,'('' Send a request to cldmail@pa.uky.edu'')')
      write(6,'(///)')
      write(6,'('' I will print every 10th model so you know I am '',
     1 ''still alive.'')')
      write(6,'('' (there are 412 models)'')')
      do imod=1,412
*       read(01,40,rec=imod+1,iostat=ierr) (flin(i),i=1,nvals)
*     >>chng 97 jan 5, to get rid of format
        read(01,'(5e15.7)',iostat=ierr) (flin(i),i=1,nvals)
        if( ierr.ne.0 ) then
          write(qq,'('' GetAtlas failed reading star flux.'')')
          stop
        endif
*
        do j=1,nvals
          flux(j) = max(1e-35, flin(j) )
        end do
*
        n2 = nvals
*
* This value is 1 larger than the value of n1.
        call RebinAtlas(n1,n2)
        do j=1,n1
          if (ContBoltz(j).gt.1e-30) then
            iteff(j) = int(abs(log10(ContBoltz(j)))*100000.)
          else
*           this is smallest possible number
            iteff(j)=9999999
          endif
        end do
*
        write(03,'(4000i7)',rec=imod+3,iostat=ierr) (iteff(j),j=1,n1)
*       write(66,'(9i8) (iteff(j),j=1,n1)
        if( ierr.ne.0 ) then
          write(qq,'('' GetAtlas failed writing iteff star flux.'')')
          stop
        else if( imod/10*10 .eq.imod ) then
          write(qq,'('' GetAtlas wrote'',i4)') imod
        endif
      end do
*
      close(unit=01)
      close(unit=03)
      write(qq,'('' GetAtlas complete, kurucz files may be deleted.'')')
      end
*
*******************************************************************
      subroutine RebinAtlas(n1,n2)
      implicit none
*rebin the atlas continuum grid onto the cloudy grid
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real c,rydb,con1,slope2,power,val,sum,x1,x2,v2,v1,term
      integer i , j , n1,n2,i1,i2
      real edge1,edge2
*     real flux1(ncell),freq1(ncell)
*     flux1 changed to gff, freq1 changed to anu3
*
* I want to insure that the stellar arrays are in increasing frequency order
* here.  the Kurucz files were in wavelength order, so it's necessary to swap
      if(anu2(2).gt.anu2(1)) then
         do j=1,n2
           anu3(j)=anu2(j)
           gff(j)=flux(j)
         end do
      else
*        this is the code for kurucz, n2 is number of energy cells, 1221
         do j=1,n2
           anu3(j)=anu2(n2+1-j)
           gff(j)=flux(n2+1-j)
         end do
      end if
*
      c=299792458.0
      rydb=10967758.30
* These are the speed of light and H-atom Rydberg constant in MKS units, for
* conversion of frequency to rydberg units.  The infinite mass
* R value is 10973731.534 and the proton to electron mass ratio is
* 1836.152701 for this calculation.
      con1=1./(c*rydb)
*
      do j=1,n2
        anu3(j)=anu3(j)*con1
      end do
*
      slope2=2.0
* this is the Rayleigh-Jeans slope in F_nu, for low frequency extrapolation
*
*     n1 is number of cloudy energy cells
      do j=1,n1
*       lower and upper bounds of this energy cell
        edge1=anu(j)+0.5*widflx(j)
        edge2=anu(j)-0.5*widflx(j)
*       anu3(1) is lower energy bound of kurucz input
*       changed from edge1 to edge2 96 apr 16 gjf due to zero in mid of array
        if (edge2.lt.anu3(1)) then
          ContBoltz(j)=gff(1)*((anu(j)/anu3(1))**slope2)
        else
          if (edge2.gt.anu3(n2)) then
             ContBoltz(j)=0.0
          else
            do i=1,n2-1
              if(anu3(i).le.edge2.and.anu3(i+1).gt.edge2) i2=i
              if(anu3(i).le.edge1.and.anu3(i+1).gt.edge1) i1=i
            end do
* Do the case where the grid point and its edges are between two of the
* stellar model points:  add segments with power-law interpolation up to
* do the averaging.
*
* When edge2 < anu3(1) i2 is equal to 0 and i1 is equal to 1, so do it
* as if i1 = i2 to avoid going outside array bounds.
              if (i1.eq.i2.or.i2.eq.0) then
                  power=log(gff(i1+1)/gff(i1))/
     c                    log(anu3(i1+1)/anu3(i1))
                  val=power*log(anu(j)/anu3(i1))
                  ContBoltz(j)=gff(i1)*exp(val)
              else
                  sum=0.0
*
                  do i=i2,i1
                  power=log(gff(i+1)/gff(i))/
     c                     log(anu3(i+1)/anu3(i))
                  if (i.eq.i2) then
                      x1=edge2
                      x2=anu3(i+1)
                      v1=gff(i)*exp(power*log(x1/anu3(i)))
                      v2=gff(i+1)
                  end if
                  if (i.eq.i1) then
                      x2=edge1
                      x1=anu3(i)
                      v2=gff(i)*exp(power*log(x1/anu3(i)))
                      v1=gff(i)
                  end if
                  if (i.gt.i2.and.i.lt.i1) then
                      x1=anu3(i)
                      x2=anu3(i+1)
                      v1=gff(i)
                      v2=gff(i+1)
                  end if
                  term=anu3(i)*v1
                  if (abs(power+1.).le.0.001) then
                      val=x1*v1*log(x2/x1)
                  else
                      val=((x2/x1)**(power+1.)-1.)
                      val=val*x1*v1/(power+1.)
                  end if
                  sum=sum+val
                  end do
*
                  ContBoltz(j)=sum/widflx(j)
              end if
          end if
      end if
      end do
*
      end
*******************************************************************************
      subroutine GetDLaw( chCard )
      implicit none
*parse parameters on the dlaw command
      character chCard*80
      integer limTabD
      parameter (limTabD=500)
*parameters for dlaw table command
*frad is log radius in cm, fhden is log hden
      real frad(limTabD),fhden(limTabD)
*lg is true if depth, false if radius to be used
      logical lgDLWDepth
*number of values
      integer nvals
      common/tablaw/ frad,fhden , lgDLWDepth,nvals
      double precision DensityLaw
*     parameters set by the dlaw command, used by fabden (maybe)
      common/dlaw/ DensityLaw(10)
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , j
      character chCAP*4
      real fread
      logical lgEOL , lgMatch , lgEnd
*
*     call fcn FABDEN(RADIUS) which uses the ten parameters
*     N.B.; existing version of FABDEN must be deleted
*     >>chng 96 nov 29, added table option
      if( lgMatch( 'TABL' , chCard )) then
*       when called, read in densities from input stream
        chCPres = 'DLW2'
        if( lgMatch('DEPT' , chCard ) ) then
          lgDLWDepth = .true.
        else
          lgDLWDepth = .false.
        endif
*
        call readar( chCard , lgEnd )
        i = 1
        frad(1) = fread( chCard , i , 76 , lgEOL )
        fhden(1) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' no pairs entered - cant interpolate'')')
          stop
        endif
        nvals = 2
        lgEnd = .false.
        do while( .not.lgEnd .and.nvals.lt.limTabD)
          call readar( chCard , lgEnd )
          if(.not.lgEnd ) then
            call cap4(chCard(1:4) , chCAP )
            if( chCAP(1:3).eq.'END') lgEnd = .true.
          endif
          if( .not.lgEnd ) then
            i = 1
            frad(nvals) = fread( chCard , i , 76 , lgEOL )
            fhden(nvals) = fread( chCard , i , 76 , lgEOL )
            nvals = nvals + 1
          endif
        end do
        nvals = nvals - 1
*       do i=1,nvals
*         write(6,*)i,frad(i),fhden(i)
*       end do
        do i=2,nvals
*         the radius values are assumed to be strictly increasing
          if (frad(i).le.frad(i-1)) then
            write(qq,'('' density.in radii must be in increasing '',
     1      ''order'')')
            stop
          endif
        end do
      else
*       this is usual case, call fabden to get density
        i = 4
        do j=1,10
          DensityLaw(j) = fread( chCard , i , 76 , lgEOL )
        end do
        chCPres = 'DLW1'
      endif
*
      end
      subroutine GetElem( chCard , j )
      implicit none
*scans line image, finds element with atom num j
      integer j
      character chCard*80
*
      integer limelm
      parameter (limelm=30)
      character chElNames*4
      common/ElNames/ chElNames(limelm)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      logical lgFound , lgMatch
*
*     find which element
      i = 1
      lgFound = .false.
      do while (i.le.limelm.and. .not.lgFound )
        if( lgMatch(chElNames(i),chCard ) ) then
*         IEL is atomic number of element, is used below
          j = i
          lgFound = .true.
        endif
        i = i + 1
      end do
      if( .not.lgFound) then
        write(qq,'('' GetElem did not find an element on the '',
     1  ''following line:'')')
        write(qq,'(a80)') chCard
        stop
      endif
*
      end
************************************************************************
      subroutine GetFeII( chCard )
      implicit none
*parse the FeII command
      character chCard*80
      real WavNRyd
*number of Ryd per wavenumber
*from Physics Today '96, BG 10
      parameter (WavNRyd=9.1126732e-6)
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
*     energy range and threshold for FeII lines output with punch verner
      real fe2ener(2) , fe2thresh
      common/feiipar/ fe2ener , fe2thresh
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgMatch , lgEOL
      integer i
      real fread
*
*     how to do feii atom
      if( lgMatch( 'NETZ' , chCard ) ) then
*       use netzer's simple few level atom
        chFeIIAtom = 'Netzer'
      else if( lgMatch( 'VERN' , chCard ) ) then
        if( lgMatch( 'SIMU' , chCard ) ) then
          lgSimKatya = .true.
        endif
        if( .not.lgKatyaData .and. .not.lgSimKatya ) then
          write(qq,'('' Katya Verner data not linked in.'')')
          write(qq,'('' This option not implemented.'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
*       check for theshold of weakest line
        if( lgMatch( 'THRE' , chCard ) ) then
          i = 5
          fe2thresh = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) call NoNumb(chCard )
          if( fe2thresh.lt.0. ) fe2thresh = 10.**fe2thresh
        endif
*       check for energy range of lines to be punched
        if( lgMatch( 'RANG' , chCard ) ) then
          i = 5
          fe2ener(1) = fread( chCard , i , 76 , lgEOL )
          fe2ener(2) = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) call NoNumb(chCard )
*         if either is negative then both are logs
          if( fe2ener(1).lt.0. .or. fe2ener(2).lt.0. ) then
            fe2ener(1) = 10.** fe2ener(1)
            fe2ener(2) = 10.** fe2ener(2)
          endif
*         entered in Ryd in above, convert to wavenumbers
          fe2ener(1) = fe2ener(1) / WavNRyd
          fe2ener(2) = fe2ener(2) / WavNRyd
        endif
        chFeIIAtom = 'Verner'
      else
        write(qq,'('' One of the keywords Verner or Netzer must'',
     1  '' appear on this line. '')')
        stop
      endif
*
      end
******************************************************************************
      subroutine GetFluc( chCard )
      implicit none
*parse the fluctuations command
      character chCard*80
*
      integer limelm
      parameter (limelm=30)
      real flong , cfirst , csecnd, flcPhase
*     parameters for the fluctuations command
      logical lgDenFluc
      common/fluct/ flong , cfirst , csecnd , lgDenFluc, flcPhase
      real te , eden , hden
      common/phycon/ te , eden , hden
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      logical lgEOL , lgMatch
      real fread , flmax , flmin , period , temp
*
*     rapid density fluctuations
*     first parameter is log of period, 2 is log den max, 3 log Nmin
*
      if( lgMatch( 'ABUN', chCard ) ) then
*       abundances varied
        lgDenFluc = .false.
      else
*       density is varied
        lgDenFluc = .true.
      endif
      i = 5
*     1st number log of period in centimeters
      period = 10.**fread( chCard , i , 76 , lgEOL )
      flong = 6.2831853 / period
      temp = fread( chCard , i , 76 , lgEOL )
*     2nd number log of max hydrogen density
      flmax = 10.**temp
*     3rd number log of min hydrogen density
      flmin = 10.**fread( chCard , i , 76 , lgEOL )
      if( flmax/flmin.gt.100. ) then
        write(qq,'(''This range of density probably will not work.'')')
      endif
      if( flmax.gt.1e15 ) then
        write(qq,'(''These parameters look funny to me.  Please '',
     1  ''check Hazy.'')')
      endif
      if( lgEOL .or. (flmin.gt.flmax) ) then
        write(qq,'(''There MUST be three numbers on this line.'')')
        write(qq,'(''These must be the period(cm), max, min '',
     1  ''densities, all logs, in that order.'')')
        stop
      endif
*
*     this is optional phase shift for the command
      flcPhase = fread( chCard , i , 76 , lgEOL )
*
*     FacAbunSav = (cfirst * cos( depth*flong+flcPhase ) + csecnd)
      cfirst = (flmax-flmin) / 2.
      csecnd = (flmax+flmin) / 2.
*     >>chng 96 july 13 moved depset to abnset fac
*     if( lgDenFluc ) then
*       this is a pressure law
*       chCPres = 'SINE'
*     else
*       this is the metallicity of the gas
*       do i=3,limelm
*         depset(i) = flmax
*       end do
*     endif
*
*     now get density if this is density option (not abundances)
      if(lgDenFluc) then
        chCPres = 'SINE'
*       depth is zero for first zone
        hden = (cfirst * cos( flcPhase ) + csecnd)
        hden = log10( hden )
      endif
*
      end
******************************************************************************
      real function GetGF( eina , enercm , gup )
      implicit none
*convert oscillator strength into Einstein A
      real eina , enercm , gup
*
*     derive the transition prob, given the following
*     call to function is gf, ener in cm^-1, g_up
*     gf is product of g and oscilator strength
*     eina = ( GetGF/gup) / 1.499e-8 / ( 1e4/enercm )**2
      GetGF = eina * gup * 1.499e-8 * ( 1e4/enercm )**2
*
      end
******************************************************************************
      subroutine GetGrain( chCard, lgDset  )
      implicit none
*parse parameters on grains command
      logical lgDset
      character chCard*80
*
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      logical lgPhysOK
*flag set if a physical condition has been disabled
      common/physok/ lgPhysOK
      logical lgDHetOn , lgDColOn
*lgDHetOn turned off with grain no heating
*lgDColOn turned off with grain no cooling
      common/dheton/ lgDHetOn , lgDColOn
      logical lgQHeat
*Kevin Volk add for quantum heating of grains
      common/qheat/ lgQHeat(ndust)
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
      character chOrgCard*80
*     copy of current line image used by readr with no caps forced
      common/OrgCard/ chOrgCard
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL , lgMatch , lgLinSet , lgLogOn , lgEOL1 ,
     1 lgVaryAbun
      real dep,fread , dep1
      integer i , ipnt
*
*     grain model, numbers are logs of grain abundance rel to std
      lgDustOn = .true.
      lgDset = .true.
*
*     log - linear option for grains
      lgLogOn = .false.
      if( lgMatch(' LOG' , chCard ) ) then
        lgLogOn = .true.
        lgLinSet = .false.
      else if( lgMatch('LINE' , chCard ) ) then
        lgLogOn = .true.
        lgLinSet = .true.
      endif
*
*     check for keyword function
      if( lgMatch('FUNC' , chCard ) ) then
        lgVaryAbun = .true.
      else
        lgVaryAbun = .false.
      endif
*
      i = 5
      dep = fread( chCard , i , 76 , lgEOL )
      if( lgLogOn ) then
*       log or linear was specified, which was it
        if( lgLinSet ) then
*         linear quantity enterd, and we want a log
          if( dep.gt.0. ) then
            dep = log10( dep )
          else
            write(qq,'('' Impossible for linear negative abundance.'')')
            write(qq,'('' Abundance entered was'',1P,E10.2)')dep
            write(qq,'('' Sorry.'')')
            stop
          endif
        endif
      else
*       nothing specified, check sign
*       force it to be a log - linear if greater than 0
        if( dep.gt.0. ) dep = log10( dep )
      endif
*
*     >>chng 97 july 17, change to linear since will be used throughout code
      dep = 10.** dep
*
*     NB! lgDustOn1(nd) turns on grains for some species.  None of these
*     commands turn off other grains, so successive commands will turn on
*     more and more grains.  This is intended
*
      if( lgMatch('ORIO' , chCard ) ) then
*       optional keyword ORION to use orion curves for large R grains
*       >>chng 96 nov 30, into loop for extra K Volk grain types
        lgDustOn1(3) = .true.
        lgDustOn1(4) = .true.
        dstfactor(3) = dep
        dstfactor(4) = dep
*       option to have grain abundance depend on depth
        if( lgVaryAbun ) then
          lgDustVary(3) = .true.
          lgDustVary(4) = .true.
        endif
      else if( lgMatch(' PAH' , chCard ) ) then
*       >>chng 97 mar 1, added this keyworkd
*       optional keyword  PAH to use two PAH grain species
        call broken
        lgDustOn1(9) = .true.
        lgDustOn1(10) = .true.
        dstfactor(9) = dep
        dstfactor(10) = dep
*       for PAH grains (only) there is a qheat option for quantum heating
        if (lgMatch('QHEA',chCard)) then
          lgQHeat(9)=.true.
          lgQHeat(10)=.true.
        endif
*       option to have grain abundance depend on depth
        if( lgVaryAbun ) then
          lgDustVary(9) = .true.
          lgDustVary(10) = .true.
        endif
      else if( lgMatch('GRAY',chCard).or.lgMatch('GREY',chCard)) then
*       >>chng 97 mar 1, added this keyworkd, 97 july 18, second spelling
*       optional keyword GRAY to use gray grain, 0.1 micron
        lgDustOn1(8) = .true.
        dstfactor(8) = dep
*       option to have grain abundance depend on depth
        if( lgVaryAbun ) then
          lgDustVary(8) = .true.
        endif
      else if( lgMatch(' AGB' , chCard ) .or. lgMatch('AGB ' , chCard ))
     1  then
*       key used to be planetary nebula, should be agb
*       planetary nebula - post agb, from Kevin Volk
*       Try to read the second depletion factor (K Volk)
        dep1 = fread(chCard,i,76,lgEOL1)
        if(lgEOL1) dep1 = dep
*       >>chng 97 july 17, linear dep1
*       if(dep1.gt.0.) dep1 = alog10(dep1)
        if(dep1.le.0.) dep1 = 10.**dep1
*       End of changes here (K Volk)
        lgDustOn1(1) = .true.
        lgDustOn1(7) = .true.
        dstfactor(1) = dep
*       >>chng 96 nov 30, as per K Volk second parameter
        dstfactor(7) = dep1
*       option to have grain abundance depend on depth
        if( lgVaryAbun ) then
          lgDustVary(1) = .true.
          lgDustVary(7) = .true.
        endif
      else
*        turn one type of dust on if second number present
         ipnt = fread( chCard , i , 76 , lgEOL )
         if( lgEOL ) then
*          no second number, use default ISM dust with optional depletion
*          Mathis et al. ISM grains
           lgDustOn1(1) = .true.
           lgDustOn1(2) = .true.
           dstfactor(1) = dep
           dstfactor(2) = dep
*          option to have grain abundance depend on depth
           if( lgVaryAbun ) then
             lgDustVary(1) = .true.
             lgDustVary(2) = .true.
           endif
         else if( ipnt.lt.1 .or. ipnt.gt.ndust ) then
           write(qq,'('' Pointer to grain type bad.  Sorry.'')')
           stop
         else
*          this branch if grain number on line
           lgDustOn1(ipnt) = .true.
           dstfactor(ipnt) = dep
*          option to have grain abundance depend on depth
           if( lgVaryAbun ) then
             lgDustVary(ipnt) = .true.
           endif
*          Changes to dust for other grains (K Volk)
*          this branch if grain species greater than 10 - we will
*          read in optical properties from ancillary file
           if (ipnt.gt.ndust-10) call rdfile(chOrgCard,i,ipnt)
*          reads in parameters for the grain from a file if the
*          number is >= 11, the current value of ndust being 20.
*
*          Add change for quantum heating, keeping track of depletions of grain
           qdep(ipnt)=qdep(ipnt)*(10.**dep)
*          Add qheat option
*          for grains set by number (only) there is a qheat option for
*          quantum heating
           if( lgMatch('QHEA',chCard)) lgQHeat(ipnt)=.true.
*           End of changes here (K Volk)
         endif
      endif
*
*     option to turn off photoelectric heating by grain, NO HEATING
      if( lgMatch( 'O HE' , chCard ) ) then
        lgPhysOK = .false.
        lgDHetOn = .false.
      endif
*
*     option to turn off gas cooling by grain, NO COOLING
      if( lgMatch( 'O CO' , chCard ) ) then
        lgPhysOK = .false.
        lgDColOn = .false.
      endif
*
      end
******************************************************************************
      subroutine GetInit(chCard)
      implicit none
*bring an initialization file into input stream before parse
      character chCard*80
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      character chOrgCard*80
*     copy of current line image used by readr with no caps forced
      common/OrgCard/ chOrgCard
      character chPath*80
      common/path/ chPath
      logical lgPathSet
*true is path has been set with set path command, false otherwise
      common/pthset/ lgPathSet
*
*     local variables
      logical lgMatch , lgHit1 , lgHit2
      character chLine*80 , chK1*1 , chName*80 , chC1*1 , chC2*1
      integer IOini , j , i , ierr, ip ,nName
      data IOini/94/
      data chC1,chC2/'"',''''/
*
      if( lgMatch('FILE',chCard) ) then
*       option to give ini file a different name
        lgHit1 = .false.
        i = 5
*     >>chng 97 june 18, get rid of go to
        do while( i.lt.80 .and. .not.lgHit1 )
*       do i=5,80
          if((chCard(i:i).eq.chC1).or.(chCard(i:i).eq.chC2)) then
            lgHit1 = .true.
            lgHit2 = .false.
            j = i + 1
            do while( j.lt.80 .and. .not.lgHit2 )
*           doj=i+1,80
              if((chCard(j:j).eq.chC1).or.(chCard(j:j).eq.chC2)) then
                lgHit2 = .true.
                nName = j - i - 1
*               use orginal form of line image before forced to caps
                chName(1:nName) = chOrgCard(i+1:j-1)
*               go to111
              endif
              j = j + 1
            end do
            if(.not.lgHit2 ) then
              write(qq,'('' I could not find the end of the name.'')')
              write(qq,'('' the name of the init file must appear in '',
     1        ''quotes.'')')
              stop
            endif
          endif
          i = i + 1
        end do
        if( .not.lgHit1 ) then
          write(qq,'('' I could not find the start of the name.'')')
          write(qq,'('' The name of the init file must appear in '',
     1    ''quotes.'')')
          stop
        endif
*111    continue
      else
        chName(1:10) = 'cloudy.ini'
        nName = 10
      endif
*     option to get cloudy.ini from a path
      if( lgPathSet.and. lgMatch('PATH',chCard) ) then
        i = 1
*     >>chng 97 june 18 get rid of go to
        do while( i.lt.80 .and. chPath(i:i).ne.' ' )
*       do i=1,80
          chLine(i:i) = chPath(i:i)
          i = i + 1
        end do
*2      continue
*       i now points to first free character
        chLine(i:i+nName-1) = chName
*       end string with zero character
        chLine(i+nName:i+nName) = char(0)
      else
        chLine(1:nName) = chName
*       end string with zero character
        chLine(nName+1:nName+1) = char(0)
      endif
*
*     get cloudy.ini initialization file
      open(IOini,file=chLine ,status='old',iostat=ierr)
      if( ierr.ne.0 .and. .not.lgPathSet ) then
*       this branch, file not found, path was not set
        write(qq,'('' GetInit could not find initialization file'',
     1  '' cloudy.ini'')')
        write(qq,'('' The path I tried follows:'')')
        write(qq,'(a80)') chLine
        stop
      else if( ierr.ne.0 ) then
*       this option - no ini file here, but path was set
*       we will check for an ini file on the path
        i = 1
*     >>chng 97 june 18, get rid of go to
        do while( i.lt.80 .and. chPath(i:i).ne.' ' )
          chLine(i:i) = chPath(i:i)
          i = i + 1
        end do
*20     continue
*       j now points to first free character
        chLine(i:i+nName-1) = chName
*       end string with zero character
        chLine(i+nName:i+nName) = char(0)
        open(IOini,file=chLine ,status='old',iostat=ierr)
        if(ierr.ne.0 ) then
*         still could not find it
          write(qq,'('' GetInit could not find initialization file'',
     1    '' cloudy.ini'')')
          write(qq,'('' The path I tried follows:'')')
          write(qq,'(a80)') chLine
          write(qq,'('' The path as set was:'')')
          write(qq,'(a80)') chPath
          write(qq,'('' The name was:'')')
          write(qq,'(a80)') chName
          stop
        endif
      endif
*
      nSaveIni = 1
*     >>chng 97 june 25, get rid of statement labels in following loop
*999  continue
      ip = nkrd+1-nSaveIni
      read(IOini,'(a80)',iostat=ierr) chCardSav(ip)
      chK1 = chCardSav(ip)(1:1)
      do while( ierr.eq.0 .and. chCardSav(ip)(1:4).ne.'    ' )
        nSaveIni = nSaveIni + 1
        ip = nkrd+1-nSaveIni
        if( ip.le.nSave ) then
          write(qq,'('' Too many ini lines.  Total of all input and '',
     1    ''ini lines cannot exceed nkrd, presently'',i4)') nkrd
          stop
        endif
        read(IOini,'(a80)',iostat=ierr) chCardSav(ip)
        chK1 = chCardSav(ip)(1:1)
        do while( ierr.eq.0 .and.
     1    (chK1.eq.'#' .or. chK1.eq.'*' .or. chK1.eq.'%' )  )
          read(IOini,'(a80)',iostat=ierr ) chCardSav(ip)
*         totally ignore any card starting with a #, *, or %
          chK1 = chCardSav(ip)(1:1)
        end do
      end do
*     go to999
*
*908  continue
      close(IOini)
*     last one with real data is nkrd+1-nSaveIni
      nSaveIni = nSaveIni - 1
*
*     following code prints out all read in line images
*     write(6,*)' nkrd=',nkrd,' nSaveIni=',nSaveIni
*     write(6,'(a80)') (chCardSav(ip),ip=nkrd,nkrd+1-nSaveIni,-1)
*
      end
******************************************************************************
      subroutine GetInter( chCard , lgEOF )
      implicit none
*parse parameters on interpolate command
      character chCard*80
      logical lgEOF
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgMMok , lgHPhtOK , lgXRayOK , lgGamrOK
      common/bndsok/ lgMMok , lgHPhtOK , lgXRayOK , lgGamrOK
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      real emm , egamry
      common/bounds/ emm , egamry
      real EnerGammaRay
*lowest energy counted as gamma rays, 100 keV
      integer ipEnerGammaRay
      common/egray/ EnerGammaRay , ipEnerGammaRay
      logical lgConBug
*flag set with trace continuum command
      common/conbug/ lgConBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL , lgDONE
      integer i , j
      real fread , cmax , cmin , fac
*
*     this sub reads in the "interpolate" command, and includes
*     logic for the "continue" lines as well.
*     OUTPUT:
*     TNU is vector of eneriges where the grid is defined
*     TSLOP initially is vector of log fnu at each freq
*     converted into slopes here too
*
      nspec = nspec + 1
      if( nspec.ge.limspc) then
        write(qq,'('' Too many spectra entered.  Increase LIMSPC'')')
        stop
      endif
*
      chSpType(nspec) = 'INTER'
*
*     read all of the numbers on a line
      j = 0
*     this is flag saying that all numbers are in
      lgDONE = .false.
*     this flag says we hit end of command stream
      lgEOF = .false.
      do while( .not. lgDONE .and. .not.lgEOF)
        i = 5
        lgEOL = .false.
*       keep scanning numbers til we hit eol for current line image
        do while(.not.lgEOL)
          j = min( j+1 , ncell )
          tnu(nspec,j) = fread( chCard , i , 76 , lgEOL )
          tslop(nspec,j) = fread( chCard , i , 76 , lgEOL )
        end do
        j = j - 1
*
*       read a new line, checking for EOF
        call readar( chCard , lgEOF )
*       option to ignore all lines starting with #, *, or %.
        do while( .not.lgEOF .and. (
     1    chCard(1:1).eq.'#' .or. chCard(1:1).eq.'*' .or.
     1    chCard(1:1).eq.'%' ) )
          call readar( chCard , lgEOF )
        end do
*
        call caps( chCard )
        if( chCard(1:4) .eq. 'CONT' ) then
          if(lgTalk) write(qq,'(23X,''*'',1X,A80,''*'')') chCard
        else
*         we have a line but next command, not continue
          lgDONE = .true.
        endif
*       this is another way to hit end of input stream - blank lines
        if( chCard(1:1) .eq. ' ' ) lgEOF = .true.
      end do
*
*     done reading all of the possible lines
      j = j - 1
      if( j.lt.1 ) then
        write(qq,'('' There must be at least 2 pairs to interpolate,'')
     1  ')
        stop
      else if( j.gt.ncell-2 ) then
        write(qq,'('' Too many continuum points entered.'')')
        stop
      endif
*
      if( tnu(nspec,1).eq.0. ) then
*       special case - if first energy is zero then it is low energy
        if( tnu(nspec,2).gt.0. ) then
*         second energy positive, assume linear Ryd
          tnu(nspec,1) = emm
        else if( tnu(nspec,2).lt.0. ) then
*         second energy negative, assume log of Ryd
          tnu(nspec,1) = log10( emm )
        else
*         second energy zero, not allowed
          write(qq,'('' An energy of zero was entered for element'',
     1    ''2 in INTERPOLATE and is not allowed.  SORRY'')') i
          stop
        endif
      endif
*
*     convert from log(Hz) to Ryd if first nu>5
      if( tnu(nspec,1).ge.5. ) then
        do i=1,j+1
          tnu(nspec,i) = 10.** (tnu(nspec,i)-15.517)
        end do
      else if( tnu(nspec,1).lt.0. ) then
*       energies entered as logs
        do i=1,j+1
          tnu(nspec,i) = 10.**tnu(nspec,i)
        end do
      else
*       numbers are linear Rydbergs
        do i=1,j+1
          if( tnu(nspec,i).eq.0. ) then
            write(qq,'('' An energy of zero was entered for element'',
     1      I3,'' in INTERPOLATE and is not allowed.  SORRY'')') i
            stop
          end if
        end do
      endif
*
      do i=1,j
*       check that frequencies are monotonically increasing
        if( tnu(nspec,i+1).le.tnu(nspec,i) ) then
          write(qq,'('' The energies MUST be in increasing order.'',
     1    ''  Energy #'',I3,''='',1P,E10.2,'' Ryd was greater than'',
     2    '' or equal to the next one.  Sorry.'')') i , tnu(nspec,i)
          stop
        endif
*       TFAC is energy, and TSLOP is slope in f_nu; not photons
        tfac(nspec,i) = tslop(nspec,i)
        tslop(nspec,i) = (tslop(nspec,i+1)-tslop(nspec,i)) /
     1  log10(tnu(nspec,i+1) / tnu(nspec,i))
      end do
      tfac(nspec,j+1) = tslop(nspec,j+1)
*
      if( j+2.lt.ncell ) then
*       zero out remainder of array
        do i=j+2,ncell
          tnu(nspec,i) = 0.
        end do
      endif
*
*     now check that array is defined over all energies
      if( (tnu(nspec,1).gt.emm) ) then
*       not defined over low energy part of array
        write(qq,'('' Warning:  the input continuum was not defined '',
     1   ''over the entire energy range. Some energies are set to '',
     2  ''zero.''/'' >>>>>>>>>>You are making a big mistake.'')')
      endif
*
*     check on IR
      if( tnu(nspec,1).gt.emm )   lgMMok = .false.
      if( tnu(nspec,1).gt.1/36.) then
        lgHPhtOK = .false.
      endif
*     gamma ray, EGAMRY is roughly 100MeV
      if( tnu(nspec,j+1).lt.egamry ) lgGamrOK = .false.
*     EnerGammaRay is roughly 100keV; high is gamma ray
      if( tnu(nspec,j+1).lt.EnerGammaRay) lgXRayOK = .false.
*
*     find min and max of continuum
      cmax = -38.
      cmin = 28
*     tfac can be very large or small
      do i=1,j
        cmax = max( cmax , tfac(nspec,i) )
        cmin = min( cmin , tfac(nspec,i) )
      end do
*
*     check on dynamic range of input continuum
      if( cmax - cmin .gt.74. .and. lgBit32 ) then
        write(qq,'('' The dynamic range of the specified continuum'',
     1  ''is too large for a 32-bit computer.  Sorry.'')')
        stop
      endif
*
      if( cmin.lt.-37. ) then
        fac = -cmin - 37.
        do i=1,j
          tfac( nspec,i ) = tfac( nspec,i ) + fac
        end do
      else if( cmax.gt.37. ) then
        fac = cmax - 37.
        do i=1,j
          tfac( nspec,i ) = tfac( nspec,i ) - fac
        end do
      endif
*
*     option to print out results at this stage - "trace continuum"
      if( lgConBug.and.lgTrace ) then
        write(qq,'('' Table for this continuum; TNU, TFAC, TSLOP'')')
        write(qq,'(1p,3e12.4)')(tnu(nspec,i),tfac(nspec,i),
     1  tslop(nspec,i),i=1,j+1)
      endif
*
*     renormalize continuum so that quantity passes through unity
*     at 1 Ryd
*     >>chng 97 june 8, get rid of statement labels
*     find 1 ryd, j is one less than number of continuum pairs
      i = 1
      do while( tnu(nspec,i).lt.1. .and. i.lt.j )
        i = i + 1
      end do
*     j is 2 if continuum has 3 points (dqher.in tests this)
*     if j is 1 then i is 1, if j is 2 then i is 2
      if( j.gt.2 .and. tnu(nspec,i).lt.1. ) then
        write(qq,'('' TABLE fails sanity test in GetInter'')')
        stop
      endif
*
*     do the renormalization so 1 ryd is about unity
      fac = tfac(nspec,i)
      do i=1,j+1
        tfac(nspec,i) = tfac(nspec,i) - fac
      end do
*
      end
******************************************************************
      subroutine GetMaxhLine
      implicit none
*find the strongest heating line
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      real heatlmax
      integer levlmax , ipHeatlmax
      common/heatlmax/ heatlmax , levlmax , ipHeatlmax
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
*
*     local variables
      integer i
      real strong
*
*     routine called to find which is the strongest heating line
      strong = 0.
*     possible for levlmax to remain 0 if induced processes turned off
      levlmax = 0
      do i=1,nTauLines
        if( TauLines(ipLnHeat,i).gt.strong ) then
          strong = TauLines(ipLnHeat,i)
          levlmax = 1
          ipHeatlmax = i
        endif
      end do
      do i=1,NWINDLINE
        if( WindLine(ipLnHeat,i).gt.strong ) then
          strong = WindLine(ipLnHeat,i)
          levlmax = 2
          ipHeatlmax = i
        endif
      end do
      end
*******************************************************************************
      subroutine GetNorm( chCard )
      implicit none
*parse parameters on the normalize command
      character chCard*80
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , ipQ
      real fread
      logical lgEOL , lgHit
      character chQ1*1 , chQ2*1
      data chQ1/'"'/ , chQ2/''''/
*
*     normalise lines to this rather than h-b, sec number is scale factor
      i = 5
      NormWL = -fread( chCard , i , 76 , lgEOL )
*     neg sign is flag that NormWL is wavelength not pointer to line array eleme
*     startr will convert it to a pointer in the line stack
      if( lgEOL ) call NoNumb(chCard )
      sclnrm = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) sclnrm = 1.
*     confirm that scale factor is positive
      if( sclnrm.le.0. ) then
        write(qq,'('' The scale factor for relative intensities must '',
     1  ''be greater than zero.'')')
        write(qq,'(''Sorry.'')')
        stop
      endif
*
*     check whether there is a label on the line
      i = 4
      lgHit = .false.
      ipQ = 0
      do while( .not.lgHit .and.i.lt.73 )
        if( (chCard(i:i).eq.chQ1) .or. (chCard(i:i).eq.chQ2) ) then
          ipQ = i
          lgHit = .true.
        endif
        i = i + 1
      end do
*
      if( lgHit ) then
*       got quote, check both quotes are there
        if( (chCard(ipQ+5:ipQ+5).ne.chQ1) .and.
     1    (chCard(ipQ+5:ipQ+5).ne.chQ2) ) then
          write(qq,'('' for normalize command with labels, two '',
     1    ''quotes are needed'')')
          stop
        endif
*       must use orginal card image
        chNormLab = chCard(ipQ+1:ipQ+4)
      endif
*
      end
******************************************************************************
      subroutine GetPrint( chCard , lgEOL )
      implicit none
*parse the print command
      character chCard*80
      logical lgEOL
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer itrprt
      common/itrprt/ itrprt(itrdim)
      logical lgPrtLastIt
*if true then print only last iteration
      common/plast/ lgPrtLastIt
      logical lgPrtShort
*flag set with print short comand
      common/pshort/ lgPrtShort
      logical lgFaintOn
*logical lgFaintOn normally true, says to not print very faint lines
*set false with print faint off command
*lines fainter than TooFaint will not be printed.  This is set in zerologic
*and reset with print line faint command
      real TooFaint
      common/faint/ TooFaint , lgFaintOn
      logical lgFntSet
*flag set true if print faint command entered,
*only used to not overrid it with print short
      common/fntset/ lgFntSet
      logical lgOnlyZone , lgOnlyHead
*lgOnlyZone set with print only zones
*lgOnlyHead set with print only header
      common/only/ lgOnlyZone , lgOnlyHead
      logical lgPrtArry
*flag set with print array command
      common/parray/ lgPrtArry
      logical lgPrintHeating
*     flag to turn on printout of heat sources
      common/pheat/ lgPrintHeating
      logical lgPrtStart
*lgPrtStart is option to start printout at certain zone
*nstart is zone number, set with print start command
      integer nstart
      common/pstart/ lgPrtStart , nstart
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer nzdump
      common/dump/ nzdump
      real prall , psort
      common/prall/ prall , psort
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgPrtCont
*flag set with print continuum command
      common/pconon/ lgPrtCont
      logical lgPrtBN
*flag set with print departure coefficients
      common/pbn/ lgPrtBN
*     lgPrtTau tells whether to print line optical depths
*     PrtTauFnt is smallest line optical depth to print
      logical lgPrtTau
      real PrtTauFnt
      common/PrtTau/ lgPrtTau , PrtTauFnt
      logical lgPrnErr
      integer ioPrnErr
      common/PrnErr/ lgPrnErr , ioPrnErr
      logical lgPrnPump , lgPrnHeat , lgPrnColl , lgPrnInwd,lgPrnDiff
      common/PrnLine/ lgPrnPump , lgPrnHeat , lgPrnColl , lgPrnInwd,
     1 lgPrnDiff
      logical lgPrnAges
      common/PrnAges/ lgPrnAges
      logical lgPrtMaser
*     option to print maser lines (true) normally false
*     print maser turns on
      common/PrtMaser/ lgPrtMaser
*
*     local variables
      logical lgKeyIn , lgMatch
      integer i,j,num1
      real fread,sum , a
*
      lgKeyIn = .false.
*
      if( lgMatch( ' ALL' , chCard ) ) then
*       print all lines including those from ratios
        prall = 1
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'AGES' , chCard ) ) then
*       print all estimates of cloud timescales
        lgPrnAges = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'ARRA' , chCard ) ) then
*       print arrays for ionization balance of heavy elements
        lgPrtArry = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'ERRO' , chCard ) ) then
*       turn on error printing to screen
        lgPrnErr = .true.
        lgKeyIn = .true.
        i = 5
        j = fread( chCard , i , 76 , lgEOL )
        if( .not.lgEOL ) ioPrnErr = j
        if( ioPrnErr.le.0 ) then
          write(qq,'('' io units must be positive.'')')
          stop
        endif
        write(ioPrnErr,'('' Errors will go to io'',i3)')ioPrnErr
      endif
*
      if( lgMatch( 'DEPA' , chCard ) ) then
*       print departure coef instead of hydrogen level populations
        lgPrtBN = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'FAIN' , chCard ) ) then
        lgKeyIn = .true.
*       faintest line, rel to norm line, to print; either linear of log
        i = 5
        a = fread( chCard , i , 76 , lgEOL )
*       option for, if no number, keyword=" OFF", to print all lines
        if( lgEOL ) then
          if( lgMatch( ' OFF' , chCard ) ) then
            lgFaintOn = .false.
          else
            write(qq,'('' There faintest line to print must be '',
     1      ''on this line, sorry.'')')
            stop
          endif
        endif
        lgFntSet = .true.
        if( a.le.0. ) then
          TooFaint = 10.** a
        else
          TooFaint = a
        endif
      endif
*
      if( lgMatch( 'HEAT' , chCard ) ) then
*       print heat arrays
        lgPrintHeating = .true.
        lgKeyIn = .true.
      endif
*
*     option to only print last iteration
      if( lgMatch( 'LAST' , chCard ) ) then
        lgPrtLastIt = .true.
        lgKeyIn = .true.
      endif
*
*     the print line command as several options
      if( lgMatch( 'LINE' , chCard ) ) then
        lgKeyIn = .true.
        if( lgMatch( ' ALL' , chCard ) ) then
*         turn on all printed componenets
          lgPrnPump = .true.
          lgPrnColl = .true.
          lgPrnHeat = .true.
        else if( lgMatch( 'PUMP' , chCard ) ) then
*         also print pump contributions
          lgPrnPump = .true.
        else if( lgMatch( 'INWA' , chCard ) ) then
*         also print inward contributions
          lgPrnInwd = .true.
        else if( lgMatch( 'COLL' , chCard ) ) then
*         also print collisional contributions
          lgPrnColl = .true.
        else if( lgMatch( 'HEAT' , chCard ) ) then
*         also print heating contributions
          lgPrnHeat = .true.
        else if( lgMatch( 'OPTI',chCard ).and.lgMatch('DEPT',chCard ) )
     1    then
*         print optical depths
          lgPrtTau = .true.
        else if( lgMatch(' SUM' , chCard ) ) then
*         option to read in set of lines to sum over
          call rdsum( sum , 'READ' )
        else
          write(qq,'('' One of the keys EXTRA, INWARD, COLL, HEAT, '',
     1    ''SUM, OPTICAL DEPTHS, ALL or PUMP should have appeared.'')')
          stop
        endif
      endif
*
*     print maser lines when TAV is called
      if( lgMatch( 'MASE' , chCard ) ) then
        lgPrtMaser = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'ONLY' , chCard ) ) then
        lgKeyIn = .true.
        if( lgMatch( 'ZONE' , chCard ) ) then
          lgOnlyZone = .true.
        else if( lgMatch( 'HEAD' , chCard ) ) then
          lgOnlyHead = .true.
        else
          write(qq,'('' There must be a keyword for the ONLY'',
     1    '' option.  They are HEAD and ZONE.  Sorry.'')')
          stop
        endif
      endif
*
      if( lgMatch( 'OPTI',chCard ).and.lgMatch('DEPT',chCard ) ) then
*       optical depths, with option for smallest to print
        lgKeyIn = .true.
        if( lgMatch( ' OFF',chCard ) ) then
*         turn off or on printing of optical depths - default off
          lgPrtTau = .false.
        else
          lgPrtTau = .true.
        endif
        if( lgMatch('FAIN' , chCard ) ) then
*         log of faintest optical depth
          i = 5
          PrtTauFnt = 10.**fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) then
            write(qq,'('' There must be a number for the FAINT'',
     1      '' option.  They are HEAD and ZONE.  Sorry.'')')
            stop
          endif
        endif
      endif
*
      if( lgMatch( 'SORT' , chCard ) ) then
*       turn on sorting with respect to wavelength
        psort = 1
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'STAR' , chCard ) ) then
*       start printout at specified zone
        lgTalk = .false.
        lgPrtStart = .true.
        i = 5
        nstart = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' The zone on which the print is to start'',
     1    '' MUST be entered on this line.  Sorry.'')')
          stop
        endif
        lgKeyIn = .true.
      endif
*
      if( lgMatch('CONT' , chCard ) ) then
        if( lgMatch('DIFF' , chCard ) ) then
          lgPrnDiff = .true.
        else
*         option to print emergent continuum
          lgPrtCont = .true.
        endif
        lgKeyIn = .true.
      endif
*
      if( lgMatch('COOL' , chCard ) ) then
*       print cooling array for a specified one
        i = 5
        nzdump = fread( chCard , i , 76 , lgEOL )
*       dumpt all zones if argument is zero or not present
        if( lgEOL ) nzdump = 0
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'QUIE',chCard) .or.
     1  (lgMatch(' OFF',chCard) .and. .not. lgMatch('FAIN',chCard)) )
     2  then
*       in above, there is also a 'print faint off' command
*       QUIET or OFF means turn off printout
        lgTalk = .false.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( ' ON ',chCard) ) THEN
*       on means turn on printout
        lgTalk = .true.
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'SHOR' , chCard ) ) then
*       make short printout, don't print last
        lgPrtShort = .true.
        if(.not.lgFntSet) TooFaint = 0.001
        lgKeyIn = .true.
      endif
*
      if( lgMatch( 'EVER' , chCard ) ) then
        lgKeyIn = .true.
*       print every nth zone
        i = 5
        num1 = fread( chCard , i , 76 , lgEOL )
       if( lgEOL ) then
          write(qq,'('' The number of zones to print MUST be entered''
     1    ,'' on this line.  Sorry.'')')
          stop
        endif
        itrprt(1) = max( num1 , 1 )
        do j=2,itrdim
          itrprt(j) = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) itrprt(j) = itrprt(j-1)
        end do
      endif
*
*     check if no numbers, but only keywords.
      if( .not. lgKeyIn ) then
*       general catch-all for no number when there should have been
        write(qq,'('' There MUST be a keyword on the following '',
     1  ''line.  Sorry.'')')
        write(qq,'(1X,A80)') chCard
        stop
      endif
*
      end
******************************************************************************
      subroutine GetPunch( chCard )
      implicit none
*parse the punch command
      character*80 chCard
*
      integer limpun
      parameter (limpun=20 )
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      character chPunch*4, chConPunEnr*4
      integer ipConPunEnr
*chPUnch - what is it we want to punch? set in GetPunch, used in DoPunch
*chConPunEnr - units of continuum in punch output
      common/cpunch/ chPunch(limpun) , chConPunEnr(limpun) , ipConPunEnr
      integer ipPnunit , npunch
      real punarg
*     ipPnunit is io unit number, number of punch commands eneterd
*     punarg is set of optional arguments for the punch command
      common/pnunit/ ipPnunit(limpun) , npunch , punarg(limpun,3)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      logical lgPunLstIter(limpun)
*lg flag lgPunLstIter for this punch option,
*do we only want to punch on last iteration?
      common/punlst/ lgPunLstIter
      logical lgDROn , lgDRPLst
*     these control punching choice of dr - this is not really a punch cmnd
*     ipDRout is io unit, lgDROn says punching dr logic has been set,
*     and lgDRPLst says to punch the last iteration
      integer ipDRout
      logical lgFe2PLst
      common/ipdr/ ipDRout , lgDROn , lgDRPLst , lgFe2PLst
      logical lgPunH2
*lgPunH2 says to punch H2 rates on unit ipPunH2
      integer ipPunH2
      common/iph2/ ipPunH2 , lgPunH2
      integer iPunDef
*     this is an integer giving the unit number for the next fort fil
*     set to 11 in zero, reset with 'set ipundef' command
*     incremented for each punch command that does not specify a unit
      common/PunDef/ iPunDef
      integer LinEvery
      logical lgLinEvery
*option to punch line intensities every LinEvery zones
*logical variable says whether LinEvery was set
      common/levery/ LinEvery , lgLinEvery
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer ioreco
      common/ioreco/ ioreco
      character*4 chOpcTyp
*     which opacity to punch out
      common/optype/ chOpcTyp
      integer ioVerner , ipHiVernFe2
      logical lgShortFe2
*punch unit for 'punch verner' command
*ipHiVernFe2 is highest level, second number on command line
      common/ioVerner/ ioVerner , ipHiVernFe2 , lgShortFe2
      character chDate*7 , chVersion*7
      common/date/ chDate , chVersion
      logical lgPunConv
      integer ipPunConv
*     unit number, and flag, for punching reason for continued iterations
      common/PunConv/ lgPunConv , ipPunConv
      integer ipPoint
      logical lgPunPoint
*option to punch out pointers with punch pointers commmand
*ipPoint is punch unit number, lgPunPoint says whether we will do it
      common/PunPoint/ ipPoint , lgPunPoint
      logical lgExemplar
*set true when on exemplar with 'set exemplar' to get around
*bug in their compiler
      common/Exemplar/ lgExemplar
      character chPunRltType*6
*set with punch line intensites and punch results commands,
*says whether results arrays produced by routine PunResult should
*be column or array
      common/PunRltType/ chPunRltType
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*     warning!!! i is used as the fread pointer when if's begin
*     this MUST NOT be reset
      integer i , j
      real fread
      integer ipu , nLabel , ierr
      character*4 chDst , chLabel*80
      logical lgEOL , lgMatch , lgOK , lgFile
*
*     this routine reads in the punch commands
*
      npunch = npunch + 1
      if( npunch.gt.limpun ) then
        write(qq,'(''(The limit to the number of PUNCH options is'',
     1  i3,''.  Increase LIMPUN if more are needed.'')') limpun
        stop
      endif
*
*     option to only punch on last iteration
      if( lgMatch( 'LAST' , chCard ) ) then
        lgPunLstIter(npunch) = .true.
      else
        lgPunLstIter(npunch) = .false.
      endif
*
*     >>chng 96 dec 19, added following open
*     >>chng 97 july 1, move to before getting unit number so that
*clearing file name happens before unit scanned off
*     option to get file name to punch to, after opening it
      if( lgMatch( 'FILE' , chCard ) ) then
        call GetQuote( chLabel , nLabel, lgOK , chCard )
        lgFile = .true.
        if( .not.lgOK ) then
          write(qq,'('' name specified but no quotes encountered'')')
          stop
        endif
*       must end string with zero character
        chLabel(nLabel+1:nLabel+1) = char(0)
      else
        lgFile = .false.
      endif
*
      i = 5
      ipPnunit(npunch) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
*       iPunDef is set to 11 in ZERO, this prevents overwriting punch files
*       iPunDef points to next file
*       can be reset with set 'iPunDef' command
        ipPnunit(npunch) = iPunDef
        iPunDef = iPunDef + 1
      else
        ipu = ipPnunit(npunch)
        if( ipu.eq.5 .or. ipu.eq.6 ) then
          write(qq,'(''  This unit conflicts with standard '',
     1    ''FORTRAN IO'')')
          stop
        else if( ipu.le.0 ) then
          write(qq,'(''  Unit numbers <= 0 not allowed in Fortran'')')
          stop
        else if( ipu.ge.90 ) then
          write(qq,'(''  Unit numbers 90 not allowed by cloudy.'')')
          write(qq,'(''  These are needed for internal matters'')')
          write(qq,'(''  Sorry.'')')
          stop
        endif
      endif
*
*     we now have the io unit, and maybe the file name, let's open it
      if( lgFile ) then
*       open the file with the name generated above
        open( ipPnunit(npunch) , file=chLabel , iostat=ierr )
        if( ierr.ne.0 ) then
          write(qq,'('' GetPunch: some error encountered trying to'',
     1    '' open file '',a10,'' unit '',i3)') chLabel, ipPnunit(npunch)
          stop
        endif
      else
*       file name not specified
*       open the file, this line may need to be modified on some systems
*       exemplar has a bug
        if( .not.lgExemplar ) open( ipPnunit(npunch) )
      endif
*
*     put title of model on unit
      write(ipPnunit(npunch),'(a7,a75)') chVersion, chTitle
*
*     this must come first since elements appear as sub-keywords
      if( lgMatch( 'OPAC' , chCard ) ) then
        chPunch(npunch) = 'OPAC'
        if( lgMatch('TOTA' , chCard ) ) then
*         DoPunch will call popac to parse the subcommands
*         punch total opacity
          chOpcTyp = 'TOTL'
          write(ipPnunit(npunch),'(''     nu,       tot opac,    '',
     1''abs opac,     scat,      albedo'')')
        else if( lgMatch( 'FIGU' , chCard ) ) then
*         do figure for hazy
          chOpcTyp = 'FIGU'
          write(ipPnunit(npunch),'('' nu, H, He, tot opac'')')
        else if( lgMatch( 'GRAI' , chCard ) ) then
          chPunch(npunch) = 'DUSO'
*         punch grain opacity command in twice, here and above in opacity
          chDst = 'OPAC'
          write(ipPnunit(npunch),'(''   grain nu,  total,  absorpt,'',
     1    ''  scat'')')
        else if( lgMatch( 'SHEL' , chCard ) ) then
          chPunch(npunch) = 'OPAC'
*         punch subshell cross sections
          chOpcTyp = 'SHEL'
*         this is element
          punarg(npunch,1) = fread( chCard , i , 76 , lgEOL )
*         this is ion
          punarg(npunch,2) = fread( chCard , i , 76 , lgEOL )
*         this is shell
          punarg(npunch,3) = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) then
            write(qq,'('' there must be io unit, atom wght, ion, '',
     1      ''shell'')')
            stop
          endif
          write(ipPnunit(npunch),'('' sub shell cross section'')')
*       all of following produce n fort.n files, one for each stage of
*       ionization.  The code stops after these files are produced.
        else if( lgMatch('HYDR' , chCard ) ) then
          chOpcTyp = 'HYDR'
        else if( lgMatch('HELI' , chCard ) ) then
          chOpcTyp = 'HELI'
        else if( lgMatch('LITH' , chCard ) ) then
          chOpcTyp = 'LITH'
        else if( lgMatch('BERY' , chCard ) ) then
          chOpcTyp = 'BERY'
        else if( lgMatch('BORO' , chCard ) ) then
          chOpcTyp = 'BORO'
        else if( lgMatch('CARB' , chCard ) ) then
          chOpcTyp = 'CARB'
        else if( lgMatch('NITR' , chCard ) ) then
          chOpcTyp = 'NITR'
        else if( lgMatch('OXYG' , chCard ) ) then
          chOpcTyp = 'OXYG'
        else if( lgMatch('FLUO' , chCard ) ) then
          chOpcTyp = 'FLUO'
        else if( lgMatch('NEON' , chCard ) ) then
          chOpcTyp = 'NEON'
        else if( lgMatch('SODI' , chCard ) ) then
          chOpcTyp = 'SODI'
        else if( lgMatch('MAGN' , chCard ) ) then
          chOpcTyp = 'MAGN'
        else if( lgMatch('ALUM' , chCard ) ) then
          chOpcTyp = 'ALUM'
        else if( lgMatch('SILI' , chCard ) ) then
          chOpcTyp = 'SILI'
        else if( lgMatch('PHOS' , chCard ) ) then
          chOpcTyp = 'PHOS'
        else if( lgMatch('SULF' , chCard ) ) then
          chOpcTyp = 'SULF'
        else if( lgMatch('SULP' , chCard ) ) then
          chOpcTyp = 'SULF'
        else if( lgMatch('CHLO' , chCard ) ) then
          chOpcTyp = 'CHLO'
        else if( lgMatch('POTA' , chCard ) ) then
          chOpcTyp = 'POTA'
        else if( lgMatch('ARGO' , chCard ) ) then
          chOpcTyp = 'ARGO'
        else if( lgMatch('CALC' , chCard ) ) then
          chOpcTyp = 'CALC'
        else if( lgMatch('SCAN' , chCard ) ) then
          chOpcTyp = 'SCAN'
        else if( lgMatch('TITA' , chCard ) ) then
          chOpcTyp = 'TITA'
        else if( lgMatch('VANA' , chCard ) ) then
          chOpcTyp = 'VANA'
        else if( lgMatch('CHRO' , chCard ) ) then
          chOpcTyp = 'CHRO'
        else if( lgMatch('MANG' , chCard ) ) then
          chOpcTyp = 'MANG'
        else if( lgMatch('IRON' , chCard ) ) then
          chOpcTyp = 'IRON'
        else if( lgMatch('COBA' , chCard ) ) then
          chOpcTyp = 'COBA'
        else if( lgMatch('NICK' , chCard ) ) then
          chOpcTyp = 'NICK'
        else if( lgMatch('COPP' , chCard ) ) then
          chOpcTyp = 'COPP'
        else if( lgMatch('ZINC' , chCard ) ) then
          chOpcTyp = 'ZINC'
        else
          write(qq,'('' There must be a second keyword on the'',
     1    '' opacity command.  Sorry.'')')
          write(qq,'('' Options are total, figure, grain, or element'',
     1    '' name.'')')
          stop
        endif
*
      else if( lgMatch( 'ABUN' , chCard ) ) then
        chPunch(npunch) = 'ABUN'
        write(ipPnunit(npunch),'('' abundances'')')
*
      else if( lgMatch( 'CHAR' , chCard ) ) then
        chPunch(npunch) = 'CHAR'
        write(ipPnunit(npunch),'('' charge exchange rate coefficnt'')')
*
      else if( lgMatch( 'COMP' , chCard ) ) then
        chPunch(npunch) = 'COMP'
        write(ipPnunit(npunch),'('' nu, comup, comdn'')')
*
      else if( lgMatch( 'COOL' , chCard ) ) then
        chPunch(npunch) = 'COOL'
        write(ipPnunit(npunch),'('' heat, cool, frac coolant '')')
*
      else if( lgMatch( 'CONT' , chCard ) ) then
*       option to set units for continuum energy in punch output
        if( lgMatch( 'NITS' , chCard ) ) then
          if( lgMatch( 'MICR' , chCard ) ) then
            chConPunEnr(npunch) = 'micr'
          else if( lgMatch( ' KEV' , chCard ) ) then
            chConPunEnr(npunch) = ' kev'
          else if( lgMatch( ' EV ' , chCard ) ) then
            chConPunEnr(npunch) = ' ev '
          else if( lgMatch( 'ANGS' , chCard ) ) then
            chConPunEnr(npunch) = 'angs'
          else if( lgMatch( 'RYDB' , chCard ) ) then
            chConPunEnr(npunch) = 'rydb'
          else
            write(qq,'('' I did not recognize units on this line.'')')
            write(qq,'('' Units are keV, eV, Angstroms, microns'')')
            stop
          endif
        else
          chConPunEnr(npunch) = 'ryd '
        endif
        if( lgMatch( 'BINS' , chCard ) ) then
*         continuum binning
          chPunch(npunch) = 'CONB'
          write(ipPnunit(npunch),'('' Continuum binning, energy, '',
     1    ''width of cells'')')
        else if( lgMatch( 'DIFF' , chCard ) ) then
*         diffuse continuum
          chPunch(npunch) = 'COND'
          write(ipPnunit(npunch),'('' Diffuse Continuum'')')
        else if( lgMatch( 'EMIT' , chCard ) ) then
*         emitted continuum
          chPunch(npunch) = 'CONE'
          write(ipPnunit(npunch),'(''     Enr      reflec '',
     1    ''    outward     total'')')
        else if( lgMatch( 'INCI' , chCard ) ) then
*         incident continuum
          chPunch(npunch) = 'CONC'
          write(ipPnunit(npunch),'('' Incident Continuum, Enr nFn '')')
        else if( lgMatch( 'INTE' , chCard ) ) then
*         continuum interactions
          chPunch(npunch) = 'CONi'
          write(ipPnunit(npunch),'('' Continuum interactions, inc, '',
     1    ''otslin. otscon, outcon, outlin '')')
*         this is option for lowest energy, if nothing then zero
          punarg(npunch,1) = fread( chCard , i , 76 , lgEOL )
        else if( lgMatch( 'IONI' , chCard ) ) then
*         ionizing continuum
*         optional number is lowest energy, 0 if no number
*         do not reset pointer since we want to scan off second number
*         this is option for lowest energy, if nothing then zero
          punarg(npunch,1) = fread( chCard , i , 76 , lgEOL )
*         this is option for smallest interaction to punch, def zero
          punarg(npunch,2) = fread( chCard , i , 76 , lgEOL )
          chPunch(npunch) = 'CONI'
          write(ipPnunit(npunch),'('' Ionizing Continuum, nu, totl '',
     1    ''flux, flx*cs, frac(inc, otsl, otsc, out) rate/total, '',
     2    ''int so far'')')
        else if( lgMatch( 'OUTW' , chCard ) ) then
*         outward only continuum
          if( lgMatch('LOCA' , chCard ) ) then
            chPunch(npunch) = 'COLO'
            write(ipPnunit(npunch),'(''Local Out   SavOutCon  ''
     1      ,''outcon+line SvOt*opc pass*opc'')')
          else
            chPunch(npunch) = 'CONO'
            write(ipPnunit(npunch),'(''Out Con      OutIncid  OutConD'',
     1      ''   OutLinD   OutConS'')')
          endif
        else if( lgMatch( 'TRAN' , chCard ) ) then
*         transmitted continuum
          chPunch(npunch) = 'CONT'
          write(ipPnunit(npunch),'('' Transmitted Continuum'')')
        else if( lgMatch( ' RAW' , chCard ) ) then
*         "raw" continua
          chPunch(npunch) = 'CORA'
          write(ipPnunit(npunch),'(''Raw Con anu    flux, '',
     1    ''    otslin     otscon,    refcon     outcon     outlin'',
     2    ''     ContDiff '')')
        else if( lgMatch( 'REFL' , chCard ) ) then
*         reflected continuum
          chPunch(npunch) = 'CONR'
          write(ipPnunit(npunch),'('' Reflected      cont       line  '',
     1    ''     total        albedo    ConID'')')
        else
          chPunch(npunch) = 'CON '
          write(ipPnunit(npunch),'('' Cont nu    incident   trans'',
     1    ''    DiffOut  net trans   reflc     total   line cont'')')
        endif
*
      else if( lgMatch( 'CONV' , chCard ) ) then
*       punch reason model declared not converged
*       not a true punch command, since done elsewhere
        ipPunConv = ipPnunit(npunch)
        lgPunConv = .true.
        write(ipPunConv,'('' reason for continued iterations'')')
*       this does not count as a punch option (really)
        npunch = npunch - 1
*
      else if( lgMatch( ' DR ' , chCard ) ) then
        ipDRout = ipPnunit(npunch)
        lgDROn = .true.
*       set punch last flag to whatever it was above
        lgDRPLst = lgPunLstIter(npunch)
        write(ipDRout,'('' Choice of zone thickness. '')')
*       this does not count as a punch option (really)
        npunch = npunch - 1
*
      else if( lgMatch( 'ELEM' , chCard ) ) then
        chPunch(npunch) = 'ELEM'
        call GetElem( chCard , j )
*       this will be the atomic number
        punarg(npunch,1) = j
        write(ipPnunit(npunch),'('' element structure, nelem='',i3)')j
*
      else if( lgMatch( 'FEII' , chCard ) ) then
*       punch out some stuff for Fred's FeII atom
        write(ipPnunit(npunch),'('' FeII rates '')')
        chPunch(npunch) = 'FEII'
*
      else if( lgMatch( 'GAMM' , chCard ) ) then
*       punch all photoionizaiton rates for all subshells
        write(ipPnunit(npunch),'('' Photoionization rates '')')
        chPunch(npunch) = 'GAMM'
*
      else if( lgMatch( 'GRAI' , chCard ) ) then
*       punch grains
        chDst = 'NONE'
        if( lgMatch( 'OPAC' , chCard ) ) then
          chPunch(npunch) = 'DUSO'
*         punch grain opacity command in twice, here and above in opacity
          chDst = 'OPAC'
          write(ipPnunit(npunch),'('' grain ext, abs, scat'')')
        else if( lgMatch('PHYS' , chCard ) ) then
          chPunch(npunch) = 'DUSP'
          chDst = 'PHYS'
          write(ipPnunit(npunch),'('' grain temp, charge,'',
     1    '' drift, frc heat, cool'')')
        else
          write(qq,'('' There must be a second key; they are '',
     1    '' OPAC and PHYS'')')
          stop
        endif
*
      else if( lgMatch( 'GAUN' , chCard ) ) then
        chPunch(npunch) = 'GAUN'
        write(ipPnunit(npunch),'('' Gaunt factors.'')')
*
      else if( lgMatch( 'HTWO' , chCard ) ) then
        ipPunH2 = ipPnunit(npunch)
        lgPunH2 = .true.
        write(ipPnunit(npunch),'('' H2 creation, destruction. '')')
*       this does not count as a punch option (really)
        npunch = npunch - 1
*
      else if( lgMatch( 'HEAT' , chCard ) ) then
        chPunch(npunch) = 'HEAT'
        write(ipPnunit(npunch),'('' htot, ctot, heat fracs'')')
*
      else if( lgMatch( 'HELI' , chCard ) ) then
        if( lgMatch('SING' , chCard ) ) then
          chPunch(npunch) = 'HEL1'
          write(ipPnunit(npunch),'(''he1    level,   simple,  ''
     1    ,''clhe2ov1  smhe2ov1   rec,     ioniz,    hei3 '')')
        else if( lgMatch(' ION' , chCard ) ) then
          chPunch(npunch) = 'HEL2'
          write(ipPnunit(npunch),'(''  z     HeII/a    simple    rec, '',
     1    ''    P ioniz,    coll     csupra '')')
        else if( lgMatch('TRIP' , chCard ) ) then
          chPunch(npunch) = 'HEL3'
          write(ipPnunit(npunch),'('' he3    level,    simple,    '',
     1    ''rec,     ioniz,    coll '')')
        else
          write(qq,'('' did not find a keyword on this '',
     1  '' line.  Keys are SING, _ION, and TRIP.'')')
         stop
        endif
*
      else if( lgMatch( 'HUMM' , chCard ) ) then
        chPunch(npunch) = 'HUMM'
        write(ipPnunit(npunch),'('' input to DHs routine.'')')
*
      else if( lgMatch( 'HYDR' , chCard ) ) then
*       punch hydrogen physical conditions
        if( lgMatch( 'COND' , chCard ) ) then
          chPunch(npunch) = 'HYDc'
          write(ipPnunit(npunch),'('' Hyd, DR,     Te,     HDEN,'',
     1    ''    EDEN,   HI/H,    ''
     1    ,''HII/H,   H2/H,     H2+/H,   H3+/H,   H-/H'')')
*       punch hydrogen ionization
        else if( lgMatch( 'IONI' , chCard ) ) then
          chPunch(npunch) = 'HYDi'
          write(ipPnunit(npunch),'(''   gam1    RecEff   HRecRad    '',
     1    ''hii/hi Shii/hi   hrec(13) dec grd  GamEff   ColEff'')')
*       punch hydrogen populations
        else if( lgMatch( 'POPU' , chCard ) ) then
          chPunch(npunch) = 'HYDp'
          write(ipPnunit(npunch),
     1   '(''   depth      HI      HII       HN'',51x,''2s       2p'')')
        else
          write(qq,'('' Punch hydrogen has options: CONDitions '',
     1    ''POPUlations and IONIzation.'')')
          stop
        endif
*
      else if( lgMatch( ' IP ' , chCard ) ) then
        chPunch(npunch) = ' IP '
        write(ipPnunit(npunch),
     1  '('' ionization potentials, valence shell'')')
*
      else if( lgMatch( 'LINE' , chCard ) ) then
*       options are punch line structure, line intensity, line array,
*       and line data
        if( lgMatch( 'STRU' , chCard ) ) then
*         this will be line structure, emissivity vs depth
          chPunch(npunch) = 'LINS'
          write(ipPnunit(npunch),'('' Emission line structure.'')')
*         read in the list of lines to examine
          call punlin( ipPnunit(npunch) , 'READ' , .false. )
        else if( lgMatch( 'CUMU' , chCard ) ) then
*         this will be integrated line intensity, fcn of depth
          chPunch(npunch) = 'LINC'
*         option for either relative intensity or abs luminosity
          if( lgMatch('RELA' , chCard ) ) then
            lgEOL = .true.
            write(ipPnunit(npunch),'('' Cumulative emission line '',
     1      ''relative intensity.'')')
          else
            write(ipPnunit(npunch),'('' Cumulative emission line '',
     1      ''absolute intensity.'')')
            lgEOL = .false.
          endif
*         read in the list of lines to examine
          call punlin( ipPnunit(npunch) , 'READ' , lgEOL )
        else if( lgMatch( 'DATA' , chCard ) ) then
*         punch line data
          chPunch(npunch) = 'LIND'
          write(ipPnunit(npunch),'('' Emission line data.'')')
        else if( lgMatch( 'ARRA' , chCard ) ) then
*         punch energies and luminosities of transferred lines
          chPunch(npunch) = 'LINA'
          write(ipPnunit(npunch),'('' Emission line array'')')
        else if( lgMatch( 'LABE' , chCard ) ) then
*         punch line labels
          chPunch(npunch) = 'LINL'
          write(ipPnunit(npunch),'('' Emission line array'')')
        else if( lgMatch( 'INTE' , chCard ) ) then
*         this will be full set of line intensities
          chPunch(npunch) = 'LINI'
          write(ipPnunit(npunch),'('' Emission line intensities'',
     1    '' per unit inner area'')')
          if( lgMatch( 'COLU' , chCard ) ) then
*           column is key to punch single column
            chPunRltType = 'column'
          else
*           array is key to punch large array
            chPunRltType = 'array '
          endif
          if( lgMatch( 'EVER' , chCard ) ) then
            LinEvery = fread( chCard , i , 76 , lgEOL )
            lgLinEvery = .true.
            if( lgEOL ) then
              write(qq,'('' There must be a second number,'',
     1        '' the number of zones to print.'')')
              stop
            endif
          else
            LinEvery = nend(1)
            lgLinEvery = .false.
          endif
        else
          write(qq,'('' This option for PUNCH LINE is something'',
     1    '' that I dont understand.  Sorry.'')')
          stop
        endif
*
      else if( lgMatch( 'LYMA' , chCard ) ) then
        chPunch(npunch) = 'LYMA'
        write(ipPnunit(npunch),'('' Tau, N2/N1, Texc, Te, Tex/x'')')
*
      else if( lgMatch( ' MAP' , chCard ) ) then
        chPunch(npunch) = 'MAP '
        write(ipPnunit(npunch),'('' te, heating, cooling.'')')
*
      else if( lgMatch( 'MOLE' , chCard ) ) then
        chPunch(npunch) = 'MOLE'
        write(ipPnunit(npunch),'('' dr, h2/h CO/H, H2O/H, OH/H, CH/H''
     1  ,''O2/H'')')
*
      else if( lgMatch( 'OPTI' , chCard ) ) then
        chPunch(npunch) = 'OPTI'
        write(ipPnunit(npunch),'('' total, absorp, scat taus'')')
*
      else if( lgMatch( ' OTS' , chCard ) ) then
        chPunch(npunch) = ' OTS'
        write(ipPnunit(npunch),'('' otscon, lin, conOpac LinOpc'')')
*
      else if( lgMatch( 'OVER' , chCard ) ) then
*       punch overview of model results
        chPunch(npunch) = 'OVER'
        write(ipPnunit(npunch),'(''  depth     Te     Htot   '',
     1'' hden   eden   HI   HII   HeI  HeII  HeIII   C1    C2    C3'',
     1''    C4    O1  O2    O3    O4    O5    O6'')')
*
      else if( lgMatch( ' PDR' , chCard ) ) then
        chPunch(npunch) = ' PDR'
        write(ipPnunit(npunch),'('' depth   H colden   AV       Te   ''
     1  ,''   HI/HDEN  H2/HDEN   CI/C    CO/C    H2O/O'')')
*
      else if( lgMatch( 'PHYS' , chCard ) ) then
        chPunch(npunch) = 'PHYS'
        write(ipPnunit(npunch),'('' PhyC    Depth       Te,'',
     1  ''       HDEN,       Ne,       HTOT,      accel'')')
*
      else if( lgMatch( 'POIN' , chCard ) ) then
*       punch out the pointers
        ipPoint = ipPnunit(npunch)
        lgPunPoint = .true.
        write(ipPnunit(npunch),'('' pointers. '')')
*       this does not count as a punch option (really)
        npunch = npunch - 1
*
      else if( lgMatch( 'PRES' , chCard ) ) then
        chPunch(npunch) = 'PRES'
        write(ipPnunit(npunch),'('' pressure; depth, p(g+l) '',
     1  ''PresInit+pinteg  pgas(r0)  pgas  prad     integ,  conv?'')')
*
      else if( lgMatch( ' QS ' , chCard ) ) then
        chPunch(npunch) = ' QS '
        write(ipPnunit(npunch),'('' grain abs, scat, qs'')')
*
      else if( lgMatch( 'RADI' , chCard ) ) then
        chPunch(npunch) = 'RADI'
        write(ipPnunit(npunch),'('' NZONE, radius, r-r0, dr.'')')
*
      else if( lgMatch( 'RECO' , chCard ) ) then
        if( lgMatch( 'COEF' , chCard ) ) then
*         recombination coefficients for everything
*         ioreco set to zero in routine zero, non-zero value
*         is flag to punch recombination coefficients.
          ioreco = ipPnunit(npunch)
*     >>chng 96 nov 24, added following
*         this does not count as a punch option (really)
          npunch = npunch - 1
*
*     >>chng 96 nov 24, moved to subbrance of recom command
        else if( lgMatch( 'EFFI' , chCard ) ) then
*         punch recombination efficiency
          chPunch(npunch) = 'RECE'
          write(ipPnunit(npunch),'('' Recomn effic H, Heo, He+'')')
        else
          write(qq,'('' No option recognized on this punch '',
     1    ''recombination command'')')
          write(qq,'('' Valid options are COEFFICIENTS and '',
     1    ''EFFICIENCY'')')
          stop
        endif
*
      else if( lgMatch( 'RESU' , chCard ) ) then
        chPunch(npunch) = 'RESU'
        if( lgMatch( 'COLU' , chCard ) ) then
*         column is key to punch single column
          chPunRltType = 'column'
        else
*         array is key to punch large array
          chPunRltType = 'array '
        endif
*       do not change following, is used as flag in getlines
        write(ipPnunit(npunch),'('' results of calculation'')')
*
      else if( lgMatch( 'SOUR' , chCard ) ) then
        if( lgMatch( 'DEPT' , chCard ) ) then
*         print continuum source function as function of depth
          chPunch(npunch) = 'SOUD'
          write(ipPnunit(npunch),'('' continuum source function'',
     1    '' vs depth'')')
        else if( lgMatch( 'SPEC' , chCard ) ) then
*         print spectrum continuum source function at 1 depth
          chPunch(npunch) = 'SOUS'
          write(ipPnunit(npunch),'('' continuum source function'')')
        else
          write(qq,'('' A second keyword must appear on this line.'')')
          write(qq,'('' They are DEPTH and SPECTRUM.'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
*
      else if( lgMatch( 'SPEC' , chCard ) ) then
*       punch special, will call routine PunSpec
        chPunch(npunch) = 'SPEC'
        write(ipPnunit(npunch),'('' Special.'')')
*
      else if( lgMatch( 'TEGR' , chCard ) ) then
*       punch tegrid
        chPunch(npunch) = 'TEGR'
        write(ipPnunit(npunch),'('' zone, te, heat, cool.'')')
*
      else if( lgMatch( 'TEMP' , chCard ) ) then
        chPunch(npunch) = 'TEMP'
        write(ipPnunit(npunch),'('' DEPTH, te, dt/dr.'')')
*
      else if( lgMatch( 'TPRE' , chCard ) ) then
        chPunch(npunch) = 'TPRE'
        write(ipPnunit(npunch),'('' old temp, guess Tnew, new temp'')')
*
      else if( lgMatch( 'VERN' , chCard ) ) then
*       set punch last flag to whatever it was above
        lgFe2PLst = lgPunLstIter(npunch)
*       punch intensities from Verner FeII atom
        chPunch(npunch) = 'VERN'
        ioVerner = ipPnunit(npunch)
        ipHiVernFe2 = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
*         will reset downstream to number of current levels
          ipHiVernFe2 = 0
        else
          if( ipHiVernFe2.lt.1 ) then
            write(qq,'('' limit less than 1 now possible.'')')
            stop
          endif
        endif
*       short keyword makes punch half as big
        if( lgMatch( 'SHOR' , chCard ) ) then
          lgShortFe2 = .true.
        else
          lgShortFe2 = .false.
        endif
*       these results are actually created by the Fe2Lines routine
*       that lives in the KatyaFe2 file
        write(ioVerner,'('' Results from Verner FeII atom.'')')
*
      else if( lgMatch( 'WIND' , chCard ) ) then
        chPunch(npunch) = 'WIND'
        write(ipPnunit(npunch),'('' radius, DEPTH,vel, accel, '',
     1  ''force mul'')')
*
      else
        write(qq,'('' GetPunch cannot find a recognized keyword on '',
     1  ''this PUNCH command line.'')')
        stop
      endif
*
      end
      subroutine GetQuote( chLabel , nLabel , lgOK , chCard )
      implicit none
*get a name from between quotes, in command line parse
*label within quotes returned within chLabel
*length is nLabel, lgOK says whether found or not
*label in line image is set to blanks when complete
      character chLabel*80 , chCard*80
      integer nLabel
      logical lgOK
      character chOrgCard*80
*     copy of current line image used by readr with no caps forced
      common/OrgCard/ chOrgCard
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chQ1*1 , chQ2*1
      logical lgHit
      integer i , i1 ,j
      data chQ1/'"'/ ,  chQ2/''''/
*
      lgHit = .false.
      i = 1
*     find start of string
      do while( .not.lgHit .and.i.lt.72 )
        if( chOrgCard(i:i).eq.chQ1 .or.  chOrgCard(i:i).eq.chQ2 )then
          lgHit = .true.
        endif
        i = i + 1
      end do
*     check if we got a hit
      if( .not.lgHit ) then
        lgOK = .false.
        return
      endif
*
*     got pointer to start of string
      i1 = i
      lgHit = .false.
*     i now points one beyond start
      i = i + 1
*     find end of string
      do while( .not.lgHit .and.i.lt.72 )
        if( chOrgCard(i:i).eq.chQ1 .or.  chOrgCard(i:i).eq.chQ2 )then
          lgHit = .true.
        endif
        i = i + 1
      end do
*
*     check if we got a hit
      if( .not.lgHit ) then
        lgOK = .false.
        return
      endif
      i = i - 2
*
*     we now have it
      nLabel = i - i1 + 1
      chLabel(1:nLabel) = chOrgCard(i1:i)
*
*     >>chng 97 july 1, blank out label once finished, to not picked up later
      do j=i1,i
         chCard(j:j) = ' '
      end do
*
*     write(qq,*)'=',chLabel(1:nLabel),'='
      lgOK = .true.
*
      end
      subroutine GetRauch
      implicit none
*rebin Rauch stellar models to match energy grid of code
*     limit to number of cells in frequency array
*     NB is this every is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real pi
      parameter ( pi=3.141592654 )
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      common/StarBad/ lgStarBad
      logical lgStarBad
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , j , nvals,nmods,n1,n2,imod,ierr
*
* This subroutine re-bins the Rauch atmosphere fluxes to match the Cloudy
* grid.  The wavelengths of the Rauch models are 5.0 to 2000.0 angstroms
* with a step size of 0.1 angstroms, 19951 points each.  Thus the wavelength
* grid is not saved in the file of ascii values.  The values in the file are
* F_lambda values in erg/s/cm^2/cm.  They have to be multiplied by pi to get
* the "real" surface flux.  Then I convert them into F_nu in erg/s/cm^2/Hz
* by taking 1.e-18 * wavelength^2 * F_lambda / c.  The factor 1.e-18 is
* due to the wavelengths being in angstroms.
*
* With some many points I need to average over the Cloudy grid rather than
* interpolating as is the case for the Kurucz or Werner models.  At short
* wavelengths the two grids are of similar spacing.
*
      parameter (nvals=19951,nmods=57)
      real stflux(nvals)
*     nvals is the number of values per Rauch model.  nmods is the total
*     number of models in the set.
*
*     real teff(nmods)
*     real xlogg(nmods)
      integer iteff(ncell)
      real wlin(nvals),flin(nvals)
*     data teff/50000.,50000.,50000.,50000.,60000.,60000.,60000.,60000.,
*    1          70000.,70000.,70000.,70000.,80000.,80000.,80000.,80000.,
*    2          90000.,90000.,90000.,90000.,100000.,100000.,100000.,
*    3          100000.,110000.,110000.,110000.,120000.,120000.,120000.,
*    4          130000.,130000.,130000.,140000.,140000.,140000.,
*    5          150000.,150000.,150000.,160000.,160000.,160000.,
*    6          170000.,170000.,170000.,180000.,180000.,180000.,
*    7          190000.,190000.,190000.,200000.,200000.,300000.,
*    8          300000.,400000.,500000./
*     data xlogg/5.,6.,7.,8.,5.,6.,7.,8.,5.,6.,7.,8.,5.,6.,7.,8.,
*    1           5.,6.,7.,8.,5.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,
*    2           8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,
*    3           6.,7.,8.,7.,8.,7.,8.,8.,8./
*
      write(qq,'('' GetRauch on the job.'')')
*
      n1 = 1
*     be sure not to clobber the anu array - will be used by other subs
      do while( anu(n1).lt.150.)
        n1 = n1 + 1
      end do
      n1 = n1 - 1
*
       write(qq,'('' A total of '',i4,'' Cloudy cells needed.'')') n1
       if( n1.eq.nRauch ) then
         write(qq,'('' The current value of nRauch is ok.'')')
       else
         if( .not.lgStarBad ) then
*          no errors yet, so open errors file
           open(unit=66,file='problems.out',status='unknown')
         endif
         lgStarBad = .true.
         write(qq,'('' WARNING!!!!!'')')
         write(qq,'('' WARNING!!!!!'')')
         write(66,'('' nRauch must be changed to'',i6,
     1   '' in block data scalar.  Its current value is'',i6)')
     2   n1,nRauch
         write(qq,'('' nRauch must be changed to'',i6,
     1   '' in block data scalar.  Its current value is'',i6)')
     2   n1,nRauch
         write(qq,'('' I will take care of this for now.'')')
         nRauch = n1
       endif
*
      open(unit=01,file='rauch.ascii',status='old',iostat=ierr)
      if( ierr.eq.0. ) then
        write(qq,'('' GetRauch got rauch.ascii.'')')
      else
        write(qq,'('' GetRauch could not find rauch.ascii.'')')
        stop
      endif
*
      do i=1,nvals
        wlin(i)=2000.-0.1*float(i-1)
*       anu2(i)=299792458.e+10/wlin(i)
      end do
* anu2 now has the frequencies in Hz.
*
* the frequencies are in increasing order; when the fluxes are
* read in they will have to be put in reverse order since they go from
* 5 to 200 angstroms.
*
      open(unit=03,file='rauch.mod',access='direct',status='unknown',
     1     form='formatted',iostat=ierr, recl=7*ncell)
      if( ierr.ne.0 ) then
        write(qq,'('' GetRauch failed creating rauch.mod.'')')
        stop
      endif
*
      do j=1,n1
        iteff(j) = int(abs(log10(anu(j))-5.)*1000000.)
      end do
*
* *** NOTE ****  WARNING!!!!! ******
* As things are written here, the CLOUDY grid range covered by the models
* must be > 1.0e-05 Rydbergs and < 100000.0 Rydbergs so that the integer
* values are not larger than 9,999,999 and are all negative before the abs
* function is applied to the value to make the iteff element.  6 digits are
* needed in the logarithm value to give 5 digit accuracy when the values are
* converted back to energy values in Rydbergs by programs reading the model
* file.  For the present Werner and Kurucz models these limits are not a
* problem, nor are these limits likely to be violated in the future by purely
* stellar models....but if the limits are exceeded, things will not work.
*
* The Rauch models go down to 5 Angstroms (about 182 Rydb) but I choose to
* terminate the array at 150 Rydb since the fluxes are extremely small at
* the shortest wavelengths -- 17 orders of magnitude below peak for the
* 500000 K model.  This differs a bit from the handling of the Werner models
* even though the temperature range is similar.
*
*     write out the cloudy energy grid for later sanity checks
      write(03,'(4000i7)',rec=1,iostat=ierr) (iteff(j),j=1,n1)
      if( ierr.ne.0 ) then
        write(qq,'('' GetRauch failed writng anu array.'')')
        stop
      endif
*
      do j=1,n1
        iteff(j)=0
      end do
*
* This array will now be used for writing out the flux values in log form,
* multiplied by 1.e+05 and converted to integer (this allows sign plus 7
* integer places, storing 5 places in the log10 value which gives 4 significant
* figure accuracy in the values).
*
      do imod=1,nmods
        read(01,'(9e9.3)',iostat=ierr) (flin(i),i=1,nvals)
        if( ierr.ne.0 ) then
          write(qq,'('' GetRauch failed reading star flux.'')')
          stop
        endif
*
        do j=1,nvals
          stflux(j) = max(1e-35, flin(nvals+1-j))
*         there should be no values that underflow in the file.
          stflux(j) =pi*wlin(j)*wlin(j)*1.e-18*stflux(j)/299792458.
          stflux(j) = max(1e-35, stflux(j))
        end do
*
        n2 = nvals
*
        call RebinRauch(stflux,wlin,flin)
*       the re-binned values are returned in the "flin" array
*
        do j=1,n1
          if (flin(j).gt.1e-30) then
            iteff(j) = int(abs(log10(flin(j))-3.)*100000.)
          else
*           this is smallest possible number
            iteff(j)=9999999
          endif
        end do
*
        write(03,'(4000i7)',rec=imod+1,iostat=ierr) (iteff(j),j=1,n1)
        if( ierr.ne.0 ) then
          write(qq,'('' GetRauch failed writing iteff star flux.'')')
          stop
        else
          write(qq,'('' GetRauch wrote stellar model number'',
     1          i4)') imod
        endif
      end do
*
      close(unit=01)
      close(unit=03)
      write(qq,'('' GetRauch complete, rauch.ascii file may be '',
     1      ''deleted.'')')
      end
******************************************************************************
      subroutine GetSet( chCard )
      implicit none
*scan parameters off SET command
      character chCard*80
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real SpeedLight
*from Physics Today Aug '96, BG 10
      parameter (SpeedLight=2.99792458E10 )
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer KshellLimit
      real EnergyKshell
      common/KshllEnr/ KshellLimit , EnergyKshell
      real COLimit
*limit to ratio CO/Total carbon, used to stop fully molecular
*models
      common/colimt/ COLimit
      character chPath*80
      common/path/ chPath
      logical lgPathSet
*true is path has been set with set path command, false otherwise
      common/pthset/ lgPathSet
      character chOrgCard*80
*     copy of current line image used by readr with no caps forced
      common/OrgCard/ chOrgCard
      real FluxFaint
*faintest high energy flux to consider, set with set flxfnt command
      common/flxfnt/ FluxFaint
      integer MapZone , nMapStep
      real RangeMap
*parameters doing with map command, MapZone is zone number,
* -1 for very start
* RangeMap is range, parsed from same command
* nMapStep is number of steps, set with set nmap command
      common/MapPar/ MapZone , RangeMap(2), nMapStep
      logical lgSMinON
*lgSMinON is flag saying that set drmin has been enteed
*     these are 1e-30 and 1e30 by default, and are set with "set dr" cmnds
*     used as one of a pair of limits to how big or small zones get
*     set dr command forces constant dr by setting both to same number
      real sdrmin , sdrmax
      common/sdrmin/ sdrmin , sdrmax , lgSMinON
      real EdenError
*     this is relative error in the electron density we want
*     set in block data to 0.01
*     reset with set EdenError command
      common/erredn/ EdenError
      logical lgCSetOn
*lgCSetOn set with set csupra command
*SetCsupra is secondary ionization rate set with set csupra
      real SetCsupra
      common/cspset/ SetCsupra , lgCSetOn
      real emm , egamry
      common/bounds/ emm , egamry
      integer negoIO
      common/negoIO/ negoIO
      integer ncPunchSkip
*set skip sets this variable, which says how many cells to skip in punch
      common/PunchSkip/ ncPunchSkip
      integer nEndDflt
      logical lgEndDflt
*     default limit to number of zones
*     lgEndDflt true if still at default
      common/EndDflt/ nEndDflt , lgEndDflt
      logical lgNumDeriv
      common/NumDeriv/ lgNumDeriv
      real drChange
*fractional change used in nextdr
      common/didz/ drChange
      real telow , tehigh
*     this is the default lowest to highest temperature checked
      common/telow/ telow , tehigh
      integer iPunDef
*     this is an integer giving the unit number for the next fort fil
*     set to 11 in zero, reset with 'set ipundef' command
*     incremented for each punch command that does not specify a unit
      common/PunDef/ iPunDef
      real toiiir, tbac, t2hstr,tohyox,t2hyox,tbcthn,t2o3str,tsqden
*     tsqden is the highest hydrogen density to do print peimbert analysis
      common/peimbt/ toiiir, tbac, t2hstr,tohyox,t2hyox,tbcthn,t2o3str,
     1 tsqden
      real trimhi , trimlo
*limits for highest and lowest stages of ionization in TrimStage
      common/trimstg/ trimhi , trimlo
      real DestWght , DestWghtSave
*     weight to give new dest prob when being evaluated,
*     default is 0.25 and is reset with SET DSTWGHT command
*     DstWghtSave is usually the same as DstWght - except on 0th
*     zone, where DstWght is set to 1 to get initial dest prob
*     then reset to DstWghtSave
      common/DstWght/ DestWght , DestWghtSave
      logical lgPhFit
*which version of phfit should be used?
      common/PhFitOn/ lgPhFit
      real WeakHeatCool
*     threshold for faintest cooling or heating to be punched
*     default is set to 0.05 in scalar, can be reest with 'set weakheatcool',
      common/WkHtCl/ WeakHeatCool
      real HCTAlex
*Dalgarno H charge transfer rate coef for high stages of ionization
*default is 8.5e-10 in zero, reset with 'set charge transfer' command
      common/HCTMin/ HCTAlex
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      logical lgExemplar
*set true when on exemplar with 'set exemplar' to get around
*bug in their compiler
      common/Exemplar/ lgExemplar
      real PunchLWidth
*contrast factor for lines to continuum in punch output
*default is 1 (gives correct line intensities) and changed with
*set width command (enters width in km/sec)
      common/PLWidth/ PunchLWidth
      logical lgTestIt , lgTestOn
*flag lgTestIt turned on if routine TestCode ever called, only generates
*comment that test code is in place
*flag lgTestOn set true for some test code to be run somewhere
      common/Testit/ lgTestIt , lgTestOn
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgMatch
      character chC1*1 , chC2*1 , chC3*1
      logical lgEOL , lgHit
      real fread
      integer i , ip
      data chC1,chC2/'"',''''/ , chC3/'\\'/
*
*     free statement nubmers =>10
*
*     commands to set certain variables, "SET XXX="
      if( lgMatch('CHAR',chCard ) ) then
*       set log of minimum charge transfer rate for high ions and H
*       default of 1.92e-10 set in zero
        i = 5
        HCTAlex = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( HCTAlex.lt.0. ) HCTAlex = 10.**HCTAlex
*
      else if( lgMatch('CSUP',chCard ) ) then
*       force secondary ionization rate, log entered
        i = 5
        SetCsupra = fread( chCard , i , 76 , lgEOL )
        lgCSetOn = .true.
        if( lgEOL ) call NoNumb(chCard)
        SetCsupra = 10.**SetCsupra
*
      else if( lgMatch('DIDZ',chCard) ) then
*       set parameter to do with choice of dr;
*       par is the largest optical depth to allow in the zone.
*       >>chng 96 jan 8 had been two numbers - dtau1 removed
        i = 5
        drChange = fread( chCard , i , 76 , lgEOL )
        if( drChange.le.0. ) drChange = 10. ** drChange
        if( lgEOL ) call NoNumb(chCard )
*
      else if( lgMatch('DSTW',chCard) ) then
*       set DestWght, fraction of new dest prob to take in
*       average of old and new, for all lines
        i = 5
        DestWght = fread( chCard , i , 76 , lgEOL )
        DestWghtSave = DestWght
        if( lgEOL ) call NoNumb(chCard )
        if( DestWght.le.0. .or. DestWght.gt.1. ) then
          write(qq,'('' DestWght must be between 0 and 1'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
*
      else if( lgMatch('EXEM',chCard) ) then
*       exemplar fortran has bug in open statement, so special case
        lgExemplar = .true.
*
      else if( lgMatch('IPUN',chCard) ) then
*       set default punch unit for first punch with no unit given
        i = 5
        iPunDef = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( iPunDef.le.6 ) then
          write(qq,'('' Punch unit must be greater than 6'')')
          stop
        endif
*
      else if( lgMatch('COLI',chCard) ) then
*       set maximum CO/C ratio
        i = 5
        COLimit = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if(COLimit.lt.0. ) COLimit = 10.** COLimit
*
      else if( lgMatch(' DR ',chCard) ) then
*       set zone thickness by forcing drmax and drmin
        i = 5
        sdrmax = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        sdrmin = sdrmax
*
      else if( lgMatch('DRMA',chCard) ) then
*       set maximum zone thickness
        i = 5
        sdrmax = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
*
      else if( lgMatch('DRMI',chCard) ) then
*       set minimum zone thickness
        i = 5
        sdrmin = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        lgSMinON = .true.
*
      else if( lgMatch('FLXF',chCard ) ) then
*       faintest continuum flux to consider
        i = 5
        FluxFaint = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( FluxFaint.lt.0. ) FluxFaint = 10.**FluxFaint
*
      else if( lgMatch( 'LOWE',chCard)  ) then
*        set lowest te to constant
         i = 5
         telow = fread( chCard , i , 76 , lgEOL )
*        linear option
         if( telow.le.10. .and. .not.lgMatch('LINE',chCard) ) then
            telow = 10.**telow
         endif
         if( lgEOL ) call NoNumb(chCard )
         if( telow.lt.2.8) then
           write(qq,'('' TE < 3K, reset to 2.8K.'')')
           telow = 2.8
         endif
*
      else if( lgMatch('NERR',chCard) ) then
*       keyword is actually EdenError
*       set telerance in eden match
        i = 5
        EdenError = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( EdenError.lt.0.) EdenError = 10.**EdenError
*
      else if( lgMatch('TEST',chCard) ) then
*       set flag saying to turn on some test
        lgTestOn = .true.
*
      else if( lgMatch('TRAC',chCard) ) then
*       set level of trace convergence
        i = 5
        nLevTrace = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
*
      else if( lgMatch('TRIM',chCard ) ) then
*       set trim upper or lower, for ionization stage trimming
*       in routine TrimStage
        i = 5
        if( lgMatch('UPPE',chCard ) ) then
*         set trim upper
          trimhi = 10.**fread( chCard , i , 76 , lgEOL )
        else if( lgMatch('LOWE',chCard ) ) then
*         set trim lower
          trimlo = 10.**fread( chCard , i , 76 , lgEOL )
        else
*         set trim upper
          trimhi = 10.**fread( chCard , i , 76 , lgEOL )
*         set trim lower to same number
          trimlo = trimhi
        endif
        if( lgEOL ) call NoNumb(chCard)
        if( trimlo.ge.1. .or. trimhi.ge.1. ) then
          write(qq,'('' number must be negative since log'')')
          stop
        endif
*
      else if( lgMatch('SKIP',chCard ) ) then
*       skip punch command, for punching every n't point
        i = 5
        ncPunchSkip = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
*
      else if( lgMatch('EAKH',chCard ) ) then
*       set WeakHeatCool, threshold on punch heating and cooling, default 0.05
        i = 5
        WeakHeatCool = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( WeakHeatCool .lt.0. ) WeakHeatCool = 10.**WeakHeatCool
*
      else if( lgMatch('KSHE',chCard ) ) then
*       upper limit to opacities for k-shell ionizaiton
        i = 5
        EnergyKshell = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( EnergyKshell .eq.0. ) then
*         arg of 0 causes upper limit to energy array
          EnergyKshell = egamry
        else if( EnergyKshell .lt.194. ) then
          write(qq,'('' k-shell energy must be greater than 194 Ryd'')')
          stop
        endif
*
      else if( lgMatch('NEGO',chCard ) ) then
*       punch negative opacities if they occur, set negopac
        i = 5
        negoIO = fread( chCard , i , 76 , lgEOL )
        if(lgEOL) then
          negoIO = 10
        else if(negoIO.eq.0 ) then
          write(qq,'('' IO unit for punching negative opacities '',
     1    ''cannot be 0'')')
          stop
        endif
*
      else if( lgMatch('NEND',chCard ) ) then
*       default limit to number of zones to be computed
*       only do this if nend is NOT currently left at its default
*       nend is set to nEndDflt in routine zero
*       this command only has effect if stop zone not entered
        if( lgEndDflt ) then
          i = 5
          nEndDflt = fread( chCard , i , 76 , lgEOL )
          lgEndDflt = .false.
          if( lgEOL ) call NoNumb(chCard)
          do i=1,itrdim
            nend(i) = nEndDflt
          end do
        endif
*
      else if( lgMatch('TSQD',chCard ) ) then
*       upper limit for highest density considered in the
*       Peimbert-style t^2 section of the printout
        i = 5
        tsqden = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        tsqden = 10.**tsqden
*
      else if( lgMatch('NMAP',chCard ) ) then
*       how many steps in plot or punch of heating-cooling map
        i = 5
        nMapStep = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
*
      else if( lgMatch('NUME',chCard ) .and. lgMatch('DERI',chCard) )
     1  then
*       this is an option to use numerical derivatives for heating and cooling
        lgNumDeriv = .true.
*
*     set path for certain files
      else if( lgMatch('PATH',chCard) ) then
*       set path for picking up files
*       format is for path to be within quotes
        lgPathSet = .true.
*       first clear out array
        do i=1,80
          chPath(i:i) = ' '
        end do
        lgHit = .false.
*       do i=5,80
        i = 1
        do while( .not.lgHit .and. i.lt.80 )
          if(chCard(i:i).eq.chC1 .or. chCard(i:i).eq.chC2 ) then
            ip = i
            lgHit = .true.
*           go to2
          endif
          i = i + 1
        end do
*       falls down to here if no " or '
        if( .not.lgHit ) then
          write(qq,'('' I couldnt find a path on this line.'')')
          write(qq,'('' Paths must begin or end with the characters '',
     1    A1,'' or '',A1)') chC1 , chC2
          write(qq,'('' Sorry.'')')
          stop
        endif
*2      continue
*       now look for end of path
        ip = ip + 1
        i = 1
        do while (ip.le.80 .and. chCard(ip:ip).ne.chC1 .and.
     1    chCard(ip:ip).ne.chC2 .and.  chCard(ip:ip).ne.' ' )
*         use original form of chCard, before readr cap't it
          chPath(i:i) = chOrgCard(ip:ip)
          ip = ip + 1
          i = i + 1
        end do
*       make sure path ends with backslash - this only works on unix
*       if end was the ] char then this could be a vms machine,
*       do nothing in that case
*       >>chng 97 june 18, add test for / in case of win nt pc
        if( chPath(i-1:i-1).ne.'/' .and. chPath(i-1:i-1).ne.']' .and.
     1    chPath(i-1:i-1).ne.chC3 )
     1    chPath(i:i)='/'
*
      else if( lgMatch('PHFI',chCard ) ) then
*       which version of PHFIT to use, 1995 or 1996
        i = 5
        ip = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( ip.eq.1995 ) then
*         option to go back to old results, pre op
          lgPhFit = .true.
        else if( ip.eq.1996 ) then
*         default is to use newer results, including opacity project
          lgPhFit = .false.
        else
          write(qq,'('' Two possible values are 1995 and 1996.'')')
          stop
        endif
*
      else if( lgMatch('WIDT',chCard ) ) then
*       set line width for contrast in continuum plots
        i = 5
*       units are km/sec
        PunchLWidth = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard)
        if( PunchLWidth.le.0. ) then
          write(qq,'('' line width must be greater than zero.'')')
          stop
        endif
        PunchLWidth = SpeedLight / (PunchLWidth*1e5)
*
      else
        write(qq,'('' I didnt recognize a key on this SET line.'')')
        stop
      endif
*
      end
******************************************************************************
      subroutine gett2( tsqr)
      implicit none
*analyze computed structure to get structural t^2
      real tsqr
*
      integer nzlim
      parameter (nzlim=2000)
*     these save structure variables, like te vs depth
      real testr, volstr, radstr, histr, hiistr , ednstr,o3str,heatstr,
     1 pdenstr
      common/struc/ testr(nzlim), volstr(nzlim), radstr(nzlim),
     1 histr(nzlim), hiistr(nzlim) , ednstr(nzlim),o3str(nzlim),
     2 heatstr(nzlim),pdenstr(nzlim)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgZonLimOK
*flag saying that too many zones to store in nzlim
      common/nzlmok/ lgZonLimOK
*
      double precision as , a , b
      real tmean
      integer i
*
*     check that we didn't overrun zone scale
      if( nzone.ge.nzlim ) then
        lgZonLimOK = .false.
      else
        lgZonLimOK = .true.
      endif
*
*     get T, t^2
      a = 0.
      b = 0.
      do i=1,min(nzlim,nzone)
        as = dble(volstr(i))*dble(hiistr(i))*dble(ednstr(i))
        a = a + dble(testr(i))*as
*       B is used twice below
        b = b + as
      end do
      if( b.le.0. ) then
        tsqr = 0.
      else
*       following is H+ weighted mean temp over vol
        tmean = a / b
        a = 0.
        do i=1,min(nzlim,nzone)
          as = dble(volstr(i))*dble(hiistr(i))*ednstr(i)
          a = a + (dble(testr(i)-tmean)**2) *as
        end do
        tsqr = a / (b*(tmean**2))
      endif
*
      end
******************************************************************************
      subroutine gett2o3( tsqr)
      implicit none
*analyze computed [OIII] spectrum to get t^2
      real tsqr
*
      integer nzlim
      parameter (nzlim=2000)
*     these save structure variables, like te vs depth
      real testr, volstr, radstr, histr, hiistr , ednstr,o3str,heatstr,
     1 pdenstr
      common/struc/ testr(nzlim), volstr(nzlim), radstr(nzlim),
     1 histr(nzlim), hiistr(nzlim) , ednstr(nzlim),o3str(nzlim),
     2 heatstr(nzlim),pdenstr(nzlim)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgZonLimOK
*flag saying that too many zones to store in nzlim
      common/nzlmok/ lgZonLimOK
*
      double precision as , a , b
      real tmean
      integer i
*
*     check that we didn't overrun zone scale
      if( nzone.ge.nzlim ) then
        lgZonLimOK = .false.
      else
        lgZonLimOK = .true.
      endif
*
*     get T, t^2
      a = 0.
      b = 0.
      do i=1,min(nzlim,nzone)
        as = dble(volstr(i))*dble(o3str(i))*dble(ednstr(i))
        a = a + dble(testr(i))*as
*       B is used twice below
        b = b + as
      end do
      if( b.le.0. ) then
        tsqr = 0.
      else
*       following is H+ weighted mean temp over vol
        tmean = a / b
        a = 0.
        do i=1,min(nzlim,nzone)
          as = dble(volstr(i))*dble(o3str(i))*ednstr(i)
          a = a + (dble(testr(i)-tmean)**2) *as
        end do
        tsqr = a / (b*(tmean**2))
      endif
*
      end
******************************************************************************
      subroutine GetTable( nqh , chCard , ar1 , nTabRead)
      implicit none
*parse the table read command
      character chCard*80
      integer nqh , nTabRead
      real ar1
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer ncfl
      parameter (ncfl=40)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real HIonPot
      parameter (HIonPot=0.99946)
*ionization potential of real hydrogen atom, in inf mass ryd
      real emm , egamry
      common/bounds/ emm , egamry
      logical lgConBug
*flag set with trace continuum command
      common/conbug/ lgConBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real cfle, cflf
      common/cflow/ cfle(ncfl) , cflf(ncfl)
      integer nism
      parameter (nism=23)
      real tnuism , fnuism
      common/conism/ tnuism(nism) , fnuism(nism)
      integer nagn
      parameter (nagn=8)
      real tnuagn , tslagn
      common/genagn/ tnuagn(nagn) , tslagn(nagn)
      integer ncrab
      parameter (ncrab=10)
      real tnucrb , fnucrb
      common/crabcn/ tnucrb(ncrab) , fnucrb(ncrab)
      integer nkn120
      parameter (nkn120=11)
      real tnuakn , fnuakn
      common/akn120/ tnuakn(nkn120) , fnuakn(nkn120)
      integer nrubin
      parameter (nrubin=45)
      real tnurbn , fnurbn
      common/conrbn/ tnurbn(nrubin) , fnurbn(nrubin)
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      real rdfalt
      common/rdfalt/ rdfalt
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real range
      common/range/ range(limspc,2)
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      real varang
      common/varang/ varang(2,limpar)
      integer nvary , nparm
      common/nvary/ nvary , nparm
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgLogSet , lgMatch , lgEOL , lgHit
      integer i , nstar , j , io
      real fac , fread , par1 , par2  , break,scale,alpha,
     1 brakmm,slopir,brakxr,slopxr
*
*     free statement numbers >=18
*
      nspec = nspec + 1
      if( nspec.gt.limspc) then
        write(qq,'(1X,I4,'' is too many spectra entered.'',
     1  ''  Increase LIMSPC'')') nspec
        stop
      endif
*
*     set flag telling interpolate
      chSpType(nspec) = 'INTER'
*
*     when adding more keys also change the comment at the end
*
      if( lgMatch('AGN ',chCard) ) then
*       do Mathews and Ferland generic AGN continuum
        do i=1,nagn
          tnu(nspec,i) = tnuagn(i)
          tslop(nspec,i) = tslagn(i)
        end do
        j = nagn - 1
*       optional keywork, to adjust IR cutoff
        if( lgMatch('BREA',chCard) ) then
           i = 4
           break = fread( chCard , i , 76 , lgEOL )
           if( lgEOL) then
             if( lgMatch(' NO ',chCard) ) then
               break = 1.02e-5
             else
               write(qq,'('' There must be a number for the break.'')')
               stop
             endif
           endif
           if( break.eq.0. ) then
             write(qq,'('' The break must be greater than 0.2 Ryd.'')')
             stop
           endif
           if( lgMatch('MICR',chCard ) ) then
*             optional keyword, ``microns'', convert to Rydbergs
              break = 0.0912 / break
           endif
           if( break.lt.0. ) then
*             option to enter break as log10
              break = 10.** break
           else if( break.eq.0. ) then
              write(qq,'('' An energy of 0 is not allowed.'')')
              stop
           endif
           if( break.ge.tnu(nspec,3) ) then
              write(qq,'('' The energy of the break cannot be greater''
     1        ,'' than'',1P,E9.2,'' Ryd.'')') tnu(nspec,3)
              stop
           else if( break.le.tnu(nspec,1) ) then
              write(qq,'('' The energy of the break cannot be less'',
     1        '' than'',1P,E9.2,'' Ryd.'')') tnu(nspec,1)
              stop
           endif
           tnu(nspec,2) = break
           tslop(nspec,2) = tslop(nspec,3) +
     1     log10( tnu(nspec,3)/tnu(nspec,2) )
           tslop(nspec,1) = tslop(nspec,2) -
     1     2.5*log10( tnu(nspec,2)/tnu(nspec,1) )
        endif
*
      else if( lgMatch('AKN1',chCard) ) then
*       AKN120 continuum from Brad Peterson's plot
        do i=1,nkn120
          tnu(nspec,i) = tnuakn(i)
          tslop(nspec,i) = log10( fnuakn(i) )
        end do
        j = nkn120 - 1
*
      else if( lgMatch('CRAB',chCard) ) then
*       Crab Nebula continuum from Davidson and Fesen 1985 Ann Rev article
        do i=1,ncrab
          tnu(nspec,i) = tnucrb(i)
          tslop(nspec,i) = log10( fnucrb(i) )
        end do
        j = ncrab - 1
*
      else if( lgMatch('COOL',chCard) ) then
*       cooling flow from Johnstone et al. 1992, MN 255, 431.
        do i=1,ncfl
          tnu(nspec,i) = cfle(i)
          tslop(nspec,i) = cflf(i)
        end do
        j = ncfl - 1
*
      else if( lgMatch(' ISM',chCard) ) then
*       local ISM radiation field from Black 1987, Interstellar Processes
        do i=1,nism
          tnu(nspec,i) = tnuism(i)
          tslop(nspec,i) = fnuism(i) - tnuism(i)
        end do
        j = nism - 1
        i = 5
*       optional scale factor to change default luminosity
*       from observed value
*       assumed to be log if negative, and linear otherwise
        scale = fread( chCard , i , 76 , lgEOL )
        if( scale.gt.0. ) scale = log10( scale )
        nqh = nqh + 1
        if( nqh.gt.limspc ) then
           write(qq,'(1X,I4,'' is too many continua entered.'',
     1     '' Increase LIMSPC'')') nqh
           stop
        endif
*       check that stack of shape and luminosity specifications
*       is parallel, stop if not - this happens is background comes
*       BETWEEN another set of shape and luminosity commands
        if( nspec.ne.nqh ) then
           write(qq,'('' This command has come between a previous '',
     1     ''ordered pair of continuum shape and luminosity commands.''
     2     ,/'' Reorder the commands to complete each continuum '',
     3     ''specification before starting another.'')')
           write(qq,'('' Sorry.'')')
           stop
        endif
        chRSpec(nqh) = 'SQCM'
        chSpNorm(nqh) = 'FLUX'
*       this will be flux density at 1 Ryd
*       >>chng 96 dec 18, from 1 ryd to H mass rydberg
*       >>chng 97 jan 10, had HLevNIonRyd but not defined yet
        range(nqh,1) = HIonPot
*       interpolted from Black 1987
        totpow(nqh) = -18.517 + scale
*       set radius to very large value if not already set
        if( radius.eq.0. ) then
          ar1 = rdfalt
          radius = 10.**ar1
        endif
*
      else if( lgMatch('POWE',chCard ) ) then
*        simple power law continuum between 10mincron and 50 kev
*        option to read in any slope for the intermediate continuum
         i = 5
         alpha = fread( chCard , i , 76 , lgEOL )
         if( lgEOL ) alpha = -1.
*        this is low energy for code
         tnu(nspec,1) = emm
         tslop(nspec,1) = -5
*
         lgLogSet = .false.
*        option to adjust sub-millimeter break
         brakmm = fread( chCard , i , 76 , lgEOL )
*        default is 10 microns
         if( lgEOL ) then
            lgLogSet = .true.
            brakmm = 9.115e-3
         else if( brakmm.eq.0. ) then
*           if second number on line is zero then set lower limit to
*           low-energy limit of the code.  Also set linear mode,
*           so that last number will also be linear.
            lgLogSet = .false.
            brakmm = tnu(nspec,1) * 1.001
         else if( brakmm.lt.0. ) then
*           if number is negative then this and next are logs
            lgLogSet = .true.
            brakmm = 10.** brakmm
         endif
         tnu(nspec,2) = brakmm
*        this is energy slope between low energy limit and this break
         slopir = 5./2.
         tslop(nspec,2) = tslop(nspec,1) +
     1      slopir * log10( tnu(nspec,2)/tnu(nspec,1) )
*
*        this is high energy limit to code
         tnu(nspec,4) = egamry
*
*        option to adjust hard X-ray break
         brakxr = fread( chCard , i , 76 , lgEOL )
*        default is 50 keV
         if( lgEOL ) then
            brakxr = 3676.
         else if( brakxr.eq.0. ) then
            brakxr = tnu(nspec,4) / 1.001
         else if( lgLogSet ) then
*           first number was negative this is a logs
            brakxr = 10.** brakxr
         endif
         tnu(nspec,3) = brakxr
*        alpha was first option on line, is slope of mid-range
         tslop(nspec,3) = tslop(nspec,2) +
     1     alpha*log10( tnu(nspec,3)/tnu(nspec,2) )
*
*        high energy range is nu^-2
         slopxr = -2.
         tslop(nspec,4) = tslop(nspec,3) +
     1     slopxr*log10( tnu(nspec,4)/tnu(nspec,3) )
*        following is number of portions of continuum
         j = 3
*
      else if( lgMatch('READ' , chCard ) ) then
        nTabRead = nTabRead + 1
        if( nTabRead.gt.1 ) then
          write(qq,'('' It is not possible to have more than 1 '',
     1    ''TABLE READ commands.'')')
          stop
        endif
*       set up eventual read of table of points previously punched by code
        i = 5
        io = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) io = 7
*       set flag saying really just read in continuum exactly as punched
        chSpType(nspec) = 'READ '
*       this will be flag saying continuum not read in here
        tslop(nspec,1) = 0.
        tslop(nspec,2) = io
*       nothing left to do here, better return
*       this file is actually read in by routine ReadTable
        return
*
      else if( lgMatch('RUBI',chCard) ) then
*       do Rubin modified theta 1 ori c
        do i=1,nrubin
          tnu(nspec,i) = tnurbn(i)
          tslop(nspec,i) = log10( fnurbn(i) )
        end do
        j = nrubin - 1
*
      else if( lgMatch('STAR',chCard ) ) then
*       TABLE STAR, numbers are temperature and log(g)
        i = 5
        par1 = fread( chCard , i , 76 , lgEOL )
*       option for log if less than or equal to 10
        if( par1.le.10. ) par1 = 10.**par1
        if( lgEOL ) then
          write(qq,'('' The stellar temperature MUST be entered.'')')
          stop
        endif
*       lgEOL is used in following logic to check whether grav set
        par2 = fread( chCard , i , 76 , lgEOL )
        if (lgMatch('ATLA',chCard)) then
*         this sub-branch added by Kevin Volk, to read in large
*         1991 grid of Kurucz atmospheres
*         default log(g) is 5 since all T_eff values have a model
*         for this log(g)
          if( lgEOL ) par2 = 5.0
          if( lgMatch('TRAC',chCard) ) then
            lgEOL = .true.
          else
            lgEOL = .false.
          endif
          call atlas(nstar,par1,par2,nspec,lgEOL)
*         set flag saying really just read in continuum exactly as punched
          chSpType(nspec) = 'VOLK '
          j=nstar-1
        else if (lgMatch('WERN',chCard)) then
*         this subbranch added by Kevin Volk, to read in large
*         grid of Kurucz atmospheres computer by Klaus Werner.
*         default log(g) is 8 since all T_eff values have a model
*         for this log(g)
          if( lgEOL ) par2 = 8.0
          call werne(nstar,par1,par2,nspec)
*         set flag saying really just read in continuum exactly as punched
          chSpType(nspec) = 'VOLK '
          j=nstar-1
*         >>chng 97 Aug 23, K Volk added Rauch stellar atmospheres
        else if (lgMatch('RAUC',chCard)) then
          if( lgEOL ) par2 = 8.0
          call RauchMod(nstar,par1,par2,nspec)
*         set flag saying really just read in continuum exactly as punched
          chSpType(nspec) = 'VOLK '
          j=nstar-1
*         End of block (K Volk)
        else if( lgMatch('KURU',chCard ) ) then
*         only log(g) = 4 supported now in Kurucz
          if( lgEOL ) par2 = 4.
          call kurucz79( nstar , par1 , par2 , nspec )
          j = nstar - 1
        else if( lgMatch('MIHA',chCard ) ) then
*         only log(g) = 4 supported now in Mihalas
          if( lgEOL ) par2 = 4.
          call mihals( nstar , par1 , par2 , nspec )
          j = nstar - 1
        else
          write(qq,'('' There must be a second key on TABLE STAR; '',
     1    '' the options are ATLAS, KURUCZ, MIHALAS, RAUCH, and '',
     2    ''WERNER.'')')
          stop
        endif
*       vary option
         if( lgVarOn ) then
           nparm = nparm + 1
           if( lgMatch('ATLA',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 2
             chVarFmt(nparm) =
     1       '(''TABLE STAR ATLAS'',F9.5,'' log(g)='',F6.3)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10( 3500. )
             varang(2,nparm) = log10( 50000. )
           else if( lgMatch('WERN',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 2
             chVarFmt(nparm) =
     1       '(''TABLE STAR WERNER'',F9.5,'' log(g)='',F6.3)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10( 80000. )
             varang(2,nparm) = log10( 200000. )
           else if( lgMatch('RAUC',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 2
             chVarFmt(nparm) =
     1       '(''TABLE STAR RAUCH'',F9.5,'' log(g)='',F6.3)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10(  50000. )
             varang(2,nparm) = log10( 500000. )
           else if( lgMatch('KURU',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 1
             chVarFmt(nparm) =
     1       '(''TABLE STAR KURUCZ'',F9.5)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10( 30000. )
             varang(2,nparm) = log10( 50000. )
           else if( lgMatch('MIHA',chCard ) ) then
*            this is number of parameters to feed onto the input line
             nvarxt(nparm) = 1
             chVarFmt(nparm) =
     1       '(''TABLE STAR MIHALAS'',F9.5)'
*            following are upper and lower limits to temperature range
             varang(1,nparm) = log10( 30000. )
             varang(2,nparm) = log10( 55000. )
           endif
*          pointer to where to write
           nvfpnt(nparm) = nRead
*          log of temp will be pointer
           vparm(nparm,1) = log10( par1 )
           vparm(nparm,2) = par2
           vincr(nparm) = 0.1
         endif
      else
         write(qq,'('' There MUST be a keyword on this line. The keys ''
     1   ,''are: AGN, AKN120, _ISM, COOL, CRAB, '',
     2   ''POWERlaw, RUBIN, and STAR.  Sorry.'')')
         stop
      endif
*
*     table star werner and table star atlas are special
*     cases put in by Kevin Volk - they are not really tables
*     at all, so return if sptype is Volk
      if( chSpType(nspec) .eq. 'VOLK ' ) return
*
*     convert from log(Hz) to Ryd if first nu>5
      if( tnu(nspec,1).ge.5. ) then
         do i=1,j+1
           tnu(nspec,i) = 10.** (tnu(nspec,i)-15.51718)
         end do
      else if( tnu(nspec,1).lt.0. ) then
*        energies entered as logs
         do i=1,j+1
           tnu(nspec,i) = 10.**tnu(nspec,i)
         end do
      endif
*
*     tfac will be log(fnu) at that spot, read into tslop
      do i=1,j+1
        tfac(nspec,i) = tslop(nspec,i)
      end do
      do i=1,j
        tslop(nspec,i) = (tslop(nspec,i+1)-tslop(nspec,i)) /
     1  log10(tnu(nspec,i+1) / tnu(nspec,i))
      end do
*
      if( j+2.lt.ncell ) then
*        zero out remainder of array
         do i=j+2,ncell
           tnu(nspec,i) = 0.
         end do
      endif
*
      if( lgConBug.and.lgTrace ) then
         write(qq,'('' Table for this continuum; TNU, TFAC, TSLOP'')')
         write(qq,'(1P,3E12.4)')(tnu(nspec,i),tfac(nspec,i),
     1   tslop(nspec,i),i=1,j+1)
      endif
*
*     renormalize continuum so that quantity passes through unity
*     at 1 Ryd
      lgHit = .true.
      do i=1,j+1
        if( tnu(nspec,i).gt.1. ) then
          fac = tfac(nspec,i)
          lgHit = .false.
*         go to15
        endif
      end do
      if( lgHit ) then
        write(qq,'('' TABLE fails sanity test in table'')')
        stop
      endif
*15   continue
*
*     do the renormalization
      do i=1,j+1
        tfac(nspec,i) = tfac(nspec,i) - fac
      end do
*
      end
******************************************************************************
      subroutine GetTrace( chCard )
      implicit none
*read in options off the trace command line
      character chCard*80
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer itrprt
      common/itrprt/ itrprt(itrdim)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgCoolTr
*flag set with trace cooling
      common/cooltr/ lgCoolTr
      logical lgBug2nu
*flag set with trace two photon command
      common/bug2nu/ lgBug2nu
      logical lgOTSBug
*flag set with trace ots command
      common/otsbug/ lgOTSBug
      logical lgConBug
*flag set with trace continuum command
      common/conbug/ lgConBug
      logical lgCarBug
*trace carbon flag
      common/carbug/ lgCarBug
      logical lgCalBug
*trace caldium atom flag
      common/calbug/ lgCalBug
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgDustBug
*flag set with trace grains command
      common/dstbug/ lgDustBug
      logical lgOpacBug
*flag set with trace opacity
      common/opcbug/ lgOpacBug
      logical lgTr8446
*flag set with trace beta command
      common/tr8446/ lgTr8446
      logical lgTrDiff
*flag set with trace difuse fields command
      common/trdiff/ lgTrDiff
      logical lgTrOptm
*flag set with trace optimizer command
      common/troptm/ lgTrOptm
      logical lgDrBug
*flag set with trace dr command
      common/drbug/ lgDrBug
      logical lgTrGant
*flag set with trace gaunt command
      common/trgant/ lgTrGant
      logical lgHeatBug
*flag set by trace heating command
      common/heatbg/ lgHeatBug
      logical lgTrMole
*flag set with trace molecules command
      common/trmole/ lgTrMole
      logical lgTrace3Bod
*trace 3 body recombination routines, trace three body
      common/bd3bug/ lgTrace3Bod
      logical lgOptcBug
*flag set if negative opacities every occured
      common/optbug/ lgOptcBug
      logical lgFeBug
*flag set with trace iron bug
      common/febug/ lgFeBug
      logical lgTrLine
*flag set with trace line command
      common/trline/ lgTrLine
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      logical lgNeonBug
*flag set with trace neon command
      common/neonbg/ lgNeonBug
      logical lgComBug
*trace compton flag
      common/combug/ lgComBug
      logical lgPointBug
*flag set with trace pointers command
      common/pntbug/ lgPointBug
      logical lgTrLevN
*flag set with trace leveln command, for n level atom
      common/TrLevN/ lgTrLevN
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
*
*     local variables
      logical lgMatch , lgEOL
      integer i
      real fread
*
*     turn on trace at a certain zone; .LE.0 or none for starting trace
*     optional second number is iteration to start debugger
*     optional word "hydrogen" provides more info on hydrogen solution
      i = 5
*     this is which zone to turn on
      nznbug = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) lgTrace = .true.
*     this is which iteration to turn on
      npsbug = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) npsbug = 1
*
*     turn trace on now if no numbers on line
      if( nznbug.eq.0 .and. npsbug.eq.1 ) then
        lgTrace = .true.
        nprint = 1
        itrprt(1) = 1
      endif
*
*     were there any keywords on the line?
      if( lgMatch('BETA',chCard) ) lgTr8446 = .true.
      if( lgMatch('CARB',chCard) ) lgCarBug = .true.
      if( lgMatch('CALC',chCard) ) lgCalBug = .true.
      if( lgMatch('COMP',chCard) ) lgComBug = .true.
      if( lgMatch('CONT',chCard) ) lgConBug = .true.
      if( lgMatch('CONV',chCard) ) then
*       this is special command, only convergence loops, not full trace
        lgTrConvg = .true.
        lgTrace = .false.
        nznbug = 10000
        nprint = 10000
        itrprt(1) = 10000
      endif
      if( lgMatch('COOL',chCard) ) lgCoolTr = .true.
      if( lgMatch('DIFF',chCard) ) lgTrDiff = .true.
      if( lgMatch(' DR ',chCard) )  lgDrBug = .true.
      if( lgMatch('EDEN',chCard) )  lgNeBug = .true.
      if( lgMatch('GAUN',chCard) ) lgTrGant = .true.
      if( lgMatch('GRAI',chCard) ) lgDustBug = .true.
      if( lgMatch('HEAV',chCard) ) lgHeavyBug = .true.
      if( lgMatch('HEAT',chCard) ) lgHeatBug = .true.
      if( lgMatch('HELI',chCard) ) then
        lgHeBug = .true.
        if( lgMatch('SING',chCard) ) lgHe1Bug = .true.
        if( lgMatch('ATOM',chCard) ) lgHe1Bug = .true.
*       this will match either ionzed or ion
        if( lgMatch(' ION',chCard) ) lgHe2Bug = .true.
        if( lgMatch('TRIP',chCard) ) lgHe3Bug = .true.
      endif
      if( lgMatch('HYDR',chCard) )   then
        lgHBug = .true.
*       option to turn on full printout
        if( lgMatch('FULL',chCard) ) then
          lgHBugFull = .true.
        else
          lgHBugFull = .false.
        endif
      endif
      if( lgMatch('IRON',chCard) )  lgFeBug = .true.
      if( lgMatch('VELN',chCard) )  lgTrLevN = .true.
      if( lgMatch('LINE',chCard) )  lgTrLine = .true.
      if( lgMatch('NEON',chCard) )  lgNeonBug = .true.
      if( lgMatch('MOLE',chCard) ) lgTrMole = .true.
      if( lgMatch('OPAC',chCard) ) lgOpacBug = .true.
*     trace pointers
      if( lgMatch('POIN',chCard) ) lgPointBug = .true.
*     following two are optical, optimize
      if( lgMatch('PTIC',chCard) ) lgOptcBug = .true.
      if( lgMatch('PTIM',chCard) ) lgTrOptm = .true.
      if( lgMatch(' OTS',chCard) ) lgOTSBug = .true.
      if( lgMatch('THRE',chCard) ) lgTrace3Bod = .true.
      if( lgMatch(' TWO',chCard) ) lgBug2nu = .true.
*
      end
      subroutine GetWerner
      implicit none
*rebin Werner stellar atmospheres to match cloudy energy grid
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      common/StarBad/ lgStarBad
      logical lgStarBad
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer j , n1 , i , n2 , imod , ierr
      integer iout(ncell)
*     real freq(ncell) , flux2(ncell)
*     freq changed to anu2, flux2 changed to ContBoltz
*
      write(qq,'('' GetWerner on the job.'')')
c This is a program to re-bin the Werner stellar model spectra to match the
c CLOUDY grid.  For short wavelengths I will use a power law extrapolation
c of the model values (which should be falling rapidly) if needed.  At long
c wavelengths I will assume Rayleigh-Jeans from the last stellar model point
c to extrapolate to 1 cm wavelength.
c
c This version uses power-law interpolation between the points of the stellar
c model.
c
c If ncell is changed the format statement below must also be changed.
c If the size of the CLOUDY frequency grid becomes larger than ncell the
c arrays below would have to be increased in size.
c
c
c This file holds the energy bin values (center energy and bin width, both in
c Rydberg units) as written out by CLOUDY.  The file has two header lines.
c
c For putting this in CLOUDY the arrrays "anu" and "widflx" would have to be
c passed into the routine.
c
*      read in the cloudy energy grid, converting to integers
       n1 = 1
       do while( anu(n1).lt.182. )
         iout(n1) = int(abs(log10(anu(n1))-5.)*1.e+06)
         n1 = n1 + 1
       end do
       n1 = n1 - 1
c
       write(qq,'('' A total of '',i4,'' Cloudy cells needed.'')') n1
       if( n1.eq.nWerner ) then
         write(qq,'('' The current value of nWerner is ok.'')')
       else
         if( .not.lgStarBad ) then
*          no errors yet, so open errors file
           open(unit=66,file='problems.out',status='unknown')
         endif
         lgStarBad = .true.
         write(qq,'('' WARNING!!!!!'')')
         write(qq,'('' WARNING!!!!!'')')
         write(qq,'('' nWerner must be changed to'',i6,
     1   '' in block data scalar.  Its current value is'',i6)')
     2   n1,nWerner
         write(66,'('' nWerner must be changed to'',i6,
     1   '' in block data scalar.  Its current value is'',i6)')
     2   n1,nWerner
         write(qq,'('' I will take care of this for now.'')')
         nWerner = n1
       endif
c
c **** Note that n1 has to be set for this program to be changed to a subroutine
c It is the number of values in the CLOUDY frequency array. *********
c
      open(unit=01,file='werner.ascii',status='old',iostat=ierr)
      if( ierr.ne.0 ) then
        write(qq,'('' GetWerner fails opening werner.ascii'')')
        write(qq,'('' Where is this file?'')')
        stop
      endif
c This "werner.ascii" file is a straight ascii dump of the Klaus Werner
c stellar model files which he gave to me in 1992.  The first set of values
c is the 80000 K log(g)=5.0 model fluxes, followed by the wavelength grid,
c followed by the other models in order of increasing log(g) and temperature.
c
      open(unit=11,file='werner.mod',iostat=ierr,status='unknown',
     c     access='direct',form='formatted',recl=7*ncell)
      if( ierr.ne.0 ) then
        write(qq,'('' GetWerner fails creating werner.mod'')')
        write(qq,'('' This is impossible??'')')
        stop
      else
        write(qq,'('' GetWerner creating werner.mod OK'')')
      endif
      write(11,'(4000i7)',rec=1) (iout(j),j=1,n1)
c
      do imod=2,21
      if (imod.eq.2) then
*       only for first one, get energy grid
*     >>chng 97 jan 5, get rid of statement
        read(01,'(5e15.7)',iostat=ierr) (anu2(i),i=1,514)
*55   format(5e15.7)
        if( ierr.ne.0 ) then
          write(qq,'('' GetWerner fails reading energy grid1.'')')
          stop
        endif
        do i=1,513
          anu2(i) = 299792458.*10973731.534*anu2(i+1)
        end do
c this converts the Rydberg values to Hz since I want to use the
c same interpolation subroutine for the Werner and the Kurucz models,
c and the Kurucz models are expressed as a function of frequency.
c
c The Klaus Werner model wavelength grid was converted to Rydberg units
c when I originally created the direct access file, but here they are
c converted back to Hz.
      end if
*     >>chng 97 jan 5, get rid of statement
      read(01,'(5e15.7)',iostat=ierr) (flux(i),i=1,514)
*55   format(5e15.7)
      if( ierr.ne.0 ) then
        write(qq,'('' GetWerner fails getting wavelenghts.'')')
        stop
      endif
c
      do i=1,513
        flux(i)=10.**flux(i+1)
        if(i.gt.1) then
          if( anu2(i).eq.anu2(i-1) ) then
* change 96 apr 12, gjf, to avoid double precision
            anu2(i-1)=anu2(i-1)*0.999
            anu2(i)=anu2(i)*1.001
          end if
c This is due to there being fluxes above and below certain wavelengths where
c the opacity changes (i.e. the Lyman and Balmer limits for example) which are
c assigned the same wavelength in the Klaus Werner files.
        end if
      end do
c
c The first value in the spectrum read in from the "werner.ascii" file is not
c one of the original Klaus Werner model values but is an extrapolation to
c long wavelength...so I remove it in the loop.
c
      n2=513
      flux(514)=0.0d+00
      anu2(514)=0.0d+00
      call RebinWer(n1,n2)
c
      do j=1,n1
        if (ContBoltz(j).gt.1e-30 ) then
          iout(j) = int(abs(log10(ContBoltz(j))-3.)*100000.)
        else
          iout(j) = 9999999
        endif
      end do
c
      write(11,'(4000i7)',rec=imod) (iout(j),j=1,n1)
*
      write(qq,'('' GetWerner wrote stellar atmosphere number'',i3)')
     1 imod
      end do
*
      close(01)
      close(unit=11)
      write(qq,'('' GetWerner completed ok, werner.ascii '',
     1''can be deleted.'')')
*
      end
******************************************************************
      subroutine RebinWer(n1,n2)
      implicit none
*rebin Werner atmospheres onto Cloudy grid
      integer n1 , n2
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*
*     real flux1(ncell),freq1(ncell)
*     flux1 changed to gff, freq1 to anu3
      real c , rydb, con1,slope2,edge1,edge2, power,val ,sum,
     1 x1,x2,v1,v2 , term
      integer i1 , i2 , i
      integer j
c
c I want to insure that the stellar arrays are in increasing frequency order
c here.
      if (anu2(2).gt.anu2(1)) then
c
          do j=1,n2
            anu3(j) = anu2(j)
            gff(j) = flux(j)
          end do
c
      else
c
          do j=1,n2
            anu3(j) = anu2(n2+1-j)
            gff(j) = flux(n2+1-j)
          end do
c
      end if
c
      c=299792458.0d+00
      rydb=10967758.30d+00
c speed of light and H-atom Rydberg constant in MKS units, for
c conversion of frequency to H-rydberg units.  The infinite mass
c R value is 10973731.534 and the proton to electron mass ratio is
c 1836.152701 for this calculation.
      con1=1.d+00/(c*rydb)
c
      do j=1,n2
        anu3(j)=anu3(j)*con1
      end do
c
      slope2=2.0d+00
c this is the Rayleigh-Jeans slope in F_nu, for low frequency extrapolation
c
      do j=1,n1
      edge1=anu(j)+0.5d+00*widflx(j)
      edge2=anu(j)-0.5d+00*widflx(j)
      if (edge1.lt.anu3(1)) then
          ContBoltz(j)=gff(1)*((anu(j)/anu3(1))**slope2)
      else
          if (edge2.gt.anu3(n2)) then
              ContBoltz(j)=0.0d+00
          else
              i1=0
              i2=0
c
              do i=1,n2-1
              if (anu3(i).le.edge2.and.anu3(i+1).gt.edge2) i2=i
              if (anu3(i).le.edge1.and.anu3(i+1).gt.edge1) i1=i
              end do
c
c Do the case where the grid point and its edges are between two of the
c stellar model points:  add segments with power-law interpolation up to
c do the averaging.
c
c When edge2 < anu3(1) i2 is equal to 0 and i1 is equal to 1, so do it
c as if i1 = i2 to avoid going outside array bounds.
              if (i1.eq.i2.or.i2.eq.0) then
                  power=log(gff(i1+1)/gff(i1))/
     c                    log(anu3(i1+1)/anu3(i1))
                  val=power*log(anu(j)/anu3(i1))
                  ContBoltz(j)=gff(i1)*exp(val)
              else
                  sum=0.0d+00
c
                  do i=i2,i1
                  power=log(gff(i+1)/gff(i))/
     c                     log(anu3(i+1)/anu3(i))
                  if (i.eq.i2) then
                      x1=edge2
                      x2=anu3(i+1)
                      v1=gff(i)*exp(power*log(x1/anu3(i)))
                      v2=gff(i+1)
                  end if
                  if (i.eq.i1) then
                      x2=edge1
                      x1=anu3(i)
                      v2=gff(i)*exp(power*log(x1/anu3(i)))
                      v1=gff(i)
                  end if
                  if (i.gt.i2.and.i.lt.i1) then
                      x1=anu3(i)
                      x2=anu3(i+1)
                      v1=gff(i)
                      v2=gff(i+1)
                  end if
                  term = anu3(i)*v1
                  if (abs(power+1.0).lt.0.001) then
                      val=x1*v1*log(x2/x1)
                  else
                      val=((x2/x1)**(power+1.d+00)-1.d+00)
                      val=val*x1*v1/(power+1.d+00)
                  end if
                  sum=sum+val
                  end do
c
                  ContBoltz(j)=sum/widflx(j)
              end if
          end if
      end if
      end do
c
      end
*********************************************************************
      subroutine gffsub(z,xlf,g,low,n,ndim,iflag)
      implicit none
*compute gaunt factors for any charge, drive Hummer routine, mod by J Ferguson
*
*          GENERATES THERMALLY AVERAGED FREE-FREE NON-RELATIVISTIC GAUNT
*          FACTOR FOR A HYDROGENIC ION OF CHARGE Z, WITH A MAXIMUM RELATIVE
*          ERROR OF .OO7, (RMS FITTING ERROR = .001) FOR TEMPERATURE AND
*          FREQUENCY IN INTERVALS:
*                     10**-4 LE U LE 10**1.5,
*                     10**-3 LE GAMS LE 10**3,
*          WHERE U = H*NU/K*T  AND  GAMS = Z**2*RYD/K*T.  TO OBTAIN THE
*          STATED ACCURACY, THE FULL NUMBER OF SIGNIFICANT FIGURES IN THE
*          COEFFICIENTS MUST BE RETAINED.
*
*          THIS SUBROUTINE USES A TWO-DIMENSIONAL CHEBYSHEV EXPANSION
*          COMPUTED FROM EXPRESSIONS GIVEN BY KARZAS AND LATTER (AP.J.
*          SUPPL., V.6, P.167, 1961) AUGMENTED BY VARIOUS LIMITING FORMS
*          OF ENERGY-SPECIFIC GAUNT FACTORS.
*          D.G.HUMMER, JILA, MAY 1987. Ap.J. 327, 477
*          modified with correct limits,  J Ferguson, July 94
*
*          SUBROUTINE ARGUMENTS ARE:
*              Z    =  base 10 log of nuclear charge
*           => T    =  TEMPERATURE IN DEGREES KELVIN (now in common)
*                      must set alogte in common logte
*              XLF  =  ARRAY CONTAINING INPUT VALUES OF LOG10(H*NU/RYD)
*              G    =  ARRAY CONTAINING OUTPUT VALUES OF GFF
*              LOW  =  FIRST ELEMENT OF ARRAY TO BE EVALUATED
*              N    =  LENGTH OF XLF AND G ARRAYS
*              NDIM  =  DIMENSION OF XLF AND G ARRAYS IN CALLING PROGRAM
*              IFLAG= explanation given in each area.
*
*
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
*
*     local variables
      real z,xlrkt,txg,txu,con,u,gamma2,slope
      double precision d(8,11) , dd(88)
      equivalence (d(1,1) , dd(1) )
      integer ndim
      real xlf(ndim),g(ndim),b(11),c(8)
      integer i,n,iflag,j,ir,low
      data (dd(i),i=1,44)/
     .  8.986940175D+00, -4.009515855D+00,  8.808871266D-01,
     .  2.640245111D-02, -4.580645915D-02, -3.568055702D-03,
     .  2.827798067D-03,  3.365860195D-04, -8.006936989D-01,
     .  9.466021705D-01,  9.043402532D-02, -9.608451450D-02,
     . -1.885629865D-02,  1.050313890D-02,  2.800889961D-03,
     . -1.078209202D-03, -3.781305103D-01,  1.102726332D-01,
     . -1.543619180D-02,  8.310561114D-03,  2.179620525D-02,
     .  4.259726289D-03, -4.181588794D-03, -1.770208330D-03,
     .  1.877213132D-02, -1.004885705D-01, -5.483366378D-02,
     . -4.520154409D-03,  8.366530426D-03,  3.700273930D-03,
     .  6.889320423D-04,  9.460313195D-05,  7.300158392D-02,
     .  3.576785497D-03, -4.545307025D-03, -1.017965604D-02,
     . -9.530211924D-03, -3.450186162D-03,  1.040482914D-03,
     .  1.407073544D-03, -1.744671550D-03,  2.864013856D-02,
     .  1.903394837D-02,  7.091074494D-03/
      data (dd(i),i=45,88) / -9.668371391d-04,
     . -2.999107465D-03, -1.820642230D-03, -3.874082085D-04,
     . -1.707268366D-02, -4.694254776D-03,  1.311691517D-03,
     .  5.316703136D-03,  5.178193095D-03,  2.451228935D-03,
     . -2.277321615D-05, -8.182359057D-04,  2.567331664D-04,
     . -9.155339970D-03, -6.997479192D-03, -3.571518641D-03,
     . -2.096101038D-04,  1.553822487D-03,  1.509584686D-03,
     .  6.212627837D-04,  4.098322531D-03,  1.635218463D-03,
     . -5.918883504D-04, -2.333091048D-03, -2.484138313D-03,
     . -1.359996060D-03, -5.371426147D-05,  5.553549563D-04,
     .  3.837562402D-05,  2.938325230D-03,  2.393747064D-03,
     .  1.328839809D-03,  9.135013312D-05, -7.137252303D-04,
     . -7.656848158D-04, -3.504683798D-04, -8.491991820D-04,
     . -3.615327726D-04,  3.148015257D-04,  8.909207650D-04,
     .  9.869737522D-04,  6.134671184D-04,  1.068883394D-04,
     . -2.046080100D-04/
*
*          COMPUTE TEMPERATURE-DEPENDENT COEFFICIENTS FOR U EXPANSION
*
      iflag = 0
*     XLRXT IS LOG(RYD/KT), code not valid for TE> 10**8
*     XLRXT IS LOG(RYD/KT), code not valid for TE< 10**2.5
      if(alogte.lt.2.5) then
        xlrkt = 5.1983649 - 2.5
        iflag = 1
      else if(alogte.gt.8.) then
        xlrkt = 5.1983649 - 8.
        iflag = 8
      else
        xlrkt = 5.1983649 - alogte
      endif
*     Z is the base 10 log of the nuclear charge
*     TXG (a Hummer variable) is related to gamma^2
*     TXU is related to U
      txg = 0.66666667*(2.0*z+xlrkt)
      gamma2 = 10**(txg*1.5)
*
      con = 0.72727273*xlrkt+0.90909091
      do j=1,8
         ir = 9
         b(11) = d(j,11)
         b(10) = txg*b(11)+d(j,10)
         do i=1,9
            b(ir) = txg*b(ir+1)-b(ir+2)+d(j,ir)
            ir = ir-1
         end do
         c(j) = 0.25*(b(1)-b(3))
      end do
*
*     sum U expansion
*
*     loop through energy at fixed temperature
      do i=low,n
*     TXU is related to U
        txu = 0.72727273*xlf(i)+con
        u = 10**((txu - .90909091)/.72727273)
*       criteria set by Hummer limits. It is a wedge from
*       (log(hnu),log(T)) =
*       (-5,2.5) to (-5,4) to (-1,8) to (4,8) to (-1.5,2.5).
*       These limits correspond to the gamma^2 and U limits given above
        if(abs(txu).le.2.0) then
          ir = 6
          b(8) = c(8)
          b(7) = txu*b(8)+c(7)
          do j=1,6
            b(ir) = txu*b(ir+1)-b(ir+2)+c(ir)
            ir = ir-1
          end do
          g(i) = b(1)-b(3)
          if(alogte.ge.2.5.and.alogte.le.8.0) iflag = 0
* On the bottom side of the hummer box,u<-4 and gamma2>.33
        else if(log10(u).lt.-4.0.and.gamma2.lt.0.3) then
          g(i) = 0.551329 * alog(2.24593/u)
          if(alogte.ge.2.5.and.alogte.le.8.0) iflag = 2
* On the bottom side of the box,u<-4 and gamma2<.33
        else if(log10(u).lt.-4.0.and.gamma2.ge.0.3) then
          g(i) = 0.551329 * alog( 0.944931/u/sqrt(gamma2) )
          if(alogte.ge.2.5.and.alogte.le.8.0) iflag = 3
* Now on the bottom side of the box.
        else if(txu.gt.2.0) then
* Top of the box high T first
          if(log10(gamma2).lt.-3.) then
            g(i) =  sqrt(0.9549297/u)
            if(alogte.ge.2.5.and.alogte.le.8.0) iflag = 4
* Must interpolate between two asymptotes
          else if(log10(gamma2).lt.0.0) then
            slope = ( sqrt(12*gamma2/u) - sqrt(0.9549297/u) ) / 3.0
            g(i) =  sqrt(12*gamma2/u) + slope * log10(gamma2)
            if(alogte.ge.2.5.and.alogte.le.8.0) iflag = 7
          else
* The top side with wedge of 1.05 where region 6 fails
            g(i) = sqrt(12. * gamma2 / u)
            g(i) = min(1.05,g(i))
            if(g(i).eq.1.05.and.alogte.ge.2.5.and.alogte.le.8.0)
     1         iflag = 5
            if(g(i).lt.1.05.and.alogte.ge.2.5.and.alogte.le.8.0)
     1         iflag = 6
          endif
        endif
        u = 0.0
      end do
*
      end
******************************************************************************
      subroutine globsb( chCard )
      implicit none
*parse parameters off the globule command
      character chCard*80
*
      real glbden , glbrad , glbpow , glbdst
      common/globul/ glbden , glbrad , glbpow , glbdst
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgSMinON
*lgSMinON is flag saying that set drmin has been enteed
*     these are 1e-30 and 1e30 by default, and are set with "set dr" cmnds
*     used as one of a pair of limits to how big or small zones get
*     set dr command forces constant dr by setting both to same number
      real sdrmin , sdrmax
      common/sdrmin/ sdrmin , sdrmax , lgSMinON
      logical lgDrMnOn
*flag to turn off dr checking in dextdr when globule command entered
      common/drmnon/ lgDrMnOn
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real range
      common/range/ range(limspc,2)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      integer nvary , nparm
      common/nvary/ nvary , nparm
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      real emm , egamry
      common/bounds/ emm , egamry
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL
      integer i
      real fread
*
*     globule with density increasing inward
*     parameters are outer density, radius of globule, and density power
      i = 5
      glbden = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        glbden = 1.
        hden = 0.
      else
        hden = glbden
        glbden = 10.** glbden
      endif
      glbrad = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        glbrad = 3.086e18
      else
        glbrad = 10.** glbrad
      endif
*     this is largest zone thickness, used to set first zone thickness
      sdrmax = glbrad / 25.
*     turn off min dr checking in NEXTDR
      lgDrMnOn = .false.
      glbpow = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) glbpow = 1.
      chCPres =  'GLOB'
*     this is distance to globule
      glbdst = glbrad
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
*       pointer to where to write
        nvfpnt(nparm) = nRead
*       this is the number of parameters to feed onto the input line
        nvarxt(nparm) = 3
        write(chVarFmt(nparm),'(''(''''GLOBULE '''',3F11.5)'')')
*       param is log of abundance by number relative to hydrogen
        vparm(nparm,1) = log10( glbden )
        vparm(nparm,2) = log10( glbrad )
        vparm(nparm,3) = glbpow
        vincr(nparm) = 0.2
      endif
*
      end
*****************************************************************************
      subroutine grain
      implicit none
*main routine to converge grains thermal solution
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
      real toler
*     allowed error in heating - cooling balance, set with TOLERANCE command
*     default set in zerologic
      common/toler/ toler
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      real dheat
*grain heating rate for this zone
      common/dustheat/ dheat(ndust)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real DustHeatLya , dstpow , dstsum , dincon,dstotl,dhcol,HDustDif
*     HDustDif is heating of grains in current zone due to diffuse fields
*DustHeatLya is heating of dust due to Lya
      common/dhla/ DustHeatLya , dstpow , dstsum , dincon ,dstotl,dhcol,
     1 HDustDif
      real tedust
      common/tedust/ tedust(ndust)
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      real DustCoolGas
*dust cooling the gas by collisions
      common/dclgas/ DustCoolGas
      character*10 chInCvgRsn
      common/InCvgRsn/ chInCvgRsn
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
*
*     this is the main routine that drives the grain physics
*
*     local variables
      real SaveHeat , SaveCool , GrnVryDpth
      integer nd , i
*
*     free statement labels >=10, 6
*
*     these will sum heating agents over grain populations
      DustHeatLya = 0.
      dhcol = 0.
      dincon = 0.
*     dstotl will be total cooling by grains here
      dstotl = 0.
*     total heating due to absorption of diffuse fields, not Lya
      HDustDif = 0.
*
      if( .not.lgDustOn ) then
        dstsum = 0.
        heating(1,14) = 0.
        DustCoolGas = 0.
        do nd=1,ndust
          dheat(nd) = 0.
          tedust(nd) = 0.
          DustDftVel(nd) = 0.
        end do
        return
      endif
*
*     option to have grain abundance depend on depth
      do i=1,nupper
*       these are total absorption and scattering cross sections
        dstab(i) = 0.
        dstsc(i) = 0.
      end do
      do nd=1,ndust
*       refresh grain opacities if variable grain abundances enabled
        if( lgDustOn1(nd).and.lgDustVary(nd)) then
          dstAbund(nd) = dstfactor(nd) * GrnVryDpth(nd)
        endif
        do i=1,nupper
*         these are total absorption and scattering cross sections
          dstab(i) = dstab(i) + dstab1(i,nd) * dstAbund(nd)
          dstsc(i) = dstsc(i) + dstsc1(i,nd) * dstAbund(nd)
        end do
      end do
*
*     must redo grain solution all the time since they
*     generally have non-trivial contributions to heating-cooling
      SaveHeat = heating(1,14)
      SaveCool = DustCoolGas
      heating(1,14) = 0.
*
*     find dust charge
      call dcharg
*     find heating (gas and dust) and grain temperature
      call dtempr
*     find dust drift velocity
      call ddrift
      SaveHeat = max( abs(SaveHeat-heating(1,14)) ,
     1 abs( SaveCool-DustCoolGas) ) / max(1e-30,htot)
      if( SaveHeat.gt.toler/2. ) then
        lgIonDone = .false.
        chInCvgRsn = 'Grain dHdC'
      endif
*
      end
******************************************************************************
      subroutine GrainRateDr( grfreqm, gropacm )
      implicit none
*called by nextdr to find grains heating rate dr
      real grfreqm , gropacm
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer limelm
      parameter (limelm=30)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real opac
      common/opac/ opac(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real xMax
      integer i , iplow
*
*     in all following changed from anu2 to anu  july 25 95
*
*     find maximum continuum interaction rate
*
*     not every continuum extends beyond C edge-this whole loop can add to zero
*     use total opacity here
*     test is to put in fir continuum if free free heating is important
      if( FreeFreeHeat/htot.gt.0.05 ) then
*       this is pointer to energy where cloud free free optical depth is unity
        iplow = ntff
      else
        iplow = ipHeavy(6,1)
      endif
      xMax = 0.
*     integrate up to heii edge
      do i=iplow,ipHeavy(2,2)
        if( anu(i)*flux(i)/widflx(i)*opac(i).gt.xMax)
     1    then
          xMax = anu(i)*flux(i)/widflx(i)*opac(i)
          grfreqm = anu(i)
          gropacm = opac(i)
        endif
      end do
*
*666  write(13,'(1p,3e10.2)') xMax , grfreqm , gropacm
*
*begin sanity check
      if( gropacm.le.0. .or. grfreqm.le.0. ) then
        write(qq,'('' GrainRateDr found non positive interaction, or '',
     1  ''energy.'')')
        write(qq,'('' This is impossible.'')')
        call ShowMe
        stop
      endif
*end sanity check
*
      end
********************************************************************
      real function grngam( nd )
      implicit none
*compute grains photoionization rates
      integer nd
      integer ndems
      parameter (ndems=50)
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real DustPhotoE
*difference between photon energy and work function for grains
      common/dnu/ DustPhotoE(ncell,ndust)
      real yn
      common/yn/ yn(ncell,ndust)
      integer ipdpot
      common/ipdpot/ ipdpot(ndust)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real yhat
      common/yhat/ yhat(ncell,ndust)
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real dqabs, dqscat
      common/dqs/ dqabs(ncell,ndust) , dqscat(ncell,ndust)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real sumots , suminc , partot , partin
*
      sumots = 0.
      suminc = 0.
      grngam = 0.
*
*     if(dstpot(nd).eq.0..and.nd.eq.1)write(QQ,'('' n,      nu,     yhat,
*    1   gam(line),   gam(incid),   total gam'')')
      do i=ipdpot(nd),nflux
         yhat(i,nd) = yn(i,nd) *
     1   min(1.,   max(0.,1. - dstpot(nd) / DustPhotoE(i,nd))   )
*        partot = (otscon(i)+
*    1   outcon(i)+outlin(i)+ otslin(i))* yhat(i,nd) * dqabs(i,nd)
         partot = SummedDif(i) * yhat(i,nd) * dqabs(i,nd)
         sumots = sumots + partot
         partin = flux(i)* yhat(i,nd) * dqabs(i,nd)
         suminc = suminc + partin
*666     if(dstpot(nd).eq.0..and.nd.eq.1)write(QQ,'(i5,1p,5e10.3)')
*    1   i,anu(i),yhat(i,nd),partot, partin,suminc+sumots
      end do
*
      grngam = sumots + suminc
*
      end
******************************************************************************
      real function GrnVryDpth( nd )
      implicit none
*set grains abundance as a function of depth into cloud
*NB most quantities are undefined for first calls to this sub
      integer nd
*     nd is the pointer to the grain species.  This routine must return
*     a scale factor for the abundance at this position.
*
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer limelm
      parameter (limelm=30)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      if( lgDustVary(nd) ) then
*       sample code - the scale factor will be the hydrogen ionization fraction
*       following can be used for any other element - first dimesion
*       is atomic weight and second is stage of ionization
        GrnVryDpth = xIonFracs(1,1) / (xIonFracs(1,2)+xIonFracs(1,1))
      else
        GrnVryDpth = 1.
      endif
*
      end
************************************************************************
       subroutine h1cs123(i,j,temp,cs)
       implicit none
*hydrogen collision data
       integer i,j,k
       real cs,  temp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
* These are fits given in
*      >>refer Callaway, J. 1994, ADNDT, 57, 9
* H I collision strengths for 1s-2s, 1s-2p, 1s-3, 2s-3, and 2p-3,
* principle quantum numbers n and l.
* CLOUDY sums angular momentum (s,p,d) components of level n=3.
*
* SEE IMPORTANT NOTE BELOW ABOUT EST. VALID ENERGY RANGES OF FITS.
************************************************************************
*
* i is the lower level and runs from 1 to 3 (1s, 2s, 2p)
* j is the upper level and runs from 2 to 4 (2s, 2p, 3)
*
       real b(10)
       real cs3s, cs3p, cs3d
       real ev, bk, ryd, E
       real T, Tmin, Tmax1, Tmax2, Tmax3
*
* some constants
*
        ev = 1.60184e-12
        bk = 1.380622e-16
        ryd = 13.60583
 
* convert temperature T (K) to energy in Rydbergs
 
        E = bk*temp/(ev*ryd)
        T = E
 
**********************************************************
*************-----------IMPORTANT------------*************
**********************************************************
*
* Callaway fits to effective cross-sections are high-order
* polynomials which become insane not too far from the
* unstated upper energy limits, given below.
* Fits are more stable at low energy and here the validity
* of cross-sections limits the validity of the fits.
*
* give energy limits for validity of fits:
* minimum energy = 0.01 Rydbergs (about 1580K)
*
        Tmin = 0.01
*
* 1s - 2s,2p maximum energy = 4 Rydbergs (~ 632,000K)
*
        Tmax1 = 4.0
*
* 1s - 3 max energy is 1.2667 Rydberg (200,000K)
*
        Tmax2 = 1.2667
*
* 2s,p - 3 max energy is 1.0 Rydberg (158,888K)
*
        Tmax3 = 1.0
*
**********************************************************
* initialize cs
        cs = 0.
*
**************fits begin here**************
*
       if( i .eq. 1 .and. j .eq. 2 ) then
*
* check temperature:
*
       if(T .gt. Tmax1) then
         T = Tmax1
       else if (T .lt. Tmin) then
         T = Tmin
       endif
*
* 1s - 2s
         b(1) = 2.5501041e-01
         b(2) = 9.973588e-02
         b(3) = -5.404749e-02
         b(4) = 2.520311e-02
         b(5) = -4.05306e-03
         b(6) = 3.508995e-02
         b(7) = 28.056
         b(8) = 7.2945
*
         cs = 0.
         do k = 1, 5
           cs = cs + b(k)*T**(k-1)
         end do
*
         cs = cs + b(6)*alog(b(7)*T)*exp(-b(8)*T)
*
       else if ( i .eq. 1 .and. j .eq. 3 ) then
*
* check temperature:
*
       if(T .gt. Tmax1) then
         T = Tmax1
       else if (T .lt. Tmin) then
         T = Tmin
       endif
*
* 1s - 2p
         b(1) = 3.6105477e-01
         b(2) = 1.73103797
         b(3) = 3.7297254e-01
         b(4) = -4.3240114e-01
         b(5) = 1.4296095e-01
         b(6) = -1.670572e-02
*
         cs = 0.
         do k = 1, 6
           cs = cs + b(k)*T**(k-1)
         end do
*
       else if ( i .eq. 1 .and. j .eq. 4 ) then
*
* check temperature:
 
       if(T .gt. Tmax2) then
         T = Tmax2
       else if (T .lt. Tmin) then
         T = Tmin
       endif
*
* 1s - 3s
         b(1) = 6.461453e-02
         b(2) = -1.1160826e-01
         b(3) = 7.6957269e-01
         b(4) = -2.18918875
         b(5) = 3.14216481
         b(6) = -2.23498961
         b(7) = 6.2651998e-01
         b(8) = 1.12515e-02
         b(9) = 28.056
         b(10) = 7.2945
*
         cs3s = 0.
         do k = 1, 7
           cs3s = cs3s + b(k)*T**(k-1)
         end do
*
         cs3s = cs3s + b(8)*alog(b(9)*T)*exp(-b(10)*T)
*
* 1s - 3p
         b(1) = 9.895325e-02
         b(2) = 2.3240113e-01
         b(3) = 2.0112555e-01
         b(4) = 8.7813331e-01
         b(5) = -3.34239518
         b(6) = 3.7075526
         b(7) = -1.37320827
*
         cs3p = 0.
         do k = 1, 7
           cs3p = cs3p + b(k)*T**(k-1)
         end do
*
* 1s - 3d
         b(1) = 5.742134e-02
         b(2) = -6.09531e-03
         b(3) = 9.3848281e-01
         b(4) = -3.40393911
         b(5) = 5.50742903
         b(6) = -4.25196238
         b(7) = 1.2687104
         b(8) = 7.24136e-03
         b(9) = 28.056
         b(10) = 7.2945
*
         cs3d = 0.
         do k = 1, 7
           cs3d = cs3d + b(k)*T**(k-1)
         end do
*
         cs3d = cs3d + b(8)*alog(b(9)*T)*exp(-b(10)*T)
 
* Summed cs: 1s - 3
         cs = cs3s + cs3p + cs3d
*
       else if (i .eq. 2 .and. j .eq. 4) then
*
* check temperature:
*
       if(T .gt. Tmax3) then
         T = Tmax3
       else if (T .lt. Tmin) then
         T = Tmin
       endif
*
* 2s - 3s
         b(1) = 1.2168
         b(2) = 4.7349
         b(3) = 6.5942
         b(4) = -14.9419
         b(5) = 10.7255
         b(6) = -3.3407
         b(7) = 0.3823
*
         cs3s = 0.
         do k = 1, 7
           cs3s = cs3s+ b(k)*T**(k-1)
         end do
*
* 2s - 3p
         b(1) = 1.9985
         b(2) = 13.2632
         b(3) = 11.9120
         b(4) = -13.0364
         b(5) = 5.6720
         b(6) = -1.2155
         b(7) = 0.1034
*
         cs3p = 0.
         do k = 1, 7
           cs3p = cs3p + b(k)*T**(k-1)
         end do
*
* 2s - 3d
         b(1) = 0.9382
         b(2) = 32.8948
         b(3) = -17.9286
         b(4) = -0.8772
         b(5) = 5.8667
         b(6) = -2.4439
         b(7) = 0.3147
*
         cs3d = 0.
         do k = 1, 7
           cs3d = cs3d + b(k)*T**(k-1)
         end do
*
* Summed cs: 2s - 3
         cs = cs3s + cs3p + cs3d
*
       else if (i .eq. 3 .and. j .eq. 4) then
*
* check temperature:
*
       if(T .gt. Tmax3) then
         T = Tmax3
       else if (T .lt. Tmin) then
         T = Tmin
       endif
*
* 2p - 3s
         b(1) = 2.0097
         b(2) = 3.7515
         b(3) = -7.9734
         b(4) = 10.9359
         b(5) = -7.1074
         b(6) = 2.1359
         b(7) = -0.2405
*
         cs3s = 0.
         do k = 1, 7
           cs3s = cs3s + b(k)*T**(k-1)
         end do
*
* 2p - 3p
         b(1) = 6.5316
         b(2) = 26.8258
         b(3) = -18.2834
         b(4) = 2.22
         b(5) = 4.1958
         b(6) = -2.0916
         b(7) = 0.289
*
         cs3p = 0.
         do k = 1, 7
           cs3p = cs3p + b(k)*T**(k-1)
         end do
*
* 2p - 3d
         b(1) = 8.9833
         b(2) = 126.0513
         b(3) = -21.9017
         b(4) = 20.7445
         b(5) = -20.3788
         b(6) = 7.3643
         b(7) = -0.9082
*
         cs3d = 0.
         do k = 1, 7
           cs3d = cs3d + b(k)*T**(k-1)
         end do
*
* Summed cs: 2p - 3
         cs = cs3s + cs3p + cs3d
*
       else
         write(qq,*) '  insane levels for H I n=1,2,3 !!!'
         stop
       endif
*
      end
******************************************************************************
      subroutine hatom( chCard )
      implicit none
*parse information from the hydrogen command line
      character chCard*80
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real DampOnFac
*usually 1, set to 0 with hydrogen damping off command, scales rayleigh scat
      common/dampon/ DampOnFac
      character chMatrix*7
      common/TypMatrx/ chMatrix
      logical lgPhysOK
*flag set if a physical condition has been disabled
      common/physok/ lgPhysOK
      character*4 chRedis
      common/redis/ chRedis
      real HColOn
*     normally is unity, set to zero when hydrogen collisions turned off
      common/hydata/ HColOn
      integer nHTopOff
      character chHTopType*4
      common/HTopOff/ nHTopOff , chHTopType
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      logical lgMatch , lgEOL , lgTopSet
      save lgTopSet
      integer i
      real fread
      data lgTopSet/.false./
*
      if( lgMatch('COLL',chCard) ) then
*       option to turn hydrogen collisions off
        if( lgMatch(' OFF',chCard) ) then
          HColOn = 0.
          lgPhysOK = .false.
        endif
*
      else if( lgMatch('DAMP' , chCard ) ) then
*       turn off absorption due to lyalpha damping wings
        DampOnFac = 0.
*
      else if( lgMatch( 'LEVE',chCard)) then
*       number of levels for hydrogen at, 2s is this plus one
        i = 5
        nhlvl = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
*         must be a number, or key maximum
*         if no number but MAXIMUM or LIMIT then set to parameter set
          if( lgMatch( 'MAXI',chCard).or.lgMatch( 'LIMI',chCard)) then
            nhlvl = lmhlvl
          else
*           punch out if no number
            call NoNumb(chCard)
          endif
        endif
        if( nhlvl.lt.4 ) then
          write(qq,'('' This would be too few levels.'')')
          stop
        else if( nhlvl.gt.lmhlvl ) then
          write(qq,'('' This would be too many levels.'')')
          write(qq,'('' The limit is set by LMHLVL='',i3)')lmhlvl
          stop
        endif
       if( .not. lgTopSet ) then
*        user did not set top off levels
         nHTopOff = nhlvl - 5
       endif
        if( nhlvl.lt.nHTopOff ) then
          write(qq,'('' Not possible to set nhlvl to less than '',
     1   ''top off='',i4)') nHTopOff
         stop
        endif
*
      else if( lgMatch( 'LOWE',chCard)) then
*       set lowest temp for departure coef
        i = 5
        thlo = fread( chCard , i , 76 , lgEOL )
        if( thlo.le.10. ) thlo = 10.**thlo
*
      else if( lgMatch( 'MATR',chCard)) then
*       which matrix inversion routine to use
        if( lgMatch( 'MATI',chCard)) then
*         this is matin1, the default
          chMatrix = 'matin1 '
        else if( lgMatch( 'LINP',chCard)) then
          chMatrix = 'linpack'
        else if( lgMatch( 'VECL',chCard)) then
          chMatrix = 'veclib '
        else
          write(qq,'('' The matrix inversion routines I know about'',
     1    '' are LINPACK, VECLIB, and MATIN1.'')')
          stop
        endif
*
      else if( lgMatch('REDI',chCard) ) then
*       set redistribution function either wind, incompl (default), or compl
        if( lgMatch(' COM',chCard) ) then
*         complete redistribution for la and all others
          chRedis = 'COMP'
        else if( lgMatch('INCO',chCard) ) then
*         incomplete redistribution for all resonance lines
          chRedis = 'INCO'
        else
          write(qq,'('' MUST be either COMPLETE or INCOMPL'')')
          stop
        endif
*
      else if( lgMatch('TOPO',chCard) ) then
*       set lowest level for hydrogen atom top off
        i = 5
        nHTopOff = fread( chCard , i , 76 , lgEOL )
        if( nHTopOff.gt.nhlvl ) then
          write(qq,'('' Not possible to set nHTopOff to more than '',
     1    ''nhlvl='',i4)') nhlvl
          stop
        endif
        lgTopSet = .true.
        if( lgEOL ) call NoNumb(chCard)
        if( lgMatch( ' ADD',chCard)) then
*         add extra part
          chHTopType = ' add'
        else if( lgMatch( 'SCAL',chCard)) then
*         use scale factors
          chHTopType = 'scal'
        else
*         this is the default
          chHTopType = 'scal'
        endif
*
      else
        write(qq,'('' There should have been a keyword - STOP'')')
        stop
      endif
*
      end
******************************************************************************
      real function hbf(x,n,z)
      integer n
      real x , z
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     calculates photoionisation cross sections for hydrogenic ions
*     routine obtained from Anil Pradhan, Nov 90
*
*     Z=nuclear charge
*     W=photon energy, W0=threshold photon energy
*     X=log10(W/W0)
*     N=principal quantum number
*     HBF=cross section in cm**(-2)
*
      real a(10),b(10),c(10),d(10),e(10),f(10)
      data a/
     +  -17.2004,-16.8584,-16.6670,-16.5339,-16.4319,-16.3491,
     +  -16.2795,-16.2194,-16.1666,-16.1195/
      data b/
     +   -2.6671, -2.8068, -2.8549, -2.8812, -2.8983, -2.9103,
     +   -2.9193, -2.9264, -2.9321, -2.9369/
      data c/
     +   -0.3228, -0.1323, -0.0931, -0.0735, -0.0612, -0.0527,
     +   -0.0465, -0.0418, -0.0380, -0.0350/
      data d/
     +    0.0608,  0.0224,  0.0224,  0.0204,  0.0181,  0.0163,
     +    0.0147,  0.0135,  0.0125,  0.0117/
      data e/
     +  -16.9991,-16.7709,-16.6188,-16.5012,-16.4069,-16.3289,
     +  -16.2624,-16.2046,-16.1536,-16.1078/
      data f/
     +   -3.1304, -3.0041, -2.9738, -2.9671, -2.9662, -2.9669,
     +   -2.9681, -2.9694, -2.9707, -2.9719/
*
      if( n.gt.10 .or. n.lt.1 ) then
        write(qq,'('' Quantum number'',I4,'' out of range of HBF.'')')
     1  n
        stop
      endif
*
      if(x.le.1.)then
        hbf=a(n)+x*(b(n)+x*(c(n)+x*d(n)))
      else
        hbf=e(n)+x*f(n)
      endif
*
*     the following two lines were out of order, swapped; yy 26-08-88
      hbf=10.**hbf
      hbf=hbf/(z**2)
*
      end
******************************************************************************
      real function hclf(n)
      implicit none
*hydrogen recombination cooling
      integer n
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real telogn
      common/telogn/ telogn(7)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real x,fac
*     real eps,e1
*
      real a(15),b(15),c(15),d(15),e(15),f(15),g(15),h(15),i(15)
*
      data a/-26.6446988, -26.9066506, -27.0619832, -27.1826903,
     1-27.2783527, -27.3595949, -27.569406, -27.611159, -27.654748,
     2 -27.70479, -27.745398, -27.776126, -27.807261, -27.833093,
     3 -27.866134/
*
      data b/ -0.40511045, -0.41644707, -0.45834359, -0.49137946,
     1-0.51931762, -0.54971231, -0.18555807, -0.29204736,
     2 -0.36741085, -0.45843009, -0.49753713, -0.51418739,
     3 -0.52287028, -0.52445456, -0.52292803/
*
      data c/ 11.29232731, 11.71035693, 12.89309608, 13.85569087,
     1 14.67354775, 15.56090323, 6.147461, 9.0304953, 11.094731,
     2 13.630431, 14.721959, 15.172335, 15.413946, 15.458123,
     3 15.428761/
*
      data d/ .067257375, .07638384, .089925637, .102252192, .111016071,
     1 .119518918, 0.0093832482, 0.028119606, 0.039357697, 0.050378417,
     2 0.051644049, 0.051367182, 0.04938724, 0.050139066, 0.043085968/
*
      data e/ -1.99108378, -2.26898352, -2.65163846, -3.02333001,
     1 -3.29462338, -3.56633674,-1.0019228, -1.5128672, -1.8327058,
     2 -2.1866371, -2.2286257, -2.1932699, -2.1205891, -2.1317169,
     3 -1.9175186/
*
      data f/ -0.0050802618, -0.005849291, -0.0074854405, -0.0085677543,
     1-0.0093067267, -0.0098455637, 0.040903604, 0.037491802,
     2 0.035618861, 0.034132954, 0.032418252, 0.02947883, 0.027393564,
     3 0.027607009, 0.02433868/
*
      data g/ .166267838, .196780541, .242675042, .282237211,.310204623,
     1.335160025, -0.81087376, -0.73435108, -0.69164333, -0.64907209,
     2 -0.61216299, -0.55239109, -0.51048669, -0.51963194,
     3 -0.4504203/
*
      data h/ .00020528663, .00027588492, .00033980652, .00041445515,
     1.00046423276, .0005121808, -0.0011986559, -0.0011333973,
     2 -0.0010992935, -0.0010878727, -0.0010412678, -0.00095539899,
     3 -0.00089141547, -0.00089294364, -0.00079179756/
*
      data i/ -0.0071357493, -0.0099630604, -0.01178647, -0.014696455,
     1-0.01670318, -0.01887373, 0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0./
*
      if( n.lt.1 ) then
        write(qq,'('' HCLF called with invalid prin quant number='',
     1  i4)') n
        stop
      endif
*
      if(n.gt.15) then
*       accounts for decreasing efficiency high up
*       fac is 0.38 at n=15, and 0.32 at 25
        fac = 0.219 + (2.58 - 2.586/float(n)) /float(n)
        hclf = hrec(n,1) * te * Boltzmann * fac
        return
      endif
*
      x = telogn(1)
      if( x.lt.0.2 .or. x.gt.10. ) then
         write(qq,'('' HCLF called with invalid temperature='',
     1   1p,e10.2)') te
         stop
      endif
*
      fac =
     1 (a(n)+c(n)*telogn(1) + e(n)*telogn(2) + g(n)*telogn(3) +
     2 i(n)*telogn(4) ) /
     3 (1.+ b(n)*telogn(1) + d(n)*telogn(2) + f(n)*telogn(3) +
     4 h(n)*telogn(4) )
*
      hclf = (10.**fac)
*
      end
******************************************************************************
      subroutine hcolst
      implicit none
*evaluate collision rate for model hydrogen atom
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      logical lgC2psOn
*are collisions between 2s and 2p enabled?
      common/c2pson/ lgC2psOn
      logical lgCasBhs
      common/casbhs/ lgCasBhs
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision hlbolt , hcbolt
*     hlbolt(low,up) line boltzmann factors for hydrogen atom
*     hcbolt(n) excit to continuum
      common/hlvcol/ hlbolt(lmhlvl-1,lmhlvl+1) , hcbolt(lmhlvl+1)
      real HColOn
*     normally is unity, set to zero when hydrogen collisions turned off
      common/hydata/ HColOn
      real hcoldn , hbul , hradn
*save collision, induced, and spontaneous rates for levels from hydroen atom
      common/hcbr/ hcoldn(lmhlvl+1) , hbul(lmhlvl+1) , hradn(lmhlvl+1)
      double precision hlte
      real hc2p2se , hc2p2sp , hc2s1s
*hc2p2se and hc2p2sp are rates for 2s - 2s collisions with electrons and protons
*hlte is lte population of each level
      common/hcolrt/ hlte(lmhlvl+1) , hc2p2se , hc2p2sp , hc2s1s
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
*     energy differences for model hydrogen atom:
*     this is array of temperatures, first between levels, sec lev to cont
*     HdeltaT( upper , lower )
      real HdeltaTe, HCionTe
      common/HdeltaT/ HdeltaTe(lmhlvl,lmhlvl), HCionTe(lmhlvl)
      logical lgHlteOk
*true is all lte populations positive for H atom
      common/HlteOk/ lgHlteOk
*
*     local variables
      integer level , lower , upper
      integer i,n,ilow,ihigh,iup,j
      real smeets,cs12s,cs12p,hsfac,hdexct,sum,
     1 told,f , cs2s,cs2p , cs
*
*     free statement labels, >=10
*
      data told/0./
*
*     define boltz facs between adjacent levels
      do iup=2,nhlvl
*       HdeltaTe is array of line temps, upper to lower
*       their boltzmann factors for this temp
        hlbolt(iup-1,iup) = exp(-dble(HdeltaTe(iup,iup-1)/te))
      end do
*     this is 1s-2s collision
      hlbolt(1,nhlvl+1) = hlbolt(1,2)
*
*     the highest level, up to the continuum
      hcbolt(nhlvl) = exp( -dble(HCionTe(nhlvl)/te) )
*
*     define remaining Boltzmann factors
      do j=1,nhlvl-2
        do i=j+2,nhlvl
          hlbolt(j,i) = hlbolt(j,i-1) * hlbolt(i-1,i)
        end do
      end do
      do i=1,nhlvl-1
        hcbolt(i) = hlbolt(i,nhlvl) * hcbolt(nhlvl)
      end do
*     2S to continuum
      hcbolt(nhlvl+1) = hcbolt(2)
*
*-------------------------------------------------------------
*
*     following factor is actually 4.14158E-16, but e- stat weight is in
      f = 2.0708e-16 / te32
      do i=1,nhlvl+1
        if( hcbolt(i).gt.1d-100 ) then
          hlte(i) = hstat(i) /  hcbolt(i) * f
        else
          hlte(i) = 0.
        endif
      end do
*
*     define HLTE(I) = lte population (cm^3) / Ne Np
*     only used in HLEVEL if Te>2500K, default value of THLO
      if( te.ge.thlo ) then
*       also 2s, thie n+1 level
*       induced recombination rate
        do i=1,nhlvl+1
*         induced recombination rate
          rinduc(i) = finduc(i) * hlte(i)
*         coooing due to induced recombination
          cinduc(i) = cind(i) * hlte(i)
        end do
      else
        do i=1,nhlvl+1
          cinduc(i) = 0.
          rinduc(i) = 0.
        end do
      endif
*
*     now check for any zeros - if present then matrix cannot be used
      lgHlteOk = .true.
      do i=1,nhlvl+1
        if( hlte(i).le.0. ) lgHlteOk = .false.
      end do
*
*-----------------------------------------------------------------------
*     evaluate all needed collisional and rad rates
*     Johnson data set chosen, HD = 0.5,
*     Vriems+Smeet data HD=1
*     collisions turned off, both =0.
*----------------------------------------------------------------------
*
*     collisional ionization, used for three body recombination
*     Vriens and Smeets collisional ionization data set
      do i=2,nhlvl
*       HColOn is option to turn off collisions, "hydrogen collis off" comnd
        hcolnc(i) = smeets(i) * HColOn
      end do
*     call colfit(1,1,0,te,hcolnc(1) )
*     >>chng 97 mar 19, to new data set
      call cfit(1,1,te,hcolnc(1) )
      hcolnc(1) = hcolnc(1) * HColOn
      hcolnc(nhlvl+1) = hcolnc(2) * HColOn
      if( lgCasBhs ) then
        hcolnc(1) = 0.
        hcolnc(2) = 0.
        hcolnc(nhlvl+1) = 0.
      endif
*
*     don't reevaluate downward coll if dT/T not large
      if( abs(te-told)/te .lt.0.002 .and.hcol(2,1).gt.0. ) then
        if( lgTrace ) write(qq,'(7X,''HCOLST called-no reval Cul'')')
*       (but still eval col below)
      else
        if( lgTrace ) write(qq,'(7X,''HCOLST called-will reeval Cul'')')
        told = te
*
        if ( lgC2psOn ) then
*         from Osterbrock's book, fit to 10,000K - 20,000K
*         >>chng 97 aug 5, broke electrons and protons apart using DEO's book
          hc2p2se = 5.738e-4 / ( te20*te20/te03 )
          hc2p2sp = 6.290e-4 /(te10*te05)
        else
          hc2p2se = 0.
          hc2p2sp = 0.
        endif
*
*       option to turn off  collisions frrom ground and n=2
        if( lgCasBhs .or. (HColOn.eq.0.) ) then
          hsfac = 0.
        else
          hsfac = 1.
        endif
*
*       new code via Kirk
        call h1cs123(1,2,te,cs12s)
        call h1cs123(1,3,te,cs12p)
*
*       C1N is deexcitation rate
*       following is 2P - 1S only
        hcol(2,1) = cs12p / sqrte * 8.629e-6 / 6. * hsfac
*       following is 2S - 1S only
        hc2s1s = cs12s / sqrte * 8.629e-6 / 2. * hsfac
*
*       hcol(u,l) is de-excitation rate from u to l
        call h1cs123(1,4,te,cs)
        hcol(3,1) = cs * hsfac * 8.629e-6/sqrte/18.
*       hcol2n(i) is rate from i to both 2s and 2p
        call h1cs123(2,4,te,cs2s)
        call h1cs123(3,4,te,cs2p)
        hcol(3,2) = (cs2s+cs2p) * hsfac * 8.629e-6/sqrte/18.
*
        do ihigh=4,nhlvl
          do ilow=1,ihigh-1
*           fill in with vriens and smeets data for collisional deexcitation
            hcol(ihigh,ilow) = hdexct(ihigh,ilow) * HColOn
          end do
        end do
*
*       case b hs does not include any collisions from n=1 or 2
        if( lgCasBhs ) then
          do ilow=1,2
*           do ihigh=ilow+1,nhlvl
*           >>chng 96 apr 25, for neg lev pops
            do ihigh=3,nhlvl
              hcol(ihigh,ilow) = 0.
            end do
          end do
        endif
*
        if( lgTrace.and.lgHBugFull) then
           write(qq,'(7X,''HCOLST rate n->n-1:'',1P,8E10.3,'' 2S1'',
     1     e9.2)') (hcol(i+1,i),i=1,8),hc2s1s
           write(qq,'(7X,''HCOLST col ion cof:'',1P,10E10.3)')
     1     (hcolnc(i),i=1,nhlvl+1)
           write(qq,'(7X,''HCOLST rate down 1:'',1P,9E10.3)')
     1     (hcol(i,1),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 2:'',1P,9E10.3)')
     1     (hcol(i,2),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 3:'',1P,9E10.3)')
     1     (hcol(i,3),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 4:'',1P,9E10.3)')
     1     (hcol(i,4),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 5:'',1P,9E10.3)')
     1     (hcol(i,5),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 6:'',1P,9E10.3)')
     1     (hcol(i,6),i=1,nhlvl)
           write(qq,'(7X,''HCOLST rate down 7:'',1P,9E10.3)')
     1     (hcol(i,7),i=1,nhlvl)
           write(qq,'(7X,''HCOLST boltz fac c:'',1P,9E10.3,''2s'',
     1     e9.3)') (hcbolt(i),i=1,nhlvl+1)
           write(qq,'(7X,''Induce rec cooling:'',1P,9E10.3)')
     1     (cinduc(i),i=1,nhlvl)
           write(qq,'(7X,''HCOLST HLTE(i):    '',1P,10E10.3)')
     1     (hlte(i),i=1,nhlvl+1)
           write(qq,'(7X,''HCOLST       C2P2S='',1P,2E10.3)')
     1     hc2p2se+hc2p2sp
        endif
      endif
*
      if( hlte(1).gt.0. ) then
*
        hcoldn(1) = (hc2s1s*hlte(nhlvl+1) + hcol(2,1)*hlte(2))/hlte(1)
        do upper=3,nhlvl
          hcoldn(1) = hcoldn(1) + hcol(upper,1) * hlte(upper)/hlte(1)
        end do
        sum = 0.
*       logic for stat weights rechecked 95 nov 9
        do upper=3,nhlvl
          sum = sum + hcol(upper,2) * hlte(upper) /
     1    ( hlte(2) + hlte(nhlvl+1) )
        end do
        hcoldn(2) = sum + hcol(2,1)
        hcoldn(nhlvl+1) = sum + hc2s1s
        do level=3,nhlvl
          hcoldn(level) = 0.
          do lower=1,level-1
            hcoldn(level) = hcoldn(level) + hcol(level,lower)
          end do
          do upper=level+1,nhlvl
            hcoldn(level) = hcoldn(level) +
     1      hcol(upper,level)* hlte(upper)/hlte(level)
          end do
        end do
*
        if( lgTrace.and.lgHBugFull) then
           write(qq,'(7X,''HCOLST hcoldn(i)      '',1P,10E10.3)')
     1     (hcoldn(i),i=1,nhlvl+1)
        endif
      else
        do n=1,nhlvl+1
          hcoldn(n) = 0.
        end do
      endif
*
      end
******************************************************************************
      real function HCTIon(ion,nelem)
      implicit none
*H charge transfer ionization, using Jim Kingdon's ctdata.for
      integer ion , nelem
*     ion is stage of ionization, 1 for atom
*     nelem is atomic number of element, 2 up to 30
      integer limelm
      parameter (limelm=30)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real CTIon
      common/CTIon/ CTIon(7,4,limelm)
*
*     local variables
      real tused
      integer ipIon
*
      ipIon = ion
*
*being sanity check
      if( CTIon(1,1,3).le.0. ) then
        write(qq,'('' Non-positive coefficient for charge trnasfer.'')')
        write(qq,'('' Was block data ctdata linked in?'')')
        call insane
        stop
      endif
*end sanity check
*
*     return zero for highly ionized species
      if( ion.ge.4 ) then
        HCTIon = 0.
        return
      endif
*
*begin sanity checks
      if( ipIon.lt.1 .or. ipIon.gt.nelem ) then
        write(qq,'('' HTRecom called with insane ion stage'',2i4)')ion,
     1  nelem
        stop
      endif
      if( nelem.lt.2 .or. nelem.gt. limelm )  then
        write(qq,'('' HTRecom called with insane atomic number'',2i4)')
     1  ion, nelem
        stop
      endif
*end sanity checks
*
*     may be no entry, first coefficient is zero in this case
      if( CTIon(1,ipIon,nelem) .le.0. ) then
        HCTIon = 0.
        return
      endif
*
*     Make sure te is between temp. boundaries; set constant outside of range
      tused = max( te,CTIon(5,ipIon,nelem) )
      tused = min( tused , CTIon(6,ipIon,nelem) )
      tused = tused * 1e-4
*
*     the interpolation equation
      HCTIon = CTIon(1,ipIon,nelem)* 1e-9 *
     1 (tused**CTIon(2,ipIon,nelem)) *
     2 (1. +
     3 CTIon(3,ipIon,nelem) * exp(CTIon(4,ipIon,nelem)*tused) ) *
     4 exp(-CTIon(7,ipIon,nelem)/tused)
*
      end
******************************************************************************
      real function HCTRecom(ion,nelem)
      implicit none
*H charge transfer recombination using Jim Kingdon's block ctdata.for
*     ion is stage of ionization, 1 for rec to atom
*     nelem is atomic number of element, 2 up to limelm
      integer ion , nelem
      integer limelm
      parameter (limelm=30)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real HCTAlex
*Dalgarno H charge transfer rate coef for high stages of ionization
*default is 8.5e-10 in zero, reset with 'set charge transfer' command
      common/HCTMin/ HCTAlex
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      real CTRecomb
*     second dimension is ionization stage,
*     1=+1 for parent, etc
*     third dimension is atomic weight of atom
      common/CTRecomb/ CTRecomb(6,4,limelm)
*
*     local variables
      real tused , sexp
      integer ipIon
*
*     subtract 1 since atom can't happen, is not in block data
      ipIon = ion
*
*begin sanity check
      if( CTRecomb(1,1,2).le.0. ) then
        write(qq,'('' Insane value in CTRecomb array.'')')
        write(qq,'('' Was block data ctdata lined in?'')')
        stop
      endif
*end sanity check
*
*     use Dalgarno estimate for highly ionized species, number reset with
*     set charge transfer command
      if( ipIon.gt.4 ) then
*       >>chng 96 nov 25, added this option, default is 1.92e-9
*       Dalgarno's charge transfer
        HCTRecom = HCTAlex * ipIon
        return
      endif
*
*begin sanity checks
      if( ipIon.lt.1 .or. ipIon.gt. nelem ) then
        write(qq,'('' HCTRecom called with insane ion stage'',2i4)')ion,
     1  nelem
        stop
      endif
      if( nelem.lt.2 .or. nelem.gt. limelm )  then
        write(qq,'('' HCTRecom called with insane atomic number'',2i4)')
     1  ion, nelem
        stop
      endif
*end sanity checks
      tused = max( te,CTRecomb(5,ipIon,nelem) )
      tused = min( tused , CTRecomb(6,ipIon,nelem) )
      tused = tused * 1e-4
      if( tused.eq.0. ) then
        HCTRecom = 0.
        return
      endif
*
*     the interpolation equation
      HCTRecom = CTRecomb(1,ipIon,nelem)* 1e-9 *
     1 (tused**CTRecomb(2,ipIon,nelem)) *
     2 (1. +
     3 CTRecomb(3,ipIon,nelem) * sexp(- CTRecomb(4,ipIon,nelem)*tused) )
*     in sexp negative sign not typo - there are negative signs already
*     in coefficient, and sexp has implicit negative sign
*
      end
******************************************************************************
      real function hdexct(ihigh,ilow)
      implicit none
*compute Vriens Smeets collisional deexcitation for H
      integer ihigh,ilow
      real te , eden , hden
      common/phycon/ te , eden , hden
*
*     local variables
      real p,n,s,tev,ryd,enp,eni,fosc,delta,bnp,anp,gamma,rate,bn
*
*     function written by Jason Ferguson to compute the Vriens and Smeets
*     rate coeff. for collisional dexcitation between any two levels of H.
*     valid for all ihigh, ilow
*
      p=float(ihigh)
      n=float(ilow)
      tev = 8.61716e-5 * te
      ryd = 13.60583
      s = abs(p - n)
      enp = -1./p/p + 1./n/n
      eni =  1./n/n
      anp = 2. / enp * fosc(n,p)
      bn = 1.4*alog(n)/n - .7/n - .51/n/n + 1.16/n/n/n - 0.55/n/n/n/n
      bnp = 4./p/p/p * (1./enp/enp + 4./3.*eni/enp**3
     1     + bn*eni*eni/enp**4)
      delta = exp(-bnp/anp) + 0.06*s*s/p/n/n
      gamma = ryd*alog(1. + n**3 * tev/ryd) * (3. + 11.*(s/n)**2) /
     1  (6. + 1.6*p*s + .3/s/s + 0.8*(p**1.5)/(s**.5)*abs(s-0.6))
      rate = (1.6e-7)*sqrt(tev)*n*n/p/p/(tev + gamma) *
     1  (anp*alog(0.3*tev/ryd + delta) + bnp)
      hdexct = rate
*
      end
******************************************************************************
      subroutine hdread( chCard )
      implicit none
*parse the hden command
      character chCard*80
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      real te , eden , hden
      common/phycon/ te , eden , hden
      real DensityPower , rscale , den0
*parameters dealing with hydrogen density scaling as
*power of radius
*DensityPower is power
      common/denpow/ DensityPower , rscale , den0
      integer nvary , nparm
      common/nvary/ nvary , nparm
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real fread
      logical lgEOL , lgMatch
*
*     log of hydrogen density
      i = 5
      hden = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        if(lgTalk)write(qq,
     1  '('' log(n) MUST be entered with this command. STOP'')')
        stop
      endif
*
*     check for further options
      if( lgMatch('LINE',chCard) ) then
*       linear option
        if( hden.le.0. ) then
          write(qq,'('' A negative density is not physical.'')')
          stop
        else
          hden = log10( hden )
        endif
      endif
*
*     check if exponent entered
      DensityPower = fread( chCard , i , 76 , lgEOL )
      den0 = 10.**hden
      if( .not.lgEOL ) then
*        not constant density
*        some sort of power law density distribution
         if( lgMatch('COLU',chCard) ) then
*           density will depend on column density to a power
*           number entered is col den, convert to scale radius
*           at this point HDEN is log10 of hydrogen density
            rscale = 10.**fread( chCard , i , 76 , lgEOL )
            if( lgEOL ) then
               write(qq,'('' The column density MUST be set if the'',
     1         '' col den option is to be used.'')')
               stop
            endif
            chCPres = 'POWC'
         else if( lgMatch('DEPT',chCard) ) then
*           depth option, sets scale radius, log cm
            rscale = 10.**fread( chCard , i , 76 , lgEOL )
            if( lgEOL ) then
               write(qq,'('' The scale depth MUST be set if the'',
     1         '' depth option is to be used.'')')
               stop
            endif
            chCPres = 'POWD'
         else
*           radius option, will be relative to inner radius
            chCPres = 'POWR'
         endif
      endif
*     vary option
      if( lgVarOn ) then
         nparm = nparm + 1
*        pointer to where to write
         nvfpnt(nparm) = nRead
         vparm(nparm,1) = hden
         vincr(nparm) = 1.
         if( chCPres.eq.'CDEN' .or.chCPres.eq.'CPRE' ) then
            chVarFmt(nparm) = '(''HDEN='',F9.5)'
            nvarxt(nparm) = 1
         else if( chCPres.eq.'POWR' ) then
            chVarFmt(nparm) = '(''HDEN='',F9.5,'' power='',F9.5)'
            vparm(nparm,2) = DensityPower
            nvarxt(nparm) = 2
         else if( chCPres.eq.'POWC' ) then
            chVarFmt(nparm) =
     1      '(''HDEN='',F9.5,'' power='',F9.5,'' column='',F9.5)'
            nvarxt(nparm) = 3
            vparm(nparm,2) = DensityPower
            vparm(nparm,3) = log10( rscale )
         else if( chCPres.eq.'POWD' ) then
            chVarFmt(nparm) =
     1      '(''HDEN='',F9.5,'' power='',F9.5,'' depth='',F9.5)'
            nvarxt(nparm) = 3
            vparm(nparm,2) = DensityPower
            vparm(nparm,3) = log10( rscale )
         else
            write(qq,'('' Internal error in HDEN'')')
            stop
         endif
      endif
*
      end
******************************************************************************
      subroutine he1col
      implicit none
*evaluate collisional rates for helium singlets
      real WavNKelv
*     conversion factor from wavenumbers to degrees kelvin
      parameter (WavNKelv=1.43883)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      logical lgHeClON
*flag saying whether he collisions are turned on
*set false with helium collisions off command
      common/heclon/ lgHeClON
      logical lgC2psOn
*are collisions between 2s and 2p enabled?
      common/c2pson/ lgC2psOn
      real he1qin,he1rin
      common/he1ind/ he1qin(nhe1lvl+1),he1rin(nhe1lvl+1)
      logical lgCasBhs
      common/casbhs/ lgCasBhs
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision he1bol , he1cbt
      common/he1blt/ he1bol(nhe1lvl-1,nhe1lvl+1) , he1cbt(nhe1lvl+1)
      double precision he1lte
      real he1c2p2s , he1c2s1s
*collision strengths and lte densities for helium singlets
      common/he1crt/ he1c2p2s , he1c2s1s , he1lte(nhe1lvl+1)
      real he1coldn , he1bul , he1radn
*save collision, induced, and spontaneous rates for levels from helium singlet
      common/he1cbr/ he1coldn(nhe1lvl+1) , he1bul(nhe1lvl+1) ,
     1 he1radn(nhe1lvl+1)
      real he1cin
      common/he1cin/ he1cin(10)
      real the1lo
      integer nhe1lo
      common/the1lo/ the1lo , nhe1lo
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
*     energy differences for model he singlet atom:
*     this is array of temperatures, first between levels, sec lev to cont
*     He1deltaT( upper , lower )
      real He1deltaTe, He1CionTe
      common/He1deltaT/ He1deltaTe(nhe1lvl,nhe1lvl), He1CionTe(nhe1lvl)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*
*     free statement labels, >=9
*
      real rcion(9) , r1n(9) , r2n(9)
      integer i , n , iup , j,lo,ihi
      real told,hd,tsq,t3,cs12s,cs12p,hsfac,sum ,f,hdexct
*
      data
     2  rcion / 1.04e-10,8.24e-9 ,1.08e-7 ,6.61e-7, 3.45E-6,
     2 8.06e-6, 9.47e-5, 2.38e-3, 3.36e-1 /
     3,r1n/3*0., 1.05e-8, 3.45e-9, 1.54e-9, 3.23e-10,2.14E-11,7.09E-14/
     4,r2n/2*0.,7.88e-8,1.14e-8,3.10e-9,1.10e-9,2.0e-10,1.0E-11,2.8E-14/
*
      data told/0./
*
*     define boltz facs between adjacent levels
      do iup=2,nhe1lvl
*       He1deltaTe is array of line temps, upper to lower
*       their boltzmann factors for this temp
        he1bol(iup-1,iup) = exp(-dble(He1deltaTe(iup,iup-1)/te))
      end do
*     this is 1s-2s
      he1bol(1,nhe1lvl+1) = he1bol(1,2)
*
*     the highest level, up to the continuum
      he1cbt(nhe1lvl) = exp( -dble(He1CionTe(nhe1lvl)/te) )
*
*     define remaining Boltzmann factors
      do j=1,nhe1lvl-2
        do i=j+2,nhe1lvl
          he1bol(j,i) = he1bol(j,i-1) * he1bol(i-1,i)
        end do
      end do
      do i=1,nhe1lvl-1
        he1cbt(i) = he1bol(i,nhe1lvl) * he1cbt(nhe1lvl)
      end do
      he1cbt(nhe1lvl+1) = he1cbt(2)
*
*-------------------------------------------------------------
*
*     define HE1LTE(I) = lte population (cm^3) / Ne Np
*     only used in HE1LEV if Te>1000K
*     extra div by 2 due to He+ partition function
      f = 2.0708e-16 / te32 / 2.
      do i=1,nhe1lvl
        if( sngl(he1cbt(i)).gt.1d-70 ) then
*         n.b.; on following two, order is VERY imp fror 32 bit machines
          he1lte(i) = (f /  he1cbt(i) ) * he1stat(i)
        else
          he1lte(i) = 0.
        endif
      end do
      he1lte(nhe1lvl+1) = he1lte(2) * he1stat(nhe1lvl+1)  / he1stat(2)
*
*-----------------------------------------------------------------------
*     evaluate all needed collisional and rad rates
*     collisions turned off, HD=0
*----------------------------------------------------------------------
*
      if( lgHeClON ) then
         hd = 1.
      else
         hd = 0.
      endif
*     collisional ionization
*     he1clc(1) = rcion(1) * he1cbt(1)*sqrte*hd
*     call colfit(2,2,0,te,he1clc(1) )
*     >>chng 97 mar 19, to new data set for collisional ionization
      call cfit(2,2,te,he1clc(1) )
      he1clc(1) = he1clc(1) * hd
      he1clc(2) = rcion(2) * he1cbt(2)*te10*te10*te10*te01*te01*hd
      he1clc(3) = rcion(3) * he1cbt(3)*te10*te10*hd
      he1clc(4) = rcion(4) * he1cbt(4)*te10*te01*hd
      he1clc(5) = rcion(5) * he1cbt(5)*te01*hd
      he1clc(6) = rcion(6) * he1cbt(6)/te01/te01*hd
      he1clc(7) = rcion(7) * he1cbt(7)/(te10*te03*te03)*hd
      he1clc(8) = rcion(8) * he1cbt(8)/(te10*te10*te10*te03)*hd
      he1clc(9) = rcion(9) * he1cbt(9)/sqrte*hd
*
*     don't reevaluate downward coll if dT/T not large
*     he2cll is zero on very first call since zeroed in block
      if( abs(te-told)/te .lt.0.002 .and.he1cll(2,1).gt.0.) then
         if( lgTrace.and.lgHeBug)
     1   write(qq,'(7X,''HE1COL called-no reval Cul'')')
*        (but still eval col below)
      else
         if( lgTrace ) then
           write(qq,'(7X,''HE1COL called-will reeval Cul'')')
         end if
         told = te
*
         if ( lgC2psOn ) then
*           from Osterbrock's book, fit to 10,000K - 20,000K
*           >>chng 97 july 25, updated to
*           >>refer Sawey, P.M.J., and Berrington, K.A., 1993, ADNDT 55, 81
            f = min( 26.63, 5.112e-3*te/te10/te01 )
            he1c2p2s = f*8.629e-6 / sqrte / 2.
         else
            he1c2p2s = 0.
         endif
*
         tsq = te  * te
         t3 = tsq * te
*        collision rates for 1-2S, 1-2P, and 1-3 from
*        >>refer Aggarwal, K.M. 1983, MNRAS, 202, 15P
*        >>chng 97 july 25, updated to
*        >>refer Sawey, P.M.J., and Berrington, K.A., 1993, ADNDT 55, 81
*        if( te.le.25000. ) then
*           cs12s = 0.195 + 1.28e-5*te - 4.69e-10*tsq + 6.19e-15*t3
*           cs12p = 0.335 + 1.45e-5*te + 1.39e-10*tsq - 5.66e-15*t3
*
*        else if( te.gt.25000. .and. te.le.5e5 ) then
*           cs12s = 0.308 + 3.58e-7*te + 6.15e-13*tsq - 1.08e-18*t3
*           cs12p = 0.328 + 1.43e-5*te - 6.55e-12*tsq - 2.69e-18*t3
*
*        else if( te.gt.5e5 ) then
*           cs12s = 0.506
*           cs12p = 5.50
*        endif
*        scale factor to agree with
*        >>refer Callaway, J., Unnikrishnan, K., & Oza, D.H. 1987,
*        >>refer Phys Rev A, 36, 2576
*        cs12p = cs12p * 0.88
*
*        >>refer Sawey, P.M.J., and Berrington, K.A., 1993, ADNDT 55, 81
         cs12s = min(0.0425 , 9.055e-3*te10*te05 )
*        write(6,*) ' 1-2s', f, cs12s
*        f = cs12p
         cs12p = min(0.0311 , 4.242e-5*sqrte*te02*te02 )
*        write(6,*) ' 1-2p', f, cs12p
*        stop
*
*        C1N is deexcitation rate
*        following is 2P - 1S only
         he1cll(2,1) = cs12p / sqrte * 8.629e-6 / 6. * hd
*        following is 2S - 1S only
         he1c2s1s = cs12s / sqrte * 8.629e-6 / 2. * hd
*
*        option to turn off  collisions frrom ground and n=2
         if( lgCasBhs .or. (hd.eq.0.) ) then
           hsfac = 0.
         else
           hsfac = 1.
         endif
*
*        HE1CLL(u,l) is de-excitation rate from u to l
*        rate coef from Callaway et al. preprint
         he1cll(3,1) = 1.4e-9 * hsfac
*        rate from i to both 2s and 2p
         he1cll(3,2) = (3.39*te10*te10*te10/te01/te01/te01) / sqrte *
     1   8.629e-6 / 18. * hsfac
*
         do ihi=4,nhe1lvl
            he1cll(ihi,1) = r1n(ihi) / sqrte * hsfac
*           different temp denpendence is not a bug
            he1cll(ihi,2) = r2n(ihi) * hsfac
            do lo=3,ihi-1
              he1cll(ihi,lo) = hdexct(ihi,lo) * hd
            end do
         end do
*
*
         if( lgTrace.and.lgHe1Bug ) then
            write(qq,'(7X,''HE1COL rate n->n-1:'',1P,8E10.3,'' 2S1'',
     1      e9.2)') (he1cll(i+1,i),i=1,8),he1c2s1s
            write(qq,'(7X,''HE1COL col ion cof:'',1P,9E10.3)') he1clc
            write(qq,'(7X,''HE1COL rate down 1:'',1P,9E10.3)')
     1      (he1cll(i,1),i=1,9)
            write(qq,'(7X,''HE1COL rate down 2:'',1P,9E10.3)')
     1      (he1cll(i,2),i=1,9)
            write(qq,'(7X,''HE1COL rate down 3:'',1P,9E10.3)')
     1      (he1cll(i,3),i=1,9)
            write(qq,'(7X,''HE1COL rate down 4:'',1P,9E10.3)')
     1      (he1cll(i,4),i=1,9)
            write(qq,'(7X,''HE1COL rate down 5:'',1P,9E10.3)')
     1      (he1cll(i,5),i=1,9)
            write(qq,'(7X,''HE1COL boltz fac c:'',1P,9E10.3)') he1cbt
            write(qq,'(7X,''HE1COL HE1LTE(i):  '',1P,10E10.3)') he1lte
            write(qq,'(7X,''he1col       c2p2s='',1p,e10.3)') he1c2p2s
         endif
      endif
*
      IF( he1lte(1).gt.0. ) THEN
*     following are eden independent, used in hlevel
      he1coldn(1) = (he1cll(2,1)*he1lte(2) + he1c2s1s*he1lte(10) +
     1 he1cll(3,1)*he1lte(3) + he1cll(4,1)*he1lte(4) +
     2 he1cll(5,1)*he1lte(5) + he1cll(6,1)*he1lte(6) +
     3 he1cll(7,1)*he1lte(7) +he1cll(8,1)*he1lte(8) +
     4 he1cll(9,1)*he1lte(9) ) / he1lte(1)
*
*     SUM is total rate from high states to both 2s and 2p
      sum = (he1cll(3,2)*he1lte(3) + he1cll(4,2)*he1lte(4) +
     1 he1cll(5,2)*he1lte(5) + he1cll(6,2)*he1lte(6) +
     2 he1cll(7,2)*he1lte(7) + he1cll(8,2)*he1lte(8) +
     3 he1cll(9,2)*he1lte(9) ) / ( he1lte(2) + he1lte(10) )
*
*     HE1CLL(2,1) is 2p - 1s rate; c2s1s is 2s - 1s rate
      he1coldn(2) = sum + he1cll(2,1)
      he1coldn(10) = sum + he1c2s1s
*
      he1coldn(3) = he1cll(3,1) + he1cll(3,2) + (he1cll(4,3)*he1lte(4) +
     1 he1cll(5,3)* he1lte(5) + he1cll(6,3)*he1lte(6) +
     2 he1cll(7,3)*he1lte(7) + he1cll(8,3)*he1lte(8) +
     3 he1cll(9,3) *he1lte(9) ) /he1lte(3)
*
      he1coldn(4) = he1cll(4,1) + he1cll(4,2) + he1cll(4,3) +
     1 (he1cll(5,4)*he1lte(5) + he1cll(6,4)*he1lte(6) +
     2 he1cll(7,4)*he1lte(7) + he1cll(8,4)*he1lte(8) +
     3 he1cll(9,4)*he1lte(9) ) / he1lte(4)
*
      he1coldn(5) = (he1cll(6,5)*he1lte(6) + he1cll(7,5)*he1lte(7) +
     1 he1cll(8,5)*he1lte(8) + he1cll(9,5)*he1lte(9)) /he1lte(5) +
     2 he1cll(5,1) + he1cll(5,2) + he1cll(5,3) + he1cll(5,4)
*
      he1coldn(6) = he1cll(6,1) + he1cll(6,2) + he1cll(6,3)+he1cll(6,4)+
     1 he1cll(6,5) + ( he1cll(7,6)*he1lte(7) + he1cll(8,6)*he1lte(8) +
     2 he1cll(9,6)*he1lte(9) ) /he1lte(6)
*
      he1coldn(7) = he1cll(7,1) + he1cll(7,2) + he1cll(7,3)+he1cll(7,4)+
     1 he1cll(7,5) + he1cll(7,6) + ( he1cll(8,7)*he1lte(8) +
     2 he1cll(9,7)*he1lte(9) ) /he1lte(7)
*
      he1coldn(8) = he1cll(8,1) + he1cll(8,2) + he1cll(8,3) +he1cll(8,4)
     1 + he1cll(8,5) + he1cll(8,6) + he1cll(8,7) +
     2 he1cll(9,8)*he1lte(9)/he1lte(8)
*
      he1coldn(9) = he1cll(9,1) + he1cll(9,2) + he1cll(9,3)+he1cll(9,4)
     1       + he1cll(9,5) + he1cll(9,6) + he1cll(9,7) +he1cll(9,8)
*
      if( lgTrace.and.lgHe1Bug ) then
         write(qq,'(7X,''HE1CLL he1coldn(i)      '',1P,10E10.3)')
     1   (he1coldn(i),i=1,10)
      endif
      else
        do n=1,nhe1lvl
          he1coldn(n) = 0.
        end do
      endif
*
      end
******************************************************************************
      subroutine he1gma( gam22 , hela )
      implicit none
*evaluate photoionization rates for helium singlets
      real gam22,hela
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer limelm
      parameter (limelm=30)
      double precision he1lte
      real he1c2p2s , he1c2s1s
*collision strengths and lte densities for helium singlets
      common/he1crt/ he1c2p2s , he1c2s1s , he1lte(nhe1lvl+1)
      double precision he1bol , he1cbt
      common/he1blt/ he1bol(nhe1lvl-1,nhe1lvl+1) , he1cbt(nhe1lvl+1)
      real he1qin,he1rin
      common/he1ind/ he1qin(nhe1lvl+1),he1rin(nhe1lvl+1)
      real he1cin
      common/he1cin/ he1cin(10)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer  ip2gam
      common/ip2gam/  ip2gam
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real otsmin
      common/otsmin/ otsmin
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer iophe1
      common/iophe1/ iophe1(9)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real hhe1
      common/hhe1/ hhe1(nhe1lvl)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
*ionization potential of level n, in Rydbergs
      real He1IonRyd
      common/He1NIonRyd/ He1IonRyd(nhe1lvl+1)
      real PhotScaleOn
*     set to 1 in zero, so have no effect
*     set to 0 with 'no photoionization' command, kills
*     photoionization of everything
      common/PhotScale/ PhotScaleOn
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real ghe1(9) ,he1cn(nhe1lvl)
      real bnfun,g2elec,rectot , p1 , p2
      integer i,n
      save ghe1 , he1cn , p1,p2
*     free statement labels >= 7
*
*     photoionization rates
*     He I ground state ionization
*
*     photoionization He
      if( lgDoPhoto ) then
*       with induced recombination, PhotScaleOn is 1, set to
*       zero with 'no photoionization' command
        ghe1(1) = bnfun( nhe1(1) , ip2gam-1,iophe1(1),1.808,
     1  he1qin(1), he1cn(1)) * PhotScaleOn
        hhe1(1) = h
        hela = secla
        gam22 = secion
*       now add on rest of integral; these energies can double photoionize
        g2elec = bnfun( ip2gam , nflux , iophe1(1)+ip2gam-nhe1(1) ,
     1  1.808 , p1 , p2) * PhotScaleOn
        if( lgTrace.and.lgHeBug ) then
          call PrtGamma(nhe1(1) ,nflux ,iophe1(1),qq,
     1    ghe1(1)+g2elec,(ghe1(1)+g2elec)*0.05)
        endif
        he1qin(1) = he1qin(1) + p1
        he1cn(1) = he1cn(1) + p2
        ghe1(1) = ghe1(1) + g2elec
*       gamma => 2 elec cross section - Brown (1970)
        g2elec = g2elec * 0.03
*       this used in helium
        gam22 = gam22 + secion
*       hela is used in helium to get total sec rate
        hela = hela + secla
        hhe1(1) = hhe1(1) + h
      endif
*
*     HeII LA and diffuse continua
      he1gam(1) = ghe1(1)
      PhotoRate(2,1,1,1) = ghe1(1)
      PhotoRate(2,1,1,2) = hhe1(1)
*
*     He I n>=2 state ionization
      if( lgDoPhoto ) then
*       F2 is related to induced rec rate, HE1CN(N) is related to cooling
        do n=2,nhe1lvl
          ghe1(n) = bnfun( nhe1(n),nhe1(1), iophe1(n), He1IonRyd(n) ,
     1    he1qin(n),he1cn(n)) * PhotScaleOn
          hhe1(n) = h
          he1gam(n) = ghe1(n)
        end do
      endif
*
*      induced recombination rate
       he1rin(1) = he1qin(1) * he1lte(1)
       he1rin(2) = he1qin(2) * (he1lte(2)+he1lte(10))
       he1cin(1) = he1cn(1) * he1lte(1)
       he1cin(2) = he1cn(2) * (he1lte(2)+he1lte(10))
       do n=3,nhe1lvl
*        induced recombination rate
         he1rin(n) = he1lte(n) * he1qin(n)
*        coooing due to induced recombination
         he1cin(n) = he1cn(n) * he1lte(n)
       end do
*
      if( lgTrace.and.lgHeBug ) then
         rectot = he1rec(1,2) * he1rec(1,1)
         do i=2,nhe1lvl
            rectot = rectot + he1rec(i,2) * he1rec(i,1)
         end do
         write(qq,'(5X,''He sin Gam:'',1P,E9.2,'' RadRec:'',E9.2,
     1   '' G eff'',E9.2,'' GndDrate'',E9.2,'' FrOp(other)'',E9.2,
     2   '' csup'',E9.2)')
     3   he1gam(1) , rectot , he1rec(1,2) , ghe1(1), ophe1f(1) , csupra
      endif
      if( lgTrace.and.(lgHe1Bug.or.lgHeBug) ) then
        if( he1gam(1).gt.0. ) then
          write(qq,'(5X,''HE1GAMgr ate'',1P,E9.2,'' pht frac Prim'',
     1    e9.2,'' ots304'',e9.2,'' ots228'',e9.2)')
     2    he1gam(1) ,
     3    ghe1(1)/he1gam(1) , otslin(iphe2l(2,1))*3.0e-18/
     3    he1gam(1), otscon(nhe2(1))*1.75e-18/he1gam(1)
        else
          write(qq,'(5X,''HE1GAMgr pht frac = none.'')')
        endif
      endif
*
      if( lgTrace.and.lgHe1Bug ) then
        if( lgDoPhoto ) then
          write(qq,'(5X,''HE1GMA finds photo rates:'',1P,9(I2,E9.2))')
     1    (i,he1gam(i),i=1,9)
        else
          write(qq,'(5X,''HE1GMA does not reeval photoioniz rates.'')')
        endif
      endif
*
      end
******************************************************************************
      real function he1jbr( ihi , low )
      implicit none
*returns continuum occupation number for helium singlet lines
      integer ihi , low
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*begin sanity check
      if( iphe1l(ihi,low).le.0 .or. iphe1l(ihi,low).gt.ncell ) then
        write(qq,'('' he1jbr insane hei line pointer:'',i5,
     1  '' ihi,low='',2i5)') iphe1l(ihi,low),ihi,low
        call ShowMe
        stop
      endif
*end sanity check
*
      if( lgFluor ) then
        he1jbr = occnum( iphe1l(ihi,low) )
      else
*       option to turn off continuum fluorsecent excitation with
*       "no induced" command
        he1jbr = 0.
      endif
*
      end
******************************************************************************
      subroutine he1lev( he2ov1 , sm2ov1 )
      implicit none
*evaluate ionization balance level populations for helium singlets
      double precision he2ov1
      real sm2ov1
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer nhe3lvl
      parameter (nhe3lvl=5)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real reci , rectri , recii
      common/herec/ reci , rectri , recii
      double precision he1bol , he1cbt
      common/he1blt/ he1bol(nhe1lvl-1,nhe1lvl+1) , he1cbt(nhe1lvl+1)
      double precision he1lte
      real he1c2p2s , he1c2s1s
*collision strengths and lte densities for helium singlets
      common/he1crt/ he1c2p2s , he1c2s1s , he1lte(nhe1lvl+1)
      real x12
      common/x12/ x12
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      real he1qin,he1rin
      common/he1ind/ he1qin(nhe1lvl+1),he1rin(nhe1lvl+1)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he1ex
      common/he1exCOM/ he1ex
      real he1coldn , he1bul , he1radn
*save collision, induced, and spontaneous rates for levels from helium singlet
      common/he1cbr/ he1coldn(nhe1lvl+1) , he1bul(nhe1lvl+1) ,
     1 he1radn(nhe1lvl+1)
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      real he1r2s , he1r2p
      common/he1rsp/ he1r2s , he1r2p
      real he3n
      common/he3n/ he3n(nhe3lvl)
      real cs2s2s,c2ss2s,cs2p2s,c2ss2p,c2pg,c2sg,c2ps2s,
     1 c2ps2p,cs2p2p,cs2s2p,csg2s,csg2p
      common/che2sn/ cs2s2s,c2ss2s,cs2p2s,c2ss2p,c2pg,c2sg,c2ps2s,
     1 c2ps2p,cs2p2p,cs2s2p,csg2s,csg2p
      real He1RecB , he1rtt
*He1RecB is case b singlet recombination rate coefficient
      common/he1rb/ He1RecB , he1rtt
      real the1lo
      integer nhe1lo
      common/the1lo/ the1lo , nhe1lo
      real hhe1
      common/hhe1/ hhe1(nhe1lvl)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real he1net
      common/he1netCOM/ he1net(nhe1lvl,nhe1lvl-1)
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
      real smhe2ov1 , clhe2ov1
      common/he1rate/ smhe2ov1 , clhe2ov1
      real a10830,a3889,a5876,a7065,a4,a19,a591,a2sg
      common/he3as/ a10830,a3889,a5876,a7065,a4,a19,a591,a2sg
      real he3pht , he3lya , he3local , he3relax
*     he3relax is fraction of 23s populations that go to singlets
      common/he3pht/ he3pht , he3lya , he3local , he3relax
*ionization potential of level n, in Rydbergs
      real He1IonRyd
      common/He1NIonRyd/ He1IonRyd(nhe1lvl+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real totcap(10)
      double precision z(11,11),c,r
*     real a2sg
*     this is in he3as.com
*     parameter (a2sg=1.13e-4)
      integer i, j, nerror
      real rdest,const,edp,rfac,gdist , hex12 , pop3n1,
     1 he1exx(nhe1lvl+1) , chk2ov1 , rtrip2s, rtrip2p, rtripg
*     real fudge
      save pop3n1 , rtrip2s,rtrip2p,rtripg
*
*     2S LEVEL IS LEVEL TEN; Z(2,I) IS 2P, Z(10,I) = 2S, HN(2) IS SUM
*     level 7 is actually 7 - 10;  8 is 11 - 20;  9 is 21 - 100
*     free statement labels >=12
*
*     last term is frac of trips that get photoionized
*     He1RecB is case b singlet rec coef
*     he1rtt is effect total rec coef
      reci = he1rtt + rectri * he3relax
*     do simple estimate of ionization balance
*     following assumes all trip recomb go to singlets
      sm2ov1 = (he1gam(1)+csupra*0.5+he1clc(1)*eden) /
     1 (eden*reci + co*1.10e-9 )
*     >>chng 96 dec 17, for HeI oscillations when pumped Lyman lines
*resulted in photoionization, simple estimate no good, so use
*previous solution
      if( nzone.gt.1 ) then
*       use previous matrix solution if it exists
        chk2ov1 = clhe2ov1
      else
*       use simple estimate for beginning of calculation
        chk2ov1 = sm2ov1
      endif
      smhe2ov1 = sm2ov1
      if( lgHe1Bug.and.lgTrace ) then
        write(qq,'(7X,''HE1LEV HE1GAM'',1P,E9.2,'' csupra'',E9.2,
     1  '' HE1CLC(1)'',E9.2,'' rec*re'',E9.2,
     2  '' smn2ov1'',e9.2)')
     3  he1gam(1) , csupra , he1clc(1),eden*reci,
     4  sm2ov1
      endif
      if( lgHeBug.and.lgTrace ) then
        write(qq,'(5X,''HE1LEV HE1GAM'',1P,'' tot ioniz'',E9.2,
     2  '' total reco'',E9.2,'' SM2OV1='',E9.2)')
     1  he1gam(1)+csupra*0.5+he1clc(1)*eden ,
     2  (eden*reci + co*1.10e-9 ) , sm2ov1
      endif
      create(2,1) = eden*reci + co*1.10e-9
      destroy(2,1) = he1gam(1)+csupra*0.5+he1clc(1)*eden
*
*     >>chng 96 dec 17, from sm2ov1 to chk2ov1
      if( chk2ov1 .lt.1e-12 ) then
        lgHe1ON = .false.
        do i=1,nhe1lvl
          he1bn(i) = 0.
          he1n(i) = 0.
*         this will be heating
          hhe1(i) = 0.
        end do
        he1bn(nhe1lvl+1) = 0.
        he1n(nhe1lvl+1) = 0.
        he12p = 0.
        he12s = 0.
        he2ov1 = 0.
        clhe2ov1 = he2ov1
        he1ex = 0.
        reci = 0.
        return
      else
        lgHe1ON = .true.
      endif
*
*     check how low temperature is; departure coef tend to infinity
*     as TE goes to zero; matrix formalism won't work on a 32-bit machine
*     if EXP(H NU/KT) > 1E38 for 13.6EV.
*     also use this if very low ionization
*     >>chng 96 dec 17, from sm2ov1 to chk2ov1
      if( te.le.the1lo .or. he1lte(1).eq.0. .or. he1lte(2).eq.0. .or.
     1  chk2ov1.lt.1e-8 ) then
*       last part above added to prevent code from using following
*       when helium is highly COLLISIONALLY ionized
        he1ex = 0.
        he1bn(1) = 1.
        do i=2,nhe1lvl+1
          he1bn(i) = 1.
          he1n(i) = 0.
        end do
*       He1RecB is evaluated with rec coef, is case b sum
*       recexc = He1RecB +
*    1  (he3n(1)*(c2ss2p+c2ss2s) + he3n(2)*(c2ps2s+c2ps2p) ) / eden
*       reci = he1rec(1,1)*he1rec(1,2) + recexc +
*    1  (he3n(1)*(c2sg+a2sg) + he3n(2)*c2pg ) / eden
*
*       do simple two level for helium, then fill in HN(i) for rest
        rdest = he1gam(1) + csupra*0.5 + he1clc(1)*eden
        if( rdest.gt.0. ) then
*         charge transfer with CO in here
          he1n(1) = (eden*reci + co*1.10e-9) / rdest
        else
          he1n(1) = 1e37
        endif
*       effective case B rec coef for low den limit Martin 1988
        he1n(4) = 1.44e-11 / (te70/te03/te03*te01) * eden / he1net(4,2)
        const = he1n(4) * he1net(4,2)
        he1n(3) = const * 14.5 / te10/te03/te03*te01 / he1net(3,2)
        he1n(5) = const * 0.291 * te03 * te01 / he1net(5,2)
        he1n(6) = const * 0.138 * te03*te01*te01 / he1net(6,2)
*       He1RecB is evaluated with rec coef, is case b sum
*       this needs to have a term for exchange collisions from trips,
*       as in recexc which is commented out above.  It is commented
*       out because of oscillations it caused.
        he12s = He1RecB * eden / (8.23+cs2s2p+he1c2s1s*eden) * 0.25
        he12p = He1RecB * eden / (he1cll(2,1)*eden+he1dst(2,1)+
     1  he1net(2,1))* 0.75
        he1n(2) = he12s + he12p
        he2ov1 = 1. / he1n(1)
        clhe2ov1 = he2ov1
        if(lgHeBug.and.lgTrace ) then
          write(qq,'(5X,''LOW TE, HE1N(1)='',1P,E12.3,
     1    '' rec='',E12.3,''HE1gam(1)='',E12.3)')
     2    he1n(1) , reci , he1gam(1)
        endif
        return
      endif
*-------------------------------------------------------------------
*
*     radiative and three body rec, fix 2s and 2p first
*     remember that HE1LTE(i) is only LTE pop when mult by Ne Nh
*
*     get rates from triplets
      if( he3n(2).gt.0. ) then
* 666 error! when going over to one eden change per iteration, get rid
* of only updates when flag set
*       use this if we have a valid triplet solution, hn3n(2)>0
*       he3n is pop relative to heii
        rtrip2s = ( he3n(1)*c2ss2s+he3n(2)*c2ps2s ) /eden
      else
*       no triplet solution, so assume no recs come here
*       >>chng 96 feb 14, have been half of triplets here
        rtrip2s = 0.
      endif
*
      z(10,11) = (he1r2s*he1rec(2,2)+rtrip2s+he1rin(2)*0.25) /
     1 he1lte(10)+ he1clc(2)*eden
      totcap(10) = z(10,11) * he1lte(10)
      reci = totcap(10)
*
      if( he3n(2).gt.0. ) then
*       use this if we have a valid triplet solution
        rtrip2p = (he3n(1)*c2ss2p + he3n(2)*c2ps2p) / eden
      else
*       no triplet solution, so assume all recs come here
*     >>chng 96 feb 14, have been half of triplets here
        rtrip2p = 0.
      endif
      z(2,11) = (he1r2p*he1rec(2,2)+rtrip2p+he1rin(2)*0.75) / he1lte(2)+
     1 he1clc(2)*eden
      totcap(2) = z(2,11) * he1lte(2)
      reci = reci + totcap(2)
*
      if( nzone .gt.1 ) then
*       this atom couples with the triplets -
*       damp out oscillations here
        pop3n1 = (pop3n1 + he3n(1)) / 2.
      else
        pop3n1 = he3n(1)
      endif
*
      if( he3n(2).gt.0. ) then
        rtripg = (pop3n1 *(c2sg+a2sg)+he3n(2)*c2pg) / eden
      else
*       no triplet solution, so assume all recs come here
*     >>chng 96 feb 14, had been zero
        rtripg = rectri * he3relax
      endif
      z(1,11) = ( he1rec(1,1)*he1rec(1,2) + rtripg + he1rin(1) ) /
     1 he1lte(1) + he1clc(1)*eden
*
      totcap(1) = z(1,11) * he1lte(1)
      reci = reci + totcap(1)
*
      do i=3,nhe1lvl
        z(i,11) = (he1rec(i,1)*he1rec(i,2)+he1rin(i))/he1lte(i) +
     1  he1clc(i)*eden
        totcap(i) = z(i,11) * he1lte(i)
        reci = reci + totcap(i)
      end do
*
*     Janev et al show HeI 100 eV cross section is about 6 times
*     smaller than that for hydrogen
      hex12 = x12 / 6.
*---------------------------------------------------------------------
*     now set up matrix for dreaded b(i)'s
*
*     level 1 balance equation
*     HE1CLL(u,l), etc, are rates for downward collisions (cm^3 s^-1)
*     corr of hi*1.7e-4 accounts for col ion by HI; Drawin Zs Phys 225, 483.
      z(1,1) = csupra*0.5 + he1gam(1) + hex12 + he1coldn(1)*eden +
     1 he1clc(1)* (eden + hi*1.7e-4) + he1bul(1) + (csg2s+csg2p)
      z(1,2) = -( he1net(2,1) + he1con(2,1) +
     1 he1cll(2,1)*eden+hex12/3.)* he1lte(2) / he1lte(1)
      z(1,3) = -( he1net(3,1) + he1con(3,1) +
     1 he1cll(3,1)*eden ) * he1lte(3) / he1lte(1)
      z(1,4) = -( he1net(4,1) + he1con(4,1) +
     1 he1cll(4,1)*eden ) * he1lte(4) / he1lte(1)
      z(1,5) = -( he1net(5,1) + he1con(5,1) +
     1 he1cll(5,1)*eden ) * he1lte(5) / he1lte(1)
      z(1,6) = -( he1net(6,1) + he1con(6,1) +
     1 he1cll(6,1)*eden ) * he1lte(6) / he1lte(1)
      z(1,7) = -( he1net(7,1) + he1con(7,1) +
     1 he1cll(7,1)*eden ) * he1lte(7) / he1lte(1)
      z(1,8) = -( he1net(8,1) + he1con(8,1) +
     1 he1cll(8,1)*eden ) * he1lte(8) / he1lte(1)
      z(1,9) = -( he1net(9,1) + he1con(9,1) +
     1 he1cll(9,1)*eden ) * he1lte(9) / he1lte(1)
      z(1,10) = -( 8.23 + hex12 +    he1c2s1s*eden)*he1lte(10)/he1lte(1)
      gdist = z(1,1)
*
*     LEVEL 2P BALANCE EQUATION - 2p is higher energy than 2s
      edp = (eden * 0.1  +  hii * 0.9 )
      c = 0.75 / he1lte(2)
*     R is low density limit branching ratio for 2s-p (NOT l-mixed)
*     this is to simulate mixing of the n=3 level
      rfac = 0.32 - 0.07 * eden / ( eden + 1e7 )
      r = ( 1. - rfac ) / he1lte(2)
      z(2,1) = -( hex12*0.33 + he1cll(2,1)*eden+he1con(2,1)/he1bol(1,2))
      z(2,2) = he1gam(2)+ he1radn(2) + hex12/3. + he1coldn(2)*eden +
     1 he1clc(2)*eden + he1c2p2s * edp + (he1bul(2)+he1con(2,1)) +
     2 ( cs2p2s + cs2p2p )
      z(2,3) = -(he1net(3,2)*r+(he1con(3,2)+he1cll(3,2)*eden)*c) *
     1 he1lte(3)
      z(2,4) = -(he1net(4,2)*r+(he1con(4,2)+he1cll(4,2)*eden)*c) *
     1 he1lte(4)
      z(2,5) = -(he1net(5,2)*r+(he1con(5,2)+he1cll(5,2)*eden)*c) *
     1 he1lte(5)
      z(2,6) = -(he1net(6,2)*r+(he1con(6,2)+he1cll(6,2)*eden)*c) *
     1 he1lte(6)
      z(2,7) = -(he1net(7,2)*r+(he1con(7,2)+he1cll(7,2)*eden)*c) *
     1 he1lte(7)
      z(2,8) = -(he1net(8,2)*r+(he1con(8,2)+he1cll(8,2)*eden)*c) *
     1 he1lte(8)
      z(2,9) = -(he1net(9,2)*r+(he1con(9,2)+he1cll(9,2)*eden)*c) *
     1 he1lte(9)
      z(2,10) = -he1c2p2s * edp
*
*     LEVEL 2S BALANCE EQUATION - define 2s as lower energy than 2p
      c = 0.25 / he1lte(10)
      r = rfac / he1lte(10)
*
      z(10,1) = -( hex12*0.33 + he1c2s1s*eden )
      z(10,2) = -(he1c2p2s*edp+t206(ipLnEscP)*t206(ipLnAul))*he1lte(2) /
     1  he1lte(10)
      z(10,3) = -(he1net(3,2)*r+(he1con(3,2)+he1cll(3,2)*eden)*c) *
     1  he1lte(3)
      z(10,4) = -(he1net(4,2)*r+(he1con(4,2)+he1cll(4,2)*eden)*c) *
     1  he1lte(4)
      z(10,5) = -(he1net(5,2)*r+(he1con(5,2)+he1cll(5,2)*eden)*c) *
     1  he1lte(5)
      z(10,6) = -(he1net(6,2)*r+(he1con(6,2)+he1cll(6,2)*eden)*c) *
     1  he1lte(6)
      z(10,7) = -(he1net(7,2)*r+(he1con(7,2)+he1cll(7,2)*eden)*c) *
     1  he1lte(7)
      z(10,8) = -(he1net(8,2)*r+(he1con(8,2)+he1cll(8,2)*eden)*c) *
     1 he1lte(8)
      z(10,9) = -(he1net(9,2)*r+(he1con(9,2)+he1cll(9,2)*eden)*c) *
     1 he1lte(9)
      z(10,10) = he1radn(10) + he1gam(2) + (he1coldn(10)+he1clc(2))*eden
     1 + hex12 + he1c2p2s*3.*edp + he1bul(2) + (cs2s2s + cs2s2p)
*
*     LEVEL 3
      z(3,1) = -(he1cll(3,1)*eden +
     1 ( he1con(3,1)*he1stat(3)/he1stat(1) ) *he1lte(1)/he1lte(3) )
      z(3,2) = -(he1cll(3,2)*eden + he1con(3,2)/he1bol(2,3) ) *0.75
      z(3,3) = he1gam(3)+he1radn(3)+ (he1clc(3)+he1coldn(3))*eden +
     1 he1bul(3)
      z(3,4) =-(he1net(4,3)+he1con(4,3)+he1cll(4,3)*
     1 eden)* he1lte(4)/he1lte(3)
      z(3,5) =-(he1net(5,3)+he1con(5,3)+he1cll(5,3)*eden)*he1lte(5)/
     1 he1lte(3)
      z(3,6) =-(he1net(6,3)+he1con(6,3)+he1cll(6,3)*eden)*he1lte(6)/
     1 he1lte(3)
      z(3,7) =-(he1net(7,3)+he1con(7,3)+he1cll(7,3)*eden)*he1lte(7)/
     1 he1lte(3)
      z(3,8) =-(he1net(8,3)+he1con(8,3)+he1cll(8,3)*eden)*he1lte(8)/
     1 he1lte(3)
      z(3,9) =-(he1net(9,3)+he1con(9,3)+he1cll(9,3)*eden)*he1lte(9)/
     1 he1lte(3)
      z(3,10) = -(he1cll(3,2) *eden + he1con(3,2)/he1bol(2,3))*0.25
*
*     level 4
      z(4,1) = -he1cll(4,1) * eden - he1con(4,1)/he1bol(1,4)
      z(4,2) =-(he1cll(4,2) * eden + he1con(4,2)/he1bol(2,4)) * 0.75
      z(4,3) = -he1cll(4,3) * eden - he1con(4,3)/he1bol(3,4)
      z(4,4) = (he1coldn(4)+he1clc(4))*eden + he1radn(4) + he1gam(4)
     1 + he1bul(4)
      z(4,5) =-(he1net(5,4)+he1con(5,4)+he1cll(5,4)*eden)*he1lte(5)/
     1 he1lte(4)
      z(4,6) =-(he1net(6,4)+he1con(6,4)+he1cll(6,4)*eden)*he1lte(6)/
     1 he1lte(4)
      z(4,7) =-(he1net(7,4)+he1con(7,4)+he1cll(7,4)*eden)*he1lte(7)/
     1 he1lte(4)
      z(4,8) =-(he1net(8,4)+he1con(8,4)+he1cll(8,4)*eden)*he1lte(8)/
     1 he1lte(4)
      z(4,9) =-(he1net(9,4)+he1con(9,4)+he1cll(9,4)*eden)*he1lte(9)/
     1 he1lte(4)
      z(4,10) = -(he1cll(4,2) * eden + he1con(4,2)/he1bol(2,4))*0.25
*
*     level 5
      z(5,1) = -he1cll(5,1) * eden - he1con(5,1)/he1bol(1,5)
      z(5,2) =-(he1cll(5,2) * eden + he1con(5,2)/he1bol(2,5) ) *0.75
      z(5,3) = -he1cll(5,3) * eden - he1con(5,3)/he1bol(3,5)
      z(5,4) = -he1cll(5,4) * eden - he1con(5,4)/he1bol(4,5)
      z(5,5) = he1gam(5) + he1radn(5) + (he1coldn(5)+he1clc(5))*eden
     1 + he1bul(5)
      z(5,6) = -(he1net(6,5)+he1con(6,5)+he1cll(6,5)*eden)*he1lte(6)/
     1 he1lte(5)
      z(5,7) = -(he1net(7,5)+he1con(7,5)+he1cll(7,5)*eden)*he1lte(7)/
     1 he1lte(5)
      z(5,8) = -(he1net(8,5)+he1con(8,5)+he1cll(8,5)*eden)*he1lte(8)/
     1  he1lte(5)
      z(5,9) = -(he1net(9,5)+he1con(9,5)+he1cll(9,5)*eden)*he1lte(9)/
     1 he1lte(5)
      z(5,10) = -(he1cll(5,2) * eden + he1con(5,2)/he1bol(2,5))*0.25
*
*     level 6
      z(6,1) = -he1cll(6,1) * eden - he1con(6,1)/he1bol(1,6)
      z(6,2) =-(he1cll(6,2) * eden + he1con(6,2)/he1bol(2,6))* 0.75
      z(6,3) = -he1cll(6,3) * eden - he1con(6,3)/he1bol(3,6)
      z(6,4) = -he1cll(6,4) * eden - he1con(6,4)/he1bol(4,6)
      z(6,5) = -he1cll(6,5) * eden - he1con(6,5)/he1bol(5,6)
      z(6,6) = (he1coldn(6)+he1clc(6))*eden + he1gam(6) + he1radn(6)
     1 + he1bul(6)
      z(6,7) = -(he1net(7,6)+he1con(7,6)+he1cll(7,6)*eden)*he1lte(7)/
     1 he1lte(6)
      z(6,8) = -(he1net(8,6)+he1con(8,6)+he1cll(8,6)*eden)*he1lte(8)/
     1 he1lte(6)
      z(6,9) = -(he1net(9,6)+he1con(9,6)+he1cll(9,6)*eden)*he1lte(9)/
     1 he1lte(6)
      z(6,10) = -(he1cll(6,2) * eden + he1con(6,2)/he1bol(2,6))* 0.25
*
*     level 7
      z(7,1) = -he1cll(7,1) * eden - he1con(7,1)/he1bol(1,7)
      z(7,2) =-(he1cll(7,2) * eden + he1con(7,2)/he1bol(2,7))* 0.75
      z(7,3) = -he1cll(7,3) * eden - he1con(7,3)/he1bol(3,7)
      z(7,4) = -he1cll(7,4) * eden - he1con(7,4)/he1bol(4,7)
      z(7,5) = -he1cll(7,5) * eden - he1con(7,5)/he1bol(5,7)
      z(7,6) = -he1cll(7,6) * eden - he1con(7,6)/he1bol(6,7)
      z(7,7) = (he1coldn(7)+he1clc(7))*eden + he1gam(7) + he1radn(7)
     1 + he1bul(7)
      z(7,8) = -(he1net(8,7)+he1con(8,7)+he1cll(8,7)*eden)*he1lte(8)/
     1 he1lte(7)
      z(7,9) = -(he1net(9,7)+he1con(9,7)+he1cll(9,7)*eden)*he1lte(9)/
     1 he1lte(7)
      z(7,10) = -(he1cll(7,2) * eden + he1con(7,2)/he1bol(2,7))*0.25
*
*     level 8
      z(8,1) = -he1cll(8,1) * eden - he1con(8,1)/he1bol(1,8)
      z(8,2) =-(he1cll(8,2) * eden + he1con(8,2)/he1bol(2,8))* 0.75
      z(8,3) = -he1cll(8,3) * eden - he1con(8,3)/he1bol(3,8)
      z(8,4) = -he1cll(8,4) * eden - he1con(8,4)/he1bol(4,8)
      z(8,5) = -he1cll(8,5) * eden - he1con(8,5)/he1bol(5,8)
      z(8,6) = -he1cll(8,6) * eden - he1con(8,6)/he1bol(6,8)
      z(8,7) = -he1cll(8,7) * eden - he1con(8,7)/he1bol(7,8)
      z(8,8) = (he1coldn(8)+he1clc(8))*eden +he1gam(8) +he1radn(8)
     1 +he1bul(8)
      z(8,9) =-(he1net(9,8)+he1con(9,8)+he1cll(9,8)*eden)*he1lte(9)/
     1 he1lte(8)
      z(8,10) = -(he1cll(8,2) * eden + he1con(8,2)/he1bol(2,8))*0.25
*
*     level 9
      z(9,1) = -he1cll(9,1) * eden - he1con(9,1)/he1bol(1,9)
      z(9,2) =-(he1cll(9,2) * eden + he1con(9,2)/he1bol(2,9))* 0.75
      z(9,3) = -he1cll(9,3) * eden - he1con(9,3)/he1bol(3,9)
      z(9,4) = -he1cll(9,4) * eden - he1con(9,4)/he1bol(4,9)
      z(9,5) = -he1cll(9,5) * eden - he1con(9,5)/he1bol(5,9)
      z(9,6) = -he1cll(9,6) * eden - he1con(9,6)/he1bol(6,9)
      z(9,7) = -he1cll(9,7) * eden - he1con(9,7)/he1bol(7,9)
      z(9,8) = -he1cll(9,8) * eden - he1con(9,8)/he1bol(8,9)
      z(9,9) = (he1coldn(9)+he1clc(9)) *eden + he1gam(9) + he1radn(9)
     1 + he1bul(9)
      z(9,10) = -(he1cll(9,2) * eden +he1con(9,2)/he1bol(2,9))* 0.25
*
      if( lgTrace.and.lgHe1Bug ) then
        do i=1,nhe1lvl+1
          write(qq,'(7X,''HeIs'',I2,1P,11E10.2)') i,(z(i,j),
     1    j=1,nhe1lvl+2)
        end do
      endif
*
*     scale to largest number of order unity
      do j=1,nhe1lvl+1
        do i=1,nhe1lvl+2
          z(j,i) = z(j,i) * he1lte(j)
        end do
      end do
*
      call matin1( z,nhe1lvl+2,nhe1lvl+1,1,nerror)
      if(nerror.ne.0 ) then
        write(qq,'('' HE1LEV MATRIX ERROR, STOP.'')')
        stop
      endif
*
*     convert from departure coef in Z(I) to level pop rel to HeII
*     HE1EX is net cooling rate due to col ionization-three body rec (s-1 here)
      he1bn(1) = z(1,11)
      he1n(1) = he1bn(1) * he1lte(1) * eden
      he1bn(2) = z(2,11)
      he1n(2) = he1bn(2) * he1lte(2) * eden
*
      do i=3,nhe1lvl
        he1bn(i) = z(i,11)
*       HE1N(I) are pop per level rel to He+; i.e., N(n)/N(He+)
        he1n(i) = he1bn(i) * he1lte(i) * eden
      end do
*
      he1ex = 0.
      do i=1,nhe1lvl-2
*       units of HE1EX are erg/cm^3/s
        he1exx(i) = He1IonRyd(i) * he1clc(i) * eden *
     1  (he1n(i)-he1lte(i)*eden)
        he1ex = he1ex + he1exx(i)
      end do
      he1ex = he1ex * en1ryd
*
      he12p = he1n(2)
      he1bn(nhe1lvl+1) = z(nhe1lvl+1,11)
      he12s = he1bn(nhe1lvl+1) * he1lte(nhe1lvl+1) * eden
      he1n(nhe1lvl+1) = he12s
      he1n(2) = he1n(2) + he12s
      he2ov1 = he1n(1) + he1n(2) + he1n(3) + he1n(4) + he1n(5) + he1n(6)
*     HE2OV1 is He+ / He sin
      he2ov1 = 1. / he2ov1
      clhe2ov1 = he2ov1
      he1ex = he1ex + en1ryd*anu(nhe1(2)) * he1clc(2) * eden *
     1 (he12s-he1lte(nhe1lvl+1)* eden)
*
      if( lgHe1Bug.and.lgTrace ) then
         write(qq,'(7X,''HE1LEV HE1GAM'',1P,10E9.2)') he1gam
         write(qq,'(7X,''HE1LEV TOTCAP'',1P,10E9.2,'' tot='',E9.2)')
     1   totcap , reci
         write(qq,'(7X,''HE1LEV IND Rc'',1P,10E9.2)') he1rin
         write(qq,'(7X,''HE1LEV IND As'',1P,10E9.2)') he1bul
         write(qq,'(7X,''HE1LEV HE1LTE'',1P,10E9.2)') he1lte
         write(qq,'(7X,''HE1LEV   HE1N'',1P,9E9.2,'' HN2s,p'',2E9.2)')
     1   he1n,he12s,he12p
         write(qq,'(7X,''HE1LEV   b(n)'',1P,9E9.2,''   2s,p'',2E9.2)')
     1   (he1bn(i),i=1,nhe1lvl) , he1bn(10) , he1bn(2)
*
         write(qq,'(7X,''HE1LEV   X12'',1P,E9.2,
     1   '' Heat Exc'',E9.2,'' Grn dest:'',E9.2)')
     2   x12,he1ex,gdist
      endif
*
      do i=1,nhe1lvl+1
        if(he1n(i).le.0. ) then
          write(qq,'('' HE1LEV finds negative population,'',i3,1P,
     1    E10.2,'' simple='',E10.2,'' Te='',E10.2,'' NZONE='',I4)')
     2    i,he1n(i) , sm2ov1,te,nzone
          write(qq,'('' HE1LEV pops,'',1p,11e9.1)')
     1     (he1n(j),j=1,nhe1lvl+1)
          call negcon
          call ShowMe
          stop
        endif
      end do
      if( lgTrace ) then
        write(qq,'(7X,''HE1LEV returns, mtrx finds HE2OV1 ='',1P,E9.2,
     1  '' simple='',E9.2,'' Gamma1='',E9.2,'' rec1'',E9.2,'' rec3'',
     2  e9.2)') he2ov1,sm2ov1,he1gam(1), reci , rectri
      endif
*
      end
******************************************************************************
      subroutine he1rad
      implicit none
*evaluate radiative rates for helium singlets
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real otsmin
      common/otsmin/ otsmin
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he1r2s , he1r2p
      common/he1rsp/ he1r2s , he1r2p
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real peshe1
*     stark broadening arrays for HeI
      common/he1str/ peshe1(nhe1lvl,nhe1lvl)
      real he1esc
      common/he1escCOM/ he1esc(9,9)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real He1EinA
*transition prob for He 1 singlets
      common/he1as/ He1EinA(9,8)
      real he1coldn , he1bul , he1radn
*save collision, induced, and spontaneous rates for levels from helium singlet
      common/he1cbr/ he1coldn(nhe1lvl+1) , he1bul(nhe1lvl+1) ,
     1 he1radn(nhe1lvl+1)
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
      real He1RecB , he1rtt
*He1RecB is case b singlet recombination rate coefficient
      common/he1rb/ He1RecB , he1rtt
      real htus , he1tus , he2tus, he3tus
      common/tusedcom/ htus , he1tus , he2tus, he3tus
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      real he1net
      common/he1netCOM/ he1net(nhe1lvl,nhe1lvl-1)
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*
      real t12old,t23old
      integer i , j , n
      real a,b,c,recf
      real receff,x,fac,sexp
*
      data t12old,t23old/2*0./
*
      recf(a,b,c) = a + b * (alogte-c)**2
*
*     free statement numbers >=10
*
*     evaluate rec coef for H, HE1REC(I,2) is recombination efficiency
*     OTSMIN normally equal to zero
*
      if( lgNewIon ) then
        do n=1,nhe1lvl
          he1rec(n,3) = receff( nhe1(n) )
        end do
      endif
*
      if( lgCaseb ) then
        he1rec(1,3) = 1e-10
      endif
*
      do n=1,nhe1lvl
        he1rec(n,3) = max( he1rec(n,3) , otsmin )
*       last factor accounts for metal absorption of HeII diffuse
*       fields, computed in AddOpac, this is counted as recombination
        he1rec(n,2) = min(1.,he1rec(n,3)+(1.-he1rec(n,3))*
     1  ophe1f(n))
      end do
      he1rec(nhe1lvl+1,2) = he1rec(2,2)
      he1rec(nhe1lvl+1,3) = he1rec(2,3)
*
      if( lgTrace.and.lgHe1Bug ) then
        write(qq,'(7X,''HE1RAD geo recomb effic'',1p,9e10.3)')
     1  (he1rec(i,3),i=1,9)
        write(qq,'(7X,''HE1RAD net recomb effic'',1p,9e10.3)')
     1  (he1rec(i,2),i=1,9)
      endif
*
*     don't reevaluate coefficients if temp unchanged
      if( abs(he1tus-te)/he1tus.gt. 0.002 ) then
        he1tus = te
        he1rec(1,1) = 1.6e-11 / sqrte
*
        x = 157900. / te
*
        he1r2s =   3.84e-13 / sqrte * te03 * te01
        he1r2p =   7.768e-12 / te70 * te01
        he1rec(2,1) = he1r2p
        he1rec(nhe1lvl+1,1) = he1r2s
        fac = 4.0 * te
        if( te.le.1e5 ) then
           he1rec(3,1) = 1.256e-11 / (te70*te03*te03/te01)
        else
           he1rec(3,1) = 1.1*10.**(-recf( 9.2150 , .12898,4.9933))/fac
        endif
        fac = fac * 1.1
        he1rec(4,1) = 10.**(-recf( 9.4583 , .12236  , 4.7567 ))/fac
        he1rec(5,1) = 10.**(-recf( 9.6516 , .11481  , 4.5614 ))/fac
        he1rec(6,1) = 10.**(-recf( 9.8112 , .10747  , 4.3913 ))/fac
        he1rec(7,1) = 10.**(-recf( 9.4942 , .093811 , 4.0473 ))/fac
        he1rec(8,1) = 10.**(-recf( 9.5858 , .070572 , 3.2727 ))/fac
        he1rec(9,1) = 10.**(-recf( 9.5028 , .045593 , 1.4592 ))/fac
*
*       >>chng 96 june 5, big jump in rec coef at level7 (old cota level)
*       causes maser in 7 -6 - don't let this happen, add extro to top level
* 666 error! change this to true levels, like Jason's hydrogen
*       factor is to account for lowering  of rec coef with inc n
        b = 0.75
        do i=7,nhe1lvl-1
*         amount we will subtract from here, then add to highest level
          a = he1rec(i,1) - he1rec(i-1,1)*b
          he1rec(i,1) = he1rec(i,1) - a
          he1rec(nhe1lvl,1) = he1rec(nhe1lvl,1) + a
        end do
*
*       dielectronic recombination
        if( te.gt. 5e4 ) then
          he1rec(nhe1lvl,1) = he1rec(nhe1lvl,1) +
     1    1.9e-3/te32*sexp(4.7e5/te)*(1.+0.3*sexp(9.4e4/te))
*         >>chng 96 oct 22, first coef had been 4.5 below, change to 4.7 as
*in aldrovandi and pequignot
*    1    1.9e-3/te32*sexp(4.5e5/te)*(1.+0.3*sexp(9.4e4/te))*0.
        endif
*
        he1rtt = he1rec(1,1)*he1rec(1,2)
*       He1RecB is the case B singlet recombination rate coef
        He1RecB = 0.
        do i=2,nhe1lvl
          he1rtt = he1rtt + he1rec(i,1)*he1rec(i,2)
          He1RecB = He1RecB + he1rec(i,1)
        end do
        if( lgTrace.and.lgHe1Bug ) then
          write(qq,'(7X,''HE1RAD eval rec cof'',1P,9E10.3)')
     1    (he1rec(i,1),i=1,9)
          write(qq,'(7X,''HE1RAD total effective recombination coef'',
     1    1P,E10.3,'' Case B, A='',2E10.3)')
     2    he1rtt , He1RecB , He1RecB+he1rec(1,1)
        endif
      else
        he1rtt = he1rec(1,1)*he1rec(1,2)
        He1RecB = 0.
        do i=2,nhe1lvl
          he1rtt = he1rtt + he1rec(i,1)*he1rec(i,2)
          He1RecB = He1RecB + he1rec(i,1)
        end do
        if( lgTrace.and.lgHe1Bug ) then
          write(qq,'(7X,''HE1RAD not reevel rec''
     1    ,'' cof total effective recombination coef is '',1P,E10.3)')
     2    he1rtt
        endif
      endiF
*
      t12old = he1nxt(2,1)
      t23old = he1nxt(3,2)
*
*     following has min(1, removed may 12 96, is it in hydro and he2?
      do j=1,nhe1lvl-1
        do i=j+1,nhe1lvl
*         >>chng 96 may 13 cap of 1 prevented maser emission
*         he1mis(i,j) = He1EinA(i,j)*min(1.,(he1esc(i,j)+peshe1(i,j)))
          he1mis(i,j) = He1EinA(i,j)*(he1esc(i,j)+peshe1(i,j))
          he1net(i,j) = he1mis(i,j) + he1dst(i,j)
        end do
      end do
*
*     these are used in HLEVEL - total decay rates
      he1radn(2) = he1net(2,1) + t206(ipLnEscP) * t206(ipLnAul)
*     this is what the two photon integrates up to
      he1radn(10) = 8.23
      he1radn(3) = he1net(3,1) + he1net(3,2)
      he1radn(4) = he1net(4,1) + he1net(4,2) + he1net(4,3)
      he1radn(5) = he1net(5,1) + he1net(5,2) + he1net(5,3) +he1net(5,4)
      he1radn(6) = he1net(6,1) + he1net(6,2) + he1net(6,3) +he1net(6,4)+
     1 he1net(6,5)
      he1radn(7) = he1net(7,1) + he1net(7,2) + he1net(7,3) +he1net(7,4)+
     1 he1net(7,5) + he1net(7,6)
      he1radn(8) = he1net(8,1) + he1net(8,2) + he1net(8,3) +he1net(8,4)+
     1 he1net(8,5) + he1net(8,6) + he1net(8,7)
      he1radn(9) = he1net(9,1) + he1net(9,2) + he1net(9,3) +he1net(9,4)+
     1 he1net(9,5) + he1net(9,6) + he1net(9,7) + he1net(9,8)
*
*     total rates out of level due to induced processes
      he1bul(1) = (he1con(2,1)*he1stat(2) + he1con(3,1)*he1stat(3) +
     1 he1con(4,1)*he1stat(4) + he1con(5,1)*he1stat(5) + he1con(6,1)*
     1 he1stat(6) + he1con(7,1)*he1stat(7)+ he1con(8,1)*he1stat(8)+
     2 he1con(9,1)*he1stat(9) ) / he1stat(1)
      he1bul(2) = (he1con(3,2)*he1stat(3) + he1con(4,2)*he1stat(4)
     1 + he1con(5,2)*he1stat(5) + he1con(6,2)*he1stat(6) +he1con(7,2)*
     1  he1stat(7) + he1con(8,2)*he1stat(8) + he1con(9,2)*he1stat(9))
     2 / ( he1stat(2) + he1stat(10) )
      he1bul(3) = he1con(3,1) + he1con(3,2) + ( he1con(4,3)*he1stat(4) +
     1 he1con(5,3)*he1stat(5) + he1con(6,3)*he1stat(6) + he1con(7,3)*
     1 he1stat(7) + he1con(8,3)*he1stat(8) + he1con(9,3)*he1stat(9))/
     2 he1stat(3)
      he1bul(4) = he1con(4,1) +he1con(4,2) +he1con(4,3)+
     1 (he1con(5,4)*he1stat(5) + he1con(6,4)*he1stat(6) +
     2 he1con(7,4)*he1stat(7)+he1con(8,4)*he1stat(8)+
     3 he1con(9,4)*he1stat(9)) / he1stat(4)
      he1bul(5) = he1con(5,1) + he1con(5,2) + he1con(5,3) + he1con(5,4)+
     1( he1con(6,5)*he1stat(6) + he1con(7,5)*he1stat(7) +
     2 he1con(8,5)*he1stat(8)+he1con(9,5)*he1stat(9) ) / he1stat(5)
      he1bul(6) = he1con(6,1) + he1con(6,2) + he1con(6,3) + he1con(6,4)+
     1 he1con(6,5) + (he1con(7,6)*he1stat(7) +he1con(8,6)*he1stat(8)
     2 + he1con(9,6)*he1stat(9) ) / he1stat(6)
      he1bul(7) = he1con(7,1) + he1con(7,2) + he1con(7,3) + he1con(7,4)+
     1 he1con(7,5) + he1con(7,6) +
     2 (he1con(8,7)*he1stat(8)+he1con(9,7)*he1stat(9) ) /he1stat(7)
      he1bul(8) = he1con(8,1)+he1con(8,2)+he1con(8,3)+he1con(8,4)+
     1 he1con(8,5)+he1con(8,6)+he1con(8,7)+
     2 he1con(9,8)*he1stat(9)/he1stat(8)
      he1bul(9) = he1con(9,1)+he1con(9,2)+he1con(9,3)+he1con(9,4)+
     1 he1con(9,5)+he1con(9,6)+he1con(9,7)+he1con(9,8)
*
      if( lgTrace.and.lgHe1Bug ) then
         write(qq,'(7X,''HE1RAD finds arrays, with optical depths defi''
     1   ,''ned? '',L1)') lgTauOutOn
        do i=2,nhe1lvl
          write(qq,'(6X,''up:'',I2,10I10)') i,(j,j=1,i-1)
          write(qq,'(9X,''A*esc'',1P,8E10.2)') (he1mis(i,j)  ,j=1,i-1)
          write(qq,'(9X,''A-net'',1P,8E10.2)') (he1net(i,j)  ,j=1,i-1)
          write(qq,'(9X,''tauin'',1P,8E10.2)') (he1nxt(i,j)  ,j=1,i-1)
          write(qq,'(9X,''t tot'',1P,8E10.2)') (he1lim(i,j)  ,j=1,i-1)
          write(qq,'(9X,''Esc  '',1P,8E10.2)') (he1esc(i,j)  ,j=1,i-1)
          write(qq,'(9X,''A*dst'',1P,8E10.2)') (he1dst(i,j)  ,j=1,i-1)
          write(qq,'(9X,''StrkE'',1P,8E10.2)') (peshe1(i,j)  ,j=1,i-1)
          write(qq,'(9X,''B(ul)'',1P,8E10.2)') (he1con(i,j)  ,j=1,i-1)
          write(qq,'(9X,''C(ul)'',1P,8E10.2)') (he1cll(i,j)*eden,
     1    j=1,i-1)
        end do
*
        write(qq,'(14X,10I9)') (i,i=1,10)
        write(qq,'(7X,''HE1RAD  rad'',1P,10E9.2)')
     1  (he1radn(i),i=1,10)
      endif
*
      end
******************************************************************************
      subroutine he2lev( heiov2 , smiov2 )
      implicit none
*evaluate ionization balance level population for model helium ion
      double precision heiov2
      real smiov2
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real reci , rectri , recii
      common/herec/ reci , rectri , recii
      real he2rb , he2rtt
      common/he2rb/ he2rb , he2rtt
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      double precision he2bol , he2cbt
      common/he2blt/ he2bol(nhe2lvl-1,nhe2lvl+1) , he2cbt(nhe2lvl+1)
      double precision he2lte
      real he2c2p2se , he2c2p2sp , he2c2s1s
*he2c2p2sp is collision rate coefficient for proton collisions from 2p to 2s
*he2c2p2se is collision rate coefficient for electron collisions from 2p to 2s
*he2c2s1 is collision rate coefficient for electron collisions from 2s to 1s
*he2lte is lte relative population density for helium ion
      common/he2crt/ he2lte(nhe2lvl+1), he2c2p2se,he2c2p2sp , he2c2s1s
      real x12
      common/x12/ x12
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      real he2qin,he2rin
      common/he2ind/ he2qin(nhe2lvl+1),he2rin(nhe2lvl+1)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he2ex
      common/he2ex/ he2ex
      real he2coldn , he2bul , he2radn
*save collision, induced, and spontaneous rates for levels from helium ion
      common/he2cbr/ he2coldn(nhe2lvl+1) , he2bul(nhe2lvl+1) ,
     1 he2radn(nhe2lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      real he2r2s , he2r2p
      common/he2rsp/ he2r2s , he2r2p
      real hhe2
      common/hhe2/ hhe2(nhe2lvl)
      real the2lo
      integer nhe2lo
      common/the2lo/ the2lo , nhe2lo
      real he2net
      common/he2net/ he2net(nhe2lvl,nhe2lvl-1)
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real sheiov2 , collhe2
      common/he2rate/ sheiov2 , collhe2
      real He2IonRyd
*ionization potential of level n in Ryd for HeII ion
      common/He2NIonRyd/ He2IonRyd(nhe2lvl+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,j,nerror
      real cion,rdest,const,gdist,edp,rfac, he2exx(nhe2lvl+1)
      real totcap(10) , x12ef
      double precision effion(9) , sum
      double precision z(11,11),c,r
*
*     2S LEVEL IS LEVEL TEN; Z(2,I) IS 2P, Z(10,I) = 2S, HN(2) IS SUM
*     level 7 is actually 7 - 10;  8 is 11 - 20;  9 is 21 - 100
*     free statement labels >=13
*
*     don't bother if no ionizing radiation
      if( .not.lgHe2ON ) then
        smiov2 = 0.
        create(2,2) = 0.
        destroy(2,2) = 0.
      else
        cion = 1.17e-5/sqrte*he2cbt(1)*eden
*       this is He++ over He+ (He ion over HeII)
        smiov2 = (he2gam(1)+cion+csupra)/(he2rtt*eden)
        create(2,2) = he2rtt*eden
        destroy(2,2) = he2gam(1)+cion
      endif
      collhe2 = cion
      sheiov2 = smiov2
      if( nzone.gt.1 ) then
        rfac = heiov2
      else
        rfac = smiov2
      endif
*     >>chng 96 May 8, was checking on smiov2, change to old soln
*     if( .not.lgHe2ON .or. smiov2.lt.1e-6 ) then
      if( .not.lgHe2ON .or. rfac.lt.1e-6 ) then
        if(lgHeBug.and.lgTrace ) then
          write(qq,'(5X,''HE2 simple I/2='',1P,E10.2,
     1    '' so not doing equilibrium.'')') smiov2
        end if
        do i=1,nhe2lvl
          he2bn(i) = 1.
          he2n(i) = 0.
          hhe2(i) = 0.
        end do
        he2bn(nhe2lvl+1) = 0.
        he2n(nhe2lvl+1) = 0.
        he22p = 0.
        he22s = 0.
        heiov2 = 0.
        he2ex = 0.
        recii = 0.
        return
      endif
*
*     check how low temperature is; departure coef tend to infinity
*     as TE goes to zero; matrix formalism won't work on a 32-bit machine
*     if EXP(H NU/KT)too big for ground state
      if( te.le.the2lo .or. he2lte(1).eq.0. .or. he2lte(2).eq.0. ) then
        he2ex = 0.
        he2bn(1) = 1.
        do i=2,nhe2lvl+1
          he2bn(i) = 1.
          he2n(i) = 0.
        end do
*       he2rtt was derived here, is sum of rad rec and escape prob
        recii = he2rtt
*
*       do simple two level, then fill in HN(i) for rest
        rdest = he2gam(1) + csupra
        if( rdest.gt.0. ) then
          he2n(1) = eden * recii / rdest
        else
          he2n(1) = 1e37
        endif
*       effective case B rec coef for low den limit Martin 1988
        he2n(4) = 1.44e-11 / (te70/te03/te03*te01) * eden / he2net(4,2)
        const = he2n(4) * he2net(4,2)
        he2n(3) = const * 14.5 / te10/te03/te03*te01 / he2net(3,2)
        he2n(5) = const * 0.291 * te03 * te01 / he2net(5,2)
        he2n(6) = const * 0.138 * te03*te01*te01 / he2net(6,2)
        he22s = he2rtt * eden / (8.23*16.) * 0.25
        he22p = he2rtt * eden / he2net(2,1) * 0.75
        he2n(2) = he22s + he22p
        heiov2 = 1. / he2n(1)
        if(lgHeBug.and.lgTrace ) then
          write(qq,'(5x,''low te, he2n(1)='',1p,e12.3
     1    ,'' rec='',E12.3,''HE2gam(1)='',E12.3)')
     2    he2n(1) , recii , he2gam(1)
        endif
        return
      endif
*-------------------------------------------------------------------
*
*     radiative and three body rec, fix 2s and 2p first
*     remember that HE2LTE(i) is only LTE pop when mult by Ne Nh
      z(10,11) = (he2r2s*he2rec(2,2)+he2rin(2)*0.25) / he2lte(10) +
     1 he2clc(2)*eden
      totcap(10) = z(10,11) * he2lte(10)
      recii = totcap(10)
*
      z(2,11) = (he2r2p*he2rec(2,2)+he2rin(2)*0.75) / he2lte(2)+
     1 he2clc(2)*eden
      totcap(2) = z(2,11) * he2lte(2)
      recii = recii + totcap(2)
*
      z(1,11) = (he2rec(1,1)*he2rec(1,2)+he2rin(1))/he2lte(1)
     1 +he2clc(1)*eden
      totcap(1) = z(1,11) * he2lte(1)
      recii = recii + totcap(1)
*
      do i=3,nhe2lvl
        z(i,11) = (he2rec(i,1)*he2rec(i,2)+he2rin(i))/he2lte(i) +
     1  he2clc(i)*eden
        totcap(i) = z(i,11) * he2lte(i)
        recii = recii + totcap(i)
      end do
*
*---------------------------------------------------------------------
*     now set up matrix for dreaded b(i)'s
*
*     level 1 balance equation
*     HE2CLL(u,l), etc, are rates for downward collisions (cm^3 s^-1)
*     corr of hi*1.7e-4 accounts for col ion by HI; Drawin Zs Phys 225, 483.
*     following is from Janev at 100eV
      x12ef = x12 / 3.
      z(1,1) = csupra + he2gam(1) + x12ef + he2coldn(1)*eden +
     1 he2clc(1)* eden + he2bul(1)
      gdist = z(1,1)
*
      z(1,2) = -( he2net(2,1) + he2con(2,1) +
     1 he2cll(2,1)*eden+x12ef/3.) * he2lte(2) / he2lte(1)
      z(1,3) = -( he2net(3,1) + he2con(3,1) +
     1 he2cll(3,1)*eden ) * he2lte(3) / he2lte(1)
      z(1,4) = -( he2net(4,1) + he2con(4,1) +
     1 he2cll(4,1)*eden ) * he2lte(4) / he2lte(1)
      z(1,5) = -( he2net(5,1) + he2con(5,1) +
     1 he2cll(5,1)*eden ) * he2lte(5) / he2lte(1)
      z(1,6) = -( he2net(6,1) + he2con(6,1) +
     1 he2cll(6,1)*eden ) * he2lte(6) / he2lte(1)
      z(1,7) = -( he2net(7,1) + he2con(7,1) +
     1 he2cll(7,1)*eden ) * he2lte(7) / he2lte(1)
      z(1,8) = -( he2net(8,1) + he2con(8,1) +
     1 he2cll(8,1)*eden ) * he2lte(8) / he2lte(1)
      z(1,9) = -( he2net(9,1) + he2con(9,1) +
     1 he2cll(9,1)*eden ) * he2lte(9) / he2lte(1)
      z(1,10) = -((8.23*16.)+x12ef + he2c2s1s*eden)*he2lte(10)/he2lte(1)
*
*     LEVEL 2P BALANCE EQUATION - 2p is higher energy than 2s
      edp = (eden * 0.1  +  hii * 0.9 )
      c = 0.75 / he2lte(2)
*     R is low density limit branching ratio for 2s-p (NOT l-mixed)
*     this is to simulate mixing of the n=3 level
      rfac = 0.32 - 0.07 * eden / ( eden + 1e7 )
      r = ( 1. - rfac ) / he2lte(2)
      z(2,1) = -( x12ef*0.67+he2cll(2,1)*eden+he2con(2,1)/he2bol(1,2))
      z(2,2) = he2gam(2)+ he2radn(2) + x12ef/3. + he2coldn(2)*eden +
     1 he2clc(2)*eden + he2c2p2se*eden + he2c2p2sp*hii + he2bul(2)+
     1 he2con(2,1)
*     >>chng 97 aug 2, break out 2s 2p protron and electron collisions
      z(2,3) = -(he2net(3,2)*r+(he2con(3,2)+he2cll(3,2)*eden)*c) *
     1 he2lte(3)
      z(2,4) = -(he2net(4,2)*r+(he2con(4,2)+he2cll(4,2)*eden)*c) *
     1 he2lte(4)
      z(2,5) = -(he2net(5,2)*r+(he2con(5,2)+he2cll(5,2)*eden)*c) *
     1 he2lte(5)
      z(2,6) = -(he2net(6,2)*r+(he2con(6,2)+he2cll(6,2)*eden)*c) *
     1 he2lte(6)
      z(2,7) = -(he2net(7,2)*r+(he2con(7,2)+he2cll(7,2)*eden)*c) *
     1 he2lte(7)
      z(2,8) = -(he2net(8,2)*r+(he2con(8,2)+he2cll(8,2)*eden)*c) *
     1 he2lte(8)
      z(2,9) = -(he2net(9,2)*r+(he2con(9,2)+he2cll(9,2)*eden)*c) *
     1 he2lte(9)
      z(2,10) = -he2c2p2se*eden - he2c2p2sp*hii
*
*     LEVEL 2S BALANCE EQUATION - define 2s as lower energy than 2p
      c = 0.25 / he2lte(10)
      r = rfac / he2lte(10)
*
      z(10,1) = -( x12ef*0.33 + he2c2s1s*eden )
      z(10,2) = -(he2c2p2se*eden + he2c2p2sp*hii)  * he2lte(2) /
     1  he2lte(10)
      z(10,3) = -(he2net(3,2)*r+(he2con(3,2)+he2cll(3,2)*eden)*c) *
     1  he2lte(3)
      z(10,4) = -(he2net(4,2)*r+(he2con(4,2)+he2cll(4,2)*eden)*c) *
     1  he2lte(4)
      z(10,5) = -(he2net(5,2)*r+(he2con(5,2)+he2cll(5,2)*eden)*c) *
     1  he2lte(5)
      z(10,6) = -(he2net(6,2)*r+(he2con(6,2)+he2cll(6,2)*eden)*c) *
     1  he2lte(6)
      z(10,7) = -(he2net(7,2)*r+(he2con(7,2)+he2cll(7,2)*eden)*c) *
     1  he2lte(7)
      z(10,8) = -(he2net(8,2)*r+(he2con(8,2)+he2cll(8,2)*eden)*c) *
     1 he2lte(8)
      z(10,9) = -(he2net(9,2)*r+(he2con(9,2)+he2cll(9,2)*eden)*c) *
     1 he2lte(9)
      z(10,10) = he2radn(10) + he2gam(2) + (he2coldn(10)+he2clc(2))*eden
     1 + x12ef + (he2c2p2se*eden+he2c2p2sp*hii)*3. + he2bul(2)
*
*     level 3
      z(3,1) = -(he2cll(3,1)*eden +
     1 ( he2con(3,1)*he2stat(3)/he2stat(1) ) *he2lte(1)/he2lte(3) )
      z(3,2) = -(he2cll(3,2)*eden + he2con(3,2)/he2bol(2,3) ) *0.75
      z(3,3) = he2gam(3)+he2radn(3) + (he2clc(3)+he2coldn(3))*eden +
     1 he2bul(3)
      z(3,4) =-(he2net(4,3)+he2con(4,3)+he2cll(4,3)*
     1 eden)* he2lte(4)/he2lte(3)
      z(3,5) =-(he2net(5,3)+he2con(5,3)+he2cll(5,3)*eden)*he2lte(5)/
     1 he2lte(3)
      z(3,6) =-(he2net(6,3)+he2con(6,3)+he2cll(6,3)*eden)*he2lte(6)/
     1 he2lte(3)
      z(3,7) =-(he2net(7,3)+he2con(7,3)+he2cll(7,3)*eden)*he2lte(7)/
     1 he2lte(3)
      z(3,8) =-(he2net(8,3)+he2con(8,3)+he2cll(8,3)*eden)*he2lte(8)/
     1 he2lte(3)
      z(3,9) =-(he2net(9,3)+he2con(9,3)+he2cll(9,3)*eden)*he2lte(9)/
     1 he2lte(3)
      z(3,10) = -(he2cll(3,2) *eden + he2con(3,2)/he2bol(2,3))*0.25
*
*     LEVEL 4
      z(4,1) = -he2cll(4,1) * eden - he2con(4,1)/he2bol(1,4)
      z(4,2) =-(he2cll(4,2) * eden + he2con(4,2)/he2bol(2,4)) * 0.75
      z(4,3) = -he2cll(4,3) * eden - he2con(4,3)/he2bol(3,4)
      z(4,4) = (he2coldn(4)+he2clc(4))*eden + he2radn(4) + he2gam(4)
     1 + he2bul(4)
      z(4,5) =-(he2net(5,4)+he2con(5,4)+he2cll(5,4)*eden)*he2lte(5)/
     1 he2lte(4)
      z(4,6) =-(he2net(6,4)+he2con(6,4)+he2cll(6,4)*eden)*he2lte(6)/
     1 he2lte(4)
      z(4,7) =-(he2net(7,4)+he2con(7,4)+he2cll(7,4)*eden)*he2lte(7)/
     1 he2lte(4)
      z(4,8) =-(he2net(8,4)+he2con(8,4)+he2cll(8,4)*eden)*he2lte(8)/
     1 he2lte(4)
      z(4,9) =-(he2net(9,4)+he2con(9,4)+he2cll(9,4)*eden)*he2lte(9)/
     1 he2lte(4)
      z(4,10) = -(he2cll(4,2) * eden + he2con(4,2)/he2bol(2,4))*0.25
*
*     LEVEL 5
      z(5,1) = -he2cll(5,1) * eden - he2con(5,1)/he2bol(1,5)
      z(5,2) =-(he2cll(5,2) * eden + he2con(5,2)/he2bol(2,5) ) *0.75
      z(5,3) = -he2cll(5,3) * eden - he2con(5,3)/he2bol(3,5)
      z(5,4) = -he2cll(5,4) * eden - he2con(5,4)/he2bol(4,5)
      z(5,5) = he2gam(5) + he2radn(5) + (he2coldn(5)+he2clc(5))*eden +
     1 he2bul(5)
      z(5,6) = -(he2net(6,5)+he2con(6,5)+he2cll(6,5)*eden)*he2lte(6)/
     1 he2lte(5)
      z(5,7) = -(he2net(7,5)+he2con(7,5)+he2cll(7,5)*eden)*he2lte(7)/
     1 he2lte(5)
      z(5,8) = -(he2net(8,5)+he2con(8,5)+he2cll(8,5)*eden)*he2lte(8)/
     1  he2lte(5)
      z(5,9) = -(he2net(9,5)+he2con(9,5)+he2cll(9,5)*eden)*he2lte(9)/
     1 he2lte(5)
      z(5,10) = -(he2cll(5,2) * eden + he2con(5,2)/he2bol(2,5))*0.25
*
*     level 6
      z(6,1) = -he2cll(6,1) * eden - he2con(6,1)/he2bol(1,6)
      z(6,2) =-(he2cll(6,2) * eden + he2con(6,2)/he2bol(2,6))* 0.75
      z(6,3) = -he2cll(6,3) * eden - he2con(6,3)/he2bol(3,6)
      z(6,4) = -he2cll(6,4) * eden - he2con(6,4)/he2bol(4,6)
      z(6,5) = -he2cll(6,5) * eden - he2con(6,5)/he2bol(5,6)
      z(6,6) = (he2coldn(6)+he2clc(6))*eden + he2gam(6) + he2radn(6) +
     1 he2bul(6)
      z(6,7) = -(he2net(7,6)+he2con(7,6)+he2cll(7,6)*eden)*he2lte(7)/
     1 he2lte(6)
      z(6,8) = -(he2net(8,6)+he2con(8,6)+he2cll(8,6)*eden)*he2lte(8)/
     1 he2lte(6)
      z(6,9) = -(he2net(9,6)+he2con(9,6)+he2cll(9,6)*eden)*he2lte(9)/
     1 he2lte(6)
      z(6,10) = -(he2cll(6,2) * eden + he2con(6,2)/he2bol(2,6))* 0.25
*
*     level 7
      z(7,1) = -he2cll(7,1) * eden - he2con(7,1)/he2bol(1,7)
      z(7,2) =-(he2cll(7,2) * eden + he2con(7,2)/he2bol(2,7))* 0.75
      z(7,3) = -he2cll(7,3) * eden - he2con(7,3)/he2bol(3,7)
      z(7,4) = -he2cll(7,4) * eden - he2con(7,4)/he2bol(4,7)
      z(7,5) = -he2cll(7,5) * eden - he2con(7,5)/he2bol(5,7)
      z(7,6) = -he2cll(7,6) * eden - he2con(7,6)/he2bol(6,7)
      z(7,7) = (he2coldn(7)+he2clc(7))*eden + he2gam(7) + he2radn(7) +
     1 he2bul(7)
      z(7,8) = -(he2net(8,7)+he2con(8,7)+he2cll(8,7)*eden)*he2lte(8)/
     1 he2lte(7)
      z(7,9) = -(he2net(9,7)+he2con(9,7)+he2cll(9,7)*eden)*he2lte(9)/
     1 he2lte(7)
      z(7,10) = -(he2cll(7,2) * eden + he2con(7,2)/he2bol(2,7))*0.25
*
*     level 8
      z(8,1) = -he2cll(8,1) * eden - he2con(8,1)/he2bol(1,8)
      z(8,2) =-(he2cll(8,2) * eden + he2con(8,2)/he2bol(2,8))* 0.75
      z(8,3) = -he2cll(8,3) * eden - he2con(8,3)/he2bol(3,8)
      z(8,4) = -he2cll(8,4) * eden - he2con(8,4)/he2bol(4,8)
      z(8,5) = -he2cll(8,5) * eden - he2con(8,5)/he2bol(5,8)
      z(8,6) = -he2cll(8,6) * eden - he2con(8,6)/he2bol(6,8)
      z(8,7) = -he2cll(8,7) * eden - he2con(8,7)/he2bol(7,8)
      z(8,8) = (he2coldn(8)+he2clc(8))*eden +he2gam(8) + he2radn(8) +
     1 he2bul(8)
      z(8,9) =-(he2net(9,8)+he2con(9,8)+he2cll(9,8)*eden)*he2lte(9)/
     1 he2lte(8)
      z(8,10) = -(he2cll(8,2)* eden + he2con(8,2)/he2bol(2,8))* 0.25
*
*     level 9
      z(9,1) = -he2cll(9,1) * eden - he2con(9,1)/he2bol(1,9)
      z(9,2) =-(he2cll(9,2) * eden + he2con(9,2)/he2bol(2,9))* 0.75
      z(9,3) = -he2cll(9,3) * eden - he2con(9,3)/he2bol(3,9)
      z(9,4) = -he2cll(9,4) * eden - he2con(9,4)/he2bol(4,9)
      z(9,5) = -he2cll(9,5) * eden - he2con(9,5)/he2bol(5,9)
      z(9,6) = -he2cll(9,6) * eden - he2con(9,6)/he2bol(6,9)
      z(9,7) = -he2cll(9,7) * eden - he2con(9,7)/he2bol(7,9)
      z(9,8) = -he2cll(9,8) * eden - he2con(9,8)/he2bol(8,9)
      z(9,9) = (he2coldn(9)+he2clc(9)) *eden + he2gam(9) + he2radn(9)
     1 + he2bul(9)
      z(9,10) = -(he2cll(9,2) * eden +he2con(9,2)/he2bol(2,9))* 0.25
*
      if( lgTrace.and.lgHe2Bug ) then
        do i=1,10
          write(qq,'(7X,''HeII'',I2,1P,11E10.2)') i,(z(i,j),j=1,11)
        end do
      endif
*
*     scale to largest number of order unity
      do j=1,nhe2lvl+1
        do i=1,nhe2lvl+2
          z(j,i) = z(j,i) * he2lte(j)
        end do
      end do
*
      call matin1( z,nhe2lvl+2,nhe2lvl+1,1,nerror)
      if(nerror.ne.0 ) then
        write(qq,'('' HE2LEV MATRIX ERROR, STOP.'')')
        stop
      endif
*
*     convert from departure coef in Z(I) to level pop rel to HeII
      he2bn(1) = z(1,11)
      he2n(1) = he2bn(1) * he2lte(1) * eden
      he2bn(2) = z(2,11)
      he2n(2) = he2bn(2) * he2lte(2) * eden
      do i=3,nhe2lvl
        he2bn(i) = z(i,11)
*       HE2N(I) are pop per level rel to HII; i.e., N(n)/N(HII)
        he2n(i) = he2bn(i) * he2lte(i) * eden
      end do
*
*     HE2EX is net cooling rate due to col ionization-three body rec (s-1 here)
      he2ex = 0.
      do i=1,nhe2lvl-2
*       units of HE2EX are erg/cm^3/s
        he2exx(i) = He2IonRyd(i) * he2clc(i) * eden *
     1  (he2n(i)-he2lte(i)*eden)
        he2ex = he2ex + he2exx(i)
      end do
      he2ex = he2ex * en1ryd
      sum = 0.
      do i=1,nhe2lvl
        effion(i) = (he2clc(i)*eden+he2gam(i))*(he2n(i)-he2lte(i)*eden)
        sum = sum + effion(i)
      end do
*
      he22p = he2n(2)
      he2bn(nhe2lvl+1) = z(nhe2lvl+1,11)
      he22s = he2bn(nhe2lvl+1) * he2lte(10) * eden
*     >>chng 96 apr 24, had not been set, hence was 0
      he2n(nhe2lvl+1) = he22s
      he2n(2) = he2n(2) + he22s
      heiov2 = he2n(1) + he2n(2) + he2n(3) + he2n(4) + he2n(5) + he2n(6)
*     HEIOV2 is He++ / He+
      heiov2 = 1. / heiov2
      he2ex = he2ex + en1ryd*anu(nhe2(2)) * he2clc(2) *
     1 eden*(he22s-he2lte(nhe2lvl+1)* eden)
*
      if( lgHe2Bug.and.lgTrace ) then
         write(qq,'(7X,''HE2LEV HE2GAM'',1P,10E9.2)') he2gam
         write(qq,'(7X,''HE2LEV TOTCAP'',1P,10E9.2,'' tot='',E9.2)')
     1   totcap , recii
         write(qq,'(7X,''HE2LEV IND Rc'',1P,10E9.2)') he2rin
         write(qq,'(7X,''HE2LEV IND As'',1P,10E9.2)') he2bul
         write(qq,'(7X,''HE2LEV HE2LTE'',1P,10E9.2)') he2lte
         write(qq,'(7X,''HE2LEV   HE2N'',1P,9E9.2,'' HeN2s,p'',2E9.2)')
     1   (he2n(i),i=1,nhe2lvl),he22s,he22p
         write(qq,'(7X,''HE2LEV   b(n)'',1P,9E9.2,''   2s,p'',2E9.2)')
     1   (he2bn(i),i=1,nhe2lvl) , he2bn(10) , he2bn(2)
*
         write(qq,'(7X,''HE2LEV   X12'',1P,E9.2,
     1   '' Heat Exc'',E9.2,'' Grn dest:'',E9.2)')
     2   x12ef,he2ex,gdist
      endif
*
      do i=1,nhe2lvl+1
        if( he2n(i).le.0. ) then
          write(qq,'('' HE2LEV finds negative population, ='',i3,1P
     1    ,E10.2,'' simple='',E10.3,'' Te='',E10.3)')
     1    i, he2n(i) , smiov2 ,te
          write(qq,'('' Populations were'',1p,10e10.2)') he2n
          call negcon
          call ShowMe
          stop
        endif
      end do
      if( lgTrace ) then
        write(qq,'(7X,''HE2LEV returns, HEIOV2 ='',1P,E10.2,
     1  '' simple='',E10.2,'' Gamm1='',E10.2,'' rec'',E10.2)')
     2  heiov2,smiov2,he2gam(1) , recii
      endif
*
      end
******************************************************************************
      subroutine he2col
      implicit none
*evaluate collisional rates for model helium ion
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      logical lgHeClON
*flag saying whether he collisions are turned on
*set false with helium collisions off command
      common/heclon/ lgHeClON
      logical lgC2psOn
*are collisions between 2s and 2p enabled?
      common/c2pson/ lgC2psOn
      real he2qin,he2rin
      common/he2ind/ he2qin(nhe2lvl+1),he2rin(nhe2lvl+1)
      logical lgCasBhs
      common/casbhs/ lgCasBhs
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision he2bol , he2cbt
      common/he2blt/ he2bol(nhe2lvl-1,nhe2lvl+1) , he2cbt(nhe2lvl+1)
      double precision he2lte
      real he2c2p2se , he2c2p2sp , he2c2s1s
*he2c2p2sp is collision rate coefficient for proton collisions from 2p to 2s
*he2c2p2se is collision rate coefficient for electron collisions from 2p to 2s
*he2c2s1 is collision rate coefficient for electron collisions from 2s to 1s
*he2lte is lte relative population density for helium ion
      common/he2crt/ he2lte(nhe2lvl+1), he2c2p2se,he2c2p2sp , he2c2s1s
      real he2coldn , he2bul , he2radn
*save collision, induced, and spontaneous rates for levels from helium ion
      common/he2cbr/ he2coldn(nhe2lvl+1) , he2bul(nhe2lvl+1) ,
     1 he2radn(nhe2lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
      real the2lo
      integer nhe2lo
      common/the2lo/ the2lo , nhe2lo
*energy differences for model he ion:
*this is array of temperatures, first between levels, sec lev to cont
*He2deltaT( upper , lower )
      real He2deltaTe, He2CionTe
      common/He2deltaT/ He2deltaTe(nhe2lvl,nhe2lvl), He2CionTe(nhe2lvl)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , j , n , iup , lo,ihi , ized
      real hd , tsq,t3,t4,cs12s,cs12p,hsfac,cs13,
     1 cs23,cs2s3s,cs2p3s, sum, told,f  , sexp
 
*
*     free statement labels, >=9
*
      real r1n(9) , r2n(9)
      real HydColIon , HydColDwn
      save told
*
       data
     3 r1n/3*0., 1.05e-8, 3.45e-9, 1.54e-9, 3.23e-10,2.14e-11,7.09E-14/
     4,r2n/2*0.,7.88e-8,1.14e-8,3.10e-9,1.10e-9,2.0e-10,1.0e-11,2.8E-14/
*
       data told/0./
*
* 666 error! this routine is constantly evaluated, and does not
*    protect itself from reevaluating coef at the same temperature.
*    this is an obvious simple speed up
*
*     define boltz facs between adjacent levels
      do iup=2,nhe2lvl
*       he2deltaTe is array of line temps, upper to lower
*       their boltzmann factors for this temp
        he2bol(iup-1,iup) = exp(-dble(He2deltaTe(iup,iup-1)/te))
      end do
*     this is 1s-2s
      he2bol(1,nhe2lvl+1) = he2bol(1,2)
*
*     the highest level, up to the continuum
      he2cbt(nhe2lvl) = exp( -dble(He2CionTe(nhe2lvl)/te) )
*
*     define remaining Boltzmann factors
      do j=1,nhe2lvl-2
        do i=j+2,nhe2lvl
          he2bol(j,i) = he2bol(j,i-1) * he2bol(i-1,i)
        end do
      end do
      do i=1,nhe2lvl-1
        he2cbt(i) = he2bol(i,nhe2lvl) * he2cbt(nhe2lvl)
      end do
      he2cbt(nhe2lvl+1) = he2cbt(2)
*
*-------------------------------------------------------------
*
*     define HE2LTE(I) = lte population (cm^3) / Ne Np
*     only used in HE2LEV if Te>1000K
      if( te.ge.the2lo*0.9 ) then
        f = 2.0708e-16 / te32
        do i=1,nhe2lvl
          he2lte(i) = he2stat(i) /  he2cbt(i) * f
        end do
        he2lte(nhe2lvl+1) = he2stat(nhe2lvl+1)/ he2cbt(2) * f
      else
        do i=1,nhe2lvl+1
          he2lte(i) = 0.
        end do
      endif
*
*-----------------------------------------------------------------------
*     evaluate all needed collisional and rad rates
*     collisions turned off, HD=0
*----------------------------------------------------------------------
*
      if( lgHeClON ) then
        hd = 1.
      else
        hd = 0.
      endif
      ized = 2
*     collisional ionization
      if( lgCasBhs ) then
        he2clc(1) = 0.
        he2clc(2) = 0.
      else
*       call colfit(2,1,0,te,he2clc(1) )
*       >>chng 97 mar 28 to new data set
        call cfit(2,1,te,he2clc(1) )
        he2clc(1) = he2clc(1) * hd
        he2clc(2) = HydColIon(2,ized)
      endif
      do n=3,nhe2lvl
*       this routine can only go up to 20
        he2clc(n) = HydColIon(n,ized) * hd
      end do
*
*     don't reevaluate downward coll if dT/T not large
*     he2cll is zero on very first call since zeroed in block
      if( abs(te-told)/te .lt.0.002 .and. he2cll(2,1).gt.0.) then
         if( lgTrace.and.lgHeBug) write(qq,'(7x,
     1   ''HE2COL called-no reval Cul'')')
*        (but still eval col below)
      else
         if( lgTrace )write(qq,'(7X,''HE2COL called-will reeval Cul'')')
         told = te
*
         if ( lgC2psOn ) then
*          from Osterbrock's book, fit to 10,000K - 20,000K
*          he2c2p2s = 1.13e-3 / te10 / te10
*          >>chng 97 aug 2, to
*          >>refer Zygelman, B. & Dalgarno, A. 1987, Phys.Rev.A, 35, 4085
           he2c2p2se = 6.1279139e-07 + 15.686661e-07 *sexp(te/171410.98)
           he2c2p2sp = 83.61586e-07 + 85.907401e-07 * sexp(te/387913.43)
         else
           he2c2p2se = 0.
           he2c2p2sp = 0.
         endif
*
         tsq = te  * te
         t3 = tsq * te
*        collision strengths for 1-2S, 1-2P, and 1-3 from, Table A2
*        >>refer Hummer, D.E., & Storey, P.J. MNRAS, 224, 801
*        this is their defn of T4, expansion only good to 10^5 K
         t4 = te / 1e4
         t4 = min( 10., t4 )
*        CS12S = 0.1435 - 1.156E-3*T4 + 7.442E-5*T4*T4 -
*    1   6.725E-6*T4**3
*        CS12P = 0.2908 + 2.657E-2*T4 - 1.736E-3*T4*T4 +
*    2   7.498E-5 * T4**3
*        following Table 2 of
*        >>refer Aggarwal, K.M., Callaway, J., Kingston, A.E., Unnikrishnan,
*        >>refer K. 1992, ApJS, 80, 473
         call he2cs123( 1,2,te,cs12s )
         call he2cs123( 1,3,te,cs12p )
*
*        C1N is deexcitation rate
*        following is 2P - 1S only
         he2cll(2,1) = cs12p / sqrte * 8.629e-6 / 6. * hd
*        following is 2S - 1S only
         he2c2s1s = cs12s / sqrte * 8.629e-6 / 2. * hd
*
*        option to turn off collisions from ground and n=2
         if( lgCasBhs .or. (hd.eq.0.) ) then
           hsfac = 0.
         else
           hsfac = 1.
         endif
*
         call he2cs123( 1 , 4, te,cs13 )
 
*        HE2CLL(u,l) is de-excitation rate from u to l
         he2cll(3,1) = cs13/ sqrte * 8.629e-6/18. * hsfac
*
         call he2cs123( 2 , 4, te,cs2s3s )
         call he2cs123( 3 , 4, te,cs2p3s )
         cs23 = cs2s3s + cs2p3s
         he2cll(3,2) = cs23 / sqrte * 8.629e-6 / 18. * hsfac
*
*        following is ratio of he+ to h collisions for exact calc
         f = 0.7
         do ihi=4,nhe2lvl
           he2cll(ihi,1) = r1n(ihi) / sqrte * hsfac * f
*          different temp denpendence is not a bug
           he2cll(ihi,2) = r2n(ihi) * hsfac * f
           do lo=3,ihi-1
*            following to scale up to blaha
*            >>chng 96 june 5, factor to get better agreement with agrawall
             he2cll(ihi,lo) = HydColDwn(ihi,lo,ized) * hd
           end do
         end do
*
         if( lgTrace.and.lgHe2Bug ) then
           write(qq,'(7X,''HE2COL rate n->n-1:'',1P,8E10.3,'' 2S1'',
     1     e9.2)') (he2cll(i+1,i),i=1,8),he2c2s1s
           write(qq,'(7X,''HE2COL col ion cof:'',1P,9E10.3)') he2clc
           write(qq,'(7X,''HE2COL rate down 1:'',1P,9E10.3)')
     1     (he2cll(i,1),i=1,9)
           write(qq,'(7X,''HE2COL rate down 2:'',1P,9E10.3)')
     1     (he2cll(i,2),i=1,9)
           write(qq,'(7X,''HE2COL rate down 3:'',1P,9E10.3)')
     1     (he2cll(i,3),i=1,9)
           write(qq,'(7X,''HE2COL rate down 4:'',1P,9E10.3)')
     1     (he2cll(i,4),i=1,9)
           write(qq,'(7X,''HE2COL rate down 5:'',1P,9E10.3)')
     1     (he2cll(i,5),i=1,9)
           write(qq,'(7X,''HE2COL boltz fac c:'',1P,9E10.3)') he2cbt
           write(qq,'(7X,''HE2COL HE2LTE(i):  '',1P,10E10.3)') he2lte
           write(qq,'(7X,''HE2COL       C2P2S='',1P,2e10.3)') he2c2p2se,
     1     he2c2p2sp
        endif
      endif
*
      if( he2lte(1).gt.0. ) then
*     following are eden independent, used in hlevel
      he2coldn(1) = (he2cll(2,1)*he2lte(2) + he2c2s1s*he2lte(10) +
     1     he2cll(3,1)*he2lte(3) + he2cll(4,1)*he2lte(4) +
     2 he2cll(5,1)*he2lte(5) + he2cll(6,1)*he2lte(6) +
     3 he2cll(7,1)*he2lte(7) + he2cll(8,1)*he2lte(8) +
     4 he2cll(9,1)*he2lte(9) ) / he2lte(1)
*
*     SUM is total rate from high states to both 2s and 2p
      sum = (he2cll(3,2)*he2lte(3) + he2cll(4,2)*he2lte(4) +
     1 he2cll(5,2)*he2lte(5) + he2cll(6,2)*he2lte(6) +
     2 he2cll(7,2)*he2lte(7) + he2cll(8,2)*he2lte(8) +
     3 he2cll(9,2)*he2lte(9) ) / ( he2lte(2) + he2lte(10) )
*
*     HE2CLL(2,1) is 2p - 1s rate; he2c2s1s is 2s - 1s rate
      he2coldn(2) = sum + he2cll(2,1)
      he2coldn(10) = sum + he2c2s1s
*
      he2coldn(3) = he2cll(3,1) + he2cll(3,2) + (he2cll(4,3)*he2lte(4) +
     1 he2cll(5,3)* he2lte(5) + he2cll(6,3)*he2lte(6) +
     2 he2cll(7,3)*he2lte(7) + he2cll(8,3)*he2lte(8) +
     3 he2cll(9,3) *he2lte(9) ) /he2lte(3)
*
      he2coldn(4) = he2cll(4,1) + he2cll(4,2) + he2cll(4,3) +
     1 (he2cll(5,4)*he2lte(5) + he2cll(6,4)*he2lte(6) +
     2 he2cll(7,4)*he2lte(7) + he2cll(8,4)*he2lte(8) +
     3 he2cll(9,4)*he2lte(9) ) / he2lte(4)
*
      he2coldn(5) = (he2cll(6,5)*he2lte(6) + he2cll(7,5)*he2lte(7) +
     1 he2cll(8,5)*he2lte(8) + he2cll(9,5)*he2lte(9)) /he2lte(5) +
     2 he2cll(5,1) + he2cll(5,2) + he2cll(5,3) + he2cll(5,4)
*
      he2coldn(6) = he2cll(6,1) + he2cll(6,2) + he2cll(6,3) +
     1 he2cll(6,4) +
     1 he2cll(6,5) + ( he2cll(7,6)*he2lte(7) + he2cll(8,6)*he2lte(8) +
     2 he2cll(9,6)*he2lte(9) ) /he2lte(6)
*
      he2coldn(7) = he2cll(7,1) + he2cll(7,2) + he2cll(7,3) +
     1 he2cll(7,4) +
     1 he2cll(7,5) + he2cll(7,6) + ( he2cll(8,7)*he2lte(8) +
     2 he2cll(9,7)*he2lte(9) ) /he2lte(7)
*
      he2coldn(8) = he2cll(8,1) + he2cll(8,2) + he2cll(8,3)+he2cll(8,4)
     1 + he2cll(8,5) + he2cll(8,6) + he2cll(8,7) +
     2 he2cll(9,8)*he2lte(9)/he2lte(8)
*
      he2coldn(9) = he2cll(9,1) + he2cll(9,2) + he2cll(9,3) +
     1 he2cll(9,4)
     1       + he2cll(9,5) + he2cll(9,6) + he2cll(9,7) + he2cll(9,8)
*
      if( lgTrace.and.lgHe2Bug ) then
        write(qq,'(7X,''HE2CLL he2coldn(n)      '',1P,10E10.3)')
     1  (he2coldn(i),i=1,10)
        write(qq,'(7X,''HE2CLL he2radn(n)      '',1P,10E10.3)')
     1  (he2radn(i),i=1,10)
        write(qq,'(7X,''HE2CLL he2bul(n)      '',1P,10E10.3)')
     1  (he2bul(i),i=1,10)
      endif
      else
        do n=1,nhe2lvl
          he2coldn(n) = 0.
        end do
      endif
*
      end
******************************************************************************
      subroutine he2rad
      implicit none
*evaluate radiative rates for model helium ion
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real otsmin
      common/otsmin/ otsmin
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he2r2s , he2r2p
      common/he2rsp/ he2r2s , he2r2p
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real peshe2
*     stark broadening escape prob for HeII
      common/he2str/ peshe2(nhe2lvl,nhe2lvl)
      real he2esc
      common/he2esc/ he2esc(9,9)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      real he2as
      common/he2as/ he2as(9,8)
      real he2coldn , he2bul , he2radn
*save collision, induced, and spontaneous rates for levels from helium ion
      common/he2cbr/ he2coldn(nhe2lvl+1) , he2bul(nhe2lvl+1) ,
     1 he2radn(nhe2lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
      real he2rb , he2rtt
      common/he2rb/ he2rb , he2rtt
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real htus , he1tus , he2tus, he3tus
      common/tusedcom/ htus , he1tus , he2tus, he3tus
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      real he2net
      common/he2net/ he2net(nhe2lvl,nhe2lvl-1)
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real a , b , c , recf,t12old,t23old,receff,alogtz,tz,x,
     1 he2jbr
      integer i,j , n
*
      data t12old,t23old/2*0./
*
      recf(a,b,c) = a + b * (alogtz-c)**2
*
*     free statement numbers >=8
*
*     evaluate rec coef for H,
*     he2rec(i,1) is rad rec
*     he2rec(i,2) is recomb efficiency,
*     he2rec(i,3) is escape probability
*
      if( lgNewIon ) then
        do n=1,nhe2lvl
          he2rec(n,3) = receff( nhe2(n) )
        end do
      endif
*
      if( lgCaseb ) then
        he2rec(1,3) = 1e-10
      endif
*
      do n=1,nhe2lvl
        he2rec(n,3) = max( he2rec(n,3) , otsmin )
*       last factor accounts for metal absorption of HeII diffuse
*       fields, computed in AddOpac, this is counted as recombination
        he2rec(n,2) = min(1.,he2rec(n,3)+(1.-he2rec(n,3))*
     1  ophe2f(n))
      end do
      he2rec(nhe2lvl+1,2) = he2rec(2,2)
      he2rec(nhe2lvl+1,3) = he2rec(2,3)
*
      if( lgTrace.and.lgHe2Bug ) then
        write(qq,'(7X,''HE2RAD geo recomb effic'',1P,9E10.3)')
     1  (he2rec(i,3),i=1,nhe2lvl)
        write(qq,'(7X,''HE2RAD net recomb effic'',1P,9E10.3)')
     1  (he2rec(i,2),i=1,nhe2lvl)
      endif
*
      tz = te / 4.
      if( abs(he2tus-te)/he2tus.gt. 0.002 ) then
        he2tus = te
        if( tz.gt.1e5 ) then
          he2rec(1,1) = 2.*1.52e-9 * 3.580 / te * te10 /te01/te01
        else if( tz.gt.2.6e4 ) then
          he2rec(1,1) = 2.*5.55e-11*2.395/ (te70/te10*te03)
        else if( tz.gt.2500. ) then
          he2rec(1,1) = 2.*2.08e-11*2.085 / (  sqrte*te03  )
        else
*         low te rec from Martin (1988)
          he2rec(1,1) = 2.*1.64e-11 *2. / sqrte
        endif
*
        x = 157900. / te
*       this is trick temp for hydrogenic recomb
        alogtz = alogte - 0.60206
*
        he2r2s =   0.92*2. * 10.** (-recf(8.9776,.06256,7.2302)) / tz
        he2r2p =   0.92*2. * 10.** (-recf(9.1508,.12667,4.9748)) / tz
        he2rec(2,1) = he2r2p
        he2rec(nhe2lvl+1,1) = he2r2s
        he2rec(3,1) = 2.*10.** (-recf( 9.2150 , .12898  , 4.9933 ))/tz
        he2rec(4,1) = 2.*10.** (-recf( 9.4583 , .12236  , 4.7567 ))/tz
        he2rec(5,1) = 2.*10.** (-recf( 9.6516 , .11481  , 4.5614 ))/tz
        he2rec(6,1) = 2.*10.** (-recf( 9.8112 , .10747  , 4.3913 ))/tz
        he2rec(7,1) = 2.*10.** (-recf( 9.4942 , .093811 , 4.0473 ))/tz
        he2rec(8,1) = 2.*10.** (-recf( 9.5858 , .070572 , 3.2727 ))/tz
        he2rec(9,1) = 2.*10.** (-recf( 9.5028 , .045593 , 1.4592 ))/tz
*
*       >>chng 96 june 5, big jump in rec coef at level7 (old cota level)
*causes maser in 7 -6 - don't let this happen, add extro to top level
* 666 error! change this to true levels, like Jason's hydrogen
*       b factor is amount rec coef should decrease
        b = 0.75
        do i=7,nhe2lvl-1
          a = he2rec(i,1) - he2rec(i-1,1)*b
*         amount we will subtract from here, then add to highest n
          he2rec(i,1) = he2rec(i,1) - a
          he2rec(nhe2lvl,1) = he2rec(nhe2lvl,1) + a
        end do
*
        he2rtt = he2rec(1,1)*he2rec(1,2)
        he2rb = 0.
        do i=2,nhe2lvl
          he2rtt = he2rtt + he2rec(i,1)*he2rec(i,2)
          he2rb = he2rb + he2rec(i,1)
        end do
        if( lgTrace.and.lgHe2Bug ) then
          write(qq,'(7X,''HE2RAD eval rec cof'',1P,9E10.3)')
     1    (he2rec(i,1),i=1,nhe2lvl)
          write(qq,'(7X,''HE2RAD total effective recombination coef'',
     1    1p,e10.3,'' Case B, A='',2E10.3)')
     2    he2rtt , he2rb , he2rb+he2rec(1,1)
        endif
      else
        he2rtt = he2rec(1,1)*he2rec(1,2)
        he2rb = 0.
        do i=2,nhe2lvl
          he2rtt = he2rtt + he2rec(i,1)*he2rec(i,2)
          he2rb = he2rb + he2rec(i,1)
        end do
        if( lgTrace.and.lgHe2Bug ) then
          write(qq,'(7X,''HE2RAD not reevel rec ''
     1    ,''cof, total effective recombination coef is '',1P,E10.3)')
     2    he2rtt
        end if
      endif
*
*     >>chng 97 feb 10, killed following, which prevented needed updates in pump
*     skip optical depths if this is >second try on this zone
*     search is true if initial search is on
*     if( t12old.eq.he2nxt(2,1) .and. t23old.eq.he2nxt(3,2).and.
*    1  .not.lgSearch ) then
*       if(lgTrace.and.lgHe2Bug)write(qq,'(7X,''HE2RAD does NOT reeval As''
*    1  )')
*       return
*     else
*       if(lgTrace.and.lgHe2Bug) write(qq,'(7X,''HE2RAD eval As'')')
*     endif
*
      t12old = he2nxt(2,1)
      t23old = he2nxt(3,2)
*
      do j=1,nhe2lvl-1
        do i=j+1,nhe2lvl
*         >>chng 96 may 13, cap of 1 prevented maser emission
*         he2mis(i,j) = he2as(i,j)*min(1.,(he2esc(i,j)+peshe2(i,j)))
          he2mis(i,j) = he2as(i,j)*(he2esc(i,j)+peshe2(i,j))
          he2net(i,j) = he2mis(i,j) + he2dst(i,j)
        end do
      end do
*
*     these are used in HLEVEL - total decay rates
      he2radn(2) = he2net(2,1)
      he2radn(10) = (8.23*16.)
      he2radn(3) = he2net(3,1) + he2net(3,2)
      he2radn(4) = he2net(4,1) + he2net(4,2) + he2net(4,3)
      he2radn(5) = he2net(5,1) + he2net(5,2) + he2net(5,3) + he2net(5,4)
      he2radn(6) = he2net(6,1) + he2net(6,2) + he2net(6,3) +he2net(6,4)+
     1 he2net(6,5)
      he2radn(7) = he2net(7,1) + he2net(7,2) + he2net(7,3) +he2net(7,4)+
     1 he2net(7,5) + he2net(7,6)
      he2radn(8) = he2net(8,1) + he2net(8,2) + he2net(8,3) +he2net(8,4)+
     1 he2net(8,5) + he2net(8,6) + he2net(8,7)
      he2radn(9) = he2net(9,1) + he2net(9,2) + he2net(9,3) +he2net(9,4)+
     1 he2net(9,5) + he2net(9,6) + he2net(9,7) + he2net(9,8)
*
*     >>chng 97 feb 10, underflow caused neg level pops, other problems
      if( he2con(2,1).lt.1e-12*he2radn(2) ) then
        do i=2,nhe2lvl
          he2con(i,1) = 0.
        end do
      endif
*
*     total rates out of level due to induced processes
      he2bul(1) = (he2con(2,1)*he2stat(2) + he2con(3,1)*he2stat(3) +
     1 he2con(4,1)*he2stat(4) + he2con(5,1)*he2stat(5) + he2con(6,1)*
     1 he2stat(6) + he2con(7,1)*he2stat(7)+ he2con(8,1)*he2stat(8)+
     2 he2con(9,1)*he2stat(9) ) / he2stat(1)
*
*     if( he2bul(1).gt.)
*    1  write(6,'(''>>>bul1'',1p,10e9.1)')
*    1  he2con(2,1)*he2stat(2)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(3,1)*he2stat(3)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(4,1)*he2stat(4)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(5,1)*he2stat(5)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(6,1)*he2stat(6)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(7,1)*he2stat(7)/(he2stat(1)*he2bul(1)) ,
*    1  he2con(8,1)*he2stat(8)/(he2stat(1)*he2bul(1)) ,
*    2  he2con(9,1)*he2stat(9)/(he2stat(1)*he2bul(1))
*     write(6,'(''>>>con1'',1p,10e9.1)')(he2con(i,1),i=2,9)
*
      he2bul(2) = (he2con(3,2)*he2stat(3) + he2con(4,2)*he2stat(4)
     1 + he2con(5,2)*he2stat(5) + he2con(6,2)*he2stat(6) +he2con(7,2)*
     1  he2stat(7) + he2con(8,2)*he2stat(8) + he2con(9,2)*he2stat(9))
     2 / ( he2stat(2) + he2stat(10) )
      he2bul(3) = he2con(3,1) + he2con(3,2) + ( he2con(4,3)*he2stat(4) +
     1 he2con(5,3)*he2stat(5) + he2con(6,3)*he2stat(6) + he2con(7,3)*
     1 he2stat(7) + he2con(8,3)*he2stat(8) + he2con(9,3)*he2stat(9))/
     2 he2stat(3)
      he2bul(4) = he2con(4,1) +he2con(4,2) +he2con(4,3)+
     1 (he2con(5,4)*he2stat(5) + he2con(6,4)*he2stat(6) +
     2 he2con(7,4)*he2stat(7)+he2con(8,4)*he2stat(8)+
     3 he2con(9,4)*he2stat(9)) / he2stat(4)
      he2bul(5) = he2con(5,1) + he2con(5,2) + he2con(5,3) + he2con(5,4)+
     1( he2con(6,5)*he2stat(6) + he2con(7,5)*he2stat(7) +
     2 he2con(8,5)*he2stat(8)+he2con(9,5)*he2stat(9) ) / he2stat(5)
      he2bul(6) = he2con(6,1) + he2con(6,2) + he2con(6,3) + he2con(6,4)+
     1 he2con(6,5) + (he2con(7,6)*he2stat(7) +he2con(8,6)*he2stat(8)
     2 + he2con(9,6)*he2stat(9) ) / he2stat(6)
      he2bul(7) = he2con(7,1) + he2con(7,2) + he2con(7,3) + he2con(7,4)+
     1 he2con(7,5) + he2con(7,6) +
     2 (he2con(8,7)*he2stat(8)+he2con(9,7)*he2stat(9) ) /he2stat(7)
      he2bul(8) = he2con(8,1)+he2con(8,2)+he2con(8,3)+he2con(8,4)+
     1 he2con(8,5)+he2con(8,6)+he2con(8,7)+
     2 he2con(9,8)*he2stat(9)/he2stat(8)
      he2bul(9) = he2con(9,1)+he2con(9,2)+he2con(9,3)+he2con(9,4)+
     1 he2con(9,5)+he2con(9,6)+he2con(9,7)+he2con(9,8)
*
      if( lgTrace.and.lgHe2Bug ) then
        write(qq,'(7X,''HE2RAD finds arrays, with optical depths defi''
     1  ,''ned? '',L1)') lgTauOutOn
        do i=2,nhe2lvl
          write(qq,'(6X,''up:'',I2,10I10)') i,(j,j=1,i-1)
          write(qq,'(9X,''A*esc'',1P,8E10.2)') (he2mis(i,j)  ,j=1,i-1)
          write(qq,'(9X,''A-net'',1P,8E10.2)') (he2net(i,j)  ,j=1,i-1)
          write(qq,'(9X,''A*Dst'',1P,8E10.2)') (he2dst(i,j)  ,j=1,i-1)
          write(qq,'(9X,''tauin'',1P,8E10.2)') (he2nxt(i,j)  ,j=1,i-1)
          write(qq,'(9X,''t tot'',1P,8E10.2)') (he2lim(i,j)  ,j=1,i-1)
          write(qq,'(9X,''Esc  '',1P,8E10.2)') (he2esc(i,j)  ,j=1,i-1)
          write(qq,'(9X,''StrkE'',1P,8E10.2)') (peshe2(i,j)  ,j=1,i-1)
          write(qq,'(9X,''B(ul)'',1P,8E10.2)') (he2con(i,j)  ,j=1,i-1)
          write(qq,'(9X,''OccNm'',1P,8E10.2)') (he2jbr(i,j)  ,j=1,i-1)
          write(qq,'(9X,''C(ul)'',1P,8E10.2)')(he2cll(i,j)*eden,j=1,i-1)
        end do
*
        write(qq,'(14X,10I9)') (i,i=1,10)
        write(qq,'(7X,''HE2RAD  rad'',1P,10E9.2)')
     1  (he2radn(i),i=1,10)
        write(qq,'(7X,''HE2RAD  bul'',1P,10E9.2)')
     1  (he2bul(i),i=1,10)
      endif
*
      end
******************************************************************************
      subroutine he2gma( gam32 , he2la )
      implicit none
*evaluate photoionization rates for model helium ion
      real gam32 , he2la
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer limelm
      parameter (limelm=30)
      double precision he2lte
      real he2c2p2se , he2c2p2sp , he2c2s1s
*he2c2p2sp is collision rate coefficient for proton collisions from 2p to 2s
*he2c2p2se is collision rate coefficient for electron collisions from 2p to 2s
*he2c2s1 is collision rate coefficient for electron collisions from 2s to 1s
*he2lte is lte relative population density for helium ion
      common/he2crt/ he2lte(nhe2lvl+1), he2c2p2se,he2c2p2sp , he2c2s1s
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      double precision he2bol , he2cbt
      common/he2blt/ he2bol(nhe2lvl-1,nhe2lvl+1) , he2cbt(nhe2lvl+1)
      real he2qin,he2rin
      common/he2ind/ he2qin(nhe2lvl+1),he2rin(nhe2lvl+1)
      real he2cin
      common/he2cin/ he2cin(10)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real te , eden , hden
      common/phycon/ te , eden , hden
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real hhe2
      common/hhe2/ hhe2(nhe2lvl)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer iophe2
      common/iophe2/ iophe2(9)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      real He2IonRyd
*ionization potential of level n in Ryd for HeII ion
      common/He2NIonRyd/ He2IonRyd(nhe2lvl+1)
      real PhotScaleOn
*     set to 1 in zero, so have no effect
*     set to 0 with 'no photoionization' command, kills
*     photoionization of everything
      common/PhotScale/ PhotScaleOn
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , n
      real bnfun
      real ghe2(nhe2lvl) , he2cn(nhe2lvl)
      save ghe2 , he2cn
*
*     free statement labels >= 6
*
*     photoionization rates
*     He II ground state ionization
      if( lgDoPhoto ) then
*       induced rec
*       FIN is relat to induc rec rate, HE2CN is related to cooling
        ghe2(1) = bnfun( nhe2(1) , nflux , iophe2(1) , 4.0 ,
     1  he2qin(1) , he2cn(1) ) * PhotScaleOn
        gam32 = secion
        hhe2(1) = h
        he2la = secla
        he2gam(1) = ghe2(1)
        PhotoRate(2,2,1,1) = ghe2(1)
        PhotoRate(2,2,1,2) = hhe2(1)
        do n=2,nhe2lvl
          ghe2(n) = bnfun( nhe2(n) , nhe2(1) , iophe2(n) ,
     1    He2IonRyd(n) , he2qin(n) , he2cn(n) ) * PhotScaleOn
          hhe2(n) = h
          he2gam(n) = ghe2(n)
        end do
      endif
*
*     induced recombination rate
      he2rin(1) = he2qin(1) * he2lte(1)
      he2rin(2) = he2qin(2) * (he2lte(2)+he2lte(10))
      he2cin(1) = he2cn(1) * he2lte(1)
      he2cin(2) = he2cn(2) * (he2lte(2)+he2lte(10))
      do n=3,nhe2lvl
*       induced recombination rate
        he2rin(n) = he2lte(n) * he2qin(n)
*       coooing due to induced recombination
        he2cin(n) = he2cn(n) * he2lte(n)
      end do
*
      if( lgTrace.and.lgHe2Bug ) then
        if( lgDoPhoto ) then
          write(qq,'(5X,''HE2GMA finds photo rates:'',1P,7(I2,E9.2))')
     1    (i,he2gam(i),i=1,7)
        else
          write(qq,'(5X,''HE2GMA does not reeval photoioniz rates.'')')
        endif
      endif
*
      end
************************************************************************
       subroutine he2cs123(i,j,temp,cs)
       implicit none
*line collision strengths for lower levels of helium ion, n=1,2,3, by K Korista
       real temp
       integer i,j
       real cs, cs3s, cs3p, cs3d, t, a, b, c
*
*      These are fits to Table 2
*      >>refer Aggarwal, K.M., Callaway, J., Kingston, A.E., Unnikrishnan, K.
*      >>refer 1992, ApJS, 80, 473
*      He II collision strengths for 1s-2s, 1s-2p, 1s-3, 2s-3, and 2p-3,
*      principle quantum numbers n and l.
*      CLOUDY sums angular momentum (s,p,d) components of level n=3.
*
*      i is the lower level and runs from 1 to 3 (1s, 2s, 2p)
*      j is the upper level and runs from 2 to 4 (2s, 2p, 3)
*      check temperature: fits only good between 5,000K and 500,000K
*
       t = temp
       if(t .lt. 5000.) then
         t = 5000.
       else if(t .gt. 5.0e+05) then
         t = 5.0e+05
       endif
 
**************fits begin here**************
 
       if( i .eq. 1 .and. j .eq. 2 ) then
* 1s - 2s
         a = 0.12176209
         b = 0.039936166
         c = 143284.77
 
         cs = a + b*exp(-t/c)
 
       else if ( i .eq. 1 .and. j .eq. 3 ) then
* 1s - 2p
         a = 0.32916723
         b = 2.9711166e-05
         c = 0.73158545
 
         cs = a + b*t**c
 
       else if ( i .eq. 1 .and. j .eq. 4 ) then
* 1s - 3s
         a = 0.46546497
         b = -0.020835863
         c = -2.159172
 
         cs3s = a + b*alog(t) + c/alog(t)
 
* 1s - 3p
         a = 0.044501688
         b = 3.0508137e-04
         c = 0.43254802
 
         cs3p = a + b*t**c
 
* 1s - 3d
         a = 0.040523277
         b = -2.004485e-15
         c = 2.1338557
 
         cs3d =  a + b*t**c
 
         cs = cs3s + cs3p + cs3d
 
       else if (i .eq. 2 .and. j .eq. 4) then
* 2s - 3s
         a = 0.5234889
         b = 4.41475e-06
         c = 8.9899702e-06
 
         cs3s = (a + c*t)/(1 + b*t)
 
* 2s - 3p
         a = 1.4903214
         b = 1.0622666e-05
         c = -2.9001451e-12
 
         cs3p = a + b*t + c*t*t
 
* 2s - 3d
         a = 1.4215094
         b = 2.0538877e-06
         c = 1.762076e-05
 
         cs3d = (a + c*t)/(1 + b*t)
 
         cs = cs3s + cs3p + cs3d
 
       else if (i .eq. 3 .and. j .eq. 4) then
* 2p - 3s
         a = 1.0295881
         b = 0.80638448
         c = 52741.735
 
         cs3s = a + b*exp(-t/c)
 
* 2p - 3p
         a = 4.769306
         b = 2.0967075e-06
         c = -2153.1219
 
         cs3p = a + b*t + c/t
 
* 2p - 3d
         a = 9.7226127
         b = 7.6089851e-05
         c = -3.3996921e-11
 
         cs3d = a + b*t + c*t*t
 
         cs = cs3s + cs3p + cs3d
 
       else
 
**************fits end here**************
         write(6,*) '  insane levels for He II n=1,2,3 !!!'
         stop
       endif
       end
******************************************************************************
      real function he2jbr( ihi , low )
      implicit none
*returns continuum occupation number for any helium ion line
      integer ihi , low
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*begin sanity check
      if( iphe2l(ihi,low).le.0 .or. iphe2l(ihi,low).gt.ncell ) then
        write(qq,'('' he2jbr insane hei line pointer:'',i5,
     1  '' ihi,low='',2i5)') iphe2l(ihi,low),ihi,low
        call ShowMe
        stop
      endif
*end sanity check
*
      if( lgFluor ) then
        he2jbr = occnum( iphe2l(ihi,low) )
      else
*       option to turn off continuum fluorsecent excitation with
*       "no induced" command
        he2jbr = 0.
      endif
*
      end
******************************************************************************
      subroutine he3lev( he2ov3 )
      implicit none
*compute ionization balance level populations for helium triplets
      double precision he2ov3
*
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real reci , rectri , recii
      common/herec/ reci , rectri , recii
      integer ioptri
      common/ioptri/ ioptri
      real he3lte
      common/he3lte/ he3lte(nhe3lvl)
      real c2p2s,c2s2p,c3s2s,c2s3s,c3p2s,c2s3p,c3d2s,
     1 c2s3d,c3s2p,c2p3s,c3p2p,c2p3p,c3d2p,c2p3d,c2sion,c2pion
      common/he3c/ c2p2s,c2s2p,c3s2s,c2s3s,c3p2s,c2s3p,c3d2s,
     1 c2s3d,c3s2p,c2p3s,c3p2p,c2p3p,c3d2p,c2p3d,c2sion,c2pion
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      double precision he3bn
      common/he3bn/ he3bn(nhe3lvl)
      real cs2s2s,c2ss2s,cs2p2s,c2ss2p,c2pg,c2sg,c2ps2s,
     1 c2ps2p,cs2p2p,cs2s2p,csg2s,csg2p
      common/che2sn/ cs2s2s,c2ss2s,cs2p2s,c2ss2p,c2pg,c2sg,c2ps2s,
     1 c2ps2p,cs2p2p,cs2s2p,csg2s,csg2p
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real a10830,a3889,a5876,a7065,a4,a19,a591,a2sg
      common/he3as/ a10830,a3889,a5876,a7065,a4,a19,a591,a2sg
      real DR10830 , r10830 , DstPrb10830
*DstPrb10830 destruction probability for 10830
*DR10830 A times prob for destruction
*r10830 is total rate from 2p to 2s
      common/d10830/ DR10830 , r10830 , DstPrb10830
      real r2s, r2p, r3s, r3p, r3d
      common/he3rr/ r2s, r2p, r3s, r3p, r3d
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real he10in
      common/heinwd/ he10in
      real he3n
      common/he3n/ he3n(nhe3lvl)
      real he3gam , He3FrLya
*     total photoionization rates for helium triplest
*     He3FrLya is fraction of this that is Lya
      common/he3gams/ he3gam(nhe3lvl) , He3FrLya
      real r2s3bd,r2p3bd
      common/r2s3bd/ r2s3bd,r2p3bd
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      real he3pht , he3lya , he3local , he3relax
*     he3relax is fraction of 23s populations that go to singlets
      common/he3pht/ he3pht , he3lya , he3local , he3relax
      real he3hsv
      common/he3hsv/ he3hsv(2)
      real He3IonCool
*cooling due to collisional ionization of helium triplets
      common/cionhe/ He3IonCool
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real collhe3 , she2ov3
      common/he3rate/ collhe3 , she2ov3
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgNegPop
      integer i,j,nerror
      real out2,csphot,sum,dest,hlgam
*
      double precision zz(6,6) , ratio
*     free statement labels >= 9
*
*     NOTATION;
*     1-2S  2-2P  3-3S  4-3P  5-3D
*
      if( lgTrace.and.lgHe3Bug ) write(qq,'('' HE3LEV called.  HeI, '',
     1''HeII, HeIII='',1P,3E10.2)') hei , heii , heiii
*     last number was 1e-15 before 95 nov 14, changed to get ldl.in to work
*     several bugs present in following code, he3n was pop cm^-3, not rel
*     to ion
*
*     estimate simple he triplet population
      if( eden.gt.0. ) then
*       estimate of HeII/He3I
*       >>chng 96 oct 27, to exact expression from hazy
*    1  ( 0.365/(te*te10*te10) )
        she2ov3 = (1.+3110.*(te/1e4)**(-0.51)/eden) /
     1  (  5.79e-6*(te/1e4)**(-1.18) )
      else
        she2ov3 = 0.
      endif
      if(.not.lgHe1ON .or. heii.lt.1e-20 ) then
        do i=1,nhe3lvl
          he3n(i) = 0.
*         >>chng 96 july 16, was set to 0, change to 1
          he3bn(i) = 1.
        end do
        he2ov3 = she2ov3
        hei3 = heii/he2ov3
        he3local = 0.
        he3relax = 1.
*       >>chng 96 july 12, following ratio was inverted, fixed 90.01
*       he3n(1) = he2ov3
        if( he2ov3.gt.1e-25 ) then
*         this is ratio of 23S to ion
          he3n(1) = 1./he2ov3
        else
          he3n(1) = 0.
        endif
        he3hsv(1) = 0.
        he3hsv(2) = 0.
        He3IonCool = 0.
        p2s = he3n(1) * heii
        p2p = 0.
        p3s = 0.
        p3p = 0.
        p3d = 0.
        p10830 = 0.
        he10in = 0.
        p5876 = 0.
        p7065 = 0.
        p3889 = 0.
        he3clx = 0.
        if(lgTrace.and.lgHe3Bug) then
          write(qq,'('' HE3LEV return, all neutral, ''
     1    ,''hei3, he3n(1)='',1p,2e10.2)') hei3,he3n(1)
        end if
        return
      endif
*
*     following are recombination to various levels
      zz(1,nhe3lvl+1) = (r2s+r2s3bd)*eden + he1n(1)*csg2s +
     1 he12s*cs2s2s + he12p*cs2p2s
*
      zz(2,nhe3lvl+1) = (r2p+r2p3bd)*eden + he1n(1)*csg2p +
     1 he12s*cs2s2p + he12p*cs2p2p
*
      zz(3,nhe3lvl+1) = r3s*eden
      zz(4,nhe3lvl+1) = r3p* eden
      zz(5,nhe3lvl+1) = r3d* eden
*
*     level 1= 2s balance equation
      zz(1,1) = c2s2p+c2s3s+c2s3p+c2s3d+he3gam(1)+c2sg+a2sg+
     1 c2sion + c2ss2s + c2ss2p
      out2 = he3gam(1)+c2sg+a2sg+c2sion + c2ss2s + c2ss2p
*     fix simple estimate by this factor
*     >>chng 96 oct 21, c2sion had been in he3relax and not in he3local
      he3local = (he3gam(1)+c2sion)/out2
      he3relax = (c2sg+a2sg + c2ss2s + c2ss2p) / out2
      she2ov3 = she2ov3 / he3relax
      collhe3 = out2 - he3gam(1)
      if( he3local .gt.he3pht ) then
*       remember fraction of exits due to photoionizatino, Lya
        he3pht = he3local
        he3lya = csphot( iphl(2,1) , nhei3 , ioptri )*otslin(iphl(2,1))/
     1  (he3gam(1)+c2sion)
      endif
      zz(1,2) = -( r10830 + c2p2s )
      zz(1,3) = -c3s2s
      zz(1,4) = -(a3889+c3p2s)
      zz(1,5) = -c3d2s
*
*     level 2=2p balance equation
      zz(2,2) = c2p2s+r10830+a591+he3gam(2)+c2p3s+c2p3d+c2p3p+
     1 c2pg + c2pion + c2ps2s + c2ps2p
      zz(2,1) = -c2s2p
      zz(2,3) = -(a7065+c3s2p)
      zz(2,4) = -c3p2p
      zz(2,5) = -(a5876+c3d2p)
*
*     level 3=3s balance equation
      zz(3,3) = (a7065 + c3s2p + c3s2s )
      zz(3,1) = -c2s3s
      zz(3,2) = -c2p3s
      zz(3,4) = -a4
      zz(3,5) = 0.
*
*     LEVEL 4=3P BALANCE EQUATION
      zz(4,4) = (a4 + a3889 + c3p2s + c3p2p )
      zz(4,1) = -c2s3p
      zz(4,2) = -c2p3p
      zz(4,3) = 0.
      zz(4,5) = -a19
*
*     LEVEL 5=3D BALANCE EQUATION
      zz(5,5) = (c3d2s + c3d2p + a5876 + a19 )
      zz(5,1) = -c2s3d
      zz(5,2) = -c2p3d
      zz(5,3) = 0.
      zz(5,4) = 0.
*
      do j=1,nhe3lvl
        ratio = 1. / zz(j,j)
        do i=1,nhe3lvl+1
          zz(j,i) = zz(j,i) * ratio
        end do
      end do
*
      call matin1( zz,6,5,1,nerror)
      if(nerror.ne.0) then
        if( lgCalled ) then
          lgBusted = .true.
          return
        else
          write(qq,'('' he i matrix error.'')')
          stop
        endif
      endif
*
*     HE3N(i) must always be population/HeII
      he3n(1) = zz(1,6)
      p2s = he3n(1) * heii
*
      he3n(2) = zz(2,6)
      p2p = he3n(2) * heii
      he3n(3) = zz(3,6)
      p3s = he3n(3) * heii
      he3n(4) = zz(4,6)
      p3p = he3n(4) * heii
      he3n(5) = zz(5,6)
      p3d = he3n(5) * heii
*
      sum = 0.
      lgNegPop = .false.
      do i=1,nhe3lvl
        if( he3n(i).le.0. ) lgNegPop = .true.
        sum = sum + he3n(i)
        if(he3lte(i).gt.0. ) then
          he3bn(i) = he3n(i) / he3lte(i) / eden
        else
          he3bn(i) = 1.
        endif
      end do
*
*     make sure all pops are positive
      if( lgNegPop ) then
        write(qq,'('' negative helium triplet populations, zone'',i4)')
     1  nzone
        write(qq,'('' pops are'',i4)')he3n
        call ShowMe
      endif
*
      if( sum.gt.0. ) then
        he2ov3 =  1. / sum
      else
        he2ov3 = 0.
      endif
*
      p10830 = p2p*a10830*1.84e-12
      he10in = p10830 * t10830(ipLnInwd)
      p5876 = p3d*a5876 * 3.39e-12
      p7065 = p3s*a7065*2.82e-12
      p3889 = p3p*a3889*5.12e-12
*
*     total collisional excitation cooling of triplet lines
      he3clx = (p2s*c2s2p-p2p*c2p2s)*1.84e-12
     1 + (p2s*(c2s3s+c2s3p+c2s3d)- p3s*c3s2s-p3p*c3p2s-p3d*c3d2s)*5e-12
     1 + (p2p*(c2p3s+c2p3d)-p3s*c3s2p-p3d*c3d2p) * 3e-12
*
*     collisional ionization cooling
*     c2sion, c2pion, both already have eden included
*     >>chng 96 july 15, added cor for 3 body heating
      He3IonCool = p2s*c2sion*(1.-1./he3bn(1))*7.735e-12 +
     1          p2p*c2pion*(1.-1./he3bn(2)) * 5.8018e-12
*
      if( lgTrace.and.lgHeBug ) then
        write(qq,'(5X,''HeI tri gam'',1P,E9.2,'' rec'',E9.2,'' 3bd'',
     1  E9.2,'' cion2S'',E9.2,'' col 23S-sin'',E9.2)')
     2  he3gam(1) , rectri, r2s3bd+r2p3bd , c2sion ,
     3  (c2ss2s+c2ss2p)/eden
        if(lgHe3Bug)write(qq,'(5X,''HeI tri lev'',1P,10e8.1)') he3n,
     1  (he3n(i)/he3n(1),i=1,5)
*
        dest = c2sion + he3gam(1) + c2ss2s + c2ss2p + a2sg
        if( dest.gt.0. ) then
          hlgam = otslin(iphl(2,1))
          write(qq,'(5X,''HeI3 dest frc; col-ion'',1P,E9.2,'' H Ly-a''
     2    ,E9.2,'' C+A to sing'',E9.2)')
     3    c2sion/dest,hlgam*1.97e-18/dest,(c2ss2s+c2ss2p+a2sg)/dest
        else
          write(qq,'(5X,''HeI3 no dest rates'')')
        endif
      endif
      if( he2ov3.le.0. ) then
        write(qq,'('' HE3LEV finds relative population <=0;'',1P,
     1  e10.3)') he2ov3
        stop
      endif
      if( lgTrace.and.lgHeBug ) then
        write(qq,'(5X,''HE3LEV returns; HE2OV3='',1P,E9.2,'' simple='',
     1  e9.2,'' pops'', 6e9.1)')he2ov3,she2ov3,he3n
      endif
*
      end
******************************************************************************
      subroutine he3col
      implicit none
*compute collisional rates for helium triplets
      integer nhe3lvl
      parameter (nhe3lvl=5)
      real he3bol
      common/he3bol/ he3bol(nhe3lvl)
      real he3lte
      common/he3lte/ he3lte(nhe3lvl)
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real c2p2s,c2s2p,c3s2s,c2s3s,c3p2s,c2s3p,c3d2s,
     1 c2s3d,c3s2p,c2p3s,c3p2p,c2p3p,c3d2p,c2p3d,c2sion,c2pion
      common/he3c/ c2p2s,c2s2p,c3s2s,c2s3s,c3p2s,c2s3p,c3d2s,
     1 c2s3d,c3s2p,c2p3s,c3p2p,c2p3p,c3d2p,c2p3d,c2sion,c2pion
      real cs2s2s,c2ss2s,cs2p2s,c2ss2p,c2pg,c2sg,c2ps2s,
     1 c2ps2p,cs2p2p,cs2s2p,csg2s,csg2p
      common/che2sn/ cs2s2s,c2ss2s,cs2p2s,c2ss2p,c2pg,c2sg,c2ps2s,
     1 c2ps2p,cs2p2p,cs2s2p,csg2s,csg2p
      real r2s3bd,r2p3bd
      common/r2s3bd/ r2s3bd,r2p3bd
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*
*     local variables
      real sexp , cs
*
*     edensqte = eden/sqrte
*     cdsqte = 8.629e-6*eden/sqrte
      if( lgTrace.and.lgHe3Bug ) write(qq,'('' HE3COL called.'')')
*
      he3bol(1) = sexp( 5.5298e4 / te )
      he3bol(2) = sexp( 4.2023e4 / te )
      he3bol(3) = sexp( 2.1676e4 / te )
      he3bol(4) = sexp( 1.8329e4 / te )
      he3bol(5) = sexp( 1.7558e4 / te )
*
*     all of following collision data from Berrington and Kingston '87
*     >>chng 97 july 25, updated to
*     >>refer Sawey, P.M.J., and Berrington, K.A., 1993, ADNDT 55, 81
*
*     10830, 2 3S 2 3P
      cs = min(64.04 , 0.0186*te70*te10/te01 )
      c2p2s = cs * cdsqte / 9.
      c2s2p = c2p2s * 3. * he3bol(1)/max(1e-30,he3bol(2))
*
*     2 trip p to ground
      cs = min( 0.0364 , 4.322e-4 * sqrte/te05 / te02 )
      c2pg = cs * cdsqte / 9.
      csg2p = c2pg * 9. / 1. * sexp(2.4314e5/te)
*
*     2 trip s to ground
      c2sg = 8.428e-8 * edensqte * te10
      csg2s = c2sg * 3. / 1. * sexp(2.2986e5/te)
*
*     singlet 2s to triplet 2s
*
      if( te.gt.1e4 ) then
        cs = max(2.397 , 7.580/(te10*te02*te005) )
      else
        cs = min( 2.397 , 0.954 * te10 )
      endif
      cs2s2s = cs * cdsqte / 1.
*     trip 2s to singlet 2s
      c2ss2s =  cs2s2s*1./3. * sexp( 9234./te )
 
*     singlet 2p to trip 2s
      cs2p2s = 0.97 * cdsqte / 3.
 
*     trip 2s to singlet 2p
      cs = min( 1.15 , 0.245 * te10*te05 )
      c2ss2p = cs * cdsqte / 3. * sexp( 16219. /te )
*
*     2p to singlet 2s
      c2ps2s = 1.65 * cdsqte/9.
      cs2s2p = c2ps2s*9./1. * sexp( 4041./te )
*
*     2p to singlet 2p
      cs2p2p =  4.4 * cdsqte/3.
      c2ps2p =  cs2p2p *3./9. * sexp(2945./te)
*
*     triplet 3s to 2s
      if( te.gt.1.5e4 ) then
        cs = min(2.63,0.561*te10*te05 )
      else
        cs = max( 2.79 , 5.121/(te10/te02 ) )
      endif
      c3s2s = cs * cdsqte / 3.
      c2s3s = c3s2s * he3bol(1)/max(1e-30,he3bol(3))
*
*     triplet 2s to 3p, 3889
      cs = min(1.88 , 1.0128*te03*te03 )
      c3p2s = cs * cdsqte / 9.
      c2s3p = c3p2s * 3. * he3bol(1)/max(1e-30,he3bol(4))
*
*     triplet 3d to 2s
      cs = min( 4.47 , 3.281e-3 * te70 )
      c3d2s = cs * cdsqte / 15.
      c2s3d = c3d2s * 5. * he3bol(1)/max(1e-30,he3bol(5))
*
*     triplet 3s 2p, 7065
      cs = min( 6.460 , 1.974*te10*te01*te005 )
      c3s2p = cs * cdsqte / 3.
      c2p3s = c3s2p / 3. * he3bol(2)/max(1e-30,he3bol(3))
*
*     triplet 3P -  2P
      cs = min( 11.45 , 0.4229*te30*te02 )
      c3p2p = cs * cdsqte / 9.
*     write(6,*) c3p2p
*     c3p2p = 1.58e-6/te10/te10/te10*te03 * eden
*     write(6,*) c3p2p
      c2p3p = c3p2p * he3bol(2)/max(1e-30,he3bol(4))
*
*     trip 3 3D to 2 3P, 5876
      cs = min( 22.19 , 1.117e-3 * te/te01/te01 )
      c3d2p = cs * cdsqte / 15.
      c2p3d = c3d2p * 1.67 * he3bol(2)/max(1e-30,he3bol(5))
*
*     HE3LTE is LTE density over (eden*next ion)
      if( he3bol(1).gt.0. ) then
         he3lte(1) =  3. / 2. * 2.0708e-16 / te32 / he3bol(1)
         he3lte(2) =  9. / 2. * 2.0708e-16 / te32 / he3bol(2)
      else
         he3lte(1) = 0.
         he3lte(2) = 0.
      endif
      if( he3bol(3).gt.0. ) then
         he3lte(3) =  3. / 2. * 2.0708e-16 / te32 / he3bol(3)
         he3lte(4) =  9. / 2. * 2.0708e-16 / te32 / he3bol(4)
         he3lte(5) =  15. / 2. * 2.0708e-16 / te32 / he3bol(5)
      else
         he3lte(3) = 0.
         he3lte(4) = 0.
         he3lte(5) = 0.
      endif
*
*     coll ioniz from 2.3.s from
*     >>refer Seaton, M.S. 1964, Plan Sp Sci 12, 55.
      c2sion = 8.8e-10 * sqrte * eden * he3bol(1)
      c2pion = 3.*8.8e-10 * sqrte * eden * he3bol(2)
*     add three-body rec to recombination rates; units s^-1
      r2s3bd = c2sion * he3lte(1)
      r2p3bd = c2pion * he3lte(2)
*
      end
******************************************************************************
      subroutine he3rad
      implicit none
*compute radiative rates for helium triplets
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real a10830,a3889,a5876,a7065,a4,a19,a591,a2sg
      common/he3as/ a10830,a3889,a5876,a7065,a4,a19,a591,a2sg
      real DR10830 , r10830 , DstPrb10830
*DstPrb10830 destruction probability for 10830
*DR10830 A times prob for destruction
*r10830 is total rate from 2p to 2s
      common/d10830/ DR10830 , r10830 , DstPrb10830
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     notation;
*     1-2S  2-2P  3-3S  4-3P  5-3D
      if( lgTrace.and.lgHe3Bug ) write(qq,'('' HE3RAD called.'')')
*
      a10830 = 1.02e7 * t10830(ipLnEscP)
      DR10830 = 1.02e7 * DstPrb10830
      r10830 = a10830 + DR10830
      a3889 = 9.48e6 * t3889(ipLnEscP)
      a5876 = 7.06e7 * t5876(ipLnEscP)
      a7065 = 2.78e7 * t7065(ipLnEscP)
      a4 = 1.08e6
      a19 = 1.28e4
      a591 = 176.
      a2sg = 1.13e-4
*
      end
******************************************************************************
      subroutine he3gma
      implicit none
*compute photoionization rates for helium triplets
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real he3lte
      common/he3lte/ he3lte(nhe3lvl)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real he3hsv
      common/he3hsv/ he3hsv(2)
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      real r2s, r2p, r3s, r3p, r3d
      common/he3rr/ r2s, r2p, r3s, r3p, r3d
      real he3gam , He3FrLya
*     total photoionization rates for helium triplest
*     He3FrLya is fraction of this that is Lya
      common/he3gams/ he3gam(nhe3lvl) , He3FrLya
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      integer ioptri
      common/ioptri/ ioptri
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer iophe1
      common/iophe1/ iophe1(9)
      real reci , rectri , recii
      common/herec/ reci , rectri , recii
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      real PhotScaleOn
*     set to 1 in zero, so have no effect
*     set to 0 with 'no photoionization' command, kills
*     photoionization of everything
      common/PhotScale/ PhotScaleOn
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real ghe32s,f1,r,bnfun,he3h,hirate, oldrate,csphot
      save ghe32s , he3h , f1, oldrate
*
      if( lgTrace.and.lgHe3Bug ) write(qq,'('' HE3GMA called.'')')
*
*     following are corrected radiative recombination coefficient
*     not actual ones
*     >>chng 96 oct 25, removed eden from edensqte, so not cancel of eden below
*     some evidence that eden and edensqte not updated together
      r2s = 1.31e-12 / sqrte * te10
      r2p = 3.09e-11 /(te10*te03)/sqrte
      r3s = 7.1e-13 / sqrte
      r3p = 2.24e-11 / (te10*te10*te03)/sqrte
      r3d = 1.25e-9 / te / te10
      rectri = r2s + r2p + r3s + r3p + r3d
*
*     with induced recombination
      if( lgDoPhoto ) then
*       ghe32s = bnfun( nhei3,nhe1(1),ioptri,0.3506,f1,r)* PhotScaleOn
        oldrate = bnfun( nhei3,nhe1(1),ioptri,0.3506,f1,r)* PhotScaleOn
*       >>chng 97 july 6, damp out Lya oscillations
*       call broken
*       if( nzone.le.1 ) then
*         ghe32s = oldrate
*       else
*         ghe32s = oldrate*0.5 + ghe32s*0.5
*       endif
        ghe32s = oldrate
        he3h = h
        if( lgTrace.and.lgHeBug ) then
          call PrtGamma(nhei3 ,nhe1(1) ,ioptri,qq,
     1    ghe32s , ghe32s*0.05 )
        endif
      endif
*     induced recombination rates
      r2s = r2s + f1 * he3lte(1)/ eden
      r2p = r2p + f1 * he3lte(2)/ eden
      he3hsv(1) = he3h
*     put in rest of flux integral
      if( nhe1(1).lt.nflux ) then
*       ratio of trip cross to singlet ground
        hirate = he1gam(1) *
     2  csphot(nhe1(1),nhei3,ioptri)/
     3  max(1e-37,csphot(nhe1(1),nhe1(1),iophe1(1)) )
*       >>chng 97 jul 12, get rid of direct access to opsv
*       hirate = he1gam(1) *OpacStack(nhe1(1)-nhei3+ioptri) /
*    1  max(1e-37,OpacStack(iophe1(1)))
      else
        hirate = 0.
      endif
*
*     now save total rates for 2^3S and 2^3P
      he3gam(1) = ghe32s + hirate
      he3gam(2) = he3gam(1) * 3.
*
*     >>chng 97 jul 11, save proportion of total rate due to Lya
      He3FrLya = otslin(iphl(2,1))* csphot(iphl(2,1),nhei3,ioptri)
      if( he3gam(1).gt.1e-30 ) then
        He3FrLya = He3FrLya / he3gam(1)
      else
        He3FrLya = 0.
      endif
*666  write(66,'(1p,2e10.2)') heii/ahe,He3FrLya
*
      end
******************************************************************************
      subroutine heatom( chCard )
      implicit none
*parse parameters off the helium command
      character chCard*80
      logical lgPresHeLya
*flag set to turn on HeII Lya, set with helium radiation pressure command
      common/phela/ lgPresHeLya
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgHeClON
*flag saying whether he collisions are turned on
*set false with helium collisions off command
      common/heclon/ lgHeClON
*
      logical lgMatch
*
      if( lgMatch('RADI',chCard) ) then
*       turn on He Ly-alpha radiation pressure; only OK if no oxygen
        lgPresHeLya = .true.
*
      else if( lgMatch('COLL',chCard ) ) then
*       turn off helium atom collisions
        if( lgMatch(' OFF',chCard) ) then
          lgHeClON = .false.
        else
          lgHeClON = .true.
        endif
*
      else
        write(qq,'('' There should have been a keyword - STOP'')')
        stop
      endif
*
      end
******************************************************************************
      subroutine HeDiff
      implicit none
*compute diffuse fields due to helium atom, ion, triplets
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer nhe3lvl
      parameter (nhe3lvl=5)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      real opac
      common/opac/ opac(ncell)
      real reci , rectri , recii
      common/herec/ reci , rectri , recii
      real he3n
      common/he3n/ he3n(nhe3lvl)
      real hi , hii
      common/h/ hi , hii
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real te , eden , hden
      common/phycon/ te , eden , hden
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
*these are a series of lines and continuua that are set in hediff and
*carried outward in metdif
      real esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      common/heots/ esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgOpacOn
      common/opacon/ lgOpacOn
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      logical lgPresHeLya
*flag set to turn on HeII Lya, set with helium radiation pressure command
      common/phela/ lgPresHeLya
*     include "facexp.com"
      integer ip374 , ip660
      common/pbowen/ ip374 , ip660
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      integer kapots , kap911
      common/kapots/ kapots , kap911
      real OTSCap
*largest allowed ratio of line ots to total photo rate,
*set to 1.5 in scalar
      common/capots/ OTSCap
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
      real DR10830 , r10830 , DstPrb10830
*DstPrb10830 destruction probability for 10830
*DR10830 A times prob for destruction
*r10830 is total rate from 2p to 2s
      common/d10830/ DR10830 , r10830 , DstPrb10830
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer ipHe23sGrnd
*pointer to He 23s to ground decay
      common/ip626/ ipHe23sGrnd
      real he2net
      common/he2net/ he2net(nhe2lvl,nhe2lvl-1)
      real he2rb , he2rtt
      common/he2rb/ he2rb , he2rtt
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real a10830,a3889,a5876,a7065,a4,a19,a591,a2sg
      common/he3as/ a10830,a3889,a5876,a7065,a4,a19,a591,a2sg
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
*
*     local variables
      real bowen
      parameter( bowen=0.3 )
      integer n,j,i
      real he1lsave(10,10) , otshere , he2lsave(10,10)
      save he1lsave , he2lsave
      real escfac,bwnfac,dam584,widlin,dam304,otsfac,
     1 ttpath,delta ,t , damper , otsnew
      real totline , outward , ots911 , ots660
*
*     free statement labels  >= 7
*
*     calculate opacity for He LA lines
*     used before opacity arrays have been computed.
*
      if( .not.lgOpacOn ) then
*       AddOpac has yet to be called, opacities are not defined
        opac(ipHn(1)) = hi * 6.30e-18 + dstab(ipHn(1))
        opac(ipHn(1)+1) = hi * 6.3e-18 + dstab(ipHn(1)+1)
        opac(ipHn(1)+2) = hi * 6.3e-18 + dstab(ipHn(1)+2)
        opac(iphe1l(2,1)) =  hi * 1.85e-18 + dstab(iphe1l(2,1))
        opac(ip374) = hi * 5.3e-19 + hei * 3.7e-18 + dstab(ip374)
        opac(ip660) = hi * 2.4e-18 + dstab(ip660)
        opac(iphe2l(2,1)) = hn(1)*hii*2.85e-19 + hei*3.0e-18 +
     1  dstab(iphe2l(2,1))
        opac(nhe1(1)) = hi*1.06e-18 + hei1*7.83e-18 + dstab(nhe1(1))
        opac(nhe2(1)) = hi*9.84e-20 + hei1*1.75e-18 +
     1  heii*1.58e-18 + dstab(nhe2(1))
      endif
*
*     OTS background
*
* HeI He I
*     He I recombination continuum
      damper = 0.5
      do n=1,6
        if( opac(nhe1(n)).gt.0. ) then
          otsnew = (1.-damper) *
     1    he1rec(n,1)*(1.-he1rec(n,3)) / opac(nhe1(n))*eden*heii +
     2    otscon(nhe1(n)) * damper
          otsnew = otsnew * opac(nhe1(n) )
          if( otsnew.lt.0. ) then
            write(qq,'('' HeDiff found negative OTS He1 CON, n='',i4,
     1      '' val='',1p,e10.1)')n , otsnew
            call ShowMe
            stop
          endif
          call AddOTSCon( otsnew , nhe1(n) )
        else
          otsnew = 0.
          call AddOTSCon( otsnew , nhe1(n) )
        endif
      end do
      n = 1
*
*     HeI recombination continua at 1.81 Ryd
      esc504 = he1rec(1,1) * he1rec(1,3) * eden * heii
*
*     HeI Ly-alpha He I ly a
*     escaping part of HeI Ly-alpha lya ly a
      esc584 = heii*he12p * he1mis(2,1)*ExpmTau(iphe1l(2,1))
*     do not want to add much outward HeI Lya since it is so important
*     use inward looking optical depth to decide outward flux
      otshere = he12p*heii*he1dst(2,1) +
     1 heii*he12p * he1mis(2,1)*(1.-ExpmTau(iphe1l(2,1)))
      if( nzone.le.1 ) then
        he1lsave(2,1) = otshere
      endif
      damper = 0.5
      otshere = he1lsave(2,1)*(1.-damper) + damper* otshere
      he1lsave(2,1) = otshere
      if( otshere.lt.0. ) then
        write(qq,'('' HeDiff found negative OTS He1 alhpa,'',i4,
     1  '' val='',1p,e10.1)')1 , otshere
        call ShowMe
        stop
      endif
      call AddOTSLin( otshere , iphe1l(2,1) , 1.0 )
*
*     all other lines of HeI - tests show this is very small effect
      do j=3,7
        do i=1,j-1
          otshere = he1n(j)*heii*he1dst(j,i)
          if( nzone.le.1 ) then
            he1lsave(j,i) = otshere
          endif
          damper = 0.5
          otshere = he1lsave(j,i)*(1.-damper) + damper* otshere
          he1lsave(j,i) = otshere
          if( otshere.lt.0. ) then
            write(qq,'('' HeDiff found negative OTS He1l'',2i4,
     1      '' val='',1p,e10.1)')j,i , otshere
            call ShowMe
            stop
          endif
          call AddOTSLin( otshere , iphe1l(j,i) , 1.0 )
        end do
      end do
*
*     HeI 2tripS to ground - one photon decay
*     this is a major source of ionization for parishii
      totline = heii*he3n(1)*a2sg
      if( lgSphere ) then
*       all goes outward or ots
        escfac = 0.
      else
        escfac = 0.5*ExpmTau( ipHe23sGrnd )
      endif
*     number of phots escaping from illuminated face of cloud
      esc626 = totline *escfac
*     otsfac = 1. - ExpZone(ipHe23sGrnd)
*     when optically thin, this goes to zero, when thick, to 100%
      otsfac = 1. - 2.*escfac
*     >>chng 96 mar 7, above had been 1-escfac, so 50% ots when thin to cont
      call AddOTSLin( totline*otsfac , ipHe23sGrnd , 0.5 )
*     following is zero when thick to cont, 0.5 when thin
      outward = max(0., 1.-otsfac-escfac )
*     outward escaping line
      out626 = totline * outward
*
*     HeI 10830 OTS
      call AddOTSLin( p2p*DR10830 , ipHe3l(1) , 1.0 )
*
**********************************************************************
*
*     OTS part of He II recombination continuum
*     OTS part is total absorbed in nebula
*     by definition escaping part is not considered further
*     emission also computed in routine DIFFEM
      do n=1,6
        if( opac(nhe2(n)).gt.0. ) then
          otsnew = he2rec(n,1)*(1.-he2rec(n,3))*eden*heiii /
     1    opac(nhe2(n))
          otsnew = ( otsnew + otscon(nhe2(n)) ) /2.
          otsnew = otsnew * opac(nhe2(n))
          if( otsnew.lt.0. ) then
            write(qq,'('' HeDiff found negative OTS He2 CON, n='',i4,
     1      '' val='',1p,e10.1)')n , otsnew
            call ShowMe
            stop
          endif
          call AddOTSCon( otsnew , nhe2(n) )
        else
          otsnew = 0.
          call AddOTSCon( otsnew , nhe2(n) )
        endif
      end do
*
*     OTS He rec continua, these are only used to check on importance
*     of he ionization
*     HeIII => HeII recombination continua
      esc228 = he2rec(1,1) * he2rec(1,3) * eden * heiii
*
*     find amount of He II rec to n=2 OTS
*     default value of OTSCap is 1.5
      ots911 = otscon(nhe2(2))
      if( ots911.gt.(hgamnc(1)/6.30e-18*OTSCap) ) then
        ots911 = hgamnc(1) / 6.30e-18 * OTSCap
        if( otsnew.lt.0. ) then
          write(qq,'('' HeDiff found negative OTS 911 CON'',
     1    '' val='',1p,e10.1)')ots911
          call ShowMe
          stop
        endif
*
        call AddOTSCon( ots911*opac(nhe2(2)) , nhe2(2) )
        kap911 = kap911 + 1
      endif
      esc911 = heiii*eden * he2rec(2,1) * he2rec(2,3)
*
******************************************************************
*VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
*
*     HeII ly a Ly-a ots destruction rate
*     this is escaping part of Ly-a
      esc304 = heiii*he22p*(1.-bowen) * he2mis(2,1)*ExpmTau(iphe2l(2,1))
*
      bwnfac = bowen * (1. - t304(3) )
      otshere = he22p*(1.-bwnfac)*heiii*he2dst(2,1)  +
     1 heiii*he22p*(1.-bowen) * he2mis(2,1)*(1.-ExpmTau(iphe2l(2,1)))
      if( nzone.le.1 ) then
        he2lsave(2,1) = otshere
      endif
      damper = 0.5
      otshere = he2lsave(2,1)*(1.-damper) + damper* otshere
      call AddOTSLin( otshere , iphe2l(2,1) , 1.0 )
      he2lsave(2,1) = otshere
*
*     this caps ots rate to prevent ots runaway
*     comment is printed if this is ever used
*     default value of OTSCap is 1.5
      if( otslin(iphe2l(2,1)) .gt.(hgamnc(1)/2.85e-19*OTSCap) ) then
        t = hgamnc(1) / 2.85e-19 * OTSCap
        t = t * opac(iphe2l(2,1))
        call AddOTSLin( t , iphe2l(2,1) , 1.0 )
        kapots = kapots + 1
      endif
*
*     two photons, but with branching ratio, very important
*     for setting H-beta lum in parispn.in
      esc660 = heiii*he22p*bowen*he2mis(2,1) * 2. * 0.8
*     ots660 is set of bowen OIII lines near 660
      ots660 = heiii*he22p*he2dst(2,1)*bowen  * 2. * 0.8
*     >>chng 96 nov 21, damping from 1 to 0.5
      call AddOTSLin( ots660 , ip660 , 0.5 )
*
*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
******************************************************************
*
*     higher n lines of HeII
      do j=3,7
        do i=1,j-1
          otshere = he2n(j)*heiii*he2dst(j,i)
          if( nzone.le.1 ) then
            he2lsave(j,i) = otshere
          endif
          damper = 0.5
          otshere = he2lsave(j,i)*(1.-damper) + damper* otshere
          he2lsave(j,i) = otshere
          if( otshere.lt.0. ) then
            write(qq,'('' HeDiff found negative OTS He2l'',2i4,
     1      '' val='',1p,e10.1)')j,i , otshere
            call ShowMe
            stop
          endif
          call AddOTSLin( otshere , iphe2l(j,i) , 1.0 )
        end do
      end do
*
*     HeI Ly-a 584 radiation pressure
      if( he1n(1).gt.1e-20.and. he1tau(2,1).gt.1.1 .and.
     1  opac(iphe1l(2,1)).gt.0. ) then
        dam584 = 0.0921 / sqrte
        plines(6) = 9.54e-5* he12p/6. / (he1n(1)/2.) *
     1  widlin( he1tau(2,1) , he1lim(2,1) , dam584 , doppler(2) )
      else
        plines(6) = 0.
      endif
*
*     HeII Ly-a 304 radiation pressure
*     lgPresHeLya usually false, can be set true with HELIUM RADIAT PRESS comnd
      t = min( he2tau(2,1) , he2lim(2,1) )
      if( lgPresHeLya .and. t.gt.1.1.and.opac(iphe2l(2,1)).gt.0. )then
*       roughly Bohnila et al; first term cor for 912 to 304, sec is path
        dam304 = 0.376 / sqrte
        ttpath = t * (1. + 2.*log(t) / (1.+0.3*dam304*t)**0.67 +
     1  (6.5*dam304*t)**0.33 )
        delta = tauabs(ipHn(1),1) *0.03704 * ttpath / t
        plines(5) = (he22p *heiii) * (he2mis(2,1) * 6.546e-11) *
     1  ttpath / ( 1.90e-8/doppler(2)*heii) / (1.+0.9*delta)**0.97
      else
        plines(5) = 0.
      endif
*
      end
*****************************************************************************
      subroutine helium( seche , helax )
      implicit none
*solve ionization balance helium ion, helium singlets, helium triplets
      real seche , helax
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nhe3lvl
      parameter (nhe3lvl=5)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real hi , hii
      common/h/ hi , hii
      real reci , rectri , recii
      common/herec/ reci , rectri , recii
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real workft , workfz
      common/workf/ workft , workfz
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      real he3n
      common/he3n/ he3n(nhe3lvl)
      double precision he3bn
      common/he3bn/ he3bn(nhe3lvl)
      real hhe1
      common/hhe1/ hhe1(nhe1lvl)
      real hhe2
      common/hhe2/ hhe2(nhe2lvl)
      real he3hsv
      common/he3hsv/ he3hsv(2)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer ioreco
      common/ioreco/ ioreco
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real gam22,hela,sm2ov1,dtri,sum,he3old,gam32,he2la, smiov2
      integer n,i,loop3 , loophe
       double precision heiov2 , he2ov1, he2ov3 , r1ov2
      save heiov2 , he2ov1, he2ov3 , r1ov2
*
      save hela , gam22 , gam32 , he2la
      real ssav(7)
      logical lgHelOn
*
*     free statement numbers >=9
*
*     option to "turn off" helium
      if( .not.lgElmtOn(2) ) then
        hei3 = 0.
        heii = 0.
        heiii = 0.
        hei1 = 0.
        hei = 0.
        return
      endif
*
*     evaluate helium optical depths, and destruction prob
      call HeTran
      he3old = hei3
      loop3 = 0
 7    continue
*
*     do relative ionization balance for adjacent stages of ionization
*
*     do ionized helium first, get ratio He++ / He+
      call he2col
      if( lgNewIon.and.lgHe2ON ) then
        call he2rad
        call he2gma( gam32 , he2la )
      else if( .not.lgHe2ON ) then
        gam32 = 0.
        he2la = 0.
        do i=1,7
          hhe2(i) = 0.
        end do
      endif
*
      if( lgHe2ON ) then
*       HEIOV2 is HeIII (ion) /HeII
        call he2lev( heiov2 , smiov2 )
*       >>chng 93, feb added so that he not turned back on
*       at very small electron fraction
        if(nzone.gt.1 .and.heiov2.eq.0. ) then
          lgHe2ON = .false.
          if(lgTrace) write(qq,'(5X,''HELIUM turns off ion 3.'')')
        endif
      else
        heiov2 = 0.
        smiov2 = 0.
        if(lgTrace) write(qq,'(5X,''HELIUM ion 3 is turned off.'')')
      endif
*
*     loop counter
      loophe = 0
      lgHelOn = .false.
 5    continue
*
*     do trip before singlets since need rec coef to singlets from trip
*     R2OVT is HeII/He(trip)
      call he3col
      if( lgNewIon ) then
        call he3rad
        call he3gma
      endif
      call he3lev( he2ov3 )
*
*     do singlets; HE2OV1 is HeII/He(sin)
      call he1col
      call he1rad
      if( lgNewIon ) then
        call he1gma( gam22 , hela )
      endif
      call he1lev( he2ov1 , sm2ov1 )
      if( he2ov1.eq.0. ) then
        gam22 = 0.
        hela = 0.
      endif
*
      if( lgTrConvg .and.nLevTrace.eq.0 ) then
        write(qq,'(7X,''HELIUM I/2'',1P,E10.3,'' simple='',E10.3
     1  ,'' 2/1'',E10.3,'' simple='',E10.3,
     2  '' 2/3'',E10.3)') heiov2, smiov2 , he2ov1, sm2ov1 , he2ov3
      endif
*
*     this check Jan 93, for hion to work, first soln very neutral,
*     but trace ionized helium.  Must iterate on triplets and singlets
*     to get goth ionized in solution
      if( he2ov3.eq.0. .and. he2ov1.gt.0. .or. lgHelOn ) then
*       this is the problem, triplets zero, but singlets populated
        lgHelOn = .true.
        loophe = loophe + 1
        if( loophe.lt.4 ) then
          if(lgTrace.and.lgHeBug) write(qq,'(5X,''HELIUM loops since ''
     1    ,''trip=0 but singlets not.'')')
          goto5
        endif
      endif
*
      if( lgTrace.and.lgHeBug ) then
        write(qq,'(5X,''HELIUM I/2'',1P,E10.3,'' simple='',E10.3
     1  ,'' 2/1'',E10.3,'' simple='',E10.3,
     2  '' 2/3'',E10.3)') heiov2, smiov2 , he2ov1, sm2ov1 , he2ov3
      endif
*
*     populations
      if( he2ov1 .eq.0.0 .or. he2ov3.eq.0.0 ) then
*       gas is completely neutral (although trace He++ possible)
        hei3 = 0.
        heii = 0.
        heiii = 0.
        hei1 = ahe
        hei = ahe
      else if( heiov2 .eq.0. .and. he2ov1 .ne.0. ) then
*       gas is singly ionized, but not doubly
        heiii = 0.
*       ratio of total neutral to ionized helium
        r1ov2 = 1.d0/he2ov3 + 1.d0/he2ov1
        heii = ahe / ( 1.d0 + r1ov2 )
        hei =  ahe / ( 1.d0 + 1.d0/r1ov2 )
        hei1 = hei / ( 1.d0 + he2ov1 /he2ov3 )
        hei3 = hei / ( 1.d0 + he2ov3 /he2ov1 )
      else
*       all three stages of ionization populated
*       ratio of total neutral to ionized helium
        r1ov2 = 1.d0/he2ov3 + 1.d0/he2ov1
        heiii = ahe / ( 1.d0 + (1.d0+r1ov2)/heiov2 )
        heii = ahe / (1.d0 + r1ov2 + heiov2 )
        hei = ahe / ( 1.d0 + (1.d0+heiov2 )/r1ov2 )
        hei1 = hei / ( 1.d0 + he2ov1 /he2ov3 )
        hei3 = hei / ( 1.d0 + he2ov3 /he2ov1 )
      endif
*
*     save into master ionization array
      xIonFracs(2,1) = hei
      xIonFracs(2,2) = heii
      xIonFracs(2,3) = heiii
*
      if( lgTrace )write(qq,'(5X,''HE; 23S:'',1P,E9.2,'' HEo:'',E9.2,
     1'' HE+:'',E9.2,'' HE++:'',E9.2)') hei3,hei,heii,heiii
*
*     July 93 logic added for partially neutral soln, not yet converged
      dtri = abs(hei3-he3old)/max(1e-36,hei3)
      if( hei3.gt.0. .and. dtri.gt.0.02 ) then
        loop3 = loop3 + 1
        if( loop3.lt.9 ) then
          if(lgTrace.and.lgHeBug) write(qq,'(5X,''HELIUM loops '',I3,
     1    '' since trip pop changed.  New, old trip='',1P,2E10.2)')
     2    loop3, hei3, he3old
          he3old = hei3
          goto7
        endif
      endif
*     He II Ly photoionization rate
      call HeDiff
*
*-----------------------------------------------------------------------
*
      ssav(1) = hhe1(1) * he1n(1)
      sum = ssav(1)
      do n=2,7
        ssav(n) = hhe1(n) * he1n(n)
        sum = sum + ssav(n)
      end do
      heating(2,1) = sum * heii
*
      sum = hhe2(1) * he2n(1)
      do n=2,7
        sum = sum + hhe2(n) * he2n(n)
      end do
      heating(2,2) = sum * heiii
*
*     heating(2,3) is helium triplets
      heating(2,3) = he3hsv(1)*he3n(1)* hei3
      workfz = workfz + (heii*(reci+rectri)*1.8+heiii*recii*4.)*eden
      if(ioreco.ne.0)write(ioreco,'(''hE '',1p,2e9.2)') reci+rectri,recii
*
      helax = (hela*hei  +  he2la*heii)
      seche = (gam22*hei1 + gam32*heii)
*
      if( lgTrace.and.lgHeBug ) then
        write(qq,'(5X,''HE; bn(2tripS)='',1P,E9.2,'' bn(HeI)='',E9.2,
     1  '' bn(HeII)='',E9.2,'' and HELIUM returns.'')')
     2  he3bn(1) , he1bn(1) , he2bn(1)
      endif
*
      end
******************************************************************************
      subroutine HeTran
      implicit none
*derive escape and destruction probabilities for He lines
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
      integer nhetau
      parameter (nhetau=4)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real He1EinA
*transition prob for He 1 singlets
      common/he1as/ He1EinA(9,8)
      real he2as
      common/he2as/ he2as(9,8)
      real he2dmp
      common/he2dmp/ he2dmp(9)
      real he1dmp
      common/he1dmpCOM/ he1dmp(9)
      real he1esc
      common/he1escCOM/ he1esc(9,9)
      real he2esc
      common/he2esc/ he2esc(9,9)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real DR10830 , r10830 , DstPrb10830
*DstPrb10830 destruction probability for 10830
*DR10830 A times prob for destruction
*r10830 is total rate from 2p to 2s
      common/d10830/ DR10830 , r10830 , DstPrb10830
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
      real he3tau
      common/he3tau/ he3tau(nta,nhetau)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      real he1fin
*     these are inward fractions for HeI lines,
*     not used now but they could be
      common/he1finCOM/ he1fin(9,8)
      real he2fin
*     these are inward fractions for HeI lines,
*     not used now but they could be
      common/he2fin/ he2fin(9,8)
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      real opac
      common/opac/ opac(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real DestWght , DestWghtSave
*     weight to give new dest prob when being evaluated,
*     default is 0.25 and is reset with SET DSTWGHT command
*     DstWghtSave is usually the same as DstWght - except on 0th
*     zone, where DstWght is set to 1 to get initial dest prob
*     then reset to DstWghtSave
      common/DstWght/ DestWght , DestWghtSave
*
*     local variables
      integer i,j
      real esin,eshe1l,he1jbr,esa0k2,damp,eovrlp,eshe2l,
     1 esccom,esout,he2jbr,escsub , tout
*     integer ihi , lo
*
*     evaluate helium destruction probabilities
*     this code was heavily modified by Paul T. O'Brien, UCL, to
*     both inward and outward fractional escape
*     the original code had only one-sided escapes
*
*     this this is 0th zone then use full destruction prob,
*     else use mean of old and new - NB must reset at end
      if( nzone.lt.1 ) DestWght = 1.
*
      if( he1lim(2,1)*0.90-he1nxt(2,1).gt.0. ) then
*       only evaluate if we have not overrun optical depth scale
        he1esc(2,1) = eshe1l( esin )
        he1esc(1,2) = he1esc(2,1) * He1EinA(2,1)
        he1fin(2,1) = fracin
        damp = he1dmp(2) / doppler(2) / 0.75
*       >>chng 96 sep 4, added DestWght weighting
*       >>chng 96 sep 4, following had extra div by two????
        he1dst(2,1) = (1.-DestWght)*he1dst(2,1) + DestWght*He1EinA(2,1)*
     1   eovrlp( heii*he1n(1) ,he1tau(2,1),he1lim(2,1) , damp ,
     2   he1opc(2,1), iphe1l(2,1) ,doppler(2),he1esc(2,1),'INCO' )
*       >>chng 97 sept 13, did not conserve energy, added following
        he1con(2,1) = he1jbr(2,1) * He1EinA(2,1)*esa0k2(he1nxt(2,1))
      else
*       >>chng 97 sept 13, did not conserve energy, added following
        he1con(2,1) = he1jbr(2,1) * He1EinA(2,1)*esa0k2(he1nxt(2,1))
      endif
*
      if( he2lim(2,1)*0.90-he2nxt(2,1).gt.0. ) then
*       only evaluate if we have not overrun optical depth scale
        he2esc(2,1) = eshe2l( esin )
        he2esc(1,2) = he2esc(2,1) * he2as(2,1)
        he2fin(2,1) = fracin
        he2con(2,1) = he2jbr(2,1) * esin *he2as(2,1)
        damp = he2dmp(2) / doppler(2) / 0.75
*       >>chng 96 sep 4, added DestWght weighting
        he2dst(2,1) = (1.-DestWght)*he2dst(2,1) + DestWght*he2as(2,1)*
     1  eovrlp( heiii*he2n(1) ,he2tau(2,1),he2lim(2,1) , damp ,
     2  he2opc(2,1), iphe2l(2,1) , doppler(2) , he2esc(2,1) ,'INCO' )
      else
*       >>chng 97 sept 13, did not conserve energy, added following
        damp = eshe2l( esin )
        he2con(2,1) = he2jbr(2,1) * esin *he2as(2,1)
      endif
*
      do i=3,nhe1lvl
        damp = he1dmp(i) / doppler(2) / 1.808/(1. - 1./float(i*i) )
        esin = esccom(he1nxt(i,1),damp )
        tout = he1lim(i,1)*0.90-he1nxt(i,1)
        if( tout.gt.0. ) then
          tout = he1lim(i,1)-he1nxt(i,1)
          esout = esccom(tout,damp)
          he1esc(i,1) = 0.5*( esin + esout )
          he1fin(i,1) = esin / (esin + esout)
*         other index is product of A and escape
          he1esc(1,i) = he1esc(i,1) * He1EinA(i,1)
*         >>chng 96 sep 4, added DestWght weighting
          he1dst(i,1) = (1.-DestWght)*he1dst(i,1)+DestWght*He1EinA(i,1)*
     1    eovrlp( heii*he1n(1) ,he1tau(i,1),he1lim(i,1) , damp ,
     2    he1opc(i,1),iphe1l(i,1) , doppler(2) , he1esc(i,1) ,chDstFun )
        endif
        he1con(i,1) = he1jbr(i,1) * esa0k2(he1nxt(i,1))*He1EinA(i,1)
      end do
*
      do i=3,nhe2lvl
        damp = he2dmp(i) / doppler(2) / 4. / (1. - 1./float(i*i) )
        esin = esccom(he2nxt(i,1),damp )
        tout = he2lim(i,1)*0.90-he2nxt(i,1)
        if( tout.gt.0. ) then
*         only do this when we are not close to boundary
*         but when we do it, use correct tau
          tout = he2lim(i,1)-he2nxt(i,1)
          esout = esccom(tout,damp )
          he2esc(i,1) = 0.5*( esin + esout )
*         >>chng 96 feb 5, no test for
*         he2esc(i,1) = 0.5* esin
*         he2esc(i,1) = esin
          he2fin(i,1) = esin / (esin + esout)
          he2con(i,1) = he2jbr(i,1)*esa0k2(he2nxt(i,1))*he2as(i,1)
          he2esc(1,i) = he2esc(i,1) * he2as(i,1)
*         >>chng 96 sep 4, added DestWght weighting
          he2dst(i,1) = (1.-DestWght)*he2dst(i,1) + DestWght*he2as(i,1)*
     1    eovrlp( heiii*he2n(1) ,he2tau(i,1),he2lim(i,1) , damp ,
     2    he2opc(i,1),
     2    iphe2l(i,1) , doppler(2) , he2esc(i,1) ,chDstFun )
        endif
      end do
*
      if ( lgTauOutOn) then
        do j=2,nhe1lvl-1
          do i=j+1,nhe1lvl
            damp = he1dmp(i) /doppler(2)/1.808/(1./float(j*j)-1./
     1      float(i*i))
            esin = esccom(he1nxt(i,j),damp )
            tout = he1lim(i,j)*0.90-he1nxt(i,j)
            if( tout.gt.0. ) then
              tout = he1lim(i,j)-he1nxt(i,j)
              esout = esccom(tout,damp )
              he1fin(i,j) = esin / (esin + esout)
              he1con(i,j) = he1jbr(i,j) * esin * He1EinA(i,j)
              he1esc(i,j) = 0.5 * (esin + esout)
              he1esc(j,i) = he1esc(i,j) * He1EinA(i,j)
*             destruction of line by background opacity
*             >>chng 96 sep 4, added DestWght weighting
              he1dst(i,j) = (1.-DestWght)*he1dst(i,j) +
     1        DestWght*He1EinA(i,j)*
     1        eovrlp( heii*he1n(j) ,he1tau(i,j),he1lim(i,j) , damp ,
     2        he1opc(i,j),
     2        iphe1l(i,j) , doppler(2) , he1esc(i,j) ,chDstFun )
            endif
          end do
        end do
        esin = esccom(t206(ipLnTauIn),1e-3 )
        esout = esccom(t206(ipLnTauTot),1e-3 )
        t206(ipLnEscP) = 0.5 * (esin + esout )
        t206(ipLnInwd) = esin / (esin + esout)
      else
*       outward optical depths not defined
        do j=2,nhe1lvl-1
          do i=j+1,nhe1lvl
            damp = he1dmp(i) /doppler(2)/1.808/(1./float(j*j)-1./
     1      float(i*i))
            esin = esccom(he1nxt(i,j),damp )
            he1fin(i,j) = 1.
            he1con(i,j) = he1jbr(i,j) * esin * He1EinA(i,j)
            he1esc(i,j) = esin
            he1esc(j,i) = he1esc(i,j) * He1EinA(i,j)
*           destruction of line by background opacity
*           >>chng 96 sep 4, added DestWght weighting
            he1dst(i,j) = (1.-DestWght)*he1dst(i,j) +
     1      DestWght*He1EinA(i,j)*
     1      eovrlp( heii*he1n(j) ,he1tau(i,j),he1lim(i,j) , damp ,
     2      he1opc(i,j),
     2      iphe1l(i,j) , doppler(2) , he1esc(i,j) ,chDstFun )
          end do
        end do
        t206(ipLnEscP) = esccom( t206(ipLnTauIn) , 1e-3  )
        t206(ipLnInwd) = 1.
      endif
*
*     do loop to get outward fraction if lgTauOutOn defined
      if ( lgTauOutOn) then
*       outward optical depths defined
        do j=2,nhe2lvl-1
          do i=j+1,nhe2lvl
            damp = he2dmp(i) / doppler(2) / 4./(1./float(j*j)-1./
     1      float(i*i))
            esin = esccom(he2nxt(i,j),damp )
            tout = he2lim(i,j)*0.90 - he2nxt(i,j)
            if( tout.gt.0. ) then
              tout = he2lim(i,j) - he2nxt(i,j)
              esout = esccom(tout ,damp )
              he2fin(i,j) = esin/ (esin + esout)
              he2con(i,j) = he2jbr(i,j) * esin * he2as(i,j)
              he2esc(i,j) = 0.5 * (esin + esout)
              he2esc(j,i) = he2esc(i,j) * he2as(i,j)
*             >>chng 96 sep 4, added DestWght weighting
              he2dst(i,j) = (1.-DestWght)*he2dst(i,j) +
     1        DestWght*he2as(i,j)*
     1        eovrlp( heiii*he2n(j) ,he2tau(i,j),he2lim(i,j) , damp ,
     2        he2opc(i,j),
     2        iphe2l(i,j) , doppler(2) , he2esc(i,j) ,chDstFun )
            endif
          end do
        end do
      else
*       outward optical depths not defined
        do j=2,nhe2lvl-1
          do i=j+1,nhe2lvl
            damp = he2dmp(i) / doppler(2) / 4./(1./float(j*j)-1./
     1      float(i*i))
            esin = esccom(he2nxt(i,j),damp )
            he2fin(i,j) = 1.
            he2con(i,j) = he2jbr(i,j) * esin * he2as(i,j)
            he2esc(i,j) = esin
            he2esc(j,i) = he2esc(i,j) * he2as(i,j)
*           >>chng 96 sep 4, added DestWght weighting
            he2dst(i,j) = (1.-DestWght)*he2dst(i,j) +
     1      DestWght*he2as(i,j)*
     1      eovrlp( heiii*he2n(j) ,he2tau(i,j),he2lim(i,j) , damp ,
     2      he2opc(i,j),
     2      iphe2l(i,j) , doppler(2) , he2esc(i,j) ,chDstFun )
          end do
        end do
      endif
*     >>chng 96 sep 4, added DestWght weighting
*     >>chng 97 aug 24, set init val if zone number small
      if( nzone.le.1) then
        DstPrb10830 =
     1  eovrlp( p2s , he3tau(ipLnTauIn,1),he3tau(ipLnTauTot,1),
     1  1e-4,8.80e-7,
     1  ipHe3l(1) , doppler(2) , he3tau(ipLnEscP,1) ,chDstFun)
      else
        DstPrb10830 = DstPrb10830 * (1.-DestWght) + DestWght*
     1  eovrlp( p2s , he3tau(ipLnTauIn,1),he3tau(ipLnTauTot,1),
     1  1e-4,8.80e-7,
     1  ipHe3l(1) , doppler(2) , he3tau(ipLnEscP,1) ,chDstFun)
      endif
*
      if( windv.eq.0. ) then
        do i=1,nhetau
*         always use complete redis for helium lines
          he3tau(ipLnEscP,i) = escsub( he3tau(ipLnTauIn,i) ,
     1    he3tau(ipLnTauTot,i) , 1e-4)
          he3tau(ipLnInwd,i) = fracin
        end do
      else
*       this is wind solution
*       ESCCOM is one-sided complete distribution (OK for wind)
        do i=1,nhetau
          he3tau(ipLnEscP,i) = esccom( he3tau(ipLnTauIn,i) , 1e-4  )
          he3tau(ipLnInwd,i) = 0.5
        end do
      endif
*
*     reset weight to old value
      DestWght = DestWghtSave
*
      end
****************************************************************
      subroutine hfit(h0,pow,n)
      implicit none
*photoionization cross section for excited hydrogenic states
      real h0 , pow
      integer n
*
*     better than 1 percent fit for n>= 30
      h0 = (1.3962688e-10 + 2.7479352e-9*sqrt(float(n)) )**2
*     same for power
      if( n.lt.1000 ) then
        pow = 2.99377 + 1.11784e-5*n - 0.382905/n -
     1  6.72051e-9*n*n
      else
        pow = 3.
      endif
*
      end
******************************************************************************
      subroutine highen( seccmp , scmpla )
      implicit none
*do high energy radiation field - gas interaction, Compton scattering, etc
      real seccmp , scmpla
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer limelm
      parameter (limelm=30)
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real pair
      common/pair/ pair
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgComBug
*trace compton flag
      common/combug/ lgComBug
      logical lgCompRecoil
*flag saying that compton recoil ionization of bound
*electrons is enabled
      common/recoil/ lgCompRecoil
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real hi , hii
      common/h/ hi , hii
      real ElecFrac
*ratio of electron to nuclei density, could be >1 because of he
*set in nockon
      common/efrac/ ElecFrac
      real htpair , posrat
      common/mev/ htpair , posrat
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real turhet,turrad
      common/turhet/ turhet,turrad
      real cryden , crpowr , crtemp , hxtot
      common/hextra/ cryden , crpowr , crtemp , hxtot
      logical lgNeutrnHeatOn
*flag lgNeutrnHeatOn says heating due to neutrons is enabled
*frcneu is fraction of total luminosity in neutrons, effneu is efficiency
*totneu is resulting total luminosity
      real frcneu , totneu , effneu
      common/neutrn/ frcneu , totneu , lgNeutrnHeatOn , effneu
      integer ircoil , irche
      common/ircoil/ ircoil , irche
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real csigh , csigc
      common/comsig/ csigh(ncell) , csigc(ncell)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hgamsc
      common/hgamsc/ hgamsc
      integer ippr , ioppr
      common/ipair/ ippr , ioppr
      integer iopcom
      common/iopcom/ iopcom
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      double precision comup, comdn
      common/comexc/ comup(ncell) , comdn(ncell)
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real CrsSecNeutron
*cross section for stopping relativistic neutrons
      common/crsnut/ CrsSecNeutron
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
*
*     local variables
      double precision hin
      integer nskip , i
      parameter (nskip=1 )
      save csav , ccsav , hcoil , crtla , crate , hecoil , cldold
      real hcoil,crsphi,energy,hecoil,crate,crtla,cd,sqthot,hcolde,
     1 cldold,clder,crion,sexp,eneut,excnut,secnut,gamfun,den,parion,
     2 pairla,heatin,csav,ccsav , crateh , cratehe
      real crtlah , crtlahe
      data crate/0./
*
*     free statement labels >=5
*
*-----------------------------------------------------------------------
*
*     bound electron scattering of >2.3 kev photons if neutral
      if( lgDoPhoto ) then
*       comoff usually 1, 0 if "NO COMPTON EFFECT" command given
*       lgCompRecoil usually t, f if "NO RECOIL IONIZATION" command given
        if( comoff.gt. .9 .and. lgCompRecoil ) then
          hcoil = 0.
          hgamsc = 0.
*         recoil starts at 194 Ryd = 2.6 keV
          do i=ircoil,nflux,nskip
            crsphi = OpacStack(i-1+iopcom) *
     1      (flux(i)+outcon(i)+outlin(i))
*           direct hydrogen ionization
            hgamsc = hgamsc + crsphi
*           recoil energy in Rydbergs
*           heating modified for suprathermal secondaries below; ANU2=ANU**2
            energy = 2.66e-5 * anu2(i) - 1.
            hcoil = hcoil + crsphi * energy
          end do
*
*         direct hydrogen ionization rate, does not include secondaries
          hgamsc = hgamsc * nskip
*         heating is in rydbergs because efionz, exctef, heatef in ryd
          hcoil = hcoil * nskip
*         secondary ionization rate
          crateh = hcoil * efionz * hi
*         La excitation rate
          crtlah = hcoil * 1.333 * exctef * hi
*         net heating efficiency, now in ergs/sec/cm3
          hcoil = hcoil * en1ryd
*
*         same thing for helium
          hecoil = 0.
          do i=irche,nflux,nskip
            crsphi = OpacStack(i-1+iopcom) *
     1      (flux(i)+outcon(i)+outlin(i))
*           recoil energy in Rydbergs
*           heating modified for suprathermal secondaries below; ANU2=ANU**2
            energy = 2.66e-5 * anu2(i) - 1.8
            hecoil = hecoil + crsphi * energy
          end do
*         first heating in ryd, later convert to ergs
          cratehe = hecoil * efionz * hei
          crate = crateh + cratehe
          crtlahe = hecoil*1.333*exctef*hei
          crtla = crtlah + crtlahe
          hecoil = hecoil * en1ryd * nskip
*
        else
          hcoil = 0.
          hecoil = 0.
          crate = 0.
          crtla = 0.
          hgamsc = 0.
        endif
      endif
*     second term is helium, two because two electrons
      heating(1,19) = hcoil*heatef*hi + hecoil*heatef*hei*2.
*
*-----------------------------------------------------------------------
*
*     heating and ionization by relativistic particles
*     CRYDEN=density (1/CM**3), neutral rate assumes 15ev total
*     energy loss, 13.6 into ionization, 1.4 into heating
*     units erg/sec/cm**3
*     iff not specified, CRTEMP is 2.6E9K
*
      if( cryden.gt.0. ) then
        cd = cryden * (radius/rinner) ** crpowr
        sqthot = sqrt( crtemp )
*       rate hot electrons heat cold ones, Balbus and McKee 1982
*       erg sec^-1 cm^-3
        hcolde = 5.5e-14 / sqthot * cd * eden
*       this is check for initial use of code
        if( nzone.le.0 ) cldold = hi+2.*htwo+hei
*       density of colliders, this can oscillate
        clder = cldold*0.8 + (hi+2.*htwo+hei) * 0.2
        cldold = clder
*       ionization rate; Balbus and McKee
        crion = 1.22e-4 / sqthot * log(2.72*(crtemp/1e8)**0.097)
     1  * cd * clder
        if( crtemp .gt. 2e9 ) then
*          cosmic ray ionization rate s-1 cm-3; ext rel limit
           crion = crion * 3.
*          usual circumstance; relativistic cosmic rays
           hxtot = 3.7e-20 *clder*cd + hcolde
        else
*          option for thermal cosmic rays
           crion = crion * 10.
           hxtot = hcolde + crion * 0.093 * 2.18e-11
        endif
        if( lgTrace ) write(qq,'(''     HIGHEN: cosmic ray density;'',
     1  1P,E10.2,'' CRion rate;'',E10.2,'' CR heat rate=;'',E10.2,
     2  '' CRtemp;'',E10.2)') cd , crion , hxtot , crtemp
      else
        crion = 0.
        hxtot = 0.
      endif
*
*     add on arbitrary extra heat
      if( turhet.ne.0. ) then
        hxtot = hxtot + turhet*sexp( turrad/real(depth) )
      endif
*
*     option to add on fast neutron heating
      if( lgNeutrnHeatOn ) then
*       eneut = totneu * (4e-26 * hden)
*       CrsSecNeutron is 4E-26 cm^-2, cross sec for stopping rel neutrons
*       and is set in large block data
        eneut = totneu * (CrsSecNeutron * hden)
        if( ElecFrac.lt.0.95 ) then
          secnut = eneut / 2.42e-11 * efionz
          excnut = secnut
          hxtot = hxtot + eneut * heatef
        else
          secnut = 0.
          excnut = 0.
          hxtot = hxtot + eneut
        endif
      else
        secnut = 0.
        excnut = 0.
      endif
*
*     pair production in elec field of nucleus
      posrat = gamfun( ippr ,nflux , ioppr )
      htpair = h
      den = hden + 4.*ahe
*
*     find heating, secondary ionization, Ly-alpha, excitation rates
*     following includes possible supra thermal electrons
*     effective pair heating
      pair = htpair * heatef * den
      parion = htpair / 2.42e-11 * efionz * den
      pairla = htpair / 2.42e-11 *exctef * 1.333 * den
*
      if( lgTrace.and.lgComBug.and.(htpair.ne.0.) ) write(qq,
     1 '(''     HIGHEN: pair production, heat'',1P,E8.2,'' ioniz'',
     2E9.2,'' la excit'',E9.2,'' HTPAIR'',E9.2)')
     1 pair , parion , pairla , htpair
*
*-------------------------------------------------------------------
*     Compton energy exchange
      if( lgDoPhoto  ) then
        cmcool = 0.
        cmheat = 0.
        heatin = 0.
        do i=1,nflux
*
*         Compton cooling
*         CSIGC is Tarter expression times ANU(I)*3.858E-25
*         6.338E-6 is k in inf mass Rydbergs, still needs factor of TE
          comup(i) = dble(flux(i)+outcon(i)+outlin(i)) * csigc(i) *
     1    (eden*4.d0*6.338d-6*1d-15)
          cmcool = cmcool + comup(i)
*
*         Compton heating
*         CSIGH is Tarter expression times ANU(I)**2 * 3.858E-25
*         CMHEAT is just spontaneous, HEATIN is just induced
          comdn(i) = dble(flux(i)+outcon(i)+outlin(i)) *
     1    csigh(i)*eden*1d-15
*
*         induced Compton heating
          hin = dble(flux(i)+outcon(i)+outlin(i))*
     1    csigh(i)*occnum(i)*eden*1d-15
          comdn(i) = comdn(i) + hin
          heatin = heatin + hin
*         following is total compton heating
          cmheat = cmheat + comdn(i)
        end do
*
*       remember how important induced compton heating is
        if( cmheat.gt.0. ) then
          cinrat = max( real(cinrat), heatin/max(1e-37,real(cmheat)) )
        endif
*
        if( lgTrace.and.lgComBug ) then
          write(qq,'(5x,''HIGHEN: COOL num='',1p,
     1    e8.2,'' HEAT num='',e8.2,'' HCOIL='',e8.2)')
     4    cmcool, cmheat, hcoil
        end if
*
*       comoff usually 1, turns off Compton
        csav = cmheat * comoff
        ccsav = cmcool * comoff
      endif
*
      cmheat = csav
      cmcool = ccsav
*
*-------------------------------------------------------------------------
*
*     following saved for possible printout in PRSTEP
      heating(1,20) = cmheat
      heating(1,21) = hxtot
      heating(1,22) = pair
*
      if( lgTrace.and.lgComBug ) write(qq,'(5X,''HIGHEN sets '',
     1''total heating='',1P,E10.2,'' frac(compt)='',E10.2,
     2'' f(bcompt)='',E10.2,'' f(hxtot)='',E10.2,'' f(pair)'',E10.2)')
     3 htot , cmheat/htot , hcoil/htot , hxtot/htot , pair/htot
*
      seccmp = crate + crion + parion + secnut
      scmpla = crtla + pairla + excnut
*
      end
******************************************************************************
      subroutine histag( nelem)
      implicit none
*trim down highest stage of ionization at start of calculation
      integer nelem
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     n is the highest stage of ionization to consider
*     this routine trims down the range of ionization stages to exclude
*     those above the highest energy considered for this continuum
*
*     >>chng 97 Aug 11, add ipHeavy
      do while( ipHeavy(nelem,IonHigh(nelem)-1).gt.nflux .and.
     1  IonHigh(nelem).gt.2 )
        IonHigh(nelem) = IonHigh(nelem) - 1
      end do
*
      end
******************************************************************************
      real function hjbar(ihi,low)
      implicit none
*return continuum occupation number for any hydrogen line
      integer ihi,low
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
*
*     HJBAR returns photon occupation number for continuum at energy
*     of the IHI to LOW transition of hydrogen
*
      if( lgFluor ) then
        hjbar = occnum( iphl(ihi,low) )
      else
*       option to turn off continuum fluorsecent excitation with
*       "no induced" command
        hjbar = 0.
      endif
*
      end
******************************************************************************
      subroutine hlevel( h2ovh1 , simhii , csupeff)
      implicit none
*solve for ionization balance level populations of model hydrogen atom
      double precision h2ovh1
      real simhii , csupeff
*
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real hnet
      common/hnet/ hnet(lmhlvl,lmhlvl-1)
      double precision hlbolt , hcbolt
*     hlbolt(low,up) line boltzmann factors for hydrogen atom
*     hcbolt(n) excit to continuum
      common/hlvcol/ hlbolt(lmhlvl-1,lmhlvl+1) , hcbolt(lmhlvl+1)
      real pmph31, pmpo51, pmpo15 , esch31
      common/bowoi/ pmph31, pmpo51, pmpo15 , esch31
      real hrc2s , hrc2p
      common/hrc2sp/ hrc2s , hrc2p
      double precision hlte
      real hc2p2se , hc2p2sp , hc2s1s
*hc2p2se and hc2p2sp are rates for 2s - 2s collisions with electrons and protons
*hlte is lte population of each level
      common/hcolrt/ hlte(lmhlvl+1) , hc2p2se , hc2p2sp , hc2s1s
      real x12
      common/x12/ x12
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      logical lgHColionImp
*     flag saying whether H atom is photo=false or collis ionized=true
      common/colion/ lgHColionImp
      logical lgHiPop2
      real pop2mx
*lgHiPop2 flag set if H n=2 population gets large relative to ground
*pop2mx is maximum population of n=2 relative to ground
      common/hipop2/ lgHiPop2 , pop2mx
      logical lgHIonON
*flag set false when hydrogen ionization too small to compute
      common/hionon/ lgHIonON
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hex , dhexdt
      common/hex/ hex , dhexdt
      real hcoldn , hbul , hradn
*save collision, induced, and spontaneous rates for levels from hydroen atom
      common/hcbr/ hcoldn(lmhlvl+1) , hbul(lmhlvl+1) , hradn(lmhlvl+1)
*     include "hbn.com"
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      reaL ri2s1s , ri1s2s
      common/rin2ph/ ri2s1s , ri1s2s
      real htotrc
      common/htotrc/ htotrc
      real HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
*     HRecRad is sum of radiative rec to all excited states
*     hrectot is hcaseb plus effective rec to ground
*     HRecEffec is total effec eval in hlevel, should be
*     roughly equal to hrectot
*     HRecNet is net rec coef, with 3-body rec less coll ioniz
*     HRecCol is thre-body recombination alone
*     HRecInd is induced recombination
      common/hcaseb/ HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
      real hgdist
      common/hgdist/ hgdist
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real HLevNIonRyd
*ionizatoin potention of hydrogenic level n
*set in makehydro
      common/HNIonRyd/ HLevNIonRyd(lmhlvl+1)
*     energy differences for model hydrogen atom:
*     this is array of temperatures, first between levels, sec lev to cont
*     HdeltaT( upper , lower )
      real HdeltaTe, HCionTe
      common/HdeltaT/ HdeltaTe(lmhlvl,lmhlvl), HCionTe(lmhlvl)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      logical lgHlteOk
*true is all lte populations positive for H atom
      common/HlteOk/ lgHlteOk
      logical lgHColRec , lgHCoolng
      common/HColRec/ lgHColRec , lgHCoolng
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      character chMatrix*7
      common/TypMatrx/ chMatrix
      real HRateDestGnd(8)
*remember total rates destroying hydrogen ground
      common/HRateDest/ HRateDestGnd
      logical lgBigSec
      common/BigSec/ lgBigSec
      real totnuc
*     totnuc is total number of nuclei and molecules, eval in ptot
      common/totnuc/ totnuc
      logical lgNoCota
*lgNoCota flag set with no three body recombination
      real CotaRate
      common/rcota/ lgNoCota , CotaRate(limelm)
      real HCTOn
*     variable to turn on or off ct ionization-recombiantion of
*     hydrogen - set 0 with no charge trasnfer command
      common/HCTOnOff/ HCTOn
      logical lgHMtrxOff
      common/MtrxOff/ lgHMtrxOff
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real colfac,h2s,phtfrc,topoff,above,below,
     1 x12p,x12s,x13,x14,edp,r2p2s,edhi,rfac, colfrc
      real colsup(lmhlvl+1)
      integer i,nerror,j,lev,iup,low , job
      integer level, lower , upper , ipiv(lmhlvl+1)
      real totcap(lmhlvl+1) , hexx(lmhlvl+1) , RadSum , secfrc
      double precision z(lmhlvl+2,lmhlvl+2),c,rm1 , save ,
     1 SaveZ(lmhlvl+2,lmhlvl+2) , error(lmhlvl+1) ,
     2 amat(lmhlvl+1,lmhlvl+1), bvec(lmhlvl+1) , rcond, work(lmhlvl+1)
      integer nzUsed
      save nzUsed
      data nzUsed/-1/
*
*     2S LEVEL IS LEVEL TEN; Z(2,I) IS 2P, Z(10,I) = 2S, HN(2) IS SUM
*     free statement labels >=12
*
*-----------------------------------------------------------------------
      lgHColionImp = .false.
      lgHColRec = .false.
*     charge transfer charge exchange
      if( nzone.le.1 .or. CTHrec(2)*CTHion(2).eq.0. ) then
        if( nzUsed.ne.nzone ) then
*         this is zone 0, the first time hydro is called
*         ct rates have not been evaluated yet by the heavies
          CTHrec(2) = 0.
          CTHion(2) = 0.
        else
          CTHrec(2) = CTHrec(1) * HCTOn
          CTHion(2) = CTHion(1) * HCTOn
        endif
      else if( nzone.ne.nzUsed ) then
*     >>chng 96 May 17 bring back into main loop
        CTHrec(2) = CTHrec(2)*0.75 + 0.25*CTHrec(1) * HCTOn
        CTHion(2) = CTHion(2)*0.75 + 0.25*CTHion(1) * HCTOn
      endif
*
*     if(cthion(2).gt.0. .and. nzUsed.ne.nzone ) then
*       write(70,'(i4,1p,12e10.2)') nzone, cthrec(2),cthion(2),
*    1  (cthionAgnt(i)/cthion(2),i=1,3)
*     endif
      nzUsed = nzone
      if( lgTrConvg .and.nLevTrace.eq.0 ) then
        write(qq,'(7x,''hlevel, te:'',1p,e9.3,'' eden:'',e9.3)') te,eden
      endif
*     check how low temperature is; departure coef tend to infinity
*     as TE goes to zero; matrix formalism won't work on a 32-bit machine
*     if EXP(H NU/KT) > 1E38 for 13.6EV.
*     the recombination coefficient is effect radiative (only) rec
*     coef (optical depths in)
*     this is first eval of destroy, not with balmer cont since hn(2)/hnn(1)
*     may div by 0 - a second evaluation occurs after solun of matrix
*     with this term
*     code will not get to that evaluation if low te used
*     csupeff is effective suprathermal ionizaiton rate
*     deep in x-ray illuminated clouds most sec ion are result of
*     O k-shell photoionization.  Cannot reevalute this directly
*     when ne changes slightly, so use simple scaling
*     csuEfrac was elec frac when csupra last evaluated
*     >>chng 97 aug 26, get rid of following since now only 1 eval per ion loop
*     csupeff = csupra * ((eden/totnuc)/csuEfrac)**(-0.42)
*     no longer necessary since within eden loop
      csupeff = csupra
*     the above did not work, since H got out of sync
*     with current value of csupra
*
      csupeff = csupra
*
*     total 2p2s rate
*     r2p2s = hc2p2s * edp
      r2p2s = hc2p2se * eden + hc2p2sp * hii
*
      destroy(1,1) = hgamnc(1)+csupeff+hcolnc(1)*eden
      create(1,1) = eden * htotrc
      edhi = eden + hi * 1.7e-4
*
*     sum up decays
      do level=1,nhlvl
        RadSum = 0.
        do lower=1,level-1
          RadSum = RadSum + hnet(level,lower)
        end do
        hradn(level) = RadSum
      end do
*
      simhii = (hgamnc(1)+csupeff+hcolnc(1)*edhi+CTHion(2)) /
     1 (eden*(htotrc+CotaRate(1)) +CTHrec(2))
      if( simhii.gt.0. ) then
        phtfrc = hgamnc(1)/((eden*(htotrc+CotaRate(1))+
     1  CTHrec(2))*simhii)
        colfrc = (hcolnc(1)*edhi+CTHion(2))/
     1  ((eden*(htotrc+CotaRate(1))+CTHrec(2))*simhii)
        secfrc = csupeff/
     1  ((eden*(htotrc+CotaRate(1))+CTHrec(2))*simhii)
        if(secfrc.gt.0.2 ) then
*         flag to say that sec ioniz is a big deal, do not
*         let eden change by much
          lgBigSec = .true.
        else
          lgBigSec = .false.
        endif
*       override above logic, which should probably be removed.
*       sec rate now changes with elec density
        lgBigSec = .false.
      else
      lgBigSec = .false.
        phtfrc = 0.
        colfrc = 0.
        secfrc = 0.
      endif
      if( lgHBug.and.lgTrace ) then
        write(qq,'(5x,''HLEVEL called, simple II/I=''
     1  ,1P,E10.4,'' PhotFrc:'',E10.4,'' ColFrc:'',E10.4,'' SecFrc'',
     2  e10.4,'' Te:'',e10.4,'' eden:'',e10.4)') simhii,phtfrc,colfrc,
     3  secfrc,te , eden
      end if
*     don't bother if no ionizing radiation
      if( simhii.lt.1e-30 ) then
        lgHMtrxOff = .true.
        if(lgHBug.and.lgTrace ) then
          write(qq,'(5X,''HLEVEL simple II/I='',1P,
     1    E10.2,'' so not doing equilibrium.'')') simhii
        end if
        lgHIonON = .false.
        do i=1,nhlvl+1
          hbn(i) = 1.
          hn(i) = 0.
        end do
        hn2p = 0.
        hn2s = 0.
        HRecEffec = 0.
        hex = 0.
        dhexdt = 0.
        h2ovh1 = 0.
        return
      endif
*
*     sec term added May 93 for cr ionized, mostly neutral, warm gas
*     originally was 1e-9, change to 1e-7 for pdr non-convergence
*     last one is check that HLTE pops are non-zero
*     >>chng 96 may 8, for dense models close to lte all ionizations can be from
*     excited states, and simple and actual pops are very different.
*     code used simple all the time, caused catastrophe for Kingdon nova model.
*     now use actual pops if we are into model
      if( nzone.gt.2 ) then
        rfac = h2ovh1
      else
        rfac = simhii
      endif
*     if( te.le.thlo .or. simhii.lt.1e-7 .or. (.not.lgHlteOk) ) then
*     >>chng 96 may 8, from simhii to rfac
*     >>chng 96 aug 22, added test on lgHMtrxOff, whether or not matrix ever tur
*     this avoids possible discontinuity where approximations change
      if( te.le.thlo .or. rfac.lt.1e-7 .or. (.not.lgHlteOk) .or.
     1 lgHMtrxOff ) then
        if( lgHBug.and.lgTrace ) then
          if(te.le.thlo)write(qq,'('' H matrix not used, te too low'')')
          if(rfac.lt.1e-7)write(qq,'('' H matrix not used, H too '',
     1    ''neutral'')')
          if(.not.lgHlteOk)write(qq,'('' H matrix not used, Hlte '',
     1    ''not ok'')')
          if(.not.lgHMtrxOff)write(qq,'('' H matrix turned off '')')
          if(.not.lgHMtrxOff)write(qq,*)' h matrix turned off2, simhii',
     1    simhii
        endif
        lgHMtrxOff = .true.
        nhlo = nhlo + 1
*       following is case b rec coef
        HRecEffec = hrec(1,1)*hrec(1,2) + HRecRad + CotaRate(1)
*
*       do radiative only cascades
        topoff = 0.
        do lev=nhlvl,3,-1
*         radiative rec plus three body rec
          above = (hrec(lev,1)*hrec(lev,2) +
     1    hcolnc(lev)*hlte(lev)*eden )*eden
          topoff = topoff + above
          do iup=lev+1,nhlvl
*           hlev(lev,low) is A * esc prob
            above = above + hn(iup)*(hnet(iup,lev) + hcol(iup,lev)*eden)
          end do
          below = 0.
          do low=1,lev-1
            below = below + hnet(lev,low) + hcol(lev,low)*eden
          end do
          if( below.gt.1e-25 ) then
            hn(lev) = above / below
          else
            hn(lev) = 0.
          endif
          if( hlte(lev).gt.1e-25 ) then
            hbn(lev) = hn(lev) / (hlte(lev) * eden )
          else
            hbn(lev) = 0.
          endif
        end do
*
        topoff = topoff +
     1   (hrec(2,1)*hrec(2,2) + hcolnc(2)*hlte(2) )* eden +
     1   (hrec(nhlvl+1,1)*hrec(nhlvl+1,2) +
     1   hcolnc(nhlvl+1)*hlte(nhlvl+1) )* eden +
     1   (hrec(1,1)*hrec(1,2) + hcolnc(1)*hlte(1) )* eden
*
*       do simple two level for hydrogen, then fill in HN(i) for rest
*       above in below is tot rec
        hn(1) = (topoff+CTHrec(2))/(hgamnc(1)+csupeff+hcolnc(1)*
     1  (eden+hi/1e4)+CTHion(2))
*       H beta recombination, assuming case B
*       HN(4) = (HRecRad*0.0912) * EDEN / HEMIS(4,2)
*       hbeta = (10.**(-20.89-0.10612*(alogte-4.4)**2))/te*eden
*       hn(4) = hbeta / hemis(4,2) / 4.093e-12
*       const = hn(4) * hemis(4,2)
*       renormalized to agree with matrix at 1000K
*       hn(3) = const * 14.5 / te10/te03/te03*te01 / hemis(3,2)*0.6645
*       hn(5) = const * 0.291 * te03 * te01 / hemis(5,2)*1.2645
*       hn(6) = const * 0.138 * te03*te01*te01 / hemis(6,2)*1.516
        x12p = x12 * 2. / 3. / 1.261
        x12s = x12 * 1. / 3. / 1.261
        x13 = x12 * 0.165 / 1.261
        x14 = x12 * 0.059 / 1.261
* 666 error! put this in above
*       hn(3) = hn(3) + hn(1)*x13/(hemis(3,2)+hemis(3,1))
*       hn(4) = hn(4) + hn(1)*x14/(hemis(4,3)+hemis(4,2)+
*    1  hemis(4,1))
        edp = (eden * 0.1  +  hii * 0.9 )
        hn2s = (HRecRad*0.33*eden + hn(1)*x12s + hn2p*r2p2s ) /
     1  (8.23+hc2s1s*edhi + r2p2s*6. )
        hn2p = ( HRecRad*0.67*eden + hn(1)*x12p + hn2s*r2p2s*6. ) /
     1  ( hnet(2,1) + hcol(2,1)*eden + r2p2s )
        hn(2) = hn2s + hn2p
        h2ovh1 = 1. / ( hn(1)+hn(2)+hn(3)+hn(4)+hn(5)+hn(6) )
*       following used for collisional ioniz cooling
*       hex will be multiplied by HII in coolr
        hex = en1ryd * hcolnc(1) * (eden+hi*1.7e-4) * hn(1)
        dhexdt = 0.
*
        if( lgHBug.and.lgTrace ) then
          write(qq,'(7X,''LOW TE,='',1P,E10.3,
     1    '' HN(1)='',E10.3,'' rec='',E10.3,'' Hgamnc(1)='',E10.3
     2    )') te , hn(1) , HRecEffec , hgamnc(1)
        endif
        if( lgTrace ) then
          write(qq,'(7X,''HLEVEL return, LOW TE used, HII/HI='',1P,
     1    e10.3,'' simple='',E10.3,'' IonRate='',E10.2,'' RecCo=''
     2    ,e9.2,'' chrex,d'',2e9.2)') h2ovh1 , simhii ,
     3    hgamnc(1)+csupeff+hcolnc(1)*eden,topoff,CTHrec(2),
     4    CTHion(2)
        endif
        return
      endif
*-------------------------------------------------------------------
*
*     radiative and three body rec, fix 2s and 2p first
*     HLTE(i) is only LTE pop when mult by Ne Nh
*
      HRecEffec = 0.
      do i=1,nhlvl+1
        z(i,nhlvl+2) = (dble(hrec(i,1)*hrec(i,2))+
     1  dble(rinduc(i)))/hlte(i) + dble(hcolnc(i)*edhi)
*       >>chng 97 july 25, had been eden changed to edhi, since coll ionize
*       is edhi, caused slight departures from true lte in very dense models
*    1  dble(rinduc(i)))/hlte(i) + dble(hcolnc(i)*eden)
        totcap(i) = z(i,nhlvl+2) * hlte(i)
        HRecEffec = HRecEffec + totcap(i)
      end do
*
*     add on charge transfer recombination
      z(1,nhlvl+2) = z(1,nhlvl+2) + CTHrec(2)/hlte(1)/eden
      totcap(1) = z(1,nhlvl+2) * hlte(1)
*
*     following electron density has approximate correction for neutrals
*     corr of hi*1.7e-4 accounts for col ion by HI; Drawin Zs Phys 225, 483.
*     eden changed to edhi June 25 93 for pdr getting very hot
      edhi = eden + hi * 1.7e-4
*
*     hcol(u,l), etc, are rates for downward collisions (cm^3 s^-1)
*     extra 1.261 renorm to all lyman photons, x12 is this sum
*     energy branching ratios fomr xu and mccray, apj 375, 190
      x12p = x12 * 2. / 3. / 1.261
      x12s = x12 * 1. / 3. / 1.261
*     factor mul X12 is high te limit for C13/C12 from Agarwall
      x13 = x12 * 0.165 / 1.261
      x14 = x12 * 0.059 / 1.261
      colsup(2) = x12 * 2. / 3. / 1.261
      colsup(nhlvl+1) = x12 * 1. / 3. / 1.261
      colsup(3) = x12 * 0.165 / 1.261
      colsup(4) = x12 * 0.059 / 1.261
      do level=5,nhlvl
        colsup(level) = colsup(level-1) / 3.
      end do
*
      edp = (eden * 0.1  +  hii * 0.9 )
*
*---------------------------------------------------------------------
*
*     master balance equation
      do level=1,nhlvl
*       all process depopulating level
*       hradn(level) is sum of spontaneous decays to lower levels
*       hradn(level) is sum of hnet, hnet is net A down
*       hbul(n) is sum of induced exits from level n, both up and down
        RadSum = 0.
*       no loop for level=1
        do lower=1,level-1
          RadSum = RadSum + hnet(level,lower)
        end do
        hradn(level) = RadSum
        z(level,level) = hgamnc(level) + RadSum +
     1  (hcoldn(level)+hcolnc(level))*edhi + hbul(level) + csupeff
*
*       all processes populating level from below
        do lower=1,level-1
*         hcont is sum of induced trans from upper to lower
          z(level,lower) = -hcol(level,lower) * edhi -
     1    hcont(level,lower)/hlbolt(lower,level)
        end do
*
*       all processes populating level from above
        do upper=level+1,nhlvl
          z(level,upper) = -(hnet(upper,level)+hcont(upper,level)+
     1    hcol(upper,level)*edhi)*hlte(upper)/hlte(level)
        end do
      end do
*
*     fix 2s-1s
      z(1,nhlvl+1) = -( 8.23+ri2s1s+hc2s1s*edhi ) * hlte(nhlvl+1)/
     1  hlte(1)
*
*     level 2p balance
      c = 0.75 / hlte(2)
      rfac = 0.32 - 0.07 * eden / ( eden + 1e7 )
      rm1 = ( 1. - rfac )
*
      z(2,1) = -( hcol(2,1)*edhi + hcont(2,1)/hlbolt(1,2) )
*
      z(2,2) = hgamnc(2)+ hnet(2,1) + (hcoldn(2)+hcolnc(2))*edhi +
     1 r2p2s + hbul(2)  + csupeff
*
*     hbul(nhlvl+1) with induced two photon
      z(nhlvl+1,nhlvl+1) = 8.23 + hgamnc(nhlvl+1) +
     1 (hcoldn(nhlvl+1)+hcolnc(nhlvl+1))*edhi +
     1 r2p2s *3. + hbul(nhlvl+1) + csupeff
*
*     now fix routes into 2s and 2p from above
      do upper=2+1,nhlvl
        save = -hcol(upper,2)*edhi - hcont(upper,2)/hlbolt(2,upper)
        z(upper,2) = save * 0.75
*       hnet is total decays to 2p and 2s
        z(2,upper) = -(hnet(upper,2)*rm1/hlte(2)+(hcont(upper,2)+
     1  hcol(upper,2)*edhi)*0.75/hlte(2) ) *hlte(upper)
*       hcont must always be multiplied by 0.25 to cancel ratio
*       of stat weights
        z(upper,nhlvl+1) =
     1   -(hcol(upper,2)*edhi + hcont(upper,2)/hlbolt(2,upper))*0.25
        z(nhlvl+1,upper) = -(hnet(upper,2)*rfac/hlte(nhlvl+1)+
     1  (hcont(upper,2)+hcol(upper,2)*edhi)*0.25/hlte(nhlvl+1)) *
     2  hlte(upper)
      end do
      z(2,nhlvl+1) = -r2p2s
*
*     level 2s balance equation - define 2s as lower energy than 2p
*
      z(nhlvl+1,1) = -( ri2s1s/hlbolt(1,2) + hc2s1s*edhi )
      z(nhlvl+1,2) = -r2p2s  * hlte(2)/hlte(nhlvl+1)
*
*     now add on supra thermal excitation
*     upper level is 2s, all works out
      do level=2,nhlvl+1
        z(1,1) = z(1,1) + colsup(level)
        z(1,level) = z(1,level) - colsup(level)*hstat(1)/hstat(level)*
     1  hlte(level)/hlte(1)
        z(level,1) = z(level,1) - colsup(level)*hstat(1)/hstat(level)/
     1  hlbolt(1,level)
        z(level,level) = z(level,level) + colsup(level)*2./hstat(level)
      end do
*
*     chrage transfer ionization
      z(1,1) = z(1,1) + CTHion(2)
*
*     remember ground state destruction rate
      hgdist = z(1,1)
      HRateDestGnd(1) = z(1,1)
      HRateDestGnd(2) = hgamnc(1)/z(1,1)
      HRateDestGnd(3) = hcolnc(1)*edhi /z(1,1)
      HRateDestGnd(4) = hcoldn(1)*edhi /z(1,1)
      HRateDestGnd(5) = csupeff /z(1,1)
      HRateDestGnd(6) = colsup(2)*9. /z(1,1)
      HRateDestGnd(7) = hbul(1) /z(1,1)
      HRateDestGnd(8) = CTHion(2) /z(1,1)
*
      if( lgTrace.and.lgHBugFull ) then
        write(qq,'(6X,''level     others => '')')
        do i=1,nhlvl+1
          write(qq,'(7x,''HII'',i2,1p,13e9.1/12x,10E9.1)') i,(z(i,j),
     1    j=1,nhlvl+2)
        end do
      endif
*
*     save matrix
      do j=1,nhlvl+2
        do i=1,nhlvl+2
          SaveZ(j,i) = z(j,i)
        end do
      end do
*
*     scale to largest number of order unity
      do j=1,nhlvl+1
        do i=1,nhlvl+2
          z(j,i) = z(j,i) * hlte(j)
        end do
      end do
*
*     this is the usual matrix inversion method, slightly faster
      if( chMatrix.eq.'matin1 ' ) then
        call matin1( z,lmhlvl+2,nhlvl+1,1,nerror)
        if(nerror.ne.0 ) then
          write(qq,'('' hydrogen matrix error, stop.'')')
          stop
        endif
*     this one may be more robust
      else if( chMatrix.eq.'linpack' ) then
        do j=1,nhlvl+1
          do i=1,nhlvl+1
            amat(j,i) = z(j,i)
          end do
          bvec(j) = z(j,nhlvl+2)
        end do
        call DGETRF(nhlvl+1,nhlvl+1,amat,lmhlvl+1,ipiv,nerror)
        call DGETRS( 'N',nhlvl+1,1,amat,lmhlvl+1,ipiv,bvec,lmhlvl+1,
     1  nerror)
*       now put results back into z so rest of code treates only
*       one case - as if matin1 had been used
        do i=1,nhlvl+1
          z(i,nhlvl+2) = bvec(i)
        end do
*     Jason found this one on the Exemplar, distributed source just stops
      else if( chMatrix.eq.'veclib ' ) then
        do j=1,nhlvl+1
          do i=1,nhlvl+1
            amat(j,i) = z(j,i)
          end do
          bvec(j) = z(j,nhlvl+2)
        end do
        job = 0
        call dgeco(amat,lmhlvl+1,nhlvl+1,ipiv,rcond,work)
        call dgesl(amat,lmhlvl+1,nhlvl+1,ipiv,bvec,job)
*       now put results back into z so rest of code treates only
*       one case - as if matin1 had been used
        do i=1,nhlvl+1
          z(i,nhlvl+2) = bvec(i)
        end do
      else
        write(qq,'('' chMatrix type insane in hydrogen, was'',a7)')
     1  chMatrix
        stop
      endif
*
*     check whether solution is valid
      do level=1,nhlvl+1
        error(level) = 0.
        do i=1,nhlvl+1
          error(level) = error(level) +
     1    SaveZ(level,i) * z(i,nhlvl+2)
        end do
        if( SaveZ(level,nhlvl+2).gt.0. ) then
          error(level) = (error(level)-SaveZ(level,nhlvl+2))/
     1    SaveZ(level,nhlvl+2)
        else
          error(level) = 0.
        endif
      end do
*
*     convert from departure coef in Z(I) to level pop rel to HII
*     HEX is net cooling rate due to col ionization-three body rec (s-1 here)
*     dHEXdt is derivative of this wrt temperature
*
      hbn(1) = z(1,nhlvl+2)
      hn(1) = hbn(1) * hlte(1) * eden
      hex = hcolnc(1) * edhi * (hn(1)-hlte(1)*eden)
      hexx(1) = hex
      dhexdt = hex * (HCionTe(1)*tsq1-halfte)
*
*     2p by itself
      hbn(2) = z(2,nhlvl+2)
      hn(2) = hbn(2) * hlte(2) * eden
      hn2p = hn(2)
      hexx(2) = HLevNIonRyd(2) * hcolnc(2) * edhi * (hn2p-hlte(2)*eden)
      hex = hex + hexx(2)
      dhexdt = dhexdt + hexx(2) * (HCionTe(2) * tsq1-halfte)
*
*     2s by itself
      hbn(nhlvl+1) = z(nhlvl+1,nhlvl+2)
      hn2s = hbn(nhlvl+1) * hlte(nhlvl+1) * eden
      hn(nhlvl+1) = hn2s
      hn(2) = hn(2) + hn2s
      h2s = HLevNIonRyd(2) * hcolnc(2)*edhi*(hn2s-hlte(nhlvl+1)*eden)
      hex = hex + h2s
      hexx(nhlvl+1) = h2s
      dhexdt = dhexdt + hexx(nhlvl+1) * (HCionTe(2) * tsq1-halfte)
*
*     highest level is fastest collision by far, its coupling to
*     continuum can overwhelm heating
      do i=3,nhlvl
        hbn(i) = z(i,nhlvl+2)
*       hn(I) are pop per level rel to HII; i.e., N(n)/N(HII)
        hn(i) = hbn(i) * hlte(i) * eden
*       units of HEX are erg/cm^3/s
*       min enters since excited levels can have departure coef >1
*       due to putting all very excit stat captures into nhlvl
*                 HLevNIonRyd is ionization energy in Rydbergs
*       hexx(i) = HLevNIonRyd(i) * hcolnc(i) * eden *
*    1  min( 0., hn(i)-real(hlte(i)*eden) )
*       >>chng 95 dec 18 cooling due to collis ioniz only counted for n=1,2
*       >>chng now in all levels except highest two
*       >>chng 96 feb 20, eden to edhi, rm real on real(hlte(i)*eden)
        hexx(i) = HLevNIonRyd(i) * hcolnc(i) * edhi *
     1  ( hn(i)-hlte(i)*eden )
*       factor in min should always be negative when bn<1
*       do not do highest level, with flaky departure coef
        if( i.le.nhlvl-2 ) then
          hex = hex + hexx(i)
          dhexdt = dhexdt + hexx(i) * (HCionTe(i) * tsq1-halfte)
        endif
      end do
*666  write(66,'(20f5.2)') (hexx(i)/hex,i=1,nhlvl)
      hex = hex * en1ryd
      dhexdt = dhexdt * en1ryd
*
*     now get real effective rec coef
      HRecNet = 0.
      HRecCol = 0.
      HRecInd = 0.
      do i=2,nhlvl+1
        HRecInd = HRecInd + rinduc(i)
        HRecCol = HRecCol + hcolnc(i)*eden * hlte(i)*(1.-hbn(i) )
        HRecNet = HRecNet +
     1  hrec(i,1)*hrec(i,2)+rinduc(i)  +
     1  hcolnc(i)*eden * hlte(i)*(1.-hbn(i) )
      end do
*
*     destruction, creation, for level n
*     level = nhlvl+1
*     write(qq,'('' destruction level'',i3,'' rad:'',f5.3,
*    1 '' Gam:'',f5.3,'' col:'',f5.3,'' colnc:'',f5.3,
*    2 '' 2p2s:'',f5.3,'' bul:'',f5.3,'' csup:'',f5.3)')
*    1 level , hradn(level) / SaveZ(level,level) ,
*    2 hgamnc(level)/ SaveZ(level,level) ,
*    2 hcoldn(level)*edhi/ SaveZ(level,level) ,
*    2 hcolnc(level)*edhi/ SaveZ(level,level) ,
*    2 r2p2s*3./ SaveZ(level,level) ,
*    2 hbul(level)/ SaveZ(level,level) ,
*    2 csupeff/ SaveZ(level,level)
*     now do creation processes
*     level = nhlvl+1
*     rfac = 0.
*     doi=1,nhlvl
*       rfac = rfac - SaveZ(level,i) * hbn(i)
*     end do
*     rfac = rfac + SaveZ(level,nhlvl+2)
*     write(qq,'('' creation    level'',i3,'' from '',
*    1 10(i3,f6.3))') level, (i,-SaveZ(level,i)*hbn(i)/rfac,i=1,nhlvl),
*    2 0, SaveZ(level,nhlvl+2)/rfac
*
*     write(QQ,'(1p,14e9.2)') hcolnc(2), hcolnc(3), hn(2),hn(3),
*    1 hlte(2),hlte(3), hexx(2),hexx(3)
*
*     this is the ratio of ionized to heutral hydrogen
*     neutral hydrogen is defined as total population in first 6 levels
*     hn(2) is 2s and 2p together
      h2ovh1 = 0.
      do level=1,nhlvl+1
        h2ovh1 = h2ovh1 + hn(level)
      end do
      h2ovh1 = 1. / h2ovh1
*     above, why was colsup(1)  always 0 while csupeff large
*     following used til 12 june 95
*     H2OVH1 = 1. / ( HN(1)+HN(2)+HN(3)+HN(4)+HN(5)+HN(6) )
*
      if( lgHBugFull.and.lgTrace ) then
        write(qq,'(7X,''HLEV HGAMNC'',1P,E9.3,9E9.2)')
     1  (hgamnc(i),i=1,nhlvl+1)
        write(qq,'(7X,''HLEV TOTCAP'',1P,10E9.2,'' tot='',E9.2)')
     1  (totcap(i),i=1,nhlvl+1) , HRecNet
        write(qq,'(7X,''HLEV IND Rc'',1P,10E9.2)')
     1  (rinduc(i),i=1,nhlvl+1)
        write(qq,'(7X,''IND Rc LTE '',1P,10E9.2)')
     1  (hgamnc(i)*hlte(i),i=1,nhlvl+1)
        write(qq,'(7X,''HLEV IND As'',1P,10E9.2)')
     1  (hbul(i),i=1,nhlvl+1)
        write(qq,'(7X,''HLEV   HLTE'',1P,10E9.2)')
     1  (hlte(i),i=1,nhlvl+1)
*       fraction of total ionization due to photo from given level
        write(qq,'(7X,''HLEVfr cion'',1P,10E9.2)') (
     1  hcolnc(i)*hn(i)*eden/(HRecEffec*eden),i=1,nhlvl)
*       fraction of total ionization due to photoionization from given level
        write(qq,'(7X,''HLEVfrPhIon'',1P,10E9.2)') (
     1  hgamnc(i)*hn(i)/(HRecEffec*eden),i=1,nhlvl)
        if( hex.gt.0. ) then
        write(qq,'(7X,''HLEVfr Heat'',1P,10E9.2)') (
     1  hexx(i)*en1ryd/abs(hex),i=1,nhlvl)
        endif
        write(qq,'(7X,''HLEV     HN'',1P,9E9.2,'' HN2s,p'',2E9.2)')
     1  (hn(i),i=1,nhlvl),hn2s,hn2p
        write(qq,'(7X,''HLEV   b(n)'',1P,9E9.2,''   2s,p'',2E9.2)')
     1  (hbn(i),i=1,nhlvl) , hbn(nhlvl+1) , hbn(2)
        write(qq,'(7X,''HLEV   X12'',1P,E9.2,
     1  '' Heat Exc'',E9.2,'' Grn dest:'',E9.2)')
     2  x12,hex,hgdist
      endif
*
      if( hn(2)/hn(1).gt.0.1 ) then
        lgHiPop2 = .true.
        pop2mx = max( hn(2)/hn(1) , pop2mx )
      endif
*
*     set flag to tell IONTE whether photo or coll ioniz
      colfac = hcol(2,1)*hlte(2)/hlte(1)*eden * ( hgamnc(2)+hcolnc(2)+
     1 hcol(3,2)*hlte(3)/hlte(2)) / (hcol(2,1)*eden+hnet(2,1))
*     >>chng 96 nov 8, what in the world was the above?  very small, test worthl
*     ratio of collisions to photo
      if( hgamnc(1)+csupeff.gt.1e-30 ) then
        colfac = hcolnc(1)*edhi / (hgamnc(1)+csupeff)
      else
        colfac = 0.
      endif
*
*     colfac added mar 93 to stop too large te change
      if( colfac.gt.0.2 )  then
        lgHColionImp = .true.
      else
        lgHColionImp = .false.
      endif
*
      do level=1,nhlvl+1
        if( hn(level).le.0. ) then
          write(qq,'(1X,''HLEVEL finds negative hydrogen level '',
     1    ''population for level '',i3,1P,E10.3,
     1    '' simple='',E10.3,'' TE='',E10.3,'' ZONE='',I4)')
     2    level,hn(level) , simhii , te , nzone
          write(qq,'(1X,''level popa are:'',1p,16e9.1)')
     1    (hn(i),i=1,nhlvl+1)
          call negcon
          call ShowMe
        endif
      end do
*
*     is hydrogen atom in condition of collisional rec? if so then
*     only very small dT's can be tolerated
*     HRecEffec is sum of totcap(i), htotrc is sum of radiative recombination
*     >>chng 97 aug 10, from HRecEffec which is total rec, to HRecCol which
*     is really three body - needed because strong induced rec tricked test
*     if( HRecEffec/htotrc.gt.100. ) then
      if( HRecCol/htotrc.gt.100. ) then
        lgHColRec = .true.
      else
        lgHColRec = .false.
      endif
*
      if( lgTrace ) then
*       HRecEffec is gross rec coef, computed here while filling in matrix
*       elements, all physical processes included.  htotrc is radiavive only
         write(qq,'(7X,''HLEVEL retrn mtrx te='',1p,e9.3,'' HII/HI='',
     1   E9.3,'' simple='',E9.3,'' b1='',e8.2,'' ion rate='',E8.2,
     2   '' TotRec'',E8.2,'' RadRec'',E8.2)')te,
     3   h2ovh1 , simhii , hbn(1), hgamnc(1)+csupeff , HRecEffec,htotrc
      endif
*
*     update destruction rate
      destroy(1,1) = hgamnc(1)+csupeff+hcolnc(1)*eden
*
      end
******************************************************************************
      subroutine hmole( hmovh1 , h2ovh1 )
      implicit none
*determine populations of hydrogen molecules
      double precision h2ovh1
      real hmovh1
      real saha
*     saha is ( h^2/2/pi/m/k )^1.5
      parameter (saha=4.14157e-16)
*     SAHA is ( h^2/2/pi/m/k )^1.5, is correct constant for free electron
      integer limelm
      parameter (limelm=30)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real tedust
      common/tedust/ tedust(ndust)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      real hi , hii
      common/h/ hi , hii
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgPunH2
*lgPunH2 says to punch H2 rates on unit ipPunH2
      integer ipPunH2
      common/iph2/ ipPunH2 , lgPunH2
      logical lgTrMole
*flag set with trace molecules command
      common/trmole/ lgTrMole
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgNoMole
*flag to turn off molecules
      common/nomole/ lgNoMole
      real hehp
      integer iheh1 , iheh2
      common/hehp/ hehp , iheh1 , iheh2
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real te , eden , hden
      common/phycon/ te , eden , hden
      real rh2dis
      common/rh2dis/ rh2dis
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      integer iphmin
      common/iphmin/ iphmin
      integer iphmop
      common/iphmop/ iphmop
      real hmidep , h2dep , h2pdep,h3pdep,hehdep
      common/hmidep/ hmidep , h2dep , h2pdep,h3pdep,hehdep
*     include "hbn.com"
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real BiggestH2
*max H2/H ratio that occured in the calculation, set in hmole
      common/h2max/ BiggestH2
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      real GammaHabing
*UV flux relative to Habing value, used for some photodissociation rates
      common/ghabng/ GammaHabing
      real GrnIonRec , grecon
*rate coefficient for ionic recombination on grain surfaces, eval in hmole
*grecon usually 1, set to 0 with no grain neutralization command
      common/gionrc/ GrnIonRec , grecon
      real HeatH2Dish , h2dfrc , h2dtot
*HeatH2Dish is heating due to H2 dissociation
      common/h2dish/ HeatH2Dish , h2dfrc , h2dtot
      integer ih2pnt , ih2pof
      common/h2ppnt/ ih2pnt(2) , ih2pof
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      double precision hlte
      real hc2p2se , hc2p2sp , hc2s1s
*hc2p2se and hc2p2sp are rates for 2s - 2s collisions with electrons and protons
*hlte is lte population of each level
      common/hcolrt/ hlte(lmhlvl+1) , hc2p2se , hc2p2sp , hc2s1s
      real HalphaHmin
*Ha creation due to H- charge transfer
      common/hahmin/ HalphaHmin
      double precision phmlte , ph2lte , phplte
      common/HMolLTE/  phmlte , ph2lte , phplte
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      real H2Opacity
*mean cross section (cm-2) for H2 Lyman absorption
      common/h2opac/ H2Opacity
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      real AgeMoleForm
*longest timescale for molecules to form
      common/AgeMole/ AgeMoleForm
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real sexp,exph2,exphp,ex3hp,ph3lte,rspon,ratind,g,hmirat,
     1 gh2dis,th2,h2esc,escinc,cionhm,drate,tdlow,fa,rgrain,rh2h2p,
     2 gamtwo,h2phet,hmiht,gamhmi,exphmi,f,corr,gamfun,
     1 hneut,faneut,c3bod,ratach,batach,fhneut,bhneut,eh2hhm,eh2old,
     4 bh2dis,gamhd,bh2h2p,gamheh,renorm,h1fnd,h1good,desh2p,
     5 colind,fac,radasc,eh2hh,h3ph2p,hmrate,h3petc,rate,damper,
     6 radath,h2pion,h2ph3p,hnnew,hatmic,fmol,h32h2,h2pcin,h2phhp
      integer i,nd,j,iho,ih2,ih2p,ih3p,k,nmole,merror,ihmi
      integer ipOffSet , ipConServ
      double precision b2pcin , plte
      parameter (nmole=5)
      double precision c(nmole+1,nmole+1)
*     CONST is 8\pi * nu(912)**3 / c**2
      real const
      parameter (const=9.940622e26 )
      character*4 chLab(nmole)
      save rspon , ratind , gamhmi , colind , gh2dis , eh2old , eh2hhm,
     1 gamtwo , h2phet , hmiht , rgrain , hneut , th2 , h2esc
*
*     free statement labels >=9
*
      if( lgNoMole .or. te.gt.1e5 ) then
*       thtmol = 0.
        hmovh1 = 0.
        hminus = 0.
        hmihet = 0.
        H2Opacity = 0.
        hmiht = 0.
        hmicol = 0.
        heating(1,16) = 0.
        heating(1,17) = 0.
        heating(1,18) = 0.
        HeatH2Dish = 0.
        hmidep = 1.
        gamhmi = 0.
        htwo   = 0.
        h2plus = 0.
        hehp   = 0.
        rh2dis = 0.
        GrnIonRec = 0.
        HalphaHmin = 0.
        return
      endif
*
*     population of H- in LTE
*     IP is 0.754 eV
*     LTE population of H minus - cm^3
      exphmi = sexp( 8.745e3/te )
      if( exphmi.gt.0. ) then
*       these are ratio n*(H-)/[  n*(ne) n*(Ho)  ]
        phmlte = saha / (te32*exphmi) * (1. / ( 2.*2. ) )
      else
        phmlte = 0.
      endif
*
*     population of H2 in LTE
*     dissociation energy is 4.477eV
      exph2 = sexp( 5.195e4 / te )
      if( exph2.gt.0. ) then
*       extra factor accounts for mass of H instead of e- in saha
*       last factor was put in ver 85.23, missing before
        if( nzone.le.0 ) then
          damper = 0.
        else
          damper = 0.5
        endif
        ph2lte =
     1  (1.-damper)* saha / (te32*exph2 ) *(1./(2.*2.))*3.634E-5 +
     2  damper * ph2lte
      else
        ph2lte = 0.
      endif
*
*     population of H2+ in LTE, phplte is H_2+/H / H+
*     dissociation energy is 2.647
      exphp = sexp( 3.072e4 / te )
      if( exphp.gt.0. ) then
*       stat weight of H2+ is 4
*       last factor was put in ver 85.23, missing before
        phplte = saha / ( te32*exphp ) *(4./(2.*1.))*3.634e-5
      else
        phplte = 0.
      endif
*
*     population of H3+ in LTE, ph3lte is H_3+/( H2+ H+ )
*     dissociation energy is 2.647
      ex3hp = sexp( 1.882e4 / te )
      if( ex3hp.gt.0. ) then
*       stat weight of H2+ is 4
*       last factor was put in ver 85.23, missing before
        ph3lte = saha / ( te32*ex3hp ) *(4./(2.*1.))*3.634e-5
      else
        ph3lte = 0.
      endif
*
*     first do gamma function for H minus, with spon+induc rec
      if( lgDoPhoto ) then
        rspon = 0.
        ratind = 0.
        gamhmi = 0.
        hmiht = 0.
        colind = 0.
        hmicol = 0.
        ipOffSet = iphmin+iphmop
        do i=iphmin,min( nhe1(1) , nflux )
* 666 error! why is this done in a loop, instead of bnfun??
          f = SummedCon(i) * OpacStack(i+ipOffSet)
          gamhmi = gamhmi + f
          hmiht = hmiht + f * anu(i)
          ratind = ratind + f * ContBoltz(i)
*         induced cooling
          colind = colind + f * ContBoltz(i) * anu(i)
          g = OpacStack(i-iphmin+iphmop) * ContBoltz(i) *
     1    widflx(i) * anu2(i)
          rspon = rspon + g
          hmicol = hmicol + g * anu(i)
        end do
*
*       correct for work function, convert from Ryd to erg
        hmiht = (hmiht-gamhmi*0.055502) * en1ryd
        colind = (colind-ratind*0.055502) * en1ryd
        hmicol = (hmicol-rspon *0.055502) * en1ryd
*       add on high energy ionization, assume hydrogen cross section
*       n.b.; HGAMNC with secondaries
        gamhmi = gamhmi + hgamnc(1)
        hmicol = (hmicol*const) * (phmlte*eden) * hi
        ratind = ratind * phmlte * eden
        colind = colind * phmlte * eden * hi
*
*       radiative association rate, spon and induced
        if( te.ge.1e4 ) then
          rspon = (rspon *const) * (phmlte * eden)
        else
          rspon = hmirat( te ) * eden
        endif
      endif
*
*     photodissociation by Lyman band absorption: esc prob treatment,
*     treatment based on Tielens and Hollenbach 1985 ApJ 291, 722.
      if( lgDoPhoto ) then
        GammaHabing = 0.
*       find total intensity over carbon-ionizing continuum
        do i=ipHeavy(6,1),ipHn(1)
          GammaHabing = GammaHabing +
     1    (flux(i)+outcon(i)+outlin(i))*anu(i)
        end do
*       now convert to Habing ISM units
*       GammaHabing is FUV continuum relative to Habing value
        GammaHabing = GammaHabing * 2.18e-11 / 1.6e-3
*       cross section is eqn A8 of Teilens and Hollenbach 85a
*       branching ratio of 10% in, so like their table 5
        gh2dis = GammaHabing * 3.4e-11
*       escape prob is line shielding, eqn A10
        H2Opacity = 1.2e-14 * (1e5/doppler(1))
        th2 = colh2 * 1.2e-14 * (1e5/doppler(1))
        h2esc = escinc(th2 ,1e-4)
*       H_2 + h nu => 2H
        gh2dis = gh2dis * h2esc
      endif
*
*     collisional ionization of H-, rate from Janev, Langer et al.
      if( te.lt.3074. ) then
        cionhm = 1.46e-32 * (te**6) * sqrte * exphmi
      else if(te.ge.3074. .and. te.lt.30000. ) then
        cionhm = 5.9e-19 * te*te*sqrte*te03*te01*te01
      else
        cionhm = 3e-7
      endif
*
*     H2 formation on grains;
*     rate from Hollenback and McKee Ap.J.Sup 41, 555 eq 3.4 3.8
      if( lgNewIon ) then
        if( lgDustOn ) then
          drate = 0.
          tdlow = 1e37
          do nd=1,ndust
            if( lgDustOn1(nd) .and. tedust(nd).gt.0. ) then
              tdlow = min( tdlow , tedust(nd) )
              drate = dstfactor(nd)
            endif
          end do
          fa = 1. / (1. + 1e4 * sexp( 600./tdlow ) )
          rgrain = 3e-18 * sqrte * fa / (1.+0.04*sqrt(tdlow+te) +
     1     0.002*te + 8e-6*te*te ) * drate
*         rate ions recombine on grain surface - used elsewhere
*         based on Drain and Sutin 1987  ApJ 320, 803 eqn 5.15
*         GRECON is usually 1, option to turn this process off
*         >>chng 97 feb 24, following had sqrt( tdlow ) not sqrte,
*         caught by Jon Slavin
          GrnIonRec = 5.8e-13 / sqrte * drate * hden * grecon
        else
          rgrain = 0.
          GrnIonRec = 0.
        endif
      endif
*
*     collisional dissociation, rate from Dove and Mandy, Ap.J.(Let) 311, L93.
*     corr is correction for approach to high density limit
*     H2 + H => 3H - rate very uncertain
      corr =10.**( max(0., min(6.,(14.44-alogte*3.08)))/(1.+1.6e4/hi))
      rh2dis = 1.55e-8 / sqrte * sexp(65107./te) * corr
*
*     H2  +  H+  =>  H2+  +  H
      rh2h2p = 1.8e-12 * sqrte*te10/te01* sexp(2.12e4/te)
*
*     H2+  +  HNU  =>  H+  + H
      if( lgDoPhoto ) then
        gamtwo = gamfun( ih2pnt(1) , ih2pnt(2) , ih2pof )
        h2phet = h
      endif
*
*     molecule formation
*
      do i=1,nmole
        c(i,nmole+1) = 0.
        do j=1,nmole
          c(i,j) = 0.
        end do
      end do
      hneut = hi + hminus + 2.*(htwo+h2plus) + 3.*h3plus
*     these should be totally equivalent??
*     >>chng 96 june 3, hneut floated above hden, ended negative
      hneut = hden - hii
*     protect against roundoff in ionized gas
      if( hneut/hden.lt.1e-3 ) then
        hneut = hi + hminus + 2.*(htwo+h2plus) + 3.*h3plus
      endif
*
      iho = 1
      chLab(iho) = 'HO  '
      ihmi = 2
      chLab(ihmi) = 'H-  '
      ih2 = 3
      chLab(ih2) = 'H2  '
      ih2p = 4
      chLab(ih2p) = 'H2+ '
      ih3p = 5
      chLab(ih3p) = 'H3+ '
*
*--------------------------------------------------------------------
*
*     H- H minus hminus balance equations
*     (IHMI,IHO) == processes making H- from Ho =+sign
*     radiative attachment: HI + NE => H-;
      c(ihmi,iho) = c(ihmi,iho) + rspon + ratind
      c(iho,iho) = c(iho,iho) - rspon - ratind
*
*     (IHMI,IHMI) = processes destroying H- =-sign
*     photodissociation, H- + H NU => H + NE
      c(ihmi,ihmi) = c(ihmi,ihmi) - gamhmi
      c(iho,ihmi) = c(iho,ihmi) + gamhmi
*
*     mutual neutralization with heavies, rate from Dalgarno and Mcray
*     all charged ions contribute equally
      faneut = 4e-6 / sqrte * max( 0. , eden - hii-heii-2.*heiii )
      c(ihmi,ihmi) = c(ihmi,ihmi) - faneut
*
*     electron collisional ionization of H-
      c(ihmi,ihmi) = c(ihmi,ihmi) - cionhm * eden
      c(iho,ihmi) = c(iho,ihmi) + cionhm*eden
*
*     inverse process; three body rec
      c3bod = cionhm * (phmlte * eden) * eden
      c(ihmi,iho) = c(ihmi,iho) + c3bod
      c(iho,iho) = c(iho,iho) - c3bod
*
*     associative detachment:  H- + H => H2 + E
      ratach = hi * 1.35e-9
      c(ihmi,ihmi) = c(ihmi,ihmi) - ratach
      c(iho,iho) = c(iho,iho) - hminus * 1.35e-9
*
*     (1,IH2) convert H2 into H- = +sign
*     the back reaction, H2 + e => H- + Ho
      if( ph2lte.gt.0. ) then
        batach = ( ratach / hi )  * phmlte / ph2lte * eden
      else
        batach = 0.
      endif
      c(ihmi,ih2) = c(ihmi,ih2) + batach
      c(iho,ih2) = c(iho,ih2) + batach
*
*     mutual neut, mostly into n=3; rates from Janev et al
*     H- + H+ => H + H(n=3)
      fhneut = hii * 7e-8
      c(ihmi,ihmi) = c(ihmi,ihmi) - fhneut
      c(iho,ihmi) = c(iho,ihmi) + fhneut
*     back reaction from excited state H
      if( te.gt.thlo ) then
*       HBN(3) is defined; when <THLO then set to 1
        bhneut = (fhneut * phmlte * eden) * hbn(3)
      else
        bhneut = 0.
      endif
*     this is the back reaction, forming H- from Ho
      c(ihmi,iho) = c(ihmi,iho) + bhneut
      c(iho,iho) = c(iho,iho) - bhneut
*
*     the processes H2(v>=4) + e- => H + H-,
*     from Janev et al, quoted in lenzuni etal
*     density dep is for non-lte, guess from dalgarno and roberge apl 233, 25
*     extra expo factor added for low temps
      if( nzone.le.1 ) then
*       this is initial setup of code, so set rate coef to actual val
        eh2hhm = 2.7e-8 * 10**(-0.7*(alogte-3.615)**2) * eden *
     1  (hden / (1e7+hden) ) * sexp(52000. /te)
        eh2old = eh2hhm
      else
*       this is deeper into the cloud, and there is danger of oscillation
        eh2old = eh2hhm
        eh2hhm = 2.7e-8 * 10**(-0.7*(alogte-3.615)**2) * eden *
     1  (hden / (1e7+hden) ) * sexp(52000. /te)
        fac = 0.5
        eh2hhm = eh2hhm*fac + eh2old*(1.-fac)
      endif
      c(ihmi,ih2) = c(ihmi,ih2) + eh2hhm
      c(iho,ih2) = c(iho,ih2) + eh2hhm
*
*--------------------------------------------------------------------
*
*     molecular hydrogen H2 htwo balance equation
*     (IH2,IHO)==create H2 from Ho =+
*
*     H2 formation on grains;
*     rate coefficient from Hollenback and McKee Ap.J.Sup 41, 555 eq 3.4 3.8
*     really is rate coefficient, needs two HIs
      c(ih2,iho) = c(ih2,iho) + rgrain * hi
      c(iho,iho) = c(iho,iho) - rgrain * hi
*
*     excited atom radiative association,
*     H(n=2) + H(n=1) => H2 + hnu
*     from Latter, W.B., and black, J.H., 1991, Ap.J. 372, 161
      radasc = (hn(2)*hii)*3e-14
      c(ih2,iho) = c(ih2,iho) + radasc
      c(iho,iho) = c(iho,iho) - radasc
*
*     make H2 from H- =+ sign
*     associative detachment; H- + H => H2: Browne and Dalgarno J PHys B 2, 885
      c(ih2,ihmi) = c(ih2,ihmi) + ratach
*
*     photo-destroy H2
      c(ih2,ih2) = c(ih2,ih2) - gh2dis
      c(iho,ih2) = c(iho,ih2) + gh2dis
*
*     the process H2 + e- => H + H + e
*     from Lenzuni et al. apj sup 76, 759, quoted from Janev et al.
      eh2hh = 1.3e-18*te*te*sexp(52000./te) * eden
      c(ih2,ih2) = c(ih2,ih2) - eh2hh
      c(iho,ih2) = c(iho,ih2) + eh2hh
*
*     the processes H2(v>=4) + e- => H + H-
*     from Lenzuni et al. apj sup 76, 759, quoted from Janev et al.
*     density dep is for non-lte, guess from dalgarno and roberge apl 233, 25
      c(ih2,ih2) = c(ih2,ih2) - eh2hhm
*
*     add on inverse of radiative attachment
      c(ih2,ih2) = c(ih2,ih2) - batach
*
*     collisional dissociation, rate from Dove and Mandy, Ap.J.(Let) 311, L93.
*     H_2 + S => 2H + S
      c(ih2,ih2) = c(ih2,ih2) - rh2dis * hi
      c(iho,ih2) = c(iho,ih2) + rh2dis * hi
*
*     back rate, three body recombination, 2H + S => H_2 + S
      bh2dis = rh2dis * ph2lte * hi * hi
      c(ih2,iho) = c(ih2,iho) + bh2dis
      c(iho,iho) = c(iho,iho) - bh2dis
*
*     H2 + HNU=>  H2+ + E
*     photoionization by hard photons, crossection=3*HI
*     GAMHD = 3. * HGAMNC(1)
      gamhd = hgamnc(1)
      c(ih2,ih2) = c(ih2,ih2) - gamhd
*     assume cosmic rays do the same thing
      c(ih2,ih2) = c(ih2,ih2) - csupra
*
*     H2  +  H+  =>  H2+  +  H
      c(ih2,ih2) = c(ih2,ih2) - rh2h2p * hii
      c(iho,ih2) = c(iho,ih2) + rh2h2p * hii
*
*     inverse rate
      if( phplte.gt. 0. ) then
*       extra factor of HII appeared before version 85.23, typo!
        bh2h2p = rh2h2p * ph2lte/phplte
      else
        bh2h2p = 0.
      endif
*     H2+ + H => H+ + H2
      c(ih2,ih2p) = c(ih2,ih2p) + bh2h2p * hi
      c(iho,iho) = c(iho,iho) - bh2h2p * h2plus
*
*     H + H3+ => H2 + H2+
      h3ph2p = hmrate( 2.08e-9 , 0. , 1.88e4 ) * hi
      c(ih2,ih3p) = c(ih2,ih3p) + h3ph2p
      c(iho,iho) = c(iho,iho) - hmrate( 2.08e-9 , 0. , 1.88e4 ) * h3plus
*
*     H2 + H3+ => H2 + H2+ + H
      h3petc = hmrate(3.41e-11,0.5,7.16e4 ) * htwo
      c(ih2,ih3p) = c(ih2,ih3p) + h3petc
      c(iho,ih2) = c(iho,ih2) + h3petc
*
*     H2 + H3+ => H2 + H+ + H2
      h32h2 = hmrate( 3.41e-11 , 0.5, 5.04e4 ) * htwo
      c(ih2,ih3p) = c(ih2,ih3p) + 2.*h32h2
*
*     e + H3+ => H2 + H
      c(ih2,ih3p) = c(ih2,ih3p) + hmrate(5.00e-9,-0.5,0.)*eden
      c(iho,ih3p) = c(iho,ih3p) + hmrate(5.00e-9,-0.5,0.)*eden
*
      if( lgTrace.and.lgTrMole .or. lgPunH2 ) then
        if( lgPunH2 ) then
          k = ipPunH2
        else
          k = qq
        endif
        if( c(ih2,ih2).ne.0. ) then
          rate = -c(ih2,ih2)
          write(k,'('' Destroy H2: rate='',1P,E10.2,''DIS;'',0P,
     1    f5.3,'' bat;'',f5.3,'' h2dis;'',f5.3,'' gamhd;'',f5.3,
     2    '' h2h2p;'',f5.3,'' E-h;'',f5.3,'' E-h-;'',f5.2)')
     2    rate,gh2dis/rate,batach/rate,rh2dis*hi/rate,gamhd/rate,
     3    rh2h2p*hii/rate , eh2hh/rate,eh2hhm/rate
*666    write(k,'('' batach, ratach,hi,phmlte,ph2lte,eden'',1p,
*    1 1p,6e10.2)') BATACH,RATACH,HI, PHMLTE , PH2LTE , EDEN
        else
          write(k,'('' Destroy H2: rate=0'')')
        endif
      endif
*
*-------------------------------------------------------------------
*
*     h2plus H2+ balance equations
*
*     make H2+ from Ho
*     H+  + H  =>  H2+ + HNU
*     approximation was from Kurucz thesis, not meant for hot gas
      radath = max(0.,2.325*min(5000.,te)-1375.)*1e-20
      c(ih2p,iho) = c(ih2p,iho) + radath*hii
      c(iho,iho) = c(iho,iho) - radath*hii
*
*     make H2+ from H2 =+sign
*     H2 + HNU => H2+ + E
*     also cosmic rays
      c(ih2p,ih2) = c(ih2p,ih2) + gamhd + csupra
*
*     H2 + H+  => H2+  + H
      c(ih2p,ih2) = c(ih2p,ih2) + rh2h2p *hii
*
*     (3,IH2P) == destroy H2+ = -sign
*     H + H2+ => H+ + H2
      c(ih2p,ih2p) = c(ih2p,ih2p) - bh2h2p*hi
      c(iho,iho) = c(iho,iho) - bh2h2p*h2plus
*
*     H2+  +  p  => H + H+ + H+; Janev et al. 3.2.6
      h2pion = 2.4e-27*te**3  * hii
      c(ih2p,ih2p) = c(ih2p,ih2p) - h2pion
      c(iho,ih2p) = c(iho,ih2p) + h2pion
*
*     H2+  +  E  => H + H+ + e-; Janev et al.
      h2pcin = 2e-7 * sexp( 30720./te )
      c(ih2p,ih2p) = c(ih2p,ih2p) - h2pcin * eden
      c(iho,ih2p) = c(iho,ih2p) + h2pcin * eden
*
*     back reaction, H + H+ + e => h2+ + e
      b2pcin = h2pcin * phplte
*     this is the hot reaction at high densities
      c(ih2p,iho) = c(ih2p,iho) + b2pcin*eden*hii
      c(iho,iho) = c(iho,iho) - b2pcin*eden*hii
*
*     H2+  +  HNU  =>  H+  + H
      c(ih2p,ih2p) = c(ih2p,ih2p) - gamtwo
*
*     photoionization by hard photons, crossection =2*HI (wild guess)
      c(ih2p,ih2p) = c(ih2p,ih2p) - 2.*hgamnc(1)
*
*     H2 + H2+ => H + H3+
      h2ph3p = 1.40e-9 * htwo*(1.-sexp(9940./te))
      c(ih2p,ih2p) = c(ih2p,ih2p) - h2ph3p
      c(iho,ih2p) = c(iho,ih2p) + h2ph3p
*
*     h + h3+ => h2 + h2+
      c(ih2p,ih3p) = c(ih2p,ih3p) + h3ph2p
*
*     H2 + H3+ => H2 + H2+ + H
      c(ih2p,ih3p) = c(ih2p,ih3p) + h3petc
*
*     destroy H2+ via H2+ + H2 => H + H+ + H2
      h2phhp = 2.41e-12*sqrte*sexp(30720./te)*htwo
      c(ih2p,ih2p) = c(ih2p,ih2p) - h2phhp
      c(iho,ih2p) = c(iho,ih2p) + h2phhp
*
*     save total H2P destruction rate for possible later printout:
*     NB this must come last
      desh2p = -c(ih2p,ih2p)
*
*------------------------------------------------------------------
*
*     H3+ balance equations
*
*     H2 + H2+ => H + H3+
      c(ih3p,ih2p) = c(ih3p,ih2p) + h2ph3p
*
*     H + H3+ => H2 + H2+
      c(ih3p,ih3p) = c(ih3p,ih3p) - h3ph2p
*
*     H2 + H3+ => H2 + H2+ + H
      c(ih3p,ih3p) = c(ih3p,ih3p) - h3petc
*
*     H2 + H3+ => H2 + H+ + H2
      c(ih3p,ih3p) = c(ih3p,ih3p) - h32h2
*
*     e + H3+ => 3H
*     e + H3+ => H2 + H
      c(ih3p,ih3p) = c(ih3p,ih3p) - 2.*hmrate(5.00e-9,-0.5,0.)*eden
*
*     photoionization by hard photons, crossection =2*HI (wild guess)
      c(ih3p,ih3p) = c(ih3p,ih3p) - 2.*hgamnc(1)
*
*------------------------------------------------------------------
*
*     first equation is hydrogen conservation
*     remember that htwo/hden = 0.5 when totally molecular
      if( htwo/hden.gt.0.1 ) then
        ipConServ = ih2
      else
*       little molecular hydrogen, leave out the atomic
        ipConServ = iho
      endif
*     this was not the cause of the problem, go back to old way
*     until I have time to debug this logic
      ipConServ = 1
      c(ipConServ,iho) = 1.
      c(ipConServ,ihmi) = 1.
      c(ipConServ,ih2) = 2.
      c(ipConServ,ih2p) = 2.
      c(ipConServ,ih3p) = 3.
*     the above will add up to the following
      c(ipConServ,nmole+1) = hneut
*
*------------------------------------------------------------------
      if( lgTrace.and.lgTrMole ) then
        do i=1,nmole
          write(qq,'(7X,''MOLE'',I2,1P,11E10.2)') i,(c(i,j),
     1    j=1,nmole+1)
        end do
      endif
*
*     invert matrix
      call matin1(c,nmole+1,nmole,1,merror)
      if(merror.ne.0 ) then
        write(qq,'('' HMOLE matrix error, stop.'')')
        call ShowMe
        stop
      endif
*
      h1fnd = c(iho,nmole+1)
      hminus = c(ihmi,nmole+1)
      htwo = c(ih2,nmole+1)
      h2plus = c(ih2p,nmole+1)
      h3plus = c(ih3p,nmole+1)
*
*     rate H-alpha is created by H- ct
      HalphaHmin  = fhneut * hminus
*
*     identify creation and destruction processes for H2+
      if( lgTrace.and.lgTrMole ) then
        rate = desh2p
        if( rate.ne.0. ) then
          write(qq,'('' Destroy H2+: rate='',1P,E10.2,'' e-;'',0P,
     1    F5.3,'' phot;'',F5.3,'' hard gam;'',F5.3,'' H2col;'',
     2    F5.3,'' h2phhp;'',F5.3,'' pion;'',F5.3,
     3    '' bh2h2p:'',F5.3)')
     2    rate , h2pcin* eden/rate , gamtwo/rate , 2.*hgamnc(1)/rate ,
     3    h2ph3p/rate , h2phhp/rate , h2pion/rate ,
     1    bh2h2p*hi/rate
*
          rate = rate * h2plus
          if( rate.gt.0. ) then
            write(qq,'('' Create  H2+: rate='',1P,E10.2,'' HII HI;'',0P,
     1      F5.3,'' Col H2;'',F5.3,'' HII H2;'',F5.3,'' HI HI;'',
     2      f5.3)') rate,
     4      radath *hii*hi/rate ,
     5      (gamhd + csupra)*htwo/rate,
     6      rh2h2p *hii*htwo/rate ,
     7      b2pcin*hi*hii*eden/rate
          else
            write(qq,'('' Create  H2+: rate= is zero'')')
          endif
        endif
      endif
*
*     heating due to H2 dissociation
      HeatH2Dish = 1.36e-23 * htwo * h2esc * GammaHabing
      heating(1,18) = HeatH2Dish
*
      hmovh1 = ( (htwo+h2plus)*2. + 3.*h3plus + hminus ) / hi
      if( hmovh1.lt.0. ) then
        write(qq,'('' HMOLE:  I found a negative molecular fraction=''
     1  ,1p,e10.2)') hmovh1
        write(qq,'('' HMOLE:  htwo,h2plus,h3plus,hminus,hi,eden=''
     1  ,1p,9e9.1)') htwo,h2plus,h3plus,hminus ,hi,eden
        write(qq,'('' HMOLE:  h1fnd='',1p,e10.2)') h1fnd
        call ShowMe
        stop
      endif
      h1good = hden / (1.d0 + dble(hmovh1) + h2ovh1 )
      hnnew = h1good * (1.d0 + dble(hmovh1) )
      renorm = hnnew / hneut
      if( lgTrace.and.lgTrMole ) then
        write(qq,'('' raw;'',8(1X,A4,'':'',1P,E10.2))')
     1  (chLab(i),c(i,nmole+1),i=1,nmole)
        write(qq,'('' ren;'',8(1X,A4,'':'',1P,E10.2))')
     1  (chLab(i),c(i,nmole+1)*renorm,i=1,nmole)
        write(qq,'('' RENORM factor was'',1P,E10.2)') renorm
      endif
      h1fnd = h1fnd * renorm
      hminus = hminus * renorm
      htwo = htwo * renorm
      h2plus = h2plus * renorm
      h3plus = h3plus * renorm
*
*     following not used any more
      hatmic = (hi+hii) / ( hi+hii+hminus+2.*(htwo+h2plus)+3*h3plus)
*
      if( lgTrace.and.lgTrMole .or. lgPunH2 ) then
        if( lgPunH2 ) then
          k = ipPunH2
        else
          k = qq
        endif
       rate = rgrain*hi + ratach*hminus + bh2dis*hi + bh2h2p*hi*h2plus +
     1  radasc*hi + h3ph2p*h3plus + h3petc*h3plus
        write(k,'('' Create H2, rate='',1P,E10.2,'' grain;'',0P,
     1  F5.3,'' hmin;'',F5.3,'' bhedis;'',F5.3,'' h2+;'',F5.3,
     2  '' radasc:'',F5.3,'' h3ph2p:'',F5.3,'' h3petc:'',F5.3)') rate ,
     2  rgrain*hi /rate,ratach*hminus /rate,bh2dis /rate,
     3  bh2h2p*hi*h2plus /rate , radasc*hi/rate,h3ph2p*h3plus/rate,
     4  h3petc*h3plus/rate
      endif
*
      if( lgTrace.and.lgTrMole ) then
        rate = rh2h2p*htwo*hii + b2pcin*hii*eden*hi +
     1  h3ph2p * h3plus + h3petc * h3plus
        if( rate.gt.1e-25 ) then
          write(qq,'(''  Create H2+, rate='',1P,E10.2,'' rh2h2p;'',0P,
     1    F5.3,'' b2pcin;'',F5.3,
     1    '' h3ph2p;'',F5.3,'' h3petc+;'',F5.3)') rate ,
     1    rh2h2p*hii*htwo /rate ,  b2pcin*hi*hii*eden/rate ,
     1    h3ph2p*h3plus/rate ,  h3petc*h3plus/rate
        else
          write(qq,'(''  Create H2+, rate=0'')')
        endif
      endif
*
      if( hminus.gt.0. .and. phmlte.gt.0. ) then
        hmidep = hminus / hi / eden / phmlte
      else
        hmidep = 1.
      endif
*     this will be net volume heating rate, photo heat - induc cool
      hmihet = hmiht * hminus - colind
*     save it
      heating(1,16) = hmihet
      heating(1,17) = h2phet * h2plus
*
*     THTMOL is total heating due to absorption of Balmer continuum
*     thtmol = hmihet + h2phet * h2plus
*     departure coef for H2 defined rel to N(1s)**2
*     (see Littes and Mihalas Solar Phys 93, 23)
      plte = hi * hi * ph2lte
      if( plte.gt.0. ) then
        h2dep = htwo / plte
      else
        h2dep = 1.
      endif
*
*     departure coef of H2+ defined rel to N(1s) N(p)
*     sec den was HI before 85.34
      plte = hi * hii * phplte
      if( plte.gt.0. ) then
        h2pdep = h2plus / plte
      else
        h2pdep = 1.
      endif
*
*     departure coef of H3+ defined rel to N(H2+) N(p)
      plte = hi * hii * phplte
      if( plte.gt.0. ) then
        h3pdep = h3plus / plte
      else
        h3pdep = 1.
      endif
*
      if( lgTrace.and.lgTrMole ) then
        write(qq,'('' HMOLE, Dep Coef, H-:'',1p,e10.2,'' H2:'',e10.2,
     1  '' H2+:'',e10.2)')   hmidep, h2dep, h2pdep
        write(qq,'(5X,''H- creat: Rad atch'',1P,E10.3,
     1  '' Induc'',E10.3,'' bHneut'',E10.2,'' 3bod'',E10.2,'' b=>H2'',
     2  E10.2,'' N(H-);'',E10.2,'' b(H-);'',E10.2)')
     1  rspon, ratind, bhneut , c3bod , batach , hminus , hmidep
*
        write(qq,'(5X,''H- destr: Photo;'',1P,E10.3,'' mut neut'',E10.2
     1  ,'' e- coll ion'',E10.2,'' =>H2'',E10.2,'' x-ray'',E10.2,
     2  '' p+H-'',E10.2)')
     2  gamhmi, faneut ,cionhm,ratach,hgamnc(1),
     3  fhneut
        write(qq,'(5X,''H- heating:'',1P,E10.3,'' Ind cooling'',E10.2,
     1  '' Spon cooling'',E10.2)') hmihet , colind , hmicol
      endif
*
      fmol = ( hminus + 2.*(htwo+h2plus) ) / hden
      BiggestH2 = max( BiggestH2 , fmol )
*
*     establish age timescale for molecule formation if this is important
      if( fmol.gt.0.05 )  then
        if( rgrain*hi+rspon.gt.1e-20 ) then
          AgeMoleForm = max( AgeMoleForm , 1./( rspon+rgrain*hi) )
        endif
      endif
*
*----------------------------------------------------------------
*
*     He H+ formation
*     rates taken from Flower+Roueff, Black
*     photodissociation through 1.6->2.3 continuum
      gamheh = 0.
      do i=iheh1,iheh2
        gamheh = gamheh + (flux(i)+outcon(i)+outlin(i))
      end do
      gamheh = gamheh * 4e-18
*
*     both He+ + H and He + H+
*     first rate is radiative associatino from
*     >>refer Zygelman, B., and Dalgarno, A. 1990, ApJ 365, 239
      hehp = (1e-15*hi*heii + 1e-20*hii*hei)
*
*     H2+ + HE => HEH+ + H0
      hehp = hehp + 3e-10*exp(-6717./te)*hei*h2plus
*
*     hard radiation
      gamheh = gamheh + 3.*hgamnc(1)
*
*     HeH+  +  H => H2+  + He
      gamheh = gamheh + 1e-10*hi
*
*     recombination, HeH+  +  e => He + H
      if( gamheh .gt. hehp * 1e-15 ) then
        gamheh = gamheh + eden * 1e-9
      else
        gamheh = -1
      endif
      hehp = hehp / gamheh
*
      end
******************************************************************************
      real function hmirat( te )
      implicit none
*compute radiative association rate for H-
      real te
*
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
*
*     fits to radiative association rate coefficients
      if( te.lt. 31.62 ) then
        hmirat = 8.934e-18 * sqrte * te003*te001*te001
      else if( te.lt.90. ) then
        hmirat = 5.159e-18 * sqrte*te10*te03*te03*te003*te001
      else if( te.lt.1200. ) then
        hmirat = 2.042e-18 * te / te10 / te03
      else if( te.lt. 3800. ) then
        hmirat = 8.861e-18 * te70 / te03 / te01 * te003
      else if( te.le.1.4e4 ) then
*       following really only optimized up to 1e4
        hmirat = 8.204e-17 * sqrte/te10/te01*te003
      else
*       out of range of these approximations
        stop
      endif
*
      end
******************************************************************************
      real function hmiopc( freq )
      implicit none
*derive total H- H minus opacity
      real freq
      integer ncrs
      parameter (ncrs=33)
      real y2(ncrs)
      real ener(ncrs) , crs(ncrs) , x , y ,
     1 energy
      logical lgFirst
      save lgFirst , ener , crs , y2
*
*     bound free cross section (x10**-17 cm^2) from Doughty et al
*     1966, MNRAS 132, 255; good agreement with Wishart MNRAS 187, 59p.
      data crs/0.    ,0.124 ,0.398 ,0.708 ,1.054 ,1.437 ,1.805 ,2.176
     1 ,2.518 ,2.842 ,3.126 ,3.377 ,3.580 ,3.741 ,3.851 ,3.913 ,3.925
     2 ,3.887 ,3.805 ,3.676 ,3.511 ,3.306 ,3.071 ,2.810 ,2.523 ,2.219
     3 ,1.898 ,1.567 ,1.233 ,.912 ,.629 ,.39 ,.19/
*
*     photoelectron energy, add 0.05552 to get incoming energy (Ryd)
      data ener/ 0.,  0.001459 ,0.003296 ,0.005256 ,0.007351 ,0.009595
     1 ,0.01201 ,0.01460 ,0.01741 ,0.02044 ,0.02375 ,0.02735 ,0.03129
     2 ,0.03563 ,0.04043 ,0.04576 ,0.05171 ,0.05841 ,0.06601 ,0.07469
     3 ,0.08470 ,0.09638 ,0.1102 ,0.1268 ,0.1470 ,0.1723 ,0.2049 ,0.2483
     4 ,0.3090 ,0.4001 ,0.5520 ,0.8557 , 1.7669 /
*
      data lgFirst/.true./
*
      if( lgFirst ) then
*       set up coefficients for spline
        call spline( ener , crs , ncrs , 2e31,2e31, y2 )
        lgFirst = .false.
      endif
*
      energy = freq - 0.05552
      if( energy.lt.ener(1) .or. energy.gt.ener(ncrs) ) then
        hmiopc = 0.
      else
        x = energy
        call splint( ener , crs , y2 , ncrs , x , y )
        hmiopc = y * 1e-17
      endif
*
      end
******************************************
      real function hrcf(n)
      implicit none
*recombination coefficient for hydrogen
      integer n
      real te , eden , hden
      common/phycon/ te , eden , hden
      real telogn
      common/telogn/ telogn(7)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real eps, ee1 , x,fac
*
      real a(15),b(15),c(15),d(15),e(15),f(15),g(15),h(15),i(15)
*
      data a/-10.7814536, -11.0434026, -11.2031246, -11.3145225,
     1 -11.4062195, -11.4846095,
     2 -11.4646746 , -11.5032599, -11.71,
     3 -11.610978, -11.992763, -11.7151303, -11.6625192, -11.6988845,
     4 -11.715368/
*
      data b/ -0.38889639, -0.39351422,-0.42457562,-0.4393928,
     1-0.43646701,-0.44245653,
     2 0.032705359, -0.17837447, 8.0767024, -0.16696997,
     3  4.7646025, -0.146717, 0.027221784, 0.0289227, 0.023116295/
*
      data c/ 4.684694732, 4.843339724, 5.25369788, 5.453982338,
     1 5.460274938, 5.569510445,
     2 -0.07601504, 2.303021561, -92.517282 ,
     3 2.2047166, -54.299096, 2.02503782, -0.28687758, -0.28812,
     4 -0.28765391/
*
      data d/ 0.064043815, 0.069211833, 0.081923668, 0.085375549,
     1 0.086385567, 0.089975575,
     2 0.006599021, 0.053925364, -1.4691482, 0.059152556,-0.88170929,
     3 0.062525821, 0.093677105, 0.090329188, 0.11801512/
 
*
      data e/ -0.87423486, -0.95685641, -1.12613095, -1.16660095,
     1 -1.18430859, -1.24102597,
     2 0.02975201, -0.53186795, 18.562078, -.59020955, 10.944953,
     3 -.63482507, -0.71040608, -0.695660318, -0.94380361/
*
      data f/ -0.0051024762,-0.0054992961,-0.0068170788,-0.0074005994,
     1-0.00737118,-0.0075487022,
     2 0.010321731, -0.00119851, 0.5103495, -0.0013545537, 0.33187099,
     3 -0.00146163, 0.000462095, 0.001726288, -0.0022470643/
*
      data g/ 0.081410787, 0.092158621, 0.114220651, 0.11805714,
     1 0.119144754, 0.125442906,
     2 -0.10863166, 0.0, -4.9301946, 0.0, -3.2247619,
     3 0.0, -0.0548276, -0.06497062, -0.037080131/
*
      data h/ 0.00024776095,0.00030627271,0.00041165267,0.00040366383,
     1 0.00041234231,0.00044871329,
     2 -0.00025303, 0.0, -0.012089006, 0.0, -0.0079305392,
     3 0.0, -1.3652e-5, -4.8413e-5, 4.68229e-5/
*
      data i/ -0.0038771298,-0.0050248303,-0.0067751069,-0.0064884839,
     1 -0.0067516033,-0.0075357895, 0.0, 0.0, 0.0, 0.0, 0.0,
     2 0.0,0.0,0.0,0.0/
*
      if( n.lt.1 ) then
         write(qq,'('' HRCF called with invalid prin quant number='',
     1   i4)') n
         stop
      endif
*
      if(n.gt.15) then
        eps = 157807./n/n/te
        if(eps.lt.1) then
          hrcf = 3.262e-6 /n**3 /te32 * exp(eps) * ee1(eps)
        else
          hrcf = 3.262e-6 /n**3 /te32 * ee1(eps)
        endif
        return
      endif
*
*
      x = telogn(1)
      if( x.lt.0.2 .or. x.gt.10. ) then
        write(qq,'('' HRCF called with invalid temperature='',
     1  1p,e10.2)') te
        stop
      endif
*
      fac =
     1 (a(n)+c(n)*telogn(1) + e(n)*telogn(2) + g(n)*telogn(3) +
     2 i(n)*telogn(4) ) /
     3 (1.+ b(n)*telogn(1) + d(n)*telogn(2) + f(n)*telogn(3) +
     4 h(n)*telogn(4) )
*
      hrcf = (10.**fac)/te
*
      end
******************************************************************************
      subroutine htrans
      implicit none
*evaluate the radiative transition rates for model hydrogen atom
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real opac
      common/opac/ opac(ncell)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      character*4 chRedis
      common/redis/ chRedis
      real hi , hii
      common/h/ hi , hii
      real pmph31, pmpo51, pmpo15 , esch31
      common/bowoi/ pmph31, pmpo51, pmpo15 , esch31
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      real otsmin
      common/otsmin/ otsmin
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hnet
      common/hnet/ hnet(lmhlvl,lmhlvl-1)
      real hrc2s , hrc2p
      common/hrc2sp/ hrc2s , hrc2p
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real strkar , pestrk
      common/strkar/ strkar(lmhlvl,lmhlvl) , pestrk(lmhlvl,lmhlvl)
      real hesc , esesc
      common/hesc/ hesc(lmhlvl,lmhlvl) , esesc(lmhlvl,lmhlvl)
      real hcoldn , hbul , hradn
*save collision, induced, and spontaneous rates for levels from hydroen atom
      common/hcbr/ hcoldn(lmhlvl+1) , hbul(lmhlvl+1) , hradn(lmhlvl+1)
      real ophf
      common/ophf/ ophf(lmhlvl)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      reaL ri2s1s , ri1s2s
      common/rin2ph/ ri2s1s , ri1s2s
      real telogn
      common/telogn/ telogn(7)
      real htotrc
      common/htotrc/ htotrc
      real htus , he1tus , he2tus, he3tus
      common/tusedcom/ htus , he1tus , he2tus, he3tus
      real HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
*     HRecRad is sum of radiative rec to all excited states
*     hrectot is hcaseb plus effective rec to ground
*     HRecEffec is total effec eval in hlevel, should be
*     roughly equal to hrectot
*     HRecNet is net rec coef, with 3-body rec less coll ioniz
*     HRecCol is thre-body recombination alone
*     HRecInd is induced recombination
      common/hcaseb/ HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real dstfe2lya , escfe2
*dstfe2lya is destruction probability for Lya onto FeII
      common/dstfe2/ dstfe2lya , escfe2
      integer ioreco
      common/ioreco/ ioreco
      integer nHTopOff
      character chHTopType*4
      common/HTopOff/ nHTopOff , chHTopType
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,j,n , lower , iupper , level , iup
      real a,b,c,hrcf,sum,recf,receff , rec2,coloi,extra
*
*     free statement labels >=13
*
      recf(a,b,c) = a + b * (alogte-c)**2
*
*     evaluate recombination coef for H, hrec(i,2) is modified OTS factor
      if( lgNewIon ) then
        do n=1,nhlvl
*         this is escape probability
          hrec(n,3) = receff( ipHn(n) )
        end do
      endif
*
*     option for case b conditions
      if( lgCaseb ) then
        hrec(1,3) = 1e-10
      endif
*
      do n=1,nhlvl
        hrec(n,3) = max( hrec(n,3) , otsmin )
*       following accounts for absorption of diffuse continuum
*       by .not.hydrogen
        hrec(n,2) = min(1.,hrec(n,3) + (1.-hrec(n,3))*ophf(n) )
      end do
      hrec(nhlvl+1,2) = hrec(2,2)
      hrec(nhlvl+1,3) = hrec(2,3)
*
      if( lgTrace.and.lgHBugFull ) then
        write(qq,'(7X,''HTRANS recomb effic'',1P,9E10.3,'' (tau only)''
     1  )') (hrec(i,3),i=1,nhlvl)
*
        write(qq,'(7X,''HTRANS recomb effic'',1P,9E10.3,'' (net)'')')
     1  (hrec(i,2),i=1,nhlvl)
*
        write(qq,'(7X,''HTRANS in optic dep'',1P,9E10.3)')
     1  (tauabs(ipHn(i),1),i=1,nhlvl)
        write(qq,'(7X,''HTRANS out op depth'',1P,9E10.3)')
     1  (tauabs(ipHn(i),2),i=1,nhlvl)
      endif
*
*     evaluate radiative recom coef
*     this sum does not have highest level since that rec coef
*     will be the difference between finite levels and true case b
      do n=1,nhlvl
        hrec(n,1) = hrcf(n)
      end do
*
*     make sum of case b up to band
      sum = 0.
      do n=2,nhlvl
        sum = sum + hrec(n,1)
      end do
*
*     following is expansion for case b
      HRecRad =
     1 (-9.9765209 + 0.158607055*telogn(1) + 0.30112749*telogn(2)
     2 - 0.063969007*telogn(3) + 0.0012691546*telogn(4) ) /
     3 (1.+ 0.035055422*telogn(1) - 0.037621619*telogn(2)
     4 + 0.0076175048*telogn(3) - 0.00023432613*telogn(4) )
*
      HRecRad = (10.**HRecRad)/te
*     this is rec coef that applies at low densities, is in hcaseb common block
      hrectot = hrec(1,1)*hrec(1,2) + HRecRad
*     highest level is remainder of recombination coefficient
*     will rescale all rec coef up by this factor to get tot case b
*     did not put h=2 in above sum, this is extra needed to top off h atom
      extra = HRecRad - sum
      if( chHTopType .eq.'scal' ) then
*       this is now scale factor to get correct sum, we will add for n=3 to end
*       nHTopOff default is 5, change with set nHTopOff
        sum = 0
        do n=nHTopOff,nhlvl
          sum = sum + hrec(n,1)
        end do
*       scale factor to get right sum
        extra = 1. + extra/sum
*       this is the top-off top off of the h atom
        do n=nHTopOff,nhlvl
          hrec(n,1) = hrec(n,1) * extra
        end do
      else if( chHTopType .eq.' add' ) then
*       spread it out by adding same to all top levels
        extra = extra /( nhlvl-nHTopOff+1 )
        do n=nHTopOff,nhlvl
          hrec(n,1) = hrec(n,1) + extra
        end do
      else
*       this is insanity
        write(qq,'('' htrans has insane chHTopType='',a4)') chHTopType
        call ShowMe
        stop
      endif
*
*     check top not negative
      if( hrec(nhlvl,1).lt.0. ) then
        write(qq,'('' ERROR - H rec to band negative.'')')
        hrec(nhlvl,1) = HRecRad * 0.15
      endif
*
*     do 2s 2p fixup
*
*     independent fits to 2s and 2p recombination
      hrc2s =   10.** (-recf(8.9776,.06256,7.2302)) / te
      hrc2p =   10.** (-recf(9.1508,.12667,4.9748)) / te
*     these fits may not agree to all sig fig with hrcf above -
*     hrcf is better - renormalize these to that
      rec2 = hrc2s + hrc2p
      rec2 = hrec(2,1) / rec2
*     now renormalize the result
      hrc2s = hrc2s * rec2
      hrc2p = hrc2p * rec2
      hrec(2,1) = hrc2p
      hrec(nhlvl+1,1) = hrc2s
*
      if( lgTrace.and.lgHBugFull ) then
        write(qq,'(7X,''HTRANS eval rec cof'',1P,9E10.3)')
     1  (hrec(i,1),i=1,nhlvl)
      endif
*
*     htotrc is total radiative recombination, must add 3-body too
      htotrc = hrec(2,1)*hrec(2,2) + hrec(1,1)*hrec(1,2)
      do i=3,nhlvl+1
        htotrc = htotrc + hrec(i,1) * hrec(i,2)
      end do
*
      if(ioreco.ne.0) write(ioreco,'(''H  '',1P,E9.2)') HRecRad
      if( lgTrace.and.lgHBug ) then
        write(qq,'(7X,''HTRANS total rec coef'',1P,E10.3,'' case A='',
     1  E10.3,'' caseB='',E10.3)') htotrc , HRecRad+hrec(1,1) , HRecRad
      endif
*
*----------------------------------------------------------------------
*
*     find Stark escape probabilities
      call strk
*
*     find prob of emission, defines ESESC=elec scat escape
      call HydroPesc
*
*     do the 8446 problem
      call p8446( coloi )
      if( lgTrace.and.lgHBugFull )  then
        write(qq,'(7X,''HTRANS calls P8446 who ''
     1  ,''found pmph31='',1p,e10.2)') pmph31
      end if
*
*     find FeII overlap destruction rate
      call fe2ovr
*
*     find the rate of induced two photon
      call twopht
*
      do j=1,nhlvl-1
        do i=j+1,nhlvl
*         hemis(i,j) = hyas(i,j)*min(1.,(hesc(i,j)+pestrk(i,j)+
*     >>chng 96 may 13 cap of 1 prevented maser emission
          hemis(i,j) = hyas(i,j)*(hesc(i,j)+pestrk(i,j)+
     1    esesc(i,j))
          hnet(i,j) = hemis(i,j) + hdest(i,j)
*begin sanity check
*      maser emission tricks this
*         if( hnet(i,j)/hyas(i,j).gt.1.01 ) then
*           write(qq,'('' HTRANS: hnet/A > 1: this is insane.'')')
*           write(qq,'('' i,j, ratio'',2i4,1p,e10.2)')i,j,
*    1      hnet(i,j)/hyas(i,j)
*           call insane
*         endif
*end sanity check
        end do
      end do
*
*     now add in FeII deexcitation via overlap,
*     but only as loss, not photoionization, source
*     dstfe2lya is Ly-alpha deexcit by FeII overlap - conversion into FeII em
      hnet(2,1) = hnet(2,1) + dstfe2lya * hyas(2,1)
      hemis(3,1) = pmph31
      hnet(3,1) = hemis(3,1) + hdest(3,1)
*
*     add ots from lines, continua
      call HydroOTS
*
*     total rates out of level due to induced processes
      do level=1,nhlvl
        hbul(level) = 0.
        do lower=1,level-1
          hbul(level) = hbul(level) + hcont(level,lower)
        end do
*       hstat is correct stat weight, =6 for 2
        do iupper=level+1,nhlvl
          hbul(level) = hbul(level) +
     1    hcont(iupper,level)*hstat(iupper)/hstat(level)
        end do
      end do
*     add on induced two photon 1s -> 2s, ratio stat weight = 1
      hbul(1) = hbul(1) + ri2s1s
*     this is used for both 2s and 2p, in following
      hbul(2) = 0.
      do iupper=3,nhlvl
        hbul(2) = hbul(2) +
     1  hcont(iupper,2)*hstat(iupper)/(hstat(2)+hstat(nhlvl+1))
      end do
*     2s - add on induced two photon
*     following should be multiplied by g(l)/g(tot) as branching ratio
*     from upper level, and then by g(tot)/g(l) to correct stat weights
*     in equation above, so they cancel out
      hbul(nhlvl+1) = hbul(2) + ri2s1s
*     2p - add on Ly a
      hbul(2) = hbul(2) + hcont(2,1)
*
      if( lgTrace.and.lgHBugFull ) then
        write(qq,'(7X,''HTRANS finds arrays, with optical depths defi''
     1  ,''ned? '',L1,'' induced 2ph='',1P,E12.3)') lgTauOutOn,ri2s1s
        do iup=2,nhlvl
         write(qq,'(1X,''up:'',I2,15I9)') iup,(j,j=1,iup-1)
         write(qq,'(i3,1x,''A-net'',1P,15E9.2)')
     1   iup,(hnet(iup,j)    ,j=1,iup-1)
         write(qq,'(i3,1x,''A*esc'',1P,15E9.2)')
     1   iup,(hemis(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''tauin'',1P,15E9.2)')
     1   iup,(htnext(iup,j)  ,j=1,iup-1)
         write(qq,'(i3,1x,''t tot'',1P,15E9.2)')
     1   iup,(htlim(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''Esc  '',1P,15E9.2)')
     1   iup,(hesc(iup,j)    ,j=1,iup-1)
         write(qq,'(i3,1x,''Dest '',1P,15E9.2)')
     1   iup,(hdest(j,iup)    ,j=1,iup-1)
         write(qq,'(i3,1x,''A*dst'',1P,15E9.2)')
     1   iup,(hdest(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''StrkE'',1P,15E9.2)')
     1   iup,(pestrk(iup,j)  ,j=1,iup-1)
         write(qq,'(i3,1x,''EsctE'',1P,15E9.2)')
     1   iup,(esesc(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''B(ul)'',1P,15E9.2)')
     1   iup,(hcont(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''Tnext'',1P,15E9.2)')
     1   iup,(htnext(iup,j)   ,j=1,iup-1)
         write(qq,'(i3,1x,''C(ul)'',1P,15E9.2)')
     1   iup,(hcol(iup,j)*eden,j=1,iup-1)
         if(iup.eq.2)
     1   write(qq,'(4X,''FeIIo'',1P,8E9.2)') dstfe2lya * hyas(2,1)
        end do
*
        write(qq,'(9x,13i9)') (i,i=1,nhlvl+1)
      endif
*
      end
******************************************************************************
      subroutine humla( taume , beta , esc , dest )
      implicit none
*fit Hummer and Kunasz escape probability for hydrogen atom Lya
      real taume,beta,esc,dest
*
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real xLaMase
*smallest Lya optical depth that occured in the calculation
      common/LaMase/ xLaMase
*
*     local variables
      real tau,taulog,betal,taucon,fac,fac1,fac2
      real esc0
      real sqrtpi
      parameter (sqrtpi=1.7724539)
*
*     fits to numerical results of Hummer and Kunasz Ap.J. 80
      tau = taume * sqrtpi
*
      if( chEscFun.eq.'SIMP' ) then
*       this set with "escape simple" command, used for debugging
        esc0 = 1. / (1. + taume )
      else
*       this is the real escape probability
        esc0 = 1. / ( (0.6451+tau) * (0.47+1.08/(1.+7.3e-6*tau) ) )
      endif
      esc0 = max(0., esc0)
      esc0 = min(1., esc0)
*
      if( tau.gt.0. ) then
        taulog = log10( min(1e8,tau ) )
      else
*       the line mased
        xLaMase = min(xLaMase,tau)
        dest = 0.
        esc = esc0
      endif
*
      if( beta .gt.0. ) then
        betal = log10( beta )
        taucon = min( 2.,beta * tau )
*
        if( taucon.gt.1e-3 ) then
          fac1 = -1.25 + 0.475 * taulog
          fac2 = -0.485 + 0.1615 * taulog
          fac = -fac1 * taucon + fac2 * taucon**2
          fac = 10.**fac
          fac = min(1. , fac )
        else
          fac = 1.
        endif
*
        esc = esc0 * fac
*       MIN puts cat at 50
        dest = beta / (0.30972 - min( .28972,0.03541667*taulog))
      else
        dest = 0.
        esc = esc0
      endif
      dest = max( 0. , min( dest , 1.-esc ) )
*
      end
******************************************************************************
      real function HydColDwn(ihigh,ilow,iz)
      implicit none
*rate coefficient for collisional de-excitation for any levels of hydrogenic Z
*written by Jason Ferguson to compute the
*     >>refer Sampson, D.H., & Zhang, H.L. 1998, ApJ, 335, 516
*     rate coeff. for collisional excitation between any two levels of
*     hydrogenic atoms charge Z.  Valid for all ilow, ihigh.
*
      integer iz
      integer ihigh,ilow
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real H,An,R,xp,xn,xnp2,tev,ryd,y,e1,e2,A,D,c,rate
      real arrH(4),arrAn(10),arrR(10)
      real ee1, fosc, sexp
      integer i
      data (arrH(i),i=1,4)/1.48,3.64,5.93,8.32/
      data (arrAn(i),i=1,10)/1.30,0.59,0.38,0.286,
     1     0.229,0.192,0.164,0.141,0.121,0.105/
      data (arrR(i),i=1,10)/1.83,1.60,1.53,1.495,
     1     1.475,1.46,1.45,1.45,1.46,1.47/
*
*begin sanity check
      if( iz.lt.2 .or. ilow.ge.ihigh .or. ilow*ihigh.le.0 ) then
        write(qq,'(''HydColDwn called with impossible parameters.'')')
        write(qq,'(3i5)') ihigh,ilow,iz
        stop
      endif
*end sanity check
*
      if(ilow.gt.4) then
        H = 2.15 * ilow
      else
        H = arrH(ilow)
      endif
      if(ilow.gt.10) then
        An = 1./float(ilow)
        R = 1.50
      else
        An = arrAn(ilow)
        R = arrR(ilow)
      endif
*
      xp=float(ihigh)
      xn=float(ilow)
      xnp2 = (xn/xp)**2
      tev = 8.61716e-5 * te
      ryd = 13.60583
*
      y = iz**2 * ryd * (1./xn**2 - 1./xp**2) / tev
      if(y.lt.1.) then
        e1 = ee1(y)
        e2 = sexp(y) - y*e1
      else
        e1 = ee1(y)
        e2 = 1 - y*e1
      endif
      A = 4.*xn**4 / ( 1 - xnp2 ) * fosc(xn,xp)
      D = A * H * ( (1-xnp2)**R - An*xnp2 )
      c = 1.12 * xn * A * (1 - xnp2)
      if(xp-xn.eq.1.) then
        c = c * sexp( 0.006*(xn-1.)**6/iz )
      endif
*
      rate = 8.63e-6/( (xn*iz)**2 * sqrt(te) )
      rate = rate * ( (A + y*c)*e1 + D*e2 )
*
*     Convert from excitation to de-excitation
      if(y.lt.1) then
        HydColDwn = rate * xnp2 / sexp(y)
      else
        HydColDwn = rate * xnp2
      endif
*
      HydColDwn = max( HydColDwn , 1.e-30 )
*
      return
      end
******************************************************************************
      real function HydColIon(n,iz)
      implicit none
*calculate hydrogenic ionization rates for all n, and Z
*     Allen 1973, Astro. Quan. for low Te.
*     Sampson and Zhang 1988, ApJ, 335, 516 for High Te.
*
      integer n,iz
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real tev,rate,xn,ryd,y,chim,rate2
      real e1,e2,e3,t1,t2,t3,t4
      real ee1,sexp , small
      integer i
      real arrH(4),arrRnp(8),arrg(10),H,Rnp,g
      data (arrH(i),i=1,4)/1.48,3.64,5.93,8.32/
      data (arrRnp(i),i=1,8)/2.20,1.90,1.73,1.65,1.60,1.56,1.54,1.52/
      data (arrg(i),i=1,10)/0.8675,0.932,0.952,0.960,0.965,0.969,
     1      0.972,0.975,0.978,0.981/
*     data small/1e-37/
      data small/0./
*
*begin sanity check
      if( iz.lt.2 .or. n.le.0 ) then
        write(qq,'(''HydColIon called with impossible parameters.'')')
        write(qq,'(3i5)') n,iz
        stop
      endif
*end sanity check
*
      if(n.gt.4) then
        H = 2.15 * n
      else
        H = arrH(n)
      endif
      if(n.gt.8) then
        Rnp = 1.52
      else
        Rnp = arrRnp(n)
      endif
      if(n.gt.10) then
        g = arrg(10)
      else
        g = arrg(n)
      endif
*
      tev = 8.617e-5 * te
      ryd = 13.60583
      xn = float(n)
      chim = iz**2 * ryd / xn / xn
      y = chim / tev
*     E1(x) integral must be multiplied by e(-y) if y>1.
      if(y.lt.1.) then
        e1 = ee1(y)
      else
        e1 = ee1(y)*sexp(y)
      endif
      e2 = sexp(y) - y*e1
      e3 = ( sexp(y) - y*e2 )/2.
*
      t1 = 1/xn * e1
      t2 = 1./3./xn * (sexp(y) - y*e3)
      t3 = 3.*H/xn/(3.-Rnp) * ( y*e2 - 2.*y*e1 + sexp(y) )
      t4 = 3.36*y*(e1 - e2)
      rate = 7.69415e-9 * sqrt(tev) * (xn/iz)**4 * g * y
      rate = rate * (t1 - t2 + t3 + t4)
      rate = max( rate , small )
*
*     rate from Allen:
      if(iz.eq.1) then
        rate2 = 1.1e-8 * sqrt(te) /chim/chim *
     1          sexp(log(10.)*5040.*chim/te)
      else
        rate2 = 2.1e-8 * sqrt(te) /chim/chim *
     1          sexp(log(10.)*5040.*chim/te)
      endif
      rate2 = max( rate2 , small )
*
*     Take the lowest of the two, they fit nicely together...
      HydColIon = min(rate,rate2)
*
      end
******************************************************************************
      subroutine hydrgn( hlax , sechi )
      implicit none
*main routine to call hlevel and determine model hydrogen atom level balance
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer limelm
      parameter (limelm=30)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real HLevNIonRyd
*ionizatoin potention of hydrogenic level n
*set in makehydro
      common/HNIonRyd/ HLevNIonRyd(lmhlvl+1)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real opac
      common/opac/ opac(ncell)
      double precision hlte
      real hc2p2se , hc2p2sp , hc2s1s
*hc2p2se and hc2p2sp are rates for 2s - 2s collisions with electrons and protons
*hlte is lte population of each level
      common/hcolrt/ hlte(lmhlvl+1) , hc2p2se , hc2p2sp , hc2s1s
      integer iphop
      common/iphop/ iphop(lmhlvl)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real hesc , esesc
      common/hesc/ hesc(lmhlvl,lmhlvl) , esesc(lmhlvl,lmhlvl)
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      logical lgHIonON
*flag set false when hydrogen ionization too small to compute
      common/hionon/ lgHIonON
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      double precision hlbolt , hcbolt
*     hlbolt(low,up) line boltzmann factors for hydrogen atom
*     hcbolt(n) excit to continuum
      common/hlvcol/ hlbolt(lmhlvl-1,lmhlvl+1) , hcbolt(lmhlvl+1)
      real x12
      common/x12/ x12
      real recgrd , photex
      common/recgrd/ recgrd , photex
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real workft , workfz
      common/workf/ workft , workfz
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer  ip2gam
      common/ip2gam/  ip2gam
      real hi , hii
      common/h/ hi , hii
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real te , eden , hden
      common/phycon/ te , eden , hden
      real resmax
      common/resmax/ resmax
      real photn2
      common/photn2/ photn2
      integer lhytot
      common/lhytot/ lhytot
      real hgamsc
      common/hgamsc/ hgamsc
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real HLineWidth
*width of each alpha transition from i+1 to i (Lya is 1)
      common/hwidth/ HLineWidth(lmhlvl)
      real otsfe2 , emuv3
      common/resion/ otsfe2 , emuv3
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     TexcLya is the excitation temperature of Lya
*     nLyaHot is counts how ofter Lya hotter than gas
*     TLyaMax is hottest
*     TeLyaMax is electron temp at point where Lya max
*     nZTLaMax is the zone where this happened
      real TexcLya , TLyaMax , TeLyaMax
      integer nLyaHot , nZTLaMax
      common/LyaExT/ TexcLya , nLyaHot , TLyaMax , TeLyaMax , nZTLaMax
      character*10 chInCvgRsn
      common/InCvgRsn/ chInCvgRsn
      real hex , dhexdt
      common/hex/ hex , dhexdt
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      real EdenError
*     this is relative error in the electron density we want
*     set in block data to 0.01
*     reset with set EdenError command
      common/erredn/ EdenError
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      real EdenMet , EdenNotH
*     EdenMet is sum of electrons from Lit through n=30, all ions
*     EdenNotH is total electron density less the proton density
*     used in hydrogen loop for charge conservation
      common/EdenOther/ EdenMet , EdenNotH
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      real cyntrn,hmfb,c584,heavfb,bhe,herec,eebrm,h2line,h2dis,
     1 heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      common/coolng/cyntrn,hmfb,c584,heavfb, bhe,herec,eebrm,h2line,
     1 h2dis,heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      real hstat
      common/hstat/ hstat(lmhlvl+1)
*     include "HdeltaT.com"
      integer ipSecIon
      common/ipSecIon/ ipSecIon
      logical lgBigSec
      common/BigSec/ lgBigSec
      real PhotScaleOn
*     set to 1 in zero, so have no effect
*     set to 0 with 'no photoionization' command, kills
*     photoionization of everything
      common/PhotScale/ PhotScaleOn
      real HPhotHeat(lmhlvl)
*this is heating due to hydrogen photoionization per level
*set in hydrgn, used in hydrocool
      common/HPHeat/ HPhotHeat
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer ip374 , ip660
      common/pbowen/ ip374 , ip660
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real ResultEden,hiip,diffhii,diffhi,dne,hip,p2,widla,
     1 pratio,gamtot,coltot,hlax,sechi,bnfun,f,ff,edensave,
     2 out2,hginv,ohii,ohi,AssumEden,simhii,hmovh1,HighE,
     3 otsmg2 , SignSave , FracChange , xLowE , csupeff
      save xLowE , HighE
      logical lgNeOscil
      integer luphlim
      parameter (luphlim=8)
      integer i,n,ip,luph
      double precision h2ovh1
      save h2ovh1
      real gh(lmhlvl)
      integer nZoneDone
      logical lg2ndPass
      save nZoneDone
      save lg2ndPass
      save gh
      real aa(6)
      character chLab(7)*6
      logical lgNeCap , lgConverged , lg2BigChg
      real dNeSave , otsnew , EdenInit
      real coef(3),frac(7) , weight , gamk
      data coef/ 2.66e-9 , 5.04e-11, 2.63e-12/
*
*     free statement numbers, >=13, not 999
*
      edensave = eden
      if( lgDoPhoto ) then
*
*       induced recombination; FINDUC is integral of
*       pho rate times exp(-hn/kt) for induc rec
*       CIND is this times hnu-hnu0 to get ind rec cooling
*       PhotScaleOn is 1, set to 0 with 'no photoionization' command
*       >>chng 96 oct 25, energy from 1 ryd to .99946 contained in HLevNIonRyd
*       >>chng 97 aug 14, divided into two branches depending on whether
*       induced is important - lgHInducImp is set in setcon
        if( lgHInducImp ) then
          xLowE = bnfun( ipHn(1) , ipSecIon-1,iphop(1), HLevNIonRyd(1),
     1    finduc(1), cind(1))*PhotScaleOn
          HPhotHeat(1) = h * PhotScaleOn
*         do second piece and pick up effects of suprathermals
          HighE = bnfun(ipSecIon,nflux,iphop(1)+ipSecIon-ipHn(1),
     1    HLevNIonRyd(1),f, ff)* PhotScaleOn
          finduc(1) = finduc(1) + f
          cind(1) = cind(1) + ff
        else
          xLowE = gamk(ipHn(1),ipSecIon-1,iphop(1),1.)
          HPhotHeat(1) = h * PhotScaleOn
          HighE = gamk(ipSecIon,nflux,iphop(1)+ipSecIon-ipHn(1),1.)
          finduc(1) =  0.
          cind(1) =  0.
        endif
*       now get sum of photoionization and heating
        gh(1) = xLowE + HighE
        HPhotHeat(1) = HPhotHeat(1) + h * PhotScaleOn
*       option to print photoionization rates
        if( lgTrace.and.lgHBug ) then
          call PrtGamma(ipHn(1),nflux,iphop(1),qq,xLowE+HighE,
     1    (HighE+xLowE) *0.05)
        endif
*       units for secondaries; inverse seconds.
        sechi = secion
        hlax = secla
*       hgamsc is direct photioniz rate due to very hard x-rays+Compton scat
        hgamnc(1) = gh(1) + hgamsc
        PhotoRate(1,1,1,1) = hgamnc(1)
        PhotoRate(1,1,1,2) = HPhotHeat(1)
*       all other continua
        do i=2,nhlvl
          if( lgHInducImp ) then
            gh(i) = bnfun(ipHn(i),ipHn(1)-1,iphop(i),HLevNIonRyd(i) ,
     1      finduc(i), cind(i)) * PhotScaleOn
          else
            gh(i) = gamk(ipHn(i),ipHn(1)-1,iphop(i),1.) * PhotScaleOn
            finduc(i) = 0.
            cind(i) = 0.
          endif
          hgamnc(i) = gh(i)
          HPhotHeat(i) = h
        end do
*666    write(qq,'(''HPhotHeat'',1p,10e10.2)') te,hgamnc(2),HPhotHeat(2)
*         call PrtGamma(ipHn(2),ipHn(1)-1,iphop(2),qq,hgamnc(2) ,
*    1    hgamnc(2) *0.10)
*       now split up 2s and 2p
*       factor of 1.5 is to get to te in induc problem
        finduc(nhlvl+1) = finduc(2)*1.5
        cind(nhlvl+1) = cind(2)
*       factor of 1.079 ratio of 2s cs to n=2 cs, Allen, AQ p96
        hgamnc(nhlvl+1) = hgamnc(2)*1.5
      endif
*
*     break out ots ionization due to mg ii 2798
      otsmg2 = otslin(int(t2804(ipLnIpCont)))+
     1 otslin(int(t2796(ipLnIpCont)))
      out2 = max(1e-37,gh(2) + eden*(hcol(2,1)+hcolnc(2)) +
     1 (otsmg2+otsfe2)*6.4e-18 + hemis(2,1) )
      resmax = max( resmax , (otsmg2+otsfe2)*6.4e-18 / out2 )
*
      if( lgTrace ) then
*        if( lgNewIon .and.hgamnc(1).gt.0. ) then
*     >>chng 97 july 8, from 0 to 1e-35, crash in pdr due to overflow
         if( lgNewIon .and.hgamnc(1).gt.1e-35 ) then
           hginv = 1. / hgamnc(1)
           chLab(1) = 'INCDNT'
           frac(1) = gh(1) * hginv
           ip = 1
           if( hgamsc*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'HGAMSC'
             frac(ip) = hgamsc*hginv
           endif
           if( otslin(iphe2l(2,1))*2.85e-19*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS304'
             frac(ip) = otslin(iphe2l(2,1))*2.85e-19*hginv
           endif
           if( otslin(iphe1l(2,1))*1.85e-18*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS584'
             frac(ip) = otslin(iphe1l(2,1))*1.85e-18*hginv
           endif
           if( otscon(nhe2(2))*6.30e-18*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS911'
             frac(ip) = otscon(nhe2(2))*6.30e-18*hginv
           endif
           if( otscon(nhe1(1))*1.25e-18*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS504'
             frac(ip) = otscon(nhe1(1))*1.25e-18*hginv
           endif
           if( otscon(nhe2(1))*1.20e-19*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS228'
             frac(ip) = otscon(nhe2(1))*1.20e-19*hginv
           endif
           if( otslin(ip660)*2.40e-18*hginv.gt.0.01 ) then
             ip = min( ip+1 , 7 )
             chLab(ip) = 'OTS660'
             frac(ip) = otslin(ip660)*2.40e-18*hginv
           endif
           write(qq,'(5X,''HYDRGNgr low, med hi='',1P,3E9.2)')
     1     xLowE , HighE , hgamsc
           write(qq,'(5X,''HYDRGNgr pht='',1P,E9.2,'' frc:'',1X,A6,E9.2,
     1     0P,6(1X,A6,F6.3))') hgamnc(1) , ( chLab(i), frac(i),i=1,ip)
*
           if(hgamnc(2).gt.1.e-20.and.(otsmg2+otsfe2)/hgamnc(2).gt.0.01)
     1       then
             write(qq,'(5X,''HYDRGNn2 rate'',1P,E9.2,'' Prim'',E9.2,
     1       '' Res line:'',E9.2)') hgamnc(2), gh(2)/hgamnc(2) ,
     2       (otsmg2+otsfe2)/hgamnc(2)
           endif
         else if( hgamnc(1).le.0. ) then
           write(qq,'(5X,''HYDRGN finds zero photoioniz rate.'')')
         else
           writE(qq,'(5X,''HYDRGN does not reeval photoioniz rates.'',
     1     '' n=1, 2='',1P,2E10.2)') hgamnc(1) , hgamnc(2)
         endif
      endif
*
*---------------------------------------------------------------------
*
*     drive HLEVEL to find H solution
*
*     set exponential factors for HLEVEL
      call hcolst
*
*     EDNCOR is correct eden, from charge conservation, eval in ESUM
*     dead code - it erev activated, current name of variable is EdenTrue
*     EdenNotH is sum of all electrons from everything else, it is set in esum
*     eother = max(0., edncor - hii )
*
*     this is top of loop for hydrogen ionization-electron density conver
*     evaluate radiative quantities
*     DEC 1 93  84.09
* 666 error! speed up code by changing htrans
*     this was moved into loop so that the destruction rates are
*     constantly reevaluated.  Much of what HTRANS does could be
*     moved back out of this loop.  Rewrite HTRANS so that each block
*     of do loops checks whether its really necessary to be reevaluated
*     Putting htrans in this loop slowed the code down by about 10%
*     the logic to reevaluate hlevel if the neutral fraction changes is now
      luph = 0
      lgNeCap = .true.
      diffhii = EdenError* 2.
      diffhi = EdenError* 2.
*     luphlim set in parameter above, is 8
      lgConverged = .false.
*     this will be flag for electron density having changed by
*     too much - this is bad if secondary ionizations are important
      EdenInit = eden
      lg2BigChg = .false.
      if( nzone.gt.1 .and. nzone.eq.nZoneDone ) then
        lg2ndPass = .true.
      else
        lg2ndPass = .false.
      endif
      nZoneDone = nzone
      dne = -1.
*     dne is set to zero within this loop
      do while( luph.lt.luphlim .and. .not.lgConverged .and.
     1  .not.lg2BigChg .and. dne.ne.0. )
        if( lgTrConvg .and. nLevTrace.eq.0 ) then
          if(luph.eq.0 ) then
            write(qq,'(7x,''enter hlevel loop, search='',l2)')lgSearch
          else if( lgNeCap ) then
            write(qq,'(7x,''hlevel loop'',i3,'' lgNeCap set, '',
     1      ''FracChange='',1p,e10.2)')luph,FracChange
          else if( diffhii.gt.EdenError ) then
            write(qq,'(7x,''hlevel loop'',i3,'' large diffhii='',1p,
     1      e10.2)') luph, diffhii
          else if( diffhi.gt.EdenError ) then
            write(qq,'(7x,''hlevel loop'',i3,'' large diffhi='',1p,e10.2
     1      )') luph, diffhi
          else if( abs(ResultEden-AssumEden)/ResultEden.gt.EdenError)
     1      then
            write(qq,'(7x,''hlevel loop'',i3,'' large change in eden'',
     1      '' to '',1p,e10.2,'' from'',e10.2)') luph, ResultEden,
     2      AssumEden
          else
            write(qq,'(7x,''hlevel loop, insane'')')
          endif
        endif
        ohii = hii
        ohi = hi
        call htrans
        luph = luph + 1
        lhytot = lhytot + 1
*       AssumEden = EdenNotH + hii
        AssumEden = eden
        call hlevel( h2ovh1 , simhii , csupeff )
        call hmole( hmovh1 , h2ovh1 )
        if( lgTrace ) write(qq,'(5X,''HYDRGN, H2OVH1='',1P,
     1  E10.3,'' simple='',E10.3,'' H-ovH1:'',e10.2)')
     1  h2ovh1 , simhii,hmovh1
        hiip = hden * h2ovh1 / (1. + h2ovh1 + hmovh1 )
        hip = hden / (1. + h2ovh1 + hmovh1 )
*       EdenNotH is electrons for everything not hydrogen
*       hiip is proposed proton density from current solution
        ResultEden = EdenNotH + hiip
        if( ResultEden.lt.0. ) then
          write(qq,'('' I found a negative electron density in HYDRGN.''
     1    ,''  Whats up?  ResultEden='',1PE10.2,'' EdenNotH='',E10.2,
     2    '' new HII='',E10.2)') ResultEden , EdenNotH , hiip
          stop
        endif
*       dne is resulting change in proton density
*       dne = hiip - ohii
*       >>chng 97 july 8, some models went totally neutral, do nothing here
        if( hiip.eq.0. ) then
          dne  = 0.
        else
          dne = ResultEden - AssumEden
        end if
*       dne = (hiip - ohii) * 0.5
*       make sure not totally neutral
        if( h2ovh1.gt.0.  ) then
*         this is true error in soln
          diffhii = abs( hiip-ohii ) / ResultEden
          diffhi = abs( hip-ohi ) / ohi
        else
*         this happens if there is no ionizing radiation
          diffhii = 0.
          diffhi = 0.
          ResultEden = AssumEden
        endif
        if( lgSearch ) then
*         this is search for new solution
          if( (lgTrConvg.and. nLevTrace.eq.0).or.(lgTrace.and.lgNeBug))
     1      then
            write(qq,'(7x,''hlevel, chg1 ne from, to, dn'',1p,3e10.3)')
     1      eden, 10.**( 0.5*(log10(AssumEden)+log10(ResultEden) ) )
          endif
          eden = 10.**( 0.5*(log10(AssumEden)+log10(ResultEden) ) )
          lgNeCap = .false.
        else
*         do not let ne change by too much
*         sign of second argument applied to first argument
*         dne = sign( min( abs(dne),0.02*hii) , dne )
*         we want final soln better than EdenError of electron density
*         so must change eden by less than that
*         EdenError default is set to 0.01 in block data
          if( luph.le.1 ) then
*           this is first time through loop, remember sign of change in eden
            SignSave = dne
*           may have been oscillating while previous calls in this zone
            if(.not.lg2ndPass) lgNeOscil = .false.
            FracChange = EdenError / 2.
          else
            if( SignSave * dne .le.0. ) then
*             change in eden is oscillating
              lgNeOscil = .true.
              FracChange = EdenError / 3.
            else if( luph.gt.4 .and. .not.lgNeOscil ) then
*             allow bigger changes
              FracChange = EdenError * 4.
            else if( .not.lgNeOscil ) then
              FracChange = EdenError * 2.
            endif
          endif
          dNeSave = dne
          dne = sign( min( abs(dne), FracChange*eden ) , dne )
*         only do this loop one time
*         >>chng 97 aug 26, do now change electron density here, eden
*         changes only one time per full loop
          dne = 0.
*         was dne capped?  if so then not converged
          if( dne.ne.dNeSave ) then
            lgNeCap = .true.
          else
            lgNeCap = .false.
          endif
          if( lgTrConvg .or.lgTrace.and.lgNeBug ) then
            write(qq,'(5x,''HYDRGN chg2 EDEN from, to, dn'',1p,3e10.3)')
     1      eden, eden+dne, dne
          endif
          eden = eden + dne
        endif
        if( eden.le.0. ) then
          write(qq,'('' Negative electron density in HYDRGN, zone='',i5
     1    )')nzone
          write(qq,'('' hii='',1p,e10.2,'' eden, dne='',2e10.2)')
     1    hii , eden , dne
          call ShowMe
          stop
        endif
        hii = hiip
        hi = hip
*       test that electron density has not changed by too much
        if( lgBigSec ) then
          if(abs(eden/EdenInit-1.).gt.0.05 ) lg2BigChg = .true.
        endif
*       test for convergence - this is a do while loop which
*       loops until this is true, or exceed max number of iterations
        if(diffhii.gt.EdenError.or.diffhi.gt.EdenError .or.
     1    abs(ResultEden-AssumEden)/ResultEden.gt.EdenError) then
          lgConverged = .false.
        else
          lgConverged = .true.
        endif
*       actual end of loop
        if( lgTrace ) then
          write(qq,'(5X,''HYDRGN, LUPH='',I2,'' OldE-'',1P,
     1    E11.4,'' OldHII='',E11.4,'' NewHII='',E11.4,'' NewE-'',E11.4,
     2    ''  HI:'',E11.4,'' EdenNotH:'',E11.4)')
     3    luph,AssumEden,ohii,hiip,eden,hip,EdenNotH
          if( lgNeBug ) write(qq,'(5X,''HYDRGN: EDEN to'',1P,
     1    E11.4,'' from'',E11.4,'' Ne resulting='',E11.4,
     2    '' AssumEden='',e11.4,'' cap?'',l2,'' oscl?'',l2,'' fne'',
     3    e8.1)')
     2    eden , eden-dne , ResultEden,AssumEden,lgNeCap,lgNeOscil,
     3    FracChange
        endif
*       do while( luph.lt.luphlim .and. .not.lgConverged .and.
*    1  .not.lg2BigChg )
      end do
*     end of elecron density convergence loop
*
*       if( lgNeCap.or. diffhii.gt.EdenError .or. diffhi.gt.EdenError )
*    1   then
*         dif is ratio of abs val of change in n+ to new electron density
*         so is change in HII relative to the electron density
*         another loop on hlevel, hmole will be needed
*         if( luph.lt.8.and. lgNeCap ) go to999
*   do while( luph.gt.8 .and.(lgNeCap.or.diffhii.gt.EdenError.or.diffhi.gt.EdenE
*
      if( luph.ge.luphlim .or. lg2BigChg ) then
*       falls through here if it didn't converge, or if change in
*       electron density got too big
*       tells IONTE that IONIZE is not finished
        if( lgTrace ) then
          if( lg2BigChg ) then
            write(qq,'(5X,''>>>>>> HYDRGN did not converge elec den,'',
     1      '' limit hit of'',i4,'' sec ioniz 2 imp'')') luph
          else if(lgNeCap) then
            write(qq,'(5X,''>>>>>> HYDRGN did not converge elec den,'',
     1      '' limit hit of'',i4,'' Change in eden capped.'')') luph
          else
            write(qq,'(5X,''>>>>>> HYDRGN did not converge elec den,'',
     1      '' limit hit of'',i4,'' Change in eden not capped.'')')
     2      luphlim
          endif
        endif
        lgIonDone = .false.
        chInCvgRsn = 'HEden conv'
      endif
*-------------------------------------------------------------
*
*     save into master ionization array
      xIonFracs(1,1) = hi
      xIonFracs(1,2) = hii
*
*     RECGRD is total recombination rate
      recgrd = hrec(1,1)*hrec(1,2)
      do i=2,nhlvl+1
        recgrd = recgrd + hrec(i,1)*hrec(i,2)
      end do
      workfz = recgrd * eden * hii
*
*     put into OTS continuum
      weight = 0.75
*     >>chng 96 may 14 weight to below for c oscil
      weight = 0.25
      do n=1,nhlvl+1
        if( opac(ipHn(n) ).gt.0.) then
          otsnew = ( otscon(ipHn(n))*(1.-weight) +
     1    weight*hrec(n,1)*(1.-hrec(n,3))*eden*hii/ opac(ipHn(n)) ) /2.
          otsnew = otsnew * opac(ipHn(n))
          if( otsnew.lt.0. ) then
            write(qq,'('' hydrgn found negative OTS CON, n='',i4,
     1      '' val='',1p,e10.1)')n , otsnew
            call ShowMe
            stop
          endif
          call AddOTSCon( otsnew , ipHn(n) )
        else
          call AddOTSCon( 0. , ipHn(n) )
        endif
      end do
*
*     OTS fields due to line destruction by background opacity
*     fix Ly-alpha since 2s2p make it special
*     95 oct 20, changed to single precision on right
      call HydroOTS
*
      photex = hn(2) * hgamnc(2)
      do i=3,nhlvl
        photex = photex + hn(i) * hgamnc(i)
      end do
*--------------------------------------------------------------
*
      if( hn(1).gt.0. ) then
        p2 = hn2p / hn(1) / 3.
*       la radiation pressure, check if incomp or compl redis, also always
*       has outward optical depth
        HLineWidth(1) = widla(htau(2,1) , htlim(2,1) , 4.72e-2/sqrte ,
     1  doppler(1))
*       coefficient in following assumes that HLineWidth is half width, not tota
        plines(1) = p2 * 5.08e-6 * HLineWidth(1)
*       excitation temperature of Lya
        if( p2.gt.0. ) then
          TexcLya = -1.183E5 / LOG( p2 )
        else
          TexcLya = 0.
        endif
      else
        p2 = 0.
        HLineWidth(1) = 0.
        plines(1) = 0.
        TexcLya = 0.
      endif
*
*     now do prad for excited H states
*     inner optical depths
      aa(1) = htau(3,2)
      aa(2) = htau(4,3)
      aa(3) = htau(5,4)
*     outer optical depths
      aa(4) = htlim(3,2)
      aa(5) = htlim(4,3)
      aa(6) = htlim(5,4)
*
      plines(3) = 0.
      do i=2,4
        if( hn(i).gt.0. ) then
          pratio = hn(i+1)/hn(i)
*         now assume line width just doppler core
          HLineWidth(i) = doppler(1)*2. * (1. - hesc(i+1,i) )
*         HLineWidth(i) = widlin( aa(i-1) ,aa(i+2) ,0. ,doppler(1) )
          plines(3) = plines(3) + coef(i-1) * pratio * HLineWidth(i)
        else
          pratio = 0.
          HLineWidth(i) = 0.
        endif
*       now assume line width just doppler core
        HLineWidth(i) = doppler(1)*2. * (1. - hesc(i+1,i) )
*       HLineWidth(i) = widlin( aa(i-1) ,aa(i+2) ,0. ,doppler(1) )
        plines(3) = plines(3) + coef(i-1) * pratio * HLineWidth(i)
      end do
*
*     higher Lyman lines radiation pressure
*     now assume only doppler core
      if( hn(1).gt.0.) then
        plines(2) = hn(3)/hn(1)/9.*1.01e-5 * doppler(1) * 2. *
     1  (1.-hesc(3,1))+
     2  hn(4)/hn(1)/16.*1.24e-5* doppler(1) * 2.*(1.-hesc(4,1)) +
     3  hn(5)/hn(1)/25.*1.36e-5 * doppler(1) * 2.*(1.-hesc(5,1))
      else
        plines(2) = 0.
      endif
*
*---------------------------------------------------------------------
*
      gamtot = hgamnc(1) + csupeff
      coltot = (hcolnc(1) + hcol(2,1)*4.*hlbolt(1,2))
      if( lgHIonON ) then
        photn2 = hgamnc(1) / (gamtot+coltot*eden+x12+photex/
     1  max(1e-37,hn(1)))
      else
        photn2 = 0.
      endif
*
*     evaluate hydrogen heating-cooling due to collisions
      call HydroCool
*
      if( lgTrace ) then
        write(qq,'(''     HYDRGN retrn H,2,NE='',3(1P,E9.2),
     1  '' REC, COL, GAMT= '',3E9.2,'' CSUP='',E8.2,'' Htwo='',E9.2)')
     2  hi,hii,eden,recgrd,coltot,gamtot, csupeff,htwo
        if(lgNeBug ) write(qq,'(5x,''EDEN change HYDRGN from to'',1p,
     1  3e10.3)') edensave , eden , edensave/eden
      endif
*
      end
******************************************************************************
      subroutine HydroCool
      implicit none
*compute net heating/cooling due to model hydrogen atom
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      double precision hlbolt , hcbolt
*     hlbolt(low,up) line boltzmann factors for hydrogen atom
*     hcbolt(n) excit to continuum
      common/hlvcol/ hlbolt(lmhlvl-1,lmhlvl+1) , hcbolt(lmhlvl+1)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
*     energy differences for model hydrogen atom:
*     this is array of temperatures, first between levels, sec lev to cont
*     HdeltaT( upper , lower )
      real HdeltaTe, HCionTe
      common/HdeltaT/ HdeltaTe(lmhlvl,lmhlvl), HCionTe(lmhlvl)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real hex , dhexdt
      common/hex/ hex , dhexdt
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
      double precision hlte
      real hc2p2se , hc2p2sp , hc2s1s
*hc2p2se and hc2p2sp are rates for 2s - 2s collisions with electrons and protons
*hlte is lte population of each level
      common/hcolrt/ hlte(lmhlvl+1) , hc2p2se , hc2p2sp , hc2s1s
      real telogn
      common/telogn/ telogn(7)
      real cyntrn,hmfb,c584,heavfb,bhe,herec,eebrm,h2line,h2dis,
     1 heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      common/coolng/cyntrn,hmfb,c584,heavfb, bhe,herec,eebrm,h2line,
     1 h2dis,heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      real teinv
      common/teinv/ teinv
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      real HPhotHeat(lmhlvl)
*this is heating due to hydrogen photoionization per level
*set in hydrgn, used in hydrocool
      common/HPHeat/ HPhotHeat
      real HeatExc , HFreBndNet
*HFreBndNet is recombination cooling less photoionization heating for H
*HeatExc is photoionization heating
*both set in hydrocool
      common/HFBNet/ HeatExc , HFreBndNet
      real HLineTotCool , dHLTot
*HLineTotCool is total hydrogen line cooling or heating, set in hydrocool
*dHLTot is the derivative, set in sumheat
      common/HLineTot/ HLineTotCool , dHLTot
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      double precision temp
      real dhrest , hlone(lmhlvl) , edhii , brems , hclf ,hsave,coolfac,
     1 RecCool , hold, sexp , factor , drestly , dbarest ,dhone(lmhlvl),
     2 dcoola
      integer i , iu , n , l
*
*     compute the total cooling due to the hydrogen atom, and its derivative
*     halfte is 1/(2T)
*
      edhii = eden * hii
*
*     lyman alpha cooling - total cooling is net rad loss
      coola = edhii * 1.636e-11 *
     1 ( hn(1)*hlbolt(1,2)*(hc2s1s + 3.*hcol(2,1))
     1 - hn2s*hc2s1s - hn2p*hcol(2,1) )
      if( coola.gt.0. ) then
*       net coolant, exponential dominates deriv
        dcoola = coola * (1.184e5 * tsq1 - halfte )
      else
*       net heating, te^-1/2 dominates
        dcoola = -coola * halfte
      endif
*     above, first line cooling, second heating
*
*     Lyman line collisional heating/cooling
      drestly = 0.
      restly = 0.
      do i=3,nhlvl-1
        hlone(i) = hcol(i,1) * (hn(1)*hlbolt(1,i)*float(i*i) -hn(i))*
     1  edhii* en1ryd*( 1. - 1./(i**2) )
        restly = restly + hlone(i)
        if( hlone(i) .gt.0. ) then
          drestly = drestly + hlone(i)*(HdeltaTe(i,1)*tsq1-halfte)
        else
          drestly = drestly -hlone(i)* halfte
        endif
      end do
*
*     all remaining hydrogen lines
      hrest = 0.
      dhrest = 0.
      do l=3,nhlvl-2
        do iu=l+1,nhlvl-1
          hlone(i) =
     1    hcol(iu,l)*(hn(l)*hlbolt(l,iu)*hstat(iu)/hstat(l)-hn(iu))*
     2    edhii* (1.384e-16* HdeltaTe(iu,l) )
          hrest = hrest + hlone(i)
          if( hlone(i) .gt.0. ) then
            dhrest = dhrest + hlone(i)*(HdeltaTe(iu,1)*tsq1-halfte)
          else
            dhrest = dhrest - hlone(i)*halfte
          endif
        end do
      end do
*
*     Balmer line collisional heating/cooling and derivative
      barest = 0.
      dbarest = 0.
      do i=3,nhlvl-1
        hlone(i) = hcol(i,2) * (hn(2)*hlbolt(2,i)*float(i*i)/4. -hn(i))*
     1  edhii* en1ryd*( 1./4. - 1./(i**2) )
        barest = barest + hlone(i)
*       count boltzmann factor from ground - not a typo
        if( hlone(i) .gt.0. ) then
*         coolant
          dhone(i) = hlone(i)*(HdeltaTe(i,1)*tsq1-halfte)
        else
*         heating agent
          dhone(i) = -hlone(i)*halfte
        endif
        dbarest = dbarest + dhone(i)
      end do
*
*     this is total hydrogen line cooling or heating
      HLineTotCool = coola + restly +  barest + hrest
*
*     above can be either heating or coolant
*     must add this to total heating or cooling, as appropriate
      if( HLineTotCool.gt.0. ) then
*       hydrogen is a net coolant
        heating(1,24) = 0.
        call coladd('Hlin' , 0 , HLineTotCool )
        dCooldT = dCooldT + dcoola + drestly + dhrest + dbarest
        dHLTot = 0.
      else
*       hydrogen is a net heat source
        heating(1,24) = -HLineTotCool
        call coladd('Hlin' , 0 , 0. )
        dHLTot = -dcoola - drestly - dbarest - dhrest
      endif
*665  write(6,'('' chydro'',1p,e10.3,9e10.2)')te, HLineTotCool, coola ,
*    1 restly , barest , hrest
*666  write(6,'('' dhydro'',1p,e10.3,9e10.2)')
*    1te, dHLTot , dcoola , drestly,dbarest,dhrest
*
*     hydrogen collisional ionization and H-3 body heating, net cooling
*     HEX and dHEXdt are evaluated in HLEVEL
*     HEX is collisional ionization cooling less three body rec heating
      chion = hex * hii
      call coladd( 'Hion' ,  0 , max(0.,chion) )
      dCooldT = dCooldT + dhexdt * hii
*     heating(1,4) is all three body heating, opposite of coll ion cooling
      heating(1,4) = max(0., -chion )
*
*     Hydrogen brems free free cooling, free-free heating
      factor = 0.9 + 1.2/(2.2+abs(alogte-5.398))
*     >>chng 96 jan 8, for stability always use corrected free free
      brems = 1.42e-27 * eden * sqrte * factor * sexp(tff*te1ryd/te)
      temp = brems
*666  write(6,'(1p,9e10.2)') hbrems , brems , hii
      hbrems = temp * hii
*     TFF is freq (Ryd) where gas becomes optically thin to absorption
*     if( chDffTrns.eq.'OTS' ) then
*       ots continuum transport - do not count optically thick part
*       brems = 1.42e-27 * eden * sqrte * factor * sexp(tff*te1ryd/te)
*     else if( chDffTrns(1:2).eq.'OU' ) then
*       brems = 1.42e-27 * eden * sqrte * factor
*     else
*       write(qq,'('' COOLR: insane chDffTrns='',a3)') chDffTrns
*       stop
*     endif
*     these two terms are both large, nearly canceling, near lte
      HFFNet = hbrems - FreeFreeHeat
*     >>chng 96 oct 30, from HFFNet to just hbrems,
*     since SumHeat picks up FreeFreeHeat
      dCooldT = dCooldT +  hbrems * halfte
      call coladd( 'H ff' ,  0 , max(0.,HFFNet)  )
      heating(1,12) = max(0.,-HFFNet )
*
*     hydrogen recombination free-bound free bound cooling
*     this is ground, not ncluded in case b sum
      hrecem = hclf(1)  * hrec(1,2)
      hsave = 0.
*     in this loop hclf(2) is both 2s and 2p
      do n=2,nhlvl-1
*       this is optically thin sum of cooling, will subtract from case b sum
*       so that we can "top off" the model atom's cooling
        hsave = hsave + hclf(n)
        hrecem = hrecem + hclf(n)  * hrec(n,2)
      end do
*
*     following is expression for case b sum of cooling
      coolfac =
     1 (-25.859117 + 0.16229407*telogn(1) + 0.34912863*telogn(2)
     2 - 0.10615964*telogn(3)) /
     3 (1.+ 0.050866793*telogn(1) - 0.014118924*telogn(2)
     4 + 0.0044980897*telogn(3) + 6.0969594E-5*telogn(4) )
      RecCool = (10.**coolfac)/te - hsave
*     let it be as much as 1% negative
      if(RecCool/hsave.lt.-.02) then
        write(qq,'('' RecCool lt 0 in HydroCool, frac error='',1p,
     1  e10.2)') RecCool/hsave
*       set it to a small positive value
        RecCool = 0.01 * hsave
      endif
      hrecem = hrecem + RecCool  * hrec(nhlvl,2)
*     this is now total free-bound cooling
      hrecem = hrecem * edhii
*
*     heating by ground of hydrogen
      heating(1,1) = hii*hn(1) * HPhotHeat(1)
*     units of heating (and cooling) are ergs/s/cm^3
*
*     photoionization of n=2, to next to highest level
*     HPhotHeat(n) is photoionization heating due to level n,
*     evaluated in routine hydrgn
      HeatExc = HPhotHeat(2) *hii*hn(2)
      do i=3,nhlvl-1
        HeatExc = HeatExc + hii*hn(i)*HPhotHeat(i)
      end do
*     following is net cooling due to two processes
*     recombination cooling less photoionization heating
      HFreBndNet = hrecem - HeatExc
*666  if(te.gt.1e6) write(qq,'(1p,'' HFreBndNet'',1p,9e10.2)')te,
*    1 HFreBndNet,hrecem,heatexc,hn(2),HPhotHeat(2)
*
*     heating(1,2) is all excited state photoionization heating
*     >>chng 96 jan 25, was -HeatExc
      heating(1,2) = max(0.,-HFreBndNet )
      call coladd( 'H FB' ,  0 , max(0.,HFreBndNet ) )
*
*     if rec coef goes as T^-.8, but times T, so propto t^.2
      dCooldT = dCooldT + 0.2*HFreBndNet*teinv
*
*     hydrogen induced recombination cooling
      crcind = cinduc(nhlvl+1)*edhii
      dCooldT = dCooldT + crcind*(1.58e5*teinv-1.5)*teinv
      do i=1,nhlvl-1
        hold = cinduc(i) * edhii
        crcind = crcind + hold
        dCooldT = dCooldT + hold*(1.58e5/(i*i*te) - 1.5 ) * teinv
      end do
      call coladd( 'Hind' ,  0 , crcind )
*
      end
****************************************************************************
      subroutine HydroOTS
      implicit none
*evaluate model hydrogen atom ots rates
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hi , hii
      common/h/ hi , hii
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real opac
      common/opac/ opac(ncell)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     make ots fields due to hydrogen lines
*
*     local variables
      real damp , otshere , temp
      integer i,j , nzUsed
      save nzUsed
      data nzUsed/-1/
*
      if( nzone.gt.1 .and. nzone.eq.nzUsed ) return
      nzUsed = nzone
*
*     OTS fields due to line destruction by background opacity
*     fix Ly-alpha since 2s2p make it special
      damp = 0.25
*
      otshere = hn2p*hii*hdest(2,1)
*begin sanity check
      if( otshere.lt.0. ) then
        write(qq,'('' HydroOTS found negative OTS H2l'',2i4,
     1  '' val='',1p,e10.1)')2,1 , otshere
        call ShowMe
        stop
      endif
*end sanity check
      temp = otslin(iphl(2,1))
*     otslin can be zeroed out in AddOpac if opacity too small
      call AddOTSLin( otshere , iphl(2,1) ,damp )
*this code in case of )(#$ oscillations
*     write(11,'('' hydroots finds'',1p,3e10.2)') otshere,
*    1 otslin(iphl(2,1)) , temp
*
      do j=3,nhlvl
        otshere =  hn(j)*hii*hdest(j,1)
*begin sanity check
        if( otshere.lt.0. ) then
          write(qq,'('' HydroOTS finds an insane negative OTS line'',
     1    '' rate='',1p,e10.2)') otshere
          write(qq,'('' upper level was'',i4,'', level pop, dest rate=''
     1    ,1p,2e10.2)') j,hn(j),hdest(j,1)
          call ShowMe
          stop
        endif
*end sanity check
        call AddOTSLin( otshere , iphl(j,1) ,damp )
      end do
*
      do i=2,nhlvl-1
        do j=i+1,nhlvl
          otshere = hn(j)*hii*hdest(j,i)
          if( otshere.lt.0. ) then
            write(qq,'('' HydroOTS found negative OTS H 2l'',2i4,
     1      '' val='',1p,e10.1)')j,i , otshere
            call ShowMe
            stop
          endif
          call AddOTSLin( otshere , iphl(j,i) ,damp )
        end do
      end do
*
      end
******************************************************************************
      subroutine HydroPesc
      implicit none
*evaluate escape and destruction probabilities for hydrogen lines
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      real opac
      common/opac/ opac(ncell)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      real hesc , esesc
      common/hesc/ hesc(lmhlvl,lmhlvl) , esesc(lmhlvl,lmhlvl)
      real hfrcin
      common/hfrcin/ hfrcin(lmhlvl,lmhlvl-1)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real hi , hii
      common/h/ hi , hii
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
      real hlife
      common/hlife/ hlife(lmhlvl)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
*     energy differences for levels in the model hydrogen atom:
      real HEnerRyd
      common/HEnrRyd/ HEnerRyd(lmhlvl,lmhlvl)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real conopc,beta
      common/eovrlpVar/ conopc,beta
      real DestWght , DestWghtSave
*     weight to give new dest prob when being evaluated,
*     default is 0.25 and is reset with SET DSTWGHT command
*     DstWghtSave is usually the same as DstWght - except on 0th
*     zone, where DstWght is set to 1 to get initial dest prob
*     then reset to DstWghtSave
      common/DstWght/ DestWght , DestWghtSave
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real branch,esin,dest,escla,damp,pop,eovrlp,
     1 hjbar,esa0k2,esccom,es , esout , tout ,
     2 OldPop(lmhlvl)
      logical lgTsave
      integer ihigh,ilow,i,j,ilo,ihi
      integer nzUsed
      save nzUsed , OldPop
*
*     real tmax
*     real fudge
*     integer iu,il
*     tmax(iu,il) = max( htlim(iu,il)/10., htlim(iu,il)-htnext(iu,il) )
*
*     free statement numbers >= 17
*
*     this this is 0th zone then use full destruction prob,
*     else use mean of old and new - NB must reset at end
      if( nzone.lt.1 ) DestWght = 1.
*
      if(lgTrace) then
        write(qq,'(10X,''HydroPesc called, DestWght='',1p,e10.2)')
     1  DestWght
      end if
*
*     >>chng 96 may 14 do not evaluate more than once
*     >>chng 96 may 16 evaluate every time
*     if( nzone.gt.0 .and. nzUsed.eq.nzone ) then
*       if(lgTrace)write(qq,'(10X,''HydroPesc not eval.'')')
*     endif
      nzUsed = nzone
*
      if( chEscFun.ne.'  K2'.and. chEscFun.ne.'INCO' .and. chEscFun.ne.
     1  'SIMP') then
        write(qq,'('' This is routine HydroPesc'')')
        write(qq,'('' Unknown escape prob func='',A4)')chEscFun
        stop
      endif
*
      lgTsave = lgTauOutOn
      lgTauOutOn = .true.
*
*     save level pops if starting
      if( nzone.le.1 ) then
        do i=1,nhlvl
          OldPop(i) = hn(i) * hii
        end do
      else
        do i=1,nhlvl
          OldPop(i) = OldPop(i)*0.75 + 0.25*hn(i)*hii
        end do
      endif
*     following if all neutral
      if( OldPop(1).le.0. ) OldPop(1) = hi
*
*     hydrogen lines opacity is function of A's
*     above 15 just use actual A's for high density limit
      do ihigh=4,min(15,nhlvl)
        do ilow=2,ihigh-1
          hyas(ihigh,ilow) = hlife(ihigh) * branch(ihigh,ilow)
*         make self-consistent opaciity
          hopac(ihigh,ilow) = hyas(ihigh,ilow) * 2.2448e-26 *
     1    hstat(ihigh)/hstat(ilow) * (rydlam/HEnerRyd(ihigh,ilow))**3
        end do
      end do
*
*     this is kludge to get departure coef of highest level below unity
*     NB cannot have ilow=1 since in above only 2 and up are set
*     do ilow = 2,nhlvl-1
*       hyas(nhlvl,ilow) = hyas(nhlvl,ilow) * fudge(1)
*     end do
*
*     >>chng factor had been 0.98, changed to 0.9 to stop oscillations
      tout = htlim(2,1)*0.9 - htnext(2,1)
      if( tout.gt.0. ) then
        tout = htlim(2,1) - htnext(2,1)
        hesc(2,1) = escla( esin , dest , OldPop(1) )
        hesc(1,2) = hesc(2,1) * hyas(2,1)
        hdest(1,2) = dest*0.25 + 0.75*hdest(1,2)
*       >>chng 96 may 14 above did not have average
        hdest(2,1) = hyas(2,1) * hdest(1,2)
*       this is fraction of line which is inward escaping
        hfrcin(2,1) = min(1., max(0.,fracin ) )
      endif
*     >>chng 97 sep 13, moved following out of if
      hcont(2,1) = hjbar(2,1) * esa0k2(htnext(2,1)) * hyas(2,1)
*
      lgTauOutOn = lgTsave
*
*     Lyman lines special since always have outer optical depths
*     if( hii.gt.0. ) then
*       popl = hii * hn(1)
*     else
*       popl = hi
*     endif
      do ihigh=3,nhlvl
        damp = hdamp(ihigh) / doppler(1) / (1. - 1./float(ihigh*ihigh) )
        esin = esccom(htnext(ihigh,1),damp)
        hcont(ihigh,1) = hjbar(ihigh,1) * esa0k2(htnext(ihigh,1)) *
     1  hyas(ihigh,1)
*       >>chng factor had been 0.98, changed to 0.9 to stop oscillations
        tout = htlim(ihigh,1)*0.9 - htnext(ihigh,1)
*       only change things if we have not overrun optical depth scale
        if( tout.gt.0. ) then
*         must use correct optical depth
          tout = htlim(ihigh,1) - htnext(ihigh,1)
          esout = esccom(tout, damp)
          hesc(ihigh,1) = 0.5*( esin + esout )
          hfrcin(ihigh,1) = min(1., max(0., esin*0.5 / hesc(ihigh,1) ))
          hesc(1,ihigh) = hesc(ihigh,1) * hyas(ihigh,1)
*         chDstFun default here is K2
*         >>chng 96 sep 4, changed explicit factors to DestWght option
          hdest(1,ihigh) = hdest(1,ihigh)*(1.-DestWght) + DestWght*
     1    eovrlp( OldPop(1) ,htnext(ihigh,1),htlim(ihigh,1) , damp ,
     2    hopac(ihigh,1), iphl(ihigh,1) , doppler(1) , hesc(ihigh,1) ,
     2    chDstFun)
          hdest(ihigh,1) = hyas(ihigh,1) * hdest(1,ihigh)
        endif
      end do
*
      if( lgTauOutOn ) then
*       outward optical depths defined
        do j=2,nhlvl-1
          do i=j+1,nhlvl
            if( htnext(i,j).lt.-30. ) then
              write(qq,'('' HYDROPESC:  H maser optical depth too '',
     1        ''small1,='',1p,e10.2,2i3)') htnext(i,j),i,j
              call ShowMe
              stop
            endif
            damp = hdamp(i) / doppler(1) / (1./float(j*j)-1./float(i*i))
*           this is used for pumping
            esin = esccom(htnext(i,j),damp)
            hcont(i,j) = hjbar(i,j) * hyas(i,j) * esin
            tout = htlim(i,j)*0.9 - htnext(i,j)
*           only change things if we have not overrun optical depth scale
*           but also trap maser effects
            if( tout.gt.0. .or. htnext(i,j).lt.0. ) then
              if( chEscFun.eq.'  K2') then
                esin = esa0k2( htnext(i,j) )
*               must use correct optical depth
                tout = htlim(i,j) - htnext(i,j)
                esout = esa0k2( tout )
              else
                esout = esccom(tout,damp)
              endif
              hesc(i,j) = 0.5*( esin + esout )
*             >>chng 96 sep 5, end had hesc(i,1) not correct i,j <= big bug
              hfrcin(i,j) = min(1., max(0., esin*0.5 / hesc(i,j) ))
              hesc(j,i) = hesc(i,j) * hyas(i,j)
*             destruction by background opacity
*             pop = max(0., hn(j) - hn(i)*float(j*j)/float(i*i) ) * hii
*             >>chng 96 may 16 from above to below
              pop = max(0., OldPop(j) - OldPop(i)*float(j*j)/float(i*i))
*             >>chng 96 sep 4, changed explicit factors to DestWght option
              hdest(j,i) = hdest(j,i)*(1.-DestWght) + DestWght*
     1        eovrlp( pop ,htnext(i,j),htlim(i,j) , damp ,
     2        hopac(i,j), iphl(i,j) , doppler(1) , hesc(i,j) ,chDstFun )
              hdest(i,j) = hyas(i,j) * hdest(j,i)
            endif
          end do
        end do
      else
*       not defined
        do j=2,nhlvl-1
          do i=j+1,nhlvl
            if( htnext(i,j).lt.-30. ) then
              write(qq,'('' HYDROPESC:  H maser optical depth too '',
     1        ''small2,='',1p,e10.2,2i3)') htnext(i,j),i,j
              call ShowMe
              stop
            endif
            damp = hdamp(i) / doppler(1) / (1./float(j*j)-1./float(i*i))
            esin = esccom(htnext(i,j),damp)
            hcont(i,j) = hjbar(i,j) * hyas(i,j) * esin
            if( chEscFun.eq.'  K2') then
              esin = esa0k2( htnext(i,j) )
            else
              esout = esccom(htnext(i,j),damp)
            endif
            hesc(i,j) = esin
            hfrcin(i,j) = 0.
            hesc(j,i) = hesc(i,j) * hyas(i,j)
*           pop = max(0., hn(j) - hn(i)*float(j*j)/float(i*i) ) * hii
*           >>chng 96 may 16 from above to below
            pop = max(0., OldPop(j) - OldPop(i)*float(j*j)/float(i*i))
*           destruction by background opacity
*           >>chng 96 sep 4, changed explicit factors to DestWght option
            hdest(j,i) = hdest(j,i)*(1.-DestWght) + DestWght*
     1      eovrlp( pop , htnext(i,j),htlim(i,j) , damp ,
     2      hopac(i,j), iphl(i,j) , doppler(1) , hesc(i,j) ,chDstFun )
            hdest(i,j) = hyas(i,j) * hdest(j,i)
          end do
        end do
      endif
*     >>chng 96 may 14 above made average of old and new dest probs
*     >>chng 96apr23 kill high min
*     highest level is a mess, set escape prob to one, actually a blend
*     if this is removed, then oscillations in totally optically thick
*     blr occur, for cases where all lines are optically thick
*     see model badbugs/bug0.in
      hesc(nhlvl,1) = max( hesc(nhlvl,1) , 0.1 )
      hesc(1,nhlvl) = hyas(nhlvl,1) * hesc(nhlvl,1)
      do i=2,nhlvl-1
        hesc(nhlvl,i) = max( hesc(nhlvl,i) , 1.0 )
        hesc(i,nhlvl) = hyas(nhlvl,i) * max( hesc(nhlvl,i) , 1.0 )
      end do
*
*begin sanity check
      do ilo=1,nhlvl-1
        do ihi=ilo+1,nhlvl
          if( hopac(ihi,ilo).le.0. ) then
            write(qq,'('' HydroPesc insane H opacity='',2i3,1p,e10.2)')
     1      ihi,ilo,hopac(ihi,ilo)
          endif
        end do
      end do
*end sanity check
*
*     electron scattering escape
      es = eden * 6.65e-25
      do ilo=1,nhlvl-1
       do ihi=ilo+1,nhlvl
          esesc(ihi,ilo) = min(1. , 5.9 * es / (es+hii*hn(ilo)*
     1    hopac(ihi,ilo)))*
     1    max( 0., 1.-hesc(ihi,ilo) - hdest(ihi,ilo)/hyas(ihi,ilo) )
          esesc(ilo,ihi) = esesc(ihi,ilo) * hyas(ihi,ilo)
        end do
      end do
*
      DestWght = DestWghtSave
*
      end
******************************************************************************
      subroutine iiibod
      implicit none
*derive three-body recombination coefficients
      integer limelm
      parameter (limelm=30)
      integer nsbig
      common/nsbig/ nsbig
      logical lgNoCota
*lgNoCota flag set with no three body recombination
      real CotaRate
      common/rcota/ lgNoCota , CotaRate(limelm)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer ioreco
      common/ioreco/ ioreco
      logical lgTrace3Bod
*trace 3 body recombination routines, trace three body
      common/bd3bug/ lgTrace3Bod
*
      integer i , iup
      real da
*
      if( lgNoCota ) then
        do i=1,limelm
          CotaRate(i) = 0.
        end do
        nsbig = 0
        return
      endif
*
      if( nsbig.eq.0 ) then
*       steve cota only defined things up to 28
        iup = min(28 , limelm )
      else
        iup = min( limelm , nsbig , 28 )
      endif
*
      do i=1,iup
        CotaRate(i) = da( float(i) )
      end do
      nsbig = 0
      if(lgTrace.and.lgTrace3Bod) then
        write(qq,'(5x,''3BOD rate:'',1P,14E8.1)')
     1 (CotaRate(i),i=1,14)
      endif
*
      if( ioreco.gt.0.  ) then
*       option to punch coefficients
        write(ioreco,'('' 3body rec coef'')')
        do i=1,iup
          write(ioreco,'(i3,1p,e10.2)') i,CotaRate(i)
        end do
      endif
*
      end
******************************************************************************
      subroutine insane
      implicit none
*set flag saying that insanity has occurred
      logical lgInsane
*     flag to say whether insanity detected
      common/insanity/ lgInsane
*
*     set flag lgInsane to true
*     called if somethine impossible happened
*     a comment will be printed after the calculation, along with
*     a request to show me
*
      lgInsane = .true.
*
      end
******************************************************************************
      subroutine ionize
      implicit none
*main routine to drive ionization solution for all species
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real ElecFrac
*ratio of electron to nuclei density, could be >1 because of he
*set in nockon
      common/efrac/ ElecFrac
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      real toler
*     allowed error in heating - cooling balance, set with TOLERANCE command
*     default set in zerologic
      common/toler/ toler
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real x12
      common/x12/ x12
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real secmet , smetla
      common/secmet/ secmet , smetla
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real tused,tfound
      common/tion/ tused,tfound
      logical lgOTSBug
*flag set with trace ots command
      common/otsbug/ lgOTSBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real hi , hii
      common/h/ hi , hii
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real te , eden , hden
      common/phycon/ te , eden , hden
      real HeavIonCool
*total cooling due to heavy element collisional ionization
      common/cmeion/ HeavIonCool
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real hetmet
      common/hetmet/ hetmet
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real CollidDensity
*total number of colliders (atoms, ions, molecules) in gas, no electrons
      common/collid/ CollidDensity
      real hgdist
      common/hgdist/ hgdist
      real totnuc
*     totnuc is total number of nuclei and molecules, eval in ptot
      common/totnuc/ totnuc
      logical lgCSetOn
*lgCSetOn set with set csupra command
*SetCsupra is secondary ionization rate set with set csupra
      real SetCsupra
      common/cspset/ SetCsupra , lgCSetOn
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      real EdenError
*     this is relative error in the electron density we want
*     set in block data to 0.01
*     reset with set EdenError command
      common/erredn/ EdenError
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      character*10 chInCvgRsn
      common/InCvgRsn/ chInCvgRsn
      integer ntry
      common/ntry/ ntry
      logical lgTrimed
      common/Trimed/ lgTrimed
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      real EdenTrue
*     this is the true eden as set in esum
*     we will try to converge eden to this
      common/TrueEden/ EdenTrue
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
*
*     local variables
      integer nzSupra , ip
      save nzSupra
      real secsav , x12sav , hlax , sechi, seccmp, scmpla,factor,
     1 seche , helax , x12new , secnew , EdenProp , EdenOld,
     1 HeatOld ,damper , CorrBig , CorrSmall
      save hlax , sechi , EdenOld , EdenProp, secnew, x12new,
     1 secsav , x12sav , CorrBig , CorrSmall
*     lgConverg is a function to check whether ionization has converged
      logical lgConverg , lgOK
*
*     these are the deltas for changes in the electron density
      data CorrSmall/0.35/ , CorrBig/2./
*
*     free statement numbers >= 7
*
*     update temperature variables which may have changed
      call tfidle
*
      alogne = log10( eden )
      tused = te
*
*-----------------------------------------------------------------------
*
*     NOCKON with effects of suprathermal electrons
*     nockon will evaluate ElecFrac
      call nockon
*
      if( lgTrace ) then
        write(qq,'(''   IONIZE called.  TE:'',1P,E9.3,''  HI:''
     1  ,E8.2,''  HII:'',E8.2,''  Ne:'',E9.3,''  CSUP:'',E8.2,
     1  ''  lgNewIon:'',L1,'' DoPhoto'',l1,''  ElecFrac:'',E9.2)')
     2  te, hi, hii,eden,csupra,lgNewIon,lgDoPhoto,ElecFrac
      end if
*
*     reevaluate gaunt factors and Boltzmann factors
      call boltgn
*
*     reevaluate all opacities if new ionization
*     >>chng 96 feb 29, see if this hurts
      if( lgDoPhoto ) call AddOpac(lgOK )
*     >>chng 96 may 16 turn back on
*     call AddOpac
*     update continuum
      call SumContinuum
*
*     hydrgn will set ionsun false if eden not converged
      call hydrgn( hlax , sechi )
*     nockon will update ElecFrac, sec efficiencies
      call nockon
*
*     electron density may have changed
      alogne = log10( eden )
*
*     evaluate Compton heating, bound E compton, cosmic rays
      call highen( seccmp , scmpla )
*
*     evaluate free-free heating rate
      call freeht
*
*     find corrections for three-body rec - collisional ionization
      call iiibod
*
      call helium( seche , helax )
*     this is only a sanity check
      call ChkSumCon(0)
*
*     find grain temperature, charge, and gas heating rate
      call grain
*
*-----------------------------------------------------------------------
*
*     these are sec ioniz, eval and incremented in BIDIAG, zero here
      secmet = 0.
      smetla = 0.
*     total cooling due to heavy element collisional ionization
      HeavIonCool = 0.
*
*     hetmet is total metal heating, will be incremented in BiDiag
*     which is called by each individual element
      hetmet = 0.
*
*     deduce dielctronic supression factors
      call DielSupres
*     fill in master charge transfer array
      call MakeCharTran
*     form sum of all continua
      call SumContinuum
*     this will be flag to check whether any ionization stages
*     were trimed down
      lgTrimed = .false.
*     zero out charge transfer rate array
      CTHion(1) = 0.
      CTHrec(1) = 0.
      chrener = 0.
*     do the ionization balance
      call lithi
      call beryli
      call boroni
      call carbon
      call oxygen
*     check whether oxygen ionization changed by much
      if( .not.lgConverg(8) ) then
        lgIonDone = .false.
        chInCvgRsn = 'Oxygen Ion'
      endif
      call codriv
      call nitrog
      call fluorinei
      call neon
      call sodium
      call magnes
      call alumin
      call silicn
      call phosi
      call sulphr
      call clrine
      call argoni
      calL potasi
      call calcm
      call scandi
      call titani
      call vanai
      call chromi
      call mangi
      call iron
*     >>chng 96 oct 11, added following test
*     check whether iron ionization changed by much
      if( .not.lgConverg(26) ) then
        lgIonDone = .false.
        chInCvgRsn = 'Iron Ioniz'
      endif
      call cobalt
      call nickel
      call coppi
      call zinci
*
*     turn photoionization rate evaluation if trimed down
      if( lgTrimed ) then
        lgDoPhoto = .true.
*       write(qq,'('' lgdophoto true ionize trim'')')
        lgNewIon = .true.
      endif
*
*     option to print OTS continuum with TRACE OTS
      if( lgTrace.and.lgOTSBug ) then
        call otsbg
      endif
*
*----------------------------------------------------------------------
*
*     update electron density
      EdenOld = eden
*     routine ESUM sets variable EdenTrue to true elec den
      call esum
*
*     following block is to not let electron density change by
*     too much
*     EdenError is set in block data, constant allowed error
*     the default value of EdenError is 0.01 in block data
*     EdenOld was incoming value of eden
*     EdenTrue is correct value from esum for current ionization
*     eden will be set using these, trying to prevent oscillations
      if( abs(EdenOld-EdenTrue)/min(EdenOld,EdenTrue).ge.EdenError) then
*       changed by too much, lets do it again
        lgIonDone = .false.
        chInCvgRsn = 'Ne big chg'
*       SEARCH is TRUE if this is only search for first solution
        if( lgSearch ) then
          if( lgTrConvg .and.nLevTrace.lt.2 ) then
            write(qq,'(5x,''ionize, chg1 ne from, to, dn'',1p,3e10.3)')
     1      EdenOld, 10.**( (log10(EdenOld) + log10(EdenTrue) ) / 2. )
          endif
          eden = 10.**( (log10(EdenOld) + log10(EdenTrue) ) / 2. )
        else
*
*         this is the proposed new electron density - is it too different?
          EdenProp = 10.**( (log10(EdenOld) + log10(EdenTrue) ) / 2. )
          EdenProp = EdenTrue
*
*         derive correction factor - how far from the solution are we?
          if( abs(1.-EdenTrue/EdenOld).gt.EdenError*CorrBig ) then
            factor = 1. + EdenError * CorrBig
          else
*           this will be a small change
            factor = 1. + EdenError * CorrSmall
          endif
*
*         get the new electron density
          if( EdenProp/EdenOld.gt.(1.+EdenError*0.5 ) ) then
*           this branch, proposed eden too big
            eden = min( EdenProp , EdenOld * factor )
            ip = 1
          else if( EdenProp/EdenOld.lt.(1.-EdenError*0.5) ) then
*           proposed eden too small
            eden = max( EdenProp , EdenOld / factor )
            ip = 2
          else
*           eden was within fac of the correct value, use it
            eden = EdenProp
            ip = 3
          endif
          if( (lgTrConvg.and.nLevTrace.lt.2).or.(lgTrace.and.lgNeBug))
     1      then
            write(qq,'(5x,''IONIZE, chg'',i1,'' ne to'',1p,e10.3,
     1      '' EdenOld'',e10.3,'' ratio'',e10.3,'' EdenProp'',e10.3,
     2      '' true='',e10.3)')
     1      ip, eden,  EdenOld, eden/EdenOld , EdenProp, EdenTrue
          endif
        endif
        if( eden.le.0. ) then
          write(qq,'('' Negative electron density in IONIZE.'')')
          call ShowMe
          stop
        endif
*       if( lgTrace)write(qq,'(''   IONIZE will not let Ne change by'',
*    1  '' too much, new Ne='',1P,E11.4,'' old was='',E11.4,
*    2  '' correct (computed in ESUM) is'',E11.4)') eden, EdenOld ,
*    3  EdenTrue
*       update temperature variables which may have changed
*       >>chng 96 oct 25 update eden related variables now
        call tfidle
      endif
*
*     get total heating rate
      HeatOld = htot
      call SumHeat
      if( HeatOld.gt.0. .and. .not.lgTSetOn ) then
*       check if heating has converged - toler is final match
        if( abs(1.-htot/HeatOld) .gt.toler*.5 ) then
          lgIonDone = .false.
          chInCvgRsn = 'Big d Heat'
        endif
      endif
*
*     find total suprathermal collisional ionization rate
*     CSUPRA is col ionize rate from all processes (inv sec)
*     X12 is LA excit rate, inv sec
*     SECCMP evaluated in HIGHEN, =ioniz rate for cosmic rays, sec bound
      if( nzone.lt.1 ) then
        nzSupra = -1
        secsav = csupra
        x12sav = x12
      endif
*     option to force secondary ionization rate, normally false
      if( lgCSetOn ) then
        csupra = SetCsupra
        x12 = SetCsupra
      else
*       >>chng 96 oct 29, eval continuously to stop oscillation between
*       two states deep in x-ray illuminated clouds
*     else if( nzone.ne.nzSupra ) then
*       each of following defined per unit neutral, except for SECMET
*       which is already mult by density of heavies
*       seche is set in helium and has densities
        secnew = seccmp + sechi*(hi+2.*htwo) + seche + secmet
*       CollidDensity is total neutral particle density
        secnew = secnew /  CollidDensity
        secnew = max( 0.,secnew )
*
        damper = 0.3
*       >>chng 96 may 13, try to damp out oscillations
        nzSupra = nzone
        nzSupra = -1
        csupra = secnew * damper + secsav*(1.-damper)
        secsav = csupra
*       now do same for Ly-alpha
        x12new = (scmpla + hlax*(hi+2.*htwo) +
     1   helax + smetla) / CollidDensity
           x12 = x12new * damper + x12sav*(1.-damper)
        x12sav = x12
      endif
*
      if( lgTrace .and. csupra.gt.0. ) then
        if( secnew.gt.0. ) then
          write(qq,'(''   IONIZE, CSUPRA='',1P,E10.3,'' fracHI'',
     1    E9.2,'' He'',E9.2,'' met'',E9.2,'' com'',E9.2,
     1    '' sec/H-phot'',E9.2,'' X12/COL12'',E9.2)')
     1    csupra ,
     2    sechi * (hi+2.*htwo)/CollidDensity /secnew ,
     3    seche/CollidDensity /secnew ,
     4    secmet/CollidDensity /secnew ,
     5    seccmp /CollidDensity /secnew ,
     6    csupra/max(1e-34,hgamnc(1)) , x12/max(1e-34,hgdist)
        else
          write(qq,'(''   IONIZE, CSUPRA, SECNEW was zero.'')')
        endif
      endif
*
      if( lgTrace .and. csupra.ne.0. ) then
         write(qq,'(''   IONIZE retrn CSUPRA'',1P,E9.2,'' SECCMP'',E9.2,
     1  '' SECHI'',E9.2,'' SECHE'',E9.2,'' SECMET'',E9.2,'' SECSAV'',
     2  E9.2,'' X12'',E9.2)') csupra,seccmp,sechi,seche,secmet,secsav,
     3  x12
*
      else if( lgTrace ) then
        write(qq,'(''   IONIZE retrn, HI:'',1P,E10.3,''  HII:'',
     1  E10.3,''  EDEN:'',E10.3,'' HTOT:'',e10.3,'' lgIonDone='',L3)')
     1  hi, hii, eden,htot,lgIonDone
      endif
*
      end
*********************************************************
      subroutine MakeCharTran
      implicit none
*fill in the HCharExcIon and Rec arrays with Kingdon's fitted CT with H
      integer limelm
      parameter (limelm=30)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real HCharExcIon(limelm,limelm) , HCharExcRec(limelm,limelm)
*     ion, nelem
*     these arrays save the charge transfer ionization and recom
*     rates for the heavy elements onto hydrogen.  ionization is
*     of the heavy element, and so is a recom for hydrogen
      common/CharExc/ HCharExcIon , HCharExcRec
*
*     local variables
      integer nelem, ion
      real TeUsed , HCTIon , HCTRecom
      save TeUsed
      data TeUsed/-1./
*
      if( abs(te-TeUsed) / te .gt.0.01 ) then
*       refresh charge transfer arrays is temperature has changed
        do nelem=3,limelm
          do ion=1,nelem
            HCharExcIon(ion,nelem) = HCTIon(ion,nelem)
            HCharExcRec(ion,nelem) = HCTRecom(ion,nelem)
          end do
        end do
        TeUsed = te
      endif
*
      end
******************************************************************************
      subroutine ionte( nThLoop , nCall )
      implicit none
*determine ionization and temperature, called by PIonte
*     nCall tells routine which call this is, 0 for first one, not changed here
*     nThLoop controlled here, indicates how many loops performed
      integer nThLoop , nCall
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real thist , tlowst
      common/tehigh/ thist , tlowst
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      integer iontot
      common/iontot/ iontot
*     include "MapPar.com"
      real hi , hii
      common/h/ hi , hii
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real htus , he1tus , he2tus, he3tus
      common/tusedcom/ htus , he1tus , he2tus, he3tus
      logical lgHColionImp
*     flag saying whether H atom is photo=false or collis ionized=true
      common/colion/ lgHColionImp
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real te , eden , hden
      common/phycon/ te , eden , hden
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real toler
*     allowed error in heating - cooling balance, set with TOLERANCE command
*     default set in zerologic
      common/toler/ toler
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      integer nUnstable
      logical lgUnstable
*keep track of possibly thermall unstagle models
*nUnstable is number of zones that were possibly thermall unstable
*lgUnstable is set in ionte and says that current consitions possibly unstable
      common/nustbl/ nUnstable , lgUnstable
      logical lgdCNeg
*flag saying if derivative of cooling is negative
      common/dcneg/ lgdCNeg
*     this says whether temp or C-H deriv is changing sign
      logical lgCmHOsc , lgTOscl
*     this is deriv of cooling minus heating wft temp
      double precision dCoolmHeatdT
      common/dCmHdT/ dCoolmHeatdT , lgCmHOsc , lgTOscl
      real dTemper
*change in temperature
      common/dtemp/ dTemper
      logical lgTeFail
*set true in IONTE if heating - cooling failure
      common/tfail/ lgTeFail
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      character*10 chInCvgRsn
      common/InCvgRsn/ chInCvgRsn
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      logical lgTrimed
      common/Trimed/ lgTrimed
      logical lgHColRec , lgHCoolng
      common/HColRec/ lgHColRec , lgHCoolng
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
      real fcool , dfcool , feheat
*     cooling computed by Katya's FeII model atom
*     fcool is total cooling (or heating if negative)
*     and dfcool is its derivative
*     holod is Russian for cold
      common/holod/ fcool , dfcool , feheat
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer limtry , limdef
*     this is default limit to number of iterations
      parameter (limdef=10)
      real dtl , dtsave , Damper
      real fneut,DCoolngDT,DerivNumer , OldCmHdT,
     1 CoolMHeat
      save OldCmHdT
      character chDEType*1 , chdTCap
      data OldCmHdT/0./
*
*     free statement label =>4
*
      if( lgTrace ) write(qq,'(/'' ionte called'')')
*
*     main routine to find ionization and temperature
*     following is flag to check for temp oscillations
*     it could be set true in main temp loop
      lgTOscl = .false.
*     scale factor for changes in temp - make smaller if oscillations
      Damper = 1.
*     flag for d(cool - heat)/dT changing sign, an internal error
*     >>chng 97 Sep 3, only turn false one time, remains true if ever true
      if( nzone.lt.1 ) lgCmHOsc = .false.
      call MakeDeriv('zero',0.,0.,DerivNumer)
*     this is will initial limit to number of tries at temp
      limtry = limdef
*     used to keep track of sign of dt, to check for oscillations
      dtl = 0.
*
*     this counts how may thermal loops we go through
*     used in calling routine to make sure that at least
*     two solutions are performed
      nThLoop = 0
*     this flag says evaluate photo rates and opacity each time,
*     will do this first convergence of ionization, but not after
      if(nCall.eq.0.)then
        lgDoPhoto = .true.
*       tell it to do whole new ionization solution
        lgNewIon = .true.
*       write(qq,'('' ionte lgdophoto true init'')')
      endif
*     this is the heating-cooling match loop
      do while (nThLoop.lt.limtry )
        if( lgTrConvg ) then
          write(qq,'(''   ionte enter heating cooling loop'',I4,'' Te:''
     1    ,1P,E11.4,'' Htot:'',E11.4,'' Ctot:'',E11.4,'' eden:'',e10.3)'
     1    ) nThLoop,te, htot,ctot,eden
        endif
*       converge the ionization; this calls ionize until lgIonDone is true
        call ConvIoniz
*       check on neutral fracs
        if( lgTrimed ) then
*         this means an heavy element has had its ionization stages
*         trimed down - must redo all rates
          lgNewIon = .true.
          lgDoPhoto = .true.
*         write(qq,'('' lgDoPhoto true ionte something trimed'')')
*       else if( eden/hden.lt.0.95 .and.eden/hden.gt.0.05 ) then
*         not safe to not redo ionization when near i-front or neutral zone
*         when secondary ionization is important
*         lgNewIon = .true.
*         lgDoPhoto = .true.
*         write(qq,'('' lgDoPhoto true ionte near -ifront'')')
        else
*         dont redo photoionization rates
          lgNewIon = .false.
          lgDoPhoto = .false.
*         write(qq,'('' lgDoPhoto false ionte '')')
        endif
        if( htot.lt.0. ) then
          write(qq,'('' Total heating is <0; is this model ''
     1    ,''collisionally ionized?'')')
        else if( htot.eq.0. ) then
          write(qq,'('' Total heating is 0; is the density small?'')')
        endif
        fneut = (hi+2.*htwo) / hden
*
*       now find total cooling
        call coolr( ctot , DCoolngDT )
*
*       remember this temp, heating, and cooling
        call PutHetCol( te , htot , ctot )
*
        if( DCoolngDT.lt.0. ) then
          lgdCNeg = .true.
        else
          lgdCNeg = .false.
        endif
        iontot = iontot + 1
        nThLoop = nThLoop + 1
*
        if( lgTSetOn ) then
*         constant temp - declare this a success
          CoolMHeat = 0.
        else
*         we will try to make the following zero
          CoolMHeat = ctot - htot
        endif
*
*       get numerical derivative, but we may not use it
        call MakeDeriv('incr',ctot-htot ,te ,DerivNumer)
*
*       save old deriv to check for oscillations
        if( nzone.lt.1 ) then
*         >>chng 96 june 7, was set to dCoolmHeatdT, is not defined initially
          OldCmHdT = ctot / te
        endif
*
        if( (te.lt.1e4.and.DCoolngDT.lt.0.) ) then
*         use numerical guess, HTOT nearly equal to CTOT, drive Te lower
*         this is to overcome thermal inflection points
          dCoolmHeatdT = dble(htot) / te * 2.
          chDEType = 'd'
        else
*         >>chng 97 mar 18, all below growth code just did the following
          dCoolmHeatdT = DCoolngDT - dHTotDT
          chDEType = 'a'
        endif
*       else if( nthLoop.lt.3 ) then
*         use computed derivative, including change in heating
*         two implic neg signs in following heat deriv
*         if( abs(dHTotDT).lt.0.3*abs(DCoolngDT) ) then
*           dCoolmHeatdT = DCoolngDT - dHTotDT
*           chDEType = 'a'
*         else
*           SIGN: sign of sec arg and abs val of first
*           dCoolmHeatdT = DCoolngDT - sign( abs(DCoolngDT)*0.3 , DHTotDT )
*           dCoolmHeatdT = DCoolngDT - DHTotDT
*           chDEType = 'c'
*         endif
*       else
*         if( abs(dHTotDT).lt.0.3*abs(DCoolngDT) ) then
*           dCoolmHeatdT = DCoolngDT - dHTotDT
*           chDEType = 'a'
*         else
*           SIGN: sign of sec arg and abs val of first
*           dCoolmHeatdT = DCoolngDT - sign( abs(DCoolngDT)*0.3 , DHTotDT )
*           dCoolmHeatdT = DCoolngDT - DHTotDT
*           chDEType = 'c'
*         endif
*       endif
*
*       >>chng 96 Aug 15, alphas with fast compile underflow at low densities
        if( dCoolmHeatdT.eq.0. ) then
          chDEType = 'z'
          dCoolmHeatdT = ctot / te
          if( dCoolmHeatdT.eq.0. .and.ctot.eq.0. ) then
            write(qq,'('' ionte the cooling and its derivitive '',
     1      ''are zero.'')')
            write(qq,'('' ionte I cannot perform the energy '',
     1      ''balance.'')')
            if( hden.le.1e-3 .and. lgBit32) write(qq,'('' Due to '',
     1      ''very low density on a 32-big cpu?'')')
            call ShowMe
            stop
          else if( dCoolmHeatdT.eq.0. .and. ctot.ne.0. ) then
            write(qq,'('' ionte the cooling derivitive '',
     1      ''is zero.'')')
            write(qq,'('' ionte I cannot perform the energy '',
     1      ''balance.'')')
            if( hden.le.1e-3 .and. lgBit32) write(qq,'('' Due to '',
     1      ''very low density on a 32-big cpu?'')')
            call ShowMe
            stop
          endif
        endif
*
*       check whether deriv changing sign - an internal error or
*       numerical instability
        if( OldCmHdT*dCoolmHeatdT.lt.0. ) lgCmHOsc = .true.
        OldCmHdT = dCoolmHeatdT
*
*       derivative can change sign when heating and cooling balance,
*       and processes have exactly same temp dependence
*       happened in mods of ism.in test
*       >>chng 97 sep 02, added following test for oscillating derivs
        if( lgCmHOsc ) then
          dCoolmHeatdT = ctot / te
          chDEType = 'o'
        endif
*
*       required change in temperature, this may be too large
        dTemper = CoolMHeat / dCoolmHeatdT
*       try to stop numerical oscillation if dTemper is changing sign
        if( dtl*dTemper .lt. 0.) then
          lgTOscl = .true.
*         make DT smaller and smaller
          Damper = Damper * 0.5
        endif
*
*       save temp so we can check if it is capped
        dtsave = dTemper
*
*       SIGN: sign of sec arg and abs val of first
*       >>chng 96 nov 8, from 0.1 to 0.08 in fneut
        if( fneut.gt.0.08 .and. lgHColionImp ) then
*         lgHColionImp is true if model collisionally ionized
*         dont let TE change by too much if lgHColionImp is set by HLEVEL
          dTemper = sign( min( abs(dTemper),0.005*te ) , dTemper )
        else if( nThLoop.gt.5.and. .not.lgTOscl ) then
*         need several changes but te not oscillating, increase dT
          dTemper = sign( min( abs(dTemper),0.06*te ) , dTemper )
        else if( nThLoop.gt.3.and. .not.lgTOscl ) then
*         need several changes but te not oscillating, increase dT
          dTemper = sign( min( abs(dTemper),0.04*te ) , dTemper )
        else
*         do not let temp change by more than 2 percent
          dTemper = sign( min( abs(dTemper),0.02*te ) , dTemper )
        endif
*
*       check if model in collisional recombination equilibirum
*       if so then small change in temp causees big change in equilibrium
*       lgHColRec set in hlevel, only true is totl rec >> rad rec
        if( lgHColRec ) then
          if( lgHCoolng) then
            if( lgTOscl ) then
              dTemper = sign( min( abs(dTemper),0.002*te ) , dTemper )
            else
*             not oscillating
              dTemper = sign( min( abs(dTemper),0.005*te ) , dTemper )
            endif
          else
            dTemper = sign( min( abs(dTemper),0.01*te ) , dTemper )
          endif
        endif
*
        dTemper = dTemper * Damper
        dtl = dTemper
*       THIS IS IT!!! this is the place where te changes.
        te = te - dTemper
*
*       if te falls below 3K quit now
        if( te.le.3. ) then
*         these will force all routines out to quit
*         when lowest temp read in values below 3 were not allowed
          te = 2.9998
          CoolMHeat = 0.
          lgIonDone = .true.
        endif
        if( lgTrConvg ) then
*         this is flag to say if te change is capped
          if( dTemper.eq.dtsave ) then
            chdTCap = ' '
          else
            chdTCap = 'c'
          endif
          write(qq,'(''   ionte chgTE'',1P,e8.2,'' dt:'',a1,
     1    E8.1,'' C:'',e9.2,'' H:'',e9.2,'' CoolMHeat:'',E9.2,0p,
     2    f7.1,1p,''% dCoolmHeatdT'',a1,E9.2,'' dCdT'',e9.2,
     3    '' dHdT'',e9.2,l2)')
     3    te,chdTCap,dTemper, ctot,htot,CoolMHeat,CoolMHeat/htot*100.,
     3    chDEType,  dCoolmHeatdT, DCoolngDT , dHTotDT, lgCmHOsc
*         dCoolmHeatdT is the actual number used for getting dT
*         DCoolngDT is just cooling
        endif
*
        if( lgTrace ) write(qq,'('' ionte TE:'',1P,E11.5,'' dT'',E10.3
     1  ,'' HTOT:'',E11.5,'' CTOT:'',E11.5,'' dCoolmHeatdT:'',a1,E11.4,
     2  '' C-H'',E11.4,'' lgHColionImp:'',L1,'' HDEN'',E9.2)')
     3   te,dTemper,htot,ctot,chDEType,dCoolmHeatdT,CoolMHeat,
     4   lgHColionImp,hden
*
*       lgIonDone = true if ionization routines got OK solution
*       lgIonDone = false if problems
*       TOLER can be set in READR, normally=0.02
        if( abs(CoolMHeat/(htot+feheat)).lt.toler .and. lgIonDone ) then
          if( lgTrace ) write(qq,'('' ionte returns ok.'')')
          thist = max( te , thist )
          tlowst = min( te , tlowst )
*         test for thermal stability
*         >>chng 97 jul 31, set flag if unstable, increment only once per zone
*         if( lgdCNeg ) nustbl = nustbl + 1
          if( lgdCNeg ) then
            lgUnstable = .true.
          else
            lgUnstable = .false.
          endif
          lgTeFail = .false.
          if( lgTrConvg ) then
            write(qq,'(''   IONTE heating cooling loop converged. Te:'',
     1      1P,E11.4,'' Htot:'',E11.4,'' Ctot:'',E11.4,'' error:'',
     2      e9.1,''%, eden='',e11.4)') te,htot,ctot,
     3      (htot-ctot)*100./max(1e-36,htot), eden
          endif
          return
        endif
*       this is option to increase limit to number of iterations
*       if the solution is not oscillating
*       nThLoop is number of times through heating-cooling-ionization loop
        if( nThLoop.eq.limdef .and. .not.lgTOscl ) then
*         limdef is set to 10 in a data statement above
*         >>chng 97 aug 10, from 2 to 4 to let keep going when not oscillation
*         this helped in getting over huge jumpts in temperature at metal fronts
          limtry = limdef * 4
          if(lgTrConvg)write(qq,'(''   IONTE increases limtry to'',i3)')
     1    limtry
        endif
      end do
*
*     no temperature convergence
      lgTeFail = .true.
*
      end
******************************************************************************
      subroutine ionzer(nelem)
      implicit none
*zero out heating and charge transfer save arrays
      integer nelem
*
      integer limelm
      parameter (limelm=30)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
*
*     local variables
      integer i
*
*     heating array
      do i=1,nelem
        heating(nelem,i) = 0.
      end do
*     zero out ionization balance arrays
      do i=1,limelm
        CTHeavy(i,1) = 0.
        CTHeavy(i,2) = 0.
      end do
*
      end
******************************************************************************
      integer function ipConSafe( energy , chLabel )
      implicit none
*generate unique pointer to energy within continuum array
*     continuum energy in Rydbergs
      real energy
*     4 char label for continuum, like those returned by chLineLbl
      character chLabel*4
*
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real FluxSave
*save incident continuum for later iterations
      common/flxsav/ FluxSave(ncell)
*rememeber the largest offset needed for ipSafe, and the energy where it occured
      integer nMaxSafe
      real EnergySafe
      common/MaxSafe/ nMaxSafe , EnergySafe
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
*
*     function to set pointer to cont energy confirming no overlap
*     NB!!!
*     this will only work if the FluxSave array has previously been zeroed out
*     at the start of routine DoPoint
*
*     local variables
      integer ipoint , iOffSet , limit , i
      data limit/60/
*
      ipConSafe = ipoint( energy )
      if( FluxSave(ipConSafe).gt.0. ) then
*       there already is something at the correct energy
        do iOffSet = 1,limit
*begin sanity check
          if( ipConSafe-iOffSet.le.0 ) then
            write(qq,'('' ipConSafe: ipConSafe-iOffset lt 0'')')
            call ShowMe
            stop
          endif
          if( ipConSafe+iOffSet.gt.ncell ) then
            write(qq,'('' ipConSafe: ipConSafe+iOffset gt ncell'')')
            call ShowMe
            stop
          endif
*end sanity check
          if( FluxSave(ipConSafe+iOffSet).eq.0. ) then
*     >>chng 96 feb 17, was neg offset first, change to pos so heii 911
*           is higher energy than H
            ipConSafe = ipConSafe + iOffSet
            FluxSave(ipConSafe) = FluxSave(ipConSafe) + 1
            chContLabel(ipConSafe) = chLabel
            nMaxSafe = max( iOffSet , nMaxSafe )
            EnergySafe = anu(ipConSafe)
            return
          else if( FluxSave(ipConSafe-iOffSet).eq.0. ) then
            ipConSafe = ipConSafe - iOffSet
            FluxSave(ipConSafe) = FluxSave(ipConSafe) + 1
            chContLabel(ipConSafe) = chLabel
            nMaxSafe = max( iOffSet , nMaxSafe )
            EnergySafe = anu(ipConSafe)
            return
          endif
        end do
        write(qq,'('' ipConSafe needs too large an offset. Problems??'',
     1  1x,a4)') chLabel
        write(qq,'('' ipConSafe: Cont energy='',1p,e10.3,'' Ryd.'')')
     1  energy
        write(qq,'('' ipConSafe: range'',1p,2e10.3,'' Ryd.'')')
     1  anu(ipConSafe-limit),anu(ipConSafe+limit)
        do i=ipConSafe-limit,ipConSafe+limit
          write(qq,'(i4,1p,e11.3,a4)') i,anu(i),chContLabel(i)
        end do
        stop
      endif
*
      FluxSave(ipConSafe) = FluxSave(ipConSafe) + 1
      chContLabel(ipConSafe) = chLabel
*
      end
******************************************************************************
      integer function ipLinSafe( energy , chLabel )
      implicit none
*generate unique pointer to line energy within energy mesh
*     line energy in Rydbergs
      real energy
*     4 char label for  line, like those returned by chLineLbl
      character chLabel*4
*
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
*rememeber the largest offset needed for ipSafe, and the energy where it occured
      integer nMaxSafe
      real EnergySafe
      common/MaxSafe/ nMaxSafe , EnergySafe
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     function to set pointer to line energy confirming no overlap
*     NB!!!
*     this will only work if the flux array has previously been zeroed out
*     at the start of routine DoPoint
*
*     local variables
      integer ipoint , iOffSet , limit
      data limit/60/
*
      ipLinSafe = ipoint( energy )
      if( flux(ipLinSafe).gt.0. ) then
        do iOffSet = 1,limit
*begin sanity check
          if( ipLinSafe-iOffSet.le.0 ) then
            write(qq,'('' ipLinSafe: ipLinSafe-iOffset lt 0'')')
            call ShowMe
            stop
          endif
          if( ipLinSafe+iOffSet.gt.ncell ) then
            write(qq,'('' ipLinSafe: ipLinSafe+iOffset gt ncell'')')
            call ShowMe
            stop
          endif
*end sanity check
          if( flux(ipLinSafe-iOffSet).eq.0. ) then
            ipLinSafe = ipLinSafe - iOffSet
            flux(ipLinSafe) = flux(ipLinSafe) + 1
            chLineLabel(ipLinSafe) = chLabel
            nMaxSafe = max( iOffSet , nMaxSafe )
            EnergySafe = anu(ipLinSafe)
            return
          else if( flux(ipLinSafe+iOffSet).eq.0. ) then
            ipLinSafe = ipLinSafe + iOffSet
            flux(ipLinSafe) = flux(ipLinSafe) + 1
            chLineLabel(ipLinSafe) = chLabel
            nMaxSafe = max( iOffSet , nMaxSafe )
            EnergySafe = anu(ipLinSafe)
            return
          endif
        end do
        write(qq,'('' ipLinSafe needs too large an offset. Problems??'')
     1  ')
        write(qq,'('' ipLinSafe: Line energy='',1p,e10.3,'' Ryd.'')')
     1  energy
        write(qq,'('' ipLinSafe: range'',1p,2e10.3,'' Ryd.'')')
     1  anu(ipLinSafe-limit),anu(ipLinSafe+limit)
        stop
      endif
*
      flux(ipLinSafe) = flux(ipLinSafe) + 1
      chLineLabel(ipLinSafe) = chLabel
*
      end
******************************************************************************
      integer function ipoint( freq )
      implicit none
*returns pointer to any energy within energy mesh
      real freq
      integer nfill
      parameter (nfill=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real filbnd,fildel,filres
      integer ifill0 , nrange
      common/fillnu/ filbnd(nfill+1),fildel(nfill),filres(nfill),
     1 ifill0(nfill) , nrange
      real ZeroNum
*this is the number zero, used to trick clever compilers when
*dividing by it to crash program
*there is a routine called zero - this name cannot overlap
      common/zero0/ ZeroNum
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      integer i
*
      if( freq.lt.filbnd(1) .or. freq.gt.filbnd(nrange+1) ) then
        write(qq,'('' ipoint:'')')
        write(qq,'('' The freq array is not defined at nu='',1P,E10.3,
     1  ''. The bounds are'',2E10.3)') freq,filbnd(1),filbnd(nrange+1)
        write(qq,'('' divide by 0 to get trace'')')
        ipoint = 1. / ZeroNum
        stop
      endif
*
      do i=1,nrange
        if( freq.ge.filbnd(i).and.freq.le.filbnd(i+1) ) then
          ipoint = log10( freq / filbnd(i) ) / fildel(i) + 1.0 +
     1    ifill0(i)
          return
        endif
      end do
      write(qq,'('' IPOINT logic error, energy was'',1p,e11.3)') freq
*
      stop
      end
      subroutine ipShells( nelem )
      implicit none
*assign continuum energy pointers to shells for all atoms
      integer nelem
*
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      real PH1
*     ph1(a,b,c,d)
*     a=1 => thresh, others fitting parameters
*     b atomic number
*     c number of electrons
*     d shell number 7-1
      common/PH1/ PH1(6,30,30,7)
      logical lgPointBug
*flag set with trace pointers command
      common/pntbug/ lgPointBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
*     include "Valence.com"
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      integer KshellLimit
      real EnergyKshell
      common/KshllEnr/ KshellLimit , EnergyKshell
      character chIonStage*4
      common/IonStage/ chIonStage(limelm+1)
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
      character chShell(7)*2
*character representation of shells 1 to 7 of atoms and ions, '1s', '2s', etc
      common/Shell/ chShell
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chLab*4
      integer ion , nelec,nshell,imax,ig0,ig1,ipoint,LimitSh,ns,
     1 ipConSafe , ipLinSafe
      real thresh
      integer nnuc
      parameter (nnuc=30)
*     character chShell(7)*2
*     remember data last
*     data chShell/'1s', '2s', '2p', '3s', '3p', '3d', '4s'/
*
*     fills in pointers to valence shell ionization threshold
*     ip(nelem) is array of pointers
*     nelem is element number
*     PH1(a,b,c,d)
*     a=1 => thresh, others fitting parameters
*     b atomic number
*     c number of electrons
*     d shell number 7-1
*
*     check within array bounds
      if( nelem.gt.nnuc ) then
        write(qq,*)' ipshell called with too large an element number'
        stop
      endif
*
*     threshold in Ryd
*     ion=1 for atom, up to nelem for hydrogenic
      do ion=1,nelem
*       number of bound electrons
        nelec = nelem - ion + 1
        call outer(nelem,nelec,imax,ig0,ig1)
*       subroutine outer(iz,in,imax,ig0,ig1)
*       iz - atomic number from 1 to 30 (integer)
*       in - number of electrons from 1 to iz (integer)
*       Output: imax - number of the outer shell
*
*       nsShells(nelem,ion) is outer shell number for ion with nelec electrons
        nsShells(nelem,ion) = imax
*       loop on all inner shells, valence shell
        do nshell=1,imax
          thresh = PH1(1,nelem,nelec,nshell) / evryd
          if( thresh.le.0.1 ) then
*           negative ip shell does not exist, set upper limit
*           to less than lower limit so this never looped upon
*           these are used as flags by LimitSh to check whether
*           this is a real shell - if 1 or 2 is changed - change LimitSh!!
            ipElement(nelem,ion,nshell,1) = 2
            ipElement(nelem,ion,nshell,2) = 1
          else
*           this is lower limit to range
            ipElement(nelem,ion,nshell,1) = ipoint( thresh )
*           this is upper limit to range
*           LimitSh is an integer function, returns pointer
*           to threshold of next major shell.  For k-shell it
*           returns the values KshellLimit, default=7.35e4
*           >>chng 96 sep 26, had been below, result zero cross sec at
*           many energies where opacity project did not produce broken
*           out cross section
            ipElement(nelem,ion,nshell,2) = LimitSh( ion ,
     1      nshell , nelem )
          endif
        end do
*       this is valence pointer
*       generate label for ionization stage
        chLab(1:2) = chElementSym(nelem)
        chLab(3:4) = chIonStage(ion)
        ipElement(nelem,ion,imax,1) = ipConSafe( thresh , chLab )
*       pointer to valence electron ionization potential
*       ipValence(nelem,ion) = ipElement(nelem,ion,imax,1)
*       write(66,'(1p,6e11.3)') thresh
*       write(66,'(a4,1p,6e11.3)') chLab,thresh,anu(ipVal(ion)),
*    1  anu( ipElem(ion,imax,1) ) , (anu(ipVal(ion))-thresh)/thresh
        ipHeavy(nelem,ion) = ipElement(nelem,ion,imax,1)
*       this is set of 3/4 of valence shell IP, this is important
*       source of ots deep in cloud
        ipLyHeavy(nelem,ion) = ipLinSafe( thresh *0.75 ,chLab )
      end do
*
*     this is for backwards compatability with cambridge code
*
      if(lgTrace.and.lgPointBug ) then
        do ion=1,nelem
          write(qq,'(''Ion:'',2i3,1x,2a2,'' total shells:'',i3)')
     1    nelem,ion,chElementSym(nelem), chIonStage(ion),
     2    nsShells(nelem,ion)
          do ns=1,nsShells(nelem,ion)
            write(qq,'('' shell'',i3,1p,1x,a2,
     1      '' range eV'',10(e9.2,''-'',e8.2))')
     2      ns, chShell(ns),
     1      anu(ipElement(nelem,ion,ns,1))*evryd,
     2      anu(ipElement(nelem,ion,ns,2))*evryd
          end do
        end do
      endif
*
      end
******************************************************************************
      subroutine iron
      implicit none
*ionization balance for iron
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     fekhot, fekcld, number of photons in hot and cold iron, per unit vol
*     ipkhot, ipkcld are pointers to energies
      real fekhot , fekcld
      integer ipkhot , ipkcld
      common/fekems/ fekhot , fekcld , ipkhot , ipkcld
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      logical lgFeBug
*flag set with trace iron bug
      common/febug/ lgFeBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      real vyield
      integer nyield
*     block data of yields from Mewe paper
*     vyield( nelem, nstage, nshell, nelec )
*     nelem is element number, 6 for carbon
*     nstage is stage of ionization, 1 for atom
*     nshell is shell number in dima notation
*     nelec is fraction that yield that number of electrons
**    nyield is number of electrons at most
      common/yield/ vyield(30,30,7,10), nyield(30,30,7)
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
*recombination rates for the elements
*first dim is nelem, the atomic number of element
*secnd dim is stage of ionizaiton, 1 for atom
      real RecombinRate(limelm,limelm)
      common/RecomRate/ RecombinRate
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=27)
      parameter (nelem=26)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2) ,
     3 fyield(27) , DieRate
*     real GRDEFF(26)
*
*     iron nelem=26
*
*     real CollidRate(nelem,2)
*
*     REAL yYIELD(24) , yYIELDL(16)
*     DATA yYIELD/24*0./ , yYIELDL/16*0./
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.26E-10,4.97E-11,1.49E-10,3.90E-11,1.66E-11,7.16E-12,
     1 3.00E-12,1.02E-12,2.54E-12,1.70E-12,1.11E-12,6.42E-13,3.59E-13,
     2 9.30E-14,1.62E-14,5.97E-14,8.44E-14,5.92E-14,4.72E-14,3.79E-14,
     3 2.60E-14,1.61E-14,1.16E-14,5.39E-15,5.67E-16,2.57E-16/
      data (cion(i,2),i=1,ndim-1)
     1 /9.13E4,1.88E5,3.56E5,6.36E5,8.70E5,1.15E6,1.45E6,1.75E6,
     2 2.73E6,3.04E6,3.37E6,3.84E6,4.19E6,4.55E6,5.30E6,5.68E6,
     3 1.47E7,1.58E7,1.69E7,1.84E7,1.96E7,2.09E7,2.26E7,2.35E7,
     4 1.02E8,1.08E8/
*
      data fyield/2*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
     4.45,.46,2*.47,2*.48,2*.49, .11,.75,3*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/26*0.2/
*
*     Fe rates from Woods et al. Ap.J. 249, 399.
*     rec from +23, 24 25 from Arnauld et al 85
      data rec,pl
     1/ 5.2E-10 , 2.40E-9 , 3.20E-9 , 4.17E-9 , 9.44E-9 , 2.14E-8
     2, 4.48E-8 , 8.75E-8 , 1.41E-7 , 2.26E-7 , 2.73E-7 , 3.56E-7
     3, 4.42E-7 , 5.52E-7 , 7.00E-7 , 8.59E-7 , 8.55E-7 , 8.93E-7
     4, 9.64E-7 , 1.06E-6 , 1.19E-6 , 1.22E-6 , 2.94E-6 , 5.00E-6
     5, 1.97E-6
     1, -0.891  , -0.843  , -0.746  , -0.682  , -0.699  , -0.728
     2, -0.759  , -0.790  , -0.810  , -0.829  , -0.828  , -0.834
     3, -0.836  , -0.840  , -0.846  , -0.850  , -0.836  , -0.824
     4, -0.816  , -0.811  , -0.808  , -0.800  , -0.852  , -0.875
     5, -0.787  /
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.28e-10 , -0.686 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.58E-3  , 8.38E-3  , 1.54E-2, 3.75E-2, 0.117   , 0.254
     2, 0.291   , 0.150   , 0.140   , 0.100   , 0.200   , 0.240
     3, 0.260   , 0.190   , 0.120   , 0.350   , 0.066   , 0.10
     4, 0.13    , 0.23    , 0.14    , 0.11    , 0.041   , 0.747
     5, 0.519    , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/ .456    , .323    , .310    , .411    , .359    , .0975
     1, .229    , 4.20    , 3.30    , 5.30    , 1.50    , 0.700
     1, .600    , .5      , 1.      , 0.      , 7.8     , 6.3
     1, 5.5     , 3.6     , 4.9     , 1.6     , 4.2     , .284
     1,.279     , 0./
      data (dite(i,1),i=1,ndim-1)
     1/ 6.00E4  , 1.94E5  , 3.31E5  , 4.32E5  , 6.28E5  , 7.50E5
     2, 7.73E5  , 2.62E5  , 2.50E5  , 2.57E5  , 2.84E5  , 8.69E5
     3, 4.21E5  , 4.57E5  , 2.85E5  , 8.18E5  , 1.51E6  , 1.30E6
     4, 1.19E6  , 1.09E6  , 9.62E5  , 7.23E5  , 4.23E5  , 5.84E7
     5, 6.01E7  , 0./
      data (dite(i,2),i=1,ndim-1)
     1/8.97E4   , 1.71E5  , 2.73E5  , 3.49E5  , 5.29E5  , 4.69E5
     2,6.54E5   , 1.32E6  , 1.33E6  , 1.41E6  , 1.52E6  , 1.51E6
     3,1.82E6   , 1.84E6  , 2.31E6  , 0.      , 9.98E6  , 9.98E6
     4,1.00E7   , 1.10E7  , 8.34E6  , 1.01E7  , 1.07E7  , 1.17E7
     5,9.97E6   , 0./
*     DATA DITCRT
*    1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
*    2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
*    3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
*    4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4     , 6E6
*    5, 6E6     , 1E20    /
*     following tricks makerecom into not evaluating burgess process
      data ditcrt/nelem*1e11/
      data aa/26*0./,bb/26*0./,cc/26*0./,dd/26*0./,ff/26*0.01/
*
*     free statement numbers >= 7
*
*     iron, atomic number 26
      if( .not.lgElmtOn(26) ) then
        fekcld = 0.
        fekhot = 0.
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     call PrtGamma(ipElement(nelem,9,5,1) ,ipElement(26,9,5,2) ,
*    1 ipElement(nelem,9,5,3),
*    1 6,  PhotoRate(nelem,9,5,1) ,PhotoRate(nelem,9,5,1)*0.05 )
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     add on special dima diel coef
      do i=IonLow(nelem),IonHigh(nelem)-1
        call drfe(i,te,DieRate)
        RecombinRate(nelem,i) = RecombinRate(nelem,i) + DieRate*eden
      end do
*
*     Fe+3 + H => Fe+2
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(3,2) = CTHeavy(3,2) + 1.78E-11*SQRTE*TE10/TE03*HI
*     following rates from
*     >>refer Neufeld, D.A., and Dalgarno, A., Phys Rev A  35, p3142.
*     ct ionization Fe+ + H+ => Fe++ + H
*     CTHeavy(2,1) = CTHeavy(2,1) + 2.3E-9 * SEXP(30054./TE) * HII
*     Fe+2 + H => Fe+ + H+
*     CTHeavy(2,2) = CTHeavy(2,2) + 4.14E-10*TE10*TE01*TE01*HI
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
*     now find total Auger yield of K-alphas
*     "cold" iron has M-shell electrons, up to Fe 18
      fekcld = 0.
      do i=IonLow(nelem),min(18,IonHigh(nelem)-1)
        fekcld = fekcld + PhotoRate(nelem,i,1,1) * xIonFracs(nelem,i)*
     1  fyield(i)
      end do
*
*     same sum for hot iron
      fekhot = 0.
      do i=max(19,IonLow(nelem)),min(nelem,IonHigh(nelem)-1)
        fekhot = fekhot + PhotoRate(nelem,i,1,1) * xIonFracs(nelem,i)*
     1  fyield(i)
      end do
*
      if( lgTrace .and.lgHeavyBug ) then
        write(qq,'(5X,''Fe'',1P,15E8.1)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,15)
      endif
*
      if(lgTrace.and.lgFeBug) then
        write(qq,'('' IRON-Abund:'',1P,13E9.2/3X,14E9.2)')
     1  (xIonFracs(nelem,i),i=1,27)
        write(qq,'('' IRON - Ka(Auger)'',1P,E10.2)')
     1  fekcld+fekhot
      endif
*
      end
*************************************************************
      subroutine drfe(ion,t,d)
      implicit none
*Dielectronic recombination rates for Fe from Arnaud & Raymond 1992
      integer ion
      real t , d
*
* ion - spectroscopic symbol of final ion
* t - temperature, K
* d - rate coefficient, cm^3 s^-1
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,j,k
      real te , sexp
      real dfe(8,25)
      data(dfe(i, 1),i=1,8)/5.120E+00,1.29E+01,0.00E+00,0.00E+00,
     &2.20E-04,1.00E-04,0.00E+00,0.00E+00/
      data(dfe(i, 2),i=1,8)/1.670E+01,3.14E+01,0.00E+00,0.00E+00,
     &2.30E-03,2.70E-03,0.00E+00,0.00E+00/
      data(dfe(i, 3),i=1,8)/2.860E+01,5.21E+01,0.00E+00,0.00E+00,
     &1.50E-02,4.70E-03,0.00E+00,0.00E+00/
      data(dfe(i, 4),i=1,8)/3.730E+01,6.74E+01,0.00E+00,0.00E+00,
     &3.80E-02,1.60E-02,0.00E+00,0.00E+00/
      data(dfe(i, 5),i=1,8)/5.420E+01,1.00E+02,0.00E+00,0.00E+00,
     &8.00E-02,2.40E-02,0.00E+00,0.00E+00/
      data(dfe(i, 6),i=1,8)/4.550E+01,3.60E+02,0.00E+00,0.00E+00,
     &9.20E-02,4.10E-02,0.00E+00,0.00E+00/
      data(dfe(i, 7),i=1,8)/6.670E+01,1.23E+02,0.00E+00,0.00E+00,
     &1.60E-01,3.60E-02,0.00E+00,0.00E+00/
      data(dfe(i, 8),i=1,8)/6.610E+01,1.29E+02,0.00E+00,0.00E+00,
     &1.80E-01,7.00E-02,0.00E+00,0.00E+00/
      data(dfe(i, 9),i=1,8)/2.160E+01,1.36E+02,0.00E+00,0.00E+00,
     &1.40E-01,2.60E-01,0.00E+00,0.00E+00/
      data(dfe(i,10),i=1,8)/2.220E+01,1.44E+02,0.00E+00,0.00E+00,
     &1.00E-01,2.80E-01,0.00E+00,0.00E+00/
      data(dfe(i,11),i=1,8)/5.960E+01,3.62E+02,0.00E+00,0.00E+00,
     &2.25E-01,2.31E-01,0.00E+00,0.00E+00/
      data(dfe(i,12),i=1,8)/7.500E+01,2.05E+02,0.00E+00,0.00E+00,
     &2.40E-01,1.70E-01,0.00E+00,0.00E+00/
      data(dfe(i,13),i=1,8)/3.630E+01,1.93E+02,0.00E+00,0.00E+00,
     &2.60E-01,1.60E-01,0.00E+00,0.00E+00/
      data(dfe(i,14),i=1,8)/3.940E+01,1.98E+02,0.00E+00,0.00E+00,
     &1.90E-01,9.00E-02,0.00E+00,0.00E+00/
      data(dfe(i,15),i=1,8)/2.460E+01,2.48E+02,5.60E+02,0.00E+00,
     &1.20E-01,1.20E-01,6.00E-01,0.00E+00/
      data(dfe(i,16),i=1,8)/5.600E+02,0.00E+00,0.00E+00,0.00E+00,
     &1.23E+00,0.00E+00,0.00E+00,0.00E+00/
      data(dfe(i,17),i=1,8)/2.250E+01,1.17E+02,3.41E+02,6.83E+02,
     &2.53E-03,3.36E-02,1.81E-01,1.92E+00/
      data(dfe(i,18),i=1,8)/1.620E+01,9.60E+01,3.30E+02,7.29E+02,
     &5.67E-03,7.82E-02,3.18E-02,1.26E+00/
      data(dfe(i,19),i=1,8)/2.370E+01,8.51E+01,3.29E+02,7.87E+02,
     &1.60E-02,7.17E-02,9.06E-02,7.39E-01/
      data(dfe(i,20),i=1,8)/1.320E+01,6.66E+01,2.97E+02,7.14E+02,
     &1.85E-02,9.53E-02,7.90E-02,1.23E+00/
      data(dfe(i,21),i=1,8)/3.910E+01,8.03E+01,3.92E+02,9.19E+02,
     &9.20E-04,1.29E-01,1.92E-01,9.12E-01/
      data(dfe(i,22),i=1,8)/7.320E+01,3.16E+02,8.77E+02,0.00E+00,
     &1.31E-01,8.49E-02,6.13E-01,0.00E+00/
      data(dfe(i,23),i=1,8)/1.000E-01,3.62E+01,3.06E+02,9.28E+02,
     &1.10E-02,4.88E-02,8.01E-02,5.29E-01/
      data(dfe(i,24),i=1,8)/4.625E+03,6.00E+03,0.00E+00,0.00E+00,
     &2.56E-01,4.52E-01,0.00E+00,0.00E+00/
      data(dfe(i,25),i=1,8)/5.300E+03,0.00E+00,0.00E+00,0.00E+00,
     &4.30E-01,0.00E+00,0.00E+00,0.00E+00/
*
      if( ion.eq.26 ) then
*       d is the rate
        d=0.0
      else if( ion.gt.26 ) then
        write(qq,'('' drfe invalid ion'',i10)') ion
        stop
      else
        te=t*8.61712e-05
        d=0.0
        do j=1,4
           k=j+4
           d=d+dfe(k,ion)*sexp(dfe(j,ion)/te)
        end do
        d=d/t**1.5
      endif
*
      end
      integer function iWavLen( tarray )
      implicit none
*convert real wavelength in A into integer form used in printout
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*
*     add 0.5 so that integer rounds up
      iWavLen = tarray( ipLnWlAng ) + 0.5
*     NB - following must be kept parallel with logic in setline and pldata
      if(iWavLen.gt.1 000 000 ) then
        iWavLen = iWavLen / 10000
      else if(iWavLen.gt.10 000 ) then
        iWavLen = iWavLen / 1000
      else if( iWavLen.lt.10 ) then
*       add 0.5 so that integer rounds up
        iWavLen = tarray( ipLnWlAng ) * 10. + 0.5
      endif
*
      end
******************************************************************************
      subroutine kurucz79( nstar , par1 , par2 , nspec )
      implicit none
*obtain interpolated Kurucz stellar atmosphere
      integer nstar , nspec
      real par1 , par2
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , ndata , mtemp
      real fac1 , fac2 , sc30,sc35,sc40,sc45,sc50,temp,alogg
      parameter (ndata=56)
      real wl(ndata) , t30g4(ndata) , t35g45(ndata) , t40g45(ndata) ,
     1 t45g45(ndata) , t50g45(ndata)
      logical lgFirst
      save lgFirst
      data lgFirst/.true./
*
*     following atmospheres LTE from Kurucz 1979, Ap.J. Sup 40, 1.
      data wl/
     1  22.9  ,  23.4  ,  24.3  ,  25.2  ,  25.6  ,
     2  26.0  ,  26.6  ,  27.5  ,  28.3  ,  29.3  ,
     3  30.1  ,  30.9  ,  32.5  ,  34.2  ,  35.1  ,
     4  35.6  ,  36.5  ,  37.5  ,  38.4  ,  40.0  ,
     5  41.5  ,  42.5  ,  44.5  ,  47.2  ,  49.4  ,
     6  50.6  ,  51.6  ,  54.0  ,  56.4  ,  58.7  ,
     7  61.2  ,  64.0  ,  67.1  ,  70.5  ,  73.6  ,
     8  77.0  ,  81.0  ,  85.0  ,  89.0  ,  92.0  ,
     9  94.0  , 118.7  , 143.3  , 194.0  , 256.2  ,
     * 331.2  , 406.2  , 471.2  , 592.5  , 775.0  ,
     1 1035.  , 1335.  , 5000.  , 6500.  , 1.E4   , 9E6/
*
      data t30g4 /
     1  2.67  ,  3.75  ,  4.16  ,  4.53  ,  4.32  ,
     2  4.81  ,  4.92  ,  5.19  ,  5.42  ,  5.65  ,
     3  5.53  ,  5.83  ,  6.30  ,  6.63  ,  6.77  ,
     4  6.82  ,  6.97  ,  7.09  ,  7.24  ,  7.44  ,
     5  7.61  ,  7.70  ,  7.91  ,  8.13  ,  8.31  ,
     6  9.55  ,  9.74  ,  9.74  ,  9.81  ,  9.83  ,
     7  9.90  ,  9.94  ,  9.98  , 10.02  , 10.06  ,
     8 10.12  , 10.14  , 10.13  , 10.19  , 10.72  ,
     9 11.24  , 11.16  , 10.96  , 10.59  , 10.25  ,
     *  9.87  ,  9.63  ,  9.40  ,  9.03  ,  8.59  ,
     1  8.12  ,  7.69  ,  5.43  ,  4.97  ,  4.22  ,  -7.60 /
*
*     following is Kurucz (1989) private communication, newer opacities
      data t35g45 /
     1  4.96  ,  5.32  ,  5.55  ,  5.86  ,  6.00  ,
     2  6.19  ,  6.53  ,  6.78  ,  7.07  ,  7.23  ,
     3  7.59  ,  7.84  ,  8.32  ,  8.60  ,  8.8   ,
     4  9.00  ,  9.30  ,  9.30  ,  9.40  ,  9.60  ,
     5  9.70  ,  9.73  ,  9.83  ,  9.92  , 10.00  ,
     6 10.34  , 10.92  , 10.78  , 10.97  , 10.97  ,
     7 10.92  , 10.99  , 11.00  , 10.88  , 11.02  ,
     8 10.99  , 10.98  , 10.95  , 10.97  , 11.30  ,
     9 11.57  , 11.36  , 11.19  , 10.81  , 10.43  ,
     * 10.04  ,  9.76  ,  9.53  ,  9.16  ,  8.72  ,
     1  8.24  ,  7.80  ,  5.52  ,  5.07  ,  4.32  , -7.50 /
*
*     following from Kuruca (1989) private communication
      data t40g45 /
     1  6.93  ,  7.39  ,  7.60  ,  7.90  ,  8.02  ,
     2  8.13  ,  8.85  ,  9.00  ,  9.23  ,  9.35  ,
     3  9.53  , 10.06  , 10.35  , 10.49  , 10.55  ,
     4 10.80  , 11.10  , 11.08  , 10.95  , 11.33  ,
     5 11.32  , 11.28  , 11.33  , 11.27  , 11.28  ,
     6 11.28  , 11.53  , 11.38  , 11.51  , 11.53  ,
     7 11.45  , 11.54  , 11.52  , 11.41  , 11.52  ,
     8 11.43  , 11.45  , 11.42  , 11.40  , 11.43  ,
     9 11.68  , 11.51  , 11.31  , 10.93  , 10.54  ,
     * 10.15  ,  9.85  ,  9.62  ,  9.24  ,  8.79  ,
     1  8.31  ,  7.88  ,  5.60  ,  5.14  ,  4.39  , -7.43 /
*
      data t45g45 /
     1  8.32  ,  9.34  ,  9.40  , 10.14  , 10.10  ,
     2 10.51  , 11.46  , 11.40  , 11.40  , 11.52  ,
     3 10.68  , 11.55  , 11.89  , 11.95  , 11.85  ,
     4 11.84  , 11.84  , 11.77  , 11.48  , 11.72  ,
     5 11.74  , 11.73  , 11.80  , 11.77  , 11.80  ,
     6 11.79  , 11.83  , 11.80  , 11.81  , 11.80  ,
     7 11.79  , 11.77  , 11.76  , 11.73  , 11.73  ,
     8 11.68  , 11.67  , 11.63  , 11.61  , 11.64  ,
     9 11.79  , 11.62  , 11.37  , 10.99  , 10.60  ,
     * 10.20  ,  9.90  ,  9.66  ,  9.28  ,  8.84  ,
     1  8.36  ,  7.92  ,  5.64  ,  5.18  ,  4.43  , -7.39 /
*
      data t50g45 /
     1  9.36  , 11.12  , 11.11  , 11.65  , 11.54  ,
     2 11.68  , 12.12  , 12.07  , 12.09  , 12.17  ,
     3 11.65  , 12.04  , 12.22  , 12.27  , 12.16  ,
     4 12.13  , 12.13  , 12.08  , 11.77  , 12.00  ,
     5 12.03  , 12.03  , 12.10  , 12.07  , 12.11  ,
     6 12.09  , 12.10  , 12.06  , 12.06  , 12.04  ,
     7 12.03  , 11.98  , 11.98  , 11.93  , 11.93  ,
     8 11.86  , 11.85  , 11.81  , 11.78  , 11.78  ,
     9 11.88  , 11.70  , 11.45  , 11.06  , 10.66  ,
     * 10.26  ,  9.95  ,  9.71  ,  9.33  ,  8.88  ,
     1  8.40  ,  7.97  ,  5.68  ,  5.22  ,  4.47  , -7.35 /
*
      if( lgFirst ) then
        sc30 = t30g4(39)
        sc35 = t35g45(39)
        sc40 = t40g45(39)
        sc45 = t45g45(39)
        sc50 = t50g45(39)
        do i=1,ndata
          t30g4(i) = t30g4(i) - sc30
          t35g45(i) = t35g45(i) - sc35
          t40g45(i) = t40g45(i) - sc40
          t45g45(i) = t45g45(i) - sc45
          t50g45(i) = t50g45(i) - sc50
        end do
        lgFirst = .false.
      endif
*
*     PAR1 and 2 are log(g) and temp
      if( par1 .gt.10. ) then
        temp = par1
        mtemp = (par1+10.) / 100.
        alogg = par2
      else
        temp = par2
        mtemp = (par2+10.) / 100.
        alogg = par1
      endif
*
      if( alogg.ne.4. ) then
        write(qq,'('' only log(g)=4 in table at present.'')')
        stop
      endiF
*
      do i=1,ndata
*       convert nanometers to Rydbergs
        tnu(nspec,ndata+1-i) = 91.16 / wl(i)
      end do
*
      if( mtemp.eq. 300 ) then
        do i=1,ndata
          tslop(nspec,ndata+1-i) = t30g4(i)
        end do
      else if( mtemp.eq. 350 ) then
        do i=1,ndata
          tslop(nspec,ndata+1-i) = t35g45(i)
        end do
      else if( mtemp.eq. 400 ) then
        do i=1,ndata
          tslop(nspec,ndata+1-i) = t40g45(i)
        end do
      else if( mtemp.eq. 450 ) then
        do i=1,ndata
          tslop(nspec,ndata+1-i) = t45g45(i)
        end do
      else if( mtemp.eq. 500 ) then
        do i=1,ndata
          tslop(nspec,ndata+1-i) = t50g45(i)
        end do
      else if( mtemp.lt.300 .or. mtemp.gt.500 ) then
        write(qq,'('' This temp is not inside table.'')')
        stop
      else
*       must interpolate on grid
        if( mtemp.gt.300.and.mtemp.le.350 ) then
          fac1 = ( temp - 30000. ) / 5000.
          fac2 = 1. - fac1
          do i=1,ndata
            tslop(nspec,ndata+1-i) = fac2*t30g4(i) + fac1*t35g45(i)
          end do
        else if( mtemp.gt.350.and.mtemp.le.400 ) then
          fac1 = ( temp - 35000. ) / 5000.
          fac2 = 1. - fac1
          do i=1,ndata
            tslop(nspec,ndata+1-i) = fac2*t35g45(i) + fac1*t40g45(i)
          end do
        else if( mtemp.gt.400.and.mtemp.le.450 ) then
          fac1 = ( temp - 40000. ) / 5000.
          fac2 = 1. - fac1
          do i=1,ndata
            tslop(nspec,ndata+1-i) = fac2*t40g45(i) + fac1*t45g45(i)
          end do
        else if( mtemp.gt.450.and.mtemp.le.500 ) then
          fac1 = ( temp - 45000. ) / 5000.
          fac2 = 1. - fac1
          do i=1,ndata
            tslop(nspec,ndata+1-i) = fac2*t45g45(i) + fac1*t50g45(i)
          end do
        endif
      endif
*
*     now convert to f-nu (above is f-lam)
      do i=1,ndata
        tslop(nspec,i) = tslop(nspec,i) - 2. * log10( tnu(nspec,i) )
      end do
*
      nstar = ndata
*
      end
******************************************************************************
      subroutine level3( t10,t21,t20)
      implicit none
*compute three level atom with radiative transfer
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real t10(nta) , t21(nta) , t20(nta)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
      integer limLevelN
      parameter (limLevelN=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real teinv
      common/teinv/ teinv
      real te , eden , hden
      common/phycon/ te , eden , hden
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
*     include "corind.com"
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      integer nLev3Fail
*number indicating what went wrong in the routine level3
*not used elsewhere, info only
      common/Lev3Fail/ nLev3Fail
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     compute three level atom, 10, 21, and 20 are line
*     arrays for 10, 21, and 20 transitions.
*     one can be a dummy
*
*     local variables
      real g0, g1, g2 , AbunxIon,p0,p1,p2,o10,o21,o20
      real g010,g110,g121,g221,g020,g220
      real a,b,c,pump01,pump12,a21,a10,bolt01,bolt12
      real beta , bolt02 , a20 , pump02
      double precision alpha , alpha1 , alpha2
      double precision r01 , r10 , r20 , r02 , r12 , r21
      double precision c01 , c10 , c20 , c02 , c12 , c21
      real ener20,ener21,ener10
*     >>chng 96 dec 6, to double precision due to round off problems below
      double precision cool02 , cool12 , cool01 , TotCool , TotInten
      double precision heat20 , heat21 , heat10
      double precision pump10 , pump21 , pump20
      double precision temp12 , temp02 , temp01
      double precision cnet02, hnet02, cnet12, hnet12, cnet01, hnet01 ,
     1 TotHeat
      character chLab*4  , chIonLbl*4 , chLab10*10 , chLineLbl*10
*
*     generalized three level atom for any ion
*     sum of three levels normalized to total abundance
*
*     stat weights of all three lines
*     sanity check will confirm ok
      g010 = t10(ipLnGl)
      g110 = t10(ipLnGu)
*
      g121 = t21(ipLnGl)
      g221 = t21(ipLnGu)
*
      g020 = t20(ipLnGl)
      g220 = t20(ipLnGu)
*
*     these are statistical weights
      if( g010.gt.0. ) then
        g0 = g010
      else if( g020.gt. 0. ) then
        g0 = g020
      else
        chLab10 = chLineLbl( t10 )
        write(qq,'('' level3: insane stat weights g0 :'',1p,
     1  2e10.2,1x,a10)') g010,g020,chLab10
        call insane
        call ShowMe
      endif
      if( g110.gt.0. ) then
        g1 = g110
      else if( g121.gt. 0. ) then
        g1 = g121
      else
        chLab10 = chLineLbl( t10 )
        write(qq,'('' level3: insane stat weights g1 :'',1p,
     1  2e10.2,1x,a10)') g010,g020,chLab
        call insane
        call ShowMe
        stop
      endif
      if( g220.gt.0. ) then
        g2 = g220
      else if( g221.gt. 0. ) then
        g2 = g221
      else
        chLab10 = chLineLbl( t20 )
        write(qq,'('' level3: insane stat weights g2 :'',1p,
     1  2e10.2,1x,a10)') g010,g020,chLab10
        call insane
        call ShowMe
        stop
      endif
*
*     abundances from the elements grid
*     one of these must be a true line
      if(g010.gt.0.) then
        chLab = chIonLbl( t10 )
        AbunxIon = xIonFracs( int(t10(ipLnNelem)+0.1) ,
     1  int(t10(ipLnIonStg)+0.1) )
      else if( g121.gt.0. ) then
        chLab = chIonLbl( t21 )
        AbunxIon = xIonFracs( int(t21(ipLnNelem)+0.1) ,
     1  int(t21(ipLnIonStg)+0.1) )
      endif
*
      a = t10(ipLnBolt)/te
      b = t21(ipLnBolt)/te
      c = t20(ipLnBolt)/te
      if( c.eq.0. ) then
        c = a + b
      endif
*
*     if still neg at end, then success!, in common so possible to
*     to check why zero returned
      nLev3Fail = -1
      if( AbunxIon.le.1e-30 .or. c.gt.60. ) then
        nLev3Fail = 0
*       all populations are zero
        PopLevels(0) = AbunxIon
        PopLevels(1) = 0.
        PopLevels(2) = 0.
*
* 666 error! these pops ARE NOT defined below
        DepLTELevels(0) = 1.
        DepLTELevels(1) = 0.
        DepLTELevels(2) = 0.
*
*       level populations
        t21(ipLnPopOpc) = 0.
        t10(ipLnPopOpc) = AbunxIon
        t20(ipLnPopOpc) = AbunxIon
        t21(ipLnPopl) = 0.
        t10(ipLnPopl) = AbunxIon
        t20(ipLnPopl) = AbunxIon
        t21(ipLnPopu) = 0.
        t10(ipLnPopu) = 0.
        t20(ipLnPopu) = 0.
*
*       line heating
        t20(ipLnHeat) = 0.
        t21(ipLnHeat) = 0.
        t10(ipLnHeat) = 0.
*
*       intensity of line
        t21(ipLnInten) = 0.
        t10(ipLnInten) = 0.
        t20(ipLnInten) = 0.
*
*       line cooling
        t20(ipLnCool) = 0.
        t21(ipLnCool) = 0.
        t10(ipLnCool) = 0.
*
*       local ots rates
        t20(ipLnOTS) = 0.
        t21(ipLnOTS) = 0.
        t10(ipLnOTS) = 0.
*
*       number of photons in line zero
        t21(ipLnNPhots) = 0.
        t10(ipLnNPhots) = 0.
        t20(ipLnNPhots) = 0.
*
*       fraction that produced lines zero
        t21(ipLnAovTOT) = 1.
        t10(ipLnAovTOT) = 1.
        t20(ipLnAovTOT) = 1.
*
*       ratio coll over total excitation
        t21(ipLnColovTOT) = 0.
        t10(ipLnColovTOT) = 0.
        t20(ipLnColovTOT) = 0.
*
*       add zero to cooling
        call coladd( chLab(1:4) , INT(t21(ipLnWlAng)),0.)
        call coladd( chLab(1:4) , INT(t10(ipLnWlAng)),0.)
        call coladd( chLab(1:4) , INT(t20(ipLnWlAng)),0.)
*
*       now add zero to ots field
*       one of these could be a dummy line
        if(t21(ipLnIpCont) .gt. 0. .and.t21(ipLnCS1).eq.0.)
     1    call AddOTSLin( 0. , int(t21(ipLnIpCont) ) ,1.0 )
        if(t10(ipLnIpCont) .gt. 0. .and.t10(ipLnCS1).eq.0.)
     1    call AddOTSLin( 0. , int(t10(ipLnIpCont) ) ,1.0 )
        if(t20(ipLnIpCont) .gt. 0. .and.t20(ipLnCS1).eq.0.)
     1    call AddOTSLin( 0. , int(t20(ipLnIpCont) ) ,1.0 )
        return
      endif
*
*     collision strengths
      o10 = t10(ipLnCS)
      o21 = t21(ipLnCS)
      o20 = t20(ipLnCS)
*
*begin sanity checks
      if(g010*g020.gt.0. .and. g010.ne.g020 ) then
        write(qq,'('' level3: insane stat weights 020 010:'',1p,
     1  2e10.2,1x,a4)') g010,g020,chLab
        call insane
        call ShowMe
        stop
      endif
      if(g110*g121.gt.0. .and. g110.ne.g121 ) then
        write(qq,'('' level3: insane stat weights 121 110:'',1p,
     1  2e10.2,1x,a4)') g110,g121,chLab
        call insane
        call ShowMe
        stop
      endif
      if(g221*g220.gt.0. .and. g221.ne.g220 ) then
        write(qq,'('' level3: insane stat weights 220 221:'',1p,
     1  2e10.2,1x,a4)') g221,g220,chLab
        call insane
        call ShowMe
        stop
      endif
*
*     both abundances must be same, equal abundance
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      if( t10(ipLnIonStg)*t21(ipLnIonStg).gt.0. .and.
     1  t10(ipLnIonStg).ne.t21(ipLnIonStg) ) then
        write(qq,'('' level3: insane IonStg, given, array2='',1p,
     1  2e10.2,1x)') AbunxIon
        call insane
        call ShowMe
        stop
      endif
      if( t20(ipLnIonStg)*t21(ipLnIonStg).gt.0. .and.
     1  t20(ipLnIonStg).ne.t21(ipLnIonStg) ) then
        write(qq,'('' level3: insane IonStg, given, array2='',1p,
     1  2e10.2,1x)') AbunxIon
        call insane
        call ShowMe
        stop
      endif
      if( t10(ipLnNelem)*t21(ipLnNelem).gt.0. .and.
     1  t10(ipLnNelem).ne.t21(ipLnNelem) ) then
        write(qq,'('' level3: insane nelem, given, array2='',1p,
     1  2e10.2,1x)') AbunxIon
        call insane
        call ShowMe
        stop
      endif
      if( t20(ipLnNelem)*t21(ipLnNelem).gt.0. .and.
     1  t20(ipLnNelem).ne.t21(ipLnNelem) ) then
        write(qq,'('' level3: insane nelem, given, array2='',1p,
     1  2e10.2,1x)') AbunxIon
        call insane
        call ShowMe
        stop
      endif
      if( o10.le.0. .or. o21.le.0. .or. o20.le.0. ) then
        write(qq,'('' level3 called with non-positive collision'',
     1  '' strength, ='',1P,E10.2)') o10,o21,o20
        write(qq,'('' label='',a10)') chLab
        call insane
        call ShowMe
        stop
      endif
*end sanity checks
*
*     net loss of line escape and destruction
      a21 = t21(ipLnAul) * ( t21(ipLnEscP)+t21(ipLnDesP) )
      a10 = t10(ipLnAul) * ( t10(ipLnEscP)+t10(ipLnDesP) )
      a20 = t20(ipLnAul) * ( t20(ipLnEscP)+t20(ipLnDesP) )
*
*     find energies of all transitions - one line could be a dummy
*     also find boltzmann factors
      if( a10.eq.0. ) then
        ener20 = t20( ipLnEnrErg)
        ener21 = t21( ipLnEnrErg)
        ener10 = ener20 - ener21
        bolt12 = exp( -t21(ipLnBolt) / te )
        bolt02 = exp( -t20(ipLnBolt) / te )
        bolt01 = bolt02 / bolt12
        temp12 = t21(ipLnBolt)
        temp02 = t20(ipLnBolt)
        temp01 = temp02 - temp12
      else if( a21.eq.0. ) then
        ener10 = t10( ipLnEnrErg)
        ener20 = t20( ipLnEnrErg)
        ener21 = ener20 - ener10
        bolt01 = exp( -t10(ipLnBolt) / te )
        bolt02 = exp( -t20(ipLnBolt) / te )
        bolt12 = bolt02/bolt01
        temp02 = t20(ipLnBolt)
        temp01 = t10(ipLnBolt)
        temp12 = temp02 - temp01
      else if( a20.eq.0. ) then
        ener10 = t10( ipLnEnrErg)
        ener21 = t21( ipLnEnrErg)
        ener20 = ener21 + ener10
        bolt01 = exp( -t10(ipLnBolt) / te )
        bolt12 = exp( -t21(ipLnBolt) / te )
        bolt02 = bolt01*bolt12
        temp01 = t10(ipLnBolt)
        temp12 = t21(ipLnBolt)
        temp02 = temp01 + temp12
      else
*       all lines are ok
        ener10 = t10( ipLnEnrErg)
        ener20 = t20( ipLnEnrErg)
        ener21 = t21( ipLnEnrErg)
        bolt01 = exp( -t10(ipLnBolt) / te )
        bolt12 = exp( -t21(ipLnBolt) / te )
        bolt02 = bolt01*bolt12
        temp02 = t20(ipLnBolt)
        temp01 = t10(ipLnBolt)
        temp12 = t21(ipLnBolt)
      endif
*
*begin sanity check
*     check all energies positive
      if( ener10.lt.0. .or. ener20.lt.0. .or. ener21.lt.0. ) then
        write(qq,'('' level3 called with insane energy scale0'',
     1  '' EN(10,21,20) ='',1P,3E10.2)') ener10,ener21,ener20
        write(qq,'('' label='',a10)') chLab
        call insane
        call ShowMe
        stop
      endif
*     check if energy order is ok
      if( ener10.gt.ener20 .or. ener21.gt.ener20 ) then
        write(qq,'('' level3 called with insane energy scale1'',
     1  '' EN(10,21,20) ='',1P,3E10.2)') ener10,ener21,ener20
        write(qq,'('' label='',a10)') chLab
        call insane
        call ShowMe
        stop
      endif
*     check if energy scale is ok
      if( abs( (ener10+ener21)/ener20 -1.) .gt.1e-4 ) then
        write(qq,'('' level3 called with insane energy scale2'',
     1  '' EN(10,21,20) ='',1P,3E10.2)') ener10,ener21,ener20
        write(qq,'('' label='',a10)') chLab
        call insane
        call ShowMe
        stop
      endif
*end sanity check
*
      pump01 = t10( ipLnPump )
      pump10 = pump01 * g0/g1
      pump12 = t21( ipLnPump )
      pump21 = pump12 * g1/g2
      pump02 = t20( ipLnPump )
      pump20 = pump02 * g0/g2
*
*     cdsqte is 8.629E-6 / sqrte * eden
      c01 = o10*bolt01*cdsqte/g0
      r01 = c01 + pump01
      c10 = o10*cdsqte/g1
      r10 = c10 + a10 + pump10
      c20 = o20*cdsqte/g2
      r20 = c20 +a20 + pump20
      c02 = o20*bolt02*cdsqte/g0
      r02 = c02 + pump02
      c12 = o21*bolt12*cdsqte/g1
      r12 = c12 + pump12
      c21 = o21*cdsqte/g2
      r21 = c21 + a21 + pump21
*
      alpha1 = dble(AbunxIon) * dble(r01+r02)/dble(r10+r01+r02)
      alpha2 = dble(AbunxIon) * dble(r01)/dble(r10+r12+r01)
      alpha = alpha1 - alpha2
*    1( dble(r01+r02)/dble(r10+r01+r02) - dble(r01)/dble(r10+r12+r01) )
*     beta is factor with n2
      beta =
     1 (r21-r01)/(r10+r12+r01) + (r20+r01+r02)/(r10+r01+r02)
*
      if( alpha/max(alpha1,alpha2) .lt. 1e-11 ) then
*       this catches both negative and round off
        p2 = 0.
        alpha = 0.
        nLev3Fail = 1
      else
        p2 = alpha / beta
      endif
      PopLevels(2) = p2
*
      if( alpha.lt.0. .or. beta.lt.0. ) then
        write(qq,'('' level3: insane n2 pop alf, bet, p2='',1p,
     1  3e10.2,1x,a10,'' t='',e10.2)') alpha , beta, p2,chLab,te
        write(qq,'('' gs are'',3f5.1)') g0,g1,g2
        write(qq,'('' Bolts are'',1p,9e10.2)') bolt01,bolt12,bolt02
        write(qq,'('' As are'',1p,9e10.2)') a10,a21,a20
        write(qq,'('' Energies are'',1p,9e10.2)') ener10,ener21,ener20
        write(qq,'('' 2 terms, dif of alpha are'',1p,3e15.6)')
     1  (r01+r02)/(r10+r01+r02) , r01/(r10+r12+r01)
        call ShowMe
        stop
      endif
*
      alpha = dble(AbunxIon)*dble(r01+r02) - dble(p2)*dble(r20+r01+r02)
*     guard against roundoff - this should really have been zero
*     >>chng 96 nov 14, protection against round-off to zero
*     >>chng 96 dec 3, made r01, etc, double, and changed limit to 1e-9
      if( abs(alpha)/(max( AbunxIon*(r01+r02),p2*(r20+r01+r02) ) )
     1 .lt.1e-9) then
        alpha = 0.
        nLev3Fail = 2
      endif
      beta = r10+r01+r02
      p1 = alpha / beta
      PopLevels(1) = p1
      if( p1.lt.0. ) then
        if( p1.gt.-1e-37 ) then
*         slightly negative solution, probably just round-off, zero it
          p1 = 0.
          PopLevels(1) = p1
          nLev3Fail = 3
        else
*         very negative solution, better punt
          write(qq,'('' level3: insane n1 pop alf, bet, p1='',1p,
     1    3e10.2,1x,a10,i5)') alpha , beta, p1,chLab,int(t10(ipLnWlAng))
          write(qq,'('' local electron density and temperature were'',
     1    1p,2e10.2)') eden , te
          call ShowMe
          stop
        endif
      endif
*
      p0 = AbunxIon - p2 - p1
*     population of lowest level
      PopLevels(0) = p0
      if( p0.le.0. ) then
        write(qq,'('' level3: insane n0 pop p1, 2, abun='',1p,
     1  3e10.2,1x)') p1,p2,AbunxIon
        call ShowMe
        stop
      endif
*
*     level populations for line opacities
      t21(ipLnPopl) = p1
      t10(ipLnPopl) = p0
      t20(ipLnPopl) = p0
      t21(ipLnPopOpc) = p1 - p2*g1/g2
      t10(ipLnPopOpc) = p0 - p1*g0/g1
      t20(ipLnPopOpc) = p0 - p2*g0/g2
      t21(ipLnPopu) = p2
      t10(ipLnPopu) = p1
      t20(ipLnPopu) = p2
*
*     line emission - net emission in line
      t21(ipLnNPhots) = t21(ipLnAul)*t21(ipLnEscP) *p2
      t21(ipLnInten) = t21(ipLnNPhots)*t21(ipLnEnrErg)
      t20(ipLnNPhots) = t20(ipLnAul)*t20(ipLnEscP) *p2
      t20(ipLnInten) = t20(ipLnNPhots)*t20(ipLnEnrErg)
      t10(ipLnNPhots) = t10(ipLnAul)*t10(ipLnEscP) *p1
      t10(ipLnInten) = t10(ipLnNPhots)*t10(ipLnEnrErg)
*     total intensity used to divide line up - one may be 0
      TotInten = t21(ipLnInten)+ t20(ipLnInten)+ t10(ipLnInten)
*
*     fraction that was collisionally excited
      t21(ipLnColovTOT) = c12 / r12
      t10(ipLnColovTOT) = c01 / r01
      t20(ipLnColovTOT) = c02 / r02
*
*     heating or cooling due to each line
      heat20 = p2*c20 * ener20
      cool02 = p0*c02 * ener20
      heat21 = p2*c21 * ener21
      cool12 = p1*c12 * ener21
      heat10 = p1*c10 * ener10
      cool01 = p0*c01 * ener10
*
*     now get net heating or cooling
      cnet02 = cool02 - heat20*t20(ipLnColovTOT)
      hnet02 = heat20 * (1.-t20(ipLnColovTOT))
      cnet12 = cool12 - heat21*t21(ipLnColovTOT)
      hnet12 = heat21 * (1.-t21(ipLnColovTOT))
      cnet01 = cool01 - heat10*t10(ipLnColovTOT)
      hnet01 = heat10 * (1.-t10(ipLnColovTOT))
*     >>chng 96 nov 22, very dense cool models, roundoff error
*could cause [OI] 63 mic to be dominant heating, cooling, or
*just zero
*     >>chng 96 dec 6, above change caused o iii 1666 cooling to
*be zeroed when important in a model in kirk's grid.  was at 1e-6,
*     >>chng to 1e-7
*     >>chng 96 dec 17, from 1e-7 to 1e-8, caused temp fail
      if( abs(cnet01/max(1d-30,cool01)).lt.1e-8 ) then
        nLev3Fail = 4
        cnet02 = 0.
        hnet02 = 0.
        cnet12 = 0.
        hnet12 = 0.
        cnet01 = 0.
        hnet01 = 0.
      endif
*
      TotCool = cnet02 + cnet12 + cnet01
      TotHeat = hnet02 + hnet12 + hnet01
*
      if( TotInten.gt.0. ) then
        t20(ipLnCool) = TotCool * (t20(ipLnInten) / TotInten)
        t21(ipLnCool) = TotCool * (t21(ipLnInten) / TotInten)
        t10(ipLnCool) = TotCool * (t10(ipLnInten) / TotInten)
        t20(ipLnHeat) = TotHeat * (t20(ipLnInten) / TotInten)
        t21(ipLnHeat) = TotHeat * (t21(ipLnInten) / TotInten)
        t10(ipLnHeat) = TotHeat * (t10(ipLnInten) / TotInten)
      else
        nLev3Fail = 5
        t20(ipLnCool) = 0.
        t21(ipLnCool) = 0.
        t10(ipLnCool) = 0.
        t20(ipLnHeat) = 0.
        t21(ipLnHeat) = 0.
        t10(ipLnHeat) = 0.
      endif
*
*     fraction that produced lines
      t21(ipLnAovTOT) = t21(ipLnAul)*t21(ipLnEscP) / r21
      t10(ipLnAovTOT) = t10(ipLnAul)*t10(ipLnEscP) / r10
      t20(ipLnAovTOT) = t20(ipLnAul)*t20(ipLnEscP) / r20
*
*     add cooling due to each line
      call coladd( chLab(1:4) , INT(t21(ipLnWlAng)),t21(ipLnCool))
      call coladd( chLab(1:4) , INT(t10(ipLnWlAng)),t10(ipLnCool))
      call coladd( chLab(1:4) , INT(t20(ipLnWlAng)),t20(ipLnCool))
*
*     destroyed part of line
*     one of these could be a dummy line
      if(t21(ipLnIpCont) .gt. 0. ) then
        t21(ipLnOTS) =  p2*t21(ipLnAul)*t21(ipLnDesP)
        call AddOTSLin( t21(ipLnOTS) , int(t21(ipLnIpCont)),1.0 )
      endif
      if(t10(ipLnIpCont) .gt. 0. ) then
        t10(ipLnOTS) =  p1*t10(ipLnAul)*t10(ipLnDesP)
        call AddOTSLin( t10(ipLnOTS) , int(t10(ipLnIpCont)),1.0 )
      endif
      if(t20(ipLnIpCont) .gt. 0. ) then
        t20(ipLnOTS) = p2*t20(ipLnAul)*t20(ipLnDesP)
        call AddOTSLin( t20(ipLnOTS) , int(t20(ipLnIpCont)),1.0 )
      endif
*
*     derivative of cooling function
*     dC/dT = Cooling * ( T(excitation)/T_e^2 - 1/(2T) )
*     in following I assume that a 1-2 exciation will have the 0-2
*     expnential in the dcdt term = NOT A TYPO
      dCooldT = dCooldT +
     1 t10(ipLnCool)* (temp01 *tsq1-halfte) +
     2 (t20(ipLnCool)+t21(ipLnCool) ) * (temp02 *tsq1-halfte)
*     two t20's above are not a typo!
*
      end
******************************************************************************
      subroutine LevelN(nlev,ndim,abund,g,ex,p,data,dest,pump,ipdest,
     1 cooltl, coolder, chLabel,lgNegPop)
      implicit none
*compute an arbitrary N level atom
      logical lgNegPop
*     nlev is the number of levels to compute, ndim is dimension of array
      integer nlev , ndim
      real cooltl , abund , coolder
      real g(ndim) , p(ndim) , ex(ndim) , data(ndim,ndim)
      real dest(ndim,ndim), pump(ndim,ndim)
      integer ipdest(ndim,ndim)
      character chLabel*4
*
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      integer limLevelN
      parameter (limLevelN=20)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real te , eden , hden
      common/phycon/ te , eden , hden
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgTrLevN
*flag set with trace leveln command, for n level atom
      common/TrLevN/ lgTrLevN
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      double precision zz(limLevelN,limLevelN)
      real excit(limLevelN,limLevelN) , crate(limLevelN,limLevelN)
*
      integer ihi , ilo , i  , j , ner
      real sexp , ots , cool1
*
*     PARAMETER statement:
*     limLevelN is upper limit to number of levels allowed by present dim
*
*     entering variables
*     NLEV is number of present dimensions
*     ABUND is total abundance of species, used for nth equation
*     G(ndim) is stat weight of levels
*     EX(ndim) is excitation potential of levels, deg K
*       0 for first one, NOT d(ENER), but energy rel to ground
*     DATA(ihi,ilo) is transit prob from up to low
*     DATA(ilo,ihi) is col str from up to low
*     lgNegPop is true is negative populations occurred
*
*     deduced variables
*     EXCIT(IHI,ILO) excitation Boltzman factor
*     CRATE(IHI,ILO) collis deexcit rate
*     CRATE(ILO,IHI) collis excit rate
*
*     free statements >=20
*
*     check if too many levels used
*     >>chng 96 aug 22, had been .gt., off by one at limit since z(n,n+1) used
      if( ndim.ge.limLevelN ) then
        write(qq,'('' LevelN called with too many levels, the limit is''
     1  ,I5)') limLevelN
        stop
      endif
*
*begin sanity checks
*     excitation temperature of lowest level must be zero
      if( ex(1).ne.0. ) then
        write(qq,'('' LevelN called with non-zero ex(1)'')')
        stop
      endif
*     both dest and pump (low, hi) are not used, should be zero
      do ihi=2,nlev
        do ilo=1,ihi-1
*         zero ots destruction rate
          if( dest(ilo,ihi).ne.0. ) then
            write(qq,'('' LevelN called with non-zero dest(l,u)'')')
          endif
          if( pump(ilo,ihi).ne.0. ) then
            write(qq,'('' LevelN called with non-zero pump(l,u)'')')
          endif
          if( ipdest(ilo,ihi).ne.0 ) then
            write(qq,'('' LevelN called with non-zero ipdest(l,u)'')')
          endif
        end do
      end do
*     data(i,i) should be zero
      do ihi=1,nlev
        if( data(ihi,ihi).ne.0 ) then
          write(qq,'('' LevelN called with non-zero data(i,i)'')')
        endif
      end do
*end sanity checks
*
      if( lgTrace.and.lgTrLevN ) then
        write(qq,'('' dest'')')
        write(qq,'(''  hi  lo'',10(i4,6x))') (ilo,ilo=1,nlev)
        do ihi=1,nlev
          write(qq,'(i3,1p,10e10.2)') ihi,(dest(ihi,ilo),ilo=1,nlev)
        end do
        write(qq,'('' data'')')
        write(qq,'(''  hi  lo'',10(i4,6x))') (ilo,ilo=1,nlev)
        do ihi=1,nlev
          write(qq,'(i3,1p,10e10.2)') ihi,(data(ihi,ilo),ilo=1,nlev)
        end do
        write(qq,'('' pump'')')
        write(qq,'(''  hi  lo'',10(i4,6x))') (ilo,ilo=1,nlev)
        do ihi=1,nlev
          write(qq,'(i3,1p,10e10.2)') ihi,(pump(ihi,ilo),ilo=1,nlev)
        end do
      endif
*
      do ihi=2,nlev
        do ilo=1,ihi-1
*         zero ots destruction rate
          if( ipdest(ihi,ilo).gt.0 ) then
            call AddOTSLin( 0.,ipdest(ihi,ilo) ,1.0 )
          endif
        end do
      end do
*
*     check for zero abundance and exit if so
      if( abund.le.0. ) then
        cooltl = 0.
        coolder = 0.
        lgNegPop = .false.
        do i=1,nlev
          p(i) = 0.
*         these are off by one - lowest index is zero
          PopLevels(i-1) = 0.
          DepLTELevels(i-1) = 0.
        end do
        PopLevels(0) = abund
        DepLTELevels(0) = 1.
*       there are TWO abort returns in this sub
        return
      endif
*
      do ilo=1,nlev-1
        do ihi=ilo+1,nlev
          excit(ihi,ilo) = sexp( (ex(ihi) - ex(ilo)) / te )
        end do
      end do
      if( lgTrace.and.lgTrLevN ) then
        write(qq,'('' excit, te='',1p,e10.2)') te
        write(qq,'(''  hi  lo'',10(i4,6x))') (ilo,ilo=1,nlev)
        do ihi=1,nlev
          write(qq,'(i3,1p,10e10.2)') ihi,(excit(ihi,ilo),ilo=1,nlev)
        end do
      endif
*
*     punt if total excitation rate is zero
      if( excit(nlev,1)+pump(nlev,1).lt.1e-13 ) then
        cooltl = 0.
        coolder = 0.
        lgNegPop = .false.
        do i=2,nlev
          p(i) = 0.
*         these are off by one - lowest index is zero
          PopLevels(i-1) = 0.
          DepLTELevels(i-1) = 0.
        end do
*       everything in ground
        p(1) = abund
        PopLevels(0) = abund
        DepLTELevels(0) = 1.
        return
      endif
*
*     factor is 8.629E-6 / SQRTE * EDEN
      do ilo=1,nlev-1
        do ihi=ilo+1,nlev
*         this is deexcitation rate
*         factor is 8.629E-6 / SQRTE * EDEN
          crate(ihi,ilo) = data(ilo,ihi)/g(ihi) * cdsqte
*         this is excitation rate
          crate(ilo,ihi) = crate(ihi,ilo) * g(ihi)/g(ilo) *
     1    excit(ihi,ilo)
        end do
      end do
*
*     rate equations equal zero
      do i=1,nlev
        do j=2,nlev
*       do j=1,nlev-1
          zz(j,i) = 0.
        end do
*       zz(nlev,i) = 1.0
        zz(1,i) = 1.0
      end do
*
*     following is colum of vector
      do i=1,nlev
        zz(i,nlev+1) = 0.
      end do
*     zz(nlev,nlev+1) = abund
*     solve the problem with everything normalzied to pop of unity
*     for numerical stbility
*     zz(nlev,nlev+1) = 1.
      zz(1,nlev+1) = 1.
*
*     eqns for destruction of level
*     data(hi,lo) are A's, crate is coll excit in direction
*     doi=1,nlev-1
      do i=2,nlev
        zz(i,i) = 0.
*       leaving I to below
        do ilo=1,i-1
          zz(i,i) = zz(i,i) + crate(i,ilo) + data(i,ilo) +
     1    dest(i,ilo)
     2    + pump(i,ilo) * g(ilo)/g(i)
*         >>chng 97 jul 31, added pumping down
*         coming to level I from below
          zz(i,ilo) = -crate(ilo,i) - pump(i,ilo)
        end do
        do ihi=i+1,nlev
*         leaving I to above
          zz(i,i) = zz(i,i) + crate(i,ihi) + pump(ihi,i)
*         coming to level I from above
          zz(i,ihi) = -crate(ihi,i) - data(ihi,i) - dest(ihi,i)
     2    - pump(ihi,i) * g(i)/g(ihi)
*         >>chng 97 jul 31, added pumping down
        end do
      end do
*
      call matin1( zz,limLevelN,nlev,1,ner)
      if( ner.ne.0 ) then
        if( lgTalk ) write(qq,'('' LevelN MATRIX ERROR.'')')
        stop
      endif
*
*     set populations
      do i=1,nlev
*       convert to real abundances
        p(i) = zz(i,nlev+1) * abund
      end do
*
*     now find total cooling and its derivative
      cooltl = 0.
      coolder = 0.
      do ihi=2,nlev
        do ilo=1,ihi-1
*         this is net cooling in oK
          cool1 = (p(ilo)*crate(ilo,ihi)-p(ihi)*crate(ihi,ilo)) *
     2    ( ex(ihi)-ex(ilo) )
          cooltl = cooltl + cool1
*         simplistic way to handle line heating - better would
*         be to go  over to method in level2 and level3
          coolder = coolder +
     1    max(0.,cool1) * ( (ex(ihi)-ex(1))*tsq1-halfte)
        end do
      end do
*     convert to ergs
      cooltl = cooltl * Boltzmann
      coolder = coolder * Boltzmann
*
*     fill in departure coefficients
      if( p(1).gt.1e-20 .and. excit(nlev,1).gt.1e-20 ) then
        do ihi=2,nlev
*         these are off by one - lowest index is zero
          PopLevels(ihi-1) = p(ihi)
          DepLTELevels(ihi-1) = (p(ihi)/p(1))*(g(1)/g(ihi))/excit(ihi,1)
        end do
      else
        do ihi=2,nlev
*         these are off by one - lowest index is zero
          PopLevels(ihi-1) = 0.
          DepLTELevels(ihi-1) = 0.
        end do
      endif
      PopLevels(0) = abund
      DepLTELevels(0) = 1.
*
*     in case atom has been trimed down
      do i=nlev+1,ndim
        p(i) = 0.
        PopLevels(i-1) = 0.
        DepLTELevels(i-1) = 0.
      end do
*
*     sanity check for stability of inversion
      lgNegPop = .false.
      do i=1,nlev
        if( p(i).lt.0. ) then
          lgNegPop = .true.
        endif
      end do
      if(lgNegPop) then
        write(qq,'('' LevelN found negative population, atom='',a4)
     1   ') chLabel
        write(qq,'('' absolute population='',1p,1p,10e10.2)')
     2  (p(i),i=1,nlev)
        do i=1,nlev
          p(i) = max(0.,p(i) )
        end do
      endif
*
      do ihi=2,nlev
        do ilo=1,ihi-1
*         set ots destruction rate
          if( ipdest(ihi,ilo).gt.0 ) then
            ots = p(ihi) * dest(ihi,ilo)
            call AddOTSLin( ots,ipdest(ihi,ilo) ,1.0 )
          endif
        end do
      end do
*
      end
******************************************************************************
      logical function lgConverg(nelem)
      implicit none
*check whether ionization of element nelem has converged
      integer nelem
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      logical lgOpacOn
      common/opacon/ lgOpacOn
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*     following is ionzation tolerance for considered converged
      real delta
      real OldFracs(limelm,0:limelm+1)
      save OldFracs
*     args are atomic number, ionization stage
*     OldFracs(nelem,0) is abundances of nelem (cm^-3)
      parameter (delta=0.15)
      real change , Abund
      integer nstage
*
*     this function returns true if ionization of element
*     with atomic number nelem has not changed by more than delta,
*     the variable in the parameter above
*     needed since method of Auger elec uses previous estimate
*
*     check whether abundances exist yet
      if( nzone.gt.0 ) then
        change = 0.
        Abund = xIonFracs(nelem,0)
*       write(qq,'('' convg old'',1p,10e9.1)') (OldFracs(nelem,nstage),
*    1   nstage=1,nelem+1)
        do nstage=1,nelem+1
          if( OldFracs(nelem,nstage)/Abund.gt.1e-4 .and.
     1      xIonFracs(nelem,nstage)/Abund.gt.1e-4 ) then
*           check change in old to new value
            change = max( change ,
     1      abs(xIonFracs(nelem,nstage)-OldFracs(nelem,nstage) ) /
     2      OldFracs(nelem,nstage) )
          endif
*         now set new value
          OldFracs(nelem,nstage) = xIonFracs(nelem,nstage)
        end do
*
        if( change.lt.delta ) then
          lgConverg = .true.
        else
          lgConverg = .false.
        endif
*       write(qq,'('' convg '',l3,1p,10e9.1)') lgConverg,
*    1   (OldFracs(nelem,nstage), nstage=1,nelem+1)
      else
        do nstage=1,nelem+1
          OldFracs(nelem,nstage) = xIonFracs(nelem,nstage)
        end do
        lgConverg = .true.
      endif
*
      end
******************************************************************************
      logical function lgMatch( chKey , chCard )
      implicit none
*determine whether match to a keyword occurs on command line
      character chKey*4 , chCard*80
*
*     local variables
      integer i
*
*     check whether a match to 'KEY' (A4) is found anywhere in chCard
*
*     do i=3,76
*       if( chKey.eq.chCard(i:i+3) ) then
*         lgMatch = .true.
*         return
*       endif
*       colon or semicolon are end-of-line indicators
*       if( chCard(i:i).eq.':' .or. chCard(i:i).eq.';'.or.
*    1  chCard(i:i).eq.'%')
*    1   then
*         lgMatch = .false.
*         return
*       endif
*     end do
*
      i = index( chCard , chKey )
      if( i.eq. 0 ) then
        lgMatch = .false.
      else
        lgMatch = .true.
      endif
*
      end
******************************************************************************
      subroutine ligbar( ized , t2s2p, t2s3p, cs2s2p , cs2s3p )
      implicit none
*obtain collision strength for any Li-sequence line
      integer ized
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real t2s2p(nta) , t2s3p(nta)
      real cs2s2p , cs2s3p
*
      real eVdegK
*from Physics Today Aug '96, BG13
      parameter (eVdegK=1.1604448e4)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     compute collision strength for Li-seq g-bar approx
*     summarized in Cochrane and McWhirter Physica Scripta 28, 25.
*     ized is nuclear charge, can be anything larger than 2
*     Kirk Korista
*
*     ized is nuclear charge, 6 for carbon, etc
*     t2s2p is tau array for stronger memeber of 2s 2p multiplet,
*     which is treated as two separate lines
*     t2s3p is next transition up, treated as an averaged multiplet
*
*     cs2s2p is the cs for the single 2s2p line that comes in
*     cs2s3p is the multiplet cs for that transition, which is
*     treated as  a multiplet average.  If t2s3p is ever broken
*     up (as t2s2p was) then cs2s3p will be the single line not the multiplet
*
*     T2S2P, T2S3P are line information array, defined in block data
*
      real a , b , c , excit , gbar
*
*     no need to evaluate coll strength if population is zero
      if( t2s2p(ipLnPopl).eq.0. ) then
        cs2s2p = 1.
        cs2s3p = 1.
        return
      endif
*
      if( ized.lt.3 ) then
*       this is a sanity check
        write(qq,'('' LIGBAR called with insane charge, ized='',i4)')
     1  ized
        call insane
      else if( ized .eq. 6 ) then
*       CIV 1549
        a = 0.292
        b = 0.289
        c = 2.67
      else if(ized .eq. 7 ) then
*       NV 1240
        a = 0.387
        b = 0.247
        c = 3.93
      else if(ized .eq. 8 ) then
*       OVI 1035 -- values interpolated
        a = 0.40
        b = 0.256
        c = 4.12
      else if( ized .eq. 10 ) then
*       NeVIII 774
        a = 0.426
        b = 0.273
        c = 4.50
      else if( ized .eq. 12 ) then
*       Mg 10 615 -- these values are general
        a = 0.45
        b = 0.27
        c = 5.0
      else if( ized .eq. 18 ) then
*       Ar 16 365
        a = 0.311
        b = 0.294
        c = 6.65
      else if( ized .eq. 26 ) then
*       Fe 24 213
        a = 0.435
        b = 0.314
        c = 6.92
      else
*       use general formula for all other cases
        a = 0.6 - 1.5 / ( float(ized)-2.)
        b = 0.27
        c = 5.
      endif
*
*     evaluate expression in terms of coefficients
*     tarray(ipLnBolt) = line energy in degrees kelvin
      excit = t2s2p(ipLnBolt)/te
*     excit = e1/(te * 1.380622e-16)
      gbar  = a + b*log( 1./excit + c )
*     tarray(ipLnGF) = gf; tarray(ipLnBolt) excit temp kelvin
      cs2s2p = gbar * 197.47*eVdegK * t2s2p(ipLnGF)/t2s2p(ipLnBolt)
*
*     Small fudge factors to CMcW83 2s-2p fits:
*     fits 3.57% too small compared to R-matrix calc. for Mg X.
*     scaled all, initially, by this constant. Pradhan & Peng (1994)
*     compilation cites a pc with Burgess, which further scales
*     cs(C IV) by 1.0429 and cs(N V) by 0.9691, approximately.
*     The scaled cs(OVI) matched well with Burgess, so no further
*     scaling was done for more highly ionized species.
 
      if ( ized .eq. 6 ) then
       cs2s2p = cs2s2p * 1.08013
      else if( ized .eq. 7 ) then
       cs2s2p = cs2s2p * 1.00370
      else
       cs2s2p = cs2s2p * 1.0357
      endif
 
*
*     use general formula for 2s3p
      a = -0.244
      b = 0.25
      c = 4.
 
*     excit = e2/(te * 1.380622e-16)
      excit = t2s3p(ipLnBolt)/te
      gbar  = a + b*log( 1./excit + c )
*     tarray(ipLnGF) = gf
      cs2s3p = gbar * 197.47*eVdegK *  t2s3p(ipLnGF)/t2s3p(ipLnBolt)
*     cs2s3p = gbar * 197.47*eVdegK *  GF2/(e2/1.60184e-12)
*
      end
******************************************************************************
      integer function LimitSh( ion , nshell , nelem )
      implicit none
*sets upper limit to subshell integrations
      integer nelem
      integer ion , nshell
      integer limelm
      parameter (limelm=30)
      integer KshellLimit
      real EnergyKshell
      common/KshllEnr/ KshellLimit , EnergyKshell
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     this routine returns the high energy limit to the energy range
*     for photoionizatin of a given shell
*
      if( nshell.eq.1 ) then
*       this limit is high energy limit to code unless changed with set kshell
        LimitSh = KshellLimit
*
      else if( nshell.eq.2 ) then
*       this is 2s shell, upper limit is 1s
*     >>chng 96 oct 8, up to high energy limit
*       LimitSh = ipElement(nelem,ion , 1,1)-1
        LimitSh = KshellLimit
*
      else if( nshell.eq.3 ) then
*       this is 2p shell, upper limit is 1s
*     >>chng 96 oct 8, up to high energy limit
*       LimitSh = ipElement(nelem,ion , 1,1)-1
        LimitSh = KshellLimit
*
      else if( nshell.eq.4 ) then
*       this is 3s shell, upper limit is 2p
*     >>chng 96 oct 8, up to K-shell edge
*       LimitSh = ipElement(nelem,ion , 3,1)-1
        LimitSh = ipElement(nelem,ion , 1,1)-1
*
      else if( nshell.eq.5 ) then
*       this is 3p shell, upper limit is 2p
*     >>chng 96 oct 8, up to K-shell edge
*       LimitSh = ipElement(nelem,ion , 3,1)-1
        LimitSh = ipElement(nelem,ion , 1,1)-1
*
      else if( nshell.eq.6 ) then
*       this is 3d shell, upper limit is 2p
*     >>chng 96 oct 8, up to K-shell edge
*       LimitSh = ipElement(nelem,ion , 3,1)-1
        LimitSh = ipElement(nelem,ion , 1,1)-1
*
      else if( nshell.eq.7 ) then
*       this is 4s shell, upper limit is 3d
        if( ipElement(nelem,ion , 6,1).lt.3 ) then
*         this is check for empty shell 6, 3d
*         if so then set to 3p instead
          LimitSh = ipElement(nelem,ion , 5,1)-1
        else
          LimitSh = ipElement(nelem,ion , 6,1)-1
        endif
*     >>chng 96 sep 26, set upper limit down to 2s
        LimitSh = ipElement(nelem,ion , 3,1)-1
*
      else
        write(qq,'('' LimitSh cannot handle nshell as large as'',i4)')
     1  nshell
        stop
      endif
*
      end
******************************************************************************
      subroutine linadd(xInten , lam , chLab , chInfo)
      implicit none
*enter lines into the line storage array, called once per zone
*     xInten - local emissivity per unit vol, no fill fac
*     lam integer wavelength
*     chLab character label for ion
*     chInfo - type of entry for line - given below
      real xInten
      integer lam
      character chLab*4 , chInfo*1
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
*
*     main routine to actually enter lines into the line storage array
*     called at top level within routine lines
*     called series of times in routine PutLine for lines transferred
*
*     chInfo is char variable indicating type of line this is
*     'c' cooling
*     'h' heating
*     'i' information only
*     'r' recombination line
*
      nsum = nsum + 1
      if( ipass .ne. 0) then
*       not first pass, sum lines only
*       total emission from vol
        sumlin(nsum) = sumlin(nsum) + xInten * dVeff
*       local emissivity in line
        emslin(nsum) = xInten
      else
*       check if number of lines in arrays exceeded
        if( nsum.gt.NLINES) then
          write(qq,'(I5,'' lines is too many for LINADD.''
     1    )') nsum
          write(qq,'(1x,a4,i6)') chLab , lam
          write(qq,'('' Increase the value of NLINES everywhere '',
     1    ''in the code.'')')
          stop
        endif
*
        if( chInfo.ne.'c' .and. chInfo.ne.'h' .and. chInfo.ne.'i'.AND.
     1    chInfo.ne.'r' ) then
          write(qq,'('' Type label for line'',I5,A4,'' is '',a1,
     1    '' which I do not understand.'')') lam,chLab,chInfo
        endif
        chSumTyp(nsum) = chInfo
*       number of lines ok, set parameters for first pass
        sumlin(nsum) = 0.
        lin(nsum) = lam
        chALab(nsum) = chLab
      endif
*
      end
******************************************************************************
      subroutine lindst(xInten , lam , chLab , ipnt , chInfo, lgOutToo)
      implicit none
*add local line intensity to line luminosity stack
      real xInten
      logical lgOutToo
      character chLab*4 , chInfo*1
      integer lam , ipnt
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real opac
      common/opac/ opac(ncell)
      real OutFac , RefFac , BeamInIn,BeamInOut,BeamOutOut
*     outward and reflected effective vols
*     used to get outward and reflected beams
*     Beam vars are related to lines where inward and outward fracs known
*     BeamOutOut outward part of outwardly directed beam
*     BeamInIn inward part of inwardly directed beam, 0 if sphere
*     BeamInOut outward part of inwardly directed beam, 0 if not sphere
      common/VolRef/ OutFac , RefFac , BeamInIn,BeamInOut,BeamOutOut
      real tmn
      common/tmn/ tmn(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      character*4  chSMDLab
      common/smdlab/ chSMDLab(NLINES)
      integer ndsum , lind
      real smdlin
      common/dsum/ ndsum , smdlin(NLINES) , lind(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real e2fn,e2
*
*     albeff(ip) = scatop(ip) / (scatop(ip) + opac(ip) )
*
      nsum = nsum + 1
      if( ipass .ne. 0) then
*       not first pass, sum lines only
        sumlin(nsum) = sumlin(nsum) + xInten * dVeff
        emslin(nsum) = xInten
*       add line to outward beam
        if( lgOutToo ) then
*         >>chng 97 sep 02, add tmn
          outlin(ipnt) = outlin(ipnt) + xInten/(anu(ipnt)*en1ryd) *
     1    OutFac *
     2    tmn(ipnt)
          reflin(ipnt) = reflin(ipnt) + xInten/(anu(ipnt)*en1ryd) *
     1    RefFac
        endif
      else
*       check if number of lines in arrays exceeded
        if( nsum.gt.NLINES) then
          if( lgTalk ) write(qq,'(I5,'' lines is too many for LINADD.''
     1    )') nsum
          write(qq,'('' Increase the value of NLINES everywhere '',
     1    ''in the code.'')')
          stop
        endif
*
        if( chInfo.ne.'c'.and.chInfo.ne.'h'.and.chInfo.ne.'i' .and.
     1  chInfo.ne.'r' ) then
          write(qq,'('' Type label for line'',I5,A4,'' is '',A1,
     1    '' which I do not understand.'')') lam,chLab,chInfo
        endif
        chSumTyp(nsum) = chInfo
*       number of lines ok, set parameters for first pass
        sumlin(nsum) = 0.
        lin(nsum) = lam
        chALab(nsum) = chLab
      endif
*
*     this is dust part
      if( lgDustOn ) then
        ndsum = ndsum + 1
        if( ipass .ne. 0) then
*         not first pass, sum lines only
*         evaluate 2nd exponential integral function
*         >>chng 97 nov 5, some variables not defined above nflux
          if( ipnt.le.nflux ) then
            e2fn = e2( tauabs(ipnt,1) , ExpmTau(ipnt) )
*           DSTOTH was unit vol energy lost onto dust by cooling lines
*           dstoth = dstoth + xInten * (1.-e2fn)
            smdlin(ndsum) = smdlin(ndsum) + xInten * dVeff / 2. *
     1      (1. + albedo(ipnt) ) * e2fn
          endif
        else
*         check if number of lines in arrays exceeded
          if( ndsum.gt.NLINES) then
            write(qq,'(I5,'' lines is too many for LINDST'')') ndsum
            write(qq,'('' Increase the value of NLINES everywhere '',
     1      ''in the code.'')')
            stop
          endif
*         number of lines ok, set parameters for first pass
          smdlin(ndsum) = 0.
          lind(ndsum) = lam
          chSMDLab(ndsum) = chLab
        endif
      endif
*
      end
      subroutine LineFit(t,r)
      implicit none
*effective recombination coefficients for lines of C, N, O, by D. Verner
* Version 2, April 30, 1997
******************************************************************************
*** This subroutine calculates effective recombination coefficients
*** for 110 permitted recombination lines of C, N, O (Pequignot, Petitjean,
*** & Boisson, 1991, A&A, 251, 680) and 405 permitted dielectronic
*** recombination lines (Nussbaumer & Storey, 1984, A&AS, 56, 293)
*** Input parameter:   t  - temperature, K
*** Output parameters: r(i,j), i=1,471
***                    r(i,1) - atomic number
***                    r(i,2) - number of electrons
***                    r(i,3) - wavelength, angstrom
***                    r(i,4) - rate coefficient, cm^3 s^(-1)
******************************************************************************
      integer i,j,j1,j2
      real t
      real r(471,4),rr(110,4),dr(405,4)
      real P,ST
      real z,te,p1,p2,p3,p4,p5,p6,a1,a,x
      integer ip(38),id(38),jd(6)
      common/P/P(110,8)
      common/ST/ST(405,9)
      data jd/143,145,157,360,376,379/
      data ip/7,9,12,13,14,16,18,19,20,21,22,44,45,49,50,52,53,54,55,
     *56,57,58,59,60,66,67,78,83,84,87,88,95,96,97,100,101,103,104/
      data id/7,3,10,27,23,49,51,64,38,47,60,103,101,112,120,114,143,
     *145,157,152,169,183,200,163,225,223,237,232,235,249,247,300,276,
     *278,376,360,379,384/
      do i=1,110
         rr(i,1)=P(i,1)
         rr(i,2)=P(i,2)
         rr(i,3)=P(i,3)
         z=P(i,1)-P(i,2)+1.0
         te=1.0e-04*t/z/z
         p1=P(i,4)
         p2=P(i,5)
         p3=P(i,6)
         p4=P(i,7)
         if(te.lt.0.004)then
            a1=p1*0.004**p2/(1.0+p3*0.004**p4)
            a=a1/sqrt(te/0.004)
         else
            if(te.gt.2.0)then
               a1=p1*2.0**p2/(1.0+p3*2.0**p4)
               a=a1/(te/2.0)**1.5
            else
               a=p1*te**p2/(1.0+p3*te**p4)
            endif
         endif
         rr(i,4)=1.0e-13*z*a*P(i,8)
      end do
      do i=1,405
         dr(i,1)=ST(i,1)
         dr(i,2)=ST(i,2)
         dr(i,3)=ST(i,3)
         te=1.0e-04*t
         p1=ST(i,4)
         p2=ST(i,5)
         p3=ST(i,6)
         p4=ST(i,7)
         p5=ST(i,8)
         p6=ST(i,9)
         if(te.lt.p6)then
            x=p5*(1.0/te-1.0/p6)
            if(x.gt.80.0)then
               a=0.0
            else
               a1=(p1/p6+p2+p3*p6+p4*p6*p6)/p6**1.5/exp(p5/p6)
               a=a1/exp(x)
            endif
         else
            if(te.gt.6.0)then
               a1=(p1/6.0+p2+p3*6.0+p4*36.0)/6.0**1.5/exp(p5/6.0)
               a=a1/(te/6.0)**1.5
            else
               a=(p1/te+p2+p3*te+p4*te*te)/te**1.5/exp(p5/te)
            endif
         endif
         dr(i,4)=1.0e-12*a
      end do
      do i=1,6
         j1=jd(i)
         j2=j1+1
         dr(j1,4)=dr(j1,4)+dr(j2,4)
         dr(j2,1)=0.0
      end do
      do i=1,38
         j1=ip(i)
         j2=id(i)
         rr(j1,4)=rr(j1,4)+dr(j2,4)
         dr(j2,1)=0.0
      end do
      do i=1,110
         r(i,1)=rr(i,1)
         r(i,2)=rr(i,2)
         r(i,3)=rr(i,3)
         r(i,4)=rr(i,4)
      end do
      j=110
      do i=1,405
         if(dr(i,1).gt.1.0)then
            j=j+1
            r(j,1)=dr(i,1)
            r(j,2)=dr(i,2)
            r(j,3)=dr(i,3)
            r(j,4)=dr(i,4)
         endif
      end do
      return
      end
*********************************************
      block data reclines
      implicit none
*block data with D Verner's recombination lines
      integer I
      real P,ST
      common/P/P(110,8)
      common/ST/ST(405,9)
      DATA(P(  1,I),I=1,8)/6.,6.,10695.,0.663,-0.679, 0.624,0.681,0.994/
      DATA(P(  2,I),I=1,8)/6.,6., 9088.,0.171,-0.558, 0.624,0.681,0.958/
      DATA(P(  3,I),I=1,8)/6.,6., 9658.,0.054,-0.528, 0.624,0.681,1.000/
      DATA(P(  4,I),I=1,8)/6.,6., 1657.,0.954,-0.665, 0.239,0.687,1.000/
      DATA(P(  5,I),I=1,8)/6.,6., 6828.,0.046,-0.536, 1.504,0.779,0.254/
      DATA(P(  6,I),I=1,8)/6.,5., 9903.,0.697,-0.784, 4.205,0.720,1.000/
      DATA(P(  7,I),I=1,8)/6.,5., 4267.,1.011,-0.754, 2.587,0.719,0.950/
      DATA(P(  8,I),I=1,8)/6.,5., 7231.,1.724,-0.700, 1.683,0.667,0.012/
      DATA(P(  9,I),I=1,8)/6.,5., 6580.,0.584,-0.521, 0.624,0.681,0.170/
      DATA(P( 10,I),I=1,8)/6.,5., 2837.,0.584,-0.521, 0.624,0.681,0.313/
      DATA(P( 11,I),I=1,8)/6.,5., 1761.,0.584,-0.521, 0.624,0.681,0.517/
      DATA(P( 12,I),I=1,8)/6.,5., 1335.,0.953,-0.539, 0.412,0.654,1.000/
      DATA(P( 13,I),I=1,8)/6.,4., 8197.,0.587,-0.780, 7.448,0.720,1.000/
      DATA(P( 14,I),I=1,8)/6.,4., 8665.,0.293,-0.611, 4.486,0.849,0.421/
      DATA(P( 15,I),I=1,8)/6.,4., 2726.,0.293,-0.611, 4.486,0.849,0.574/
      DATA(P( 16,I),I=1,8)/6.,4., 4069.,0.523,-0.784, 4.205,0.720,0.910/
      DATA(P( 17,I),I=1,8)/6.,4., 7613.,0.523,-0.784, 4.205,0.720,0.090/
      DATA(P( 18,I),I=1,8)/6.,4., 3888.,0.359,-0.572, 2.795,0.827,0.119/
      DATA(P( 19,I),I=1,8)/6.,4., 1923.,0.688,-0.754, 2.587,0.719,1.000/
      DATA(P( 20,I),I=1,8)/6.,4., 4649.,0.429,-0.501, 0.624,0.681,0.940/
      DATA(P( 21,I),I=1,8)/6.,4., 4187.,0.174,-0.784, 4.205,0.720,0.980/
      DATA(P( 22,I),I=1,8)/6.,4., 2163.,0.229,-0.754, 2.587,0.719,0.426/
      DATA(P( 23,I),I=1,8)/6.,3., 7726.,0.580,-0.775, 7.448,0.720,1.000/
      DATA(P( 24,I),I=1,8)/6.,3., 4659.,0.519,-0.818, 4.205,0.720,1.000/
      DATA(P( 25,I),I=1,8)/6.,3., 2529.,0.907,-0.749, 4.205,0.720,1.000/
      DATA(P( 26,I),I=1,8)/6.,3., 1549.,3.772,-0.590, 0.889,0.549,1.000/
      DATA(P( 27,I),I=1,8)/7.,7.,10117.,0.601,-0.695, 1.683,0.667,1.000/
      DATA(P( 28,I),I=1,8)/7.,7.,10525.,0.393,-0.697, 1.683,0.667,0.724/
      DATA(P( 29,I),I=1,8)/7.,7., 9829.,0.393,-0.697, 1.683,0.667,0.276/
      DATA(P( 30,I),I=1,8)/7.,7., 8692.,1.254,-0.624, 1.683,0.667,0.957/
      DATA(P( 31,I),I=1,8)/7.,7., 8212.,0.624,-0.602, 1.683,0.667,0.760/
      DATA(P( 32,I),I=1,8)/7.,7., 7452.,0.047,-0.489, 0.624,0.681,0.964/
      DATA(P( 33,I),I=1,8)/7.,7., 1200.,1.437,-0.664, 0.768,0.564,1.000/
      DATA(P( 34,I),I=1,8)/7.,6., 4530.,0.108,-0.754, 2.587,0.719,0.650/
      DATA(P( 35,I),I=1,8)/7.,6., 4026.,0.108,-0.754, 2.587,0.719,0.350/
      DATA(P( 36,I),I=1,8)/7.,6., 4176.,0.085,-0.754, 2.587,0.719,0.542/
      DATA(P( 37,I),I=1,8)/7.,6., 1494.,0.085,-0.754, 2.587,0.719,0.391/
      DATA(P( 38,I),I=1,8)/7.,6., 2232.,0.059,-0.754, 2.587,0.719,0.653/
      DATA(P( 39,I),I=1,8)/7.,6., 4678.,0.059,-0.754, 2.587,0.719,0.223/
      DATA(P( 40,I),I=1,8)/7.,6., 4041.,0.326,-0.754, 2.587,0.719,0.926/
      DATA(P( 41,I),I=1,8)/7.,6., 4552.,0.326,-0.754, 2.587,0.719,0.074/
      DATA(P( 42,I),I=1,8)/7.,6., 4239.,0.252,-0.754, 2.587,0.719,0.887/
      DATA(P( 43,I),I=1,8)/7.,6., 4435.,0.181,-0.754, 2.587,0.719,0.790/
      DATA(P( 44,I),I=1,8)/7.,6., 5005.,0.633,-0.690, 1.683,0.667,1.000/
      DATA(P( 45,I),I=1,8)/7.,6., 5679.,1.200,-0.615, 1.683,0.667,0.337/
      DATA(P( 46,I),I=1,8)/7.,6., 1742.,3.561,-0.615, 1.683,0.667,0.520/
      DATA(P( 47,I),I=1,8)/7.,6., 1345.,3.561,-0.615, 1.683,0.667,0.137/
      DATA(P( 48,I),I=1,8)/7.,5., 8237.,0.587,-0.780, 7.448,0.720,1.000/
      DATA(P( 49,I),I=1,8)/7.,5., 4379.,0.697,-0.784, 4.205,0.720,1.000/
      DATA(P( 50,I),I=1,8)/7.,5., 1885.,1.011,-0.754, 2.587,0.719,0.924/
      DATA(P( 51,I),I=1,8)/7.,5., 4641.,1.434,-0.707, 1.683,0.667,0.005/
      DATA(P( 52,I),I=1,8)/7.,5., 4110.,1.350,-0.734, 0.624,0.681,0.058/
      DATA(P( 53,I),I=1,8)/7.,4., 7703.,0.438,-0.801,10.350,0.717,1.000/
      DATA(P( 54,I),I=1,8)/7.,4., 7582.,0.363,-0.618, 7.778,0.848,0.510/
      DATA(P( 55,I),I=1,8)/7.,4., 4606.,0.587,-0.780, 7.448,0.720,1.000/
      DATA(P( 56,I),I=1,8)/7.,4., 4707.,0.293,-0.611, 4.486,0.849,0.426/
      DATA(P( 57,I),I=1,8)/7.,4., 2646.,0.523,-0.784, 4.205,0.720,0.730/
      DATA(P( 58,I),I=1,8)/7.,4., 1700.,0.523,-0.784, 4.205,0.720,0.235/
      DATA(P( 59,I),I=1,8)/7.,4., 1036.,0.520,-0.754, 2.587,0.719,0.992/
      DATA(P( 60,I),I=1,8)/7.,4., 3481.,0.429,-0.501, 0.624,0.681,0.817/
      DATA(P( 61,I),I=1,8)/7.,3., 7618.,0.550,-0.764,10.350,0.717,1.000/
      DATA(P( 62,I),I=1,8)/7.,3., 4945.,0.566,-0.780, 7.448,0.720,1.000/
      DATA(P( 63,I),I=1,8)/7.,3., 2981.,0.519,-0.818, 4.205,0.720,1.000/
      DATA(P( 64,I),I=1,8)/7.,3., 1620.,0.907,-0.749, 4.205,0.720,1.000/
      DATA(P( 65,I),I=1,8)/8.,8., 8447.,0.226,-0.508, 0.624,0.681,1.000/
      DATA(P( 66,I),I=1,8)/8.,8., 7773.,1.983,-0.630, 0.971,0.573,1.000/
      DATA(P( 67,I),I=1,8)/8.,8., 9264.,1.191,-0.684, 1.683,0.667,1.000/
      DATA(P( 68,I),I=1,8)/8.,8., 3947.,0.264,-0.589, 0.442,0.756,0.158/
      DATA(P( 69,I),I=1,8)/8.,8., 1357.,2.231,-0.630, 0.971,0.573,1.000/
      DATA(P( 70,I),I=1,8)/8.,7., 4342.,0.144,-0.754, 2.587,0.719,1.000/
      DATA(P( 71,I),I=1,8)/8.,7., 4607.,0.112,-0.754, 2.587,0.719,0.880/
      DATA(P( 72,I),I=1,8)/8.,7., 4489.,0.080,-0.754, 2.587,0.719,0.074/
      DATA(P( 73,I),I=1,8)/8.,7., 4094.,0.289,-0.754, 2.587,0.719,1.000/
      DATA(P( 74,I),I=1,8)/8.,7., 4278.,0.225,-0.754, 2.587,0.719,0.880/
      DATA(P( 75,I),I=1,8)/8.,7., 4051.,0.225,-0.754, 2.587,0.719,0.120/
      DATA(P( 76,I),I=1,8)/8.,7., 4294.,0.160,-0.754, 2.587,0.719,0.850/
      DATA(P( 77,I),I=1,8)/8.,7., 4339.,0.160,-0.754, 2.587,0.719,0.150/
      DATA(P( 78,I),I=1,8)/8.,7., 4075.,0.601,-0.695, 1.683,0.667,1.000/
      DATA(P( 79,I),I=1,8)/8.,7., 4111.,0.409,-0.705, 1.683,0.667,0.720/
      DATA(P( 80,I),I=1,8)/8.,7., 3867.,0.409,-0.705, 1.683,0.667,0.280/
      DATA(P( 81,I),I=1,8)/8.,7., 4152.,0.226,-0.679, 1.683,0.667,0.616/
      DATA(P( 82,I),I=1,8)/8.,7., 4913.,0.226,-0.679, 1.683,0.667,0.294/
      DATA(P( 83,I),I=1,8)/8.,7., 4651.,1.257,-0.624, 1.683,0.667,1.000/
      DATA(P( 84,I),I=1,8)/8.,7., 4341.,0.633,-0.609, 1.683,0.667,1.000/
      DATA(P( 85,I),I=1,8)/8.,7., 3736.,0.047,-0.506, 0.624,0.681,1.000/
      DATA(P( 86,I),I=1,8)/8.,6., 4435.,0.155,-0.784, 4.205,0.720,1.000/
      DATA(P( 87,I),I=1,8)/8.,6., 3265.,0.633,-0.690, 1.683,0.667,1.000/
      DATA(P( 88,I),I=1,8)/8.,6., 3762.,1.200,-0.615, 1.683,0.667,0.383/
      DATA(P( 89,I),I=1,8)/8.,6., 5592.,0.050,-0.508, 0.624,0.691,0.220/
      DATA(P( 90,I),I=1,8)/8.,5., 7713.,0.438,-0.801,10.350,0.717,1.000/
      DATA(P( 91,I),I=1,8)/8.,5., 7677.,0.363,-0.618, 7.778,0.848,0.510/
      DATA(P( 92,I),I=1,8)/8.,5., 4632.,0.587,-0.780, 7.448,0.720,1.000/
      DATA(P( 93,I),I=1,8)/8.,5., 4344.,0.391,-0.611, 4.486,0.849,0.450/
      DATA(P( 94,I),I=1,8)/8.,5., 2450.,0.697,-0.784, 4.205,0.720,0.913/
      DATA(P( 95,I),I=1,8)/8.,5., 1068.,0.906,-0.740, 2.587,0.719,0.406/
      DATA(P( 96,I),I=1,8)/8.,5., 3409.,0.700,-0.700, 1.683,0.667,0.003/
      DATA(P( 97,I),I=1,8)/8.,5., 3066.,0.430,-0.473, 0.624,0.681,0.117/
      DATA(P( 98,I),I=1,8)/8.,4., 7611.,0.354,-0.812,14.400,0.712,1.000/
      DATA(P( 99,I),I=1,8)/8.,4., 7592.,0.311,-0.641,11.480,0.846,0.563/
      DATA(P(100,I),I=1,8)/8.,4., 2993.,0.311,-0.641,11.480,0.846,0.430/
      DATA(P(101,I),I=1,8)/8.,4., 4930.,0.438,-0.801,10.350,0.717,1.000/
      DATA(P(102,I),I=1,8)/8.,4., 1845.,0.363,-0.618, 7.778,0.848,0.470/
      DATA(P(103,I),I=1,8)/8.,4., 2942.,0.587,-0.780, 7.448,0.720,1.000/
      DATA(P(104,I),I=1,8)/8.,4., 1644.,0.492,-0.784, 4.205,0.720,0.850/
      DATA(P(105,I),I=1,8)/8.,4., 1708.,0.164,-0.784, 4.205,0.720,0.680/
      DATA(P(106,I),I=1,8)/8.,3., 5291.,0.545,-0.764,10.350,0.717,1.000/
      DATA(P(107,I),I=1,8)/8.,3., 2082.,0.331,-0.553,11.480,0.846,1.000/
      DATA(P(108,I),I=1,8)/8.,3., 3434.,0.566,-0.780, 7.448,0.720,1.000/
      DATA(P(109,I),I=1,8)/8.,3., 2070.,0.519,-0.818, 4.205,0.720,1.000/
      DATA(P(110,I),I=1,8)/8.,3., 1125.,0.907,-0.749, 4.205,0.720,1.000/
      DATA(ST(  1,I),I=1,9)/6.,6., 1140.1, 0.0000, 0.4616,
     * 0.0000, 0.0000, 1.0136,0.10/
      DATA(ST(  2,I),I=1,9)/6.,5., 8797.3, 0.0000, 0.0859,
     * 0.0000, 0.0000, 0.4749,0.10/
      DATA(ST(  3,I),I=1,9)/6.,5., 6579.3, 0.0619,-0.1724,
     * 0.1524,-0.0055, 1.6026,0.30/
      DATA(ST(  4,I),I=1,9)/6.,5., 5113.4, 0.0000, 0.3787,
     * 0.0000, 0.0000, 3.6080,0.15/
      DATA(ST(  5,I),I=1,9)/6.,5., 4961.1, 0.0000, 0.0273,
     * 0.0000, 0.0000, 0.7948,0.10/
      DATA(ST(  6,I),I=1,9)/6.,5., 4619.1,-0.0004, 0.9778,
     * 0.0002, 0.0000, 3.5887,0.15/
      DATA(ST(  7,I),I=1,9)/6.,5., 4267.2, 0.8583,-1.9394,
     * 1.1805,-0.0323, 5.6506,0.60/
      DATA(ST(  8,I),I=1,9)/6.,5., 4142.4, 0.0000, 0.1297,
     * 0.0000, 0.0000, 2.3123,0.10/
      DATA(ST(  9,I),I=1,9)/6.,5., 3165.7, 0.0001, 0.3373,
     * 0.0000, 0.0000, 5.0189,0.20/
      DATA(ST( 10,I),I=1,9)/6.,5., 1335.3, 1.5568, 3.9044,
     * 2.6807,-0.0123, 0.5834,0.10/
      DATA(ST( 11,I),I=1,9)/6.,5., 1167.5, 0.0000, 0.2038,
     * 0.0000, 0.0000, 0.7948,0.10/
      DATA(ST( 12,I),I=1,9)/6.,5., 1092.5, 0.0000, 0.7724,
     * 0.0001, 0.0000, 0.7948,0.10/
      DATA(ST( 13,I),I=1,9)/6.,5., 1036.8, 0.4879, 0.1712,
     * 1.3281,-0.0308, 0.9202,0.10/
      DATA(ST( 14,I),I=1,9)/6.,5.,  971.1,-0.0003, 6.4693,
     * 0.0006,-0.0001, 7.4627,0.25/
      DATA(ST( 15,I),I=1,9)/6.,5.,  952.5,-0.0003, 3.3894,
     * 0.0003, 0.0000, 5.7634,0.20/
      DATA(ST( 16,I),I=1,9)/6.,5.,  946.1, 0.0001, 1.4276,
     * 0.0001, 0.0000, 0.7949,0.10/
      DATA(ST( 17,I),I=1,9)/6.,5.,  799.8,-0.0001, 6.8606,
     * 0.0002, 0.0000, 0.4749,0.10/
      DATA(ST( 18,I),I=1,9)/6.,4.,14382.5, 0.0291,-0.1855,
     * 0.3267,-0.0338, 4.6059,0.20/
      DATA(ST( 19,I),I=1,9)/6.,4.,13986.1, 0.0263,-0.0947,
     * 0.1296,-0.0109, 3.7460,0.30/
      DATA(ST( 20,I),I=1,9)/6.,4.,13717.4, 0.0859,-0.5480,
     * 0.9649,-0.0997, 4.6058,0.20/
      DATA(ST( 21,I),I=1,9)/6.,4.,13579.6, 0.1094,-0.2675,
     * 0.1883,-0.0090, 2.0379,0.40/
      DATA(ST( 22,I),I=1,9)/6.,4., 9700.4, 0.0002, 0.0060,
     * 0.0004, 0.0000, 0.3000,0.10/
      DATA(ST( 23,I),I=1,9)/6.,4., 8664.6, 0.0886,-0.2722,
     * 0.2362,-0.0138, 2.0358,0.35/
      DATA(ST( 24,I),I=1,9)/6.,4., 8340.8, 0.0116, 0.1716,
     * 0.0132,-0.0005, 0.3184,0.10/
      DATA(ST( 25,I),I=1,9)/6.,4., 8315.1, 0.0000, 0.3579,
     * 0.0001, 0.0000, 5.3545,0.20/
      DATA(ST( 26,I),I=1,9)/6.,4., 8226.2, 0.0001, 0.3041,
     * 0.0000, 0.0000, 5.3518,0.20/
      DATA(ST( 27,I),I=1,9)/6.,4., 8196.5, 0.3807,-1.1942,
     * 1.0595,-0.0718, 2.3905,0.40/
      DATA(ST( 28,I),I=1,9)/6.,4., 8196.5, 0.1278,-0.4040,
     * 0.3619,-0.0250, 2.4353,0.40/
      DATA(ST( 29,I),I=1,9)/6.,4., 8189.1, 0.0005, 0.5632,
     * 0.0001, 0.0000, 5.3503,0.20/
      DATA(ST( 30,I),I=1,9)/6.,4., 7597.8, 0.0287,-0.1106,
     * 0.1235,-0.0069, 1.7323,0.30/
      DATA(ST( 31,I),I=1,9)/6.,4., 6740.3, 0.0207,-0.0509,
     * 0.0782,-0.0023, 0.5355,0.10/
      DATA(ST( 32,I),I=1,9)/6.,4., 5826.2, 0.0018, 0.0078,
     * 0.0026, 0.0000, 0.4390,0.10/
      DATA(ST( 33,I),I=1,9)/6.,4., 5305.3, 0.0298,-0.1075,
     * 0.1472,-0.0124, 3.7460,0.30/
      DATA(ST( 34,I),I=1,9)/6.,4., 5263.1, 0.0008, 0.0046,
     * 0.0017,-0.0001, 0.4000,0.10/
      DATA(ST( 35,I),I=1,9)/6.,4., 5133.4, 0.1048,-0.2563,
     * 0.1805,-0.0086, 2.0382,0.40/
      DATA(ST( 36,I),I=1,9)/6.,4., 4717.9, 0.0000, 0.2144,
     * 0.0000, 0.0000, 3.6259,0.15/
      DATA(ST( 37,I),I=1,9)/6.,4., 4662.4, 0.0019, 0.0063,
     * 0.0042,-0.0002, 0.4188,0.10/
      DATA(ST( 38,I),I=1,9)/6.,4., 4648.8, 0.1151,-0.1057,
     * 0.3451,-0.0113, 0.4817,0.10/
      DATA(ST( 39,I),I=1,9)/6.,4., 4593.2, 0.0005, 0.6813,
     * 0.0001, 0.0000, 3.6254,0.15/
      DATA(ST( 40,I),I=1,9)/6.,4., 4542.7, 0.0000, 0.0064,
     * 0.0000, 0.0000, 0.2711,0.10/
      DATA(ST( 41,I),I=1,9)/6.,4., 4429.2, 0.0000, 0.4345,
     * 0.0001, 0.0000, 3.5947,0.15/
      DATA(ST( 42,I),I=1,9)/6.,4., 4395.3, 0.0000, 0.0074,
     * 0.0000, 0.0000, 0.3643,0.10/
      DATA(ST( 43,I),I=1,9)/6.,4., 4371.1, 0.0000, 0.3019,
     * 0.0000, 0.0000, 3.6551,0.15/
      DATA(ST( 44,I),I=1,9)/6.,4., 4330.0, 0.0005, 1.3291,
     * 0.0000, 0.0000, 3.5934,0.15/
      DATA(ST( 45,I),I=1,9)/6.,4., 4325.5, 0.0013, 0.0060,
     * 0.0021,-0.0001, 0.4500,0.10/
      DATA(ST( 46,I),I=1,9)/6.,4., 4300.8, 0.0000, 0.2610,
     * 0.0000, 0.0000, 3.6685,0.15/
      DATA(ST( 47,I),I=1,9)/6.,4., 4187.0, 0.1051,-0.4050,
     * 0.4552,-0.0261, 1.7717,0.30/
      DATA(ST( 48,I),I=1,9)/6.,4., 4158.7, 0.0116,-0.0223,
     * 0.0367,-0.0009, 0.4847,0.10/
      DATA(ST( 49,I),I=1,9)/6.,4., 4069.4, 0.2862,-1.1021,
     * 1.2297,-0.0691, 1.7324,0.30/
      DATA(ST( 50,I),I=1,9)/6.,4., 3927.4, 0.0003, 0.5449,
     * 0.0000, 0.0000, 3.6034,0.15/
      DATA(ST( 51,I),I=1,9)/6.,4., 3887.1, 0.0177,-0.0341,
     * 0.0559,-0.0013, 0.4847,0.10/
      DATA(ST( 52,I),I=1,9)/6.,4., 3602.6, 0.0000, 0.2012,
     * 0.0000, 0.0000, 3.3809,0.15/
      DATA(ST( 53,I),I=1,9)/6.,4., 3414.9, 0.0000, 0.0060,
     * 0.0000, 0.0000, 0.2711,0.10/
      DATA(ST( 54,I),I=1,9)/6.,4., 3385.2, 0.0000, 0.0554,
     * 0.0000, 0.0000, 0.3472,0.10/
      DATA(ST( 55,I),I=1,9)/6.,4., 2512.2, 0.0000, 0.5505,
     * 0.0000, 0.0000, 0.3472,0.10/
      DATA(ST( 56,I),I=1,9)/6.,4., 2440.0, 0.0000, 0.1694,
     * 0.0000, 0.0000, 0.2711,0.10/
      DATA(ST( 57,I),I=1,9)/6.,4., 2296.9, 0.8743, 3.8841,
     * 1.4779,-0.0483, 0.4521,0.10/
      DATA(ST( 58,I),I=1,9)/6.,4., 2296.1, 0.0000, 0.4000,
     * 0.0000, 0.0000, 0.5770,0.10/
      DATA(ST( 59,I),I=1,9)/6.,4., 2200.4, 0.0000, 0.5229,
     * 0.0000, 0.0000, 0.4931,0.10/
      DATA(ST( 60,I),I=1,9)/6.,4., 2162.9, 0.0396,-0.0138,
     * 0.1125, 0.0029, 0.5586,0.10/
      DATA(ST( 61,I),I=1,9)/6.,4., 2114.3, 0.0000, 0.3575,
     * 0.0000, 0.0000, 0.3472,0.10/
      DATA(ST( 62,I),I=1,9)/6.,4., 2017.4, 0.0000, 0.8108,
     * 0.0000, 0.0000, 0.4931,0.10/
      DATA(ST( 63,I),I=1,9)/6.,4., 1923.3, 0.0000, 0.3165,
     * 0.0000, 0.0000, 0.4931,0.10/
      DATA(ST( 64,I),I=1,9)/6.,4., 1923.1, 0.2666,-0.3774,
     * 0.7627, 0.0310, 0.6278,0.10/
      DATA(ST( 65,I),I=1,9)/6.,4., 1828.0,-0.0001, 3.8078,
     *-0.0002, 0.0000, 0.2711,0.10/
      DATA(ST( 66,I),I=1,9)/6.,4., 1796.8, 0.0000, 0.2882,
     * 0.0000, 0.0000, 0.3643,0.10/
      DATA(ST( 67,I),I=1,9)/6.,4., 1777.9, 0.0000, 0.1239,
     * 0.0000, 0.0000, 0.4931,0.10/
      DATA(ST( 68,I),I=1,9)/6.,4., 1701.6, 0.0000, 0.1853,
     * 0.0000, 0.0000, 0.3240,0.10/
      DATA(ST( 69,I),I=1,9)/6.,4., 1633.6, 0.0000, 0.2130,
     * 0.0000, 0.0000, 0.3240,0.10/
      DATA(ST( 70,I),I=1,9)/6.,4., 1620.3, 0.0243, 0.0381,
     * 0.0513,-0.0017, 0.4200,0.10/
      DATA(ST( 71,I),I=1,9)/6.,4., 1577.1, 0.2336, 3.4440,
     * 0.2656,-0.0109, 0.3185,0.10/
      DATA(ST( 72,I),I=1,9)/6.,4., 1548.9, 0.0000, 0.2776,
     * 0.0000, 0.0000, 0.3643,0.10/
      DATA(ST( 73,I),I=1,9)/6.,4., 1516.3, 0.0000, 0.1069,
     * 0.0000, 0.0000, 0.3472,0.10/
      DATA(ST( 74,I),I=1,9)/6.,4., 1491.2, 0.0000, 0.3415,
     * 0.0000, 0.0000, 0.3240,0.10/
      DATA(ST( 75,I),I=1,9)/6.,4., 1480.4, 0.0000, 0.1479,
     * 0.0000, 0.0000, 0.5770,0.10/
      DATA(ST( 76,I),I=1,9)/6.,4., 1478.1, 0.0000, 0.4007,
     * 0.0000, 0.0000, 0.4931,0.10/
      DATA(ST( 77,I),I=1,9)/6.,4., 1381.7, 0.0128, 0.0598,
     * 0.0227,-0.0012, 0.4327,0.10/
      DATA(ST( 78,I),I=1,9)/6.,4., 1296.3, 0.1194,-0.2296,
     * 0.3770,-0.0090, 0.4847,0.10/
      DATA(ST( 79,I),I=1,9)/6.,4., 1247.4,-0.0001, 0.8535,
     * 0.5001,-0.0341, 0.6671,0.10/
      DATA(ST( 80,I),I=1,9)/6.,4., 1175.7, 0.3864, 3.1446,
     * 1.1348,-0.0611, 0.4130,0.10/
      DATA(ST( 81,I),I=1,9)/6.,4.,  977.0, 0.8323, 5.1970,
     * 2.5875,-0.0812, 0.4437,0.10/
      DATA(ST( 82,I),I=1,9)/6.,4.,  574.3, 0.0980, 0.1127,
     * 0.2229, 0.0007, 0.4990,0.10/
      DATA(ST( 83,I),I=1,9)/6.,4.,  538.2, 0.1342,-0.1435,
     * 0.4201,-0.0134, 0.4903,0.10/
      DATA(ST( 84,I),I=1,9)/6.,4.,  511.5, 0.0589, 0.2539,
     * 0.0849,-0.0015, 0.4390,0.10/
      DATA(ST( 85,I),I=1,9)/6.,4.,  493.5, 0.1009, 0.5483,
     * 0.2102,-0.0138, 0.5706,0.10/
      DATA(ST( 86,I),I=1,9)/6.,4.,  492.6, 0.0728, 0.3386,
     * 0.1285,-0.0069, 0.4327,0.10/
      DATA(ST( 87,I),I=1,9)/6.,4.,  483.7, 0.0718, 0.3649,
     * 0.1455,-0.0090, 0.5733,0.10/
      DATA(ST( 88,I),I=1,9)/6.,4.,  476.0, 0.0000, 1.1418,
     * 0.0000, 0.0000, 0.9157,0.10/
      DATA(ST( 89,I),I=1,9)/6.,4.,  459.6, 0.9723, 2.2972,
     * 1.8844,-0.0286, 0.3893,0.10/
      DATA(ST( 90,I),I=1,9)/6.,4.,  450.7, 0.0000, 0.2904,
     * 0.0481,-0.0036, 0.3764,0.10/
      DATA(ST( 91,I),I=1,9)/6.,4.,  433.3, 0.0453, 0.1992,
     * 0.0720,-0.0020, 0.4534,0.10/
      DATA(ST( 92,I),I=1,9)/6.,4.,  411.7, 0.0001, 4.3059,
     * 0.0000, 0.0000, 0.3643,0.10/
      DATA(ST( 93,I),I=1,9)/6.,4.,  398.4, 0.0001, 2.6254,
     * 0.0002, 0.0000, 0.3240,0.10/
      DATA(ST( 94,I),I=1,9)/6.,4.,  371.7, 0.1225, 0.1922,
     * 0.2586,-0.0088, 0.4200,0.10/
      DATA(ST( 95,I),I=1,9)/7.,7.,10594.8, 0.0000, 0.0135,
     * 0.0000, 0.0000, 0.4078,0.10/
      DATA(ST( 96,I),I=1,9)/7.,7., 9048.1, 0.0000, 0.0190,
     * 0.0024,-0.0003, 0.3710,0.10/
      DATA(ST( 97,I),I=1,9)/7.,7., 8180.4, 0.0000, 0.0064,
     * 0.0003, 0.0000, 0.3500,0.10/
      DATA(ST( 98,I),I=1,9)/7.,7., 1000.2, 0.0000, 0.0395,
     * 0.0000, 0.0000, 0.2727,0.10/
      DATA(ST( 99,I),I=1,9)/7.,7.,  994.2, 0.0000, 0.0721,
     * 0.0000, 0.0000, 0.3594,0.10/
      DATA(ST(100,I),I=1,9)/7.,7.,  980.7, 0.0000, 0.4728,
     * 0.0000, 0.0000, 0.5591,0.10/
      DATA(ST(101,I),I=1,9)/7.,6., 5679.6, 0.0234,-0.0852,
     * 0.0927,-0.0056, 2.3686,0.30/
      DATA(ST(102,I),I=1,9)/7.,6., 5495.1, 0.0000, 0.0781,
     * 0.0000, 0.0000, 1.1623,0.10/
      DATA(ST(103,I),I=1,9)/7.,6., 5004.4, 0.0704,-0.1990,
     * 0.1603,-0.0099, 3.3831,0.40/
      DATA(ST(104,I),I=1,9)/7.,6., 4724.1, 0.0000, 0.0186,
     * 0.0000, 0.0000, 0.7718,0.10/
      DATA(ST(105,I),I=1,9)/7.,6., 1085.1, 0.0005, 0.8561,
     * 2.3770,-0.1017, 0.8595,0.10/
      DATA(ST(106,I),I=1,9)/7.,6.,  916.3, 0.0143,-0.2447,
     * 1.1821, 0.0132, 0.8461,0.10/
      DATA(ST(107,I),I=1,9)/7.,6.,  646.4, 0.0009, 2.2631,
     * 0.0000, 0.0000, 1.1627,0.10/
      DATA(ST(108,I),I=1,9)/7.,5., 6938.2, 0.0000, 0.2206,
     * 0.0000, 0.0000, 0.7295,0.10/
      DATA(ST(109,I),I=1,9)/7.,5., 5334.7, 0.0000, 0.1260,
     * 0.0000, 0.0000, 0.9211,0.10/
      DATA(ST(110,I),I=1,9)/7.,5., 4507.5, 0.0005, 0.8446,
     * 0.0000, 0.0000, 4.0119,0.15/
      DATA(ST(111,I),I=1,9)/7.,5., 4477.8, 0.0004, 1.0155,
     * 0.0001, 0.0000, 4.0085,0.15/
      DATA(ST(112,I),I=1,9)/7.,5., 4373.6, 0.0000, 0.9660,
     * 0.0001, 0.0000, 4.0183,0.15/
      DATA(ST(113,I),I=1,9)/7.,5., 4199.6, 0.0149, 0.0226,
     * 0.0304,-0.0002, 0.8516,0.10/
      DATA(ST(114,I),I=1,9)/7.,5., 4099.4, 0.0000, 0.0194,
     * 0.0280,-0.0010, 0.8274,0.10/
      DATA(ST(115,I),I=1,9)/7.,5., 4001.8, 0.0023, 0.0256,
     * 0.0027, 0.0000, 0.8500,0.10/
      DATA(ST(116,I),I=1,9)/7.,5., 3429.0, 0.0000, 0.1420,
     * 0.0000, 0.0000, 2.8512,0.10/
      DATA(ST(117,I),I=1,9)/7.,5., 2197.8, 0.0000, 0.2454,
     * 0.0001, 0.0000, 0.7958,0.10/
      DATA(ST(118,I),I=1,9)/7.,5., 2188.1,-0.0001, 1.7355,
     *-0.0001, 0.0000, 0.8199,0.10/
      DATA(ST(119,I),I=1,9)/7.,5., 2064.3, 0.0001, 4.2360,
     * 0.0014,-0.0001, 0.7958,0.10/
      DATA(ST(120,I),I=1,9)/7.,5., 1885.1, 0.4468,-0.8007,
     * 0.3715, 0.0369, 3.0634,0.45/
      DATA(ST(121,I),I=1,9)/7.,5., 1857.2, 0.0000, 0.3940,
     * 0.0000, 0.0000, 0.8200,0.10/
      DATA(ST(122,I),I=1,9)/7.,5., 1498.3, 0.0000, 0.9684,
     * 0.0000, 0.0000, 0.7295,0.10/
      DATA(ST(123,I),I=1,9)/7.,5.,  991.0, 2.8315,12.9695,
     *16.8995,-0.5167, 0.8162,0.10/
      DATA(ST(124,I),I=1,9)/7.,5.,  979.9, 0.1764,-0.4582,
     * 0.6309, 0.0215, 1.0251,0.10/
      DATA(ST(125,I),I=1,9)/7.,5.,  782.9, 0.0014, 6.8449,
     * 0.0000, 0.0000, 1.7651,0.10/
      DATA(ST(126,I),I=1,9)/7.,5.,  764.0, 1.1769, 3.6750,
     * 3.8084,-0.1470, 0.9780,0.10/
      DATA(ST(127,I),I=1,9)/7.,5.,  685.7, 0.5940,-0.4426,
     * 4.3937,-0.3217, 0.9795,0.10/
      DATA(ST(128,I),I=1,9)/7.,5.,  472.3,-0.0545, 1.1395,
     * 0.1343,-0.0013, 0.7456,0.10/
      DATA(ST(129,I),I=1,9)/7.,5.,  418.8, 0.4465, 3.5875,
     * 0.5445,-0.0132, 0.8626,0.10/
      DATA(ST(130,I),I=1,9)/7.,5.,  411.3, 0.0000, 1.3202,
     *-0.0001, 0.0000, 0.9211,0.10/
      DATA(ST(131,I),I=1,9)/7.,5.,  391.3, 0.0022, 9.8112,
     * 0.0001, 0.0000, 2.7078,0.10/
      DATA(ST(132,I),I=1,9)/7.,5.,  387.4,-0.0002, 5.2820,
     *-0.0002, 0.0000, 0.9211,0.10/
      DATA(ST(133,I),I=1,9)/7.,5.,  374.4, 0.0961,-1.1219,
     * 4.6102,-0.4746, 0.8564,0.10/
      DATA(ST(134,I),I=1,9)/7.,5.,  348.7,-0.0004,15.4012,
     *-0.0006, 0.0001, 0.7295,0.10/
      DATA(ST(135,I),I=1,9)/7.,5.,  340.2, 0.0045,18.4734,
     *-0.0004, 0.0001, 1.7651,0.10/
      DATA(ST(136,I),I=1,9)/7.,5.,  323.3, 0.0341,32.2696,
     *-0.0123, 0.0018, 3.9830,0.15/
      DATA(ST(137,I),I=1,9)/7.,5.,  311.6, 0.2238, 0.3397,
     * 0.4567,-0.0033, 0.8515,0.10/
      DATA(ST(138,I),I=1,9)/7.,4., 9203.0, 0.0111,-0.1354,
     * 0.4831,-0.0482, 0.5315,0.10/
      DATA(ST(139,I),I=1,9)/7.,4., 7850.8, 0.0097, 0.0216,
     * 0.0354, 0.0009, 1.5444,0.10/
      DATA(ST(140,I),I=1,9)/7.,4., 7760.0, 0.0000, 0.5947,
     *-0.0001, 0.0000, 6.4512,0.25/
      DATA(ST(141,I),I=1,9)/7.,4., 7742.0,-0.0001, 0.5524,
     * 0.0000, 0.0000, 6.4494,0.25/
      DATA(ST(142,I),I=1,9)/7.,4., 7740.8,-0.0002, 0.8844,
     *-0.0004, 0.0000, 6.4485,0.25/
      DATA(ST(143,I),I=1,9)/7.,4., 7703.2, 0.0783,-0.2678,
     * 0.2577,-0.0190, 3.3144,0.35/
      DATA(ST(144,I),I=1,9)/7.,4., 7703.2, 0.2348,-0.8031,
     * 0.7726,-0.0569, 3.3133,0.35/
      DATA(ST(145,I),I=1,9)/7.,4., 7582.3, 0.1075,-0.3417,
     * 0.3133,-0.0219, 3.0892,0.35/
      DATA(ST(146,I),I=1,9)/7.,4., 7581.7, 0.0404,-0.1053,
     * 0.0858,-0.0048, 2.5490,0.30/
      DATA(ST(147,I),I=1,9)/7.,4., 5209.1, 0.0000, 0.0043,
     * 0.0195,-0.0018, 0.4783,0.20/
      DATA(ST(148,I),I=1,9)/7.,4., 4803.6, 0.0202,-0.0542,
     * 0.0678,-0.0040, 1.8505,0.15/
      DATA(ST(149,I),I=1,9)/7.,4., 4757.2, 0.0000, 0.3191,
     * 0.0000, 0.0000, 4.5945,0.15/
      DATA(ST(150,I),I=1,9)/7.,4., 4745.2, 0.0003, 0.5548,
     * 0.0000, 0.0000, 4.6121,0.15/
      DATA(ST(151,I),I=1,9)/7.,4., 4708.1, 0.0000, 0.3688,
     * 0.0000, 0.0000, 4.5974,0.15/
      DATA(ST(152,I),I=1,9)/7.,4., 4707.4, 0.0814,-0.2208,
     * 0.2735,-0.0166, 1.8703,0.15/
      DATA(ST(153,I),I=1,9)/7.,4., 4705.7, 0.0025, 1.1065,
     * 0.0002, 0.0000, 4.5996,0.15/
      DATA(ST(154,I),I=1,9)/7.,4., 4680.1, 0.0000, 0.5669,
     *-0.0001, 0.0000, 4.5904,0.15/
      DATA(ST(155,I),I=1,9)/7.,4., 4676.2,-0.0001, 1.7011,
     * 0.0004,-0.0001, 4.5902,0.15/
      DATA(ST(156,I),I=1,9)/7.,4., 4640.1, 0.0010, 0.9578,
     *-0.0001, 0.0000, 4.5926,0.15/
      DATA(ST(157,I),I=1,9)/7.,4., 4606.4, 0.2266,-1.0525,
     * 1.4037,-0.1084, 2.6627,0.25/
      DATA(ST(158,I),I=1,9)/7.,4., 4606.2, 0.0951,-0.3764,
     * 0.4486,-0.0331, 2.4572,0.25/
      DATA(ST(159,I),I=1,9)/7.,4., 4512.8, 0.0002, 0.0054,
     * 0.0129,-0.0011, 0.5497,0.20/
      DATA(ST(160,I),I=1,9)/7.,4., 4289.9, 0.0154,-0.0448,
     * 0.0594,-0.0039, 1.6851,0.20/
      DATA(ST(161,I),I=1,9)/7.,4., 4124.4, 0.0000, 0.3355,
     * 0.0000, 0.0000, 4.6276,0.15/
      DATA(ST(162,I),I=1,9)/7.,4., 4073.5, 0.0004, 0.5100,
     *-0.0001, 0.0000, 4.5780,0.15/
      DATA(ST(163,I),I=1,9)/7.,4., 3480.9, 0.0045,-0.0291,
     * 0.6366,-0.0515, 0.1742,0.10/
      DATA(ST(164,I),I=1,9)/7.,4., 3459.1,-0.0001, 0.0048,
     * 0.0060,-0.0004, 0.2000,0.10/
      DATA(ST(165,I),I=1,9)/7.,4., 3200.9, 0.0000, 0.0110,
     * 0.0000, 0.0000, 0.2391,0.10/
      DATA(ST(166,I),I=1,9)/7.,4., 3078.3, 0.0405, 0.0627,
     * 0.0874,-0.0040, 1.6451,0.10/
      DATA(ST(167,I),I=1,9)/7.,4., 3004.1,-0.0005, 0.0186,
     * 0.0007, 0.0000, 0.2062,0.10/
      DATA(ST(168,I),I=1,9)/7.,4., 2664.4, 0.0000, 0.1852,
     * 0.0000, 0.0000, 0.2391,0.10/
      DATA(ST(169,I),I=1,9)/7.,4., 2646.4, 0.3066, 0.6885,
     * 0.7846,-0.0310, 1.6158,0.10/
      DATA(ST(170,I),I=1,9)/7.,4., 2630.2, 0.0001, 0.6841,
     * 0.0000, 0.0000, 1.5424,0.10/
      DATA(ST(171,I),I=1,9)/7.,4., 2602.6, 0.0002, 1.1617,
     *-0.0001, 0.0000, 1.5171,0.10/
      DATA(ST(172,I),I=1,9)/7.,4., 2574.6, 0.0001, 2.1507,
     * 0.0003, 0.0000, 1.5406,0.10/
      DATA(ST(173,I),I=1,9)/7.,4., 2550.6,-0.0001, 3.5429,
     * 0.0002, 0.0000, 1.5142,0.10/
      DATA(ST(174,I),I=1,9)/7.,4., 2457.1, 0.0000, 0.1785,
     * 0.0000, 0.0000, 0.2391,0.10/
      DATA(ST(175,I),I=1,9)/7.,4., 2430.8,-0.0019, 0.0709,
     * 0.0026,-0.0001, 0.2062,0.10/
      DATA(ST(176,I),I=1,9)/7.,4., 2418.8, 0.0002, 0.8460,
     * 0.0001, 0.0000, 1.5806,0.10/
      DATA(ST(177,I),I=1,9)/7.,4., 2318.1, 0.0054,-0.0820,
     * 0.3300,-0.0360, 0.6469,0.10/
      DATA(ST(178,I),I=1,9)/7.,4., 2234.7, 0.0001, 1.1331,
     * 0.0000, 0.0000, 1.5707,0.10/
      DATA(ST(179,I),I=1,9)/7.,4., 2190.2, 0.0002, 1.8069,
     *-0.0001, 0.0000, 1.4918,0.10/
      DATA(ST(180,I),I=1,9)/7.,4., 2159.5, 0.0000, 0.5740,
     * 0.0000, 0.0000, 1.0459,0.10/
      DATA(ST(181,I),I=1,9)/7.,4., 2080.3, 0.1309, 0.2038,
     * 0.2829,-0.0129, 1.6449,0.10/
      DATA(ST(182,I),I=1,9)/7.,4., 1718.6, 0.0751,-1.3414,
     * 6.4456,-0.6185, 0.3433,0.10/
      DATA(ST(183,I),I=1,9)/7.,4., 1699.8, 0.1002, 0.2187,
     * 0.2544,-0.0103, 1.6169,0.10/
      DATA(ST(184,I),I=1,9)/7.,4., 1325.3, 0.0667,-0.8159,
     * 2.9104,-0.2907, 0.5315,0.10/
      DATA(ST(185,I),I=1,9)/7.,4., 1279.7, 0.0025,-0.0455,
     * 0.2315,-0.0235, 0.5303,0.10/
      DATA(ST(186,I),I=1,9)/7.,4., 1271.6, 0.0036,-0.0444,
     * 0.2866,-0.0275, 0.1932,0.10/
      DATA(ST(187,I),I=1,9)/7.,4., 1260.3, 0.0000, 0.8144,
     * 0.0000, 0.0000, 1.0459,0.10/
      DATA(ST(188,I),I=1,9)/7.,4., 1255.8,-0.0014, 1.1562,
     * 0.3338,-0.0313, 1.4122,0.10/
      DATA(ST(189,I),I=1,9)/7.,4., 1239.8, 0.0002, 1.2463,
     * 0.0000, 0.0000, 1.4918,0.10/
      DATA(ST(190,I),I=1,9)/7.,4., 1233.8, 0.0000, 1.0352,
     * 0.0001, 0.0000, 1.5142,0.10/
      DATA(ST(191,I),I=1,9)/7.,4., 1231.0, 0.0001, 0.8813,
     * 0.0001, 0.0000, 1.5406,0.10/
      DATA(ST(192,I),I=1,9)/7.,4., 1230.4, 0.0002, 0.6921,
     * 0.0000, 0.0000, 1.5806,0.10/
      DATA(ST(193,I),I=1,9)/7.,4., 1228.4, 0.0000, 0.6558,
     * 0.0001, 0.0000, 0.7942,0.10/
      DATA(ST(194,I),I=1,9)/7.,4., 1225.5, 0.0016,-0.0276,
     * 0.1766,-0.0156, 0.1317,0.10/
      DATA(ST(195,I),I=1,9)/7.,4., 1223.8, 0.0000, 0.3810,
     * 0.0000, 0.0000, 0.2391,0.10/
      DATA(ST(196,I),I=1,9)/7.,4., 1222.3, 0.0000, 0.1345,
     * 0.0000, 0.0000, 0.5296,0.10/
      DATA(ST(197,I),I=1,9)/7.,4., 1221.3, 0.0000, 0.4580,
     * 0.0000, 0.0000, 1.4106,0.10/
      DATA(ST(198,I),I=1,9)/7.,4., 1173.6,-0.0128, 0.9919,
     * 0.1844,-0.0155, 1.4480,0.20/
      DATA(ST(199,I),I=1,9)/7.,4., 1102.4,-0.0032, 0.4261,
     * 0.0453,-0.0024, 1.4909,0.10/
      DATA(ST(200,I),I=1,9)/7.,4., 1036.2, 0.0466,-0.6226,
     * 2.3090,-0.1996, 0.6230,0.10/
      DATA(ST(201,I),I=1,9)/7.,4.,  993.2,-0.0013, 1.3770,
     * 0.3981,-0.0374, 1.4124,0.10/
      DATA(ST(202,I),I=1,9)/7.,4.,  955.3, 0.0349,-0.2307,
     * 1.5474,-0.1407, 0.5544,0.10/
      DATA(ST(203,I),I=1,9)/7.,4.,  952.9, 0.0081,-0.1496,
     * 0.7610,-0.0774, 0.5303,0.10/
      DATA(ST(204,I),I=1,9)/7.,4.,  923.2, 0.1057,-0.3719,
     * 4.7527,-0.4378, 0.2552,0.10/
      DATA(ST(205,I),I=1,9)/7.,4.,  765.1, 0.1051,-1.9051,
     *10.2062,-0.9291, 0.3490,0.10/
      DATA(ST(206,I),I=1,9)/7.,4.,  756.6, 0.0000, 0.2633,
     * 0.0000, 0.0000, 0.2391,0.10/
      DATA(ST(207,I),I=1,9)/7.,4.,  715.7, 0.0009, 3.2627,
     *-0.0002, 0.0000, 1.4919,0.10/
      DATA(ST(208,I),I=1,9)/7.,4.,  704.8, 0.0000, 0.2364,
     * 0.0000, 0.0000, 0.2391,0.10/
      DATA(ST(209,I),I=1,9)/7.,4.,  678.0, 0.0001, 1.9513,
     * 0.0001, 0.0000, 1.0459,0.10/
      DATA(ST(210,I),I=1,9)/7.,4.,  322.6, 0.0063,-0.1200,
     * 0.9206,-0.0779, 0.0798,0.10/
      DATA(ST(211,I),I=1,9)/7.,4.,  297.7, 0.0427,-0.4023,
     * 1.3341,-0.1392, 0.4279,0.10/
      DATA(ST(212,I),I=1,9)/7.,4.,  283.5, 0.1599,-1.8302,
     * 6.3083,-0.5637, 0.5187,0.10/
      DATA(ST(213,I),I=1,9)/7.,4.,  239.6, 0.0238,-0.2925,
     * 1.8886,-0.1810, 0.1931,0.10/
      DATA(ST(214,I),I=1,9)/7.,4.,  234.2,-0.0031, 0.1646,
     * 0.2047,-0.0151, 0.1978,0.10/
      DATA(ST(215,I),I=1,9)/7.,4.,  225.3,-0.0001, 7.3142,
     *-0.0009, 0.0001, 1.1402,0.10/
      DATA(ST(216,I),I=1,9)/7.,4.,  221.8, 0.0000, 0.7356,
     * 0.0000, 0.0000, 0.2391,0.10/
      DATA(ST(217,I),I=1,9)/7.,4.,  217.9, 0.0004, 3.5092,
     *-0.0003, 0.0001, 1.4107,0.10/
      DATA(ST(218,I),I=1,9)/7.,4.,  209.4,-0.0049, 0.1832,
     * 0.0068,-0.0002, 0.2062,0.10/
      DATA(ST(219,I),I=1,9)/7.,4.,  177.6, 0.0000, 1.5341,
     * 0.0001, 0.0000, 0.7942,0.10/
      DATA(ST(220,I),I=1,9)/8.,8.,27639.7, 0.1953,-0.7805,
     * 0.8492,-0.0759,13.2470,0.50/
      DATA(ST(221,I),I=1,9)/8.,8.,18022.8, 0.0971,-0.8743,
     * 1.6447,-0.1593,14.3535,0.50/
      DATA(ST(222,I),I=1,9)/8.,8.,11298.9, 0.2147,-0.9024,
     * 1.0281,-0.0820,12.9529,0.50/
      DATA(ST(223,I),I=1,9)/8.,8., 9263.6, 1.3752,-0.0677,
     * 3.8878,-0.4719,15.3842,0.50/
      DATA(ST(224,I),I=1,9)/8.,8., 7949.5, 0.0000, 0.4000,
     * 0.0000, 0.0000, 0.5587,0.10/
      DATA(ST(225,I),I=1,9)/8.,8., 7773.3, 1.0991,-1.9677,
     * 5.9828,-0.6378,14.1284,0.45/
      DATA(ST(226,I),I=1,9)/8.,8., 6318.6, 0.0000, 0.0280,
     * 0.0000, 0.0000, 1.0257,0.10/
      DATA(ST(227,I),I=1,9)/8.,7.,25393.1, 0.0000, 0.0040,
     * 0.0000, 0.0000, 0.2971,0.10/
      DATA(ST(228,I),I=1,9)/8.,7.,11945.6,-0.0001, 0.0072,
     * 0.0015,-0.0002, 0.3500,0.10/
      DATA(ST(229,I),I=1,9)/8.,7., 9377.4, 0.0000, 0.0063,
     * 0.0000, 0.0000, 0.3616,0.10/
      DATA(ST(230,I),I=1,9)/8.,7., 8883.3, 0.0000, 0.0056,
     * 0.0000, 0.0000, 0.3475,0.10/
      DATA(ST(231,I),I=1,9)/8.,7., 8771.8, 0.0000, 0.0161,
     * 0.0000, 0.0000, 0.3456,0.10/
      DATA(ST(232,I),I=1,9)/8.,7., 4651.7, 0.1037,-0.2657,
     * 0.2045,-0.0029, 3.0303,0.35/
      DATA(ST(233,I),I=1,9)/8.,7., 4593.2, 0.0000, 0.0080,
     * 0.0059,-0.0006, 0.3499,0.10/
      DATA(ST(234,I),I=1,9)/8.,7., 4349.8, 0.0000, 0.0048,
     * 0.0075,-0.0005, 0.3000,0.10/
      DATA(ST(235,I),I=1,9)/8.,7., 4341.1, 0.0376,-0.0999,
     * 0.0783,-0.0003, 2.8346,0.30/
      DATA(ST(236,I),I=1,9)/8.,7., 4188.0,-0.0001, 0.0154,
     * 0.0079,-0.0008, 0.3498,0.10/
      DATA(ST(237,I),I=1,9)/8.,7., 4074.8, 0.0923,-0.1817,
     * 0.1002,-0.0007, 4.2197,0.50/
      DATA(ST(238,I),I=1,9)/8.,7., 3800.2, 0.0000, 0.1009,
     * 0.0000, 0.0000, 2.2340,0.10/
      DATA(ST(239,I),I=1,9)/8.,7., 3077.8, 0.0000, 0.0099,
     * 0.0000, 0.0000, 0.3616,0.10/
      DATA(ST(240,I),I=1,9)/8.,7., 3017.9, 0.0000, 0.0082,
     * 0.0000, 0.0000, 0.3475,0.10/
      DATA(ST(241,I),I=1,9)/8.,7., 3009.0, 0.0000, 0.0076,
     * 0.0000, 0.0000, 0.3616,0.10/
      DATA(ST(242,I),I=1,9)/8.,7.,  386.3, 0.0000, 0.4461,
     * 0.0000, 0.0000, 0.2804,0.10/
      DATA(ST(243,I),I=1,9)/8.,7.,  385.7, 0.0000, 0.3115,
     * 0.0000, 0.0000, 0.3318,0.10/
      DATA(ST(244,I),I=1,9)/8.,6., 4587.1, 0.0000, 0.2800,
     * 0.0000, 0.0000, 4.6381,0.15/
      DATA(ST(245,I),I=1,9)/8.,6., 3881.6, 0.0000, 0.1304,
     * 0.0000, 0.0000, 0.9941,0.10/
      DATA(ST(246,I),I=1,9)/8.,6., 3763.1, 0.0000, 0.0746,
     * 0.0000, 0.0000, 1.6189,0.10/
      DATA(ST(247,I),I=1,9)/8.,6., 3762.3, 0.0053,-0.0983,
     * 0.4693, 0.0054, 0.5684,0.10/
      DATA(ST(248,I),I=1,9)/8.,6., 3326.6, 0.0090, 0.0107,
     * 0.0226,-0.0004, 0.7877,0.10/
      DATA(ST(249,I),I=1,9)/8.,6., 3265.9, 0.0001, 0.9493,
     * 0.1777, 0.0623, 1.2049,0.10/
      DATA(ST(250,I),I=1,9)/8.,6., 3191.9, 0.0000, 0.0723,
     * 0.0000, 0.0000, 1.8883,0.10/
      DATA(ST(251,I),I=1,9)/8.,6., 3176.1, 0.0000, 0.2069,
     * 0.0000, 0.0000, 1.3144,0.10/
      DATA(ST(252,I),I=1,9)/8.,6., 3041.6, 0.0139,-0.0463,
     * 0.0950,-0.0013, 1.1799,0.10/
      DATA(ST(253,I),I=1,9)/8.,6., 2092.0, 0.0001, 0.7959,
     * 0.0000, 0.0000, 1.5025,0.10/
      DATA(ST(254,I),I=1,9)/8.,6., 1947.2, 0.0000, 1.1393,
     * 0.0002, 0.0000, 1.3915,0.10/
      DATA(ST(255,I),I=1,9)/8.,6., 1924.2, 0.0000, 0.5098,
     * 0.0001, 0.0000, 1.3217,0.10/
      DATA(ST(256,I),I=1,9)/8.,6.,  834.5,-0.0092,16.2803,
     * 6.0953,-0.3399, 1.2980,0.15/
      DATA(ST(257,I),I=1,9)/8.,6.,  703.4, 0.0646,-1.0379,
     * 5.4702,-0.3506, 0.6221,0.10/
      DATA(ST(258,I),I=1,9)/8.,6.,  599.6, 0.0002, 1.4709,
     * 1.2954,-0.0807, 1.5493,0.10/
      DATA(ST(259,I),I=1,9)/8.,6.,  541.6, 0.0002, 2.4329,
     * 0.0001, 0.0000, 1.2893,0.10/
      DATA(ST(260,I),I=1,9)/8.,6.,  374.1,-0.0005, 1.8930,
     * 1.0691,-0.0524, 1.1337,0.15/
      DATA(ST(261,I),I=1,9)/8.,6.,  320.7,-0.0001, 3.8598,
     * 0.0000, 0.0000, 1.5798,0.10/
      DATA(ST(262,I),I=1,9)/8.,6.,  300.5, 0.0003,13.1930,
     * 0.0015,-0.0002, 1.3900,0.10/
      DATA(ST(263,I),I=1,9)/8.,6.,  299.3,-0.0001, 6.0914,
     * 0.0000, 0.0000, 1.5798,0.10/
      DATA(ST(264,I),I=1,9)/8.,5., 9225.1, 0.0001, 0.0009,
     * 0.0005, 0.0000, 0.1500,0.10/
      DATA(ST(265,I),I=1,9)/8.,5., 8723.6, 0.0000, 0.0335,
     * 0.0000, 0.0000, 0.9214,0.10/
      DATA(ST(266,I),I=1,9)/8.,5., 6099.6, 0.0000, 0.0283,
     * 0.0000, 0.0000, 1.0719,0.10/
      DATA(ST(267,I),I=1,9)/8.,5., 4541.3, 0.0011, 0.6456,
     * 0.0000, 0.0000, 4.8635,0.20/
      DATA(ST(268,I),I=1,9)/8.,5., 4491.5, 0.0003, 0.6584,
     * 0.0000, 0.0000, 4.8271,0.15/
      DATA(ST(269,I),I=1,9)/8.,5., 4034.0, 0.0000, 0.0702,
     * 0.0000, 0.0000, 0.0719,0.10/
      DATA(ST(270,I),I=1,9)/8.,5., 3799.3, 0.0000, 0.0189,
     * 0.0000, 0.0000, 0.3721,0.10/
      DATA(ST(271,I),I=1,9)/8.,5., 3794.0, 0.0000, 0.1226,
     * 0.0000, 0.0000, 2.5050,0.10/
      DATA(ST(272,I),I=1,9)/8.,5., 3720.8, 0.0000, 0.1250,
     * 0.0000, 0.0000, 0.3721,0.10/
      DATA(ST(273,I),I=1,9)/8.,5., 3553.8, 0.0000, 0.0045,
     * 0.0000, 0.0000, 0.0719,0.10/
      DATA(ST(274,I),I=1,9)/8.,5., 3549.1, 0.0000, 0.0012,
     * 0.0000, 0.0000, 0.0719,0.10/
      DATA(ST(275,I),I=1,9)/8.,5., 3490.9, 0.0033, 0.0082,
     * 0.0069, 0.0003, 0.1785,0.10/
      DATA(ST(276,I),I=1,9)/8.,5., 3409.1, 0.0004, 0.0001,
     * 0.0016, 0.0002, 0.2052,0.10/
      DATA(ST(277,I),I=1,9)/8.,5., 3350.7, 0.0012,-0.0001,
     * 0.0091,-0.0002, 0.1795,0.10/
      DATA(ST(278,I),I=1,9)/8.,5., 3066.1, 0.0230, 0.0016,
     * 0.0859, 0.0015, 0.2149,0.10/
      DATA(ST(279,I),I=1,9)/8.,5., 3037.9, 0.0000, 1.5217,
     * 0.0000, 0.0000, 0.7085,0.10/
      DATA(ST(280,I),I=1,9)/8.,5., 3027.9, 0.0000, 0.0918,
     * 0.0000, 0.0000, 0.9214,0.10/
      DATA(ST(281,I),I=1,9)/8.,5., 3024.3, 0.0002, 0.0005,
     * 0.0005, 0.0000, 0.2000,0.15/
      DATA(ST(282,I),I=1,9)/8.,5., 3003.0, 0.0007, 0.5561,
     * 0.0000, 0.0000, 4.8630,0.20/
      DATA(ST(283,I),I=1,9)/8.,5., 2907.1, 0.0000, 0.2918,
     * 0.0000, 0.0000, 0.9214,0.10/
      DATA(ST(284,I),I=1,9)/8.,5., 2772.5, 0.0000, 0.6734,
     *-0.0001, 0.0000, 1.6944,0.10/
      DATA(ST(285,I),I=1,9)/8.,5., 2637.7, 0.0000, 1.1338,
     *-0.0002, 0.0000, 1.6242,0.10/
      DATA(ST(286,I),I=1,9)/8.,5., 2620.0, 0.0000, 1.0784,
     * 0.0000, 0.0000, 1.0719,0.10/
      DATA(ST(287,I),I=1,9)/8.,5., 2511.2, 0.0002, 2.8067,
     *-0.0001, 0.0000, 1.7471,0.10/
      DATA(ST(288,I),I=1,9)/8.,5., 2486.3, 0.0000, 0.3204,
     * 0.0000, 0.0000, 0.0719,0.10/
      DATA(ST(289,I),I=1,9)/8.,5., 2363.6, 0.0000, 0.2168,
     * 0.0000, 0.0000, 0.3721,0.10/
      DATA(ST(290,I),I=1,9)/8.,5., 1936.1, 0.0000, 0.1495,
     * 0.0000, 0.0000, 0.3721,0.10/
      DATA(ST(291,I),I=1,9)/8.,5., 1785.9, 0.0000, 0.5212,
     * 0.0000, 0.0000, 1.0719,0.10/
      DATA(ST(292,I),I=1,9)/8.,5., 1515.5, 0.0008, 0.0086,
     * 0.0048, 0.0000, 0.1501,0.10/
      DATA(ST(293,I),I=1,9)/8.,5., 1355.1, 0.0016, 0.0209,
     * 0.0111, 0.0001, 0.1392,0.10/
      DATA(ST(294,I),I=1,9)/8.,5., 1341.8, 0.0734,-0.7096,
     * 2.5557,-0.1364, 0.3106,0.10/
      DATA(ST(295,I),I=1,9)/8.,5., 1296.4, 0.0000, 0.2047,
     * 0.0000, 0.0000, 0.3721,0.10/
      DATA(ST(296,I),I=1,9)/8.,5., 1289.4, 0.0000, 1.1066,
     * 0.0001, 0.0000, 0.0719,0.10/
      DATA(ST(297,I),I=1,9)/8.,5., 1212.9, 0.0309,-0.3064,
     * 0.8385,-0.0813, 0.5422,0.10/
      DATA(ST(298,I),I=1,9)/8.,5., 1102.0, 0.0018, 5.6429,
     * 0.0008,-0.0001, 6.9210,0.25/
      DATA(ST(299,I),I=1,9)/8.,5., 1079.9, 0.0027,-0.0002,
     * 0.0195,-0.0005, 0.1795,0.10/
      DATA(ST(300,I),I=1,9)/8.,5., 1067.8, 0.0935,-0.1253,
     * 0.2148, 0.0392, 0.8956,0.15/
      DATA(ST(301,I),I=1,9)/8.,5., 1060.0, 0.0103, 0.0256,
     * 0.0214, 0.0011, 0.1784,0.10/
      DATA(ST(302,I),I=1,9)/8.,5., 1046.0, 0.0404,-0.2108,
     * 0.3873,-0.0250, 0.6667,0.10/
      DATA(ST(303,I),I=1,9)/8.,5., 1006.7, 0.0161,12.4488,
     * 0.0002, 0.0000, 7.5667,0.25/
      DATA(ST(304,I),I=1,9)/8.,5.,  922.7, 0.7799,-3.0453,
     * 4.4113,-0.2320, 1.0333,0.20/
      DATA(ST(305,I),I=1,9)/8.,5.,  844.4,-0.0001, 3.3684,
     * 0.0001, 0.0000, 0.7085,0.10/
      DATA(ST(306,I),I=1,9)/8.,5.,  789.4, 4.7096,-7.7314,
     *39.5926,-1.4842, 0.2109,0.10/
      DATA(ST(307,I),I=1,9)/8.,5.,  779.9, 0.4003,-3.8675,
     *13.9290,-0.7433, 0.3106,0.10/
      DATA(ST(308,I),I=1,9)/8.,5.,  745.8, 0.0000, 0.5475,
     * 0.0000, 0.0000, 0.3721,0.10/
      DATA(ST(309,I),I=1,9)/8.,5.,  713.0, 0.0041, 6.5679,
     *-0.0013, 0.0002, 2.5057,0.10/
      DATA(ST(310,I),I=1,9)/8.,5.,  703.9, 0.0000, 0.5760,
     * 0.0000, 0.0000, 0.0719,0.10/
      DATA(ST(311,I),I=1,9)/8.,5.,  636.5, 0.1084, 0.2681,
     * 0.2245, 0.0112, 0.1785,0.10/
      DATA(ST(312,I),I=1,9)/8.,5.,  617.0, 1.7032,-6.6508,
     * 9.6338,-0.5066, 1.0333,0.20/
      DATA(ST(313,I),I=1,9)/8.,5.,  609.4, 0.4193,-1.9258,
     * 5.0398,-0.0611, 0.4046,0.10/
      DATA(ST(314,I),I=1,9)/8.,5.,  554.4, 0.9392,-0.7450,
     * 8.8543,-0.2444, 0.4542,0.10/
      DATA(ST(315,I),I=1,9)/8.,5.,  487.0, 0.0000, 0.3641,
     * 0.0000, 0.0000, 0.0719,0.10/
      DATA(ST(316,I),I=1,9)/8.,5.,  442.8, 0.0228, 0.0016,
     * 0.0852, 0.0015, 0.2149,0.10/
      DATA(ST(317,I),I=1,9)/8.,5.,  379.8, 0.1502, 0.0108,
     * 0.5603, 0.0096, 0.2149,0.10/
      DATA(ST(318,I),I=1,9)/8.,5.,  342.3, 0.0096, 0.0238,
     * 0.0199, 0.0010, 0.1785,0.10/
      DATA(ST(319,I),I=1,9)/8.,5.,  306.7, 0.0046,-0.0187,
     * 0.3118,-0.0071, 0.0888,0.10/
      DATA(ST(320,I),I=1,9)/8.,5.,  303.5, 0.0043, 0.0573,
     * 0.0305, 0.0003, 0.1392,0.10/
      DATA(ST(321,I),I=1,9)/8.,5.,  289.9, 0.0113, 0.0019,
     * 0.2579,-0.0234, 0.1676,0.10/
      DATA(ST(322,I),I=1,9)/8.,5.,  288.5, 0.0000, 3.7916,
     *-0.0007, 0.0001, 1.6242,0.10/
      DATA(ST(323,I),I=1,9)/8.,5.,  285.8, 0.0521,-0.4336,
     * 1.0532, 0.0448, 0.5153,0.10/
      DATA(ST(324,I),I=1,9)/8.,5.,  279.8, 0.0999,-0.2634,
     * 0.4500, 0.0242, 0.3298,0.10/
      DATA(ST(325,I),I=1,9)/8.,5.,  276.1, 0.0124,18.7191,
     * 0.0017,-0.0002, 3.8567,0.15/
      DATA(ST(326,I),I=1,9)/8.,5.,  273.5,-0.0018,25.0077,
     * 0.0020,-0.0002, 4.3545,0.15/
      DATA(ST(327,I),I=1,9)/8.,5.,  267.0, 0.1622,-1.1147,
     * 2.2783,-0.1975, 0.7623,0.15/
      DATA(ST(328,I),I=1,9)/8.,5.,  265.5,-0.0001,16.4077,
     * 0.0006,-0.0001, 1.0719,0.10/
      DATA(ST(329,I),I=1,9)/8.,5.,  260.5, 0.0005, 2.2010,
     * 2.6463,-0.1639, 0.6095,0.15/
      DATA(ST(330,I),I=1,9)/8.,5.,  258.6, 0.0060, 6.1638,
     *-0.0005, 0.0001, 2.5060,0.10/
      DATA(ST(331,I),I=1,9)/8.,5.,  252.5, 0.0128,20.5521,
     * 0.0011,-0.0001, 3.8567,0.15/
      DATA(ST(332,I),I=1,9)/8.,5.,  250.3,-0.0023,31.5306,
     * 0.0025,-0.0003, 4.3545,0.15/
      DATA(ST(333,I),I=1,9)/8.,5.,  238.5, 0.1215, 0.0327,
     * 0.5626, 0.0832, 0.2035,0.10/
      DATA(ST(334,I),I=1,9)/8.,5.,  224.1, 0.0000, 3.2239,
     * 0.0001, 0.0000, 0.3721,0.10/
      DATA(ST(335,I),I=1,9)/8.,5.,  216.2, 0.0000, 0.5602,
     * 0.0000, 0.0000, 0.3721,0.10/
      DATA(ST(336,I),I=1,9)/8.,5.,  213.0,-0.0657, 1.4583,
     * 0.2876, 0.0223, 0.6524,0.10/
      DATA(ST(337,I),I=1,9)/8.,5.,  211.3, 0.0022, 5.2042,
     * 0.0232,-0.0015, 1.9159,0.10/
      DATA(ST(338,I),I=1,9)/8.,5.,  207.2, 0.1477,-0.0102,
     * 1.0783,-0.0272, 0.1795,0.10/
      DATA(ST(339,I),I=1,9)/8.,5.,  203.0, 0.0846, 0.2543,
     * 0.3268,-0.0198, 0.4614,0.10/
      DATA(ST(340,I),I=1,9)/8.,5.,  200.8, 0.0001,10.4614,
     * 0.0006,-0.0001, 0.0719,0.10/
      DATA(ST(341,I),I=1,9)/8.,5.,  196.4, 0.0031,19.1580,
     *-0.0023, 0.0004, 1.6946,0.10/
      DATA(ST(342,I),I=1,9)/8.,5.,  188.2,-0.0032,32.3813,
     *-0.0036, 0.0005, 4.8979,0.15/
      DATA(ST(343,I),I=1,9)/8.,5.,  184.2,-0.0017,29.1270,
     * 0.0040,-0.0006, 6.5238,0.20/
      DATA(ST(344,I),I=1,9)/8.,5.,  182.8, 0.1135, 0.2808,
     * 0.2350, 0.0117, 0.1785,0.10/
      DATA(ST(345,I),I=1,9)/8.,5.,  171.1, 0.0174, 0.2317,
     * 0.1234, 0.0014, 0.1392,0.10/
      DATA(ST(346,I),I=1,9)/8.,5.,  158.6, 0.0012, 7.8984,
     * 0.0004, 0.0000, 0.9216,0.10/
      DATA(ST(347,I),I=1,9)/8.,4., 6487.5,-0.0765, 4.1680,
     * 1.2966,-0.1261, 2.8234,0.15/
      DATA(ST(348,I),I=1,9)/8.,4., 5875.5, 0.0274,-0.0918,
     * 0.1266,-0.0106, 3.3189,0.15/
      DATA(ST(349,I),I=1,9)/8.,4., 5023.2,-0.0001, 0.5197,
     * 0.0000, 0.0000, 5.8621,0.20/
      DATA(ST(350,I),I=1,9)/8.,4., 5006.9, 0.0000, 0.4687,
     * 0.0000, 0.0000, 5.8758,0.20/
      DATA(ST(351,I),I=1,9)/8.,4., 4982.4, 0.0008, 0.8823,
     * 0.0001, 0.0000, 5.8662,0.20/
      DATA(ST(352,I),I=1,9)/8.,4., 4981.4, 0.0221,-0.0957,
     * 0.1292,-0.0117, 3.5562,0.20/
      DATA(ST(353,I),I=1,9)/8.,4., 4961.4, 0.0012, 1.4623,
     * 0.0001, 0.0000, 5.8616,0.20/
      DATA(ST(354,I),I=1,9)/8.,4., 4961.4, 0.0009, 0.5036,
     *-0.0002, 0.0000, 5.8627,0.20/
      DATA(ST(355,I),I=1,9)/8.,4., 4958.7, 0.0000, 0.4494,
     * 0.0000, 0.0000, 5.8588,0.20/
      DATA(ST(356,I),I=1,9)/8.,4., 4953.3, 0.0011, 1.3491,
     *-0.0006, 0.0001, 5.8599,0.20/
      DATA(ST(357,I),I=1,9)/8.,4., 4952.5, 0.0000, 2.1583,
     *-0.0001, 0.0000, 5.8576,0.20/
      DATA(ST(358,I),I=1,9)/8.,4., 4952.5, 0.0004, 0.7195,
     * 0.0001, 0.0000, 5.8581,0.20/
      DATA(ST(359,I),I=1,9)/8.,4., 4944.7, 0.0000, 0.3643,
     * 0.0000, 0.0000, 5.8621,0.20/
      DATA(ST(360,I),I=1,9)/8.,4., 4930.3, 0.0407,-0.2476,
     * 0.4153,-0.0419, 3.9910,0.20/
      DATA(ST(361,I),I=1,9)/8.,4., 4930.3, 0.1223,-0.7431,
     * 1.2467,-0.1257, 3.9913,0.20/
      DATA(ST(362,I),I=1,9)/8.,4., 4924.2, 0.0007, 0.7699,
     * 0.0001, 0.0000, 5.8606,0.20/
      DATA(ST(363,I),I=1,9)/8.,4., 4498.2, 0.0226,-0.0754,
     * 0.1040,-0.0087, 3.3188,0.15/
      DATA(ST(364,I),I=1,9)/8.,4., 4493.9, 0.0005, 0.4192,
     *-0.0001, 0.0000, 5.8498,0.20/
      DATA(ST(365,I),I=1,9)/8.,4., 4462.6, 0.0457,-0.1671,
     * 0.2516,-0.0184, 3.2313,0.10/
      DATA(ST(366,I),I=1,9)/8.,4., 3236.6, 0.0000, 0.1399,
     * 0.0000, 0.0000, 1.9093,0.10/
      DATA(ST(367,I),I=1,9)/8.,4., 3164.3, 0.0160, 0.1955,
     * 0.0529,-0.0039, 2.9938,0.10/
      DATA(ST(368,I),I=1,9)/8.,4., 3129.6, 0.0000, 0.1965,
     * 0.0000, 0.0000, 3.0685,0.10/
      DATA(ST(369,I),I=1,9)/8.,4., 3083.8, 0.0001, 0.4411,
     * 0.0000, 0.0000, 2.9807,0.10/
      DATA(ST(370,I),I=1,9)/8.,4., 3077.9, 0.0000, 0.1517,
     * 0.0000, 0.0000, 1.9094,0.10/
      DATA(ST(371,I),I=1,9)/8.,4., 3031.3, 0.0002, 0.7817,
     * 0.0000, 0.0000, 2.9583,0.10/
      DATA(ST(372,I),I=1,9)/8.,4., 3023.6, 0.0009, 1.3603,
     * 0.0001, 0.0000, 2.9790,0.10/
      DATA(ST(373,I),I=1,9)/8.,4., 3016.6, 0.0000, 0.5112,
     * 0.0000, 0.0000, 2.9986,0.10/
      DATA(ST(374,I),I=1,9)/8.,4., 3005.2, 0.0002, 0.9032,
     * 0.0002, 0.0000, 2.9618,0.10/
      DATA(ST(375,I),I=1,9)/8.,4., 3003.8, 0.0009, 2.7109,
     * 0.0000, 0.0001, 2.9619,0.10/
      DATA(ST(376,I),I=1,9)/8.,4., 2993.3, 0.0007, 1.3851,
     *-0.0001, 0.0000, 2.9537,0.10/
      DATA(ST(377,I),I=1,9)/8.,4., 2991.3, 0.0035, 4.1590,
     * 0.0002,-0.0001, 2.9540,0.10/
      DATA(ST(378,I),I=1,9)/8.,4., 2974.6, 0.0000, 2.3453,
     *-0.0001, 0.0000, 2.9549,0.10/
      DATA(ST(379,I),I=1,9)/8.,4., 2941.4, 0.3768, 2.0972,
     * 0.8634,-0.0657, 3.0325,0.10/
      DATA(ST(380,I),I=1,9)/8.,4., 2941.4, 0.1258, 0.6993,
     * 0.2887,-0.0220, 3.0326,0.10/
      DATA(ST(381,I),I=1,9)/8.,4., 2784.0, 0.0075,-0.1040,
     * 0.5878,-0.0604, 1.8618,0.10/
      DATA(ST(382,I),I=1,9)/8.,4., 2696.3, 0.0009, 1.2340,
     *-0.0001, 0.0000, 2.9394,0.10/
      DATA(ST(383,I),I=1,9)/8.,4., 1660.8, 0.1433, 2.3447,
     * 0.1964,-0.0148, 2.9947,0.10/
      DATA(ST(384,I),I=1,9)/8.,4., 1643.7, 0.4277, 2.2318,
     * 1.0820,-0.0818, 3.0315,0.10/
      DATA(ST(385,I),I=1,9)/8.,4., 1629.2, 0.1100, 1.9840,
     * 0.1615,-0.0121, 2.9994,0.10/
      DATA(ST(386,I),I=1,9)/8.,4., 1524.4, 0.0751, 1.2396,
     * 0.1036,-0.0078, 2.9944,0.10/
      DATA(ST(387,I),I=1,9)/8.,4., 1371.3, 0.1528,-2.1819,
     *12.1631,-1.1983, 2.0811,0.10/
      DATA(ST(388,I),I=1,9)/8.,4., 1085.8,-0.0859, 5.0151,
     * 1.5551,-0.1513, 2.8250,0.15/
      DATA(ST(389,I),I=1,9)/8.,4., 1071.6, 0.0003, 1.3349,
     * 0.0000, 0.0000, 2.9583,0.10/
      DATA(ST(390,I),I=1,9)/8.,4., 1067.9, 0.0000, 4.0933,
     *-0.0001, 0.0000, 2.9549,0.10/
      DATA(ST(391,I),I=1,9)/8.,4., 1055.1, 0.0012, 1.7375,
     * 0.0001, 0.0000, 2.9791,0.10/
      DATA(ST(392,I),I=1,9)/8.,4., 1040.6, 0.1517, 0.8702,
     * 0.3453,-0.0262, 3.0318,0.10/
      DATA(ST(393,I),I=1,9)/8.,4., 1037.4, 0.0004, 2.3306,
     *-0.0002, 0.0000, 2.9389,0.10/
      DATA(ST(394,I),I=1,9)/8.,4., 1032.5, 0.0011, 1.5181,
     *-0.0002, 0.0000, 2.9540,0.10/
      DATA(ST(395,I),I=1,9)/8.,4., 1031.9, 0.0012, 1.3021,
     *-0.0001, 0.0000, 2.9625,0.10/
      DATA(ST(396,I),I=1,9)/8.,4., 1020.0, 0.0011, 1.9488,
     * 0.1513,-0.0122, 2.9376,0.10/
      DATA(ST(397,I),I=1,9)/8.,4.,  943.7, 0.0001, 1.1447,
     * 0.0000, 0.0000, 2.6478,0.10/
      DATA(ST(398,I),I=1,9)/8.,4.,  774.5, 0.0308,-0.3144,
     * 2.7102,-0.2657, 2.0844,0.10/
      DATA(ST(399,I),I=1,9)/8.,4.,  760.4, 0.0565,-1.0006,
     * 9.1628,-0.9287, 1.7646,0.10/
      DATA(ST(400,I),I=1,9)/8.,4.,  681.3, 0.5482, 4.2072,
     * 1.6253,-0.1233, 3.0007,0.15/
      DATA(ST(401,I),I=1,9)/8.,4.,  629.7, 0.2120,-3.1260,
     *19.1353,-1.8583, 2.0594,0.10/
      DATA(ST(402,I),I=1,9)/8.,4.,  202.3, 0.0577,-0.7299,
     * 3.0596,-0.3423, 1.9926,0.10/
      DATA(ST(403,I),I=1,9)/8.,4.,  192.9, 0.1384,-2.1966,
     * 9.3514,-1.0249, 2.1022,0.10/
      DATA(ST(404,I),I=1,9)/8.,4.,  168.0, 0.0839,-1.2048,
     * 5.8036,-0.6387, 1.8941,0.10/
      DATA(ST(405,I),I=1,9)/8.,4.,  141.3,-0.0005,11.8982,
     *-0.0002, 0.0000, 3.0188,0.10/
      end
******************************************************************************
* note - order of routines in this file is important since hazy iv
* gets a table from here.  do not split this file into pieces.
******************************************************************************
      subroutine LineSet1
      implicit none
*put energetics, H, and He lines into line intensity stack
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
      real DustCoolGas
*dust cooling the gas by collisions
      common/dclgas/ DustCoolGas
*these are a series of lines and continuua that are set in hediff and
*carried outward in metdif
      real esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      common/heots/ esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      real totlum , totlsv
      common/totlum/ totlum , totlsv
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      real hesc , esesc
      common/hesc/ hesc(lmhlvl,lmhlvl) , esesc(lmhlvl,lmhlvl)
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      real COVibCool, dCOVdT
*cooling due to rotational excit fo CO, and its deriv
      common/covib/ COVibCool, dCOVdT
      real hi , hii
      common/h/ hi , hii
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real heatlmax
      integer levlmax , ipHeatlmax
      common/heatlmax/ heatlmax , levlmax , ipHeatlmax
      real hetmet
      common/hetmet/ hetmet
      real he1ex
      common/he1exCOM/ he1ex
      real he2ex
      common/he2ex/ he2ex
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer nHTopOff
      character chHTopType*4
      common/HTopOff/ nHTopOff , chHTopType
      real hfrcin
      common/hfrcin/ hfrcin(lmhlvl,lmhlvl-1)
      real smbeta , cn4861 , cn1216
      common/smbeta/ smbeta , cn4861 , cn1216
      real te , eden , hden
      common/phycon/ te , eden , hden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real pair
      common/pair/ pair
      real cyntrn,hmfb,c584,heavfb,bhe,herec,eebrm,h2line,h2dis,
     1 heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      common/coolng/cyntrn,hmfb,c584,heavfb, bhe,herec,eebrm,h2line,
     1 h2dis,heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      real cryden , crpowr , crtemp , hxtot
      common/hextra/ cryden , crpowr , crtemp , hxtot
      real TotalDustHeat , dphmax , h2pmax , dclmax
*TotalDustHeat is total heating due to grain heating over model
      common/dphoht/ TotalDustHeat , dphmax , h2pmax , dclmax
      real dheat
*grain heating rate for this zone
      common/dustheat/ dheat(ndust)
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      real HLineTotCool , dHLTot
*HLineTotCool is total hydrogen line cooling or heating, set in hydrocool
*dHLTot is the derivative, set in sumheat
      common/HLineTot/ HLineTotCool , dHLTot
      real he2fin
*     these are inward fractions for HeI lines,
*     not used now but they could be
      common/he2fin/ he2fin(9,8)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he10in
      common/heinwd/ he10in
      real c2p2s,c2s2p,c3s2s,c2s3s,c3p2s,c2s3p,c3d2s,
     1 c2s3d,c3s2p,c2p3s,c3p2p,c2p3p,c3d2p,c2p3d,c2sion,c2pion
      common/he3c/ c2p2s,c2s2p,c3s2s,c2s3s,c3p2s,c2s3p,c3d2s,
     1 c2s3d,c3s2p,c2p3s,c3p2p,c2p3p,c3d2p,c2p3d,c2sion,c2pion
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      real He3IonCool
*cooling due to collisional ionization of helium triplets
      common/cionhe/ He3IonCool
      real CODissHeat , codfrc , codtot
*CODissHeat is CO Photodissociation heating
      common/codish/ CODissHeat , codfrc , codtot
      real H2PlsCool
*cooling due to H + H+ => H2+
      common/h2pcng/ H2PlsCool
      real HeatH2Dish , h2dfrc , h2dtot
*HeatH2Dish is heating due to H2 dissociation
      common/h2dish/ HeatH2Dish , h2dfrc , h2dtot
      real HeatExc , HFreBndNet
*HFreBndNet is recombination cooling less photoionization heating for H
*HeatExc is photoionization heating
*both set in hydrocool
      common/HFBNet/ HeatExc , HFreBndNet
      real DustHeatLya , dstpow , dstsum , dincon,dstotl,dhcol,HDustDif
*     HDustDif is heating of grains in current zone due to diffuse fields
*DustHeatLya is heating of dust due to Lya
      common/dhla/ DustHeatLya , dstpow , dstsum , dincon ,dstotl,dhcol,
     1 HDustDif
      real widflx
      common/widflx/ widflx(ncell)
      real DiffCont
*diffus is local diffuse continuum, for current zone
      common/diffus/ DiffCont(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real htpair , posrat
      common/mev/ htpair , posrat
      real dstfe2lya , escfe2
*dstfe2lya is destruction probability for Lya onto FeII
      common/dstfe2/ dstfe2lya , escfe2
      real strkar , pestrk
      common/strkar/ strkar(lmhlvl,lmhlvl) , pestrk(lmhlvl,lmhlvl)
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      real HalphaHmin
*Ha creation due to H- charge transfer
      common/hahmin/ HalphaHmin
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real x12
      common/x12/ x12
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      reaL ri2s1s , ri1s2s
      common/rin2ph/ ri2s1s , ri1s2s
      real HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
*     HRecRad is sum of radiative rec to all excited states
*     hrectot is hcaseb plus effective rec to ground
*     HRecEffec is total effec eval in hlevel, should be
*     roughly equal to hrectot
*     HRecNet is net rec coef, with 3-body rec less coll ioniz
*     HRecCol is thre-body recombination alone
*     HRecInd is induced recombination
      common/hcaseb/ HRecRad , hrectot , HRecEffec , HRecNet , HRecCol ,
     1 HRecInd
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real r1r0sq
      common/r1r0sq/ r1r0sq
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
*     number of continuum point to enter into line array
      integer nPredCont
*     pointers to position in line array for continuum points
      parameter (nPredCont=50)
      integer ipPredCont(nPredCont)
*     values of continuum points in Rydbergs, entered in block data scalar
      real EnrPredCont(nPredCont)
      common/PredCont/ EnrPredCont, ipPredCont
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer ipHe23sGrnd
*pointer to He 23s to ground decay
      common/ip626/ ipHe23sGrnd
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real hbf,hbetab,eryd , hbetac , hlalph , dhtot , pump,
     1 e626,e228,e504,e584,e911,spfac,sexp,hebf  , ConRef ,
     2 cb206,f10830,flow , eff , em,rec,pop,col,totl,
     3 cb5016 , halpha , sum, fac , ConIn , ConOt
      integer i , nd , low,iup , ipnt
*
      if( lgTrace ) write(qq,'(''   LineSet1 called'')')
*
*     initialize ExtraInten with a zero
      call PutExtra( 0. )
*
*     option to punch out FeII atom
      if( chFeIIAtom.eq.'Verner'.and..not.lgSimKatya ) then
        call Fe2Lines('add' , 0. )
      endif
*
*     total H-beta from multi-level atom
      eryd = (1./float(2*2)-1./float(4*4))
      hbetac = hii*hn(4)*hemis(4,2)*en1ryd*eryd
*     these lines added to outlin in metdif - following must be false
      call lindst( hbetac , 4861 , 'TOTL' , iphl(4,2) ,'i',.false.)
*
*     total Ly-a from multi-level atom
      hlalph = hii*hn2p *hemis(2,1)*1.634e-11
      call linadd( hlalph , 1216 , 'TOTL','i')
      totlsv = totlsv / dVeff * covgeo
*
*     someday, put in 21 cm, A from Gould, ApJ 423, 522, =2.88426e-15 s-1
*
*     total luminosity in incident continuum
      call linadd( totlsv , 0 , 'Inci' , 'i' )
      totlsv = totlsv * dVeff / covgeo
*
*     ipass is flag to indicate whether to only set up line array
*     (ipass=0) or actually evaluate lines intensities (ipass=1)
      if( ipass.ne.0 ) totlsv = 0.
*
*     total heating, all forms, information since individuals added later
      call linadd( htot , 0 , 'TotH','i')
*
*     hydrogen photoionization heating, ground state only
      call linadd( heating(1,1) , 0 , 'BFH1','h')
*
*     net hydrogen photoionization heating less rec cooling, all excited states
*     normally zero, positive if excited states are net heating
      call linadd( heating(1,2)  , 0 , 'BFHx','h')
      if(htot.gt.0.) then
        if( heating(1,23)/htot .gt.heatlmax ) then
          heatlmax = heating(1,23)/htot
          call GetMaxhLine
        endif
      endif
*
*     heating due to induced lines absorption of continuum
      call linadd( heating(1,23)  , 0 , 'Line','h')
*
*     net cooling due to collisional ionization of Heo
      call linadd( max(0.,he1ex*heii ) , 0 , 'He1i','c')
*
*     this is the heating due to 3-body recombination
      call linadd( max(-he1ex*heii ,0.) , 0 , '3He1','h')
*
*     net cooling due to collisional ionization of He+
      call linadd( max(0.,he2ex*heiii ) , 0 , 'He2i','c')
*
*     this is the heating due to 3-body recombination
      call linadd( max(-he2ex*heiii ,0.) , 0 , '3He2','h')
*
*     total helium photoionization heating, all stages
      call linadd( heating(2,1)+heating(2,2)+heating(2,3),0,'BFHe','h')
*
*     total heavy element photoionization heating, all stages
      call linadd( hetmet , 0 , 'TotM','h')
*
*     net free-free cooling, nearly cancels with cooling in lte
      call linadd(max(0.,HFFNet) , 0 , 'HFFc','c')
*
*     net free-free heating, nearly cancels with cooling in lte
      call linadd(max(0.,-HFFNet) , 0 , 'HFFh','h')
*
*     H brems (free-free) cooling
      call linadd(hbrems , 0 , 'H FF','i')
*
*     total free-free heating
      call linadd( FreeFreeHeat , 0 , 'FF H','i')
*
*     charge exchange cooling
*     call linadd( chrexCool , 0 , 'Hchr' , 'c' )
*
*     Compton heating
      call linadd( real(cmheat) , 0 , 'ComH','h')
*
*     H- heating
      call linadd( max(0.,hmihet) , 0 , 'H- H','h')
*
*     induced H- cooling
      call linadd( max(0.,-hmihet) , 0 , 'H-Hc','c')
*
      dhtot = 0.
      do nd=1,ndust
        dhtot = dhtot + dheat(nd)
      end do
      TotalDustHeat = TotalDustHeat + dhtot * dVeff
      dphmax = max( dhtot/htot , dphmax )
      h2pmax = max( h2pmax , heating(1,17) /htot )
*     gas heating by grain photoionization
      call linadd( dhtot , 0 , 'GrGH' ,'h')
*
      dclmax = max( dclmax , DustCoolGas/htot )
*     gas cooling by grain collisions
      call linadd( DustCoolGas , 0 , 'GrGC' ,'c')
*
*     "extra" heat added to this zone, from HEXTRA command
      call linadd( hxtot , 0 , 'extH' ,'h')
*
*     "extra" cooling added to this zone, from CEXTRA command
      call linadd( cextxx , 0 , 'extC' ,'c')
*
*     heating due to pair production
      call linadd( pair , 0 , 'pair', 'h' )
*
*     H beta recombination, assuming case B
      hbetab = (10.**(-20.89-0.10612*(alogte-4.4)**2))/te*hii*eden
      call linadd( hbetab , 4861 , 'Ca B','i')
*
*     case b intensity of Ly-alpha, no two photon
      call linadd(HRecRad*eden*hii*1.64e-11, 1216 , 'Ca B' ,'i')
*
*     H-beta computed from Q(H) and specified covering factor
      smbeta = smbeta / dVeff * covgeo
      call linadd( smbeta , 4861 , 'Q(H)' ,'i')
*
*     Ly-alpha from Q(H), high-dens lim, specified covering factor
      call linadd( smbeta*34.19 , 1216 , 'Q(H)' ,'i')
      smbeta = smbeta * dVeff / covgeo
      if( ipass.ne.0 ) smbeta = 0.
*
*     total Ly-a from multi-level atom
      hlalph = hii*hn2p *hemis(2,1)*1.634e-11
*     these lines added to outlin in metdif - following must be false
      call lindst( hlalph , 1216 , 'TOTL',iphl(2,1),'i',.false.)
*
*     inward part of Lya
      hlalph = hlalph * hfrcin(2,1)
      call linadd( hlalph , 1216 , 'Inwd', 'i')
*
*     do not put in distubed high levels
      do low=1,min(nHTopOff-2,nhlvl-2)
*
*       do not have n=2 since population of hn(2) is 2s+2p
*       highest level is way overpopulated due to top-off of
*       finite atom - do not predict its intensity
        do iup=max(3,low+1),min(nHTopOff-1,nhlvl-1)
          eryd = (1./float(low*low)-1./float(iup*iup))
          halpha = hii*hn(iup)*hemis(iup,low)*en1ryd*eryd
          i = rydlam/eryd
          if( i.gt.99999 ) i = i / 10
*         these lines added to outlin in metdif - following must be false
          call lindst( halpha,i,'TOTL',iphl(iup,low) ,'r',.false.)
          halpha = halpha * hfrcin(iup,low)
          call linadd( halpha,i,'Inwd','i')
        end do
      end do
*
*     total collisional cooling due to all hydrogen lines
      call linadd( max(0.,HLineTotCool) , 912,'Clin' , 'c')
*
*     total collisional heating due to all hydrogen lines
      call linadd( max(0.,-HLineTotCool) , 912,'Hlin' , 'h')
*
*     2-photon two photon emission from multi-level atom
      call linadd( hii*hn2s *8.23      *1.634E-11 ,    0 , '2 NU','r')
*
*     la contribution from suprathermal secondaries from ground
      call linadd(x12*hii*hn(1)*1.634e-11,1216,'LA X','i')
*
*     H-alpha produce by H- mutual neutralization
      call linadd( HalphaHmin *3.032E-12,6563,'H-CT','i')
*
*     "Ly alpha" produced by induced two photon
      call linadd( hn2s*hii*ri2s1s *1.634E-11,1216,'Ind2','i')
*
*     H-beta produced by continuum pumping in optically thin ld limit
      pump = hcont(4,1) * hn(1)*hii * 4.09e-12 * 0.4836 * 16.
      call linadd( pump , 4861 , 'Pump','r')
*
*     CHION is HEX*HII (in COOLR) and is net col ionz-3 body heat
*     collision ionization cooling of hydrogen
      call linadd( max(0.,chion) , 0 , 'CION','c')
*
*     this is the heating due to 3-body recombination
      call linadd( max(-chion,0.) , 0 , '3bHt','h')
*
*     Stark broadening contribution to line
      call linadd( hii*hn2p*pestrk(1,2)*1.634E-11 , 1216 , 'Strk','i')
*
*     Stark broadening contribution to line
      call linadd(hii*hn(3)*pestrk(2,3)*3.025E-12 , 6563  ,'Strk','i')
*
*     Stark broadening contribution to line
      call linadd(hii*hn(4)*pestrk(2,4)*4.084E-12 , 4861 , 'Strk','i')
*
*     Stark broadening contribution to line
      call linadd(hii*hn(4)*pestrk(3,4)*1.059E-12 ,18751 , 'Strk','i')
*
*     Stark broadening contribution to line
      call linadd(hii*hn(5)*pestrk(4,5)*4.900E-13 ,40512 , 'Strk','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd( hii*hn2p*hdest(2,1)*1.634E-11, 1216,'Dest','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd(hii*hn(3)*hdest(3,2)*3.025E-12, 6563,'Dest','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd(hii*hn(5)*hdest(5,4)*4.915E-13,40516,'Dest','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd(hii*hn(4)*hdest(4,2)*4.084E-12, 4861,'Dest','i')
*
*     portion of line lost due to absorp by background opacity
      call linadd(hii*hn(4)*hdest(4,3)*1.059E-12,18751,'Dest','i')
*
*     Ly-alpha destroyed by overlap with FeII
      call linadd(hn2p*hii*hyas(2,1)*dstfe2lya*1.637E-11 ,
     1 1216 , 'Fe 2' , 'i' )
*
*     electron scattering escape contribution to line
      call linadd( hii*hn2p*esesc(1,2)*1.634E-11 , 1216 , 'e sc','i')
*
*     electron scattering escape contribution to line
      call linadd( hii*hn(3)*esesc(2,3)*3.03E-12 , 6563 , 'e sc','i')
*
*     electron scattering escape contribution to line
      call linadd( hii*hn(4)*esesc(2,4)*4.09E-12 , 4861 , 'e sc','i')
*
*     electron scattering escape contribution to line
      call linadd( hii*hn(4)*esesc(3,4)*1.06E-12 ,18751 , 'e sc','i')
*
*     electron scattering escape contribution to line
      call linadd( hii*hn(5)*esesc(4,5)*4.91E-13 ,40512 , 'e sc','i')
*
*     511keV annihilation line
      hbf = (hden+4.*ahe)*posrat*2.*8.20E-7
      call PntForLine( 2.427e-2 , 'e-e+' , ipnt )
      call lindst(hbf,511,             'e-e+',ipnt,'i', .true.)
*     call linadd( (hden+4.*ahe)*posrat*2.*8.20E-7 , 511 ,'e-e+','i')
*
*     free-found transitions
      if( te.lt.1e4 ) then
         hbf = 3.64e-25*sexp(5584./te)
      else if( te.lt. 5e4 ) then
         hbf = 2.15e-25
      else
         hbf = 1.66e-24 / te10 / te10 * te01
      endif
      if(heiii.gt.0. ) then
        if( te.lt.2500. ) then
          hebf = 1.24e-23*sexp(4760./te)
        else if( te.lt.5000. ) then
          hebf = 1.85e-24
        else
          hebf = 2.57e-23 / te10/te10/te10
        endif
      else
        hebf = 0.
      endif
*
*     hbnuf1 = (Hy2nu(iphl(4,2))/widflx(iphl(4,2)))*0.75/2.*hn2s*hii*
*    1 anu(iphl(4,2))*
*    1 en1ryd  + (hii+heii)*eden*hbf + heiii * eden * hebf
*
*     this is diffuse emission computed by code
*     hbnufn = DiffCont( iphl(4,2) )/widflx(iphl(4,2))*en1ryd*
*    1 anu(iphl(4,2))**2
*     diffuse cont-nu.fnu(4862) due to all computed emission processes
*     call linadd( hbnufn, 4862 , 'nFnu' ,'i')
*
*     hbnufn = DiffCont( iphl(2,1) )/widflx(iphl(2,1))*en1ryd*
*    1 anu(iphl(2,1))**2
*     diffuse cont-nu.fnu(1212) due to all computed emission processes
*     call linadd( hbnufn, 1212 , 'nFnu' ,'i')
*
*     predict emitted continuum at series of continuum points
      do i=1,nPredCont
*       reflected toal continuum (dif+incident emitted inward direction)
        ConRef = refcon(ipPredCont(i))/widflx(ipPredCont(i))*
     1  anu2(ipPredCont(i))*en1ryd
*       reflected part of INCIDENT continuum (only incident)
        ConIn = reflux(ipPredCont(i))/widflx(ipPredCont(i))*
     1  anu2(ipPredCont(i))*en1ryd
*       outward continuum
        ConOt = outcon(ipPredCont(i))/widflx(ipPredCont(i))*
     1  anu2(ipPredCont(i))*en1ryd*r1r0sq
*       this is wavelength in Angstroms, energies stored in EnrPredCont
        low = rydlam / EnrPredCont(i)
*       some are hundreds of microns, overflows in printout, cnvrt to microns
        if( low.gt. 100 000 ) low = low / 10 000
        sumlin(nsum+1) = 0.
*       total continuum produced by cloud at selected energy points
        call linadd( (ConRef+ConOt)/dVeff, low , 'nFnu' ,'i')
        sumlin(nsum+1) = 0.
*       total reflected continuum, total inward emission plus
*       reflected diffuse continuum
        call linadd( ConRef        /dVeff, low , 'InwT' ,'i')
        sumlin(nsum+1) = 0.
*       reflected incident continuum (only incident)
        call linadd( ConIn         /dVeff, low , 'InwC' ,'i')
      end do
*
*     now find incident continuum
      cn4861 = cn4861 / dVeff
*
*     incident continuum nu*f_nu at H-beta, at illuminated face of cloud
      call linadd( cn4861 , 4860 , 'Inci' ,'i')
      cn1216 = cn1216 / dVeff
*
*     incident continuum nu*f_nu near Ly-alpha, at illuminated face of cloud
      call linadd( cn1216 , 1215 , 'Inci' ,'i')
      cn1216 = cn1216 * dVeff
      cn4861 = cn4861 * dVeff
      if( ipass.ne.0 ) then
        cn4861 = 0.
        cn1216 = 0.
      endif
*
*     >>chng 96 june 13, had been hrec(2,2)
*     integrated Balmer continuum emission
      flow = (hrec(2,1)+hrec(nhlvl+1,1))*hrec(2,3)*eden*hii*5.45e-12
      call linadd( flow , 0,'Ba C','i')
*
*     >>chng 96 june 13, had been hrec(3,2)
*     Paschen continuum emission
      call linadd(hrec(3,1)*hrec(3,3)*eden*hii*3.53e-12 , 0 ,'PA C','i')
*
*     total grain heating by all sources, lines, collisions, incident continuum
      call linadd( dstotl , 0 , 'GraT' ,'i')
*
*     grain heating by incident continuum
      call linadd( dincon , 0 , 'GraI' ,'i')
*
*     grain heating due to destruction of Ly alpha
      call linadd( DustHeatLya , 1216 , 'GraL' ,'i')
*
*     grain heating due to collisions with gas
      call linadd( dhcol , 0 , 'GraC' ,'i')
*
*     grain heating due to diffuse fields, may also have grain emission
      call linadd( HDustDif , 0 , 'GraD' ,'i')
*
*     part of H brems, in x-ray beyond 0.5KeV
      call linadd((hbrems+bhe)*sexp(5.8e6/te) , 0 , 'FF X','i')
*
*     total Compton cooling
      call linadd( tccool , 0 , 'ComC','c')
*
*     expansion cooling, only non-zero for wind
      call linadd( expans , 0 , 'Expn','c' )
*
*     electron - electron brems
      call linadd( eebrm , 0 , 'eeff','c')
*
*     H recombination cooling
      call linadd( hrecem , 0 , 'H FB','i')
*
*     net free-bound cooling and heating
      call linadd(max(0.,HFreBndNet) , 0 , 'HFBc','c')
      call linadd(max(0.,-HFreBndNet) , 0 , 'HFBh','h')
*
*     cooling due to induced rec of hydrogen
      call linadd( crcind , 0 , 'Hind','c')
*
*     cooling due to induced rec of fully ionized helium
      call linadd( c3ind , 0 , '3He2','c')
*
*     cyclotron cooling
      call linadd( cyntrn , 0 , 'Cycn' ,'c')
*
*     changed from info to cooling june 25 95 to pick this up in primal.in
*     collisionally excited La cooling
      call linadd( max(0., coola),  1216 , 'Cool','i')
*
*     collisionally de-excited La heating
      call linadd( max(0.,-coola),  1216 , 'Heat','i')
*
*     cooling due to n>2 Lyman lines
      call linadd( max(0., restly),  960 , 'Crst','i')
*
*     heating due to n>2 Lyman lines
      call linadd( max(0.,-restly),  960 , 'Hrst','i')
*
*     cooling due to n>3 Balmer lines
      call linadd( max(0., barest), 4861 , 'Crst','i')
*
*     heating due to n>3 Balmer lines
      call linadd( max(0.,-barest), 4861 , 'Hrst','i')
*
*     cooling due to higher Paschen lines
      call linadd( max(0., hrest) ,  0   , 'Crst','i')
*
*     heating due to higher Paschen lines
      call linadd( max(0.,-hrest) ,  0   , 'Hrst','i')
*
*     H2 rotation lines from Lepp and Shull ApJ 270, 578.
      call linadd( h2line , 2 , 'H2 l','c')
*
*     H2 dissociation by H atoms (not e)
      call linadd( h2dis , 0 , 'H2dC','c')
*
*     molecular hydrogen heating
      h2dtot = h2dtot + HeatH2Dish * dVeff
      h2dfrc = max( HeatH2Dish/htot , h2dfrc )
*
*     heating by H2 dissociation by Lyman continuum
      call linadd( HeatH2Dish , 0 , 'H2dH','h')
*
*     neg H ion free-bound emission
      call linadd( hmfb , 0 , 'H-FB' ,'c')
*
*     H+ + H => H2+ + photon continuum cooling
      call linadd( H2PlsCool , 0 , 'H2+ ','c')
*
*     HeH+ formation cooling
      call linadd(max((3.27E-12+te*Boltzmann),0.)*hii*hei*1e-20+
     1(1.76E-11+te*Boltzmann )*hi*heii*1e-16 , 0 , 'HEH+','i')
*
*     carbon monoxide heating
      codtot = codtot + CODissHeat * dVeff
      codfrc = max( CODissHeat/htot , codfrc )
*
*     carbon monoxide co photodissociation
      call linadd( CODissHeat , 0 , 'COdh' , 'h')
*
*     cooling due to coll of vib rot levels
      call linadd( COVibCool , 0 , 'CO C' , 'c' )
*
*     He brems emission
      call linadd(bhe , 0 , 'HeFF','c')
*
*     He recombination cooling
      call linadd(herec , 0 , 'HeFB','c')
*
*     heavy element recombination cooling
      call linadd( heavfb , 0 , 'MeFB' ,'c')
*
*     metal brems emission
      call linadd( heavff , 0 , 'MeFF','c')
*
*     total brems emission
      call linadd((hbrems+bhe+heavff) , 0 , 'ToFF' ,'i')
*
*     He I triplet net collisional ionization cooling
      call linadd( max(0.,He3IonCool) , 0 , 'He3I','c')
*
*     He I triplet net 3-body heating
      call linadd( max(0.,-He3IonCool) , 0 , 'He3b','h')
*
*     He I 584, collisional excitation cooling
      call linadd( max(0.,c584) , 584 , 'HeIC','c')
*
*     He I 584, collisional de-excitation heating
      call linadd( max(0.,-c584) , 584 , 'HeIH','h')
*
*     total 584 emergent from cloud in inner direction
*     now compute emergent Helium emergent flux
      if( lgSphere ) then
        spfac = 0.5
        e911 = 0.
        e584 = 0.
        e626 = 0.
        e228 = 0.
        e504 = 0.
      else
        spfac = 1.
        if( chDffTrns(1:2).eq.'OU' ) then
          eff = 0.5
        else
          eff = 1.
        endif
        e504 = esc504 / 2. * 3.95e-11 * eff
*       this is inward looking tau but no fac of two in original defn
        e584 = esc584 / 2. * 3.41e-11 /2.
*       this looked to illuminated face and does not need extra factor
        e626 = esc626 * 3.18e-11
        e911 = esc911 * 2.18e-11 * eff
        e228 = esc228 * 8.72e-11 * eff
      endif
*
*     He I rec to ground escaping cloud
      call linadd( e504 , 504 , 'He I' ,'i')
*
*     He I Ly alpha escaping cloud
*     call linadd( e584 , 584, 'esc ' ,'i')
*     these lines added to outlin in metdif - following must be false
      call lindst( e584 , 584, 'esc ',iphe1l(2,1),'i', .false.)
*
*     He I 2^3S-ground emission escaping lluminated face of cloud
*     call linadd( e626 , 626 , 'esc ' ,'i')
*     these lines added to outlin in metdif - following must be false
      call lindst( e626 , 626, 'esc ',ipHe23sGrnd,'i', .false.)
*
*     He I 4471,
      if( te.le.1e4 ) then
        em = 2.42e-22/(te/te10)
      else
        em = 8.79e-22 / te / te03 / te01
      endif
*
*     >>chng 97 jan 4, label was HeI, changed to Ca B for symmetry with others
*     He I 4471 recombination only, fit to Brocklehurst '72
      rec = eden*heii*em
      call PntForLine( 4471. , 'He 1' , ipnt )
      call lindst(rec,4471,'Ca B',ipnt,'i', .true.)
*     call linadd( eden*heii*em , 4471 , 'Ca B' ,'i')
*
*     He I total 5876, from n-level atom
*     these lines added to outlin in metdif - following must be false
      call lindst(p5876,5876,'TOTL',ipHe3l(2),'i', .false.)
*
*     inward part of 5876
      call linadd( p5876*t5876(ipLnInwd) , 5876 , 'Inwd','i')
*
*     He I 5876 REC, simple fit to Brocklehurst
      call linadd(eden*heii*4.22e-21/(te*te10),5876,'Ca B','r')
*
*     He I 6678 REC, simple fit to Brocklehurst
      rec = eden*heii*1.32e-21/(te*te10*te01)
      call PntForLine( 6678. , 'He 1' , ipnt )
      call lindst(rec,6678,'Ca B',ipnt,'i', .true.)
*
*     10830 from n-level atom
*     these lines added to outlin in metdif - following must be false
      call lindst(p10830,10830,'TOTL',ipHe3l(1),'i', .false.)
*
      f10830 = 1.02e7*t10830(ipLnEscP) /
     1 (1.02e7*t10830(ipLnEscP)+ 2.51e-9*sqrte*eden)
*
*     He I 10830 produced by radiative recombination
      rec = heii * eden * 5.13e-22 /(te70*te10*te01*te01)*f10830
      call linadd( rec,10830 ,'reco' ,'i')
*
*     following expression from Clegg 1987
      pop = heii * 5.79e-6*((te/1e4)**(-1.18)) /
     1 (1. + 3110./eden*((te/1e4)**(-0.51)) )
      col = pop * c2s2p * 1.84e-12*f10830
*
*     collisionally excited 10830 estimated from Clegg 1987 (not model atom)
      call linadd( col,10830 ,'coll' ,'i')
*
*     inward escaping HeI 10830
      call linadd( he10in,10830 ,'Inwd' ,'i')
*
*     He I 3889 from n-level atom
*     these lines added to outlin in metdif - following must be false
      call lindst(p3889,3889,'TOTL',ipHe3l(4),'i', .false.)
*
*     He I 7065 from n-level atom
*     these lines added to outlin in metdif - following must be false
      call lindst(p7065,7065,'TOTL',ipHe3l(3),'i', .false.)
*
*     total collisional He I triplet line cooling, from n-level atom
      call linadd( max(0.,he3clx) , 0 , 'CcHE' ,'c')
*
*     total collisional de-exec He I heating, from n-level atom
      call linadd( max(0.,-he3clx) , 0 , 'ChHE' ,'h')
*
      em = eden * heii
      cb206 = 1.064e-22 / te70/te10/te03/te03 * em
*
*     case B He I 2.06 micron
      call linadd( cb206 , 2 , 'Ca B','i')
*
*     He I 2.06 micron from model atom, all physics in
      totl = heii*he12p*t206(ipLnAul)*t206(ipLnEscP)*9.66e-13
      call PntForLine( 20600. , 'He 1' , ipnt )
      call lindst( totl , 2 , 'TOTL',ipnt,'i', .true.)
*     call linadd( totl , 2 , 'TOTL','i')
*
*     Case B He I 5016
      cb5016 = 5.43e-23 / te70/te10 * em
      call PntForLine( 5016. , 'He 1' , ipnt )
      call lindst( cb5016 , 5016 , 'Ca B',ipnt,'i', .true.)
*     call linadd( cb5016 , 5016 , 'Ca B','i')
*
*     He II Lyman continuum
      call linadd( e228 , 228 , 'HeII' ,'i')
*
*     He II Balmer continuum escaping from cloud
      call linadd( e911 , 911 , 'He2C' ,'i')
*
*     He II 304 predicted by 10-level atom
      sum = heiii*he22p*he2mis(2,1)*6.546e-11*spfac
*     these lines added to outlin in metdif - following must be false
      call lindst(sum,  304,'TOTL',iphe2l(2,1),'i', .false.)
*     call linadd(sum , 304,'TOTL','i')
*
*     He II 1640 predicted by 10-level atom
*     these lines added to outlin in metdif - following must be false
      sum = heiii*he2n(3)*he2mis(3,2)*1.214e-11
      call lindst( sum,  1640,'TOTL',iphe2l(3,2),'i', .false.)
*     call linadd( sum , 1640,'TOTL','i')
*
*     inward part of HeII 1640
      call linadd(sum*he2fin(3,2) , 1640,'Inwd','i')
*
      sum = heiii*he2n(4)*he2mis(4,2)*1.637e-11
*     He II 1216 predicted by 10-level atom, only valid at high densities
*     these lines added to outlin in metdif - following must be false
      call lindst( sum, 1217,'TOTL',iphe2l(4,2),'i', .false.)
*     call linadd(sum , 1217,'TOTL','i')
*
*     He II 1216 inward fraction
      call linadd(sum*he2fin(4,2) , 1217,'Inwd','i')
*
*     He II 1085 predicted by 10-level atom, only valid at high densities
      sum = heiii*he2n(5)*he2mis(5,2)*1.84e-11
*     these lines added to outlin in metdif - following must be false
      call lindst( sum,  1085,'TOTL',iphe2l(5,2),'i', .false.)
*     call linadd( sum,  1085,'TOTL','i')
*
*     He II 1085 inward fraction
      call linadd( sum*he2fin(5,2) , 1085,'Inwd','i')
*
*     He II 4686 predicted by 10-level atom, only valid at high densities
      sum = heiii*he2n(4)*he2mis(4,3)*4.247e-12
*     these lines added to outlin in metdif - following must be false
      call lindst( sum, 4686,'TOTL',iphe2l(4,3),'i', .false.)
*     call linadd( sum, 4686,'TOTL','i')
*
*     inward beamed part of 4686
      call linadd( sum * he2fin(4,3) , 4686,'Inwd','i')
*
*     He II 3205 predicted by 10-level atom, only valid at high densities
      sum = heiii*he2n(5)*he2mis(5,3)*6.21e-12
*     these lines added to outlin in metdif - following must be false
      call lindst( sum, 3205,'TOTL',iphe2l(5,3),'i', .false.)
*     call linadd( sum, 3205,'TOTL','i')
*
*     HeII 3205 inward fraction
      call linadd( sum * he2fin(5,3) , 3205,'Inwd','i')
*
      fac = eden * heiii
      em = fac *2.03e-20/(te70*te10*te03)
*     He II 1640, case B at low densities
      call linadd(  em , 1640 , 'Ca B' ,'i')
*
*     He II 4686, case B
      em = fac *2.52e-20/(te**1.05881)
      call linadd(  em , 4686 , 'Ca B' ,'i')
*
      if( lgTrace ) write(qq,'(''   LineSet1 returns'')')
*
      end
******************************************************************************
      subroutine LineSet2
      implicit none
*place lines of elements lithium through neon into lines storage stack
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real raten3
      common/raten3/ raten3
      real DiffusHeavy , xLyaHeavy
*DiffusHeavy is total rec rate to grnd for nelem,ion element
*xLyaHeavy is Lya for nelem,ion
      common/DiffHeav/ DiffusHeavy(limelm,limelm),
     1 xLyaHeavy(limelm,limelm)
*     include "RecCNO.com"
      real TurbVel
*this is the turbulent velocity in cm/s, normally zero, set with
*turbulence command
      common/turb/ TurbVel
      real cyntrn,hmfb,c584,heavfb,bhe,herec,eebrm,h2line,h2dis,
     1 heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      common/coolng/cyntrn,hmfb,c584,heavfb, bhe,herec,eebrm,h2line,
     1 h2dis,heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      real p1909 , p2326 , p1895 , p1666 , p1401
      common/pmp2s/ p1909 , p2326 , p1895 , p1666 , p1401
      real supprs
*     suppresssion factors for dielectronic recombination
*     1 is burgess and 2 is storey
      common/supprs/ supprs(limelm,2)
      real r9850
      common/r1335/ r9850
      real c3343, c3869, c4720, c2424, c2975, c1565, c3426, c1134
      common/coolne/ c3343, c3869, c4720, c2424, c2975, c1565, c3426,
     1 c1134
      real c5577, c6300, c3727, c7325, c4363, c5007, fs88, fs52,
     1 coolOi , c6363
      common/coolox/ c5577, c6300, c3727, c7325, c4363, c5007, fs88,
     1 fs52, coolOi , c6363
      real c5200, c5755, c6584, c10400,c3466
      common/cooln/ c5200, c5755, c6584, c10400,c3466
      real c9850,c8727,c3134
      common/coolc/ c9850,c8727,c3134
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real popoi
      common/popoi/ popoi(6)
      real s3727 , s7325
      common/s3727/ s3727 , s7325
*     include "pntmet.com"
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real AugerO3
*photoionization rate for OII, producing 1665
      common/augro3/ AugerO3
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real O3730,O3727,O2471,O7323,O7332
      common/oii/ O3730,O3727,O2471,O7323,O7332
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variable
      integer nelem , ipnt
      real rp386,rp300,xlila,bela,bola,corr,
     1 ctRate, efficn2,cs5200,r6584,fac,rec , t4 ,sum , colfac,
     2 rnii , p386,cla,rn3tot,rn3mor,flla,rb,ct4363,r4363,
     3 efac,effec,ola,xnela , xnla , GetLineRec
*
      if( lgTrace ) write(qq,'(''   LineSet2 called'')')
*
      t4 = te / 1e4
*
*     cooling due to collisional ionization of heavy elements
      call linadd( colmet , 0 , 'Mion' ,'c')
*
*     lithium
*     recombination from fully stripped ion
      nelem = 3
*     these lines added to outlin in metdif - following must be false
      xlila = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( xlila*1.05E-9 , 19 , 'Li3r','i')
*
*     beryllium
*     recombination from fully stripped ion
      nelem = 4
*     these lines added to outlin in metdif - following must be false
      bela = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( bela*1.05E-9 , 19 , 'Be4r','i')
*
*     boron
*     recombination from fully stripped ion
      nelem = 5
*     these lines added to outlin in metdif - following must be false
      bola = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( bola*1.05E-9 , 19 , 'Bo5r','i')
*
*     carbon
*
*     >>chng 97 may 2, added better rec coef
*     C I 1656 recombination, all agents
      rec = GetLineRec( 4, 1657 ) * t1656(ipLnAovTOT)
      call PutExtra( rec )
*
*     C 1 1656, collision strength from van Regemoter
      call PutLine( t1656 )
*
*     C 1 1656 recomb; n.b. coll deexcitation not in
      call linadd( rec ,1656, 'REC ','i')
*
*     C 1 9850, coll excit
      call linadd( c9850 , 9850 , 'C Ic','c')
*
*     >>chng 97 may 2, added better rec coef
*     C 1 9850, recom contribution rec coef from apj sup 73, 513.
*     r9850 is correction for collisional deexcitation as in carb cool
*     >>chng 97 aug 2, had factor of rec, changed to r9850, this
*     was a big mistake
      rec = (GetLineRec(2,9088)+GetLineRec(3,9658)) * r9850
      call linadd( rec , 9850 , 'C Ir','i')
*
*     total intensity, all processes, C I 9850
      call PntForLine( 9850. , 'C  1' , ipnt )
      call lindst( rec+c9850, 9850,'TOTL',ipnt,'i', .true.)
*     call linadd( rec+c9850, 9850 , 'TOTL','i')
*
*     C 1 8727; equivalent to 4363
      call PntForLine( 8727. , 'C  1' , ipnt )
      call lindst( c8727, 8727,'C  1',ipnt,'c', .true.)
*     call linadd( c8727, 8727, 'C  1','c')
*
*     1S - 3P
      call linadd(c8727*1.22E-6, 4621, 'C  1','c')
*
*     C 1 610 micron
      call PutLine( t610 )
*
*     C 1 370 micron
      call PutLine( t370 )
*
*     C 2 158 micron, both e- and H0, H2 in excitation
      call PutLine( t157 )
*
*     C 2  2326
*     total CII] 2326 with correction for Balmer continuum abs
      call PutExtra( p2326*8.6e-12 )
      call PutLine( t2326 )
*
*     photoproduction, Helfand and Trefftz
      call linadd( p2326*8.6E-12 , 2326 , 'Phot' ,'i')
*
*     >>chng 97 may 2, better rec coef
      rec = GetLineRec(12,1335) * t1335(ipLnAovTOT)
*
*     total intensity of C 2 1335
      call PutExtra( max(0.,rec) )
      call PutLine( t1335 )
*
*     C 2 1335 recombination,
      call linadd(rec,1335,'REC ','i')
*
*     C 2 intercombination line with same upper state as 1335
      call linadd( c3134 , 3134 , 'C II','c')
*
*     *****************************************
*     C 3 977
*     recombinaton contribution from nussbaumer and story 84
      rec = GetLineRec( 180, 977 ) * t977(ipLnAovTOT)
*
*     continuum pumped C 3 977 by continuum near 386A
      rp386 = t386(ipLnPump) *t386(ipLnPopOpc)
*
*     higher lines, same process
      rp300 =
     1 t310(ipLnPump)*t310(ipLnPopOpc) +
     2 t291(ipLnPump)*t291(ipLnPopOpc) +
     3 t280(ipLnPump)*t280(ipLnPopOpc) +
     4 t274(ipLnPump)*t274(ipLnPopOpc) +
     5 t270(ipLnPump)*t270(ipLnPopOpc)
*
*     total line intensity due to pumping
      p386 = (rp386 + rp300) *2.03e-11 * t977(ipLnAovTOT)
*
*     total C 3 977 including recombination and pumping
      call PutExtra( p386+max(0.,rec))
*
*     total C 3] 977, recombination + collisional + pumped excitation
      call PutLine( t977 )
*
*     dielectronic recombination contribution to C 3 977
      call linadd( rec  , 977 , 'C3 R' ,'i')
*
*     C 3 977 pumped by continuum near 386A
      call linadd( p386 , 977 , 'P386' ,'r')
*
*     C 3  1909 collision, both lines together
      fac = em1908+t1909(ipLnInten)
      call linadd( fac , 1909 , 'TOTL','i')
*
      call PutLine(t1909 )
*
*     C 3 1908 j-2 to ground
      call PntForLine( 1907. , 'C  3' , ipnt )
      call lindst( em1908 , 1907 ,'C  3',ipnt,'i', .true.)
*     call linadd( em1908 , 1907 , 'C  3','i')
*
      corr = t1909(ipLnAovTOT)
      fac = eden * xIonFracs(6,4)/(te/te10)*supprs(3,2)
*
*     C 3 1909 recombination from Storey
      call linadd( 3.1E-19*fac*corr,  1909  ,  'C3 R' ,'i')
*
*     C 3 1909 following relax following inner shell photoionization
      call linadd( p1909*corr*1.05E-11 , 1909 , 'Phot' ,'i')
*
*     >>chng 97 may 2, better rec ocef
      rec = GetLineRec( 179,1176)*c31175(ipLnAovTOT)
      call PutExtra( max(0.,rec) )
*
*     C 3* 1175, excited state line, above 1909
      call PutLine( c31175 )
*
*     dielectronic recombination contribution to C 3 1175
      call linadd( max(0., rec ) , 1175, 'Rec ', 'i' )
*
*     recombination C 4 1549 from C 5
*     >>chng 97 may 2, better rec coef
      rec = GetLineRec( 26, 1549 ) * t1550(ipLnAovTOT)
*
*     total intensity of C 4 1549, all processes
      call linadd(t1550(ipLnInten)+t1548(ipLnInten)+rec,1549,'TOTL','i')
      sum = t1550(ipLnInten)*t1550(ipLnInwd) +
     1 t1548(ipLnInten)*t1548(ipLnInwd)
*
*     inward part of C 4
      call linadd(sum+rec*t1550(ipLnInwd),1549,'Inwd','i')
      call PutExtra( rec*.3333 )
      call PutLine( t1550 )
      call PutExtra( rec*.6666 )
      call PutLine( t1548 )
*
*     part of line destroyed by photoionization of Balmer continuum
      call linadd( (t1550(ipLnOTS)+t1548(ipLnOTS))*t1548(ipLnEnrErg) ,
     1 1549 , 'DEST' ,'i')
*
*     recombination C 4 1549 from CV
      call linadd( rec ,1549, 'C4 r','i')
*
*     Li seq 2s 3p Li seq transition
      call PutLine( t312 )
*
*     K-alpha due to recombination of stripped ion
*     these lines added to outlin in metdif - following must be false
      cla = xLyaHeavy(6,6)*xIonFracs(6,7)*5.90E-10
      call PntForLine( 33.7 , 'C 6r' , ipnt )
      call lindst( cla, 34,'C 6r',ipnt,'i', .false.)
*     call linadd( cla , 34 , 'C 6r','i')
*
*     nitrogen
*
*     5200 rec, both rad+di, 1/3 of total to doublets
      colfac = 8.629e-6/sqrte*eden
      cs5200 = 7.28e-5 * te / te10
*     this is recombination with quenching
      rec = GetLineRec( 33 , 1200 ) *
     1 1.24e-5 / (1.24e-5 + cs5200*colfac / 10. )
*
*     N 1 5200, both 5198, 5200, collisions and recombination
      call PntForLine( 5200. , 'N  1' , ipnt )
      call lindst(c5200+rec,5200,'N  1', ipnt,'i',.true.)
*     call linadd(c5200+rec,5200,'N  1','i')
*
*     N 1 5200, both 5198, 5200, collisions and recombination
      call linadd(c5200,5200,'Coll','c')
*
*     recombination contributon to [NI] 5200
      call linadd( rec , 5200 , 'REC ','i')
*
*     [N 1] 3466, 3 - 1 transition, whole multiplet
      call PntForLine( 3466. , 'N  1' , ipnt )
      call lindst(c3466 , 3466,'N  1', ipnt,'c',.true.)
*     call linadd(c3466 , 3466 , 'N  1','c')
*
*     [N 1] 10400 3 - 2 transition, whole multiplet
      call PntForLine( 10400. , 'N  1' , ipnt )
      call lindst( c10400 , 10400,'N  1', ipnt,'c',.true.)
*     call linadd( c10400 , 10400,'N  1','c')
*
*     collisionally excited part
      call PutLine( t1200 )
*
*     N 2 6584 alone
      call PntForLine( 6584. , 'N  2' , ipnt )
      call lindst(c6584/(1.+1./2.951) ,6584,'N  2', ipnt,'c',.true.)
*
*     N 2 6548 alone
      call PntForLine( 6548. , 'N  2' , ipnt )
      call lindst(c6584/(1.+2.951) ,6548,'N  2', ipnt,'c',.true.)
*
*     N 2 6584 alone, recombination contribution
      efficn2 = 4e-3/(4e-3+5.18e-6*eden/sqrte)
      r6584 = 8e-22/(te70/te03/te03)* efficn2
      call linadd( r6584 * xIonFracs(7,3) * eden , 6584 , 'REC ' ,'i')
*
*     helium charge transfer form Sun Sadeghpour, Kirby Dalgarno and Lafyatis,
*     cfa preprint 4208
      ctRate = 1.8e-11 * hei * xIonFracs(7,3)*1.146/
     1 (1.146 + 0.87*cdsqte) * 3.46e-12
*
*     N 2 5755  total, collisions plus charge transfer
      call PntForLine( 5755. , 'N  2' , ipnt )
      call lindst( c5755+ctRate, 5755 , 'N  2' , ipnt ,'i',.true.)
*     call linadd( c5755+ctRate, 5755 , 'N  2','i')
*
*     N 2 5755  collisional contribution
      call linadd( c5755 , 5755 , 'Coll','c')
*
*     N 2 5755  charge transfer contribution
      call linadd( ctRate , 5755 , 'C T ','c')
*
*     N 2 fine structure line
      call PutLine( t122 )
*
*     N 2 fine structure line
      call PutLine( t205 )
*
*     N 2 2140 intercombination line
      call PutLine( t2140 )
*
*     >>chng 97 may 2, better rec contribution
      rec = GetLineRec( 202 , 1085 ) * t1085(ipLnAovTOT)
      call PutExtra( max(0.,rec) )
*
*     N 2 1084, CS guess from g-bar
      call PutLine( t1085 )
*
*     dielectronic recombination contribution to N 2 1085
      call linadd( max(0., rec ) , 1085, 'Rec ', 'i' )
*
*     continuum puming of N 2 intersystem transition
      rnii = t671(ipLnPump) * t671(ipLnPopOpc)
*
*     continuum pumped N 2 6584
      call linadd(  rnii*0.377*0.75*3.02E-12*efficn2  ,  6584  ,
     1 'N2cn', 'i')
*
*     continuum pumped N 2 5755
      efficn2 = 1. /(1. +8.6e-6*eden/sqrte)
      call linadd(rnii*0.0117*3.46E-12*efficn2 ,5755,'N2cn', 'i')
*
*     N 3] 1750, collisionally excited
      call PutLine( t1750 )
*
*     [N 3] 57 micron fine structure line
      call PutLine( t57 )
*
*     continuum pumped "Bowen" N 3
*     rate system a is populated
      raten3 = t374x(ipLnPopOpc) * t374x(ipLnPump)
*
*     rate system b is populated
      if( TurbVel.lt.200. ) then
        rb = t374x(ipLnPopOpc) * t374x(ipLnPump) + t374g(ipLnPopOpc) *
     1  t374g(ipLnPump)
      else
*       only one line if both fully overlap due to large turb
        rb = t374g(ipLnPopOpc) * t374g(ipLnPump)
      endif
      rn3mor = t315(ipLnPopOpc)*t315(ipLnPump)*0.448 + t324(ipLnPopOpc)*
     1 t324(ipLnPump)*0.78 +
     1  t333(ipLnPopOpc)*t333(ipLnPump)* 0.434
*
*     pumping of optical N 3 bowen lines
      rn3tot = ( rb + raten3 ) * 0.439 + rn3mor
*
*     continuum pumped "Bowen" N 3, optically thin excited line
      sum = raten3*4.29E-12
      call PntForLine( 4640. , 'N3cn' , ipnt )
      call lindst( sum  , 4640 , 'N3cn' , ipnt ,'i',.true.)
*     call linadd( raten3*4.29E-12, 4640, 'N3cn' , 'i' )
*
*     continuum pumped "Bowen" N 3, optically thin excited line
      sum = rb*4.29E-12*0.834
      call PntForLine( 4634. , 'N3cn' , ipnt )
      call lindst( sum  , 4634 , 'N3cn' , ipnt ,'i',.true.)
*     call linadd( rb*4.29E-12*0.834, 4634, 'N3cn' , 'i' )
*
*     continuum pumped "Bowen" N 3, optically thin excited line
      sum = rb*4.29E-12*(1.-0.834)
      call PntForLine( 4642. , 'N3cn' , ipnt )
      call lindst( sum  , 4642 , 'N3cn' , ipnt ,'i',.true.)
*     call linadd( rb*4.29E-12*(1.-0.834), 4642, 'N3cn' , 'i' )
*
*     total rate for N 3 990
*     correction factor for collisional deexcitation
      fac = t990(ipLnAovTOT)
*
*     >>chng 97 may 2, better rec coef
      rec = GetLineRec(217 , 991)*t990(ipLnAovTOT)
      call PutExtra( max(0.,rec)+ rn3tot*2.01e-11*fac )
*
*     N 3 990, all processes
      call PutLine( t990 )
*
*     total N 3 990, both electron excitation and continuum pumping
      call linadd( rec+rn3tot*2.01e-11*fac , 990 , 'extr','i')
*
*     part of N 3 990 due to recombination
      call linadd( rec , 990 , 'rec ','i')
*
*     N 3 989.8, continuum pumped
      call linadd( rn3tot*2.01e-11 , 990 , 'N 3p','r')
*
*     N 4] 1486, total intensity of both lines
      call linadd( em1486+t1486(ipLnInten) , 1486 , 'TOTL','i')
      call PutLine( t1486 )
*
*     the N 4] slow transition by itself
      call linadd( em1486 , 1485 , 'N  4','i')
*
*     >>chng 97 may 2, better expression for dielectronic recombination
      rec = GetLineRec( 288 , 765 )*t765(ipLnAovTOT)
*
*     dielectronic recom contribution from Nussbaumer and Storey 1984
      call PutExtra(rec )
*
*     N 4 765, collisionally excited
      call PutLine( t765 )
*
*     N 4 765 recombination,
      call linadd(max(0.,rec),765,'rec ','i')
*
*     continuum pumping of NV 1240
*     N 5 1240, total emission, collisions plus pumping
      call linadd( t1243(ipLnInten)+t1239(ipLnInten),1240,'TOTL','i')
      sum = t1243(ipLnInten)*t1243(ipLnInwd) +
     1 t1239(ipLnInten)*t1239(ipLnInwd)
*
*     inward part of N 5
      call linadd( sum,1240,'Inwd','i')
      call PutLine( t1243 )
      call PutLine( t1239 )
*
*     N 5 209, 2s-3p li seq
      call PutLine( t209 )
*
*     recombination K-alpha from fully stripped ion
*     these lines added to outlin in metdif - following must be false
      xnla = xLyaHeavy(7,7)*xIonFracs(7,8)
      call PntForLine( 24.8 , 'N 7r' , ipnt )
      call lindst( xnla*8.03E-10, 25 , 'N 7r' , ipnt ,'i',.false.)
*     call linadd( xnla*8.03E-10, 25 , 'N 7r','i')
*
*     fluorine
*     [F II] 29.33 microns
      call PutLine( F0229 )
*
*     [F II] 67.2 microns
      call PutLine( F0267 )
*
*     F IV 44.07 micron
      call PutLine( F444 )
*
*     F IV 25.83 micron
      call PutLine( F425 )
*     recombination from fully stripped ion
      nelem = 7
*     these lines added to outlin in metdif - following must be false
      flla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( flla*1.05E-9 , 19 , 'Fl7r','i')
*
*     oxygen
*     total Oxygen I  6300, including line optical depth
      call PntForLine( 6300. , 'O  1' , ipnt )
      call lindst( c6300  , 6300 , 'O  1' , ipnt ,'c',.true.)
*
*     total Oxygen I  6363, including line optical depth
      call PntForLine( 6363. , 'O  1' , ipnt )
      call lindst( c6363  , 6363 , 'O  1' , ipnt ,'c',.true.)
*
*     auroral OI
      call PntForLine( 5577. , 'O  1' , ipnt )
      call lindst( c5577 , 5577 , 'O  1' , ipnt ,'c',.true.)
*     call linadd( c5577 , 5577 , 'O  1','c')
*
*     O I fine structure line
      call PutLine( t63 )
*
*     O I fine structure line
      call PutLine( t146 )
*
*     total collisional cooling due to 6-level OI atom
      call linadd( max(0.,coolOi) , 0, 'TOIc','c')
*
*     total collisional heating due to 6-level OI atom
      call linadd( max(0.,-coolOi) , 0, 'TOIh','h')
*
*     OI 8446 from six level atom
      sum = popoi(5)*t8446(3)*3.28E7*2.36E-12
      call PntForLine( 8446. , 'O  1' , ipnt )
*666 error!  these are actually in the optical depth arrays, should
*     be moved to call PutLine
      call lindst( sum , 8446 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(5)*t8446(3)*3.28E7*2.36E-12,8446,'6lev','i')
*
*     OI 1304 from six level atom
      call PntForLine( 1304. , 'O  1' , ipnt )
      sum = popoi(2)*t1304(3)*6.04E8*1.53E-11
      call lindst( sum , 1304 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(2)*t1304(3)*6.04E8*1.53E-11,1304,'6lev','i')
*
*     OI 1039 from six level atom
      call PntForLine( 1039. , 'O  1' , ipnt )
      sum = popoi(4)*t1039(3)*1.69E8*1.92E-11
      call lindst( sum , 1039 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(4)*t1039(3)*1.69E8*1.92E-11,1039,'6lev','i')
*
*     OI 4368 from six level atom
      call PntForLine( 4368. , 'O  1' , ipnt )
      sum = popoi(6)*t4368(3)*8.97E6*4.55E-12
      call lindst( sum , 4368 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(6)*t4368(3)*8.97E6*4.55E-12,4368,'6lev','i')
*
*     OI 1.3 micron from six level atom
      call PntForLine( 13100. , 'O  1' , ipnt )
      sum = popoi(4)*tOI13(3)*2.12E7*1.52E-12
      call lindst( sum , 13 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(4)*tOI13(3)*2.12E7*1.52E-12,  13,'6lev','i')
*
*     OI 1.1 micron from six level atom
      call PntForLine( 11300. , 'O  1' , ipnt )
      sum = popoi(5)*tOI11(3)*3.03E7*1.76E-12
      call lindst( sum , 11 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(5)*tOI11(3)*3.03E7*1.76E-12,  11,'6lev','i')
*
*     OI 2.9 micron from six level atom
      call PntForLine( 29000. , 'O  1' , ipnt )
      sum = popoi(6)*tOI29(3)*4.00E6*6.86E-13
      call lindst( sum , 29 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(6)*tOI29(3)*4.00E6*6.86E-13,  29,'6lev','i')
*
*     OI 4.6 micron from six level atom
      call PntForLine( 46000. , 'O  1' , ipnt )
      sum = popoi(6)*tOI46(3)*9.73E5*4.32E-13
      call lindst( sum , 46 , '6lev' , ipnt ,'i',.false.)
*     call linadd(popoi(6)*tOI46(3)*9.73E5*4.32E-13,  46,'6lev','i')
*
*     O II 3727 produced by photoionization OF O0
      s3727 = (s3727+s7325*0.5) * 5.34e-12 * 9.7e-5 / (9.7e-5 +
     1 eden * 1.15e-6 / sqrte )
*
*     O II 3727, all lines of multiplet together
      call PntForLine( 3727. , 'O  2' , ipnt )
      call lindst( c3727+s3727 , 3727 , 'TOTL' , ipnt,'c',.true.)
*
*     O II 7325, all lines of multiplet together
      call PntForLine( 7325. , 'O  2' , ipnt )
      call lindst( c7325 , 7325 , 'TOTL',ipnt,'c',.true.)
*
*     line produced by photoionization of Oo; already in TOTL
      call linadd( s3727 , 3727 , 'IONZ' ,'i')
      s7325 = s7325 * 2.72E-12 * 0.34 / (0.34+eden*6.04e-6/sqrte)
*
*     line produced by photoionization of Oo; already in TOTL
      call linadd( s7325 , 7325 , 'IONZ' ,'i')
*
*     five level atom calculations; D5/2 - S3/2
      call linadd(O3730,3729,'O II','i')
*
*     D3/2 - S3/2 transition
      call linadd(O3727,3726,'O II','i')
*
*     both 2P 1/2 and 3/2 to ground
      call linadd(O2471,2471,'O II','c')
*
*     P1/2-D5/2 and P3/2-D5/2 together
      call linadd(O7323,7323,'O II','i')
*
*     P1/2-D3/2 and P3/2-D3/2 together
      call linadd(O7332,7332,'O II','i')
*
*     O II 833.8 coll excit
      call PutLine( t834 )
*
*     >>chng 97 july 24, following three lines are also in Dima's list
*     coef = 34.9E-14*t4**(-0.749)*(1.+0.023*(1.-t4)+0.074*(1.-t4)**2)*
*    1 supprs(2,2)
*     O II 4651 - whole multiplet, from Storey Ast Ap 282, 999 (1994).
*     call linadd( eden*oxy(3)*coef*4.28e-12,4651,'O  2','i')
*
*     OII 4075 - Storey AstAp 282, 999 (1994)
*     coef = 24.5e-14*t4**(-0.770)*(1.+0.096*(1.-t4)+0.039*(1.-t4)**2)
*     call linadd( eden*oxy(3)*coef*4.88e-12,4075,'O  2','i')
*
*     OII 4341 - Storey AstAp 282, 999 (1994)
*     coef = 10.4e-14 * t4**(-0.721)*(1.+0.073*(1.-t4)+0.072*(1.-t4)**2)
*     O II 4341 - whole multiplet, from Storey Ast Ap 282, 999 (1994).
*     call linadd( eden*oxy(3)*coef*4.58e-12,4341,'O  2','i')
*
*     O III 1661+1666
      efac = (t1666(ipLnAovTOT)+t1661(ipLnAovTOT) )* 0.5
*
*     total intensity of OIII] 1665, all processes
      call linadd(t1666(ipLnInten)+t1661(ipLnInten),1665,'TOTL','i')
      call PutLine( t1661 )
*
      call PutLine( t1666 )
*
*     contribution to OIII 1665 due to inner shell (2s^2) ionization
      call linadd(p1666*1.20e-11*efac , 1665 , 'Phot' ,'i')
*
*     contribution to OIII 1665 due to K-shell ionization
      call linadd(AugerO3*1.20e-11*efac*0.27 , 1665 , 'Augr' ,'i')
*
*     O III  5007 alone, collisions, tot OIII is this times 1.333
*     fac = c5007/(1.+1./2.887)
      call PntForLine( 5007. , 'O  3' , ipnt )
      call lindst(c5007/(1.+1./2.887), 5007 , 'O  3',ipnt,'c',.true.)
*
*     O III  4959 alone, collisions, tot OIII is this times 4
      call PntForLine( 4959. , 'O  3' , ipnt )
      call lindst(c5007/(1.+2.887) , 4959 , 'O  3' , ipnt,'c',.true.)
*
*     O III 5007 lost through excit photo
      call linadd( d5007t / 1.25 , 5007 , 'LOST','i')
*
*     collisional quenching ratio
      effec = 1.6 / ( 1.6 + 0.9*colfac)
*
*     O III 4363 recombination, coef from Burgess and Seaton
      r4363 = 6.3e-21 / (te70*te10) *  eden * xIonFracs(8,4)*effec
*
*     charge exchange, Dalgarno+Sternberg ApJ Let 257, L87.
*     scalled to agree with Gargaud et al AA 208, 251, (1989)
      ct4363 = sqrte*1.3e-12*4.561e-12*hi*xIonFracs(8,4)*effec
*
*     O III 4363, sum of rec, coll, ct excitation
      fac = c4363+r4363+ct4363
      call PntForLine( 4363. , 'O  3' , ipnt )
      call lindst(fac, 4363 , 'TOTL' , ipnt ,'i', .true.)
*
*     O III 4363,collisions from five level atom
      call linadd( c4363 , 4363 , 'Coll' , 'c')
*
*     O III 4363 recombination, coef from Burgess and Seaton
      call linadd( r4363 , 4363 , 'Rec ','i')
*
*     collisional excitation of 2321, 5-level atom
      call PntForLine( 2321. , 'O  3' , ipnt )
      call lindst( c4363*0.236 , 2321 , 'O  3' , ipnt ,'c', .true.)
*     call linadd( c4363*0.236 , 2321 , 'O  3','c')
*
*     charge exchange, Dalgarno+Sternberg ApJ Let 257, L87.
      call linadd(ct4363,4363,'C EX','i')
*
*     charge exchange rate, D+S
      call linadd( hi*xIonFracs(8,4)*0.225*3.56e-12*1.34e-11*sqrte ,
     1 5592 , 'C EX','i')
*
*     O III 88 micron, collisionally excited
      call PutLine( tO88 )
*
*     O III 52 micron, collisionally excited
      call PutLine( t52 )
*
*     >>chng 97 may 2, better rec contribution
      rec = GetLineRec(332, 835 ) * t835(ipLnAovTOT)
      call PutExtra( max(0.,rec) )
*
*     O III 834A, collisions and dielectronic recombination
      call PutLine( t835 )
*
*     O III 834A, dielectronic recombination only
      call linadd(max(0.,rec),835,'rec ','i')
*
*     O IV 26 micron
      call PutLine( t26 )
*
*     O IV 1402, collisions
      call PutLine( t1402 )
*
*     inner shell photoionization, relaxation
      call linadd(p1401*1.42E-11 , 1401 , 'InSh' ,'i')
*
*     >>chng 97 may 2, better rec contribution
      rec = GetLineRec( 379 , 789 ) * t789(ipLnAovTOT)
      call PutExtra( max(0.,rec) )
*
*     O IV 789A
      call PutLine( t789 )
*
*     O IV 789A, dielectronic recombination only
      call linadd(max(0.,rec),789,'rec ','i')
*
*     >>chng 97 may 2, better rec contribution
      rec = GetLineRec( 467 , 630 )
      call PutExtra( max(0.,rec) )
*
*     O V 630, collisional excitation and dielectonic recombination
      call PutLine( t630 )
*
*     O V 630A, dielectronic recombination only
      call linadd(max(0.,rec),630,'rec ','i')
*
*     O V 1218], total intensity of both lines
      call linadd( em1218+t1214(ipLnInten), 1218,'TOTL','i')
      call PutLine( t1214 )
*
*     the slow transition by itself
      call linadd( em1218 , 1211,'O  5','i')
*
*     BS O V 5112, recombination
      call linadd(1.4E-21/te70*eden*xIonFracs(8,6)*t1214(ipLnAovTOT),
     1 5112 , 'O  5','i')
*
*     O VI 1035, total of pumping and collisional excitation
      call linadd( t1032(ipLnInten)+t1037(ipLnInten),1035,'TOTL','i')
      sum = t1032(ipLnInten)*t1032(ipLnInwd) +
     1 t1037(ipLnInten)*t1037(ipLnInwd)
*
*     inward part of OVI line
      call linadd( sum,1035,'Inwd','i')
      call PutLine( t1032 )
      call PutLine( t1037 )
*
*     O VI 150, li seq 2s 3p
      call PutLine( t150 )
      nelem = 8
*     these lines added to outlin in metdif - following must be false
      ola = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.05E-9
*
*     recombination from fully stripped ion
      call PntForLine( 19.0 , 'O 8r' , ipnt )
      call lindst( ola         , 19 , 'O 8r',ipnt,'i',.false.)
*     call linadd( ola*1.05E-9 , 19 , 'O 8r','i')
*
*     neon
*     Neon II 12.8 micron
      call PutLine( tNe13 )
*
*     Ne III fine structure line
      call PutLine( tNe16 )
*
*     Ne III fine structure line
      call PutLine( tNe36 )
*
*     Ne III  3869, of 3968+3869 doublet
      call PntForLine( 3869. , 'Ne 3' , ipnt )
      call lindst(c3869/(1.+1./3.318) , 3869 , 'Ne 3',ipnt,'c',.true.)
*     call linadd(c3869/(1.+1./3.318) , 3869 , 'Ne 3','c')
*
*     Ne III  3968, of 3968+3869 doublet
      call PntForLine( 3968. , 'Ne 3' , ipnt )
      call lindst(c3869/(1.+3.318) , 3968 , 'Ne 3',ipnt,'c',.true.)
*     call linadd(c3869/(1.+3.318) , 3968 , 'Ne 3','c')
*
*     NeIII auroral line
      call PntForLine(     3343., 'Ne 3' , ipnt )
      call lindst( c3343 , 3343 , 'Ne 3',ipnt,'c',.true.)
*     call linadd( c3343 , 3343 , 'Ne 3','c')
*
*     NeIII auroral line
      call PntForLine(         1815., 'Ne 3' , ipnt )
      call lindst( c3343*1.38, 1815 , 'Ne 3',ipnt,'c',.true.)
*     call linadd( c3343*1.38, 1815 , 'Ne 3','c')
*
*     Ne IV 2424, collisional excitation
      call PntForLine(     2424., 'Ne 4' , ipnt )
      call lindst( c2424 , 2424 , 'Ne 4',ipnt,'c',.true.)
*     call linadd( c2424 , 2424 , 'Ne 4','c')
*
*     Ne IV N=3 lines, three level atom approx
      call PntForLine(    4720., 'Ne 4' , ipnt )
      call lindst(c4720 , 4720 , 'Ne 4',ipnt,'c',.true.)
*     call linadd(c4720 , 4720 , 'Ne 4','c')
*
*     Ne IV N=3 lines, three level atom approx
      call PntForLine(        1602., 'Ne 4' , ipnt )
      call lindst(c4720*4.34, 1602 , 'Ne 4',ipnt,'c',.true.)
*     call linadd(c4720*4.34, 1602 , 'Ne 4','c')
*
*     Ne V 3426 of 3426, 3346 doublet
      call PntForLine(                  3426., 'Ne 5' , ipnt )
      call lindst(c3426/(1.+1./2.738) , 3426 , 'Ne 5',ipnt,'c',.true.)
*     call linadd(c3426/(1.+1./2.738) , 3426 , 'Ne 5','c')
*
*     Ne V 3346 of 3426, 3346 doublet
      call PntForLine(               3346., 'Ne 5' , ipnt )
      call lindst(c3426/(1.+2.738) , 3346 , 'Ne 5',ipnt,'c',.true.)
*     call linadd(c3426/(1.+2.738) , 3346 , 'Ne 5','c')
*
*     auroral line
      call PntForLine(     2976., 'Ne 5' , ipnt )
      call lindst( c2975 , 2976 , 'Ne 5',ipnt,'c',.true.)
*     call linadd( c2975 , 2976 , 'Ne 5','c')
*
*     collisionally excited
      call PntForLine(     1575., 'Ne 5' , ipnt )
      call lindst( c1565 , 1575 , 'Ne 5',ipnt,'c',.true.)
*     call linadd( c1565 , 1575 , 'Ne 5','c')
*
*     Ne V 24.2, 14.3 micron
      call PutLine( tNe24 )
*
*     Ne V 24.2, 14.3 micron
      call PutLine( tNe14 )
*
*     both components of 5S-3P 1146.1, 1137.0 doublet
      call PntForLine(     1141., 'Ne 5' , ipnt )
      call lindst( c1134 , 1141 , 'Ne 5',ipnt,'c',.true.)
*     call linadd( c1134 , 1141 , 'Ne 5','c')
*
*     [Ne VI] 7.6 microns
      call PutLine( xNe0676 )
*
*     Ne VII 895, collisionally excited, both lines
      call linadd( em895+t895(ipLnInten) , 895 , 'TOTL','i')
*
*     Ne VII 895, only fast transition
      call PutLine( t895 )
*
*     Ne VII 890, single line
      call linadd( em895 , 890 , 'Ne 7','i')
*
*     Ne VIII 774, collisionally excited
      call linadd( t770(ipLnInten)+t780(ipLnInten),774,'TOTL','i')
*
*     inward part of NeVIII 774 line
      sum = t770(ipLnInten)*t770(ipLnInwd) +
     1 t780(ipLnInten)*t780(ipLnInwd)
      call linadd( sum,774,'Inwd','i')
*
*     the NeVIII 770 780 doublet
      call PutLine( t770 )
      call PutLine( t780 )
*
*     Ne VIII 88 2s 3p, collisionally excited
      call PutLine( t88 )
*
*     Ne Ly-alpha recombination from fully stripped ion
      nelem = 10
*     these lines added to outlin in metdif - following must be false
      xnela = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.65E-9
      call PntForLine(     12., 'NeLr' , ipnt )
      call lindst( xnela , 12 , 'NeLr',ipnt,'i',.false.)
*     call linadd( xnela , 12 , 'NeLr','i')
*
      if( lgTrace ) write(qq,'(''   LineSet2 returns'')')
*
      end
******************************************************************************
      subroutine LineSet3
      implicit none
*place lines of elements sodium through argon into lines storage stack
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real raten3
      common/raten3/ raten3
      real DiffusHeavy , xLyaHeavy
*DiffusHeavy is total rec rate to grnd for nelem,ion element
*xLyaHeavy is Lya for nelem,ion
      common/DiffHeav/ DiffusHeavy(limelm,limelm),
     1 xLyaHeavy(limelm,limelm)
      real c2569 , c1357 , c2972,c1365,c2067,c4017
      common/coolna/ c2569 , c1357 , c2972,c1365,c2067,c4017
      real  c1806
      common/coolmg/ c1806
      real c1170, c2428, c2125
      common/coolal/ c1170, c2428, c2125
      real c2148, c1446, c949, c1815, c1985, c691, c606, c583
      common/coolsi/ c2148, c1446, c949, c1815, c1985,c691, c606, c583
      real c6731, c10330, c6312, c9532,
     2 c1715, c1213, c1826, c488, c520
*cooling lines of sulphur
      common/cools/ c6731, c10330,c6312, c9532,
     2 c1715, c1213, c1826, c488, c520
      real c8579, c6164, c3679 , c5525, c3350,
     1 c8494, Cl5539, Cl5519, Cl3354, Cl3344, Cl8504, Cl8436,
     2 Cl8552, Cl8483, c8047, c3119, c5324
      common/coolcl/ c8579, c6164, c3679 , c5525, c3350,
     1 c8494, Cl5539, Cl5519, Cl3354, Cl3344, Cl8504, Cl8436,
     2 Cl8552, Cl8483, c8047, c3119, c5324
*all argon coolants not carried in line transfer arrays
      real c7136, c7007, fs4413, c409, c5192 , c3109,
     1 Ar4740, Ar4711, Ar2868, Ar2854, Ar7263, Ar7171, Ar7331,Ar7237
      common/coolar/ c7136, c7007,fs4413,c409, c5192 , c3109,
     1 Ar4740, Ar4711, Ar2868, Ar2854, Ar7263, Ar7171, Ar7331,Ar7237
      real cyntrn,hmfb,c584,heavfb,bhe,herec,eebrm,h2line,h2dis,
     1 heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      common/coolng/cyntrn,hmfb,c584,heavfb, bhe,herec,eebrm,h2line,
     1 h2dis,heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      real p1909 , p2326 , p1895 , p1666 , p1401
      common/pmp2s/ p1909 , p2326 , p1895 , p1666 , p1401
      real supprs
*     suppresssion factors for dielectronic recombination
*     1 is burgess and 2 is storey
      common/supprs/ supprs(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real popoi
      common/popoi/ popoi(6)
      real s3727 , s7325
      common/s3727/ s3727 , s7325
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real S6733,S6718,S4070,S4078,S10323,S10289,S10373,S10339
      common/sii/ S6733,S6718,S4070,S4078,S10323,S10289,S10373,S10339
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nelem , ipnt
      real alla,sla,clla,phla,drec,sila,sexp,xnala,arla,rec, fac,xmgla,
     1 t4 ,sum
*
      if( lgTrace ) write(qq,'(''   LineSet3 called'')')
*
      t4 = te / 1e4
*
*     sodium
*     sum of Na D lines
      call PutLine( t5895 )
*
*     [NaIII] 7.319 micron
      call PutLine( fsNa373 )
*
*     [NaIV] 9.048 micron
      call PutLine( fsNa490 )
*
*     [NaIV] 21.29 micron
      call PutLine( fsNa421 )
*
*     [NaV] 1365, sum of 1365.1+1365.8; cs only guess
      call PntForLine(     1365., 'Na 5' , ipnt )
      call lindst( c1365 , 1365 , 'Na 5',ipnt,'c',.true.)
*     call linadd( c1365 , 1365 , 'Na 5','c')
*
*     [NaV] 2067, sum of 2066.9+2068.4; cs only guess
      call PntForLine(     2067., 'Na 5' , ipnt )
      call lindst( c2067 , 2067 , 'Na 5',ipnt,'c',.true.)
*     call linadd( c2067 , 2067 , 'Na 5','c')
*
*     [NaV] 4017, sum of 4010.9+4016.7+4022.7; cs only guess
      call PntForLine(     4017., 'Na 5' , ipnt )
      call lindst( c4017 , 4017 , 'Na 5',ipnt,'c',.true.)
*     call linadd( c4017 , 4017 , 'Na 5','c')
*
*     [Na VI] 2568.9
      call PntForLine(     2569., 'Na 6' , ipnt )
      call lindst( c2569 , 2569 , 'Na 6',ipnt,'c',.true.)
*     call linadd( c2569 , 2569 , 'Na 6','c')
*
*     [Na VI] 1356.6
      call PntForLine(     1357., 'Na 6' , ipnt )
      call lindst( c1357 , 1357 , 'Na 6',ipnt,'c',.true.)
*     call linadd( c1357 , 1357 , 'Na 6','c')
*
*     [Na VI] 2971.9
      call PntForLine(                  2972., 'Na 6' , ipnt )
      call lindst( c2972/(1.+1./3.02) , 2972 , 'Na 6',ipnt,'c',.true.)
*     call linadd( c2972/(1.+1./3.02) , 2972 , 'Na 6','c')
*
*     [Na VI] 2872.7
      call PntForLine(               2872., 'Na 6' , ipnt )
      call lindst( c2972/(1.+3.02) , 2872 , 'Na 6',ipnt,'c',.true.)
*     call linadd( c2972/(1.+3.02) , 2872 , 'Na 6','c')
*
*     [NaVI] 14.32 micron
      call PutLine( xNa6143 )
*
*     [NaVI] 8.62 micron
      call PutLine( xNa6862 )
*
*     [NaVII] 4.675 micron
      call PutLine( xNa0746 )
*
*     Na Ly-alpha recombination from fully stripped ion, 10A
      nelem = 11
*     these lines added to outlin in metdif - following must be false
      xnala = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.98e-9
      call PntForLine( 10. , 'NaLr' , ipnt )
      call lindst( xnala, 10 , 'NaLr',ipnt,'i',.false.)
*     call linadd( xnala, 10 , 'NaLr','i')
*
*     Magnesium I 4571, O I data for coll strength and trans prob
      call PutLine( t4561 )
*
*     Mg I 2853
      call PutLine( MgI2853 )
*
*     Mg I 2026
      call PutLine( MgI2026 )
*
*     Mg II 2798
      call linadd( t2796(ipLnInten)+t2804(ipLnInten),2798,'TOTL','i')
      sum = t2796(ipLnInten)*t2796(ipLnInwd) +
     1 t2804(ipLnInten)*t2804(ipLnInwd)
*
*     inward part of Mg II 2798
      call linadd( sum,2798,'Inwd','i')
      call PutLine( t2796 )
      call PutLine( t2804 )
*
*     Mg IV 4.5 micron
      call PutLine( tMg4 )
*
*     Mg V  13.5 micron emission
      call PutLine( tMg14 )
*
*     Mg V 5.6 micron emission
      call PutLine( tMg6 )
*
*     [Mg 5] 2571, 2893
      call PutLine( xMg52855 )
*
*     [Mg 5] 2417.5A, 3-2 in model atom
      call PutLine( xMg52417 )
*
*     [Mg 5] 1324.58A, 3-1 in model atom
      call PutLine( xMg51325 )
*
*     MG VI
      call PntForLine(    1806., 'Mg 6' , ipnt )
      call lindst( c1806, 1806 , 'Mg 6',ipnt,'c',.true.)
*     call linadd( c1806, 1806 , 'Mg 6','c')
*
*     [Mg 7] 2510, 2629, 2-1 transitions, together
      call PutLine( xMg72569 )
*
*     [Mg 7] 3-2 transition, 2261.5
      call PutLine( xMg72261 )
*
*     [Mg 7] 3-1 transition, 1189.82A
      call PutLine( xMg71190 )
*
*     Mg 7 IR line 5.50 microns
      call PutLine( fsMg755 )
*
*     Mg 7 IR line 9.03 microns
      call PutLine( fsMg790 )
*
*     [Mg 8] 3.03 micron
      call PutLine( xMg08303 )
*
*     Mg 9 704.5
      call PutLine( t705 )
*
*     Mg 10 614.9 bothof doublet, li seq 2s 2p
      call linadd( tMg610(ipLnInten)+tMg625(ipLnInten),615,'TOTL','i')
      call PutLine( tMg610 )
      call PutLine( tMg625 )
*
*     Mg 10 58 li seq 2s 3p
      call PutLine( t58 )
*
*     recombination from fully stripped ion
      nelem = 12
*     these lines added to outlin in metdif - following must be false
      xmgla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*2.80E-9
      call PntForLine(    7., 'MgLr' , ipnt )
      call lindst( xmgla, 7 , 'MgLr',ipnt,'i',.true.)
*     call linadd( xmgla, 7 , 'MgLr','i')
*
*     Aluminum
*     Al I 3957
      call PutLine( AlI3957 )
*
*     Al I 3090
      call PutLine( AlI3090 )
*
*     Al II 1671
*     taken out of level one for parallel speed up
*     call PutLine( Al1671 )
*
*     total emission in Al II] 2669.7, 2660 doublet
      call linadd( em2669+t2670(ipLnInten) , 2665 , 'totl','i')
      call PutLine( t2670 )
*
*     emission in Al II] 2669 alone
      call linadd( em2669 , 2660 , 'Al 2','i')
*
*     Al III
      call linadd( t1855(ipLnInten)+t1863(ipLnInten),1860,'TOTL','i')
      sum = t1855(ipLnInten)*t1855(ipLnInwd) +
     1 t1863(ipLnInten)*t1863(ipLnInwd)
*
*     inward part of AlIII line
      call linadd( sum,1860,'Inwd','i')
      call PutLine( t1855 )
      call PutLine( t1863 )
*
*     [Al V] 2.905 mic
      call PutLine( Al529 )
*
*     [Al VI] 3.66 mic
      call PutLine( Al6366 )
*
*     [Al VI] 9.12 mic
      call PutLine( Al6912 )
*
*     [Al VI] 2428.4
      call PntForLine(                  2428., 'Al 6' , ipnt )
      call lindst( c2428/(1.+1./3.73) , 2428 , 'Al 6',ipnt,'c',.true.)
*     call linadd( c2428/(1.+1./3.73) , 2428 , 'Al 6','c')
*
*     [Al VI] 2601.0
      call PntForLine(               2601., 'Al 6' , ipnt )
      call lindst( c2428/(1.+3.73) , 2601 , 'Al 6',ipnt,'c',.true.)
*     call linadd( c2428/(1.+3.73) , 2601 , 'Al 6','c')
*
*     [Al VI] 1169.86
      call PntForLine(     1170., 'Al 6' , ipnt )
      call lindst( c1170 , 1170 , 'Al 6',ipnt,'c',.true.)
*     call linadd( c1170 , 1170 , 'Al 6','c')
*
*     [Al VI] 2124.95
      call PntForLine(     2125., 'Al 6' , ipnt )
      call lindst( c2125 , 2125 , 'Al 6',ipnt,'c',.true.)
*     call linadd( c2125 , 2125 , 'Al 6','c')
*
*     [Al VIII] 5.75 mic
      call PutLine( Al8575 )
*
*     [Al VIII] 3.70 mic
      call PutLine( Al8370 )
*
*     [Al IX] 2.04 micron, no collision strength, A NIST
      call PutLine( Al09204 )
*
*     Al X
      call PutLine( t639 )
*
*     Al 11, Li seq 2s2p
      call linadd( tAl550(ipLnInten)+tAl568(ipLnInten),556,'TOTL','i')
      call PutLine( tAl550 )
      call PutLine( tAl568 )
*
*     Al 11, Li seq 2s3p
      call PutLine( tAl48 )
*
*     recombination from fully stripped ion
      nelem = 13
*     these lines added to outlin in metdif - following must be false
      alla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*3.25E-9
      call PntForLine(    6., 'AlLr' , ipnt )
      call lindst( alla , 6 , 'AlLr',ipnt,'i',.false.)
*     call linadd( alla , 6 , 'AlLr','i')
*
*     silicon
*     Si I 2518
      call PutLine( Sii2518 )
*
*     Si I 2215
      call PutLine( Sii2215 )
*
*     Silicon II 35 micron
      call PutLine( tSi35 )
*
*     SI II] 2336,
      call PutLine( t2335 )
*
*     SI II 1808, permitted resonance line, collisionally excited
      call PutLine( t1808 )
*
*     SI II 1527, permitted resonance line, collisionally excited
      call PutLine( t1527 )
*
*     SI II 1305, permitted resonance line, collisionally excited
      call PutLine( t1305 )
*
*     SI II 1260, permitted resonance line, collisionally excited
      call PutLine( t1260 )
*
*     SI II 1260, rough guess of dielec contribution
      drec = xIonFracs(14,3)*eden*7.6e-7 /te32*1.57E-11*supprs(3,2)
      fac = t1260(ipLnAovTOT)
      call PntForLine( 1260. , 'Si 2' , ipnt )
      call lindst( drec*fac , 1260 , 'diel',ipnt,'i',.true.)
*     call linadd( drec*fac , 1260 , 'diel','i')
*
*     dielectronic recombination SiII 1909
      call PntForLine(                1909., 'Si 2' , ipnt )
      call lindst( drec*1260./1909. , 1909 , 'diel',ipnt,'i',.true.)
*     call linadd( drec*1260./1909. , 1909 , 'diel','i')
      rec =
     1  1e-12*(0.1152/t4-0.3082+4.4734*t4+0.0207*t4*t4)/t4**1.5*
     2  sexp(0.2981/t4)
*     >>chng 96 july 8, added dielectronic recombination contribution to 789
      rec = rec*xIonFracs(14,4)*eden*t1207(ipLnAovTOT)*1.65e-11 *
     1 supprs(3,2)
      call PutExtra( max(0.,rec) )
*
*     SI III 1207, collisional excitation and dielectronic recombination
      call PutLine( t1207 )
*
*     Si III 1207, dielectronic recombination only
      call linadd(max(0.,rec),1207,'rec ','i')
*
*     Si III] 1892+1883, total intensity of both lines
      call linadd( em1895+t1895(ipLnInten) ,1888 , 'TOTL','i')
      call PutLine(t1895 )
*
*     Si III] 1883 by itself
      call PntForLine(      1883., 'Si 3' , ipnt )
      call lindst( em1895 , 1883 , 'Si 3',ipnt,'i',.true.)
*     call linadd( em1895 , 1883 , 'Si 3','i')
*
      fac = t1895(ipLnAovTOT)
*
*     photoproduction by inner shell removal
      call linadd( p1895*1.05e-11*fac , 1895 , 'PHOT','i')
*
*     Si IV 1397, collisionally excited
      call linadd( t1403(ipLnInten)+t1394(ipLnInten),1397,'TOTL','i')
*
      sum = t1403(ipLnInten)*t1403(ipLnInwd) +
     1 t1394(ipLnInten)*t1394(ipLnInwd)
*     inward part of SiIV 1397
      call linadd( sum,1397,'Inwd','i')
      call PutLine( t1403 )
      call PutLine( t1394 )
*
*     SI VI 1.9641 micron
      call PutLine( Si619 )
*
*     SI VII, 2148, O III like, collisionally excited
      call PntForLine(     2148., 'Si 7' , ipnt )
      call lindst( c2148 , 2148 , 'Si 7',ipnt,'c',.true.)
      call linadd( c2148 , 2148 , 'Si 7','c')
*
*     Si VII 2.48, 6.49 micron, collisionally excited
      call PutLine( tSi25 )
*
*     Si VII 2.48, 6.49 micron, collisionally excited
      call PutLine( tSi65 )
*
*     SI VIII 1446, OIII like, collisionally excited
      call PntForLine(     1446., 'Si 8' , ipnt )
      call lindst( c1446 , 1446 , 'Si 8',ipnt,'c',.true.)
*     call linadd( c1446 , 1446 , 'Si 8','c')
*
*     SI IX 1985, 2150, collisionally excited
      call PntForLine(     1985., 'Si 9' , ipnt )
      call lindst( c1985 , 1985 , 'Si 9',ipnt,'c',.true.)
*     call linadd( c1985 , 1985 , 'Si 9','c')
*
*     collisionally excited
      call PntForLine(    949., 'Si 9' , ipnt )
      call lindst( c949 , 949 , 'Si 9',ipnt,'c',.true.)
*     call linadd( c949 , 949 , 'Si 9','c')
*
*     collisionally excited
      call PntForLine(     1815., 'Si 9' , ipnt )
      call lindst( c1815 , 1815 , 'Si 9',ipnt,'c',.true.)
*     call linadd( c1815 , 1815 , 'Si 9','c')
*
*     SI 9, 3.86, 2.84 3P fine structure lines
      call PutLine( tSi4 )
*
*     SI 9, 3.86, 2.84 3P fine structure lines
      call PutLine( tSi3 )
*
*     both components of 5S-3P doublet
      call PntForLine(    691., 'Si 9' , ipnt )
      call lindst( c691 , 691 , 'Si 9',ipnt,'c',.true.)
*     call linadd( c691 , 691 , 'Si 9','c')
*
*     SI 10 606A, actually group of 4 intercombination lines.
      call PntForLine(    606., 'Si10' , ipnt )
      call lindst( c606 , 606 , 'Si10',ipnt,'c',.true.)
*     call linadd( c606 , 606 , 'Si10','c')
*
*     [Si 10] 1.43 micron, collisionally excited
      call PutLine( Si10143 )
*
*     SI XI 582.9, collisionally excited
      call PntForLine(    583., 'Si11' , ipnt )
      call lindst( c583 , 583 , 'Si11',ipnt,'c',.true.)
*     call linadd( c583 , 583 , 'Si11','c')
*
      call linadd( tSi499(ipLnInten)+tSi521(ipLnInten),506,'TOTL','i')
*
*     SI XII 506 li seq 2s 2p
      call PutLine( tSi499 )
      call PutLine( tSi521 )
*
*     SI XII 40.9A, li seq 2s 3p
      call PutLine( tSi41 )
*
*     recombination from fully stripped ion
      nelem = 14
*     these lines added to outlin in metdif - following must be false
      sila = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*3.23E-9
      call PntForLine(    6., 'SiLr' , ipnt )
      call lindst( sila , 6 , 'SiLr',ipnt,'i',.false.)
*     call linadd( sila , 6 , 'SiLr','i')
*
*     phosphorus
*     [P II] 60.64 micron
      call PutLine( P0260 )
*
*     [P II] 32.87 micron
      call PutLine( P0233 )
*
*     [P III] 17.885 micron
      call PutLine( P0318 )
*
*     P VII 1.3745 micron
      call PutLine( P713 )
*
*     P VIII 4.85 mic
      call PutLine( P848 )
*
*     P VIII 1.735 microns
      call PutLine( P817 )
*
*     P X 2.708 mic
      call PutLine( P1027 )
*
*     P X 1.868 microns
      call PutLine( P1018 )
*
*     recombination from fully stripped ion
      nelem = 15
*     these lines added to outlin in metdif - following must be false
      phla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.05E-9
      call PntForLine(    19., 'P15r' , ipnt )
      call lindst( phla , 19 , 'P15r',ipnt,'i',.false.)
*     call linadd( phla , 19 , 'P15r','i')
*
*     sulphur
*     guestimate of Sulphur I triplet excited state recombination rate.
*     this is to check whether photoexcit of S II is ever important
      call linadd( 1.75e-22*eden*xIonFracs(16,2)/sqrte/te10/te03 ,
     1 1807 , 'S 1R','i')
*
*     S II 6731 + 6716 together
      call linadd( c6731 ,6720,'S  2','c')
*
*     S II 4070 +4078 together
      call linadd( S4070+S4078 , 4074 , 'S  2','c')
*
*     S II N=3 lines, all four lines together
      call PntForLine( 10330. , 'S  2' , ipnt )
      call lindst( c10330 , 10330 , 'S  2',ipnt,'c',.true.)
*
*     now output the real thing
*     individual line from five level atom
      call PntForLine(     6731., 'S II' , ipnt )
      call lindst( S6733 , 6731 , 'S II',ipnt,'i',.true.)
*     call linadd( S6733 , 6731 , 'S II','i')
*
*     individual line from five level atom
      call PntForLine(     6716., 'S II' , ipnt )
      call lindst( S6718 , 6716 , 'S II',ipnt,'i',.true.)
*     call linadd( S6718 , 6716 , 'S II','i')
*
*     individual line from five level atom
      call PntForLine(     4070., 'S II' , ipnt )
      call lindst( S4070 , 4070 , 'S II',ipnt,'i',.true.)
*     call linadd( S4070 , 4070 , 'S II','i')
*
*     individual line from five level atom
      call PntForLine(     4078., 'S II' , ipnt )
      call lindst( S4078 , 4078 , 'S II',ipnt,'i',.true.)
*     call linadd( S4078 , 4078 , 'S II','i')
*
*     individual line from five level atom
      call linadd(S10323,10323,'S II','i')
*
*     individual line from five level atom
      call linadd(S10289,10289,'S II','i')
*
*     individual line from five level atom
      call linadd(S10373,10373,'S II','i')
*
*     individual line from five level atom
      call linadd(S10339,10339,'S II','i')
*
*     resonance line near NV, collisionally excited
      call PutLine( t1256 )
*
*     S III fine structure 18.7
      call PutLine( tS19 )
*
*     S III fine structure 34
      call PutLine( tS34 )
*
*     S III] 1713.12, 1728.94
      call PutLine( tS1720 )
*
*     [S III] 9532 alone
      call PntForLine(                  9532., 'S  3' , ipnt )
      call lindst( c9532/(1.+1./2.48) , 9532 , 'S  3',ipnt,'c',.true.)
*
*     [S III] 9069 alone
      call PntForLine(               9069., 'S  3' , ipnt )
      call lindst( c9532/(1.+2.48) , 9069 , 'S  3',ipnt,'c',.true.)
*
*     [S III] 6312, transauroral temperature sensitive
      call PntForLine(     6312., 'S  3' , ipnt )
      call lindst( c6312 , 6312 , 'S  3',ipnt,'c',.true.)
*     call linadd( c6312 , 6312 , 'S  3','c')
*
*     [S III] 3722, same upper level as 6312
      call PntForLine(          3722., 'S  3' , ipnt )
      call lindst( c6312*0.59 , 3722 , 'S  3',ipnt,'c',.true.)
*     call linadd( c6312*0.59 , 3722 , 'S  3','c')
*
*     WL, other data, from Ho + Henry Ap.J. 1984
      call PutLine( t1194 )
*
*     S IV 10.5 micron, collisionally excited (label is 105)
      call PutLine( tS11 )
*
*     S IV 1406, collisionally excited
      call PutLine( t1406 )
*
*     S V 1198] both lines together
      call linadd( em1198+t1198(ipLnInten) , 1198 , 'TOTL','i')
*
*     S V 1198] the stronger transition
      call PutLine( t1198)
*
*     Be seq, weaker of the two transitions
      call linadd( em1198 , 1188 , 'S  5','i')
*
*     S V 786.5, collisionally excited
      call PutLine( t786 )
*
*     S VI 933+944, collisionally excited
*     total S VI 933+944
      call linadd( t944(ipLnInten)+t933(ipLnInten),933,'TOTL','i')
      call PutLine( t944 )
      call PutLine( t933 )
*
*     S VIII 9913
      call PutLine( fsS810 )
*
*     S IX 1.25 microns
      call PutLine( fsS912 )
*
*     S IX  3.78 microns
      call PutLine( fsS938 )
*
*     S XI 1.91 microns
      call PutLine( fsS1119 )
*
*     S XI 1.40 microns
      call PutLine( fsS1114 )
*
*     S IX 1715, 1987, collisionally excited
      call PntForLine(     1715., 'S  9' , ipnt )
      call lindst( c1715 , 1715 , 'S  9',ipnt,'c',.true.)
*     call linadd( c1715 , 1715 , 'S  9','c')
*
*     S XII 7611.2
      call PutLine( fsS1207 )
*
*     S X 1213, 1197, collisionally excited
      call PntForLine(    1213., 'S 10' , ipnt )
      call lindst( c1213, 1213 , 'S 10',ipnt,'c',.true.)
*     call linadd( c1213, 1213 , 'S 10','c')
*
*     S XI 1615, 1826, collisionally excited
      call PntForLine(     1826., 'S 11' , ipnt )
      call lindst( c1826 , 1826 , 'S 11',ipnt,'c',.true.)
*     call linadd( c1826 , 1826 , 'S 11','c')
*
*     group of four intercombination lines
      call PntForLine(    520., 'S 12' , ipnt )
      call lindst( c520 , 520 , 'S 12',ipnt,'c',.true.)
*     call linadd( c520 , 520 , 'S 12','c')
*
*     S XIII 488.4, 1909 like, collisionally excited
      call PntForLine(    488., 'S 13' , ipnt )
      call lindst( c488 , 488 , 'S 13',ipnt,'c',.true.)
*     call linadd( c488 , 488 , 'S 13','c')
*
*     S 14 506 li seq 2s2p
      call linadd( tSu418(ipLnInten)+tSu446(ipLnInten),427,'TOTL','i')
      call PutLine( tSu418 )
      call PutLine( tSu446 )
*
*     S 14 30 li seq 2s3p
      call PutLine( tSu30 )
*
*     S 16 4.7A Ly a recombination from fully stripped ion
      nelem = 16
*     these lines added to outlin in metdif - following must be false
      sla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*4.21E-9
      call PntForLine(   5., 'S LR' , ipnt )
      call lindst( sla , 5 , 'S LR',ipnt,'i',.false.)
      call linadd( sla , 5 , 'S LR','i')
*
*     chlorine lines
*     [Cl II] 33.281 micron
      call PutLine( fsCl233 )
*
*     [Cl II] 14.3678 micron
      call PutLine( fsCl214 )
*
*     Chlorine II 8581, 9127 doublet
      call PntForLine(           8579., 'Cl 2' , ipnt )
      call lindst( c8579*0.791 , 8579 , 'Cl 2',ipnt,'c',.true.)
*     call linadd( c8579*0.791 , 8579 , 'Cl 2','c')
*
*     Chlorine II 8581, 9127 doublet
      call PntForLine(           9127., 'Cl 2' , ipnt )
      call lindst( c8579*0.209 , 9127 , 'Cl 2',ipnt,'c',.true.)
      call linadd( c8579*0.209 , 9127 , 'Cl 2','c')
*
*     Chlorine II 6164 auroral line
      call PntForLine(     6164., 'Cl 2' , ipnt )
      call lindst( c6164 , 6164 , 'Cl 2',ipnt,'c',.true.)
*     call linadd( c6164 , 6164 , 'Cl 2','c')
*
*     Chlorine II 3679 auroral line
      call PntForLine(     3676., 'Cl 2' , ipnt )
      call lindst( c3679 , 3676 , 'Cl 2',ipnt,'c',.true.)
*     call linadd( c3679 , 3679 , 'Cl 2','c')
*
*     Cl III 5519, 5539 doublet, both together
      call linadd( c5525 , 5525 , 'TOTL','c')
*
*     Cl III 3354, 3344 doublet, both together
      call linadd( c3350 , 3350 , 'TOTL','c')
*
*     Cl III 8504, 8436, 8552, 8483 multiplet, all together
      call linadd( c8494 , 8494 , 'TOTL','c')
*
*     Cl III 5538
      call PntForLine(      5538., 'Cl 3' , ipnt )
      call lindst( Cl5539 , 5538 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl5539 , 5538 , 'Cl 3','i')
*
*     Cl III 5518
      call PntForLine(      5518., 'Cl 3' , ipnt )
      call lindst( Cl5519 , 5518 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl5519 , 5518 , 'Cl 3','i')
*
*     Cl III 3354
      call PntForLine(      3354., 'Cl 3' , ipnt )
      call lindst( Cl3354 , 3354 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl3354 , 3354 , 'Cl 3','i')
*
*     Cl III 3344
      call PntForLine(      3344., 'Cl 3' , ipnt )
      call lindst( Cl3344 , 3344 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl3344 , 3344 , 'Cl 3','i')
*
*     Cl III 8504
      call PntForLine(      8504., 'Cl 3' , ipnt )
      call lindst( Cl8504 , 8504 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl8504 , 8504 , 'Cl 3','i')
*
*     Cl III 8436
      call PntForLine(      8436., 'Cl 3' , ipnt )
      call lindst( Cl8436 , 8436 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl8436 , 8436 , 'Cl 3','i')
*
*     Cl III 8552
      call PntForLine(      8552., 'Cl 3' , ipnt )
      call lindst( Cl8552 , 8552 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl8552 , 8552 , 'Cl 3','i')
*
*     Cl III 8483
      call PntForLine(      8483., 'Cl 3' , ipnt )
      call lindst( Cl8483 , 8483 , 'Cl 3',ipnt,'i',.true.)
*     call linadd( Cl8483 , 8483 , 'Cl 3','i')
*
*     [Cl IV] fine structure line 20.354 microns
      call PutLine(Cl04203)
*
*     [Cl IV] fine structure line 11.741 microns
      call PutLine(Cl04117)
*
*     ClIV 8047
      call PntForLine(           8047., 'Cl 4' , ipnt )
      call lindst( c8047*0.667 , 8047 , 'Cl 4',ipnt,'c',.true.)
*     call linadd( c8047*0.667 , 8047 , 'Cl 4','c')
*
*     ClIV 7532
      call PntForLine(           7532., 'Cl 4' , ipnt )
      call lindst( c8047*0.333 , 7532 , 'Cl 4',ipnt,'c',.true.)
*     call linadd( c8047*0.333 , 7532 , 'Cl 4','c')
*
*     ClIV 3119
      call PntForLine(     3119., 'Cl 4' , ipnt )
      call lindst( c3119 , 3119 , 'Cl 4',ipnt,'c',.true.)
*     call linadd( c3119 , 3119 , 'Cl 4','c')
*
*     ClIV 5324
      call PntForLine(     5324., 'Cl 4' , ipnt )
      call lindst( c5324 , 5324 , 'Cl 4',ipnt,'c',.true.)
      call linadd( c5324 , 5324 , 'Cl 4','c')
*
*     Cl IX 7334A
      call PutLine( Cl973 )
*
*     Cl X 3.05 microns
      call PutLine( Cl1030 )
*
*     Cl X 9223A
      call PutLine( Cl1092 )
*
      nelem = 17
*     these lines added to outlin in metdif - following must be false
      clla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*5.33E-9
*     Cl 17 ly a recombination 3.7A from fully stripped ion
      call PntForLine(    4., 'ClRr' , ipnt )
      call lindst( clla , 4 , 'ClRr',ipnt,'i',.false.)
*     call linadd( clla , 4 , 'ClRr','i')
*
*     Argon II 7 micron
      call PutLine( tAr7 )
*
*     Argon III 7135
      call PntForLine(                   7135., 'Ar 3' , ipnt )
      call lindst( c7136/(1.+1./4.144) , 7135 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c7136/(1.+1./4.144) , 7135 , 'Ar 3','c')
*
*     Argon III 7751
      call PntForLine(                7751., 'Ar 3' , ipnt )
      call lindst( c7136/(1.+4.144) , 7751 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c7136/(1.+4.144) , 7751 , 'Ar 3','c')
*
*     Argon III 5192
      call PntForLine(     5192., 'Ar 3' , ipnt )
      call lindst( c5192 , 5192 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c5192 , 5192 , 'Ar 3','c')
*
*     Argon III 3109
      call PntForLine(            3109., 'Ar 3' , ipnt )
      call lindst( c3109*0.9894 , 3109 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c3109*0.9894 , 3109 , 'Ar 3','c')
*
*     Argon III 3005
      call PntForLine(                 3005., 'Ar 3' , ipnt )
      call lindst( c3109*(1.-0.9894) , 3005 , 'Ar 3',ipnt,'c',.true.)
*     call linadd( c3109*(1.-0.9894) , 3005 , 'Ar 3','c')
*
*     Argon III 21.8, 9 micron lines
      call PutLine( tAr22 )
*
*     Argon III 21.8, 9 micron lines
      call PutLine( tAr9 )
*
*     Argon IV 4711 + 4740 together, 4740=90%
      call linadd( Ar4740+Ar4711, 4725 , 'TOTL','i')
*
*     [AvIV] 2868, 2854 together
      call linadd( Ar2868+Ar2854 , 2860 , 'TOTL','i')
*
*     [AvIV] auroral lines, 7237, 7331, 7171, 7263
      call linadd( Ar7237+Ar7331+Ar7171+Ar7263,7250,'TOTL','i')
*
*     [Ar IV] 4740
      call PntForLine(      4740., 'Ar 4' , ipnt )
      call lindst( Ar4740 , 4740 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar4740 , 4740 , 'Ar 4','c')
*
*     [Ar IV] 4711
      call PntForLine(      4711., 'Ar 4' , ipnt )
      call lindst( Ar4711 , 4711 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar4711 , 4711 , 'Ar 4','c')
*
*     [Ar IV] 2868
      call PntForLine(      2868., 'Ar 4' , ipnt )
      call lindst( Ar2868 , 2868 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar2868 , 2868 , 'Ar 4','c')
*
*     [Ar IV] 2854
      call PntForLine(      2854., 'Ar 4' , ipnt )
      call lindst( Ar2854 , 2854 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar2854 , 2854 , 'Ar 4','c')
*
*     [Ar IV] 7263
      call PntForLine(      7263., 'Ar 4' , ipnt )
      call lindst( Ar7263 , 7263 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar7263 , 7263 , 'Ar 4','c')
*
*     [Ar IV] 7171
      call PntForLine(      7171., 'Ar 4' , ipnt )
      call lindst( Ar7171 , 7171 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar7171 , 7171 , 'Ar 4','c')
*
*     [Ar IV] 7331
      call PntForLine(      7331., 'Ar 4' , ipnt )
      call lindst( Ar7331 , 7331 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar7331 , 7331 , 'Ar 4','c')
*
*     [Ar IV] 7237
      call PntForLine(      7237., 'Ar 4' , ipnt )
      call lindst( Ar7237 , 7237 , 'Ar 4',ipnt,'c',.true.)
*     call linadd( Ar7237 , 7237 , 'Ar 4','c')
*
*     Argon V, 3P lines, 7005, collisionally excited
      call PntForLine(                  7005., 'Ar 5' , ipnt )
      call lindst( c7007/(1.+1./2.143) ,7005 , 'Ar 5',ipnt,'c',.true.)
*     call linadd( c7007/(1.+1./2.143), 7005 , 'Ar 5','c')
*
*     Argon V, 3P lines, 6435, collisionally excited
      call PntForLine(                6435., 'Ar 5' , ipnt )
      call lindst( c7007/(1.+2.143) , 6435 , 'Ar 5',ipnt,'c',.true.)
      call linadd( c7007/(1.+2.143) , 6435 , 'Ar 5','c')
*
*     Argon V fine structure lines, 13.09, 7.903 micron line
      call PutLine( tAr13 )
*
*     Argon V fine structure lines, 13.09, 7.903 micron line
      call PutLine( tAr8 )
*
*     [Ar VI] 4.53 micron
      call PutLine( Ar06453 )
*
*     Ar X 5533.4A
      call PutLine( Ar1055 )
*
*     Ar XI 2.60 microns
      call PutLine( Ar1126 )
*
*     Ar XI 6917A
      call PutLine( Ar1178 )
*
*     Ar XIV 4413, predicted lambda, not observed(??)
      call PntForLine(      4413., 'Ar14' , ipnt )
      call lindst( fs4413 , 4413 , 'Ar14',ipnt,'c',.true.)
*     call linadd( fs4413 , 4413 , 'Ar14','c')
*
*     collisionally excited
      call PntForLine(    409., 'Ar15' , ipnt )
      call lindst( c409 , 409 , 'Ar15',ipnt,'c',.true.)
*     call linadd( c409 , 409 , 'Ar15','c')
*
*     collisionally excited Ar16 354, Li seq 2s-2p
      call PutLine( t354 )
*
*     collisionally excited Ar16 389, Li seq 2s-2p
      call PutLine( t389 )
*
*     collisionally excited Ar16 365, Li seq 2s-3p
      call PutLine( t25 )
*
*     Ar 18 ly a recombination 3.7A from fully stripped ion
      nelem = 18
*     these lines added to outlin in metdif - following must be false
      arla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*5.33e-9
      call PntForLine( 3.75 , 'ArRr' , ipnt )
      call lindst( arla , 4 , 'ArRr',ipnt,'i',.false.)
*     call linadd( arla , 4 , 'ArRr','i')
*
      if( lgTrace ) write(qq,'(''   LineSet3 returns'')')
*
      end
******************************************************************************
      subroutine LineSet4
      implicit none
*place lines of elements sodium through argon into lines storage stack
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer LimPredFe2
*limit to number of bands picked up from Katya's FeII atom
*wavelengths set in block data scalar, in data statements for
*iPredFe2
      parameter (LimPredFe2=12)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real raten3
      common/raten3/ raten3
      real dstCala , dCakh , dCaf12 , Ca3d , Ca4p
*parameters dealing with dest of CaII by Lya
      common/dcala/ dstCala , dCakh , dCaf12 , Ca3d , Ca4p
      real Cak,Cah,Cax,Cay,Caz,Caf1,Caf2
      common/caline/ Cak,Cah,Cax,Cay,Caz,Caf1,Caf2
      integer ipfe10
      real pfe10,pfe11a,pfe11b,pfe14
      common/pumpfe/ ipfe10,pfe10,pfe11a,pfe11b,pfe14
      real DiffusHeavy , xLyaHeavy
*DiffusHeavy is total rec rate to grnd for nelem,ion element
*xLyaHeavy is Lya for nelem,ion
      common/DiffHeav/ DiffusHeavy(limelm,limelm),
     1 xLyaHeavy(limelm,limelm)
      real Cair, c7306, Cakh, Ca3688 , Ca2112 , Ca5620 , Ca4941 ,
     1 c3997, c2414, Ca6087, c5311,cCa302,cCa345,cCa19
      common/coolca/ Cair, c7306, Cakh, Ca3688 , Ca2112 , Ca5620 ,
     1 Ca4941 , c3997, c2414, Ca6087, c5311,cCa302,cCa345,cCa19
      real V38830 , V47741 , V49496 , V44p2m,V38507
      common/coolvan/ V38830 , V47741 , V49496 , V44p2m,V38507
*     coolants for iron
      real rmt48, for7, Fecool, Feir, c5270, c3892, c5177, c6087,
     1 c1467, c2649, c2568, c1242, c2170, c5303, c133, Fe5722,
     2 c7082, c1118, c1328, c592, fs846, c263, c242 ,
     3 Fe231 , Fe232 , Fe221, cFe16, cFe26, cFe34, cFe35, cFe46, cFe56
      common/coolfe/ rmt48, for7, Fecool, Feir, c5270, c3892, c5177,
     1 c6087, c1467, c2649, c2568, c1242, c2170, c5303, c133, Fe5722,
     2 c7082, c1118, c1328, c592, fs846, c263, c242 ,
     3 Fe231 , Fe232 , Fe221, cFe16, cFe26, cFe34, cFe35, cFe46, cFe56
      common/coolsc/ Sc22p08m , Sc24p1m , Sc24p2m ,Sc33936, Sc42100 ,
     1 Sc45058 , Sc43595
      real Sc22p08m , Sc24p1m , Sc24p2m ,Sc33936, Sc42100 ,
     1 Sc45058 , Sc43595
      real Ti3l31 , Ti3l32 , Ti3l21
      common/coolti/ Ti3l31 , Ti3l32 , Ti3l21
      real Cr4l31 , Cr4l21 , Cr5l31 , Cr5l21 , Cr5l32,Cr3l21
      common/coolcr/ Cr4l31 , Cr4l21 , Cr5l31 , Cr5l21 , Cr5l32,Cr3l21
*     include "fcakh.com"
      real otsfe2 , emuv3
      common/resion/ otsfe2 , emuv3
*     fekhot, fekcld, number of photons in hot and cold iron, per unit vol
*     ipkhot, ipkcld are pointers to energies
      real fekhot , fekcld
      integer ipkhot , ipkcld
      common/fekems/ fekhot , fekcld , ipkhot , ipkcld
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real cyntrn,hmfb,c584,heavfb,bhe,herec,eebrm,h2line,h2dis,
     1 heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      common/coolng/cyntrn,hmfb,c584,heavfb, bhe,herec,eebrm,h2line,
     1 h2dis,heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      real supprs
*     suppresssion factors for dielectronic recombination
*     1 is burgess and 2 is storey
      common/supprs/ supprs(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real Fe4CoolTot, fe42836,fe42829,fe42567 , fe40401 ,
     1 fe41207, fe41206, fe41106, fe41007, fe41008, fe40906
*total cooling due to 12 level model FeIV atom, and three uv lines
*4P5/2 - 6S5/2, 4P3/2 - 6S5/2, and 4D+ - 6S
*Fe4CoolTot is total cooling due to entire atom, also three selectec lines
      common/fe4cool/ Fe4CoolTot, fe42836,fe42829,fe42567 , fe40401,
     1 fe41207, fe41206, fe41106, fe41007, fe41008, fe40906
      real Fe2L16Tot,fe21308,fe21207,fe21106,fe21006,
     1 fe21204,fe21103,fe21104,fe21001,fe21002 ,
     1 fe20201 , fe20302 , fe20706 , fe20807 , fe20908 ,
     1 fe21007 , fe21107 , fe21108 , fe21110 , fe21507 ,
     1 fe21208 , fe21209 , fe21211 , fe21406 ,fe21508 , fe21609
*total cooling due to 16 level model FeII atom
*fe2cool is total cooling due to 16 level atom,
      common/fe2cool/ Fe2L16Tot,fe21308,fe21207,fe21106,fe21006,
     1 fe21204,fe21103,fe21104,fe21001,fe21002 ,
     1 fe20201 , fe20302 , fe20706 , fe20807 , fe20908 ,
     1 fe21007 , fe21107 , fe21108 , fe21110 , fe21507,
     1 fe21208 , fe21209 , fe21211 , fe21406,fe21508,fe21609
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer iPredFe2(3,LimPredFe2)
*set of pointers to bands within Katya's FeII atom
*first dim is band wavelength, lower, upper bounds
*second is number of bands
      common/PredFe2/ iPredFe2
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real r14,cola,fela,znla,c14,scla, c10,colfac, escinc,
     1 tila,potla, xmnla,cala,cula,chla,xnila,vala,eff , SumBandFe2
      integer nelem , i , ipnt
*
      if( lgTrace ) write(qq,'(''   LineSet4 called'')')
*
*     potassium
*     K I 7745
      call PutLine( KI7745 )
*
*     [K III] 4.62 microns
      call PutLine( xK03462 )
*
*     [KIV] 5.983 min
      call PutLine( xK04598 )
*
*     [KIV] 15.39 mic
      call PutLine( xK04154 )
*
*     [KVI] 8.823 mic
      call PutLine( xK06882 )
*
*     [KVI]  5.575 mic
      call PutLine( xK06557 )
*
*     [K VII] 3.189 microns
      call PutLine( xK07319 )
*
*     K 11 4249.99A
      call PutLine( xK11425 )
*
*     K 19 ly a recombination 3.7A from fully stripped ion
      nelem = 10
*     these lines added to outlin in metdif - following must be false
      potla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*5.33E-9
      call PntForLine(  3.55 , 'K19r' , ipnt )
      call lindst( potla , 4 , 'K19r',ipnt,'i',.false.)
*     call linadd( potla , 4 , 'K19r','i')
*
*     calcium
*     Ca I 4228
      call PutLine( CaI4228 )
*
*     coll excit calcium k+h
      call linadd( Cakh  , 3933 , 'Ca 2','c')
*
*     infrared triplet
      call linadd( Cair  , 8579 , 'Ca 2','c')
*
*     forbidden lines, 7291+7324 together
      call linadd( c7306 , 7306 , 'Ca 2','c')
*
*     fraction H Ly-alpha destruction of excited levels
      call linadd( dCakh  , 3933 , 'Phot','i')
*
*     fraction H Ly-alpha destruction of excited levels
      call linadd( dCaf12 , 7306 , 'Phot','i')
*
*     individual lines from five level atom
      call PntForLine(   3934., 'Ca2K' , ipnt )
      call lindst( Cak , 3934 , 'Ca2K',ipnt,'i',.true.)
*     call linadd( Cak , 3934 , 'Ca2K','i')
*
*     individual lines from five level atom
      call PntForLine(   3969., 'Ca2H' , ipnt )
      call lindst( Cah , 3969 , 'Ca2H',ipnt,'i',.true.)
*     call linadd( Cah , 3969 , 'Ca2H','i')
*
*     individual lines from five level atom
      call PntForLine(   8498., 'Ca2X' , ipnt )
      call lindst( Cax , 8498 , 'Ca2X',ipnt,'i',.true.)
*     call linadd( Cax , 8498 , 'Ca2X','i')
*
*     individual lines from five level atom
      call PntForLine(   8542., 'Ca2Y' , ipnt )
      call lindst( Cay , 8542 , 'Ca2Y',ipnt,'i',.true.)
*     call linadd( Cay , 8542 , 'Ca2Y','i')
*
*     individual lines from five level atom
      call PntForLine(   8662., 'Ca2Z' , ipnt )
      call lindst( Caz , 8662 , 'Ca2Z',ipnt,'i',.true.)
*     call linadd( Caz , 8662 , 'Ca2Z','i')
*
*     individual lines from five level atom
      call PntForLine(    7291., 'CaF1' , ipnt )
      call lindst( Caf1 , 7291 , 'CaF1',ipnt,'i',.true.)
*     call linadd( Caf1 , 7291 , 'CaF1','i')
*
*     individual lines from five level atom
      call PntForLine(    7324., 'CaF2' , ipnt )
      call lindst( Caf2 , 7324 , 'CaF2',ipnt,'i',.true.)
*     call linadd( Caf2 , 7324 , 'CaF2','i')
*
*     reccombination contribution to CaII emission
      eff = eden * xIonFracs(20,3) * 5.4e-21 / (te/te10/te10)
      call linadd( eff , 3933 , 'Rec ','i')
*
*     Ca IV 3.2 micron
      call PutLine( tCa3 )
*
*     Ca V 4.16, 11.47 micron
      call PutLine( tCa4 )
*
*     Ca V 4.16, 11.47 micron
      call PutLine( tCa12 )
*
*     Ca V optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      6087., 'Ca 5' , ipnt )
      call lindst( Ca6087 , 6087 , 'Ca 5',ipnt,'c',.true.)
*     call linadd( Ca6087 , 6087 , 'Ca 5','c')
*
*     Ca V optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(     5311., 'Ca 5' , ipnt )
      call lindst( c5311 , 5311 , 'Ca 5',ipnt,'c',.true.)
*     call linadd( c5311 , 5311 , 'Ca 5','c')
*
*     Ca V optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(     2414., 'Ca 5' , ipnt )
      call lindst( c2414 , 2414 , 'Ca 5',ipnt,'c',.true.)
*     call linadd( c2414 , 2414 , 'Ca 5','c')
*
*     Ca V optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(     3997., 'Ca 5' , ipnt )
      call lindst( c3997 , 3997 , 'Ca 5',ipnt,'c',.true.)
*     call linadd( c3997 , 3997 , 'Ca 5','c')
*
*     [Ca VII] 4.09 microns
      call PutLine( Ca0741 )
*
*     [Ca VII] 6.15 microns
      call PutLine( Ca0761 )
*
*     Ca VII optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      5620., 'Ca 7' , ipnt )
      call lindst( Ca5620 , 5620 , 'Ca 7',ipnt,'c',.true.)
*     call linadd( Ca5620 , 5620 , 'Ca 7','c')
*
*     Ca VII optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      4941., 'Ca 7' , ipnt )
      call lindst( Ca4941 , 4941 , 'Ca 7',ipnt,'c',.true.)
*     call linadd( Ca4941 , 4941 , 'Ca 7','c')
*
*     Ca VII optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      2112., 'Ca 7' , ipnt )
      call lindst( Ca2112 , 2112 , 'Ca 7',ipnt,'c',.true.)
*     call linadd( Ca2112 , 2112 , 'Ca 7','c')
*
*     Ca VII optical and uv lines, collisional excitation, 3-level atom
      call PntForLine(      3688., 'Ca 7' , ipnt )
      call lindst( Ca3688 , 3688 , 'Ca 7',ipnt,'c',.true.)
*     call linadd( Ca3688 , 3688 , 'Ca 7','c')
*
*     [Ca VIII]  2.32 microns, A Saraph and Strey
      call PutLine( Ca08232 )
*
*     [Ca 12] 3328.78A
      call PutLine( Ca12333 )
*
*     Ca 18 Li seq 2s2p, 302, 345 separate
      call PutLine( tCa302 )
*
*     Ca 18 Li seq 2s2p, 302, 345 separate
      call PutLine( tCa345 )
*
*     Ca 18 Li seq 2s3p,
      call PutLine( tCa19 )
*
*     Calcium Ly a recombination from fully stripped ion
      nelem = 20
*     these lines added to outlin in metdif - following must be false
      cala = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9
      call PntForLine( 3.02 , 'CaLr' , ipnt )
      call lindst( cala , 3 , 'CaLr',ipnt,'i',.false.)
*     call linadd( cala , 3 , 'CaLr','i')
*
*     scandium Ly a recombination from fully stripped ion
      nelem = 21
*     these lines added to outlin in metdif - following must be false
      scla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9
      call PntForLine( 2.98 , 'ScLr' , ipnt )
      call lindst( scla , 3 , 'ScLr',ipnt,'i',.false.)
*     call linadd( scla , 3 , 'ScLr','i')
*
*     Sc II 2.08 (1-3)
      call PntForLine(   22.08e4 , 'Sc 2' , ipnt )
      call lindst( Sc22p08m , 21 , 'Sc 2',ipnt,'c',.true.)
*     call linadd( Sc22p08m , 21 , 'Sc 2' , 'c' )
*
*     Sc II 4.1 mic (1-2)
      call PntForLine(   24.1e4 , 'Sc 2' , ipnt )
      call lindst( Sc24p1m , 41 , 'Sc 2',ipnt,'c',.true.)
*     call linadd( Sc24p1m , 41 , 'Sc 2' , 'c' )
*
*     Sc II 4.22 (2-3)
      call PntForLine(   24.2e4 , 'Sc 2' , ipnt )
      call lindst( Sc24p2m , 42 , 'Sc 2',ipnt,'c',.true.)
*     call linadd( Sc24p2m , 42 , 'Sc 2' , 'c' )
*
*     Sc III 3936
      call PntForLine(       3933., 'Sc 3' , ipnt )
      call lindst( Sc33936 , 3933 , 'Sc 3',ipnt,'c',.true.)
*     call linadd( Sc33936 , 3933 , 'Sc 3' , 'c' )
*
*     [Sc V] 1.46 microns
      call PutLine( Sc05231 )
*
*     Sc VI 5054 (1-2)
      call PntForLine(       5054., 'Sc 6' , ipnt )
      call lindst( Sc45058 , 5054 , 'Sc 6',ipnt,'c',.true.)
*     call linadd( Sc45058 , 5054 , 'Sc 6' , 'c' )
*
*     Sc VI 3595 (2-3)
      call PntForLine(       3592., 'Sc 6' , ipnt )
      call lindst( Sc43595 , 3592 , 'Sc 6',ipnt,'c',.true.)
*     call linadd( Sc43595 , 3592 , 'Sc 6' , 'c' )
*
*     Sc VI 2100 (1-3)
      call PntForLine(       2100., 'Sc 6' , ipnt )
      call lindst( Sc42100 , 2100 , 'Sc 6',ipnt,'c',.true.)
*     call linadd( Sc42100 , 2100 , 'Sc 6' , 'c' )
*
*     [Sc 13] 2637.97A
      call PutLine( Sc13264 )
*
*     titanium Ly a recombination from fully stripped ion
      nelem = 22
*     these lines added to outlin in metdif - following must be false
      tila = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9
      call PntForLine( 2.95 , 'TiLr' , ipnt )
      call lindst( tila , 3 , 'TiLr',ipnt,'i',.false.)
*     call linadd( tila , 3 , 'TiLr','i')
*
*     Ti III 1.21 micron, (actually multiplet) 2-1 transition from model atom
      call PntForLine(  1.21e4 , 'Ti 3' , ipnt )
      call lindst( Ti3l21 , 12 , 'Ti 3',ipnt,'c',.true.)
*     call linadd( Ti3l21 , 12 , 'Ti 3','c')
*
*     Ti III 9594, 3-1 transition, (actually multiplet) from model atom
      call PntForLine(      9594., 'Ti 3' , ipnt )
      call lindst( Ti3l31 , 9594 , 'Ti 3',ipnt,'c',.true.)
*     call linadd( Ti3l31 , 9594 , 'Ti 3','c')
*
*     Ti III 4.57 micron, 3-2 transition, (actually multiplet) from model atom
      call PntForLine( 4.57e4  , 'Ti 3' , ipnt )
      call lindst( Ti3l32 , 45 , 'Ti 3',ipnt,'c',.true.)
*     call linadd( Ti3l32 , 45 , 'Ti 3','c')
*
*     [Ti VI] 1.72 microns
      call PutLine( Ti06172 )
*
*     [Ti XIV] 2117.79
      call PutLine( Ti14212 )
*
*     vanadium Ly a recombination from fully stripped ion
      nelem = 23
*     these lines added to outlin in metdif - following must be false
      vala = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9
      call PntForLine( 2.92 , 'V Lr' , ipnt )
      call lindst( vala , 3 , 'V Lr',ipnt,'i',.false.)
*     call linadd( vala , 3 , 'V Lr','i')
*
*     V III 8823
      call PntForLine(      8823., 'V  3' , ipnt )
      call lindst( V38830 , 8823 , 'V  3',ipnt,'c',.true.)
*     call linadd( V38830 , 8823 , 'V  3' , 'c' )
*
*     V III 8507
      call PntForLine(      8507., 'V  3' , ipnt )
      call lindst( V38507 , 8507 , 'V  3',ipnt,'c',.true.)
      call linadd( V38507 , 8507 , 'V  3' , 'c' )
*
*     V IV 7741 1-3
      call PntForLine(      7735., 'V  4' , ipnt )
      call lindst( V47741 , 7735 , 'V  4',ipnt,'c',.true.)
*     call linadd( V47741 , 7735 , 'V  4' , 'c' )
*
*     V IV 9496 2-1
      call PntForLine(      9489., 'V  4' , ipnt )
      call lindst( V49496 , 9489 , 'V  4',ipnt,'c',.true.)
*     call linadd( V49496 , 9489 , 'V  4' , 'c' )
*
*     V IV 4.19 mic 3-2
      call PntForLine( 4.19e4  , 'V  4' , ipnt )
      call lindst( V44p2m , 42 , 'V  4',ipnt,'c',.true.)
*     call linadd( V44p2m , 42 , 'V  4' , 'c' )
*
*     [V VII] 1.304 microns
      call PutLine( Va07130 )
*
*     [V 15] 1721.38
      call PutLine( Va15172 )
*
*     Chromium Ly a recombination from fully stripped ion
      nelem = 24
*     these lines added to outlin in metdif - following must be false
      chla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9
      call PntForLine( 2.89 , 'CrLr' , ipnt )
      call lindst( chla , 3 , 'CrLr',ipnt,'i',.false.)
*     call linadd( chla , 3 , 'CrLr','i')
*
*     [CrIII] multiplet blend at 5828A
      call PntForLine(      5828., 'Cr 3' , ipnt )
      call lindst( Cr3l21 , 5828 , 'Cr 3',ipnt,'c',.true.)
*     call linadd( Cr3l21 , 5828 , 'Cr 3','c')
*
*     [CrIV] 2 - 1 multiplet blend at 7272
      call PntForLine(      7267., 'Cr 4' , ipnt )
      call lindst( Cr4l21 , 7267 , 'Cr 4',ipnt,'c',.true.)
*     call linadd( Cr4l21 , 7267 , 'Cr 4','c')
*
*     [CrIV] 3 - 1 multiplet blend at 6806
      call PntForLine(      6801., 'Cr 4' , ipnt )
      call lindst( Cr4l31 , 6801 , 'Cr 4',ipnt,'c',.true.)
*     call linadd( Cr4l31 , 6801 , 'Cr 4','c')
*
*     [CrV] 2 - 1 multiplet blend at 7985
      call PntForLine(      7979., 'Cr 5' , ipnt )
      call lindst( Cr5l21 , 7979 , 'Cr 5',ipnt,'c',.true.)
*     call linadd( Cr5l21 , 7979 , 'Cr 5','c')
*
*     [CrV] 3 - 1 multiplet blend at 6582
      call PntForLine(      6577., 'Cr 5' , ipnt )
      call lindst( Cr5l31 , 6577 , 'Cr 5',ipnt,'c',.true.)
*     call linadd( Cr5l31 , 6577 , 'Cr 5','c')
*
*     [CrV] 3 - 2 multiplet blend at 3.75 microns
      call PntForLine( 3.75e4  , 'Cr 5' , ipnt )
      call lindst( Cr5l32 , 37 , 'Cr 5',ipnt,'c',.true.)
*     call linadd( Cr5l32 , 37 , 'Cr 5','c')
*
*     [Cr VIII] 1.01 microns
      call PutLine( Cr08101 )
*
*     [Cr 16] 1410.60
      call PutLine( Cr16141 )
*
*     Manganese Ly a recombination from fully stripped ion
      nelem = 25
*     these lines added to outlin in metdif - following must be false
      xmnla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*6.58E-9
      call PntForLine( 2.84  , 'MnLr' , ipnt )
      call lindst( xmnla , 3 , 'MnLr',ipnt,'i',.false.)
*     call linadd( xmnla , 3 , 'MnLr','i')
*
*     [Mn IX] 7968.5 A
      call PutLine( xMn0979 )
*
*     [Mn 17] 1169.59
      call PutLine( xMn1712 )
*
*     bob rubin's uv line
*     f2 = xIonFracs(26,4)*sexp(50 764./te)*0.45*cdsqte/6.*7.01e-12
*     call linadd( f2 , 2837 , 'BobR' , 'i')
*     f2 = xIonFracs(26,4)*sexp(55 989./te)*0.384*cdsqte/6.*7.74e-12
*     call linadd( f2 , 2568 , 'BobR' , 'i')
*
*     iron
*     Fe 1 3884
      call PutLine( FeI3884 )
*
*     Fe 1 3729
      call PutLine( FeI3729 )
*
*     Fe 1 3457
      call PutLine( FeI3457 )
*
*     Fe 1 3021
      call PutLine( FeI3021 )
*
*     Fe 1 2966
      call PutLine( FeI2966 )
*
*     Fe 2 the 3-2 transition of Netzer's atom
      call linadd( rmt48 , 6200 , 'Fe 2','i')
*
*     Fe 2 forbidden 2-1 transition from Netzer's atom
      call linadd( for7 , 4300 , 'Fe 2','i')
*
*     Fe 2 UV3, 3-1 transition from Netzer's atom
      call linadd( emuv3 , 2400 , 'Fe 2','i')
*
*     total of all UV+optical Fe 2 cooling
      call linadd( max(0.,Fecool), 0 , 'Fe2c','c')
      call linadd( max(0.,-Fecool), 0 , 'Fe2h','h')
*
*     1 to 6 transition of Fred's Fe 2 atom
      call linadd( cFe16 , 1100 , 'Fe 2','i')
*
*     2 to 6 transition of Fred's Fe 2 atom
      call linadd( cFe26 , 1500 , 'Fe 2','i')
*
*     3 to 4 transition of Fred's Fe 2 atom
      call linadd( cFe34 , 11500 , 'Fe 2','i')
*
*     3 to 5 transition of Fred's Fe 2 atom
      call linadd( cFe35 , 2500 , 'Fe 2','i')
*
*     4 to 6 transition of Fred's Fe 2 atom
      call linadd( cFe46 , 2300 , 'Fe 2','i')
*
*     5 to 6 transition of Fred's Fe 2 atom
      call linadd( cFe56 , 8900 , 'Fe 2','i')
*
*     results of 16 level Fe 2 atom, not all are printed
*     all cooling due to 16 level atom
      call linadd( Fe2L16Tot , 0 , 'Fe 2', 'c' )
*
*     Fe 2 1.664 microns 8-13
      call PntForLine(    16640. ,  'Fe 2' , ipnt )
      call lindst( fe21308 , 166 ,  'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21308 , 166 ,  'Fe 2' , 'i' )
*
*     Fe 2 1.599 microns 7-12
      call PntForLine(    15990. , 'Fe 2' , ipnt )
      call lindst( fe21207 , 160 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21207 , 160 , 'Fe 2' , 'i' )
*
*     Fe 2 1.534 microns 6-11
      call PntForLine(    15340. , 'Fe 2' , ipnt )
      call lindst( fe21106 , 153 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21106 , 153 , 'Fe 2' , 'i' )
*
*     Fe 2 1.644 microns 6-10
      call PntForLine(    16440. , 'Fe 2' , ipnt )
      call lindst( fe21006 , 164 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21006 , 164 , 'Fe 2' , 'i' )
*
*     Fe 2 1.279 microns 12-4
      call PntForLine(     12790. , 'Fe 2' , ipnt )
      call lindst( fe21204 , 128 ,  'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21204 , 128 ,  'Fe 2' , 'i' )
*
*     Fe 2 1.295 microns 11-3
      call PntForLine(     12950. , 'Fe 2' , ipnt )
      call lindst( fe21103 , 130 ,  'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21103 , 130 ,  'Fe 2' , 'i' )
*
*     Fe 2 1.328 microns 11-4
      call PntForLine(    13280. , 'Fe 2' , ipnt )
      call lindst( fe21104 , 133 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21104 , 133 , 'Fe 2' , 'i' )
*
*     Fe 2 1.257 microns 10-1
      call PntForLine(    12570. , 'Fe 2' , ipnt )
      call lindst( fe21001 , 126 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21001 , 126 , 'Fe 2' , 'i' )
*
*     Fe 2 1.321 microns 10-2
      call PntForLine(    13210. , 'Fe 2' , ipnt )
      call lindst( fe21002 , 132 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21002 , 132 , 'Fe 2' , 'i' )
*
*     Fe 2 25.988 microns 2-1
      call PntForLine(   259880. , 'Fe 2' , ipnt )
      call lindst( fe20201 , 259 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20201 , 259 , 'Fe 2' , 'i' )
*
*     Fe 2 35.348 microns 3-2
      call PntForLine(   353480. , 'Fe 2' , ipnt )
      call lindst( fe20302 , 353 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20302 , 353 , 'Fe 2' , 'i' )
*
*     Fe 2 17.936 microns 7-6, label is 178 to be unique
      call PntForLine(   179360. , 'Fe 2' , ipnt )
      call lindst( fe20706 , 178 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20706 , 178 , 'Fe 2' , 'i' )
*
*     Fe 2 24.518 microns 8-7
      call PntForLine(   245180. , 'Fe 2' , ipnt )
      call lindst( fe20807 , 245 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20807 , 245 , 'Fe 2' , 'i' )
*
*     Fe 2 35.776 microns 9-8
      call PntForLine(   357760. , 'Fe 2' , ipnt )
      call lindst( fe20908 , 358 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe20908 , 358 , 'Fe 2' , 'i' )
*
*     Fe 2 1.810 microns 10-7
      call PntForLine(    18100. , 'Fe 2' , ipnt )
      call lindst( fe21007 , 181 , 'Fe 2' , ipnt,'i',.true.)
*     call linadd( fe21007 , 181 , 'Fe 2' , 'i' )
*
*     Fe 2 1.677 microns 11-7
      call PntForLine(    16770. , 'Fe 2' , ipnt )
      call lindst( fe21107 , 168 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21107 , 168 , 'Fe 2' , 'i' )
*
*     Fe 2 1.800 microns 11-8
      call PntForLine(    18000. , 'Fe 2' , ipnt )
      call lindst( fe21108 , 180 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21108 , 180 , 'Fe 2' , 'i' )
*
*     Fe 2 1.712 microns 12-8
      call PntForLine(    17120. , 'Fe 2' , ipnt )
      call lindst( fe21208 , 171 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21208 , 171 , 'Fe 2' , 'i' )
*
*     Fe 2 1.798 microns 12-9
      call PntForLine(    17980. , 'Fe 2' , ipnt )
      call lindst( fe21209 , 179 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21209 , 179 , 'Fe 2' , 'i' )
*
*     Fe 2 22.902 microns 11-10
      call PntForLine(   229020. , 'Fe 2' , ipnt )
      call lindst( fe21110 , 229 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21110 , 229 , 'Fe 2' , 'i' )
*
*     Fe 2 34.660 microns 12-11
      call PntForLine(   346600. , 'Fe 2' , ipnt )
      call lindst( fe21211 , 347 , 'Fe 2' ,ipnt, 'i',.true.)
*     call linadd( fe21211 , 347 , 'Fe 2' , 'i' )
*
*     >>chng 97 mar 14, added following 4 lines after consultation with Verner
*     these are typically within 5-9% of their large model atom
*     Fe 2 8619A 14-06
      call PntForLine(       8619., 'Fe 2' , ipnt )
      call lindst( fe21406 , 8619 , 'Fe 2',ipnt,'i',.true.)
*     call linadd( fe21406 , 8619 , 'Fe 2' , 'i' )
*
*     Fe 2 8894A 15-07
      call PntForLine(       8894., 'Fe 2' , ipnt )
      call lindst( fe21507 , 8894 , 'Fe 2',ipnt,'i',.true.)
*     call linadd( fe21507 , 8894 , 'Fe 2' , 'i' )
*
*     Fe 2 9229A 15-08
      call PntForLine(       9229., 'Fe 2' , ipnt )
      call lindst( fe21508 , 9229 , 'Fe 2',ipnt,'i',.true.)
*     call linadd( fe21508 , 9229 , 'Fe 2' , 'i' )
*
*     Fe 2 9270A 16-09
      call PntForLine(       9270., 'Fe 2' , ipnt )
      call lindst( fe21609 , 9270 , 'Fe 2',ipnt,'i',.true.)
*     call linadd( fe21609 , 9270 , 'Fe 2' , 'i' )
*
*     some banks from Katya Verner's model Fe II atom
*     when not linked in, just zeros, numbers set in block data scalar
      do i=1,LimPredFe2
        eff = SumBandFe2( iPredFe2(2,i) , iPredFe2(3,i))
*       emission from lage FeII atom, integrated over band
        call linadd( eff , iPredFe2(1,i) , 'Fe2b' , 'i' )
      end do
*
*     anomalous Fe 2 transition at 1787, RMT 191
      call PutLine( t191 )
*
*     sum of 3p and 3g states together
      call linadd( c5270 , 0 , 'Fe 3','c')
*
*     Fe 3 5270, predictions from garstang et al 78
      call PntForLine(            5270., 'Fe 3' , ipnt )
      call lindst( c5270*0.2090 , 5270 , 'Fe 3',ipnt,'c',.true.)
*     call linadd( c5270*0.2090 , 5270 , 'Fe 3','c')
*
*     Fe 3 5270, predictions from garstang et al 78
      call PntForLine(            4658., 'Fe 3' , ipnt )
      call lindst( c5270*0.3667 , 4658 , 'Fe 3',ipnt,'c',.true.)
*     call linadd( c5270*0.3667 , 4658 , 'Fe 3','c')
*
*     Fe 3 1122 entire multiplet
      call PutLine( t1122 )
*
*     total cooling due to 12-level Fe 4 atom
      call linadd( Fe4CoolTot , 0 , 'Fe 4','c')
*
*     Fe 4 3096.A, 4-1 and 5-1 transitions together
      call PntForLine(       3096., 'Fe 4' , ipnt )
      call lindst( fe40401 , 3096 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe40401 , 3096 , 'Fe 4','i')
*
*     Fe 4 2835.7A, 6-1 transition, 4P5/2 - 6S5/2
      call PntForLine(       2836., 'Fe 4' , ipnt )
      call lindst( fe42836 , 2836 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe42836 , 2836 , 'Fe 4','i')
*
*     Fe 4 2829.4A, 7-1 transition, 4P3/2 - 6S5/2
      call PntForLine(       2829., 'Fe 4' , ipnt )
      call lindst( fe42829 , 2829 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe42829 , 2829 , 'Fe 4','i')
*
*     Fe 4 2567.6+ 2567.4. 11-1 and 12-1 transitions
      call PntForLine(       2567., 'Fe 4' , ipnt )
      call lindst( fe42567 , 2567 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe42567 , 2567 , 'Fe 4','i')
*
*     Fe 4 2.774 microns 12-7 transition
      call PntForLine(    2.774e4, 'Fe 4' , ipnt )
      call lindst( fe41207 , 277 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41207 , 277 , 'Fe 4','i')
*
*     Fe 4 2.714 microns 12-6 transition
      call PntForLine(  2.714e4  , 'Fe 4' , ipnt )
      call lindst( fe41206 , 271 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41206 , 271 , 'Fe 4','i')
*
*     Fe 4 2.716 microns 11-6 transition
      call PntForLine(  2.716e4  , 'Fe 4' , ipnt )
      call lindst( fe41106 , 272 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41106 , 272 , 'Fe 4','i')
*
*     Fe 4 2.806 microns 10-7 transition
      call PntForLine(  2.806e4  , 'Fe 4' , ipnt )
      call lindst( fe41007 , 281 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41007 , 281 , 'Fe 4','i')
*
*     Fe 4 2.865 microns 10-8 transition
      call PntForLine(  2.865e4  , 'Fe 4' , ipnt )
      call lindst( fe41008 , 287 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe41008 , 287 , 'Fe 4','i')
*
*     Fe 4 2.836 microns 9-6 transition
      call PntForLine(  2.836e4  , 'Fe 4' , ipnt )
      call lindst( fe40906 , 284 , 'Fe 4',ipnt,'i',.true.)
*     call linadd( fe40906 , 284 , 'Fe 4','i')
*
*     Fe 5  3892+3839
      call PntForLine(     3892., 'Fe 5' , ipnt )
      call lindst( c3892 , 3892 , 'Fe 5',ipnt,'c',.true.)
*     call linadd( c3892 , 3892 , 'Fe 5','c')
*
*     all of 2G lines together first
      call linadd( c5177 , 0 , 'Fe 6','c')
*
*     Fe 6 5177, approximate correct
      call PntForLine(           5177., 'Fe 6' , ipnt )
      call lindst( c5177*0.354 , 5177 , 'Fe 6',ipnt,'c',.true.)
*     call linadd( c5177*0.354 , 5177 , 'Fe 6','c')
*
*     [Fe 7] 9.51 micron
      call PutLine( Fe0795 )
*
*     [Fe 7] 7.81 micron
      call PutLine( Fe0778 )
*
*     [Fe 7] 6087
      call PntForLine(     6087., 'Fe 7' , ipnt )
      call lindst( c6087 , 6087 , 'Fe 7',ipnt,'c',.true.)
*     call linadd( c6087 , 6087 , 'Fe 7','c')
*
*     [Fe 7] 5722
      call PntForLine(      5722., 'Fe 7' , ipnt )
      call lindst( Fe5722 , 5722 , 'Fe 7',ipnt,'c',.true.)
*     call linadd( Fe5722 , 5722 , 'Fe 7','c')
*
*     Be-seq lines
      call PutLine( t245 )
*
*     Fe 9 242 j=1 slower decay
      call PntForLine(    242., 'Fe 7' , ipnt )
      call lindst( c242 , 242 , 'Fe 7',ipnt,'c',.true.)
*     call linadd( c242 , 242 , 'Fe 9','c')
*
*     the E1 transition that can pump [Fe X]
      call PutLine( t352 )
*
*     optically thin Fe X pumping
      colfac = 8.629e-6/sqrte*eden
      eff = 69.4 / (69.4 + 0.27*colfac)
*
*     coll exc of 352 which decays to escit state of 6374
*     assumes 17/56 (ratio of A's) go to excit state
      c10 = t352(ipLnNPhots)*eff*.01676  * t352(ipLnEnrErg) *
     1 352/6374.
*
*     Fe 10 and Fe 14 from Mason 75
*     total (coll, pumped)
*     call linadd( C6374+C10 , 6374 , 'Fe10','i')
      call PutExtra( c10 )
*
*     [Fe 10] 6375, collisions with pumping too
      call PutLine( Fe106375 )
*
*     collisional contribution
*     call linadd( C6374 , 6374 , 'Coll','c')
*     collisions of E1 line, plus pumped by continuum fluorescense
*     call linadd( C10 , 6374 , ' 352','c')
*     Fe XI 7892, 6.08 micron
      call PutLine( tFe07 )
*
* 666 error! put this line back in!
*     EFF = 43.6 / (43.6 + 0.27*COLFAC)
*     R11 = FE(11)*FLUX(IPFE10)*3.122E-12*EFF *
*    1 ( PFE11A*ESCINC(T353(1),1E-4)/(1.+17.0/5.3*T353(3) )  +
*    2 PFE11B*ESCINC(T353(1)/3.,1E-4)/(1.+11.0/12.3*T353(3) ) )
*     contribution to Fe11 from continuum fluorescense
*     call linadd( R11    , 7892 , 'Pump','i')
*
*     [Fe 11] 6.08 microns
      call PutLine( tFe61 )
*
*     Fe 11 2649 collisional excitation
      call PntForLine(     2649., 'Fe11' , ipnt )
      call lindst( c2649 , 2649 , 'Fe11',ipnt,'c',.true.)
*     call linadd( c2649 , 2649 , 'Fe11','c')
*
*     Fe 11 1467 collisional excitation
      call PntForLine(     1467., 'Fe11' , ipnt )
      call lindst( c1467 , 1467 , 'Fe11',ipnt,'c',.true.)
*     call linadd( c1467 , 1467 , 'Fe11','c')
*
*     Fe 12, 1242, 1349 together, collisional excitation
      call PntForLine(     1242., 'Fe12' , ipnt )
      call lindst( c1242 , 1242 , 'Fe12',ipnt,'c',.true.)
*     call linadd( c1242 , 1242 , 'Fe12','c')
*
*     Fe 12, 2170, 2406 together, collisional excitation
      call PntForLine(     2170., 'Fe12' , ipnt )
      call lindst( c2170 , 2170 , 'Fe12',ipnt,'c',.true.)
*     call linadd( c2170 , 2170 , 'Fe12','c')
*
*     Fe12 2904, 2567, 3567, 3073 together, collisional excitation
      call PntForLine(     2568., 'Fe12' , ipnt )
      call lindst( c2568 , 2568 , 'Fe12',ipnt,'c',.true.)
*     call linadd( c2568 , 2568 , 'Fe12','c')
*
*     [Fe 13] 1.07 microns
      call PutLine( Fe1310 )
*
*     [Fe 13] 1.08 microns
      call PutLine( Fe1311 )
*
*     Fe 14 optically thin in line 344
      eff = 60.3 / (60.3 + 0.23 * colfac/4. )
      r14 = xIonFracs(26,14)*pfe14*flux(ipfe10)*3.75e-12*eff /
     1 (1.+24./.63*t347(3) ) * escinc(t347(1),1e-4)
      call PntForLine(         5303., 'Fe14' , ipnt )
      call lindst( c5303+r14 , 5303 , 'Fe14',ipnt,'i',.true.)
*     call linadd( c5303+r14 , 5303 , 'Fe14','i')
*
*     contribution from collisional excitation
      call linadd( c5303 , 5303 , 'Coll','c')
*
*     continuum fluorescense
      call linadd( r14 , 5303 , 'Pump','r')
*
*     collisional excitation of E1 line
* 666 error! put this in
      c14 = 0.
      call linadd( c14 , 5303 , ' 347','c')
*
*     Fe 18 974.86A
      call PutLine( Fe18975 )
*
*     Fe 19 from loulergue et al '85
      call PntForLine(    592., 'Fe19' , ipnt )
      call lindst( c592 , 592 , 'Fe19',ipnt,'c',.true.)
*     call linadd( c592 , 592 , 'Fe19','c')
*
*     Fe 19 from loulergue et al '85
      call PntForLine(     7082., 'Fe19' , ipnt )
      call lindst( c7082 , 7082 , 'Fe19',ipnt,'c',.true.)
*     call linadd( c7082 , 7082 , 'Fe19','c')
*
*     Fe 19 from loulergue et al '85
      call PntForLine(     1118., 'Fe19' , ipnt )
      call lindst( c1118 , 1118 , 'Fe19',ipnt,'c',.true.)
*     call linadd( c1118 , 1118 , 'Fe19','c')
*
*     Fe 19 from loulergue et al '85
      call PntForLine(     1328., 'Fe19' , ipnt )
      call lindst( c1328 , 1328 , 'Fe19',ipnt,'c',.true.)
*     call linadd( c1328 , 1328 , 'Fe19','c')
*
*     next two 3p ground state lines, collisional excitation
      call PutLine( tFe13 )
*
*     collisional excitation
      call PutLine( tFe23 )
*
*     Fe 22 845.6A
      call PntForLine(     846., 'Fe22' , ipnt )
      call lindst( fs846 , 846 , 'Fe22',ipnt,'c',.true.)
*     call linadd( fs846 , 846 , 'Fe22','c')
*
*     Fe 23 1909-like 262.6
      call PntForLine(    263., 'Fe23' , ipnt )
      call lindst( c263 , 263 , 'Fe23',ipnt,'c',.true.)
*     call linadd( c263 , 263 , 'Fe23','c')
*
*     Fe 24 only 192 of 255, 192 Li seq doublet, collisional excitation
      call PutLine( t192 )
*
*     Fe 24 255 of 255, 192 Li seq doublet, collisional excitation
      call PutLine( t255 )
*
*     Fe 24 Li seq 2s3p collisional excitation
      call PutLine( t11 )
*
*     recombination Ka
      nelem = 26
*     these lines added to outlin in metdif - following must be false
      fela = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
*
*     total intensity of K-alpha line
      call linadd( fekcld*1.03e-8+(fekhot+fela)*1.11E-8, 2 , 'FeKa','i')
*
*     recombination from fully stripped ion
      call linadd( fela*1.11E-8 , 2 , 'FeLr','i')
*
*     total hot iron Ka; Auger "hot" iron, plus recom
      call linadd( (fekhot+fela)*1.11E-8 , 2 , 'TotH','i')
*
*     Auger production of "cold" iron, less than or 17 times ionized
      call linadd( fekcld*1.03e-8 , 2 , 'AugC','i')
*
*     cobalt
*     Ly-alpha recombination from fully stripped ion
      nelem = 27
*     these lines added to outlin in metdif - following must be false
      cola = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( cola*1.30E-8 , 1 , 'CoLr','i')
*
*     [Co XI] 5168. A
      call PutLine( Co11527 )
*
*     nickel
*     Ni Ly-alpha recombination from fully stripped ion, 1.5A
      nelem = 28
*     these lines added to outlin in metdif - following must be false
      xnila = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)
      call linadd( xnila*1.30e-8 , 1 , 'NiLr','i')
*
*     [Ni XII] 4230.8 A
      call PutLine( xNi1242 )
*
*     copper
*     Cu Ly-alpha recombination from fully stripped ion, 1.5A
      nelem = 29
*     these lines added to outlin in metdif - following must be false
      cula = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.30E-8
      call PntForLine( 1.3  , 'CuLr' , ipnt )
      call lindst( cula , 1 , 'CuLr',ipnt,'i',.false.)
*     call linadd( cula , 1 , 'CuLr','i')
*
*     zinc
*     Zn Ly-alpha recombination from fully stripped ion, 1.5A
      nelem = 30
*     these lines added to outlin in metdif - following must be false
      znla = xLyaHeavy(nelem,nelem)*xIonFracs(nelem,nelem+1)*1.30E-8
      call PntForLine( 1.3  , 'ZnLr' , ipnt )
      call lindst( znla , 1 , 'ZnLr',ipnt,'i',.false.)
*     call linadd( znla , 1 , 'ZnLr','i')
*
      if( lgTrace ) write(qq,'(''   LineSet4 returns'')')
*
      end
******************************************************************************
      subroutine lines
      implicit none
*main routine to put emission line intensities into line stack
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real cyntrn,hmfb,c584,heavfb,bhe,herec,eebrm,h2line,h2dis,
     1 heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      common/coolng/cyntrn,hmfb,c584,heavfb, bhe,herec,eebrm,h2line,
     1 h2dis,heavff,crcind,colmet, tccool,c3ind,expans, cextxx
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      integer nsumtt
      common/nsumtt/ nsumtt
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      real DiffCont
*diffus is local diffuse continuum, for current zone
      common/diffus/ DiffCont(ncell)
*     include "h2dish.com"
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real DiffusHeavy , xLyaHeavy
*DiffusHeavy is total rec rate to grnd for nelem,ion element
*xLyaHeavy is Lya for nelem,ion
      common/DiffHeav/ DiffusHeavy(limelm,limelm),
     1 xLyaHeavy(limelm,limelm)
      real popoi
      common/popoi/ popoi(6)
      real hetmet
      common/hetmet/ hetmet
      real he2ex
      common/he2ex/ he2ex
      real dheat
*grain heating rate for this zone
      common/dustheat/ dheat(ndust)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      reaL ri2s1s , ri1s2s
      common/rin2ph/ ri2s1s , ri1s2s
      real em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      common/embesq/ em1908 , em1218 , em1486 , em895,em2669,em1895,
     1 em1198
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      real pmph31, pmpo51, pmpo15 , esch31
      common/bowoi/ pmph31, pmpo51, pmpo15 , esch31
*these are a series of lines and continuua that are set in hediff and
*carried outward in metdif
      real esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      common/heots/ esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      integer ndsum , lind
      real smdlin
      common/dsum/ ndsum , smdlin(NLINES) , lind(NLINES)
      real hesc , esesc
      common/hesc/ hesc(lmhlvl,lmhlvl) , esesc(lmhlvl,lmhlvl)
      real hfrcin
      common/hfrcin/ hfrcin(lmhlvl,lmhlvl-1)
      real htpair , posrat
      common/mev/ htpair , posrat
      real smbeta , cn4861 , cn1216
      common/smbeta/ smbeta , cn4861 , cn1216
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real p1909 , p2326 , p1895 , p1666 , p1401
      common/pmp2s/ p1909 , p2326 , p1895 , p1666 , p1401
      real cryden , crpowr , crtemp , hxtot
      common/hextra/ cryden , crpowr , crtemp , hxtot
      real DustHeatLya , dstpow , dstsum , dincon,dstotl,dhcol,HDustDif
*     HDustDif is heating of grains in current zone due to diffuse fields
*DustHeatLya is heating of dust due to Lya
      common/dhla/ DustHeatLya , dstpow , dstsum , dincon ,dstotl,dhcol,
     1 HDustDif
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
      real workft , workfz
      common/workf/ workft , workfz
      real s3727 , s7325
      common/s3727/ s3727 , s7325
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      real coola , chion , hrecem , hrest,barest,restly
      common/hem/ coola , chion , hrecem , hrest,barest,restly
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      real TotalDustHeat , dphmax , h2pmax , dclmax
*TotalDustHeat is total heating due to grain heating over model
      common/dphoht/ TotalDustHeat , dphmax , h2pmax , dclmax
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real dstfe2lya , escfe2
*dstfe2lya is destruction probability for Lya onto FeII
      common/dstfe2/ dstfe2lya , escfe2
      integer ip374 , ip660
      common/pbowen/ ip374 , ip660
      real r1r0sq
      common/r1r0sq/ r1r0sq
      real supprs
*     suppresssion factors for dielectronic recombination
*     1 is burgess and 2 is storey
      common/supprs/ supprs(limelm,2)
      real heatlmax
      integer levlmax , ipHeatlmax
      common/heatlmax/ heatlmax , levlmax , ipHeatlmax
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      real GBarMax
      integer ipMaxExtra
*value of, and pointer to, strongest g-bar cooling line
      common/ExtraMax/ GBarMax , ipMaxExtra
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      integer nHTopOff
      character chHTopType*4
      common/HTopOff/ nHTopOff , chHTopType
      real fcool , dfcool , feheat
*     cooling computed by Katya's FeII model atom
*     fcool is total cooling (or heating if negative)
*     and dfcool is its derivative
*     holod is Russian for cold
      common/holod/ fcool , dfcool , feheat
      character chIonStage*4
      common/IonStage/ chIonStage(limelm+1)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
*     save rec coef data for recombination lines of C, N, O
      real RecCoefCNO(471,4)
      common/RecCNO/ RecCoefCNO
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     major routines used here:
*
*     PutLine( tarray )
*     this uses information in tarray to give various
*     contributions to lines, and their intensities
*
*     PutExtra( extra )
*     extra is some extra intensity to add to the line
*     it will go into the totl contribution put out by PutLine,
*     and this contriibution should be indicated by independent
*     call to linadd
*
*     local variables
      character chLabel*4
      real BigstExtra
      logical lgRecOn
      real sum,slope,bhead, below,bac,f0,f1,f3, ExtraCool , flow,f2
      integer i0,i1,i3,i2, i , ipnt
      save lgRecOn
*
*     free statement labels, >=2
*
      if( lgTrace ) write(qq,'('' lines called'')')
*
      workft = workft + workfz*dVeff*en1ryd
      power = power + htot * dVeff
      dstpow = dstpow + dstotl * dVeff
      comtot = comtot + cmheat * dVeff
      hmitot = hmitot + hmihet * dVeff
      totcol = totcol + ctot * dVeff
      GrossHeat = GrossHeat + feheat * dVeff
      cintot = cintot + crcind * dVeff
*     nsum is line pointer within large stack of line intensities
      nsum = 0
      ndsum = 0.
*
*     last arg in call to lindst and linadd is info on line
*     info is char variable indicating type of line this is
*     'c' cooling
*     'h' heating
*     'i' information only
*     'r' recombination line
*
*     all components of lines are entered into the main line stack here
*     when printing, filters exist to not print Inwd component
*
*     initialize routine that can generate pointers for forbidden lines
      call PntForLine( 0. , 'FILL' , i )
*
*     evaluate rec coef for rec lines of C, N, O
*     some will be used in LineSet2 and then zeroed out,
*     others left alone and used below
      call LineFit( te , RecCoefCNO )
*
*     punch energetics, H and He lines
      call LineSet1
*
*     do heavies, lithium through neon
      call LineSet2
*
*     do heavies, sodium through argon
      call LineSet3
*
*     do heavies, potasium through zinc
      call LineSet4
*
      call rdsum( sum , ' SUM' )
      sumlin(nsum+1) = 0.
*     optional sum of certain emission lines, set with "print sum"
      call linadd( sum/dVeff , 0 , 'Stoy','i')
*
*     stuff in Bac ratio
*     extrapolated continuum above the BJ
      i0 = ipHn(2) + 1
*     reflec continuum is different from others since relative to inner
*     radius, others for for this radius
*     remove ContDiff
*     ContDiff was in here, removed july 95 - I do not think this
*     will work with ots continuum
      f0 = (outcon(i0)+refcon(i0)/r1r0sq)/widflx(i0)
      i1 = ipHn(2)
      f1 = (outcon(i1)+refcon(i1)/r1r0sq)/widflx(i1)
      slope = ( f1 - f0 ) / ( anu(i1)-anu(i0) )
      bhead = f1 + (0.250-anu(i1))* slope
*
*     extrapolated continuum below head
      i2 = ipHn(2)-1
      f2 = (outcon(i2)+refcon(i2)/r1r0sq)/widflx(i2)
      i3 = ipHn(2)-2
      f3 = (outcon(i3)+refcon(i3)/r1r0sq)/widflx(i3)
      slope = ( f3 - f2 ) / ( anu(i3)-anu(i2) )
      below = f2 + (0.250-anu(i2))* slope
*     extrapolate to point above Balmer continuum
      flow = f2 + (f2-f3)
      bac = f1 - flow
*
*     convert to nuFnu units
      bhead = f1
      below = f2
      bac = (bhead-below) * 0.250*0.250 *en1ryd*r1r0sq
      sumlin(nsum+1) = 0.
*     residual flux at head of Balmer continuum, nuFnu
      call linadd( max(0.,bac)/dVeff , 3646 , 'BaC ','i')
*
      f1 = (ContDiff(i1))/widflx(i1)
      f2 = (ContDiff(i2))/widflx(i2)
      bac = (f1-f2) * 0.250*0.250 *en1ryd*r1r0sq
      sumlin(nsum+1) = 0.
*     residual flux in Balmer continuum, nuFnu
      call linadd( max(0.,bac)/dVeff , 3646 , 'cdif','i')
*
      f1 = (outcon(i1))/widflx(i1)*r1r0sq
      f2 = (outcon(i2))/widflx(i2)*r1r0sq
      bac = (f1-f2) * 0.250*0.250 *en1ryd
      sumlin(nsum+1) = 0.
*     residual flux in Balmer continuum, nuFnu
      call linadd( max(0.,bac)/dVeff , 3646 , 'cout','i')
*
      f1 = refcon(i1)/widflx(i1)
      f2 = refcon(i2)/widflx(i2)
      bac = (f1-f2) * 0.250*0.250 *en1ryd
      sumlin(nsum+1) = 0.
*     residual flux in Balmer continuum, nuFnu
      call linadd( max(0.,bac)/dVeff , 3646 , 'cref','i')
*
      f1 = DiffCont(i1)/widflx(i1)
      f2 = DiffCont(i2)/widflx(i2)
      bac = (f1-f2) * 0.250*0.250 *en1ryd
*     residual flux in Balmer continuum, nuFnu
      call linadd( max(0.,bac) , 3646 , 'thin','i')
*
*     large number of C, N, and O recombination lines
      if( ipass.eq.0 ) lgRecOn = .true.
      do i=1,471
        chLabel(1:2) = chElementSym(int(RecCoefCNO(i,1)))
        chLabel(3:4) = chIonStage(int(RecCoefCNO(i,1)-
     1  RecCoefCNO(i,2)+1.01))
*       number of rec per unit vol
*       >>chng 97 aug 28, do not predict rec intensities at high densities
*       blr.in and oldblr.in go nuts if this is added in outward beam
        if( eden.lt.1e8 .and. lgRecOn ) then
          f2 = RecCoefCNO(i,4)*eden*xIonFracs(int(RecCoefCNO(i,1)) ,
     1    int(RecCoefCNO(i,1)-RecCoefCNO(i,2)+2) )
*         convert to intensity
          f2 = f2 * 1.99e-8 / RecCoefCNO(i,3)
        else
          lgRecOn = .false.
          f2 = 0.
        endif
        call PntForLine( RecCoefCNO(i,3) , chLabel , ipnt )
        call lindst(f2,int(RecCoefCNO(i,3)+.5),chLabel,ipnt,'r',.true.)
*       call linadd(f2,int(RecCoefCNO(i,3)+.5),chLabel     ,'r')
      end do
*
*     add in all the other lines
*     Dima'a 6k lines
      ExtraCool = 0.
      BigstExtra = 0.
      do i=1,NWINDLINE
        call PutLine( WindLine(1,i) )
        if( WindLine( ipLnCool,i).gt.BigstExtra ) then
          BigstExtra = WindLine(ipLnCool,i)
          ipMaxExtra = i
        endif
        ExtraCool = ExtraCool + WindLine(ipLnCool,i)
      end do
      GBarMax = max( GBarMax , ExtraCool/ctot )
*
      nsumtt = nsum
      if( lgTrace ) write(qq,'('' lines returns'')')
*
      end
***********************************************************
      real function GetLineRec( ip , lWl )
      implicit none
*return rec coef*hnu for C, N, or O recombination lines from Dima's list
      integer ip , lWl
      integer limelm
      parameter (limelm=30)
*     save rec coef data for recombination lines of C, N, O
      real RecCoefCNO(471,4)
      common/RecCNO/ RecCoefCNO
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*begin sanity check
      if( int(RecCoefCNO(ip,3)+0.5).ne. lWl ) then
        write(qq,'('' GetLineRec called with incorrect wavelength.'')')
        write(qq,'('' index, call and get wl are '',3i5)') ip, lWl,
     1  int(RecCoefCNO(ip,3)+0.5)
        stop
      endif
*end sanity check
*
*     final produce is vol emissivity in line
      GetLineRec = RecCoefCNO(ip,4)*eden*
     1 xIonFracs(int(RecCoefCNO(ip,1)) ,
     1   int(RecCoefCNO(ip,1)-RecCoefCNO(ip,2)+2) ) * 1.99e-8 /
     2   RecCoefCNO(ip,3)
*
*     zero out rec coef so that not used again in master dump
*     this routine cannot be called twice on same line
      RecCoefCNO( ip,4) = 0.
*
      end
**************************************************************************
      subroutine lint( xarray , yarray , n , xval , yval )
      implicit none
*do linear interpolation, used for grains opacity
      integer n
      real xarray(n) , yarray(n) , xval , yval
*
*     local variables
      integer i
*
      do i=1,n-1
        if( xval.le.xarray(i+1) ) then
           yval = (xval - xarray(i)) / (xarray(i+1)-xarray(i))
     1     * (yarray(i+1)-yarray(i)) + yarray(i)
           return
        endif
      end do
*
      end
      subroutine lithi
      implicit none
*compute ionization balance for lithium
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=4)
      parameter (nelem=3)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*
*     lithium nelem=3
*     data are for carbon
*
*     real CollidRate(nelem,2)
*     fluorescent fields, first dim is stage of ionization, sec is shell
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.44e-10,4.20e-11,1.92e-11/
      data (cion(i,2),i=1,ndim-1)
     2 /1.31e5,2.83e5,5.56e5/
*     DATA GRDEFF/0.10,0.10,0.10/
*     GRDEFF is fraction of recombinations to ground state, used for
*     outward diffuse fields
*
*     rec from +3, +4 from Arnaud et al Ast Ap Sup 60 425. (1985)
*     rec from fully ionized uses Seaton '79 in ionrat
      data rec , pl/
     1 1.47e-10 , 8.74e-10 ,
     2  -0.624  , -0.645   /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/1.44e-10 , -0.621/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.54E-3 , 6.15E-3 ,  0./
      data (dicoef(i,2),i=1,ndim-1)
     1/4.42E-2 , 5.88E-2 ,  0./
      data (dite(i,1),i=1,ndim-1)
     2/1.57E+5 , 1.41E+5 , 0./
      data (dite(i,2),i=1,ndim-1)
     2 /3.74E5 , 1.41E5 ,  0./
      data ditcrt
     3/1.2E+4 , 1.2E+4 , 1E20/
*
      data aa/  .0108  ,1.8267 ,0./
     1  ,  bb/-0.1075  ,4.1012 ,0./
     1,    cc/  .2810  ,4.8443 ,0./
     2,    dd/-0.0193  ,.2261  ,0./
     3,    ff/ 0.001   ,0.5960 ,0./
*
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
*     zero out ionization balance arrays
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2 aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine magnes
      implicit none
*ionization balance for magnesium
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer ipmgex ,ipOpMgEx
      real xmglst, popmg2 , rmg2l , xMg2Max
*     these all deal with photoionization from upper lev of Mg II 2798
      common/mgexc/ ipmgex , xmglst, popmg2 , rmg2l , xMg2Max,ipOpMgEx
      real hi , hii
      common/h/ hi , hii
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=13)
      parameter (nelem=12)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
      real gamfun
*
*     magnesium nelem=12
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /8.90E-11,5.90E-11,1.10E-11,9.14E-12,5.02E-12,2.73E-12,
     1 1.47E-12,7.35E-13,4.11E-13,1.64E-13,1.42E-14,5.74E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /8.87E4,1.74E5,9.30E5,1.26E6,1.64E6,2.17E6,2.61E6,
     2 3.09E6, 3.81E6,4.25E6,2.04E7,2.27E7/
*
*     rec from +9, +10, +11 from Arnauld et al '85
      data rec , pl
     1/ 6.86E-10, 3.04E-9, 3.02E-9, 5.73E-9, 1.02E-8, 1.38E-8, 1.86E-8,
     2  3.21E-8 , 7.84E-8, 2.34E-7, 4.15E-7,
     2  -0.855  , -0.838 , -0.734 , -0.718 , -0.716 , -0.695 , -0.691 ,
     3  -0.711  , -0.765 , -0.829 , -0.821  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 2.01e-10 , -0.681/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/4.49e-4, 1.95e-3, 5.12e-3, 7.74e-3, 1.17e-2, 3.69e-2,
     2 3.63e-2, 4.15e-2, 8.86e-3, .252, .144, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.021, .074, .323, .636, .807, .351, .548, .233, .318,
     2 .315, .291, 0./
      data (dite(i,1),i=1,ndim-1)
     1 /5.01e4, 6.06e5, 4.69e5, 3.74e5, 3.28e5, 4.80e5, 3.88e5,
     2 3.39e5, 2.11e5, 1.40e7, 1.50e7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/2.81e4, 1.44e6, 7.55e5, 7.88e5, 1.02e6, 9.73e5, 7.38e5,
     2 3.82e5, 1.54e6, 2.64e6, 3.09e6, 0./
      data ditcrt
     5/4.0E3  , 7.4E4  , 6.6E4  , 5.5E4  , 4.4E4  , 4.5E4  ,
     6 4.5E4  , 5.0E5  , 3.4E4  , 2.4E6  , 4.0E6  , 1E20/
*
*     mg i from nuss+storey, who say that =>Mgii is very small
      data aa/1.2044 , 11*0./, bb/-4.6836 , 11*0./,
     1     cc/7.6620 , 11*0./, dd/-0.5930 , 11*0./,
     2     ff/1.6260 , 0.1,10*0./
*
*     magnesium, atomic number 12
      if( .not.lgElmtOn(12) ) then
        xMg2Max = 0.
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     charge exchange ionization, Allan et al. 1988, MNRAS 235, 1245.
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(1,1) = CTHeavy(1,1) + HII * 7.5E-19 * TE*TE*TE10
*     charge exchange, rates from Butler and Dalgarno 1980B
*     MG+2 => MG+
*     CTHeavy(2,2) = CTHeavy(2,2) + 9E-14 * HI
*     T = MIN( SQRTE , 200. )
*     MG+3 => MG+2
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(3,2) = CTHeavy(3,2) + 6.5E-11 * T*HI + HEI*7E-10
      CTHeavy(3,2) = CTHeavy(3,2) + hei*7e-10
*     MG+4 => MG+3
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(4,2) = CTHeavy(4,2) + 6.5E-11 * T * HI + HEI*3E-9
      CTHeavy(4,2) = CTHeavy(4,2) + hei*3E-9
*
      if( lgDoPhoto .and. IonLow(nelem).le.1 ) then
*       can only do this one time
*       photoionization from excited upper state of 2798
        rmg2l = gamfun(ipmgex, ipHn(1), ipOpMgEx )
        PhotoRate(nelem,2,4,1) = PhotoRate(nelem,2,4,1) + rmg2l*popmg2
        if( nzone.le.1 ) then
          xMg2Max = 0.
        else if( PhotoRate(nelem,2,4,1).gt.1e-30 )  then
*         remember max rel photo rate
          xMg2Max = max(xMg2Max, rmg2l*popmg2/PhotoRate(nelem,2,4,1) )
        endif
      else
        xMg2Max = 0.
      endif
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
*     write(88,'(1p,9e10.2)')(photorate(nelem,2,i,1),i=1,4)
*     call PrtGamma(ipMagnesium(2,4,1) ,ipMagnesium(2,4,2) ,
*    1 ipMagnesium(2,4,3),
*    1 qq,  photorate(nelem,2,4,1) ,photorate(nelem,2,4,1)*0.05 )
*
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if(lgTrace.and.lgHeavyBug) then
        write(qq,'(5X,''MAGNES returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
******************************************************************************
      program MainCl
      implicit none
*main program that calls cloudy when used as a stand-alone program
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      real failmx
*     info related to the number of temperature or pressure failures
*     failmx is largest relative error in heating cooling match
*     nPreFail is number of pressure failuers
      integer nfail , nPreFail
      common/nfail/ nfail , failmx , nPreFail
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgOK
      call cdInit
      call cdDriv( lgOK )
      write(qq,'('' Cloudy ends:'',i3,'' warnings,'',i3,'' cautions,'',
     1i3,'' temperature failures,'',i3,'' pressure failures,'',i4,
     2'' zones,'',i3,'' iterations.'')')
     3 nwarn , ncaun , nfail , nPreFail,nzone, iter
*
      stop
      end
*****************************************************************
      subroutine MakeCS( t )
      implicit none
*compute collision strength by g-bar approximations
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real t(nta)
*
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real WavNRyd
*number of Ryd per wavenumber
*from Physics Today '96, BG 10
      parameter (WavNRyd=9.1126732e-6)
      integer limelm
      parameter (limelm=30)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     routine to get cs from various approximations
*
*     local variables
      real Abun , cs , gbar
      integer ion
*
*     check if abundance greater than 0
      ion = t(ipLnIonStg)
      Abun = xIonFracs( int(t(ipLnNelem)) , ion )
      if( Abun.le.0. ) then
        gbar = 1.
      else
*       check if neutral or ion
        if( ion .eq.1 ) then
*         neutral - compute gbar for evantual cs
          call gbar0(t(ipLnBolt) , gbar )
        else
*         ion - compute gbar for evantual cs
          call gbar1(t(ipLnBolt) , gbar )
        endif
      endif
*
*     above was g-bar, convert to cs
      cs = gbar * (14.5104/WavNRyd) * t(ipLnGF)/ t(ipLnEnrWN)
*
*     stuff the cs in place
      t( ipLnCS ) = cs
*
      end
******************************************************************************
      subroutine MakeDeriv(job ,hmc ,te ,DerivNumer)
      implicit none
*derive numerical derivative of heating minus cooling
      character job*4
      real hmc , DerivNumer , te
*
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nstore , nstMax , i
      parameter (nstMax=50)
      real hmcSave(nstMax) , TeSave(nstMax) , dTe
      save hmcSave , TeSave , nstore
*
      if( job.eq.'zero' ) then
        nstore = 0
      else if( job.eq.'incr' ) then
        nstore = nstore + 1
        if( nstore .gt. nstMax ) then
          write(qq,'('' too many stores for MakeDeriv'')')
          nstore = nstMax
        endif
        hmcSave(nstore) = hmc
        TeSave(nstore) = te
        if( nstore.gt.1 ) then
          DerivNumer = 0.
          do i=1,nstore-1
            dTe = TeSave(i)-TeSave(i+1)
            if( dTe.ne.0. ) then
              DerivNumer = DerivNumer + (hmcSave(i)-hmcSave(i+1)) / dTe
            endif
          end do
          DerivNumer = DerivNumer / (nstore-1)
        else
          DerivNumer = 0.
        endif
      else
        write(qq,'('' MakeDeriv called with insane job='',a4)')job
        stop
      endif
      end
      subroutine MakeHydro
      implicit none
*make data for hydrogen and helium, 1 per coreload
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer nhetau
      parameter (nhetau=4)
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real HIonPot
      parameter (HIonPot=0.99946)
*ionization potential of real hydrogen atom, in inf mass ryd
*     TexcLya is the excitation temperature of Lya
*     nLyaHot is counts how ofter Lya hotter than gas
*     TLyaMax is hottest
*     TeLyaMax is electron temp at point where Lya max
*     nZTLaMax is the zone where this happened
      real TexcLya , TLyaMax , TeLyaMax
      integer nLyaHot , nZTLaMax
      common/LyaExT/ TexcLya , nLyaHot , TLyaMax , TeLyaMax , nZTLaMax
      real HColOn
*     normally is unity, set to zero when hydrogen collisions turned off
      common/hydata/ HColOn
      double precision he3bn
      common/he3bn/ he3bn(nhe3lvl)
      real he3n
      common/he3n/ he3n(nhe3lvl)
      real he3tau
      common/he3tau/ he3tau(nta,nhetau)
      real he3pht , he3lya , he3local , he3relax
*     he3relax is fraction of 23s populations that go to singlets
      common/he3pht/ he3pht , he3lya , he3local , he3relax
      real he2dmp
      common/he2dmp/ he2dmp(9)
      real he1dmp
      common/he1dmpCOM/ he1dmp(9)
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real he2as
      common/he2as/ he2as(9,8)
      real ophf
      common/ophf/ ophf(lmhlvl)
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
      real He1EinA
*transition prob for He 1 singlets
      common/he1as/ He1EinA(9,8)
      real HeAsSav
*Einstein a's used for helium
      common/AsSav/ HeAsSav(9,8)
      real hlife
      common/hlife/ hlife(lmhlvl)
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      real the1lo
      integer nhe1lo
      common/the1lo/ the1lo , nhe1lo
      real the2lo
      integer nhe2lo
      common/the2lo/ the2lo , nhe2lo
      real hetrip
      integer ipHe3l(4)
      common/hetrip/ hetrip(11) , ipHe3l
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      real he1qin,he1rin
      common/he1ind/ he1qin(nhe1lvl+1),he1rin(nhe1lvl+1)
      real he2qin,he2rin
      common/he2ind/ he2qin(nhe2lvl+1),he2rin(nhe2lvl+1)
      real he1cin
      common/he1cin/ he1cin(10)
      real he2cin
      common/he2cin/ he2cin(10)
*     energy differences for model hydrogen atom:
*     this is array of temperatures, first between levels, sec lev to cont
*     HdeltaT( upper , lower )
      real HdeltaTe, HCionTe
      common/HdeltaT/ HdeltaTe(lmhlvl,lmhlvl), HCionTe(lmhlvl)
*     energy differences for model he singlet atom:
*     this is array of temperatures, first between levels, sec lev to cont
*     He1deltaT( upper , lower )
      real He1deltaTe, He1CionTe
      common/He1deltaT/ He1deltaTe(nhe1lvl,nhe1lvl), He1CionTe(nhe1lvl)
*energy differences for model he ion:
*this is array of temperatures, first between levels, sec lev to cont
*He2deltaT( upper , lower )
      real He2deltaTe, He2CionTe
      common/He2deltaT/ He2deltaTe(nhe2lvl,nhe2lvl), He2CionTe(nhe2lvl)
*     energy differences for levels in the model hydrogen atom:
      real HEnerRyd
      common/HEnrRyd/ HEnerRyd(lmhlvl,lmhlvl)
*     energy differences for model helium singlet atom:
      real He1EnerRyd
      common/He1EnrRyd/ He1EnerRyd(nhe1lvl,nhe1lvl)
*energy differences for model helium ion:
      real He2EnerRyd
      common/He2EnrRyd/ He2EnerRyd(nhe2lvl,nhe2lvl)
      real HLevNIonRyd
*ionizatoin potention of hydrogenic level n
*set in makehydro
      common/HNIonRyd/ HLevNIonRyd(lmhlvl+1)
*ionization potential of level n, in Rydbergs
      real He1IonRyd
      common/He1NIonRyd/ He1IonRyd(nhe1lvl+1)
      real He2IonRyd
*ionization potential of level n in Ryd for HeII ion
      common/He2NIonRyd/ He2IonRyd(nhe2lvl+1)
*
*     local variables
      real EinstA , scrhe1 , test
      integer i , j , n , iup , lo
*
*     upper level 4 and above, goind to lower level 2 and above,
*     come from the hlife and branch product formed in routine pesc
*     all other values come from here
*
*     fill in A's with Jason's routine
      do lo=1,nhlvl-1
        do iup=lo+1,nhlvl
          hyas(iup,lo) = EinstA(iup,lo)
          hemis(iup,lo) = EinstA(iup,lo)
        end do
      end do
*
*     2p 1s is special since do not assume 2s 2p mixed
      hyas(2,1) = 6.265E8
      hdamp(2) = hyas(2,1)* 7.958e-6/0.75
*
*NB NB hdamp is only dimensioned up through nhlvl, so 2s-1s has no damp cnst
      hlife(2) = hyas(2,1)
      do iup=3,nhlvl
        hlife(iup) = 0.
        do lo=2,iup-1
*         array of damping constants for hydrogen
          hlife(iup) = hlife(iup) + hyas(iup,lo)
        end do
        hdamp(iup) = (hlife(iup)+hyas(iup,1)) * 7.958e-6/(1.-1./
     1  float(iup*iup))
      end do
*     level not possible
      hdamp(1) = 0.
*
*     define excitation and ionization temperatures for hydrogen
*
      do iup=1,nhlvl
*     >>chng 96 aug 22, had been 1 ryd in below, off by 3 cells for 1 ryd
*       HLevNIonRyd(iup) = 0.99946 / float(iup**2)
*     >>chng 96 dec 18, put 0.99946 in parameter statement
        HLevNIonRyd(iup) = HIonPot / float(iup**2)
        HCionTe(iup) = te1ryd* HLevNIonRyd(iup)
*       fill in stat weights for hydrogen
        hstat(iup) = 2.*(iup**2)
      end do
      hstat(2) = 6.
*     this is 2s, the "highest" level in model atom
      hstat(nhlvl+1) = 2.
      HLevNIonRyd(nhlvl+1) = HLevNIonRyd(2)
*
*     statistical weights for helium singlet atom and ion
      do iup=1,nhe1lvl
        He1IonRyd(iup) = 1. / float(iup**2)
        He1CionTe(iup) = te1ryd* He1IonRyd(iup)
        he1stat(iup) = iup**2
      end do
*     ground and n=2 not hydrogenic
      He1IonRyd(1) = 1.80802
      He1IonRyd(2) = 0.2478
      He1IonRyd(nhe1lvl+1) = He1IonRyd(2)
      he1stat(nhe1lvl+1) = 1.
      he1stat(2) = 3.
*
*     helium ion He II HeII
      do iup=1,nhe2lvl
        he2stat(iup) = 2.*(iup**2)
        He2IonRyd(iup) = 4. / float(iup**2)
        He2CionTe(iup) = te1ryd* He2IonRyd(iup)
      end do
      he2stat(2) = 6.
      he2stat(nhe2lvl+1) = 2.
      He2IonRyd(nhe2lvl+1) = He2IonRyd(2)
*
      do iup=2,nhlvl
        do lo=1,iup-1
          HEnerRyd(iup,lo) = HLevNIonRyd(lo) - HLevNIonRyd(iup)
          HdeltaTe(iup,lo) = te1ryd * HEnerRyd(iup,lo)
        end do
      end do
*
      do iup=2,nhe1lvl
        do lo=1,iup-1
          He1EnerRyd(iup,lo) = He1IonRyd(lo) - He1IonRyd(iup)
          He1deltaTe(iup,lo) = te1ryd * He1EnerRyd(iup,lo)
        end do
      end do
*
      do iup=2,nhe2lvl
        do lo=1,iup-1
          He2EnerRyd(iup,lo) = He2IonRyd(lo) - He2IonRyd(iup)
          He2deltaTe(iup,lo) = te1ryd * He2EnerRyd(iup,lo)
        end do
      end do
*
      do i=1,nhlvl+1
        hbn(i) = 1.
      end do
*
      do i=1,nhlvl+1
        cinduc(i) = 0.
        finduc(i) = 0.
        rinduc(i) = 0.
      end do
      do i=1,nhe1lvl+1
        he1qin(i) = 0.
        he1rin(i) = 0.
      end do
      do i=1,nhe2lvl+1
        he2qin(i) = 0.
        he2rin(i) = 0.
      end do
*
      do i=1,nhetau
        he3tau(ipLnTauIn,i) = taumin
        he3tau(ipLnTauTot,i) = 1e20
        he3tau(ipLnEscP,i) = 1.
        he3tau(ipLnInwd,i) = 1.
      end do
*
      do i=1,nhlvl+1
        hgamnc(i) = 0.
        hn(i) = 1e-35
        hcolnc(i) = 0.
        hrec(i,1) = 0.
        hrec(i,2) = 1.
        hrec(i,3) = 1.
        do j=i+1,nhlvl
          hcol(j,i) = 0.
        end do
      end do
      do i=1,nhlvl
        do j=i+1,nhlvl
          hdest(j,i) = 0.
          hdest(i,j) = 0.
          hemis(i,j) = 0.
          htlim(i,j) = 0.
        end do
      end do
      hn2s = 1e-30
      hn2p = 1e-30
*
*     this is hydrogenic screening factor for HeI singlet ground state
      scrhe1 = 1.808
      do i=1,nhe1lvl-1
*       damping constant scales as A*lambda, or z
        he1dmp(i) = hdamp(i)
        he1gam(i) = 0.
        he1n(i) = 1e-35
        he1clc(i) = 0.
        he1rec(i,1) = 0.
        he1rec(i,2) = 1.
        he1rec(i,3) = 1.
        do j=i+1,nhe1lvl
          he1cll(j,i) = 0.
*         scale HeII A's from hydrogen
          He1EinA(j,i) = scrhe1 * HeAsSav(j,i)
*         destruction probabilities
          he1dst(j,i) = 0.
          he1mis(j,i) = 0.
        end do
        scrhe1 = 1.
      end do
*
      do i=1,nhe2lvl-1
*       damping constant scales as A*lambda, or z
        he2dmp(i) = hdamp(i) * 4.
        he2gam(i) = 0.
        he2n(i) = 1e-35
        he2clc(i) = 0.
        he2rec(i,1) = 0.
        he2rec(i,2) = 1.
        he2rec(i,3) = 1.
        do j=i+1,nhe2lvl
          he2cll(j,i) = 0.
*         scale HeII A's from hydrogen, A's go as Z^4,
*         Wiese et al. viiii
          he2as(j,i) = 16. * HeAsSav(j,i)
*         destruction probabilities
          he2dst(j,i) = 0.
          he2mis(j,i) = 0.
        end do
      end do
      do n=1,nhlvl
        ophf(n) = 0.
      end do
      do n=1,nhe1lvl
        ophe1f(n) = 0.
      end do
      do n=1,nhe2lvl
        ophe2f(n) = 0.
      end do
*
*     self consistent opacity from hydrogen A's
*     ok to use hstat(2) for upper stat weight of Lya since special
*     when lower level is 2 must use stat weight of 8
      do lo=1,nhlvl-1
        if( lo.eq.2 ) then
          test = 8.
        else
          test = hstat(lo)
        endif
*       HeAsSav is dimensioned 10,9 so will not work for arbitrary
*       levels - but hopac will be fixed when As set with branch
        do iup=lo+1,nhlvl
          hopac(iup,lo) = hyas(iup,lo) * 2.24484e-26 *
     1    hstat(iup)/test * (rydlam/HEnerRyd(iup,lo))**3
        end do
      end do
*
*     >>chng 96 may 31, big mistake in HeII opacities
*     >>chng 96 june 4, smaller big mistake in HeII opacities
      do lo=1,nhe2lvl-1
        if( lo.eq.2 ) then
          test = 8.
        else
          test = he2stat(lo)
        endif
        do iup=lo+1,nhe2lvl
          he2opc(iup,lo) = he2as(iup,lo) * 2.24484e-26 *
     1    he2stat(iup)/test * (rydlam/He2EnerRyd(iup,lo))**3
*         scale HeII opacities from hydrogen
*         he2opc(iup,lo) = hopac(iup,lo) / 4.
        end do
      end do
*
*     scrhe1 = 1.808
*     >>chng 96 may 31, big mistake in HeI opacities
*     >>chng 96 june 4, smaller big mistake in HeI opacities
      do lo=1,nhe1lvl-1
        if( lo.eq.2 ) then
          test = 8.
        else
          test = he1stat(lo)
        endif
        do iup=lo+1,nhe1lvl
          he1opc(iup,lo) = He1EinA(iup,lo) * 2.24484e-26 *
     1    he1stat(iup)/test * (rydlam/He1EnerRyd(iup,lo))**3
*         he1opc(j,i) = hopac(j,i) / scrhe1
        end do
*       scrhe1 = 1.
      end do
*     HeI ground state is special
      he1opc(2,1) = 2.42e-8
      He1EinA(2,1) = 17.99e8
      he1dmp(2) = he1dmp(2) * 1.37
      he1n(nhe1lvl) = 1e-30
      he2n(nhe2lvl) = 1e-30
      hgamnc(nhlvl) = 0.
      he1gam(nhe1lvl) = 0.
      he2gam(nhe2lvl) = 0.
      hcolnc(nhlvl) = 0.
      he1clc(nhe1lvl) = 0.
      he2clc(nhe2lvl) = 0.
      he1rec(nhe1lvl,1) = 0.
      he2rec(nhe2lvl,1) = 0.
      he1rec(nhe1lvl,2) = 1.
      he2rec(nhe2lvl,2) = 1.
      he1rec(nhe1lvl,3) = 1.
      he2rec(nhe2lvl,3) = 1.
      he2dmp(nhe2lvl) = hdamp(9) * 16.
      he1dmp(nhe1lvl) = hdamp(9)
      he22s = 1e-30
      he22p = 1e-30
      he12s = 1e-30
      he12p = 1e-30
*
*     zero out inner optical depths
      do i=1,nhlvl-1
        do j=1,nhlvl
          htnext(j,i) = taumin
          htau(j,i) = taumin
        end do
      end do
      do i=1,nhe1lvl-1
        do j=1,nhe1lvl
          he1nxt(j,i) = taumin
          he1tau(j,i) = taumin
        end do
      end do
      do i=1,nhe2lvl-1
        do j=1,nhe2lvl
          he2nxt(j,i) = taumin
          he2tau(j,i) = taumin
        end do
      end do
      t206(ipLnTauIn) = taumin
      t206(ipLnTauTot) = taumin
      t206(ipLnEscP) = 1.
      t206(ipLnInwd) = 0.5
      t206(ipLnAul) = 1.976e6
*
      end
******************************************************************************
      subroutine MakeOpacity( nelem )
      implicit none
*generate ionic subshell opacities by calling phfit
      integer nelem
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real AnuOrg
*original set of energy units, always the same no matter what the
*shape of the continuum - actual energy units change with shape
      common/anusave/ AnuOrg(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real PH1
*     ph1(a,b,c,d)
*     a=1 => thresh, others fitting parameters
*     b atomic number
*     c number of electrons
*     d shell number 7-1
      common/PH1/ PH1(6,30,30,7)
      integer noptot
      common/noptot/ noptot
      integer ipPoint
      logical lgPunPoint
*option to punch out pointers with punch pointers commmand
*ipPoint is punch unit number, lgPunPoint says whether we will do it
      common/PunPoint/ ipPoint , lgPunPoint
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      real opac
      common/opac/ opac(ncell)
      integer KshellLimit
      real EnergyKshell
      common/KshllEnr/ KshellLimit , EnergyKshell
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
      logical lgPhFit
*which version of phfit should be used?
      common/PhFitOn/ lgPhFit
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nion , nshell,nelec,limit,need,low,ihi,ipop,ip
      real cs , energy
      logical lgOK
*
      do nion=1,nelem
*begin sanity check
        do ip=1,ncell
          opac(ip) = 0.
        end do
*end sanity check
*       number of bound electrons
        nelec = nelem - nion + 1
        do nshell=1,nsShells(nelem,nion)
          ipElement(nelem,nion,nshell,3) = noptot + 1
*         this is continuum pointer upper limit for energy range of this shell
          limit = ipElement(nelem,nion,nshell,2)
*         this is number of cells in continuum needed to store opacity
          need = limit - ipElement(nelem,nion,nshell,1) + 1
*
*         check that opsv will have enough frequeny cells
          if( noptot + need.gt.NOPSV ) then
            write(qq,'('' MakeOpacity needs more opacity cells than ''
     1      ,''NOPSV,  increase it.'')')
            write(qq,'('' element, Ion, are'',2i3)') nelem,nion
            stop
          endif
*
*         set lower and upper limits to this range
          low = ipElement(nelem,nion,nshell,1)
          ihi = ipElement(nelem,nion,nshell,2)
          ipop = ipElement(nelem,nion,nshell,3)
*         write(qq,'('' shell'',i3,'' opac offset'',i9,'' NuLo'',1p,
*    1    e9.1,'' Nuup'',e9.1)')
*    1     nshell,ipElement(nelem,nion,nshell,3),AnuOrg(low),AnuOrg(ihi)
*begin sanity check
          if( low.gt.ihi .and. low.gt.5 ) then
            write(qq,'('' MakeOpacity has insane pointers.'')')
            write(qq,'('' nelem,nion,shell'',9i10)')  nelem,nion,
     1      nshell,low,ihi
            call ShowMe
            stop
          endif
*end sanity check
          do ip=low,ihi
*     >>chng 96 oct 8 add min to ip, so never eval below threshold
            energy = max( AnuOrg(ip)*evryd,PH1(1,nelem,nelec,nshell) )
            call phfit( nelem, nelec , nshell , energy ,cs,lgPhFit)
            OpacStack(ip-low+ipop) = cs*1e-18
*begin sanity check
            opac(ip) = opac(ip) + cs
*end sanity check
          end do
          noptot = noptot + ihi - low + 1
*         punch pointers option
          if(lgPunPoint) then
            write(ipPoint,'(3i3,1p,4e10.2)')
     1      nelem,nion,nshell,anu(low),anu(ihi),OpacStack(ipop),
     2      OpacStack(ihi-low+ipop)
          endif
        end do
*begin sanity check
*       write(6,'('' checking el'',2i3,'' range'',1p,2e10.2)')
*    1  nelem,nion,anu(ipElement(nelem,nion,nsShells(nelem,nion),1)),
*    1  anu(KshellLimit)
        lgOK = .true.
        do ip=ipElement(nelem,nion,nsShells(nelem,nion),1),KshellLimit
          if( opac(ip).le.0. ) then
           lgOK = .false.
           write(qq,'('' MakeOpacity finds insane opacity, nelem, nu='',
     1     2i3,1p,2e10.2)') nelem, nion,anu(ip), opac(ip)
          endif
        end do
*end sanity check
      end do
      if( .not.lgOK ) then
        write(qq,'('' MakeOpacity: insanity has occurred.'')')
        call ShowMe
        stop
      endif
*
      end
******************************************************************************
      subroutine MakeRecomb( rec,pl, dicoef,dite,ditcrt,aa,bb,cc,dd,ff,
     2 nelem,tlow)
      implicit none
*generate recombination coefficients for any species
      integer nelem
      real rec(nelem-1) , pl(nelem-1) , dicoef(nelem,2),
     1 dite(nelem,2) , ditcrt(nelem) , aa(nelem) , bb(nelem) ,
     2 cc(nelem) , dd(nelem) , ff(nelem) , tlow(2)
*
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real DiffusHeavy , xLyaHeavy
*DiffusHeavy is total rec rate to grnd for nelem,ion element
*xLyaHeavy is Lya for nelem,ion
      common/DiffHeav/ DiffusHeavy(limelm,limelm),
     1 xLyaHeavy(limelm,limelm)
*recombination rates for the elements
*first dim is nelem, the atomic number of element
*secnd dim is stage of ionizaiton, 1 for atom
      real RecombinRate(limelm,limelm)
      common/RecomRate/ RecombinRate
      integer nsbig
      common/nsbig/ nsbig
      logical lgNoCota
*lgNoCota flag set with no three body recombination
      real CotaRate
      common/rcota/ lgNoCota , CotaRate(limelm)
      real worksv
      common/worksv/ worksv(32)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real te , eden , hden
      common/phycon/ te , eden , hden
      real GuessDiel
*this is fudge factor for scaled nussbamer and story diel recom
*set with diel kludge commmand, usually 1
      common/cludon/ GuessDiel
      real GrnIonRec , grecon
*rate coefficient for ionic recombination on grain surfaces, eval in hmole
*grecon usually 1, set to 0 with no grain neutralization command
      common/gionrc/ GrnIonRec , grecon
      real supprs
*     suppresssion factors for dielectronic recombination
*     1 is burgess and 2 is storey
      common/supprs/ supprs(limelm,2)
      logical lgVrrFit
*which version of Dima's routine to use?
      common/vrrfit/ lgVrrFit
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
      integer ioreco
      common/ioreco/ ioreco
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , iupper , NeBound
      real fac2 , t4m1,z,xlam,radrec,sexp , tefac
      real SaveRate(limelm,3)
      real cludge(4)
      data cludge/ 3e-13 , 3e-12 , 1.5e-11 , 2.5e-11/
*
*     free statement labels >= 7
*
*     set up ionization balance matrix, C(I,1)=destruction, 2=creation
*     heating rates saved in array B(I) in same scrat block
*     factor is for Aldrovandi+Pequignot fit, FAC2 is for Nuss+Storey
*     fit for dielectronic recomb
*     GrnIonRec is rate ions recombine on grain surface, normally zero;
*     set in hmole, already has factor of hydrogen density
*
      if( IonLow(nelem).lt.1 .or. IonHigh(nelem).gt.nelem+1) then
        write(qq,'('' MakeRecom called with insane low,nstage'')')
        write(qq,*)' nelem, low, nstage=',nelem,IonLow(nelem),
     1  IonHigh(nelem)
        stop
      endif
      nsbig = max( IonHigh(nelem) , nsbig )
      t4m1 = 1e4 / te
      fac2 = 1e-14 * sqrte
*
*     zero out ionization, rec, heating save arrays
      do i=1,nelem
        RecombinRate(nelem,i) = 0.
        SaveRate(i,1) = 0.
        SaveRate(i,2) = 0.
        SaveRate(i,3) = 0.
      end do
*
*------------------------------------------------------------------
*
*     do h-like stage with Seaton '59 formula
*
      z = nelem
      if( IonHigh(nelem)-1.eq.nelem ) then
        xlam = 157890. * z * z / te
*
*       radiative recombination
        if( lgVrrFit ) then
          call rrfit( nelem , 1 , te , radrec )
        else
          radrec = ( 5.197e-14*z* sqrt(xlam) *
     1    (0.4288 + 0.5*log(xlam) + 0.469*(xlam**(-0.33333) )) )
        endif
        SaveRate(IonHigh(nelem)-1,1) = radrec +
     1  CotaRate(IonHigh(nelem)-1)
*
*       three body, grain surface recombinations
        RecombinRate(nelem,IonHigh(nelem)-1) = eden *
     1  (CotaRate(IonHigh(nelem)-1)+radrec)+
     1  GrnIonRec
*       this is supposed to be the ground term of the recombination
        DiffusHeavy(nelem,IonHigh(nelem)-1) = radrec*eden / 10.
        xLyaHeavy(nelem,IonHigh(nelem)-1) = radrec*eden / 10.
*
*       work function
        worksv(IonHigh(nelem)-1) = RecombinRate(nelem,IonHigh(nelem)-1)*
     1  anu( ipElement(nelem,IonHigh(nelem)-1,
     2  nsShells(nelem,IonHigh(nelem)-1),1) )
        iupper = IonHigh(nelem)-1 - 1
      else
        iupper = IonHigh(nelem)-1
      endif
*
*---------------------------------------------------------------------
*
      do i=IonLow(nelem),iupper
*       number of bound electrons of the ion
        NeBound = nelem - i
        if( lgVrrFit ) then
          call rrfit( nelem , nelem-i+1 , te , radrec )
        else
          if( te.gt.1e3 .or. i.gt.1 .or. tlow(1).eq.0. ) then
            radrec = rec(i)*te**pl(i)
          else
*           use special Pequignot and Aldrovandi fit for low temp
            radrec = tlow(1)*te**tlow(2)
          endif
        endif
        RecombinRate(nelem,i) = eden*( radrec + CotaRate(i) )
*       this is supposed to be the ground term of the recombination
*       >>chng 97 feb 17, following two did not have eden,
*       exposed bug when super low density models did not conserve energy
        DiffusHeavy(nelem,i ) = eden*radrec / 10.
        xLyaHeavy(nelem,i) = eden*radrec / 10.
*
*       recombinatinon on grain surface
        RecombinRate(nelem,i) = RecombinRate(nelem,i) + GrnIonRec
        SaveRate(i,1) = radrec + CotaRate(i) + GrnIonRec
*
*       Burgess dielectronic recombination
        if(  te.gt.ditcrt(i)*.1 )  then
          SaveRate(i,2) =
     1    supprs(i,1)/te32 * dicoef(i,1) * exp(-dite(i,1)/te)*
     3    (1.+dicoef(i,2)*sexp(dite(i,2)/te))
          RecombinRate(nelem,i) = RecombinRate(nelem,i) +
     1    SaveRate(i,2)*eden
        endif
*
*       Nussbaumer and Storey dielectronic recombination
*       do not ever do it for rec from
*       a closed shell, NeBound is number of bound electrons in ion
        if( NeBound.ne.2 .and. NeBound.ne.10 .and. NeBound.ne.18 )
     1    then
          tefac = ff(i)*t4m1
*         fac2 = 1e-14 * sqrte
          if( ff(i).ne.0. .and.abs(tefac).lt.30. ) then
            SaveRate(i,3) =
     1      supprs(i,2) * fac2*max(0.,(((aa(i)*t4m1+
     1      bb(i))*t4m1+ cc(i))*t4m1+dd(i))*exp(-tefac))
          else if( te.gt.100..and.ff(i).eq.0. .and. i.le.4 ) then
            SaveRate(i,3) =
     1      supprs(i,2) *cludge(i)*GuessDiel
          endif
          RecombinRate(nelem,i) = RecombinRate(nelem,i) +
     1    SaveRate(i,3)*eden
        endif
*
        worksv(i) = RecombinRate(nelem,i) *
     1  anu( ipElement(nelem,i,nsShells(nelem,i),1) )
      end do
*
*     option to punch rec coef
      if( ioreco.gt.0 )  then
        write(ioreco,'('' R '',1p,14e9.2)')(SaveRate(i,1),i=1,
     1  min(14,IonHigh(nelem)-1))
        write(ioreco,'('' B '',1p,14e9.2)')(SaveRate(i,2),i=1,
     1  min(14,IonHigh(nelem)-1))
        write(ioreco,'('' NS'',1p,14e9.2)')(SaveRate(i,3),i=1,
     1  min(14,IonHigh(nelem)-1))
        write(ioreco,'(1x,a2,1p,14e9.2)') chElementSym(nelem),
     1  (RecombinRate(nelem,i),i=1,min(14,IonHigh(nelem)-1))
        if( IonHigh(nelem)-1.gt.14 ) then
          write(ioreco,'('' R '',1p,14e9.2)')(SaveRate(i,1),i=15,
     1    min(29,IonHigh(nelem)-1))
          write(ioreco,'('' B '',1p,14e9.2)')(SaveRate(i,2),i=15,
     1    min(29,IonHigh(nelem)-1))
          write(ioreco,'('' NS'',1p,14e9.2)')(SaveRate(i,3),i=15,
     1    min(29,IonHigh(nelem)-1))
          write(ioreco,'(3x,1p,14e9.2)')
     1    (RecombinRate(nelem,i),i=15,IonHigh(nelem)-1)
        endif
      endif
*
*begin sanity check
      do i=IonLow(nelem),IonHigh(nelem)-1
        if( DiffusHeavy(nelem,i).le.0. ) then
          write(qq,'('' MakeRecomb finds insane DiffusHeavy rate,'',
     1    '' nelem='',i3,'' rates follow.'')')nelem
          write(qq,'(1p,10e9.1)') (DiffusHeavy(nelem,iupper),iupper=1,
     1    IonHigh(nelem))
          call ShowMe
          stop
        endif
        if( xLyaHeavy(nelem,i).le.0. ) then
          write(qq,'('' MakeRecomb finds insane xLyaHeavy rate,'',
     1    '' nelem='',i3,'' rates follow.'')')nelem
          write(qq,'(1p,10e9.1)') (xLyaHeavy(nelem,iupper),iupper=1,
     1    IonHigh(nelem))
          call ShowMe
          stop
        endif
        if( RecombinRate(nelem,i).le.0. ) then
          write(qq,'('' MakeRecomb finds insane recombination rate,'',
     1    '' nelem='',i3,'' rates follow.'')')nelem
          write(qq,'(1p,10e9.1)') (RecombinRate(nelem,iupper),iupper=1,
     1    IonHigh(nelem))
          call ShowMe
          stop
        endif
      end do
*end sanity check
      end
******************************************************************************
      subroutine MakeRT
      implicit none
*drive static or wind metal line radiative transfer
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer nfst
      parameter (nfst=39)
      integer ndfst
      parameter (ndfst=5)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
*
*     local variables
      integer i
*
      if( windv.eq.0. ) then
*       static model
*       high quality lines
        do i=1,nTauLines
          call MakeStatRT( TauLines(1,i) )
        end do
*       heavy element lines in cooling with only g-bar
        do i=1,NWINDLINE
          call MakeStatRT( WindLine(1,i) )
        end do
      else
*       windy model
        do i=1,nTauLines
          call MakeWindRT( TauLines(1,i) )
        end do
*       heavy element lines in cooling with only g-bar
        do i=1,NWINDLINE
          call MakeWindRT( WindLine(1,i) )
        end do
      endif
*     write(6,*) ' MakeRT'
*     call dumpline( TauLines(1,57) )
*
*     Verner's model FeII atom
*     do not call if Netzer model used, or it Fe(2) is zero
*     exception is when code is searching for first soln
      if( chFeIIAtom.eq.'Verner' .and.
     1  (lgSearch.or.xIonFracs(26,2).gt.0.) ) then
        if(.not.lgSimKatya ) call MakeRTFe2
      endif
*
      end
***************************************************************
      subroutine MakeStatRT( t )
      implicit none
*do line radiative transfer for static geometry
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real t(nta)
*
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      real DestWght , DestWghtSave
*     weight to give new dest prob when being evaluated,
*     default is 0.25 and is reset with SET DSTWGHT command
*     DstWghtSave is usually the same as DstWght - except on 0th
*     zone, where DstWght is set to 1 to get initial dest prob
*     then reset to DstWghtSave
      common/DstWght/ DestWght , DestWghtSave
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real velocity , damp , eovrlp , escgrd,escsub,esccom,escinc
      integer nelem
*
*     this is the routine that computes much of the radiative transfer
*     physics for lines for static case.  Lines diveded into two types,
*     high quality (ipLnCS1=0) and lower quality g-bar lines
*
*begin sanity check
      if( t(ipLnColovTOT).gt.1.00001 .or. t(ipLnColovTOT).lt.0. ) then
        write(qq,'('' MakeStatRT insane ipLnColovTOT='',1p,e10.2)')
     1  t(ipLnColovTOT)
      endif
      if( t(ipLnTauIn).lt.-30. ) then
        write(qq,'('' MakeStatRT called with large negative optical'',
     1  '' depth.'')')
        call DumpLine( t )
      endif
*end sanity check
*
*     this checks if we have overrun the optical depth scale
*     possible for line to mase, reason for sec test
*     >>chng 97 jan 8, on iterations where the first iteration had NO species,
*but it does exist on later iterations, added test for existence of ion
      if( t(ipLnTauTot)*0.9-t(ipLnTauIn) .lt. 0. .and.
     1  t(ipLnTauIn).gt.0. .and. t(ipLnTauTot).ne.taumin ) then
*       do not do anything if we have overrun the scale
        return
      endif
      nelem = t( ipLnNelem )
*     negative element number says ignore it
      if( nelem.lt.0. ) return
      velocity = doppler(nelem)
      damp = t(ipLnDampRel) / velocity
      t(ipLnDamp) = damp
*
*     this this is 0th zone then use full destruction prob,
*     else use mean of old and new - NB must reset at end
      if( nzone.lt.1 ) DestWght = 1.
*
*     static solution - which redistribution function?
      if( t(ipLnRedis).gt.0. ) then
*       incomplete redistribution
*       escape probability
*     >>chng 97 june 27, add pointer to continuum
        t(ipLnEscP) = escgrd( t(ipLnTauIn) , t(ipLnTauTot) , damp ,
     1  int( t(ipLnIpCont) ) )
*       inward escaping fraction
        t(ipLnInwd) = fracin
*       destruction probability
        if( t(ipLnCS1).eq.0. ) then
*         higher quality lines
*     >>chng 96 sep 4 to DestWght weighting
          t(ipLnDesP) =  t(ipLnDesP) * (1.-DestWght) + DestWght*
     1    eovrlp( t(ipLnPopOpc) , t(ipLnTauIn) ,
     1    t(ipLnTauTot) , damp , t(ipLnOpac) , INT(t(ipLnIpCont)) ,
     1    velocity, t(ipLnEscP) , 'INCO')
*         continuum pumping rate, A gu/gl abs prob occnum
*         the "no induced" command causes conpmp to set 0
          if( lgFluor ) then
            wayin = escinc( t(ipLnTauCon),damp )
            t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1      wayin * occnum(int(t(ipLnIpCont)))
          else
            t(ipLnPump) = 0.
          endif
*    1    conpmp(t(1)) * occnum(int(t(ipLnIpCont)))
        else
          t(ipLnDesP) = 0.
*         wayin was computed by escape prob routine, is inner esc
          if( lgFluor ) then
            wayin = escinc( t(ipLnTauCon),damp )
            t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1      wayin * occnum(int(t(ipLnIpCont)))
          else
            t(ipLnPump) = 0.
          endif
        endif
      else
*       complete redistribution - t(ipLnRedis) is negative
* 666 error! put in something like escfs for maser effects
        t(ipLnEscP) = escsub( t(ipLnTauIn) , t(ipLnTauTot) , damp )
*       inward escaping fraction
        t(ipLnInwd) = fracin
        if( t(ipLnCS1).eq.0. ) then
*         destruction probability
*     >>chng 96 sep 4 to DestWght weighting
          t(ipLnDesP) =  t(ipLnDesP) * (1.-DestWght) + DestWght*
     1    eovrlp( t(ipLnPopOpc) , t(ipLnTauIn) ,
     1    t(ipLnTauTot) , damp , t(ipLnOpac) , INT(t(ipLnIpCont)) ,
     1    velocity, t(ipLnEscP) , '  K2')
*         continuum pumping rate
*         the "no fluor" command causes conpmp to set 0
          if( lgFluor ) then
            wayin = esccom( t(ipLnTauCon),damp )
            t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1      wayin * occnum(int(t(ipLnIpCont)))
          else
            t(ipLnPump) = 0.
          endif
*    1    conpmp(t(1))* occnum(int(t(ipLnIpCont)))
        else
          t(ipLnDesP) = 0.
*         wayin was computed by escape prob reoutine, is inner esc
          if( lgFluor ) then
            wayin = esccom( t(ipLnTauCon),damp)
            t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1      wayin * occnum(int(t(ipLnIpCont)))
          else
            t(ipLnPump) = 0.
          endif
        endif
      endif
*
*     reset weighting
      DestWght = DestWghtSave
*
      end
******************************************************************************
      subroutine MakeWindRT( t )
      implicit none
*do line radiative transfer for wind geometry
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real t(nta)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
*     wayin - escape probability in inward direction
*     wayout - escape probability in outward direction
*     =1 when outward optical depths unknown (touton .false.)
*     fractin = wayin / (wayin+wayout) when outer defined, else zero
      real wayin , wayout , fracin
      common/twoway/ wayin , wayout , fracin
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      real DestWght , DestWghtSave
*     weight to give new dest prob when being evaluated,
*     default is 0.25 and is reset with SET DSTWGHT command
*     DstWghtSave is usually the same as DstWght - except on 0th
*     zone, where DstWght is set to 1 to get initial dest prob
*     then reset to DstWghtSave
      common/DstWght/ DestWght , DestWghtSave
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     this is the routine that computes much of the radiative transfer
*     physics for lines in wind case.  Lines diveded into two types,
*     high quality (ipLnCS1=0) and lower quality g-bar lines
*
*     local variables
      real velocity , damp , eovrlp , esccom
*     real conpmp
      integer nelem
*
*begin sanity check
      if( t(ipLnColovTOT) .gt.1. .or. t(ipLnColovTOT).lt.0. ) then
        write(qq,'('' MakeWindRT insane ipLnColovTOT='',1p,e10.2)')
     1  t(ipLnColovTOT)
      endif
*end sanity check
*
      nelem = t( ipLnNelem )
*begin sanity check
      if( nelem.lt. 1) then
*       this is non-existent line, but flag no longer exists
        write(qq,'('' MakeWindRT called with insane nelem='',i4)') nelem
        stop
      endif
*end sanity check
*
      velocity = doppler(nelem)
      damp = t(ipLnDampRel) / velocity
      t(ipLnDamp) = damp
*
*     use only one-sided escape probabilities
*     get escape probability, this gets fractions too
      t(ipLnEscP) = esccom( t(ipLnTauIn),damp)
*     inward fraction
      t(ipLnInwd) = 0.5
      if( t(ipLnCS1).eq.0. ) then
*       high quality line
*       destruction by overlapping continuum
*       >>chng 96 sep 4 to DestWght weighting
*       this this is 0th zone then use full destruction prob,
*       else use mean of old and new - NB must reset at end
        if( nzone.lt.1 ) DestWghtSave = 1.
        t(ipLnDesP) = (1.-DestWght)*t(ipLnDesP) + DestWght*
     1  eovrlp( t(ipLnPopOpc), t(ipLnTauIn),
     1  t(ipLnTauTot), damp, t(ipLnOpac), int(t(ipLnIpCont)),
     2  velocity,t(ipLnEscP),'  K2' )
*       reset weight
        DestWght = DestWghtSave
*       continuum pumping
        if( lgFluor ) then
          t(ipLnPump) = t(ipLnAul)*t(ipLnGu)/t(ipLnGl)*
     1    t(ipLnEscP) * occnum(  int(t(ipLnIpCont))  )
        else
          t(ipLnPump) = 0.
        endif
* 666 error! understand why conpmp does not work
*    1  conpmp(t) * occnum(  int(t(ipLnIpCont))  )
      else
*       low quality line
        t(ipLnDesP) = 0.
*       wayin was computed by escape prob reoutine, is inner esc
        if( lgFluor ) then
          t(ipLnPump) = t(ipLnAul)* t(ipLnGu)/t(ipLnGl)*
     1    t(ipLnEscP) * occnum(int(t(ipLnIpCont)))
        else
          t(ipLnPump) = 0.
        endif
      endif
*
      end
******************************************************************************
      subroutine mangi
      implicit none
*derive ionization balance for manganese
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (nelem=25)
      parameter (ndim=26)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real FYIELD(nelem)
*     real GRDEFF(nelem)
*
*     manganese nelem=25
*     based on iron
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.26E-10,4.97E-11,1.49E-10,3.90E-11,1.66E-11,7.16E-12,
     1 3.00E-12,1.02E-12,2.54E-12,1.70E-12,1.11E-12,6.42E-13,3.59E-13,
     2 9.30E-14,1.62E-14,5.97E-14,8.44E-14,5.92E-14,4.72E-14,3.79E-14,
     3 2.60E-14,1.61E-14,1.16E-14,5.39E-15,5.67E-16/
      data (cion(i,2),i=1,ndim-1)
     1 /9.13E4,1.88E5,3.56E5,6.36E5,8.70E5,1.15E6,1.45E6,1.75E6,
     2 2.73E6,3.04E6,3.37E6,3.84E6,4.19E6,4.55E6,5.30E6,5.68E6,
     3 1.47E7,1.58E7,1.69E7,1.84E7,1.96E7,2.09E7,2.26E7,2.35E7,
     4 1.02E8/
*
*     DATA FYIELD/2*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47,2*.48,2*.49, 3*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/nelem*0.2/
*
*     Fe rates from Woods et al. Ap.J. 249, 399.
*     rec from +23, 24 25 from Arnauld et al 85
      data rec,pl
     1/ 5.2E-10 , 2.40E-9 , 3.20E-9 , 4.17E-9 , 9.44E-9 , 2.14E-8
     2, 4.48E-8 , 8.75E-8 , 1.41E-7 , 2.26E-7 , 2.73E-7 , 3.56E-7
     3, 4.42E-7 , 5.52E-7 , 7.00E-7 , 8.59E-7 , 8.55E-7 , 8.93E-7
     4, 9.64E-7 , 1.06E-6 , 1.19E-6 , 1.22E-6 , 2.94E-6 , 5.00E-6
     5,
     1  -0.891  , -0.843  , -0.746  , -0.682  , -0.699  , -0.728
     2, -0.759  , -0.790  , -0.810  , -0.829  , -0.828  , -0.834
     3, -0.836  , -0.840  , -0.846  , -0.850  , -0.836  , -0.824
     4, -0.816  , -0.811  , -0.808  , -0.800  , -0.852  , -0.875
     5/
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.28e-10 , -0.686 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.58E-3  , 8.38E-3  , 1.54E-2, 3.75E-2, 0.117   , 0.254
     2, 0.291   , 0.150   , 0.140   , 0.100   , 0.200   , 0.240
     3, 0.260   , 0.190   , 0.120   , 0.350   , 0.066   , 0.10
     4, 0.13    , 0.23    , 0.14    , 0.11    , 0.041   , 0.747
     5, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/ .456    , .323    , .310    , .411    , .359    , .0975
     1, .229    , 4.20    , 3.30    , 5.30    , 1.50    , 0.700
     1, .600    , .5      , 1.      , 0.      , 7.8     , 6.3
     1, 5.5     , 3.6     , 4.9     , 1.6     , 4.2     , .284
     1, 0./
      data (dite(i,1),i=1,ndim-1)
     1/ 6.00E4  , 1.94E5  , 3.31E5  , 4.32E5  , 6.28E5  , 7.50E5
     2, 7.73E5  , 2.62E5  , 2.50E5  , 2.57E5  , 2.84E5  , 8.69E5
     3, 4.21E5  , 4.57E5  , 2.85E5  , 8.18E5  , 1.51E6  , 1.30E6
     4, 1.19E6  , 1.09E6  , 9.62E5  , 7.23E5  , 4.23E5  , 5.84E7
     5, 0./
      data (dite(i,2),i=1,ndim-1)
     1/8.97E4   , 1.71E5  , 2.73E5  , 3.49E5  , 5.29E5  , 4.69E5
     2,6.54E5   , 1.32E6  , 1.33E6  , 1.41E6  , 1.52E6  , 1.51E6
     3,1.82E6   , 1.84E6  , 2.31E6  , 0.      , 9.98E6  , 9.98E6
     4,1.00E7   , 1.10E7  , 8.34E6  , 1.01E7  , 1.07E7  , 1.17E7
     5 , 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4     , 6E6
     5, 1E20    /
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
*
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine maprng( chCard )
      implicit none
*parse map command to produce map of heating and cooling
      character chCard*80
      integer MapZone , nMapStep
      real RangeMap
*parameters doing with map command, MapZone is zone number,
* -1 for very start
* RangeMap is range, parsed from same command
* nMapStep is number of steps, set with set nmap command
      common/MapPar/ MapZone , RangeMap(2), nMapStep
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      logical lgEOL , lgMatch , lgLogOn
      integer i
      real fread
*
*     do cooling space map for specified zones
*     if no number, or <0, do map and punch out without doing first zone
      i = 5
      MapZone = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        MapZone = -1
        return
      endif
*
      if( lgMatch( 'RANG' , chCard ) ) then
        RangeMap(1) = fread( chCard , i , 76 , lgEOL )
        if( RangeMap(1).le.10. ) then
          RangeMap(1) = 10.** RangeMap(1)
          lgLogOn = .true.
        else
          lgLogOn = .false.
        endif
        RangeMap(2) = fread( chCard , i , 76 , lgEOL )
        if( lgLogOn ) RangeMap(2) = 10.** RangeMap(2)
*
        if( lgEOL ) then
          write(qq,'('' There must be a zone number, followed by'',
     1    '' two temperatures, on this line.  Sorry.'')')
          stop
        endif
        return
      endif
*
      end
**************************************************************************
      block data martin
      implicit none
*block data with grains data from P.G. Martin
*
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      character chDstLab*10
*     labels for types of dust grains
      common/dstlab/ chDstLab(ndust)
      real DustWorkFcn
*work function (Ioniz pot) of various grain species
      common/dwork/ DustWorkFcn(ndust)
      real dustp,eev, sab,sse,darea, dsize
      integer ndpts
      common/dust/ dustp(4,ndust),eev(limcrs,ndust),
     z sab(limcrs,ndust),sse(limcrs,ndust),ndpts(ndust),darea(ndust),
     z dsize(ndust)
      real dstela,dstelz
      common/dustab/ dstela(4,ndust),dstelz(4,ndust)
      real sublimat
      common/sublimat/ sublimat(ndust)
*
      integer i , j
*
*     NDUST is .ge. the number of grain species
*     LIMCRS is upper limit to number of cross sections
*     chDstLab is the character label for the grain species
*     DustWorkFcn is the grain photoionization threshold in Ryd
*     DUSTP 1 - 4 are density, molecular wt, normalizing abundance, depletion
*     EEV is energy in log10 Ryd (despite name)
*     SAB is log10 absorption cross section per H nucleon
*     SSE is log10 scattering cross section per H nucleon TIMES (1 - g)
*     so SSE is effective scattering cross section
*     and SAB + SSE gives radiation pressure cross section
*     NDPTS is number of energies
*     DAREA is surface area cm**2 per hydrogen nucleon
*     projected area is a quarter of this
*     DSIZE is effective size (r32) in cm
*     DSTELA is the relative number of an element depleted in grains, wrt H
*     DSTELZ is the atomic number of this element
*     sublimat is grain sublimation temperature
*
*
*     grain type 1: graphite - mrn/dl power law
      data chDstLab(1)/' Gra-ISM  '/
      data (dustp(i,1),i=1,4)/2.260e+00,1.200e+01,4.800e-04,5.800e-01/
      data ndpts(1)/157/, darea(1)/2.097e-21/, dsize(1)/3.536e-06/
      data (dstelz(i,1),i=1,4)/6.000e+00,0.000e+00,0.000e+00,0.000e+00/
      data (dstela(i,1),i=1,4)/2.784e-04,0.000e+00,0.000e+00,0.000e+00/
      data DustWorkFcn(1)/0.5883/
      data sublimat(1)/1750./
*
      data (eev(i,1),i=1,157)/ -5.000, -2.999, -2.950, -2.901, -2.851,
     Z -2.802, -2.752, -2.703, -2.654, -2.604, -2.555, -2.505, -2.456,
     Z -2.407, -2.357, -2.308, -2.258, -2.209, -2.160, -2.110, -2.061,
     Z -2.011, -1.962, -1.913, -1.863, -1.814, -1.764, -1.715, -1.666,
     Z -1.616, -1.567, -1.517, -1.468, -1.418, -1.369, -1.320, -1.270,
     Z -1.221, -1.171, -1.122, -1.073, -1.023, -0.974, -0.924, -0.875,
     Z -0.826, -0.776, -0.727, -0.677, -0.628, -0.579, -0.529, -0.480,
     Z -0.430, -0.381, -0.332, -0.282, -0.233, -0.183, -0.134, -0.085,
     Z -0.035,  0.014,  0.064,  0.113,  0.162,  0.212,  0.261,  0.311,
     Z  0.360,  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,
     Z  0.755,  0.805,  0.854,  0.894,  0.932,  0.970,  1.008,  1.044,
     Z  1.079,  1.112,  1.144,  1.174,  1.201,  1.225,  1.245,  1.262,
     Z  1.275,  1.285,  1.292,  1.297,  1.301,  1.304,  1.306,  1.308,
     Z  1.309,  1.310,  1.311,  1.312,  1.313,  1.314,  1.315,  1.316,
     Z  1.317,  1.318,  1.319,  1.320,  1.366,  1.412,  1.458,  1.501,
     Z  1.543,  1.582,  1.621,  1.659,  1.696,  1.733,  1.769,  1.805,
     Z  1.841,  1.876,  1.911,  1.946,  1.981,  2.016,  2.051,  2.086,
     Z  2.121,  2.156,  2.191,  2.225,  2.260,  2.296,  2.331,  2.366,
     Z  2.400,  2.437,  2.472,  2.508,  2.542,  2.580,  2.616,  2.655,
     Z  2.689,  2.723,  2.763,  2.793,  2.834,  2.863,  2.866,  4.866/
*
      data (sab(i,1),i=1,157)/-28.465,-24.449,-24.346,-24.242,-24.140,
     Z-24.040,-23.947,-23.863,-23.792,-23.741,-23.713,-23.712,-23.731,
     Z-23.764,-23.800,-23.828,-23.842,-23.837,-23.812,-23.769,-23.713,
     Z-23.645,-23.568,-23.487,-23.400,-23.317,-23.227,-23.136,-23.044,
     Z-22.952,-22.859,-22.766,-22.674,-22.582,-22.493,-22.406,-22.324,
     Z-22.249,-22.180,-22.114,-22.050,-21.990,-21.929,-21.868,-21.810,
     Z-21.754,-21.699,-21.646,-21.594,-21.547,-21.506,-21.461,-21.412,
     Z-21.316,-21.158,-21.279,-21.434,-21.512,-21.505,-21.408,-21.290,
     Z-21.159,-21.111,-21.072,-21.120,-21.256,-21.362,-21.453,-21.535,
     Z-21.566,-21.570,-21.613,-21.622,-21.662,-21.702,-21.757,-21.834,
     Z-21.903,-21.959,-22.028,-22.094,-22.151,-22.204,-22.266,-22.334,
     Z-22.402,-22.467,-22.532,-22.596,-22.656,-22.711,-22.756,-22.795,
     Z-22.825,-22.848,-22.864,-22.876,-22.885,-22.892,-22.896,-22.901,
     Z-22.903,-22.905,-22.908,-22.910,-22.912,-22.914,-22.916,-22.918,
     Z-22.920,-22.922,-22.923,-21.776,-21.836,-21.908,-21.993,-22.073,
     Z-22.154,-22.234,-22.319,-22.404,-22.494,-22.578,-22.672,-22.764,
     Z-22.860,-22.953,-23.048,-23.144,-23.245,-23.343,-23.441,-23.542,
     Z-23.644,-23.746,-23.848,-23.948,-24.053,-24.161,-24.264,-24.369,
     Z-24.472,-24.585,-24.693,-24.804,-24.908,-25.027,-25.141,-25.264,
     Z-25.371,-25.479,-25.607,-25.704,-25.840,-25.932,-25.941,-32.417/
*
      data (sse(i,1),i=1,157)/-37.538,-29.541,-29.345,-29.149,-28.954,
     Z-28.761,-28.570,-28.383,-28.199,-28.019,-27.840,-27.660,-27.476,
     Z-27.287,-27.093,-26.897,-26.698,-26.499,-26.299,-26.099,-25.900,
     Z-25.701,-25.502,-25.303,-25.104,-24.905,-24.703,-24.501,-24.298,
     Z-24.092,-23.885,-23.676,-23.467,-23.260,-23.060,-22.874,-22.710,
     Z-22.573,-22.462,-22.368,-22.284,-22.216,-22.163,-22.122,-22.089,
     Z-22.065,-22.044,-22.022,-21.997,-21.969,-21.931,-21.876,-21.796,
     Z-21.709,-21.754,-22.008,-22.256,-22.268,-22.073,-21.886,-21.725,
     Z-21.630,-21.640,-21.583,-21.631,-21.751,-21.863,-21.970,-22.115,
     Z-22.306,-22.432,-22.551,-22.684,-22.781,-22.909,-23.030,-23.175,
     Z-23.342,-23.507,-23.668,-23.806,-23.942,-24.079,-24.218,-24.355,
     Z-24.493,-24.629,-24.768,-24.908,-25.046,-25.184,-25.320,-25.462,
     Z-25.603,-25.749,-25.890,-26.028,-26.181,-26.342,-26.486,-26.684,
     Z-26.814,-26.974,-27.172,-27.389,-27.486,-27.280,-26.930,-26.583,
     Z-26.254,-25.915,-25.409,-25.254,-25.300,-25.375,-25.499,-25.635,
     Z-25.771,-25.907,-26.043,-26.181,-26.319,-26.456,-26.592,-26.730,
     Z-26.869,-27.004,-27.140,-27.276,-27.412,-27.548,-27.686,-27.822,
     Z-27.958,-28.095,-28.230,-28.366,-28.503,-28.639,-28.777,-28.913,
     Z-29.049,-29.193,-29.329,-29.464,-29.605,-29.750,-29.893,-30.030,
     Z-30.165,-30.313,-30.449,-30.597,-30.704,-30.879,-30.885,-37.180/
*
*     grain type 2: silicate - mrn/dl power law
      data chDstLab(2)/' Sil-ISM  '/
      data (dustp(i,2),i=1,4)/3.300e+00,1.700E+02,4.000E-05,8.200E-01/
      data ndpts(2)/157/, darea(2)/2.397e-21/, dsize(2)/3.536e-06/
      data (dstelz(i,2),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,2),i=1,4)/1.312E-04,3.280E-05,3.280E-05,3.280E-05/
      data DustWorkFcn(2)/0.5883/
      data sublimat(2)/1400./
*
      data (eev(i,2),i=1,157)/ -5.000, -2.481, -2.431, -2.382, -2.332,
     Z -2.283, -2.234, -2.209, -2.184, -2.160, -2.135, -2.110, -2.085,
     Z -2.036, -2.011, -1.987, -1.962, -1.937, -1.913, -1.888, -1.863,
     Z -1.838, -1.814, -1.789, -1.764, -1.740, -1.715, -1.666, -1.616,
     Z -1.567, -1.517, -1.468, -1.418, -1.369, -1.320, -1.270, -1.221,
     Z -1.171, -1.122, -1.073, -1.023, -0.974, -0.924, -0.875, -0.826,
     Z -0.776, -0.727, -0.677, -0.628, -0.579, -0.529, -0.480, -0.430,
     Z -0.381, -0.356, -0.332, -0.307, -0.282, -0.233, -0.208, -0.159,
     Z -0.109, -0.060, -0.010,  0.039,  0.088,  0.138,  0.162,  0.187,
     Z  0.212,  0.261,  0.311,  0.360,  0.409,  0.459,  0.508,  0.558,
     Z  0.607,  0.656,  0.706,  0.755,  0.805,  0.854,  0.866,  0.911,
     Z  0.957,  1.002,  1.048,  1.093,  1.135,  1.175,  1.212,  1.247,
     Z  1.281,  1.314,  1.346,  1.378,  1.409,  1.440,  1.469,  1.496,
     Z  1.522,  1.546,  1.567,  1.582,  1.589,  1.591,  1.592,  1.593,
     Z  1.604,  1.650,  1.683,  1.706,  1.720,  1.724,  1.725,  1.771,
     Z  1.815,  1.851,  1.884,  1.915,  1.945,  1.972,  2.009,  2.042,
     Z  2.073,  2.102,  2.127,  2.133,  2.173,  2.206,  2.237,  2.267,
     Z  2.297,  2.327,  2.357,  2.387,  2.415,  2.446,  2.473,  2.505,
     Z  2.537,  2.566,  2.598,  2.627,  2.658,  2.685,  2.712,  2.718,
     Z  2.719,  2.720,  2.761,  2.793,  2.836,  2.864,  2.866,  4.866/
*
      data (sab(i,2),i=1,157)/-28.457,-23.345,-23.241,-23.124,-23.014,
     Z-22.997,-23.120,-23.187,-23.208,-23.119,-22.990,-22.868,-22.748,
     Z-22.572,-22.544,-22.703,-22.953,-23.219,-23.459,-23.628,-23.693,
     Z-23.685,-23.658,-23.649,-23.654,-23.659,-23.654,-23.621,-23.582,
     Z-23.550,-23.518,-23.483,-23.442,-23.399,-23.353,-23.302,-23.248,
     Z-23.191,-23.129,-23.060,-22.984,-22.908,-22.842,-22.774,-22.701,
     Z-22.637,-22.568,-22.505,-22.439,-22.378,-22.319,-22.262,-22.213,
     Z-22.137,-22.004,-21.859,-21.714,-21.585,-21.420,-21.288,-21.258,
     Z-21.207,-21.152,-21.112,-21.102,-21.083,-21.100,-21.164,-21.261,
     Z-21.302,-21.337,-21.387,-21.409,-21.422,-21.435,-21.453,-21.474,
     Z-21.495,-21.491,-21.502,-21.527,-21.551,-21.578,-21.601,-21.570,
     Z-21.597,-21.628,-21.654,-21.690,-21.732,-21.779,-21.827,-21.875,
     Z-21.924,-21.975,-22.026,-22.078,-22.131,-22.189,-22.250,-22.307,
     Z-22.355,-22.393,-22.432,-22.470,-22.488,-22.492,-22.396,-22.125,
     Z-22.100,-22.185,-22.254,-22.303,-22.331,-22.300,-22.117,-22.205,
     Z-22.271,-22.347,-22.421,-22.492,-22.562,-22.625,-22.606,-22.686,
     Z-22.762,-22.834,-22.897,-22.784,-22.882,-22.966,-23.046,-23.125,
     Z-23.204,-23.285,-23.367,-23.449,-23.526,-23.611,-23.686,-23.776,
     Z-23.868,-23.950,-24.040,-24.123,-24.214,-24.291,-24.366,-24.363,
     Z-24.074,-23.841,-23.939,-24.022,-24.136,-24.220,-24.228,-29.744/
*
      data (sse(i,2),i=1,157)/-37.697,-27.642,-27.453,-27.268,-27.123,
     Z-27.082,-27.019,-26.909,-26.743,-26.560,-26.407,-26.274,-26.154,
     Z-26.017,-26.055,-26.370,-26.729,-26.729,-26.467,-26.222,-26.025,
     Z-25.864,-25.726,-25.601,-25.482,-25.365,-25.251,-25.031,-24.820,
     Z-24.614,-24.410,-24.209,-24.011,-23.815,-23.624,-23.438,-23.260,
     Z-23.095,-22.948,-22.819,-22.701,-22.579,-22.464,-22.369,-22.284,
     Z-22.206,-22.132,-22.068,-22.005,-21.948,-21.893,-21.839,-21.781,
     Z-21.719,-21.710,-21.714,-21.734,-21.767,-21.772,-21.793,-21.881,
     Z-21.850,-21.800,-21.817,-21.830,-21.799,-21.765,-21.779,-21.902,
     Z-22.042,-22.185,-22.332,-22.467,-22.607,-22.688,-22.783,-22.891,
     Z-23.024,-23.132,-23.195,-23.304,-23.423,-23.552,-23.695,-23.673,
     Z-23.762,-23.875,-23.989,-24.096,-24.210,-24.326,-24.441,-24.554,
     Z-24.668,-24.782,-24.895,-25.011,-25.125,-25.241,-25.355,-25.468,
     Z-25.584,-25.698,-25.813,-25.934,-26.055,-26.186,-26.251,-26.070,
     Z-25.955,-26.016,-26.132,-26.246,-26.373,-26.528,-26.343,-26.365,
     Z-26.479,-26.594,-26.708,-26.822,-26.937,-27.053,-27.167,-27.282,
     Z-27.398,-27.511,-27.625,-27.649,-27.763,-27.881,-27.997,-28.111,
     Z-28.225,-28.340,-28.454,-28.568,-28.683,-28.798,-28.912,-29.039,
     Z-29.162,-29.279,-29.400,-29.514,-29.639,-29.753,-29.869,-29.904,
     Z-29.922,-29.919,-30.032,-30.177,-30.282,-30.451,-30.455,-37.596/
*
*     grain type 3: gra - mrn/dl truncat power law
      data chDstLab(3)/' Gra-Ori  '/
      data (dustp(i,3),i=1,4)/2.260E+00,1.200E+01,4.800E-04,5.800E-01/
      data ndpts(3)/157/, darea(3)/8.562e-22/, dsize(3)/8.660E-06/
      data (dstelz(i,3),i=1,4)/6.000e+00,0.000E+00,0.000E+00,0.000E+00/
      data (dstela(i,3),i=1,4)/2.784E-04,0.000E+00,0.000E+00,0.000E+00/
      data DustWorkFcn(3)/0.5883/
      data sublimat(3)/1750./
*
      data (eev(i,3),i=1,157)/ -5.000, -2.999, -2.950, -2.901, -2.851,
     Z -2.802, -2.752, -2.703, -2.654, -2.604, -2.555, -2.505, -2.456,
     Z -2.407, -2.357, -2.308, -2.258, -2.209, -2.160, -2.110, -2.061,
     Z -2.011, -1.962, -1.913, -1.863, -1.814, -1.764, -1.715, -1.666,
     Z -1.616, -1.567, -1.517, -1.468, -1.418, -1.369, -1.320, -1.270,
     Z -1.221, -1.171, -1.122, -1.073, -1.023, -0.974, -0.924, -0.875,
     Z -0.826, -0.776, -0.727, -0.677, -0.628, -0.579, -0.529, -0.480,
     Z -0.430, -0.381, -0.332, -0.282, -0.233, -0.183, -0.134, -0.085,
     Z -0.035,  0.014,  0.064,  0.113,  0.162,  0.212,  0.261,  0.311,
     Z  0.360,  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,
     Z  0.755,  0.805,  0.854,  0.894,  0.932,  0.970,  1.008,  1.044,
     Z  1.079,  1.112,  1.143,  1.172,  1.199,  1.223,  1.244,  1.261,
     Z  1.274,  1.284,  1.291,  1.297,  1.301,  1.304,  1.306,  1.308,
     Z  1.309,  1.310,  1.311,  1.312,  1.313,  1.314,  1.315,  1.316,
     Z  1.317,  1.318,  1.319,  1.320,  1.366,  1.412,  1.458,  1.503,
     Z  1.546,  1.586,  1.626,  1.664,  1.701,  1.738,  1.774,  1.809,
     Z  1.845,  1.881,  1.916,  1.951,  1.986,  2.021,  2.057,  2.092,
     Z  2.127,  2.161,  2.197,  2.233,  2.268,  2.303,  2.339,  2.374,
     Z  2.410,  2.447,  2.479,  2.514,  2.551,  2.591,  2.631,  2.667,
     Z  2.702,  2.741,  2.783,  2.821,  2.844,  2.845,  2.866,  4.866/
*
      data (sab(i,3),i=1,157)/-28.460,-24.447,-24.343,-24.239,-24.136,
     Z-24.037,-23.943,-23.859,-23.788,-23.737,-23.710,-23.708,-23.726,
     Z-23.758,-23.792,-23.817,-23.828,-23.820,-23.792,-23.746,-23.687,
     Z-23.616,-23.537,-23.454,-23.365,-23.279,-23.186,-23.094,-22.999,
     Z-22.905,-22.809,-22.713,-22.618,-22.525,-22.433,-22.345,-22.263,
     Z-22.188,-22.120,-22.056,-21.995,-21.937,-21.880,-21.822,-21.769,
     Z-21.717,-21.667,-21.622,-21.583,-21.553,-21.532,-21.521,-21.526,
     Z-21.522,-21.507,-21.565,-21.598,-21.606,-21.575,-21.532,-21.548,
     Z-21.579,-21.596,-21.625,-21.685,-21.740,-21.768,-21.793,-21.810,
     Z-21.800,-21.790,-21.804,-21.800,-21.817,-21.836,-21.867,-21.919,
     Z-21.969,-22.013,-22.072,-22.130,-22.181,-22.230,-22.288,-22.352,
     Z-22.417,-22.480,-22.541,-22.601,-22.660,-22.713,-22.760,-22.799,
     Z-22.828,-22.851,-22.867,-22.880,-22.889,-22.896,-22.901,-22.905,
     Z-22.907,-22.910,-22.912,-22.914,-22.916,-22.918,-22.920,-22.923,
     Z-22.925,-22.926,-22.927,-21.860,-21.906,-21.964,-22.037,-22.111,
     Z-22.188,-22.264,-22.348,-22.430,-22.516,-22.600,-22.692,-22.781,
     Z-22.875,-22.971,-23.065,-23.161,-23.261,-23.358,-23.460,-23.560,
     Z-23.662,-23.761,-23.866,-23.972,-24.077,-24.182,-24.288,-24.393,
     Z-24.502,-24.616,-24.715,-24.822,-24.936,-25.062,-25.189,-25.302,
     Z-25.412,-25.537,-25.672,-25.797,-25.873,-25.876,-25.941,-32.417/
*
      data (sse(i,3),i=1,157)/-37.420,-29.423,-29.227,-29.031,-28.836,
     Z-28.643,-28.452,-28.265,-28.081,-27.901,-27.722,-27.542,-27.358,
     Z-27.169,-26.975,-26.778,-26.580,-26.380,-26.181,-25.981,-25.782,
     Z-25.583,-25.384,-25.185,-24.986,-24.787,-24.584,-24.383,-24.179,
     Z-23.974,-23.767,-23.558,-23.349,-23.142,-22.942,-22.756,-22.592,
     Z-22.455,-22.344,-22.250,-22.166,-22.098,-22.046,-22.005,-21.972,
     Z-21.949,-21.929,-21.910,-21.888,-21.865,-21.835,-21.793,-21.737,
     Z-21.701,-21.812,-22.027,-22.254,-22.287,-22.155,-22.095,-22.062,
     Z-22.021,-22.052,-22.034,-22.039,-22.107,-22.194,-22.287,-22.425,
     Z-22.621,-22.760,-22.876,-23.015,-23.107,-23.228,-23.338,-23.468,
     Z-23.625,-23.786,-23.943,-24.078,-24.213,-24.349,-24.486,-24.621,
     Z-24.759,-24.894,-25.029,-25.163,-25.300,-25.437,-25.578,-25.718,
     Z-25.856,-25.998,-26.132,-26.294,-26.447,-26.607,-26.751,-26.949,
     Z-27.078,-27.239,-27.436,-27.653,-27.751,-27.545,-27.195,-26.848,
     Z-26.518,-26.179,-25.672,-25.614,-25.647,-25.711,-25.823,-25.957,
     Z-26.092,-26.226,-26.363,-26.499,-26.636,-26.771,-26.907,-27.041,
     Z-27.180,-27.318,-27.454,-27.591,-27.730,-27.867,-28.007,-28.144,
     Z-28.282,-28.420,-28.556,-28.702,-28.842,-28.981,-29.116,-29.250,
     Z-29.386,-29.520,-29.654,-29.790,-29.962,-30.113,-30.248,-30.383,
     Z-30.567,-30.743,-30.827,-30.962,-31.008,-31.156,-31.198,-37.250/
*
*     grain type 4: sil - mrn/dl truncat power law
      data chDstLab(4)/' Sil-Ori  '/
      data (dustp(i,4),i=1,4)/3.300e+00,1.700e+02,4.000e-05,8.200E-01/
      data ndpts(4)/157/, darea(4)/9.787e-22/, dsize(4)/8.660e-06/
      data (dstelz(i,4),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,4),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(4)/0.5883/
      data sublimat(4)/1400./
*
      data (eev(i,4),i=1,157)/ -5.000, -2.481, -2.431, -2.382, -2.332,
     Z -2.283, -2.234, -2.209, -2.184, -2.160, -2.135, -2.110, -2.085,
     Z -2.036, -2.011, -1.987, -1.962, -1.937, -1.913, -1.888, -1.863,
     Z -1.838, -1.814, -1.789, -1.764, -1.740, -1.715, -1.690, -1.641,
     Z -1.591, -1.542, -1.493, -1.443, -1.394, -1.344, -1.295, -1.246,
     Z -1.196, -1.147, -1.097, -1.048, -0.999, -0.949, -0.900, -0.850,
     Z -0.801, -0.752, -0.702, -0.653, -0.603, -0.554, -0.505, -0.455,
     Z -0.406, -0.381, -0.356, -0.332, -0.307, -0.257, -0.208, -0.159,
     Z -0.109, -0.060, -0.010,  0.039,  0.088,  0.138,  0.187,  0.212,
     Z  0.261,  0.311,  0.360,  0.409,  0.459,  0.508,  0.558,  0.607,
     Z  0.656,  0.706,  0.755,  0.805,  0.854,  0.866,  0.911,  0.957,
     Z  1.002,  1.048,  1.093,  1.137,  1.178,  1.216,  1.252,  1.287,
     Z  1.321,  1.354,  1.386,  1.417,  1.447,  1.476,  1.503,  1.528,
     Z  1.551,  1.571,  1.584,  1.590,  1.592,  1.593,  1.604,  1.650,
     Z  1.683,  1.706,  1.719,  1.723,  1.724,  1.725,  1.771,  1.815,
     Z  1.851,  1.883,  1.914,  1.943,  1.970,  1.981,  2.026,  2.057,
     Z  2.086,  2.114,  2.131,  2.177,  2.210,  2.239,  2.269,  2.301,
     Z  2.332,  2.363,  2.389,  2.417,  2.450,  2.484,  2.507,  2.535,
     Z  2.569,  2.592,  2.619,  2.642,  2.677,  2.703,  2.718,  2.719,
     Z  2.720,  2.755,  2.788,  2.831,  2.845,  2.846,  2.866,  4.866/
*
      data (sab(i,4),i=1,157)/-28.457,-23.345,-23.241,-23.124,-23.013,
     Z-22.997,-23.120,-23.187,-23.208,-23.118,-22.989,-22.868,-22.747,
     Z-22.571,-22.544,-22.703,-22.953,-23.219,-23.459,-23.627,-23.692,
     Z-23.684,-23.656,-23.647,-23.652,-23.657,-23.652,-23.638,-23.597,
     Z-23.561,-23.529,-23.495,-23.455,-23.411,-23.364,-23.313,-23.258,
     Z-23.198,-23.136,-23.066,-22.987,-22.904,-22.828,-22.760,-22.684,
     Z-22.612,-22.545,-22.475,-22.409,-22.346,-22.282,-22.223,-22.161,
     Z-22.124,-22.067,-21.937,-21.799,-21.666,-21.503,-21.452,-21.457,
     Z-21.468,-21.484,-21.500,-21.513,-21.539,-21.586,-21.660,-21.655,
     Z-21.655,-21.666,-21.666,-21.664,-21.667,-21.672,-21.679,-21.685,
     Z-21.680,-21.685,-21.695,-21.706,-21.719,-21.730,-21.713,-21.728,
     Z-21.746,-21.762,-21.786,-21.817,-21.854,-21.893,-21.934,-21.978,
     Z-22.025,-22.072,-22.120,-22.170,-22.224,-22.284,-22.337,-22.378,
     Z-22.414,-22.453,-22.486,-22.500,-22.409,-22.151,-22.128,-22.207,
     Z-22.272,-22.320,-22.345,-22.353,-22.317,-22.144,-22.226,-22.289,
     Z-22.361,-22.431,-22.500,-22.566,-22.628,-22.653,-22.654,-22.729,
     Z-22.799,-22.868,-22.898,-22.896,-22.979,-23.054,-23.132,-23.217,
     Z-23.300,-23.384,-23.455,-23.532,-23.623,-23.717,-23.782,-23.863,
     Z-23.958,-24.023,-24.101,-24.167,-24.269,-24.342,-24.363,-24.074,
     Z-23.841,-23.923,-24.010,-24.123,-24.161,-24.163,-24.228,-29.742/
*
      data (sse(i,4),i=1,157)/-37.578,-27.524,-27.335,-27.150,-27.004,
     Z-26.964,-26.901,-26.791,-26.625,-26.442,-26.289,-26.155,-26.036,
     Z-25.898,-25.937,-26.252,-26.611,-26.610,-26.349,-26.104,-25.907,
     Z-25.746,-25.608,-25.483,-25.364,-25.247,-25.133,-25.022,-24.807,
     Z-24.598,-24.393,-24.191,-23.991,-23.794,-23.601,-23.412,-23.229,
     Z-23.058,-22.901,-22.763,-22.642,-22.522,-22.401,-22.297,-22.208,
     Z-22.127,-22.052,-21.983,-21.921,-21.863,-21.809,-21.757,-21.708,
     Z-21.650,-21.627,-21.626,-21.642,-21.682,-21.796,-21.951,-22.074,
     Z-22.112,-22.122,-22.169,-22.213,-22.206,-22.168,-22.236,-22.372,
     Z-22.527,-22.675,-22.820,-22.972,-23.064,-23.163,-23.271,-23.402,
     Z-23.519,-23.582,-23.683,-23.798,-23.923,-24.058,-24.055,-24.138,
     Z-24.243,-24.352,-24.451,-24.561,-24.672,-24.783,-24.893,-25.006,
     Z-25.119,-25.231,-25.344,-25.455,-25.566,-25.680,-25.794,-25.905,
     Z-26.016,-26.132,-26.250,-26.382,-26.545,-26.381,-26.268,-26.325,
     Z-26.438,-26.550,-26.660,-26.782,-26.833,-26.660,-26.677,-26.789,
     Z-26.901,-27.011,-27.122,-27.234,-27.345,-27.457,-27.527,-27.641,
     Z-27.751,-27.865,-27.976,-28.085,-28.204,-28.315,-28.426,-28.552,
     Z-28.664,-28.775,-28.893,-29.005,-29.134,-29.246,-29.357,-29.470,
     Z-29.582,-29.700,-29.811,-29.921,-30.032,-30.173,-30.234,-30.252,
     Z-30.249,-30.360,-30.476,-30.557,-30.583,-30.731,-30.769,-37.665/
*
*     grain type 5: silicate - radius 0.01 micron
      data chDstLab(5)/' Sil-0.01 '/
      data (dustp(i,5),i=1,4)/3.300e+00,1.700e+02,4.000e-05,8.200E-01/
      data ndpts(5)/157/, darea(5)/8.476e-21/, dsize(5)/1.000E-06/
      data (dstelz(i,5),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,5),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(5)/0.5883/
      data sublimat(5)/1400./
*
      data (eev(i,5),i=1,157)/ -5.000, -2.481, -2.431, -2.382, -2.332,
     Z -2.283, -2.234, -2.209, -2.184, -2.160, -2.135, -2.110, -2.085,
     Z -2.036, -2.011, -1.987, -1.962, -1.937, -1.913, -1.888, -1.863,
     Z -1.838, -1.814, -1.789, -1.764, -1.740, -1.690, -1.641, -1.591,
     Z -1.542, -1.493, -1.443, -1.394, -1.344, -1.295, -1.246, -1.196,
     Z -1.147, -1.097, -1.048, -0.999, -0.949, -0.900, -0.850, -0.801,
     Z -0.752, -0.702, -0.653, -0.603, -0.554, -0.505, -0.455, -0.430,
     Z -0.406, -0.381, -0.356, -0.332, -0.307, -0.282, -0.257, -0.233,
     Z -0.208, -0.159, -0.134, -0.085, -0.060, -0.010,  0.039,  0.088,
     Z  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360,  0.409,
     Z  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,  0.805,
     Z  0.854,  0.866,  0.911,  0.957,  1.002,  1.045,  1.090,  1.129,
     Z  1.170,  1.206,  1.241,  1.277,  1.309,  1.342,  1.375,  1.407,
     Z  1.438,  1.467,  1.495,  1.522,  1.547,  1.569,  1.583,  1.590,
     Z  1.592,  1.593,  1.605,  1.651,  1.684,  1.707,  1.720,  1.724,
     Z  1.725,  1.771,  1.816,  1.853,  1.886,  1.918,  1.948,  1.975,
     Z  2.016,  2.049,  2.080,  2.110,  2.131,  2.177,  2.210,  2.242,
     Z  2.273,  2.304,  2.335,  2.366,  2.397,  2.428,  2.459,  2.489,
     Z  2.519,  2.549,  2.579,  2.609,  2.639,  2.669,  2.698,  2.718,
     Z  2.719,  2.720,  2.766,  2.798,  2.830,  2.861,  2.866,  4.866/
*
      data (sab(i,5),i=1,157)/-28.457,-23.345,-23.242,-23.125,-23.014,
     Z-22.998,-23.121,-23.188,-23.209,-23.120,-22.992,-22.870,-22.750,
     Z-22.573,-22.545,-22.703,-22.953,-23.220,-23.461,-23.630,-23.696,
     Z-23.688,-23.662,-23.654,-23.659,-23.665,-23.649,-23.611,-23.579,
     Z-23.552,-23.523,-23.490,-23.455,-23.419,-23.380,-23.339,-23.297,
     Z-23.254,-23.209,-23.162,-23.115,-23.069,-23.022,-22.974,-22.927,
     Z-22.880,-22.832,-22.785,-22.739,-22.694,-22.653,-22.607,-22.603,
     Z-22.597,-22.546,-22.395,-22.214,-22.007,-21.790,-21.633,-21.469,
     Z-21.080,-20.952,-20.902,-20.755,-20.646,-20.537,-20.505,-20.467,
     Z-20.487,-20.564,-20.696,-20.767,-20.830,-20.912,-20.955,-20.983,
     Z-21.004,-21.035,-21.074,-21.114,-21.112,-21.131,-21.176,-21.218,
     Z-21.266,-21.307,-21.256,-21.302,-21.354,-21.394,-21.449,-21.510,
     Z-21.580,-21.647,-21.714,-21.785,-21.849,-21.915,-21.982,-22.047,
     Z-22.115,-22.186,-22.253,-22.309,-22.352,-22.398,-22.438,-22.457,
     Z-22.354,-22.045,-22.016,-22.118,-22.198,-22.254,-22.283,-22.248,
     Z-22.036,-22.139,-22.218,-22.305,-22.387,-22.466,-22.541,-22.608,
     Z-22.599,-22.683,-22.763,-22.840,-22.881,-22.879,-22.966,-23.050,
     Z-23.133,-23.217,-23.302,-23.387,-23.473,-23.559,-23.645,-23.729,
     Z-23.815,-23.901,-23.985,-24.071,-24.158,-24.245,-24.327,-24.363,
     Z-24.073,-23.839,-23.951,-24.034,-24.119,-24.207,-24.227,-29.755/
*
      data (sse(i,5),i=1,157)/-41.112,-31.058,-30.868,-30.684,-30.538,
     Z-30.497,-30.435,-30.325,-30.159,-29.976,-29.823,-29.690,-29.570,
     Z-29.431,-29.468,-29.781,-30.140,-30.140,-29.879,-29.634,-29.438,
     Z-29.277,-29.139,-29.014,-28.895,-28.778,-28.553,-28.337,-28.128,
     Z-27.923,-27.719,-27.517,-27.316,-27.117,-26.918,-26.719,-26.521,
     Z-26.323,-26.126,-25.928,-25.730,-25.532,-25.334,-25.135,-24.936,
     Z-24.735,-24.534,-24.331,-24.125,-23.916,-23.704,-23.484,-23.372,
     Z-23.254,-23.130,-23.001,-22.870,-22.733,-22.597,-22.464,-22.293,
     Z-22.093,-22.021,-21.900,-21.694,-21.541,-21.405,-21.309,-21.188,
     Z-21.125,-21.170,-21.337,-21.480,-21.600,-21.738,-21.862,-22.003,
     Z-22.101,-22.221,-22.354,-22.494,-22.577,-22.624,-22.744,-22.879,
     Z-22.998,-23.143,-23.123,-23.218,-23.329,-23.447,-23.550,-23.667,
     Z-23.787,-23.904,-24.023,-24.144,-24.261,-24.380,-24.500,-24.619,
     Z-24.738,-24.855,-24.974,-25.094,-25.213,-25.335,-25.458,-25.601,
     Z-25.759,-25.567,-25.449,-25.519,-25.636,-25.755,-25.876,-26.030,
     Z-25.837,-25.862,-25.980,-26.100,-26.217,-26.334,-26.452,-26.572,
     Z-26.692,-26.809,-26.926,-27.046,-27.176,-27.278,-27.397,-27.516,
     Z-27.633,-27.751,-27.870,-27.989,-28.109,-28.229,-28.349,-28.466,
     Z-28.583,-28.700,-28.818,-28.936,-29.055,-29.174,-29.295,-29.406,
     Z-29.425,-29.422,-29.541,-29.658,-29.778,-29.895,-29.912,-37.618/
*
*     grain type 6: silicate - radius 0.1 micron
      data chDstLab(6)/' Sil-0.1  '/
      data (dustp(i,6),i=1,4)/3.300e+00,1.700e+02,4.000e-05,8.200E-01/
      data ndpts(6)/157/, darea(6)/8.476e-22/, dsize(6)/1.000E-05/
      data (dstelz(i,6),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,6),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(6)/0.5883/
      data sublimat(6)/1400./
*
      data (eev(i,6),i=1,157)/ -5.000, -2.481, -2.431, -2.382, -2.332,
     Z -2.283, -2.234, -2.209, -2.184, -2.160, -2.135, -2.110, -2.085,
     Z -2.036, -2.011, -1.987, -1.962, -1.937, -1.913, -1.888, -1.863,
     Z -1.838, -1.814, -1.789, -1.764, -1.740, -1.715, -1.690, -1.666,
     Z -1.616, -1.567, -1.517, -1.468, -1.418, -1.369, -1.320, -1.270,
     Z -1.221, -1.171, -1.122, -1.073, -1.023, -0.974, -0.924, -0.875,
     Z -0.826, -0.776, -0.727, -0.677, -0.628, -0.579, -0.529, -0.480,
     Z -0.430, -0.406, -0.381, -0.332, -0.307, -0.282, -0.257, -0.208,
     Z -0.159, -0.109, -0.060, -0.010,  0.039,  0.088,  0.138,  0.187,
     Z  0.212,  0.261,  0.311,  0.360,  0.409,  0.459,  0.508,  0.558,
     Z  0.607,  0.656,  0.706,  0.755,  0.805,  0.854,  0.866,  0.911,
     Z  0.957,  1.002,  1.048,  1.093,  1.138,  1.180,  1.219,  1.256,
     Z  1.291,  1.325,  1.357,  1.389,  1.420,  1.450,  1.478,  1.504,
     Z  1.529,  1.552,  1.571,  1.584,  1.590,  1.592,  1.593,  1.604,
     Z  1.650,  1.683,  1.706,  1.719,  1.723,  1.724,  1.725,  1.771,
     Z  1.815,  1.850,  1.883,  1.913,  1.942,  1.968,  1.981,  2.026,
     Z  2.057,  2.085,  2.113,  2.131,  2.133,  2.172,  2.203,  2.231,
     Z  2.262,  2.292,  2.321,  2.350,  2.379,  2.409,  2.438,  2.471,
     Z  2.503,  2.525,  2.556,  2.589,  2.614,  2.640,  2.663,  2.696,
     Z  2.718,  2.719,  2.720,  2.763,  2.805,  2.832,  2.866,  4.866/
*
      data (sab(i,6),i=1,157)/-28.457,-23.345,-23.241,-23.124,-23.014,
     Z-22.997,-23.120,-23.187,-23.208,-23.119,-22.990,-22.869,-22.749,
     Z-22.572,-22.544,-22.703,-22.953,-23.220,-23.460,-23.629,-23.694,
     Z-23.686,-23.659,-23.650,-23.655,-23.661,-23.656,-23.643,-23.624,
     Z-23.586,-23.555,-23.524,-23.490,-23.452,-23.410,-23.366,-23.318,
     Z-23.267,-23.212,-23.154,-23.090,-23.022,-22.952,-22.879,-22.802,
     Z-22.721,-22.634,-22.532,-22.402,-22.281,-22.269,-22.258,-22.085,
     Z-22.118,-22.120,-21.934,-21.753,-21.586,-21.529,-21.524,-21.553,
     Z-21.550,-21.568,-21.588,-21.604,-21.617,-21.643,-21.689,-21.744,
     Z-21.730,-21.721,-21.723,-21.718,-21.711,-21.712,-21.713,-21.716,
     Z-21.717,-21.712,-21.714,-21.720,-21.725,-21.732,-21.738,-21.727,
     Z-21.736,-21.748,-21.760,-21.779,-21.807,-21.841,-21.879,-21.921,
     Z-21.966,-22.013,-22.060,-22.109,-22.160,-22.217,-22.276,-22.328,
     Z-22.370,-22.406,-22.444,-22.478,-22.493,-22.400,-22.136,-22.112,
     Z-22.194,-22.260,-22.309,-22.334,-22.342,-22.305,-22.128,-22.213,
     Z-22.277,-22.349,-22.422,-22.490,-22.557,-22.617,-22.648,-22.649,
     Z-22.724,-22.793,-22.862,-22.895,-22.785,-22.880,-22.959,-23.031,
     Z-23.112,-23.191,-23.269,-23.348,-23.427,-23.510,-23.590,-23.680,
     Z-23.770,-23.834,-23.922,-24.015,-24.086,-24.161,-24.228,-24.322,
     Z-24.363,-24.074,-23.841,-23.944,-24.053,-24.125,-24.228,-29.744/
*
      data (sse(i,6),i=1,157)/-38.111,-28.058,-27.868,-27.684,-27.538,
     Z-27.497,-27.435,-27.325,-27.159,-26.976,-26.823,-26.690,-26.570,
     Z-26.431,-26.468,-26.782,-27.141,-27.141,-26.880,-26.635,-26.438,
     Z-26.277,-26.140,-26.015,-25.895,-25.779,-25.665,-25.553,-25.444,
     Z-25.233,-25.026,-24.821,-24.619,-24.418,-24.218,-24.019,-23.821,
     Z-23.623,-23.427,-23.231,-23.038,-22.846,-22.659,-22.478,-22.308,
     Z-22.157,-22.035,-21.950,-21.884,-21.756,-21.614,-21.586,-21.568,
     Z-21.531,-21.501,-21.459,-21.662,-21.819,-22.086,-22.226,-22.205,
     Z-22.308,-22.310,-22.289,-22.315,-22.348,-22.324,-22.271,-22.327,
     Z-22.464,-22.620,-22.768,-22.914,-23.068,-23.160,-23.259,-23.366,
     Z-23.497,-23.616,-23.677,-23.776,-23.888,-24.010,-24.143,-24.144,
     Z-24.224,-24.324,-24.430,-24.525,-24.633,-24.742,-24.852,-24.963,
     Z-25.073,-25.183,-25.291,-25.403,-25.512,-25.622,-25.732,-25.841,
     Z-25.953,-26.064,-26.174,-26.292,-26.424,-26.588,-26.428,-26.317,
     Z-26.371,-26.483,-26.595,-26.705,-26.827,-26.877,-26.708,-26.724,
     Z-26.834,-26.944,-27.055,-27.164,-27.272,-27.381,-27.501,-27.571,
     Z-27.685,-27.794,-27.906,-28.022,-27.998,-28.106,-28.215,-28.327,
     Z-28.441,-28.562,-28.671,-28.781,-28.889,-29.017,-29.131,-29.261,
     Z-29.370,-29.479,-29.599,-29.709,-29.832,-29.941,-30.052,-30.162,
     Z-30.241,-30.259,-30.255,-30.460,-30.536,-30.645,-30.709,-37.149/
*
*     grain type 7: silicate from Kevin Volk
      data chDstLab(7)/' SilicaAGB'/
      data (dustp(i,7),i=1,4)/3.300e+00,1.700e+02,4.000e-05,8.200E-01/
      data ndpts(7)/233/, darea(7)/2.397e-21/, dsize(7)/3.536E-06/
      data (dstelz(i,7),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,7),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(7)/0.5883/
      data sublimat(7)/1400./
*
      data (eev(j,7),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,7),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
*******************
*    this is the version of Kevin Volk's pn grains that he sent
*    in November of 92.  He says that the dust mass to gas ratio is 1/223,
*    and that this is about 2/3 of ism.
      data (sab(j,7),j=1,149)/-28.202,-28.062,-27.881,-27.684,-27.450,
     C-27.186,-26.964,-26.714,-26.430,-26.202,-26.062,-25.881,-25.684,
     C-25.450,-25.186,-24.964,-24.714,-24.430,-24.202,-24.060,-23.868,
     C-23.634,-23.316,-23.172,-23.132,-23.034,-23.010,-22.986,-22.964,
     C-22.941,-22.919,-22.900,-22.879,-22.868,-22.857,-22.847,-22.831,
     C-22.828,-22.838,-22.861,-22.896,-22.937,-22.997,-23.020,-23.007,
     C-22.993,-22.988,-22.983,-22.978,-22.973,-22.951,-22.923,-22.882,
     C-22.836,-22.787,-22.752,-22.717,-22.681,-22.655,-22.624,-22.604,
     C-22.589,-22.572,-22.565,-22.551,-22.542,-22.527,-22.517,-22.501,
     C-22.483,-22.470,-22.459,-22.453,-22.447,-22.447,-22.447,-22.455,
     C-22.481,-22.517,-22.538,-22.563,-22.608,-22.655,-22.709,-22.767,
     C-22.810,-22.853,-22.923,-22.993,-23.082,-23.125,-23.148,-23.176,
     C-23.228,-23.352,-23.521,-23.548,-23.553,-23.558,-23.558,-23.559,
     C-23.559,-23.541,-23.514,-23.483,-23.451,-23.421,-23.377,-23.340,
     C-23.305,-23.258,-23.208,-23.156,-23.097,-23.040,-22.974,-22.911,
     C-22.839,-22.762,-22.689,-22.600,-22.510,-22.390,-22.257,-22.167,
     C-22.147,-22.102,-22.039,-21.947,-21.762,-21.697,-21.639,-21.580,
     C-21.530,-21.454,-21.435,-21.449,-21.462,-21.474,-21.486,-21.500,
     C-21.522,-21.545,-21.555,-21.565,-21.575,-21.593,-21.595,-21.596/
      data (sab(j,7),j=150,233)/-21.601,-21.605,-21.608,-21.611,-21.614,
     C-21.617,-21.619,-21.621,-21.623,-21.625,-21.625,-21.627,-21.628,
     C-21.684,-21.710,-21.746,-21.788,-21.835,-21.883,-21.931,-21.980,
     C-22.031,-22.082,-22.134,-22.187,-22.245,-22.306,-22.363,-22.411,
     C-22.449,-22.488,-22.526,-22.544,-22.548,-22.452,-22.181,-22.156,
     C-22.241,-22.310,-22.359,-22.387,-22.356,-22.173,-22.261,-22.327,
     C-22.403,-22.477,-22.548,-22.618,-22.681,-22.662,-22.742,-22.818,
     C-22.890,-22.953,-22.840,-22.938,-23.022,-23.102,-23.181,-23.260,
     C-23.341,-23.423,-23.505,-23.582,-23.667,-23.742,-23.832,-23.924,
     C-24.006,-24.096,-24.179,-24.270,-24.347,-24.422,-24.419,-24.130,
     C-23.897,-23.995,-24.078,-24.192,-24.276,-24.284,-27.042/
*
      data (sse(j,7),j=1,149)/-36.921,-36.642,-36.302,-35.888,-35.420,
     C-34.894,-34.451,-33.952,-33.384,-32.930,-32.651,-32.310,-31.896,
     C-31.429,-30.902,-30.459,-29.960,-29.393,-28.938,-28.652,-28.272,
     C-27.803,-27.170,-26.851,-26.673,-26.481,-26.443,-26.409,-26.375,
     C-26.337,-26.307,-26.278,-26.247,-26.215,-26.187,-26.178,-26.168,
     C-26.158,-26.147,-26.132,-26.115,-26.097,-26.070,-26.005,-25.927,
     C-25.821,-25.778,-25.732,-25.679,-25.633,-25.589,-25.552,-25.509,
     C-25.467,-25.430,-25.393,-25.371,-25.350,-25.335,-25.315,-25.296,
     C-25.277,-25.258,-25.243,-25.224,-25.211,-25.200,-25.189,-25.178,
     C-25.166,-25.155,-25.141,-25.130,-25.119,-25.108,-25.094,-25.083,
     C-25.088,-25.096,-25.102,-25.110,-25.120,-25.148,-25.212,-25.278,
     C-25.330,-25.396,-25.464,-25.536,-25.608,-25.679,-25.751,-25.795,
     C-25.836,-26.028,-26.374,-26.235,-26.094,-25.976,-25.818,-25.707,
     C-25.627,-25.460,-25.261,-25.053,-24.871,-24.667,-24.363,-24.199,
     C-24.054,-23.829,-23.626,-23.417,-23.199,-23.015,-22.815,-22.644,
     C-22.443,-22.242,-22.071,-21.876,-21.715,-21.545,-21.368,-21.215,
     C-21.117,-21.076,-21.009,-20.975,-21.086,-21.149,-21.184,-21.171,
     C-21.159,-21.138,-21.133,-21.141,-21.148,-21.154,-21.322,-21.445,
     C-21.442,-21.445,-21.450,-21.456,-21.462,-21.473,-21.490,-21.506/
      data (sse(j,7),j=150,233)/-21.512,-21.519,-21.524,-21.530,-21.534,
     C-21.538,-21.542,-21.546,-21.549,-21.551,-21.552,-21.554,-21.556,
     C-21.569,-21.683,-21.790,-21.904,-22.020,-22.135,-22.248,-22.362,
     C-22.476,-22.589,-22.705,-22.819,-22.935,-23.049,-23.162,-23.278,
     C-23.392,-23.507,-23.628,-23.749,-23.880,-23.945,-23.764,-23.649,
     C-23.710,-23.826,-23.940,-24.067,-24.222,-24.037,-24.059,-24.173,
     C-24.288,-24.402,-24.516,-24.631,-24.747,-24.861,-24.976,-25.092,
     C-25.205,-25.319,-25.343,-25.457,-25.575,-25.691,-25.805,-25.919,
     C-26.034,-26.148,-26.262,-26.377,-26.492,-26.606,-26.733,-26.856,
     C-26.973,-27.094,-27.208,-27.333,-27.447,-27.563,-27.598,-27.616,
     C-27.613,-27.726,-27.871,-27.976,-28.145,-28.149,-32.290/
*
*     grain type 8: grey opacity grains to test CLOUDY against DUSTCD
*     other constants as for grain 7  (K Volk)
      data chDstLab(8)/' Grey'/
      data (dustp(i,8),i=1,4)/3.300e+00,1.700e+02,4.000e-05,8.200E-01/
      data ndpts(8)/233/, darea(8)/2.397e-21/, dsize(8)/3.536E-06/
      data (dstelz(i,8),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,8),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(8)/0.5883/
      data sublimat(8)/2000./
*
      data (eev(j,8),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,8),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,8),j=1,233)/233*-22.882/
      data (sse(j,8),j=1,233)/233*-22.581/
*
* (K Volk) added PAH grains 30 April 1993
*
* The following is for PAHs with 120 C atoms (and 26 H atoms) based on
* the paper of Desert, Boulanger, and Puget (1990) with some values taken
* from the paper of Schutte, Tielens, and Allamdolla (1993).  The PAHs are
* of radius 0.001 microns.
*
* These grains take up about 0.25 to 0.5% of the available carbon assuming
* solar abundances, so there is no depletion of other elements.
      data chDstLab(9)/' PAH 1.0nm'/
      data DustWorkFcn(9)/0.706/
      data sublimat(9)/2000./
      data (dustp(i,9),i=1,4)/3.300e+00,1.466E+03,2.754E-08,1.000e+00/
      data ndpts(9)/259/,  darea(9)/3.461E-21/, dsize(9)/1.000E-07/
      data (sab(j,9),j=1,125)/-28.962,-28.892,-28.807,-28.703,-28.586,
     c-28.454,-28.343,-28.218,-28.076,-27.962,-27.892,-27.807,-27.703,
     c-27.586,-27.454,-27.344,-27.219,-27.079,-26.966,-26.898,-26.804,
     c-26.694,-26.552,-26.487,-26.453,-26.418,-26.412,-26.406,-26.401,
     c-26.395,-26.389,-26.383,-26.377,-26.372,-26.366,-26.361,-26.357,
     c-26.352,-26.347,-26.343,-26.339,-26.336,-26.334,-26.271,-26.072,
     c-26.002,-25.985,-25.755,-25.424,-25.421,-25.421,-25.418,-25.418,
     c-25.419,-25.755,-25.932,-25.925,-25.920,-25.472,-25.410,-25.408,
     c-25.408,-25.407,-25.407,-25.409,-25.466,-25.665,-25.910,-25.909,
     c-24.949,-24.931,-24.897,-24.898,-24.901,-24.960,-24.919,-26.141,
     c-26.346,-26.365,-26.368,-26.371,-26.374,-26.377,-26.381,-26.385,
     c-26.388,-26.392,-26.397,-26.405,-26.414,-26.424,-26.433,-26.436,
     c-26.103,-25.950,-25.814,-25.711,-25.644,-25.610,-25.526,-25.501,
     c-25.501,-25.501,-25.502,-25.503,-25.504,-25.505,-25.513,-25.362,
     c-25.112,-25.113,-25.115,-25.665,-25.672,-25.758,-25.484,-25.482,
     c-25.488,-25.503,-25.514,-26.003,-26.190,-26.494,-27.550,-27.888/
      data (sab(j,9),j=126,259)/
     c-28.227,-28.117,-26.484,-25.760,-25.753,-25.752,-25.760,-27.239,
     c-26.835,-26.457,-26.117,-25.804,-25.509,-25.241,-24.989,-24.759,
     c-24.545,-24.341,-24.155,-23.978,-23.815,-23.664,-23.520,-23.390,
     c-23.267,-23.158,-23.061,-22.977,-22.914,-22.879,-22.879,-22.879,
     c-22.879,-22.879,-22.879,-22.846,-22.785,-22.591,-22.345,-22.099,
     c-21.863,-21.783,-21.757,-21.742,-21.740,-21.741,-21.747,-21.770,
     c-21.814,-21.878,-21.967,-22.085,-22.232,-22.416,-22.636,-22.898,
     c-23.214,-23.577,-24.008,-24.493,-24.622,-25.142,-25.730,-26.353,
     c-27.020,-27.684,-28.308,-28.917,-29.511,-30.111,-30.738,-31.393,
     c-32.078,-32.815,-33.582,-34.406,-35.232,-36.052,-36.892,-37.713,
     c-38.469,-39.032,-39.302,-39.380,-39.419,-39.458,-39.894,-41.844,
     c-43.375,-44.514,-45.237,-45.448,-45.501,-48.077,-50.810,-53.261,
     c-55.694,-58.154,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,
     c-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,
     c-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,
     c-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,
     c-60.000,-60.000,-60.000,-60.000,-60.000,-60.000/
      data (sse(j,9),j=1,259) /259* -30.000/
* Assume no scattering from the PAH moelcules.  This is not really true, but
* I assume any scattering is coherent and therefore of no concern
      data (eev(j,9),j=1,146)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.16988, -2.16704, -2.167, -2.161356,
     C -2.161, -2.15845, -2.154, -2.148, -2.141, -2.134, -2.127,
     C -2.12582, -2.12267, -2.120, -2.116375, -2.116, -2.11316, -2.112,
     C -2.109, -2.105, -2.101, -2.09714, -2.097, -2.09527, -2.093,
     C -2.09158, -2.08969, -2.090, -2.086, -2.082, -2.078, -2.074,
     C -2.070, -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040,
     C -2.036, -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004,
     C -1.999, -1.995, -1.990, -1.985, -1.98330, -1.980, -1.97907,
     C -1.975, -1.97059, -1.970, -1.96623, -1.96572, -1.959, -1.94669,
     C -1.937, -1.92002, -1.91303, -1.888, -1.863, -1.83852, -1.838,
     C -1.83491, -1.82774, -1.82404, -1.814, -1.789, -1.764, -1.740,
     C -1.715, -1.666, -1.616, -1.567, -1.5620807, -1.560445, -1.55729,
     C -1.55563, -1.517, -1.468, -1.418, -1.369, -1.320, -1.270,
     C -1.221, -1.171, -1.122, -1.073, -1.023, -0.974, -0.924, -0.875/
      data (eev(j,9),j=147,259)/
     C -0.826, -0.776, -0.727, -0.677, -0.628, -0.579, -0.529, -0.480,
     C -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360,
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
*     grain type 10: 0.354 nm radius PAH grains (15 C atoms)
*
* (K Volk) added PAH grains 30 April 1993
*
* The following is for PAHs with 15 C atoms (and 9 H atoms) based on
* the paper of Desert, Boulanger, and Puget (1990) with some values taken
* from the paper of Schutte, Tielens, and Allamdolla (1993).  The PAHs are
* of radius 0.000354 microns.
*
* These grains take up about 0.25 to 0.5% of the available carbon assuming
* solar abundances, so there is no depletion of other elements.
      data chDstLab(10)/' PAH .35nm'/
      data DustWorkFcn(10)/0.706/
      data sublimat(10)/2000./
      data (dustp(i,10),i=1,4)/3.300e+00,1.890E+02,1.558E-07,1.000e+00/
      data ndpts(10)/259/,  darea(10)/2.447E-21/, dsize(10)/3.536E-08/
      data (sab(j,10),j=1,125)/-29.113,-29.043,-28.958,-28.854,-28.737,
     c-28.605,-28.494,-28.369,-28.227,-28.113,-28.043,-27.958,-27.854,
     c-27.737,-27.605,-27.494,-27.370,-27.229,-27.117,-27.049,-26.955,
     c-26.845,-26.703,-26.638,-26.604,-26.569,-26.562,-26.557,-26.551,
     c-26.545,-26.539,-26.534,-26.528,-26.522,-26.517,-26.512,-26.507,
     c-26.502,-26.498,-26.494,-26.490,-26.487,-26.484,-26.422,-26.222,
     c-26.152,-26.135,-25.670,-25.213,-25.210,-25.210,-25.209,-25.209,
     c-25.211,-25.694,-26.082,-26.076,-26.071,-25.285,-25.207,-25.205,
     c-25.205,-25.204,-25.204,-25.206,-25.280,-25.563,-26.060,-26.060,
     c-24.680,-24.660,-24.624,-24.624,-24.625,-24.684,-24.642,-26.292,
     c-26.496,-26.516,-26.518,-26.521,-26.524,-26.528,-26.532,-26.535,
     c-26.539,-26.543,-26.548,-26.556,-26.564,-26.575,-26.583,-26.586,
     c-26.254,-26.100,-25.964,-25.862,-25.795,-25.712,-25.522,-25.473,
     c-25.473,-25.473,-25.474,-25.474,-25.474,-25.476,-25.490,-25.487,
     c-25.263,-25.264,-25.265,-25.815,-25.823,-25.908,-25.634,-25.633,
     c-25.639,-25.654,-25.664,-26.153,-26.340,-26.644,-27.686,-27.982/
      data (sab(j,10),j=126,259)/
     c-28.091,-27.786,-26.182,-25.459,-25.451,-25.451,-25.459,-26.983,
     c-26.627,-26.292,-25.989,-25.710,-25.445,-25.205,-24.976,-24.768,
     c-24.573,-24.386,-24.215,-24.052,-23.902,-23.761,-23.627,-23.505,
     c-23.391,-23.288,-23.198,-23.119,-23.060,-23.029,-23.029,-23.029,
     c-23.029,-23.029,-23.029,-22.997,-22.935,-22.741,-22.495,-22.249,
     c-22.013,-21.934,-21.907,-21.893,-21.890,-21.892,-21.897,-21.921,
     c-21.965,-22.029,-22.117,-22.236,-22.382,-22.567,-22.786,-23.048,
     c-23.365,-23.728,-24.158,-24.644,-24.773,-25.292,-25.880,-26.503,
     c-27.171,-27.835,-28.458,-29.068,-29.662,-30.261,-30.888,-31.544,
     c-32.228,-32.965,-33.732,-34.557,-35.383,-36.203,-37.042,-37.863,
     c-38.620,-39.183,-39.452,-39.530,-39.569,-39.608,-40.045,-41.994,
     c-43.526,-44.664,-45.387,-45.598,-45.651,-48.227,-50.960,-53.412,
     c-55.845,-58.305,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,
     c-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,
     c-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,
     c-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,-60.000,
     c-60.000,-60.000,-60.000,-60.000,-60.000,-60.000/
      data (sse(j,10),j=1,259) /259* -30.000/
* Assume no scattering from the PAH moelcules.  This is not really true, but
* I assume any scattering is coherent and therefore of no concern
      data (eev(j,10),j=1,146)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.16988, -2.16704, -2.167, -2.161356,
     C -2.161, -2.15845, -2.154, -2.148, -2.141, -2.134, -2.127,
     C -2.12582, -2.12267, -2.120, -2.116375, -2.116, -2.11316, -2.112,
     C -2.109, -2.105, -2.101, -2.09714, -2.097, -2.09527, -2.093,
     C -2.09158, -2.08969, -2.090, -2.086, -2.082, -2.078, -2.074,
     C -2.070, -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040,
     C -2.036, -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004,
     C -1.999, -1.995, -1.990, -1.985, -1.98330, -1.980, -1.97907,
     C -1.975, -1.97059, -1.970, -1.96623, -1.96572, -1.959, -1.94669,
     C -1.937, -1.92002, -1.91303, -1.888, -1.863, -1.83852, -1.838,
     C -1.83491, -1.82774, -1.82404, -1.814, -1.789, -1.764, -1.740,
     C -1.715, -1.666, -1.616, -1.567, -1.5620807, -1.560445, -1.55729,
     C -1.55563, -1.517, -1.468, -1.418, -1.369, -1.320, -1.270,
     C -1.221, -1.171, -1.122, -1.073, -1.023, -0.974, -0.924, -0.875/
      data (eev(j,10),j=147,259)/
     C -0.826, -0.776, -0.727, -0.677, -0.628, -0.579, -0.529, -0.480,
     C -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360,
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
*     grain type 11: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(11)/' Dummy Val'/
      data (dustp(i,11),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(11)/233/, darea(11)/2.397e-21/, dsize(11)/3.536E-06/
      data (dstelz(i,11),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,11),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(11)/0.5883/
      data sublimat(11)/2000./
*
      data (eev(j,11),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,11),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,11),j=1,233)/233*-22.882/
      data (sse(j,11),j=1,233)/233*-22.581/
*     grain type 12: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(12)/' Dummy Val'/
      data (dustp(i,12),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(12)/233/, darea(12)/2.397e-21/, dsize(12)/3.536E-06/
      data (dstelz(i,12),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,12),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(12)/0.5883/
      data sublimat(12)/2000./
*
      data (eev(j,12),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,12),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,12),j=1,233)/233*-22.882/
      data (sse(j,12),j=1,233)/233*-22.581/
*     grain type 13: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(13)/' Dummy Val'/
      data (dustp(i,13),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(13)/233/, darea(13)/2.397e-21/, dsize(13)/3.536E-06/
      data (dstelz(i,13),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,13),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(13)/0.5883/
      data sublimat(13)/2000./
*
      data (eev(j,13),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,13),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,13),j=1,233)/233*-22.882/
      data (sse(j,13),j=1,233)/233*-22.581/
*     grain type 14: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(14)/' Dummy Val'/
      data (dustp(i,14),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(14)/233/, darea(14)/2.397e-21/, dsize(14)/3.536E-06/
      data (dstelz(i,14),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,14),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(14)/0.5883/
      data sublimat(14)/2000./
*
      data (eev(j,14),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,14),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,14),j=1,233)/233*-22.882/
      data (sse(j,14),j=1,233)/233*-22.581/
*     grain type 15: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(15)/' Dummy Val'/
      data (dustp(i,15),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(15)/233/, darea(15)/2.397e-21/, dsize(15)/3.536E-06/
      data (dstelz(i,15),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,15),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(15)/0.5883/
      data sublimat(15)/2000./
*
      data (eev(j,15),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,15),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,15),j=1,233)/233*-22.882/
      data (sse(j,15),j=1,233)/233*-22.581/
*     grain type 16: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(16)/' Dummy Val'/
      data (dustp(i,16),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(16)/233/, darea(16)/2.397e-21/, dsize(16)/3.536E-06/
      data (dstelz(i,16),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,16),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(16)/0.5883/
      data sublimat(16)/2000./
*
      data (eev(j,16),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,16),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,16),j=1,233)/233*-22.882/
      data (sse(j,16),j=1,233)/233*-22.581/
*     grain type 17: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(17)/' Dummy Val'/
      data (dustp(i,17),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(17)/233/, darea(17)/2.397e-21/, dsize(17)/3.536E-06/
      data (dstelz(i,17),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,17),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(17)/0.5883/
      data sublimat(17)/2000./
*
      data (eev(j,17),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,17),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,17),j=1,233)/233*-22.882/
      data (sse(j,17),j=1,233)/233*-22.581/
*     grain type 18: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(18)/' Dummy Val'/
      data (dustp(i,18),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(18)/233/, darea(18)/2.397e-21/, dsize(18)/3.536E-06/
      data (dstelz(i,18),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,18),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(18)/0.5883/
      data sublimat(18)/2000./
*
      data (eev(j,18),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,18),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,18),j=1,233)/233*-22.882/
      data (sse(j,18),j=1,233)/233*-22.581/
*     grain type 19: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(19)/' Dummy Val'/
      data (dustp(i,19),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(19)/233/, darea(19)/2.397e-21/, dsize(19)/3.536E-06/
      data (dstelz(i,19),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,19),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(19)/0.5883/
      data sublimat(19)/2000./
*
      data (eev(j,19),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,19),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,19),j=1,233)/233*-22.882/
      data (sse(j,19),j=1,233)/233*-22.581/
*     grain type 20: dummy greybody grains
* These values will be overwritten by values from a file, or not used
* (K Volk)
*
      data chDstLab(20)/' Dummy Val'/
      data (dustp(i,20),i=1,4)/3.300e+00,1.700e+02,4.000E-05,8.200E-01/
      data ndpts(20)/233/, darea(20)/2.397e-21/, dsize(20)/3.536E-06/
      data (dstelz(i,20),i=1,4)/8.000e+00,1.200e+01,1.400E+01,2.600E+01/
      data (dstela(i,20),i=1,4)/1.312e-04,3.280e-05,3.280E-05,3.280E-05/
      data DustWorkFcn(20)/0.5883/
      data sublimat(20)/2000./
*
      data (eev(j,20),j=1,149)/ -5.040, -4.970, -4.885, -4.781, -4.664,
     C -4.532, -4.421, -4.296, -4.154, -4.040, -3.970, -3.885, -3.781,
     C -3.664, -3.532, -3.421, -3.296, -3.154, -3.040, -2.970, -2.873,
     C -2.756, -2.597, -2.517, -2.472, -2.421, -2.411, -2.402, -2.393,
     C -2.383, -2.373, -2.363, -2.352, -2.341, -2.330, -2.319, -2.308,
     C -2.296, -2.283, -2.271, -2.258, -2.244, -2.231, -2.216, -2.202,
     C -2.186, -2.180, -2.174, -2.167, -2.161, -2.154, -2.148, -2.141,
     C -2.134, -2.127, -2.120, -2.116, -2.112, -2.109, -2.105, -2.101,
     C -2.097, -2.093, -2.090, -2.086, -2.082, -2.078, -2.074, -2.070,
     C -2.066, -2.062, -2.057, -2.053, -2.049, -2.045, -2.040, -2.036,
     C -2.032, -2.027, -2.023, -2.018, -2.013, -2.009, -2.004, -1.999,
     C -1.995, -1.990, -1.985, -1.980, -1.975, -1.970, -1.965, -1.959,
     C -1.937, -1.913, -1.888, -1.863, -1.838, -1.814, -1.789, -1.764,
     C -1.740, -1.715, -1.666, -1.616, -1.567, -1.517, -1.468, -1.418,
     C -1.369, -1.320, -1.270, -1.221, -1.171, -1.122, -1.073, -1.023,
     C -0.974, -0.924, -0.875, -0.826, -0.776, -0.727, -0.677, -0.628,
     C -0.579, -0.529, -0.480, -0.430, -0.381, -0.356, -0.332, -0.307,
     C -0.282, -0.233, -0.208, -0.159, -0.109, -0.060, -0.011,  0.039,
     C  0.088,  0.138,  0.162,  0.187,  0.212,  0.261,  0.311,  0.360/
      data (eev(j,20),j=150,233)/
     C  0.409,  0.459,  0.508,  0.558,  0.607,  0.656,  0.706,  0.755,
     C  0.805,  0.854,  0.866,  0.911,  0.957,  1.002,  1.048,  1.093,
     C  1.135,  1.175,  1.212,  1.247,  1.281,  1.314,  1.346,  1.378,
     C  1.409,  1.440,  1.469,  1.496,  1.522,  1.546,  1.567,  1.582,
     C  1.589,  1.591,  1.592,  1.593,  1.604,  1.650,  1.683,  1.706,
     C  1.720,  1.724,  1.725,  1.771,  1.815,  1.851,  1.884,  1.915,
     C  1.945,  1.972,  2.009,  2.042,  2.073,  2.102,  2.127,  2.133,
     C  2.173,  2.206,  2.237,  2.267,  2.297,  2.327,  2.357,  2.387,
     C  2.415,  2.446,  2.473,  2.505,  2.537,  2.566,  2.598,  2.627,
     C  2.658,  2.685,  2.712,  2.718,  2.719,  2.720,  2.761,  2.793,
     C  2.836,  2.864,  2.866,  3.866/
*
* Scattering efficiency set to half the absorption efficiency
      data (sab(j,20),j=1,233)/233*-22.882/
      data (sse(j,20),j=1,233)/233*-22.581/
* Note that grain types 11 to 20 are read in from files, so there are dummy
* data values for these grain types here.  If you add a grain, increase NDUST
* to 21, change the duplicate values to grain types 12 to 21, and put your grain
* as grain 11 (K Volk)
*
      end
******************************************************************************
      subroutine mean
      implicit none
*derive mean ionization fractions over computed structure
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     xIonMeans(nelem, stage,type)
*     stage=0 is integrated sum of all
*     type = 1 is radius integration, 2=vol
      real xIonMeans
      common/IonMeans/ xIonMeans(limelm,0:limelm+1,2)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real r1r0sq
      common/r1r0sq/ r1r0sq
*
*     local variables
      real sumrad  , sumvol , dc  , dcv
      integer nelem , i
*
      do nelem=1,limelm
        sumrad = 0.
        sumvol = 0.
        do i=1,nelem+1
          dc = xIonFracs(nelem,i) *drad*FillFac
*         xIonMeans(n,i,1) is radial integration
          xIonMeans(nelem,i,1) = xIonMeans(nelem,i,1) + dc
*         xIonMeans(n,i,2) is vol integration
          dcv = dc * r1r0sq
          xIonMeans(nelem,i,2) = xIonMeans(nelem,i,2) + dcv
          sumrad = sumrad + dc
          sumvol = sumvol + dcv
        end do
        xIonMeans(nelem,0,1) = xIonMeans(nelem,0,1) + sumrad
        xIonMeans(nelem,0,2) = xIonMeans(nelem,0,2) + sumvol
      end do
*
      end
******************************************************************************
      subroutine metdif
      implicit none
*add diffuse fields to local reflected and outward radiation fields
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real opac
      common/opac/ opac(ncell)
      real tmn
      common/tmn/ tmn(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      double precision he2bol , he2cbt
      common/he2blt/ he2bol(nhe2lvl-1,nhe2lvl+1) , he2cbt(nhe2lvl+1)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      real r1r0sq
      common/r1r0sq/ r1r0sq
*these are a series of lines and continuua that are set in hediff and
*carried outward in metdif
      real esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      common/heots/ esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      integer ipHe23sGrnd
*pointer to He 23s to ground decay
      common/ip626/ ipHe23sGrnd
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      real DiffusHeavy , xLyaHeavy
*DiffusHeavy is total rec rate to grnd for nelem,ion element
*xLyaHeavy is Lya for nelem,ion
      common/DiffHeav/ DiffusHeavy(limelm,limelm),
     1 xLyaHeavy(limelm,limelm)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      integer ip374 , ip660
      common/pbowen/ ip374 , ip660
*     fekhot, fekcld, number of photons in hot and cold iron, per unit vol
*     ipkhot, ipkcld are pointers to energies
      real fekhot , fekcld
      integer ipkhot , ipkcld
      common/fekems/ fekhot , fekcld , ipkhot , ipkcld
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      real H12phtOTS , He12phtOTS , He22phtOTS
      integer ipH12pht , ipHe12pht , ipHe22pht
      common/hhe2phtots/ H12phtOTS , He12phtOTS , He22phtOTS,
     1 ipH12pht , ipHe12pht , ipHe22pht
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      integer iophe2
      common/iophe2/ iophe2(9)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real Diff2Pht
*total local two photon emission
      common/dif2nu/ Diff2Pht(ncell)
      real DiffCont
*diffus is local diffuse continuum, for current zone
      common/diffus/ DiffCont(ncell)
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
*     include "facexp.com"
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      real ThrowOut(ncell)
*this is the spectrum of continuum thrown into the outward beam
      common/ThroOut/ ThrowOut
      real SavOutCon(ncell)
*     variables related to deriving the ratio of outward to incident continuum
*     SumOutMax - energy where max occurs, ipSumOutMax pointer to this
*     sumOutCon is summed out outlin and outcon less SavOutCon for all energy
*     SumHOutCon is H-ionizing only
      real SumOutCon , SumIncCon , SumHOutCon , SumHIncCon , SumOutMax
      integer ipSumOutMax
      common/SumOutInc/ SumOutCon , SumIncCon , SavOutCon , SumHOutCon ,
     1 SumHIncCon , SumOutMax , ipSumOutMax
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
      real OutFac , RefFac , BeamInIn,BeamInOut,BeamOutOut
*     outward and reflected effective vols
*     used to get outward and reflected beams
*     Beam vars are related to lines where inward and outward fracs known
*     BeamOutOut outward part of outwardly directed beam
*     BeamInIn inward part of inwardly directed beam, 0 if sphere
*     BeamInOut outward part of inwardly directed beam, 0 if not sphere
      common/VolRef/ OutFac , RefFac , BeamInIn,BeamInOut,BeamOutOut
      real hfrcin
      common/hfrcin/ hfrcin(lmhlvl,lmhlvl-1)
*save total grain emission from this zone, per unit vol,
*for add outward in metfic
      real GrainEmission
      common/GrainEmis/ GrainEmission(ncell)
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
*     indicate whether plasma freq ever entered energy array
      logical lgPlasNu
*     this is the plasma frequency
      real plsfrq
*     this is the continuum pointer to the plasma frequency, and largest it ever
      integer ipPlasma, ipPlasmax
      common/plasnu/ lgPlasNu , plsfrq , ipPlasma, ipPlasmax
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real factor
*     character*10 char , chLineLbl
      parameter (factor=0.5)
      integer ihi,ilo,i,ip,nelem,ipla , i1
      real outwrd,bf,esc,diffuse,ots, difflya,xInWrd
*     real save1(9) , save2(9)
*
*     many tmn added to conserve energy in very high Z models
*     rerun highZ qso model if any tmn ever deleted here
*
*     free statement number >= 45
*
*     use duffuse lines and continuum to add flux to outward beam
*
*     NB!!!  this routine adds flux to the outward beam
*            it can only be called once per zone
*
*     covrt is radiative transfer covering factor
*     covrt = 0 for open geometry
*     covrt = 1 for closed geometry
*
*     outwrd is fraction that goes outward, of the escaping line radiation
*     default covrt is zero for open geometry, is 1 for closed
*     outwrd is 1/2 for opten, 1 for closed
      outwrd = (1.+covrt)/2.
*
      if( lgTrace ) write(qq,'('' metdif called.'')')
*
*     >>chng 96 nov 19, do not consider energies below plasma freq
*     i1 points to lowest energy thin to brems and plas freq
      i1 = max( ipPlasma,1)
*
*     radius is the outer edge of the current zone
*     OutFac = outwrd * dreff
*     >>chng 95 nov 16
*     OutFac = outwrd * dreff * ( radius/(radius+drad) )**2
*     dreff in upper since fill fac enters, but not in lower
*     >>chng 96 may 8, moved to zonsrt
*     OutFac = outwrd * radius * dreff / (radius + 2.*drad)
*
*     save contents of outcon for checking how much was added
      do i=1,nflux
        SavOutCon(i) = outcon(i) + outlin(i)
      end do
*
*     following used for beamed fields, which have already taken accout of
*     inward vs outward escape, only count out if sphere
*     dreff is drad * FillFac
      bf = covrt * radius * dReff / (radius + 2.*drad)
*     >>chng 96 may 8, moved to zonsrt
*     RefFac = (1.-outwrd) * dReff * r1r0sq
*     OutFac = outwrd * radius * dReff / (radius + 2.*drad)
*
*     continuum interaction arrays that occur here:
*
*     ContDiff - not counted in internal energy budget
*     of the cloud, used to get pretty plots afterwards
*
*     outcon, outward only continuum, inc in heating rates
*     otscon, otslin, loc ots rates, inc in heating
*
*  HI   HI   HI   HI    HI   HI   HI   HI   HI   HI
*
*     Ly-alpha special since 2s2p resolved
*     >>chng 96 july 11, did not use computed fractions, assumed 50-50 before
      xInWrd = hn2p*hii*hemis(2,1)*hfrcin(2,1)
      reflin(iphl(2,1)) = reflin(iphl(2,1)) + xInWrd*BeamInIn
*     inward beam that goes out since sphere set
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(iphl(2,1)) = outlin(iphl(2,1)) + xInWrd*BeamInOut*
     1 tmn(iphl(2,1))
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(iphl(2,1)) = outlin(iphl(2,1)) + hn2p*hii*hemis(2,1)*
     1 (1.-hfrcin(2,1)) * BeamOutOut*
     1 tmn(iphl(2,1))
*
*     hydrogen lyman lines
*     >>chng 96 july 11, did not use computed fractions, assumed 50-50 before
*     >>chng 96 july 16, had top level
      do ihi=3,min(25,nhlvl-1)
        xInWrd = hn(ihi)*hii*hemis(ihi,1)*hfrcin(ihi,1)
        reflin(iphl(ihi,1)) = reflin(iphl(ihi,1)) + xInWrd*BeamInIn
*       >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
        outlin(iphl(ihi,1)) = outlin(iphl(ihi,1)) + xInWrd*BeamInOut*
     2  tmn(iphl(ihi,1))
        outlin(iphl(ihi,1)) = outlin(iphl(ihi,1)) +
     1  hn(ihi)*hii*hemis(ihi,1)*(1.-hfrcin(ihi,1))*BeamOutOut*
     2  tmn(iphl(ihi,1))
      end do
*
*     hydrogen lines
      do ilo=2,nhlvl-2
        do ihi=ilo+1,min(25,nhlvl-1)
*         outlin(iphl(ihi,ilo)) = outlin(iphl(ihi,ilo)) +
*    1    hn(ihi)*hii*hemis(ihi,ilo)*OutFac*tmn( iphl(ihi,ilo) )
*         reflin(iphl(ihi,ilo)) = reflin(iphl(ihi,ilo)) +
*    1    hn(ihi)*hii*hemis(ihi,ilo)*RefFac
*         >>chng 96 july 11, did not use computed fractions, assume 50-50 before
          xInWrd = hn(ihi)*hii*hemis(ihi,ilo)*hfrcin(ihi,ilo)
          reflin(iphl(ihi,ilo)) = reflin(iphl(ihi,ilo))+xInWrd*BeamInIn
*         >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
          outlin(iphl(ihi,ilo)) = outlin(iphl(ihi,ilo))+xInWrd*BeamInOut
     2    *tmn(iphl(ihi,ilo))
*         >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
          outlin(iphl(ihi,ilo)) = outlin(iphl(ihi,ilo)) +
     1    hn(ihi)*hii*hemis(ihi,ilo)*(1.-hfrcin(ihi,ilo))*BeamOutOut*
     2    tmn(iphl(ihi,ilo))
        end do
      end do
*
*     all locally destroyed two photon continua of H, HeI, HeII
      if( H12phtOTS.lt.0. ) then
        write(qq,'('' metdif found negative OTS CON, H12phtOTS'',
     1  '' val='',1p,e10.1)')H12phtOTS
        call ShowMe
        stop
      endif
*     ots = H12phtOTS / opac(ipH12pht)
      call AddOTSCon( H12phtOTS , ipH12pht )
*
      if( He12phtOTS.lt.0. ) then
        write(qq,'('' metdif found negative OTS CON, He12phtOTS'',
     1  '' val='',1p,e10.1)')He12phtOTS
        call ShowMe
        stop
      endif
      call AddOTSCon( He12phtOTS , ipHe12pht )
*
      if( He22phtOTS.lt.0. ) then
        write(qq,'('' metdif found negative OTS CON, He22phtOTS'',
     1  '' val='',1p,e10.1)')He22phtOTS
        call ShowMe
        stop
      endif
      call AddOTSCon( He22phtOTS , ipHe22pht )
*
* He II   He II   He II    He II   He II  He II   He II
*
*     He II Ly-alpha special since 2s2p resolved
*     and bowen gets much of line (reason for fac of 0.5)
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(iphe2l(2,1)) = outlin(iphe2l(2,1)) +
     1 esc304 *OutFac * tmn(iphe2l(2,1))
      reflin(iphe2l(2,1)) = reflin(iphe2l(2,1)) +
     1 heiii*he22p*he2mis(2,1)*RefFac
*
*     HeII higher lyman lines
*     >>chng 96 july 16, had only gone up to 6
      do ihi=3,nhe2lvl-1
*       >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
        outlin(iphe2l(ihi,1)) = outlin(iphe2l(ihi,1)) +
     1  heiii*he2n(ihi)*he2mis(ihi,1)*OutFac*tmn(iphe2l(ihi,1))
        reflin(iphe2l(ihi,1)) = reflin(iphe2l(ihi,1)) +
     1  heiii*he2n(ihi)*he2mis(ihi,1)*RefFac
      end do
*
*     He II ionized helium lines
*     >>chng 96 july 16, had only gone up to 6
      do ilo=2,nhe2lvl-2
        do ihi=ilo+1,nhe2lvl-1
*       >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
          outlin(iphe2l(ihi,ilo)) = outlin(iphe2l(ihi,ilo)) +
     1    heiii*he2n(ihi)*he2mis(ihi,ilo)*OutFac*tmn(iphe2l(ihi,ilo))
          reflin(iphe2l(ihi,ilo)) = reflin(iphe2l(ihi,ilo)) +
     1    heiii*he2n(ihi)*he2mis(ihi,ilo)*RefFac
        end do
      end do
*
*  HeI  He I   He I   He I   He I   He I   He I   He I
*     outward part of escaping He I Ly alpha hei lya
      reflin(iphe1l(2,1) ) = reflin(iphe1l(2,1) ) + RefFac*esc584
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(iphe1l(2,1) ) = outlin(iphe1l(2,1) ) +
     1 OutFac*esc584*tmn(iphe1l(2,1))
*     95 nov 2 removed tmn from last term
*    1 bf*esc584
*
*     HeI higher lyman lines
*     >>chng 96 july 16, had only gone up to 6
      do ihi=3,nhe1lvl-1
*       >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
        outlin(iphe1l(ihi,1)) = outlin(iphe1l(ihi,1)) +
     1  heii*he1n(ihi)*he1mis(ihi,1)*OutFac*tmn(iphe1l(ihi,1))*
     1  tmn(iphe1l(ihi,1))
        reflin(iphe1l(ihi,1)) = reflin(iphe1l(ihi,1)) +
     1  heii*he1n(ihi)*he1mis(ihi,1)*RefFac
      end do
*
*     helium 1 triplet lines
      outlin(ipHe3l(1)) = outlin(ipHe3l(1)) + p10830/1.84e-12 *
     1 OutFac*tmn(ipHe3l(1))
      outlin(ipHe3l(2)) = outlin(ipHe3l(2)) + p5876/3.39e-12 *
     1 OutFac*tmn(ipHe3l(2))
      outlin(ipHe3l(3)) = outlin(ipHe3l(3)) + p7065/2.82e-12 *
     1 OutFac*tmn(ipHe3l(3))
      outlin(ipHe3l(4)) = outlin(ipHe3l(4)) + p3889/5.12e-12 *
     1 OutFac*tmn(ipHe3l(4))
*
      reflin(ipHe3l(1)) = reflin(ipHe3l(1)) + p10830/1.84e-12 *
     1 RefFac*tmn(ipHe3l(1))
      reflin(ipHe3l(2)) = reflin(ipHe3l(2)) + p5876/3.39e-12 *
     1 RefFac*tmn(ipHe3l(2))
      reflin(ipHe3l(3)) = reflin(ipHe3l(3)) + p7065/2.82e-12 *
     1 RefFac*tmn(ipHe3l(3))
      reflin(ipHe3l(4)) = reflin(ipHe3l(4)) + p3889/5.12e-12 *
     1 RefFac*tmn(ipHe3l(4))
*
*     He I ionized helium singlet lines
*     >>chng 96 july 16, had only gone up to 6
      do ilo=2,nhe1lvl-2
        do ihi=ilo+1,nhe1lvl-1
*         >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
          outlin(iphe1l(ihi,ilo)) = outlin(iphe1l(ihi,ilo)) +
     1    heii*he1n(ihi)*he1mis(ihi,ilo)*OutFac*tmn(iphe1l(ihi,ilo))
          reflin(iphe1l(ihi,ilo)) = reflin(iphe1l(ihi,ilo)) +
     1    heii*he1n(ihi)*he1mis(ihi,ilo)*RefFac
        end do
      end do
*
*     95 nov 2 removed tmn
*     >>chng 96 nov 20, added tmn, needed for zoning in hizqso model
      outlin(ipHe23sGrnd) = outlin(ipHe23sGrnd) +
     1  OutFac*out626*tmn(ipHe23sGrnd)
      reflin(ipHe23sGrnd) = reflin(ipHe23sGrnd) + RefFac*out626
*
      outlin(ip660) = outlin(ip660) + OutFac*esc660*tmn(ip660)
      reflin(ip660) = reflin(ip660) + RefFac*esc660
*
      if( chDffTrns.eq.'OTS' ) then
*       pick up these continua here if we are not doing outward only
*       hydrogen two photon emission
*       if outward only then add two photon to outcon, and
*       subtract it from diffuse field since this is added
*       just below
        do i=i1,iphe2l(2,1)
          outcon(i) = outcon(i) + Diff2Pht(i) * OutFac*tmn(i)
          refcon(i) = refcon(i) + Diff2Pht(i) * RefFac*tmn(i)
        end do
*
        do i=i1,nflux
*         continuum not used for heating, just pretty pictures
*         add it here - outward approximation will do it in outcon
          ContDiff(i) = ContDiff(i) + DiffCont(i)*OutFac*tmn(i)
        end do
*
*     option for outward only continuum
      else if( chDffTrns(1:2).eq.'OU' ) then
*       continuum is zero below i1
        do i=i1,nflux
*         outcon is the interactive continuum
*         ExpZone is attenuation across one zone
*         ThrowOut is amount throun into outward beam
          outcon(i) = outcon(i) + ThrowOut(i)*OutFac*tmn(i)
        end do
        do i=1,nflux
*         >>chng 96 july 13, add extra grain emiss to save out, so it is
*         not counted in effective sum - benign source of radiation
          SavOutCon(i) = SavOutCon(i) + GrainEmission(i)*OutFac*tmn(i)
        end do
*
      else
*       dtrans was neither one nor other, this is impossible
        write(qq,'('' chDffTrns='',A3,'' in METDIF.  This is '',
     1  ''impossible.'')') chDffTrns
        stop
      endif
*
*begin sanity check
      do i=1,nTauLines
        if( TauLines(ipLnNPhots,i)*TauLines(ipLnColovTOT,i).lt.0.)then
          write(qq,'('' METDIF finds insane NPohts*ColovTot for '',
     1    ''level 1 line, vals='',1p,2e10.1)')
     2    TauLines(ipLnNPhots,i),TauLines(ipLnColovTOT,i)
          call DumpLine( TauLines(1,i) )
          call ShowMe
          stop
        endif
      end do
*end sanity check
*
*     outward line photons
      do i=1,nTauLines
*       pointer to line energy in continuum array
        ip = TauLines(ipLnIpCont,i)
*       last factor does not accout for frac of lines pumped
*       ExpZone => tmn 95 nov 2
*       >>chng 96 july 11, did not use computed fractions, assumed 50-50 before
        xInWrd = TauLines(ipLnNPhots,i)*TauLines(ipLnInwd,i)
        reflin(ip) = reflin(ip) + xInWrd*BeamInIn
*       inward beam that goes out since sphere set
        outlin(ip) = outlin(ip) + xInWrd*BeamInOut* tmn(ip)*
     1  TauLines(ipLnColovTOT,i)
*       >>chng 96 july 16, added ipLnColovTOT
        outlin(ip) = outlin(ip) +
     1  TauLines(ipLnNPhots,i)*(1.-TauLines(ipLnInwd,i)) * BeamOutOut*
     2  tmn(ip) * TauLines(ipLnColovTOT,i)
*       >>chng 96 july 16, added ipLnColovTOT
      end do
*
*begin sanity check
      do i=1,NWINDLINE
        if( WindLine(ipLnNPhots,i)*WindLine(ipLnColovTOT,i).lt.0.)then
          write(qq,'('' METDIF finds insane NPohts*ColovTot for '',
     1    ''level 2 line, vals='',1p,2e10.1)')
     2    WindLine(ipLnNPhots,i),WindLine(ipLnColovTOT,i)
          call DumpLine( WindLine(1,i) )
          call ShowMe
          stop
        endif
      end do
*end sanity check
*
*     outward line photons
      do i=1,NWINDLINE
*       NB if this changes, then EmitFe2 in KatyaFe2 (Fe2 sub dir)
*       probably needs to change too
*       pointer to line energy in continuum array
        ip = WindLine(ipLnIpCont,i)
*       last factor does not accout for frac of lines pumped
*       ExpZone => tmn 95 nov 2
*       >>chng 96 july 11, did not use computed fractions, assumed 50-50 before
        xInWrd = WindLine(ipLnNPhots,i)*WindLine(ipLnInwd,i)
        reflin(ip) = reflin(ip) + xInWrd*BeamInIn
*       inward beam that goes out since sphere set
        outlin(ip) = outlin(ip) + xInWrd*BeamInOut*tmn(ip)*
     1  WindLine(ipLnColovTOT,i)
*       >>chng 96 july 16, added ipLnColovTOT to above
*       >>chng 96 july 16, need tmn to stop outward line from dominating
*       deep in thick cloud
        outlin(ip) = outlin(ip) +
     1  WindLine(ipLnNPhots,i)*(1.-WindLine(ipLnInwd,i)) * BeamOutOut*
     2  tmn(ip) * WindLine(ipLnColovTOT,i)
*       >>chng 96 july 16, added ipLnColovTOT
      end do
*
      if( chFeIIAtom.eq.'Verner' ) then
*       this will do the above, adding FeII to reflected, outward beam
        if( xIonFracs(26,2).gt.0..and..not.lgSimKatya)
     1  call EmitFe2( OutFac , RefFac )
      else if( chFeIIAtom.ne.'Netzer' ) then
        write(qq,'('' metdif has insane chFeIIAtom'')')
        stop
      endif
*
*     factor=0.5 in parameter above is damper for ots continuum
*     rec producing ionizing radiation
      do nelem=3,limelm
        do i=1,nelem-1
          if( xIonFracs(nelem,i+1).gt.0. ) then
            ip = ipHeavy(nelem,i)
*           receff is escape prob from this zone
*           esc = receff( ip+1 )
*           this is exp(-tau zone)
*           this is extinction to face
            esc = ExpmTau(ip)
*           DiffusHeavy is rad rec to ground, with electron density,
*           it is evaluated in routine MakeRecomb
            diffuse = DiffusHeavy(nelem,i)* xIonFracs(nelem,i+1)
            if( opac(ip).gt.0. ) then
              ots = diffuse * min(0., 1.-esc ) / opac( ip )
            else
              ots = 0.
            endif
            ots = factor * ots + otscon(ip)*(1.-factor)
            ots = ots * opac(ip)
            if( ots.lt.0. ) then
              write(qq,'('' metdif found negative OTS heav, n='',2i4,
     1        '' val='',1p,e10.1,'' nzone='',i4)')nelem,i, ots,nzone
              call ShowMe
              stop
            endif
            Call AddOTSCon( ots , ip )
*           otscon(ip) = ots
*           >>chng 97 Apr 28, remove frm reflected continuum since should
*           not be line
*           refcon(ip) = refcon(ip) + diffuse*esc*RefFac
*           ExpZone => tmn 95 nov 2
            outcon(ip ) = outcon(ip ) + diffuse*OutFac*esc*tmn(ip)
*           now do the recombination Lya
            ipla = ipLyHeavy(nelem,i)
            esc = ExpmTau(ipla)
*           xLyaHeavy is set to a fraction of rad rec in MakeRecomb
            difflya = xLyaHeavy(nelem,i) * xIonFracs(nelem,i+1)
*begin sanity check
            if( difflya.lt.0. ) then
              write(qq,'('' METDIF Negative Lya flux for element, ion=''
     1        ,2i4)')nelem,i
              write(qq,'('' METDIF xLyaHeavy, xIonFracs='',1p,2e10.2)')
     1        xLyaHeavy(nelem,i) , xIonFracs(nelem,i+1)
              Call ShowMe
              stop
            endif
*end sanity check
*           ExpZone => tmn 95 nov 2
*           >>chng 97 apr 28, next two had extra factor of outwrd
            outlin( ipla ) = outlin(ipla) + difflya *OutFac *
     1      tmn(ipla) * esc
            reflin( ipla ) = reflin(ipla) + difflya *RefFac *
     1      tmn(ipla) * esc
            ots = difflya * min(0.,1.-esc)
            if( ots.lt.0. ) then
              write(qq,'('' metdif found negative OTS line heav'',2i4,
     1        '' val='',1p,e10.1)')nelem,i , ots
              write(qq,'('' 1-esc ='',1p,e10.2)') 1.-esc
              call ShowMe
              stop
            endif
            call AddOTSLin( ots , ipla , 0.5 )
          else
*           abundance  is zero
            ip = ipHeavy(nelem,i)
            ots = 0.
            Call AddOTSCon( ots , ip )
            ipla = ipLyHeavy(nelem,i)
            call AddOTSLin( ots , ipla , 0.5 )
          endif
        end do
      end do
*
*     Fe Auger K-alpha in outward only
*     first is rec plus hot auger
*     this is pointer to valence shell Lya
*     >>chng 97 apr 28, had been 26,20, so picked up vastly wrong energy for Ka
*     improve to real pointers for line
*     >>chng 96 nov 20, added tmn to two below, to prevent line from
*     overwhelming very thick models
*     >>chng 97 apr 28, put in reflected Ka, had been only outward
*     outlin(ip) = outlin(ip) + fekhot/1.11e-8 * dReff *
      outlin(ipkhot) = outlin(ipkhot) + fekhot*OutFac*tmn(ipkhot)
      reflin(ipkhot) = reflin(ipkhot) + fekhot * RefFac
*     >>chng 97 apr 28, put in reflected Ka, had been only outward
*     this is cold iron, one cell below hot
*     outlin(ip-1) = outlin(ip-1) +fekcld/1.03e-8*dReff*
      outlin(ipkcld) = outlin(ipkcld) +fekcld*OutFac*tmn(ipkcld-1)
      reflin(ipkcld) = reflin(ipkcld) +fekcld*RefFac
*     save1(7) = outlin(1384)
*     save2(7) = outlin(1879)
*
*     now figure out how much we added to the beam
*     this is used for setting zone thickness - do not want to
*     add too much energy in outward beam
      SumOutCon = 0.
      SumIncCon = 0.
      ots = 0.
*     this will be photon energy where this peak occurs
      SumOutMax = 0.
      do i=1,ipHn(1)-1
*       >>chng 96 jan 14, was photon number, now energy
*       >>chng 96 nov 19, save difference in SavOutCon array, for later punch
        SavOutCon(i) = max(0.,outlin(i)+outcon(i)-SavOutCon(i))
        esc = SavOutCon(i) * opac(i) * anu(i)
        if( esc.gt.ots ) then
          ots = esc
          SumOutMax = anu(i)
          ipSumOutMax = i
        endif
*       the ratio of SumOutCon to SumIncCon is kept below 5% in nextdr
        SumOutCon = SumOutCon + esc
*       >>chng 96 nov 18, add outcon, outlin to sum
*       SumIncCon = SumIncCon + (flux(i)+otscon(i)+otslin(i)) *opac(i)*
        SumIncCon = SumIncCon +
     1  (flux(i)+otscon(i)+otslin(i)+outcon(i)+outlin(i) ) *
     1  opac(i)* anu(i)
      end do
      SumHOutCon = 0.
      SumHIncCon = 0.
*     this will be sum of H-ionizing continuum
*     >>chng 96 jan 14, was photon number, now energy
      do i=ipHn(1),nflux
*       esc = ( outlin(i)+outcon(i)-SavOutCon(i) )* opac(i)* anu(i)
        SavOutCon(i) = max(0.,outlin(i)+outcon(i)-SavOutCon(i))
        esc = SavOutCon(i) * opac(i) * anu(i)
        if( esc.gt.ots ) then
          ots = esc
          SumOutMax = anu(i)
          ipSumOutMax = i
        endif
        SumHOutCon = SumHOutCon + esc
*       >>chng 96 nov 18, add outcon, outlin to sum
        SumHIncCon = SumHIncCon +
     1  (flux(i)+otscon(i)+otslin(i)+outcon(i)+outlin(i))*opac(i)*
     1  anu(i)
      end do
      SumOutCon = SumOutCon + SumHOutCon
      SumIncCon = SumIncCon + SumHIncCon
*     write(60,'(i4,1p,7e9.1)')nzone, (save1(i)/max(1.,save1(1)),i=1,7)
*     write(61,'(i4,1p,7e9.1)')nzone, (save2(i)/max(1.e-20,save2(1)),
*    1 i=1,7)
*
      if( lgTrace ) write(qq,'('' metdif returns.'')')
*
      end
******************************************************************************
      subroutine metprt
      implicit none
*print he, heavy element optical depths, call prtmet
      integer nhetau
      parameter (nhetau=4)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
*     include "he3tau.arr"
      real he3tau
      common/he3tau/ he3tau(nta,nhetau)
      integer nfst
      parameter (nfst=39)
      integer ndfst
      parameter (ndfst=5)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      write(qq,'('' TauInc updated optical depths:'')')
*
      write(qq,'(''    He trp:'',1P,3E9.2,'' Sin:'',3E9.2,
     1'' II:'',3E9.2/'' 10830:'',3E9.2,'' 3889:'',3E9.2,'' 5876:'',
     23E9.2/'' 584:'',3E9.2,'' 304:'',3E9.2,'' 7065:'',3E9.2)') he3tau
*
      call prtmet
*
      end
******************************************************************************
      subroutine mihals( nstar , par1 , par2 , nspec )
      implicit none
*generate continuum from Mihalas stellar atmosphere
      integer nstar , nspec
      real par1 , par2
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer mtemp
      real temp, alogg
      integer ndata
      parameter (ndata=47)
      real wl(ndata) , t40g4(ndata) , t375g4(ndata) , t35g4(ndata) ,
     1 t45g4(ndata) , t50g4(ndata) , t55g4(ndata) , t325g4(ndata) ,
     2 t30g4(ndata)
      integer i
      real fac1 , fac2
*
*     following atmospheres NLTE from Mihalas, NCAR-TN/STR-76
      data wl/
     1 87.7939, 75.0851, 62.3770, 62.3760, 53.1367,
     2 43.8975, 43.8965, 38.6940, 38.6930, 31.7719,
     3 24.8510, 24.8500, 22.3465, 19.8430, 19.8420,
     4 17.3087, 14.7749, 13.5080, 12.2411, 11.6077,
     5 10.9750, 10.9740, 10.2883,  9.7549,  8.2307,
     6  6.5541,  4.8780,  4.8770,  3.8105,  2.7440,
     7  2.7430,  2.4006,  2.0577,  1.7564,  1.7554,
     8  1.5242,  1.2199,  1.2189,  0.9526,  0.6864,
     9  0.6854,  0.5335,  0.4395,  0.4385,  0.2212,
     *  0.0033,  1E-4/
      data t30g4/
     1 51.490, 43.717, 35.900, 35.898, 30.234,
     2 24.636, 22.972, 19.877, 20.031, 15.728,
     3 11.647, 11.199,  9.782,  8.417,  4.205,
     4  3.631,  2.850,  2.413,  1.965,  1.741,
     5  1.520, -1.931, -1.923, -1.909, -1.828,
     6 -1.645, -1.317, -1.323, -0.993, -0.510,
     7 -0.748, -0.517, -0.243,  0.048,  0.048,
     8  0.312,  0.740,  0.695,  1.186,  1.852,
     9  1.840,  2.359,  2.764,  2.761,  4.202,
     * 13.107, 20.699/
      data t325g4/
     1 43.608, 36.844, 30.128, 30.114, 25.301,
     2 20.573, 17.983, 15.386, 13.113, 10.637,
     3  7.128,  6.695,  5.527,  4.367,  1.771,
     4  1.418,  0.933,  0.646,  0.341,  0.185,
     5  0.029, -2.016, -2.011, -1.999, -1.926,
     6 -1.750, -1.421, -1.437, -1.088, -0.569,
     7 -0.764, -0.529, -0.248,  0.049,  0.049,
     8  0.319,  0.754,  0.718,  1.214,  1.884,
     9  1.875,  2.395,  2.801,  2.798,  4.238,
     * 13.143, 20.735/
      data t35g4 /
     1 37.814, 31.886, 26.019, 25.986, 21.790,
     2 17.670, 14.982, 12.661,  4.193,  4.020,
     3  2.826,  2.747,  2.082,  1.283,  0.696,
     4  0.388,  0.017, -0.192, -0.410, -0.521,
     5 -0.631, -2.056, -2.049, -2.038, -1.964,
     6 -1.790, -1.462, -1.488, -1.138, -0.605,
     7 -0.761, -0.527, -0.248,  0.049,  0.048,
     8  0.319,  0.756,  0.728,  1.225,  1.895,
     9  1.886,  2.408,  2.814,  2.812,  4.249,
     * 13.184, 20.776/
      data t375g4/
     1 33.776, 28.424, 23.152, 23.069, 19.318,
     2 15.642, 13.211, 11.053,  2.397,  1.888,
     3  1.150,  1.143,  0.731,  0.221,  0.097,
     4 -0.171, -0.475, -0.637, -0.803, -0.886,
     5 -0.966, -2.102, -2.093, -2.079, -2.000,
     6 -1.820, -1.487, -1.518, -1.166, -0.628,
     7 -0.756, -0.524, -0.246,  0.048,  0.047,
     8  0.317,  0.753,  0.730,  1.225,  1.893,
     9  1.888,  2.407,  2.812,  2.811,  4.249,
     * 13.207, 20.799/
      data t40g4/
     1 31.030, 26.058, 21.192, 21.030, 17.596,
     2 14.242, 11.981,  9.539,  1.543,  0.939,
     3  0.289,  0.289,  0.002, -0.337, -0.355,
     4 -0.587, -0.838, -0.969, -1.100, -1.164,
     5 -1.225, -2.158, -2.146, -2.130, -2.040,
     6 -1.856, -1.514, -1.547, -1.191, -0.647,
     7 -0.758, -0.525, -0.247,  0.049,  0.046,
     8  0.316,  0.752,  0.734,  1.228,  1.896,
     9  1.892,  2.411,  2.817,  2.816,  4.256,
     * 13.215, 20.807/
      data t45g4 /
     1 26.168, 21.629, 17.233, 16.584, 13.538,
     2 10.627,  3.420,  2.306,  0.525, -0.082,
     3 -0.662, -0.662, -0.864, -1.063, -1.060,
     4 -1.242, -1.418, -1.503, -1.583, -1.620,
     5 -1.655, -2.257, -2.239, -2.219, -2.123,
     6 -1.925, -1.570, -1.595, -1.231, -0.675,
     7 -0.765, -0.530, -0.249,  0.049,  0.046,
     8  0.319,  0.759,  0.743,  1.240,  1.913,
     9  1.910,  2.431,  2.839,  2.838,  4.281,
     * 13.235, 20.827/
      data t50g4 /
     1 23.826, 19.658, 15.626, 14.645, 11.833,
     2  9.190,  0.621, -0.005, -0.199, -0.733,
     3 -1.241, -1.241, -1.412, -1.572, -1.571,
     4 -1.717, -1.843, -1.897, -1.942, -1.961,
     5 -1.976, -2.330, -2.307, -2.283, -2.178,
     6 -1.972, -1.610, -1.622, -1.254, -0.690,
     7 -0.768, -0.532, -0.250,  0.049,  0.047,
     8  0.321,  0.764,  0.750,  1.249,  1.925,
     9  1.922,  2.445,  2.853,  2.853,  4.296,
     * 13.256, 20.848/
      data t55g4 /
     1 21.808, 17.921, 14.170, 12.897, 10.251,
     2  7.788, -0.428, -0.817, -0.837, -1.281,
     3 -1.706, -1.706, -1.848, -1.979, -1.979,
     4 -2.094, -2.184, -2.216, -2.237, -2.242,
     5 -2.242, -2.369, -2.342, -2.315, -2.204,
     6 -1.994, -1.631, -1.530, -1.262, -0.695,
     7 -0.765, -0.531, -0.250,  0.049,  0.048,
     8  0.322,  0.766,  0.752,  1.252,  1.929,
     9  1.927,  2.451,  2.860,  2.859,  4.304,
     * 13.274, 20.866/
*
*     PAR1 and 2 are log(g) and temp
      if( par1 .gt.10. ) then
         temp = par1
         mtemp = (par1+10.) / 100.
         alogg = par2
      else
         temp = par2
         mtemp = (par2+10.) / 100.
         alogg = par1
      endif
*
      if( alogg.ne.4. ) then
         write(qq,'('' only log(g)=4 in table at present.'')')
         stop
      endif
*
      do i=1,ndata
*       convert inverse microns to Rydbergs
        tnu(nspec,i) = wl(ndata+1-i) *0.09116
      end do
*
      if( mtemp.eq. 300 ) then
         do i=1,ndata
            tslop(nspec,i) = t30g4(ndata+1-i)
         end do
      else if( mtemp.eq. 325 ) then
         do i=1,ndata
            tslop(nspec,i) = t325g4(ndata+1-i)
         end do
      else if( mtemp.eq. 350 ) then
         do i=1,ndata
            tslop(nspec,i) = t35g4(ndata+1-i)
         end do
      else if( mtemp.eq. 375 ) then
         do i=1,ndata
            tslop(nspec,i) = t375g4(ndata+1-i)
         end do
      else if( mtemp.eq. 400 ) then
         do i=1,ndata
            tslop(nspec,i) = t40g4(ndata+1-i)
         end do
      else if( mtemp.eq. 450 ) then
         do i=1,ndata
            tslop(nspec,i) = t45g4(ndata+1-i)
         end do
      else if( mtemp.eq. 500 ) then
         do i=1,ndata
            tslop(nspec,i) = t50g4(ndata+1-i)
         end do
      else if( mtemp.eq. 550 ) then
         do i=1,ndata
            tslop(nspec,i) = t55g4(ndata+1-i)
         end do
      else if( mtemp.lt.300 .or. mtemp.gt.550 ) then
         write(qq,'('' This temp is not inside table.'')')
         stop
      else
*        must interpolate on grid
         if( mtemp.gt.300.and.mtemp.le.325 ) then
            fac1 = ( temp - 30000. ) / 2500.
            fac2 = 1. - fac1
            do i=1,ndata
               tslop(nspec,i) = fac2*t30g4(ndata+1-i) +
     1         fac1*t325g4(ndata+1-i)
            end do
         else if( mtemp.gt.325.and.mtemp.le.350 ) then
            fac1 = ( temp - 32500. ) / 2500.
            fac2 = 1. - fac1
            do i=1,ndata
               tslop(nspec,i) = fac2*t325g4(ndata+1-i) +
     1         fac1*t35g4(ndata+1-i)
            end do
         else if( mtemp.gt.350.and.mtemp.le.375 ) then
            fac1 = ( temp - 35000. ) / 2500.
            fac2 = 1. - fac1
            do i=1,ndata
               tslop(nspec,i) = fac2*t35g4(ndata+1-i) +
     1         fac1*t375g4(ndata+1-i)
            end do
         else if( mtemp.gt.375.and.mtemp.le.400 ) then
            fac1 = ( temp - 37500. ) / 2500.
            fac2 = 1. - fac1
            do i=1,ndata
               tslop(nspec,i) = fac2*t375g4(ndata+1-i) +
     1         fac1*t40g4(ndata+1-i)
            end do
         else if( mtemp.gt.400.and.mtemp.le.450 ) then
            fac1 = ( temp - 40000. ) / 5000.
            fac2 = 1. - fac1
            do i=1,ndata
               tslop(nspec,i) = fac2*t40g4(ndata+1-i) +
     1         fac1*t45g4(ndata+1-i)
            end do
         else if( mtemp.gt.450.and.mtemp.le.500 ) then
            fac1 = ( temp - 45000. ) / 5000.
            fac2 = 1. - fac1
            do i=1,ndata
               tslop(nspec,i) = fac2*t45g4(ndata+1-i) +
     1         fac1*t50g4(ndata+1-i)
            end do
         else
* aclly- else if( mtemp.gt.500.and.mtemp.le.550 ) THEN
            fac1 = ( temp - 50000. ) / 5000.
            fac2 = 1. - fac1
            do i=1,ndata
               tslop(nspec,i) = fac2*t50g4(ndata+1-i) +
     1         fac1*t55g4(ndata+1-i)
            end do
         endif
      endif
*
*     convert from magnitudes to log10( f-nu )
      do i=1,ndata
         tslop(nspec,i) = -tslop(nspec,i)/2.5
      end do
      nstar = ndata
*
      end
******************************************************************************
      subroutine molcol( chLabel )
      implicit none
*generate and print molecular column densities
      character chLabel*4
*
      integer nhevml
      parameter (nhevml=18)
      integer limelm
      parameter (limelm=30)
      real hevmol
      common/hevmol/ hevmol(nhevml)
      real hevcol
      common/hevcol/ hevcol(nhevml)
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      real te , eden , hden
      common/phycon/ te , eden , hden
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real xMosheH2O , Xm4
      save xMosheH2O
*
      if( chLabel.eq.'ZERO' ) then
*        zero out the column densities
         do i=1,nhevml
           hevcol(i) = 0.
         end do
         xMosheH2O = 0.
*
      else if( chLabel.eq.'ADD ' ) then
*        add together column densities
         do i=1,nhevml
           hevcol(i) = hevcol(i) + hevmol(i) * dReff
         end do
*
*        parameters for Moshe's maser theory
         Xm4 = hevmol(9)*1e4/hden
         xMosheH2O = xMosheH2O +  Xm4 * ( (hden*1e-9)**2 ) *
     1   (dReff/1e13) * (doppler(9)/1e5)
*
      else if( chLabel.eq.'PRIN' ) then
*        print the column densities
         write(qq,'(''                  CH:'',1P,E9.3,2X,'' CH+:'',E9.3,
     1   ''  OH:'',E9.3,'' OH+:    '',E9.3,2X,''O2:   '',E9.3,''  C2:'',
     2   E9.3,4X,''   CO:'',E9.3)') (hevcol(i),i=1,7)
*
         write(qq,'(''                 CO+:'',1P,E9.3,2X,'' H2O:'',E9.3,
     1   ''H2O+:'',E9.3,'' O2+:    '',E9.3,'' C2+:   '',E9.3,'' H3+:'',
     2   E9.3,4X,'' H3O+:'',E9.3)') (hevcol(i),i=8,14)
*
         write(qq,'(''                CH2+:'',1P,E9.3,2X,'' CH2:'',E9.3,
     1   '' CH3:'',E9.3,''MoH2O    '',e9.3)') (hevcol(i),i=15,17),
     2   xMosheH2O
      else
         write(qq,'('' MOLCOL does not understand the label '',A4)')
     1   chLabel
         stop
      endif
*
      end
******************************************************************************
      subroutine negcon
      implicit none
*sanity check for negative continuum intensities
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgFNeg
      integer i
*
*     look for negative continuum points
      lgFNeg = .false.
      do i=1,nflux
        if( flux(i).lt.0. ) then
          write(qq,'('' FLUX negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') flux(i) , anu(i) , i
          lgFNeg = .true.
        else if( otslin(i).lt.0. ) then
          write(qq,'('' OTSLIN negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') otslin(i) , anu(i) , i
          lgFNeg = .true.
        else if( otscon(i).lt.0. ) then
          write(qq,'('' OTSCON negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') otscon(i) , anu(i) , i
          lgFNeg = .true.
        else if( outcon(i).lt.0. ) then
          write(qq,'('' OUTCON negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') outcon(i) , anu(i) , i
          lgFNeg = .true.
        else if( outlin(i).lt.0. ) then
          write(qq,'('' OUTLIN negative, value, freq, pointer='',
     1    1p,2e10.2,i5)') outlin(i) , anu(i) , i
          lgFNeg = .true.
        endif
      end do
*
      if(.not.lgFNeg) then
        write(qq,'('' No parts of the continuum were '',
     1  ''negative, the electron density was'',1p,e10.2,'' te='',
     2  e10.2)') eden,te
        write(qq,'('' This is zone number'',I4)') nzone
      endif
*
      end
******************************************************************************
      subroutine neon
      implicit none
*ionization balance for neon
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      logical lgNeonBug
*flag set with trace neon command
      common/neonbg/ lgNeonBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real hi , hii
      common/h/ hi , hii
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer nelem , ndim
      parameter (nelem=10)
      parameter (ndim=11)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(10) , yYIELD(8)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/10*0.2/ , yYIELD/8*0./
*
*     neon nelem=10
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /3.03E-11,1.79E-11,1.61E-11,9.76E-12,4.48E-12,2.03E-12,
     1 1.02E-12,3.84E-13,3.05E-14,1.17E-14/
      data (cion(i,2),i=1,ndim-1)
     1/2.50E5,4.76E5,7.37E5,1.13E6,1.47E6,1.83E6,2.40E6,2.77E6,1.39E7,
     2 1.58E7/
*
*     rec from +7, +8 fro Arnaud et al 85
      data rec , pl
     1/3.07E-10, 8.87E-10, 2.21E-9, 4.28E-9, 8.17E-9, 1.51E-8, 3.21E-8
     1, 9.29E-8, 1.02E-7 ,
     2 -0.759  , -0.693  , -0.675 , -0.668 , -0.684 , -0.704 ,-0.742 ,
     2 -0.803 , -0.769  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data
     1 aa/0., 0.0129, 3.6781,-0.0254,-0.0141, 19.9280,  5.4751, 3*0./
     1,bb/0.,-0.1779,14.1481, 5.5365,33.8479,235.0536,203.9751, 3*0./
     1,cc/0., 0.9353,17.1175,17.0727,43.1608,152.5096, 86.9016, 3*0./
     1,dd/0.,-0.0682,-0.5017,-0.7225,-1.6072,  9.1413, -7.4568, 3*0./
     1,ff/0.1,0.4516, 0.2313, 0.1702, 0.1942,  0.1282,  2.5145, 3*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/9.77E-4 , 2.65E-3 , 3.69E-3 , 1.12E-2 , 2.44E-2 , 3.02E-2
     2,6.10E-3 , 2.52E-1 , 1.44E-1 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.073, .242, 1.01, .391, 2.52, .445, .254, .304, .296, 0./
      data (dite(i,1),i=1,ndim-1)
     3/3.11E5  , 2.84E5  , 2.24E5  , 2.7E5  , 3.09E5  , 2.83E5
     4,1.68E5  , 1.4E7  , 1.5E7  , 0./
      data (dite(i,2),i=1,ndim-1)
     1 /2.06e5, 3.07e5, 2.94e5, 5.50e5, 9.91e5, 1.73e6, 6.13e5, 1.80e6,
     2 2.24e6, 0./
      data ditcrt
     5/3.0E4  , 3.3E4  , 3.3E4  , 3.5E4  , 3.6E4  , 3.6E4
     6,2.9E4  , 1.5E6  , 3.8E6  , 1E20  /
*
*     neon, atomic number 10
      if( .not.lgElmtOn(10) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     charge exchange, first 2 from Butler, Heil, Dalgarno
*     Ne+2 => Ne+
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(2,2) = CTHeavy(2,2) + 1E-14 * HI
*     Ne+3 => Ne+2
*     CTHeavy(3,2) = CTHeavy(3,2) + 5.7E-11*SQRTE*HI
*     Ne+4 => Ne+3, Butler and Dalgarno 1980B
*     CTHeavy(4,2) = CTHeavy(4,2) + 6.6E-9*HI
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
      if( lgTrace.and.lgNeonBug ) then
        write(qq,'('' NEON;'',1P,10E9.2/6X,10E9.2)')
     1  (CTHeavy(i,1),i=1,10),(CTHeavy(i,2),i=1,10)
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if(lgTrace.and.lgHeavyBug) then
        write(qq,'(5x,''NEON   returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
******************************************************************************
      subroutine NextDR
      implicit none
*use adaptive logic to find next zone thickness
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzlim
      parameter (nzlim=2000)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real AngleIllum
*angle of illumination - actually 1./cos(normal), so > 1.
      common/Angllum/ AngleIllum
      logical lgPresOK
*     set true in presur if presure ok, false otherwise
      common/presok/ lgPresOK
      real opac
      common/opac/ opac(ncell)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real glbden , glbrad , glbpow , glbdst
      common/globul/ glbden , glbrad , glbpow , glbdst
      real drMinimum
*fraction of initial thickness, set in firstdr
*do not let dr get smaller than this
      common/drmin/ drMinimum
      real dstCala , dCakh , dCaf12 , Ca3d , Ca4p
*parameters dealing with dest of CaII by Lya
      common/dcala/ dstCala , dCakh , dCaf12 , Ca3d , Ca4p
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgSMinON
*lgSMinON is flag saying that set drmin has been enteed
*     these are 1e-30 and 1e30 by default, and are set with "set dr" cmnds
*     used as one of a pair of limits to how big or small zones get
*     set dr command forces constant dr by setting both to same number
      real sdrmin , sdrmax
      common/sdrmin/ sdrmin , sdrmax , lgSMinON
      real drNext
*next dr, as set in nextdr
      common/drnxt/ drNext
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real flong , cfirst , csecnd, flcPhase
*     parameters for the fluctuations command
      logical lgDenFluc
      common/fluct/ flong , cfirst , csecnd , lgDenFluc, flcPhase
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      real HColStop , colpls , colnut
*limit column densities set with stop column command
*colend is total hydrogen column, others are ionized and neutral
      common/colend/ HColStop , colpls , colnut
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real H2Opacity
*mean cross section (cm-2) for H2 Lyman absorption
      common/h2opac/ H2Opacity
      real reftot,avhden,chii, avdust , avdpot , thtot
      common/toiii/ reftot,avhden,chii,
     1 avdust(ndust) , avdpot(ndust) , thtot
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      logical lgDrMinUsed
*set true is calculations stops because zone thickness gets too small
      common/drminu/ lgDrMinUsed
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgDrBug
*flag set with trace dr command
      common/drbug/ lgDrBug
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      real drChange
*fractional change used in nextdr
      common/didz/ drChange
      real dVeldRad
*dVel/dR used for sobolev (large velocity gradient)
      common/dvdr/ dVeldRad
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      logical lgDROn , lgDRPLst
*     these control punching choice of dr - this is not really a punch cmnd
*     ipDRout is io unit, lgDROn says punching dr logic has been set,
*     and lgDRPLst says to punch the last iteration
      integer ipDRout
      logical lgFe2PLst
      common/ipdr/ ipDRout , lgDROn , lgDRPLst , lgFe2PLst
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      logical lgDrNeg
*flag set in nextdr saying whether dr is negative
      common/drneg/ lgDrNeg
      logical lgTeFail
*set true in IONTE if heating - cooling failure
      common/tfail/ lgTeFail
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      logical lgNxtDROff
*flag telling nextdr whether this is first call or not
      common/ndroff/ lgNxtDROff
      double precision phmlte , ph2lte , phplte
      common/HMolLTE/  phmlte , ph2lte , phplte
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      logical lgConPres
*flag saying whether or not incident continuum should be included
*in total pressure, turned off with constant gas pressure
      common/conprs/ lgConPres
      real pinit , pinteg , pinzon
      common/pinteg/ pinit , pinteg , pinzon
      real PressureInit
*     this is the total pressure at the illuminated face
      common/PresInit/ PressureInit
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real SavOutCon(ncell)
*     variables related to deriving the ratio of outward to incident continuum
*     SumOutMax - energy where max occurs, ipSumOutMax pointer to this
*     sumOutCon is summed out outlin and outcon less SavOutCon for all energy
*     SumHOutCon is H-ionizing only
      real SumOutCon , SumIncCon , SumHOutCon , SumHIncCon , SumOutMax
      integer ipSumOutMax
      common/SumOutInc/ SumOutCon , SumIncCon , SavOutCon , SumHOutCon ,
     1 SumHIncCon , SumOutMax , ipSumOutMax
      logical lgLastIt
*     this is false on any but the last iteration
*     set true in startr if iter > itermx
      common/lastit/ lgLastIt
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      integer ijMase
      real dTauMase
*     dTauMase is smallest maser optical depth in atoms, set in
*     tauinc for H, and in tauchn for heavy elements
*     it is negative or zero
*     ijMase is 100*n_upper + n_lower
*     if ijMase is 0 when dTauMase used, maser was in heavy element
      common/dtMase/ ijMase , dTauMase
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
*     these save structure variables, like te vs depth
      real testr, volstr, radstr, histr, hiistr , ednstr,o3str,heatstr,
     1 pdenstr
      common/struc/ testr(nzlim), volstr(nzlim), radstr(nzlim),
     1 histr(nzlim), hiistr(nzlim) , ednstr(nzlim),o3str(nzlim),
     2 heatstr(nzlim),pdenstr(nzlim)
      real toler
*     allowed error in heating - cooling balance, set with TOLERANCE command
*     default set in zerologic
      common/toler/ toler
      real he3gam , He3FrLya
*     total photoionization rates for helium triplest
*     He3FrLya is fraction of this that is Lya
      common/he3gams/ he3gam(nhe3lvl) , He3FrLya
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer k, ipStrong , level , istage
      integer ioxystag , initstag , icarstag , iironstag
      real Strong , drLineHeat , drH2Band , drchk,coleff,dt,savedr,
     1 drmax, drFluc,winddr,factor, drConPres , drDepth , error,hdnew,
     3 fac2, GlobDr,dnew,fabden,SpecDr , drEden , drHMase, drTab,tabden
      character chLineLbl*10 , chLbl*10 , chDestAtom*8
*
*     used as big radius
      real BigRadius
*
      logical lgDoPun , lgOscil
      real OldTe , drHion , OHIIoHI , drHe1ion , OHe2oHe1
      real OldEden , dEden
      save OldEden , OldTe , OldHeat , OHIIoHI , OHe2oHe1
      real drdHdStep , dHdStep , OldHeat , SvHe2oHe1
*
      real x,z,dnglob , drInter , freqm, opacm , drFail , drSphere ,
     1 drPressure , dRTaue , TauInwd , TauDTau , dDestRate ,
     1 SaveOHIIoHI , dDRCarbon , dDRNitrogen , drDest , dDROxygen,
     1 dDRIron,dTdStep,
     1 drdTdStep , drOutFrac , Out2Tot , DrGrainHeat , grfreqm , gropacm
*
      parameter (z=1.0001 , dnglob=0.10 )
      data BigRadius/1e30/
*
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*
*     changes in logic
*     95 oct 19, drSphere now 3% of radius, was 2%, fewer zone
*     95 oct 19, subtracted grain opacity from total opacity used
*     to get thickness in routine ContRate
*
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*
*     free statement labels >= 13
*
*-----------------------------------------------------------------------
*
*     this sub determines the thickness of the next zone
*     if is called one time for each zone
*     flag lgNxtDROff is true if this is initialization of NextDR,
*     is false if we are to use logic to find dr
*
*-----------------------------------------------------------------------
*
      if( lgTrace ) write(qq,'(''   NextDR called'')')
*
*    1    '' NextDR keys from change in H ionization'',e11.3)')
*     check on change in hydrogen ionizaiton
      if( nzone.le.1 ) then
        if( hii.gt.0. .and. hi.gt.0. ) then
          OHIIoHI = hii / hi
        else
          OHIIoHI = 0.
        endif
        drHion = BigRadius
*     else if(hii.gt.0. .and. hi.gt.0. .and. OHIIoHI.gt.0. ) then
*     >>chng 97 july 9, for deep in PDR vastly now ionz H slowed down works
      else if(hii.gt.0. .and. hi.gt.0. .and. OHIIoHI.gt.1e-15 ) then
        x = (hii/hi) / OHIIoHI
        if(x.lt.1. ) then
          x = 1. - x
*         >>chng 96 feb 23 from 0.7 to 0.3 because punched through H i-front
*         >>chng 97 may 5, from 0.3 to 0.2 since punched through H i-front
          drHion = drad * max( 0.2 , 0.2 /max(1e-10,x))
        else
          drHion = BigRadius
        endif
        SaveOHIIoHI = OHIIoHI
        OHIIoHI = hii / hi
      else
        SaveOHIIoHI = OHIIoHI
        if( hii.gt.0. .and. hi.gt.0. ) then
          OHIIoHI = hii / hi
        else
          OHIIoHI = 0.
        endif
        drHion = BigRadius
      endif
*
*     possible hydrogen maser action
      if( dTauMase .lt.-0.01 ) then
*       maser so powerful, must limit inc in tay
*       >>chng 96 aug8, from 0.3 to 0.1 due to large maser crash
        drHMase = drad * max( 0.1 , -0.2/dTauMase)
      else
        drHMase = BigRadius
      endif
*
*     '' NextDR keys from change in He1 ionization'',e11.3)')
*     check on change in HeI ionization
      SvHe2oHe1 = OHe2oHe1
      if( nzone.le.1 ) then
        if( heii.gt.0. .and. hei.gt.0. ) then
          OHe2oHe1 = heii / hei
        else
          OHe2oHe1 = 0.
        endif
        drHe1ion = BigRadius
      else if(heii.gt.0. .and. hei.gt.0. .and. OHe2oHe1.gt.0. ) then
*       >>chng 97 july 14, from 1e-2 to 1e-3
        if( (He3FrLya.gt.1e-3) .and. (heii/hei.le.1e-3) ) then
*       >>chng 97 jul 12, He mostly neutral but Lya photoionized,
*       oscillation could
*       take place - do not trigger dr from this oscillation
          drHe1ion = BigRadius
        else
          x = (heii/hei) / OHe2oHe1
          if(x.lt.1. ) then
            x = 1. - x
*           >>chng 97 may 5, ran into i-fronts
            drHe1ion = drad * max( 0.2 , 0.2 /max(1e-10,x))
          else
            drHe1ion = BigRadius
          endif
        endif
        OHe2oHe1 = heii / hei
      else
        if( heii.gt.0. .and. hei.gt.0. ) then
          OHe2oHe1 = heii / hei
        else
          OHe2oHe1 = 0.
        endif
        drHe1ion = BigRadius
      endif
*666  write(11,'(1p,3e10.2)') OHe2oHe1 , He3FrLya
*
*     check on how much outward flux is being added relative to
*     attenuated incident beam
*    1    '' NextDR keys from ratio out2 tot continuua'',e9.1)')
      if( SumIncCon.gt.0. .and. SumOutCon.gt.0. .and. .not.lgTSetOn)then
*       evaluated in metdif
        Out2Tot = SumOutCon / SumIncCon
*       Out2HTot = SumHOutCon / SumHIncCon
*       try to keep outward frac less than 5% of total
        drOutFrac = drad * max( 0.7 , 0.05/max(1e-10,Out2Tot))
      else
        drOutFrac = BigRadius
      endif
*
*     check how heating is changing
*     '' NextDR keys from change in heating; current, delta='',
      if( nzone.le.1 .or. lgTSetOn ) then
        drdHdStep = BigRadius
      else
        dHdStep = abs( htot - OldHeat ) / htot
        if( dHdStep.gt. 0. ) then
          if(hden.ge.1e13 ) then
*           drdHdStep = drad * max( 0.8 , 0.05/dHdStep )
            drdHdStep = drad * max( 0.8 , 0.075/dHdStep )
          else if(hden.ge.1e11 ) then
*           drdHdStep = drad * max( 0.8 , 0.075/dHdStep )
            drdHdStep = drad * max( 0.8 , 0.100/dHdStep )
          else
*           changed from .15 to .12 for outer edge of coolhii too steep dT
*           changed to .10 for symmetry, big change in some rates, 95nov14
*           changed from .10 to .125 since parispn seemed to waste zones
*           >>chng 96 may 21, from .125 to .15 since pn's still waste zones
            drdHdStep = drad * max( 0.8 , 0.15/dHdStep )
          endif
        else
          drdHdStep = BigRadius
        endif
      endif
      OldHeat = htot
*
*     pressure due to incident continuum if in eos
      if( chCPres.eq.'CPRE' .and. lgConPres ) then
        if( nzone.gt. 2. .and. pinzon.gt.0. ) then
*         pinzon is pressure from acceleration onto previos zone
*         want this less than some fraction of total pressure
          drConPres = 0.05 * PressureInit /
     1    (AccelTot*xMassDensity*FillFac)
        else
          drConPres = BigRadius
        endif
      else
        drConPres = BigRadius
      endif
*
*     check how temperature is changing
*    1    '' NextDR keys from change in temperature; current, delta='',
      if( nzone.le.1 ) then
        drdTdStep = BigRadius
      else
        dTdStep = abs( te - OldTe ) / te
        if( te.gt.1e4 ) then
*         >>chng 96 may 30, for high temps with flat cooling fcn,
*         do not want too fine a test
          x = 0.05
        else
*         >>chng 95 oct 13 from 0.05 to 0.03 for big te changes at
*         outer edges of pn's and hii regions
          x = 0.03
        endif
        if( dTdStep.gt. 0. ) then
*         >>chng 96 may 30, variable depending on temp
*         >>chng 96 may 31, allow 0.7 smaller, was 0.8
*         >>chng 97 may 5, from 0.7 to 0.5 stop from punching through thermal fr
          drdTdStep = drad * max( 0.7 , x/dTdStep )
        else
          drdTdStep = BigRadius
        endif
      endif
      OldTe = te
*
*     find freq where opacity largest and interaction rate is fastest
*    1  '' NextDR keys from cont inter nu='',e9.2,
      call ContRate( freqm, opacm )
*     drChange is optical depth at max interaction energy
*     >>chng 96 june 6 was drChange=0.15 changed to 0.3 for high Z models
*     taking too many zones
*     drInter = drChange / max(1e-30,opacm*FillFac)
      drInter = 0.3 / max(1e-30,opacm*FillFac*AngleIllum)
*
*     check on changes in destruction rates for various atoms
*     call ChkRate( 1 , dDRHydro  ,istage )
*     call ChkRate( 2 , dDRHelium ,istage )
      call ChkRate( 6 , dDRCarbon ,icarstag )
      call ChkRate( 7 , dDRNitrogen ,initstag )
      call ChkRate( 8 , dDROxygen ,ioxystag )
      call ChkRate(26 , dDRIron ,iironstag )
      dDestRate = max( dDROxygen , dDRIron , dDRCarbon,dDRNitrogen)
      if( dDRCarbon.eq.dDestRate ) then
        dDestRate = dDRCarbon
        istage = icarstag
        chDestAtom = 'Carbon  '
      else if( dDRNitrogen.eq.dDestRate ) then
        dDestRate = dDRNitrogen
        istage = initstag
        chDestAtom = 'Nitrogen'
      else if( dDROxygen.eq.dDestRate ) then
        dDestRate = dDROxygen
        chDestAtom = 'Oxygen  '
        istage = ioxystag
      else if( dDRIron.eq.dDestRate ) then
        dDestRate = dDRIron
        istage = iironstag
        chDestAtom = 'Iron    '
      else
        write(qq,'('' insanity following ChkRate'')')
        call ShowMe
        stop
      endif
*    1    '' NextDR keys from change in dest rates, atom='',a8,i3)')
      if( dDestRate.gt. 0. ) then
*       if( te.gt.40 000. ) then
*         added different accuracy for hot gas since tend to jump over
*         big te range for small change in heat (intrinsically unstable)
*         drDest = drad * max( 0.5 , 0.10/dDestRate )
*       else
*         was drChange, changed to .15 for parishii go through HeII=HeI I front
*         drDest = drad * max( 0.5 , 0.15/dDestRate )
*         >>chng 95 dec 18 from above to below to stop oscillations
*         >>chng 95 dec 27 from min of .5 to .75 to stop zone size from changing
*         drDest = drad * max( 0.8 , 0.20 /dDestRate )
*         >>chng 96 jan 14 from .2 to .25 to use less zones
*         >>chng 96 may 30 from min of 0.8 to 0.5 to prevent crashing into He i-
          drDest = drad * max( 0.5 , 0.20 /dDestRate )
*       endif
      else
        drDest = BigRadius
      endif
*
*     check whether change in wind velocity constrains DRAD
      if( windv.gt.0. ) then
        if( dVeldRad.ne.0. ) then
*         dVeldRad is D(vel)/vel / DRAD, computed in PRESUR
          winddr = 0.03 / dVeldRad
        else
          winddr = 1.1 * drad
        endif
      else
        winddr = BigRadius
      endif
*
*     inside out globule
      if( chCPres.eq.'GLOB' ) then
        if( glbdst.lt.0. ) then
          write(qq,'('' Globule distance is negative, internal '',
     1    ''overflow has occured,  sorry.'')')
          write(qq,'('' This is routine NextDR, GLBDST is'',1P,E10.2)')
     2    glbdst
          stop
        endif
        factor = glbden * (glbrad/glbdst)**glbpow
        fac2 = glbden * (glbrad/(glbdst-drad))**glbpow
        if( fac2/factor .gt. 1.+dnglob ) then
*         DNGLOB is relative change in density allowed this zone, 0.10
          GlobDr = drad * dnglob/(fac2/factor-1.)
        else
          GlobDr = BigRadius
        endif
*       GlobDr = GLBDST * DNGLOB * (GLBRAD/GLBDST)**(-GLBPOW) / GLBPOW
        GlobDr = min( GlobDr , glbdst /20. )
      else
        GlobDr = BigRadius
      endif
*
      if( chCPres(1:3).eq.'DLW' ) then
*       one of the special density laws, first get density at possible next dr
        if( chCPres.eq.'DLW1' ) then
          hdnew = fabden(radius+drad,depth+drad)
        else if( chCPres.eq.'DLW2' ) then
          hdnew = tabden(radius+drad,depth+drad)
        else
          write(qq,'('' dlw insanity in NextDR'')')
          stop
        endif
        drTab = abs( hdnew - hden ) / max(hdnew,hden)
        drTab = drad * max( 0.2 , 0.10/max(0.01,drTab))
      else
        drTab = BigRadius
      endif
*
*     special density law
      if( chCPres.eq.'DLW1' ) then
        dnew = abs( fabden( radius+drad , depth+drad ) / hden - 1.)
*       DNGLOB is relative change in density allowed this zone, 0.10
        if( dnew.eq.0. ) then
          SpecDr = drad * 3.
        else if( dnew/dnglob.gt.1.0 ) then
          SpecDr = drad / ( dnew / dnglob )
        else
          SpecDr = BigRadius
        endif
      else
        SpecDr = BigRadius
      endif
*
*     check grain line heating dominates
*     this is important in PDR and HII region calculations
*     >>chng 97 july 3, added following check
      if( heating(1,14)/htot.gt.0.2 ) then
        call GrainRateDr( grfreqm, gropacm )
        DrGrainHeat = 1.0 / max(1e-30,gropacm*FillFac*AngleIllum)
      else
        DrGrainHeat = BigRadius
      endif
*
*     check if line heating dominates
*     this is important in high metallicity models
      if( heating(1,23)/htot.gt.0.2 ) then
        call FndLineHt( level , ipStrong , Strong )
        if( Strong/htot.gt.0.1 ) then
          if( level .eq. 1 ) then
*           a level1 line was the heat source (usual case)
*           drLineHeat = max(1.0,TauLines(ipLnTauIn,ipStrong)*0.2) /
*    1      TauLines(ipLnDTau,ipStrong)
            TauInwd = TauLines(ipLnTauIn,ipStrong)
            TauDTau = TauLines(ipLnDTau,ipStrong)
          else if( level.eq.2 ) then
*           a level2 line was the heat source
*           (bad case since not as well treated)
*           drLineHeat = max(1.0,WindLine(ipLnTauIn,ipStrong)*0.2) /
*    1      WindLine(ipLnDTau,ipStrong)
            TauInwd = WindLine(ipLnTauIn,ipStrong)
            TauDTau = WindLine(ipLnDTau,ipStrong)
          else
*           this is insane, since Strong was set, but not level
            call insane
            write(qq,'('' NextDR Strong line heating set, but not '',
     1      ''level.'')')
            drLineHeat = BigRadius
            ipStrong = 1
            Strong = 0.
            stop
          endif
*         in following logic cannot use usual inverse opacity,
*         since line heating competes with escape probability,
*         so is effective at surprising optical depths
          if( TauDTau .gt.0. ) then
            drLineHeat = max(1.,TauInwd)*0.4 / TauDTau
          else
            drLineHeat = BigRadius
          endif
        else
          drLineHeat = BigRadius
          ipStrong = 1
          Strong = 0.
        endif
      else
        drLineHeat = BigRadius
        ipStrong = 1
        Strong = 0.
      endif
*666  write(6,*) 'drLineHeat=',TauLines(ipLnWlang,ipStrong)
*
*     Lyman band optical depth
*     second term total lyman band optical depth, do not check if thick
*     H2Opacity is opacity evaluated in hmole
      if( htwo*H2Opacity.gt.1e-20 .and. colh2*H2Opacity.lt.5. ) then
        if( colh2*H2Opacity.lt.2.) then
*         special extra 2 since H2 will change by this amount early on
          drH2Band = (drChange/2.) /(htwo*H2Opacity*FillFac)
        else
          drH2Band = drChange /(htwo*H2Opacity*FillFac)
        endif
      else
        drH2Band = BigRadius
      endif
*
*     can't make drmax large deep in model since causes feedback
*     oscillations with changes in heating or destruction rates
*     >>chng 96 Oct 15, change from 5 to 10
      if( nzone.lt.11 ) then
        if( nzone.lt.5 ) then
*         >>chng 96 nov 11, had been 4 * drad up to 11, change to following
*         to be similar to c90.01, max of 1.3 between 5 and 11
          drmax = 4. * drad / AngleIllum
        else
          drmax = 1.3 * drad / AngleIllum
        endif
      else
*       >>chng 96 Oct 15, do not let zones increase if oscillations present
        lgOscil = .false.
*       this routine called before tauinc stores variables
*       >>chng 96 oct 31, error to declare oscillation propto toler, the
*heating cooling tolerance
        error = toler*toler
        do k=nzone-9,min(nzlim,nzone-2)
*         small residiual is to allow 0.01 rel error
          if( (testr(k-1)-testr(k))/testr(k)*(testr(k)-
     1      testr(k+1))/testr(k).lt.-error ) then
            lgOscil = .true.
          endif
*         small residiual is to allow 0.01 rel error
          if((ednstr(k-1)-ednstr(k))/ednstr(k)*(ednstr(k)-
     1      ednstr(k+1))/ednstr(k).lt.-error )then
            lgOscil = .true.
          endif
        end do
        if( lgOscil ) then
*         >>chng 96 Oct 15, do not let zones increase if oscillations present
          drmax = drad
        else
*         >>chng 96 jan 15 was 1.15 - why so small?
          drmax = 1.3 * drad
        endif
      endif
*
*     is current pressure ok?
      if(lgPresOK) then
        drPressure = BigRadius
      else if(nzone.gt.0 ) then
*       first zone usually has pressure fail due to bug in ptot
        drPressure = drad / 2.
      else
        drPressure = BigRadius
      endif
*
      if(lgTeFail) then
        drFail = drad / 2.
      else
        drFail = BigRadius
      endif
*
*     change in electron density
      if( nzone.le.1 ) OldEden = eden
      if( eden/hden.le.1. ) then
        dEden = abs( eden - OldEden ) / eden
        if( dEden.gt. 0. ) then
*         >>chng 96 may 15, down to .03 from 0.04
*         >>chng 96 may 17, up to 0.1 from .03
          drEden = drad * max( 0.7 , 0.10/dEden )
        else
          drEden = BigRadius
        endif
      else
        drEden = BigRadius
      endif
      OldEden = eden
*
*     do not let thickness get too large
*    1    '' NextDR keys from relative depth'',e11.3)')
      if( nzone.gt.20 ) then
        drDepth = depth / 5.
      else
        drDepth = BigRadius
      endif
*
*     spherical models, do not want delta R/R big
      drSphere = radius * 0.03
      drSphere = radius * 0.04
*
*     optical depth to electron scattering
      dRTaue = drChange / (eden * 6.65e-25)
*
      if( flong.ne.0. ) then
*     FacAbunSav = (cfirst * cos( depth*flong ) + csecnd)
*       this is option for rapid density fluctuations
*       set DR to roughly 0.1 of fluctuation length
*       read flcsub first parameter (log of period) is used to get flong
*       flong = 6.2831853 / period in flcsub
        drFluc = 0.628/2. / flong
      else
        drFluc = BigRadius
      endif
*
*     if density fluctuations in place then override change in heat
*     for dr set
      if( chCPres.eq.'SINE' .and. lgDenFluc ) then
        drdHdStep = BigRadius
      endif
 
*=======active dr sets
*
*     >>chng 97 mar 11, ms powerstation 4 could not handle too many args to min
      drNext = min( drmax,drInter , drLineHeat , winddr ,drFluc, GlobDr,
     1 DrGrainHeat )
      drNext = min( drNext ,
     1 SpecDr , drFail , drSphere , sdrmax , drPressure , dRTaue )
      drNext = min( drNext ,
     2 drH2Band , drDest , drdTdStep , drdHdStep , drConPres , drTab )
      drNext = min( drNext ,
     3 drOutFrac , drHion , drHe1ion , drDepth , drEden, drHMase)
*
*     option to force min drad
      if( drNext.lt.sdrmin ) then
        drNext = sdrmin
      endif
*
*     dr = zero is a logical mistake
      if( drNext.le.0. ) then
        write(qq,'('' NextDR finds insane drNext:'',1p,e10.2)') drNext
        write(qq,'('' all drs follow:'',1p,5e10.2)')
     1  drmax,drInter , drLineHeat , winddr ,drFluc, GlobDr,
     1  SpecDr , drFail , drSphere , sdrmax , drPressure , dRTaue ,
     2  drH2Band , drOutFrac , drDepth
        stop
      endif
*
      savedr = drNext
*
*     all this is to only punch on last iteration
*     the punch dr command is not really a punch command, making this necessary
*     lgDRon is set true if "punch dr" entered
      if( lgDROn ) then
        if( lgDRPLst ) then
*         lgDRPLst was set true if "punch" had "last" on it
          if( lgLastIt ) then
            lgDoPun = .true.
          else
            lgDoPun = .false.
          endif
        else
          lgDoPun = .true.
        endif
      else
        lgDoPun = .false.
      endif
      if(lgTrace.and.lgDrBug .or. lgDoPun ) then
        k = ipDRout
        if(lgTeFail .and. nzone.gt.0 ) then
          write(k,'('' >>>> A temperature failure occured.'')')
        endif
        if(.not.lgPresOK .and. nzone.gt.0 ) then
          write(k,'('' >>>> A pressure failure occured.'')')
        endif
*
*=======begin active dr sets
*
        if( drNext.eq.drLineHeat  ) then
          if( level.eq. 1) then
            chLbl =  chLineLbl(TauLines(1,ipStrong))
            write(k,'(1X,I4,1P,E11.3,'' NextDR keys from level 1 '',
     1      ''line heating,'',a10,'' TauIn'',3e10.2)')
     2      nzone,drNext, chLbl,TauInwd,TauLines(ipLnPump,ipStrong),
     3      TauLines(ipLnEscP,ipStrong)
          else if( level.eq.2 ) then
            chLbl =  chLineLbl(WindLine(1,ipStrong))
            write(k,'(1X,I4,1P,E11.3,'' NextDR keys from level 2 '',
     1      ''line heating,'',a10,'' TauIn'',3e10.2)')
     2      nzone,drNext, chLbl,TauInwd,WindLine(ipLnPump,ipStrong),
     3      WindLine(ipLnEscP,ipStrong)
          else
            write(qq,'('' insanity pr line heat'')')
            stop
          endif
*
        else if( drNext.eq.drDepth  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from relative depth'',e11.3)')
     2    nzone,drNext
*
        else if( drNext.eq.drTab  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from spec den law, new old den'',
     1    2e10.2)') nzone,drNext,hdnew,hden
*
        else if( drNext.eq.drHMase  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from H maser, dt, ij='',e10.2,i5)')
     2    nzone,drNext,dTauMase , ijMase
*
        else if( drNext.eq.drHion  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in H ionization fm to'',2e11.3)')
     2    nzone,drNext , SaveOHIIoHI , OHIIoHI
*
        else if( drNext.eq.drEden  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in elec den'',e11.3)')
     2    nzone,drNext, dEden
*
        else if( drNext.eq.drHe1ion  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in He1 ionization'',2e11.3,
     2    '' FrLya'',e11.3)')
     2    nzone,drNext, OHe2oHe1 ,SvHe2oHe1, He3FrLya
*
        else if( drNext.eq.drDest  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in dest rates, atom='',a8,i3)')
     2    nzone,drNext, chDestAtom,istage
*
        else if( drNext.eq.drOutFrac  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from ratio out2 tot continuua'',2e10.2,i7,
     1    2(1x,a4))')
     2    nzone,drNext, Out2Tot, SumOutMax,ipSumOutMax ,
     3    chLineLabel(ipSumOutMax), chContLabel(ipSumOutMax)
*         in above SumOutMax is anu where peak occured
*
        else if( drNext.eq.drdHdStep  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in heating; current, delta='',
     2    1p,2e10.3)')
     2    nzone,drNext, htot, dHdStep
*
        else if( drNext.eq.drConPres  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in con accel'')')
     2    nzone,drNext
*
        else if( drNext.eq.drdTdStep  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from change in temperature; current, delta='',
     2    1p,2e10.3)')
     2    nzone,drNext, te, dTdStep
*
        else if( drNext.eq.sdrmin  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from sdrmin'')') nzone,drNext
*
        else if( drNext.eq.drH2Band  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from H2 Lyman Band - opacity='',1p,e10.2)')
     2    nzone,drNext, htwo*H2Opacity
*
        else if( drNext.eq.sdrmax  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from sdrmax'')') nzone,drNext
*
        else if( drNext.eq.drSphere  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from sphericity'')') nzone,drNext
*
        else if( drNext.eq.dRTaue  ) then
          write(k,'(1X,I4,1P,E11.3,
     1    '' NextDR keys from optical depth to electron scattering'')')
     2     nzone,drNext
*
        else if( drNext.eq.drPressure  ) then
          write(k,'(1X,I4,1P,E11.3,'' NextDR key from pressure failure''
     1    )') nzone, drNext
*
        else if( drNext.eq.drFail  ) then
          write(k,'(1X,I4,1P,E11.3,
     1   '' NextDR key from temperature failure.'')') nzone, drNext
*
        else if( drNext.eq.drmax  ) then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR key from DRMAX; nu opc dr='',1p,3e9.2,'' oscil='',l2
     1   )') nzone ,
     1   drNext, freqm , opacm , drChange / opacm , lgOscil
*
        else if( drNext.eq.drInter  ) then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR keys from cont inter nu='',e9.2,
     1  '' opac='',e9.2)') nzone,drNext, freqm, opacm
*
        else if( drNext.eq. DrGrainHeat ) then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR keys from grain heating nu='',e9.2,
     1  '' opac='',e9.2)') nzone,drNext, grfreqm, gropacm
*
        else if( drNext.eq.winddr ) then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR key from Wind, dVeldRad='',E10.3)') nzone , winddr ,
     2  dVeldRad
*
        else if( drNext.eq.drFluc )  then
          write(k,'(1X,I4,1P,E11.3,
     1  '' NextDR key from density fluctuations'')') nzone , drNext
*
        else if( drNext.eq.GlobDr  ) then
          write(k,'(1X,I4,1P,
     1  '' NextDR keys from GLOB law new dr='',E9.2,'' HDEN='',
     1  E9.2)') nzone ,drNext,hden
*
        else if( drNext.eq.SpecDr  ) then
          write(k,'(1X,I4,1P,
     1  '' NextDR keys from special law new dr='',E10.2,
     2  '' HDEN='',E10.2)') nzone,drNext,hden
        else
          write(k,'(1X,I4,1P,'' NextDR keys from insanity '',E10.2,
     1    E10.2)') nzone,drNext
          stop
        endif
*
*======end active dr sets
*
      endif
*
*     remember what drNext is, the do test for zones too thin
      drchk = drNext
*
*     this is general code that prevents zone thickness drNext from
*     becoming too thin, something that can happen for various bad reasons
*     HOWEVER we do not want to do this test for certain density laws,
*     for which very small zone thicknesses are unavoidable
*     the special cases are:
*     special density law,
*     globule density law,
*     not at carbon +-0 i front
*     not flucuations command
*     drMinimum was set in FirstDR to either sdrmin (set drmin) or
*     some fraction of the initial radius - it is always set
*     to something non-trivial.
*     sdrmin is only set wih the "set dr" command
      if( chCPres.ne.'DLW1' .and. chCPres.ne.'GLOB' .and.
     1  xIonFracs(6,1)/xIonFracs(6,0).lt.0.05 .and. (flong.eq.0.) ) then
*       don't let dr get smaller than drMinimum, if this resets drNext
*       then code stops with warning that zones got too thin
        if( drNext.lt.drMinimum ) then
          drNext = drMinimum
*         leaving this at true will cause the model to stop with a warning
*         that the zone thickness is too small
          lgDrMinUsed = .true.
        endif
      endif
*
*     following is to make thickness of model exact
*     n.b., on last zone, drNext can be NEGATIVE!!
*     DEPTH was incremented at start of zone calc in newrad,
*     has been outer edge of zone all throughout
      drNext = min( drNext , real(router(iter)-depth)*z)
*     this means outer limit exceeded
      if( drNext.lt.0. ) then
        lgDrNeg = .true.
      else
        lgDrNeg = .false.
      endif
*
      if( HColStop.lt.5e29 ) then
        coleff = hden * FillFac
        drNext = min( drNext,(HColStop-colden-real(drad)*coleff)*z/
     1  coleff)
      else if( colpls.lt.5e29 ) then
        coleff = hii * FillFac
        drNext = min( drNext , (colpls-chii-real(drad)*coleff)*z/coleff)
      else if( colnut.lt.5e29 ) then
        coleff = hi * FillFac
        if((colnut-chi-real(drad)*coleff).lt.coleff*drNext ) then
          drNext = (colnut-chi-real(drad)*coleff)*z/coleff
        endif
      endif
*
      if( iptnu.ne.ncell ) then
*       end optical depth has been specified
        dt = opac(iptnu) * FillFac
        drNext = min( drNext , (tauend-tauabs(iptnu,1)-real(drad)*dt)/
     1  dt)
      endif
*
      if( lgTrace ) write(qq,'('' NextDR chooses next drad='',1P,E12.4,
     1 ''; this drad was'',E12.4)') drNext, drad
*
*     this flag is used here to test where sub is initialized yet
*     not off, so on
      lgNxtDROff = .false.
*
      end
******************************************************************************
      subroutine nickel
      implicit none
*ionization balance for nickel
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=29)
      parameter (nelem=28)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real GRDEFF(28)
*
*     nickel, nelem=28
*
*     real CollidRate(nelem,2)
*
*     REAL yYIELD(26) , yYIELDL(18)
*     DATA yYIELD/26*0./ , yYIELDL/18*0./
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.34E-10,6.38E-10,1.51E-10,5.43E-11,2.46E-11,1.00E-11,
     1 5.29E-11,2.67E-12,1.26E-12,4.66E-13,1.36E-12,9.44E-13,6.35E-13,
     2 3.80E-13,2.17E-13,5.74E-14,1.04E-13,3.88E-14,5.65E-14,4.02E-14,
     3 3.25E-14,2.65E-14,1.83E-14,1.15E-15,8.39E-15,3.84E-15,4.21E-16,
     4 1.91E-16/
      data (cion(i,2),i=1,ndim-1)
     1 /8.86E4,2.11E5,4.08E5,6.37E5,8.76E5,1.25E6,1.54E6,1.88E6,2.24E6,
     2 2.60E6,3.73E6,4.09E6,4.46E6,4.99E6,5.39E6,5.79E6,6.63E6,
     3 7.04E6,1.80E7,1.91E7,2.04E7,2.20E7,2.33E7,2.47E7,2.66E7,2.78E7,
     4 1.19E8,1.25E8/
*
*     DATA FYIELD/2*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47,2*.48,2*.49, .11,.75,5*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*     they are correct for iron, not ni
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/28*0.2/
*
*     all rates from Shull and Van Steenberg apj sup 48, 95.
      data rec/2.27e-10, 6.31e-10, 8.83e-10, 1.01e-09, 3.71e-09,
     1         4.84E-09, 1.09E-08, 2.48E-08, 9.68E-08, 1.72E-07,
     2         2.61E-07, 3.95E-07, 4.70E-07, 5.70E-07, 6.98E-07,
     3         8.32E-07, 9.76E-07, 1.19E-06, 1.16E-06, 1.14E-06,
     4         1.17E-06, 1.24E-06, 1.35E-06, 1.38E-06, 6.64E-07,
     5         4.67E-07, 8.98E-07/
      data pl/ -0.7, -0.7, -0.7, -0.7, -0.746, -0.682, -0.699, -0.728,
     1 -0.759, -0.79, -0.81, -0.829, -0.828, -0.834, -0.836, -0.84,
     2 -0.846, -0.85, -0.836, -0.824, -0.816, -0.811, -0.808, -0.8,
     3 -0.718, -0.677, -0.732/
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.81e-10 , -0.681 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.41E-3, 5.2E-3, .0138, .023, .0419, .0683, .122, .300, .15,
     2 .697, .709, .644, .525, .446, .363, .302, .102, .27, .0467,
     3 .0835, .0996, .199, .24, .115, .0316, .803, .575, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.469, .357, .281, .128, .0417, .0558, .0346, 0., 1.9, .277,
     2 .135, .134, .192, .332, .337, .121, .0514, .183, 7.56, 4.55,
     3 4.87, 2.19, 1.15, 1.23, .132, .289, .286, 0./
      data (dite(i,1),i=1,ndim-1)
     1/9.82E+4, 2.01E+5, 3.05E+5, 4.20E+5, 5.56E+5, 6.72E+5, 7.93E+5,
     2 9.00E+5, 1.00E+6, 7.81E+5, 7.64E+5, 7.44E+5, 6.65E+5, 5.97E+5,
     3 5.24E+5, 4.96E+5, 4.46E+5, 8.46E+6, 1.36E+6, 1.23E+6, 1.06E+6,
     4 1.25E+6, 1.23E+6, 3.32E+5, 6.45E+5, 6.65E+7, 6.81E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/ 1.01E+5, 1.91E+5, 2.32E+5, 3.18E+5, 4.55E+5, 5.51E+5, 5.28E+5,
     2 0., 5.50E+5, 8.87E+5, 1.80E+6, 1.25E+6, 1.89E+6, 8.84E+5,
     3 1.29E+6, 6.24E+5, 1.59E+6, 8.01E+6, 9.32E+6, 9.45E+6, 9.45E+6,
     4 8.01E+6, 7.57E+6, 2.64E+6, 1.93E+6, 1.19E+7, 9.08E+6, 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4     , 6E6
     5, 6E6     , 1E20    , 1E20 , 1E20 /
      data aa/28*0./,bb/28*0./,cc/28*0./,dd/28*0./,ff/28*0./
*
*     free statement numbers >= 7
*
*     nickel, atomic number 28
      if( .not.lgElmtOn(28) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     charge transfer from Neufeld and Dalgarno 89
*     Ni+2 + H0 => Ni+ + H+,
*     >>chng 96 Oct 1, all H ct moved to bidiag
*     CTHeavy(2,2) = CTHeavy(2,2) + HI * 7.28E-12 * TE70/TE10*TE01*TE01
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine nitrog
      implicit none
*ionization balance for nitrogen
      integer limelm
      parameter (limelm=30)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      integer in1(3)
      real p2nit
      common/nitexc/ p2nit , in1
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real hi , hii
      common/h/ hi , hii
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real aeff , d5200r , cs5200 , gamfun , popexc
      integer i
      integer ndim , nelem
      parameter ( ndim=8)
      parameter (nelem=7)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real grdeff(7)  , yyield(5)
*     real CollidRate(nelem,2)
*
*     nitrogen nelem=7
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /7.08E-11,4.55E-11,1.83E-11,7.16E-12,2.30E-12,1.44E-13,
     1 4.93E-14/
      data (cion(i,2),i=1,ndim-1)
     1 /1.68e5,3.43e5,5.50e5,8.99e5,1.14e6,6.41e6,7.74e6/
*
*     rec from +5, +4 from Arnaud et al 85
      data rec , pl
     1/1.11E-10 , 7.91E-10 , 2.53E-9  , 1.08E-8  , 2.07E-8 , 2.90E-8,
     2 -0.608   , -0.639   , -0.676   , -0.765   , -0.780  , -0.750 /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/2.98E-3 , 7.41E-3 , 1.13E-2 , 2.62E-3 , 7.5E-2 , 4.61E-2 , 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /0.,.0764,.164,.243,.35,.309,0./
      data (dite(i,1),i=1,ndim-1)
     2/2.2E5  , 2.01E5  , 1.72E5  , 1.02E5  , 4.75E6  , 5.44E6  , 0./
      data (dite(i,2),i=1,ndim-1)
     1 /0., 7.37E4, 2.25E5, 1.25E5, 8.35E5, 1.14E6, 0./
      data ditcrt
     3/1.8E4  , 1.8E4  , 2.4E4  , 1.5E4  , 6.8E5  , 1.0E6  , 1E20/
*
      data aa/0.0    , 0.0320, -0.8806, 0.4134  ,0.,0.,0./
     1 ,   bb/0.6310 ,-0.6624, 11.2406, -4.6319 ,0.,0.,0./
     2 ,   cc/0.1990 , 4.3191, 30.7066, 25.9172 ,0.,0.,0./
     3 ,   dd/-0.0197, 0.0003, -1.1721, -2.2290 ,0.,0.,0./
     4 ,   ff/0.4398 , 0.5946, 0.6127 , 0.2360  ,0.1,0.,0./
*
*     nitrogen, atomic number 7
      if( .not.lgElmtOn(7) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     N+2 => N+ Butler and Dalgarno 1980B
*     ct with he now from Sun, Sadeghpour, Kirby, Dalgarno, and Lafyatis,
*     cfa preprint 4208
*     this agrees with exp Fand&Kwong, ApJ 474, 529
      CTHeavy(2,2) = CTHeavy(2,2) + hei*0.8e-10
*     N+3 => N+2 Butler and Dalgarno 1980B
      CTHeavy(3,2) = CTHeavy(3,2) +hei * 1.5e-10
*     ce rate from quantal calc of ce, Ap.J. in press,
*     Feickert, Blint, Surratt, and Watson, (preprint Sep 84).
*     also Rittby et al J Phys B 17, L677, 1984.
*     CR = 1.E-9 + 8E-12 * TE10 * SQRTE
      CTHeavy(4,2) = CTHeavy(4,2) + hei*2E-9
*
*     photoionization from 2D of NI
      if( xIonFracs(7,1).gt.0. ) then
        d5200r = gamfun(in1(1),in1(2),in1(3))
        aeff = d5200r + 1.28e-5
        cs5200 = 1.32e-4 * te/(te10*te01)
*       uses 1 for total pop of atom - so is normalized to unity
        p2nit = popexc(cs5200,4.,10.,aeff,2.769e4,1.)/aeff
        if( lgDoPhoto ) then
          PhotoRate(7,1,3,1) = PhotoRate(7,1,3,1)*(1.-p2nit) +
     1    p2nit*d5200r
          PhotoRate(7,1,3,2) = PhotoRate(7,1,3,2)*(1.-p2nit) + h*p2nit
        endif
      else
        p2nit = 0.
      endif
*
      if( itime.eq.-1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
*     charge exchange destruction-creation of hydrogen
*     CTHrec(1) = CTHrec(1) + xIonFracs(7,1) * c1
*     CTHionAgnt(2) = xIonFracs(7,2) * c2
*     CTHion(1) = CTHion(1) + CTHionAgnt(2)
*     chrener = chrener +
*     (hi*xIonFracs(7,2)*c2-hii*xIonFracs(7,1)*c1)*1.084e4/te1ryd
*
      if( lgTrace.and.lgHeavyBug ) then
        write(qq,'(5X,''NITROGEN retun; frac='',1P,9E10.3)')
     1  (xIonFracs(7,i)/xIonFracs(7,0),i=1,8)
      endif
*
      end
******************************************************************************
      subroutine nockon
      implicit none
*computes suprathermal excitation and ionization efficiencies
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      logical lgSecOFF
*flag saying that secondary electron have been turned off
      common/secoff/ lgSecOFF
      real ElecFrac
*ratio of electron to nuclei density, could be >1 because of he
*set in nockon
      common/efrac/ ElecFrac
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real te , eden , hden
      common/phycon/ te , eden , hden
      real totnuc
*     totnuc is total number of nuclei and molecules, eval in ptot
      common/totnuc/ totnuc
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
*
*     local variables
      real xe
      integer nzsave
      real OldEfionz , OldHeatef , OldExctef
      save OldEfionz , OldHeatef , OldExctef
      save nzsave
      data nzsave/-2/
*
      nzsave = nzone
*     ElecFrac is electron fraction
      ElecFrac = eden / totnuc
      csuEfrac = ElecFrac
*
*     XE = EDEN/(total neutrals, roughly H)
*     analytic fits to Shull and Van Steenberg (1985; Ap.J. 298, 268).
*     lgSecOFF turns off secondary ionizations, sets heating effic to 100%
*
*     heating efficiency
*     following is electron fraction, could be >1 because of He
      xe = ElecFrac
*     only do this if continuum goes to high energies
      if( nzone.lt. 1 ) then
        OldHeatef = 1.
        OldEfionz = 0.
        OldExctef = 0.
      endif
*
      if( lgSecOFF .or. xe.gt.0.95 ) then
        heatef = 1.
        efionz = 0.
        exctef = 0.
      else
*
*       at very low ionization - as per Xu and McCray 1991, Ap.J. 375, 190.
*       everything goes to asymptote that is not present in Shull and
*       Van Steenberg - do this by not letting xe fall below 1e-4
        xe = max( xe , 1e-4)
        heatef = 0.9971 * ( 1.-(1.-xe**0.2663)**1.3163 )
        heatef = (heatef + OldHeatef)/2.
        OldHeatef = heatef
*
*       secondary ionization
        efionz = 0.3908 * (1.-xe**0.4092)**1.7592
        OldEfionz = efionz
*
*       secondary excitation of L-alpha, actually all Lyman lines
        exctef = 0.4766 * (1.-xe**0.2735)**1.5221
        exctef = (exctef + OldExctef) / 2.
        OldExctef = exctef
      endif
*
      end
******************************************************************
      subroutine NoNumb( chCard )
      implicit none
*general error handler for no numbers on input line
      character  chCard*80
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     general catch-all for no number when there should have been
      write(qq,'(1X,A80)') chCard
      write(qq,'('' There should have been a number on this '',
     1''line.   Sorry.'')')
      stop
*
      end
******************************************************************************
      subroutine notein( chLine )
      implicit none
*enter a note about calculation into comment array
      character*132 chLine
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      integer limwcn
      parameter (limwcn=100)
      character chWarnln*132 , chCaunln*132 , chNoteln*132 ,
     1 chBangln*132
      common/wcnln/ chWarnln(limwcn) , chCaunln(limwcn) ,
     1 chNoteln(limwcn) , chBangln(limwcn)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      nnote = nnote + 1
      if( nnote.gt.limwcn ) then
        write(qq,'('' Too many notes have been entered; increase'',
     1  '' the value of LIMWCN everywhere in the code.'')')
        stop
      else
        chNoteln(nnote) = chLine
      endif
*
      end
******************************************************************************
      subroutine noteot( io )
      implicit none
*print stack of notes about current calculation
      integer io
*
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      integer limwcn
      parameter (limwcn=100)
      character chWarnln*132 , chCaunln*132 , chNoteln*132 ,
     1 chBangln*132
      common/wcnln/ chWarnln(limwcn) , chCaunln(limwcn) ,
     1 chNoteln(limwcn) , chBangln(limwcn)
*
      integer i
*
      if(nnote.gt.0)write(io,'(a132)') (chNoteln(i),i=1,nnote)
*
      end
******************************************************************************
      subroutine nsset
      implicit none
*generate low and high boundaries for ionization distribution of each element
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real te , eden , hden
      common/phycon/ te , eden , hden
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real hi , hii
      common/h/ hi , hii
      real uh,uheii
      common/u/ uh,uheii
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real strkar , pestrk
      common/strkar/ strkar(lmhlvl,lmhlvl) , pestrk(lmhlvl,lmhlvl)
      real peshe1
*     stark broadening arrays for HeI
      common/he1str/ peshe1(nhe1lvl,nhe1lvl)
      real peshe2
*     stark broadening escape prob for HeII
      common/he2str/ peshe2(nhe2lvl,nhe2lvl)
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,j
*
      if( lgTrace ) write(qq,'('' NSSET called.'')')
*     free statement numbers >=3
*
*     define array of quantum numbers needed for Puetter Stark broadening
      do i=1,nhlvl-1
        do j=i+1,nhlvl
          strkar(j,i) = float(i*j) ** 1.2
          pestrk(j,i) = 0.
        end do
      end do
*
      do i=1,nhe1lvl-1
        do j=i+1,nhe1lvl
          peshe1(j,i) = 0.
        end do
      end do
*
      do i=1,nhe2lvl-1
        do j=i+1,nhe2lvl
          peshe2(j,i) = 0.
        end do
      end do
*
*     fix number of stages of ionization
      do i=1,limelm
        IonLow(i) = 1
        IonHigh(i) = i + 1
      end do
*
*     bring highest stage of ionization within the freq array
      call histag( 6)
      call histag( 7)
      call histag( 8)
      call histag( 9 )
      call histag( 10)
      call histag( 11)
      call histag( 12)
      call histag( 13)
      call histag( 14)
      call histag( 15 )
      call histag( 16)
      call histag( 17)
      call histag( 18)
      call histag( 19 )
      call histag( 20)
      call histag( 21 )
      call histag( 22 )
      call histag( 23 )
      call histag( 24 )
      call histag( 25 )
      call histag( 26)
      call histag( 27)
      call histag( 28)
      call histag( 29)
      call histag( 30)
*
*     if very highly ionized then raise lower ionization stages
      if( uh .ge. 1. ) then
        do i=11,20
          IonLow(i) = max( 1 , IonHigh(i) -7)
        end do
        do i=21,limelm
          IonLow(i) = max( 1 , IonHigh(i) -15)
        end do
      endif
*
      end
******************************************************************************
      subroutine nxtchr( chr , ichr , ipnt , chCard , last , lgEOL )
      implicit none
*get the next character on command line, used by fread
      character chr*1 , chCard*80
      integer last , ipnt , ichr
      logical lgEOL
*
*     read character chCard(IPNT:IPNT), return charac as CHR, octal as ICHR
*     return lgEOL=.TRUE. if END reached
*
      chr = chCard(ipnt:ipnt)
      ichr = ichar( chr )
*
      if(ipnt.ge.last ) then
        lgEOL = .true.
      else
        lgEOL = .false.
      endif
*
      end
******************************************************************************
      subroutine obsred( chCard )
      implicit none
*parse observed line intensites for optimization routines
      character*80  chCard
*     read observed line fluxes & errors
      integer nobslm
      parameter (nobslm=100)
      real amint,amierr
      integer linam,nlobs
      common/obsint/ amint(nobslm),amierr(nobslm),linam(nobslm),nlobs
      character*4 chAmLab
      common/obslin/ chAmLab(nobslm)
      logical lgTrOptm
*flag set with trace optimizer command
      common/troptm/ lgTrOptm
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOF , lgEOL
      integer i , j
      real fread
      character*80  chCap , chVlt*1
      real deferr
      parameter (deferr=0.05)
*
      nlobs = 0
*
      call readar( chCard , lgEOF )
      if( lgEOF ) then
        write(qq,'('' Hit EOF while reading line list; use END to'',
     1  '' end list.'')')
        stop
      endif
      chCap = chCard
      call caps( chCap )
*
      do while( .not.lgEOF )
        nlobs = nlobs + 1
        if( nlobs.gt.nobslm ) then
          write(qq,'('' Too many lines have been entered; the limit is''
     1    ,I4,''.  Increase variable NOBSLM.'')') nobslm
          stop
        endif
*
*       order on line is label (col 1-4), wavelength, flux, error
        chAmLab(nlobs) = chCard(1:4)
        i = 5
        linam(nlobs) = fread( chCard , i , 76 , lgEOL )
        amint(nlobs) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'(1X,A80)') chCard
          write(qq,'('' The wavelength and relative intensity MUST'',
     1    '' be entered on this line.  Sorry.'')')
          stop
        endif
        amierr(nlobs) = fread( chCard , i , 76 , lgEOL )
*
        if( amint(nlobs).le.0. ) then
          write(qq,'('' An observed intensity of'',1P,E10.2,
     1    '' is not allowed.  Sorry.'')') amint(nlobs)
          stop
        endif
*
        if(amierr(nlobs).le.0.0 ) then
*         this is the relative error allowed
          amierr(nlobs) = deferr
        endif
*
*       check if number is a limit
        chVlt = ' '
        do j=1,80
          if(chCard(j:j).eq.'<') then
*           limit value assumed
            chVlt='<'
          endif
        end do
*
        if(chVlt.eq.'<') then
*         value is an upper limit only, use negative error to flag
          amierr(nlobs) = -amierr(nlobs)
        endif
*
*       get next line
        call readar( chCard , lgEOF )
        if( lgEOF ) then
          write(qq,'('' Hit EOF while reading line list; use END to'',
     1    '' end list.'')')
          stop
        endif
        chCap = chCard
        call caps( chCap )
        if( chCap(1:3).eq.'END' ) lgEOF = .true.
      end do
*
      if(lgTrace.and.lgTrOptm ) then
        write(qq,'(I4,'' lines were entered, they were;'')') nlobs
        do i=1,nlobs
          write(qq,'(1x,a4,i5,1p,2e10.2)') chAmLab(i),linam(i),
     1    amint(i),amierr(i)
        end do
      endif
*
      end
**************************************************************************
      subroutine ofit(e,otot,opart)
      implicit none
*compute cross sections for all shells of atomic oxygen
* Photoionization of OI
* Input parameter:   e - photon energy, eV
* Output parameters: otot - total photoionization cross section, Mb
*    opart(1) - 2p-shell photoionization, goes to 4So
*    opart(2) - 2p-shell photoionization, goes to 2Do
*    opart(3) - 2p-shell photoionization, goes to 2Po
*    opart(4) - 2s-shell photoionization
*    opart(5) - double photoionization, goes to O++
*    opart(6) - triple photoionization, goes to O+++
*    opart(7) - 1s-shell photoionization
      real y(5,7),eth(7),opart(7),otot,e,q,x
      integer l(7),i
      data eth/13.62,16.94,18.79,28.48,50.,110.5,538./
      data (y(i,1),i=1,5)/8.915,3995.,3.242,10.44,0.0/
      data (y(i,2),i=1,5)/11.31,1498.,5.27,7.319,0.0/
      data (y(i,3),i=1,5)/10.5,1.059E+05,1.263,13.04,0.0/
      data (y(i,4),i=1,5)/19.49,48.47,8.806,5.983,0.0/
      data (y(i,5),i=1,5)/50.,4.244E+04,0.1913,7.012,4.454E-02/
      data (y(i,6),i=1,5)/110.5,0.1588,148.3,-3.38,3.589E-02/
      data (y(i,7),i=1,5)/177.4,32.37,381.2,1.083,0.0/
      data l/1,1,1,0,1,1,0/
      otot=0.0
      do i=1,7
         opart(i)=0.0
      end do
      do i=1,7
         if(e.ge.eth(i))then
            q=5.5-0.5*y(4,i)+l(i)
            x=e/y(1,i)
            opart(i)=y(2,i)*((x-1.0)**2+y(5,i)**2)/x**q/
     &           (1.0+sqrt(x/y(3,i)))**y(4,i)
            otot=otot+opart(i)
         endif
      end do
*
      end
*****************************************
      subroutine oilevl( abund , coloi )
      implicit none
*get OI level population with Ly-beta pumping
      real abund , coloi
*
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer ipoiex
*pointers to line energies for OI bowen problem,
*used to generate boltzman factors
      common/ipoi/ ipoiex(5)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgTr8446
*flag set with trace beta command
      common/tr8446/ lgTr8446
      real pmph31, pmpo51, pmpo15 , esch31
      common/bowoi/ pmph31, pmpo51, pmpo15 , esch31
      real popoi
      common/popoi/ popoi(6)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      integer negoi
      common/negoi/ negoi
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i, ner
      real c12,c14,c15,c23,c64,c65,c53,c43,c62,simple,cs,
     1 c26,c32,c51,c41,c21,a65,a64,a53,a62,a32,a51,a41,a21,
     2 e56,e45,e23,e12,e34,a43,c56,c46,c34,c35,c16,c61,c13,c31,
     3 c36 , c63 , c42, c24, c52, c25 , c45 , c54
      double precision zz(7,7)
      logical lgNegPop
      real deptoi(6)
      real g(6)
      data g/9.,3.,9.,3.,15.,9/
*
*     free statement numbers >=3
*
*     compute emission from six level OI atom
*
*     boltzmann factors for ContBoltz since collisions not dominant in UV tran
*     ipoiex is array lof dEnergy for each level, set in DoPoint
      e12 = ContBoltz( ipoiex(1) )
      e23 = ContBoltz( ipoiex(2) )
      e34 = ContBoltz( ipoiex(3) )
      e45 = ContBoltz( ipoiex(4) )
      e56 = ContBoltz( ipoiex(5) )
*
*     total rad rates here include dest by background continuum
      a21 = t1304(ipLnAul)*(t1304(ipLnDesP)+t1304(ipLnEscP))
      a41 = t1039(ipLnAul)*(t1039(ipLnDesP)+t1039(ipLnEscP))
      a51 = tO1025(ipLnAul)*(tO1025(ipLnDesP)+tO1025(ipLnEscP))
      a51 = pmpo51
      a32 = t8446(ipLnAul)*(t8446(ipLnDesP)+t8446(ipLnEscP))
      a62 = t4368(ipLnAul)*(t4368(ipLnDesP)+t4368(ipLnEscP))
      a43 = tOI13(ipLnAul)*(tOI13(ipLnDesP)+tOI13(ipLnEscP))
      a53 = tOI11(ipLnAul)*(tOI11(ipLnDesP)+tOI11(ipLnEscP))
      a64 = tOI29(ipLnAul)*(tOI29(ipLnDesP)+tOI29(ipLnEscP))
      a65 = tOI46(ipLnAul)*(tOI46(ipLnDesP) +tOI46(ipLnEscP))
*
*     even at density of 10^17 excited states not in lte due
*     to fast transitions down - just need to kill a21 to get to unity at 10^17
*
*     the 2-1 transition is 1302, cs Wang and McConkey '92 Jphys B 25, 5461
      cs = 2.151e-5 * te/te03
      call PutCS( cs , t1304 )
*     the 5-1 transition is 1027, cs Wang and McConkey '92 Jphys B 25, 5461
      cs = 9.25e-7 * te*te10/te01/te01
      call PutCS( cs , tO1025 )
      c21 = cdsqte * t1304(ipLnCS)  / g(2)
      c51 = cdsqte * tO1025(ipLnCS) / g(5)
*     all following are g-bar approx, g-bar = 0.2
      c31 = cdsqte * 1.0  / g(3)
      call PutCS( 0.27 , t1039 )
      c41 = cdsqte * t1039(ipLnCS) / g(4)
      c61 = cdsqte * 1.   / g(6)
      c12 = c21 * g(2)/g(1) * e12
      c13 = c31 * g(3)/g(1) * e12*e23
      c14 = c41 * g(4)/g(1) * e12*e23*e34
      c15 = c51 * g(5)/g(1) * e12*e23*e34*e45
      c16 = c61 * g(6)/g(1) * e12*e23*e34*e45*e56
*
      c32 = cdsqte*85. / g(3)
      c42 = cdsqte*85. / g(4)
      c52 = cdsqte*85. / g(5)
      c62 = cdsqte*85. / g(6)
      c23 = c32 * g(3)/g(2) * e23
      c24 = c42 * g(4)/g(2) * e23*e34
      c25 = c52 * g(5)/g(2) * e23*e34*e45
      c26 = c62 * g(6)/g(2) * e23*e34*e45*e56
*
      c43 = cdsqte * 70.  / g(4)
      c53 = cdsqte * 312. / g(5)
      c63 = cdsqte * 1.   / g(6)
      c34 = c43 * g(4)/g(3) * e34
      c35 = c53 * g(5)/g(3) * e34*e45
      c36 = c63 * g(6)/g(3) * e34*e45*e56
*
      c54 = cdsqte *  50. / g(5)
      c64 = cdsqte * 415. / g(6)
      c45 = c54 *g(5)/g(4) * e45
      c46 = c64 *g(6)/g(4) * e45*e56
*
      c65 = cdsqte * 400. / g(6)
      c56 = c65 * g(6)/g(5) * e56
*
* 666 error! this must include all stimulated emission, pump by cont, etc
*
*     this is check for whether matrix inversion likely to fail
      simple = (c16 + pmpo15) / (c61+c62+c64+a65+a64+a62)
      if( simple .lt.1e-19 ) then
        popoi(1) = abund
        do i=2,6
          popoi(i) = 0.
        end do
        coloi = 0.
        return
      endif
*
*---------------------------------------------------------
*
      do i=1,6
        zz(1,i) = 1.0
        zz(i,7) = 0.
      end do
*     first equation is sum of populations
      zz(1,7) = abund
*
*     level one ground term
*     zz(1,1) = c12+c14+c15+pmpo15+c16+c13
*     zz(1,2) = -a21 - c21
*     zz(1,3) = -c31
*     zz(1,4) = -c41 - a41
*     zz(1,5) = -c51 - a51
*     zz(1,6) = -c61
*
*     level two, 3s 3So
      zz(2,1) = -c12
      zz(2,2) = c21 +c23 +c24 +c25 +c26 +a21
      zz(2,3) = -c32 - a32
      zz(2,4) = -c42
      zz(2,5) = -c52
      zz(2,6) = -c62 -a62
*
*     level three
      zz(3,1) = -c13
      zz(3,2) = -c23
      zz(3,3) = c31 +c32 +c34 +c35 +c36 +a32
      zz(3,4) = -c43 - a43
      zz(3,5) = -c53 - a53
      zz(3,6) = -c63
*
*     level four
      zz(4,1) = -c14
      zz(4,2) = -c24
      zz(4,3) = -c34
      zz(4,4) = c41 +c42 +c43 +c45 +c46 +a41 +a43
      zz(4,5) = -c54
      zz(4,6) = -c64  -a64
*
*     level five
      zz(5,1) = -c15 - pmpo15
      zz(5,2) = -c25
      zz(5,3) = -c35
      zz(5,4) = -c45
      zz(5,5) = c51 +c52 +c53 +c54 +c56 +a51 +a53
      zz(5,6) = -c65 - a65
*
*     level six
      zz(6,1) = -c16
      zz(6,2) = -c26
      zz(6,3) = -c36
      zz(6,4) = -c46
      zz(6,5) = -c56
      zz(6,6) = c61+c62+c63+c64+c65+a65+a64+a62
*
      call matin1(zz,7,6,1,ner)
      if( ner.ne.0 ) then
        if( lgTalk ) write(qq,'('' oi matrix error'')')
        stop
      endif
*
      lgNegPop = .false.
      do i=1,6
        popoi(i) = zz(i,7)
        if( popoi(i).lt.0. ) lgNegPop = .true.
      end do
*
*     following used to confirm that all dep coef are unity at
*     density of 1e17, t=10,000, and all A's set to zero
      if( lgTrace.and.lgTr8446 ) then
        deptoi(1) = 1.
        deptoi(2) = popoi(2)/popoi(1)/(g(2)/g(1)*e12)
        deptoi(3) = popoi(3)/popoi(1)/(g(3)/g(1)*e12*e23)
        deptoi(4) = popoi(4)/popoi(1)/(g(4)/g(1)*e12*e23*e34)
        deptoi(5) = popoi(5)/popoi(1)/(g(5)/g(1)*e12*e23*e34*e45)
        deptoi(6) = popoi(6)/popoi(1)/(g(6)/g(1)*e12*e23*e34*e45*e56)
        write(qq,'('' oilevl finds levl pop'',1p,10e11.3)') popoi
        write(qq,'('' oilevl finds dep coef'',1p,10e11.3)') deptoi
      endif
*
*     this happens due to numerical instability in matrix inversion routine
      if( lgNegPop ) then
         negoi = negoi + 1
         write(qq,'('' OILEVL finds negative population'',1P,6E10.2)')
     1   popoi
         write(qq,'('' simple 5 ='',1P,E10.2)') simple
*
         popoi(6) = 0.
         popoi(5) = abund*(c15+pmpo15)/(a51+a53+c51+c53)
         popoi(4) = 0.
         popoi(3) = popoi(5)*(a53+c53)/(a32+c32)
         popoi(2) = (popoi(3)*(a32+c32)+abund*c12) /(a21+c21)
         popoi(1) = abund
*        write(QQ,'('' OILEVL resets this to simple pop'',1P,6E10.2)')
*    1   popoi
      endif
*
*     this is total cooling due to model atom, can be neg (heating)
      coloi =
     1 (popoi(1)*c12-popoi(2)*c21) * 1.53e-11 +
     1 (popoi(1)*c14-popoi(4)*c41) * 1.92e-11 +
     2 (popoi(1)*c15-popoi(5)*c51) * 1.94e-11 +
     3 (popoi(2)*c23-popoi(3)*c32) * 2.36e-12 +
     4 (popoi(2)*c26-popoi(6)*c62) * 4.55e-12 +
     5 (popoi(3)*c35-popoi(5)*c53) * 1.76e-12 +
     6 (popoi(3)*c34-popoi(4)*c43) * 1.52e-12 +
     7 (popoi(4)*c46-popoi(6)*c64) * 6.86e-13 +
     8 (popoi(5)*c56-popoi(6)*c65) * 4.32e-13
*
      end
******************************************************************************
      subroutine opac0
      implicit none
*compute initial set of opacities for all species
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      real widflx
      common/widflx/ widflx(ncell)
      real AnuOrg
*original set of energy units, always the same no matter what the
*shape of the continuum - actual energy units change with shape
      common/anusave/ AnuOrg(ncell)
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      integer iphop
      common/iphop/ iphop(lmhlvl)
      integer iophe1
      common/iophe1/ iophe1(9)
      integer iophe2
      common/iophe2/ iophe2(9)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer i2d , i2p
*pointers for photoionization into excited state of oii
      common/i3727/ i2d , i2p
      real opac
      common/opac/ opac(ncell)
      real PH1
*     ph1(a,b,c,d)
*     a=1 => thresh, others fitting parameters
*     b atomic number
*     c number of electrons
*     d shell number 7-1
      common/PH1/ PH1(6,30,30,7)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      integer iphmin
      common/iphmin/ iphmin
      integer iopo2d
      common/iopo/ iopo2d
      real Hy2nu, he12nu, he22nu
*Hy2nu is hydrogen two photon, others He1 and He2
      common/em2nu/ Hy2nu(ncell) , he12nu(ncell), he22nu(ncell)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      integer ipRayScat
*opacity pointer for rayleigh scattering
      common/iprayl/ ipRayScat
      integer ipBrems
*opacity offset pointer for brems (free-free)
      common/ipbrms/ ipBrems
      integer iphmra
      common/iphmra/ iphmra
      integer iphmop
      common/iphmop/ iphmop
      integer ioptri
      common/ioptri/ ioptri
      integer noptot
      common/noptot/ noptot
      integer ippr , ioppr
      common/ipair/ ippr , ioppr
      integer iopcom
      common/iopcom/ iopcom
      integer nxray
      common/nxray/ nxray
      integer ica2ex , ica2op
      common/ca2ex/ ica2ex(2) , ica2op
      integer ih2pnt , ih2pof
      common/h2ppnt/ ih2pnt(2) , ih2pof
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      integer ipmgex ,ipOpMgEx
      real xmglst, popmg2 , rmg2l , xMg2Max
*     these all deal with photoionization from upper lev of Mg II 2798
      common/mgexc/ ipmgex , xmglst, popmg2 , rmg2l , xMg2Max,ipOpMgEx
      integer in1(3)
      real p2nit
      common/nitexc/ p2nit , in1
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
      logical lgPhFit
*which version of phfit should be used?
      common/PhFitOn/ lgPhFit
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*
      integer i,n , ipoint
      real eps,x,hbf,rayleh,eva2nu,ehe12p,ehe22p,thom,hmiopc,
     1 z,crs,thres
      logical lgOpEval
      integer ncsh2p
      parameter (ncsh2p=10)
      real csh2p(ncsh2p) , opart(7)
*
      double precision dx
*
      save lgOpEval
      data lgOpEval/.false./
*
*     H2+ h2plus h2+
      data csh2p/6.75,0.24 , 8.68,2.5, 10.54,7.1, 12.46,6.0,
     1 14.28,2.7/
*
*     free statement labels >=92
*
*     this is option to stop at certain optical depth
      if( taunu.gt.0. ) then
        iptnu = ipoint( taunu )
        iptnu = min( iptnu , ncell-1 )
      else
        iptnu = ncell
        tauend = 1e30
      endif
*
*     make and print dust opacities
*     fill in dstab and dstsc, totals, zero if no dust
*     may be different if different grains are turned on
      call dustop
*
      if( lgOpEval ) then
*       this is not the first time code called
        if(lgTrace) write(qq,'('' OPAC0 called but NOT evaluated.'')')
        return
      endif
*
      lgOpEval = .true.
      if(lgTrace) write(qq,'('' OPAC0 called.'')')
*
*     zero out opac since this array sometimes addressed before AddOpac called
      do i=1,ncell
        opac(i) = 0.
      end do
*
*     NOPTOT is number of opacity cells OPSV filled so far by OPAC0
      noptot = 0
*
*     hydrogen Lyman continuum
      iphop(1) = noptot + 1
      do i=ipHn(1),nupper
*       >>chng 96 oct 8, from analytic to phfit for cs, diff less than 1%
*       eps = sqrt(abs( AnuOrg(i) - 1.) ) + 1e-3
*       OpacStack(i-ipHn(1)+iphop(1)) = 6.3e-18/anu2(i)/anu2(i)*exp(4.*
*    1  (1.-atan(eps)/eps)) / (1.-exp(-6.283185/eps))
        thres = max( AnuOrg(i)*evryd , PH1(1,1,1,1) )
        call phfit(1,1,1,thres ,crs,lgPhFit)
        OpacStack(i-ipHn(1)+iphop(1)) = crs * 1e-18
      end do
      noptot = noptot + nupper - ipHn(1) + 1
*
*     Balmer, Paschen, etc  continua, hbf only goes up to 10
      do n=2,min(10,nhlvl)
        iphop(n) = noptot + 1
        do i=ipHn(n),ipHn(1)
          x = anulog(i) - anulog(ipHn(n))
          OpacStack(i-ipHn(n)+iphop(n)) = hbf(x ,n,1.)
        end do
        noptot = noptot + ipHn(1) - ipHn(n) + 1
      end do
*
      do n=11,nhlvl
        iphop(n) = noptot + 1
*       this routine can do ANY level, but is probably very slow
        call SigmaSet( AnuOrg(ipHn(n)) , OpacStack(iphop(n)), n ,
     1  ipHn(1)-ipHn(n)+1 )
        noptot = noptot + ipHn(1) - ipHn(n) + 1
      end do
*
*     Lyman alpha damping wings - Rayleigh scattering
      ipRayScat = noptot + 1
      do i=1,ipHn(1)
        OpacStack( i-1+ipRayScat ) = rayleh( AnuOrg(i) )
      end do
      noptot = noptot + ipHn(1) - 1 + 1
*
*     hydrogen two photon emission
*     sum = 0.
      do i=1,iphl(2,1)
        Hy2nu(i) = eva2nu( AnuOrg(i)) * widflx(i)
*       sum = sum + Hy2nu(i)
      end do
*
*     HeI two photon emission
*     sum = 0.
      do i=1,iphe1l(2,1)
        he12nu(i) = ehe12p( AnuOrg(i)) * widflx(i)
*       sum = sum + he12nu(i)
      end do
*
*     sum = 0.
*     HeII two photon emission
      do i=1,iphe2l(2,1)
        he22nu(i) = ehe22p( AnuOrg(i)) * widflx(i)
*       sum = sum + he22nu(i)
      end do
*
*     assume Thomson scattering up to NXRAY, 20.6 Ryd=0.3 keV
      thom = 6.65e-25
      iopcom = noptot + 1
      do i=1,nxray
        OpacStack(i-1+iopcom) = thom
      end do
*
*     Klein-Nishina from eqn 7.5, Rybicki and Lightman
      do i=nxray+1,nupper
        dx = AnuOrg(i) / 3.7573d4
        OpacStack(i-1+iopcom) = thom *
     1  3.d0/4.d0*( (1.d0+dx)/dx**3 * (
     2  2.d0*dx*(1.d0+dx)/(1.d0+2.d0*dx) - log( 1.d0+2.d0*dx ) ) +
     3  1.d0/2.d0/dx*log(1.d0+2.d0*dx) -
     4  (1.d0+3.d0*dx)/(1.d0+2.d0*dx)**3 )
      end do
      noptot = noptot + nupper - 1 + 1
*
*     pair production
      ioppr = noptot + 1
      do i=ippr,nupper
*       pair production heating rate for unscreened H + He
*       fit to figure 41 of Experimental Nuclear Physics,
*       Vol1, E.Segre, ed
        x = AnuOrg(i) / 7.512e4 * 2.
        OpacStack(i-ippr+ioppr) = 5.793e-28 *
     1  ((-0.46737118 + x*(0.349255416+x*0.002179893))/
     2  (1.+x*(0.130471301+x*0.000524906)))**2
      end do
      noptot = noptot + nupper - ippr + 1
*
*     brems (free-free) opacity
      ipBrems = noptot + 1
      do i=1,nupper
*       missing factor of 1E-20 to avoid underflow
*       free free opacity needs g(ff)*(1-exp(hn/kT))/sqrt(T)*1E-20
        OpacStack(i-1+ipBrems) = 1.03680e-18 / (AnuOrg(i)**3)
      end do
      noptot = noptot + nupper - 1 + 1
*
      iphmra = noptot + 1
      do i=1,nupper
*       following is ratio of h minus to neut h opacity
        OpacStack(i-1+iphmra) = 0.1175 * anusqr(i)
      end do
      noptot = noptot + nupper - 1 + 1
*
      iphmop = noptot + 1
      do i=iphmin,nhe1(1)
*       H- hminus H minus bound-free opacity
        OpacStack(i-iphmin+iphmop) = hmiopc( AnuOrg(i) )
      end do
      noptot = noptot + nhe1(1) - iphmin + 1
*
*     H2+ H2P h2plus photoabsorption
*     cs from Buckingham Reid and Spence, MN 112m 382, 0 K temp
      call opacrm( ih2pnt(1),ih2pnt(2) , csh2p, ncsh2p , ih2pof,'H2+ ')
*
*     Helium, triplet 23S from Steward 1979, quoted in Mathisen compendium
      call opacpl( nhei3,nhe1(1) ,5.5e-18,1.35,ioptri )
*
*     HeI singlet neutral helium ground
      iophe1(1) = noptot + 1
      do i=nhe1(1),nupper
*       following was brown values, bad at high energies
*       if( AnuOrg(i) .le. 4.809 ) then
*         x = 3.61 * AnuOrg(i) - 0.22
*       else
*         x = 37. - 63. * AnuOrg(i) ** (-0.76)
*       endif
        call phfit(2,2,1,AnuOrg(i)*evryd,crs,lgPhFit)
        OpacStack(i-nhe1(1)+iophe1(1)) = crs*1e-18
      end do
      noptot = noptot + nupper - nhe1(1) + 1
*
*     HeI neutral Helium 21s from Stewart JPhysB 11, L431
      call opacpl( nhe1(2),nhe1(1),0.4*8.7e-18,1.5,iophe1(2))
*
*     HeI helium singlet bound free excited states
      z = 1.
      do n=3,nhe1lvl
        crs = 7.906e-18 * float(n) / (z*z)
        call opacpl( nhe1(n),nhe1(1),crs ,3.0,iophe1(n))
      end do
*
*     HeII ionized helium bound free ground state
      iophe2(1) = noptot + 1
      do i=nhe2(1),nupper
*       >>chng 96 oct 8, from analytic to phfit for cs, diff less than 1%
*       eps = sqrt( abs( AnuOrg(i)/4. - 1.) ) + 1e-3
*       OpacStack(i-nhe2(1)+iophe2(1)) = 4.032e-16/anu2(i)/anu2(i)*
*    1  exp(4.* (1.-atan(eps)/eps)) / (1.-exp(-6.283185/eps))
        thres = max( AnuOrg(i)*evryd , PH1(1,2,1,1) )
        call phfit(2,1,1,thres ,crs,lgPhFit)
        OpacStack(i-nhe2(1)+iophe2(1)) = crs*1e-18
      end do
      noptot = noptot + nupper - nhe2(1) + 1
*
*     HeII ionized helium bound free excited states
      z = 2.
      do n=2,nhe2lvl
        crs = 7.906e-18 * float(n) / (z*z)
        iophe2(n) = noptot + 1
        do i=nhe2(n),nhe2(1)
          x = anulog(i) - anulog(nhe2(n))
          OpacStack(i-nhe2(n)+iophe2(n)) = hbf(x ,n,2.)
        end do
        noptot = noptot + nhe2(1) - nhe2(n) + 1
      end do
*
*     lithium opacity
      call MakeOpacity( 3)
*
*     beryllium opacity
      call MakeOpacity( 4)
*
*     boron opacity
      call MakeOpacity( 5)
*
*     carbon opacity
      call MakeOpacity( 6 )
*
*     Nitrogen
      call MakeOpacity( 7 )
*     Henry ApJ 161, 1153.
*     photoionization of excited level of N+
      call opacpl( in1(1) , in1(2) , 9e-18,1.75,in1(3) )
*
*     Oxygen
      call MakeOpacity( 8 )
*     only do this is 1996 Verner results are used
      if( .not.lgPhFit ) then
        do i=ipElement(8,1,3,1),ipElement(8,1,3,2)
          eps = AnuOrg(i) * evryd
          call ofit(eps,crs,opart)
*         this is total cs of all processes leaving shell 3
          crs = opart(1)
          do n=2,6
            crs = crs + opart(n)
          end do
          crs = crs * 1e-18
          OpacStack(i-ipElement(8,1,3,1)+ipElement(8,1,3,3) ) = crs
        end do
      endif
*     Henry nubmers for 1S excit state of OI, OP data very sparse
      call opacpl( ipo1exc(1),ipo1exc(2),4.64e-18,0.,ipo1exc(3) )
*     photoionization of excited level of O2+ 1D making 5007
*     fit to TopBase Opacity Project cs
      call opacpl( ipo3exc(1) , ipo3exc(2),3.8e-18,0.,ipo3exc(3) )
*     photoionization of excited level of O2+ 1S making 4363
      call opacpl( ipo3exc3(1) , ipo3exc3(2),5.5e-18,0.01,ipo3exc3(3) )
*
*     photoionization to excited states of O+
      iopo2d = noptot + 1
      thres = AnuOrg(i2d)
      do i=i2d,nhe2(1)
        crs = 3.85e-18 * (4.4*(AnuOrg(i)/thres)**(-1.5)  -
     1  3.38 * (AnuOrg(i) / thres) ** (-2.5) )
        OpacStack(i-i2d+iopo2d) = crs
      end do
      noptot = noptot + nhe2(1) - i2d + 1
*
*     Fluorine opacity
      call MakeOpacity( 9)
*
*     Neon
      call MakeOpacity( 10 )
*
*     Sodium
      call MakeOpacity( 11 )
*
*     Magnesium
      call MakeOpacity( 12 )
*     photoionization of excited level of Mg+
*     fit to opacity project data Dima got
      ipOpMgEx = noptot + 1
      do i=ipmgex,ipHn(1)
        OpacStack( i-ipmgex+ipOpMgEx ) = (0.2602325880970085 +
     1  445.8558249365131*exp(-AnuOrg(i)/0.1009243952792674))*1e-18
      end do
      noptot = noptot + ipHn(1) - ipmgex + 1
*
*     Aluminum
      call MakeOpacity( 13 )
*
*     Silicon
      call MakeOpacity( 14 )
*
*     phosphorus
      call MakeOpacity( 15 )
*
*     Sulphur
      call MakeOpacity( 16 )
*
*     Chlorine
      call MakeOpacity( 17 )
*
*     Argon
      call MakeOpacity( 18 )
*
*     potassium
      call MakeOpacity( 19 )
*
*     Calcium
      call MakeOpacity( 20 )
*     excited states of Ca+
      call opacpl( ica2ex(1) , ica2ex(2) , 4e-18 , 1. , ica2op )
*
*     scandium
      call MakeOpacity( 21 )
*
*     titanium
      call MakeOpacity( 22 )
*
*     vanadium
      call MakeOpacity( 23 )
*
*     chromium
      call MakeOpacity( 24 )
*
*     Manganese
      call MakeOpacity( 25 )
*
*     Iron
      call MakeOpacity( 26 )
*
*     Cobalt
      call MakeOpacity( 27 )
*
*     nickel
      call MakeOpacity( 28 )
*
*     copper
      call MakeOpacity( 29 )
*
*     zinc
      call MakeOpacity( 30 )
*
      if( lgTrace ) write(qq,'('' OPAC0 return OK, number of opacity'',
     1 '' cells used in OPSC='',I7,'' and OPSV is dimensioned'',I7)')
     2 noptot , NOPSV
*
      if( NOPSV - noptot .lt.ncell ) write(qq,'('' Warning, only'',
     1I4,'' cells left in OPSV.  Increase NOPSV.'')') NOPSV - noptot
*
      end
******************************************************************************
      subroutine opacpl(ilo,ihi,cross,s,ip)
      implicit none
*generate array of cross sections using a simple power law fit
      integer ilo,ihi,ip
      real cross , s
*
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer noptot
      common/noptot/ noptot
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real thres
*
      ip = noptot + 1
      thres = anu(ilo)
*
      do i=ilo,ihi
        OpacStack(i-ilo+ip) = cross * (anu(i)/thres)**(-s)
      end do
*
      noptot = noptot + ihi - ilo + 1
      if( noptot.gt.NOPSV ) then
        write(qq,'('' OPACPL too many opacity points.'')')
        write(qq,'('' Increase parameter variable NOPSV'',
     1  '' everywhere it occurs in the code.'')')
        write(qq,'('' The current value is'',I6,''.'')') NOPSV
        stop
      endif
*
      end
******************************************************************************
      subroutine opacrm( low , ihi , cross , ncross,  ipop ,chLabl)
      implicit none
*generate photoionization cross sections from Reilman and Manson points
      integer ncross , low , ihi , ipop
      character*4 chLabl
      real cross(ncross)
*
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      integer noptot
      common/noptot/ noptot
*
*     local variables
      integer nop , ncr , i , j , ics
      real slope
      parameter(nop=100)
      real en(nop) , cs(nop)
*
*     this is the opacity entering routine designed for
*     the Reilman and Manson tables.  It works with incident
*     photon energy (entered in eV) and cross sections in megabarns
*
      ipop = noptot + 1
*
      ncr = ncross / 2
      if( ncr.gt.nop ) then
         write(qq,'('' Too many opacities were entered into'',
     1   '' OPACRM.  Increase the value of NOP.'')')
         write(qq,'('' chLabl was '',A4)') chLabl
         stop
      endif
*
*     the array CROSS has ordered pairs of elements.
*     the first is the energy in eV (not Ryd)
*     and the second is the cross section in megabarns
      do i=1,ncr
        en(i) = cross( (i-1)*2+1 ) / 13.6
        cs(i) = cross( i*2 ) * 1e-18
      end do
*
      if( en(1).gt.anu(low) ) then
         write(qq,'('' OPACRM: The entered opacity energy bandwidth''
     1   ,'' is not large enough (low fail).'')')
         write(qq,'('' The desired energy (Ryd) was'',1P,E12.5,
     1   ''eV and the lowest entered in the array was'',E12.5,'' eV'')')
     2   anu(low)*13.606 , en(1)*13.606
         write(qq,'('' chLabl was '',A4)') chLabl
         write(qq,'('' The original energy (eV) and cross section (mb)''
     1   ,'' arrays follow:'')')
         write(qq,'(1X,1P,2E11.4)') (cross(i),i=1,ncross)
         stop
      endif
*
      slope = ( cs(2)-cs(1) ) / ( en(2)-en(1) )
      ics = 1
*
*     now fill in the opacities using linear interpolation
      do i=low,ihi
        if( anu(i).gt.en(ics) .and. anu(i).le.en(ics+1)) then
          OpacStack(i-low+ipop) = cs(ics) + slope*(anu(i)-en(ics))
        else
          ics = ics + 1
          if(ics+1.gt.ncr ) then
            write(qq,'('' OPACRM: The entered opacity energy ''
     1      ,''bandwidth is not large enough (high fail).'')')
            write(qq,'('' The entered energy was '',1P,E10.2,
     1      ''eV and the highest in the array was '',E10.2,''eV'')')
     2      anu(i)*13.6 , en(ncr)*13.6
            write(qq,'('' chLabl was '',A4)') chLabl
            write(qq,'('' The lowest energy enterd in the array was''
     1      ,1P,E10.2,'' eV'')') en(1)*13.65
            write(qq,'('' The highest energy ever needed would be'',
     1      1P,E10.2,''eV'')') anu(ihi)*13.6
            write(qq,'('' The lowest energy needed was'',
     1      1P,E10.2,''eV'')') anu(low)*13.6
            stop
          endif
          slope = ( cs(ics+1)-cs(ics) ) / ( en(ics+1)-en(ics) )
          if( anu(i).gt.en(ics) .and. anu(i).le.en(ics+1)) then
            OpacStack(i-low+ipop) = cs(ics) + slope*(anu(i)-en(ics))
          else
            write(qq,'('' Internal logical error in OPACRM.'')')
            write(qq,'('' The desired energy ('',1P,E9.2,
     1      ''eV), I='',I5,'', is not within the next energy bound'',
     2      2e10.2)') anu(i)*13.6 , i , en(ics) , en(ics+1)
            write(qq,'('' The previous energy (eV) was'',1P,E9.2)')
     3      anu(i-1)*13.6
            write(qq,'('' Here comes the energy array.  ICS='',
     1      I4)') ics
            write(qq,'(1P,10E10.2)') (en(j),j=1,ncr)
            write(qq,'('' chLabl was '',A4)') chLabl
            stop
          endif
        endif
      end do
*
      noptot = noptot + ihi - low + 1
      if( noptot.gt.NOPSV ) then
         write(qq,'('' OPACPL too many opacity points.'')')
         write(qq,'('' Increase parameter variable NOPSV'',
     1   '' everywhere it occurs in the code.'')')
         write(qq,'('' The current value is'',I6,''.'')') NOPSV
         stop
      endif
*
      end
******************************************************************************
      subroutine opacz
      implicit none
*zero out opacity save arrays, save old opacity in OldOpacSave array
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real opac
      common/opac/ opac(ncell)
      real OldOpacSave
      logical lgOTSOn
*save previous opacity
      common/OldOpac/ OldOpacSave(ncell)  , lgOTSOn(ncell)
*
      integer i
*
      do i=1,ncell
        scatop(i) = 0.
        OldOpacSave(i) = opac(i)
        opac(i) = 0.
      end do
*
      end
*****************************************
      real function opfun(x)
      implicit none
*helper routine used to get continuum pumping of lines
      real x
      real pmptau
      common/pmptau/ pmptau
*
*     local variables
      real v , vfun , sexp
*
      v = vfun(x)
      opfun = sexp( pmptau*v ) * v
*
      end
******************************************************************************
      subroutine opinb( ipOpac , low , ihi , a , b )
      implicit none
*add opacity of individual species, including stimulated emission
*     a is the density of the lower level (cm^-3)
*     b is its departure coefficient, can be zero
      integer ipOpac , low , ihi
      real a , b
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real opac
      common/opac/ opac(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real binv
      integer iup , i , k
*
*begin sanity check
      if( ipOpac.le.0 ) then
        write(qq,'('' bad pointer to OPINB'')')
        stop
      endif
*end sanity check
*
*     b is dep coef, lgFluor is turned off with 'no indcued' command
*     >> chng 97 sep 01, add k to save speed
      k = ipOpac-low
*     >>chng 97 sep 01, added check on lgHInducImmp
      if( b.gt.1e-35 .and. lgFluor .and. lgHInducImp ) then
        iup = min( ihi , nflux )
        iup = max( low , iup )
        binv = 1. / b
        do i=low,iup
*         >>chng 97 sep 01, changed b to binv=1/b
*         >>chng 97 sep 01, added check on lgHInducImmp
*         opac(i) = opac(i) + OpacStack(i-low+ipOpac)*a*
          opac(i) = opac(i) + OpacStack(i+k)*a*
     1    max(0.,1.-ContBoltz(i)*binv )
        end do
      else
*       B is the departure coef, which can go to zero, neglect stim emin
        iup = min( ihi , nflux )
        iup = max( low , iup )
        do i=low,iup
*         opac(i) = opac(i) + OpacStack(i-low+ipOpac) * a
*         >>chng 97 sep 01, added check on lgHInducImmp
          opac(i) = opac(i) + OpacStack(i+k) * a
        end do
      endif
*
      end
******************************************************************************
      subroutine optred( chCard )
      implicit none
*parse the optimize command line
      character*80  chCard
*
      integer limpar
      parameter (limpar=20)
      real rincrm
      common/rincrm/ rincrm(limpar)
      integer nvary , nparm
      common/nvary/ nvary , nparm
      logical lgOptLin , lgOptLum , lgOptCol
*flags set if we are to optimize lines, luminosity, or colums
      common/whtopm/ lgOptLin , lgOptLum , lgOptCol
      real varang
      common/varang/ varang(2,limpar)
      character*4 chOptRtn
*     this specifies the optimization routine
*     'amoe', 'powe', 'bubr'
      common/oprout/ chOptRtn
      integer iooptm
      common/iooptm/ iooptm
      integer itoptm
      common/itoptm/ itoptm
      real optint , optier
      common/intopn/ optint , optier
      real OptGlobalErr
*set with optimize tolerance command, used for global match to fit
* default set in scalar to 0.10
      common/vtoler/ OptGlobalErr
      logical lgTrOpt
*lgTrOpt flag set with optimization trace command
*nTrOpt is which call to cloudy to turn on trace
      integer nTrOpt
      common/tropt/ nTrOpt , lgTrOpt
      logical lgOptimFlow
      common/OptmFlow/ lgOptimFlow
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgMatch , lgEOL
      real deferr , fread
      integer i
      parameter (deferr=0.05)
*
*     free statement numbers all
*
      if( lgMatch('AMOE',chCard) ) THEN
*       use AMOEBA to optimize parameters
        chOptRtn = 'AMOE'
*
      else if( lgMatch('COLU',chCard) ) THEN
*       optimize column density
        lgOptCol = .true.
*       read lcolumn densities to match
        call colred( chCard )
*
      else if( lgMatch('INCR',chCard) ) then
*       scan off increments for the previously selected paramter
        if( nparm.gt.0 ) then
*         also called during optimization process, ignore then
          i = 5
          rincrm(nparm) = fread( chCard , i , 76 , lgEOL )
        endif
*
      else if( lgMatch('LUMI',chCard) .or. lgMatch('INTE',chCard) ) then
*       scan off intensity or luminosity of normalization line
        i = 5
        optint = fread( chCard , i , 76 , lgEOL )
        optier = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          optier = deferr
        endif
*       set flag to say that intentity or luminosity of line set
        lgOptLum = .true.
*
      else if( lgMatch('ITER',chCard) ) then
*       scan off number of iterations
        i = 5
        itoptm = fread( chCard , i , 76 , lgEOL )
*
      else if( lgMatch('LINE',chCard) ) then
*       read lines to match
        call obsred( chCard )
*       set flag saying that something has been set
        lgOptLin = .true.
*
      else if( lgMatch('POWE',chCard) ) then
*       use POWELL to optimize parameters
        chOptRtn = 'POWE'
*
      else if( lgMatch('PUNC',chCard) ) then
*       scan off fortran I/O unit number for final line images, default is 9
        i = 5
        iooptm = fread( chCard , i , 76 , lgEOL )
        if( iooptm.le.0 ) then
          write(qq,'('' This fortran unit number not allowed, sorry.''
     1    )')
          stop
        endif
*
      else if( lgMatch('RANG',chCard) ) then
*       scan off range for the previously selected variable
        if( nparm.gt.0 ) then
          i = 5
          varang(1,nparm) = fread( chCard , i , 76 , lgEOL )
          if(lgEOL) varang(1,nparm) = -1e38
          varang(2,nparm) = fread( chCard , i , 76 , lgEOL )
          if(lgEOL) varang(2,nparm) = 1e38
        endif
*
      else if( lgMatch('SUBP',chCard) ) then
*       use SUBPLEX to optimize parameters
        chOptRtn = 'SUBP'
*
      else if( lgMatch('TOLE',chCard) ) then
*       scan off tolerance of fit, sum of residuals must be smaller than this
*       default is 0.10
        i = 5
        OptGlobalErr = fread( chCard , i , 76 , lgEOL )
*
      else if( lgMatch('TRAC',chCard) ) then
        if( lgMatch('STAR' , chCard ) ) then
*         trace start iteration number
*         turn on trace printout starting on nth call to cloudy
          i = 5
          nTrOpt = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) then
            write(qq,'('' optimize trace start command:'')')
            write(qq,'('' The iteration number must appear.'')')
            stop
          endif
          lgTrOpt = .true.
        else if( lgMatch('FLOW' , chCard ) ) then
*         trace flow
*         follow logical flow within code
          lgOptimFlow = .true.
        else
          write(qq,'('' optimize trace flow command:'')')
          write(qq,'('' One of the sub keys START or FLOW must appear.''
     1    )')
          stop
        endif
*
      else
        write(qq,'('' Unrecognized keyword, consult HAZY.'')')
        stop
      endif
*
      end
******************************************************************************
      subroutine otsbg
      implicit none
*print ots arrays
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      integer i
*
      write(qq,'(4X,'' OTSCON array, ANU, OTSCON, OTS/INCID'')')
      do i=1,nupper
        if( otscon(i).gt.0. ) then
          write(qq,'(5x,i4,1p,1p,3e12.4)')
     1    i,anu(i),otscon(i),otscon(i)/max(1e-30,flux(i) )
        endif
      end do
*
      write(qq,'(4X,'' OTSLIN array, ANU, OTSLIN, OTS/INCID'')')
      do i=1,nupper
        if( otslin(i).gt.0. ) then
          write(qq,'(5X,I4,1P,1P,3E12.4)')
     1    i,anu(i),otslin(i),otslin(i)/max(1e-30,flux(i) )
        endif
      end do
*
      end
******************************************************************************
      subroutine outer(iz,in,imax,ig0,ig1)
      implicit none
*determine outer shell for some species
      integer iz,in,imax,ig0,ig1
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
******************************************************************************
*** Input parameters:  iz - atomic number from 1 to 30 (integer)
***                    in - number of electrons from 1 to iz (integer)
*** Output parameters: imax - number of the outer shell
***                    ig0  - statistical weight of (iz,in) ground state
***                    ig1  - statistical weight of (iz,in-1) ground state
******************************************************************************
      integer in1 , kg
      integer iss(30),igl(30),iga(12)
      data iss/1,1,2,2,3,3,3,3,3,3,4,4,5,5,5,5,5,5,
     &6,6,6,6,6,6,6,6,6,6,7,7/
      data igl/2,1,2,1,2,1,4,5,4,1,2,1,2,1,4,5,4,1,
     &4,5,4,1,6,9,10,9,6,1,2,1/
      data iga/2,1,4,5,4,7,6,9,10,9,2,1/
*
      if(iz.lt.1.or.iz.gt.30) then
        write(qq,'('' ***ERROR: wrong atomic number'')')
        return
      endif
      if(in.lt.1.or.in.gt.iz) then
        write(qq,'('' ***ERROR: wrong number of electrons'')')
        return
      endif
*** Number of the outer shell and statistical weight
      imax=iss(in)
      ig0=igl(in)
      in1=in-1
      if(in.eq.1) then
         ig1=1
      else
         ig1=igl(in1)
      endif
      if(in.gt.18.and.iz.eq.in) then
        imax=7
        kg=iz-18
        ig0=iga(kg)
        if(iz.eq.20) ig1=2
        if(iz.eq.21) ig1=3
        if(iz.eq.22) ig1=4
        if(iz.eq.25) ig1=7
        if(iz.eq.26) ig1=10
        if(iz.eq.30) ig1=2
      endif
      if(in.gt.18.and.(iz-in).eq.1) then
          if(iz.eq.20) then
             imax=7
             ig0=2
          endif
          if(iz.eq.21) then
             imax=7
             ig0=3
          endif
          if(iz.eq.22) then
             imax=7
             ig0=4
          endif
          if(iz.eq.25) then
             imax=7
             ig0=7
          endif
          if(iz.eq.26) then
             imax=7
             ig0=10
          endif
          if(iz.eq.30) then
             imax=7
             ig0=2
          endif
      endif
*
      end
******************************************************************************
      subroutine outsum( outtot, outin, outout )
      implicit none
*sum outward continuum beams
      real outtot , outin , outout
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*
*     local variables
      integer i
*
      outin = 0.
      outout = 0.
      do i=1,nflux
*       N.B. in following en1ryd prevents overflow
        outin = outin + anu(i) * (flux(i)*en1ryd)
        outout = outout + anu(i) * (outlin(i)+outcon(i))*en1ryd
      end do
      outtot = outin + outout
*
      end
******************************************************************************
      subroutine oxygen
      implicit none
*derive ionization balance for oxygen
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
      integer limelm
      parameter (limelm=30)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      integer iopo2d
      common/iopo/ iopo2d
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real AugerO3
*photoionization rate for OII, producing 1665
      common/augro3/ AugerO3
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      real p1909 , p2326 , p1895 , p1666 , p1401
      common/pmp2s/ p1909 , p2326 , p1895 , p1666 , p1401
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real s3727 , s7325
      common/s3727/ s3727 , s7325
      integer i2d , i2p
*pointers for photoionization into excited state of oii
      common/i3727/ i2d , i2p
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
*     include "decoff.com"
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real hi , hii
      common/h/ hi , hii
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real catmic , oatmic
      common/coatom/ catmic , oatmic
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real HCharExcIon(limelm,limelm) , HCharExcRec(limelm,limelm)
*     ion, nelem
*     these arrays save the charge transfer ionization and recom
*     rates for the heavy elements onto hydrogen.  ionization is
*     of the heavy element, and so is a recom for hydrogen
      common/CharExc/ HCharExcIon , HCharExcRec
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real aeff,popexc,gamfun
      integer i,iup
      integer ndim , nelem
      parameter (ndim=9)
      parameter (nelem=8)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2), save,
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     oxygen nelem=8
*
*     real CollidRate(nelem,2)
*
*     DATA yYIELD/6*0./
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.09E-10,3.96E-11,1.67E-11,7.60E-12,3.33E-12,1.15E-12,
     1 7.90E-14,2.89E-14/
      data (cion(i,2),i=1,ndim-1)
     1 / 1.58E5,4.07E5,6.37E5,8.98E5,1.32E6,1.60E6,8.57E6,1.01E7/
*     DATA GRDEFF/ 0.10,0.10,0.10,0.10,0.03,0.042,0.11,0.30/
*
*     highest three from Arnaud et al '85
      data rec,pl
     1/1.60E-10 , 7.67E-10 , 2.35E-09 , 4.59E-09 , 1.73E-08 , 3.04E-8
     1, 1.56E-7 ,
     2  -0.678  , -0.646   , -0.666   , -0.670   , -0.759   , -0.774 ,
     3 -0.834 /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/2*0./
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.11e-3, 5.07e-3, 1.48e-2, 1.84e-2, 4.13e-3, 1.06e-1,
     2 6.23e-2, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.0925, .181, .305, .1, .162, .34, .304, 0./
      data (dite(i,1),i=1,ndim-1)
     3/1.75e5  , 1.98e5  , 2.41e5  , 2.12e5  , 1.25e5  , 6.25e6  ,
     4 7.01E6  , 0.  /
      data (dite(i,2),i=1,ndim-1)
     1 /1.45e5, 3.35e5, 2.83e5, 2.83e5, 2.27e5, 1.12e6, 1.47e6, 0./
      data ditcrt
     5/2.7E4  , 2.2E4  , 2.4E4  , 2.5E4  , 1.6E4  , 1.0E6  ,
     6 1.5E6  , 1E20  /
*
      data aa/0.,-0.0036,0.,0.0061,-2.8425,0.,0.,0./
     1 ,   bb/0.0238,0.7519,21.8790,0.2269,0.2283,0.,0.,0./
     2 ,   cc/0.0659,1.5252,16.2730,32.1419,40.4072,0.,0.,0./
     3 ,   dd/0.0349,-0.0838,-0.7020,1.9939,-3.4956,0.,0.,0./
     4 ,   ff/0.5334,0.2769,1.1899,-0.0646,1.7558,0.,0.,0./
*
*     oxygen, atomic number 8
      if( .not.lgElmtOn(8) ) then
        poiii2Max = 0.
        poiii3Max = 0.
        r4363Max = 0.
        r5007Max = 0.
        poiii2 = 0.
        p1666 = 0.
        oatmic = 0.
        AugerO3 = 0.
        p1401 = 0.
        s3727 = 0.
        s7325 = 0.
        heating(8,10) = 0.
        poimax = 0.
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     O-H charge exchange
*     if( loxy.eq.1 ) then
*       rate is Field and Steigman, scaled down by 25% to acknowledge
*       new O+ rate from Chambaud et al J Phys B 13, 4205
*       fit is from Arnaud+Rothenflug 1985 AA(SUP) 60, 425
*       c1 = 0.91e-9 * exp(-227.6/te) * (1. - 0.93*sexp(1e-3*te) )
*       CTHeavy(1,1) = CTHeavy(1,1) + HII * C1
*       >>chng 96 Oct 1, all H ct moved to bidiag
*       CTHeavy(1,1) = CTHeavy(1,1) + HII * HCharExcIon(1,8)
*       c2 = 1.0e-9 * (1. - 0.66*sexp(9.8e-4*te) )
*       CTHeavy(1,2) = CTHeavy(1,2) + hi * c2
*       CTHeavy(1,2) = CTHeavy(1,2) + hi * HCharExcRec(1,8)
*       c1 is ionization of oxygen, rec of hydrogen
*       write(71,'(1p,i4,13e10.3)') nzone,c1,c2,c1/c2,
*    1  HCharExcIon(1,8),HCharExcRec(1,8)
*     endif
*
*     O+2 => O+ Butler Heil and Dalgarno 1980
*     CTHeavy(2,2) = CTHeavy(2,2) + 2.8E-11*TE10*TE10*TE10*TE03*TE03*HI
*     T = MIN( SQRTE,200. ) * HI
*     O+3 => O+2 Bulter Heil and Dalgarno 1980
*     CTHeavy(3,2) = CTHeavy(3,2) + 8.6E-11 * T + HEI*1E-9
      CTHeavy(3,2) = CTHeavy(3,2) + hei*1E-9
*     write(6,*) 'o3', 8.6e-11*t ,HCharExcRec(3,8)*hi
*     O+4 => O+3 Butler and Dalgarno 1980B
*     CTHeavy(4,2) = CTHeavy(4,2) + 2.6E-12 * t + HEI*6E-10
      CTHeavy(4,2) = CTHeavy(4,2) + hei*6E-10
*
*     photoexcitation of O III 1666 and O IV 1401
* 666 error! this will be zero in current form of phfit
*     set 2s**2 rate to rate for O V
      p1666 = PhotoRate(8,4,2,1)
*
      p1401 = PhotoRate(8,3,2,1)
*
*     photoionization from O++ 1D
*
*     estimate gamma function by assuming no frequency dependence
*     betwen 1D and O++3P edge
      if( lgDoPhoto ) then
        d5007r = gamfun( ipo3exc(1),ipo3exc(2) , ipo3exc(3) )
        d4363 = gamfun( ipo3exc3(1),ipo3exc3(2) , ipo3exc3(3) )
        d6300 = gamfun( ipo1exc(1),ipo1exc(2) , ipo1exc(3) )
*       A21 = 0.0263
        aeff = 0.0263 + d5007r
*       1. as last arg makes this the relative population
        poiii2 = popexc(2.5,9.,5.,aeff,2.88e4,1.)/aeff
*       photoionization from excited states
        if( nzone.gt.0 ) then
          PhotoRate(8,1,3,1) = PhotoRate(8,1,3,1)*(1.-poiexc) +
     1    d6300*poiexc
          PhotoRate(8,3,3,1) = PhotoRate(8,3,3,1)*(1.-poiii2-poiii3) +
     1    d5007r*poiii2 + d4363*poiii3
          if( PhotoRate(8,3,3,1).gt.1e-30 .and. IonLow(nelem).le.3) then
            if((d5007r*poiii2+d4363*poiii3)/PhotoRate(8,3,3,1).gt.
     1        (r4363Max+r5007Max)) then
              poiii2Max = d5007r*poiii2/PhotoRate(8,3,3,1)
              poiii3Max = d4363*poiii3/PhotoRate(8,3,3,1)
            endif
            r4363Max = max( r4363Max , d4363 )
            r5007Max = max( r5007Max , d5007r )
          endif
          if( IonLow(nelem).le.1 .and.
     1      (PhotoRate(8,1,3,1)+HCharExcIon(1,8)*hii).gt.1e-30 ) then
            poimax = max( poimax , d6300*poiexc/(PhotoRate(8,1,3,1) +
     1      HCharExcIon(1,8)*hii ) )
          endif
        else
          poiii2Max = 0.
          poiii3Max = 0.
          r4363Max = 0.
          r5007Max = 0.
          poimax = 0.
        endif
      endif
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     save photodistruction rate for 3727 creation
      if( IonLow(nelem).eq.1 .and. i2d.lt.nflux ) then
        s3727 = gamfun( i2d , i2p , iopo2d )
        iup = min( nhe2(1) , nflux )
        s7325 = gamfun( i2d , iup , iopo2d )
        s7325 = s7325 - s3727
        s3727 = (s3727 + s7325)
*       ratio of cross sections
        s7325 = s7325 * 0.66
      else
        s3727 = 0.
        s7325 = 0.
      endif
*
      AugerO3 = PhotoRate(8,1,1,1)
*
      oatmic = xIonFracs(8,0) * max(1e-7,(1.-co/xIonFracs(8,0)))
      save = xIonFracs(8,0)
      xIonFracs(8,0) = oatmic
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
      xIonFracs(8,0) = save
*
*     charge exchange onto hydrogen
      CTHionAgnt(3) = xIonFracs(8,2) * HCharExcRec(1,8)
*     write(72,'(i4,1p,10e10.2)')nzone,xIonFracs(8,2),HCharExcRec(1,8),
*    1 CTHionAgnt(3), xIonFracs(8,1) , HCharExcIon(1,8) ,
*    1  xIonFracs(8,1) * HCharExcIon(1,8)
      CTHion(1) = CTHion(1) + CTHionAgnt(3)
      CTHrec(1) = CTHrec(1) + xIonFracs(8,1) * HCharExcIon(1,8)
      chrener = chrener - (hi*xIonFracs(8,2)*HCharExcRec(1,8) -
     1 hii*xIonFracs(8,1)*HCharExcIon(1,8))*230./te1ryd
*
*     1666 ratio corrected for phot crs at 50ev
      p1666 = p1666 * xIonFracs(8,2) * 0.3
      p1401 = p1401 * xIonFracs(8,3) * 0.43
      s3727 = s3727 * xIonFracs(8,1)
      s7325 = s7325 * xIonFracs(8,1)
      AugerO3 = AugerO3 * xIonFracs(8,1)
*
      if( lgTrace ) then
        write(qq,'(5X,''OXYGEN returns; frac='',1P,9E10.3)')
     1  (xIonFracs(8,i)/xIonFracs(8,0),i=1,9)
      endif
*
      end
******************************************************************************
      subroutine p8446( coloi )
      implicit none
*drive the solution of OI level populations, Ly-beta pumping
      real coloi
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real hesc , esesc
      common/hesc/ hesc(lmhlvl,lmhlvl) , esesc(lmhlvl,lmhlvl)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      real hi , hii
      common/h/ hi , hii
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real pmph31, pmpo51, pmpo15 , esch31
      common/bowoi/ pmph31, pmpo51, pmpo15 , esch31
      logical lgTr8446
*flag set with trace beta command
      common/tr8446/ lgTr8446
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      real t1656(nta),t9830(nta),t8727(nta),t610(nta),t370(nta),
     1t2326(nta),t1335(nta),t157(nta),t1909(nta),t977(nta),t386(nta),
     1t310(nta),t291(nta),t280(nta),t274(nta),t270(nta),c31175(nta),
     1t1550(nta),t1548(nta),t312(nta),t1200(nta),t2140(nta),t1085(nta),
     1t671(nta),t122(nta),t205(nta),t1750(nta),t990(nta),t374g(nta),
     1t374x(nta),t315(nta),t324(nta),t333(nta),t57(nta),t1486(nta),
     1t765(nta),t1243(nta),t1239(nta),t209(nta),t6300(nta),t6363(nta),
     1t5577(nta),tO1025(nta),t1039(nta),t1304(nta),t4368(nta),
     1t8446(nta),tOI11(nta),tOI13(nta),tOI29(nta),tOI46(nta),t146(nta),
     1t63(nta),t834(nta),t1661(nta),t1666(nta),t835(nta),t304(nta),
     1tO88(nta),t52(nta),t1402(nta),t789(nta),t26(nta),t630(nta),
     1t1214(nta),t1032(nta),t1037(nta),t150(nta),F0229(nta),F0267(nta),
     1F444(nta),F425(nta),tNe13(nta),tNe36(nta),tNe16(nta),tNe14(nta),
     1tNe24(nta),xNe0676(nta),t895(nta),t770(nta),t780(nta),t88(nta),
     1t5895(nta),fsNa373(nta),fsNa490(nta),fsNa421(nta),xNa6143(nta),
     1xNa6862(nta),xNa0746(nta),t4561(nta),MgI2853(nta),MgI2026(nta),
     1t2796(nta),t2804(nta),tMg4(nta),tMg14(nta),tMg6(nta),
     1xMg51325(nta),xMg52417(nta),xMg52855(nta),fsMg755(nta),
     1fsMg790(nta),xMg71190(nta),xMg72261(nta),xMg72569(nta),
     1xMg08303(nta),t705(nta),tMg610(nta),tMg625(nta),t58(nta),
     1AlI3957(nta),AlI3090(nta),t2670(nta),t1855(nta),t1863(nta),
     1Al529(nta),Al6366(nta),Al6912(nta),Al8575(nta),Al8370(nta),
     1Al09204(nta),t639(nta),tAl550(nta),tAl568(nta),tAl48(nta),
     1Sii2518(nta),Sii2215(nta),t2335(nta),t1808(nta),t1527(nta),
     1t1305(nta),t1260(nta),tSi35(nta),t1207(nta),t1895(nta),
     1t1394(nta),t1403(nta),Si619(nta),tSi25(nta),tSi65(nta),tSi3(nta),
     1tSi4(nta),Si10143(nta),tSi499(nta),tSi521(nta),tSi41(nta),
     1P0233(nta),P0260(nta),P0318(nta),P713(nta),P848(nta),P817(nta),
     1P1027(nta),P1018(nta),t1256(nta),t1194(nta),tS19(nta),tS34(nta),
     1tS1720(nta),t1406(nta),tS11(nta),t1198(nta),t786(nta),t933(nta),
     1t944(nta),fsS810(nta),fsS912(nta),fsS938(nta),fsS1119(nta),
     1fsS1114(nta),fsS1207(nta),tSu418(nta),tSu446(nta),tSu30(nta),
     1fsCl214(nta),fsCl233(nta),Cl04203(nta),Cl04117(nta),Cl973(nta),
     1Cl1030(nta),Cl1092(nta),tAr7(nta),tAr9(nta),tAr22(nta),
     1tAr13(nta),tAr8(nta),Ar06453(nta),Ar1055(nta),Ar1126(nta),
     1Ar1178(nta),t354(nta),t389(nta),t25(nta),KI7745(nta),
     1xK03462(nta),xK04598(nta),xK04154(nta),xK06882(nta),xK06557(nta),
     1xK07319(nta),xK11425(nta),CaI4228(nta),t3934(nta),t3969(nta),
     1t8498(nta),t8542(nta),t8662(nta),t7291(nta),t7324(nta),tCa3(nta),
     1tCa12(nta),tCa4(nta),Ca0741(nta),Ca0761(nta),Ca08232(nta),
     1Ca12333(nta),tCa302(nta),tCa345(nta),tCa19(nta),Sc05231(nta),
     1Sc13264(nta),Ti06172(nta),Ti14212(nta),Va07130(nta),Va15172(nta),
     1Cr08101(nta),Cr16141(nta),xMn0979(nta),xMn1712(nta),FeI3884(nta),
     1FeI3729(nta),FeI3457(nta),FeI3021(nta),FeI2966(nta),tuv3(nta),
     1tr48(nta),tFe16(nta),tFe26(nta),tFe34(nta),tFe35(nta),tFe46(nta),
     1tFe56(nta),t191(nta),t1122(nta),Fe0795(nta),Fe0778(nta),
     1t245(nta),t352(nta),Fe106375(nta),tFe07(nta),tFe61(nta),
     1t353(nta),Fe1310(nta),Fe1311(nta),t347(nta),Fe18975(nta),
     1tFe23(nta),tFe13(nta),t192(nta),t255(nta),t11(nta),Co11527(nta),
     1xNi1242(nta)
      common/TauLines/t1656,t9830,t8727,t610,t370,t2326,t1335,t157,
     1t1909,t977,t386,t310,t291,t280,t274,t270,c31175,t1550,t1548,t312,
     1t1200,t2140,t1085,t671,t122,t205,t1750,t990,t374g,t374x,t315,t324,
     1t333,t57,t1486,t765,t1243,t1239,t209,t6300,t6363,t5577,tO1025,
     1t1039,t1304,t4368,t8446,tOI11,tOI13,tOI29,tOI46,t146,t63,t834,
     1t1661,t1666,t835,t304,tO88,t52,t1402,t789,t26,t630,t1214,t1032,
     1t1037,t150,F0229,F0267,F444,F425,tNe13,tNe36,tNe16,tNe14,tNe24,
     1xNe0676,t895,t770,t780,t88,t5895,fsNa373,fsNa490,fsNa421,xNa6143,
     1xNa6862,xNa0746,t4561,MgI2853,MgI2026,t2796,t2804,tMg4,tMg14,tMg6,
     1xMg51325,xMg52417,xMg52855,fsMg755,fsMg790,xMg71190,xMg72261,
     1xMg72569,xMg08303,t705,tMg610,tMg625,t58,AlI3957,AlI3090,t2670,
     1t1855,t1863,Al529,Al6366,Al6912,Al8575,Al8370,Al09204,t639,tAl550,
     1tAl568,tAl48,Sii2518,Sii2215,t2335,t1808,t1527,t1305,t1260,tSi35,
     1t1207,t1895,t1394,t1403,Si619,tSi25,tSi65,tSi3,tSi4,Si10143,
     1tSi499,tSi521,tSi41,P0233,P0260,P0318,P713,P848,P817,P1027,P1018,
     1t1256,t1194,tS19,tS34,tS1720,t1406,tS11,t1198,t786,t933,t944,
     1fsS810,fsS912,fsS938,fsS1119,fsS1114,fsS1207,tSu418,tSu446,tSu30,
     1fsCl214,fsCl233,Cl04203,Cl04117,Cl973,Cl1030,Cl1092,tAr7,tAr9,
     1tAr22,tAr13,tAr8,Ar06453,Ar1055,Ar1126,Ar1178,t354,t389,t25,
     1KI7745,xK03462,xK04598,xK04154,xK06882,xK06557,xK07319,xK11425,
     1CaI4228,t3934,t3969,t8498,t8542,t8662,t7291,t7324,tCa3,tCa12,tCa4,
     1Ca0741,Ca0761,Ca08232,Ca12333,tCa302,tCa345,tCa19,Sc05231,Sc13264,
     1Ti06172,Ti14212,Va07130,Va15172,Cr08101,Cr16141,xMn0979,xMn1712,
     1FeI3884,FeI3729,FeI3457,FeI3021,FeI2966,tuv3,tr48,tFe16,tFe26,
     1tFe34,tFe35,tFe46,tFe56,t191,t1122,Fe0795,Fe0778,t245,t352,
     1Fe106375,tFe07,tFe61,t353,Fe1310,Fe1311,t347,Fe18975,tFe23,tFe13,
     1t192,t255,t11,Co11527,xNi1242
      real popoi
      common/popoi/ popoi(6)
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real aoi,alb,tin,tout,esin,esccom,esab,esoi,
     1 eslb,opacoi,opaclb,foi,flb,xlb,xoi,pmph13
      save esab
*
*     free statement labels >=2
*
*     A's from Pradhan; OI pump line; Ly beta, 8446
      data aoi/7.24e7/ , alb/5.575e7/
*
*     Notation;
*     PMPH31 net rate hydrogen level 3 depopulated to 1
*     PMPO15 and PMPO51 are similar, but for oxygen
*     ESCH31 is emission in 1025 transition
*
*     called by LINES before calc really start, protect here
*     also used for cases where OI not present
      if( xIonFracs(8,1).le.0.) then
        do i=1,6
          popoi(i) = 0.
        end do
        coloi = 0.
        pmpo15 = 0.
        pmpo51 = 0.
*       3,1 is escape prob, 1,3 is product with a
        pmph31 = hesc(1,3)
        esch31 = hesc(1,3)
        if( lgTr8446.and.lgTrace ) then
          write(qq,'(7X,''P8446 called for first ''
     1    ,''time, finds 3-1 escape prob='',1P,E10.2)') hesc(1,3)
        end if
        return
      endif
*
      if( lgTauOutOn ) then
*       two sided escape prob
        tin = htnext(3,1)+tO1025(ipLnTauIn)
        esin = esccom( tin ,1e-4 )
        tout = (htlim(3,1)+tO1025(ipLnTauTot))*0.9 -
     1  htnext(3,1)-tO1025(ipLnTauIn)
        if( tout.gt.0. ) then
          tout = htlim(3,1)+tO1025(2)-htnext(3,1)-tO1025(1)
*         do not update esab if we overran optical depth scale
          esab = 0.5 * ( esin + esccom( tout ,1e-4 ) )
        endif
      else
*       one-sided escape probability
        esab = esccom( htnext(3,1)+tO1025(1) ,1e-4 )
      endif
*
      esoi = tO1025(ipLnEscP)
      eslb = hesc(3,1)
*
      if( lgTr8446.and.lgTrace ) then
        write(qq,'(7X,''P8446 finds Lbeta, OI '',
     1  ''widths='',1P,2E10.2,'' and esc prob='',2E10.2,'' esAB='',
     2  e10.2)') doppler(1), doppler(8), eslb, esoi, esab
      endif
*
*     find relative opacities for two lines
      opacoi = 2.92e-9 * xIonFracs(8,1) * 0.5556 / doppler(8)
      opaclb = 1.22e-8 * hii*hn(1) / doppler(1)
*     these are x sub a (OI) and x sub b (ly beta) defined in Elitz+Netz
      xoi = opacoi / ( opacoi + opaclb )
      xlb = opaclb / ( opacoi + opaclb )
*
*     find relative line-widths, assume same rest freq
      foi = min( doppler(1) , doppler(8) ) / doppler(8)
      flb = min( doppler(1) , doppler(8) ) / doppler(1) *
     1  (1. - tO1025(ipLnEscP) )
      if( lgTr8446.and.lgTrace ) write(qq,'(7X,''P8446 opac Lb, OI='',
     1 1P,2E10.2,'' X Lb, OI='',2E10.2,'' FLb, OI='',2E10.2)')
     2 opaclb,opacoi, xlb,xoi, flb, foi
*
*     pumping of OI by L-beta - this goes into OI matrix as 1-5 rate
*     lgFluor set false with no induced command, usually true
      if( lgFluor ) then
        pmpo15 = flb * alb * (hn(3)*hii) * xoi * (1. - esab )/
     1  xIonFracs(8,1)
*       net decay rate from upper level
        pmpo51 = aoi * ( 1.-(1.-foi)*(1.-esoi) - xoi*(1.-esab)*foi )
      else
        pmpo15 = 0.
        pmpo51 = 0.
      endif
*
*     find level populations for OI
      call oilevl( xIonFracs(8,1) , coloi )
*
*     escape term from n=3 of H; followed by pump term to n=3
      pmph31 = alb * ( 1.-(1.-flb)*(1.-eslb) - xlb*(1.-esab)*flb )
      pmph13 = xlb * (1.-esab ) * foi * aoi * popoi(5)
      pmph31 = hesc(1,3)
*
*     following is actual emission rate, used to predict Ly-beta in lines.for
      esch31 = alb * ( eslb * (1.-flb) + esab*flb )
      if( lgTr8446.and.lgTrace ) write(qq,'(7X,''P8446 PMPH31='',1P,
     1E10.2,'' EscP3-1'',E10.2,'' ESCH31='',E10.2)')
     2 pmph31,pmph31/alb,esch31/alb
*
*     continuum pumping due to J=1, 0 sub states.
*     neglect J=2 since L-Beta very optically thick
*
*     lower level populations
      t1304(ipLnPopl) = popoi(1)
      tO1025(ipLnPopl) = popoi(1)
      t1039(ipLnPopl) = popoi(1)
      t8446(ipLnPopl) = popoi(2)
      t4368(ipLnPopl) = popoi(2)
      tOI13(ipLnPopl) = popoi(3)
      tOI11(ipLnPopl) = popoi(3)
      tOI29(ipLnPopl) = popoi(4)
      tOI46(ipLnPopl) = popoi(5)
*
*     upper level populations
      t1304(ipLnPopu) = popoi(2)
      tO1025(ipLnPopu) = popoi(5)
      t1039(ipLnPopu) = popoi(4)
      t8446(ipLnPopu) = popoi(3)
      t4368(ipLnPopu) = popoi(6)
      tOI13(ipLnPopu) = popoi(4)
      tOI11(ipLnPopu) = popoi(5)
      tOI29(ipLnPopu) = popoi(6)
      tOI46(ipLnPopu) = popoi(6)
*
*     opacity factor
*     t1304(ipLnPopOpc) = (popoi(1)-popoi(2)*3.0)
* 666 error! following needed to get badbugs/bug8.in to work
      t1304(ipLnPopOpc) = popoi(1)
      tO1025(ipLnPopOpc) = (popoi(1)-popoi(5)*0.6)
      t1039(ipLnPopOpc) = (popoi(1)-popoi(4)*3.0)
*     t8446(ipLnPopOpc) = (popoi(2)-popoi(3)*.33)
* 666 error! following needed to get badbugs/bug5.in to work
      t8446(ipLnPopOpc) = max(0., popoi(2)-popoi(3)*.33)
      t4368(ipLnPopOpc) = (popoi(2)-popoi(6)*.33)
      tOI13(ipLnPopOpc) = (popoi(3)-popoi(4)*3.0)
      tOI11(ipLnPopOpc) = (popoi(3)-popoi(5)*0.6)
      tOI29(ipLnPopOpc) = (popoi(4)-popoi(6)*.33)
      tOI46(ipLnPopOpc) = (popoi(5)-popoi(6)*1.67)
*
      call AddOTSLin( popoi(2)*t1304(ipLnDesP)*t1304(ipLnAul),
     1 int(t1304(ipLnIpCont)) ,0.1)
*     call AddOTSLin( popoi(4)*t1039(ipLnDesP)*t1039(ipLnAul),
*    1 int(t1039(ipLnIpCont)) ,0.5)
      call AddOTSLin( popoi(3)*t8446(ipLnDesP)*t8446(ipLnAul),
     1 int(t8446(ipLnIpCont)) ,0.5)
      call AddOTSLin( popoi(6)*t4368(ipLnDesP)*t4368(ipLnAul),
     1 int(t4368(ipLnIpCont)) ,0.5)
      call AddOTSLin( popoi(4)*tOI13(ipLnDesP)*tOI13(ipLnAul),
     1 int(tOI13(ipLnIpCont)) ,0.5)
      call AddOTSLin( popoi(5)*tOI11(ipLnDesP)*tOI11(ipLnAul),
     1 int(tOI11(ipLnIpCont)) ,0.5)
      call AddOTSLin( popoi(6)*tOI29(ipLnDesP)*tOI29(ipLnAul),
     1 int(tOI29(ipLnIpCont)) ,0.5)
      call AddOTSLin( popoi(6)*tOI46(ipLnDesP)*tOI46(ipLnAul),
     1 int(tOI46(ipLnIpCont)) ,0.5)
*
      end
******************************************************************************
      subroutine pcnrng( chCard )
      implicit none
*set range for map to parse range option on map command
      character chCard*80
      integer ndplot
      parameter (ndplot=10)
      real emm , egamry
      common/bounds/ emm , egamry
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      logical lgLogOn , lgMatch , lgEOL
      real fread , a
      integer i
*
      i = 4
      pltxmn(nplot) = fread( chCard , i , 76 , lgEOL )
*
      if(.not.lgMatch( 'RANG' , chCard ) ) then
*        no numbers on line, just set default limits to energy array
         pltxmn(nplot) = log10( emm )
         pltxmx(nplot) = log10( egamry )
         lgLogOn = .true.
      else if( lgEOL ) then
*        no numbers on line, just set default limits to energy array
         pltxmn(nplot) = log10( emm )
         pltxmx(nplot) = log10( egamry )
         lgLogOn = .true.
      else
*        lower limit entered, now interprete it
         if( pltxmn(nplot).lt.0. ) then
            lgLogOn = .true.
         else if( pltxmn(nplot).eq.0.0 ) then
*           option for first number to be zero, lower edge of array
            lgLogOn = .false.
            pltxmn(nplot) = emm
         else
*           a positive number was entered
            lgLogOn = .false.
         endif
*
*        now look at upper limit
         pltxmx(nplot) = fread( chCard , i , 76 , lgEOL )
         if( lgEOL.or. pltxmx(nplot).eq.0.0 ) then
*           option for second number to be omitted or zero
            if( lgLogOn ) then
               pltxmx(nplot) = log10( egamry )
            else
               pltxmx(nplot) = egamry
            endif
         endif
      endif
*
*     now force to be log
      if( .not.lgLogOn ) then
         pltxmx(nplot) = log10( pltxmx(nplot) )
         pltxmn(nplot) = log10( pltxmn(nplot) )
      endif
*
*     check that min is less than max
      if( pltxmn(nplot).eq.pltxmx(nplot) ) then
         write(qq,'('' Upper and lower plot boundaries are equal.'')')
         stop
      else if( pltxmn(nplot).gt.pltxmx(nplot) ) then
         a = pltxmx(nplot)
         pltxmx(nplot) = pltxmn(nplot)
         pltxmn(nplot) = a
      endif
*
      end
******************************************************************************
      subroutine pcontn
      implicit none
*print information about continuum if requested with PRINT CONTINUUM command
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real r1r0sq
      common/r1r0sq/ r1r0sq
      integer nxray
      common/nxray/ nxray
      logical lgPrtCont
*flag set with print continuum command
      common/pconon/ lgPrtCont
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real FluxSave
*save incident continuum for later iterations
      common/flxsav/ FluxSave(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      integer i ,  j , ninc , nxbd,i1,nline,nfluxsv
      parameter (nfluxsv=360)
      real fluxsv(nfluxsv)
*     this is number of ranges for adding x-ray bands
      parameter (nxbd=9)
*
      real xraybd(nxbd+1) , xbdsav(nxbd)
      data xraybd/ 7.3498, 36.8 , 73.5 , 110.3 , 147.1 , 183.8,
     1  220.6 ,  367.6 ,   551.5 ,735.3 /
*
*     following was always printed before version 84, now an option
*     to turn on information with PRINT CONTINUUM command
*
      if( .not.lgPrtCont ) return
*
*     derive x-ray fluxes in various bands for later printout
*
*     >>chng 97 june 8, get rid of statement labels
      if( xraybd(1) .lt. anu(nflux) ) then
        i1 = nxray - 10
*       get out to lower bound of first range
        do while( anu(i1).lt.xraybd(1) .and. i1.lt.nflux )
          i1 = i1 + 1
        end do
*       now add up over that range
        do i=1,nxbd
          xbdsav(i) = 0.
          do while( anu(i1).lt.xraybd(i+1) .and. i1.lt.nflux )
            xbdsav(i) = xbdsav(i) +
     1      flux(i1) + ContDiff(i1) + outlin(i1) + outcon(i1)
            i1 = i1 + 1
          end do
          xbdsav(i) = xbdsav(i) * r1r0sq
        end do
      else
*       continuum not defined at x-ray energies, but zero it for safety
        do i=1,nxbd
          xbdsav(i) = 0.
        end do
      endif
*
*     now print x-ray flux (photons s^-1, flux or lum) in various bands
      if( xbdsav(1).gt.0 ) write(qq,'(/,'' 0.1-0.5kev:'',1p,e8.2,
     1 '' 0.5-1.0kev:'',e8.2,'' 1.0-1.5:'',
     1e8.2,'' 1.5-2.0:'',e8.2,'' 2.0-2.5:'',e8.2,'' 2.5-3:'',e8.2,
     2'' 3-5:'',e8.2/''      5-7.5:'',e8.2,''     7.5-10:'',e8.2)')
     3 xbdsav
*
*     renorm fLUX array before printing it
      if( ipHn(1)-ipHn(2)+1.gt.nfluxsv ) then
        write(qq,'('' PCONTN: not enough cells in FluxSave, need'',i4)')
     1  ipHn(1)-ipHn(2)+1
        stop
      endif
      do i=ipHn(2),ipHn(1)
        if( FluxSave(i).gt.0. ) then
          fluxsv(i-ipHn(2)+1) = (flux(i)+outlin(i)+outcon(i)+
     1    ContDiff(i)) * r1r0sq/ FluxSave(i)
        else
          fluxsv(i-ipHn(2)+1) = 0.
        endif
      end do
*     renormalize whole continuum
      do i=1,nflux
        flux(i) = ((flux(i)+ContDiff(i)+outcon(i))/widflx(i)+
     1  outlin(i)) * r1r0sq
      end do
      write(qq,'(//56X,''Normalised continuum'')')
      write(qq,'(10(F7.3,F6.3))') (anu(i),fluxsv(i-ipHn(2)+1),
     1i=ipHn(2),ipHn(1),3)
*
      write(qq,'(/,50X,''Emergent continuum - phot/ryd/cm2 (r in)''
     1)')
*
      nline = ( ( nflux-ipHn(2) -1 ) /4 + 7 ) / 7
      ninc = nline * 4
      do j=1,nline
        i1 = (j-1) * 4 + 1 + ipHn(2)
        write(qq,'(1X,3(0P,F6.3,1P,E9.2),2(2X,0P,F6.1,1P,E9.2),
     1  2(3x,1p,e9.2,1p,e9.2))')
     1  (anu(i),(flux(i)+outlin(i)+outcon(i)+ContDiff(i)),i=i1,nflux,
     1  ninc)
      end do
*
      end
******************************************************************************
      subroutine addln1
      implicit none
*add lines to truncated list, using known line ratios, by Peter Martin
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer isave , i , inew , nline , j1 , j
      real sumnr , amatch
*
      isave=npxdd
*     H lines Case B Osterbrock tab 4.4 t=10**4 hden=10**6
*     line strength for normalizing line
      sumnr = amatch('TOTL',4861)
      if(sumnr.ne.0.) then
         call addln2('Halb',6563,sumnr*2.81)
         call addln2('Hgab',4340,sumnr*0.471)
         call addln2('Hdeb',4101,sumnr*0.262)
         call addln2('Hepb',3970,sumnr*0.163)
         call addln2('H08b',3889,sumnr*0.110)
         call addln2('H09b',3835,sumnr*0.0783)
         call addln2('H10b',3798,sumnr*0.0588)
         call addln2('H11b',3770,sumnr*0.0457)
         call addln2('H12b',3750,sumnr*0.0367)
         call addln2('H13b',3734,sumnr*0.0301)
         call addln2('H14b',3721,sumnr*0.0252)
         call addln2('H15b',3712,sumnr*0.0213)
         call addln2('H20b',3683,sumnr*0.0104)
      endif
*
* HeI lines case B Osterbrock tab 4.6 t=10**4, hden = 10**6
* lines with lambda gt 3550a and relative strength gt 0.02 of 4471
      sumnr=amatch('HE I',4471)
      if(sumnr.ne.0.) then
*        triplets 2 3p - n 3d
         call addln2('He1b',5876,sumnr*2.73)
         call addln2('He1b',4471,sumnr*1.)
         call addln2('He1b',4026,sumnr*0.476)
         call addln2('He1b',3820,sumnr*0.265)
         call addln2('He1b',3705,sumnr*0.163)
         call addln2('He1b',3634,sumnr*0.108)
         call addln2('He1b',3587,sumnr*0.076)
*        wavelength to short
*        triplets 2 3p - n 3s
         call addln2('He1b',7065,sumnr*0.325)
         call addln2('He1b',4713,sumnr*0.090)
         call addln2('He1b',4121,sumnr*0.037)
         call addln2('He1b',3867,sumnr*0.019)
*        too weak
*        triplets 2 3s - n 3p
         call addln2('He1b',10830,sumnr*4.41)
         call addln2('He1b',3889,sumnr*2.27)
         call addln2('He1b',3187,sumnr*0.920)
*        wavelength too short
*        singlets 2 1p - n 1d
         call addln2('He1b',6678,sumnr*0.780)
         call addln2('He1b',4922,sumnr*0.274)
         call addln2('He1b',4388,sumnr*0.129)
         call addln2('He1b',4144,sumnr*0.071)
         call addln2('He1b',4009,sumnr*0.044)
         call addln2('He1b',3927,sumnr*0.029)
         call addln2('He1b',3872,sumnr*0.020)
*        too weak
*        singlets 2 1s - n 1p
         call addln2('He1b',5016,sumnr*0.590)
         call addln2('He1b',3965,sumnr*0.235)
         call addln2('He1b',3614,sumnr*0.115)
*        wavelength too short
*        singlets 2 1p - n 1s
         call addln2('He1b',7281,sumnr*0.138)
         call addln2('He1b',5047,sumnr*0.039)
         call addln2('He1b',4437,sumnr*0.017)
      endif
*
* He2 case B Osterbrock tab 4.5 t=10**4, hden=10**6
* Pickering lines with relative strength gt 0.013 of 4686
      sumnr=amatch('HeII',4686)
      if(sumnr.ne.0.) then
         call addln2('He2b',10124, sumnr* 0.271 )
         call addln2('He2b', 6560, sumnr* 0.136 )
         call addln2('He2b', 5412, sumnr* 0.078 )
         call addln2('He2b', 4860, sumnr* 0.049 )
         call addln2('He2b', 4686, sumnr* 1.)
         call addln2('He2b', 4542, sumnr* 0.033 )
         call addln2('He2b', 4339, sumnr* 0.024 )
         call addln2('He2b', 4200, sumnr* 0.018 )
         call addln2('He2b', 4100, sumnr* 0.013 )
      endif
*
*     O II recombination lines scales from Kaler's nebulae
      sumnr=amatch('O  2',4651)
      if(sumnr.ne.0.) then
         call addln2('O r2', 4072 , sumnr* 0.32 )
         call addln2('O r2', 4130 , sumnr* 0.13 )
         call addln2('O r2', 4153 , sumnr* 0.13 )
         call addln2('O r2', 4190 , sumnr* 0.06 )
         call addln2('O r2', 4254 , sumnr* 0.05 )
         call addln2('O r2', 4294 , sumnr* 0.12 )
         call addln2('O r2', 4318 , sumnr* 0.13 )
         call addln2('O r2', 4349 , sumnr* 0.29 )
         call addln2('O r2', 4415 , sumnr* 0.12 )
         call addln2('O r2', 4595 , sumnr* 0.08 )
         call addln2('O r2', 4607 , sumnr* 0.05 )
         call addln2('O r2', 4676 , sumnr* 0.08 )
         call addln2('O r2', 4705 , sumnr* 0.06 )
         call addln2('O r2', 4620 , sumnr* 0.024)
      endif
*
*     O III recombination lines   a and b are case a and case b
      sumnr=amatch('O B3',3341)
      if(sumnr.ne.0.) then
         call addln2('Ora3',3341,sumnr*0.107)
         call addln2('Orb3',3047,sumnr*3.19 )
         call addln2('Ora3',3047,sumnr*0.37 )
         call addln2('Orb3',5592,sumnr*0.57 )
         call addln2('Ora3',5592,sumnr*0.069)
         sumnr=amatch('O B3',3760)
      endif
*
      if(sumnr.ne.0.) then
         call addln2('ora3',3760,sumnr*0.808)
      endif
*
*     O IV recombination (for whole multiplet multiply by 11.5/6.9)
      sumnr=amatch('O B4',3412)
      if(sumnr.ne.0.) then
*        burgess and seaton
         call addln2('Ora4',3412,sumnr*0.002)
*        from n7027
         call addln2('Or?4',3736,sumnr*0.27)
      endif
*
*      N II recombination lines   a and b are case a and case b
      sumnr=amatch('N B2',5047)
      if(sumnr.ne.0.) then
         call addln2('Nra2',5047,sumnr*0.107)
*        1/3 4606,4621,4631 RMT 5
         call addln2('Nrb2',4621,sumnr*3.19 )
         call addln2('Nra2',4621,sumnr*0.37 )
      endif
*
      sumnr=amatch('N B2',5680)
      if(sumnr.ne.0.) then
*        case a from case b
         call addln2('Nra2',5680,sumnr*0.808)
*        based on 0.3 of case a
         call addln2('N r2',5942,sumnr*0.25 )
      endif
*
*     N III recombination lines
      sumnr=amatch('N B3',4641)
      if(sumnr.ne.0.) then
*        burgess and seaton
         call addln2('Nra3',4641,sumnr*0.002)
      endif
*
*     C II recombination lines
      sumnr=amatch('C  2',4267)
      if(sumnr.ne.0.) then
         call addln2('C r2',4619,sumnr*0.05)
      endif
*
*     C III recombination
      sumnr=amatch('C  3',4187)
      if(sumnr.ne.0.) then
         call addln2('C r3', 4070, sumnr* 2.1 )
      endif
*
*     C IV recombination
      sumnr=amatch('C  4',4659)
      if(sumnr.ne.0.) then
*        includes reddening cor
         call addln2('C r4',5801,sumnr*1.25 )
      endif
*
*     ratios of many forbidden lines
      sumnr=amatch('Ne 3', 3869 )
      if(sumnr.ne.0.) then
         call addln2('NeR3', 3968 , sumnr* 0.30 )
      endif
*
      sumnr=amatch('Ne 5',3426)
      if(sumnr.ne.0.) then
         call addln2('NeR5', 3346, sumnr* 0.34)
      endif
*
      sumnr=amatch('N  2',6584)
      if(sumnr.ne.0.) then
         call addln2('N r2',6548, sumnr* 0.335)
      endif
*
      sumnr=amatch('O  3',5007)
      if(sumnr.ne.0.) then
         call addln2('O r3', 4959, sumnr* 0.336)
      endif
      sumnr=amatch('Ar 5',7007)
      if(sumnr.ne.0.) then
         call addln2('Arr5',6435, sumnr* 0.43 )
      endif
*
      sumnr=amatch('O  1',6300)
      if(sumnr.ne.0.) then
         call addln2('O r1',6363, sumnr* 0.33)
      endif
*
      sumnr=amatch('Ar 3',7136)
      if(sumnr.ne.0.) then
         call addln2('Arr3',7751, sumnr* 0.31)
      endif
*
      sumnr = amatch('S  3',9532)
      if(sumnr.ne.0.) then
         call addln2('S r3',9069, sumnr* 0.39)
      endif
*
*     no lines added
      if(npxdd.eq.isave .or. (.not.lgTalk) ) return
*
*     write new lines
      inew = npxdd - isave
      nline = (inew + 3) / 4
*
      do i=1,nline
        j1=isave+i
        write(qq,'(5x,3(1x,a4,i5,f7.3,f9.4,5x),1x,a4,i5,f7.3,f9.4)')
     1  (chALab(j),lin(j),asumli(j),scaled(j),j=j1,npxdd,nline)
      end do
*
      end
******************************************************************************
      subroutine addln2(chAA,lll,sumnew)
      implicit none
*add lines to list, scaled from know ratios, by Peter Martin
      integer lll
      real sumnew
      character*4 chAA
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      logical lgFaintOn
*logical lgFaintOn normally true, says to not print very faint lines
*set false with print faint off command
*lines fainter than TooFaint will not be printed.  This is set in zerologic
*and reset with print line faint command
      real TooFaint
      common/faint/ TooFaint , lgFaintOn
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
*
*     local variables
      real scaldu
*
*     new emission line as log of total luminosity
      if( lgFaintOn ) then
*     >>chng 97 june 30, did not have sclnrm so only worked when lines not resca
         scaldu = sumnew / snorm * sclnrm
*        do not print relatively faint lines
         if(scaldu.ge.TooFaint) then
            npxdd= npxdd + 1
            scaled(npxdd) = scaldu
            sumlin(npxdd) = sumnew
            asumli(npxdd) = log10(sumnew)+arealg
            chALab(npxdd) = chAA
            lin(npxdd) = lll
         endif
      endif
*
      end
******************************************************************************
      real function amatch(chAA,lll)
      implicit none
*find lines within line array, to use to rescale Peter Martin's extra lines
      integer lll
      character*4 chAA
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
*
*     local variables
      integer j
*
*     tO produce strength of line used for normalizing
*
      do j=1,nsum
        if(chALab(j).eq.chAA .and. lin(j).eq.lll) then
          amatch = sumlin(j)
          return
        endif
      end do
      amatch = 0.
*
      end
******************************************************************************
      subroutine spect
      implicit none
*order the emission line list according to increasing wavelength
*     l (index vector) is obtained using m01alf from the nag library
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
*
*     local variables
      integer ia(NLINES)
      integer nw,ifail,n , i , nline
*
      ifail=0
      n=npxdd
      nw=n
      do i=1,n
        ia(i)=lin(i)
      end do
*     CALL M01ALF(IA,IW,L,INDW,N,NW,IFAIL)
*     l not defined below as result of above not existing
      ifail = 1
      if(ifail.ne.0) then
        write(qq,'('' ADDLN1 fails.'')')
        stop
      endif
*
      if( .not.lgTalk ) return
*
*     now write reordered and merged ouput
      write(qq,'(''1'')')
      nline = (npxdd + 3) / 4
*
      end
******************************************************************************
*     subroutine m01alf(ia,iw,l,indw,n,nw,ifail)
*     implicit none
*     integer ia(1) , iw(1) , l(1) , indw(1)
*     integer n,nw,ifail
*     include "IOqq.com"
*
*     WRITE(QQ,'('' The PRINT SORT option has not been fully '',
*    1 ''implemented.'')')
*     WRITE(QQ,'('' Address all complaints to Peter G. Martin.'')')
*
*     STOP
*     END
 
******************************************************************************
      subroutine pgaunt( io )
      implicit none
*called by punch gaunts command to output gaunt factors
      integer io
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real te , eden , hden
      common/phycon/ te , eden , hden
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
*
*     local variables
      integer nte , nenr , i , ite, j,if1
      parameter (nte=21 , nenr=31)
      real ener(nenr) , g(nte,nenr) , gfac , ste(nte) ,z
      integer ier(nte,nenr)
*
*     this routine is called from the PUNCH GAUNTS command
*     it drives the gaunt factor routine to punch gaunts over full range
*
      do i=1,nte
        ste(i) = 0.5*(i-1)
      end do
      do i=1,nenr
        ener(i) = 0.5*(i-1)-5.
      end do
*
*     ener is log of energy
      do ite=1,nte
        alogte = ste(ite)
*       nuclear charge
        z = log10(1.)
        do j=1,nenr
          call gffsub(z,ener(j),gfac,1,1,1,if1)
          g(ite,j) = gfac
          ier(ite,j) = if1
        end do
      end do
*
*     now punch out the results
      write(io,'(6x,21f6.1)') (ste(i),i=1,nte)
      do j=1,nenr
        write(io,'(22f6.2)') ener(j),(log10(g(ite,j)),ite=1,nte)
      end do
*
      write(io,'(6x,21f6.1)') (ste(i),i=1,nte)
      do j=1,nenr
        write(io,'(f6.3,21i6)') ener(j),(ier(ite,j),ite=1,nte)
      end do
*
*     now do the same thing as triplets
      write(io,'(6x,21f6.1)') (ste(i),i=1,nte)
      do i=1,nte
        do j=1,nenr
          write(io,'(22f6.2)') ste(i),ener(j),log10(g(i,j))
        end do
      end do
*
      end
      subroutine phfit(nz,ne,is,e,s,lghs)
      implicit none
*derive photoionization cross sectoins for first 30 elements
      integer nz,ne,is
      real e,s
      logical lghs
*** Version 3. October 8, 1996.
*** Written by D. A. Verner, verner@pa.uky.edu
*** Inner-shell ionization energies of some low-ionized species are slightly
*** improved to fit smoothly the experimental inner-shell ionization energies
*** of neutral atoms.
*** New logical argument lghs
******************************************************************************
*** This subroutine calculates partial photoionization cross sections
*** for all ionization stages of all atoms from H to Zn (Z=30) by use of
*** the following fit parameters:
*** Outer shells of the Opacity Project (OP) elements:
***    Verner, Ferland, Korista, Yakovlev, 1996, ApJ, in press.
*** Inner shells of all elements, and outer shells of the non-OP elements:
***    Verner and Yakovlev, 1995, A&AS, 109, 125
*** Input parameters:  nz - atomic number from 1 to 30 (integer)
***                    ne - number of electrons from 1 to iz (integer)
***                    is - shell number (integer)
***                    e - photon energy, eV
***                    lghs - logical, "FALSE" (default) calculates
***                           new cross sections, "TRUE" calculates
***                           only old Hartree-Slater cross sections
*** Output parameter:  s - photoionization cross section, Mb
*** Shell numbers:
*** 1 - 1s, 2 - 2s, 3 - 2p, 4 - 3s, 5 - 3p, 6 - 3d, 7 - 4s.
*** If a species in the ground state has no electrons on the given shell,
*** the subroutine returns s=0.
******************************************************************************
      integer L
      COMMON/L/L(7)
      integer NINN
      COMMON/NINN/NINN(30)
      integer NTOT
      COMMON/NTOT/NTOT(30)
      real PH1 , PH2
      COMMON/PH1/PH1(6,30,30,7)
      COMMON/PH2/PH2(7,30,30)
*
*     local variables
      integer nout  , nint
      real einn,p1,y,q,a,b,x,z
*
      s=0.0
      if(nz.lt.1.or.nz.gt.30)return
      if(ne.lt.1.or.ne.gt.nz)return
      nout=NTOT(ne)
      if(nz.eq.ne.and.nz.gt.18)nout=7
      if(nz.eq.(ne+1).and.(nz.eq.20.or.nz.eq.21.or.nz.eq.22.or.nz.
     &eq.25.or.nz.eq.26))nout=7
      if(is.gt.nout)return
      if(is.eq.6.and.(nz.eq.20.or.nz.eq.19).and.ne.ge.19)return
      if(e.lt.PH1(1,nz,ne,is))return
      nint=NINN(ne)
      if(nz.eq.15.or.nz.eq.17.or.nz.eq.19.or.
     &(nz.gt.20.and.nz.ne.26))then
         einn=0.0
      else
         if(ne.lt.3)then
            einn=1.0e+30
         else
            einn=PH1(1,nz,ne,nint)
         endif
      endif
      if(is.le.nint.or.e.ge.einn.or.lghs)then
         p1=-PH1(5,nz,ne,is)
         y=e/PH1(2,nz,ne,is)
         q=-0.5*p1-L(is)-5.5
         a=PH1(3,nz,ne,is)*((y-1.0)**2+PH1(6,nz,ne,is)**2)
         b=sqrt(y/PH1(4,nz,ne,is))+1.0
         s=a*y**q*b**p1
      else
         if(is.lt.nout.and.is.gt.nint.and.e.lt.einn)return
         p1=-PH2(4,nz,ne)
         q=-0.5*p1-5.5
         x=e/PH2(1,nz,ne)-PH2(6,nz,ne)
         z=sqrt(x*x+PH2(7,nz,ne)**2)
         a=PH2(2,nz,ne)*((x-1.0)**2+PH2(5,nz,ne)**2)
         b=1.0+sqrt(z/PH2(3,nz,ne))
         s=a*z**q*b**p1
      endif
      return
      end
      block data bdata
      COMMON/L/L(7)
      COMMON/NINN/NINN(30)
      COMMON/NTOT/NTOT(30)
      COMMON/PH1/PH1(6,30,30,7)
      COMMON/PH2/PH2(7,30,30)
      DATA (L(I),I=1,7) /0,0,1,0,1,2,0/
      DATA (NINN(I),I=1,30) /0,0,1,1,1,1,1,1,1,1,3,3,
     & 3,3,3,3,3,3,5,5,5,5,5,5,5,5,5,5,5,5/
      DATA (NTOT(I),I=1,30) /1,1,2,2,3,3,3,3,3,3,4,4,
     & 5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,7,7/
      DATA (PH1(I, 1, 1, 1),I=1,6) /1.360E+01, 4.298E-01,
     1 5.475E+04, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 2, 1, 1),I=1,6) /5.442E+01, 1.720E+00,
     1 1.369E+04, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 2, 2, 1),I=1,6) /2.459E+01, 5.996E+00,
     1 4.470E+03, 2.199E+00, 6.098E+00, 0.000E+00/
      DATA (PH1(I, 3, 1, 1),I=1,6) /1.225E+02, 3.871E+00,
     1 6.083E+03, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 3, 2, 1),I=1,6) /7.564E+01, 2.006E+01,
     1 3.201E+02, 7.391E+00, 2.916E+00, 0.000E+00/
      DATA (PH1(I, 3, 3, 1),I=1,6) /6.439E+01, 2.740E+01,
     1 1.564E+02, 3.382E+01, 1.490E+00, 0.000E+00/
      DATA (PH1(I, 3, 3, 2),I=1,6) /5.392E+00, 3.466E+00,
     1 4.774E+01, 2.035E+01, 4.423E+00, 0.000E+00/
      DATA (PH1(I, 4, 1, 1),I=1,6) /2.177E+02, 6.879E+00,
     1 3.422E+03, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 4, 2, 1),I=1,6) /1.539E+02, 1.760E+01,
     1 5.458E+02, 1.719E+01, 3.157E+00, 0.000E+00/
      DATA (PH1(I, 4, 3, 1),I=1,6) /1.299E+02, 4.759E+01,
     1 9.796E+01, 1.166E+03, 1.022E+00, 0.000E+00/
      DATA (PH1(I, 4, 3, 2),I=1,6) /1.821E+01, 6.685E+00,
     1 4.904E+01, 3.419E+01, 3.738E+00, 0.000E+00/
      DATA (PH1(I, 4, 4, 1),I=1,6) /1.193E+02, 4.093E+01,
     1 1.306E+02, 1.212E+02, 1.348E+00, 0.000E+00/
      DATA (PH1(I, 4, 4, 2),I=1,6) /9.323E+00, 3.427E+00,
     1 1.423E+03, 2.708E+00, 1.064E+01, 0.000E+00/
      DATA (PH1(I, 5, 1, 1),I=1,6) /3.402E+02, 1.075E+01,
     1 2.190E+03, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 5, 2, 1),I=1,6) /2.594E+02, 3.336E+01,
     1 2.846E+02, 2.163E+01, 2.624E+00, 0.000E+00/
      DATA (PH1(I, 5, 3, 1),I=1,6) /2.274E+02, 6.592E+01,
     1 8.605E+01, 1.906E+02, 1.210E+00, 0.000E+00/
      DATA (PH1(I, 5, 3, 2),I=1,6) /3.793E+01, 1.054E+01,
     1 4.273E+01, 4.433E+01, 3.501E+00, 0.000E+00/
      DATA (PH1(I, 5, 4, 1),I=1,6) /2.098E+02, 5.984E+01,
     1 1.037E+02, 7.915E+01, 1.436E+00, 0.000E+00/
      DATA (PH1(I, 5, 4, 2),I=1,6) /2.516E+01, 2.403E+00,
     1 1.530E+02, 9.203E+00, 9.374E+00, 0.000E+00/
      DATA (PH1(I, 5, 5, 1),I=1,6) /1.940E+02, 6.155E+01,
     1 9.698E+01, 7.354E+01, 1.438E+00, 0.000E+00/
      DATA (PH1(I, 5, 5, 2),I=1,6) /1.405E+01, 6.495E+00,
     1 1.525E+04, 1.352E+00, 1.218E+01, 0.000E+00/
      DATA (PH1(I, 5, 5, 3),I=1,6) /8.298E+00, 6.658E+00,
     1 3.643E+02, 9.500E+00, 5.469E+00, 5.608E-01/
      DATA (PH1(I, 6, 1, 1),I=1,6) /4.900E+02, 1.548E+01,
     1 1.521E+03, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 6, 2, 1),I=1,6) /3.921E+02, 4.624E+01,
     1 2.344E+02, 2.183E+01, 2.581E+00, 0.000E+00/
      DATA (PH1(I, 6, 3, 1),I=1,6) /3.522E+02, 8.412E+01,
     1 8.111E+01, 7.459E+01, 1.428E+00, 0.000E+00/
      DATA (PH1(I, 6, 3, 2),I=1,6) /6.449E+01, 7.843E+00,
     1 7.109E+01, 2.828E+01, 4.754E+00, 0.000E+00/
      DATA (PH1(I, 6, 4, 1),I=1,6) /3.289E+02, 8.370E+01,
     1 8.067E+01, 7.471E+01, 1.442E+00, 0.000E+00/
      DATA (PH1(I, 6, 4, 2),I=1,6) /4.789E+01, 3.942E+00,
     1 1.219E+02, 1.499E+01, 7.489E+00, 0.000E+00/
      DATA (PH1(I, 6, 5, 1),I=1,6) /3.076E+02, 9.113E+01,
     1 6.649E+01, 9.609E+01, 1.338E+00, 0.000E+00/
      DATA (PH1(I, 6, 5, 2),I=1,6) /3.047E+01, 2.991E+00,
     1 1.184E+03, 3.085E+00, 1.480E+01, 0.000E+00/
      DATA (PH1(I, 6, 5, 3),I=1,6) /2.438E+01, 1.094E+01,
     1 1.792E+02, 3.308E+01, 4.150E+00, 5.276E-01/
      DATA (PH1(I, 6, 6, 1),I=1,6) /2.910E+02, 8.655E+01,
     1 7.421E+01, 5.498E+01, 1.503E+00, 0.000E+00/
      DATA (PH1(I, 6, 6, 2),I=1,6) /1.939E+01, 1.026E+01,
     1 4.564E+03, 1.568E+00, 1.085E+01, 0.000E+00/
      DATA (PH1(I, 6, 6, 3),I=1,6) /1.126E+01, 9.435E+00,
     1 1.152E+03, 5.687E+00, 6.336E+00, 4.474E-01/
      DATA (PH1(I, 7, 1, 1),I=1,6) /6.671E+02, 2.108E+01,
     1 1.117E+03, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 7, 2, 1),I=1,6) /5.521E+02, 6.943E+01,
     1 1.519E+02, 2.627E+01, 2.315E+00, 0.000E+00/
      DATA (PH1(I, 7, 3, 1),I=1,6) /5.043E+02, 1.060E+02,
     1 7.304E+01, 5.547E+01, 1.538E+00, 0.000E+00/
      DATA (PH1(I, 7, 3, 2),I=1,6) /9.789E+01, 1.862E+01,
     1 3.447E+01, 4.231E+01, 3.606E+00, 0.000E+00/
      DATA (PH1(I, 7, 4, 1),I=1,6) /4.753E+02, 1.070E+02,
     1 7.046E+01, 5.342E+01, 1.552E+00, 0.000E+00/
      DATA (PH1(I, 7, 4, 2),I=1,6) /7.747E+01, 6.225E+00,
     1 1.110E+02, 1.733E+01, 6.719E+00, 0.000E+00/
      DATA (PH1(I, 7, 5, 1),I=1,6) /4.473E+02, 1.220E+02,
     1 5.235E+01, 9.428E+01, 1.335E+00, 0.000E+00/
      DATA (PH1(I, 7, 5, 2),I=1,6) /5.545E+01, 5.853E+00,
     1 1.908E+02, 6.264E+00, 9.711E+00, 0.000E+00/
      DATA (PH1(I, 7, 5, 3),I=1,6) /4.745E+01, 1.925E+01,
     1 9.400E+01, 1.152E+02, 3.194E+00, 5.496E-01/
      DATA (PH1(I, 7, 6, 1),I=1,6) /4.236E+02, 1.242E+02,
     1 5.002E+01, 9.100E+01, 1.335E+00, 0.000E+00/
      DATA (PH1(I, 7, 6, 2),I=1,6) /3.796E+01, 1.094E+01,
     1 7.483E+02, 2.793E+00, 9.956E+00, 0.000E+00/
      DATA (PH1(I, 7, 6, 3),I=1,6) /2.960E+01, 1.827E+01,
     1 1.724E+02, 8.893E+01, 3.348E+00, 4.209E-01/
      DATA (PH1(I, 7, 7, 1),I=1,6) /4.048E+02, 1.270E+02,
     1 4.748E+01, 1.380E+02, 1.252E+00, 0.000E+00/
      DATA (PH1(I, 7, 7, 2),I=1,6) /2.541E+01, 1.482E+01,
     1 7.722E+02, 2.306E+00, 9.139E+00, 0.000E+00/
      DATA (PH1(I, 7, 7, 3),I=1,6) /1.453E+01, 1.164E+01,
     1 1.029E+04, 2.361E+00, 8.821E+00, 4.239E-01/
      DATA (PH1(I, 8, 1, 1),I=1,6) /8.714E+02, 2.754E+01,
     1 8.554E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 8, 2, 1),I=1,6) /7.393E+02, 8.709E+01,
     1 1.329E+02, 2.535E+01, 2.336E+00, 0.000E+00/
      DATA (PH1(I, 8, 3, 1),I=1,6) /6.837E+02, 1.354E+02,
     1 6.029E+01, 5.682E+01, 1.533E+00, 0.000E+00/
      DATA (PH1(I, 8, 3, 2),I=1,6) /1.381E+02, 9.141E+00,
     1 6.896E+01, 3.896E+01, 4.943E+00, 0.000E+00/
      DATA (PH1(I, 8, 4, 1),I=1,6) /6.491E+02, 1.377E+02,
     1 5.735E+01, 5.486E+01, 1.540E+00, 0.000E+00/
      DATA (PH1(I, 8, 4, 2),I=1,6) /1.139E+02, 8.467E+00,
     1 9.641E+01, 2.287E+01, 6.061E+00, 0.000E+00/
      DATA (PH1(I, 8, 5, 1),I=1,6) /6.144E+02, 1.593E+02,
     1 4.123E+01, 1.141E+02, 1.287E+00, 0.000E+00/
      DATA (PH1(I, 8, 5, 2),I=1,6) /8.737E+01, 7.942E+00,
     1 1.063E+02, 9.708E+00, 8.183E+00, 0.000E+00/
      DATA (PH1(I, 8, 5, 3),I=1,6) /7.741E+01, 1.937E+01,
     1 1.619E+02, 7.312E+01, 3.648E+00, 3.760E-02/
      DATA (PH1(I, 8, 6, 1),I=1,6) /5.840E+02, 1.620E+02,
     1 3.939E+01, 1.104E+02, 1.289E+00, 0.000E+00/
      DATA (PH1(I, 8, 6, 2),I=1,6) /6.551E+01, 1.594E+01,
     1 1.217E+02, 6.156E+00, 7.271E+00, 0.000E+00/
      DATA (PH1(I, 8, 6, 3),I=1,6) /5.494E+01, 2.067E+01,
     1 2.318E+02, 7.136E+01, 3.618E+00, 5.538E-02/
      DATA (PH1(I, 8, 7, 1),I=1,6) /5.581E+02, 1.690E+02,
     1 3.584E+01, 1.894E+02, 1.185E+00, 0.000E+00/
      DATA (PH1(I, 8, 7, 2),I=1,6) /4.599E+01, 1.759E+01,
     1 1.962E+02, 4.020E+00, 7.999E+00, 0.000E+00/
      DATA (PH1(I, 8, 7, 3),I=1,6) /3.512E+01, 1.745E+01,
     1 5.186E+02, 1.728E+01, 4.995E+00, 2.182E-02/
      DATA (PH1(I, 8, 8, 1),I=1,6) /5.380E+02, 1.774E+02,
     1 3.237E+01, 3.812E+02, 1.083E+00, 0.000E+00/
      DATA (PH1(I, 8, 8, 2),I=1,6) /2.848E+01, 1.994E+01,
     1 2.415E+02, 3.241E+00, 8.037E+00, 0.000E+00/
      DATA (PH1(I, 8, 8, 3),I=1,6) /1.362E+01, 1.391E+01,
     1 1.220E+05, 1.364E+00, 1.140E+01, 4.103E-01/
      DATA (PH1(I, 9, 1, 1),I=1,6) /1.103E+03, 3.485E+01,
     1 6.759E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I, 9, 2, 1),I=1,6) /9.539E+02, 1.131E+02,
     1 1.039E+02, 2.657E+01, 2.255E+00, 0.000E+00/
      DATA (PH1(I, 9, 3, 1),I=1,6) /8.905E+02, 1.711E+02,
     1 4.890E+01, 6.137E+01, 1.501E+00, 0.000E+00/
      DATA (PH1(I, 9, 3, 2),I=1,6) /1.852E+02, 6.423E+00,
     1 8.497E+01, 6.075E+01, 5.214E+00, 0.000E+00/
      DATA (PH1(I, 9, 4, 1),I=1,6) /8.502E+02, 1.737E+02,
     1 4.668E+01, 5.876E+01, 1.511E+00, 0.000E+00/
      DATA (PH1(I, 9, 4, 2),I=1,6) /1.572E+02, 1.146E+01,
     1 8.453E+01, 2.457E+01, 5.771E+00, 0.000E+00/
      DATA (PH1(I, 9, 5, 1),I=1,6) /8.091E+02, 1.925E+02,
     1 3.680E+01, 7.933E+01, 1.377E+00, 0.000E+00/
      DATA (PH1(I, 9, 5, 2),I=1,6) /1.262E+02, 1.889E+01,
     1 7.149E+01, 1.194E+01, 6.030E+00, 0.000E+00/
      DATA (PH1(I, 9, 5, 3),I=1,6) /1.142E+02, 2.528E+01,
     1 1.419E+02, 7.089E+01, 3.628E+00, 3.418E-01/
      DATA (PH1(I, 9, 6, 1),I=1,6) /7.709E+02, 1.603E+02,
     1 5.302E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I, 9, 6, 2),I=1,6) /9.957E+01, 2.629E+01,
     1 3.563E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I, 9, 6, 3),I=1,6) /8.714E+01, 2.292E+01,
     1 3.005E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I, 9, 7, 1),I=1,6) /7.392E+02, 2.055E+02,
     1 3.144E+01, 1.230E+02, 1.263E+00, 0.000E+00/
      DATA (PH1(I, 9, 7, 2),I=1,6) /7.610E+01, 2.307E+01,
     1 7.140E+01, 7.282E+00, 6.543E+00, 0.000E+00/
      DATA (PH1(I, 9, 7, 3),I=1,6) /6.271E+01, 2.744E+01,
     1 2.458E+02, 7.329E+01, 3.596E+00, 1.390E-01/
      DATA (PH1(I, 9, 8, 1),I=1,6) /7.122E+02, 1.660E+02,
     1 4.798E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I, 9, 8, 2),I=1,6) /5.459E+01, 2.882E+01,
     1 2.439E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I, 9, 8, 3),I=1,6) /3.497E+01, 2.658E+01,
     1 2.649E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I, 9, 9, 1),I=1,6) /6.940E+02, 2.390E+02,
     1 2.295E+01, 1.257E+03, 9.638E-01, 0.000E+00/
      DATA (PH1(I, 9, 9, 2),I=1,6) /3.786E+01, 2.568E+01,
     1 1.097E+02, 4.297E+00, 7.303E+00, 0.000E+00/
      DATA (PH1(I, 9, 9, 3),I=1,6) /1.742E+01, 1.658E+01,
     1 2.775E+05, 1.242E+00, 1.249E+01, 3.857E-01/
      DATA (PH1(I,10, 1, 1),I=1,6) /1.362E+03, 4.304E+01,
     1 5.475E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,10, 2, 1),I=1,6) /1.196E+03, 1.586E+02,
     1 6.695E+01, 3.352E+01, 2.002E+00, 0.000E+00/
      DATA (PH1(I,10, 3, 1),I=1,6) /1.125E+03, 2.193E+02,
     1 3.719E+01, 8.181E+01, 1.396E+00, 0.000E+00/
      DATA (PH1(I,10, 3, 2),I=1,6) /2.391E+02, 2.859E+01,
     1 2.897E+01, 3.836E+01, 3.992E+00, 0.000E+00/
      DATA (PH1(I,10, 4, 1),I=1,6) /1.078E+03, 1.886E+02,
     1 5.011E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,10, 4, 2),I=1,6) /2.073E+02, 2.822E+01,
     1 4.978E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,10, 5, 1),I=1,6) /1.031E+03, 2.308E+02,
     1 3.232E+01, 7.167E+01, 1.411E+00, 0.000E+00/
      DATA (PH1(I,10, 5, 2),I=1,6) /1.719E+02, 2.496E+01,
     1 5.575E+01, 1.427E+01, 5.562E+00, 0.000E+00/
      DATA (PH1(I,10, 5, 3),I=1,6) /1.579E+02, 2.740E+01,
     1 1.717E+02, 6.423E+01, 3.819E+00, 1.680E-01/
      DATA (PH1(I,10, 6, 1),I=1,6) /9.873E+02, 2.343E+02,
     1 3.097E+01, 6.907E+01, 1.416E+00, 0.000E+00/
      DATA (PH1(I,10, 6, 2),I=1,6) /1.415E+02, 2.615E+01,
     1 5.421E+01, 1.117E+01, 5.907E+00, 0.000E+00/
      DATA (PH1(I,10, 6, 3),I=1,6) /1.262E+02, 3.316E+01,
     1 1.962E+02, 7.397E+01, 3.563E+00, 2.895E-01/
      DATA (PH1(I,10, 7, 1),I=1,6) /9.480E+02, 2.360E+02,
     1 3.027E+01, 6.734E+01, 1.422E+00, 0.000E+00/
      DATA (PH1(I,10, 7, 2),I=1,6) /1.132E+02, 3.092E+01,
     1 4.190E+01, 1.139E+01, 5.554E+00, 0.000E+00/
      DATA (PH1(I,10, 7, 3),I=1,6) /9.712E+01, 3.494E+01,
     1 2.214E+02, 7.203E+01, 3.563E+00, 2.573E-01/
      DATA (PH1(I,10, 8, 1),I=1,6) /9.131E+02, 2.387E+02,
     1 2.943E+01, 6.525E+01, 1.424E+00, 0.000E+00/
      DATA (PH1(I,10, 8, 2),I=1,6) /8.721E+01, 3.192E+01,
     1 3.797E+01, 1.054E+01, 5.652E+00, 0.000E+00/
      DATA (PH1(I,10, 8, 3),I=1,6) /6.346E+01, 3.485E+01,
     1 2.451E+02, 6.937E+01, 3.645E+00, 2.042E-01/
      DATA (PH1(I,10, 9, 1),I=1,6) /8.831E+02, 2.452E+02,
     1 2.783E+01, 6.075E+01, 1.420E+00, 0.000E+00/
      DATA (PH1(I,10, 9, 2),I=1,6) /6.374E+01, 3.187E+01,
     1 4.025E+01, 8.495E+00, 6.038E+00, 0.000E+00/
      DATA (PH1(I,10, 9, 3),I=1,6) /4.096E+01, 3.428E+01,
     1 2.766E+02, 4.179E+01, 4.029E+00, 3.052E-01/
      DATA (PH1(I,10,10, 1),I=1,6) /8.701E+02, 3.144E+02,
     1 1.664E+01, 2.042E+05, 8.450E-01, 0.000E+00/
      DATA (PH1(I,10,10, 2),I=1,6) /4.847E+01, 3.204E+01,
     1 5.615E+01, 5.808E+00, 6.678E+00, 0.000E+00/
      DATA (PH1(I,10,10, 3),I=1,6) /2.156E+01, 2.000E+01,
     1 1.691E+04, 2.442E+00, 1.043E+01, 3.345E-01/
      DATA (PH1(I,11, 1, 1),I=1,6) /1.649E+03, 5.211E+01,
     1 4.525E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,11, 2, 1),I=1,6) /1.465E+03, 2.268E+02,
     1 3.995E+01, 5.315E+01, 1.678E+00, 0.000E+00/
      DATA (PH1(I,11, 3, 1),I=1,6) /1.386E+03, 2.406E+02,
     1 3.850E+01, 5.198E+01, 1.575E+00, 0.000E+00/
      DATA (PH1(I,11, 3, 2),I=1,6) /2.999E+02, 1.758E+01,
     1 4.531E+01, 4.549E+01, 4.689E+00, 0.000E+00/
      DATA (PH1(I,11, 4, 1),I=1,6) /1.335E+03, 2.464E+02,
     1 3.613E+01, 4.968E+01, 1.579E+00, 0.000E+00/
      DATA (PH1(I,11, 4, 2),I=1,6) /2.642E+02, 2.097E+01,
     1 6.127E+01, 2.644E+01, 5.246E+00, 0.000E+00/
      DATA (PH1(I,11, 5, 1),I=1,6) /1.281E+03, 2.777E+02,
     1 2.745E+01, 7.512E+01, 1.397E+00, 0.000E+00/
      DATA (PH1(I,11, 5, 2),I=1,6) /2.244E+02, 2.947E+01,
     1 4.802E+01, 1.621E+01, 5.395E+00, 0.000E+00/
      DATA (PH1(I,11, 5, 3),I=1,6) /2.085E+02, 3.552E+01,
     1 1.374E+02, 7.062E+01, 3.675E+00, 1.613E-01/
      DATA (PH1(I,11, 6, 1),I=1,6) /1.230E+03, 2.806E+02,
     1 2.654E+01, 7.237E+01, 1.405E+00, 0.000E+00/
      DATA (PH1(I,11, 6, 2),I=1,6) /1.899E+02, 3.303E+01,
     1 4.218E+01, 1.377E+01, 5.458E+00, 0.000E+00/
      DATA (PH1(I,11, 6, 3),I=1,6) /1.722E+02, 4.212E+01,
     1 1.650E+02, 9.649E+01, 3.367E+00, 2.182E-01/
      DATA (PH1(I,11, 7, 1),I=1,6) /1.185E+03, 2.360E+02,
     1 3.753E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,11, 7, 2),I=1,6) /1.567E+02, 3.868E+01,
     1 2.607E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,11, 7, 3),I=1,6) /1.384E+02, 3.523E+01,
     1 3.028E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,11, 8, 1),I=1,6) /1.143E+03, 2.841E+02,
     1 2.551E+01, 6.977E+01, 1.414E+00, 0.000E+00/
      DATA (PH1(I,11, 8, 2),I=1,6) /1.269E+02, 3.807E+01,
     1 3.144E+01, 1.250E+01, 5.405E+00, 0.000E+00/
      DATA (PH1(I,11, 8, 3),I=1,6) /9.892E+01, 4.314E+01,
     1 2.232E+02, 8.352E+01, 3.511E+00, 1.644E-01/
      DATA (PH1(I,11, 9, 1),I=1,6) /1.118E+03, 2.426E+02,
     1 3.466E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,11, 9, 2),I=1,6) /9.945E+01, 4.130E+01,
     1 1.933E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,11, 9, 3),I=1,6) /7.162E+01, 3.957E+01,
     1 2.748E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,11,10, 1),I=1,6) /1.097E+03, 3.266E+02,
     1 1.889E+01, 2.527E+02, 1.120E+00, 0.000E+00/
      DATA (PH1(I,11,10, 2),I=1,6) /7.347E+01, 3.939E+01,
     1 2.629E+01, 1.103E+01, 5.618E+00, 0.000E+00/
      DATA (PH1(I,11,10, 3),I=1,6) /4.729E+01, 3.911E+01,
     1 3.551E+02, 2.257E+01, 4.643E+00, 2.900E-01/
      DATA (PH1(I,11,11, 1),I=1,6) /1.079E+03, 4.216E+02,
     1 1.119E+01, 5.642E+07, 7.736E-01, 0.000E+00/
      DATA (PH1(I,11,11, 2),I=1,6) /7.084E+01, 4.537E+01,
     1 1.142E+01, 2.395E+02, 3.380E+00, 0.000E+00/
      DATA (PH1(I,11,11, 3),I=1,6) /3.814E+01, 3.655E+01,
     1 2.486E+02, 3.222E+02, 3.570E+00, 1.465E-01/
      DATA (PH1(I,11,11, 4),I=1,6) /5.139E+00, 5.968E+00,
     1 1.460E+00, 2.557E+07, 3.789E+00, 0.000E+00/
      DATA (PH1(I,12, 1, 1),I=1,6) /1.963E+03, 6.203E+01,
     1 3.802E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,12, 2, 1),I=1,6) /1.762E+03, 2.042E+02,
     1 6.140E+01, 2.778E+01, 2.161E+00, 0.000E+00/
      DATA (PH1(I,12, 3, 1),I=1,6) /1.675E+03, 2.858E+02,
     1 3.290E+01, 5.384E+01, 1.560E+00, 0.000E+00/
      DATA (PH1(I,12, 3, 2),I=1,6) /3.675E+02, 4.041E+01,
     1 2.228E+01, 3.904E+01, 3.986E+00, 0.000E+00/
      DATA (PH1(I,12, 4, 1),I=1,6) /1.618E+03, 2.671E+02,
     1 3.699E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,12, 4, 2),I=1,6) /3.282E+02, 3.981E+01,
     1 3.936E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,12, 5, 1),I=1,6) /1.558E+03, 3.082E+02,
     1 2.721E+01, 5.108E+01, 1.539E+00, 0.000E+00/
      DATA (PH1(I,12, 5, 2),I=1,6) /2.839E+02, 3.967E+01,
     1 3.755E+01, 1.873E+01, 4.950E+00, 0.000E+00/
      DATA (PH1(I,12, 5, 3),I=1,6) /2.660E+02, 2.461E+01,
     1 3.546E+02, 6.160E+01, 4.366E+00, 6.452E-03/
      DATA (PH1(I,12, 6, 1),I=1,6) /1.501E+03, 2.742E+02,
     1 3.407E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,12, 6, 2),I=1,6) /2.444E+02, 4.341E+01,
     1 2.832E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,12, 6, 3),I=1,6) /2.249E+02, 4.016E+01,
     1 2.442E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,12, 7, 1),I=1,6) /1.449E+03, 2.777E+02,
     1 3.278E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,12, 7, 2),I=1,6) /2.076E+02, 4.500E+01,
     1 2.434E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,12, 7, 3),I=1,6) /1.865E+02, 4.155E+01,
     1 2.901E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,12, 8, 1),I=1,6) /1.400E+03, 3.259E+02,
     1 2.350E+01, 6.173E+01, 1.464E+00, 0.000E+00/
      DATA (PH1(I,12, 8, 2),I=1,6) /1.735E+02, 4.710E+01,
     1 2.448E+01, 1.636E+01, 4.951E+00, 0.000E+00/
      DATA (PH1(I,12, 8, 3),I=1,6) /1.413E+02, 5.114E+01,
     1 2.134E+02, 9.563E+01, 3.438E+00, 5.419E-03/
      DATA (PH1(I,12, 9, 1),I=1,6) /1.356E+03, 3.345E+02,
     1 2.212E+01, 7.147E+01, 1.413E+00, 0.000E+00/
      DATA (PH1(I,12, 9, 2),I=1,6) /1.411E+02, 4.810E+01,
     1 2.118E+01, 1.675E+01, 4.941E+00, 0.000E+00/
      DATA (PH1(I,12, 9, 3),I=1,6) /1.093E+02, 5.137E+01,
     1 2.223E+02, 9.301E+01, 3.513E+00, 5.276E-03/
      DATA (PH1(I,12,10, 1),I=1,6) /1.336E+03, 3.607E+02,
     1 1.877E+01, 1.401E+02, 1.238E+00, 0.000E+00/
      DATA (PH1(I,12,10, 2),I=1,6) /1.111E+02, 4.804E+01,
     1 1.914E+01, 1.613E+01, 5.050E+00, 0.000E+00/
      DATA (PH1(I,12,10, 3),I=1,6) /8.014E+01, 5.319E+01,
     1 2.104E+02, 7.813E+01, 3.630E+00, 2.851E-01/
      DATA (PH1(I,12,11, 1),I=1,6) /1.320E+03, 3.709E+02,
     1 1.767E+01, 1.346E+02, 1.225E+00, 0.000E+00/
      DATA (PH1(I,12,11, 2),I=1,6) /9.881E+01, 5.142E+01,
     1 1.290E+01, 5.775E+01, 3.903E+00, 0.000E+00/
      DATA (PH1(I,12,11, 3),I=1,6) /6.569E+01, 4.940E+01,
     1 2.049E+02, 4.112E+03, 2.995E+00, 2.223E-05/
      DATA (PH1(I,12,11, 4),I=1,6) /1.504E+01, 8.139E+00,
     1 3.278E+00, 4.341E+07, 3.610E+00, 0.000E+00/
      DATA (PH1(I,12,12, 1),I=1,6) /1.311E+03, 2.711E+02,
     1 3.561E+01, 2.374E+01, 1.952E+00, 0.000E+00/
      DATA (PH1(I,12,12, 2),I=1,6) /9.400E+01, 4.587E+01,
     1 1.671E+01, 2.389E+01, 4.742E+00, 0.000E+00/
      DATA (PH1(I,12,12, 3),I=1,6) /5.490E+01, 4.937E+01,
     1 2.023E+02, 1.079E+04, 2.960E+00, 1.463E-02/
      DATA (PH1(I,12,12, 4),I=1,6) /7.646E+00, 9.393E+00,
     1 3.034E+00, 2.625E+07, 3.923E+00, 0.000E+00/
      DATA (PH1(I,13, 1, 1),I=1,6) /2.304E+03, 7.281E+01,
     1 3.239E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,13, 2, 1),I=1,6) /2.086E+03, 2.738E+02,
     1 4.036E+01, 3.567E+01, 1.915E+00, 0.000E+00/
      DATA (PH1(I,13, 3, 1),I=1,6) /1.992E+03, 3.137E+02,
     1 3.272E+01, 4.295E+01, 1.676E+00, 0.000E+00/
      DATA (PH1(I,13, 3, 2),I=1,6) /4.421E+02, 4.434E+01,
     1 2.098E+01, 3.913E+01, 4.062E+00, 0.000E+00/
      DATA (PH1(I,13, 4, 1),I=1,6) /1.929E+03, 3.117E+02,
     1 3.223E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,13, 4, 2),I=1,6) /3.994E+02, 4.639E+01,
     1 3.516E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,13, 5, 1),I=1,6) /1.862E+03, 3.305E+02,
     1 2.857E+01, 3.660E+01, 1.712E+00, 0.000E+00/
      DATA (PH1(I,13, 5, 2),I=1,6) /3.502E+02, 4.550E+01,
     1 3.393E+01, 1.945E+01, 4.926E+00, 0.000E+00/
      DATA (PH1(I,13, 5, 3),I=1,6) /3.301E+02, 4.084E+01,
     1 1.706E+02, 6.480E+01, 3.927E+00, 1.386E-01/
      DATA (PH1(I,13, 6, 1),I=1,6) /1.799E+03, 3.193E+02,
     1 2.989E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,13, 6, 2),I=1,6) /3.065E+02, 5.016E+01,
     1 2.604E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,13, 6, 3),I=1,6) /2.846E+02, 4.719E+01,
     1 2.229E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,13, 7, 1),I=1,6) /1.739E+03, 3.396E+02,
     1 2.653E+01, 3.478E+01, 1.721E+00, 0.000E+00/
      DATA (PH1(I,13, 7, 2),I=1,6) /2.662E+02, 5.726E+01,
     1 2.274E+01, 1.983E+01, 4.594E+00, 0.000E+00/
      DATA (PH1(I,13, 7, 3),I=1,6) /2.414E+02, 5.746E+01,
     1 1.941E+02, 8.747E+01, 3.460E+00, 1.206E-01/
      DATA (PH1(I,13, 8, 1),I=1,6) /1.688E+03, 3.268E+02,
     1 2.786E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,13, 8, 2),I=1,6) /2.268E+02, 5.340E+01,
     1 1.982E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,13, 8, 3),I=1,6) /1.905E+02, 5.032E+01,
     1 2.888E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,13, 9, 1),I=1,6) /1.634E+03, 3.432E+02,
     1 2.572E+01, 3.376E+01, 1.730E+00, 0.000E+00/
      DATA (PH1(I,13, 9, 2),I=1,6) /1.903E+02, 5.651E+01,
     1 1.865E+01, 1.904E+01, 4.763E+00, 0.000E+00/
      DATA (PH1(I,13, 9, 3),I=1,6) /1.538E+02, 6.049E+01,
     1 2.132E+02, 8.633E+01, 3.522E+00, 1.041E-01/
      DATA (PH1(I,13,10, 1),I=1,6) /1.604E+03, 3.482E+02,
     1 2.494E+01, 3.260E+01, 1.732E+00, 0.000E+00/
      DATA (PH1(I,13,10, 2),I=1,6) /1.558E+02, 5.735E+01,
     1 1.619E+01, 1.989E+01, 4.749E+00, 0.000E+00/
      DATA (PH1(I,13,10, 3),I=1,6) /1.200E+02, 6.033E+01,
     1 2.186E+02, 8.353E+01, 3.609E+00, 9.152E-02/
      DATA (PH1(I,13,11, 1),I=1,6) /1.583E+03, 3.200E+02,
     1 2.994E+01, 2.757E+01, 1.876E+00, 0.000E+00/
      DATA (PH1(I,13,11, 2),I=1,6) /1.407E+02, 5.629E+01,
     1 1.398E+01, 3.550E+01, 4.267E+00, 0.000E+00/
      DATA (PH1(I,13,11, 3),I=1,6) /1.026E+02, 6.016E+01,
     1 1.990E+02, 5.082E+02, 3.110E+00, 2.016E-02/
      DATA (PH1(I,13,11, 4),I=1,6) /2.845E+01, 1.027E+01,
     1 4.915E+00, 1.990E+06, 3.477E+00, 0.000E+00/
      DATA (PH1(I,13,12, 1),I=1,6) /1.571E+03, 3.049E+02,
     1 3.295E+01, 2.905E+01, 1.898E+00, 0.000E+00/
      DATA (PH1(I,13,12, 2),I=1,6) /1.281E+02, 5.171E+01,
     1 1.642E+01, 2.275E+01, 4.810E+00, 0.000E+00/
      DATA (PH1(I,13,12, 3),I=1,6) /8.997E+01, 6.154E+01,
     1 1.842E+02, 2.404E+03, 2.920E+00, 7.839E-03/
      DATA (PH1(I,13,12, 4),I=1,6) /1.883E+01, 1.012E+01,
     1 6.324E+00, 2.195E+02, 4.481E+00, 0.000E+00/
      DATA (PH1(I,13,13, 1),I=1,6) /1.567E+03, 3.670E+02,
     1 2.206E+01, 4.405E+01, 1.588E+00, 0.000E+00/
      DATA (PH1(I,13,13, 2),I=1,6) /1.256E+02, 5.594E+01,
     1 1.425E+01, 3.094E+01, 4.399E+00, 0.000E+00/
      DATA (PH1(I,13,13, 3),I=1,6) /8.040E+01, 6.445E+01,
     1 1.735E+02, 1.131E+04, 2.762E+00, 2.337E-02/
      DATA (PH1(I,13,13, 4),I=1,6) /1.133E+01, 1.204E+01,
     1 5.384E+00, 4.341E+02, 4.088E+00, 0.000E+00/
      DATA (PH1(I,13,13, 5),I=1,6) /5.986E+00, 1.860E+01,
     1 1.828E+02, 2.797E+00, 1.084E+01, 3.076E-01/
      DATA (PH1(I,14, 1, 1),I=1,6) /2.673E+03, 8.447E+01,
     1 2.793E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,14, 2, 1),I=1,6) /2.438E+03, 2.752E+02,
     1 4.754E+01, 2.848E+01, 2.135E+00, 0.000E+00/
      DATA (PH1(I,14, 3, 1),I=1,6) /2.336E+03, 3.150E+02,
     1 3.880E+01, 3.034E+01, 1.925E+00, 0.000E+00/
      DATA (PH1(I,14, 3, 2),I=1,6) /5.235E+02, 4.847E+01,
     1 1.966E+01, 3.851E+01, 4.148E+00, 0.000E+00/
      DATA (PH1(I,14, 4, 1),I=1,6) /2.268E+03, 3.599E+02,
     1 2.832E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,14, 4, 2),I=1,6) /4.761E+02, 5.350E+01,
     1 3.155E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,14, 5, 1),I=1,6) /2.194E+03, 3.356E+02,
     1 3.343E+01, 2.487E+01, 1.982E+00, 0.000E+00/
      DATA (PH1(I,14, 5, 2),I=1,6) /4.234E+02, 6.098E+01,
     1 2.624E+01, 2.213E+01, 4.520E+00, 0.000E+00/
      DATA (PH1(I,14, 5, 3),I=1,6) /4.014E+02, 3.950E+01,
     1 2.223E+02, 6.521E+01, 4.118E+00, 4.760E-05/
      DATA (PH1(I,14, 6, 1),I=1,6) /2.125E+03, 3.679E+02,
     1 2.641E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,14, 6, 2),I=1,6) /3.756E+02, 5.745E+01,
     1 2.394E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,14, 6, 3),I=1,6) /3.511E+02, 5.486E+01,
     1 2.031E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,14, 7, 1),I=1,6) /2.058E+03, 3.442E+02,
     1 3.135E+01, 2.260E+01, 2.020E+00, 0.000E+00/
      DATA (PH1(I,14, 7, 2),I=1,6) /3.310E+02, 6.593E+01,
     1 2.049E+01, 2.121E+01, 4.515E+00, 0.000E+00/
      DATA (PH1(I,14, 7, 3),I=1,6) /3.032E+02, 5.911E+01,
     1 2.326E+02, 6.806E+01, 3.718E+00, 2.813E-05/
      DATA (PH1(I,14, 8, 1),I=1,6) /2.001E+03, 3.759E+02,
     1 2.474E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,14, 8, 2),I=1,6) /2.872E+02, 6.086E+01,
     1 1.857E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,14, 8, 3),I=1,6) /2.465E+02, 5.786E+01,
     1 2.777E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,14, 9, 1),I=1,6) /1.946E+03, 3.799E+02,
     1 2.398E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,14, 9, 2),I=1,6) /2.468E+02, 6.237E+01,
     1 1.648E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,14, 9, 3),I=1,6) /2.051E+02, 6.007E+01,
     1 2.789E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,14,10, 1),I=1,6) /1.887E+03, 3.460E+02,
     1 3.100E+01, 1.979E+01, 2.094E+00, 0.000E+00/
      DATA (PH1(I,14,10, 2),I=1,6) /2.076E+02, 6.653E+01,
     1 1.463E+01, 2.200E+01, 4.611E+00, 0.000E+00/
      DATA (PH1(I,14,10, 3),I=1,6) /1.668E+02, 7.021E+01,
     1 2.109E+02, 8.199E+01, 3.588E+00, 6.329E-05/
      DATA (PH1(I,14,11, 1),I=1,6) /1.868E+03, 3.131E+02,
     1 3.784E+01, 2.017E+01, 2.186E+00, 0.000E+00/
      DATA (PH1(I,14,11, 2),I=1,6) /1.899E+02, 5.977E+01,
     1 1.486E+01, 2.786E+01, 4.565E+00, 0.000E+00/
      DATA (PH1(I,14,11, 3),I=1,6) /1.466E+02, 6.482E+01,
     1 2.326E+02, 1.188E+02, 3.547E+00, 8.417E-04/
      DATA (PH1(I,14,11, 4),I=1,6) /4.514E+01, 1.288E+01,
     1 6.083E+00, 1.356E+06, 3.353E+00, 0.000E+00/
      DATA (PH1(I,14,12, 1),I=1,6) /1.852E+03, 3.201E+02,
     1 3.591E+01, 2.174E+01, 2.123E+00, 0.000E+00/
      DATA (PH1(I,14,12, 2),I=1,6) /1.744E+02, 5.843E+01,
     1 1.569E+01, 2.296E+01, 4.803E+00, 0.000E+00/
      DATA (PH1(I,14,12, 3),I=1,6) /1.311E+02, 6.652E+01,
     1 2.197E+02, 1.169E+02, 3.529E+00, 8.658E-04/
      DATA (PH1(I,14,12, 4),I=1,6) /3.349E+01, 1.182E+01,
     1 8.666E+00, 3.532E+02, 4.208E+00, 0.000E+00/
      DATA (PH1(I,14,13, 1),I=1,6) /1.848E+03, 4.580E+02,
     1 1.628E+01, 7.706E+01, 1.385E+00, 0.000E+00/
      DATA (PH1(I,14,13, 2),I=1,6) /1.619E+02, 6.738E+01,
     1 1.263E+01, 3.623E+01, 4.172E+00, 0.000E+00/
      DATA (PH1(I,14,13, 3),I=1,6) /1.186E+02, 7.154E+01,
     1 1.832E+02, 3.537E+02, 3.133E+00, 2.870E-04/
      DATA (PH1(I,14,13, 4),I=1,6) /2.240E+01, 1.364E+01,
     1 8.454E+00, 7.489E+01, 4.676E+00, 0.000E+00/
      DATA (PH1(I,14,13, 5),I=1,6) /1.635E+01, 2.123E+01,
     1 6.975E+01, 4.907E+00, 9.525E+00, 3.169E-01/
      DATA (PH1(I,14,14, 1),I=1,6) /1.846E+03, 5.322E+02,
     1 1.184E+01, 2.580E+02, 1.102E+00, 0.000E+00/
      DATA (PH1(I,14,14, 2),I=1,6) /1.560E+02, 7.017E+01,
     1 1.166E+01, 4.742E+01, 3.933E+00, 0.000E+00/
      DATA (PH1(I,14,14, 3),I=1,6) /1.060E+02, 7.808E+01,
     1 1.532E+02, 5.765E+06, 2.639E+00, 2.774E-04/
      DATA (PH1(I,14,14, 4),I=1,6) /1.517E+01, 1.413E+01,
     1 1.166E+01, 2.288E+01, 5.334E+00, 0.000E+00/
      DATA (PH1(I,14,14, 5),I=1,6) /8.152E+00, 2.212E+01,
     1 1.845E+02, 3.849E+00, 9.721E+00, 2.921E-01/
      DATA (PH1(I,15, 1, 1),I=1,6) /3.070E+03, 9.701E+01,
     1 2.433E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,15, 2, 1),I=1,6) /2.817E+03, 3.381E+02,
     1 3.646E+01, 3.254E+01, 2.002E+00, 0.000E+00/
      DATA (PH1(I,15, 3, 1),I=1,6) /2.707E+03, 3.711E+02,
     1 3.220E+01, 3.257E+01, 1.869E+00, 0.000E+00/
      DATA (PH1(I,15, 3, 2),I=1,6) /6.119E+02, 6.401E+01,
     1 1.519E+01, 3.741E+01, 3.995E+00, 0.000E+00/
      DATA (PH1(I,15, 4, 1),I=1,6) /2.633E+03, 3.790E+02,
     1 3.053E+01, 3.068E+01, 1.885E+00, 0.000E+00/
      DATA (PH1(I,15, 4, 2),I=1,6) /5.604E+02, 5.712E+01,
     1 2.980E+01, 2.988E+01, 4.450E+00, 0.000E+00/
      DATA (PH1(I,15, 5, 1),I=1,6) /2.553E+03, 3.860E+02,
     1 2.914E+01, 2.656E+01, 1.945E+00, 0.000E+00/
      DATA (PH1(I,15, 5, 2),I=1,6) /5.035E+02, 7.791E+01,
     1 2.079E+01, 2.573E+01, 4.191E+00, 0.000E+00/
      DATA (PH1(I,15, 5, 3),I=1,6) /4.796E+02, 7.305E+01,
     1 7.867E+01, 7.330E+01, 3.527E+00, 1.286E-03/
      DATA (PH1(I,15, 6, 1),I=1,6) /2.477E+03, 3.824E+02,
     1 2.955E+01, 2.402E+01, 2.010E+00, 0.000E+00/
      DATA (PH1(I,15, 6, 2),I=1,6) /4.522E+02, 7.664E+01,
     1 1.966E+01, 2.403E+01, 4.317E+00, 0.000E+00/
      DATA (PH1(I,15, 6, 3),I=1,6) /4.245E+02, 6.502E+01,
     1 1.792E+02, 6.744E+01, 3.727E+00, 1.364E-03/
      DATA (PH1(I,15, 7, 1),I=1,6) /2.407E+03, 4.243E+02,
     1 2.277E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,15, 7, 2),I=1,6) /4.018E+02, 6.712E+01,
     1 1.952E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,15, 7, 3),I=1,6) /3.717E+02, 6.437E+01,
     1 2.384E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,15, 8, 1),I=1,6) /2.337E+03, 3.811E+02,
     1 2.964E+01, 2.122E+01, 2.087E+00, 0.000E+00/
      DATA (PH1(I,15, 8, 2),I=1,6) /3.552E+02, 7.217E+01,
     1 1.771E+01, 2.129E+01, 4.617E+00, 0.000E+00/
      DATA (PH1(I,15, 8, 3),I=1,6) /3.094E+02, 5.587E+01,
     1 3.696E+02, 4.738E+01, 4.244E+00, 1.094E-03/
      DATA (PH1(I,15, 9, 1),I=1,6) /2.280E+03, 4.327E+02,
     1 2.146E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,15, 9, 2),I=1,6) /3.098E+02, 7.044E+01,
     1 1.553E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,15, 9, 3),I=1,6) /2.632E+02, 6.819E+01,
     1 2.712E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,15,10, 1),I=1,6) /2.214E+03, 3.828E+02,
     1 2.932E+01, 1.991E+01, 2.123E+00, 0.000E+00/
      DATA (PH1(I,15,10, 2),I=1,6) /2.663E+02, 6.951E+01,
     1 1.560E+01, 1.845E+01, 4.938E+00, 0.000E+00/
      DATA (PH1(I,15,10, 3),I=1,6) /2.204E+02, 6.893E+01,
     1 2.980E+02, 3.497E+01, 4.307E+00, 1.008E-03/
      DATA (PH1(I,15,11, 1),I=1,6) /2.192E+03, 3.423E+02,
     1 3.671E+01, 2.010E+01, 2.232E+00, 0.000E+00/
      DATA (PH1(I,15,11, 2),I=1,6) /2.461E+02, 6.270E+01,
     1 1.535E+01, 2.486E+01, 4.787E+00, 0.000E+00/
      DATA (PH1(I,15,11, 3),I=1,6) /1.977E+02, 6.186E+01,
     1 3.368E+02, 4.700E+01, 4.256E+00, 1.118E-03/
      DATA (PH1(I,15,11, 4),I=1,6) /6.503E+01, 1.526E+00,
     1 3.688E+01, 1.111E+03, 4.890E+00, 0.000E+00/
      DATA (PH1(I,15,12, 1),I=1,6) /2.173E+03, 3.969E+02,
     1 2.640E+01, 2.945E+01, 1.901E+00, 0.000E+00/
      DATA (PH1(I,15,12, 2),I=1,6) /2.280E+02, 6.564E+01,
     1 1.491E+01, 2.333E+01, 4.787E+00, 0.000E+00/
      DATA (PH1(I,15,12, 3),I=1,6) /1.795E+02, 6.946E+01,
     1 2.661E+02, 5.760E+01, 3.967E+00, 4.482E-03/
      DATA (PH1(I,15,12, 4),I=1,6) /5.144E+01, 1.151E+01,
     1 1.153E+01, 2.303E+02, 4.447E+00, 0.000E+00/
      DATA (PH1(I,15,13, 1),I=1,6) /2.157E+03, 5.025E+02,
     1 1.577E+01, 6.163E+01, 1.467E+00, 0.000E+00/
      DATA (PH1(I,15,13, 2),I=1,6) /2.124E+02, 7.708E+01,
     1 1.206E+01, 3.388E+01, 4.192E+00, 0.000E+00/
      DATA (PH1(I,15,13, 3),I=1,6) /1.639E+02, 7.943E+01,
     1 1.949E+02, 1.392E+02, 3.391E+00, 5.039E-03/
      DATA (PH1(I,15,13, 4),I=1,6) /3.828E+01, 1.832E+01,
     1 8.260E+00, 7.058E+02, 3.682E+00, 0.000E+00/
      DATA (PH1(I,15,13, 5),I=1,6) /3.020E+01, 2.401E+01,
     1 2.851E+01, 9.795E+00, 8.210E+00, 3.290E-01/
      DATA (PH1(I,15,14, 1),I=1,6) /2.155E+03, 4.445E+02,
     1 1.990E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,15,14, 2),I=1,6) /1.987E+02, 7.299E+01,
     1 1.328E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,15,14, 3),I=1,6) /1.495E+02, 7.517E+01,
     1 2.347E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,15,14, 4),I=1,6) /2.709E+01, 1.666E+01,
     1 7.930E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,15,14, 5),I=1,6) /1.973E+01, 2.511E+01,
     1 2.564E+01, 1.800E+01, 7.200E+00, 2.600E-01/
      DATA (PH1(I,15,15, 1),I=1,6) /2.154E+03, 6.472E+02,
     1 9.167E+00, 2.562E+02, 1.063E+00, 0.000E+00/
      DATA (PH1(I,15,15, 2),I=1,6) /1.940E+02, 8.632E+01,
     1 9.931E+00, 6.594E+01, 3.617E+00, 0.000E+00/
      DATA (PH1(I,15,15, 3),I=1,6) /1.400E+02, 8.812E+01,
     1 1.512E+02, 2.230E+03, 2.795E+00, 3.422E-04/
      DATA (PH1(I,15,15, 4),I=1,6) /2.017E+01, 1.658E+01,
     1 1.125E+01, 2.613E+01, 5.205E+00, 0.000E+00/
      DATA (PH1(I,15,15, 5),I=1,6) /1.049E+01, 2.580E+01,
     1 9.925E+01, 6.712E+00, 8.516E+00, 2.765E-01/
      DATA (PH1(I,16, 1, 1),I=1,6) /3.494E+03, 1.104E+02,
     1 2.139E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,16, 2, 1),I=1,6) /3.224E+03, 4.390E+02,
     1 2.453E+01, 4.405E+01, 1.765E+00, 0.000E+00/
      DATA (PH1(I,16, 3, 1),I=1,6) /3.107E+03, 4.667E+02,
     1 2.293E+01, 4.459E+01, 1.668E+00, 0.000E+00/
      DATA (PH1(I,16, 3, 2),I=1,6) /7.072E+02, 4.414E+01,
     1 2.178E+01, 4.365E+01, 4.480E+00, 0.000E+00/
      DATA (PH1(I,16, 4, 1),I=1,6) /3.029E+03, 4.669E+02,
     1 2.233E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,16, 4, 2),I=1,6) /6.517E+02, 6.930E+01,
     1 2.571E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,16, 5, 1),I=1,6) /2.941E+03, 4.828E+02,
     1 2.087E+01, 3.742E+01, 1.720E+00, 0.000E+00/
      DATA (PH1(I,16, 5, 2),I=1,6) /5.906E+02, 6.791E+01,
     1 2.451E+01, 2.306E+01, 4.707E+00, 0.000E+00/
      DATA (PH1(I,16, 5, 3),I=1,6) /5.647E+02, 5.542E+01,
     1 1.641E+02, 6.822E+01, 4.000E+00, 4.183E-02/
      DATA (PH1(I,16, 6, 1),I=1,6) /2.859E+03, 4.758E+02,
     1 2.101E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,16, 6, 2),I=1,6) /5.346E+02, 7.360E+01,
     1 2.030E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,16, 6, 3),I=1,6) /5.048E+02, 7.213E+01,
     1 1.689E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,16, 7, 1),I=1,6) /2.782E+03, 4.802E+02,
     1 2.041E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,16, 7, 2),I=1,6) /4.804E+02, 7.555E+01,
     1 1.812E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,16, 7, 3),I=1,6) /4.471E+02, 7.326E+01,
     1 2.213E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,16, 8, 1),I=1,6) /2.705E+03, 4.937E+02,
     1 1.946E+01, 3.568E+01, 1.737E+00, 0.000E+00/
      DATA (PH1(I,16, 8, 2),I=1,6) /4.296E+02, 8.031E+01,
     1 1.659E+01, 2.170E+01, 4.615E+00, 0.000E+00/
      DATA (PH1(I,16, 8, 3),I=1,6) /3.791E+02, 6.911E+01,
     1 2.970E+02, 5.519E+01, 4.011E+00, 2.178E-02/
      DATA (PH1(I,16, 9, 1),I=1,6) /2.641E+03, 4.891E+02,
     1 1.931E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,16, 9, 2),I=1,6) /3.797E+02, 7.905E+01,
     1 1.462E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,16, 9, 3),I=1,6) /3.282E+02, 7.695E+01,
     1 2.615E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,16,10, 1),I=1,6) /2.569E+03, 4.952E+02,
     1 1.916E+01, 3.555E+01, 1.742E+00, 0.000E+00/
      DATA (PH1(I,16,10, 2),I=1,6) /3.321E+02, 8.439E+01,
     1 1.291E+01, 2.335E+01, 4.545E+00, 0.000E+00/
      DATA (PH1(I,16,10, 3),I=1,6) /2.809E+02, 7.813E+01,
     1 2.751E+02, 4.495E+01, 4.110E+00, 2.108E-02/
      DATA (PH1(I,16,11, 1),I=1,6) /2.544E+03, 4.681E+02,
     1 2.148E+01, 4.092E+01, 1.738E+00, 0.000E+00/
      DATA (PH1(I,16,11, 2),I=1,6) /3.094E+02, 6.780E+01,
     1 1.495E+01, 2.519E+01, 4.826E+00, 0.000E+00/
      DATA (PH1(I,16,11, 3),I=1,6) /2.557E+02, 5.747E+01,
     1 4.712E+02, 3.610E+01, 4.742E+00, 2.480E-02/
      DATA (PH1(I,16,11, 4),I=1,6) /8.805E+01, 1.413E+01,
     1 9.139E+00, 1.656E+03, 3.626E+00, 0.000E+00/
      DATA (PH1(I,16,12, 1),I=1,6) /2.522E+03, 4.813E+02,
     1 2.029E+01, 3.854E+01, 1.736E+00, 0.000E+00/
      DATA (PH1(I,16,12, 2),I=1,6) /2.888E+02, 7.355E+01,
     1 1.407E+01, 2.397E+01, 4.754E+00, 0.000E+00/
      DATA (PH1(I,16,12, 3),I=1,6) /2.350E+02, 7.411E+01,
     1 2.919E+02, 4.864E+01, 4.142E+00, 2.785E-02/
      DATA (PH1(I,16,12, 4),I=1,6) /7.268E+01, 1.271E+01,
     1 1.363E+01, 2.570E+02, 4.361E+00, 0.000E+00/
      DATA (PH1(I,16,13, 1),I=1,6) /2.502E+03, 5.523E+02,
     1 1.504E+01, 5.527E+01, 1.517E+00, 0.000E+00/
      DATA (PH1(I,16,13, 2),I=1,6) /2.703E+02, 8.665E+01,
     1 1.155E+01, 3.202E+01, 4.227E+00, 0.000E+00/
      DATA (PH1(I,16,13, 3),I=1,6) /2.164E+02, 8.744E+01,
     1 2.037E+02, 9.310E+01, 3.565E+00, 9.497E-03/
      DATA (PH1(I,16,13, 4),I=1,6) /5.750E+01, 2.143E+01,
     1 9.080E+00, 7.224E+02, 3.618E+00, 0.000E+00/
      DATA (PH1(I,16,13, 5),I=1,6) /4.731E+01, 3.325E+01,
     1 1.099E+01, 3.639E+01, 5.977E+00, 3.761E-01/
      DATA (PH1(I,16,14, 1),I=1,6) /2.486E+03, 6.434E+02,
     1 1.082E+01, 1.410E+02, 1.221E+00, 0.000E+00/
      DATA (PH1(I,16,14, 2),I=1,6) /2.536E+02, 9.233E+01,
     1 1.048E+01, 4.007E+01, 3.968E+00, 0.000E+00/
      DATA (PH1(I,16,14, 3),I=1,6) /1.995E+02, 9.246E+01,
     1 1.780E+02, 1.498E+02, 3.319E+00, 2.142E-02/
      DATA (PH1(I,16,14, 4),I=1,6) /4.415E+01, 2.175E+01,
     1 8.208E+00, 7.941E+02, 3.591E+00, 0.000E+00/
      DATA (PH1(I,16,14, 5),I=1,6) /3.483E+01, 2.934E+01,
     1 3.702E+01, 1.445E+01, 7.321E+00, 2.989E-01/
      DATA (PH1(I,16,15, 1),I=1,6) /2.478E+03, 7.306E+02,
     1 8.303E+00, 7.483E+02, 9.844E-01, 0.000E+00/
      DATA (PH1(I,16,15, 2),I=1,6) /2.387E+02, 9.694E+01,
     1 9.659E+00, 5.188E+01, 3.738E+00, 0.000E+00/
      DATA (PH1(I,16,15, 3),I=1,6) /1.846E+02, 9.058E+01,
     1 1.896E+02, 7.538E+01, 3.635E+00, 2.934E-01/
      DATA (PH1(I,16,15, 4),I=1,6) /3.190E+01, 2.047E+01,
     1 7.824E+00, 2.396E+02, 3.950E+00, 0.000E+00/
      DATA (PH1(I,16,15, 5),I=1,6) /2.333E+01, 2.890E+01,
     1 1.054E+02, 7.474E+00, 8.421E+00, 2.840E-01/
      DATA (PH1(I,16,16, 1),I=1,6) /2.477E+03, 8.114E+02,
     1 6.649E+00, 3.734E+03, 8.646E-01, 0.000E+00/
      DATA (PH1(I,16,16, 2),I=1,6) /2.350E+02, 1.047E+02,
     1 8.520E+00, 9.469E+01, 3.346E+00, 0.000E+00/
      DATA (PH1(I,16,16, 3),I=1,6) /1.700E+02, 9.152E+01,
     1 1.883E+02, 7.193E+01, 3.633E+00, 2.485E-01/
      DATA (PH1(I,16,16, 4),I=1,6) /2.130E+01, 1.916E+01,
     1 1.003E+01, 3.296E+01, 5.038E+00, 0.000E+00/
      DATA (PH1(I,16,16, 5),I=1,6) /1.036E+01, 2.975E+01,
     1 5.644E+01, 1.321E+01, 7.513E+00, 2.621E-01/
      DATA (PH1(I,17, 1, 1),I=1,6) /3.946E+03, 1.247E+02,
     1 1.894E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,17, 2, 1),I=1,6) /3.659E+03, 4.174E+02,
     1 3.143E+01, 3.162E+01, 2.037E+00, 0.000E+00/
      DATA (PH1(I,17, 3, 1),I=1,6) /3.534E+03, 4.432E+02,
     1 2.956E+01, 3.058E+01, 1.953E+00, 0.000E+00/
      DATA (PH1(I,17, 3, 2),I=1,6) /8.094E+02, 7.444E+01,
     1 1.356E+01, 3.797E+01, 4.103E+00, 0.000E+00/
      DATA (PH1(I,17, 4, 1),I=1,6) /3.448E+03, 4.473E+02,
     1 2.878E+01, 2.772E+01, 1.999E+00, 0.000E+00/
      DATA (PH1(I,17, 4, 2),I=1,6) /7.498E+02, 7.310E+01,
     1 2.449E+01, 3.044E+01, 4.421E+00, 0.000E+00/
      DATA (PH1(I,17, 5, 1),I=1,6) /3.356E+03, 4.633E+02,
     1 2.651E+01, 2.523E+01, 2.025E+00, 0.000E+00/
      DATA (PH1(I,17, 5, 2),I=1,6) /6.846E+02, 1.049E+02,
     1 1.622E+01, 2.683E+01, 4.067E+00, 0.000E+00/
      DATA (PH1(I,17, 5, 3),I=1,6) /6.567E+02, 3.905E+01,
     1 3.845E+02, 8.984E+01, 4.272E+00, 3.017E-01/
      DATA (PH1(I,17, 6, 1),I=1,6) /3.266E+03, 4.610E+02,
     1 2.666E+01, 2.298E+01, 2.085E+00, 0.000E+00/
      DATA (PH1(I,17, 6, 2),I=1,6) /6.249E+02, 9.701E+01,
     1 1.646E+01, 2.531E+01, 4.266E+00, 0.000E+00/
      DATA (PH1(I,17, 6, 3),I=1,6) /5.920E+02, 7.621E+01,
     1 1.831E+02, 6.513E+01, 3.852E+00, 3.987E-01/
      DATA (PH1(I,17, 7, 1),I=1,6) /3.184E+03, 5.397E+02,
     1 1.840E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,17, 7, 2),I=1,6) /5.660E+02, 8.450E+01,
     1 1.684E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,17, 7, 3),I=1,6) /5.293E+02, 8.280E+01,
     1 2.053E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,17, 8, 1),I=1,6) /3.100E+03, 4.593E+02,
     1 2.668E+01, 2.099E+01, 2.148E+00, 0.000E+00/
      DATA (PH1(I,17, 8, 2),I=1,6) /5.109E+02, 9.134E+01,
     1 1.502E+01, 2.321E+01, 4.515E+00, 0.000E+00/
      DATA (PH1(I,17, 8, 3),I=1,6) /4.556E+02, 8.470E+01,
     1 2.378E+02, 5.655E+01, 3.889E+00, 3.329E-01/
      DATA (PH1(I,17, 9, 1),I=1,6) /3.030E+03, 5.491E+02,
     1 1.746E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,17, 9, 2),I=1,6) /4.565E+02, 8.818E+01,
     1 1.375E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,17, 9, 3),I=1,6) /4.001E+02, 8.635E+01,
     1 2.505E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,17,10, 1),I=1,6) /2.951E+03, 4.603E+02,
     1 2.645E+01, 1.991E+01, 2.182E+00, 0.000E+00/
      DATA (PH1(I,17,10, 2),I=1,6) /4.048E+02, 8.397E+01,
     1 1.392E+01, 2.002E+01, 4.904E+00, 0.000E+00/
      DATA (PH1(I,17,10, 3),I=1,6) /3.483E+02, 8.434E+01,
     1 2.880E+02, 4.019E+01, 4.242E+00, 2.672E-01/
      DATA (PH1(I,17,11, 1),I=1,6) /2.923E+03, 4.414E+02,
     1 2.836E+01, 2.402E+01, 2.121E+00, 0.000E+00/
      DATA (PH1(I,17,11, 2),I=1,6) /3.797E+02, 6.106E+01,
     1 1.676E+01, 2.195E+01, 5.347E+00, 0.000E+00/
      DATA (PH1(I,17,11, 3),I=1,6) /3.207E+02, 6.471E+01,
     1 4.512E+02, 3.950E+01, 4.637E+00, 2.356E-01/
      DATA (PH1(I,17,11, 4),I=1,6) /1.142E+02, 1.534E+00,
     1 6.782E+01, 1.497E+03, 4.756E+00, 0.000E+00/
      DATA (PH1(I,17,12, 1),I=1,6) /2.898E+03, 5.111E+02,
     1 2.068E+01, 3.167E+01, 1.860E+00, 0.000E+00/
      DATA (PH1(I,17,12, 2),I=1,6) /3.566E+02, 7.233E+01,
     1 1.520E+01, 2.042E+01, 5.148E+00, 0.000E+00/
      DATA (PH1(I,17,12, 3),I=1,6) /2.974E+02, 7.682E+01,
     1 3.345E+02, 3.803E+01, 4.431E+00, 2.396E-01/
      DATA (PH1(I,17,12, 4),I=1,6) /9.703E+01, 8.603E+00,
     1 2.080E+01, 2.738E+02, 4.689E+00, 0.000E+00/
      DATA (PH1(I,17,13, 1),I=1,6) /2.875E+03, 6.130E+02,
     1 1.391E+01, 5.524E+01, 1.527E+00, 0.000E+00/
      DATA (PH1(I,17,13, 2),I=1,6) /3.354E+02, 8.204E+01,
     1 1.391E+01, 2.025E+01, 4.934E+00, 0.000E+00/
      DATA (PH1(I,17,13, 3),I=1,6) /2.760E+02, 8.644E+01,
     1 2.701E+02, 3.890E+01, 4.239E+00, 2.462E-01/
      DATA (PH1(I,17,13, 4),I=1,6) /7.997E+01, 1.825E+01,
     1 1.148E+01, 1.976E+02, 4.245E+00, 0.000E+00/
      DATA (PH1(I,17,13, 5),I=1,6) /6.782E+01, 3.654E+01,
     1 1.195E+01, 3.759E+01, 6.009E+00, 4.036E-01/
      DATA (PH1(I,17,14, 1),I=1,6) /2.851E+03, 5.520E+02,
     1 1.713E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,17,14, 2),I=1,6) /3.151E+02, 9.076E+01,
     1 1.198E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,17,14, 3),I=1,6) /2.552E+02, 9.562E+01,
     1 2.144E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,17,14, 4),I=1,6) /6.470E+01, 2.019E+01,
     1 9.833E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,17,14, 5),I=1,6) /5.347E+01, 3.505E+01,
     1 2.148E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,17,15, 1),I=1,6) /2.838E+03, 7.650E+02,
     1 8.653E+00, 2.714E+02, 1.105E+00, 0.000E+00/
      DATA (PH1(I,17,15, 2),I=1,6) /2.979E+02, 9.151E+01,
     1 1.265E+01, 2.088E+01, 4.703E+00, 0.000E+00/
      DATA (PH1(I,17,15, 3),I=1,6) /2.382E+02, 9.580E+01,
     1 2.222E+02, 4.214E+01, 4.019E+00, 2.237E-01/
      DATA (PH1(I,17,15, 4),I=1,6) /5.019E+01, 2.307E+01,
     1 8.302E+00, 2.450E+02, 3.950E+00, 0.000E+00/
      DATA (PH1(I,17,15, 5),I=1,6) /3.961E+01, 3.460E+01,
     1 3.044E+01, 3.383E+01, 6.261E+00, 2.707E-01/
      DATA (PH1(I,17,16, 1),I=1,6) /2.832E+03, 5.619E+02,
     1 1.634E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,17,16, 2),I=1,6) /2.837E+02, 9.168E+01,
     1 1.167E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,17,16, 3),I=1,6) /2.236E+02, 9.695E+01,
     1 2.052E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,17,16, 4),I=1,6) /3.686E+01, 2.191E+01,
     1 7.493E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,17,16, 5),I=1,6) /2.381E+01, 3.339E+01,
     1 4.993E+01, 1.800E+01, 7.200E+00, 2.600E-01/
      DATA (PH1(I,17,17, 1),I=1,6) /2.830E+03, 9.700E+02,
     1 5.255E+00, 1.856E+06, 7.888E-01, 0.000E+00/
      DATA (PH1(I,17,17, 2),I=1,6) /2.780E+02, 1.092E+02,
     1 1.059E+01, 2.491E+01, 4.205E+00, 0.000E+00/
      DATA (PH1(I,17,17, 3),I=1,6) /2.090E+02, 8.004E+01,
     1 3.053E+02, 3.498E+01, 4.457E+00, 2.017E-01/
      DATA (PH1(I,17,17, 4),I=1,6) /2.531E+01, 2.231E+01,
     1 6.628E+00, 1.843E+02, 4.196E+00, 0.000E+00/
      DATA (PH1(I,17,17, 5),I=1,6) /1.297E+01, 3.398E+01,
     1 4.539E+01, 2.232E+01, 6.896E+00, 2.479E-01/
      DATA (PH1(I,18, 1, 1),I=1,6) /4.426E+03, 1.399E+02,
     1 1.690E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,18, 2, 1),I=1,6) /4.121E+03, 4.468E+02,
     1 3.108E+01, 3.039E+01, 2.092E+00, 0.000E+00/
      DATA (PH1(I,18, 3, 1),I=1,6) /3.988E+03, 4.680E+02,
     1 3.003E+01, 2.854E+01, 2.037E+00, 0.000E+00/
      DATA (PH1(I,18, 3, 2),I=1,6) /9.180E+02, 5.440E+01,
     1 1.838E+01, 4.656E+01, 4.439E+00, 0.000E+00/
      DATA (PH1(I,18, 4, 1),I=1,6) /3.898E+03, 4.756E+02,
     1 2.883E+01, 2.615E+01, 2.074E+00, 0.000E+00/
      DATA (PH1(I,18, 4, 2),I=1,6) /8.548E+02, 8.162E+01,
     1 2.235E+01, 3.057E+01, 4.418E+00, 0.000E+00/
      DATA (PH1(I,18, 5, 1),I=1,6) /3.798E+03, 4.749E+02,
     1 2.874E+01, 2.235E+01, 2.171E+00, 0.000E+00/
      DATA (PH1(I,18, 5, 2),I=1,6) /7.856E+02, 1.086E+02,
     1 1.606E+01, 2.688E+01, 4.173E+00, 0.000E+00/
      DATA (PH1(I,18, 5, 3),I=1,6) /7.558E+02, 8.270E+01,
     1 1.006E+02, 7.201E+01, 3.789E+00, 5.509E-03/
      DATA (PH1(I,18, 6, 1),I=1,6) /3.702E+03, 4.731E+02,
     1 2.888E+01, 2.042E+01, 2.234E+00, 0.000E+00/
      DATA (PH1(I,18, 6, 2),I=1,6) /7.217E+02, 1.081E+02,
     1 1.515E+01, 2.572E+01, 4.251E+00, 0.000E+00/
      DATA (PH1(I,18, 6, 3),I=1,6) /6.861E+02, 5.722E+01,
     1 3.784E+02, 7.663E+01, 4.151E+00, 1.194E-02/
      DATA (PH1(I,18, 7, 1),I=1,6) /3.613E+03, 6.028E+02,
     1 1.666E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,18, 7, 2),I=1,6) /6.584E+02, 9.398E+01,
     1 1.567E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,18, 7, 3),I=1,6) /6.183E+02, 9.297E+01,
     1 1.904E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,18, 8, 1),I=1,6) /3.523E+03, 4.789E+02,
     1 2.796E+01, 1.917E+01, 2.271E+00, 0.000E+00/
      DATA (PH1(I,18, 8, 2),I=1,6) /5.992E+02, 9.884E+01,
     1 1.431E+01, 2.351E+01, 4.545E+00, 0.000E+00/
      DATA (PH1(I,18, 8, 3),I=1,6) /5.390E+02, 7.562E+01,
     1 3.466E+02, 5.329E+01, 4.195E+00, 1.392E-02/
      DATA (PH1(I,18, 9, 1),I=1,6) /3.446E+03, 6.126E+02,
     1 1.585E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,18, 9, 2),I=1,6) /5.403E+02, 9.783E+01,
     1 1.294E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,18, 9, 3),I=1,6) /4.787E+02, 9.639E+01,
     1 2.389E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,18,10, 1),I=1,6) /3.361E+03, 4.679E+02,
     1 2.931E+01, 1.744E+01, 2.362E+00, 0.000E+00/
      DATA (PH1(I,18,10, 2),I=1,6) /4.845E+02, 9.273E+01,
     1 1.306E+01, 2.086E+01, 4.862E+00, 0.000E+00/
      DATA (PH1(I,18,10, 3),I=1,6) /4.225E+02, 9.230E+01,
     1 2.855E+02, 4.508E+01, 4.165E+00, 8.883E-03/
      DATA (PH1(I,18,11, 1),I=1,6) /3.331E+03, 4.486E+02,
     1 3.143E+01, 2.008E+01, 2.315E+00, 0.000E+00/
      DATA (PH1(I,18,11, 2),I=1,6) /4.570E+02, 6.529E+01,
     1 1.602E+01, 2.336E+01, 5.323E+00, 0.000E+00/
      DATA (PH1(I,18,11, 3),I=1,6) /3.925E+02, 7.368E+01,
     1 4.198E+02, 4.419E+01, 4.492E+00, 7.712E-03/
      DATA (PH1(I,18,11, 4),I=1,6) /1.435E+02, 3.884E+00,
     1 3.295E+01, 7.082E+02, 4.645E+00, 0.000E+00/
      DATA (PH1(I,18,12, 1),I=1,6) /3.303E+03, 6.199E+02,
     1 1.559E+01, 4.503E+01, 1.664E+00, 0.000E+00/
      DATA (PH1(I,18,12, 2),I=1,6) /4.314E+02, 8.000E+01,
     1 1.424E+01, 2.136E+01, 5.094E+00, 0.000E+00/
      DATA (PH1(I,18,12, 3),I=1,6) /3.667E+02, 8.563E+01,
     1 3.204E+02, 4.230E+01, 4.329E+00, 7.258E-03/
      DATA (PH1(I,18,12, 4),I=1,6) /1.243E+02, 8.091E+00,
     1 2.596E+01, 3.212E+02, 4.685E+00, 0.000E+00/
      DATA (PH1(I,18,13, 1),I=1,6) /3.277E+03, 6.427E+02,
     1 1.444E+01, 4.208E+01, 1.659E+00, 0.000E+00/
      DATA (PH1(I,18,13, 2),I=1,6) /4.076E+02, 8.974E+01,
     1 1.313E+01, 2.094E+01, 4.919E+00, 0.000E+00/
      DATA (PH1(I,18,13, 3),I=1,6) /3.426E+02, 9.233E+01,
     1 2.786E+02, 4.220E+01, 4.227E+00, 7.408E-03/
      DATA (PH1(I,18,13, 4),I=1,6) /1.056E+02, 1.839E+01,
     1 1.304E+01, 2.002E+02, 4.303E+00, 0.000E+00/
      DATA (PH1(I,18,13, 5),I=1,6) /9.101E+01, 3.564E+01,
     1 1.418E+01, 3.945E+01, 6.194E+00, 7.398E-02/
      DATA (PH1(I,18,14, 1),I=1,6) /3.253E+03, 6.819E+02,
     1 1.269E+01, 4.958E+01, 1.562E+00, 0.000E+00/
      DATA (PH1(I,18,14, 2),I=1,6) /3.852E+02, 9.393E+01,
     1 1.265E+01, 2.082E+01, 4.848E+00, 0.000E+00/
      DATA (PH1(I,18,14, 3),I=1,6) /3.200E+02, 9.835E+01,
     1 2.474E+02, 4.284E+01, 4.125E+00, 7.283E-03/
      DATA (PH1(I,18,14, 4),I=1,6) /8.828E+01, 2.249E+01,
     1 1.048E+01, 2.022E+02, 4.127E+00, 0.000E+00/
      DATA (PH1(I,18,14, 5),I=1,6) /7.502E+01, 3.732E+01,
     1 2.476E+01, 3.876E+01, 6.142E+00, 1.882E-01/
      DATA (PH1(I,18,15, 1),I=1,6) /3.228E+03, 6.171E+02,
     1 1.548E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,18,15, 2),I=1,6) /3.642E+02, 1.010E+02,
     1 1.120E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,18,15, 3),I=1,6) /2.987E+02, 1.073E+02,
     1 2.007E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,18,15, 4),I=1,6) /7.174E+01, 2.269E+01,
     1 9.306E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,18,15, 5),I=1,6) /5.981E+01, 3.958E+01,
     1 3.058E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,18,16, 1),I=1,6) /3.216E+03, 8.408E+02,
     1 8.071E+00, 1.847E+02, 1.160E+00, 0.000E+00/
      DATA (PH1(I,18,16, 2),I=1,6) /3.455E+02, 1.031E+02,
     1 1.164E+01, 2.134E+01, 4.657E+00, 0.000E+00/
      DATA (PH1(I,18,16, 3),I=1,6) /2.801E+02, 1.025E+02,
     1 2.281E+02, 4.380E+01, 4.046E+00, 7.167E-03/
      DATA (PH1(I,18,16, 4),I=1,6) /5.637E+01, 2.612E+01,
     1 7.899E+00, 2.318E+02, 3.961E+00, 0.000E+00/
      DATA (PH1(I,18,16, 5),I=1,6) /4.074E+01, 3.862E+01,
     1 3.973E+01, 3.208E+01, 6.347E+00, 2.643E-01/
      DATA (PH1(I,18,17, 1),I=1,6) /3.208E+03, 6.260E+02,
     1 1.489E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,18,17, 2),I=1,6) /3.317E+02, 1.018E+02,
     1 1.096E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,18,17, 3),I=1,6) /2.662E+02, 1.085E+02,
     1 1.937E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,18,17, 4),I=1,6) /4.198E+01, 2.473E+01,
     1 7.104E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,18,17, 5),I=1,6) /2.763E+01, 3.780E+01,
     1 6.006E+01, 1.800E+01, 7.200E+00, 2.600E-01/
      DATA (PH1(I,18,18, 1),I=1,6) /3.203E+03, 1.135E+03,
     1 4.280E+00, 3.285E+07, 7.631E-01, 0.000E+00/
      DATA (PH1(I,18,18, 2),I=1,6) /3.260E+02, 1.302E+02,
     1 9.185E+00, 2.693E+01, 4.021E+00, 0.000E+00/
      DATA (PH1(I,18,18, 3),I=1,6) /2.492E+02, 1.647E+02,
     1 8.372E+01, 5.452E+01, 3.328E+00, 6.270E-01/
      DATA (PH1(I,18,18, 4),I=1,6) /2.892E+01, 2.525E+01,
     1 6.394E+00, 1.700E+02, 4.223E+00, 0.000E+00/
      DATA (PH1(I,18,18, 5),I=1,6) /1.576E+01, 3.854E+01,
     1 4.872E+01, 2.640E+01, 6.662E+00, 2.355E-01/
      DATA (PH1(I,19, 1, 1),I=1,6) /4.934E+03, 1.559E+02,
     1 1.517E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,19, 2, 1),I=1,6) /4.611E+03, 5.177E+02,
     1 2.589E+01, 3.282E+01, 2.018E+00, 0.000E+00/
      DATA (PH1(I,19, 3, 1),I=1,6) /4.471E+03, 5.376E+02,
     1 2.534E+01, 3.129E+01, 1.966E+00, 0.000E+00/
      DATA (PH1(I,19, 3, 2),I=1,6) /1.035E+03, 1.155E+02,
     1 8.875E+00, 3.732E+01, 3.844E+00, 0.000E+00/
      DATA (PH1(I,19, 4, 1),I=1,6) /4.375E+03, 5.442E+02,
     1 2.451E+01, 2.858E+01, 2.005E+00, 0.000E+00/
      DATA (PH1(I,19, 4, 2),I=1,6) /9.680E+02, 8.979E+01,
     1 2.067E+01, 3.141E+01, 4.401E+00, 0.000E+00/
      DATA (PH1(I,19, 5, 1),I=1,6) /4.269E+03, 5.279E+02,
     1 2.596E+01, 2.351E+01, 2.144E+00, 0.000E+00/
      DATA (PH1(I,19, 5, 2),I=1,6) /8.935E+02, 1.199E+02,
     1 1.483E+01, 2.724E+01, 4.169E+00, 0.000E+00/
      DATA (PH1(I,19, 5, 3),I=1,6) /8.611E+02, 9.596E+01,
     1 7.963E+01, 6.368E+01, 3.884E+00, 1.487E+00/
      DATA (PH1(I,19, 6, 1),I=1,6) /4.166E+03, 5.297E+02,
     1 2.562E+01, 2.213E+01, 2.182E+00, 0.000E+00/
      DATA (PH1(I,19, 6, 2),I=1,6) /8.255E+02, 1.179E+02,
     1 1.420E+01, 2.609E+01, 4.262E+00, 0.000E+00/
      DATA (PH1(I,19, 6, 3),I=1,6) /7.867E+02, 1.054E+02,
     1 1.244E+02, 6.541E+01, 3.764E+00, 9.280E-01/
      DATA (PH1(I,19, 7, 1),I=1,6) /4.070E+03, 6.694E+02,
     1 1.515E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,19, 7, 2),I=1,6) /7.578E+02, 1.040E+02,
     1 1.460E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,19, 7, 3),I=1,6) /7.147E+02, 1.038E+02,
     1 1.768E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,19, 8, 1),I=1,6) /3.974E+03, 5.204E+02,
     1 2.646E+01, 1.958E+01, 2.282E+00, 0.000E+00/
      DATA (PH1(I,19, 8, 2),I=1,6) /6.945E+02, 1.112E+02,
     1 1.306E+01, 2.458E+01, 4.472E+00, 0.000E+00/
      DATA (PH1(I,19, 8, 3),I=1,6) /6.295E+02, 1.376E+02,
     1 1.164E+02, 5.816E+01, 3.609E+00, 8.872E-01/
      DATA (PH1(I,19, 9, 1),I=1,6) /3.890E+03, 6.796E+02,
     1 1.446E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,19, 9, 2),I=1,6) /6.310E+02, 1.080E+02,
     1 1.218E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,19, 9, 3),I=1,6) /5.647E+02, 1.071E+02,
     1 2.272E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,19,10, 1),I=1,6) /3.799E+03, 5.158E+02,
     1 2.685E+01, 1.837E+01, 2.338E+00, 0.000E+00/
      DATA (PH1(I,19,10, 2),I=1,6) /5.712E+02, 1.100E+02,
     1 1.119E+01, 2.456E+01, 4.565E+00, 0.000E+00/
      DATA (PH1(I,19,10, 3),I=1,6) /5.038E+02, 1.558E+02,
     1 1.104E+02, 5.635E+01, 3.554E+00, 7.774E-01/
      DATA (PH1(I,19,11, 1),I=1,6) /3.766E+03, 5.034E+02,
     1 2.785E+01, 2.112E+01, 2.275E+00, 0.000E+00/
      DATA (PH1(I,19,11, 2),I=1,6) /5.413E+02, 8.084E+01,
     1 1.395E+01, 2.604E+01, 4.988E+00, 0.000E+00/
      DATA (PH1(I,19,11, 3),I=1,6) /4.713E+02, 1.737E+02,
     1 8.545E+01, 4.865E+01, 3.547E+00, 8.892E-01/
      DATA (PH1(I,19,11, 4),I=1,6) /1.758E+02, 1.352E+01,
     1 1.538E+01, 7.752E+02, 3.884E+00, 0.000E+00/
      DATA (PH1(I,19,12, 1),I=1,6) /3.735E+03, 6.944E+02,
     1 1.389E+01, 4.826E+01, 1.635E+00, 0.000E+00/
      DATA (PH1(I,19,12, 2),I=1,6) /5.133E+02, 1.060E+02,
     1 1.113E+01, 2.784E+01, 4.499E+00, 0.000E+00/
      DATA (PH1(I,19,12, 3),I=1,6) /4.430E+02, 1.414E+02,
     1 1.332E+02, 5.593E+01, 3.674E+00, 7.309E-01/
      DATA (PH1(I,19,12, 4),I=1,6) /1.547E+02, 1.930E+01,
     1 1.619E+01, 3.223E+02, 4.079E+00, 0.000E+00/
      DATA (PH1(I,19,13, 1),I=1,6) /3.706E+03, 7.193E+02,
     1 1.288E+01, 4.554E+01, 1.628E+00, 0.000E+00/
      DATA (PH1(I,19,13, 2),I=1,6) /4.868E+02, 1.155E+02,
     1 1.017E+01, 2.932E+01, 4.325E+00, 0.000E+00/
      DATA (PH1(I,19,13, 3),I=1,6) /4.162E+02, 1.360E+02,
     1 1.449E+02, 5.618E+01, 3.706E+00, 6.504E-01/
      DATA (PH1(I,19,13, 4),I=1,6) /1.344E+02, 3.470E+01,
     1 9.467E+00, 1.032E+03, 3.365E+00, 0.000E+00/
      DATA (PH1(I,19,13, 5),I=1,6) /1.176E+02, 4.576E+01,
     1 1.153E+01, 6.308E+01, 5.520E+00, 2.470E-01/
      DATA (PH1(I,19,14, 1),I=1,6) /3.679E+03, 8.147E+02,
     1 9.835E+00, 9.408E+01, 1.355E+00, 0.000E+00/
      DATA (PH1(I,19,14, 2),I=1,6) /4.618E+02, 1.184E+02,
     1 9.849E+00, 2.972E+01, 4.280E+00, 0.000E+00/
      DATA (PH1(I,19,14, 3),I=1,6) /3.909E+02, 2.054E+02,
     1 5.562E+01, 1.347E+04, 2.349E+00, 5.284E-01/
      DATA (PH1(I,19,14, 4),I=1,6) /1.152E+02, 3.602E+01,
     1 8.591E+00, 2.262E+03, 3.242E+00, 0.000E+00/
      DATA (PH1(I,19,14, 5),I=1,6) /9.944E+01, 5.453E+01,
     1 1.638E+01, 9.114E+01, 5.035E+00, 4.138E-01/
      DATA (PH1(I,19,15, 1),I=1,6) /3.651E+03, 6.817E+02,
     1 1.428E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,19,15, 2),I=1,6) /4.374E+02, 1.113E+02,
     1 1.061E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,19,15, 3),I=1,6) /3.665E+02, 1.188E+02,
     1 1.922E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,19,15, 4),I=1,6) /9.657E+01, 2.466E+01,
     1 9.855E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,19,15, 5),I=1,6) /8.266E+01, 4.382E+01,
     1 3.214E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,19,16, 1),I=1,6) /3.633E+03, 8.442E+02,
     1 9.086E+00, 8.929E+01, 1.343E+00, 0.000E+00/
      DATA (PH1(I,19,16, 2),I=1,6) /4.165E+02, 1.249E+02,
     1 9.136E+00, 3.259E+01, 4.130E+00, 0.000E+00/
      DATA (PH1(I,19,16, 3),I=1,6) /3.452E+02, 1.876E+02,
     1 6.770E+01, 1.658E+07, 2.363E+00, 4.546E-01/
      DATA (PH1(I,19,16, 4),I=1,6) /7.925E+01, 3.296E+01,
     1 7.619E+00, 1.323E+03, 3.423E+00, 0.000E+00/
      DATA (PH1(I,19,16, 5),I=1,6) /6.091E+01, 4.791E+01,
     1 3.344E+01, 5.426E+01, 5.626E+00, 3.140E-01/
      DATA (PH1(I,19,17, 1),I=1,6) /3.623E+03, 6.897E+02,
     1 1.383E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,19,17, 2),I=1,6) /3.990E+02, 1.121E+02,
     1 1.039E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,19,17, 3),I=1,6) /3.279E+02, 1.199E+02,
     1 1.862E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,19,17, 4),I=1,6) /6.269E+01, 2.670E+01,
     1 7.455E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,19,17, 5),I=1,6) /4.581E+01, 4.055E+01,
     1 6.784E+01, 1.800E+01, 7.200E+00, 2.600E-01/
      DATA (PH1(I,19,18, 1),I=1,6) /3.617E+03, 1.103E+03,
     1 5.173E+00, 2.564E+03, 8.917E-01, 0.000E+00/
      DATA (PH1(I,19,18, 2),I=1,6) /3.867E+02, 1.488E+02,
     1 7.085E+00, 6.561E+01, 3.449E+00, 0.000E+00/
      DATA (PH1(I,19,18, 3),I=1,6) /3.067E+02, 2.286E+02,
     1 4.199E+01, 8.731E+06, 2.239E+00, 5.560E-01/
      DATA (PH1(I,19,18, 4),I=1,6) /4.728E+01, 2.985E+01,
     1 6.625E+00, 3.001E+02, 3.891E+00, 0.000E+00/
      DATA (PH1(I,19,18, 5),I=1,6) /3.163E+01, 4.195E+01,
     1 7.392E+01, 1.697E+01, 7.208E+00, 2.531E-01/
      DATA (PH1(I,19,19, 1),I=1,6) /3.614E+03, 1.171E+03,
     1 4.540E+00, 6.165E+03, 8.392E-01, 0.000E+00/
      DATA (PH1(I,19,19, 2),I=1,6) /3.843E+02, 1.602E+02,
     1 6.389E+00, 1.044E+02, 3.159E+00, 0.000E+00/
      DATA (PH1(I,19,19, 3),I=1,6) /3.014E+02, 2.666E+02,
     1 3.107E+01, 7.187E+06, 2.067E+00, 5.274E-01/
      DATA (PH1(I,19,19, 4),I=1,6) /4.080E+01, 2.910E+01,
     1 6.377E+00, 2.229E+03, 3.587E+00, 0.000E+00/
      DATA (PH1(I,19,19, 5),I=1,6) /2.466E+01, 4.138E+01,
     1 2.614E+01, 2.143E+02, 5.631E+00, 2.437E-01/
      DATA (PH1(I,19,19, 6),I=1,6) /1.000E+00, 1.000E+00,
     1 0.000E+00, 1.000E+00, 1.000E+00, 1.000E+00/
      DATA (PH1(I,19,19, 7),I=1,6) /4.341E+00, 3.824E+00,
     1 7.363E-01, 2.410E+07, 4.427E+00, 2.049E-04/
      DATA (PH1(I,20, 1, 1),I=1,6) /5.470E+03, 1.729E+02,
     1 1.369E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,20, 2, 1),I=1,6) /5.129E+03, 6.297E+02,
     1 1.936E+01, 3.921E+01, 1.862E+00, 0.000E+00/
      DATA (PH1(I,20, 3, 1),I=1,6) /4.982E+03, 6.640E+02,
     1 1.820E+01, 3.979E+01, 1.777E+00, 0.000E+00/
      DATA (PH1(I,20, 3, 2),I=1,6) /1.157E+03, 9.395E+01,
     1 1.115E+01, 3.959E+01, 4.176E+00, 0.000E+00/
      DATA (PH1(I,20, 4, 1),I=1,6) /4.880E+03, 7.235E+02,
     1 1.486E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,20, 4, 2),I=1,6) /1.087E+03, 1.072E+02,
     1 1.788E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,20, 5, 1),I=1,6) /4.767E+03, 6.862E+02,
     1 1.665E+01, 3.443E+01, 1.823E+00, 0.000E+00/
      DATA (PH1(I,20, 5, 2),I=1,6) /1.008E+03, 1.169E+02,
     1 1.552E+01, 2.618E+01, 4.389E+00, 0.000E+00/
      DATA (PH1(I,20, 5, 3),I=1,6) /9.745E+02, 4.041E+01,
     1 5.215E+02, 1.044E+02, 4.452E+00, 1.164E-05/
      DATA (PH1(I,20, 6, 1),I=1,6) /4.659E+03, 7.342E+02,
     1 1.417E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,20, 6, 2),I=1,6) /9.357E+02, 1.122E+02,
     1 1.490E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,20, 6, 3),I=1,6) /8.946E+02, 1.144E+02,
     1 1.199E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,20, 7, 1),I=1,6) /4.555E+03, 7.396E+02,
     1 1.384E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,20, 7, 2),I=1,6) /8.642E+02, 1.145E+02,
     1 1.363E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,20, 7, 3),I=1,6) /8.177E+02, 1.152E+02,
     1 1.643E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,20, 8, 1),I=1,6) /4.453E+03, 6.989E+02,
     1 1.570E+01, 3.218E+01, 1.851E+00, 0.000E+00/
      DATA (PH1(I,20, 8, 2),I=1,6) /7.968E+02, 1.154E+02,
     1 1.287E+01, 2.461E+01, 4.561E+00, 0.000E+00/
      DATA (PH1(I,20, 8, 3),I=1,6) /7.267E+02, 8.942E+01,
     1 3.336E+02, 5.766E+01, 4.171E+00, 1.104E-05/
      DATA (PH1(I,20, 9, 1),I=1,6) /4.362E+03, 7.503E+02,
     1 1.324E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,20, 9, 2),I=1,6) /7.287E+02, 1.187E+02,
     1 1.147E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,20, 9, 3),I=1,6) /6.572E+02, 1.184E+02,
     1 2.157E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,20,10, 1),I=1,6) /4.265E+03, 7.010E+02,
     1 1.547E+01, 3.197E+01, 1.858E+00, 0.000E+00/
      DATA (PH1(I,20,10, 2),I=1,6) /6.649E+02, 9.384E+01,
     1 1.413E+01, 1.780E+01, 5.361E+00, 0.000E+00/
      DATA (PH1(I,20,10, 3),I=1,6) /5.919E+02, 7.052E+01,
     1 5.909E+02, 4.129E+01, 4.878E+00, 7.117E-06/
      DATA (PH1(I,20,11, 1),I=1,6) /4.229E+03, 6.805E+02,
     1 1.642E+01, 3.522E+01, 1.842E+00, 0.000E+00/
      DATA (PH1(I,20,11, 2),I=1,6) /6.326E+02, 8.448E+01,
     1 1.359E+01, 2.702E+01, 5.021E+00, 0.000E+00/
      DATA (PH1(I,20,11, 3),I=1,6) /5.569E+02, 6.511E+01,
     1 6.616E+02, 4.371E+01, 4.937E+00, 7.881E-06/
      DATA (PH1(I,20,11, 4),I=1,6) /2.113E+02, 1.605E+01,
     1 1.437E+01, 6.989E+02, 3.857E+00, 0.000E+00/
      DATA (PH1(I,20,12, 1),I=1,6) /4.198E+03, 7.401E+02,
     1 1.369E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,20,12, 2),I=1,6) /6.018E+02, 1.203E+02,
     1 1.052E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,20,12, 3),I=1,6) /5.270E+02, 1.293E+02,
     1 1.934E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,20,12, 4),I=1,6) /1.883E+02, 2.552E+01,
     1 1.335E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,20,13, 1),I=1,6) /4.163E+03, 7.816E+02,
     1 1.217E+01, 4.492E+01, 1.646E+00, 0.000E+00/
      DATA (PH1(I,20,13, 2),I=1,6) /5.732E+02, 1.243E+02,
     1 9.859E+00, 2.823E+01, 4.388E+00, 0.000E+00/
      DATA (PH1(I,20,13, 3),I=1,6) /4.967E+02, 1.070E+02,
     1 2.788E+02, 4.768E+01, 4.200E+00, 4.591E-06/
      DATA (PH1(I,20,13, 4),I=1,6) /1.664E+02, 3.989E+01,
     1 9.257E+00, 9.884E+02, 3.326E+00, 0.000E+00/
      DATA (PH1(I,20,13, 5),I=1,6) /1.472E+02, 5.202E+01,
     1 1.127E+01, 6.821E+01, 5.408E+00, 2.204E-01/
      DATA (PH1(I,20,14, 1),I=1,6) /4.133E+03, 8.261E+02,
     1 1.079E+01, 5.751E+01, 1.531E+00, 0.000E+00/
      DATA (PH1(I,20,14, 2),I=1,6) /5.455E+02, 1.268E+02,
     1 9.589E+00, 2.852E+01, 4.353E+00, 0.000E+00/
      DATA (PH1(I,20,14, 3),I=1,6) /4.687E+02, 1.208E+02,
     1 2.181E+02, 5.816E+01, 3.907E+00, 4.346E-06/
      DATA (PH1(I,20,14, 4),I=1,6) /1.452E+02, 4.100E+01,
     1 8.521E+00, 1.977E+03, 3.218E+00, 0.000E+00/
      DATA (PH1(I,20,14, 5),I=1,6) /1.272E+02, 6.097E+01,
     1 1.648E+01, 9.236E+01, 5.007E+00, 4.261E-01/
      DATA (PH1(I,20,15, 1),I=1,6) /4.105E+03, 8.505E+02,
     1 1.012E+01, 6.416E+01, 1.482E+00, 0.000E+00/
      DATA (PH1(I,20,15, 2),I=1,6) /5.193E+02, 1.297E+02,
     1 9.293E+00, 2.927E+01, 4.300E+00, 0.000E+00/
      DATA (PH1(I,20,15, 3),I=1,6) /4.423E+02, 1.303E+02,
     1 1.855E+02, 6.993E+01, 3.707E+00, 1.400E-05/
      DATA (PH1(I,20,15, 4),I=1,6) /1.249E+02, 3.994E+01,
     1 8.068E+00, 2.341E+03, 3.235E+00, 0.000E+00/
      DATA (PH1(I,20,15, 5),I=1,6) /1.088E+02, 5.749E+01,
     1 2.483E+01, 7.819E+01, 5.203E+00, 3.800E-01/
      DATA (PH1(I,20,16, 1),I=1,6) /4.078E+03, 8.635E+02,
     1 9.791E+00, 6.215E+01, 1.479E+00, 0.000E+00/
      DATA (PH1(I,20,16, 2),I=1,6) /4.948E+02, 1.315E+02,
     1 9.126E+00, 2.928E+01, 4.281E+00, 0.000E+00/
      DATA (PH1(I,20,16, 3),I=1,6) /4.175E+02, 1.384E+02,
     1 1.622E+02, 8.811E+01, 3.521E+00, 4.384E-04/
      DATA (PH1(I,20,16, 4),I=1,6) /1.054E+02, 3.722E+01,
     1 7.757E+00, 1.194E+03, 3.398E+00, 0.000E+00/
      DATA (PH1(I,20,16, 5),I=1,6) /8.451E+01, 5.673E+01,
     1 3.044E+01, 7.647E+01, 5.265E+00, 3.557E-01/
      DATA (PH1(I,20,17, 1),I=1,6) /4.063E+03, 9.606E+02,
     1 7.782E+00, 1.191E+02, 1.271E+00, 0.000E+00/
      DATA (PH1(I,20,17, 2),I=1,6) /4.719E+02, 1.373E+02,
     1 8.622E+00, 3.169E+01, 4.152E+00, 0.000E+00/
      DATA (PH1(I,20,17, 3),I=1,6) /3.944E+02, 1.413E+02,
     1 1.542E+02, 9.906E+01, 3.446E+00, 1.107E-03/
      DATA (PH1(I,20,17, 4),I=1,6) /8.680E+01, 3.645E+01,
     1 7.134E+00, 1.200E+03, 3.447E+00, 0.000E+00/
      DATA (PH1(I,20,17, 5),I=1,6) /6.727E+01, 5.169E+01,
     1 4.224E+01, 4.415E+01, 5.864E+00, 3.052E-01/
      DATA (PH1(I,20,18, 1),I=1,6) /4.053E+03, 1.003E+03,
     1 7.079E+00, 1.108E+02, 1.256E+00, 0.000E+00/
      DATA (PH1(I,20,18, 2),I=1,6) /4.542E+02, 1.483E+02,
     1 7.770E+00, 3.866E+01, 3.891E+00, 0.000E+00/
      DATA (PH1(I,20,18, 3),I=1,6) /3.731E+02, 1.260E+02,
     1 1.945E+02, 6.819E+01, 3.770E+00, 4.791E-04/
      DATA (PH1(I,20,18, 4),I=1,6) /6.920E+01, 3.504E+01,
     1 6.596E+00, 7.909E+02, 3.588E+00, 0.000E+00/
      DATA (PH1(I,20,18, 5),I=1,6) /5.091E+01, 4.617E+01,
     1 7.930E+01, 1.711E+01, 7.186E+00, 2.658E-01/
      DATA (PH1(I,20,19, 1),I=1,6) /4.047E+03, 7.997E+02,
     1 1.168E+01, 3.233E+01, 1.744E+00, 0.000E+00/
      DATA (PH1(I,20,19, 2),I=1,6) /4.445E+02, 1.335E+02,
     1 8.939E+00, 2.914E+01, 4.269E+00, 0.000E+00/
      DATA (PH1(I,20,19, 3),I=1,6) /3.638E+02, 1.448E+02,
     1 1.446E+02, 1.349E+02, 3.300E+00, 3.358E-04/
      DATA (PH1(I,20,19, 4),I=1,6) /6.037E+01, 3.176E+01,
     1 6.924E+00, 5.246E+02, 3.771E+00, 0.000E+00/
      DATA (PH1(I,20,19, 5),I=1,6) /4.090E+01, 4.498E+01,
     1 7.314E+01, 1.898E+01, 7.152E+00, 2.735E-01/
      DATA (PH1(I,20,19, 6),I=1,6) /1.000E+00, 1.000E+00,
     1 0.000E+00, 1.000E+00, 1.000E+00, 1.000E+00/
      DATA (PH1(I,20,19, 7),I=1,6) /1.187E+01, 4.155E+00,
     1 2.235E+00, 1.595E+04, 4.313E+00, 3.539E-01/
      DATA (PH1(I,20,20, 1),I=1,6) /4.043E+03, 6.947E+02,
     1 1.586E+01, 2.563E+01, 1.966E+00, 0.000E+00/
      DATA (PH1(I,20,20, 2),I=1,6) /4.425E+02, 1.201E+02,
     1 1.010E+01, 2.468E+01, 4.592E+00, 0.000E+00/
      DATA (PH1(I,20,20, 3),I=1,6) /3.523E+02, 1.529E+02,
     1 1.282E+02, 2.217E+02, 3.087E+00, 3.343E-03/
      DATA (PH1(I,20,20, 4),I=1,6) /4.830E+01, 3.012E+01,
     1 7.227E+00, 1.736E+02, 4.165E+00, 0.000E+00/
      DATA (PH1(I,20,20, 5),I=1,6) /3.443E+01, 4.487E+01,
     1 9.017E+01, 1.465E+01, 7.498E+00, 2.754E-01/
      DATA (PH1(I,20,20, 6),I=1,6) /1.000E+00, 1.000E+00,
     1 0.000E+00, 1.000E+00, 1.000E+00, 1.000E+00/
      DATA (PH1(I,20,20, 7),I=1,6) /6.113E+00, 7.366E+00,
     1 2.373E+00, 2.082E+02, 4.841E+00, 5.841E-04/
      DATA (PH1(I,21, 1, 1),I=1,6) /6.034E+03, 1.907E+02,
     1 1.241E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,21, 2, 1),I=1,6) /5.675E+03, 6.267E+02,
     1 2.182E+01, 3.452E+01, 1.998E+00, 0.000E+00/
      DATA (PH1(I,21, 3, 1),I=1,6) /5.520E+03, 6.439E+02,
     1 2.169E+01, 3.290E+01, 1.960E+00, 0.000E+00/
      DATA (PH1(I,21, 3, 2),I=1,6) /1.288E+03, 1.197E+02,
     1 8.820E+00, 3.718E+01, 4.054E+00, 0.000E+00/
      DATA (PH1(I,21, 4, 1),I=1,6) /5.413E+03, 6.607E+02,
     1 2.038E+01, 3.109E+01, 1.971E+00, 0.000E+00/
      DATA (PH1(I,21, 4, 2),I=1,6) /1.213E+03, 1.109E+02,
     1 1.725E+01, 3.167E+01, 4.371E+00, 0.000E+00/
      DATA (PH1(I,21, 5, 1),I=1,6) /5.294E+03, 6.684E+02,
     1 1.971E+01, 2.792E+01, 2.022E+00, 0.000E+00/
      DATA (PH1(I,21, 5, 2),I=1,6) /1.130E+03, 1.386E+02,
     1 1.325E+01, 2.785E+01, 4.218E+00, 0.000E+00/
      DATA (PH1(I,21, 5, 3),I=1,6) /1.094E+03, 1.435E+02,
     1 4.807E+01, 8.557E+01, 3.452E+00, 4.096E-02/
      DATA (PH1(I,21, 6, 1),I=1,6) /5.178E+03, 6.752E+02,
     1 1.918E+01, 2.616E+01, 2.052E+00, 0.000E+00/
      DATA (PH1(I,21, 6, 2),I=1,6) /1.054E+03, 1.367E+02,
     1 1.270E+01, 2.670E+01, 4.303E+00, 0.000E+00/
      DATA (PH1(I,21, 6, 3),I=1,6) /1.009E+03, 1.269E+02,
     1 1.155E+02, 8.134E+01, 3.618E+00, 1.480E-02/
      DATA (PH1(I,21, 7, 1),I=1,6) /5.067E+03, 8.133E+02,
     1 1.269E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,21, 7, 2),I=1,6) /9.775E+02, 1.256E+02,
     1 1.274E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,21, 7, 3),I=1,6) /9.275E+02, 1.273E+02,
     1 1.529E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,21, 8, 1),I=1,6) /4.960E+03, 6.739E+02,
     1 1.909E+01, 2.432E+01, 2.101E+00, 0.000E+00/
      DATA (PH1(I,21, 8, 2),I=1,6) /9.062E+02, 1.274E+02,
     1 1.195E+01, 2.504E+01, 4.532E+00, 0.000E+00/
      DATA (PH1(I,21, 8, 3),I=1,6) /8.308E+02, 7.899E+01,
     1 4.780E+02, 6.650E+01, 4.304E+00, 9.238E-03/
      DATA (PH1(I,21, 9, 1),I=1,6) /4.861E+03, 8.244E+02,
     1 1.216E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,21, 9, 2),I=1,6) /8.333E+02, 1.300E+02,
     1 1.081E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,21, 9, 3),I=1,6) /7.567E+02, 1.304E+02,
     1 2.045E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,21,10, 1),I=1,6) /4.759E+03, 6.781E+02,
     1 1.869E+01, 2.393E+01, 2.110E+00, 0.000E+00/
      DATA (PH1(I,21,10, 2),I=1,6) /7.657E+02, 1.156E+02,
     1 1.130E+01, 2.296E+01, 4.853E+00, 0.000E+00/
      DATA (PH1(I,21,10, 3),I=1,6) /6.874E+02, 8.313E+01,
     1 5.075E+02, 4.739E+01, 4.637E+00, 3.716E-03/
      DATA (PH1(I,21,11, 1),I=1,6) /4.720E+03, 6.682E+02,
     1 1.915E+01, 2.701E+01, 2.060E+00, 0.000E+00/
      DATA (PH1(I,21,11, 2),I=1,6) /7.309E+02, 7.807E+01,
     1 1.420E+01, 2.694E+01, 5.297E+00, 0.000E+00/
      DATA (PH1(I,21,11, 3),I=1,6) /6.505E+02, 8.091E+01,
     1 5.240E+02, 4.759E+01, 4.674E+00, 3.660E-03/
      DATA (PH1(I,21,11, 4),I=1,6) /2.498E+02, 3.414E+00,
     1 5.976E+01, 1.109E+03, 4.577E+00, 0.000E+00/
      DATA (PH1(I,21,12, 1),I=1,6) /4.684E+03, 7.696E+02,
     1 1.415E+01, 3.494E+01, 1.825E+00, 0.000E+00/
      DATA (PH1(I,21,12, 2),I=1,6) /6.982E+02, 1.019E+02,
     1 1.215E+01, 2.361E+01, 5.033E+00, 0.000E+00/
      DATA (PH1(I,21,12, 3),I=1,6) /6.173E+02, 1.007E+02,
     1 3.568E+02, 4.400E+01, 4.463E+00, 3.640E-03/
      DATA (PH1(I,21,12, 4),I=1,6) /2.251E+02, 1.104E+01,
     1 2.980E+01, 3.451E+02, 4.545E+00, 0.000E+00/
      DATA (PH1(I,21,13, 1),I=1,6) /4.649E+03, 8.283E+02,
     1 1.206E+01, 4.105E+01, 1.707E+00, 0.000E+00/
      DATA (PH1(I,21,13, 2),I=1,6) /6.666E+02, 1.131E+02,
     1 1.124E+01, 2.303E+01, 4.893E+00, 0.000E+00/
      DATA (PH1(I,21,13, 3),I=1,6) /5.852E+02, 1.050E+02,
     1 3.290E+02, 4.379E+01, 4.411E+00, 3.675E-03/
      DATA (PH1(I,21,13, 4),I=1,6) /2.015E+02, 1.499E+01,
     1 2.155E+01, 2.761E+02, 4.455E+00, 0.000E+00/
      DATA (PH1(I,21,13, 5),I=1,6) /1.800E+02, 4.763E+01,
     1 1.441E+01, 4.454E+01, 6.085E+00, 5.576E-03/
      DATA (PH1(I,21,14, 1),I=1,6) /4.615E+03, 9.428E+02,
     1 9.117E+00, 7.840E+01, 1.428E+00, 0.000E+00/
      DATA (PH1(I,21,14, 2),I=1,6) /6.362E+02, 1.182E+02,
     1 1.081E+01, 2.278E+01, 4.836E+00, 0.000E+00/
      DATA (PH1(I,21,14, 3),I=1,6) /5.544E+02, 1.106E+02,
     1 2.980E+02, 4.355E+01, 4.348E+00, 3.645E-03/
      DATA (PH1(I,21,14, 4),I=1,6) /1.784E+02, 2.031E+01,
     1 1.547E+01, 2.264E+02, 4.346E+00, 0.000E+00/
      DATA (PH1(I,21,14, 5),I=1,6) /1.581E+02, 4.941E+01,
     1 2.617E+01, 4.344E+01, 6.056E+00, 6.050E-03/
      DATA (PH1(I,21,15, 1),I=1,6) /4.582E+03, 8.245E+02,
     1 1.210E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,21,15, 2),I=1,6) /6.052E+02, 1.335E+02,
     1 9.523E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,21,15, 3),I=1,6) /5.236E+02, 1.434E+02,
     1 1.765E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,21,15, 4),I=1,6) /1.557E+02, 2.891E+01,
     1 1.052E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,21,15, 5),I=1,6) /1.380E+02, 5.322E+01,
     1 3.348E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,21,16, 1),I=1,6) /4.554E+03, 9.555E+02,
     1 8.840E+00, 7.637E+01, 1.426E+00, 0.000E+00/
      DATA (PH1(I,21,16, 2),I=1,6) /5.803E+02, 1.249E+02,
     1 1.026E+01, 2.249E+01, 4.764E+00, 0.000E+00/
      DATA (PH1(I,21,16, 3),I=1,6) /4.977E+02, 1.266E+02,
     1 2.303E+02, 4.517E+01, 4.139E+00, 3.408E-03/
      DATA (PH1(I,21,16, 4),I=1,6) /1.348E+02, 2.899E+01,
     1 9.855E+00, 1.921E+02, 4.175E+00, 0.000E+00/
      DATA (PH1(I,21,16, 5),I=1,6) /1.107E+02, 5.034E+01,
     1 4.505E+01, 3.882E+01, 6.159E+00, 6.694E-03/
      DATA (PH1(I,21,17, 1),I=1,6) /4.531E+03, 8.307E+02,
     1 1.185E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,21,17, 2),I=1,6) /5.552E+02, 1.344E+02,
     1 9.326E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,21,17, 3),I=1,6) /4.730E+02, 1.444E+02,
     1 1.721E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,21,17, 4),I=1,6) /1.141E+02, 3.036E+01,
     1 8.550E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,21,17, 5),I=1,6) /9.187E+01, 5.439E+01,
     1 4.585E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,21,18, 1),I=1,6) /4.517E+03, 9.957E+02,
     1 8.077E+00, 7.124E+01, 1.415E+00, 0.000E+00/
      DATA (PH1(I,21,18, 2),I=1,6) /5.306E+02, 1.371E+02,
     1 9.401E+00, 2.320E+01, 4.579E+00, 0.000E+00/
      DATA (PH1(I,21,18, 3),I=1,6) /4.476E+02, 1.422E+02,
     1 1.820E+02, 5.428E+01, 3.854E+00, 3.269E-03/
      DATA (PH1(I,21,18, 4),I=1,6) /9.451E+01, 3.451E+01,
     1 7.316E+00, 1.881E+02, 4.071E+00, 0.000E+00/
      DATA (PH1(I,21,18, 5),I=1,6) /7.349E+01, 5.468E+01,
     1 5.377E+01, 3.321E+01, 6.239E+00, 2.941E-01/
      DATA (PH1(I,21,19, 1),I=1,6) /4.508E+03, 1.030E+03,
     1 7.512E+00, 6.545E+01, 1.410E+00, 0.000E+00/
      DATA (PH1(I,21,19, 2),I=1,6) /5.148E+02, 1.443E+02,
     1 8.939E+00, 2.406E+01, 4.456E+00, 0.000E+00/
      DATA (PH1(I,21,19, 3),I=1,6) /4.285E+02, 1.348E+02,
     1 2.014E+02, 5.215E+01, 3.952E+00, 3.368E-03/
      DATA (PH1(I,21,19, 4),I=1,6) /7.762E+01, 3.513E+01,
     1 6.785E+00, 1.898E+02, 4.068E+00, 0.000E+00/
      DATA (PH1(I,21,19, 5),I=1,6) /5.591E+01, 5.169E+01,
     1 5.465E+01, 2.788E+01, 6.613E+00, 2.567E-01/
      DATA (PH1(I,21,19, 6),I=1,6) /2.476E+01, 2.183E+01,
     1 8.459E+01, 6.603E+01, 6.452E+00, 3.890E-01/
      DATA (PH1(I,21,20, 1),I=1,6) /4.500E+03, 7.669E+02,
     1 1.437E+01, 2.629E+01, 1.953E+00, 0.000E+00/
      DATA (PH1(I,21,20, 2),I=1,6) /5.054E+02, 1.274E+02,
     1 1.003E+01, 2.215E+01, 4.755E+00, 0.000E+00/
      DATA (PH1(I,21,20, 3),I=1,6) /4.190E+02, 1.472E+02,
     1 1.711E+02, 5.517E+01, 3.796E+00, 3.289E-03/
      DATA (PH1(I,21,20, 4),I=1,6) /6.848E+01, 3.246E+01,
     1 6.970E+00, 1.757E+02, 4.198E+00, 0.000E+00/
      DATA (PH1(I,21,20, 5),I=1,6) /4.678E+01, 4.990E+01,
     1 5.795E+01, 2.476E+01, 6.870E+00, 2.658E-01/
      DATA (PH1(I,21,20, 6),I=1,6) /1.444E+01, 1.611E+01,
     1 1.269E+02, 5.229E+01, 7.300E+00, 3.103E-01/
      DATA (PH1(I,21,20, 7),I=1,6) /1.280E+01, 3.837E+00,
     1 1.909E+00, 5.825E+02, 5.018E+00, 1.415E-02/
      DATA (PH1(I,21,21, 1),I=1,6) /4.494E+03, 7.367E+02,
     1 1.554E+01, 2.940E+01, 1.937E+00, 0.000E+00/
      DATA (PH1(I,21,21, 2),I=1,6) /5.032E+02, 1.180E+02,
     1 1.065E+01, 2.172E+01, 4.911E+00, 0.000E+00/
      DATA (PH1(I,21,21, 3),I=1,6) /4.054E+02, 1.593E+02,
     1 1.473E+02, 6.007E+01, 3.635E+00, 3.208E-03/
      DATA (PH1(I,21,21, 4),I=1,6) /5.640E+01, 3.284E+01,
     1 6.849E+00, 1.709E+02, 4.207E+00, 0.000E+00/
      DATA (PH1(I,21,21, 5),I=1,6) /3.360E+01, 4.936E+01,
     1 6.176E+01, 2.186E+01, 7.081E+00, 2.671E-01/
      DATA (PH1(I,21,21, 6),I=1,6) /8.010E+00, 9.733E+00,
     1 2.488E+02, 2.066E+01, 1.022E+01, 3.104E-01/
      DATA (PH1(I,21,21, 7),I=1,6) /7.342E+00, 8.324E+00,
     1 2.252E+00, 4.118E+02, 4.588E+00, 1.441E-04/
      DATA (PH1(I,22, 1, 1),I=1,6) /6.626E+03, 2.094E+02,
     1 1.131E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,22, 2, 1),I=1,6) /6.249E+03, 8.656E+02,
     1 1.234E+01, 5.893E+01, 1.622E+00, 0.000E+00/
      DATA (PH1(I,22, 3, 1),I=1,6) /6.087E+03, 8.854E+02,
     1 1.240E+01, 8.225E+01, 1.477E+00, 0.000E+00/
      DATA (PH1(I,22, 3, 2),I=1,6) /1.425E+03, 1.025E+02,
     1 1.038E+01, 4.131E+01, 4.265E+00, 0.000E+00/
      DATA (PH1(I,22, 4, 1),I=1,6) /5.974E+03, 7.415E+02,
     1 1.773E+01, 3.385E+01, 1.915E+00, 0.000E+00/
      DATA (PH1(I,22, 4, 2),I=1,6) /1.346E+03, 1.388E+02,
     1 1.408E+01, 3.133E+01, 4.198E+00, 0.000E+00/
      DATA (PH1(I,22, 5, 1),I=1,6) /5.848E+03, 7.545E+02,
     1 1.694E+01, 3.060E+01, 1.955E+00, 0.000E+00/
      DATA (PH1(I,22, 5, 2),I=1,6) /1.260E+03, 1.433E+02,
     1 1.296E+01, 2.842E+01, 4.278E+00, 0.000E+00/
      DATA (PH1(I,22, 5, 3),I=1,6) /1.221E+03, 1.686E+02,
     1 3.856E+01, 9.198E+01, 3.355E+00, 3.372E-05/
      DATA (PH1(I,22, 6, 1),I=1,6) /5.726E+03, 7.617E+02,
     1 1.648E+01, 2.934E+01, 1.972E+00, 0.000E+00/
      DATA (PH1(I,22, 6, 2),I=1,6) /1.179E+03, 1.419E+02,
     1 1.240E+01, 2.693E+01, 4.373E+00, 0.000E+00/
      DATA (PH1(I,22, 6, 3),I=1,6) /1.131E+03, 1.291E+02,
     1 1.268E+02, 8.686E+01, 3.655E+00, 1.321E-05/
      DATA (PH1(I,22, 7, 1),I=1,6) /5.607E+03, 8.905E+02,
     1 1.167E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,22, 7, 2),I=1,6) /1.098E+03, 1.372E+02,
     1 1.192E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,22, 7, 3),I=1,6) /1.044E+03, 1.401E+02,
     1 1.425E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,22, 8, 1),I=1,6) /5.495E+03, 7.690E+02,
     1 1.599E+01, 2.789E+01, 1.997E+00, 0.000E+00/
      DATA (PH1(I,22, 8, 2),I=1,6) /1.022E+03, 1.341E+02,
     1 1.154E+01, 2.533E+01, 4.576E+00, 0.000E+00/
      DATA (PH1(I,22, 8, 3),I=1,6) /9.419E+02, 1.084E+02,
     1 2.972E+02, 6.609E+01, 4.056E+00, 1.465E-05/
      DATA (PH1(I,22, 9, 1),I=1,6) /5.387E+03, 9.021E+02,
     1 1.121E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,22, 9, 2),I=1,6) /9.448E+02, 1.417E+02,
     1 1.019E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,22, 9, 3),I=1,6) /8.631E+02, 1.430E+02,
     1 1.937E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,22,10, 1),I=1,6) /5.281E+03, 7.712E+02,
     1 1.576E+01, 2.765E+01, 2.005E+00, 0.000E+00/
      DATA (PH1(I,22,10, 2),I=1,6) /8.734E+02, 1.250E+02,
     1 1.070E+01, 2.364E+01, 4.830E+00, 0.000E+00/
      DATA (PH1(I,22,10, 3),I=1,6) /7.878E+02, 9.852E+01,
     1 4.256E+02, 4.955E+01, 4.485E+00, 1.750E-05/
      DATA (PH1(I,22,11, 1),I=1,6) /5.239E+03, 7.394E+02,
     1 1.717E+01, 2.884E+01, 2.020E+00, 0.000E+00/
      DATA (PH1(I,22,11, 2),I=1,6) /8.363E+02, 9.240E+01,
     1 1.291E+01, 2.687E+01, 5.160E+00, 0.000E+00/
      DATA (PH1(I,22,11, 3),I=1,6) /7.511E+02, 9.404E+01,
     1 4.550E+02, 5.003E+01, 4.543E+00, 1.753E-05/
      DATA (PH1(I,22,11, 4),I=1,6) /2.915E+02, 3.359E+00,
     1 6.875E+01, 1.244E+03, 4.559E+00, 0.000E+00/
      DATA (PH1(I,22,12, 1),I=1,6) /5.200E+03, 9.318E+02,
     1 1.045E+01, 5.288E+01, 1.604E+00, 0.000E+00/
      DATA (PH1(I,22,12, 2),I=1,6) /8.013E+02, 1.259E+02,
     1 1.049E+01, 2.445E+01, 4.779E+00, 0.000E+00/
      DATA (PH1(I,22,12, 3),I=1,6) /7.156E+02, 1.122E+02,
     1 3.306E+02, 4.701E+01, 4.376E+00, 1.686E-05/
      DATA (PH1(I,22,12, 4),I=1,6) /2.650E+02, 9.778E+00,
     1 3.726E+01, 4.225E+02, 4.552E+00, 0.000E+00/
      DATA (PH1(I,22,13, 1),I=1,6) /5.162E+03, 9.469E+02,
     1 1.008E+01, 5.127E+01, 1.603E+00, 0.000E+00/
      DATA (PH1(I,22,13, 2),I=1,6) /7.670E+02, 1.254E+02,
     1 1.046E+01, 2.368E+01, 4.830E+00, 0.000E+00/
      DATA (PH1(I,22,13, 3),I=1,6) /6.807E+02, 1.133E+02,
     1 3.222E+02, 4.654E+01, 4.373E+00, 1.686E-05/
      DATA (PH1(I,22,13, 4),I=1,6) /2.397E+02, 1.712E+01,
     1 2.117E+01, 2.738E+02, 4.407E+00, 0.000E+00/
      DATA (PH1(I,22,13, 5),I=1,6) /2.159E+02, 5.265E+01,
     1 1.405E+01, 4.648E+01, 6.025E+00, 8.018E-03/
      DATA (PH1(I,22,14, 1),I=1,6) /5.126E+03, 9.454E+02,
     1 1.011E+01, 5.151E+01, 1.603E+00, 0.000E+00/
      DATA (PH1(I,22,14, 2),I=1,6) /7.342E+02, 1.245E+02,
     1 1.045E+01, 2.319E+01, 4.873E+00, 0.000E+00/
      DATA (PH1(I,22,14, 3),I=1,6) /6.473E+02, 1.160E+02,
     1 3.065E+02, 4.592E+01, 4.355E+00, 1.680E-05/
      DATA (PH1(I,22,14, 4),I=1,6) /2.148E+02, 1.736E+01,
     1 1.941E+01, 2.691E+02, 4.420E+00, 0.000E+00/
      DATA (PH1(I,22,14, 5),I=1,6) /1.921E+02, 5.337E+01,
     1 2.611E+01, 4.514E+01, 6.042E+00, 7.441E-03/
      DATA (PH1(I,22,15, 1),I=1,6) /5.089E+03, 9.027E+02,
     1 1.114E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,22,15, 2),I=1,6) /6.999E+02, 1.454E+02,
     1 9.019E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,22,15, 3),I=1,6) /6.129E+02, 1.565E+02,
     1 1.694E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,22,15, 4),I=1,6) /1.900E+02, 3.119E+01,
     1 1.069E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,22,15, 5),I=1,6) /1.704E+02, 5.839E+01,
     1 3.348E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,22,16, 1),I=1,6) /5.059E+03, 9.613E+02,
     1 9.746E+00, 5.327E+01, 1.581E+00, 0.000E+00/
      DATA (PH1(I,22,16, 2),I=1,6) /6.729E+02, 1.313E+02,
     1 9.948E+00, 2.269E+01, 4.817E+00, 0.000E+00/
      DATA (PH1(I,22,16, 3),I=1,6) /5.853E+02, 1.296E+02,
     1 2.477E+02, 4.576E+01, 4.216E+00, 1.795E-05/
      DATA (PH1(I,22,16, 4),I=1,6) /1.673E+02, 2.786E+01,
     1 1.099E+01, 1.974E+02, 4.259E+00, 0.000E+00/
      DATA (PH1(I,22,16, 5),I=1,6) /1.408E+02, 5.484E+01,
     1 4.527E+01, 3.999E+01, 6.137E+00, 9.213E-03/
      DATA (PH1(I,22,17, 1),I=1,6) /5.027E+03, 9.080E+02,
     1 1.096E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,22,17, 2),I=1,6) /6.441E+02, 1.464E+02,
     1 8.835E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,22,17, 3),I=1,6) /5.563E+02, 1.574E+02,
     1 1.656E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,22,17, 4),I=1,6) /1.445E+02, 3.258E+01,
     1 8.817E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,22,17, 5),I=1,6) /1.195E+02, 5.940E+01,
     1 4.665E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,22,18, 1),I=1,6) /5.011E+03, 1.031E+03,
     1 8.364E+00, 6.468E+01, 1.478E+00, 0.000E+00/
      DATA (PH1(I,22,18, 2),I=1,6) /6.178E+02, 1.446E+02,
     1 9.107E+00, 2.319E+01, 4.635E+00, 0.000E+00/
      DATA (PH1(I,22,18, 3),I=1,6) /5.296E+02, 1.466E+02,
     1 1.952E+02, 4.874E+01, 4.006E+00, 1.732E-05/
      DATA (PH1(I,22,18, 4),I=1,6) /1.231E+02, 3.545E+01,
     1 7.729E+00, 1.792E+02, 4.142E+00, 0.000E+00/
      DATA (PH1(I,22,18, 5),I=1,6) /9.930E+01, 5.902E+01,
     1 5.520E+01, 3.434E+01, 6.226E+00, 2.921E-01/
      DATA (PH1(I,22,19, 1),I=1,6) /4.998E+03, 1.048E+03,
     1 8.085E+00, 6.252E+01, 1.476E+00, 0.000E+00/
      DATA (PH1(I,22,19, 2),I=1,6) /5.949E+02, 1.452E+02,
     1 9.082E+00, 2.289E+01, 4.645E+00, 0.000E+00/
      DATA (PH1(I,22,19, 3),I=1,6) /5.066E+02, 1.497E+02,
     1 1.878E+02, 4.955E+01, 3.967E+00, 1.717E-05/
      DATA (PH1(I,22,19, 4),I=1,6) /1.035E+02, 3.700E+01,
     1 6.988E+00, 1.778E+02, 4.126E+00, 0.000E+00/
      DATA (PH1(I,22,19, 5),I=1,6) /7.917E+01, 5.872E+01,
     1 5.237E+01, 3.131E+01, 6.379E+00, 2.839E-01/
      DATA (PH1(I,22,19, 6),I=1,6) /4.327E+01, 2.624E+01,
     1 9.279E+01, 6.851E+01, 6.300E+00, 3.297E-01/
      DATA (PH1(I,22,20, 1),I=1,6) /4.988E+03, 1.086E+03,
     1 7.494E+00, 5.795E+01, 1.469E+00, 0.000E+00/
      DATA (PH1(I,22,20, 2),I=1,6) /5.792E+02, 1.542E+02,
     1 8.585E+00, 2.370E+01, 4.508E+00, 0.000E+00/
      DATA (PH1(I,22,20, 3),I=1,6) /4.870E+02, 1.508E+02,
     1 1.834E+02, 5.660E+01, 3.868E+00, 1.691E-05/
      DATA (PH1(I,22,20, 4),I=1,6) /8.603E+01, 3.786E+01,
     1 6.489E+00, 1.768E+02, 4.124E+00, 0.000E+00/
      DATA (PH1(I,22,20, 5),I=1,6) /6.201E+01, 5.643E+01,
     1 5.284E+01, 2.686E+01, 6.696E+00, 2.571E-01/
      DATA (PH1(I,22,20, 6),I=1,6) /2.749E+01, 2.399E+01,
     1 1.731E+02, 5.474E+01, 6.742E+00, 3.650E-01/
      DATA (PH1(I,22,21, 1),I=1,6) /4.980E+03, 6.950E+02,
     1 1.983E+01, 1.966E+01, 2.290E+00, 0.000E+00/
      DATA (PH1(I,22,21, 2),I=1,6) /5.704E+02, 1.312E+02,
     1 9.886E+00, 2.185E+01, 4.872E+00, 0.000E+00/
      DATA (PH1(I,22,21, 3),I=1,6) /4.772E+02, 1.630E+02,
     1 1.584E+02, 5.914E+01, 3.739E+00, 1.643E-05/
      DATA (PH1(I,22,21, 4),I=1,6) /7.654E+01, 3.518E+01,
     1 6.620E+00, 1.617E+02, 4.260E+00, 0.000E+00/
      DATA (PH1(I,22,21, 5),I=1,6) /5.253E+01, 5.494E+01,
     1 5.561E+01, 2.416E+01, 6.917E+00, 2.642E-01/
      DATA (PH1(I,22,21, 6),I=1,6) /1.613E+01, 1.771E+01,
     1 2.597E+02, 3.909E+01, 7.825E+00, 2.982E-01/
      DATA (PH1(I,22,21, 7),I=1,6) /1.358E+01, 5.011E+00,
     1 1.639E+00, 5.095E+02, 4.958E+00, 1.633E-03/
      DATA (PH1(I,22,22, 1),I=1,6) /4.972E+03, 6.826E+02,
     1 2.029E+01, 2.415E+01, 2.187E+00, 0.000E+00/
      DATA (PH1(I,22,22, 2),I=1,6) /5.690E+02, 1.177E+02,
     1 1.068E+01, 2.144E+01, 5.085E+00, 0.000E+00/
      DATA (PH1(I,22,22, 3),I=1,6) /4.640E+02, 1.814E+02,
     1 1.291E+02, 6.629E+01, 3.531E+00, 5.519E-05/
      DATA (PH1(I,22,22, 4),I=1,6) /6.500E+01, 3.562E+01,
     1 6.517E+00, 1.572E+02, 4.268E+00, 0.000E+00/
      DATA (PH1(I,22,22, 5),I=1,6) /4.000E+01, 5.424E+01,
     1 5.924E+01, 2.151E+01, 7.123E+00, 2.645E-01/
      DATA (PH1(I,22,22, 6),I=1,6) /9.940E+00, 1.102E+01,
     1 5.478E+02, 1.610E+01, 1.096E+01, 2.972E-01/
      DATA (PH1(I,22,22, 7),I=1,6) /6.820E+00, 9.184E+00,
     1 2.167E+00, 4.297E+02, 4.552E+00, 3.612E-03/
      DATA (PH1(I,23, 1, 1),I=1,6) /7.246E+03, 2.290E+02,
     1 1.035E+02, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,23, 2, 1),I=1,6) /6.852E+03, 7.669E+02,
     1 1.757E+01, 3.884E+01, 1.928E+00, 0.000E+00/
      DATA (PH1(I,23, 3, 1),I=1,6) /6.682E+03, 7.973E+02,
     1 1.694E+01, 3.805E+01, 1.874E+00, 0.000E+00/
      DATA (PH1(I,23, 3, 2),I=1,6) /1.570E+03, 4.820E+01,
     1 1.999E+01, 7.258E+01, 4.724E+00, 0.000E+00/
      DATA (PH1(I,23, 4, 1),I=1,6) /6.563E+03, 8.146E+02,
     1 1.606E+01, 3.587E+01, 1.887E+00, 0.000E+00/
      DATA (PH1(I,23, 4, 2),I=1,6) /1.487E+03, 1.341E+02,
     1 1.463E+01, 3.226E+01, 4.336E+00, 0.000E+00/
      DATA (PH1(I,23, 5, 1),I=1,6) /6.431E+03, 8.301E+02,
     1 1.528E+01, 3.284E+01, 1.918E+00, 0.000E+00/
      DATA (PH1(I,23, 5, 2),I=1,6) /1.396E+03, 1.597E+02,
     1 1.178E+01, 2.849E+01, 4.246E+00, 0.000E+00/
      DATA (PH1(I,23, 5, 3),I=1,6) /1.355E+03, 1.329E+02,
     1 7.374E+01, 1.017E+02, 3.596E+00, 2.681E-02/
      DATA (PH1(I,23, 6, 1),I=1,6) /6.302E+03, 8.379E+02,
     1 1.487E+01, 3.151E+01, 1.935E+00, 0.000E+00/
      DATA (PH1(I,23, 6, 2),I=1,6) /1.311E+03, 1.437E+02,
     1 1.233E+01, 2.743E+01, 4.461E+00, 0.000E+00/
      DATA (PH1(I,23, 6, 3),I=1,6) /1.260E+03, 1.761E+02,
     1 7.417E+01, 9.459E+01, 3.402E+00, 1.814E-02/
      DATA (PH1(I,23, 7, 1),I=1,6) /6.174E+03, 9.714E+02,
     1 1.078E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,23, 7, 2),I=1,6) /1.225E+03, 1.493E+02,
     1 1.118E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,23, 7, 3),I=1,6) /1.168E+03, 1.535E+02,
     1 1.330E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,23, 8, 1),I=1,6) /6.058E+03, 8.454E+02,
     1 1.444E+01, 3.020E+01, 1.955E+00, 0.000E+00/
      DATA (PH1(I,23, 8, 2),I=1,6) /1.146E+03, 1.434E+02,
     1 1.098E+01, 2.603E+01, 4.573E+00, 0.000E+00/
      DATA (PH1(I,23, 8, 3),I=1,6) /1.060E+03, 1.412E+02,
     1 1.992E+02, 6.905E+01, 3.834E+00, 1.640E-02/
      DATA (PH1(I,23, 9, 1),I=1,6) /5.941E+03, 9.834E+02,
     1 1.036E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,23, 9, 2),I=1,6) /1.063E+03, 1.540E+02,
     1 9.623E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,23, 9, 3),I=1,6) /9.758E+02, 1.562E+02,
     1 1.835E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,23,10, 1),I=1,6) /5.831E+03, 8.491E+02,
     1 1.420E+01, 2.950E+01, 1.968E+00, 0.000E+00/
      DATA (PH1(I,23,10, 2),I=1,6) /9.883E+02, 1.272E+02,
     1 1.058E+01, 2.434E+01, 4.902E+00, 0.000E+00/
      DATA (PH1(I,23,10, 3),I=1,6) /8.960E+02, 1.198E+02,
     1 3.365E+02, 5.275E+01, 4.289E+00, 1.591E-02/
      DATA (PH1(I,23,11, 1),I=1,6) /5.787E+03, 8.254E+02,
     1 1.504E+01, 3.096E+01, 1.969E+00, 0.000E+00/
      DATA (PH1(I,23,11, 2),I=1,6) /9.488E+02, 9.010E+01,
     1 1.292E+01, 2.883E+01, 5.244E+00, 0.000E+00/
      DATA (PH1(I,23,11, 3),I=1,6) /8.589E+02, 1.178E+02,
     1 3.418E+02, 5.198E+01, 4.329E+00, 1.528E-02/
      DATA (PH1(I,23,11, 4),I=1,6) /3.363E+02, 4.802E+00,
     1 5.149E+01, 9.708E+02, 4.521E+00, 0.000E+00/
      DATA (PH1(I,23,12, 1),I=1,6) /5.745E+03, 8.791E+02,
     1 1.315E+01, 3.287E+01, 1.891E+00, 0.000E+00/
      DATA (PH1(I,23,12, 2),I=1,6) /9.114E+02, 1.194E+02,
     1 1.089E+01, 2.492E+01, 4.980E+00, 0.000E+00/
      DATA (PH1(I,23,12, 3),I=1,6) /8.209E+02, 1.210E+02,
     1 3.219E+02, 4.969E+01, 4.340E+00, 1.495E-02/
      DATA (PH1(I,23,12, 4),I=1,6) /3.081E+02, 1.475E+01,
     1 2.755E+01, 3.277E+02, 4.457E+00, 0.000E+00/
      DATA (PH1(I,23,13, 1),I=1,6) /5.704E+03, 9.381E+02,
     1 1.144E+01, 3.678E+01, 1.793E+00, 0.000E+00/
      DATA (PH1(I,23,13, 2),I=1,6) /8.746E+02, 1.297E+02,
     1 1.022E+01, 2.418E+01, 4.886E+00, 0.000E+00/
      DATA (PH1(I,23,13, 3),I=1,6) /7.834E+02, 1.219E+02,
     1 3.155E+02, 4.959E+01, 4.332E+00, 1.503E-02/
      DATA (PH1(I,23,13, 4),I=1,6) /2.810E+02, 1.396E+01,
     1 2.795E+01, 3.475E+02, 4.463E+00, 0.000E+00/
      DATA (PH1(I,23,13, 5),I=1,6) /2.557E+02, 6.549E+01,
     1 1.189E+01, 4.523E+01, 5.865E+00, 5.604E-01/
      DATA (PH1(I,23,14, 1),I=1,6) /5.664E+03, 9.448E+02,
     1 1.126E+01, 3.775E+01, 1.777E+00, 0.000E+00/
      DATA (PH1(I,23,14, 2),I=1,6) /8.391E+02, 1.492E+02,
     1 8.956E+00, 2.627E+01, 4.576E+00, 0.000E+00/
      DATA (PH1(I,23,14, 3),I=1,6) /7.474E+02, 1.218E+02,
     1 3.136E+02, 4.700E+01, 4.379E+00, 1.470E-02/
      DATA (PH1(I,23,14, 4),I=1,6) /2.543E+02, 5.439E+01,
     1 8.345E+00, 9.136E+02, 3.280E+00, 0.000E+00/
      DATA (PH1(I,23,14, 5),I=1,6) /2.305E+02, 7.687E+01,
     1 1.769E+01, 7.556E+01, 5.183E+00, 4.070E-01/
      DATA (PH1(I,23,15, 1),I=1,6) /5.624E+03, 9.854E+02,
     1 1.025E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,23,15, 2),I=1,6) /8.017E+02, 1.579E+02,
     1 8.542E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,23,15, 3),I=1,6) /7.093E+02, 1.701E+02,
     1 1.628E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,23,15, 4),I=1,6) /2.274E+02, 3.357E+01,
     1 1.077E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,23,15, 5),I=1,6) /2.058E+02, 6.386E+01,
     1 3.315E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,23,16, 1),I=1,6) /5.591E+03, 9.640E+02,
     1 1.077E+01, 4.005E+01, 1.740E+00, 0.000E+00/
      DATA (PH1(I,23,16, 2),I=1,6) /7.727E+02, 1.513E+02,
     1 8.749E+00, 2.570E+01, 4.587E+00, 0.000E+00/
      DATA (PH1(I,23,16, 3),I=1,6) /6.800E+02, 1.400E+02,
     1 2.393E+02, 5.044E+01, 4.150E+00, 1.006E-02/
      DATA (PH1(I,23,16, 4),I=1,6) /2.031E+02, 5.013E+01,
     1 7.844E+00, 8.057E+02, 3.393E+00, 0.000E+00/
      DATA (PH1(I,23,16, 5),I=1,6) /1.735E+02, 6.959E+01,
     1 3.541E+01, 6.440E+01, 5.460E+00, 2.830E-01/
      DATA (PH1(I,23,17, 1),I=1,6) /5.557E+03, 9.898E+02,
     1 1.013E+01, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,23,17, 2),I=1,6) /7.401E+02, 1.589E+02,
     1 8.371E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,23,17, 3),I=1,6) /6.468E+02, 1.710E+02,
     1 1.594E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,23,17, 4),I=1,6) /1.781E+02, 3.490E+01,
     1 9.007E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,23,17, 5),I=1,6) /1.506E+02, 6.472E+01,
     1 4.696E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,23,18, 1),I=1,6) /5.531E+03, 9.782E+02,
     1 1.044E+01, 3.841E+01, 1.745E+00, 0.000E+00/
      DATA (PH1(I,23,18, 2),I=1,6) /7.123E+02, 1.580E+02,
     1 8.337E+00, 2.583E+01, 4.520E+00, 0.000E+00/
      DATA (PH1(I,23,18, 3),I=1,6) /6.188E+02, 1.692E+02,
     1 1.626E+02, 6.988E+01, 3.712E+00, 1.180E-02/
      DATA (PH1(I,23,18, 4),I=1,6) /1.549E+02, 4.722E+01,
     1 6.956E+00, 5.988E+02, 3.553E+00, 0.000E+00/
      DATA (PH1(I,23,18, 5),I=1,6) /1.281E+02, 6.736E+01,
     1 4.931E+01, 4.579E+01, 5.859E+00, 3.123E-01/
      DATA (PH1(I,23,19, 1),I=1,6) /5.516E+03, 9.875E+02,
     1 1.024E+01, 3.726E+01, 1.748E+00, 0.000E+00/
      DATA (PH1(I,23,19, 2),I=1,6) /6.859E+02, 1.633E+02,
     1 8.009E+00, 2.702E+01, 4.427E+00, 0.000E+00/
      DATA (PH1(I,23,19, 3),I=1,6) /5.923E+02, 1.721E+02,
     1 1.571E+02, 6.951E+01, 3.697E+00, 1.225E-02/
      DATA (PH1(I,23,19, 4),I=1,6) /1.329E+02, 4.591E+01,
     1 6.536E+00, 5.301E+02, 3.633E+00, 0.000E+00/
      DATA (PH1(I,23,19, 5),I=1,6) /1.059E+02, 6.053E+01,
     1 5.762E+01, 2.883E+01, 6.578E+00, 2.283E-01/
      DATA (PH1(I,23,19, 6),I=1,6) /6.528E+01, 3.190E+01,
     1 8.329E+01, 1.369E+02, 5.672E+00, 1.237E-01/
      DATA (PH1(I,23,20, 1),I=1,6) /5.504E+03, 9.965E+02,
     1 9.948E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,23,20, 2),I=1,6) /6.654E+02, 1.599E+02,
     1 8.204E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,23,20, 3),I=1,6) /5.715E+02, 1.723E+02,
     1 1.553E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,23,20, 4),I=1,6) /1.118E+02, 3.793E+01,
     1 6.694E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,23,20, 5),I=1,6) /8.555E+01, 6.751E+01,
     1 4.255E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,23,20, 6),I=1,6) /4.671E+01, 2.794E+01,
     1 2.071E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,23,21, 1),I=1,6) /5.493E+03, 1.056E+03,
     1 8.926E+00, 3.290E+01, 1.738E+00, 0.000E+00/
      DATA (PH1(I,23,21, 2),I=1,6) /6.421E+02, 1.795E+02,
     1 7.208E+00, 3.031E+01, 4.183E+00, 0.000E+00/
      DATA (PH1(I,23,21, 3),I=1,6) /5.487E+02, 1.685E+02,
     1 1.634E+02, 6.966E+01, 3.723E+00, 1.158E-02/
      DATA (PH1(I,23,21, 4),I=1,6) /9.452E+01, 4.339E+01,
     1 5.872E+00, 3.580E+02, 3.847E+00, 0.000E+00/
      DATA (PH1(I,23,21, 5),I=1,6) /6.813E+01, 6.101E+01,
     1 5.383E+01, 2.353E+01, 6.904E+00, 2.586E-01/
      DATA (PH1(I,23,21, 6),I=1,6) /2.931E+01, 1.913E+01,
     1 3.556E+03, 5.763E+00, 1.187E+01, 5.113E-01/
      DATA (PH1(I,23,22, 1),I=1,6) /5.484E+03, 1.467E+03,
     1 4.369E+00, 3.858E+02, 1.042E+00, 0.000E+00/
      DATA (PH1(I,23,22, 2),I=1,6) /6.389E+02, 1.378E+02,
     1 9.535E+00, 2.195E+01, 4.927E+00, 0.000E+00/
      DATA (PH1(I,23,22, 3),I=1,6) /5.292E+02, 1.302E+02,
     1 2.706E+02, 4.385E+01, 4.365E+00, 6.490E-05/
      DATA (PH1(I,23,22, 4),I=1,6) /7.942E+01, 4.123E+01,
     1 5.887E+00, 1.634E+02, 4.188E+00, 0.000E+00/
      DATA (PH1(I,23,22, 5),I=1,6) /5.323E+01, 6.049E+01,
     1 5.264E+01, 2.216E+01, 7.058E+00, 2.583E-01/
      DATA (PH1(I,23,22, 6),I=1,6) /1.466E+01, 1.451E+01,
     1 7.154E+02, 1.749E+01, 1.038E+01, 4.665E-01/
      DATA (PH1(I,23,23, 1),I=1,6) /5.475E+03, 6.550E+02,
     1 2.420E+01, 2.343E+01, 2.326E+00, 0.000E+00/
      DATA (PH1(I,23,23, 2),I=1,6) /6.380E+02, 9.688E+01,
     1 1.212E+01, 1.905E+01, 5.757E+00, 0.000E+00/
      DATA (PH1(I,23,23, 3),I=1,6) /5.270E+02, 2.290E+02,
     1 8.513E+01, 5.037E+02, 2.767E+00, 9.964E-04/
      DATA (PH1(I,23,23, 4),I=1,6) /7.700E+01, 3.668E+01,
     1 6.690E+00, 7.759E+01, 4.706E+00, 0.000E+00/
      DATA (PH1(I,23,23, 5),I=1,6) /4.700E+01, 5.937E+01,
     1 7.599E+01, 1.488E+01, 7.586E+00, 2.690E-01/
      DATA (PH1(I,23,23, 6),I=1,6) /1.200E+01, 1.146E+01,
     1 3.134E+03, 7.037E+00, 1.377E+01, 3.417E-01/
      DATA (PH1(I,23,23, 7),I=1,6) /6.740E+00, 1.002E+01,
     1 2.059E+00, 3.914E+02, 4.565E+00, 5.057E-04/
      DATA (PH1(I,24, 1, 1),I=1,6) /7.895E+03, 2.495E+02,
     1 9.505E+01, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,24, 2, 1),I=1,6) /7.482E+03, 9.695E+02,
     1 1.185E+01, 5.351E+01, 1.696E+00, 0.000E+00/
      DATA (PH1(I,24, 3, 1),I=1,6) /7.306E+03, 9.824E+02,
     1 1.199E+01, 5.185E+01, 1.668E+00, 0.000E+00/
      DATA (PH1(I,24, 3, 2),I=1,6) /1.721E+03, 1.480E+02,
     1 7.312E+00, 3.880E+01, 4.083E+00, 0.000E+00/
      DATA (PH1(I,24, 4, 1),I=1,6) /7.181E+03, 9.952E+02,
     1 1.156E+01, 4.841E+01, 1.687E+00, 0.000E+00/
      DATA (PH1(I,24, 4, 2),I=1,6) /1.634E+03, 1.488E+02,
     1 1.333E+01, 3.225E+01, 4.310E+00, 0.000E+00/
      DATA (PH1(I,24, 5, 1),I=1,6) /7.042E+03, 1.003E+03,
     1 1.125E+01, 4.457E+01, 1.717E+00, 0.000E+00/
      DATA (PH1(I,24, 5, 2),I=1,6) /1.539E+03, 1.748E+02,
     1 1.089E+01, 2.892E+01, 4.221E+00, 0.000E+00/
      DATA (PH1(I,24, 5, 3),I=1,6) /1.497E+03, 2.216E+02,
     1 2.692E+01, 1.091E+02, 3.193E+00, 3.540E-03/
      DATA (PH1(I,24, 6, 1),I=1,6) /6.907E+03, 1.004E+03,
     1 1.114E+01, 4.238E+01, 1.740E+00, 0.000E+00/
      DATA (PH1(I,24, 6, 2),I=1,6) /1.450E+03, 1.749E+02,
     1 1.035E+01, 2.790E+01, 4.278E+00, 0.000E+00/
      DATA (PH1(I,24, 6, 3),I=1,6) /1.396E+03, 2.006E+02,
     1 6.290E+01, 1.016E+02, 3.330E+00, 1.634E-03/
      DATA (PH1(I,24, 7, 1),I=1,6) /6.769E+03, 1.056E+03,
     1 9.975E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,24, 7, 2),I=1,6) /1.359E+03, 1.619E+02,
     1 1.050E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,24, 7, 3),I=1,6) /1.299E+03, 1.675E+02,
     1 1.244E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,24, 8, 1),I=1,6) /6.650E+03, 1.010E+03,
     1 1.086E+01, 4.093E+01, 1.755E+00, 0.000E+00/
      DATA (PH1(I,24, 8, 2),I=1,6) /1.276E+03, 1.514E+02,
     1 1.053E+01, 2.659E+01, 4.591E+00, 0.000E+00/
      DATA (PH1(I,24, 8, 3),I=1,6) /1.185E+03, 1.297E+02,
     1 2.646E+02, 7.449E+01, 3.960E+00, 6.187E-03/
      DATA (PH1(I,24, 9, 1),I=1,6) /6.523E+03, 1.068E+03,
     1 9.610E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,24, 9, 2),I=1,6) /1.189E+03, 1.668E+02,
     1 9.095E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,24, 9, 3),I=1,6) /1.097E+03, 1.701E+02,
     1 1.738E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,24,10, 1),I=1,6) /6.409E+03, 1.017E+03,
     1 1.063E+01, 4.093E+01, 1.756E+00, 0.000E+00/
      DATA (PH1(I,24,10, 2),I=1,6) /1.110E+03, 1.388E+02,
     1 9.935E+00, 2.496E+01, 4.858E+00, 0.000E+00/
      DATA (PH1(I,24,10, 3),I=1,6) /1.011E+03, 1.397E+02,
     1 2.826E+02, 5.599E+01, 4.153E+00, 5.775E-03/
      DATA (PH1(I,24,11, 1),I=1,6) /6.362E+03, 9.927E+02,
     1 1.118E+01, 4.335E+01, 1.752E+00, 0.000E+00/
      DATA (PH1(I,24,11, 2),I=1,6) /1.068E+03, 9.748E+01,
     1 1.227E+01, 2.968E+01, 5.204E+00, 0.000E+00/
      DATA (PH1(I,24,11, 3),I=1,6) /9.738E+02, 1.312E+02,
     1 3.124E+02, 5.494E+01, 4.251E+00, 6.239E-03/
      DATA (PH1(I,24,11, 4),I=1,6) /3.842E+02, 5.856E+00,
     1 4.533E+01, 8.787E+02, 4.495E+00, 0.000E+00/
      DATA (PH1(I,24,12, 1),I=1,6) /6.318E+03, 1.103E+03,
     1 8.914E+00, 5.657E+01, 1.588E+00, 0.000E+00/
      DATA (PH1(I,24,12, 2),I=1,6) /1.029E+03, 1.295E+02,
     1 1.028E+01, 2.555E+01, 4.945E+00, 0.000E+00/
      DATA (PH1(I,24,12, 3),I=1,6) /9.334E+02, 1.427E+02,
     1 2.652E+02, 5.321E+01, 4.178E+00, 5.905E-03/
      DATA (PH1(I,24,12, 4),I=1,6) /3.548E+02, 1.135E+01,
     1 3.894E+01, 4.475E+02, 4.496E+00, 0.000E+00/
      DATA (PH1(I,24,13, 1),I=1,6) /6.274E+03, 1.115E+03,
     1 8.708E+00, 5.540E+01, 1.588E+00, 0.000E+00/
      DATA (PH1(I,24,13, 2),I=1,6) /9.893E+02, 1.454E+02,
     1 9.421E+00, 2.472E+01, 4.803E+00, 0.000E+00/
      DATA (PH1(I,24,13, 3),I=1,6) /8.933E+02, 1.424E+02,
     1 2.644E+02, 5.317E+01, 4.181E+00, 5.962E-03/
      DATA (PH1(I,24,13, 4),I=1,6) /3.255E+02, 1.164E+01,
     1 3.651E+01, 4.413E+02, 4.490E+00, 0.000E+00/
      DATA (PH1(I,24,13, 5),I=1,6) /2.981E+02, 6.675E+01,
     1 1.246E+01, 4.963E+01, 5.860E+00, 3.057E-01/
      DATA (PH1(I,24,14, 1),I=1,6) /6.231E+03, 1.111E+03,
     1 8.763E+00, 5.576E+01, 1.589E+00, 0.000E+00/
      DATA (PH1(I,24,14, 2),I=1,6) /9.512E+02, 1.447E+02,
     1 9.388E+00, 2.428E+01, 4.837E+00, 0.000E+00/
      DATA (PH1(I,24,14, 3),I=1,6) /8.546E+02, 1.426E+02,
     1 2.618E+02, 5.270E+01, 4.188E+00, 5.989E-03/
      DATA (PH1(I,24,14, 4),I=1,6) /2.969E+02, 2.539E+01,
     1 1.632E+01, 2.419E+02, 4.286E+00, 0.000E+00/
      DATA (PH1(I,24,14, 5),I=1,6) /2.708E+02, 6.544E+01,
     1 2.411E+01, 4.849E+01, 5.923E+00, 2.753E-01/
      DATA (PH1(I,24,15, 1),I=1,6) /6.187E+03, 1.073E+03,
     1 9.448E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,24,15, 2),I=1,6) /9.108E+02, 1.710E+02,
     1 8.093E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,24,15, 3),I=1,6) /8.130E+02, 1.843E+02,
     1 1.566E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,24,15, 4),I=1,6) /2.680E+02, 3.606E+01,
     1 1.078E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,24,15, 5),I=1,6) /2.444E+02, 6.965E+01,
     1 3.257E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,24,16, 1),I=1,6) /6.152E+03, 1.110E+03,
     1 8.774E+00, 5.647E+01, 1.586E+00, 0.000E+00/
      DATA (PH1(I,24,16, 2),I=1,6) /8.797E+02, 1.476E+02,
     1 9.146E+00, 2.358E+01, 4.847E+00, 0.000E+00/
      DATA (PH1(I,24,16, 3),I=1,6) /7.819E+02, 1.427E+02,
     1 2.573E+02, 5.042E+01, 4.228E+00, 5.960E-03/
      DATA (PH1(I,24,16, 4),I=1,6) /2.419E+02, 2.465E+01,
     1 1.419E+01, 2.341E+02, 4.369E+00, 0.000E+00/
      DATA (PH1(I,24,16, 5),I=1,6) /2.093E+02, 6.644E+01,
     1 4.311E+01, 4.198E+01, 6.057E+00, 3.135E-01/
      DATA (PH1(I,24,17, 1),I=1,6) /6.114E+03, 1.076E+03,
     1 9.366E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,24,17, 2),I=1,6) /8.432E+02, 1.720E+02,
     1 7.934E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,24,17, 3),I=1,6) /7.444E+02, 1.850E+02,
     1 1.537E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,24,17, 4),I=1,6) /2.148E+02, 3.733E+01,
     1 9.131E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,24,17, 5),I=1,6) /1.847E+02, 7.035E+01,
     1 4.687E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,24,18, 1),I=1,6) /6.080E+03, 1.122E+03,
     1 8.562E+00, 5.603E+01, 1.582E+00, 0.000E+00/
      DATA (PH1(I,24,18, 2),I=1,6) /8.140E+02, 1.553E+02,
     1 8.726E+00, 2.320E+01, 4.789E+00, 0.000E+00/
      DATA (PH1(I,24,18, 3),I=1,6) /7.153E+02, 1.571E+02,
     1 2.130E+02, 5.017E+01, 4.114E+00, 5.706E-03/
      DATA (PH1(I,24,18, 4),I=1,6) /1.900E+02, 3.531E+01,
     1 8.881E+00, 1.815E+02, 4.264E+00, 0.000E+00/
      DATA (PH1(I,24,18, 5),I=1,6) /1.602E+02, 6.754E+01,
     1 5.675E+01, 3.729E+01, 6.191E+00, 2.358E-01/
      DATA (PH1(I,24,19, 1),I=1,6) /6.062E+03, 1.128E+03,
     1 8.464E+00, 5.569E+01, 1.580E+00, 0.000E+00/
      DATA (PH1(I,24,19, 2),I=1,6) /7.842E+02, 1.551E+02,
     1 8.723E+00, 2.287E+01, 4.810E+00, 0.000E+00/
      DATA (PH1(I,24,19, 3),I=1,6) /6.855E+02, 1.640E+02,
     1 1.963E+02, 5.019E+01, 4.060E+00, 5.648E-03/
      DATA (PH1(I,24,19, 4),I=1,6) /1.656E+02, 3.830E+01,
     1 7.706E+00, 1.719E+02, 4.245E+00, 0.000E+00/
      DATA (PH1(I,24,19, 5),I=1,6) /1.359E+02, 6.693E+01,
     1 5.368E+01, 3.420E+01, 6.344E+00, 2.242E-01/
      DATA (PH1(I,24,19, 6),I=1,6) /9.064E+01, 3.098E+01,
     1 1.201E+02, 6.811E+01, 6.392E+00, 3.113E-03/
      DATA (PH1(I,24,20, 1),I=1,6) /6.046E+03, 1.081E+03,
     1 9.244E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,24,20, 2),I=1,6) /7.598E+02, 1.731E+02,
     1 7.776E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,24,20, 3),I=1,6) /6.602E+02, 1.862E+02,
     1 1.500E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,24,20, 4),I=1,6) /1.427E+02, 4.027E+01,
     1 6.892E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,24,20, 5),I=1,6) /1.134E+02, 7.290E+01,
     1 4.327E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,24,20, 6),I=1,6) /6.946E+01, 3.105E+01,
     1 2.269E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,24,21, 1),I=1,6) /6.033E+03, 1.224E+03,
     1 7.106E+00, 7.179E+01, 1.455E+00, 0.000E+00/
      DATA (PH1(I,24,21, 2),I=1,6) /7.331E+02, 1.640E+02,
     1 8.333E+00, 2.286E+01, 4.721E+00, 0.000E+00/
      DATA (PH1(I,24,21, 3),I=1,6) /6.344E+02, 1.721E+02,
     1 1.795E+02, 5.067E+01, 3.993E+00, 5.538E-03/
      DATA (PH1(I,24,21, 4),I=1,6) /1.219E+02, 4.256E+01,
     1 6.252E+00, 1.605E+02, 4.224E+00, 0.000E+00/
      DATA (PH1(I,24,21, 5),I=1,6) /9.275E+01, 6.776E+01,
     1 4.856E+01, 2.817E+01, 6.628E+00, 2.673E-01/
      DATA (PH1(I,24,21, 6),I=1,6) /4.916E+01, 3.483E+01,
     1 2.224E+02, 5.448E+01, 6.484E+00, 3.436E-01/
      DATA (PH1(I,24,22, 1),I=1,6) /6.021E+03, 1.085E+03,
     1 9.165E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,24,22, 2),I=1,6) /7.161E+02, 1.735E+02,
     1 7.720E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,24,22, 3),I=1,6) /6.164E+02, 1.871E+02,
     1 1.480E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,24,22, 4),I=1,6) /1.032E+02, 4.293E+01,
     1 5.797E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,24,22, 5),I=1,6) /7.436E+01, 6.450E+01,
     1 5.388E+01, 2.100E+01, 7.200E+00, 2.600E-01/
      DATA (PH1(I,24,22, 6),I=1,6) /3.096E+01, 9.947E+00,
     1 1.924E+03, 9.000E+00, 1.450E+01, 3.500E-01/
      DATA (PH1(I,24,23, 1),I=1,6) /6.009E+03, 1.497E+03,
     1 4.593E+00, 1.465E+02, 1.189E+00, 0.000E+00/
      DATA (PH1(I,24,23, 2),I=1,6) /7.074E+02, 2.013E+02,
     1 6.869E+00, 2.572E+01, 4.266E+00, 0.000E+00/
      DATA (PH1(I,24,23, 3),I=1,6) /5.970E+02, 1.477E+02,
     1 2.382E+02, 4.633E+01, 4.261E+00, 6.156E-03/
      DATA (PH1(I,24,23, 4),I=1,6) /8.745E+01, 4.462E+01,
     1 5.566E+00, 1.542E+02, 4.230E+00, 0.000E+00/
      DATA (PH1(I,24,23, 5),I=1,6) /5.879E+01, 6.599E+01,
     1 5.021E+01, 2.175E+01, 7.102E+00, 2.576E-01/
      DATA (PH1(I,24,23, 6),I=1,6) /1.650E+01, 1.521E+01,
     1 1.031E+03, 1.415E+01, 1.123E+01, 4.827E-01/
      DATA (PH1(I,24,24, 1),I=1,6) /5.996E+03, 1.035E+03,
     1 1.025E+01, 3.343E+01, 1.822E+00, 0.000E+00/
      DATA (PH1(I,24,24, 2),I=1,6) /7.030E+02, 1.588E+02,
     1 8.555E+00, 2.258E+01, 4.789E+00, 0.000E+00/
      DATA (PH1(I,24,24, 3),I=1,6) /5.850E+02, 1.865E+02,
     1 1.540E+02, 5.560E+01, 3.823E+00, 5.785E-03/
      DATA (PH1(I,24,24, 4),I=1,6) /7.900E+01, 4.234E+01,
     1 5.602E+00, 1.356E+02, 4.374E+00, 0.000E+00/
      DATA (PH1(I,24,24, 5),I=1,6) /4.900E+01, 6.567E+01,
     1 5.313E+01, 1.981E+01, 7.258E+00, 2.601E-01/
      DATA (PH1(I,24,24, 6),I=1,6) /8.660E+00, 7.244E+00,
     1 1.485E+03, 9.671E+00, 1.575E+01, 7.760E-01/
      DATA (PH1(I,24,24, 7),I=1,6) /6.767E+00, 9.636E+00,
     1 6.532E-01, 5.232E+02, 4.641E+00, 9.332E-05/
      DATA (PH1(I,25, 1, 1),I=1,6) /8.572E+03, 2.709E+02,
     1 8.759E+01, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,25, 2, 1),I=1,6) /8.141E+03, 9.661E+02,
     1 1.309E+01, 4.829E+01, 1.794E+00, 0.000E+00/
      DATA (PH1(I,25, 3, 1),I=1,6) /7.957E+03, 9.997E+02,
     1 1.266E+01, 4.727E+01, 1.749E+00, 0.000E+00/
      DATA (PH1(I,25, 3, 2),I=1,6) /1.880E+03, 2.004E+02,
     1 5.352E+00, 3.934E+01, 3.800E+00, 0.000E+00/
      DATA (PH1(I,25, 4, 1),I=1,6) /7.827E+03, 9.916E+02,
     1 1.277E+01, 4.256E+01, 1.799E+00, 0.000E+00/
      DATA (PH1(I,25, 4, 2),I=1,6) /1.788E+03, 1.631E+02,
     1 1.229E+01, 3.227E+01, 4.294E+00, 0.000E+00/
      DATA (PH1(I,25, 5, 1),I=1,6) /7.682E+03, 9.946E+02,
     1 1.255E+01, 3.824E+01, 1.847E+00, 0.000E+00/
      DATA (PH1(I,25, 5, 2),I=1,6) /1.689E+03, 1.952E+02,
     1 9.881E+00, 2.837E+01, 4.199E+00, 0.000E+00/
      DATA (PH1(I,25, 5, 3),I=1,6) /1.644E+03, 2.576E+02,
     1 2.159E+01, 1.234E+02, 3.086E+00, 1.723E-02/
      DATA (PH1(I,25, 6, 1),I=1,6) /7.539E+03, 9.973E+02,
     1 1.238E+01, 3.663E+01, 1.868E+00, 0.000E+00/
      DATA (PH1(I,25, 6, 2),I=1,6) /1.596E+03, 1.879E+02,
     1 9.744E+00, 2.825E+01, 4.277E+00, 0.000E+00/
      DATA (PH1(I,25, 6, 3),I=1,6) /1.539E+03, 2.403E+02,
     1 4.744E+01, 1.147E+02, 3.190E+00, 1.237E-02/
      DATA (PH1(I,25, 7, 1),I=1,6) /7.391E+03, 1.144E+03,
     1 9.260E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,25, 7, 2),I=1,6) /1.500E+03, 1.751E+02,
     1 9.871E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,25, 7, 3),I=1,6) /1.437E+03, 1.822E+02,
     1 1.165E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,25, 8, 1),I=1,6) /7.270E+03, 1.005E+03,
     1 1.205E+01, 3.464E+01, 1.893E+00, 0.000E+00/
      DATA (PH1(I,25, 8, 2),I=1,6) /1.414E+03, 1.452E+02,
     1 1.087E+01, 2.737E+01, 4.741E+00, 0.000E+00/
      DATA (PH1(I,25, 8, 3),I=1,6) /1.317E+03, 1.889E+02,
     1 1.381E+02, 7.915E+01, 3.619E+00, 1.713E-02/
      DATA (PH1(I,25, 9, 1),I=1,6) /7.132E+03, 1.157E+03,
     1 8.934E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,25, 9, 2),I=1,6) /1.321E+03, 1.802E+02,
     1 8.605E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,25, 9, 3),I=1,6) /1.224E+03, 1.847E+02,
     1 1.647E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,25,10, 1),I=1,6) /7.016E+03, 1.007E+03,
     1 1.191E+01, 3.374E+01, 1.907E+00, 0.000E+00/
      DATA (PH1(I,25,10, 2),I=1,6) /1.239E+03, 1.468E+02,
     1 9.533E+00, 2.564E+01, 4.859E+00, 0.000E+00/
      DATA (PH1(I,25,10, 3),I=1,6) /1.133E+03, 1.588E+02,
     1 2.466E+02, 5.979E+01, 4.044E+00, 1.415E-02/
      DATA (PH1(I,25,11, 1),I=1,6) /6.966E+03, 9.952E+02,
     1 1.220E+01, 3.635E+01, 1.885E+00, 0.000E+00/
      DATA (PH1(I,25,11, 2),I=1,6) /1.195E+03, 1.084E+02,
     1 1.148E+01, 3.003E+01, 5.139E+00, 0.000E+00/
      DATA (PH1(I,25,11, 3),I=1,6) /1.096E+03, 1.576E+02,
     1 2.464E+02, 5.814E+01, 4.081E+00, 1.417E-02/
      DATA (PH1(I,25,11, 4),I=1,6) /4.352E+02, 5.053E+00,
     1 5.856E+01, 1.103E+03, 4.490E+00, 0.000E+00/
      DATA (PH1(I,25,12, 1),I=1,6) /6.919E+03, 1.016E+03,
     1 1.168E+01, 3.428E+01, 1.894E+00, 0.000E+00/
      DATA (PH1(I,25,12, 2),I=1,6) /1.153E+03, 1.412E+02,
     1 9.670E+00, 2.617E+01, 4.900E+00, 0.000E+00/
      DATA (PH1(I,25,12, 3),I=1,6) /1.053E+03, 1.572E+02,
     1 2.455E+02, 5.660E+01, 4.109E+00, 1.411E-02/
      DATA (PH1(I,25,12, 4),I=1,6) /4.030E+02, 1.345E+01,
     1 3.535E+01, 4.180E+02, 4.462E+00, 0.000E+00/
      DATA (PH1(I,25,13, 1),I=1,6) /6.872E+03, 1.025E+03,
     1 1.145E+01, 3.313E+01, 1.902E+00, 0.000E+00/
      DATA (PH1(I,25,13, 2),I=1,6) /1.111E+03, 1.437E+02,
     1 9.475E+00, 2.535E+01, 4.916E+00, 0.000E+00/
      DATA (PH1(I,25,13, 3),I=1,6) /1.010E+03, 1.534E+02,
     1 2.551E+02, 5.638E+01, 4.140E+00, 1.436E-02/
      DATA (PH1(I,25,13, 4),I=1,6) /3.731E+02, 2.286E+01,
     1 2.034E+01, 2.772E+02, 4.326E+00, 0.000E+00/
      DATA (PH1(I,25,13, 5),I=1,6) /3.436E+02, 7.288E+01,
     1 1.205E+01, 5.254E+01, 5.787E+00, 1.633E-04/
      DATA (PH1(I,25,14, 1),I=1,6) /6.826E+03, 1.018E+03,
     1 1.161E+01, 3.333E+01, 1.905E+00, 0.000E+00/
      DATA (PH1(I,25,14, 2),I=1,6) /1.070E+03, 1.522E+02,
     1 9.043E+00, 2.474E+01, 4.856E+00, 0.000E+00/
      DATA (PH1(I,25,14, 3),I=1,6) /9.690E+02, 1.541E+02,
     1 2.509E+02, 5.596E+01, 4.141E+00, 1.435E-02/
      DATA (PH1(I,25,14, 4),I=1,6) /3.427E+02, 2.273E+01,
     1 1.932E+01, 2.771E+02, 4.340E+00, 0.000E+00/
      DATA (PH1(I,25,14, 5),I=1,6) /3.144E+02, 7.442E+01,
     1 2.225E+01, 4.974E+01, 5.829E+00, 4.047E-01/
      DATA (PH1(I,25,15, 1),I=1,6) /6.778E+03, 1.164E+03,
     1 8.718E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,25,15, 2),I=1,6) /1.027E+03, 1.846E+02,
     1 7.670E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,25,15, 3),I=1,6) /9.238E+02, 1.990E+02,
     1 1.508E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,25,15, 4),I=1,6) /3.118E+02, 3.864E+01,
     1 1.074E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,25,15, 5),I=1,6) /2.860E+02, 7.574E+01,
     1 3.181E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,25,16, 1),I=1,6) /6.741E+03, 1.013E+03,
     1 1.172E+01, 3.345E+01, 1.909E+00, 0.000E+00/
      DATA (PH1(I,25,16, 2),I=1,6) /9.939E+02, 1.554E+02,
     1 8.799E+00, 2.403E+01, 4.866E+00, 0.000E+00/
      DATA (PH1(I,25,16, 3),I=1,6) /8.910E+02, 1.555E+02,
     1 2.430E+02, 5.379E+01, 4.166E+00, 1.402E-02/
      DATA (PH1(I,25,16, 4),I=1,6) /2.840E+02, 2.364E+01,
     1 1.585E+01, 2.573E+02, 4.393E+00, 0.000E+00/
      DATA (PH1(I,25,16, 5),I=1,6) /2.483E+02, 7.277E+01,
     1 4.169E+01, 4.324E+01, 6.012E+00, 3.835E-01/
      DATA (PH1(I,25,17, 1),I=1,6) /6.698E+03, 1.167E+03,
     1 8.667E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,25,17, 2),I=1,6) /9.536E+02, 1.856E+02,
     1 7.522E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,25,17, 3),I=1,6) /8.492E+02, 1.997E+02,
     1 1.482E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,25,17, 4),I=1,6) /2.547E+02, 3.986E+01,
     1 9.199E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,25,17, 5),I=1,6) /2.218E+02, 7.629E+01,
     1 4.645E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,25,18, 1),I=1,6) /6.664E+03, 1.021E+03,
     1 1.152E+01, 3.256E+01, 1.914E+00, 0.000E+00/
      DATA (PH1(I,25,18, 2),I=1,6) /9.230E+02, 1.679E+02,
     1 8.168E+00, 2.438E+01, 4.732E+00, 0.000E+00/
      DATA (PH1(I,25,18, 3),I=1,6) /8.191E+02, 1.748E+02,
     1 1.921E+02, 5.809E+01, 3.973E+00, 1.717E-02/
      DATA (PH1(I,25,18, 4),I=1,6) /2.282E+02, 5.334E+01,
     1 7.236E+00, 4.454E+02, 3.624E+00, 0.000E+00/
      DATA (PH1(I,25,18, 5),I=1,6) /1.945E+02, 7.818E+01,
     1 4.992E+01, 4.763E+01, 5.832E+00, 3.093E-01/
      DATA (PH1(I,25,19, 1),I=1,6) /6.635E+03, 1.021E+03,
     1 1.154E+01, 3.219E+01, 1.919E+00, 0.000E+00/
      DATA (PH1(I,25,19, 2),I=1,6) /8.900E+02, 1.668E+02,
     1 8.196E+00, 2.394E+01, 4.767E+00, 0.000E+00/
      DATA (PH1(I,25,19, 3),I=1,6) /7.860E+02, 1.739E+02,
     1 1.939E+02, 5.345E+01, 4.041E+00, 1.659E-02/
      DATA (PH1(I,25,19, 4),I=1,6) /2.016E+02, 5.184E+01,
     1 6.791E+00, 3.811E+02, 3.719E+00, 0.000E+00/
      DATA (PH1(I,25,19, 5),I=1,6) /1.691E+02, 7.618E+01,
     1 4.935E+01, 3.879E+01, 6.116E+00, 3.087E-01/
      DATA (PH1(I,25,19, 6),I=1,6) /1.193E+02, 3.865E+01,
     1 9.713E+01, 1.133E+02, 5.798E+00, 1.437E-01/
      DATA (PH1(I,25,20, 1),I=1,6) /6.617E+03, 1.171E+03,
     1 8.591E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,25,20, 2),I=1,6) /8.614E+02, 1.867E+02,
     1 7.373E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,25,20, 3),I=1,6) /7.560E+02, 2.007E+02,
     1 1.450E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,25,20, 4),I=1,6) /1.768E+02, 4.271E+01,
     1 7.047E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,25,20, 5),I=1,6) /1.444E+02, 7.861E+01,
     1 4.367E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,25,20, 6),I=1,6) /9.575E+01, 3.452E+01,
     1 2.355E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,25,21, 1),I=1,6) /6.602E+03, 1.045E+03,
     1 1.101E+01, 3.201E+01, 1.902E+00, 0.000E+00/
      DATA (PH1(I,25,21, 2),I=1,6) /8.319E+02, 1.782E+02,
     1 7.660E+00, 2.515E+01, 4.612E+00, 0.000E+00/
      DATA (PH1(I,25,21, 3),I=1,6) /7.280E+02, 1.909E+02,
     1 1.610E+02, 6.064E+01, 3.847E+00, 2.553E-02/
      DATA (PH1(I,25,21, 4),I=1,6) /1.530E+02, 5.019E+01,
     1 5.951E+00, 3.117E+02, 3.866E+00, 0.000E+00/
      DATA (PH1(I,25,21, 5),I=1,6) /1.210E+02, 6.892E+01,
     1 5.293E+01, 2.594E+01, 6.855E+00, 1.836E-01/
      DATA (PH1(I,25,21, 6),I=1,6) /7.240E+01, 3.798E+01,
     1 2.289E+02, 7.678E+01, 6.206E+00, 6.108E-02/
      DATA (PH1(I,25,22, 1),I=1,6) /6.589E+03, 1.174E+03,
     1 8.541E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,25,22, 2),I=1,6) /8.118E+02, 1.872E+02,
     1 7.318E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,25,22, 3),I=1,6) /7.063E+02, 2.015E+02,
     1 1.433E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,25,22, 4),I=1,6) /1.300E+02, 4.531E+01,
     1 5.863E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,25,22, 5),I=1,6) /9.879E+01, 8.115E+01,
     1 3.665E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,25,22, 6),I=1,6) /5.120E+01, 3.615E+01,
     1 3.188E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,25,23, 1),I=1,6) /6.576E+03, 1.154E+03,
     1 8.979E+00, 2.899E+01, 1.859E+00, 0.000E+00/
      DATA (PH1(I,25,23, 2),I=1,6) /7.947E+02, 2.016E+02,
     1 6.777E+00, 2.756E+01, 4.332E+00, 0.000E+00/
      DATA (PH1(I,25,23, 3),I=1,6) /6.822E+02, 1.908E+02,
     1 1.609E+02, 6.198E+01, 3.835E+00, 2.549E-02/
      DATA (PH1(I,25,23, 4),I=1,6) /1.120E+02, 4.956E+01,
     1 5.285E+00, 2.544E+02, 4.005E+00, 0.000E+00/
      DATA (PH1(I,25,23, 5),I=1,6) /8.062E+01, 7.190E+01,
     1 4.707E+01, 2.356E+01, 6.977E+00, 2.565E-01/
      DATA (PH1(I,25,23, 6),I=1,6) /3.367E+01, 1.604E+01,
     1 1.991E+05, 2.538E+00, 1.808E+01, 6.536E-01/
      DATA (PH1(I,25,24, 1),I=1,6) /6.564E+03, 8.684E+02,
     1 1.627E+01, 2.405E+01, 2.207E+00, 0.000E+00/
      DATA (PH1(I,25,24, 2),I=1,6) /7.849E+02, 1.346E+02,
     1 9.823E+00, 1.970E+01, 5.386E+00, 0.000E+00/
      DATA (PH1(I,25,24, 3),I=1,6) /6.714E+02, 2.207E+02,
     1 1.185E+02, 9.212E+01, 3.460E+00, 1.974E-01/
      DATA (PH1(I,25,24, 4),I=1,6) /1.015E+02, 4.359E+01,
     1 5.735E+00, 1.016E+02, 4.563E+00, 0.000E+00/
      DATA (PH1(I,25,24, 5),I=1,6) /7.009E+01, 7.141E+01,
     1 4.984E+01, 2.130E+01, 7.133E+00, 2.616E-01/
      DATA (PH1(I,25,24, 6),I=1,6) /2.058E+01, 1.624E+01,
     1 2.592E+05, 2.411E+00, 1.797E+01, 4.774E-01/
      DATA (PH1(I,25,24, 7),I=1,6) /1.564E+01, 9.306E+00,
     1 1.189E+00, 1.439E+09, 4.095E+00, 8.740E-04/
      DATA (PH1(I,25,25, 1),I=1,6) /6.550E+03, 8.758E+02,
     1 1.592E+01, 3.965E+01, 1.947E+00, 0.000E+00/
      DATA (PH1(I,25,25, 2),I=1,6) /7.816E+02, 8.316E+01,
     1 1.156E+01, 2.187E+01, 6.149E+00, 0.000E+00/
      DATA (PH1(I,25,25, 3),I=1,6) /6.554E+02, 2.737E+02,
     1 7.498E+01, 3.952E+02, 2.793E+00, 4.661E-02/
      DATA (PH1(I,25,25, 4),I=1,6) /9.460E+01, 4.114E+01,
     1 6.172E+00, 5.928E+01, 4.989E+00, 0.000E+00/
      DATA (PH1(I,25,25, 5),I=1,6) /5.940E+01, 7.040E+01,
     1 6.697E+01, 1.485E+01, 7.643E+00, 2.659E-01/
      DATA (PH1(I,25,25, 6),I=1,6) /1.430E+01, 1.311E+01,
     1 1.668E+04, 4.497E+00, 1.646E+01, 3.881E-01/
      DATA (PH1(I,25,25, 7),I=1,6) /7.434E+00, 1.183E+01,
     1 1.549E+00, 2.920E+06, 4.113E+00, 3.256E-02/
      DATA (PH1(I,26, 1, 1),I=1,6) /9.278E+03, 2.932E+02,
     1 8.099E+01, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,26, 2, 1),I=1,6) /8.829E+03, 1.057E+03,
     1 1.195E+01, 5.769E+01, 1.718E+00, 0.000E+00/
      DATA (PH1(I,26, 3, 1),I=1,6) /8.638E+03, 1.087E+03,
     1 1.157E+01, 5.086E+01, 1.722E+00, 0.000E+00/
      DATA (PH1(I,26, 3, 2),I=1,6) /2.046E+03, 1.873E+02,
     1 5.833E+00, 3.849E+01, 3.998E+00, 0.000E+00/
      DATA (PH1(I,26, 4, 1),I=1,6) /8.484E+03, 1.215E+03,
     1 9.098E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,26, 4, 2),I=1,6) /1.950E+03, 1.799E+02,
     1 1.138E+01, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,26, 5, 1),I=1,6) /8.350E+03, 1.066E+03,
     1 1.181E+01, 4.116E+01, 1.827E+00, 0.000E+00/
      DATA (PH1(I,26, 5, 2),I=1,6) /1.847E+03, 1.708E+02,
     1 1.125E+01, 2.839E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,26, 5, 3),I=1,6) /1.799E+03, 8.070E+01,
     1 2.675E+02, 1.191E+02, 4.194E+00, 1.901E-05/
      DATA (PH1(I,26, 6, 1),I=1,6) /8.184E+03, 1.228E+03,
     1 8.773E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,26, 6, 2),I=1,6) /1.745E+03, 1.860E+02,
     1 9.942E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,26, 6, 3),I=1,6) /1.689E+03, 1.970E+02,
     1 7.720E+01, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,26, 7, 1),I=1,6) /8.041E+03, 1.235E+03,
     1 8.619E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,26, 7, 2),I=1,6) /1.648E+03, 1.888E+02,
     1 9.298E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,26, 7, 3),I=1,6) /1.582E+03, 1.975E+02,
     1 1.093E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,26, 8, 1),I=1,6) /7.918E+03, 1.068E+03,
     1 1.155E+01, 3.578E+01, 1.895E+00, 0.000E+00/
      DATA (PH1(I,26, 8, 2),I=1,6) /1.559E+03, 1.623E+02,
     1 1.000E+01, 2.675E+01, 4.711E+00, 0.000E+00/
      DATA (PH1(I,26, 8, 3),I=1,6) /1.456E+03, 1.338E+02,
     1 3.000E+02, 7.010E+01, 4.143E+00, 1.631E-05/
      DATA (PH1(I,26, 9, 1),I=1,6) /7.769E+03, 1.249E+03,
     1 8.327E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,26, 9, 2),I=1,6) /1.460E+03, 1.940E+02,
     1 8.150E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,26, 9, 3),I=1,6) /1.358E+03, 1.999E+02,
     1 1.561E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,26,10, 1),I=1,6) /7.651E+03, 1.067E+03,
     1 1.150E+01, 3.412E+01, 1.922E+00, 0.000E+00/
      DATA (PH1(I,26,10, 2),I=1,6) /1.375E+03, 1.534E+02,
     1 9.191E+00, 2.691E+01, 4.849E+00, 0.000E+00/
      DATA (PH1(I,26,10, 3),I=1,6) /1.262E+03, 1.412E+02,
     1 3.368E+02, 5.569E+01, 4.328E+00, 1.177E-05/
      DATA (PH1(I,26,11, 1),I=1,6) /7.599E+03, 1.061E+03,
     1 1.161E+01, 3.713E+01, 1.889E+00, 0.000E+00/
      DATA (PH1(I,26,11, 2),I=1,6) /1.329E+03, 1.363E+02,
     1 9.940E+00, 3.026E+01, 4.885E+00, 0.000E+00/
      DATA (PH1(I,26,11, 3),I=1,6) /1.216E+03, 1.396E+02,
     1 3.383E+02, 5.459E+01, 4.366E+00, 1.179E-05/
      DATA (PH1(I,26,11, 4),I=1,6) /4.893E+02, 2.873E+01,
     1 1.207E+01, 5.150E+02, 3.846E+00, 0.000E+00/
      DATA (PH1(I,26,12, 1),I=1,6) /7.553E+03, 1.258E+03,
     1 8.097E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,26,12, 2),I=1,6) /1.287E+03, 1.967E+02,
     1 7.555E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,26,12, 3),I=1,6) /1.181E+03, 2.136E+02,
     1 1.496E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,26,12, 4),I=1,6) /4.570E+02, 4.064E+01,
     1 1.228E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,26,13, 1),I=1,6) /7.499E+03, 1.112E+03,
     1 1.052E+01, 3.562E+01, 1.871E+00, 0.000E+00/
      DATA (PH1(I,26,13, 2),I=1,6) /1.240E+03, 1.724E+02,
     1 8.240E+00, 2.693E+01, 4.675E+00, 0.000E+00/
      DATA (PH1(I,26,13, 3),I=1,6) /1.125E+03, 1.387E+02,
     1 3.367E+02, 5.279E+01, 4.407E+00, 1.111E-05/
      DATA (PH1(I,26,13, 4),I=1,6) /4.238E+02, 7.077E+01,
     1 7.969E+00, 5.650E+02, 3.329E+00, 0.000E+00/
      DATA (PH1(I,26,13, 5),I=1,6) /3.922E+02, 7.993E+01,
     1 1.135E+01, 5.807E+01, 5.676E+00, 6.512E-02/
      DATA (PH1(I,26,14, 1),I=1,6) /7.450E+03, 1.103E+03,
     1 1.069E+01, 3.585E+01, 1.875E+00, 0.000E+00/
      DATA (PH1(I,26,14, 2),I=1,6) /1.197E+03, 1.722E+02,
     1 8.199E+00, 2.626E+01, 4.710E+00, 0.000E+00/
      DATA (PH1(I,26,14, 3),I=1,6) /1.081E+03, 1.392E+02,
     1 3.316E+02, 5.237E+01, 4.410E+00, 1.107E-05/
      DATA (PH1(I,26,14, 4),I=1,6) /3.916E+02, 6.712E+01,
     1 8.093E+00, 5.886E+02, 3.360E+00, 0.000E+00/
      DATA (PH1(I,26,14, 5),I=1,6) /3.610E+02, 8.203E+01,
     1 2.092E+01, 6.128E+01, 5.596E+00, 3.441E-02/
      DATA (PH1(I,26,15, 1),I=1,6) /7.403E+03, 1.096E+03,
     1 1.083E+01, 3.612E+01, 1.878E+00, 0.000E+00/
      DATA (PH1(I,26,15, 2),I=1,6) /1.155E+03, 1.720E+02,
     1 8.161E+00, 2.570E+01, 4.741E+00, 0.000E+00/
      DATA (PH1(I,26,15, 3),I=1,6) /1.039E+03, 1.383E+02,
     1 3.325E+02, 5.090E+01, 4.446E+00, 1.114E-05/
      DATA (PH1(I,26,15, 4),I=1,6) /3.600E+02, 6.329E+01,
     1 8.143E+00, 5.637E+02, 3.421E+00, 0.000E+00/
      DATA (PH1(I,26,15, 5),I=1,6) /3.308E+02, 8.150E+01,
     1 3.022E+01, 6.039E+01, 5.612E+00, 2.772E-02/
      DATA (PH1(I,26,16, 1),I=1,6) /7.359E+03, 1.095E+03,
     1 1.084E+01, 3.598E+01, 1.880E+00, 0.000E+00/
      DATA (PH1(I,26,16, 2),I=1,6) /1.115E+03, 1.714E+02,
     1 8.138E+00, 2.516E+01, 4.774E+00, 0.000E+00/
      DATA (PH1(I,26,16, 3),I=1,6) /9.983E+02, 1.632E+02,
     1 2.449E+02, 5.452E+01, 4.187E+00, 1.594E-05/
      DATA (PH1(I,26,16, 4),I=1,6) /3.292E+02, 6.060E+01,
     1 7.963E+00, 5.214E+02, 3.487E+00, 0.000E+00/
      DATA (PH1(I,26,16, 5),I=1,6) /2.902E+02, 7.972E+01,
     1 3.922E+01, 5.574E+01, 5.729E+00, 2.828E-02/
      DATA (PH1(I,26,17, 1),I=1,6) /7.316E+03, 1.098E+03,
     1 1.078E+01, 3.596E+01, 1.878E+00, 0.000E+00/
      DATA (PH1(I,26,17, 2),I=1,6) /1.076E+03, 1.710E+02,
     1 8.135E+00, 2.440E+01, 4.817E+00, 0.000E+00/
      DATA (PH1(I,26,17, 3),I=1,6) /9.590E+02, 1.647E+02,
     1 2.392E+02, 5.276E+01, 4.204E+00, 1.574E-05/
      DATA (PH1(I,26,17, 4),I=1,6) /2.990E+02, 5.854E+01,
     1 7.650E+00, 4.679E+02, 3.561E+00, 0.000E+00/
      DATA (PH1(I,26,17, 5),I=1,6) /2.621E+02, 7.914E+01,
     1 4.686E+01, 5.125E+01, 5.835E+00, 2.574E-02/
      DATA (PH1(I,26,18, 1),I=1,6) /7.275E+03, 1.102E+03,
     1 1.068E+01, 3.576E+01, 1.878E+00, 0.000E+00/
      DATA (PH1(I,26,18, 2),I=1,6) /1.039E+03, 1.706E+02,
     1 8.130E+00, 2.387E+01, 4.850E+00, 0.000E+00/
      DATA (PH1(I,26,18, 3),I=1,6) /9.211E+02, 1.715E+02,
     1 2.205E+02, 5.298E+01, 4.154E+00, 1.508E-05/
      DATA (PH1(I,26,18, 4),I=1,6) /2.696E+02, 5.701E+01,
     1 7.237E+00, 4.092E+02, 3.643E+00, 0.000E+00/
      DATA (PH1(I,26,18, 5),I=1,6) /2.336E+02, 7.704E+01,
     1 5.530E+01, 4.380E+01, 6.059E+00, 2.673E-02/
      DATA (PH1(I,26,19, 1),I=1,6) /7.237E+03, 1.103E+03,
     1 1.067E+01, 3.584E+01, 1.876E+00, 0.000E+00/
      DATA (PH1(I,26,19, 2),I=1,6) /1.003E+03, 1.694E+02,
     1 8.158E+00, 2.345E+01, 4.887E+00, 0.000E+00/
      DATA (PH1(I,26,19, 3),I=1,6) /8.849E+02, 1.788E+02,
     1 2.032E+02, 5.293E+01, 4.107E+00, 1.398E-05/
      DATA (PH1(I,26,19, 4),I=1,6) /2.409E+02, 5.450E+01,
     1 6.938E+00, 3.605E+02, 3.741E+00, 0.000E+00/
      DATA (PH1(I,26,19, 5),I=1,6) /2.055E+02, 7.556E+01,
     1 5.336E+01, 3.855E+01, 6.265E+00, 2.667E-02/
      DATA (PH1(I,26,19, 6),I=1,6) /1.511E+02, 3.652E+01,
     1 1.323E+02, 9.277E+01, 6.150E+00, 2.051E-02/
      DATA (PH1(I,26,20, 1),I=1,6) /7.217E+03, 1.110E+03,
     1 1.055E+01, 3.563E+01, 1.873E+00, 0.000E+00/
      DATA (PH1(I,26,20, 2),I=1,6) /9.693E+02, 1.694E+02,
     1 8.138E+00, 2.316E+01, 4.905E+00, 0.000E+00/
      DATA (PH1(I,26,20, 3),I=1,6) /8.512E+02, 1.840E+02,
     1 1.920E+02, 5.238E+01, 4.082E+00, 1.377E-05/
      DATA (PH1(I,26,20, 4),I=1,6) /2.135E+02, 5.365E+01,
     1 6.463E+00, 3.169E+02, 3.824E+00, 0.000E+00/
      DATA (PH1(I,26,20, 5),I=1,6) /1.783E+02, 7.433E+01,
     1 5.210E+01, 3.306E+01, 6.509E+00, 2.404E-02/
      DATA (PH1(I,26,20, 6),I=1,6) /1.250E+02, 4.332E+01,
     1 1.701E+02, 9.791E+01, 5.905E+00, 2.604E-02/
      DATA (PH1(I,26,21, 1),I=1,6) /7.199E+03, 1.113E+03,
     1 1.049E+01, 3.537E+01, 1.874E+00, 0.000E+00/
      DATA (PH1(I,26,21, 2),I=1,6) /9.383E+02, 1.803E+02,
     1 7.682E+00, 2.415E+01, 4.757E+00, 0.000E+00/
      DATA (PH1(I,26,21, 3),I=1,6) /8.202E+02, 1.952E+02,
     1 1.709E+02, 5.690E+01, 3.953E+00, 1.330E-05/
      DATA (PH1(I,26,21, 4),I=1,6) /1.876E+02, 5.277E+01,
     1 6.047E+00, 2.797E+02, 3.910E+00, 0.000E+00/
      DATA (PH1(I,26,21, 5),I=1,6) /1.527E+02, 7.260E+01,
     1 5.246E+01, 2.751E+01, 6.823E+00, 2.105E-02/
      DATA (PH1(I,26,21, 6),I=1,6) /9.906E+01, 4.487E+01,
     1 2.082E+02, 9.579E+01, 5.914E+00, 2.368E-02/
      DATA (PH1(I,26,22, 1),I=1,6) /7.184E+03, 1.124E+03,
     1 1.027E+01, 3.534E+01, 1.866E+00, 0.000E+00/
      DATA (PH1(I,26,22, 2),I=1,6) /9.101E+02, 1.818E+02,
     1 7.623E+00, 2.401E+01, 4.752E+00, 0.000E+00/
      DATA (PH1(I,26,22, 3),I=1,6) /7.920E+02, 1.996E+02,
     1 1.636E+02, 5.719E+01, 3.924E+00, 1.320E-05/
      DATA (PH1(I,26,22, 4),I=1,6) /1.633E+02, 5.218E+01,
     1 5.672E+00, 2.482E+02, 3.991E+00, 0.000E+00/
      DATA (PH1(I,26,22, 5),I=1,6) /1.288E+02, 7.273E+01,
     1 5.143E+01, 2.428E+01, 7.028E+00, 1.365E-01/
      DATA (PH1(I,26,22, 6),I=1,6) /7.501E+01, 4.369E+01,
     1 2.661E+02, 6.273E+01, 6.344E+00, 2.402E-01/
      DATA (PH1(I,26,23, 1),I=1,6) /7.169E+03, 1.155E+03,
     1 9.711E+00, 3.329E+01, 1.869E+00, 0.000E+00/
      DATA (PH1(I,26,23, 2),I=1,6) /8.871E+02, 2.059E+02,
     1 6.695E+00, 2.772E+01, 4.410E+00, 0.000E+00/
      DATA (PH1(I,26,23, 3),I=1,6) /7.669E+02, 2.032E+02,
     1 1.578E+02, 5.933E+01, 3.879E+00, 1.308E-05/
      DATA (PH1(I,26,23, 4),I=1,6) /1.411E+02, 5.256E+01,
     1 5.295E+00, 2.332E+02, 4.036E+00, 0.000E+00/
      DATA (PH1(I,26,23, 5),I=1,6) /1.067E+02, 7.625E+01,
     1 4.810E+01, 2.286E+01, 7.043E+00, 2.449E-01/
      DATA (PH1(I,26,23, 6),I=1,6) /5.480E+01, 4.154E+01,
     1 3.683E+02, 3.529E+01, 7.056E+00, 3.316E-01/
      DATA (PH1(I,26,24, 1),I=1,6) /7.155E+03, 1.245E+03,
     1 8.309E+00, 3.170E+01, 1.826E+00, 0.000E+00/
      DATA (PH1(I,26,24, 2),I=1,6) /8.710E+02, 2.158E+02,
     1 6.454E+00, 2.722E+01, 4.355E+00, 0.000E+00/
      DATA (PH1(I,26,24, 3),I=1,6) /7.451E+02, 2.023E+02,
     1 1.591E+02, 5.990E+01, 3.878E+00, 1.309E-05/
      DATA (PH1(I,26,24, 4),I=1,6) /1.211E+02, 5.277E+01,
     1 5.015E+00, 2.131E+02, 4.093E+00, 0.000E+00/
      DATA (PH1(I,26,24, 5),I=1,6) /8.705E+01, 7.777E+01,
     1 4.422E+01, 2.336E+01, 7.017E+00, 2.557E-01/
      DATA (PH1(I,26,24, 6),I=1,6) /3.065E+01, 2.670E+01,
     1 6.301E+03, 5.385E+00, 1.232E+01, 4.407E-01/
      DATA (PH1(I,26,25, 1),I=1,6) /7.140E+03, 8.931E+02,
     1 1.666E+01, 2.381E+01, 2.262E+00, 0.000E+00/
      DATA (PH1(I,26,25, 2),I=1,6) /8.608E+02, 1.431E+02,
     1 9.289E+00, 2.026E+01, 5.376E+00, 0.000E+00/
      DATA (PH1(I,26,25, 3),I=1,6) /7.341E+02, 2.281E+02,
     1 1.241E+02, 8.058E+01, 3.572E+00, 1.223E-01/
      DATA (PH1(I,26,25, 4),I=1,6) /1.102E+02, 4.663E+01,
     1 5.434E+00, 9.271E+01, 4.640E+00, 0.000E+00/
      DATA (PH1(I,26,25, 5),I=1,6) /7.617E+01, 7.750E+01,
     1 4.624E+01, 2.155E+01, 7.138E+00, 2.599E-01/
      DATA (PH1(I,26,25, 6),I=1,6) /2.193E+01, 1.933E+01,
     1 3.679E+04, 3.564E+00, 1.566E+01, 4.144E-01/
      DATA (PH1(I,26,25, 7),I=1,6) /1.619E+01, 1.014E+01,
     1 1.084E+00, 2.562E+04, 4.167E+00, 1.598E-02/
      DATA (PH1(I,26,26, 1),I=1,6) /7.124E+03, 8.044E+02,
     1 2.055E+01, 3.633E+01, 2.118E+00, 0.000E+00/
      DATA (PH1(I,26,26, 2),I=1,6) /8.570E+02, 5.727E+01,
     1 1.076E+01, 2.785E+01, 6.635E+00, 0.000E+00/
      DATA (PH1(I,26,26, 3),I=1,6) /7.240E+02, 2.948E+02,
     1 7.191E+01, 3.219E+02, 2.837E+00, 6.314E-02/
      DATA (PH1(I,26,26, 4),I=1,6) /1.040E+02, 4.334E+01,
     1 5.921E+00, 5.293E+01, 5.129E+00, 0.000E+00/
      DATA (PH1(I,26,26, 5),I=1,6) /6.600E+01, 7.630E+01,
     1 6.298E+01, 1.479E+01, 7.672E+00, 2.646E-01/
      DATA (PH1(I,26,26, 6),I=1,6) /1.470E+01, 1.407E+01,
     1 1.850E+04, 4.458E+00, 1.691E+01, 4.039E-01/
      DATA (PH1(I,26,26, 7),I=1,6) /7.902E+00, 1.277E+01,
     1 1.468E+00, 1.116E+05, 4.112E+00, 3.238E-02/
      DATA (PH1(I,27, 1, 1),I=1,6) /1.001E+04, 3.163E+02,
     1 7.510E+01, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,27, 2, 1),I=1,6) /9.545E+03, 1.251E+03,
     1 9.046E+00, 6.786E+01, 1.613E+00, 0.000E+00/
      DATA (PH1(I,27, 3, 1),I=1,6) /9.347E+03, 1.249E+03,
     1 9.384E+00, 6.378E+01, 1.609E+00, 0.000E+00/
      DATA (PH1(I,27, 3, 2),I=1,6) /2.219E+03, 2.352E+02,
     1 4.599E+00, 3.873E+01, 3.808E+00, 0.000E+00/
      DATA (PH1(I,27, 4, 1),I=1,6) /9.205E+03, 1.267E+03,
     1 9.026E+00, 6.059E+01, 1.619E+00, 0.000E+00/
      DATA (PH1(I,27, 4, 2),I=1,6) /2.119E+03, 1.593E+02,
     1 1.253E+01, 3.366E+01, 4.493E+00, 0.000E+00/
      DATA (PH1(I,27, 5, 1),I=1,6) /9.046E+03, 1.275E+03,
     1 8.806E+00, 5.513E+01, 1.651E+00, 0.000E+00/
      DATA (PH1(I,27, 5, 2),I=1,6) /2.012E+03, 1.799E+02,
     1 1.074E+01, 2.878E+01, 4.518E+00, 0.000E+00/
      DATA (PH1(I,27, 5, 3),I=1,6) /1.961E+03, 1.923E+02,
     1 4.987E+01, 9.392E+01, 3.631E+00, 2.239E-05/
      DATA (PH1(I,27, 6, 1),I=1,6) /8.890E+03, 1.277E+03,
     1 8.703E+00, 5.267E+01, 1.668E+00, 0.000E+00/
      DATA (PH1(I,27, 6, 2),I=1,6) /1.910E+03, 1.760E+02,
     1 1.043E+01, 2.775E+01, 4.612E+00, 0.000E+00/
      DATA (PH1(I,27, 6, 3),I=1,6) /1.846E+03, 2.159E+02,
     1 7.348E+01, 9.457E+01, 3.535E+00, 1.182E-05/
      DATA (PH1(I,27, 7, 1),I=1,6) /8.718E+03, 1.330E+03,
     1 8.042E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,27, 7, 2),I=1,6) /1.803E+03, 2.030E+02,
     1 8.771E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,27, 7, 3),I=1,6) /1.735E+03, 2.134E+02,
     1 1.027E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,27, 8, 1),I=1,6) /8.595E+03, 1.260E+03,
     1 8.868E+00, 4.790E+01, 1.717E+00, 0.000E+00/
      DATA (PH1(I,27, 8, 2),I=1,6) /1.711E+03, 1.706E+02,
     1 9.597E+00, 2.731E+01, 4.722E+00, 0.000E+00/
      DATA (PH1(I,27, 8, 3),I=1,6) /1.603E+03, 2.448E+02,
     1 9.893E+01, 9.263E+01, 3.432E+00, 9.870E-06/
      DATA (PH1(I,27, 9, 1),I=1,6) /8.433E+03, 1.344E+03,
     1 7.779E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,27, 9, 2),I=1,6) /1.606E+03, 2.084E+02,
     1 7.728E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,27, 9, 3),I=1,6) /1.505E+03, 2.157E+02,
     1 1.481E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,27,10, 1),I=1,6) /8.315E+03, 1.252E+03,
     1 8.903E+00, 4.635E+01, 1.738E+00, 0.000E+00/
      DATA (PH1(I,27,10, 2),I=1,6) /1.519E+03, 1.643E+02,
     1 8.754E+00, 2.695E+01, 4.851E+00, 0.000E+00/
      DATA (PH1(I,27,10, 3),I=1,6) /1.397E+03, 2.062E+02,
     1 1.816E+02, 6.860E+01, 3.824E+00, 9.070E-06/
      DATA (PH1(I,27,11, 1),I=1,6) /8.260E+03, 1.249E+03,
     1 8.967E+00, 4.909E+01, 1.719E+00, 0.000E+00/
      DATA (PH1(I,27,11, 2),I=1,6) /1.470E+03, 1.433E+02,
     1 9.597E+00, 2.996E+01, 4.928E+00, 0.000E+00/
      DATA (PH1(I,27,11, 3),I=1,6) /1.362E+03, 2.054E+02,
     1 1.804E+02, 6.660E+01, 3.855E+00, 8.999E-06/
      DATA (PH1(I,27,11, 4),I=1,6) /5.466E+02, 1.262E+01,
     1 2.734E+01, 6.463E+02, 4.280E+00, 0.000E+00/
      DATA (PH1(I,27,12, 1),I=1,6) /8.207E+03, 1.277E+03,
     1 8.536E+00, 4.760E+01, 1.714E+00, 0.000E+00/
      DATA (PH1(I,27,12, 2),I=1,6) /1.423E+03, 1.673E+02,
     1 8.543E+00, 2.705E+01, 4.820E+00, 0.000E+00/
      DATA (PH1(I,27,12, 3),I=1,6) /1.314E+03, 2.058E+02,
     1 1.783E+02, 6.530E+01, 3.868E+00, 8.972E-06/
      DATA (PH1(I,27,12, 4),I=1,6) /5.120E+02, 2.690E+01,
     1 2.122E+01, 3.166E+02, 4.210E+00, 0.000E+00/
      DATA (PH1(I,27,13, 1),I=1,6) /8.154E+03, 1.277E+03,
     1 8.527E+00, 4.599E+01, 1.727E+00, 0.000E+00/
      DATA (PH1(I,27,13, 2),I=1,6) /1.376E+03, 1.726E+02,
     1 8.292E+00, 2.627E+01, 4.812E+00, 0.000E+00/
      DATA (PH1(I,27,13, 3),I=1,6) /1.266E+03, 1.933E+02,
     1 2.002E+02, 6.453E+01, 3.945E+00, 9.099E-06/
      DATA (PH1(I,27,13, 4),I=1,6) /4.777E+02, 2.652E+01,
     1 1.977E+01, 2.830E+02, 4.297E+00, 0.000E+00/
      DATA (PH1(I,27,13, 5),I=1,6) /4.440E+02, 1.358E+02,
     1 6.171E+00, 4.715E+01, 5.247E+00, 8.240E-01/
      DATA (PH1(I,27,14, 1),I=1,6) /8.102E+03, 1.272E+03,
     1 8.593E+00, 4.604E+01, 1.730E+00, 0.000E+00/
      DATA (PH1(I,27,14, 2),I=1,6) /1.331E+03, 1.718E+02,
     1 8.247E+00, 2.592E+01, 4.840E+00, 0.000E+00/
      DATA (PH1(I,27,14, 3),I=1,6) /1.219E+03, 1.931E+02,
     1 1.993E+02, 6.407E+01, 3.953E+00, 9.111E-06/
      DATA (PH1(I,27,14, 4),I=1,6) /4.436E+02, 2.529E+01,
     1 1.979E+01, 2.943E+02, 4.315E+00, 0.000E+00/
      DATA (PH1(I,27,14, 5),I=1,6) /4.110E+02, 9.918E+01,
     1 1.786E+01, 5.216E+01, 5.592E+00, 5.707E-01/
      DATA (PH1(I,27,15, 1),I=1,6) /8.045E+03, 1.361E+03,
     1 7.456E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,27,15, 2),I=1,6) /1.281E+03, 2.135E+02,
     1 6.900E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,27,15, 3),I=1,6) /1.167E+03, 2.301E+02,
     1 1.403E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,27,15, 4),I=1,6) /4.088E+02, 4.412E+01,
     1 1.052E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,27,15, 5),I=1,6) /3.790E+02, 8.885E+01,
     1 2.993E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,27,16, 1),I=1,6) /8.005E+03, 1.264E+03,
     1 8.703E+00, 4.638E+01, 1.732E+00, 0.000E+00/
      DATA (PH1(I,27,16, 2),I=1,6) /1.244E+03, 1.755E+02,
     1 8.017E+00, 2.508E+01, 4.854E+00, 0.000E+00/
      DATA (PH1(I,27,16, 3),I=1,6) /1.131E+03, 1.925E+02,
     1 1.972E+02, 6.228E+01, 3.980E+00, 9.096E-06/
      DATA (PH1(I,27,16, 4),I=1,6) /3.775E+02, 2.185E+01,
     1 1.954E+01, 3.125E+02, 4.423E+00, 0.000E+00/
      DATA (PH1(I,27,16, 5),I=1,6) /3.360E+02, 9.235E+01,
     1 3.595E+01, 4.513E+01, 5.839E+00, 5.704E-01/
      DATA (PH1(I,27,17, 1),I=1,6) /7.951E+03, 1.362E+03,
     1 7.447E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,27,17, 2),I=1,6) /1.196E+03, 2.146E+02,
     1 6.772E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,27,17, 3),I=1,6) /1.080E+03, 2.305E+02,
     1 1.383E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,27,17, 4),I=1,6) /3.439E+02, 4.522E+01,
     1 9.201E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,27,17, 5),I=1,6) /3.053E+02, 8.909E+01,
     1 4.487E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,27,18, 1),I=1,6) /7.915E+03, 1.266E+03,
     1 8.671E+00, 4.646E+01, 1.731E+00, 0.000E+00/
      DATA (PH1(I,27,18, 2),I=1,6) /1.163E+03, 1.808E+02,
     1 7.771E+00, 2.435E+01, 4.849E+00, 0.000E+00/
      DATA (PH1(I,27,18, 3),I=1,6) /1.048E+03, 1.922E+02,
     1 1.949E+02, 5.995E+01, 4.013E+00, 9.089E-06/
      DATA (PH1(I,27,18, 4),I=1,6) /3.142E+02, 3.099E+01,
     1 1.193E+01, 2.258E+02, 4.398E+00, 0.000E+00/
      DATA (PH1(I,27,18, 5),I=1,6) /2.754E+02, 9.052E+01,
     1 5.045E+01, 4.052E+01, 6.001E+00, 4.620E-01/
      DATA (PH1(I,27,19, 1),I=1,6) /7.877E+03, 1.287E+03,
     1 8.375E+00, 4.957E+01, 1.697E+00, 0.000E+00/
      DATA (PH1(I,27,19, 2),I=1,6) /1.123E+03, 1.802E+02,
     1 7.760E+00, 2.395E+01, 4.878E+00, 0.000E+00/
      DATA (PH1(I,27,19, 3),I=1,6) /1.009E+03, 1.943E+02,
     1 1.901E+02, 5.795E+01, 4.029E+00, 8.959E-06/
      DATA (PH1(I,27,19, 4),I=1,6) /2.833E+02, 3.765E+01,
     1 9.284E+00, 1.936E+02, 4.355E+00, 0.000E+00/
      DATA (PH1(I,27,19, 5),I=1,6) /2.450E+02, 9.011E+01,
     1 4.789E+01, 3.807E+01, 6.102E+00, 4.132E-01/
      DATA (PH1(I,27,19, 6),I=1,6) /1.861E+02, 3.461E+01,
     1 1.735E+02, 7.681E+01, 6.518E+00, 1.706E-04/
      DATA (PH1(I,27,20, 1),I=1,6) /7.840E+03, 1.363E+03,
     1 7.433E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,27,20, 2),I=1,6) /1.086E+03, 2.158E+02,
     1 6.639E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,27,20, 3),I=1,6) /9.692E+02, 2.313E+02,
     1 1.357E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,27,20, 4),I=1,6) /2.544E+02, 4.790E+01,
     1 7.244E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,27,20, 5),I=1,6) /2.158E+02, 9.095E+01,
     1 4.368E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,27,20, 6),I=1,6) /1.578E+02, 4.257E+01,
     1 2.299E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,27,21, 1),I=1,6) /7.820E+03, 1.295E+03,
     1 8.260E+00, 5.104E+01, 1.682E+00, 0.000E+00/
      DATA (PH1(I,27,21, 2),I=1,6) /1.052E+03, 1.797E+02,
     1 7.740E+00, 2.344E+01, 4.914E+00, 0.000E+00/
      DATA (PH1(I,27,21, 3),I=1,6) /9.379E+02, 2.015E+02,
     1 1.767E+02, 5.582E+01, 4.018E+00, 8.773E-06/
      DATA (PH1(I,27,21, 4),I=1,6) /2.255E+02, 4.430E+01,
     1 6.990E+00, 1.659E+02, 4.350E+00, 0.000E+00/
      DATA (PH1(I,27,21, 5),I=1,6) /1.876E+02, 8.695E+01,
     1 4.460E+01, 3.324E+01, 6.378E+00, 3.125E-01/
      DATA (PH1(I,27,21, 6),I=1,6) /1.290E+02, 4.433E+01,
     1 2.748E+02, 5.829E+01, 6.482E+00, 1.086E-04/
      DATA (PH1(I,27,22, 1),I=1,6) /7.803E+03, 1.364E+03,
     1 7.423E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,27,22, 2),I=1,6) /1.025E+03, 2.163E+02,
     1 6.587E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,27,22, 3),I=1,6) /9.074E+02, 2.319E+02,
     1 1.344E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,27,22, 4),I=1,6) /1.999E+02, 5.038E+01,
     1 6.114E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,27,22, 5),I=1,6) /1.619E+02, 9.318E+01,
     1 3.733E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,27,22, 6),I=1,6) /1.020E+02, 4.352E+01,
     1 3.483E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,27,23, 1),I=1,6) /7.788E+03, 1.313E+03,
     1 8.026E+00, 5.052E+01, 1.675E+00, 0.000E+00/
      DATA (PH1(I,27,23, 2),I=1,6) /9.918E+02, 1.840E+02,
     1 7.606E+00, 2.298E+01, 4.903E+00, 0.000E+00/
      DATA (PH1(I,27,23, 3),I=1,6) /8.775E+02, 2.077E+02,
     1 1.666E+02, 5.503E+01, 3.993E+00, 8.505E-06/
      DATA (PH1(I,27,23, 4),I=1,6) /1.740E+02, 5.017E+01,
     1 5.619E+00, 1.481E+02, 4.342E+00, 0.000E+00/
      DATA (PH1(I,27,23, 5),I=1,6) /1.366E+02, 8.377E+01,
     1 4.275E+01, 2.773E+01, 6.744E+00, 2.457E-01/
      DATA (PH1(I,27,23, 6),I=1,6) /7.950E+01, 4.369E+01,
     1 3.792E+02, 4.396E+01, 6.895E+00, 1.079E-04/
      DATA (PH1(I,27,24, 1),I=1,6) /7.773E+03, 1.365E+03,
     1 7.414E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,27,24, 2),I=1,6) /9.708E+02, 2.166E+02,
     1 6.563E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,27,24, 3),I=1,6) /8.556E+02, 2.326E+02,
     1 1.332E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,27,24, 4),I=1,6) /1.495E+02, 5.342E+01,
     1 5.159E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,27,24, 5),I=1,6) /1.128E+02, 9.621E+01,
     1 3.175E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,27,24, 6),I=1,6) /5.127E+01, 4.530E+01,
     1 3.755E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,27,25, 1),I=1,6) /7.758E+03, 1.487E+03,
     1 6.149E+00, 5.282E+01, 1.571E+00, 0.000E+00/
      DATA (PH1(I,27,25, 2),I=1,6) /9.547E+02, 2.172E+02,
     1 6.667E+00, 2.353E+01, 4.602E+00, 0.000E+00/
      DATA (PH1(I,27,25, 3),I=1,6) /8.295E+02, 2.089E+02,
     1 1.651E+02, 5.457E+01, 3.992E+00, 8.474E-06/
      DATA (PH1(I,27,25, 4),I=1,6) /1.305E+02, 5.435E+01,
     1 4.874E+00, 1.379E+02, 4.336E+00, 0.000E+00/
      DATA (PH1(I,27,25, 5),I=1,6) /9.362E+01, 8.419E+01,
     1 4.192E+01, 2.297E+01, 7.043E+00, 2.547E-01/
      DATA (PH1(I,27,25, 6),I=1,6) /3.350E+01, 2.181E+01,
     1 1.205E+03, 1.434E+01, 1.114E+01, 1.266E-02/
      DATA (PH1(I,27,26, 1),I=1,6) /7.742E+03, 2.079E+03,
     1 3.020E+00, 1.067E+03, 9.653E-01, 0.000E+00/
      DATA (PH1(I,27,26, 2),I=1,6) /9.443E+02, 1.709E+02,
     1 8.001E+00, 2.274E+01, 5.044E+00, 0.000E+00/
      DATA (PH1(I,27,26, 3),I=1,6) /8.130E+02, 1.989E+02,
     1 1.810E+02, 5.274E+01, 4.078E+00, 1.431E-04/
      DATA (PH1(I,27,26, 4),I=1,6) /1.213E+02, 5.602E+01,
     1 4.666E+00, 1.358E+02, 4.323E+00, 0.000E+00/
      DATA (PH1(I,27,26, 5),I=1,6) /7.621E+01, 8.408E+01,
     1 4.300E+01, 2.074E+01, 7.214E+00, 2.553E-01/
      DATA (PH1(I,27,26, 6),I=1,6) /1.708E+01, 2.419E+00,
     1 1.275E+01, 2.823E+01, 1.843E+01, 4.806E-05/
      DATA (PH1(I,27,27, 1),I=1,6) /7.725E+03, 6.269E+02,
     1 3.582E+01, 3.161E+01, 2.476E+00, 0.000E+00/
      DATA (PH1(I,27,27, 2),I=1,6) /9.400E+02, 8.888E+01,
     1 1.030E+01, 2.797E+01, 5.913E+00, 0.000E+00/
      DATA (PH1(I,27,27, 3),I=1,6) /8.000E+02, 2.832E+02,
     1 9.075E+01, 7.686E+01, 3.416E+00, 4.833E-05/
      DATA (PH1(I,27,27, 4),I=1,6) /1.150E+02, 5.097E+01,
     1 4.896E+00, 1.198E+02, 4.513E+00, 0.000E+00/
      DATA (PH1(I,27,27, 5),I=1,6) /7.300E+01, 8.256E+01,
     1 4.587E+01, 1.973E+01, 7.331E+00, 2.573E-01/
      DATA (PH1(I,27,27, 6),I=1,6) /1.580E+01, 1.581E+01,
     1 4.931E+03, 6.607E+00, 1.532E+01, 3.676E-01/
      DATA (PH1(I,27,27, 7),I=1,6) /7.864E+00, 1.370E+01,
     1 1.555E+00, 7.559E+02, 4.337E+00, 3.355E-02/
      DATA (PH1(I,28, 1, 1),I=1,6) /1.078E+04, 3.406E+02,
     1 6.983E+01, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,28, 2, 1),I=1,6) /1.029E+04, 1.349E+03,
     1 8.382E+00, 7.431E+01, 1.588E+00, 0.000E+00/
      DATA (PH1(I,28, 3, 1),I=1,6) /1.008E+04, 1.373E+03,
     1 8.336E+00, 7.347E+01, 1.558E+00, 0.000E+00/
      DATA (PH1(I,28, 3, 2),I=1,6) /2.399E+03, 1.314E+02,
     1 8.142E+00, 4.522E+01, 4.477E+00, 0.000E+00/
      DATA (PH1(I,28, 4, 1),I=1,6) /9.937E+03, 1.382E+03,
     1 8.149E+00, 6.782E+01, 1.580E+00, 0.000E+00/
      DATA (PH1(I,28, 4, 2),I=1,6) /2.295E+03, 1.813E+02,
     1 1.117E+01, 3.332E+01, 4.426E+00, 0.000E+00/
      DATA (PH1(I,28, 5, 1),I=1,6) /9.771E+03, 1.404E+03,
     1 7.788E+00, 6.396E+01, 1.592E+00, 0.000E+00/
      DATA (PH1(I,28, 5, 2),I=1,6) /2.184E+03, 1.649E+02,
     1 1.145E+01, 2.997E+01, 4.706E+00, 0.000E+00/
      DATA (PH1(I,28, 5, 3),I=1,6) /2.131E+03, 2.473E+02,
     1 3.198E+01, 1.014E+02, 3.435E+00, 2.062E-06/
      DATA (PH1(I,28, 6, 1),I=1,6) /9.609E+03, 1.415E+03,
     1 7.600E+00, 6.229E+01, 1.599E+00, 0.000E+00/
      DATA (PH1(I,28, 6, 2),I=1,6) /2.077E+03, 1.726E+02,
     1 1.052E+01, 2.738E+01, 4.768E+00, 0.000E+00/
      DATA (PH1(I,28, 6, 3),I=1,6) /2.011E+03, 2.139E+02,
     1 8.219E+01, 9.511E+01, 3.615E+00, 6.838E-07/
      DATA (PH1(I,28, 7, 1),I=1,6) /9.423E+03, 1.429E+03,
     1 7.520E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,28, 7, 2),I=1,6) /1.965E+03, 2.177E+02,
     1 8.285E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,28, 7, 3),I=1,6) /1.894E+03, 2.300E+02,
     1 9.666E+01, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,28, 8, 1),I=1,6) /9.300E+03, 1.401E+03,
     1 7.673E+00, 5.681E+01, 1.640E+00, 0.000E+00/
      DATA (PH1(I,28, 8, 2),I=1,6) /1.870E+03, 1.608E+02,
     1 9.953E+00, 2.835E+01, 4.878E+00, 0.000E+00/
      DATA (PH1(I,28, 8, 3),I=1,6) /1.756E+03, 2.140E+02,
     1 1.434E+02, 7.628E+01, 3.752E+00, 5.528E-07/
      DATA (PH1(I,28, 9, 1),I=1,6) /9.125E+03, 1.443E+03,
     1 7.283E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,28, 9, 2),I=1,6) /1.760E+03, 2.233E+02,
     1 7.335E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,28, 9, 3),I=1,6) /1.648E+03, 2.321E+02,
     1 1.405E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,28,10, 1),I=1,6) /9.007E+03, 1.400E+03,
     1 7.626E+00, 5.528E+01, 1.653E+00, 0.000E+00/
      DATA (PH1(I,28,10, 2),I=1,6) /1.669E+03, 1.441E+02,
     1 9.448E+00, 2.779E+01, 5.132E+00, 0.000E+00/
      DATA (PH1(I,28,10, 3),I=1,6) /1.541E+03, 2.358E+02,
     1 1.530E+02, 7.451E+01, 3.705E+00, 4.687E-07/
      DATA (PH1(I,28,11, 1),I=1,6) /8.950E+03, 1.383E+03,
     1 7.837E+00, 5.839E+01, 1.644E+00, 0.000E+00/
      DATA (PH1(I,28,11, 2),I=1,6) /1.618E+03, 1.444E+02,
     1 9.470E+00, 3.104E+01, 4.981E+00, 0.000E+00/
      DATA (PH1(I,28,11, 3),I=1,6) /1.506E+03, 2.334E+02,
     1 1.540E+02, 7.184E+01, 3.746E+00, 4.400E-07/
      DATA (PH1(I,28,11, 4),I=1,6) /6.071E+02, 1.032E+01,
     1 3.674E+01, 8.252E+02, 4.304E+00, 0.000E+00/
      DATA (PH1(I,28,12, 1),I=1,6) /8.894E+03, 1.442E+03,
     1 7.159E+00, 6.122E+01, 1.602E+00, 0.000E+00/
      DATA (PH1(I,28,12, 2),I=1,6) /1.569E+03, 1.824E+02,
     1 8.013E+00, 2.738E+01, 4.780E+00, 0.000E+00/
      DATA (PH1(I,28,12, 3),I=1,6) /1.456E+03, 2.327E+02,
     1 1.539E+02, 7.045E+01, 3.763E+00, 4.221E-07/
      DATA (PH1(I,28,12, 4),I=1,6) /5.713E+02, 2.577E+01,
     1 2.339E+01, 3.455E+02, 4.232E+00, 0.000E+00/
      DATA (PH1(I,28,13, 1),I=1,6) /8.838E+03, 1.452E+03,
     1 7.048E+00, 6.036E+01, 1.602E+00, 0.000E+00/
      DATA (PH1(I,28,13, 2),I=1,6) /1.519E+03, 1.853E+02,
     1 7.851E+00, 2.679E+01, 4.785E+00, 0.000E+00/
      DATA (PH1(I,28,13, 3),I=1,6) /1.405E+03, 2.180E+02,
     1 1.742E+02, 6.951E+01, 3.842E+00, 4.401E-07/
      DATA (PH1(I,28,13, 4),I=1,6) /5.347E+02, 2.505E+01,
     1 2.361E+01, 3.622E+02, 4.225E+00, 0.000E+00/
      DATA (PH1(I,28,13, 5),I=1,6) /4.984E+02, 1.711E+02,
     1 4.708E+00, 4.790E+01, 5.019E+00, 8.478E-01/
      DATA (PH1(I,28,14, 1),I=1,6) /8.783E+03, 1.448E+03,
     1 7.081E+00, 6.137E+01, 1.599E+00, 0.000E+00/
      DATA (PH1(I,28,14, 2),I=1,6) /1.471E+03, 1.841E+02,
     1 7.825E+00, 2.644E+01, 4.816E+00, 0.000E+00/
      DATA (PH1(I,28,14, 3),I=1,6) /1.356E+03, 2.108E+02,
     1 1.846E+02, 6.874E+01, 3.886E+00, 4.288E-07/
      DATA (PH1(I,28,14, 4),I=1,6) /4.988E+02, 2.375E+01,
     1 2.383E+01, 3.786E+02, 4.245E+00, 0.000E+00/
      DATA (PH1(I,28,14, 5),I=1,6) /4.637E+02, 1.543E+02,
     1 1.053E+01, 4.743E+01, 5.176E+00, 8.373E-01/
      DATA (PH1(I,28,15, 1),I=1,6) /8.720E+03, 1.467E+03,
     1 6.912E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,28,15, 2),I=1,6) /1.419E+03, 2.287E+02,
     1 6.549E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,28,15, 3),I=1,6) /1.299E+03, 2.464E+02,
     1 1.356E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,28,15, 4),I=1,6) /4.620E+02, 4.702E+01,
     1 1.037E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,28,15, 5),I=1,6) /4.302E+02, 9.587E+01,
     1 2.890E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,28,16, 1),I=1,6) /8.680E+03, 1.439E+03,
     1 7.182E+00, 6.248E+01, 1.598E+00, 0.000E+00/
      DATA (PH1(I,28,16, 2),I=1,6) /1.379E+03, 1.886E+02,
     1 7.589E+00, 2.560E+01, 4.825E+00, 0.000E+00/
      DATA (PH1(I,28,16, 3),I=1,6) /1.262E+03, 2.088E+02,
     1 1.852E+02, 6.640E+01, 3.924E+00, 4.306E-07/
      DATA (PH1(I,28,16, 4),I=1,6) /4.291E+02, 2.003E+01,
     1 2.274E+01, 3.611E+02, 4.438E+00, 0.000E+00/
      DATA (PH1(I,28,16, 5),I=1,6) /3.840E+02, 1.158E+02,
     1 2.906E+01, 4.380E+01, 5.646E+00, 7.430E-01/
      DATA (PH1(I,28,17, 1),I=1,6) /8.620E+03, 1.467E+03,
     1 6.916E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,28,17, 2),I=1,6) /1.328E+03, 2.299E+02,
     1 6.430E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,28,17, 3),I=1,6) /1.207E+03, 2.467E+02,
     1 1.337E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,28,17, 4),I=1,6) /3.933E+02, 4.806E+01,
     1 9.150E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,28,17, 5),I=1,6) /3.521E+02, 9.596E+01,
     1 4.382E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,28,18, 1),I=1,6) /8.584E+03, 1.440E+03,
     1 7.163E+00, 6.246E+01, 1.599E+00, 0.000E+00/
      DATA (PH1(I,28,18, 2),I=1,6) /1.293E+03, 1.925E+02,
     1 7.399E+00, 2.482E+01, 4.836E+00, 0.000E+00/
      DATA (PH1(I,28,18, 3),I=1,6) /1.174E+03, 2.087E+02,
     1 1.825E+02, 6.397E+01, 3.955E+00, 4.274E-07/
      DATA (PH1(I,28,18, 4),I=1,6) /3.620E+02, 2.901E+01,
     1 1.340E+01, 2.515E+02, 4.429E+00, 0.000E+00/
      DATA (PH1(I,28,18, 5),I=1,6) /3.210E+02, 1.005E+02,
     1 4.742E+01, 4.168E+01, 5.919E+00, 5.228E-01/
      DATA (PH1(I,28,19, 1),I=1,6) /8.542E+03, 1.439E+03,
     1 7.170E+00, 6.247E+01, 1.599E+00, 0.000E+00/
      DATA (PH1(I,28,19, 2),I=1,6) /1.251E+03, 1.931E+02,
     1 7.348E+00, 2.450E+01, 4.851E+00, 0.000E+00/
      DATA (PH1(I,28,19, 3),I=1,6) /1.132E+03, 2.109E+02,
     1 1.780E+02, 6.201E+01, 3.969E+00, 4.273E-07/
      DATA (PH1(I,28,19, 4),I=1,6) /3.290E+02, 3.448E+01,
     1 1.054E+01, 2.150E+02, 4.412E+00, 0.000E+00/
      DATA (PH1(I,28,19, 5),I=1,6) /2.877E+02, 1.033E+02,
     1 4.372E+01, 3.878E+01, 5.977E+00, 5.276E-01/
      DATA (PH1(I,28,19, 6),I=1,6) /2.246E+02, 3.839E+01,
     1 1.714E+02, 7.972E+01, 6.440E+00, 1.220E-04/
      DATA (PH1(I,28,20, 1),I=1,6) /8.503E+03, 1.439E+03,
     1 7.178E+00, 6.253E+01, 1.598E+00, 0.000E+00/
      DATA (PH1(I,28,20, 2),I=1,6) /1.211E+03, 1.935E+02,
     1 7.316E+00, 2.416E+01, 4.868E+00, 0.000E+00/
      DATA (PH1(I,28,20, 3),I=1,6) /1.092E+03, 2.189E+02,
     1 1.653E+02, 6.160E+01, 3.932E+00, 4.163E-07/
      DATA (PH1(I,28,20, 4),I=1,6) /2.972E+02, 3.985E+01,
     1 8.589E+00, 1.892E+02, 4.394E+00, 0.000E+00/
      DATA (PH1(I,28,20, 5),I=1,6) /2.561E+02, 1.023E+02,
     1 4.197E+01, 3.659E+01, 6.079E+00, 4.805E-01/
      DATA (PH1(I,28,20, 6),I=1,6) /1.930E+02, 4.212E+01,
     1 2.596E+02, 6.923E+01, 6.485E+00, 1.416E-04/
      DATA (PH1(I,28,21, 1),I=1,6) /8.472E+03, 1.466E+03,
     1 6.924E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,28,21, 2),I=1,6) /1.174E+03, 2.314E+02,
     1 6.277E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,28,21, 3),I=1,6) /1.051E+03, 2.476E+02,
     1 1.308E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,28,21, 4),I=1,6) /2.682E+02, 5.179E+01,
     1 6.728E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,28,21, 5),I=1,6) /2.266E+02, 9.852E+01,
     1 4.031E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,28,21, 6),I=1,6) /1.620E+02, 4.735E+01,
     1 2.988E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,28,22, 1),I=1,6) /8.452E+03, 1.430E+03,
     1 7.274E+00, 6.333E+01, 1.599E+00, 0.000E+00/
      DATA (PH1(I,28,22, 2),I=1,6) /1.139E+03, 1.947E+02,
     1 7.253E+00, 2.382E+01, 4.880E+00, 0.000E+00/
      DATA (PH1(I,28,22, 3),I=1,6) /1.019E+03, 2.193E+02,
     1 1.639E+02, 5.860E+01, 3.969E+00, 4.138E-07/
      DATA (PH1(I,28,22, 4),I=1,6) /2.378E+02, 4.756E+01,
     1 6.461E+00, 1.609E+02, 4.380E+00, 0.000E+00/
      DATA (PH1(I,28,22, 5),I=1,6) /1.971E+02, 9.385E+01,
     1 4.144E+01, 3.216E+01, 6.437E+00, 3.229E-01/
      DATA (PH1(I,28,22, 6),I=1,6) /1.330E+02, 5.059E+01,
     1 3.124E+02, 5.417E+01, 6.505E+00, 1.508E-04/
      DATA (PH1(I,28,23, 1),I=1,6) /8.434E+03, 1.466E+03,
     1 6.929E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,28,23, 2),I=1,6) /1.112E+03, 2.318E+02,
     1 6.240E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,28,23, 3),I=1,6) /9.886E+02, 2.482E+02,
     1 1.297E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,28,23, 4),I=1,6) /2.119E+02, 5.449E+01,
     1 5.709E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,28,23, 5),I=1,6) /1.709E+02, 1.010E+02,
     1 3.462E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,28,23, 6),I=1,6) /1.080E+02, 4.837E+01,
     1 3.797E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,28,24, 1),I=1,6) /8.418E+03, 1.463E+03,
     1 6.925E+00, 6.343E+01, 1.583E+00, 0.000E+00/
      DATA (PH1(I,28,24, 2),I=1,6) /1.077E+03, 1.956E+02,
     1 7.233E+00, 2.315E+01, 4.910E+00, 0.000E+00/
      DATA (PH1(I,28,24, 3),I=1,6) /9.576E+02, 2.215E+02,
     1 1.608E+02, 5.699E+01, 3.980E+00, 4.065E-07/
      DATA (PH1(I,28,24, 4),I=1,6) /1.849E+02, 5.389E+01,
     1 5.242E+00, 1.434E+02, 4.370E+00, 0.000E+00/
      DATA (PH1(I,28,24, 5),I=1,6) /1.447E+02, 9.036E+01,
     1 4.016E+01, 2.699E+01, 6.796E+00, 2.509E-01/
      DATA (PH1(I,28,24, 6),I=1,6) /7.610E+01, 4.694E+01,
     1 4.360E+02, 3.874E+01, 7.119E+00, 3.263E-03/
      DATA (PH1(I,28,25, 1),I=1,6) /8.402E+03, 1.466E+03,
     1 6.933E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,28,25, 2),I=1,6) /1.059E+03, 2.320E+02,
     1 6.226E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,28,25, 3),I=1,6) /9.358E+02, 2.488E+02,
     1 1.288E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,28,25, 4),I=1,6) /1.597E+02, 5.774E+01,
     1 4.849E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,28,25, 5),I=1,6) /1.201E+02, 1.043E+02,
     1 2.963E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,28,25, 6),I=1,6) /5.490E+01, 5.023E+01,
     1 3.918E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,28,26, 1),I=1,6) /8.386E+03, 1.647E+03,
     1 5.367E+00, 6.758E+01, 1.485E+00, 0.000E+00/
      DATA (PH1(I,28,26, 2),I=1,6) /1.040E+03, 2.324E+02,
     1 6.314E+00, 2.361E+01, 4.604E+00, 0.000E+00/
      DATA (PH1(I,28,26, 3),I=1,6) /9.084E+02, 2.230E+02,
     1 1.588E+02, 5.650E+01, 3.977E+00, 4.038E-07/
      DATA (PH1(I,28,26, 4),I=1,6) /1.401E+02, 5.823E+01,
     1 4.586E+00, 1.330E+02, 4.367E+00, 0.000E+00/
      DATA (PH1(I,28,26, 5),I=1,6) /1.003E+02, 9.061E+01,
     1 3.980E+01, 2.247E+01, 7.093E+00, 2.543E-01/
      DATA (PH1(I,28,26, 6),I=1,6) /3.532E+01, 2.971E+01,
     1 1.965E+03, 9.751E+00, 1.140E+01, 4.019E-01/
      DATA (PH1(I,28,27, 1),I=1,6) /8.368E+03, 2.249E+03,
     1 2.776E+00, 1.325E+03, 9.540E-01, 0.000E+00/
      DATA (PH1(I,28,27, 2),I=1,6) /1.029E+03, 1.808E+02,
     1 7.632E+00, 2.289E+01, 5.060E+00, 0.000E+00/
      DATA (PH1(I,28,27, 3),I=1,6) /8.903E+02, 2.205E+02,
     1 1.625E+02, 5.653E+01, 3.990E+00, 1.246E-04/
      DATA (PH1(I,28,27, 4),I=1,6) /1.315E+02, 6.024E+01,
     1 4.394E+00, 1.314E+02, 4.347E+00, 0.000E+00/
      DATA (PH1(I,28,27, 5),I=1,6) /8.232E+01, 9.066E+01,
     1 4.075E+01, 2.048E+01, 7.246E+00, 2.545E-01/
      DATA (PH1(I,28,27, 6),I=1,6) /1.817E+01, 1.501E+00,
     1 9.258E-01, 4.442E+01, 1.928E+01, 3.708E-02/
      DATA (PH1(I,28,28, 1),I=1,6) /8.348E+03, 7.366E+02,
     1 2.836E+01, 3.622E+01, 2.316E+00, 0.000E+00/
      DATA (PH1(I,28,28, 2),I=1,6) /1.024E+03, 1.132E+02,
     1 9.424E+00, 2.712E+01, 5.643E+00, 0.000E+00/
      DATA (PH1(I,28,28, 3),I=1,6) /8.760E+02, 3.043E+02,
     1 8.611E+01, 7.868E+01, 3.408E+00, 1.680E-05/
      DATA (PH1(I,28,28, 4),I=1,6) /1.250E+02, 5.448E+01,
     1 4.611E+00, 1.157E+02, 4.548E+00, 0.000E+00/
      DATA (PH1(I,28,28, 5),I=1,6) /8.200E+01, 8.896E+01,
     1 4.351E+01, 1.942E+01, 7.372E+00, 2.566E-01/
      DATA (PH1(I,28,28, 6),I=1,6) /1.700E+01, 6.063E+00,
     1 1.186E+03, 6.823E+00, 2.223E+01, 6.227E-03/
      DATA (PH1(I,28,28, 7),I=1,6) /7.637E+00, 1.468E+01,
     1 1.437E+00, 7.411E+02, 4.342E+00, 3.908E-02/
      DATA (PH1(I,29, 1, 1),I=1,6) /1.157E+04, 3.656E+02,
     1 6.510E+01, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,29, 2, 1),I=1,6) /1.106E+04, 1.427E+03,
     1 8.057E+00, 7.912E+01, 1.583E+00, 0.000E+00/
      DATA (PH1(I,29, 3, 1),I=1,6) /1.085E+04, 1.435E+03,
     1 8.196E+00, 7.379E+01, 1.577E+00, 0.000E+00/
      DATA (PH1(I,29, 3, 2),I=1,6) /2.585E+03, 1.732E+02,
     1 6.336E+00, 4.099E+01, 4.316E+00, 0.000E+00/
      DATA (PH1(I,29, 4, 1),I=1,6) /1.070E+04, 1.476E+03,
     1 7.658E+00, 7.281E+01, 1.567E+00, 0.000E+00/
      DATA (PH1(I,29, 4, 2),I=1,6) /2.459E+03, 1.822E+02,
     1 1.108E+01, 3.417E+01, 4.489E+00, 0.000E+00/
      DATA (PH1(I,29, 5, 1),I=1,6) /1.053E+04, 1.516E+03,
     1 7.156E+00, 7.157E+01, 1.560E+00, 0.000E+00/
      DATA (PH1(I,29, 5, 2),I=1,6) /2.363E+03, 2.174E+02,
     1 9.074E+00, 2.892E+01, 4.445E+00, 0.000E+00/
      DATA (PH1(I,29, 5, 3),I=1,6) /2.298E+03, 1.099E+02,
     1 1.898E+02, 1.272E+02, 4.081E+00, 2.821E-08/
      DATA (PH1(I,29, 6, 1),I=1,6) /1.036E+04, 1.537E+03,
     1 6.899E+00, 7.045E+01, 1.560E+00, 0.000E+00/
      DATA (PH1(I,29, 6, 2),I=1,6) /2.253E+03, 2.118E+02,
     1 8.876E+00, 2.857E+01, 4.513E+00, 0.000E+00/
      DATA (PH1(I,29, 6, 3),I=1,6) /2.173E+03, 1.503E+02,
     1 1.866E+02, 1.055E+02, 3.944E+00, 1.972E-08/
      DATA (PH1(I,29, 7, 1),I=1,6) /1.016E+04, 1.531E+03,
     1 7.047E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,29, 7, 2),I=1,6) /2.133E+03, 2.330E+02,
     1 7.838E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,29, 7, 3),I=1,6) /2.045E+03, 2.473E+02,
     1 9.111E+01, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,29, 8, 1),I=1,6) /1.004E+04, 1.556E+03,
     1 6.650E+00, 6.987E+01, 1.559E+00, 0.000E+00/
      DATA (PH1(I,29, 8, 2),I=1,6) /2.037E+03, 2.003E+02,
     1 8.422E+00, 2.803E+01, 4.659E+00, 0.000E+00/
      DATA (PH1(I,29, 8, 3),I=1,6) /1.905E+03, 1.999E+02,
     1 1.798E+02, 7.715E+01, 3.888E+00, 1.496E-08/
      DATA (PH1(I,29, 9, 1),I=1,6) /9.844E+03, 1.546E+03,
     1 6.833E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,29, 9, 2),I=1,6) /1.920E+03, 2.388E+02,
     1 6.970E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,29, 9, 3),I=1,6) /1.793E+03, 2.493E+02,
     1 1.335E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,29,10, 1),I=1,6) /9.729E+03, 1.540E+03,
     1 6.748E+00, 6.512E+01, 1.590E+00, 0.000E+00/
      DATA (PH1(I,29,10, 2),I=1,6) /1.827E+03, 1.901E+02,
     1 7.838E+00, 2.795E+01, 4.791E+00, 0.000E+00/
      DATA (PH1(I,29,10, 3),I=1,6) /1.690E+03, 2.206E+02,
     1 1.906E+02, 6.390E+01, 3.955E+00, 1.558E-08/
      DATA (PH1(I,29,11, 1),I=1,6) /9.668E+03, 1.523E+03,
     1 6.915E+00, 6.870E+01, 1.581E+00, 0.000E+00/
      DATA (PH1(I,29,11, 2),I=1,6) /1.773E+03, 1.626E+02,
     1 8.723E+00, 3.155E+01, 4.881E+00, 0.000E+00/
      DATA (PH1(I,29,11, 3),I=1,6) /1.657E+03, 2.651E+02,
     1 1.307E+02, 7.793E+01, 3.637E+00, 1.894E-08/
      DATA (PH1(I,29,11, 4),I=1,6) /6.706E+02, 1.529E+01,
     1 2.453E+01, 6.172E+02, 4.260E+00, 0.000E+00/
      DATA (PH1(I,29,12, 1),I=1,6) /9.610E+03, 1.558E+03,
     1 6.567E+00, 6.667E+01, 1.576E+00, 0.000E+00/
      DATA (PH1(I,29,12, 2),I=1,6) /1.722E+03, 1.953E+02,
     1 7.587E+00, 2.834E+01, 4.738E+00, 0.000E+00/
      DATA (PH1(I,29,12, 3),I=1,6) /1.604E+03, 2.619E+02,
     1 1.331E+02, 7.654E+01, 3.661E+00, 1.879E-08/
      DATA (PH1(I,29,12, 4),I=1,6) /6.330E+02, 2.604E+01,
     1 2.426E+01, 3.618E+02, 4.240E+00, 0.000E+00/
      DATA (PH1(I,29,13, 1),I=1,6) /9.550E+03, 1.563E+03,
     1 6.515E+00, 6.616E+01, 1.577E+00, 0.000E+00/
      DATA (PH1(I,29,13, 2),I=1,6) /1.670E+03, 1.993E+02,
     1 7.415E+00, 2.757E+01, 4.743E+00, 0.000E+00/
      DATA (PH1(I,29,13, 3),I=1,6) /1.551E+03, 2.401E+02,
     1 1.577E+02, 7.468E+01, 3.767E+00, 2.341E-08/
      DATA (PH1(I,29,13, 4),I=1,6) /5.949E+02, 3.706E+01,
     1 1.653E+01, 2.918E+02, 4.111E+00, 0.000E+00/
      DATA (PH1(I,29,13, 5),I=1,6) /5.570E+02, 2.011E+02,
     1 3.929E+00, 5.061E+01, 4.854E+00, 8.398E-01/
      DATA (PH1(I,29,14, 1),I=1,6) /9.493E+03, 1.558E+03,
     1 6.561E+00, 6.691E+01, 1.575E+00, 0.000E+00/
      DATA (PH1(I,29,14, 2),I=1,6) /1.619E+03, 1.974E+02,
     1 7.417E+00, 2.691E+01, 4.791E+00, 0.000E+00/
      DATA (PH1(I,29,14, 3),I=1,6) /1.499E+03, 2.384E+02,
     1 1.588E+02, 7.405E+01, 3.780E+00, 2.405E-08/
      DATA (PH1(I,29,14, 4),I=1,6) /5.572E+02, 3.531E+01,
     1 1.668E+01, 3.042E+02, 4.130E+00, 0.000E+00/
      DATA (PH1(I,29,14, 5),I=1,6) /5.200E+02, 1.207E+02,
     1 1.569E+01, 5.849E+01, 5.405E+00, 4.555E-01/
      DATA (PH1(I,29,15, 1),I=1,6) /9.423E+03, 1.577E+03,
     1 6.419E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,29,15, 2),I=1,6) /1.563E+03, 2.446E+02,
     1 6.221E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,29,15, 3),I=1,6) /1.439E+03, 2.632E+02,
     1 1.311E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,29,15, 4),I=1,6) /5.184E+02, 5.001E+01,
     1 1.019E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,29,15, 5),I=1,6) /4.840E+02, 1.032E+02,
     1 2.783E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,29,16, 1),I=1,6) /9.384E+03, 1.553E+03,
     1 6.609E+00, 6.923E+01, 1.568E+00, 0.000E+00/
      DATA (PH1(I,29,16, 2),I=1,6) /1.522E+03, 1.990E+02,
     1 7.271E+00, 2.604E+01, 4.826E+00, 0.000E+00/
      DATA (PH1(I,29,16, 3),I=1,6) /1.400E+03, 2.302E+02,
     1 1.675E+02, 7.119E+01, 3.847E+00, 2.441E-08/
      DATA (PH1(I,29,16, 4),I=1,6) /4.838E+02, 3.424E+01,
     1 1.441E+01, 2.579E+02, 4.283E+00, 0.000E+00/
      DATA (PH1(I,29,16, 5),I=1,6) /4.350E+02, 1.064E+02,
     1 3.399E+01, 5.025E+01, 5.723E+00, 4.731E-01/
      DATA (PH1(I,29,17, 1),I=1,6) /9.317E+03, 1.576E+03,
     1 6.433E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,29,17, 2),I=1,6) /1.467E+03, 2.457E+02,
     1 6.110E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,29,17, 3),I=1,6) /1.340E+03, 2.635E+02,
     1 1.295E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,29,17, 4),I=1,6) /4.458E+02, 5.099E+01,
     1 9.072E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,29,17, 5),I=1,6) /4.010E+02, 1.031E+02,
     1 4.266E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,29,18, 1),I=1,6) /9.282E+03, 1.550E+03,
     1 6.633E+00, 6.922E+01, 1.570E+00, 0.000E+00/
      DATA (PH1(I,29,18, 2),I=1,6) /1.431E+03, 1.960E+02,
     1 7.274E+00, 2.502E+01, 4.908E+00, 0.000E+00/
      DATA (PH1(I,29,18, 3),I=1,6) /1.307E+03, 2.291E+02,
     1 1.666E+02, 6.860E+01, 3.881E+00, 2.421E-08/
      DATA (PH1(I,29,18, 4),I=1,6) /4.129E+02, 3.356E+01,
     1 1.254E+01, 2.441E+02, 4.373E+00, 0.000E+00/
      DATA (PH1(I,29,18, 5),I=1,6) /3.688E+02, 1.023E+02,
     1 4.888E+01, 4.483E+01, 5.919E+00, 3.996E-01/
      DATA (PH1(I,29,19, 1),I=1,6) /9.237E+03, 1.550E+03,
     1 6.630E+00, 6.917E+01, 1.570E+00, 0.000E+00/
      DATA (PH1(I,29,19, 2),I=1,6) /1.386E+03, 1.983E+02,
     1 7.172E+00, 2.486E+01, 4.901E+00, 0.000E+00/
      DATA (PH1(I,29,19, 3),I=1,6) /1.262E+03, 2.322E+02,
     1 1.615E+02, 6.669E+01, 3.889E+00, 2.403E-08/
      DATA (PH1(I,29,19, 4),I=1,6) /3.778E+02, 3.308E+01,
     1 1.152E+01, 2.347E+02, 4.436E+00, 0.000E+00/
      DATA (PH1(I,29,19, 5),I=1,6) /3.335E+02, 1.017E+02,
     1 4.646E+01, 4.207E+01, 6.020E+00, 3.632E-01/
      DATA (PH1(I,29,19, 6),I=1,6) /2.661E+02, 4.605E+01,
     1 1.458E+02, 7.967E+01, 6.285E+00, 4.503E-03/
      DATA (PH1(I,29,20, 1),I=1,6) /9.181E+03, 1.574E+03,
     1 6.454E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,29,20, 2),I=1,6) /1.339E+03, 2.470E+02,
     1 5.993E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,29,20, 3),I=1,6) /1.211E+03, 2.640E+02,
     1 1.274E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,29,20, 4),I=1,6) /3.447E+02, 5.350E+01,
     1 7.318E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,29,20, 5),I=1,6) /2.999E+02, 1.045E+02,
     1 4.286E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,29,20, 6),I=1,6) /2.320E+02, 5.210E+01,
     1 2.093E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,29,21, 1),I=1,6) /9.155E+03, 1.546E+03,
     1 6.671E+00, 6.964E+01, 1.570E+00, 0.000E+00/
      DATA (PH1(I,29,21, 2),I=1,6) /1.302E+03, 1.958E+02,
     1 7.186E+00, 2.423E+01, 4.960E+00, 0.000E+00/
      DATA (PH1(I,29,21, 3),I=1,6) /1.178E+03, 2.383E+02,
     1 1.525E+02, 6.417E+01, 3.890E+00, 2.517E-08/
      DATA (PH1(I,29,21, 4),I=1,6) /3.113E+02, 4.346E+01,
     1 7.773E+00, 1.823E+02, 4.413E+00, 0.000E+00/
      DATA (PH1(I,29,21, 5),I=1,6) /2.672E+02, 9.821E+01,
     1 4.314E+01, 3.667E+01, 6.291E+00, 2.759E-01/
      DATA (PH1(I,29,21, 6),I=1,6) /1.990E+02, 5.000E+01,
     1 3.041E+02, 6.355E+01, 6.458E+00, 2.040E-03/
      DATA (PH1(I,29,22, 1),I=1,6) /9.127E+03, 1.573E+03,
     1 6.468E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,29,22, 2),I=1,6) /1.267E+03, 2.476E+02,
     1 5.944E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,29,22, 3),I=1,6) /1.137E+03, 2.644E+02,
     1 1.263E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,29,22, 4),I=1,6) /2.824E+02, 5.587E+01,
     1 6.260E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,29,22, 5),I=1,6) /2.375E+02, 1.064E+02,
     1 3.728E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,29,22, 6),I=1,6) /1.670E+02, 5.236E+01,
     1 3.470E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,29,23, 1),I=1,6) /9.107E+03, 1.541E+03,
     1 6.731E+00, 7.196E+01, 1.562E+00, 0.000E+00/
      DATA (PH1(I,29,23, 2),I=1,6) /1.229E+03, 1.968E+02,
     1 7.138E+00, 2.379E+01, 4.979E+00, 0.000E+00/
      DATA (PH1(I,29,23, 3),I=1,6) /1.104E+03, 2.376E+02,
     1 1.529E+02, 6.163E+01, 3.925E+00, 2.511E-08/
      DATA (PH1(I,29,23, 4),I=1,6) /2.504E+02, 5.085E+01,
     1 5.992E+00, 1.563E+02, 4.410E+00, 0.000E+00/
      DATA (PH1(I,29,23, 5),I=1,6) /2.067E+02, 1.010E+02,
     1 3.860E+01, 3.121E+01, 6.491E+00, 3.331E-01/
      DATA (PH1(I,29,23, 6),I=1,6) /1.390E+02, 5.652E+01,
     1 3.452E+02, 5.007E+01, 6.558E+00, 2.171E-03/
      DATA (PH1(I,29,24, 1),I=1,6) /9.088E+03, 1.572E+03,
     1 6.482E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,29,24, 2),I=1,6) /1.203E+03, 2.479E+02,
     1 5.918E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,29,24, 3),I=1,6) /1.073E+03, 2.649E+02,
     1 1.255E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,29,24, 4),I=1,6) /2.243E+02, 5.878E+01,
     1 5.342E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,29,24, 5),I=1,6) /1.801E+02, 1.092E+02,
     1 3.217E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,29,24, 6),I=1,6) /1.030E+02, 5.346E+01,
     1 4.010E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,29,25, 1),I=1,6) /9.070E+03, 1.572E+03,
     1 6.440E+00, 6.913E+01, 1.560E+00, 0.000E+00/
      DATA (PH1(I,29,25, 2),I=1,6) /1.166E+03, 2.072E+02,
     1 6.884E+00, 2.337E+01, 4.917E+00, 0.000E+00/
      DATA (PH1(I,29,25, 3),I=1,6) /1.041E+03, 2.368E+02,
     1 1.537E+02, 5.951E+01, 3.955E+00, 2.525E-08/
      DATA (PH1(I,29,25, 4),I=1,6) /1.960E+02, 5.776E+01,
     1 4.896E+00, 1.391E+02, 4.397E+00, 0.000E+00/
      DATA (PH1(I,29,25, 5),I=1,6) /1.528E+02, 9.650E+01,
     1 3.804E+01, 2.618E+01, 6.870E+00, 2.460E-01/
      DATA (PH1(I,29,25, 6),I=1,6) /7.990E+01, 5.875E+01,
     1 3.868E+02, 3.774E+01, 6.878E+00, 3.091E-01/
      DATA (PH1(I,29,26, 1),I=1,6) /9.052E+03, 1.571E+03,
     1 6.497E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,29,26, 2),I=1,6) /1.146E+03, 2.480E+02,
     1 5.914E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,29,26, 3),I=1,6) /1.020E+03, 2.654E+02,
     1 1.248E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,29,26, 4),I=1,6) /1.703E+02, 6.225E+01,
     1 4.565E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,29,26, 5),I=1,6) /1.277E+02, 1.127E+02,
     1 2.769E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,29,26, 6),I=1,6) /5.738E+01, 5.539E+01,
     1 4.028E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,29,27, 1),I=1,6) /9.032E+03, 2.025E+03,
     1 3.761E+00, 2.259E+02, 1.184E+00, 0.000E+00/
      DATA (PH1(I,29,27, 2),I=1,6) /1.128E+03, 2.508E+02,
     1 5.929E+00, 2.384E+01, 4.581E+00, 0.000E+00/
      DATA (PH1(I,29,27, 3),I=1,6) /9.911E+02, 2.369E+02,
     1 1.537E+02, 5.847E+01, 3.967E+00, 2.525E-08/
      DATA (PH1(I,29,27, 4),I=1,6) /1.499E+02, 6.247E+01,
     1 4.311E+00, 1.291E+02, 4.390E+00, 0.000E+00/
      DATA (PH1(I,29,27, 5),I=1,6) /1.072E+02, 9.745E+01,
     1 3.768E+01, 2.211E+01, 7.130E+00, 2.537E-01/
      DATA (PH1(I,29,27, 6),I=1,6) /3.684E+01, 3.541E+01,
     1 1.181E+03, 1.390E+01, 1.017E+01, 3.416E-01/
      DATA (PH1(I,29,28, 1),I=1,6) /9.012E+03, 2.378E+03,
     1 2.659E+00, 7.489E+02, 9.937E-01, 0.000E+00/
      DATA (PH1(I,29,28, 2),I=1,6) /1.114E+03, 3.054E+02,
     1 4.889E+00, 2.675E+01, 4.155E+00, 0.000E+00/
      DATA (PH1(I,29,28, 3),I=1,6) /9.715E+02, 2.328E+02,
     1 1.588E+02, 5.776E+01, 3.997E+00, 2.543E-08/
      DATA (PH1(I,29,28, 4),I=1,6) /1.312E+02, 6.472E+01,
     1 4.139E+00, 1.278E+02, 4.366E+00, 0.000E+00/
      DATA (PH1(I,29,28, 5),I=1,6) /8.861E+01, 9.750E+01,
     1 3.865E+01, 2.022E+01, 7.277E+00, 2.537E-01/
      DATA (PH1(I,29,28, 6),I=1,6) /2.029E+01, 1.590E+01,
     1 3.992E+03, 7.098E+00, 1.616E+01, 7.439E-01/
      DATA (PH1(I,29,29, 1),I=1,6) /8.988E+03, 1.788E+03,
     1 4.870E+00, 7.645E+01, 1.451E+00, 0.000E+00/
      DATA (PH1(I,29,29, 2),I=1,6) /1.106E+03, 2.502E+02,
     1 5.938E+00, 2.402E+01, 4.576E+00, 0.000E+00/
      DATA (PH1(I,29,29, 3),I=1,6) /9.470E+02, 2.826E+02,
     1 1.093E+02, 6.688E+01, 3.668E+00, 9.174E-07/
      DATA (PH1(I,29,29, 4),I=1,6) /1.288E+02, 6.198E+01,
     1 4.164E+00, 1.158E+02, 4.488E+00, 0.000E+00/
      DATA (PH1(I,29,29, 5),I=1,6) /8.300E+01, 9.617E+01,
     1 4.275E+01, 1.747E+01, 7.555E+00, 2.599E-01/
      DATA (PH1(I,29,29, 6),I=1,6) /1.064E+01, 7.279E+00,
     1 1.027E+03, 7.988E+00, 2.033E+01, 1.582E+00/
      DATA (PH1(I,29,29, 7),I=1,6) /7.726E+00, 1.436E+01,
     1 4.681E-01, 2.383E+03, 4.224E+00, 3.736E-02/
      DATA (PH1(I,30, 1, 1),I=1,6) /1.239E+04, 3.915E+02,
     1 6.083E+01, 3.288E+01, 2.963E+00, 0.000E+00/
      DATA (PH1(I,30, 2, 1),I=1,6) /1.187E+04, 1.564E+03,
     1 7.165E+00, 9.095E+01, 1.535E+00, 0.000E+00/
      DATA (PH1(I,30, 3, 1),I=1,6) /1.165E+04, 1.600E+03,
     1 7.032E+00, 9.272E+01, 1.497E+00, 0.000E+00/
      DATA (PH1(I,30, 3, 2),I=1,6) /2.780E+03, 3.219E+02,
     1 3.342E+00, 3.904E+01, 3.684E+00, 0.000E+00/
      DATA (PH1(I,30, 4, 1),I=1,6) /1.149E+04, 1.565E+03,
     1 7.294E+00, 7.835E+01, 1.557E+00, 0.000E+00/
      DATA (PH1(I,30, 4, 2),I=1,6) /2.647E+03, 1.989E+02,
     1 1.025E+01, 3.502E+01, 4.434E+00, 0.000E+00/
      DATA (PH1(I,30, 5, 1),I=1,6) /1.131E+04, 1.582E+03,
     1 7.052E+00, 7.246E+01, 1.577E+00, 0.000E+00/
      DATA (PH1(I,30, 5, 2),I=1,6) /2.550E+03, 2.168E+02,
     1 9.068E+00, 2.977E+01, 4.514E+00, 0.000E+00/
      DATA (PH1(I,30, 5, 3),I=1,6) /2.479E+03, 1.230E+02,
     1 1.663E+02, 1.330E+02, 4.013E+00, 2.250E-08/
      DATA (PH1(I,30, 6, 1),I=1,6) /1.113E+04, 1.607E+03,
     1 6.765E+00, 7.173E+01, 1.574E+00, 0.000E+00/
      DATA (PH1(I,30, 6, 2),I=1,6) /2.435E+03, 2.335E+02,
     1 8.158E+00, 2.769E+01, 4.506E+00, 0.000E+00/
      DATA (PH1(I,30, 6, 3),I=1,6) /2.363E+03, 1.386E+02,
     1 2.396E+02, 1.169E+02, 4.016E+00, 1.579E-08/
      DATA (PH1(I,30, 7, 1),I=1,6) /1.092E+04, 1.637E+03,
     1 6.617E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,30, 7, 2),I=1,6) /2.309E+03, 2.488E+02,
     1 7.424E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,30, 7, 3),I=1,6) /2.216E+03, 2.651E+02,
     1 8.601E+01, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,30, 8, 1),I=1,6) /1.080E+04, 1.629E+03,
     1 6.509E+00, 7.085E+01, 1.574E+00, 0.000E+00/
      DATA (PH1(I,30, 8, 2),I=1,6) /2.210E+03, 2.179E+02,
     1 7.856E+00, 2.852E+01, 4.612E+00, 0.000E+00/
      DATA (PH1(I,30, 8, 3),I=1,6) /2.070E+03, 2.034E+02,
     1 1.893E+02, 8.099E+01, 3.908E+00, 6.713E-09/
      DATA (PH1(I,30, 9, 1),I=1,6) /1.059E+04, 1.652E+03,
     1 6.423E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,30, 9, 2),I=1,6) /2.087E+03, 2.548E+02,
     1 6.629E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,30, 9, 3),I=1,6) /1.953E+03, 2.670E+02,
     1 1.269E+02, 5.000E+01, 4.000E+00, 3.000E-01/
      DATA (PH1(I,30,10, 1),I=1,6) /1.048E+04, 1.636E+03,
     1 6.400E+00, 6.864E+01, 1.584E+00, 0.000E+00/
      DATA (PH1(I,30,10, 2),I=1,6) /1.992E+03, 2.104E+02,
     1 7.257E+00, 2.813E+01, 4.728E+00, 0.000E+00/
      DATA (PH1(I,30,10, 3),I=1,6) /1.846E+03, 2.254E+02,
     1 1.992E+02, 6.645E+01, 3.978E+00, 6.413E-09/
      DATA (PH1(I,30,11, 1),I=1,6) /1.042E+04, 1.605E+03,
     1 6.675E+00, 7.053E+01, 1.588E+00, 0.000E+00/
      DATA (PH1(I,30,11, 2),I=1,6) /1.936E+03, 1.953E+02,
     1 7.654E+00, 3.173E+01, 4.697E+00, 0.000E+00/
      DATA (PH1(I,30,11, 3),I=1,6) /1.815E+03, 2.273E+02,
     1 1.928E+02, 6.347E+01, 4.011E+00, 6.017E-09/
      DATA (PH1(I,30,11, 4),I=1,6) /7.374E+02, 1.960E+01,
     1 1.939E+01, 5.293E+02, 4.225E+00, 0.000E+00/
      DATA (PH1(I,30,12, 1),I=1,6) /1.035E+04, 1.631E+03,
     1 6.432E+00, 6.791E+01, 1.590E+00, 0.000E+00/
      DATA (PH1(I,30,12, 2),I=1,6) /1.882E+03, 2.070E+02,
     1 7.256E+00, 2.865E+01, 4.736E+00, 0.000E+00/
      DATA (PH1(I,30,12, 3),I=1,6) /1.760E+03, 2.265E+02,
     1 1.930E+02, 6.308E+01, 4.019E+00, 6.018E-09/
      DATA (PH1(I,30,12, 4),I=1,6) /6.980E+02, 3.115E+01,
     1 2.108E+01, 3.355E+02, 4.197E+00, 0.000E+00/
      DATA (PH1(I,30,13, 1),I=1,6) /1.029E+04, 1.636E+03,
     1 6.381E+00, 6.693E+01, 1.592E+00, 0.000E+00/
      DATA (PH1(I,30,13, 2),I=1,6) /1.828E+03, 2.085E+02,
     1 7.155E+00, 2.796E+01, 4.758E+00, 0.000E+00/
      DATA (PH1(I,30,13, 3),I=1,6) /1.704E+03, 2.296E+02,
     1 1.871E+02, 6.376E+01, 3.995E+00, 5.868E-09/
      DATA (PH1(I,30,13, 4),I=1,6) /6.583E+02, 3.116E+01,
     1 2.073E+01, 3.448E+02, 4.181E+00, 0.000E+00/
      DATA (PH1(I,30,13, 5),I=1,6) /6.190E+02, 2.539E+02,
     1 2.886E+00, 5.384E+01, 4.592E+00, 8.255E-01/
      DATA (PH1(I,30,14, 1),I=1,6) /1.023E+04, 1.633E+03,
     1 6.399E+00, 6.753E+01, 1.591E+00, 0.000E+00/
      DATA (PH1(I,30,14, 2),I=1,6) /1.775E+03, 2.101E+02,
     1 7.058E+00, 2.748E+01, 4.771E+00, 0.000E+00/
      DATA (PH1(I,30,14, 3),I=1,6) /1.650E+03, 2.720E+02,
     1 1.333E+02, 8.071E+01, 3.661E+00, 4.757E-09/
      DATA (PH1(I,30,14, 4),I=1,6) /6.187E+02, 2.985E+01,
     1 2.083E+01, 3.577E+02, 4.196E+00, 0.000E+00/
      DATA (PH1(I,30,14, 5),I=1,6) /5.790E+02, 1.403E+02,
     1 1.361E+01, 6.070E+01, 5.261E+00, 5.034E-01/
      DATA (PH1(I,30,15, 1),I=1,6) /1.015E+04, 1.691E+03,
     1 5.972E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,30,15, 2),I=1,6) /1.716E+03, 2.609E+02,
     1 5.912E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,30,15, 3),I=1,6) /1.586E+03, 2.806E+02,
     1 1.269E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,30,15, 4),I=1,6) /5.780E+02, 5.311E+01,
     1 1.000E+01, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,30,15, 5),I=1,6) /5.420E+02, 1.108E+02,
     1 2.676E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,30,16, 1),I=1,6) /1.012E+04, 1.617E+03,
     1 6.536E+00, 6.839E+01, 1.594E+00, 0.000E+00/
      DATA (PH1(I,30,16, 2),I=1,6) /1.673E+03, 2.142E+02,
     1 6.875E+00, 2.631E+01, 4.800E+00, 0.000E+00/
      DATA (PH1(I,30,16, 3),I=1,6) /1.546E+03, 2.596E+02,
     1 1.443E+02, 7.722E+01, 3.739E+00, 5.496E-09/
      DATA (PH1(I,30,16, 4),I=1,6) /5.416E+02, 3.912E+01,
     1 1.395E+01, 2.883E+02, 4.155E+00, 0.000E+00/
      DATA (PH1(I,30,16, 5),I=1,6) /4.900E+02, 1.153E+02,
     1 3.254E+01, 5.308E+01, 5.645E+00, 4.056E-01/
      DATA (PH1(I,30,17, 1),I=1,6) /1.004E+04, 1.689E+03,
     1 5.993E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,30,17, 2),I=1,6) /1.613E+03, 2.621E+02,
     1 5.810E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,30,17, 3),I=1,6) /1.481E+03, 2.807E+02,
     1 1.254E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,30,17, 4),I=1,6) /5.015E+02, 5.403E+01,
     1 8.971E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,30,17, 5),I=1,6) /4.540E+02, 1.106E+02,
     1 4.142E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,30,18, 1),I=1,6) /1.001E+04, 1.617E+03,
     1 6.532E+00, 6.768E+01, 1.597E+00, 0.000E+00/
      DATA (PH1(I,30,18, 2),I=1,6) /1.576E+03, 2.135E+02,
     1 6.802E+00, 2.575E+01, 4.839E+00, 0.000E+00/
      DATA (PH1(I,30,18, 3),I=1,6) /1.448E+03, 2.538E+02,
     1 1.487E+02, 7.400E+01, 3.794E+00, 5.551E-09/
      DATA (PH1(I,30,18, 4),I=1,6) /4.671E+02, 3.780E+01,
     1 1.186E+01, 2.389E+02, 4.334E+00, 0.000E+00/
      DATA (PH1(I,30,18, 5),I=1,6) /4.197E+02, 1.073E+02,
     1 4.863E+01, 4.776E+01, 5.875E+00, 2.432E-01/
      DATA (PH1(I,30,19, 1),I=1,6) /9.960E+03, 1.610E+03,
     1 6.593E+00, 6.774E+01, 1.600E+00, 0.000E+00/
      DATA (PH1(I,30,19, 2),I=1,6) /1.528E+03, 2.118E+02,
     1 6.804E+00, 2.536E+01, 4.875E+00, 0.000E+00/
      DATA (PH1(I,30,19, 3),I=1,6) /1.399E+03, 2.529E+02,
     1 1.489E+02, 7.156E+01, 3.823E+00, 5.330E-09/
      DATA (PH1(I,30,19, 4),I=1,6) /4.299E+02, 3.741E+01,
     1 1.098E+01, 2.313E+02, 4.386E+00, 0.000E+00/
      DATA (PH1(I,30,19, 5),I=1,6) /3.828E+02, 1.057E+02,
     1 4.664E+01, 4.477E+01, 5.995E+00, 2.234E-01/
      DATA (PH1(I,30,19, 6),I=1,6) /3.108E+02, 5.749E+01,
     1 1.122E+02, 7.804E+01, 6.097E+00, 3.731E-01/
      DATA (PH1(I,30,20, 1),I=1,6) /9.915E+03, 1.611E+03,
     1 6.591E+00, 6.799E+01, 1.598E+00, 0.000E+00/
      DATA (PH1(I,30,20, 2),I=1,6) /1.482E+03, 2.023E+02,
     1 6.987E+00, 2.500E+01, 4.972E+00, 0.000E+00/
      DATA (PH1(I,30,20, 3),I=1,6) /1.353E+03, 2.543E+02,
     1 1.465E+02, 6.961E+01, 3.838E+00, 5.027E-09/
      DATA (PH1(I,30,20, 4),I=1,6) /3.939E+02, 3.705E+01,
     1 1.008E+01, 2.216E+02, 4.447E+00, 0.000E+00/
      DATA (PH1(I,30,20, 5),I=1,6) /3.467E+02, 1.046E+02,
     1 4.454E+01, 4.180E+01, 6.115E+00, 1.997E-01/
      DATA (PH1(I,30,20, 6),I=1,6) /2.740E+02, 5.735E+01,
     1 2.033E+02, 7.143E+01, 6.214E+00, 3.888E-01/
      DATA (PH1(I,30,21, 1),I=1,6) /9.854E+03, 1.685E+03,
     1 6.036E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,30,21, 2),I=1,6) /1.436E+03, 2.638E+02,
     1 5.673E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,30,21, 3),I=1,6) /1.302E+03, 2.813E+02,
     1 1.231E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,30,21, 4),I=1,6) /3.609E+02, 5.754E+01,
     1 6.797E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,30,21, 5),I=1,6) /3.128E+02, 1.126E+02,
     1 3.961E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,30,21, 6),I=1,6) /2.380E+02, 5.727E+01,
     1 2.777E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,30,22, 1),I=1,6) /9.831E+03, 1.605E+03,
     1 6.653E+00, 6.874E+01, 1.597E+00, 0.000E+00/
      DATA (PH1(I,30,22, 2),I=1,6) /1.397E+03, 2.114E+02,
     1 6.748E+00, 2.443E+01, 4.934E+00, 0.000E+00/
      DATA (PH1(I,30,22, 3),I=1,6) /1.267E+03, 2.512E+02,
     1 1.490E+02, 6.562E+01, 3.896E+00, 5.943E-09/
      DATA (PH1(I,30,22, 4),I=1,6) /3.257E+02, 4.721E+01,
     1 7.066E+00, 1.761E+02, 4.431E+00, 0.000E+00/
      DATA (PH1(I,30,22, 5),I=1,6) /2.785E+02, 1.016E+02,
     1 4.118E+01, 3.606E+01, 6.396E+00, 1.450E-01/
      DATA (PH1(I,30,22, 6),I=1,6) /2.030E+02, 5.906E+01,
     1 3.187E+02, 5.850E+01, 6.430E+00, 2.472E-01/
      DATA (PH1(I,30,23, 1),I=1,6) /9.809E+03, 1.683E+03,
     1 6.057E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,30,23, 2),I=1,6) /1.362E+03, 2.642E+02,
     1 5.637E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,30,23, 3),I=1,6) /1.227E+03, 2.816E+02,
     1 1.222E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,30,23, 4),I=1,6) /2.969E+02, 6.012E+01,
     1 5.837E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,30,23, 5),I=1,6) /2.487E+02, 1.147E+02,
     1 3.456E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,30,23, 6),I=1,6) /1.750E+02, 5.760E+01,
     1 3.804E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,30,24, 1),I=1,6) /9.788E+03, 1.697E+03,
     1 5.935E+00, 9.066E+01, 1.488E+00, 0.000E+00/
      DATA (PH1(I,30,24, 2),I=1,6) /1.323E+03, 2.094E+02,
     1 6.772E+00, 2.401E+01, 4.975E+00, 0.000E+00/
      DATA (PH1(I,30,24, 3),I=1,6) /1.193E+03, 2.522E+02,
     1 1.476E+02, 6.376E+01, 3.914E+00, 6.079E-09/
      DATA (PH1(I,30,24, 4),I=1,6) /2.633E+02, 5.492E+01,
     1 5.518E+00, 1.512E+02, 4.431E+00, 0.000E+00/
      DATA (PH1(I,30,24, 5),I=1,6) /2.165E+02, 1.096E+02,
     1 3.576E+01, 3.034E+01, 6.524E+00, 3.502E-01/
      DATA (PH1(I,30,24, 6),I=1,6) /1.360E+02, 6.530E+01,
     1 3.456E+02, 4.608E+01, 6.555E+00, 2.476E-01/
      DATA (PH1(I,30,25, 1),I=1,6) /9.770E+03, 1.682E+03,
     1 6.079E+00, 5.000E+01, 1.650E+00, 0.000E+00/
      DATA (PH1(I,30,25, 2),I=1,6) /1.298E+03, 2.645E+02,
     1 5.621E+00, 2.600E+01, 4.500E+00, 0.000E+00/
      DATA (PH1(I,30,25, 3),I=1,6) /1.162E+03, 2.821E+02,
     1 1.215E+02, 7.000E+01, 3.700E+00, 1.000E-01/
      DATA (PH1(I,30,25, 4),I=1,6) /2.369E+02, 6.326E+01,
     1 5.006E+00, 1.800E+02, 4.200E+00, 0.000E+00/
      DATA (PH1(I,30,25, 5),I=1,6) /1.896E+02, 1.177E+02,
     1 2.996E+01, 4.500E+01, 5.900E+00, 2.600E-01/
      DATA (PH1(I,30,25, 6),I=1,6) /1.080E+02, 5.878E+01,
     1 4.151E+02, 4.000E+01, 7.000E+00, 3.000E-01/
      DATA (PH1(I,30,26, 1),I=1,6) /9.751E+03, 1.732E+03,
     1 5.666E+00, 8.751E+01, 1.484E+00, 0.000E+00/
      DATA (PH1(I,30,26, 2),I=1,6) /1.259E+03, 2.231E+02,
     1 6.480E+00, 2.364E+01, 4.891E+00, 0.000E+00/
      DATA (PH1(I,30,26, 3),I=1,6) /1.129E+03, 2.523E+02,
     1 1.473E+02, 6.205E+01, 3.933E+00, 6.078E-09/
      DATA (PH1(I,30,26, 4),I=1,6) /2.075E+02, 6.183E+01,
     1 4.578E+00, 1.352E+02, 4.422E+00, 0.000E+00/
      DATA (PH1(I,30,26, 5),I=1,6) /1.612E+02, 1.030E+02,
     1 3.598E+01, 2.554E+01, 6.932E+00, 2.426E-01/
      DATA (PH1(I,30,26, 6),I=1,6) /8.260E+01, 6.378E+01,
     1 4.172E+02, 3.462E+01, 7.005E+00, 3.108E-01/
      DATA (PH1(I,30,27, 1),I=1,6) /9.733E+03, 1.890E+03,
     1 4.708E+00, 1.202E+02, 1.363E+00, 0.000E+00/
      DATA (PH1(I,30,27, 2),I=1,6) /1.239E+03, 2.366E+02,
     1 6.210E+00, 2.347E+01, 4.803E+00, 0.000E+00/
      DATA (PH1(I,30,27, 3),I=1,6) /1.101E+03, 2.528E+02,
     1 1.467E+02, 6.144E+01, 3.938E+00, 6.071E-09/
      DATA (PH1(I,30,27, 4),I=1,6) /1.826E+02, 6.427E+01,
     1 4.285E+00, 1.295E+02, 4.424E+00, 0.000E+00/
      DATA (PH1(I,30,27, 5),I=1,6) /1.365E+02, 1.033E+02,
     1 3.582E+01, 2.337E+01, 7.076E+00, 2.470E-01/
      DATA (PH1(I,30,27, 6),I=1,6) /5.940E+01, 5.376E+01,
     1 6.007E+02, 2.429E+01, 7.985E+00, 3.026E-01/
      DATA (PH1(I,30,28, 1),I=1,6) /9.713E+03, 1.981E+03,
     1 4.228E+00, 1.057E+02, 1.361E+00, 0.000E+00/
      DATA (PH1(I,30,28, 2),I=1,6) /1.222E+03, 2.686E+02,
     1 5.600E+00, 2.394E+01, 4.574E+00, 0.000E+00/
      DATA (PH1(I,30,28, 3),I=1,6) /1.077E+03, 2.519E+02,
     1 1.478E+02, 6.090E+01, 3.949E+00, 6.087E-09/
      DATA (PH1(I,30,28, 4),I=1,6) /1.601E+02, 6.684E+01,
     1 4.057E+00, 1.255E+02, 4.414E+00, 0.000E+00/
      DATA (PH1(I,30,28, 5),I=1,6) /1.143E+02, 1.045E+02,
     1 3.568E+01, 2.181E+01, 7.163E+00, 2.533E-01/
      DATA (PH1(I,30,28, 6),I=1,6) /3.972E+01, 3.640E+01,
     1 1.498E+03, 1.188E+01, 1.082E+01, 3.519E-01/
      DATA (PH1(I,30,29, 1),I=1,6) /9.691E+03, 1.125E+03,
     1 1.382E+01, 2.765E+01, 2.242E+00, 0.000E+00/
      DATA (PH1(I,30,29, 2),I=1,6) /1.209E+03, 2.121E+02,
     1 6.713E+00, 2.342E+01, 4.988E+00, 0.000E+00/
      DATA (PH1(I,30,29, 3),I=1,6) /1.065E+03, 2.664E+02,
     1 1.329E+02, 6.260E+01, 3.864E+00, 5.913E-09/
      DATA (PH1(I,30,29, 4),I=1,6) /1.479E+02, 6.443E+01,
     1 4.075E+00, 1.175E+02, 4.506E+00, 0.000E+00/
      DATA (PH1(I,30,29, 5),I=1,6) /1.021E+02, 1.047E+02,
     1 3.618E+01, 2.122E+01, 7.201E+00, 2.534E-01/
      DATA (PH1(I,30,29, 6),I=1,6) /2.694E+01, 2.593E+01,
     1 3.408E+03, 7.832E+00, 1.363E+01, 3.562E-01/
      DATA (PH1(I,30,29, 7),I=1,6) /1.796E+01, 1.411E+01,
     1 8.168E-01, 8.775E+02, 4.393E+00, 4.021E-04/
      DATA (PH1(I,30,30, 1),I=1,6) /9.667E+03, 8.320E+02,
     1 2.586E+01, 4.497E+01, 2.215E+00, 0.000E+00/
      DATA (PH1(I,30,30, 2),I=1,6) /1.203E+03, 9.755E+01,
     1 9.077E+00, 3.219E+01, 5.888E+00, 0.000E+00/
      DATA (PH1(I,30,30, 3),I=1,6) /1.037E+03, 3.486E+02,
     1 7.784E+01, 8.298E+01, 3.391E+00, 1.125E-08/
      DATA (PH1(I,30,30, 4),I=1,6) /1.450E+02, 6.195E+01,
     1 4.094E+00, 1.086E+02, 4.614E+00, 0.000E+00/
      DATA (PH1(I,30,30, 5),I=1,6) /9.700E+01, 1.025E+02,
     1 3.930E+01, 1.876E+01, 7.456E+00, 2.559E-01/
      DATA (PH1(I,30,30, 6),I=1,6) /1.730E+01, 1.818E+01,
     1 1.017E+04, 5.288E+00, 1.736E+01, 4.667E-01/
      DATA (PH1(I,30,30, 7),I=1,6) /9.394E+00, 1.673E+01,
     1 1.236E+00, 1.029E+03, 4.259E+00, 3.962E-02/
      DATA (PH2(I, 1, 1),I=1,7) /4.298E-01, 5.475E+04,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 2, 1),I=1,7) /1.720E+00, 1.369E+04,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 2, 2),I=1,7) /1.361E+01, 9.492E+02,
     1 1.469E+00, 3.188E+00, 2.039E+00, 4.434E-01, 2.136E+00/
      DATA (PH2(I, 3, 1),I=1,7) /3.871E+00, 6.083E+03,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 3, 2),I=1,7) /2.006E+01, 3.201E+02,
     1 7.391E+00, 2.916E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 3, 3),I=1,7) /3.107E+00, 6.245E+01,
     1 1.501E+01, 4.895E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 4, 1),I=1,7) /6.879E+00, 3.422E+03,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 4, 2),I=1,7) /1.760E+01, 5.458E+02,
     1 1.719E+01, 3.157E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 4, 3),I=1,7) /1.181E+00, 2.678E+02,
     1 5.645E+00, 1.170E+01, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 4, 4),I=1,7) /9.539E+00, 2.932E+05,
     1 4.301E-01, 1.052E+01, 3.655E-01, 8.278E-04, 1.269E-02/
      DATA (PH2(I, 5, 1),I=1,7) /1.075E+01, 2.190E+03,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 5, 2),I=1,7) /3.336E+01, 2.846E+02,
     1 2.163E+01, 2.624E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 5, 3),I=1,7) /1.041E+00, 5.393E+01,
     1 1.767E+01, 9.540E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 5, 4),I=1,7) /2.869E+00, 1.859E+04,
     1 1.783E+00, 1.618E+01, 3.503E+00, 4.960E-03, 3.400E-02/
      DATA (PH2(I, 5, 5),I=1,7) /5.213E-01, 5.466E+00,
     1 8.618E+00, 1.728E+01, 1.887E+01, 1.319E+01, 4.556E+00/
      DATA (PH2(I, 6, 1),I=1,7) /1.548E+01, 1.521E+03,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 6, 2),I=1,7) /4.624E+01, 2.344E+02,
     1 2.183E+01, 2.581E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 6, 3),I=1,7) /3.506E+00, 1.068E+02,
     1 1.436E+01, 7.457E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 6, 4),I=1,7) /4.614E+00, 1.539E+04,
     1 1.737E+00, 1.593E+01, 5.922E+00, 4.378E-03, 2.528E-02/
      DATA (PH2(I, 6, 5),I=1,7) /4.058E-01, 8.709E+00,
     1 1.261E+02, 8.578E+00, 2.093E+00, 4.929E+01, 3.234E+00/
      DATA (PH2(I, 6, 6),I=1,7) /2.144E+00, 5.027E+02,
     1 6.216E+01, 5.101E+00, 9.157E-02, 1.133E+00, 1.607E+00/
      DATA (PH2(I, 7, 1),I=1,7) /2.108E+01, 1.117E+03,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 7, 2),I=1,7) /6.943E+01, 1.519E+02,
     1 2.627E+01, 2.315E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 7, 3),I=1,7) /4.471E+00, 8.376E+01,
     1 3.297E+01, 6.003E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 7, 4),I=1,7) /5.494E+00, 1.690E+04,
     1 1.714E+00, 1.706E+01, 7.904E+00, 6.415E-03, 1.937E-02/
      DATA (PH2(I, 7, 5),I=1,7) /2.420E-01, 9.375E-01,
     1 2.788E+02, 9.156E+00, 1.850E+00, 1.877E+02, 3.999E+00/
      DATA (PH2(I, 7, 6),I=1,7) /6.128E-02, 1.944E+00,
     1 8.163E+02, 8.773E+00, 1.043E+01, 4.280E+02, 2.030E+01/
      DATA (PH2(I, 7, 7),I=1,7) /4.034E+00, 8.235E+02,
     1 8.033E+01, 3.928E+00, 9.097E-02, 8.598E-01, 2.325E+00/
      DATA (PH2(I, 8, 1),I=1,7) /2.754E+01, 8.554E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 8, 2),I=1,7) /8.709E+01, 1.329E+02,
     1 2.535E+01, 2.336E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 8, 3),I=1,7) /7.824E+00, 6.864E+01,
     1 3.210E+01, 5.495E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 8, 4),I=1,7) /2.854E+00, 1.642E+04,
     1 1.792E+00, 2.647E+01, 2.836E+01, 3.036E-02, 5.554E-02/
      DATA (PH2(I, 8, 5),I=1,7) /2.044E-01, 8.659E-01,
     1 4.931E+02, 8.785E+00, 3.143E+00, 3.328E+02, 4.285E+01/
      DATA (PH2(I, 8, 6),I=1,7) /1.723E-01, 6.753E+02,
     1 3.852E+02, 6.822E+00, 1.191E-01, 3.839E-03, 4.569E-01/
      DATA (PH2(I, 8, 7),I=1,7) /1.386E+00, 5.967E+01,
     1 3.175E+01, 8.943E+00, 1.934E-02, 2.131E+01, 1.503E-02/
      DATA (PH2(I, 8, 8),I=1,7) /1.240E+00, 1.745E+03,
     1 3.784E+00, 1.764E+01, 7.589E-02, 8.698E+00, 1.271E-01/
      DATA (PH2(I, 9, 1),I=1,7) /3.485E+01, 6.759E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 9, 2),I=1,7) /1.131E+02, 1.039E+02,
     1 2.657E+01, 2.255E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 9, 3),I=1,7) /2.563E+00, 6.930E+01,
     1 7.547E+01, 6.448E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I, 9, 4),I=1,7) /4.008E+00, 1.157E+04,
     1 1.848E+00, 2.446E+01, 2.411E+01, 2.071E-02, 3.998E-02/
      DATA (PH2(I, 9, 5),I=1,7) /7.286E-01, 4.690E-01,
     1 1.400E+02, 9.718E+00, 2.570E-01, 1.506E+02, 2.574E-01/
      DATA (PH2(I, 9, 6),I=1,7) /7.744E-01, 3.165E+00,
     1 1.099E+02, 9.203E+00, 6.812E+00, 9.531E+01, 9.781E+00/
      DATA (PH2(I, 9, 7),I=1,7) /2.542E+00, 1.541E+02,
     1 5.742E+01, 6.614E+00, 1.115E+00, 1.641E+01, 5.124E+00/
      DATA (PH2(I, 9, 8),I=1,7) /1.763E+00, 8.013E+01,
     1 1.667E+01, 1.050E+01, 5.103E-01, 1.715E+01, 7.724E-01/
      DATA (PH2(I, 9, 9),I=1,7) /1.297E+01, 3.803E+03,
     1 2.587E+00, 7.275E+00, 2.170E-03, 1.701E-04, 1.345E-02/
      DATA (PH2(I,10, 1),I=1,7) /4.304E+01, 5.475E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,10, 2),I=1,7) /1.586E+02, 6.695E+01,
     1 3.352E+01, 2.002E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,10, 3),I=1,7) /1.003E+01, 5.631E+01,
     1 3.628E+01, 5.585E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,10, 4),I=1,7) /4.888E+00, 1.198E+04,
     1 1.788E+00, 2.550E+01, 2.811E+01, 2.536E-02, 4.417E-02/
      DATA (PH2(I,10, 5),I=1,7) /1.499E+00, 9.854E-01,
     1 1.350E+02, 8.836E+00, 1.656E+00, 1.042E+02, 1.435E+00/
      DATA (PH2(I,10, 6),I=1,7) /1.248E+00, 2.430E+00,
     1 1.066E+02, 8.999E+00, 6.855E-01, 9.169E+01, 3.702E-01/
      DATA (PH2(I,10, 7),I=1,7) /5.566E+00, 1.685E+03,
     1 6.409E+02, 3.056E+00, 8.290E-03, 5.149E+00, 6.687E+00/
      DATA (PH2(I,10, 8),I=1,7) /7.753E-01, 5.708E+00,
     1 6.725E+01, 1.005E+01, 4.633E-01, 7.654E+01, 2.023E+00/
      DATA (PH2(I,10, 9),I=1,7) /1.247E+01, 1.583E+03,
     1 3.935E+00, 7.810E+00, 6.558E-02, 1.520E+00, 1.084E-01/
      DATA (PH2(I,10,10),I=1,7) /4.870E+00, 4.287E+03,
     1 5.798E+00, 8.355E+00, 2.434E-01, 4.236E-02, 5.873E+00/
      DATA (PH2(I,11, 1),I=1,7) /5.211E+01, 4.525E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,11, 2),I=1,7) /2.268E+02, 3.995E+01,
     1 5.315E+01, 1.678E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,11, 3),I=1,7) /1.391E+01, 4.729E+01,
     1 3.889E+01, 5.265E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,11, 4),I=1,7) /1.535E+02, 7.215E+03,
     1 3.886E-01, 8.476E+00, 9.121E-01, 1.667E-01, 1.766E-02/
      DATA (PH2(I,11, 5),I=1,7) /2.096E+00, 1.609E+00,
     1 2.473E+02, 7.681E+00, 1.895E+00, 9.940E+01, 3.278E+00/
      DATA (PH2(I,11, 6),I=1,7) /4.846E+01, 7.101E+01,
     1 3.945E+01, 2.832E+00, 1.285E-02, 9.603E-04, 6.378E-03/
      DATA (PH2(I,11, 7),I=1,7) /5.408E+00, 2.346E+01,
     1 2.913E+01, 8.260E+00, 9.275E-01, 2.204E+01, 7.577E-01/
      DATA (PH2(I,11, 8),I=1,7) /6.690E-01, 2.330E+00,
     1 1.205E+02, 9.714E+00, 7.365E-01, 1.383E+02, 4.260E+00/
      DATA (PH2(I,11, 9),I=1,7) /1.069E+01, 1.885E+03,
     1 3.613E+00, 9.803E+00, 8.579E-02, 3.725E+00, 2.279E-01/
      DATA (PH2(I,11,10),I=1,7) /8.203E+00, 1.040E+03,
     1 8.259E+00, 7.362E+00, 2.328E+00, 3.375E+00, 4.010E+00/
      DATA (PH2(I,11,11),I=1,7) /6.139E+00, 1.601E+00,
     1 6.148E+03, 3.839E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,12, 1),I=1,7) /6.203E+01, 3.802E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,12, 2),I=1,7) /2.042E+02, 6.140E+01,
     1 2.778E+01, 2.161E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,12, 3),I=1,7) /1.452E+01, 4.427E+01,
     1 3.826E+01, 5.460E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,12, 4),I=1,7) /3.482E+01, 9.008E+02,
     1 1.823E+00, 1.444E+01, 2.751E+00, 5.444E+00, 7.918E-02/
      DATA (PH2(I,12, 5),I=1,7) /4.884E-01, 6.344E-02,
     1 5.085E+02, 9.385E+00, 6.666E-01, 5.348E+02, 3.997E-03/
      DATA (PH2(I,12, 6),I=1,7) /3.570E+00, 3.104E+00,
     1 6.060E+01, 8.857E+00, 1.422E+00, 5.452E+01, 2.078E+00/
      DATA (PH2(I,12, 7),I=1,7) /1.711E+00, 2.185E+00,
     1 9.350E+01, 9.202E+00, 6.325E-01, 1.007E+02, 1.729E+00/
      DATA (PH2(I,12, 8),I=1,7) /9.762E-01, 1.728E+00,
     1 9.184E+01, 1.006E+01, 8.090E-01, 1.276E+02, 3.979E+00/
      DATA (PH2(I,12, 9),I=1,7) /2.912E+01, 1.394E+03,
     1 2.895E+00, 6.487E+00, 4.326E-02, 9.402E-01, 1.135E-01/
      DATA (PH2(I,12,10),I=1,7) /1.086E+01, 5.377E+02,
     1 9.779E+00, 7.117E+00, 2.604E+00, 4.860E+00, 3.722E+00/
      DATA (PH2(I,12,11),I=1,7) /8.139E+00, 3.278E+00,
     1 4.341E+07, 3.610E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,12,12),I=1,7) /1.197E+01, 1.372E+08,
     1 2.228E-01, 1.574E+01, 2.805E-01, 0.000E+00, 0.000E+00/
      DATA (PH2(I,13, 1),I=1,7) /7.281E+01, 3.239E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,13, 2),I=1,7) /2.738E+02, 4.036E+01,
     1 3.567E+01, 1.915E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,13, 3),I=1,7) /2.355E+01, 3.388E+01,
     1 3.432E+01, 5.085E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,13, 4),I=1,7) /8.044E+00, 1.774E+04,
     1 1.653E+00, 2.655E+01, 2.953E+01, 2.538E-02, 1.203E-02/
      DATA (PH2(I,13, 5),I=1,7) /1.842E+00, 4.982E-01,
     1 2.568E+02, 8.406E+00, 6.945E-01, 1.719E+02, 6.595E+00/
      DATA (PH2(I,13, 6),I=1,7) /4.866E-01, 2.350E-01,
     1 7.216E+02, 8.659E+00, 2.773E-01, 5.704E+02, 1.580E-01/
      DATA (PH2(I,13, 7),I=1,7) /2.636E+00, 1.889E+02,
     1 1.338E+02, 6.204E+00, 1.836E+00, 3.552E+01, 8.223E-03/
      DATA (PH2(I,13, 8),I=1,7) /3.483E-01, 1.962E-02,
     1 1.856E+01, 2.084E+01, 8.839E+00, 5.675E-02, 2.768E-01/
      DATA (PH2(I,13, 9),I=1,7) /2.414E+01, 2.925E+02,
     1 6.973E+00, 6.724E+00, 1.000E-01, 3.495E+00, 2.701E-01/
      DATA (PH2(I,13,10),I=1,7) /3.130E+00, 1.513E+01,
     1 1.674E+01, 1.180E+01, 5.342E+00, 3.994E+01, 4.803E+00/
      DATA (PH2(I,13,11),I=1,7) /1.027E+01, 4.915E+00,
     1 1.990E+06, 3.477E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,13,12),I=1,7) /2.048E-01, 6.948E-02,
     1 5.675E+02, 9.049E+00, 4.615E-01, 9.149E+01, 6.565E-01/
      DATA (PH2(I,13,13),I=1,7) /1.381E+01, 7.195E+00,
     1 1.621E+03, 3.642E+00, 3.166E-01, 2.041E-01, 4.753E-01/
      DATA (PH2(I,14, 1),I=1,7) /8.447E+01, 2.793E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,14, 2),I=1,7) /2.752E+02, 4.754E+01,
     1 2.848E+01, 2.135E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,14, 3),I=1,7) /3.560E+01, 2.539E+01,
     1 3.307E+01, 4.728E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,14, 4),I=1,7) /1.205E+01, 1.992E+04,
     1 1.582E+00, 2.425E+01, 2.392E+01, 1.990E-02, 1.007E-02/
      DATA (PH2(I,14, 5),I=1,7) /8.787E-01, 1.950E-01,
     1 7.461E+02, 8.302E+00, 4.489E-01, 4.528E+02, 1.015E+00/
      DATA (PH2(I,14, 6),I=1,7) /3.343E-01, 1.465E-01,
     1 1.404E+03, 8.503E+00, 1.646E+00, 1.036E+03, 2.936E-01/
      DATA (PH2(I,14, 7),I=1,7) /7.655E-01, 3.477E-01,
     1 3.733E+02, 8.986E+00, 1.476E-03, 3.850E+02, 8.999E-02/
      DATA (PH2(I,14, 8),I=1,7) /3.277E-01, 6.680E-02,
     1 4.132E+01, 1.606E+01, 3.280E+00, 1.149E-02, 6.396E-01/
      DATA (PH2(I,14, 9),I=1,7) /6.305E+01, 7.293E+01,
     1 1.558E+02, 2.400E+00, 2.989E-03, 1.115E+00, 8.051E-02/
      DATA (PH2(I,14,10),I=1,7) /7.761E-01, 8.863E-01,
     1 1.541E+02, 9.980E+00, 1.303E+00, 2.009E+02, 4.537E+00/
      DATA (PH2(I,14,11),I=1,7) /1.288E+01, 6.083E+00,
     1 1.356E+06, 3.353E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,14,12),I=1,7) /1.659E-01, 5.790E-04,
     1 1.474E+02, 1.336E+01, 8.626E-01, 9.613E+01, 6.442E-01/
      DATA (PH2(I,14,13),I=1,7) /2.556E+00, 4.140E+00,
     1 1.337E+01, 1.191E+01, 1.570E+00, 6.634E+00, 1.272E-01/
      DATA (PH2(I,14,14),I=1,7) /2.317E+01, 2.506E+01,
     1 2.057E+01, 3.546E+00, 2.837E-01, 1.672E-05, 4.207E-01/
      DATA (PH2(I,16, 1),I=1,7) /1.104E+02, 2.139E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,16, 2),I=1,7) /4.390E+02, 2.453E+01,
     1 4.405E+01, 1.765E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,16, 3),I=1,7) /3.310E+01, 2.555E+01,
     1 3.821E+01, 5.037E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,16, 4),I=1,7) /1.474E+01, 2.294E+04,
     1 1.529E+00, 2.568E+01, 2.738E+01, 2.203E-02, 1.073E-02/
      DATA (PH2(I,16, 5),I=1,7) /2.443E+00, 3.490E-01,
     1 5.411E+02, 7.769E+00, 7.033E-01, 2.279E+02, 1.172E+00/
      DATA (PH2(I,16, 6),I=1,7) /6.485E+00, 1.275E+01,
     1 6.583E+01, 7.692E+00, 1.678E+00, 3.426E+01, 1.370E-01/
      DATA (PH2(I,16, 7),I=1,7) /1.040E+01, 5.364E+01,
     1 3.641E+01, 7.090E+00, 2.310E+00, 1.775E+01, 1.663E+00/
      DATA (PH2(I,16, 8),I=1,7) /1.526E-01, 9.646E+03,
     1 1.438E+03, 5.977E+00, 1.492E+00, 1.615E-03, 4.049E-01/
      DATA (PH2(I,16, 9),I=1,7) /1.462E+01, 3.161E+01,
     1 1.611E+01, 8.642E+00, 1.153E-03, 1.869E+01, 3.037E-01/
      DATA (PH2(I,16,10),I=1,7) /3.757E-01, 5.703E-01,
     1 1.460E+02, 1.135E+01, 1.503E+00, 2.222E+02, 4.606E+00/
      DATA (PH2(I,16,11),I=1,7) /1.413E+01, 9.139E+00,
     1 1.656E+03, 3.626E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,16,12),I=1,7) /1.713E-01, 5.072E-04,
     1 1.986E+02, 1.307E+01, 7.880E-01, 9.424E+01, 6.265E-01/
      DATA (PH2(I,16,13),I=1,7) /2.173E+00, 2.606E+00,
     1 6.641E+01, 8.655E+00, 1.863E+00, 1.975E+01, 3.361E+00/
      DATA (PH2(I,16,14),I=1,7) /2.027E+00, 6.666E+00,
     1 5.454E+01, 8.611E+00, 4.109E+00, 1.568E+01, 9.421E+00/
      DATA (PH2(I,16,15),I=1,7) /8.787E+00, 3.136E+02,
     1 3.442E+00, 1.281E+01, 7.354E-01, 2.782E+00, 1.788E-01/
      DATA (PH2(I,16,16),I=1,7) /1.808E+01, 4.564E+04,
     1 1.000E+00, 1.361E+01, 6.385E-01, 9.935E-01, 2.486E-01/
      DATA (PH2(I,18, 1),I=1,7) /1.399E+02, 1.690E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,18, 2),I=1,7) /4.468E+02, 3.108E+01,
     1 3.039E+01, 2.092E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,18, 3),I=1,7) /4.154E+01, 2.135E+01,
     1 4.118E+01, 4.945E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,18, 4),I=1,7) /1.888E+01, 2.571E+04,
     1 1.475E+00, 2.634E+01, 2.909E+01, 2.445E-02, 1.054E-02/
      DATA (PH2(I,18, 5),I=1,7) /1.557E+00, 4.997E-02,
     1 5.031E+02, 8.966E+00, 2.938E-01, 4.552E+02, 6.459E+00/
      DATA (PH2(I,18, 6),I=1,7) /3.209E-01, 2.459E-02,
     1 2.285E+03, 8.810E+00, 6.692E-01, 2.068E+03, 2.113E+01/
      DATA (PH2(I,18, 7),I=1,7) /5.310E+00, 7.018E-01,
     1 1.001E+02, 8.939E+00, 4.987E-01, 1.099E+02, 2.202E-01/
      DATA (PH2(I,18, 8),I=1,7) /1.257E-01, 1.760E+03,
     1 1.579E+03, 6.714E+00, 1.975E+00, 3.286E-03, 3.226E-01/
      DATA (PH2(I,18, 9),I=1,7) /1.040E+01, 8.204E+00,
     1 1.495E+01, 1.115E+01, 9.203E-04, 3.804E+01, 6.390E-01/
      DATA (PH2(I,18,10),I=1,7) /1.926E-01, 8.279E-01,
     1 2.392E+02, 1.121E+01, 1.434E+00, 3.814E+01, 4.649E+00/
      DATA (PH2(I,18,11),I=1,7) /3.884E+00, 3.295E+01,
     1 7.082E+02, 4.645E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,18,12),I=1,7) /2.966E-02, 3.693E+00,
     1 9.951E+03, 7.313E+00, 1.363E-02, 4.383E-04, 2.513E+00/
      DATA (PH2(I,18,13),I=1,7) /5.440E-01, 1.080E+00,
     1 9.419E+02, 7.582E+00, 1.107E+01, 1.700E+02, 1.587E+01/
      DATA (PH2(I,18,14),I=1,7) /1.031E+01, 9.946E+00,
     1 7.444E+01, 6.261E+00, 4.885E-01, 6.406E+00, 3.659E-03/
      DATA (PH2(I,18,15),I=1,7) /6.953E+00, 2.035E+01,
     1 1.400E+01, 9.595E+00, 8.842E-01, 7.501E+00, 1.806E-01/
      DATA (PH2(I,18,16),I=1,7) /1.417E+01, 3.580E+01,
     1 3.776E+01, 5.742E+00, 6.316E-01, 2.384E+00, 1.794E+00/
      DATA (PH2(I,18,17),I=1,7) /2.494E+01, 2.503E+01,
     1 1.272E+02, 4.288E+00, 5.108E-01, 9.299E-01, 7.195E-01/
      DATA (PH2(I,18,18),I=1,7) /1.709E+01, 2.106E+01,
     1 2.645E+02, 4.796E+00, 4.185E-01, 1.688E+00, 8.943E-01/
      DATA (PH2(I,20, 1),I=1,7) /1.729E+02, 1.369E+02,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,20, 2),I=1,7) /6.297E+02, 1.936E+01,
     1 3.921E+01, 1.862E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,20, 3),I=1,7) /9.472E+01, 1.105E+01,
     1 3.818E+01, 4.192E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,20, 4),I=1,7) /2.618E+01, 2.028E+04,
     1 1.456E+00, 2.560E+01, 2.803E+01, 2.402E-02, 9.323E-03/
      DATA (PH2(I,20, 5),I=1,7) /4.293E+00, 1.293E+00,
     1 1.691E+01, 1.438E+01, 3.461E-05, 9.363E-01, 4.589E-02/
      DATA (PH2(I,20, 6),I=1,7) /1.309E+02, 5.513E+01,
     1 3.828E+02, 2.023E+00, 9.084E-02, 1.833E-02, 9.359E-01/
      DATA (PH2(I,20, 7),I=1,7) /9.980E+00, 1.116E+00,
     1 5.918E+01, 9.005E+00, 3.879E+00, 7.104E+01, 5.311E+00/
      DATA (PH2(I,20, 8),I=1,7) /1.008E+01, 1.849E+03,
     1 1.792E+04, 2.868E+00, 2.410E+02, 6.138E-03, 6.931E+01/
      DATA (PH2(I,20, 9),I=1,7) /2.345E+01, 1.227E+01,
     1 1.312E+01, 9.771E+00, 6.842E-04, 2.417E+01, 5.469E-01/
      DATA (PH2(I,20,10),I=1,7) /2.288E-01, 9.384E-01,
     1 2.549E+02, 1.103E+01, 1.390E+00, 2.478E+01, 3.100E+00/
      DATA (PH2(I,20,11),I=1,7) /1.605E+01, 1.437E+01,
     1 6.989E+02, 3.857E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,20,12),I=1,7) /5.520E-02, 2.076E+02,
     1 1.790E+04, 5.893E+00, 1.843E-03, 2.826E-04, 1.657E+00/
      DATA (PH2(I,20,13),I=1,7) /1.366E+00, 6.641E-01,
     1 3.188E+02, 8.138E+00, 2.806E-01, 1.039E+02, 3.329E+00/
      DATA (PH2(I,20,14),I=1,7) /8.080E-01, 4.760E-01,
     1 3.682E+02, 8.634E+00, 5.720E-01, 1.487E+02, 1.283E+00/
      DATA (PH2(I,20,15),I=1,7) /9.515E+00, 7.642E+01,
     1 8.973E+01, 5.141E+00, 2.471E+00, 4.829E+00, 5.824E+00/
      DATA (PH2(I,20,16),I=1,7) /6.882E-01, 1.523E-01,
     1 1.502E+02, 1.061E+01, 8.227E+00, 1.210E+02, 3.876E+00/
      DATA (PH2(I,20,17),I=1,7) /4.255E+00, 7.736E+00,
     1 1.355E+01, 1.236E+01, 1.369E+00, 1.467E+01, 3.298E-02/
      DATA (PH2(I,20,18),I=1,7) /2.436E+01, 3.815E+01,
     1 2.931E+02, 3.944E+00, 3.126E-01, 1.802E+00, 1.233E+00/
      DATA (PH2(I,20,19),I=1,7) /1.553E+01, 1.064E+07,
     1 7.790E-01, 2.130E+01, 6.453E-01, 2.161E-03, 6.706E-02/
      DATA (PH2(I,20,20),I=1,7) /1.278E+01, 5.370E+05,
     1 3.162E-01, 1.242E+01, 4.477E-01, 1.012E-03, 1.851E-02/
      DATA (PH2(I,26, 1),I=1,7) /2.932E+02, 8.099E+01,
     1 3.288E+01, 2.963E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,26, 2),I=1,7) /1.057E+03, 1.195E+01,
     1 5.769E+01, 1.718E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,26, 3),I=1,7) /7.326E+01, 1.276E+01,
     1 4.914E+01, 4.941E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,26, 4),I=1,7) /4.575E+01, 2.580E+04,
     1 1.358E+00, 2.604E+01, 2.723E+01, 3.582E-02, 8.712E-03/
      DATA (PH2(I,26, 5),I=1,7) /9.713E+00, 7.204E-02,
     1 1.853E+02, 8.843E+00, 9.551E-03, 1.702E+02, 4.263E+00/
      DATA (PH2(I,26, 6),I=1,7) /9.243E+00, 1.098E+01,
     1 7.637E+01, 7.962E+00, 1.748E+00, 4.446E+01, 3.512E+00/
      DATA (PH2(I,26, 7),I=1,7) /2.011E+01, 4.455E-01,
     1 4.236E+01, 9.724E+00, 2.757E+00, 6.847E+01, 3.989E+00/
      DATA (PH2(I,26, 8),I=1,7) /7.519E-04, 6.066E-05,
     1 1.606E+06, 8.813E+00, 4.398E+00, 1.915E+06, 3.140E+01/
      DATA (PH2(I,26, 9),I=1,7) /3.190E+01, 2.388E+00,
     1 2.186E+01, 9.589E+00, 2.902E-02, 3.805E+01, 4.805E-01/
      DATA (PH2(I,26,10),I=1,7) /3.444E-01, 1.452E+00,
     1 3.960E+02, 1.013E+01, 1.264E+00, 2.891E+01, 3.404E+00/
      DATA (PH2(I,26,11),I=1,7) /2.873E+01, 1.207E+01,
     1 5.150E+02, 3.846E+00, 0.000E+00, 0.000E+00, 0.000E+00/
      DATA (PH2(I,26,12),I=1,7) /5.555E-02, 2.108E+02,
     1 2.045E+04, 6.033E+00, 1.885E-03, 2.706E-04, 1.628E+00/
      DATA (PH2(I,26,13),I=1,7) /8.509E-01, 1.454E-01,
     1 1.239E+03, 8.066E+00, 4.937E-01, 4.505E+02, 2.504E+00/
      DATA (PH2(I,26,14),I=1,7) /1.317E-01, 2.791E-03,
     1 2.487E+03, 9.791E+00, 6.938E-01, 2.170E+03, 6.852E-03/
      DATA (PH2(I,26,15),I=1,7) /6.295E+00, 1.738E+00,
     1 1.130E+02, 8.037E+00, 3.096E-01, 4.671E+01, 1.425E-01/
      DATA (PH2(I,26,16),I=1,7) /8.284E+00, 3.281E+00,
     1 5.360E+01, 8.571E+00, 3.279E-01, 2.971E+01, 5.220E-01/
      DATA (PH2(I,26,17),I=1,7) /6.886E+01, 6.470E+01,
     1 2.062E+01, 4.111E+00, 2.778E-04, 1.190E-05, 6.570E-03/
      DATA (PH2(I,26,18),I=1,7) /6.741E+00, 2.687E+01,
     1 1.807E+02, 6.290E+00, 2.387E-04, 2.494E+01, 8.251E+00/
      DATA (PH2(I,26,19),I=1,7) /7.098E-02, 1.979E+01,
     1 1.745E+04, 6.750E+00, 2.158E+02, 2.542E+03, 4.672E+02/
      DATA (PH2(I,26,20),I=1,7) /5.059E+00, 2.420E+04,
     1 4.850E+04, 2.374E+00, 2.516E-03, 4.546E-01, 2.683E+01/
      DATA (PH2(I,26,21),I=1,7) /2.656E+00, 5.259E-01,
     1 1.450E+01, 1.632E+01, 1.558E+01, 3.361E+01, 3.743E-03/
      DATA (PH2(I,26,22),I=1,7) /7.256E-01, 1.523E-03,
     1 3.736E+01, 1.767E+01, 5.064E+01, 8.871E+01, 5.280E-02/
      DATA (PH2(I,26,23),I=1,7) /2.544E+01, 3.653E+02,
     1 8.913E+00, 6.538E+00, 5.602E-01, 0.000E+00, 0.000E+00/
      DATA (PH2(I,26,24),I=1,7) /1.698E-01, 6.107E+00,
     1 1.555E+03, 8.055E+00, 8.698E+00, 1.760E+02, 1.847E+01/
      DATA (PH2(I,26,25),I=1,7) /1.761E-01, 4.365E+03,
     1 6.298E+03, 5.204E+00, 1.141E+01, 9.272E+01, 1.075E+02/
      DATA (PH2(I,26,26),I=1,7) /5.461E-02, 3.062E-01,
     1 2.671E+07, 7.923E+00, 2.069E+01, 1.382E+02, 2.481E-01/
      END
******************************************************************************
      subroutine phosi
      implicit none
*derive ionization balance for phosphorus
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real hi , hii
      common/h/ hi , hii
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=16)
      parameter (nelem=15)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(16)
*
*     phosphorus nelem=15
*     data from sulphus
*
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/16*0.2/
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.45E-10,7.11E-11,2.12E-11,6.39E-12,6.43E-12,1.85E-12,
     1 1.71E-12,1.01E-12,6.97E-13,4.75E-13,2.90E-13,1.63E-13,1.04E-13,
     2 4.42E-14,4.25E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /1.20E5,2.71E5,4.06E5,5.49E5,8.47E5,1.02E6,3.26E6,3.81E6,
     2 4.40E6,5.19E6,5.86E6,6.55E6,7.56E6,8.02E6,3.74E7/
*
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
*     rec from +13 14 15 from Arnauld et al 85
      data rec , pl
     1/1.54E-10 , 13.4E-10 , 3.37E-9 , 7.36E-9 , 7.64E-9 , 4.23E-8 ,
     2 2.31E-8  , 2.43E-8  , 3.84E-8 , 5.41E-8 , 6.60E-8 , 1.47E-7 ,
     2 3.35E-7  , 6.67E-7  ,
     3 -0.63    , -0.686   , -0.745  , -0.755  , -0.701  , -0.849  ,
     3 -0.733   , -0.696   , -0.711  , -0.716  , -0.714  , -0.755  ,
     3 -0.806   , -0.840   /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.23e-10 , -0.593 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.62E-3, 1.09E-2, 3.35E-2, 3.14E-2, 1.27E-2, 1.47E-2, 1.34E-2,
     2 2.38E-2, 3.19E-2, 7.13E-2, .08, .0796, .0134, .402,0./
      data (dicoef(i,2),i=1,ndim-1)
     1/0., 1.20E-2, 6.59E-2, 6.89E-2, .187, .129, 1.04, 1.12, 1.40,
     2 1.00, .555, 1.63, .304, .298, 0./
      data (dite(i,1),i=1,ndim-1)
     1/1.25E+5, 1.92E+5, 1.89E+5, 1.68E+5, 1.38E+5, 1.80E+6, 6.90E+5,
     2 5.84E+5, 5.17E+5, 6.66E+5, 6.00E+5, 5.09E+5, 2.91E+5, 2.41E+7,
     3 0./
      data (dite(i,2),i=1,ndim-1)
     1/0., 1.80E+4, 1.59E+5, 8.04E+4, 1.71E+5, 1.75E+6, 2.15E+6,
     1 2.59E+6, 2.91E+6, 2.32E+6, 2.41E+6, 6.37E+6, 1.04E+6, 4.67E+6,
     2 0./
      data ditcrt
     3/2.2E4  , 1.2E4  , 1.4E4  , 1.5E4  , 1.4E4  , 2.9E5  , 1.3E5
     3,1.1E5  , 9.0E4  , 9.0E4  , 9.0E4  , 8.3E4  , 6.0E4  , 5.0E6
     3, 1E20  /
*
*     phosphorus, atomic number 15
      IF( .NOT.lgElmtOn(nelem) ) THEN
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine PhotoIonize( nelem )
      implicit none
*fill array PhotoRate with photoionization rates for heavy elements
      real gamk
      integer nelem
      integer limelm
      parameter (limelm=30)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real hv2ion , hv2la
      common/hv2ion/ hv2ion(limelm,limelm) , hv2la(limelm,limelm)
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      real PhotScaleOn
*     set to 1 in zero, so have no effect
*     set to 0 with 'no photoionization' command, kills
*     photoionization of everything
      common/PhotScale/ PhotScaleOn
      real vyield
      integer nyield
*     block data of yields from Mewe paper
*     vyield( nelem, nstage, nshell, nelec )
*     nelem is element number, 6 for carbon
*     nstage is stage of ionization, 1 for atom
*     nshell is shell number in dima notation
*     nelec is fraction that yield that number of electrons
**    nyield is number of electrons at most
      common/yield/ vyield(30,30,7,10), nyield(30,30,7)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , j , k , ns , iplow , iphi , ipop
*
*     nelem is element number, 6=carbon, 26=iron
*
*     IonLow(nelem) and IonHigh(nelem) are bounds for evaluation
*
*     option to not evaluate rates if not first iteration
      if( .not.lgDoPhoto ) return
*
*begin sanity check
      if( IonLow(nelem).le.0 .or. IonLow(nelem).gt.nelem .or.
     1  IonHigh(nelem).gt.nelem+1) then
        write(qq,'('' PhotoIonize called with insane low, high:nelem='',
     1  i4,'' low, high='',2i10)') nelem, IonLow(nelem) , IonHigh(nelem)
        call ShowMe
        stop
      endif
*end sanity check
*
*     zero out the zrray
      do i=1,nelem
        hv2ion(nelem,i) = 0.
        hv2la(nelem,i) = 0.
        do j=1,7
          do k=1,2
            PhotoRate(nelem,i,j,k) = 0.
          end do
        end do
      end do
*
      do i=IonLow(nelem),IonHigh(nelem)-1
*       do ns=1,nsElem(i)
*     >>chng 96 oct 1, get rid of nsElem, use master array instead
        do ns=1,nsShells(nelem,i)
          iplow = ipElement(nelem,i,ns,1)
          iphi = ipElement(nelem,i,ns,2)
          ipop = ipElement(nelem,i,ns,3)
*         compute the photoionization rate,PhotScaleOn is 1, set 0
*         with "no photoionization" command
          PhotoRate(nelem,i,ns,1)  = gamk( iplow , iphi , ipop ,
     1    vyield(nelem,i,ns,1) ) * PhotScaleOn
*         this is the heating rate
*         in all these save rates BEFORE multiplication by secondary
*         efficiencies, since they will themselves change later
          PhotoRate(nelem,i,ns,2)  = h
          hv2ion(nelem,i) = hv2ion(nelem,i) + secion
          hv2la(nelem,i) = hv2la(nelem,i) + secla
        end do
      end do
*
*     real rate
*     if(nelem.eq.6) then
*       call broken
*       ns = nsElem(1)
*       i = 1
*       iplow = ipElement(nelem,i,ns,1)
*       iphi = ipElement(nelem,i,ns,2)
*       ipop = ipElement(nelem,i,ns,3)
*       rate =  PhotoRate(nelem,i,ns,1)
*       if(rate.gt.0. )
*    1  call PrtGamma(iplow ,iphi,ipop,20,rate,rate*0.05)
*     endif
*
      end
******************************************************************************
      subroutine PIonte
      implicit none
*drive pressure, ionization, and thermal balance
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real pnow , pcorec
      common/pnow/ pnow , pcorec
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer ntry
      common/ntry/ ntry
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgPresOK
*     set true in presur if presure ok, false otherwise
      common/presok/ lgPresOK
      real failmx
*     info related to the number of temperature or pressure failures
*     failmx is largest relative error in heating cooling match
*     nPreFail is number of pressure failuers
      integer nfail , nPreFail
      common/nfail/ nfail , failmx , nPreFail
      logical lgTeFail
*set true in IONTE if heating - cooling failure
      common/tfail/ lgTeFail
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nmax , nThLoop
      parameter (nmax=20)
      integer loop
      logical lgLoopOnce
*
      if( lgTrConvg ) then
        write(qq,'(''  '')')
        write(qq,'('' PIonte entered zone'',i4)') nzone
      endif
*     ntry is number of times ionize called
      ntry = 0
      loop = 0
      lgPresOK = .false.
      lgLoopOnce = .true.
      do while((.not.lgPresOK .and. loop.lt.nmax) .or.
     1  lgLoopOnce )
        if( lgTrConvg ) then
          write(qq,'('' PIonte  loop'',I4,'' Te:'',1P,
     1    E9.2,'' Hden:'',E9.2,'' current Pres:'',E9.2,'' Corr Pres'',
     2    E9.2)') loop , te,hden,pnow,pcorec
        endif
*       pressure loop, presur evaluates lgPresOK, true if pressure now ok
        call presur(loop)
*       heating cooling balance while doing ionization
        call ionte(nThLoop,loop)
*       make sure boltzmann factors are up to date
        call boltgn
        loop = loop + 1
*       this just makes sure we do two solutions
        if( loop.gt.1 .or. nThLoop.gt.1 ) lgLoopOnce = .false.
      end do
*     lgTeFail is flag set in IONTE to say whether heating - cooling matched
      if( lgTeFail ) then
        call tefail
      endif
      if( .not.lgIonDone.and. .not.lgTeFail ) then
        write(qq,'('' No Ioniz Convergence'')')
      endif
*
*     keep track of high and low pressures
*     plow = min( plow , pnow )
*     phi = max( phi , pnow )
*
      if( .not.lgPresOK .and.lgTalk ) then
*       record number of pressure failures
        nPreFail = nPreFail + 1
        write(qq,'('' PIonte exit, pressure not converged; zone'',I4,
     1  '' Te:'',1P,E9.2,'' Hden:'',E9.2,'' current Pres:'',E9.2,
     1  '' Corr Pres'',e9.2)') nzone, te,hden,pnow,pcorec
      else if( lgTrConvg ) then
*       option to follow convergene, only necessary to print if not above
        write(qq,'('' PIonte exit, pressure converged, Te:'',1p,
     1  e9.2,'' Hden:'',E9.2,'' current Pres:'',E9.2,'' Corr Pres'',
     2  e9.2)') te,hden,pnow,pcorec
      endif
*
      end
******************************************************************************
      real function plankf( ip )
      implicit none
*evaluate Planck function for any cell at current electron temperature
      integer ip
*
      real fr1ryd
*     frequency of 1 rydberg
*     FR1RYD is frequency for 912
      parameter (fr1ryd=3.28805E15)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
*
*     evaluate Planck function
*     argument is pointer to cell energy in ANU
*     return photon flux for cell IP
      if( ContBoltz(ip).le.0. ) then
        plankf = 1e-35
      else
        plankf = 6.991e-21 * (fr1ryd*anu(ip))**2 /
     1  (1./ContBoltz(ip) - 1) * fr1ryd * 4.
      endif
*
      end
******************************************************************************
      subroutine pldata( io )
      implicit none
*punches selected line data for all lines transferred in code
      integer io
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      real hi , hii
      common/h/ hi , hii
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
*     save rec coef data for recombination lines of C, N, O
      real RecCoefCNO(471,4)
      common/RecCNO/ RecCoefCNO
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,j , nelem , iWavLen
      real tot , dc
      character chLineLbl*10 , chLbl*10
*
*     routine punches out (on unit io) line data
*     for all recombination lines, and all transitions that are transferred
*
*     say what is happening so we know why we stopped
      write(qq,'('' punching line data, then stopping'')')
*
*     evaluate rec coef at constant temperature if this is set, else
*     use 10,000K
      if( lgTSetOn ) then
        te = ForceTemp
      else
        te = 1e4
      endif
*     this is set of Dima's recombination lines
      call LineFit( te , RecCoefCNO )
      nelem = 2
      write(io,'(/7x,''Recombination lines of C, N, O'')')
      write(io,'(4x,''Ion  WL(A)   Coef     Ion   WL(A)  Coef'')')
      do i=1,471,nelem
        write(io,'(2(4x,a2,i2,i6,f8.3))')
     1  (chElementSym(int(RecCoefCNO(j,1))),
     2  int(RecCoefCNO(j,1)-RecCoefCNO(j,2)+1.01),
     3  int(RecCoefCNO(j,3)+0.5),
     3  log10(RecCoefCNO(j,4)),j=i,min(471,i+nelem-1))
      end do
      write(io,'(/)')
*
      eden = 1.
      hden = 1.
*     want very small neutral fractions so get mostly e- cs
      hi = 1.e-5
      htwo = 0.
      hii = 1.
      do i=1,nTauLines
        TauLines(ipLnPopl,i) = 1.
      end do
      do i=1,NWINDLINE
        WindLine(ipLnPopl,i) = 1.
      end do
      do i=1,limelm
        do j=1,limelm
          xIonFracs(i,j) = 1.
        end do
      end do
      call coolr( tot , dc )
*
      write(io,'(7x,''Level 1 transferred lines'')')
      write(io,'(''Ion label   WL '',
     1'' gl gu    gf       A       CS'')')
      do i=1,nTauLines
        chLbl = chLineLbl(TauLines(1,i) )
*       following logic must be kept parallel with that in putline
        iWavLen = TauLines( ipLnWlAng ,i)
        if(iWavLen.gt.1 000 000 ) then
          iWavLen = iWavLen / 10000
        else if(iWavLen.gt.10 000 ) then
          iWavLen = iWavLen / 1000
        else if( iWavLen.lt.10 ) then
          iWavLen = TauLines( ipLnWlAng ,i) * 10.
        endif
*       check because some CS are huge, others small, but avoid exp notation
        if( TauLines(ipLnCS,i).gt.1. ) then
*         write(io,'(a10,i5,1p,2i3,2e9.2,0p,f7.3)')
          write(io,'(a4,i5,a6,1p,2i3,2e9.2,0p,f7.3)')
     1    chLbl(1:4) ,iWavLen, chLbl(5:10),
     2    int(TauLines(ipLnGl,i)),
     3    int(TauLines(ipLnGu,i)) ,
     3    TauLines(ipLnGF,i),
     3    TauLines(ipLnAul,i),TauLines(ipLnCS,i)
        else
*         write(io,'(a10,i5,1p,2i3,2e9.2,0p,f7.4)')
          write(io,'(a4,i5,a6,1p,2i3,2e9.2,0p,f7.4)')
     1    chLbl(1:4) ,iWavLen, chLbl(5:10),
     2    int(TauLines(ipLnGl,i)),
     3    int(TauLines(ipLnGu,i)) ,
     3    TauLines(ipLnGF,i),
     3    TauLines(ipLnAul,i),TauLines(ipLnCS,i)
        endif
      end do
*
      write(io,'(//)')
      write(io,'(7x,''end level 1, start level 2'')')
      write(io,'(''Ion label   WL '',
     1'' gl gu    gf       A       CS'')')
      do i=1,NWINDLINE
        nelem = WindLine(ipLnNelem,i)
        iWavLen = WindLine( ipLnWlAng ,i)
*       following logic must be kept parallel with that in putline
        if(iWavLen.gt.1 000 000 ) then
          iWavLen = iWavLen / 10000
        else if(iWavLen.gt.10 000 ) then
          iWavLen = iWavLen / 1000
        else if( iWavLen.lt.10 ) then
          iWavLen = WindLine( ipLnWlAng ,i) * 10.
        endif
        chLbl = chLineLbl(WindLine(1,i) )
        if( WindLine(ipLnCS,i).gt.1. ) then
*         write(io,'(a10,i5,1p,2i3,2e9.2,0p,f7.3)')
          write(io,'(a4,i5,a6,1p,2i3,2e9.2,0p,f7.3)')
*         write(io,'(i5,1x,a4,i5,a6,1p,2i3,2e9.2,0p,f7.3)')
     1    chLbl(1:4) ,iWavLen,chLbl(5:10),
*    1    int(WindLine(ipLnipCont,i)),chLbl(1:4) ,iWavLen,chLbl(5:10),
     2    int(WindLine(ipLnGl,i)),
     3    int(WindLine(ipLnGu,i)) ,
     3    WindLine(ipLnGF,i),
     3    WindLine(ipLnAul,i),WindLine(ipLnCS,i)
        else
*         write(io,'(a10,i5,1p,1x,2i3,2e9.2,0p,f7.4)')
          write(io,'(a4,i5,a6,1p,2i3,2e9.2,0p,f7.4)')
*         write(io,'(i5,1x,a4,i5,a6,1p,2i3,2e9.2,0p,f7.4)')
     1    chLbl(1:4) ,iWavLen,chLbl(5:10),
*    1    int(WindLine(ipLnipCont,i)),chLbl(1:4) ,iWavLen,chLbl(5:10),
     2    int(WindLine(ipLnGl,i)),
     3    int(WindLine(ipLnGu,i)) ,
     3    WindLine(ipLnGF,i),
     3    WindLine(ipLnAul,i),WindLine(ipLnCS,i)
        endif
      end do
*
*     stop when done, we have done some serious damage to the code
      write(qq,'('' stopping in pldata'')')
      stop
*
      end
******************************************************************************
      subroutine plinin( io )
      implicit none
*produce the 'punch lines intensity' output
      integer io
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real telec , thmin
      common/taucon/ telec , thmin
*
*     local variables
      character*80 chCard
      logical lgEOF
      integer i
*
*     used to punch out all the emission line intensities
*     first initialize the line image reader
      call rdinit
*
      write(io,'(130(''*''))')
      lgEOF = .false.
      do while( .not.lgEOF )
        call readar( chCard , lgEOF )
        if(.not.lgEOF)write(io,'(a80)') chCard
      end do
*     first print any cautions or warnings
      call warnot( io )
      call caunot (io )
      write(io,'(''zone='',i5)') nzone
      write(io,'(130(''*''))')
      write(io,'(''begin emission lines'')')
*
*     >>chng 96 july 3, only punch zero intensities
      call PunResult(io,'    ', 0, 0., 'Start' )
      do i=1,nsum
        if( sumlin(i).gt.0. ) then
          call PunResult(io,chALab(i),lin(i),sumlin(i),'Line ')
        endif
      end do
      call PunResult(io,'    ', 0, 0., 'Flush' )
*     write(io,'(6(1x,a4,i6,1p,e10.3))') (chALab(I) ,
*    1lin(i) , sumlin(i),i=1,nsum)
*
      write(io,'(''     '')')
      write(io,'(130(''*''))')
*
      end
      subroutine pllabels( io )
      implicit none
*punch all labels and wavelengths for emission line array
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer io
*
*     local variables
      integer i
*
      do i=1,nsum
*       this format chosen to be identical to that used by final
        write(io,'(a4,i5)')chALab(i), lin(i)
      end do
      end
******************************************************************************
      subroutine plot( chCall )
      implicit none
*master routine to generate some sort of plot
      character*5 chCall
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer mapdim
      parameter (mapdim=102)
      integer ndplot
      parameter (ndplot=10)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real opac
      common/opac/ opac(ncell)
      integer nmap
      real temap , hmap , cmap
      common/mapr/ nmap , temap(mapdim) , hmap(mapdim) , cmap(mapdim)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
*     include "pltrce.com"
      character chPType*4
*     which type of plot
      common/ptype/ chPType(ndplot)
      logical lgLastIt
*     this is false on any but the last iteration
*     set true in startr if iter > itermx
      common/lastit/ lgLastIt
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer np
*
*     return if this is not the last iteration, or a plot not required
      if( .not.lgPlotON ) return
      if( .not.lgLastIt .and. (chCall.ne.'FIRST') ) return
      do np=1,nplot
        if( chPType(np).eq.' MAP' ) then
          call pltmap( np , chCall )
        else if(
     1     chPType(np).eq.'CONT' .or. chPType(np).eq.'CRAW' .or.
     1     chPType(np).eq.'DIFF' .or. chPType(np).eq.'REFL' .or.
     2     chPType(np).eq.'EMIT' .or. chPType(np).eq.'CPHT' .or.
     3     chPType(np).eq.'OUTW' ) then
           call pltcon( np , chCall )
        else if( chPType(np).eq.'OPAA' .or. chPType(np).eq.'OPAS' .or.
     1     chPType(np).eq.'OPAT' ) then
*          absorption, scattering, or total opacity
           call pltopc( np , chCall )
        else
          write(qq,'('' PLOT type='',A4,'' not known.  STOP'')')
     1    chPType(np)
          stop
        endif
      end do
*
      end
******************************************************************************
      subroutine pltcon( np , chCall )
      implicit none
*generate plot of continuum array
      integer np
      character chCall*5
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real DiffCont
*diffus is local diffuse continuum, for current zone
      common/diffus/ DiffCont(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real FluxSave
*save incident continuum for later iterations
      common/flxsav/ FluxSave(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      integer ndplot
      parameter (ndplot=10)
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
      logical lgPltTrace
*flag set with plot trace command
      common/pltrce/ lgPltTrace(ndplot)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real widflx
      common/widflx/ widflx(ncell)
      real r1r0sq
      common/r1r0sq/ r1r0sq
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      character chPType*4
*     which type of plot
      common/ptype/ chPType(ndplot)
      real SavOutCon(ncell)
*     variables related to deriving the ratio of outward to incident continuum
*     SumOutMax - energy where max occurs, ipSumOutMax pointer to this
*     sumOutCon is summed out outlin and outcon less SavOutCon for all energy
*     SumHOutCon is H-ionizing only
      real SumOutCon , SumIncCon , SumHOutCon , SumHIncCon , SumOutMax
      integer ipSumOutMax
      common/SumOutInc/ SumOutCon , SumIncCon , SavOutCon , SumHOutCon ,
     1 SumHIncCon , SumOutMax , ipSumOutMax
      real opac
      common/opac/ opac(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      character chXtitle*22
      character chSym*1 , chSymPlt1*1 , chSymPlt2*2
      real y(ncell) , y2(ncell)
      save xmin , xmax , ymin , ymax
      save y , y2
      real xmax , contin , ymin , ymin2 , ymax , xmin
      integer i
*
      if( chCall .eq. 'FIRST' ) return
*
      xmin = anulog(1)
      xmin = max( pltxmn(np) , xmin )
      xmax = anulog(nflux)
      xmax = min( xmax , pltxmx(np) )
*
      if(lgPltTrace(np))write(qq,'('' XMIN, XMAX='',1P,2E12.4,
     1'' NFLUX='',3I4)')xmin,xmax,nflux
*
      if( chPType(np).eq.'REFL' .and. lgSphere ) then
        write(qq,'('' Reflected continuum not computed when SPHERE '',
     1  ''set.'')')
        return
      endif
*
*     these will be the default symbols for first and second plot
      chSymPlt1 = '.'
      chSymPlt2 = 'o'
      ymin = 1e37
      ymin2 = 1e37
      ymax = -1e37
      do i=1,nflux
         if( anulog(i).gt.xmin .and. anulog(i).lt.xmax ) then
            if( chPType(np).eq.'CONT' ) then
               y(i) = log10( max( FluxSave(i)/widflx(i)*anu2(i),
     1         1e-37) )
               contin = flux(i) + (ContDiff(i) + outcon(i)) * covgeo
               y2(i) =max((contin/widflx(i)+outlin(i)*covgeo)*anu2(i)*
     1         r1r0sq, 1e-37)
               y2(i) = log10( y2(i) )
            else if( chPType(np).eq.'CPHT' ) then
*              plot continuum as photons
               y(i) = log10( max( FluxSave(i)/widflx(i), 1e-37) )
               contin = flux(i) + (ContDiff(i)+outcon(i))*
     1         covgeo/widflx(i)
               y2(i) = max( (contin+outlin(i)*covgeo)*r1r0sq , 1e-37)
               y2(i) = log10( y2(i) )
            else if( chPType(np).eq.'REFL' ) then
*              plot "reflected" continuum from last zone only
               y(i) = log10( max( (refcon(i)/widflx(i)+reflin(i))*
     1         anu2(i),1e-37))
               y2(i) = y(i)
            else if( chPType(np).eq.'EMIT' ) then
*              plot "emitted" continuum from both sides of cloud
               y(i) = log10( max(
     1         ((refcon(i)+ContDiff(i)+outcon(i))/widflx(i) +outlin(i)
     1         + reflin(i) )* anu2(i), 1e-37))
               y2(i) = y(i)
            else if( chPType(np).eq.'OUTW' ) then
*              plot outward and attenuated incident continuum
               chSymPlt1 = 'i'
               y(i) = log10(max(flux(i)*opac(i),1e-37))
               chSymPlt2 = 'o'
               y2(i) = log10(max((outlin(i)+outcon(i)-SavOutCon(i))*
     1         opac(i), 1e-37))
            else if( chPType(np).eq.'DIFF' ) then
*              plot "diffuse" continuum from last zone only
               y(i) = log10( max( DiffCont(i)*anu2(i)/widflx(i) ,1e-37))
               y2(i) = y(i)
            else if( chPType(np).eq.'CRAW' ) then
               y(i) = log10( max( FluxSave(i) ,1e-37))
               y2(i) = max( (flux(i)+ContDiff(i)+otscon(i)+otslin(i)+
     1         outlin(i)+outcon(i))* r1r0sq , 1e-37 )
               y2(i) = log10( y2(i) )
            endif
            if(y(i).gt.-36.9 ) ymin = min( ymin , y(i) )
            if(y2(i).gt.-36.9 ) ymin2 = min( ymin2 , y2(i) )
            ymax = max( ymax , y(i) , y2(i) )
         endif
      end do
*
      if(lgTrace) write(qq,'('' PLOT called for the first time,'',
     1 '' YMAX, MIN='',1P,2E10.2)') ymax , ymin
*
*     lower min by at most 5 dex below peak
      ymin2 = max( ymax - 5. , -35. , ymin2 )
*     make sure there is room at the bottom
      ymin = min( ymin2 , ymin , ymax - 1. )
*     emitted continuum is thermal, so goes to zero
      if( chPType(np) .eq.'EMIT' ) ymin = max( ymin , ymax-4. )
*
      if(lgPltTrace(np))write(qq,'('' YMAX, MIN='',1P,2E14.4,'' Npnts=''
     1 ,I4)') ymax,ymin , nflux
      chXtitle = 'Log(nu fnu) vs log(nu)'
*
      chSym = chSymPlt1
      call pltr( anulog , y , nflux , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 1 , lgPltTrace(np) )
      chSym = chSymPlt2
      call pltr( anulog , y2, nflux , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 3 , lgPltTrace(np) )
*
      end
******************************************************************************
      subroutine pltmap( np , chCall )
      implicit none
*generate plot of heating and cooling map
      integer np
      character*5 chCall
*
      integer mapdim
      parameter (mapdim=102)
      integer nmap
      real temap , hmap , cmap
      common/mapr/ nmap , temap(mapdim) , hmap(mapdim) , cmap(mapdim)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer ndplot
      parameter (ndplot=10)
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
      logical lgPltTrace
*flag set with plot trace command
      common/pltrce/ lgPltTrace(ndplot)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer MapZone , nMapStep
      real RangeMap
*parameters doing with map command, MapZone is zone number,
* -1 for very start
* RangeMap is range, parsed from same command
* nMapStep is number of steps, set with set nmap command
      common/MapPar/ MapZone , RangeMap(2), nMapStep
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real xmin,xmax,ymin,ymax
      character chSym*1
      logical lgTlkSav
      character chXtitle*22
      save lgTlkSav , xmin , xmax , ymin , ymax
*
      if( chCall.eq.'FIRST' ) return
*
      lgTlkSav = lgTalk
      lgTalk = .false.
      RangeMap(1) = 10.**pltxmn(np)
      RangeMap(2) = 10.**pltxmx(np)
      call punt(' map')
      lgTalk = lgTlkSav
      do i=1,nmap
         temap(i) = log10( temap(i) )
      end do
      xmin = min( temap(1) , temap(nmap) )
      xmin = max( pltxmn(np) , xmin )
      xmax = max( temap(1) , temap(nmap) )
      xmax = min( xmax , pltxmx(np) )
*
      if(lgPltTrace(np))write(qq,'('' xmin, xmax='',1p,2e12.4,
     1'' nmap='',2i4)')xmin,xmax,nmap
      ymin = 1e37
      ymax = -1e37
*
      do i=1,nmap
        if( temap(i).gt.xmin .and. temap(i).lt.xmax ) then
          hmap(i) = log10( max( hmap(i) , 1e-35 ) )
          cmap(i) = log10( max( cmap(i) , 1e-35 ) )
          if( cmap(i).gt.-34.) then
            ymin = min( ymin , hmap(i) , cmap(i) )
          else
            ymin = min( ymin , hmap(i) )
          endif
          ymax = max( ymax , hmap(i) , cmap(i) )
        endif
      end do
*
      if(lgTrace) write(qq,'('' PLOT called for the first time,'',
     1  '' YMAX, MIN='',1P,2E10.2)') ymax , ymin
*
      if(lgPltTrace(np))write(qq,'('' YMAX, MIN='',1P,2E14.4,'' Npnts=''
     1 ,I4)') ymax,ymin , nmap
*
      chSym = 'H'
      chXtitle = 'heating - cooling v te'
      call pltr( temap , hmap , nmap , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 1 , lgPltTrace(np) )
      chSym = 'C'
      call pltr( temap , cmap , nmap , xmin , xmax , ymin , ymax ,
     1chSym , chXtitle , 3 , lgPltTrace(np))
*
      end
******************************************************************************
      subroutine pltopc( np , chCall )
      implicit none
*generate plot of local gas opacity
      character*5 chCall
      integer np
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real opac
      common/opac/ opac(ncell)
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real sctsav
      common/sctsav/ sctsav(ncell)
      real opacsv
      common/opacsv/ opacsv(ncell)
      integer ndplot
      parameter (ndplot=10)
      character chPType*4
*     which type of plot
      common/ptype/ chPType(ndplot)
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
      logical lgPltTrace
*flag set with plot trace command
      common/pltrce/ lgPltTrace(ndplot)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
*     integer i,max,min
      real xmin,xmax,ymin,ymax,arg1,arg2
      character chSym*1
      real y(ncell) , y2(ncell)
      character chXtitle*22
      save xmin , xmax , ymin , ymax
      save y , y2
*
      if( chCall.eq.'FIRST' ) return
      xmin = anulog(1)
      xmin = max( pltxmn(np) , xmin )
      xmax = anulog(nflux)
      xmax = min( xmax , pltxmx(np) )
*
      if(lgPltTrace(np))write(qq,'('' XMIN, XMAX='',1P,2E12.4,
     1'' NFLUX='',3I4)')xmin,xmax,nflux
*
      ymin = 1e37
      ymax = -1e37
*
      do i=1,nflux
        if( chPType(np).eq.'OPAA' ) then
*          absorption opacity
           arg1 = opacsv(i)
           arg2 = opac(i)
        else if( chPType(np).eq.'OPAS' ) then
*          scattering opacity
           arg1 = sctsav(i)
           arg2 = scatop(i)
        else if( chPType(np).eq.'OPAT' ) then
*          total opacity
           arg1 = opacsv(i) + sctsav(i)
           arg2 = opac(i) + scatop(i)
        endif
        y(i) =  log10( max( arg1/hden , 1e-35 ) )
        y2(i) = log10( max( arg2/hden , 1e-35 ) )
        if( anulog(i).gt.xmin .and. anulog(i).lt.xmax ) then
           ymin = min( ymin , y(i) , y2(i) )
           ymax = max( ymax , y(i) , y2(i) )
        endif
      end do
*
      if(lgTrace) write(qq,'('' PLOT called for the first time,'',
     1 '' YMAX, MIN='',1P,2E10.2)') ymax , ymin
*
*     lower min by factor of 10 to show absorption in next plot
      ymin = max( ymin - 1. , -35.)
      ymax = ymax + 1.
      if(lgPltTrace(np))write(qq,'('' YMAX, MIN='',1P,2E14.4,'' Npnts=''
     1 ,I4)') ymax,ymin , nflux
*
      chXtitle = 'Log(opacity) vs log(n)'
      chSym = '.'
      call pltr( anulog , y , nflux , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 1 , lgPltTrace(np) )
*
      chSym = 'o'
      call pltr( anulog , y2, nflux , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , 3 , lgPltTrace(np) )
*
      end
******************************************************************************
      subroutine pltr( x , y , npnts , xmin , xmax , ymin , ymax ,
     1 chSym , chXtitle , itim , lgTrace )
      implicit none
*core plotting routine for generating line printer plots
      integer npnts , itim
      real x(npnts) , y(npnts)
      real xmax,xmin,ymin,ymax
      character chSym*1 , chXtitle*22
      logical lgTrace
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer ndecad,i,j,nc,lx,iy,ix,lowx
      real ydown,yinc,xdec,xinc
      parameter (ndecad=14)
      integer jpnt(ndecad) , ihi , iwid
      parameter (ihi=59 , iwid=121 )
      character chPage(59)*121 , chLab(ndecad)*4
      save chPage , yinc , ydown , lx , xdec , lowx , xinc , jpnt
      data chLab/'1E-4','.001','0.01',' 0.1','  1 ',' 10 ',' 100','1000'
     1          ,'1E4 ','1E5 ','1E6 ','1E7 ','1E8 ','1E9 '/
*
*     ITIM=1, first call, =2 intermediate calls, =3 for last call
*
      if( itim.eq.1 ) then
*       first call, set left border of plot and clear out array
        do i=2,ihi
           chPage(i)(1:1) = 'l'
           do j=2,iwid
              chPage(i)(j:j) = ' '
           end do
        end do
*
*       centered label for plot
        chPage(2)(47:iwid) = chTitle
        chPage(2)(25:46) = chXtitle
*
*       one dex increments in x and y marked special
        i = 1
        ydown = 0.
        yinc = float(ihi-2) / (ymax - ymin)
        nc = 0
*3      continue
*     >>chng 97 may 24, to do while from go to loop
        do while( i.le.ihi .and. nc.lt.200 )
           chPage(i)(2:2) = '-'
           ydown = ydown + yinc
           i = ydown + 1
           nc = nc + 1
        end do
*       if( i.le.ihi .and. nc.lt.200 ) go to3
*
*       bottom increments of plot
        do i=1,iwid
           chPage(ihi)(i:i) = '-'
        end do
*
*       LX is pointer to label for number in x-axis in chLab
        if( xmin.lt.0. ) then
           lx = max( 0. , 4.999 - abs(xmin) )
           xdec = -int(abs( xmin ) + 1e-5 )
        else
           lx = max( 0. , 4. + xmin )
           xdec = int( xmin + 1e-5 )
        endif
        lowx = lx + 1
        xinc = float(iwid-1) / (xmax-xmin)
        i = max(1. , (xdec - xmin ) * xinc + 1. )
        nc = 0
*5      continue
*     >>chng 97 may 24, to do while from go to loop
        do while( i.lt.iwid .and. nc.lt.100 )
           chPage(ihi-1) (i:i) = 'l'
*          fix position of x labels
           lx = min( lx+1 , ndecad)
*          slight offset to center label
           jpnt(lx) = max( 0 , i - 3 )
           jpnt(lx) = min( iwid-4 , jpnt(lx) )
           xdec = xdec + 1.
           i = max( 1. , (xdec-xmin) * xinc + 1. )
           nc = nc + 1
*       if( i.lt.iwid .and. nc.lt.100 ) go to5
        end do
      endif
*
*     now fill in data, symbol is chSym
      do i=1,npnts
        if( x(i).gt.xmin .and. x(i).lt.xmax ) then
          iy = ihi - max( y(i)-ymin , 0. ) * yinc
          iy = max(1,iy)
          ix = (x(i) - xmin) * xinc + 1
          if(lgTrace)write(qq,'('' x, y, ix, iy='',2f7.3,2i4)')
     1    x(i),y(i),ix,iy
          chPage(iy)(ix:ix) = chSym
        endif
      end do
*
      if( itim.eq. 3 ) then
*       make the plot
        write(qq,'(''1'')')
        write(qq,'(5X,A121)') (chPage(i),i=2,ihi)
*       now put on label for X-axis
        do i=1,iwid
          chPage(1)(i:i) = ' '
        end do
        do i=lowx,lx
          do j=1,4
            chPage(1) ( (jpnt(i)+j):(jpnt(i)+j) ) = chLab(i)(j:j)
          end do
        end do
        write(qq,'(5X,A121)') chPage(1)
      endif
*
      end
******************************************************************************
      subroutine plwcon( chCard )
      implicit none
*parse the power law continuum command
      character chCard*80
*
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      character chSpType*5
      common/sptype/ chSpType(limspc)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      integer nvary , nparm
      common/nvary/ nvary , nparm
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL , lgMatch
      integer i
      real fread
*
*     power law with cutoff and X-ray continuum
*
      nspec = nspec + 1
      if( nspec.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC'')')
        stop
      endif
*
      chSpType(nspec) = 'POWER'
*
*     first parameter is slope of continuum, probably should be negative
      i = 5
      slope(nspec) = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' There should have been a number on this '',
     1  ''line.   Sorry.'')')
        stop
      endif
*
      if( slope(nspec).ge.0. ) then
        write(qq,'('' Is the slope of this power law correct?'')')
      endif
*
*     second optional parameter is high energy cut off
      cutoff(nspec,1) = fread( chCard , i , 76 , lgEOL )
*     no cutoff if eof hit
      if( lgEOL ) then
*       no extra parameters at all, so put in extreme cutoffs
        cutoff(nspec,1) = 1e4
        cutoff(nspec,2) = 1e-4
      else
*       first cutoff was present, check for second
        cutoff(nspec,2) = fread( chCard , i , 76 , lgEOL )
        if(lgEOL) cutoff(nspec,2) = 1e-4
      endif
*
*     check that energies were entered in the correct order
      if( cutoff(nspec,2).gt.cutoff(nspec,1) ) then
        write(qq,'('' The optional cutoff energies do not appear'',
     1  '' to be in the correct order.  Check Hazy.'')')
        stop
      endif
*
*     check for keywork KELVIN to interprete cutoff energies as degrees
      if( lgMatch( 'KELV' , chCard ) ) then
*       temps are log if first le 10
        if( cutoff(nspec,1).le.10.)cutoff(nspec,1)=10.**cutoff(nspec,1)
        if( cutoff(nspec,2).le.10.)cutoff(nspec,2)=10.**cutoff(nspec,2)
        cutoff(nspec,1) = cutoff(nspec,1) / 1.5789e5
        cutoff(nspec,2) = cutoff(nspec,2) / 1.5789e5
      endif
*
      if( cutoff(nspec,1).lt.0. .or. cutoff(nspec,2).lt.0. ) then
        write(qq,'('' A negative cutoff energy is not physical.  '',
     1  ''Sorry.'')')
        stop
      endif
*
      if( cutoff(nspec,2).eq.0. .and. slope(nspec).le.-1. )
     1 write(qq,'('' A power-law with this slope, and no low energy'',
     2'' cutoff, may have an unphysically large''/
     3'' brightness temperature in the radio.'')')
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
*       pointer to where to write
        nvfpnt(nparm) = nRead
        if( lgMatch('ARYB',chCard) ) then
*         this test is for key "varyb", meaning to vary second parameter
*         the cutoff temperature
*         this is the number of parameters to feed onto the input line
          nvarxt(nparm) = 2
*         vary ??
          write(chVarFmt(nparm),'(''(''''POWER LAW'',F10.4,'' KELVIN'''',
     12F10.5)'')') slope(nspec)
*         param is linear scale factor
          vparm(nparm,1) = log10( cutoff(nspec,1)*1.5789e5)
          vparm(nparm,2) = log10( cutoff(nspec,2)*1.5789e5)
          vincr(nparm) = 0.2
        else if( lgMatch('ARYC',chCard) ) then
*         the keyword wsa "varyc"
*         this is the number of parameters to feed onto the input line
          nvarxt(nparm) = 1
*         vary ??
          write(chVarFmt(nparm),
     1    '(''(''''POWER LAW'',2F10.4,'' KELVIN'''',F10.5)'')')
     2    slope(nspec) , log10( cutoff(nspec,1)* 1.5789E5)
*
          vparm(nparm,1) = log10( cutoff(nspec,2)*1.5789e5)
          vincr(nparm) = 0.2
        else
*         vary the first parameter only, but still are two more
*         this is the number of parameters to feed onto the input line
          nvarxt(nparm) = 3
          write(chVarFmt(nparm),
     1    '(''(''''POWER LAW KELVIN'''',3F15.5)'')')
*         param is slope of the power law
          vparm(nparm,1) = slope(nspec)
          vparm(nparm,2) = log10( cutoff(nspec,1)*1.5789e5)
          vparm(nparm,3) = log10( cutoff(nspec,2)*1.5789e5)
          vincr(nparm) = 0.2
        endif
      endif
*
      end
******************************************************************************
      subroutine pmeani
      implicit none
*print mean ionization fractions for all elements
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     include "colden.exp"
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real reftot,avhden,chii, avdust , avdpot , thtot
      common/toiii/ reftot,avhden,chii,
     1 avdust(ndust) , avdpot(ndust) , thtot
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgGeoPP
*true if geometry is plane parallel, set in comment
      common/GeoPP/ lgGeoPP
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      character*10 chElNam(limelm)
      common/elnam/ chElNam
*
*     local variables
      integer i , nelem , n
      real aa(64) , c(64)
*     character*10 chElNam(limelm)
*     common/elnam/ chElNam
*     data
*    1   chElNam/'Hydrogen  ', 'Helium    ', 'Lithium   ', 'Beryllium ',
*    1           'Boron     ', 'Carbon    ', 'Nitrogen  ', 'Oxygen    ',
*    2           'Fluorine  ', 'Neon      ', 'Sodium    ', 'Magnesium ',
*    2           'Aluminium ', 'Silicon   ', 'Phosphorus', 'Sulphur   ',
*    2           'Chlorine  ', 'Argon     ', 'Potassium ', 'Calcium   ',
*    2           'Scandium  ', 'Titanium  ', 'Vanadium  ', 'Chromium  ',
*    2           'Manganese ', 'Iron      ', 'Cobalt    ', 'Nickel    ',
*    2           'Copper    ', 'Zinc      '/
*
*     print mean ionization
*
*     only print sphereical if not plane parallel
      if( lgSphere.and.(.not.lgGeoPP) ) then
*
        call VolMean( 1 , n , aa )
        call VolMean( 2 , n , c )
        write(qq,'(/,'' Hydrogen  '',2F7.3,27X,
     1 ''Log10 Mean Ionisation (over volume)'',/,'' Helium    '',3F7.3)'
     2  )(aa(i),i=1,2) ,  (c(i),i=1,3)
        do nelem=3,limelm
          if( lgElmtOn(nelem) ) then
            call VolMean( nelem , n , aa )
            write(qq,'(1x,a10,17F7.3)')chElNam(nelem),(aa(i),
     1      i=1,min(17,n))
            if(n.gt.17)write(qq,'(11x,17F7.3)')(aa(i),i=18,n)
          endif
        end do
      endif
*
      write(qq,'(7x,17i7)') (i,i=1,17)
*
      call RadMean( 1 , n , aa )
      call RadMean( 2 , n , c )
      write(qq,'(/,'' Hydrogen  '',2F7.3,27X,
     1''Log10 Mean Ionisation (over radius)'',/,'' Helium    '',3F7.3)')
     2 (aa(i),i=1,2) , (c(i),i=1,3)
*
      do nelem=3,limelm
        if( lgElmtOn(nelem) ) then
          call RadMean( nelem , n , aa )
          write(qq,'(1x,a10,17F7.3)')chElNam(nelem),(aa(i),
     1    i=1,min(17,n))
          if(n.gt.17)write(qq,'(11x,17F7.3)')(aa(i),i=18,n)
        endif
      end do
*
      end
******************************************************************************
      subroutine pmprng( chCard )
      implicit none
*parse range from plot command
      character chCard*80
*
      integer ndplot
      parameter (ndplot=10)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
*
*     local variables
      logical lgEOL
      real a , fread
      integer i
      logical lgLogOn , lgMatch
*
      i = 4
*     pltxmn is min for x axis of plot
      pltxmn(nplot) = fread( chCard , i , 76 , lgEOL )
*
      if( .not.lgMatch('RANG' , chCard ) ) then
*       no lines were enterd, so use default temperature limits
        pltxmn(nplot) = 1.
        pltxmx(nplot) = 9.
        lgLogOn = .true.
      else if( lgEOL ) then
*       no lines were enterd, so use default temperature limits
        pltxmn(nplot) = 1.
        pltxmx(nplot) = 9.
        lgLogOn = .true.
      else
*       number entered, now interprete it
        if( pltxmn(nplot).le.10. ) then
          lgLogOn = .true.
        else
          lgLogOn = .false.
        endif
*       linear option for temperature
        if( lgMatch( 'LINE' , chCard ) ) lgLogOn = .false.
*       lower temp was entered, now how about upper temp
        pltxmx(nplot) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          if( lgLogOn ) then
            pltxmx(nplot) = 9.
          else
            pltxmx(nplot) = 1e9
          endif
        else
*          second number was entered, check for sanity
           if( pltxmx(nplot).le.pltxmn(nplot) )  then
             write(qq,'('' The second (maximum) temperature for the'',
     1       '' map is'',1P,E10.2,'', but this is less than the'',
     2       '' first (minimum) temperature,'',E10.2)') pltxmx(nplot),
     3       pltxmn(nplot)
             write(qq,'('' HELP!  I am confused!!'')')
             stop
           endif
        endif
      endif
*
*     now force to be log
      if( .not.lgLogOn ) then
        if( pltxmx(nplot).le.0..or.pltxmn(nplot).le.0. ) then
          write(qq,'('' Limits for temperature are negative.'',
     1    ''  This is impossible.   Sorry.'')')
          stop
        endif
        pltxmx(nplot) = log10( pltxmx(nplot) )
        pltxmn(nplot) = log10( pltxmn(nplot) )
      endif
*
*     check that min is less than max
      if( pltxmn(nplot).eq.pltxmx(nplot) ) then
        write(qq,'('' Upper and lower plot boundaries are equal.'')')
        stop
      else if( pltxmn(nplot).gt.pltxmx(nplot) ) then
        a = pltxmx(nplot)
        pltxmx(nplot) = pltxmn(nplot)
        pltxmn(nplot) = a
      endif
*
      end
******************************************************************************
      subroutine pnegopc
      implicit none
*punch negative opacities on io unit, iff 'set negopc' command was given
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real opac
      common/opac/ opac(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer negoIO
      common/negoIO/ negoIO
*
*     local variables
      logical lgDidIt
      integer i
      save lgDidIt
      data lgDidIt/.false./
*
      if(negoIO.gt.0 ) then
        if(lgDidIt) then
          write(negoIO,'('' another zone '')')
        else
          write(negoIO,'(1p,2e10.2)')(anu(i),opac(i),i=1,nflux)
          lgDidIt = .true.
        endif
      endif
*
      end
******************************************************************************
      subroutine PntForLine( wavelength , chLabel , ipnt )
      implicit none
*generate pointer for forbidden line
      real wavelength
      character chLabel*4
      integer ipnt
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer maxForLin
      parameter (maxForLin=1000)
      integer nForLin , ipForLin(maxForLin)
      integer ipoint
      save nForLin , ipForLin
*
      if( wavelength.lt.0. ) then
        write(qq,'('' PntSetLin called with insane wavelength,='',
     1  1pe10.2)') wavelength
      else if( wavelength.eq.0. ) then
*       zero is special flag to initialize
        nForLin = 0
      else
*
        nForLin = nForLin + 1
        if( ipass .ne. 0) then
*         not first pass, sum lines only
          ipnt =ipForLin(nForLin)
        else
*         check if number of lines in arrays exceeded
          if( nForLin.gt.maxForLin ) then
            write(qq,'(I5,'' lines is too many for '',
     1      ''PntForLine.'')') nForLin
            write(qq,'('' Increase the value of maxForLine everywhere'',
     1      '' in the code.'')')
            stop
          endif
*
          ipForLin(nForLin) = ipoint( rydlam/wavelength )
          ipnt =ipForLin(nForLin)
*         only put in line label if nothing already there
          if(chLineLabel(ipForLin(nForLin)).eq.'    ' )
     1     chLineLabel(ipForLin(nForLin)) = chLabel
        endif
      endif
*
      end
******************************************************************************
      real function pop3(g1,g2,g3,o12,o13,o23,a21,a31,a32,ex12,ex23,
     1 pop2, abund , gam2 )
      implicit none
*solve three level atom without radiative transfer
      real g1,g2,g3,o12,o13,o23,a21,a31,a32,ex12,ex23,pop2,
     1 abund , gam2
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real b12 , b23 , b13  , c12,c13,c23,c32,c31,c21
      real alf , bet , fac , ex
*
*     computes level populations for 3 level atom, all col rad coupling
*     results are populations of levels 2 and 3, (cm^-3) no A included
      ex = ex12 / te
      if( (abund.le.0.) .or. (ex.gt.20.) ) theN
        pop3 = 0.
        pop2 = 0.
        return
      endif
*
      b12 = exp(-ex)
      b23 = exp(-ex23/te)
*
      b13 = b12 * b23
      if( b13.eq.0. ) then
        pop3 = 0.
        pop2 = 0.
        return
      endif
*
      c12 = cdsqte * o12 / g1 * b12
      c13 = cdsqte * o13 / g1 * b13
      c23 = cdsqte * o23 / g2 * b23
      c32 = cdsqte * o23 / g3
      c31 = cdsqte * o13 / g3
      c21 = cdsqte * o12 / g2
*
      alf = a21 + c21 + c23 + gam2
      bet = a31 + a32 + c31 + c32
      pop2 = ( c13/bet + c12/(c32+a32) ) / ( alf/(c32+a32) - c23/bet )
      pop3 = (c13 + pop2*c23) / bet
*
*     renorm to 1+pop2+pop3=1
      fac = abund / ( 1. + pop2 + pop3 )
      pop2 = pop2 * fac
      pop3 = pop3 * fac
*
      end
******************************************************************************
      real function popexc( omega , g1 , g2 , a21 , bltz , abund )
      implicit none
*do level population for simple two level atom, no radiative transfer
      real omega , g1 , g2 , a21 , bltz , abund
*
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real teinv
      common/teinv/ teinv
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real boltz , q21 , q12 , r
*
*     result is density (cm-3) of excited state times a21
*     result normalized to n1+n2=abund
*     cdsqte is eden / sqrte * 8.629e-6
*
      boltz = bltz * teinv
      if( abund.eq.0. .or. boltz.gt.15. ) then
         popexc = 0.
         p2ovp1 = 0.
         return
      endif
*
*begin sanity check
      if( omega.le.0. ) then
        write(qq,'('' POPEXC called with non-positive collision'',
     1  '' strength, ='',1P,E10.2)') omega
        write(qq,'('' bltz='',1P,E10.2)') bltz
        write(qq,'('' args were omega , g1 , g2 , a21 , bltz , abund '',
     1  1p6e12.5)') omega , g1 , g2 , a21 , bltz , abund
        call ShowMe
        stop
      endif
*end sanity check
*
      q21 = cdsqte * omega
      q12 = q21 / g1 * exp(-boltz)
      q21 = q21 / g2
      r = (a21+q21) / q12
      popexc = abund * a21 / ( r + 1. )
*
*     following is relative popultation per sub-level, used
*     to calculate radiation pressure in TEMP
      p2ovp1 = g1 / ( g2*r )
*
      end
******************************************************************************
      subroutine potasi
      implicit none
*compute ionization equilibrium for Potassium
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      real dstCala , dCakh , dCaf12 , Ca3d , Ca4p
*parameters dealing with dest of CaII by Lya
      common/dcala/ dstCala , dCakh , dCaf12 , Ca3d , Ca4p
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
*recombination rates for the elements
*first dim is nelem, the atomic number of element
*secnd dim is stage of ionizaiton, 1 for atom
      real RecombinRate(limelm,limelm)
      common/RecomRate/ RecombinRate
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=20)
      parameter (nelem=19)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(20)
*
*     potassium nelem=19
*     rec data from calcium
*
*     real CollidRate(nelem,2)
*     DATA GRDEFF/20*0.2/
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /2.09E-10,9.00E-11,5.35E-11,2.58E-11,1.31E-11,5.91E-12,
     1 2.86E-12,6.96E-13,9.56E-13,3.20E-13,3.86E-13,2.54E-13,1.90E-13,
     2 1.42E-13,9.25E-14,5.48E-14,3.74E-14,1.65E-14,1.68E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /7.09E4,1.38E5,5.94E5,7.81E5,9.79E5,1.27E6,1.49E6,1.66E6,
     2 2.18E6,2.45E6,6.87E6,7.61E6,8.43E6,9.48E6,1.04E7,1.13E7,
     3 1.26E7,1.34E7,5.95E7/
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data rec,pl
     1/ 4.5E-10 , 1.07E-9 , 2.50E-9 , 9.33E-9 , 2.45E-8 , 3.43E-8
     2, 4.57E-8 , 6.53E-8 , 6.64E-8 , 2.57E-7 , 1.62E-7 , 2.05E-7
     3, 2.50E-7 , 1.70E-7 , 4.12E-7 , 4.27E-7 , 9.57E-7 , 1.29E-6
     4
     1, -0.900  , -0.800  , -0.700  , -0.780  , -0.840  , -0.820
     2, -0.820  , -0.810  , -0.780  , -0.900  , -0.820  , -0.810
     3, -0.800  , -0.730  , -0.800  , -0.780  , -0.850  , -0.850
     4/
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.06e-10 , -0.683 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/3.28E-4, .0584, .122, .132, .133, .126, .139, .0955, .0402,
     2 .0419, .0257, .0445, .0548, .0713, .0903, .110, .0205, .549,
     3 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/.0907, .110, .0174, .132, .114, .162, .0878, .263, .0627, .0616,
     2 2.77, 2.23, 2.00, 1.82, .424, .243, .185, .292, 0./
      data (dite(i,1),i=1,ndim-1)
     1/3.46E+4, 3.84E+5, 4.08E+5, 3.82E+5, 3.53E+5, 3.19E+5, 3.22E+5,
     2 2.47E+5, 2.29E+5, 3.73E+6, 9.26E+5, 7.96E+5, 6.90E+5, 6.70E+5,
     3 4.72E+5, 5.67E+5, 4.21E+5, 3.65E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/1.64E+4, 2.45E+5, 4.27E+5, 6.92E+5, 8.78E+5, 7.43E+5, 6.99E+5,
     2 4.43E+5, 2.81E+5, 5.84E+6, 4.89E+6, 4.62E+6, 4.52E+6, 3.32E+6,
     3 1.37E+6, 4.41E+6, 2.27E+6, 7.25E+6, 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 1E20 /
*
      data aa/19*0./,bb/19*0./,cc/19*0./,dd/19*0./,
     1 ff/0.,0.1,17*0./
*
*     potassium, atomic number 19
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*666  call PrtGamma(ipPotassium(2,5,1) ,ipPotassium(2,5,2) ,
*    1 ipPotassium(2,5,3),
*    1 qq,  photorate(nelem,2,5,1) ,photorate(nelem,2,5,1)*0.05 )
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     correct low temp rad rec coef
      if( te.lt.1e3 ) then
        RecombinRate(nelem,2) = RecombinRate(nelem,2) +
     1  ( 5.49e-10*(te**(-0.647)) - rec(2)*(te**pl(2)) ) * eden
      endif
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine pread( chCard )
      implicit none
*parse the plot command
      character chCard*80
*
      integer ndplot
      parameter (ndplot=10)
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
      logical lgPltTrace
*flag set with plot trace command
      common/pltrce/ lgPltTrace(ndplot)
      character chPType*4
*     which type of plot
      common/ptype/ chPType(ndplot)
      real emm , egamry
      common/bounds/ emm , egamry
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      logical lgMatch
*
      nplot = nplot + 1
      lgPlotON = .true.
      if( nplot.gt.ndplot ) then
         write(qq,'('' Too many plots; the limit is'',I3,
     1   '' This one ignored.'')') ndplot
         nplot = ndplot
      endif
*
      if( lgMatch( ' MAP' , chCard ) ) then
*        option to make plot of heating - cooling map
        chPType(nplot) = ' MAP'
      else if( lgMatch( 'CONT' , chCard ) ) then
*       option to make "raw" plot, in internal units
        if( lgMatch( ' RAW' , chCard ) ) then
          chPType(nplot) = 'CRAW'
*       option to make diffuse continuum plot
        else if( lgMatch( 'DIFF' , chCard ) ) then
          chPType(nplot) = 'DIFF'
*       this is emitted continuum
        else if( lgMatch( 'EMIT' , chCard ) ) then
          chPType(nplot) = 'EMIT'
*       this is outward and attenuated continuum
        else if( lgMatch( 'OUTW' , chCard ) ) then
          chPType(nplot) = 'OUTW'
*       this is reflected continuum
        else if( lgMatch( 'REFL' , chCard ) ) then
          chPType(nplot) = 'REFL'
*       this is continuum in photons
        else if( lgMatch( 'PHOT' , chCard ) ) then
          chPType(nplot) = 'CPHT'
        else
          chPType(nplot) = 'CONT'
        endif
      else if( lgMatch( 'OPAC' , chCard ) ) then
         if( lgMatch( 'ABSO' , chCard ) ) then
*           plot absorption opacity
            chPType(nplot) = 'OPAA'
         else if( lgMatch( 'SCAT' , chCard ) ) then
*           plot scattering opacity
            chPType(nplot) = 'OPAS'
         else if( lgMatch( 'TOTA' , chCard ) ) then
*           plot total opacity
            chPType(nplot) = 'OPAT'
         else
*           plot total opacity for default
            chPType(nplot) = 'OPAT'
         endif
      else
         write(qq,'('' The second keyword on the PLOT command must'',
     1   '' be CONTINUUM, _MAP, or OPACITY.'')')
         stop
      endif
*
*     option to turn on trace of plot logic
      if( lgMatch('TRAC' , chCard ) ) then
         lgPltTrace(nplot) = .true.
      else
         lgPltTrace(nplot) = .false.
      endif
*
*     option to set min and max x-axis
      if(chPType(nplot).eq.' MAP' ) then
*       this will be map of cooling and heating vs temp
        call pmprng( chCard )
      else
*       continuum map
        call pcnrng( chCard )
      endif
*
      end
      subroutine amoeba(p,y,mp,np,ndim,ftol,funk,iteram)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      external func
*
      write(qq,'('' Obtain a copy of Amoeba from Press et al'',
     1'' and modify it as described in the nr.txt file in'')')
      write(qq,'('' the page on the web.  Replace the existing''
     1'' amoeba (this routine) with the modified NR version.'')')
*
      stop
      end
      subroutine powell(p,xi,n,np,ftol,iter,fret)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      write(qq,'('' Obtain a copy of Powell from Press et al'',
     1'' and modify it as described in the nr.txt file in'')')
      write(qq,'('' the page on the web.  Replace the existing''
     1'' Powell (this routine) with the modified NR version.'')')
*
      stop
      end
******************************************************************************
      subroutine presur(loop)
      implicit none
*evaluate the current pressure, and change needed to get it to PressureInit
*     sets presok true if good pressure, false if pressure change capped
      integer loop
      real solarm
*     solar mass in grams
      parameter (solarm=1.9892e33)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      logical lgAbunTabl(limelm) , lgAbTaDepth(limelm),lgAbTaON
*lgAbunTabl says whether this element is to have its abundance
*determined from a table (true) or stored constant (false)
*set true with element table command
*lgAbTaDepth says whether depth or radius, true is depth
      common/AbunTablLG/ lgAbunTabl , lgAbTaDepth,lgAbTaON
      logical lgPresOK
*     set true in presur if presure ok, false otherwise
      common/presok/ lgPresOK
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      real prspow
      common/prspow/ prspow
      real timefc
      common/timefc/ timefc
      real flong , cfirst , csecnd, flcPhase
*     parameters for the fluctuations command
      logical lgDenFluc
      common/fluct/ flong , cfirst , csecnd , lgDenFluc, flcPhase
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      real DensityPower , rscale , den0
*parameters dealing with hydrogen density scaling as
*power of radius
*DensityPower is power
      common/denpow/ DensityPower , rscale , den0
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real te , eden , hden
      common/phycon/ te , eden , hden
      real PressureInit
*     this is the total pressure at the illuminated face
      common/PresInit/ PressureInit
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real dVeldRad
*dVel/dR used for sobolev (large velocity gradient)
      common/dvdr/ dVeldRad
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      real AccelAver , acldr
*variables for tracking average radiative acceleration
      common/aclbar/ AccelAver , acldr
      real glbden , glbrad , glbpow , glbdst
      common/globul/ glbden , glbrad , glbpow , glbdst
      real pnow , pcorec
      common/pnow/ pnow , pcorec
      logical lgVelPos
*flag set if wind solution had negative velocity
      common/velpos/ lgVelPos
      real plow , phi
*     keep trace of lowest and highest pressures in model
      common/prslim/ plow , phi
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real dDensityDT, dndtSave
*deriv of density needed for expansion cooling
      common/dndt/ dDensityDT, dndtSave
      real r1r0sq
      common/r1r0sq/ r1r0sq
      real pinit , pinteg , pinzon
      common/pinteg/ pinit , pinteg , pinzon
      logical lgConPres
*flag saying whether or not incident continuum should be included
*in total pressure, turned off with constant gas pressure
      common/conprs/ lgConPres
      real hehp
      integer iheh1 , iheh2
      common/hehp/ hehp , iheh1 , iheh2
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      real EdenMet , EdenNotH
*     EdenMet is sum of electrons from Lit through n=30, all ions
*     EdenNotH is total electron density less the proton density
*     used in hydrogen loop for charge conservation
      common/EdenOther/ EdenMet , EdenNotH
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real factor ,  pold , dold,TotalPressure,abun ,tababun,
     1 hold,term,poldd,pnew,dnew,pneed,fabden,tabden
      integer nelem , ion
      double precision vold , windnw
      real pdelta , perror , edensave
      parameter (pdelta=0.07 , perror=0.02)
      real OldAbun , FacAbun , FacAbunSav
      save OldAbun , FacAbun , FacAbunSav
*
      logical lgDppos
      double precision rsave
      save factor , pold , rsave , dold , lgDppos
      data factor/1./, pold/0./, rsave/0./,
     1 dold/0./ , lgDppos/.true./
*
      edensave = eden
      if( nzone.eq.1 ) then
*       this is first zone, lock onto pressure
        PressureInit = TotalPressure()
        plow = 1e36
        phi = -1e36
        pnow = PressureInit
        if( lgTrace ) then
          write(qq,'('' PRESUR called, this is first zone, so''
     1    ,'' reseting pressure to'',1P,E10.3)') PressureInit
        end if
      else
*       pnow is just sum of gas plus local line radiation pressure
        pnow = TotalPressure()
      endif
      hold = hden
*
*     inside out globule
      if( chCPres.eq.'GLOB' ) then
*       GLBDST is distance from globule, or glbrad-DEPTH
        if( glbdst.lt.0. ) then
          write(qq,'('' Globule distance is negative, internal '',
     1    ''overflow has occured,  sorry.'')')
          write(qq,'('' This is routine PRESUR, GLBDST is'',1P,E10.2)'
     1    ) glbdst
          stop
        endif
        factor = ( glbden * (glbrad/(glbdst ) )**glbpow)/hden
*
      else if( chCPres.eq.'WIND' ) then
*       this is logic for wind solution
*       following makes sure wind v only updated once per zone
        if( depth.ne.rsave ) then
          rsave = depth
*         evaluate radiative acceleration
          call radacl
*         Wind model
*         G, COMASS = mass of star in solar masses
          agrav = (6.67e-8 * comass) * (solarm / radius ) / radius
*         is this the first zone?
          if( nzone.gt.2 ) then
*           acceleration due to grad P(rad), xMassDensity is gm per cc
            AccelPres = -(RadPres-pold)/drad/xMassDensity
          else
            AccelPres = 0.
          endif
*         this is numerically unstable
          AccelPres = 0.
*         AccelXXX is computed in radinc, is continuum and line acceleration
*         AccelCont is continuum accel
*         AccelLine is line accel
*         AccelPres is gradient of local gas pressure
          AccelTot = AccelCont + AccelLine + AccelPres
*         remember largest radiative acceleration
          AccelMax = max( AccelMax , AccelTot )
*         keep track of average acceleration
          AccelAver = AccelAver + AccelTot * dReff
          acldr = acldr + dReff
*
*         following is form of energy equation, only used to check if neg vel
          term = windv**2+2.*(AccelTot-agrav)*drad
*
*         remember the current wind velocity
          vold = windv
          if( term.le.1e3 ) then
*           wind vel is way below sonic point, give up, do not change vel
            lgVelPos = .false.
          else
*           square of new wind velocity for outer edge of this zone
            windnw = dble(windv*windv) + dble(2.*(AccelTot-agrav))*drad
*           WINDV is velocity at OUTER edge of this zone
            windv = sqrt(windnw)
            lgVelPos = .true.
          endif
 
*         following needed for expansion cooling
          dDensityDT = AccelTot/windv + 2.*windv/radius
*
*         following used to control new DRAD
          dVeldRad = abs( windv-vold ) / windv / drad
*
        else
          factor = 1.
        endif
        factor = emdot / (windv*hden ) / r1r0sq
        poldd = pold
        pnew = RadPres
        pold = RadPres
*
      else if( chCPres.eq. 'TIME' ) then
*       called by TIMER for N = N(T)
        write(qq,'('' TIME does not now work.  Sorry.'')')
        factor = timefc
        stop
*
      else if( chCPres.eq.'SINE' ) then
*       rapid density fluctuation
        factor = (cfirst * cos( depth*flong + flcPhase ) + csecnd)/hden
*
      else if( chCPres.eq.'POWR' ) then
*       power law function of radius
        dnew = den0 * (radius/rinner)**DensityPower
        factor = dnew / hden
*
      else if( chCPres.eq.'POWD' ) then
*       power law function of depth
        dnew = den0 * (1.+depth/rscale)**DensityPower
        factor = dnew / hden
*
      else if( chCPres.eq.'POWC' ) then
*       power law function of column density
        dnew = den0 * (1.+ colden /rscale)**DensityPower
        factor = dnew / hden
*
      else if( chCPres.eq.'CPRE' ) then
*       constant pressure
        if( lgConPres ) then
*         this has pressure due to incident continuum
          pneed = PressureInit + pinteg
          factor = pneed / pnow
        else
*         this does not
          pneed = PressureInit * (radius/rinner)**prspow
          factor = pneed / pnow
        endif
        if( loop.gt.0 ) then
*         just want sign of following
          if( (pold-pnow)*(dold-hden).gt.0. ) then
            lgDppos = .true.
          else
            lgDppos = .false.
          endif
        else
           lgDppos = .true.
        endif
        pold = pnow
        dold = hden
*
      else if( chCPres(1:3).eq.'DLW' ) then
        if( chCPres.eq.'DLW1' ) then
*         call ACF sub
          factor = fabden( radius , depth ) / hden
        else if( chCPres.eq.'DLW2' ) then
*         call table interpolation subroutine
*         >>chng 96 nov 29, added tabden
          factor = tabden( radius , depth ) / hden
        else
          write(qq,'('' Insanity, presur gets chCPres='',a4)') chCPres
          stop
        endif
*
      else if( chCPres.eq.'CDEN' ) then
*       constant density
        factor = 1.
      else
        write(qq,'('' Unknown pressure law='',A4,'' STOP.'')')chCPres
        stop
      endif
*
*     save correct pressure
      pcorec = pnow * factor
*
      if( factor.gt.1.+perror .or. factor.lt.1.-perror ) then
        lgPresOK = .false.
      else
        lgPresOK = .true.
      endif
*
*     make sure that change is not too extreme
      factor = min( factor , 1. + pdelta )
      factor = max( factor , 1. - pdelta )
*
*     >>chng 97 jun 3, added variable abundances for element table command
*     option to get abundances off a table with element read command
      if( lgAbTaON ) then
        do nelem=2,limelm
          if( lgAbunTabl(nelem) ) then
            abun = tababun( radius , depth , nelem ) * hden
*            write(66,*) depth , abun
            hold = abun / xIonFracs(nelem,0)
            xIonFracs(nelem,0) = abun
            do ion=1,nelem+1
              xIonFracs(nelem,ion) = xIonFracs(nelem,ion) * hold
            end do
          endif
        end do
      endif
*
*     this happens if fluctuations abundances command entered
      if(  .not.lgDenFluc ) then
        if( nzone.le.1 ) then
          OldAbun = 1.
          FacAbun = 1.
          FacAbunSav = cfirst * cos( depth*flong + flcPhase ) + csecnd
        else
          OldAbun = FacAbunSav
*         rapid abundances fluctuation
          FacAbunSav = cfirst * cos( depth*flong + flcPhase ) + csecnd
          FacAbun = FacAbunSav/OldAbun
        endif
      else
        FacAbun = 1.
      endif
*
      if( factor*FacAbun.ne.1. ) then
*       nelem,0 is abundance of nelem
*       H, He not affected by abundance fluctuations
        do nelem=1,2
          do ion=0,nelem+1
*           >>chng 96 july 12 had only multiplied total abun, not ions
            xIonFracs(nelem,ion) = xIonFracs(nelem,ion) * factor
          end do
        end do
*       Lit on up is, so with FacAbun
        do nelem=3,limelm
          do ion=0,nelem+1
*           >>chng 96 july 12 had only multiplied total abun, not ions
            xIonFracs(nelem,ion) = xIonFracs(nelem,ion)*factor*FacAbun
          end do
        end do
        eden = eden * factor
        EdenMet = EdenMet * factor
        EdenNotH = EdenNotH * factor
*       >>chng 96 oct 25 update some te-ne variables
        call tfidle
        hden = hden * factor
        hi = hi * factor
        hii = hii * factor
        ahe = ahe * factor
        hei = hei * factor
        heii = heii * factor
        heiii = heiii * factor
        hei1 = hei1 * factor
        hei3 = hei3 * factor
*       alith = alith * factor * FacAbun
*       aberyl = aberyl * factor * FacAbun
*       aboron = aboron  * factor * FacAbun
*       acarb = acarb * factor * FacAbun
*       an = an * factor * FacAbun
*       aoxy = aoxy * factor * FacAbun
*       afluorine = afluorine  * factor * FacAbun
*       ane = ane * factor * FacAbun
*       ana = ana * factor * FacAbun
*       amg = amg * factor * FacAbun
*       aal = aal * factor * FacAbun
*       asil = asil * factor * FacAbun
*       aphos = aphos * factor * FacAbun
*       asul = asul * factor * FacAbun
*       aclor = aclor * factor * FacAbun
*       aargon = aargon * factor * FacAbun
*       apotas = apotas * factor * FacAbun
*       aca = aca * factor * FacAbun
*       ascand = ascand * factor * FacAbun
*       atitan = atitan  * factor * FacAbun
*       avana = avana  * factor * FacAbun
*       achrom = achrom  * factor * FacAbun
*       amanga = amanga  * factor * FacAbun
*       afe = afe * factor * FacAbun
*       acobl = acobl * factor * FacAbun
*       ani = ani * factor * FacAbun
*       acopp = acopp * factor * FacAbun
*       azinc = azinc  * factor * FacAbun
*       charge transfer rates
        CTHion(1) = CTHion(1) * factor
        CTHion(2) = CTHion(2) * factor
        CTHrec(1) = CTHrec(1) * factor
        CTHrec(2) = CTHrec(2) * factor
        chrener = chrener * factor
*       molecules done in hmole
        htwo = htwo * factor
        h2plus = h2plus * factor
        hminus = hminus * factor
        hehp = hehp * factor
*       molecules done in comole
        ch = ch * factor * FacAbun
        chp = chp * factor  * FacAbun
        oh = oh * factor  * FacAbun
        ohp = ohp * factor  * FacAbun
        otwo = otwo * factor  * FacAbun
        ctwo = ctwo * factor  * FacAbun
        co = co * factor  * FacAbun
        cop = cop * factor  * FacAbun
        h2o = h2o * factor  * FacAbun
        h2op = h2op * factor  * FacAbun
        o2p = o2p * factor  * FacAbun
        c2p = c2p * factor  * FacAbun
        h3p = h3p * factor
        h3op = h3op * factor
        ch2p = ch2p * factor  * FacAbun
        ch2 = ch2 * factor  * FacAbun
        ch3 = ch3 * factor  * FacAbun
        cp = cp * factor * FacAbun
      endif
*
      if( lgTrace ) then
        write(qq,'('' PRESUR called, changing HDEN from'',1P,
     1  e10.3,'' TO'',E10.3,'' Set fill fac to'',E10.3)')
     2  hold,hden,FillFac
        if(lgNeBug ) write(qq,'('' EDEN change PRESUR from to'',1p,
     1  3e10.3)') edensave , eden , edensave/eden
      endif
*
      end
******************************************************************************
      subroutine prhead
      implicit none
*print program's header, including luminosities and ionization parameters
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real planck
      parameter (planck=6.62259e-27 )
      real hnu3c2
      parameter (hnu3c2=0.524166)
      real pi4
      parameter (pi4=12.566371)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real csigh , csigc
      common/comsig/ csigh(ncell) , csigc(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real emm , egamry
      common/bounds/ emm , egamry
*quantities to do with radiation field and printed in header
      real qx , powion , xpow , pbal ,q,qgam,pradio , fx1ryd ,
     1 GammaLumin
      integer ipeak
      common/prhd/ qx , powion , xpow , pbal , q , qgam , pradio ,
     1 fx1ryd , ipeak, GammaLumin
*     include "gampow.com"
      real totlum , totlsv
      common/totlum/ totlum , totlsv
      real uh,uheii
      common/u/ uh,uheii
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real qhtot , qhe , qheii , qbal , qrad , qtot
      common/qs/ qhtot , qhe , qheii , qbal , qrad , qtot
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      logical lgComUndr
*set true if compton cooling underflows
      common/comund/ lgComUndr
      logical lgOnlyZone , lgOnlyHead
*lgOnlyZone set with print only zones
*lgOnlyHead set with print only header
      common/only/ lgOnlyZone , lgOnlyHead
      real TEnerDen
*energy density temperature
      common/tenden/ TEnerDen
      logical lgEdnGTcm
*flag set if energy density of rad field greater tha
*compton temp - this is unphysical but could be set
*by users
      common/edgtcm/ lgEdnGTcm
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer ipoint,ip2kev,ip2500,i
      real qxl,pionl,avpow,qhel,qheiil,ql,ratio,alfox,gpowl,
     1 qgaml,radpwl,solar,fluxv,ffun,absv,fbeta,absbol,bolc,
     2 tcomp, tradio , pballog , qballog
*
      if( .not.lgTalk ) return
*
      write(qq,'(10X,I4,''Cell Peak'',1P,E8.2,
     1 3X,''Lo'',1P,E9.2,''='',0P,F6.4,''cm'',
     2 3X,''Hi-Con:'',1P,E8.2,'' Ryd'',
     3 3X,''E(hi):'',1P,E8.2,''Ryd'',
     4 5X,''E(hi):  '',0P,F9.2,'' MeV'')') nflux , anu(ipeak) ,
     5 anu(1)-widflx(1)/2.,9.117e-6/(anu(1)-widflx(1)/2.),
     6 anu(nflux)+widflx(nflux)/2. ,
     6 egamry,egamry*0.0000136
 
*
      if( xpow.gt.0. ) then
        xpow = log10( xpow ) + pirsq
        qxl = log10( qx ) + pirsq
      else
        xpow = 0.
        qxl = 0.
      endif
*
      if( powion.gt.0. ) then
        pionl = log10(powion) + pirsq
        avpow = powion/qhtot/en1ryd
      else
        pionl = 0.
        avpow = 0.
      endif
*
*     >>chng 97 mar 18, break these two out here, so that returns zero
*when no radiation - had been done in the print statement so pirsq was printed
      if( pbal.gt.0. ) then
        pballog = log10(max(1e-30,pbal))+pirsq
        qballog = log10(max(1e-30,qbal))+pirsq
      else
        pballog = 0.
        qballog = 0.
      endif
*
      if( pirsq.gt. 0. ) then
        write(qq,'(10X,'' L(nu>1ryd):'',F9.4,1P,''   Average nu:'',
     1  e9.3,''   L( X-ray):'',0P,F9.4,''   L(BalC):'',F9.4,5X,
     2  ''Q(Balmer C):'',F9.4)') pionl , avpow ,
     3  xpow, pballog , qballog
      else
        write(qq,'(10X,'' I(nu>1ryd):'',F9.4,1P,''   Average nu:'',
     1  e9.3,''   I( X-ray):'',0P,F9.4,''   I(BalC):'',F9.4,5X,
     2  ''Phi(BalmrC):'',F9.4)') pionl , avpow ,
     3  xpow, log10(max(1e-30,pbal)) ,
     4  log10(max(1e-30,qbal))
      endif
*
      if( qhe.gt.0. ) then
        qhel = log10(qhe) + pirsq
      else
        qhel = 0.
      endif
*
      if( qheii.gt.0. ) then
        qheiil = log10(qheii) + pirsq
      else
        qheiil = 0.
      endif
      if( q.gt.0. ) then
        ql = log10( q ) + pirsq
      else
        ql = 0.
      endif
*
      if( pirsq.ne.0. ) then
        write(qq,'(10X,'' Q(1.0-1.8):'',F9.4,''   Q(1.8-4.0):'',F9.4,
     1  ''   Q(4.0-20):'',F9.4,''   Q(20--):'',F9.4,5X,''Ion pht flx:'',
     2  1p,e9.3)') ql , qhel , qheiil , qxl , qhtot
      else
        write(qq,'(10X,'' phi(1.0-1.8):'',F7.4,''   phi(1.8-4.0):''
     1  ,F7.3, ''   phi(4.0-20):'',F7.3,''   phi(20--):'',F7.3,5X,
     2  ''Ion pht flx:'',1P,E9.3)') ql , qhel , qheiil , qxl , qhtot
      endif
*
*     estimate alpha (o-x)
      if( anu(nflux).gt.150. ) then
*       the ratio of fluxes is nearly 403.3^alpha ox
        ip2kev = ipoint( 147. )
        ip2500 = ipoint( 0.3645 )
        if( flux(ip2500).gt.1e-28 ) then
          ratio = (flux(ip2kev)*anu(ip2kev)/widflx(ip2kev) ) /
     1    (flux(ip2500)*anu(ip2500)/widflx( ip2500) )
        else
          ratio = 0.
        endif
        if( ratio .gt. 0. ) then
          alfox = log( ratio ) / log( anu(ip2kev)/anu(ip2500) )
        else
          alfox = 0.
        endif
      else
        alfox = 0.
      endif
*
      if( GammaLumin.gt.0. ) then
        gpowl = log10(GammaLumin) + pirsq
        qgaml = log10( qgam ) + pirsq
      else
        gpowl = 0.
        qgaml = 0.
      endif
      if( pradio.gt.0. ) then
        radpwl = log10( pradio ) + pirsq
      else
        radpwl = 0.
      endif
*
      if( pirsq.gt.0. ) then
        write(qq,'(10X,'' L(gam ray):'',F9.4,''   Q(gam ray):'',F9.4,
     1  3X,''L(Infred):'',F9.4,''   Alf(ox):'',F9.4,5X,
     2  ''Total lumin:'',F9.4)
     3  ') gpowl , qgaml , radpwl , alfox , log10(totlum)+pirsq
      else
        write(qq,'(10X,'' I(gam ray):'',F9.4,''   phi(gam r):'',F9.4,
     1  3X,''I(Infred):'',F9.4,''   Alf(ox):'',F9.4,5X,
     2  ''Total inten:'',F9.4)
     3  ') gpowl , qgaml , radpwl , alfox , log10(totlum)+pirsq
      endif
*
*     magnitudes
      if( pirsq.gt.0. ) then
        solar = log10(totlum) + pirsq - 33.5828
        absbol = 4.75 - 2.5 * solar
*       flux density in V, erg / s / cm2 / hz
        fluxv = ffun( 0.1643 ) * planck * 0.1643
*       absv = 4.79 - 2.5 * (log10(max(1e-30,fluxv)) + pirsq - 18.742 -
*    1  0.016)
*       allen 76, page 197
        absv = -2.5 * (log10(max(1e-30,fluxv)) + pirsq - 20.654202)
        fbeta = ffun( 0.1875 ) * planck * 0.1875 * 6.167e14
*     >>chng 97 mar 18, following branch so zero returned when no radiation at a
        if( fbeta.gt.0. ) then
          fbeta = log10( max(1e-37, fbeta ) ) + pirsq
        else
          fbeta = 0.
        endif
        bolc = absbol - absv
        write(qq,'(11X,''log L/Lsun:'',F9.4,''   Abs bol mg:'',F9.4,3X,
     1  ''Abs V mag:'',F9.4,''   Bol cor:'',F9.4,5X,
     2  ''nuFnu(Bbet):'',F9.4)')
     3  solar , absbol , absv , bolc , fbeta
      endif
*
      cmcool = 0.
      cmheat = 0.
      do i=1,nflux
*       CSIGC is Tarter expression times ANU(I)*3.858E-25
        cmcool = cmcool + (flux(i)+outlin(i)+outcon(i)) * csigc(i)
*       Compton heating with correction for induced Compton scattering
*       CSIGH is Tarter expression times ANU(I)**2 * 3.858E-25
        cmheat = cmheat + (flux(i)+outlin(i)+outcon(i)) * csigh(i) *
     1  (1.+occnum(i) )
      end do
      cmheat = cmheat * ( eden  * 1e-15)
*     6.338E-6 is k in inf mass Rydbergs
      cmcool = cmcool*(eden*4.*6.338e-6*1e-15)
*
*     all of following need factor of 10^-15 to be true rates
      if( cmcool.gt.0. ) then
        lgComUndr = .false.
        tcomp = cmheat / cmcool
      else
*       underflow if Compt cooling rate is zero
        lgComUndr = .true.
        tcomp = 0.
      endif
*
*     check whether energy density temp is greater than compton temp
      if( TEnerDen.gt.1.05*tcomp ) then
        lgEdnGTcm = .true.
      else
        lgEdnGTcm = .false.
      endif
*
*     say some ionization parameters
      write(qq,'(10X,'' U(1.0----):'',1P,E9.3,''   U(4.0----):'',
     1E9.3,''   T(En-Den):'',E9.3,''   T(Comp):'',E9.3,5X,
     2''nuJnu(912A):'',E9.3)')
     3 uh , uheii , TEnerDen , tcomp , fx1ryd
*
*     some occupation numbers
      write(qq,'(10X,'' Occ(FarIR):'',1P,E9.3,''   Occ(H n=6):'',
     1E9.3,''   Occ(1Ryd):'',E9.3,''   Occ(4R):'',E9.3,5X,
     2''Occ (Nu-hi):'',E9.3)') occnum(1) , occnum(ipHn(6)) ,
     3 occnum(ipHn(1)) , occnum(nheii) , occnum(nflux)
*
*     now print brightness temps
      tradio = occnum(1)*te1ryd*anu(1)
      write(qq,'(10X,'' Tbr(FarIR):'',1P,E9.3,''   Tbr(H n=6):'',
     1E9.3,''   Tbr(1Ryd):'',E9.3,''   Tbr(4R):'',E9.3,5X,
     2''Tbr (Nu-hi):'',E9.3)')
     3 tradio , occnum(ipHn(6))*te1ryd*anu(ipHn(6)) ,
     4 occnum(ipHn(1))*te1ryd*anu(ipHn(1)) ,
     4 occnum(nheii)*te1ryd*anu(nheii) , occnum(nflux)*te1ryd*anu(nflux)
*
      if( tradio.gt.1e9 ) then
        write(qq,'('' >>>The radio brightness temperature is very '',
     1  ''large,'',1P,E10.2,''K at'',E10.2,''cm.  Is this physical???''
     2  )')
     2  tradio , 9.115e-6/anu(1)
      endif
*
*     skip a line
      write(qq,'(''  '')')
*
      if( lgOnlyHead ) then
        stop
      endif
*
      end
******************************************************************************
      subroutine PrintElem( chJob , chLabl , abund )
      implicit none
*print chemical composition at start of calculation
      character chJob*4 , chLabl*2
      real abund
*
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      integer limit
      parameter (limit=9)
      character chAllLabels(limit)*13
      integer ipnt , i , noffset
      save ipnt, chAllLabels
*
      if( chJob.eq.'init' ) then
        ipnt = 0
        write(qq,'(57x,''Chemical Composition'')')
      else if( chJob.eq.'fill' ) then
        ipnt = ipnt + 1
        write(chAllLabels(ipnt),'(2x,a2,'':'',1p,e8.2)') chLabl,abund
        if( ipnt.eq.limit ) then
          write(qq,'(6x,9a13)') (chAllLabels(i),i=1,limit)
          ipnt = 0
        endif
      else if( chJob.eq.'flus' ) then
*       flush the stack
        i = limit - ipnt
        noffset = i / 2
        do i=ipnt,1,-1
          chAllLabels(i+noffset) = chAllLabels(i)
        end do
        do i=1,noffset
          write(chAllLabels(i),'(13x)')
        end do
        write(qq,'(6x,9a13)') (chAllLabels(i),i=1,ipnt+noffset)
      else
        write(qq,'('' PrintElem does not understand job='',a4)')chJob
        stop
      endif
*
      end
******************************************************************************
      subroutine prme( chDoIt , array )
      implicit none
*print heavy element line optical depths at end of calculation
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
*     lgPrtTau tells whether to print line optical depths
*     PrtTauFnt is smallest line optical depth to print
      logical lgPrtTau
      real PrtTauFnt
      common/PrtTau/ lgPrtTau , PrtTauFnt
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      real array(nta)
      character chLabel*2 , chDoIt*2
*
*     local variables
      integer i , n
      integer nlim
      parameter (nlim=6)
      character chLsav(nlim)*10 , chLineLbl*10
      real tsav(nlim)
      save chLsav , tsav , n
*
*     this routine is called by prtmet, and is used to print out
*     line optical depths after model complete - it IS NOT a
*     timing pace setter
*
*     label for line
      chLabel = chElementSym(int(array(ipLnNelem)))
*
      if( chDoIt.eq.'In' ) then
        n = 0
*
      else if( chDoIt.EQ.'  ' ) THEN
*       NB number in following statement must agree with nlim
        write(qq,'(2X,6(1X,A10,1P,E9.2))')
     1  (chLsav(i),tsav(i),i=1,n)
*
      else if( array(ipLnTauIn).gt.PrtTauFnt .or.
     1  array(ipLnTauIn).lt.0.) then
*       array(ipLnTauIn) is the optical depth
*       PrtTauFnt is threshold for printing it
        n = n + 1
        if( n.gt.nlim ) then
*       NB number in following statement must agree with nlim
          write(qq,'(2X,6(1X,A10,1P,E9.2))')
     1    (chLsav(i),tsav(i),i=1,nlim)
          n = 1
        endif
*
        chLsav(n) = chLineLbl( array )
        tsav(n) = array(ipLnTauIn)
      endif
*
      end
******************************************************************************
      subroutine prstep
      implicit none
*print out individual zone results
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nhe3lvl
      parameter (nhe3lvl=5)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real dheat
*grain heating rate for this zone
      common/dustheat/ dheat(ndust)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real pair
      common/pair/ pair
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      logical lgPrtBN
*flag set with print departure coefficients
      common/pbn/ lgPrtBN
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      logical lgdCNeg
*flag saying if derivative of cooling is negative
      common/dcneg/ lgdCNeg
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgPrintHeating
*     flag to turn on printout of heat sources
      common/pheat/ lgPrintHeating
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real cryden , crpowr , crtemp , hxtot
      common/hextra/ cryden , crpowr , crtemp , hxtot
*     include "hbn.com"
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      real he3n
      common/he3n/ he3n(nhe3lvl)
      double precision he3bn
      common/he3bn/ he3bn(nhe3lvl)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real photn2
      common/photn2/ photn2
      real tedust
      common/tedust/ tedust(ndust)
      character chDstLab*10
*     labels for types of dust grains
      common/dstlab/ chDstLab(ndust)
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      real recgrd , photex
      common/recgrd/ recgrd , photex
      integer ntry
      common/ntry/ ntry
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      real hehp
      integer iheh1 , iheh2
      common/hehp/ hehp , iheh1 , iheh2
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hmidep , h2dep , h2pdep,h3pdep,hehdep
      common/hmidep/ hmidep , h2dep , h2pdep,h3pdep,hehdep
      real r1r0sq
      common/r1r0sq/ r1r0sq
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real dRadSign
*sign of dr for going in or out, 1 (usually) or -1
      common/drsign/ dRadSign
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     TexcLya is the excitation temperature of Lya
*     nLyaHot is counts how ofter Lya hotter than gas
*     TLyaMax is hottest
*     TeLyaMax is electron temp at point where Lya max
*     nZTLaMax is the zone where this happened
      real TexcLya , TLyaMax , TeLyaMax
      integer nLyaHot , nZTLaMax
      common/LyaExT/ TexcLya , nLyaHot , TLyaMax , TeLyaMax , nZTLaMax
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      real flong , cfirst , csecnd, flcPhase
*     parameters for the fluctuations command
      logical lgDenFluc
      common/fluct/ flong , cfirst , csecnd , lgDenFluc, flcPhase
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      logical lgQHeat
*Kevin Volk add for quantum heating of grains
      common/qheat/ lgQHeat(ndust)
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      logical lgAbunTabl(limelm) , lgAbTaDepth(limelm),lgAbTaON
*lgAbunTabl says whether this element is to have its abundance
*determined from a table (true) or stored constant (false)
*set true with element table command
*lgAbTaDepth says whether depth or radius, true is depth
      common/AbunTablLG/ lgAbunTabl , lgAbTaDepth,lgAbTaON
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,nd,ishift,nq
      real rmidle,dmidle,fac,hatmic,coninc,cdif,
     1 qt1(ndust) , qp1(ndust)
*     >>chng 96 nov 30, qt1 qp1 as per K Volk changes for quantum heating
      character chLet*1 , chField8*8 , chQHMark*1
      real a(64)
*
*     free statement labesl >=11
*
      if( lgdCNeg ) then
        chLet = 'u'
      else
        chLet = ' '
      endif
*
*     middle of zone for printing
      rmidle = radius - drad * 0.5 * dRadSign
      dmidle = depth - drad * 0.5
*
*     option to print single line when quiet but tracing convergence
*     with "trace convergence" command
      if( lgTalk .or. lgTrConvg ) then
        if(nzone.le.999 ) then
          write(chField8,'(''####'',i3)') nzone
        else
          write(chField8,'(''###'',i4)') nzone
        endif
        write(qq,'(1X,a8,A1,''Te:'',1P,E9.3,'' Hden:'',E9.3,
     1  '' Ne:'',E9.3,'' R:'',E9.3,'' R-R0:'',E9.3,'' dR:'',E9.3,
     2  '' NTR:'',I3,'' Htot:'',E9.3,'' T912:'',E10.3,''###'')')
     3  chField8,chLet,te,hden,eden,rmidle,dmidle,drad,ntry,htot,
     1  tauabs(ipHn(1),1)
        if( lgTrConvg ) write(qq,'('' H:'',1p,2e10.2,'' He:'',3e10.2)')
     3  hi/(hi+hii) , hii / (hi+hii) , hei/ahe , heii/ahe , heiii/ahe
      endif
*
*     now return if not talking
      if( .not.lgTalk .or. lgTrConvg ) return
*
*     lgDenFluc set to true in zero, only false when variable abundances
*     lgAbTaON set true when element table used
      if( .not.lgDenFluc .or. lgAbTaON ) then
        write(qq,'('' Abun:'',1p,15e8.1)')(xIonFracs(i,0),i=1,limelm)
      endif
*
*-------------------------------------------------
*     print wind parameters if windy model
      fac = windv * hden * r1r0sq
      if( windv.ne.0. ) then
         if( AccelTot.eq.0. ) then
            fac = 1.
         else
            fac = AccelTot
         endif
         write(qq,'('' WIND; V:'',1P,E9.3,''km/s G:'',
     1   E10.3,'' Accel:'',E10.3,'' Fr(cont):'',0P,F6.3,'' Fr(line):'',
     2   F6.3,'' Fr(dP):'',F6.3)')
     3   windv/1e5 , -agrav , AccelTot , AccelCont /fac ,AccelLine /fac,
     4   AccelPres /fac
      endif
*
*     print line with radiation pressure if significant
      if( windv.ne.0. .or. pbeta.gt..05 ) then
        call PrtLinePres
      endif
*
*----------------------------------------------------
      hatmic = (hi+hii) / ( hi+hii+hminus+2.*(htwo+h2plus)+3*h3plus)
      write(qq,'('' Hydrogen '',2X,2(1P,E10.3),'' H+o/Hden:'',E10.3,
     1 E10.3,'' H-'',5X,''H2'',E10.3,E10.3,'' H2+  HeH+'',
     2 E10.3,'' H col den'',E10.3)')
     3 hi/(hi+hii) , hii / (hi+hii) ,
     3 hatmic , hminus / hden , htwo / hden , h2plus / hden ,
     4 hehp / hden , colden
*
*     print departure coef if desired
      if( lgPrtBN ) then
         a(1) = hbn(1)
         a(2) = 1.
         a(3) = (hi+hii) / hden
         a(4) = hmidep
         a(5) = h2dep
         a(6) = h2pdep
         a(7) = h3pdep
         a(8) = hehdep
         write(qq,'('' Hydrogen '',2X,2(1P,E10.3),'' H+0/Hden:'',E10.3,
     1   E10.3,'' H-'',5X,''H2'',E10.3,7X,''H2+'',E10.3,5X,''H3+'',
     2   E10.3,''HeH+'',E8.2)') (a(i),i=1,8)
      endif
*
      if(lgPrintHeating) write(qq,'(12X,1P,E10.3,10X,E10.3,10X,E10.3)')
     2 heating(1,1)/htot , heating(1,16)/htot , heating(1,17)/htot
*
*     temperature correspoding to radiation fields
      coninc = 0.
      cdif = 0.
      do i=1,nflux
         coninc = coninc + flux(i) * (anu(i)*en1ryd)
         cdif = cdif + (ContDiff(i)+outlin(i)+outcon(i))*(anu(i)*en1ryd)
      end do
      coninc = ( coninc / 2.997925e10 / 7.56464e-15 )**0.25
      cdif = ( cdif / 2.997925e10 / 7.56464e-15 )**0.25
*
*     print stright level pop per ionized hydrogen
      write(qq,'('' H 2SP 3-6'',2X,6(1P,E10.3),
     1'' Texc(La):'',E10.3,'' T(contn):'',E10.3,'' T(diffs):'',E10.3)')
     2 hn2s,hn2p,(hn(i),i=3,6),TexcLya, coninc,cdif
*
*     option to print dep coef
      if( lgPrtBN ) then
        write(qq,'('' H 2SP 3-12'',1x,1p,12e10.3)')
     1  hbn(nhlvl+1),(hbn(i),i=2,min(nhlvl,12))
        if( nhlvl.gt.12 ) write(qq,'('' rest:    '',2x,1p,13e10.3)')
     1  (hbn(i),i=13,nhlvl)
      endif
*
      if( lgPrintHeating ) write(qq,'(12X,1P,E10.3,10X,E10.3
     1,'' Bound Com'',E10.3,''    Extra:'',E10.3,''    Pairs:'',E10.3,
     2''   H-lines'',E10.3)')
     2 heating(1,2)/htot ,0. ,heating(1,19)/htot,
     3 heating(1,21)/htot,heating(1,22)/htot
*
*     Helium
      if( lgElmtOn(2) ) then
        a(1) = hei / ahe
        a(2) = heii / ahe
        a(3) = heiii / ahe
        a(4) = hei3 / ahe
*
        write(qq,'('' Helium   '',2X,3(1P,E10.3),'' He I 2S3 '',E10.3,
     1  '' Comp H, C'',2E10.3,'' Fill Fact'',E10.3,'' Gam 1/tot'',E10.3)
     2  ')(a(i),i=1,4),cmheat,cmcool*te,FillFac, photn2
*
*       option to print departure coef
        if( lgPrtBN ) then
          a(1) = he1bn(1)
          a(2) = he2bn(1)
          a(3) = 1.
          a(4) = he3bn(1)
*
          write(qq,'('' Helium   '',2X,3(1P,E10.3),'' He I 2S3 '',E10.3,
     1    '' Comp H, C'',2E10.3,'' Fill Fact'',E10.3,'' Gam 1/tot'',
     2    e10.3)') (a(i),i=1,4),cmheat,cmcool*te,FillFac, photn2
        endif
*
*       print heating from He (and others) if desired
*       entry "lines" is induced line heating
*       1,12 ffheat:  2,3 he triplets, 1,20 compton
        if( lgPrintHeating ) write(qq,'(12X,2(1P,E10.3),''    Lines:'',
     1   2e10.2,''  Compton:'',E10.3,'' FF Heatig'',E10.3)')
     2  heating(2,1)/htot ,heating(2,2)/htot , heating(1,23)/htot,
     3  heating(2,3)/htot , heating(1,20)/htot , heating(1,12)/htot
*
        fac = heii / ahe
        write(qq,'('' He singlet '',6(1P,E10.3),'' He triplt'',5E10.3)')
     1  (he1n(i)*fac,i=1,6), (he3n(i)*fac,i=1,nhe3lvl)
*       option to print departure coef
        if( lgPrtBN ) then
           write(qq,'('' He singlet '',10(1P,E10.3))') (he1bn(i),
     1     i=1,nhe1lvl+1)
           write(qq,'('' He triplet '',6(1P,E10.3))') he3bn
        endif
        fac = heiii / ahe
        write(qq,'('' HeII'',7X,9(1P,E10.3),'' RadPres/GAS:'',E10.3)')
     1  (he2n(i)*fac,i=1,9) , pbeta
*       option to print departure coef
        if( lgPrtBN ) then
           write(qq,'('' HeII 1-9,2s'',10(1P,E10.3),'' RadPres/GAS:'',
     1     e10.3)') he2bn , pbeta
        endif
      endif
*
      if( lgDustOn ) then
*        Change things so the dust species that are quantum heated are marked wi
*        asterisk just after the name (K Volk)
         do nd=1,ndust
            if( lgDustOn1(nd) ) then
              if (lgQHeat(nd)) then
                chQHMark ='*'
              else
                chQHMark =' '
              end if
*             (K Volk) added QHMARK here and in the write statement
              write(qq,'(1P,A10,a1,''  Dust temp'',E10.3,'' Pot(Volt)''
     1        ,e10.3,'' Nelectron'',E10.3,'' drft cm/s'',E10.3,
     2        ''  Heating:'',E10.3,'' Frac(tot)'',E10.3)')
     1        chDstLab(nd),chQHMark,tedust(nd),dstpot(nd)*evryd,
     2        dstq(nd),DustDftVel(nd) ,dheat(nd),dheat(nd)/htot
            endif
         end do
*        (K Volk) added QHEAT punch out of temperature values
*
         if (iqp.gt.0) then
             if (nqout1.eq.0) then
*
                 do nd=1,ndust
                 if (lgQHeat(nd).and.lgDustOn1(nd)) then
                     nqout1=nqout1+1
                     nqp1(nqout1)=nd
                 end if
                 end do
*
               if (nqout1.eq.0) then
                 write(iqp,'(''**** no grains were quantum heated.'')')
                 nqout1=-1
               end if
             end if
*
             if (nqout1.gt.0) then
                write(iqp,'(''Dust Temperature Distribution: zone '',
     1          i4,'' --- dust types:'',10i3)')
     2          nzone,(nqp1(nd),nd=1,nqout1)
                write(iqp,'(''Weighted mean temperatures: '',0p10f8.2)')
     1          (tedust(nqp1(nd)),nd=1,nqout1)
                write(iqp,'(''Equilibrium temperatures: '',0p10f8.2)')
     1          (tequil1(nqp1(nd)),nd=1,nqout1)
*
                do nq=1,nqhg1
                  do nd=1,nqout1
                    qp1(nd)=qhprob(nqp1(nd),nq)
                    qt1(nd)=qtemp(nqp1(nd),nq)
                  end do
                  write(iqp,'(10(0pf8.2,1pe10.3))')
     1            (qt1(nd),qp1(nd),nd=1,nqout1)
                end do
             end if
         end if
c End of changes here (K Volk)
      endif
*
*     gas pressure, pressure due to incident radiation field, rad accel
      write(qq,'(1P,'' Pressure'',3X,'' NgasTgas:'',E10.3,'' P(total):''
     1,E10.3,'' P( gas ):'',E10.3,'' P(Radtn):'',E10.3,'' Rad accel'',
     1 E10.3,'' Force Mul'',E10.3)')
     3 GasPres/Boltzmann , RadPres+GasPres , GasPres , RadPres ,
     4 AccelTot , fmul
*
*     heavy element molecules
      if( co.gt.0. ) then
         write(qq,'(1P,'' Molecules   CH/Ctot :'',E10.3,'' CH+/Ctot:'',
     1   E10.3,'' CO/Ctot :'',E10.3,'' CO+/Ctot:'',E10.3,'' H2O/Otot:'',
     1   E10.3,'' OH/Ototl:'',E10.3)')
     1   ch/xIonFracs(6,0),chp/xIonFracs(6,0),co/xIonFracs(6,0),
     2   cop/xIonFracs(6,0),h2o/xIonFracs(8,0),
     1   oh/xIonFracs(8,0)
      endif
*
*     Li, be, b
      if( lgElmtOn(3).or.  lgElmtOn(4) ) then
        write(qq,'('' Lithium'',4X,4(1P,E10.3),'' Beryllium'',5E10.3)')
     2  (xIonFracs(3,i)/max(1e-35,xIonFracs(3,0)),i=1,4) ,
     3  (xIonFracs(4,i)/max(1e-35,xIonFracs(4,0)),i=1,5)
        if(lgPrintHeating) write(qq,'(12X,3(1P,E10.3),20x,5(1P,E10.3))')
     1  (heating(3,i)/htot,i=1,3) , (heating(4,i)/htot,i=1,4)
      endif
      if( lgElmtOn(5)) then
        write(qq,'('' Boron  '',4X,6(1P,E10.3))')
     2  (xIonFracs(5,i)/max(1e-35,xIonFracs(5,0)),i=1,6)
        if(lgPrintHeating) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(5,i)/htot,i=1,5)
      endif
*
*     Carbon
      if( lgElmtOn(6) ) then
        write(qq,'('' Carbon'',5X,7(1P,E10.3),'' H2O+/Otot'',E10.3,
     1  '' OH+/Ototl'',E10.3)')
     2  (xIonFracs(6,i)/max(1e-35,xIonFracs(6,0)),i=1,7) ,
     3  h2op/max(1e-35,xIonFracs(8,0)) ,
     3  ohp/max(1e-35,xIonFracs(8,0))
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(6,i)/htot,i=1,6)
      endif
*
*     Nitrogen
      if( lgElmtOn(7) ) then
        write(qq,'('' Nitrogen'',3X,8(1P,E10.3),'' O2/Ototl:'',E10.3,
     1  '' O2+/Otot:'',E10.3)')
     1   (xIonFracs(7,i)/max(1e-35,xIonFracs(7,0)),i=1,8),
     2   otwo/max(1e-35,xIonFracs(8,0)) ,
     2   o2p/max(1e-35,xIonFracs(8,0))
        if( lgPrintHeating) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(7,i)/htot,i=1,7)
      endif
*
*     Oxygen
      if( lgElmtOn(8) ) then
        write(qq,'('' Oxygen'',5X,9(1P,E10.3),'' Hex(tot):'',E10.3,
     1  '' A:'',0P,F7.3)') (xIonFracs(8,i)/max(1e-35,xIonFracs(8,0)),
     2   i=1,9),
     2  hxtot, log10(max(recgrd,1e-30))
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(8,i)/htot,i=1,8)
      endif
*
*     fluorine
      if( lgElmtOn(9) ) then
        write(qq,'('' Fluorine'',3X,10(1P,E10.3))')
     1  (xIonFracs(9,i)/max(1e-35,xIonFracs(9,0)),i=1,10)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(9,i)/htot,i=1,9)
      endif
*
*     Neon
      if( lgElmtOn(10) ) then
        write(qq,'('' Neon'',7X,11(1P,E10.3))')
     1  (xIonFracs(10,i)/xIonFracs(10,0),i=1,11)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(10,i)/htot,i=1,10)
      endif
*
*     Sodium
      if( lgElmtOn(11)) then
        write(qq,'('' Sodium'',5X,12(1P,E10.3))')
     1  (xIonFracs(11,i)/xIonFracs(11,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(11,i)/htot,i=1,11)
      endif
*
*     Magnesium
      if( lgElmtOn(12)) then
        ishift = max( 0 , IonHigh(12)-12 )
        write(qq,'('' Magnesium'',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(12,i+ishift)/xIonFracs(12,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(12,i+ishift)/htot,i=1,12)
      endif
*
*     Aluminium
      if( lgElmtOn(13)) then
        ishift = max( 0 , IonHigh(13)-12 )
        write(qq,'('' Aluminium'',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(13,i+ishift)/xIonFracs(13,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(13,i+ishift)/htot,i=1,12)
      endif
*
*     Silicon
      if( lgElmtOn(14)) then
        ishift = max( 0 , IonHigh(14)-12 )
        write(qq,'('' Silicon  '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(14,i+ishift)/xIonFracs(14,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(14,i+ishift)/htot,i=1,12)
      endif
*
*     Phosphorus
      if( lgElmtOn(15)) theN
        ishift = max( 0 , IonHigh(15)-12 )
        write(qq,'('' Phosphors'',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(15,i+ishift)/xIonFracs(15,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(15,i+ishift)/htot,i=1,12)
      ENDIF
*
*     Sulphur
      if( lgElmtOn(16)) then
        ishift = max( 0 , IonHigh(16)-12 )
        write(qq,'('' Sulphur  '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(16,i+ishift)/xIonFracs(16,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(16,i+ishift)/htot,i=1,12)
      endif
*
*     Chlorine
      if( lgElmtOn(17)) then
        ishift = max( 0 , IonHigh(17)-12 )
        write(qq,'('' Chlorine '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(17,i+ishift)/xIonFracs(17,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(17,i+ishift)/htot,i=1,12)
      endif
*
*     Argon
      if( lgElmtOn(18)) then
        ishift = max( 0 , IonHigh(18)-12 )
        write(qq,'('' Argon    '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(18,i+ishift)/xIonFracs(18,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(18,i+ishift)/htot,i=1,12)
      endif
*
*     Potassium
      if( lgElmtOn(19)) then
        ishift = max( 0 , IonHigh(19)-12 )
        write(qq,'('' Potassium'',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(19,i+ishift)/xIonFracs(19,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(19,i+ishift)/htot,i=1,12)
      endif
*
*     Calcium
      if( lgElmtOn(20)) then
        ishift = max( 0 , IonHigh(20)-12 )
        write(qq,'('' Calcium  '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(20,i+ishift)/xIonFracs(20,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(20,i+ishift)/htot,i=1,12)
      endif
*
*     Scandiuim
      if( lgElmtOn(21)) then
        ishift = max( 0 , IonHigh(21)-12 )
        write(qq,'('' Scandium '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(21,i+ishift)/xIonFracs(21,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(21,i+ishift)/htot,i=1,12)
      endif
*
*     Titanium
      if( lgElmtOn(22)) then
        ishift = max( 0 , IonHigh(22)-12 )
        write(qq,'('' Titanium '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(22,i+ishift)/xIonFracs(22,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(22,i+ishift)/htot,i=1,12)
      endif
*
*     Vanadium
      if( lgElmtOn(23)) then
        ishift = max( 0 , IonHigh(23)-12 )
        write(qq,'('' Vanadium '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(23,i+ishift)/xIonFracs(23,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(23,i+ishift)/htot,i=1,12)
      endif
*
*     Chromium
      if( lgElmtOn(24)) then
        ishift = max( 0 , IonHigh(24)-12 )
        write(qq,'('' Chromium '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(24,i+ishift)/xIonFracs(24,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(24,i+ishift)/htot,i=1,12)
      endif
*
*     Manganese
      if( lgElmtOn(25)) then
        ishift = max( 0 , IonHigh(25)-12 )
        write(qq,'('' Manganes '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(25,i+ishift)/xIonFracs(25,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(25,i+ishift)/htot,i=1,12)
      endif
*
*     Iron
      if( lgElmtOn(26)) then
        ishift = max( 0 , IonHigh(26)-12 )
        do while( ishift.gt.0 .and. xIonFracs(26,12+ishift)/
     1    xIonFracs(26,0).lt.1e-12 )
          ishift = ishift - 1
        end do
        write(qq,'('' Iron'',5X,I2,12(1P,E10.3))')
     1  ishift,(xIonFracs(26,i+ishift)/xIonFracs(26,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(26,i+ishift)/htot,i=1,12)
      endif
*
*     Cobalt
      if( lgElmtOn(27)) then
        ishift = max( 0 , IonHigh(27)-12 )
        do while( ishift.gt.0 .and. xIonFracs(27,12+ishift)/
     1    xIonFracs(27,0).lt.1e-12 )
          ishift = ishift - 1
        end do
        write(qq,'('' Cobalt'',3X,I2,12(1P,E10.3))')
     1  ishift,(xIonFracs(27,i+ishift)/xIonFracs(27,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(27,i+ishift)/htot,i=1,12)
      endif
*
*     nickel
      if( lgElmtOn(28)) then
        ishift = max( 0 , IonHigh(28)-12 )
        do while( ishift.gt.0 .and. xIonFracs(28,12+ishift)/
     1    xIonFracs(28,0).lt.1e-12 )
          ishift = ishift - 1
        end do
        write(qq,'('' Nickel'',3X,I2,12(1P,E10.3))')
     1  ishift,(xIonFracs(28,i+ishift)/xIonFracs(28,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1 (heating(28,i+ishift)/htot,i=1,12)
      endif
*
*     Copper
      if( lgElmtOn(29)) then
        ishift = max( 0 , IonHigh(29)-12 )
        write(qq,'('' Copper   '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(29,i+ishift)/xIonFracs(29,0),i=1,12)
        if( lgPrintHeating ) write(qq,'(12X,12(1P,E10.3))')
     1  (heating(29,i+ishift)/htot,i=1,12)
      endif
*
*     Zinc
      if( lgElmtOn(30)) then
        ishift = max( 0 , IonHigh(30)-12 )
        write(qq,'('' Zinc     '',I2,12(1P,E10.3))')
     1  ishift, (xIonFracs(30,i+ishift)/xIonFracs(30,0),i=1,12)
        if( lgPrintHeating ) Write(qq,'(12X,12(1P,E10.3))')
     1  (heating(30,i)/htot,i=1+ishift,min(30,12+ishift))
      endif
*
      if( chFeIIAtom.eq.'Verner' ) then
        call PrtFeII
      endif
      end
******************************************************************************
      subroutine PrtAllTau
      implicit none
*master routine controlling printout of optical depths at end of calculation
      integer ndfst
      parameter (ndfst=5)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      logical lgStatic
*flag saying that spherical geometry is static, set with sphere static
      common/static/ lgStatic
      real telec , thmin
      common/taucon/ telec , thmin
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real fcon,flin
*
*     optical depths used by code are total through model,
*     when sphere is set, this is twice optical depth through
*     computed structure
      if( lgSphere ) then
        fcon = 2.
        if( lgStatic ) then
          flin = 2.
        else
          flin = 1.
        endif
      else
        fcon = 1.
        flin = 1.
      endif
*
*     print out optical depths and column densities
*
*     R(1300) is Rayleigh scattering
      write(qq,'(/'' Contin Optical Depths: COMP:'',1P,E9.2,''    H-:'',
     1E9.2,'' R(1300):'',E9.2,'' H2+'',E9.2,''  HeTri:'',E8.2)')
     2 telec , thmin , chi*6.71e-24 , ch2pls*7e-18 ,
     3 tautot(nhei3,1)/fcon
*
      write(qq,'(''  Pfa:'',1P,E8.2,''   Pa:'',E8.2,''   Ba:'',E8.2,
     1''   Hb:'',E8.2,''  La:'',E8.2,
     1''   1r:'',E9.3,''  1.8:'',E8.2,''  4.:'',E9.3)')
     3 tautot(iphl(5,4),1)/fcon,tautot(iphl(4,3),1)/fcon,
     3 tautot(iphl(3,2),1)/fcon, tautot(iphl(4,2),1)/fcon,
     4 tautot(iphl(2,1),1)/fcon, tautot(ipHn(1),1)/fcon,
     5 tautot(nhe1(1),1)/fcon, tautot(nhe2(1),1)/fcon
*
*     print optical depths of previous iteration
      write(qq,'('' Line Optical Depths: 10830:'',1P,E9.2,''  3889:'',
     1 E9.2,''  5876:'',E9.2,''  7065:'',E9.2,'' 2.06m'',E9.2)')
     2 t10830(ipLnTauIn)/flin,t3889(ipLnTauIn)/flin,
     3 t5876(ipLnTauIn)/flin, t7065(ipLnTauIn)/flin ,
     3 t206(ipLnTauIn)/flin
*
      call prtmet
*
      write(qq,'(/'' Old hydro optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(ipHn(i),2)/fcon,i=1,8)
      write(qq,'('' New hydro optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(ipHn(i),1)/fcon,i=1,8)
*
      write(qq,'(14X,''Old H Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,htlim(i+1,i)/flin,i=1,8)
      write(qq,'(14X,''New H Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,htau(i+1,i)/flin,i=1,8)
*
      write(qq,'('' Old He Is optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(nhe1(i),2)/fcon,i=1,8)
      write(qq,'('' New He Is optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(nhe1(i),1)/fcon,i=1,8)
*
      write(qq,'(10X,''Old He Is Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,he1lim(i+1,i)/flin,i=1,8)
      write(qq,'(10X,''New He Is Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,he1tau(i+1,i)/flin,i=1,8)
*
      write(qq,'('' Old He II optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(nhe2(i),2)/fcon,i=1,8)
      write(qq,'('' New HE II optical depths:'',8(I4,1P,E9.2))')
     2 (i,tauabs(nhe2(i),1)/fcon,i=1,8)
*
      write(qq,'(10X,''Old He II Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,he2lim(i+1,i)/flin,i=1,8)
      write(qq,'(10X,''New He II Lines:'',8(I2,''-'',I1,1p,E9.2))')
     2 (i+1,i,he2tau(i+1,i)/flin,i=1,8)
*
      end
**************************************************************************
      subroutine PrtGamma( n1 , n2 , ip , io , total, threshold)
      implicit none
*special version of gamma function to print strong contributors
      integer n1,n2,ip,io
      real threshold , total
*
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
*
*     local variables
      integer i , j , k
      real phisig , flxcor
*
*     special special version of GAMFUN to punch step-by-step results
      if(n1 .ge. nflux) return
*
      write(io,'('' PrtGamma from '',1P,E9.2,'' to '',E9.2,''R rates >''
     1,e9.2,'' total='',e9.2)')  anu(n1),anu(n2),threshold ,total
      if( threshold.le.0. .or. total.le.0. ) return
*
      k = n1
      j = min( n2 , nflux )
*
*     do theshold special, do not pick up otscon
      i = k
      phisig = (flux(i)+otslin(i)) * OpacStack(i-k+ip)
      if(phisig.gt.threshold)  then
        flxcor = flux(i) + otslin(i)
        write(io,'(i5,1p,2e9.2,0p,4f5.2,1p,1x,2(a4,1x))')i,
     1  anu(i),phisig/total,
     2  flux(i)/flxcor,otslin(i)/flxcor,otscon(i)/flxcor,
     3  (outcon(i)+outlin(i))/flxcor , chLineLabel(i), chContLabel(i)
      endif
*
      do i=k+1,j
        phisig = SummedCon(i) * OpacStack(i-k+ip)
        if( phisig.gt.threshold) then
          flxcor = flux(i) + otslin(i) + otscon(i)+outlin(i)+outcon(i)
          write(io,'(i5,1p,2e9.2,0p,4f5.2,1p,1x,2(a4,1x))')i,
     1    anu(i),phisig/total,
     2    flux(i)/flxcor,otslin(i)/flxcor,otscon(i)/flxcor,
     3    (outcon(i)+outlin(i))/flxcor , chLineLabel(i), chContLabel(i)
        endif
      end do
*
      end
******************************************************************************
      subroutine PrtLinePres
      implicit none
*print line radiation pressures for current conditions
      real amu
      parameter (amu=1.660531e-24)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      logical lgPradCap , lgPradDen
*lgPradCap true if radiation pressure capped on first iteration
*lgPradDen capped by thermalization length
      common/prdcap/ lgPradCap , lgPradDen
      logical lgRadPrsON
*flag true if radiation pressure is turned on, part of total pressure
      common/radpon/ lgRadPrsON
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      integer iprdmx
      common/iprdmx/ iprdmx
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      logical lgConPres
*flag saying whether or not incident continuum should be included
*in total pressure, turned off with constant gas pressure
      common/conprs/ lgConPres
      real pinit , pinteg , pinzon
      common/pinteg/ pinit , pinteg , pinzon
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real totnuc
*     totnuc is total number of nuclei and molecules, eval in ptot
      common/totnuc/ totnuc
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real AtomicWeight
*stored vector of atomic weights for all elements, set in block data scalar
      common/AtomcWgt/ AtomicWeight(limelm)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real WidthLine , RadPres1, thresh
      integer i,ip , nline
      parameter (thresh=0.05 , nline=20)
      integer iwl(nline) , iWavLen
      character chLab(nline)*4 , chIonLbl*4
      real frac(nline)
*
*     this routine only called if printout of contributors to line
*     radiation pressure is desired
*
*     plines(1)=l-alpha,          in hlevel(ionize)
*     plines(2) = hign n lyman ;   plines(3)=excit h lines iN HLEVEL
*     plines(4) = he i 10830
*     plines(5)= HeII 304 plines(11)=HeI La (in helium)
*     plines(6)= HeI 584
 
*     compute radiation pressure due to special H and He lines
      ip = 0
      if( RadPres.gt.1e-30 ) then
        do i=1,20
          if( plines(i).gt.RadPres*thresh ) then
            ip = ip + 1
            if( i.eq.1 ) then
              iwl(ip) = 1216
              chLab(ip) = 'H  1'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.2 ) then
              iwl(ip) = 1034
              chLab(ip) = 'H  1'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.3 ) then
              iwl(ip) = 6563
              chLab(ip) = 'H  1'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.4 ) then
              iwl(ip) = 10830
              chLab(ip) = 'He 1'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.5 ) then
              iwl(ip) = 304
              chLab(ip) = 'He 2'
              frac(ip) = plines(i)/RadPres
            else if( i.eq.6 ) then
              iwl(ip) = 584
              chLab(ip) = 'He 1'
              frac(ip) = plines(i)/RadPres
            else
              write(qq,'('' PrtLinePres insanity'')')
              stop
            endif
          endif
        end do
*
*       line radiation pressure from large set of level 1 lines
        do i=1,nTauLines
          if( TauLines(ipLnPopu,i).gt.1e-30 ) then
            RadPres1 = 5.551e-2*((TauLines(ipLnEnrWN,i)/1.e6)**4)*
     1      ( TauLines(ipLnPopu,i) / TauLines(ipLnGu,i) ) /
     2      ( TauLines(ipLnPopl,i) / TauLines(ipLnGl,i) ) *
     2      WidthLine(TauLines(1,i)) * 2.
          else
            RadPres1 = 0.
          endif
          if( RadPres1.gt.RadPres*thresh ) then
            ip = min(20 , ip+1 )
            iwl(ip) = iWavLen( TauLines(1,i) )
            chLab(ip) = chIonLbl(TauLines(1,i))
            frac(ip) = RadPres1/RadPres
          endif
        end do
        do i=1,NWINDLINE
          if( WindLine(ipLnPopu,i).gt.1e-30 ) then
            RadPres1 = 5.551e-2*((WindLine(ipLnEnrWN,i)/1.e6)**4)*
     1      ( WindLine(ipLnPopu,i) / WindLine(ipLnGu,i) ) /
     2      ( WindLine(ipLnPopl,i) / WindLine(ipLnGl,i) ) *
     2      WidthLine(WindLine(1,i)) * 2.
          else
            RadPres1 = 0.
          endif
          if( RadPres1.gt.RadPres*thresh ) then
            ip = min(20 , ip+1 )
            iwl(ip) = iWavLen( WindLine(1,i) )
            chLab(ip) = chIonLbl(WindLine(1,i))
            frac(ip) = RadPres1/RadPres
          endif
        end do
*
*       now print them
        write(qq,'('' P(Lines):'',6(0p,f8.2,1x,a4,i5,'',''))')
     1   (frac(i),chLab(i),iwl(i),i=1,ip)
      end if
*
      end
******************************************************************************
      subroutine prtmet
      implicit none
*print all line optical depths at end of iteration
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
*     lgPrtTau tells whether to print line optical depths
*     PrtTauFnt is smallest line optical depth to print
      logical lgPrtTau
      real PrtTauFnt
      common/PrtTau/ lgPrtTau , PrtTauFnt
*
*     local variables
      integer i
*
*     default is to not print optical depths, turn on with
*     print optical depths on command
      if( lgPrtTau ) then
*
*       'In' means to zero counter, following elements mean nothing
        call prme('In',  TauLines(1,1) )
*
*       print all lines lines
        do i=1,nTauLines
          call prme(' c',  TauLines(1,i) )
        end do
        do i=1,NWINDLINE
          call prme(' c',  WindLine(1,i) )
        end do
*
*       this means print it
        call prme('  ',  TauLines(1,1) )
      endif
*
      end
******************************************************************************
      subroutine ptrcer
      implicit none
*show continuum pointers in real time following drive pointers command
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      character chCard*80 , chKey*1
      logical lgEOL
      integer i , ipnt , j , ipoint , ierr
      real pnt , fread , t1 , t2
*
      write(qq,'('' There are two ways to do this:  do you want me '',
     1''to test all the pointers (enter y)''/'' or do you want to '',
     2''enter energies yourself? (enter n)'')')
      read(5,'(A1)') chKey
*
      if( chKey.eq.'n' ) then
        write(qq,'('' Enter energy (Ryd); 0 to stop; negative is log.''
     1  )')
*98     read(5,'(a80)',end=999) chCard
        ierr = 0
        pnt = 1.
        read(5,'(a80)',iostat=ierr) chCard
        do while( ierr.eq.0 .and. pnt.ne.0. )
          i = 1
          pnt = fread( chCard , i , 76 , lgEOL )
          if( pnt.lt.0. ) pnt = 10.** pnt
          if( pnt.ne.0. ) then
            ipnt = ipoint( pnt )
            write(qq,'('' Cell num'',I4,'' center:'',1P,E9.2,'' width:''
     1      ,E9.2,'' low:'',E9.2,'' hi:'',E9.2,'' convoc:'',E9.2)')
     2      ipnt , anu(ipnt) , widflx(ipnt) , anu(ipnt)-widflx(ipnt)/2.,
     3      anu(ipnt)+widflx(ipnt)/2. , convoc(ipnt)
          endif
          read(5,'(a80)',iostat=ierr) chCard
        end do
*999  continue
      else if( chKey.eq.'y' ) then
        write(qq,'('' errors output on 7, IP(cor),IP(fount),nu'',
     1  '' lower, upper of found, desired cell.'')')
        do i=1,nflux
          t1 = anu(i)-widflx(i)/2.*0.9
          t2 = anu(i)+widflx(i)/2.*0.9
          j = ipoint( t1 )
          if( j.ne.i ) then
            write(qq,'('' Pointers do not agree for lower bound of''
     1      ,'' of cell'',I4)') i
          endif
          j = ipoint( t2 )
          if( j.ne.i ) theN
            write(qq,'('' Pointers do not agree for upper bound of''
     1      ,'' of cell'',I4)') i
          endif
        end do
      else
        write(qq,'('' This key is not understood, sorry.  '',A1)')
     1  chKey
        stop
      endif
*
      stop
      end
******************************************************************************
      subroutine PunCool( io )
      implicit none
*punch coolants
      integer io
*
      integer ncolnt
      parameter (ncolnt=10 000)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      logical lgTeFail
*set true in IONTE if heating - cooling failure
      common/tfail/ lgTeFail
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real WeakHeatCool
*     threshold for faintest cooling or heating to be punched
*     default is set to 0.05 in scalar, can be reest with 'set weakheatcool',
      common/WkHtCl/ WeakHeatCool
*
*     local variables
      integer iplim , i , j , is , imax , ip
      real cset , xmax
      parameter (iplim=7)
      character*4 chLSav(iplim) , chL2(iplim)
      real csav(iplim) , csav2(iplim) , sgnsav(iplim) , sgn2(iplim)
      integer isav(iplim) , isav2(iplim)
*
*     cset will be weakest cooling to consider
*     WeakHeatCool set with 'set weakheatcool' command
*     default is 0.05
      cset = ctot * WeakHeatCool
*
*     first find all strong lines, both + and - sign
      ip = 1
      do i=1,ncltot
        if( (cooling(i).gt.cset .or.heatnt(i).gt.cset)
     1    .and.ip.le.iplim ) then
          chLSav(ip) = chClntLab(i)
          isav(ip) = collam(i)
          csav(ip) = max( cooling(i) , heatnt(i) ) / ctot
*         save sign to remember if heating or cooling line
          if( heatnt(i).eq.0. ) then
            sgnsav(ip) = +1.
          else
            sgnsav(ip) = -1.
          endif
          ip = ip + 1
        endif
      end do
      ip = ip - 1
*
*     order strongest to weakest
      do i=1,ip
        xmax = 0.
        do j=1,ip
          if(csav(j).gt.xmax ) then
            xmax = csav(j)
            imax = j
          endif
        end do
        chL2(i) = chLSav(imax)
        isav2(i) = isav(imax)
        csav2(i) = csav(imax)
        sgn2(i) = sgnsav(imax)
        csav(imax) = -1.
      end do
*
*     warn is te failure occurred
      if(lgTeFail) then
        write(io,'('' >>>>  A temperature failure occured.'')')
      end if
*
*     convert very long wavelengths to micros
      do i=1,ip
        if( isav2(i).gt.1e5 ) isav2(i) = isav2(i)/1e4
      end do
*
*     keep sign of coolant, for strong negative cooling
      write(io,'(i4,1p,2e9.2,7(1x,a4,i6,0p,f6.3))') nzone,
     1 htot,ctot,(chL2(is),isav2(is), sign(csav2(is),sgn2(is)),is=1,ip)
*
      end
******************************************************************************
      subroutine PunGamma( io )
      implicit none
*punch photoionization rates for all subshells, with punch gamma command
      integer io
      integer limelm
      parameter (limelm=30)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real hv2ion , hv2la
      common/hv2ion/ hv2ion(limelm,limelm) , hv2la(limelm,limelm)
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      real vyield
      integer nyield
*     block data of yields from Mewe paper
*     vyield( nelem, nstage, nshell, nelec )
*     nelem is element number, 6 for carbon
*     nstage is stage of ionization, 1 for atom
*     nshell is shell number in dima notation
*     nelec is fraction that yield that number of electrons
**    nyield is number of electrons at most
      common/yield/ vyield(30,30,7,10), nyield(30,30,7)
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer n , ion, ns , i
*
      do n=1,limelm
        do ion=1,n
          do ns=1,nsShells(n,ion)
            write(io,'(3i3,1p,2e9.2,0p,10f5.2)')
     1      n,ion,ns,PhotoRate(n,ion,ns,1),
     1      PhotoRate(n,ion,ns,2),(vyield(n,ion,ns,i),i=1,
     1      nyield(n,ion,ns))
          end do
        end do
      end do
*
      end
****************************************************************************
      subroutine PunHeat( io )
      implicit none
*punch contributors to local heating, with punch heat command
      integer io
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      integer ncolnt
      parameter (ncolnt=10 000)
      integer limelm
      parameter (limelm=30)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgTeFail
*set true in IONTE if heating - cooling failure
      common/tfail/ lgTeFail
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      character chIonStage*4
      common/IonStage/ chIonStage(limelm+1)
      real WeakHeatCool
*     threshold for faintest cooling or heating to be punched
*     default is set to 0.05 in scalar, can be reest with 'set weakheatcool',
      common/WkHtCl/ WeakHeatCool
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer iplim
      parameter ( iplim=9)
      real TauIn , Pump , EscP , CS
      character chLineLbl*10 , chLbl*10 , chLabel(iplim)*4
      integer i , j, k,ipsave(iplim),jpsave(iplim) , ipnt,
     1 level , ipStrong
      real save(iplim) , Strong , ColHeat
      logical lgHeatLine
*
      ipnt = 0
      do i=1,limelm
        do j=1,limelm
*         WeakHeatCool set with 'set weakheatcool' command
*         default is 0.05
          if( heating(i,j)/htot.gt.WeakHeatCool ) then
            ipnt = min( iplim , ipnt + 1 )
            ipsave(ipnt) = i
            jpsave(ipnt) = j
            save(ipnt) = heating(i,j) / htot
          endif
        end do
      end do
*
*     now check for possible line heating not counted in 1,23
*     there should not be any significant heating source heree
*     since they would not be counted in deriv correctly
      do i=1,ncltot
        if( heatnt(i)/htot.gt.WeakHeatCool) then
*         ipnt = min( iplim , ipnt + 1 )
*         ipsave(ipnt) = -1
*         jpsave(ipnt) = i
*         save(ipnt) = heatnt(i) / htot
          j = collam(i)
*         force to save wavelength convention as printout
          if( j.gt. 100 000 ) j = j / 10 000
          write(io,'('' Negative coolant was '',a4,i6,1p,e10.2)')
     1    chClntLab(i),j, heatnt(i)/htot
        endif
      end do
*
      if(lgTeFail) then
        write(io,'('' >>>>  A temperature failure occured.'')')
      end if
*
      do k=1,ipnt
*       generate labels that make sense in printout
        i = ipsave(k)
        j = jpsave(k)
        if( i.ge.j ) then
*         this is case of photoionization of atom or ion
          chLabel(k)(1:2) = chElementSym(i)
          chLabel(k)(3:4) = chIonStage(j)
        else if(i.eq.1 .and. j.eq.2 ) then
*         photoionization from all excited states of H
          chLabel(k) = 'Hn=2'
        else if(i.eq.1 .and. j.eq.4 ) then
*         collisional ionization of H from ground
          chLabel(k) = 'Hion'
        else if(i.eq.1 .and. j.eq.10 ) then
*         CO dissociation
          chLabel(k) = 'COds'
        else if(i.eq.1 .and. j.eq.12 ) then
*         free free heating
          chLabel(k) = 'H FF'
        else if(i.eq.1 .and. j.eq.13 ) then
*         heating line, that was supposed to cool
          chLabel(k) = 'Clin'
        else if(i.eq.1 .and. j.eq.14 ) then
*         grain photoionization
          chLabel(k) = 'dust'
        else if(i.eq.1 .and. j.eq.16 ) then
*         H- heating
          chLabel(k) = 'H-  '
        else if(i.eq.1 .and. j.eq.18 ) then
*         H2 dissociation
          chLabel(k) = 'H2ds'
        else if(i.eq.1 .and. j.eq.19 ) then
*         Compton recoil of bound electrons
          chLabel(k) = 'CBnd'
        else if(i.eq.1 .and. j.eq.20 ) then
*         Compton heating
          chLabel(k) = 'Comp'
        else if(i.eq.1 .and. j.eq.23 ) then
*         line heating
          chLabel(k) = 'line'
        else if(i.eq.1 .and. j.eq.24 ) then
*         hydrogen line heating
          chLabel(k) = 'Hlin'
        else if(i.eq.2 .and. j.eq.4 ) then
*         helium triplet line heating
          chLabel(k) = 'He3l'
        else
          write(chLabel(k),'(2i2)') i,j
        endif
      end do
      write(io,'(i4,1p,2e9.2,0p,9(1x,a4,f6.3))')
     1nzone,htot,ctot,(chLabel(i),save(i),i=1,ipnt)
*
*     a negative pointer in the heating array is probably a problem,
*     indicating that some line has become a heat source
*
      lgHeatLine = .false.
*     check if any lines were major heat sources
      do i=1,ipnt
*       heating(1,23) is line heating - identify line if important
        if( ipsave(i).eq.1 .and. jpsave(i).eq.23 ) lgHeatLine = .true.
      end do
*
      if( lgHeatLine ) then
*       a line was a major heat source - identify it
        call FndLineHt( level, ipStrong , Strong )
        if( Strong/htot.gt.0.005 ) then
          if( level.eq.1 ) then
            chLbl =  chLineLbl(TauLines(1,ipStrong))
            TauIn = TauLines(ipLnTauIn,ipStrong)
            Pump = TauLines(ipLnPump,ipStrong)
            EscP = TauLines(ipLnEscP,ipStrong)
            CS = TauLines(ipLnCS,ipStrong)
*           ratio of line to total heating
            ColHeat = TauLines(ipLnHeat,ipStrong)/htot
          else if( level.eq.2 ) then
            chLbl =  chLineLbl(WindLine(1,ipStrong))
            TauIn = WindLine(ipLnTauIn,ipStrong)
            Pump = WindLine(ipLnPump,ipStrong)
            EscP = WindLine(ipLnEscP,ipStrong)
            CS = WindLine(ipLnCS,ipStrong)
            ColHeat = WindLine(ipLnHeat,ipStrong)/htot
          else
            write(qq,'('' PunHeat insane level'',i4)')level
            stop
          endif
          write(io,'(1X,'' LHeat lv'',i2,1x,a10,'' TIn'',1p,e10.2,
     1    '' Pmp'',e9.1,'' EscP'',e9.1,'' CS'',e9.1,'' Hlin/tot'',
     1    e10.2)')
     1    level , chLbl, TauIn , Pump , EscP , CS,ColHeat
        endif
      endif
*
      end
******************************************************************************
      subroutine punlin( ip , chDo , lgLog3 )
      implicit none
*parse punch lines command, or actually do the punch output
      integer ip
      character*4 chDo
      logical lgLog3
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     this variable controls how many lines can be saved, but it only appears
      integer npunlm
      parameter (npunlm=15)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real a(32) , fread ,emiss , absint , relint
      integer i
      character*80 chCard , chCap
      logical lgEOF , lgEOL , lgOK , lgRelhld
      integer lampn(npunlm),nlpun
      double precision savlum(npunlm) , dlum(npunlm)
      character*4 chPLab(npunlm)
      save lampn , nlpun , chPLab , savlum , lgRelhld
*
      if( chDo.eq.'READ' ) then
        lgRelhld = lgLog3
*       this call, read in lines
        nlpun = 0
*
*     >>chng 97 june 15, get rid of go to
        call readar( chCard , lgEOF )
        chCap = chCard
        call caps( chCap )
        if( lgEOF ) then
          write(qq,'('' Hit EOF while reading line list; use END to'',
     1    '' end list.'')')
          stop
        endif
        do while( chCap(1:3).ne.'END' )
          nlpun = nlpun + 1
          if( nlpun.gt.npunlm ) then
            write(qq,'('' Too many lines have been entered; the '',
     1      I4,''limit is.  Increase variable NPUNLM.'')') npunlm
            stop
          endif
*
*         order on line is label (col 1-4), wavelength
          chPLab(nlpun) = chCard(1:4)
          i = 5
          lampn(nlpun) = fread( chCard , i , 76 , lgEOL )
          savlum(nlpun) = 0.
          call readar( chCard , lgEOF )
          chCap = chCard
          call caps( chCap )
          if( lgEOF ) then
            write(qq,'('' Hit EOF while reading line list; use END to'',
     1      '' end list.'')')
            stop
          endif
*         go to999
        end do
*
        write(ip,'(I4,'' lines were entered, they were;'')') nlpun
        do i=1,nlpun
          write(ip,'(A4,I5)') chPLab(i),lampn(i)
        end do
*
      else if( chDo.eq.'PUNS' ) then
*       punch lines structure command
        do i=1,nlpun
          call cdEms( chPLab(i) , lampn(i) , emiss,lgOK )
          if ( lgOK ) then
            dlum(i) = emiss
          else
            write(qq,'('' PUNLIN could not fine line: '',A4,I5)')
     1      chPLab(i) , lampn(i)
            stop
          endif
        end do
        write(ip,'(1p,11e12.4)') depth-drad/2. , (dlum(i),i=1,nlpun)
*
      else if( chDo.eq.'PUNC' ) then
*       punch lines cumulative command
        do i=1,nlpun
          if( lgRelhld ) then
            call cdLine( chPLab(i),lampn(i),a(i),absint,lgOK )
          else
            call cdLine( chPLab(i),lampn(i),relint,a(i),lgOK )
          endif
          if ( .not.lgOK ) then
            write(qq,'('' PUNLIN could not fine line: '',A4,I5)')
     1      chPLab(i) , lampn(i)
            stop
          endif
        end do
        write(ip,'(1p,11e12.4)') depth-drad/2. , (a(i),i=1,nlpun)
*
      else
        write(qq,'('' unrecognized key for PUNLIN='',A4)') chDo
        stop
      endif
*
      end
******************************************************************************
      subroutine PunOpac( lunit , np )
      implicit none
*punch total opacity in any element, punch opacity command
*     lunit is io unit number, np is pointer within stack of punches
      integer lunit , np
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limpun
      parameter (limpun=20 )
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      character*4 chOpcTyp
*     which opacity to punch out
      common/optype/ chOpcTyp
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer KshellLimit
      real EnergyKshell
      common/KshllEnr/ KshellLimit , EnergyKshell
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real opac
      common/opac/ opac(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real pca2ex
      common/pca2ex/ pca2ex
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      integer iophe1
      common/iophe1/ iophe1(9)
      integer iophe2
      common/iophe2/ iophe2(9)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      integer iphop
      common/iphop/ iphop(lmhlvl)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
      integer in1(3)
      real p2nit
      common/nitexc/ p2nit , in1
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      integer ipPnunit , npunch
      real punarg
*     ipPnunit is io unit number, number of punch commands eneterd
*     punarg is set of optional arguments for the punch command
      common/pnunit/ ipPnunit(limpun) , npunch , punarg(limpun,3)
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , j , ilow , nelem,ion,ipS
      double precision ener , ener3
*
*     free statement labels  => 31
*
*     total opacity
      if( chOpcTyp.eq.'TOTL' ) then
        write(lunit,'(1p,5e12.4,1x,a4)') (anu(j),
     1  (opac(j)+scatop(j)),opac(j),scatop(j),
     2  scatop(j)/max(1e-37,scatop(j)+opac(j)),chContLabel(j),j=1,nflux)
*
*     subshell photo cross sections
      else if( chOpcTyp.eq.'SHEL' ) then
        nelem = punarg(np,1)
        ion = punarg(np,2)
        ipS = punarg(np,3)
        do i=ipElement(nelem,ion,ipS,1),ipElement(nelem,ion,ipS,2)
          write(lunit,'(1p,2e11.3)') anu(i),
     1    OpacStack( i-ipElement(nelem,ion,ipS,1)+
     2    ipElement(nelem,ion,ipS,3))
        end do
*
*     figure for hazy
      else if( chOpcTyp.eq.'FIGU' ) then
        do i=ipHn(1),nhe1(1)-1
          ener = anu(i)* 0.01356
          ener3 = 1e24 * ener**3
          write(lunit,'(1p,5e12.4)') anu(i),ener,
     1    OpacStack(i-ipHn(1)+iphop(1))*ener3,
     1    0.,opac(i)/hden*ener3
        end do
        do i=nhe1(1),nupper
          ener = anu(i)* 0.01356
          ener3 = 1d24 * ener**3
          write(lunit,'(1p,5e12.4)') anu(i),ener,
     1    OpacStack(i-ipHn(1)+iphop(1))*ener3,
     2    OpacStack(i-nhe1(1)+iophe1(1))*ahe/hden*ener3,
     3    opac(i)/hden*ener3
        end do
*
*     hydrogen
      else if( chOpcTyp.EQ.'HYDR' ) then
        call opacz
        call opinb( iphop(1), ipHn(1) , nupper , 1. , 0. )
        ilow = ipHeavy(1,1)
        write(10+1,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1  j=ilow,nupper)
        stop
*
*     helium
      else if( chOpcTyp.EQ.'HELI' ) then
        call opacz
        call opinb( iophe1(1) , nhe1(1) , nflux , 1. , 0.)
        ilow = ipHeavy(2,1)
        write(10+1,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1  j=ilow,nupper)
        call opacz
        call opinb( iophe2(1), nhe2(1) , nupper   , 1. , 0. )
        ilow = ipHeavy(2,2)
        write(10+2,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1  j=ilow,nupper)
        stop
*
*     lithium
      else if( chOpcTyp.eq.'LITH' ) then
        do i=1,3
          do j=1,3
            xIonFracs(3,j) = 0.
          end do
          xIonFracs(3,i) = 1.
          call opacz
          call PutOpacity( 3)
          ilow = ipHeavy(3,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
         end do
        stop
*
*     beryllium
      else if( chOpcTyp.eq.'BERY' ) then
        do i=1,4
          do j=1,4
            xIonFracs(4,j) = 0.
          end do
          xIonFracs(4,i) = 1.
          call opacz
          call PutOpacity( 4)
          ilow = ipHeavy(4,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
         end do
        stop
*
*     boron
      else if( chOpcTyp.eq.'BORO' ) then
        do i=1,5
          do j=1,5
            xIonFracs(5,j) = 0.
          end do
          xIonFracs(5,i) = 1.
          call opacz
          call PutOpacity( 5)
          ilow = ipHeavy(5,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
         end do
        stop
*
*     carbon
      else if( chOpcTyp.eq.'CARB' ) then
        do i=1,6
          do j=1,6
            xIonFracs(6,j) = 0.
          end do
          xIonFracs(6,i) = 1.
          call opacz
          call PutOpacity( 6)
          ilow = ipHeavy(6,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     nitrogen
      else if( chOpcTyp.eq.'NITR' ) then
        p2nit = 0.
        do i=1,7
          do j=1,7
            xIonFracs(7,j) = 0.
          end do
          xIonFracs(7,i) = 1.
          call opacz
          call PutOpacity( 7)
          ilow = ipHeavy(7,i)
          write(10+i,'(1P,2E10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     oxygen
      ELSE IF( chOpcTyp.EQ.'OXYG' ) THEN
        do i=1,8
          do j=1,8
            xIonFracs(8,j) = 0.
          end do
          xIonFracs(8,i) = 1.
          call opacz
          call PutOpacity( 8)
          ilow = ipHeavy(8,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        STOP
*
*     fluorine
      ELSE IF( chOpcTyp.EQ.'FLUO' ) THEN
        do i=1,9
          do j=1,9
            xIonFracs(9,j) = 0.
          end do
          xIonFracs(9,i) = 1.
          call opacz
          call PutOpacity( 9)
          ilow = ipHeavy(9,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
         end do
        STOP
*
*     neon
      ELSE IF( chOpcTyp.EQ.'NEON' ) THEN
        do i=1,10
          do j=1,10
            xIonFracs(10,j) = 0.
          end do
          xIonFracs(10,i) = 1.
          call opacz
          call PutOpacity( 10)
          ilow = ipHeavy(10,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     sodium
      else if( chOpcTyp.EQ.'SODI' ) theN
        do i=1,11
          do j=1,11
            xIonFracs(11,j) = 0.
          end do
          xIonFracs(11,i) = 1.
          call opacz
          call PutOpacity( 11)
          ilow = ipHeavy(11,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     magnesium
      else if( chOpcTyp.eq.'MAGN' ) then
        do i=1,12
          do j=1,12
            xIonFracs(12,j) = 0.
          end do
          xIonFracs(12,i) = 1.
          call opacz
          call PutOpacity( 12)
          ilow = ipHeavy(12,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     aluminium
      ELSE IF( chOpcTyp.EQ.'ALUM' ) THEN
        do i=1,13
          do j=1,12
            xIonFracs(13,j) = 0.
          end do
          xIonFracs(13,i) = 1.
          call opacz
          call PutOpacity( 13)
          ilow = ipHeavy(13,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        STOP
*
*     silicon
      ELSE IF( chOpcTyp.EQ.'SILI' ) THEN
        do i=1,14
          do j=1,14
            xIonFracs(14,j) = 0.
          end do
          xIonFracs(14,i) = 1.
          call opacz
          call PutOpacity( 14)
          ilow = ipHeavy(14,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     phosphorus
      ELSE IF( chOpcTyp.EQ.'PHOS' ) THEN
        do i=1,15
          do j=1,15
            xIonFracs(15,j) = 0.
          end do
          xIonFracs(15,i) = 1.
          call opacz
          call PutOpacity( 15)
          ilow = ipHeavy(15,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     sulfur
      ELSE IF( chOpcTyp.EQ.'SULF' ) THEN
        do i=1,16
          do j=1,16
            xIonFracs(16,j) = 0.
          end do
          xIonFracs(16,i) = 1.
          call opacz
          call PutOpacity( 16)
          ilow = ipHeavy(16,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     chlorine
      ELSE IF( chOpcTyp.EQ.'CHLO' ) THEN
        do i=1,17
          do j=1,17
            xIonFracs(17,j) = 0.
          end do
          xIonFracs(17,i) = 1.
          call opacz
          call PutOpacity( 17)
          ilow = ipHeavy(17,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     argon
      ELSE IF( chOpcTyp.EQ.'ARGO' ) THEN
        do i=1,18
          do j=1,18
            xIonFracs(18,j) = 0.
          end do
          xIonFracs(18,i) = 1.
          call opacz
          call PutOpacity( 18)
          ilow = ipHeavy(18,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        STOP
*
*     potassium
      ELSE IF( chOpcTyp.EQ.'POTA' ) THEN
        do i=1,19
          do j=1,19
            xIonFracs(19,j) = 0.
          end do
          xIonFracs(19,i) = 1.
          call opacz
          call PutOpacity( 19)
          ilow = ipHeavy(19,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     calcium
      ELSE IF( chOpcTyp.EQ.'CALC' ) THEN
        pca2ex = 0.
        do i=1,20
          do j=1,20
            xIonFracs(20,j) = 0.
          end do
          xIonFracs(20,i) = 1.
          call opacz
          call PutOpacity( 20)
          ilow = ipHeavy(20,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        STOP
*
*     scandium
      else if( chOpcTyp.eq.'SCAN' ) theN
        do i=1,21
          do j=1,21
            xIonFracs(21,j) = 0.
          end do
          xIonFracs(21,i) = 1.
          call opacz
          call PutOpacity( 21)
          ilow = ipHeavy(21,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     titanium
      else if( chOpcTyp.EQ.'TITA' ) THEN
        do i=1,22
          do j=1,22
            xIonFracs(22,j) = 0.
          end do
          xIonFracs(22,i) = 1.
          call opacz
          call PutOpacity( 22)
          ilow = ipHeavy(22,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     vanadium
      ELSE IF( chOpcTyp.EQ.'VANA' ) THEN
        do i=1,23
          do j=1,23
            xIonFracs(23,j) = 0.
          end do
          xIonFracs(23,i) = 1.
          call opacz
          call PutOpacity( 23)
          ilow = ipHeavy(23,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     chromium
      ELSE IF( chOpcTyp.EQ.'CHRO' ) THEN
        do i=1,24
          do j=1,24
            xIonFracs(24,j) = 0.
          end do
          xIonFracs(24,i) = 1.
          call opacz
          call PutOpacity( 24)
          ilow = ipHeavy(24,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     manganese
      ELSE IF( chOpcTyp.EQ.'MANG' ) THEN
        do i=1,25
          do j=1,25
            xIonFracs(25,j) = 0.
          end do
          xIonFracs(25,i) = 1.
          call opacz
          call PutOpacity( 25)
          ilow = ipHeavy(25,i)
          WRITE(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     iron
      else if( chOpcTyp.eq.'IRON' ) then
        do i=1,26
          do j=1,26
            xIonFracs(26,j) = 0.
          end do
          xIonFracs(26,i) = 1.
          call opacz
          call PutOpacity( 26)
          ilow = ipHeavy(26,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     cobalt
      else if( chOpcTyp.eq.'COBA' ) then
        do i=1,27
          do j=1,27
            xIonFracs(27,j) = 0.
          end do
          xIonFracs(27,i) = 1.
          call opacz
          call PutOpacity( 27)
          ilow = ipHeavy(27,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     nickel
      else if( chOpcTyp.eq.'NICK' ) then
        do i=1,28
          do j=1,28
            xIonFracs(28,j) = 0.
          end do
          xIonFracs(28,i) = 1.
          call opacz
          call PutOpacity( 28)
          ilow = ipHeavy(28,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     copper
      else if( chOpcTyp.eq.'COPP' ) then
        do i=1,29
          do j=1,29
            xIonFracs(29,j) = 0.
          end do
          xIonFracs(29,i) = 1.
          call opacz
          call PutOpacity( 29)
          ilow = ipHeavy(29,i)
          write(10+i,'(1p,2e10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
*     zinc
      else if( chOpcTyp.eq.'ZINC' ) then
        do i=1,30
          do j=1,30
            xIonFracs(30,j) = 0.
          end do
          xIonFracs(30,i) = 1.
          call opacz
          call PutOpacity( 30)
          ilow = ipHeavy(30,i)
          write(10+i,'(1P,2E10.3)') (anu(j)*13.6,opac(j)/1e-18,
     1    j=ilow,KshellLimit)
        end do
        stop
*
      else
        write(qq,'('' UNIDENTIFIED OPACITY KEY='',A4)') chOpcTyp
        stop
      endif
*
      end
******************************************************************************
      subroutine PunResult( io , chLab, LineWL, xInten , chFunction )
      implicit none
*produce output for the punch results and punch line intensity commands
      integer io , LineWL
      real xInten
      character chLab*4 , chFunction*5
*
      character chPunRltType*6
*set with punch line intensites and punch results commands,
*says whether results arrays produced by routine PunResult should
*be column or array
      common/PunRltType/ chPunRltType
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer LineWidth
*     if LineWidth is changed then change format in write too
      parameter (LineWidth=6)
      character chLabSave(LineWidth)*4
      integer LineSave(LineWidth)  ,  ipLine , i
      real xIntenSave(LineWidth)
      save chLabSave , LineSave, xIntenSave ,  ipLine
*
      if( chFunction.eq.'Start' ) then
      ipLine = 0
      else if( chFunction.eq.'Line ' ) then
        ipLine = ipLine + 1
        LineSave(ipLine) = LineWL
        chLabSave(ipLine) = chLab
        xIntenSave(ipLine) = xInten
        if( ipLine.eq.LineWidth ) then
          if( chPunRltType.eq.'array ' ) then
*           usual array 6 wide
            write(io,'(6(1x,a4,i6,1p,e10.3))') (chLabSave(i) ,
     1      LineSave(i) , xIntenSave(i),i=1,ipLine)
          else if( chPunRltType.eq.'column' ) then
*           single column for input into data base
            write(io,'(1x,a4,i6,1p,e10.3)') (chLabSave(i) ,
     1      LineSave(i) , xIntenSave(i),i=1,ipLine)
          else
            write(qq,'('' PunResult called with insane chPunRltType='',
     1      a6)') chPunRltType
          endif
          ipLine = 0
        endif
      else if( chFunction.eq.'Flush' ) then
        if( ipLine.gt.0 ) then
          if( chPunRltType.eq.'array ' ) then
*           usual array 6 wide
            write(io,'(6(1x,a4,i6,1p,e10.3))') (chLabSave(i) ,
     1      LineSave(i) , xIntenSave(i),i=1,ipLine)
          else if( chPunRltType.eq.'column' ) then
*           single column for input into data base
            write(io,'(1x,a4,i6,1p,e10.3)') (chLabSave(i) ,
     1      LineSave(i) , xIntenSave(i),i=1,ipLine)
          else
            write(qq,'('' PunResult called with insane chPunRltType='',
     1      a6)') chPunRltType
          endif
        endif
      else
        write(qq,'('' PunResult called with insane request='',a5)')
     1  chFunction
        stop
      endif
*
      end
*********************************************************************
      subroutine PunSpec( io , chTime )
      implicit none
*generate output for the punch special command
      integer io
      character chTime*4
*
      if( chTime.eq.'LAST' ) then
*       code to execute only after last zone
        write(io,'('' this is last zone output'')')
      else
*       code to execute after every zone
        write(io,'('' this is every zone output'')')
      endif
*
      end
******************************************************************************
      subroutine punt(chType)
      implicit none
*produce map of heating-cooling space for specified zone
      character chType*4
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer ncolnt
      parameter (ncolnt=10 000)
      integer mapdim
      parameter (mapdim=102)
      integer limelm
      parameter (limelm=30)
      integer MapZone , nMapStep
      real RangeMap
*parameters doing with map command, MapZone is zone number,
* -1 for very start
* RangeMap is range, parsed from same command
* nMapStep is number of steps, set with set nmap command
      common/MapPar/ MapZone , RangeMap(2), nMapStep
      logical lgCNegChk
*flag set true during cooling map, saying to keep cool even
*if cooling is negative
      common/cnegtk/ lgCNegChk
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real telow , tehigh
*     this is the default lowest to highest temperature checked
      common/telow/ telow , tehigh
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      logical lgTeHigh
*flag set if temperature map is from hot to cool, set with high command
      common/thigh/ lgTeHigh
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real tused,tfound
      common/tion/ tused,tfound
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real te , eden , hden
      common/phycon/ te , eden , hden
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      real hi , hii
      common/h/ hi , hii
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      integer nmap
      real temap , hmap , cmap
      common/mapr/ nmap , temap(mapdim) , hmap(mapdim) , cmap(mapdim)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character*4 chLabel , units*1
      real eps,t1,torg,xx,TotalPressure,ratio,fac,factor,tmax,tmin,
     1 tlowst,oldch,dc,strong,strhet,ch,hfrac,cfrac
      integer k,j,ih,jh,l
      integer i , loop
      parameter (eps=0.005)
*
*     free statement labels >=6
*
      t1 = te
      torg = te
*     make sure pressure has been evaluated
      xx = TotalPressure()
*
*     print out all coolants if all else fails
      if( lgTalk ) then
        write(qq,'('' Cloudy punts, Te='',1P,E10.3,'' HTOT='',E10.3,
     1  '' CTOT='',E10.3,'' nzone='',i4)') te , htot , ctot,nzone
        write(qq,'('' COOLNG array is'')')
*
        if( ctot.gt.0. )  then
          call coolpr( 'ZERO' ,1,  0. , eps )
          do i=1,ncltot
            ratio = cooling(i) / ctot
            call coolpr( chClntLab(i) , collam(i), ratio , eps )
          end do
          call coolpr( 'DONE', 1 , 0. , eps )
          write(qq,'('' Line heating array follows'')')
          call coolpr( 'ZERO' ,1,  0. , eps )
          do i=1,ncltot
            ratio = heatnt(i) / ctot
            call coolpr( chClntLab(i) , collam(i), ratio , eps )
          end do
          call coolpr( 'DONE', 1 , 0. , eps )
        endif
      endif
*
*     map out te-ionization-cooling space before punching out.
      if( lgTalk ) then
        write(qq,'(4X,''Te'',5X,''Heat'',19(''-''),''> Cool'',
     1  22(''-''),''>'',4x,''dH/dT'',4X,''dC/DT'',4X,
     1  3X,''Ne'',9X,''NH'',6X,''HII'',7X,''Helium '')')
      endif
*
      if( chType.eq.'punt') then
*       this is the original use of punt, we are punting
*       only map within factor of two of final temperature
*       fac will the range to either side of punted temperature
        fac = 1.5
        tmin = torg / fac
        tmax = torg * fac
*       we want about 20 steps between high and low temperature
*       default of nMapStep is 20, set with set nmaps command
        factor = 10.**(log10(tmax/tmin)/float(nMapStep) )
        te = tmin
      else if( chType.eq.' map' ) then
*       create some sort of map of heating-cooling
        tlowst = max( RangeMap(1) , telow)
        tmin = tlowst * 0.998
        tmax = min( RangeMap(2) , tehigh ) * 1.002
*       we want about nMapStep (=20) steps between high and low temperature
        factor = 10.**(log10(tmax/tmin)/float(nMapStep))
        if( lgTeHigh ) then
*         high te
          factor = 1. / factor
*         TEHIGH is highest possible temperature, 1E10
          te = min( RangeMap(2) , tehigh ) / factor
        else
*         low te
          te = tlowst / factor
        endif
      else
*       don't know what to do
        write(qq,'('' PUNT called with insane argument,='',A4)') chType
        stop
      endif
*
      lgCNegChk = .false.
      nmap = 0
      oldch = 0.
      te = te * factor
      do while( te.lt.tmax*0.999 .and. te.gt.tmin*1.001 )
        nmap = min( mapdim , nmap + 1 )
        xx = TotalPressure()
        call nsset
        lgNewIon = .true.
        call cholup( dc , loop )
        temap(nmap) = te
        cmap(nmap) = ctot
        hmap(nmap) = htot
        strong = 0.
        do j=1,ncltot
          if( cooling(j) .gt. strong ) then
            chLabel = chClntLab(j)
            strong = cooling(j)
            l = collam(j)
          endif
        end do
        cfrac = strong / ctot
        strhet = 0.
        do k=1,limelm
          do j=1,limelm
            if( heating(k,j).gt.strhet ) then
              strhet = heating(k,j)
              ih = k
              jh = j
            endif
          end do
        end do
        ch = ctot - htot
*       use ratio to check for change of sign since product
*       can underflow at low densities
        if( oldch/ch.lt.0..and. lgTalk ) then
          write(qq,'(1X,47(''-''),'' Probable thermal solution'',
     1    '' here. '',44(''-''))')
        endif
        oldch = ch
        hfrac = strhet / htot
        if( lgTalk ) then
*         convert to micros if IR transition
          if( l.lt.100 000. ) then
            units = 'A'
          else
            l = l / 1e4
            units = 'm'
          endif
          if( lgTrace )write(qq,'(''TRACE: te, htot, ctot'',1p,3e11.3)')
     1    te,htot,ctot
          write(qq,'(1P,e10.4,E11.4,2I4,0P,F6.3,1P,E11.4,1X,A4,1X,I4,a1,
     1    0P, F6.3,1P,2e10.2,2E11.4,0P,4F6.2)')
     1    te,htot,ih,jh,hfrac,ctot,chLabel,l,units,cfrac,dHTotDT,dc,
     1    eden, hden,log10(max(1e-9,hii/hden)) ,
     1    log10(max(1e-9,hei/ahe)),
     1    log10(max(1e-9,heii/ahe)),log10(max(1e-9,heiii/ahe))
        endif
        te = te * factor
      end do
*
      lgCNegChk = .true.
      te = t1
*
      end
******************************************************************************
      subroutine PutCS( cs , tarray )
      implicit none
*enter a collision strength into an individual line vector
      real cs
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*
*     local variables
*
*     routine to stuff collision strength cs into tarray
*
*begin sanity check
      if( cs.le.0. ) then
        write(qq,'('' PutCS called with insane collision strength,='',
     1  1p,e10.2)') cs
        call DumpLine( tarray )
        call ShowMe
        stop
      endif
*end sanity check
*
      tarray( ipLnCS ) = cs
*
      end
******************************************************************************
      subroutine PutExtra( Extra )
      implicit none
*enter and 'extra' intensity source for some line
      real Extra
      real ExtraInten
*extra intensity to be added to lines
      common/ExtrIntn/ ExtraInten
*
      ExtraInten = Extra
*
      end
******************************************************************************
      subroutine PutHetCol( te , htot , ctot )
      implicit none
*save heating, cooling, and temperature in stack for numerical derivatives
      real te , htot , ctot
      integer nGrid
      parameter (nGrid=100)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real TeGrid(nGrid) , HtGrid(nGrid) , ClGrid(nGrid)
      integer ipGrid , nZonGrid(nGrid)
      common/HeatCool/ TeGrid , HtGrid , ClGrid , ipGrid, nZonGrid
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      if( nzone.eq.0 ) then
*       code is searching for first temp now - do not remember these numbers
        ipGrid = 0
      else
        ipGrid = ipGrid + 1
        if( ipGrid.gt.nGrid ) ipGrid = 1
*begin sanity checks
        if(ipGrid.le.0 .or. ipGrid.gt.nGrid ) then
          write(qq,'('' PutHetCol has insane ipGrid'',i5)')ipGrid
          call ShowMe
        endif
        if(nzone.le.0 ) then
          write(qq,'('' PutHetCol has insane nzone'',i5)')nzone
          call ShowMe
        endif
*end sanity checks
        TeGrid(ipGrid) = te
        HtGrid(ipGrid) = htot
        ClGrid(ipGrid) = ctot
        nZonGrid(ipGrid) = nzone
      endif
*
      end
******************************************************************************
      subroutine PutLine( tarray )
      implicit none
*enter local line intensity into the intensity stack for eventual printout
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
*
      integer limelm
      parameter (limelm=30)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      real ExtraInten
*extra intensity to be added to lines
      common/ExtrIntn/ ExtraInten
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
*
*     local variables
      character chLabel*4 , chIonLbl*4
      real xIntensity
      integer iWavLen
*
*     routine to use line array data to generate input
*     for emission line array
*
*     subroutine linadd(xIntensity , lam , chLab , chInfo)
*     real f
*     integer lam
*     character chLab*4 , chInfo*1
*
*     if ipass=0 then we must generate label info since first pass
*     gt.0 then only need line intensity data
      if( ipass.eq.0 ) then
*       these variables not used by linadd if ipass ne 0
        chLabel = chIonLbl( tarray )
        iWavLen = tarray( ipLnWlAng )
*       NB - following must be kept parallel with logic in setline and pldata
        if(iWavLen.gt.1 000 000 ) then
          iWavLen = iWavLen / 10000
        else if(iWavLen.gt.10 000 ) then
          iWavLen = iWavLen / 1000
        else if( iWavLen.lt.10 ) then
          iWavLen = tarray( ipLnWlAng ) * 10.
        endif
*       line energy in rydbergs
        xLineEnergy(nsum+1) = tarray(ipLnRyd)
      else
        chLabel = '    '
        iWavLen = 0
      endif
*
*     total line intensity or luminosity
      xIntensity = tarray( ipLnInten ) + ExtraInten
*     ExtraInten is option that allows extra intensity (i.e., recomb)
*     to be added to this line  with Call PutExtra( exta )
*     in main lines this extra
*     contribution must be identified explicitly
      ExtraInten = 0.
      call linadd(xIntensity , iWavLen , chLabel(1:4) , 'i')
*
*     inward part of line - do not move this away from previous lines
*     since xIntensity is used here
      xIntensity = tarray( ipLnInwd )* xIntensity
      call linadd(xIntensity , iWavLen , 'Inwd' , 'i')
*
*     cooling part of line
      xIntensity = tarray( ipLnCool )
      call linadd(xIntensity , iWavLen , 'Coll' , 'c')
*
*     fluorescent excited part of line
      xIntensity = tarray( ipLnPopOpc ) * tarray( ipLnPump ) *
     1  tarray( ipLnAovTOT ) * tarray( ipLnEnrErg )
      call linadd(xIntensity , iWavLen , 'Pump' , 'i')
*
*     heating part of line
      xIntensity = tarray( ipLnHeat )
      call linadd(xIntensity , iWavLen , 'Heat' , 'h')
*
      end
******************************************************************************
      subroutine PutOpacity( nelem )
      implicit none
*enter total photo cross section for all subshells into opacity array
      integer nelem
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
      integer ipElement(limelm,limelm,7,3)
*     first dim is atomic number of element
*     second dimension is ion stage, 1 for atom
*     third is shell, 1 for k shell, up to 7
*     last is 1 for pointer to energy of threshold
*     2 is highest energy for shell, set by LimitSh
*     3 is opacity offset
      common/ipElement/ ipElement
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nion,nshell,low,ihi,ipop
*     integer nelec
*
*     this routine drives opacin to put in total opacities
*
*begin sanity check
      if(nelem.lt.1 .or. nelem.gt.limelm ) then
        write(qq,'('' PutOpacity:  Insanity occurred.  nelem='',i4)')
     1  nelem
        call ShowMe
        stop
      endif
*end sanity check
*
*     this element may be turned off
      if( .not.lgElmtOn(nelem) ) return
*
      do nion=1,nelem
        if( xIonFracs(nelem,nion).gt.0. ) then
*         number of bound electrons
*         nelec = nelem - nion + 1
*         >>chng 96 Oct 1, get rid of nsElem, use master array
*         do nshell=1,nsElem(nion)
          do nshell=1,nsShells(nelem,nion)
*           set lower and upper limits to this range
            low = ipElement(nelem,nion,nshell,1)
            ihi = ipElement(nelem,nion,nshell,2)
            ipop = ipElement(nelem,nion,nshell,3)
            call opacin( ipop , low , ihi, xIonFracs(nelem,nion) )
          end do
        endif
      end do
*
      end
******************************************************************************
      subroutine qg32 (xl, xu, fct, y)
      implicit none
*32 point Gaussian quadrature, originally given to Gary F by Jim Lattimer
      real xl,xu,fct,y
      external fct
      real a,b,c
*
*******************************************************************************
*                                                                             *
*    32-point Gaussian quadrature.                                            *
*    xl  : the lower limit of integration                                     *
*    xu  : the upper limit                                                    *
*    fct : the (external) function                                            *
*    y   : the value of the integral                                          *
*                                                                             *
*******************************************************************************
*
      a = .5 * (xu + xl)
      b = xu - xl
      c = .498631930924740780       * b
      y = .35093050047350483e-2     * (fct (a + c) + fct (a - c))
      c = b * .49280575577263417
      y = y + .8137197365452835e-2  * (fct (a + c) + fct (a - c))
      c = b * .48238112779375322
      y = y + .1269603265463103e-1  * (fct (a + c) + fct (a - c))
      c = b * .46745303796886984
      y = y + .17136931456510717e-1 * (fct (a + c) + fct (a - c))
      c = b * .44816057788302606
      y = y + .21417949011113340e-1 * (fct (a + c) + fct (a - c))
      c = b * .42468380686628499
      y = y + .25499029631188088e-1 * (fct (a + c) + fct (a - c))
      c = b * .3972418979839712
      y = y + .29342046739267774e-1 * (fct (a + c) + fct (a - c))
      c = b * .36609105937014484
      y = y + .32911111388180923e-1 * (fct (a + c) + fct (a - c))
      c = b * .3315221334651076
      y = y + .36172897054424253e-1 * (fct (a + c) + fct (a - c))
      c = b * .29385787862038116
      y = y + .39096947893535153e-1 * (fct (a + c) + fct (a - c))
      c = b * .2534499544661147
      y = y + .41655962113473378e-1 * (fct (a + c) + fct (a - c))
      c = b * .21067563806531767
      y = y + .43826046502201906e-1 * (fct (a + c) + fct (a - c))
      c = b * .16593430114106382
      y = y + .45586939347881942e-1 * (fct (a + c) + fct (a - c))
      c = b * .11964368112606854
      y = y + .46922199540402283e-1 * (fct (a + c) + fct (a - c))
      c = b * .7223598079139825e-1
      y = y + .47819360039637430e-1 * (fct (a + c) + fct (a - c))
      c = b * .24153832843869158e-1
      y = b * (y + .482700442573639e-1 * (fct (a + c) + fct (a - c)))
*
      end
**************************************************************
      subroutine qheat1(ndust1,tmean,ted1)
      implicit none
*one of Kevin Volk's quantum heating routines for grains
      integer ndust1
      real tmean, ted1
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
      integer ndems
      parameter (ndems=50)
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real dsttmp , dstems , dstslp
      common/dustems/ dsttmp(ndems) , dstems(ndems,ndust) ,
     1 dstslp(ndems,ndust)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      logical lgDustBug
*flag set with trace grains command
      common/dstbug/ lgDustBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real bval(nqgrid,nqgrid),prob(nqgrid),u1(nqgrid)
      real aval(nqgrid),delu(nqgrid),tval(nqgrid) , qtmax1
      real corsav(ncell),conv,value,fract,x,convi
      integer j,k,l,i1,i
      logical lgHit
      real pmax,term,sum,sum1,umax,umin,ufunct,y,
     1 dintg,scale
*
      if( lgTrace.and.lgDustBug) then
        write(qq,'(''    qheat1 called grain'',i3)')
     1  ndust1
      endif
*
      scale=qhnrat(ndust1)/qdep(ndust1)
*
      do j=1,ncell
        corsav(j) = ContBoltz(j)
      end do
*
      conv=4.5911e+10
* conversion from ergs to rydberg energy units
      convi=1./conv
*
* total collisional heating in rydb/s/h atom
*          etot=qcu1/4.
*
*          do j=1,nflux
*          value=(flux(j)+otslin(j)+outcon(j)+otscon(j))*
*     c           dstab1(j,ndust1)*anu(j)
*          etot=etot+value*hden*dstAbund(j)
*          end do
*
*     do j=1,nflux-1
*     >>chng 97 july 17, restructure to get rid of go to
      qdudt0 = qcu1
      j = 1
      do while( anu(j).lt.qwavec )
*       if (anu(j).lt.qwavec) then
*         value = (flux(j)+otslin(j)+outcon(j)+otscon(j))*
*         >>chng 97 July 17, to summed continuum
          value = SummedCon(j) * dstab1(j,ndust1)*anu(j)
          qdudt0 = qdudt0+value*hden*4.
*       end if
        j = j + 1
      end do
*
*     j now points to above qwavec
      value = SummedCon(j) * dstab1(j,ndust1)*anu(j)
      fract = (qwavec-anu(j-1))/(anu(j)-anu(j-1))
      value = value*fract
      qdudt0 = qdudt0+value*hden*4. * dstAbund(ndust1)
*
*     >>chng 97 july 17, divide out variable abundances
      x =log10(convi*qdudt0/hden/dstAbund(ndust1) )
      call splint(dstems(1,ndust1),dsttmp,dstslp(1,ndust1),
     c            ndems,x,y)
      qtmin =10.**y
*
      qtmax1 =min(20.*ted1,qtmax)
      if (qtmin.gt.qtmax) then
* error condition -- set temperature to the equilibrium value and exit
          qhprob(ndust1,1)=1.0
          qtemp(ndust1,1)=ted1
*
          do j=2,nqhg1
            qtemp(ndust1,j)=ted1
            qhprob(ndust1,j)=1.e-08
          end do
*     >>chng 97 mar 1, had not returned anything
          tmean = ted1
          if( lgTrace.and.lgDustBug)
     1    write(qq,'(''    qheat1 error returns too hot'')')
*
          return
      end if
      x=log(qtmax1/qtmin)/float(nqhg1-1)
      i=0
      prob(1)=qdudt0*scale
      tval(1)=qtmin
      u1(1)=ufunct(qtmin,ndust1)
*
      do j=2,nqhg1
      tval(j)=qtmin*exp(x*float(j-1))
      prob(j)=4.*conv*dintg(tval(j),ndust1,i)*scale
      u1(j)=ufunct(tval(j),ndust1)
      end do
*
      delu(1)=u1(2)-u1(1)
      delu(nqhg1)=u1(nqhg1)-u1(nqhg1-1)
      bval(nqhg1-1,nqhg1)=prob(nqhg1)-prob(1)
*
      do j=2,nqhg1-1
      bval(j-1,j)=prob(j)-prob(1)
      delu(j)=(u1(j+1)-u1(j-1))/2.
      end do
*
      do j=1,nqhg1-1
        do k=j+1,nqhg1
          umin=u1(k)-delu(k)/2.-u1(j)
          umax=u1(k)+delu(k)/2.-u1(j)
          if (k.eq.nqhg1) umax=100000.
          call nphot(umin,umax,bval(k,j),ndust1)
        end do
      end do
*
      do k=1,nqhg1
        term =log10(tval(k))
* interpolate to find the energy loss value at t = tval(k)
*
        i1=0
        lgHit = .false.
        j = 1
        do while( .not.lgHit .and. j.lt.ndems )
*     >>chng 97 jan 3, by gjf, to get rid of statement number
*       do j=1,ndems-1
          if (term.gt.dsttmp(j).and.term.le.dsttmp(j+1)) then
            fract =(term-dsttmp(j))/(dsttmp(j+1)-dsttmp(j))
            value =dstems(j,ndust1)+fract*(dstems(j+1,ndust1)-
     c      dstems(j,ndust1))
            i1 = 1
            lgHit = .true.
          end if
          j = j + 1
        end do
*
        if (i1.eq.1) then
          aval(k) =scale*conv*(10.**value)
        else
          aval(k) =scale*conv*(10.**dstems(1,ndust1))
        end if
      end do
*
      do j=nqhg1,2,-1
        aval(j)=aval(j)-aval(1)
        aval(j)=delu(j)/aval(j)
      end do
*
      aval(1)=0.
*
      do j=1,nqhg1-2
        do k=nqhg1-1,j+1,-1
          bval(k,j)=bval(k,j)+bval(k+1,j)
        end do
      end do
*
      prob(1)=1.0
      pmax=1.0
      sum=prob(1)
*
      do k=2,nqhg1
        prob(k)=0.
        do j=1,k-1
          prob(k)=prob(k)+prob(j)*bval(k,j)
        end do
        prob(k)=prob(k)*aval(k)
        sum=sum+prob(k)
        if (prob(k).gt.pmax) pmax=prob(k)
        if (pmax.gt.1.e+06) then
          value=1./pmax
          do l=1,k
            prob(l)=prob(l)*value
          end do
          sum=sum*value
          pmax=1.0
        end if
      end do
*
      sum=1./sum
*
      do j=1,nqhg1
        prob(j)=prob(j)*sum
      end do
*
      sum=0.
      sum1=0.
*
      do j=1,nqhg1
        sum=sum+prob(j)
        sum1=sum1+prob(j)*(tval(j)**4)
      end do
*
      tmean=(sum1**0.25)
*
      do j=1,nqhg1
        qtemp(ndust1,j)=tval(j)
        qhprob(ndust1,j)=prob(j)
* debugging aid
*      write(42,398) qtemp(ndust1,j),qhprob(ndust1,j)
* 398  format(1x,0pf8.3,1x,1pe12.5)
      end do
      do j=1,ncell
        ContBoltz(j)=corsav(j)
      end do
*
      if( lgTrace.and.lgDustBug)
     1 write(qq,'(''    qheat1 returns'',1p,2e10.2)') tmean,ted1
*
      end
******************************************************************************
      subroutine radacl
      implicit none
*radiative acceleration due to incident continuum, calls forlin for lines
*used for wind solution derives AccelLine and AccelCont
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real opac
      common/opac/ opac(ncell)
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      real rforce , forlin
      integer i
*
      rforce = 0.
      do i=1,nflux
        rforce = rforce + (flux(i)+outlin(i)+outcon(i)) * anu(i)*
     1  (opac(i)+scatop(i))
      end do
*
*     radiative acceleration; xMassDensity is gm per cc, eval when PTOT called
      AccelLine = forlin() / 2.998e10 / xMassDensity
      AccelCont = rforce * en1ryd / 2.998e10 / xMassDensity
*
      end
******************************************************************************
      subroutine radi( chCard , ar1 )
      implicit none
*parse the radius command
      character chCard*80
      real ar1
*
      real parscl
      parameter (parscl=18.489396)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer nvary , nparm
      common/nvary/ nvary , nparm
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL , lgMatch , lgRLog , lgR2set
      real convl , fread , a
      integer i
*
*     log of inner and outer radii, default second=infinity,
*     if R2<R1 then R2=R1+R2
*     there is an optional keyword, "PARSEC" on the line, to use PC as units
      if( lgMatch( 'PARS' , chCard ) ) then
        convl = parscl
      else
        convl = 0.
      endif
*     if linear appears on line, then radius is linear, otherwise, log
      if( lgMatch( 'LINE' , chCard ) ) then
        lgRLog = .false.
      else
        lgRLog = .true.
      endif
*
      i = 5
      ar1 = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' There should have been a number on this line.'',
     1  ''  Sorry.'')')
        stop
      endif
*
*     option for linear or log radius
      if( lgRLog ) then
        ar1 = ar1 + convl
      else
        ar1 = log10( ar1) + convl
      endif
      radius = 10. ** ar1
*
*     check for second number, which indicates thickness of model
      a = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
*       not set
        lgR2set = .false.
      else
*       outer radius is set,
        lgR2set = .true.
*       log or linear option is still in place
        if( lgRLog ) then
          a = a + convl
        else
          a = log10( a) + convl
        endif
        a = 10. ** a
*       check whether it was thickness or outer radius
        if( a .gt. radius ) then
          router(1) = a - radius
        else
          router(1) = a
        endif
        do i=2,itrdim
          router(i) = router(1)
        end do
      endif
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
*       pointer to where to write
        nvfpnt(nparm) = nRead
        vincr(nparm) = 0.5
*
        if( lgR2set ) then
          chVarFmt(nparm) =
     1    '(''RADIUS='',F9.5,'' depth or outer R'',F9.5)'
          nvarxt(nparm) = 2
*         second number is thickness or outer radius
          vparm(nparm,2) = log10( router(1) )
        else
          chVarFmt(nparm) ='(''RADIUS='',F9.5)'
          nvarxt(nparm) = 1
        endif
*
*       log of radius is first number
        vparm(nparm,1) = log10( radius )
      endif
*
      end
*****************************************************************************
      subroutine radinc
      implicit none
*do work associated with geometry increments of this zone
      real pi
      parameter ( pi=3.141592654 )
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real SpeedLight
*from Physics Today Aug '96, BG 10
      parameter (SpeedLight=2.99792458E10 )
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real DiffCont
*diffus is local diffuse continuum, for current zone
      common/diffus/ DiffCont(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real tmn
      common/tmn/ tmn(ncell)
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      real e2TauAbs
*E2(tau) exponential integral
      common/e2tau/ e2TauAbs(ncell)
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
      real pnow , pcorec
      common/pnow/ pnow , pcorec
      real opac
      common/opac/ opac(ncell)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
*     these are the integrated absorption and scattering optical depths
*     to the illuminated face of the cloud
      real depabs , depsct
      common/deptau/ depabs(ncell) , depsct(ncell)
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real tcmptn , ttherm
      common/timesc/ tcmptn , ttherm
      real PressureInit
*     this is the total pressure at the illuminated face
      common/PresInit/ PressureInit
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real drNext
*next dr, as set in nextdr
      common/drnxt/ drNext
      real CrsSecNeutron
*cross section for stopping relativistic neutrons
      common/crsnut/ CrsSecNeutron
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      real r1r0sq
      common/r1r0sq/ r1r0sq
      logical lgScatON
*flag saying whether (true) or not (false) scattering opacity
*is enabled
      common/scaton/ lgScatON
      real hlmax
*     remember max photo rate for var h levels, by h lines
      common/hlmax/ hlmax(lmhlvl)
      real hcoldn , hbul , hradn
*save collision, induced, and spontaneous rates for levels from hydroen atom
      common/hcbr/ hcoldn(lmhlvl+1) , hbul(lmhlvl+1) , hradn(lmhlvl+1)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      logical lgUSphON
*lgUSphON flag set when we hit stromgren radius in spherical geometry
      real rstrom
      common/uspher/ lgUSphON , rstrom
      logical lgConBug
*flag set with trace continuum command
      common/conbug/ lgConBug
      logical lgNeutrnHeatOn
*flag lgNeutrnHeatOn says heating due to neutrons is enabled
*frcneu is fraction of total luminosity in neutrons, effneu is efficiency
*totneu is resulting total luminosity
      real frcneu , totneu , effneu
      common/neutrn/ frcneu , totneu , lgNeutrnHeatOn , effneu
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgOpacBug
*flag set with trace opacity
      common/opcbug/ lgOpacBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real hi , hii
      common/h/ hi , hii
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      double precision hlte
      real hc2p2se , hc2p2sp , hc2s1s
*hc2p2se and hc2p2sp are rates for 2s - 2s collisions with electrons and protons
*hlte is lte population of each level
      common/hcolrt/ hlte(lmhlvl+1) , hc2p2se , hc2p2sp , hc2s1s
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      integer ip374 , ip660
      common/pbowen/ ip374 , ip660
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      real the1lo
      integer nhe1lo
      common/the1lo/ the1lo , nhe1lo
      real the2lo
      integer nhe2lo
      common/the2lo/ the2lo , nhe2lo
      integer iphop
      common/iphop/ iphop(lmhlvl)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      real pinit , pinteg , pinzon
      common/pinteg/ pinit , pinteg , pinzon
      real dRadSign
*sign of dr for going in or out, 1 (usually) or -1
      common/drsign/ dRadSign
      logical lgEdenBad
      integer nzEdenBad
*some flags and counters set in radinc when bad electron density is detected
      common/ednbad/ lgEdenBad , nzEdenBad
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      logical lgOpacNeg
*flag set if negative opacities occured
      common/opcneg/ lgOpacNeg
      real ExpZone
*exp(-tau) for the current zone only
      common/facexp/ ExpZone(ncell)
      real EdenError
*     this is relative error in the electron density we want
*     set in block data to 0.01
*     reset with set EdenError command
      common/erredn/ EdenError
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real EdenTrue
*     this is the true eden as set in esum
*     we will try to converge eden to this
      common/TrueEden/ EdenTrue
      real plow , phi
*     keep trace of lowest and highest pressures in model
      common/prslim/ plow , phi
      real AngleIllum
*angle of illumination - actually 1./cos(normal), so > 1.
      common/Angllum/ AngleIllum
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      logical lgTeFail
*set true in IONTE if heating - cooling failure
      common/tfail/ lgTeFail
      integer nUnstable
      logical lgUnstable
*keep track of possibly thermall unstagle models
*nUnstable is number of zones that were possibly thermall unstable
*lgUnstable is set in ionte and says that current consitions possibly unstable
      common/nustbl/ nUnstable , lgUnstable
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,n
      real aa,rfac,rforce,escatc,tnew,sexp,
     1 flx,crs,hlrate , relec,e2,opfac,t,forlin
*     real bscat
      real dReffAver , drTau
      save dReffAver
      save rfac
      real scatsv(ncell) , tmnold
      logical lgFlxNeg
*---------------------------------------------------------------------
*
*     when this sub is called RADIUS is the outer edge of zone
*
      if( lgTrace ) write(qq,'('' radinc called; radius='',1P,E10.3,
     1'' rinner='',
     1E10.3,'' DRAD='',E10.3,'' drNext='',E10.3,'' ROUTER='',E10.3,
     2'' DEPTH='',E10.3)') radius,rinner,drad,drNext,router(iter),depth
*
*     check whether temp ever drops below lowest for matrix
      if( te.le.thlo ) nhlo = nhlo + 1
      if( te.le.the1lo ) nhe1lo = nhe1lo + 1
      if( te.le.the2lo ) nhe2lo = nhe2lo + 1
*
*     check cooling time for this zone, remember longest
      aa = ttherm
      ttherm = max( ttherm, 1.5*pden*Boltzmann*te/ctot)
*
*     keep track of high and low deviations of pressures
      plow = min( plow , (PressureInit+pinteg)/pnow )
      phi = max( phi , (PressureInit+pinteg)/pnow )
*
*     increment counter if this zone possibly thermally unstable
*     this flag was set in ionte, deriv of heating and cooling negative
      if( lgUnstable ) nUnstable = nUnstable + 1
*
*     this is a redundant check that electron density is converged
      if( lgTrace.and.lgNeBug ) then
        write(qq,'('' radinc the correct electron density was'',
     1  1P,E11.4,'' and the assumed value was'',E11.4)') EdenTrue , eden
      endif
*     check on IONDON since somethings get here with trouble after
*     a temperature failure
      if( abs(EdenTrue-eden)/eden .gt.EdenError ) then
        if( lgIonDone .and. (.not.lgTeFail) ) then
*         this is a serious error, both ionizaiton and temperature were
*         converged but electron density is incorrect
          if(lgTalk)write(qq,'('' In radinc the correct electron '',
     1    ''density was'',1P,E11.4,'' but the assumed value was'',E11.4,
     2    '' zone='',i3)') EdenTrue , eden , nzone
          lgEdenBad = .true.
*         remember first bad electron density zone number
          if(nzEdenBad.eq.0) nzEdenBad = nzone
        else
*         electron density wrong but either ionizaiton or temperature
*         failure was detected
          if(lgTalk) then
            write(qq,'('' In radinc the correct electron '',
     1      ''density was'',1P,E11.4,'' but the assumed value was'',
     2      E11.4,'' zone='',I3,''.'')')
     3      EdenTrue , eden , nzone
            if(lgTeFail)write(qq,'('' Due to temperature failure??'')')
            if(.not.lgIonDone)
     1      write(qq,'('' Due to ionization failure??'')')
          endif
        endif
      endif
*
*     find Stromgren radius
      if( .not.lgUSphON .and. hi/hden.gt.0.49 ) then
         rstrom = radius
         lgUSphON = .true.
      endif
*
*     ratio of inner to outer radii, at this point
*     radius is the outer radius of this zone
      rfac = ( (radius-drad*dRadSign) / radius ) ** 2
*
      if( nzone.le. 1 ) then
        dReffAver = dRNeff
      else
*       this is to damp out feedback between nextdr and tmn
*       caused heating and dr to oscillate
        dReffAver = 0.8 * dReffAver + 0.2 * dRNeff
      endif
*
      relec = 0.
      rforce = 0.
*
*     print out arrays if TRACE OPACITIES is true
      if( lgTrace.and.lgOpacBug ) then
        write(qq,'(/1X,''Energy, TMN(old), flux, opacity:'')')
        write(qq,'(3(I5,1P,4E9.2))') (i,anu(i),tmn(i),flux(i),opac(i)
     1  ,i=1,nflux)
      else if( lgTrace.and.lgConBug ) then
        write(qq,'(1X,''Energy, flux, OTS:'')')
        write(qq,'(1P,4(I6,3E9.2))') (i,anu(i),
     1  flux(i)+outlin(i)+outcon(i),
     1  otscon(i)+ otslin(i),i=1, nflux)
      endif
*
*     diffuse continua factor
*     if lgSphere then all diffuse radiation is outward (COVRT=1)
*     lgSphere not set then COVRT=0.0
*
*begin sanity check
      lgFlxNeg = .false.
      do i=1,nflux
        if( flux(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in flux.'')')
          write(qq,'('' Intensity, frequency, pointer='',1P,2E11.3,I6)')
     1    flux(i), anu(i), i
          lgFlxNeg = .true.
        endif
        if( otscon(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in otscon.'')')
          write(qq,'('' Intensity, frequency, pointer='',1P,2E11.3,I6)')
     1    otscon(i), anu(i), i
          lgFlxNeg = .true.
        endif
        if( tmn(i).lt.0. ) then
          write(qq,'('' radinc finds negative tmn.'')')
          write(qq,'('' value, frequency, pointer='',1p,2e11.3,
     1    i6,1x,a4)') tmn(i), anu(i), i , chLineLabel(i)
          lgFlxNeg = .true.
        endif
        if( otslin(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in otslin.'')')
          write(qq,'('' Intensity, frequency, pointer='',1p,2e11.3,
     1    i6,1x,a4)') otslin(i), anu(i), i , chLineLabel(i)
          lgFlxNeg = .true.
        endif
        if( outlin(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in outlin.'')')
          write(qq,'('' Intensity, frequency, pointer='',1p,2e11.3,
     1    i6,1x,a4)') outlin(i), anu(i), i , chLineLabel(i)
          lgFlxNeg = .true.
        endif
        if( outcon(i).lt.0. ) then
          write(qq,'('' radinc finds negative intensity in outcon.'')')
          write(qq,'('' Intensity, frequency, pointer='',1p,2e11.3,
     1    i6,1x,a4)') outcon(i), anu(i), i , chContLabel(i)
          lgFlxNeg = .true.
        endif
        if(opac(i).lt.0.)  then
          lgOpacNeg = .true.
*         this sub will punch negative opacities on io unit,
*         iff 'set negopc' command was given
          call pnegopc
        endif
      end do
      if(lgFlxNeg) then
        write(qq,'('' Insanity has occurred, this is zone'',i4)')nzone
        call ShowMe
        stop
      endif
*end sanity check
*
*     attenuate the flux array after doing radiative acceleration
      escatc = 6.65e-25 * eden
*     AngleIllum is 1/cos(theta)
      drTau = dReff * AngleIllum
      do i=1,nflux
*       sum total continuous optical depths
        tauabs(i,1) = tauabs(i,1) + opac(i) * dReff
*       following only depth to illuminated face
        depabs(i) = depabs(i) + opac(i) * dReff
        tausct(i,1) = tausct(i,1) + scatop(i) * dReff
        depsct(i) = depsct(i) + scatop(i) * dReff
        tautot(i,1) = tauabs(i,1) + tausct(i,1)
*
*       TMN is array of scale factors which account for attenuation
*       of continuum across the zone (necessary to conserve energy
*       at the 1% - 5% level.) sphere effects in
*       drNext was set by NEXTDR and will be next dr
*       compute both total and thompson scat rad acceleration
        rforce = rforce +
     1  (flux(i)+outlin(i)+outcon(i)+ContDiff(i))*anu(i)*
     1  (opac(i)+scatop(i))
        relec = relec  + ((flux(i)+outlin(i)+outcon(i)+ContDiff(i))*
     1  escatc) * anu(i)
*       this will be the optical thickness of the next zone
*       >>chng 97 apr 10, added AngleIllum, usually 1,
*       reset with illuminate command
        tnew = opac(i) * dReffAver * AngleIllum
        tmnold = tmn(i)
        if( tnew.lt.0.10 ) then
*       >>chng 96 march 20, make no larger than 0.99 to avoid oscillations
*         following is third order expansion of (1-EXP(-TNEW))/TNEW
*         off by 1% at .3
          tmn(i) = (1. - tnew/24.*(12.-tnew*(4.-tnew)) )
*         tmn(i) = max(0.99, (1. - tnew/24.*(12.-tnew*(4.-tnew)) ) )
        else if( tnew.gt.5. ) then
          tmn(i) = 1. / tnew
        else
          tmn(i) = (1. - exp(-tnew) ) / tnew
        endif
*       approximate correction for sphericity
        tmn(i) = tmn(i) * radius/(radius+dReffAver)
*       attenuation of flux by optical depths IN THIS ZONE
*       >>chng 97 apr 3, from dReff to drTau, with AngleIllum
*       ExpZone(i) = sexp(opac(i)*dReff)
        ExpZone(i) = sexp(opac(i)*drTau)
*       e(-tau) in inward direction, up to illuminated face
        ExpmTau(i) = ExpmTau(i) * ExpZone(i)
*       e2(tau) in inward direction, up to illuminated face
        e2TauAbs(i) = e2( depabs(i)  , ExpmTau(i) )
*       rfac is square of ratio of inner to outer radius
*       opfac = ExpZone(i) *tmn(i)/tmnold*rfac
        opfac = ExpZone(i) *rfac * tmn(i) / tmnold
        flux(i) = flux(i) * opfac
        ContDiff(i) = ContDiff(i) * opfac
*       rec scale is shifted by one so as to not pick up rec twice
*       >>chng 96 may 8, had been max(1,i-1) so i=1 was hit twice
*       >>chng 96 aug 22, removed shift of one, don't remember why it was there
*       if( i.ge.2 ) then
*         outcon(i-1) = outcon(i-1) * opfac
*         outlin(i-1) = outlin(i-1) * opfac
*       endif
        outcon(i) = outcon(i) * opfac
        outlin(i) = outlin(i) * opfac
*
*       reset occupation numbers
        occnum(i) = flux(i) * convoc(i)
      end do
*     >>chng 96 aug 22, removed shift of one, don't remember why it was there
*     outcon(nflux) = outcon(nflux) * opfac
*     outlin(nflux) = outlin(nflux) * opfac
*
*     do scattering opacity, intensity goes as 1/(1+tau)
      if( lgScatON ) then
        do i=1,nflux
*         assume half forward scattering
*         opfac = 1. / ( 1. + dReff*0.5 * scatop(i) )
*         >>chng 97 Apr 25, remove .5 to get agreement with
*         Lightman and White formula
          opfac = 1. / ( 1. + dReff * scatop(i) )
          flux(i) = flux(i) * opfac
          ContDiff(i) = ContDiff(i) * opfac
          outcon(i) = outcon(i) * opfac
          outlin(i) = outlin(i) * opfac
*         dReff for following appears when it is used
*         >>chng 96 aug 21, extra factor of two in below
          scatsv(i) = (flux(i)+outcon(i))*scatop(i)
        end do
      else
        do i=1,nflux
          scatsv(i) = 0.
        end do
      endif
*
*     now do slight reshuffling of energy due to compton scattering
      call cmshft
*
      relec = relec * en1ryd
*     radiative acceleration; xMassDensity is gm per cc, eval when PTOT called
      t = 1. / SpeedLight / xMassDensity
      AccelLine = forlin() * t
      AccelCont = rforce * en1ryd * t
      AccelTot = AccelCont + AccelLine
      AccelMax = max( AccelMax , AccelTot )
*666  write(6,*) AccelCont /AccelTot,AccelLine /AccelTot
*     force multiplier; RELEC*T can be zero for N=10^5 and low rad field
      if( relec*t .gt.0. ) then
        fmul = ( AccelLine + AccelCont ) / (relec*t)
      else
        fmul = 0.
      endif
*
*     following is integral of radiative force
      pinzon = AccelTot * xMassDensity * drTau
      pinteg = pinteg + pinzon
*
*     attenuate neutrons if they are present
      if( lgNeutrnHeatOn ) then
*       correct for optical depth effects
        totneu = totneu * sexp( CrsSecNeutron*hden * drTau)
*       correct for spherical effects
        totneu = totneu * rfac
      endif
*
*     following rad factors are extinguished by 1/r**2 and e- opacity
*     also bound electrons
*     if( lgScatON ) then
*       following has bound electrons, for use above 2kev
*       bscat = 1. / ( 1. + dReff * (eden+hi) * 3e-25 )
*     else
*       bscat = 1.
*     endif
*
*---------------------------------------------------------------------
*
*     do all emergent continua if model is NOT spherical
      if( .not.lgSphere ) then
        do i=1,nflux
          if( tauabs(i,1).lt.30. ) then
*           DiffCont is diffuse emission per unit vol, fill fac
*           the 1/2 comes from isotropic emission
*           scatsv(i) = (flux(i)+outcon(i))*0.5*scatop(i)
*           >>chng 97 apr 25, remove fac of 2 to
*           get agreement wth lightman&white
*           flx = (DiffCont(i)+scatsv(i)) * dReff *e2TauAbs(i)
*           >>chng 97 may 8, needed 1/2 in front of DiffCont
*           had been there, but also with scatsv, and lost both
*           when /2 removed to get agreement with lightman and white
            flx = (DiffCont(i)/2.+scatsv(i)) * dReff *e2TauAbs(i)
*           flx = (DiffCont(i)+scatsv(i)) * dReff/2. *e2TauAbs(i)
*           refcon - reflected diffuse plus back-scattered incident cont
            refcon(i) = refcon(i) + flx * r1r0sq
*           >>chng 97 apr 25, remove fac of 2 to get
*           agreement wth lightman&white
            reflin(i) = reflin(i) +
     1      outlin(i)*scatop(i)*dReff*e2TauAbs(i)*r1r0sq
*    1      outlin(i)*0.5*scatop(i)*dReff*e2TauAbs(i)*r1r0sq
            reflux(i) = reflux(i) +
     1        flux(i)*scatop(i)*dReff*e2TauAbs(i)*r1r0sq
*    1        flux(i)*0.5*scatop(i)*dReff*e2TauAbs(i)*r1r0sq
          endif
        end do
      endif
*
*     remember largest line photoionization rate for COMNT
      do n=2,nhlvl-3
        crs = OpacStack( iphl(n,n-1)-ipHn(n+1)+iphop(n+1) )
        hlrate = otslin( iphl(n,n-1) ) * crs
        hlmax(n) = max( hlmax(n) , hlrate/max(1e-30,hgamnc(n) +
     1  eden*hcoldn(n) + hradn(n) ) )
      end do
*
      ffhtot = ffhtot + FreeFreeHeat * dVeff
*
*     diffuse fields of heavy elements, outward beams
*     NB this one only can be evaluated once per zone, since phtons
*     added to outward beam!
*     >>chng 97 jul 30, moved out to cloudy
*     call metdif
*
      if( lgTrace ) write(qq,'('' radinc returns'')')
*
      end
******************************************************************************
      subroutine RadMean( nelem , n , arlog )
      implicit none
*derive mean ionization fractions over ravius for some element
      integer limelm
      parameter (limelm=30)
      real arlog(limelm+1)
      integer nelem , n
*
*     local variables
      real abund , normalize
      integer i
*     xIonMeans(nelem, stage,type)
*     stage=0 is integrated sum of all
*     type = 1 is radius integration, 2=vol
      real xIonMeans
      common/IonMeans/ xIonMeans(limelm,0:limelm+1,2)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     fills in array arlog with log of ionization fractions
*     N is set to highest stage with non-zero abundance
*     N set to 0 if element turned off
*
*     first call zmean to sero out save arrays
*     next call mean in zone calc to enter ionziation fractions
*     finally this routine computes actual means
*
      if( xIonMeans(nelem,0,1) .le.0. ) then
*       no ionization for this element
        do i=1,nelem+1
          arlog(i) = -30.
        end do
        n = 0
        return
      endif
*
      n = nelem+1
      do while(n.gt.1.and. xIonMeans(nelem,n,1) .le.0. )
        arlog(n) = -30.
        n = n - 1
      end do
*
      normalize = xIonMeans(nelem,0,1)
      do i=1,n
        if( xIonMeans(nelem,i,1).gt.0. ) then
          abund = xIonMeans(nelem,i,1)
          arlog(i) = log10( max(1E-30,abund/normalize ))
        else
          arlog(i) = -30.
        endif
      end do
*
      end
******************************************************************************
      subroutine rangr( nqh , chCard )
      implicit none
*parse the range option on the luminosity command
      character chCard*80
      integer nqh
*
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real HIonPot
      parameter (HIonPot=0.99946)
*ionization potential of real hydrogen atom, in inf mass ryd
      real emm , egamry
      common/bounds/ emm , egamry
      real range
      common/range/ range(limspc,2)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      logical lgEOL , lgMatch
      real fread , p1 , p2
      integer i
*
      if( lgMatch( 'TOTA', chCard ) ) then
        range(nqh,1) = emm
        range(nqh,2) = egamry
      else if( lgMatch( 'RANG', chCard ) ) then
        i = 1
*       first call return the luminosity on the card, ignore it
        p1 = fread( chCard , i , 76 , lgEOL )
*
*       this should be the lower limit
        p1 = fread( chCard , i , 76 , lgEOL )
        if( p1.eq.0. ) p1 = emm
*
        p2 = fread( chCard , i , 76 , lgEOL )
*       no third numer on card then go all the way to gamma ray
        if( p2.eq.0. ) p2 = egamry
*
*       option to enter log if first energy is neg
        if( p1.lt.0. .or. lgMatch( ' LOG', chCard ) ) then
          p1 = 10.**p1
*         second number may not have been entered
          if(.not.lgEOL) p2 = 10.**p2
        endif
*
*       make sure that energies are within array bounds
        range(nqh,1) = max( p1 , emm )
        range(nqh,2) = min( p2 , egamry )
        if( range(nqh,1).gt.range(nqh,2) ) then
          write(qq,'('' Range MUST be in increasing order - sorry.'')')
          stop
        endif
      else
*       range not specified, use default - total ionizing field
*     >>chng 96 dec 18, from 1.001 to 1 Ryd for H mass nuc
        range(nqh,1) = HIonPot
        range(nqh,2) = egamry
      endif
*
      end
******************************************************************************
      subroutine RauchMod(nstar,temp,alogg,nspec)
      implicit none
*get one of the Rauch model atmospheres, coded by K. Volk
      real temp,alogg
      integer nspec,nstar
*     limit to number of cells in frequency array
*     NB is this every is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      character chPath*80
      common/path/ chPath
      logical lgPathSet
*true is path has been set with set path command, false otherwise
      common/pthset/ lgPathSet
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chLine*80
      real flux1(ncell),flux2(ncell)
      logical lgTHit, lgAgain
      real tval(19)
      integer jval(4,19) ,ivals(ncell) , ierror
      integer nmods , j , i , j1,i1 , ierr
      real xval,fr1,fr2,fr3,fr4,gval
      real fact1,fact2
      parameter (nmods=57)
      real teff(nmods),xlogg(nmods)
      data teff/50000.,50000.,50000.,50000.,60000.,60000.,60000.,60000.,
     1          70000.,70000.,70000.,70000.,80000.,80000.,80000.,80000.,
     2          90000.,90000.,90000.,90000.,100000.,100000.,100000.,
     3          100000.,110000.,110000.,110000.,120000.,120000.,120000.,
     4          130000.,130000.,130000.,140000.,140000.,140000.,
     5          150000.,150000.,150000.,160000.,160000.,160000.,
     6          170000.,170000.,170000.,180000.,180000.,180000.,
     7          190000.,190000.,190000.,200000.,200000.,300000.,
     8          300000.,400000.,500000./
      data xlogg/5.,6.,7.,8.,5.,6.,7.,8.,5.,6.,7.,8.,5.,6.,7.,8.,
     1           5.,6.,7.,8.,5.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,
     2           8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,6.,7.,8.,
     3           6.,7.,8.,7.,8.,7.,8.,8.,8./
      data tval/50000.,60000.,70000.,80000.,90000.,100000.,
     1          110000.,120000.,130000.,140000.,150000.,
     2          160000.,170000.,180000.,190000.,200000.,
     3          300000.,400000.,500000./
      data jval/2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,
     1          21,22,23,24,25,26,26,27,28,29,29,30,31,32,32,33,
     2          34,35,35,36,37,38,38,39,40,41,41,42,43,44,44,45,
     3          46,47,47,48,49,50,50,51,52,53,53,53,54,55,55,55,
     4          56,57,57,57,57,58,58,58,58/
*
      if( lgPathSet ) then
        j = 1
        lgAgain = .true.
        i = 1
*       >>chng 97 may 13, get rid of statement numbers
*       do i=1,80
        do while (lgAgain.and. i.le.80 )
          if( chPath(i:i).ne.' ') then
            chLine(j:j) = chPath(i:i)
            j = j + 1
          else
*           go to2
            lgAgain = .false.
          endif
          i = i + 1
        end do
*2      continue
*       j now points to first free character
        chLine(j:j+8) = 'rauch.mod'
*       end string with zero character
        chLine(j+9:j+9) = char(0)
      else
        chLine(1:9) = 'rauch.mod'
*       end string with zero character
        chLine(10:10) = CHAR(0)
      endif
      open(unit=94,file=chLine,
     1     status='old',access='direct',
     1     form='formatted',iostat=ierr,recl=7*ncell)
*
*     something went wrong
      if( ierr.ne.0 ) then
        write(qq,'(''Error: Rauch stellar atmosphere file'',
     1  '' rauch.mod not found.'')')
        write(qq,'('' The path I tried:'',A80)') chLine
        write(qq,'('' And here comes its octal representation:'')')
        write(qq,'(1X,A1,Z4)') (chLine(i:i),chLine(i:i),i=1,80)
*       write(qq,'(1X,A1,O4)') (chLine(i:i),chLine(i:i),i=1,80)
        stop
      endif
*
*     determine which models are to be interpolated
*
      lgTHit = .false.
      do j=1,18
        if( tval(j).le.temp.and.tval(j+1).gt.temp ) then
          j1 = j
          lgTHit = .true.
        endif
      end do
*
      if( .not.lgTHit ) then
        if( tval(19).eq.temp ) then
          j1 = 18
        else
          write(qq,'('' Requested temperature of'',1P,E10.2,
     1    '' is not within the range'',1P,2E10.2)')
     2    temp, tval(1), tval(19)
          stop
        endif
      endif
*
      read(94,'(4000i7)' ,rec=1,iostat=ierror)
     1 (ivals(j),j=1,nRauch)
*
      do j=1,nRauch
*       tnu holds the frequency arrays
        tnu(nspec,j) = 10.**(-1.*float(ivals(j))/1000000.+5.0)
      end do
*
      xval=alogg-4.0
      i1=int(xval)
*
* Interpolation is carried out first in Teff and then in log(g).
* Two Rauch models are read in for the lower log(g) value first, which
* I denote models A and B with B the higher T model [j1+1 rather than j1].
* unless alogg is 8.0 a second pair of Rauch models are read in for the
* higher log(g) value, denoted models C and D.  Then the interpolation is
*
*  RESULT = fr2*(fr3*B+fr4*A)+fr1*(fr3*D+fr4*C)
*
* when one has 4 models and
*
* RESULT = (fr3*B+fr4*A)
*
* when one has just 2 models.
      fr1 = xval-float(i1)
      fr2 = 1.-fr1
      fr3 = (temp-tval(j1))/(tval(j1+1)-tval(j1))
      fr4 = 1.-fr3
*
*     following must change if ncell changes
      read(94,'(4000i7)' ,rec=jval(i1,j1),iostat=ierror)
     1 (ivals(j),j=1,nRauch)
      if( ierror.ne.0 ) then
        ierr = 1
        return
      endif
      gval = xlogg(jval(i1,j1)-1)
*
      if(lgTalk)write(qq,'(23x,''*<<< Rauch model '',I3,'' READ'',
     1    '' IN.  T_eff = '',F10.2,'' log(g) = '',F8.5,''  >>>'',
     2    10x,''*'')')
     2  jval(i1,j1)-1,teff(jval(i1,j1)-1),gval
*
      do j=1,nRauch
        if( ivals(j).lt.9999999 ) then
          flux1(j) = (3.-1.*float(ivals(j))/100000.0)
        else
          flux1(j) = -35.
        endif
      end do
*
      read(94,'(4000i7)' ,rec=jval(i1,j1+1),iostat=ierror)
     1 (ivals(j),j=1,nRauch)
      if( ierror.ne.0 ) then
        ierr = 1
        return
      endif
      gval=xlogg(jval(i1,j1+1)-1)
      if(lgTalk)write(qq,'(23X,''*<<< Rauch model '',I3,'' READ'',
     1    '' IN.  T_eff = '',F10.2,'' log(g) = '',F8.5,''  >>>'',
     2    10x,''*'')')
     2 jval(i1,j1+1)-1,teff(jval(i1,j1+1)-1),gval
*
      do j=1,nRauch
*       flux2(j) = 10.**(-1.*float(ivals(j))/100000.)
        if( ivals(j).lt.9999999 ) then
          flux2(j) = (3.-1.*float(ivals(j))/100000.0)
        else
          flux2(j) = -35.
        endif
      end do
*
* The following is an approximate scaling to use for the range of
* temperatures above 200000 K where the temperature steps are large
* and thus the interpolations are over large ranges.  For the lower
* temperatures I assume that there is no need for this since the
* step of 10000 K is not so large.
*
* It should be remembered that this interpolation is not exact, and
* the possible error at high temperatures might be large enough to
* matter.
*
* At the end of the subroutine the fluxes are re-scaled to force the
* correct total flux (sigma * T^4).
*
      if (temp.gt.200000.) then
          fact1=alog10(temp/tval(j1))*4.
          fact2=alog10(temp/tval(j1+1))*4.
      else
          fact1=0.
          fact2=0.
      end if
*
      do j=1,nRauch
        flux(j) = fr4*(flux1(j)+fact1)+fr3*(flux2(j)+fact2)
      end do
*
      if (i1.lt.4) then
*         for log(g) < 8.0 repeat the interpolation at the larger log(g) then
*         carry out the interpolation in log(g)
          read(94,'(4000i7)' ,rec=jval(i1+1,j1),iostat=ierror)
     1    (ivals(j),j=1,nRauch)
          if( ierror.ne.0 ) then
            ierr = 1
            return
          endif
          gval = xlogg(jval(i1+1,j1)-1)
          if(lgTalk)write(qq,'(23X,''*<<< Rauch model ''
     1    ,I3,'' READ''
     1    ,'' IN.  T_eff = '',F10.2,'' log(g) = '',F8.5,''  >>>'',
     2    10x,''*'')')
     2    jval(i1+1,j1)-1,teff(jval(i1+1,j1)-1),gval
*
          do j=1,nRauch
            if( ivals(j).lt.9999999 ) then
              flux1(j) = (3.-1.*float(ivals(j))/100000.0)
            else
              flux1(j) = -35.
            endif
          end do
*
          read(94,'(4000I7)' ,rec=jval(i1+1,j1+1),iostat=ierror)
     1            (ivals(j),j=1,nRauch)
          if( ierror.ne.0 ) then
            ierr = 1
            return
          endif
          gval = xlogg(jval(i1+1,j1+1)-1)
          if(lgTalk)write(qq,'(23X,''*<<< Rauch model ''
     1    ,I3,'' READ''
     1    ,'' IN.  T_eff = '',F10.2,'' log(g) = '',F8.5,''  >>>'',
     2    10x,''*'')')
     1    jval(i1+1,j1+1)-1,teff(jval(i1+1,j1+1)-1),gval
*
          do j=1,nRauch
            if( ivals(j).lt.9999999 ) then
              flux2(j) = (3.-1.*float(ivals(j))/100000.0)
            else
              flux2(j) = -35.
            endif
          end do
*
          do j=1,nRauch
            flux1(j)=(flux1(j)+fact1)*fr4+(flux2(j)+fact2)*fr3
          end do
*
          do j=1,nRauch
            flux(j) = 10.**(fr2*flux(j)+fr1*flux1(j))
          end do
      else
*     One gets here if log(g) is 8.0 and there is no higher log(g) pair of
*     models to interpolate.
*
        do j=1,nRauch
          flux(j) = 10.**flux(j)
        end do
      endif
* Note on the interpolation: 15 August 1997 (Kevin Volk)
*
* I tested the total flux from the interpolated grids.  I found that the
* ratio of actual to expected total flux is about 1.05 for 55000 K and
* log(g) of 7.5, between 0.99 and 1.01 for temperature values between
* 60000 K and 200000 K, and about 1.15 for 250000 K declining to 0.95
* for 500000 K.  So for most of the range things are O.K. but where
* the interpolation interval is large and at the highest temperatures
* there is a noticeable scaling.
*
* I do not know why the hottest models require a scaling factor of less than
* 1.0.  This may mean that the extrapolation beyond 2000 Angstroms is bad
* although one would think that at such high temperatures it would not
* matter.
*
* Since Cloudy checks the scaling elsewhere there is no need to re-scale
* things here, but this inaccuracy should be kept in mind.
*
      do j=1,nRauch
*       TSLOP is f_nu for each TNU point
        tslop(nspec,j) = flux(j)
      end do
      do j=nRauch+1, ncell
        tslop(nspec,j) = 0.
      end do
*
      nstar = nRauch
      close(94)
*
      ierr = 0
      end
******************************************************************************
      real function rayleh( ener )
      implicit none
*compute Rayleigh scattering cross section for Lya
      real ener
      real fr1ryd
*     frequency of 1 rydberg
*     FR1RYD is frequency for 912
      parameter (fr1ryd=3.28805E15)
      real DampOnFac
*usually 1, set to 0 with hydrogen damping off command, scales rayleigh scat
      common/dampon/ DampOnFac
*
*     do hydrogen Rayleigh scattering cross sections;
*     fits to Phys Rev 163, 147; and Mihalas radiative damping
*
*     >>chng 96 aug 15, changed logic to do more terms for each part of
*     rayleigh scattering
*     if( ener.lt.0.05 ) then
*        rayleh = 8.41e-25 * ener**4 * DampOnFac
*
      if( ener.lt. 0.05 ) then
         rayleh = ( 8.41e-25*ener**4 + 3.37e-24*ener**6 ) * DampOnFac
*
      else if( ener .lt. 0.646 ) then
         rayleh = ( 8.41e-25*ener**4 + 3.37e-24*ener**6 +
     1   4.71e-22*ener**14 ) * DampOnFac
*
      else if( ener.ge.0.646 .and. ener.lt.1.0 ) then
         rayleh = 1.788e5 / ( fr1ryd*max(0.001,abs(0.74959-ener)) )**2
*        typical energy between Ly-a and Ly-beta
         rayleh = max( rayleh , 1e-24 ) * DampOnFac
      else
         rayleh = 0.
      endif
*
      end
******************************************************************************
      subroutine rdelem( chCard )
      implicit none
*parse options on element command
      character chCard*80
*
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      integer limelm
      parameter (limelm=30)
      integer limTabD
      parameter (limTabD=500)
      logical lgAbunTabl(limelm) , lgAbTaDepth(limelm),lgAbTaON
*lgAbunTabl says whether this element is to have its abundance
*determined from a table (true) or stored constant (false)
*set true with element table command
*lgAbTaDepth says whether depth or radius, true is depth
      common/AbunTablLG/ lgAbunTabl , lgAbTaDepth,lgAbTaON
      real AbTabFac(limelm,limTabD) , AbTabRad(limelm,limTabD)
      integer nAbunTabl
*AbTabFac abundances for element table
*AbTabRad depth scale
      common/AbunTablFac/ AbTabFac , AbTabRad , nAbunTabl
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgAbnSolar
      common/abnslr/ lgAbnSolar
      real solar
      common/solar/ solar(limelm)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      real scalem
      common/scalem/ scalem(limelm)
      integer nvary , nparm
      common/nvary/ nvary , nparm
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer ipSolar, npSolar
      common/ipSolar/ ipSolar(limelm) , npSolar
      character chElNames*4
      common/ElNames/ chElNames(limelm)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEnd , lgMatch , lgHIT
      character chCap*80
      logical lgEOL
      integer i , j , k , iel
      real param , fread
*
*     say that abundances have been changed
      lgAbnSolar = .false.
*
*     read in list of elements for abundances command
      if( lgMatch('READ' ,chCard ) ) then
        npSolar = 0
        do i=2,limelm
          call readar( chCard , lgEnd )
          if( lgEnd ) then
            write(qq,'('' Hit EOF while reading element list; use '',
     1      ''END to end list.'')')
            stop
          endif
          chCap = chCard
          call caps( chCap )
          if( chCap(1:3).eq.'END' ) then
*           write(6,*) (ipSolar(j),j=1,npSolar)
            return
          endif
*     >>chng 97 jun 2, removed statement label
*         do j=2,limelm
          j = 1
          lgHIT = .false.
          do while( j.lt.limelm .and. .not.lgHIT )
            j = j + 1
            if(chCap(1:4).eq.chElNames(j) ) then
              npSolar = npSolar + 1
              ipSolar(npSolar) = j
              lgHIT = .true.
            endif
          end do
          if( .not.lgHIT ) then
            write(qq,'(a80)') chCard
            write(qq,'('' Sorry, but I did not recognize element '',
     1      ''name on this line.'')')
            write(qq,'('' Here is the list of names I recognize.'')')
            write(qq,'(10(1x,a4))') (chElNames(k),k=2,limelm)
            stop
* 10       continue
          endif
        end do
*       fell through, make sure one more line, the end line
        call readar( chCard , lgEnd )
        chCap = chCard
        call caps( chCap )
        if( chCap(1:3).eq.'END' ) then
          return
        else
          write(qq,'('' Too many elements were entered.'')')
          write(qq,'('' I only know about'',i3,'' elements.'')')limelm
          write(qq,'('' Sorry.'')')
          stop
        endif
      endif
*
*     find which element
*     >>chng 97 jun 2, remove statement label
*      do i=1,limelm
      lgHIT = .false.
      i = 0
      do while( .not.lgHIT .and.i.lt.limelm )
        i = i + 1
        if( lgMatch(chElNames(i),chCard ) ) then
*         IEL is atomic number of element, is used below
          iel = i
          lgHIT = .true.
        endif
      end do
      if( .not.lgHIT ) then
        write(qq,'('' ELEM did not find an element on the following '',
     1  ''line:'')')
        write(qq,'(a80)') chCard
        stop
      endif
*
* 2    continue
*
*     IEL is the atomic number of the element
*
      i = 4
      param = fread( chCard , i , 76 , lgEOL )
*
      if( lgMatch('SCAL' ,chCard ) ) then
*       enter abundance as scale factor, relative to what is in now
        if( lgEOL ) then
          write(qq,'('' There must be a number on this line.'')')
          write(qq,'('' Sorry.'')')
          stop
        else
          if( lgMatch(' LOG' ,chCard ) .or. param.le.0. ) then
*           option for log of scale factor
            param = 10.** param
          endif
          scalem(iel) = param
        endif
      else if( lgMatch('ABUN' ,chCard ) ) then
*       log of actual abundance
        if( lgEOL ) then
          write(qq,'('' There must be a number on this line.'')')
          write(qq,'('' Sorry.'')')
          stop
        else
          solar(iel) = 10. ** param
        endif
      else if( lgMatch(' OFF' ,chCard ) ) then
*       option to turn off this element, set abundance to zero
        lgElmtOn(iel) = .false.
        if( iel.eq.1 ) then
          write(qq,'('' It is not possible to turn hydrogen off.'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
      else if( lgMatch('TABL' ,chCard ) ) then
*     >>chng 97 jun 2, add table option
*       when called, read in densities from input stream
        lgAbunTabl(iel) = .true.
*       general flag saying this option turned on
        lgAbTaON = .true.
        if( lgMatch('DEPT' , chCard ) ) then
          lgAbTaDepth(iel) = .true.
        else
          lgAbTaDepth(iel) = .false.
        endif
*
*       make sure not trying to change hydrogen
        if( iel.eq.1 ) then
          write(qq,'('' cannot change abundance of hydrogen.'')')
          write(qq,'('' Sorry.'')')
          stop
        endif
*
        call readar( chCard , lgEnd )
        i = 1
        AbTabRad(iel,1) = fread( chCard , i , 76 , lgEOL )
        AbTabFac(iel,1) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' no pairs entered - cant interpolate'')')
          stop
        endif
        nAbunTabl = 2
        lgEnd = .false.
        do while( .not.lgEnd .and.nAbunTabl.lt.limTabD)
          call readar( chCard , lgEnd )
          if(.not.lgEnd ) then
            call cap4(chCard(1:4) , chCap )
            if( chCap(1:3).eq.'END') lgEnd = .true.
          endif
          if( .not.lgEnd ) then
            i = 1
            AbTabRad(iel,nAbunTabl) = fread( chCard , i , 76 , lgEOL )
            AbTabFac(iel,nAbunTabl) = fread( chCard , i , 76 , lgEOL )
            nAbunTabl = nAbunTabl + 1
          endif
        end do
        nAbunTabl = nAbunTabl - 1
*       do i=1,nAbunTabl
*         write(6,*)i,AbTabRad(iel,i),AbTabFac(iel,i)
*       end do
        do i=2,nAbunTabl
*         the radius values are assumed to be strictly increasing
          if (AbTabRad(iel,i).le.AbTabRad(iel,i-1)) then
            write(qq,'('' abun radii must be in increasing '',
     1      ''order'')')
            stop
          endif
        end do
      else
        write(qq,'('' There must be a keyword on this line.'')')
        write(qq,'('' The keys I know about are TABLE, SCALE ''
     1  ''and ABUNDANCE.'')')
         write(qq,'('' Sorry.'')')
         stop
      endif
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
        nvarxt(nparm) = 1
*       pointer to where to write
        nvfpnt(nparm) = nRead
        if( lgMatch('SCAL' ,chCard ) ) then
*         vary scale factor
          write(chVarFmt(nparm),'(''(''''ELEMENT '',A4,'' SCALE'''',F9.5,
     1'''' LOG'''')'')') chElNames(iel)
*         param is linear scale factor
          vparm(nparm,1) = log10( param )
          vincr(nparm) = 0.2
        else if( lgMatch('ABUN' ,chCard ) ) then
*         vary absolute abundance
          write(chVarFmt(nparm),'(''(''''ELEMENT '',A4,'' ABUND'''',F9.5,
     1'''' LOG'''')'')') chElNames(iel)
*         param is log of abundance by number relative to hydrogen
          vparm(nparm,1) = param
          vincr(nparm) = 0.2
        endif
      endif
*
      end
******************************************************************************
      subroutine rdinit
      implicit none
*initial readar array for storing line images at start of calculation
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
*
*     this sub must be called before calling READAR to get line images
*     it simply sets the pointer to set up reading the images
*
      if( iReadWay.gt.0 ) then
*       this is usual case, read from the start of array, the commands
        nRead = 0
      else if( iReadWay.lt.0 ) then
*       this is special case where we read from end of array, the ini file
        nReadSv = nRead
        nRead = nkrd + 1
      endif
*
      end
******************************************************************************
      subroutine rdsum( sum , chDo )
      implicit none
*parse print line sum commandto enter set of lines into sum
      real sum
      character chDo*4
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      integer nlsum
      common/nlsum/ nlsum
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOF , lgEOL , lgOK , lgEND
      character chCard*80 , chCCap*80
      integer nrdsum , i
      real fread , absint , relint
      parameter (nrdsum=30)
      integer lamsm(nrdsum)
      character chSMLab(nrdsum)*4
      save lamsm , chSMLab
*
      if( chDo.eq.'READ' ) then
*        this call, read in lines
         nlsum = 0
         lgEND = .false.
         do while( .not.lgEND )
*     >>chng 97 jun 8, get rid of go to
*999     call readar( chCard , lgEOF )
           call readar( chCard , lgEOF )
           if( lgEOF ) then
             write(qq,'('' Hit EOF while reading line list; use END to''
     1       ,'' end list.'')')
             stop
           endif
           chCCap = chCard
           call caps( chCCap )
*
           if( chCCap(1:3).ne.'END' ) then
             nlsum = nlsum + 1
             if( nlsum.gt.nrdsum ) then
               write(qq,'('' Too many lines have been entered; the '',
     1         I4,''limit is.  Increase variable NRDSUM.'')') nrdsum
               stop
             endif
*            order on line is label (col 1-4), wavelength
             chSMLab(nlsum) = chCCap(1:4)
             i = 5
             lamsm(nlsum) = fread( chCard , i , 76 , lgEOL )
           else
             lgEND = .true.
           endif
         end do
*
      else if( chDo.eq.' SUM' ) then
        sum = 0.
        if( ipass.eq. 0 ) return
        do i=1,nlsum
          call cdLine( chSMLab(i) , lamsm(i) , relint,absint,lgOK )
          if ( lgOK ) then
            absint = 10.**( absint-pirsq )
            sum = sum + absint
          else
            write(qq,'('' RDSUM could not fine line '',A4,I5)')
     1      chSMLab(i) , lamsm(i)
            stop
          endif
        end do
      else
        write(qq,'('' unrecognized key for RDSUM='',A4)') chDo
        stop
      endif
*
      end
******************************************************************************
      subroutine readar( chCard , lgEOF )
      implicit none
*read input commands from array where images are stored
      character chCard*80
      logical lgEOF
*
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      character chOrgCard*80
*     copy of current line image used by readr with no caps forced
      common/OrgCard/ chOrgCard
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer last
*
      if( iReadWay.gt.0 ) then
*       this is usual case, reading commands from start of array
*       pretend read the array
        nRead = nRead + 1
        if( nRead.gt.nSave ) then
          lgEOF = .true.
        else
          chCard = chCardSav(nRead)
*         save copy of the original input card
          chOrgCard = chCard
          lgEOF = .false.
        endif
      else
*       this is special case of reading cloudy.ini file
        lgEOF = .false.
        nRead = nRead - 1
*       this option never hits eof
        chCard = chCardSav(nRead)
*       last one with real data is nkrd+1-nSaveIni
        last = nkrd + 1 - nSaveIni
*
*       next read would have been eof
        if(nRead.eq.last ) then
          iReadWay = 1
          nRead = nReadSv
        endif
      endif
*
      end
******************************************************************************
      subroutine readck( nqh )
      implicit none
*check for sanity after commands all read in
      integer nqh
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     lgPstop says that not enough info for model, so stop
      logical lgStop , lgPstop
      real ck
*
      lgStop = .false.
*
*     NSAVE is number of lines saved, =0 if no commands entered
      if( nSave.le.0 ) then
        write(qq,'('' No commands were entered - whats up?'')')
        stop
      endif
*
      lgPstop = .false.
*     check hden within range.
      if( hden.eq.-99. ) then
        write(qq,'('' Hydrogen density MUST be specified.'')')
        lgPstop = .true.
        lgStop = .true.
      else
        if( lgTalk.and. (hden.lt.-4. .or. hden.gt.15.)) then
          write(qq,'(/'' Is this value of the H-density reasonable?'')')
          write(qq,'(''  The code may not run for extreme densities'')')
        endif
      endif
*
*     is the model going to crash?
      if( lgTalk.and. .not. lgStop ) then
        ck = 1e-37
        ck = ck / 1e30
        if( ck.eq.0. .and.((hden.lt.-5.3).or.(hden.gt.19.2)) ) then
          write(qq,'('' Simulation may crash because of extreme''
     2    ,'' density.  Do not use a 32-bit machine, or make '',
     3    ''everything double precision.'')')
          write(qq,'(''   '')')
        endif
      endif
*
      if( lgTalk.and. hden.gt.24. ) then
        write(qq,'('' You must be kidding about this density. '',
     1  '' Use ATLAS instead.'')')
      endif
*
      if( nspec.eq.0  ) then
        write(qq,'('' Type of continuum MUST be specified.'')')
        lgStop = .true.
        lgPstop = .true.
      endif
*
      if( nqh.eq.0  ) then
        write(qq,'('' Luminosity of continuum MUST be specified.'')')
        lgStop = .true.
        lgPstop = .true.
      endif
*
      if( radius.eq.0. ) then
        write(qq,'('' Starting radius MUST be specified.'')')
        lgStop = .true.
        lgPstop = .true.
      endif
*
      if( nspec.ne.nqh ) then
         write(qq,'('' There were not the same number of continuum '',
     1   ''shapes and luminosities entered.'')')
         lgStop = .true.
      endif
*
      if( lgPstop ) then
        write(qq,'('' Insufficient information for model, STOP.'')')
        stop
      endif
*
      if( lgStop ) then
        stop
      else
        return
      endif
*
      end
******************************************************************************
      subroutine readr
      implicit none
*main command line parser, decode command, then call other routines to read
      integer ndplot
      parameter (ndplot=10)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nfudgc
      parameter (nfudgc=10)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer limext
      parameter (limext=5)
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
      integer limpar
      parameter (limpar=20)
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real pi
      parameter ( pi=3.141592654 )
      logical lgWindOK
*flag set if wind not ok, (below sonic point)
      common/windok/ lgWindOK
      logical lgAbnSolar
      common/abnslr/ lgAbnSolar
      logical lgSupDie
*     logical flag for suppression of dielectronic recombination
*     1 is burgess, 2 is nussbaumer and storey
      common/supdie/ lgSupDie(2)
      logical lgOut2In
*flag set with roberto command, to do outward to inward calculation
      common/out2in/ lgOut2In
      logical lgTrOpt
*lgTrOpt flag set with optimization trace command
*nTrOpt is which call to cloudy to turn on trace
      integer nTrOpt
      common/tropt/ nTrOpt , lgTrOpt
      integer noptim
      common/noptim/ noptim
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
      logical lgTrOvrd
*flag affecting which iteration to turn on trace
      common/trovrd/ lgTrOvrd
      real GuessDiel
*this is fudge factor for scaled nussbamer and story diel recom
*set with diel kludge commmand, usually 1
      common/cludon/ GuessDiel
      real emm , egamry
      common/bounds/ emm , egamry
      logical lgPhysOK
*flag set if a physical condition has been disabled
      common/physok/ lgPhysOK
      real DoubleTau
*1 or two, set to double optical depth scale, set to 2 with double command
*default is 1
      common/double/ DoubleTau
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
      logical lgCasBhs
      common/casbhs/ lgCasBhs
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      real excolm , exleak , exlow
      common/extinc/ excolm , exleak , exlow
      real toler
*     allowed error in heating - cooling balance, set with TOLERANCE command
*     default set in zerologic
      common/toler/ toler
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real turhet,turrad
      common/turhet/ turhet,turrad
      real cryden , crpowr , crtemp , hxtot
      common/hextra/ cryden , crpowr , crtemp , hxtot
      logical lgSMinON
*lgSMinON is flag saying that set drmin has been enteed
*     these are 1e-30 and 1e30 by default, and are set with "set dr" cmnds
*     used as one of a pair of limits to how big or small zones get
*     set dr command forces constant dr by setting both to same number
      real sdrmin , sdrmax
      common/sdrmin/ sdrmin , sdrmax , lgSMinON
      real telow , tehigh
*     this is the default lowest to highest temperature checked
      common/telow/ telow , tehigh
      logical lgCylnOn
*lgCylnOn set true when cylinder command given
*cylind is half height in centimeters
      real CylindHigh
      common/cylind/ CylindHigh , lgCylnOn
      real CycloCoolCoef
*coefficient scaled from magnetic field used for
*Cyclotron cooling
      common/cyclot/ CycloCoolCoef
*     limfal is limit to number of te failures, set with "failures" cmnd
*     lgNoMap is option not to map failures
      integer limfal
      logical lgNoMap
      common/limfal/ limfal , lgNoMap
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      logical lgAutoIt
      real autocv
      common/autoit/ lgAutoIt , autocv
      real TurbVel
*this is the turbulent velocity in cm/s, normally zero, set with
*turbulence command
      common/turb/ TurbVel
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      logical lgTeHigh
*flag set if temperature map is from hot to cool, set with high command
      common/thigh/ lgTeHigh
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      real qhtot , qhe , qheii , qbal , qrad , qtot
      common/qs/ qhtot , qhe , qheii , qbal , qrad , qtot
      real EdenExtra
*extra electrons added with eden command
      common/edxtra/ EdenExtra
      real te , eden , hden
      common/phycon/ te , eden , hden
      real range
      common/range/ range(limspc,2)
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      character chSpType*5
      common/sptype/ chSpType(limspc)
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      real fudgea
      integer nfudge
      common/fudgec/ fudgea(nfudgc) , nfudge
      character*4 chRedis
      common/redis/ chRedis
      character chDate*7 , chVersion*7
      common/date/ chDate , chVersion
      real rdfalt
      common/rdfalt/ rdfalt
      logical lgNeutrnHeatOn
*flag lgNeutrnHeatOn says heating due to neutrons is enabled
*frcneu is fraction of total luminosity in neutrons, effneu is efficiency
*totneu is resulting total luminosity
      real frcneu , totneu , effneu
      common/neutrn/ frcneu , totneu , lgNeutrnHeatOn , effneu
      integer nvary , nparm
      common/nvary/ nvary , nparm
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real varang
      common/varang/ varang(2,limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      logical lgReadIn , lgScanar
*flag lgReadIn set if we are to read in line images (cdRead never called)
*flag lsScanar set true in cdInit:w
*lgScanar is not used at all - confirm then remove
      common/readin/ lgReadIn , lgScanar
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
      logical lgCExtraOn
*info about 'extra' cooling, lgCextOn says it is on
      real CoolExtra , cextpw
      common/cextra/ lgCExtraOn , CoolExtra , cextpw
      logical lgVrrFit
*which version of Dima's routine to use?
      common/vrrfit/ lgVrrFit
      integer nBetaVer
*     normally zero, non-zero if this is a beta test version
      common/BetaVer/ nBetaVer
      logical lgQHeat
*Kevin Volk add for quantum heating of grains
      common/qheat/ lgQHeat(ndust)
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
      character chOrgCard*80
*     copy of current line image used by readr with no caps forced
      common/OrgCard/ chOrgCard
      real AngleIllum
*angle of illumination - actually 1./cos(normal), so > 1.
      common/Angllum/ AngleIllum
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , nqh , j , nTabRead,iopt
      real fread , ar1,teset,a,z,fabden,tabden
      logical lgEOL , lgMatch , lgEOF , lgDSet ,lgQHet
      logical lgNu2
      logical lgNoInit
      character  chCard*80, chKey4*4 , chKey3*3 , chKey5*5,chK1*1
      save lgNoInit
      data lgNoInit/.true./
*
*     check if lgScanar is false, if not return
*     lgScanar is set by cdinit, the first step in calling
*     the code as a subroutine
*     if( .not.lgScanar ) return
*
*     following says abundances are solar
      lgAbnSolar = .true.
      lgPlotON = .false.
      nplot = 0
      lgDSet = .false.
      radius = 0.
      rinner = 0.
      nqh = 0
      nspec = 0
*     this is check that two table reads are not entered
      nTabRead = 0
      do i=1,limspc
        chRSpec(i) = 'UNKN'
      end do
      nparm = 0
*
*     this is an option to turn on trace printout on the nth
*     call from the optimizer
      if( lgTrOpt ) then
*       nTrOpt was set with "optimize trace" command,
*       is iteration to turn on trace
        if( nTrOpt.eq.noptim ) then
          lgTrace = .true.
          lgTalk = .true.
          lgTrOvrd = .true.
          write(qq,'('' READR turns on trace from optimize option.'')'
     1    )
        endif
      endif
*
      if( nBetaVer.gt.0 ) write(qq,'(/24x,''This is a beta test '',
     1''version of the code, and should not be used for publications.''/
     2)')
*
      if( lgTalk ) write(qq,'(57X,''Cloudy '',a7//23X,38(''*''),a7,
     1 38(''*''),/23X,''*'',81X,''*'')') chVersion , chDate
*
*     following signals which read is in progress,
*     1 is forward read, of input commands
*     -1 is reverse read from bottom of line array, of cloudy.ini file
      iReadWay = 1
*     initialize array reader, this sub does nothing but set
*     initial value of a variable, depending on value of iReadWay
      call rdinit
*
*     read until eof or blank line, than branch to 999
      call readar( chCard , lgEOF )
*     line starting with blank is eof
      do while( .not.lgEOF .and. chCard(1:1).ne.' ')
*       echo the line before we cap it, and trim it
        if(lgTalk) write(qq,'(23X,''*'',1X,A80,''*'')') chCard
*       change chCard to all caps after saving it
        call caps( chCard )
*       kill any part of line after one of end of line characters
*       do not do this if keyword no eol is no card
        if( .not. lgMatch('O EO',chCard) ) call TrimCard( chCard )
        chK1 = chCard(1:1)
        chKey4 = chCard(1:4)
        chKey3 = chCard(1:3)
        chKey5 = chCard(1:5)
*
*       check whether VARY is on line
        if( lgMatch( 'VARY' , chCard ) ) then
          lgVarOn = .true.
          if( nparm+1.gt.limpar ) then
            write(qq,'('' Too many VARY lines entered; the limit is'',
     1      i4)') limpar
            stop
          endif
        else
          lgVarOn = .false.
        endif
*
      if( chCard(1:2).eq.'C ' ) then
*       this is null test
        i = 1
*
*     start to look for keywords
      else IF( chKey4.eq.'ABSO' ) then
*       enter luminosity in absolute magnitudes, in reads2
        call absmag( chCard , nqh )
*
      else if( chKey3.eq.'AGE' ) then
*       enter age of cloud so we can check for time-steady reads2
        call GetAge( chCard )
*
      else if( chKey4.eq.'AGN ' ) then
*       enter generic style agn continuum, in reads2
        call GetAgn( chCard )
*
      else if( chKey4.eq.'ABUN' ) then
*       chemical composition, readsun
        call compos( chCard , lgDSet )
*       abundances no longer solar
        lgAbnSolar = .false.
*
      else if( chKey4.eq.'BACK' ) then
*       cosmic background, in readsun
        call backgr( nqh , chCard , ar1 )
*
      else if( chKey4.eq.'BLAC' ) then
*       black body, in reads2
        call blacfx( chCard , nqh , ar1 )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
*         no luminosity options on vary
          nvarxt(nparm) = 1
          chVarFmt(nparm) = '(''BLACKbody='',F15.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
*         log of temp will be pointer
          vparm(nparm,1) = log10( slope(nspec) )
          vincr(nparm) = 0.5
        endif
*
      else if( chKey4.eq.'BREM' ) then
*       brems continuum from central object
        nspec = nspec + 1
        if( nspec.gt.limspc) call TooManCon
        chSpType(nspec) = 'BREMS'
        i = 5
        slope(nspec) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       t can be entered either as t or log(t)
        if( slope(nspec).le.10. ) slope(nspec)=10.**slope(nspec)
        cutoff(nspec,1) = 0.
        if( lgVarOn ) then
           nparm = nparm + 1
*          only one parameter
           nvarxt(nparm) = 1
           chVarFmt(nparm) = '(''BREMS, T='',F9.5)'
*          pointer to where to write
           nvfpnt(nparm) = nRead
*          log of temp will be pointer
           vparm(nparm,1) = log10( slope(nspec) )
           vincr(nparm) = 0.5
         endif
*
      else if( chKey4.eq.'CASE' ) then
*       do case b - set tau-La to 10**9 if not specified
        lgCaseb = .true.
        i = 5
        tlamin = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          tlamin = 1e9
        else
          tlamin = 10. ** tlamin
        endif
*       Hummer and Storey case B; no collisions from n=1, 2 (usually in)
        if( lgMatch('HUMM',chCard ) ) lgCasBhs = .true.
*
      else if( chKey4.eq.'CEXT' ) then
*       add "extra" cooling, power law temp dependence
        lgCExtraOn = .true.
        i = 5
        CoolExtra = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        cextpw = fread( chCard , i , 76 , lgEOL )
*
      else if( chKey4.eq.'COMP' ) then
*       compile ascii version of stellar atmosphere continua in volk
        call compil( chCard )
*
      else if( chKey4.eq.'CONS' ) then
*       constant temperature, pressure, density, or gas pressure
*       in readsun
        call constn( chCard )
*
      else if( chKey4.eq.'CORO' ) then
*        coronal equilibrium; set constant temperature to number on line
*        in readsun
         call coronl( chCard , nqh , ar1 )
*
      else if( chKey4.eq.'COSM' ) then
*        C.R. heating, log of density of rel. electrons
         i = 5
         cryden = 10.** fread( chCard , i , 76 , lgEOL )
         if( lgEOL ) then
            if( lgMatch( 'BACK' , chCard ) ) then
*              galactic background cosmic ray density to produce
*              secondary ionization rate quoted by Tielens and Hollenbach
               cryden = 2e-9
               crtemp = 2.6e9
            else
               call NoNumb(chCard )
            endif
         else
*           optional power law density
            crpowr = fread( chCard , i , 76 , lgEOL )
*           option to specify a temp for non-rel electrons
            crtemp = fread( chCard , i , 76 , lgEOL )
            if( lgEOL ) then
*              relavistic limit (Balbus and McKee)
               crtemp = 2.6e9
            else
               crtemp = min( 10.**crtemp , 2.6e9 )
            endif
         endif
*
      else if( chKey4.eq.'COVE' ) then
*        covering factor for gas
         i = 5
         covgeo = fread( chCard , i , 76 , lgEOL )
         if( lgEOL ) call NoNumb(chCard )
         if( covgeo.le.0. ) covgeo = 10.** covgeo
         if( covgeo.gt.1. ) then
            write(qq,'('' A covering factor greater than 1 makes'',
     1      '' no physical sense.  Sorry.'')')
            stop
         endif
         covrt = covgeo
*
      else if( chKey4.eq.'CYLI' ) then
*       height of cylinder in cm
        i = 5
        lgCylnOn = .true.
        CylindHigh = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*
      else if( chKey4.eq.'DIEL' ) then
*       change various factors for dielectronic recombination
        if( lgMatch( 'KLUD' , chCard ) ) then
*       option to turn off guess of diel rec coef for 3rd row elements
          i = 3
          GuessDiel = fread( chCard , i , 76 , lgEOL )
        else if( lgMatch( 'BURG' , chCard ) ) then
*         modify suppression of burgess dielectronic recombinations
          if( lgMatch(' ON ' , chCard ) ) then
*           leave suppression on - this is default state
            lgSupDie(1) = .true.
          else if( lgMatch(' OFF' , chCard ) ) then
*           turn suppression off
            lgSupDie(1) = .false.
          else
            write(qq,'('' flag ON or OFF must appear.'')')
            stop
          endif
        else if( lgMatch( 'NUSS' , chCard ) ) then
*         modify suppression of nussbaumer and storey dielectronic recomb
          if( lgMatch(' ON ' , chCard ) ) then
*           turn suppression on
            lgSupDie(2) = .true.
          else if( lgMatch(' OFF' , chCard ) ) then
*           leave suppression off - this is default state
            lgSupDie(2) = .false.
          else
            write(qq,'('' flag ON or OFF must appear.'')')
            stop
          endif
        else
          write(qq,'('' key KLUDge, BURGess, or NUSSbaumer must '',
     1    ''appear.'')')
          stop
        endif
*
      else if( chKey4.eq.'DIFF' ) then
*        set method of transferring diffuse fields
         if( lgMatch( ' OTS' , chCard ) ) then
           chDffTrns = 'OTS'
         else if( lgMatch( ' OUT' , chCard ) ) then
           i = 4
           j = fread( chCard , i , 76 , lgEOL )
           if( lgEOL ) then
*            this is the default set in block data
             chDffTrns = 'OU2'
           else
             if( j.gt.0 .and. j.lt.10 ) then
               write(chDffTrns,'(''OU'',i1)') j
             else
               write(qq,'('' must be between 1 and 9 '')')
               stop
             endif
           endif
         else
           write(qq,'('' There should have been OUTward or OTS on '',
     1     ''this line.  Sorry.'')')
           stop
         endif
*
      else if( chKey4.eq.'DLAW' ) then
*       either use fabden routine, or read in table of points
*       >>chng 96 dec 12, broken out to routine
        call GetDLaw( chCard )
*
      else if( chKey4.eq.'DOUB' ) then
*       double optical depth scale after each iteration
        DoubleTau = 2.
*
      else if( chKey4.eq.'DRIV' ) then
*       call one of several drivers, readsun
        call driver( chCard )
*
      else if( chKey4.eq.'GRAI' ) then
*       read parameters dealing with grains, in reads2
        call GetGrain( chCard , lgDSet )
*
      else if( chKey4.eq.'EDEN' ) then
*       option to add "extra" electrons, to test compton limit
*       for very low T(star) - option is log of eden
        i = 5
        EdenExtra = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       warn that this model is meaningless
        lgPhysOK = .false.
*
      else if( chKey4.eq.'ELEM' ) then
*       change abundance of specific element
*       in reads2.f
        call rdelem( chCard )
*
      else if( chKey4.eq.'ENER' ) then
*       energy density (degrees K) of this continuum source
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = 'SQCM'
        teset = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( radius.eq.0. ) then
*         set radius to large value
          ar1 = rdfalt
          radius = 10.**ar1
        endif
*       convert temp to log, recognize linear option
        if( lgMatch( 'LINE' , chCard ).or.teset .gt.10. ) then
*         option for linear temperature, must store log
          teset = log10( teset )
        endif
        if(teset.gt.5. ) write(qq,'('' This intensity may be too '',
     1  ''large.  The code may crash due to overflow.  Was log '',
     2  ''intended?'')')
*       teset is not log of temp, now get log of total luminosity
        chSpNorm(nqh) = 'LUMI'
*       full range of continuum will be used
        range(nqh,1) = emm
        range(nqh,2) = egamry
        totpow(nqh) = 4. * teset - 4.2464476 + 0.60206
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) =
     1    '(''ENERGY DENSITY'',F9.5,'' log '')'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = log10( totpow(nqh) )
          vincr(nparm) = 0.1
          nvarxt(nparm) = 1
        endif
*
      else if( chKey4.eq.'ESCA' ) then
*       option to change escape probabilities, in reads2
        call esread( chCard )
*
      else if( chKey4.eq.'EXTI' ) then
*       extinguish ionizing continuum by absorbing column AFTER
*       setting luminosity or Q(H).  First number is the column
*       density (log), second number is leakage (def=0%)
*       last number is lowest energy (ryd), last two may be omitted
*       from right to left
        i = 5
        excolm = 10. ** fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       option to set leakage - default is 0.
        exleak = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) exleak = 0.
        if( exleak.lt.0. ) exleak = 10.**exleak
        if( exleak.gt.1. ) then
          if(lgTalk)write(qq,'('' A leakage of'',F9.0,''% was entered'',
     1     '' - this must be less than 100%'')') exleak*100.
          stop
        endif
*       option to set lowest energy for absorber
        exlow = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          exlow = 0.99946
        else
          if(exlow.le.0. ) exlow=10.**exlow
          if( exlow.lt.0.99946 )
     1    write(qq,'('' Energy less than 1 Ryd!!'')')
        endif
*
      else if( chKey4.eq.'FAIL' ) then
*       reset number of temp failures allowed, default=20
        i = 5
*       save previous value
        j = limfal
        limfal = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       'no map' flag, fail without mapping
        if( lgMatch( 'NO M' , chCard ) ) then
          lgNoMap = .true.
        endif
*       complain if failures was increased above default
        if( limfal.gt.j ) then
          write(qq,'('' Cloudy should not have problems making '',
     1    ''this command necessary.'')')
          write(qq,'('' Please show this input stream to Gary Ferland''
     1    ,'' if this command is really needed for this model.'')')
        endif
*
      else if( chKey4.eq.'FEII' ) then
        call GetFeII( chCard )
*
      else if( chKey4.eq.'FILL' ) then
*       filling factor, power law exponent (default=1., 0.)
        i = 5
        a = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( a.le.0. ) then
*          number less than or equal to 0, must have been entered as log
           FillFac = 10. ** a
        else
*          number greater than zero, must have been the real thing
           FillFac = a
           if( FillFac.gt.1.0 ) then
              if(lgTalk) then
                write(qq,'('' Filling factor > 1, reset to 1'')')
              endif
              FillFac = 1.
           endif
        endif
        fiscal = FillFac
*       option to have power law dependence
        filpow = fread( chCard , i , 76  , lgEOL )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) =
     1    '(''FILLING FACTOR='',F9.5,'' power='',F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = log10( FillFac )
          vincr(nparm) = 0.5
*         power law dependence here, but cannot be varied
          vparm(nparm,2) = filpow
          nvarxt(nparm) = 2
*         do not allow filling factor to go positive
          varang(1,nparm) = -1e38
          varang(2,nparm) = 0.
        endif
*
      else if( chKey4.eq.'FIRE' ) then
*       cosmic thermal background radiation, argument is redshift
        i = 5
*       if no number on line then FREAD returns z=0; i.e., now
        z = fread( chCard , i , 76 , lgEOL )
*       in readsun
        call firebl( z  , nqh , ar1 )
*
      else if( chKey4.eq.'FLUC' ) then
*       rapid density fluctuations, in readsun
        call GetFluc( chCard )
*
      else if( chKey4.eq.'F(NU' ) then
*       this is the specific flux at nu
*       following says n(nu) not nuF(nu)
        lgNu2 = .false.
*       in reads2
        call setflx( chCard , nqh , ar1 , 'SQCM' , lgNu2 )
*
      else if( chKey4.eq.'FORC' ) then
*       set temperature of first zone, but don't keep constant
*       log if < 10
        i = 5
        ForceTemp = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( lgMatch( ' LOG' , chCard ) .or.
     1  (ForceTemp.le.10. .and. .not. lgMatch('LINE',chCard ))) then
          ForceTemp = 10.**ForceTemp
        endif
        if( ForceTemp.lt.3. ) then
          write(qq,'('' TE reset to 3K: entered number too small.'')')
          ForceTemp = 3.
        endif
*
      else if( chKey4.eq.'FUDG' ) then
*       enter a fudge factor
        i = 5
        do j=1,nfudgc
          fudgea(j) = fread( chCard , i , 76 , lgEOL )
          if( .not.lgEOL ) nfudge = j
        end do
*
      else if( chKey4.eq.'GLOB' ) then
*       globule with density increasing inward
*       parameters are outer density, radius of globule, and density power
        call globsb( chCard )
*
      else if( chKey4.eq.'HDEN' ) then
*       hydrogen density, in reads2
        call hdread( chCard )
*
      else if( chKey4.eq.'HELI' ) then
*       stuff to do with helium, in reads2
        call heatom( chCard )
*
      else if( chKey4.eq.'HEXT' ) then
*       turbulent heating rate, so that first= log(erg(cm-3, s-1))
*       second is scale radius, so that HXTOT = TURHET*SEXP(TURRAD/
*    1  DEPTH)
        i = 5
        turhet = 10.** fread( chCard , i , 76 , lgEOL )
        a = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          turrad = 0.
        else
          turrad = 10. ** a
        endif
*       >>chng 97 feb 24, removed set of lgPhysOK to false since extra heat
*       is intended
*
      else if( chKey4.eq.'HIGH' ) then
*       approach equilibrium from high te
        lgTeHigh = .true.
*
      else if( chCard(1:8).eq.'HYDROGEN' ) then
*       stuff to do with hydrogen atom, in reads2
        call hatom( chCard )
*
      else if( chKey4.eq.'ILLU' ) then
*       illumination angle
        i = 5
        AngleIllum = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       default is degrees, but radian key also there
        if( lgMatch( 'RADI' , chCard ) ) then
*         entered as radians, convert to degrees first
          AngleIllum = AngleIllum / ( pi / 180. )
        endif
*       we now have degrees, make sure between 0 and 90
        if( AngleIllum.lt.0. .or. AngleIllum.ge.90. ) then
          write(qq,'('' Angle of illumination must be between 0 and'',
     1    '' 90.'')')
          stop
        endif
*       we really want 1. / cos( theta ) with theta in radians
        AngleIllum = AngleIllum * pi / 180.
        AngleIllum = 1. / cos( AngleIllum )
*
      else if( chKey4.eq.'INIT' ) then
*       read cloudy.ini initialization file
*       following is set to false after first pass through this sub
*       so that init file only read one time in multi run jobs
        if(lgNoInit) call GetInit(chCard)
*       both in reads2.f
        iReadWay = -1
*       initialize array reader, this sub does nothing but set
*       initial value of a variable, depending on value of iReadWay
        call rdinit
*
      else if( chKey5.eq.'INTEN' ) then
*       intensity of this continuum source
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = 'SQCM'
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( radius.eq.0. ) then
*         set radius to large value
          ar1 = rdfalt
          radius = 10.**ar1
        endif
        if( lgMatch( 'LINE' , chCard ) ) then
*         option for linear input parameter
          totpow(nqh) = log10( totpow(nqh) )
        endif
        chSpNorm(nqh) = 'LUMI'
*       rangr in readsun
        call rangr( nqh , chCard )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) =
     1    '(''INTENSITY'',F9.5,'' log range'',2F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = totpow(nqh)
          vincr(nparm) = 0.5
*         range option, but cannot be varied
          vparm(nparm,2) = log10( range(nqh,1) )
          vparm(nparm,3) = log10( range(nqh,2) )
          nvarxt(nparm) = 3
        endif
*
      else if( chKey5.eq.'INTER' ) then
*       interpolate on input tables for continuum, set of power  laws used
*       input ordered pairs nu( ryd or log(hz) ), log(fnu)
*       additional lines begin CONTINUE
*       first check that this is the one and only INTERP command
*       in readsun
        call GetInter( chCard , lgEOF )
        if( .not.lgEOF ) then
*         back up one line since this sub reads until unrecognized command
          nRead = nRead - 1
        endif
*
      else if( chKey4.eq.'IONI' ) then
*       inter ionization parameter U=Q/12 R*R N C;
*       defined per hydrogen, not per electron (as before)
*       radius must also be entered if spherical, but not needed if plane
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = 'SQCM'
        chSpNorm(nqh) = 'IONI'
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) = '(''IONIZATION PARAMETER='',F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = totpow(nqh)
          vincr(nparm) = 0.5
          nvarxt(nparm) = 1
        endif
*       set R to large value if U specified.
        if( radius.eq.0. ) then
          ar1 = rdfalt
          radius = 10.**ar1
        endif
*
      else if( chKey4.eq.'ITER' ) then
*       iterate to get optical depths and diffuse field properly
        i = 5
        itermx = fread( chCard , i , 76 , lgEOL ) - 1
        itermx = max( itermx , 1 )
        if( itermx.gt.itrdim-1 ) then
          write(qq,'('' No more than'',I3,'' can be performed ''
     1    ,''because of vector sizes; reduce ITER or increase '',
     2    ''itrdim in code.'')')itrdim
          stop
        endif
        if( lgMatch('CONV',chCard) ) then
*         option to keep iterating until it converges
          lgAutoIt = .true.
*         above would have been legitimite setting of ITERMX, set to default 10
          if( lgEOL ) itermx = 10 - 1
          a = fread( chCard , i , 76 , lgEOL )
*         change convergence criteria, preset in zero
          if( .not.lgEOL ) autocv = a
        endif
*
      else if( chKey4.eq.'L(NU' ) then
*       this is the specific luminositiy at nu
*       following says n(nu) not nuF(nu)
        lgNu2 = .false.
*       in reads2
        call setflx( chCard , nqh , ar1 , '4 PI' , lgNu2 )
*
      else if( chKey4.eq.'LASE' ) then
*       mostly one frequency (a laser) to check gamma's
        nspec = nspec + 1
        if( nspec.gt.limspc ) call TooManCon
        chSpType(nspec) = 'LASER'
        i = 5
        slope(nspec) = fread( chCard , i , 76 , lgEOL )
        if( slope(nspec).le.0. ) slope(nspec) = 10.**slope(nspec)
        if( lgEOL ) call NoNumb(chCard )
*
      else if( chKey4.eq.'LUMI' ) then
*       luminosity of this continuum source
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = '4 PI'
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( lgMatch( 'LINE' , chCard ) ) then
*          option for linear input parameter
           totpow(nqh) = log10( totpow(nqh) )
        endif
        chSpNorm(nqh) = 'LUMI'
        if( lgMatch( 'SOLA' , chCard ) ) then
*          option to use log of total lumin in solar units
           range(nqh,1) = emm
           range(nqh,2) = egamry
           totpow(nqh) = totpow(nqh) + 33.5827
        else
*          rangr in readsun
           call rangr( nqh , chCard )
        endif
*       vary option
        if( lgVarOn ) then
           nparm = nparm + 1
           chVarFmt(nparm) =
     1     '(''LUMINOSITY'',F9.5,'' log range'',2F9.5)'
*          pointer to where to write
           nvfpnt(nparm) = nRead
           vparm(nparm,1) = totpow(nqh)
           vincr(nparm) = 0.5
*          range option in, but cannot be varied
           vparm(nparm,2) = log10( range(nqh,1) )
           vparm(nparm,3) = log10( range(nqh,2) )
           nvarxt(nparm) = 3
        endif
*
      else if( chKey4.eq.'MAGN' ) then
*       log of magnetic field (gauss) to turn on cyclotron cooling
        i = 5
        CycloCoolCoef = 10.**( 2.*fread( chCard , i , 76 , lgEOL ) )
        if( lgEOL ) call NoNumb(chCard )
*       coef is 4/3 /8pi /c * vtherm(elec)
        CycloCoolCoef = CycloCoolCoef * 4.5433e-25
*
      else if( chKey4.eq.'MAP ' ) then
*       do cooling space map for specified zones, in reads2
        call maprng( chCard )
*
      else if( chKey4.eq.'META' ) then
*       read depletion for metals, all elements heavier than He
*       in reads2
        call rmetal( chCard )
*       abundances no longer solar
        lgAbnSolar = .false.
*
      else if( chKey4.eq.'NEUT' ) then
*       heating and ionization due to fast neutrons, arg is total luminosity
*       in neutrons rel to boblmetric lumin; sec number is efficiency
        i = 5
        frcneu = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( frcneu.gt.0. ) frcneu = log10( frcneu )
        lgNeutrnHeatOn = .true.
        effneu = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          effneu = 1.0
        else
          if( effneu.le.0. ) effneu = 10.**effneu
        endif
*
      else if( chKey3.eq.'NO ' ) then
*       don't do something, in readsun
        call dont( chCard )
*
      else if( chKey4.eq.'NORM' ) then
        call GetNorm( chCard )
*        normalise lines to this rather than h-b, sec number is scale factor
*        i = 5
*        norm = -fread( chCard , i , 76 , lgEOL )
*        if( lgEOL ) call NoNumb(chCard )
*        sclnrm = fread( chCard , i , 76 , lgEOL )
*        if( lgEOL ) sclnrm = 1.
*
      else if( chKey4.eq.'NUF(' ) then
*       flux density of this continuum source, at optional frequency
*       expressed as product nu*f_nu
        lgNu2 = .true.
*       in reads2
        call setflx( chCard , nqh , ar1 , 'SQCM' , lgNu2 )
*
      else if( chKey4.eq.'NUL(' ) then
*       specific luminosity density of this continuum source, at opt freq
*       expressed as product nu*f_nu
        lgNu2 = .true.
*       in reads2
        call setflx( chCard , nqh , ar1 , '4 PI' , lgNu2 )
*
      else if( chKey4.eq.'OPTI' ) then
*       option to optimize the model by varying certain parameters
*       in reads2
        call optred( chCard )
*
      else if( chKey4.eq.'PHI(' ) then
*       enter phi(h), the number of h-ionizing photons/cm2
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc)  call TooManCon
        chRSpec(nqh) = 'SQCM'
        chSpNorm(nqh) = 'PHI '
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( radius.eq.0. ) then
*         set radius to large value
          ar1 = rdfalt
          radius = 10.**ar1
        endif
*       check if continuum so intense that crash is likely
        if( totpow(nqh).gt.29. ) then
          write(qq,'('' Is the flux for this continuum correct?'')')
          write(qq,'('' It appears too bright to me.'')')
        endif
*       rangr in readsun
        call rangr( nqh , chCard )
*       vary option
        if( lgVarOn ) then
           nparm = nparm + 1
           chVarFmt(nparm) =
     1     '(''phi(h)'',F9.5,'' log range'',2F9.5)'
*          pointer to where to write
           nvfpnt(nparm) = nRead
           vparm(nparm,1) = totpow(nqh)
           vincr(nparm) = 0.5
*          range option in, but cannot be varied
           vparm(nparm,2) = log10( range(nqh,1) )
           vparm(nparm,3) = log10( range(nqh,2) )
           nvarxt(nparm) = 3
        endif
*
      else if( chKey4.eq.'PLOT' ) then
*       make plot of log(nu.f(nu)) vs log(nu) or opacity
*       in file plot
        call pread( chCard )
*
      else if( chKey4.eq.'POWE' ) then
*       power law with cutoff, in reads2
        call plwcon( chCard )
*
      else if( chKey4.eq.'PRIN' ) then
*       adjust print schedule, in readsun
        call GetPrint( chCard , lgEOL )
*
      else if( chKey4.eq.'PUNC' ) then
*       punch something, in punch
        call GetPunch( chCard )
*
      else if( chKey4.eq.'Q(H)' ) then
*       log of number of ionizing photons
        i = 5
        nqh = nqh + 1
        if( nqh.gt.limspc ) call TooManCon
        chRSpec(nqh) = '4 PI'
        chSpNorm(nqh) = 'Q(H)'
        totpow(nqh) = fread( chCard , i , 76 , lgEOL )
        if( totpow(nqh).gt.100..and.lgTalk )
     1   write(qq,'('' Is this reasonable?'')')
        if( lgEOL ) call NoNumb(chCard )
*       rangr in readsun
        call rangr( nqh , chCard )
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          chVarFmt(nparm) =
     1    '(''Q(H)'',F9.5,'' log range'',2F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
          vparm(nparm,1) = totpow(nqh)
          vincr(nparm) = 0.5
*         range option in, but cannot be varied
          vparm(nparm,2) = log10( range(nqh,1) )
          vparm(nparm,3) = log10( range(nqh,2) )
          nvarxt(nparm) = 3
        endif
*
      else if ( chKey4.eq.'QHEA' ) then
*        (K Volk) added QHEAT here
         iopt=0
*        Turn on quantum heating heating (ignored if grains are not PAHs unless
*        they have the qheat keyword on the card)
         call setqhe(chCard, lgQHeat, iopt)
*
      else if( chKey4.eq.'RATI' ) then
*       enter a continuum luminosity as a ratio of
*       nuFnu for this continuum relative to a previous continuum
*       format; first number is ratio of second to first continuum
*       second number is energy for this ratio
*       if third numbewr on line, then 2nd number is energy of
*       first continuum, while 3rd number is energy of second continuum
*       in reads2
        call cratio( chCard , nqh )
*
      else if( chKey4.eq.'RADI' ) then
*       log of inner and outer radii, default second=infinity,
*       if R2<R1 then R2=R1+R2
*       there is an optional keyword, "PARSEC" on the line
*       to use PC as units, reads2
        call radi( chCard , ar1 )
*
      else if( chKey4.eq.'ROBE' ) then
        lgOut2In = .true.
*
      else if( chKey4.eq.'SET ' ) then
*       set something, in reads2
        call GetSet( chCard )
*
      else if( chKey4.eq.'SPEC' ) then
*       special key, can do anything
        lgVrrFit = .false.
*
      else if( chKey4.eq.'SPHE' ) then
*       compute a spherical model, diffuse field from other side in
*       in reads2
        call sphset( chCard )
*
      else if( chKey4.eq.'STOP' ) then
*       stop model at desired zone, temperature, column density or tau-912
*       in readsun
        call stopr( chCard )
*
      else if( chKey4.eq.'TABL' ) then
*       interpolate on input tables for continuum, set of power  laws used
*       input stored in big BLOCK data
*       first check that this is the one and only INTERP command
*       in readsun
        call GetTable( nqh , chCard , ar1 , nTabRead )
*
      else if( chKey4.eq.'TAUM' ) then
*       minimum optical depths for lines (normally 1e-20)
*       (used in STARTER to set lines up)
        i = 5
        taumin = 10.**fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*
      else if( chKey4.eq.'TIME' ) then
        write(qq,'('' This command not now implemented.'')')
*       following will stop things here
        call NoNumb( chCard )
        i = 5
        itime = fread( chCard , i , 76 , lgEOL )
        tmt1 = 10. ** fread( chCard , i , 76 , lgEOL )
        tmpwr = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          tmpwr = 0.
          tmt1 = 0.
        endif
*
      else if( chKey4 .eq. 'TITL' ) then
*       read in title of model
        chTitle = chOrgCard(6:80)
*
      else if( chKey4.eq.'TOLE' ) then
*       tolerance in heating cooling match, number is error/total
        i = 5
        toler = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
*       >>chng 96 dec 31, added below so negative is log
        if( toler.le.0. ) toler = 10.** toler
*
      else if( chKey4.eq.'TRAC' ) then
*       turn on trace output, in reads2
        call GetTrace( chCard )
*
      else if( chKey4.eq.'TURB' ) then
*       turbulent velocity in km/sec
        i = 5
        TurbVel = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) call NoNumb(chCard )
        if( lgMatch( ' LOG' , chCard ) ) TurbVel = 10. ** TurbVel
*       convert to cm/sec
        TurbVel = TurbVel * 1e5
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
*         only one parameter to vary
          nvarxt(nparm) = 1
          chVarFmt(nparm) = '(''TURBULENCE='',F9.5,'' log'')'
*         pointer to where to write
          nvfpnt(nparm) = nRead
*         turbulent velocity
          vparm(nparm,1) = log10( TurbVel/1e5 )
          vincr(nparm) = 0.5
        endif
*
      else if( chKey4.eq.'WIND' ) then
*       wind structure, parameters are initial velocity and optional mass
*       v in km/sec, mass in solar masses
        i = 5
        windv0 = fread( chCard , i , 76 , lgEOL ) * 1e5
        if( windv0.le.0. ) then
          write(qq,'('' The initial wind velocity must be positive.'',
     1    ''  Sorry.'')')
          stop
        else if( windv0.le.1.e6 ) then
*         speed of sound roughly 10 km/s
          write(qq,'('' >>>>Initial wind velocity should be greater'',
     1    '' than speed of sound; calculation only valid above sonic'',
     2    '' point.'')')
          lgWindOK = .false.
        endif
        if( lgEOL ) call NoNumb(chCard )
        windv = windv0
        comass = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) comass = 1.
        chCPres = 'WIND'
*       used for line width
        chRedis = 'WIND'
*
*       end end end end end end end end end end end end end end end end
*       these are first col characters that mean line totally
*       ignored.  usually stripped out in fillar, but could
*       be input here is code called as sub
        else if(chK1.ne.'#' .and. chK1.ne.'*' .and. chK1.ne.'%' ) then
*         end of keys - if we get here key is unrecognized----------
          write(qq,'(''  Unrecognized command. Key="'',A4,
     1    ''".  This is routine readr.'')')
     1    chKey4
          write(qq,'('' The line image was='',A80)') chCard
          write(qq,'('' Sorry.'')')
          stop
        endif
        call readar( chCard , lgEOF )
      end do
*
*-------------------------------------------------------------------
*
*     hit lgEOL or blank line
*     free statement numbers after here, >=204
*
*     K Volk check for qheat option from a "grains" command without the "QHEAT"
*     command -- if so, pretend the card has been put in
      lgQHet = .false.
      do i=1,ndust
        if (lgQHeat(i)) lgQHet = .true.
      end do
*     if qheat command ever appeared then qtmax is non-zero
      if (qtmax.eq.0.) then
*       there were not qheat commands, but qheat was turned on, on a grains line
*       generate dummy command line and call setqhe to get defaults
        chCard='QHEAT'
*
        do j=6,80
          chCard(j:j)=' '
        end do
*
        iopt=1
        call setqhe(chCard,lgQHeat,iopt)
      end if
*     end of changes (K Volk)
*
*
      do i=1,80
        chCard(i:i) = ' '
      end do
      if( lgTalk ) then
        write(qq,'(23X,''*'',1X,A80,''*'')') chCard
        write(qq,'(23X,83(''*'')///)')
      endif
*
*     set flag so that we will not actually read cards in again
      lgNoInit = .false.
*
      if( chCPres.eq.'DLW1' ) then
        hden = log10(fabden(radius,depth))
      else if( chCPres.eq.'DLW2' ) then
*       >>chng 96 nov 29, added tabden, based on Kevin Volk code
        hden = log10(tabden(radius,depth))
      endif
*
*     sanity checks for some of the things read in, in reads2
      call readck( nqh )
      hden = 10. ** hden
      rinner = radius
*     mass loss rate for wind model, normally WINDV0=0
      emdot = hden * windv0
*
*     iterate to convergence and wind models are mutually exclusive
      if( windv0.gt.0. .and. lgAutoIt ) then
        write(qq,'('' Due to the nature of the Sobolev'',
     1  '' approximation, it makes no sense to converge a windy model.''
     2  )')
        write(qq,'('' Iterate to convergence is turned off'')')
        lgAutoIt = .false.
        itermx = 0.
      endif
*
*     this is an option to turn on trace printout on the nth
*     call from the optimizer - only allow trace if
*     this is the case and NOPTIM 1 below nTrOpt
      if( lgTrOpt ) then
*       nTrOpt was set with "optimize trace" command,
*       is iteration to turn on trace
        if( nTrOpt.ne.noptim ) then
          lgTrace = .false.
*         following overrides turning on trace elsewhere
          lgTrOvrd = .false.
        else
          lgTrace = .true.
          lgTalk = .true.
          lgTrOvrd = .true.
          write(qq,'('' READR turns on trace from optimize option.'')'
     1    )
        endif
      endif
*
      end
******************************************************************************
      subroutine ReadTable(io)
      implicit none
*called by TABLE READ to read in continuum from PUNCH TRANSMITTED CONTINUUM
      integer io
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limpun
      parameter (limpun=20 )
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real tmn
      common/tmn/ tmn(ncell)
      real ConTabRead
*save array for table read command, to save continuum previously punched
      common/cnread/ ConTabRead(ncell)
      integer ipPnunit , npunch
      real punarg
*     ipPnunit is io unit number, number of punch commands eneterd
*     punarg is set of optional arguments for the punch command
      common/pnunit/ ipPnunit(limpun) , npunch , punarg(limpun,3)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chExtra*80
      integer ierr , i , nPoints
      real Differ , fread , EnerLast
      logical lgEOL
*
*     check whether any other punch on this unit
      do i=1,npunch
        if( io.eq.ipPnunit(i) ) then
          write(qq,'('' ReadTable: PUNCH output has been requested '',
     1    ''on the same i/o unit as TABLE READ - continuum file has '',
     2    ''been clobbered.'')')
          write(qq,'('' The conflicting unit is'',i4)') io
          write(qq,'('' Please confirm no punch/read conflicts, '',
     1    ''recreate continuum file, and rerun.'')')
          stop
        endif
      end do
*
*     ok if called iteratively, since closed at the end
      open(io,iostat=i,status='old')
      if( i.ne.0 ) then
        write(qq,'('' TABLE READ did not find fort file, unit='',i3)')io
        stop
      endif
*
*     read in first two lines of header
      read(io,'(a80)') chExtra
*     first number on this line is version number, confirm that
*     this is greater than 90.01 due to bug in punch tran con in 90.00
      i = 1
*     first number should be version number of code
      Differ = fread( chExtra , i , 76 , lgEOL )
      if( Differ.lt.90.04 ) then
        write(qq,'(a80)') chExtra
        write(qq,'('' This transmitted continuum file was produced '',
     1  ''by an older version of Cloudy.  '')')
        write(qq,'('' It must be recreated with version 90.04 or '',
     1  ''later.'')')
        write(qq,'('' The version I read in was'',f6.2)') Differ
        write(qq,'('' Sorry.'')')
        stop
      endif
      read(io,'(a80)') chExtra
*
*     now read in the file of numbers
      ierr = 0
      i = 1
      do while( ierr.eq.0 .and. i.lt.ncell )
        read(io,*,iostat=ierr) tmn(i) , ConTabRead(i)
        i = i + 1
      end do
*     put pointer at last good value
      nPoints = i - 2
*
*     check that sane number of values entered
      if( nPoints.lt.1 ) then
        write(qq,'('' ReadTable, fort file for TABLE READ has too few'',
     1  '' points, ='',i5)') nPoints
        stop
      endif
*
*     check on units of energy scale, convert to Rydbergs if necessary
*     tmn is scale read in from punch file, anu is correct scale
*     EnerLast is energy of last point in rydbergs
      EnerLast = tmn(nPoints)
      if( abs(tmn(1) - anu(1)) / anu(1) .gt.1e-3 ) then
*       first energy does not appear to have been in Rydbergs
        if ( tmn(1).lt.0. ) then
          write(qq,'('' ReadTable:  the first energy in table read '',
     1    ''file is not positive.  Something is wrong.'')')
          stop
        else if ( abs(tmn(1) - rydlam/anu(1)*1e-4)/tmn(1).lt.1e-3 ) then
*         wavelength in microns
          EnerLast = rydlam / tmn(nPoints) /1e4
        else if ( abs(tmn(1) - rydlam/anu(1))/tmn(1).lt.1e-3 ) then
*         wavelength in Angstroms
          EnerLast = rydlam / tmn(nPoints)
        else if ( abs(tmn(1) - anu(1)*evryd*1e-3)/tmn(1).lt.1e-3 ) then
*         wavelength in keV
          EnerLast = tmn(nPoints) / evryd / 1e-3
        else if ( abs(tmn(1) - anu(1)*evryd)/tmn(1).lt.1e-3 ) then
*         wavelength in eV
          EnerLast = tmn(nPoints)/evryd
        else
          write(qq,'('' ReadTable:  the energy scale in the table '',
     1    ''read file makes no sense to me.'')')
          stop
        endif
      endif
*
*     now check now the energies of the highest points agree
      Differ = abs( EnerLast - anu(nPoints) ) / anu(nPoints)
      if( Differ.gt.0.001 ) then
        write(qq,'('' ReadTable: The energy mesh of the file read in '',
     1  ''by the TABLE READ command does not agree with this version '',
     2  ''of Cloudy.'')')
        write(qq,'('' ReadTable: Was the file generated by an older '',
     1  ''version of the code?'')')
        write(qq,'('' ReadTable: Number of points read in='',i5)')
     1  nPoints
        write(qq,'('' ReadTable: input, internal energies='',1p,2e12.4)'
     1  )tmn(nPoints) , anu(nPoints)
        stop
      endif
*
*     make sure rest of array has valid zeros
      do i=nPoints+1,ncell
        ConTabRead(i) = 0.
      end do
*
      close(io)
*
      end
******************************************************************************
      subroutine reageo( io )
      implicit none
*write the comment about type of geometry at end of calculation
      integer io
      character chRgcln*132
*     a comment about the geometry after model stops
      common/rgcom/ chRgcln(2)
*
      write(io,'(a132)') chRgcln
*
      end
*
*******************************************************************
      subroutine RebinRauch(stflux,wlin,flin)
      implicit none
* rebin the rauch continuum grid onto the cloudy grid by K Volk
      integer nvals
      parameter (nvals=19951)
*     Arrays passed in from "GetRauch"
      real stflux(nvals),wlin(nvals),flin(nvals)
*
* This is mostly a copy of "RebinAtlas" except that I pass in the arrays
* rather than the integer values, since both values needed will
* be fixed before this routine is called and since the model arrays are
* much larger than the Cloudy grid size.  Also I do linear interpolation
* rather than log-log interpolation here.
*
* stflux holds the current model flux densities F_nu in erg/s/cm^2/Hz.
* wlin holds the wavelengths in Angstroms.
* flin will have the rebinned fluxes in it upon return.
*
*     limit to number of cells in frequency array
*     NB is this every is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes
      real SpeedLight
*from Physics Today Aug '96, BG 10
      parameter (SpeedLight=2.99792458E10 )
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      real widflx
      common/widflx/ widflx(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real wlryd(nvals)
*
*     local variables
      real rydb,slope(nvals),value,sum,x1,x2,v2,v1,slope2
      integer i , j , i1,i2
      real edge1,edge2
*
      rydb=10967758.30
* These are the speed of light and H-atom Rydberg constant in MKS units, for
* conversion of frequency to rydberg units.  The infinite mass
* R value is 10973731.534 and the proton to electron mass ratio is
* 1836.152701 for this calculation.
*
* Convert wavelengths from angstroms to rydberg; in the calling routine
* I assured that the wavelengths are decreasing in the array.
*
      do j=1,nvals
        wlryd(j)=1.e+10/(wlin(j)*rydb)
      end do
* Calculate the slopes for interpolation between the Rauch model points.
* Since the model points are closely spaced I will use linear interpolation.
*
      do j=1,nvals-1
        slope(j)=(stflux(j+1)-stflux(j))/(wlryd(j+1)-wlryd(j))
      end do
*
      slope2=2.0
* this is the Rayleigh-Jeans slope in F_nu, for "low" frequency extrapolation.
*
* Actually the extrapolation does not match too well for the lower temperature
* models, but if the long wavelength stellar continuum level matters in the
* results then something strange is going on anyway.
*
      do j=1,nRauch
*       lower and upper bounds of this energy cell
        edge1=anu(j)+0.5*widflx(j)
        edge2=anu(j)-0.5*widflx(j)
        if (edge2.lt.wlryd(1)) then
          flin(j)=stflux(1)*((anu(j)/wlryd(1))**slope2)
        else
          if (edge2.gt.wlryd(nvals)) then
             flin(j)=0.0
          else
            i1=0
            i2=0
*
            do i=1,nvals-1
              if(wlryd(i).le.edge2.and.wlryd(i+1).gt.edge2) i2=i
              if(wlryd(i).le.edge1.and.wlryd(i+1).gt.edge1) i1=i
            end do
*
            sum=0.
*
            if (i1.eq.i2) then
              flin(j)=stflux(i1)+slope(i1)*(anu(j)-wlryd(i1))
            else
*
              do i=i2,i1
              v1=max(wlryd(i),edge2)
              v2=min(wlryd(i+1),edge1)
              value=v2-v1
              x1=stflux(i)+slope(i)*(v1-wlryd(i))
              x2=stflux(i)+slope(i)*(v2-wlryd(i))
              sum=sum+(x1+x2)*value
              end do
*
              sum=sum/(2.*widflx(j))
              flin(j)=sum
            end if
*
          end if
        end if
      end do
*
      end
******************************************************************************
      real function receff( ip )
      implicit none
*generate escape probability function for continua,
      integer ip
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real e2TauAbs
*E2(tau) exponential integral
      common/e2tau/ e2TauAbs(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otsmin
      common/otsmin/ otsmin
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
*     these are the integrated absorption and scattering optical depths
*     to the illuminated face of the cloud
      real depabs , depsct
      common/deptau/ depabs(ncell) , depsct(ncell)
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      real opac
      common/opac/ opac(ncell)
      real tmn
      common/tmn/ tmn(ncell)
      real ExpZone
*exp(-tau) for the current zone only
      common/facexp/ ExpZone(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
      real hnukt , tin , escin , escpcn, tout , escout
      real sum , denom , dEner
      integer i
*
*     escape probability functin for continua,
*     formally correct for photoelectric absorption only
      if( ip.gt.nflux ) then
        receff = 0.
        return
      endif
*
*     bug in following statement unocvered June 93 S. Schaefer
      hnukt = te1ryd * anu(ip)/te
*
*     inward optical depth and escape prob
      if( chDffTrns.EQ.'OTS' ) then
        tin = tauabs( ip , 1 )
        if( tin.lt.5. ) then
          escin = escpcn( tin , hnukt )
        else
          escin = 1e-4
        endif
*
*       outward optical depth
        tout = tauabs( ip , 2 ) - tin
*
        if( lgTauOutOn ) then
          if( tout.gt.0. ) then
            if(tout.lt.5. ) then
              escout = escpcn( tout , hnukt )
            else
              escout = 1e-4
            endif
            receff = 0.5*(escin + escout)
          else
*           this logic added april 93 to prevent big change in
*           esc prob, resulting in terminal oscillations, when optical
*           depth scale overrun
*           tau was negative, use 5% of inward optical depth
            escout = escpcn( tin*0.05 , hnukt )
            receff = 0.5*(escin + escout)
          endif
        else
          receff = escin
        endif
      else if( chDffTrns.eq.'OU1' ) then
        receff = ExpZone(ip+2)
      else if( chDffTrns.eq.'OU2' ) then
*       this is the default, set in zero
        receff = e2TauAbs(ip+2)
      else if( chDffTrns.eq.'OU3' ) then
        receff = 1.
      else if( chDffTrns.eq.'OU4' ) then
*       this cannot happen, was the former outward treat
*       optical depth for this zone
        if( ContBoltz(ip).gt.0. ) then
          i = ip
          dEner = te / te1ryd * 0.5
          sum = 0.
          denom = 0.
          do while ( ContBoltz(i).gt.0. .and.(anu(i)-anu(ip)).lt.
     1      dEner.and.i.le.nflux )
            sum = sum + ContBoltz(i) * tmn(i)
            denom = denom + ContBoltz(i)
            i = i + 1
          end do
          receff = sum / denom
        else
          receff = tmn(ip)
        endif
      else
        write(qq,'('' RECEFF does not understand the transfer method='',
     1  A3)') chDffTrns
        stop
      endif
*
      receff = max( otsmin , receff )
*     can get epsilon above unity on cray
      receff = min( 1. , receff )
*
      end
******************************************************************************
      subroutine reset
      implicit none
*reset many variables at the start of a new iteration
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      integer limelm
      parameter (limelm=30)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real hnsav(lmhlvl+1),he1nsav(nhe1lvl+1),he2nsav(nhe2lvl+1)
*     these are used to reset the level popls of the h and he model atoms
      common/HHePopSv/ hnsav,he1nsav,he2nsav
      real reftot,avhden,chii, avdust , avdpot , thtot
      common/toiii/ reftot,avhden,chii,
     1 avdust(ndust) , avdpot(ndust) , thtot
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      real xLaMase
*smallest Lya optical depth that occured in the calculation
      common/LaMase/ xLaMase
      integer ipxry
      real tauxry
      common/xry/ ipxry , tauxry
      real glbden , glbrad , glbpow , glbdst
      common/globul/ glbden , glbrad , glbpow , glbdst
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real BigEdenError
      integer ipEdenError
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      common/EdError/ BigEdenError , ipEdenError
      real chs,chps,ohs,ohps,otwos,ctwos,cos,cops,h2os,h2ops,
     1 o2ps,c2ps,h3ps,h3ops,ch2ps,ch2s,ch3s,cps
      common/hevmls/ chs,chps,ohs,ohps,otwos,ctwos,cos,cops,h2os,h2ops,
     1 o2ps,c2ps,h3ps,h3ops,ch2ps,ch2s,ch3s,cps
      logical lgNxtDROff
*flag telling nextdr whether this is first call or not
      common/ndroff/ lgNxtDROff
      integer nUnstable
      logical lgUnstable
*keep track of possibly thermall unstagle models
*nUnstable is number of zones that were possibly thermall unstable
*lgUnstable is set in ionte and says that current consitions possibly unstable
      common/nustbl/ nUnstable , lgUnstable
      real dDensityDT, dndtSave
*deriv of density needed for expansion cooling
      common/dndt/ dDensityDT, dndtSave
      real BiggestH2
*max H2/H ratio that occured in the calculation, set in hmole
      common/h2max/ BiggestH2
      real EdenTrue
*     this is the true eden as set in esum
*     we will try to converge eden to this
      common/TrueEden/ EdenTrue
      real CarMolFrac
*largest fraction of carbon that went molecular
      common/cmfrac/ CarMolFrac
      real rjnmin , ajmmin
      common/jmin/ rjnmin , ajmmin
*     include "filfac.com"
      integer kapots , kap911
      common/kapots/ kapots , kap911
      real tgrmax
      common/tgrmax/ tgrmax(ndust)
      real opac
      common/opac/ opac(ncell)
      real opacsv
      common/opacsv/ opacsv(ncell)
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real sctsav
      common/sctsav/ sctsav(ncell)
      real oldcla
      common/oldcla/ oldcla
      logical lgLotsCO
*flag saying that there is lots of CO, triggers lgEndFun stopping model
      common/lotsco/ lgLotsCO
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      double precision he3bn
      common/he3bn/ he3bn(nhe3lvl)
      double precision heb1sv , heb2sv , heb3sv
      common/hebnsv/ heb1sv(10) , heb2sv(10) , heb3sv(nhe3lvl)
*these are a series of lines and continuua that are set in hediff and
*carried outward in metdif
      real esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      common/heots/ esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      real smbeta , cn4861 , cn1216
      common/smbeta/ smbeta , cn4861 , cn1216
      real totlum , totlsv
      common/totlum/ totlum , totlsv
      real sv4861 , sv1216
      common/sv4861/ sv4861 , sv1216
      real qhtot , qhe , qheii , qbal , qrad , qtot
      common/qs/ qhtot , qhe , qheii , qbal , qrad , qtot
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      real hlmax
*     remember max photo rate for var h levels, by h lines
      common/hlmax/ hlmax(lmhlvl)
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
      real ophf
      common/ophf/ ophf(lmhlvl)
      real ophs, ophe2s, ophe1s
      common/ophs/ ophs(lmhlvl) , ophe2s(nhe2lvl), ophe1s(nhe1lvl)
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer iontot
      common/iontot/ iontot
      real DustHeatLya , dstpow , dstsum , dincon,dstotl,dhcol,HDustDif
*     HDustDif is heating of grains in current zone due to diffuse fields
*DustHeatLya is heating of dust due to Lya
      common/dhla/ DustHeatLya , dstpow , dstsum , dincon ,dstotl,dhcol,
     1 HDustDif
      logical lgPradCap , lgPradDen
*lgPradCap true if radiation pressure capped on first iteration
*lgPradDen capped by thermalization length
      common/prdcap/ lgPradCap , lgPradDen
      logical lgDrMinUsed
*set true is calculations stops because zone thickness gets too small
      common/drminu/ lgDrMinUsed
      logical lgVelPos
*flag set if wind solution had negative velocity
      common/velpos/ lgVelPos
      logical lgNegGrnDrg
*flag set if negative grin drag force encountered
      common/negdrg/ lgNegGrnDrg
      logical lgUSphON
*lgUSphON flag set when we hit stromgren radius in spherical geometry
      real rstrom
      common/uspher/ lgUSphON , rstrom
      real AccelAver , acldr
*variables for tracking average radiative acceleration
      common/aclbar/ AccelAver , acldr
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real tmn
      common/tmn/ tmn(ncell)
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      real e2TauAbs
*E2(tau) exponential integral
      common/e2tau/ e2TauAbs(ncell)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real x12
      common/x12/ x12
      real supsav , savion , savla , hetsav , savefi,x12sav
      common/supsav/ supsav , savion , savla , hetsav , savefi,x12sav
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real uh,uheii
      common/u/ uh,uheii
      integer lfes,lcas,nscas,nsca1s,nsfes,nsfe1s,nsnis,nsni1s,lnis
     1 ,nscos,lcos
      common/lfes/ lfes,lcas,nscas,nsca1s,nsfes,nsfe1s,nsnis,nsni1s,lnis
     1 ,nscos,lcos
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real xIonFsave , HeatSave
*     args are atomic number, ionization stage
      common/IonFsave/ xIonFsave(limelm,0:limelm+1) ,
     1 HeatSave(limelm,limelm)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real solar
      common/solar/ solar(limelm)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real he1cin
      common/he1cin/ he1cin(10)
      real he2cin
      common/he2cin/ he2cin(10)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real hi , hii
      common/h/ hi , hii
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real otssav
      common/otssav/ otssav(ncell,2)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real FluxSave
*save incident continuum for later iterations
      common/flxsav/ FluxSave(ncell)
      real hisv,hiisv,hsv,edsav,EDOthSav,EDMSav
      common/save/ hisv,hiisv,hsv,edsav,EDOthSav,EDMSav
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real h2sav,h2psav,hmisav,ohmsav,h3psav
      common/hmisav/ h2sav,h2psav,hmisav,ohmsav,h3psav
      real drSave , drnsv
*save initial dr, and drnext
      common/drsv/ drSave , drnsv
      real drNext
*next dr, as set in nextdr
      common/drnxt/ drNext
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real he1sav , he2sav , he3sav , heisav
      common/hesav/ he1sav , he2sav , he3sav , heisav
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      logical lgTrOvrd
*flag affecting which iteration to turn on trace
      common/trovrd/ lgTrOvrd
      real pca2ex
      common/pca2ex/ pca2ex
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      real stimax
      common/stimax/ stimax(2)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      real EdenMet , EdenNotH
*     EdenMet is sum of electrons from Lit through n=30, all ions
*     EdenNotH is total electron density less the proton density
*     used in hydrogen loop for charge conservation
      common/EdenOther/ EdenMet , EdenNotH
      real SavOutCon(ncell)
*     variables related to deriving the ratio of outward to incident continuum
*     SumOutMax - energy where max occurs, ipSumOutMax pointer to this
*     sumOutCon is summed out outlin and outcon less SavOutCon for all energy
*     SumHOutCon is H-ionizing only
      real SumOutCon , SumIncCon , SumHOutCon , SumHIncCon , SumOutMax
      integer ipSumOutMax
      common/SumOutInc/ SumOutCon , SumIncCon , SavOutCon , SumHOutCon ,
     1 SumHIncCon , SumOutMax , ipSumOutMax
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      logical lgHMtrxOff
      common/MtrxOff/ lgHMtrxOff
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real OldOpacSave
      logical lgOTSOn
*save previous opacity
      common/OldOpac/ OldOpacSave(ncell)  , lgOTSOn(ncell)
      logical lgEdenBad
      integer nzEdenBad
*some flags and counters set in radinc when bad electron density is detected
      common/ednbad/ lgEdenBad , nzEdenBad
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real pintig
      integer n,i,nelem,ion,nd
*
*     free statement labels >=36
*
      lgEdenBad = .false.
      nzEdenBad = 0
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      BigEdenError  = 0.
      AccelMax = 0.
      ipEdenError = 0
      SumOutCon = 0.
      SumIncCon = 0.
      dDensityDT = dndtSave
      windv = windv0
*
      BiggestH2 = -1.
*
*     lgNxtDROff is flag saying to reinit DR logic in NEXTDR
      lgNxtDROff = .true.
*
*     turn H matrix back on
      lgHMtrxOff = .false.
*
      lgVelPos = .true.
      lgBusted = .false.
*
      rjnmin = 1e37
      ajmmin = 1e37
*
      xLaMase = 0.
      stimax(1) = 0.
      stimax(2) = 0.
*
      oldcla = 0.
      CarMolFrac = -1.
*     reset molecular fractions
      ch = chs
      chp = chps
      oh = ohs
      ohp = ohps
      otwo = otwos
      ctwo = ctwos
      co = cos
      cop = cops
      h2o = h2os
      h2op = h2ops
      o2p = o2ps
      c2p = c2ps
      h3p = h3ps
      h3op = h3ops
      ch2p = ch2ps
      ch2 = ch2s
      ch3 = ch3s
      cp = cps
*
      htwo = h2sav
      h2plus = h2psav
      h3plus = h3psav
      hminus = hmisav
*
*     dont call HE1, HE2, or HE3 routines if no ionizing radiation
*     must reset this since he++ turned off at depth
      if( nflux.lt.nhe2(1) ) then
        lgHe2ON = .false.
      else
        lgHe2ON = .true.
      endif
      lgHe1ON = .true.
*
      ntff = 1
      tff = 0.
      pintig = 0.
      glbdst = 0.
*     zone thickness, and next zone thickness
      drad = drSave
      drNext = drnsv
      lgUSphON = .false.
      lgPradCap = .false.
      lgPradDen = .false.
      lgDrMinUsed = .false.
      lgNegGrnDrg = .false.
      lgLotsCO = .false.
*
*     simple estimate of H-beta intensity
      smbeta = qhtot * 4.75e-13
      cn4861 = sv4861
      cn1216 = sv1216
*
*     total luminosity
      totlsv = totlum
*
*     set debugger on now if NZONE desired is 0
      if( nznbug.eq.0 .and. iter.ge.npsbug .and. lgTrOvrd) then
        lgTrace = .true.
        write(qq,'('' RESET called.'')')
      else
        lgTrace = .false.
      endif
*
*     zero secondary suptrathermals variables for first ionization attem
      secion = savion
      secla = savla
      csupra = supsav
      x12 = x12sav
      heatef = hetsav
      efionz = savefi
      AccelAver = 0.
      acldr = 0.
      pbeta = 0.
      kapots = 0
      kap911 = 0
      nUnstable = 0
      lgUnstable = .false.
      RadBetaMax = 0.
      pca2ex = 0.
*
*     these are opacity factors needed for recombination coef
      do n=1,nhlvl
        ophf(n) = ophs(n)
      end do
      do n=1,nhe1lvl
        ophe1f(n) = ophe1s(n)
      end do
      do n=1,nhe2lvl
        ophe2f(n) = ophe2s(n)
      end do
      do n=1,nhlvl+1
        hn(n) = hnsav(n)
      end do
      do n=1,nhe1lvl+1
        he1n(n) = he1nsav(n)
      end do
      do n=1,nhe2lvl+1
        he2n(n) = he2nsav(n)
      end do
*
      iontot = 0
      esc626 = 0.
      esc584 = 0.
      esc304 = 0.
      esc660 = 0.
      esc911 = 0.
      esc228 = 0.
*
      do i=1,nhlvl
        hlmax(i) = 0.
      end do
*
      hden = hsv
      eden = edsav
      EdenNotH = EDOthSav
      EdenMet = EDMSav
*     reset correct electron density to saved electron density
      EdenTrue = edsav
      ahe = solar(2) * hden
      heiii = heisav
      heii = he2sav
      hei = he1sav
      hei1 = hei
      hei3 = he3sav
*
      do i=1,nhlvl+1
        cinduc(i) = 0.
      end do
*
      do i=1,10
        he1cin(i) = 0.
        he2cin(i) = 0.
        he1bn(i) = heb1sv(i)
        he2bn(i) = heb2sv(i)
      end do
*
      do i=1,nhe3lvl
        he3bn(i) = heb3sv(i)
      end do
*
      if( lgTrace.and.lgNeBug ) write(qq,'(5X,''EDEN set to'',1P,E12.4,
     1'' by RESET.'')') eden
*
      do nelem=1,limelm
        xIonFracs(nelem,0) = solar(nelem) * hden
        do ion=1,nelem+1
          xIonFracs(nelem,ion) = xIonFsave(nelem,ion)
        end do
        do i=1,limelm
          heating(nelem,i) = HeatSave(nelem,i)
        end do
      end do
*
      hmihet = 0.
      hmitot = 0.
*
      DustHeatLya = 0.
      dhcol = 0.
      dincon = 0.
      HDustDif = 0.
      dstpow = 0.
      dstsum = 0.
      dstotl = 0.
      do nd=1,ndust
*       >>chng 97 july 5, reset grain potential
*       reset grain to pential to initial value from previous iteration
        dstpot(nd) = dstpotsav(nd)
        avdust(nd) = 0.
        avdpot(nd) = 0.
         avdft(nd) = 0.
        tgrmax(nd) = -1.
      end do
*
      hi = hisv
      hii = hiisv
      hn(1) = hi / hii
*
*     fix number of stages of ionization
      do i=1,limelm
        IonLow(i) = IonLowSave(i)
        IonHigh(i) = IonHighSave(i)
      end do
*
*     continuum was saved in FluxSave
      do i=1,nupper
        flux(i) = FluxSave(i)
        lgOTSOn(i) = .true.
        occnum(i) = flux(i) * convoc(i)
        otscon(i) = otssav(i,1)
        otslin(i) = otssav(i,2)
        outcon(i) = 0.
        outlin(i) = 0.
        opac(i) = opacsv(i)
        scatop(i) = sctsav(i)
        albedo(i) = scatop(i) / max( 1e-30 , scatop(i)+opac(i) )
        tmn(i) = 1.
        ExpmTau(i) = 1.
        e2TauAbs(i) = 1.
        reflin(i) = 0.
        refcon(i) = 0.
        reflux(i) = 0.
      end do
*     update continuum
      call SumContinuum
*
      FreeFreeHeat = 0.
      ffhtot = 0.
*
      if( lgTalk ) write(qq,'(''1''/10X,''Start Iteration Number'',I2,
     13X,A75//)') iter, chTitle
*
      end
******************************************************************************
      subroutine result( io )
      implicit none
*punch results from punch results command
      integer io
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real telec , thmin
      common/taucon/ telec , thmin
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      integer limelm
      parameter (limelm=30)
*     xIonMeans(nelem, stage,type)
*     stage=0 is integrated sum of all
*     type = 1 is radius integration, 2=vol
      real xIonMeans
      common/IonMeans/ xIonMeans(limelm,0:limelm+1,2)
*
*     local variables
      logical lgEOF
      character*80 chCard
      integer i
*
*     used to punch out line intensities, optical depths,
*     and column densities
*
      lgEOF = .false.
*     first initialize the line image reader
      call rdinit
*
      write(io,'(130(''*''))')
      lgEOF = .false.
      call readar( chCard , lgEOF )
      do while( .not. lgEOF )
        write(io,'(A80)') chCard
        call readar( chCard , lgEOF )
      end do
*
*     first print any cautions or warnings
      call warnot( io )
      call caunot (io )
      write(io,'(130(''*''))')
*
      write(io,'(''C*OPTICAL DEPTHS ELECTRON='',1P,E10.3)') telec
*
      write(io,'(''BEGIN EMISSION LINES'')')
      call PunResult(io,'    ', 0, 0., 'Start' )
      do i=1,nsum
        if( sumlin(i).gt.0. ) then
          call PunResult(io,chALab(i),lin(i),sumlin(i),'Line ')
        endif
      end do
      call PunResult(io,'    ', 0, 0., 'Flush' )
*
      write(io,'(''     '')')
*
      write(io,'(''BEGIN COLUMN DENSITIES'')')
*     make sure this is kept parallel with CDCOLM, which uses it
*     real in all column densities
*     make sure this is kept parallel with CDCOLM, which uses it
*     donelem=1,limelm
*     >>chng 97 mar 20, dump whole thing
        write(io,'(4x,1p,12e10.3)') xIonMeans
*       write(io,'(4x,1p,12e10.3)') (xIonMeans(nelem,i,1),i=1,nelem+1)
*     end do
      write(io,'(''     '')')
*
      write(io,'(''END OF RESULTS'')')
      write(io,'(130(''*''))')
*
      end
******************************************************************************
      subroutine rmetal( chCard )
      implicit none
*parse parameters on metal command
      character chCard*80
*
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer nvary , nparm
      common/nvary/ nvary , nparm
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real ScaleMetals
*scale factor for metals, set with metals command
      common/dmetal/ ScaleMetals
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      real GrainMetal
*factor depleting grain abundances from grain on metals command, usually 1
      common/grmetl/ GrainMetal
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      integer limelm
      parameter (limelm=30)
      real Depletion , depset
*     Depletion is set of stored scale factors for depletion of general ism
*     depset is unity unless depletion is used
*     lgDepln is true if depln used
      logical lgDepln
      common/deplon/ Depletion(limelm) , depset(limelm) , lgDepln
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL , lgLogOn , lgMatch , lgGrains
      integer i
      real fread , dmlog
*
*     this routine called when metals command entered
*
*     metal depletion factor, if negative then it is the log
      i = 5
      ScaleMetals = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        if( lgMatch( 'DEPL' , chCard ) ) then
*         this option - no numbers on line but keyword depletion is
*         deplete by set of scale factors
          lgDepln = .true.
          do i=1,limelm
            depset(i) = Depletion(i)
          end do
          ScaleMetals = 1.
          return
        else
*         no number, so keyword, punch out
          if( .not.lgTalk ) write(qq,'(1X,A80)') chCard
          write(qq,'('' There must be a number on this line.  Sorry.''
     1    )')
          stop
        endif
      endif
*
*     sort out whether log
      lgLogOn = .false.
      if( lgMatch( ' LOG' , chCard ) ) then
        lgLogOn = .true.
      else if( lgMatch( 'LINE' , chCard ) ) then
        lgLogOn = .false.
      endif
*
      if( ScaleMetals.le.0. .or. lgLogOn ) then
        dmlog = ScaleMetals
        ScaleMetals = 10.**ScaleMetals
      else
        dmlog = log10( ScaleMetals )
      endif
*
*     option to vary grain abundance as well
      if( lgMatch( 'GRAI' , chCard ) ) then
        lgGrains = .true.
        GrainMetal = ScaleMetals
      else
        lgGrains = .false.
        GrainMetal = 1.
      endif
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
        if( lgGrains ) then
          chVarFmt(nparm) = '(''METALS LOG='',F9.5,'' GRAINS'')'
        else
          chVarFmt(nparm) = '(''METALS LOG='',F9.5)'
        endif
*       pointer to where to write
        nvfpnt(nparm) = nRead
        vparm(nparm,1) = dmlog
        vincr(nparm) = 0.5
        nvarxt(nparm) = 1
      endif
*
      end
      subroutine rrfit(iz,in,t,r)
      implicit none
*D Verner routine to compute radiative recombination rate coefficients
******************************************************************************
*** Version 3. May 20, 1996.
*** This subroutine calculates rates of radiative recombination for all ions
*** of all elements from H through Zn by use of the following fits:
*** H-like, He-like, Li-like, Na-like - Verner & Ferland, 1996, ApJS, in press
*** Other ions of C, N, O, Ne - Pequignot et al. 1991, A&A, 251, 680,
***                             refitted by our formula
*** Fe XIV-XV and Fe XVII-XXIII - Arnaud & Raymond, 1992, ApJ, 398, 394
*** Other ions of Mg, Si, S, Ar, Ca, Fe, Ni -
***                      - Shull & Van Steenberg, 1982, ApJS, 48, 95
*** Other ions of Na, Al - Landini & Monsignori Fossi, 1990, A&AS, 82, 229
*** Other ions of F, P, Cl, K, Ti, Cr, Mn, Co (excluding Ti I-II, Cr I-IV,
*** Mn I-V, Co I)        - Landini & Monsignori Fossi, 1991, A&AS, 91, 183
*** All other species    - interpolations of the power-law fits
*** Input parameters:  iz - atomic number
***                    in - number of electrons from 1 to iz
***                    t  - temperature, K
*** Output parameter:  r  - rate coefficient, cm^3 s^(-1)
******************************************************************************
      real rrec,rnew,fe,t,r,tt,ppb,tz,z
      integer iz,in
      common/rrec/rrec(2,30,30)
      common/rnew/rnew(4,30,30)
      common/ferr/fe(3,13)
      common/ppb/ppb(4,10,10)
      r=0.0
      if(iz.lt.1.or.iz.gt.30)then
         write(6,'('' rrfit called with insane atomic number, ='',i4
     &   )') iz
         stop
      endif
      if(in.lt.1.or.in.gt.iz)then
         write(6,'('' rrfit called with insane number elec ='',i4
     &   )') in
        stop
      endif
      if(in.le.3.or.in.eq.11.or.(iz.gt.5.and.iz.lt.9).or.iz.eq.10)then
         tt=sqrt(t/rnew(3,iz,in))
         r=rnew(1,iz,in)/(tt*(tt+1.0)**(1.0-rnew(2,iz,in))*
     &        (1.0+sqrt(t/rnew(4,iz,in)))**(1.0+rnew(2,iz,in)))
      else
         tt=t*1.0e-04
         if(iz.eq.26.and.in.le.13)then
            r=fe(1,in)/tt**(fe(2,in)+fe(3,in)*log10(tt))
         else
            if((iz.gt.5.and.iz.lt.9).or.iz.eq.10)then
               z=float(iz-in+1)
               tz=tt/z**2
               r=1.0e-13*z*ppb(1,iz,in)*tz**ppb(2,iz,in)/
     &              (1.0+ppb(3,iz,in)*tz**ppb(4,iz,in))
            else
               r=rrec(1,iz,in)/tt**rrec(2,iz,in)
            endif
         endif
      endif
      return
      end
*********************************************
      block data radrec
      implicit none
*block data with D Verner's recombination coefficients
      real rrec , rnew , fe
      integer i
      common/rrec/rrec(2,30,30)
      common/rnew/rnew(4,30,30)
      common/ferr/fe(3,13)
      data(rrec(i, 4, 4),i=1,2)/4.500e-13,0.6480/
      data(rrec(i, 5, 4),i=1,2)/2.680e-12,0.7250/
      data(rrec(i, 6, 4),i=1,2)/4.900e-12,0.8030/
      data(rrec(i, 7, 4),i=1,2)/9.400e-12,0.7650/
      data(rrec(i, 8, 4),i=1,2)/1.590e-11,0.7590/
      data(rrec(i, 9, 4),i=1,2)/1.919e-11,0.7849/
      data(rrec(i,10, 4),i=1,2)/2.800e-11,0.7710/
      data(rrec(i,11, 4),i=1,2)/4.030e-11,0.7873/
      data(rrec(i,12, 4),i=1,2)/6.830e-11,0.7650/
      data(rrec(i,13, 4),i=1,2)/8.343e-11,0.8291/
      data(rrec(i,14, 4),i=1,2)/1.430e-10,0.8230/
      data(rrec(i,15, 4),i=1,2)/1.460e-10,0.8391/
      data(rrec(i,16, 4),i=1,2)/2.000e-10,0.8060/
      data(rrec(i,17, 4),i=1,2)/2.091e-10,0.8691/
      data(rrec(i,18, 4),i=1,2)/3.070e-10,0.8190/
      data(rrec(i,19, 4),i=1,2)/3.210e-10,0.8934/
      data(rrec(i,20, 4),i=1,2)/4.610e-10,0.8330/
      data(rrec(i,21, 4),i=1,2)/4.870e-10,0.8060/
      data(rrec(i,22, 4),i=1,2)/5.139e-10,0.7781/
      data(rrec(i,23, 4),i=1,2)/5.850e-10,0.7570/
      data(rrec(i,24, 4),i=1,2)/6.556e-10,0.7359/
      data(rrec(i,25, 4),i=1,2)/7.238e-10,0.7242/
      data(rrec(i,27, 4),i=1,2)/8.404e-10,0.7167/
      data(rrec(i,28, 4),i=1,2)/1.360e-09,0.8420/
      data(rrec(i,29, 4),i=1,2)/1.880e-09,0.8420/
      data(rrec(i,30, 4),i=1,2)/2.400e-09,0.8420/
      data(rrec(i, 5, 5),i=1,2)/4.600e-13,0.6360/
      data(rrec(i, 6, 5),i=1,2)/2.300e-12,0.6450/
      data(rrec(i, 7, 5),i=1,2)/5.000e-12,0.6760/
      data(rrec(i, 8, 5),i=1,2)/9.600e-12,0.6700/
      data(rrec(i, 9, 5),i=1,2)/1.558e-11,0.6816/
      data(rrec(i,10, 5),i=1,2)/2.300e-11,0.7040/
      data(rrec(i,11, 5),i=1,2)/3.253e-11,0.7075/
      data(rrec(i,12, 5),i=1,2)/4.600e-11,0.7110/
      data(rrec(i,13, 5),i=1,2)/5.951e-11,0.7125/
      data(rrec(i,14, 5),i=1,2)/7.700e-11,0.7140/
      data(rrec(i,15, 5),i=1,2)/1.042e-10,0.7330/
      data(rrec(i,16, 5),i=1,2)/1.400e-10,0.7550/
      data(rrec(i,17, 5),i=1,2)/1.760e-10,0.7682/
      data(rrec(i,18, 5),i=1,2)/2.140e-10,0.7740/
      data(rrec(i,19, 5),i=1,2)/2.629e-10,0.7772/
      data(rrec(i,20, 5),i=1,2)/3.240e-10,0.7800/
      data(rrec(i,21, 5),i=1,2)/3.970e-10,0.7840/
      data(rrec(i,22, 5),i=1,2)/4.700e-10,0.7873/
      data(rrec(i,23, 5),i=1,2)/5.500e-10,0.7910/
      data(rrec(i,24, 5),i=1,2)/6.301e-10,0.7952/
      data(rrec(i,25, 5),i=1,2)/7.058e-10,0.7982/
      data(rrec(i,27, 5),i=1,2)/8.252e-10,0.8004/
      data(rrec(i,28, 5),i=1,2)/8.710e-10,0.8000/
      data(rrec(i,29, 5),i=1,2)/9.170e-10,0.8000/
      data(rrec(i,30, 5),i=1,2)/9.630e-10,0.7990/
      data(rrec(i, 6, 6),i=1,2)/4.700e-13,0.6240/
      data(rrec(i, 7, 6),i=1,2)/2.200e-12,0.6390/
      data(rrec(i, 8, 6),i=1,2)/5.100e-12,0.6600/
      data(rrec(i, 9, 6),i=1,2)/9.171e-12,0.6757/
      data(rrec(i,10, 6),i=1,2)/1.500e-11,0.6840/
      data(rrec(i,11, 6),i=1,2)/2.191e-11,0.6875/
      data(rrec(i,12, 6),i=1,2)/3.200e-11,0.6910/
      data(rrec(i,13, 6),i=1,2)/4.308e-11,0.6970/
      data(rrec(i,14, 6),i=1,2)/5.800e-11,0.7030/
      data(rrec(i,15, 6),i=1,2)/7.316e-11,0.7027/
      data(rrec(i,16, 6),i=1,2)/9.200e-11,0.7140/
      data(rrec(i,17, 6),i=1,2)/1.198e-10,0.7508/
      data(rrec(i,18, 6),i=1,2)/1.580e-10,0.7900/
      data(rrec(i,19, 6),i=1,2)/2.048e-10,0.8032/
      data(rrec(i,20, 6),i=1,2)/2.600e-10,0.8000/
      data(rrec(i,21, 6),i=1,2)/3.280e-10,0.7990/
      data(rrec(i,22, 6),i=1,2)/3.966e-10,0.7973/
      data(rrec(i,23, 6),i=1,2)/4.760e-10,0.8000/
      data(rrec(i,24, 6),i=1,2)/5.547e-10,0.8027/
      data(rrec(i,25, 6),i=1,2)/6.313e-10,0.8058/
      data(rrec(i,27, 6),i=1,2)/7.503e-10,0.8085/
      data(rrec(i,28, 6),i=1,2)/7.940e-10,0.8080/
      data(rrec(i,29, 6),i=1,2)/8.380e-10,0.8080/
      data(rrec(i,30, 6),i=1,2)/8.810e-10,0.8070/
      data(rrec(i, 7, 7),i=1,2)/4.100e-13,0.6080/
      data(rrec(i, 8, 7),i=1,2)/2.000e-12,0.6460/
      data(rrec(i, 9, 7),i=1,2)/5.231e-12,0.6615/
      data(rrec(i,10, 7),i=1,2)/9.100e-12,0.6680/
      data(rrec(i,11, 7),i=1,2)/1.447e-11,0.6814/
      data(rrec(i,12, 7),i=1,2)/2.300e-11,0.6950/
      data(rrec(i,13, 7),i=1,2)/3.145e-11,0.6915/
      data(rrec(i,14, 7),i=1,2)/4.300e-11,0.6880/
      data(rrec(i,15, 7),i=1,2)/5.659e-11,0.7023/
      data(rrec(i,16, 7),i=1,2)/7.400e-11,0.7160/
      data(rrec(i,17, 7),i=1,2)/9.561e-11,0.7102/
      data(rrec(i,18, 7),i=1,2)/1.230e-10,0.7020/
      data(rrec(i,19, 7),i=1,2)/1.587e-10,0.7105/
      data(rrec(i,20, 7),i=1,2)/2.040e-10,0.7300/
      data(rrec(i,21, 7),i=1,2)/2.630e-10,0.7490/
      data(rrec(i,22, 7),i=1,2)/3.220e-10,0.7683/
      data(rrec(i,23, 7),i=1,2)/3.950e-10,0.7830/
      data(rrec(i,24, 7),i=1,2)/4.671e-10,0.7967/
      data(rrec(i,25, 7),i=1,2)/5.407e-10,0.8058/
      data(rrec(i,27, 7),i=1,2)/6.611e-10,0.8121/
      data(rrec(i,28, 7),i=1,2)/7.080e-10,0.8110/
      data(rrec(i,29, 7),i=1,2)/7.550e-10,0.8100/
      data(rrec(i,30, 7),i=1,2)/8.020e-10,0.8090/
      data(rrec(i, 8, 8),i=1,2)/3.100e-13,0.6780/
      data(rrec(i, 9, 8),i=1,2)/1.344e-12,0.6708/
      data(rrec(i,10, 8),i=1,2)/4.400e-12,0.6750/
      data(rrec(i,11, 8),i=1,2)/7.849e-12,0.6952/
      data(rrec(i,12, 8),i=1,2)/1.400e-11,0.7160/
      data(rrec(i,13, 8),i=1,2)/2.049e-11,0.7090/
      data(rrec(i,14, 8),i=1,2)/3.000e-11,0.7020/
      data(rrec(i,15, 8),i=1,2)/4.125e-11,0.6965/
      data(rrec(i,16, 8),i=1,2)/5.500e-11,0.7110/
      data(rrec(i,17, 8),i=1,2)/7.280e-11,0.7518/
      data(rrec(i,18, 8),i=1,2)/9.550e-11,0.7930/
      data(rrec(i,19, 8),i=1,2)/1.235e-10,0.8052/
      data(rrec(i,20, 8),i=1,2)/1.580e-10,0.8000/
      data(rrec(i,21, 8),i=1,2)/2.060e-10,0.7990/
      data(rrec(i,22, 8),i=1,2)/2.537e-10,0.7977/
      data(rrec(i,23, 8),i=1,2)/3.190e-10,0.8020/
      data(rrec(i,24, 8),i=1,2)/3.844e-10,0.8071/
      data(rrec(i,25, 8),i=1,2)/4.564e-10,0.8124/
      data(rrec(i,27, 8),i=1,2)/5.842e-10,0.8168/
      data(rrec(i,28, 8),i=1,2)/6.380e-10,0.8160/
      data(rrec(i,29, 8),i=1,2)/6.920e-10,0.8150/
      data(rrec(i,30, 8),i=1,2)/7.460e-10,0.8140/
      data(rrec(i, 9, 9),i=1,2)/6.273e-13,0.6798/
      data(rrec(i,10, 9),i=1,2)/1.500e-12,0.6930/
      data(rrec(i,11, 9),i=1,2)/3.399e-12,0.7054/
      data(rrec(i,12, 9),i=1,2)/7.700e-12,0.7180/
      data(rrec(i,13, 9),i=1,2)/1.275e-11,0.7170/
      data(rrec(i,14, 9),i=1,2)/2.110e-11,0.7160/
      data(rrec(i,15, 9),i=1,2)/2.975e-11,0.6945/
      data(rrec(i,16, 9),i=1,2)/4.000e-11,0.6960/
      data(rrec(i,17, 9),i=1,2)/5.281e-11,0.7491/
      data(rrec(i,18, 9),i=1,2)/6.920e-11,0.8110/
      data(rrec(i,19, 9),i=1,2)/9.044e-11,0.8251/
      data(rrec(i,20, 9),i=1,2)/1.180e-10,0.8100/
      data(rrec(i,21, 9),i=1,2)/1.580e-10,0.8040/
      data(rrec(i,22, 9),i=1,2)/1.983e-10,0.7980/
      data(rrec(i,23, 9),i=1,2)/2.570e-10,0.8040/
      data(rrec(i,24, 9),i=1,2)/3.154e-10,0.8101/
      data(rrec(i,25, 9),i=1,2)/3.837e-10,0.8183/
      data(rrec(i,27, 9),i=1,2)/5.147e-10,0.8253/
      data(rrec(i,28, 9),i=1,2)/5.750e-10,0.8240/
      data(rrec(i,29, 9),i=1,2)/6.350e-10,0.8230/
      data(rrec(i,30, 9),i=1,2)/6.960e-10,0.8210/
      data(rrec(i,10,10),i=1,2)/2.200e-13,0.7590/
      data(rrec(i,11,10),i=1,2)/8.775e-13,0.7467/
      data(rrec(i,12,10),i=1,2)/3.500e-12,0.7340/
      data(rrec(i,13,10),i=1,2)/6.481e-12,0.7345/
      data(rrec(i,14,10),i=1,2)/1.200e-11,0.7350/
      data(rrec(i,15,10),i=1,2)/1.834e-11,0.7285/
      data(rrec(i,16,10),i=1,2)/2.700e-11,0.7330/
      data(rrec(i,17,10),i=1,2)/3.711e-11,0.7641/
      data(rrec(i,18,10),i=1,2)/4.900e-11,0.8010/
      data(rrec(i,19,10),i=1,2)/6.444e-11,0.8175/
      data(rrec(i,20,10),i=1,2)/8.510e-11,0.8200/
      data(rrec(i,21,10),i=1,2)/1.170e-10,0.8220/
      data(rrec(i,22,10),i=1,2)/1.494e-10,0.8242/
      data(rrec(i,23,10),i=1,2)/2.010e-10,0.8280/
      data(rrec(i,24,10),i=1,2)/2.525e-10,0.8311/
      data(rrec(i,25,10),i=1,2)/3.177e-10,0.8341/
      data(rrec(i,27,10),i=1,2)/4.552e-10,0.8364/
      data(rrec(i,28,10),i=1,2)/5.250e-10,0.8360/
      data(rrec(i,29,10),i=1,2)/5.950e-10,0.8360/
      data(rrec(i,30,10),i=1,2)/6.650e-10,0.8350/
      data(rrec(i,12,12),i=1,2)/1.400e-13,0.8550/
      data(rrec(i,13,12),i=1,2)/7.197e-13,0.7697/
      data(rrec(i,14,12),i=1,2)/3.700e-12,0.6930/
      data(rrec(i,15,12),i=1,2)/7.980e-12,0.6829/
      data(rrec(i,16,12),i=1,2)/1.200e-11,0.7010/
      data(rrec(i,17,12),i=1,2)/1.800e-11,0.7232/
      data(rrec(i,18,12),i=1,2)/2.690e-11,0.7440/
      data(rrec(i,19,12),i=1,2)/3.748e-11,0.7628/
      data(rrec(i,20,12),i=1,2)/5.040e-11,0.7800/
      data(rrec(i,21,12),i=1,2)/7.240e-11,0.7950/
      data(rrec(i,22,12),i=1,2)/9.440e-11,0.8107/
      data(rrec(i,23,12),i=1,2)/1.350e-10,0.8220/
      data(rrec(i,24,12),i=1,2)/1.751e-10,0.8340/
      data(rrec(i,25,12),i=1,2)/2.298e-10,0.8417/
      data(rrec(i,27,12),i=1,2)/3.461e-10,0.8469/
      data(rrec(i,28,12),i=1,2)/4.030e-10,0.8460/
      data(rrec(i,29,12),i=1,2)/4.600e-10,0.8450/
      data(rrec(i,30,12),i=1,2)/5.170e-10,0.8440/
      data(rrec(i,13,13),i=1,2)/3.980e-13,0.8019/
      data(rrec(i,14,13),i=1,2)/1.000e-12,0.7860/
      data(rrec(i,15,13),i=1,2)/2.558e-12,0.7629/
      data(rrec(i,16,13),i=1,2)/5.700e-12,0.7550/
      data(rrec(i,17,13),i=1,2)/1.011e-11,0.7703/
      data(rrec(i,18,13),i=1,2)/1.580e-11,0.7930/
      data(rrec(i,19,13),i=1,2)/2.448e-11,0.8052/
      data(rrec(i,20,13),i=1,2)/3.760e-11,0.8100/
      data(rrec(i,21,13),i=1,2)/5.870e-11,0.8150/
      data(rrec(i,22,13),i=1,2)/7.972e-11,0.8206/
      data(rrec(i,23,13),i=1,2)/1.130e-10,0.8270/
      data(rrec(i,24,13),i=1,2)/1.470e-10,0.8325/
      data(rrec(i,25,13),i=1,2)/1.908e-10,0.8372/
      data(rrec(i,27,13),i=1,2)/2.976e-10,0.8406/
      data(rrec(i,28,13),i=1,2)/3.630e-10,0.8400/
      data(rrec(i,29,13),i=1,2)/4.280e-10,0.8390/
      data(rrec(i,30,13),i=1,2)/4.940e-10,0.8390/
      data(rrec(i,14,14),i=1,2)/5.900e-13,0.6010/
      data(rrec(i,15,14),i=1,2)/1.294e-12,0.6766/
      data(rrec(i,16,14),i=1,2)/2.700e-12,0.7450/
      data(rrec(i,17,14),i=1,2)/5.165e-12,0.7893/
      data(rrec(i,18,14),i=1,2)/9.120e-12,0.8110/
      data(rrec(i,19,14),i=1,2)/1.513e-11,0.8186/
      data(rrec(i,20,14),i=1,2)/2.400e-11,0.8200/
      data(rrec(i,21,14),i=1,2)/3.960e-11,0.8220/
      data(rrec(i,22,14),i=1,2)/5.518e-11,0.8245/
      data(rrec(i,23,14),i=1,2)/8.370e-11,0.8280/
      data(rrec(i,24,14),i=1,2)/1.123e-10,0.8313/
      data(rrec(i,25,14),i=1,2)/1.525e-10,0.8342/
      data(rrec(i,26,14),i=1,2)/2.000e-10,0.8360/
      data(rrec(i,27,14),i=1,2)/2.537e-10,0.8364/
      data(rrec(i,28,14),i=1,2)/3.160e-10,0.8360/
      data(rrec(i,29,14),i=1,2)/3.780e-10,0.8360/
      data(rrec(i,30,14),i=1,2)/4.410e-10,0.8350/
      data(rrec(i,15,15),i=1,2)/9.761e-13,0.6209/
      data(rrec(i,16,15),i=1,2)/1.800e-12,0.6860/
      data(rrec(i,17,15),i=1,2)/3.320e-12,0.7579/
      data(rrec(i,18,15),i=1,2)/6.030e-12,0.8120/
      data(rrec(i,19,15),i=1,2)/1.063e-11,0.8269/
      data(rrec(i,20,15),i=1,2)/1.800e-11,0.8200/
      data(rrec(i,21,15),i=1,2)/3.130e-11,0.8180/
      data(rrec(i,22,15),i=1,2)/4.451e-11,0.8153/
      data(rrec(i,23,15),i=1,2)/6.830e-11,0.8200/
      data(rrec(i,24,15),i=1,2)/9.206e-11,0.8246/
      data(rrec(i,25,15),i=1,2)/1.250e-10,0.8302/
      data(rrec(i,26,15),i=1,2)/1.640e-10,0.8340/
      data(rrec(i,27,15),i=1,2)/2.093e-10,0.8349/
      data(rrec(i,28,15),i=1,2)/2.630e-10,0.8340/
      data(rrec(i,29,15),i=1,2)/3.170e-10,0.8330/
      data(rrec(i,30,15),i=1,2)/3.700e-10,0.8320/
      data(rrec(i,16,16),i=1,2)/4.100e-13,0.6300/
      data(rrec(i,17,16),i=1,2)/1.248e-12,0.7663/
      data(rrec(i,18,16),i=1,2)/3.230e-12,0.8690/
      data(rrec(i,19,16),i=1,2)/6.384e-12,0.8790/
      data(rrec(i,20,16),i=1,2)/1.070e-11,0.8400/
      data(rrec(i,21,16),i=1,2)/1.920e-11,0.8210/
      data(rrec(i,22,16),i=1,2)/2.765e-11,0.8012/
      data(rrec(i,23,16),i=1,2)/4.650e-11,0.8060/
      data(rrec(i,24,16),i=1,2)/6.539e-11,0.8099/
      data(rrec(i,25,16),i=1,2)/9.539e-11,0.8202/
      data(rrec(i,26,16),i=1,2)/1.330e-10,0.8280/
      data(rrec(i,27,16),i=1,2)/1.769e-10,0.8299/
      data(rrec(i,28,16),i=1,2)/2.290e-10,0.8280/
      data(rrec(i,29,16),i=1,2)/2.810e-10,0.8260/
      data(rrec(i,30,16),i=1,2)/3.330e-10,0.8240/
      data(rrec(i,17,17),i=1,2)/1.010e-12,0.7380/
      data(rrec(i,18,17),i=1,2)/1.950e-12,0.7520/
      data(rrec(i,19,17),i=1,2)/3.766e-12,0.7662/
      data(rrec(i,20,17),i=1,2)/7.080e-12,0.7800/
      data(rrec(i,21,17),i=1,2)/1.430e-11,0.7920/
      data(rrec(i,22,17),i=1,2)/2.152e-11,0.8038/
      data(rrec(i,23,17),i=1,2)/3.740e-11,0.8120/
      data(rrec(i,24,17),i=1,2)/5.335e-11,0.8207/
      data(rrec(i,25,17),i=1,2)/7.807e-11,0.8260/
      data(rrec(i,26,17),i=1,2)/1.090e-10,0.8290/
      data(rrec(i,27,17),i=1,2)/1.459e-10,0.8296/
      data(rrec(i,28,17),i=1,2)/1.910e-10,0.8290/
      data(rrec(i,29,17),i=1,2)/2.360e-10,0.8280/
      data(rrec(i,30,17),i=1,2)/2.810e-10,0.8280/
      data(rrec(i,18,18),i=1,2)/3.770e-13,0.6510/
      data(rrec(i,19,18),i=1,2)/1.304e-12,0.6753/
      data(rrec(i,20,18),i=1,2)/3.960e-12,0.7000/
      data(rrec(i,21,18),i=1,2)/1.130e-11,0.7240/
      data(rrec(i,22,18),i=1,2)/1.857e-11,0.7484/
      data(rrec(i,23,18),i=1,2)/3.170e-11,0.7680/
      data(rrec(i,24,18),i=1,2)/4.479e-11,0.7883/
      data(rrec(i,25,18),i=1,2)/6.106e-11,0.8020/
      data(rrec(i,26,18),i=1,2)/8.130e-11,0.8100/
      data(rrec(i,27,18),i=1,2)/1.098e-10,0.8118/
      data(rrec(i,28,18),i=1,2)/1.500e-10,0.8100/
      data(rrec(i,29,18),i=1,2)/1.900e-10,0.8080/
      data(rrec(i,30,18),i=1,2)/2.300e-10,0.8060/
      data(rrec(i,19,19),i=1,2)/2.762e-13,0.8023/
      data(rrec(i,20,19),i=1,2)/6.780e-13,0.8000/
      data(rrec(i,21,19),i=1,2)/2.330e-12,0.7980/
      data(rrec(i,22,19),i=1,2)/3.983e-12,0.7955/
      data(rrec(i,23,19),i=1,2)/1.150e-11,0.7940/
      data(rrec(i,24,19),i=1,2)/1.906e-11,0.7919/
      data(rrec(i,25,19),i=1,2)/3.620e-11,0.7907/
      data(rrec(i,26,19),i=1,2)/6.050e-11,0.7900/
      data(rrec(i,27,19),i=1,2)/8.818e-11,0.7898/
      data(rrec(i,28,19),i=1,2)/1.190e-10,0.7900/
      data(rrec(i,29,19),i=1,2)/1.500e-10,0.7900/
      data(rrec(i,30,19),i=1,2)/1.810e-10,0.7900/
      data(rrec(i,20,20),i=1,2)/1.120e-13,0.9000/
      data(rrec(i,21,20),i=1,2)/6.540e-13,0.8670/
      data(rrec(i,22,20),i=1,2)/1.196e-12,0.8344/
      data(rrec(i,23,20),i=1,2)/5.330e-12,0.8090/
      data(rrec(i,24,20),i=1,2)/9.471e-12,0.7846/
      data(rrec(i,25,20),i=1,2)/2.169e-11,0.7683/
      data(rrec(i,26,20),i=1,2)/4.120e-11,0.7590/
      data(rrec(i,27,20),i=1,2)/6.409e-11,0.7570/
      data(rrec(i,28,20),i=1,2)/8.910e-11,0.7590/
      data(rrec(i,29,20),i=1,2)/1.140e-10,0.7610/
      data(rrec(i,30,20),i=1,2)/1.390e-10,0.7630/
      data(rrec(i,21,21),i=1,2)/1.170e-13,0.8980/
      data(rrec(i,22,21),i=1,2)/5.330e-12,0.8640/
      data(rrec(i,23,21),i=1,2)/1.060e-11,0.8300/
      data(rrec(i,24,21),i=1,2)/1.580e-11,0.7960/
      data(rrec(i,25,21),i=1,2)/2.100e-11,0.7620/
      data(rrec(i,26,21),i=1,2)/2.620e-11,0.7280/
      data(rrec(i,27,21),i=1,2)/2.822e-11,0.7280/
      data(rrec(i,28,21),i=1,2)/3.040e-11,0.7280/
      data(rrec(i,29,21),i=1,2)/3.260e-11,0.7280/
      data(rrec(i,30,21),i=1,2)/3.480e-11,0.7280/
      data(rrec(i,22,22),i=1,2)/1.220e-13,0.8970/
      data(rrec(i,23,22),i=1,2)/3.870e-12,0.8480/
      data(rrec(i,24,22),i=1,2)/7.610e-12,0.7980/
      data(rrec(i,25,22),i=1,2)/1.140e-11,0.7480/
      data(rrec(i,26,22),i=1,2)/1.510e-11,0.6990/
      data(rrec(i,27,22),i=1,2)/1.626e-11,0.6990/
      data(rrec(i,28,22),i=1,2)/1.750e-11,0.6990/
      data(rrec(i,29,22),i=1,2)/1.870e-11,0.6990/
      data(rrec(i,30,22),i=1,2)/2.000e-11,0.6990/
      data(rrec(i,23,23),i=1,2)/1.270e-13,0.8950/
      data(rrec(i,24,23),i=1,2)/2.680e-12,0.8240/
      data(rrec(i,25,23),i=1,2)/5.240e-12,0.7530/
      data(rrec(i,26,23),i=1,2)/7.800e-12,0.6820/
      data(rrec(i,27,23),i=1,2)/8.402e-12,0.6820/
      data(rrec(i,28,23),i=1,2)/9.050e-12,0.6820/
      data(rrec(i,29,23),i=1,2)/9.700e-12,0.6820/
      data(rrec(i,30,23),i=1,2)/1.030e-11,0.6820/
      data(rrec(i,24,24),i=1,2)/1.320e-13,0.8940/
      data(rrec(i,25,24),i=1,2)/1.730e-12,0.8200/
      data(rrec(i,26,24),i=1,2)/3.320e-12,0.7460/
      data(rrec(i,27,24),i=1,2)/3.575e-12,0.7460/
      data(rrec(i,28,24),i=1,2)/3.580e-12,0.7460/
      data(rrec(i,29,24),i=1,2)/3.580e-12,0.7460/
      data(rrec(i,30,24),i=1,2)/3.590e-12,0.7460/
      data(rrec(i,25,25),i=1,2)/1.370e-13,0.8920/
      data(rrec(i,26,25),i=1,2)/1.020e-12,0.8430/
      data(rrec(i,27,25),i=1,2)/1.278e-12,0.7682/
      data(rrec(i,28,25),i=1,2)/1.600e-12,0.7000/
      data(rrec(i,29,25),i=1,2)/1.920e-12,0.7000/
      data(rrec(i,30,25),i=1,2)/2.240e-12,0.7000/
      data(rrec(i,26,26),i=1,2)/1.420e-13,0.8910/
      data(rrec(i,27,26),i=1,2)/4.459e-13,0.7897/
      data(rrec(i,28,26),i=1,2)/1.400e-12,0.7000/
      data(rrec(i,29,26),i=1,2)/1.500e-12,0.7000/
      data(rrec(i,30,26),i=1,2)/1.600e-12,0.7000/
      data(rrec(i,27,27),i=1,2)/2.510e-13,0.7950/
      data(rrec(i,28,27),i=1,2)/1.000e-12,0.7000/
      data(rrec(i,29,27),i=1,2)/1.000e-12,0.7000/
      data(rrec(i,30,27),i=1,2)/1.100e-12,0.7000/
      data(rrec(i,28,28),i=1,2)/3.600e-13,0.7000/
      data(rrec(i,29,28),i=1,2)/3.600e-13,0.7000/
      data(rrec(i,30,28),i=1,2)/3.600e-13,0.7000/
      data(rrec(i,29,29),i=1,2)/3.600e-13,0.7000/
      data(rrec(i,30,29),i=1,2)/3.600e-13,0.7000/
      data(rrec(i,30,30),i=1,2)/3.600e-13,0.7000/
      data(rnew(i, 1, 1),i=1,4)/7.982e-11,0.7480,3.148e+00,7.036e+05/
      data(rnew(i, 2, 1),i=1,4)/1.891e-10,0.7524,9.370e+00,2.774e+06/
      data(rnew(i, 3, 1),i=1,4)/3.039e-10,0.7539,1.871e+01,6.209e+06/
      data(rnew(i, 4, 1),i=1,4)/4.290e-10,0.7557,3.000e+01,1.093e+07/
      data(rnew(i, 5, 1),i=1,4)/5.437e-10,0.7560,4.576e+01,1.706e+07/
      data(rnew(i, 6, 1),i=1,4)/6.556e-10,0.7567,6.523e+01,2.446e+07/
      data(rnew(i, 7, 1),i=1,4)/7.586e-10,0.7563,9.015e+01,3.338e+07/
      data(rnew(i, 8, 1),i=1,4)/8.616e-10,0.7563,1.191e+02,4.352e+07/
      data(rnew(i, 9, 1),i=1,4)/9.712e-10,0.7566,1.499e+02,5.498e+07/
      data(rnew(i,10, 1),i=1,4)/1.085e-09,0.7570,1.834e+02,6.776e+07/
      data(rnew(i,11, 1),i=1,4)/1.163e-09,0.7558,2.328e+02,8.262e+07/
      data(rnew(i,12, 1),i=1,4)/1.317e-09,0.7574,2.585e+02,9.769e+07/
      data(rnew(i,13, 1),i=1,4)/1.419e-09,0.7578,3.057e+02,1.143e+08/
      data(rnew(i,14, 1),i=1,4)/1.517e-09,0.7574,3.601e+02,1.329e+08/
      data(rnew(i,15, 1),i=1,4)/1.586e-09,0.7560,4.327e+02,1.534e+08/
      data(rnew(i,16, 1),i=1,4)/1.729e-09,0.7568,4.725e+02,1.746e+08/
      data(rnew(i,17, 1),i=1,4)/1.791e-09,0.7565,5.591e+02,1.972e+08/
      data(rnew(i,18, 1),i=1,4)/1.913e-09,0.7567,6.175e+02,2.212e+08/
      data(rnew(i,19, 1),i=1,4)/2.033e-09,0.7569,6.797e+02,2.463e+08/
      data(rnew(i,20, 1),i=1,4)/2.129e-09,0.7570,7.591e+02,2.739e+08/
      data(rnew(i,21, 1),i=1,4)/2.262e-09,0.7578,8.186e+02,3.000e+08/
      data(rnew(i,22, 1),i=1,4)/2.370e-09,0.7574,9.002e+02,3.307e+08/
      data(rnew(i,23, 1),i=1,4)/2.415e-09,0.7565,1.032e+03,3.635e+08/
      data(rnew(i,24, 1),i=1,4)/2.537e-09,0.7571,1.108e+03,3.954e+08/
      data(rnew(i,25, 1),i=1,4)/2.618e-09,0.7565,1.225e+03,4.307e+08/
      data(rnew(i,26, 1),i=1,4)/2.735e-09,0.7568,1.314e+03,4.659e+08/
      data(rnew(i,27, 1),i=1,4)/2.809e-09,0.7565,1.444e+03,5.042e+08/
      data(rnew(i,28, 1),i=1,4)/3.002e-09,0.7581,1.467e+03,5.409e+08/
      data(rnew(i,29, 1),i=1,4)/3.022e-09,0.7564,1.666e+03,5.855e+08/
      data(rnew(i,30, 1),i=1,4)/3.127e-09,0.7567,1.779e+03,6.246e+08/
      data(rnew(i, 2, 2),i=1,4)/9.356e-10,0.7892,4.266e-02,4.677e+06/
      data(rnew(i, 3, 2),i=1,4)/1.112e-10,0.6926,2.437e+01,8.323e+06/
      data(rnew(i, 4, 2),i=1,4)/1.317e-10,0.6691,8.473e+01,1.412e+07/
      data(rnew(i, 5, 2),i=1,4)/1.922e-10,0.6717,1.272e+02,1.975e+07/
      data(rnew(i, 6, 2),i=1,4)/2.765e-10,0.6858,1.535e+02,2.556e+07/
      data(rnew(i, 7, 2),i=1,4)/3.910e-10,0.6988,1.611e+02,3.271e+07/
      data(rnew(i, 8, 2),i=1,4)/4.897e-10,0.7048,1.906e+02,4.093e+07/
      data(rnew(i, 9, 2),i=1,4)/5.602e-10,0.7052,2.476e+02,5.077e+07/
      data(rnew(i,10, 2),i=1,4)/6.161e-10,0.7029,3.274e+02,6.243e+07/
      data(rnew(i,11, 2),i=1,4)/6.833e-10,0.7018,4.060e+02,7.491e+07/
      data(rnew(i,12, 2),i=1,4)/7.510e-10,0.7020,4.921e+02,8.643e+07/
      data(rnew(i,13, 2),i=1,4)/8.182e-10,0.7008,5.875e+02,1.007e+08/
      data(rnew(i,14, 2),i=1,4)/8.722e-10,0.6996,7.098e+02,1.155e+08/
      data(rnew(i,15, 2),i=1,4)/9.142e-10,0.6961,8.682e+02,1.335e+08/
      data(rnew(i,16, 2),i=1,4)/9.692e-10,0.6945,1.017e+03,1.517e+08/
      data(rnew(i,17, 2),i=1,4)/1.021e-09,0.6932,1.184e+03,1.695e+08/
      data(rnew(i,18, 2),i=1,4)/1.087e-09,0.6936,1.329e+03,1.880e+08/
      data(rnew(i,19, 2),i=1,4)/1.145e-09,0.6921,1.503e+03,2.098e+08/
      data(rnew(i,20, 2),i=1,4)/1.179e-09,0.6893,1.757e+03,2.344e+08/
      data(rnew(i,21, 2),i=1,4)/1.265e-09,0.6902,1.877e+03,2.555e+08/
      data(rnew(i,22, 2),i=1,4)/1.322e-09,0.6885,2.092e+03,2.829e+08/
      data(rnew(i,23, 2),i=1,4)/1.375e-09,0.6885,2.321e+03,3.056e+08/
      data(rnew(i,24, 2),i=1,4)/1.422e-09,0.6874,2.589e+03,3.336e+08/
      data(rnew(i,25, 2),i=1,4)/1.488e-09,0.6867,2.802e+03,3.623e+08/
      data(rnew(i,26, 2),i=1,4)/1.542e-09,0.6859,3.073e+03,3.926e+08/
      data(rnew(i,27, 2),i=1,4)/1.589e-09,0.6846,3.373e+03,4.267e+08/
      data(rnew(i,28, 2),i=1,4)/1.676e-09,0.6861,3.530e+03,4.538e+08/
      data(rnew(i,29, 2),i=1,4)/1.686e-09,0.6824,4.031e+03,4.948e+08/
      data(rnew(i,30, 2),i=1,4)/1.758e-09,0.6834,4.254e+03,5.258e+08/
      data(rnew(i, 3, 3),i=1,4)/1.036e-11,0.3880,1.077e+02,1.177e+07/
      data(rnew(i, 4, 3),i=1,4)/2.338e-11,0.4211,3.647e+02,1.215e+07/
      data(rnew(i, 5, 3),i=1,4)/4.487e-11,0.4644,5.371e+02,1.465e+07/
      data(rnew(i, 6, 3),i=1,4)/8.540e-11,0.5247,5.014e+02,1.479e+07/
      data(rnew(i, 7, 3),i=1,4)/1.169e-10,0.5470,6.793e+02,1.650e+07/
      data(rnew(i, 8, 3),i=1,4)/2.053e-10,0.6019,4.772e+02,1.711e+07/
      data(rnew(i, 9, 3),i=1,4)/2.739e-10,0.6188,5.033e+02,2.064e+07/
      data(rnew(i,10, 3),i=1,4)/3.200e-10,0.6198,6.329e+02,2.616e+07/
      data(rnew(i,11, 3),i=1,4)/3.873e-10,0.6295,7.000e+02,2.989e+07/
      data(rnew(i,12, 3),i=1,4)/4.284e-10,0.6287,8.748e+02,3.586e+07/
      data(rnew(i,13, 3),i=1,4)/4.881e-10,0.6326,9.941e+02,4.085e+07/
      data(rnew(i,14, 3),i=1,4)/5.373e-10,0.6337,1.164e+03,4.677e+07/
      data(rnew(i,15, 3),i=1,4)/5.876e-10,0.6354,1.341e+03,5.292e+07/
      data(rnew(i,16, 3),i=1,4)/6.571e-10,0.6400,1.452e+03,5.796e+07/
      data(rnew(i,17, 3),i=1,4)/7.076e-10,0.6397,1.653e+03,6.555e+07/
      data(rnew(i,18, 3),i=1,4)/7.538e-10,0.6388,1.889e+03,7.306e+07/
      data(rnew(i,19, 3),i=1,4)/8.182e-10,0.6411,2.044e+03,8.057e+07/
      data(rnew(i,20, 3),i=1,4)/8.577e-10,0.6403,2.334e+03,8.850e+07/
      data(rnew(i,21, 3),i=1,4)/9.162e-10,0.6413,2.543e+03,9.690e+07/
      data(rnew(i,22, 3),i=1,4)/9.844e-10,0.6440,2.708e+03,1.044e+08/
      data(rnew(i,23, 3),i=1,4)/1.020e-09,0.6427,3.057e+03,1.140e+08/
      data(rnew(i,24, 3),i=1,4)/1.091e-09,0.6445,3.225e+03,1.229e+08/
      data(rnew(i,25, 3),i=1,4)/1.151e-09,0.6451,3.461e+03,1.334e+08/
      data(rnew(i,26, 3),i=1,4)/1.198e-09,0.6443,3.789e+03,1.437e+08/
      data(rnew(i,27, 3),i=1,4)/1.211e-09,0.6406,4.357e+03,1.572e+08/
      data(rnew(i,28, 3),i=1,4)/1.288e-09,0.6440,4.506e+03,1.651e+08/
      data(rnew(i,29, 3),i=1,4)/1.372e-09,0.6472,4.627e+03,1.740e+08/
      data(rnew(i,30, 3),i=1,4)/1.412e-09,0.6454,5.053e+03,1.891e+08/
      data(rnew(i,11,11),i=1,4)/5.641e-12,0.1749,3.077e+02,2.617e+06/
      data(rnew(i,12,11),i=1,4)/1.920e-11,0.3028,4.849e+02,5.890e+06/
      data(rnew(i,13,11),i=1,4)/3.753e-11,0.3585,6.848e+02,9.035e+06/
      data(rnew(i,14,11),i=1,4)/5.942e-11,0.3930,8.962e+02,1.213e+07/
      data(rnew(i,15,11),i=1,4)/1.721e-10,0.5429,2.848e+02,3.975e+07/
      data(rnew(i,16,11),i=1,4)/3.502e-10,0.6266,1.532e+02,1.755e+07/
      data(rnew(i,17,11),i=1,4)/2.502e-10,0.5580,5.303e+02,4.558e+07/
      data(rnew(i,18,11),i=1,4)/2.862e-10,0.5621,7.002e+02,4.885e+07/
      data(rnew(i,19,11),i=1,4)/2.757e-10,0.5364,1.204e+03,7.013e+07/
      data(rnew(i,20,11),i=1,4)/5.273e-10,0.6281,5.329e+02,3.188e+07/
      data(rnew(i,21,11),i=1,4)/3.890e-10,0.5645,1.391e+03,6.295e+07/
      data(rnew(i,22,11),i=1,4)/4.207e-10,0.5646,1.688e+03,6.872e+07/
      data(rnew(i,23,11),i=1,4)/4.605e-10,0.5659,1.949e+03,7.419e+07/
      data(rnew(i,24,11),i=1,4)/4.975e-10,0.5655,2.257e+03,8.072e+07/
      data(rnew(i,25,11),i=1,4)/5.349e-10,0.5658,2.577e+03,8.710e+07/
      data(rnew(i,26,11),i=1,4)/7.688e-10,0.6173,1.653e+03,6.161e+07/
      data(rnew(i,27,11),i=1,4)/5.850e-10,0.5598,3.538e+03,1.052e+08/
      data(rnew(i,28,11),i=1,4)/6.347e-10,0.5631,3.780e+03,1.116e+08/
      data(rnew(i,29,11),i=1,4)/6.619e-10,0.5602,4.322e+03,1.210e+08/
      data(rnew(i,30,11),i=1,4)/7.002e-10,0.5612,4.726e+03,1.287e+08/
      data(rnew(i, 6, 4),i=1,4)/2.020E-09,0.7798,6.690E-01,2.425E+06/
      data(rnew(i, 7, 4),i=1,4)/1.595E-11,0.3529,9.870E+03,2.584E+07/
      data(rnew(i, 8, 4),i=1,4)/2.008E-11,0.3567,1.520E+04,3.843E+07/
      data(rnew(i,10, 4),i=1,4)/2.793E-11,0.3533,3.017E+04,7.872E+07/
      data(rnew(i, 6, 5),i=1,4)/8.577E-10,0.7837,7.286E-01,1.140E+07/
      data(rnew(i, 7, 5),i=1,4)/7.039E-10,0.8607,2.203E+00,3.029E+06/
      data(rnew(i, 8, 5),i=1,4)/1.542E-10,0.6712,1.775E+02,1.535E+08/
      data(rnew(i,10, 5),i=1,4)/2.515E-10,0.7011,3.028E+02,8.903E+06/
      data(rnew(i, 6, 6),i=1,4)/7.651E-09,0.8027,1.193E-03,9.334E+12/
      data(rnew(i, 7, 6),i=1,4)/5.989E-10,0.7560,1.377E+00,1.517E+09/
      data(rnew(i, 8, 6),i=1,4)/3.672E-09,0.7676,2.900E-01,8.521E+07/
      data(rnew(i,10, 6),i=1,4)/9.353E-11,0.6270,9.031E+02,2.387E+07/
      data(rnew(i, 7, 7),i=1,4)/1.243E-08,0.7022,1.136E-03,1.015E+13/
      data(rnew(i, 8, 7),i=1,4)/1.816E-08,0.7170,6.717E-03,3.286E+12/
      data(rnew(i,10, 7),i=1,4)/4.227E-11,0.5395,1.687E+03,1.491E+17/
      data(rnew(i, 8, 8),i=1,4)/1.341E-10,0.6159,1.673E+00,6.366E+16/
      data(rnew(i,10, 8),i=1,4)/9.563E-12,0.3067,9.768E+03,4.851E+17/
      data(rnew(i,10, 9),i=1,4)/5.417E-08,0.6930,1.179E-03,1.060E+07/
      data(rnew(i,10,10),i=1,4)/5.023E-12,0.2420,3.181E+02,1.450E+18/
      data(fe(1,i),i=4,13)/4.33e-10,3.91e-10,3.49e-10,3.16e-10,
     &2.96e-10,2.59e-10,2.24e-10,1.91e-10,1.68e-10,1.46e-10/
      data(fe(2,i),i=4,13)/0.531,0.523,0.521,0.534,
     &0.557,0.567,0.579,0.601,0.602,0.597/
      data(fe(3,i),i=4,13)/5.77e-02,6.15e-02,6.22e-02,6.02e-02,
     &5.79e-02,5.65e-02,5.49e-02,5.10e-02,5.07e-02,5.22e-02/
      end
******************************************************************************
      block data scalar
      implicit none
*block data setting up intial values
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer nfill
      parameter (nfill=20)
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      integer nobslm
      parameter (nobslm=100)
      integer LimPredFe2
*limit to number of bands picked up from Katya's FeII atom
*wavelengths set in block data scalar, in data statements for
*iPredFe2
      parameter (LimPredFe2=12)
      integer ncollm
      parameter (ncollm=100)
      integer limpar
      parameter (limpar=20)
      integer nfudgc
      parameter (nfudgc=10)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
      integer ndplot
      parameter (ndplot=10)
      integer ncfl
      parameter (ncfl=40)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
      real COLimit
*limit to ratio CO/Total carbon, used to stop fully molecular
*models
      common/colimt/ COLimit
      integer KshellLimit
      real EnergyKshell
      common/KshllEnr/ KshellLimit , EnergyKshell
      logical lgNoExec
*flag saying no to compute model, just generate continuum and stop
*set with cdNoex call
      common/noexec/ lgNoExec
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
*     lgPrtTau tells whether to print line optical depths
*     PrtTauFnt is smallest line optical depth to print
      logical lgPrtTau
      real PrtTauFnt
      common/PrtTau/ lgPrtTau , PrtTauFnt
      character*10 chElNam(limelm)
      common/elnam/ chElNam
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      real CrsSecNeutron
*cross section for stopping relativistic neutrons
      common/crsnut/ CrsSecNeutron
      integer MapZone , nMapStep
      real RangeMap
*parameters doing with map command, MapZone is zone number,
* -1 for very start
* RangeMap is range, parsed from same command
* nMapStep is number of steps, set with set nmap command
      common/MapPar/ MapZone , RangeMap(2), nMapStep
      real ZeroNum
*this is the number zero, used to trick clever compilers when
*dividing by it to crash program
*there is a routine called zero - this name cannot overlap
      common/zero0/ ZeroNum
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      real filbnd,fildel,filres
      integer ifill0 , nrange
      common/fillnu/ filbnd(nfill+1),fildel(nfill),filres(nfill),
     1 ifill0(nfill) , nrange
      real StopElecFrac
*stop efraction sets this limiting electron fraction rel to H
      common/efrend/ StopElecFrac
      real amcol,amcerr
      integer ionam,ncobs
      common/obscol/ amcol(ncollm),amcerr(ncollm),ionam(ncollm),ncobs
      real amint,amierr
      integer linam,nlobs
      common/obsint/ amint(nobslm),amierr(nobslm),linam(nobslm),nlobs
      real varang
      common/varang/ varang(2,limpar)
      real rincrm
      common/rincrm/ rincrm(limpar)
      integer itoptm
      common/itoptm/ itoptm
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      character*4 chOptRtn
*     this specifies the optimization routine
*     'amoe', 'powe', 'bubr'
      common/oprout/ chOptRtn
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      character*4 chOpcTyp
*     which opacity to punch out
      common/optype/ chOpcTyp
      character chDstFun*4 , chEscFun*4
*     labels of escape and destruction probability functions
*     'simp' for simple, '__k2' for hummer's k2, and 'INCO' for incomplete
      common/escdst/ chDstFun , chEscFun
      integer iooptm
      common/iooptm/ iooptm
      real GuessDiel
*this is fudge factor for scaled nussbamer and story diel recom
*set with diel kludge commmand, usually 1
      common/cludon/ GuessDiel
      real plow , phi
*     keep trace of lowest and highest pressures in model
      common/prslim/ plow , phi
      logical lgPunH2
*lgPunH2 says to punch H2 rates on unit ipPunH2
      integer ipPunH2
      common/iph2/ ipPunH2 , lgPunH2
      real OTSCap
*largest allowed ratio of line ots to total photo rate,
*set to 1.5 in scalar
      common/capots/ OTSCap
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      real the1lo
      integer nhe1lo
      common/the1lo/ the1lo , nhe1lo
      real the2lo
      integer nhe2lo
      common/the2lo/ the2lo , nhe2lo
      real rdfalt
      common/rdfalt/ rdfalt
      real ScaleMetals
*scale factor for metals, set with metals command
      common/dmetal/ ScaleMetals
      real EdenExtra
*extra electrons added with eden command
      common/edxtra/ EdenExtra
      real FluxFaint
*faintest high energy flux to consider, set with set flxfnt command
      common/flxfnt/ FluxFaint
      real otsmin
      common/otsmin/ otsmin
      real emm , egamry
      common/bounds/ emm , egamry
      real EnerGammaRay
*lowest energy counted as gamma rays, 100 keV
      integer ipEnerGammaRay
      common/egray/ EnerGammaRay , ipEnerGammaRay
      real drChange
*fractional change used in nextdr
      common/didz/ drChange
      real HeAsSav
*Einstein a's used for helium
      common/AsSav/ HeAsSav(9,8)
      real fudgea
      integer nfudge
      common/fudgec/ fudgea(nfudgc) , nfudge
      integer lhytot
      common/lhytot/ lhytot
      real bignum , smlnum
      common/number/ bignum , smlnum
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2dmp
      common/he2dmp/ he2dmp(9)
      real he1dmp
      common/he1dmpCOM/ he1dmp(9)
      real excolm , exleak , exlow
      common/extinc/ excolm , exleak , exlow
      character chPType*4
*     which type of plot
      common/ptype/ chPType(ndplot)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nzdump
      common/dump/ nzdump
      character*4 chRedis
      common/redis/ chRedis
      real toler
*     allowed error in heating - cooling balance, set with TOLERANCE command
*     default set in zerologic
      common/toler/ toler
      real r1r0sq
      common/r1r0sq/ r1r0sq
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      logical lgFaintOn
*logical lgFaintOn normally true, says to not print very faint lines
*set false with print faint off command
*lines fainter than TooFaint will not be printed.  This is set in zerologic
*and reset with print line faint command
      real TooFaint
      common/faint/ TooFaint , lgFaintOn
      real prall , psort
      common/prall/ prall , psort
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real cfle, cflf
      common/cflow/ cfle(ncfl) , cflf(ncfl)
      integer nism
      parameter (nism=23)
      real tnuism , fnuism
      common/conism/ tnuism(nism) , fnuism(nism)
      integer nkn120
      parameter (nkn120=11)
      real tnuakn , fnuakn
      common/akn120/ tnuakn(nkn120) , fnuakn(nkn120)
      integer nagn
      parameter (nagn=8)
      real tnuagn , tslagn
      common/genagn/ tnuagn(nagn) , tslagn(nagn)
      integer ncrab
      parameter (ncrab=10)
      real tnucrb , fnucrb
      common/crabcn/ tnucrb(ncrab) , fnucrb(ncrab)
      integer nrubin
      parameter (nrubin=45)
      real tnurbn , fnurbn
      common/conrbn/ tnurbn(nrubin) , fnurbn(nrubin)
      real prspow
      common/prspow/ prspow
      integer itrprt
      common/itrprt/ itrprt(itrdim)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real turhet,turrad
      common/turhet/ turhet,turrad
      real cryden , crpowr , crtemp , hxtot
      common/hextra/ cryden , crpowr , crtemp , hxtot
      logical lgSMinON
*lgSMinON is flag saying that set drmin has been enteed
*     these are 1e-30 and 1e30 by default, and are set with "set dr" cmnds
*     used as one of a pair of limits to how big or small zones get
*     set dr command forces constant dr by setting both to same number
      real sdrmin , sdrmax
      common/sdrmin/ sdrmin , sdrmax , lgSMinON
      real telow , tehigh
*     this is the default lowest to highest temperature checked
      common/telow/ telow , tehigh
      real CycloCoolCoef
*coefficient scaled from magnetic field used for
*Cyclotron cooling
      common/cyclot/ CycloCoolCoef
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      real DampOnFac
*usually 1, set to 0 with hydrogen damping off command, scales rayleigh scat
      common/dampon/ DampOnFac
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      real HColStop , colpls , colnut
*limit column densities set with stop column command
*colend is total hydrogen column, others are ionized and neutral
      common/colend/ HColStop , colpls , colnut
      real StopElecDensity
*stopping electron density, set with stop eden command
      common/endedn/ StopElecDensity
      character chReason*21
      common/reason/ chReason
*     limfal is limit to number of te failures, set with "failures" cmnd
*     lgNoMap is option not to map failures
      integer limfal
      logical lgNoMap
      common/limfal/ limfal , lgNoMap
      character chElNames*4
      common/ElNames/ chElNames(limelm)
      real Depletion , depset
*     Depletion is set of stored scale factors for depletion of general ism
*     depset is unity unless depletion is used
*     lgDepln is true if depln used
      logical lgDepln
      common/deplon/ Depletion(limelm) , depset(limelm) , lgDepln
      real AtomicWeight
*stored vector of atomic weights for all elements, set in block data scalar
      common/AtomcWgt/ AtomicWeight(limelm)
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
      character chIonStage*4
      common/IonStage/ chIonStage(limelm+1)
      real SolarSave , anova , apn , ahii, camern, aprim, aism
      common/solars/ SolarSave(limelm) , anova(limelm) , apn(limelm) ,
     1 ahii(limelm) , camern(limelm) , aprim(limelm) , aism(limelm)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      real OptGlobalErr
*set with optimize tolerance command, used for global match to fit
* default set in scalar to 0.10
      common/vtoler/ OptGlobalErr
      real EdenError
*     this is relative error in the electron density we want
*     set in block data to 0.01
*     reset with set EdenError command
      common/erredn/ EdenError
      logical lgPrtStart
*lgPrtStart is option to start printout at certain zone
*nstart is zone number, set with print start command
      integer nstart
      common/pstart/ lgPrtStart , nstart
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
*     number of continuum point to enter into line array
      integer nPredCont
*     pointers to position in line array for continuum points
      parameter (nPredCont=50)
      integer ipPredCont(nPredCont)
*     values of continuum points in Rydbergs, entered in block data scalar
      real EnrPredCont(nPredCont)
      common/PredCont/ EnrPredCont, ipPredCont
      integer nBetaVer
*     normally zero, non-zero if this is a beta test version
      common/BetaVer/ nBetaVer
      character chShell(7)*2
*character representation of shells 1 to 7 of atoms and ions, '1s', '2s', etc
      common/Shell/ chShell
      real WeakHeatCool
*     threshold for faintest cooling or heating to be punched
*     default is set to 0.05 in scalar, can be reest with 'set weakheatcool',
      common/WkHtCl/ WeakHeatCool
      logical lgQHeat
*Kevin Volk add for quantum heating of grains
      common/qheat/ lgQHeat(ndust)
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
      integer iPredFe2(3,LimPredFe2)
*set of pointers to bands within Katya's FeII atom
*first dim is band wavelength, lower, upper bounds
*second is number of bands
      common/PredFe2/ iPredFe2
*
*     local variables
      integer i , j
*
*     list of shells, 1 to 7
      data chShell/'1s', '2s', '2p', '3s', '3p', '3d', '4s'/
*
*     energies where diffuse continuuum is to be entered into line array
      data EnrPredCont/ 7.345e-04, 1.498e-03,2.211e-03,2.952e-03,
     1    3.677e-03,
     1    4.314e-03, 5.162e-03, 6.240e-03,7.320e-03,9.776e-03,1.293e-02,
     2    2.216e-02, 3.922e-02, 5.548e-02,6.213e-02,6.248e-02,8.149e-02,
     3    0.1109, 0.1111, 0.1468, 0.1866, 0.2498, 0.2501, 0.3811,0.4401,
     4    0.4441, 0.5083, 0.6251, 0.6718, 0.7027, 0.7219, 0.7484,0.7620,
     5    0.7758, 0.7971, 0.8189, 0.8263, 0.8489, 0.8565, 0.8800,0.9112,
     6    0.9982, 1.000,  1.199,  1.299,  1.499,  1.585,  1.805 , 1.809,
     7    2.283/
*
*     bands where FeII emission from Katya's atom will be entered into lines
*     negative sign flags wavelength, not yet converted to pointer
*     first number wavelength given in main lines printout
*     second two are bounds for summing over the FeII atom emission
*     line included if wavelength ge lower, le upper
*     number of wavelength bands is set by LimPredFe2 as set in parameter
      data (iPredFe2(i,1),i=1,3)/  1120, 1070, 1170/,
     1     (iPredFe2(i,2),i=1,3)/  1450, 1400, 1500/,
     1     (iPredFe2(i,3),i=1,3)/  1550, 1500, 1600/,
     1     (iPredFe2(i,4),i=1,3)/  1650, 1600, 1700/,
     1     (iPredFe2(i,5),i=1,3)/  1787, 1784, 1789/,
     1     (iPredFe2(i,6),i=1,3)/  2430, 2200, 2660/,
     1     (iPredFe2(i,7),i=1,3)/  2780, 2660, 2900/,
     1     (iPredFe2(i,8),i=1,3)/  2960, 2900, 3025/,
     1     (iPredFe2(i,9),i=1,3)/  3180, 3025, 3330/,
     1     (iPredFe2(i,10),i=1,3)/ 4600, 4450, 4750/,
     1     (iPredFe2(i,11),i=1,3)/ 4920, 4750, 5080/,
     1     (iPredFe2(i,12),i=1,3)/ 5270, 5080, 5460/
*
*     these are the numbers of freq points in the atlas and werner grids,
*     after they were remapped onto the cloudy scale,
*     must be changed whenever energy mesh is changed
      data nWerner/3613/ , nAtlas/3282/ , nRauch/3594/
*
*     this is version of beta test, normally zero
*c90 beta 3, May 23 1996
*c90 beta 4, June 9 1996
      data nBetaVer/ 0/
*
*     zero out array of line labels.  This can only be done
*     one time when code is initialized since array of pointers
*     is only set up one time, in SetLine
      data chLineLabel/ncell*'    '/
      data chContLabel/ncell*'    '/
*
*     threshold for faintest heating cooling to punch with
*     punch heating or punch cooling commands,
*     can be reset with PUNCH WEAKHEATCOOL command
      data WeakHeatCool/0.05/
*
*     this is number of init lines read in
      data nSaveIni/0/
*
*     this is a zero to trick smart fortran compilers
      data ZeroNum/0./
*
*     say what is needed
      data lgTalk/.true./ , lgCalled/.false./
*
*     we will execute the code
      data lgNoExec/.false./
*
*     list of atomic weights, used for thermal line widths
      data AtomicWeight/ 1.0080, 4.0026, 6.941, 9.0122, 10.811,
     1 12.011, 14.0067, 15.9994, 18.9984, 20.179, 22.9898, 24.305,
     2 26.9815, 28.086, 30.9738, 32.06, 35.453, 39.948, 39.102,
     3 40.08, 44.956, 47.90, 50.9414, 51.996, 54.9380, 55.847,
     4 58.9332, 58.71, 63.546, 65.37/
*
*     symbols for elements, used in various printouts
      data chElementSym/'H ','He','Li','Be','B ','C ','N ','O ','F ',
     1 'Ne','Na','Mg','Al','Si','P ','S ','Cl','Ar','K ','Ca',
     2'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn'/
*
*     ionization stages
      data chIonStage/' 1',' 2',' 3',' 4',' 5',' 6',' 7',' 8',' 9','10',
     1                '11','12','13','14','15','16','17','18','19','20',
     2                '21','22','23','24','25','26','27','28','29','30',
     3 '31'/
*
*     default no printing of optical depths, TooFaint is .1
      data lgPrtTau/.false./ , PrtTauFnt/0.1/
*
*     labels for match on element name
*     this must be caps for present logic in matches
      DATA chElNames/'HYDR','HELI','LITH','BERY','BORO','CARB','NITR',
     1       'OXYG','FLUO','NEON','SODI','MAGN','ALUM','SILI','PHOS',
     2       'SULP','CHLO','ARGO','POTA','CALC','SCAN','TITA','VANA',
     3       'CHRO','MANG','IRON','COBA','NICK','COPP','ZINC'/
*
      data
     1   chElNam/'Hydrogen  ', 'Helium    ', 'Lithium   ', 'Beryllium ',
     1           'Boron     ', 'Carbon    ', 'Nitrogen  ', 'Oxygen    ',
     2           'Fluorine  ', 'Neon      ', 'Sodium    ', 'Magnesium ',
     2           'Aluminium ', 'Silicon   ', 'Phosphorus', 'Sulphur   ',
     2           'Chlorine  ', 'Argon     ', 'Potassium ', 'Calcium   ',
     2           'Scandium  ', 'Titanium  ', 'Vanadium  ', 'Chromium  ',
     2           'Manganese ', 'Iron      ', 'Cobalt    ', 'Nickel    ',
     2           'Copper    ', 'Zinc      '/
*
      data chCardSav /nkrd*'error - no line image input'/
*
*     drChange was reset to get orion flux in h-beta correct
*     drChange is really tau of current zone
      data bignum/1.5e38/ , smlnum/3e-37/ , drChange/ 0.15/ ,
     2 lhytot/0/ , otsmin/0./ , FluxFaint/1e-10/ , itoptm/20/,
     3 ScaleMetals/1./ , GuessDiel/1./ , chOpcTyp/'    '/ ,
     3 thlo/1000./ , the1lo/1000./ , the2lo/1500./ ,
     4 OTSCap/1.5/ , CrsSecNeutron/4e-26/,
     5 RangeMap/10.,.99e10/ , MapZone/9999/ , plow/1e36/ , phi/-1e36/,
     6 iooptm/9/,
     6 chDstFun/'  K2'/ , chEscFun/'  K2'/ , nrange/0/ ,
     7 OptGlobalErr/0.10/ ,
     7 StopElecFrac/-1e37/ , covrt/0./ , covgeo/1./, dReff/1./ ,
     7 dVeff/1./ ,
     8 dRNeff/1./,nlobs/0/,ncobs/0/ , qq/6/, ipPunH2/7/,
     9 lgPunH2/.false./, chOptRtn/'SUBP'/
*
*     upper limit to energies of inner shell opacities in ryd
*     this is 1 mev by default
      data EnergyKshell/7.35e4/
*
*     RDFALT is log of default starting radius (cm)
      data rdfalt/25./ , nMapStep/20/ , COLimit/0.80/,EdenError/0.01/
*
*     following used by AMOOEBA
      data rincrm/limpar*0./ , (varang(1,i),i=1,limpar)/limpar*-1e37/,
     1 (varang(2,i),i=1,limpar)/limpar*1e37/
*
*     statistical weights of 10 level H, He+ atoms
*     data he2stat/2.,6.,18.,32.,50.,72.,588.,4970.,6.71e5,2./
*     statistical weights of 10 level He singlet atoms
*     data he1stat/1.,3.,9.,16.,25.,36.,294.,2485.,3.355e5,1./
*     data statsn/1.,3.,9.,16.,25.,36.,294.,2485.,3.355e5,1./
*
*     array of lifetimes for helium lines - sum of a's down/4pi*912
      data he2dmp/0.,455.1,72.4,21.9,8.42,3.77,1.82,0.939,0.438/
      data he1dmp/0.,455.1,72.4,21.9,8.42,3.77,1.82,0.939,0.438/
*
*     HLIFE is lifetime of excited states FOR CASE B - no Lyman line
*     DATA HLIFE/0.,0. ,4.41E7,1.741E7,7.431E6,3.547E6,1.860E6,
*    1 1.051E6,6.306E5,3.973e5,2.607e5,1.770e5,1.237e5,8.868e4,
*    2 6.496e4,4.850e4,3.683e4,2.842e4,2.091e4,1.754e4/
*
*     used for hei and scaled heii A's, not for H
*     >>chng 96 june 4, cota leves were still in place
      data ((HeAsSav(j,i),j=1,9),i=1,8)/
     10.,6.265E8,5.575E7,1.278E7,4.125E6,1.644E6,7.568E5,3.86e5 ,2.14e5,
     20.,0.,     4.41E7 ,8.42E6 ,2.53E6 ,9.73E5 ,4.39E5 ,2.219E5,1.22e5,
     30.,0.,     0.     ,8.99E6 ,2.201E6,7.78E5 ,3.36E5 ,1.65E5 ,8.91e4,
     40 ,0.,     0.     ,0.     ,2.70E6 ,7.71E5 ,3.041E5,1.42e5 ,7.46e4,
     50.,0.,     0.     ,0.     ,0.     ,1.025E6,3.253E5,1.39e5 ,6.91e4,
     60.,0.,     0.     ,0.     ,0.     ,0.     ,4.561E5,1.56e5 ,7.07e4,
     70.,0.,     0.     ,0.     ,0.     ,0.     ,0.     ,2.27e5 ,8.24e4,
     80.,0.,     0.     ,0.     ,0.     ,0.     ,0.     ,0.     ,1.23e5/
*
      data nzdump/-100/ , excolm/0./ , exleak/0./,
     2 exlow/1./ , EdenExtra/0./
*
*     generic AGN continuum taken from Mathews and Ferland ApJ Dec15 '87
*     except self absorption at 10 microns, nu**-2.5 below that
      DATA tnuagn/1E-5, 9.12E-3, .206, 1.743, 4.13, 26.84, 7353., 7.4E6/
     1 ,  tslagn/-3.388,4.0115 ,2.6576,2.194,1.819,-.6192,-2.326, -7.34/
*
*     Crab Nebula continuum from Davidson and Fesen, 1985 Ann Rev
*     second vector is F_nu as seen from Earth
      DATA tnucrb/1.0E-5, 5.2E-4, 1.5E-3, 0.11, 0.73, 7.3, 73., 7300.,
     1 1.5E6, 7.4E6 /
     2  fnucrb/3.77E-21, 1.38E-21, 2.10E-21, 4.92E-23, 1.90E-23,
     3 2.24E-24, 6.42E-26, 4.02E-28, 2.08E-31, 1.66E-32/
*
*     Bob Rubin's theta 1 Ori C continuum, modified from Kurucz to
*     get NeIII right
      DATA tnurbn /1E-5, 1.0,1.02445,1.07266,
     1 1.12563,1.18411, 1.23881,1.29328,
     2 1.35881,1.42463, 1.48981,1.55326,
     3 1.6166 ,1.68845, 1.76698,1.8019,
     4 1.8078, 1.8082 , 1.84567,1.9317,
     5 2.04891,2.14533, 2.19702,2.27941,
     6 2.37438,2.43137, 2.49798,2.56113 ,
     7 2.59762,2.66597, 2.80543,2.95069,
     8 3.02911,3.11182, 3.22178,3.3155,
     9 3.42768,3.50678, 3.56157,3.61811,
     1 3.75211,3.89643, 4.0    ,4.1, 1E5/
*     Emergent fluxes are in units of erg/(cm^2 s Hz) and are what Kurucz
*     (and model atmosphere types) call pi*F_nu.
      DATA fnurbn/.181419E-11, .181419E-01,.145003E-01,.129057E-01,
     1 .130125E-01,.115540E-01,.114839E-01,.964582E-02,
     2 .922259E-02,.829783E-02,.735761E-02,.651893E-02,
     3 .617587E-02,.510496E-02,.499538E-02,.364324E-02,
     4 .325440E-02,.325440E-02,.162006E-02,.139964E-02,
     5 .127473E-02,.100621E-02,.102095E-02,.900858E-03,
     6 .460721E-03,.699557E-03,.861525E-03,.751004E-03,
     7 .500242E-03,.568666E-03,.418121E-03,.619107E-04,
     8 .279322E-04,.404350E-04,.266258E-04,.186196E-04,
     9 .146275E-04,.203668E-05,.799454E-06,.868859E-06,
     1 .370180E-06,.186293E-06,.450348E-07, 1E-15 , 1E-20/
*
*     cooling flow continuum from Johnstone et al. MNRAS 255, 431.
      data (cfle(i),cflf(i),i=1,5)/
     1 0.0000100,-0.8046910 ,
     1 0.7354023 ,  -0.8046910 , 1.4708046 ,  -0.7436830 ,
     1 2.2062068 ,  -0.6818757 , 2.9416091 ,  -0.7168990 /
      data (cfle(i),cflf(i),i=6,ncfl)/
     1 3.6770115 ,  -0.8068384 , 4.4124136 ,  -0.6722584 ,
     1 5.1478162 ,  -0.7626385 , 5.8832183 ,  -1.0396487 ,
     1 6.6186204 ,  -0.7972314 , 7.3540230 ,  -0.9883416 ,
     1 14.7080460,  -1.1675659 , 22.0620689,  -1.1985949 ,
     1 29.4160919,  -1.2263466 , 36.7701149,  -1.2918345 ,
     1 44.1241379,  -1.3510833 , 51.4781609,  -1.2715496 ,
     1 58.8321838,  -1.1098027 , 66.1862030,  -1.4315782 ,
     1 73.5402298,  -1.1327956 , 147.080459,  -1.6869649 ,
     1 220.620681,  -2.0239367 , 294.160919, -2.2130392 ,
     1 367.701141, -2.3773901 , 441.241363, -2.5326197 ,
     1 514.7816162, -2.5292389 , 588.3218384 , -2.8230250 ,
     1 661.8620605 , -2.9502323 , 735.4022827 , -3.0774822 ,
     1 1470.8045654,  -4.2239799 , 2206.2067871,  -5.2547927 ,
     1 2941.6091309,  -6.2353640 , 3677.0114746,  -7.1898708 ,
     1 4412.4135742,  -8.1292381 , 5147.8159180,  -9.0594845 ,
     1 5883.2182617,  -9.9830370 , 6618.6206055, -10.9028034 ,
     1 7354.0229492, -11.8188877 , 7400.0000000, -30.0000000 ,
     1 10000000.0000000 ,    -30.0000000 /
*
*     AKN120 continuum from Brad Peterson's plot
*     second vector is F_nu*1E10 as seen from Earth
      DATA tnuakn/  1E-5 , 1.9E-5  , 3.0E-4  , 2.4E-2  , 0.15   ,
     1    0.30  ,   0.76 ,    2.0  ,  76.0   , 760.    , 7.4E6  /
      DATA fnuakn/1.5E-16, 1.6E-16 , 1.4E-13 , 8.0E-15 , 1.6E-15 ,
     1  1.8E-15 , 7.1E-16,  7.9E-17, 1.1E-18 , 7.1E-20 , 1.3E-24/
*
*     interstellar radiation field from Black 1987, "Interstellar Processes"
*     table of log nu, log nu*fnu taken from his figure 2
      DATA tnuism/   9.00  ,  10.72  ,  11.00  ,  11.23  ,  11.47  ,
     1    11.55  ,  11.85  ,  12.26  ,  12.54  ,  12.71  ,  13.10  ,
     2    13.64  ,  14.14  ,  14.38  ,  14.63  ,  14.93  ,  15.08  ,
     3    15.36  ,  15.43  ,  16.25  ,  17.09  ,  18.00  ,  23.00  /
      DATA fnuism/  -7.97  ,  -2.96  ,  -2.47  ,  -2.09  ,  -2.11  ,
     1    -2.34  ,  -3.66  ,  -2.72  ,  -2.45  ,  -2.57  ,  -3.85  ,
     2    -3.34  ,  -2.30  ,  -1.79  ,  -1.79  ,  -2.34  ,  -2.72  ,
     3    -2.55  ,  -2.62  ,  -5.68  ,  -6.45  ,  -6.30  ,  -11.3  /
*
      DATA chPType/ndplot*'NONE'/
*
      data hden /-99./ , chRedis/'INCO'/ , toler/0.02/ ,
     2 TooFaint/1e-3/ , lgFaintOn/.true./ , prall,psort/2*0./,nfudge/0/,
     3 taumin, tlamin/2*1e-20/ , fudgea/nfudgc*0./ ,
     4 prspow/0./ , itrprt/itrdim*10000/ , turhet/0./ , turrad/1e30/ ,
     6 cryden,crpowr,crtemp,hxtot/4*0./ ,
     7  sdrmin/1e-30/ , sdrmax/1e30/ , tehigh/1e10/ ,
     8 telow/2.8/ , lgSMinON/.false./ , CycloCoolCoef/0./
*
      data NormWL/1/ , sclnrm/1./ , ForceTemp/0./,
     2 itermx,iter/0,0/ , nsum/0/ , DampOnFac/1./ , comtot/0./ ,
     3 comoff/1./ , cmcool/0./
*
      data  emm/1.001e-5/, egamry/7.354e6/ ,EnerGammaRay /7676./
*
*     solar abundances Grevesse and Anders 1989, Grevesse and Noel 1993
      data SolarSave(1)/1.0/   , SolarSave(2)/0.100/ ,
     1   SolarSave(3)/2.04e-9/ , SolarSave(4)/2.63e-11/ ,
     2   SolarSave(5)/7.59e-10/, SolarSave(6)/ 3.55E-4/,
     3   SolarSave(7)/ 9.33E-5/, SolarSave(8)/ 7.41E-4/,
     4   SolarSave(9)/ 3.02e-8/, SolarSave(10)/ 1.17E-4/,
     5   SolarSave(11)/2.06E-6/, SolarSave(12)/ 3.80E-5/,
     6   SolarSave(13)/2.95E-6/, SolarSave(14)/ 3.55E-5/,
     7   SolarSave(15)/3.73e-7/, SolarSave(16)/ 1.62E-5/,
     8   SolarSave(17)/1.88E-7/, SolarSave(18)/ 3.98E-6/,
     9   SolarSave(19)/1.35e-7/, SolarSave(20)/ 2.29E-6/,
     1   SolarSave(21)/1.58e-9/, SolarSave(22)/1.10e-7/,
     2   SolarSave(23)/1.05e-8/, SolarSave(24)/4.84e-7/,
     3   SolarSave(25)/3.42e-7/, SolarSave(26)/ 3.24E-5/,
     4   SolarSave(27)/8.32e-8/, SolarSave(28)/ 1.76E-6/,
     5   SolarSave(29)/1.87e-8/, SolarSave(30)/4.52e-8/
*
*     Nova Cyg 75 abundances, C, O, NE UP 20, NIT UP 100, REST SOLAR AR
      data anova(1)/1.0/   , anova(2)/0.098/ ,
     1   anova(3)/2.04e-9/ , anova(4)/2.6e-11/ ,
     2   anova(5)/7.60e-9/ , anova(6)/ 9.4E-4/,
     3   anova(7)/ 9.8E-3/ , anova(8)/ 1.7E-2/,
     4   anova(9)/ 3.02e-8/, anova(10)/ 2.03E-3/,
     5   anova(11)/2.06E-6/, anova(12)/ 3.80E-5/,
     6   anova(13)/2.95E-6/, anova(14)/ 3.55E-5/,
     7   anova(15)/3.73e-7/, anova(16)/ 1.62E-5/,
     8   anova(17)/1.88E-7/, anova(18)/ 3.63E-6/,
     9   anova(19)/1.35e-7/, anova(20)/ 2.29E-6/,
     1   anova(21)/1.22e-9/, anova(22)/8.60e-8/,
     2   anova(23)/1.05e-8/, anova(24)/4.84e-7/,
     3   anova(25)/3.42e-7/, anova(26)/ 4.68E-5/,
     4   anova(27)/2.24E-9/, anova(28)/ 1.76E-6/,
     5   anova(29)/1.87e-8/, anova(30)/4.52e-8/
*
*     primordial abundances
      data aprim/1.0,0.072,1E-10, 1E-16,26*1e-25/
*
*     typical ISM abundances, mean of Table 3, Cowie+Songaila, Ann Rev '86
*     also Table 5, Savage and Sembach, Ann Rev 1996
      data aism(1)/1./, aism(2)/ 0.098/, aism(3)/5.4E-11/,
     1 aism(4)/1E-20/,
     1 aism(5)/8.9E-11/, aism(6)/ 2.51e-4/, aism(7)/ 7.94e-5/,
     2 aism(8)/ 5.01e-4/, aism(9)/1E-20/, aism(10)/ 1.23e-4/,
     3 aism(11)/ 3.16e-7/, aism(12)/ 1.26e-5/, aism(13)/ 7.94e-8/,
     4 aism(14)/ 3.16e-6/, aism(15)/1.6E-7/, aism(16)/ 3.24e-5/,
     5 aism(17)/ 1e-7 /, aism(18)/ 2.82e-6/, aism(19)/1.1E-8/,
     6 aism(20)/ 4.1e-10/, aism(21)/1E-20/, aism(22)/5.8E-10/,
     7 aism(23)/1.0E-10/, aism(24)/1.0E-8/, aism(25)/2.3E-8/,
     8 aism(26)/6.31E-7/,
     8 aism(27)/1e-20/ , aism(28)/ 1.82e-8 /, aism(29)/1.5E-9/,
     9 aism(30)/2.0E-8/
*
*     typical ISM depletion factors, subjective mean of Cowie and Songaila
*     and Jenkins
*
      data
     1  Depletion(1)/1./    ,  Depletion(2)/1./,   Depletion(3)/.16/,
     2  Depletion(4)/.6/    ,  Depletion(5)/.13/,  Depletion(6)/0.4/,
     3  Depletion(7)/1.0/   , Depletion(8)/0.6/,   Depletion(9)/.3/ ,
     4  Depletion(10)/1./   , Depletion(11)/0.2/,  Depletion(12)/0.2/,
     3  Depletion(13)/0.01/ , Depletion(14)/0.03/, Depletion(15)/.25/,
     4  Depletion(16)/1.0/  , Depletion(17)/0.4/,  Depletion(18)/1.0/,
     5  Depletion(19)/.3/   , Depletion(20)/1E-4/, Depletion(21)/5e-3/,
     6  Depletion(22)/8e-3/ , Depletion(23)/6e-3/, Depletion(24)/6e-3/,
     7  Depletion(25)/5e-2/ , Depletion(26)/0.01/, Depletion(27)/0.01/,
     8  Depletion(28)/0.01/ , Depletion(29)/.1/ ,  Depletion(30)/.25/
*
*     HII region abundances, Orion mean of Baldwin et al, Rubin et al,
*     and DEO et al, all 1991 apj
*     also Table 5, Savage and Sembach, Ann Rev 1996 for ism
      data ahii(1)/1./, ahii(2)/ 0.095/,ahii(3)/5.4E-11/,ahii(4)/1E-20/,
     1 ahii(5)/8.9E-11/,ahii(6)/3.e-4/,ahii(7)/ 7.0e-5/,ahii(8)/4.0E-4/,
     2 ahii(9)/1E-20/,ahii(10)/6e-5/, ahii(11)/3e-7/, ahii(12)/3.E-6/,
     3 ahii(13)/2.e-7/,ahii(14)/4.e-6/,ahii(15)/1.6E-7/,
     3 ahii(16)/1.0E-5/,
     4 ahii(17)/1.e-7/,ahii(18)/3.e-6/,ahii(19)/1.1E-8/,ahii(20)/2.E-8/,
     5 ahii(21)/1E-20/, ahii(22)/5.8E-10/,ahii(23)/1.0E-10/,
     3 ahii(24)/1.0e-8/,
     6 ahii(25)/2.3E-8/, ahii(26)/ 3.0e-6/, ahii(27)/ 1e-20/,
     7 ahii(28)/ 1e-7/, ahii(29)/1.5E-9/, ahii(30)/2.0E-8/
*
*     PN abund from Aller+Czyzak, ApJ Sup 51, 211
      data apn(1)/1./, apn(2)/0.1/, apn(3)/1E-20/, apn(4)/1E-20/,
     1 apn(5)/1E-20/, apn(6)/7.8e-4/, apn(7)/1.8e-4/, apn(8)/4.4e-4/,
     2 apn(9)/3E-7/, apn(10)/1.1e-4/, apn(11)/1.9e-6/, apn(12)/1.6E-6/,
     3 apn(13)/2.7e-7/, apn(14)/1e-5/, apn(15)/2E-7/, apn(16)/1e-5 /,
     4 apn(17)/1.7e-7 /, apn(18)/2.7e-6/,apn(19)/1.2E-7/,apn(20)/1.2E-8/,
     5 apn(21)/1E-20/, apn(22)/1E-20/, apn(23)/1E-20/, apn(24)/1E-20/,
     6 apn(25)/1E-20/, apn(26)/5.0e-7/, apn(27)/1e-20/, apn(28)/1.8E-8/,
     7 apn(29)/1E-20/, apn(30)/1E-20/
*
*     mix from Cameron 1982, in "Essays on Nuclear Astro"
      data camern(1)/1./, camern(2)/ .0677/, camern(3)/2.2E-9/,
     1 camern(4)/4.5E-11/, camern(5)/3.4E-10/, camern(6)/ 4.22e-4/,
     2 camern(7)/ 8.72e-5/, camern(8)/ 6.93e-4/, camern(9)/2.9E-8/,
     3 camern(10)/ 9.77e-5/, camern(11)/ 2.25e-6/,
     4 camern(12)/ 3.98e-5/, camern(13)/ 3.20e-6/,
     5 camern(14)/ 3.76e-5/, camern(15)/2.4E-7/, camern(16)/ 1.88E-5/,
     6 camern(17)/ 1.78e-7 /, camern(18)/ 3.99e-6/, camern(19)/1.3E-7/,
     7 camern(20)/ 2.35e-6/, camern(21)/1.16E-9/, camern(22)/9.0E-8/,
     8 camern(23)/9.5E-9/, camern(24)/4.8E-7/, camern(25)/3.5E-7/,
     9 camern(26)/ 3.38e-5/, camern(27)/ 8.27e-8/, camern(28)/ 1.80e-6/,
     1 camern(29)/2.0E-8/, camern(30)/4.7E-8/
*
      data FillFac,fiscal,filpow/2*1.,0./ , chCPres/'CDEN'/,
     2 nprint,tend/1000,4000./,
     3 HColStop , colpls , colnut /3*1e30/ , StopElecDensity/-1e30/ ,
     4 chReason/'reason not specified.'/ , lgPrtStart/.false./,
     4 nstart/0/,
     5 itime,dt,tmt1,tmpwr/0,3*0./ , limfal/20/ , lgNoMap/.false./,
     6 r1r0sq/1./
*
* (K Volk) added the qheat stuff here
      data lgQHeat/ndust*.false./
      data nqp1/ndust*0/, nqout1/0/, iqp/0/, qtmax/0./
      data qdep/ndust*1.0/
      data qhnrat/1.8732e+10,1.6387e+10,2.7518e+11,2.4073e+11,
     c            3.7065e+09,3.7069e+11,1.6387e+10,1.6387e+10,
     c            3.6312e+07,6.4191e+06,1.0e+07,1.0e+07,1.0e+07,
     c            1.0e+07,1.0e+07,1.0e+07,1.0e+07,1.0e+07,1.0e+07,
     c            1.0e+07/
* End of initialization of QHEAT values (K Volk)
      end
******************************************************************************
      subroutine scandi
      implicit none
*do ionization balance for scandium
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (nelem=21)
      parameter (ndim=22)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real FYIELD(nelem) , GRDEFF(nelem)
*
*     titanium nelem=21
*     based on iron
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.26E-10,4.97E-11,1.49E-10,3.90E-11,1.66E-11,7.16E-12,
     1 3.00E-12,1.02E-12,2.54E-12,1.70E-12,1.11E-12,6.42E-13,3.59E-13,
     2 9.30E-14,1.62E-14,5.97E-14,8.44E-14,5.92E-14,4.72E-14,3.79E-14,
     3 2.60E-14/
      data (cion(i,2),i=1,ndim-1)
     1 /9.13E4,1.88E5,3.56E5,6.36E5,8.70E5,1.15E6,1.45E6,1.75E6,
     2 2.73E6,3.04E6,3.37E6,3.84E6,4.19E6,4.55E6,5.30E6,5.68E6,
     3 1.47E7,1.58E7,1.69E7,1.84E7,1.96E7/
*
*     DATA FYIELD/2*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47, 3*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/nelem*0.2/
*
*     Fe rates from Woods et al. Ap.J. 249, 399.
*     rec from +23, 24 25 from Arnauld et al 85
      data rec,pl
     1/ 5.2E-10 , 2.40E-9 , 3.20E-9 , 4.17E-9 , 9.44E-9 , 2.14E-8
     2, 4.48E-8 , 8.75E-8 , 1.41E-7 , 2.26E-7 , 2.73E-7 , 3.56E-7
     3, 4.42E-7 , 5.52E-7 , 7.00E-7 , 8.59E-7 , 8.55E-7 , 8.93E-7
     4, 9.64E-7 , 1.06E-6 ,
     1  -0.891  , -0.843  , -0.746  , -0.682  , -0.699  , -0.728
     2, -0.759  , -0.790  , -0.810  , -0.829  , -0.828  , -0.834
     3, -0.836  , -0.840  , -0.846  , -0.850  , -0.836  , -0.824
     4, -0.816  , -0.811  /
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.28e-10 , -0.686 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.58E-3  , 8.38E-3  , 1.54E-2, 3.75E-2, 0.117   , 0.254
     2, 0.291   , 0.150   , 0.140   , 0.100   , 0.200   , 0.240
     3, 0.260   , 0.190   , 0.120   , 0.350   , 0.066   , 0.10
     4, 0.13    , 0.23
     5, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/ .456    , .323    , .310    , .411    , .359    , .0975
     1, .229    , 4.20    , 3.30    , 5.30    , 1.50    , 0.700
     1, .600    , .5      , 1.      , 0.      , 7.8     , 6.3
     1, 5.5     , 3.6
     1, 0./
      data (dite(i,1),i=1,ndim-1)
     1/ 6.00E4  , 1.94E5  , 3.31E5  , 4.32E5  , 6.28E5  , 7.50E5
     2, 7.73E5  , 2.62E5  , 2.50E5  , 2.57E5  , 2.84E5  , 8.69E5
     3, 4.21E5  , 4.57E5  , 2.85E5  , 8.18E5  , 1.51E6  , 1.30E6
     4, 1.19E6  , 1.09E6
     5, 0./
      data (dite(i,2),i=1,ndim-1)
     1/8.97E4   , 1.71E5  , 2.73E5  , 3.49E5  , 5.29E5  , 4.69E5
     2,6.54E5   , 1.32E6  , 1.33E6  , 1.41E6  , 1.52E6  , 1.51E6
     3,1.82E6   , 1.84E6  , 2.31E6  , 0.      , 9.98E6  , 9.98E6
     4,1.00E7   , 1.10E7
     5 , 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5
     5, 1E20    /
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      END
******************************************************************************
      subroutine SetCon(lgOK )
      implicit none
*derive intensity of incident continuum
      logical lgOK
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real pi4
      parameter (pi4=12.566371)
      real hnu3c2
      parameter (hnu3c2=0.524166)
      real fr1ryd
*     frequency of 1 rydberg
*     FR1RYD is frequency for 912
      parameter (fr1ryd=3.28805E15)
      real en1ryd
*     Cohen Taylor 1986 Codata fund const
*     see physics today, Aug '96, p BG11
      parameter (en1ryd=2.179874E-11)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
      real planck
      parameter (planck=6.62259e-27 )
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real SpeedLight
*from Physics Today Aug '96, BG 10
      parameter (SpeedLight=2.99792458E10 )
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer limelm
      parameter (limelm=30)
      real emm , egamry
      common/bounds/ emm , egamry
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real EnerGammaRay
*lowest energy counted as gamma rays, 100 keV
      integer ipEnerGammaRay
      common/egray/ EnerGammaRay , ipEnerGammaRay
*quantities to do with radiation field and printed in header
      real qx , powion , xpow , pbal ,q,qgam,pradio , fx1ryd ,
     1 GammaLumin
      integer ipeak
      common/prhd/ qx , powion , xpow , pbal , q , qgam , pradio ,
     1 fx1ryd , ipeak, GammaLumin
*     include "gampow.com"
      real EdenTrue
*     this is the true eden as set in esum
*     we will try to converge eden to this
      common/TrueEden/ EdenTrue
      real EdenExtra
*extra electrons added with eden command
      common/edxtra/ EdenExtra
      real smbeta , cn4861 , cn1216
      common/smbeta/ smbeta , cn4861 , cn1216
      real sv4861 , sv1216
      common/sv4861/ sv4861 , sv1216
      logical lgConBug
*flag set with trace continuum command
      common/conbug/ lgConBug
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      logical lgSecOFF
*flag saying that secondary electron have been turned off
      common/secoff/ lgSecOFF
      logical lgCompRecoil
*flag saying that compton recoil ionization of bound
*electrons is enabled
      common/recoil/ lgCompRecoil
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real FluxSave
*save incident continuum for later iterations
      common/flxsav/ FluxSave(ncell)
      real hisv,hiisv,hsv,edsav,EDOthSav,EDMSav
      common/save/ hisv,hiisv,hsv,edsav,EDOthSav,EDMSav
      real csigh , csigc
      common/comsig/ csigh(ncell) , csigc(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real tmn
      common/tmn/ tmn(ncell)
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      real e2TauAbs
*E2(tau) exponential integral
      common/e2tau/ e2TauAbs(ncell)
      integer i2d , i2p
*pointers for photoionization into excited state of oii
      common/i3727/ i2d , i2p
      real telogn
      common/telogn/ telogn(7)
      integer ircoil , irche
      common/ircoil/ ircoil , irche
      real uh,uheii
      common/u/ uh,uheii
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      real qhtot , qhe , qheii , qbal , qrad , qtot
      common/qs/ qhtot , qhe , qheii , qbal , qrad , qtot
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real AnuOrg
*original set of energy units, always the same no matter what the
*shape of the continuum - actual energy units change with shape
      common/anusave/ AnuOrg(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      integer nxray
      common/nxray/ nxray
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgComBug
*trace compton flag
      common/combug/ lgComBug
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgOcc1Hi
*flag saying that occupation number at 1 ryd > 1
      common/occ1hi/ lgOcc1Hi
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      logical lgHabing
*flag set if incident radiation field less than
*10x the Habing ISM field
      common/habing/ lgHabing
      real TEnerDen
*energy density temperature
      common/tenden/ TEnerDen
      real TimeErode
*timescale for photoerosion of iron due to gamma rays
      common/terode/ TimeErode
      real FluxFaint
*faintest high energy flux to consider, set with set flxfnt command
      common/flxfnt/ FluxFaint
      real totlum , totlsv
      common/totlum/ totlum , totlsv
      logical lgNeutrnHeatOn
*flag lgNeutrnHeatOn says heating due to neutrons is enabled
*frcneu is fraction of total luminosity in neutrons, effneu is efficiency
*totneu is resulting total luminosity
      real frcneu , totneu , effneu
      common/neutrn/ frcneu , totneu , lgNeutrnHeatOn , effneu
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      logical lgPtrace
*flag set with drive pointers command
      common/PltTrace/ lgPtrace
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      real occmax , occmnu , tbrmax , tbrmnu , tbr4nu , occ1nu
      common/occmax/ occmax , occmnu , tbrmax , tbrmnu , tbr4nu ,
     1 occ1nu
      real hi , hii
      common/h/ hi , hii
      logical lgCon0
*flag saying that parts of continuum are zero
      common/con0/ lgCon0
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
*     indicate whether plasma freq ever entered energy array
      logical lgPlasNu
*     this is the plasma frequency
      real plsfrq
*     this is the continuum pointer to the plasma frequency, and largest it ever
      integer ipPlasma, ipPlasmax
      common/plasnu/ lgPlasNu , plsfrq , ipPlasma, ipPlasmax
      logical lgHIonON
*flag set false when hydrogen ionization too small to compute
      common/hionon/ lgHIonON
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
      logical lgHionRad
      common/HionRad/ lgHionRad
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      logical lgCSetOn
*lgCSetOn set with set csupra command
*SetCsupra is secondary ionization rate set with set csupra
      real SetCsupra
      common/cspset/ SetCsupra , lgCSetOn
      real EdenMet , EdenNotH
*     EdenMet is sum of electrons from Lit through n=30, all ions
*     EdenNotH is total electron density less the proton density
*     used in hydrogen loop for charge conservation
      common/EdenOther/ EdenMet , EdenNotH
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      real he3n
      common/he3n/ he3n(nhe3lvl)
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,j,n,ipoint,ip
      real hokcgs,fsum,factor,ffun,alf,bet,ex1ryd,fntest,p1,p,
     1 p2,pheii,p4,p5,p6,qgn,pgn,p7,tcomp,tcompr,phe,p3,ecrit,
     2 uhei,r2ov1,r3ov2,occ1 , rec , xIoniz , smeets,EdenHeav
*     HOKCGS is h/k in cgs units
      parameter (hokcgs=4.8016e-11)
*
*     free statement labels, anything >=41 except 90, 99
*
      real wanu(4) , aweigh(4) , fweigh(4)
      double precision wfun(4) , amean , amean2 , amean3 , peak
*
      data  aweigh(1)/-0.4305682/ , aweigh(2)/-0.1699905/ ,
     1      aweigh(3)/+0.1699905/ , aweigh(4)/+0.4305682/ ,
     2      fweigh(1)/+0.1739274/ , fweigh(2)/+0.3260726/ ,
     3      fweigh(3)/+0.3260726/ , fweigh(4)/+0.1739274/
*
*     set continuum
      if( lgTrace ) write(qq,'('' SetCon called.'')')
*
*     define factors to convert FLUX array into photon occupation array OCCNUM
*     by multiplication
      factor = en1ryd / pi4 / fr1ryd / hnu3c2
*
*-------------------------------------------------------------
      do i=1,nupper
*       this was original anu array with no continuum averaging
        anu(i) = AnuOrg(i)
        ContBoltz(i) = 0.
        tmn(i) = 1.
        ExpmTau(i) = 1.
        e2TauAbs(i) = 1.
        fsum = 0.
        amean = 0.
        amean2 = 0.
        amean3 = 0.
        do j=1,4
          wanu(j) = anu(i) + widflx(i)*aweigh(j)
          wfun(j) = fweigh(j) * ffun( wanu(j) )
          fsum = fsum + wfun(j)
          amean = amean + wanu(j) * wfun(j)
          amean2 = amean2 + wanu(j) * wanu(j) * wfun(j)
          amean3 = amean3 + wanu(j) * wanu(j) * wanu(j) * wfun(j)
        end do
        flux(i) = fsum * widflx(i)
        if( flux(i).gt.0. ) then
          anu(i) = amean2 / amean
          anu2(i) = amean3 / amean
*         fix conversion factor for occupation number
        else
          anu2(i) = anu(i) * anu(i)
        endif
        anu3(i) = anu2(i) * anu(i)
*
        refcon(i) = 0.
        convoc(i) = factor / widflx(i) / anu2(i)
*
*       following are Compton exchange factors from Tarter
        alf = 1./ ( 1. + anu(i)* ( 1.1792e-4 + 7.084e-10*anu(i) ) )
        bet = (1. - alf * anu(i)*(1.1792e-4+2.*7.084e-10*anu(i))/4.)
        csigh(i) = alf * anu2(i) * 3.858e-25
        csigc(i) = alf * bet * anu(i) * 3.858e-25
      end do
      if( lgTrace.and.lgComBug ) then
        write(qq,'(/,/,'' Compton heating, cooling coefficients '')')
        write(qq,'(4(i6,1p,3e9.2))')
     1  (i,anu(i),csigh(i),csigc(i),i=1,nupper,2)
      endif
*     option to check frequencies in real time, drive pointers command
      if( lgPtrace ) call ptrcer
      do i=1,nupper
*       define array of log10( nu(ryd))
        anulog(i) = log10( anu(i) )
      end do
*
*     extinguish continuum if set on
      call extin( ex1ryd )
*
*     now find peak of continuum
      ipeak = 1
      peak = 0.
      do i=ipHn(1),nupper
        if( flux(i)*anu(i)/widflx(i) .gt. peak ) then
*         IPEAK is pointer to largest f_nu,
*         and is passed to other parts of code
          ipeak = i
          peak = flux(i) * anu(i)/widflx(i)
        endif
      end do
*
*     check whether this will work on a 32 bit IEEE cpu
      peak = flux(ipeak) * anu(ipeak)
      if( peak.gt.1e38 .and. lgBit32 ) then
        write(qq,'('' SetCon: this appears to be a 32-bit cpu.'')')
        write(qq,'('' The continuum is too intense to compute'',
     1  '' with this cpu.  Use a long-word cpu or a fainter '',
     2  ''continuum. (This is the f_nu test)'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
*     say what type of cpu this is, if desired
      if( lgTrace ) then
        write(qq,'('' SetCon: The peak of the H-ion continuum is at'',
     1  1p,e10.3)')anu(ipeak)
        if( lgBit32 ) then
          write(qq,'('' SetCon: this is a 32-bit cpu.'')')
        else
          write(qq,'('' SetCon: this is a long-word cpu.'')')
        endif
      endif
*
*     find highest energy to consider in continuum flux array
*     peak is the peak product nu*flux
      peak = flux(ipeak)/widflx(ipeak)*anu2(ipeak)
*
      if( peak.gt.1e38 .and. lgBit32 ) then
        write(qq,'('' SetCon: this appears to be a 32-bit cpu.'')')
        write(qq,'('' The continuum is too intense to compute'',
     1  '' with this cpu.  Use a long-word cpu or a fainter '',
     2  ''continuum. (This is the nu*f_nu test)'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
*     FluxFaint set in block data; normally 1e-10
      fntest = peak * FluxFaint
*
      if( fntest.gt.0. ) then
*       this test for pdr conditions where NO H-ionizing radiation
        i = nupper
        do while(i.gt.ipeak .and. flux(i)*anu2(i)/widflx(i).lt.fntest)
          i = i - 1
        end do
      else
        i = ipHn(1)
      endif
*
*     this line of code dates from 1979 and IOA Cambridge.  removed july 19 95
*     nflux = max( ineon(1)+4 , i )
*
*     last number may have been zero
      do while( flux(nflux).le.0. .and. nflux.gt.1 )
        nflux = nflux - 1
      end do
*
      if( nflux.eq.1 ) then
        write(qq,'('' This incident continuum appears to have no '',
     1  ''radiation.'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
*     check that continuum defined everywhere
      lgCon0 = .false.
      ip = 0
      do i=1,nflux
        if( flux(i).le.0. ) then
          if( lgTalk.and..not.lgCon0 ) then
            write(qq,'('' Continuum has zero intensity starting at'',
     1      1p,e11.4,'' Ryd.'')') anu(i)
            lgCon0 = .true.
          endif
          ip = ip + 1
        endif
      end do
      if( lgCon0.and.lgTalk ) write(qq,'(i6,'' cells in the incident'',
     1'' continuum have zero intensity.  Problems???'')
     2')ip
*
*     turn off secondary ionizations if soft continuum source
      if( anu(nflux) .lt. 7.4 ) lgSecOFF = .true.
*
*     check whether any hydrogen ionizing radiation
      if( nflux.lt.ipHn(1) ) then
        lgHIonON = .false.
      else
        lgHIonON = .true.
      endif
*
*     dont call HE1, HE2, or HE3 routines if no ionizing radiation
      if( lgElmtOn(2) ) then
        if( nflux.lt.nhe2(1) ) then
          lgHe2ON = .false.
        else
          lgHe2ON = .true.
        endif
        lgHe1ON = .true.
      else
        lgHe1ON = .false.
        lgHe2ON = .false.
      endif
*
*     if( nflux.lt.nxray ) then
*        decoff = 0.
*        disdec = 0.
*     else
*        turn off heavy element ionization trimming when X-rays on
*        decoff = 1.
*        disdec = 1.
*     endif
*
*     turn off recoil ionization if high energy < 190R
      if( anu(nflux).le.190 ) lgCompRecoil = .false.
*
*     sum photons and energy, save mean
      call sumcon( 1      , ipHn(2)-1,  qrad ,pradio , p1 )
      call sumcon( ipHn(2), ipHn(1)-1,  qbal ,  pbal , p1 )
      call sumcon( ipHn(1), nhe1(1)-1,     q ,     p , p2 )
      call sumcon( nhe1(1), nhe2(1)-1,   qhe ,   phe , p3 )
      call sumcon( nhe2(1), nxray-1  , qheii , pheii , p4 )
      call sumcon( nxray  , ipEnerGammaRay-1  ,    qx ,  xpow , p5 )
      call sumcon( ipEnerGammaRay  , nflux    ,  qgam ,GammaLumin , p6 )
*
*     find to estimate photoerosion timescale
      n = ipoint( 7.35e5 )
      call sumcon( n , nflux , qgn , pgn , p7)
      TimeErode = qgn
*
*     find Compton temp
      tcompr = (p1+p2+p3+p4+p5+p6) /
     1 (pradio+pbal+p+phe+pheii+xpow+GammaLumin)
      tcomp = tcompr / ( 4.*6.272e-6 )
      if( lgTrace ) then
         write(qq,'('' mean photon energy='',1P,E10.3,
     1   ''R ='',E10.3,''K'','' low, high nu='',2E12.4)')
     2   tcompr , tcomp ,
     2   anu(1)-widflx(1)/2. , anu(nflux)+widflx(nflux)/2.
      endif
*
*     this is total power in ionizing radiation
      powion = p + phe + pheii + xpow + GammaLumin
*     this is the total photon luminosity
      totlum = pradio + powion + pbal
      totlsv = totlum
*
*     total H-ionizing photon number, followed by total photon number
      qhtot = q + qhe + qheii + qx + qgam
      qtot = qhtot + qbal + qrad
      if( powion.le.0. .and. lgTalk ) then
        lgHionRad = .true.
        write(qq,'('' >>>>There is no hydrogen-ionizing radiation.<<<<''
     1  )')
        write(qq,'('' >>>>Was this intended?<<<<'')')
        write(qq,'(''  '')')
*     >>chng 97 mar 18, add following sanity check - stop if no Paschen ionizing
*radiaion since even metals will be totally neutral
        call sumcon( ipHn(3) , ipHn(2)-1 ,  factor ,  alf , p1 )
        if( factor.le.0. ) then
          write(qq,'('' >>>>There is no sodium-ionizing radiation.<<<<''
     1   )')
          write(qq,'('' >>>>This code is not approriate for these'',
     1    '' conditions.<<<<'')')
*         punch out before we crash
          lgOK = .false.
          return
        endif
      else
        lgHionRad = .false.
      endif
*
*     option to add energy deposition due to fast neutrons, as frc of tot lum
*     efficiency default is unity
      if( lgNeutrnHeatOn ) then
        totneu = effneu * totlum * 10.**frcneu
      else
        totneu = 0.
      endif
*
*     temp correspond to energy density, printed in STARTR
      TEnerDen = ( totlum / SpeedLight / 7.56464e-15 )**0.25
*
*     simple estimate of Hbeta flux if all phot go to H
      smbeta = qhtot * 4.75e-13
*     incident continuum nu*f_nu at Hbeta and Ly-alpha
      cn4861 = ffun(0.1875 ) * planck * fr1ryd * 0.1875 * 0.1875
      cn1216 = ffun(0.75 ) * planck * fr1ryd * 0.75 * 0.75
      sv4861 = cn4861
      sv1216 = cn1216
*
*     flux density nu*Fnu = erg / s / cm2
*     EX1RYD is optional extinction factor at 1 ryd
      fx1ryd = ffun(1.000) * planck * ex1ryd * fr1ryd
*
*     check for plasma frequency - then zero out incident continuum
*     for energies below this
*     this is critical electron density, shielding of incident continuum
*     if electron density is greater than this
      ecrit = (anu(1)/2.729e-12)**2
      if( hden*1.2.gt.ecrit ) then
        lgPlasNu = .true.
        plsfrq = 2.729e-12 * sqrt( hden*1.2 )
        ipPlasma = ipoint( plsfrq )
*       save max pointer too
        ipPlasmax = ipPlasma
        do i=1,ipPlasma
*         count as reflected continuum
          refcon(i) = flux(i)
          flux(i) = 0.
        end do
      else
        lgPlasNu = .false.
        ipPlasma = 0
        plsfrq = 0.
      endif
      if( ipPlasma.gt.1 .and. lgTalk) then
        write(qq,'(''  !The plasma frequency is'',1P,E10.2,
     1  '' Ryd.  The incident continuum is set to 0 below this.'')')
     2  plsfrq
      endif
*
      occmax = 0.
      tbrmax = 0.
      do i=1,nupper
*       set up occupation number array
        occnum(i) = flux(i) * convoc(i)
        if( occnum(i).gt.occmax ) then
          occmax = occnum(i)
          occmnu = anu(i)
        endif
*       following product is continuum brightness temperature
        if( occnum(i)*te1ryd*anu(i) .gt. tbrmax) then
          tbrmax = occnum(i)*te1ryd*anu(i)
          tbrmnu = anu(i)
        endif
*       save continuum for next iteration
        FluxSave(i) = flux(i)
      end do
*
*     if continuum brightness temp is large, where does it fall below
*     1e4k???
      if( tbrmax.gt.1e4 ) then
        i = ipoint( tbrmnu )
        do while( i.lt.nupper.and. (occnum(i)*te1ryd*anu(i).gt.1e4) )
          i = i + 1
        end do
        tbr4nu = anu(i)
      else
        tbr4nu = 0.
      endif
*
*     if continuum occ num is large, where does it fall below 1?
      if( occmax .gt.1. ) then
        i = ipoint(occmnu)
        do while( i.lt.nupper.and.( occnum(i) .GT. 1. ))
          i = i + 1
        end do
        occ1nu = anu(i)
      else
        occ1nu = 0.
      endif
*
*     remember if incident radiation field is less than 10*Habing ISM
      if( totlum.lt.1.8e-2 ) lgHabing = .true.
*
*     fix ionization parameter (per hydrogen) at inner edge
      uh = qhtot/ hden / SpeedLight
      uheii = (qheii+qx) / hden / SpeedLight
      uhei = (qhe+qheii+qx) / hden / SpeedLight
*
*     guess first temperature and neutral h density
      if( ForceTemp.gt.0. ) then
        te = ForceTemp
      else
        if( uh.gt.0. ) then
          te = max(8000. , 20000. + log10(uh) * 5000. )
        else
          te = 1000.
        endif
      endif
*     following needed for tfidle
      eden = hden
      hi = 0.
      call tfidle
      call velset
*
*     estimate secondary ionizaiton rate - probably 0, but possible extra
*     SetCsupra set with "set csupra"
      csupra = SetCsupra
*
*     first estimate level of hydrogen ionization
      rec =
     1(-9.9765209 + 0.158607055*telogn(1) + 0.30112749*telogn(2)
     2- 0.063969007*telogn(3) + 0.0012691546*telogn(4) ) /
     3(1.+ 0.035055422*telogn(1) - 0.037621619*telogn(2)
     4+ 0.0076175048*telogn(3) - 0.00023432613*telogn(4) )
      rec = (10.**rec)/te * eden
      xIoniz = qhtot*2e-18 + smeets(1)*eden
      r2ov1 = xIoniz / rec
      hi = hden / (1. + r2ov1 )
      hii = hden - hi
      if( hii.gt.1e-30 ) then
        hn(1) = hi / hii
      else
        hn(1) = 0.
      endif
*
*     save into master ionization array
      xIonFracs(1,1) = hi
      xIonFracs(1,2) = hii
*
*     now save estimates of whether induced recombination is going
*     to be important -this is a code pacesetter since bnfun is slower
*     than gamk
      lgHInducImp = .false.
      do i=1,nhlvl
        if(occnum(ipHn(i)).gt.0.01) lgHInducImp = .true.
      end do
*
*     next estimate level of helium singly ionized
*     call colfit( 2,2,0,te,xIoniz )
*     >>chng 97 mar 19, to new data set
      call cfit( 2,2,te,xIoniz )
      xIoniz = xIoniz * eden + qhe * 1e-18
      r2ov1 = xIoniz / rec
*
*     now estimate level of helium doubly ionized
*     call colfit( 2,1,0,te,xIoniz )
*     >>chng 97 mar 19, to new data set
      call cfit( 2,1,te,xIoniz )
      xIoniz = xIoniz * eden + qheii * 1e-18
*     rough charge dependence
      rec = rec * 4.
      r3ov2 = xIoniz / rec
*
*     now set level of helium ionization
      if( r2ov1 .gt.0. ) then
        heii = ahe / (1./r2ov1 + 1. + r3ov2 )
        hei = heii / r2ov1
      else
*       no He ionizing radiation
        heii = 0.
        hei = ahe
      endif
      hei1 = hei
      heiii = heii * r3ov2
*     save into master ionization array
      xIonFracs(2,1) = hei
      xIonFracs(2,2) = heii
      xIonFracs(2,3) = heiii
*
*     estimate electrons from heavies, assuming each at least
*     1 times ionized
      EdenHeav = 0.
      do i=3,limelm
        EdenHeav = EdenHeav + xIonFracs(i,0)
      end do
*
*     estimate of electron density
      eden = hii + heii + 2.*heiii + EdenHeav + EdenExtra
*     carbon is nearly always at least once ionized
      EdenMet = xIonFracs(6,0)
      EdenNotH = eden - hii
      if( eden.lt.0. ) then
        write(qq,'('' Negative electron density results in SetCon.'')')
        write(qq,'(1p,10e10.2)') eden,hii,heii,heiii,xIonFracs(6,0),
     1  EdenExtra
        call ShowMe
        stop
      endif
      EdenTrue = eden
      if( lgTrace.and.lgNeBug ) write(qq,'(5X,''EDEN set to'',1P,E12.4,
     1'' by SetCon.'')') eden
*
*     he triplets only one that needs eden
      hei3 = heii * 5.79e-2/te * (1.+3110*(te/1e4)**(-0.51)/eden)
*
*     for later line opacities we need ratioal estimates
      if( heiii.gt.0. ) then
*       if heiii is 0 then leave at values set in block data
        he2n(1) = heii/heiii
      endif
      if( heii.gt.0. ) then
*       if heii is 0 then leave at values set in block data
        he1n(1) = hei/heii
        he3n(1) = hei3/heii
      endif
*
      occ1 = fx1ryd/hnu3c2/pi4 / fr1ryd
*     what is occupation number at 1 Ryd?
      if( occ1.gt.1. ) then
        lgOcc1Hi = .true.
      else
        lgOcc1Hi = .false.
      endif
*
*     variables needed for possible second iteration, used in RESET
      hsv = hden
*
      if( lgTrace.and.lgConBug ) then
*        print some useful stuff
         write(qq,'('' H2,1='',2I5,'' NX='',I5,'' IRC='',
     1   I5)') ipHn(2) ,ipHn(1),nxray,ircoil
         write(qq,'('' HE3, 1='',2I5,'' HE2='',I5)')nhei3,nhe1(1),
     1   nhe2(1)
         write(qq,'('' CARBON'',11I5)') (ipHeavy(6,i),i=1,6)
         write(qq,'('' OXY'',9I5,'' IOX3='',I5,'' I2D,P='',2I5)')
     1   (ipHeavy(8,i),i=1,8),ipo3exc(1),i2d,i2p
         write(qq,'(//50X,''PHOTONS PER CELL (NOT RYD)'')')
         write(qq,'(//40X,''nu, flux, wid, occ '')')
         write(qq,'(3(1X,I4,1P,4E9.2))') (i,anu(i),flux(i),widflx(i),
     1   occnum(i),i=1,nflux)
      endif
*
      if( lgTrace )then
        write(qq,'(1X,''SetCon returns, nflux='',i5,'' anu(nflux)='',
     1  1p,e11.4,'' eden='',e10.2)') nflux , anu(nflux),eden
      endif
*
      lgOK = .true.
*
      end
******************************************************************************
      subroutine setflx( chCard , nqh , ar1 , chType , lgNU2 )
      implicit none
*parse intensity command parameters
      integer nqh
      logical lgNU2
      character chType*4 , chCard*80
      real ar1
*
      real fr1ryd
*     frequency of 1 rydberg
*     FR1RYD is frequency for 912
      parameter (fr1ryd=3.28805E15)
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real HIonPot
      parameter (HIonPot=0.99946)
*ionization potential of real hydrogen atom, in inf mass ryd
      real rdfalt
      common/rdfalt/ rdfalt
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real range
      common/range/ range(limspc,2)
      character chSpNorm*4 , chRSpec*4
*     chSpNorm says how spectrum was normlized - are or lum
*     chrspec says whether per unit anea or tot 4 pi
      common/spnorm/ chSpNorm(limspc)  , chRSpec(limspc)
      real totpow , slope , cutoff , spfac
      integer nspec , ipspec
      common/spec/ totpow(limspc) , slope(limspc) , cutoff(limspc,3) ,
     1 spfac(limspc) , nspec , ipspec
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL
      integer i
      real fread , fr
*
*     flux density of this continuum source, at optional frequency
      i = 5
      nqh = nqh + 1
      if( nqh.gt.limspc ) then
        write(qq,'('' Too many continua entered; increase LIMSPC''
     1  )')
        stop
      endif
*
      chRSpec(nqh) = chType
      totpow(nqh) = fread( chCard , i , 76 , lgEOL )
*
*     large luminosity but per sq cm
      if( totpow(nqh).gt.37. .and.chRSpec(nqh).eq.'SQCM' )
     1  write(qq,'('' This intensity is VERY'',
     1 '' large.  Problems?  Was luminosity intended??'')')
*
      if( lgEOL ) then
        if(.not.lgTalk) write(qq,'(1X,A80)') chCard
        write(qq,'('' There should have been a number on this '',
     1  ''line.   Sorry.'')')
        stop
      endif
*
      chSpNorm(nqh) = 'FLUX'
*     this is optional frequency in Rydbergs
      range(nqh,1) = fread( chCard , i , 76 , lgEOL )
*     >>chng 96 dec 18, was 1 changed to H mass nuc ryd
*     if( lgEOL ) range(nqh,1) = 1.
      if( lgEOL ) range(nqh,1) = HIonPot
      if( range(nqh,1).le.0. ) range(nqh,1) = 10.** range(nqh,1)
*
      if( lgNU2 ) then
*       range is now freq in ryd, totpow is log of product nu*f_nu
        fr = log10( range(nqh,1)* fr1ryd )
        totpow(nqh) = totpow(nqh) - fr
      endif
*
*     set R to large value in case R not specified (per sq cm)
*     and this is per unit area
      if( chType.eq.'SQCM' .and. radius.eq.0. ) then
*       RDFALT in BLOCK DATA SCALAR, is 25
        ar1 = rdfalt
        radius = 10.**ar1
      endif
*
      end
******************************************************************************
      subroutine SetLine
      implicit none
*set up internal parameters and pointers for all transferred lines
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      real WavNRyd
*number of Ryd per wavenumber
*from Physics Today '96, BG 10
      parameter (WavNRyd=9.1126732e-6)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real pi4
      parameter (pi4=12.566371)
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
*     degrees kelvin per unit wavenumber
      real t1cm
      parameter (t1cm=1.43883)
*     energy ergs per unit wavenumber
      real e1cm
      parameter (e1cm=1.98648e-16)
      logical lgTrLine
*flag set with trace line command
      common/trline/ lgTrLine
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
*rememeber the largest offset needed for ipSafe, and the energy where it occured
      integer nMaxSafe
      real EnergySafe
      common/MaxSafe/ nMaxSafe , EnergySafe
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      logical lgFstOn
      common/fston/ lgFstOn
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,ipLinSafe , ipoint , ip , iWavLen
      real eina,abscf , GetGF
*     degrees kelvin per unit wavenumber
*     real t1cm
*     parameter (t1cm=1.43883)
*     energy ergs per unit wavenumber
*     real e1cm
*     parameter (e1cm=1.98648e-16)
      character chLineLbl*10 , chLab*10 , chIonLbl*4
*
*     this routine sets continuum pointers for all lines
*     which are transferred as heavy element lines
*
*     Verner's FeII lines - do first so following labels will over write this
*     only call if katya data linked in
      if( lgKatyaData .and..not.lgSimKatya ) call PointFe2
*
*     level 2 heavy element lines
      do i=1,NWINDLINE
        WindLine(ipLnRyd,i) = WindLine(ipLnEnrWN,i) * WavNRyd
        WindLine(ipLnIpCont,i) = ipoint( WindLine(ipLnRyd,i) )
*       derive the A, call to function is gf, wl (A), g_up
        WindLine(ipLnAul,i) = eina( WindLine(ipLnGF,i) ,
     1  WindLine(ipLnEnrWN,i) , WindLine(ipLnGu,i) )
        WindLine(ipLnDampRel,i) = WindLine(ipLnAul,i) *
     1  WindLine(ipLnWlAng,i)*1e-8 / pi4
*       derive the abs coef, call to function is gf, wl (A), g_low
        WindLine(ipLnOpac,i) = abscf( WindLine(ipLnGF,i) ,
     1  WindLine(ipLnEnrWN,i) , WindLine(ipLnGl,i) )
*       excitation energy of transition in degrees kelvin
        WindLine(ipLnBolt,i) = t1cm * WindLine(ipLnEnrWN,i)
*       energy of photon in ergs
        WindLine(ipLnEnrErg,i) = e1cm * WindLine(ipLnEnrWN,i)
        ip = ipoint( WindLine(ipLnRyd,i) )
        WindLine(ipLnIpCont,i) =  ip
        if(chLineLabel(ip).eq.'    ') chLineLabel(ip) =
     1  chIonLbl(WindLine(1,i))
      end do
*666  write(6,'(1x,a10,1p,3e10.2)')
*    1 (chLineLbl( WindLine(1,i) ), WindLine(ipLnWlAng,i),
*    2 anu( int(WindLine(ipLnIpCont,i))), WindLine(ipLnAul,i),
*    3 i=1,NWINDLINE,1000)
*
*     level 1 heavy elements line array
      do i=1,nTauLines
        TauLines(ipLnRyd,i) = TauLines(ipLnEnrWN,i) * WavNRyd
        chLab(1:4) = chIonLbl(TauLines(1,i))
        TauLines(ipLnIpCont,i) = ipLinSafe( TauLines(ipLnRyd,i) ,
     1   chLab(1:4)   )
        if( TauLines(ipLnGF,i ) .gt. 0. ) then
*         the gf value was entered
*         derive the A, call to function is gf, wl (A), g_up
          TauLines(ipLnAul,i) = eina( TauLines(ipLnGF,i) ,
     1    TauLines(ipLnEnrWN,i) , TauLines(ipLnGu,i) )
        else if(TauLines(ipLnAul,i).gt.0. ) then
*         the Einstion A value was entered
*         derive the gf, call to function is A, wl (A), g_up
          TauLines(ipLnGF,i) = GetGF( TauLines(ipLnAul,i) ,
     1    TauLines(ipLnEnrWN,i) , TauLines(ipLnGu,i) )
        else
          write(qq,'('' level 1 line does not have valid gf or A'')')
          write(qq,'('' This is SetLine'')')
          stop
        endif
        TauLines(ipLnDampRel,i) = TauLines(ipLnAul,i) *
     1  TauLines(ipLnWlAng,i)*1e-8 / pi4
*       derive the abs coef, call to function is gf, wl (A), g_low
        TauLines(ipLnOpac,i) = abscf( TauLines(ipLnGF,i) ,
     1  TauLines(ipLnEnrWN,i) , TauLines(ipLnGl,i) )
*       excitation energy of transition in degrees kelvin
        TauLines(ipLnBolt,i) = t1cm * TauLines(ipLnEnrWN,i)
*       energy of photon in ergs
        TauLines(ipLnEnrErg,i) = e1cm * TauLines(ipLnEnrWN,i)
*begin sanity checks
*       line wavelength must be gt o
        if( TauLines(ipLnWlAng,i).le.0. ) then
          write(qq,'('' SetLine finds insane line wavelength'',
     1    '' <=0, line number'',i4,'' wl='',1p,e10.2)') i,
     2     TauLines(ipLnWlAng,i)
        endif
*end sanity checks
      end do
*     option to print out whole thing with "trace lines" command
      if( lgTrLine ) then
        write(qq,'(1X,''      WL(Ang)   E(RYD)   IP  '',
     1  '' gl  gu      gf       A        damp     abs K'')')
        do i=1,nTauLines
          chLab = chLineLbl(TauLines(1,i))
          iWavLen = TauLines( ipLnWlAng ,i)
          if(iWavLen.gt.1 000 000 ) then
            iWavLen = iWavLen / 10000
          else if(iWavLen.gt.10 000 ) then
            iWavLen = iWavLen / 1000
          endif
          write(qq,'(1X,a10,i5,1P,E10.3,1X,3I4,E10.2,3E10.2)')
     1    chLab, iWavLen,
     1    rydlam/TauLines(ipLnWlAng,i),
     1    int(TauLines(ipLnIpCont,i)),
     2    int(TauLines(ipLnGl,i)),
     2    int(TauLines(ipLnGu,i)),
     2    TauLines(ipLnGF,i),
     2    TauLines(ipLnAul,i),
     3    TauLines(ipLnDampRel,i),
     2    TauLines(ipLnOpac,i)
        end do
        do i=1,NWINDLINE
          chLab = chLineLbl(WindLine(1,i))
          iWavLen = WindLine( ipLnWlAng ,i)
          if(iWavLen.gt.1 000 000 ) then
            iWavLen = iWavLen / 10000
          else if(iWavLen.gt.10 000 ) then
            iWavLen = iWavLen / 1000
          endif
          write(qq,'(1X,a10,i5,1P,E10.3,1X,3I4,E10.2,3E10.2)')
     1    chLab,iWavLen,
     1    rydlam/WindLine(ipLnWlAng,i),
     1    int(WindLine(ipLnIpCont,i)),
     2    int(WindLine(ipLnGl,i)),
     2    int(WindLine(ipLnGu,i)),
     2    WindLine(ipLnGF,i),
     2    WindLine(ipLnAul,i),
     3    WindLine(ipLnDampRel,i),
     2    WindLine(ipLnOpac,i)
        end do
      endif
*
      if( lgTrLine ) then
        write(qq,'('' Largest offset in ipLinSafe was'',i5,
     1  '' at an energy of'',1p,e10.2,'' Ryd.'')') nMaxSafe,EnergySafe
      endif
*
*     this is an option to kill fine structure line optical depths
      if( .not.lgFstOn ) then
        do i=1,nTauLines
          if( TauLines(ipLnEnrWN,i).lt. 10 000. ) then
            TauLines(ipLnOpac,i) = 0.
          endif
        end do
      endif
*
      end
******************************************************************************
      subroutine opacin(ip , k , j , a )
      implicit none
*add opacity due to single species to main opacity array
*     ip is opacity pointer within opsv
*     k is lower freq limit
*     j is upper limit
*     a is abundance
      integer ip , k , j
      real a
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real opac
      common/opac/ opac(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
*     limit to number of opacity cells available
      integer NOPSV
      parameter (NOPSV=1000000)
      real OpacStack
*this is the stack used to hold opacities - entered one time when code
*is initialized, in routine opac0
      common/opsv/ OpacStack(NOPSV)
*
*     local variables
      integer i , ipOffset
*
*     code spends roughly 20% of its time in this loop
*
*     test for dummy shell
*     >>chng 96 sept 26, following tricked Dima's partial shells
*     if( OpacStack(ip).eq.0. ) return
      ipOffset = ip - k
      do i=k, min( j , nflux )
*       opac(i) = opac(i) + OpacStack(i-k+ip) * a
        opac(i) = opac(i) + OpacStack(i+ipOffset) * a
      end do
*
      end
******************************************************************************
      subroutine level2( tarray )
      implicit none
*do level population and cooling for two level atom
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
*
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limLevelN
      parameter (limLevelN=20)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real p2ovp1
      common/p2ovp1/ p2ovp1
      real te , eden , hden
      common/phycon/ te , eden , hden
      real pfs1 , pfs2
      common/fslev/ pfs1 , pfs2
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real PopLevels(0:limLevelN) , DepLTELevels(0:limLevelN)
*     this stores most recently evaluated level populations
*     resulting from the leven family of routines
*     PopLevels(0) is the lowest level
*     DepLevels is lte departure coef
      common/PopLevls/ PopLevels , DepLTELevels
      integer ipWindIon(NWINDLINE), ipWindNelem(NWINDLINE),ipWEtc
*pointers to element and ion, and spectroscopic label, for level 2 lines
      character*4 chWinLab(NWINDLINE)
      common/WindEtc/ ipWindIon , ipWindNelem,ipWEtc , chWinLab
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chLab*4
      character chIonLbl*4
      real g1 , g2 , a21 , boltz , AbunxIon , omega , sexp ,
     1 col21 , col12 , rate12 , r , plower,coolng,aem,
     2 ri21 , Enr12 , Enr21
      integer nelem , ion , ipCont
*
*     result is density (cm-3) of excited state times A21
*     result normalized to N1+N2=ABUND
*     routine increments dCooldT, call coladd
*     CDSQTE is EDEN / SQRTE * 8.629E-6
*
      if( ipWEtc.gt.0 ) then
        ion = ipWindIon(ipWEtc)
        nelem = ipWindNelem(ipWEtc)
        chLab = chWinLab(ipWEtc)
      else
        ion = tarray(ipLnIonStg) + 0.00001
        nelem = tarray(ipLnNelem) + 0.00001
        chLab = chIonLbl( tarray )
      endif
*
*     net rate down A21*(escape + destruction)
      a21 = tarray(ipLnAul) * ( tarray(ipLnEscP)+tarray(ipLnDesP) )
*
*     continuum pointer
      ipCont =  int(tarray(ipLnIpCont) )
*
*     approximate boltzmann factor to see if results zero
      boltz = ContBoltz( ipCont )
*
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      AbunxIon = xIonFracs( nelem , ion )
*
*     ROUGH check whether upper level has significant population
      r = (boltz*cdsqte + tarray(ipLnPump))/(cdsqte+a21)
*
*     following first test needed for 32 bit cpu on search phase
*     >>chng 96 july 2, was 1e-30 crashed on dec, change to 1e-25
*     if( AbunxIon.lt.1e-25 .or. boltz.gt.30. ) then
*     >>chng 96 july 11, to below, since can be strong pumping when
*     boltzman factor essentially zero
      if( AbunxIon.lt.1e-25 .or. r.lt.1e-25 ) then
*       put in pop since possible just too cool
        tarray(ipLnPopl) = AbunxIon
        tarray(ipLnPopOpc) = AbunxIon
        tarray(ipLnPopu) = 0.
        tarray(ipLnInten) = 0.
        tarray(ipLnCool) = 0.
        tarray(ipLnNPhots) = 0.
        tarray(ipLnOTS) = 0.
        tarray(ipLnAovTOT) = 1.
        tarray(ipLnColovTOT) = 0.
        tarray(ipLnHeat) = 0.
*       level populations
        PopLevels(0) = AbunxIon
        PopLevels(1) = 0.
        DepLTELevels(0) = 1.
        DepLTELevels(1) = 0.
*       this is used for line radiation pressure
        p2ovp1 = 0.
*       add zero to cooling
        call coladd( chLab(1:4) , int(tarray(ipLnWlAng)),0.)
*       now add zero to ots field
*       this is high-quality line if .eq.0
        if( tarray(ipLnCS1) .eq.0. )
     1  call AddOTSLin( 0. , ipCont ,1.0)
        return
      endif
*
*     statistical weights of upper and lower levels
      g1 = tarray(ipLnGl)
      g2 = tarray(ipLnGu)
*
*     now get real Boltzmann factor
      boltz = tarray(ipLnBolt) / te
*begin sanity checks
      if( boltz .le.0. ) then
        write(qq,'('' level2 called with non-positive Boltzmann'',
     1  '' factor, ='',1P,E10.2)') boltz
        write(qq,'('' wl='',1P,E10.2)') tarray(ipLnWlAng)
        write(qq,'('' line label='',a10)') chLab
        stop
      endif
*end sanity checks
      boltz = sexp(boltz)
*
*     collision strength for this transition
      omega = tarray(ipLnCS)
*
*begin sanity checks
      if(g1.le.0. .or. g2.le.0. ) then
        write(qq,'('' level2 called with non-positive statistical'',
     1  '' weights, ='',1P,2E10.2)') g1,g2
        write(qq,'('' wl='',1P,E10.2)') tarray(ipLnWlAng)
        write(qq,'('' label='',a4)')chLab
      endif
      if( omega.le.0. ) then
        write(qq,'('' level2 called with non-positive collision'',
     1  '' strength, ='',1P,E10.2)') omega
        write(qq,'('' wl='',1P,E10.2)') tarray(ipLnWlAng)
        write(qq,'('' line label='',a10)') chLab
        stop
      endif
*end sanity checks
*
      col21 = cdsqte * omega
*     rate 1 to 2 is both collisions and pumping
      col12 = col21 / g1 * boltz
      col21 = col21 / g2
*
      rate12 = col12 + tarray(ipLnPump)
*     induced emissions down
      ri21 = tarray(ipLnPump) * g1/g2
      r = (a21+col21+ri21) / rate12
*
*     upper level pop
      pfs2 = AbunxIon / (r+1.)
      PopLevels(1) = pfs2
      tarray(ipLnPopu) = pfs2
*     pop of ground
*     PopLevels(0) = AbunxIon - PopLevels(1)
*
*     lower level population
      pfs1 = pfs2 * r
      PopLevels(0) = pfs1
*
*     departure coef of excited state rel to ground
      DepLTELevels(0) = 1.
      if( boltz.gt.1e-20.and.PopLevels(1).gt.1e-20 ) then
*       this line could have zero boltz factor but radiatively excited
*       dec alpha does not obey () in fast mode??
        DepLTELevels(1) =
     1   ( PopLevels(1)/PopLevels(0) )  /
     2   ( boltz * g2/g1 )
      else
        DepLTELevels(1) = 0.
      endif
*
*     number of escaping line photons, used elsewhere for outward beam
      tarray(ipLnNPhots) = tarray(ipLnAul) * tarray(ipLnEscP) *pfs2
*
*     intensity of line
      tarray(ipLnInten) = tarray(ipLnNPhots)*tarray(ipLnEnrErg)
      plower = AbunxIon - pfs2
*
*     ratio of collisional to total excitation
      tarray(ipLnColovTOT) = col12/rate12
*
*     two cases - collisionally excited (usual case) or
*     radiatively excited - in which case line can be a heat source
*     following are correct heat exchange, if will mix to get correct deriv
      Enr12 = plower*col12 *tarray(ipLnEnrErg)
      Enr21 = pfs2*col21*tarray(ipLnEnrErg)
*     energy exchange due to this level
*     net cooling due to excit minus part of de-excit
      tarray(ipLnCool) = Enr12 - Enr21*tarray(ipLnColovTOT)
*     net heating is remainder
      tarray(ipLnHeat) = Enr21*(1.-tarray(ipLnColovTOT))
      coolng = tarray(ipLnCool)
*
*     expression pre jul 3 95, changed for case where line heating dominates
*     coolng = (plower*col12 - pfs2*col21)*tarray(ipLnEnrErg)
*     tarray(ipLnCool) = coolng
*
*     add to cooling - heating part was taken out above,
*     and is not added in here - it will be added to heating(1,23)
*     in SumCool
      call coladd( chLab(1:4) , int(tarray(ipLnWlAng)) , coolng )
*
*     derivative of cooling function
      dCooldT = dCooldT + coolng*( tarray(ipLnBolt)*tsq1 - halfte )
*
*     destroyed part of line
      tarray(ipLnOTS) = pfs2 * tarray(ipLnAul) * tarray(ipLnDesP)
*
      if( tarray(ipLnOTS).lt.0. ) then
        write(qq,'('' level2 finds negative ots rate, rate and wl are'',
     1  1P,E10.2,0P,F7.0)') tarray(ipLnOTS),tarray(5)
        write(qq,'(1P,10E10.2)') tarray(17),a21,col21,col12,pfs2,
     1  plower,coolng
        write(qq,'(1p,10e10.2)') tarray(1),tarray(11),tarray(13),
     1  tarray(18)
        stop
      endif
*
*     add this line to ots field
      if( tarray(ipLnCS1) .eq.0. )
     1  call AddOTSLin( tarray(ipLnOTS) , ipCont ,0.5)
*
*     compute ratio Aul/(Aul+Cul)
      aem = tarray(ipLnAul) * tarray(ipLnEscP)
      tarray(ipLnAovTOT) = aem / (aem+col21+ri21)
*
*     following is relative popultation per sub-level, used
*     to calculate radiation pressure in TEMP
      p2ovp1 = g1 / ( g2*r )
*     level population with correction for stimulated emission
      tarray(ipLnPopl) = PopLevels(0)
      tarray(ipLnPopOpc) = PopLevels(0) - PopLevels(1)*g1/g2
*
      end
******************************************************************************
      real function ColStrGBar(tarray)
      implicit none
*generate g-bar collision strengths for level 2 line2
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tarray(nta)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     these are expansions for collision strengths
*     210 is total number of coef from mewe plus gaetz and salpeter
      real g(4,210)
      common/MeweCoef/ g
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
* Calculation of the collision strengths of multiplets.
* Neutrals are recalculated from Fisher et al. (1996)
* Gaetz & Salpeter (1983, ApJS 52, 155) and Mewe (1972, A&A 20, 215) fits
* for ions.
*
*     local variables
      double precision xx,yy
      real y, e1, sexp, gb, a, b, c, d, x, ttype
      integer i, j
*
*     which type of transition is this?
      ttype = tarray(ipLnCS1)
      if(ttype.lt.0.05) then
         write(qq,'('' ColStrGBar called with insane ipLnCS1'')')
         stop
      endif
*     excitation energy over kT
      y = tarray(ipLnBolt)/te
      if(ttype.lt.1.5)then
         xx=-log10(y)
         if(ttype.lt.0.5)then
            yy=(1.398813573838321+xx*(0.02943050869177121+
     1xx*(-0.4439783893114510+xx*(0.2316073358577902+
     1xx*(0.001870493481643103+xx*(-0.008227246351067403))))))/
     1(1.0+xx*(-0.6064792600526370+xx*(0.1958559534507252+
     1xx*(-0.02110452007196644+xx*(0.01348743933722316+
     1xx*(-0.0001944731334371711))))))
         else
            yy=(1.359675968512206+xx*(0.04636500015069853+
     1xx*(-0.4491620298246676+xx*(0.2498199231048967+
     1xx*(0.005053803073345794+xx*(-0.01015647880244268))))))/
     1(1.0+xx*(-0.5904799485819767+xx*(0.1877833737815317+
     1xx*(-0.01536634911179847+xx*(0.01530712091180953+
     1xx*(-0.0001909176790831023))))))
         endif
         ColStrGBar = 10**yy*tarray(ipLnGF)/(tarray(ipLnRyd)*13.6)
      else
         i = ttype
*
         if(i.lt.26)then
            e1 = log(1.0+1.0/y)-0.4/(y+1.0)**2
            a=g(1,i)
            b=g(2,i)
            c=g(3,i)
            d=g(4,i)
            x=tarray(ipLnNelem)-3.0
            if(i.eq.14)then
               a=a*(1.0-0.5/x)
               b=1.0-0.8/x
               c=c*(1.0-1.0/x)
            else if(i.eq.16)then
               a=a*(1.0-0.9/x)
               b=b*(1.0-1.7/x)
               c=c*(1.0-2.1/x)
            else if(i.eq.18)then
               a=a*(1.0+2.0/x)
               b=b*(1.0-0.7/x)
            endif
            gb=a+(b*y-c*y*y+d)*e1+c*y
*        ipLnRyd is exciation energy in Rydbergs
            ColStrGBar = 14.510395*tarray(ipLnGF)*gb/tarray(ipLnRyd)
*     following i>=26
         else
            if(i.lt.999)then
               j=int(g(4,i))
               if(j.eq.1)then
                  ColStrGBar=tarray(ipLnGl)*g(1,i)*
     &                 (te/10**g(3,i))**g(2,i)
               else
                  ColStrGBar = tarray(ipLnGl)*g(1,i)*
     1                 sexp(g(2,i)*(10**g(3,i)/te))
               endif
            else
c This is for AlII 1670 line only!
*              ColStrGBar=0.0125*te**0.603
               ColStrGBar=0.0125*sqrte*te10*te003
            endif
         endif
      endif
*
*
*     following to make sure that negative values not returned
      ColStrGBar = max( ColStrGBar , 1e-10 )
*
      end
******************************************************************************
      subroutine DimaCool
      implicit none
*compute cooling due to level 2 lines
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      real te , eden , hden
      common/phycon/ te , eden , hden
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer ipWindIon(NWINDLINE), ipWindNelem(NWINDLINE),ipWEtc
*pointers to element and ion, and spectroscopic label, for level 2 lines
      character*4 chWinLab(NWINDLINE)
      common/WindEtc/ ipWindIon , ipWindNelem,ipWEtc , chWinLab
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      real cs , ColStrGBar , tused
      save tused
      data tused/-1./
*
      if( lgDoPhoto.and.abs(te-tused)/te.gt.0.05 .or.nzone.le.1 ) then
*       reevaluate this is big temp change, or if new photo
*       danger here is if ionization stage trimming drops,
*       cs of 1 will be used if this not reevaluated
        do i=1,NWINDLINE
*         >>chng 97 aug 30, remove test for insane Nelem IonStg
*         sanity check is in convwind
*         if( WindLine(ipLnNelem,i).gt.0. .and.
*    1    .and. xIonFracs(int(WindLine(ipLnNelem,i)),
*    1    int(WindLine(ipLnIonStg,i)) ).gt.0. ) then
*         only evaluate cs if positive abundance
          if( xIonFracs(ipWindNelem(i),ipWindIon(i)).gt.0.)then
            cs = ColStrGBar( WindLine(1,i) )
          else
            cs = 1.
          endif
          call PutCS( cs , WindLine(1,i) )
        end do
        tused = te
      endif
      do i=1,NWINDLINE
*       we need to call this even if nothing present since then sets zero
*       ignore all lines with negative atomic number
*       >>chng 97 aug 30, get rid of test for non-pos ipLnNelem
*       pointer tells level2 to use existing WineEtc labels
        ipWEtc = i
        call level2( WindLine(1,i) )
      end do
*
*     pointer tells levels to generate labels
      ipWEtc = 0
*
      end
******************************************************************************
      subroutine SetPoint
      implicit none
*set up pointers for lines and continua
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer nfill
      parameter (nfill=20)
      integer nip2pht
*use to dimension two photon arrays
      parameter (nip2pht=3000)
      real pi4
      parameter (pi4=12.566371)
      integer ndfst
      parameter (ndfst=5)
*     number of FeII lines in Fred's atom
      integer nfeii
      parameter (nfeii=373)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer ica2ex , ica2op
      common/ca2ex/ ica2ex(2) , ica2op
      integer ih2pnt , ih2pof
      common/h2ppnt/ ih2pnt(2) , ih2pof
      integer ipVFilter
* pointer to V filter for getting Av
      common/ipvfil/ ipVFilter
      integer limelm
      parameter (limelm=30)
      integer ipfe2
      common/ipfe2/ ipfe2(nfeii)
      real fe2lam , fe2osc , fe2enr,fe2gs
      common/fe2pmp/ fe2lam(nfeii) , fe2osc(nfeii) ,
     1 fe2enr(nfeii),fe2gs(nfeii)
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      integer ipxry
      real tauxry
      common/xry/ ipxry , tauxry
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      integer ipfe10
      real pfe10,pfe11a,pfe11b,pfe14
      common/pumpfe/ ipfe10,pfe10,pfe11a,pfe11b,pfe14
      integer ip374 , ip660
      common/pbowen/ ip374 , ip660
      integer ipHe23sGrnd
*pointer to He 23s to ground decay
      common/ip626/ ipHe23sGrnd
      real emm , egamry
      common/bounds/ emm , egamry
      real hehp
      integer iheh1 , iheh2
      common/hehp/ hehp , iheh1 , iheh2
      integer ippr , ioppr
      common/ipair/ ippr , ioppr
      integer ircoil , irche
      common/ircoil/ ircoil , irche
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real AnuOrg
*original set of energy units, always the same no matter what the
*shape of the continuum - actual energy units change with shape
      common/anusave/ AnuOrg(ncell)
      real FluxSave
*save incident continuum for later iterations
      common/flxsav/ FluxSave(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real hi , hii
      common/h/ hi , hii
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real HLevNIonRyd
*ionizatoin potention of hydrogenic level n
*set in makehydro
      common/HNIonRyd/ HLevNIonRyd(lmhlvl+1)
*ionization potential of level n, in Rydbergs
      real He1IonRyd
      common/He1NIonRyd/ He1IonRyd(nhe1lvl+1)
      real He2IonRyd
*ionization potential of level n in Ryd for HeII ion
      common/He2NIonRyd/ He2IonRyd(nhe2lvl+1)
      integer iphe1l
*pointers to all lines in helium singlets lines
*upper, lower
      common/iphe1l/ iphe1l(nhe1lvl,nhe1lvl-1)
      integer iphe2l
*pointers for helium ion lines
      common/iphe2l/ iphe2l(nhe2lvl,nhe2lvl-1)
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      integer  ip2gam
      common/ip2gam/  ip2gam
      integer i2d , i2p
*pointers for photoionization into excited state of oii
      common/i3727/ i2d , i2p
      integer ipmgex ,ipOpMgEx
      real xmglst, popmg2 , rmg2l , xMg2Max
*     these all deal with photoionization from upper lev of Mg II 2798
      common/mgexc/ ipmgex , xmglst, popmg2 , rmg2l , xMg2Max,ipOpMgEx
      integer ipoiex
*pointers to line energies for OI bowen problem,
*used to generate boltzman factors
      common/ipoi/ ipoiex(5)
*     fekhot, fekcld, number of photons in hot and cold iron, per unit vol
*     ipkhot, ipkcld are pointers to energies
      real fekhot , fekcld
      integer ipkhot , ipkcld
      common/fekems/ fekhot , fekcld , ipkhot , ipkcld
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgConBug
*flag set with trace continuum command
      common/conbug/ lgConBug
      logical lgPointBug
*flag set with trace pointers command
      common/pntbug/ lgPointBug
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer iphmin
      common/iphmin/ iphmin
      integer nxray
      common/nxray/ nxray
      real EnerGammaRay
*lowest energy counted as gamma rays, 100 keV
      integer ipEnerGammaRay
      common/egray/ EnerGammaRay , ipEnerGammaRay
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      real DustWorkFcn
*work function (Ioniz pot) of various grain species
      common/dwork/ DustWorkFcn(ndust)
      integer idwork
      common/idwork/ idwork(ndust)
      logical lgTrLine
*flag set with trace line command
      common/trline/ lgTrLine
      integer KshellLimit
      real EnergyKshell
      common/KshllEnr/ KshellLimit , EnergyKshell
      real filbnd,fildel,filres
      integer ifill0 , nrange
      common/fillnu/ filbnd(nfill+1),fildel(nfill),filres(nfill),
     1 ifill0(nfill) , nrange
      integer ipSecIon
      common/ipSecIon/ ipSecIon
      character chLineLabel*4 , chContLabel*4
      common/LineLabl/ chLineLabel(ncell) , chContLabel(ncell)
*     energy differences for levels in the model hydrogen atom:
      real HEnerRyd
      common/HEnrRyd/ HEnerRyd(lmhlvl,lmhlvl)
      integer ipHalfLya, ip2pht(nip2pht)
      common/ip2pht/ ipHalfLya, ip2pht
*     ipHeavy(nelem,nstage) is pointer to valence IP of this stage
      integer ipHeavy, ipLyHeavy
      common/Heavy/ ipHeavy(limelm,limelm),ipLyHeavy(limelm,limelm)
      real H12phtOTS , He12phtOTS , He22phtOTS
      integer ipH12pht , ipHe12pht , ipHe22pht
      common/hhe2phtots/ H12phtOTS , He12phtOTS , He22phtOTS,
     1 ipH12pht , ipHe12pht , ipHe22pht
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
      integer in1(3)
      real p2nit
      common/nitexc/ p2nit , in1
*     save number of shells for each element and ionization stage
*     first dimension is atomic weight, second is ionization stage
      integer nsShells(limelm,limelm)
      common/nsShells/ nsShells
*     number of continuum point to enter into line array
      integer nPredCont
*     pointers to position in line array for continuum points
      parameter (nPredCont=50)
      integer ipPredCont(nPredCont)
*     values of continuum points in Rydbergs, entered in block data scalar
      real EnrPredCont(nPredCont)
      common/PredCont/ EnrPredCont, ipPredCont
      real PH1
*     ph1(a,b,c,d)
*     a=1 => thresh, others fitting parameters
*     b atomic number
*     c number of electrons
*     d shell number 7-1
      common/PH1/ PH1(6,30,30,7)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i , j, nd , ipoint , n0,ipnt,low,n,nlap,ipConSafe,
     1 ipLinSafe
      real energy
      logical lgOverLi , lgOverCo , lgPntEval
*
*     real hla(13)
      save lgPntEval
      data lgPntEval/.false./
*
*     free statement labels >=63
*
*     set up the current hydrogen atom for this run
      call MakeHydro
*
      if( lgPntEval ) then
        if( lgTrace )write(qq,'('' SetPoint called, not evaluating.'')')
*       now save current form of array
        do i=1,ncell
          anu(i) = AnuOrg(i)
        end do
        return
      else
        if( lgTrace ) write(qq,'('' SetPoint called first time.'')')
        lgPntEval = .true.
      endif
*
      n0 = 1
      ipnt = 0
*     fill in continuum with freq points
*     arg are range pointer, 2 energy limits, resolution
*     first argument is lower energy of the continuum range to be defined
*     second argument is upper range; both are in Rydbergs
*     third number is the relative energy resolution, dnu/nu,
*       for that range of the continuum
*     last two numbers are internal book keeping
*     N0 is number of energy cells used so far
*     IPNT is a counter for the number of fills used
*
*     if this is changed, then also change warning in GetTable about using
*     transmitted continuum - it says version number where continuum changed
*
*     call fill(  emm ,   0.001 , 0.02 , n0 , ipnt )
*     lower edge of following set by need to resolve 10 micron PAH emission
*     call fill(  emm ,   0.001 , 0.02 , n0 , ipnt )
*     call fill( 0.001,   0.061, 0.01 , n0 , ipnt )
*     call fill( 0.061,   0.064, 0.003, n0 , ipnt )
*     call fill( 0.064,   0.109, 0.01 , n0 , ipnt )
*
      call fill(  emm ,   0.001, 0.02 , n0 , ipnt )
      call fill( 0.001,   0.109, 0.003, n0 , ipnt )
      call fill( 0.109,   0.26 , 0.001, n0 , ipnt )
*     call fill( 0.109,   0.115, 0.001, n0 , ipnt )
*     call fill( 0.115,   0.22 , 0.009, n0 , ipnt )
*     call fill( 0.22,    0.26 , 0.001, n0 , ipnt )
      call fill( 0.26,    0.90 , 0.009, n0 , ipnt )
      call fill( 0.90 ,   0.985, 0.001, n0 , ipnt )
*     all the lyman lines merge here
      call fill( 0.985,   1.01 , 0.0003,n0 , ipnt )
      call fill( 1.01 ,   1.78 , 0.008, n0 , ipnt )
      call fill( 1.78 ,   1.82 , 0.002, n0 , ipnt )
      call fill( 1.82 ,   3.97 , 0.008, n0 , ipnt )
*     >>chng 97 jan 27, increase resolution between 4 and 4.05 ryd
      call fill( 3.97 ,   4.05 , 0.002, n0 , ipnt )
      call fill( 4.05 ,   50.0 , 0.008, n0 , ipnt )
      call fill( 50.  ,  600.0 , 0.01 , n0 , ipnt )
      call fill( 600. ,    7e4 , 0.05 , n0 , ipnt )
      call fill(  7e4 , egamry , 0.10 , n0 , ipnt )
      nupper = n0 - 1
*     NUPPER is number of NCELL cells actually used for freq mesh
*     finish off rest of array, even if not used, N0 is next element to fill
      if( n0.le.ncell ) then
        do i=n0,ncell
          widflx(i) = widflx(i-1)
          anu(i) = anu(i-1) + widflx(i)
        end do
      endif
*     this is a sanity check for fill
      call ChckFill
*
*     following is to check that no OTS pointers overlap
      do i=1,ncell
*       flux stores line pointers
*       NB!! ipLinSafe needs for this to have happened!
*       it checks the flux array for preexisting hits
        flux(i) = 0.
*       FluxSave stores continuum pointers
        FluxSave(i) = 0.
      end do
*
*     array of either 1 or 0 for energy of elec to be counted
*     as able to produce secondary ionizaitons
*     below 100eV no secondary ionization
      ipSecIon = ipoint( 7.353 )
*
*     this is highest energy where k-shell opacities are counted
*     can be adjusted with "set kshell" command
      KshellLimit = ipoint( EnergyKshell )
*
*     pointer to 8 ev, photoionization thresh for dust
      low = 10000
      do nd=1,ndust
*       grain treatment requries that we have good points to
*       threshold when grain charges up - cannot up an ipsafe
*       routine here since can't there either - would end up
*       with mismatched pointers
*begin sanity check
        if( DustWorkFcn(nd).le.0. ) then
          write(qq,'('' Grain work function for species'',i3,
     1    '' is not positive.  This is impossible.  Was block data'',
     1    '' martin linked in?'')') nd
          stop
        endif
*end sanity check
        idwork(nd) = ipoint( DustWorkFcn(nd) )
        low = min( low , idwork(nd) )
      end do
*
*     pointers for molecules
*     H2+ dissociation energy 2.647 eV but cs small below 0.638 Ryd
      ih2pnt(1) = ipConSafe( 0.502 , 'H2+ ' )
      ih2pnt(2) = ipoint( 1.03 )
*
*     pointers for most prominent PAH features
*     energies used in ipoint are actually from opacity punch file
*     wavelenghts are rough observed values of blends
*     7.6 microns
      i = ipoint( 0.0117 )
      chContLabel(i) = 'PAH '
*     feature near 6.2 microns
      i = ipoint( 0.0147 )
      chContLabel(i) = 'PAH '
*     3.3 microns
      i = ipoint( 0.028 )
      chContLabel(i) = 'PAH '
*     11.2 microns
      i = ipoint( 0.0080 )
      chContLabel(i) = 'PAH '
*     12.3 microns
      i = ipoint( 0.0077 )
      chContLabel(i) = 'PAH '
*     13.5 microns
      i = ipoint( 0.0069 )
      chContLabel(i) = 'PAH '
*
*     fix pointers for hydrogen and helium
*
*     following are pointers to places to save locally destroyed
*     two photon continua
      ipH12pht = ipConSafe( 0.6 , 'H1p2' )
      ipHe12pht = ipConSafe( 1.2 , 'He12' )
      ipHe22pht = ipConSafe( 1.5 , 'He22' )
*
*     pointers to He I triplet lines
      ipHe3l(1) = ipLinSafe( 0.08416 , 'HeI3')
      ipHe3l(2) = ipLinSafe( 911.6/5876. , 'HeI3')
      ipHe3l(3) = ipLinSafe( 911.6/7065. , 'HeI3')
      ipHe3l(4) = ipLinSafe( 911.6/3889. , 'HeI3')
*
*     pointer to Bowen 374A resonance line
      ip374 = ipLinSafe( 1.92 , 'He 2')
      ip660 = ipLinSafe( 1.38 , 'He 2')
*
*     pointers to i => i-1 lines
      do i=1,nhlvl-1
*       HLevNIonRyd is level energy ryd
        ipHn(i) = ipConSafe( HLevNIonRyd(i) ,'H  1' )
        do j=i+1,min(25,nhlvl)
*         this was set in zero
          iphl(j,i) = ipLinSafe( HEnerRyd(j,i) , 'H  1')
*         make sure pointer not in next higher continuum
          if( iphl(j,i).ge.ipHn(i) ) then
            write(qq,'('' H line'',2i3,'' spills over into'',i3,
     1      '' continuum, energy='',1p,e11.3)') j,i,i,anu(iphl(j,i))
          endif
        end do
        do j=max(i+1,26),nhlvl
*         this was set in zero, these will not be used for ots
          iphl(j,i) = ipoint( HEnerRyd(j,i)  )
          if( iphl(j,i).ge.ipHn(i) ) then
            write(qq,'('' H line'',2i3,'' spills over into'',i3,
     1      '' continuum, energy='',1p,e11.3)') j,i,i,anu(iphl(j,i))
          endif
        end do
      end do
      ipHn(nhlvl+1) = ipHn(2)
*     photoioinization of highest level
*     this is a continuum pointer
      ipHn(nhlvl) = ipConSafe( HLevNIonRyd(nhlvl) , 'H  1' )
*
*     set up series of continuum pointers to be used in routine lines to
*     enter continnum points into line array
      do i=1,nPredCont
*       EnrPredCont contains array of energy points, from block data scalar
        ipPredCont(i) = ipoint( EnrPredCont(i) )
      end do
*
*     for induced two photon emission we need mirror image set
*     of pointers for continuum between Lya and helf Lya
      ipHalfLya = ipoint( 0.375 )
      if( ipHalfLya.gt.nip2pht ) then
        write(qq,'('' SetPoint: too many continuum points needed'',
     1  '' to fill ip2pht array - increase nip2pht to at least'',
     2  i7)') ipHalfLya
        stop
      endif
      do i=1,ipHalfLya
*       energy is symmetric energy, the other side of half lya
        energy = 0.75 - anu(i)
        ip2pht(i) = ipoint(energy)
      end do
*
*     do HeI
      do i=1,nhe1lvl-1
        nhe1(i) = ipConSafe( He1IonRyd(i) , 'He 1' )
        do j=i+1,nhe1lvl
*         get energies from table, in zero
          iphe1l(j,i) = ipLinSafe( He1IonRyd(i) - He1IonRyd(j),'He 1')
*         make sure pointer not in next higher continuum
          if( iphe1l(j,i).ge.nhe1(i) ) then
            write(qq,'('' He1 line'',2i3,'' spills over into'',i3,
     1      '' continuum, energy='',1p,e11.3)') j,i,i,anu(iphe1l(j,i))
          endif
        end do
      end do
      nhe1(nhe1lvl) = ipConSafe( He1IonRyd(nhe1lvl) , 'He 1' )
      nhe1(nhe1lvl+1) = nhe1(2)
*
*     now do HeII
      do i=1,nhe2lvl-1
*       want heii to be just blueward of hydrogne
        nhe2(i) = ipConSafe( He2IonRyd(i) , 'He 2' )
        do j=i+1,nhe2lvl
          iphe2l(j,i) = ipLinSafe( He2IonRyd(i) - He2IonRyd(j),'He 2')
          if( iphe2l(j,i).ge.nhe2(i) ) then
            write(qq,'('' He2 line'',2i3,'' spills over into'',i3,
     1      '' continuum, energy='',1p,e11.3)') j,i,i,anu(iphe2l(j,i))
          endif
        end do
      end do
      nhe2(nhe2lvl) = ipConSafe( He2IonRyd(nhe2lvl) , 'He 2')
      nhe2(nhe2lvl+1) = nhe2(2)
*
*     pointer to helium 2 trip s to ground decay
      ipHe23sGrnd = ipLinSafe( 1.457 , 'HeI3')
*
*     photoionization for HeI triplet 23s
      nhei3 = ipConSafe( 0.3506 ,'HeI3' )
* 666 error! remove following two, replace with above
      nhei1 = nhe1(1)
      nheii = nhe2(1)
*
*     pointer to energy defining effect x-ray column
      ipxry = ipoint( 73.5 )
*     double photoionization
* 666 error! most of these have been removed
      ip2gam = ipoint( 7.3 )
*     pointer to Hminus edge at 0.754eV
      iphmin = ipConSafe(0.05544 , 'H-  ' )
*     pointer to CaII XYZ at 8700A
*     ipxyz = ipoint(0.1)
*
      iheh1 = ipoint(1.6)
      iheh2 = ipoint(2.3)
*     pointer to carbon k-shell ionization
      nxray = ipoint(20.6)
*     pointer to threshold for pair production
      ippr = ipoint( 7.51155e4 ) + 1
*     pointer to x-ray - gamma ray bound; 100 kev
      ipEnerGammaRay = ipoint( EnerGammaRay )
*     pointers to bound compton electron scattering of H, He
      ircoil = ipoint(194.)
      irche = ipoint(260.)
*
      do i=1,nfeii
        ipfe2(i) = ipoint( fe2enr(i) )
      end do
*     pointers to hot and cold iron
      ipkcld = ipLinSafe( 6400./13.54 , 'Fekc' )
      ipkhot = ipLinSafe( 6600./13.54 , 'Fekh' )
      ipHe3l(1) = ipLinSafe( 0.08416 , 'HeI3')
*
*     make low energy edges of some cells exact
      call fiddle( ipHn(1) , 0.99946 )
      call fiddle( ipHn(2) , 0.24986 )
      call fiddle( nhe1(1) , 1.8072 )
      call fiddle( nhe2(1) , 4.00000 )
*     pointer to excited state of O+2
      ipo3exc(1) = ipConSafe(3.855 ,'O3ex' )
      call fiddle(   ipo3exc(1) , 3.855   )
*
*     now save current form of array
      do i=1,ncell
        AnuOrg(i) = anu(i)
        anusqr(i) = sqrt( AnuOrg(i) )
      end do
*
*     following order of elements is in roughly decreasing abundance
*     when ipShells gets a cell for the valence IP it does so through
*     ipConSafe, which makes sure that no two ions get the same cell
*     earliest elements have most precise ip mapping
*
*     set up shell pointers for hydrogen and helium
      nsShells(1,1) = 1
      ipHeavy(1,1) = ipHn(1)
      nsShells(2,1) = 1
      nsShells(2,2) = 1
      ipHeavy(2,1) = nhe1(1)
      ipHeavy(2,2) = nhe2(1)
*
*begin sanity check
*     check that ionization potential of neutral carbon valence shell is
*     positive - check that block data has been linked in
      if( PH1(1,6,6,3).le.0. ) then
        write(qq,'('' PH1 returned non-positive threshold for Co.'')')
        write(qq,'('' Was the photo common block linked in?'')')
        stop
      endif
*end sanity check
*
*     Carbon
      call ipShells( 6 )
*
*     oxygen
*     pointers for excited states
*     IO3 is pointer to O++ exc state, is set above
      i2d = ipoint( 1.242 )
      i2p = ipoint( 1.367 )
      ipo1exc(1) = ipConSafe(0.856 ,'O1ex' )
      ipo1exc(2) = ipoint(2.0 )
*     finish off excited state photoionization
*     do not use ipConSafe since only upper limit
      ipo3exc(2) = ipoint(5.0 )
*     upper level of 4363
      ipo3exc3(1) = ipConSafe(3.646 ,'O3ex' )
      ipo3exc3(2) = ipoint(5.0 )
*
*     following are various pointers for OI - Lybeta pump problem
*     these are delta energies for boltzmann factors
* 666 error! this is redundant with contents of oxygen line arrays
*     use them instead
*     when removing this, make sure all line intensity predictions
*     also go into oi line arrays
      ipoiex(1) = ipoint( 0.7005 )
      ipoiex(2) = ipoint( 0.10791)
      ipoiex(3) = ipoint( 0.06925)
      ipoiex(4) = ipoint( 0.01151)
      ipoiex(5) = ipoint( 0.01999)
      call ipShells( 8 )
      if( ipHeavy(8,1).eq.ipHn(1) ) then
*       ipShells uses ipConSave and this cannot happen
        write(qq,'('' SetPoint insanity in ipShells for O'')')
        call ShowMe
        stop
      endif
*     probable pointer overlap here; cells very narrow, no problem
      if( nhe2(2).eq.ipHeavy(8,1)) then
*       ipShells uses ipConSave and this cannot happen
        write(qq,'('' SetPoint insanity in ipShells for O-He+'')')
        call ShowMe
        stop
      endif
*
*     >>chng 97 jan 27, move nitrogen after oxygen so that O gets the
*     most accurate pointers
*     Nitrogen
*     in1(1) is thresh for photo from excited state
      in1(1) = ipConSafe(0.893 ,'N1ex' )
*     upper limit
      in1(2) = ipoint( 2. )
      call ipShells( 7 )
*
      if( (lgTrace.and.lgConBug).or.(lgTrace.and.lgPointBug) ) then
        write(qq,'(''   SetPoint:'',I5,''cells possible,'',I5,
     1  '' used. N(1R):'',I4,'' N(1.8):'',
     1  I4,''  N(4Ryd):'',I4,'' N(O3)'',I4,''  N(x-ray):'',
     2  I5,'' N(rcoil)'',I5)') ncell , nupper, ipHn(1) , nhe1(1) ,
     3  nhe2(1) , ipo3exc(1) , nxray , ircoil
        write(qq,'(''   SetPoint: HeI trip: '',I5)') nhei3
        write(qq,'(''   SetPoint: ipEnerGammaRay: '',I5,
     1  '' IPPRpari produc'',I5)') ipEnerGammaRay, ippr
        write(qq,'(''   SetPoint: H pointers;'',12I4)')(i,ipHn(i),i=1,6)
        write(qq,'(''   SetPoint: HeI pnters;'',12I4)')(i,nhe1(i),i=1,6)
        write(qq,'(''   SetPoint: Oxy pnters;'',16I4)')(i,
     1  ipHeavy(8,i),i=1,8)
      endif
*
*     Neon
      call ipShells( 10 )
*
*     Sodium
      call ipShells( 11 )
*
*     Magnesium
*     following is energy for phot of MG+ from exc state producing 2798
      ipmgex = ipoint( 0.779 )
      call ipShells( 12 )
*     ipmgla(12) = ipoint( hla(5) )
*
*     Aluminium
      call ipShells( 13 )
*     ipalla(13) = ipoint( hla(6) )
*
*     Silicon
      call ipShells( 14 )
*     ipsila(14) = ipoint( hla(7) )
*
*     phosphorus
      call ipShells( 15 )
*
*     Sulphur
      call ipShells( 16 )
*     ipsla(16) = ipoint( hla(8) )
*
*     chlorine
      call ipShells( 17 )
*     ipclla(17) = ipoint( hla(9) )
*
*     Iron
      call ipShells( 26 )
*     ipfela(26) = ipoint( hla(12) )
*
*     Argon
      call ipShells( 18 )
*     iparla(18) = ipoint( hla(10) )
*
*     Potassium
      call ipShells( 19 )
*
*     Calcium
      call ipShells( 20 )
*     ipcala(20) = ipoint( hla(11) )
*
*     pointers to ir triplet, kh
*     icaxyz = ipoint( 0.11 )
*     icakh = ipoint( 0.235 )
*     lower, upper edges of Ca+ excited term photoionizaiton
*     ica2ex(1) = ipoint(0.72)
      ica2ex(1) = ipConSafe(0.72 ,'Ca2x' )
      ica2ex(2) = ipoint(1.)
*
*     scandium
      call ipShells( 21 )
*
*     titanium
      call ipShells( 22 )
*
*     vanadium
      call ipShells( 23)
*
*     chromium
      call ipShells( 24 )
*
*     manganese
      call ipShells( 25 )
*
*     fluorine
      call ipShells( 9 )
*
*     Lithium
      call ipShells( 3 )
*
*     Beryllium
      call ipShells( 4 )
*
*     Boron
      call ipShells( 5 )
*
*     Cobalt
      call ipShells( 27 )
*
*     Nickel
      call ipShells( 28 )
*
*     copper
      call ipShells( 29 )
*
*     zinc
      call ipShells( 30 )
*
*     set all pointers to ionizaiton edges with labels
*
*     set up factors and pointers for Fe continuum fluorescence
      ipfe10 = ipoint( 2.605 )
*
*     center of V filter
      ipVFilter = ipoint( 0.164 )
*
*     following is WL(CM)**2/(8PI) * conv fac for RYD to NU *A21
      pfe10 = 2.00e-18 / widflx(ipfe10)
*     this is 353 pump, f=0.032
      pfe11a = 4.54e-19 / widflx(ipfe10)
*     this is 341.1 f=0.012
      pfe11b = 2.75e-19 / widflx(ipfe10)
      pfe14 = 1.15e-18 / widflx(ipfe10)
*
*     option to print out line pointers
      if(lgTrLine ) then
        do i=1,nhlvl
          write(qq,'('' H  '',I2,10I4)')i,(iphl(n,i),n=i+1,nhlvl)
        end do
        do i=1,nhe1lvl
          write(qq,'('' He1'',I2,10I4)')i,(iphe1l(n,i),n=i+1,nhe2lvl)
        end do
        do i=1,nhe2lvl
          write(qq,'('' He2'',I2,10I4)')i,(iphe2l(n,i),n=i+1,nhe2lvl)
        end do
      endif
*
*     set up energy pointers for line optical depth arrays
*     this also increments flux, sets other parameters for lines
      call SetLine
*
*begin sanity check
      lgOverCo = .false.
      nlap = 0
      do i=1,ncell
        if( FluxSave(i).gt.1. ) then
          write(qq,'('' Cont pointers overlap'',I3,'' times at '',
     1    ''frequency'',1P,E10.3,'' I='',I4)') int(FluxSave(i)),anu(i),i
          lgOverCo = .true.
          nlap = nlap + 1
        endif
      end do
      if( lgOverCo ) then
        write(qq,'('' OTS continuum pointer overlap occurs'',I4,
     1  '' times.  STOP.'')') nlap
      endif
*
*     if ipLinSafe worked then this check is totally redundant
      lgOverLi = .false.
      nlap = 0
      do i=1,ncell
        if( flux(i).gt.1. ) then
          write(qq,'('' Line pointers overlap'',I3,'' times at '',
     1    ''frequency'',1P,E10.3,'' I='',I4,'' wl='',E10.3,''A'')')
     2    int(flux(i)) , anu(i),i,911.6/anu(i)
          lgOverLi = .true.
          nlap = nlap + 1
        endif
      end do
      if( lgOverLi ) then
        write(qq,'('' OTS line pointer overlap occurs'',I4,
     1  '' times.  STOP.'')') nlap
      endif
*
      if( lgOverLi .or. lgOverCo ) stop
*
*end sanity check
*
      end
**************************************************************
      subroutine setqhe(chCard,lgQHeat,iopt)
      implicit none
*parse qheat command line to set grains quantum heating, by K Volk
      character*80 chCard
      integer iopt
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      logical lgQHeat(ndust)
      real vmin(ncell),vmax(ncell)
*     variables needed for Kevin Volk quantum heating routines
      integer iflnph
      common/nphotl/ vmin,vmax,iflnph
 
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
*
*     local variables
      logical lgEOL
      integer nvals , i , j
      parameter (nvals=500)
      real fread,qtmax1,xqhg1
*     real frad(nvals),fhden(nvals)
*     save frad,fhden
*
* initialize the values to defaults
      iflnph =1
      nqhg1 =50
      qtmax =3000.0
      qtmin =0.0
      qwavec =0.00911267/30.0
*     30 microns converted into rydberg units
      qdudt0 =0.
      qtcol =0.
*
      do i=1,nqgrid
        do j=1,2
          qhprob(j,i)=0.
          qtemp(j,i)=0.
        end do
      end do
*
* read an optional second value on the command line, which is the number
* of values in the enthalpy array, and third value which is the maximum
* temperature for the calculation (which must be less than 5000 k, and
* greater than 50 k).  note that qtmax will be set higher if the
* calculated equilibrium temperature is larger than 0.2 times qtmax.
      i = index(chCard,' ')
      lgEOL = .true.
*     first number is number of bins in the temperature array
      xqhg1 = fread(chCard, i, 76, lgEOL)
      if(lgEOL) then
        nqhg1 = 50
      else
        nqhg1 = int(xqhg1)
        if (nqhg1.lt.10.or.nqhg1.gt.nqgrid) nqhg1=50
      end if
*
      qtmax1 = fread(chCard, i, 76, lgEOL)
      if(lgEOL) qtmax1 = 3000.
*     insure that qtmax is between 50 and 5000
      qtmax1 = min( 5000. , qtmax1 )
      qtmax1 = max( 50. , qtmax1 )
*     this is the default value for qtmax, probably safe under normal
*     nebular conditions
      if(lgEOL) then
        qtmax = 3000.
      else
        qtmax = qtmax1
      endif
*
      if (index(chCard,'ALL').gt.0) then
*     key option all sets quantum heating for all grains
        do j=1,ndust
          lgQHeat(j)=.true.
        end do
      else
        if (iopt.eq.0) then
           lgQHeat(9)=.true.
           lgQHeat(10)=.true.
        end if
      end if
*     default: set quantum heating for only the pah grains
      if (index(chCard,'PRINT').gt.0) then
        iqp = 90
        open(unit=iqp,file='qheat.out',status='unknown')
      end if
*
*     flag for printing the temperature arrays for any layer that is
*     included in the print-out
      end
******************************************************************************
      real function sexp(x)
      implicit none
*save exponential function
      real x , exp
*
      if( x.lt.60.) then
         sexp = exp(-x)
      else
         sexp = 0.
      endif
*
      end
******************************************************************************
      subroutine ShowMe
      implicit none
*produce request to send information to GJF after a crash
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      character chDate*7 , chVersion*7
      common/date/ chDate , chVersion
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      real failmx
*     info related to the number of temperature or pressure failures
*     failmx is largest relative error in heating cooling match
*     nPreFail is number of pressure failuers
      integer nfail , nPreFail
      common/nfail/ nfail , failmx , nPreFail
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
*
      write(qq,'(/)')
      write(qq,'(/)')
      write(qq,'(10X,'' vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv '')')
      write(qq,'(10X,''> Something bad has happened.       <'')')
      write(qq,'(10X,''> Please show this to Gary Ferland. <'')')
      write(qq,'(10X,''> email:  gary@cloud9.pa.uky.edu    <'')')
      write(qq,'(10X,''> Please send all following info:   <'')')
      write(qq,'(10X,'' ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ '')')
      write(qq,'(/)')
*
      write(qq,'('' Cloudy version number is '',a7)') chVersion
*
      write(qq,'(i5,'' warnings,'',i3,'' cautions,'',
     1 i3,'' temperature failures.  Messages follow.'')')
     1 nwarn , ncaun , nfail
*     now print the cautions and warnings
      call warnot(qq)
      call caunot(qq)
*
*     now output the commands
      write(qq,'('' Input commands follow:'')')
      write(qq,'(''c======================'')')
      do i=1,nSave
        write(qq,'(a80)') chCardSav(i)
      end do
      write(qq,'(''c======================'')')
      end
****************************************************************
      subroutine SigmaSet( freq,cs,n,nfreq)
      implicit none
*generate hydrogenic photoionization cross sections for prin n
      real freq(*),cs(*)
      integer n , nfreq
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real z , en , h0 , pow
      integer lmin , lmax , i
*
      z = 1.
      en = z*z/float(n*n)
      if( n.lt.30 ) then
        lmin = 0
        lmax = n - 1
*       energy width of cells in ryd is en
        call hypho(z,n,lmin,lmax,en,nfreq,freq,cs)
*       write(10,'(''n, ener cs='',i3,1p,4e10.3)')
*    1  n , freq(1), cs(1), freq(nfreq) , cs(nfreq)
      else
*       used for n>= 30
        call hfit( h0,pow,n )
        do i=1,nfreq
          cs(i) = h0*(freq(i)/freq(1))**(-pow)
        end do
      endif
*
*     hypho can go nuts if the first energy in the array
*     is too small.  Check it.
*begin sanity check
      if( cs(1).le.0. ) then
        write(qq,'('' SigmaSet returned non-positive cross section'',
     1  '' for threshold of level'',i3,1p,e10.3)') n , cs(1)
        call ShowMe
        stop
      endif
*end sanity check
*
      end
******************************************************************************
      subroutine silicn
      implicit none
*determine ionization balance of Silicon
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real p1909 , p2326 , p1895 , p1666 , p1401
      common/pmp2s/ p1909 , p2326 , p1895 , p1666 , p1401
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
*     creating and destruction rates for all ions
*     first dim is nelem, atomic number
*     second is stage of ionization
      double precision destroy , create
      common/DestCrt/ destroy(limelm,limelm) , create(limelm,limelm)
      real hi , hii
      common/h/ hi , hii
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=15)
      parameter (nelem=14)
      real OldRate
      integer nzUsed
      save OldRate , nzUsed
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(14)  , yYIELD(12) , yYIELDL(4)
*     real CollidRate(nelem,2)
      data nzUsed/-1/ , OldRate/0./
*
*     DATA GRDEFF/14*0.2/ , yYIELD/12*0./,yYIELDL/4*0./
*
*     silicon nelem=14
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /3.92E-10,4.87E-11,2.32E-11,6.20E-12,4.86E-12,2.60E-12,
     1 1.65E-12,1.03E-12,6.02E-13,3.23E-13,1.95E-13,8.08E-14,7.44E-15,
     2 3.09E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /9.46E4,1.90E5,3.88E5,5.24E5,1.93E6,2.38E6,2.86E6,3.52E6,4.07E6,
     2 4.66E6,5.52E6,6.07E6,2.83E7,3.10E7/
*
*     rec fro +11, 12 13 from Arnauld et al 85
      data rec , pl
     1/1.64E-10 , 2.00E-9 , 2.19E-9 , 1.41E-8 , 1.05E-8 , 1.54E-8 ,
     2 1.93E-8  , 2.43E-8 , 3.76E-8 , 5.53E-8 , 2.80E-7 , 5.81E-8 ,
     3 5.99E-7  ,
     3 -0.601  , -0.786  , -0.693  , -0.821  , -0.735  , -0.716  ,
     4 -0.703  , -0.688  ,  -0.703  , -0.714  , -0.823 , -0.858  ,
     5 -0.818  /
*     Pequignot and Aldrovandi Ast Ap 161, 169., scaled to smoothly fit
*     onto high temp coef
      data tlow/ 1.64e-10 , -0.617 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1 /1.10E-3,5.87E-3, 5.03E-3, 5.43E-3, 8.86E-3, 1.68E-2, 2.49E-2,
     2 3.13E-2, 4.25E-2, 6.18E-2, 1.38E-2, .327, .189, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/0., .753, .188, .450, 0., 1.80, 1.88, 2.01, 1.22, .303, 1.42,
     2 .306, .286, 0./
      data (dite(i,1),i=1,ndim-1)
     1/7.70E+4, 9.63E+4, 8.75E+4, 1.05E+6, 1.14E+6, 4.85E+5, 4.15E+5,
     2 3.66E+5, 3.63E+5, 3.88E+5, 2.51E+5, 1.88E+7, 1.99E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/0., 6.46E+4, 4.71E+4, 7.98E+5, 0., 1.03E+6, 1.91E+6, 2.11E+6,
     2 2.14E+6, 1.12E+6, 3.93E+6, 3.60E+6, 4.14E+6, 0./
      data ditcrt
     3/1.1E4  , 1.1E4  , 1.1E4  , 1.7E5  , 9.5E4  , 8.0E4  , 7.4E4
     3,6.8E4  , 6.6E4  , 6.5E4  , 4.5E4  , 3.7E6  , 6.3E6  , 1E20/
*
*     from nuss+storey, who say that =>si iv is very small
      data aa/-0.0219 , 3.2163 , 0.1203 , 11*0./,
     1     bb/ 0.4364 ,-12.0571,-2.6900 , 11*0./,
     2     cc/ 0.0684 , 16.2118,19.1943 , 11*0./,
     3     dd/-0.0032 ,-0.5886 ,-0.1479 , 11*0./,
     4     ff/ 0.1342 , 0.5613 , 0.1118 , 0.1,10*0./
*
*     silicon, atomic number 14
      if( .not.lgElmtOn(14) ) then
        p1895 = 0.
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
      if( nzone.gt.1 .and. OldRate.gt.0. ) then
        if( nzone.ne.nzUsed ) then
          PhotoRate(nelem,1,5,1) = (PhotoRate(nelem,1,5,1) +
     1    OldRate) / 2.
          nzUsed = nzone
        else
          PhotoRate(nelem,1,5,1) = OldRate
        endif
      endif
      OldRate = PhotoRate(nelem,1,5,1)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     pumping to 3p of Si III
      p1895 = PhotoRate(nelem,2,3,1)
*
*     SI ++ - SI+ CH EXCH FROM GARGAUD ET AL., 82, AST AP 106, 197
*     RATE = 2.53E-10 * TE/TE70*TE03
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(2,2) = CTHeavy(2,2) + HI * RATE
*     CTHeavy(2,1) = CTHeavy(2,1) + HII*RATE*0.262 * SEXP(2.943E4/TE)
*     SI+3 => SI+2 BUTLER AND DALGARNO 1980B
*     CTHeavy(3,2) = CTHeavy(3,2) + 4E-10 * HI + HEI*SQRTE*TE10*TE10*
*     >>refer Butler, S.E., &Dalgarno, A. 1980, ApJ 241, 838
*     scale by 1.3 to bring into agreement with
*     >>refer Fang, Z., & Kwong, H.S. 1997 ApJ 483, 527
      CTHeavy(3,2) = CTHeavy(3,2) + hei*sqrte*te10*te10*1.3*1.5e-12
*     SI+4 => SI+3 BUTLER AND DALGARNO 1980B
*     CTHeavy(4,2) = CTHeavy(4,2) + 2.3E-9 * HI
*     Si+4 + Heo => Si+3 (Opradolce et al. 1985, AstAp. 148, 229.)
      CTHeavy(4,2) = CTHeavy(4,2) + 2.54E-11 * sqrte/te03/te01/te01*hei
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
*     get pmp rate cm-3 s-1
      p1895 = p1895 * xIonFracs(nelem,2) * 0.85
*
      if(lgTrace.and.lgHeavyBug) then
        write(qq,'(5X,''SILICN returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
******************************************************************************
      real function smeets(n)
      implicit none
*generate hydrogenic collisional ionization rate coefficients
      integer n
      real te , eden , hden
      common/phycon/ te , eden , hden
*
*     local variables
      real tryd,eps,denom,coef,sexp
*
*     a function written to calculate the rate coefficients
*     for hydrogen collisional ionizations from
*     Jason Ferguson, summer 94
*     valid for all n
*     Vriens & Smeets 1980. Phys Rev A 22, 940.
*
      tryd = 8.617e-5 * te
      eps = 1.57890e+5 / te / n / n
      denom = eps**2.33 + 4.38*eps**1.72 + 1.32*eps
      coef = 9.56e-6 / tryd**1.5 / denom * sexp(eps)
      smeets = coef
*
      end
******************************************************************************
      subroutine sodium
      implicit none
*ionization balance for sodium
      integer limelm
      parameter (limelm=30)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      real hi , hii
      common/h/ hi , hii
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=12)
      parameter (nelem=11)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real grdeff(11)  , Yyield(9) , Yyieldl(1)
*     real CollidRate(nelem,2)
*     data grdeff/11*0.2/ , Yyield/9*0./ , Yyieldl/1*1./
*
*     sodium nelem=11
*
*
*     rates taken from Mg Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /8.90E-11,5.90E-11,1.10E-11,9.14E-12,5.02E-12,2.73E-12,
     1 1.47E-12,7.35E-13,4.11E-13,1.64E-13,1.42E-14/
      data (cion(i,2),i=1,ndim-1)
     1 /8.87E4,1.74E5,9.30E5,1.26E6,1.64E6,2.17E6,2.61E6,
     2 3.09E6, 3.81E6,4.25E6,2.04E7/
*
*     from Aldrovandi and Pequignot Revista Brasileira de Fisica, 4, 491,
      data rec , pl
     1/ 3.42E-10, 1.17E-9, 2.60E-9, 4.56E-9, 6.81E-9, 1.07E-8, 1.32E-8,
     2  1.92E-8 , 2.24E-8, 2.54E-8,
     2  -0.85  , -0.73 , -0.70 , -0.68 , -0.66 , -0.66 , -0.65 ,
     3  -0.68  , -0.67 , -0.63  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.35e-10 , -0.682/
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.0E-3 , 2.6E-3 , 6.0E-3 , 1.1E-2 , 8.0E-3 , 1.0E-2 ,
     2 3.2E-2 , 1.2E-2 , 2.2E-1 , 1.8E-1 , 0./
      data (dite(i,1),i=1,ndim-1)
     3/3.6E5  , 3.8E5  , 3.4E5  , 3.0E5  , 2.7E5  , 2.8E5  ,
     4 3.2E5  , 1.9E5  , 1.2E7  , 1.3E7  , 0./
      data ditcrt
     5/0.,      1.3E5  , 4.4E5  , 7.2E4  , 2.8E5  , 4.0E5  ,
     6 1.3E6  , 1.6E6  , 1.9E6  , 3.4E4  , 0./
      data (dicoef(i,2),i=1,ndim-1)/nelem*0./
      data (dite(i,2),i=1,ndim-1)/nelem*0./
*
      data aa/11*0./, bb/11*0./, cc/11*0./, dd/11*0./, ff/0.1,10*0./
*
*     sodium, atomic number 11
      if( .not.lgElmtOn(11) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      if(lgTrace.and.lgHeavyBug) then
        write(qq,'(5X,''SODIUM returns; frac='',1P,10E10.3)')
     1  (xIonFracs(nelem,i)/xIonFracs(nelem,0),i=1,10)
      endif
*
      end
******************************************************************************
      subroutine sphset( chCard )
      implicit none
*parse parameters on sphere command
      character chCard*80
      logical lgStatic
*flag saying that spherical geometry is static, set with sphere static
      common/static/ lgStatic
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      logical lgScatON
*flag saying whether (true) or not (false) scattering opacity
*is enabled
      common/scaton/ lgScatON
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
*
      integer i
      real fac , fread
      logical lgMatch , lgEOL
*
*     compute a spherical model, diffuse field from other side included
      lgSphere = .true.
*     turn off electron scattering opacity
      lgScatON = .false.
*     if "STATIC" is specified then set to case B for H lines
      if( lgMatch( 'STAT' , chCard ) ) then
        lgStatic = .true.
        tlamin = 1e5
      endif
*
*     check for optional covering factor
      i = 5
      fac = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        covgeo = 1.
      else
        covgeo = fac
        if( covgeo.le.0. ) covgeo = 10.** covgeo
      endif
      covrt = covgeo
*
      end
******************************************************************************
      subroutine spline(x,y,n,yp1,ypn,y2a)
      implicit none
*spline interpolation routine
      integer n
      real x(n),y(n) , y2a(n) , yp1,ypn
*     returns array Y2 needed for SPLINT
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nlim
      parameter (nlim=160)
      double precision u(nlim) , sig , p , qn  , un
      integer i , k
*
*     check that not too many points
      if( n.gt.nlim ) then
        write(qq,'('' Too many points for SPLINE.  Increase NLIM'')')
        stop
      endif
*
      if (yp1.gt..99e30) then
        y2a(1)=0.
        u(1)=0.
      else
        y2a(1)=-0.5
        u(1)=(3.d0/(dble(x(2))-dble(x(1))))*((dble(y(2))-dble(y(1)))/
     1   (dble(x(2))-dble(x(1)))-dble(yp1))
      endif
*
      do i=2,n-1
        if(x(i+1).eq.x(i-1) .or. x(i+1).eq.x(i) .or. x(i).eq.x(i-1))then
          u(i) = u(i-1)
        else
          sig=(dble(x(i))-dble(x(i-1)))/(dble(x(i+1))-dble(x(i-1)))
          p=sig*y2a(i-1)+2.d0
          y2a(i)=(sig-1.d0)/p
          u(i)=(6.d0*((dble(y(i+1))-dble(y(i)))/
     1    (dble(x(i+1))-dble(x(i)))-
     1    (dble(y(i))-dble(y(i-1))) / (dble(x(i))-dble(x(i-1))))/
     2    (dble(x(i+1))-dble(x(i-1)))-sig*u(i-1))/p
        endif
      end do
*
      if (ypn.gt..99e30) then
        qn=0.
        un=0.
      else
        qn=0.5
        un=(3.d0/(dble(x(n))-dble(x(n-1))))*(dble(ypn)-(dble(y(n))-
     1  dble(y(n-1)))/ (dble(x(n))-dble(x(n-1))))
      endif
*
      y2a(n)=(un-qn*u(n-1))/(qn*y2a(n-1)+1.d0)
      do k=n-1,1,-1
        y2a(k)=y2a(k)*y2a(k+1)+u(k)
      end do
*
      end
******************************************************************************
      subroutine splint(xa,ya,y2a,n,x,y)
      implicit none
*spline interpolation
      integer n
      real y2a(n)
*     uses XA,YA deduced by SPLINE
      real xa(n),ya(n), x , y
      integer klo , khi , k
      real h , a , b
*
      klo=1
      khi=n
      do while( khi-klo.gt.1 )
        k=(khi+klo)/2
        if(xa(k).gt.x)then
          khi=k
        else
          klo=k
        endif
      end do
*
      h= dble(xa(khi)) - dble(xa(klo))
      if (h.eq.0.) stop
      a=(dble(xa(khi))-dble(x))/h
      b=(dble(x)-dble(xa(klo)))/h
      y=a*dble(ya(klo))+b*dble(ya(khi))+
     *      ((a**3-a)*y2a(klo)+(b**3-b)*y2a(khi))*(h**2)/6.d0
*
      end
******************************************************************************
      subroutine startr
      implicit none
*set and save values of many variables at start of iteration
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
      integer nfst
      parameter (nfst=39)
      integer ndfst
      parameter (ndfst=5)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer ncold
      parameter (ncold=6)
      integer nFe2Neg
*clount how many times FeII came back with negative level pops
      common/Fe2Neg/ nFe2Neg
      real AgeMoleForm
*longest timescale for molecules to form
      common/AgeMole/ AgeMoleForm
      real hnsav(lmhlvl+1),he1nsav(nhe1lvl+1),he2nsav(nhe2lvl+1)
*     these are used to reset the level popls of the h and he model atoms
      common/HHePopSv/ hnsav,he1nsav,he2nsav
*     TexcLya is the excitation temperature of Lya
*     nLyaHot is counts how ofter Lya hotter than gas
*     TLyaMax is hottest
*     TeLyaMax is electron temp at point where Lya max
*     nZTLaMax is the zone where this happened
      real TexcLya , TLyaMax , TeLyaMax
      integer nLyaHot , nZTLaMax
      common/LyaExT/ TexcLya , nLyaHot , TLyaMax , TeLyaMax , nZTLaMax
      real xLaMase
*smallest Lya optical depth that occured in the calculation
      common/LaMase/ xLaMase
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      real BigEdenError
      integer ipEdenError
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      common/EdError/ BigEdenError , ipEdenError
      real CoolHeatMax
      character*4 chCoolHeatMax
*     max of negative coolants, and a pointer to it
      integer ipCoolHeatMax
      common/CHMax/ CoolHeatMax , ipCoolHeatMax , chCoolHeatMax
      logical lgHeMase
*flag set true in addopac if any helium continua mased
      common/hemase/ lgHeMase
      logical lgComNeg
*flag saying some molecular abundances were negative
      common/comneg/ lgComNeg
      logical lgZoneSet , lgZoneTrp
*lgZonSet set if stopping zone specified
*lgZoneTrp set if stopped due to zone number
      common/zonset/ lgZoneSet , lgZoneTrp
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real chs,chps,ohs,ohps,otwos,ctwos,cos,cops,h2os,h2ops,
     1 o2ps,c2ps,h3ps,h3ops,ch2ps,ch2s,ch3s,cps
      common/hevmls/ chs,chps,ohs,ohps,otwos,ctwos,cos,cops,h2os,h2ops,
     1 o2ps,c2ps,h3ps,h3ops,ch2ps,ch2s,ch3s,cps
      logical lgLotsCO
*flag saying that there is lots of CO, triggers lgEndFun stopping model
      common/lotsco/ lgLotsCO
      integer negoi
      common/negoi/ negoi
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      real tgrmax
      common/tgrmax/ tgrmax(ndust)
      real TotMassColl , tmas , wmas
*variables to do with mean mass per particle over model,
*called <Mol> in final print out, used to get Jeans mass
      common/colmas/ TotMassColl , tmas , wmas
      real resmax
      common/resmax/ resmax
      real he3pht , he3lya , he3local , he3relax
*     he3relax is fraction of 23s populations that go to singlets
      common/he3pht/ he3pht , he3lya , he3local , he3relax
      integer kapots , kap911
      common/kapots/ kapots , kap911
      integer nUnstable
      logical lgUnstable
*keep track of possibly thermall unstagle models
*nUnstable is number of zones that were possibly thermall unstable
*lgUnstable is set in ionte and says that current consitions possibly unstable
      common/nustbl/ nUnstable , lgUnstable
      real opac
      common/opac/ opac(ncell)
      real opacsv
      common/opacsv/ opacsv(ncell)
      real scatop , albedo
*     scatop is total scattering opacity,
*     albedo is local gas albedo
      common/scatop/ scatop(ncell) , albedo(ncell)
      real sctsav
      common/sctsav/ sctsav(ncell)
      real he1sav , he2sav , he3sav , heisav
      common/hesav/ he1sav , he2sav , he3sav , heisav
      real qhtot , qhe , qheii , qbal , qrad , qtot
      common/qs/ qhtot , qhe , qheii , qbal , qrad , qtot
      real tcmptn , ttherm
      common/timesc/ tcmptn , ttherm
      real AccelAver , acldr
*variables for tracking average radiative acceleration
      common/aclbar/ AccelAver , acldr
      real FracInd , fbul
*remember induced fractions for hydrogen
      integer ndclev , nbul
      common/frcind/ FracInd , ndclev , fbul , nbul
      real xMax2Pht
      common/Max2Pht/ xMax2Pht
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      real drSave , drnsv
*save initial dr, and drnext
      common/drsv/ drSave , drnsv
      real hisv,hiisv,hsv,edsav,EDOthSav,EDMSav
      common/save/ hisv,hiisv,hsv,edsav,EDOthSav,EDMSav
      integer lhytot
      common/lhytot/ lhytot
      real thist , tlowst
      common/tehigh/ thist , tlowst
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real ophs, ophe2s, ophe1s
      common/ophs/ ophs(lmhlvl) , ophe2s(nhe2lvl), ophe1s(nhe1lvl)
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
      real ophf
      common/ophf/ ophf(lmhlvl)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      real dDensityDT, dndtSave
*deriv of density needed for expansion cooling
      common/dndt/ dDensityDT, dndtSave
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      integer ilt,iltln, ilthn, ihthn, ifail
      common/dalerr/ilt, iltln, ilthn, ihthn, ifail
*     include "fsheat.com"
      logical lgOptcBug
*flag set if negative opacities every occured
      common/optbug/ lgOptcBug
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      integer itrprt
      common/itrprt/ itrprt(itrdim)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real failmx
*     info related to the number of temperature or pressure failures
*     failmx is largest relative error in heating cooling match
*     nPreFail is number of pressure failuers
      integer nfail , nPreFail
      common/nfail/ nfail , failmx , nPreFail
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      integer MXSTPL
*maximum numeer of stop line commands
      parameter (MXSTPL=10)
*parameters for stop line command
      real stpint
      integer ipStopLin1,ipStopLin2,nstpl , LineStopWl
*LineStopWl - line wavelength for stop line command
*ipStopLin1 is pointer to first line of pair in stack of lines
*ipStopLin2 is pointer to second line of pair in stack of lines, usually Hbeta
*  initially holds wavelength, converted to pointer in startr
      common/StopLine/ stpint(MXSTPL),ipStopLin1(MXSTPL),
     1 ipStopLin2(MXSTPL), nstpl , LineStopWl(MXSTPL)
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real DustHeatLya , dstpow , dstsum , dincon,dstotl,dhcol,HDustDif
*     HDustDif is heating of grains in current zone due to diffuse fields
*DustHeatLya is heating of dust due to Lya
      common/dhla/ DustHeatLya , dstpow , dstsum , dincon ,dstotl,dhcol,
     1 HDustDif
      real colden
      common/colden/ colden(ncold)
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
      real reftot,avhden,chii, avdust , avdpot , thtot
      common/toiii/ reftot,avhden,chii,
     1 avdust(ndust) , avdpot(ndust) , thtot
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      double precision dlnenp
      common/abrems/ dlnenp
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      real workft , workfz
      common/workf/ workft , workfz
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
*     these are the integrated absorption and scattering optical depths
*     to the illuminated face of the cloud
      real depabs , depsct
      common/deptau/ depabs(ncell) , depsct(ncell)
      real otssav
      common/otssav/ otssav(ncell,2)
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      real x12
      common/x12/ x12
      real supsav , savion , savla , hetsav , savefi,x12sav
      common/supsav/ supsav , savion , savla , hetsav , savefi,x12sav
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real h2sav,h2psav,hmisav,ohmsav,h3psav
      common/hmisav/ h2sav,h2psav,hmisav,ohmsav,h3psav
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real drNext
*next dr, as set in nextdr
      common/drnxt/ drNext
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      real sound,vsound
*     vsound is local sound speed, eval zone by zone
*     sound is sound travel time (sec) updated in tauing
      common/sound/ sound,vsound
      real hi , hii
      common/h/ hi , hii
      double precision heb1sv , heb2sv , heb3sv
      common/hebnsv/ heb1sv(10) , heb2sv(10) , heb3sv(nhe3lvl)
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      double precision he3bn
      common/he3bn/ he3bn(nhe3lvl)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
*these are a series of lines and continuua that are set in hediff and
*carried outward in metdif
      real esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      common/heots/ esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
*     variable to tell lines whether this is the first initialaization
*     pass or whether we are in the middle of a model
*     ipass=0 on initialization call, =1 on all others
      integer ipass
      common/linsum/ ipass
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real tlast
      common/tlast/ tlast
      real PressureInit
*     this is the total pressure at the illuminated face
      common/PresInit/ PressureInit
      logical lgPrtLastIt
*if true then print only last iteration
      common/plast/ lgPrtLastIt
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real he1cin
      common/he1cin/ he1cin(10)
      real he2cin
      common/he2cin/ he2cin(10)
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      real the1lo
      integer nhe1lo
      common/the1lo/ the1lo , nhe1lo
      real the2lo
      integer nhe2lo
      common/the2lo/ the2lo , nhe2lo
      integer lfes,lcas,nscas,nsca1s,nsfes,nsfe1s,nsnis,nsni1s,lnis
     1 ,nscos,lcos
      common/lfes/ lfes,lcas,nscas,nsca1s,nsfes,nsfe1s,nsnis,nsni1s,lnis
     1 ,nscos,lcos
      logical lgLastIt
*     this is false on any but the last iteration
*     set true in startr if iter > itermx
      common/lastit/ lgLastIt
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      real TotalDustHeat , dphmax , h2pmax , dclmax
*TotalDustHeat is total heating due to grain heating over model
      common/dphoht/ TotalDustHeat , dphmax , h2pmax , dclmax
      real CODissHeat , codfrc , codtot
*CODissHeat is CO Photodissociation heating
      common/codish/ CODissHeat , codfrc , codtot
      real HeatH2Dish , h2dfrc , h2dtot
*HeatH2Dish is heating due to H2 dissociation
      common/h2dish/ HeatH2Dish , h2dfrc , h2dtot
      logical lgInTalk
*used to save flag for print last during amoeba runs
      common/intalk/ lgInTalk
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      real pinit , pinteg , pinzon
      common/pinteg/ pinit , pinteg , pinzon
      logical lgPrtStart
*lgPrtStart is option to start printout at certain zone
*nstart is zone number, set with print start command
      integer nstart
      common/pstart/ lgPrtStart , nstart
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real xIonFsave , HeatSave
*     args are atomic number, ionization stage
      common/IonFsave/ xIonFsave(limelm,0:limelm+1) ,
     1 HeatSave(limelm,limelm)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real heatlmax
      integer levlmax , ipHeatlmax
      common/heatlmax/ heatlmax , levlmax , ipHeatlmax
      real GBarMax
      integer ipMaxExtra
*value of, and pointer to, strongest g-bar cooling line
      common/ExtraMax/ GBarMax , ipMaxExtra
      real EdenMet , EdenNotH
*     EdenMet is sum of electrons from Lit through n=30, all ions
*     EdenNotH is total electron density less the proton density
*     used in hydrogen loop for charge conservation
      common/EdenOther/ EdenMet , EdenNotH
      real SavOutCon(ncell)
*     variables related to deriving the ratio of outward to incident continuum
*     SumOutMax - energy where max occurs, ipSumOutMax pointer to this
*     sumOutCon is summed out outlin and outcon less SavOutCon for all energy
*     SumHOutCon is H-ionizing only
      real SumOutCon , SumIncCon , SumHOutCon , SumHIncCon , SumOutMax
      integer ipSumOutMax
      common/SumOutInc/ SumOutCon , SumIncCon , SavOutCon , SumHOutCon ,
     1 SumHIncCon , SumOutMax , ipSumOutMax
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
*
*     local variables
      character chCAPS*4
      integer i,j,ii,ion,n,nd
      logical lgHit
      real ratio,dtau,fhnxt,fhe1nx,fhe2nx,tl,TotalPressure
*     real d
      integer nelem,ierrda
*
*     free statement labels >=30
*
*     STARTR is called at the start of EVERY iteration
      if( lgTrace ) write(qq,'('' STARTR called.'')')
*
*     check if this is the last iteration
      if( iter.gt.itermx ) then
        lgLastIt = .true.
      else
        lgLastIt = .false.
      endif
      lgHeMase = .false.
      SumOutCon = 0.
      SumIncCon = 0.
*     save exansion rate here
      dndtSave = dDensityDT
*
      AgeMoleForm = 0.
      CoolHeatMax = 0.
*
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      BigEdenError  = 0.
      ipEdenError = 0
*
      nLyaHot = 0
      TLyaMax = 0.
      xMax2Pht = 0.
      xLaMase = 0.
      nFe2Neg = 0
*
*     TLAST is the temperature of the last zone, and is normally
*     evaluated in ZONDUN, at the end of a zone calculation
*     it has been undefined up til now, and for the first zone is nonsense
      tlast = te
*
*     evaluate the gas and radiation pressure
      PressureInit = TotalPressure()
      pinit = PressureInit
      pinteg = 0.
      pinzon = 0.
*
      lgLotsCO = .false.
      lgComNeg = .false.
*
*     define two timescales for equilibrium, Compton and thermal
      tcmptn = 1.d0 / ( dble(qtot*6.65e-25) * eden )
      ttherm = 1.5 * pden * Boltzmann * te / ctot
*
      do nelem=1,limelm
        do ion=1,nelem+1
          xIonFsave(nelem,ion) = xIonFracs(nelem,ion)
        end do
        do i=1,limelm
          HeatSave(nelem,i) = heating(nelem,i)
        end do
      end do
      ntff = 1
      tff = 0.
      negoi = 0.
*     save ionization bal for second row elements
      do i=1,limelm
        IonLowSave(i) = IonLow(i)
        IonHighSave(i) = IonHigh(i)
      end do
*
      edsav = eden
      EDOthSav = EdenNotH
      EDMSav = EdenMet
*
*     reset molecular fractions
      chs = ch
      chps = chp
      ohs = oh
      ohps = ohp
      otwos = otwo
      ctwos = ctwo
      cos = co
      cops = cop
      h2os = h2o
      h2ops = h2op
      o2ps = o2p
      c2ps = c2p
      h3ps = h3p
      h3ops = h3op
      ch2ps = ch2p
      ch2s = ch2
      ch3s = ch3
      cps = cp
*
      h2sav = htwo
      h2psav = h2plus
      h3psav = h3plus
      hmisav = hminus
*
*     save zone thicknes, and next zone thickness
      drSave = drad
      drnsv = drNext
*
*     these are opacity factors needed for recombination coef
      do n=1,nhlvl
        ophs(n) = ophf(n)
      end do
      do n=1,nhlvl+1
        hnsav(n) = hn(n)
      end do
      do n=1,nhe1lvl+1
        he1nsav(n) = he1n(n)
      end do
      do n=1,nhe2lvl+1
        he2nsav(n) = he2n(n)
      end do
      do n=1,nhe1lvl
        ophe1s(n) = ophe1f(n)
      end do
      do n=1,nhe2lvl
        ophe2s(n) = ophe2f(n)
      end do
*
      nprint = itrprt(iter)
      hisv = hi
      hiisv = hii
      nhlo = 0
      TotMassColl = 0.
      tmas = 0.
      wmas = 0.
      kapots = 0
      kap911 = 0
      nhe1lo = 0
      nhe2lo = 0
      nUnstable = 0
      lgUnstable = .false.
      heisav = heiii
      he2sav = heii
      he1sav = hei
      hei = hei1
      he3sav = hei3
*
      do i=1,nhlvl+1
        cinduc(i) = 0.
      end do
      do i=1,10
        he1cin(i) = 0.
        he2cin(i) = 0.
        heb1sv(i) = he1bn(i)
        heb2sv(i) = he2bn(i)
      end do
      do i=1,nhe3lvl
        heb3sv(i) = he3bn(i)
      end do
*
      resmax = 0.
      he3pht = 0.
      he3lya = 0.
*
      do i=1,nupper
*       diffuse fields continuum
        ContDiff(i) = 0.
*       save OTS continuum for next iteration
        otssav(i,1) = otscon(i)
        otssav(i,2) = otslin(i)
        outcon(i) = 0.
        outlin(i) = 0.
*       save opacities for next iteration
        opacsv(i) = opac(i)
        sctsav(i) = scatop(i)
*       will accumulate optical depths through cloud
        depabs(i) = taumin
        depsct(i) = taumin
      end do
*
*     this zeroes out arrays to hold mean ionization fractions
*     later enered by mean
*     read out by setlim
      call zmean
*
      do i=1,ncold
        colden(i) = 0.
      end do
*
*     now zero heavy element molecules
      call molcol( 'ZERO' )
*
      ffhtot = 0.
      lhytot = 0
      thist = 0.
      tlowst = 1e20
      ierrda = 0
      AccelAver = 0.
      acldr = 0.
      ilt = 0
      iltln = 0
      ilthn = 0
      ihthn = 0
      ifail = 0
      savion = secion
      savla = secla
      supsav = csupra
      x12sav = x12
      hetsav = heatef
      savefi = efionz
      nfail = 0
      nPreFail = 0
      failmx = 0.
      tl = te
      dstpow = 0.
      dstotl = 0.
      dstsum = 0.
      DustHeatLya = 0.
      dincon = 0.
      HDustDif = 0.
*
      thtot = 0.
      chii = 0.
      dlnenp = 0.
      reftot = 0.
      avhden = 0.
      workft = 0.
      workfz = 0.
*
*     zero out averaging routine
      call aver('zero',0.,0.,'          ')
*
      do nd=1,ndust
*       >>chng 97 july 5, save and reset this
*       save grain potential
        dstpotsav(nd) = dstpot(nd)
        avdust(nd) = 0.
        avdpot(nd) = 0.
        avdft(nd) = 0.
        tgrmax(nd) = -1.
      end do
*
      comtot = 0.
      codfrc = 0.
      codtot = 0.
      h2dfrc = 0.
      h2dtot = 0.
      TotalDustHeat = 0.
      dphmax = 0.
      h2pmax = 0.
      dclmax = 0.
      heatlmax = 0.
      GBarMax = 0.
      cintot = 0.
      secion = 0.
      secla = 0.
      lgZoneTrp = .false.
*
*     set up line array
      ipass = 0
      call lines
      ipass = 1
      if( lgTrace ) then
        write(qq,'(i7,'' lines printed in cooling arrays; the'',
     1  '' limit is'',i7)') nsum , NLINES
      end if
*
*     now zero out some variables set by last call to LINES
      cintot = 0.
      totcol = 0.
      GrossHeat = 0.
      comtot = 0.
      workft = 0.
      power = 0.
      TotalDustHeat = 0.
      dphmax = 0.
      h2pmax = 0.
      dclmax = 0.
      heatlmax = 0.
      GBarMax = 0.
      codfrc = 0.
      codtot = 0.
      h2dfrc = 0.
      h2dtot = 0.
      sound = 0.
*
*     find which line to normalise array to (default is H BETA)
*     NormWL=1 then use first line in list (H-BETA)
*     NormWL<0 then find line with wavelength=-NormWL
      if( NormWL.lt.0 ) then
        lgHit = .false.
*       repair norm line wavelength
        NormWL = -NormWL
        i = 1
        do while( .not.lgHit .and. i.lt.nsum )
          if( lin(i) .eq. NormWL ) then
            if( chNormLab.eq.'    ' ) then
              j = i
              lgHit = .true.
            else
*             >>chng 96 dec 12, added label match option
              call cap4( chALab(i),chCAPS )
              if( chNormLab.eq.chCAPS ) then
*               when chNormLab set, only count as hit when label matches too
                j = i
                lgHit = .true.
              endif
            endif
          endif
          i = i + 1
        end do
        if( .not. lgHit ) then
          write(qq,'('' couldnt find'',i5,'' lab='',a4)') NormWL,
     1    chNormLab
          stop
        endif
        NormWL = j
        if(lgTrace) then
          write(qq,'('' Reormalize line spectrum to line number'',
     1    i5,'' wavelength is'',i9,'' scale='',f5.2,'' label is '',a4)')
     2    NormWL, lin(j),sclnrm,chALab(j)
        endif
      endif
*
*     if STPINT not 1E37 then stop integration when line LineStopWl
*     reaches intensity STPINT relative to H BETA
      do ii=1,nstpl
        if( iter.le.1 ) then
          i = 1
          lgHit = .false.
*         >>chng 96 dec 12, got rid of if, change to do while
          do while( .not.lgHit.and. i.lt.nsum )
            if( lin(i).eq.LineStopWl(ii) ) then
              ipStopLin1(ii) = i
              lgHit = .true.
            endif
            i = i + 1
          end do
*
          if( .not.lgHit )  then
            write(qq,'('' STARTER2 couldnt find line'',I5)')
     1      ipStopLin1(ii)
            stop
          endif
*
          if(lgTrace)write(qq,'('' stop line 1 is number'',
     1    i5,'' wavelength is'',i9,'' label is '',a4)')
     2    ipStopLin1(ii), lin(ipStopLin1(ii)),chALab(ipStopLin1(ii))
*
          if( ipStopLin2(ii).ne.1 ) then
            i = 1
            lgHit = .false.
            do while( .not.lgHit.and. i.lt.nsum )
*           >>chng 96 dec 12, more to do while logic
*           do i=1,nsum
              if( lin(i).eq.ipStopLin2(ii) ) then
                ipStopLin2(ii) = i
                lgHit = .true.
              endif
              i = i + 1
            end do
            if( .not.lgHit )  then
              write(qq,'('' STARTER3 couldnt find line'',I5)')
     1        ipStopLin2(ii)
              stop
            endif
            if(lgTrace)write(qq,'('' stop line 2 is number'',
     1      i5,'' wavelength is'',i9,'' label is '',a4)')
     2      ipStopLin2(ii), lin(ipStopLin2(ii)),chALab(ipStopLin2(ii))
          endif
        endif
      end do
*
*     option to only print last iteration
      if( lgPrtLastIt ) then
        if( iter.eq.1 ) lgTalk = .false.
*       initial condition of TALK may be off if AMOEBA used
*       sec part is for print last command
        if( lgLastIt .and. (.not.lgPrtStart) ) lgTalk = lgInTalk
      endif
*
      if( lgTrace.and.lgOptcBug ) then
         if( lgTauOutOn ) then
            write(qq,'('' Outer optical depths defined.'')')
         else
            write(qq,'('' Outer optical depths NOT defined.'')')
        endif
        write(qq,'('' Helium 10830:'',1P,3E10.2,
     2  '' 3889:'',3E10.2,'' 5876:'',3E10.2/'' 7065:'',3E10.2)')
     3  t10830,t3889,t5876,t7065
*       heavy element lines
        write(qq,'(4(0p,f6.0,'':'',1p,3e8.1))')
     1  (TauLines(ipLnWlAng,i),TauLines(ipLnTauIn,i),
     1  TauLines(ipLnTauTot,i),TauLines(ipLnEscP,i),i=1,nTauLines)
      endif
*
      if( lgCaseb ) then
         if( lgTrace ) write(qq,'('' STARTR does not change mid-z'',
     1   ''one optical depth since CASE B'')')
      else
         fhnxt = hii * dReff / doppler(1) * 0.52
         fhe1nx = heii * dReff / doppler(2) * 0.52
         fhe2nx = heiii * dReff / doppler(2) * 0.52
         do j=2,nhlvl
           dtau = (hn(1) -  hn(j) * hstat(1) / hstat(j) ) * hopac(j,1)
           htnext(j,1) = max( htau(j,1) , dtau * fhnxt )
         end do
         do j=2,nhe1lvl
           dtau = (he1n(1) -he1n(j)*he1stat(1)/he1stat(j) )*he1opc(j,1)
           he1nxt(j,1) = max( he1tau(j,1) , dtau * fhe1nx )
         end do
*
         do j=2,nhe2lvl
           dtau = (he2n(1) -he2n(j)*he2stat(1)/he2stat(j) )*he2opc(j,1)
           he2nxt(j,1) = max( he2tau(j,1) , dtau * fhe2nx )
         end do
*
         do i=2,nhlvl-1
           do j=i+1,nhlvl
             dtau = (hn(i) - hn(j)* hstat(i) / hstat(j) ) * hopac(j,i)
             htnext(j,i) = max( taumin , dtau * fhnxt  )
           end do
         end do
         do i=2,nhe1lvl-1
           do j=i+1,nhe1lvl
             dtau = (he1n(i)-he1n(j)*he1stat(i)/he1stat(j))*he1opc(j,i)
             he1nxt(j,i) = max( taumin , dtau * fhe1nx )
           end do
         end do
*
         do i=2,nhe2lvl-1
           do j=i+1,nhe2lvl
             dtau = (he2n(i)-he2n(j)*he2stat(i)/he2stat(j))*he2opc(j,i)
             he2nxt(j,i) = max( taumin , dtau * fhe2nx )
           end do
         end do
*
         if( lgTrace ) then
            if( lgHBug .and.lgHBugFull ) then
               write(qq,'('' STARTR estimates optical depths for ''
     1         ,''center of first zone;  HTNEXT array follows:'')')
               do i=2,nhlvl
                 write(qq,'(7x,i1,1p,8e10.2)') i,(htnext(i,j),j=1,7)
               end do
            endif
*
            if( lgHe1Bug ) then
               write(qq,'('' STARTR estimates optical depths for ''
     1         ,''center of first zone;  HE1NXT array follows:'')')
               do i=2,nhe1lvl
                  write(qq,'(7x,i1,1p,8e10.2)') i,(he1nxt(i,j),j=1,7)
               end do
            endif
*
            if( lgHe2Bug ) then
              write(qq,'('' STARTR estimates optical depths for ''
     1        ,''center of first zone;  HE2NXT array follows:'')')
              do i=2,nhe2lvl
                write(qq,'(7X,I1,1P,8E10.2)') i,(he2nxt(i,j),j=1,7)
              end do
            endif
         endif
      endif
*
*     check if induced recombination can be ignored
      FracInd = 0.
      fbul = 0.
*     don't do ground state since SPHERE turns it off
      do i=2,nhlvl-1
         ratio = rinduc(i) / ( rinduc(i) + hrec(i,1)*hrec(i,2) )
         if( ratio .gt. FracInd ) then
            FracInd = ratio
            ndclev = i
         endif
         ratio = hcont(i+1,i) / ( hcont(i+1,i)+hemis(i+1,i) )
         if( ratio.gt.fbul ) then
            fbul = ratio
            nbul = i
         endif
      end do
*
      if( lgTrace ) write(qq,'(1X,''STARTR returns.'')')
*
      end
******************************************************************************
      subroutine stopr( chCard )
      implicit none
*parse the stop command
      character chCard*80
*
      real parsec
      parameter (parsec=3.085678e18)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      integer MXSTPL
*maximum numeer of stop line commands
      parameter (MXSTPL=10)
      real emm , egamry
      common/bounds/ emm , egamry
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      real HColStop , colpls , colnut
*limit column densities set with stop column command
*colend is total hydrogen column, others are ionized and neutral
      common/colend/ HColStop , colpls , colnut
      real StopElecDensity
*stopping electron density, set with stop eden command
      common/endedn/ StopElecDensity
*parameters for stop line command
      real stpint
      integer ipStopLin1,ipStopLin2,nstpl , LineStopWl
*LineStopWl - line wavelength for stop line command
*ipStopLin1 is pointer to first line of pair in stack of lines
*ipStopLin2 is pointer to second line of pair in stack of lines, usually Hbeta
*  initially holds wavelength, converted to pointer in startr
      common/StopLine/ stpint(MXSTPL),ipStopLin1(MXSTPL),
     1 ipStopLin2(MXSTPL), nstpl , LineStopWl(MXSTPL)
      real telow , tehigh
*     this is the default lowest to highest temperature checked
      common/telow/ telow , tehigh
      real T2High
*highest allowed temperature, set with stop temperature exceeds command
      common/stphit/ T2High
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      logical lgZoneSet , lgZoneTrp
*lgZonSet set if stopping zone specified
*lgZoneTrp set if stopped due to zone number
      common/zonset/ lgZoneSet , lgZoneTrp
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer nvary , nparm
      common/nvary/ nvary , nparm
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      real StopElecFrac
*stop efraction sets this limiting electron fraction rel to H
      common/efrend/ StopElecFrac
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
      integer nEndDflt
      logical lgEndDflt
*     default limit to number of zones
*     lgEndDflt true if still at default
      common/EndDflt/ nEndDflt , lgEndDflt
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgEOL , lgMatch
      integer i , j , mxzone
      real a , fread ,tread,effcol
*
      i = 5
      a = fread( chCard , i , 76 , lgEOL )
      if( lgEOL ) then
        write(qq,'('' There MUST be a number on a STOP line.  Sorry.'')
     1  ')
        stop
      endif
*
      if( lgMatch( 'TEMP',chCard) ) then
*       lowest electron temperature allowed before stopping
*       assumed to be the log of the temperature if <10
*       optional keyword LINEAR forces linear
        if( a.le.10. .and. .not.lgMatch('LINE',chCard) ) then
          tread = 10.**a
        else
          tread = a
        endif
        if( tread.lt.3. ) then
          write(qq,'('' Temperatures below 3K not allowed. Reset '',
     1    ''to 3K.  Sorry.'')')
          tread = 3.
        endif
        if( lgMatch( 'EXCE',chCard) ) then
*         option for this to be highest allowed temperature,
*         stop temperate exceeds
          T2High = tread
        else
          tend = tread
          telow = min( telow , tend )
        endif
*
      else if( lgMatch( 'THIC',chCard) ) then
        if( lgMatch( 'LINE' , chCard ) ) then
          router(1) = a
        else
          if( a.gt.37. .and.lgBit32) then
            write(qq,'('' thickness too large for a 32 bit cpu?'')')
            stop
          endif
          router(1) = 10.** a
        endif
        if( lgMatch( 'PARS',chCard) ) then
          router(1) = router(1) * parsec
        endif
        do j=2,itrdim
          a = fread( chCard , i , 76 , lgEOL )
          if( lgEOL ) then
            router(j) = router(j-1)
          else
            if( lgMatch( 'LINE' , chCard ) ) then
              router(j) = a
            else
              if( a.gt.37. .and.lgBit32) then
                write(qq,'('' thickness too large for a 32 bit cpu?'')')
                stop
              endif
              router(j) = 10.** a
            endif
            if( lgMatch( 'PARS',chCard) ) then
              router(j) = router(j) * parsec
            endif
          endif
        end do
*       vary option
        if( lgVarOn ) then
          nparm = nparm + 1
          nvarxt(nparm) = 1
          chVarFmt(nparm) ='(''STOP THICKNESS'',F9.5)'
*         pointer to where to write
          nvfpnt(nparm) = nRead
*         log of temp will be pointer
          vparm(nparm,1) = log10( router(1) )
          vincr(nparm) = 0.5
        endif
*
      else if( lgMatch( 'OPTI',chCard) ) then
        if( a.gt.37. .and.lgBit32) then
          write(qq,'('' optical depth too big for a 32 bit cpu?'')')
          stop
        endif
        tauend = 10.** a
        taunu = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          if( lgMatch( 'LYMA',chCard) ) then
*           largest Lyman limit optical depth
            taunu = 1.
          else if( lgMatch( 'BALM',chCard) ) then
*           stop at this balmer continuum optical depth
            taunu = 0.25
          else
            write(qq,'('' There must be a second number, the energy''
     1      ,'' in Ryd.  Sorry.'')')
            stop
          endif
        else
          if( taunu.lt.0. ) then
            taunu = 10.** taunu
          endif
          if( taunu.lt.emm .or. taunu.gt.egamry ) then
            write(qq,'('' The energy must be in the range '',1P,
     1      E9.2,'' to '',E9.2,''.  It was '',E9.2,''. Sorry.'')')
     2      emm , egamry , taunu
            stop
          endif
        endif
*
      else if( lgMatch( 'ZONE',chCard) ) then
*       stop after computing this zone
        nend(1) = a
        lgZoneSet = .true.
        mxzone = nend(1)
        lgEndDflt = .false.
        do j=2,itrdim
          nend(j) = fread( chCard , i , 76 , lgEOL )
          mxzone = max( mxzone , nend(j) )
          if( lgEOL ) nend(j) = nend(j-1)
        end do
*
      else if( lgMatch('EFRA' , chCard ) ) then
*       stop at this electron fraction, relative to hydrogen
        if( a.le.0. ) then
          StopElecFrac = 10.**a
        else
          StopElecFrac = a
        endif
*
      else if( lgMatch( 'COLU',chCard) ) then
*        stop at this column density; first is effective
         if( lgMatch( 'EFFE' , chCard ) ) then
*          actually stop at certain optical depth at 1keV
           effcol = 10. ** a
           tauend = effcol * 2.14e-22
           taunu = 73.5
*          vary option
           if( lgVarOn ) then
             nparm = nparm + 1
             nvarxt(nparm) = 1
             chVarFmt(nparm) ='(''STOP EFFECTIVE COLUMN DENSITY'',F9.5)'
*            pointer to where to write
             nvfpnt(nparm) = nRead
*            log of temp will be pointer
             vparm(nparm,1) = log10( effcol )
             vincr(nparm) = 0.5
           endif
*
         else if( lgMatch( 'IONI' , chCard ) ) then
*          this is ionized column
           if( a.gt.37. .and.lgBit32) then
             write(qq,'('' column too big for a 32 bit cpu?'')')
             stop
           endif
           colpls = 10.**a
*          vary option
           if( lgVarOn ) then
             nparm = nparm + 1
             nvarxt(nparm) = 1
             chVarFmt(nparm) = '(''STOP IONIZED COLUMN DENSITY'',F9.5)'
*            pointer to where to write
             nvfpnt(nparm) = nRead
*            log of temp will be pointer
             vparm(nparm,1) = log10( colpls )
             vincr(nparm) = 0.5
           endif
         else if( lgMatch( 'NEUT' , chCard ) ) then
*          this will be neutral column
           colnut = 10. ** a
*          vary option
           if( lgVarOn ) then
             nparm = nparm + 1
             nvarxt(nparm) = 1
             chVarFmt(nparm) = '(''STOP NEUTRAL COLUMN DENSITY'',F9.5)'
*            pointer to where to write
             nvfpnt(nparm) = nRead
*            log of temp will be pointer
             vparm(nparm,1) = log10( colnut )
             vincr(nparm) = 0.5
           endif
         else
*          both HII and HI
           if( a.gt.37. .and.lgBit32) then
             write(qq,'('' column too big for a 32 bit cpu?'')')
             stop
           endif
           HColStop = 10.**a
*          vary option
           if( lgVarOn ) then
             nparm = nparm + 1
             nvarxt(nparm) = 1
             chVarFmt(nparm) = '(''STOP COLUMN DENSITY'',F9.5)'
*            pointer to where to write
             nvfpnt(nparm) = nRead
*            log of temp will be pointer
             vparm(nparm,1) = log10( HColStop )
             vincr(nparm) = 0.5
           endif
         endif
*
      else if( lgMatch( 'EDEN',chCard) ) then
*       stop if electron density falls below this value
*       LINEAR option
        if( lgMatch( 'LINE',chCard) ) then
          StopElecDensity = a
        else
          StopElecDensity = 10. ** a
        endif
*
      else if( lgMatch( 'LINE',chCard) ) then
*       first line wavelength, then intensity relative to Hbeta for stop
*       if third number is entered, it is wl of line in denominator
        nstpl = min( nstpl+1 , MXSTPL )
        ipStopLin1(nstpl) = a
*       save line wavelength
        LineStopWl(nstpl) = a
        stpint(nstpl) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          write(qq,'('' There MUST be a relative intensity'',
     1    ''  entered.  Sorry.'')')
          stop
        endif
        ipStopLin2(nstpl) = fread( chCard , i , 76 , lgEOL )
        if( lgEOL ) then
          ipStopLin2(nstpl) = 1
        else
          if(ipStopLin2(nstpl).le.100 .or. ipStopLin2(nstpl).gt.10000 )
     1      then
            write(qq,'('' is the 3rd value correct?'')')
            stop
          endif
        endif
*
      else
        write(qq,'('' keyword error for STOP line.'')')
        stop
      endif
*
      end
******************************************************************************
      subroutine strbst( chCard )
      implicit none
*generate abundance set from Fred Hamann's starburst evolution grid
      character chCard*80
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer limelm
      parameter (limelm=30)
      real solar
      common/solar/ solar(limelm)
      real SolarSave , anova , apn , ahii, camern, aprim, aism
      common/solars/ SolarSave(limelm) , anova(limelm) , apn(limelm) ,
     1 ahii(limelm) , camern(limelm) , aprim(limelm) , aism(limelm)
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      logical lgVarOn
*logical variable says whether current line image has vary option
      common/varon/ lgVarOn
      real varang
      common/varang/ varang(2,limpar)
      integer nvary , nparm
      common/nvary/ nvary , nparm
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      character*2 chElementSym
      common/ElmntSym/ chElementSym(limelm)
*
*     local variables
      real zh,zhe,zc,zn,zo,zne,zna,zmg,zal,zsi,zs,zcl,zar,zca,zfe,zco,
     1 zni
      real zLimit , zHigh
      logical lgMatch , lgEOL , lgDebug
      integer i
      real zed , fread , zed2,zed3,zed4,zedlog,sqrzed
*     this is largest stored metallicity
      data zLimit/35.5/
*
      if( lgMatch( 'TRAC',chCard ) ) then
        lgDebug = .true.
      else
        lgDebug = .false.
      endif
*
      i = 5
*     argument is metallicity
      zed = fread( chCard , i , 76 , lgEOL )
      if( lgDebug ) then
*       trace keyword did appear
*       this will not be used, but must trick the sanity test
        zHigh = zLimit
*       if trace option set, print header now, and init ZED
        write(qq,'('' Abundances relative to H, Z'')')
        write(qq,'(5X,A2,3X,30(3X,A2,1X))') ' Z',chElementSym
        zed = 1e-3
      else if( lgEOL.and. .not.lgDebug ) then
*       no number and trace keyword did not appear
        write(qq,'('' The metallicity must appear on this line.'')')
        stop
      else
        zHigh = zed
      endif
*
*     interpolate on Fred Hamann's set of starburst abundances
*     scan off keys _log or linear
      if( lgMatch( ' LOG',chCard ) ) then
        zed = 10.**zed
        zHigh = zed
      else if( lgMatch('LINE',chCard )  )then
        if( zed.le.0. ) then
          write(qq,'('' Z .le.0 not allowed, Z='',1P,
     1    e10.2)') zed
          stop
        endif
      else
*       log, linear not specified, neg so log
        if( zed.le.0. ) then
          zed = 10.**zed
          zHigh = zed
        endif
      endif
*
*     following if loop only if trace option is set
*     >>chng 97 june 17, get rid of go to
*999  continue
*
      do while (zed.le.zHigh )
        if( zed.lt.1e-3 .or. zed.gt.zLimit ) then
          write(qq,'('' The metallicity must be between 1E-3 and'',1P,
     1    e10.2)')zLimit
          stop
        endif
        zed2 = zed*zed
        zed3 = zed2*zed
        zed4 = zed3*zed
        zedlog = alog(zed)
        sqrzed = sqrt( zed )
*       The value of each element as a function of ZED=[Z]
        zh = 1.081646723 - 0.04600492*zed + 8.6569e-6*zed2
     1     + 1.922e-5*zed3 - 2.0087e-7*zed4
*
*       helium
        zhe = 0.864675891 + 0.044423807*zed + 7.10886e-5*zed2
     1    - 5.3242e-5*zed3 + 5.70194e-7*zed4
        solar(2) = zhe
*
*       li, b, bo unchanged
        solar(3) = 1.
        solar(4) = 1.
        solar(5) = 1.
*
*       carbon
        zc = 0.347489799 + 0.016054107*zed - 0.00185855*zed2
     1    + 5.43015e-5*zed3 - 5.3123e-7*zed4
        solar(6) = zc
*
*       nitrogen
        zn = -0.06549567 + 0.332073984*zed + 0.009146066*zed2
     1    - 0.00054441*zed3 + 6.16363e-6*zed4
        if(zn.lt.0.0) then
          zn = 0.05193*zed
        endif
        if(zed.lt.0.3) then
          zn = -0.00044731103 + 0.00026453554*zed + 0.52354843*zed2
     1      - 0.41156655*zed3 + 0.1290967*zed4
          if(zn.lt.0.0) then
            zn = 0.000344828 * zed
          endif
        endif
        solar(7) = zn
*
*       oxygen
        zo = 1.450212747 - 0.05379041*zed + 0.000498919*zed2
     1    + 1.09646e-5*zed3 - 1.8147e-7*zed4
        solar(8) = zo
*
*       neon
        zne = 1.110139023 + 0.002551998*zed - 2.09516e-7*zed3
     1    - 0.00798157*(zedlog)**2
        solar(10) = zne
*
*       fluorine, scale from neon
        solar(9) = solar(10)
*
*       sodium
        zna = 1.072721387 - 0.02391599*(zedlog)**2
     1    +.068644972*zedlog + 0.017030935 / sqrzed
*       this one is slightly negative at very low Z
        zna = max( 1e-12, zna )
        solar(11) = zna
*
*       magnesium
        zmg = 1.147209646 - 7.9491e-7*zed**3 -.00264458*(zedlog)**2
     1    - 0.00635552*zedlog
        solar(12) = zmg
*
*       aluminium
        zal = 1.068116358 - 0.00520227*sqrzed*zedlog
     1    -0.01403851*(zedlog)**2 + 0.066186787*zedlog
*       this one is slightly negative at very low Z
        zal = max( 1e-12, zal )
        solar(13) = zal
*
*       silicon
        zsi = 1.067372578 + 0.011818743*zed - 0.00107725*zed2
     1    + 3.66056e-5*zed3 - 3.556e-7*zed4
        solar(14) = zsi
*
*       phosphorus scaled from silicon
        solar(15) = solar(14)
*
*       sulphur
        zs = 1.12000
        solar(16) = zs
*
*       chlorine
        zcl = 1.10000
        solar(17) = zcl
*
*       argon
        zar = 1.091067724 + 2.51124e-6*zed3
     1    - 0.0039589*sqrzed*zedlog + 0.015686715*zedlog
        solar(18) = zar
*
*       potassium scaled from silicon
        solar(19) = solar(14)
*
*       calcium
        zca = 1.077553875 - 0.00888806*zed + 0.001479866*zed2
     1    - 6.5689e-5*zed3 + 1.16935e-6*zed4
        solar(20) = zca
*
*       iron
        zfe = 0.223713045 + 0.001400746*zed + 0.000624734*zed2
     1    - 3.5629e-5*zed3 + 8.13184e-7*zed4
        solar(26) = zfe
*
*       scandium, scaled from iron
        solar(21) = solar(26)
*
*       titanium, scaled from iron
        solar(22) = solar(26)
*
*       vanadium scaled from iron
        solar(23) = solar(26)
*
*       chromium scaled from iron
        solar(24) = solar(26)
*
*       manganese scaled from iron
        solar(25) = solar(26)
*
*       cobalt
        zco = zfe
        solar(27) = zco
*
*       nickel
        zni = zfe
        solar(28) = zni
*
*       copper scaled from iron
        solar(29) = solar(26)
*
*       zinc  scaled from iron
        solar(30) = solar(26)
*
*       rescale to true abundances
        solar(1) = 1.
        solar(2) = solar(2) * SolarSave(2)/zh
        do i=3,limelm
          solar(i) = solar(i) * SolarSave(i)*zed/zh
        end do
*
        if( lgDebug ) then
          write(qq,'(1P,E10.2,0P,20(F6.2))') zed,(log10(solar(i)),i=1,
     1    limelm)
          if( zed.eq.zLimit ) stop
        endif
*
*       this trick makes sure last one is upper limit
        if( zed.lt.zLimit ) then
          zed = min(zed * 1.5 , zLimit )
        else
          zed = zed * 1.5
        endif
      end do
*
*     vary option
      if( lgVarOn ) then
        nparm = nparm + 1
*       this is number of parameters to feed onto the input line
        nvarxt(nparm) = 1
        chVarFmt(nparm) = '(''ABUNDANCES STARBURST'',F9.5,'' LOG'')'
*       following are upper and lower limits to metallicity range
        varang(1,nparm) = log10( 1e-3 )
        varang(2,nparm) = log10( zLimit )
*       pointer to where to write
        nvfpnt(nparm) = nRead
*       log of metallicity will be argument
        vparm(nparm,1) = log10( zed )
        vincr(nparm) = 0.2
      endif
*
      end
******************************************************************************
      subroutine strk
      implicit none
*compute stark broadening escape probabilities using Puetter formalism
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      logical lgStarkON
*flag saying that stark broadening is enabled, set false with no stark
      common/strkon/ lgStarkON
      real He1EinA
*transition prob for He 1 singlets
      common/he1as/ He1EinA(9,8)
      real he2as
      common/he2as/ he2as(9,8)
      real peshe1
*     stark broadening arrays for HeI
      common/he1str/ peshe1(nhe1lvl,nhe1lvl)
      real peshe2
*     stark broadening escape prob for HeII
      common/he2str/ peshe2(nhe2lvl,nhe2lvl)
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
      real strkar , pestrk
      common/strkar/ strkar(lmhlvl,lmhlvl) , pestrk(lmhlvl,lmhlvl)
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
*
*     local variables
      integer i , j
      real ah , strkla , stark
*
      if( .not.lgStarkON .or.eden.lt.1e8 ) then
        do j=1,nhlvl
          do i=1,nhlvl
            pestrk(i,j) = 0.
            pestrk(j,i) = 0.
          end do
        end do
        do j=1,nhe1lvl
          do i=1,nhe1lvl
            peshe1(i,j) = 0.
          end do
        end do
        do j=1,nhe2lvl
          do i=1,nhe2lvl
            peshe2(i,j) = 0.
          end do
        end do
        return
      endif
*
*     evaluate Stark escape probability from Puetter Ap.J. 251, 446.
*
*     coefficients for Stark broadening escape probability
*     needs factor of nu/nl ** 3 *xl to be Puetters AH
      ah = 6.9e-6*1000./1e12 / (sqrte*te10*te10*te03*te01*te01) * eden
*     coefficient for all lines except Ly alpha
      stark = 0.264 * ah**0.4
*     coefficient for Ly alpha
      strkla = 0.538*ah*4.*9.875*(sqrte/te10/te03)
*
*     Lyman lines always have outer optical depths
      pestrk(2,1) = strkla /2. * ( max(1.,htnext(2,1))**(-0.75)+
     1max( 1., htlim(2,1)/10. , (htlim(2,1)-htnext(2,1)) ) **(-0.75))
      pestrk(2,1) = min(.01, pestrk(2,1) )
      pestrk(1,2) = pestrk(2,1) * hyas(2,1)
*
      peshe1(2,1) = strkla /2. * ( max(1.,he1nxt(2,1))**(-0.75)+
     1max(1.,he1lim(2,1)/10.,(he1lim(2,1)-he1nxt(2,1)) ) **(-0.75))
      peshe1(2,1) = min(.01, peshe1(2,1) )
      peshe1(1,2) = peshe1(2,1) * He1EinA(2,1)
*
      peshe2(2,1) = strkla /2. * ( max(1.,he2nxt(2,1))**(-0.75)+
     1max(1.,he2lim(2,1)/10.,(he2lim(2,1)-he2nxt(2,1)) ) **(-0.75))
      peshe2(2,1) = min(.01, peshe2(2,1) )
      peshe2(1,2) = peshe2(2,1) * he2as(2,1)
*
      do j=3,nhlvl
        pestrk(j,1) = stark*strkar(j,1)/2.*(max(1.,htnext(j,1))**(-0.6)
     1  +max( htlim(j,1)/10. , (htlim(j,1)-htnext(j,1)) ,1.)**(-0.6))
        pestrk(j,1) = min( .01 , pestrk(j,1) )
        pestrk(1,j) = hyas(j,1) * pestrk(j,1)
      end do
      do j=3,nhe1lvl
        peshe1(j,1) = strkla /2. * ( max(1.,he1nxt(j,1))**(-0.75)+
     1  max(1.,he1lim(j,1)/10.,(he1lim(j,1)-he1nxt(j,1)) ) **(-0.75))
        peshe1(j,1) = min(.01, peshe1(j,1) )
        peshe1(1,j) = peshe1(j,1) * He1EinA(j,1)
      end do
*
      do j=3,nhe2lvl
        peshe2(j,1) = strkla /2. * ( max(1.,he2nxt(j,1))**(-0.75)+
     1  max(1.,he2lim(j,1)/10.,(he2lim(j,1)-he2nxt(j,1)) ) **(-0.75))
        peshe2(j,1) = min(.01, peshe2(j,1) )
        peshe2(1,j) = peshe2(j,1) * he2as(j,1)
      end do
*
*     all other lines
      if( lgTauOutOn ) then
*       outer optical depths defined, Ly alpha first
*       don't add Stark if tau less than 100
*       all other lines
        do i=2,nhlvl-1
           do j=i+1,nhlvl
             pestrk(j,i) = stark*strkar(j,i)/2.*(max(1.,
     1       htnext(j,i))**(-0.6) +max( htlim(j,i)/10. ,
     2       (htlim(j,i)-htnext(j,i)) ,1.)**(-0.6))
             pestrk(j,i) = min( .01 , pestrk(j,i) )
             pestrk(i,j) = hyas(j,i) * pestrk(j,i)
          end do
        end do
        do i=2,nhe1lvl-1
          do j=i+1,nhe1lvl
            peshe1(j,i) = stark*strkar(j,i)/2.*(max(1.,
     1       he1nxt(j,i))**(-0.6) +max( he1lim(j,i)/10. ,
     2       (he1lim(j,i)-he1nxt(j,i)) ,1.)**(-0.6))
             peshe1(j,i) = min( .01 , peshe1(j,i) )
             peshe1(i,j) = He1EinA(j,i) * peshe1(j,i)
          end do
        end do
*
         do i=2,nhe2lvl-1
            do j=i+1,nhe2lvl
               peshe2(j,i) = stark*strkar(j,i)/2.*(max(1.,
     1         he2nxt(j,i))**(-0.6) +max( he2lim(j,i)/10. ,
     2         (he2lim(j,i)-he2nxt(j,i)) ,1.)**(-0.6))
               peshe2(j,i) = min( .01 , peshe2(j,i) )
               peshe2(i,j) = he2as(j,i) * peshe2(j,i)
            end do
         end do
      else
*       outer optical depths not defined
        do i=2,nhlvl-1
          do j=i+1,nhlvl
            pestrk(j,i) = min(.01,stark*strkar(j,i)*
     1      max(1.,htnext(j,i))** (-0.6))
            pestrk(i,j) = hyas(j,i) * pestrk(j,i)
          end do
        end do
        do i=2,nhe1lvl-1
          do j=i+1,nhe1lvl
            peshe1(j,i) = min(.01,stark*strkar(j,i)*
     1      max(1.,he1nxt(j,i))** (-0.6))
            peshe1(i,j) = He1EinA(j,i) * peshe1(j,i)
            peshe2(i,j) = he2as(j,i) * peshe2(j,i)
          end do
        end do
*
       do i=2,nhe2lvl-1
         do j=i+1,nhe2lvl
           peshe2(j,i) = min(.01,stark*strkar(j,i)*
     1     max(1.,he2nxt(j,i))** (-0.6))
           peshe2(i,j) = he2as(j,i) * peshe2(j,i)
         end do
        end do
      endif
*
      end
*********************************************************************
*
*     NB this is much the original coding and does not use strong typing
*gjf mod: to avoid conflict with exemplar parallel version of lapack,
*dasum changed to cdasum
*daxpy changed to cdaxpy
*dcopy changed to cdcopy
*sscal changed to csscal
*
***********************************************************************
      subroutine subplx (f,n,tol,maxnfe,mode,scale,x,fx,nfe,
     *                   work,iwork,iflag)
c
      integer n,maxnfe,mode,nfe,iwork(*),iflag
      real f,tol,scale(*),x(n),fx,work(*)
      external f
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
*
* Jason Ferguson:
* Changed on 8/4/94, in order to incorparate into cloudy
* changes made are: double precision to real,
* a 2-D function f(n,x) into 1-D f(x),
* and the termination check.
c
c subplx uses the subplex method to solve unconstrained
c optimization problems.  The method is well suited for
c optimizing objective functions that are noisy or are
c discontinuous at the solution.
c
c subplx sets default optimization options by calling the
c subroutine subopt.  The user can override these defaults
c by calling subopt prior to calling subplx, changing the
c appropriate common variables, and setting the value of
c mode as indicated below.
c
c By default, subplx performs minimization.
c
c input
c
c   f      - user supplied function f(n,x) to be optimized,
c            declared external in calling routine
c
c   n      - problem dimension
c
c   tol    - relative error tolerance for x (tol .ge. 0.)
c
c   maxnfe - maximum number of function evaluations
c
c   mode   - integer mode switch with binary expansion
c            (bit 1) (bit 0) :
c            bit 0 = 0 : first call to subplx
c                  = 1 : continuation of previous call
c            bit 1 = 0 : use default options
c                  = 1 : user set options
c
c   scale  - scale and initial stepsizes for corresponding
c            components of x
c            (If scale(1) .lt. 0.,
c            abs(scale(1)) is used for all components of x,
c            and scale(2),...,scale(n) are not referenced.)
c
c   x      - starting guess for optimum
c
c   work   - real work array of dimension .ge.
c            2*n + nsmax*(nsmax+4) + 1
c            (nsmax is set in subroutine subopt.
c            default: nsmax = min(5,n))
c
c   iwork  - integer work array of dimension .ge.
c            n + int(n/nsmin)
c            (nsmin is set in subroutine subopt.
c            default: nsmin = min(2,n))
c
c output
c
c   x      - computed optimum
c
c   fx     - value of f at x
c
c   nfe    - number of function evaluations
c
c   iflag  - error flag
c            = -2 : invalid input
c            = -1 : maxnfe exceeded
c            =  0 : tol satisfied
c            =  1 : limit of machine precision
c            =  2 : fstop reached (fstop usage is determined
c                   by values of options minf, nfstop, and
c                   irepl. default: f(x) not tested against
c                   fstop)
c            iflag should not be reset between calls to
c            subplx.
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      real alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common/usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
      real fbonus,sfstop,sfbest
      logical new
c
      common/isubc/ fbonus,sfstop,sfbest,new
c
c local variables
c
      integer i,j,ifsptr,ins,insfnl,insptr,ipptr,isptr,
     *        istep,istptr,ns,nsubs
      real bnsfac(3,2),dum,scl(1),sfx,xpscl
      logical cmode
c
      save
c
c subroutines and functions
c
      external func,sortd,evalf,partx,setstp,simplx,subopt
c   blas
      external cdcopy
c   fortran
      intrinsic abs,mod
c
c data
c
      data ((bnsfac(i,j),i=1,3),j=1,2) /-1.0,-2.0,0.0,
     *      1.0,0.0,2.0/
c-----------------------------------------------------------
c
      if (mod(mode,2) .eq. 0) then
c
c       first call, check input
c
        if (n .lt. 1) go to 120
        if (tol .lt. 0.0) go to 120
        if (maxnfe .lt. 1) go to 120
        if (scale(1) .ge. 0.0) then
          do i = 1,n
            xpscl = x(i)+scale(i)
            if (xpscl .eq. x(i)) go to 120
          end do
        else
          scl(1) = abs(scale(1))
          do i = 1,n
            xpscl = x(i)+scl(1)
            if (xpscl .eq. x(i)) go to 120
          end do
        end if
        if (mod(mode/2,2) .eq. 0) then
          call subopt (n)
        else
          if (alpha .le. 0.0) go to 120
          if (beta .le. 0.0 .or. beta .ge. 1.0) go to 120
          if (gamma .le. 1.0) go to 120
          if (delta .le. 0.0 .or. delta .ge. 1.0)
     *        go to 120
          if (psi .le. 0.0 .or. psi .ge. 1.0) go to 120
          if (omega .le. 0.0 .or. omega .ge. 1.0)
     *        go to 120
          if (nsmin .lt. 1 .or. nsmax .lt. nsmin .or.
     *        n .lt. nsmax) go to 120
          if (n .lt. ((n-1)/nsmax+1)*nsmin) go to 120
          if (irepl .lt. 0 .or. irepl .gt. 2) go to 120
          if (ifxsw .lt. 1 .or. ifxsw .gt. 3) go to 120
          if (bonus .lt. 0.0) go to 120
          if (nfstop .lt. 0) go to 120
        end if
c
c       initialization
c
        istptr = n+1
        isptr = istptr+n
        ifsptr = isptr+nsmax*(nsmax+3)
        insptr = n+1
        if (scale(1) .gt. 0.0) then
          call cdcopy (n,scale,1,work,1)
          call cdcopy (n,scale,1,work(istptr),1)
        else
          call cdcopy (n,scl,0,work,1)
          call cdcopy (n,scl,0,work(istptr),1)
        end if
        do i = 1,n
          iwork(i) = i
        end do
        nfe = 0
        nfxe = 1
        if (irepl .eq. 0) then
          fbonus = 0.0
        else if (minf) then
          fbonus = bnsfac(ifxsw,1)*bonus
        else
          fbonus = bnsfac(ifxsw,2)*bonus
        end if
        if (nfstop .eq. 0) then
          sfstop = 0.0
        else if (minf) then
          sfstop = fstop
        else
          sfstop = -fstop
        end if
        ftest = 0.0
        cmode = .false.
        new = .true.
        initx = .true.
        call evalf (f,0,iwork,dum,n,x,sfx,nfe)
        initx = .false.
      else
c
c       continuation of previous call
c
        if (iflag .eq. 2) then
          if (minf) then
            sfstop = fstop
          else
            sfstop = -fstop
          end if
          cmode = .true.
          go to 70
        else if (iflag .eq. -1) then
          cmode = .true.
          go to 70
        else if (iflag .eq. 0) then
          cmode = .false.
          go to 90
        else
          return
        end if
      end if
c
c     subplex loop
c
   40 continue
        do i = 1,n
          work(i) = abs(work(i))
        end do
        call sortd (n,work,iwork)
        call partx (n,iwork,work,nsubs,iwork(insptr))
        call cdcopy (n,x,1,work,1)
        ins = insptr
        insfnl = insptr+nsubs-1
        ipptr = 1
c
c       simplex loop
c
   60   continue
          ns = iwork(ins)
   70     continue
          call simplx (f,n,work(istptr),ns,iwork(ipptr),
     *                 maxnfe,cmode,x,sfx,nfe,work(isptr),
     *                 work(ifsptr),iflag)
          cmode = .false.
          if (iflag .ne. 0) go to 110
          if (ins .lt. insfnl) then
            ins = ins+1
            ipptr = ipptr+ns
            go to 60
          end if
c
c       end simplex loop
c
        do i = 1,n
          work(i) = x(i)-work(i)
        end do
c
c       check termination
c
   90   continue
        istep = istptr
        do 100 i = 1,n
*
*       Change in order to help with the convergence.
*       We want to minimize the function to a level of tol.
*       xstop is stopping criteria oringinally set in subplex
*       if xstop < tol then the program would stop.
*       We also want to stop if the function value itself is
*       less than tol.
          xstop=  max(abs(work(i)),abs(work(istep))*psi)/
     *        max(abs(x(i)),1.0)
*
*old        if (max(abs(work(i)),abs(work(istep))*psi)/
*old  *        max(abs(x(i)),1.0) .gt. tol) then
*
           if(sfx.gt.tol.and.xstop.gt.0.01) then
             call setstp (nsubs,n,work,work(istptr))
             go to 40
           end if
          istep = istep+1
  100   continue
c
c     end subplex loop
c
      iflag = 0
  110 continue
      if (minf) then
        fx = sfx
      else
        fx = -sfx
      end if
      return
c
c     invalid input
c
  120 continue
      iflag = -2
      return
      end
*********************************************************************
      subroutine calcc (ns,s,ih,inew,updatc,c)
c
      integer ns,ih,inew
      real s(ns,ns+3),c(ns)
      logical updatc
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c calcc calculates the centroid of the simplex without the
c vertex with highest function value.
c
c input
c
c   ns     - subspace dimension
c
c   s      - real work space of dimension .ge.
c            ns*(ns+3) used to store simplex
c
c   ih     - index to vertex with highest function value
c
c   inew   - index to new point
c
c   updatc - logical switch
c            = .true.  : update centroid
c            = .false. : calculate centroid from scratch
c
c   c      - centroid of the simplex without vertex with
c            highest function value
c
c output
c
c   c      - new centroid
c
c local variables
c
      integer i,j
c
c subroutines and functions
c
c   blas
      external cdaxpy,cdcopy,csscal
c
c-----------------------------------------------------------
c
      if (updatc) then
        if (ih .eq. inew) return
        do i = 1,ns
          c(i) = c(i)+(s(i,inew)-s(i,ih))/ns
        end do
      else
        call cdcopy (ns,0.0,0,c,1)
        do j = 1,ns+1
          if (j .ne. ih) call cdaxpy (ns,1.0,s(1,j),1,c,1)
        end do
        call csscal (ns,1.0/ns,c,1)
      end if
      return
      end
      real function cdasum(n,dx,incx)
c
c     takes the sum of the absolute values.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified to correct problem with negative increment, 8/21/90.
c
      real dx(*),dtemp
      integer i,incx,ix,m,mp1,n
c
      cdasum = 0.00
      dtemp = 0.00
      if(n.le.0)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      do i = 1,n
        dtemp = dtemp + abs(dx(ix))
        ix = ix + incx
      end do
      cdasum = dtemp
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,6)
      if( m .eq. 0 ) go to 40
      do i = 1,m
        dtemp = dtemp + abs(dx(i))
      end do
      if( n .lt. 6 ) go to 60
   40 mp1 = m + 1
      do i = mp1,n,6
        dtemp = dtemp + abs(dx(i)) + abs(dx(i + 1)) + abs(dx(i + 2))
     *  + abs(dx(i + 3)) + abs(dx(i + 4)) + abs(dx(i + 5))
      end do
   60 cdasum = dtemp
      return
      end
*********************************************************************
      subroutine cdaxpy(n,da,dx,incx,dy,incy)
c
c     constant times a vector plus a vector.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      real dx(*),dy(*),da
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (da .eq. 0.00) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do i = 1,n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
      end do
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do i = 1,m
        dy(i) = dy(i) + da*dx(i)
      end do
      if( n .lt. 4 ) return
   40 mp1 = m + 1
      do i = mp1,n,4
        dy(i) = dy(i) + da*dx(i)
        dy(i + 1) = dy(i + 1) + da*dx(i + 1)
        dy(i + 2) = dy(i + 2) + da*dx(i + 2)
        dy(i + 3) = dy(i + 3) + da*dx(i + 3)
      end do
      return
      end
*********************************************************************
      subroutine cdcopy(n,dx,incx,dy,incy)
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c
      real dx(*),dy(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do i = 1,n
        dy(iy) = dx(ix)
        ix = ix + incx
        iy = iy + incy
      end do
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do i = 1,m
        dy(i) = dx(i)
      end do
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do i = mp1,n,7
        dy(i) = dx(i)
        dy(i + 1) = dx(i + 1)
        dy(i + 2) = dx(i + 2)
        dy(i + 3) = dx(i + 3)
        dy(i + 4) = dx(i + 4)
        dy(i + 5) = dx(i + 5)
        dy(i + 6) = dx(i + 6)
      end do
      return
      end
      real function dist (n,x,y)
c
      integer n
      real x(n),y(n)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c dist calculates the distance between the points x,y.
c
c input
c
c   n      - number of components
c
c   x      - point in n-space
c
c   y      - point in n-space
c
c local variables
c
      integer i
      real absxmy,scale,sum
c
c subroutines and functions
c
c   fortran
      intrinsic abs,sqrt
c
c-----------------------------------------------------------
c
      absxmy = abs(x(1)-y(1))
      if (absxmy .le. 1.0) then
        sum = absxmy*absxmy
        scale = 1.0
      else
        sum = 1.0
        scale = absxmy
      end if
      do i = 2,n
        absxmy = abs(x(i)-y(i))
        if (absxmy .le. scale) then
          sum = sum+(absxmy/scale)**2
        else
          sum = 1.0+sum*(scale/absxmy)**2
          scale = absxmy
        end if
      end do
      dist = scale*sqrt(sum)
      return
      end
*********************************************************************
      subroutine evalf (f,ns,ips,xs,n,x,sfx,nfe)
c
      integer ns,n,nfe
      integer ips(*)
      real f,xs(*),x(n),sfx
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c evalf evaluates the function f at a point defined by x
c with ns of its components replaced by those in xs.
c
c input
c
c   f      - user supplied function f(n,x) to be optimized
c
c   ns     - subspace dimension
c
c   ips    - permutation vector
c
c   xs     - real ns-vector to be mapped to x
c
c   n      - problem dimension
c
c   x      - real n-vector
c
c   nfe    - number of function evaluations
c
c output
c
c   sfx    - signed value of f evaluated at x
c
c   nfe    - incremented number of function evaluations
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      real alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common/usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
      real fbonus,sfstop,sfbest
      logical new
c
      common/isubc/ fbonus,sfstop,sfbest,new
c
c local variables
c
      integer i
      real fx
      logical newbst
c
      save
c
c subroutines and functions
c
      external func,fstats
c
c-----------------------------------------------------------
c
      do i = 1,ns
        x(ips(i)) = xs(i)
      end do
      newx = new .or. irepl .ne. 2
      fx = func(x)
*      fx = f(n,x)
      if (irepl .eq. 0) then
        if (minf) then
          sfx = fx
        else
          sfx = -fx
        end if
      else if (new) then
        if (minf) then
          sfx = fx
          newbst = fx .lt. ftest
        else
          sfx = -fx
          newbst = fx .gt. ftest
        end if
        if (initx .or. newbst) then
          if (irepl .eq. 1) call fstats (fx,1,.true.)
          ftest = fx
          sfbest = sfx
        end if
      else
        if (irepl .eq. 1) then
          call fstats (fx,1,.false.)
          fx = fxstat(ifxsw)
        end if
        ftest = fx+fbonus*fxstat(4)
        if (minf) then
          sfx = ftest
          sfbest = fx
        else
          sfx = -ftest
          sfbest = -fx
        end if
      end if
      nfe = nfe+1
      return
      end
*********************************************************************
      subroutine fstats (fx,ifxwt,reset)
c
      integer ifxwt
      real fx
      logical reset
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c fstats modifies the common /usubc/ variables nfxe,fxstat.
c
c input
c
c   fx     - most recent evaluation of f at best x
c
c   ifxwt  - integer weight for fx
c
c   reset  - logical switch
c            = .true.  : initialize nfxe,fxstat
c            = .false. : update nfxe,fxstat
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      real alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common/usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
c local variables
c
      integer nsv
      real fscale,f1sv
c
      save
c
c subroutines and functions
c
c   fortran
      intrinsic abs,max,min,sqrt
c
c-----------------------------------------------------------
c
      if (reset) then
        nfxe = ifxwt
        fxstat(1) = fx
        fxstat(2) = fx
        fxstat(3) = fx
        fxstat(4) = 0.0
      else
        nsv = nfxe
        f1sv = fxstat(1)
        nfxe = nfxe+ifxwt
        fxstat(1) = fxstat(1)+ifxwt*(fx-fxstat(1))/nfxe
        fxstat(2) = max(fxstat(2),fx)
        fxstat(3) = min(fxstat(3),fx)
        fscale = max(abs(fxstat(2)),abs(fxstat(3)),1.0)
        fxstat(4) = fscale*sqrt((
     *              (nsv-1)*(fxstat(4)/fscale)**2+
     *              nsv*((fxstat(1)-f1sv)/fscale)**2+
     *              ifxwt*((fx-fxstat(1))/fscale)**2)
     *              /(nfxe-1))
      end if
      return
      end
*********************************************************************
      subroutine newpt (ns,coef,xbase,xold,new,xnew,small)
c
      integer ns
      real coef,xbase(ns),xold(ns),xnew(*)
      logical new,small
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c newpt performs reflections, expansions, contractions, and
c shrinkages (massive contractions) by computing:
c
c xbase + coef * (xbase - xold)
c
c The result is stored in xnew if new .eq. .true.,
c in xold otherwise.
c
c use :  coef .gt. 0 to reflect
c        coef .lt. 0 to expand, contract, or shrink
c
c input
c
c   ns     - number of components (subspace dimension)
c
c   coef   - one of four simplex method coefficients
c
c   xbase  - real ns-vector representing base
c            point
c
c   xold   - real ns-vector representing old
c            point
c
c   new    - logical switch
c            = .true.  : store result in xnew
c            = .false. : store result in xold, xnew is not
c                        referenced
c
c output
c
c   xold   - unchanged if new .eq. .true., contains new
c            point otherwise
c
c   xnew   - real ns-vector representing new
c            point if  new .eq. .true., not referenced
c            otherwise
c
c   small  - logical flag
c            = .true.  : coincident points
c            = .false. : otherwise
c
c local variables
c
      integer i
      real xoldi
      logical eqbase,eqold
c
c subroutines and functions
c
c   fortran
      intrinsic dble
c
c-----------------------------------------------------------
c
      eqbase = .true.
      eqold = .true.
      if (new) then
        do i = 1,ns
          xnew(i) = xbase(i)+coef*(xbase(i)-xold(i))
          eqbase = eqbase .and.
     *             (dble(xnew(i)) .eq. dble(xbase(i)))
          eqold = eqold .and.
     *            (dble(xnew(i)) .eq. dble(xold(i)))
        end do
      else
        do i = 1,ns
          xoldi = xold(i)
          xold(i) = xbase(i)+coef*(xbase(i)-xold(i))
          eqbase = eqbase .and.
     *             (dble(xold(i)) .eq. dble(xbase(i)))
          eqold = eqold .and.
     *            (dble(xold(i)) .eq. dble(xoldi))
        end do
      end if
      small = eqbase .or. eqold
      return
      end
*********************************************************************
      subroutine order (npts,fs,il,is,ih)
c
      integer npts,il,is,ih
      real fs(npts)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c order determines the indices of the vertices with the
c lowest, second highest, and highest function values.
c
c input
c
c   npts   - number of points in simplex
c
c   fs     - real vector of function values of
c            simplex
c
c   il     - index to vertex with lowest function value
c
c output
c
c   il     - new index to vertex with lowest function value
c
c   is     - new index to vertex with second highest
c            function value
c
c   ih     - new index to vertex with highest function value
c
c local variables
c
      integer i,il0,j
c
c subroutines and functions
c
c   fortran
      intrinsic mod
c
c-----------------------------------------------------------
c
      il0 = il
      j = mod(il0,npts)+1
      if (fs(j) .ge. fs(il)) then
        ih = j
        is = il0
      else
        ih = il0
        is = j
        il = j
      end if
      do i = il0+1,il0+npts-2
        j = mod(i,npts)+1
        if (fs(j) .ge. fs(ih)) then
          is = ih
          ih = j
        else if (fs(j) .gt. fs(is)) then
          is = j
        else if (fs(j) .lt. fs(il)) then
          il = j
        end if
      end do
      return
      end
*********************************************************************
      subroutine partx (n,ip,absdx,nsubs,nsvals)
c
      integer n,nsubs,nsvals(*)
      integer ip(n)
      real absdx(n)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c partx partitions the vector x by grouping components of
c similar magnitude of change.
c
c input
c
c   n      - number of components (problem dimension)
c
c   ip     - permutation vector
c
c   absdx  - vector of magnitude of change in x
c
c   nsvals - integer array dimensioned .ge. int(n/nsmin)
c
c output
c
c   nsubs  - number of subspaces
c
c   nsvals - integer array of subspace dimensions
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      real alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common/usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
c local variables
c
      integer i,nleft,ns1,ns2,nused
      real asleft,as1,as1max,as2,gap,gapmax
c
      save
c
c subroutines and functions
c
c   fortran
      intrinsic min
c
c-----------------------------------------------------------
c
      nsubs = 0
      nused = 0
      nleft = n
      asleft = absdx(1)
      do i = 2,n
        asleft = asleft+absdx(i)
      end do
   20 continue
      if (nused .lt. n) then
        nsubs = nsubs+1
        as1 = 0.0
        do i = 1,nsmin-1
          as1 = as1+absdx(ip(nused+i))
        end do
        gapmax = -1.0
        do ns1 = nsmin,min(nsmax,nleft)
          as1 = as1+absdx(ip(nused+ns1))
          ns2 = nleft-ns1
          if (ns2 .gt. 0) then
            if (ns2 .ge. ((ns2-1)/nsmax+1)*nsmin) then
              as2 = asleft-as1
              gap = as1/ns1-as2/ns2
              if (gap .gt. gapmax) then
                gapmax = gap
                nsvals(nsubs) = ns1
                as1max = as1
              end if
            end if
          else
            if (as1/ns1 .gt. gapmax) then
              nsvals(nsubs) = ns1
              return
            end if
          end if
        end do
        nused = nused+nsvals(nsubs)
        nleft = n-nused
        asleft = asleft-as1max
        go to 20
      end if
      return
      end
*********************************************************************
      subroutine setstp (nsubs,n,deltax,step)
c
      integer nsubs,n
      real deltax(n),step(n)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c setstp sets the stepsizes for the corresponding components
c of the solution vector.
c
c input
c
c   nsubs  - number of subspaces
c
c   n      - number of components (problem dimension)
c
c   deltax - vector of change in solution vector
c
c   step   - stepsizes for corresponding components of
c            solution vector
c
c output
c
c   step   - new stepsizes
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      real alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common/usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
c local variables
c
      integer i
      real cdasum,stpfac
c
      save
c
c subroutines and functions
c
c   blas
      external cdasum,csscal
c   fortran
      intrinsic max,min,sign
c
c-----------------------------------------------------------
c
c     set new step
c
      if (nsubs .gt. 1) then
        stpfac = min(max(cdasum(n,deltax,1)/cdasum(n,step,1),
     *           omega),1.0/omega)
      else
        stpfac = psi
      end if
      call csscal (n,stpfac,step,1)
c
c     reorient simplex
c
      do i = 1,n
        if (deltax(i) .ne. 0.) then
          step(i) = sign(step(i),deltax(i))
        else
          step(i) = -step(i)
        end if
      end do
      return
      end
*********************************************************************
      subroutine simplx (f,n,step,ns,ips,maxnfe,cmode,x,fx,
     *                   nfe,s,fs,iflag)
c
      integer n,ns,maxnfe,nfe,iflag
      integer ips(ns)
      real f,step(n),x(n),fx,s(ns,ns+3),fs(ns+1)
      logical cmode
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c simplx uses the Nelder-Mead simplex method to minimize the
c function f on a subspace.
c
c input
c
c   f      - function to be minimized, declared external in
c            calling routine
c
c   n      - problem dimension
c
c   step   - stepsizes for corresponding components of x
c
c   ns     - subspace dimension
c
c   ips    - permutation vector
c
c   maxnfe - maximum number of function evaluations
c
c   cmode  - logical switch
c            = .true.  : continuation of previous call
c            = .false. : first call
c
c   x      - starting guess for minimum
c
c   fx     - value of f at x
c
c   nfe    - number of function evaluations
c
c   s      - real work array of dimension .ge.
c            ns*(ns+3) used to store simplex
c
c   fs     - real work array of dimension .ge.
c            ns+1 used to store function values of simplex
c            vertices
c
c output
c
c   x      - computed minimum
c
c   fx     - value of f at x
c
c   nfe    - incremented number of function evaluations
c
c   iflag  - error flag
c            = -1 : maxnfe exceeded
c            =  0 : simplex reduced by factor of psi
c            =  1 : limit of machine precision
c            =  2 : reached fstop
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      real alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common/usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
      real fbonus,sfstop,sfbest
      logical new
c
      common/isubc/ fbonus,sfstop,sfbest,new
c
c local variables
c
      integer i,icent,ih,il,inew,is,itemp,j,npts
      real dist,dum,fc,fe,fr,tol
      logical small,updatc
c
      save
c
c subroutines and functions
c
      external func,calcc,dist,evalf,newpt,order,start
c   blas
      external cdcopy
c   fortran
      intrinsic min
c
c-----------------------------------------------------------
c
      if (cmode) go to 50
      npts = ns+1
      icent = ns+2
      itemp = ns+3
      updatc = .false.
      call start (n,x,step,ns,ips,s,small)
      if (small) then
        iflag = 1
        return
      end if
      if (irepl .gt. 0) then
        new = .false.
        call evalf (f,ns,ips,s(1,1),n,x,fs(1),nfe)
      else
        fs(1) = fx
      end if
      new = .true.
      do j = 2,npts
        call evalf (f,ns,ips,s(1,j),n,x,fs(j),nfe)
      end do
      il = 1
      call order (npts,fs,il,is,ih)
      tol = psi*dist(ns,s(1,ih),s(1,il))
c
c     main loop
c
   20 continue
        call calcc (ns,s,ih,inew,updatc,s(1,icent))
        updatc = .true.
        inew = ih
c
c       reflect
c
        call newpt (ns,alpha,s(1,icent),s(1,ih),.true.,
     *              s(1,itemp),small)
        if (small) go to 40
        call evalf (f,ns,ips,s(1,itemp),n,x,fr,nfe)
        if (fr .lt. fs(il)) then
c
c         expand
c
          call newpt (ns,-gamma,s(1,icent),s(1,itemp),
     *                .true.,s(1,ih),small)
          if (small) go to 40
          call evalf (f,ns,ips,s(1,ih),n,x,fe,nfe)
          if (fe .lt. fr) then
            fs(ih) = fe
          else
            call cdcopy (ns,s(1,itemp),1,s(1,ih),1)
            fs(ih) = fr
          end if
        else if (fr .lt. fs(is)) then
c
c         accept reflected point
c
          call cdcopy (ns,s(1,itemp),1,s(1,ih),1)
          fs(ih) = fr
        else
c
c         contract
c
          if (fr .gt. fs(ih)) then
            call newpt (ns,-beta,s(1,icent),s(1,ih),.true.,
     *                  s(1,itemp),small)
          else
            call newpt (ns,-beta,s(1,icent),s(1,itemp),
     *                  .false.,dum,small)
          end if
          if (small) go to 40
          call evalf (f,ns,ips,s(1,itemp),n,x,fc,nfe)
          if (fc .lt. min(fr,fs(ih))) then
            call cdcopy (ns,s(1,itemp),1,s(1,ih),1)
            fs(ih) = fc
          else
c
c           shrink simplex
c
            do j = 1,npts
              if (j .ne. il) then
                call newpt (ns,-delta,s(1,il),s(1,j),
     *                      .false.,dum,small)
                if (small) go to 40
                call evalf (f,ns,ips,s(1,j),n,x,fs(j),nfe)
              end if
            end do
          end if
          updatc = .false.
        end if
        call order (npts,fs,il,is,ih)
c
c       check termination
c
   40   continue
        if (irepl .eq. 0) then
          fx = fs(il)
        else
          fx = sfbest
        end if
   50   continue
        if (nfstop .gt. 0 .and. fx .le. sfstop .and.
     *      nfxe .ge. nfstop) then
          iflag = 2
        else if (nfe .ge. maxnfe) then
          iflag = -1
        else if (dist(ns,s(1,ih),s(1,il)) .le. tol .or.
     *           small) then
          iflag = 0
        else
          go to 20
        end if
c
c     end main loop, return best point
c
      do i = 1,ns
        x(ips(i)) = s(i,il)
      end do
      return
      end
*********************************************************************
      subroutine sortd (n,xkey,ix)
c
      integer n
      integer ix(n)
      real xkey(n)
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c sortd uses the shakersort method to sort an array of keys
c in decreasing order. The sort is performed implicitly by
c modifying a vector of indices.
c
c For nearly sorted arrays, sortd requires O(n) comparisons.
c for completely unsorted arrays, sortd requires O(n**2)
c comparisons and will be inefficient unless n is small.
c
c input
c
c   n      - number of components
c
c   xkey   - real vector of keys
c
c   ix     - integer vector of indices
c
c output
c
c   ix     - indices satisfy xkey(ix(i)) .ge. xkey(ix(i+1))
c            for i = 1,...,n-1
c
c local variables
c
      integer i,ifirst,ilast,iswap,ixi,ixip1
c
c-----------------------------------------------------------
c
      ifirst = 1
      iswap = 1
      ilast = n-1
   10 continue
      if (ifirst .le. ilast) then
        do i = ifirst,ilast
          ixi = ix(i)
          ixip1 = ix(i+1)
          if (xkey(ixi) .lt. xkey(ixip1)) then
            ix(i) = ixip1
            ix(i+1) = ixi
            iswap = i
          end if
        end do
        ilast = iswap-1
        do i = ilast,ifirst,-1
          ixi = ix(i)
          ixip1 = ix(i+1)
          if (xkey(ixi) .lt. xkey(ixip1)) then
            ix(i) = ixip1
            ix(i+1) = ixi
            iswap = i
          end if
        end do
        ifirst = iswap+1
        go to 10
      end if
      return
      end
*********************************************************************
      subroutine start (n,x,step,ns,ips,s,small)
c
      integer n,ns
      integer ips(n)
      real x(n),step(n),s(ns,ns+3)
      logical small
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c start creates the initial simplex for simplx minimization.
c
c input
c
c   n      - problem dimension
c
c   x      - current best point
c
c   step   - stepsizes for corresponding components of x
c
c   ns     - subspace dimension
c
c   ips    - permutation vector
c
c
c output
c
c   s      - first ns+1 columns contain initial simplex
c
c   small  - logical flag
c            = .true.  : coincident points
c            = .false. : otherwise
c
c local variables
c
      integer i,j
c
c subroutines and functions
c
c   blas
      external cdcopy
c   fortran
      intrinsic dble
c
c-----------------------------------------------------------
c
      do i = 1,ns
        s(i,1) = x(ips(i))
      end do
      do j = 2,ns+1
        call cdcopy (ns,s(1,1),1,s(1,j),1)
        s(j-1,j) = s(j-1,1)+step(ips(j-1))
      end do
c
c check for coincident points
c
      do j = 2,ns+1
        if (dble(s(j-1,j)) .eq. dble(s(j-1,1))) go to 40
      end do
      small = .false.
      return
c
c coincident points
c
   40 continue
      small = .true.
      return
      end
*********************************************************************
      subroutine subopt (n)
c
      integer n
c
c                                         Coded by Tom Rowan
c                            Department of Computer Sciences
c                              University of Texas at Austin
c
c subopt sets options for subplx.
c
c input
c
c   n      - problem dimension
c
c common
c
      integer nsmin,nsmax,irepl,ifxsw,nfstop,nfxe
      real alpha,beta,gamma,delta,psi,omega,
     *     bonus,fstop,fxstat,ftest
      logical minf,initx,newx
c
      common/usubc/ alpha,beta,gamma,delta,psi,omega,nsmin,
     *               nsmax,irepl,ifxsw,bonus,fstop,nfstop,
     *               nfxe,fxstat(4),ftest,minf,initx,newx
c
      save
c
c subroutines and functions
c
c   fortran
      intrinsic min
c
c-----------------------------------------------------------
c
c***********************************************************
c simplex method strategy parameters
c***********************************************************
c
c alpha  - reflection coefficient
c          alpha .gt. 0
c
      alpha = 1.0
c
c beta   - contraction coefficient
c          0 .lt. beta .lt. 1
c
      beta = .50
c
c gamma  - expansion coefficient
c          gamma .gt. 1
c
      gamma = 2.0
c
c delta  - shrinkage (massive contraction) coefficient
c          0 .lt. delta .lt. 1
c
      delta = .50
c
c***********************************************************
c subplex method strategy parameters
c***********************************************************
c
c psi    - simplex reduction coefficient
c          0 .lt. psi .lt. 1
c
      psi = .250
c
c omega  - step reduction coefficient
c          0 .lt. omega .lt. 1
c
      omega = .10
c
c nsmin and nsmax specify a range of subspace dimensions.
c In addition to satisfying  1 .le. nsmin .le. nsmax .le. n,
c nsmin and nsmax must be chosen so that n can be expressed
c as a sum of positive integers where each of these integers
c ns(i) satisfies   nsmin .le. ns(i) .ge. nsmax.
c Specifically,
c     nsmin*ceil(n/nsmax) .le. n   must be true.
c
c nsmin  - subspace dimension minimum
c
      nsmin = min(2,n)
c
c nsmax  - subspace dimension maximum
c
      nsmax = min(5,n)
c
c***********************************************************
c subplex method special cases
c***********************************************************
c nelder-mead simplex method with periodic restarts
c   nsmin = nsmax = n
c***********************************************************
c nelder-mead simplex method
c   nsmin = nsmax = n, psi = small positive
c***********************************************************
c
c irepl, ifxsw, and bonus deal with measurement replication.
c Objective functions subject to large amounts of noise can
c cause an optimization method to halt at a false optimum.
c An expensive solution to this problem is to evaluate f
c several times at each point and return the average (or max
c or min) of these trials as the function value.  subplx
c performs measurement replication only at the current best
c point. The longer a point is retained as best, the more
c accurate its function value becomes.
c
c The common variable nfxe contains the number of function
c evaluations at the current best point. fxstat contains the
c mean, max, min, and standard deviation of these trials.
c
c irepl  - measurement replication switch
c irepl  = 0, 1, or 2
c        = 0 : no measurement replication
c        = 1 : subplx performs measurement replication
c        = 2 : user performs measurement replication
c              (This is useful when optimizing on the mean,
c              max, or min of trials is insufficient. Common
c              variable initx is true for first function
c              evaluation. newx is true for first trial at
c              this point. The user uses subroutine fstats
c              within his objective function to maintain
c              fxstat. By monitoring newx, the user can tell
c              whether to return the function evaluation
c              (newx = .true.) or to use the new function
c              evaluation to refine the function evaluation
c              of the current best point (newx = .false.).
c              The common variable ftest gives the function
c              value that a new point must beat to be
c              considered the new best point.)
c
      irepl = 0
c
c ifxsw  - measurement replication optimization switch
c ifxsw  = 1, 2, or 3
c        = 1 : retain mean of trials as best function value
c        = 2 : retain max
c        = 3 : retain min
c
      ifxsw = 1
c
c Since the current best point will also be the most
c accurately evaluated point whenever irepl .gt. 0, a bonus
c should be added to the function value of the best point
c so that the best point is not replaced by a new point
c that only appears better because of noise.
c subplx uses bonus to determine how many multiples of
c fxstat(4) should be added as a bonus to the function
c evaluation. (The bonus is adjusted automatically by
c subplx when ifxsw or minf is changed.)
c
c bonus  - measurement replication bonus coefficient
c          bonus .ge. 0 (normally, bonus = 0 or 1)
c        = 0 : bonus not used
c        = 1 : bonus used
c
      bonus = 1.0
c
c nfstop = 0 : f(x) is not tested against fstop
c        = 1 : if f(x) has reached fstop, subplx returns
c              iflag = 2
c        = 2 : (only valid when irepl .gt. 0)
c              if f(x) has reached fstop and
c              nfxe .gt. nfstop, subplx returns iflag = 2
c
      nfstop = 0
c
c fstop  - f target value
c          Its usage is determined by the value of nfstop.
c
c minf   - logical switch
c        = .true.  : subplx performs minimization
c        = .false. : subplx performs maximization
c
      minf = .true.
      return
      end
*****************************************************************
*****************************************************************
*
*     matrix inversion routine
*
*     solves Ax=B  A is an nXn matrix, C and B are nX1 matrices
*     dim A(n,n), B(n,1)  C overwrites B.
*     integer ipiv(n)
*     integer info  see below:
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, U(i,i) is exactly zero. The factorization
*                has been completed, but the factor U is exactly
*                singular, and division by zero will occur if it is used
*                to solve a system of equations.
*
*
*
*must call the routines in the following order:
*       call dgetrf(n,n,A,n,ipiv,info)
*       call dgetrs('N',n,1,A,n,ipiv,B,n,info)
*
*
***************************************************************************
      SUBROUTINE DGETRS( TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  DGETRS solves a system of linear equations
*     A * X = B  or  A' * X = B
*  with a general N-by-N matrix A using the LU factorization computed
*  by DGETRF.
*
*  Arguments
*  =========
*
*  TRANS   (input) CHARACTER*1
*          Specifies the form of the system of equations:
*          = 'N':  A * X = B  (No transpose)
*          = 'T':  A'* X = B  (Transpose)
*          = 'C':  A'* X = B  (Conjugate transpose = Transpose)
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  NRHS    (input) INTEGER
*          The number of right hand sides, i.e., the number of columns
*          of the matrix B.  NRHS >= 0.
*
*  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
*          The factors L and U from the factorization A = P*L*U
*          as computed by DGETRF.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  IPIV    (input) INTEGER array, dimension (N)
*          The pivot indices from DGETRF; for 1<=i<=N, row i of the
*          matrix was interchanged with row IPIV(i).
*
*  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
*          On entry, the right hand side matrix B.
*          On exit, the solution matrix X.
*
*  LDB     (input) INTEGER
*          The leading dimension of the array B.  LDB >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            NOTRAN
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DLASWP, DTRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      NOTRAN = LSAME( TRANS, 'N' )
      IF( .NOT.NOTRAN .AND. .NOT.LSAME( TRANS, 'T' ) .AND. .NOT.
     $    LSAME( TRANS, 'C' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -8
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGETRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( NOTRAN ) THEN
*
*        Solve A * X = B.
*
*        Apply row interchanges to the right hand sides.
*
         CALL DLASWP( NRHS, B, LDB, 1, N, IPIV, 1 )
*
*        Solve L*X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Lower', 'No transpose', 'Unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
*
*        Solve U*X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Upper', 'No transpose', 'Non-unit', N,
     $               NRHS, ONE, A, LDA, B, LDB )
      ELSE
*
*        Solve A' * X = B.
*
*        Solve U'*X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Upper', 'Transpose', 'Non-unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
*
*        Solve L'*X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Lower', 'Transpose', 'Unit', N, NRHS, ONE,
     $               A, LDA, B, LDB )
*
*        Apply row interchanges to the solution vectors.
*
         CALL DLASWP( NRHS, B, LDB, 1, N, IPIV, -1 )
      END IF
*
      RETURN
*
*     End of DGETRS
*
      END
***************************************************************************
      SUBROUTINE DGEMM ( TRANSA, TRANSB, M, N, K, ALPHA, A, LDA, B, LDB,
     $                   BETA, C, LDC )
*     .. Scalar Arguments ..
      CHARACTER*1        TRANSA, TRANSB
      INTEGER            M, N, K, LDA, LDB, LDC
      DOUBLE PRECISION   ALPHA, BETA
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * ), C( LDC, * )
*     ..
*
*  Purpose
*  =======
*
*  DGEMM  performs one of the matrix-matrix operations
*
*     C := alpha*op( A )*op( B ) + beta*C,
*
*  where  op( X ) is one of
*
*     op( X ) = X   or   op( X ) = X',
*
*  alpha and beta are scalars, and A, B and C are matrices, with op( A )
*  an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
*
*  Parameters
*  ==========
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n',  op( A ) = A.
*
*              TRANSA = 'T' or 't',  op( A ) = A'.
*
*              TRANSA = 'C' or 'c',  op( A ) = A'.
*
*           Unchanged on exit.
*
*  TRANSB - CHARACTER*1.
*           On entry, TRANSB specifies the form of op( B ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSB = 'N' or 'n',  op( B ) = B.
*
*              TRANSB = 'T' or 't',  op( B ) = B'.
*
*              TRANSB = 'C' or 'c',  op( B ) = B'.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry,  M  specifies  the number  of rows  of the  matrix
*           op( A )  and of the  matrix  C.  M  must  be at least  zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry,  N  specifies the number  of columns of the matrix
*           op( B ) and the number of columns of the matrix C. N must be
*           at least zero.
*           Unchanged on exit.
*
*  K      - INTEGER.
*           On entry,  K  specifies  the number of columns of the matrix
*           op( A ) and the number of rows of the matrix op( B ). K must
*           be at least  zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION.
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  A      - DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is
*           k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
*           Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
*           part of the array  A  must contain the matrix  A,  otherwise
*           the leading  k by m  part of the array  A  must contain  the
*           matrix A.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. When  TRANSA = 'N' or 'n' then
*           LDA must be at least  max( 1, m ), otherwise  LDA must be at
*           least  max( 1, k ).
*           Unchanged on exit.
*
*  B      - DOUBLE PRECISION array of DIMENSION ( LDB, kb ), where kb is
*           n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
*           Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
*           part of the array  B  must contain the matrix  B,  otherwise
*           the leading  n by k  part of the array  B  must contain  the
*           matrix B.
*           Unchanged on exit.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in the calling (sub) program. When  TRANSB = 'N' or 'n' then
*           LDB must be at least  max( 1, k ), otherwise  LDB must be at
*           least  max( 1, n ).
*           Unchanged on exit.
*
*  BETA   - DOUBLE PRECISION.
*           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
*           supplied as zero then C need not be set on input.
*           Unchanged on exit.
*
*  C      - DOUBLE PRECISION array of DIMENSION ( LDC, n ).
*           Before entry, the leading  m by n  part of the array  C must
*           contain the matrix  C,  except when  beta  is zero, in which
*           case C need not be set on entry.
*           On exit, the array  C  is overwritten by the  m by n  matrix
*           ( alpha*op( A )*op( B ) + beta*C ).
*
*  LDC    - INTEGER.
*           On entry, LDC specifies the first dimension of C as declared
*           in  the  calling  (sub)  program.   LDC  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            NOTA, NOTB
      INTEGER            I, INFO, J, L, NCOLA, NROWA, NROWB
      DOUBLE PRECISION   TEMP
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Executable Statements ..
*
*     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
*     transposed and set  NROWA, NCOLA and  NROWB  as the number of rows
*     and  columns of  A  and the  number of  rows  of  B  respectively.
*
      NOTA  = LSAME( TRANSA, 'N' )
      NOTB  = LSAME( TRANSB, 'N' )
      IF( NOTA )THEN
         NROWA = M
         NCOLA = K
      ELSE
         NROWA = K
         NCOLA = M
      END IF
      IF( NOTB )THEN
         NROWB = K
      ELSE
         NROWB = N
      END IF
*
*     Test the input parameters.
*
      INFO = 0
      IF(      ( .NOT.NOTA                 ).AND.
     $         ( .NOT.LSAME( TRANSA, 'C' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'T' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.NOTB                 ).AND.
     $         ( .NOT.LSAME( TRANSB, 'C' ) ).AND.
     $         ( .NOT.LSAME( TRANSB, 'T' ) )      )THEN
         INFO = 2
      ELSE IF( M  .LT.0               )THEN
         INFO = 3
      ELSE IF( N  .LT.0               )THEN
         INFO = 4
      ELSE IF( K  .LT.0               )THEN
         INFO = 5
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 8
      ELSE IF( LDB.LT.MAX( 1, NROWB ) )THEN
         INFO = 10
      ELSE IF( LDC.LT.MAX( 1, M     ) )THEN
         INFO = 13
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DGEMM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.
     $    ( ( ( ALPHA.EQ.ZERO ).OR.( K.EQ.0 ) ).AND.( BETA.EQ.ONE ) ) )
     $   RETURN
*
*     And if  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         IF( BETA.EQ.ZERO )THEN
            do J = 1, N
               do I = 1, M
                  C( I, J ) = ZERO
               end do
            end do
         ELSE
            do J = 1, N
               do I = 1, M
                  C( I, J ) = BETA*C( I, J )
               end do
            end do
         END IF
         RETURN
      END IF
*
*     Start the operations.
*
      IF( NOTB )THEN
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B + beta*C.
*
            do J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  do I = 1, M
                     C( I, J ) = ZERO
                  end do
               ELSE IF( BETA.NE.ONE )THEN
                  do I = 1, M
                     C( I, J ) = BETA*C( I, J )
                  end do
               END IF
               do L = 1, K
                  IF( B( L, J ).NE.ZERO )THEN
                     TEMP = ALPHA*B( L, J )
                     do I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
                     end do
                  END IF
               end do
            end do
         ELSE
*
*           Form  C := alpha*A'*B + beta*C
*
            do J = 1, N
               do I = 1, M
                  TEMP = ZERO
                  do L = 1, K
                     TEMP = TEMP + A( L, I )*B( L, J )
                  end do
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
               end do
            end do
         END IF
      ELSE
         IF( NOTA )THEN
*
*           Form  C := alpha*A*B' + beta*C
*
            do J = 1, N
               IF( BETA.EQ.ZERO )THEN
                  do I = 1, M
                     C( I, J ) = ZERO
                  end do
               ELSE IF( BETA.NE.ONE )THEN
                  do I = 1, M
                     C( I, J ) = BETA*C( I, J )
                  end do
               END IF
               do L = 1, K
                  IF( B( J, L ).NE.ZERO )THEN
                     TEMP = ALPHA*B( J, L )
                     do I = 1, M
                        C( I, J ) = C( I, J ) + TEMP*A( I, L )
                     end do
                  END IF
               end do
            end do
         ELSE
*
*           Form  C := alpha*A'*B' + beta*C
*
            do J = 1, N
               do I = 1, M
                  TEMP = ZERO
                  do L = 1, K
                     TEMP = TEMP + A( L, I )*B( J, L )
                  end do
                  IF( BETA.EQ.ZERO )THEN
                     C( I, J ) = ALPHA*TEMP
                  ELSE
                     C( I, J ) = ALPHA*TEMP + BETA*C( I, J )
                  END IF
               end do
            end do
         END IF
      END IF
*
      RETURN
*
*     End of DGEMM .
*
      END
      SUBROUTINE DGER  ( M, N, ALPHA, X, INCX, Y, INCY, A, LDA )
*     .. Scalar Arguments ..
      DOUBLE PRECISION   ALPHA
      INTEGER            INCX, INCY, LDA, M, N
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), X( * ), Y( * )
*     ..
*
*  Purpose
*  =======
*
*  DGER   performs the rank 1 operation
*
*     A := alpha*x*y' + A,
*
*  where alpha is a scalar, x is an m element vector, y is an n element
*  vector and A is an m by n matrix.
*
*  Parameters
*  ==========
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of the matrix A.
*           M must be at least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of the matrix A.
*           N must be at least zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION.
*           On entry, ALPHA specifies the scalar alpha.
*           Unchanged on exit.
*
*  X      - DOUBLE PRECISION array of dimension at least
*           ( 1 + ( m - 1 )*abs( INCX ) ).
*           Before entry, the incremented array X must contain the m
*           element vector x.
*           Unchanged on exit.
*
*  INCX   - INTEGER.
*           On entry, INCX specifies the increment for the elements of
*           X. INCX must not be zero.
*           Unchanged on exit.
*
*  Y      - DOUBLE PRECISION array of dimension at least
*           ( 1 + ( n - 1 )*abs( INCY ) ).
*           Before entry, the incremented array Y must contain the n
*           element vector y.
*           Unchanged on exit.
*
*  INCY   - INTEGER.
*           On entry, INCY specifies the increment for the elements of
*           Y. INCY must not be zero.
*           Unchanged on exit.
*
*  A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).
*           Before entry, the leading m by n part of the array A must
*           contain the matrix of coefficients. On exit, A is
*           overwritten by the updated matrix.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program. LDA must be at least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 2 Blas routine.
*
*  -- Written on 22-October-1986.
*     Jack Dongarra, Argonne National Lab.
*     Jeremy Du Croz, Nag Central Office.
*     Sven Hammarling, Nag Central Office.
*     Richard Hanson, Sandia National Labs.
*
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER        ( ZERO = 0.0D+0 )
*     .. Local Scalars ..
      DOUBLE PRECISION   TEMP
      INTEGER            I, INFO, IX, J, JY, KX
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF     ( M.LT.0 )THEN
         INFO = 1
      ELSE IF( N.LT.0 )THEN
         INFO = 2
      ELSE IF( INCX.EQ.0 )THEN
         INFO = 5
      ELSE IF( INCY.EQ.0 )THEN
         INFO = 7
      ELSE IF( LDA.LT.MAX( 1, M ) )THEN
         INFO = 9
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DGER  ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( ( M.EQ.0 ).OR.( N.EQ.0 ).OR.( ALPHA.EQ.ZERO ) )
     $   RETURN
*
*     Start the operations. In this version the elements of A are
*     accessed sequentially with one pass through A.
*
      IF( INCY.GT.0 )THEN
         JY = 1
      ELSE
         JY = 1 - ( N - 1 )*INCY
      END IF
      IF( INCX.EQ.1 )THEN
         do J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               do I = 1, M
                  A( I, J ) = A( I, J ) + X( I )*TEMP
               end do
            END IF
            JY = JY + INCY
         end do
      ELSE
         IF( INCX.GT.0 )THEN
            KX = 1
         ELSE
            KX = 1 - ( M - 1 )*INCX
         END IF
         do J = 1, N
            IF( Y( JY ).NE.ZERO )THEN
               TEMP = ALPHA*Y( JY )
               IX   = KX
               do I = 1, M
                  A( I, J ) = A( I, J ) + X( IX )*TEMP
                  IX        = IX        + INCX
               end do
            END IF
            JY = JY + INCY
         end do
      END IF
*
      RETURN
*
*     End of DGER  .
*
      END
      SUBROUTINE DGETF2( M, N, A, LDA, IPIV, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  DGETF2 computes an LU factorization of a general m-by-n matrix A
*  using partial pivoting with row interchanges.
*
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*
*  This is the right-looking Level 2 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the m by n matrix to be factored.
*          On exit, the factors L and U from the factorization
*          A = P*L*U; the unit diagonal elements of L are not stored.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  IPIV    (output) INTEGER array, dimension (min(M,N))
*          The pivot indices; for 1 <= i <= min(M,N), row i of the
*          matrix was interchanged with row IPIV(i).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*          > 0: if INFO = k, U(k,k) is exactly zero. The factorization
*               has been completed, but the factor U is exactly
*               singular, and division by zero will occur if it is used
*               to solve a system of equations.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            J, JP
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX
      EXTERNAL           IDAMAX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGER, DSCAL, DSWAP, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGETF2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
      do J = 1, MIN( M, N )
*
*        Find pivot and test for singularity.
*
         JP = J - 1 + IDAMAX( M-J+1, A( J, J ), 1 )
         IPIV( J ) = JP
         IF( A( JP, J ).NE.ZERO ) THEN
*
*           Apply the interchange to columns 1:N.
*
            IF( JP.NE.J )
     $         CALL DSWAP( N, A( J, 1 ), LDA, A( JP, 1 ), LDA )
*
*           Compute elements J+1:M of J-th column.
*
            IF( J.LT.M )
     $         CALL DSCAL( M-J, ONE / A( J, J ), A( J+1, J ), 1 )
*
         ELSE IF( INFO.EQ.0 ) THEN
*
            INFO = J
         END IF
*
         IF( J.LT.MIN( M, N ) ) THEN
*
*           Update trailing submatrix.
*
            CALL DGER( M-J, N-J, -ONE, A( J+1, J ), 1, A( J, J+1 ), LDA,
     $                 A( J+1, J+1 ), LDA )
         END IF
      end do
      RETURN
*
*     End of DGETF2
*
      END
      SUBROUTINE DGETRF( M, N, A, LDA, IPIV, INFO )
*
*  -- LAPACK routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     March 31, 1993
*
*     .. Scalar Arguments ..
      INTEGER            INFO, LDA, M, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  DGETRF computes an LU factorization of a general M-by-N matrix A
*  using partial pivoting with row interchanges.
*
*  The factorization has the form
*     A = P * L * U
*  where P is a permutation matrix, L is lower triangular with unit
*  diagonal elements (lower trapezoidal if m > n), and U is upper
*  triangular (upper trapezoidal if m < n).
*
*  This is the right-looking Level 3 BLAS version of the algorithm.
*
*  Arguments
*  =========
*
*  M       (input) INTEGER
*          The number of rows of the matrix A.  M >= 0.
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the M-by-N matrix to be factored.
*          On exit, the factors L and U from the factorization
*          A = P*L*U; the unit diagonal elements of L are not stored.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,M).
*
*  IPIV    (output) INTEGER array, dimension (min(M,N))
*          The pivot indices; for 1 <= i <= min(M,N), row i of the
*          matrix was interchanged with row IPIV(i).
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*          > 0:  if INFO = i, U(i,i) is exactly zero. The factorization
*                has been completed, but the factor U is exactly
*                singular, and division by zero will occur if it is used
*                to solve a system of equations.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, IINFO, J, JB, NB
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEMM, DGETF2, DLASWP, DTRSM, XERBLA
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      IF( M.LT.0 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, M ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGETRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( M.EQ.0 .OR. N.EQ.0 )
     $   RETURN
*
*     Determine the block size for this environment.
*
      NB = ILAENV( 1, 'DGETRF', ' ', M, N, -1, -1 )
      IF( NB.LE.1 .OR. NB.GE.MIN( M, N ) ) THEN
*
*        Use unblocked code.
*
         CALL DGETF2( M, N, A, LDA, IPIV, INFO )
      ELSE
*
*        Use blocked code.
*
         do J = 1, MIN( M, N ), NB
            JB = MIN( MIN( M, N )-J+1, NB )
*
*           Factor diagonal and subdiagonal blocks and test for exact
*           singularity.
*
            CALL DGETF2( M-J+1, JB, A( J, J ), LDA, IPIV( J ), IINFO )
*
*           Adjust INFO and the pivot indices.
*
            IF( INFO.EQ.0 .AND. IINFO.GT.0 )
     $         INFO = IINFO + J - 1
            do I = J, MIN( M, J+JB-1 )
               IPIV( I ) = J - 1 + IPIV( I )
            end do
*
*           Apply interchanges to columns 1:J-1.
*
            CALL DLASWP( J-1, A, LDA, J, J+JB-1, IPIV, 1 )
*
            IF( J+JB.LE.N ) THEN
*
*              Apply interchanges to columns J+JB:N.
*
               CALL DLASWP( N-J-JB+1, A( 1, J+JB ), LDA, J, J+JB-1,
     $                      IPIV, 1 )
*
*              Compute block row of U.
*
               CALL DTRSM( 'Left', 'Lower', 'No transpose', 'Unit', JB,
     $                     N-J-JB+1, ONE, A( J, J ), LDA, A( J, J+JB ),
     $                     LDA )
               IF( J+JB.LE.M ) THEN
*
*                 Update trailing submatrix.
*
                  CALL DGEMM( 'No transpose', 'No transpose', M-J-JB+1,
     $                        N-J-JB+1, JB, -ONE, A( J+JB, J ), LDA,
     $                        A( J, J+JB ), LDA, ONE, A( J+JB, J+JB ),
     $                        LDA )
               END IF
            END IF
         end do
      END IF
      RETURN
*
*     End of DGETRF
*
      END
      SUBROUTINE DLASWP( N, A, LDA, K1, K2, IPIV, INCX )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     October 31, 1992
*
*     .. Scalar Arguments ..
      INTEGER            INCX, K1, K2, LDA, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  DLASWP performs a series of row interchanges on the matrix A.
*  One row interchange is initiated for each of rows K1 through K2 of A.
*
*  Arguments
*  =========
*
*  N       (input) INTEGER
*          The number of columns of the matrix A.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the matrix of column dimension N to which the row
*          interchanges will be applied.
*          On exit, the permuted matrix.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.
*
*  K1      (input) INTEGER
*          The first element of IPIV for which a row interchange will
*          be done.
*
*  K2      (input) INTEGER
*          The last element of IPIV for which a row interchange will
*          be done.
*
*  IPIV    (input) INTEGER array, dimension (M*abs(INCX))
*          The vector of pivot indices.  Only the elements in positions
*          K1 through K2 of IPIV are accessed.
*          IPIV(K) = L implies rows K and L are to be interchanged.
*
*  INCX    (input) INTEGER
*          The increment between successive values of IPIV.  If IPIV
*          is negative, the pivots are applied in reverse order.
*
* =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IP, IX
*     ..
*     .. External Subroutines ..
      EXTERNAL           DSWAP
*     ..
*     .. Executable Statements ..
*
*     Interchange row I with row IPIV(I) for each of rows K1 through K2.
*
      IF( INCX.EQ.0 )
     $   RETURN
      IF( INCX.GT.0 ) THEN
         IX = K1
      ELSE
         IX = 1 + ( 1-K2 )*INCX
      END IF
      IF( INCX.EQ.1 ) THEN
         do I = K1, K2
            IP = IPIV( I )
            IF( IP.NE.I )
     $         CALL DSWAP( N, A( I, 1 ), LDA, A( IP, 1 ), LDA )
         end do
      ELSE IF( INCX.GT.1 ) THEN
         do I = K1, K2
            IP = IPIV( IX )
            IF( IP.NE.I )
     $         CALL DSWAP( N, A( I, 1 ), LDA, A( IP, 1 ), LDA )
            IX = IX + INCX
         end do
      ELSE IF( INCX.LT.0 ) THEN
         do I = K2, K1, -1
            IP = IPIV( IX )
            IF( IP.NE.I )
     $         CALL DSWAP( N, A( I, 1 ), LDA, A( IP, 1 ), LDA )
            IX = IX + INCX
         end do
      END IF
*
      RETURN
*
*     End of DLASWP
*
      END
      subroutine csscal(n,da,dx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
*     changed to single precisions
c
      real da,dx(*)
      integer i,incx,m,mp1,n,nincx
c
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do i = 1,nincx,incx
        dx(i) = da*dx(i)
      end do
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do i = 1,m
        dx(i) = da*dx(i)
      end do
      if( n .lt. 5 ) return
   40 mp1 = m + 1
      do i = mp1,n,5
        dx(i) = da*dx(i)
        dx(i + 1) = da*dx(i + 1)
        dx(i + 2) = da*dx(i + 2)
        dx(i + 3) = da*dx(i + 3)
        dx(i + 4) = da*dx(i + 4)
      end do
      return
      end
      subroutine DSCAL(n,da,dx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision da,dx(*)
      integer i,incx,m,mp1,n,nincx
c
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do i = 1,nincx,incx
        dx(i) = da*dx(i)
      end do
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do i = 1,m
        dx(i) = da*dx(i)
      end do
      if( n .lt. 5 ) return
   40 mp1 = m + 1
      do i = mp1,n,5
        dx(i) = da*dx(i)
        dx(i + 1) = da*dx(i + 1)
        dx(i + 2) = da*dx(i + 2)
        dx(i + 3) = da*dx(i + 3)
        dx(i + 4) = da*dx(i + 4)
      end do
      return
      end
***************************************************************
      SUBROUTINE DSWAP (n,dx,incx,dy,incy)
c
c     interchanges two vectors.
c     uses unrolled loops for increments equal one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dy(*),dtemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c       code for unequal increments or equal increments not equal
c         to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do i = 1,n
        dtemp = dx(ix)
        dx(ix) = dy(iy)
        dy(iy) = dtemp
        ix = ix + incx
        iy = iy + incy
      end do
      return
c
c       code for both increments equal to 1
c
c
c       clean-up loop
c
   20 m = mod(n,3)
      if( m .eq. 0 ) go to 40
      do i = 1,m
        dtemp = dx(i)
        dx(i) = dy(i)
        dy(i) = dtemp
      end do
      if( n .lt. 3 ) return
   40 mp1 = m + 1
      do i = mp1,n,3
        dtemp = dx(i)
        dx(i) = dy(i)
        dy(i) = dtemp
        dtemp = dx(i + 1)
        dx(i + 1) = dy(i + 1)
        dy(i + 1) = dtemp
        dtemp = dx(i + 2)
        dx(i + 2) = dy(i + 2)
        dy(i + 2) = dtemp
      end do
      return
      end
      SUBROUTINE DTRSM ( SIDE, UPLO, TRANSA, DIAG, M, N, ALPHA, A, LDA,
     $                   B, LDB )
*     .. Scalar Arguments ..
      CHARACTER*1        SIDE, UPLO, TRANSA, DIAG
      INTEGER            M, N, LDA, LDB
      DOUBLE PRECISION   ALPHA
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*     ..
*
*  Purpose
*  =======
*
*  DTRSM  solves one of the matrix equations
*
*     op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
*
*  where alpha is a scalar, X and B are m by n matrices, A is a unit, or
*  non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
*
*     op( A ) = A   or   op( A ) = A'.
*
*  The matrix X is overwritten on B.
*
*  Parameters
*  ==========
*
*  SIDE   - CHARACTER*1.
*           On entry, SIDE specifies whether op( A ) appears on the left
*           or right of X as follows:
*
*              SIDE = 'L' or 'l'   op( A )*X = alpha*B.
*
*              SIDE = 'R' or 'r'   X*op( A ) = alpha*B.
*
*           Unchanged on exit.
*
*  UPLO   - CHARACTER*1.
*           On entry, UPLO specifies whether the matrix A is an upper or
*           lower triangular matrix as follows:
*
*              UPLO = 'U' or 'u'   A is an upper triangular matrix.
*
*              UPLO = 'L' or 'l'   A is a lower triangular matrix.
*
*           Unchanged on exit.
*
*  TRANSA - CHARACTER*1.
*           On entry, TRANSA specifies the form of op( A ) to be used in
*           the matrix multiplication as follows:
*
*              TRANSA = 'N' or 'n'   op( A ) = A.
*
*              TRANSA = 'T' or 't'   op( A ) = A'.
*
*              TRANSA = 'C' or 'c'   op( A ) = A'.
*
*           Unchanged on exit.
*
*  DIAG   - CHARACTER*1.
*           On entry, DIAG specifies whether or not A is unit triangular
*           as follows:
*
*              DIAG = 'U' or 'u'   A is assumed to be unit triangular.
*
*              DIAG = 'N' or 'n'   A is not assumed to be unit
*                                  triangular.
*
*           Unchanged on exit.
*
*  M      - INTEGER.
*           On entry, M specifies the number of rows of B. M must be at
*           least zero.
*           Unchanged on exit.
*
*  N      - INTEGER.
*           On entry, N specifies the number of columns of B.  N must be
*           at least zero.
*           Unchanged on exit.
*
*  ALPHA  - DOUBLE PRECISION.
*           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
*           zero then  A is not referenced and  B need not be set before
*           entry.
*           Unchanged on exit.
*
*  A      - DOUBLE PRECISION array of DIMENSION ( LDA, k ), where k is m
*           when  SIDE = 'L' or 'l'  and is  n  when  SIDE = 'R' or 'r'.
*           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
*           upper triangular part of the array  A must contain the upper
*           triangular matrix  and the strictly lower triangular part of
*           A is not referenced.
*           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
*           lower triangular part of the array  A must contain the lower
*           triangular matrix  and the strictly upper triangular part of
*           A is not referenced.
*           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
*           A  are not referenced either,  but are assumed to be  unity.
*           Unchanged on exit.
*
*  LDA    - INTEGER.
*           On entry, LDA specifies the first dimension of A as declared
*           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
*           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
*           then LDA must be at least max( 1, n ).
*           Unchanged on exit.
*
*  B      - DOUBLE PRECISION array of DIMENSION ( LDB, n ).
*           Before entry,  the leading  m by n part of the array  B must
*           contain  the  right-hand  side  matrix  B,  and  on exit  is
*           overwritten by the solution matrix  X.
*
*  LDB    - INTEGER.
*           On entry, LDB specifies the first dimension of B as declared
*           in  the  calling  (sub)  program.   LDB  must  be  at  least
*           max( 1, m ).
*           Unchanged on exit.
*
*
*  Level 3 Blas routine.
*
*
*  -- Written on 8-February-1989.
*     Jack Dongarra, Argonne National Laboratory.
*     Iain Duff, AERE Harwell.
*     Jeremy Du Croz, Numerical Algorithms Group Ltd.
*     Sven Hammarling, Numerical Algorithms Group Ltd.
*
*
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     .. Local Scalars ..
      LOGICAL            LSIDE, NOUNIT, UPPER
      INTEGER            I, INFO, J, K, NROWA
      DOUBLE PRECISION   TEMP
*     .. Parameters ..
      DOUBLE PRECISION   ONE         , ZERO
      PARAMETER        ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      LSIDE  = LSAME( SIDE  , 'L' )
      IF( LSIDE )THEN
         NROWA = M
      ELSE
         NROWA = N
      END IF
      NOUNIT = LSAME( DIAG  , 'N' )
      UPPER  = LSAME( UPLO  , 'U' )
*
      INFO   = 0
      IF(      ( .NOT.LSIDE                ).AND.
     $         ( .NOT.LSAME( SIDE  , 'R' ) )      )THEN
         INFO = 1
      ELSE IF( ( .NOT.UPPER                ).AND.
     $         ( .NOT.LSAME( UPLO  , 'L' ) )      )THEN
         INFO = 2
      ELSE IF( ( .NOT.LSAME( TRANSA, 'N' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'T' ) ).AND.
     $         ( .NOT.LSAME( TRANSA, 'C' ) )      )THEN
         INFO = 3
      ELSE IF( ( .NOT.LSAME( DIAG  , 'U' ) ).AND.
     $         ( .NOT.LSAME( DIAG  , 'N' ) )      )THEN
         INFO = 4
      ELSE IF( M  .LT.0               )THEN
         INFO = 5
      ELSE IF( N  .LT.0               )THEN
         INFO = 6
      ELSE IF( LDA.LT.MAX( 1, NROWA ) )THEN
         INFO = 9
      ELSE IF( LDB.LT.MAX( 1, M     ) )THEN
         INFO = 11
      END IF
      IF( INFO.NE.0 )THEN
         CALL XERBLA( 'DTRSM ', INFO )
         RETURN
      END IF
*
*     Quick return if possible.
*
      IF( N.EQ.0 )
     $   RETURN
*
*     And when  alpha.eq.zero.
*
      IF( ALPHA.EQ.ZERO )THEN
         do J = 1, N
            do I = 1, M
               B( I, J ) = ZERO
            end do
         end do
         RETURN
      END IF
*
*     Start the operations.
*
      IF( LSIDE )THEN
         IF( LSAME( TRANSA, 'N' ) )THEN
*
*           Form  B := alpha*inv( A )*B.
*
            IF( UPPER )THEN
               do J = 1, N
                  IF( ALPHA.NE.ONE )THEN
                     do I = 1, M
                        B( I, J ) = ALPHA*B( I, J )
                     end do
                  END IF
                  do K = M, 1, -1
                     IF( B( K, J ).NE.ZERO )THEN
                        IF( NOUNIT )
     $                     B( K, J ) = B( K, J )/A( K, K )
                        do I = 1, K - 1
                           B( I, J ) = B( I, J ) - B( K, J )*A( I, K )
                        end do
                     END IF
                  end do
               end do
            ELSE
               do J = 1, N
                  IF( ALPHA.NE.ONE )THEN
                     do I = 1, M
                        B( I, J ) = ALPHA*B( I, J )
                     end do
                  END IF
                  do K = 1, M
                     IF( B( K, J ).NE.ZERO )THEN
                        IF( NOUNIT )
     $                     B( K, J ) = B( K, J )/A( K, K )
                        do I = K + 1, M
                           B( I, J ) = B( I, J ) - B( K, J )*A( I, K )
                        end do
                     END IF
                  end do
               end do
            END IF
         ELSE
*
*           Form  B := alpha*inv( A' )*B.
*
            IF( UPPER )THEN
               do J = 1, N
                  do I = 1, M
                     TEMP = ALPHA*B( I, J )
                     do K = 1, I - 1
                        TEMP = TEMP - A( K, I )*B( K, J )
                     end do
                     IF( NOUNIT )
     $                  TEMP = TEMP/A( I, I )
                     B( I, J ) = TEMP
                  end do
               end do
            ELSE
               do J = 1, N
                  do I = M, 1, -1
                     TEMP = ALPHA*B( I, J )
                     do K = I + 1, M
                        TEMP = TEMP - A( K, I )*B( K, J )
                     end do
                     IF( NOUNIT )
     $                  TEMP = TEMP/A( I, I )
                     B( I, J ) = TEMP
                  end do
               end do
            END IF
         END IF
      ELSE
         IF( LSAME( TRANSA, 'N' ) )THEN
*
*           Form  B := alpha*B*inv( A ).
*
            IF( UPPER )THEN
               do J = 1, N
                  IF( ALPHA.NE.ONE )THEN
                     do I = 1, M
                        B( I, J ) = ALPHA*B( I, J )
                     end do
                  END IF
                  do K = 1, J - 1
                     IF( A( K, J ).NE.ZERO )THEN
                        do I = 1, M
                           B( I, J ) = B( I, J ) - A( K, J )*B( I, K )
                        end do
                     END IF
                  end do
                  IF( NOUNIT )THEN
                     TEMP = ONE/A( J, J )
                     do I = 1, M
                        B( I, J ) = TEMP*B( I, J )
                     end do
                  END IF
               end do
            ELSE
               do J = N, 1, -1
                  IF( ALPHA.NE.ONE )THEN
                     do I = 1, M
                        B( I, J ) = ALPHA*B( I, J )
                     end do
                  END IF
                  do K = J + 1, N
                     IF( A( K, J ).NE.ZERO )THEN
                        do I = 1, M
                           B( I, J ) = B( I, J ) - A( K, J )*B( I, K )
                        end do
                     END IF
                  end do
                  IF( NOUNIT )THEN
                     TEMP = ONE/A( J, J )
                     do I = 1, M
                       B( I, J ) = TEMP*B( I, J )
                     end do
                  END IF
               end do
            END IF
         ELSE
*
*           Form  B := alpha*B*inv( A' ).
*
            IF( UPPER )THEN
               do K = N, 1, -1
                  IF( NOUNIT )THEN
                     TEMP = ONE/A( K, K )
                     do I = 1, M
                        B( I, K ) = TEMP*B( I, K )
                     end do
                  END IF
                  do J = 1, K - 1
                     IF( A( J, K ).NE.ZERO )THEN
                        TEMP = A( J, K )
                        do I = 1, M
                           B( I, J ) = B( I, J ) - TEMP*B( I, K )
                        end do
                     END IF
                  end do
                  IF( ALPHA.NE.ONE )THEN
                     do I = 1, M
                        B( I, K ) = ALPHA*B( I, K )
                     end do
                  END IF
               end do
            ELSE
               do K = 1, N
                  IF( NOUNIT )THEN
                     TEMP = ONE/A( K, K )
                     do I = 1, M
                        B( I, K ) = TEMP*B( I, K )
                     end do
                  END IF
                  do J = K + 1, N
                     IF( A( J, K ).NE.ZERO )THEN
                        TEMP = A( J, K )
                        do I = 1, M
                           B( I, J ) = B( I, J ) - TEMP*B( I, K )
                        end do
                     END IF
                  end do
                  IF( ALPHA.NE.ONE )THEN
                     do I = 1, M
                        B( I, K ) = ALPHA*B( I, K )
                     end do
                  END IF
               end do
            END IF
         END IF
      END IF
*
      RETURN
*
*     End of DTRSM .
*
      END
      integer function IDAMAX(n,dx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dmax
      integer i,incx,ix,n
c
      IDAMAX = 0
      if( n.lt.1 .or. incx.le.0 ) return
      IDAMAX = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      dmax = dabs(dx(1))
      ix = ix + incx
      do i = 2,n
*        if(dabs(dx(ix)).le.dmax) go to 5
         if(dabs(dx(ix)).gt.dmax) then
           IDAMAX = i
           dmax = dabs(dx(ix))
         endif
         ix = ix + incx
      end do
      return
c
c        code for increment equal to 1
c
   20 dmax = dabs(dx(1))
      do i = 2,n
*        if(dabs(dx(i)).le.dmax) go to 30
         if(dabs(dx(i)).gt.dmax) then
           IDAMAX = i
           dmax = dabs(dx(i))
         endif
      end do
      return
      end
      INTEGER FUNCTION ILAENV( ISPEC, NAME, OPTS, N1, N2, N3,
     $                 N4 )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER*( * )    NAME, OPTS
      INTEGER            ISPEC, N1, N2, N3, N4
*     ..
*
*  Purpose
*  =======
*
*  ILAENV is called from the LAPACK routines to choose problem-dependent
*  parameters for the local environment.  See ISPEC for a description of
*  the parameters.
*
*  This version provides a set of parameters which should give good,
*  but not optimal, performance on many of the currently available
*  computers.  Users are encouraged to modify this subroutine to set
*  the tuning parameters for their particular machine using the option
*  and problem size information in the arguments.
*
*  This routine will not function correctly if it is converted to all
*  lower case.  Converting it to all upper case is allowed.
*
*  Arguments
*  =========
*
*  ISPEC   (input) INTEGER
*          Specifies the parameter to be returned as the value of
*          ILAENV.
*          = 1: the optimal blocksize; if this value is 1, an unblocked
*               algorithm will give the best performance.
*          = 2: the minimum block size for which the block routine
*               should be used; if the usable block size is less than
*               this value, an unblocked routine should be used.
*          = 3: the crossover point (in a block routine, for N less
*               than this value, an unblocked routine should be used)
*          = 4: the number of shifts, used in the nonsymmetric
*               eigenvalue routines
*          = 5: the minimum column dimension for blocking to be used;
*               rectangular blocks must have dimension at least k by m,
*               where k is given by ILAENV(2,...) and m by ILAENV(5,...)
*          = 6: the crossover point for the SVD (when reducing an m by n
*               matrix to bidiagonal form, if max(m,n)/min(m,n) exceeds
*               this value, a QR factorization is used first to reduce
*               the matrix to a triangular form.)
*          = 7: the number of processors
*          = 8: the crossover point for the multishift QR and QZ methods
*               for nonsymmetric eigenvalue problems.
*
*  NAME    (input) CHARACTER*(*)
*          The name of the calling subroutine, in either upper case or
*          lower case.
*
*  OPTS    (input) CHARACTER*(*)
*          The character options to the subroutine NAME, concatenated
*          into a single character string.  For example, UPLO = 'U',
*          TRANS = 'T', and DIAG = 'N' for a triangular routine would
*          be specified as OPTS = 'UTN'.
*
*  N1      (input) INTEGER
*  N2      (input) INTEGER
*  N3      (input) INTEGER
*  N4      (input) INTEGER
*          Problem dimensions for the subroutine NAME; these may not all
*          be required.
*
* (ILAENV) (output) INTEGER
*          >= 0: the value of the parameter specified by ISPEC
*          < 0:  if ILAENV = -k, the k-th argument had an illegal value.
*
*  Further Details
*  ===============
*
*  The following conventions have been used when calling ILAENV from the
*  LAPACK routines:
*  1)  OPTS is a concatenation of all of the character options to
*      subroutine NAME, in the same order that they appear in the
*      argument list for NAME, even if they are not used in determining
*      the value of the parameter specified by ISPEC.
*  2)  The problem dimensions N1, N2, N3, N4 are specified in the order
*      that they appear in the argument list for NAME.  N1 is used
*      first, N2 second, and so on, and unused problem dimensions are
*      passed a value of -1.
*  3)  The parameter value returned by ILAENV is checked for validity in
*      the calling subroutine.  For example, ILAENV is used to retrieve
*      the optimal blocksize for STRTRI as follows:
*
*      NB = ILAENV( 1, 'STRTRI', UPLO // DIAG, N, -1, -1, -1 )
*      IF( NB.LE.1 ) NB = MAX( 1, N )
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            CNAME, SNAME
      CHARACTER*1        C1
      CHARACTER*2        C2, C4
      CHARACTER*3        C3
      CHARACTER*6        SUBNAM
      INTEGER            I, IC, IZ, NB, NBMIN, NX
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CHAR, ICHAR, INT, MIN, REAL
*     ..
*     .. Executable Statements ..
*
      GO TO ( 100, 100, 100, 400, 500, 600, 700, 800 ) ISPEC
*
*     Invalid value for ISPEC
*
      ILAENV = -1
      RETURN
*
  100 CONTINUE
*
*     Convert NAME to upper case if the first character is lower case.
*
      ILAENV = 1
      SUBNAM = NAME
      IC = ICHAR( SUBNAM( 1:1 ) )
      IZ = ICHAR( 'Z' )
      IF( IZ.EQ.90 .OR. IZ.EQ.122 ) THEN
*
*        ASCII character set
*
         IF( IC.GE.97 .AND. IC.LE.122 ) THEN
            SUBNAM( 1:1 ) = CHAR( IC-32 )
            do I = 2, 6
               IC = ICHAR( SUBNAM( I:I ) )
               IF( IC.GE.97 .AND. IC.LE.122 )
     $            SUBNAM( I:I ) = CHAR( IC-32 )
            end do
         END IF
*
      ELSE IF( IZ.EQ.233 .OR. IZ.EQ.169 ) THEN
*
*        EBCDIC character set
*
         IF( ( IC.GE.129 .AND. IC.LE.137 ) .OR.
     $       ( IC.GE.145 .AND. IC.LE.153 ) .OR.
     $       ( IC.GE.162 .AND. IC.LE.169 ) ) THEN
            SUBNAM( 1:1 ) = CHAR( IC+64 )
            do I = 2, 6
               IC = ICHAR( SUBNAM( I:I ) )
               IF( ( IC.GE.129 .AND. IC.LE.137 ) .OR.
     $             ( IC.GE.145 .AND. IC.LE.153 ) .OR.
     $             ( IC.GE.162 .AND. IC.LE.169 ) )
     $            SUBNAM( I:I ) = CHAR( IC+64 )
            end do
         END IF
*
      ELSE IF( IZ.EQ.218 .OR. IZ.EQ.250 ) THEN
*
*        Prime machines:  ASCII+128
*
         IF( IC.GE.225 .AND. IC.LE.250 ) THEN
            SUBNAM( 1:1 ) = CHAR( IC-32 )
            do I = 2, 6
               IC = ICHAR( SUBNAM( I:I ) )
               IF( IC.GE.225 .AND. IC.LE.250 )
     $            SUBNAM( I:I ) = CHAR( IC-32 )
            end do
         END IF
      END IF
*
      C1 = SUBNAM( 1:1 )
      SNAME = C1.EQ.'S' .OR. C1.EQ.'D'
      CNAME = C1.EQ.'C' .OR. C1.EQ.'Z'
      IF( .NOT.( CNAME .OR. SNAME ) )
     $   RETURN
      C2 = SUBNAM( 2:3 )
      C3 = SUBNAM( 4:6 )
      C4 = C3( 2:3 )
*
      GO TO ( 110, 200, 300 ) ISPEC
*
  110 CONTINUE
*
*     ISPEC = 1:  block size
*
*     In these examples, separate code is provided for setting NB for
*     real and complex.  We assume that NB will take the same value in
*     single or double precision.
*
      NB = 1
*
      IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         ELSE IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR.
     $            C3.EQ.'QLF' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( C2.EQ.'PO' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         ELSE IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NB = 1
         ELSE IF( SNAME .AND. C3.EQ.'GST' ) THEN
            NB = 64
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            NB = 64
         ELSE IF( C3.EQ.'TRD' ) THEN
            NB = 1
         ELSE IF( C3.EQ.'GST' ) THEN
            NB = 64
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NB = 32
            END IF
         ELSE IF( C3( 1:1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NB = 32
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NB = 32
            END IF
         ELSE IF( C3( 1:1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NB = 32
            END IF
         END IF
      ELSE IF( C2.EQ.'GB' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               IF( N4.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            ELSE
               IF( N4.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            END IF
         END IF
      ELSE IF( C2.EQ.'PB' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               IF( N2.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            ELSE
               IF( N2.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            END IF
         END IF
      ELSE IF( C2.EQ.'TR' ) THEN
         IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( C2.EQ.'LA' ) THEN
         IF( C3.EQ.'UUM' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'ST' ) THEN
         IF( C3.EQ.'EBZ' ) THEN
            NB = 1
         END IF
      END IF
      ILAENV = NB
      RETURN
*
  200 CONTINUE
*
*     ISPEC = 2:  minimum block size
*
      NBMIN = 2
      IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR.
     $       C3.EQ.'QLF' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NBMIN = 8
            ELSE
               NBMIN = 8
            END IF
         ELSE IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NBMIN = 2
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRD' ) THEN
            NBMIN = 2
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NBMIN = 2
            END IF
         ELSE IF( C3( 1:1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NBMIN = 2
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NBMIN = 2
            END IF
         ELSE IF( C3( 1:1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NBMIN = 2
            END IF
         END IF
      END IF
      ILAENV = NBMIN
      RETURN
*
  300 CONTINUE
*
*     ISPEC = 3:  crossover point
*
      NX = 0
      IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR.
     $       C3.EQ.'QLF' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NX = 1
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRD' ) THEN
            NX = 1
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NX = 128
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1:1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR.
     $          C4.EQ.'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR.
     $          C4.EQ.'BR' ) THEN
               NX = 128
            END IF
         END IF
      END IF
      ILAENV = NX
      RETURN
*
  400 CONTINUE
*
*     ISPEC = 4:  number of shifts (used by xHSEQR)
*
      ILAENV = 6
      RETURN
*
  500 CONTINUE
*
*     ISPEC = 5:  minimum column dimension (not used)
*
      ILAENV = 2
      RETURN
*
  600 CONTINUE
*
*     ISPEC = 6:  crossover point for SVD (used by xGELSS and xGESVD)
*
      ILAENV = INT( REAL( MIN( N1, N2 ) )*1.6E0 )
      RETURN
*
  700 CONTINUE
*
*     ISPEC = 7:  number of processors (not used)
*
      ILAENV = 1
      RETURN
*
  800 CONTINUE
*
*     ISPEC = 8:  crossover point for multishift (used by xHSEQR)
*
      ILAENV = 50
      RETURN
*
*     End of ILAENV
*
      END
      LOGICAL          FUNCTION LSAME( CA, CB )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER          CA, CB
*     ..
*
*  Purpose
*  =======
*
*  LSAME returns .TRUE. if CA is the same letter as CB regardless of
*  case.
*
*  Arguments
*  =========
*
*  CA      (input) CHARACTER*1
*  CB      (input) CHARACTER*1
*          CA and CB specify the single characters to be compared.
*
* =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC          ICHAR
*     ..
*     .. Local Scalars ..
      INTEGER            INTA, INTB, ZCODE
*     ..
*     .. Executable Statements ..
*
*     Test if the characters are equal
*
      LSAME = CA.EQ.CB
      IF( LSAME )
     $   RETURN
*
*     Now test for equivalence if both characters are alphabetic.
*
      ZCODE = ICHAR( 'Z' )
*
*     Use 'Z' rather than 'A' so that ASCII can be detected on Prime
*     machines, on which ICHAR returns a value with bit 8 set.
*     ICHAR('A') on Prime machines returns 193 which is the same as
*     ICHAR('A') on an EBCDIC machine.
*
      INTA = ICHAR( CA )
      INTB = ICHAR( CB )
*
      IF( ZCODE.EQ.90 .OR. ZCODE.EQ.122 ) THEN
*
*        ASCII is assumed - ZCODE is the ASCII code of either lower or
*        upper case 'Z'.
*
         IF( INTA.GE.97 .AND. INTA.LE.122 ) INTA = INTA - 32
         IF( INTB.GE.97 .AND. INTB.LE.122 ) INTB = INTB - 32
*
      ELSE IF( ZCODE.EQ.233 .OR. ZCODE.EQ.169 ) THEN
*
*        EBCDIC is assumed - ZCODE is the EBCDIC code of either lower or
*        upper case 'Z'.
*
         IF( INTA.GE.129 .AND. INTA.LE.137 .OR.
     $       INTA.GE.145 .AND. INTA.LE.153 .OR.
     $       INTA.GE.162 .AND. INTA.LE.169 ) INTA = INTA + 64
         IF( INTB.GE.129 .AND. INTB.LE.137 .OR.
     $       INTB.GE.145 .AND. INTB.LE.153 .OR.
     $       INTB.GE.162 .AND. INTB.LE.169 ) INTB = INTB + 64
*
      ELSE IF( ZCODE.EQ.218 .OR. ZCODE.EQ.250 ) THEN
*
*        ASCII is assumed, on Prime machines - ZCODE is the ASCII code
*        plus 128 of either lower or upper case 'Z'.
*
         IF( INTA.GE.225 .AND. INTA.LE.250 ) INTA = INTA - 32
         IF( INTB.GE.225 .AND. INTB.LE.250 ) INTB = INTB - 32
      END IF
      LSAME = INTA.EQ.INTB
*
*     RETURN
*
*     End of LSAME
*
      END
      SUBROUTINE XERBLA( SRNAME, INFO )
*
*  -- LAPACK auxiliary routine (version 2.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     September 30, 1994
*
*     .. Scalar Arguments ..
      CHARACTER*6        SRNAME
      INTEGER            INFO
*     ..
*
*  Purpose
*  =======
*
*  XERBLA  is an error handler for the LAPACK routines.
*  It is called by an LAPACK routine if an input parameter has an
*  invalid value.  A message is printed and execution stops.
*
*  Installers may consider modifying the STOP statement in order to
*  call system-specific exception-handling facilities.
*
*  Arguments
*  =========
*
*  SRNAME  (input) CHARACTER*6
*          The name of the routine which called XERBLA.
*
*  INFO    (input) INTEGER
*          The position of the invalid parameter in the parameter list
*          of the calling routine.
*
* =====================================================================
*
*     .. Executable Statements ..
*
      write(*,'('' ** On entry to '',A6,'' parameter number '',I2,
     1'' had an illegal value'')')srname, info
*
      stop
*
*     >>chng 97 jan 5, get rid of statement number
*9999 FORMAT( ' ** On entry to ', A6, ' parameter number ', I2, ' had ',
*    $      'an illegal value' )
*
*     End of XERBLA
*
      end
******************************************************************************
      subroutine matin1 (a,dim1,n1,n2,nerror)
      implicit none
*matrix inversion routine used throughout the code
*     real determ
*
*     MATRIX INVERSION WITH ACCOMPANYING SOLUTION OF LINEAR EQUATIONS.
*     SOLVES THE MATRIX EQUATION A*X = B FOR THE VECTOR X
*     CALLING SEQUENCE-
*     CALL MATIN1(E,NDIM,N,MDIM,M,NERROR,DETERM)
*
*     parameters
*     A a two dimensional array with ndim as column size,containing
*       the matrix of order n in its first n columns. the matrix of
*       constant5vectors , b, is stored in columns n+1 through n+m of e
*     ndim - first dimension parameter of e as decl red in the c lling
*     program
*     n   - the order of the matrix a - called n1 in declare
*     MDIM  - NOT USED ( USED IN EARLIER VERSIONS  )
*     M - NUMBER OF COLUMN VECTORS IN MATRIX B. ID M = 0, ONLY THE
*     INVERSE OF A AND THE COMPUTATION OF THE DETERMINANT IS CARRIE
*     OUT
*     INDEX- A ONE DIMENSIONAL ARRAY CONTAINING N LOCATIONS, USED BY
*     MATIN1 FOR BOOK KEEPING. SPACE MUST BE PROVIDED BY THE CALLIN
*     ROUTINE
*     change - index now here, dim=100, so n1 .lt.100
*     NERROR  - OUTPUT PARAMETER WHICH IS SET ON RETURN TO NON ZERO, IF
*     AT ANY ELIMINATION STEP THE CORRESPONDING COLUMN OF A CONTAINED
*     ONLY ZEROES. A PRINTED MESSAGE IS GIVEN ON FILE TAPE2
*     INDICATING THE COLUMN.
*     DETERM - A SINGLE PRECISSION VARIABLE CONTATINIG ON RETURN THE
*     DETERMINANT OF A
*     ON RETURN, E WILL, IF NERROR = 0 CONTAIN THE INVERSE OF A IN
*     ITS FIRST N COLUMNS AND IF M NOT =  0 THE S LUTI N MATRIX IN
*     THE NEXT FOLLOWING  (N+1) TO (N+M) COLUMNS.
*
      double precision deter,swap,pivot
      integer dim1,dim,emat,pivcol,pivcl1,pivcl2
      integer n1,n2,nerror,mn,nmin1,i,lpiv,icol,i3,i2,i1,
     1 jcol,n
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      double precision a(*)
*
      integer dimIndex
      parameter (dimIndex=100)
      integer index(dimIndex)
*     DATA(LGUNIT=2)
*
      deter=1.0
      n=n1
      if( n.gt.dimIndex ) then
        write(qq,'('' matin1 called with dimIndex exceeded'')')
        stop
      endif
      emat=n+n2
      dim=dim1
      nmin1=n-1
*     the routine does its own evaluation for doubLE SUBSCRIPTING OF
*     array a.
      pivcol=1-dim
*     main loop to invert the matrix
      do 11 mn=1,n
      pivot=0.0
      pivcol=pivcol+dim
*     search for next pivot in column main.
      pivcl1=pivcol+mn-1
      pivcl2=pivcol +nmin1
      do 2 i=pivcl1,pivcl2
      if(dabs(a(i))-dabs(pivot)) 2,2,1
    1 pivot=a(i)
      lpiv=i
    2 continue
*     is pivot different from zero
      if(pivot) 3,15,3
*     get the pivot-line indicator and swap lines IF NECESSARY
    3 icol=lpiv-pivcol+1
      index(mn)=icol
      if(icol-mn) 6,6,4
*     complement the determinant
    4 deter=-deter
*     pointer to line pivot found
      icol=icol-dim
*     pointer to exact pivot line
      i3=mn-dim
      do 5 i=1,emat
      icol=icol+dim
      i3=i3+dim
      swap=a(i3)
      a(i3)=a(icol)
    5 a(icol)=swap
*     compute determinant
    6 deter=deter*pivot
      pivot=1.d0/pivot
*     transform pivot column
      i3=pivcol+nmin1
      do 7 i=pivcol,i3
    7 a(i)=-a(i)*pivot
      a(pivcl1)=pivot
*     pivot element transformed
*
*     now convert rest of the matrix
      i1=mn-dim
*     pointer to pivot line elements
      icol=1-dim
*     general column pointer
      do 10 i=1,emat
      icol=icol+dim
      i1=i1+dim
*     pointers moved
      if(i-mn) 8,10,8
*     pivot column excluded
    8 jcol=icol+nmin1
      swap=a(i1)
      i3=pivcol-1
      do 9 i2=icol,jcol
      i3=i3+1
    9 a(i2)=a(i2)+swap*a(i3)
      a(i1)=swap*pivot
   10 continue
   11 continue
*     now rearrange the matrix to get right invers
      do 14 i1=1,n
      mn=n+1-i1
      lpiv=index(mn)
      if(lpiv-mn) 12,14,12
   12 icol=(lpiv-1)*dim+1
      jcol=icol+nmin1
      pivcol=(mn-1)*dim+1-icol
        do i2=icol,jcol
          i3=i2+pivcol
          swap=a(i2)
          a(i2)=a(i3)
          a(i3)=swap
        end do
   14 continue
*
*     determ=deter
      nerror=0
      return
*
   15 nerror=-1
*     determ=deter
      return
      end
****************************************************************
      subroutine hypho(zed,n,lmin,lmax,en,ncell,anu,bfnu)
      implicit none
*generate hydrogenic photoionization cross sections
      real zed, en
      integer n,lmin,lmax,ncell
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*     *************************************************************
*          GENERATE HYDROGENIC PHOTOIONIZATION CROSS SECTIONS
*
*     Hypho calculates Hydrogenic bound-free (BF) xsectns for each n,l .
*     For Opacity work we calculate l-weighted average for each n .
*     BF xsectns for Hydorgenic ion are tabulated at E/z**2. E is
*     the energy in Ry corresponding to the frequencies on the Opacity
*     mesh. It can changed accoding to need.
*
* zed=Z-Nelc,
* n=principle quantum number
* lmin=lowest angular momentum considered of level n
* lmx=highest angular momentum considered of level n
* en=zed*zed/(n*n) lowest energy at which the hydrogenic cross sections are
* to be calculated
* anu = photon energy
* bfnu=photoionization cross section in cm^-2
*
*     local variables
      integer nlv, nsl, ntg, ncm , nfreq , i,j,il,if,k,l,
     1 lmax1,ilmax,lg,lin,m,muls,ll,lm,lll,llm,mulr,llk,
     1 mulp
      real zed2,fn,sn4,sn,gl,al,fth,g12,se,e,p,ee,exp1,gne,
     1 con2,ai,gn0,g11,a,gn1e,g22,g32,g21,g31,sl,sm,sm4,
     2 sum,p1,p2,alfac,flm,fll,gnt,sl4
      parameter (nlv=850,nsl=40,ntg=20,ncm=3000)
      real bfnu(ncm) , anu(ncm)
      parameter (nfreq = ncm )
      real g2(nfreq,2),g3(nfreq,2),ab(nfreq),alo(7000),
     cfal(7000),freq(nfreq)
      save g2,g3,ab,alo, fal,freq
      integer mm(nfreq)
      double precision fac , x , con3 , anl
      logical first
* CON1=conversion factor from a0**2 to Mb, x-sectns in megabarns
*     CON1=8.5594e-19 *  1.e+18
      real zero,one,two,four,ten,con1
      data first /.true./
      data zero/0./ , one/1./ , two/2./,four/4./,ten/10./,
     1 con1/0.8559/
*
      if( ncell.gt.ncm ) then
        write(qq,'('' increase ncm in hypho to at least'',i5)') ncell
        stop
      endif
*
      if( first ) then
        fal(1) = zero
        do i=2,7000
          ai = float(i - 1)
          alo(i-1) = log10(ai)
          fal(i) = alo(i-1) + fal(i-1)
        end do
        first = .false.
      endif
C
C          CALCULATION OF HYDROGENIC PHOTOIONIZATION CROSS SECTION
C
C         INITIALIZATION FOR N
C * con2=(a0**2*1.e+18)*(n/zed)**2, zed=z-nelc
c * for hydrogen, the threshold, fth=1/n**2, and for hydrogenic atom,it is
c zed**2/n**2.
              zed2 = zed * zed
      fn =float(n)
      sn = fn*fn
      sn4 = four*sn
      con2=con1*(fn/zed)**2
      fth=one/sn
c
      gn0=2.3052328943  -2.302585093  *fal(n+n)-fn*0.61370563888  +
     .alo(n)*(fn+one)*2.30258093
      lmax1=min(lmax,n-1)
      ilmax=n-lmin
c * calculate top-up st.wt for given n and lmin=lmax+1 (R-matrix). subtract
c the sum from 2n**2.
      gl = 0.
      if (lmin .ne. 0) then
        do i = 1, lmin
          lg = i - 1
          gl = gl + 2. * lg + 1
        end do
      endif
      gnt = 2. * ( n*n - gl )
C define photon energies epnu corresponding to hydrogenic atom with charge
c z and freq to hydrogen atom;  INITIALIZE G'S
      do i=1,ncell
        mm(i) = 0
        bfnu(i) = zero
        freq(i)=anu(i)*zed2
        do j=1,2
          g2(i,j) = zero
          g3(i,j) = zero
        end do
      end do
*     gjf Aug 95 change
*     original code returned total &(*(*$# if freq(1)<en
      freq(1) = max( freq(1) , en )
c
C calculate cross section:  L LOOP
c
       do 21 il = 1, ilmax
           l = n - il
           lin=l-lmin+1
           m=0
           al = float(l)
           k = n - l - 2
           con3=con2/(two*al+one)
c
C          FREQUENCY LOOP (FREQ UNITS ARE RYD*ZED**2)
C
           do 51 if = 1, ncell
             if(freq(if).lt.fth) then
                if(l.le.lmax1) anl=0.
                go to 51
             endif
              g11 = zero
              g12 = zero
                m=m+1
                se=freq(if)-fth
            if (se.lt.0.) write(8,'(1x,i4,1p2e12.4)')if,freq(if),fth
c            if ( se .lt. -1.e-30) se = 1.e-06
                e=sqrt(se)
                x=one+sn*se
            if ( k .lt. 0 ) then
                     if (e.ge.0.314  ) then
                          ee=6.2831853  /e
                          p=0.5  *alog10(exp1(-ee))
                     else
                          p = zero
                     endif
                     if(e.gt.1.0E-6) then
                          a=two*(fn-atan(fn*e)/e)
                     else
                          a=zero
                     endif
                     ab(m)=(gn0+a)/2.302585  -p-(fn+two)*log10(x)
                     gne = 0.1
                     gn1e = x*gne/(fn + fn)
                     g3(m,2) = gne
                     g3(m,1) = gn1e
                     g2(m,2) = gne*fn*x*(fn+fn-one)
                     g2(m,1) = gn1e*(fn+fn-one)*(four+(fn-one)*x)
            endif
                g22 = g2(m,2)
                g32 = g3(m,2)
                g21 = g2(m,1)
                g31 = g3(m,1)
                muls = mm(m)
                if(k)20,30,25
C
C                     l.lt.n-2
C
25              if(k.gt.1) go to 28
                ll = n - 1
                lm = n - 2
28              sl = float(ll*ll)
                sl4 = four*sl
                fll = float(ll)
                g12 = (sn4 - sl4 + (two*sl - fll)*x)*g22 -
     .          sn4*(sn - sl)*(one + (fll + one)**2*se)*g32
                if (l.eq.0) go to 12
                sm = float(lm*lm)
                sm4 = four*sm
                flm = float(lm)
                g11 = (sn4 - sm4 + (two*sm + flm)*x)*g21 -
     .          sn4*(sn - (flm + one)**2)*(one + sm*se)*g31
                g31 = g21
                g21 = g11
12              g32 = g22
                g22 = g12
c
                    if ( m .ne. ncell ) go to 31
                         ll = ll - 1
                    if ( l .eq. 0 ) go to 31
                         lm = lm - 1
  31                continue
c
                if (g12.lt.1.E20) go to 40
                muls = muls + 35
                g22 = g22*1.E-35
                g32 = g32*1.E-35
                g12 = g12*1.E-35
                if (l.eq.0) go to 40
                g11 = g11*1.E-35
                g21 = g21*1.E-35
                g31 = g31*1.E-35
                go to 40
C
c                    l.eq.n-1
c
20              g11 = g31
                if (l.eq.0) g11 = zero
                g12 = g32
                go to 40
C
C                    l.eq.n-2
C
30              g11 = g21
                if (l.eq.0) g11 = zero
                g12 = g22
40              continue
                mm(m) = muls
                g2(m,2) = g22
                g3(m,2) = g32
                g2(m,1) = g21
                g3(m,1) = g31
                alfac = fal(n+l+1) - fal(n-l) + two*(al-fn)*alo(2*n)
                p1 = one
                lll = l + 1
                llm = l - 1
                mulr = 0
                if (llm.lt.1) go to 46
                do  1985 i = 1,llm
                     ai = float(i)
                     p1 = p1*(one + ai*ai*se)
                     if (p1.ge.1.E20) then
                          p1 = p1*1.E-10
                          mulr = mulr + 10
                     endif
 1985            continue
46              p2 = p1
                llk = llm + 1
                if (llk.lt.1) llk = 1
                do i = llk,lll
                     ai = float(i)
                     p2 = p2*(one + ai*ai*se)
                end do
                mulp = 0
17             if (g12.lt.one) go to 117
               mulp = mulp - 10
               g12 = g12*1.E-10
               if (l.eq.0) go to 17
               g11 = g11*1.E-10
               go to 17
117            sum=alfac+float(mulr)+two*(ab(m)+float(muls-mulp+1))
               fac = zero
*     >>chng 96apr19, 35 had been 50
               if(abs(sum).lt.35.  ) fac=ten**sum
               if (l.eq.0) go to 18
               g11 = g11*p1*g11
18             g12 = g12*p2*g12
C               anl=con3*(g11 *al + g12 *(al+one))
C    .         *x*fac
               if(l.le.lmax1)anl=fac*x*con3*(g11*al+g12*(al+1.))
                    anl = anl * 2. * (2.* al + 1. )
c
           bfnu(if) = bfnu(if) + anl*1e-18
c
  51        continue
c
  21       continue
c
c              bfmin = 1.e-03 * bfnu(1) / gnt
            do 61 i = 1, ncell
  61        bfnu(i) = bfnu(i) / gnt
c
      end
******************************************************************************
      subroutine sulphr
      implicit none
*compute ionization balance for sulphur
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real hi , hii
      common/h/ hi , hii
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real CTHeavy
*this is the charge ionizaiton, recom array
*that goes into the ionization balance
*(ion,1) is ionization, (ion,2) is recombination
*it has all charge transfer rates EXCEPT those for hydrogen
*those are in HCharExcIon and HCharExcRec
      common/chargt/ CTHeavy(limelm,2)
      real te , eden , hden
      common/phycon/ te , eden , hden
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (ndim=17)
      parameter (nelem=16)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     REAL GRDEFF(16)  , yYIELD(14) , yYIELDL(6)
*     real CollidRate(nelem,2)
*
*     DATA GRDEFF/16*0.2/ , yYIELD/14*0./ , yYIELDL/6*0./
*
*     sulphur nelem=16
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.45E-10,7.11E-11,2.12E-11,6.39E-12,6.43E-12,1.85E-12,
     1 1.71E-12,1.01E-12,6.97E-13,4.75E-13,2.90E-13,1.63E-13,1.04E-13,
     2 4.42E-14,4.25E-15,1.81E-15/
      data (cion(i,2),i=1,ndim-1)
     1 /1.20E5,2.71E5,4.06E5,5.49E5,8.47E5,1.02E6,3.26E6,3.81E6,
     2 4.40E6,5.19E6,5.86E6,6.55E6,7.56E6,8.02E6,3.74E7,4.05E7/
*
      data aa/16*0./,bb/16*0./,cc/16*0./,dd/16*0./,ff/16*0./
*
*     rec from +13 14 15 from Arnauld et al 85
      data rec , pl
     1/1.54E-10 , 13.4E-10 , 3.37E-9 , 7.36E-9 , 7.64E-9 , 4.23E-8 ,
     2 2.31E-8  , 2.43E-8  , 3.84E-8 , 5.41E-8 , 6.60E-8 , 1.47E-7 ,
     2 3.35E-7  , 6.67E-7  , 7.27E-7 ,
     3 -0.63    , -0.686   , -0.745  , -0.755  , -0.701  , -0.849  ,
     3 -0.733   , -0.696   , -0.711  , -0.716  , -0.714  , -0.755  ,
     3 -0.806   , -0.840   , -0.807  /
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.23e-10 , -0.593 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/1.62E-3, 1.09E-2, 3.35E-2, 3.14E-2, 1.27E-2, 1.47E-2, 1.34E-2,
     2 2.38E-2, 3.19E-2, 7.13E-2, .08, .0796, .0134, .402, .241, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/0., 1.20E-2, 6.59E-2, 6.89E-2, .187, .129, 1.04, 1.12, 1.40,
     2 1.00, .555, 1.63, .304, .298, .281, 0./
      data (dite(i,1),i=1,ndim-1)
     1/1.25E+5, 1.92E+5, 1.89E+5, 1.68E+5, 1.38E+5, 1.80E+6, 6.90E+5,
     2 5.84E+5, 5.17E+5, 6.66E+5, 6.00E+5, 5.09E+5, 2.91E+5, 2.41E+7,
     3 2.54e+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/0., 1.80E+4, 1.59E+5, 8.04E+4, 1.71E+5, 1.75E+6, 2.15E+6,
     1 2.59E+6, 2.91E+6, 2.32E+6, 2.41E+6, 6.37E+6, 1.04E+6, 4.67E+6,
     2 5.30E+6, 0./
      data ditcrt
     3/2.2E4  , 1.2E4  , 1.4E4  , 1.5E4  , 1.4E4  , 2.9E5  , 1.3E5
     3,1.1E5  , 9.0E4  , 9.0E4  , 9.0E4  , 8.3E4  , 6.0E4  , 5.0E6
     3,9.0E6  , 1E20  /
*
*     sulphur, atomic number 16
      if( .not.lgElmtOn(16) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
*     charge exchange, all rates from Butler+Dalgarno 1980B
*     S+2 => S+
*     >>chng 96 Oct 1, moved all H ct to bidiag
*     CTHeavy(2,2) = CTHeavy(2,2) + 1E-14 * HI
*     S+3 => S+2
*     CTHeavy(3,2) = CTHeavy(3,2) + 2.5E-9 * HI + HEI*SQRTE * 1.1E-11
      CTHeavy(3,2) = CTHeavy(3,2) + hei*sqrte * 1.1e-11
*     S+4 => S+3
*     CTHeavy(4,2) = CTHeavy(4,2) + 7.5E-9 * HI
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine SumContinuum
      implicit none
*sum flux, otscon, otslin, outcon, outlin, to form SummeDif, SummedCon SummedOcc
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
*
*     local variables
      integer i
*
      do i=1,nflux
        SummedDif(i) = otscon(i)+otslin(i)+outcon(i)+outlin(i)
        SummedCon(i) = flux(i)+SummedDif(i)
        SummedOcc(i) = SummedCon(i) * convoc(i)
      end do
*
      end
******************************************************************************
      subroutine SumCool(total)
      implicit none
*evaluate total cooling from all entries into cooling stack
      real total
*
      integer ncolnt
      parameter (ncolnt=10 000)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real CoolHeatMax
      character*4 chCoolHeatMax
*     max of negative coolants, and a pointer to it
      integer ipCoolHeatMax
      common/CHMax/ CoolHeatMax , ipCoolHeatMax , chCoolHeatMax
      character chClntLab*4
*     remember strongest coolants
      common/collab/ chClntLab(ncolnt)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
*
*     routine to add together all line heating and cooling
*
      total = 0.
      coolheat = 0.
*     this is sum of agents that should be coolants
*     coolheat will be coolants that came out as heat
      do i=1,ncltot
        total = total + cooling(i)
        coolheat = coolheat + heatnt(i)
      end do
      heating(1,13) = coolheat
*
*     make comment if negative cooling ever significant
      if( htot.gt.0. ) then
        if( coolheat/htot.gt.0.01 ) then
*         CoolHeatMax was set to zero at start of calc, we want very biggest
          do i=1,ncltot
            if( heatnt(i)/htot.gt.CoolHeatMax) then
              CoolHeatMax = heatnt(i) / htot
              ipCoolHeatMax = collam(i)
              chCoolHeatMax = chClntLab(i)
            endif
          end do
        endif
      endif
*
*     this sum of lines that were heat sources - this
*     part was not counted as heating in call to cooling add routine
*     since level 2 and level 3 separate this out - this does
*     NOT double count line heating
      heatl = 0.
      do i=1,NWINDLINE
        heatl = heatl + WindLine(ipLnHeat,i)
      end do
      do i=1,nTauLines
        heatl = heatl + TauLines(ipLnHeat,i)
      end do
*
*     line heating added in following, only here
      heating(1,23) = heatl
*
*begin sanity check
      if( total.le.0. ) then
        write(qq,'('' SumCool finds cooling <= 0'',1p,e10.2)') total
      endif
      if( heatl/ctot.lt.-1e-15 ) then
        write(qq,'('' SumCool finds negative heating'',1p,2e10.2)')
     1  heatl,ctot
*       write(qq,'('' dump went to fort.66'')')
*       write(66,'(1p,12e10.1)') (heatnt(i),i=1,ncltot)
      endif
*end sanity check
*
      end
******************************************************************************
      subroutine SumHeat
      implicit none
*evaluate all heating agents to determine total heating for this zone
      integer limelm
      parameter (limelm=30)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer ncolnt
      parameter (ncolnt=10 000)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
      logical lgHeatBug
*flag set by trace heating command
      common/heatbg/ lgHeatBug
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      integer collam,ncltot
      real cooling , heatnt
*     these save arrays of line heating and cooling
*     coladd is called by n level cooling routines, and coladd
*     fills in cooling (cooling) or heating (heatnt)
*     heatnt is always positive, although it is negative cooling
      common/coolnt/ collam(ncolnt) , cooling(ncolnt), heatnt(ncolnt),
     1 ncltot
      logical lgHColRec , lgHCoolng
      common/HColRec/ lgHColRec , lgHCoolng
      real te , eden , hden
      common/phycon/ te , eden , hden
      real HLineTotCool , dHLTot
*HLineTotCool is total hydrogen line cooling or heating, set in hydrocool
*dHLTot is the derivative, set in sumheat
      common/HLineTot/ HLineTotCool , dHLTot
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgNumDeriv
      common/NumDeriv/ lgNumDeriv
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      real fcool , dfcool , feheat
*     cooling computed by Katya's FeII model atom
*     fcool is total cooling (or heating if negative)
*     and dfcool is its derivative
*     holod is Russian for cold
      common/holod/ fcool , dfcool , feheat
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real trigger
      parameter (trigger=0.02)
      real save(20)
      integer ipsave(20),jpsave(20)
*
      integer i , j , ipnt
      real TotalHeat , oldfac , oldheat , oldtemp,deriv
      integer nzSave , nhit
      save nzSave , oldheat , oldtemp , nhit
*
*     routine to sum up total heating, and print agents if needed
*     it also computes the true deriv, dH/dT
*
*     get total heating
      TotalHeat = 0.
      do i=1,limelm
        do j=1,limelm
          TotalHeat = TotalHeat + heating(i,j)
        end do
      end do
      htot = TotalHeat
*
*     check whether Lya heating is important
*     if so then only very small temp changes can be made
      if( heating(1,11)/htot.gt. 0.15 ) then
        lgHCoolng = .true.
      else
        lgHCoolng = .false.
      endif
*
*     add on line heating to this array, heatl was evaluated in sumcool
*     not zero, because of roundoff error
      if( heatl/ctot .lt.-1e-15 ) then
        write(qq,'('' SumHeat gets negative line heating,'',1p,2e10.2,
     1  '' this is insane.'')') heatl,ctot
        write(qq,'('' this is zone'',i4)') nzone
        call ShowMe
        stop
      endif
*
*     now get deriv
      dHTotDT = 0.
*     photoionization of all elements
      do i=1,limelm
*     >>chng 97 mar 18, counter had gone to i-1
*       do j=1,i-1
        do j=1,i
          dHTotDT = dHTotDT + heating(i,j)
        end do
      end do
*     this is deriv of photo heating -
*     >>chng 96 jan 14
*>>>>>NB heating going down with iincreasing temp is negative
      dHTotDT = -0.7 *dHTotDT/ te
*
*     oldfac was factor used in old implimentation
*     any term using it should be rethought
      oldfac = -0.7 / te
*     carbon monoxide
      dHTotDT = dHTotDT + heating(1,10) * oldfac
*     ly alpha collisoinal heating
      dHTotDT = dHTotDT + heating(1,11) * oldfac
*     line heating
      dHTotDT = dHTotDT + heating(1,23) * oldfac
*     free free heating, propto T^-0.5
*     >>chng 96 oct 30, from heating(1,12) to FreeFreeHeat,
*     do cooling separately assume FreeFreeHeat goes as T^-3/2
*     dHTotDT = dHTotDT + heating(1,12) * (-0.5/te)
      dHTotDT = dHTotDT + FreeFreeHeat * (-1.5/te)
*     grain heating by photo
*     >>chng 97 july 2, change deriv in following, better fit to what came out
      dHTotDT = dHTotDT + heating(1,14) * 0.1 / te
*     grain heating by collsional
      dHTotDT = dHTotDT + heating(1,15) * oldfac
*     helium triplets heating
      dHTotDT = dHTotDT + heating(2,3) * oldfac
*     hydrogen molecule dissociation
      dHTotDT = dHTotDT + heating(1,18) * oldfac
*     >>chng 96 nov 15, had been oldfac below, wrong sign
*     H- heating, goes up with temp since rad assoc does
      dHTotDT = dHTotDT + heating(1,16) * 0.7/te
*     H2+ heating
      dHTotDT = dHTotDT + heating(1,17) * oldfac
*     Balmer continuum and all other excited states
*     - T goes up so does pop and heating
*     but this all screwed up by change in eden
      dHTotDT = dHTotDT + heating(1,2) * oldfac
*     all three body heating, opposite of coll ion cooling
      dHTotDT = dHTotDT + heating(1,4) * oldfac
*     bound electron recoil heating
      dHTotDT = dHTotDT + heating(1,19) * oldfac
*     compton heating
      dHTotDT = dHTotDT + heating(1,20) * oldfac
*     extra heating source, usually zero
      dHTotDT = dHTotDT + heating(1,21) * oldfac
*     pair production
      dHTotDT = dHTotDT + heating(1,22) * oldfac
*     deriv of heating due to collisions of H lines, heating(1,24)
      dHTotDT = dHTotDT + dHLTot
*     heating due to Katya's FeII atom
      if( heating(26,28).gt.0. ) then
        dHTotDT = dHTotDT + dfcool
      endif
*
*     possibility of getting emperical heating derivative
*     normally false, set true with 'set numerical derivatives' command
      if( lgNumDeriv ) then
        if( nzone.gt.2 .and. nzone.eq.nzSave .and. oldtemp.ne.te
     1  .and.nhit.gt.4) then
*         hnit is number of trys on this zone - use to stop numerical problems
*         do not evaluate numerical deriv until well into solution
          deriv = (oldheat - htot)/(oldtemp-te)
          dHTotDT = deriv
        else
          deriv = dHTotDT
        endif
*       this happens when new zone starts
        if(nzone.ne.nzSave) nhit = 0
        nzSave = nzone
        nhit = nhit + 1
        oldheat = htot
        oldtemp = te
      endif
*
      if( lgTrace.and.lgHeatBug ) then
        ipnt = 0
        do i=1,limelm
          do j=1,limelm
            if( heating(i,j)/htot.gt.trigger ) then
              ipnt = min( 20 , ipnt + 1 )
              ipsave(ipnt) = i
              jpsave(ipnt) = j
              save(ipnt) = heating(i,j) / htot
            endif
          end do
        end do
*
*       now check for possible line heating not counted in 1,23
*       there should not be any significant heating source heree
*       since they would not be counted in deriv correctly
        do i=1,ncltot
          if( heatnt(i)/htot.gt.trigger) then
            ipnt = min( 20 , ipnt + 1 )
            ipsave(ipnt) = -1
            jpsave(ipnt) = i
            save(ipnt) = heatnt(i) / htot
          endif
        end do
*
*       write(qq,'('' heat fe2'',1p,8e10.2)')fcool,dfcool,heating(26,28)
        write(qq,'(5x,''SumHeat HTOT'',1P,E10.3,'' Te:'',e10.3,
     1 '' dH/dT'',e9.2,2X,0P,6(2I3,F6.3))')
     1  htot,te,dHTotDT,(ipsave(i),jpsave(i),save(i),i=1,min(6,ipnt))
        if( ipnt.gt.6 ) then
          write(qq,'(31x,7(2i4,f6.3))') (ipsave(i),jpsave(i),save(i),
     1    i=7,ipnt)
        endif
      endif
*
      end
******************************************************************************
      real function tababun ( r0 , depth , iel)
      implicit none
*interpolate on table of points to do 'element table' command,
*based on code by K Volk
*each line is log radius and abundance.
      double precision r0 , depth
*     atomic number
      integer iel
      integer limTabD
      parameter (limTabD=500)
      integer limelm
      parameter (limelm=30)
      real AbTabFac(limelm,limTabD) , AbTabRad(limelm,limTabD)
      integer nAbunTabl
*AbTabFac abundances for element table
*AbTabRad depth scale
      common/AbunTablFac/ AbTabFac , AbTabRad , nAbunTabl
      logical lgAbunTabl(limelm) , lgAbTaDepth(limelm),lgAbTaON
*lgAbunTabl says whether this element is to have its abundance
*determined from a table (true) or stored constant (false)
*set true with element table command
*lgAbTaDepth says whether depth or radius, true is depth
      common/AbunTablLG/ lgAbunTabl , lgAbTaDepth,lgAbTaON
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer j
      logical lgHit
      real x,frac
*     write(6,*)'tababun called with n=',nAbunTabl
*     stop
*
*     interpolate on radius or depth?
      if( lgAbTaDepth(iel) ) then
*       depth key appeared = we want depth
        x = log10( depth )
      else
*       use radius
        x = log10( r0 )
      endif
*
      if( x.lt.AbTabRad(iel,1).or.x.ge.AbTabRad(iel,nAbunTabl) ) then
        write(qq,'('' requested radius outside range of tababun'')')
        write(qq,'('' radius was'',1p,e10.2,'' min, max='',2e10.2)')
     1  x,AbTabRad(iel,1),AbTabRad(iel,nAbunTabl)
        stop
      else
        lgHit = .false.
        j = 1
*       do j=1,nAbunTabl-1
        do while( .not.lgHit .and. j.le.nAbunTabl-1 )
          if (AbTabRad(iel,j).le.x.and.AbTabRad(iel,j+1).gt.x) then
            frac=(x-AbTabRad(iel,j))/(AbTabRad(iel,j+1)-AbTabRad(iel,j))
            tababun=AbTabFac(iel,j)+frac*(AbTabFac(iel,j+1)-
     1       AbTabFac(iel,j))
            lgHit = .true.
          end if
          j = j + 1
        end do
        if( .not.lgHit ) then
          write(qq,'('' radius outran dlaw table scale, requested='',
     1    f6.2,'' largest='',f6.2)')x,AbTabRad(iel,nAbunTabl)
          stop
        endif
      endif
*
*     got it, now return value, not log of density
      tababun = 10.** tababun
*
      end
******************************************************************************
      real function tabden ( r0 , depth )
      implicit none
*interpolate on table of points for density with dlaw table command, by K Volk
*each line is log radius and H density per cc.
      double precision r0 , depth
      integer limTabD
      parameter (limTabD=500)
*parameters for dlaw table command
*frad is log radius in cm, fhden is log hden
      real frad(limTabD),fhden(limTabD)
*lg is true if depth, false if radius to be used
      logical lgDLWDepth
*number of values
      integer nvals
      common/tablaw/ frad,fhden , lgDLWDepth,nvals
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer j
      logical lgHit
      real x,frac
*
*begin sanity check
      if( r0.le.0. .or. depth.le.0. ) then
        write(qq,'('' tabden called with insane depth, radius, ='',
     1  1p,2e10.2)') depth, r0
      endif
*end sanity check
*
*     interpolate on radius or depth?
      if( lgDLWDepth ) then
*       depth key appeared = we want depth
        x = log10( depth )
      else
*       use radius
        x = log10( r0 )
      endif
*
      if( x.lt.frad(1).or.x.ge.frad(nvals) ) then
        write(qq,'('' requested radius outside range of tabden'')')
        write(qq,'('' radius was'',1p,e10.2,'' min, max='',2e10.2)')
     1  x,frad(1),frad(nvals)
        stop
      else
        lgHit = .false.
        j = 1
*       do j=1,nvals-1
        do while( .not.lgHit .and. j.le.nvals-1 )
          if (frad(j).le.x.and.frad(j+1).gt.x) then
            frac=(x-frad(j))/(frad(j+1)-frad(j))
            tabden=fhden(j)+frac*(fhden(j+1)-fhden(j))
            lgHit = .true.
          end if
          j = j + 1
        end do
        if( .not.lgHit ) then
          write(qq,'('' radius outran dlaw table scale, requested='',
     1    f6.2,'' largest='',f6.2)')x,frad(nvals)
          stop
        endif
      endif
*
*     got it, now return value, not log of density
      tabden = 10.** tabden
*
      end
******************************************************************************
      subroutine tauchn( tauary )
      implicit none
*increment optical depths for all heavy element lines, zone by zone
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real tauary(nta)
*
      integer limelm
      parameter (limelm=30)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      real wndeff
      common/windeff/ wndeff
      integer ijMase
      real dTauMase
*     dTauMase is smallest maser optical depth in atoms, set in
*     tauinc for H, and in tauchn for heavy elements
*     it is negative or zero
*     ijMase is 100*n_upper + n_lower
*     if ijMase is 0 when dTauMase used, maser was in heavy element
      common/dtMase/ ijMase , dTauMase
*
*     local variables
      real vel , dtau
*
*     routine increments optical depths for static or exanding atmosphere
*
      vel = doppler(int(tauary(ipLnNelem)+.1))
      if( windv.eq.0. ) then
*       static solution
        tauary(ipLnDTau) = tauary(ipLnPopOpc)*tauary(ipLnOpac) / vel
        dtau = tauary(ipLnDTau) * dReff
*     >>chng 97 mar 18, put in for heavy elements, to stop FeII maser from
*killing Katya's atom
        tauary(ipLnTauIn) = tauary(ipLnTauIn) + dtau
        dTauMase = min(dTauMase,dtau)
*       following stops disaster, will allow escape prob to get big and
*       damp out the maser
        dtau = max( -1., dtau )
        tauary(ipLnTauCon) = tauary(ipLnTauCon) + tauary(ipLnDTau)*dReff
      else
*       wind
        tauary(ipLnTauIn) = wndeff * tauary(ipLnPopOpc)*tauary(ipLnOpac)
        tauary(ipLnTauCon) = tauary(ipLnTauIn)
*       save for continuum pumping array
*       tauary(ipLnDTau) = tauary(ipLnTauIn) / dReff
*       >>chng 96 jan 15 above had been place,
*       current nova.in crashed due to small dr
*       why was it as above?
        tauary(ipLnDTau) = tauary(ipLnPopOpc)*tauary(ipLnOpac) *
     1  FillFac / max(doppler(1),vel)
        tauary(ipLnTauTot) = tauary(ipLnTauIn)
      endif
*
      end
******************************************************************************
      subroutine tauff
      implicit none
*compute optical depth where cloud is thin to free-free and plasma freq
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
*     indicate whether plasma freq ever entered energy array
      logical lgPlasNu
*     this is the plasma frequency
      real plsfrq
*     this is the continuum pointer to the plasma frequency, and largest it ever
      integer ipPlasma, ipPlasmax
      common/plasnu/ lgPlasNu , plsfrq , ipPlasma, ipPlasmax
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real widflx
      common/widflx/ widflx(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
*
*     routine sets variable ntff, pointer to lowest cont cell that is thin
*
      real fac
*
*     find frequency where continuum thin to free-free
      do while( ntff.lt.nflux .and. tauabs(ntff,1).ge.1. )
        ntff = ntff + 1
      end do
*
*     TFF will be frequency where goes thin to brems
*     >>chng 96 May 7, had been 2, change as per Kevin Volk bug report
      if(ntff.gt.2 .and.tauabs(ntff,1).gt.0.001 ) then
*       for case where plasma frequency important, tau can be zero
        fac = (1.-tauabs(ntff-1,1))/( tauabs(ntff,1)-tauabs(ntff-1,1))
        fac = max( fac , 0. )
        tff = anu(ntff-1) + widflx(ntff-1)*fac
      else
        tff = 0.
      endif
*
*     now evaluate the plasma frequency
      plsfrq = 2.729e-12 * sqrt( eden*1.2 )
      if( plsfrq.gt.anu(1) ) lgPlasNu = .true.
*
*     >>chng 96 july 15, did not include plasma freq before
*     function returns larger of these two frequencies
      tff = max( plsfrq , tff )
*
*     now increment ntff still further, until above plasma frequency
      do while( ntff.lt.nflux .and. anu(ntff).le.tff )
        ntff = ntff + 1
      end do
*
*     save max plasma frequency for case where density changes
      if(tff.eq.plsfrq) ipPlasmax = max( ipPlasma,ntff)
*
      end
******************************************************************************
      subroutine TauInc
      implicit none
*increment optical depths once per zone
      real pi
      parameter ( pi=3.141592654 )
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer limelm
      parameter (limelm=30)
      real evryd
*     number of eV in an infinite mass Rydberg
*     from Aug '96 Physics Today, BG11
      parameter (evryd=13.6056981)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer ndfst
      parameter (ndfst=5)
*     number of FeII lines in Fred's atom
      integer nfeii
      parameter (nfeii=373)
      integer nzlim
      parameter (nzlim=2000)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
*     TexcLya is the excitation temperature of Lya
*     nLyaHot is counts how ofter Lya hotter than gas
*     TLyaMax is hottest
*     TeLyaMax is electron temp at point where Lya max
*     nZTLaMax is the zone where this happened
      real TexcLya , TLyaMax , TeLyaMax
      integer nLyaHot , nZTLaMax
      common/LyaExT/ TexcLya , nLyaHot , TLyaMax , TeLyaMax , nZTLaMax
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      integer iphmin
      common/iphmin/ iphmin
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real hmidep , h2dep , h2pdep,h3pdep,hehdep
      common/hmidep/ hmidep , h2dep , h2pdep,h3pdep,hehdep
      logical lgHLyaMased
*flag saying that Lya mased
      common/lyamas/ lgHLyaMased
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgOptcBug
*flag set if negative opacities every occured
      common/optbug/ lgOptcBug
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      double precision hlbolt , hcbolt
*     hlbolt(low,up) line boltzmann factors for hydrogen atom
*     hcbolt(n) excit to continuum
      common/hlvcol/ hlbolt(lmhlvl-1,lmhlvl+1) , hcbolt(lmhlvl+1)
      double precision he1bol , he1cbt
      common/he1blt/ he1bol(nhe1lvl-1,nhe1lvl+1) , he1cbt(nhe1lvl+1)
      double precision he2bol , he2cbt
      common/he2blt/ he2bol(nhe2lvl-1,nhe2lvl+1) , he2cbt(nhe2lvl+1)
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      real tedust
      common/tedust/ tedust(ndust)
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      real reftot,avhden,chii, avdust , avdpot , thtot
      common/toiii/ reftot,avhden,chii,
     1 avdust(ndust) , avdpot(ndust) , thtot
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      real dstq , dstpot , dstpotsav
*dstpot is grain potential in Ryd, dstq is charge, derived from dstpot
*dstpotsav saves initial grain temp for reseting at start of zone calc
      common/GrainPot/ dstq(ndust) , dstpot(ndust) , dstpotsav(ndust)
      real pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx
      integer ipHe3l(4)
      common/hetrip/ pht2s,p2s,p2p,p3s,p3p,p3d,
     1p10830,p5876,p7065,p3889,he3clx,ipHe3l
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      double precision dlnenp
      common/abrems/ dlnenp
      real opac
      common/opac/ opac(ncell)
      real sound,vsound
*     vsound is local sound speed, eval zone by zone
*     sound is sound travel time (sec) updated in tauing
      common/sound/ sound,vsound
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real hehp
      integer iheh1 , iheh2
      common/hehp/ hehp , iheh1 , iheh2
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real telec , thmin
      common/taucon/ telec , thmin
      real pciexc
      common/pciexc/ pciexc
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real te , eden , hden
      common/phycon/ te , eden , hden
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real TotMassColl , tmas , wmas
*variables to do with mean mass per particle over model,
*called <Mol> in final print out, used to get Jeans mass
      common/colmas/ TotMassColl , tmas , wmas
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
      real rjnmin , ajmmin
      common/jmin/ rjnmin , ajmmin
      real feopc , Fe2TauLte , Fe2PopLte
* opacity and optical depths for ground of Fred's FeII atom
      common/fe2tau/ feopc(nfeii) , Fe2TauLte(nfeii) , Fe2PopLte(nfeii)
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
*     these save structure variables, like te vs depth
      real testr, volstr, radstr, histr, hiistr , ednstr,o3str,heatstr,
     1 pdenstr
      common/struc/ testr(nzlim), volstr(nzlim), radstr(nzlim),
     1 histr(nzlim), hiistr(nzlim) , ednstr(nzlim),o3str(nzlim),
     2 heatstr(nzlim),pdenstr(nzlim)
      real wndeff
      common/windeff/ wndeff
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      real BigEdenError
      integer ipEdenError
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      common/EdError/ BigEdenError , ipEdenError
      real EdenTrue
*     this is the true eden as set in esum
*     we will try to converge eden to this
      common/TrueEden/ EdenTrue
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
      integer ijMase
      real dTauMase
*     dTauMase is smallest maser optical depth in atoms, set in
*     tauinc for H, and in tauchn for heavy elements
*     it is negative or zero
*     ijMase is 100*n_upper + n_lower
*     if ijMase is 0 when dTauMase used, maser was in heavy element
      common/dtMase/ ijMase , dTauMase
      real he1esc
      common/he1escCOM/ he1esc(9,9)
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chLbl*10, chLineLbl*10
      real CapMaser
      parameter (CapMaser=-30.)
      integer i,j,nd , low , ihi
      real r,factor,fnext,dtau,rjeans,ajmass , ErrorEden
*
*     free statement numbers >= 30
*
      if(lgTrace) write(qq,'('' TauInc called.'')')
*
*     following is general method to find means weighted by various functions
*     called int startr to initialize to zero, called here to put in numbers
*     results will be weighted by radius and volumn
*     this is the only place things must be entered to create averages
      call aver('zone', 1. , 1.                  ,'          ' )
      call aver('doit', te , 1.                  ,'    Te    ' )
      call aver('doit', te , eden                ,'  Te(Ne)  ' )
      call aver('doit', te , eden*hii            ,' Te(NeNp) ' )
      call aver('doit', te , eden*heii           ,' Te(NeHe+)' )
      call aver('doit', te , eden*heiii          ,'Te(NeHe2+)' )
      call aver('doit', te , eden*xIonFracs(8,2) ,' Te(NeO+) ' )
      call aver('doit', te , eden*xIonFracs(8,3) ,' Te(NeO2+)' )
      call aver('doit',hden, 1.                  ,'    NH    ' )
      call aver('doit',eden, xIonFracs(8,3)      ,'  Ne(O2+) ' )
      call aver('doit',eden, hii                 ,'   Ne(Np) ' )
*
*     save information about structure of model, now used to get t^2
      testr(min(nzone,nzlim)) = te
      pdenstr(min(nzone,nzlim)) = pden
      heatstr(min(nzone,nzlim)) = htot
      volstr(min(nzone,nzlim)) = dVeff
      radstr(min(nzone,nzlim)) = dReff
      histr(min(nzone,nzlim)) = hi
      hiistr(min(nzone,nzlim)) = hii
      ednstr(min(nzone,nzlim)) = eden
      o3str(min(nzone,nzlim)) = xIonFracs(8,3)
*
*     check on error budget for eden
      ErrorEden = (eden-EdenTrue)/EdenTrue
      if( abs(ErrorEden).gt.abs(BigEdenError) ) then
        BigEdenError = ErrorEden
        ipEdenError = nzone
      endif
*
      vsound = sqrt( GasPres /xMassDensity )
*     sound is sound travel time
      sound = sound+dReff/vsound
*
      dlnenp = dlnenp + dble(eden) * dble(hii) * dble(dReff)
      colden = colden + hden * dReff
      chi = chi + hi*dReff
*
*     counter for number of times Lya excit temp hotter than gas
      if( TexcLya.gt.te ) then
        nLyaHot = nLyaHot + 1
        if( TexcLya.gt.TLyaMax ) then
          TLyaMax = TexcLya
          TeLyaMax = te
          nZTLaMax = nzone
        endif
      endif
*
      chmin = chmin + hminus * dReff
      colh2 = colh2 + htwo * dReff
      chehp = chehp + hehp * dReff
      ch2pls = ch2pls + h2plus*dReff
*
*     now add total molecular column densities
      call molcol( 'ADD ' )
*
*     call zmean zeros out these arrays
*     rest of elements
      call mean
*
*-----------------------------------------------------------------------
*
      reftot = reftot + dReff
      avhden = avhden + dReff
      do nd=1,ndust
        if( lgDustOn1(nd) ) theN
          avdust(nd) = avdust(nd) + tedust(nd) * dReff
          avdft(nd) = avdft(nd) + DustDftVel(nd) * dReff
          avdpot(nd) = avdpot(nd) + dstpot(nd)*evryd * dReff
        endif
      end do
      chii = chii + hii * dReff
      thtot = thtot + te * dReff * hden
      TotMassColl = TotMassColl + xMassDensity * dReff
      tmas = tmas + te * xMassDensity * dReff
      wmas = wmas + wmole * xMassDensity * dReff
*
*     now find minimum Jeans length and mass; length in cm
      rjeans = 7.79637 +(alogte-log10(wmole)-
     1 log10(xMassDensity*FillFac))/2.
*     minimum Jeans mass in gm
      ajmass = 3.*(rjeans-0.30103)+log10(4.*pi/3.*xMassDensity*FillFac)
      rjnmin = min( rjnmin , rjeans )
      ajmmin = min( ajmmin , ajmass )
*
      telec = telec + dReff * eden * 6.65e-25
      thmin = thmin + dReff * hminus * 3.9e-17 *
     1 (1. - ContBoltz(iphmin)/hmidep )
*
*     find line widths for thermal and turbulent motion
*     CLOUDY uses line center optical depths, =0.015 F / DELTA NU
      call velset
*
*     following used for wind solution in TAUCHN
      if(windv.gt.0.) wndeff = min( depth , radius ) /
     1 max( doppler(1),windv ) * FillFac
*
*     prevent maser runaway
      dTauMase = 0.
*     if following is still zero when maser used, then maser was in
*     heavy element line
      ijMase = 0
*
*     increment optical depths for all heavy element lines
*     same routine does wind and static
      do i=1,nTauLines
        call tauchn( TauLines(1,i))
        if( TauLines(ipLnTauIn,i).lt.CapMaser ) then
          write(qq,'('' TauInc, Tau line maser tau too small,'',1p,
     1    e10.2)')TauLines(ipLnTauIn,i)
          chLbl = chLineLbl( TauLines(1,i) )
          write(qq,'('' line='',i3,'' zone='',i4,1x,a10)')
     1    i,nzone,chLbl
          call ShowMe
          stop
        endif
      end do
*
*     all lines in cooling with g-bar
      do i=1,NWINDLINE
        call tauchn( WindLine(1,i))
        if( WindLine(ipLnTauIn,i).lt.CapMaser ) then
          write(qq,'('' TauInc, Wind line maser tau too small,'',1p,
     1    e10.2)')WindLine(ipLnTauIn,i)
          write(qq,'('' line='',i3,'' zone='',i4)')
     1    i,nzone
          call ShowMe
          stop
        endif
      end do
*
*     do Katya Verner FeII atom if this is enabled
      if( chFeIIAtom.eq.'Verner'.and.xIonFracs(26,2).gt.0.) then
        if(.not.lgSimKatya) call TauIncFe2
      endif
*
      if( windv.eq.0. ) then
*
      if(lgTrace) write(qq,'('' TauInc updates for static atmos'')')
*
*     following is for static atmosphere
*
*     hydrogen lines
      factor = hii * dReff / doppler(1)
      fnext = hii * dRNeff / doppler(1) * 0.6
      do low=1,nhlvl-1
        do ihi=max(3,low+1),nhlvl
*         line absorption, corrected for stimulated emission
          if( ihi.lt.nhlvl-2 ) then
            dtau = (hn(low) - hn(ihi)* hstat(low) / hstat(ihi) ) *
     1      hopac(ihi,low)
          else
*           do not allow stim em cor for highest state since it
*           has especially flaky departure coef
            dtau = hn(low) * hopac(ihi,low)
          endif
          if( dtau*factor .lt. dTauMase) then
            dTauMase = dtau * factor
            ijMase = 100*ihi + low
          endif
*     >>chng 96 aug 8, added max, so that smallest maser tau is -1
          htau(ihi,low) = htau(ihi,low) + max(-1.,dtau * factor)
          htnext(ihi,low) = htau(ihi,low) + max(-1.,dtau * fnext)
          if( htnext(ihi,low).lt.CapMaser ) then
            write(qq,'('' TauInc, H line maser tau too small,'',1p,
     1      e10.2)')htnext(ihi,low)
            write(qq,'('' upper, lower='',2i3,'' zone='',i4)')
     1      ihi,low,nzone
            call ShowMe
            stop
          endif
        end do
      end do
*     Ly-alpha absorption, corrected for stimulated emission
      dtau = (hn(1) - hn2p* 2. / 6. ) * hopac(2,1)
      if( dtau.lt.0. ) lgHLyaMased = .true.
      htau(2,1) = htau(2,1) + dtau * factor
      htnext(2,1) = htau(2,1) + dtau * fnext
*
*     He I lines
*     Helium lines, optical depths are total, not He alone
*     hydrogen and helium were added in with correction for stimulated emission
      factor = heii * dReff / doppler(2)
      fnext = heii * dRNeff / doppler(2) * 0.6
      do low=1,nhe1lvl-1
        do ihi=low+1,nhe1lvl
*         line absorption, corrected for stimulated emission
          if( ihi.lt.nhe1lvl-2 ) then
            dtau = (he1n(low) - he1n(ihi)*he1stat(low)/he1stat(ihi))*
     1      he1opc(ihi,low)
          else
*           do not allow stim emission for psuedo-states
            dtau = he1n(low) * he1opc(ihi,low)
          endif
          he1tau(ihi,low) = he1tau(ihi,low) + dtau * factor
          he1nxt(ihi,low) = he1tau(ihi,low) + dtau * fnext
          if( he1nxt(ihi,low).lt.CapMaser ) then
            write(qq,'('' TauInc, He1 line maser tau too small,'',1p,
     1      e10.2)') he1nxt(ihi,low)
            write(qq,'('' upper, lower='',2i3,'' zone='',i4)')
     1      ihi,low,nzone
            call ShowMe
            stop
          endif
        end do
      end do
*666  write(6,'('' he1'',1p,9e10.2)') (he1dst(i+1,i), i=1,2),
*    1 (he1nxt(i+1,i),i=1,2), (he1esc(i+1,i),i=1,2)
*     >>chng 96 july 8, optical depth increment had been deleted around beta 3
*     >>chng 96 july 8, did not have correction for stimulated emission, ever
      t206(ipLnTauIn) = t206(ipLnTauIn) + (he12s-he12p*0.333) *
     1 1.162e-6 * factor
      if( t206(ipLnTauIn).lt.CapMaser ) then
        write(qq,'('' TauInc, He1 2.06 mic line maser tau too small,'',
     1  1p,e10.2)') t206(ipLnTauIn)
        write(qq,'('' zone='',i4)') nzone
        call ShowMe
        stop
      endif
*
*     He II lines
      factor = heiii * dReff / doppler(2)
      fnext = heiii * dRNeff / doppler(2) * 0.6
      do low=1,nhe2lvl-1
        do ihi=low+1,nhe2lvl
          if( ihi.lt.nhe2lvl-2 ) then
*           line absorption, corrected for stimulated emission
            dtau = (he2n(low) - he2n(ihi)*he2stat(low)/he2stat(ihi))*
     1      he2opc(ihi,low)
          else
*           do not include stim emission for highest level
            dtau = he2n(low) * he2opc(ihi,low)
          endif
          he2tau(ihi,low) = he2tau(ihi,low) + dtau * factor
          he2nxt(ihi,low) = he2tau(ihi,low) + dtau * fnext
          if( he2nxt(ihi,low).lt.CapMaser ) then
            write(qq,'('' TauInc, He2 line maser tau too small,'',1p,
     1      e10.2)') he2nxt(ihi,low)
            write(qq,'('' upper, lower='',2i3,'' zone='',i4)')
     1      ihi,low,nzone
            call ShowMe
            stop
          endif
        end do
      end do
*
      factor = dReff / doppler(2)
      t10830(ipLnTauIn) = t10830(ipLnTauIn)+8.80e-7 *(p2s-p2p/3.)*factor
       t3889(ipLnTauIn) = t3889(ipLnTauIn)  + 3.75e-8 * p2s * factor
       t5876(ipLnTauIn) = t5876(ipLnTauIn)  + 5.35e-7 * p2p * factor
       t7065(ipLnTauIn) = t7065(ipLnTauIn)  + 2.95e-7 * p2p * factor
*
*     iron fe
*     first are overlapping feii lines
      do i=1,nfeii
        Fe2TauLte(i) = Fe2TauLte(i) + feopc(i)  * dReff
      end do
*
      else
      if(lgTrace) write(qq,'('' TauInc updates for wind'')')
*
*     expanding atmosphere
*     min of depth or radius is to stop (nearly) infinite line
*     line optical depths when ionization parameter set so
*     radius itself is very large
      r = min( depth , radius ) / max(doppler(1),windv) * FillFac
*
*     hydrogen lines
      factor = hii * r
*
      do i=1,nhlvl-1
        do j=max(3,i+1),nhlvl
*         line absorption, corrected for stimulated emission
          if(j.le.nhlvl-2) then
            dtau = (hn(i) - hn(j)* hstat(i) / hstat(j) ) * hopac(j,i)
          else
            dtau = hn(i) * hopac(j,i)
          endif
          htau(j,i) = dtau * factor
          htnext(j,i) = htau(j,i)
        end do
      end do
*     Ly-alpha absorption, corrected for stimulated emission
      dtau = (hn(1) - hn2p* 2. / 6. ) * hopac(2,1)
      if( dtau.lt.0. ) lgHLyaMased = .true.
      htau(2,1) = dtau * factor
      htnext(2,1) = htau(2,1)
*
*     He I lines
*     Helium lines and continua, optical depths are total, not He alone
*     hydrogen and helium were added in with correction for stimulated emission
      factor = heii * r
      do i=1,nhe1lvl-1
        do j=i+1,nhe1lvl
*         line absorption, corrected for stimulated emission
          if( j.le.nhe1lvl-2 ) then
            dtau = (he1n(i) - he1n(j)*he1stat(i)/he1stat(j))*he1opc(j,i)
          else
*           do not include stim emission for psuedo-states
            dtau = he1n(i) * he1opc(j,i)
          endif
          he1tau(j,i) = dtau * factor
          he1nxt(j,i) = he1tau(j,i)
        end do
      end do
      t206(ipLnTauIn) = he12s*heii*1.162e-6 * r
      t206(ipLnTauTot) = t206(ipLnTauIn)
*
*     He II lines
      factor = heiii * r
      do i=1,nhe2lvl-1
        do j=i+1,nhe2lvl
          if( j.le.nhe2lvl-2 ) then
*           line absorption, corrected for stimulated emission
            dtau = (he2n(i) - he2n(j)*he2stat(i)/he2stat(j))*he2opc(j,i)
          else
*           do not include stim emission for psuedo-sates
            dtau = he2n(i) * he2opc(j,i)
          endif
          he2tau(j,i) = dtau * factor
          he2nxt(j,i) = he2tau(j,i)
        end do
      end do
*
      t10830(ipLnTauIn) = r*(p2s-p2p/3.) * 8.80e-7
      t10830(ipLnTauTot) = t10830(ipLnTauIn)
       t3889(ipLnTauIn) = 3.75e-8 *p2s*r
       t3889(ipLnTauTot) = t3889(ipLnTauIn)
       t5876(ipLnTauIn) = 5.35e-7 *p2p*r
       t5876(ipLnTauTot) = t5876(ipLnTauIn)
       t7065(ipLnTauIn) = 2.95e-7 *p2p*r
       t7065(ipLnTauTot) = t7065(ipLnTauIn)
*
      endif
*
*     now do escape prob
      call MakeRT
      if( lgTrace.and.lgOptcBug ) call metprt
*
      if(lgTrace) write(qq,'('' TauInc returns.'')')
*
      end
******************************************************************************
      subroutine tauout
      implicit none
*set initial outward optical depths at start of first iteration
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     energy differences for levels in the model hydrogen atom:
      real HEnerRyd
      common/HEnrRyd/ HEnerRyd(lmhlvl,lmhlvl)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real TurbVel
*this is the turbulent velocity in cm/s, normally zero, set with
*turbulence command
      common/turb/ TurbVel
      integer ipxry
      real tauxry
      common/xry/ ipxry , tauxry
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      integer ipHn
* pointers to threshold of photoionization of hydrogen
      common/nh/ ipHn(lmhlvl+1)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real t10830,t3889,t5876,t7065
      common/he3tau/ t10830(nta),t3889(nta),t5876(nta),t7065(nta)
      real He1EinA
*transition prob for He 1 singlets
      common/he1as/ He1EinA(9,8)
      real he2as
      common/he2as/ he2as(9,8)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real qhtot , qhe , qheii , qbal , qrad , qtot
      common/qs/ qhtot , qhe , qheii , qbal , qrad , qtot
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real HColStop , colpls , colnut
*limit column densities set with stop column command
*colend is total hydrogen column, others are ionized and neutral
      common/colend/ HColStop , colpls , colnut
      logical lgStatic
*flag saying that spherical geometry is static, set with sphere static
      common/static/ lgStatic
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      real DoubleTau
*1 or two, set to double optical depth scale, set to 2 with double command
*default is 1
      common/double/ DoubleTau
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      real TAddHLya,TAddHeI,TAddHeII
      common/TAddLya/ TAddHLya,TAddHeI,TAddHeII
      real hyas
      common/hyas/ hyas(lmhlvl,lmhlvl-1)
      real hlife
      common/hlife/ hlife(lmhlvl)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i ,j , ilo,ihi
      real f , fac , z , coleff, balc
      real taulim , branch
      parameter (taulim=1e8)
*
*     free statement labels >=29
*
*     set initial and total optical depths in arrays
*     TAUNU is set when lines read in, sets stopping radius
      if( taunu.gt.0. ) then
*        an optical depth has been specified
         if( iptnu.ge.ipHn(1) ) then
*           at ionizing energies
            do i=1,ipHn(1)-1
               tauabs(i,2) = taumin
               tausct(i,2) = taumin
               tautot(i,2) = taumin
            end do
            do i=ipHn(1),nupper
*              tauabs(i,2) = tauend * (anu(i)/anu(iptnu))**(-2.43)
               tauabs(i,2) = tauend
               tausct(i,2) = taumin
               tautot(i,2) = tauabs(i,2) + tausct(i,2)
            end do
         else
*           not specified at ionizing energies
            do i=1,ipHn(1)-1
               tauabs(i,2) = tauend
               tausct(i,2) = tauend
               tautot(i,2) = tauend
            end do
            do i=ipHn(1),nupper
               tauabs(i,2) = taulim * anu(i)**(-2.43)
               tausct(i,2) = taumin
               tautot(i,2) = tauabs(i,2) + tausct(i,2)
            end do
         endif
      else
*        ending optical depth not specified, assume 1E8 at 1 Ryd
         do i=1,ipHn(1)-1
            tauabs(i,2) = taumin
            tausct(i,2) = taumin
            tautot(i,2) = taumin
         end do
         do i=ipHn(1),nupper
            tauabs(i,2) = taulim * anu(i)**(-2.43)
            tausct(i,2) = taumin
            tautot(i,2) = tauabs(i,2) + tausct(i,2)
         end do
      endif
*
*     if lgSphere then double outer, set inner to half
*     assume will be optically thin at sub-ionizing energies
      if( lgSphere .or. lgCaseb ) then
         do i=1,ipHn(1)-1
            tauabs(i,1) = taumin
            tauabs(i,2) = taumin * 2.
            tausct(i,1) = taumin
            tausct(i,2) = taumin * 2.
            tautot(i,1) = 2.*taumin
            tautot(i,2) = 4.*taumin
         end do
         do i=ipHn(1),nupper
            tauabs(i,1) = tauabs(i,2)
            tauabs(i,2) = tauabs(i,2) * 2.
            tausct(i,1) = tausct(i,2)
            tausct(i,2) = tausct(i,2) * 2.
            tautot(i,1) = tautot(i,2)
            tautot(i,2) = tautot(i,2) * 2.
         end do
         if( taunu.gt.0. ) then
*           ending optical depth specified, and lgSphere also
            tauend = tauend * 2.
         endif
      endif
*
*     fix offset for effective column density optical depth
      tauxry = tauabs( ipxry , 1 )
*
      do i=1,nhlvl-1
        do j=1,nhlvl
          htnext(j,i) = taumin
          htau(j,i) = taumin
        end do
      end do
      do i=1,nhe1lvl-1
        do j=1,nhe1lvl
          he1nxt(j,i) = taumin
          he1tau(j,i) = taumin
        end do
      end do
      do i=1,nhe2lvl-1
        do j=1,nhe2lvl
          he2nxt(j,i) = taumin
          he2tau(j,i) = taumin
        end do
      end do
*
*     HeI 10830 when static
      if( lgStatic ) then
        t10830(ipLnTauIn) = 100.
        t10830(ipLnTauTot) = 200.
      endif
*
*     La may be case B
      htau(2,1) = tlamin
      htnext(2,1) = tlamin
      he1tau(2,1) = tlamin
      he2tau(2,1) = tlamin
      he1nxt(2,1) = tlamin
      he2nxt(2,1) = tlamin
*
      f = tlamin / hopac(2,1)
      do i=3,nhlvl
        htau(i,1) = f * hopac(i,1)
        htnext(i,1) = htau(i,1)
      end do
*
      f = tlamin / he1opc(2,1)
      do i=3,nhe1lvl
        he1tau(i,1) = f * he1opc(i,1)
        he1nxt(i,1) = he1tau(i,1)
      end do
*
      f = tlamin / he2opc(2,1)
      do i=3,nhe2lvl
        he2tau(i,1) = f * he2opc(i,1)
        he2nxt(i,1) = he2tau(i,1)
      end do
*
*     fix LA in ways of increasing accuracy
*
*     account for turbulence
      z = 1.28e6 / sqrt( 1.65e12 + TurbVel*TurbVel )
      if( lgCaseb ) then
*       force outer optical depth to twice inner if case B
        htlim(2,1) = 2. * htnext(2,1)
        he1lim(2,1) = 2. * he1nxt(2,1)
        he2lim(2,1) = 2. * he2nxt(2,1)
*       force off Balmer et al optical depths
        fac = 0.
      else
*       usual case for H LyA; try to guess outer optical depth
        if( colnut.lt.6e29 ) then
*         neutral column is defined
          htlim(2,1) = colnut * DoubleTau * 7.6e-14 * z
        else if( taunu.lt.3. .and. taunu.ge.0.99 ) then
*         Lyman continuum optical depth defined
          htlim(2,1) = tauend * 1.2e4 * z * DoubleTau
        else if( HColStop.lt. 6e29 ) then
*         neutral column not defined, guess from total col and U
          coleff = HColStop - min( min(qhtot/eden,1e24)/2.6e-13 ,
     1    0.6*HColStop )
          htlim(2,1) = coleff * 7.6e-14 * z
        else
*         no way to estimate 912 optical depth, set to large number
          htlim(2,1) = 1e20 * z
        endif
*       set He LyA optical depths to large number
        he1lim(2,1) = htlim(2,1)
        he2lim(2,1) = htlim(2,1)
*       allow Balmer et al. optical depths
        fac = 1.
      endif
*
      if( htlim(2,1).gt.1. ) then
        TAddHLya = min(1. , htlim(2,1)/1e4 )
        htau(2,1) = htau(2,1) + TAddHLya
        htnext(2,1) = htau(2,1)
      else
        TAddHLya = tlamin
      endif
      f = htlim(2,1) / hopac(2,1)
      do i=3,nhlvl
        htlim(i,1) = hopac(i,1) * f
        htau(i,1) = htau(i,1) + TAddHLya*hopac(i,1)/hopac(2,1)
        htnext(i,1) = htau(i,1)
      end do
*
      if( he1lim(2,1).gt.1. ) then
        TAddHeI = min(1. , he1lim(2,1)/1e4 )
        he1tau(2,1) = he1tau(2,1) + TAddHeI
        he1nxt(2,1) = he1tau(2,1)
      else
        TAddHeI = tlamin
      endif
*     min triggers if case b command entered
      TAddHeI = min(he1lim(2,1)/10., he1tau(2,1))
      f = he1lim(2,1) / he1opc(2,1)
      do i=3,nhe1lvl
        he1lim(i,1) = he1opc(i,1) * f
        he1tau(i,1) = he1tau(i,1) + TAddHeI*he1opc(i,1)/he1opc(2,1)
        he1nxt(i,1) = he1tau(i,1)
      end do
*
      if( he2lim(2,1).gt.1. ) then
        TAddHeII = min(1. , he2lim(2,1)/1e4 )
        he2tau(2,1) = he2tau(2,1) + TAddHeII
        he2nxt(2,1) = he2tau(2,1)
      else
        TAddHeII = tlamin
      endif
*     min triggers if case b used
      TAddHeII = min( he2lim(2,1)/10., he2tau(2,1))
      f = he2lim(2,1) / he2opc(2,1)
      do i=3,nhe2lvl
        he2lim(i,1) = he2opc(i,1) * f
        he2tau(i,1) = he2tau(i,1) + TAddHeII*he2opc(i,1)/he2opc(2,1)
        he2nxt(i,1) = he2tau(i,1)
      end do
*
*     try to guess what Balmer cont optical guess is
*     relation from Ferland and Netzer 1979
      if( taunu.gt.0.24 .and. taunu.lt.0.7 ) then
        htlim(3,2) = tauend * 3.7e4 * z * fac + 1e-20
      else
*       this is a guess based on something, but it gets very large
        balc = qhtot * 2.1e-19 * fac + 1e-20
*       z if the factor that account for turbulence, =1 is TurbVel=0
        htlim(3,2) = min(2e5,balc*3.7e4*z*fac+1e-20)
      endif
*
      htlim(4,3) = htlim(3,2) * 0.01 * z * fac + 1e-20
      htlim(5,4) = htlim(3,2) * 0.0005 * z * fac + 1e-20
      htlim(6,5) = htlim(3,2) * 7.7e-5 * z * fac + 1e-20
      do i=7,nhlvl
        htlim(i,i-1) = htlim(6,5) / i * fac + 1e-20
      end do
*     htlim(7,6) = htlim(6,5) / 10. * fac + 1e-20
*     htlim(8,7) = htlim(6,5) / 100. * fac + 1e-20
*     htlim(9,8) = htlim(6,5) / 1000. * fac + 1e-20
*
      do ihi=4,min(15,nhlvl)
        do ilo=2,ihi-1
          hyas(ihi,ilo) = hlife(ihi) * branch(ihi,ilo)
*         make self-consistent opaciity
          hopac(ihi,ilo) = hyas(ihi,ilo) * 2.249e-26 *
     1    hstat(ihi)/hstat(ilo) * (rydlam/HEnerRyd(ihi,ilo))**3
        end do
      end do
      do ihi=4,nhe1lvl
        do ilo=1,ihi-1
*         scale HeII opacities from hydrogen
          he1opc(ihi,ilo) = hopac(ihi,ilo) / 1.808
        end do
      end do
      do ihi=4,nhe2lvl
        do ilo=1,ihi-1
*         scale HeII opacities from hydrogen
          he2opc(ihi,ilo) = hopac(ihi,ilo) / 4.
        end do
      end do
      do ilo=2,nhlvl-1
        f = htlim(ilo+1,ilo) / hopac(ilo+1,ilo) * fac + 1e-20
        do ihi=ilo+2,nhlvl
          htlim(ihi,ilo) = f * hopac(ihi,ilo)
        end do
      end do
*
      do i=2,nhe1lvl-1
        do j=i+1,nhe1lvl
          he1lim(j,i) = taumin
        end do
      end do
*
      do i=2,nhe2lvl-1
        do j=i+1,nhe2lvl
          he2lim(j,i) = taumin
        end do
      end do
*
*     fix escape prob for He, metals, first set log of Te, needed by RECEFF
      te = 2e4
      call tfidle
      call MakeRT
*
      if( lgTrace ) then
        if( lgHBug .and.lgHBugFull ) then
          write(qq,'(//'' HTLIM array as set in TAUOUT'')')
          do i=1,nhlvl
            write(qq,'(1X,I3,1P,15E9.2)') i,(htlim(i,j),j=1,nhlvl-1)
          end do
          write(qq,'(//'' HTAU array'')')
          do i=1,nhlvl
            write(qq,'(1X,I3,1P,15E9.2)') i,(htau(i,j),j=1,nhlvl-1)
          end do
          write(qq,'(//'' HTAU As array'')')
          do i=1,nhlvl
             write(qq,'(1X,I3,1P,15E9.2)') i,(hyas(i,j),j=1,nhlvl-1)
          end do
          write(qq,'(//'' H opac array'')')
          do i=1,nhlvl
            write(qq,'(1X,I3,1P,15E9.2)') i,(hopac(i,j),j=1,nhlvl-1)
          end do
        else if( lgHe1Bug ) then
          write(qq,'(//'' HE1LIM array as set in TAUOUT'')')
          do i=1,nhe1lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he1lim(i,j),j=1,nhe1lvl-1)
          end do
          write(qq,'(//'' HE1TAU array'')')
          do i=1,nhe1lvl
            write(qq,'(1x,i3,1p,8e11.3)') i,(he1tau(i,j),j=1,nhe1lvl-1)
          end do
          write(qq,'(//'' HE1 As array'')')
          do i=1,nhe1lvl
            write(qq,'(1x,i3,1p,8e11.3)') i,(He1EinA(i,j),j=1,nhe1lvl-1)
          end do
          write(qq,'(//'' HE1 opac array'')')
          do i=1,nhe1lvl
            write(qq,'(1x,i3,1p,8e11.3)') i,(he1opc(i,j),j=1,nhe1lvl-1)
          end do
*
        else if( lgHe2Bug ) then
          write(qq,'(//'' HE2LIM array as set in TAUOUT'')')
          do i=1,nhe2lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he2lim(i,j),j=1,nhe2lvl-1)
          end do
          write(qq,'(//'' HE2TAU array'')')
          do i=1,nhe2lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he2tau(i,j),j=1,nhe2lvl-1)
          end do
          write(qq,'(//'' HE2TAU As'')')
          do i=1,nhe2lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he2as(i,j),j=1,nhe2lvl-1)
          end do
          write(qq,'(//'' HE2TAU opcity array'')')
          do i=1,nhe2lvl
            write(qq,'(1X,I3,1P,8E11.3)') i,(he2opc(i,j),j=1,nhe2lvl-1)
          end do
        else
          write(qq,'(1X,''TAUOUT called.'')')
        endif
      endif
*
      end
******************************************************************************
      subroutine tav( t , f1 )
      implicit none
*computes average of old and new optical depths for new scale at end of iter
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real t(nta) , f1
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      real DoubleTau
*1 or two, set to double optical depth scale, set to 2 with double command
*default is 1
      common/double/ DoubleTau
      logical lgStatic
*flag saying that spherical geometry is static, set with sphere static
      common/static/ lgStatic
      logical lgPrtMaser
*     option to print maser lines (true) normally false
*     print maser turns on
      common/PrtMaser/ lgPrtMaser
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chLineLbl*10, chSave*10
*
*     option to print masing lines, set with print maser
      if( lgPrtMaser .and.
     1  (t(ipLnTauTot).lt.-0.01 .or. t(ipLnTauIn).lt.-0.01) ) then
        chSave = chLineLbl( t )
        write(qq,'('' Masing line:'',a10,'' t(in, out)='',1p,2e10.2)')
     1  chSave , t(ipLnTauIn) ,  t(ipLnTauTot)
      endif
*
*     (1) is inner optical depth, (2) is outer, (3) is esc prob
      if( iter.eq.1 .and. (.not.lgStatic) ) then
*       first shot at model, set T(ipLnTauTot) to T(1)
*       DoubleTau normally 1, set to 2 by DoubleTau command in order
*       to simulate two-sided photoionization
        t(ipLnTauTot) = t(ipLnTauIn) * DoubleTau
        t(ipLnTauIn) = min(taumin,t(ipLnTauTot)/2.)
      else if( lgSphere.and.lgStatic ) then
*       static sphere, both sides interact
*       t(ipLnTauIn) = max( taumin, t(ipLnTauIn) - t(ipLnTauTot)/2. )
*       t(ipLnTauTot) = 2. * t(ipLnTauIn)
*     >>chng 96 july 6 from above to below
        if( iter.eq.1 ) then
*         on first iteration TauIn was 0 for first zone
          t(ipLnTauTot) = 2. * t(ipLnTauIn)
        else
          t(ipLnTauTot) = t(ipLnTauIn)*f1+t(ipLnTauTot)*(1.-f1)
        endif
        t(ipLnTauIn) = t(ipLnTauTot)/2.
      else
*       take some sort of mean of old and new limiting optical depths
        if( t(ipLnTauIn).gt.0. .and. t(ipLnTauTot).gt.0. ) then
          t(ipLnTauTot) = 10.**( log10(t(ipLnTauTot))*(1.-f1) +
     1    log10(t(ipLnTauIn)*DoubleTau)*f1 )
          t(ipLnTauIn) = min(taumin,t(ipLnTauTot)/2.)
        else
          t(ipLnTauTot) = ( t(ipLnTauIn)*DoubleTau + t(ipLnTauTot) )/2.
          t(ipLnTauIn) = min(taumin,t(ipLnTauTot)/2.)
        endif
      endif
*
*     this is escape prob
      t(ipLnEscP) = 0.5 * (1. + 1./max(1.,t(ipLnTauTot)) )
*
*     this is fraction inward
      t(ipLnInwd) = min(1., 1.5-t(ipLnEscP) )
*
*     this is destruction probability
*     >>chng 96 sep 4, was not here, needed to add since now taking
*     mean of old and new dest prob
      t(ipLnDesP) = 0.
*
*     line opacity
      t(ipLnDTau) = 0.
*
*     optical depth to the continuum source
      t(ipLnTauCon) = 0.
*
      end
******************************************************************************
      subroutine tefail
      implicit none
*handle temperature failure
*     this says whether temp or C-H deriv is changing sign
      logical lgCmHOsc , lgTOscl
*     this is deriv of cooling minus heating wft temp
      double precision dCoolmHeatdT
      common/dCmHdT/ dCoolmHeatdT , lgCmHOsc , lgTOscl
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real te , eden , hden
      common/phycon/ te , eden , hden
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real dTemper
*change in temperature
      common/dtemp/ dTemper
*     limfal is limit to number of te failures, set with "failures" cmnd
*     lgNoMap is option not to map failures
      integer limfal
      logical lgNoMap
      common/limfal/ limfal , lgNoMap
      integer ifailz
      common/failz/ ifailz(12)
      real failmx
*     info related to the number of temperature or pressure failures
*     failmx is largest relative error in heating cooling match
*     nPreFail is number of pressure failuers
      integer nfail , nPreFail
      common/nfail/ nfail , failmx , nPreFail
      integer MapZone , nMapStep
      real RangeMap
*parameters doing with map command, MapZone is zone number,
* -1 for very start
* RangeMap is range, parsed from same command
* nMapStep is number of steps, set with set nmap command
      common/MapPar/ MapZone , RangeMap(2), nMapStep
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      logical lgPrnErr
      integer ioPrnErr
      common/PrnErr/ lgPrnErr , ioPrnErr
      character*10 chInCvgRsn
      common/InCvgRsn/ chInCvgRsn
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
*
      nfail = nfail + 1
      if( lgTalk ) then
        write(qq,'('' NO TE ION CONVERG'',I3,'' Z='',I4,
     1  '' TE='',1P,E10.4,'' ERROR='',E9.2,'' HTOT='',E9.2,'' CTOT='',
     2  E9.2,'' DERR='',E9.2,'' DTe='',E9.2,'' lgIonDone:'',1L1)')
     3  nfail , nzone, te,(htot-ctot)/htot, htot, ctot, dCoolmHeatdT,
     4  dTemper,
     4  lgIonDone
        if(lgTOscl.and.lgCmHOsc) then
          write(qq,'('' Temperature and d(Cool-Heat)/dT were both '',
     1    ''oscillating.'')')
        else if(lgTOscl) then
          write(qq,'('' Temperature was oscillating.'')')
        else if(lgCmHOsc) then
          write(qq,'('' d(Cool-Heat)/dT was oscillating.'')')
        endif
*       not really a temperature failure, but something else
        if( .not.lgIonDone ) then
          write(qq,'('' Solution not converged due to '',a10)')
     1    chInCvgRsn
        endif
      endif
*     option to print to screen
      if( lgPrnErr ) then
        write(ioPrnErr,'('' NO TE ION CONVERG'',I3,'' Z='',I4,
     1  '' TE='',1P,E10.4,'' ERROR='',E9.2,'' HTOT='',E9.2,'' CTOT='',
     2  E9.2,'' DERR='',E9.2,'' DTe='',E9.2,'' lgIonDone:'',1L1)')
     3  nfail , nzone, te,(htot-ctot)/htot, htot, ctot, dCoolmHeatdT,
     4  dTemper,lgIonDone
        if(lgCmHOsc)write(qq,'('' d(Cool-Heat)/dT was oscillating.'')')
      endif
*
*     remember which zone this is
      ifailz( min( nfail,10 ) ) = nzone
*     remember the relative error
*     convert to single precision for following max, abs (vax failed here)
      failmx = max( failmx , abs(real((htot-ctot)/htot)) )
      if( nfail .lt. limfal ) return
*
*     punt
      if( lgTalk ) then
        write(qq,'('' Stop after'',I3,'' temperature failures.'')')
     1  limfal
        write(qq,'('' This limit can be reset with the'',
     1  '' FAILURES command.'')')
*
*       adjust range of punting map
        RangeMap(1) = te / 100.
        RangeMap(2) = min( te * 100. , 9e9 )
        if(.not. lgNoMap) then
*         need to make printout out now, before disturbing soln with map
          call prstep
          call punt('punt')
        endif
      endif
*
*     return out from here and let lgEndFun catch lgBusted set,
*     and generate normal output there
      lgBusted = .true.
      if(lgTalk)write(qq,'('' tefail sets lgBusted since nfail>=limfal'',
     1 2i5)') nfail , limfal
*
      end
      subroutine TestCode
      implicit none
*set flag saying that test code is in place
      logical lgTestIt , lgTestOn
*flag lgTestIt turned on if routine TestCode ever called, only generates
*comment that test code is in place
*flag lgTestOn set true for some test code to be run somewhere
      common/Testit/ lgTestIt , lgTestOn
*
*     called if test code is in place
      lgTestIt = .true.
*
      end
******************************************************************************
      real function TexcLine(t)
      implicit none
*derive excitation temperature of line from contents of line array
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real t(nta)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      real te , eden , hden
      common/phycon/ te , eden , hden
*
*     routine to evaluate line excitation temp using contents of line array
*
      if( t(ipLnPopu)*t(ipLnPopl).gt.0. ) then
        TexcLine = (t(ipLnPopu)/t(ipLnGu)) / (t(ipLnPopl)/t(ipLnGl))
        TexcLine = -t(ipLnBolt) / log(TexcLine)
      else
        TexcLine = 0.
      endif
*
      end
******************************************************************************
      subroutine tfidle
      implicit none
*update some temperature dependent variables
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      real teinv
      common/teinv/ teinv
      real dCooldT , tsq1 , halfte
*derivative of cooling, 1/te^2, .5/T
      common/dcool/ dCooldT , tsq1 , halfte
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real edensqte , cdsqte
*edensqte is eden/sqrte, cdsqte is this times 8.629e-6
      common/edsqte/ edensqte , cdsqte
      real SqrtEden
*square root of electron density, set in tfidle
      common/sqrne/ SqrtEden
      real alogte , alogne , alogete
*     alogte is base 10 log, alogete base e
      common/logte/ alogte , alogne , alogete
      real te , eden , hden
      common/phycon/ te , eden , hden
      real telogn
      common/telogn/ telogn(7)
      real hi , hii
      common/h/ hi , hii
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real ttused , edused
      integer i
      save ttused,edused
      data ttused,edused/2*0./
*
*begin sanity check
      if( te.le.0. ) then
        write(qq,'('' TFIDLE has been called with a negative'',
     1  '' temperature,'',1p,e10.3)') te
        write(qq,'('' This is zone'',i5,'' iteration'',i5)')
     1  nzone,iter
        call ShowMe
        stop
      endif
*end sanity check
*
      if( te.ne.ttused ) then
        ttused = te
        sqrte = sqrt(te)
        halfte = 0.5 / te
        tsq1 = 1. / (te**2)
        te32 = te * sqrte
        te70 = te ** 0.70
        te30 = te ** 0.30
        te20 = te ** 0.20
        te10 = te ** 0.10
        te05 = te ** 0.05
        te03 = te ** 0.03
        te02 = te ** 0.02
        te01 = te ** 0.01
        te005 = te** 0.005
        te003 = te** 0.003
        te001 = te** 0.001
        teinv = 1. / te
        alogte = log10( te )
        alogete = log( te )
        telogn(1) = alogte
        do i=2,7
          telogn(i) = telogn(i-1) * telogn(1)
        end do
      endif
*
*     check that eden now negative
      if( eden.le.0. ) then
        write(qq,'('' I found a zero or negative electron density,'',
     1  1p,e10.2)') eden
        stop
      endif
*
*     term with hi added June 4, 93, to account for warm pdr
      edensqte = (eden+hi/1e4) / sqrte
      cdsqte = edensqte * 8.629e-6
*
      if( eden.ne.edused ) then
        edused = eden
        SqrtEden = sqrt( eden )
      endif
*
      end
******************************************************************************
      subroutine tfirst( lgOK )
      implicit none
*drive search for initial temperature, for illuminated face
      logical lgOK
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer limelm
      parameter (limelm=30)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      integer MapZone , nMapStep
      real RangeMap
*parameters doing with map command, MapZone is zone number,
* -1 for very start
* RangeMap is range, parsed from same command
* nMapStep is number of steps, set with set nmap command
      common/MapPar/ MapZone , RangeMap(2), nMapStep
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      real telow , tehigh
*     this is the default lowest to highest temperature checked
      common/telow/ telow , tehigh
      logical lgNoDec
*flag saying that temperature is being decremented in initial search for temp
      common/nodec/ lgNoDec
      logical lgIonDone
*whether or not the ionization balance is converged
      common/iondun/ lgIonDone
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      logical lgColNeg
*set false during during search for equilibrium temp
*check whether to complain about negative cooling
      common/colneg/ lgColNeg
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgTeHigh
*flag set if temperature map is from hot to cool, set with high command
      common/thigh/ lgTeHigh
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real te , eden , hden
      common/phycon/ te , eden , hden
      real PressureInit
*     this is the total pressure at the illuminated face
      common/PresInit/ PressureInit
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      character*10 chInCvgRsn
      common/InCvgRsn/ chInCvgRsn
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real xmultp , trig,told,cold,hold,tnew,cnew,hnew,dt,
     1 TotalPressure,dc,factor,sign,tmin,tmax,t1,t2 ,tinc , fac2
      integer ionlup,loop,isear,j,i , looplimit , nThLoop
*     XMULTP is scale factor to multiply temperature
      parameter (xmultp=3.0)
      double precision derrdt
      real tsave
      save tsave
*
*     free statement labels =>9
*
*     turnon photo rate evaluation
      lgDoPhoto = .true.
*
      if( lgTrConvg ) then
        write(qq,'(''  '')')
        write(qq,'('' TFIRST entered '')')
      endif
*
*     if MapZone LT 0, just map first zone and punch out
      if( MapZone .le. 0 ) then
        if( lgTrace .or.lgTrConvg)
     1  write(qq,'('' TFIRST called.  just map'')')
        call punt(' map')
        lgOK = .false.
        return
      endif
*
*     force an initial temperature, also constant temperature
      if( ForceTemp .ne. 0. ) then
*       force te to certain value
        if(lgTrace) then
          write(qq,'('' TFIRST called, forcing TE to'',1P,E10.2)')
     1    ForceTemp
        end if
        te = ForceTemp
        PressureInit = TotalPressure()
*       say this is search for first solution, let Ne change a lot
        lgSearch = .true.
*
        ionlup = 0
        lgIonDone = .false.
*     >>chng 96 oct 11, loop at least 3x to make sure ionization converged
        do while( ionlup.le.3 .or.(.not.lgIonDone.and.ionlup.le.7) )
*         lgIonDone can be set false by several tests in ionize
          lgIonDone = .true.
          lgNewIon = .true.
          lgDoPhoto = .true.
          call ionize
*         only used to keep forcing new optical depths below
          ionlup = ionlup + 1
          call coolr( ctot , dc )
*         force reevaluation of H trans rates
          htnext(3,2) = htnext(3,2) * 0.9999
        end do
        if( ionlup.gt.1) then
*         repair damage done above
          htnext(3,2) = htnext(3,2) / ( 0.9999**ionlup )
        endif
        lgSearch = .false.
        lgOK = .true.
        return
      endif
*
*     check if this is second or higher iteration
      if( iter .ne. 1) then
*       this is second or higher iteration on multi-iteration model
        if(lgTrace.or.lgTrConvg) write(qq,'('' TFIRST called, ITER='',
     1  I2,'' resetting Te to '',1P,E10.2)') iter , tsave
        lgSearch = .false.
        te = tsave
        PressureInit = TotalPressure()
        do i=1,2
          lgNewIon = .true.
          lgDoPhoto = .true.
          call ConvIoniz
          call coolr( ctot , dc )
*         coolr evaluates level pops, needed for following
          call MakeRT
          tsave = te
        end do
*       now get final temperature
        call ionte( nThLoop ,0 )
        lgOK = .true.
        return
      endif
*
*     do first te from scratch
      lgSearch = .true.
      if( lgTrace ) write(qq,'('' TFIRST called, new temperature.'')')
*
*     approach equilibrium from either high or low TE
      if( lgTeHigh ) then
*       approach from high TE
        te = 1e6
        lgNoDec = .false.
        factor = 1. / xmultp
      else
*       approach from low TE
        lgNoDec = .true.
        te = 4000.
        factor = xmultp
      endif
*
*     find first temperature
      lgColNeg = .false.
      PressureInit = TotalPressure()
*
      htot = 1.
      ctot = 1.
*     call cooling, heating, opacity, loop to convergence
*     this is very first call to it, by default is at 4000K
      if( lgTrConvg ) then
        write(qq,'('' TFIRST calling cholup1 with te='',1p,e10.3)')te
      endif
      call cholup( dc , loop )
      if( lgTrace )then
        write(qq,'('' TFIRST first temp after'',I3,'' trys'')')
     1  loop
      end if
*     >>chng 97 feb 18, define following three
      told = te
      cold = ctot
      hold = htot
*
      if( lgTrace ) write(qq,'('' RETURN TO TFIRST 1, HTOT:'',1P,E10.3,
     1''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e11.4,25(''<''))')
     2 htot , ctot , te,eden
*
*     sign is cooling minus heating, in most cases negative means T too low
      sign = abs(ctot-htot) / (ctot-htot)
*
*     if low te approach then check if already past soln (cooling > heating)
      if( .not.lgTeHigh .and. sign.ge.0. ) then
        if( lgTrConvg ) then
          write(qq,'('' TFIRST entering T<tfirst loop, te htot ctot='',
     1    1p,3e10.3,'' sign='',e9.1)')te,htot,ctot,sign
        endif
*       check range 10 - 4000K, TELOW usually 2.8K, set with SET LOWEST command
*     >>chng 96 may 30, logic had gone straight to 3K, which blew up dense cloud
*       now go down more gently
*     >>chng 97 mar 3, variable factor, smaller when close to 3K
        fac2 = 0.8
        do while( te*fac2 .gt.telow .and. sign.ge.0. )
*     >>chng 96 June 14, to below, so that we can get soln near 3K
*       do while( te.gt.telow .and. sign.ge.0. )
*     >>chng 97 feb 18, define following three
          told = te
          cold = ctot
          hold = htot
*     >>chng 97 mar 3, make fac2 small when close to lower bound
          if( te.lt.5. ) then
            fac2 = 0.97
          else if( te.lt.20. ) then
            fac2 = 0.9
          else
            fac2 = 0.8
          endif
*         now change to new temp
          te = te * fac2
*         te = telow
          PressureInit = TotalPressure()
*         call cooling, heating, opacity, loop to convergence
          if(lgTrConvg) write(qq,'(/'' calling cholup2, te='',1p,e9.2)')
     1    te
          call cholup( dc , loop )
          tnew = te
          cnew = ctot
          hnew = htot
          if( lgTrConvg ) then
            write(qq,'('' cholup2 returns, te='',1p,e9.2,'' htot'',e9.2,
     1      '' ctot'',e9.2)') te, htot , ctot
          endif
          if( lgTrace .or. lgTrConvg) then
            write(qq,'('' RETURN TO TFIRST 2  HTOT:'',1P,E10.3,
     1      ''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e11.4,25(''<'')
     2      )') htot , ctot , te,eden
          endif
          sign = abs( ctot-htot ) / (ctot-htot)
        end do
        if( ctot.gt.htot ) then
*         even at lowest temp, too much cooling; no solution possible
          write(qq,'('' Equilibrium temperture below T='',1P,E8.2,
     1    ''.  If this is OK, then reset with LOWEST command.'',
     2    ''  This is TFIRST.  TELOW was'',e9.2)') te,telow
          lgOK = .false.
          return
        endif
*     >>chng 97 mar 3, from *0.9 to / fac2
        te = te / fac2
        factor = 1./(0.5*(1.+fac2))
        sign = abs( cold-hold ) / (cold-hold)
        if( lgTrConvg ) then
          write(qq,'('' <4000K loop returns, te='',1p,e9.2,'' sign'',
     1    e9.2,'' factor'',e9.2)') te , sign , factor
        endif
      endif
*
      tmin = 1e9
      tmax = 0.
*     coming up to here te is either 4,000 (usually) or 10^6
      t1 = telow / 1.001
*     >>chng 96 dc 28, added div by factor to prevent checking on temp > 1e10
      t2 = tehigh * 1.001 / factor
      if( lgTrConvg ) then
        write(qq,'('' TFIRST entering second loop te='',1p,e9.2,
     1  '' sign'',e9.2,'' factor'',e9.2,'' t1, t2='',2e10.2)') te,
     2  sign ,factor, t1,t2
      endif
      do while ( (ctot-htot)*sign.gt.0. .and. te.gt.t1 .and. te.lt.t2 )
*     >>chng 97 feb 18, define following three
        told = te
        cold = ctot
        hold = htot
        te = te * factor
        PressureInit = TotalPressure()
        tmin = min( tmin , te )
        tmax = max( tmax , te )
        lgIonDone = .false.
        chInCvgRsn = 'TFIRST srh'
        isear = 1
        do while( isear.le.6 .and. .not.lgIonDone )
*         call cooling, heating, opacity, loop to convergence
          lgIonDone = .true.
          if(lgTrConvg)write(qq,'(/'' calling cholup3, te='',1p,e9.2)')
     1    te
          call cholup( dc , loop )
          if( lgTrConvg ) then
            write(qq,'('' cholup3 returns, te='',1p,e9.2,'' htot'',e9.2,
     1      '' ctot'',e9.2)') te, htot , ctot
          endif
          if( lgTrace ) then
            write(qq,'('' RETURN TO TFIRST 3  HTOT:'',1P,E10.3,
     1      ''  ctot:'',e10.3,''  Te:'',e11.4,'' eden'',e11.4,25(''<'')
     2      )') htot , ctot , te,eden
          endif
          isear = isear + 1
        end do
        tnew = te
        cnew = ctot
        hnew = htot
      end do
*
*     fall through loop, te too high or low
      if ( te.le.t1 .or. te.ge.t2 ) then
        if( te.le.t1 ) then
          write(qq,'('' TFIRST finds TE below TE = '',1P,E10.3,
     1    ''K, HTOT='',E12.4,'' CTOT='',E12.4)')
     2    t1 , htot , ctot
        else if( te.ge.t2 ) then
          write(qq,'('' TFIRST finds TE above TE = '',1P,E10.3,
     1    ''K, HTOT='',E12.4,'' last CTOT='',E12.4)')
     2    t2 , htot , ctot
        else
          write(qq,'('' TFIRST finds insanity '')')
          call ShowMe
        endif
        lgOK = .false.
        return
      endif
*
*     now search inside (also either side of) TE range where sign changed
*     first turn on ionization stage trimming
      lgNoDec = .false.
      lgColNeg = .true.
*
      trig = te
*     change sense of temp search so that we can "weave" into soln
      tinc = 1./factor ** 0.2
*
      do j=1,2
        if( (ctot-htot.gt.1e-30).and.ctot.gt.0. ) then
          sign = abs( ctot-htot ) / (ctot-htot)
          if(lgTrConvg)write(qq,'(//'' >>>entering second loop, te '',
     1    ''reset to'',1p,e9.2)') te
          PressureInit = TotalPressure()
*         call cooling, heating, opacity, loop to convergence
          isear = 1
          lgIonDone = .false.
          if( lgTrace ) then
            write(qq,'('' RETURN TO TFIRST 4  HTOT:'',1P,E10.3,
     1      ''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e11.4,25(''<'')
     2      )') htot , ctot , te,eden
          endif
          i = 0
*         looplimit = 8
*         >>chng 97 july 29, to recover fumbled initial ionizatino
          looplimit = 12
          told = te
          cold = ctot
          hold = htot
*         this loop is not necessariy executed (ctot and htot very close)
          do while( i.lt.looplimit .and. (ctot-htot)*sign.gt.0. )
            i = i + 1
            told = te
            cold = ctot
            hold = htot
            te = te * tinc
            PressureInit = TotalPressure()
            lgNewIon = .true.
            lgDoPhoto = .true.
            call cholup( dc , loop )
            if( lgTrConvg ) then
              write(qq,'('' cholup returns, te='',1p,e9.2,'' htot'',e9.2
     1        ,'' ctot'',e9.2)') te, htot , ctot
            endif
            tnew = te
            cnew = ctot
            hnew = htot
            if( lgTrace ) write(qq,'('' RETURN TO TFIRST 4  HTOT:'',1P,
     1      E10.3,''  CTOT:'',E10.3,''  Te:'',E11.4,'' EDEN'',e11.4,
     2      25(''<''))') htot,ctot,te,eden
          end do
          if( i.ge.looplimit .and. (ctot-htot)*sign.gt.0. .and.
     1      abs(ctot/htot-1.).gt.0.05 ) then
*     >>chng 96 dec 17, way out for dense, cold, molecular gas
            if( te.lt.1e3 .and. co/xIonFracs(6,0).gt.0.5 ) then
              write(qq,'('' cold molecular trap, te='',1p,e10.2,
     1        '' F(CO)='',e10.2)') te,co/xIonFracs(6,0)
              write(qq,'('' Conditions in this cloud are not '',
     1        ''appropriate for this code.'')')
              lgOK = .false.
              return
            else
              write(qq,'('' Insanity occurred in tfirst, i=0'')')
              call ShowMe
              stop
            endif
          endif
*         weave back in again
          tinc = 1./tinc ** 0.2
        endif
      end do
      if( lgTrConvg ) write(qq,'('' search set false'')')
      lgSearch = .false.
*
*     now must be close enough to call regular ionization-cooling
*     first do linear interpolation to guess temperature
      if( tnew.ne.told .and.tnew.gt.0..and.told.gt.0. ) then
        derrdt = dble((cnew-hnew)-(cold-hold)) / dble(tnew-told)
        dt = -dble(cold-hold) / derrdt
        te = told + dt
        te = max( te , min(told,tnew) )
        te = min( te , max(told,tnew) )
        PressureInit = TotalPressure()
      endif
      if( lgTrace ) then
        write(qq,'('' TFIRST calls IONTE after interpolating''
     1  ,'' a temperature of'',1p,e10.3,'' Told='',e10.2,'' Tnew='',
     2  e10.2,'' dC-Hold'',e10.2,'' dC-Hnew'',e10.2)') te , told,tnew,
     1 (cold-hold),(cnew-hnew)
      end if
      if(lgTrConvg)write(qq,'(//'' >>>calling ionte with interpolated'',
     1'' te='',1p,e10.3)') te
      call ionte( nThLoop , 0 )
      tsave = te
      if( lgTrace ) then
        write(qq,'('' TFIRST return, TE:'',1P,E10.2,18(''=''))')
     1  te
      endif
*
      lgOK = .true.
*
      end
******************************************************************************
      subroutine theavy( ndim )
      implicit none
*time dependent heavy element ionization balance
*this routine currently does not do anything
      integer l,n,ndim
      integer limelm
      parameter (limelm=30)
      real ar( limelm )
*
      real timefc
      common/timefc/ timefc
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
*
*     local variables
      integer i,n1
      real change , rec
*
*     none of this can possibly work
      n = 0
      n1 = n - 1
      rec = 0.
      do i=l,n1
*       rec = c( i-l+1 , 2 )*dt
        change = ar(i+1) * (1.-exp(-rec) )
        ar(i) = (ar(i) + change) * timefc
        ar(i+1) = ar(i+1) - change
      end do
      l = 1
*
      end
******************************************************************************
      subroutine timer
      implicit none
*time dependent models
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      real timefc
      common/timefc/ timefc
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real hi , hii
      common/h/ hi , hii
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real te , eden , hden
      common/phycon/ te , eden , hden
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real time,rad,TotalPressure,psave,dcdt,coll,sexp,c31,dion,
     1 change,rec,fac
      integer i,loop
      data change/40./
*
*     time dependent rec-col behind shock with no radiation.
*     initial conditions set by physical conditions in last zone
*
      nflux = -1
      time = 0.
*     this is the flag that will be used to say time-dep model
      itime = -1
      rad = 0.
      call prstep
      nzone = 1
      timefc = 1.
      power = 0.
      totcol = 0.
      GrossHeat = 0.
      htot = TotalPressure() * 1.5
      psave = htot
      if( lgTalk ) write(qq,'(''1'',30X,''TIME DEPENDENT MODEL OF ZONE''
     1 ,I3,'' THERMAL ENERGY='',1P,E10.3)') itime, psave
*
*     clear out line array
      do i=1,NLINES
        sumlin(i) = 0.
      end do
*
*-------------------------------------------------------------------
*     choose dt to 1/change of cooling time
*     continue until TE drops below TEND
      do while( te.gt. tend )
        call coolr( ctot , dcdt )
        dt = htot / ctot / change
*
*       hydrogen
*       soln of rad trans like eqn for ioniz of h
        coll = 1.03e-11 * sexp(1.579e5/te) * te**0.652
        if( te .lt. 2e4 ) rec = 2.9e-10/(te70*te10/te03)
        if( te .ge. 2e4 ) rec = 1.31e-8/(te*te10*te03)
*
        fac = sexp( eden * (rec+coll) * dt )
        hii = hden * coll/(coll+rec) * (1.-fac) + hii*fac
        hi = hden - hii
*
*       helium + => 0
        rec = 9.96e-11 * te**( -0.669 )
        c31 = 1.074e-5 / sqrte * exp(-1.15e4/te )
        hei3 = rec * eden * heiii / (c31*eden+1.27e-4)
        dion = heii * (1.-exp(-eden*dt*rec*1.3333) )
        hei1 = (hei1 + dion) * timefc
        hei = (hei + dion) *timefc
        heii = (heii - dion) * timefc
*
*       helium ++ => +
        dion = heiii * (1.-exp(-eden*dt*2.44e-9/(te70*te10 ) ))
        heiii = (heiii - dion )* timefc
        heii = (heii + dion) * timefc
*
*       heavy elements
        call carbon
        call nitrog
        call oxygen
        call neon
        call magnes
        call alumin
        call silicn
        call sulphr
        call clrine
        call argoni
        call calcm
        call iron
        call cobalt
        call nickel
*
*       get new electron density, find emission spectrum and rATE
        drad = dt
        call esum
        call lines
        depth = time
        if((nzone/nprint)*nprint.eq.nzone)call prstep
        nzone = nzone + 1
        htot = htot - ctot * dt
*
        if( htot.lt. 0. ) then
          if( lgTalk ) write(qq,'('' htot is <0, htot, ctot, dt='',3(1p,
     1    e12.3))') htot , ctot , dt
          stop
        endif
*
        te = te * htot / (htot+ctot*dt)
        rad = rad + ctot * dt
        time = time + dt
*
*       following for density changing with time
        timefc = 1.
*       if( tmpwr.eq.0. ) go to4
        if( tmpwr.ne.0. ) then
          timefc = ( (tmt1+dt)/tmt1 ) ** tmpwr
          chCPres = 'TIME'
          loop = 0
          call presur( loop )
          tmt1 = tmt1 + dt
          htot = htot * timefc
        endif
      end do
*     go to4
*
      power = psave
      totcol = rad
      call prstep
      call final
*
      end
******************************************************************************
      subroutine titani
      implicit none
*determine ionization balance for titanium
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (nelem=22)
      parameter (ndim=23)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real FYIELD(nelem) , GRDEFF(nelem)
*
*     titanium nelem=22
*     based on iron
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.26E-10,4.97E-11,1.49E-10,3.90E-11,1.66E-11,7.16E-12,
     1 3.00E-12,1.02E-12,2.54E-12,1.70E-12,1.11E-12,6.42E-13,3.59E-13,
     2 9.30E-14,1.62E-14,5.97E-14,8.44E-14,5.92E-14,4.72E-14,3.79E-14,
     3 2.60E-14,1.61E-14/
      data (cion(i,2),i=1,ndim-1)
     1 /9.13E4,1.88E5,3.56E5,6.36E5,8.70E5,1.15E6,1.45E6,1.75E6,
     2 2.73E6,3.04E6,3.37E6,3.84E6,4.19E6,4.55E6,5.30E6,5.68E6,
     3 1.47E7,1.58E7,1.69E7,1.84E7,1.96E7,2.09E7/
*
*     DATA FYIELD/2*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47,.48, 3*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/nelem*0.2/
*
*     Fe rates from Woods et al. Ap.J. 249, 399.
*     rec from +23, 24 25 from Arnauld et al 85
      data rec,pl
     1/ 5.2E-10 , 2.40E-9 , 3.20E-9 , 4.17E-9 , 9.44E-9 , 2.14E-8
     2, 4.48E-8 , 8.75E-8 , 1.41E-7 , 2.26E-7 , 2.73E-7 , 3.56E-7
     3, 4.42E-7 , 5.52E-7 , 7.00E-7 , 8.59E-7 , 8.55E-7 , 8.93E-7
     4, 9.64E-7 , 1.06E-6 , 1.19E-6 ,
     1  -0.891  , -0.843  , -0.746  , -0.682  , -0.699  , -0.728
     2, -0.759  , -0.790  , -0.810  , -0.829  , -0.828  , -0.834
     3, -0.836  , -0.840  , -0.846  , -0.850  , -0.836  , -0.824
     4, -0.816  , -0.811  , -0.808 /
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.28e-10 , -0.686 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.58E-3  , 8.38E-3  , 1.54E-2, 3.75E-2, 0.117   , 0.254
     2, 0.291   , 0.150   , 0.140   , 0.100   , 0.200   , 0.240
     3, 0.260   , 0.190   , 0.120   , 0.350   , 0.066   , 0.10
     4, 0.13    , 0.23    , 0.14
     5, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/ .456    , .323    , .310    , .411    , .359    , .0975
     1, .229    , 4.20    , 3.30    , 5.30    , 1.50    , 0.700
     1, .600    , .5      , 1.      , 0.      , 7.8     , 6.3
     1, 5.5     , 3.6     , 4.9
     1, 0./
      data (dite(i,1),i=1,ndim-1)
     1/ 6.00E4  , 1.94E5  , 3.31E5  , 4.32E5  , 6.28E5  , 7.50E5
     2, 7.73E5  , 2.62E5  , 2.50E5  , 2.57E5  , 2.84E5  , 8.69E5
     3, 4.21E5  , 4.57E5  , 2.85E5  , 8.18E5  , 1.51E6  , 1.30E6
     4, 1.19E6  , 1.09E6  , 9.62E5
     5, 0./
      data (dite(i,2),i=1,ndim-1)
     1/8.97E4   , 1.71E5  , 2.73E5  , 3.49E5  , 5.29E5  , 4.69E5
     2,6.54E5   , 1.32E6  , 1.33E6  , 1.41E6  , 1.52E6  , 1.51E6
     3,1.82E6   , 1.84E6  , 2.31E6  , 0.      , 9.98E6  , 9.98E6
     4,1.00E7   , 1.10E7  , 8.34E6
     5 , 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5
     5, 1E20    /
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy( nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************
      subroutine TooManCon
      implicit none
*say that too many continua have been entered
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*     too many continua were entered
      write(qq,'('' Too many continua entered; increase LIMSPC''
     1)')
      stop
      end
******************************************************************************
      real function TotalPressure()
      implicit none
*determine the gas and line radiation pressures for current conditions
      real amu
      parameter (amu=1.660531e-24)
*     this is the Boltzmann factor, erg/K
      real Boltzmann
      parameter (Boltzmann=1.380658e-16)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer limelm
      parameter (limelm=30)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      logical lgPradCap , lgPradDen
*lgPradCap true if radiation pressure capped on first iteration
*lgPradDen capped by thermalization length
      common/prdcap/ lgPradCap , lgPradDen
      logical lgRadPrsON
*flag true if radiation pressure is turned on, part of total pressure
      common/radpon/ lgRadPrsON
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      integer iprdmx
      common/iprdmx/ iprdmx
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real xMassDensity , pden , wmole
*xMassDensity grams per cc
      common/densty/ xMassDensity , pden , wmole
      logical lgConPres
*flag saying whether or not incident continuum should be included
*in total pressure, turned off with constant gas pressure
      common/conprs/ lgConPres
      real CollidDensity
*total number of colliders (atoms, ions, molecules) in gas, no electrons
      common/collid/ CollidDensity
      real pinit , pinteg , pinzon
      common/pinteg/ pinit , pinteg , pinzon
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      real totnuc
*     totnuc is total number of nuclei and molecules, eval in ptot
      common/totnuc/ totnuc
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real AtomicWeight
*stored vector of atomic weights for all elements, set in block data scalar
      common/AtomcWgt/ AtomicWeight(limelm)
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
*
*     local variables
      real pmx
      real WidthLine , RadPres1, HHeLines
      integer i,ip
*
*     function TotalPressure - evaluate total pressure
*     this function has a single dummy argument
*     this function evaluates the following
*     TotalPressure - gas and radiation pressure, dynes/cm^2
*     GasPres gas pressure, same units
*
*     HDEN is defined as total hydrogen nuclei density; all forms
*     present abarb with carbon monoxide
*
*     TOTNUC is total number of nuclei and molecules
*     nelem,0 is abundance of nelem
      totnuc = 0.
      do i=1,limelm
        totnuc = totnuc + xIonFracs(i,0)
      end do
*
*      add on molecules
       totnuc = totnuc +
     1 htwo + h2plus + hminus + ch + chp +
     2 oh + ohp + otwo + ctwo + co + cop + h2o + h2op + o2p + c2p +
     3 h3p + h3op + ch2p + ch2 + ch3 + h3plus
*
*     pden is the total number of particles per unit vol
      pden = eden + totnuc
*
*     this is total neutral particle density for collisional ionization
      CollidDensity = 0.
      do i=1,limelm
        CollidDensity = CollidDensity + xIonFracs(i,1)
      end do
*
      CollidDensity = CollidDensity + h2plus + hminus + ch + chp +
     2 oh + ohp + otwo + ctwo + co + cop + h2o + h2op + o2p + c2p +
     3 h3p + h3op + ch2p + ch2 + ch3 + h3plus + 2.*htwo
*
*     gas pressure
      GasPres = pden * te * Boltzmann
*
*     WMOLE is molecular weight, amu per particle
      wmole = 0.
      do i=1,limelm
        wmole = wmole + xIonFracs(i,0)*AtomicWeight(i)
      end do
*
      wmole = wmole +  ch*13. + chp*13. + oh*17. + ohp*17. + otwo*32. +
     3 ctwo*24. + co*28. + cop*28. + h2o*18. + h2op*18. + o2p*32. +
     4 c2p*24. + h3p*3. + h3op*19. + ch2p*14. + ch2*14. + ch3*15.
*
      wmole = wmole / pden
*
*     xMassDensity is grams per cc
      xMassDensity = wmole * amu * pden
*
*     RadPres is pressure due to lines, lgRadPresON turns off or on
      RadPres = 0.
      pmx = 0.
*     find max rad pressure even if capped
*     lgRadPrsON is turned off by NO RADIATION PRESSURE command
      if( lgRadPrsON ) then
*       plines(1)=l-alpha,          in hlevel(ionize)
*       plines(2) = hign n lyman ;   plines(3)=excit h lines iN HLEVEL
*       plines(4) = he i 10830
*       plines(5)= HeII 304 plines(11)=HeI La (in helium)
*       plines(6)= HeI 584
*
*       compute radiation pressure due to special H and He lines
        HHeLines = 0.
        do i=1,20
          if( plines(i).gt.pmx ) then
            pmx = plines(i)
            ip = i
          endif
          HHeLines = HHeLines + plines(i)
        end do
*
        RadPres = HHeLines
*
*       line radiation pressure from large set of level 1 lines
        do i=1,nTauLines
          if( TauLines(ipLnPopu,i).gt.1e-30 ) then
            RadPres1 = 5.551e-2*((TauLines(ipLnEnrWN,i)/1.e6)**4)*
     1      ( TauLines(ipLnPopu,i) / TauLines(ipLnGu,i) ) /
     2      ( TauLines(ipLnPopl,i) / TauLines(ipLnGl,i) ) *
     2      WidthLine(TauLines(1,i)) * 2.
            RadPres = RadPres + RadPres1
          endif
        end do
        do i=1,NWINDLINE
          if( WindLine(ipLnPopu,i).gt.1e-30 ) then
            RadPres1 = 5.551e-2*((WindLine(ipLnEnrWN,i)/1.e6)**4)*
     1      ( WindLine(ipLnPopu,i) / WindLine(ipLnGu,i) ) /
     2      ( WindLine(ipLnPopl,i) / WindLine(ipLnGl,i) ) *
     2      WidthLine(WindLine(1,i)) * 2.
            RadPres = RadPres + RadPres1
          endif
        end do
*       call broken
*       everything but Lya
*       write(66,'(1p,2e10.2)') HHeLines , RadPres
      endif
*
*     PBETA is ratio of radiation to gas + continuum pressure
      if( lgConPres ) then
*       this includes integrated incident continuum
        pbeta = RadPres / ( GasPres + pinteg )
      else
*       this does not
        pbeta = RadPres / GasPres
      endif
*
*     stop model from running away on first iteration, when line optical
*     depths are not defined correctly anyway.
*     if( iter.le.itermx .and. RadPres.ge.GasPres ) then
*     >>chng 97 july 23, only cap radiation pressure on first iteration
      if( iter.le.1 .and. RadPres.ge.GasPres ) then
        RadBetaMax = max( RadBetaMax , pbeta )
*       stop RadPres from exceeding the gas pressure on first iteration
        RadPres = min( RadPres , GasPres )
        lgPradCap = .true.
      endif
*
      if( lgRadPresON ) then
        TotalPressure = GasPres + RadPres
      else
        TotalPressure = GasPres
      endif
*
      if( pbeta.ge.RadBetaMax ) then
        RadBetaMax = pbeta
        iprdmx = ip
      endif
*
*     remember highest pressure anywhere
      PresMax = max( PresMax , TotalPressure )
*
      end
******************************************************************************
      real function totlin( chInfo )
      implicit none
*sum total intensity of cooling, recombination, or intensity lines
      character*1 chInfo
*
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
*
*     routine goes through set of entered line
*     intensities and picks out those which have
*     types agreeing with chInfo.  Valid types are
*     'c', 'r', and 'i'
*begin sanity check
      if( chInfo.ne.'i'.and.chInfo.ne.'r' .and.
     1 chInfo.ne.'c' ) then
        write(qq,'('' TOTLIN does not understand chInfo='',a1)') chInfo
        stop
      endif
*end sanity check
*
*     now find sum of lines of type chInfo
      totlin = 0.
      do i=1,nsum
        if( chSumTyp(i).eq.chInfo ) then
          totlin = totlin +  sumlin(i)
        endif
      end do
*
      end
******************************************************************************
      subroutine TrimCard( chCard )
      implicit none
*trim off any part of line image after end of line characters
      character chCard*80
*
*     local variables
      integer i , i1 , i2 , i3
*
*     find whether one of line ends present
      i1 = index(chCard,':')
      if( i1.eq.0 ) i1 = 80
      i2 = index(chCard,';')
      if( i2.eq.0 ) i2 = 80
      i3 = index(chCard,'%')
      if( i3.eq.0 ) i3= 80
*
*     now pick smallest of the lot
      i1 = min( i1 , i2 , i3 )
*
      do i=i1,76
        chCard(i:i)  = ' '
      end do
*
      end
******************************************************************************
      subroutine TrimStages(nelem)
      implicit none
*raise or lower most extreme stages of ionization considered
      integer nelem
*
*     real trimhi , trimlo
*     common/trimstg/ trimhi , trimlo
*     parameter (trimhi=1e-6)
*     parameter (trimlo=1e-10)
      integer limelm
      parameter (limelm=30)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
      real trimhi , trimlo
*limits for highest and lowest stages of ionization in TrimStage
      common/trimstg/ trimhi , trimlo
      integer IonLow(limelm) , IonHigh(limelm) , IonLowSave(limelm),
     1 IonHighSave(limelm)
*pointers to lowest and highest stages of ionization of the elements
*also places to save them
      common/IonRange/ IonLow , IonHigh , IonLowSave, IonHighSave
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      logical lgNoDec
*flag saying that temperature is being decremented in initial search for temp
      common/nodec/ lgNoDec
      logical lgTrimed
      common/Trimed/ lgTrimed
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*begin sanity check
      if( IonLow(nelem).le.0 ) then
        write(qq,'('' TrimStages called with LOW <1.'')')
        call ShowMe
        stop
      endif
*end sanity check
*
*     raise or lower highest and lowest stages of ionization to
*     consider only significant stages
*     IonLow(nelem) lowest stage of ionization
*     IonHigh(nelem)  stage of ionization
*
*     special trim if upper stages have zero abundance
      do while( xIonFracs(nelem,IonHigh(nelem))/xIonFracs(nelem,0).lt.
     1  1e-35 .and. IonHigh(nelem).gt.IonLow(nelem)+1 )
*       xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
        xIonFracs(nelem,IonHigh(nelem))  = 0.
        heating(nelem,IonHigh(nelem)-1) = 0.
        IonHigh(nelem) = IonHigh(nelem) - 1
      end do
*
      if( IonHigh(nelem) .eq. 2 ) return
*
*     trim down high stages
      if( .not.lgNoDec .and.
     1  xIonFracs(nelem,IonHigh(nelem))/xIonFracs(nelem,0)
     1  .le.trimhi .and.  IonHigh(nelem).gt.3) then
        xIonFracs(nelem,IonHigh(nelem))  = 0.
        heating(nelem,IonHigh(nelem)-1) = 0.
        IonHigh(nelem) = IonHigh(nelem) - 1
      endif
*
*     raise or lower lowest stage of ionization
      if( xIonFracs(nelem,IonLow(nelem))/xIonFracs(nelem,0).gt.1e-3
     1  .and.  IonLow(nelem).gt.1 ) then
*       lower lowest level of ionization
        IonLow(nelem) = IonLow(nelem)-1
*       tell code to do all photo rates
        lgTrimed = .true.
      else if( xIonFracs(nelem,IonLow(nelem))/xIonFracs(nelem,0).le.
     1  trimlo .and.  IonLow(nelem).lt.(IonHigh(nelem)-2) ) then
*       raise lowest level of ionization
        xIonFracs(nelem,IonLow(nelem))  = 0.
        heating(nelem,IonLow(nelem)) = 0.
        IonLow(nelem) = IonLow(nelem) + 1
      endif
*
      end
******************************************************************************
      subroutine twopht
      implicit none
*hydrogen two photon emission, including induced emission
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer nip2pht
*use to dimension two photon arrays
      parameter (nip2pht=3000)
      integer ipHalfLya, ip2pht(nip2pht)
      common/ip2pht/ ipHalfLya, ip2pht
      integer iphl
*     upper, lower pointers
      common/iphl/ iphl(lmhlvl,lmhlvl-1)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      reaL ri2s1s , ri1s2s
      common/rin2ph/ ri2s1s , ri1s2s
      real convoc , occnum
*     occnum is the continuum occupation number, attenuated incident ONLY
*     convoc is the conversion factor
      common/occnum/ convoc(ncell) , occnum(ncell)
      real Hy2nu, he12nu, he22nu
*Hy2nu is hydrogen two photon, others He1 and He2
      common/em2nu/ Hy2nu(ncell) , he12nu(ncell), he22nu(ncell)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      real xMax2Pht
      common/Max2Pht/ xMax2Pht
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgBug2nu
*flag set with trace two photon command
      common/bug2nu/ lgBug2nu
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
*
*     local variables
      integer i
      real sum
*
      if( .not. lgNewIon ) return
      ri2s1s = 0.
      if( .not. lgFluor ) return
      do i=1,ipHalfLya
        ri2s1s = ri2s1s + SummedOcc(i)* Hy2nu(i) *
     1  occnum( ip2pht(i) )
      end do
*     integral is symmetric
      ri2s1s = ri2s1s * 2.
*
*     remember maximum value
      xMax2Pht = max( xMax2Pht , ri2s1s )
*
      ri1s2s = ri2s1s * 1.
*
      if( lgTrace.and.lgBug2nu ) then
        write(qq,'(1p,2e12.4)') (anu(i),occnum(i),i=1,iphl(2,1),10)
*       sum two-nu A's to check OK
        sum = 0.
        do i=1,iphl(2,1)
          sum = sum + Hy2nu(i)
        end do
        write(qq,'(7X,''TWOPHT finds induced two photon rate ='',1P,
     1  E12.3,'' total A='',E12.3)') ri2s1s , sum
      endif
*
      end
******************************************************************************
      subroutine update
      implicit none
*update optical depth scale
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      integer nhetau
      parameter (nhetau=4)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer nfst
      parameter (nfst=39)
      integer ndfst
      parameter (ndfst=5)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      integer limelm
      parameter (limelm=30)
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
*     these are the integrated absorption and scattering optical depths
*     to the illuminated face of the cloud
      real depabs , depsct
      common/deptau/ depabs(ncell) , depsct(ncell)
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      real DoubleTau
*1 or two, set to double optical depth scale, set to 2 with double command
*default is 1
      common/double/ DoubleTau
      integer ipxry
      real tauxry
      common/xry/ ipxry , tauxry
      real he3tau
      common/he3tau/ he3tau(nta,nhetau)
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      logical lgStatic
*flag saying that spherical geometry is static, set with sphere static
      common/static/ lgStatic
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      real otsmin
      common/otsmin/ otsmin
      real escah , pmcah , ecah , tpcah , conca , conhe
      common/pmpcah/ escah , pmcah , ecah , tpcah(2) , conca , conhe
      integer nhe1
      common/nhe1/ nhe1(nhe1lvl+1)
      integer nhe2
      common/nhe2/ nhe2(nhe2lvl+1)
      logical lgAutoIt
      real autocv
      common/autoit/ lgAutoIt , autocv
      real telec , thmin
      common/taucon/ telec , thmin
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real ColDenSav
*save column densities from iteration to iteration, to check whether
*it changed by too much (a bad sign)
      common/ColDnSav/ ColDenSav(itrdim)
      real colden , chmin , colh2 , ch2pls , chi , chehp
      common/colden/ colden , chmin , colh2 , ch2pls , chi , chehp
      real TAddHLya,TAddHeI,TAddHeII
      common/TAddLya/ TAddHLya,TAddHeI,TAddHeII
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      real SolarSave , anova , apn , ahii, camern, aprim, aism
      common/solars/ SolarSave(limelm) , anova(limelm) , apn(limelm) ,
     1 ahii(limelm) , camern(limelm) , aprim(limelm) , aism(limelm)
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      logical lgPunConv
      integer ipPunConv
*     unit number, and flag, for punching reason for continued iterations
      common/PunConv/ lgPunConv , ipPunConv
      character chNotConverged*10
*     this gives the reason the model was declaired not converged
*     when 'iter to convergence' command is given
      common/NoConverge/ chNotConverged
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real ElecFrac
*ratio of electron to nuclei density, could be >1 because of he
*set in nockon
      common/efrac/ ElecFrac
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,j
      real totwid,f1,f2,fhe1,fhe2,receff,f , TauOff , OldDTau,
     1 AverFac , OldHe1DTau , OldEfrac
      save OldDTau , OldHe1DTau , OldEfrac
      logical lgConverged , lgTauOscil ,lgTauHeOscil , lgEverOscil
      save lgTauOscil ,lgTauHeOscil , lgEverOscil
*
*     save column density
      ColDenSav(iter) = colden
*
      if( lgTrace ) then
        write(qq,'(1X,''UPDATE estimating new optical depths'')')
        if( lgHBug .and.lgHBugFull) then
          write(qq,'(1X,''New Hydrogen outward optical depths:'')')
          write(qq,'(I3,1P,7E9.2)') (i,(htau(i,j),j=1,7),i=1,nhlvl)
        endif
      endif
*
*     pumping of CaH
      conca = max( sqrt(max(1.,log(max(1e-37,tpcah(1))))),
     1 (6.1e-5*tpcah(1))**0.5 )
      conhe = max( sqrt(max(1.,log(max(1e-37,htau(6,2))))) ,
     1 (1.7e-6*max(1e-37,htau(6,2))) ** 0.5 )
      totwid = 10.*conhe + 1.6*conca
*     if( totwid.gt.121. ) write(qq,'('' overlap'')')
      tpcah(2) = tpcah(1)
      tpcah(1) = taumin
*
*     this is an option to keep iterating until it converges
*     iterate to convergence option
*     autocv is percentage difference in optical depths allowed,
*     =0.20 in block data
      lgConverged = .true.
      chNotConverged = 'Converged!'
*     write(qq,'('' entering auto iter loop'')')
      if( iter.gt.1 .and. lgAutoIt ) then
*       check both H-alpha and Ly-alpha - only if balmer lines thick
        if( htau(3,2).gt. 0.5 ) then
          if( abs( htlim(2,1)/(htau(2,1)*DoubleTau)-1.).gt.autocv) then
*           not converged to within AUTOCV, normally 15 percent
            lgConverged = .false.
            chNotConverged = 'H Lya     '
            if(lgPunConv)write(ipPunConv,'('' H Lya'')')
          endif
          if( abs(htlim(3,2)/(htau(3,2)*DoubleTau)-1.).gt.autocv) then
*           not converged to within AUTOCV, normally 15 percent
            lgConverged = .false.
            chNotConverged = 'H Lya     '
            if(lgPunConv)write(ipPunConv,'('' H B a'')')
          endif
        endif
        if( lgHe1ON.and.(he1tau(2,1)-TAddHeI).gt.0.5 ) then
          if( abs(he1tau(2,1)*DoubleTau/he1lim(2,1)-1.).gt.autocv) then
            lgConverged = .false.
            chNotConverged = 'He1 Lya   '
            if(lgPunConv)write(ipPunConv,'('' He1 Lya'')')
          endif
        endif
        if( lgHe2ON.and.(he2tau(2,1)-TAddHeII) .gt.0.5 ) then
          if( abs(he2tau(2,1)*DoubleTau/he2lim(2,1)-1.).gt.autocv) then
            lgConverged = .false.
            chNotConverged = 'He2 Lya   '
            if(lgPunConv)write(ipPunConv,'('' He2 Lya'')')
          else if( he2tau(3,2).gt.0.5.and.
     1      abs(he2tau(3,2)*DoubleTau/he2lim(3,2)-1.).gt.autocv*2.) then
            lgConverged = .false.
            chNotConverged = 'He2 3-2   '
            if(lgPunConv)write(ipPunConv,'('' He2 3-2'')')
          else if( he2tau(4,3).gt.0.5.and.
     1      abs(he2tau(4,3)*DoubleTau/he2lim(4,3)-1.).gt.autocv*2.) then
            lgConverged = .false.
            chNotConverged = 'He2 4-3   '
            if(lgPunConv)write(ipPunConv,'('' He2 4-3'')')
          endif
        endif
        if(lgPunConv.and.lgConverged)write(ipPunConv,'('' converged'')')
*       lower limit to number of iterations if converged
        if(lgConverged) itermx = min( itermx , iter )
*
*     >>chng 96 dec 20, moved following to within if on lgAutoIt
*       this is test for stopping on first zone
        if( te.lt.tend .and. nzone.eq.1 ) then
          lgConverged = .true.
          chNotConverged = '          '
          itermx = min( itermx , iter )
        endif
      endif
*
*     must take average of old and new optical depths - were old in place?
*
      if( iter.le.1 ) then
*       this is first pass
        f1 = 1.
        lgTauOscil = .false.
        lgTauHeOscil = .false.
        lgEverOscil = .false.
      else
*     >>chng 96 june 6, kill logic for oscillations, do not use optical depths
*this was too conservative.  instead check whether i-front breaking out
*by looking at electron fractions
        if( (OldEfrac-0.98)*(ElecFrac-0.98) .lt.0. ) then
          f1 = 0.2
          lgTauOscil = .true.
        else
*         no oscillations, save to speed up convergence
          f1 = 0.75
          lgTauOscil = .false.
        endif
*       this will affect convergence speed - use 75% of new result,
*       25 old damping
*       dec 15 95 changed to 0.75 as per Kirk's tests on convergence
*       of Lya in blr
*       convergence for lines appears below in sep statement
*       first find out whether H or He lyman lines are oscillating
*       if( OldDTau*(htlim(2,1)-htau(2,1)*DoubleTau).lt.0. ) then
*         lgTauOscil = .true.
*         lgEverOscil = .true.
*       else
*         lgTauOscil = .false.
*         lgEverOscil = .true.
*       endif
*       if( OldHe1DTau*(he1lim(2,1)-he1tau(2,1)*DoubleTau).lt.0. ) then
*         lgTauHeOscil = .true.
*       else
*         lgTauHeOscil = .false.
*       endif
*       now find how much old and new to take
*       if( lgTauHeOscil.or.lgTauOscil ) then
*     >>chng 96 jan 10 was .5, change to .25 as per kirk's oscillating runs
*         f1 = 0.2
*       else if( lgEverOscil ) then
*         f1 = 0.3
*       else
*         f1 = 0.5
*       endif
*       write(qq,'('' were lyman lines oscillating??'',2l2)')
*    1  lgTauOscil,lgTauHeOscil
      endif
*     will use this to check on electron density oscillations
      OldEfrac = ElecFrac
      OldDTau = htlim(2,1) - htau(2,1)*DoubleTau
      OldHe1DTau = he1lim(2,1) - he1tau(2,1)*DoubleTau
      AverFac = f1
      f2 = 1. - f1
*
*     static is false unless sphere static set
      if( lgStatic ) then
        do i=2,nhlvl
          if( iter.eq.1 ) then
*           for initial iteration "zero" of ly a optical
*           scale may have been set to one in routine tauout
            TauOff = TAddHLya * hopac(i,1)/hopac(2,1)
          else
            TauOff = 0.
          endif
*         delta below is actual optical depth from illuminated face
*         NB - this code is only for static lines!
*         htlim(i,1) = (htau(i,1)-TauOff)*f1*DoubleTau + htlim(i,1)*f2
          htlim(i,1) = 10.**(
     1    log10(max(taumin,(htau(i,1)-TauOff)*DoubleTau))*f1 +
     1    log10(max(taumin,htlim(i,1)) )*f2 )
          if(htlim(i,1).le.0. ) then
*           this probably due to underflow above
            htlim(i,1) = TauOff / 1e6
          endif
          htnext(i,1) = htlim(i,1) / 2.
          htau(i,1) = htlim(i,1) / 2.
        end do
        do i=2,nhe1lvl
*         DoubleTau is usually 1, set to 2 with the DoubleTau option to
*         simulate two-sided photoionization
          if( iter.eq.1 ) then
            TauOff = TAddHeI * he1opc(i,1)/he1opc(2,1)
          else
            TauOff = 0.
          endif
*         he1lim(i,1) = (he1tau(i,1)-TauOff)*f1*DoubleTau + he1lim(i,1)*f2
          he1lim(i,1) = 10.**(
     1    log10(max(taumin,(he1tau(i,1)-TauOff)*DoubleTau))*f1 +
     1    log10(max(taumin,he1lim(i,1)) )*f2 )
          if(he1lim(i,1).le.0. ) then
*           this probably due to underflow above
            he1lim(i,1) = TauOff / 1e6
          endif
          he1nxt(i,1) = he1lim(i,1) / 2.
          he1tau(i,1) = he1lim(i,1) / 2.
        end do
        do i=2,nhe2lvl
          if( iter.eq.1 ) then
            TauOff = TAddHeII * he2opc(i,1)/he2opc(2,1)
          else
            TauOff = 0.
          endif
*         he2lim(i,1) = (he2tau(i,1)-TauOff)*f1*DoubleTau + he2lim(i,1)*f2
          he2lim(i,1) = 10.**(
     1    log10(max(taumin,(he2tau(i,1)-TauOff)*DoubleTau))*f1 +
     1    log10(max(taumin,he2lim(i,1)) )*f2 )
          if(he2lim(i,1).le.0. ) then
*           this probably due to underflow above
            he2lim(i,1) = TauOff / 1e6
          endif
          he2nxt(i,1) = he2lim(i,1) / 2.
          he2tau(i,1) = he2lim(i,1) / 2.
        end do
      else
        do i=2,nhlvl
          if( iter.eq.1 ) then
*           for initial iteration "zero" of ly a optical
*           scale may have been set to one in routine tauout
            TauOff = TAddHLya * hopac(i,1)/hopac(2,1)
          else
            TauOff = 0.
          endif
*         NB this is the expanding line sphere code
*         htlim(i,1) = (htau(i,1)-TauOff)*f1 * DoubleTau + htlim(i,1) * f2
          htlim(i,1) = 10.**(
     1    log10(max(taumin,(htau(i,1)-TauOff)*DoubleTau))*f1 +
     1    log10(max(taumin,htlim(i,1)) )*f2 )
          if(htlim(i,1).le.0. ) then
*           this probably due to underflow above
            htlim(i,1) = TauOff / 1e6
          endif
          htnext(i,1) = min(taumin,htlim(i,1)/2.)
          htau(i,1) = min(taumin,htlim(i,1)/2.)
        end do
        do i=2,nhe1lvl
*         DoubleTau is usually 1, set to 2 with the DoubleTau option to
*         simulate two-sided photoionization
          if( iter.eq.1 ) then
            TauOff = TAddHeI * he1opc(i,1)/he1opc(2,1)
          else
            TauOff = 0.
          endif
*         he1lim(i,1) = (he1tau(i,1)-TauOff)*f1*DoubleTau + he1lim(i,1)*f2
          he1lim(i,1) = 10.**(
     1    log10(max(taumin,(he1tau(i,1)-TauOff)*DoubleTau))*f1 +
     1    log10(max(taumin,he1lim(i,1)) )*f2 )
          if(he1lim(i,1).le.0. ) then
*           this probably due to underflow above
            he1lim(i,1) = TauOff / 1e6
          endif
          he1nxt(i,1) = min(taumin,he1lim(i,1)/2. )
          he1tau(i,1) = min(taumin,he1lim(i,1)/2. )
        end do
        do i=2,nhe2lvl
          if( iter.eq.1 ) then
            TauOff = TAddHeII * he2opc(i,1)/he2opc(2,1)
          else
            TauOff = 0.
          endif
*         he2lim(i,1) = (he2tau(i,1)-TauOff)*f1*DoubleTau + he2lim(i,1)*f2
          he2lim(i,1) = 10.**(
     1    log10(max(taumin,(he2tau(i,1)-TauOff)*DoubleTau))*f1 +
     1    log10(max(taumin,he2lim(i,1)) )*f2 )
          if(he2lim(i,1).le.0. ) then
*           this probably due to underflow above
            he2lim(i,1) = TauOff / 1e6
          endif
          he2nxt(i,1) = min(taumin,he2lim(i,1)/2.)
          he2tau(i,1) = min(taumin,he2lim(i,1)/2.)
        end do
      endif
*
*     >>chng 96 may 31, commented out below, so use same factors as before
*     if( lgTauOutOn ) then
*       these factors are used for excited H and He lines
*       this is to speed convergence for lines -
*       continuum appeared above in sep statement
*       f1 = 0.75
*     >>chng 96 jan 9, to below by analogy with lyman lines, have not tested
*       this is done in parallel with change from arith to log average
*       f1 = 0.5
*     >>chng 96 jan 12, change back to 0.75 to speed convergence
*       f1 = 0.75
*     else
*       f1 = 1.
*     endif
*     f2 = 1. - f1
*
      if( lgStatic ) then
        do j=2,nhlvl-1
          do i=j+1,nhlvl
*     >>chng 96 jan 9, had been arith average, now log
*           htlim(i,j) = htau(i,j) * f1 * DoubleTau + htlim(i,j) * f2
            htlim(i,j) = 10.**(
     1      log10(max(taumin,(htau(i,j))*DoubleTau))*f1 +
     1      log10(max(taumin,htlim(i,j)) )*f2 )
            htnext(i,j) = htlim(i,j) / 2.
            htau(i,j) = htlim(i,j) / 2.
          end do
        end do
        do j=2,nhe1lvl-1
          do i=j+1,nhe1lvl
*           he1lim(i,j) = he1tau(i,j)*f1*DoubleTau + he1lim(i,j) * f2
            he1lim(i,j) = 10.**(
     1      log10(max(taumin,(he1tau(i,j))*DoubleTau))*f1 +
     1      log10(max(taumin,he1lim(i,j)) )*f2 )
            he1nxt(i,j) = he1lim(i,j) / 2.
            he1tau(i,j) = he1lim(i,j) / 2.
          end do
        end do
        do j=2,nhe2lvl-1
          do i=j+1,nhe2lvl
*           he2lim(i,j) = he2tau(i,j)*f1*DoubleTau + he2lim(i,j) * f2
            he2lim(i,j) = 10.**(
     1      log10(max(taumin,(he2tau(i,j))*DoubleTau))*f1 +
     1      log10(max(taumin,he2lim(i,j)) )*f2 )
            he2nxt(i,j) = he2lim(i,j) / 2.
            he2tau(i,j) = he2lim(i,j) / 2.
          end do
        end do
      else
        do j=2,nhlvl-1
          do i=j+1,nhlvl
*           htlim(i,j) = htau(i,j) * f1 * DoubleTau + htlim(i,j) * F2
            htlim(i,j) = 10.**(
     1      log10(max(taumin,(htau(i,j))*DoubleTau))*f1 +
     1      log10(max(taumin,htlim(i,j)) )*f2 )
            htnext(i,j) = min(taumin,htlim(i,j)/2.)
            htau(i,j) = min(taumin,htlim(i,j)/2.)
          end do
        end do
        do j=2,nhe1lvl-1
          do i=j+1,nhe1lvl
*           he1lim(i,j) = he1tau(i,j)*f1*DoubleTau + he1lim(i,j) * f2
            he1lim(i,j) = 10.**(
     1      log10(max(taumin,(he1tau(i,j))*DoubleTau))*f1 +
     1      log10(max(taumin,he1lim(i,j)) )*f2 )
            he1nxt(i,j) = min(taumin,he1lim(i,j)/2.)
            he1tau(i,j) = min(taumin,he1lim(i,j)/2.)
          end do
        end do
        do j=2,nhe2lvl-1
          do i=j+1,nhe2lvl
*           he2lim(i,j) = he2tau(i,j)*f1*DoubleTau + he2lim(i,j) * f2
            he2lim(i,j) = 10.**(
     1      log10(max(taumin,(he2tau(i,j))*DoubleTau))*f1 +
     1      log10(max(taumin,he2lim(i,j)) )*f2 )
            he2nxt(i,j) = min(taumin,he2lim(i,j)/2.)
            he2tau(i,j) = min(taumin,he2lim(i,j)/2.)
          end do
        end do
      endif
*
*     force hydrogen outward optical depths to be on
      lgTauOutOn = .true.
*
*     possibly fix La optical depths
*     tlamin is set to large number when case b set
      if( tlamin.gt. 1e-5 .and. (.not.lgStatic) .or.lgCaseb) then
        htau(2,1) = tlamin
        htlim(2,1) = tlamin*2.
        htnext(2,1) = tlamin
        f = tlamin / hopac(2,1)
        fhe1 = tlamin / he1opc(2,1)
        he1tau(2,1) = tlamin
        he1lim(2,1) = tlamin*2.
        he1nxt(2,1) = tlamin
        he2tau(2,1) = tlamin
        he2lim(2,1) = tlamin*2.
        he2nxt(2,1) = tlamin
        fhe2 = tlamin / he2opc(2,1)
        do i=3,nhlvl
          htau(i,1) = f * hopac(i,1)
          htnext(i,1) = htau(i,1)
          htlim(i,1) = htau(i,1) * 2.
        end do
        do i=3,nhe1lvl
          he1tau(i,1) = fhe1 * he1opc(i,1)
          he1lim(i,1) = he1tau(i,1)* 2.
          he1nxt(i,1) = he1tau(i,1)
        end do
        do i=3,nhe2lvl
          he2tau(i,1) = fhe1 * he2opc(i,1)
          he2lim(i,1) = he2tau(i,1) * 2.
          he2nxt(i,1) = he2tau(i,1)
        end do
      endif
*
*     following sets (1)=inward optical depth to TAUMIN,
*     (2)=outward = (log) mean of old optical depths,
*     sets (3) to escap prob for first zone
      do i=1,nhetau
        call tav( he3tau(1,i) , AverFac )
      end do
      call tav( t206 , AverFac )
*
      if( lgSphere ) then
        he1rec(1,2) = max( 0. , otsmin )
        he1rec(2,2) = 1.
        he2rec(1,2) = max( 0. , otsmin )
        he2rec(2,2) = 1.
      else
        he1rec(1,2) = receff( nhe1(1) )
        he2rec(1,2) = receff( nhe2(1) )
      endif
*
      telec = taumin
      thmin = taumin
*     all heavy element lines
      do i=1,nTauLines
        call tav( TauLines(1,i) , AverFac )
*     >>chng 96 july 6 following sanity check added
*begin sanity check
        if( abs(TauLines(ipLnTauIn,i)).gt.abs(TauLines(ipLnTauTot,i)))
     1    then
          write(qq,'('' UPDATE finds TauIn>TauOut, line='',i5,1p,
     1    2e10.2)')i , TauLines(ipLnTauIn,i), TauLines(ipLnTauTot,i)
          call ShowMe
          stop
        endif
*end sanity check
      end do
*
*     all heavy element lines not in cooling
      do i=1,NWINDLINE
        call tav( WindLine(1,i) , AverFac )
      end do
*
*     Verner's FeII atom
      if( chFeIIAtom .eq. 'Verner' ) then
        if(.not.lgSimKatya ) call TavFe2
      endif
*
*     now redo escape probabilities, but zero dest prob
      call MakeRT
      do i=1,nTauLines
        TauLines(ipLnDesP,i) = 0.
      end do
*
*     >>chng 96 sep 4, zeroed out dest prob due to DstWght added
      do i=1,nhe1lvl-1
        do j=i+1,nhe1lvl
          he1dst(j,i) = 0.
          he1dst(i,j) = 0.
        end do
      end do
      do i=1,nhe2lvl-1
        do j=i+1,nhe2lvl
          he2dst(j,i) = 0.
          he2dst(i,j) = 0.
        end do
      end do
      do i=1,nhlvl
        do j=i+1,nhlvl
          hdest(j,i) = 0.
          hdest(i,j) = 0.
        end do
      end do
*
      if( lgCaseb ) then
        do i=1,nupper
*         DEPABS and SCT are abs and sct optical depth for depth only
*         we will not change total optical depths, just reset inner to half
*         tauabs(i,2) = 2.*depabs(i)
          tauabs(i,1) = tauabs(i,2)/2.
*         tausct(i,2) = 2.*depsct(i)
          tausct(i,1) = tausct(i,2)/2.
          depsct(i) = taumin
          depabs(i) = taumin
        end do
      else if( lgSphere ) then
        do i=1,nupper
*         DEPABS and SCT are abs and sct optical depth for depth only
          tauabs(i,2) = 2.*depabs(i)
          tauabs(i,1) = depabs(i)
          tausct(i,2) = 2.*depsct(i)
          tausct(i,1) = depsct(i)
          tautot(i,2) = tausct(i,2) + tauabs(i,2)
          tautot(i,1) = tausct(i,1) + tauabs(i,1)
          depsct(i) = taumin
          depabs(i) = taumin
        end do
      else
        do i=1,nupper
          tautot(i,2) = tautot(i,1)
          tautot(i,1) = taumin
          tauabs(i,2) = tauabs(i,1)
          tauabs(i,1) = taumin
          tausct(i,2) = tausct(i,1)
          tausct(i,1) = taumin
          depsct(i) = taumin
          depabs(i) = taumin
        end do
      endif
*
*     this is optical depth at x-ray point defining effective optical depth
      tauxry = tauabs(ipxry,1)
*
      end
******************************************************************************
      subroutine vanai
      implicit none
*do ionization balance for vanadium
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (nelem=23)
      parameter (ndim=24)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real FYIELD(nelem) , GRDEFF(nelem)
*
*     chromium nelem=23
*     based on iron
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.26E-10,4.97E-11,1.49E-10,3.90E-11,1.66E-11,7.16E-12,
     1 3.00E-12,1.02E-12,2.54E-12,1.70E-12,1.11E-12,6.42E-13,3.59E-13,
     2 9.30E-14,1.62E-14,5.97E-14,8.44E-14,5.92E-14,4.72E-14,3.79E-14,
     3 2.60E-14,1.61E-14,1.16E-14/
      data (cion(i,2),i=1,ndim-1)
     1 /9.13E4,1.88E5,3.56E5,6.36E5,8.70E5,1.15E6,1.45E6,1.75E6,
     2 2.73E6,3.04E6,3.37E6,3.84E6,4.19E6,4.55E6,5.30E6,5.68E6,
     3 1.47E7,1.58E7,1.69E7,1.84E7,1.96E7,2.09E7,2.26E7/
*
*     DATA FYIELD/2*.34,2*.35,.36,2*.37,.38,.39,.40,.41,.42,.43,.44,
*    4.45,.46,2*.47,2*.48, 3*0./
*     above fluorescent yields quoted in Krolik+Kallman Ap.J.(Let) 320, L5.
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/nelem*0.2/
*
*     Fe rates from Woods et al. Ap.J. 249, 399.
*     rec from +23, 24 25 from Arnauld et al 85
      data rec,pl
     1/ 5.2E-10 , 2.40E-9 , 3.20E-9 , 4.17E-9 , 9.44E-9 , 2.14E-8
     2, 4.48E-8 , 8.75E-8 , 1.41E-7 , 2.26E-7 , 2.73E-7 , 3.56E-7
     3, 4.42E-7 , 5.52E-7 , 7.00E-7 , 8.59E-7 , 8.55E-7 , 8.93E-7
     4, 9.64E-7 , 1.06E-6 , 1.19E-6 , 1.22E-6 ,
     1  -0.891  , -0.843  , -0.746  , -0.682  , -0.699  , -0.728
     2, -0.759  , -0.790  , -0.810  , -0.829  , -0.828  , -0.834
     3, -0.836  , -0.840  , -0.846  , -0.850  , -0.836  , -0.824
     4, -0.816  , -0.811  , -0.808  , -0.800  /
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.28e-10 , -0.686 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.58E-3  , 8.38E-3  , 1.54E-2, 3.75E-2, 0.117   , 0.254
     2, 0.291   , 0.150   , 0.140   , 0.100   , 0.200   , 0.240
     3, 0.260   , 0.190   , 0.120   , 0.350   , 0.066   , 0.10
     4, 0.13    , 0.23    , 0.14    , 0.11
     5, 0./
      data (dicoef(i,2),i=1,ndim-1)
     1/ .456    , .323    , .310    , .411    , .359    , .0975
     1, .229    , 4.20    , 3.30    , 5.30    , 1.50    , 0.700
     1, .600    , .5      , 1.      , 0.      , 7.8     , 6.3
     1, 5.5     , 3.6     , 4.9     , 1.6
     1, 0./
      data (dite(i,1),i=1,ndim-1)
     1/ 6.00E4  , 1.94E5  , 3.31E5  , 4.32E5  , 6.28E5  , 7.50E5
     2, 7.73E5  , 2.62E5  , 2.50E5  , 2.57E5  , 2.84E5  , 8.69E5
     3, 4.21E5  , 4.57E5  , 2.85E5  , 8.18E5  , 1.51E6  , 1.30E6
     4, 1.19E6  , 1.09E6  , 9.62E5  , 7.23E5
     5, 0./
      data (dite(i,2),i=1,ndim-1)
     1/8.97E4   , 1.71E5  , 2.73E5  , 3.49E5  , 5.29E5  , 4.69E5
     2,6.54E5   , 1.32E6  , 1.33E6  , 1.41E6  , 1.52E6  , 1.51E6
     3,1.82E6   , 1.84E6  , 2.31E6  , 0.      , 9.98E6  , 9.98E6
     4,1.00E7   , 1.10E7  , 8.34E6  , 1.01E7
     5 , 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4
     5, 1E20    /
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy(nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
*********************************************************************
      subroutine drvary
      implicit none
*main driver for optimization runs
*     Drives cloudy to optimize variables;
*
*     code originally written by R.F. Carswell, IOA Cambridge
*
*     Also called directly is 'Numerical Recipes' POWELL, but this
*     does not work very well, so POWELL (and the subsidiary routines
*     it uses) should be dropped perhaps.
*     (Bob's advice was followed).
*
      integer ncollm
      parameter (ncollm=100)
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer nobslm
      parameter (nobslm=100)
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      real amint,amierr
      integer linam,nlobs
      common/obsint/ amint(nobslm),amierr(nobslm),linam(nobslm),nlobs
      real amcol,amcerr
      integer ionam,ncobs
      common/obscol/ amcol(ncollm),amcerr(ncollm),ionam(ncollm),ncobs
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
*     limfal is limit to number of te failures, set with "failures" cmnd
*     lgNoMap is option not to map failures
      integer limfal
      logical lgNoMap
      common/limfal/ limfal , lgNoMap
      character*4 chAmLab
      common/obslin/ chAmLab(nobslm)
      integer itoptm
      common/itoptm/ itoptm
      real rincrm
      common/rincrm/ rincrm(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      real varmax, varmin
      common/varmax/ varmax(limpar) , varmin(limpar)
      real varang
      common/varang/ varang(2,limpar)
      integer noptim
      common/noptim/ noptim
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer nvary , nparm
      common/nvary/ nvary , nparm
      logical lgFaintOn
*logical lgFaintOn normally true, says to not print very faint lines
*set false with print faint off command
*lines fainter than TooFaint will not be printed.  This is set in zerologic
*and reset with print line faint command
      real TooFaint
      common/faint/ TooFaint , lgFaintOn
      character*4 chOptRtn
*     this specifies the optimization routine
*     'amoe', 'powe', 'bubr'
      common/oprout/ chOptRtn
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgOptLin , lgOptLum , lgOptCol
*flags set if we are to optimize lines, luminosity, or colums
      common/whtopm/ lgOptLin , lgOptLum , lgOptCol
      integer iooptm
      common/iooptm/ iooptm
      real OptGlobalErr
*set with optimize tolerance command, used for global match to fit
* default set in scalar to 0.10
      common/vtoler/ OptGlobalErr
      character chDate*7 , chVersion*7
      common/date/ chDate , chVersion
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      logical lgOptimFlow
      common/OptmFlow/ lgOptimFlow
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      logical lgTrOptm
*flag set with trace optimizer command
      common/troptm/ lgTrOptm
*
*     local variables
      integer i,j,ival,np,ii,iflag,mode,need,iteram,
     1 nint,nplxmx
      real fret,fx,func,ymn
      character chNote*7
      real p(21,20),y(21),xi(20,20)
      character chK1*80
*     equivalence the POWELL & AMOEBA workspaces
      equivalence (p(1,1),xi(1,1))
      external func
      real param(limpar) , ptem(limpar)
*     Stuff for Subplex
      parameter (nplxmx=200)
      real worke(nplxmx)
      integer iworke(nplxmx) , nfe
*
*     free statement labels  >=20
*
      lgTalk = .false.
*     zero out lots of variables
      call zero
*
*     necessary to do this to keep all lines in
      lgFaintOn = .false.
      limfal = 1000
*
*     call READR the first time to scan off all variable options
      call readr
*
      nvary = nparm
*
      if( lgOptLum ) then
        nint = 1
      else
        nint = 0
      endif
*
      if( (nlobs+nint+ncobs).lt.1 ) then
        write(qq,'('' The input stream has vary commands, but'')')
        write(qq,'('' no observed quantities were entered.  Whats up?''
     1  )')
        write(qq,'('' Use the NO VARY command to input vary options''
     1  ,'' but not try to perform this.'')')
        stop
      else if( nvary.lt. 1 ) then
        write(qq,'('' No parameters to vary were entered. Whats up?'')'
     1  )
        stop
      endif
*
*     lgTrOptm set with trace optimize command
      if( lgTrOptm ) then
        do i=1,nvary
          write(qq,'(a80)')chVarFmt(i)
          write(chK1,chVarFmt(i)) (vparm(i,ii),ii=1,nvarxt(i))
          write(qq,'(a80)')chK1
        end do
      endif
*
*     option to change default increments; if zero then leave as is
      do i=1,limpar
        if( rincrm(i).ne.0. ) then
          vincr(i) = rincrm(i)
        endif
      end do
*
*     say who we are
      write(qq,'(54X,''Optimization  Driver'')')
      write(qq,'(57X,''Cloudy '',a7//23X,38(''*''),A7,
     1 38(''*''),/23X,''*'',81X,''*'')') chVersion , chDate
*
*     now echo initial input quantities with flag for vary
      do i=1,nSave
        chNote = '       '
        do j=1,nvary
          if( i.eq.nvfpnt(j) ) then
            chNote = 'VARY>>>'
          endif
        end do
        write(qq,'(15X,A7,'' *'',1X,A80,''*'')') chNote,chCardSav(i)
      end do
      write(qq,'(23X,''*'',81X,''*''/23X,83(''*'')//)')
*
*     option to trace logical flow within this sub
      if( lgOptimFlow ) then
        do j=1,nvary
          i = nvfpnt(j)
          write(qq,'('' trace:'',a80)') chCardSav(i)
          write(qq,'(a80)') chVarFmt(j)
          write(qq,'('' number of variables on line:'',i4)') nvarxt(j)
          write(qq,'('' Values:'',1p,10e10.2)')
     1    (vparm(j,ii),ii=1,nvarxt(j))
        end do
      endif
*
      write(qq,'('' Up to'',I5,'' iterations will be performed,'')')
     1 itoptm
      write(qq,'('' and the final version of the input file will be'',
     1'' written on Fortran I/O unit'',I3)') iooptm
      if( chOptRtn.eq.'AMOE' ) then
        write(qq,'('' The amoeba method will be used.'')')
      else if( chOptRtn.eq.'POWE' ) then
        write(qq,'('' Powells method will be used.'')')
      else if( chOptRtn.eq.'SUBP' ) then
        write(qq,'('' Subplex method will be used.'')')
      else
        write(qq,'('' I dont understand what method to use.'')')
        write(qq,'('' Sorry.'')')
        stop
      endif
*
      write(qq,'(/I4,'' parameters will be varied.  The first lines, '',
     1''and the increments are:'')') nvary
      do i=1,nvary
         varmax(i) = -1e37
         varmin(i) = 1e37
*        write formatted to output using the format held in chVarFmt(np)
         write(chK1,chVarFmt(i)) (vparm(i,ii),ii=1,nvarxt(i))
         write(qq,'(/1X,A80)') chK1
         write(qq,'('' Initial increment is'',F6.3,'', the limits are'',
     1   1P,E10.2,'' to '',E10.2)') vincr(i), varang(1,i), varang(2,i)
      end do
*
*     this will be number of times optimizer calls cloudy
      noptim = 0
*
      if( chOptRtn.eq.'POWE' ) then
*        Powell's method
         do j=1,nvary
           ptem(j) = vparm(j,1)
           do i=1,nvary
             xi(i,j) = 0.0
           end do
           xi(j,j) = vincr(j)
         end do
         call powell(ptem,xi,nvary,20,OptGlobalErr,iteram,fret)
         do j=1,nvary
           vparm(j,1) = ptem(j)
         end do
*
      else if( chOptRtn.eq.'SUBP' ) then
         write(qq,'('' Begin optimization with SUBPLEX'')')
         need = 2*nvary + nvary*(nvary+4)+1
         if( need.gt.nplxmx) then
           write(qq,'('' Increase size of NPLXMX in parameter '',
     1     ''statements to handle this many variables.'')')
           write(qq,'('' I need at least '',I5)') need
           stop
         endif
         do j=1,nvary
           ptem(j) = vparm(j,1)
         end do
*
*        The subrouting SUBPLX input into cloudy 8/4/94.
*        The program itself is very well commented.
*        The mode must set to 0 for the default values.
*        The switch iflag tells if the program terminated normally.
         mode = 0
         call subplx(func,nvary,OptGlobalErr,itoptm,mode,vincr,ptem,fx,
     1      nfe,worke,iworke,iflag)
         if(iflag.eq.-1) then
           write(qq, '('' SUBPLEX exceeding maximum iterations.''/
     $    '' This can be reset with the OPTIMZE ITERATIONS command.'')')
         endif
*
         do j=1,nvary
           vparm(j,1) = ptem(j)
         end do
         if( lgOptimFlow ) then
           write(qq,'('' trace return subplx:'')')
           do j=1,nvary
             write(qq,'('' Values:'',1p,10e10.2)')
     1       (vparm(j,ii),ii=1,nvarxt(j))
           end do
         endif
*
      else if( chOptRtn.eq.'AMOE' ) then
*        AMOEBA
*        set up the two-dimensional array of values for the parameters
*        required by AMOEBA, NVARY+1 of them.
         do j=1,nvary
            do i=1,nvary+1
              p(i,j) = vparm(j,1)
            end do
         end do
*        set the single values in each which are different from the
*        first guess
         do i=2,nvary+1
           j = i - 1
           p(i,j) = vparm(j,1) + vincr(j)
         end do
*        initialize y, the value to be minimized
         do i=1,nvary+1
            do j=1,nvary
              vparm(j,1) = p(i,j)
              param(j) = p(i,j)
            end do
*           FUNC calls CLOUDY with the variable parameters in VPARM,
*           returning the equivalent of chi**2 as FUNC
            y(i) = func(param)
         end do
*
*       AMOEBA is the standard 'Numerical Recipes' routine, which
*       minimizes the function FUNC(param)
*       where param is the array of parameters
*       dimensional array of parameters for the model. It is described
*       on pages 402 - 406 of the book. [Press et al., Numerical
*       Recipes (Fortran version), Cambridge U.P., 1992]
        call amoeba(p,y,21,20,nvary,OptGlobalErr,func,iteram)
*       print summary of results
        ival = 1
        ymn = 1.0e34
*       keep pointer to minimum value
        do i=1,nvary+1
           if(y(i).lt.ymn) then
             ymn = y(i)
             ival = i
           endif
        end do
*       end set variable values to those which gave the minimum Y
        do j=1,nvary
          vparm(j,1) = p(ival,j)
        end do
      endif
      write(qq,'(1X,50(''*''))')
      write(qq,'(1X,50(''*''))')
      write(qq,'(1X,50(''*''))')
      write(qq,'(/'' Cloudy was called '',i4,'' times.''/)') noptim
      do i=1,nvary
        vparm(i,1) = min( vparm(i,1) , varang(2,i) )
        vparm(i,1) = max( vparm(i,1) , varang(1,i) )
        param(i) = vparm(i,1)
        np = nvfpnt(i)
        write(chCardSav(np),chVarFmt(i)) (vparm(i,ii),ii=1,nvarxt(i))
        write(qq,'(1X,''Optimal command: '',A80)') chCardSav(np)
        write(qq,'(''  Smallest value:'',1P,E10.2,'' Largest value:'',
     1  E10.2,'' Allowed range '',E10.2,'' to '',E10.2)')
     2  varmin(i) , varmax(i) , varang(1,i) , varang(2,i)
      end do
      lgTalk = .true.
      lgFaintOn = .true.
*
*     though a page eject
      write(qq,'(''1'')')
*
*     punch optimal parameters on unit iooptm
      do i=1,nSave
        write(iooptm,'(A80)') chCardSav(i)
      end do
*
*     recalculate values in cloudy for the best fit, and print out
*     all the information
      fret = func(param)
*
      end
*********************************************************************
      real function func(param)
      implicit none
*actual function called during evaluation of optimization run
      integer limpar
      parameter (limpar=20)
      real param(limpar)
*
      integer limext
      parameter (limext=5)
      integer nobslm
      parameter (nobslm=100)
      integer ncollm
      parameter (ncollm=100)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      integer nvary , nparm
      common/nvary/ nvary , nparm
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
      character chALab*4 , chSumTyp*1
      common/sumlab/ chALab(NLINES) , chSumTyp(NLINES)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer npxdd
      real snorm,arealg,scaled, asumli
      common/sum2/ npxdd,snorm,arealg,scaled(NLINES),asumli(NLINES)
      integer noptim
      common/noptim/ noptim
      real amcol,amcerr
      integer ionam,ncobs
      common/obscol/ amcol(ncollm),amcerr(ncollm),ionam(ncollm),ncobs
      character chColmnLab*4
*     labels for column densities on vary command
      common/colab/ chColmnLab(ncollm)
      real amint,amierr
      integer linam,nlobs
      common/obsint/ amint(nobslm),amierr(nobslm),linam(nobslm),nlobs
      logical lgOptLin , lgOptLum , lgOptCol
*flags set if we are to optimize lines, luminosity, or colums
      common/whtopm/ lgOptLin , lgOptLum , lgOptCol
      character*4 chAmLab
      common/obslin/ chAmLab(nobslm)
      real varmax, varmin
      common/varmax/ varmax(limpar) , varmin(limpar)
      real vpused
      common/vpused/ vpused(limpar)
      logical lgFourPi
*lgFourPi flag set true if intensities entered into 4\pi st
      real pirsq
      common/fourpi/ lgFourPi , pirsq
      real optint , optier
      common/intopn/ optint , optier
      logical lgOptimFlow
      common/OptmFlow/ lgOptimFlow
      real varang
      common/varang/ varang(2,limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character chCAPLB*4 , chFind*4
      logical lgOK , lgHIT
      logical lgLinSet , lgLimOK
      integer ipobs(nobslm) , i , nfound,j,ii,np
      real chisq,scld,chi1,chi2,diffx,diff1,diff2,theocl,
     1 predin,resid
      save lgLinSet , ipobs
      data lgLinSet/.false./
*
*     This routine is called by AMOEBA (or POWELL) with values of the
*     variable parameters for CLOUDY in the array p(i). It returns
*     the value FUNC = SUM (obs-model)**2/sig**2 for the lines
*     specified in the observational data file, values held in the
*     common blocks /OBSLIN/ & /OBSINT/
*     replacement input strings for CLOUDY READR held in /chCardSav/
*     parameter information for setting chCardSav held in /parmv/
*     additional variables
*     Gary's variables
*
*     free statement numbers >=8
*
      if( lgOptimFlow ) then
        write(qq,'('' trace, func variables'',1p,10e10.2)')
     1  (param(i),i=1,nvary)
      endif
*
      do i=1,nvary
        vparm(i,1) = param(i)
      end do
*
*     call routine to pack /kardsv/ variable with appropriate
*     CLOUDY input lines given the array of variable parameters p(i)
      call setinp( lgLimOK )
*
      if( .not.lgLimOK ) then
*       these parameters are not within limits of parameter search
*       >>chng 96 apr 26, as per Peter van Hoof comment
        write(qq,'('' Iteration'',I4,'' not within range.'')') noptim
*       this is error; very bad since not within range of parameters
        func = 1e37
        return
      endif
*
      do i=1,nvary
        varmax(i) = max( varmax(i) , vpused(i) )
        varmin(i) = min( varmin(i) , vpused(i) )
      end do
*
      noptim = noptim + 1
      call cloudy
*
*     Line fluxes now in commn blocks, so extract and
*     compare with observations
      chisq = 0.0
      snorm = sumlin(NormWL)
      if( NormWL.le.0 ) then
         write(qq,'('' Normalization line pointer is bad.'',
     1   ''  What has gone wrong?'')')
         stop
      endif
      if( snorm.eq.0. ) then
         write(qq,'('' Normalization line has zero intensity.'',
     1   ''  What has gone wrong?'')')
         stop
      endif
*
*     first print all warnings
      call warnot( qq )
      write(qq,'(1X,'' ID '',13X,''Model'',4X,''Observed'',7X,
     1 ''error'',5X,'' chi**2'',5X,''Type'')')
*     cycle through the observational values
      nfound = 0
*
*     first is to optimize relative emission line spectrum
      if( lgOptLin ) then
*        set pointers to all optimized lines if first call
         if( .not.lgLinSet ) then
           lgLinSet = .true.
           do i=1,nlobs
             call cap4( chAmLab(i) , chFind )
             lgHIT = .false.
             j = 1
*            >>chng 97 june 13, get rid of go to, change to do while
             do while( .not.lgHIT .and. j.le. nsum )
*              check wavelength for a match
*              change label to all caps to be like input chAmLab
               call cap4( chALab(j) , chCAPLB )
               if(lin(j).eq.linam(i).and.chCAPLB.eq.chFind) then
*                 match, so set pointer
                  ipobs(i) = j
                  lgHIT = .true.
               endif
               j = j + 1
             end do
             if( .not.lgHIT ) then
               write(qq,'('' Optimizer could not find line with '',
     1         ''label'',1X,A4,'' and wavelength'',I5,''. Sorry.'')')
     2         chAmLab(i),linam(i)
             stop
             endif
           end do
         endif
*
         do i=1,nlobs
*           and find corresponding model value by straight search
            nfound = nfound + 1
            scld = sumlin(ipobs(i))/snorm*sclnrm
*           add (diff/amierr)**2 to overall chi**2
*           checking that AMIERR is .gt. 0 (negative means upper limit)
*           AMINT(I) is desired intensity
            if(amierr(i).gt.0.0) then
               if( scld.ne.0. ) then
                  chi1 = ( (scld-amint(i)) / scld / amierr(i) )**2
                  chi2 = ( (scld-amint(i)) / amint(i) / amierr(i) )**2
                  chi1 = max( chi1 , chi2 )
                  chisq = chisq + chi1
               else
                  chi1 = 1e36
                  chisq = chisq + chi1
               endif
            else
*              value quoted is an upper limit, so add to chisq
*              only if limit exceeded. Otherwise there is no information.
               if( scld.ne.0. ) then
                  diff1 = ( scld-amint(i) ) / scld
                  diff2 = ( scld-amint(i) ) / amint(i)
                  diffx = max( abs(diff1) , abs(diff2) )
                  diffx = sign( diffx , diff1 )
               else
                  diffx = ( scld-amint(i) ) / amint(i)
               endif
               if(diffx.gt.0.0) then
                  chi1 = (diffx/amierr(i))**2
                  chisq = chisq + chi1
               else
                  chi1 = 0.
               endif
            endif
            write(qq,'(1X,A4,I6,3F12.5,1P,E12.2,'' Relative intensity'')
     1      ')chALab(ipobs(i)),lin(ipobs(i)),scld,amint(i),amierr(i),
     2      chi1
         end do
      endif
*
*     option to optimize column densities
      if( lgOptCol ) then
         do i=1,ncobs
            call cdColm( chColmnLab(i) , ionam(i), theocl , lgOK )
            if( .not.lgOK ) then
               stop
            endif
            nfound = nfound + 1
*           add (diff/AMCERR)**2 to overall chi**2
*           checking that AMCERR is .gt. 0 (negative means upper
*           limit)
            if(amcerr(i).gt.0.0) then
               chi1 = ( (theocl-amcol(i)) / amcol(i) / amcerr(i) )**2
               if( theocl.gt.0.) then
                 chi2 = ( (theocl-amcol(i)) / theocl / amcerr(i) )**2
               else
                 chi2 = 0.
               endif
               chi1 = max( chi1 , chi2 )
               chisq = chisq + chi1
            else
*              value quoted is an upper limit, so add to chisq
*              only if limit exceeded. Otherwise there is no information.
               diffx = ( theocl-amcol(i) ) / amcol(i)
               if(diffx.gt.0.0) then
                  chi1 = (diffx/amcerr(i))**2
                  chisq = chisq + chi1
               else
                  chi1 = 0.
               endif
            endif
            write(qq,'(1X,A4,I6,1P,2E12.4,0P,2F12.5,
     1      '' Column density'')')
     2      chColmnLab(i),ionam(i),theocl,amcol(i),amcerr(i),chi1
         end do
      endif
*
*     option to optimize line flux
      if( lgOptLum ) then
        predin = log10(sumlin(NormWL)) + pirsq
        resid = 1. - 10.**abs(optint - predin )
        chi1 = (resid/optier)**2
        chisq = chisq + chi1
        write(qq,'(1X,A4,I6,3F12.5,1P,E12.2,'' Line intensity'')')
     1  chALab(NormWL),lin(NormWL),predin , optint , optier,chi1
        nfound = nfound + 1
      endif
*
      if( nfound.lt.nlobs ) then
        write(qq,'('' Lines were missed in optimization.'')')
        stop
      endif
*
      if( nfound.le.0 ) then
        write(qq,'('' WARNING; no line matches found'')')
        stop
      endif
*
*     only print this if output has been turned on
      if( lgTalk ) then
        do i=1,nvary
         vparm(i,1) = min( vparm(i,1) , varang(2,i) )
         vparm(i,1) = max( vparm(i,1) , varang(1,i) )
         param(i) = vparm(i,1)
         np = nvfpnt(i)
         write(chCardSav(np),chVarFmt(i)) (vparm(i,ii),ii=1,nvarxt(i))
         write(qq,'(1x,''Optimal command: '',A80)') chCardSav(np)
        end do
      endif
*
*     write out chisquared for this iteration
      write(qq,'('' Iteration'',I4,'' Chisq='',1P,E10.2)') noptim ,
     1 chisq
*
      func = chisq
*
      end
*********************************************************************
      subroutine setinp( lgLimOK )
      implicit none
*sets input lines to feed into cloudy in optimization runs
      logical lgLimOK
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      integer nSave , nRead , nSaveIni , iReadWay,nReadSv
      common/ninput/ nSave , nRead , nSaveIni, iReadWay,nReadSv
      integer nvary , nparm
      common/nvary/ nvary , nparm
      integer limext
      parameter (limext=5)
      integer limpar
      parameter (limpar=20)
      real vparm , vincr
*     vparm is the value of the parameters oon line limpar,
*     there can be as many as nvarxt parameters on the line
*     vincr is the increment
      integer nvarxt
      common/vparm/ vparm(limpar,limext) , vincr(limpar),
     1  nvarxt(limpar)
      character chVarFmt*80
      common/vformt/ chVarFmt(limpar)
      real vpused
      common/vpused/ vpused(limpar)
      integer nvfpnt
      common/nvfpnt/ nvfpnt(limpar)
      real varang
      common/varang/ varang(2,limpar)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer i,np , ii
*
*     set up chCardSav(n) array like Gary's input file, using input
*     variable parameters p(i), and format information held in
*     the common block /parmv/. Results written to common /kardsv/.
*
      write(qq,'(1x,50(''*''))')
*
      lgLimOK = .true.
*     echo the variable input lines for this run
      do i=1,nvary
        np = nvfpnt(i)
*       write formatted to the character string chCardSav(np),
*       using the format held in chVarFmt(np)
        vpused(i) = min( vparm(i,1) , varang(2,i) )
        vpused(i) = max( vpused(i) , varang(1,i) )
        if( nvarxt(i).gt.1 ) then
          write(chCardSav(np),chVarFmt(i)) vpused(i),
     1    (vparm(i,ii),ii=2,nvarxt(i))
        else
          write(chCardSav(np),chVarFmt(i)) vpused(i)
        endif
        write(qq,'(1X,A80)') chCardSav(np)
        if( vpused(i).eq.varang(2,i).or.vpused(i).eq.varang(1,i) ) then
          lgLimOK = .false.
          write(qq,'('' Limit to variable exceeded.'')')
        endif
      end do
*
      end
**************************************************************
      subroutine dgeco(amat,l,n,ipiv,rcond,work)
      implicit none
*one of the veclib routines that lives on the Exemplar
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real amat,rcond,work
      integer l,n,ipiv
*
      write(qq,'('' veclib routines must be added to Cloudy.'')')
*
      stop
      end
**************************************************************
      subroutine dgesl(amat,l,n,ipiv,bvec,job)
      implicit none
*one of the veclib routines that lives on the Exemplar
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real amat, bvec
      integer l,n,ipiv,job
*
      write(qq,'('' veclib routines must be added to Cloudy.'')')
*
      stop
      end
******************************************************************************
      subroutine velset
      implicit none
*set thermal velocities for all particles in gas
      integer limelm
      parameter (limelm=30)
      real AtomicWeight
*stored vector of atomic weights for all elements, set in block data scalar
      common/AtomcWgt/ AtomicWeight(limelm)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real TurbVel
*this is the turbulent velocity in cm/s, normally zero, set with
*turbulence command
      common/turb/ TurbVel
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
*
*     local variables
      integer nelem
      real turb2
*
*     computes one doppler width, in cm/sec
*     usually TurbVel =0
*
*     compute doppler width
      turb2 = TurbVel * TurbVel
      do nelem=1,limelm
        doppler(nelem) = sqrt( 1.651e8*te/AtomicWeight(nelem) + turb2 )
      end do
*
      end
*********************************************************************
      block data version
      implicit none
*block data keeping track of version numbers
*>>>>>VERSION.F
      character chDate*7 , chVersion*7
      common/date/ chDate , chVersion
      data chDate,chVersion/'96Jun17' , ' 90.04 '/
*
*  .04  Sept 5, 1997
*  .03i all individual chem element pointers removed
*  .03h update He+ collisional ionization with HydColIon by Jason Ferguson
*  .03g eden to edhi in hlevel, caused slight departures from lte in very
*       dense models, also caused 3-body heating to be too important
*       HeI collision data updated to Sawey and Berrington ADNDT 55, 81
*       very cool fully molecular models could have CO inversion error
*       due to OH underflow
*  .03f problem with calcium fixed (introduced 5 days before), all transferred
*       lines in radiation pressure, which is now larger.  Radiation
*       pressure only capped on first iteration instead of all except last.
*  .03e second Thornley problem otslinon off, variable grain abundances in
*  .03d variable grain abundances
*  .03c several fixes for Lya photo induced oscillaitons
*  .03b add cooling derivative for HeI and HeII lines(!!),
*       cooling for 1s-2s for HeI and HeII
*       reset grain potential at start/end of calculation
*       change limit to opacity in addopac to 1e-29
*       error in logic for change in electron density
*       default line width in plots changed to 1000 km/sec
*  .03  change SIII collision strengths, Tayal '97
*  .03a error in nWerner, off by one
*  .03  Dima's recombination lines all in
*  .02z increased resolution of continuum up past Fe K edge
*  .02y deriv of photo heating cooling did not include top stage of ioniz
*       small increase in A for NII 2140 Brage Hibbert LEckrone apj 478, 423
*  .02x HeI singlet line cooling multiplied by HeIII not HeII
*  .02w error in rec to ground and Lya of heavy elements, no electron density
*       rec coef for ion rec on grain surface had grain not elec temp
*  .02v fixed error introduced in SIV cs in .02k
*  .02u killed cont pumping of Heii when underflow upset matrix
*  .02t submitted version of Dalgarno CT rates put in
*  .02s small changes in atomic constants in parameters, to be in line
*       with '86 codata recomendations
*  .02r Ar IV model atom revised to 5 levels, cs data to Ramsbottom et al 97
*       major change (fac of several) in collision strength
*       change FeX, FeXI, and FeXIV cs data to 1
*  .02q increased continuum resolution above 4.0 to 4.05 ryd
*  .02p added lots of [Ca VII] lines, [Fe VII] 6087 cs too small by 2.96x
*  .02o abundances of rare species in ism and HII Region mixes changed
*       to Savage and Sembach Ann REv 1996
*  .02n statistical charge transfer rate coef of 8.5e-10q put in
*  .02m added 2 fir fevii lines, updated fir energies with Feuchtgruber et al
*  .02l Kevin Volk star1 routine all in, with option renamed kuwn
*  .02k new cs for [SIV] 10 mic line, fixed error in H matrx flag resetting
*  .02j changed limit to Lev3Fail=4 from 1e-7 to 1e-8 in level3
*       changed default lower limit for all range options from 1 Ryd to 0.9996 r
*       for H mass rydberg
*  .02i change logic for test of HeII/HeI in hei, for case where pumping of
*       atom resulted in photoionization, new var is chk2ov1
*       code now exits totally when cold molecular first zone does not converge
*  .02h error in cs for Ar VI 4.53 micron line, should have been 6.33, was 0.8
*  .02g fixed problems with level3 roundoff causing cooling to underflow
*  .02f expression for HeI Lya cooling changed to be accruate near LTE
*  .02e in metdif defn of incremental outward changed to refer to all
*       previous outward - SumIncCon
*  .02d protect against roundoff error in level3
*  .02c colfit 2.0 in, fixed discontinuity in H collisional ionization
*  .02b zoning for first 10 allowed dr to get too big, error introduced
*       in very late 90.01
*  .02a restored test whether H collisionally or photo ionized - logic
*       had been blown, this improved thermal stability
*  .02  improved temp predictor-corrector when ff heating dominant
*  .01p added logic to damp oscillations in bidiag auger during search
*  .01o 16 level FeII goes to very low temperatures continuously
*  .01n 2 errors in bidiag, used yield of last electron, clobbered Auger
*       rates when collisional ionization set
*       ionization potential of hydrogen now 0.9996 ryd
*  .01m very small change in evaluation of H ff heating, to keep constant
*       when running large grids
*  .01l sanity checks against zero photo cross secs, fixed several elem
*       with 0 cs at energyies below threshold
*  .01k moved all H ct to Jim Kingdon's routine
*  .01j major bug in total photo cross section for OP elements,
*       sub shell photo cross sect only went up to next major theshold,
*       which was assumed to dominate.  In many op species there is
*       no jump at shell edges, so subshells must go to much higher energy
*       result was that some species has zero cross sections at some energies
*  .01i DstWght now in for all eovrlp destruction probabilities
*       temp of last zone was used for cs in [OIII] analysis, changed to 1e4K
*  .01h better protection against counting ns kludge from closed shell
*       (no effect on balance of any major elements).  Better bracket gamma
*       branch routine from Jason
*  .01g 16 level FeII atom put in
*  .01f reflected continuum albedo now defined
*  .01e slight change in As for NIV] and OIV]
*  .01d added 12 level [FeIV] atom, H atom can do 50 levels
*  .01c bug in computing grain drift velocity in grids when
*       grains turned off initially, then turned on
*       added [Mg V] and [Mg VII] lines, improved temp dependencies
*       of many IR line collision strengths
*  .01b improved coll str fits with temp for many IR lines,
*       added [K IV] and [K VI] IR lines
*  .01a fixed error in atomic number pointer for P X, updated cs
*       expression for CII 157 mic
*  .01  several of Kirk's grids have run ok, final touchup with
*       adding frequency points to diffuse continuum printout
*  .00h lines broken up, F sequence in using Saraph and Tully AAS 107, 29.
*  .00g tmn added back to outward lines in metdif
*  .00f helium triplet collisional cooling did not include
*       three body heating, problems when close to lte
*  .00e error in he triplet population at VERY low densities,
*       [FeX] collision strength changed to straight Pelan and berrington
*       so 10x larger
*  .00d work on punch continua, level2 includes pump before check
*       on magnitude of coll exciatation
*       punch transmitted continuum had major error
*  .00c Cl sequence updated from Pelan and Berrington
*  .00bsphere static did not increment optical depths correctly, and
*      did not have correct ipLnTauCon which was added
*      typo in Dima's line list, OIV 609 line had bad energy
*      very small change in cs of 3P levels of SV
*  .00a first installment on fixes, labels changed for "2" lines
*      dielectronic recom contributions updated
*90.00 96 June 17, leaving for Disney World
*  .28 cleaned up lots of small problems on sgi and cray
*  .27 runs on cray 90 with stack memory, indefinites
*  .26 changed logic for converging optical depths
*  .25 he1 and he2 had rec coef from cota levels, made smooth - caused
*      maser in HeI and HeII 7-6 transition
*  .24 removed last of bad A's from cota levels
*  .23 error in opacities for HeI and HeII lines
*  .22 logic added for H masing lines, problem in csupra when
*      metals far more abundance than H or He
*  .21 error in conversion FeII A into oscil
*  .20 leaving for Mike Brotherton's defense in Austin, this is c90 beta 3
*  .19 4 new IR lines, 4 old lines moved to line arrays,
*      problems with free-free gaunt factor routine partially fixed
*  .18 changed VolFac to OutFac, using dVeff
*      better protection against table read from old version
*  .17 h ct back on again
*  .16 damped ophf oscillations, set traps for neg ots fields gracefully
*  .15 trap set in TauInc for strong maser emission
*      changed he sin, ion line rates to hdexct (had included psuedo states)
*  .14 stepped OI photo cross sections, Pequignot rad rec coef
*  .13 hnet, he1net he2net had cap of 1 on escape prob, prevented
*      maser emission
*  .12 many new ir lines added, changed cs for H Lya, 1-3, 2-3 transition,
*      updated He+ collision strengths, 1-2-3
*  .11 cured two instabilities discovered by Jim Kingdon, fixed several
*      bugs discovered by Kevin Volk, none affected line answers,
*      lowest energy continuum point was 3sx too small
*      update doublet ratios for forb line, A's for beseq
*  .10 this is c90 beta 1 released Apr 26 96,
*      15 level hydrogen atom now default, topoff over upper 5 levels
*  .09a sec highest level in feii atom - no stim em cor, to fix over-masing
*  .09 h atom topoff back to all in highest level
*  .08 reflected and outward continua now produce correct eq on plots
*  .07 fixed rec lines that spilled over into next higher continuum
*  .06  default nhlvl now 25
*  .05d branch now goes to 30,000K, for n=4,5 better fit at intermed den
*  .05c first abund arg removed from level3 routine
*  .05b h atom top-off now to all n=3,nhlvl
*  .05a changed He + N+3 =. N+2 + He+ ct rate to Sun et al cfa pre 4208
*  .05 abundances now Grevesse and Noel, meteoretic, Fe down 33%
*  .04b changed default orion abundances to baldwin et al
*  .04a removed big fudge factor on coll ion rate from n=9 of hydrogen
*  .04 arbitrary level hydrogen atom works (??)
*  .03a killed kludge rec for iron since in arnaud and raymond rates
*  .03 bad induced continuum in he 1 2 excited states
*  .02 set escape proba for highest H Lyman line to 1,
*      to avoid numerical oscillations in totally optically thick models
*      changed free-free heating evaluation to do every time if signigicant
*  .01 numerous changes after comparison with ION,
*      Dima's radiative rec now totally in
*89.00 leaving for Israel
*  .25 passed code through array limits checker
*  .24 all col ioniz now Dima's colfit, many rates very different
*  .23 new cs for Mg+* photo, MgII twice as strong
*  .22  new colstrgbar with neutrals, KI fit to cs
*  .21f full population of upper level of mg2 2798 inc in photo fhof mg+
*  .21e put ff emission in fir back into outward beam
*  .21d change NaD cs to Dima's new value
*  .21c he3relax defined as frac that go to singlets
*  .21bmade hydrogen opacity call to opinb
*  .21 HeI, HeII Lya lines now have ExpmTau included, less outward
*  .20 reeval grains for every iteration since heating-cooling change
*  .19 secla not updated in gamk, bnfun, and bnfun used all enr for sec
*  .18 hydrogen line net heating has better derivatives
*  .17 REALLY BIG BUG in Neon I photo crossection fixed
* 1996
*  .16 collisions from H n=2 to 3 and up HAD BEEN TURNED OFF!
*  .15 tmn back in but with damped dr, all lex meeting tests ok
*      except for blister
*  .14 brems not ever added to outward beam below tff
*  .13avery slight coding changes for secondary ionization changes
*  .13 added check for temperature oscillation, double optical
*      depths to convergence tests, moved block data vars to executable
*  .12 lines tranferred did not have popl and popopc correct
*      mostly affected CaII
*  .11 several bugs related to ipLnPopl vs iipLnPopOpc
*      also incorrect setting of these in ionize, not using level2
*      for wind lines
*  .10 chage trans ion of h back out
*  .09 charge transfer ionizat of hydrogen now vector
*  .08 careful comparison with lexington meeting test results
*  .06 H ff now HFFNet = cool-heat for H free free, same for free bound
*      h now includes charge transfer recombination
*  .05 fixed problem with eden going negative, unable to converge cooling
*      for low density warm gas
*  .04  level3 did not zero cooling when abundance zero, leveln did
*       not zero deriv of cooling when abundance zero
*  .03a put evaluation of Lya heating in hydrogen so that it is done
*       all the time = = =  put logic for change in temp in nextdr
*  .03  Jim Kingdon's depletions in, fluctuations affects abundances
*  .02  lots of small changes after kirk's loc models
*  .01  cleaned up temp failures after one of kirk's loc runs
*88.00  July 28 95, after converting level3 to sep heating-cooling
*   .53 cleaned up crashes from running hazy all
*   .52 worked on more bugs from instability of 35Z blr
*   .51 increased resolution in 100-1000eV range, ipContSave
*   .50 got pdr.in to work well, lots of little bugs working through hazy
*   .49 removed bug dealing with too many incremeents of photo rates
*   .48 trying to get all models to work again
*   .47 several loop reogrinizations, code speed up by 3x
*       nexdr now relies mainly on dTau at max interaction
*   .46 get exactly same results for pn on sun and cray 90
*   .45 lots of small init bugs discovered from running on eagle cray c90
*   .44 g-bar lines use ContBoltz not exp for boltzmann factor
*   .43 winddat lines use inner escprob not conpmp, do not write onto ots
*   .42 collapsed line transfer loops into MakeLineRT
*   .41 all 6k of Dima's lines now in cooling
*   .40 he1 array t206 was not dim nta - had buggered solarsave(26)
*   .39 fixed error in ipLnAovTot in level3 (forgot escape prob)
*   .38 conpmp now uses optical depth in center of next zone
*   .37 fixed error in opacity 1-9 transition of H
*   .36 removed all PDoublet - now three level atoms
*         cs for al iii was in error, and ovi doublet had one line
*   .35 got lalpha.in to work, lowered bn(2s) by increasing cs 2s photo
*   .34 corrected error in H stat weight introduced in 33
*   .33 lots of work on hydrogen matrix
*       hopac matrix defined from A's
*   .32 fixed bug in gamk heating introduced in speedup below
*   .31 population in line arrays not set when gas too cool
*   .30 added ionization species to punch continuum
*       bug fixed - when abundance of species set to zero by trim,
*       ots was not set to zero
*   .29 bug in rec eff function when temp passed below 1500K
*   .28 first runs of orion with verner feii atom,
*       electron density converged in map
*   .27 Verner's FeII atom in, lots of neutral species
*   .26 energy inputs to grain heating straightened out
*   .25 cleaned up OI and FeII routines to eleimanate negative pops
*   .24 at end of first iteration integrated H He Lyman line optical
*       depths are now corrected for assumed initial optical depth -
*       this helps convergence in models optically thin in Lyman lines
*   .23 highest 4 levels in H not used for collisional ionziation cooling
*   .22 no more calls to pexc()
*   .21 supppression in for all dielec recomb
*   .20 supression of nuss+storey dielectronic suppression as in burgess
*       also moved suppression routine out of carbon
*   .19 HeI lines in outward beam
*   .18 big error in si iii] cs, again
*   .17 all heavy line optical depths now just one array
*   .16 fstaus history
*   .15 all fines refernces out, level3 agrees exactly
*   .14 level3 gives same answer for ci ir lines
*   .13 atomic data for oiv] changed, 20% difference
*   .12 larger A for 1909 (121 from 96)
*   .11 problems with fines calls for ci and mgv ir lines
*   .10 all character onto hungarian notation
*   .09 PDoublet routine used for AlIII
*   .08 nearly all commons out?  all implict none?
*   .07 burgess dielec recom not considered at low eneough temp
*   .06 lots more commons out
*   .05 answer for hydogen changed when commons, implicit none, changed
*   .04 low end of pl in agn now exp cutoff
*   .03 contin now clean, implicit none
*   .02 comole and comment have no common, all implcit none
*   .01 block.f has no commons, all implicit none
* 87.00 Lexington meeting final models
*Jan19 95
*  .50 Dima changed S+ photo cross to opacity project value
*  .49 changed SiIII 1898 cs to 3x larger value
*  .48 power law flat again in agn command
*  .47 put in bump for agn command
*  .46 iondun also set by checking oxygen convergence
* 1995
*  .45 fixed ratio crash in ion bal for zinc
*  .44 agn now has -0.5 slope bb, option to change it
*  .43 lots more continue removed
*  .42 Stafford et al NII collision strengths
*  .41 agn command
*  .40 heat now working again
*  .39 cleaned up more continues, saved photo rates in common
*  .38 mewe yields are now all in
*  .37 lots of includes added
*  .36 all optical dpeth arrays into includes
*  .35 two constant temp models called in row identical
*  .34 gffsub not called first time on multi-run calcs
*  .33 a few small fixes
*  .32 changed 11 to nhlvl+2 in hydrogen
*  .31 cloudy.ini can be any file name
*  .30 cloudy.ini can be on the path
*  .29 cloudy.ini file now read in with init file
*  .28 titanium , scandium in iwth fe data
*  .27 Li, Be, B in with carbon rec, coll ioniz data
*  .26 "heating" array now fulling in, pheat parallel
*  .25 fe, cobalt, nickel, cleaned up, NOPSV trimed down
*  .24 chlorine, argon, calcium cleaned up
*  .23 alum, sil, sulph cleared up
*  .22 oxy ne toally cleaned out
*  .21 all elements formerly in use dima opacities only
*  .20 all 30 elements now have opacities
*  .19 all remants of old carbon ionization gone
*  .18 old carbon ionization totally out
*  .17 new ionization, recomb, bi-diag written, in par with old
*  .16 all opacities up to neon, and iron, now to dima
*  .15 more li seq lines in, increase ligbar by 3.5%
*  .14 fixed bug in counting cooling for mg 10 twice
*  .13 ar 16 and fe 24 2s2p transition split into two lines
*  .12 half dozen li seq lines in with both 2s2p and 2s3p
*  .11 lots more Li seq lines added to optical depth arrays
*  .10 new collision strengths for Li-seq
*  .09 cs for FeX 6374 from Mohan et al, 20x larger than Mason
*  .08 Dima Verner's photo used for thresholds
*  .07 incorporating branch, new level scheme for hydrogen
*  .06 new h atom work begins, mean of old and new H level pops used for opacity
*  .05 rough charge temperature dependence for dielec suppression
*  .04 bug in implementation of shull and van steenberg recomb rates
*  .03 bug in implementation of shull and van steenberg coll rates
*  .02 pointers for cobalt and clorine not reset at end of iteration
*  .01 three new vary commands
*86.00 sparc 20 arrives, try to stabalize all tests
*  .47  table stars atlas works again, lly-a counted as rec line for energy bal
*  .46  jason's subplex
*  .45 bug in Ly-bet escape prob when no oxy 1
*  .44 escape simple added
*  .43  nend() and itrprt() changed to parameter, itrdim
*  .42  ContDiff only evaluated in diffem for ots
*  .41  gaunt factor toutine now includes limits
*  .40  lines self-fluoresced since occnum included lines
*  .39  outward beamed lines completed
*  .38  all taun lines now reflected, outward beams
*  .37  energy in h col psuedo levels off for n=9
*  .36  pumping, dest, into Fred's 6 level atom
*  .35  nlevel in for 3 level fe ii atom
*  .34  H- mutual neutralization production of H-alpha added
*  .33  small bugs in HMOLE  - H2+ goes to lte for high n
*  .32  last of small set of bugs
*  .31  element vary works, element scales can be combined with other
*       abundance commands
*  .30  check for energy conservation changed to adds of rec and cool
*  .29  sorted out hydrogen line rec, col, and info, in routine lines
*  .28  collisional ionization cooling of helium
*  .27  fabden now has depth as argument too
*  .26  all elements turned off with elements off command
*  .25  element command added
*  .24  contin pumping now turned on for rest of elements (only C up to now)
*  .23  underflow in how punch line structure cause return of zero in
*       geometries with large radius
*  .22  Cl in with corr photo, rec cs, co with cor photo, ni rec
*  .21  Cl, Co added to abundances
*  .20  cleaned up bugs in NIII 990 pumping
*  .19  all cool1 and cool2 converted to array pexc
*  .18  CIV 1540 now all in
*  .17  beseq now fully incorporated with tarray
*  .16  carbon moved to tarrays in TauInc
*  .15  taux arrays now have all radiative info on a line,
*       cleaned up print out for last page
*  .14  NCELL increase to 1500
*  .13  eold changed to enew in ionize, comment with tet
*  .12  changed to outward only as default diffuse fields
*  .11  e2 in diffem for outward flux
*  .10  receff not evaluated for tau gt 5
*  .10  beginning of outward only approx
*  .09  no stimulated emission correction in AddOpac during thermal search
*  .08  now drChange and didh, drChange returned to 0.15, didh=0.1
*  .07  work on HeII bowen to get Paris PN right
*  .06  changed default drChange to .10 to get orion exact
*  .05  two photon emission of helium now exact
*  .04  more work on HeI emission
*  .03  closed shell dielec recomb fixed
*  .02a heII two photon emission
*  .02  further work on HeI diffuse fields
*  .01  hei trip to ground one photon decay added to outward beam
*  .00a new threshold energies for Al 6 and Ne 9 (VERY small change)
*85.00  try to upgrade amoeba routine to press et al sec edition
*84.10a lgDHetOn, lgDColOn, lgPhysOK moved to zero out of block data
*84.09  error in declaration of Z in function ratabn
*84.08  error in excitation potential of [SiIX] IR lines
*84.07  original Reilman and Manson opacity for S+7 used instead of
*       their revised one
*       problem with negative globule when iterating fixed
*       overflow in conset for intense continuum guarded against better
*       wind error, change in velocity not computed correctly
*       stop thickness did not work exactly
*84.06f in PDR, steps too big before H2 came in
*84.06e oscillation at depth in x-ray ionized dusty models
*84.06d set lgHe1ON and lgHe2ON to true in zero
*84.06c collision strengths within 6D ground of FeII to Pradhan and Zhang '93
*84.06b changed CS data for Si II to Dufton and Kingston 91 - BIG change in
*       1814 CS
*84.06a added 3 more Si II lines, major change in CS for 1808 line
*84.06  Volk's continua were divided by nu^2 instead of nu in ffun1,
*       bug discovered by P van Hoof,
*       problem with large scale fluctuations discovered by K Kwitter
*84.05h changed transfer of CII] 2326 against Balmer continuum
*84.05g transferred mgi 4561 since it becaume really strong in al lll models
*84.05f many small typoes discovered by running on cray
*84.05e bug in receff discovered by S. Schaefer
*84.05d cdsqte now always includes HI/1E4
*84.05c force reevaluation of H, HeI, HeII collisional terms when const temp
*84.05b damped oscillations in intermediate cosmic ray dominated case
*84.05a altered optical depth treat of oi ir line heating
*84.05  factor for OI pump by IR background off by 1
*84.04k problem with He+ trace ionization when cosmic ray ionized,
*       and gas all neutral
*84.04j stat weight eror in OI 6300 optical depths
*84.04i problem with cosmic ray ionization dominated, totally netural limit
*       traced down to product hn(1) * HII not Hi
*84.04h Steffen Schaefer found problem in interpretation of logs in
*       table power law command
*84.04g Paul O'Brien found typo in HeI esc prob routine, did not affect results
*84.04f punch grain opacity command did not work
*84.04e overrun of optical depth scale caused oscillations at high density
*       added depletion to metals command
*84.04d problem with low den ioniz continuity over 1000K break
*84.04c fixed oscillation in VERY high U models due to pair production
*84.04b change in helium ionzation dr logic for high U model oscillations
*       added lgNxtDROff flag for nextdr services
*84.04a added comment to indicate how much He 23S photo was Lya
*84.04  new collision strengths for AlIII, AlII, SiIII, SiIV,
*       those for Al are quite different
*84.03a yet more instabilities at very high densities cured
*84.03  instabilities at very high densities cured
*84.02f Kevin Volk's grey grains
*84.02e high density instabilities
*84.02d subtracted 3-body rec from diffuse part of heav el cont
*84.02c altered dr logic for very dense model oscillations
*84.00b damper on feii esc prob to stop h-ionization oscillations
*84.00a numerical instability in L-shell auger
*84.02  problem with extinguish command led to rewrite of flxfnt logic
*84.01a r1/r0 factor missing in one punch continuum
*84.01  line driving in winds not properly computed
*84.00d iostat not properly checked in Volk routines
*84.00c turned line acceleration back on
*84.00b problem with cdLine div by zero reference line intensity
*84.00a check for ZERO hbeta intensity for flour in comment.f
*84.00 Feb 13 93
*  .71 fixed instability in cooling flow cloud model
*  .70 cooling term from H + H+ => H2+
*  .69 logic for CO-dr in pdr models
*  .68 fully incoporated into model atom
*  .67 optical depths for hei 2.06 micron line
*  .66 revised collision cross sections for He+
*  .65 added Paul O'Brien's code to do two sided helium escape prob
*  .64 set so that heII cant be turned back on deep in neutral gas
*  .63 AddOpac now called within ionize, solved instability in blr.in
*  .62 bad pointer to Ca+ photoionization opacity fixed
*  .61 fixed bad pointer put in in ver .60
*  .60 altered matrix for L-shell ionization, broke out LSION
*  .59 computed collision strength for NaD
*  .58 separate ksion and lsion instead of xrion
*  .57 OI 6300, 6363 predicted independently, using each optical depth
*  .56 he singlets matrix only used if photoionization rate not zero
*  .55 new transit prob for NIII] 1750
*  .54 set nmap option in place
*  .53 table atlas, werner, both seem to work
*  .52 new version of Kevin Volk atlas routines, grid
*  .51 continuum pumping of 1240
*  .50 up to 10 stop line commands
*  .49 transferred svi 933
*  .48 Fred Hamonn's abundance set put in without documentation
*  .47 changed atlas91 format, file half as long
*1993
*  .46 minor bug in Lya esc prob when grid overrun, changed initial
*      Lya optical depth to 1e20 when none entered
*  .45 density dep for coll dis of H2, non-lte from dalgarno and roberge
*  .44 Kevin Volk's large atlas grid implemented
*  .43 new version of volk type 7 grains block data
*  .42 added more lines to fred's feii atom, now 373
*  .41 improved cs for H2+ + hnu => H + H+
*  .40 diffon totally removed, lgNewIon cleaned up, "diffue fields" cmd gone
*  .39 diffuse fields removed from code
*  .38 suprathermal excitation to n=4 of H added
*  .37 gamk added, slightly smaller heating due to K shell in neutral regions
*  .36 many bugs in secondary excitation of H lines discovered with M Voit
*  .35 conorm totally rewritten to linearize it, alpha ox on ratio command
*  .34 ratio command put in
*  .33 PUNCH RESULTS command, and the ability to read it, added
*  .32 move complete, no write(6 anywhere
*  .31 move write(6, to write(qq,
*  .30 derivative of cooling due to collisional ionization of H improved
*  .29 negative Ly-a cooling changed to heating
*  .28 print continuum in, final continuum printout no longer by default
*  .27 electron collis dest of H2+
*  .26 moved H2+ opacity over to opsv array
*  .25 electron collisional destruction of H2
*  .24 playing around with scale factor multiplying te in TFIRST
*  .23 ElecFrac for routine NOCKON is now ratio electrons to total nuclei,
*      had been to total hydrogen
*  .22 comment if Ca+ photo by Lyalpha ever important
*  .21 increases NLINES to 1000 everywhere
*  .20 updated transit prob for [FeII] lines
*  .19 more [FeII] lines added
*  .18 subroutine CDNOEX added to print header only
*  .17 STIMON removed, only NDUCON used for "NO INDUCED PROCESSES"
*  .16 htau was used for cont pumping of H lines instead of htnext
*  .15 a continuum of zero below 1/36 Ryd turned off occupation numbers
*  .14 small changes to get compton equil to work at very low, hi temp
*      on sparc station
*below end of Cambridge visit
*  .13 fine struc escape prob changed to de Jong et al 1980
*  .12 heating due to CII 157 micron
*  .11 error in implementing Tielens and Hollenbach neutrl collisions
*  .10 ion recombination of grain surfaces
*  .09 heavy element molecule column densities now computed
*  .08 co cooling
*  .07 cosmic ray ionization of helium now ok
*  .06 cosmic ray background doubled to agree with Tielens and Hollenbach
*  .05 CO fully molecular with feedback to carbon, cr ioniz of H2
*  .04 works for NO H-ionizing radiaion, PDR Tielens and Hollenbach
*  .03 cooling flow table continuum
*  .02 excited atom radiative association formation of H2
*below end of Ohio State, ver 82.31, June 19 1992
*  .31 cross section for FeXI 6.09 microns line was off by 100x
*  .30 maser cap changed to -20 optical depths
*  .29 cap on 911 ots field
*  .28 ism abundances added in .22 had wrong n
*  .27 option to add together weighted line intensities
*  .26 minor problem with grain heating entered into lines
*  .25 vary and log options added to turbulence command
*  .24 NIII 990 rad pump includes coll deexcit
*  .23 coments, warnings, etc, now printed in subroutine
*  .22 removed NLR abundances, put ISM in place
*  .21 new coll str for NIII 990 and NIII]1750
*  .20 all photo opacities fully converted to table look-up and plotted
*  .19 changed limits to d(EDEN) in IONIZE
*  .18 NaD in with coll str=1
*  .17 Ni rec, col ion, data up
*  .16 all opacities in, but not debugged, ni rec coef not yet right
*  .15 nickel in, but rec, coll data not right
*  .14 starting to put ni in
*  .13 sodium put in
*  .12 three more lines transferred
*  .11 /TAU/ broken up into many smaller blocks
*  .10 table look up up through magnesion for opacity
*  .09 changed opacity for niii 1750
*  .08 cooling due to collis ioniz-3 body of H, HE was wrong
*  .07 HJBAR now function calling array occnum
*  .06 bowen lya problems again
*  .05 allowed number of pressure iterations increased to 20
*  .04 xopac is history, all in opsv
*  .03 all x-ray opacities now in main opacity array
*  .02 optical depths in Fred's FeII atom
*  .01 abs for vary match of line flux
*82.00 try to stabilize these changes
*  .49 problem with abundances sent to OPACIN recently introduced
*  .48 call to HExCOL moved to before if branch: sometimes
*      temp had changed a great deal after evaluation
*  .47 all outer shell opacities rationalized, cs not good yet
*  .46 second row now complete
*  .45 fixing frequency mesh for opacity
*  .44 mtrxin broken into recomb, ionization parts
*  .43 punch lines structure didn't work with other punch commands
*  .42 emission from AlII] doublet added
*  .41 collisional ionization of Helium cooling back in
*  .40 cleaned up some formatting
*  .39 change increment DTAU1 from .1 to .001
*  .38 bowen niii all done
*  .37 continuum pumping of "bowen" NIII lines
*  .36 energy density command for cont intensity
*  .35 zero out continuum below plasma frequency
*  .34 hydrogen goes fully atomic gracefully (?)
*  .33 stop if negative molecule abundances
*  .32 error in printed optical depth for sphere static, only printout
*  .31 freds improved list of feii lines included
*  .30 feii in on ots fields, abs by balmer continuum
*  .29 feii feed-back into sp population
*  .28 FeII pump by Ly-alpha in?
*  .27 feii pumping routines moving in
*  .26 big COOLNG is history, stack complete?
*  .25 second check that stack is ok
*  .24 all coolants in stack
*  .23 begin move to stack cooling function
*  .22 grain reradiation added as recombination to energy balance check
*  .21 residuals in vary for upper limit changed
*  .20 print sum option added, error in s3 branching ratio fixed
*  .19 few small bugs fixed
*  .18 bug in helium sec ioniz rate introduced in .09
*  .17 Blum and Pradhan cs for CII, NIII, OIV
*  .16 UNKN for rspec is history
*  .15 intensity command added
*  .14 more work on sorting out sqcm vs 4 pi
*  .13 several small changes with control interface
*  .12 metals vary grains abundances too
*  .11 large destruction prob when esp prob is one
*  .10 optimize trace implemented
*  .09 more work on SECMET sec ionization rate
*  .08 major problems with sefn of secion and secla
*  .07 added lots of CALL AddOpac to TFIRST
*  .06 induced He lines photo and cooling removed, was in 2x
*  .05 problem with induced opacity going to zero
*      for very low temp, ContBoltz is 0, energy not
*      conserved for very low temp
*  .04 case B sum in HeI rec coef for very low temp
*  .03 very low temp ly-alpha now case b
*  .02 change NeV coll strength to Lennon and Burke
*81.01 photo cross sec for Fe o changed
*  .05 as debugged as its going to get
*  .04 two small fixes so density of 1e-5 works again
*  .03 grids smaller near Ca-Fe L-edges
*  .02 Brian Espey found compton underflow for low den clouds
*  .01 problem with covering factor command
*80.00 July 31, 1991, all four machines give same answer
*  .17 double precision error in hmole fixed
*  .16 caution if neg heav mole negative
*  .15 certain HeI and HeII variables not reset when no helium
*  .14 compiles on vax, comment if large c in molecules
*  .13 bug in setting outward fraction in radinc, conems
*  .12 improved ir ff heat response to dT
*  .11 default HII region abundances changed, Orion out
*  .10 numerious small changes on sun, back to cray
*  .09 wind problems on sun fixed
*  .08 O2 and O2+ both back in
*  .07 bug in HISTAG setting cap on NFLUX instead of NUPPER
*  .06 lots of work on CO molecules
*  .05 C+ now in heavy molecule balance
*  .04 massive collisional ionization cs update
*  .03 starting to put in CO, etc
*  .02 table star now in vary
*  .01 subroutine for calling code as sub now set
*79.00 May 20, 91, small fixes to get sun, cray to agree
*  .76 all heavy elements reeval in main ioniz loop always
*  .75 change cell size near 10,000 ryd to 10 percent
*  .74 increased lowest temp for h matrix to 400k
*  .73 bug that only happened on 32-bit machines fixed
*  .72 pointer for al opacity off, attenuated 3.8R continuum
*  .71 several small problems, dust now grain in commands
*  .70 several problems with molecules fixed
*  .69 cells reworked with dust
*  .68 dust now rewritten with sense
*  .67 CEXTRA added
*  .66 amoeba range, increment options changed
*  .65 heating terms in electron coll with grains corrected
*  .64 ncell increased to 600, dust grid finer
*  .63 bug in dust cooling
*  .62 radius book-keeping changed to double precision
*  .61 Fe Ka divided into hot and cold
*  .60 code checks that R+dR not equal to R
*  .59 all radius variables moved to new sub, NEWRAD
*  .58 rewrite d(Temp) zoning
*  .57 pointers to H, He, and He+ psuedo-states were off
*  .56 bug in H- emission for low temp
*  .55 more changes in choice of DR for globule
*  .54 covering factor now covgeo, covrt, brmfac is always 0.5
*  .53 change in choice of dr
*  .52 covering factor added correctly
*  .51 covering factor added
*  .50 4 ionizing lines added outward only
*  .49 three nebular approx ionizing lines added transfer
*  .48 added gaunt free-free for He+
*  .47 OVI 1034 in outward beam
*  .46 Fe K-a Auger added in outward only
*  .45 TMN sorted out
*  .44 some ionizing Si, Mg lines added in
*  .43 all rest heavy elemnt rec lines
*  .42 Ly lines of C, O, and Fe in outward only
*  .41 iron included in ots
*  .40 still more ionizing iron lines in outward only
*  .39 C, O, Fe, rec in outward only for sphere
*  .38 HeII rec to n=2 as Milne-relation continuum
*  .37 really stupid typo in reset of occupation numbers on iteration
*  .36 some uv fe lines in outward approx
*  .35 bug in continuum emission due to H n=9 pseudo-state
*  .34 several bugs on iteration with variables not reset
*  .33 zone thickness now checks for dr
*  .32 definition of effective optical depth bad on first iteration
*  .31 several trivial bugs fixed after HII region crash at rice
*  .30 contin renorm in interpolate after OBrien crash
*  .29 OI presses on when negative populations found
*  .28 stop effective column changed back to 1kev due to O K-edge
*  .27 option to read in any slope with TABLE POWER LAW
*  .26 helium in bound electron scattering
*  .25 OI back reaction in as difference
*  .24 sub-millimeter break in agn table changed to 10 microns
*  .23 FeIX 245 in; OI back-effect on HI not included
*1990 below
*  .22 ots OI fields all in, ADDOTS defined
*  .21 oxygen model atom seems to work
*  .20 OI now six level atom
*  .19 abundances no dust no longer changes abundances of depleted elements
*  .18 multiple numbers on vary generated line, HDEN now thichness or radius
*  .17 put OTS continua from C, O back in as source of ionization
*  .16 Bowen 660 ots bug introduced in .14 fixed
*  .15 c, o rec continua back in, all otslin, otscon
*  .14 He ots fields fully looped, checking for overlap in pntset
*  .13 CONOTS split into OTSCON and OTSLIN
*  .12 bug introduced in .10 fixed
*  .11 OIII 5007/4959 ratio four not three; bug for about 6 months
*  .10 all helium lines OTS, destruction
*  .09 line center opacity for OIII 1666 10 times too small
*  .08 cooling due to hydrodynamic expansion
*  .07 option to iterate until it converges
*  .06 H state specific recombination cooling over wide range of temp
*  .05 exact form of H rad rec coef
*  .04 hydrogen absorption, emission, now up to n=9
*  .03 Pradhan's hydrogenic cros sec in for H, He+
*  .02 formally correct hydrogen continuum escape prob
*  .01 Hummer escape prob did not go to 1 at zero optical depth
*78.00 Nov 13 90, all checks running ok??
*  .42 bound compton heat now included for all ionization levels
*  .41 optimize column densities fully implemented
*  .40 mean ionization arrays from original Camb version to logical one
*  .39 bug introdcued in resizine flux, pointer to Lyman line above LyCon
*  .38 bug in computation of wind velocity
*  .37 change H optical depths from Hummer to me
*  .36 RECEFF for all helium states
*  .35 TAUTOT now in and out, RECEFF just pointer
*  .34 carbon, oxygen outward killed
*  .33 made opacity array defined for all freq no matter what nflux
*  .32 debugged Hummer escape for Ly-a
*  .31 move to Hummer Lya escape, dest prob
*  .30 numerical arry to 100MeV; compton, pair now exact
*  .29 now passes induced test for He; bug in cont pump esc prob
*  .28 OPSAV is history
*  .27 all he reference to opsav gone
*  .26 many non-he opac  sources changed from OPSAV to OPSV
*  .25 only evaluate OPAC0 on first shot at code
*  .24 yet another H opacity pointer bug introduced in .17
*  .23 optimize line intensities included
*  .22 H induced cooling array was not zeroed at start of iteration
*  .21 array telling if line added heat, cool, or intensity
*  .20 T912 on zone print now total aborption optical depth
*  .19 change printout of AMOEBA routine, range option
*  .18 He opac bug introduced in ver .17 fixed; OPSV array one dimen
*  .17 effective x-ray optical depth now 0.5 kev not 1 kev, H opsv array
*  .16 HeI oscillations of dest prob in high density models
*  .15 read in table of points
*  .14 readjusted frequency partition; dust probably wont work now
*  .13 explicit E2 function written, Harrington version deleted
*  .12 change Hummer PESCK2 to my ESA0K2
*  .11 EOVRLP back to original state
*  .10 H continuum goes to LTE within few percent
*  .09 correc to He sing pop, trip pop, in opacity scale
*  .08 He ground rec in diffus, ionizing rad not added to conots
*  .07 "reflected" continuum supposed to be in with exp integral
*  .06 options to read arrays or do IO for calling as sub
*  .05 optimize seems to work
*  .04 all Bob's subs in place for optimize
*  .03 all input lines now into KARDSV first, then read array
*  .02 line width constant core for 8446 problem
*  .01 gaunt factor of nu**-0.2 added to brems
*77.00 minor change in dust common block, now DSTAP and DSTAP1
*  .03 more minor changes, get map to work
*  .02 last day at JILA, a trivial chagnge, orion paper submitted
*  .01 remesh continuum between 8 and 10 eV to stop grain pot oscil
*76.00 final Orion Models
*  .63 checking on dielec rec for sulphur
*  .62 7th grain added
*  .61 change in 374 pumping of HeII
*  .60 grain recombination cooling of gas
*  .59 collisional heating of grain in
*  .58 six grain types now in
*  .57 function hlnop gone, now just summed into conots
*  .56 BUG - FillFac not mult DRNEXT in TauInc
*  .55 CIV 1540 destruction by Balmer continuum
*  .54 BIG BIG CHANGE in LyA/Hbet due to Hummer beta*F(beta) function
*  .53 many small bugs in h line photoionization
*  .52 0.5 - 1 ryd continuum three times higher resolution
*  .51 many small changes in NEXTDR to stop TE fail, better H line ioniat
*  .50 all hydrogen now HNET and HDEST included, along with CONOTS
*  .49 all lines now humer k2
*  .48 bound free continuum in optical and ir vastly improved
*  .47 line destruction probabilities now Hummer function
*  .46 helium now rid of all E1 fun for IR continua
*  .45 free-free heating cooling now uses real ff tau
*  .44 Lyman lines now K2 by default
*  .43 K2 now default for hydrogen subordinate lines
*  .42 h levels 3 - 7 now done correctly for photo effects
*  .41 better Rayleigh scattering cross sections
*  .40 Humer K2 function for H subordinate lines
*  .39 scattering opacity now half in dI propto dTau
*  .38 start moving to HDEN is total hydrogen nuclei in all forms;
*  .37 lgDustOn1 used to turn off individual dust grains
*  .36 first shot at Peter's reworking of grain heating
*  .35 Q's defined always before cap
*  .34 bug in calculation of nFnu in lines
*  .33 new SOLAR abundances
*  .32 lots of bugs in pressure; loop now keeps const to 2 percent
*  .31 all OPSVMM removed
*  .30 both emission and opacity in for HeII free bound
*  .29 bound free opacities in for hydrogen n=3,6
*  .28 Kevin Volk PN silicate grain opacity function now in as 3rd dust
*  .27 H- radiative assoc now series of approximations; LTE pop better for mol
*  .26 several more LINEAR options added
*  .25 CI mm lines  in, molecules work? H2+ shielding
*  .24 breaking finished
*  .23 plot broken up into pieces
*  .22 fine structure line pumping now in
*  .21 reflected beam now in
*  .20 warn if mole not done, neiii fs156 was not in array
*  .19 two pop of dust in photo threshold
*  .18 attenuation of HeI pump by continuum
*  .17 change resion to OTS, put into conots
*  .16 static now works
*  .15 Q now defined in terms of correct dust area for cap or abs
*  .14 fractional bit, interpolated potential, now in
*  .13 electron vel in grain recombin wrong; now larger
*  .12 grain heating bug fixed
*  .11 punch continuum now same units as continuum flux in output
*  .10 STATIC now works on iteration for all lines
*  .09 background opacity destruction of 10830; STATIC defined
*  .08 now TAUTOT, TAUABS, and TAUSCT arrays
*  .07 dust reemission missed factor of 4pi
*  .06 now print temp of rad fields every zone
*  .05 neutron command now more standard, efficiency added
*  .04 sec ioniz due to neutrons included
*  .03 bug in effect col den printed where sphere set
*  .02 NEXTDR now looks at change in temp also
*  .01 OTSCap now command
*75.00 stop effective column; major debugging completed
*  .23 dust heating reduced by Draine factors
*  .20 wind line optical depths fixed (big bug), "u" before Te
*  .19 new Kurucz model atmospheres
*  .18 now 10 tables ok
*  .16 HOUTON killed, no hydrogen outward command
*  .15 helium continuum masing made stable for HII region
*  .14 dust sticking prob, photo yield, changed
*  .05 everything works??? (fixed 3-body bug, eden bug for cold phase)
*  .04 he bug traced to numerical instability in matrix error, OK???
*  .02 Q's now in for dust, effective area per proton too
*  .01 HII/HI now variable H2OVH1, use all six low n
*74.00 RIDGE crash; move onto CRAY, everything OK with INDEF, dynamic mem
*  .53 COOLR broken up into each element
*  .52 plot map of heating cooling
*  .51 TALK now included in PUNT
*  .49 SPTYPE changed from integer to word, laser should work exact Q
*  .48 some fixes to array pointers; IPOINT now works new way
*  .47 NCELMM is history
*  .46 NCELMM not used except except in COMMON
*  .45 all heavy element pointers now on NCELMM+NCELL scale
*  .44 HeI singlet opacity bug introduced in .43 fixed
*  .43 helium pointers now go to NCELMM+NCELL, but answer is wrong
*  .42 IPOINT now runs to NCELMM+NCELL
*  .41 OPSAV now NCELMM+NCELL
*  .40 no array(NCELMM) in code now; doesn't work though
*  .39 no more mm vs uv in setup
*  .38 more changes to get rid of anumm
*  .36 warnings if density very small and dC/dT zero
*  .35 warn if maser very thick, sphere comments corrected
*  .34 stop optical depth command
*  .33 photoelectric heating of gas by dust
*  .32 DRMIN problem, now nu*f_nu at 912 in header
*  .31 OTS helium field induced recombination, cooling
*  .30 change in EOVLAP caused RESION to be misdefined in COOLR
*  .29 helium ots fields not defined correctly for very low temper
*  .28 bug; extin command did not affect contin saved for second iteration
*  .27 adjusted behavior of HE2LEV in low temp limit
*  .26 ISM option for TABLE command, from Black 1987
*  .25 Orion dust option, cap on dust opacity
*  .24 force due to incident continuum now printed
*  .23 magnitudes now printed, slant angle also
*  .22 S+ cross section to Mendoza background
*  .21 now print NeN+ dl, without temp
*  .20 print options added
*  .19 HeI two photon in outward beam
*  .18 TABLE STAR MIHALAS now in for log(g) = 4
*  .17 grain charge, ionization potential, now consistent
*  .16 Draine and Salpeter grain charge, drift vel
*  .15 minor fixes after VAX and CRAY runs
*  .14 Bowen set to 0.5, ContDiff defined
*  .13 heii bowen depletion of ly-a included
*  .12 H-beta flux for test hot PN exact agreement with Harrington
*  .11 HeI, II Ly-a OTS, CONOTS array, Lyman dst prop in both
*  .10 he works well for large densities, singlets off by 2 for largel rad
*  .09 triplet - singlet coupling
*  .08 sort of runs on Cray with Indef
*  .07 statistical weights OK for HeI singlets, goes to LTE
*  .06 try to get HeI to LTE in high photon limit
*  .05 minor problems fixed
*  .04 HeII lines added, test against Seaton case B
*  .03 n=1, 2 state photo included for HeI singlets
*  .02 error in As for two phot, WIDFLX not included
*  .01 initial induced two photon rate
*73.00 HeII goes to LTE both high phot and H density
*  .28 adjusted rec to HeII n=2 to get exactly right departure coef
*  .27 HeII goes to LTE in hi-gam limit, photo cross sec was off
*  .26 sort of runs on Cray with indef
*  .25 multiple lgHeBug options
*  .24 HeII goes to LTE, but atomic data wrong
*  .23 much confusion about helium
*  .22 LINDST includes LINADD; DSTRAD cleaned up
*  .21 default inner, outer radii changed
*  .20 AS => HYAS
*  .19 some minor changes in hydrogen
*  .18 NLR abundances
*  .17 GLOB, outward dust line interaction
*  .16 much confusion about dust
*  .15 fixed plot, new cs from peter martin
*  .14 two dust temps work, but not yet Ly-alpha
*  .13 dust temp works
*  .12 first edition of spline dust cross section, 1 abs only
*  .11 hydrogen HLNOPC now uses full opacity array
*  .10 dust now in its own array, NDUST used, scatter+abs OK
*  .09 reorganized RFIELD so IR, UV arrays are adjacent
*  .08 HeI 584 radiation pressure
*  .07 WIDFLX defined consistently; HEVAL defined
*  .06 Mgo + H+ => Mg+ + Ho charge transfer from Allan et al. 88
*  .05 all temp are logs if 10 or below
*  .04 IRCOIL misspelled in loop for soft ionizing scattering opacity
*  .03 further improve on 304 rad press; two sided esc kept now
*  .02 FIREBALL command, final few fixes for Compton limit
*  .01 minor changes in ANU array for Compton limit
*72.00 full log scale for UV array, IPOINT works in both regimes
*  .21 lowest frequency changed to 1E-5 Ryd
*  .20 EDEN added, tuning EMM
*  .19 bug in DA when temperatures near 10K
*  .18 trying to bet 34K blackbodies to work
*  .17 rough induced Compton heating included for T=10^9K
*  .16 IR continuum Comptonization now zone by zone, cell by cell
*  .15 Crab Nebula continuum added to TABLE command
*  .14 TAUMN chanced to TMNUV, TMNMM defined for IR array
*  .13 cleaned up several aspects of wind; passes e- only tests
*  .12 RFORCE was not included in acceleration
*  .11 RECEFF now works for 50,000K and Balmer continuum
*  .10 HTOT now only evaluated from PHEAT
*  .09 heating was being changed in IONTE loop incorrectly
*  .08 CSUPRA was on when EDEN/(H+HE) < 0.95; now ratio is E/H only
*  .07 low energy cutoff in power law command
*  .06 FirstDR changed to take stop ionized and neutral into account
*  .05 STOP IONIZED and NEUTRAL column density
*  .04 cleaned up luminosity option, dump lines,
*  .03 rewrite lumin renorm, now default is total lumin, t=3K works
*  .02 approximations for H, He ground state rec ceof
*  .01 check whether opac(NH)=0 in DIFOTS (fix crash at T=10**9K)
*71.00 gaunt factors for UV arrays
*  .02 define DERROR in IONTE, include D(Heat)/dT always
*70.00 all OK?
*  .62 con dest XYZ, optical depth F12
*  .61 opacity due to bound electron scattering
*  .59 Hummer gaunt now in for IR array
*  .58 Boltz fact now 4 parts, not always evaluated
*  .56 Steward (79) cross section for HeI 23S, 2x bigger
*  .55 HeI ground state diffuse fields counted twice
*  .53 electron scattering treated as 1/tau not e-tau
*  .48 H-line heating now corrected for dust cross section
*  .47 optical depths for [CI] [OI] lines, SiVII added
*  .46 wrong A for CaII K
*  .45 thermal dust emission in IR array
*  .44 all H- processes have back reactions
*  .42 better opacities for H-, induced, spon, but not in yet
*  .41 H- changed to Lites and Mihalas
*  .39 defined far numerical array, Kindgon Ca charge transfer
*  .36 CaII IR trip with complete redis
*  .35 change to esc prob with a's
*  .34 H 7-8 opacity added
*  .33 H- heating added
*  .29 Koristas numbers for iron line pumping
*  .28 hydrogen self ionization now in
*  .27 problem with ionizat stage pointers on iteration
*  .26 calcium 5-level atom ok(?)
*  .21 dust emission in line array, abund in FINAL ok for faint
*  .19 corrected neg sign error in FCHEI, elec den converg
*  .18 added f(nu) option for luminosity
*  .15 2-pt Gaussian quad for CONSET freq integ
*  .12 Si II fs collision strength from Keenan et al.
*  .11 Helium now modularized, but HEONE still separate
*  .07 bug in free-free heating rate
*69.00 end of Cambridge stay
*  .27 Ly-beta had overlap rate, not emission rate, in line printout
*  .26 Lyman continuum astrophysical flux now predicted
*  .25 heavy element collision ionization now separate coolant
*  .23 induced Compton scatter for numerical array
*  .22 fix several bugs introduced along the way, added Occ, Tbr printout
*  .18 cooling due to induced rec
*  .17 free-free heating
*  .16 heating due to n>=3 of hydrogen
*  .15 induced rec and photoioniz from level 7
*  .14 induced processes for all H lines
*  .12 three body rec to He, departure coef defined
*  .11 continuum does not HAVE to be fully defined, warning results
*  .10 continuous opacity scale corrected for induced rec
*  .09 induced rec to 1, 2
*  .08 induced rec to n=3,6 of hydrogen
*  .07 full optical depths for O5 630, Ne8 774
*  .05 logic error in stop for line strength
*68.01 vary HTOT in IONTE when only H changed
*67.00 IBM version - OK
*  .43 Berrington and Kingston He I rates
*  .33 escape prob for fine structure lines; optical depth scale fixed
*  .29 rework Fe II and Mg II photo onto n=2 (small numer chan)
*  .28 8446 on n=3 pop
*  .24 BIG bug in defn of outer optical depths
*  .13 heavy element brems now from Harrington '82 pn paper
*66.00 ten level hydrogen atom
*  .04 cs for Mg3+ Mg4+ from Mendoza ann Zeippen 1987
*  .03 Pequignot and Aldrovandi fits to rad rec for t<1000
*65.00 three body rec coef from S. Cota
*64.00 PAIR PRODUCTION!!!  also extend nu to 100 MeV
*  .01 calcium and aluminum
*63.00 made c a subroutine, exch coll for he to berrington et al, setup>3
      END
*****************************************
      real function vfun( x )
      implicit none
*approximate form of Voit function
      real x
      real sqrtpi
      parameter (sqrtpi=1.7724539)
      real pmpdmp
      common/pmpdmp/ pmpdmp
*
*     local variables
      real sexp
*
      vfun = sexp( x*x ) + pmpdmp/sqrtpi /(1.+ x*x )
*
      end
************************************************************
      subroutine atlas( nstar , temp , alogg , nspec , lgTrace )
      implicit none
*interpolate on atlas model atmospheres, by K Volk
      real alogg , temp
      integer nstar,nspec
      logical lgTrace
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      character chPath*80
      common/path/ chPath
      character chLine*80
      logical lgPathSet
*true is path has been set with set path command, false otherwise
      common/pthset/ lgPathSet
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real dev1 , dev2
      integer j,k,j1,ierr,nmods,i , jmod
      logical lgAgain
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
*     these routines written by Kevin Volk
      parameter (nmods=412)
*     tnu array will be used to hold stellar array
*
*
* nmods is the number of accessable models in the new model set
* record 3 is the wavelength grid, record 2 holds the log(g) values,
* and record 1 holds the T_eff values, so there are nmods+3 records
* in the main file
*
* the values are all in integer format, usually of log10 quantities
*     real flux(ncell)
      integer ivals(ncell)
      real teff(nmods),xlogg(nmods)
      real tval(61)
      integer jval(11,61)
      data tval/3500.,3750.,4000.,4250.,4500.,4750.,5000.,5250.,
     1          5500.,5750.,6000.,6250.,6500.,6750.,7000.,7250.,
     1          7500.,7750.,8000.,8250.,8500.,8750.,9000.,9250.,
     1          9500.,9750.,10000.,10500.,
     1          11000.,11500.,12000.,12500.,13000.,14000.,15000.,
     1          16000.,17000.,18000.,19000.,20000.,21000.,22000.,
     1          23000.,24000.,25000.,26000.,27000.,28000.,29000.,
     1          30000.,31000.,32000.,33000.,34000.,35000.,37500.,
     1          40000.,42500.,45000.,47500.,50000./
* these arrays hold the teff and log(g) values for the models in the
* set; if the parameters are in range, interpolation is done first in
* temperature and then in log(g)
*
* start by reading in the parameters
*
*
*     add together path to form atlas file
*
*     true is special path set, false if file in same dir
      if( lgPathSet ) then
        j = 1
        lgAgain = .true.
        i = 1
*     >>chng 97 may 13, get rid of statement numbers
*       do i=1,80
        do while (lgAgain.and. i.le.80 )
          if( chPath(i:i).ne.' ') then
            chLine(j:j) = chPath(i:i)
            j = j + 1
          else
*           go to2
            lgAgain = .false.
          endif
          i = i + 1
        end do
*2      continue
*       j now points to first free character
        chLine(j:j+8) = 'atlas.mod'
*       end string with zero character
        chLine(j+9:j+9) = char(0)
      else
        chLine(1:9) = 'atlas.mod'
*       end string with zero character
        chLine(10:10) = CHAR(0)
      endif
*
      do j=1,11
        do k=1,61
          jval(j,k) = -1
        end do
      end do
*
*     gjf open(unit=92,file='atlas.mod',
      if(lgTrace)write(qq,'('' About to open file='',A80)') chLine
      open(unit=92,file=chLine,
     1     status='old',access='direct',
     1     form='formatted',iostat=ierr,recl=7*ncell)
*
*     something went wrong
      if( ierr.ne.0 ) then
        write(qq,'(''Error: Kurucz stellar atmosphere file'',
     1  '' atlas.mod not found.'')')
        write(qq,'('' The path I tried:'',A80)') chLine
        write(qq,'('' And here comes its octal representation:'')')
        write(qq,'(1X,A1,Z4)') (chLine(i:i),chLine(i:i),i=1,80)
*       write(qq,'(1X,A1,O4)') (chLine(i:i),chLine(i:i),i=1,80)
        stop
      endif
*
      if(lgTrace)write(qq,'('' About to get temps'')')
      read(92,'(4000i7)' ,rec=1,iostat=ierr) (ivals(j),j=1,nmods)
*999  format(4000i7)
      if( ierr.ne.0 ) then
        write(qq,'('' IOSTAT returned'',I3,'' when reading '',
     1   ''temperatures.'')') ierr
        stop
      endif
*
      do j=1,nmods
        teff(j) = float(ivals(j))
      end do
*
      if(lgTrace)write(qq,'('' About to get gravs'')')
      read(92,'(4000i7)' ,rec=2,iostat=ierr) (ivals(j),j=1,nmods)
*       write(66,'(4i10)') (ivals(j),j=1,nmods)
      if( ierr.ne.0 ) then
        write(qq,'('' IOSTAT returned'',I3,'' when reading '',
     1   ''gravities.'')') ierr
        stop
      endif
*
      do j=1,nmods
        xlogg(j) = float(ivals(j))/100000.0
      end do
*
      if(lgTrace)write(qq,'('' About to get wavelengths'')')
      read(92,'(4000i7)' ,rec=3,iostat=ierr) (ivals(j),j=1,nAtlas)
      if( ierr.ne.0 ) then
        write(qq,'('' IOSTAT returned'',I3,'' when reading '',
     1   ''wavelengths.'')') ierr
        stop
      endif
*
*     dec alpha compiler was too smart, flagged following sanity check
      i = nAtlas
      j = ncell
*     if( nAtlas.gt.ncell ) then
      if( i.gt.j ) then
        write(qq,'('' Too many points read in from stellar atmosphere.''
     1  ,''  Increase ncell everywhere.  Min='',I5)')nAtlas
        stop
      endif
*
      do j=1,nAtlas
*       tnu holds the frequency arrays
        tnu(nspec,j) = 10.**(-1.*float(ivals(j))/1000000.+5.0)
      end do
*
      do j=1,nmods
        j1 = int(2.*xlogg(j)+0.001)+1
        if( j1.lt.1 .or. j1.gt.11 ) then
          write(qq,'('' atlas finds insane j1:'',i5,
     1    '' j, xlogg(j),='',i5,1p,e10.2)') j1,j,xlogg(j)
          stop
        endif
        do k=1,61
          if( teff(j).eq.tval(k) ) jval(j1,k)=j+1
        end do
      end do
*
*      determine which model or models are needed.
*
*     TEMP and ALOGG are desired temp and log g
*
      jmod = -1
*
      lgAgain = .true.
      j = 1
*     doj=1,nmods
*     >>chng 97 may 13, get rid of statement number
      do while( lgAgain.and. j.le.nmods )
        dev1 = abs(temp/teff(j)-1.)
        if( xlogg(j).gt.0.4 ) then
          dev2 = abs(alogg/xlogg(j)-1.)
        else
          dev2 = abs(alogg-xlogg(j))
        endif
*       this is because log(g) can be zero for the new set of models
*       this is test for exact model, result is jmod still -1 if hit
        if (dev1.le.0.001.and.dev2.le.0.001) then
          jmod = j+1
*         go to335
          lgAgain = .false.
        endif
        j = j + 1
      end do
*335  continue
*
      if (alogg.lt.0..or.alogg.gt.5.) then
*       this rejects temps outside the range of models
        write(qq,'('' Gravity outside range of 0.0 to'',
     1  '' 5.0'')')
        stop
      endif
*     following blocks either a) interpolate or b) get exact model
      if (jmod.eq.-1) then
         if (temp.lt.3500..or.temp.gt.50000.) then
*          this rejects values outside the range of model temperatures
           write(qq,'('' Temperature outside range of 3500 to'',
     1     '' 50,000K'')')
           stop
         endif
         if(lgTrace)write(qq,'('' About to call GETATL.'')')
         call getatl(temp,alogg,jval,tval,ierr,teff,xlogg)
         if( ierr.eq.1 ) then
           write(qq,'('' GETATL returned ierr=1, stop.'')')
           stop
         endif
*        the GETATL subroutine carries out the interpolation
*        in t_eff and log(g)
      else
         if(lgTrace)write(qq,'('' Exact model about to be read in.'')')
*        read in the values (log10 of F_nu in cgs units)
         read(92,'(4000i7)' ,rec=jmod+2,iostat=ierr)(ivals(j),
     1   j=1,nAtlas)
*
         if( ierr.ne.0 ) then
           write(qq,'('' IOSTAT returned'',I3,'' when reading '',
     1      ''atlas model number'',I3)') ierr , jmod+2
           stop
         endif
*
          if(lgTalk)write(qq,'(23X,''*<<< K. Volk s Kurucz model '',I3,
     1    '' read in.  T_eff = '',F8.2,'' log(g) = '',F8.5,
     2    ''  >>> *'')') jmod-1,teff(jmod-1),xlogg(jmod-1)
*
          do j=1,nAtlas
            if( ivals(j).lt.9999999 ) then
              flux(j) = 10.**(-1.*float(ivals(j))/100000.0)
            else
              flux(j) = 0.
            endif
          end do
      endif
*
      do j=1,nAtlas
*       TSLOP is f_nu for each TNU point
        tslop(nspec,j) = flux(j)
      end do
      do j=nAtlas+1, ncell
        tslop(nspec,j) = 0.
      end do
*
      nstar = nAtlas
*
      close(unit=92)
*
      end
******************************************************************************
      subroutine getatl(temp,alogg,jval,tval,ierr,teff,xlogg)
      implicit none
*get one of the Atlas model atmospheres, coded by K. Volk
      real temp,alogg
      integer ierr
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      integer nmods , j , i , j1,i1
      real xval,fr1,fr2,fr3,fr4,gval
*     parameter (ndata=865,nmods=412)
      parameter (nmods=412)
      real teff(nmods),xlogg(nmods)
      real tval(61)
      integer jval(11,61) ,ivals(ncell) , ierror
      real flux1(ncell),flux2(ncell)
      logical lgTHit
*
      do j=1,61
        do i=10,1,-1
          if( jval(i,j).eq.-1 ) jval(i,j) = jval(i+1,j)
        end do
      end do
*
*     determine which models are to be interpolated
*
      lgTHit = .false.
      do j=1,60
        if( tval(j).le.temp.and.tval(j+1).gt.temp ) then
          j1 = j
          lgTHit = .true.
        endif
      end do
*
      if( .not.lgTHit ) then
        if( tval(61).eq.temp ) then
          j1 = 60
        else
          write(qq,'('' Requested temperature of'',1P,E10.2,
     1    '' is not within the range'',1P,2E10.2)')
     2    temp, tval(1), tval(61)
          stop
        endif
      endif
*
      xval = 2.*alogg+1.0
      i1 = int(xval)
*
* Interpolation is carried out first in Teff and then in log(g).
* Two Kurucz models are read in for the lower log(g) value first, which
* I denote models A and B with B the higher T model [j1+1 rather than j1].
* unless alogg is 5.0 a second pair of Kurucz models are read in for the
* higher log(g) value, denoted models C and D.  Then the interpolation is
*
*  RESULT = fr2*(fr3*B+fr4*A)+fr1*(fr3*D+fr4*C)
*
* when one has 4 models and
*
* RESULT = (fr3*B+fr4*A)
*
* when one has just 2 models.
      fr1 = xval-float(i1)
      fr2 = 1.-fr1
      fr3 = (temp-tval(j1))/(tval(j1+1)-tval(j1))
      fr4 = 1.-fr3
*
*     read(92,'(4000i7)' ,rec=jval(i1,j1)+2,err=700)
*     >>chng 97 july 24, get rid of go to
      read(92,'(4000i7)' ,rec=jval(i1,j1)+2,iostat=ierror)
     1 (ivals(j),j=1,nAtlas)
      if( ierror.ne.0 ) then
        ierr = 1
        return
      endif
*     following must change if ncell changes
*999  format(4000I7)
      gval = xlogg(jval(i1,j1)-1)
*
      if(lgTalk)write(qq,'(23x,''*<<< K. Volk s Kurucz model '',I3,
     1 '' READ IN.  T_eff = '',F8.2,'' log(g) = '',F8.5,''  >>> *'')'
     2 ) jval(i1,j1)-1,teff(jval(i1,j1)-1),gval
*
      do j=1,nAtlas
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*       flux1(j)=10.**(-1.*float(ivals(j))/100000.)
        flux1(j) = (-1.*float(ivals(j))/100000.)
      end do
*
*     >>chng 97 july 24, get rid of go to
      read(92,'(4000i7)' ,rec=jval(i1,j1+1)+2,iostat=ierror)
     1 (ivals(j),j=1,nAtlas)
      if( ierror.ne.0 ) then
        ierr = 1
        return
      endif
      gval=xlogg(jval(i1,j1+1)-1)
      if(lgTalk)write(qq,'(23X,''*<<< K. Volk s Kurucz model '',I3,
     1 '' READ IN.  T_eff = '',F8.2,'' log(g) = '',F8.5,''  >>> *'')')
     2 jval(i1,j1+1)-1,teff(jval(i1,j1+1)-1),gval
*
      do j=1,nAtlas
*       flux2(j) = 10.**(-1.*float(ivals(j))/100000.)
        if( ivals(j).lt.9999999 ) then
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*         flux2(j) = 10.**(-1.*float(ivals(j))/100000.0)
          flux2(j) = (-1.*float(ivals(j))/100000.0)
        else
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*         flux2(j) = 0.
          flux2(j) = -35.
        endif
      end do
*
      do j=1,nAtlas
        flux(j) = fr4*flux1(j)+fr3*flux2(j)
      end do
*
      if (i1.lt.11) then
*         for log(g) < 5.0 repleat the interpolation at ht elarger log(g) then
*         carry out the interpolation in log(g)
*         >>chng 97 july 24, get rid of go to
          read(92,'(4000i7)' ,rec=jval(i1+1,j1)+2,iostat=ierror)
     1    (ivals(j),j=1,nAtlas)
          if( ierror.ne.0 ) then
            ierr = 1
            return
          endif
          gval = xlogg(jval(i1+1,j1)-1)
          if(lgTalk)write(qq,'(23X,''*<<< K. Volk s Kurucz model ''
     1    ,I3,'' READ''
     1    ,'' IN.  T_eff = '',F8.2,'' log(g) = '',F8.5,''  >>> *'')')
     2    jval(i1+1,j1)-1,teff(jval(i1+1,j1)-1),gval
*
          do j=1,nAtlas
*           flux1(j)=10.**(-1.*float(ivals(j))/100000.)
            if( ivals(j).lt.9999999 ) then
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*             flux1(j) = 10.**(-1.*float(ivals(j))/100000.0)
              flux1(j) = (-1.*float(ivals(j))/100000.0)
            else
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*             flux1(j) = 0.
              flux1(j) = -35.
            endif
          end do
*
*         >>chng 97 july 24, get rid of go to
          read(92,'(4000I7)' ,rec=jval(i1+1,j1+1)+2,iostat=ierror)
     1            (ivals(j),j=1,nAtlas)
          if( ierror.ne.0 ) then
            ierr = 1
            return
          endif
          gval = xlogg(jval(i1+1,j1+1)-1)
          if(lgTalk)write(qq,'(23X,''*<<< K. Volk s Kurucz model ''
     1    ,I3,'' READ''
     1    ,'' IN.  T_eff = '',F8.2,'' log(g) = '',F8.5,''  >>> *'')')
     1    jval(i1+1,j1+1)-1,teff(jval(i1+1,j1+1)-1),gval
*
          do j=1,nAtlas
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*his changes did not have this commented out - oversight??
*           flux2(j)=10.**(-1.*float(ivals(j))/100000.)
            if( ivals(j).lt.9999999 ) then
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*             flux2(j) = 10.**(-1.*float(ivals(j))/100000.0)
              flux2(j) = (-1.*float(ivals(j))/100000.0)
            else
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*             flux2(j) = 0.
              flux2(j) = -35.
            endif
          end do
*
          do j=1,nAtlas
            flux1(j)=flux1(j)*fr4+flux2(j)*fr3
          end do
*
          do j=1,nAtlas
*     >>chng 96 dec 27, as per K Volk change, to interpolation in log of space
*           flux(j)=fr2*flux(j)+fr1*flux1(j)
            flux(j) = 10.**(fr2*flux(j)+fr1*flux1(j))
          end do
      else
*     One gets here if log(g) is 5.0 and there is no higher log(g) pair of
*     models to interpolate.
*
        do j=1,nAtlas
          flux(j) = 10.**flux(j)
        end do
      endif
*
      ierr = 0
*     return
*700  continue
*     ierr = 1
*     return
      end
*
******************************************************************************
      subroutine werne( nstar , temp , alogg , nspec )
      implicit none
*read in and interpolate on Werner grid of PN atmospheres, by K Volk
      real temp, alogg,dev1,dev2,term
      integer nmods,nstar,nspec,j,i,ierr,istop1,jmod
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      real tnu, tslop, tfac
      common/terp/ tnu(limspc,ncell) , tslop(limspc,ncell) ,
     1 tfac(limspc,ncell)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      character chPath*80
      common/path/ chPath
      character chLine*80
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      logical lgPathSet
*true is path has been set with set path command, false otherwise
      common/pthset/ lgPathSet
      integer nupper
*number of frequency cells needed to get full energy resolution of code
      common/NumUpper/ nupper
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*     parameter (ndata=865,nmods=20)
      parameter (nmods=20)
* SUBROUTINE "WERNE" WAS ADDED (28 DEC 1992) TO READ FROM THE SET OF
* HOT WHITE DWARF MODEL ATMOSPHERES FROM KLAUS WERNER AT KEIL.  THE
* VALUES ARE READ IN (ENERGY IN RYDBERG UNITS, LOG10(F_NU) [F_NU IN CGS
* UNITS]) FOR ANY OF 20 MODELS.  T_EFF VALUES OF 80, 100, 120, 140, 160,
* 180 AND 200 THOUSAND K AND LOG(G) VALUES OF 5.0, 6.0, 7.0, AND 8.0 ARE
* AVAILABLE.  THIS VERSION DOES INTERPOLATION.  IF A MODEL HAS A T_EFF
* AND A G VALUE WITHIN 1% OF THE VALUES SPECIFIED IN THE PARAMETERS, THAT
* MODEL IS CHOSEN FOR USE.  EACH MODEL HAS 514 POINTS, THE LONGEST WAVELENGTH
* POINT BEING AN EXTRAPOLATION FROM THE NEXT TWO POINTS.  THE FILE IS A
* FORMATTED DIRECT ACCESS FILE WITH RECORD LENGTH 7*865=6055 BYTES, FORMAT
* 865I7=3*250i7,115i7.
*
* FILE USED: WERNER.MOD (CONTAINS THE WAVELENGTH ARRAY, THEN THE MODELS)
*
* TESTS INDICATE THAT THE INTERPOLATION AND RESCALING PRESERVE THE SET
* T_EFF VALUE (MEASURED BY THE SURFACE FLUX) TO WITHIN ABOUT 100 K FOR
* ANY TEMPERATURE IN THE 80,000 TO 200,000 K RANGE.  RESCALING BY FACTORS
* OF ORDER 1.01 TO 1.1 ARE NEEDED TO ACHIEVE THIS, SINCE THE INTERPOLATION BY
* ITSELF CAN PRODUCE SOME DEVIATIONS.  THE LARGEST RESCALING IS NEEDED AT
* "LOW" T_EFF AND LOG(G) VALUES.  FOR HIGH TEMPERATURES THE SCALING IS SELDOM
* LARGER THAN 1.01.
*
* THESE RESCALING RESULTS ARE FOR THE FULL MODELS, NOT THE REBINNED VERSIONS.
* THE NUMBER OF GRID POINTS IS NOT CHANGED TOO MUCH, SO THE RESULTS SHOULD
* NOT BE AFFECTED TOO MUCH.
*
*
*     nmods is the number of accessable models in the werner model set.
*     data set 1 is the wavelength grid, so there are nmods+1 data sets
*     in the main file.  each set has 865 re-binned values, increasing in
*     frequency.  the original models had 514 values.
*
      real wl(ncell), teff(nmods),xlogg(nmods)
      integer ivals(ncell),modnum(7,4)
      real tval(7),gval(4)
      logical lgAgain
*
      data tval/80000.,100000.,120000.,140000.,160000.,180000.,
     1          200000./
      Data gval/5.,6.,7.,8./
      data modnum/2,6,10,13,16,18,20,3,7,10,13,16,18,20,4,8,11,14,
     1            16,18,20,5,9,12,15,17,19,21/
      data teff/80000.,80000.,80000.,80000.,100000.,100000.,100000.,
     1          100000.,120000.,120000.,120000.,140000.,140000.,
     1          140000.,160000.,160000.,180000.,180000.,200000.,
     1          200000./
      data xlogg/5.,6.,7.,8.,5.,6.,7.,8.,6.,7.,8.,6.,7.,8.,7.,8.,
     1           7.,8.,7.,8./
*
*     add together path to form atlas file
*
*     true is special path set, false if file in same dir
      if( lgPathSet ) then
        j = 1
        lgAgain = .true.
        i = 1
*     >>chng 97 may 13, get rid of statement number
*       do i=1,80
        do while( lgAgain.and.i.le.80 )
          if( chPath(i:i).ne.' ') then
            chLine(j:j) = chPath(i:i)
            j = j + 1
          else
            lgAgain = .false.
          endif
          i = i + 1
        end do
*2      continue
*       j now points to first free character
        chLine(j:j+9) = 'werner.mod'
*       end string with zero character
        chLine(j+10:j+10) = char(0)
      else
        chLine(1:10) = 'werner.mod'
*       end string with zero character
        chLine(11:11) = CHAR(0)
      endif
*
      ierr=1
      istop1=1
      open(unit=93,file=chLine,status='OLD',iostat=ierr,
     1     access='DIRECT',form='FORMATTED',recl=7*ncell)
*
*     something went wrong
      if( ierr.ne.0 ) then
          write(qq,'(''ERROR: The Klaus Werner stellar atmosphere '',
     1    ''file was not found.''/''Sorry.'')')
          stop
      end if
*
      read(93,'(4000i7)' ,iostat=ierr ,rec=1) (ivals(j),j=1,nWerner)
*     following must change if GetWerner changes
*999  format(4000i7)
      if( ierr.ne.0 ) then
        write(qq,'('' error getting Werner wavelength scale.'')')
        stop
      endif
*
      do j=1,nWerner
        wl(j)=10.**(5.-float(ivals(j))/1000000.)
      end do
*
      jmod=-1
*
*
*     TEMP and ALOGG are desired temp and log g
*
*     this may (or may not) catch bad input parameters
      if( temp.lt.80 000. .or. temp.gt.200 000. ) then
        write(qq,'('' Entered temperature is outside range of grid.'')')
        stop
      else if( alogg.lt.5. .or. alogg.gt.8. ) then
        write(qq,'('' Entered gravity is outside range of grid.'')')
        stop
      endif
*
      lgAgain = .true.
      j = 1
*     >>chng 97 may 13, get rid of statement nmber
*     do j=1,nmods
      do while(lgAgain .and. j.le.nmods )
        dev1=abs(temp/teff(j)-1.)
        dev2=abs(alogg-xlogg(j))
        if (dev1.le.0.01.and.dev2.le.0.00414) then
          jmod=j+1
*         go to730
          lgAgain = .false.
        endif
        j = j + 1
      end do
*
*730  continue
      if(jmod.eq.-1) then
        call getmod(temp,alogg,modnum,tval,gval,ierr,wl)
        if (ierr.gt.0) then
          write(qq,'('' Error occurred in getmod.'')')
          stop
        endif
      else
        read(93,'(4000i7)' ,iostat=ierr,rec=jmod) (ivals(j),j=1,nWerner)
        if( ierr.ne.0 ) then
          write(qq,'('' Error trying to read Werner atmosphere'',i4)')
     1    jmod
          stop
        endif
*
        do j=1,nWerner
          flux(j)=3.-float(ivals(j))/100000.
        end do
*
        if(lgTalk)write(qq,'(23X,''* <<< K.Volk s  K. Werner model ''
     1  ,i2,'' read in.  T_eff = '',F8.1,''  log(g) = '',F6.3,
     2  ''>>> *'')') jmod-1,teff(jmod-1),xlogg(jmod-1)
      endif
*
      do j=1,nWerner
*       gjf TSLOP(NSPEC,J)=FLUX(j)
*       TSLOP is f_nu for each TNU point
        tslop(nspec,j) = 10.**flux(j)
        tnu(nspec,j)=wl(j)
        if( j.gt.1.and.j.lt.nWerner) then
          if( tnu(nspec,j).eq.tnu(nspec,j-1)) then
            if(tnu(nspec,j).lt.10.) then
              term=1.0
            else
              term=10.0
            endif
            tnu(nspec,j)=tnu(nspec,j)+5.e-07*term
            tnu(nspec,j-1)=tnu(nspec,j-1)-5.e-07*term
*           this is to handle jumps at ionization or level absorption edges
*           by spacing them 1.0e-06 rydberg apart -- more or less, as this is
*           at the edge of the real variable precision.  For values above 10.0
*           the jump is made 10 times larger to allow it to show up.
          endif
        endif
      end do
      do j=nWerner+1,ncell
        tslop(nspec,j) = 0.
      enddo
*
      nstar = nWerner
      istop1=0
      close(unit=93)
*
      end
******************************************************************************
      subroutine getmod(temp,alogg,modnum,tval,gval,ierr,wl)
      implicit none
*get a single Werner PN atmosphere, by K Volk
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      integer modnum,ierr,j,j1,i1,ivals
      real temp,alogg,tval,gval,wl,flux1,fr1,fr2,fr3,fr4,flux2,
     1 fact1,fact2
*     parameter (ndata=865)
      dimension tval(7),gval(4),modnum(7,4),wl(ncell)
      dimension flux1(ncell),flux2(ncell),ivals(ncell)
      ierr=1
*
*     this subroutine gets stellar atmospheres from the Werner file
*     and interpolates on them, returning the flux in FLUX as
*     F_nu
*
      do j=1,6
        if( tval(j).le.temp.and.tval(j+1).gt.temp) j1=j
      end do
*
      i1=int(alogg)-4
      if (i1.eq.4) i1=3
      if (temp.eq.200000.) j1=6
      if (j1.lt.1.or.j1.gt.6.or.i1.lt.1.or.i1.gt.3) return
*     >>chng 97 may 13, get rid of branch to 1000
*     read(93,'(4000I7)',err=1000,rec=modnum(j1,i1))
      read(93,'(4000I7)',iostat=ierr,rec=modnum(j1,i1))
     1 (ivals(j),j=1,nWerner)
      if( ierr.ne.0 ) return
*     following must change if GetWerner changes
*999  FORMAT(4000i7)
*
      do j=1,nWerner
        flux1(j)=3.-float(ivals(j))/100000.
      end do
*
*     >>chng 97 jan 5, get rid of statement number
      if(lgTalk) then
        write(qq,'(''<<<< Klaus Werner stellar model '',i2,
     1  '' read in.  T_eff = '',F8.1,'' log(g) = '',F6.3,
     1  '' >>>>'')') modnum(j1,i1)-1,tval(j1),gval(i1)
      endif
*     >>chng 97 may 13, get rid of branch to 1000
*     read(93,'(4000I7)',err=1000,rec=modnum(j1,i1+1))
      read(93,'(4000I7)',iostat=ierr,rec=modnum(j1,i1+1))
     1 (ivals(j),j=1,nWerner)
      if(ierr.ne.0 ) return
      if(lgTalk) then
        write(qq,'(''<<<< Klaus Werner stellar model '',I2,
     1  '' read in.  T_eff = '',F8.1,'' log(g) = '',F6.3,
     1  '' >>>>'')') modnum(j1,i1+1)-1,tval(j1),gval(i1+1)
      endif
*     >>chng 97 jan 5, get rid of statement number
*     if(lgTalk)write(qq,960) modnum(j1,i1+1)-1,tval(j1),gval(i1+1)
      fr1=alogg-gval(i1)
      fr2=1.-fr1
      fr3=(temp-tval(j1))/(tval(j1+1)-tval(j1))
      fr4=1.-fr3
*
      do j=1,nWerner
        flux2(j)=3.-float(ivals(j))/100000.
      end do
*
      do j=1,nWerner
*       this is the interpolation between the two read in so far
        flux(j)=fr2*flux1(j)+fr1*flux2(j)
      end do
*
*     >>chng 97 may 13, get rid of branch to return
*     read(93,'(4000i7)',err=1000,rec=modnum(j1+1,i1))
      read(93,'(4000i7)',iostat=ierr,rec=modnum(j1+1,i1))
     1 (ivals(j),j=1,nWerner)
      if( ierr.ne.0 ) return
*
      do j=1,nWerner
        flux1(j)=3.-float(ivals(j))/100000.
      end do
*
      if(lgTalk) then
        write(qq,'(''<<<< Klaus Werner stellar model '',I2,
     1  '' read in.  T_eff = '',F8.1,'' log(g) = '',F6.3,
     1  '' >>>>'')') modnum(j1+1,i1)-1,tval(j1+1),gval(i1)
      endif
*     >>chng 97 jan 5, get rid of statement number
*     if(lgTalk)write(qq,960) modnum(j1+1,i1)-1,tval(j1+1),gval(i1)
*     >>chng 97 may 13, get rid of branch to return
*     read(93,'(4000i7)',err=1000,rec=modnum(j1+1,i1+1))
      read(93,'(4000i7)',iostat=ierr,rec=modnum(j1+1,i1+1))
     1 (ivals(j),j=1,nWerner)
      if( ierr.ne.0 ) return
*
      do j=1,nWerner
        flux2(j)=3.-float(ivals(j))/100000.
      end do
*
      if(lgTalk) then
        write(qq,'(''<<<< Klaus Werner stellar model '',I2,
     1  '' read in.  T_eff = '',F8.1,'' log(g) = '',F6.3,
     1  '' >>>>'')') modnum(j1+1,i1+1)-1,tval(j1+1),gval(i1+1)
      endif
*     >>chng 97 jan 5 get rid of statement numbers
*     if(lgTalk)write(qq,960) modnum(j1+1,i1+1)-1,tval(j1+1),gval(i1+1)
*
      do j=1,nWerner
        flux1(j)=flux1(j)*fr2+flux2(j)*fr1
      end do
*
*     NOW, ALLOW FOR THE TOTAL FLUX BEING SIGNIFICANTLY DIFFERENT BETWEEN THE
*     TWO SET OF FLUXES SINCE THE T_EFF VALUES ARE SIGNIFICANTLY DIFFERENT.
*     SCALE THINGS BY THE 4TH POWER OF T_EFF
*
      fact1=alog10(temp/tval(j1))*4.
      fact2=alog10(temp/tval(j1+1))*4.
*
      do j=1,nWerner
        flux(j)=fr4*(flux(j)+fact1)+fr3*(flux1(j)+fact2)
      end do
*
      call renor(wl,temp)
*     THIS CHECKS THE TOTAL FLUX AND SCALES IT TO MATCH THE SPECIFIED T_EFF
*     VALUE (ORDER 1% CHANGE AT WORST FROM MY TEST RUNS)
      ierr=0
*1000 return
      end
*
******************************************************************************
      subroutine renor(wl,temp)
      implicit none
*convert between cloudy energy grid and werner one, by K Volk
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real freq,wl,temp,con1,c,sigma,val,tot1,tot
      integer j
      dimension wl(ncell),freq(ncell)
      con1=9.1126708e-08
      c=299792458.
      con1=c/con1
*
*     rydberg to frequency conversion factor
      sigma=5.67051e-05
*
      do j=1,nWerner
        freq(j)=con1*wl(j)
      end do
*
      tot=(10.**flux(1))*(freq(2)-freq(1))+(10.**flux(nWerner))*
     c    (freq(nWerner)-freq(nWerner-1))
*
      do j=2,nWerner-1
        tot=tot+(10.**flux(j))*(freq(j+1)-freq(j-1))/2.
      end do
*
*     this should be the total surface flux in erg/cm^2/s now
*
      tot1=sigma*(temp**4.)
      val=alog10(tot1/tot)
*
      do j=1,nWerner
        flux(j)=flux(j)+val
      end do
*
      end
******************************************************************************
      subroutine compil(chCard)
      implicit none
*compile werner or kurucz model atmospheres into cloudy format, by K Volk
      character chCard*80
      common/StarBad/ lgStarBad
      logical lgStarBad
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      logical lgMatch
*
*     original version of this sub written by Kevin Volk
*
* this subroutine is intended to convert a sequential version of the klaus
* werner or kurucz model values (assumed to come with the program) into a
* direct access version for faster access.  the original file is assumed to
* be named in *.ASC, and the new direct access file is assumed to be named
* in *.MOD.  if either cannot be openned the subroutine exits.
*
* ierr is returned as 1 if an error is encountered in this process.  the new
* input file is left open for the program to use.
*
*     possible we only want to copy over the Rauch atmospheres
      if( lgMatch('RAUC',chCard ).and. lgMatch('INIT',chCard ) ) then
        call ConcatRauch
        stop
      endif
*
*     generate frequency array
      lgStarBad = .false.
      call SetPoint
*     do werner hot stars - do first since fast
      call GetWerner
*     do all work with atlas
      call GetAtlas
*     do the rauch hot stars
      call GetRauch
*
      if( lgStarBad ) then
        write(qq,'('' '')')
        write(qq,'(5(''WARNING!!''))')
        write(qq,'(''Something has gone wrong with the compilation.'')')
        write(qq,'(''Errors have gone to the file problems.out'')')
        write(qq,'('' '')')
        write(qq,'(''The compilation was not successful.'')')
        write(qq,'(5(''WARNING!!''))')
        close(66)
      else
        write(qq,'('' '')')
        write(qq,'('' The compilation was successful!'')')
        write(qq,'('' The portable files kurucz.ascii, kurucz.list, '',
     1  ''rauch.ascii, and werner.ascii are no longer needed and '',
     1  ''may be deleted to save space.'')')
        write(qq,'('' Do not forget to set the path when running in '',
     1  ''other directories.'')')
        write(qq,'('' '')')
        write(qq,'('' Good Luck!!'')')
        write(qq,'('' '')')
        write(qq,'('' '')')
      endif
      stop
      end
**************************************************************
      subroutine rdfile(kard,i,igr)
      implicit none
*read grains parameters from a file.  It is called when the grain number  >10
* The sublimation temperature is a new addition for c90.
* This subroutine added by (K Volk) 27 August 1993
      character*80 kard
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
      integer limcrs
*limit to numbers of cross sections for grain opacity
      parameter (limcrs=260)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real sublimat
      common/sublimat/ sublimat(ndust)
      character chDstLab*10
*     labels for types of dust grains
      common/dstlab/ chDstLab(ndust)
      real DustWorkFcn
*work function (Ioniz pot) of various grain species
      common/dwork/ DustWorkFcn(ndust)
      real dustp,eev, sab,sse,darea, dsize
      integer ndpts
      common/dust/ dustp(4,ndust),eev(limcrs,ndust),
     z sab(limcrs,ndust),sse(limcrs,ndust),ndpts(ndust),darea(ndust),
     z dsize(ndust)
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
      real dstela,dstelz
      common/dustab/ dstela(4,ndust),dstelz(4,ndust)
      real anumkv
*helper routine for K Volk's pah quantum heating
      integer itype
      common/lastdt/ anumkv(10),itype(10)
*
*     local variables
      integer i,j,i1,l,j1,j2,ierr,igr
      character*70 fname
      real s1
*
* first, get the file name from the kard variable
*
      do j=1,70
        fname(j:j)=' '
      end do
*
      i1=i
*
* try to read the file name, remembering that the qheat keyword might be first
*
      do l=1,2
       j1=0
       j2=0
*
       do j=i1,80
         if (kard(j:j).ne.' '.and.j1.eq.0) j1=j
         if (kard(j:j).eq.' '.and.j1.ne.0) j2=j
         if (j2.gt.0) goto 552
       end do
*
        if (j.eq.81.and.j1.gt.0) j2=80
        if (j.eq.81.and.j1.eq.0) goto 557
 552    fname(1:j2-j1+1)=kard(j1:j2)
        if ((fname.eq.'qheat'.or.fname.eq.'QHEAT').and.j2.lt.80) then
          i1=j2+1
        else
          goto 557
        end if
      end do
 
 557  if (j1.eq.0.or.j2.eq.0) fname='dust.val '
      ierr=1
      open(unit=89,file=fname,status='old',err=587)
      s1=sublimat(igr)
*
*     >>chng 97 jan 5, get rid of statement number
      read(89,'(1x,a10,2x,f7.3,1x,i1,1x,e12.4,1x,e12.4,1x,f7.1)'
     1 ,err=585,end=585) chDstLab(igr),DustWorkFcn(igr),
     1 itype(igr-10), anumkv(igr-10),qhnrat(igr),sublimat(igr)
*560  format(1x,a10,2x,f7.3,1x,i1,1x,e12.4,1x,e12.4,1x,f7.1)
      if (sublimat(igr).le.50.) sublimat(igr)=s1
* The "old" dust input file does not have the sublimation temperature
* so it is reset to the initial value if it is zero, or if the value is
* absurdly small.
*
      read(89,'(e9.3,1x,e9.3,1x,e9.3,1x,e9.3,1x,i3,1x,e9.3,1x,e9.3)'
     1 ,err=585,end=585) (dustp(i,igr),i=1,4),ndpts(igr),
     2                             darea(igr),dsize(igr)
*     >>chng 97 jan 5, get rid of statement number
*565  format(e9.3,1x,e9.3,1x,e9.3,1x,e9.3,1x,i3,1x,e9.3,1x,e9.3)
*
      if (ndpts(igr).gt.limcrs) ndpts(igr)=limcrs
*
      read(89,'(4(f5.1,1x,e12.4))', err=585,end=585) (dstelz(j,igr),
     1                              dstela(j,igr),j=1,4)
*     >>chng 97 jan 5, get rid of statement number
*567  format(4(f5.1,1x,e12.4))
*
      do i=1,ndpts(igr)
      read(89,'(3f11.5)',err=585,end=585) eev(i,igr),sab(i,igr),
     c                             sse(i,igr)
*570  format(3f11.5)
      end do
*
      ierr=0
 585  close(unit=89)
 587  if (ierr.eq.1) then
        write(06,'('' Error - the file specified for dust '',i2,
     c  '' could not be read properly.'')') igr
        lgDustOn1(igr)=.false.
        stop
      end if
*
      end
*
**************************************************************
      real function ufunct(temp,ndust1)
      implicit none
*one of K. Volk's quantum heating routines for grains
      real temp
      integer ndust1
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      real anumkv
*helper routine for K Volk's pah quantum heating
      integer itype
      common/lastdt/ anumkv(10),itype(10)
*
*     local variables
      integer itype1,j
      real atoms(ndust),pow(4),tlim(5),cval(4),term(4)
*
*     this common block holds the number of atoms and base grain type
*     for the 10 grains that can be read in from files.
      data pow/3.0,2.3,1.68,1.0/
      data tlim/0.,50.,150.,500.,1.e+30/
      data cval/2.300e-10,4.7141e-09,1.4081e-07,1.6806e-05/
*     coefficients converted to rydberg energy units, per unit atom
*     assuming a density of 3.3 g/cm^3 and pure silicon dioxide.
*     this is not right, but the result is correct because atoms
*     was calculated using the same assumption.
      data term/0.,2.8749e-05,4.6752e-04,7.4916e-03/
      data atoms/3.991e+07,1.725e+07,5.863e+08,2.534e+08,3.902e+05,
     c           3.902e+07,1.725e+07,1.725e+07,24.0,144.0,0.0,0.0,
     c           0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0/
*
      if (ndust1.gt.ndust-10) then
        atoms(ndust1)=anumkv(ndust1-10)
        itype1 = itype(ndust1-10)+1
      else
        itype1=0
      end if
*
      if(ndust1.eq.1.or.ndust1.eq.3.or.ndust1.gt.7.or.
     1  itype1.eq.1) then
*       pah/graphitic grains (and the greybody grains)
        ufunct=(temp**3.3)*1.904e-11/
     1  (1.+6.51e-03*temp+1.5e-06*temp*temp+8.3e-07*(temp**2.3))
      else
*       silicate grains
*       do j=1,4
        j = 1
        ufunct = 0.
        do while( j.lt.4 .and. ufunct.eq.0 )
*         limits of tlim set above, 0 and 1e30, so must happen
          if (temp.gt.tlim(j).and.temp.le.tlim(j+1)) then
            ufunct=term(j)+cval(j)*(temp**pow(j)-tlim(j)**pow(j))
*           go to 455
          end if
          j = j + 1
        end do
      end if
*455  ufunct=ufunct*atoms(ndust1)
      ufunct = ufunct*atoms(ndust1)
*
      end
*****************************************************************
      subroutine nphot(umin,umax,xphot,ndust1)
      implicit none
*one of Kevin Kolk's quantum heating routines for grains
* This routine calculates the photon flux able to produce a
* transition.  umin and umax give the energy range in rydberg
* for which the total flux of photons weighted by the absorption
* cross-section of the grain is to be calculated.
      integer ndust1
      real umin,umax,xphot
*
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
      integer nqgrid
*appears in dimension statement for Kevin Volk quantum heating add
      parameter (nqgrid=200)
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real widflx
      common/widflx/ widflx(ncell)
      real qtmin,qtmax,qwavec,qdudt0,qhnrat,qdep,qtemp,qhprob,qcu1,
     c     qtcol,tequil1
      integer nqhg1,nqout1,iqp,nqp1
*Kevin Volk add for quantum heating of grains
      common/qheat2/ qtmin,qtmax,qwavec,nqhg1,qdudt0,qhnrat(ndust),
     c qdep(ndust),qtemp(ndust,nqgrid),qhprob(ndust,nqgrid),qcu1,
     c qtcol,tequil1(ndust),nqp1(ndust),nqout1,iqp
      real dstab,dstab1, dstsc, dstsc1
      common/dstop/ dstab(ncell),dstab1(ncell,ndust) ,
     1 dstsc(ncell) , dstsc1(ncell,ndust)
      real vmin(ncell),vmax(ncell)
*     variables needed for Kevin Volk quantum heating routines
      integer iflnph
      common/nphotl/ vmin,vmax,iflnph
 
      real SummedCon , SummedDif , SummedOcc
      common/SummdCon/ SummedCon(ncell) , SummedDif(ncell) ,
     1 SummedOcc(ncell)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
*
*     local variables
      integer lget
      integer j,j1,j2
      real val1,val2
*
c The following assumes that nflux is always larger than 1
c
      if (iflnph.lt.nflux) then
c
          do j=iflnph,nflux
            vmin(j)=anu(j)-widflx(j)/2.
            vmax(j)=anu(j)+widflx(j)/2.
          end do
c
          iflnph=nflux
      end if
      xphot=0.
      j1=lget(anu,nflux,umin)-1
      j2=lget(anu,nflux,umax)+1
*
*     >>chng 97 june get rid of go to
*     do j=j1,j2
      j = j1
      do while( j.lt.j2 .and. vmin(j).le.umax )
        if(vmax(j).ge.umin) then
*         if(vmin(j).gt.umax) goto 515
          val1 =max(umin,vmin(j))
          val2 =min(umax,vmax(j))
*         xphot =xphot+(flux(j)+otslin(j)+outcon(j)+otscon(j))*
*         >>chng 97 july 17, summedcon
          xphot =xphot + SummedCon(j) *
     1    dstab1(j,ndust1)*(val2-val1)/widflx(j)
        endif
        j = j + 1
      end do
      xphot = xphot * dstAbund(ndust1)
*
* this assumes that the flux arrays are in photons/s/rydb/cm^2 units,
* rather than cgs flux density units
*515  xphot = xphot*qhnrat(ndust1)/qdep(ndust1)
      xphot = xphot*qhnrat(ndust1)/qdep(ndust1)
      end
**************************************************************
      integer function lget(avals,nvals,target)
      implicit none
*worker routine for Kevin Volk quantum heating routines for grains
      integer nvals
      real avals(nvals),target
*
*     local variables
      integer l1,l2,l3,loop
*
      l1=0
      l3=nvals+1
      if (nvals.lt.2) then
          lget=1
          return
      end if
*
      do loop=1,10000000
        if ((l3-l1).eq.1) goto 550
        l2=(l3+l1)/2
        if (target.gt.avals(l2)) then
          l1=l2
        else
          l3=l2
        end if
      end do
*
 550  lget=l1
      end
******************************************************************************
      subroutine VolMean( nelem , n , arlog )
      implicit none
*do volume mean of ionization fractions over volumn of any element
      integer limelm
      parameter (limelm=30)
      real arlog(limelm+1)
      integer nelem , n
*
*     local variables
      real abund , normalize
      integer i
*     xIonMeans(nelem, stage,type)
*     stage=0 is integrated sum of all
*     type = 1 is radius integration, 2=vol
      real xIonMeans
      common/IonMeans/ xIonMeans(limelm,0:limelm+1,2)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     fills in array arlog with log of ionization fractions
*     N is set to highest stage with non-zero abundance
*     N set to 0 if element turned off
*
*     first call zmean to sero out save arrays
*     next call mean in zone calc to enter ionziation fractions
*     finally this routine computes actual means
*
      if( xIonMeans(nelem,0,2) .le.0. ) then
*       no ionization for this element
        do i=1,nelem+1
          arlog(i) = -30.
        end do
        n = 0
        return
      endif
*
      n = nelem+1
      do while(n.gt.1.and. xIonMeans(nelem,n,2) .le.0. )
        arlog(n) = -30.
        n = n - 1
      end do
*
      normalize = xIonMeans(nelem,0,2)
      do i=1,n
        if( xIonMeans(nelem,i,2).gt.0. ) then
          abund = xIonMeans(nelem,i,2)
          arlog(i) = log10( max(1E-30,abund)/normalize )
        else
          arlog(i) = -30.
        endif
      end do
*
      end
******************************************************************************
      subroutine warnin( chLine )
      implicit none
*enter warnings at the end of the calculations into large stack
      character*132 chLine
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      integer limwcn
      parameter (limwcn=100)
      character chWarnln*132 , chCaunln*132 , chNoteln*132 ,
     1 chBangln*132
      common/wcnln/ chWarnln(limwcn) , chCaunln(limwcn) ,
     1 chNoteln(limwcn) , chBangln(limwcn)
*
      nwarn = nwarn + 1
      if( nwarn.gt.limwcn ) then
        write(qq,'('' Too many warnings have been entered; increase'',
     1  '' the value of LIMWCN everywhere in the code.'')')
        stop
      else
        chWarnln(nwarn) = chLine
      endif
*
      end
******************************************************************************
      subroutine warnot( io )
      implicit none
*write all warnings entered into comment stack
      integer io
*
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
      integer limwcn
      parameter (limwcn=100)
      character chWarnln*132 , chCaunln*132 , chNoteln*132 ,
     1 chBangln*132
      common/wcnln/ chWarnln(limwcn) , chCaunln(limwcn) ,
     1 chNoteln(limwcn) , chBangln(limwcn)
*
      integer i
*
      if(nwarn.gt.0)write(io,'(a132)') (chWarnln(i),i=1,nwarn)
*
      end
******************************************************************************
      subroutine wcnint
      implicit none
*initialize stack or warnings, cautions, notes
      integer nwarn , ncaun , nnote , nbang
      common/wcncom/ nwarn , ncaun , nnote , nbang
*
*     this sub is called first, to initialize the variables
      nwarn = 0
      ncaun = 0
      nnote = 0
      nbang = 0
*
      end
******************************************************************************
      real function widla( tauin , tauout , a , vth )
      implicit none
*determine Lya line width for radiation pressure
      real tauin , tauout , a , vth
      logical lgPradCap , lgPradDen
*lgPradCap true if radiation pressure capped on first iteration
*lgPradDen capped by thermalization length
      common/prdcap/ lgPradCap , lgPradDen
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      character*4 chRedis
      common/redis/ chRedis
      real te , eden , hden
      common/phycon/ te , eden , hden
*
*     local variables
      logical lgTonSav
      save lgTonSav
      real widlin , tau , t , therm , escinc
*
*     optical depth in outer direction is always defined for la
      lgTonSav = lgTauOutOn
      lgTauOutOn = .true.
*
*     compute width of la with either complete or incomplete redistribution
      if( chRedis.eq.'INCO' .or. chRedis.eq.'WIND' ) then
        widla = widlin( tauin , tauout , a , vth )
      else
*
        tau = tauout / 2.
        t = max( 0. , min(tauin,(tauout-tauin)) )
*
*       max optical depth is thermalization length
        therm = (3e14 / eden ) ** 2
        if( tau.gt.therm ) then
          tau = therm
          lgPradDen = .true.
        endif
*
*       1st fac in () is sqrt(2*pi); sec is 2/(pi^.25)
        widla = vth * (2.5066 + 1.5023*sqrt(a*tau))* (1.-escinc(t,a))
      endif
      lgTauOutOn = lgTonSav
*
      end
******************************************************************************
      real function widlin( tauin , tauout , a , vth )
      implicit none
*determine half width of any line with known optical depths
      real tauin , tauout , a , vth
      character*4 chRedis
      common/redis/ chRedis
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgPradCap , lgPradDen
*lgPradCap true if radiation pressure capped on first iteration
*lgPradDen capped by thermalization length
      common/prdcap/ lgPradCap , lgPradDen
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      real pi
      parameter ( pi=3.141592654 )
*
      real tau , t , therm,atau,aa,b,escinc,r
*
*     lgTauOutOn=.TRUE. if optical depth in outer direction is defined
*     smaller of inner and outer optical depths is chosen for esc prob
*     thermal broadening alone follows, lvg at 99
*     following uses line width from Bonilha et al. Ap.J. (1979) 233 649
*     return value is half width*(1-ESC PROB)
*     TAU is used for width of source function
*     T is used for escape probability
*     this assumes incompl redis, a.tau^1/3 width
*
      if( lgTauOutOn ) then
         tau = tauout / 2.
         t = max(tauin/100.,min(tauin,(tauout-tauin)))
      else
         tau = tauin
         t = tauin
      endif
*
*     max optical depth is thermalization length
      therm = 5.3e16/eden
      if( tau.gt.therm ) then
         lgPradDen = .true.
         tau = therm
      endif
*
      if( chRedis.ne.'WIND' ) then
*       converted from go-to 15 june 95
*
        atau = log( max(0.0001,tau) )
        if( tau.le.20. ) then
          aa = (4.8+5.2*tau+(4.*tau-1.)*atau)
          b = (6.5*tau-atau )
        else
          aa = 1. + 2.*atau/(1.+0.3*a*tau)**0.6667 +
     1     (6.5*a*tau)**0.333
          b = 1.6 + 1.5 / (1.+0.20*a*tau)
        endif
*
*       this is half width of line
        widlin = vth * 0.8862 * aa / b * (1. - escinc(t,a) )
*
      else
*       WIND
        r = a * tau / pi
        if( r.le.1. ) then
           widlin = vth * sqrt( log(max(1.,tau) )*.2821)
           return
        endif
*
        widlin = 2.*windv0
        if( r*vth .gt. widlin ) return
*
        widlin = vth *r* log( widlin/(r*vth) )
      endif
*
      end
******************************************************************************
      real function WidthLine( tauary )
      implicit none
*compute line width (cm/sec), using optical depth array information
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real tauary(nta)
*
      real pi
      parameter ( pi=3.141592654 )
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
      integer limelm
      parameter (limelm=30)
      real doppler
*doppler width of each element, cm/sec including turbulent,
*as set in routine velset
      common/DoppVel/ doppler(limelm)
      character*4 chRedis
      common/redis/ chRedis
      real te , eden , hden
      common/phycon/ te , eden , hden
      logical lgPradCap , lgPradDen
*lgPradCap true if radiation pressure capped on first iteration
*lgPradDen capped by thermalization length
      common/prdcap/ lgPradCap , lgPradDen
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
*
*     local variables
      real tauin,tauout,a,vth,t,tau,therm,atau,aa,b,r
*
*     lgTauOutOn=.TRUE. if optical depth in outer direction is defined
*     smaller of inner and outer optical depths is chosen for esc prob
*     thermal broadening alone follows, lvg at 99
*     following uses line width from Bonilha et al. Ap.J. (1979) 233 649
*     return value is half width*(1-ESC PROB)
*     TAU is used for width of source function
*     T is used for escape probability
*     this assumes incompl redis, a.tau^1/3 width
*
      tauin = tauary(ipLnTauIn)
      tauout = tauary(ipLnTauTot)
      a = tauary(ipLnDamp)
      vth = doppler(int(tauary(ipLnNelem)+.1))
*
      if( lgTauOutOn ) then
*       find optical depth to nearest boundary
        tau = tauout / 2.
        t = max(tauin/100.,min(tauin,(tauout-tauin)))
      else
        tau = tauin
        t = tauin
      endif
*
*     max optical depth is thermalization length
      therm = 5.3e16/eden
      if( tau.gt.therm ) then
        lgPradDen = .true.
        tau = therm
      endif
*
      if( chRedis.ne.'WIND' ) then
*       converted from go-to 15 june 95
*       static geometry
        atau = log( max(0.0001,tau) )
        if( tau.le.20. ) then
          aa = 4.8 + 5.2*tau + (4.*tau-1.)*atau
          b = (6.5*tau-atau )
        else
          aa = 1. + 2.*atau/(1.+0.3*a*tau)**0.6667 +
     1    (6.5*a*tau)**0.333
          b = 1.6 + 1.5 / (1.+0.20*a*tau)
        endif
        WidthLine = vth * 0.8862 * aa / b * (1. - tauary(ipLnEscP))
*       we want full width, not half width
        WidthLine = WidthLine * 2.
*
      else
*       wind
        r = a * tau / pi
        if( r.le.1. ) then
          WidthLine = vth * sqrt( log(max(1.,tau) )*.2821)
        else
          WidthLine = 2.*windv0
          if( r*vth .le. WidthLine ) then
            WidthLine = vth *r* log( WidthLine/(r*vth) )
          endif
        endif
      endif
*
      end
******************************************************************************
      real function xinvrs ( y , a , b , u , v  , ifail )
      implicit none
*do inverse function for Cota's three-body recombination
      real y,a,b,u,v
      integer ifail
*
*     local variables
      integer itmax,i
      real xlog,bxu,fxdfx,fx,dfx,xx,x
      data itmax / 10 /
*
* inverts equation of the form :
*
*             Y = A + B * X ** U - V * LOG ( X )
*
      ifail   = 0
      xlog    = ( ( a - y ) / v )
      x       = 10. ** xlog
*
      do i = 1 , itmax
        bxu     = b * x ** u
        fx      = y - a - bxu + v * xlog
        dfx     = v * .4342945 - bxu * u
*
        if( dfx.ne.0. ) then
          fxdfx = min( 0.2 , abs(fx/dfx) )
          xx = x * (1. - sign( fxdfx , fx/dfx ) )
        else
*     >>chng 96 feb 2 this added in case dfx ever 0
*  suggested by Peter van Hoof
          xx = x * (1. - sign( 0.2 , fx ) )
        endif
        if ( ( abs ( xx - x ) /  x ) .lt. 1.e-4 ) then
          xinvrs = xx
          return
        else
          x = xx
          if( x.lt.1e-30 ) then
             xinvrs = 100.
             ifail = 1
             return
          endif
          xlog = log10 ( x )
        endif
      end do
      xinvrs = xx
      ifail = 1
*
      end
******************************************************************************
      real function xmap ( x , y , x0 )
      implicit none
*mapping function for Cota's 3-body recombination
      real  x0 , y1,x1,x2,x3
      real x13m,x12m,y13m,c,a,b
*
* PARABOLIC INTERPOLATION.
*
      real x(3) , y(3)
*
      y1   = y (1)
      x1   = x (1)
      x2   = x (2)
      x3   = x (3)
      x13m = x1 - x3
      x12m = x1 - x2
      y13m = y1 - y (3)
      x3   = (x1 + x3) * x13m
      x2   = (x1 + x2) * x12m
      b    = ( ( y1 - y ( 2 ) ) * x3 - y13m * x2 )
     *               / (  x12m * x3 - x13m * x2 )
      a    = ( y13m - x13m * b ) / x3
      c    = y1 - a * x1 * x1 - b * x1
*
      xmap  = a * x0 * x0 + b * x0 + c
*
      end
******************************************************************************
      subroutine zero
      implicit none
*actively zero out or initialize variables needed for model calculation
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer MXSTPL
*maximum numeer of stop line commands
      parameter (MXSTPL=10)
      integer nzlim
      parameter (nzlim=2000)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer nhetau
      parameter (nhetau=4)
*     the temperature of 1 Rydberg
*     te1ryd is h/k is temp of 1 Rydberg, HOKCGS*nu(912)
*from Physics Today, Aug '96, p BG13
      real te1ryd
      parameter (te1ryd=1.578866E5)
      integer ndfst
      parameter (ndfst=5)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
      real rydlam
*     energy of 1 infinite mass Rydberg, in vacuum wavelength
      parameter (rydlam=911.6)
      integer nfst
      parameter (nfst=39)
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     number of FeII lines in Fred's atom
      integer nfeii
      parameter (nfeii=373)
*     limit to number of line images that can be read in
      integer nkrd
      parameter (nkrd=1000)
*     limit to number of cells in frequency array
      integer ncell
      parameter (ncell=4000)
*     NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB NB
*     if this number is changed, also need to change formats in
*     Kevin Volk's stellar atmospheres codes, with 400 look for 400i7
*     limit to number of spectra that can be entered
      integer limspc
      parameter (limspc=10)
      integer limpun
      parameter (limpun=20 )
      integer ncold
      parameter (ncold=6)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer limelm
      parameter (limelm=30)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      real HIonPot
      parameter (HIonPot=0.99946)
*ionization potential of real hydrogen atom, in inf mass ryd
      real SpeedLight
*from Physics Today Aug '96, BG 10
      parameter (SpeedLight=2.99792458E10 )
      real PunchLWidth
*contrast factor for lines to continuum in punch output
*default is 1 (gives correct line intensities) and changed with
*set width command (enters width in km/sec)
      common/PLWidth/ PunchLWidth
      integer nEndDflt
      logical lgEndDflt
*     default limit to number of zones
*     lgEndDflt true if still at default
      common/EndDflt/ nEndDflt , lgEndDflt
      logical lgAbunTabl(limelm) , lgAbTaDepth(limelm),lgAbTaON
*lgAbunTabl says whether this element is to have its abundance
*determined from a table (true) or stored constant (false)
*set true with element table command
*lgAbTaDepth says whether depth or radius, true is depth
      common/AbunTablLG/ lgAbunTabl , lgAbTaDepth,lgAbTaON
      integer ipPoint
      logical lgPunPoint
*option to punch out pointers with punch pointers commmand
*ipPoint is punch unit number, lgPunPoint says whether we will do it
      common/PunPoint/ ipPoint , lgPunPoint
      real p1909 , p2326 , p1895 , p1666 , p1401
      common/pmp2s/ p1909 , p2326 , p1895 , p1666 , p1401
      logical lgVrrFit
*which version of Dima's routine to use?
      common/vrrfit/ lgVrrFit
      real CODissHeat , codfrc , codtot
*CODissHeat is CO Photodissociation heating
      common/codish/ CODissHeat , codfrc , codtot
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real OldOpacSave
      logical lgOTSOn
*save previous opacity
      common/OldOpac/ OldOpacSave(ncell)  , lgOTSOn(ncell)
      real toiiir, tbac, t2hstr,tohyox,t2hyox,tbcthn,t2o3str,tsqden
*     tsqden is the highest hydrogen density to do print peimbert analysis
      common/peimbt/ toiiir, tbac, t2hstr,tohyox,t2hyox,tbcthn,t2o3str,
     1 tsqden
*     these save structure variables, like te vs depth
      real testr, volstr, radstr, histr, hiistr , ednstr,o3str,heatstr,
     1 pdenstr
      common/struc/ testr(nzlim), volstr(nzlim), radstr(nzlim),
     1 histr(nzlim), hiistr(nzlim) , ednstr(nzlim),o3str(nzlim),
     2 heatstr(nzlim),pdenstr(nzlim)
      logical lgCSetOn
*lgCSetOn set with set csupra command
*SetCsupra is secondary ionization rate set with set csupra
      real SetCsupra
      common/cspset/ SetCsupra , lgCSetOn
      integer nHTopOff
      character chHTopType*4
      common/HTopOff/ nHTopOff , chHTopType
*save total grain emission from this zone, per unit vol,
*for add outward in metfic
      real GrainEmission
      common/GrainEmis/ GrainEmission(ncell)
      logical lgSearch
*     lgSearch is true is initial temp-ion search underway,
*     false after first zone established
      common/search/ lgSearch
      real DustCoolGas
*dust cooling the gas by collisions
      common/dclgas/ DustCoolGas
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
*     TexcLya is the excitation temperature of Lya
*     nLyaHot is counts how ofter Lya hotter than gas
*     TLyaMax is hottest
*     TeLyaMax is electron temp at point where Lya max
*     nZTLaMax is the zone where this happened
      real TexcLya , TLyaMax , TeLyaMax
      integer nLyaHot , nZTLaMax
      common/LyaExT/ TexcLya , nLyaHot , TLyaMax , TeLyaMax , nZTLaMax
      real PhotoRate
*     store photoionization rates
*     first dim is nelem, the atomic number of element
*     secnd dim is stage of ionizaiton, 1 for atom
*     third dim is shell number, valence shell depends on ion
*     forth dim: 1 is photo rate
*                2 is heating
*                both will be nultiplied by ion abundance to get
*                actual vol rates
      common/PhotRate/ PhotoRate(limelm,limelm,7,2)
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      logical lgDoPhoto
      common/DoPhoto/ lgDoPhoto
      logical lgPhFit
*which version of phfit should be used?
      common/PhFitOn/ lgPhFit
      integer nFe2Neg
*clount how many times FeII came back with negative level pops
      common/Fe2Neg/ nFe2Neg
      integer ncPunchSkip
*set skip sets this variable, which says how many cells to skip in punch
      common/PunchSkip/ ncPunchSkip
      logical lgPrnPump , lgPrnHeat , lgPrnColl , lgPrnInwd,lgPrnDiff
      common/PrnLine/ lgPrnPump , lgPrnHeat , lgPrnColl , lgPrnInwd,
     1 lgPrnDiff
*rememeber the largest offset needed for ipSafe, and the energy where it occured
      integer nMaxSafe
      real EnergySafe
      common/MaxSafe/ nMaxSafe , EnergySafe
      real HColOn
*     normally is unity, set to zero when hydrogen collisions turned off
      common/hydata/ HColOn
      real BigEdenError
      integer ipEdenError
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      common/EdError/ BigEdenError , ipEdenError
      character chMatrix*7
      common/TypMatrx/ chMatrix
      real FreeFreeHeat , ffhtot , hbrems , HFFNet
*     FreFreHeat is free-free heating, evaluated in freeht
*     hbrems is cooling, evaluated in hydcol
*     HFFNet is net cooling, negative if heating
*     heating stored in heating(1,12)
      common/ffheat/ FreeFreeHeat , ffhtot , hbrems , HFFNet
      integer negoIO
      common/negoIO/ negoIO
      double precision phmlte , ph2lte , phplte
      common/HMolLTE/  phmlte , ph2lte , phplte
      real xLaMase
*smallest Lya optical depth that occured in the calculation
      common/LaMase/ xLaMase
      real fcool , dfcool , feheat
*     cooling computed by Katya's FeII model atom
*     fcool is total cooling (or heating if negative)
*     and dfcool is its derivative
*     holod is Russian for cold
      common/holod/ fcool , dfcool , feheat
      logical lgPrtMaser
*     option to print maser lines (true) normally false
*     print maser turns on
      common/PrtMaser/ lgPrtMaser
      logical lgNoCota
*lgNoCota flag set with no three body recombination
      real CotaRate
      common/rcota/ lgNoCota , CotaRate(limelm)
      logical lgInsane
*     flag to say whether insanity detected
      common/insanity/ lgInsane
      real trimhi , trimlo
*limits for highest and lowest stages of ionization in TrimStage
      common/trimstg/ trimhi , trimlo
*     include "fe2pop.com"
      real vyield
      integer nyield
*     block data of yields from Mewe paper
*     vyield( nelem, nstage, nshell, nelec )
*     nelem is element number, 6 for carbon
*     nstage is stage of ionization, 1 for atom
*     nshell is shell number in dima notation
*     nelec is fraction that yield that number of electrons
**    nyield is number of electrons at most
      common/yield/ vyield(30,30,7,10), nyield(30,30,7)
      real flong , cfirst , csecnd, flcPhase
*     parameters for the fluctuations command
      logical lgDenFluc
      common/fluct/ flong , cfirst , csecnd , lgDenFluc, flcPhase
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
      real PhotScaleOn
*     set to 1 in zero, so have no effect
*     set to 0 with 'no photoionization' command, kills
*     photoionization of everything
      common/PhotScale/ PhotScaleOn
      integer ioreco
      common/ioreco/ ioreco
      logical lgSupDie
*     logical flag for suppression of dielectronic recombination
*     1 is burgess, 2 is nussbaumer and storey
      common/supdie/ lgSupDie(2)
      logical lgWindOK
*flag set if wind not ok, (below sonic point)
      common/windok/ lgWindOK
      logical lgSecOFF
*flag saying that secondary electron have been turned off
      common/secoff/ lgSecOFF
      character chDffTrns*3
*     method for transferring diffuse continuum
*     either 'ots' or 'out'
      common/dtrans/ chDffTrns
      logical lgDHetOn , lgDColOn
*lgDHetOn turned off with grain no heating
*lgDColOn turned off with grain no cooling
      common/dheton/ lgDHetOn , lgDColOn
      logical lgPunLstIter(limpun)
*lg flag lgPunLstIter for this punch option,
*do we only want to punch on last iteration?
      common/punlst/ lgPunLstIter
      integer ipSolar, npSolar
      common/ipSolar/ ipSolar(limelm) , npSolar
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
      logical lgPrnAges
      common/PrnAges/ lgPrnAges
      real DiffusHeavy , xLyaHeavy
*DiffusHeavy is total rec rate to grnd for nelem,ion element
*xLyaHeavy is Lya for nelem,ion
      common/DiffHeav/ DiffusHeavy(limelm,limelm),
     1 xLyaHeavy(limelm,limelm)
      real scalem
      common/scalem/ scalem(limelm)
      logical lgPhysOK
*flag set if a physical condition has been disabled
      common/physok/ lgPhysOK
      real agrav , AccelTot , AccelCont,AccelLine,AccelPres , fmul ,
     1 AccelMax
*variable dealing with radiative acceleration and wind solution
*AccelTot is total radiative acceleration, lines and continuum
*AccelCont continuum radiative acceleration - old faccel(1)
*AccelLine line radiative acceleration - old faccel(2)
*AccelPres change in pressure acceleration - old faccel(3)
*AccelMax is largest acceleration, usually at illuminated face
      common/pwind/ agrav , AccelTot , AccelCont,AccelLine,AccelPres ,
     1 fmul, AccelMax
      real oldcla
      common/oldcla/ oldcla
      real H2Opacity
*mean cross section (cm-2) for H2 Lyman absorption
      common/h2opac/ H2Opacity
      logical lgHMtrxOff
      common/MtrxOff/ lgHMtrxOff
      real DoubleTau
*1 or two, set to double optical depth scale, set to 2 with double command
*default is 1
      common/double/ DoubleTau
      real T2High
*highest allowed temperature, set with stop temperature exceeds command
      common/stphit/ T2High
      logical lgHe1ON , lgHe2ON
*flags saying whether HeI and HeII are present
      common/he12on/ lgHe1ON , lgHe2ON
      logical lgOpacNeg
*flag set if negative opacities occured
      common/opcneg/ lgOpacNeg
      logical lgPrtCont
*flag set with print continuum command
      common/pconon/ lgPrtCont
      logical lgCylnOn
*lgCylnOn set true when cylinder command given
*cylind is half height in centimeters
      real CylindHigh
      common/cylind/ CylindHigh , lgCylnOn
      real hmidep , h2dep , h2pdep,h3pdep,hehdep
      common/hmidep/ hmidep , h2dep , h2pdep,h3pdep,hehdep
*     include "stplin.com"
*parameters for stop line command
      real stpint
      integer ipStopLin1,ipStopLin2,nstpl , LineStopWl
*LineStopWl - line wavelength for stop line command
*ipStopLin1 is pointer to first line of pair in stack of lines
*ipStopLin2 is pointer to second line of pair in stack of lines, usually Hbeta
*  initially holds wavelength, converted to pointer in startr
      common/StopLine/ stpint(MXSTPL),ipStopLin1(MXSTPL),
     1 ipStopLin2(MXSTPL), nstpl , LineStopWl(MXSTPL)
      real Ca2RmLya
*amount of Lya removed by photoionization of excited CaII levels
      common/ca2mly/ Ca2RmLya
      logical lgPrintHeating
*     flag to turn on printout of heat sources
      common/pheat/ lgPrintHeating
      real heating
*     first elements is atomic number of element, sec is ionization stage
      common/heating/ heating(limelm,limelm)
      real xIonFracs
*     args are atomic number, ionization stage
*     xIonFracs(nelem,0) is density of nelem (cm^-3),
*     including molecules but not grains
*     xIonFracs(nelem,i) is density of ith ionization stage (cm^-3)
      common/IonFracs/ xIonFracs(limelm,0:limelm+1)
*     this is the explicit version of this common
*     the array version is hevmol.arr, and needs parameter nhevml
      real ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      common/hevmol/ ch,chp,oh,ohp,otwo,ctwo,co,cop,h2o,h2op,o2p,c2p,
     1 h3p,h3op,ch2p,ch2,ch3,cp
      logical lgOut2In
*flag set with roberto command, to do outward to inward calculation
      common/out2in/ lgOut2In
      logical lgLotsCO
*flag saying that there is lots of CO, triggers lgEndFun stopping model
      common/lotsco/ lgLotsCO
      real pca2ex
      common/pca2ex/ pca2ex
      real AgeMoleForm
*longest timescale for molecules to form
      common/AgeMole/ AgeMoleForm
      logical lgEdenBad
      integer nzEdenBad
*some flags and counters set in radinc when bad electron density is detected
      common/ednbad/ lgEdenBad , nzEdenBad
      logical lgNxtDROff
*flag telling nextdr whether this is first call or not
      common/ndroff/ lgNxtDROff
      integer nWerner , nAtlas , nRauch
*these are the numbers of freq points in the atlas, rauch, and werner grids,
*after they were remapped onto the cloudy scale,
*must be changed whenever energy mesh is changed
      common/StarSize/ nWerner , nAtlas , nRauch
*     include "hbn.com"
      logical lgH2Ozer
*flag set true if H2O destruction rate went to zero
      common/h2ozer/ lgH2Ozer
      real TurbVel
*this is the turbulent velocity in cm/s, normally zero, set with
*turbulence command
      common/turb/ TurbVel
      real GrnIonRec , grecon
*rate coefficient for ionic recombination on grain surfaces, eval in hmole
*grecon usually 1, set to 0 with no grain neutralization command
      common/gionrc/ GrnIonRec , grecon
      integer nlsum
      common/nlsum/ nlsum
      logical lgFntSet
*flag set true if print faint command entered,
*only used to not overrid it with print short
      common/fntset/ lgFntSet
      logical lgFe2On
*logical variable that controls whether (true) or not (false)
*pumping of the FeiI model atom by HI Lya is included
      common/fe2on/ lgFe2On
      real rjnmin , ajmmin
      common/jmin/ rjnmin , ajmmin
      logical lgZoneSet , lgZoneTrp
*lgZonSet set if stopping zone specified
*lgZoneTrp set if stopped due to zone number
      common/zonset/ lgZoneSet , lgZoneTrp
      logical lgDrNeg
*flag set in nextdr saying whether dr is negative
      common/drneg/ lgDrNeg
      real catmic , oatmic
      common/coatom/ catmic , oatmic
      real CaseBCheck
*largest difference between actual rec sum and real case B
      common/difher/ CaseBCheck
      logical lgConPres
*flag saying whether or not incident continuum should be included
*in total pressure, turned off with constant gas pressure
      common/conprs/ lgConPres
      logical lgComNeg
*flag saying some molecular abundances were negative
      common/comneg/ lgComNeg
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      real pinit , pinteg , pinzon
      common/pinteg/ pinit , pinteg , pinzon
      logical lgCExtraOn
*info about 'extra' cooling, lgCextOn says it is on
      real CoolExtra , cextpw
      common/cextra/ lgCExtraOn , CoolExtra , cextpw
      logical lgOptimFlow
      common/OptmFlow/ lgOptimFlow
      real HCTOn
*     variable to turn on or off ct ionization-recombiantion of
*     hydrogen - set 0 with no charge trasnfer command
      common/HCTOnOff/ HCTOn
      real glbden , glbrad , glbpow , glbdst
      common/globul/ glbden , glbrad , glbpow , glbdst
      character chCardSav*80 , chTitle*75
      common/input/ chCardSav(nkrd),chTitle
      logical lgBit32
*     this says whether (true) or not (false) this is a 32 bit cpu
      common/bit32/ lgBit32
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      integer negoi
      common/negoi/ negoi
      real dDensityDT, dndtSave
*deriv of density needed for expansion cooling
      common/dndt/ dDensityDT, dndtSave
      integer iPunDef
*     this is an integer giving the unit number for the next fort fil
*     set to 11 in zero, reset with 'set ipundef' command
*     incremented for each punch command that does not specify a unit
      common/PunDef/ iPunDef
      logical lgInTalk
*used to save flag for print last during amoeba runs
      common/intalk/ lgInTalk
      logical lgVelPos
*flag set if wind solution had negative velocity
      common/velpos/ lgVelPos
      real htus , he1tus , he2tus, he3tus
      common/tusedcom/ htus , he1tus , he2tus, he3tus
      integer ntff
*ntff is pointer to lowest energy thin to ff abs and plasma frequency
      real tff
      common/tff/ ntff , tff
      integer kapots , kap911
      common/kapots/ kapots , kap911
      real BiggestH2
*max H2/H ratio that occured in the calculation, set in hmole
      common/h2max/ BiggestH2
      real tauend , taunu
      integer iptnu
      common/tauend/ tauend , taunu , iptnu
      real resmax
      common/resmax/ resmax
      logical lgNumDeriv
      common/NumDeriv/ lgNumDeriv
      real windv0 , comass, windv , emdot
      common/wind/ windv0 , comass, windv , emdot
      real e2TauAbs
*E2(tau) exponential integral
      common/e2tau/ e2TauAbs(ncell)
*exp(-tau) to illunated face
      real ExpmTau
      common/exptau/ ExpmTau(ncell)
      real tmn
      common/tmn/ tmn(ncell)
      real ContDiff
*diffuse continuum, not counted in internal energy budget
      common/condif/ ContDiff(ncell)
      real reflin , refcon , reflux
*     reflected line and continuum
*     reflux is reflected part in incident continuum, by itself, for albedo
      common/reflec/ reflin(ncell),refcon(ncell),reflux(ncell)
      real GrainMetal
*factor depleting grain abundances from grain on metals command, usually 1
      common/grmetl/ GrainMetal
      logical lgNegGrnDrg
*flag set if negative grin drag force encountered
      common/negdrg/ lgNegGrnDrg
      real CarMolFrac
*largest fraction of carbon that went molecular
      common/cmfrac/ CarMolFrac
      integer ipPnunit , npunch
      real punarg
*     ipPnunit is io unit number, number of punch commands eneterd
*     punarg is set of optional arguments for the punch command
      common/pnunit/ ipPnunit(limpun) , npunch , punarg(limpun,3)
      real dVeldRad
*dVel/dR used for sobolev (large velocity gradient)
      common/dvdr/ dVeldRad
      real gff , gffhe2
      common/gaunts/ gff(ncell) , gffhe2(ncell)
      real ContBoltz
*array of Boltzmann factors for the continuum array
      common/corind/ ContBoltz(ncell)
      real colden
      common/colden/ colden(ncold)
      real range
      common/range/ range(limspc,2)
      real ophe2f , ophe1f
      common/heopfr/ ophe2f(nhe2lvl) , ophe1f(nhe1lvl)
      real stimax
      common/stimax/ stimax(2)
      real htwo,h2plus,hminus,h3plus
      common/hmi/ htwo,h2plus,hminus,h3plus
      real hmihet , hmitot , hmicol
      common/hmihet/ hmihet , hmitot , hmicol
      real dstCala , dCakh , dCaf12 , Ca3d , Ca4p
*parameters dealing with dest of CaII by Lya
      common/dcala/ dstCala , dCakh , dCaf12 , Ca3d , Ca4p
      real totcol , ctot , heatl , coolheat,GrossHeat
*     heatl is total line heating, t(ipLnHeat)
*     coolheat is other coolants that were heat sources
*     grossheat is heat from agent that is added as heat-cooling
*     is used to check on relative accuracy soln
      common/tcool/ totcol , ctot , heatl , coolheat,GrossHeat
      real hlmax
*     remember max photo rate for var h levels, by h lines
      common/hlmax/ hlmax(lmhlvl)
      real HLineWidth
*width of each alpha transition from i+1 to i (Lya is 1)
      common/hwidth/ HLineWidth(lmhlvl)
      real h , htot , power , dHTotDT
      common/heat/ h , htot , power , dHTotDT
      real hgamsc
      common/hgamsc/ hgamsc
      real emm , egamry
      common/bounds/ emm , egamry
      real escah , pmcah , ecah , tpcah , conca , conhe
      common/pmpcah/ escah , pmcah , ecah , tpcah(2) , conca , conhe
      real EdenFFSum
*sum of heavy element free electrons, set in esum
      common/ffsum/ EdenFFSum
      real thist , tlowst
      common/tehigh/ thist , tlowst
      real ophf
      common/ophf/ ophf(lmhlvl)
      real hstat
      common/hstat/ hstat(lmhlvl+1)
      real he1stat
      common/he1statCOM/ he1stat(nhe1lvl+1)
      real he2stat
      common/he2stat/ he2stat(nhe2lvl+1)
*     include "hdamp.com"
      real htau, htlim, hcont, hopac
*     hcont(up,low) is downward induced emission from up to low
      common/htau/ htau(lmhlvl,lmhlvl) , htlim(lmhlvl,lmhlvl) ,
     1 hcont(lmhlvl,lmhlvl) , hopac(lmhlvl,lmhlvl)
      real htnext
      common/htnext/ htnext(lmhlvl,lmhlvl-1)
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      real he2tau , he2lim , he2con,he2opc
      common/he2tau/ he2tau(9,8) , he2lim(9,8) , he2con(9,8),he2opc(9,8)
      real he1tau,he1lim,he1con,he1opc, t206
      common/he1tauCOM/ he1tau(9,8),he1lim(9,8),he1con(9,8),he1opc(9,8),
     1 t206(nta)
      real he1nxt
      common/he1nxtCOM/ he1nxt(nhe1lvl,nhe1lvl-1)
      real he2nxt
      common/he2nxt/ he2nxt(nhe2lvl,nhe2lvl-1)
      integer nsbig
      common/nsbig/ nsbig
      integer ilt,iltln, ilthn, ihthn, ifail
      common/dalerr/ilt, iltln, ilthn, ihthn, ifail
      integer iontot
      common/iontot/ iontot
      real flux , anu , anu3 , anulog , anusqr , anu2
      integer nflux
*nflux is number of continuum points needed to get to high energy
*end of this continuum
*flux is photons per cell
*rest are energy in Ryd (anu) or log, sqrt(), or power
      common/rfield/ flux(ncell) , anu(ncell) , nflux , anulog(ncell) ,
     1 anusqr(ncell) , anu2(ncell) , anu3(ncell)
      logical lgDrMinUsed
*set true is calculations stops because zone thickness gets too small
      common/drminu/ lgDrMinUsed
      logical lgPradCap , lgPradDen
*lgPradCap true if radiation pressure capped on first iteration
*lgPradDen capped by thermalization length
      common/prdcap/ lgPradCap , lgPradDen
      logical lgUSphON
*lgUSphON flag set when we hit stromgren radius in spherical geometry
      real rstrom
      common/uspher/ lgUSphON , rstrom
      logical lgHeMase
*flag set true in addopac if any helium continua mased
      common/hemase/ lgHeMase
      logical lgOpacOn
      common/opacon/ lgOpacOn
      logical lgHiPop2
      real pop2mx
*lgHiPop2 flag set if H n=2 population gets large relative to ground
*pop2mx is maximum population of n=2 relative to ground
      common/hipop2/ lgHiPop2 , pop2mx
      logical lgMMok , lgHPhtOK , lgXRayOK , lgGamrOK
      common/bndsok/ lgMMok , lgHPhtOK , lgXRayOK , lgGamrOK
*these are a series of lines and continuua that are set in hediff and
*carried outward in metdif
      real esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      common/heots/ esc584 , esc304 , esc911, esc228 , esc504 , esc610 ,
     3 esc660 , esc910 , esc626 , out626
      logical lgHabing
*flag set if incident radiation field less than
*10x the Habing ISM field
      common/habing/ lgHabing
      real otsfe2 , emuv3
      common/resion/ otsfe2 , emuv3
      integer ipmgex ,ipOpMgEx
      real xmglst, popmg2 , rmg2l , xMg2Max
*     these all deal with photoionization from upper lev of Mg II 2798
      common/mgexc/ ipmgex , xmglst, popmg2 , rmg2l , xMg2Max,ipOpMgEx
      logical lgRadPresON
      real RadPres , plines , RadBetaMax,pbeta,GasPres , PresMax
*lgRadPresON says whether radiation pressure enabled, turned ooff with
*   constant density, constant gas pressure commands, on with constant pressure
*RadPres is trapped line radiation pressure for current zone
*RadBetaMax is largest ratio of radiation to gas pressure
*GasPres is gas pressure, nkT, set in ptot
*PresMas is largest pressure that occurred in the calculation
      common/prad/ lgRadPresON , RadPres , plines(20) ,
     1  RadBetaMax,pbeta,GasPres , PresMax
      real thlo
      integer nhlo
      common/thlo/ thlo , nhlo
      real the1lo
      integer nhe1lo
      common/the1lo/ the1lo , nhe1lo
      real the2lo
      integer nhe2lo
      common/the2lo/ the2lo , nhe2lo
      real hetrip
      integer ipHe3l(4)
      common/hetrip/ hetrip(11) , ipHe3l
      integer ipo3exc(3) , ipo3exc3(3) , ipo1exc(3)
      real poiii2 , d5007r,d5007t, d4363 , r5007Max,r4363Max,
     1 poiii3 , poiii2Max , poiii3Max , poiexc , poimax,d6300
      common/o3exc/ ipo3exc , poiii2 , d5007r,d5007t , ipo3exc3,
     1 poiii3 , poiii2Max , poiii3Max , d4363 , r5007Max,r4363Max,
     2 ipo1exc , poiexc , poimax,d6300
      real CTHion(2) , CTHrec(2) , chrener , chrexCool ,
     1 CTHionAgnt(5)
*     first cell of vector is current value of ioniz/rec of elements
*     sec is lagging value, average of current and old
*     CTHrec is total rate (s^-1) for charge transfer neutralization of hydrogen
*     CTHion is same for ct ionization of hydrogen
*     chrener is energy exchange in Ryd
      common/chrex/ CTHion , CTHrec, chrener , chrexCool ,
     1 CTHionAgnt
      real x12
      common/x12/ x12
      real recgrd , photex
      common/recgrd/ recgrd , photex
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real he3tau
      common/he3tau/ he3tau(nta,nhetau)
      real telec , thmin
      common/taucon/ telec , thmin
*      NB This file was automatically generated by the makelist program
*      in the TauLines subdirectory.
*      DO NOT modify this file to put in more lines.
*      Change the line list lines.dat instead
      integer nTauLines
      parameter (nTauLines= 263)
      real TauLines
      common/TauLines/ TauLines(nta,nTauLines)
      real hcolnc,hn, hrec,hn2s,hn2p, hemis,
     2 hdest,hcol , hdamp
      double precision hbn
      common/phlevl/ hbn(lmhlvl+1),hcolnc(lmhlvl+1),hn(lmhlvl+1),
     1 hrec(lmhlvl+1,3),hn2s,hn2p, hemis(lmhlvl,lmhlvl),
     2 hdest(lmhlvl,lmhlvl),hcol(lmhlvl,lmhlvl) ,hdamp(lmhlvl)
      real he2gam,he2clc,he2n,he2rec,he22s,
     1 he22p, he2mis,he2dst,he2cll
      common/phe2lv/ he2gam(nhe2lvl+1),he2clc(nhe2lvl+1),
     1 he2n(nhe2lvl+1),he2rec(nhe2lvl+1,3),he22s,
     2 he22p, he2mis(nhe2lvl,nhe2lvl),he2dst(nhe2lvl,nhe2lvl),
     3 he2cll(nhe2lvl,nhe2lvl)
      real he1gam,he1clc,he1n,he1rec,he12s,
     1 he12p, he1mis,he1dst,he1cll
      common/phe1lv/ he1gam(nhe1lvl+1),he1clc(nhe1lvl+1),
     1 he1n(nhe1lvl+1),he1rec(nhe1lvl+1,3),he12s, he12p,
     2 he1mis(nhe1lvl,nhe1lvl),he1dst(nhe1lvl,nhe1lvl),
     3 he1cll(nhe1lvl,nhe1lvl)
      integer nhei1,nhei3,nheii
      real hei,heii,heiii,hei1,hei3,ahe
      common/he/ nhei1,nhei3,nheii,hei,heii,heiii,hei1,hei3,ahe
      real secion,secla,heatef,efionz,exctef,csupra,csuEfrac
*     csuEfrac is electron fraction used when csupra was evaluated
      common/shullc/ secion,secla,heatef,efionz,exctef,csupra,csuEfrac
      logical lgTauOutOn
*     indicates whether (true) or not the outward optical
*     depths have been predicted yet
      common/touton/ lgTauOutOn
      real SolarSave , anova , apn , ahii, camern, aprim, aism
      common/solars/ SolarSave(limelm) , anova(limelm) , apn(limelm) ,
     1 ahii(limelm) , camern(limelm) , aprim(limelm) , aism(limelm)
      real solar
      common/solar/ solar(limelm)
      real Depletion , depset
*     Depletion is set of stored scale factors for depletion of general ism
*     depset is unity unless depletion is used
*     lgDepln is true if depln used
      logical lgDepln
      common/deplon/ Depletion(limelm) , depset(limelm) , lgDepln
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real AccelAver , acldr
*variables for tracking average radiative acceleration
      common/aclbar/ AccelAver , acldr
      real opac
      common/opac/ opac(ncell)
      logical lgNeutrnHeatOn
*flag lgNeutrnHeatOn says heating due to neutrons is enabled
*frcneu is fraction of total luminosity in neutrons, effneu is efficiency
*totneu is resulting total luminosity
      real frcneu , totneu , effneu
      common/neutrn/ frcneu , totneu , lgNeutrnHeatOn , effneu
      real tautot , tauabs , tausct
      common/tautot/ tautot(ncell,2) , tauabs(ncell,2) , tausct(ncell,2)
      real r1r0sq
      common/r1r0sq/ r1r0sq
      real otslin , otscon , outcon , outlin
*     otsline and ots con - local ots fields for line and continua
*     outlin and outcon - outward line and continuum fields
      common/ots/ otslin(ncell) , otscon(ncell) ,
     1            outlin(ncell) , outcon(ncell)
      real DiffCont
*diffus is local diffuse continuum, for current zone
      common/diffus/ DiffCont(ncell)
      real CloudAgeSet
*age of cloud set with age command
      common/CloudAge/ CloudAgeSet
      real feopc , Fe2TauLte , Fe2PopLte
* opacity and optical depths for ground of Fred's FeII atom
      common/fe2tau/ feopc(nfeii) , Fe2TauLte(nfeii) , Fe2PopLte(nfeii)
      real tgffused , tgffsued2
      common/tgff/ tgffused , tgffsued2
      logical lgBroke
*logical flag saying that the code is broken
      common/broke/ lgBroke
      integer nUnstable
      logical lgUnstable
*keep track of possibly thermall unstagle models
*nUnstable is number of zones that were possibly thermall unstable
*lgUnstable is set in ionte and says that current consitions possibly unstable
      common/nustbl/ nUnstable , lgUnstable
      logical lgFluor
*     turn off continuum pumping, set with 'no induced processes' command
      common/fluors/ lgFluor
      character chFeIIAtom*6
*say which FeII atom this is, Verner or Netzer
      common/FeIIAtom/ chFeIIAtom
      double precision FreeFreeOpacity
*density and temp factors needed for free-free opacity
      common/ffopac/ FreeFreeOpacity(ncell)
      real xMax2Pht
      common/Max2Pht/ xMax2Pht
      real TauDummy
*     this is a dummy optical depth array for non-existant lines
      common/TauDmmy/ TauDummy(nta)
      real ExpZone
*exp(-tau) for the current zone only
      common/facexp/ ExpZone(ncell)
      real SavOutCon(ncell)
*     variables related to deriving the ratio of outward to incident continuum
*     SumOutMax - energy where max occurs, ipSumOutMax pointer to this
*     sumOutCon is summed out outlin and outcon less SavOutCon for all energy
*     SumHOutCon is H-ionizing only
      real SumOutCon , SumIncCon , SumHOutCon , SumHIncCon , SumOutMax
      integer ipSumOutMax
      common/SumOutInc/ SumOutCon , SumIncCon , SavOutCon , SumHOutCon ,
     1 SumHIncCon , SumOutMax , ipSumOutMax
      logical lgPrnErr
      integer ioPrnErr
      common/PrnErr/ lgPrnErr , ioPrnErr
      real hlife
      common/hlife/ hlife(lmhlvl)
*     energy range and threshold for FeII lines output with punch verner
      real fe2ener(2) , fe2thresh
      common/feiipar/ fe2ener , fe2thresh
      logical lgKatyaData , lgSimKatya
*     lgKatyaData is a logical flag that determines whether Katya's FeII
*     data has been linked in.  it is set true with the FeII Verner command
*     lgSimKatya is set true if the key 'simulate' is on the line, in which
*     case everything else runs, but the atom is not actually used
      common/KatyaData/ lgKatyaData , lgSimKatya
      real AngleIllum
*angle of illumination - actually 1./cos(normal), so > 1.
      common/Angllum/ AngleIllum
*
*     local variables
      integer i , j , nd
      real test
      logical lgSane
*
*     this routine is called exactly one time at the start of
*     the calculation of a single model.  It is called before
*     the boundary conditions are read in, and is never called again
*     during that calculation.  When the code is used as a subroutine
*     this routine is called first, when a specific model is initialized.
*     All default variables that must be initialized before a calculation
*     must appear in the routine.
*
*     these used to be in block data logic
      call Zerologic
*
*     zero out warnings, cautions, notes, etc
      call wcnint
*
      DustCoolGas = 0.
      lgHMtrxOff = .false.
      lgPunPoint = .false.
*     default line width for plots, in units of speed of light
*     PunchLWidth = 1.
*     >>chng 97 jul 10, from unity to 1000 km/sec
      PunchLWidth = SpeedLight / 1000.e5
*     limits for highest and lowest stages of ionization in TrimStage
      trimhi = 1e-6
      trimlo = 1e-10
      AngleIllum = 1.
      do i=1,nzlim
        testr(i) = 0.
        volstr(i) = 0.
        radstr(i) = 0.
        histr(i) = 0.
        hiistr(i) = 0.
        ednstr(i) = 0.
        o3str(i) = 0.
        heatstr(i) = 0.
        pdenstr(i) = 0.
      end do
      fcool = 0.
      dfcool = 0.
      feheat = 0.
      p1909 = 0.
      p2326 = 0.
      p1895 = 0.
      p1666 = 0.
      p1401 = 0.
      FreeFreeHeat = 0.
      ffhtot = 0.
      flong = 0.
      flcPhase = 0.
      hbrems = 0.
      HFFNet = 0.
      HCTOn = 0.
      nhlvl = 15
      nHTopOff = 10
      chHTopType = ' add'
      PhotScaleOn = 1.
      lgVrrFit = .true.
      lgPhFit = .false.
      AgeMoleForm = 0.
      lgPrnAges = .false.
      lgPrnDiff = .false.
      tsqden = 1e7
      CODissHeat = 0.
      lgPrtMaser = .false.
      lgNumDeriv = .false.
      lgTSetOn = .false.
      lgDenFluc = .true.
      lgOptimFlow = .false.
      call colzro
      do i=1,limpun
        lgPunLstIter(i) = .false.
      end do
*
*     normally is unity, set to zero when hydrogen collisions turned off
      HColOn = 1.
      DoubleTau = 1.
      SumOutCon = 0.
      SumIncCon = 0.
*
*     these are variables to remember the biggest error in the
*     electron density, and the zone in qhich it occurred
      BigEdenError = 0.
      ipEdenError = 0
*
*     which matrix inversion routine to use
      chMatrix = 'matin1 '
*
      lgPrnPump = .false.
      lgPrnInwd = .false.
      lgPrnColl = .false.
      lgPrnHeat = .false.
*
      H2Opacity = 0.
      SetCsupra = 0.
      lgPrnErr = .false.
      ioPrnErr = 2
*
*     flag says to do photo rates
      lgDoPhoto = .true.
*
*begin sanity checks
*     this is a sanity check - it is possible that block data sclar
*     was not linked in
      if( nWerner.le.0 ) then
        write(qq,'('' Insane value for nWerner encountered.'')')
        write(qq,'('' Was block data scalar linked in??'')')
        write(qq,'('' Check that it compiled OK (it probably did not).''
     1  )')
        call insane
        stop
      endif
*end sanity check
*
*begin sanity checks
*     this is a sanity check - its possible that block data auger
*     was not linked in
      if( nyield(3,1,1).ne.1 ) then
        write(qq,'('' Insane value for electron yield encountered.'')')
        write(qq,'('' Was block data auger linked in??'')')
        write(qq,'('' Check that it compiled OK (it probably did not).''
     1  )')
        call insane
        stop
      endif
*end sanity check
*
*begin sanity checks
*     this is a sanity check - its possible first check that block data lines
*     were linked in
      if( TauLines(ipLnEnrWN,1).le.0. ) then
        write(qq,'('' Insane value for TauLines array.'')')
        write(qq,'('' Was block data LineData linked in??'')')
        write(qq,'('' Check that it compiled OK (it probably did not).''
     1  )')
        call insane
        stop
      endif
*end sanity check
*
*begin sanity check
*     this is a sanity check - its possible that block data lines
*     (the file blckline.for)
*     was not linked in, or line data faulty
      lgSane = .true.
      do i=1,nTauLines
*       line wavelength in A
        if( TauLines(ipLnWlAng,i).le.0. ) then
          write(qq,'(''  routine zero, insane line wavelength'')')
          write(qq,'('' line index is '',i5)') i
          lgSane = .false.
        endif
        if( TauLines(ipLnGl,i).le.0. ) then
          write(qq,'(''  routine zero, insane lower stat wght'')')
          write(qq,'('' line index is '',i5)') i
          lgSane = .false.
        endif
        if( TauLines(ipLnGu,i).le.0. ) then
          write(qq,'(''  routine zero, insane upper stat wght'')')
          write(qq,'('' line index is '',i5)') i
          lgSane = .false.
        endif
        if( TauLines(ipLnEnrWN,i).le.0. ) then
          write(qq,'(''  routine zero, insane energy WN'')')
          write(qq,'('' line index is '',i5)') i
          lgSane = .false.
        endif
        if( TauLines(ipLnIonStg,i).le.0. ) then
          write(qq,'(''  routine zero, insane ioniz stage'')')
          write(qq,'('' line index is '',i5)') i
          lgSane = .false.
        endif
        if( TauLines(ipLnNelem,i).le.0. .or.
     1  TauLines(ipLnNelem,i).gt.limelm) then
          write(qq,'(''  routine zero, insane Nelem'')')
          write(qq,'('' line index is '',i5)') i
          lgSane = .false.
        endif
        if( TauLines(ipLnIonStg,i).gt.TauLines(ipLnNelem,i)) then
          write(qq,'(''  routine zero, insane IonStg>Nelem'')')
          write(qq,'('' line index is '',i5)') i
          lgSane = .false.
        endif
        if( TauLines(ipLnRedis,i).eq.0. ) then
          write(qq,'(''  routine zero, insane line redis fcn'')')
          write(qq,'('' line index is '',i5)') i
          lgSane = .false.
        endif
      end do
      if( .not.lgSane ) then
        write(qq,'('' Insane value for line arrays encountered.'')')
        write(qq,'('' Was block data lines linked in??'')')
        write(qq,'('' Were errors intreoducted into the line array?'')')
        call ShowMe
        stop
      endif
*end sanity checks
*
*     lte populations of some hydrogen molecules
      phmlte = 0.
      ph2lte = 0.
      phplte = 0.
*
*     Lya excitation temperature, counter for hotter than gas
      TexcLya = 0.
      TLyaMax = 0.
      nLyaHot = 0
*
*     starting search for new solution
      lgSearch = .true.
*
      xMax2Pht = 0.
      nFe2Neg = 0
*
*     max offset for ipSafe
      nMaxSafe = 0
      EnergySafe = 0.
*
*     turn off printing of heating agents
      lgPrintHeating = .false.
*
*     turn off flag for insane goings
      lgInsane = .false.
*
*     punch every one continuum point
      ncPunchSkip = 1
*
*     io unit for punching negative opacities
      negoIO = 0
*
*     flag for Lya masing
      xLaMase = 0.
*
*     the code is not broken
      lgBroke = .false.
*
*     age of the cloud, to check for time-steady
      CloudAgeSet = -1.
*
      lgWindOK = .true.
*     default condition is burgess supressed, nusbaumer and storye not
      lgSupDie(1) = .true.
      lgSupDie(2) = .false.
*
*     the ipSolar array is a set of pointers used for reading
*     in abundances with the "abundances" command
*     the hydrogen abundance of unity is not read in
      npSolar = limelm - 1
      do i=1,npSolar
        ipSolar(i) = i + 1
      end do
*
*     option to turn off an element
      do i=1,limelm
        lgElmtOn(i) = .true.
*       set of scale factors for changing abundances with elements command
        scalem(i) = 1.
*       option to have abundances from table
        lgAbunTabl(i) = .false.
      end do
      lgAbTaON = .false.
*
*     zero out diffuse recombinaiton emission arrays
      do i=1,limelm
        do j=1,limelm
          DiffusHeavy(i,j) = 0.
          xLyaHeavy(i,j) = 0.
          do nd=1,7
            PhotoRate(i,j,nd,1) = 0.
            PhotoRate(i,j,nd,2) = 0.
          end do
        end do
      end do
*
*     this is the simple fred hamann feii atom
      do i=1,nfeii
        Fe2PopLte(i) = 0.
        feopc(i) = 0.
        Fe2TauLte(i) = taumin
      end do
*
*     zero out volume and column density save arrays
      call zmean
*
      lgFluor = .true.
      lgDHetOn = .true.
      lgDColOn = .true.
      lgPhysOK = .true.
*     highest allowed temperature
      T2High = 1e12
      lgOpacNeg = .false.
      lgSecOFF = .false.
      lgNxtDROff = .true.
      lgHe1ON = .true.
      lgHe2ON = .true.
      hmidep = 1.
      h2dep = 1.
      h2pdep = 1.
      h3pdep = 1.
      hehdep = 1.
      oldcla = 0.
      ioreco = 0
      do i=1,limelm
        CotaRate(i) = 0.
      end do
*
      agrav = 0.
      AccelTot = 0.
      AccelCont = 0.
      AccelLine = 0.
      AccelPres = 0.
      AccelMax = 0.
      fmul = 0.
*
*     main arrays to save ionization fractions and heating rates
      do i=1,limelm
        do j=1,limelm
          heating(i,j) = 0.
        end do
      end do
      do i=1,limelm
        do j=0,limelm+1
          xIonFracs(i,j) = 0.
        end do
      end do
*
      Ca2RmLya = 0.
      pca2ex = 0.
*
*     set default cylinder thickness
      CylindHigh = 1e35
      lgCylnOn = .false.
      lgEdenBad = .false.
      nzEdenBad = 0
*
*     limits to stop line command
      nstpl = 0
      do i=1,MXSTPL
        stpint(i) = 1e37
        ipStopLin1(i) = 1
        ipStopLin2(i) = 1
        LineStopWl(i) = 0.
      end do
*
      grecon = 1.
      CarMolFrac = -1.
      nlsum = 0
      lgPrtCont = .false.
      lgFe2On = .true.
      lgLotsCO = .false.
      lgH2Ozer = .false.
      lgOut2In = .false.
      lgFntSet = .false.
      GrainMetal = 1.
      lgComNeg = .false.
      catmic = 0.
      oatmic = 0.
      ch = 0.
      chp = 0.
      oh = 0.
      ohp = 0.
      otwo = 0.
      ctwo = 0.
      co = 0.
      cop = 0.
      h2o = 0.
      h2op = 0.
      o2p = 0.
      c2p = 0.
      h3p = 0.
      h3op = 0.
      ch2p = 0.
      ch2 = 0.
      ch3 = 0.
      cp = 0.
      rjnmin = 1e37
      ajmmin = 1e37
      CaseBCheck = -1e36
      lgDrNeg = .false.
      lgCalled = .true.
      lgBusted = .false.
      lgConPres = .true.
      lgVelPos = .true.
      lgZoneSet = .false.
      lgZoneTrp = .false.
*
*     default FeII is Netzer's
      chFeIIAtom = 'Netzer'
*     will not simulate Katya's atom
      lgSimKatya = .false.
*     energy range of her atom is zero to infinity
      fe2ener(1) = 0.
      fe2ener(2) = 1e8
*     set zero for the threshold of weakest line to punch
      fe2thresh = 0.
*
*     some titles and line images
      chTitle(1:20) = '                    '
      chTitle(21:40) = '                    '
      chTitle(41:60) = '                    '
      chTitle(61:75) = '               '
*
      chDffTrns = 'OU2'
      TurbVel = 0.
      lgCExtraOn = .false.
      CoolExtra = 0.
      pinit = 0.
      pinteg = 0.
      pinzon = 0.
*
*     check whether this is a 32-bit machine
      test = 1e-37
      test = test / 1d40
      if( test.eq.0. ) then
        lgBit32 = .true.
      else
        lgBit32 = .false.
      endif
*
      covrt = 0.
      glbdst = 0.
      glbrad = 0.
      covgeo = 1.
      negoi = 0.
*
      do i=1,ncell
        OldOpacSave(i) = 0.
        lgOTSOn(i) = .true.
        GrainEmission(i) = 0.
        FreeFreeOpacity(i) = 0.
        DiffCont(i) = 0.
        ContDiff(i) = 0.
        reflin(i) = 0.
        reflux(i) = 0.
        refcon(i) = 0.
        otslin(i) = 0.
        otscon(i) = 0.
        outcon(i) = 0.
        outlin(i) = 0.
        tmn(i) = 1.
        ExpZone(i) = 1.
        e2TauAbs(i) = 1.
        ExpmTau(i) = 1.
      end do
*
      do i=1,ncell
        opac(i) = 0.
        ContBoltz(i) = 0.
        gff(i) = 1.1
        gffhe2(i) = 1.1
        tautot(i,1) = taumin
        tauabs(i,1) = taumin
        tausct(i,1) = taumin
      end do
*
*     these are flags to let gff sub know to recompute ContBoltz and gss
      tgffused = -1.
      tgffsued2 = -1.
*
*     this is default punch unit for first punch command
      iPunDef = 11
*
      htus = 1.
      he1tus = 1.
      he2tus= 1.
      he3tus = 1.
      dDensityDT = 0.
      cinrat = 0.
      cintot = 0.
      otsfe2 = 0.
      ntff =1
      tff = 0.
      BiggestH2 = -1.
      lgNegGrnDrg = .false.
      nUnstable = 0
      lgUnstable = .false.
      tauend = 0.
      taunu = 0.
      iptnu = ncell
      resmax = 0.
      kapots = 0
      kap911 = 0
      frcneu = 0.
      effneu = 1.
      totneu = 0.
      lgNeutrnHeatOn = .false.
      windv0 = 0.
      AccelAver = 0.
      acldr = 0.
      comass = 0.
      windv = 0.
      emdot = 0.
      npunch = 0
      lgHeMase = .false.
      lgUSphON = .false.
      dVeldRad = 0.
      stimax(1) = 0.
      stimax(2) = 0.
      htwo = 0.
      h2plus = 0.
      h3plus = 0.
      hminus = 0.
      Ca3d = 0.
      Ca4p = 0.
      dstCala = 0.
      hmihet = 0.
      hmitot = 0.
      do i=1,lmhlvl
        hlmax(i) = 0.
        HLineWidth(i) = 0.
      end do
      do i=1,ncold
        colden(i) = 0.
      end do
      do i=1,limspc
*       range(i,1) = 1.
*     >>chng 96 dec 18, from inf mass ryd to H mass ryg
        range(i,1) = HIonPot
        range(i,2) = egamry
      end do
*
      totcol = 0.
      GrossHeat = 0.
      heatl = 0.
      coolheat = 0.
      h = 0.
      htot = 1.
      ctot = 1.
      power = 0.
      rinner = 0.d0
      radius = 0.d0
      drad = 0.d0
      depth = 1d-30
      r1r0sq = 1.
*
      nzone = 0
      lgEndDflt = .true.
*     this is default number of zones
*     >>chng 96 june 5, from 400 to 500 for thickes corners4 grid
      nEndDflt = 600
      do i=1,itrdim
        nend(i) = nEndDflt
        router(i) = 1e30
      end do
*
      hgamsc = 0.
      esc584 = 0.
      esc626 = 0.
      esc304 = 0.
      esc911 = 0.
      esc910 = 0.
      esc610 = 0.
      esc660 = 0.
*
*     at start opacity array not defined, will not be until OPACIN called
*     this is cricial for He diffuse fields
      lgOpacOn = .false.
*
*     save initial condition for talk in case PRINT LAST used
      lgInTalk = lgTalk
*
*     flags for whether continuum is defined over all energies
      lgMMok = .true.
      lgHPhtOK = .true.
      lgXRayOK = .true.
      lgGamrOK = .true.
      lgHiPop2 = .false.
      pop2mx = 0.
      escah = 1.40e8
      EdenFFSum = 0.
      thist = 0.
      tlowst = 1e20
      nsbig = 0
      iontot = 0
      ilt = 0
      iltln = 0
      ilthn = 0
      ihthn = 0
      ifail = 0
*
      nflux = ncell
*
      lgHabing = .false.
      lgPradCap = .false.
      lgPradDen = .false.
*
      lgDrMinUsed = .false.
*
      otsfe2 = 0.
*
      popmg2 = 0.
      rmg2l = 0.
      poiii2 = 0.
      poiii3 = 0.
      poiexc = 0.
*
      lgRadPresON = .false.
      RadPres = 0.
      do i=1,20
        plines(i) = 0.
      end do
      RadBetaMax = 0.
      PresMax = 0.
*
      nhlo = 0
      nhe1lo = 0
      nhe2lo = 0
*
      do i=1,11
        hetrip(i) = 0.
      end do
*
      d5007r = 0.
      d5007t = 0.
      d4363 = 0.
      d6300 = 0.
*
      CTHion(1) = 0.
      CTHion(2) = 0.
      CTHrec(1) = 0.
      CTHrec(2) = 0.
*
      x12 = 0.
*
      recgrd = 3e-13
      photex = 0.
*
*     initialize heavy element line array
      do i=1,nTauLines
*       these are line optical depth arrays
*       inward optical depth
        TauLines(ipLnTauIn,i) = taumin
        TauLines(ipLnTauCon,i) = taumin
        TauLines(ipLnColovTOT,i) = 0.
*       outward optical depth
        TauLines(ipLnTauTot,i) = 1e30
*       escape probability
        TauLines(ipLnEscP,i) = 1.
*       inward part of line
        TauLines(ipLnInwd,i) = 1.
*       destruction probability
        TauLines(ipLnDesP,i) = 0.
*       line pumping rate
        TauLines(ipLnPump,i) = 0.
*       population of lower level
        TauLines(ipLnPopl,i) = 0.
*       >>chng 97 july 21, added following zero
*       population of upper level
        TauLines(ipLnPopu,i) = 0.
*       population of lower level with correction for stim emission
        TauLines(ipLnPopOpc,i) = 0.
*       following two heat exchange excitation, deexcitation
        TauLines(ipLnCool,i) = 0.
        TauLines(ipLnHeat,i) = 0.
*       intensity of line
        TauLines(ipLnInten,i) = 0.
*       number of photons emitted in line
        TauLines(ipLnNPhots,i) = 0.
*       opacity in line
        TauLines(ipLnDTau,i) = 0.
*       indicates that this is a high quality transition
        TauLines(ipLnCS1,i) = 0.
      end do
*     this is a dummy optical depth array for non-existant lines
      do i=1,nta
        TauDummy(i) = 0.
      end do
*
*     initialize the large blcok of OP lines
      call ConvWind
*     initialize Dima and Katya Verner's FeII arrays
*     do this whether or not its used
*     this routine sets the flag lgKatyaData which indicates whether
*     her FeII data have been linked in - this routine MUST be
*     called before any other FeII routine
      call ConvFe2
      call ZeroFe2
*
      call zero1
      call zero2
*
      telec = taumin
      thmin = taumin
*
      tpcah(1) = taumin
      tpcah(2) = 1e20
*
      hei = 0.
      heii = 0.
      heiii = 0.
      hei3 = 0.
      hei1 = 0.
*
      secion = 0.
      secla = 0.
      heatef = 1.
      efionz = 0.
      exctef = 0.
      csupra = 0.
*
      lgTauOutOn = .false.
*
      lgDepln = .false.
      do i=1,limelm
        solar(i) = SolarSave(i)
*       these are depltion scale factors
        depset(i) = 1.
*begin sanity check
        if( solar(i).eq.0. .or. depset(i).eq.0. ) then
          write(qq,'('' ZERO finds insane abundance or depletion.'')')
          write(qq,'('' atomic number='',i6,'' abundance='',1p,e10.2,
     1    '' depletion='',e10.2)') i, solar(i),depset(i)
          call ShowMe
          stop
        endif
*end sanity check
      end do
*
      end
******************************************************************************
      subroutine zero1
      implicit none
*zero out some variables at start of calculation
*
*     NB!!! the number of variables here MUST parallel the
*     dimension of the line arrays as set in nta.par
*
*     these are series of pointers to elements of line arrays
      integer
     1 ipLnTauIn   , ipLnTauTot , ipLnInwd    , ipLnWlAng , ipLnDampRel,
     2 ipLnIpCont  , ipLnGF     , ipLnOpac    , ipLnEnrWN , ipLnEnrErg ,
     3 ipLnNPhots  , ipLnDamp   , ipLnGl      , ipLnGu    , ipLnNelem  ,
     3 ipLnIonStg  , ipLnBolt   , ipLnAul     , ipLnEscP  , ipLnDesP   ,
     4 ipLnPump    , ipLnPopl   , ipLnAovTOT  , ipLnInten , ipLnRedis  ,
     5 ipLnCS      , ipLnRyd    , ipLnOTS     , ipLnDTau  , ipLnCool   ,
     6 ipLnPopOpc  , ipLnHeat   , ipLnColovTOT, ipLnCS1   , ipLnCS2    ,
     7 ipLnPopu    , ipLnTauCon
*     1 inward optical deph
      parameter (ipLnTauIn=1)
*     2 total optical depth from previous iteration
      parameter (ipLnTauTot=2)
*     3 escape probability
      parameter (ipLnEscP=3)
*     4 inward part of the line
      parameter (ipLnInwd=4)
*     5 line WL (A), <0 compl redis
      parameter (ipLnWlAng=5)
*     6 related to the damping constant
      parameter (ipLnDampRel=6)
*     7 pointer to line energy in continuum array
      parameter (ipLnIpCont=7)
*     8 lower stat. weight
      parameter (ipLnGl=8)
*     9 upper stat. weight
      parameter (ipLnGu=9)
*     10 gf value
      parameter (ipLnGF=10)
*     11 A_ul, transition probability
      parameter (ipLnAul=11)
*     12 trans energy degrees kelvin
      parameter (ipLnBolt=12)
*     13 destruction probability
      parameter (ipLnDesP=13)
*     14 line opacity
      parameter (ipLnOpac=14)
*     15 transition energy-wavenumbers
      parameter (ipLnEnrWN=15)
*     16 is the stage of ionization
      parameter (ipLnIonStg=16)
*     17 continuum pumping rate
      parameter (ipLnPump=17)
*     19 trans energy ergs
      parameter (ipLnEnrErg=19)
*     20 num of phot EMIT per s in line
      parameter (ipLnNPhots=20)
*     21 ratio A21/(A21+C21)
      parameter (ipLnAovTOT=21)
*     22 atomic number of the atom
      parameter (ipLnNelem=22)
*     23 damping constant for line
      parameter (ipLnDamp=23)
*     ratio of collisional to radiative excitation
      parameter (ipLnColovTOT=24)
*     25 intensity of line
      parameter (ipLnInten=25)
*     26 redistribution funciton to be used for line
      parameter (ipLnRedis=26)
*     27 line collision strength
      parameter (ipLnCS=27)
*     28 line excitation energy in Rydbergs
      parameter (ipLnRyd=28)
*     29 local OTS line destruction, photons/sec
      parameter (ipLnOTS=29)
*     30 total opacity (cm^-1) in transition
      parameter (ipLnDTau=30)
*     31 heat exchange, collisional excitation
      parameter (ipLnCool=31)
*     32 heat exchange, collisional de-excitation
      parameter (ipLnHeat=32)
*     33 type of transition for Mewe collision strength
*     in general first parameter for CS expansion
*     this parameter zero indicates high quality line
*     (separate pointer to OTS background)
      parameter (ipLnCS1=33)
*     34 second parameter for CS expansion
      parameter (ipLnCS2=34)
*     35 population of upper level, needed for line excitation temp
      parameter (ipLnPopu=35)
*     18 pop of low level for excit temp
      parameter (ipLnPopl=18)
*     36 pop of low lev-correcd for stim em
      parameter (ipLnPopOpc=36)
*     37 optical depth to the continuum source
      parameter (ipLnTauCon=37)
*     NB!!! ipLnArry.par and this file MUST be kept parallel
*     length of optical depth line array elements
*     pointers to each element are summarized in ipLnArray.par
      integer nta
      parameter (nta=37)
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
*     number of levels in helium singlet atom
*     2s is nhe1lvl+1
      integer nhe1lvl
      parameter (nhe1lvl=9)
*     number of levels in helium ion
*     2s is nhe2lvl+1
      integer nhe2lvl
      parameter (nhe2lvl=9)
      integer nhe3lvl
      parameter (nhe3lvl=5)
      integer ndust
*number of grain species, set up to 20 to include K Volk's PAHs
      parameter (ndust=20)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer NWINDLINE
*number of level 2 lines, dim for WindLine array
      parameter (NWINDLINE=6744)
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      real te , eden , hden
      common/phycon/ te , eden , hden
      real CoolHeatMax
      character*4 chCoolHeatMax
*     max of negative coolants, and a pointer to it
      integer ipCoolHeatMax
      common/CHMax/ CoolHeatMax , ipCoolHeatMax , chCoolHeatMax
      integer ijMase
      real dTauMase
*     dTauMase is smallest maser optical depth in atoms, set in
*     tauinc for H, and in tauchn for heavy elements
*     it is negative or zero
*     ijMase is 100*n_upper + n_lower
*     if ijMase is 0 when dTauMase used, maser was in heavy element
      common/dtMase/ ijMase , dTauMase
      logical lgTestIt , lgTestOn
*flag lgTestIt turned on if routine TestCode ever called, only generates
*comment that test code is in place
*flag lgTestOn set true for some test code to be run somewhere
      common/Testit/ lgTestIt , lgTestOn
      real DustDftVel , avdft
*DustDftVel is dust drift velocity
      common/dstdft/ DustDftVel(ndust) , avdft(ndust)
      real DestWght , DestWghtSave
*     weight to give new dest prob when being evaluated,
*     default is 0.25 and is reset with SET DSTWGHT command
*     DstWghtSave is usually the same as DstWght - except on 0th
*     zone, where DstWght is set to 1 to get initial dest prob
*     then reset to DstWghtSave
      common/DstWght/ DestWght , DestWghtSave
      real HCTAlex
*Dalgarno H charge transfer rate coef for high stages of ionization
*default is 8.5e-10 in zero, reset with 'set charge transfer' command
      common/HCTMin/ HCTAlex
      real dheat
*grain heating rate for this zone
      common/dustheat/ dheat(ndust)
      logical lgQHeat
*Kevin Volk add for quantum heating of grains
      common/qheat/ lgQHeat(ndust)
      real tgrmax
      common/tgrmax/ tgrmax(ndust)
      logical lgDustOn , lgDustOn1 , lgDustVary
      real dstfactor , dstAbund
*dstfactor is abundance set with grains command, stays constant over calculaiton
*dstAbund is abundance that may depend on depth
*lgDustOn says whether any grains are enabled
*lgDustOn1 says whether that particular species is on
*lgDustVary says to use special function to vary grain abundance over model
*set with keyword function on grain command
      common/dstfac/ lgDustOn , dstfactor(ndust) , lgDustOn1(ndust) ,
     1 lgDustVary(ndust) , dstAbund(ndust)
      real tedust
      common/tedust/ tedust(ndust)
      integer nLevTrace
*     flag to indicate level of detail in trace, now only in trace convergence
      common/LevTrace/ nLevTrace
      real WindLine
*transfer arrays for large block of level two lines
      common/WindData/ WindLine(nta,NWINDLINE)
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real he1qin,he1rin
      common/he1ind/ he1qin(nhe1lvl+1),he1rin(nhe1lvl+1)
      real he2qin,he2rin
      common/he2ind/ he2qin(nhe2lvl+1),he2rin(nhe2lvl+1)
      real he1cin
      common/he1cin/ he1cin(10)
      real he2cin
      common/he2cin/ he2cin(10)
      double precision he1bn
      common/he1bnCOM/ he1bn(nhe1lvl+1)
      double precision he2bn
      common/he2bn/ he2bn(nhe2lvl+1)
      double precision he3bn
      common/he3bn/ he3bn(nhe3lvl)
      real he3n
      common/he3n/ he3n(nhe3lvl)
      real he3pht , he3lya , he3local , he3relax
*     he3relax is fraction of 23s populations that go to singlets
      common/he3pht/ he3pht , he3lya , he3local , he3relax
      real he2dmp
      common/he2dmp/ he2dmp(9)
      real he1dmp
      common/he1dmpCOM/ he1dmp(9)
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      character*10 chLineLbl , chLbl
      integer i , nd
*
      nLevTrace = 0
*     weight to give new destruction probability for lines
      DestWght = 0.25
      DestWghtSave = 0.25
      dTauMase = 0.
      lgTestIt = .false.
      lgTestOn = .false.
      CoolHeatMax = 0.
      ipCoolHeatMax = 0
      te = 1e4
*
*     this is array of line energies, only defined for some lines
      do i=1,NLINES
        xLineEnergy(i) = 0.
      end do
*
*     >>chng 97 jan 6, from 0 to 8.5e-10*q as per Alex Dalgarno e-mail
*     >>chng 97 feb 6, from 8.5e-10*q 1.92e-9x as per Alex Dalgarno e-mail
      HCTAlex = 1.92e-9
*
*     some grain variables
      do nd=1,ndust
        lgQHeat(nd) = .false.
        lgDustVary(nd) = .false.
        DustDftVel(nd) = 1.
        avdft(nd) = 0.
        tgrmax(nd) = -1.
        lgDustOn1(nd) = .false.
        dheat(nd) = 0.
        dstfactor(nd) = 1.
        tedust(nd) = 0.
      end do
      lgDustOn = .false.
*
*     lines in cooling function with Mewe approximate collision strengths
      do i=1,NWINDLINE
*       these are line optical depth arrays
*       inward optical depth
        WindLine(ipLnTauIn,i) = taumin
        WindLine(ipLnTauCon,i) = taumin
        WindLine(ipLnColovTOT,i) = 0.
*       outward optical depth
        WindLine(ipLnTauTot,i) = 1e20
*       escape probability
        WindLine(ipLnEscP,i) = 1.
*       inward part of line
        WindLine(ipLnInwd,i) = 1.
*       destruction probability
        WindLine(ipLnDesP,i) = 0.
*       line pumping rate
        WindLine(ipLnPump,i) = 0.
*       population of lower level
        WindLine(ipLnPopl,i) = 0.
*       population of upper level
        WindLine(ipLnPopu,i) = 0.
*       population of lower level with correction for stim emission
        WindLine(ipLnPopOpc,i) = 0.
*       following two heat exchange excitation, deexcitation
        WindLine(ipLnCool,i) = 0.
        WindLine(ipLnHeat,i) = 0.
*       intensity of line
        WindLine(ipLnInten,i) = 0.
*       number of photons emitted in line
        WindLine(ipLnNPhots,i) = 0.
*       opacity in line
        WindLine(ipLnDTau,i) = 0.
*begin sanity check
        if( WindLine(ipLnCS1,i).le.0. ) then
          chLbl = chLineLbl( WindLine(1,i) )
          write(qq,'('' Zero1, insane Type for WindLine line,'',a10)')
     1    chLbl
        endif
*end sanity check
      end do
*
      he3pht = 0.
      he3lya = 0.
*
      do i=1,nhe1lvl+1
        he1cin(i) = 0.
        he1bn(i) = 1.
      end do
      do i=1,nhe2lvl+1
        he2cin(i) = 0.
        he2bn(i) = 1.
      end do
      do i=1,nhe3lvl
        he3n(i) = 0.
        he3bn(i) = 1.
      end do
*
      end
******************************************************************************
      subroutine zero2
      implicit none
*zero out some variables at start of calculation
      real Fe2L16Tot,fe21308,fe21207,fe21106,fe21006,
     1 fe21204,fe21103,fe21104,fe21001,fe21002 ,
     1 fe20201 , fe20302 , fe20706 , fe20807 , fe20908 ,
     1 fe21007 , fe21107 , fe21108 , fe21110 , fe21507 ,
     1 fe21208 , fe21209 , fe21211 , fe21406 ,fe21508 , fe21609
*total cooling due to 16 level model FeII atom
*fe2cool is total cooling due to 16 level atom,
      common/fe2cool/ Fe2L16Tot,fe21308,fe21207,fe21106,fe21006,
     1 fe21204,fe21103,fe21104,fe21001,fe21002 ,
     1 fe20201 , fe20302 , fe20706 , fe20807 , fe20908 ,
     1 fe21007 , fe21107 , fe21108 , fe21110 , fe21507,
     1 fe21208 , fe21209 , fe21211 , fe21406,fe21508,fe21609
      real Fe4CoolTot, fe42836,fe42829,fe42567 , fe40401 ,
     1 fe41207, fe41206, fe41106, fe41007, fe41008, fe40906
*total cooling due to 12 level model FeIV atom, and three uv lines
*4P5/2 - 6S5/2, 4P3/2 - 6S5/2, and 4D+ - 6S
*Fe4CoolTot is total cooling due to entire atom, also three selectec lines
      common/fe4cool/ Fe4CoolTot, fe42836,fe42829,fe42567 , fe40401,
     1 fe41207, fe41206, fe41106, fe41007, fe41008, fe40906
*
      Fe2L16Tot = 0.
      fe21406 = 0.
      fe21507 = 0.
      fe21508 = 0.
      fe21609 = 0.
      fe21308 = 0.
      fe21207 = 0.
      fe21106 = 0.
      fe21006 = 0.
      fe21204 = 0.
      fe21103 = 0.
      fe21104 = 0.
      fe21001 = 0.
      fe21002 = 0.
      fe20201  = 0.
      fe20302  = 0.
      fe20706  = 0.
      fe20807  = 0.
      fe20908  = 0.
      fe21007  = 0.
      fe21107  = 0.
      fe21108  = 0.
      fe21110  = 0.
      fe21208  = 0.
      fe21209  = 0.
      fe21211  = 0.
      Fe4CoolTot = 0.
      fe40401 = 0.
      fe42836 = 0.
      fe42829 = 0.
      fe42567 = 0.
      fe41207 = 0.
      fe41206 = 0.
      fe41106 = 0.
      fe41007 = 0.
      fe41008 = 0.
      fe40906 = 0.
      end
      subroutine Zerologic
      implicit none
*set initial values for logical variables
*
*     number of levels in hydrogen atom
*     2s is nhlvl+1
*     this parameter is set on the fly with hydrogen levels command
      integer nhlvl
      common/nhlvl/ nhlvl
*     lmhlvl appears in dimension statements throughout the code, is hardwired
      integer lmhlvl
      parameter (lmhlvl=50)
      integer nfudgc
      parameter (nfudgc=10)
      integer ndplot
      parameter (ndplot=10)
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer NLINES
*number of emission lines in main stack
      parameter (NLINES=40000)
      integer limelm
      parameter (limelm=30)
      real optint , optier
      common/intopn/ optint , optier
      integer itrprt
      common/itrprt/ itrprt(itrdim)
      logical lgResetOTS
      common/ResetOTS/ lgResetOTS
      real te , eden , hden
      common/phycon/ te , eden , hden
      character*4 chRedis
      common/redis/ chRedis
      real toler
*     allowed error in heating - cooling balance, set with TOLERANCE command
*     default set in zerologic
      common/toler/ toler
      logical lgFaintOn
*logical lgFaintOn normally true, says to not print very faint lines
*set false with print faint off command
*lines fainter than TooFaint will not be printed.  This is set in zerologic
*and reset with print line faint command
      real TooFaint
      common/faint/ TooFaint , lgFaintOn
      real prall , psort
      common/prall/ prall , psort
      real fudgea
      integer nfudge
      common/fudgec/ fudgea(nfudgc) , nfudge
      real taumin , tlamin
*     taumin is the smallest optical depths allowed,
*     these used since optical depth of zero would crash
      common/taumin/ taumin , tlamin
      real prspow
      common/prspow/ prspow
      real emm , egamry
      common/bounds/ emm , egamry
      real ForceTemp
*initial temperature to try to force soln, set with force command
*also set with other constant temper commands
      common/forcte/ ForceTemp
      integer NormWL
      real sclnrm
      character chNormLab*4
*     NormWL is integer wavelength of emission line on normalize command
*     sclnrm is the scale factor for its appearance
*     chNormLab is optional label1
      common/norm/ NormWL , sclnrm , chNormLab
      double precision comtot , cmheat , cmcool , comoff, cinrat
      common/comptn/ comtot , cmheat , cmcool , comoff, cinrat
      real DampOnFac
*usually 1, set to 0 with hydrogen damping off command, scales rayleigh scat
      common/dampon/ DampOnFac
      integer nsum , lin
*     these are the main line storage arryas
*     xLineEnergy is energy of line in Rydbergs
*     nsum is current point, to last line entered in the array
*     linadd increments nsum before doing anything else
      real sumlin , emslin , xLineEnergy
      common/sum/ nsum , sumlin(NLINES) , lin(NLINES), emslin(NLINES) ,
     1 xLineEnergy(NLINES)
      integer iter , itermx
*     these are the variables that control how many iterations are
*     to be done, and number of the current iteration
*     iter is current iteration - 1 for first iteration
*     itermx is number of iterations to perform, set with iterate command
*     upper limit is parameter variable ItrDim
      common/IterCnt/ iter , itermx
      real HColStop , colpls , colnut
*limit column densities set with stop column command
*colend is total hydrogen column, others are ionized and neutral
      common/colend/ HColStop , colpls , colnut
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      logical lgDROn , lgDRPLst
*     these control punching choice of dr - this is not really a punch cmnd
*     ipDRout is io unit, lgDROn says punching dr logic has been set,
*     and lgDRPLst says to punch the last iteration
      integer ipDRout
      logical lgFe2PLst
      common/ipdr/ ipDRout , lgDROn , lgDRPLst , lgFe2PLst
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      real EnerGammaRay
*lowest energy counted as gamma rays, 100 keV
      integer ipEnerGammaRay
      common/egray/ EnerGammaRay , ipEnerGammaRay
      logical lgOptLin , lgOptLum , lgOptCol
*flags set if we are to optimize lines, luminosity, or colums
      common/whtopm/ lgOptLin , lgOptLum , lgOptCol
      logical lgTrOpt
*lgTrOpt flag set with optimization trace command
*nTrOpt is which call to cloudy to turn on trace
      integer nTrOpt
      common/tropt/ nTrOpt , lgTrOpt
      logical lgCSetOn
*lgCSetOn set with set csupra command
*SetCsupra is secondary ionization rate set with set csupra
      real SetCsupra
      common/cspset/ SetCsupra , lgCSetOn
      logical lgPathSet
*true is path has been set with set path command, false otherwise
      common/pthset/ lgPathSet
      logical lgNoExec
*flag saying no to compute model, just generate continuum and stop
*set with cdNoex call
      common/noexec/ lgNoExec
      logical lgAbnSolar
      common/abnslr/ lgAbnSolar
      logical lgTrOvrd
*flag affecting which iteration to turn on trace
      common/trovrd/ lgTrOvrd
      logical lgDriveMole
*flag set when drive molecule command entered
      common/moldrv/ lgDriveMole
      logical lgdR2Small
*set true if zone thickness became too small
      common/dr2sml/ lgdR2Small
      logical lgZoneSet , lgZoneTrp
*lgZonSet set if stopping zone specified
*lgZoneTrp set if stopped due to zone number
      common/zonset/ lgZoneSet , lgZoneTrp
      logical lgAutoIt
      real autocv
      common/autoit/ lgAutoIt , autocv
      logical lgTrDiff
*flag set with trace difuse fields command
      common/trdiff/ lgTrDiff
      logical lgReadIn , lgScanar
*flag lgReadIn set if we are to read in line images (cdRead never called)
*flag lsScanar set true in cdInit:w
*lgScanar is not used at all - confirm then remove
      common/readin/ lgReadIn , lgScanar
      logical lgVaryOn
*flag set true if vary option used
      common/vary/ lgVaryOn
      logical lgStatic
*flag saying that spherical geometry is static, set with sphere static
      common/static/ lgStatic
      logical lgCNegChk
*flag set true during cooling map, saying to keep cool even
*if cooling is negative
      common/cnegtk/ lgCNegChk
      logical lgOnlyZone , lgOnlyHead
*lgOnlyZone set with print only zones
*lgOnlyHead set with print only header
      common/only/ lgOnlyZone , lgOnlyHead
      logical lgPtrace
*flag set with drive pointers command
      common/PltTrace/ lgPtrace
*     limfal is limit to number of te failures, set with "failures" cmnd
*     lgNoMap is option not to map failures
      integer limfal
      logical lgNoMap
      common/limfal/ limfal , lgNoMap
      real r1r0sq
      common/r1r0sq/ r1r0sq
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      logical lgPrtStart
*lgPrtStart is option to start printout at certain zone
*nstart is zone number, set with print start command
      integer nstart
      common/pstart/ lgPrtStart , nstart
      character chReason*21
      common/reason/ chReason
      real StopElecDensity
*stopping electron density, set with stop eden command
      common/endedn/ StopElecDensity
      logical lgDrBug
*flag set with trace dr command
      common/drbug/ lgDrBug
      logical lgOTSBug
*flag set with trace ots command
      common/otsbug/ lgOTSBug
      logical lgBug2nu
*flag set with trace two photon command
      common/bug2nu/ lgBug2nu
      logical lgDustBug
*flag set with trace grains command
      common/dstbug/ lgDustBug
      logical lgHLyaMased
*flag saying that Lya mased
      common/lyamas/ lgHLyaMased
      logical lgHeClON
*flag saying whether he collisions are turned on
*set false with helium collisions off command
      common/heclon/ lgHeClON
      logical lgDrMnOn
*flag to turn off dr checking in dextdr when globule command entered
      common/drmnon/ lgDrMnOn
      logical lgScatON
*flag saying whether (true) or not (false) scattering opacity
*is enabled
      common/scaton/ lgScatON
      logical lgPresHeLya
*flag set to turn on HeII Lya, set with helium radiation pressure command
      common/phela/ lgPresHeLya
      logical lgStarkON
*flag saying that stark broadening is enabled, set false with no stark
      common/strkon/ lgStarkON
      logical lgRadPrsON
*flag true if radiation pressure is turned on, part of total pressure
      common/radpon/ lgRadPrsON
      logical lgTrGant
*flag set with trace gaunt command
      common/trgant/ lgTrGant
      logical lgHeatBug
*flag set by trace heating command
      common/heatbg/ lgHeatBug
      logical lgHeavyBug
*flag set to true by trace heavy command
      common/TrHeav/ lgHeavyBug
      logical lgCoolTr
*flag set with trace cooling
      common/cooltr/ lgCoolTr
      logical lgTrMole
*flag set with trace molecules command
      common/trmole/ lgTrMole
      logical lgPrtLastIt
*if true then print only last iteration
      common/plast/ lgPrtLastIt
      logical lgTrace3Bod
*trace 3 body recombination routines, trace three body
      common/bd3bug/ lgTrace3Bod
      logical lgOptcBug
*flag set if negative opacities every occured
      common/optbug/ lgOptcBug
      logical lgFeBug
*flag set with trace iron bug
      common/febug/ lgFeBug
      logical lgTrLine
*flag set with trace line command
      common/trline/ lgTrLine
      logical lgNeonBug
*flag set with trace neon command
      common/neonbg/ lgNeonBug
      logical lgNeBug
*set true if trace eden is entered
      common/nebug/ lgNeBug
      logical lgComBug
*trace compton flag
      common/combug/ lgComBug
      logical lgPointBug
*flag set with trace pointers command
      common/pntbug/ lgPointBug
      logical lgFreeOn
*flag set false if no free-free heating command entered
      common/freeon/ lgFreeOn
      logical lgColNeg
*set false during during search for equilibrium temp
*check whether to complain about negative cooling
      common/colneg/ lgColNeg
      logical lgC2psOn
*are collisions between 2s and 2p enabled?
      common/c2pson/ lgC2psOn
      logical lgOpacBug
*flag set with trace opacity
      common/opcbug/ lgOpacBug
      logical lgTr8446
*flag set with trace beta command
      common/tr8446/ lgTr8446
      logical lgFstOn
      common/fston/ lgFstOn
      logical lgCarBug
*trace carbon flag
      common/carbug/ lgCarBug
      logical lgCalBug
*trace caldium atom flag
      common/calbug/ lgCalBug
      logical lgConBug
*flag set with trace continuum command
      common/conbug/ lgConBug
      logical lgCasBhs
      common/casbhs/ lgCasBhs
      logical lgCaseb
*flag set when case b command entered
      common/caseb/ lgCaseb
      logical lgCalled , lgBusted , lgTalk
*variables for whether cloudy has been called, has returned
*with busted answer, and should talk
      common/called/ lgCalled , lgBusted , lgTalk
      logical lgHBug , lgHBugFull
*lgHBug set with trace hydrogen command
*hfull set with trace hydrogen full command
      common/hbug/ lgHBug , lgHBugFull
      logical lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
*flags set with trace helium (lgHeBug)
*lgHe1Bug is singlets or atom
*lgHe2Bug is helium ion
*lgHe3Bug is triplet
      common/hebug/ lgHeBug , lgHe1Bug , lgHe2Bug , lgHe3Bug
      logical lgNoCota
*lgNoCota flag set with no three body recombination
      real CotaRate
      common/rcota/ lgNoCota , CotaRate(limelm)
      logical lgTrace
      integer nznbug , npsbug
*nznbug zone to turn on trace, set by trace command, npsbug is iteratoin number
      common/trace/ lgTrace , nznbug , npsbug
      logical lgPrtArry
*flag set with print array command
      common/parray/ lgPrtArry
      logical lgTeHigh
*flag set if temperature map is from hot to cool, set with high command
      common/thigh/ lgTeHigh
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      logical lgNoMole
*flag to turn off molecules
      common/nomole/ lgNoMole
      logical lgPrtBN
*flag set with print departure coefficients
      common/pbn/ lgPrtBN
      logical lgPrtShort
*flag set with print short comand
      common/pshort/ lgPrtShort
      logical lgPlotON
*lgPlotON is flag set when plot turned on
      integer nplot
      real pltxmn , pltxmx
      common/ploton/ lgPlotON , pltxmn(ndplot) , pltxmx(ndplot) , nplot
      logical lgPltTrace
*flag set with plot trace command
      common/pltrce/ lgPltTrace(ndplot)
      logical lgTSetOn
*     this variable is normally false, and is set true
*     in the input parser if a constant temperture model is to be computed
      common/tseton/ lgTSetOn
      real hgamnc(lmhlvl+1),finduc(lmhlvl+1) ,rinduc(lmhlvl+1)  ,
     1 cind(lmhlvl+1) , cinduc(lmhlvl+1) , cintot
      logical lgHInducImp
*lgHInducImp says whether or not induced recombination is important
*  hgamnc is hydyrogen photoionization rate
*  finduc is integral of photorate times exp(-hu/kt) for ind rec
*  cind is this times hnu-hnuo0 to get  cooling
*  cinduc is actual cooling
*  cintot is total over model
      common/HPhoto/ hgamnc, finduc ,rinduc , cind  ,
     1 cinduc , cintot,lgHInducImp
      logical lgNewIon
*flag saying to do new ionization balance
      common/newion/ lgNewIon
      logical lgCompRecoil
*flag saying that compton recoil ionization of bound
*electrons is enabled
      common/recoil/ lgCompRecoil
      logical lgSecOFF
*flag saying that secondary electron have been turned off
      common/secoff/ lgSecOFF
      logical lgTrLevN
*flag set with trace leveln command, for n level atom
      common/TrLevN/ lgTrLevN
      logical lgTrConvg
      common/TrConvg/ lgTrConvg
      real CycloCoolCoef
*coefficient scaled from magnetic field used for
*Cyclotron cooling
      common/cyclot/ CycloCoolCoef
      logical lgSMinON
*lgSMinON is flag saying that set drmin has been enteed
*     these are 1e-30 and 1e30 by default, and are set with "set dr" cmnds
*     used as one of a pair of limits to how big or small zones get
*     set dr command forces constant dr by setting both to same number
      real sdrmin , sdrmax
      common/sdrmin/ sdrmin , sdrmax , lgSMinON
      real telow , tehigh
*     this is the default lowest to highest temperature checked
      common/telow/ telow , tehigh
      real cryden , crpowr , crtemp , hxtot
      common/hextra/ cryden , crpowr , crtemp , hxtot
      real turhet,turrad
      common/turhet/ turhet,turrad
      logical lgPunConv
      integer ipPunConv
*     unit number, and flag, for punching reason for continued iterations
      common/PunConv/ lgPunConv , ipPunConv
      logical lgExemplar
*set true when on exemplar with 'set exemplar' to get around
*bug in their compiler
      common/Exemplar/ lgExemplar
*
*     local variables
      integer i
*
*     following were block data scalar
      lgPunConv = .false.
      lgDROn = .false.
      lgDRPLst = .false.
      lgFe2PLst = .false.
      lgExemplar = .false.
      ipDRout = 6
      hden = -99.
      chRedis = 'INCO'
      toler = 0.02
      TooFaint = 1e-3
      lgFaintOn = .true.
      prall = 0.
      psort = 0.
      nfudge = 0
      tlamin = 1e-20
      prspow = 0.
      do i=1,itrdim
        itrprt(i) = 10000
      end do
      turhet = 0.
      turrad = 1e30
      cryden = 0.
      crpowr = 0.
      crtemp = 0.
      hxtot = 0.
      sdrmin = 1e-30
      sdrmax = 1e30
      tehigh = 1e10
      telow = 2.8
      lgSMinON = .false.
      CycloCoolCoef = 0.
      NormWL = 1
      chNormLab = '    '
      sclnrm = 1.
      ForceTemp = 0.
      itermx = 0
      iter = 0
      nsum = 0
      DampOnFac = 1.
      comtot = 0.
      comoff = 1.
      cmcool = 0.
      emm = 1.001e-5
      egamry = 7.354e6
      EnerGammaRay = 7676.
      fiscal = 1.
      FillFac = 1.
      filpow = 0.
      chCPres = 'CDEN'
      nprint = 1000
      tend = 4000.
      HColStop = 1e30
      colpls = 1e30
      colnut = 1e30
      StopElecDensity = -1e30
      chReason = 'reason not specified.'
      lgPrtStart = .false.
      nstart = 0
      itime = 0
      dt = 0.
      tmt1 = 0.
      tmpwr = 0.
      limfal = 20
      lgNoMap = .false.
      r1r0sq = 1.
*
*     following were block data logic
      lgResetOTS = .true.
      lgStarkON = .true.
      lgCNegChk = .true.
      lgVaryOn =.false.
      lgCaseb =.false.
      lgCasBhs =.false.
      lgFstOn = .true.
      lgCompRecoil = .true.
      lgOpacBug =.false.
      lgC2psOn =.true.
      lgColNeg = .true.
      lgTrConvg =.false.
      lgTr8446 =.false.
      lgFreeOn = .true.
      lgTrLevN =.false.
      lgTrGant =.false.
      lgOptcBug =.false.
      lgTrace3Bod =.false.
      lgPrtLastIt =.false.
      lgOTSBug =.false.
      lgTrMole =.false.
      lgHeatBug =.false.
      lgHeavyBug =.false.
      lgSecOFF =.false.
      lgRadPrsON =.true.
      lgNewIon = .true.
      lgTSetOn =.false.
      lgPlotON =.false.
      lgBug2nu =.false.
      lgDrBug =.false.
      lgPtrace =.false.
      lgReadIn = .true.
      lgScanar = .true.
      lgOptLin =.false.
      lgOptLum =.false.
      lgOptCol =.false.
      lgDustBug =.false.
      lgPrtShort =.false.
      lgTrOpt =.false.
      lgPrtBN =.false.
      lgSphere =.false.
      lgNoMole =.false.
      lgTeHigh =.false.
      lgPrtArry =.false.
      lgComBug =.false.
      do i=1,ndplot
        lgPltTrace(i) = .false.
      end do
      lgNoCota =.false.
      lgHeBug =.false.
      lgCarBug =.false.
      lgCalBug =.false.
      lgConBug =.false.
      lgNeBug =.false.
      lgFeBug =.false.
      lgCalled =.false.
      lgBusted =.false.
      lgHBug =.false.
      lgPresHeLya =.false.
      lgScatON =.true.
      lgDrMnOn =.true.
      lgHeClON =.true.
      lgHLyaMased =.false.
      lgTrLine =.false.
      lgHe1Bug =.false.
      lgHe2Bug =.false.
      lgHe3Bug =.false.
      nznbug =10000
      npsbug = 10000
      lgHBugFull =.false.
      lgTrace =.false.
      do i=1,limelm
        CotaRate(i) = 0.
      end do
      lgTrOvrd = .true.
      lgTrDiff =.false.
      lgZoneSet =.false.
      lgZoneTrp =.false.
      lgPointBug =.false.
      lgNeonBug =.false.
      lgdR2Small =.false.
      lgOnlyZone =.false.
      lgOnlyHead =.false.
      lgStatic =.false.
      optint =0.
      optier =0.
      lgAutoIt =.false.
      autocv = 0.20
      lgDriveMole =.false.
      lgAbnSolar =.false.
      lgCoolTr =.false.
      lgPathSet =.false.
      lgCSetOn =.false.
*
      end
******************************************************************************
      subroutine zinci
      implicit none
*ionization balance for zinc
      integer limelm
      parameter (limelm=30)
      logical lgElmtOn
      common/elmton/ lgElmtOn(limelm)
*     these are simple powers of the electron temperature, are
*     evaluated in tfidle, and can be used to avoid exponentials
      real sqrte,te32,te70,te30,te20,te10,te05,te03,te02,te01,te005,
     1  te003,te001
      common/TePowers/sqrte,te32,te70,te30,te20,te10,te05,te03,te02,
     1 te01,te005,te003, te001
      integer itime
      real dt , tmt1 , tmpwr
      common/timed/ itime , dt , tmt1 , tmpwr
      real te , eden , hden
      common/phycon/ te , eden , hden
      real hi , hii
      common/h/ hi , hii
*
*     local variables
      integer i
      integer ndim , nelem
      parameter (nelem=30)
      parameter (ndim=31)
      real rec(ndim-2), pl(ndim-2), dicoef(ndim-1,2),
     1 dite(ndim-1,2), ditcrt(ndim-1), cion(ndim-1,2), aa(ndim-1),
     2 bb(ndim-1), cc(ndim-1), dd(ndim-1), ff(ndim-1), tlow(2)
*     real GRDEFF(nelem)
*
*     zinc nelem=30
*     rec data not for real
*
*     real CollidRate(nelem,2)
*
*     rates from Shull and van Steenberg, Ap.J. Sup 48, 95.
      data (cion(i,1),i=1,ndim-1)
     1 /1.34E-10,6.38E-10,1.51E-10,5.43E-11,2.46E-11,1.00E-11,
     1 5.29E-11,2.67E-12,1.26E-12,4.66E-13,1.36E-12,9.44E-13,6.35E-13,
     2 3.80E-13,2.17E-13,5.74E-14,1.04E-13,3.88E-14,5.65E-14,4.02E-14,
     3 3.25E-14,2.65E-14,1.83E-14,1.15E-15,8.39E-15,3.84E-15,4.21E-16,
     4 1.91E-16,2*1.91E-16/
      data (cion(i,2),i=1,ndim-1)
     1 /8.86E4,2.11E5,4.08E5,6.37E5,8.76E5,1.25E6,1.54E6,1.88E6,2.24E6,
     2 2.60E6,3.73E6,4.09E6,4.46E6,4.99E6,5.39E6,5.79E6,6.63E6,
     3 7.04E6,1.80E7,1.91E7,2.04E7,2.20E7,2.33E7,2.47E7,2.66E7,2.78E7,
     4 1.19E8,1.25E8,2*1.25E8/
*
*     GRDEFF is fraction of recombinations to ground state, used for
*     DATA GRDEFF/nelem*0.2/
*
*     all rates from Shull and Van Steenberg apj sup 48, 95.
      data rec/2.27e-10, 6.31e-10, 8.83e-10, 1.01e-09, 3.71e-09,
     1         4.84E-09, 1.09E-08, 2.48E-08, 9.68E-08, 1.72E-07,
     2         2.61E-07, 3.95E-07, 4.70E-07, 5.70E-07, 6.98E-07,
     3         8.32E-07, 9.76E-07, 1.19E-06, 1.16E-06, 1.14E-06,
     4         1.17E-06, 1.24E-06, 1.35E-06, 1.38E-06, 6.64E-07,
     5         4.67E-07, 8.98E-07, 2*8.98E-07/
      data pl/ -0.7, -0.7, -0.7, -0.7, -0.746, -0.682, -0.699, -0.728,
     1 -0.759, -0.79, -0.81, -0.829, -0.828, -0.834, -0.836, -0.84,
     2 -0.846, -0.85, -0.836, -0.824, -0.816, -0.811, -0.808, -0.8,
     3 -0.718, -0.677, -0.732,2*-0.732/
*
*     Pequignot and Aldrovandi Ast Ap 161, 169.
      data tlow/ 1.81e-10 , -0.681 /
*
      data (dicoef(i,1),i=1,ndim-1)
     1/ 1.41E-3, 5.2E-3, .0138, .023, .0419, .0683, .122, .300, .15,
     2 .697, .709, .644, .525, .446, .363, .302, .102, .27, .0467,
     3 .0835, .0996, .199, .24, .115, .0316, .803, .575,2*.575,  0./
      data (dicoef(i,2),i=1,ndim-1)
     1 /.469, .357, .281, .128, .0417, .0558, .0346, 0., 1.9, .277,
     2 .135, .134, .192, .332, .337, .121, .0514, .183, 7.56, 4.55,
     3 4.87, 2.19, 1.15, 1.23, .132, .289, .286,2*.286,  0./
      data (dite(i,1),i=1,ndim-1)
     1/9.82E+4, 2.01E+5, 3.05E+5, 4.20E+5, 5.56E+5, 6.72E+5, 7.93E+5,
     2 9.00E+5, 1.00E+6, 7.81E+5, 7.64E+5, 7.44E+5, 6.65E+5, 5.97E+5,
     3 5.24E+5, 4.96E+5, 4.46E+5, 8.46E+6, 1.36E+6, 1.23E+6, 1.06E+6,
     4 1.25E+6, 1.23E+6, 3.32E+5, 6.45E+5, 6.65E+7, 3*6.81E+7, 0./
      data (dite(i,2),i=1,ndim-1)
     1/ 1.01E+5, 1.91E+5, 2.32E+5, 3.18E+5, 4.55E+5, 5.51E+5, 5.28E+5,
     2 0., 5.50E+5, 8.87E+5, 1.80E+6, 1.25E+6, 1.89E+6, 8.84E+5,
     3 1.29E+6, 6.24E+5, 1.59E+6, 8.01E+6, 9.32E+6, 9.45E+6, 9.45E+6,
     4 8.01E+6, 7.57E+6, 2.64E+6, 1.93E+6, 1.19E+7, 3*9.08E+6, 0./
      data ditcrt
     1/ 6E3     , 2E4     , 4E4     , 5E4     , 7E4     , 8E4
     2, 8E4     , 3E4     , 3E4     , 3E4     , 3E4     , 9E4
     3, 4E4     , 5E4     , 3E4     , 9E5     , 2E5     , 2E5
     4, 2E5     , 2E5     , 1E5     , 7E4     , 4E4     , 6E6
     5, 6E6     , 1E20    , 1E20 , 3*1E20 /
      data aa/nelem*0./,bb/nelem*0./,cc/nelem*0./,dd/nelem*0./,
     1 ff/nelem*0./
*
*     zinc
      if( .not.lgElmtOn(nelem) ) then
        return
      endif
*
      call ionzer(nelem)
*
      call PhotoIonize(nelem)
*
*     find collisional ionization rates
      call CollidIonize(nelem , cion )
*
*     get recombination coefficients
      call MakeRecomb( rec , pl , dicoef , dite , ditcrt ,
     2aa , bb , cc , dd , ff , nelem , tlow)
*
      if( itime .eq. -1 ) then
        call theavy( nelem)
        return
      endif
*
*     solve for ionization balance
      call BiDiag( nelem , .false.)
*
      call TrimStages(nelem)
*
      end
******************************************************************************
      subroutine zmean
      implicit none
*zero mean of ionization fractions array
      integer limelm
      parameter (limelm=30)
*     xIonMeans(nelem, stage,type)
*     stage=0 is integrated sum of all
*     type = 1 is radius integration, 2=vol
      real xIonMeans
      common/IonMeans/ xIonMeans(limelm,0:limelm+1,2)
*
*     local variables
      integer nelem,i,j
*
      do nelem=1,limelm
        do i=0,nelem+1
          do j=1,2
            xIonMeans(nelem,i,j) = 0.
          end do
        end do
      end do
*
      end
******************************************************************************
      subroutine zondun
      implicit none
*last routine called after all zone calculations, before lgEndFun
      real te , eden , hden
      common/phycon/ te , eden , hden
      real tlast
      common/tlast/ tlast
*
*     this is the last routine called after all zone calculations,
*     and before calling lgEndFun to check if done
*
      tlast = te
*
      end
******************************************************************************
      subroutine zonsrt( chMode )
      implicit none
*set variables that change with each zone, like radius, depth
      character chMode*4
*
      integer itrdim
*dimension of vector to do with number of iterations stored
*so, this is the the most that can possibly be performed
      parameter (itrdim=20)
      integer nzlim
      parameter (nzlim=2000)
      real dReff , dVeff , dRNeff
*dReff is dr * filling factor
*dRNeff is next dr effective radius
*dVeff is effec vol relative to inner radius
      common/dRdVeff/ dReff , dVeff , dRNeff
*     these save structure variables, like te vs depth
      real testr, volstr, radstr, histr, hiistr , ednstr,o3str,heatstr,
     1 pdenstr
      common/struc/ testr(nzlim), volstr(nzlim), radstr(nzlim),
     1 histr(nzlim), hiistr(nzlim) , ednstr(nzlim),o3str(nzlim),
     2 heatstr(nzlim),pdenstr(nzlim)
      logical lgSphere
*flag saying whether spherical geometry
      common/sphere/ lgSphere
      double precision rinner , radius , drad , depth , router(itrdim)
      common/radius/ rinner , radius , drad , depth , router
      real FillFac , filpow , fiscal
*FillFac is filling factor, default 1,
* others are parameters to make function of radius
      common/filfac/ FillFac , filpow , fiscal
      real covrt , covgeo
*     covering factors, where sphere set, covrt usually 1, not set = 0
*     covgeo almost always is 1
      common/cover/ covrt , covgeo
      real drNext
*next dr, as set in nextdr
      common/drnxt/ drNext
      real r1r0sq
      common/r1r0sq/ r1r0sq
      logical lgCylnOn
*lgCylnOn set true when cylinder command given
*cylind is half height in centimeters
      real CylindHigh
      common/cylind/ CylindHigh , lgCylnOn
      real glbden , glbrad , glbpow , glbdst
      common/globul/ glbden , glbrad , glbpow , glbdst
      logical lgdR2Small
*set true if zone thickness became too small
      common/dr2sml/ lgdR2Small
      logical lgOut2In
*flag set with roberto command, to do outward to inward calculation
      common/out2in/ lgOut2In
      real dRadSign
*sign of dr for going in or out, 1 (usually) or -1
      common/drsign/ dRadSign
      character chCPres*4
*label describing the pressure law for current calculation
* 'DLW2' is tabden interpolated table
      common/cpres/ chCPres
      real te , eden , hden
      common/phycon/ te , eden , hden
      integer nzone,nprint,nend
*nzone is zone counter, incremented in routine cloudy
*tend is lowest temperature, set with stop temperature command
*nprint is how many zones to print
*nend(iteration) is limiting number of zones for that iteration
      real tend
      common/ZoneCnt/ nzone,nprint,tend,nend(itrdim)
      real TeInit , TeProp
      common/tpred/ TeInit , TeProp
      real OutFac , RefFac , BeamInIn,BeamInOut,BeamOutOut
*     outward and reflected effective vols
*     used to get outward and reflected beams
*     Beam vars are related to lines where inward and outward fracs known
*     BeamOutOut outward part of outwardly directed beam
*     BeamInIn inward part of inwardly directed beam, 0 if sphere
*     BeamInOut outward part of inwardly directed beam, 0 if not sphere
      common/VolRef/ OutFac , RefFac , BeamInIn,BeamInOut,BeamOutOut
      integer qq
*this is the io unit that all output will go to
      common/IOqq/ qq
*
*     local variables
      real ratio , vin,vout,rm , dt1 , dt2 , DTaver,outwrd
      integer ioff , i
      parameter (ioff=5)
      logical lgOscil
      save dt2 , DTaver
*
*     called at start of a zone to update all variables
*     having to do with starting this zone
*
*     this sub can be called in two ways, 'incr' means increment
*     radius variables, while 'init' means only initialize rest
*
      if( chMode.eq.'incr' ) then
*       update radius variables
        drad = drNext
        depth = depth + drad
        radius = radius + drad * dRadSign
*       following is distance to globule, usually doesnt matter
        glbdst = glbdst - drad
*       if gt 5th zone, and not constant pressure, and not oscillating te
*       option to guess next temperature : option to predict next temperature
*       nzlim is dim of structure variables saving temp, do data if nzone>nzlim
        if( chCPres.ne.'CPRE' .and. nzone.gt.ioff+1 .and.
     1    nzone.lt.nzlim)then
          TeInit = te
          lgOscil = .false.
          dt1 = 0.
          dt2 = 0.
          DTaver = 0.
          do i=nzone-ioff,nzone-1
            dt1 = dt2
            dt2 = testr(i-1) - testr(i)
            DTaver = DTaver + dt2
            if(dt1*dt2.lt.0. ) lgOscil = .true.
          end do
          if(.not.lgOscil ) then
            DTaver = DTaver / float(ioff)
*           don't want to overcorrect, use smaller of two
            DTaver = sign( min(abs(DTaver),abs(dt2)) , DTaver)
*           do not let it change by more than 5% of current temp
            DTaver = sign( min(abs(DTaver),0.05*te) , DTaver)
            te = te - DTaver
          else
*           temp was oscillating - too dangerous to do anything
            DTaver = 0.
          endif
          TeProp = te
        endif
      else if( chMode.eq.'init' ) then
*       initialize the variables at start of calculation
        depth = 1d-30
        radius = rinner
        drNext = drad
*       depth variable for globule
        glbdst = glbrad
*       following is for out to in geometry
        if( lgOut2In ) then
          dRadSign = -1.
        else
*         this is the normal case
          dRadSign = 1.
        endif
      else
        write(qq,'('' ZONSRT called with insane argument, '',A4)')chMode
        call insane
        stop
      endif
*
*     check whether zone thickness is too small relative to radius
      if( chCPres.eq.'GLOB' ) then
        ratio = drad / (glbdst+drad)
*       this only matters for globule command
        if( ratio.lt.1e-14 ) then
          lgdR2Small = .true.
        else
          lgdR2Small = .false.
        endif
      endif
*
      FillFac = min( 1. , fiscal * real(radius/rinner)**filpow )
*
*     effective radius
      dReff = drad * FillFac
*     area factor
      r1r0sq = ( (radius-drad*dRadSign/2.) /rinner) ** 2
*
*     following only approximate, used for center of next zone
      dRNeff = drNext * FillFac
*
*     RADIUS is outer radius of this zone
*     RINNER is inner radius of nebula; dVeff is the effective vol element
*     dVeff is vol rel to inner radius, so has units cm
*     for plane parallel dVeff is dReff
      if( drad/radius.gt.0.01 ) then
        vin =  ((radius-drad)/rinner) * FillFac *(min(
     1  real(radius-drad),
     1  CylindHigh)/real(rinner))*(radius-drad)
        vout = (radius/rinner) * FillFac *(min(real(radius),CylindHigh)/
     1  rinner)* radius
*       just the difference in the two vols
        dVeff = ( vout - vin ) / 3.
      else
*       RM is the middle of the zone;
*       radius is always the OUTER edge of the current zone
        rm = radius - drad/2.
        dVeff =  (rm/rinner) * drad* FillFac * (min(rm,CylindHigh)/
     1  rinner)
      endif
*
*     covering factor, default if unity
      dVeff = dVeff * covgeo
*
*     these are needed for line intensities in outward bean
*     lgSphere set, covrt usually 1, not lgSphere then 0
*     outwrd is 1/2 when lgSphere not set, 1 when set
      outwrd = (1.+covrt)/2.
*     this includes both the effective vol, and 1/r^2 dilution
      OutFac = outwrd * radius * dReff / (radius + 2.*drad)
      RefFac = (1.-outwrd) * dReff * r1r0sq
      if( lgSphere ) then
*       inward beams do not go in when lgSphere set since geometry symmetric
        BeamInIn = 0.
        BeamInOut = radius * dReff / (radius + 2.*drad)
      else
        BeamInIn = dReff * r1r0sq
*       inward beams do not go out
        BeamInOut = 0.
      endif
*     factor for outwardly directed part of line
      BeamOutOut = radius * dReff / (radius + 2.*drad)
*
      end
